Rem  Copyright (c) Oracle Corporation 1999 - 2021. All Rights Reserved.
Rem
Rem    NAME
Rem      load_es.sql
Rem
Rem    DESCRIPTION
Rem      Install Spanish version of Application Express applications
Rem
Rem    NOTES
Rem      Assumes the Application Express owner.
Rem      Note that the NLS_LANG must be properly set in the environment
Rem      prior to running this script or character set conversion can take place
Rem      The character set portion of NLS_LANG must be set to AL32UTF8
Rem         Example: AMERICAN_AMERICA.AL32UTF8
Rem 
Rem    Arguments:
Rem      None
Rem
Rem    MODIFIED    (MM/DD/YYYY)
Rem      jkallman   08/29/2003 - Created 

prompt . ORACLE
prompt .
prompt . Application Express Hosted Development Service Installation.
prompt .........................................................


set define '^'
set concat on
set concat .
set verify off
set termout off
set termout on

declare
    l_schema sys.dba_registry.schema%type;
begin
    sys.dbms_registry.set_session_namespace ( namespace   => 'DBTOOLS' );
    l_schema := sys.dbms_registry.schema( 'APEX' );
    execute immediate 'alter session set current_schema='||sys.dbms_assert.enquote_name( l_schema );
end;
/

@@f4411_es.sql
@@f4470_es.sql
@@f4000_es.sql
@@f4020_es.sql
@@f4050_es.sql
@@f4155_es.sql
@@f4300_es.sql
@@f4350_es.sql
@@f4500_es.sql
@@f4550_es.sql
@@f4600_es.sql
@@f4650_es.sql
@@f4700_es.sql
@@f4750_es.sql
@@f4850_es.sql
@@f4900_es.sql

set define '^'

prompt Adjust instance settings
-- Update image prefix, owner, release of installed translated applications
begin
    wwv_flow_security.g_security_group_id := 10;
    --
    for c1 in (select flow_image_prefix, owner
                 from wwv_flows
                where security_group_id = 10
                  and id = 4000) loop
        update wwv_flows
           set flow_image_prefix = c1.flow_image_prefix,
                owner = c1.owner,
                flow_version = (select '&PRODUCT_NAME. ' || wwv_flows_release from dual where rownum = 1)
          where id in ( select translation_flow_id 
                          from wwv_flow_language_map
                         where translation_flow_language_code = 'es' 
                           and security_group_id = wwv_flow_security.g_security_group_id );
        update wwv_flows set flow_version = '&PRODUCT_NAME. ' where id = 4551;
        exit;
    end loop;--c1
    commit;
end;
/
