Rem  Copyright (c) Oracle Corporation 1999 - 2021. All Rights Reserved.
Rem
Rem    NAME
Rem      unload_es.sql
Rem
Rem    DESCRIPTION
Rem      Deinstall Spanish version of Application Express applications.  This script will be used to remove
Rem      the Spanish version of Application Express applications from an existing Application Express instance.
Rem
Rem    NOTES
Rem      To be run from SQL*Plus as the Application Express owner or current_schema set to Application Express owner.
Rem 
Rem    REQUIREMENTS
Rem      Requires connection to the target database as the Application Express owner (APEX_XXXXXX) or
Rem      connection as SYS and issuing 'ALTER SESSION SET CURRENT_SCHEMA = APEX_XXXXXX'.
Rem
Rem    ARGUMENTS
Rem      None
Rem
Rem    MODIFIED    (MM/DD/YYYY)
Rem      jkallman   09/01/2004 - Created


prompt . ORACLE
prompt .
prompt . Application Express Hosted Development Service Spanish Language Deinstall
prompt ...........................................................................


set define '^'
set concat on
set concat .
set verify off
set termout on

declare
    l_schema sys.dba_registry.schema%type;
begin
    sys.dbms_registry.set_session_namespace ( namespace   => 'DBTOOLS' );
    l_schema := sys.dbms_registry.schema( 'APEX' );
    execute immediate 'alter session set current_schema='||sys.dbms_assert.enquote_name( l_schema );
end;
/

declare
    l_applications dbms_sql.number_table;
    l_offset       number := 1;
begin
    l_applications(l_applications.count+1)  := 4000;
    l_applications(l_applications.count+1)  := 4020;
    l_applications(l_applications.count+1)  := 4050;
    l_applications(l_applications.count+1)  := 4155;
    l_applications(l_applications.count+1)  := 4300;
    l_applications(l_applications.count+1)  := 4350;
    l_applications(l_applications.count+1)  := 4411;
    l_applications(l_applications.count+1)  := 4470;
    l_applications(l_applications.count+1)  := 4500;
    l_applications(l_applications.count+1)  := 4550;
    l_applications(l_applications.count+1)  := 4600;
    l_applications(l_applications.count+1)  := 4650;
    l_applications(l_applications.count+1)  := 4700;
    l_applications(l_applications.count+1)  := 4750;
    l_applications(l_applications.count+1)  := 4850;
    l_applications(l_applications.count+1)  := 4900;
    --
    wwv_flow_security.g_security_group_id := 10;
    for i in 1..l_applications.count loop
        wwv_flow_api.remove_flow( l_applications(i) + l_offset );
        commit;
    end loop;
    --
end;
/

