Rem  Copyright (c) Oracle Corporation 1999 - 2021. All Rights Reserved.
Rem
Rem    NAME
Rem      unload_pt.sql
Rem
Rem    DESCRIPTION
Rem      Deinstall Portuguese (Portugal) version of Application Express Runtime Messages.  This script will be used to remove
Rem      the Czech version of Application Express Runtime Messages from an existing Application Express instance.
Rem
Rem    REQUIREMENTS
Rem      Requires connection as SYS.
Rem
Rem    ARGUMENTS
Rem      None
Rem
Rem    MODIFIED    (MM/DD/YYYY)
Rem    jkallman     09/01/2004 - Created


prompt . ORACLE
prompt .
prompt . Application Express Portuguese (Portugal) Language Language Runtime Messages Deinstall
prompt ........................................................................................


set define '^'
set concat on
set concat .
set verify off
set termout on

declare
    l_schema sys.dba_registry.schema%type;
begin
    sys.dbms_registry.set_session_namespace ( namespace   => 'DBTOOLS' );
    l_schema := sys.dbms_registry.schema( 'APEX' );
    execute immediate 'alter session set current_schema='||sys.dbms_assert.enquote_name( l_schema );
end;
/

declare
    l_applications dbms_sql.number_table;
    l_offset       number := 25;
begin
    l_applications( l_applications.count+1 ) := 4470;
    --
    wwv_flow_security.g_security_group_id := 10;
    for i in 1..l_applications.count loop
        wwv_flow_api.remove_flow( l_applications(i) + l_offset );
        commit;
    end loop;
    --
end;
/