"use strict";

const gulp = require('gulp');
const sass = require('gulp-sass');
const autoprefixer = require('gulp-autoprefixer');
const csso = require('gulp-csso');
const rename = require('gulp-rename');


// SCSS Compile & Minify
function css() {
    return gulp.src('./scss/**/*.scss')
        .pipe(sass())
        .pipe(autoprefixer())
        .pipe(gulp.dest('./css/'))
        .pipe(csso())
        .pipe(rename({
          suffix: '.min'
        }))
        .pipe(gulp.dest('./css/'));
}

// Watch
function watchFiles() {
    gulp.watch('./scss/**/*.scss', gulp.series(css));
}

// Multi Tasks
const watch = gulp.parallel(watchFiles);
const dev   = gulp.series(css, watch);

// Exports
exports.css     = css;
exports.dev     = dev;
exports.watch   = watch;
exports.default = dev;
