prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4498
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4498 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4498
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101230355403035')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'ar'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'Y'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4498)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113345'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4498)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4498)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4498)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4498)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4498)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4498)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4498)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4498)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4498)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4498)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4498)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4498)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4498)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.ar'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4498
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4498)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4498)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4498)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4498)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4498)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4498)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4498)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.ar'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4498
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4498)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4498)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4498)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4498)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4498)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4498)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4498)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.ar'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4498
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4498)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4498)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4498)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.ar'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4498
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4498)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4498)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4498)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4498)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4498)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4498)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4498)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4498)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4498)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4498)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4498)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4498)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4498)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4498)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4498)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.ar'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4498
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4498)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4498)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4498)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4498)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4498)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4498)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4498)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4498)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4498)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4498)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4498)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4498)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4498)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4498)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4498)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.ar'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4498
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4498)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4498)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4498)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4498)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4498)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4498)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4498)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4498)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4498)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4498)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4498)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4498)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4498)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4498)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4498)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.ar'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4498
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4498)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4498)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4498)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4498)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4498)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4498)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4498)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4498)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4498)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4498)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4498)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4498)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4498)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4498)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4498)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4498
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4498)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4498
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4498)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4498
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4498)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4498
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4498)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4498
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4498)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4498
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4498
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4498)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4498)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4498)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4498)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4498)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4498)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4498)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4498)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4498)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4498)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4498)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4498)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4498)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4498)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4498)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4498)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4498)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4498)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4498)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4498)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4498)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4498)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4498)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4498)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4498)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4498)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4498)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4498)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4498)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4498
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4498)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4498)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4498)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4498)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4498)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4498
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4498)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4498
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4498)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4498
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4498)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4498
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4498)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4498
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4498)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4498
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4498)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4498)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4498)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4498)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4498)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4498)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4498)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4498)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4498)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4498
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4498)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4498)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4498)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4498)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4498)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4498)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4498)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4498
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4498)
,p_page_name=>'winlov'
,p_page_title=>unistr('\0645\0631\0628\0639 \062D\0648\0627\0631 \0627\0644\0628\062D\062B')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\0628\062D\062B')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\0625\063A\0644\0627\0642')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\0627\0644\062A\0627\0644\064A &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \0627\0644\0633\0627\0628\0642')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\0627\0644\0635\0641 (\0627\0644\0635\0641\0648\0641) #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4498
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4498)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4498
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4498)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4498)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4498)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4498)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4498)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4498)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4498)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4498)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4498)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4498)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4498)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4498)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4498)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4498)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4498)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4498)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4498)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4498)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4498)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4498)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4498)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4498)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4498)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4498)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4498)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4498)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4498)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4498)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4498)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4498)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4498)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4498)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4498)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4498)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4498)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4498)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4498)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4498)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4498)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4498)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4498)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4498)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4498)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4498)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4498)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4498)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4498)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4498)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4498)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4498)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4498)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4498)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4498)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4498)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4498)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4498)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4498)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4498)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4498)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4498)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4498)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4498)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4498)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4498)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4498)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4498)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4498)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4498)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4498)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4498)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4498)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4498)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4498)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4498)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4498)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4498)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4498)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4498)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4498)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4498)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4498)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4498)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4498)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4498)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4498)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4498)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4498)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4498)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4498)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4498)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4498)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4498)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4498)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4498)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4498)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4498)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4498)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4498)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4498)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4498)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4498)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4498)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4498)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4498)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4498)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4498)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4498)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4498)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4498)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4498)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4498)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4498)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4498)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4498)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4498)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4498)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4498)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4498)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4498)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4498)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4498)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4498)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4498)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4498)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4498)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4498)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4498)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4498)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4498)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4498)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4498)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4498)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4498)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4498)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4498)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4498)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4498)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4498)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4498)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4498)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4498)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4498)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4498)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4498)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4498)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4498)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4498)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4498)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4498)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4498)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4498)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4498)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4498)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4498)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4498)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4498)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4498)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4498)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4498)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4498)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4498)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4498)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4498)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4498)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4498)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4498)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4498)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4498)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4498)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4498)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4498)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4498)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4498)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4498)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4498)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4498)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4498)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4498)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4498)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4498)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4498)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4498)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4498)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4498)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4498)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4498)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553665010398706)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540770549398696)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0633\0624\0648\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540630014398696)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597981721398739)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0631\0641\0636 \0627\0644\0648\0635\0648\0644')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557650713398709)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\0643\0648\064A\0646 \062D\0633\0627\0628 %0 \0627\0644\062E\0627\0635 \0628\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543296954398698)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\0633\0627\0628 \0645\0642\0641\0644.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533193002398690)
,p_name=>'AM_PM'
,p_message_language=>'ar'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667563699398792)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631/\0625\062E\0641\0627\0621 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675601798398798)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'ar'
,p_message_text=>unistr('(\0646\0634\0637)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645121645398775)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0631\062C\0639 \0627\0633\062A\062F\0639\0627\0621 Ajax \062E\0637\0623 \0627\0644\062E\0627\062F\0645 %0 \0641\064A %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575913198398722)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \062A\062D\0648\064A\0644 \0627\0644\0627\0633\0645 \0627\0644\0628\062F\064A\0644 \0644\0644\062A\0637\0628\064A\0642 "%0" \0625\0644\0649 \0645\0639\0631\0641 \062A\0637\0628\064A\0642 \0641\0631\064A\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576025641398722)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0648\062C\062F \062A\0637\0628\064A\0642 \0628\0627\0644\0627\0633\0645 \0627\0644\0628\062F\064A\0644 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565682094398715)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1816 \062E\0637\0623 \063A\064A\0631 \0645\062A\0648\0642\0639 \0623\062B\0646\0627\0621 \062A\062D\0648\064A\0644 \0627\0644\0627\0633\0645 \0627\0644\0628\062F\064A\0644 \0644\0644\062A\0637\0628\064A\0642 p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658576317398785)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\062B\0644 \0627\0644\0645\062C\0645\0648\0639 \0627\0644\0627\062E\062A\0628\0627\0631\064A \0641\064A \0627\0644\062A\0637\0628\064A\0642 \0648\0633\064A\0644\0629 \0628\0633\064A\0637\0629 \0644\062A\062D\062F\064A\062F \0645\0627 \0625\0630\0627 \0643\0627\0646 \0627\0644\062A\0637\0628\064A\0642 \0646\0641\0633\0647 \0645\0648\0632\0639\064B\0627 \0639\0644\0649 \0645\0633\062A\0648\0649 \0645\0633\0627\062D\0627\062A \0627\0644\0639\0645\0644. \0648\064A\0645\0643\0646 \0645\0642\0627\0631\0646\0629 \0647\0630\0627 \0627\0644\0645\062C\0645\0648\0639 \0627\0644\0627\062E\062A\0628\0627\0631\064A \0644\0645\0639\0631\0641\0629 \0645\0627 \0625\0630\0627 \0643\0627\0646 \0647\0646\0627\0643 \0645\062C\0645\0648\0639 \0645\0637\0627\0628\0642 \0644\0647. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551493077398704)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \062F\0627\0644\0629 \0627\0644\0645\0635\0627\062F\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536826415398693)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \062F\0627\0644\0629 \0627\0644\0645\0635\0627\062F\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700335360398817)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0639\0645\064A\0644 %0 \0627\0644\0630\064A \0623\0631\062C\0639\0647 Oracle Cloud Identity Management \063A\064A\0631 \0645\0639\062A\0645\062F \0641\064A \0627\0644\0645\062C\0627\0644%1!<br/>\0627\0644\0631\062C\0627\0621 <a href="&LOGOUT_URL.">\0645\0639\0627\0648\062F\0629 \062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644</a> \0648\062A\062D\062F\064A\062F \0627\0633\0645 \0639\0645\064A\0644 \0645\0639\062A\0645\062F \0623\0648 \062A\063A\064A\064A\0631 \0639\0646\0648\0627\0646 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534534618398691)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0634\062A\0645\0644 \062D\0633\0627\0628\0643 "%0" \0639\0644\0649 \0627\0645\062A\064A\0627\0632\0627\062A \0627\0644\062A\0637\0648\064A\0631 \0627\0644\0644\0627\0632\0645\0629 (DB_DEVELOPER \0623\0648 DB_ADMINISTRATOR)<br/>\0641\064A \0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644 "%1"! \0627\0644\0631\062C\0627\0621 <a href="&LOGOUT_URL.">\0645\0639\0627\0648\062F\0629 \062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644</a> \0628\0639\062F \0625\062A\0627\062D\0629 \0627\0644\0627\0645\062A\064A\0627\0632\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533602899398690)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0639\0645\064A\0644 \0627\0644\0630\064A \0623\0631\062C\0639\0647 Oracle Cloud Identity Management \063A\064A\0631 \0645\0639\062A\0645\062F \0641\064A \0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644 \0627\0644\062D\0627\0644\064A\0629!<br/>\0627\0644\0631\062C\0627\0621 <a href="&LOGOUT_URL.">\0645\0639\0627\0648\062F\0629 \062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644</a> \0648\062A\062D\062F\064A\062F \0627\0633\0645 \0639\0645\064A\0644 \0645\0639\062A\0645\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534681354398691)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0623\0633\0628\0627\0628 \0623\0645\0646\064A\0629\060C \0644\0627 \064A\064F\0633\0645\062D \0628\062A\0634\063A\064A\0644 \062A\0637\0628\064A\0642\0627\062A \0641\064A \0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644 \0647\0630\0647 \0639\0646 \0637\0631\064A\0642 \0627\0644\0645\062C\0627\0644 \0641\064A \0639\0646\0648\0627\0646 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551169100398704)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0645\0637\0627\0644\0628\0629 \0645\0633\0626\0648\0644 \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0628\062A\0634\063A\064A\0644 $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551039288398704)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0632\0645\0629 SYS.DBMS_LDAP \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0623\0648 \063A\064A\0631 \0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550904915398704)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062A\062D\0631\064A\0631 \062F\0627\0644\0629 \0645\0633\062A\062E\062F\0645 LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551224026398704)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0645\0635\0627\062F\0642\0629 LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552093262398705)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0641\064A \0648\0633\064A\0637\0629 p_flow_page ar \0628\0625\062C\0631\0627\0621 login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551635706398704)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'ar'
,p_message_text=>unistr('p_session \063A\064A\0631 \0635\0627\0644\062D \0641\064A wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599596412398740)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0633\064A\0637\0629 \063A\064A\0631 \0635\062D\064A\062D\0629 \0627\0644\0635\064A\0627\063A\0629 \0641\064A wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551719746398704)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\0645\0631\064A\0631 \0627\0633\0645 \0645\0633\062A\062E\062F\0645 \062E\0627\0644\064D \0625\0644\0649 \0625\062C\0631\0627\0621 \062A\0633\062C\064A\0644 \062F\062E\0648\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540552624398696)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0627\0644\0627\0646\062A\0638\0627\0631 \0644\0645\062F\0629 <span id="apex_login_throttle_sec">%0</span> \062B\0627\0646\064A\0629 \0644\062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644 \0645\0631\0629 \0623\062E\0631\0649.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541886341398697)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0638\0631 \0645\062D\0627\0648\0644\0629 \062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597327390398739)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0635\0627\062F\0642\0629 "%0" \063A\064A\0631 \0645\0648\062C\0648\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542139721398697)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0641 \0645\062C\0645\0648\0639\0629 \0627\0644\0623\0645\0627\0646 \062E\0627\0644\064D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551513192398704)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062A\0646\0641\064A\0630 \0639\0645\0644\064A\0629 \0645\0627 \0628\0639\062F \0627\0644\0645\0635\0627\062F\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551361439398704)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0639\0645\0644\064A\0629 \0645\0627 \0642\0628\0644 \0627\0644\0645\0635\0627\062F\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552531079398705)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0627\0644\0631\062C\0627\0621 \0641\062A\062D \0639\0646\0648\0627\0646 URL \0641\064A \0627\0644\0645\062A\0635\0641\062D \0646\0641\0633\0647 \062D\064A\062B \0642\0645\062A \0628\0627\0644\0628\062F\0621 \0641\064A \0637\0644\0628 \0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0643\0644\0645\0629 \0627\0644\0633\0631.  \0625\0630\0627 \0642\0645\062A \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0639\0646\0648\0627\0646 URL \0644\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0643\0644\0645\0629 \0627\0644\0633\0631 \0648\062A\0645\062A \0625\0639\0627\062F\0629 \062A\0648\062C\064A\0647\0643 \0625\0644\0649'),
unistr('\0635\0641\062D\0629 \0627\0644\062F\062E\0648\0644\060C \0641\0627\0644\0631\062C\0627\0621 \0627\0644\0628\062F\0621 \0641\064A \0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0643\0644\0645\0629 \0627\0644\0633\0631 \0645\0631\0629 \0623\062E\0631\0649 \0645\0639 \062A\0631\0643'),
unistr('\0627\0644\0645\062A\0635\0641\062D \0645\0641\062A\0648\062D\064B\0627.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697818906398815)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 URL \0644\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0643\0644\0645\0629 \0627\0644\0633\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534885220398692)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062C\0645\0648\0639\0629 \0627\0644\0627\0633\062A\0647\0644\0627\0643 %0 \0641\064A \0645\062F\064A\0631 \0627\0644\0645\0648\0627\0631\062F \0644\0645 \064A\062A\0645 \0645\0646\062D\0647\0627 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534984839398692)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0627\0633\062A\062E\062F\0627\0645 DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \0644\0645\0646\062D \0627\0644\0627\0645\062A\064A\0627\0632 \0627\0644\0645\0641\0642\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562964687398713)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \062F\0627\0644\0629 \0645\0631\0627\0642\0628\0629 \062C\0644\0633\0629 \0627\0644\0639\0645\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563021826398713)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \062F\0627\0644\0629 \0627\0644\062A\062D\0642\0642 \0645\0646 \062C\0644\0633\0629 \0627\0644\0639\0645\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563258638398713)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0645\0637\0627\0644\0628\0629 \0645\0633\0626\0648\0644 %0 \0628\062A\0643\0648\064A\0646 \0645\062D\0631\0643 \0644\062F\062E\0648\0644 \0627\0644\0645\0648\062D\062F \0641\064A Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572749318398720)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0625\0631\062C\0627\0639 %0 \063A\064A\0631 \0635\0627\0644\062D \0641\064A \0631\0645\0632 %1 \0627\0644\0641\0631\064A\062F \0628\0648\0627\0633\0637\0629 \0627\0644\062F\062E\0648\0644 \0627\0644\0645\0648\062D\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551946566398704)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \062A\062D\0631\064A\0631 \0645\062E\0637\0637 \0627\0644\0645\0635\0627\062F\0642\0629 \0648\0625\0636\0627\0641\0629 \0627\0633\0645 \0627\0644\062A\0637\0628\064A\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572400822398720)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062A\062F\0639\064A \0625\062C\0631\0627\0621 %0 \063A\064A\0631 \0645\0634\0631\0648\0639:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572673700398720)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0644\0633\0629 \0639\0645\0644 \0627\0644\062A\0637\0628\064A\0642 \063A\064A\0631 \0635\0627\0644\062D\0629 \0641\064A \0631\0645\0632 urlc \0627\0644\0641\0631\064A\062F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572280439398720)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\062C\062F \062E\0637\0623 \0641\064A portal_sso_redirect: \0645\0639\0644\0648\0645\0627\062A \062A\0633\062C\064A\0644 \0627\0644\062A\0637\0628\064A\0642 \063A\064A\0631 \0645\0648\062C\0648\062F\0629: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563139230398713)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0632\0645\0629 WWSEC_SSO_ENABLER_PRIVATE \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0623\0648 \063A\064A\0631 \0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110551838733398704)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\0639\0630\0631 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0633\0645 \062A\0637\0628\064A\0642 \0634\0631\064A\0643 \0645\0633\062C\0644 \0641\064A \0645\062E\0637\0637 \0645\0635\0627\062F\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572350054398720)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \062A\0633\062C\064A\0644 \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642 \0643\0645\0627 \0647\0648 \0645\0628\064A\0646 \0641\064A \062F\0644\064A\0644 \0627\0644\062A\062B\0628\064A\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563370629398713)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0645\0635\0627\062F\0642\0629 \0627\0644\062F\062E\0648\0644 \0627\0644\0645\0648\062D\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672783720398796)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 URL \063A\064A\0631 \0645\0639\062A\0645\062F:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562731177398713)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0627\0644\0645\0635\0627\062F\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534789846398691)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644 "%0" \063A\064A\0631 \0646\0634\0637\0629. \0639\0644\064A\0643 \0628\0627\0644\0627\062A\0635\0627\0644 \0628\0627\0644\0645\0633\0626\0648\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535137163398692)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'ar'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541554113398697)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0631\0641\0636 \0627\0644\0648\0635\0648\0644 \0628\0648\0627\0633\0637\0629 \0627\062E\062A\0628\0627\0631 \0627\0644\0623\0645\0627\0646 \0641\064A \0627\0644\062A\0637\0628\064A\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541616198398697)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0631\0641\0636 \0627\0644\0648\0635\0648\0644 \0628\0648\0627\0633\0637\0629 \0627\062E\062A\0628\0627\0631 \0627\0644\0623\0645\0627\0646 \0641\064A \0627\0644\0635\0641\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541725429398697)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0627\0644\0627\0639\062A\0645\0627\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605134129398745)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0625\0646\0634\0627\0621 \0628\0648\0627\0633\0637\0629 %0 \0628\0627\0633\062A\062E\062F\0627\0645 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605238327398745)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0647\062A\0645\0627\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663090270398788)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0635\0641 \0627\0644\062D\062F\062B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662871398398788)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0627\0631\064A\062E \0627\0644\0646\0647\0627\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663146925398788)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0641 \0627\0644\062D\062F\062B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662729521398788)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0627\0631\064A\062E \0627\0644\0628\062F\0627\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662914112398788)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0627\0644\062D\062F\062B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553587872398706)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\062C\062F \062E\0637\0623 \0641\064A \0645\062D\062A\0648\0649 \0627\0644\0645\062C\0645\0648\0639 \0627\0644\0627\062E\062A\0628\0627\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553479911398706)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\062C\062F \062E\0637\0623 \0641\064A \062A\0646\0633\064A\0642 \0627\0644\0645\062C\0645\0648\0639 \0627\0644\0627\062E\062A\0628\0627\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617445714398754)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0646\0633\062E \0625\0644\0649 \0627\0644\062D\0627\0641\0638\0629.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617196740398754)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062F\0639\0645 \0647\0630\0627 \0627\0644\0645\0633\062A\0639\0631\0636 \0627\0644\0646\0633\062E \0628\0627\0633\062A\062E\062F\0627\0645 \0632\0631 \0623\0648 \0642\0627\0626\0645\0629. \062D\0627\0648\0644 \0627\0633\062A\062E\062F\0627\0645 \0627\0644\0627\062E\062A\0635\0627\0631 Ctrl+C \0623\0648 Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605635571398745)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\063A\0644\0627\0642 \0627\0644\0625\062E\0637\0627\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661679086398787)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0628\0627\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656148901398783)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656068567398783)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0648\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660263429398786)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 #LABEL# \0644\0648\0646\064B\0627 \0635\0627\0644\062D\064B\0627. \0645\062B\0627\0644: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655974770398783)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0644\0648\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656263564398783)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\063A\064A\064A\0631 \0635\064A\063A\0629 \0627\0644\0644\0648\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695413213398813)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695501754398813)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\062A\062D \0642\0627\0626\0645\0629 \0644\0640: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675789271398798)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'ar'
,p_message_text=>unistr('(\0645\0643\062A\0645\0644)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568082949398716)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062A\0635\0644 \0628\0645\0633\0626\0648\0644 \0627\0644\062A\0637\0628\064A\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582466967398727)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0627\062A\0635\0644 \0628\0645\0633\0626\0648\0644 \0627\0644\062A\0637\0628\064A\0642.'),
unistr('\062A\062A\0648\0641\0631 \062A\0641\0627\0635\064A\0644 \062D\0648\0644 \0647\0630\0627 \0627\0644\062D\0627\062F\062B \0628\0648\0627\0633\0637\0629 \0645\0639\0631\0641 \062A\0635\062D\064A\062D \0627\0644\0623\062E\0637\0627\0621 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660528430398786)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0635\062D\064A\062D \0627\0644\0623\062E\0637\0627\0621 \0642\0628\0644 \0627\0644\062D\0641\0638.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606537704398746)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 %0 \0645\0646 \0627\0644\0639\0646\0627\0635\0631 \0627\0644\0645\0637\0627\0628\0642\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606459691398746)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0639\0646\0627\0635\0631 \0645\0637\0627\0628\0642\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676211901398798)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\062F\0645 \0627\0644\062D\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660957274398787)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0644\0641 \0627\0644\0645\062D\062F\062F \0641\064A \0639\0646\0635\0631 %0 \063A\064A\0631 \0645\0648\062C\0648\062F \0641\064A APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649453891398778)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\063A\064A\0631\062A \0646\0633\062E\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062D\0627\0644\064A\0629 \0641\064A \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0644\0623\0646 \0627\0644\0645\0633\062A\062E\062F\0645 \0628\062F\0623 \0639\0645\0644\064A\0629 \062A\062D\062F\064A\062B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618532341398755)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\0645 \0627\0644\062A\062D\0645\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665598679398790)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623 \0645\0639\0627\0644\062C\0629 \0623\0648\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665365402398790)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062F\0631\0627\062C \0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679465349398801)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0633\0644\0633\0644: \0627\0644\0625\062C\0631\0627\0621')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665457076398790)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062B \0627\0644\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606908182398746)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0648\064A\0645 \0627\0644\0645\0646\0628\062B\0642: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529566278398687)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529684669398687)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665789979398790)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\0648\062C\062F \0642\064A\0645\0629 \0644\0640 #LABEL#.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665683880398790)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 #LABEL# \062A\0627\0631\064A\062E\064B\0627 \0635\0627\0644\062D\064B\0627\060C \0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533213594398690)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\0643\0648\0646 \0642\064A\0645\0629 #LABEL# \0628\064A\0646 %0 \0648 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533385144398690)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\0643\0648\0646 \0642\064A\0645\0629 #LABEL# \0641\064A %0 \0623\0648 \0628\0639\062F\0647.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533463362398690)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\0643\0648\0646 \0642\064A\0645\0629 #LABEL# \0641\064A %0 \0623\0648 \0642\0628\0644\0647.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610402114398749)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \0623\0643\0628\0631 \0645\0646 (\0644\0627\062D\0642 \0644\0640) \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0627\0644\0645\062D\062F\062F \0644\0644\062A\0627\0631\064A\062E %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610896856398749)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \0644\0627 \064A\0637\0627\0628\0642 \0627\0644\0635\064A\063A\0629 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610356276398748)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \0623\0642\0644 \0645\0646 (\0633\0627\0628\0642 \0639\0644\0649) \0627\0644\062D\062F \0627\0644\0623\062F\0646\0649 \0627\0644\0645\062D\062F\062F \0644\0644\062A\0627\0631\064A\062E %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610579168398749)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \0644\064A\0633 \0641\064A \0646\0637\0627\0642 \0635\0627\0644\062D \0645\0646 %0 \0625\0644\0649 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610752547398749)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \0644\064A\0633 \0641\064A \0646\0637\0627\0642 \0633\0646\0648\0627\062A \0635\0627\0644\062D \0628\064A\0646 %0 \0648%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660888722398787)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\063A\0627\0621')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688076036398808)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\063A\0644\0627\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690033600398809)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0644\064A\0645\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660657768398786)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0648\0627\0641\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660756276398786)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566987690398716)
,p_name=>'APEX.ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534373503398691)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \0627\0644\062E\0637\0623 \0627\0644\062A\0627\0644\064A \0623\062B\0646\0627\0621 \062A\0646\0641\064A\0630 \0645\0639\0627\0648\062F\0629 \0627\062A\0635\0627\0644 \0644\0625\0635\0644\0627\062D \062E\0637\0623: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543051107398698)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0637\0628\0627\0639\0629 \0635\0641\062D\0629 \0627\0644\062E\0637\0623: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535031777398692)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623 \062F\0627\062E\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674879568398797)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0639\0644\064A\0643 \0628\0627\0644\0627\062A\0635\0627\0644 \0628\0627\0644\0645\0633\0626\0648\0644.'),
unistr('\062A\062A\0648\0641\0631 \062A\0641\0627\0635\064A\0644 \062D\0648\0644 \0647\0630\0627 \0627\0644\062D\0627\062F\062B \0645\0646 \062E\0644\0627\0644 \0645\0639\0631\0641 \062A\0635\062D\064A\062D \0627\0644\0623\062E\0637\0627\0621 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669181373398793)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0641\062A\062D \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0628\063A\0631\0636 \0627\0644\0642\0631\0627\0621\0629-\0641\0642\0637')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699701090398817)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'ar'
,p_message_text=>unistr('ORA-28353: \0641\0634\0644 \0641\062A\062D \0627\0644\062D\0627\0641\0638\0629. \0648\0645\0646 \062B\0645\060C \0644\0627 \064A\0645\0643\0646 \0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0628\064A\0627\0646\0627\062A \0627\0644\062A\0637\0628\064A\0642 \062D\0627\0644\064A\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669217900398793)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0630\0631\0629\060C \0647\0630\0647 \0627\0644\0635\0641\062D\0629 \063A\064A\0631 \0645\062A\0627\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536777294398693)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0639\0644\0648\0645\0627\062A \0627\0644\0641\0646\064A\0629 (\064A\0645\0643\0646 \0644\0644\0645\0637\0648\0631\064A\0646 \0641\0642\0637 \0631\0624\064A\062A\0647\0627)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632834103398765)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0633\0627\0644\0629 \062E\0637\0623')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646719738398776)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0646\0633\064A\0642 \0627\0644\0645\062A\0648\0642\0639: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613451748398751)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0633\062A\062E\062F\0645 \0641\064A \0642\0627\0626\0645\0629 \0627\0644\062A\062D\0643\0645 \0628\0627\0644\0648\0635\0648\0644 \0628\0627\0644\0641\0639\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613327403398751)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \062A\0623\0643\064A\062F \0625\0636\0627\0641\0629 \0627\0644\0645\0633\062A\062E\062F\0645 (\0627\0644\0645\0633\062A\062E\062F\0645\064A\0646) \0627\0644\062A\0627\0644\064A %0 \0625\0644\0649 \0642\0627\0626\0645\0629 \0627\0644\062A\062D\0643\0645 \0628\0627\0644\0648\0635\0648\0644 <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613834300398751)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\062C\062F \0645\0633\062A\062E\062F\0645 \0645\0643\0631\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613572390398751)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0644\0627\0645\0629 (@) \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0641\064A \0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613644384398751)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0642\0637\0629 (.) \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0641\064A \0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613789685398751)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645 \0637\0648\064A\0644 \0644\0644\063A\0627\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614036508398751)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0627\0644\0645\062D\062F\062F\064A\0646 \0641\064A \0642\0627\0626\0645\0629 \0627\0644\062A\062D\0643\0645 \0628\0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0627\0644\062A\0637\0628\064A\0642 \0641\0642\0637 \0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614176837398751)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645\0629 \0625\0639\062F\0627\062F \0627\0644\062A\062D\0643\0645 \0641\064A \0627\0644\0648\0635\0648\0644 \063A\064A\0631 \0645\062A\0648\0642\0639\0629: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613960979398751)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646 \0644\0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0627\0644\0645\0635\062F\0642 \0639\0644\064A\0647\0645 \0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656785359398784)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0637\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656665029398783)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0645\0643\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656917989398784)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('%0: \0645\0639\0637\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656894475398784)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('%0: \0645\0645\0643\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656517324398783)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0645\0639\0631\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649613103398778)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0646\0632\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606120705398745)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0631\0634\062D \0627\0644\0645\0637\0628\0642 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647230648398776)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0637\0628\064A\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532139418398689)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\0634\0631\064A\0637\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659944906398786)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0630\0644\0643')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532238297398689)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0633\0645 \0628\064A\0627\0646\064A \0642\0631\0635\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658645177398785)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531973053398689)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\062F\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647783683398777)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647895680398777)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062D \0627\0644\0643\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647946590398777)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062D %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665160521398790)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F %1\060C \0627\0644\0645\0634\0627\0631 \0625\0644\064A\0647 \0641\064A \0627\0644\062C\0627\0646\0628 %0\060C \063A\064A\0631 \0645\062A\0627\062D \0623\0648 \063A\064A\0631 \0645\0639\062A\0645\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522374878398681)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0627\0644\0645\0631\0634\062D\0627\062A \0627\0644\0645\0637\0644\0648\0628 \0639\0631\0636\0647\0627')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604360658398744)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0646\062A\0627\0626\062C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604492858398744)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\062D\062F\064A\062F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607076128398746)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0631\0634\062D\0627\062A \0627\0644\062D\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523892952398682)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0627\0644\0645\0631\0634\062D\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663621798398789)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\062C\0627\0648\0632 \062D\062F \0627\0644\0642\064A\0645\0629 \0627\0644\0641\0631\064A\062F\0629 (%0) \0641\064A \0627\0644\062C\0627\0646\0628 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649277761398778)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062C\0627\0646\0628 %0 \063A\064A\0631 \0645\062F\0639\0648\0645 \0641\064A \0627\0644\0623\0639\0645\062F\0629 \0645\0646 \0627\0644\0646\0648\0639 DATE \0623\0648 TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647364012398776)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0631\0634\062D %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647476683398776)
,p_name=>'APEX.FS.GO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0642\0627\0644 \0625\0644\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648828682398777)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0633\0627\0648\064A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532984141398690)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A \0639\0644\0649 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532649564398690)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0643\0628\0631 \0645\0646 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532757662398690)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0643\0628\0631 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532472288398690)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0642\0644 \0645\0646 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532555758398690)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0642\0644 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532806199398690)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0628\062F\0623 \0628\0640 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535311411398692)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0628\064A\0627\0646\0627\062A %0 (%1) \063A\064A\0631 \0645\062F\0639\0648\0645 \0641\064A \062C\0627\0646\0628 "\062D\0642\0644 \0627\0644\0625\062F\062E\0627\0644".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525581703398684)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062C\0648\0627\0646\0628 \0645\062A\0639\062F\062F\0629 \0627\0644\0642\064A\0645 \062A\062A\0637\0644\0628 \0642\0648\0627\0639\062F \0628\064A\0627\0646\0627\062A \0628\0627\0644\0625\0635\062F\0627\0631 12.2 \0623\0648 \0623\062D\062F\062B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649004360398778)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0642\062F\064A\0645 \0623\0639\0645\062F\0629 \0628\062D\062B \0641\064A \0627\0644\062C\0627\0646\0628 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522445940398681)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0632\064A\062F \0645\0646 \0627\0644\0645\0631\0634\062D\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604519801398744)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062F\0627\064A\0629 \0627\0644\0646\0637\0627\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648578316398777)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0625\0644\0649 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648659695398777)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0639\0644\0649 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648797008398777)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0642\0644 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604657408398744)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0647\0627\064A\0629 \0627\0644\0646\0637\0627\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667414162398791)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0635\0631 \0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645 #%2 ("%1") \0641\064A \062C\0627\0646\0628 \0627\0644\0646\0637\0627\0642 %0 \063A\064A\0631 \0635\0627\0644\062D (\0627\0644\0641\0627\0635\0644 "|" \063A\064A\0631 \0645\0648\062C\0648\062F).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648928547398778)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0625\062F\062E\0627\0644 \0627\0644\064A\062F\0648\064A \0641\064A \062C\0627\0646\0628 \0627\0644\0646\0637\0627\0642 %0 \063A\064A\0631 \0645\062F\0639\0648\0645 \062D\0627\0644\064A\064B\0627\060C \0646\0638\0631\064B\0627 \0644\0623\0646 \0627\0644\0639\0645\0648\062F \0645\0646 \0627\0644\0646\0648\0639 DATE \0623\0648 TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648262434398777)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532038338398689)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601191092398742)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647649601398777)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647599899398776)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648447486398777)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'ar'
,p_message_text=>unistr('- \062A\062D\062F\064A\062F -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531839803398689)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648009157398777)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631 \0623\0642\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648154482398777)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631 \0627\0644\0645\0632\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110648382610398777)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0646\062C\0648\0645 \0648\0623\0643\062B\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606080035398745)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0642\062A\0631\0627\062D\0627\062A \0627\0644\062A\0631\0634\064A\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649150835398778)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0627\0646\0628 \0627\0644\062D\0642\0644 \0627\0644\0646\0635\064A %0 \0645\062F\0639\0648\0645 \0641\0642\0637 \062D\0627\0644\064A\064B\0627 \0641\064A \0623\0639\0645\062F\0629 NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522278073398681)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062C\0645\0627\0644\064A \0639\062F\062F \0627\0644\0635\0641\0648\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665232237398790)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0628\064A\0627\0646\0627\062A %0 (%1) \063A\064A\0631 \0645\062F\0639\0648\0645 \0641\064A \0627\0644\0628\062D\062B \0645\062A\0639\062F\062F \0627\0644\062C\0648\0627\0646\0628.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657196229398784)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0642\0627\0644 \0625\0644\0649 \0627\0644\062E\0637\0623')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614721734398752)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\0639.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622306003398757)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\064A \0641\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614866393398752)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0648\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622262930398757)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\0633\064A\0639 \0641\0627\0635\0644 \0639\0646\0635\0631 \0627\0644\062A\062D\0643\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700963819398818)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622005964398757)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0630\0641 %0 \0645\0646 \0627\0644\0635\0641\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692461064398811)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0647\0648\064A\0629 \0645\0643\0631\0631\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611727822398750)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0648\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615078245398752)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0627\0644\0645\062C\0645\0648\0639\0629.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614907174398752)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0648\0627\0646.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611860825398750)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\062E\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631800286398765)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0645\064A\0644 \0645\0632\064A\062F \0645\0646 \0627\0644\0635\0641\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611573676398749)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615104019398752)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0641\0648\0641 \0627\0644\0635\0641\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611976984398750)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'ar'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612017789398750)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 - %1 \0645\0646 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668062141398792)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0635\0641\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611669250398749)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692222742398811)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645\062A \0627\0644\0625\0636\0627\0641\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692331420398811)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062A\063A\064A\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700777069398817)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 %0\060C \0627\0644\0639\0645\0648\062F %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700802412398817)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692133367398811)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062D\0630\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615390170398752)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0627\0644\0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610960877398749)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\062D\062F\064A\062F %0 \0645\0646 \0627\0644\062E\0644\0627\064A\0627')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612147507398750)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\062D\062F\064A\062F %0 \0645\0646 \0627\0644\0635\0641\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652464963398780)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\0643\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622189094398757)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641\062D\0629 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615224146398752)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615468165398752)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0641\0631\0632 \062A\0635\0627\0639\062F\064A\064B\0627 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615527856398752)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0641\0631\0632 \062A\0646\0627\0632\0644\064A\064B\0627 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611088839398749)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062A\0635\0627\0639\062F\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611321544398749)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062A\0635\0627\0639\062F\064A %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611126421398749)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062A\0646\0627\0632\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611403162398749)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062A\0646\0627\0632\0644\064A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110611276471398749)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\0645 \0627\0644\0641\0631\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621984195398757)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062C\0645\0627\0644\064A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548300832398702)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0634\0644 \0637\0644\0628 HTTP \0625\0644\0649"%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689695821398809)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \062A\062D\062F\064A\062F \0627\0644\0634\0628\0643\0629 %0 \0645\0646 \0627\0644\0623\0639\0645\062F\0629 %1 \0645\0646 \0627\0644\0635\0641\0648\0641. \0627\0633\062A\062E\062F\0645 \0645\0641\0627\062A\064A\062D \0627\0644\0623\0633\0647\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621870903398757)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0642\0627\0626\0645\0629 \0645\0646 %0 \0645\0646 \0627\0644\0635\0641\0648\0641. \0627\0633\062A\062E\062F\0645 \0645\0641\0627\062A\064A\062D \0627\0644\0623\0633\0647\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700593262398817)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608614013398747)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0625\062C\0631\0627\0621\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609690461398748)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609595977398748)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629 \0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694007906398812)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679591181398801)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\062C\0645\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681264012398802)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0643\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637645342398769)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0644 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0646\0635\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638862899398770)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\062F\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639902488398771)
,p_name=>'APEX.IG.AND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659378484398785)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\062F \0627\0644\0645\0645\064A\0632 \0627\0644\062A\0642\0631\064A\0628\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695053227398813)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\062F\062F \0627\0644\0625\062C\0645\0627\0644\064A \0627\0644\0645\0645\064A\0632 \0627\0644\062A\0642\0631\064A\0628\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678186966398800)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\0627\062D\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680032176398801)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0635\0627\0639\062F\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638980194398770)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0635\0627\062F\0642\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694171611398812)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0644\0642\0627\0626\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659713784398786)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062A\0648\0633\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694730754398813)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062A\0648\0633\0637 \0627\0644\0625\062C\0645\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677688606398800)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0645\062D\0648\0631 \0627\0644\062A\0633\0645\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677885509398800)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0645\0627\0643\0646 \0627\0644\0639\0634\0631\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677721190398800)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0645\062D\0648\0631 \0627\0644\0642\064A\0645\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683816690398804)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0648\0646 \0627\0644\062E\0644\0641\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678226324398800)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0631\064A\0637\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634248143398766)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685004640398805)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0644\0627\0647\0645\0627')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678320465398800)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0642\0627\0639\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609882359398748)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\063A\0627\0621')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639894254398771)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0633\0627\0633 \0644\062D\0627\0644\0629 \0627\0644\0623\062D\0631\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695678285398814)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'ar'
,p_message_text=>unistr('(\062D\0633\0627\0633 \0644\062D\0627\0644\0629 \0627\0644\0623\062D\0631\0641)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666577311398791)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0641\0638 \0627\0644\062A\063A\064A\064A\0631\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610299215398748)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\063A\064A\064A\0631 \0637\0631\064A\0642\0629 \0627\0644\0639\0631\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640900990398772)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637479865398769)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\062C\0627\0648\0632 \0627\0633\062A\0639\0644\0627\0645\0643 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0646\0642\0627\0637 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0628\0627\0644\063A %0 \0644\0643\0644 \0631\0633\0645 \0628\064A\0627\0646\064A. \0627\0644\0631\062C\0627\0621 \062A\0637\0628\064A\0642 \0645\0631\0634\062D \0644\062A\0642\0644\064A\0644 \0639\062F\062F \0627\0644\062A\0633\062C\064A\0644\0627\062A \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A \0627\0644\062E\0627\0635 \0628\0643.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608587061398747)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\0647\064A\0643\0644 \0627\0644\062A\0646\0638\064A\0645\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615813576398753)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677164536398799)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\063A\0644\0627\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684031832398805)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0644\0648\0627\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660130500398786)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0627\064A\0646\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639202650398770)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608707213398747)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0639\0645\062F\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685866144398806)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\0631\0636 \0627\0644\0639\0645\0648\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639302570398770)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\0643\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608950218398747)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0633\0627\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634856272398767)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641154113398772)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0648\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615626283398752)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\062E \0625\0644\0649 \0627\0644\062D\0627\0641\0638\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615739649398753)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\062E \0644\0623\0633\0641\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659198824398785)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\062F\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659275966398785)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\062F \0627\0644\0645\0645\064A\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694993202398813)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\062F\062F \0627\0644\0625\062C\0645\0627\0644\064A \0627\0644\0645\0645\064A\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694818859398813)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\062F\062F \0627\0644\0625\062C\0645\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692576287398811)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0643\0648\064A\0646 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637830499398769)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\064A\0627\0646\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685692554398806)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685267487398805)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0631\064A\062E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666334621398791)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645\0629 \0627\0644\062A\0627\0631\064A\062E \063A\064A\0631 \0635\0627\0644\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635519189398767)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\064A\0627\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638547240398770)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0625\0639\062F\0627\062F\0627\062A \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638326487398769)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0648\0639 \0627\0644\0627\0641\062A\0631\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609710795398748)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686843977398807)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0647\0644 \062A\0631\064A\062F \0628\0627\0644\062A\0623\0643\064A\062F \062D\0630\0641 \0647\0630\0627 \0627\0644\062A\0642\0631\064A\0631\061F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642930674398773)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641 \0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641706661398772)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641 \0627\0644\0635\0641\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680191036398802)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0646\0627\0632\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640698091398771)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0641\0627\0635\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608255590398747)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\0641\0627\0635\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668812214398793)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\062A\062C\0627\0647')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640397821398771)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0637\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634966598398767)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062D\062A\0648\064A \0639\0644\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635151275398767)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0628\062F\0623 \0628\0640')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678419892398800)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0627\0626\0631\064A \0645\062C\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641323748398772)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0646\0632\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540022561398696)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0627\0646\0627\062A \0641\0642\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687894205398808)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0635\064A\063A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552608024398705)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0646\0633\064A\0642 \0627\0644\062A\0646\0632\064A\0644 %0 \063A\064A\0631 \0645\0645\0643\0646.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680840735398802)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\0639 \0645\0643\0631\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680943110398802)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0627\0635\0644 \0639\0646\0627\0635\0631 \062A\062D\0643\0645 \0645\0643\0631\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642834039398773)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0641 \0645\0643\0631\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641620174398772)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641\0648\0641 \0627\0644\0645\0643\0631\0631\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609300232398748)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679953683398801)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691432707398810)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0627\0644\0645\062C\0645\0648\0639\0629 \062D\0633\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687413933398807)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\062E\0629 \0645\062E\0641\064A\0629 (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687674972398807)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0633\0627\0644\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687349765398807)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\062E\0629 (\0646\0633\062E\0629 \0625\0644\0649)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687068633398807)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0625\0631\0633\0627\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687564181398807)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0648\0636\0648\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687200987398807)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0633\062A\0644\0645 (\0625\0644\0649)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640078871398771)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0645\0643\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633209849398766)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0633\0627\0648\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686434022398806)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062B\0627\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640102158398771)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0628\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686339983398806)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0648\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652399307398780)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0625\0639\062F\0627\062F \0627\0644\0645\0644\0641. \062C\0627\0631\064D \0628\062F\0621 \0627\0644\062A\0646\0632\064A\0644.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110615924188398753)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0628\0626\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617083304398754)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\062A\0639\0628\0626\0629 \0645\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616906616398753)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\062A\0639\0628\0626\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608823603398747)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0631\0634\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639497557398770)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0631\0634\062D\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694408854398813)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\0634\062D...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680392616398802)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0648\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609017004398748)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0627\0631\064A\062E\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637924664398769)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\064A\063A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684946265398805)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0646\0627\0639 \0627\0644\0635\064A\0627\063A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686778904398807)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'ar'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686650384398807)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'ar'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599457337398740)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'ar'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538733563398695)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'ar'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642519835398773)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640242203398771)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062F\0648\0627\0644 \0648\0627\0644\0639\0648\0627\0645\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678534724398800)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0645\0639\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659043937398785)
,p_name=>'APEX.IG.GO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0642\0627\0644 \0625\0644\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633879693398766)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0643\0628\0631 \0645\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633917853398766)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0643\0628\0631 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640561885398771)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0628\0643\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608030273398747)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\0634\0628\0643\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681140005398802)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062C\0645\0648\0639\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640738187398771)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\0639 \062D\0633\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608383331398747)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \062A\062C\0645\064A\0639 \062D\0633\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685585254398806)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0634\0631\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684409558398805)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0648\0627\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684656420398805)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062D\0627\0630\0627\0629 \0627\0644\0639\0646\0648\0627\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694307760398813)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0644\064A\0645\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689830924398809)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\064A\0645\0643\0646 \0625\062F\0631\0627\062C \0627\0644\0628\064A\0627\0646\0627\062A \0648\062A\062D\062F\064A\062B\0647\0627 \0648\062D\0630\0641\0647\0627 \0645\0628\0627\0634\0631\0629 \0636\0645\0646 \0647\0630\0647 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629.</p>'),
'',
unistr('<p>\0623\062F\0631\062C \0635\0641\064B\0627 \062C\062F\064A\062F\064B\0627 \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0632\0631 "\0625\0636\0627\0641\0629 \0635\0641".</p>'),
'',
unistr('<p>\0642\0645 \0628\062A\062D\0631\064A\0631 \0628\064A\0627\0646\0627\062A \0645\0648\062C\0648\062F\0629 \0628\0627\0644\0646\0642\0631 \0627\0644\0645\0632\062F\0648\062C \0639\0644\0649 \062E\0644\064A\0629 \0628\0639\064A\0646\0647\0627. \0648\0644\062A\062D\0631\064A\0631 \0643\0645\064A\0627\062A \0623\0643\0628\0631\060C \0627\0646\0642\0631 \0639\0644\0649 "\062A\062D\0631\064A\0631" \0644\0644\062F\062E\0648\0644 \0641\064A \0648\0636\0639 \0627\0644\062A\062D\0631\064A\0631. \0648\0641\064A \0647\0630\0627 \0627\0644\0648\0636\0639 \064A\0645\0643\0646\0643 \0627\0644\0646\0642\0631 \0627\0644\0645\0641\0631\062F \0623\0648 \0627\0633\062A\062E\062F\0627\0645 \0644\0648\062D\0629 \0627\0644\0645\0641\0627\062A\064A\062D \0644\062A\062D\0631\064A\0631 \062E\0644\0627\064A\0627 \0628\0639\064A\0646\0647\0627.</p>'),
'',
unistr('<p>\0627\0633\062A\062E\062F\0645 \0627\0644\0642\0627\0626\0645\0629 "\062A\063A\064A\064A\0631" \0644\062A\0643\0631\0627\0631 \0635\0641\0648\0641 \0648\062D\0630\0641\0647\0627. \0648\0644\062A\0645\0643\064A\0646 \0627\0644\0642\0627\0626\0645\0629 "\062A\063A\064A\064A\0631" \0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639\0627\062A \0627\0644\0627\062E\062A\064A\0627\0631 \0644\062A\062D\062F\064A\062F \0635\0641 \0623\0648 \0623\0643\062B\0631.</p>'),
'',
unistr('<p>\0642\0645 \0628\062A\0643\0631\0627\0631 \0635\0641 \0645\062D\062F\062F \0639\0646 \0637\0631\064A\0642 \0627\0644\0646\0642\0631 \0639\0644\0649 \0627\0644\0642\0627\0626\0645\0629 "\062A\063A\064A\064A\0631" \0648\062A\062D\062F\064A\062F "\062A\0643\0631\0627\0631 \0635\0641\0648\0641". \0648\0627\062D\0630\0641 \0635\0641\064B\0627 \0645\062D\062F\062F\064B\0627 \0639\0646 \0637\0631\064A\0642 \0627\0644\0646\0642\0631 \0639\0644\0649 \0627\0644\0642\0627\0626\0645\0629 "\062A\063A\064A\064A\0631" \0648\062A\062D\062F\064A\062F "\062D\0630\0641 \0635\0641".</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691916328398811)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0645\0643\0627\0646\064A\0627\062A \0627\0644\062A\062D\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692018139398811)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\062A\0642\062F\0645 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0645\062C\0645\0648\0639\0629 \0645\0646 \0627\0644\0628\064A\0627\0646\0627\062A \0641\064A \062A\0642\0631\064A\0631 \0642\0627\0628\0644 \0644\0644\0628\062D\062B \0648\0627\0644\062A\062E\0635\064A\0635. \0648\064A\0645\0643\0646 \0625\062C\0631\0627\0621 \0627\0644\0639\062F\064A\062F \0645\0646 \0627\0644\0639\0645\0644\064A\0627\062A \0639\0644\064A\0647 \0644\062A\0642\0644\064A\0644 \0639\062F\062F \0627\0644\0633\062C\0644\0627\062A \0627\0644\0645\0631\062C\0639\0629\060C \0648\062A\063A\064A\064A\0631 \0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\0628\064A\0627\0646\0627\062A.</p>'),
'',
unistr('<p>\0627\0633\062A\062E\062F\0645 \0627\0644\062D\0642\0644 "\0628\062D\062B" \0641\064A \062A\0631\0634\064A\062D \0627\0644\0633\062C\0644\0627\062A \0627\0644\0645\0631\062C\0639\0629. \0648\0627\0646\0642\0631 \0639\0644\0649 "\0625\062C\0631\0627\0621\0627\062A" \0644\0644\0648\0635\0648\0644 \0625\0644\0649 \0627\0644\0639\062F\064A\062F \0645\0646 \062E\064A\0627\0631\0627\062A \062A\0639\062F\064A\0644 \0646\0633\0642 \0627\0644\062A\0642\0631\064A\0631\060C \0623\0648 \0627\0633\062A\062E\062F\0627\0645 \0642\0648\0627\0626\0645 "\0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F" \0641\064A \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629.</p>'),
'',
unistr('<p>\0627\0633\062A\062E\062F\0645 "\0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631" \0644\062D\0641\0638 \0639\0645\0644\064A\0627\062A \0627\0644\062A\062E\0635\064A\0635 \0627\0644\062A\064A \0623\062C\0631\064A\062A\0647\0627 \0641\064A \062A\0642\0631\064A\0631. \0643\0645\0627 \064A\0645\0643\0646\0643 \062A\0646\0632\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A \0645\0646 \0627\0644\062A\0642\0631\064A\0631 \0641\064A \0645\0644\0641 \062E\0627\0631\062C\064A\060C \0623\0648 \0625\0631\0633\0627\0644\0647\0627 \0641\064A \0631\0633\0627\0644\0629 \0625\0644\0643\062A\0631\0648\0646\064A\0629 \0625\0644\0649 \0646\0641\0633\0643 \0623\0648 \0627\0644\0622\062E\0631\064A\0646.</p>'),
'',
unistr('<p>\0644\0645\0639\0631\0641\0629 \0627\0644\0645\0632\064A\062F\060C \064A\064F\0631\062C\0649 \0627\0644\0627\0637\0644\0627\0639 \0639\0644\0649 "\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0634\0628\0643\0627\062A \0627\0644\062A\0641\0627\0639\0644\064A\0629" \0641\064A <em>\062F\0644\064A\0644 \0645\0633\062A\062E\062F\0645 Oracle Application Express</em> (Oracle Application Express End User''s Guide).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691704284398811)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0638\0631\0629 \0639\0627\0645\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689783422398809)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\064A\0645\0643\0646\0643 \062A\062E\0635\064A\0635 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0628\062D\064A\062B \062A\0639\0631\0636 \0627\0644\0628\064A\0627\0646\0627\062A \0628\0637\0631\0642 \0645\062A\0646\0648\0639\0629 \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0625\0645\0643\0627\0646\064A\0627\062A \0627\0644\0645\0636\0645\0646\0629 \0641\064A\0647\0627.</p>'),
'',
unistr('<p>\0627\0633\062A\062E\062F\0645 \0642\0648\0627\0626\0645 "\0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F" \0623\0648 \0627\0644\0642\0627\0626\0645\0629 "\0625\062C\0631\0627\0621\0627\062A" \0644\062A\062D\062F\064A\062F \0623\064A \0627\0644\0623\0639\0645\062F\0629 \064A\062A\0645 \0639\0631\0636\0647\0627\060C \0648\0628\0623\064A \062A\0633\0644\0633\0644\060C \0648\062A\062C\0645\064A\062F \0623\0639\0645\062F\0629. \0643\0645\0627 \064A\0645\0643\0646\0643 \062A\0639\0631\064A\0641 \0645\062E\062A\0644\0641 \0645\0631\0634\062D\0627\062A \0627\0644\0628\064A\0627\0646\0627\062A \0648\0641\0631\0632 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0645\0631\062C\0639\0629.</p>'),
'',
unistr('<p>\0627\0633\062A\062E\062F\0645 \0627\0644\0632\0631 "\0639\0631\0636" (\0627\0644\0645\062C\0627\0648\0631 \0644\0644\062D\0642\0644 "\0628\062D\062B") \0641\064A \0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0637\0631\0642 \0639\0631\0636 \0628\064A\0627\0646\0627\062A \0623\062E\0631\0649 \0631\0628\0645\0627 \062A\0645 \062A\0639\0631\064A\0641\0647\0627 \0628\0648\0627\0633\0637\0629 \0645\0637\0648\0631 \0627\0644\062A\0637\0628\064A\0642. \0643\0645\0627 \064A\0645\0643\0646\0643 \062A\0643\0648\064A\0646 \0631\0633\0645 \0628\064A\0627\0646\064A \0623\0648 \0639\0631\0636 \0631\0633\0645 \0628\064A\0627\0646\064A \0645\0648\062C\0648\062F.</p>  '),
'',
unistr('<p><em>\0645\0644\0627\062D\0638\0629: \0627\0646\0642\0631 \0639\0644\0649 <strong>\062A\0639\0644\064A\0645\0627\062A</strong> \0641\064A \0645\0631\0628\0639\0627\062A \062D\0648\0627\0631 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0645\0632\064A\062F \0645\0646 \0627\0644\0645\0639\0644\0648\0645\0627\062A \0627\0644\062A\0641\0635\064A\0644\064A\0629 \062D\0648\0644 \0627\0644\062F\0627\0644\0629 \0627\0644\0645\062D\062F\062F\0629.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691833745398811)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0645\0643\0627\0646\064A\0627\062A \0625\0639\062F\0627\062F \0627\0644\062A\0642\0627\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641510070398772)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688649429398808)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062A\062C\0645\064A\0639 \0627\0644\0623\0639\0645\062F\0629. \064A\062A\0645 \0639\0631\0636 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\062C\0645\0639\0629 \0641\064A \0646\0647\0627\064A\0629 \0627\0644\0628\064A\0627\0646\0627\062A\060C \0623\0648 \0641\064A \062D\0627\0644\0629 \062A\0639\0631\064A\0641 "\0641\0648\0627\0635\0644 \062A\062D\0643\0645" \064A\062A\0645 \0639\0631\0636\0647\0627 \0641\064A \0623\0633\0641\0644 \0643\0644 \0641\0627\0635\0644.</p>'),
'',
unistr('<p><strong>\0642\0627\0626\0645\0629 \0627\0644\062A\062C\0645\064A\0639</strong><br>'),
unistr('\062A\0639\0631\0636 \0642\0627\0626\0645\0629 \0627\0644\062A\062C\0645\064A\0639 \0645\0627 \062A\0645 \062A\0639\0631\064A\0641\0647 \0645\0646 \062A\062C\0645\064A\0639\0627\062A. \0648\064A\0645\0643\0646 \062A\0639\0637\064A\0644 \062A\062C\0645\064A\0639 \0645\0648\062C\0648\062F \0639\0646 \0637\0631\064A\0642 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647.<br>'),
unistr('\0627\0646\0642\0631 \0639\0644\0649 "\0625\0636\0627\0641\0629" ( &plus; ) \0644\062A\0643\0648\064A\0646 \062A\062C\0645\064A\0639 \062C\062F\064A\062F\060C \0623\0648 \0639\0644\0649 "\062D\0630\0641" ( &minus; ) \0644\0625\0632\0627\0644\0629 \062A\062C\0645\064A\0639 \0645\0648\062C\0648\062F.</p>'),
'',
unistr('<p><strong>\0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\062C\0645\064A\0639</strong><br>'),
unistr('\0627\0633\062A\062E\062F\0645 \0627\0644\0646\0645\0648\0630\062C \0627\0644\0645\0648\062C\0648\062F \0639\0644\0649 \0627\0644\062C\0627\0646\0628 \0627\0644\0623\064A\0645\0646 \0641\064A \062A\0639\0631\064A\0641 \0627\0644\062A\062C\0645\064A\0639.<br>'),
unistr('\062D\062F\062F \0627\0633\0645 \0627\0644\0639\0645\0648\062F \0648\0646\0648\0639 \0627\0644\062A\062C\0645\064A\0639.<br>'),
unistr('\064A\0645\0643\0646 \0628\0634\0643\0644 \0627\062E\062A\064A\0627\0631\064A \0625\062F\062E\0627\0644 \062A\0644\0645\064A\062D \0628\0634\0623\0646 \0627\0644\062A\062C\0645\064A\0639.<br>'),
unistr('\0641\064A \062D\0627\0644\0629 \0648\062C\0648\062F \0641\0627\0635\0644 \062A\062D\0643\0645 \0645\0639\0631\0641\060C \0641\0625\0646 \062A\062D\062F\064A\062F <strong>\0625\0638\0647\0627\0631 \0627\0644\0642\064A\0645\0629 \0627\0644\0625\062C\0645\0627\0644\064A\0629</strong> \0627\0644\0645\062A\0648\0633\0637 \0627\0644\0625\062C\0645\0627\0644\064A \0623\0648 \0627\0644\0625\062C\0645\0627\0644\064A \0627\0644\0643\0644\064A \0623\0648 \0642\064A\0645\0629 \0645\0634\0627\0628\0647\0629 \0641\064A \0623\0633\0641\0644 \0627\0644\0628\064A\0627\0646\0627\062A.</p>'),
'',
unistr('<p><em>\0645\0644\0627\062D\0638\0629: \064A\0645\0643\0646 \0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 "\062A\062C\0645\064A\0639" \0639\0646 \0637\0631\064A\0642 \0627\0644\0642\0627\0626\0645\0629 "\0625\062C\0631\0627\0621\0627\062A" \0623\0648 \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F \0648\0627\0644\0645\062C\0645\0648\0639 ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690810127398810)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\062A\062C\0645\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689300414398809)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0644\062A\0639\0631\064A\0641 \0631\0633\0645 \0628\064A\0627\0646\064A \064A\0638\0647\0631 \0643\0637\0631\064A\0642\0629 \0639\0631\0636 \0628\064A\0627\0646\0627\062A \0645\0646\0641\0635\0644\0629.<br>'),
unistr('\062D\062F\062F \0646\0648\0639 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0648\0633\0645\0627\062A\0647.</p>'),
unistr('<p><strong>\0633\0645\0627\062A \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A</strong></br>'),
unistr('\062A\062E\062A\0644\0641 \0633\0645\0627\062A \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\0645\062A\0627\062D\0629 \062A\0628\0639\064B\0627 \0644\0646\0648\0639 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A.</p>'),
'<p>',
'<ul>',
unistr('  <li>\062D\062F\062F \0627\0644\0639\0645\0648\062F \0627\0644\0630\064A \064A\062D\062A\0648\064A \0639\0644\0649 \0642\064A\0645\0629 \0627\0644\0633\0645\0629:'),
'    <ul>',
unistr('      <li>\0627\0644\062A\0633\0645\064A\0629 - \0646\0635 \0643\0644 \0646\0642\0637\0629 \0628\064A\0627\0646\0627\062A.</li>'),
unistr('      <li>\0627\0644\0642\064A\0645\0629 - \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0645\0637\0644\0648\0628 \062A\062E\0637\064A\0637\0647\0627.</li>'),
unistr('      <li>\0627\0644\0633\0644\0633\0644\0629 - \0644\062A\0639\0631\064A\0641 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\062F\064A\0646\0627\0645\064A\0643\064A \0645\062A\0639\062F\062F \0627\0644\0633\0644\0627\0633\0644.</li>'),
unistr('      <li>\0641\062A\062D - \0633\0639\0631 \0627\0644\0641\062A\062D \0627\0644\064A\0648\0645\064A \0644\0644\0623\0633\0647\0645 (\0627\0644\0623\0633\0647\0645 \0641\0642\0637).</li>'),
unistr('      <li>\0625\0642\0641\0627\0644 - \0633\0639\0631 \0627\0644\0625\0642\0641\0627\0644 \0627\0644\064A\0648\0645\064A \0644\0644\0623\0633\0647\0645 (\0627\0644\0623\0633\0647\0645 \0641\0642\0637).</li>'),
unistr('      <li>\0645\0631\062A\0641\0639 - \0627\0644\0642\064A\0645\0629 \0627\0644\0645\0631\062A\0641\0639\0629 (\0627\0644\0646\0637\0627\0642 \0648\0627\0644\0623\0633\0647\0645 \0641\0642\0637).</li>'),
unistr('      <li>\0645\0646\062E\0641\0636 - \0627\0644\0642\064A\0645\0629 \0627\0644\0645\0646\062E\0641\0636\0629 (\0627\0644\0646\0637\0627\0642 \0648\0627\0644\0623\0633\0647\0645).</li>'),
unistr('      <li>\0627\0644\062D\062C\0645 - \062D\062C\0645 \0627\0644\062A\062F\0627\0648\0644 \0627\0644\064A\0648\0645\064A \0644\0644\0623\0633\0647\0645 (\0627\0644\0623\0633\0647\0645 \0641\0642\0637).</li>'),
unistr('      <li>\0627\0644\0647\062F\0641 - \0627\0644\0642\064A\0645\0629 \0627\0644\0647\062F\0641 (\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\0642\0645\0639\064A).</li>'),
unistr('      <li>\0633 - \0642\064A\0645\0629 \0627\0644\0645\062D\0648\0631 \0633 (\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\0641\0642\0627\0639\064A \0648\0627\0644\0645\0628\0639\062B\0631 \0641\0642\0637).</li>'),
unistr('      <li>\0635 - \0642\064A\0645\0629 \0627\0644\0645\062D\0648\0631 \0635 (\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\0641\0642\0627\0639\064A \0648\0627\0644\0645\0628\0639\062B\0631 \0641\0642\0637).</li>'),
unistr('      <li>\0639 - \0639\0631\0636 \0627\0644\0634\0631\064A\0637 \0623\0648 \0646\0635\0641 \0642\0637\0631 \0627\0644\0641\0642\0627\0639\0629 (\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\0641\0642\0627\0639\064A \0648\0627\0644\0645\0628\0639\062B\0631 \0641\0642\0637).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\0627\0644\0627\062A\062C\0627\0647 - \0627\0644\0639\0631\0636 \0631\0623\0633\064A\064B\0627 \0623\0648 \0623\0641\0642\064A\064B\0627.</li>'),
unistr('  <li>\0627\0644\062A\062C\0645\064A\0639 - \062A\062D\062F\064A\062F \0643\064A\0641\064A\0629 \062A\062C\0645\064A\0639 \0642\064A\0645 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A.</li>'),
unistr('  <li>\0627\0644\0645\0643\062F\0633 - \062A\062D\062F\064A\062F \0625\0630\0627 \0645\0627 \0643\0627\0646\062A \0639\0646\0627\0635\0631 \0627\0644\0628\064A\0627\0646\0627\062A \0645\0643\062F\0633\0629.</li>'),
unistr('  <li>\0641\0631\0632 \062D\0633\0628 - \0627\0644\0641\0631\0632 \062D\0633\0628 \0627\0644\062A\0633\0645\064A\0629 \0623\0648 \0627\0644\0642\064A\0645\0629 (\0627\0644\0642\064A\0645).'),
'    <ul>',
unistr('      <li>\0627\0644\0627\062A\062C\0627\0647 - \0641\0631\0632 \0627\0644\0642\064A\0645 \0628\062A\0631\062A\064A\0628 \062A\0635\0627\0639\062F\064A \0623\0648 \062A\0646\0627\0632\0644\064A.</li>'),
unistr('      <li>\0627\0644\0642\064A\0645 \0627\0644\0641\0627\0631\063A\0629 - \062A\062D\062F\064A\062F \0643\064A\0641\064A\0629 \0641\0631\0632 \0627\0644\0633\062C\0644\0627\062A \0630\0627\062A \0627\0644\0642\064A\0645 \0627\0644\0641\0627\0631\063A\0629 \0645\0642\0627\0631\0646\0629 \0628\0627\0644\0633\062C\0644\0627\062A \0630\0627\062A \0627\0644\0642\064A\0645 \063A\064A\0631 \0627\0644\0641\0627\0631\063A\0629.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\0627\0644\0645\0646\0627\0632\0644 \0627\0644\0639\0634\0631\064A\0629</li>'),
unistr('  <li>\0639\0646\0648\0627\0646 \0645\062D\0648\0631 \0627\0644\062A\0633\0645\064A\0629</li>'),
unistr('  <li>\0639\0646\0648\0627\0646 \0645\062D\0648\0631 \0627\0644\0642\064A\0645\0629</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691247701398810)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688309243398808)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0644\0627\062E\062A\064A\0627\0631 \0623\064A \0627\0644\0623\0639\0645\062F\0629 \0633\064A\062A\0645 \0639\0631\0636\0647\0627 \0648\0628\0623\064A \062A\0631\062A\064A\0628.</p>'),
'',
unistr('<p>\064A\0645\0643\0646 \0625\062E\0641\0627\0621 \0627\0644\0639\0645\0648\062F \0639\0646 \0637\0631\064A\0642 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647.<br>'),
unistr('\0643\0645\0627 \064A\0645\0643\0646 \0625\0639\0627\062F\0629 \062A\0631\062A\064A\0628 \0627\0644\0623\0639\0645\062F\0629 \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0646\0642\0644 \0644\0623\0639\0644\0649 ( &uarr; ) \0623\0648 \0646\0642\0644 \0644\0623\0633\0641\0644 ( &darr; ).<br>'),
unistr('\0627\0633\062A\062E\062F\0645 \0627\0644\0645\064F\062D\062F\0650\062F \0627\0644\0645\0646\0633\062F\0644 \0644\0639\0631\0636 "\0643\0644" \0627\0644\0623\0639\0645\062F\0629 \0623\0648 "\0627\0644\0645\0639\0631\0648\0636" \0623\0648 "\063A\064A\0631 \0627\0644\0645\0639\0631\0648\0636" \0645\0646 \0627\0644\0623\0639\0645\062F\0629.</p>'),
'',
unistr('<p>\0628\0634\0643\0644 \0627\062E\062A\064A\0627\0631\064A\060C \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 \0627\0644\0646\0645\0648\0630\062C \0641\064A \062A\062D\062F\064A\062F \0627\0644\062D\062F \0627\0644\0623\062F\0646\0649 \0644\0639\0631\0636 \0639\0645\0648\062F \0628\0627\0644\0628\0643\0633\0644.</p>'),
'',
unistr('<p><em>\0645\0644\0627\062D\0638\0629: \064A\0645\0643\0646\0643 \0643\0630\0644\0643 \0625\0639\0627\062F\0629 \062A\0631\062A\064A\0628 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629 \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0645\0642\0628\0636 \0627\0644\0633\062D\0628 (\0641\064A \0628\062F\0627\064A\0629 \0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F) \0648\0633\062D\0628 \0627\0644\0639\0645\0648\062F \0625\0644\0649 \0627\0644\064A\0645\064A\0646 \0623\0648 \0625\0644\0649 \0627\0644\064A\0633\0627\0631. \0648\0628\0645\0642\062F\0648\0631\0643 \0623\064A\0636\064B\0627 \062A\063A\064A\064A\0631 \0639\0631\0636 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629 \0639\0646 \0637\0631\064A\0642 \062A\062D\062F\064A\062F \0641\0627\0635\0644 \0627\0644\0623\0639\0645\062F\0629\060C \0627\0644\0648\0627\0642\0639 \0628\064A\0646 \0627\0644\0639\0646\0627\0648\064A\0646\060C \0648\0646\0642\0644\0647 \0625\0644\0649 \0627\0644\064A\0645\064A\0646 \0623\0648 ')
||unistr('\0625\0644\0649 \0627\0644\064A\0633\0627\0631.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691121774398810)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\0623\0639\0645\062F\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688737102398808)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062A\0639\0631\064A\0641 \0623\0639\0645\062F\0629 \0625\0636\0627\0641\064A\0629 \0627\0633\062A\0646\0627\062F\064B\0627 \0625\0644\0649 \062D\0633\0627\0628\0627\062A \062A\0642\0648\0645 \0639\0644\0649 \0627\0644\0631\064A\0627\0636\064A\0627\062A \0648\0627\0644\062F\0648\0627\0644 \064A\062A\0645 \0625\062C\0631\0627\0624\0647\0627 \0639\0644\0649 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0648\062C\0648\062F\0629.</p>'),
'',
unistr('<p><strong>\0642\0627\0626\0645\0629 \0627\0644\062D\0633\0627\0628</strong><br>'),
unistr('\062A\0639\0631\0636 \0642\0627\0626\0645\0629 "\0627\0644\062D\0633\0627\0628" \0645\0627 \062A\0645 \062A\0639\0631\064A\0641\0647 \0645\0646 \062D\0633\0627\0628\0627\062A. \0648\064A\0645\0643\0646 \062A\0639\0637\064A\0644 \062D\0633\0627\0628 \0645\0648\062C\0648\062F \0639\0646 \0637\0631\064A\0642 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647.<br>'),
unistr('\0627\0646\0642\0631 \0639\0644\0649 "\0625\0636\0627\0641\0629" ( &plus; ) \0644\0625\0636\0627\0641\0629 \062D\0633\0627\0628 \062C\062F\064A\062F\060C \0627\0648 \0639\0644\0649 "\062D\0630\0641" ( &minus; ) \0644\0625\0632\0627\0644\0629 \062D\0633\0627\0628 \0645\0648\062C\0648\062F.</p>'),
'',
unistr('<p><strong>\0625\0639\062F\0627\062F\0627\062A \0627\0644\062D\0633\0627\0628</strong><br>'),
unistr('\0627\0633\062A\062E\062F\0645 \0627\0644\0646\0645\0648\0630\062C \0641\064A \062A\0639\0631\064A\0641 \0627\0644\062D\0633\0627\0628.<br>'),
unistr('\0623\062F\062E\0644 \062A\0641\0627\0635\064A\0644 \0627\0644\0639\0645\0648\062F\060C \0645\062B\0644 \0627\0644\0639\0646\0648\0627\0646 \0648\0627\0644\062A\0633\0645\064A\0629 \0648\062D\062F\062F \0625\0639\062F\0627\062F\0627\062A \0627\0644\0645\062D\0627\0630\0627\0629.<br> '),
unistr('\0627\0633\062A\062E\062F\0645 \0645\0633\0627\062D\0629 \0646\0635 "\0627\0644\062A\0639\0628\064A\0631" \0641\064A \0625\062F\062E\0627\0644 \0627\0644\0639\0645\0648\062F/\0627\0644\0623\0639\0645\062F\0629 \0648\0645\0627 \064A\0642\062A\0631\0646 \0628\0647\0627 \0645\0646 \062F\0648\0627\0644 \0644\0625\062C\0631\0627\0621 \0627\0644\062D\0633\0627\0628.<br>'),
unistr('\062D\062F\062F \0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0645\0644\0627\0626\0645\060C \0645\0639 \0642\0646\0627\0639 \062A\0646\0633\064A\0642 \0627\062E\062A\064A\0627\0631\064A\060C \0644\0644\0639\0645\0648\062F \0627\0644\062C\062F\064A\062F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690703892398810)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\062D\0633\0627\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689015495398809)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062A\0639\0631\064A\0641 \0641\0627\0635\0644 \062A\062D\0643\0645 \0641\064A \0639\0645\0648\062F \0623\0648 \0623\0643\062B\0631.</p>'),
'',
unistr('<p><strong>\0642\0627\0626\0645\0629 \0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645</strong><br>'),
unistr('\062A\0639\0631\0636 \0642\0627\0626\0645\0629 "\0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645" \0645\0627 \062A\0645 \062A\0639\0631\064A\0641\0647 \0645\0646 \0641\0648\0627\0635\0644 \0627\0644\062A\062D\0643\0645. \0648\064A\0645\0643\0646 \062A\0639\0637\064A\0644 \0639\0645\0648\062F \0641\0627\0635\0644 \062A\062D\0643\0645 \0645\0648\062C\0648\062F \0639\0646 \0637\0631\064A\0642 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647.<br>'),
unistr('\0627\0646\0642\0631 \0639\0644\0649 "\0625\0636\0627\0641\0629" ( &plus; ) \0644\062A\0636\0645\064A\0646 \0639\0645\0648\062F \062C\062F\064A\062F \0641\064A \0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645\060C \0623\0648 \0627\0646\0642\0631 \0639\0644\0649 "\062D\0630\0641" ( &minus; ) \0644\0625\0632\0627\0644\0629 \0639\0645\0648\062F \0645\0648\062C\0648\062F \0645\0646 \0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645.<br>'),
unistr('\0644\0625\0639\0627\062F\0629 \062A\0631\062A\064A\0628 \0627\0644\0623\0639\0645\062F\0629\060C \0627\0646\0642\0631 \0639\0644\0649 "\0646\0642\0631 \0644\0623\0639\0644\0649" ( &uarr; ) \0623\0648 "\0646\0642\0644 \0644\0623\0633\0641\0644" ( &darr; ) \0644\0646\0642\0644 \0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\062F\062F \0623\0639\0644\0649 \0623\0648 \0623\0633\0641\0644 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0623\062E\0631\0649.</p>'),
'',
unistr('<p><strong>\0625\0639\062F\0627\062F\0627\062A \0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645</strong><br>'),
unistr('\0627\0633\062A\062E\062F\0645 \0627\0644\0646\0645\0648\0630\062C \0641\064A \062A\0639\0631\064A\0641 \0639\0645\0648\062F \0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645.<br>'),
unistr('\062A\062A\0639\0644\0642 \0627\0644\0625\0639\062F\0627\062F\0627\062A \0628\062A\062D\062F\064A\062F \0639\0645\0648\062F \0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645\060C \0648\0627\062A\062C\0627\0647 \0627\0644\0641\0631\0632\060C \0648\0643\064A\0641\064A\0629 \062A\0631\062A\064A\0628 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0641\0627\0631\063A\0629 (\0623\064A \0627\0644\0623\0639\0645\062F\0629 \063A\064A\0631 \0627\0644\0645\0634\062A\0645\0644\0629 \0639\0644\0649 \0642\064A\0645).</p>'),
'',
unistr('<p><em>\0645\0644\0627\062D\0638\0629: \0639\0646\062F \0639\0631\0636 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629\060C \064A\0645\0643\0646 \062A\0639\0631\064A\0641 \0641\0627\0635\0644 \062A\062D\0643\0645 \0628\0627\0644\0646\0642\0631 \0639\0644\0649 "\0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F" \0648\062A\062D\062F\064A\062F \0623\064A\0642\0648\0646\0629 \0641\0627\0635\0644 \0627\0644\062A\062D\0643\0645.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690452193398810)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0641\0648\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689289977398809)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062A\0646\0632\064A\0644 \0643\0644 \0627\0644\0635\0641\0648\0641 \0627\0644\062D\0627\0644\064A\0629 \0641\064A \0645\0644\0641 \062E\0627\0631\062C\064A. \0648\0633\0648\0641 \064A\0634\062A\0645\0644 \0627\0644\0645\0644\0641 \0641\0642\0637 \0639\0644\0649 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629 \062D\0627\0644\064A\064B\0627\060C \0628\0627\0633\062A\062E\062F\0627\0645 \0623\064A\0629 \0645\0631\0634\062D\0627\062A \0648\0639\0645\0644\064A\0627\062A \0641\0631\0632 \0645\0637\0628\0642\0629 \0639\0644\0649 \0627\0644\0628\064A\0627\0646\0627\062A.</p>'),
'',
unistr('<p>\062D\062F\062F \062A\0646\0633\064A\0642 \0627\0644\0645\0644\0641 \0648\0627\0636\063A\0637 \0639\0644\0649 "\062A\0646\0632\064A\0644".<br>'),
unistr('\0645\0644\0627\062D\0638\0629: \0644\0646 \064A\0634\062A\0645\0644 \0645\0644\0641 CSV \0639\0644\0649 \062A\0646\0633\064A\0642 \0646\0635\064A \0645\062B\0644 \0627\0644\062A\062C\0645\064A\0639\0627\062A \0648\0641\0648\0627\0635\0644 \0627\0644\062A\062D\0643\0645.</p>'),
'',
unistr('<p>\0644\0625\0631\0633\0627\0644 \0627\0644\0645\0644\0641 \0639\0628\0631 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A\060C \062D\062F\062F "\0625\0631\0633\0627\0644 \0643\0631\0633\0627\0644\0629 \0625\0644\0643\062A\0631\0648\0646\064A\0629" \0648\0623\062F\062E\0644 \062A\0641\0627\0635\064A\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A (\0627\0644\0645\062A\0644\0642\064A\060C \0627\0644\0645\0648\0636\0648\0639\060C \0627\0644\0631\0633\0627\0644\0629).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690252414398809)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\062A\0646\0632\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688454434398808)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062A\0643\0648\064A\0646 \0645\0631\0634\062D\0627\062A \0627\0644\0628\064A\0627\0646\0627\062A \0648\0627\0644\062A\064A \062A\0642\0644\0644 \0645\0646 \0639\062F\062F \0627\0644\0635\0641\0648\0641 \0627\0644\0631\0627\062C\0639\0629.</p>'),
'',
unistr('<p><strong>\0642\0627\0626\0645\0629 \0627\0644\0645\0631\0634\062D\0627\062A</strong><br>'),
unistr('\062A\0639\0631\0636 \0642\0627\0626\0645\0629 \0627\0644\0645\0631\0634\062D\0627\062A \0645\0627 \062A\0645 \062A\0639\0631\064A\0641\0647 \0645\0646 \0645\0631\0634\062D\0627\062A. \0648\064A\0645\0643\0646 \062A\0639\0637\064A\0644 \0645\0631\0634\062D \0645\0648\062C\0648\062F \0639\0646 \0637\0631\064A\0642 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647.<br>'),
unistr('\0627\0646\0642\0631 \0639\0644\0649 "\0625\0636\0627\0641\0629" ( &plus; ) \0644\0645\0633\062D \0645\0631\0634\062D \062C\062F\064A\062F\060C \0623\0648 \0639\0644\0649 "\062D\0630\0641" ( &minus; ) \0644\0625\0632\0627\0644\0629 \0645\0631\0634\062D \0645\0648\062C\0648\062F.</p>'),
'',
unistr('<p><strong>\0625\0639\062F\0627\062F\0627\062A \0627\0644\0645\0631\0634\062D</strong><br>'),
unistr('\0627\0633\062A\062E\062F\0645 \0627\0644\0646\0645\0648\0630\062C \0641\064A \062A\0639\0631\064A\0641 \062E\0635\0627\0626\0635 \0627\0644\0645\0631\0634\062D.<br>'),
unistr('\062A\062D\062F\064A\062F \0646\0648\0639 \0627\0644\0645\0631\0634\062D \0627\0644\0645\0644\0627\0626\0645:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0635\0641 - \0645\0631\0634\062D \0644\0644\0628\062D\062B \0639\0646 \0645\0635\0637\0644\062D \0641\064A \0623\064A \0639\0645\0648\062F \0642\0627\0628\0644 \0644\0644\062A\0631\0634\064A\062D.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0639\0645\0648\062F - \062A\0631\0634\064A\062D \0639\0645\0648\062F \0628\0639\064A\0646\0647 \0628\0627\0633\062A\062E\062F\0627\0645 \0639\0627\0645\0644 \0648\0642\064A\0645\0629 \0628\0639\064A\0646\0647\0645\0627.</p>'),
'',
unistr('<p><em>\0645\0644\0627\062D\0638\0629: \0639\0646\062F \0639\0631\0636 \0634\0628\0643\0629 \062A\0641\0627\0639\0644\064A\0629\060C \064A\0645\0643\0646 \062A\0639\0631\064A\0641 \0645\0631\0634\062D\0627\062A \0635\0641 \0639\0646 \0637\0631\064A\0642 \0627\0644\0643\062A\0627\0628\0629 \0641\064A \0627\0644\062D\0642\0644 "\0628\062D\062B". \0648\0627\0644\0646\0642\0631 \0639\0644\0649 "\062A\062D\062F\064A\062F \0623\0639\0645\062F\0629 \0644\0644\0628\062D\062B" \0628\063A\0631\0636 \0642\0635\0631 \0627\0644\0628\062D\062B \0639\0644\0649 \0623\0639\0645\062F\0629 \0645\0639\064A\0646\0629. \0648\064A\0645\0643\0646 \0643\0625\062C\0631\0627\0621 \0628\062F\064A\0644\060C \0641\062A\062D \0642\0627\0626\0645\0629 "\0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F" \0648\062A\062D\062F\064A\062F \0642\064A\0645\0629 \0644\062A\0643\0648\064A\0646 \0645\0631\0634\062D \0639\0645\0648\062F.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691032642398810)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\0645\0631\0634\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688848933398808)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \0639\0631\0636 \0627\0644\0628\064A\0627\0646\0627\062A \0643\0645\0627 \0643\0627\0646\062A \0641\064A \0646\0642\0637\0629 \0633\0627\0628\0642\0629 \0641\064A \0627\0644\0645\0627\0636\064A.</p>'),
unistr('<p>\0623\062F\062E\0644 \0639\062F\062F \0627\0644\062F\0642\0627\0626\0642 \0641\064A \0627\0644\0645\0627\0636\064A \0644\0625\062C\0631\0627\0621 \0627\0633\062A\0639\0644\0627\0645 \0639\0646 \0628\064A\0627\0646\0627\062A \062A\0627\0631\064A\062E\064A\0629.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690666352398810)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0627\0631\064A\062E\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691373701398810)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688941146398808)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062A\0645\064A\064A\0632 \0635\0641\0648\0641 \0623\0648 \0623\0639\0645\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \062A\0628\0639\064B\0627 \0644\0634\0631\0637 \062A\0645 \0625\062F\062E\0627\0644\0647.</p>'),
'',
unistr('<p><strong>\0642\0627\0626\0645\0629 \0627\0644\062A\0645\064A\064A\0632</strong><br>'),
unistr('\062A\0639\0631\0636 \0642\0627\0626\0645\0629 "\0627\0644\062A\0645\064A\064A\0632" \0645\0627 \062A\0645 \062A\0639\0631\064A\0641\0647 \0645\0646 \062A\0645\064A\064A\0632\0627\062A. \0648\064A\0645\0643\0646 \062A\0639\0637\064A\0644 \062A\0645\064A\064A\0632 \0645\0648\062C\0648\062F \0639\0646 \0637\0631\064A\0642 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647.<br>'),
unistr('\0627\0646\0642\0631 \0639\0644\0649 "\0625\0636\0627\0641\0629" ( &plus; ) \0644\062A\0643\0648\064A\0646 \062A\0645\064A\064A\0632 \062C\062F\064A\062F\060C \0623\0648 \0627\0646\0642\0631 \0639\0644\0649 "\062D\0630\0641" ( &minus; ) \0644\0625\0632\0627\0644\0629 \062A\0645\064A\064A\0632 \0645\0648\062C\0648\062F.</p>'),
unistr('<p><strong>\0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0645\064A\064A\0632</strong><br>'),
unistr('\0627\0633\062A\062E\062F\0645 \0627\0644\0646\0645\0648\0630\062C \0641\064A \062A\0639\0631\064A\0641 \062E\0635\0627\0626\0635 \0627\0644\062A\0645\064A\064A\0632.<br>'),
unistr('\0623\062F\062E\0644 \0627\0644\0627\0633\0645\060C \0648\062D\062F\062F "\0635\0641" \0623\0648 "\0639\0645\0648\062F" \062B\0645 \062D\062F\062F \0631\0645\0648\0632 \0623\0644\0648\0627\0646 HTML\0644\0644\062E\0644\0641\064A\0629 \0648\0627\0644\0646\0635.<br>'),
unistr('\062D\062F\062F <strong>\0646\0648\0639 \0627\0644\0634\0631\0637</strong> \0627\0644\0645\0644\0627\0626\0645 \0644\062A\0645\064A\064A\0632 \0628\064A\0627\0646\0627\062A \0645\062D\062F\062F\0629:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0635\0641 - \062A\0645\064A\064A\0632 \0627\0644\0645\0635\0637\0644\062D \0641\064A \0623\064A \0639\0645\0648\062F.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0639\0645\0648\062F - \0627\0644\062A\0645\064A\064A\0632 \0641\064A \0639\0645\0648\062F \0645\062D\062F\062F \062A\0628\0639\064B\0627 \0644\0639\0627\0645\0644 \0648\0642\064A\0645\0629 \0628\0639\064A\0646\0647\0645\0627.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690591360398810)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\062A\0645\064A\064A\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689102158398809)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062D\0641\0638 \0627\0644\062A\063A\064A\064A\0631\0627\062A \0627\0644\062A\064A \0623\062C\0631\064A\062A\0647\0627 \0639\0644\0649 \0646\0633\0642 \0627\0644\0634\0628\0643\0629 \0627\0644\062D\0627\0644\064A\0629 \0648\0639\0644\0649 \0627\0644\062A\0643\0648\064A\0646.<br>'),
unistr('\0628\0648\0633\0639 \0645\0637\0648\0631\064A \0627\0644\062A\0637\0628\064A\0642\0627\062A \062A\0639\0631\064A\0641 \0627\0644\0639\062F\064A\062F \0645\0646 \0646\064F\0633\0642 \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\0628\062F\064A\0644\0629. \0648\0645\062A\0649 \0623\0645\0643\0646\060C \064A\0645\0643\0646\0643 \0623\0646\062A \0648\0633\0648\0627\0643 \0645\0646 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646 \062D\0641\0638 \062A\0642\0631\064A\0631 \0628\0648\0635\0641\0647 "\0639\0627\0645"\060C \0645\0645\0627 \064A\062C\0639\0644\0647 \0645\062A\0627\062D\064B\0627 \0644\0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0639\0644\0649 \0627\0644\0634\0628\0643\0629. \064A\0645\0643\0646\0643 \0643\0630\0644\0643 \062D\0641\0638 \062A\0642\0631\064A\0631 \0628\0648\0635\0641\0647 \062A\0642\0631\064A\0631\064B\0627 "\062E\0627\0635" \0644\0627 \064A\064F\0633\0645\062D \0644\0623\062D\062F \0633\0648\0627\0643 \0628\0627\0644\0627\0637\0644\0627\0639 \0639\0644\064A\0647.</p>'),
unistr('<p>\0627\062E\062A\0631 \0645\0646 \0628\064A\0646 \0627\0644\0623\0646\0648\0627\0639 \0627\0644\0645\062A\0627\062D\0629 \0648\0623\062F\062E\0644 \0627\0633\0645\064B\0627 \0644\0644\062A\0642\0631\064A\0631 \0627\0644\0645\062D\0641\0648\0638.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690333551398810)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\062A\0642\0631\064A\0631'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688581747398808)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0627\0633\062A\062E\062F\0645 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0641\064A \062A\0639\064A\064A\0646 \062A\0631\062A\064A\0628 \0627\0644\0623\0639\0645\062F\0629.</p>'),
'',
unistr('<p><strong>\0642\0627\0626\0645\0629 \0627\0644\0641\0631\0632</strong><br>'),
unistr('\064A\0639\0631\0636 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 "\0641\0631\0632" \0642\0627\0626\0645\0629 \0628\0642\0648\0627\0639\062F \0627\0644\0641\0631\0632 \0627\0644\0645\0643\0648\0646\0629.<br>'),
unistr('\0627\0646\0642\0631 \0639\0644\0649 "\0625\0636\0627\0641\0629" ( &plus; ) \0644\062A\0643\0648\064A\0646 \0639\0645\0648\062F \0641\0631\0632\060C \0623\0648 \0639\0644\0649 "\062D\0630\0641" ( &minus; ) \0644\0625\0632\0627\0644\0629 \0639\0645\0648\062F \0641\0631\0632.<br>'),
unistr('\0627\0646\0642\0631 \0639\0644\0649 "\0646\0642\0644 \0644\0623\0639\0644\0649" ( &uarr; ) \0648"\0646\0642\0644 \0644\0623\0633\0641\0644" ( &darr; ) \0644\0646\0642\0644 \0639\0645\0648\062F \0627\0644\0641\0631\0632 \0627\0644\0645\062D\062F\062F \0623\0639\0644\0649 \0623\0648 \0623\0633\0641\0644 \0623\0639\0645\062F\0629 \0627\0644\0641\0631\0632 \0627\0644\0623\062E\0631\0649.</p>'),
'',
unistr('<p><strong>\0625\0639\062F\0627\062F\0627\062A \0627\0644\0641\0631\0632</strong><br>'),
unistr('\062A\062D\062F\064A\062F \0639\0645\0648\062F \0627\0644\0641\0631\0632 \0648\0627\062A\062C\0627\0647 \0627\0644\0641\0631\0632 \0648\0643\064A\0641\064A\0629 \062A\0631\062A\064A\0628 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0641\0627\0631\063A\0629 (\0623\064A \0627\0644\0623\0639\0645\062F\0629 \063A\064A\0631 \0627\0644\0645\0634\062A\0645\0644\0629 \0639\0644\0649 \0642\064A\0645\0629).</p>'),
'',
unistr('<p><em>\0645\0644\0627\062D\0638\0629: \064A\0645\0643\0646 \0641\0631\0632 \0627\0644\0628\064A\0627\0646\0627\062A \062D\0633\0628 \0627\0644\0623\0639\0645\062F\0629 \063A\064A\0631 \0627\0644\0645\0639\0631\0648\0636\0629\061B \0639\0644\0645\064B\0627 \0628\0623\0646\0647 \0644\064A\0633\062A \062C\0645\064A\0639 \0627\0644\0623\0639\0645\062F\0629 \0642\0627\0628\0644\0629 \0644\0644\0641\0631\0632.</em><br>'),
unistr('<em>\064A\0645\0643\0646 \0641\0631\0632 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629 \0628\0627\0644\0636\063A\0637 \0639\0644\0649 \0633\0647\0645 \0644\0623\0639\0644\0649 (\062A\0635\0627\0639\062F\064A) \0623\0648 \0633\0647\0645 \0644\0623\0633\0641\0644 (\062A\0646\0627\0632\0644\064A) \0627\0644\0645\0648\062C\0648\062F\0629 \0641\064A \0646\0647\0627\064A\0629 \0639\0646\0627\0648\064A\0646 \0627\0644\0623\0639\0645\062F\0629. \0648\0644\0625\0636\0627\0641\0629 \0639\0645\0648\062F \062A\0627\0644\064D \0625\0644\0649 \0641\0631\0632 \0645\0648\062C\0648\062F\060C \064A\0644\0632\0645 \0627\0644\0636\063A\0637 \0628\0627\0633\062A\0645\0631\0627\0631 \0639\0644\0649 \0627\0644\0645\0641\062A\0627\062D Shift \0645\0639 \0627\0644\0646\0642\0631 \0639\0644\0649 \0633\0647\0645 \0644\0623\0639\0644\0649 \0623\0648 \0644\0623\0633\0641\0644.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690971480398810)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\0641\0631\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110690190723398809)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\0627\0634\062A\0631\0627\0643')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642429678398773)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062E\0641\0627\0621')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609254603398748)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645\064A\064A\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677267039398799)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\062A\0641\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678002681398800)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0641\0642\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635411238398767)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0627\0639\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640457712398771)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\064A\0642\0648\0646\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608177946398747)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\0623\064A\0642\0648\0646\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633651666398766)
,p_name=>'APEX.IG.IN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642053513398772)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F \063A\064A\0631 \0646\0634\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642121692398772)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F\0627\062A \063A\064A\0631 \0646\0634\0637\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649766914398778)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \062F\0627\062E\0644\064A \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0637\0644\0628 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545576686398700)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0645\0631\0634\062D \0627\0644\0639\0645\0648\062F "%0" \063A\064A\0631 \0645\062F\0639\0648\0645 \0644\0644\0639\0645\0648\062F "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689900026398809)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\064A\063A\0629 \062A\0627\0631\064A\062E \063A\064A\0631 \0635\0627\0644\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664174341398789)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \062A\062F\0639\0645 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \062A\0639\0631\064A\0641 \0645\0631\0634\062D \0641\064A \0627\0644\0639\0645\0648\062F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664088907398789)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0646\0648\0639 \0645\0639\0631\0641 \064A\0635\0644\062D \0644\0644\062A\0639\0631\064A\0641 \0641\064A \0634\0628\0643\0629 \062A\0641\0627\0639\0644\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550614737398703)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\064A\063A\0629 \0631\0642\0645 \063A\064A\0631 \0635\0627\0644\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692689562398811)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F \063A\064A\0631 \0635\0627\0644\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692794854398811)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F\0627\062A \063A\064A\0631 \0635\0627\0644\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683771692398804)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\0639\064A\064A\0646 \0627\0644\0641\0631\0632 \062D\0633\0628 \0639\0644\0649 %0\060C \0644\0643\0646 \0644\0645 \064A\062A\0645 \062A\062D\062F\064A\062F \0639\0645\0648\062F \0644\0640 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681065902398802)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645\0629 \063A\064A\0631 \0635\0627\0644\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676183534398798)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\0631\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634413519398767)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\064A \0622\062E\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634611890398767)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\064A \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633521290398766)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0641\0627\0631\063A\064B\0627')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633470724398766)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0627\0631\063A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684546090398805)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0633\0645\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676597491398799)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0633\0645\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680449618398802)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\062E\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623758705398759)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\064A\0648\0645 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623978246398759)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 \0633\0627\0639\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624453342398759)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062F\0642\064A\0642\0629 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623465211398758)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0631 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623549580398758)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0633\0628\0648\0639 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623615573398758)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 %0 \0645\0646 \0627\0644\0623\064A\0627\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623836370398759)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 %0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624566161398759)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624347635398759)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0634\0647\0648\0631 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624220916398759)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623268932398758)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 %0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623368206398758)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0646\0629 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684706031398805)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062D\0627\0630\0627\0629 \0627\0644\062E\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684899486398805)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\062E\062F\0627\0645 \0645\062C\0645\0648\0639\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634040813398766)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0642\0644 \0645\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634164660398766)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0642\0644 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678641456398800)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678790408398800)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\064A \0645\0639 \0645\0633\0627\062D\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685162125398805)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'ar'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677389191398799)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\062E\0641\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687721247398807)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0645 \0628\0641\0635\0644 \0627\0644\0639\0646\0627\0648\064A\0646 \0627\0644\0645\062A\0639\062F\062F\0629 \0628\0641\0627\0635\0644\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635275736398767)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0637\0627\0628\0642 \0627\0644\062A\0639\0628\064A\0631 \0627\0644\0639\0627\062F\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659639602398786)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\0642\0635\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695213442398813)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0627\0644\0625\062C\0645\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659867774398786)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0633\064A\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695322372398813)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0633\064A\0637 \0627\0644\0625\062C\0645\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659546566398786)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\062F\0646\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635362698398767)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0642\0627\0626\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660322409398786)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 \062F\0642\0627\0626\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695136577398813)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\062F\0646\0649 \0627\0644\0625\062C\0645\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635788022398768)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0647\0648\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642366783398773)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062A\0648\064A \0627\0644\0628\064A\0627\0646\0627\062A \0639\0644\0649 \0645\0627 \064A\0632\064A\062F \0639\0646 %0 \0645\0646 \0627\0644\0635\0641\0648\0641 \0648\0647\0630\0627 \064A\062A\062C\0627\0648\0632 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0627\0644\0645\0633\0645\0648\062D \0628\0647. \0627\0644\0631\062C\0627\0621 \062A\0637\0628\064A\0642 \0645\0631\0634\062D\0627\062A \0625\0636\0627\0641\064A\0629 \0644\0639\0631\0636 \0627\0644\0646\062A\0627\0626\062C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669074657398793)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0627\0644\0645\0639\0631\0641 \0627\0644\062B\0627\0628\062A \0644\0644\0645\0646\0637\0642\0629 \0644\0623\0646 \0627\0644\0635\0641\062D\0629 \062A\062D\062A\0648\064A \0639\0644\0649 \0639\062F\0629 \0634\0628\0643\0627\062A \062A\0641\0627\0639\0644\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638442379398770)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0633\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638611207398770)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0645\0633\0645\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622668407398758)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\064A\0648\0645 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622474065398758)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0639\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624614872398759)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062F\0642\064A\0642\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622975354398758)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0631 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622889355398758)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0633\0628\0648\0639 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622776649398758)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\064A\0627\0645 \0627\0644\0642\0627\062F\0645\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110622570566398758)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A \0627\0644\0642\0627\062F\0645\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624753809398759)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624070117398759)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\0634\0647\0631 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624176884398759)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623191115398758)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110623074655398758)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0646\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634382256398767)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633\062A \0628\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633362794398766)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0633\0627\0648\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699534463398816)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0646\0637\0642\0629 \0630\0627\062A \0627\0644\0645\0639\0631\0641 %0 \0644\064A\0633\062A \0645\0646\0637\0642\0629 \0634\0628\0643\0629 \062A\0641\0627\0639\0644\064A\0629 \0623\0648 \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0641\064A \0627\0644\062A\0637\0628\064A\0642 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633708605398766)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0641\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634553999398767)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0641\064A \0622\062E\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110634711986398767)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0641\064A \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642243436398773)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0628\064A\0627\0646\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680284621398802)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645 \062E\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685329878398806)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0642\0645\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680507945398802)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\064A\0642\0627\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680651654398802)
,p_name=>'APEX.IG.ON'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0634\063A\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632551269398765)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 \062F\0642\064A\0642\0629 \0648\0627\062D\062F\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688289270398808)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\062A\062D \0645\0646\062A\0642\064A \0627\0644\0623\0644\0648\0627\0646: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677093794398799)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\062A\062D')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639530783398770)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0627\0645\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676416900398799)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\062A\062C\0627\0647')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678853889398801)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0631\0635\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110640854964398771)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\062F\0648\0644 \0645\062D\0648\0631\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110608455649398747)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \062C\062F\0648\0644 \0645\062D\0648\0631\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110688134218398808)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0635\0644 \0627\0644\0642\064A\0645 \0628\0627\0633\062A\062E\062F\0627\0645 "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110678958633398801)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0637\0628\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684275323398805)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0646\062A\0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684391304398805)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0647\0627\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110684175043398805)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\062F\0627\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638727443398770)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0627\0633\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639085697398770)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0623\0633\0627\0633\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655520310398783)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0623\0633\0627\0633\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537701314398694)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0636\0645\064A\0646 \0639\0644\0627\0645\0627\062A \0625\0645\0643\0627\0646\064A\0629 \0627\0644\0648\0635\0648\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536465778398693)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0641\0642\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536551892398693)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0623\0633\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536320574398693)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062A\062C\0627\0647 \0627\0644\0635\0641\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536260233398693)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'ar'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536190031398693)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'ar'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537892028398694)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062E\0635\0635')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535956761398692)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'ar'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535855986398692)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'ar'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536003936398693)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'ar'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535723867398692)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062C\0645 \0627\0644\0635\0641\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525911842398684)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0635 \0627\0644\0645\0646\0633\0642 \0644\0644\0634\0631\064A\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679045635398801)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0627\0626\0631\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679177896398801)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0637\0627\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689453253398809)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\062F\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643034147398773)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\062F\064A\062F \0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641879564398772)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\062F\064A\062F \0627\0644\0635\0641\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647000286398776)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0637\0642\0629 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0641\064A \0627\0644\0635\0641\062D\0629 %1 \0648\0627\0644\0645\0646\0637\0642\0629 %2 \0636\0645\0646 \0627\0644\062A\0637\0628\064A\0642 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609903697398748)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638180625398769)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698719672398816)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0630\0641 \0627\0644\062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698450878398816)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0628\062F\064A\0644 \0644\0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698389427398816)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A \0644\0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698604413398816)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062E\0627\0635')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698539547398816)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0639\0627\0645 \0644\0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110647113525398776)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0627\0644\0645\062D\0641\0648\0638\0629 \0630\0627\062A \0627\0644\0627\0633\0645 %0 \063A\064A\0631 \0645\0648\062C\0648\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632407743398765)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0627\0646\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0645\0646\0630 %0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632398100398765)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0627\0646\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0645\0646\0630 \062F\0642\064A\0642\0629 \0648\0627\062D\062F\0629 \0645\0636\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572040485398719)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0642\0631\064A\0631 \0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \063A\064A\0631 \0645\0648\062C\0648\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691656399398811)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 - \062A\062D\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646995159398776)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0627\0644\0645\062D\0641\0648\0638\0629 \0630\0627\062A \0627\0644\0645\0639\0631\0641 %0 \063A\064A\0631 \0645\0648\062C\0648\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110691551974398810)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 - \062D\0641\0638 \0643\0640')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610098966398748)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0627\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699695050398816)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0628\0643\0629 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0627\0644\0645\062D\0641\0648\0638\0629 \0630\0627\062A \0627\0644\0645\0639\0631\0641 \0627\0644\062B\0627\0628\062A %0 \063A\064A\0631 \0645\0648\062C\0648\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694554730398813)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609172705398748)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643110431398773)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0631\0627\062C\0639 \0639\0646 \0627\0644\062A\063A\064A\064A\0631\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641925639398772)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0643\0633 \0627\0644\0635\0641\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639126805398770)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638032541398769)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0641\0648\0641 \0644\0643\0644 \0635\0641\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699237137398816)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062C\0631\0627\0621\0627\062A \0627\0644\0635\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700405935398817)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062C\0631\0627\0621\0627\062A \0627\0644\0635\0641 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110609480214398748)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652128381398780)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062D\0641\0638')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607613375398746)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\0645\062D\0641\0648\0638\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607772697398747)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0641\062A\0631\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582296190398727)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\062C\062F \062A\0637\0628\064A\0642 \0645\062D\0641\0648\0638 \0628\0627\0644\0627\0633\0645 %0 \0645\0648\062C\0648\062F \0628\0627\0644\0641\0639\0644. \0623\062F\062E\0644 \0627\0633\0645\064B\0627 \062C\062F\064A\062F\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607815605398747)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0627\0635')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607920359398747)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0627\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694268497398812)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638 \0628\0627\0633\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641259777398772)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638 \0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679234641398801)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0628\0639\062B\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607533613398746)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686503057398807)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\062D\062B: \0643\0644 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0646\0635\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607484055398746)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685747214398806)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\062D\062B: \0627\0644\0646\0635 \0627\0644\0643\0627\0645\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632275462398765)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B \0639\0646 ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675834963398798)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'ar'
,p_message_text=>unistr('- \062A\062D\062F\064A\062F -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616034083398753)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\062D\062F\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668750447398792)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062F \0635\0641\064B\0627 \0648\0627\062D\062F\064B\0627 \0641\064A \0627\0644\0645\0646\0637\0642\0629 \0627\0644\0631\0626\064A\0633\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607372068398746)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0623\0639\0645\062F\0629 \0644\0644\0628\062D\062B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698996464398816)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062C\0631\0627\0621\0627\062A \0627\0644\062A\062D\062F\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616296247398753)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\062E\0644\0627\064A\0627')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616136549398753)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\0635\0641\0648\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687115107398807)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644 \0643\0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679614189398801)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0644\0633\0644\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605319401398745)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657976073398784)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631 \0627\0644\0642\064A\0645\0629 \0627\0644\0625\062C\0645\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642729499398773)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0635\0641 \0648\0627\062D\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641037995398772)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679706991398801)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062D\0633\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699300541398816)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646\0643 \062A\0639\0631\064A\0641 \0641\0631\0632 \0648\0627\062D\062F \0641\0642\0637 \0644\0643\0644 \0639\0645\0648\062F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699155200398816)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0627\0644\062A\063A\064A\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110680766012398802)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0648\0645\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635098091398767)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0628\062F\0623 \0628\0640')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679387496398801)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\0648\0631\0635\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600359241398741)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645\062F\064A\062F \0639\0631\0636 \0627\0644\0639\0645\0648\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110641455672398772)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0634\062A\0631\0627\0643')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110659412644398786)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062C\0645\0648\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700697642398817)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0628\0643\0629 \062A\0641\0627\0639\0644\064A\0629. \0627\0644\062A\0642\0631\064A\0631: %0\060C \0637\0631\064A\0642\0629 \0627\0644\0639\0631\0636: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110694668269398813)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062C\0645\0648\0639 \0627\0644\0625\062C\0645\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677556218398799)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0647\062F\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683964055398804)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0648\0646 \0627\0644\0646\0635')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610178967398748)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0628\062F\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657813649398784)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0644\0645\064A\062D \0627\0644\0623\062F\0627\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110638204902398769)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0648\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110642619684398773)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\063A\0627\0621 \0627\0644\062A\062C\0645\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639703354398771)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\062D\062F\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686950714398807)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\062C\062F \062A\063A\064A\064A\0631\0627\062A \0644\0645 \064A\062A\0645 \062D\0641\0638\0647\0627. \0647\0644 \062A\0631\064A\062F \0627\0644\0645\062A\0627\0628\0639\0629\061F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110639618461398771)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676685390398799)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681561326398803)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0625\062F\062E\0627\0644 \0642\064A\0645\0629.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666451029398791)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645\0629 (\0644\0627 \064A\0645\0643\0646 \062A\063A\064A\064A\0631 \0627\0644\0645\0646\0637\0642\0629 \0627\0644\0632\0645\0646\064A\0629)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685456343398806)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0635')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677995912398800)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0623\0633\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637772293398769)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675917610398798)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0648\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110677486214398799)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062C\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635639065398767)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0627\0628\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676055458398798)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\062F\0646\0649 \0644\0639\0631\0636 \0627\0644\0639\0645\0648\062F (\0628\0627\0644\0628\0643\0633\0644)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626853819398761)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0628\064A\0646 %1 \0648%2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626584348398761)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \064A\062D\062A\0648\064A \0639\0644\0649 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626609128398761)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062D\062A\0648\064A %0 \0639\0644\0649 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604756066398744)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\0627 \064A\0628\062F\0623 \0628\0640 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625318378398760)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \064A\0633\0627\0648\064A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625569781398760)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0623\0643\0628\0631 \0645\0646 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625686091398760)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0623\0643\0628\0631 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626389439398761)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0641\064A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627534753398761)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\064A\0627\0645 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627390436398761)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0627\0639\0627\062A \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627166548398761)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\062F\0642\0627\0626\0642 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627944906398762)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0634\0647\0648\0631 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627750401398762)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628129103398762)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0646\0648\0627\062A \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627493846398761)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\064A\0648\0645 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627278793398761)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0633\0627\0639\0629 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627084056398761)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\062F\0642\064A\0642\0629 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627835838398762)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0634\0647\0631 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110627679093398762)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0623\0633\0628\0648\0639 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628040299398762)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0633\0646\0629 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629985016398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\064A\0627\0645 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629781132398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0627\0639\0627\062A \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629582772398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\062F\0642\0627\0626\0642 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630355152398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0634\0647\0648\0631 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630174313398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630517898398764)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0646\0648\0627\062A \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629805954398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\064A\0648\0645 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629628197398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0633\0627\0639\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629407787398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\062F\0642\064A\0642\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630236898398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0634\0647\0631 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630023989398763)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0623\0633\0628\0648\0639 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630493997398764)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \062E\0644\0627\0644 \0627\0644\0633\0646\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626097497398760)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0641\0627\0631\063A\064B\0627')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625903840398760)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0641\0627\0631\063A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625754800398760)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0623\0642\0644 \0645\0646 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625839961398760)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0623\0642\0644 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626127023398760)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\062B\0644 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626701802398761)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \064A\0637\0627\0628\0642 \0627\0644\062A\0639\0628\064A\0631 \0627\0644\0639\0627\062F\064A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632654736398765)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626924357398761)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0628\064A\0646 %1 \0648%2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625493294398760)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\0627 \064A\0633\0627\0648\064A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626433814398761)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0641\064A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628728902398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\064A\0627\0645 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628508005398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0627\0639\0627\062A \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628325051398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\062F\0642\0627\0626\0642 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629149747398763)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0634\0647\0648\0631 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628990125398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629342596398763)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0646\0648\0627\062A \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628650014398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\064A\0648\0645 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628422492398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0633\0627\0639\0629 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628211695398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\062F\0642\064A\0642\0629 \0627\0644\0645\0627\0636\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629032682398763)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0634\0647\0631 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110628842003398762)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0623\0633\0628\0648\0639 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110629233777398763)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0639\0627\0645 \0627\0644\0645\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631180739398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\064A\0627\0645 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630964431398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0627\0639\0627\062A \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630719109398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\062F\0642\0627\0626\0642 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631544120398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0634\0647\0648\0631 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631309712398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631714162398765)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 %1 \0645\0646 \0627\0644\0633\0646\0648\0627\062A \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631027047398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\064A\0648\0645 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630871532398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0633\0627\0639\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110630657687398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\062F\0642\064A\0642\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631464943398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0634\0647\0631 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631252236398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0623\0633\0628\0648\0639 \0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631678372398764)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \062E\0644\0627\0644 \0627\0644\0633\0646\0629 \0627\0644\062A\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110626234874398761)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0645\062B\0644 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633180824398766)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \064A\0628\062F\0623 \0628\0640 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676755960398799)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635866280398768)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0646\0648\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676836316398799)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676973485398799)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110685951285398806)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\062B\0646\064A\0646\060C 12 \064A\0646\0627\064A\0631 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686035636398806)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0646\0627\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686111351398806)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 16 \0633\0627\0639\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110686233723398806)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 16 \0633\0627\0639\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541263773398697)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0645\0644\0641 \063A\064A\0631 \0635\0627\0644\062D. \0623\0646\0648\0627\0639 \0627\0644\0645\0644\0641\0627\062A \0627\0644\0645\062F\0639\0648\0645\0629 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668197220398792)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\0639\0631\0627\0636')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667836483398792)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0645\0644\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667906468398792)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0645\0644\0641\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541009114398696)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\062D\0628 \0648\0625\0633\0642\0627\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541485067398697)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\062D\0628 \0627\0644\0645\0644\0641\0627\062A \0648\0625\0641\0644\0627\062A\0647\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542614299398698)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0645\0644\0641 \0623\0648 \0625\0633\0642\0627\0637 \0648\0627\062D\062F \0647\0646\0627.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542753540398698)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\0645\0644\0641\0627\062A \0623\0648 \0625\0633\0642\0627\0637\0647\0627 \0647\0646\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542822636398698)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0645\0644\0641 \0623\0648 \0625\0633\0642\0627\0637 \0648\0627\062D\062F \0647\0646\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542958494398698)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\0645\0644\0641\0627\062A \0623\0648 \0625\0633\0642\0627\0637\0647\0627 \0647\0646\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541366941398697)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0645\0644\0641\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541128167398697)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0644\0641 \0643\0628\064A\0631 \0644\0644\063A\0627\064A\0629. \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\062D\062C\0645 \0627\0644\0645\0644\0641 \0647\0648 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528925508398687)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0648\0627\0646 \0645\0637\0644\0648\0628.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527873559398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062F\064A\0646\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528298869398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0645\0632 \0627\0644\062F\0648\0644\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527909329398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0642\0645 \0627\0644\0645\0646\0632\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528843851398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0627\0626\0631\0629 \0627\0644\0639\0631\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528798153398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637 \0627\0644\0637\0648\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528689797398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631 \0639\0644\0649 \0627\0644\062E\0631\064A\0637\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528300117398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062C\0645\0648\0639 \0627\0644\0646\0642\0627\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528059662398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0645\0632 \0627\0644\0628\0631\064A\062F\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528135202398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0644\0627\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527788905398686)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0627\0631\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527603955398685)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\062A\0627\0626\062C \0627\0644\062A\0631\0645\064A\0632 \0627\0644\062C\063A\0631\0627\0641\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540256558398696)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0633\062A\062E\062F\0645 \0627\0644\0631\0645\0648\0632 \0627\0644\062C\063A\0631\0627\0641\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540329385398696)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0633\062A\062E\062F\0645 \0627\0644\0631\0645\0648\0632 \0627\0644\062C\063A\0631\0627\0641\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528554404398686)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0631\064A\0637\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110528425242398686)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0639\0646\0627\0648\064A\0646.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529027210398687)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0637\0644\0648\0628.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698836119398816)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0635 \0627\0644\062A\0639\0644\064A\0645\0627\062A: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592204245398735)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062D\062F\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592363323398735)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0645\062D\062F\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538233456398694)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \0644\064A\0633 \0641\064A \0646\0637\0627\0642 \0635\0627\0644\062D \0645\0646 %0 \0625\0644\0649 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538321317398694)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \0644\064A\0633 \0645\0636\0627\0639\0641 \0627\0644\0631\0642\0645 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537969915398694)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 #LABEL# \0645\0637\0627\0628\0642\064B\0627 \0644\0644\0642\064A\0645\062A\064A\0646 %0 \0648%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538148106398694)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616440855398753)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\064A\0642\0627\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616590023398753)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0634\063A\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538047163398694)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0639\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521423029398680)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629 \0625\062F\062E\0627\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650689091398779)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650763132398779)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521561762398680)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0625\062F\062E\0627\0644\0627\062A \0627\0644\0645\062D\062F\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654488777398782)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062A\0642\062F\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654772856398782)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\063A\0627\0621')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654566933398782)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0627\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654891008398782)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\064A\0627\0631\0627\062A \0627\0644\0646\0645\0648\0630\062C \0627\0644\0645\0628\0627\0634\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655402821398783)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\064A\0627\0631\0627\062A \0627\0644\0642\0627\0644\0628 \063A\064A\0631 \0645\062A\0648\0641\0631\0629 \0644\0623\0646 \0647\0630\0627 \0627\0644\0645\0643\0648\0646 \063A\064A\0631 \0645\0639\0631\0648\0636 \0641\064A \0627\0644\0635\0641\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654392244398782)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \062E\064A\0627\0631\0627\062A \0642\0627\0644\0628.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654696128398782)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529946593398687)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062D \062F\0627\0626\0631\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531731733398689)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0646\0645\0627\0637 \0627\0644\0645\062E\0635\0635\0629 \063A\064A\0631 \0635\0627\0644\062D\0629 \0641\064A JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530220547398688)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\062F\0627\0629 \0627\0644\0645\0633\0627\0641\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530008034398687)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0633\0645 \062F\0627\0626\0631\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522609196398681)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\062D\062B \0645\062A\0639\062F\062F \0627\0644\062C\0648\0627\0646\0628 \064A\062A\0637\0644\0628 \0645\0635\062F\0631 \0628\064A\0627\0646\0627\062A \0639\0644\0649 \0645\0633\062A\0648\0649 \0627\0644\0645\0646\0637\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525257060398683)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0648\0642\0639 \0627\0644\062D\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526320659398684)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062D\062F\0627\062B\064A\0627\062A \0627\0644\0645\0648\0636\0639 \0627\0644\0645\0628\062F\0626\064A \063A\064A\0631 \0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523777425398682)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0627\0644\0645\0648\0636\0639 \0627\0644\0645\0628\062F\0626\064A \0646\0642\0637\0629 \0641\064A \0634\0643\0644 \0647\0646\062F\0633\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526108612398684)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524750136398683)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0637\0628\0642\0629')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658006792398785)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0637\0628\0642\0629: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529378043398687)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0631\064A\0637\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522559440398681)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0633\0627\0626\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526202684398684)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0645\064A\0627\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657024199398784)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062A\0648\064A \0627\0644\0628\064A\0627\0646\0627\062A \0639\0644\0649 \0645\0627 \064A\0632\064A\062F \0639\0646 %0 \0645\0646 \0627\0644\0635\0641\0648\0641 \0648\0647\0630\0627 \064A\062A\062C\0627\0648\0632 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0627\0644\0645\0633\0645\0648\062D \0628\0647.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524590918398683)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\0627\0644\0628\0646\0648\062F</a> \0648\0628\064A\0627\0646\0627\062A \0627\0644\062E\0631\064A\0637\0629 &copy; 2017 \0647\0646\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523414218398682)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A SDO_GEOMETRY \063A\064A\0631 \0645\062A\0627\062D \0641\064A \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0647\0630\0647.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524639773398683)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; \0645\0633\0627\0647\0645\0648 OpenStreetMap </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524884153398683)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0642\0627\0637')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658105005398785)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0646\0642\0627\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530136563398688)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0643\0628\064A\0631/\062A\0635\063A\064A\0631 \0627\0644\0645\0633\062A\0637\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529813691398687)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525185426398683)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0627\0644\0645\062D\0645\0644 \0625\0644\0649 \0627\0644\0634\0645\0627\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605456390398745)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0628\062F\064A\0644 \0625\0644\0649 \0648\0636\0639 \062B\0646\0627\0626\064A \0627\0644\0623\0628\0639\0627\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605509162398745)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0628\062F\064A\0644 \0625\0644\0649 \0648\0636\0639 \062B\0644\0627\062B\064A \0627\0644\0623\0628\0639\0627\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529752602398687)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0634\0639\0627\0631 \062D\0642\0648\0642 \0627\0644\0646\0634\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530365365398688)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0633\0627\0641\0629 \0627\0644\0625\062C\0645\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524970945398683)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0643\0628\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525028515398683)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0635\063A\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652598648398780)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\064A\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653472098398781)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0648\0631\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653012532398781)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0645\0632 \0627\0644\0645\0636\0645\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666644073398791)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062F\0631\0627\062C \0635\0648\0631\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666735705398791)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062F\0631\0627\062C \0627\0631\062A\0628\0627\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652691920398780)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0627\0626\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667353152398791)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0631\062A\0628\0627\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653352586398781)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653216793398781)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0645\0631\062A\0628\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652750530398780)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0627\064A\0646\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652859857398781)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0648\062C\062F \0645\0627 \064A\0645\0643\0646 \0645\0639\0627\064A\0646\062A\0647')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652998122398781)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\0648\0633\0637\0647 \062E\0637')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653137097398781)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \063A\064A\0631 \0645\0631\062A\0628\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632055561398765)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110689542832398809)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0632\064A\062F...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110631976147398765)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0627\0631\064D \0627\0644\062A\062D\0645\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663798649398789)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0633\0627\0644\0629 \0627\0644\0625\0634\0639\0627\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637088024398769)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 #LABEL# \0631\0642\0645\064B\0627 \0623\0642\0644 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637123656398769)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 #LABEL# \0631\0642\0645\064B\0627 \0635\0627\0644\062D\064B\0627.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637215829398769)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'ar'
,p_message_text=>unistr('#LABEL# \063A\064A\0631 \0645\0637\0627\0628\0642 \0644\062A\0646\0633\064A\0642 \0627\0644\0631\0642\0645 %0 (\0645\062B\0627\0644: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636938143398768)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 #LABEL# \0631\0642\0645\064B\0627 \0623\0643\0628\0631 \0645\0646 \0623\0648 \064A\0633\0627\0648\064A %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636811055398768)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 #LABEL# \0631\0642\0645\064B\0627 \0628\064A\0646 %0 \0648%1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632134924398765)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\062A\062D \0641\064A \0646\0627\0641\0630\0629 \062C\062F\064A\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585398186398730)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\0642\062F\064A\0645 \0647\0630\0647 \0627\0644\0635\0641\062D\0629 \0628\0627\0644\0641\0639\0644 \0648\0644\0627 \064A\0645\0643\0646 \0625\0639\0627\062F\0629 \062A\0642\062F\064A\0645\0647\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567905206398716)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641\062D\0629 "%1" \0636\0645\0646 \0627\0644\062A\0637\0628\064A\0642 "%0" \063A\064A\0631 \0645\0648\062C\0648\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601796882398742)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\0648\062C\062F \0642\064A\0645\0629 \0644\0640 #LABEL#.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545010176398699)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651076673398779)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\063A\0644\0627\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650961868398779)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B \0639\0646 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651285495398779)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651138292398779)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537127804398693)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\062F\062E\0644 \0645\0635\0637\0644\062D \0628\062D\062B \064A\062A\0643\0648\0646 \0645\0646 %0 \0645\0646 \0627\0644\062D\0631\0648\0641 \0639\0644\0649 \0627\0644\0623\0642\0644.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606607682398746)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645 \0627\0644\0645\0646\0628\062B\0642\0629: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537204055398693)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\062F\062E\0644 \0645\0635\0637\0644\062D \0628\062D\062B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537050380398693)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0646\062A\0627\0626\062C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536934164398693)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624869005398759)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0635\0637\0644\062D \0627\0644\0628\062D\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650807412398779)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661571568398787)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0627\0631\064D \0627\0644\0645\0639\0627\0644\062C\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535521762398692)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629 \0625\0644\0649 \0627\0644\0634\0627\0634\0629 \0627\0644\0631\0626\064A\0633\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531580816398689)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0644\0627 \064A\0628\062F\0648 \0623\0646 \062C\0647\0627\0632\0643 \0623\0648 \0645\0633\062A\0639\0631\0636\0643 \064A\062F\0639\0645 \062A\062B\0628\064A\062A \062A\0637\0628\064A\0642\0627\062A \0627\0644\0648\064A\0628 \0627\0644\062A\0642\062F\0645\064A\0629 \062D\0627\0644\064A\064B\0627.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0641\064A \062D\0627\0644\0629 \0643\0627\0646 \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642 \0645\062B\0628\062A\064B\0627 \0628\0627\0644\0641\0639\0644 \0639\0644\0649 \062C\0647\0627\0632\0643\060C \0627\0641\062A\062D\0647 \0645\0646 \0634\0627\0634\062A\0643 \0627\0644\0631\0626\064A\0633\064A\0629.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531199263398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642. \0623\0636\0641\0647 \0625\0644\0649 \0634\0627\0634\062A\0643 \0627\0644\0631\0626\064A\0633\064A\0629 \0644\0627\0633\062A\062E\062F\0627\0645\0647 \0641\064A \0648\0636\0639 \0627\0644\0634\0627\0634\0629 \0627\0644\0643\0627\0645\0644\0629.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1- \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0627\0644\0642\0627\0626\0645\0629</strong> \0641\064A \0623\0633\0641\0644 \0627\0644\062A\0646\0642\0644</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2- \0627\0646\0642\0631 \0639\0644\0649 <strong>\062A\062B\0628\064A\062A</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3- \0627\0646\0642\0631 \0639\0644\0649 <strong>\0625\0636\0627\0641\0629</strong> \0644\0644\062A\0623\0643\064A\062F</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531268059398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642 \0645\0646 \0627\0644\0623\0641\0636\0644 \062A\062C\0631\0628\062A\0647\0627 \0639\0644\0649 Chrome \0623\0648 Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1- \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0627\0644\0642\0627\0626\0645\0629</strong> \0628\062C\0627\0646\0628 \0634\0631\064A\0637 \0627\0644\0639\0646\0648\0627\0646</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2- \0627\0646\0642\0631 \0639\0644\0649 <strong>\062A\062B\0628\064A\062A</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530815372398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642 \0645\0646 \0627\0644\0623\0641\0636\0644 \062A\062C\0631\0628\062A\0647 \0641\064A Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1- \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0645\0634\0627\0631\0643\0629</strong> \0641\064A \0623\0633\0641\0644 \0627\0644\062A\0646\0642\0644</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2- \0627\0646\0642\0631 \0639\0644\0649 <strong>\0641\062A\062D \0641\064A Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530580295398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642. \0623\0636\0641\0647 \0625\0644\0649 \0634\0627\0634\062A\0643 \0627\0644\0631\0626\064A\0633\064A\0629 \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0623\0641\0636\0644 \062A\062C\0631\0628\0629.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1- \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0645\0634\0627\0631\0643\0629</strong> \0628\062C\0627\0646\0628 \0634\0631\064A\0637 \0627\0644\0639\0646\0648\0627\0646</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2- \0627\0646\0642\0631 \0639\0644\0649 <strong>\0625\0636\0627\0641\0629 \0625\0644\0649 \0627\0644\0634\0627\0634\0629 \0627\0644\0631\0626\064A\0633\064A\0629</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3- \0627\0646\0642\0631 \0639\0644\0649 <strong style="color:#007AE1;">\0625\0636\0627\0641\0629</strong> \0644\0644\062A\0623\0643\064A\062F</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530434848398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642. \0623\0636\0641\0647 \0625\0644\0649 \0634\0627\0634\062A\0643 \0627\0644\0631\0626\064A\0633\064A\0629 \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0623\0641\0636\0644 \062A\062C\0631\0628\0629.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1- \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0645\0634\0627\0631\0643\0629</strong> \0641\064A \0623\0633\0641\0644 \0627\0644\062A\0646\0642\0644</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2- \0645\0631\0631 \0644\0623\0633\0641\0644 \0648\0627\0646\0642\0631 \0639\0644\0649 <strong>\0625\0636\0627\0641\0629 \0625\0644\0649 \0627\0644\0634\0627\0634\0629 \0627\0644\0631\0626\064A\0633\064A\0629</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3- \0627\0646\0642\0631 \0639\0644\0649 <strong style="color:#007AE1;">\0625\0636\0627\0641\0629</strong> \0644\0644\062A\0623\0643\064A\062F</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525460495398684)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642. \0623\0636\0641\0647 \0625\0644\0649 \0634\0627\0634\062A\0643 \0627\0644\0631\0626\064A\0633\064A\0629 \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0623\0641\0636\0644 \062A\062C\0631\0628\0629.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1- \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0645\0632\064A\062F</strong> \0628\062C\0627\0646\0628 \0634\0631\064A\0637 \0627\0644\0639\0646\0648\0627\0646</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2- \0627\0646\0642\0631 \0639\0644\0649 <strong>\0625\0636\0627\0641\0629 \0625\0644\0649 \0627\0644\0634\0627\0634\0629 \0627\0644\0631\0626\064A\0633\064A\0629</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3- \0627\0646\0642\0631 \0639\0644\0649 <strong style="color:#007AE1;">\0625\0636\0627\0641\0629</strong> \0644\0644\062A\0623\0643\064A\062F</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530795897398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642. \0623\0636\0641\0647 \0625\0644\0649 \0634\0627\0634\062A\0643 \0627\0644\0631\0626\064A\0633\064A\0629 \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0623\0641\0636\0644 \062A\062C\0631\0628\0629.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0645\0634\0627\0631\0643\0629</strong> \0628\062C\0627\0646\0628 \0634\0631\064A\0637 \0627\0644\0639\0646\0648\0627\0646</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0627\0646\0642\0631 \0639\0644\0649 <strong>\0641\062A\062D \0641\064A Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530625181398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642. \0623\0636\0641\0647 \0625\0644\0649 \0634\0627\0634\062A\0643 \0627\0644\0631\0626\064A\0633\064A\0629 \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0623\0641\0636\0644 \062A\062C\0631\0628\0629.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 <strong>\0645\0634\0627\0631\0643\0629</strong> \0641\064A \0623\0633\0641\0644 \0627\0644\062A\0646\0642\0644</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0627\0646\0642\0631 \0639\0644\0649 <strong>\0641\062A\062D \0641\064A Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531411170398689)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642 \0645\0646 \0627\0644\0623\0641\0636\0644 \062A\062C\0631\0628\062A\0647\0627 \0639\0644\0649 Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0644\0627 \064A\062F\0639\0645 Firefox \062D\0627\0644\064A\064B\0627 \062A\062B\0628\064A\062A \062A\0637\0628\064A\0642\0627\062A \0627\0644\0648\064A\0628.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110530925902398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642 \0645\0646 \0627\0644\0623\0641\0636\0644 \062A\062C\0631\0628\062A\0647\0627 \0639\0644\0649 Chrome \0623\0648 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0644\0627 \064A\062F\0639\0645 Firefox \062D\0627\0644\064A\064B\0627 \062A\062B\0628\064A\062A \062A\0637\0628\064A\0642\0627\062A \0627\0644\0648\064A\0628 \0639\0644\0649 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531022456398688)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642 \0645\0646 \0627\0644\0623\0641\0636\0644 \062A\062C\0631\0628\062A\0647\0627 \0641\064A Chrome \0623\0648 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0644\0627 \064A\062F\0639\0645 Safari \062D\0627\0644\064A\064B\0627 \062A\062B\0628\064A\062A \062A\0637\0628\064A\0642\0627\062A \0627\0644\0648\064A\0628 \0639\0644\0649 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531399885398689)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0647\0630\0627 \0627\0644\0645\0648\0642\0639 \0644\0647 \0648\0638\064A\0641\0629 \062A\0637\0628\064A\0642 \0645\0646 \0627\0644\0623\0641\0636\0644 \062A\062C\0631\0628\062A\0647\0627 \0639\0644\0649 Chrome \0623\0648 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0644\0627 \064A\062F\0639\0645 Firefox \062D\0627\0644\064A\064B\0627 \062A\062B\0628\064A\062A \062A\0637\0628\064A\0642\0627\062A \0627\0644\0648\064A\0628 \0639\0644\0649 Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533816226398691)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\062A\0639\0630\0631 \0627\0644\0627\062A\0635\0627\0644</h1>'),
unistr('    <p>\062A\062D\062A\0627\062C \0625\0644\0649 \0627\0644\0627\062A\0635\0627\0644 \0628\0627\0644\0625\0646\062A\0631\0646\062A \0644\0627\0633\062A\062E\062F\0627\0645 \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642.</p>'),
unistr('    <button type="button">\0625\0639\0627\062F\0629 \0627\0644\0645\062D\0627\0648\0644\0629</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533765555398690)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0627\0644\0627\062A\0635\0627\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673521612398796)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617987010398754)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0648\0627\0644 \0627\0644\064A\0648\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696887769398814)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644 \062F\0639\0648\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696682920398814)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\064A\0627\0631\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619726689398756)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \064A\0648\0645\064A\0629 \0644\0643\0644 \0627\0644\064A\0648\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619544937398755)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \064A\0648\0645\064A\0629 \0644\0644\0628\064A\0627\0646\0627\062A \0645\0639 \0627\0644\0648\0642\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664450095398789)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658880768398785)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549453527398703)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'ar'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549275742398702)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'ar'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549101399398702)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'ar'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549313475398702)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'ar'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548879496398702)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0627\0631\064A\062E \0627\0644\0646\0647\0627\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549072320398702)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\062D\062F\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696723832398814)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0639\0648\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664523699398789)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664228613398789)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667028356398791)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681341179398802)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \062A\0648\062C\062F \0623\062D\062F\0627\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697065650398815)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \062D\062F\062B \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696925038398814)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644 \062F\0639\0648\0629 \0628\0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667101995398791)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675160328398798)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644 \0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674960463398797)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644 \0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697750089398815)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0645\064A\0639 \0627\0644\062D\0642\0648\0644 \0645\0637\0644\0648\0628\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697680526398815)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644 \062F\0639\0648\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696513476398814)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0648\0636\0648\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675047765398798)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548960209398702)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0627\0631\064A\062E \0627\0644\0628\062F\0627\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672892981398796)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0645\0648\0630\062C \0641\064A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619360764398755)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0642\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667279882398791)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\064A\0648\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665071519398790)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664399833398789)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0628\0648\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619686320398755)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0623\0633\0628\0648\0639\064A\0629 \0644\0643\0644 \0627\0644\064A\0648\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619403313398755)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0623\0633\0628\0648\0639\064A\0629 \0644\0644\0628\064A\0627\0646\0627\062A \0645\0639 \0627\0644\0648\0642\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664936614398790)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0646\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664647075398789)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0639\0645\062F\0629...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664719426398789)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0645\064A\0644 \0627\0644\0645\0632\064A\062F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596885601398738)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0644\062E\0644\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543116677398698)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0645\064A\0644 \0627\0644\0645\0632\064A\062F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545298741398699)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110664870562398790)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0645\064A\0644 \0627\0644\0645\0632\064A\062F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666995115398791)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0641 \0627\0644\0645\0646\0637\0642\0629 %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545135989398699)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0628\064A\0627\0646\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569231878398717)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062A\0639\0630\0631 \0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0641\0635\0644 \0635\0641\062D\0627\062A \0627\0644\0645\0646\0637\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537460313398694)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0625\0639\062F\0627\062F \0641\0635\0644 \0635\0641\062D\0627\062A \0627\0644\0645\0646\0637\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658285171398785)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0639\0645\062F\0629...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666839302398791)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0645\0646\0637\0642\0629 %0 \063A\064A\0631 \0645\062F\0639\0648\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537357934398694)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0639\0631\0636 \0627\0644\0645\0646\0637\0642\0629 "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601846758398742)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\0648\062C\062F \0642\064A\0645\0629 \0644\0640 #COLUMN_HEADER#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696128082398814)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('%0\061C\060C \0645\062D\0631\0631 \0646\0635 \0645\0646\0633\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603977082398744)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\062C\0627\0648\0632 \062A\0631\0645\064A\0632 HTML \0644\0644\0646\0635 \0627\0644\0645\0646\0633\0642 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0637\0648\0644 \0627\0644\0639\0646\0635\0631 (\0627\0644\0623\062D\0631\0641 \0627\0644\0641\0639\0644\064A\0629 %0\060C \0627\0644\0645\0633\0645\0648\062D \0628\0647\0627 %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663807946398789)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655664377398783)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0643\0631\0627\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653977257398781)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653837832398781)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\062B\0646\0627\0621 \0627\0644\0642\064A\0645 \0627\0644\062E\0627\0644\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663930165398789)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617543531398754)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644 \0644\0623\0633\0641\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617695042398754)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644 \0644\0623\0639\0644\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653658835398781)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654224224398782)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0623\062E\0631\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653771707398781)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654097849398781)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654154394398782)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 %0 \0645\0646 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655778120398783)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\062F\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655884679398783)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0631\0627\062C\0639 \0639\0646 \0627\0644\062A\063A\064A\064A\0631\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110653522845398781)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0627\0644\0625\0639\062F\0627\062F\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614558772398752)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522025657398681)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644 \0645\0631\0629 \0623\062E\0631\0649')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521934583398681)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\062A \062C\0644\0633\062A\0643')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522191184398681)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645\062F\064A\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521700698398680)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\062A\0646\062A\0647\064A \062C\0644\0633\062A\0643 \062E\0644\0627\0644 %0. \0647\0644 \062A\0631\064A\062F \062A\0645\062F\064A\062F\0647\0627\061F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521875788398681)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\062A\0646\062A\0647\064A \062C\0644\0633\062A\0643 \0641\064A %0 \0648\0644\0627 \064A\0645\0643\0646 \062A\0645\062F\064A\062F\0647\0627. \0627\0644\0631\062C\0627\0621 \062D\0641\0638 \0623\064A \0639\0645\0644 \0627\0644\0622\0646 \0644\062A\062C\0646\0628 \0641\0642\062F\0627\0646 \0623\064A \0628\064A\0627\0646\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674700859398797)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0631\0645\0632 \062A\0646\0638\064A\0641 \062C\0644\0633\0629 \0639\0645\0644 \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567852540398716)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0631\0645\0632 \0625\0639\062F\0627\062F \062C\0644\0633\0629 \0627\0644\0639\0645\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110541988082398697)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\062A \062C\0644\0633\062A\0643')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673625133398796)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0625\063A\0644\0627\0642 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 \0647\0630\0627 \0648\0627\0644\0636\063A\0637 \0639\0644\0649 \0632\0631 \0625\0639\0627\062F\0629 \0627\0644\062A\062D\0645\064A\0644 \0641\064A \0627\0644\0645\062A\0635\0641\062D \0644\0628\062F\0621 \062C\0644\0633\0629 \0639\0645\0644 \062C\062F\064A\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692968821398812)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\0642\0631 <a href="%0">\0647\0646\0627</a> \0644\062A\0643\0648\064A\0646 \062C\0644\0633\0629 \0639\0645\0644 \062C\062F\064A\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579519476398725)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062C\0644\0633\0629 \063A\064A\0631 \0635\0627\0644\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619069299398755)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \062A\0645\0643\064A\0646 \0623\064A\0629 \0623\062F\0648\0627\0631 \062F\064A\0646\0627\0645\064A\0643\064A\0629 \0641\064A \062C\0644\0633\0629 \0639\0645\0644 Real Application Security \0644\0644\0645\0633\062A\062E\062F\0645 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565742039398715)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-99900 \062A\0639\0630\0631 \062A\0643\0648\064A\0646 \0645\0639\0631\0641 \062C\0644\0633\0629 \0627\0644\0639\0645\0644 \0627\0644\0641\0631\064A\062F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582090036398727)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \0627\0646\062A\0647\0627\0643 \0644\062D\0645\0627\064A\0629 \062C\0644\0633\0629 \0627\0644\0639\0645\0644: \0642\062F \064A\0643\0648\0646 \0647\0630\0627 \0628\0633\0628\0628 \062A\0639\062F\064A\0644 \064A\062F\0648\064A \0644\0639\0646\0635\0631 \0635\0641\062D \0645\062D\0645\064A %0. \0641\0625\0646 \0644\0645 \062A\0643\0646 \0639\0644\0649 \062F\0631\0627\064A\0629 \0628\0633\0628\0628 \062D\062F\0648\062B \0647\0630\0627 \0627\0644\062E\0637\0623\060C \0641\0627\0644\0631\062C\0627\0621 \0627\0644\0627\062A\0635\0627\0644 \0628\0645\0633\0626\0648\0644 \0627\0644\062A\0637\0628\064A\0642 \0637\0644\0628\064B\0627 \0644\0644\0645\0633\0627\0639\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701191322398818)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\0627\0643 \062D\0645\0627\064A\0629 \0627\0644\0635\0641\062D\0629: \0642\062F \064A\0643\0648\0646 \0627\0644\0633\0628\0628 \0641\064A \0647\0630\0627 \062A\0642\062F\064A\0645 \0635\0641\062D\0629 \0644\0645 \064A\062A\0645 \0627\0644\0627\0646\062A\0647\0627\0621 \0645\0646 \062A\062D\0645\064A\0644\0647\0627 \0623\0648 \0625\062C\0631\0627\0621 \062A\0639\062F\064A\0644 \064A\062F\0648\064A \0639\0644\0649 \0639\0646\0627\0635\0631 \0645\062D\0645\064A\0629 \0641\064A \0627\0644\0635\0641\062D\0629. \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0645\0632\064A\062F \0645\0646 \0627\0644\0645\0633\0627\0639\062F\0629\060C \0627\0644\0631\062C\0627\0621 \0627\0644\0627\062A\0635\0627\0644 \0628\0645\0633\0626\0648\0644 \0627\0644\062A\0637\0628\064A\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700158115398817)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0634\062A\0645\0644 %0 \0639\0644\0649 \0623\062D\062F \0627\0644\0623\062D\0631\0641 \063A\064A\0631 \0627\0644\0635\0627\0644\062D\0629 \0627\0644\062A\0627\0644\064A\0629 & \0623\0648 < \0623\0648 > \0623\0648 " \0623\0648 / \0623\0648 ; \0623\0648 , \0623\0648 * \0623\0648 | \0623\0648 = \0623\0648 % \0623\0648 --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700212294398817)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0634\062A\0645\0644 %0 \0639\0644\0649 \0623\062D\062F \0627\0644\0623\062D\0631\0641 \063A\064A\0631 \0627\0644\0635\0627\0644\062D\0629 \0627\0644\062A\0627\0644\064A\0629 & \0623\0648 <\0623\0648 >\0623\0648 "\0623\0648 /\0623\0648 ;\0623\0648 ,\0623\0648 *\0623\0648 |\0623\0648 =\0623\0648 % \0623\0648 -- \0623\0648 \0633\0637\0631 \062C\062F\064A\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699971602398817)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0634\062A\0645\0644 %0 \0639\0644\0649 \0623\062D\0631\0641 \062E\0627\0635\0629. \0648\0644\0643\0646 \0644\0627 \064A\064F\0633\0645\062D \0633\0648\0649 \0628\0627\0644\0623\062D\0631\0641 a-Z \06480-9 \0648\0627\0644\0645\0633\0627\0641\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110700045641398817)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0634\062A\0645\0644 %0 \0639\0644\0649 < \0623\0648 > \0623\0648 " \0648\0647\064A \0623\062D\0631\0641 \063A\064A\0631 \0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544177565398699)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0625\062F\062E\0627\0644 \0645\062C\0645\0648\0639 \0627\062E\062A\0628\0627\0631\064A \0644\0625\0638\0647\0627\0631 \0645\0639\0627\0644\062C\0629 \0635\0641\062D\0629 \062A\062A\0637\0644\0628 \0645\062C\0645\0648\0639\064B\0627 \0627\062E\062A\0628\0627\0631\064A\064B\0627 \0641\064A \062D\0627\0644\0629 \0648\062C\0648\062F \0637\0644\0628 \0623\0648 \0623\0643\062B\0631\060C \0623\0648 \0645\0633\062D \0627\0644\0630\0627\0643\0631\0629 \0627\0644\0645\062E\0628\0626\064A\0629\060C \0623\0648 \062A\0645\0631\064A\0631 \0642\064A\0645 \0627\0644\0648\0633\0627\0626\0637 \0643\0645\0639\0644\0645\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576992687398723)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \0627\0646\062A\0647\0627\0643 \0644\062D\0645\0627\064A\0629 \062C\0644\0633\0629 \0627\0644\0639\0645\0644: \0642\062F \064A\0643\0648\0646 \0647\0630\0627 \0628\0633\0628\0628 \062A\0639\062F\064A\0644 \064A\062F\0648\064A \0644\0639\0646\0648\0627\0646 URL \064A\0634\062A\0645\0644 \0639\0644\0649 \0645\062C\0645\0648\0639 \0627\062E\062A\0628\0627\0631\064A \0623\0648 \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0631\062A\0628\0627\0637 \064A\0634\062A\0645\0644 \0639\0644\0649 \0645\062C\0645\0648\0639 \0627\062E\062A\0628\0627\0631\064A \063A\064A\0631 \0635\062D\064A\062D \0623\0648 \063A\064A\0631 \0645\0648\062C\0648\062F. \0641\0625\0646 \0644\0645 \062A\0643\0646 \0639\0644\0649 \062F\0631\0627\064A\0629 \0628\0633\0628\0628 \062D\062F\0648\062B \0647\0630\0627 \0627\0644\062E\0637\0623\060C \0641\0627\0644\0631\062C\0627\0621 \0627\0644\0627\062A\0635\0627\0644 \0628\0645\0633\0626\0648\0644 \0627\0644\062A\0637\0628\064A\0642 \0637\0644\0628\064B\0627 \0644\0644\0645\0633\0627\0639\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110654943909398782)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\064A\064A\0646 \0648\0636\0639 \0627\0644\062A\0628\0627\064A\0646 \0627\0644\0639\0627\0644\064A \0625\0644\0649 \0625\064A\0642\0627\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655037541398782)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\064A\064A\0646 \0648\0636\0639 \0627\0644\062A\0628\0627\064A\0646 \0627\0644\0639\0627\0644\064A \0625\0644\0649 \062A\0634\063A\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573697352398721)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0641\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573860911398721)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0623\0633\0641\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573968686398721)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574003296398721)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644 \0627\0644\0643\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574142338398721)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574271508398721)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\0643\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574328757398721)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573534683398721)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0639\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573745692398721)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0623\0639\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682615612398803)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'ar'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683361147398804)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 %0 \0645\0646 \0627\0644\0623\064A\0627\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682513482398803)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'ar'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683421975398804)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 %0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682383705398803)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'ar'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683504193398804)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 %0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682958138398804)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0634\0647\0648\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683131162398804)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 %0 \0645\0646 \0627\0644\0634\0647\0648\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682412758398803)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'ar'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683213153398804)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 %0 \0645\0646 \0627\0644\062B\0648\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682740907398804)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'ar'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683614364398804)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 %0 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682819528398804)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'ar'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110683085910398804)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0644\0627\0644 %0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522954433398681)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'ar'
,p_message_text=>unistr('[\062E\0637]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523317164398682)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'ar'
,p_message_text=>unistr('[\062E\0637\0648\0637 \0645\062A\0639\062F\062F\0629]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523162814398682)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'ar'
,p_message_text=>unistr('[\0646\0642\0627\0637 \0645\062A\0639\062F\062F\0629]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523583599398682)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'ar'
,p_message_text=>unistr('[\0645\0636\0644\0639\0627\062A \0645\062A\0639\062F\062F\0629]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523678810398682)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'ar'
,p_message_text=>unistr('[\0643\0627\0626\0646 \0647\0646\062F\0633\064A]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522814075398681)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'ar'
,p_message_text=>unistr('[\0627\0644\0646\0642\0637\0629 (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523075385398682)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'ar'
,p_message_text=>unistr('[\0645\0636\0644\0639]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600219986398741)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600127029398741)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\0639\0627\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646686250398776)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062D \0627\0644\062A\0642\064A\064A\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636543695398768)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0641\064A \0646\0637\0627\0642 \062A\0642\064A\064A\0645 \0635\0627\0644\062D \0645\0646 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636645665398768)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \063A\064A\0631 \0631\0642\0645\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632733457398765)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0633\0627\0644\0629 \0646\062C\0627\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695827748398814)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695728803398814)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681492484398803)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0631\064A\0637 \0627\0644\0623\062F\0648\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696261815398814)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\0633\064A\0639 / \0637\064A \0645\0646\0637\0642\0629 \0627\0633\062A\0643\0634\0627\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696389598398814)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\0633\064A\0639 / \0637\064A \0639\0645\0648\062F \062C\0627\0646\0628\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605962653398745)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0632\0621 \0627\0644\0627\0633\062A\0643\0634\0627\0641 \0627\0644\0631\0626\064A\0633\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612967808398750)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\0645 \0648\0627\062D\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612767005398750)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0627\0639\0629 \0648\0627\062D\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613035232398751)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\064A\0627\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612864516398750)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612616168398750)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613253792398751)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110613188290398751)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0628\0648\0639 \0648\0627\062D\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699441537398816)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062F\0627\064A\0629 \0627\0644\0635\0641\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561424024398712)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0645\0643\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535241683398692)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0627\0644\0637\0644\0628.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614652769398752)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645\0629 \0645\0637\0644\0648\0628\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697593067398815)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0627\0644\0627\0646\062A\0638\0627\0631 \062D\062A\0649 \064A\062A\0645 \062A\062D\0645\064A\0644 \0627\0644\0635\0641\062D\0629 \0628\0634\0643\0644 \0643\0627\0645\0644\060C \062B\0645 \0625\0639\0627\062F\0629 \0627\0644\0645\062D\0627\0648\0644\0629.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657700885398784)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\062C\062F \062A\063A\064A\064A\0631\0627\062A \063A\064A\0631 \0645\062D\0641\0648\0638\0629 \0641\064A \0647\0630\0647 \0627\0644\0635\0641\062D\0629.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538671792398695)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0634\062A\0645\0644 \0627\0644\0645\0635\0646\0641 \0639\0644\0649 \0648\0631\0642\0629 \0646\0634\0637\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538553373398695)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \062A\062A\0645 \062A\0647\064A\0626\0629 \0627\0644\0645\0635\0646\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538435743398694)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \062F\0627\062E\0644\064A \0623\062B\0646\0627\0621 \062A\0643\0648\064A\0646 \0645\0644\0641 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540954736398696)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0631\0642\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672699613398796)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0625\062C\0631\0627\0621\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590158813398733)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0627\0644\0625\062C\0631\0627\0621\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585887919398730)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629 \062F\0627\0644\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585765643398730)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629 \0639\0645\0648\062F \062A\062C\0645\064A\0639 \062D\0633\0628')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619901565398756)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629 \0639\0645\0648\062F \062C\062F\0648\0644 \0645\062D\0648\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620000264398756)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0636\0627\0641\0629 \0639\0645\0648\062F \0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560270862398711)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596300480398738)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\062C\0645\064A\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577406984398724)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062A\0648\0633\0637')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581727969398727)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\062F\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577562499398724)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\0642\0635\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577752011398724)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0633\064A\0637')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577638187398724)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\062F\0646\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577392569398723)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062C\0645\0648\0639 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578400844398724)
,p_name=>'APEXIR_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0643\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559556759398710)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0627\0641\0629 \0627\0644\0623\0639\0645\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542084072398697)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0644 \0627\0644\0635\0641\0648\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669666640398793)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\062F\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671277280398795)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0628\062F\064A\0644: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572110824398720)
,p_name=>'APEXIR_AND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561661918398712)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0637\0628\064A\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555313764398707)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0635\0627\0639\062F\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574932932398722)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0639\062A\0628\0627\0631\064B\0627 \0645\0646 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671883440398795)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062A\0648\0633\0637 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663237794398788)
,p_name=>'APEXIR_BAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0631\064A\0637\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561024350398711)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554143959398706)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0648\0646 \0627\0644\062E\0644\0641\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556019575398708)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0632\0631\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587759466398731)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0641\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556615849398708)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\063A\0627\0621')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562584450398713)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0641\0626\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554042821398706)
,p_name=>'APEXIR_CELL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062E\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578378001398724)
,p_name=>'APEXIR_CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588636079398732)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0627\0631\064D \0627\0644\0628\062F\0621...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110624940387398759)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \062A\0633\0645\064A\0629 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637376950398769)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\062C\0627\0648\0632 \0627\0633\062A\0639\0644\0627\0645\0643 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0646\0642\0627\0637 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0628\0627\0644\063A %0 \0644\0643\0644 \0631\0633\0645 \0628\064A\0627\0646\064A. \0627\0644\0631\062C\0627\0621 \062A\0637\0628\064A\0642 \0645\0631\0634\062D \0644\062A\0642\0644\064A\0644 \0639\062F\062F \0627\0644\062A\0633\062C\064A\0644\0627\062A \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A \0627\0644\062E\0627\0635 \0628\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636289227398768)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0642\0644\0644 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0639\062F\062F \0627\0644\0635\0641\0648\0641 \0641\064A \0627\0633\062A\0639\0644\0627\0645 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0645\0646 \0639\062F\062F \0627\0644\0635\0641\0648\0641 \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A\060C \0648\0644\064A\0633 \0645\0646 \0639\062F\062F \0627\0644\0635\0641\0648\0641 \0627\0644\0645\0639\0631\0648\0636\0629. \064A\062A\062C\0627\0648\0632 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0631\0626\064A\0633\064A \0644\062F\064A\0643 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0639\062F\062F \0627\0644\0635\0641\0648\0641 %0. \0627\0644\0631\062C\0627\0621 \062A\0637\0628\064A\0642 \0645\0631\0634\062D \0644\062A\0642\0644\064A\0644 \0639\062F\062F \0627\0644\0633\062C\0644\0627\062A \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A \0627\0644\062E\0627\0635 \0628\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559609918398710)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110632969505398765)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\0643\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575326899398722)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0635\064A\063A\0629 \0627\0644\062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582719037398728)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556535059398708)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593944708398736)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0639\0645\062F\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666260616398791)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\0634\062D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584787657398729)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588481116398732)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0644\0648\0645\0627\062A \0627\0644\0623\0639\0645\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668533164398792)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0633\0645\064A\0629 \0627\0644\0639\0645\0648\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586116292398730)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570215847398718)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571189066398719)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062D\062A\0648\064A \0639\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555031689398707)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571358379398719)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0641\064A \0622\062E\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579847918398725)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0641\064A \0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571279746398719)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\064A \0622\062E\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579707210398725)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\064A \0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554951911398707)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \062E\0627\0644\064A\064B\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554875339398707)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0627\0644\064D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554694942398706)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062B\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555101245398707)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0641\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554728512398707)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0645\062B\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570555567398718)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0637\0627\0628\0642 \0627\0644\062A\0639\0628\064A\0631 \0627\0644\0639\0627\062F\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575229076398722)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\062D\062A\0633\0627\0628')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110635980586398768)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0628\064A\0631 \062D\0633\0627\0628\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594225934398736)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0643\0648\064A\0646 \0627\062D\062A\0633\0627\0628 \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0623\0633\0645\0627\0621 \0627\0644\0645\0633\062A\0639\0627\0631\0629 \0644\0644\0623\0639\0645\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594386922398736)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'ar'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594457058398736)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'ar'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594584904398736)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'ar'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540419315398696)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'ar'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579125372398725)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0633\0627\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586762176398731)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0648\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589765591398733)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0648\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674131830398797)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0639\0645\062F\0629 \0641\0648\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537533817398694)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\062F \0627\0644\0645\0645\064A\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672353650398795)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\062F \0627\0644\0645\0645\064A\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672232178398795)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\062F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644362040398774)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\0645\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699089983398816)
,p_name=>'APEXIR_DATA'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\064A\0627\0646\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588552004398732)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0627\0646\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0645\0646\0630 %0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662014723398787)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0634\0628\0643\0629 \0627\0644\0628\064A\0627\0646\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560333994398711)
,p_name=>'APEXIR_DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0631\064A\062E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592431259398735)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0641\062A\0631\0627\0636\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669422755398793)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556748103398708)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560600234398711)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0647\0644 \062A\0631\064A\062F \062D\0630\0641 \0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0647\0630\0647\061F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655316212398782)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586410894398730)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641 \0627\0644\062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555405758398707)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0646\0627\0632\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562682456398713)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584605171398729)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0635\0641 \0648\0627\062D\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592912818398735)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\062A\062C\0627\0647 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593815506398736)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0637\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556234062398708)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0648\0636')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559470094398710)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592842038398735)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0641\064A \0627\0644\062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587640145398731)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0623\0633\0641\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579213226398725)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0646\0632\064A\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592700337398735)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\0645 \0627\0644\0639\0631\0636')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658716226398785)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\062C\062F \062A\0645\064A\064A\0632 \0628\0627\0644\0634\0631\0637 \0630\0627\062A\0647 \0628\0627\0644\0641\0639\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674388924398797)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\0648\0631\064A \0645\0643\0631\0631. \064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\0648\0631\064A \0641\0631\064A\062F\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674522367398797)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588725654398732)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0625\0639\062F\0627\062F\0627\062A \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595311021398737)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595762631398737)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0645\0631\0634\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650102308398778)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0627\0644\0645\062C\0645\0648\0639\0629 \062D\0633\0628')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595603606398737)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0627\0644\062A\0645\064A\064A\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620207607398756)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631 \0627\0644\062C\062F\0648\0644 \0627\0644\0645\062D\0648\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669792440398793)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548487383398702)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670081953398794)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\062E\0629 \0645\062E\0641\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670226403398794)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0635')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669909857398793)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\062E\0629 \0625\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670767102398794)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\062F\0644 \0627\0644\062A\0643\0631\0627\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552151742398705)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0643\0648\064A\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A \0644\0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642. \0627\0644\0631\062C\0627\0621 \0627\0644\0627\062A\0635\0627\0644 \0628\0627\0644\0645\0633\0624\0648\0644 \0644\062F\064A\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643605823398774)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670333801398794)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0637\0644\0627\0639 \0639\0644\0649 \0627\0644\0645\0631\0641\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670123866398794)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0648\0636\0648\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644610116398774)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0645\0648\0636\0648\0639 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669812938398793)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553879976398706)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0645\0643\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595576932398737)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645\0643\064A\0646/\062A\0639\0637\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595040562398737)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594648203398737)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0645\062B\0644\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595486410398737)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0645\062B\0644\0629:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559342931398710)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\062B\0646\0627\0621 \0627\0644\0642\064A\0645 \0627\0644\062E\0627\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596016844398738)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\0633\064A\0639/\0637\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593623883398736)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0628\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578716827398725)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0631\0634\064A\062D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589680529398733)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0631\0634\062D\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599966550398741)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0628\064A\0631 \0627\0644\0645\0631\0634\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696477686398814)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0628\064A\0631 \0627\0644\0645\0631\0634\062D \0637\0648\064A\0644 \0644\0644\063A\0627\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599811426398740)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0645\0631\0634\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596246094398738)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0623\0639\0645\062F\0629 \0644\0644\0628\062D\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579071759398725)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0627\0631\064A\062E\064A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593468997398736)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\064A\062D \0644\0643 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0639\0646 \0628\064A\0627\0646\0627\062A \062A\0627\0631\064A\062E\064A\0629 \0639\0631\0636 \0627\0644\0628\064A\0627\0646\0627\062A \0643\0645\0627 \0643\0627\0646\062A \0645\0648\062C\0648\062F\0629 \0633\0627\0628\0642\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644019081398774)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0627\0631\064A\062E\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645421349398775)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\064A\063A\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575179284398722)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0646\0627\0639 \0627\0644\0635\064A\063A\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586387493398730)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062F\0627\0644\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594175307398736)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062F\0648\0627\0644 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669339334398793)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062F\0648\0627\0644/\0627\0644\0639\0648\0627\0645\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586011886398730)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062F\0627\0644\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578513617398724)
,p_name=>'APEXIR_GO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0642\0627\0644 \0625\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554373717398706)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\062E\0636\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110537666874398694)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\0639 \062D\0633\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670442145398794)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062C\0645\064A\0639 \062D\0633\0628 \0627\0644\0639\0645\0648\062F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625020637398760)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0639\0645\0648\062F \062A\062C\0645\064A\0639 \062D\0633\0628.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636151718398768)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0642\0644\0644 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0639\062F\062F \0627\0644\0635\0641\0648\0641 \0641\064A \0627\0633\062A\0639\0644\0627\0645 \062A\062C\0645\064A\0639 \062D\0633\0628 \0645\0646 \0639\062F\062F \0627\0644\0635\0641\0648\0641 \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A\060C \0648\0644\064A\0633 \0645\0646 \0639\062F\062F \0627\0644\0635\0641\0648\0641 \0627\0644\0645\0639\0631\0648\0636\0629. \064A\062A\062C\0627\0648\0632 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0631\0626\064A\0633\064A \0644\062F\064A\0643 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0639\062F\062F \0627\0644\0635\0641\0648\0641 %0. \0627\0644\0631\062C\0627\0621 \062A\0637\0628\064A\0642 \0645\0631\0634\062D \0644\062A\0642\0644\064A\0644 \0639\062F\062F \0627\0644\0633\062C\0644\0627\062A \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A \0627\0644\062E\0627\0635 \0628\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616704428398753)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0632\0631 \062A\062C\0645\064A\0639 \062D\0633\0628')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674201952398797)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0631\062A\064A\0628 \0641\0631\0632 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559741993398710)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0623\0641\0642\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591384168398734)
,p_name=>'APEXIR_HELP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0644\064A\0645\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583141365398728)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062A\062A\064A\062D \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \062A\062E\0635\064A\0635 \0627\0644\062A\0642\0627\0631\064A\0631. \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \062A\0639\062F\064A\0644 \0627\0644\0625\0637\0627\0631 \0627\0644\0639\0627\0645 \0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0639\0628\0631 \062A\062D\062F\064A\062F \0627\0644\0623\0639\0645\062F\0629 \0648\062A\0637\0628\064A\0642 \0627\0644\0645\0631\0634\062D\0627\062A \0648\0627\0644\062A\0645\064A\064A\0632 \0648\0627\0644\0641\0631\0632. \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0643\0630\0644\0643 \062A\062D\062F\064A\062F \0641\0648\0627\0635\0644 \0648\062A\062C\0645\064A\0639\0627\062A \0648\0631\0633\0648\0645 \0628\064A\0627\0646\064A\0629 \0648\0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628 \0648\0625\0636\0627\0641\0629 \0627\0644\0639\0645\0644\064A\0627\062A \0627\0644\062D\0633\0627\0628\064A\0629 \0627\0644\062E\0627')
||unistr('\0635\0629 \0628\0647\0645. \0643\0645\0627 \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0625\0639\062F\0627\062F \0627\0634\062A\0631\0627\0643 \0644\064A\062A\0645 \0625\0631\0633\0627\0644 \0646\0633\062E\0629 HTML \0645\0646 \0627\0644\062A\0642\0631\064A\0631 \0625\0644\064A\0647\0645 \0641\064A \0641\062A\0631\0627\062A \0645\062D\062F\062F\0629. \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \062A\0643\0648\064A\0646 \0639\062F\0629 \0645\062A\063A\064A\0631\0627\062A \0645\0646 \062A\0642\0631\064A\0631 \0648\062D\0641\0638\0647\0627 \0643\062A\0642\0627\0631\064A\0631 \0645\0639\064A\0646\0629 \0644\0639\0631\0636\0647\0627 \0628\0634\0643\0644 \0639\0627\0645 \0623\0648 \062E\0627\0635. '),
'<p/>',
unistr('\062A\0644\062E\0635 \0627\0644\0623\0642\0633\0627\0645 \0627\0644\062A\0627\0644\064A\0629 \0627\0644\0637\0631\0642 \0627\0644\062A\064A \064A\0645\0643\0646\0643 \0628\0647\0627 \062A\062E\0635\064A\0635 \062A\0642\0631\064A\0631 \062A\0641\0627\0639\0644\064A. \0644\0645\0639\0631\0641\0629 \0627\0644\0645\0632\064A\062F\060C \0627\0637\0644\0639 \0639\0644\0649 "\0627\0633\062A\062E\062F\0627\0645 \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A\0629" \0641\064A <i>\062F\0644\064A\0644 \0645\0633\062A\062E\062F\0645 Oracle Application Express</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590243617398733)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0638\0647\0631 \0642\0627\0626\0645\0629 \0627\0644\0625\062C\0631\0627\0621\0627\062A \0639\0644\0649 \064A\0645\064A\0646 \0632\0631 "\0627\0646\062A\0642\0627\0644" \0641\064A \0634\0631\064A\0637 \0627\0644\0628\062D\062B. \0627\0633\062A\062E\062F\0645 \0647\0630\0647 \0627\0644\0642\0627\0626\0645\0629 \0644\062A\062E\0635\064A\0635 \062A\0642\0631\064A\0631 \062A\0641\0627\0639\0644\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583942754398729)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0627\0644\062A\062C\0645\064A\0639\0627\062A \0647\064A \0639\0645\0644\064A\0627\062A \062D\0633\0627\0628\064A\0629 \0631\064A\0627\0636\064A\0629 \062A\062A\0645 \0639\0644\0649 \0639\0645\0648\062F. \062A\0638\0647\0631 \0627\0644\062A\062C\0645\064A\0639\0627\062A \0628\0639\062F \0643\0644 \0641\0627\0635\0644 \0639\0646\0627\0635\0631 \062A\062D\0643\0645 \0648\0641\064A \0646\0647\0627\064A\0629 \0627\0644\062A\0642\0631\064A\0631 \0641\064A \0627\0644\0639\0645\0648\062F \062D\064A\062B \062A\0645 \062A\0639\0631\064A\0641\0647\0627. \062A\062A\0636\0645\0646 \0627\0644\062E\064A\0627\0631\0627\062A:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\0627\0644\062A\062C\0645\064A\0639</strong> \064A\062A\064A\062D \062A\062D\062F\064A\062F \062A\062C\0645\064A\0639 \0645\0639\0631\0641 \0645\0633\0628\0642\064B\0627'),
unistr('\0644\062A\062D\0631\064A\0631\0647.</li>'),
unistr('<li><strong>\0627\0644\062F\0627\0644\0629</strong> \0647\064A \0627\0644\062F\0627\0644\0629 \0627\0644\0645\0637\0644\0648\0628 \062A\0646\0641\064A\0630\0647\0627 (\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C SUM\060C MIN).</li>'),
unistr('<li><strong>\0627\0644\0639\0645\0648\062F</strong> \064A\064F\0633\062A\062E\062F\0645 \0644\062A\062D\062F\064A\062F \0627\0644\0639\0645\0648\062F \0627\0644\0630\064A \064A\062A\0645 \062A\0637\0628\064A\0642 \0627\0644\062F\0627\0644\0629 \0627\0644\0631\064A\0627\0636\064A\0629 \0639\0644\064A\0647. \064A\062A\0645 \0639\0631\0636 \0627\0644\0623\0639\0645\062F\0629'),
unistr('\0627\0644\0631\0642\0645\064A\0629 \0641\0642\0637.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584066170398729)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\064A\0645\0643\0646\0643 \062A\0639\0631\064A\0641 \0631\0633\0645 \0628\064A\0627\0646\064A \0648\0627\062D\062F \0644\0643\0644 \062A\0642\0631\064A\0631 \0645\062D\0641\0648\0638. \0628\0645\062C\0631\062F'),
unistr('\062A\0639\0631\064A\0641\0647\060C \064A\0645\0643\0646\0643 \0627\0644\062A\0628\062F\064A\0644 \0628\064A\0646 \0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0648\0627\0644\062A\0642\0631\064A\0631 \0628\0627\0633\062A\062E\062F\0627\0645 \0623\064A\0642\0648\0646\0627\062A \0637\0631\0642 \0627\0644\0639\0631\0636 \0641\064A \0634\0631\064A\0637 \0627\0644\0628\062D\062B.'),
unistr('\062A\062A\0636\0645\0646 \0627\0644\062E\064A\0627\0631\0627\062A:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>\0646\0648\0639 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A</strong> \064A\062D\062F\062F \0646\0648\0639 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\0645\0637\0644\0648\0628 \062A\0636\0645\064A\0646\0647.'),
unistr('\0648\064A\0645\0643\0646 \0627\0644\0627\062E\062A\064A\0627\0631 \0645\0646 \0628\064A\0646 \0634\0631\064A\0637\064A \0623\0641\0642\064A \0623\0648 \0634\0631\064A\0637\064A \0631\0623\0633\064A \0623\0648 \062F\0627\0626\0631\064A \0623\0648 \062E\0637\064A.</li>'),
unistr('<li><strong>\0627\0644\062A\0633\0645\064A\0629</strong> \062A\062A\064A\062D \0644\0643 \062A\062D\062F\064A\062F \0627\0644\0639\0645\0648\062F \0627\0644\0630\064A \0633\064A\062A\0645 \0627\0633\062A\062E\062F\0627\0645\0647 \0643\062A\0633\0645\064A\0629.</li>'),
unistr('<li><strong>\0639\0646\0648\0627\0646 \0627\0644\0645\062D\0648\0631 \0644\0644\062A\0633\0645\064A\0629</strong> \0627\0644\0639\0646\0648\0627\0646 \0627\0644\0645\0639\0631\0648\0636 \0639\0644\0649 \0627\0644\0645\062D\0648\0631 \0627\0644\0645\0631\062A\0628\0637 \0628\0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\062F\062F \0644\0644\062A\0633\0645\064A\0629.'),
unistr('\0644\0627 \064A\062A\0648\0641\0631 \0647\0630\0627 \0644\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\062F\0627\0626\0631\064A.</li>'),
unistr('<li><strong>\0627\0644\0642\064A\0645\0629</strong> \062A\062A\064A\062D \0644\0643 \062A\062D\062F\064A\062F \0627\0644\0639\0645\0648\062F \0627\0644\0630\064A \0633\064A\062A\0645 \0627\0633\062A\062E\062F\0627\0645\0647 \0643\0642\064A\0645\0629.  \0625\0630\0627 \0643\0627\0646\062A \0627\0644\062F\0627\0644\0629 \0627\0644\0645\064F\0633\062A\062E\062F\0645\0629 COUNT\060C \0641\0644\0633\062A \0628\062D\0627\062C\0629 \0644\062A\062D\062F\064A\062F \0642\064A\0645\0629.</li>'),
unistr('<li><strong>\0639\0646\0648\0627\0646 \0627\0644\0645\062D\0648\0631 \0644\0644\0642\064A\0645\0629</strong> \0627\0644\0639\0646\0648\0627\0646 \0627\0644\0645\0639\0631\0648\0636 \0639\0644\0649 \0627\0644\0645\062D\0648\0631 \0627\0644\0645\0631\062A\0628\0637 \0628\0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\062F\062F \0644\0644\0642\064A\0645\0629.'),
unistr('\0644\0627 \064A\062A\0648\0641\0631 \0647\0630\0627 \0644\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0627\0644\062F\0627\0626\0631\064A.</li>'),
unistr('<li><strong>\0627\0644\062F\0627\0644\0629</strong> \062F\0627\0644\0629 \0627\062E\062A\064A\0627\0631\064A\0629 \064A\062A\0645 \062A\0637\0628\064A\0642\0647\0627 \0639\0644\0649 \0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\062F\062F \0644\0644\0642\064A\0645\0629.</li>'),
unistr('<li><strong>\0627\0644\0641\0631\0632</strong> \0641\0631\0632 \0645\062C\0645\0648\0639\0629 \0627\0644\0646\062A\0627\0626\062C \0627\0644\062E\0627\0635\0629 \0628\0643.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583313162398728)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\064A\0624\062F\064A \0627\0644\0646\0642\0631 \0639\0644\0649 \0623\064A \0639\0646\0648\0627\0646 \0639\0645\0648\062F \0625\0644\0649 \0639\0631\0636 \0642\0627\0626\0645\0629 \0639\0646\0648\0627\0646 \0639\0645\0648\062F. \0648\062A\062A\0636\0645\0646 \0627\0644\062E\064A\0627\0631\0627\062A:'),
'<p></p>',
'<ul>',
unistr('<li>\0623\064A\0642\0648\0646\0629 <strong>\0641\0631\0632 \062A\0635\0627\0639\062F\064A</strong> \0641\0631\0632 \0627\0644\062A\0642\0631\064A\0631 \062D\0633\0628 \0627\0644\0639\0645\0648\062F \0628\062A\0631\062A\064A\0628 \062A\0635\0627\0639\062F\064A.</li>'),
unistr('<li>\0623\064A\0642\0648\0646\0629 <strong>\0641\0631\0632 \062A\0646\0627\0632\0644\064A</strong> \0641\0631\0632 \0627\0644\062A\0642\0631\064A\0631 \062D\0633\0628 \0627\0644\0639\0645\0648\062F \0628\062A\0631\062A\064A\0628 \062A\0646\0627\0632\0644\064A.</li>'),
unistr('<li><strong>\0625\062E\0641\0627\0621 \0627\0644\0639\0645\0648\062F</strong> \0625\062E\0641\0627\0621 \0627\0644\0639\0645\0648\062F. \0644\0627 \064A\0645\0643\0646 \0625\062E\0641\0627\0621 \0643\0644 \0627\0644\0623\0639\0645\062F\0629. \0625\0630\0627 \0644\0645 \064A\0643\0646 \0645\0646 \0627\0644\0645\0645\0643\0646 \0625\062E\0641\0627\0621 \0627\0644\0639\0645\0648\062F\060C \0641\0644\0646 \062A\0638\0647\0631 \0623\064A\0642\0648\0646\0629 \0625\062E\0641\0627\0621 \0627\0644\0639\0645\0648\062F.</li>'),
unistr('<li><strong>\062A\0642\0633\064A\0645 \0627\0644\0639\0645\0648\062F</strong> \062A\0643\0648\064A\0646 \0645\062C\0645\0648\0639\0629 \0645\0642\0633\0645\0629 \0641\064A \0627\0644\0639\0645\0648\062F. \064A\0624\062F\064A \0647\0630\0627 \0625\0644\0649 \0633\062D\0628 \0627\0644\0639\0645\0648\062F \0645\0646 \0627\0644\062A\0642\0631\064A\0631 \0643\0633\062C\0644 \0631\0626\064A\0633\064A.</li>'),
unistr('<li><strong>\0645\0639\0644\0648\0645\0627\062A \0627\0644\0639\0645\0648\062F</strong> \0639\0631\0636 \0646\0635 \062A\0639\0644\064A\0645\0627\062A \0627\0644\0639\0645\0648\062F\060C \0625\0646 \0648\062C\062F.</li>'),
unistr('<li><strong>\0645\0646\0637\0642\0629 \0627\0644\0646\0635</strong> \0645\0633\062A\062E\062F\0645\0629 \0644\0625\062F\062E\0627\0644 \0645\0639\0627\064A\064A\0631 \0627\0644\0628\062D\062B \0627\0644\062D\0633\0627\0633\0629 \0644\062D\0627\0644\0629 \0627\0644\0623\062D\0631\0641'),
unistr('(\0644\0627 \062D\0627\062C\0629 \0644\0623\062D\0631\0641 \0627\0644\0628\062F\0644). \064A\0642\0644\0644 \0625\062F\062E\0627\0644 \0642\064A\0645\0629 \0645\0646 \0642\0627\0626\0645\0629'),
unistr('\0627\0644\0642\064A\0645 \0623\0633\0641\0644 \0627\0644\0642\0627\0626\0645\0629. \062B\0645 \064A\0645\0643\0646\0643 \062A\062D\062F\064A\062F \0642\064A\0645\0629 \0645\0646'),
unistr('\0627\0644\0623\0633\0641\0644 \0648\0633\064A\062A\0645 \062A\0643\0648\064A\0646 \0627\0644\0642\064A\0645\0629 \0627\0644\0645\062D\062F\062F\0629 \0643\0645\0631\0634\062D \0628\0627\0633\062A\062E\062F\0627\0645 ''='''),
unistr('(\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644 <code>column = ''ABC''</code>). \0628\062F\0644\0627\064B \0645\0646 \0630\0644\0643\060C \064A\0645\0643\0646\0643 \0627\0644\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 \0627\0644\0628\062D\062B \0648\0625\062F\062E\0627\0644 \0642\064A\0645\0629 \0644\064A\062A\0645 \062A\0643\0648\064A\0646\0647\0627 \0643\0645\0631\0634\062D \0628\0627\0633\062A\062E\062F\0627\0645 \062A\0639\062F\064A\0644\0627\062A ''LIKE'''),
unistr('(\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>\0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645 \0627\0644\0641\0631\064A\062F\0629</b> \062A\062D\062A\0648\064A \0639\0644\0649 \0623\0648\0644 500 \0642\064A\0645\0629 \0641\0631\064A\062F\0629 \062A\0644\0628\064A \0645\0639\0627\064A\064A\0631 \0627\0644\0645\0631\0634\062D \0627\0644\062E\0627\0635\0629 \0628\0643. \0625\0630\0627 \0643\0627\0646 \0627\0644\0639\0645\0648\062F \062A\0627\0631\064A\062E\064B\0627\060C \0641\0633\062A\0638\0647\0631'),
unistr('\0642\0627\0626\0645\0629 \0646\0637\0627\0642\0627\062A \0627\0644\062A\0648\0627\0631\064A\062E \0628\062F\0644\0627\064B \0645\0646 \0630\0644\0643. \0648\0625\0630\0627 \062D\062F\062F\062A \0642\064A\0645\0629\060C \0641\0633\064A\062A\0645'),
unistr('\062A\0643\0648\064A\0646 \0645\0631\0634\062D \0628\0627\0633\062A\062E\062F\0627\0645 ''='' (\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583801058398728)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\064A\062A\064A\062D \0644\0643 \0625\0636\0627\0641\0629 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\062D\0633\0648\0628\0629 \0625\0644\0649 \062A\0642\0631\064A\0631\0643. \064A\0645\0643\0646 \0623\0646 \062A\0643\0648\0646 \0639\0645\0644\064A\0627\062A \062D\0633\0627\0628\064A\0629 \0631\064A\0627\0636\064A\0629 (\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C <code>NBR_HOURS/24</code>) \0623\0648 \062F\0648\0627\0644 Oracle'),
unistr('\0627\0644\0642\064A\0627\0633\064A\0629 \0645\0637\0628\0642\0629 \0639\0644\0649 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\062D\0627\0644\064A\0629. \062A\0638\0647\0631 \0628\0639\0636\0647\0627 \0643\0623\0645\062B\0644\0629 \0648\0627\0644\0623\062E\0631\0649 (\0645\062B\0644 <code>TO_DATE)</code> \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645\0647\0627 \0643\0630\0644\0643). \062A\062A\0636\0645\0646 \0627\0644\062E\064A\0627\0631\0627\062A:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\0627\0644\0627\062D\062A\0633\0627\0628</strong> \064A\062A\064A\062D \0644\0643 \062A\062D\062F\064A\062F \0639\0645\0644\064A\0629 \0627\062D\062A\0633\0627\0628 \0645\0639\0631\0641\0629 \0633\0627\0628\0642\064B\0627 \0644\062A\062D\0631\064A\0631\0647\0627.</li>'),
unistr('<li><strong>\0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F</strong> \0647\0648 \0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F \0627\0644\062C\062F\064A\062F.</li>'),
unistr('<li><strong>\0642\0646\0627\0639 \0627\0644\0635\064A\063A\0629</strong> \0647\0648 \0642\0646\0627\0639 \0635\064A\063A\0629 \0645\0646 Oracle \064A\062A\0645 \062A\0637\0628\064A\0642\0647 \0639\0644\0649 \0627\0644\0639\0645\0648\062F (\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C S9999).</li>'),
unistr('<li><strong>\0627\0644\0627\062D\062A\0633\0627\0628</strong> \0647\0648 \0627\0644\0627\062D\062A\0633\0627\0628 \0627\0644\0645\0637\0644\0648\0628 \062A\0646\0641\064A\0630\0647. \0641\064A \0627\0644\0627\062D\062A\0633\0627\0628\060C \062A\062A\0645 \0627\0644\0625\0634\0627\0631\0629 \0625\0644\0649 \0627\0644\0623\0639\0645\062F\0629 \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0623\0633\0645\0627\0621 \0627\0644\0645\0633\062A\0639\0627\0631\0629 \0627\0644\0645\0639\0631\0648\0636\0629.</li>'),
'</ul>',
unistr('<p>\0623\0633\0641\0644 \0627\0644\0627\062D\062A\0633\0627\0628\060C \062A\0638\0647\0631 \0627\0644\0623\0639\0645\062F\0629 \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\062E\0627\0635 \0628\0643'),
unistr('\0628\0627\0644\0623\0633\0645\0627\0621 \0627\0644\0645\0633\062A\0639\0627\0631\0629 \0627\0644\062E\0627\0635\0629 \0628\0647\0627. \0648\064A\0624\062F\064A \0627\0644\0646\0642\0631 \0639\0644\0649 \0627\0633\0645 \0627\0644\0639\0645\0648\062F \0623\0648 \0627\0644\0627\0633\0645 \0627\0644\0645\0633\062A\0639\0627\0631 \0625\0644\0649 \062A\0636\0645\064A\0646\0647\0627'),
unistr('\0641\064A \0627\0644\0627\062D\062A\0633\0627\0628. \062A\0648\062C\062F \0628\062C\0627\0646\0628 \0627\0644\0623\0639\0645\062F\0629 \0644\0648\062D\0629 \0645\0641\0627\062A\064A\062D. \062A\0639\0645\0644 \0644\0648\062D\0629 \0627\0644\0645\0641\0627\062A\064A\062D \0647\0630\0647'),
unistr('\0643\0627\062E\062A\0635\0627\0631 \0644\0644\0645\0641\0627\062A\064A\062D \0634\0627\0626\0639\0629 \0627\0644\0627\0633\062A\062E\062F\0627\0645. \0641\064A \0623\0642\0635\0649 \0627\0644\064A\0645\064A\0646 \062A\0648\062C\062F \0627\0644\062F\0648\0627\0644.</p>'),
unistr('<p>\064A\0648\0636\062D \0645\062B\0627\0644 \0627\0644\0627\062D\062A\0633\0627\0628 \0627\0644\062A\0627\0644\064A \0643\064A\0641\064A\0629 \0639\0631\0636 \0625\062C\0645\0627\0644\064A \0627\0644\062A\0639\0648\064A\0636:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\062D\064A\062BA \0647\0648 ORGANIZATION \0648B \0647\0648 SALARY \0648C \0647\0648 COMMISSION)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590330152398733)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\064F\0633\062A\062E\062F\0645 \0644\062A\0643\0648\064A\0646 \0641\0635\0644 \0627\0644\0645\062C\0645\0648\0639\0629 \0641\064A \0639\0645\0648\062F \0648\0627\062D\062F \0623\0648 \0623\0643\062B\0631. \064A\0624\062F\064A \0647\0630\0627 \0625\0644\0649 \0633\062D\0628 \0627\0644\0623\0639\0645\062F\0629 \0645\0646 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A \0648\0639\0631\0636\0647\0627 \0643\0633\062C\0644 \0631\0626\064A\0633\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584549944398729)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0639\0631\0636 \062A\0641\0627\0635\064A\0644 \0635\0641 \0648\0627\062D\062F \0641\064A \0643\0644 \0645\0631\0629\060C \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 \0637\0631\064A\0642\0629 \0639\0631\0636 \0635\0641 \0648\0627\062D\062F \0641\064A \0627\0644\0635\0641 \0627\0644\0630\064A \062A\0631\064A\062F \0639\0631\0636\0647. \0633\062A\0643\0648\0646 \062F\0627\0626\0645\064B\0627 \0637\0631\064A\0642\0629 \0639\0631\0636 \0635\0641 \0648\0627\062D\062F \0627\0644\0639\0645\0648\062F \0627\0644\0623\0648\0644. \062A\0628\0639\064B\0627 \0644\062A\062E\0635\064A\0635 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A\060C \0642\062F \062A\0643\0648\0646 \0637\0631\064A\0642\0629 \0639\0631\0636 \0635\0641 \0648\0627\062D\062F \0647\064A \0637\0631\064A\0642\0629 \0627\0644\0639\0631\0636 \0627\0644\0642\064A\0627\0633\064A\0629 \0623\0648 \0635\0641\062D\0629 \0645\062E\0635\0635\0629 \062A\0633\0645\062D \0628\0627\0644\062A\062D\062F\064A\062B.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584464873398729)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062A\0645\0643\064A\0646 \062A\0646\0632\064A\0644 \0645\062C\0645\0648\0639\0629 \0627\0644\0646\062A\0627\0626\062C \0627\0644\062D\0627\0644\064A\0629. \062A\062E\062A\0644\0641 \0635\064A\063A \0627\0644\062A\0646\0632\064A\0644'),
unistr('\062D\0633\0628 \0627\0644\0645\062B\0628\062A \0644\062F\064A\0643 \0648\062A\0639\0631\064A\0641 \0627\0644\062A\0642\0631\064A\0631 \0644\0643\0646'),
unistr('\0642\062F \062A\062A\0636\0645\0646 CSV \0623\0648 HTML \0623\0648 \0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A \0623\0648 XLS \0623\0648 PDF \0623\0648 RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583589274398728)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0642\0645 \0628\062A\0631\0643\064A\0632 \0627\0644\062A\0642\0631\064A\0631 \0639\0628\0631 \0625\0636\0627\0641\0629 \0639\0628\0627\0631\0629 <code>WHERE</code> \0623\0648 \062A\0639\062F\064A\0644\0647\0627 \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645. \0648\064A\0645\0643\0646\0643 \0627\0644\062A\0631\0634\064A\062D \062D\0633\0628 \0639\0645\0648\062F \0623\0648 \0635\0641.  '),
unistr('<p>\0625\0630\0627 \0642\0645\062A \0628\0627\0644\062A\0631\0634\064A\062D \062D\0633\0628 \0639\0645\0648\062F\060C \0641\062D\062F\062F \0639\0645\0648\062F\064B\0627 (\0644\0627 \064A\0646\0628\063A\064A \0623\0646 \064A\0643\0648\0646'),
unistr('\0639\0645\0648\062F\064B\0627 \0645\0639\0631\0648\0636\064B\0627)\060C \062D\062F\062F \0645\0639\0627\0645\0644 Oracle \0642\064A\0627\0633\064A\064B\0627  (=\060C !=\060C \0644\064A\0633 \0641\064A\060C \0628\064A\0646)\060C \0648\0623\062F\062E\0644 \062A\0639\0628\064A\0631\064B\0627 \0644\0644\0645\0642\0627\0631\0646\0629 \0628\0647. \0627\0644\062A\0639\0628\064A\0631\0627\062A \062D\0633\0627\0633\0629 \0644\062D\0627\0644\0629 \0627\0644\0623\062D\0631\0641. \0627\0633\062A\062E\062F\0645 % \0643\062D\0631\0641 \0628\062F\0644 (\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>\0625\0630\0627 \0642\0645\062A \0628\0627\0644\062A\0631\0634\064A\062D \062D\0633\0628 \0635\0641\060C \064A\0645\0643\0646\0643 \062A\0643\0648\064A\0646 \0639\0628\0627\0631\0627\062A <code>WHERE</code> \0645\0639\0642\062F\0629 \0628\0627\0633\062A\062E\062F\0627\0645'),
unistr('\0627\0644\0623\0633\0645\0627\0621 \0627\0644\0645\0633\062A\0639\0627\0631\0629 \0644\0644\0623\0639\0645\062F\0629 \0648\0623\064A \062F\0648\0627\0644 \0623\0648 \0645\0639\0627\0645\0644\0627\062A Oracle (\0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644\060C <code>G = ''VA'' or G = ''CT''</code>\060C \062D\064A\062B \064A\0643\0648\0646'),
unistr('<code>G</code> \0627\0644\0627\0633\0645 \0627\0644\0645\0633\062A\0639\0627\0631 \0644\0640 <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584172574398729)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\064A\062A\064A\062D \0644\0643 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0639\0646 \0628\064A\0627\0646\0627\062A \062A\0627\0631\064A\062E\064A\0629 \0639\0631\0636 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\064A \0643\0627\0646\062A \0645\0648\062C\0648\062F\0629 \0633\0627\0628\0642\064B\0627.'),
unistr('\0627\0644\0641\062A\0631\0629 \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629 \0627\0644\062A\064A \064A\0645\0643\0646\0643 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0639\0646 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0627\0631\064A\062E\064A\0629 \0628\0647\0627 \0647\0648 3 \0633\0627\0639\0627\062A (\0623\0648 180'),
unistr('\062F\0642\064A\0642\0629) \0644\0643\0646 \062A\062E\062A\0644\0641 \0627\0644\0641\062A\0631\0629 \0627\0644\0641\0639\0644\064A\0629 \0644\0643\0644 \0642\0627\0639\062F\0629 \0628\064A\0627\0646\0627\062A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645321393398775)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\062A\062A\064A\062D \0644\0643 \0627\0644\0635\064A\063A\0629 \062A\062E\0635\064A\0635 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631.'),
unistr('\062A\062A\0636\0645\0646 \0627\0644\0635\064A\063A\0629 \0627\0644\0642\0627\0626\0645\0629 \0627\0644\0641\0631\0639\064A\0629 \0627\0644\062A\0627\0644\064A\0629:</p>'),
unistr('<ul><li>\0641\0631\0632</li>'),
unistr('<li>\062A\0642\0633\064A\0645 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645</li>'),
unistr('<li>\062A\0645\064A\064A\0632</li>'),
unistr('<li>\062D\0633\0627\0628</li>'),
unistr('<li>\062A\062C\0645\064A\0639</li>'),
unistr('<li>\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A</li>'),
unistr('<li>\062A\062C\0645\064A\0639 \062D\0633\0628</li>'),
unistr('<li>\062C\062F\0648\0644 \0645\062D\0648\0631\064A</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643505817398774)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\064A\0645\0643\0646\0643 \062A\0639\0631\064A\0641 \0637\0631\064A\0642\0629 \062A\062C\0645\064A\0639 \062D\0633\0628 \0648\0627\062D\062F\0629 \0644\0643\0644 \062A\0642\0631\064A\0631'),
unistr('\0645\062D\0641\0648\0638. \0628\0645\062C\0631\062F \062A\0639\0631\064A\0641\0647\0627\060C \064A\0645\0643\0646\0643 \0627\0644\062A\0628\062F\064A\0644 \0628\064A\0646 \0637\0631\064A\0642\062A\064A \0627\0644\0639\0631\0636 \062A\062C\0645\064A\0639 \062D\0633\0628 \0648\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631'),
unistr('\0628\0627\0633\062A\062E\062F\0627\0645 \0623\064A\0642\0648\0646\0627\062A \0637\0631\0642 \0627\0644\0639\0631\0636 \0641\064A \0634\0631\064A\0637 \0627\0644\0628\062D\062B. \0644\062A\0643\0648\064A\0646 \0637\0631\064A\0642\0629 \0639\0631\0636 \062A\062C\0645\064A\0639 \062D\0633\0628\060C'),
unistr(' \062D\062F\062F: '),
'<p></p><ul>',
unistr('<li>\0627\0644\0623\0639\0645\062F\0629 \0627\0644\062A\064A \0633\064A\062A\0645 \062A\0643\0648\064A\0646 \0645\062C\0645\0648\0639\0627\062A \062D\0633\0628\0647\0627</li>'),
unistr('<li>\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0637\0644\0648\0628 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628\0647\0627 \0645\0639 \0627\0644\062F\0627\0644\0629 \0627\0644\0645\0637\0644\0648\0628 \062A\0646\0641\064A\0630\0647\0627 (\0627\0644\0645\062A\0648\0633\0637\060C \0627\0644\0645\062C\0645\0648\0639\060C \0627\0644\0639\062F\062F\060C \0648\063A\064A\0631 \0630\0644\0643.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583703786398728)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\064A\062A\064A\062D \0644\0643 \062A\0639\0631\064A\0641 \0645\0631\0634\062D. \064A\062A\0645 \062A\0645\064A\064A\0632 \0627\0644\0635\0641\0648\0641 \0627\0644\062A\064A \062A\0644\0628\064A \0645\0639\0627\064A\064A\0631 \0627\0644\0645\0631\0634\062D \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0644\062E\0635\0627\0626\0635 \0627\0644\0645\0631\062A\0628\0637\0629 \0628\0627\0644\0645\0631\0634\062D. \062A\062A\0636\0645\0646 \0627\0644\062E\064A\0627\0631\0627\062A:</p>'),
'<ul>',
unistr('<li><strong>\0627\0644\0627\0633\0645</strong> \064A\064F\0633\062A\062E\062F\0645 \0644\0644\0639\0631\0636 \0641\0642\0637.</li>'),
unistr('<li><strong>\0627\0644\062A\0633\0644\0633\0644</strong> \064A\062D\062F\062F \062A\0633\0644\0633\0644 \062A\0642\064A\064A\0645 \0627\0644\0642\0648\0627\0639\062F.</li>'),
unistr('<li><strong>\0645\0645\0643\0646</strong> \064A\062D\062F\062F \0625\0630\0627 \0645\0627 \0643\0627\0646\062A \0627\0644\0642\0627\0639\062F\0629 \0645\0645\0643\0646\0629 \0623\0648 \0645\0639\0637\0644\0629.</li>'),
unistr('<li><strong>\0646\0648\0639 \0627\0644\062A\0645\064A\064A\0632</strong> \064A\062D\062F\062F \0625\0630\0627 \0645\0627 \0643\0627\0646 \064A\0646\0628\063A\064A'),
unistr('\062A\0645\064A\064A\0632 \0627\0644\0635\0641 \0623\0648 \0627\0644\062E\0644\064A\0629. \0641\064A \062D\0627\0644\0629 \062A\062D\062F\064A\062F \062E\0644\064A\0629\060C \064A\062A\0645 \062A\0645\064A\064A\0632 \0627\0644\0639\0645\0648\062F \0627\0644\0645\0634\0627\0631 \0625\0644\064A\0647 \0641\064A'),
unistr('\0634\0631\0637 \0627\0644\062A\0645\064A\064A\0632.</li>'),
unistr('<li><strong>\0644\0648\0646 \0627\0644\062E\0644\0641\064A\0629</strong> \0644\0648\0646 \0627\0644\062E\0644\0641\064A\0629 \0627\0644\062C\062F\064A\062F \0641\064A \0627\0644\0645\0646\0637\0642\0629 \0627\0644\0645\0645\064A\0632\0629.</li>'),
unistr('<li><strong>\0644\0648\0646 \0627\0644\0646\0635</strong> \0647\0648 \0644\0648\0646 \0627\0644\0646\0635 \0627\0644\062C\062F\064A\062F \0641\064A \0627\0644\0645\0646\0637\0642\0629 \0627\0644\0645\0645\064A\0632\0629.</li>'),
unistr('<li><strong>\0634\0631\0637 \0627\0644\062A\0645\064A\064A\0632</strong>  \064A\062D\062F\062F \0634\0631\0637 \0627\0644\062A\0645\064A\064A\0632 \0627\0644\062E\0627\0635 \0628\0643.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521360526398680)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\064A\0645\0643\0646\0643 \062A\0639\0631\064A\0641 \0637\0631\064A\0642\0629 \0639\0631\0636 \0645\062D\0648\0631\064A \0648\0627\062D\062F\0629 \0644\0643\0644 \062A\0642\0631\064A\0631 \0645\062D\0641\0648\0638. \0628\0645\062C\0631\062F \062A\0639\0631\064A\0641\0647\0627\060C \064A\0645\0643\0646\0643 \0627\0644\062A\0628\062F\064A\0644 \0628\064A\0646 \0637\0631\064A\0642\062A\064A \0627\0644\0639\0631\0636 \0627\0644\0645\062D\0648\0631\064A \0648\0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631 \0628\0627\0633\062A\062E\062F\0627\0645 \0623\064A\0642\0648\0646\0627\062A \0637\0631\0642 \0627\0644\0639\0631\0636 \0641\064A \0634\0631\064A\0637 \0627\0644\0628\062D\062B. \0644\062A\0643\0648\064A\0646 \0637\0631\064A\0642\0629 \0639\0631\0636 \0645\062D\0648\0631\064A\060C \062D\062F\062F: '),
'<p></p>',
'<ul>',
unistr('<li>\0627\0644\0623\0639\0645\062F\0629 \0627\0644\062A\064A \0633\062A\0643\0648\0646 \0627\0644\0645\062D\0648\0631</li>'),
unistr('<li>\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0637\0644\0648\0628 \0639\0631\0636\0647\0627 \0643\0635\0641\0648\0641</li>'),
unistr('<li>\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0637\0644\0648\0628 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628\0647\0627 \0645\0639 \0627\0644\0648\0638\064A\0641\0629 \0627\0644\0645\0637\0644\0648\0628 \0623\062F\0627\0624\0647\0627 (\0627\0644\0645\062A\0648\0633\0637\060C \0627\0644\0645\062C\0645\0648\0639\060C \0627\0644\0639\062F\062F\060C \0648\063A\064A\0631 \0630\0644\0643.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594807041398737)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0625\0630\0627 \0642\0645\062A \0628\062A\062E\0635\064A\0635 \062A\0642\0631\064A\0631 \062A\0641\0627\0639\0644\064A\060C \0641\0633\062A\0638\0647\0631 \0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631'),
unistr('\0623\0633\0641\0644 \0634\0631\064A\0637 \0627\0644\0628\062D\062B \0648\0623\0639\0644\0649 \0627\0644\062A\0642\0631\064A\0631. \064A\0645\0643\0646 \0637\064A \0647\0630\0647 \0627\0644\0645\0646\0637\0642\0629 \0648\062A\0648\0633\064A\0639\0647\0627 \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0623\064A\0642\0648\0646\0629 \0639\0644\0649 \0627\0644\064A\0633\0627\0631.'),
'<p>',
unistr('\0644\0643\0644 \0625\0639\062F\0627\062F \062A\0642\0631\064A\0631\060C \064A\0645\0643\0646\0643:'),
'</p><ul>',
unistr('<li>\062A\062D\0631\064A\0631 \0625\0639\062F\0627\062F \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0627\0644\0627\0633\0645.</li>'),
unistr('<li>\062A\0639\0637\064A\0644/\062A\0645\0643\064A\0646 \0625\0639\062F\0627\062F \0645\0646 \062E\0644\0627\0644 \062A\062D\062F\064A\062F \0645\0631\0628\0639 \0627\062E\062A\064A\0627\0631 \062A\0645\0643\064A\0646/\062A\0639\0637\064A\0644 \0623\0648 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647. \0627\0633\062A\062E\062F\0645 \0639\0646\0635\0631 \0627\0644\062A\062D\0643\0645 \0647\0630\0627 \0644\062A\0634\063A\064A\0644 \0625\0639\062F\0627\062F \0623\0648 \0625\064A\0642\0627\0641 \062A\0634\063A\064A\0644\0647 \0645\0624\0642\062A\064B\0627.</li>'),
unistr('<li>\0625\0632\0627\0644\0629 \0625\0639\062F\0627\062F \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 \0625\0632\0627\0644\0629.</li>'),
'</ul>',
unistr('<p>\0625\0630\0627 \0642\0645\062A \0628\062A\0643\0648\064A\0646 \0631\0633\0645 \0628\064A\0627\0646\064A \0623\0648 \062A\062C\0645\064A\0639 \062D\0633\0628 \0623\0648 \062C\062F\0648\0644 \0645\062D\0648\0631\064A\060C \064A\0645\0643\0646\0643 \0627\0644\062A\0628\062F\064A\0644 \0628\064A\0646\0647\0627'),
unistr('\0648\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0623\0633\0627\0633\064A \0628\0627\0633\062A\062E\062F\0627\0645 \0631\0648\0627\0628\0637 \0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631 \0648\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0648\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628 \0648\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062C\062F\0648\0644 \0627\0644\0645\062D\0648\0631\064A'),
unistr('\0627\0644\0645\0639\0631\0648\0636\0629 \0639\0644\0649 \0627\0644\064A\0645\064A\0646. \0625\0630\0627 \0643\0646\062A \062A\0639\0631\0636 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0623\0648 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628 \0623\0648 \0627\0644\062C\062F\0648\0644 \0627\0644\0645\062D\0648\0631\064A\060C \064A\0645\0643\0646\0643'),
unistr('\0623\064A\0636\064B\0627 \0627\0633\062A\062E\062F\0627\0645 \0631\0627\0628\0637 "\062A\062D\0631\064A\0631" \0644\062A\062D\0631\064A\0631 \0627\0644\0625\0639\062F\0627\062F\0627\062A.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584326066398729)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0627\0644\062A\0642\0631\064A\0631 \0625\0644\0649 \0627\0644\0625\0639\062F\0627\062F\0627\062A \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629\060C \0648\0625\0632\0627\0644\0629 \0623\064A \0645\0646 \0627\0644\062A\062E\0635\064A\0635\0627\062A \0627\0644\062A\064A \0642\0645\062A \0628\0647\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645612812398775)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\064A\064A\0646 \0639\062F\062F \0627\0644\0633\062C\0644\0627\062A \0627\0644\062A\064A \064A\062A\0645 \0639\0631\0636\0647\0627 \0641\064A \0627\0644\0635\0641\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584225867398729)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0645\062E\0635\0635 \0644\0644\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0645\0633\062A\0642\0628\0644\064A. \0623\062F\062E\0644 \0627\0644\0627\0633\0645 \0648\0627\0644\0648\0635\0641 \0627\0644\0627\062E\062A\064A\0627\0631\064A \0648\064A\0645\0643\0646\0643 \0625\062A\0627\062D\0629 \0627\0644\0648\0635\0648\0644 \0627\0644\0639\0627\0645 \0644\0644\062A\0642\0631\064A\0631 (\0623\064A\060C \0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0627\0644\0630\064A\0646 \064A\0645\0643\0646\0647\0645 \0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0623\0633\0627\0633\064A \0627\0644\0627\0641\062A\0631\0627\0636\064A). \064A\0645\0643\0646\0643 \062D\0641\0638 \0623\0631\0628\0639\0629 \0623\0646\0648\0627\0639 \0645\0646 \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A\0629:</p>'),
'<ul>',
unistr('<li><strong>\0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0623\0633\0627\0633\064A</strong> (\0627\0644\0645\0637\0648\0631 \0641\0642\0637). \0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0623\0633\0627\0633\064A \0647\0648 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0630\064A \064A\0638\0647\0631 \0641\064A \0627\0644\0628\062F\0627\064A\0629. \0644\0627 \064A\0645\0643\0646 \0625\0639\0627\062F\0629 \062A\0633\0645\064A\0629 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0623\0633\0627\0633\064A \0623\0648 \062D\0630\0641\0647.</li>'),
unistr('<li><strong>\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0628\062F\064A\0644</strong> (\0627\0644\0645\0637\0648\0631 \0641\0642\0637). \064A\062A\064A\062D \0644\0644\0645\0637\0648\0631\064A\0646 \062A\0643\0648\064A\0646 \0639\062F\0629 \062A\062E\0637\064A\0637\0627\062A \062A\0642\0627\0631\064A\0631. \064A\0645\0643\0646 \0644\0644\0645\0637\0648\0631\064A\0646 \0641\0642\0637 \062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0628\062F\064A\0644 \0623\0648 \0625\0639\0627\062F\0629 \062A\0633\0645\064A\062A\0647 \0623\0648 \062D\0630\0641\0647.</li>'),
unistr('<li><strong>\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0639\0627\0645</strong> (\0627\0644\0645\0633\062A\062E\062F\0645). \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645 \0627\0644\0630\064A \0642\0627\0645 \0628\0625\0646\0634\0627\0626\0647 \062D\0641\0638\0647 \0623\0648 \0625\0639\0627\062F\0629 \062A\0633\0645\064A\062A\0647 \0623\0648 \062D\0630\0641\0647. \064A\0645\0643\0646 \0644\0645\0633\062A\062E\062F\0645\064A\0646 \0622\062E\0631\064A\0646 \0639\0631\0636 \0627\0644\062A\062E\0637\064A\0637 \0648\062D\0641\0638\0647 \0643\062A\0642\0631\064A\0631 \0622\062E\0631.</li>'),
unistr('<li><strong>\0627\0644\062A\0642\0631\064A\0631 \0627\0644\062E\0627\0635</strong> (\0627\0644\0645\0633\062A\062E\062F\0645). \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645 \0627\0644\0630\064A \0623\0646\0634\0623 \0627\0644\062A\0642\0631\064A\0631 \0641\0642\0637 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631 \0623\0648 \062D\0641\0638\0647 \0623\0648 \0625\0639\0627\062F\0629 \062A\0633\0645\064A\062A\0647 \0623\0648 \062D\0630\0641\0647.</li>'),
'</ul>',
unistr('<p>\0625\0630 \062D\0641\0638\062A \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\0645\062E\0635\0635\0629\060C \064A\0638\0647\0631 \0645\062D\062F\062F \0627\0644\062A\0642\0627\0631\064A\0631 \0641\064A \0634\0631\064A\0637 \0627\0644\0628\062D\062B \0639\0644\0649 \064A\0633\0627\0631 \0645\062D\062F\062F \0627\0644\0635\0641\0648\0641 (\0641\064A \062D\0627\0644\0629 \062A\0645\0643\064A\0646 \0647\0630\0647 \0627\0644\0645\064A\0632\0629).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583222628398728)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\062C\062F \0641\064A \0623\0639\0644\0649 \0643\0644 \0635\0641\062D\0629 \062A\0642\0631\064A\0631 \0645\0646\0637\0642\0629 \0628\062D\062B. \062A\0642\062F\0645 \0647\0630\0647 \0627\0644\0645\0646\0637\0642\0629 (\0623\0648 \0634\0631\064A\0637 \0627\0644\0628\062D\062B) \0627\0644\0645\064A\0632\0627\062A \0627\0644\062A\0627\0644\064A\0629:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646224218398776)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('<li><strong>\0642\0627\0626\0645\0629 \0627\0644\0625\062C\0631\0627\0621\0627\062A</strong> \062A\062A\064A\062D \0644\0643 \062A\062E\0635\064A\0635 \062A\0642\0631\064A\0631. \0627\0637\0644\0639 \0639\0644\0649 \0627\0644\0623\0642\0633\0627\0645 \0627\0644\062A\0627\0644\064A\0629.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645760185398775)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'ar'
,p_message_text=>unistr('<li><strong>\0623\064A\0642\0648\0646\0629 \062A\062D\062F\064A\062F \0623\0639\0645\062F\0629</strong> \062A\062A\064A\062D \0644\0643 \062A\0639\0631\064A\0641 \0627\0644\0639\0645\0648\062F \0627\0644\0630\064A \062A\0628\062D\062B \0639\0646\0647 (\0623\0648 \0627\0644\0643\0644).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646015464398775)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'ar'
,p_message_text=>unistr('<li><strong>\0627\0644\062A\0642\0627\0631\064A\0631</strong> \062A\0639\0631\0636 \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629 \0627\0644\0628\062F\064A\0644\0629 \0648\0627\0644\0645\062D\0641\0648\0638\0629 \0627\0644\0639\0627\0645\0629 \0623\0648 \0627\0644\062E\0627\0635\0629.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645931117398775)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('<li><strong>\0627\0644\0635\0641\0648\0641</strong> \064A\062A\0645 \0645\0646 \062E\0644\0627\0644\0647\0627 \062A\0639\064A\064A\0646 \0639\062F\062F \0627\0644\0633\062C\0644\0627\062A \0627\0644\062A\064A \064A\062A\0645 \0639\0631\0636\0647\0627 \0644\0643\0644 \0635\0641\062D\0629.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645800205398775)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\0645\0646\0637\0642\0629 \0627\0644\0646\0635</strong> \062A\062A\064A\062D \0644\0643 \0625\062F\062E\0627\0644 \0645\0639\0627\064A\064A\0631 \0628\062D\062B \062D\0633\0627\0633\0629 \0644\062D\0627\0644\0629 \0627\0644\0623\062D\0631\0641 (\064A\062A\0645 \062A\0636\0645\064A\0646 \0623\062D\0631\0641 \0627\0644\0628\062F\0644).</li>'),
unistr('<li><strong>\0632\0631 \0627\0644\0627\0646\062A\0642\0627\0644</strong> \064A\0646\0641\0630 \0627\0644\0628\062D\062B. \0648\0633\064A\0624\062F\064A \0627\0644\0636\063A\0637 \0639\0644\0649 \0645\0641\062A\0627\062D \0627\0644\0625\062F\062E\0627\0644 Enter \0625\0644\0649 \062A\0646\0641\064A\0630 \0627\0644\0628\062D\062B \0643\0630\0644\0643 \0639\0646\062F\0645\0627 \064A\0643\0648\0646 \0627\0644\0645\0624\0634\0631 \0641\064A \0645\0646\0637\0642\0629 \0646\0635 \0627\0644\0628\062D\062B.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646151675398775)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('<li><strong>\0623\064A\0642\0648\0646\0627\062A \0637\0631\0642 \0627\0644\0639\0631\0636</strong> \0627\0644\062A\0628\062F\064A\0644 \0628\064A\0646 \0637\0631\0642 \0639\0631\0636 \0627\0644\0623\064A\0642\0648\0646\0627\062A \0648\0627\0644\062A\0642\0631\064A\0631 \0648\0627\0644\062A\0641\0627\0635\064A\0644 \0648\0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0648\062A\062C\0645\064A\0639 \062D\0633\0628 \0648\062C\062F\0648\0644 \0645\062D\0648\0631\064A \0644\0644\062A\0642\0631\064A\0631 \0625\0630\0627 \0643\0627\0646\062A \0645\0639\0631\0641\0629 .</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662177414398787)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062A\064A\062D \0644\0643 <li><strong>\0625\062F\0627\0631\0629</strong> \0627\0644\0642\064A\0627\0645 \0628\0625\062F\0627\0631\0629 \0627\0644\062E\0635\0627\0626\0635 \0648\0627\0644\0623\0639\0645\062F\0629 \0648\0627\0644\0635\0641\0648\0641 \0648\0639\0631\0636 \0627\0644\062A\0627\0631\064A\062E \0644\0634\0628\0643\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0623\0648 \0627\0644\062A\0642\0631\064A\0631.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583433003398728)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\064F\0633\062A\062E\062F\0645 \0644\062A\0639\062F\064A\0644 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629. \062A\0638\0647\0631 \0627\0644\0623\0639\0645\062F\0629 \0639\0644\0649 \0627\0644\064A\0645\064A\0646\060C \0648\064A\062A\0645 \0625\062E\0641\0627\0621 \0627\0644\0623\0639\0645\062F\0629 \0639\0644\0649 \0627\0644\064A\0633\0627\0631. \064A\0645\0643\0646\0643 \0625\0639\0627\062F\0629 \062A\0631\062A\064A\0628 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0639\0631\0648\0636\0629 \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0623\0633\0647\0645 \0641\064A \0623\0642\0635\0649 \0627\0644\064A\0645\064A\0646. \062A\062A\0636\0645\0646 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\062D\0633\0648\0628\0629 \0627\0644\0628\0627\062F\0626\0629 <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583667761398728)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\064A\064F\0633\062A\062E\062F\0645 \0644\062A\063A\064A\064A\0631 \0627\0644\0623\0639\0645\062F\0629 \0644\0644\0641\0631\0632 \062D\0633\0628\0647\0627 \0648\062A\062D\062F\064A\062F \0625\0630\0627 \0645\0627 \0643\0627\0646'),
unistr('\0633\064A\062A\0645 \0627\0644\0641\0631\0632 \0628\062A\0631\062A\064A\0628 \062A\0635\0627\0639\062F\064A \0623\0645 \062A\0646\0627\0632\0644\064A. \0643\0645\0627 \064A\0645\0643\0646\0643 \062A\062D\062F\064A\062F \0643\064A\0641\064A\0629 \0627\0644\062A\0639\0627\0645\0644 \0645\0639'),
unistr('<code>\0627\0644\0642\064A\0645 \0627\0644\062E\0627\0644\064A\0629</code>. \0627\0644\0625\0639\062F\0627\062F \0627\0644\0627\0641\062A\0631\0627\0636\064A \064A\0639\0631\0636 <code>\0627\0644\0642\064A\0645 \0627\0644\062E\0627\0644\064A\0629</code> \062F\0627\0626\0645\064B\0627 \0641\064A \0627\0644\0646\0647\0627\064A\0629 \0623\0648 \0639\0631\0636\0647\0627 \062F\0627\0626\0645\064B\0627 \0641\064A \0627\0644\0628\062F\0627\064A\0629. \064A\0638\0647\0631 \0627\0644\0641\0631\0632 \0627\0644\0646\0627\062A\062C \0639\0644\0649 \064A\0645\064A\0646'),
unistr('\0639\0646\0627\0648\064A\0646 \0627\0644\0623\0639\0645\062F\0629 \0641\064A \0627\0644\062A\0642\0631\064A\0631.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643337592398773)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\062F \0625\0636\0627\0641\0629 \0627\0634\062A\0631\0627\0643\060C \062A\0642\0648\0645 \0628\0625\062F\062E\0627\0644 \0639\0646\0648\0627\0646 \0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A (\0623\0648 \0639\062F\0629 \0639\0646\0627\0648\064A\0646 \0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A\060C \0645\0641\0635\0648\0644\0629 \0628\0641\0627\0635\0644\0629)\060C \0648\0645\0648\0636\0648\0639 \0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A \0648\0645\0639\062F\0644 \0627\0644\062A\0643\0631\0627\0631 \0648\062A\0648\0627\0631\064A\062E \0627\0644\0628\062F\0627\064A\0629 \0648\0627\0644\0646\0647\0627\064A\0629. \062A\062A\0636\0645\0646 \0631\0633\0627\0626\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A \0627\0644\0646\0627\062A\062C\0629 \0646\0633\062E\0629 HTML \0645\0646 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A \062A\062D\062A\0648\064A \0639\0644\0649 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062D\0627\0644\064A')
||unistr('\0629 \0628\0627\0633\062A\062E\062F\0627\0645 \0625\0639\062F\0627\062F \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0630\064A \0643\0627\0646 \0645\0648\062C\0648\062F\064B\0627 \0639\0646\062F \0625\0636\0627\0641\0629 \0627\0644\0627\0634\062A\0631\0627\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661993166398787)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0634\0628\0643\0627\062A \0627\0644\0628\064A\0627\0646\0627\062A \0647\064A \0641\064A \0627\0644\0623\0633\0627\0633 \062A\0642\0627\0631\064A\0631 \0642\0627\0628\0644\0629 \0644\0644\062A\062D\0631\064A\0631 \0648\064A\0645\0643\0646 \062A\062E\0635\064A\0635\0647\0627 \0628\0634\0643\0644 \0643\0628\064A\0631. \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \062A\0639\062F\064A\0644 \0645\062E\0637\0637 \0627\0644\062A\0642\0631\064A\0631 \0639\0628\0631 \062A\062D\062F\064A\062F \0627\0644\0623\0639\0645\062F\0629 \0648\062A\0637\0628\064A\0642 \0627\0644\0645\0631\0634\062D\0627\062A \0648\0627\0644\062A\0645\064A\064A\0632 \0648\0627\0644\0641\0631\0632. \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0643\0630\0644\0643 \062A\062D\062F\064A\062F \0641\0648\0627\0635\0644 \0648\062A\062C\0645\064A\0639\0627\062A \0648\0631\0633\0648\0645 \0628\064A\0627\0646\064A\0629 \0648\0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628 \0648\0625\0636\0627\0641\0629 \0627\0644\0639\0645\0644\064A\0627\062A \0627\0644\062D\0633\0627\0628')
||unistr('\064A\0629 \0627\0644\062E\0627\0635\0629 \0628\0647\0645. \0643\0645\0627 \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \062A\0643\0648\064A\0646 \0639\062F\0629 \0645\062A\063A\064A\0631\0627\062A \0644\062A\0642\0631\064A\0631 \0648\062D\0641\0638\0647\0627 \0643\062A\0642\0627\0631\064A\0631 \0628\0623\0633\0645\0627\0621 \0644\0644\0639\0631\0636 \0627\0644\062E\0627\0635. '),
'<p/>',
unistr('\064A\0645\0643\0646 \062A\062E\0635\064A\0635 \0634\0628\0643\0629 \0628\064A\0627\0646\0627\062A \0628\0627\0633\062A\062E\062F\0627\0645 \0634\0631\064A\0637 \0627\0644\0628\062D\062B \0623\0648 \0642\0627\0626\0645\0629 \0627\0644\0625\062C\0631\0627\0621\0627\062A \0623\0648 \0642\0627\0626\0645\0629 \0627\0644\0625\062F\0627\0631\0629 \0623\0648 \0642\0627\0626\0645\0629 \0639\0646\0648\0627\0646 \0627\0644\0639\0645\0648\062F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673710996398797)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0638\0647\0631 \0642\0627\0626\0645\0629 \0627\0644\0625\062C\0631\0627\0621\0627\062A \0639\0644\0649 \064A\0645\064A\0646 \0632\0631 "\0627\0646\062A\0642\0627\0644" \0641\064A \0634\0631\064A\0637 \0627\0644\0628\062D\062B. \0627\0633\062A\062E\062F\0645 \0647\0630\0647 \0627\0644\0642\0627\0626\0645\0629 \0644\062A\062E\0635\064A\0635 \062A\0642\0631\064A\0631 \0634\0628\0643\0629 \0628\064A\0627\0646\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662494701398788)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0641\062D\0629 \0625\0636\0627\0641\0629/\062A\062D\0631\064A\0631 \0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662566152398788)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0644\0625\0636\0627\0641\0629 \0635\0641 \0625\0644\0649 \0634\0628\0643\0629 \0627\0644\0628\064A\0627\0646\0627\062A\060C \0627\0646\0642\0631 \0639\0644\0649 \0625\0636\0627\0641\0629 \0635\0641. \0644\062A\062D\0631\064A\0631 \062A\0641\0627\0635\064A\0644 \0635\0641\060C \0627\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 \062A\062D\0631\064A\0631 \0635\0641 (\0627\0644\0639\0645\0648\062F \0627\0644\0623\0648\0644) \0641\064A \0627\0644\0635\0641 \0627\0644\0630\064A \062A\0631\064A\062F \062A\062D\0631\064A\0631\0647. \0633\062A\0638\0647\0631 \0635\0641\062D\0629 \0625\0636\0627\0641\0629/\062A\062D\0631\064A\0631 \0635\0641 \0648\0633\062A\0639\0631\0636 \0623\0639\0645\062F\0629 \0634\0628\0643\0629 \0627\0644\0628\064A\0627\0646\0627\062A. </p>'),
'',
unistr('<p>\0639\0646\062F \062A\062D\0631\064A\0631 \0635\0641 \064A\0645\0643\0646\0643:</p>'),
'',
'<p><ul>',
unistr('<li><strong>\062D\0630\0641</strong> \0627\0644\0635\0641.</li>'),
unistr('<li><strong>\062A\0637\0628\064A\0642 \0627\0644\062A\063A\064A\064A\0631\0627\062A</strong> \0644\062D\0641\0638 \0627\0644\062A\063A\064A\064A\0631\0627\062A \0627\0644\062A\064A \062A\062A\0645 \0639\0644\0649 \0627\0644\0635\0641.</li>'),
unistr('<li>\0636\0645\0646 <strong>\0627\0644\0625\062C\0631\0627\0621\0627\062A</strong>\060C \0625\0636\0627\0641\0629 \0635\0641 \0648\0625\0636\0627\0641\0629 \0645\0644\0641\0627\062A \0623\0648 \0645\0644\0627\062D\0638\0627\062A \0623\0648 \0631\0648\0627\0628\0637 \0623\0648 \0639\0644\0627\0645\0627\062A \0648\0645\0631\0627\062C\0639\0629 \0627\0644\062A\0627\0631\064A\062E.</li>'),
unistr('<li>\0627\0644\062A\0646\0642\0644 \0625\0644\0649 \0627\0644\0635\0641 <strong>\0627\0644\062A\0627\0644\064A \0648\0627\0644\0633\0627\0628\0642</strong>.</li>'),
unistr('<li>\0636\0645\0646 <strong>\0627\0644\0625\062F\0627\0631\0629</strong>\060C \062A\0639\064A\064A\0646 \062E\0635\0627\0626\0635 \0627\0644\0623\0639\0645\062F\0629 \0648\0645\062C\0645\0648\0639\0627\062A \0627\0644\0623\0639\0645\062F\0629 \0648\0627\0644\0645\0631\0627\062C\0639\0627\062A \0648\0642\0648\0627\0626\0645 \0627\0644\0642\064A\0645.</li>'),
'</ul></p>',
'',
unistr('<p>\0633\062A\0639\0631\0636 \0645\0646\0637\0642\0629 \0627\0644\062A\0639\0644\064A\0642\0627\062A \0627\0644\062A\0648\0636\064A\062D\064A\0629 \0623\0633\0641\0644 \0627\0644\0635\0641\062D\0629 \0623\064A \0645\0644\0641\0627\062A \0623\0648 \0645\0644\0627\062D\0638\0627\062A \0623\0648 \0639\0644\0627\0645\0627\062A \0645\0631\062A\0628\0637\0629 \0628\0627\0644\0635\0641 \0627\0644\062D\0627\0644\064A.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673895220398797)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\064F\0633\062A\062E\062F\0645 \0644\062A\0643\0648\064A\0646 \0641\0635\0644 \0627\0644\0645\062C\0645\0648\0639\0629 \0641\064A \0639\0645\0648\062F \0648\0627\062D\062F \0623\0648 \0623\0643\062B\0631. \064A\0624\062F\064A \0647\0630\0627 \0625\0644\0649 \0633\062D\0628 \0627\0644\0623\0639\0645\062F\0629 \0645\0646 \062A\0642\0631\064A\0631 \0634\0628\0643\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0648\0639\0631\0636\0647\0627 \0643\0633\062C\0644 \0631\0626\064A\0633\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662385825398788)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062A\0645\0643\064A\0646 \062A\0646\0632\064A\0644 \0645\062C\0645\0648\0639\0629 \0627\0644\0646\062A\0627\0626\062C \0627\0644\062D\0627\0644\064A\0629. \062A\062A\0636\0645\0646 \0635\064A\063A \0627\0644\062A\0646\0632\064A\0644'),
unistr(' CSV \0623\0648 HTML \0623\0648 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673975534398797)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0625\0630\0627 \0642\0645\062A \0628\062A\062E\0635\064A\0635 \062A\0642\0631\064A\0631 \0634\0628\0643\0629 \0628\064A\0627\0646\0627\062A\060C \0641\0633\062A\0638\0647\0631 \0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631'),
unistr('\0623\0633\0641\0644 \0634\0631\064A\0637 \0627\0644\0628\062D\062B \0648\0623\0639\0644\0649 \0627\0644\062A\0642\0631\064A\0631. \064A\0645\0643\0646 \0637\064A \0647\0630\0647 \0627\0644\0645\0646\0637\0642\0629 \0648\062A\0648\0633\064A\0639\0647\0627 \0628\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0623\064A\0642\0648\0646\0629 \0639\0644\0649 \0627\0644\064A\0633\0627\0631.'),
'<p>',
unistr('\0644\0643\0644 \0625\0639\062F\0627\062F \062A\0642\0631\064A\0631\060C \064A\0645\0643\0646\0643:'),
'</p><ul>',
unistr('<li>\062A\062D\0631\064A\0631 \0625\0639\062F\0627\062F \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0627\0644\0627\0633\0645.</li>'),
unistr('<li>\062A\0639\0637\064A\0644/\062A\0645\0643\064A\0646 \0625\0639\062F\0627\062F \0645\0646 \062E\0644\0627\0644 \062A\062D\062F\064A\062F \0645\0631\0628\0639 \0627\062E\062A\064A\0627\0631 \062A\0645\0643\064A\0646/\062A\0639\0637\064A\0644 \0623\0648 \0625\0644\063A\0627\0621 \062A\062D\062F\064A\062F\0647. \0627\0633\062A\062E\062F\0645 \0639\0646\0635\0631 \0627\0644\062A\062D\0643\0645 \0647\0630\0627 \0644\062A\0634\063A\064A\0644 \0625\0639\062F\0627\062F \0623\0648 \0625\064A\0642\0627\0641 \062A\0634\063A\064A\0644\0647 \0645\0624\0642\062A\064B\0627.</li>'),
unistr('<li>\0625\0632\0627\0644\0629 \0625\0639\062F\0627\062F \0628\0627\0644\0646\0642\0631 \0639\0644\0649 \0623\064A\0642\0648\0646\0629 \0625\0632\0627\0644\0629.</li>'),
'</ul>',
unistr('<p>\0625\0630\0627 \0642\0645\062A \0628\062A\0643\0648\064A\0646 \0631\0633\0645 \0628\064A\0627\0646\064A \0623\0648 \062A\062C\0645\064A\0639 \062D\0633\0628\060C \064A\0645\0643\0646\0643 \0627\0644\062A\0628\062F\064A\0644 \0628\064A\0646\0647\0627'),
unistr('\0648\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0623\0633\0627\0633\064A \0628\0627\0633\062A\062E\062F\0627\0645 \0631\0648\0627\0628\0637 \0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631 \0648\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0648\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628'),
unistr('\0627\0644\0645\0639\0631\0648\0636\0629 \0639\0644\0649 \0627\0644\064A\0645\064A\0646. \0625\0630\0627 \0643\0646\062A \062A\0639\0631\0636 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A \0623\0648 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628 \0623\0648 \0627\0644\062C\062F\0648\0644 \0627\0644\0645\062D\0648\0631\064A\060C \064A\0645\0643\0646\0643'),
unistr('\0623\064A\0636\064B\0627 \0627\0633\062A\062E\062F\0627\0645 \0631\0627\0628\0637 "\062A\062D\0631\064A\0631" \0644\062A\062D\0631\064A\0631 \0627\0644\0625\0639\062F\0627\062F\0627\062A.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662210120398788)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\062D\0641\0638 \062A\062E\0637\064A\0637 \062A\0642\0631\064A\0631 \0634\0628\0643\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0645\062E\0635\0635\0629 \0644\0644\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0645\0633\062A\0642\0628\0644\064A. \0623\062F\062E\0644 \0627\0633\0645\064B\0627 \0648\0648\0635\0641\064B\0627 \0627\062E\062A\064A\0627\0631\064A\064A\0646. \064A\0645\0643\0646\0643 \062D\0641\0638 \062B\0644\0627\062B\0629 \0623\0646\0648\0627\0639 \0645\0646 \062A\062E\0637\064A\0637\0627\062A \062A\0642\0627\0631\064A\0631 \0634\0628\0643\0629 \0627\0644\0628\064A\0627\0646\0627\062A:</p>'),
'<ul>',
unistr('<li><strong>\0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0623\0633\0627\0633\064A</strong> (\0627\0644\0645\0633\0624\0648\0644 \0641\0642\0637). \0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0623\0633\0627\0633\064A \0647\0648 \0627\0644\062A\062E\0637\064A\0637 \0627\0644\0630\064A \064A\0638\0647\0631 \0641\064A \0627\0644\0628\062F\0627\064A\0629. \0644\0627 \064A\0645\0643\0646 \0625\0639\0627\062F\0629 \062A\0633\0645\064A\0629 \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629 \0627\0644\0623\0633\0627\0633\064A\0629 \0623\0648 \062D\0630\0641\0647\0627.</li>'),
unistr('<li><strong>\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0628\062F\064A\0644</strong> (\0627\0644\0645\0633\0624\0648\0644\0648\0646 \0641\0642\0637). \064A\062A\064A\062D \0644\0644\0645\0633\0624\0648\0644\064A\0646 \062A\0643\0648\064A\0646 \0639\062F\0629 \062A\062E\0637\064A\0637\0627\062A \062A\0642\0627\0631\064A\0631. \064A\0645\0643\0646 \0644\0644\0645\0633\0624\0648\0644\064A\0646 \0641\0642\0637 \062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0628\062F\064A\0644 \0623\0648 \0625\0639\0627\062F\0629 \062A\0633\0645\064A\062A\0647 \0623\0648 \062D\0630\0641\0647.</li>'),
unistr('<li><strong>\0627\0644\062A\0642\0631\064A\0631 \0627\0644\062E\0627\0635</strong> (\0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646). \064A\0645\0643\0646 \0644\0644\0645\0633\062A\062E\062F\0645 \0627\0644\0630\064A \0642\0627\0645 \0628\0625\0646\0634\0627\0621 \062A\062E\0637\064A\0637 \0627\0644\062A\0642\0631\064A\0631 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631 \0623\0648 \062D\0641\0638\0647 \0623\0648 \0625\0639\0627\062F\0629 \062A\0633\0645\064A\062A\0647 \0623\0648 \062D\0630\0641\0647.</li>'),
'</ul>',
unistr('<p>\0625\0630\0627 \062D\0641\0638\062A \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\0645\062E\0635\0635\0629\060C \064A\0638\0647\0631 \0645\062D\062F\062F \0627\0644\062A\0642\0627\0631\064A\0631 \0641\064A \0634\0631\064A\0637 \0627\0644\0628\062D\062B \0639\0644\0649 \064A\0633\0627\0631 \0645\062D\062F\062F \0627\0644\0635\0641\0648\0641 (\0641\064A \062D\0627\0644\0629 \062A\0645\0643\064A\0646 \0647\0630\0647 \0627\0644\0645\064A\0632\0629).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588345319398732)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062E\0641\0627\0621 \0627\0644\0639\0645\0648\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578995780398725)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645\064A\064A\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589842307398733)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0645\064A\064A\0632\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594907867398737)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0631\0637 \0627\0644\062A\0645\064A\064A\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643924160398774)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0644\0648\0628 \0627\0644\062A\0645\064A\064A\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553915735398706)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\062A\0645\064A\064A\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663448260398788)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0641\0642\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693043590398812)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F \0648\0627\062D\062F \063A\064A\0631 \0646\0634\0637')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693199561398812)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0625\0639\062F\0627\062F\0627\062A \063A\064A\0631 \0627\0644\0646\0634\0637\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584920609398729)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0644\064A\0645\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595943087398738)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0635\0627\0644\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589307865398733)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0628\064A\0631 \0627\062D\062A\0633\0627\0628 \063A\064A\0631 \0635\0627\0644\062D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548718232398702)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \062A\0627\0631\064A\062E \0627\0644\0646\0647\0627\064A\0629 \0623\0643\0628\0631 \0645\0646 \062A\0627\0631\064A\062E \0627\0644\0628\062F\0627\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603670356398743)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0628\064A\0631 \0645\0631\0634\062D \063A\064A\0631 \0635\0627\0644\062D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671424547398795)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\0639\0644\0627\0645 \0645\0631\0634\062D \063A\064A\0631 \0635\0627\0644\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693226923398812)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F \0648\0627\062D\062F \063A\064A\0631 \0635\0627\0644\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693322615398812)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0625\0639\062F\0627\062F\0627\062A \063A\064A\0631 \0627\0644\0635\0627\0644\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644156890398774)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('(\0628\0627\0644\062F\0642\0627\0626\0642)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661191417398787)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0641\064A \0622\062E\0631 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661380796398787)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0641\064A %1 \0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661227759398787)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0641\064A \0622\062E\0631 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661463490398787)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\064A\0633 \0641\064A %1 \0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594033932398736)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0648\062D\0629 \0627\0644\0645\0641\0627\062A\064A\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560190521398711)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0633\0645\064A\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587908508398732)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0627\0644\0645\062D\0648\0631 \0644\0644\062A\0633\0645\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580421131398726)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\064A\0648\0645 \0627\0644\0645\0627\0636\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580694146398726)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 \0633\0627\0639\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580184725398726)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0631 \0627\0644\0645\0627\0636\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580287796398726)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0633\0628\0648\0639 \0627\0644\0645\0627\0636\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580385620398726)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 %0 \0645\0646 \0627\0644\0623\064A\0627\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580587472398726)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 %0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579941955398725)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 %0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580080177398726)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0646\0629 \0627\0644\0645\0627\0636\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560070254398711)
,p_name=>'APEXIR_LINE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556819529398708)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\064A \0645\0639 \0645\0633\0627\062D\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671320574398795)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062E\0637\064A\0637')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588857643398732)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646 \0627\0644\0645\0642\062F\0631 \0623\0646 \064A\062A\062C\0627\0648\0632 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0627\0644\0645\0633\0645\0648\062D \0628\0647 \0645\0646 \0627\0644\0645\0648\0627\0631\062F. \0627\0644\0631\062C\0627\0621 \062A\0639\062F\064A\0644 \0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0648\0625\0639\0627\062F\0629 \0627\0644\0645\062D\0627\0648\0644\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571045541398719)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0639\062F\062F \0635\0641\0648\0641 \0647\0630\0627 \0627\0644\062A\0642\0631\064A\0631 \0647\0648 %0 \0645\0646 \0627\0644\0635\0641\0648\0641. \0627\0644\0631\062C\0627\0621 \062A\0637\0628\064A\0642 \0645\0631\0634\062D \0644\062A\0642\0644\064A\0644 \0639\062F\062F \0627\0644\0633\062C\0644\0627\062A \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\062E\0627\0635 \0628\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671932425398795)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F \0623\0642\0635\0649 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672128464398795)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0633\064A\0637 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575090203398722)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672062202398795)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F \0623\062F\0646\0649 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671031143398794)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644575187398774)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0647\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587177318398731)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587033682398731)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644 \0627\0644\0643\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698208112398815)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0627\0644\0645\0639\0631\0641 \0627\0644\062B\0627\0628\062A \0644\0644\0645\0646\0637\0642\0629 \0644\0623\0646 \0627\0644\0635\0641\062D\0629 \062A\062D\062A\0648\064A \0639\0644\0649 \0639\062F\0629 \062A\0642\0627\0631\064A\0631 \062A\0641\0627\0639\0644\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555527412398707)
,p_name=>'APEXIR_NAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0633\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582902357398728)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\062C\0645\064A\0639 \0627\0644\062C\062F\064A\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693937721398812)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0626\0629 \062C\062F\064A\062F\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110583077705398728)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\062D\062A\0633\0627\0628 \0627\0644\062C\062F\064A\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577899290398724)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580960885398726)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\064A\0648\0645 \0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580765148398726)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0639\0629 \0627\0644\062A\0627\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581229742398726)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0631 \0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581194892398726)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0633\0628\0648\0639 \0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581053437398726)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\064A\0627\0645 \0627\0644\062A\0627\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110580871715398726)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0622\062E\0631 %0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581447700398727)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A \0627\0644\062A\0627\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581372426398727)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0646\0629 \0627\0644\062A\0627\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555871731398707)
,p_name=>'APEXIR_NO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596138847398738)
,p_name=>'APEXIR_NONE'
,p_message_language=>'ar'
,p_message_text=>unistr('- \0628\0644\0627 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643757602398774)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 \0639\0646\0648\0627\0646 \0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A \0635\0627\0644\062D\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592623581398735)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645 \0627\0644\062E\0627\0644\064A\0629 \062F\0627\0626\0645\064B\0627 \0641\064A \0627\0644\0628\062F\0627\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592566587398735)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645 \0627\0644\062E\0627\0644\064A\0629 \062F\0627\0626\0645\064B\0627 \0641\064A \0627\0644\0646\0647\0627\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593039568398735)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \0627\0644\0642\064A\0645 \0627\0644\0641\0627\0631\063A\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589476909398733)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0648\0642\062A \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0627\0631\064A\062E\064A\0629 \0631\0642\0645\064A\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589097020398732)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0627\0644\062A\0633\0644\0633\0644 \0631\0642\0645\064A\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593532055398736)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0627\0645\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554428353398706)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\0631\062A\0642\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663383705398788)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\062A\062C\0627\0647')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556347543398708)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0630\0644\0643')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539164288398695)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062A\062C\0627\0647 \0627\0644\0635\0641\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539809762398695)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0641\0642\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539908382398696)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0623\0633\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539082052398695)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062C\0645 \0627\0644\0635\0641\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539640391398695)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'ar'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539588084398695)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'ar'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539765244398695)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062E\0635\0635')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539317722398695)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'ar'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539293337398695)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'ar'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110539478413398695)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'ar'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672431577398796)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\0628\0629 \0627\0644\0639\062F\062F \0627\0644\0625\062C\0645\0627\0644\064A %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671614888398795)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\0628\0629 \0627\0644\0645\062C\0645\0648\0639 \0627\0644\0625\062C\0645\0627\0644\064A %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670663077398794)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\0628\0629 \0627\0644\0639\062F\062F \0627\0644\0625\062C\0645\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670595856398794)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0633\0628\0629 \0627\0644\0645\062C\0645\0648\0639 \0627\0644\0625\062C\0645\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559951724398711)
,p_name=>'APEXIR_PIE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0631\0635\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619898505398756)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062C\062F\0648\0644 \0627\0644\0645\062D\0648\0631\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621347493398757)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0627\0644\062A\062C\0645\064A\0639.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621548793398757)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646\0643 \0627\0644\062A\062C\0645\064A\0639 \0641\064A \0639\0645\0648\062F \0645\062D\062F\062F \0643\0639\0645\0648\062F \0635\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620750015398756)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\062D\0648\0631\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620580524398756)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0645\062D\0648\0631\064A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621100654398757)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\0648\0631\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521291655398680)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0642\0644\0644 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0639\062F\062F \0627\0644\0635\0641\0648\0641 \0641\064A \0627\0633\062A\0639\0644\0627\0645 \0645\062D\0648\0631\064A \0645\0646 \0639\062F\062F \0627\0644\0635\0641\0648\0641 \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A\060C \0648\0644\064A\0633 \0645\0646 \0639\062F\062F \0627\0644\0635\0641\0648\0641 \0627\0644\0645\0639\0631\0648\0636\0629. \064A\062A\062C\0627\0648\0632 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0631\0626\064A\0633\064A \0644\062F\064A\0643 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\0639\062F\062F \0627\0644\0635\0641\0648\0641 %0. \0627\0644\0631\062C\0627\0621 \062A\0637\0628\064A\0642 \0645\0631\0634\062D \0644\062A\0642\0644\064A\0644 \0639\062F\062F \0627\0644\0633\062C\0644\0627\062A \0641\064A \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\0623\0633\0627\0633\064A \0627\0644\062E\0627\0635 \0628\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621053175398756)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \0645\062D\0648\0631\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590402727398733)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A \0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\0648\0631\064A \0639\0644\0649 \0627\0644\0643\062B\064A\0631 \0645\0646 \0627\0644\0642\064A\0645 \0627\0644\0641\0631\064A\062F\0629 - \0644\0627 \064A\0645\0643\0646 \062A\0643\0648\064A\0646 SQL \0645\062D\0648\0631\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643864056398774)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0627\064A\0646\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577973950398724)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110669574491398793)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0633\0627\0633\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644848207398775)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0623\0633\0627\0633\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538997197398695)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0636\0645\064A\0646 \0639\0644\0627\0645\0627\062A \0625\0645\0643\0627\0646\064A\0629 \0627\0644\0648\0635\0648\0644')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525887779398684)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0635 \0627\0644\0645\0646\0633\0642 \0644\0644\0634\0631\064A\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602629576398743)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0627\0635')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560576905398711)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0627\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556193515398708)
,p_name=>'APEXIR_RED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\062D\0645\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698172202398815)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0639\0631\0641 \0627\0644\062B\0627\0628\062A \0644\0644\0645\0646\0637\0642\0629 %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587224109398731)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587325066398731)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\0643\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693426832398812)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586858789398731)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0641\0648\0627\0635\0644 \0639\0646\0627\0635\0631 \0627\0644\062A\062D\0643\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586558215398731)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0645\0631\0634\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586694946398731)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062A\0627\0631\064A\062E\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693501763398812)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586934540398731)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\062A\0645\064A\064A\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693657443398812)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \0627\0644\062C\062F\0648\0644 \0627\0644\0645\062D\0648\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674682248398797)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0632\0627\0644\0629 \062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655247886398782)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0633\0645\064A\0629 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596496950398738)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0633\0645\064A\0629 \0627\0644\062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578243204398724)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672522432398796)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0627\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552756872398705)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A \0627\0644\0645\062D\0641\0648\0638 \0628\0627\0644\0627\0633\0645 \0627\0644\0645\0633\062A\0639\0627\0631 %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602987633398743)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552893997398705)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0641 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A \0627\0644\0645\062D\0641\0648\0638 %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110594785434398737)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0627\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575586917398722)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\064A\0642\0629 \0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579413766398725)
,p_name=>'APEXIR_RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560798663398711)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\0639\0627\062F\0629 \0627\0644\062A\0642\0631\064A\0631 \0625\0644\0649 \0627\0644\0625\0639\062F\0627\062F\0627\062A \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555996029398707)
,p_name=>'APEXIR_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668672289398792)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 ROWID \0643\0639\0645\0648\062F \0645\0641\062A\0627\062D \0623\0633\0627\0633\064A \0644\0645\0635\062F\0631 \0628\064A\0627\0646\0627\062A REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585976712398730)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641\0648\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645517902398775)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0641\0648\0641 \0644\0643\0644 \0635\0641\062D\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620869408398756)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0639\0645\062F\0629 \0627\0644\0635\0641\0648\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620612768398756)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0627\0644\0635\0641 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621296174398757)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0639\0645\0648\062F \0627\0644\0635\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621443534398757)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0639\0645\0648\062F \0627\0644\0635\0641 \0645\062E\062A\0644\0641\064B\0627 \0639\0646 \0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\0648\0631\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600033615398741)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\0634\062D \0627\0644\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575607132398722)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 %0 \0645\0646 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579650841398725)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0635 \0627\0644\0635\0641 \064A\062D\062A\0648\064A \0639\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555240908398707)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590038183398733)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0645\062D\0641\0648\0638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589900126398733)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631 \0627\0644\0645\062D\0641\0648\0638 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592174286398735)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\064A\062A\0645 \0627\0633\062A\062E\062F\0627\0645 \0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062D\0627\0644\064A \0643\0625\0639\062F\0627\062F\0627\062A \0627\0641\062A\0631\0627\0636\064A\0629 \0644\0643\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110655190847398782)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110579341629398725)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638 \062A\0642\0631\064A\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693830606398812)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638 \0627\0644\062A\0642\0631\064A\0631*')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646518121398776)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110584803008398729)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0631\064A\0637 \0627\0644\0628\062D\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110693782483398812)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652030678398780)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0642\0631\064A\0631 \0627\0644\0628\062D\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636003270398768)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\062D\062F\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556986432398708)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('- \062A\062D\062F\064A\062F \0639\0645\0648\062F -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578602832398725)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0623\0639\0645\062F\0629')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560438706398711)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('- \062A\062D\062F\064A\062F \0648\0638\064A\0641\0629 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585664839398730)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('- \062A\062D\062F\064A\062F \0639\0645\0648\062F \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620361211398756)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('- \062A\062D\062F\064A\062F \0639\0645\0648\062F \0645\062D\0648\0631\064A -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671540613398795)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620441378398756)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('- \062A\062D\062F\064A\062F \0639\0645\0648\062F \0635\0641 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529131553398687)
,p_name=>'APEXIR_SEND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535497116398692)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0631\0633\0627\0644 \0643\0628\0631\064A\062F \0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555645883398707)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0633\0644\0633\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578827024398725)
,p_name=>'APEXIR_SORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588160680398732)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062A\0635\0627\0639\062F\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588271998398732)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062A\0646\0627\0632\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674050262398797)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0631\062A\064A\0628 \0627\0644\0641\0631\0632')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582692490398728)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\0627\0641\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593794606398736)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0627\0644\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644285716398774)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0634\062A\0631\0627\0643')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670965247398794)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0647\0627\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525356771398684)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\062E\0637\064A \0641\064A \062D\0627\0644\0629 \0639\062F\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0644\0628\064A\0627\0646\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110670888013398794)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062F\0627\064A\0629 \0645\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671776459398795)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062C\0645\0648\0639 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661738193398787)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0646\0637\0642\0629 = %0\060C \0627\0644\062A\0642\0631\064A\0631 = %1\060C \0637\0631\064A\0642\0629 \0627\0644\0639\0631\0636 = %2\060C \0628\062F\0627\064A\0629 \0627\0644\0635\0641\0648\0641 \0627\0644\0645\0639\0631\0648\0636\0629 = %3\060C \0646\0647\0627\064A\0629 \0627\0644\0635\0641\0648\0641 \0627\0644\0645\0639\0631\0648\0636\0629 = %4\060C \0625\062C\0645\0627\0644\064A \0627\0644\0635\0641\0648\0641 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582320614398727)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0646\0637\0642\0629 = %0\060C \0627\0644\062A\0642\0631\064A\0631 = %1\060C \0627\0644\0639\0631\0636 = %2\060C \0628\062F\0627\064A\0629 \0627\0644\0635\0641\0648\0641 \0627\0644\0645\0639\0631\0648\0636\0629 = %3\060C \0646\0647\0627\064A\0629 \0627\0644\0635\0641\0648\0641 \0627\0644\0645\0639\0631\0648\0636\0629 = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554512435398706)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0648\0646 \0627\0644\0646\0635')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571613214398719)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\064A\0627\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571520146398719)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0627\0639\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571423727398719)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0642\0627\0626\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571800448398719)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0647\0648\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571716563398719)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0627\0628\064A\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110571966172398719)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0646\0648\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110674489497398797)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631/\0625\062E\0641\0627\0621')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587489739398731)
,p_name=>'APEXIR_TOP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0639\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667663137398792)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \063A\064A\0631 \0645\062C\0645\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588901022398732)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0627\0633\0645 \0627\0644\062A\0645\064A\064A\0632 \0641\0631\064A\062F\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559282505398710)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A \063A\064A\0631 \0645\062F\0639\0648\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587508388398731)
,p_name=>'APEXIR_UP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0623\0639\0644\0649')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589127508398732)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0625\062F\062E\0627\0644 \0644\0648\0646 \0635\0627\0644\062D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589251533398733)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0625\062F\062E\0627\0644 \0642\0646\0627\0639 \0635\064A\063A\0629 \0635\0627\0644\062D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110556440674398708)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110588073636398732)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0627\0644\0645\062D\0648\0631 \0644\0644\0642\064A\0645\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595815566398737)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645\0629 \0645\0637\0644\0648\0628\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559859217398711)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0631\0623\0633\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110663554914398789)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0623\0633\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595173890398737)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650386418398779)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\062A\0641\0627\0635\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110695922334398814)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062D\062A\0648\064A \0627\0644\062A\0642\0631\064A\0631 \0639\0644\0649 \0637\0631\064A\0642\0629 \0639\0631\0636 %0 \0645\0639\0631\0641\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650471692398779)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\062A\062C\0645\064A\0639 \062D\0633\0628')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650244622398779)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\0623\064A\0642\0648\0646\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620157224398756)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\062C\062F\0648\0644 \0627\0644\0645\062D\0648\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110595225880398737)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644430287398774)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0628\0648\0639\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578137195398724)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0642\0631\064A\0631 \0627\0644\0639\0645\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673152714398796)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\064A\0627\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673012999398796)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110672987092398796)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673306765398796)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0634\0647\0648\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673236667398796)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110673493076398796)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110671153598398795)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0646\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110554299186398706)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0635\0641\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110555787093398707)
,p_name=>'APEXIR_YES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0639\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110587857598398732)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A %0 \0639\0644\0649 < or > \0648\0647\0648 \062D\0631\0641 \063A\064A\0631 \0635\0627\0644\062D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110610604887398749)
,p_name=>'APEX_REGION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0637\0642\0629')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110538802419398695)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062E\0631\0642 \0627\0644\0634\0631\0648\0637 \0627\0644\0645\0633\0628\0642\0629 \0644\0648\0627\062C\0647\0629 \0628\0631\0645\062C\0629 \0627\0644\062A\0637\0628\064A\0642\0627\062A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558311576398709)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0627\0644\062D\0635\0648\0644 \0639\0644\0649 \0642\064A\0645\0629 \0625\0639\062F\0627\062F \0627\0644\062A\0637\0628\064A\0642 %0 \0644\0623\0646 \062E\064A\0627\0631 \0627\0644\062A\0643\0648\064A\0646 \0627\0644\0645\0631\062A\0628\0637 \0645\0639\0637\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558261229398709)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \062A\0639\064A\064A\0646 \0642\064A\0645\0629 \0625\0639\062F\0627\062F \0627\0644\062A\0637\0628\064A\0642 %0 \0644\0623\0646 \062E\064A\0627\0631 \0627\0644\062A\0643\0648\064A\0646 \0627\0644\0645\0631\062A\0628\0637 \0645\0639\0637\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665982761398790)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645\0629 \0625\0639\062F\0627\062F \0627\0644\062A\0637\0628\064A\0642 %0 \063A\064A\0631 \0635\0627\0644\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110665811156398790)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\062F\0627\062F \0627\0644\062A\0637\0628\064A\0642 \0627\0644\0645\0637\0644\0648\0628 %0 \063A\064A\0631 \0645\0639\0631\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666095983398790)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \062A\0639\064A\064A\0646 \0625\0639\062F\0627\062F \0627\0644\062A\0637\0628\064A\0642 %0 \0639\0644\0649 \0642\064A\0645\0629 \0641\0627\0631\063A\0629')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546986979398701)
,p_name=>'BACK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0644\062E\0644\0641')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533920913398691)
,p_name=>'BUILDER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0646\0634\0626')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598024078398739)
,p_name=>'BUTTON LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0633\0645\064A\0629 \0627\0644\0632\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533094678398690)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0632\0631 \0641\0626\0627\062A CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562298840398712)
,p_name=>'BUTTON_ID'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0643\0648\0646 \0645\0639\0631\0641 \0627\0644\0632\0631 \0627\0644\0630\064A \062A\0645 \062A\0643\0648\064A\0646\0647 \0627\0644\0645\0639\0631\0641 \0627\0644\062B\0627\0628\062A \0644\0644\0632\0631 \0641\064A \062D\0627\0644\0629 \062A\0639\0631\064A\0641\0647\060C \0623\0648 \0641\064A \062D\0627\0644\0629 \0639\062F\0645 \062A\0639\0631\064A\0641\0647\060C \064A\0643\0648\0646 \0645\0639\0631\0641 \062A\0645 \062A\0643\0648\064A\0646\0647 \062F\0627\062E\0644\064A\064B\0627 \0628\0627\0644\0635\064A\063A\0629 ''B'' || [\0645\0639\0631\0641 \0627\0644\0632\0631 \0627\0644\062F\0627\062E\0644\064A]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525704111398684)
,p_name=>'CANDLESTICK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0645\0648\0639 \0627\0644\064A\0627\0628\0627\0646\064A\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607266911398746)
,p_name=>'CENTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0633\0637')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557228351398708)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0644\0628 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548683588398702)
,p_name=>'CHECK$'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062D\062F\062F \0627\0644\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110667734903398792)
,p_name=>'CHECKED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062D\062F\062F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643212311398773)
,p_name=>'COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603741739398743)
,p_name=>'COMMENTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0644\064A\0642\0627\062A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585236207398730)
,p_name=>'CONTINUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062A\0627\0628\0639\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547261138398701)
,p_name=>'COPYRIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0642\0648\0642 \0627\0644\0646\0634\0631 &copy; %0\060C \062C\0645\064A\0639 \0627\0644\062D\0642\0648\0642 \0645\062D\0641\0648\0638\0629.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590914865398734)
,p_name=>'COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\062F\062F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597646883398739)
,p_name=>'CREATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0643\0648\064A\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649958835398778)
,p_name=>'CREATED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062A\0643\0648\064A\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650033226398778)
,p_name=>'CREATED_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062A\0643\0648\064A\0646 \0628\0648\0627\0633\0637\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574827794398722)
,p_name=>'CREATED_ON'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062A\0643\0648\064A\0646 \0641\064A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585479870398730)
,p_name=>'CUSTOM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062E\0635\0635')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596694664398738)
,p_name=>'CUSTOMIZE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062E\0635\064A\0635')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598257682398739)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \062A\0641\0636\064A\0644\0627\062A \0627\0644\0635\0641\062D\0629 \0644\0644\0645\0633\062A\062E\062F\0645 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598367036398739)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\063A\064A\064A\0631 \0627\0644\062A\0641\0636\064A\0644\0627\062A \0644\0644\0645\0633\062A\062E\062F\0645 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598180715398739)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \062A\0641\0636\064A\0644\0627\062A \0627\0644\0635\0641\062D\0629 \0644\0644\0645\0633\062A\062E\062F\0645 %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561953478398712)
,p_name=>'DAILY'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\0645\064A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110533566676398690)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0644\0641 \0627\0644\0630\064A \062A\0645 \062A\062D\0645\064A\0644\0647 \063A\064A\0631 \0635\0627\0644\062D \0623\0648 \0644\0647 \0627\0645\062A\062F\0627\062F \062E\0637\0623.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557491541398709)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0633\062A\062E\062F\0627\0645 \0645\062D\062F\062F XML \0623\0648JSON \063A\064A\0631 \0635\0627\0644\062D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526775873398685)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062D\062A\0648\064A \0645\0644\0641 \062A\0639\0631\064A\0641 \0627\0644\0628\064A\0627\0646\0627\062A \0648\0627\0644\0645\0644\0641 \0627\0644\0630\064A \062A\0645 \062A\062D\0645\064A\0644\0647 \0639\0644\0649 \0623\064A \0639\0645\0648\062F \062C\062F\0648\0644 \0647\062F\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612420920398750)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0628\064A\0627\0646\0627\062A \0641\064A \0627\0644\0645\0644\0641 \0627\0644\0630\064A \062A\0645 \062A\062D\0645\064A\0644\0647.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612579097398750)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0628\064A\0627\0646\0627\062A \0641\064A \0648\0631\0642\0629 \0627\0644\0639\0645\0644 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110532346426398689)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0644\0641 \0627\0644\0645\062D\062F\062F \0644\064A\0633 \0645\0644\0641 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110522718304398681)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\0649 \062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A: \062A\0645\062A \0645\0639\0627\0644\062C\0629 %0 \0645\0646 \0627\0644\0635\0641\0648\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523974562398682)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\0649 \062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A: \062A\0645\062A \0645\0639\0627\0644\062C\0629 %0 \0645\0646 \0627\0644\0635\0641\0648\0641 \0648\064A\0648\062C\062F \062E\0637\0623 \0648\0627\062D\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524232509398683)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\0649 \062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A: \062A\0645\062A \0645\0639\0627\0644\062C\0629 %0 \0645\0646 \0627\0644\0635\0641\0648\0641 \0648\064A\0648\062C\062F %1 \0645\0646 \0627\0644\0623\062E\0637\0627\0621.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524098378398682)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\0649 \062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A: \062A\0645\062A \0645\0639\0627\0644\062C\0629 \0635\0641 \0648\0627\062D\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527096487398685)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\0649 \062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A: \062A\0645\062A \0645\0639\0627\0644\062C\0629 \0635\0641 \0648\0627\062D\062F \0628\0648\062C\0648\062F \0623\062E\0637\0627\0621.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524193391398683)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\0649 \062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A: \062A\0645\062A \0645\0639\0627\0644\062C\0629 \0635\0641 \0648\0627\062D\062F \0628\062F\0648\0646 \0623\062E\0637\0627\0621.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617737581398754)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0627\0644\0647\062F\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617860275398754)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0627\0644\0645\0635\062F\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618696711398755)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\064A\063A\0629 \0627\0644\0631\0642\0645/\0627\0644\062A\0627\0631\064A\062E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682069018398803)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0634\0644\062A \0627\0633\062A\0639\0627\062F\0629 \0642\064A\0645\0629 \0627\0644\0628\062D\062B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110650511092398779)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062E\0637\064A\0637 \0627\0644\0628\064A\0627\0646\0627\062A/\0627\0644\062C\062F\0648\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618724962398755)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614263336398751)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0634\0644\062A \0642\0627\0639\062F\0629 \0627\0644\062A\062D\0648\064A\0644')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590594161398734)
,p_name=>'DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0631\064A\062E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564657910398714)
,p_name=>'DAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564796619398714)
,p_name=>'DAYS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\064A\0627\0645')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603416868398743)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0635\062D\064A\062D \0627\0644\0623\062E\0637\0627\0621 \063A\064A\0631 \0645\0645\0643\0646 \0641\064A \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110652250592398780)
,p_name=>'DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0641\062A\0631\0627\0636\064A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565426258398715)
,p_name=>'DELETE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0630\0641')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110525681108398684)
,p_name=>'DIAL_PCT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\0631\0635 (\0627\0644\0646\0633\0628\0629 \0627\0644\0645\0626\0648\064A\0629)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540196854398696)
,p_name=>'DOWNLOAD'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0646\0632\064A\0644')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651361941398779)
,p_name=>'DUP_USER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0645\0633\062A\062E\062F\0645 \0645\062A\0643\0631\0631 \0641\064A \0627\0644\0642\0627\0626\0645\0629.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547707686398701)
,p_name=>'EDIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557122068398708)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542225826398697)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0625\0631\0633\0627\0644 \0647\0630\0627 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A \0628\0648\0627\0633\0637\0629 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651521813398780)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A \0637\0648\064A\0644 \0644\0644\063A\0627\064A\0629. \0627\0644\062D\062F \0647\0648 240 \062D\0631\0641\064B\0627.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585106315398729)
,p_name=>'ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614344405398752)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \062A\0639\064A\064A\0646 \0642\064A\0645\0629 \0645\0635\062F\0631 \0639\0646\0635\0631 \0627\0644\0635\0641\062D\0629 \0644\0645\0646\0637\0642\0629 \0627\0644\062A\062C\062F\064A\062F \0627\0644\062C\0632\0626\064A \0644\0644\0635\0641\062D\0629')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576687963398723)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062A\0643\0648\064A\0646 \0628\0648\0627\0633\0637\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542519150398698)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0647\062A \0635\0644\0627\062D\064A\0629 \0643\0644\0645\0629 \0627\0644\0633\0631')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110536620691398693)
,p_name=>'FILE_EMPTY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0644\0641 \0641\0627\0631\063A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616888841398753)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0632\0627\062F \062D\062C\0645 \0627\0644\0645\0644\0641 \0627\0644\0630\064A \062A\0645 \062A\062D\0645\064A\0644\0647 \0639\0646 %0 \0645\064A\063A\0627\0628\0627\064A\062A. \0627\0644\0631\062C\0627\0621 \062A\062D\0645\064A\0644 \0645\0644\0641 \0623\0635\063A\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544681332398699)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0634\0644 \0627\0644\062A\0635\062F\064A\0642 \0639\0644\0649 \0627\0644\0645\0633\062A\062E\062F\0645 \0648\0644\0645 \064A\062A\0645 \062A\062D\0645\064A\0644 \0645\0644\0641 \0623\0648 \0623\0643\062B\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544785320398699)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062A\064A\062D \0647\0630\0627 \0627\0644\0645\062B\064A\0644 \0644\0644\0645\0633\062A\062E\062F\0645\064A\0646 \063A\064A\0631 \0627\0644\0645\0635\062F\0642\064A\0646 \0628\062A\062D\0645\064A\0644 \0627\0644\0645\0644\0641\0627\062A.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597758735398739)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0648\0627\062D\062F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596955081398738)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B\062A %0 \0645\0646 \0627\0644\0623\062E\0637\0627\0621')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547192027398701)
,p_name=>'FORM_OF'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0645\0646 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581855563398727)
,p_name=>'GO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0646\062A\0642\0627\0644 \0625\0644\0649')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681612953398803)
,p_name=>'HELP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0644\064A\0645\0627\062A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534064696398691)
,p_name=>'HOME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641\062D\0629 \0627\0644\0631\0626\064A\0633\064A\0629')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564450421398714)
,p_name=>'HOUR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0627\0639\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564530441398714)
,p_name=>'HOURS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0627\0639\0627\062A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548507047398702)
,p_name=>'ICON'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0623\064A\0642\0648\0646\0629 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598501543398739)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0627\0646\0627\062A \0635\0644\0627\062D\064A\0629 \062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644 \063A\064A\0631 \0635\0627\0644\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110698028999398815)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645\0629 \063A\064A\0631 \0635\0627\0644\062D\0629 \0644\0644\0645\0639\0644\0645\0629: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593254890398736)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0625\0639\062F\0627\062F\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593393045398736)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\062A\0642\0631\064A\0631 \0645\0639\064A\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575774687398722)
,p_name=>'IR_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623 %0. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575493050398722)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \062D\0633\0627\0628 \062A\0646\0642\0644 \0627\0644\0646\0645\0648\0630\062C. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553024850398705)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0644\062A\0642\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552464940398705)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0637\0642\0629 \0627\0644\062A\0642\0631\064A\0631 \063A\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A \0644\064A\0633\062A \0645\0648\062C\0648\062F\0629 \0641\064A \0627\0644\062A\0637\0628\064A\0642 %0 \0648\0627\0644\0635\0641\062D\0629 %1 \0648\0627\0644\0645\0646\0637\0642\0629 %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110593146411398735)
,p_name=>'IR_STAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0638\0647\0631 \0644\0644\0645\0637\0648\0631\064A\0646 \0641\0642\0637')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581589856398727)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0627\062C \0627\0633\062A\0639\0644\0627\0645 \0627\0644\062A\0642\0631\064A\0631 \0625\0644\0649 \0645\0641\062A\0627\062D \0641\0631\064A\062F \0644\062A\0639\0631\064A\0641 \0643\0644 \0635\0641. \0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 \0627\0644\0645\0641\062A\0627\062D \0627\0644\0645\0642\062F\0645 \0628\0647\0630\0627 \0627\0644\0627\0633\062A\0639\0644\0627\0645. \0627\0644\0631\062C\0627\0621 \062A\0639\0631\064A\0641 \0639\0645\0648\062F \0645\0641\062A\0627\062D \0641\0631\064A\062F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581633486398727)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0627\062C \0627\0633\062A\0639\0644\0627\0645 \0627\0644\062A\0642\0631\064A\0631 \0625\0644\0649 \0645\0641\062A\0627\062D \0641\0631\064A\062F \0644\062A\0639\0631\064A\0641 \0643\0644 \0635\0641. \0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 \0627\0644\0645\0641\062A\0627\062D \0627\0644\0645\0642\062F\0645 \0628\0647\0630\0627 \0627\0644\0627\0633\062A\0639\0644\0627\0645. \0627\0644\0631\062C\0627\0621 \062A\062D\0631\064A\0631 \0633\0645\0627\062A \0627\0644\062A\0642\0631\064A\0631 \0644\062A\0639\0631\064A\0641 \0639\0645\0648\062F \0645\0641\062A\0627\062D \0641\0631\064A\062F. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618923103398755)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\062E\062A\064A\0627\0631 \0645\0644\0641')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618807576398755)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\062D\0628 \0627\0644\0645\0644\0641\0627\062A \0648\0625\0641\0644\0627\062A\0647\0627 \0647\0646\0627 \0623\0648')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547463072398701)
,p_name=>'ITEMS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0627\0635\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576877646398723)
,p_name=>'ITEM_VALUE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645\0629 \0627\0644\0639\0646\0635\0631')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591225920398734)
,p_name=>'LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0633\0645\064A\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603390066398743)
,p_name=>'LANGUAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0644\063A\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565197715398714)
,p_name=>'LAST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\062E\064A\0631')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544560016398699)
,p_name=>'LENGTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0637\0648\0644')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597894712398739)
,p_name=>'LOGIN'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636488433398768)
,p_name=>'MANAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062F\0627\0631\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701063437398818)
,p_name=>'MAXIMIZE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0643\0628\064A\0631')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564210114398714)
,p_name=>'MINUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0642\064A\0642\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564305681398714)
,p_name=>'MINUTES'
,p_message_language=>'ar'
,p_message_text=>unistr('\062F\0642\0627\0626\0642')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651783217398780)
,p_name=>'MISSING_AT'
,p_message_language=>'ar'
,p_message_text=>unistr('"@" \063A\064A\0631 \0645\0648\062C\0648\062F \0641\064A \0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651979272398780)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0630\064A\0631: \0644\0645 \064A\062A\0645 \062A\0639\0631\064A\0641 \0642\0627\0644\0628 \0635\0641\062D\0629 \0645\0631\0628\0639 \062D\0648\0627\0631 \0644\0635\0641\062D\0629 \0645\0631\0628\0639 \0627\0644\062D\0648\0627\0631 %0 \0641\064A \0627\0644\062A\0637\0628\064A\0642 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651670851398780)
,p_name=>'MISSING_DOT'
,p_message_language=>'ar'
,p_message_text=>unistr('"." \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0641\064A \0645\062C\0627\0644 \0639\0646\0648\0627\0646 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600859510398741)
,p_name=>'MODULE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\062D\062F\0629 \0627\0644\0646\0645\0637\064A\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557906673398709)
,p_name=>'MONTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561758917398712)
,p_name=>'MONTHLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0634\0647\0631\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558088057398709)
,p_name=>'MONTHS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0647\0648\0631')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590894592398734)
,p_name=>'MOVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658327186398785)
,p_name=>'MOVE_FROM'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644 \0645\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658411903398785)
,p_name=>'MOVE_TO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0642\0644 \0625\0644\0649')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110578019599398724)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0641\064A \0639\0645\0644\064A\0629 \062D\0630\0641 \0639\062F\0629 \0635\0641\0648\0641: \0627\0644\0635\0641= %0\060C %1\060C %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577089167398723)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0644\0627 \064A\0643\0648\0646 \0645\0633\062A\062E\062F\0645 \0639\0627\0645')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534297647398691)
,p_name=>'NAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0633\0645')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591061860398734)
,p_name=>'NEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\062F\064A\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557794430398709)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646\0643 \062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644 \0625\0644\0649 %0 \0645\0646 \062E\0644\0627\0644 \0627\0644\0627\0646\062A\0642\0627\0644 \0625\0644\0649:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557887171398709)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062E\0637\0627\0631 \062D\0633\0627\0628 %0 \062C\062F\064A\062F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681887435398803)
,p_name=>'NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600763360398741)
,p_name=>'NO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110696098239398814)
,p_name=>'NOBODY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \0623\062D\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565599501398715)
,p_name=>'NOT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606340926398745)
,p_name=>'NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \062E\0627\0644\064D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577165162398723)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\064A\0633 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596740522398738)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0628\064A\0627\0646\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605867880398745)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \062A\0642\0631\064A\0631 \0642\0627\0628\0644 \0644\0644\062A\062D\062F\064A\062B. \062A\0645 \062A\062D\062F\064A\062B \0639\062F\0629 \0635\0641\0648\0641 \0648\0644\0627 \064A\0645\0643\0646 \062A\0646\0641\064A\0630 \0639\0645\0644\064A\0627\062A \0627\0644\062D\0630\0641 \0625\0644\0627 \0639\0644\0649 \0627\0644\0646\0645\0627\0630\062C \0627\0644\062C\062F\0648\0644\064A\0629 \0645\0646 \0627\0644\0646\0648\0639 "\062A\0642\0631\064A\0631 \0642\0627\0628\0644 \0644\0644\062A\062D\062F\064A\062B".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606785357398746)
,p_name=>'OK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0648\0627\0641\0642')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602484235398743)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'ar'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110699897493398817)
,p_name=>'ORA_06550'
,p_message_language=>'ar'
,p_message_text=>unistr('ORA-06550: \0627\0644\0633\0637\0631 %0\060C \0627\0644\0639\0645\0648\062F %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649378321398778)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0646\062A \062A\0633\062A\062E\062F\0645 \0645\0633\062A\0639\0631\0636 \0648\064A\0628 \0642\062F\064A\0645\064B\0627. \0644\0644\062D\0635\0648\0644 \0639\0644\0649 \0642\0627\0626\0645\0629 \0628\0627\0644\0645\0633\062A\0639\0631\0636\0627\062A \0627\0644\0645\062F\0639\0648\0645\0629\060C \0627\0637\0644\0639 \0639\0644\0649 \062F\0644\064A\0644 \062A\062B\0628\064A\062A Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550792536398704)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0637\0644\0628 \0645\062C\0645\0648\0639\0629 \063A\064A\0631 \0635\0627\0644\062D\0629 \0645\0646 \0627\0644\0635\0641\0648\0641\060C \062A\0645 \062A\0639\062F\064A\0644 \0628\064A\0627\0646\0627\062A \0645\0635\062F\0631 \0627\0644\062A\0642\0631\064A\0631.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570803937398719)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0631\0642\0645 \0635\0641\062D\0629 \0635\0627\0644\062D\060C \0639\0644\0649 \0633\0628\064A\0644 \0627\0644\0645\062B\0627\0644 p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574423800398721)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0627\0644\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574537473398721)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062C\0645\0648\0639\0629 \0627\0644\062A\0627\0644\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574650505398721)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110574779037398721)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\062C\0645\0648\0639\0629 \0627\0644\0633\0627\0628\0642\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681779409398803)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0627\0644\062A\0642\0633\064A\0645 \0625\0644\0649 \0635\0641\062D\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612373042398750)
,p_name=>'PASSWORD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557051682398708)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\063A\064A\064A\0631 \0643\0644\0645\0629 \0645\0631\0648\0631 %0 \0627\0644\062E\0627\0635\0629 \0628\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546800696398701)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \062A\062A\0648\0627\0641\0642 \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0645\0639 \0642\0648\0627\0639\062F \0627\0644\062A\0631\0643\064A\0628 \0641\064A \0647\0630\0627 \0627\0644\0645\0648\0642\0639.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545997618398700)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\062E\062A\0644\0641 \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0627\0644\062C\062F\064A\062F\0629 \0639\0646 \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0627\0644\0642\062F\064A\0645\0629 \0628\0640 %0 \0645\0646 \0627\0644\062D\0631\0648\0641 \0639\0644\0649 \0627\0644\0623\0642\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546546558398700)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0644\0627 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546797451398701)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \0643\0644\0645\0629 \0628\0633\064A\0637\0629 \0645\062D\0638\0648\0631\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546699570398701)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0644\0627 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \0627\0633\0645 \0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545835719398700)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 %0 \0645\0646 \0627\0644\062D\0631\0648\0641 \0639\0644\0649 \0627\0644\0623\0642\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546036445398700)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \062D\0631\0641 \0623\0628\062C\062F\064A \0648\0627\062D\062F \0639\0644\0649 \0627\0644\0623\0642\0644 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546426228398700)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \062D\0631\0641 \0635\063A\064A\0631 \0648\0627\062D\062F \0639\0644\0649 \0627\0644\0623\0642\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546199043398700)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \062D\0631\0641 \0631\0642\0645\064A \0648\0627\062D\062F \0639\0644\0649 \0627\0644\0623\0642\0644 (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546223698398700)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \062D\0631\0641 \062A\0631\0642\064A\0645 \0648\0627\062D\062F \0639\0644\0649 \0627\0644\0623\0642\0644 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110546349245398700)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\062D\062A\0648\064A \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0639\0644\0649 \062D\0631\0641 \0643\0628\064A\0631 \0648\0627\062D\062F \0639\0644\0649 \0627\0644\0623\0642\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557516108398709)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062E\0637\0627\0631 \0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544805104398699)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 \0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0644\0623\0646\0647 \062A\0645 \0627\0633\062A\062E\062F\0627\0645\0647\0627 \062E\0644\0627\0644 %0 \0645\0646 \0627\0644\0623\064A\0627\0645 \0627\0644\0633\0627\0628\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625154113398760)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0627\0635\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110625209594398760)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0635\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602226910398742)
,p_name=>'PERCENT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\0633\0628\0629 \0627\0644\0645\0626\0648\064A\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572539443398720)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0631\062C\0627\0621 \0627\0644\0627\062A\0635\0627\0644 \0628\0627\0644\0645\0633\0624\0648\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110681970474398803)
,p_name=>'PREVIOUS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0627\0628\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617374317398754)
,p_name=>'PRINT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0628\0627\0639\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601095651398741)
,p_name=>'PRIVILEGES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0645\062A\064A\0627\0632\0627\062A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570921974398719)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\062C\0639 \0627\0644\0645\0646\0637\0642\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591115779398734)
,p_name=>'REPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600983678398741)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\062A\0631\0629 \0627\0644\062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682125405398803)
,p_name=>'REPORT_LABEL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0642\0631\064A\0631: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601614421398742)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\062C\0645\0627\0644\064A \0627\0644\062A\0642\0631\064A\0631')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550810108398704)
,p_name=>'RESET'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0627\0644\062A\0642\0633\064A\0645 \0625\0644\0649 \0635\0641\062D\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576761470398723)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0627\0644\062A\0642\0633\064A\0645 \0625\0644\0649 \0635\0641\062D\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605766625398745)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0639\0627\062F\0629 \062A\0639\064A\064A\0646 \0643\0644\0645\0629 \0627\0644\0633\0631')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582544431398728)
,p_name=>'RESTORE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\0639\0627\062F\0629')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110614495868398752)
,p_name=>'RESULTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0646\062A\0627\0626\062C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606800282398746)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\062C\0648\0639 \0644\0644\062A\0637\0628\064A\0642.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110607185235398746)
,p_name=>'RIGHT'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\064A\0646')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636731698398768)
,p_name=>'ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590748717398734)
,p_name=>'ROW_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\062F \0627\0644\0635\0641\0648\0641')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110606246730398745)
,p_name=>'SAVE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\0641\0638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602885301398743)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0628\062F\064A\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603279410398743)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0635\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602719137398743)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0641\062A\0631\0627\0636\064A \0627\0644\0623\0633\0627\0633\064A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603583951398743)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\0648\0641\0631 \0623\0643\062B\0631 \0645\0646 %0 \0645\0646 \0627\0644\0635\0641\0648\0641. \0642\0645 \0628\0632\064A\0627\062F\0629 \0645\062D\062F\062F \0627\0644\0635\0641\0648\0641 \0644\0639\0631\0636 \0627\0644\0645\0632\064A\062F \0645\0646 \0627\0644\0635\0641\0648\0641.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668910045398793)
,p_name=>'SEARCH'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\062D\062B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564194469398714)
,p_name=>'SECONDS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062B\0648\0627\0646\064D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602373514398742)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0637\0644\0627\0639 \0639\0644\0649 \0627\0644\0645\0631\0641\0642')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660087760398786)
,p_name=>'SELECT_ROW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062F \0635\0641')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602005801398742)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\064A\064A\0646 \0648\0636\0639 \0642\0627\0631\0626 \0627\0644\0634\0627\0634\0629 \0639\0644\0649 \0625\064A\0642\0627\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602136007398742)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\064A\064A\0646 \0648\0636\0639 \0642\0627\0631\0626 \0627\0644\0634\0627\0634\0629 \0639\0644\0649 \062A\0634\063A\064A\0644')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598465202398739)
,p_name=>'SHOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661804190398787)
,p_name=>'SHOW_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0638\0647\0627\0631 \0627\0644\0643\0644')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110687954609398808)
,p_name=>'SIGN_IN'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0633\062C\064A\0644 \0627\0644\062F\062E\0648\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110637519598398769)
,p_name=>'SIGN_OUT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0633\062C\064A\0644 \0627\0644\062E\0631\0648\062C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591702650398734)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0623\064A\0627\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598946877398740)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0623\064A\0627\0645')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591613485398734)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598826271398740)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0633\0627\0639\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591587168398734)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598741045398740)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\062F\0642\0627\0626\0642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591926747398735)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0634\0647\0648\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599109907398740)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0634\0647\0648\0631')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599309304398740)
,p_name=>'SINCE_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0622\0646')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591407139398734)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\062B\0648\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110598633737398740)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\062B\0648\0627\0646\064A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110591880765398734)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599067452398740)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0623\0633\0627\0628\064A\0639')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110592080427398735)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599266097398740)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0646\0630 %0 \0645\0646 \0627\0644\0633\0646\0648\0627\062A')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585581780398730)
,p_name=>'STANDARD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0627\0633\064A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601949273398742)
,p_name=>'START_DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0627\0631\064A\062E \0627\0644\0628\062F\0627\064A\0629')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542436366398697)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062A\0644\0642\0649 \0631\0633\0627\0644\0629 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A \0647\0630\0647 \0645\0646 \0627\0634\062A\0631\0627\0643 \0627\0644\062A\0642\0627\0631\064A\0631 \0627\0644\062A\0641\0627\0639\0644\064A\0629 \0627\0644\0630\064A \062A\0645 \0625\0646\0634\0627\0624\0647 \0628\0648\0627\0633\0637\0629 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697149102398815)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0634\062A\0631\0627\0643\0627\062A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645270578398775)
,p_name=>'TAB'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0644\0627\0645\0629 \0627\0644\062A\0628\0648\064A\0628')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564098786398714)
,p_name=>'TITLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0648\0627\0646')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547001247398701)
,p_name=>'TODAY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\064A\0648\0645')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601504623398742)
,p_name=>'TOTAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0625\062C\0645\0627\0644\064A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548025476398702)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646 \062A\062D\062F\064A\062F %0 \0645\0646 \0627\0644\0623\0639\0645\062F\0629 \0628\062D\062F \0623\0642\0635\0649.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526584783398685)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\064A \0627\0644\0643\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526833978398685)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\064A \0627\0644\0643\0644 \0623\062F\0646\0627\0647')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526401207398684)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\0633\064A\0639 \0627\0644\0643\0644')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526629946398685)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0648\0633\064A\0639 \0627\0644\0643\0644 \0623\062F\0646\0627\0647')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526963951398685)
,p_name=>'TREE.REPARENT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0639\0648\064A\0636')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619146518398755)
,p_name=>'TREES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0634\0628\0643\0627\062A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110662665808398788)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0637\0644\0648\0628')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110586298486398730)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0645\0635\062F\0642')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110633098024398765)
,p_name=>'UNAVAILABLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0645\062A\0627\062D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599711916398740)
,p_name=>'UNKNOWN'
,p_message_language=>'ar'
,p_message_text=>unistr('\063A\064A\0631 \0645\0639\0631\0648\0641')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543342989398698)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0645\0635\0627\062F\0642\0629 \063A\064A\0631 \0645\0639\0631\0648\0641.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545346771398700)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0630\0627 \0644\0645 \062A\0639\062F \062A\0631\064A\062F \0627\0633\062A\0644\0627\0645 \0631\0633\0627\0626\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A\060C \0641\0627\0644\0631\062C\0627\0621 \0627\0644\0646\0642\0631 \0639\0644\0649 <a href="%0">\0625\0644\063A\0627\0621 \0627\0644\0627\0634\062A\0631\0627\0643</a> \0644\0625\062F\0627\0631\0629 \0627\0634\062A\0631\0627\0643\0643.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110542326954398697)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\0630\0627 \0644\0645 \062A\0639\062F \062A\0631\064A\062F \0627\0633\062A\0644\0627\0645 \0631\0633\0627\0626\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A\060C \0641\0627\0644\0631\062C\0627\0621 \0627\0644\0630\0647\0627\0628 \0625\0644\0649 \0631\0627\0628\0637 URL \0627\0644\062A\0627\0644\064A \0644\0625\062F\0627\0631\0629 \0627\0634\062A\0631\0627\0643\0643:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110577233285398723)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A \063A\064A\0631 \0645\062F\0639\0648\0645')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565359769398715)
,p_name=>'UPDATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563931779398714)
,p_name=>'UPDATED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\062A\062D\062F\064A\062B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570635283398718)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062D\0638\0631 \0631\0627\0628\0637 URL \0627\0644\0645\0637\0644\0648\0628. \0627\062A\0635\0644 \0628\0627\0644\0645\0633\0624\0648\0644 \0644\062F\064A\0643.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110590632904398734)
,p_name=>'USER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0633\062A\062E\062F\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110612250730398750)
,p_name=>'USERNAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651897075398780)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645 \0637\0648\064A\0644 \0644\0644\063A\0627\064A\0629. \0627\0644\062D\062F \0647\0648 %0 \0645\0646 \0627\0644\062D\0631\0648\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597459550398739)
,p_name=>'USERS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0645\0633\062A\062E\062F\0645\0648\0646')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110651400500398779)
,p_name=>'USER_EXISTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645 \0645\0648\062C\0648\062F \0628\0627\0644\0641\0639\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110666167521398790)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0648\0631\0629 \0645\0644\0641 \062A\0639\0631\064A\0641 \0627\0644\0645\0633\062A\062E\062F\0645 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553757978398706)
,p_name=>'VALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\0627\0644\062D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547383801398701)
,p_name=>'VALIDATIONS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0644\064A\0627\062A \0627\0644\062A\062F\0642\064A\0642')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603076150398743)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0627\0644\0642\064A\0645\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646434157398776)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0642\064A\0645\0629 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572973278398720)
,p_name=>'VERTICAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0623\0633\064A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565250066398714)
,p_name=>'VIEW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597552393398739)
,p_name=>'VIEWS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0637\0631\0642 \0627\0644\0639\0631\0636')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603836511398744)
,p_name=>'VIEW_ALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\0643\0644')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110585013047398729)
,p_name=>'WARNING'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0630\064A\0631')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564825045398714)
,p_name=>'WEEK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0628\0648\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561845905398712)
,p_name=>'WEEKLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0628\0648\0639\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110564916504398714)
,p_name=>'WEEKS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0633\0627\0628\064A\0639')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110603189972398743)
,p_name=>'WELCOME_USER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\062D\0628\064B\0627: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601348653398742)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0642\064A\0645\0629 \063A\064A\0631 \0635\0627\0644\062D\0629\060C \0627\0644\0631\062C\0627\0621 \0627\0644\062A\062D\0642\0642 \0645\0646 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0645\0642\062F\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601414825398742)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0642\064A\0645\0629 \063A\064A\0631 \0635\0627\0644\062D\0629\060C \0627\0644\0631\062C\0627\0621 \0627\0644\062A\062D\0642\0642 \0645\0646 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0645\0642\062F\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544424309398699)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0642\064A\0645\0629 \0628\064A\0627\0646\0627\062A \063A\064A\0631 \0635\0627\0644\062D\0629\060C \0627\0644\0631\062C\0627\0621 \0627\0644\062A\062D\0642\0642 \0645\0646 \0635\064A\063A\0629 \0627\0644\062A\0627\0631\064A\062E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110601236211398742)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0642\064A\0645\0629 \0631\0642\0645\064A\0629 \063A\064A\0631 \0635\0627\0644\062D\0629\060C \0627\0644\0631\062C\0627\0621 \0627\0644\062A\062D\0642\0642 \0645\0646 \0627\0644\0635\064A\063A\0629 \0627\0644\0631\0642\0645\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553367157398705)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0642\064A\0645\0629 \0637\0627\0628\0639 \0632\0645\0646\064A \063A\064A\0631 \0635\0627\0644\062D\0629\060C \0627\0644\0631\062C\0627\0621 \0627\0644\062A\062D\0642\0642 \0645\0646 \0635\064A\063A\0629 \0627\0644\0637\0627\0628\0639 \0627\0644\0632\0645\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110575801001398722)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0631\0628\0637 "%0". \0627\0633\062A\062E\062F\0645 \0639\0644\0627\0645\0627\062A \0627\0644\0627\0642\062A\0628\0627\0633 \0627\0644\0645\0632\062F\0648\062C\0629 \0644\0644\0639\0646\0627\0635\0631 \0648\062D\062F\0627\062A \0628\0627\064A\062A \0645\062A\0639\062F\062F\0629\060C \0623\0648 \062A\062D\0642\0642 \0645\0646 \0623\0646 \0637\0648\0644 \0627\0644\0639\0646\0635\0631 30 \0628\0627\064A\062A \0623\0648 \0623\0642\0644. \0627\0633\062A\062E\062F\0645 \0635\064A\0627\063A\0629 v() \0644\0644\0625\0634\0627\0631\0629 \0625\0644\0649 \0627\0644\0639\0646\0627\0635\0631 \0627\0644\0623\0637\0648\0644 \0645\0646 30 \0628\0627\064A\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566323831398715)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0631\0641\0636 \0627\0644\0648\0635\0648\0644 \0628\0648\0627\0633\0637\0629 \0627\0644\0641\062D\0635 \0627\0644\0623\0645\0646\064A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568859198398717)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0637\0628\064A\0642 \063A\064A\0631 \0645\062A\0648\0641\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567283073398716)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1014 \0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0644\062A\0637\0628\064A\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567366744398716)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062A\0637\0628\064A\0642=%0 \0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567749993398716)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642 \0645\062D\0638\0648\0631\060C \0627\0644\0631\062C\0627\0621 \0625\0639\0627\062F\0629 \0627\0644\0645\062D\0627\0648\0644\0629 \0644\0627\062D\0642\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567620297398716)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0648\0635\0648\0644 \0625\0644\0649 \0647\0630\0627 \0627\0644\062A\0637\0628\064A\0642 \0645\062D\0638\0648\0631 \0644\0645\0637\0648\0631\064A \0627\0644\062A\0637\0628\064A\0642\060C \0627\0644\0631\062C\0627\0621 \0625\0639\0627\062F\0629 \0627\0644\0645\062D\0627\0648\0644\0629 \0644\0627\062D\0642\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566820149398716)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-7744 \062A\0639\0630\0631\062A \0645\0639\0627\0644\062C\0629 \0631\0627\0628\0637 URL \0639\0648\062F\0629 \0627\0644\0641\0631\0639 \0625\0644\0649 \0627\0644\0648\0638\064A\0641\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566704861398716)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-7744 \062A\0639\0630\0631\062A \0645\0639\0627\0644\062C\0629 \0635\0641\062D\0629 \0639\0648\062F\0629 \0627\0644\0641\0631\0639 \0625\0644\0649 \0627\0644\0648\0638\064A\0641\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567095307398716)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1430 \0639\0645\0644\064A\0629 \0627\0644\0627\0633\062A\062F\0639\0627\0621 \0644\0644\0639\0631\0636 \0645\0646 \0627\0644\0635\0641\062D\0629 \063A\064A\0631 \0645\062F\0639\0648\0645\0629: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568144707398717)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1018 \062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0645\0633\062D \0630\0627\0643\0631\0629 \0627\0644\062A\062E\0632\064A\0646 \0627\0644\0645\0624\0642\062A \0644\0644\062E\0637\0648\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566571817398715)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1005 \0646\0648\0639 \0627\0644\062D\0633\0627\0628 \063A\064A\0631 \0645\0639\0631\0648\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567418625398716)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1201 \0644\0645 \064A\062A\0645 \062A\0639\064A\064A\0646 \0645\0639\0631\0641 \0627\0644\062C\0644\0633\0629 \0641\064A \0627\0644\0645\0635\0627\062F\0642\0629 \0627\0644\0645\062E\0635\0635\0629.-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567514026398716)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641\062D\0629=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110567193559398716)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-7620 \062A\0639\0630\0631 \062A\062D\062F\064A\062F \0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644 \0644\0644\062A\0637\0628\064A\0642 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549564708398703)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566211772398715)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1802 \062A\0639\0630\0631 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0645\0639\0631\0641 \0627\0644\0639\0646\0635\0631 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565934418398715)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1002 \062A\0639\0630\0631 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0645\0639\0631\0641 \0627\0644\0639\0646\0635\0631 \0627\0644\062E\0627\0635 \0628\0627\0644\0639\0646\0635\0631"%0" \0641\064A \0627\0644\062A\0637\0628\064A\0642 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566077068398715)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \063A\064A\0631 \0645\062A\0648\0642\0639\060C \062A\0639\0630\0631 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0633\0645 \0627\0644\0639\0646\0635\0631 \0639\0644\0649 \0645\0633\062A\0648\0649 \0627\0644\0635\0641\062D\0629 \0623\0648 \0627\0644\062A\0637\0628\064A\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566496984398715)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\0646\062A \0628\0627\0644\0641\0639\0644 \0641\064A \0627\0644\0635\0641\062D\0629 \0627\0644\0623\0648\0644\0649 \0645\0646 \0627\0644\0628\064A\0627\0646\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110581977937398727)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0641 \0627\0644\0639\0646\0635\0631 (%0) \0644\064A\0633 \0639\0646\0635\0631\064B\0627 \0645\0639\0631\0641\064B\0627 \0641\064A \0627\0644\0635\0641\062D\0629 \0627\0644\062D\0627\0644\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544040497398699)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \062A\0639\064A\064A\0646 \0627\0644\0639\0646\0635\0631 \0628\0648\0627\0633\0637\0629 \062A\0645\0631\064A\0631 \0627\0644\0648\0633\064A\0637\0627\062A \0625\0644\0649 \0627\0644\062A\0637\0628\064A\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544323374398699)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'ar'
,p_message_text=>unistr('(\0644\0645 \064A\062A\0645 \062A\0648\0641\064A\0631 \062A\062F\0642\064A\0642 \0627\0644\0645\062C\0645\0648\0639)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543814809398698)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646 \062A\0639\064A\064A\0646 \0627\0644\0639\0646\0635\0631 \0639\0646\062F\0645\0627 \064A\0643\0648\0646 \0645\0635\062D\0648\0628\064B\0627 \0628\062A\062F\0642\064A\0642 \0627\0644\0645\062C\0645\0648\0639 "\0639\0644\0627\0645\0629 \0645\0633\062A\0648\0649 \0627\0644\062A\0637\0628\064A\0642".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543720197398698)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646 \062A\0639\064A\064A\0646 \0627\0644\0639\0646\0635\0631 \0639\0646\062F\0645\0627 \064A\0643\0648\0646 \0645\0635\062D\0648\0628\064B\0627 \0628\062A\062F\0642\064A\0642 \0627\0644\0645\062C\0645\0648\0639 "\0639\0644\0627\0645\0629 \0645\0633\062A\0648\0649 \0627\0644\062A\0637\0628\064A\0642".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543919285398699)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646 \062A\0639\064A\064A\0646 \0627\0644\0639\0646\0635\0631 \0639\0646\062F\0645\0627 \064A\0643\0648\0646 \0645\0635\062D\0648\0628\064B\0627 \0628\062A\062F\0642\064A\0642 \0627\0644\0645\062C\0645\0648\0639 "\062C\0644\0633\0629".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543680928398698)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0646\0635\0631 \0628\0644\0627 \062D\0645\0627\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568249357398717)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \062A\062A\0648\0641\0631 \0635\0641\062D\0629 \062A\0639\0644\064A\0645\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110557347679398709)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644 %0 \0644\064A\0633 \0644\062F\064A\0647\0627 \0623\064A \0627\0645\062A\064A\0627\0632\0627\062A \0644\062A\062D\0644\064A\0644 \0627\0644\0645\062E\0637\0637 %1 \0644\063A\0648\064A\064B\0627.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566646389398715)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1010 \062A\0645 \062A\062C\0627\0648\0632 \062D\062F \062A\0643\0631\0627\0631 \0645\0639\0627\0644\062C\0629 \0642\0628\0648\0644 \0627\0644\0641\0631\0639 \0625\0644\0649 \0627\0644\0635\0641\062D\0629. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544243609398699)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062F\0639\0627\0621 \0647\0630\0647 \0627\0644\0635\0641\062D\0629 \0628\0627\0633\062A\062E\062F\0627\0645 \0631\0627\0628\0637 URL \0623\0648 \0628\0627\0633\062A\062E\062F\0627\0645 GET \0623\0648 POST \0625\0644\0649 \0625\062C\0631\0627\0621 \0627\0644\0639\0631\0636\060C \064A\062C\0628 \0627\0633\062A\062F\0639\0627\0621 \0646\0648\0639 \0627\0644\0641\0631\0639 "\0627\0644\0641\0631\0639 \0625\0644\0649 \0627\0644\0635\0641\062D\0629".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110620970693398756)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0639\0646\062F \0645\062D\0627\0648\0644\0629 \062D\0641\0638 \0642\064A\0645\0629 \063A\064A\0631 \0631\0642\0645\064A\0629 \0641\064A \0627\0644\0639\0646\0635\0631 %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559026848398710)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062E\0637\0637 \0627\0644\062A\062D\0644\064A\0644 \0627\0644\0644\063A\0648\064A \0644\0644\062A\0637\0628\064A\0642 "%0" \063A\064A\0631 \0645\0648\062C\0648\062F \0641\064A \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110559117995398710)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 \0627\0644\062D\0633\0627\0628\0627\062A \0641\064A \0645\0633\0627\062D\0629 \0639\0645\0644 INTERNAL \0625\0644\0627 \0644\0645\0639\0627\0644\062C\0629 &PRODUCT_NAME. <a href="%0">\0627\0644\062E\062F\0645\0627\062A \0627\0644\0625\062F\0627\0631\064A\0629</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565824337398715)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-1029 \062A\0639\0630\0631 \062A\062E\0632\064A\0646 \0645\0639\0644\0648\0645\0627\062A \0627\0644\062C\0644\0633\0629.  \0627\0644\062C\0644\0633\0629=%0 \0627\0644\0639\0646\0635\0631=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568973173398717)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0625\064A\0642\0627\0641 \0627\0644\062A\062A\0628\0639: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110566188636398715)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623 \063A\064A\0631 \0645\062A\0648\0642\0639')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576170066398723)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0648\062C\062F \062E\0637\0623 \0641\064A update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569014832398717)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0625\062F\062E\0627\0644 \0627\0644\062A\0637\0628\064A\0642 \0648\0627\0644\0635\0641\062D\0629 \0644\0639\0631\0636 \0627\0644\062A\0639\0644\064A\0645\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110589561878398733)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0644\062A\0634\063A\064A\0644 \0627\0644\062A\0644\0642\0627\0626\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570160812398718)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0634\0637\0628 %0 \0645\0646 \0627\0644\062C\0644\0633\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529405817398687)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \062A\0646\0641\064A\0630 \0627\0644\0631\0645\0632 %0! \0647\0648 \063A\064A\0631 \0645\062F\0639\0648\0645 \0628\0648\0627\0633\0637\0629 \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0623\0648 \063A\064A\0631 \0645\0645\0643\0646 \0628\0648\0627\0633\0637\0629 \0645\0639\0644\0645\0629 \0627\0644\0645\062B\064A\0644 MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110529254022398687)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\0631\0646\0627\0645\062C \0627\0644\062A\0634\063A\064A\0644 \0645\062A\0639\062F\062F \0627\0644\0644\063A\0627\062A \063A\064A\0631 \0645\062A\0648\0641\0631 \0641\064A \0646\0633\062E\0629 \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0647\0630\0647!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550014988398703)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0644\0627 \064A\0643\0648\0646 \0635\0641\064A\0641 \0645\062C\0645\0648\0639\0629 \0627\0644\062A\0637\0628\064A\0642 \0641\0627\0631\063A\064B\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549879505398703)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0642\0645 \0633\0645\0629 \0627\0644\0639\0636\0648 \0627\0644\0645\062D\062F\062F %0 \063A\064A\0631 \0635\0627\0644\062D.  \064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0631\0642\0645 \0627\0644\0633\0645\0629 \0628\064A\0646 1 \0648%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550316659398703)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062C\0645\0648\0639\0629 \0627\0644\062A\0637\0628\064A\0642 \0645\0648\062C\0648\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550166476398703)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0623\0646 \064A\0643\0648\0646 \0627\0633\0645 \0627\0644\0645\062C\0645\0648\0639\0629 \0641\0627\0631\063A\064B\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550293880398703)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0623\0646 \064A\0632\064A\062F \0627\0633\0645 \0627\0644\0645\062C\0645\0648\0639\0629 \0639\0646 255 \062D\0631\0641\064B\0627')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549699573398703)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062C\0645\0648\0639\0629 \0627\0644\062A\0637\0628\064A\0642 %0 \063A\064A\0631 \0645\0648\062C\0648\062F\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550484649398703)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062E\0644\064A\0629 \0644\064A\0633\062A \0645\0641\062A\0648\062D\0629 \0628\0639\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549733269398703)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062A\0633\0644\0633\0644 \0627\0644\0639\0636\0648 %0 \063A\064A\0631 \0645\0648\062C\0648\062F \0641\064A \0645\062C\0645\0648\0639\0629 \0627\0644\062A\0637\0628\064A\0642 %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110549959185398703)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0633\0644\0633\0644 \0627\0644\0639\0636\0648 %0 \063A\064A\0631 \0645\0648\062C\0648\062F \0641\064A \0645\062C\0645\0648\0639\0629 \0627\0644\062A\0637\0628\064A\0642 "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621764615398757)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0638\064A\0641\0629 \0627\0644\062A\0634\0641\064A\0631 "%0" \063A\064A\0631 \0645\062F\0639\0648\0645\0629 \0641\064A \0647\0630\0627 \0627\0644\0646\0638\0627\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675289926398798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\062E\062A\0628\0627\0631 \0625\0645\0643\0627\0646\064A\0629 \0627\0644\0648\0635\0648\0644')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569644066398718)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0625\063A\0644\0627\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569710178398718)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\064A\0627\0631\0627\062A \062A\062E\0635\064A\0635 \0627\0644\0635\0641\062D\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569805854398718)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0641\062A\0631\0627\0636\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569946574398718)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0648\0636')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570050705398718)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062E\0641\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569467220398718)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062F \0627\0644\0645\0646\0627\0637\0642 \0627\0644\062A\064A \062A\0631\064A\062F \062A\0636\0645\064A\0646\0647\0627 \0641\064A \0647\0630\0647 \0627\0644\0635\0641\062D\0629. \0642\062F \0644\0627 \064A\062A\0645 \0639\0631\0636 \0627\0644\0645\0646\0627\0637\0642 \0627\0644\0645\062D\062F\062F\0629 \0625\0630\0627 \0644\0645 \062A\0643\0646 \0641\064A \0633\064A\0627\0642 \0627\0644\062A\0637\0628\064A\0642 \0627\0644\0635\062D\064A\062D \0623\0648 \0644\064A\0633\062A \0644\062F\064A\0643 \0627\0644\0627\0645\062A\064A\0627\0632\0627\062A \0627\0644\0635\062D\064A\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569572751398718)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'ar'
,p_message_text=>unistr('\0647\0630\0647 \0627\0644\0635\0641\062D\0629 \063A\064A\0631 \0642\0627\0628\0644\0629 \0644\0644\062A\062E\0635\064A\0635.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675518597398798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\0645\0643\0646\0643 \062A\062E\0635\064A\0635 \0647\064A\0626\0629 \0627\0644\062A\0637\0628\064A\0642 \0645\0646 \062E\0644\0627\0644 \062A\063A\064A\064A\0631 \0623\0633\0644\0648\0628 \0627\0644\0633\0645\0629. \0627\0644\0631\062C\0627\0621 \062A\062D\062F\064A\062F \0623\0633\0644\0648\0628 \0633\0645\0629 \0645\0646 \0627\0644\0642\0627\0626\0645\0629 \0623\062F\0646\0627\0647 \0648\0627\0644\0646\0642\0631 \0639\0644\0649 "\062A\0637\0628\064A\0642 \0627\0644\062A\063A\064A\064A\0631\0627\062A".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110676342450398799)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0631\0636 \0627\0644\0645\0646\0637\0642\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675436031398798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\062E\062F\0627\0645 \0627\0644\0623\0633\0644\0648\0628 \0627\0644\0627\0641\062A\0631\0627\0636\064A \0644\0644\062A\0637\0628\064A\0642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110675359681398798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0647\064A\0626\0629 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618320839398755)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0624\0634\0631 \0627\0644\0639\0645\0648\062F \0627\0644\0645\0634\0627\0631 \0625\0644\064A\0647 \0641\064A %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110521643578398680)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062E\0631\062C\0627\062A CLOB \063A\064A\0631 \0645\062F\0639\0648\0645\0629 \0644\0635\064A\063A\0629 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618091607398754)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0641\0627\0635\0644 \0627\0644\0639\0645\0648\062F \0641\064A \0628\062F\0627\064A\0629 \0635\0641\064A\0641 \0627\0644\0623\0639\0645\062F\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618108495398754)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0624\0634\0631 \0645\062C\0645\0648\0639\0629 \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\0634\0627\0631 \0625\0644\064A\0647 \0641\064A %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110535600552398692)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0635\062F\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110540867494398696)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0623\0646 \062A\0643\0648\0646 \0635\064A\063A\0629 \0627\0644\062A\0635\062F\064A\0631 XML \0628\0627\0633\062A\062E\062F\0627\0645 ORDS \0643\062E\0627\062F\0645 \0637\0628\0627\0639\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618406708398755)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0624\0634\0631 \0627\0644\0639\0645\0648\062F \0627\0644\0645\0634\0627\0631 \0625\0644\064A\0647 \0641\064A \0627\0644\062A\0645\064A\064A\0632 %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534182378398691)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0635\064A\063A\0629 \0627\0644\062A\0635\062F\064A\0631 \063A\064A\0631 \0635\0627\0644\062D\0629: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110618224591398754)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0624\0634\0631 \0627\0644\0645\062C\0645\0648\0639\0629 \0627\0644\0631\0626\064A\0633\064A\0629 \0627\0644\0645\0634\0627\0631 \0625\0644\064A\0647 \0641\064A %0 \063A\064A\0631 \0645\0648\062C\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110643433714398773)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F %1 \0641\064A \0627\0644\062C\062F\0648\0644 %0 \0639\0645\0648\062F \0628\0627\0644\0647\0648\064A\0629 "GENERATED ALWAYS". \0627\0644\0631\062C\0627\0621 \0627\0644\062A\0623\0643\062F \0645\0646 \0639\062F\0645 \062A\0639\064A\064A\0646 \0639\0645\0648\062F \0645\0635\062F\0631 \0644\0639\0645\0648\062F %1 \0641\064A \0645\0631\0628\0639 \062D\0648\0627\0631 \0627\0644\062A\0643\0648\064A\0646.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560876614398711)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0627\0635\0644 \0627\0644\0627\0644\062A\0632\0627\0645 \0627\0644\0645\062D\062F\062F \0642\0644\064A\0644 \0644\0644\063A\0627\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110560977065398711)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0642\062F\064A\0645 \0623\0639\0645\062F\0629 \0644\062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562190301398712)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0623\0639\0645\062F\0629 \0644\0645\062D\062F\062F \0627\0644\0635\0641\0648\0641 "%0". \062C\0631\0628 \0627\0644\0627\0643\062A\0634\0627\0641 \0627\0644\062A\0644\0642\0627\0626\064A \0623\0648 \0631\0627\062C\0639 \0647\064A\0643\0644 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570424010398718)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0623\0648\0631\0627\0642 \0639\0645\0644 \0641\064A \0645\0644\0641 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570368542398718)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0631\0642\0649 \0627\0644\0639\0645\0644 \0627\0644\0645\062D\062F\062F\0629 \063A\064A\0631 \0645\0648\062C\0648\062F\0629 \0641\064A \0645\0644\0641 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110550519769398703)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\063A\064A\0631\062A \0646\0633\062E\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\062D\0627\0644\064A\0629 \0641\064A \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0644\0623\0646 \0627\0644\0645\0633\062A\062E\062F\0645 \0628\062F\0623 \0639\0645\0644\064A\0629 \062A\062D\062F\064A\062B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552955212398705)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062A\062D\062F\064A\062B \0623\0639\0645\062F\0629 \0627\0644\062A\0642\0631\064A\0631: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657675623398784)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \062A\062D\0648\064A\0644 %0 \0625\0644\0649 SDO_GEOMETRY.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597184853398738)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \062A\062D\0648\064A\0644 \0627\0644\0639\0645\0648\062F  %0 \0645\0646 \0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A %1 \0625\0644\0649 VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604176157398744)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0644\0639\0645\0648\062F "%0" \0627\0644\0645\062D\062F\062F \0644\0644\0633\0645\0629 "%1" \0641\064A \0645\0635\062F\0631 \0627\0644\0628\064A\0627\0646\0627\062A!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545400881398700)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0645\0631\0634\062D %0 \063A\064A\0631 \0645\062F\0639\0648\0645 \0644\0644\0623\0639\0645\062F\0629 \0645\062A\0639\062F\062F\0629 \0627\0644\0642\064A\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110661067989398787)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0631\0634\062D "\0628\064A\0646" \063A\064A\0631 \0635\0627\0644\062D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527533056398685)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645 \0627\0644\0645\062D\062F\062F\0629 \063A\064A\0631 \0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527425787398685)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0633\062A\0639\0644\0627\0645 \063A\064A\0631 \0635\0627\0644\062D. \064A\062C\0628 \0623\0646 \064A\0643\0648\0646 \0646\0648\0639 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \062C\062F\0648\0644 \0623\0648 \0627\0633\062A\0639\0644\0627\0645 SQL \0623\0648 \062F\0627\0644\0629 PL/SQL \062A\064F\0631\062C\0639 \0627\0633\062A\0639\0644\0627\0645 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597231002398738)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0641\0634\0644 \062A\062D\0644\064A\0644 \0627\0633\062A\0639\0644\0627\0645 SQL \0644\063A\0648\064A\064B\0627!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604210407398744)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0648\0636\0639 \0627\0644\0639\0645\0648\062F \0627\0644\0645\062D\062F\062F %0 \0644\0644\0633\0645\0629 "%1" \0641\064A \0639\0628\0627\0631\0629 SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110526027822398684)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0633\062A\062E\062F\0627\0645 \0627\0644\0643\062B\064A\0631 \0644\0644\063A\0627\064A\0629 \0645\0646 \0627\0644\0639\0646\0627\0635\0631 \0641\064A \0645\0631\0634\062D \0627\0644\0642\064A\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604051107398744)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\062D\062F\064A\062F \0639\0645\0648\062F \0644\0644\0633\0645\0629 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527341481398685)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\0631\062C\0639 \0646\0635 \062F\0627\0644\0629 PL/SQL \0642\064A\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110617267053398754)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062D\062A\0648\064A \0645\0635\062F\0631 \0628\064A\0627\0646\0627\062A REST \0639\0644\0649 \0639\0645\0644\064A\0629 \0644\0645\0639\0627\0644\062C\0629 \0625\062C\0631\0627\0621 DML \0627\0644\0645\0637\0644\0648\0628.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110523210208398682)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0648\064A\0644 GeoJSON \0625\0644\0649 SDO_GEOMETRY (\0627\0644\0639\0645\0648\062F %0) \063A\064A\0631 \0645\062A\0648\0641\0631 \0641\064A \0645\062C\0645\0648\0639\0629 \0627\0644\0628\064A\0627\0646\0627\062A \0647\0630\0647.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524332872398683)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\0648\064A\0644 SDO_GEOMETRY (\0627\0644\0639\0645\0648\062F %0) \063A\064A\0631 \0645\062F\0639\0648\0645 \0644\0645\0635\0627\062F\0631 \0628\064A\0627\0646\0627\062A XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110531684169398689)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\0631\0641 %0 \063A\064A\0631 \0645\062F\0639\0648\0645 \0643\0641\0627\0635\0644 \0645\062A\0639\062F\062F \0627\0644\0642\064A\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110658982097398785)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 \0647\0630\0647 \0627\0644\0648\0638\064A\0641\0629 \0641\064A \0633\064A\0627\0642 \0627\0644\0627\0633\062A\0639\0644\0627\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110524452278398683)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\0645 \062A\0637\0627\0628\0642 \0646\0648\0639 \0628\064A\0627\0646\0627\062A \0627\0644\0639\0645\0648\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527261262398685)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \062A\062C\0627\0648\0632 \062D\062F\0648\062F \0631\0628\0637 ORDS OUT \0627\0644\062F\0627\062E\0644\064A\0629. \0627\0644\0631\062C\0627\0621 \062A\0642\0644\064A\0644 \0643\0645\064A\0629 \0635\0641\0648\0641 DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110605007564398744)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062A\0639\0630\0631 \062A\062D\0644\064A\0644 \0627\0633\062A\062C\0627\0628\0629 JSON \0645\0646 \0627\0644\062E\0627\062F\0645 \0627\0644\0628\0639\064A\062F \0644\063A\0648\064A\064B\0627: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110527177445398685)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0633\064A\0627\0642 \062E\0637\0623 \0623\0648 \063A\064A\0631 \0645\0639\0631\0648\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110621631943398757)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0648\0639 \0627\0644\0645\0644\0641 \0647\0630\0627 \063A\064A\0631 \0645\062F\0639\0648\0645 \0628\0648\0627\0633\0637\0629 \0627\0644\0645\062D\0644\0644 \0627\0644\0644\063A\0648\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576282087398723)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0635\0648\0644 \063A\064A\0631 \0645\0635\062F\0642 (\0644\0645 \064A\062A\0645 \062A\0639\064A\064A\0646 wwv_flow_api.set_credentials).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553283174398705)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0643\0648\064A\0646 \0645\0633\0627\062D\0629 \0627\0644\0639\0645\0644 \0644\0623\0646\0647\0627 \0645\0648\062C\0648\062F\0629 \0628\0627\0644\0641\0639\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110553127477398705)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0643\0648\064A\0646 \0645\062C\0645\0648\0639\0629 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646 \0644\0623\0646\0647\0627 \0645\0648\062C\0648\062F\0629 \0628\0627\0644\0641\0639\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563491204398713)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0633\0645 \0645\0633\062A\062E\062F\0645 \0645\0643\0631\0631 \0644\0640 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563597461398713)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062A\062D\0645\064A\0644 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646. \0641\0634\0644 \0639\0646\062F \0627\0644\0645\0633\062A\062E\062F\0645 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573436732398720)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0627\0646 \0633\064A\062A\0645 \062A\062D\0645\064A\0644 %0 \0645\0646 \0627\0644\0645\0633\062A\062E\062F\0645\064A\0646.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573277536398720)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573373302398720)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0645\062A\064A\0627\0632\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573048910398720)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649537623398778)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0639\0631\0636 \0639\0646\0635\0631 \0627\0644\0635\0641\062D\0629 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569157529398717)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0639\0631\0636 \0639\0646\0635\0631 \0627\0644\0635\0641\062D\0629 \0644\0623\0646\0647 \0644\0645 \064A\062A\0645 \0641\062A\062D \0646\0645\0648\0630\062C HTML \0628\0639\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110534442317398691)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062D\0633\0627\0628 \0627\0644\0642\064A\0645\0629 \0627\0644\0627\0641\062A\0631\0627\0636\064A\0629 \0644\0639\0646\0635\0631 \0627\0644\0635\0641\062D\0629 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568427218398717)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0641\064A \0627\0644\062D\0633\0627\0628 \0627\0644\0644\0627\062D\0642 \0644\0639\0646\0635\0631 \0627\0644\0635\0641\062D\0629 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568317961398717)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062D\0633\0627\0628 \0642\064A\0645\0629 \0645\0635\062F\0631 \0627\0644\0639\0646\0635\0631 \0644\0639\0646\0635\0631 \0627\0644\0635\0641\062D\0629 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548123584398702)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0648\0635\0648\0644 \063A\064A\0631 \0645\0639\062A\0645\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568686348398717)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062C\0627\0641\0627 \0633\0643\0631\0628\062A \063A\064A\0631 \0645\062F\0639\0648\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568703107398717)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110569309105398717)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0628\062F\0621 \0627\0644\0627\0633\062A\0639\0644\0627\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576568190398723)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\062D\062F\064A\062B %0 \063A\064A\0631 \0645\062F\0639\0648\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110570724436398719)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0641 \0627\0644\0639\0646\0635\0631 \063A\064A\0631 \0635\0627\0644\062D: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110597076758398738)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \062A\0648\062C\062F \062A\0639\0644\064A\0645\0627\062A \0644\0647\0630\0627 \0627\0644\0639\0646\0635\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561535810398712)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0634\0644 \062A\0643\0648\064A\0646 \0627\0633\062A\0639\0644\0627\0645 \0627\0644\0631\0633\0645 \0627\0644\0628\064A\0627\0646\064A. \062A\062D\0642\0642 \0645\0646 \0625\0639\062F\0627\062F\0627\062A \062A\062E\0637\064A\0637 \0627\0644\0639\0645\0648\062F \0648\0627\0644\0645\0635\062F\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656363636398783)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062C\0645 \0627\0644\0645\0631\0641\0642 %0 \0645\064A\063A\0627\0628\0627\064A\062A \062A\062A\062C\0627\0648\0632 \0627\0644\062D\062F \0627\0644\0623\0642\0635\0649 \0644\062D\062C\0645 \0627\0644\0645\0631\0641\0642 \0627\0644\0628\0627\0644\063A %1 \0645\064A\063A\0627\0628\0627\064A\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562430383398712)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\064A\0645\0629 \063A\064A\0631 \0635\0627\0644\062D\0629 \0644\0644\0645\0639\0644\0645\0629 p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110679831654398801)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0642\062F \062A\062C\0627\0648\0632\062A \0627\0644\0639\062F\062F \0627\0644\0623\0642\0635\0649 \0627\0644\0645\0633\0645\0648\062D \0628\0647 \0644\0639\062F\062F \0631\0633\0627\0626\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A \0644\0643\0644 \0645\0633\0627\062D\0629 \0639\0645\0644. \0627\0644\0631\062C\0627\0621 \0627\0644\0627\062A\0635\0627\0644 \0628\0627\0644\0645\0633\0624\0648\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543471608398698)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0627\0633\062A\062F\0639\0627\0621 \0647\0630\0627 \0627\0644\0625\062C\0631\0627\0621 \0645\0646 \062F\0627\062E\0644 \062C\0644\0633\0629 \0627\0644\062A\0637\0628\064A\0642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562318281398712)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0625\062F\062E\0627\0644 \0642\064A\0645\0629 \062E\0627\0644\064A\0629 \0644\0644\0645\0639\0644\0645\0629 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616367385398753)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0642\0627\0644\0628 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A "%0" \0641\064A \0627\0644\062A\0637\0628\064A\0642 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110692803754398811)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\0639\064A\064A\0646 \0645\0639\0644\0645\0629 \0627\0644\0645\062B\064A\0644 SMTP_HOST_ADDRESS \0644\0625\0631\0633\0627\0644 \0631\0633\0627\0626\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562049896398712)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \0625\062F\062E\0627\0644 \0645\0633\062A\0644\0645 \0631\0633\0627\0644\0629 \0644\0625\0631\0633\0627\0644 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110682211867398803)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \062A\0643\0648\064A\0646 \0627\062A\0635\0627\0644 SMTP \0645\0639 \062E\0627\062F\0645 \0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A \0627\0644\0645\0643\0648\0646.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110656470777398783)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0633\062A\062F\0639\0627\0621 Ajax \063A\064A\0631 \0635\0627\0644\062D!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547870411398701)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0639\0631\064A\0641 \0648\0638\064A\0641\0629Ajax \0644\0644\0623\062F\0627\0629 \0627\0644\0625\0636\0627\0641\064A\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646802180398776)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0639\0631\064A\0641 \062A\0646\0641\064A\0630 \0639\0631\0636 \0644\0644\0623\062F\0627\0629 \0627\0644\0625\0636\0627\0641\064A\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547980402398701)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\0639\0631\064A\0641 \0648\0638\064A\0641\0629 \0639\0631\0636 \0644\0644\0623\062F\0627\0629 \0627\0644\0625\0636\0627\0641\064A\0629 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657313155398784)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\0631\0646\0627\0645\062C \0627\0644\0625\0636\0627\0641\064A \0644\0645\0635\062F\0631 \0628\064A\0627\0646\0627\062A REST "%0" \0644\0627 \064A\062D\062A\0648\064A \0639\0644\0649 \0648\0638\064A\0641\0629 "\0642\062F\0631\0627\062A".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657251448398784)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\0631\0646\0627\0645\062C \0627\0644\0625\0636\0627\0641\064A \0644\0645\0635\062F\0631 \0628\064A\0627\0646\0627\062A REST "%0" \0644\0627 \064A\062D\062A\0648\064A \0639\0644\0649 \0648\0638\064A\0641\0629 DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657465102398784)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\0631\0646\0627\0645\062C \0627\0644\0625\0636\0627\0641\064A \0644\0645\0635\062F\0631 \0628\064A\0627\0646\0627\062A REST "%0" \0644\0627 \064A\062D\062A\0648\064A \0639\0644\0649 \0648\0638\064A\0641\0629 \062A\0646\0641\064A\0630.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110657557542398784)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\0631\0646\0627\0645\062C \0627\0644\0625\0636\0627\0641\064A \0644\0645\0635\062F\0631 \0628\064A\0627\0646\0627\062A REST "%0" \0644\0627 \064A\062D\062A\0648\064A \0639\0644\0649 \0648\0638\064A\0641\0629 \0625\062D\0636\0627\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545628474398700)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0645 \0627\0644\0625\0628\0644\0627\063A \0639\0646 \062E\0637\0623 \0641\064A \0631\0645\0632 PLSQL \0623\062B\0646\0627\0621 \0645\0639\0627\0644\062C\0629 \0627\0644\0623\062F\0627\0629 \0627\0644\0625\0636\0627\0641\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552241364398705)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0627\0644\0642\064A\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582894766398728)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \062A\062D\0648\064A\0644 \0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A %0 \0625\0644\0649 VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668486406398792)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \0627\0644\0639\0645\0648\062F "%0" \0627\0644\0645\062D\062F\062F \0644\0644\0633\0645\0629 "%1" \0641\064A \0639\0628\0627\0631\0629 SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644748073398774)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062C\0628 \062A\062D\062F\064A\062F \0627\0633\062A\0639\0644\0627\0645 \0642\0627\0626\0645\0629 \0642\064A\0645 (LOV) \0623\0648 \0642\0627\0626\0645\0629 \0642\064A\0645 \0645\0639\064A\0646\0629 \0644\0640 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110646374500398776)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\062F\062F \0627\0644\0623\0639\0645\062F\0629 \0627\0644\0645\062D\062F\062F\0629 \0641\064A \0627\0633\062A\0639\0644\0627\0645 SQL \0644\0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645 \0644\0640 %0 \062E\0637\0623. \0627\0637\0644\0639 \0639\0644\0649 \0623\0645\062B\0644\0629 \0627\0644\0639\0628\0627\0631\0627\062A \0627\0644\0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668269109398792)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\062A\0645 \062A\062D\062F\064A\062F \0639\0645\0648\062F \0644\0644\0633\0645\0629 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697977267398815)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0642\064A\0645\0629 \0627\0644\0645\062F\062E\0644\0629 %0 \0644\0644\0633\0645\0629 "%1" \0644\064A\0633\062A \0631\0642\0645\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110649842457398778)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 \0644\0647 \0646\0648\0639 \0628\064A\0627\0646\0627\062A \062E\0637\0623 \0641\064A \0639\0628\0627\0631\0629 SQL. \0627\0644\0639\0645\0648\062F \0631\0642\0645 %1 \0647\0648 %2 \0644\0643\0646 %3 \0647\0648 \0627\0644\0645\062A\0648\0642\0639.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110668324865398792)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0639\0645\0648\062F "%0" \0627\0644\0645\062D\062F\062F \0644\0644\0633\0645\0629 "%1" \0628\0646\0648\0639 \0627\0644\0628\064A\0627\0646\0627\062A %2 \0644\0643\0646 \064A\062C\0628 \0623\0646 \064A\0643\0648\0646 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110544955417398699)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0627\0644\0639\062B\0648\0631 \0639\0644\0649 \062A\062E\0637\064A\0637 \0627\0644\062A\0642\0631\064A\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604954288398744)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\0645\0643\0646 \0627\0633\062A\062E\062F\0627\0645 \0645\064A\0632\0629 \062D\0633\0627\0628 \0627\0644\0645\062C\0645\0648\0639 \0644\0644\062A\0642\0627\0631\064A\0631 \0627\0644\0642\0627\0626\0645\0629 \0639\0644\0649 \0645\0635\062F \0628\064A\0627\0646\0627\062A REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110568528296398717)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('ERR-2904 \062A\0639\0630\0631 \062A\0639\064A\064A\0646 \0642\064A\0645\0629 \0627\0644\0627\062E\062A\0635\0627\0631.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110572869591398720)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062E\0637\0623: \0646\0648\0639 \0627\062E\062A\0635\0627\0631 \063A\064A\0631 \0645\0639\0631\0648\0641.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110562860738398713)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0625\062D\0636\0627\0631 authentication_scheme \0641\064A \0627\0644\062A\0637\0628\064A\0642 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110636341855398768)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\0639\0631\0641 \0627\0644\0639\0645\064A\0644 \0645\0648\062C\0648\062F \0628\0627\0644\0641\0639\0644 \0644\0644\062C\0644\0633\0629 \0627\0644\062D\0627\0644\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110573166979398720)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0628\0631\064A\062F \0627\0644\0625\0644\0643\062A\0631\0648\0646\064A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697306764398815)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0634\0644\062A \0627\0644\0645\0635\0627\062F\0642\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110599691673398740)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A \0645\0644\0641 \062A\0639\0631\064A\0641 \0627\0631\062A\0628\0627\0637 \0648\0627\062D\062F \0623\0648 \0623\0643\062B\0631 \0641\064A apex_util.g_request_cookies \0639\0644\0649 \0642\064A\0645\0629 \063A\064A\0631 \0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110582121710398727)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0633\062A\062C\0627\0628\0629 \0645\0646 \0633\062C\0644 UDDI \063A\064A\0631 \0635\0627\0644\062D\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110545735363398700)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0645 \064A\0642\0645 \0631\0627\0628\0637 URL \0627\0644\0645\0642\062F\0645 \0628\0625\0631\062C\0627\0639 \0645\0633\062A\0646\062F WSDL \0635\0627\0644\062D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110548224622398702)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A \0645\0633\062A\0646\062F WSDL \0639\0644\0649 \0639\062F\0629 \0631\0648\0627\0628\0637 SOAP. &PRODUCT_NAME. \0644\0627 \064A\062F\0639\0645 \0625\0644\0627 WSDL \0628\0631\0627\0628\0637 SOAP \0648\0627\062D\062F. \0627\0646\0642\0631 \0644\062A\0643\0648\064A\0646 \0645\0631\062C\0639 \062E\062F\0645\0629 \0648\064A\0628 \064A\062F\0648\064A\064B\0627 \0644\0645\062A\0627\0628\0639\0629 \062A\0643\0648\064A\0646 \0645\0631\062C\0639 \0644\0647\0630\0647 \0627\0644\062E\062F\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110616601885398753)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0627\0633\062A\062C\0627\0628\0629 \0645\0646 \0627\0644\062E\062F\0645\0629 \0644\0645 \062A\0643\0646 \0628\0627\0644\0635\064A\063A\0629 XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697266449398815)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0631\0645\0632 \0648\0635\0648\0644 \0645\0635\0627\062F\0642\0629 OAuth \0627\0644\0645\0645\064A\0632 \063A\064A\0631 \0645\062A\0648\0641\0631 \0623\0648 \0645\0646\062A\0647\064A \0627\0644\0635\0644\0627\062D\064A\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110660441443398786)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0642\062F \062A\062C\0627\0648\0632\062A \0627\0644\0639\062F\062F \0627\0644\0623\0642\0635\0649 \0627\0644\0645\0633\0645\0648\062D \0628\0647 \0644\0639\062F\062F \0637\0644\0628\0627\062A \062E\062F\0645\0629 \0627\0644\0648\064A\0628 \0644\0643\0644 \0645\0633\0627\062D\0629 \0639\0645\0644. \0627\0644\0631\062C\0627\0621 \0627\0644\0627\062A\0635\0627\0644 \0628\0627\0644\0645\0633\0624\0648\0644.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110697456055398815)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0623\062C\0627\0628 \0627\0644\062E\0627\062F\0645 \0628\0646\0648\0639 \0631\0645\0632 \0645\0635\0627\062F\0642\0629 OAuth \0645\0645\064A\0632 \063A\064A\0631 \0645\062F\0639\0648\0645.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547645492398701)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'ar'
,p_message_text=>unistr('\0644\0627 \064A\062D\062A\0648\064A \0645\0633\062A\0646\062F WSDL \0647\0630\0627 \0639\0644\0649 \0631\0627\0628\0637 SOAP \0627\0644\0645\0637\0644\0648\0628 \0644\0625\0636\0627\0641\0629 \0627\0644\0645\0631\062C\0639.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110543598224398698)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062A\0637\0644\0628 WSDL \0628\064A\0627\0646\0627\062A \0635\0644\0627\062D\064A\0629 \0627\0644\0645\0635\0627\062F\0642\0629. \0627\0644\0631\062C\0627\0621 \0625\062F\062E\0627\0644 \0627\0633\0645 \0627\0644\0645\0633\062A\062E\062F\0645 \0648\0643\0644\0645\0629 \0627\0644\0645\0631\0648\0631 \0623\062F\0646\0627\0647.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110552396877398705)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631 \0641\0647\0645 \0645\0633\062A\0646\062F WSDL \0628\0648\0627\0633\0637\0629 \0645\062D\0631\0643 \0627\0644\0639\0631\0636. \0627\0646\0642\0631 \0639\0644\0649 \062A\0643\0648\064A\0646 \0645\0631\062C\0639 \062E\062F\0645\0629 \0648\064A\0628 \064A\062F\0648\064A\064B\0627 \0644\0645\062A\0627\0628\0639\0629 \062A\0643\0648\064A\0646 \0645\0631\062C\0639 \0644\0647\0630\0627 \0627\0644\062E\062F\0645\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110619294396398755)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062A\0639\0630\0631\062A \0645\0639\0627\0644\062C\0629 \0627\0644\062A\062D\062F\064A\062B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110645062203398775)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0627\0644\0639\0631\0636 \0648\0627\0644\0646\062A\064A\062C\0629 \0641\064A \0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645 \0647\0645\0627 \0627\0644\0639\0645\0648\062F \0646\0641\0633\0647!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110644937517398775)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0642\0627\0626\0645\0629 \0627\0644\0642\064A\0645 \0644\0627 \062A\062D\062A\0648\064A \0639\0644\0649 \0639\0645\0648\062F \0646\062A\064A\062C\0629.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576480557398723)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0627\0644\062D\0635\0648\0644 \0639\0644\0649 \0642\064A\0645\0629 \0627\0644\0639\0645\0648\062F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600420022398741)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'ar'
,p_message_text=>unistr('\0628\064A\0627\0646\0627\062A \0627\0644\0646\0645\0648\0630\062C \0627\0644\062C\062F\0648\0644\064A \0627\0644\062D\0627\0644\064A\0629 \0642\062F\064A\0645\0629 \0644\0644\063A\0627\064A\0629\060C \062A\0645 \062A\0639\062F\064A\0644 \0628\064A\0627\0646\0627\062A \0627\0644\0645\0635\062F\0631.<br/> \0627\0646\0642\0631 <strong><a href="%0">\0647\0646\0627</a></strong> \0644\062A\062C\0627\0647\0644 \062A\063A\064A\064A\0631\0627\062A\0643 \0648\0625\0639\0627\062F\0629 \062A\062D\0645\064A\0644 \0627\0644\0628\064A\0627\0646\0627\062A \0645\0646 \0642\0627\0639\062F\0629 \0627\0644\0628\064A\0627\0646\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558544790398710)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062A\062D\062F\064A\062F \0633\0644\0633\0644\0629 \0627\0644\062A\0642\0633\064A\0645 \0625\0644\0649 \0635\0641\062D\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558484311398709)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062A\0639\0630\0631 \062A\062D\062F\064A\062F \0639\0646\0627\0648\064A\0646 \0627\0644\0627\0633\062A\0639\0644\0627\0645:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558673452398710)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \062A\0646\0641\064A\0630 \0627\0633\062A\0628\062F\0627\0644 \062A\0630\064A\064A\0644 \0627\0644\062A\0642\0631\064A\0631')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558770874398710)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0641\0634\0644 \062A\062D\0644\064A\0644 \0627\0633\062A\0639\0644\0627\0645 SQL \0644\063A\0648\064A\064B\0627:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563795995398713)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\062D\062F \0627\0644\0623\062F\0646\0649 \0644\0639\062F\062F \0627\0644\0635\0641\0648\0641: %0\060C \062A\0645 \0644\0644\0639\062B\0648\0631 \0639\0644\0649 \0635\0641\0648\0641 \0644\0643\0646 \0644\0645 \064A\062A\0645 \0639\0631\0636\0647\0627: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561293073398712)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0627\0644\0627\0633\062A\0639\0644\0627\0645 #%0 (%1) \063A\064A\0631 \0635\0627\0644\062D\060C \062A\062D\062A\0627\062C \0627\0644\0623\0639\0645\062F\0629 \0627\0644\062A\064A \062A\0633\062A\062E\062F\0645 HTML \0625\0644\0649 \0623\0633\0645\0627\0621 \0645\0633\062A\0639\0627\0631\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110576386736398723)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'ar'
,p_message_text=>unistr('\062D\062F\062B \062E\0637\0623 \0623\062B\0646\0627\0621 \0627\0644\062D\0635\0648\0644 \0639\0644\0649 \0639\0646\0627\0648\064A\0646 \0627\0644\0627\0633\062A\0639\0644\0627\0645\0627\062A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558834880398710)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\062E\0637\0623 \062A\0642\0631\064A\0631:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110596503978398738)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'ar'
,p_message_text=>unistr('\0641\0631\0632 \062D\0633\0628 \0647\0630\0627 \0627\0644\0639\0645\0648\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561391449398712)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'ar'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\062A\0639\0630\0631 \062A\062D\0644\064A\0644 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0644\063A\0648\064A\064B\0627\060C \0627\0644\0631\062C\0627\0621 \0627\0644\062A\062D\0642\0642 \0645\0646 \0635\064A\0627\063A\0629 \0627\0644\0627\0633\062A\0639\0644\0627\0645 \0627\0644\062E\0627\0635 \0628\0643.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600595919398741)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'ar'
,p_message_text=>unistr('\064A\062D\062A\0648\064A \0647\0630\0627 \0627\0644\0646\0645\0648\0630\062C \0639\0644\0649 \062A\063A\064A\064A\0631\0627\062A \063A\064A\0631 \0645\062D\0641\0648\0638\0629. \0627\0646\0642\0631 \0639\0644\0649 "\0645\0648\0627\0641\0642" \0644\0644\0645\062A\0627\0628\0639\0629 \062F\0648\0646 \062D\0641\0638 \0627\0644\062A\063A\064A\064A\0631\0627\062A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110604840579398744)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'ar'
,p_message_text=>unistr('\0645\062E\0637\0637 \062A\0642\0633\064A\0645 \0627\0644\062A\0642\0631\064A\0631 \0625\0644\0649 \0635\0641\062D\0627\062A (%0) \063A\064A\0631 \0645\062F\0639\0648\0645 \0641\064A \0645\0635\062F\0631 \0627\0644\0628\064A\0627\0646\0627\062A \0627\0644\0645\062D\062F\062F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110561133710398712)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0639\0645\0648\062F \0627\0644\0627\0633\062A\0639\0644\0627\0645  #%0 (%1) \063A\064A\0631 \0635\0627\0644\062D\060C \0627\0633\062A\062E\062F\0645 \0627\0644\0627\0633\0645 \0627\0644\0645\0633\062A\0639\0627\0631 \0644\0644\0639\0645\0648\062F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563804472398713)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 (\0627\0644\0635\0641\0648\0641) %0 - %1 \0644\0623\0643\062B\0631 \0645\0646 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110602552705398743)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 - %1 \0644\0623\0643\062B\0631 \0645\0646 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110563645656398713)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0635\0641 (\0627\0644\0635\0641\0648\0641) %0 - %1 \0645\0646 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110547587161398701)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'ar'
,p_message_text=>unistr('%0 - %1 \0645\0646 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558959057398710)
,p_name=>'Y'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0639\0645')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110565086190398714)
,p_name=>'YEAR'
,p_message_language=>'ar'
,p_message_text=>unistr('\0633\0646\0629')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110558151843398709)
,p_name=>'YEARS'
,p_message_language=>'ar'
,p_message_text=>unistr('\0627\0644\0633\0646\0648\0627\062A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110600652942398741)
,p_name=>'YES'
,p_message_language=>'ar'
,p_message_text=>unistr('\0646\0639\0645')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4498)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4498)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\0633\0637\062D \0627\0644\0645\0643\062A\0628')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4498
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4498)
,p_name=>unistr('\0627\0644\0631\0633\0627\0626\0644')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\0627\0644\0631\0633\0627\0626\0644')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
