prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4496
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4496 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4496
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101352244403437')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'cs'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4496)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113349'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4496)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4496)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4496)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4496)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4496)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4496)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4496)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4496)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4496)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4496)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4496)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4496)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4496)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.cs'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4496
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4496)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4496)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4496)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4496)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4496)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4496)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4496)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.cs'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4496
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4496)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4496)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4496)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4496)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4496)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4496)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4496)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.cs'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4496
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4496)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4496)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4496)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.cs'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4496
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4496)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4496)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4496)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4496)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4496)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4496)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4496)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4496)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4496)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4496)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4496)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4496)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4496)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4496)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4496)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.cs'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4496
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4496)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4496)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4496)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4496)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4496)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4496)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4496)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4496)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4496)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4496)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4496)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4496)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4496)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4496)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4496)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.cs'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4496
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4496)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4496)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4496)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4496)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4496)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4496)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4496)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4496)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4496)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4496)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4496)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4496)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4496)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4496)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4496)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.cs'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4496
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4496)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4496)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4496)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4496)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4496)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4496)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4496)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4496)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4496)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4496)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4496)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4496)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4496)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4496)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4496)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4496
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4496)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4496
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4496)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4496
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4496)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4496
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4496)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4496
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4496)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4496
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4496
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4496)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4496)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4496)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4496)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4496)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4496)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4496)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4496)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4496)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4496)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4496)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4496)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4496)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4496)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4496)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4496)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4496)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4496)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4496)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4496)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4496)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4496)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4496)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4496)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4496)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4496)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4496)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4496)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4496)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4496
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4496)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4496)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4496)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4496)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4496)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4496
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4496)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4496
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4496)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4496
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4496)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4496
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4496)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4496
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4496)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4496
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4496)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4496)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4496)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4496)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4496)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4496)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4496)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4496)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4496)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4496
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4496)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4496)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4496)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4496)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4496)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4496)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4496)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4496
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4496)
,p_page_name=>'winlov'
,p_page_title=>unistr('Dialogov\00E9 okno Vyhled\00E1v\00E1n\00ED')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('Vyhled\00E1v\00E1n\00ED')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('Zav\0159\00EDt')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('Dal\0161\00ED &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; P\0159edchoz\00ED')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\0158\00E1dky #FIRST_ROW#\00A0\2013 #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4496
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4496)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4496
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4496)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4496)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4496)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4496)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4496)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4496)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4496)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4496)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4496)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4496)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4496)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4496)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4496)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4496)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4496)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4496)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4496)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4496)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4496)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4496)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4496)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4496)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4496)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4496)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4496)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4496)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4496)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4496)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4496)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4496)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4496)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4496)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4496)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4496)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4496)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4496)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4496)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4496)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4496)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4496)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4496)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4496)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4496)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4496)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4496)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4496)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4496)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4496)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4496)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4496)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4496)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4496)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4496)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4496)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4496)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4496)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4496)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4496)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4496)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4496)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4496)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4496)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4496)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4496)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4496)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4496)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4496)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4496)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4496)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4496)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4496)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4496)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4496)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4496)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4496)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4496)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4496)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4496)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4496)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4496)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4496)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4496)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4496)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4496)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4496)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4496)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4496)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4496)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4496)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4496)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4496)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4496)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4496)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4496)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4496)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4496)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4496)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4496)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4496)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4496)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4496)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4496)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4496)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4496)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4496)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4496)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4496)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4496)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4496)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4496)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4496)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4496)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4496)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4496)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4496)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4496)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4496)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4496)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4496)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4496)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4496)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4496)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4496)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4496)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4496)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4496)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4496)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4496)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4496)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4496)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4496)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4496)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4496)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4496)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4496)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4496)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4496)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4496)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4496)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4496)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4496)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4496)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4496)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4496)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4496)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4496)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4496)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4496)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4496)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4496)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4496)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4496)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4496)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4496)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4496)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4496)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4496)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4496)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4496)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4496)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4496)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4496)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4496)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4496)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4496)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4496)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4496)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4496)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4496)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4496)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4496)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4496)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4496)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4496)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4496)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4496)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4496)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4496)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4496)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4496)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4496)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4496)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4496)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4496)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4496)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4496)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733652387398849)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'cs'
,p_message_text=>'Sloupec %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720775029398839)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'cs'
,p_message_text=>unistr('Spr\00E1vce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720685709398839)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatelsk\00E9 jm\00E9no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777901189398881)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDstup odep\0159en')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737640048398851)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00E1\0161 \00FA\010Det %0 byl vytvo\0159en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723200323398841)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'cs'
,p_message_text=>unistr('\00DA\010Det je zam\010Den\00FD.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713178849398833)
,p_name=>'AM_PM'
,p_message_language=>'cs'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847530415398931)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159epnout %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855672846398937)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'cs'
,p_message_text=>unistr('(Aktivn\00ED)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825140366398915)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Ajaxov\00E9 vol\00E1n\00ED vr\00E1tilo chybu serveru %0 pro %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755942265398865)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'cs'
,p_message_text=>unistr('Alias aplikace "%0" nelze p\0159ev\00E9st na jedine\010Dn\00E9 ID aplikace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756094525398865)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>'Aplikace s aliasem "%0" neexistuje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745695442398857)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('ERR-1816 Neo\010Dek\00E1van\00E1 chyba p\0159i p\0159evodu aliasu aplikace p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838516220398924)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Kontroln\00ED sou\010Det aplikace poskytuje jednoduch\00FD zp\016Fsob, jak ur\010Dit, zda je stejn\00E1 aplikace nasazena v jin\00FDch pracovn\00EDch prostorech. Tyto kontroln\00ED sou\010Dty m\016F\017Eete porovnat a ur\010Dit, zda existuje shoda. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731468070398847)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED funkce autentizace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716845744398836)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED funkce autentizace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880362695398956)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Jm\00E9no z\00E1kazn\00EDka vr\00E1cen\00E9 slu\017Ebou Oracle Cloud Identity Management nen\00ED autorizov\00E1no pro dom\00E9nu %1!<br/><a href="&LOGOUT_URL.">P\0159ihlaste se znovu</a> a zadejte jm\00E9no autorizovan\00E9ho z\00E1kazn\00EDka nebo zm\011B\0148te adresu URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714596103398834)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00E1\0161 \00FA\010Det "%0" nem\00E1 pot\0159ebn\00E1 v\00FDvoj\00E1\0159sk\00E1 opr\00E1vn\011Bn\00ED (DB_DEVELOPER nebo DB_ADMINISTRATOR)<br/>pro pracovn\00ED prostor "%1"! <a href="&LOGOUT_URL.">P\0159ihlaste se znovu</a>, a\017E z\00EDsk\00E1te opr\00E1vn\011Bn\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713687137398834)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'cs'
,p_message_text=>unistr('Jm\00E9no z\00E1kazn\00EDka vr\00E1cen\00E9 slu\017Ebou Oracle Cloud Identity Management nen\00ED autorizov\00E1no v aktu\00E1ln\00EDm pracovn\00EDm prostoru!<br/><a href="&LOGOUT_URL.">P\0159ihlaste se znovu</a> a zadejte jm\00E9no autorizovan\00E9ho z\00E1kazn\00EDka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714677142398834)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Z bezpe\010Dnostn\00EDch d\016Fvod\016F nen\00ED povoleno spou\0161t\011Bn\00ED aplikac\00ED tohoto pracovn\00EDho prostoru prost\0159ednictv\00EDm dom\00E9ny v adrese URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731195530398847)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\017E\00E1dejte sv\00E9ho spr\00E1vce datab\00E1ze o spu\0161t\011Bn\00ED skriptu $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731072521398847)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'cs'
,p_message_text=>unistr('Bal\00ED\010Dek SYS.DBMS_LDAP neexistuje nebo je neplatn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730906933398847)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED u\017Eivatelsk\00E9 funkce LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731284228398847)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED autentizace LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732047028398847)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba v argumentu v procedu\0159e p_flow_page procedury login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731655695398847)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E9 p_session ve wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779570259398882)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\0161kozen\00FD argument pro wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731744315398847)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'cs'
,p_message_text=>unistr('Do p\0159ihla\0161ovac\00ED procedury byla p\0159ed\00E1na hodnota null jako u\017Eivatelsk\00E9 jm\00E9no.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720581188398839)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Dkejte <span id="apex_login_throttle_sec">%0</span> sekund a pak se p\0159ihlaste znovu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721862792398840)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Pokus o p\0159ihl\00E1\0161en\00ED byl zablokov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777305927398880)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>'Autentizace "%0" nebyla nalezena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722148071398840)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'cs'
,p_message_text=>unistr('ID skupiny zabezpe\010Den\00ED je null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731562385398847)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i prov\00E1d\011Bn\00ED procesu po autentizaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731346998398847)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED procesu p\0159ed autentizac\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732544118398848)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'cs'
,p_message_text=>unistr('Otev\0159ete adresu URL ve stejn\00E9m prohl\00ED\017Ee\010Di, kde jste zah\00E1jili po\017Eadavek Obnovit heslo.  Kdy\017E klikn\011Bte na adresu URL Obnovit heslo a budete p\0159esm\011Brov\00E1ni na p\0159ihla\0161ovac\00ED str\00E1nku, zahajte po\017Eadavek Obnovit heslo znovu a nechte prohl\00ED\017Ee\010D otev\0159en\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877825198398954)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'cs'
,p_message_text=>unistr('Adresa URL pro obnoven\00ED hesla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714877908398835)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'cs'
,p_message_text=>unistr('Skupina spot\0159ebitel\016F %0 aplikace Resource Manager nebyla ud\011Blena pro %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714971448398835)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro ud\011Blen\00ED chyb\011Bj\00EDc\00EDho opr\00E1vn\011Bn\00ED pou\017Eijte skupinu DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742959645398855)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED funkce uk\00E1zky relace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743065861398855)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED funkce ov\011B\0159en\00ED relace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743215368398855)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\017E\00E1dejte sv\00E9ho spr\00E1vce %0 o konfiguraci modulu pro p\0159ihl\00E1\0161en\00ED typu Single Sign-On aplikace Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752728077398862)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E9 %0 v tokenu %1 vr\00E1cen\00E9m ze SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731920688398847)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'cs'
,p_message_text=>unistr('Upravte sch\00E9ma autentizace a p\0159idejte n\00E1zev aplikace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752426603398862)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD volaj\00EDc\00ED procedury %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752608388398862)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 relace aplikace v tokenu urlc: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752272686398862)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba v portal_sso_redirect: chyb\00ED registra\010Dn\00ED \00FAdaje aplikace: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743178200398855)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'cs'
,p_message_text=>unistr('Bal\00ED\010Dek WWSEC_SSO_ENABLER_PRIVATE neexistuje nebo je neplatn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110731801229398847)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Ve sch\00E9matu autentizace nelze naj\00EDt n\00E1zev registrovan\00E9 aplikace partnera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752373159398862)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'cs'
,p_message_text=>unistr('Registrujte tuto aplikaci podle popisu v p\0159\00EDru\010Dce pro instalaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743338308398856)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED autentizace SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852783870398935)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'cs'
,p_message_text=>unistr('Neautorizovan\00E1 adresa URL:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742727955398855)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED autentizace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714773305398835)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'cs'
,p_message_text=>unistr('Pracovn\00ED prostor "%0" je neaktivn\00ED. Obra\0165te se na spr\00E1vce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715106051398835)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'cs'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721594208398840)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDstup byl odep\0159en kontrolou zabezpe\010Den\00ED aplikace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721601594398840)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDstup byl odep\0159en kontrolou zabezpe\010Den\00ED str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721796040398840)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED autorizace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785149488398886)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'cs'
,p_message_text=>unistr('Sestaveno v %0 s pou\017Eit\00EDm %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785233603398886)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'cs'
,p_message_text=>'nula'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843002673398927)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Popis ud\00E1losti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842850559398927)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'cs'
,p_message_text=>unistr('Datum ukon\010Den\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843102975398928)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'cs'
,p_message_text=>unistr('ID ud\00E1losti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842726953398927)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'cs'
,p_message_text=>unistr('Datum zah\00E1jen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842945275398927)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev ud\00E1losti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733560458398848)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba obsahu kontroln\00EDho sou\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733471165398848)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba form\00E1tu kontroln\00EDho sou\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797463241398895)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'cs'
,p_message_text=>unistr('Zkop\00EDrov\00E1no do schr\00E1nky.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797190434398894)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'cs'
,p_message_text=>unistr('Tento prohl\00ED\017Ee\010D nepodporuje kop\00EDrov\00E1n\00ED z tla\010D\00EDtka nebo nab\00EDdky. Zkuste stisknout Ctrl+C nebo Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785632350398886)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Zav\0159\00EDt upozorn\011Bn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841680306398926)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'cs'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836112600398922)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836094576398922)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010D\00E1te\010Dn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840211450398925)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED b\00FDt platn\00E1 barva. P\0159\00EDklad: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835963365398922)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'cs'
,p_message_text=>'Zvolte barvu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836292839398923)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zm\011Bnit form\00E1t barvy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875479667398952)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'cs'
,p_message_text=>'Seznam hodnot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875500965398952)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'cs'
,p_message_text=>unistr('Otev\0159\00EDt seznam pro: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855774711398937)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'cs'
,p_message_text=>unistr('(Dokon\010Deno)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748013993398859)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'cs'
,p_message_text=>unistr('Kontaktujte spr\00E1vce aplikace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762403436398869)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Obra\0165te se na spr\00E1vce aplikace.'),
unistr('Podrobnosti o tomto incidentu jsou dostupn\00E9 prost\0159ednictv\00EDm ladic\00EDho id "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840577973398926)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed ulo\017Een\00EDm opravte chyby.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786576712398887)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Nalezen\00E9 shody - %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786469878398887)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyly nalezeny \017E\00E1dn\00E9 shody')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856203273398938)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED pr\016Fb\011Bh')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840955640398926)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Soubor ur\010Den\00FD v polo\017Ece %0 neexistuje v APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829437931398918)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED verze dat v\00A0datab\00E1zi se od zah\00E1jen\00ED procesu aktualizace u\017Eivatelem zm\011Bnila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798521225398895)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'cs'
,p_message_text=>unistr('Nenahr\00E1vat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845567545398929)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159edb\011B\017En\00E9ho zpracov\00E1n\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845365342398929)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vlo\017Eit \0159\00E1dek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859409170398940)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\0159ad\00ED : Akce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845455225398929)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktualizovat \0159\00E1dek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786985548398887)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyskakovac\00ED kalend\00E1\0159: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709534673398831)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709631214398831)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845776980398929)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED m\00EDt n\011Bjakou hodnotu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845647382398929)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED b\00FDt platn\00E9 datum, nap\0159\00EDklad %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713205334398833)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnota #LABEL# mus\00ED b\00FDt mezi %0 a\00A0%1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713387039398833)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnota #LABEL# se mus\00ED shodovat nebo n\00E1sledovat po %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713411467398834)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnota #LABEL# se mus\00ED shodovat nebo p\0159edch\00E1zet hodnot\011B\00A0%0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790478118398890)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# je pozd\011Bj\0161\00ED ne\017E zadan\00E9 nejpozd\011Bj\0161\00ED datum %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790869118398890)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# neodpov\00EDd\00E1 form\00E1tu %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790312246398890)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# je star\0161\00ED ne\017E zadan\00E9 nejstar\0161\00ED datum %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790528543398890)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# nen\00ED v platn\00E9m rozsahu %0 a\017E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790732477398890)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# nen\00ED v platn\00E9m rozsahu let %0 a\017E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840828301398926)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Zru\0161it')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868073075398947)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zav\0159\00EDt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870095307398948)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840645046398926)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'cs'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840735306398926)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746910544398858)
,p_name=>'APEX.ERROR'
,p_message_language=>'cs'
,p_message_text=>'Chyba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714380923398834)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159i prov\00E1d\011Bn\00ED zp\011Btn\00E9ho vol\00E1n\00ED zpracov\00E1n\00ED chyby se vyskytla n\00E1sleduj\00EDc\00ED chyba: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723031578398841)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Do\0161lo k chyb\011B p\0159i vykreslov\00E1n\00ED chybov\00E9 str\00E1nky: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715046462398835)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vnit\0159n\00ED chyba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854856201398937)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Obra\0165te se na spr\00E1vce.'),
unistr('Podrobnosti o tomto incidentu jsou dostupn\00E9 prost\0159ednictv\00EDm ladic\00EDho id "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849117724398932)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'cs'
,p_message_text=>unistr('Datab\00E1ze je otev\0159ena pro p\0159\00EDstup pouze ke \010Dten\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879773773398955)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'cs'
,p_message_text=>unistr('ORA-28353: Otev\0159en\00ED walletu selhalo. Data aplikace nyn\00ED nejsou p\0159\00EDstupn\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849292221398932)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Je n\00E1m l\00EDto, ale tato str\00E1nka nen\00ED k dispozici')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716706338398836)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'cs'
,p_message_text=>unistr('Technick\00E9 informace (viditeln\00E9 pouze pro v\00FDvoj\00E1\0159e)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812846906398906)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'cs'
,p_message_text=>unistr('Hl\00E1\0161en\00ED o\00A0chyb\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826707903398916)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('O\010Dek\00E1van\00FD form\00E1t: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793433903398892)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatel je ji\017E v seznamu \0159\00EDzen\00ED p\0159\00EDstupu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793342685398892)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'cs'
,p_message_text=>unistr('Potvr\010Fte p\0159id\00E1n\00ED %0 u\017Eivatele/u\017Eivatel\016F  do seznamu \0159\00EDzen\00ED p\0159\00EDstupu <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793856677398892)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'cs'
,p_message_text=>unistr('Existuje duplicitn\00ED u\017Eivatel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793502020398892)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyb\011Bj\00EDc\00ED zavin\00E1\010D (@) v\00A0e-mailov\00E9 adrese')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793641019398892)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyb\011Bj\00EDc\00ED te\010Dka(.) v\00A0e-mailov\00E9 adrese')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793753109398892)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatelsk\00E9 jm\00E9no je p\0159\00EDli\0161 dlouh\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794054448398892)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'cs'
,p_message_text=>unistr('K\00A0t\00E9to aplikaci maj\00ED p\0159\00EDstup pouze u\017Eivatel\00E9 definovan\00ED v\00A0seznamu \0159\00EDzen\00ED p\0159\00EDstupu aplikace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794155905398892)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Neo\010Dek\00E1van\00E1 hodnota nastaven\00ED \0159\00EDzen\00ED p\0159\00EDstupu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793961458398892)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'cs'
,p_message_text=>unistr('K\00A0t\00E9to aplikaci maj\00ED p\0159\00EDstup v\0161ichni ov\011B\0159en\00ED u\017Eivatel\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836717723398923)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'cs'
,p_message_text=>unistr('Zak\00E1z\00E1no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836676103398923)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'cs'
,p_message_text=>'Povoleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836985080398923)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'cs'
,p_message_text=>unistr('%0: Je zak\00E1z\00E1no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836865580398923)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'cs'
,p_message_text=>'%0: Je povoleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836581732398923)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'cs'
,p_message_text=>unistr('Nezji\0161t\011Bno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829619440398918)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('St\00E1hnout')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786130095398887)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159i\0159azen\00FD filtr %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827278608398916)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'cs'
,p_message_text=>unistr('Pou\017E\00EDt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712120329398833)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupcov\00FD graf')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839904543398925)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'cs'
,p_message_text=>unistr('Ostatn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712262889398833)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDse\010Dov\00FD graf')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838654465398924)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'cs'
,p_message_text=>'Graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711958643398832)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827740602398916)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'cs'
,p_message_text=>'Vymazat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827894929398917)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vymazat v\0161e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827968347398917)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'cs'
,p_message_text=>'Vymazat %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845122669398929)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec %1, odkazovan\00FD z fazety %0, nen\00ED dostupn\00FD nebo nen\00ED autorizov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702370976398826)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte filtry, kter\00E9 chcete zobrazit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784353046398885)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00FDsledk\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784461282398885)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybr\00E1no %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787070370398887)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED filtry')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703833889398827)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Seznam filtr\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843604719398928)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'cs'
,p_message_text=>unistr('Limit jedine\010Dn\00FDch hodnot (%0) p\0159ekro\010Den pro fazetu %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829253547398918)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Fazeta %0 nen\00ED podporov\00E1na u sloupc\016F typu DATE nebo TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827309389398916)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'cs'
,p_message_text=>'Filtr %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827466554398916)
,p_name=>'APEX.FS.GO'
,p_message_language=>'cs'
,p_message_text=>'Spustit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828839239398917)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('rovn\00E1 se %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712926742398833)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'cs'
,p_message_text=>'obsahuje %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712664814398833)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'cs'
,p_message_text=>unistr('v\00EDce ne\017E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712745449398833)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'cs'
,p_message_text=>unistr('v\00EDce ne\017E nebo rovno %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712403916398833)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'cs'
,p_message_text=>unistr('m\00E9n\011B ne\017E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712500200398833)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'cs'
,p_message_text=>unistr('m\00E9n\011B ne\017E nebo rovno %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712800718398833)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'cs'
,p_message_text=>unistr('za\010D\00EDn\00E1 na\00A0%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715327695398835)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Datov\00FD typ %0 (%1) nen\00ED podporov\00E1n u fazety Vstupn\00ED pole.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705565171398828)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00EDcehodnotov\00E9 fazety vy\017Eaduj\00ED datab\00E1zi verze 12.2 nebo nov\011Bj\0161\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829020490398917)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyly zad\00E1ny \017E\00E1dn\00E9 vyhled\00E1vac\00ED sloupce pro fazetu %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702488679398826)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00EDce filtr\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784526629398886)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'cs'
,p_message_text=>unistr('Za\010D\00E1tek rozsahu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828551471398917)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 a\017E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828620907398917)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'cs'
,p_message_text=>'Nad %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828747688398917)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'cs'
,p_message_text=>'Pod %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784603492398886)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'cs'
,p_message_text=>'Konec rozsahu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847473874398931)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eka seznamu hodnot #%2 ("%1") pro fazetu rozsahu %0 je neplatn\00E1 (chyb\00ED odd\011Blova\010D "|").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828918638398917)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'cs'
,p_message_text=>unistr('Ru\010Dn\00ED vstup pro fazetu rozsahu %0 nyn\00ED nen\00ED podporov\00E1n, proto\017Ee sloupec je typu DATE nebo TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828283429398917)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('a\017E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712002660398833)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'cs'
,p_message_text=>'Odebrat graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781129874398883)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'cs'
,p_message_text=>'Obnovit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827625563398916)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827510969398916)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'cs'
,p_message_text=>'Vyhledat...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828472457398917)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'cs'
,p_message_text=>unistr('-\00A0Vybrat\00A0-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711877580398832)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828026954398917)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazit m\00E9n\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828119526398917)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazit v\00EDce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110828339852398917)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 a v\00EDce hv\011Bzdi\010Dek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786053614398887)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1vrhy filtru')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829125903398917)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Fazeta textov\00E9ho pole %0 je nyn\00ED podporov\00E1na pouze u sloupc\016F typu NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702204593398826)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00FD po\010Det \0159\00E1dk\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845274789398929)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Datov\00FD typ %0 (%1) nen\00ED podporov\00E1n ve fazetov\00E9m vyhled\00E1v\00E1n\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837123969398923)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ej\00EDt na chybu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794768194398893)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>'Agregovat.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802335711398898)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'cs'
,p_message_text=>unistr('Sbalit P\0159eru\0161en\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794855175398893)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159eru\0161en\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802293802398898)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozbalit P\0159eru\0161en\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880953896398956)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>'Sloupec %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802036239398898)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Odstran\011Bn\00E9 \0159\00E1dk\016F: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872414537398950)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'cs'
,p_message_text=>unistr('Duplicitn\00ED identita')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791722545398891)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Prvn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795073066398893)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Z\00E1hlav\00ED skupiny.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794993321398893)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Z\00E1hlav\00ED.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791825356398891)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811885019398905)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDst dal\0161\00ED \0159\00E1dky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791518358398890)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795197928398893)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dky str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791932998398891)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'cs'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792071607398891)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'cs'
,p_message_text=>unistr('%0\2013%1 z\00A0%2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848025392398931)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDb\011Br str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791670784398890)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872221187398950)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159id\00E1no')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872317750398950)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'cs'
,p_message_text=>unistr('Zm\011Bn\011Bno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880725768398956)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dka %0, Sloupec %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880839366398956)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dka %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872138475398950)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'cs'
,p_message_text=>unistr('Odstran\011Bno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795322334398893)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'cs'
,p_message_text=>unistr('Z\00E1hlav\00ED \0159\00E1dky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790936674398890)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybr\00E1no %0 bun\011Bk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792172602398891)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det vybran\00FDch \0159\00E1dek: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832455459398920)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybrat v\0161e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802144258398898)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'cs'
,p_message_text=>unistr('Str\00E1nka %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795207607398893)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybrat \0159\00E1dek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795475833398893)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159azeno vzestupn\011B %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795551862398893)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159azeno sestupn\011B %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791044607398890)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit vzestupn\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791395704398890)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit vzestupn\011B %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791155926398890)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit sestupn\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791405549398890)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit sestupn\011B %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110791268524398890)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'cs'
,p_message_text=>unistr('Nese\0159azovat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801948268398898)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'cs'
,p_message_text=>'Celkem %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728356551398845)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\017Eadavek HTTP na "%0" selhal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869698226398948)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'cs'
,p_message_text=>unistr('Seznam v\00FDb\011Bru m\0159\00ED\017Eky m\00E1 %0\00A0sloupc\016F a\00A0%1\00A0\0159\00E1dek. Pou\017Eijte kl\00E1vesy se \0161ipkami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801808127398898)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte \0159\00E1dky seznamu %0. Pou\017Eijte kl\00E1vesy se \0161ipkami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880540158398956)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Interaktivn\00ED m\0159\00ED\017Eka %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788600632398888)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'cs'
,p_message_text=>'Akce'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789684348398889)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789560313398889)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat \0159\00E1dek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874018046398951)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'cs'
,p_message_text=>'Agregovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859593945398940)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'cs'
,p_message_text=>'Agregace'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861223753398942)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('V\0161e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817695952398909)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('V\0161echny textov\00E9 sloupce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818864067398910)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Alternativn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819905575398911)
,p_name=>'APEX.IG.AND'
,p_message_language=>'cs'
,p_message_text=>'a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839304920398925)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ibli\017En\00FD po\010Det jedine\010Dn\00FDch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875063468398952)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00FD pr\016Fm\011Br po\010Dtu jedine\010Dn\00FDch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858145001398939)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'cs'
,p_message_text=>unistr('Plo\0161n\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860022012398941)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Vzestupn\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818925312398910)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'cs'
,p_message_text=>'Autorizace'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874166199398951)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'cs'
,p_message_text=>'Automaticky'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839799051398925)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'cs'
,p_message_text=>unistr('Pr\016Fm\011Br')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874775465398952)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00FD pr\016Fm\011Br')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857661536398939)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev osy \0161t\00EDtku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857837740398939)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Desetinn\00E1 m\00EDsta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857738299398939)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev osy hodnoty')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863813990398944)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Barva pozad\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858289633398939)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupcov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814216775398907)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'cs'
,p_message_text=>'mezi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865043665398944)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'cs'
,p_message_text=>'Oba'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858330931398939)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Bublinov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789829097398889)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Zru\0161it')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819882582398911)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozli\0161ovat mal\00E1 a\00A0velk\00E1 p\00EDsmena')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875691253398952)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'cs'
,p_message_text=>unistr('(Rozli\0161uje mal\00E1 a\00A0velk\00E1 p\00EDsmena)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846582280398930)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'cs'
,p_message_text=>unistr('Zm\011Bny byly ulo\017Eeny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790204583398890)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zm\011Bnit zobrazen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820990416398912)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'cs'
,p_message_text=>'Graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817421122398909)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00E1\0161 dotaz p\0159ekra\010Duje maxim\00E1ln\00ED po\010Det %0\00A0datov\00FDch bod\016F na graf. Pou\017Eijte filtr ke sn\00ED\017Een\00ED po\010Dtu z\00E1znam\016F v\00A0z\00E1kladn\00EDm dotazu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788557543398888)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED sch\00E9matu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795825957398893)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'cs'
,p_message_text=>'Vymazat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857179447398938)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Zav\0159\00EDt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864044914398944)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'cs'
,p_message_text=>'Barvy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840195603398925)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1hled')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819299165398910)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Sloupec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788717853398888)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'cs'
,p_message_text=>'Sloupce'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865807577398945)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('\00DA\010Del sloupce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819375384398911)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'cs'
,p_message_text=>unistr('Komplexn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788951006398889)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vypo\010D\00EDtat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814876482398907)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'cs'
,p_message_text=>'obsahuje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821104780398912)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159eru\0161en\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795686203398893)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'cs'
,p_message_text=>unistr('Kop\00EDrovat do schr\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795795929398893)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'cs'
,p_message_text=>unistr('Zkop\00EDrovat dol\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839143136398925)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839230423398925)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det jedine\010Dn\00FDch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874983036398952)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00FD po\010Det jedine\010Dn\00FDch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874835688398952)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00FD po\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872535732398950)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159it %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817877358398909)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'cs'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865619292398945)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>'Typ dat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865296664398945)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'cs'
,p_message_text=>'Datum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846352072398930)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 hodnota data')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815517601398908)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'cs'
,p_message_text=>'dny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818548403398910)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED nastaven\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818392802398910)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED typ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789781361398889)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'cs'
,p_message_text=>'Odstranit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866894133398946)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'cs'
,p_message_text=>'Opravdu chcete odstranit tuto sestavu?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822906970398913)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Odstranit \0159\00E1dku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821795069398912)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('Odstranit \0159\00E1dky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860105982398941)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Sestupn\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820618463398911)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'cs'
,p_message_text=>'Detail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788294675398888)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED detail\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848876703398932)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Sm\011Br')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820359682398911)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'cs'
,p_message_text=>unistr('Zak\00E1z\00E1no')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814929223398907)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'cs'
,p_message_text=>'neobsahuje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815158610398908)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'cs'
,p_message_text=>unistr('neza\010D\00EDn\00E1 na')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858401495398939)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'cs'
,p_message_text=>unistr('Prstencov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821305980398912)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'cs'
,p_message_text=>unistr('St\00E1hnout')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720074095398838)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'cs'
,p_message_text=>'Pouze data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867894924398947)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Zvolte form\00E1t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732663685398848)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'cs'
,p_message_text=>unistr('Form\00E1t stahov\00E1n\00ED %0 nen\00ED aktivov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860873449398941)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Duplicitn\00ED agregace')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860922165398941)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'cs'
,p_message_text=>unistr('Duplicitn\00ED P\0159eru\0161en\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822875163398913)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Duplikovat \0159\00E1dek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821662232398912)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('Duplicitn\00ED \0159\00E1dky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789391159398889)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'cs'
,p_message_text=>'Upravit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859900526398940)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'cs'
,p_message_text=>'Upravit graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871404993398949)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'cs'
,p_message_text=>'Upravit Seskupit podle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867457989398946)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'cs'
,p_message_text=>unistr('Skryt\00E1 kopie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867688110398946)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'cs'
,p_message_text=>unistr('Zpr\00E1va')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867329438398946)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'cs'
,p_message_text=>'Kopie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867018387398946)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'cs'
,p_message_text=>unistr('E-mail odesl\00E1n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867553866398946)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edm\011Bt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867202383398946)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDjemce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820051394398911)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'cs'
,p_message_text=>'Povoleno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813232460398906)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'cs'
,p_message_text=>'je rovno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866452318398946)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDklad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820146048398911)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDraz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866379495398945)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'cs'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832346668398920)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'cs'
,p_message_text=>unistr('Soubor je p\0159ipraven. Zahajuje se stahov\00E1n\00ED.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110795977980398894)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'cs'
,p_message_text=>'Vyplnit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797026499398894)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyplnit v\00FDb\011Br pomoc\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796939626398894)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDb\011Br v\00FDpln\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788873494398889)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'cs'
,p_message_text=>'Filtrovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819491752398911)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'cs'
,p_message_text=>'Filtry'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874468549398951)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'cs'
,p_message_text=>'Filtrovat...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860348892398941)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'cs'
,p_message_text=>unistr('Prvn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789024737398889)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'cs'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817981921398910)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Form\00E1t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864934744398944)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'cs'
,p_message_text=>unistr('Form\00E1tovac\00ED maska')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866749435398946)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'cs'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866642739398946)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'cs'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779403616398882)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'cs'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718774545398838)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'cs'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822543076398913)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'cs'
,p_message_text=>'Zmrazit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820277406398911)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'cs'
,p_message_text=>unistr('Funkce a\00A0Oper\00E1tory')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858546745398939)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Trycht\00FD\0159ov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839002347398925)
,p_name=>'APEX.IG.GO'
,p_message_language=>'cs'
,p_message_text=>'Spustit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813855760398907)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'cs'
,p_message_text=>unistr('v\011Bt\0161\00ED ne\017E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813966246398907)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'cs'
,p_message_text=>unistr('v\011Bt\0161\00ED nebo rovno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820539059398911)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'cs'
,p_message_text=>unistr('M\0159\00ED\017Eka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788012397398888)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('M\0159\00ED\017Ekov\00E9 zobrazen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861156876398941)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'cs'
,p_message_text=>'Skupina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820771908398911)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'cs'
,p_message_text=>'Seskupit podle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788318440398888)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED seskupen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865574111398945)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Typ podm\00EDnky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864454942398944)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'cs'
,p_message_text=>'Nadpis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864688595398944)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'cs'
,p_message_text=>unistr('Zarovn\00E1n\00ED z\00E1hlav\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874363948398951)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869838272398948)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Data m\016F\017Eete vkl\00E1dat, aktualizovat a odstra\0148ovat p\0159\00EDmo v t\00E9to interaktivn\00ED m\0159\00ED\017Ece.</p>'),
'',
unistr('<p>Nov\00FD \0159\00E1dek vlo\017E\00EDte kliknut\00EDm na tla\010D\00EDtko P\0159idat \0159\00E1dek.</p>'),
'',
unistr('<p>St\00E1vaj\00EDc\00ED data uprav\00EDte poklep\00E1n\00EDm na konkr\00E9tn\00ED bu\0148ku. Chcete-li prov\00E1d\011Bt v\011Bt\0161\00ED \00FApravy, kliknut\00EDm na Upravit p\0159ejd\011Bte do re\017Eimu \00FAprav. V re\017Eimu \00FAprav m\016F\017Eete konkr\00E9tn\00ED bu\0148ky upravit jedin\00FDm kliknut\00EDm nebo pomoc\00ED kl\00E1vesnice.</p>'),
'',
unistr('<p>Pomoc\00ED nab\00EDdky Zm\011Bnit duplikujte a odstra\0148te \0159\00E1dky. Chcete-li povolit nab\00EDdku Zm\011Bnit, vyberte pomoc\00ED za\0161krt\00E1vac\00EDch pol\00ED\010Dek jeden nebo v\00EDce \0159\00E1dk\016F.</p>'),
'',
unistr('<p>Vybran\00FD \0159\00E1dek duplikujte kliknut\00EDm na nab\00EDdku Zm\011Bnit a v\00FDb\011Brem p\0159\00EDkazu Duplikovat \0159\00E1dky. Vybran\00FD \0159\00E1dek odstran\00EDte kliknut\00EDm na nab\00EDdku Zm\011Bnit a v\00FDb\011Brem polo\017Eky Odstranit \0159\00E1dek.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871900795398950)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'cs'
,p_message_text=>unistr('\00DApravy - mo\017Enosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872051886398950)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interaktivn\00ED m\0159\00ED\017Eka p\0159edstavuje sadu dat v prohled\00E1vateln\00E9 a p\0159izp\016Fsobiteln\00E9 sestav\011B. M\016F\017Eete omezit po\010Det vr\00E1cen\00FDch z\00E1znam\016F a zm\011Bnit zp\016Fsob zobrazen\00ED dat.</p>'),
'',
unistr('<p>Pomoc\00ED pole Hledat m\016F\017Eete filtrovat vr\00E1cen\00E9 z\00E1znamy. Kliknut\00EDm na polo\017Eku Akce z\00EDsk\00E1te p\0159\00EDstup k mnoha mo\017Enostem \00FApravy rozvr\017Een\00ED sestavy nebo pou\017Eijte nab\00EDdky Z\00E1hlav\00ED sloupc\016F v zobrazen\00FDch sloupc\00EDch.</p>'),
'',
unistr('<p>Pomoc\00ED dialogu Nastaven\00ED sestavy ulo\017Ete sv\00E9 \00FApravy sestavy. Data ze zpr\00E1vy si tak\00E9 m\016F\017Eete st\00E1hnout do extern\00EDho souboru nebo je odeslat e-mailem sob\011B nebo ostatn\00EDm.</p>'),
'',
unistr('<p>Dal\0161\00ED informace naleznete v \010D\00E1sti \201EPou\017E\00EDv\00E1n\00ED interaktivn\00EDch m\0159\00ED\017Eek\201C v <em>P\0159\00EDru\010Dce koncov\00E9ho u\017Eivatele Oracle Application Express</em>.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871794552398949)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ehled')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869723683398948)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interaktivn\00ED m\0159\00ED\017Eku m\016F\017Eete pomoc\00ED vestav\011Bn\00FDch funkc\00ED p\0159izp\016Fsobit tak, aby zobrazovala data r\016Fzn\00FDmi zp\016Fsoby.</p>'),
'',
unistr('<p>Nab\00EDdky Z\00E1hlav\00ED sloupc\016F a Akce umo\017E\0148uj\00ED ur\010Dit, kter\00E9 sloupce se maj\00ED zobrazit, v jak\00E9m po\0159ad\00ED a tak\00E9 sloupce zmrazit. M\016F\017Eete tak\00E9 definovat r\016Fzn\00E9 datov\00E9 filtry a se\0159adit vr\00E1cen\00E1 data.</p>'),
'',
unistr('<p>Pomoc\00ED tla\010D\00EDtka Zobrazit (vedle pole Hledat) z\00EDsk\00E1te p\0159\00EDstup k dal\0161\00EDm zobrazen\00EDm dat, kter\00E1 mohla b\00FDt definov\00E1na v\00FDvoj\00E1\0159em aplikace. M\016F\017Eete tak\00E9 vytvo\0159it graf nebo zobrazit existuj\00EDc\00ED graf.</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Kliknut\00EDm na polo\017Eku <strong>N\00E1pov\011Bda</strong> v dialogov\00FDch oknech interaktivn\00ED m\0159\00ED\017Eky z\00EDsk\00E1te podrobn\011Bj\0161\00ED informace o vybran\00E9 funkci.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871807762398950)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'cs'
,p_message_text=>unistr('Vykazov\00E1n\00ED - mo\017Enosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821509121398912)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda interaktivn\00ED m\0159\00ED\017Eky.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868636992398947)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tento dialog pou\017Eijte k agregaci sloupc\016F. Agregovan\00E9 hodnoty se zobrazuj\00ED ve spodn\00ED \010D\00E1sti dat, nebo - pokud jsou definov\00E1na p\0159eru\0161en\00ED - ve spodn\00ED \010D\00E1sti ka\017Ed\00E9ho p\0159eru\0161en\00ED. </p>'),
'',
unistr('<p><strong>Seznam agregac\00ED</strong><br>'),
unistr('Seznam Agregace zobrazuje definovan\00E9 agregace. St\00E1vaj\00EDc\00ED agregaci deaktivujete zru\0161en\00EDm v\00FDb\011Bru.<br>'),
unistr('Kliknut\00EDm na P\0159idat ( &plus; ) vytvo\0159\00EDte novou agregaci, kliknut\00EDm na Odstranit ( &minus; ) odstran\00EDte st\00E1vaj\00EDc\00ED agregaci.</p>'),
'',
unistr('<p><strong>Nastaven\00ED agregace</strong><br>'),
unistr('K definici agregace pou\017Eijte formul\00E1\0159 vpravo.<br>'),
unistr('Vyberte n\00E1zev sloupce a typ agregace.<br>'),
unistr('Voliteln\011B zadejte popis agregace.<br>'),
unistr('Pokud jste definovali p\0159eru\0161en\00ED, v\00FDb\011Brem mo\017Enosti <strong>Zobrazit celkovou hodnotu</strong> se v doln\00ED \010D\00E1sti dat zobraz\00ED celkov\00FD pr\016Fm\011Br, sou\010Det nebo podobn\00E1 hodnota.</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Dialog Agregace je p\0159\00EDstupn\00FD v nab\00EDdce Akce nebo po kliknut\00ED na z\00E1hlav\00ED sloupce a sou\010Det ( &sum; ). </em> </p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870889912398949)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0Agregac\00EDm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869341357398948)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>V tomto dialogu definujete graf, kter\00FD se zobraz\00ED jako samostatn\00E9 zobrazen\00ED \00FAdaj\016F.<br>'),
'Vyberte typ grafu a atributy grafu.</p>',
'<p><strong>Atributy grafu</strong></br>',
unistr('Dostupn\00E9 atributy grafu se li\0161\00ED v z\00E1vislosti na typu grafu.</p>'),
'<p>',
'<ul>',
unistr('  <li>Vyberte sloupec obsahuj\00EDc\00ED hodnotu pro atribut:'),
'    <ul>',
unistr('      <li>Popisek - Text pro ka\017Ed\00FD datov\00FD bod.</li>'),
unistr('      <li>Hodnota - Data, kter\00E1 maj\00ED b\00FDt vykreslen\00E1.</li>'),
unistr('      <li>\0158ady - Pro definov\00E1n\00ED dynamick\00E9ho dotazu s v\00EDce \0159adami.</li>'),
unistr('      <li>Otv\00EDrac\00ED - Denn\00ED otev\00EDrac\00ED skladov\00E1 cena (pouze burzovn\00ED).</li>'),
unistr('      <li>Kone\010Dn\00E1 - Denn\00ED kone\010Dn\00E1 skladov\00E1 cena (pouze burzovn\00ED).</li>'),
unistr('      <li>Vysok\00E1 - Vysok\00E1 hodnota (pouze rozsahy a akcie).</li>'),
unistr('      <li>N\00EDzk\00E1 - N\00EDzk\00E1 hodnota (pouze rozsahy a akcie).</li>'),
unistr('      <li>Objem - Denn\00ED objem z\00E1sob (pouze burzovn\00ED).</li>'),
unistr('      <li>C\00EDl - C\00EDlov\00E1 hodnota (pouze trycht\00FD\0159ov\00FD).</li>'),
unistr('      <li>X - Hodnota osy x (pouze bublinov\00E1 a bodov\00E1).</li>'),
unistr('      <li>Y - Hodnota osy y (pouze bublinov\00E1 a bodov\00E1).</li>'),
unistr('      <li>Z - \0160\00ED\0159ka pruhu nebo pom\011Br bubliny (pouze pruhov\00E1, bublinov\00E1 a rozsahov\00E1).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Orientace - Svisl\00E1 nebo vodorovn\00E1.</li>'),
unistr('  <li>Agregace - V\00FDb\011Br, jak agregovat hodnoty grafu.</li>'),
unistr('  <li>Skl\00E1d\00E1n\00ED - Ur\010Den\00ED, zda jsou datov\00E9 polo\017Eky skl\00E1d\00E1ny.</li>'),
unistr('  <li>Se\0159adit podle - Se\0159azen\00ED podle popisku nebo hodnot.'),
'    <ul>',
unistr('      <li>Sm\011Br - \0158azen\00ED ve vzestupn\00FDch nebo sestupn\00FDch hodnot\00E1ch.</li>'),
unistr('      <li>Nulov\00E9 hodnoty - Ur\010Den\00ED, jak se\0159adit z\00E1znamy s hodnotami null vzhledem k z\00E1znam\016Fm s ne-null hodnotami.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Desetinn\00E1 m\00EDsta</li>'),
unistr('  <li>N\00E1zev osy popisku</li>'),
unistr('  <li>N\00E1zev osy hodnoty</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871230237398949)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda ke Graf\016Fm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868399334398947)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>V tomto dialogu ur\010D\00EDte, kter\00E9 sloupce se zobraz\00ED a v jak\00E9m po\0159ad\00ED.</p>'),
'',
unistr('<p>Sloupec skryjete zru\0161en\00EDm jeho v\00FDb\011Bru.<br>'),
unistr('Po\0159ad\00ED sloupc\016F zm\011Bn\00EDte kliknut\00EDm na tla\010D\00EDtka P\0159esunout nahoru ( &uarr; ) nebo P\0159esunout dol\016F ( &darr; ).<br>'),
unistr('V rozev\00EDrac\00EDm seznamu m\016F\017Eete zvolit V\0161echny sloupce, Zobrazen\00E9 sloupce nebo Nezobrazen\00E9 sloupce.</p>'),
'',
unistr('<p>Voliteln\011B ve formul\00E1\0159i ur\010Dete minim\00E1ln\00ED \0161\00ED\0159ku sloupce v pixelech.</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Po\0159ad\00ED zobrazen\00FDch sloupc\016F m\016F\017Eete zm\011Bnit tak\00E9 tak, \017Ee klikn\011Bte na \00FAchyt pro p\0159eta\017Een\00ED (na za\010D\00E1tku z\00E1hlav\00ED sloupce) a p\0159et\00E1hn\011Bte sloupec doleva \010Di doprava. \0160\00ED\0159ku zobrazen\00E9ho sloupce m\016F\017Eete zm\011Bnit tak\00E9 v\00FDb\011Brem odd\011Blova\010De sloupce mezi z')
||unistr('\00E1hlav\00EDmi a jeho p\0159eta\017Een\00EDm doleva \010Di doprava.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871160284398949)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupce - n\00E1pov\011Bda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868791485398947)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tento dialog pou\017Eijte k definov\00E1n\00ED dal\0161\00EDch sloupc\016F na z\00E1klad\011B matematick\00FDch a funk\010Dn\00EDch v\00FDpo\010Dt\016F proveden\00FDch proti existuj\00EDc\00EDm sloupc\016Fm.</p>'),
'',
unistr('<p><strong>V\00FDpo\010Detn\00ED seznam</strong><br>'),
unistr('Seznam V\00FDpo\010Det zobrazuje definovan\00E9 v\00FDpo\010Dty. St\00E1vaj\00EDc\00ED v\00FDpo\010Det deaktivujete zru\0161en\00EDm v\00FDb\011Bru.<br>'),
unistr('Kliknut\00EDm na P\0159idat ( &plus; ) p\0159id\00E1te nov\00FD v\00FDpo\010Det, kliknut\00EDm na Odstranit ( &minus; ) odstran\00EDte st\00E1vaj\00EDc\00ED v\00FDpo\010Det.</p>'),
'',
unistr('<p><strong>Nastaven\00ED v\00FDpo\010Dtu</strong><br>'),
unistr('K definici v\00FDpo\010Dtu pou\017Eijte formul\00E1\0159.<br>'),
unistr('Zadejte podrobnosti sloupce, nap\0159\00EDklad nadpis, popisek a vyberte nastaven\00ED zarovn\00E1n\00ED.<br>'),
unistr('V textov\00E9 oblasti V\00FDraz zadejte sloupce a souvisej\00EDc\00ED funkce pro v\00FDpo\010Det.<br>'),
unistr('Vyberte pot\0159ebn\00FD datov\00FD typ pro nov\00FD sloupec a p\0159\00EDpadn\011B masku form\00E1tu.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870756441398949)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0V\00FDpo\010Dt\016Fm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869096854398947)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tento dialog pou\017Eijte k definov\00E1n\00ED p\0159eru\0161en\00ED v jednom nebo v\00EDce sloupc\00EDch.</p>'),
'',
unistr('<p><strong>Seznam p\0159eru\0161en\00ED</strong><br>'),
unistr('Seznam p\0159eru\0161en\00ED zobrazuje definovan\00E1 p\0159eru\0161en\00ED. St\00E1vaj\00EDc\00ED sloupec p\0159eru\0161en\00ED deaktivujte zru\0161en\00EDm jeho v\00FDb\011Bru.<br>'),
unistr('Kliknut\00EDm na P\0159idat ( &plus; ) zahrnete do p\0159eru\0161en\00ED nov\00FD sloupec, kliknut\00EDm na Odstranit ( minus; ) odstran\00EDte existuj\00EDc\00ED sloupec z p\0159eru\0161en\00ED.<br>'),
unistr('Chcete-li zm\011Bnit po\0159ad\00ED sloupc\016F, kliknut\00EDm na P\0159esunout nahoru ( &uarr; ) nebo P\0159esunout dol\016F ( &darr; ) p\0159esu\0148te vybran\00FD sloupec nahoru a dol\016F vzhledem k ostatn\00EDm sloupc\016Fm. </p>'),
'',
unistr('<p><strong>Nastaven\00ED p\0159eru\0161en\00ED</strong><br>'),
unistr('K definici sloupce p\0159eru\0161en\00ED pou\017Eijte formul\00E1\0159.<br>'),
unistr('Ve formul\00E1\0159i ur\010D\00EDte sloupec p\0159eru\0161en\00ED, sm\011Br \0159azen\00ED a zp\016Fsob \0159azen\00ED sloupc\016F s hodnotou null (sloupce bez hodnoty).</p>'),
'',
unistr('<p><em>Pozn\00E1mka: P\0159i prohl\00ED\017Een\00ED interaktivn\00ED m\0159\00ED\017Eky m\016F\017Eete definovat p\0159eru\0161en\00ED kliknut\00EDm na z\00E1hlav\00ED sloupce a v\00FDb\011Brem ikony p\0159eru\0161en\00ED.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870443005398948)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0P\0159eru\0161en\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869224103398948)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomoc\00ED tohoto dialogu st\00E1hnete v\0161echny aktu\00E1ln\00ED \0159\00E1dky do extern\00EDho souboru. Soubor bude obsahovat pouze aktu\00E1ln\011B zobrazen\00E9 sloupce s daty ovlivn\011Bn\00FDmi pou\017Eit\00FDmi filtry a \0159azen\00EDm.</p>'),
'',
unistr('<p>Vyberte form\00E1t souboru a klikn\011Bte na St\00E1hnout.<br>'),
unistr('Pozn\00E1mka: Soubor CSV nebude zahrnovat form\00E1tov\00E1n\00ED textu, nap\0159\00EDklad agregace a p\0159eru\0161en\00ED.</p>'),
'',
unistr('<p>Chcete-li soubor poslat e-mailem, vyberte Odeslat jako e-mail a zadejte podrobnosti (p\0159\00EDjemce, p\0159edm\011Bt a zpr\00E1va). </p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870265449398948)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda ke Stahov\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868479683398947)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>V tomto dialogu konfigurujete filtry dat, kter\00E9 omezuj\00ED po\010Det vr\00E1cen\00FDch \0159\00E1dk\016F.</p>'),
'',
unistr('<p><strong>Seznam filtr\016F</strong><br>'),
unistr('Seznam filtr\016F zobrazuje definovan\00E9 filtry. Existuj\00EDc\00ED filtr deaktivujete zru\0161en\00EDm jeho v\00FDb\011Bru.<br>'),
unistr('Kliknut\00EDm na tla\010D\00EDtko P\0159idat ( &plus; ) vytvo\0159\00EDte nov\00FD filtr, kliknut\00EDm na Odstranit ( &minus; ) odeberete st\00E1vaj\00EDc\00ED filtr.</p>'),
'',
unistr('<p><strong>Nastaven\00ED filtru</strong><br>'),
unistr('K definici vlastnost\00ED filtru pou\017Eijte formul\00E1\0159.<br>'),
unistr('Vyberte p\0159\00EDslu\0161n\00FD typ filtru:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0158\00E1dek - filtr pro pojem v libovoln\00E9m filtrovateln\00E9m sloupci.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sloupec - filtrov\00E1n\00ED ur\010Dit\00E9ho sloupce pomoc\00ED oper\00E1toru a hodnoty.</p>'),
'',
unistr('<p><em>Pozn\00E1mka: P\0159i prohl\00ED\017Een\00ED interaktivn\00ED m\0159\00ED\017Eky m\016F\017Eete definovat filtry \0159\00E1dk\016F p\0159\00EDm\00FDm z\00E1pisem do pole Hledat. Po kliknut\00ED na volbu Vyberte sloupce, kter\00E9 chcete vyhledat omez\00EDte vyhled\00E1v\00E1n\00ED na ur\010Dit\00FD sloupec. Alternativn\011B otev\0159ete nab\00EDdku Z\00E1hlav\00ED ')
||unistr('sloupce a vyberte hodnotu pro vytvo\0159en\00ED filtru sloupce.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871011538398949)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0Filtr\016Fm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868877422398947)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tento dialog pou\017Eijte k zobrazen\00ED dat tak, jak existovaly v p\0159edchoz\00EDm \010Dasov\00E9m okam\017Eiku.</p>'),
unistr('<p>Zadejte po\010Det minut v minulosti k proveden\00ED zp\011Btn\00E9ho dotazu.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870620982398949)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0Flashbacku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871396202398949)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0Seskupen\00EDm podle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868911935398947)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tento dialog pou\017Eijte k zv\00FDrazn\011Bn\00ED \0159\00E1dk\016F nebo sloupc\016F dat na z\00E1klad\011B zadan\00E9 podm\00EDnky.</p>'),
'',
unistr('<p><strong>Seznam Zv\00FDrazn\011Bn\00ED</strong><br>'),
unistr('Seznam Zv\00FDrazn\011Bn\00ED zobrazuje definovan\00E1 zv\00FDrazn\011Bn\00ED. St\00E1vaj\00EDc\00ED zv\00FDrazn\011Bn\00ED deaktivujete zru\0161en\00EDm v\00FDb\011Bru.<br>'),
unistr('Kliknut\00EDm na P\0159idat (& plus;) vytvo\0159\00EDte nov\00E9 zv\00FDrazn\011Bn\00ED, kliknut\00EDm na Odstranit (& minus;) zv\00FDrazn\011Bn\00ED odstran\00EDte.</p>'),
'',
unistr('<p><strong>Nastaven\00ED zv\00FDrazn\011Bn\00ED</strong><br>'),
unistr('Vlastnosti zv\00FDrazn\011Bn\00ED se definuj\00ED ve formul\00E1\0159i.<br>'),
unistr('Zadejte n\00E1zev, vyberte \0158\00E1dek nebo Sloupec a vyberte barevn\00E9 k\00F3dy HTML pro pozad\00ED a text. <br>'),
unistr('Chcete-li zv\00FDraznit konkr\00E9tn\00ED data, vyberte p\0159\00EDslu\0161n\00FD <strong>Typ podm\00EDnky</strong>:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0158\00E1dek - zv\00FDrazn\00ED v\00FDraz v libovoln\00E9m sloupci.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sloupec - zv\00FDrazn\011Bn\00ED v konkr\00E9tn\00EDm sloupci na z\00E1klad\011B zadan\00E9ho oper\00E1toru a hodnoty.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870558960398949)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda ke Zv\00FDrazn\011Bn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869162319398948)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tento dialog pou\017Eijte k ulo\017Een\00ED zm\011Bn, kter\00E9 jste provedli v aktu\00E1ln\00EDm rozlo\017Een\00ED a konfiguraci m\0159\00ED\017Eky.<br>'),
unistr('V\00FDvoj\00E1\0159i aplikac\00ED mohou definovat v\00EDce alternativn\00EDch rozvr\017Een\00ED sestav. Je-li to mo\017En\00E9, m\016F\017Eete vy a dal\0161\00ED koncov\00ED u\017Eivatel\00E9 ulo\017Eit sestavu jako ve\0159ejnou, \010Dili p\0159\00EDstupnou v\0161em ostatn\00EDm u\017Eivatel\016Fm m\0159\00ED\017Eky. Sestavu m\016F\017Eete tak\00E9 ulo\017Eit jako soukromou, a pa')
||unistr('k ji m\016F\017Eete zobrazit pouze vy.</p>'),
unistr('<p>Vyberte si z dostupn\00FDch typ\016F a zadejte n\00E1zev ulo\017Een\00E9ho p\0159ehledu.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870335703398948)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E1pov\011Bda k\00A0Sestav\00E1m'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868536442398947)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>V tomto dialogu se nastavuje po\0159ad\00ED zobrazen\00ED.</p>'),
'',
unistr('<p><strong>Seznam \0159azen\00ED</strong><br>'),
unistr('Dialog Se\0159adit zobrazuje seznam konfigurovan\00FDch pravidel \0159azen\00ED.<br>'),
unistr('Kliknut\00EDm na tla\010D\00EDtko P\0159idat ( &plus; ) vytvo\0159\00EDte sloupec \0159azen\00ED, kliknut\00EDm na Odstranit ( &minus; ) ho odeberete.<br>'),
unistr('Kliknut\00EDm na volby P\0159esunout nahoru ( &uarr; ) nebo P\0159esunout dol\016F ( &darr; ) p\0159esunete vybran\00FD sloupec \0159azen\00ED nahoru \010Di dol\016F vzhledem k jin\00FDm sloupc\016Fm \0159azen\00ED.</p>'),
'',
unistr('<p><strong>Nastaven\00ED \0159azen\00ED</strong><br>'),
unistr('Vyberte sloupec \0159azen\00ED, sm\011Br \0159azen\00ED a zp\016Fsob \0159azen\00ED sloupc\016F obsahuj\00EDc\00EDch hodnoty null (sloupce bez hodnoty).</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Data lze \0159adit podle sloupc\016F, kter\00E9 nejsou zobrazen\00E9; ne v\0161echny sloupce je v\0161ak mo\017En\00E9 se\0159adit.</em><br>'),
unistr('<em>Zobrazen\00E9 sloupce lze \0159adit stisknut\00EDm \0161ipek nahoru (vzestupn\011B) nebo dol\016F (sestupn\011B) na konci z\00E1hlav\00ED sloupc\016F. Chcete-li p\0159idat dal\0161\00ED sloupec do st\00E1vaj\00EDc\00EDho \0159azen\00ED, podr\017Ete kl\00E1vesu Shift a klikn\011Bte na \0161ipku nahoru nebo dol\016F.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870991901398949)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0Se\0159azen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110870194373398948)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0Subskripci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822444271398913)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'cs'
,p_message_text=>unistr('Skr\00FDt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789261717398889)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('Zv\00FDraznit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857241177398938)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Vysok\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858002614398939)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Horizont\00E1ln\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815421380398908)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'cs'
,p_message_text=>'hodiny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820449128398911)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'cs'
,p_message_text=>'Ikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788171071398888)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED ikon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813675586398906)
,p_name=>'APEX.IG.IN'
,p_message_language=>'cs'
,p_message_text=>'v'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822090502398912)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'cs'
,p_message_text=>unistr('Neaktivn\00ED nastaven\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822137379398912)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('Neaktivn\00ED nastaven\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829755887398918)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159i zpracov\00E1n\00ED po\017Eadavku interaktivn\00ED m\0159\00ED\017Eky do\0161lo k vnit\0159n\00ED chyb\011B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725576551398843)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Typ filtru sloupce "%0" nen\00ED podporov\00E1n u sloupce "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869955706398948)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD form\00E1t data')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844150569398928)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Interaktivn\00ED m\0159\00ED\017Eka nepodporuje definov\00E1n\00ED filtru na sloupci %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844090151398928)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED platn\00FD typ filtru pro definov\00E1n\00ED filtru interaktivn\00ED m\0159\00ED\017Eky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730680387398846)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD form\00E1t \010D\00EDsla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872605204398950)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E9 nastaven\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872793352398950)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 nastaven\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863720496398943)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'cs'
,p_message_text=>unistr('operace Se\0159adit podle byla nastavena na %0, ale pro %0 nebyl vybr\00E1n \017E\00E1dn\00FD sloupec.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861025666398941)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 hodnota')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856192834398938)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'cs'
,p_message_text=>'Nezobrazeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814491678398907)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('v\00A0posledn\00EDm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814614198398907)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('v\00A0n\00E1sleduj\00EDc\00EDm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813550625398906)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED pr\00E1zdn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813495637398906)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('je pr\00E1zdn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864576392398944)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('\0160t\00EDtek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856549233398938)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('\0160t\00EDtek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860464034398941)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803725524398899)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00ED den')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803977093398899)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00ED hodina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804438760398900)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00ED minuta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803481327398899)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('Minul\00FD m\011Bs\00EDc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803589512398899)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('Minul\00FD t\00FDden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803646823398899)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0dn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803885071398899)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0hodin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804526081398900)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804341095398900)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0m\011Bs\00EDc\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804235117398900)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0t\00FDdn\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803272545398899)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0let')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803355714398899)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Minul\00FD rok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864700912398944)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'cs'
,p_message_text=>unistr('Zarovn\00E1n\00ED bu\0148ky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864865540398944)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Pou\017E\00EDt skupinu pro')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814097878398907)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'cs'
,p_message_text=>unistr('men\0161\00ED ne\017E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814139748398907)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'cs'
,p_message_text=>unistr('men\0161\00ED nebo rovno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858631654398940)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'cs'
,p_message_text=>unistr('Liniov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858762730398940)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'cs'
,p_message_text=>unistr('Spojnicov\00FD s plo\0161n\00FDm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865101940398945)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'cs'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857363834398939)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00EDzk\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867782862398946)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'cs'
,p_message_text=>unistr('Jednotliv\00E9 adresy odd\011Blte \010D\00E1rkou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815293107398908)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('shoduje se s\00A0regul\00E1rn\00EDm v\00FDrazem')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839659547398925)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'cs'
,p_message_text=>unistr('Maxim\00E1ln\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875286464398952)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00E9 maximum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839860593398925)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'cs'
,p_message_text=>unistr('Medi\00E1n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875300780398952)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00FD medi\00E1n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839524093398925)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'cs'
,p_message_text=>unistr('Minim\00E1ln\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815347667398908)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'cs'
,p_message_text=>'minuty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840393928398926)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed n\011Bkolika minutami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875145747398952)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00E9 minimum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815768659398908)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('m\011Bs\00EDce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822321615398913)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Data obsahuj\00ED v\00EDce ne\017E %0 \0159\00E1dek, co\017E p\0159esahuje maxim\00E1ln\00ED povolen\00FD po\010Det. Pokud chcete zobrazit v\00FDsledky, pou\017Eijte v\00EDce filtr\016F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849072904398932)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Mus\00ED b\00FDt zad\00E1no statick\00E9 ID oblasti, proto\017Ee str\00E1nka obsahuje v\00EDce interaktivn\00EDch m\0159\00ED\017Eek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818488958398910)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818669515398910)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Pojmenovan\00E1 sestava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802666181398898)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1sleduj\00EDc\00ED den')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802424346398898)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1sleduj\00EDc\00ED hodina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804669752398900)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1sleduj\00EDc\00ED minuta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802917180398899)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00ED m\011Bs\00EDc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802846298398899)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00ED t\00FDden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802743255398899)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0dn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110802539319398898)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0hodin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804711666398900)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804028028398899)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0m\011Bs\00EDc\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804106994398900)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0t\00FDdn\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803169094398899)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0let')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110803001978398899)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00ED rok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814381048398907)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED mezi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813368486398906)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED rovno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879556992398955)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Oblast s ID %0 nen\00ED oblast\00ED interaktivn\00ED m\0159\00ED\017Eky nebo neexistuje v aplikaci %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813724695398907)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814542790398907)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED v\00A0posledn\00EDm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110814724796398907)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED v\00A0n\00E1sleduj\00EDc\00EDm')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822273140398913)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyla nalezena \017E\00E1dn\00E1 data')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860206495398941)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'cs'
,p_message_text=>'Hodnoty Null'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865317946398945)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'cs'
,p_message_text=>unistr('\010C\00EDseln\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860594566398941)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'cs'
,p_message_text=>'Vypnuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860600176398941)
,p_name=>'APEX.IG.ON'
,p_message_language=>'cs'
,p_message_text=>'Zapnuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812598070398906)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed 1\00A0minutou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868255688398947)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'cs'
,p_message_text=>unistr('Otev\0159\00EDt v\00FDb\011Br barev: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857012512398938)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Otev\0159\00EDt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819528359398911)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Oper\00E1tor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856488468398938)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'cs'
,p_message_text=>'Orientace'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858817088398940)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDse\010Dov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110820860987398912)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'cs'
,p_message_text=>'Operace pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110788408367398888)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED pivot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110868165114398947)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnoty odd\011Blte \201E%0\201C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110858934192398940)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Pol\00E1rn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864274849398944)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'cs'
,p_message_text=>unistr('St\0159ed')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864362825398944)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'cs'
,p_message_text=>'Konec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110864155354398944)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'cs'
,p_message_text=>unistr('Za\010D\00E1tek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818768827398910)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'cs'
,p_message_text=>unistr('Prim\00E1rn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819083031398910)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('Prim\00E1rn\00ED v\00FDchoz\00ED nastaven\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835506825398922)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Prim\00E1rn\00ED sestava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717729465398837)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'cs'
,p_message_text=>unistr('Zahrnout tagy p\0159\00EDstupnosti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716423001398836)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'cs'
,p_message_text=>unistr('Na \0161\00ED\0159ku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716595275398836)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'cs'
,p_message_text=>unistr('Na v\00FD\0161ku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716358981398836)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'cs'
,p_message_text=>unistr('Orientace str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716229513398836)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'cs'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716144011398836)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'cs'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717845465398837)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'cs'
,p_message_text=>unistr('Vlastn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715917776398835)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'cs'
,p_message_text=>unistr('Pr\00E1vn\00ED informace')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715890441398835)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'cs'
,p_message_text=>'Dopis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716069492398836)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'cs'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715720297398835)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'cs'
,p_message_text=>unistr('Velikost str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705920862398828)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'cs'
,p_message_text=>unistr('Odstranit form\00E1tovan\00FD text')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859070344398940)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Paprskov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859127586398940)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozsahov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869413154398948)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'cs'
,p_message_text=>'Aktualizovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823083552398913)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktualizovat \0159\00E1dku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821852413398912)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktualizovat \0159\00E1dky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827072910398916)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Oblast interaktivn\00ED m\0159\00ED\017Eky neexistuje v\00A0aplikaci %0, na str\00E1nce\00A0%1 a\00A0v oblasti %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789971692398889)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'cs'
,p_message_text=>'Odebrat %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818135641398910)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'cs'
,p_message_text=>'Sestava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878759867398955)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'cs'
,p_message_text=>unistr('Sestava odstran\011Bna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878430711398954)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Alternativn\00ED sestava ulo\017Eena pro v\0161echny u\017Eivatele')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878326527398954)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED sestava ulo\017Eena pro v\0161echny u\017Eivatele')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878651000398955)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Soukrom\00E1 sestava ulo\017Eena')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878539246398955)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'cs'
,p_message_text=>unistr('Ve\0159ejn\00E1 sestava ulo\017Eena pro v\0161echny u\017Eivatele')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110827171658398916)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 interaktivn\00ED m\0159\00ED\017Eka s\00A0n\00E1zvem %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812496345398906)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('Data sestavy jako p\0159ed %0\00A0minutami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812389517398906)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('Data sestavy jako p\0159ed 1\00A0minutou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752069305398862)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Sestava interaktivn\00ED m\0159\00ED\017Eky neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871651599398949)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'cs'
,p_message_text=>unistr('Sestava\00A0\2013 Upravit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826910214398916)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 interaktivn\00ED m\0159\00ED\017Eka s\00A0ID %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110871557281398949)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'cs'
,p_message_text=>unistr('Sestava\00A0\2013 Ulo\017Eit jako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790040574398889)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('Nastaven\00ED sestavy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879628304398955)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 interaktivn\00ED m\0159\00ED\017Eka se\00A0statick\00FDm ID %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874579614398952)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED sestavy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789147959398889)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'cs'
,p_message_text=>'Obnovit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823148031398913)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'cs'
,p_message_text=>unistr('Vr\00E1tit zm\011Bny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821987379398912)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('Vr\00E1tit \0159\00E1dky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819160732398910)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818046020398910)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dk\016F na str\00E1nku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879245442398955)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'cs'
,p_message_text=>unistr('Akce \0159\00E1dk\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880469573398956)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Akce pro \0159\00E1dku %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110789426030398889)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832117682398920)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'cs'
,p_message_text=>unistr('ulo\017Eeno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787628053398888)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 vy\00FA\010Dtov\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787714500398888)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762263257398869)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 sestava s n\00E1zvem %0 ji\017E existuje. Zadejte nov\00FD n\00E1zev.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787843019398888)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Soukrom\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787923387398888)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'cs'
,p_message_text=>unistr('Ve\0159ejn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874294271398951)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit jako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821264713398912)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit nastaven\00ED sestavy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859223534398940)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Bodov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787526995398888)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866501861398946)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED: V\0161echny textov\00E9 sloupce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787455566398888)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865765219398945)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1n\00ED: Full text')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812282705398906)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'cs'
,p_message_text=>'Vyhledat ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855878638398937)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'cs'
,p_message_text=>unistr('-\00A0Vybrat\00A0-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796019289398894)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDb\011Br')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848706696398932)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte 1\00A0\0159\00E1dek v\00A0hlavn\00ED oblasti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787382994398887)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte sloupce, kter\00E9 chcete vyhledat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878956007398955)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'cs'
,p_message_text=>unistr('Akce v\00FDb\011Bru')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796255355398894)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDb\011Br bu\0148ky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796103021398894)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDb\011Br \0159\00E1dku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867172263398946)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'cs'
,p_message_text=>'Odeslat jako e-mail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859663997398940)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158ada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785380505398886)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837962712398924)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit celkovou hodnotu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822799855398913)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Jedno\0159\00E1dkov\00E9 zobrazen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821055464398912)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859792131398940)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158adit podle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879333385398955)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Na jeden sloupec m\016F\017Eete definovat pouze jedno \0159azen\00ED.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879177182398955)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('Nab\00EDdka Zm\011Bn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110860738528398941)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'cs'
,p_message_text=>unistr('Z\00E1sobn\00EDk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815068892398907)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'cs'
,p_message_text=>unistr('za\010D\00EDn\00E1 na')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859388171398940)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'cs'
,p_message_text=>unistr('Burzovn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780344910398883)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozt\00E1hnout \0161\00ED\0159ky sloupc\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110821412045398912)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'cs'
,p_message_text=>'Subskripce'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110839472944398925)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'cs'
,p_message_text=>unistr('Sou\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880665112398956)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'cs'
,p_message_text=>unistr('Interaktivn\00ED m\0159\00ED\017Eka. Sestava: %0, Zobrazen\00ED: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110874681770398952)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00FD sou\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857569364398939)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('C\00EDl')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863952362398944)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'cs'
,p_message_text=>'Barva textu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790176768398889)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159epnout')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837821100398924)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'cs'
,p_message_text=>'Popisek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110818232517398910)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'cs'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110822620991398913)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zru\0161it zmrazen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819788453398911)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'cs'
,p_message_text=>'Jednotka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866921002398946)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyly ulo\017Eeny zm\011Bny. Chcete pokra\010Dovat?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110819674100398911)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'cs'
,p_message_text=>'Hodnota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856696916398938)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Hodnota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861593369398942)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Je nutn\00E9 zadat hodnotu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846422689398930)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnota (\010Dasov\00E9 p\00E1smo nelze zm\011Bnit)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865400720398945)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'cs'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857963374398939)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vertik\00E1ln\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817725823398909)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855946607398938)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'cs'
,p_message_text=>'Zobrazeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110857439107398939)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Objem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815602352398908)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('t\00FDdny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856031601398938)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'cs'
,p_message_text=>unistr('Minim\00E1ln\00ED \0161\00ED\0159ka sloupce (v\00A0pixelech)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806887645398901)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 mezi %1 a\00A0%2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806552841398901)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'cs'
,p_message_text=>'%0 obsahuje %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806686408398901)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'cs'
,p_message_text=>'%0 neobsahuje %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784732210398886)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%1 nen\00ED za\010D\00E1tek %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805384911398900)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'cs'
,p_message_text=>'%0 je rovno %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805512719398901)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je v\011Bt\0161\00ED ne\017E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805647087398901)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je v\011Bt\0161\00ED nebo rovno %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806300166398901)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807527832398902)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00EDch %1\00A0dn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807386398398902)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00EDch %1\00A0hodin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807181974398902)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00EDch %1\00A0minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807916289398902)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00EDch %1\00A0m\011Bs\00EDc\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807787799398902)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00EDch %1\00A0t\00FDdn\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808105888398902)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00EDch %1\00A0let')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807412694398902)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00ED den')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807294747398902)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00ED hodinu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807045202398902)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00ED m\011Bs\00EDc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807829671398902)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00ED m\011Bs\00EDc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110807691891398902)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00ED t\00FDden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808095486398902)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za posledn\00ED rok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809946940398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0p\0159\00ED\0161t\00EDch %1\00A0dnech')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809780369398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0p\0159\00ED\0161t\00EDch %1\00A0hodin\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809560319398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0p\0159\00ED\0161t\00EDch %1\00A0minut\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810378917398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0p\0159\00ED\0161t\00EDch %1\00A0m\011Bs\00EDc\00EDch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810175518398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0p\0159\00ED\0161t\00EDch %1\00A0t\00FDdnech')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810561383398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0p\0159\00ED\0161t\00EDch %1\00A0letech')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809874559398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0n\00E1sleduj\00EDc\00EDm dni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809670021398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0n\00E1sleduj\00EDc\00ED hodin\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809469458398903)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0n\00E1sleduj\00EDc\00ED minut\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810291626398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0n\00E1sleduj\00EDc\00EDm m\011Bs\00EDci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810048513398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0n\00E1sleduj\00EDc\00EDm t\00FDdnu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810444419398904)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 v\00A0n\00E1sleduj\00EDc\00EDm roce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806041827398901)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED pr\00E1zdn\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805976494398901)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je pr\00E1zdn\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805737771398901)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je men\0161\00ED ne\017E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805852006398901)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je men\0161\00ED nebo rovno %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806127160398901)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'cs'
,p_message_text=>'%0 jako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806753082398901)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 se shoduje s\00A0regul\00E1rn\00EDm v\00FDrazem %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812683186398906)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed %0\00A0minutami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806950108398902)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED mezi %1 a\00A0%2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805426066398901)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED rovno %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806407752398901)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808788025398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00EDch %1\00A0dn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808542249398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00EDch %1\00A0hodin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808306988398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00EDch %1\00A0minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809113369398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00EDch %1\00A0m\011Bs\00EDc\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808942461398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00EDch %1\00A0t\00FDdn\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809336296398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00EDch %1\00A0let')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808678919398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00ED den')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808428368398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00ED hodinu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808287341398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00ED minutu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809049414398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00ED m\011Bs\00EDc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110808819265398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00ED t\00FDden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110809258816398903)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED za posledn\00ED rok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811123775398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0p\0159\00ED\0161t\00EDch %1\00A0dnech')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810958648398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0p\0159\00ED\0161t\00EDch %1\00A0hodin\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810742844398904)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0p\0159\00ED\0161t\00EDch %1\00A0minut\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811507449398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0p\0159\00ED\0161t\00EDch %1\00A0m\011Bs\00EDc\00EDch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811341309398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0p\0159\00ED\0161t\00EDch %1\00A0t\00FDdnech')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811752357398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0p\0159\00ED\0161t\00EDch %1\00A0letech')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811021649398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0n\00E1sleduj\00EDc\00EDm dni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810821373398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0n\00E1sleduj\00EDc\00ED hodin\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110810623448398904)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0n\00E1sleduj\00EDc\00ED minut\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811409440398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0n\00E1sleduj\00EDc\00EDm m\011Bs\00EDci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811206876398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0n\00E1sleduj\00EDc\00EDm t\00FDdnu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811678992398905)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0n\00E1sleduj\00EDc\00EDm roce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110806201257398901)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED jako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813137258398906)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 za\010D\00EDn\00E1 na %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856702118398938)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'cs'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815889239398908)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'cs'
,p_message_text=>'roky'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856834737398938)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856943995398938)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110865914771398945)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'cs'
,p_message_text=>unistr('Pond\011Bl\00ED, 12.\00A0ledna 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866014729398945)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'cs'
,p_message_text=>'Leden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866182202398945)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'cs'
,p_message_text=>unistr('p\0159ed 16\00A0hodinami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110866266588398945)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'cs'
,p_message_text=>'za 16 hodin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721211754398839)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD typ souboru. Podporovan\00E9 typy soubor\016F jsou %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848109296398931)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'cs'
,p_message_text=>unistr('Proch\00E1zet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847870140398931)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'cs'
,p_message_text=>'Vybrat soubor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847915186398931)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'cs'
,p_message_text=>'Vybrat soubory'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721071357398839)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159et\00E1hnout')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721401252398840)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159et\00E1hnout soubory')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722682236398840)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte soubor, nebo jej p\0159et\00E1hn\011Bte sem.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722747807398841)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte, nebo p\0159et\00E1hn\011Bte soubor sem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722839226398841)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte soubor, nebo jej p\0159et\00E1hn\011Bte sem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722910484398841)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte, nebo p\0159et\00E1hn\011Bte soubor sem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721354417398839)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('%0\00A0soubor\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721143747398839)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'cs'
,p_message_text=>unistr('Soubor je p\0159\00EDli\0161 velk\00FD. Maxim\00E1ln\00ED velikost souboru je %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708922992398830)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Vy\017Eadov\00E1na adresa.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707855708398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'cs'
,p_message_text=>unistr('M\011Bsto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708287070398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'cs'
,p_message_text=>unistr('K\00F3d zem\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707992840398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'cs'
,p_message_text=>unistr('\010C\00EDslo domu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708801080398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zem\011Bpisn\00E1 \0161\00ED\0159ka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708709922398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zem\011Bpisn\00E1 d\00E9lka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708673576398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazit na map\011B')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708349154398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'cs'
,p_message_text=>unistr('Sk\00F3re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708002352398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'cs'
,p_message_text=>unistr('PS\010C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708188855398830)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'cs'
,p_message_text=>'Stav'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707742689398829)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'cs'
,p_message_text=>'Ulice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707655413398829)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDsledky geografick\00E9ho k\00F3dov\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720271129398839)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'cs'
,p_message_text=>unistr('S geografick\00FDmi \00FAdaji')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720338435398839)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'cs'
,p_message_text=>unistr('Bez geografick\00FDch \00FAdaj\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708531319398830)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'cs'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110708466713398830)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyly nalezeny \017E\00E1dn\00E9 adresy.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709061483398830)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je povinn\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878848977398955)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Text n\00E1pov\011Bdy: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772285736398877)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'cs'
,p_message_text=>unistr('Za\0161krtnuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772339389398877)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'cs'
,p_message_text=>unistr('Neza\0161krtnuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718288992398837)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# nen\00ED v platn\00E9m rozsahu %0 a\017E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718337359398837)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# nen\00ED n\00E1sobkem %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717977552398837)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# se mus\00ED shodovat s hodnotami %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718146135398837)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'cs'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796434661398894)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'cs'
,p_message_text=>'Vypnuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796518571398894)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'cs'
,p_message_text=>'Zapnuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718015789398837)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'cs'
,p_message_text=>'Ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701418815398825)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat polo\017Eku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830627810398919)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830765431398919)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'cs'
,p_message_text=>'Odebrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701550444398825)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybran\00E9 polo\017Eky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834431006398921)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'cs'
,p_message_text=>unistr('Roz\0161\00ED\0159en\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834754557398921)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Zru\0161it')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834539620398921)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'cs'
,p_message_text=>unistr('Spole\010Dn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834802488398922)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'cs'
,p_message_text=>unistr('Volby \017Eiv\00E9 \0161ablony')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835459291398922)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Volby \0161ablony nejsou k\00A0dispozici, proto\017Ee tato komponenta nen\00ED na str\00E1nce vykreslena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834396687398921)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyly nalezeny \017E\00E1dn\00E9 mo\017Enosti \0161ablony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834630384398921)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709976048398831)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'cs'
,p_message_text=>'Vymazat kruh'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711748158398832)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'cs'
,p_message_text=>unistr('Vlastn\00ED styly nejsou platn\00FDm JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710202385398831)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1stroj vzd\00E1lenost')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710015439398831)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'cs'
,p_message_text=>'Nakreslit kruh'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702625920398826)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'cs'
,p_message_text=>unistr('Fazetov\00E9 vyhled\00E1v\00E1n\00ED vy\017Eaduje datov\00FD zdroj na \00FArovni oblasti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705227489398828)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED m\00EDsto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706375330398828)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Sou\0159adnice v\00FDchoz\00ED pozice jsou neplatn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703731712398827)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED pozice mus\00ED b\00FDt bod geometrie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706177479398828)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'cs'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704728829398827)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'cs'
,p_message_text=>'Vrstva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838077015398924)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'cs'
,p_message_text=>'Vrstva: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709350894398831)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'cs'
,p_message_text=>'Mapovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702532579398826)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'cs'
,p_message_text=>unistr('Zpr\00E1vy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706278871398828)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'cs'
,p_message_text=>unistr('m\00EDle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837074475398923)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Data obsahuj\00ED v\00EDce ne\017E %0 \0159\00E1dek, co\017E p\0159esahuje maxim\00E1ln\00ED povolen\00FD po\010Det.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704520489398827)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Podm\00EDnky</a> &nbsp;&nbsp; Data mapy &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703455733398826)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Datov\00FD typ SDO_GEOMETRY nen\00ED v t\00E9to datab\00E1zi dostupn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704631589398827)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; p\0159isp\011Bvatel\00E9 OpenStreetMap </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704838024398827)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'cs'
,p_message_text=>'Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838101367398924)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 bod\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710103298398831)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'cs'
,p_message_text=>unistr('Obd\00E9ln\00EDkov\00E1 lupa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709808640398831)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'cs'
,p_message_text=>'Odebrat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705104094398828)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'cs'
,p_message_text=>'Resetovat orientaci na sever'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785495890398886)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159epnout do re\017Eimu 2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785534099398886)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159epnout do re\017Eimu 3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709748545398831)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159epnout upozorn\011Bn\00ED na autorsk\00E1 pr\00E1va')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710321025398831)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'cs'
,p_message_text=>unistr('Celkov\00E1 vzd\00E1lenost')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704943525398827)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ibl\00ED\017Eit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705097756398828)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'cs'
,p_message_text=>unistr('Odd\00E1lit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832521639398920)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'cs'
,p_message_text=>unistr('Tu\010Dn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833408225398921)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Obr\00E1zek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833077165398920)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'cs'
,p_message_text=>unistr('Inline k\00F3d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846627656398930)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vlo\017Eit obr\00E1zek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846757181398930)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'cs'
,p_message_text=>unistr('Vlo\017Eit odkaz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832643667398920)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'cs'
,p_message_text=>unistr('Kurz\00EDva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847337357398931)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'cs'
,p_message_text=>'Odkaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833313073398921)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'cs'
,p_message_text=>'Seznam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833292195398920)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159azen\00FD seznam')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832717615398920)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1hled')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832830713398920)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'cs'
,p_message_text=>unistr('Nic k n\00E1hledu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832968299398920)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159e\0161krtnut\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833176896398920)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Nese\0159azen\00FD seznam')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812014074398905)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('aktu\00E1ln\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110869579439398948)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00EDce...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110811969479398905)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDt\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843795334398928)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'cs'
,p_message_text=>unistr('Zpr\00E1va s upozorn\011Bn\00EDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817022825398909)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED b\00FDt \010D\00EDslo men\0161\00ED nebo rovno %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817112434398909)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED b\00FDt platn\00E9 \010D\00EDslo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817251947398909)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# neodpov\00EDd\00E1 form\00E1tu \010D\00EDsla %0 (P\0159\00EDklad: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816990742398909)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED b\00FDt \010D\00EDslo v\011Bt\0161\00ED nebo rovno %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816811750398909)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED b\00FDt \010D\00EDslo od %0 do %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812127997398905)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'cs'
,p_message_text=>unistr('otev\0159e se v nov\00E9m okn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765303752398871)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'cs'
,p_message_text=>unistr('Tato str\00E1nka ji\017E byla odesl\00E1na a nelze ji odeslat znovu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747955314398859)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Aplikace "%0" Str\00E1nka "%1" nenalezena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781778142398884)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('#LABEL# mus\00ED m\00EDt n\011Bjakou hodnotu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725059403398842)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831021298398919)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zav\0159\00EDt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830988915398919)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'cs'
,p_message_text=>unistr('Naj\00EDt %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831272660398919)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831151157398919)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717100376398836)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadejte hledan\00FD v\00FDraz o\00A0d\00E9lce alespo\0148 %0\00A0znak\016F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786629699398887)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozev\00EDrac\00ED seznam hodnot: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717272627398836)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadejte hledan\00FD pojem.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717040170398836)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyly nalezeny \017E\00E1dn\00E9 v\00FDsledky.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716955043398836)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'cs'
,p_message_text=>'Odebrat %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804808620398900)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Hledat term\00EDn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830881653398919)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841508138398926)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'cs'
,p_message_text=>unistr('Prob\00EDh\00E1 zpracov\00E1n\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715553064398835)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat na dom. obrazovku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711587584398832)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Zd\00E1 se, \017Ee va\0161e za\0159\00EDzen\00ED nebo prohl\00ED\017Ee\010D moment\00E1ln\011B nepodporuje instalaci progresivn\00EDch webov\00FDch aplikac\00ED.</p>'),
unistr('    <p class="a-pwaDialog-intro">Pokud je tato aplikace ve va\0161em za\0159\00EDzen\00ED ji\017E instalov\00E1na, otev\0159ete ji z\00A0domovsk\00E9 obrazovky.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711188633398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace. P\0159idejte si ji na domovskou obrazovku abyste mohli vyu\017E\00EDt funkci Na celou obrazovku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1.\00A0Klepn\011Bte na ikonu <strong>Menu</strong> na spodn\00EDm naviga\010Dn\00EDm panelu</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2.\00A0Klepn\011Bte na <strong>Instalovat</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3.\00A0Klepn\011Bte na <strong>P\0159idat</strong> pro potvrzen\00ED</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711270069398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace a\00A0nejlep\0161\00ED z\00E1\017Eitek poskytuje v\00A0prohl\00ED\017Ee\010Di Chrome nebo Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1.\00A0Klepn\011Bte na ikonu <strong>Menu</strong> kter\00E1 se nach\00E1z\00ED vedle adresn\00EDho \0159\00E1dku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2.\00A0Klepn\011Bte na <strong>Instalovat</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710889851398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace a\00A0nejlep\0161\00ED z\00E1\017Eitek poskytuje v\00A0prohl\00ED\017Ee\010Di Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1.\00A0Klepn\011Bte na ikonu <strong>Sd\00EDlet</strong> na spodn\00EDm naviga\010Dn\00EDm panelu</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2.\00A0Klepn\011Bte na <strong>Otev\0159\00EDt v\00A0Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710558418398831)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace. P\0159idejte si jej na domovskou obrazovku, abyste dos\00E1hli nejlep\0161\00EDho z\00E1\017Eitku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Klepn\011Bte na ikonu <strong>Sd\00EDlet</strong>, kter\00E1 se nach\00E1z\00ED vedle adresn\00EDho \0159\00E1dku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Klepn\011Bte na <strong>P\0159idat na domovskou obrazovku</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Klepn\011Bte na <strong style="color:#007AE1;">P\0159idat</strong> pro potvrzen\00ED</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710475705398831)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace. P\0159idejte si jej na domovskou obrazovku, abyste dos\00E1hli nejlep\0161\00EDho z\00E1\017Eitku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Klepn\011Bte na ikonu <strong>Sd\00EDlet</strong> na spodn\00EDm naviga\010Dn\00EDm panelu</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Sje\010Fte dol\016F a\00A0klepn\011Bte na <strong> P\0159idat na domovskou obrazovku </strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Klepn\011Bte na <strong style="color:#007AE1;">P\0159idat</strong> pro potvrzen\00ED</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705499311398828)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace. P\0159idejte si jej na domovskou obrazovku, abyste dos\00E1hli nejlep\0161\00EDho z\00E1\017Eitku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1.\00A0Klepn\011Bte na ikonu <strong>V\00EDce</strong>, kter\00E1 se nach\00E1z\00ED vedle adresn\00EDho \0159\00E1dku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2.\00A0Klepn\011Bte na <strong>P\0159idat na domovskou obrazovku</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3.\00A0Klepn\011Bte na<strong style="color:#007AE1;">P\0159idat</strong> pro potvrzen\00ED</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710785925398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace. P\0159idejte si jej na domovskou obrazovku, abyste dos\00E1hli nejlep\0161\00EDho z\00E1\017Eitku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Klepn\011Bte na ikonu <strong>Sd\00EDlet</strong>, kter\00E1 se nach\00E1z\00ED vedle adresn\00EDho \0159\00E1dku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Klepn\011Bte na <strong>Otev\0159\00EDt v\00A0Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710666056398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace. P\0159idejte si jej na domovskou obrazovku, abyste dos\00E1hli nejlep\0161\00EDho z\00E1\017Eitku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Klepn\011Bte na ikonu <strong>Sd\00EDlet</strong> na spodn\00EDm naviga\010Dn\00EDm panelu</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Klepn\011Bte na<strong>Otev\0159\00EDt v\00A0Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711457666398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace a\00A0nejlep\0161\00ED z\00E1\017Eitek poskytuje v\00A0prohl\00ED\017Ee\010Di Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox aktu\00E1ln\011B nepodporuje instalaci webov\00FDch aplikac\00ED.</p>'),
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110710996150398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace a\00A0nejlep\0161\00ED z\00E1\017Eitek poskytuje v\00A0prohl\00ED\017Ee\010Di Chrome nebo Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox aktu\00E1ln\011B nepodporuje instalaci webov\00FDch aplikac\00ED v\00A0opera\010Dn\00EDm syst\00E9mu macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711097862398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace a\00A0nejlep\0161\00ED z\00E1\017Eitek poskytuje v\00A0prohl\00ED\017Ee\010Di Chrome nebo Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari aktu\00E1ln\011B nepodporuje instalaci webov\00FDch aplikac\00ED v\00A0opera\010Dn\00EDm syst\00E9mu macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711332791398832)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Tento web m\00E1 funkci aplikace a\00A0nejlep\0161\00ED z\00E1\017Eitek poskytuje v\00A0prohl\00ED\017Ee\010Di Chrome nebo Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox aktu\00E1ln\011B nepodporuje instalaci webov\00FDch aplikac\00ED ve Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713839869398834)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Nelze se p\0159ipojit</h1>'),
unistr('    <p>Abyste mohli tuto aplikaci pou\017E\00EDvat, mus\00EDte b\00FDt p\0159ipojen\00ED k\00A0internetu.</p>'),
'    <button type="button">Opakovat pokus</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713757641398834)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze se p\0159ipojit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853592184398936)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797926545398895)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('Celodenn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876884686398953)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'cs'
,p_message_text=>unistr('Odeslat pozv\00E1nku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876673245398953)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'cs'
,p_message_text=>'Volby'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799714304398896)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED dn\016F pro cel\00FD den')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799532838398896)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED dn\016F pro data s \010Dasem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844462734398929)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'cs'
,p_message_text=>'Den'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838870150398924)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'cs'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729434327398845)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'cs'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729287835398845)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'cs'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729104822398845)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'cs'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729300028398845)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'cs'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728892603398845)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Datum ukon\010Den\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729051650398845)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev ud\00E1losti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876719548398953)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Pozv\00E1nka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844551624398929)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'cs'
,p_message_text=>'Seznam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844218029398928)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('M\011Bs\00EDc')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847013444398930)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861374412398942)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'cs'
,p_message_text=>unistr('\017D\00E1dn\00E9 ud\00E1losti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877098541398953)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'cs'
,p_message_text=>unistr('Upravte st\00E1vaj\00EDc\00ED ud\00E1lost.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876971016398953)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'cs'
,p_message_text=>unistr('Odeslat pozv\00E1nku prost\0159ednictv\00EDm e-mailu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847152486398931)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855178506398937)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'cs'
,p_message_text=>'Odeslat e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854977779398937)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'cs'
,p_message_text=>'Odeslat e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877713730398954)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Je t\0159eba vyplnit v\0161echna pole.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877680431398954)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Odeslat pozv\00E1nku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876566908398953)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edm\011Bt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855010363398937)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDjemce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728962351398845)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Datum zah\00E1jen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852880097398935)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'cs'
,p_message_text=>unistr('Formul\00E1\0159 na %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799385176398896)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'cs'
,p_message_text=>unistr('\010Cas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847231291398931)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'cs'
,p_message_text=>'Dnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845090975398929)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844373574398928)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('T\00FDden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799658525398896)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED t\00FDdn\016F pro cel\00FD den')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799426624398896)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED t\00FDdn\016F pro data s \010Dasem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844906100398929)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'cs'
,p_message_text=>'Rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844628357398929)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'cs'
,p_message_text=>'Sloupce...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844773220398929)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDst dal\0161\00ED...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776838272398880)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'cs'
,p_message_text=>unistr('Zp\011Bt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723103303398841)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDst dal\0161\00ED...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725262417398842)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'cs'
,p_message_text=>'Vyhledat...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110844835817398929)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDst dal\0161\00ED...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846931171398930)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>'ID oblasti %0 nebylo nalezeno.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725192682398842)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Nenalezena \017E\00E1dn\00E1 data')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749213402398860)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze vynulovat str\00E1nkov\00E1n\00ED oblasti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717435947398837)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i nastaven\00ED str\00E1nkov\00E1n\00ED oblasti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838247306398924)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'cs'
,p_message_text=>'Sloupce...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846830054398930)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'cs'
,p_message_text=>unistr('Typ oblasti %0 nen\00ED podporov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717301593398836)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i vykreslov\00E1n\00ED oblasti #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781822107398884)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('#COLUMN_HEADER# mus\00ED m\00EDt n\011Bjakou hodnotu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876168612398953)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('%0, editor form\00E1tovan\00E9ho textu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783935545398885)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00E9 zna\010Dky form\00E1tovan\00E9ho textu / HTML p\0159esahuje maxim\00E1ln\00ED d\00E9lku polo\017Eky (skute\010Dn\00E1 %0, povoleno %1 znak\016F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843875137398928)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'cs'
,p_message_text=>'Odstranit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835670166398922)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'cs'
,p_message_text=>'Duplikovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833906571398921)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00E9 sloupce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833854579398921)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vylou\010Dit hodnoty null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843990002398928)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797575410398895)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout dol\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797686480398895)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout nahoru')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833603638398921)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834275999398921)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED sloupce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833718532398921)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834014303398921)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dka %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834160277398921)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dek %0 z %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835766714398922)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'cs'
,p_message_text=>'Aktualizovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835803398398922)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vr\00E1tit zm\011Bny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110833584674398921)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('Nab\00EDdka Nastaven\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794547859398893)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Nap\0159\00EDklad %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702012372398825)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Znovu p\0159ihl\00E1sit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701998829398825)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Va\0161e relace skon\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702162646398825)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'cs'
,p_message_text=>unistr('Prodlou\017Eit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701798815398825)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'cs'
,p_message_text=>unistr('Va\0161e relace skon\010D\00ED v %0. Chcete ji prodlou\017Eit?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701817765398825)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'cs'
,p_message_text=>unistr('Va\0161e relace skon\010D\00ED v %0 a\00A0nelze ji prodlou\017Eit. Ihned ulo\017Ete ve\0161kerou pr\00E1ci, aby nedo\0161lo ke ztr\00E1t\011B dat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854736716398937)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED k\00F3du nastaven\00ED \00FAklidu relace datab\00E1ze.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747834105398859)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED k\00F3du nastaven\00ED relace datab\00E1ze.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110721991920398840)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Va\0161e relace skon\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853642749398936)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'cs'
,p_message_text=>unistr('Zav\0159ete tento dialog a stiskem tla\010D\00EDtka op\011Btovn\00E9ho na\010Dten\00ED prohl\00ED\017Ee\010De z\00EDskejte novou relaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872920202398950)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('Kliknut\00EDm <a href="%0">sem</a> vytvo\0159\00EDte novou relaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759576534398867)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Relace nen\00ED platn\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799053764398896)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'cs'
,p_message_text=>unistr('V relaci Real Application Security nelze aktivovat \017E\00E1dn\00E9 dynamick\00E9 role pro u\017Eivatele "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745741052398857)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('ERR-99900 Nelze vytvo\0159it jedine\010Dn\00E9 ID relace: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762039365398869)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Poru\0161en\00ED ochrany stavu relace: m\016F\017Ee b\00FDt zp\016Fsobeno ru\010Dn\00ED zm\011Bnou chr\00E1n\011Bn\00E9 polo\017Eky str\00E1nky. Pokud si nejste jisti t\00EDm, co chybu zp\016Fsobilo, obra\0165te se na spr\00E1vce aplikace, kter\00FD v\00E1m poskytne pomoc.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881106207398957)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Poru\0161en\00ED ochrany str\00E1nky: m\016F\017Ee b\00FDt zp\016Fsobeno odesl\00E1n\00EDm str\00E1nky, jej\00ED\017E na\010D\00EDt\00E1n\00ED je\0161t\011B nebylo dokon\010Deno nebo ru\010Dn\00ED zm\011Bnou chr\00E1n\011Bn\00FDch polo\017Eek str\00E1nky. O dal\0161\00ED pomoc po\017E\00E1dejte spr\00E1vce aplikace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880194824398956)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 obsahuje nejm\00E9n\011B jeden z n\00E1sleduj\00EDc\00EDch neplatn\00FDch znak\016F &<>"/;,*|=% nebo --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880266416398956)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 obsahuje nejm\00E9n\011B jeden z n\00E1sleduj\00EDc\00EDch neplatn\00FDch znak\016F &<>"/;,*|=% nebo -- nebo znak nov\00E9ho \0159\00E1dku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879963879398956)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 obsahuje speci\00E1ln\00ED znaky. Povoleny jsou pouze znaky a-Z, 0-9 a mezery.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110880074344398956)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 obsahuje <, > nebo ", co\017E jsou neplatn\00E9 znaky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724103524398842)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyl zad\00E1n \017E\00E1dn\00FD kontroln\00ED sou\010Det k zobrazen\00ED zpracov\00E1n\00ED pro str\00E1nku, kter\00E1 vy\017Eaduje kontroln\00ED sou\010Det, je-li p\0159id\00E1n nejm\00E9n\011B jeden po\017Eadavek, vymaz\00E1n\00ED pam\011Bti cache nebo hodnoty argument\016F jako parametry.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756948754398865)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Poru\0161en\00ED ochrany stavu relace: m\016F\017Ee b\00FDt zp\016Fsobeno ru\010Dn\00ED zm\011Bnou adresy URL obsahuj\00EDc\00ED kontroln\00ED sou\010Det, nebo pou\017Eit\00EDm odkazu s nespr\00E1vn\00FDm \010Di chyb\011Bj\00EDc\00EDm kontroln\00EDm sou\010Dtem. Pokud si nejste jisti t\00EDm, co chybu zp\016Fsobilo, obra\0165te se na spr\00E1vce aplikace, ')
||unistr('kter\00FD v\00E1m poskytne pomoc.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110834968210398922)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'cs'
,p_message_text=>unistr('Vypnout re\017Eim vysok\00E9ho kontrastu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835060267398922)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'cs'
,p_message_text=>unistr('Zapnout re\017Eim vysok\00E9ho kontrastu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753616386398863)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'cs'
,p_message_text=>'Na konec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753820590398863)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'cs'
,p_message_text=>unistr('Dol\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753958943398863)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754071678398863)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout v\0161e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754125922398863)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'cs'
,p_message_text=>'Odebrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754260620398863)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Odebrat v\0161e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754304809398863)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'cs'
,p_message_text=>'Obnovit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753581433398863)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'cs'
,p_message_text=>unistr('Na za\010D\00E1tek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753773888398863)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'cs'
,p_message_text=>'Nahoru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862654597398943)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'cs'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863336132398943)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('za %0dn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862571392398943)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'cs'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863454198398943)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>'za %0hodin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862363179398942)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'cs'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863587354398943)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>'za %0minut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862984345398943)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('%0m\011Bs\00EDc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863139630398943)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('za %0m\011Bs\00EDc\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862427474398942)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'cs'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863281496398943)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>'za %0sekund'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862778498398943)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'cs'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863631427398943)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('za %0t\00FDdn\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862889120398943)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'cs'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110863086533398943)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>'za %0let'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702926459398826)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'cs'
,p_message_text=>unistr('[\010C\00E1ra]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703359983398826)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'cs'
,p_message_text=>unistr('[V\00EDce \010Dar]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703127665398826)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'cs'
,p_message_text=>unistr('[V\00EDce bod\016F]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703550285398826)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'cs'
,p_message_text=>unistr('[V\00EDce mnoho\00FAheln\00EDk\016F]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703641935398827)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'cs'
,p_message_text=>'[Objekt geometrie]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702858158398826)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'cs'
,p_message_text=>'[Bod (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703060426398826)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'cs'
,p_message_text=>unistr('[Mnoho\00FAheln\00EDk]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780236127398882)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'cs'
,p_message_text=>'Sbalit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780104110398882)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'cs'
,p_message_text=>'Obnovit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826630755398916)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'cs'
,p_message_text=>unistr('Vymazat hodnocen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816533339398909)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v platn\00E9m rozsahu hodnocen\00ED 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816654023398909)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED \010D\00EDslo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812760621398906)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'cs'
,p_message_text=>unistr('Hl\00E1\0161en\00ED o\00A0\00FAsp\011Bchu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875830462398953)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875750308398952)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861489827398942)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Panel n\00E1stroj\016F')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876202293398953)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'cs'
,p_message_text=>'Rozbalit/sbalit navigaci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876315793398953)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozbalit/sbalit bo\010Dn\00ED sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785967905398886)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Hlavn\00ED navigace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792986367398891)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'cs'
,p_message_text=>'1 den'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792792397398891)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'cs'
,p_message_text=>'1 hodina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793050531398892)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 dny/dn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792854953398891)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'cs'
,p_message_text=>'%0 hodin(y)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792677300398891)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'cs'
,p_message_text=>'%0 minut(y)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793229004398892)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 t\00FDdny/t\00FDdn\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110793114315398892)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('1 t\00FDden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879414682398955)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'cs'
,p_message_text=>unistr('Za\010D\00E1tek str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741437187398854)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'cs'
,p_message_text=>'Povoleno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715244663398835)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i zpracov\00E1n\00ED po\017Eadavku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794679739398893)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\017Eadovan\00E1 hodnota')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877531508398954)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Dkejte, dokud se str\00E1nka pln\011B nena\010Dte, a\00A0opakujte pokus.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837701866398924)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'cs'
,p_message_text=>unistr('Tato str\00E1nka m\00E1 neulo\017Een\00E9 zm\011Bny.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718637822398837)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0161it nem\00E1 \017E\00E1dn\00FD aktivn\00ED list.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718517408398837)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0161it nen\00ED inicializov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718498461398837)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Do\0161lo k intern\00ED chyb\011B p\0159i vytv\00E1\0159en\00ED souboru XSLX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720920431398839)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'cs'
,p_message_text=>'List'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852617550398935)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'cs'
,p_message_text=>'Akce'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770140210398875)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('Nab\00EDdka Akce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765845918398872)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat funkci')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765787491398872)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat mo\017Enost Seskupit podle sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799965537398897)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat kontingen\010Dn\00ED sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800058776398897)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159idat sloupec \0159\00E1dku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740226798398853)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'cs'
,p_message_text=>'Agregovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776372801398880)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'cs'
,p_message_text=>'Agregace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757480982398866)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'cs'
,p_message_text=>unistr('Pr\016Fm\011Br')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761796539398869)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757557955398866)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'cs'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757792132398866)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'cs'
,p_message_text=>unistr('Medi\00E1n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757640192398866)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'cs'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757313378398866)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'cs'
,p_message_text=>unistr('Sou\010Det %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758400340398866)
,p_name=>'APEXIR_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('V\0161e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739509016398853)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('V\0161echny sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722044565398840)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('V\0161echny \0159\00E1dky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849663390398932)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Alternativn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851236940398934)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'cs'
,p_message_text=>unistr('Alternativn\00ED v\00FDchoz\00ED: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752148118398862)
,p_name=>'APEXIR_AND'
,p_message_language=>'cs'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741609724398854)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'cs'
,p_message_text=>unistr('Pou\017E\00EDt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735302707398850)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Vzestupn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754978908398864)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'cs'
,p_message_text=>'k datu %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851839536398935)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Pr\016Fm\011Br %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843253562398928)
,p_name=>'APEXIR_BAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Li\0161ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741036438398854)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'cs'
,p_message_text=>'mezi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734161334398849)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Barva pozad\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736058155398850)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'cs'
,p_message_text=>unistr('modr\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767747800398873)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'cs'
,p_message_text=>'Na konec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736605557398851)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Zru\0161it')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742538697398855)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'cs'
,p_message_text=>'Kategorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734086835398849)
,p_name=>'APEXIR_CELL'
,p_message_language=>'cs'
,p_message_text=>unistr('Bu\0148ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758394959398866)
,p_name=>'APEXIR_CHART'
,p_message_language=>'cs'
,p_message_text=>'Graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768698308398874)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'cs'
,p_message_text=>'Inicializace...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110804992295398900)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Je nutn\00E9 zadat \0161t\00EDtek grafu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817327779398909)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00E1\0161 dotaz p\0159ekra\010Duje maxim\00E1ln\00ED po\010Det %0\00A0datov\00FDch bod\016F na graf. Pou\017Eijte filtr ke sn\00ED\017Een\00ED po\010Dtu z\00E1znam\016F v\00A0z\00E1kladn\00EDm dotazu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816211599398908)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Maxim\00E1ln\00ED po\010Det \0159\00E1dek pro dotaz na Graf omezuje po\010Det \0159\00E1dek v\00A0z\00E1kladn\00EDm dotazu, nikoli po\010Det zobrazen\00FDch \0159\00E1dek. V\00E1\0161 z\00E1kladn\00ED dotaz p\0159ekra\010Duje maxim\00E1ln\00ED po\010Det \0159\00E1dek %0. Pou\017Eijte filtr, abyste sn\00ED\017Eili po\010Det z\00E1znam\016F v\00A0z\00E1kladn\00EDm dotazu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739631223398853)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'cs'
,p_message_text=>'Typ grafu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110812992718398906)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Za\0161krtnout v\0161e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755337324398864)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte form\00E1t sestavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762705411398869)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'cs'
,p_message_text=>'vymazat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736518735398851)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Sloupec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773900510398878)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>'Sloupce'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846228441398930)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'cs'
,p_message_text=>'Filtrovat...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764711135398871)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('Nab\00EDdka nadpisu sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768449711398874)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'cs'
,p_message_text=>'Informace o sloupci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848516984398932)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('\0160t\00EDtek sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766199960398872)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'cs'
,p_message_text=>'Sloupec %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750209758398860)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'cs'
,p_message_text=>'obsahuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751116958398861)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'cs'
,p_message_text=>'neobsahuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735042475398850)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'cs'
,p_message_text=>'v'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751323078398861)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED v\00A0posledn\00EDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759853565398867)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED v\00A0n\00E1sleduj\00EDc\00EDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751256102398861)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('je v\00A0posledn\00EDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759799156398867)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('je v\00A0n\00E1sleduj\00EDc\00EDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734901837398850)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('nem\00E1 hodnotu null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734890762398849)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('m\00E1 hodnotu null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734671564398849)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'cs'
,p_message_text=>'jako'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735192905398850)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734787626398849)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED jako')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750593862398861)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'cs'
,p_message_text=>unistr('shoduje se s\00A0regul\00E1rn\00EDm v\00FDrazem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755217060398864)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDpo\010Det')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110815937715398908)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDpo\010Detn\00ED v\00FDraz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774299955398878)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159te v\00FDpo\010Det pomoc\00ED alias\016F sloupc\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774372522398878)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'cs'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774422227398878)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'cs'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774563455398878)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'cs'
,p_message_text=>unistr('CASE WHEN A\00A0=10 THEN B\00A0+\00A0C ELSE B END')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720472022398839)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'cs'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759109656398867)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vypo\010D\00EDtat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766785427398872)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159eru\0161en\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769780770398875)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159eru\0161en\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854124270398936)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupce p\0159eru\0161en\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717596007398837)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det jedine\010Dn\00FDch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852366579398935)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det jedine\010Dn\00FDch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852290155398935)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824312799398914)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'cs'
,p_message_text=>unistr('Denn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879064246398955)
,p_name=>'APEXIR_DATA'
,p_message_language=>'cs'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768552798398874)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'cs'
,p_message_text=>unistr('Data sestavy jako p\0159ed %0\00A0minutami.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842018017398927)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda k\00A0datov\00E9 m\0159\00ED\017Ece')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740312661398853)
,p_name=>'APEXIR_DATE'
,p_message_language=>'cs'
,p_message_text=>'Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772426427398877)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849463624398932)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED typ sestavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736722197398851)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'cs'
,p_message_text=>'Odstranit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740672920398854)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'cs'
,p_message_text=>unistr('Chcete smazat toto nastaven\00ED sestav?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835374896398922)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Odstranit v\00FDchoz\00ED sestavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766433568398872)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'cs'
,p_message_text=>'Odstranit sestavu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735438253398850)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Sestupn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742687774398855)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'cs'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764658909398871)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Jedno\0159\00E1dkov\00E9 zobrazen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772968674398877)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Sm\011Br %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773876901398878)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'cs'
,p_message_text=>unistr('Zak\00E1z\00E1no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736289573398850)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'cs'
,p_message_text=>'Zobrazeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739464676398853)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00E9 sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772839209398877)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazit v\00A0sestav\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767606999398873)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'cs'
,p_message_text=>unistr('Dol\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759256708398867)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'cs'
,p_message_text=>unistr('St\00E1hnout')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772703748398877)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'cs'
,p_message_text=>'Nezobrazovat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838758149398924)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'cs'
,p_message_text=>unistr('Zv\00FDrazn\011Bn\00ED se stejnou podm\00EDnkou ji\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854324750398936)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Duplicitn\00ED kontingen\010Dn\00ED sloupec. Seznam kontingen\010Dn\00EDch sloupc\016F mus\00ED b\00FDt jedine\010Dn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854566183398936)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'cs'
,p_message_text=>'Upravit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768793141398874)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'cs'
,p_message_text=>unistr('Upravit nastaven\00ED grafu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775390587398879)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'cs'
,p_message_text=>'Upravit graf'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775758809398879)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'cs'
,p_message_text=>'Upravit filtr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830160463398918)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'cs'
,p_message_text=>'Upravit Seskupit podle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775600791398879)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('Upravit zv\00FDrazn\011Bn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800247533398897)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'cs'
,p_message_text=>'Upravit operaci pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849774320398932)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'cs'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728442608398845)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'cs'
,p_message_text=>unistr('E-mailov\00E1 adresa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850079481398933)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'cs'
,p_message_text=>unistr('Skryt\00E1 kopie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850249941398933)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'cs'
,p_message_text=>unistr('Text zpr\00E1vy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849963149398933)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'cs'
,p_message_text=>'Kopie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850789929398934)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'cs'
,p_message_text=>'Frekvence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732112606398847)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'cs'
,p_message_text=>unistr('E-mail nebyl pro tuto aplikaci konfigurov\00E1n. Obra\0165te se na sv\00E9ho spr\00E1vce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823651296398914)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Je t\0159eba zadat e-mailovou adresu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850325328398933)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'cs'
,p_message_text=>unistr('Viz p\0159\00EDloha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850127262398933)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edm\011Bt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824662809398914)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Je t\0159eba zadat p\0159edm\011Bt e-mailu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849827575398933)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDjemce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733801186398849)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'cs'
,p_message_text=>'Povoleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775513232398879)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'cs'
,p_message_text=>'Aktivovat/Deaktivovat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775060107398879)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'cs'
,p_message_text=>'Chyba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774610886398878)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDklady')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775422909398879)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDklady:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739308338398853)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vylou\010Dit hodnoty null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776083303398879)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'cs'
,p_message_text=>'Rozbalit/sbalit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773660434398878)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDraz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758798655398867)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'cs'
,p_message_text=>'Filtrovat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769697818398875)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'cs'
,p_message_text=>'Filtry'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779914784398882)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('Filtrovac\00ED v\00FDraz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876478507398953)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDraz filtru je p\0159\00EDli\0161 dlouh\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779823927398882)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'cs'
,p_message_text=>'Typ filtru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776266388398880)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyberte sloupce, kter\00E9 chcete vyhledat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759012261398867)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'cs'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773415900398877)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Flashback v\00E1m umo\017En\00ED zobrazit data tak, jak existovala v\00A0konkr\00E9tn\00EDm okam\017Eiku v\00A0minulosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824060941398914)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Trv\00E1n\00ED flashbacku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825475264398915)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Form\00E1t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755176248398864)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'cs'
,p_message_text=>unistr('Form\00E1tovac\00ED maska %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766393649398872)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>'Funkce'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774133549398878)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'cs'
,p_message_text=>'Funkce %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849324327398932)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'cs'
,p_message_text=>unistr('Funkce/Oper\00E1tory')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766056995398872)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'cs'
,p_message_text=>'Funkce %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758521465398866)
,p_name=>'APEXIR_GO'
,p_message_language=>'cs'
,p_message_text=>'Spustit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734386097398849)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'cs'
,p_message_text=>unistr('zelen\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110717620461398837)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'cs'
,p_message_text=>'Seskupit podle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850411983398933)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Seskupit podle sloupce %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805069755398900)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Je nutn\00E9 zadat sloupce seskupen\00ED podle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816127755398908)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Maxim\00E1ln\00ED po\010Det \0159\00E1dek pro dotaz Seskupit podle omezuje po\010Det \0159\00E1dek v\00A0z\00E1kladn\00EDm dotazu, nikoli po\010Det zobrazen\00FDch \0159\00E1dek. V\00E1\0161 z\00E1kladn\00ED dotaz p\0159ekra\010Duje maxim\00E1ln\00ED po\010Det \0159\00E1dek\00A0%0. Pou\017Eijte filtr, abyste sn\00ED\017Eili po\010Det z\00E1znam\016F v\00A0z\00E1kladn\00EDm dotazu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796747460398894)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159azen\00ED seskupen\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854294687398936)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\0159ad\00ED se\0159azen\00ED seskupen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739772254398853)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Horizont\00E1ln\00ED sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771339893398876)
,p_name=>'APEXIR_HELP'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763168380398870)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Interaktivn\00ED sestavy koncov\00FDm u\017Eivatel\016Fm umo\017E\0148uj\00ED si sestavy p\0159izp\016Fsobit. U\017Eivatel\00E9 mohou zm\011Bnit rozlo\017Een\00ED dat sestavy v\00FDb\011Brem sloupc\016F, pou\017Eit\00EDm filtr\016F, zv\00FDrazn\011Bn\00EDm a se\0159azen\00EDm. U\017Eivatel\00E9 mohou tak\00E9 definovat p\0159eru\0161en\00ED, agregace, grafy, seskupen\00ED a\00A0p')
||unistr('\0159idat vlastn\00ED v\00FDpo\010Dty. U\017Eivatel\00E9 mohou tak\00E9 nastavit subskripce, aby jim byla ve stanoven\00E9m intervalu zas\00EDl\00E1na e-mailov\00E1 verze sestavy ve form\00E1tu HTML. U\017Eivatel\00E9 mohou vytvo\0159it v\00EDce variant sestavy a\00A0ulo\017Eit je jako pojmenovan\00E9 sestavy pro ve\0159ejn\00E9 neb')
||unistr('o soukrom\00E9 prohl\00ED\017Een\00ED '),
'<p/>',
unistr('N\00E1sleduj\00EDc\00ED \010D\00E1sti shrnuj\00ED zp\016Fsoby, jak si m\016F\017Eete interaktivn\00ED sestavu p\0159izp\016Fsobit. Dal\0161\00ED informace najdete v \010D\00E1sti \201EPou\017E\00EDv\00E1n\00ED interaktivn\00EDch zpr\00E1v\201C v\00A0<i>p\0159\00EDru\010Dce koncov\00E9ho u\017Eivatele aplikace Oracle Application Express </i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770261266398875)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('Nab\00EDdka Akce se zobraz\00ED na li\0161t\011B Vyhled\00E1v\00E1n\00ED napravo od tla\010D\00EDtka P\0159ej\00EDt. Pomoc\00ED t\00E9to nab\00EDdky m\016F\017Eete p\0159izp\016Fsobit interaktivn\00ED sestavu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763982570398870)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agregace jsou matematick\00E9 v\00FDpo\010Dty proveden\00E9 na sloupci. Agregace se zobrazuj\00ED po ka\017Ed\00E9m p\0159eru\0161en\00ED a\00A0na konci sestavy ve sloupci, ve kter\00E9m jsou definov\00E1ny. Mo\017Enosti zahrnuj\00ED:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agregace</strong> umo\017E\0148uje vybrat d\0159\00EDve'),
'definovanou agregaci, kterou chcete upravit.</li>',
unistr('<li><strong>Funkce</strong> je funkce, kter\00E1 m\00E1 b\00FDt provedena (nap\0159\00EDklad SUM, MIN).</li>'),
unistr('<li><strong>Sloupec</strong> se pou\017E\00EDv\00E1 k\00A0v\00FDb\011Bru sloupce, na kter\00FD se m\00E1 pou\017E\00EDt matematick\00E1 funkce. Zobraz\00ED se pouze'),
unistr('\010D\00EDseln\00E9 sloupce.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764064365398870)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pro ka\017Ed\00FD ulo\017Een\00FD p\0159ehled m\016F\017Eete definovat jeden graf. Jakmile je'),
unistr('definovan\00FD, m\016F\017Eete p\0159ep\00EDnat mezi zobrazen\00EDm grafu a\00A0sestavy pomoc\00ED ikon zobrazen\00ED na li\0161t\011B Vyhled\00E1v\00E1n\00ED.'),
unistr('Volby zahrnuj\00ED:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Typ grafu</strong> ur\010Duje typ grafu, kter\00FD bude vybr\00E1n.'),
unistr('Vybrat m\016F\017Eete vodorovn\00FD sloupcov\00FD, svisl\00FD sloupcov\00FD, v\00FDse\010Dov\00FD nebo \010D\00E1rov\00FD.</li>'),
unistr('<li><strong>\0160t\00EDtek</strong> umo\017E\0148uje vybrat sloupec, kter\00FD bude pou\017Eit jako \0161t\00EDtek.</li>'),
unistr('<li><strong>N\00E1zev osy pro \0161t\00EDtek</strong> je n\00E1zev, kter\00FD se zobrazuje na ose p\0159idru\017Een\00E9 ke sloupci vybran\00E9mu pro'),
unistr('\0161t\00EDtek. Nen\00ED to k\00A0dispozici pro v\00FDse\010Dov\00FD graf.</li>'),
unistr('<li><strong>Hodnota</strong> umo\017E\0148uje vybrat sloupec, kter\00FD m\00E1 b\00FDt pou\017E\00EDt jako Hodnota. Pokud je va\0161e funkce'),
unistr('COUNT, Hodnotu nen\00ED nutn\00E9 vyb\00EDrat.</li>'),
unistr('<li><strong>N\00E1zev osy pro Hodnotu</strong> je n\00E1zev, kter\00FD se zobrazuje na ose p\0159idru\017Een\00E9 ke sloupci vybran\00E9mu pro'),
unistr('Hodnotu. Nen\00ED to k\00A0dispozici pro v\00FDse\010Dov\00FD graf.</li>'),
unistr('<li><strong>Funkce</strong> je voliteln\00E1 funkce, kterou lze prov\00E9st ve sloupci vybran\00E9m pro Hodnotu.</li>'),
unistr('<li><strong>\0158adit </strong> umo\017E\0148uje se\0159adit sadu v\00FDsledk\016F.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763398585398870)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kliknut\00EDm na z\00E1hlav\00ED kter\00E9hokoli sloupce se zobraz\00ED nab\00EDdka z\00E1hlav\00ED sloupce. Mo\017Enosti zahrnuj\00ED:'),
'<p></p>',
'<ul>',
unistr('<li>Ikona <strong>Se\0159adit vzestupn\011B</strong> se\0159ad\00ED sestavu ve vzestupn\00E9m po\0159ad\00ED podle sloupce.</li>'),
unistr('<li>Ikona <strong>Se\0159adit sestupn\011B</strong> se\0159ad\00ED sestavu v\00A0sestupn\00E9m po\0159ad\00ED podle sloupce.</li>'),
unistr('<li>Ikona <strong>Skr\00FDt sloupec</strong> skryje sloupec. Ne v\0161echny sloupce lze skr\00FDt. Pokud sloupec nelze skr\00FDt, ikona Skr\00FDt sloupec zde nebude.</li>'),
unistr('<li>Ikona <strong>Sloupec p\0159eru\0161en\00ED</strong> vytvo\0159\00ED na sloupci skupinu p\0159eru\0161en\00ED. T\00EDm se ze sloupec v sestav\011B stane hlavn\00ED z\00E1znam.</li>'),
unistr('<li><strong>Informace o\00A0sloupci</strong> zobraz\00ED text n\00E1pov\011Bdy ke sloupci, pokud je k\00A0dispozici.</li>'),
unistr('<li><strong>Textov\00E1 oblast</strong> se pou\017E\00EDv\00E1 k\00A0zad\00E1n\00ED krit\00E9ri\00ED vyhled\00E1v\00E1n\00ED bez rozli\0161en\00ED velk\00FDch a\00A0mal\00FDch p\00EDsmen'),
unistr('(z\00E1stupn\00E9 znaky nejsou t\0159eba). Zad\00E1n\00EDm hodnoty se redukuje seznam'),
unistr('hodnot v\00A0doln\00ED \010D\00E1sti nab\00EDdky. Pot\00E9 m\016F\017Eete zdola vybrat hodnotu'),
unistr('a\00A0vybran\00E1 hodnota bude pou\017Eita jako filtr s oper\00E1torem \201E=\201C'),
unistr('(p\0159\00EDklad: <code>column\00A0=\00A0''ABC''</code>). P\0159\00EDpadn\011B m\016F\017Eete kliknout na ikonu s baterkou a zadat hodnotu, kter\00E1 m\00E1 b\00FDt pou\017Eita jako filtr s oper\00E1torem \201ELIKE\201C (p\0159\00EDklad: <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>Seznam jedine\010Dn\00FDch hodnot</b> obsahuje prvn\00EDch 500 jedine\010Dn\00FDch'),
unistr('hodnot, kter\00E9 spl\0148uj\00ED va\0161e krit\00E9ria filtru. Pokud je ve sloupci datum, zobraz\00ED se'),
unistr('m\00EDsto toho seznam rozsahu dat. Pokud vyberete hodnotu, vytvo\0159\00ED se filtr'),
unistr('s pou\017Eit\00EDm \201E=\201C (p\0159\00EDklad: <code>column\00A0=\00A0''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763836759398870)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017E\0148uje p\0159idat do sestavy vypo\010D\00EDtan\00E9 sloupce. Mohou to b\00FDt matematick\00E9 v\00FDpo\010Dty (p\0159\00EDklad: <code>NBR_HOURS/24</code>) nebo standardn\00ED funkce'),
unistr('Oracle p\0159i\0159azen\00E9 existuj\00EDc\00EDm sloupc\016Fm. N\011Bkter\00E9 se zobrazuj\00ED jako p\0159\00EDklady a\00A0jin\00E9 (nap\0159\00EDklad <code> TO_DATE) </code> lze pou\017E\00EDt tak\00E9. Mo\017Enosti zahrnuj\00ED:'),
'<p></p>',
'<ul>',
unistr('<li><strong>V\00FDpo\010Det</strong> umo\017E\0148uje vybrat d\0159\00EDve definovan\00FD v\00FDpo\010Det, kter\00FD chcete upravit.</li>'),
unistr('<li><strong>Nadpis sloupce</strong> je nadpis sloupce pro nov\00FD sloupec.</li>'),
unistr('<li><strong>Maska form\00E1tu</strong> je maska form\00E1tu Oracle, kter\00E1 se pou\017E\00EDv\00E1 na sloupce (p\0159\00EDklad: S9999).</li>'),
unistr('<li><strong>V\00FDpo\010Det</strong> je v\00FDpo\010Det, kter\00FD se m\00E1 prov\00E9st. V\00A0r\00E1mci v\00FDpo\010Dtu se na sloupce odkazuje pomoc\00ED zobrazen\00FDch alias\016F.</li>'),
'</ul>',
unistr('<p>Pod v\00FDpo\010Dtem se sloupce v\00A0dotazu zobraz\00ED s\00A0jejich'),
unistr('p\0159idru\017Een\00FDm aliasem. Kliknut\00ED na n\00E1zev sloupce nebo alias je zahrne'),
unistr('ve v\00FDpo\010Dtu. Vedle sloupc\016F je kl\00E1vesnice. Tato kl\00E1vesnice funguje jako'),
unistr('zkratka pro b\011B\017En\011B pou\017E\00EDvan\00E9 kl\00E1vesy. \00DApln\011B vpravo jsou funkce.</p>'),
unistr('<p>N\00E1sleduj\00EDc\00ED p\0159\00EDklad v\00FDpo\010Dtu ukazuje, jak zobrazit celkovou kompenzaci:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(kde A je ORGANIZACE, B je MZDA a\00A0C je PROVIZE)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770357705398875)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'cs'
,p_message_text=>unistr('Slou\017E\00ED k\00A0vytvo\0159en\00ED skupiny p\0159eru\0161en\00ED na jednom nebo n\011Bkolika sloupc\00EDch. Tato funkce vyt\00E1hne sloupce z\00A0interaktivn\00ED sestavy a\00A0zobraz\00ED je jako hlavn\00ED z\00E1znam.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764578907398871)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Pokud chcete zobrazit v\0161echny podrobnosti jednoho \0159\00E1dku najednou, klikn\011Bte na ikonu Jedno\0159\00E1dkov\00E9 zobrazen\00ED pro \0159\00E1dek, kter\00FD chcete zobrazit. Pokud je k\00A0dispozici, bude jedno\0159\00E1dkov\00E9 zobrazen\00ED v\017Edy v\00A0prvn\00EDm sloupci. V\00A0z\00E1vislosti na p\0159izp\016Fsoben\00ED interak')
||unistr('tivn\00ED sestavy m\016F\017Ee b\00FDt jedno\0159\00E1dkov\00E9 zobrazen\00EDm standardn\00ED zobrazen\00ED nebo p\0159izp\016Fsoben\00E1 str\00E1nka, kter\00E1 m\016F\017Ee umo\017E\0148ovat aktualizaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764486704398871)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017E\0148uje sta\017Een\00ED aktu\00E1ln\00ED sady v\00FDsledk\016F. Form\00E1ty ke sta\017Een\00ED'),
unistr('se li\0161\00ED v\00A0z\00E1vislosti na va\0161\00ED instalaci a definici sestavy, ale'),
'mohou zahrnovat CSV, HTML, e-mail, XLS, PDF nebo RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763503233398870)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Zp\0159esn\00ED sestavu p\0159id\00E1n\00EDm nebo \00FApravou klauzule <code> WHERE </code> v\00A0dotazu. M\016F\017Eete filtrovat podle sloupce nebo podle \0159\00E1dku.'),
unistr('<p>Pokud filtrujete podle sloupce, vyberte sloupec (nemus\00ED b\00FDt zobrazen), vyberte standardn\00ED oper\00E1tor Oracle (=, !=, nen\00ED v, mezi) a\00A0zadejte v\00FDraz. Ve v\00FDrazech se rozli\0161uj\00ED velk\00E1 a\00A0mal\00E1 p\00EDsmena. Pou\017Eijte % jako z\00E1stupn\00FD znak (p\0159\00EDklad: <code>STATE_NAM')
||'E',
'like A%)</code>.</p>',
unistr('<p>Pokud filtrujete podle \0159\00E1dku, m\016F\017Eete vytv\00E1\0159et komplexn\00ED klauzule <code>WHERE</code> pomoc\00ED'),
unistr('alias\016F sloupc\016F a\00A0jin\00FDch funkc\00ED nebo oper\00E1tor\016F Oracle (p\0159\00EDklad: <code>G\00A0=\00A0''VA'' or G\00A0=\00A0''CT''</code>, kde'),
'<code>G</code> je alias pro <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764172565398870)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Flashback  v\00E1m umo\017En\00ED zobrazit data tak, jak existovala v\00A0minulosti'),
unistr('V\00FDchoz\00ED doba, kterou m\016F\017Eete zp\011Btn\011B vyvolat, jsou 3\00A0hodiny '),
unistr('(nebo 180\00A0minut), ale skute\010Dn\00E1 doba se bude u\00A0ka\017Ed\00E9 datab\00E1ze li\0161it.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825347306398915)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Form\00E1t umo\017E\0148uje p\0159izp\016Fsobit zobrazen\00ED sestavy.'),
unistr('Form\00E1t obsahuje n\00E1sleduj\00EDc\00ED podnab\00EDdku:</p>'),
unistr('<ul><li>\0158adit</li>'),
unistr('<li>P\0159eru\0161en\00ED</li>'),
unistr('<li>Zv\00FDraznit</li>'),
unistr('<li>Vypo\010D\00EDtat</li>'),
'<li>Agregace</li>',
'<li>Graf</li>',
unistr('<li>Seskupen\00ED</li>'),
'<li>Operace Pivot</li> ',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823549745398913)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Na jedenu ulo\017Eenou sestavu m\016F\017Eete definovat jedno zobrazen\00ED seskupen\00ED. Jakmile je definov\00E1no, m\016F\017Eete pomoc\00ED ikon zobrazen\00ED na li\0161t\011B Vyhled\00E1v\00E1n\00ED p\0159ep\00EDnat mezi zobrazen\00EDm seskupen\00ED a\00A0zobrazen\00EDm sestavy. Pokud chcete vytvo\0159it zobrazen\00ED seskupen\00ED,'),
'vyberte:',
'<p></p><ul>',
unistr('<li>sloupce, kter\00E9 chcete seskupit</li>'),
unistr('<li>sloupce, kter\00E9 chcete agregovat spolu s\00A0funkc\00ED, kter\00E1 m\00E1 b\00FDt provedena (pr\016Fm\011Br, suma, po\010Det atd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763793296398870)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Umo\017E\0148uje definovat filtr. \0158\00E1dky, kter\00E9 spl\0148uj\00ED krit\00E9ria filtru, budou zv\00FDrazn\011Bny tak, jak je definov\00E1no ve filtru. Mo\017Enosti zahrnuj\00ED:</p>'),
'<ul>',
unistr('<li><strong>N\00E1zev</strong> je pou\017Eit jen pro zobrazen\00ED.</li>'),
unistr('<li><strong>Sekvence</strong> ur\010Duje po\0159ad\00ED, ve kter\00E9m jsou pravidla vyhodnocov\00E1na. </li>'),
unistr('<li><strong>Povoleno</strong> ur\010Duje, zda je pravidlo povoleno nebo zak\00E1z\00E1no.</li>'),
unistr('<li><strong>Typ zv\00FDrazn\011Bn\00ED</strong> ur\010Duje, zda by m\011Bla b\00FDt zv\00FDrazn\011Bna \0159\00E1dka nebo bu\0148ka.'),
unistr('Pokud je vybr\00E1na bu\0148ka, je zv\00FDrazn\011Bn sloupec,'),
unistr('pou\017Eit\00FD v\00A0podm\00EDnce zv\00FDrazn\011Bn\00ED.</li>'),
unistr('<li><strong>Barva pozad\00ED</strong> je nov\00E1 barva pozad\00ED zv\00FDrazn\011Bn\00E9 oblasti.</li>'),
unistr('<li><strong>Barva textu</strong> je nov\00E1 barva textu ve zv\00FDrazn\011Bn\00E9 oblasti.</li>'),
unistr('<li><strong>Podm\00EDnka zv\00FDrazn\011Bn\00ED</strong> definuje podm\00EDnku filtru.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701392717398825)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Na ulo\017Een\00FD p\0159ehled m\016F\017Eete definovat jedno kontingen\010Dn\00ED zobrazen\00ED. Po definov\00E1n\00ED m\016F\017Eete p\0159ep\00EDnat mezi kontingen\010Dn\00EDm a\00A0p\0159ehledov\00FDm zobrazen\00EDm pomoc\00ED ikon zobrazen\00ED na vyhled\00E1vac\00EDm panelu. Pokud chcete vytvo\0159it kontingen\010Dn\00ED zobrazen\00ED, vyberete: '),
'<p></p>',
'<ul>',
unistr('<li>sloupce, na kter\00E9 m\00E1 b\00FDt pou\017Eita funkce pivot</li>'),
unistr('<li>sloupce, kter\00E9 maj\00ED b\00FDt zobrazeny jako \0159\00E1dky</li>'),
unistr('<li>sloupce, kter\00E9 maj\00ED b\00FDt agregov\00E1ny spolu s\00A0funkc\00ED, kter\00E1 m\00E1 b\00FDt provedena (pr\016Fm\011Br, suma, po\010Det atd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774849580398879)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pokud si p\0159izp\016Fsob\00EDte interaktivn\00ED sestavu, zobraz\00ED se jej\00ED nastaven\00ED'),
unistr('pod vyhled\00E1vac\00ED li\0161tou a\00A0nad sestavou. Tuto oblast lze sbalit a\00A0rozbalit pomoc\00ED ikony vlevo.'),
'<p>',
unistr('U ka\017Ed\00E9ho nastaven\00ED sestavy m\016F\017Eete:'),
'</p><ul>',
unistr('<li>Upravit nastaven\00ED kliknut\00EDm na n\00E1zev.</li>'),
unistr('<li>Zak\00E1zat nebo povolit nastaven\00ED za\0161krtnut\00EDm nebo od\0161krtnut\00EDm pol\00ED\010Dka Povolit/Zak\00E1zat. Pomoc\00ED tohoto ovl\00E1dac\00EDho prvku m\016F\017Eete nastaven\00ED do\010Dasn\011B zapnout nebo vypnout.</li>'),
unistr('<li>Odebrat nastaven\00ED kliknut\00EDm na ikonu Odebrat.</li>'),
'</ul>',
unistr('<p>Pokud jste vytvo\0159ili graf, seskupen\00ED nebo funkci pivot, m\016F\017Eete p\0159ep\00EDnat mezi nimi'),
unistr('a\00A0z\00E1kladn\00ED sestavou pomoc\00ED odkaz\016F Zobrazen\00ED sestavy, Zobrazen\00ED grafu, Zobrazen\00ED seskupen\00ED a\00A0Zobrazen\00ED pivot'),
unistr('zobrazen\00FDch vpravo. Pokud si prohl\00ED\017E\00EDte graf, seskupen\00ED nebo pivot,'),
unistr('m\016F\017Eete tak\00E9 upravit nastaven\00ED pomoc\00ED odkazu Upravit.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764375697398871)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'cs'
,p_message_text=>unistr('Obnov\00ED sestavu zp\011Bt na v\00FDchoz\00ED nastaven\00ED a\00A0odebere ve\0161ker\00E1 p\0159izp\016Fsoben\00ED, kter\00E1 jste provedli.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825654278398915)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Nastav\00ED po\010Det z\00E1znam\016F, kter\00E9 se maj\00ED zobrazit na str\00E1nku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764214103398871)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ulo\017E\00ED p\0159izp\016Fsobenou sestavu pro budouc\00ED pou\017Eit\00ED. Poskytnete n\00E1zev a\00A0voliteln\00FD popis a\00A0m\016F\017Eete sestavu zp\0159\00EDstupnit ve\0159ejnosti (tj.\00A0v\0161em u\017Eivatel\016Fm, kte\0159\00ED maj\00ED p\0159\00EDstup k\00A0prim\00E1rn\00ED v\00FDchoz\00ED sestav\011B). M\016F\017Eete ulo\017Eit \010Dty\0159i typy interaktivn\00EDch sestav:</p>'),
'<ul>',
unistr('<li><strong>Prim\00E1rn\00ED v\00FDchoz\00ED</strong> (pouze pro v\00FDvoj\00E1\0159e). Prim\00E1rn\00ED v\00FDchoz\00ED je sestava, kter\00E1 se zobraz\00ED na za\010D\00E1tku. Prim\00E1rn\00ED v\00FDchoz\00ED sestavy nelze p\0159ejmenovat ani smazat.</li>'),
unistr('<li><strong>Alternativn\00ED sestava</strong> (pouze pro v\00FDvoj\00E1\0159e). Umo\017E\0148uje v\00FDvoj\00E1\0159\016Fm vytv\00E1\0159et v\00EDce rozvr\017Een\00ED sestavy. Alternativn\00ED sestavu mohou ulo\017Eit, p\0159ejmenovat nebo odstranit pouze v\00FDvoj\00E1\0159i.</li>'),
unistr('<li><strong>Ve\0159ejn\00E1 sestava</strong> (koncov\00FD u\017Eivatel). M\016F\017Ee b\00FDt ulo\017Eena, p\0159ejmenov\00E1na nebo odstran\011Bna koncov\00FDm u\017Eivatelem, kter\00FD ji vytvo\0159il. Ostatn\00ED u\017Eivatel\00E9 mohou rozlo\017Een\00ED zobrazit a\00A0ulo\017Eit jako novou sestavu.</li>'),
unistr('<li><strong>Soukrom\00E1 sestava</strong> (koncov\00FD u\017Eivatel). Pouze koncov\00FD u\017Eivatel, kter\00FD sestavu vytvo\0159il, ji m\016F\017Ee zobrazit, ulo\017Eit, p\0159ejmenovat nebo odstranit.</li>'),
'</ul>',
unistr('<p>Pokud p\0159izp\016Fsoben\00E9 sestavy ulo\017E\00EDte, zobraz\00ED se na li\0161t\011B Vyhled\00E1v\00E1n\00ED selektor Sestav vlevo od selektoru \0158\00E1dk\016F (pokud je tato funkce povolena).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763299124398870)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00A0horn\00ED \010D\00E1sti ka\017Ed\00E9 str\00E1nky sestavy je oblast vyhled\00E1v\00E1n\00ED. Tato oblast (nebo vyhled\00E1vac\00ED li\0161ta) poskytuje n\00E1sleduj\00EDc\00ED funkce:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826296467398915)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('<li><strong>Nab\00EDdka Akce</strong> umo\017E\0148uje upravit sestavu. Viz n\00E1sleduj\00EDc\00ED \010D\00E1sti.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825749245398915)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'cs'
,p_message_text=>unistr('<li><strong>Ikona Vybrat sloupce </strong> umo\017E\0148uje ur\010Dit, ve kter\00E9m sloupci (p\0159\00EDpadn\011B ve v\0161ech) se m\00E1 hledat.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826050242398915)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'cs'
,p_message_text=>unistr('<li>Ikona <strong>Sestavy</strong> zobraz\00ED alternativn\00ED v\00FDchoz\00ED a\00A0ulo\017Een\00E9 soukrom\00E9 nebo ve\0159ejn\00E9 sestavy.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825940198398915)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('<li>Ikona <strong>\0158\00E1dky</strong> nastav\00ED po\010Det z\00E1znam\016F, kter\00E9 se maj\00ED zobrazit na str\00E1nku.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825889782398915)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>Ikona <strong>Textov\00E1 oblast</strong> umo\017E\0148uje zadat krit\00E9ria vyhled\00E1v\00E1n\00ED bez rozli\0161ov\00E1n\00ED velk\00FDch a\00A0mal\00FDch p\00EDsmen (z\00E1stupn\00E9 znaky jsou zahrnuty).</li>'),
unistr('<li><strong>Tla\010D\00EDtko Spustit</strong> spust\00ED vyhled\00E1v\00E1n\00ED. Stisknut\00EDm kl\00E1vesy Enter lze tak\00E9 spustit vyhled\00E1v\00E1n\00ED, pokud je kurzor v\00A0oblasti vyhled\00E1n\00ED textu.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826105543398915)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('<li><strong>Ikony Zobrazen\00ED</strong> p\0159ep\00EDnaj\00ED mezi zobrazen\00EDm ikon, sestav, podrobnost\00ED, graf\016F, seskupen\00ED a\00A0kontingen\010Dn\00EDm zobrazen\00EDm sestav, pokud jsou tato zobrazen\00ED definov\00E1na.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842122393398927)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('<li>Nab\00EDdka <strong>Spr\00E1va</strong> umo\017E\0148uje prov\00E1d\011Bt spr\00E1vu vlastnost\00ED, sloupc\016F, \0159\00E1dek a\00A0zobrazit historii sestavy nebo datov\00E9 m\0159\00ED\017Eky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763470486398870)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Slou\017E\00ED k\00A0\00FAprav\011B zobrazen\00FDch sloupc\016F. Sloupce vpravo se zobraz\00ED. Sloupce vlevo jsou skryt\00E9. Uspo\0159\00E1d\00E1n\00ED zobrazen\00FDch sloupc\016F m\016F\017Eete zm\011Bnit pomoc\00ED \0161ipek vpravo. P\0159ed po\010D\00EDtan\00FDmi sloupci je p\0159edpona <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763637833398870)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Slou\017E\00ED ke zm\011Bn\011B sloupc\016F, kter\00E9 se maj\00ED se\0159adit, a\00A0ur\010Duje, zda'),
unistr('se\0159adit vzestupn\011B nebo sestupn\011B. M\016F\017Eete tak\00E9 ur\010Dit, jak zach\00E1zet se znaky'),
unistr('<code>NULL</code>. V\00FDchoz\00ED nastaven\00ED v\017Edy zobraz\00ED znaky<code> NULL </code> posledn\00ED nebo je v\017Edy zobraz\00ED jako prvn\00ED. V\00FDsledn\00E9 t\0159\00EDd\011Bn\00ED se zobraz\00ED napravo od'),
unistr('z\00E1hlav\00ED sloupc\016F v\00A0sestav\011B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823333176398913)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159i p\0159id\00E1n\00ED subskripce, uv\00E1d\00EDte e-mailovou adresu (nebo v\00EDce e-mailov\00FDch adres odd\011Blen\00FDch \010D\00E1rkami), p\0159edm\011Bt e-mailu, frekvenci a\00A0datum zah\00E1jen\00ED a\00A0ukon\010Den\00ED. E-maily, kter\00E9 v\00E1m budou na z\00E1klad\011B subskripce doru\010Dov\00E1ny, obsahuj\00ED HTML verzi interaktivn\00ED se')
||unistr('stavy, ktera obsahuje aktu\00E1ln\00ED data vyu\017E\00EDvaj\00EDc\00ED nastaven\00ED sestavy, kter\00E1 byla k\00A0dispozici p\0159i p\0159id\00E1n\00ED subskripce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841912272398927)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Datov\00E9 m\0159\00ED\017Eky jsou v\00A0podstat\011B upraviteln\00E9 sestavy, kter\00E9 si lze velmi dob\0159e p\0159izp\016Fsobit. U\017Eivatel\00E9 mohou zm\011Bnit rozlo\017Een\00ED dat sestavy v\00FDb\011Brem sloupc\016F, pou\017Eit\00EDm filtr\016F, zv\00FDrazn\011Bn\00EDm a\00A0se\0159azen\00EDm. U\017Eivatel\00E9 mohou tak\00E9 definovat p\0159eru\0161en\00ED, agregace, grafy')
||unistr(', seskupen\00ED a p\0159id\00E1vat vlastn\00ED v\00FDpo\010Dty. U\017Eivatel\00E9 mohou vytvo\0159it v\00EDce variant sestavy a\00A0ukl\00E1dat je jako pojmenovan\00E9 sestavy pro soukrom\00E9 prohl\00ED\017Een\00ED. '),
'<p/>',
unistr('Datovou m\0159\00ED\017Eku lze p\0159izp\016Fsobit pomoc\00ED li\0161t\011B Vyhled\00E1v\00E1n\00ED nebo pomoc\00ED nab\00EDdky Akce, nab\00EDdky Spr\00E1va nebo nab\00EDdky Nadpisy sloupc\016F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853786627398936)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'cs'
,p_message_text=>unistr('Nab\00EDdka Akce se zobraz\00ED na li\0161t\011B Vyhled\00E1v\00E1n\00ED napravo od tla\010D\00EDtka P\0159ej\00EDt. Pomoc\00ED t\00E9to nab\00EDdky m\016F\017Eete p\0159izp\016Fsobit sestavu datov\00E9 m\0159\00ED\017Eky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842462730398927)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'cs'
,p_message_text=>unistr('Str\00E1nka P\0159idat/upravit \0159\00E1dku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842596984398927)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pokud chcete p\0159idat \0159\00E1dku do datov\00E9 m\0159\00ED\017Eky, klikn\011Bte na P\0159idat \0159\00E1dku. Pokud chcete upravit podrobnosti \0159\00E1dky, klikn\011Bte na ikonu Upravit \0159\00E1dku (prvn\00ED sloupec) na \0159\00E1dce, kterou chcete upravit. Zobraz\00ED se str\00E1nka P\0159idat/Upravit \0159\00E1dku zobrazuj\00EDc\00ED slou')
||unistr('pce datov\00E9 m\0159\00ED\017Eky. </p>'),
'',
unistr('<p>P\0159i \00FAprav\00E1ch \0159\00E1dek m\016F\017Eete:</p>'),
'',
'<p><ul>',
unistr('<li><strong>Odstranit</strong> \0159\00E1dku.</li>'),
unistr('<li><strong>Pou\017E\00EDt zm\011Bny</strong> pro ulo\017Een\00ED zm\011Bn proveden\00FDch v\00A0\0159\00E1dce. </li>'),
unistr('<li>V\00A0\010D\00E1sti <strong>Akce</strong> p\0159idat \0159\00E1dku, soubory, pozn\00E1mky, odkazy nebo \0161t\00EDtky a\00A0zkontrolovat historii.</li>'),
unistr('<li>P\0159ech\00E1zet na <strong>Dal\0161\00ED a\00A0P\0159edchoz\00ED</strong> \0159\00E1dky.</li>'),
unistr('<li>V\00A0\010D\00E1sti <strong>Spr\00E1va</strong> nastavovat vlastnosti sloupc\016F, skupiny sloupc\016F, ov\011B\0159en\00ED a\00A0seznamy hodnot.</li>'),
'</ul></p>',
'',
unistr('<p>Oblast Pozn\00E1mky ve spodn\00ED \010D\00E1sti str\00E1nky zobraz\00ED v\0161echny soubory, pozn\00E1mky, odkazy nebo \0161t\00EDtky p\0159idru\017Een\00E9 k\00A0aktu\00E1ln\00EDmu \0159\00E1dku.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853876248398936)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'cs'
,p_message_text=>unistr('Slou\017E\00ED k\00A0vytvo\0159en\00ED skupiny p\0159eru\0161en\00ED na jednom nebo n\011Bkolika sloupc\00EDch. Tato funkce vyt\00E1hne sloupce z\00A0datov\00E9 m\0159\00ED\017Eky a\00A0zobraz\00ED je jako hlavn\00ED z\00E1znam.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842316888398927)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017E\0148uje sta\017Een\00ED aktu\00E1ln\00ED sady v\00FDsledk\016F. Form\00E1ty ke sta\017Een\00ED '),
unistr('zahrnuj\00ED CSV, HTML, nebo e-mail.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853993533398936)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pokud si p\0159izp\016Fsob\00EDte sestavu datov\00E9 m\0159\00ED\017Eky, zobraz\00ED se jej\00ED nastaven\00ED'),
unistr('pod vyhled\00E1vac\00ED li\0161tou a\00A0nad sestavou. Tuto oblast lze sbalit a\00A0rozbalit pomoc\00ED ikony vlevo.'),
'<p>',
unistr('U ka\017Ed\00E9ho nastaven\00ED sestavy m\016F\017Eete:'),
'</p><ul>',
unistr('<li>Upravit nastaven\00ED kliknut\00EDm na n\00E1zev.</li>'),
unistr('<li>Zak\00E1zat nebo povolit nastaven\00ED za\0161krtnut\00EDm nebo od\0161krtnut\00EDm pol\00ED\010Dka Povolit/Zak\00E1zat. Pomoc\00ED tohoto ovl\00E1dac\00EDho prvku m\016F\017Eete nastaven\00ED do\010Dasn\011B zapnout nebo vypnout.</li>'),
unistr('<li>Odebrat nastaven\00ED kliknut\00EDm na ikonu Odebrat.</li>'),
'</ul>',
unistr('<p>Pokud jste vytvo\0159ili graf nebo seskupen\00ED, m\016F\017Eete p\0159ep\00EDnat mezi nimi'),
unistr('a\00A0z\00E1kladn\00ED sestavou pomoc\00ED odkaz\016F Zobrazen\00ED sestavy, Zobrazen\00ED grafu nebo Zobrazen\00ED seskupen\00ED'),
unistr('zobrazen\00FDch vpravo. Pokud si prohl\00ED\017E\00EDte graf nebo seskupen\00ED'),
unistr('m\016F\017Eete tak\00E9 upravit nastaven\00ED pomoc\00ED odkazu Upravit.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842251597398927)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ulo\017E\00ED p\0159izp\016Fsoben\00E9 rozlo\017Een\00ED sestavy datov\00E9 m\0159\00ED\017Eky pro budouc\00ED pou\017Eit\00ED. Vy si zvol\00EDte jm\00E9no a\00A0popis. M\016F\017Eete ulo\017Eit t\0159i typy rozvr\017Een\00ED sestavy datov\00E9 m\0159\00ED\017Eky:</p>'),
'<ul>',
unistr('<li><strong>Prim\00E1rn\00ED v\00FDchoz\00ED</strong> (Pouze pro spr\00E1vce). Prim\00E1rn\00ED v\00FDchoz\00ED je rozlo\017Een\00ED, kter\00E9 se zobraz\00ED na za\010D\00E1tku. Prim\00E1rn\00ED v\00FDchoz\00ED sestavy nelze p\0159ejmenovat ani odstranit.</li>'),
unistr('<li><strong>Alternativn\00ED sestava</strong> (Pouze pro spr\00E1vce). Umo\017E\0148uje spr\00E1vc\016Fm vytv\00E1\0159et v\00EDce rozvr\017Een\00ED sestavy. Alternativn\00ED sestavu mohou ulo\017Eit, p\0159ejmenovat nebo odstranit pouze spr\00E1vci.</li>'),
unistr('<li><strong>Soukrom\00E1 sestava</strong> (V\0161ichni u\017Eivatel\00E9). U\017Eivatel, kter\00FD vytvo\0159il rozlo\017Een\00ED sestavy, m\016F\017Ee sestavu zobrazit, ulo\017Eit, p\0159ejmenovat nebo odstranit.</li>'),
'</ul>',
unistr('<p>Pokud p\0159izp\016Fsoben\00E9 sestavy ulo\017E\00EDte, zobraz\00ED se na li\0161t\011B Vyhled\00E1v\00E1n\00ED selektor Sestav vlevo od Selektoru \0159\00E1dek (pokud je tato funkce povolena).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768358763398874)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Skr\00FDt sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758998425398867)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('Zv\00FDraznit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769804602398875)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Zv\00FDrazn\011Bn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774917991398879)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'cs'
,p_message_text=>unistr('Stav zv\00FDrazn\011Bn\00ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823949553398914)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Styl zv\00FDrazn\011Bn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733992395398849)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Typ zv\00FDrazn\011Bn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843473165398928)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Horizont\00E1ln\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873012164398950)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'cs'
,p_message_text=>unistr('1\00A0neaktivn\00ED nastaven\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873153132398950)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 neaktivn\00ED(ch) nastaven\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764962775398871)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda interaktivn\00ED sestavy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775918617398879)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769376938398874)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD v\00FDpo\010Detn\00ED v\00FDraz. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728763078398845)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Koncov\00E9 datum mus\00ED n\00E1sledovat po po\010D\00E1te\010Dn\00EDm datu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783633580398885)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD filtrovac\00ED v\00FDraz. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851498714398934)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD dotaz na filtr')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873226239398951)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'cs'
,p_message_text=>unistr('1 neplatn\00E9 nastaven\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873366062398951)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 neplatn\00E1/neplatn\00FDch nastaven\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824129726398914)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'cs'
,p_message_text=>unistr('(v minut\00E1ch)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841159878398926)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je v\00A0posledn\00ED %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841380836398926)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 je v\00A0n\00E1sleduj\00EDc\00ED %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841297235398926)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0posledn\00ED %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841455811398926)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nen\00ED v\00A0n\00E1sleduj\00EDc\00ED %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774088350398878)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'cs'
,p_message_text=>unistr('Kl\00E1vesnice')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740188086398853)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('\0160t\00EDtek %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767945008398873)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev osy pro \0161t\00EDtek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760499232398868)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00ED den')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760638802398868)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00ED hodina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760195146398867)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('Minul\00FD m\011Bs\00EDc')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760206710398868)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('Minul\00FD t\00FDden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760333069398868)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0dn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760520053398868)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0hodin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759965053398867)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('Posledn\00EDch %0\00A0let')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760014930398867)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Minul\00FD rok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740041762398853)
,p_name=>'APEXIR_LINE'
,p_message_language=>'cs'
,p_message_text=>unistr('\010C\00E1rov\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736855971398851)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'cs'
,p_message_text=>unistr('Spojnicov\00FD s plo\0161n\00FDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851352662398934)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'cs'
,p_message_text=>'Mapovat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768839307398874)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'cs'
,p_message_text=>unistr('Zd\00E1 se, \017Ee dotaz p\0159esahuje maxim\00E1ln\00ED povolen\00E9 zdroje. Upravte nastaven\00ED sestavy a\00A0opakujte pokus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751096548398861)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Maxim\00E1ln\00ED po\010Det \0159\00E1dk\016F pro tuto sestavu je %0\00A0\0159\00E1dk\016F. Pokud chcete sn\00ED\017Eit po\010Det z\00E1znam\016F v\00A0dotazu, pou\017Eijte filtr.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851954583398935)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'cs'
,p_message_text=>'Maximum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852163528398935)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Medi\00E1n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755005098398864)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('p\0159ed %0\00A0minutami')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852006980398935)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'cs'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851045512398934)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('M\011Bs\00EDc')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824554198398914)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'cs'
,p_message_text=>unistr('M\011Bs\00ED\010Dn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767129718398873)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767070124398873)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout v\0161e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878251141398954)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Mus\00ED b\00FDt zad\00E1no statick\00E9 ID oblasti, proto\017Ee str\00E1nka obsahuje v\00EDce interaktivn\00EDch sestav.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735531579398850)
,p_name=>'APEXIR_NAME'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762926499398870)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Nov\00E1 agregace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873975966398951)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Nov\00E1 kategorie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110763099090398870)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Nov\00FD v\00FDpo\010Det')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757800273398866)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760962877398868)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1sleduj\00EDc\00ED den')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760740161398868)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1sleduj\00EDc\00ED hodina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761238620398868)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00ED m\011Bs\00EDc')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761136672398868)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00ED t\00FDden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761009259398868)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0dn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110760867973398868)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0hodin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761498093398868)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00EDch %0\00A0let')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761315241398868)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00ED\0161t\00ED rok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735800595398850)
,p_name=>'APEXIR_NO'
,p_message_language=>'cs'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776162924398879)
,p_name=>'APEXIR_NONE'
,p_message_language=>'cs'
,p_message_text=>unistr('-\00A0\017D\00E1dn\00E9\00A0-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823766175398914)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 e-mailov\00E1 adresa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772639673398877)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnoty null v\017Edy jako prvn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772543256398877)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnoty null v\017Edy jako posledn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773083573398877)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158azen\00ED znak\016F null %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769428554398875)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'cs'
,p_message_text=>unistr('\010Cas flashbacku mus\00ED b\00FDt \010D\00EDseln\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769076316398874)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\0159ad\00ED mus\00ED b\00FDt \010D\00EDseln\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773553105398878)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Oper\00E1tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734474217398849)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'cs'
,p_message_text=>unistr('oran\017Eov\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843321916398928)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'cs'
,p_message_text=>'Orientace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736399725398850)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'cs'
,p_message_text=>unistr('Jin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719126786398838)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Orientace str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719846252398838)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Na \0161\00ED\0159ku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719905839398838)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Na v\00FD\0161ku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719022895398838)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'cs'
,p_message_text=>unistr('Velikost str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719646593398838)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'cs'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719585397398838)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'cs'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719772972398838)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'cs'
,p_message_text=>unistr('Vlastn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719327816398838)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Pr\00E1vn\00ED informace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719231453398838)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'cs'
,p_message_text=>'Dopis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110719423248398838)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'cs'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852474182398935)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Procento z\00A0celkov\00E9ho po\010Dtu %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851664247398934)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Procento z\00A0celkov\00E9ho sou\010Dtu %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850672023398934)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Procento z\00A0celkov\00E9ho po\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850576833398934)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'cs'
,p_message_text=>unistr('Procento z\00A0celkov\00E9ho sou\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739977799398853)
,p_name=>'APEXIR_PIE'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDse\010Dov\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799865336398896)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'cs'
,p_message_text=>'Operace pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801338164398898)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Je nutn\00E9 zadat agregaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801597658398898)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze agregovat na sloupci vybran\00E9m jako sloupec \0159\00E1dku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800725536398897)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>'Sloupce operace pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800590845398897)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'cs'
,p_message_text=>'Sloupec operace pivot %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801111952398897)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Je nutn\00E9 zadat sloupec operace pivot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701209193398825)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Maxim\00E1ln\00ED po\010Det \0159\00E1dk\016F pro dotaz operace pivot omezuje po\010Det \0159\00E1dk\016F v\00A0z\00E1kladn\00EDm dotazu, nikoli po\010Det zobrazen\00FDch \0159\00E1dk\016F. V\00E1\0161 z\00E1kladn\00ED dotaz p\0159ekra\010Duje maxim\00E1ln\00ED po\010Det \0159\00E1dk\016F\00A0%0. Pou\017Eijte filtr, abyste sn\00ED\017Eili po\010Det z\00E1znam\016F v\00A0z\00E1kladn\00EDm dotazu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801077553398897)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159azen\00ED operace pivot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770403698398875)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'cs'
,p_message_text=>unistr('Kontingen\010Dn\00ED sloupec obsahuje p\0159\00EDli\0161 mnoho odli\0161n\00FDch hodnot\00A0\2013 Nelze vygenerovat kontingen\010Dn\00ED SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823889511398914)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1hled')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757904578398866)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110849516494398932)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'cs'
,p_message_text=>unistr('Prim\00E1rn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824818781398914)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Prim\00E1rn\00ED sestava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718910132398838)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zahrnout tagy p\0159\00EDstupnosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705831198398828)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Odstranit form\00E1tovan\00FD text')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782603465398884)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Soukrom\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740567049398853)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'cs'
,p_message_text=>unistr('Ve\0159ejn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736101689398850)
,p_name=>'APEXIR_RED'
,p_message_language=>'cs'
,p_message_text=>unistr('\010Derven\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878199363398954)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Statick\00E9 ID oblasti %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767221711398873)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'cs'
,p_message_text=>'Odebrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767372782398873)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Odebrat v\0161e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873470929398951)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'cs'
,p_message_text=>'Odebrat graf'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766897860398872)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'cs'
,p_message_text=>unistr('Odebrat P\0159eru\0161en\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766595614398872)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'cs'
,p_message_text=>'Odebrat filtr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766603300398872)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'cs'
,p_message_text=>'Odebrat Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873567128398951)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'cs'
,p_message_text=>unistr('Odebrat seskupen\00ED podle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766916686398873)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('Odebrat zv\00FDrazn\011Bn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873643983398951)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'cs'
,p_message_text=>'Odebrat Operaci pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854654919398937)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'cs'
,p_message_text=>'Odebrat sestavu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835263946398922)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ejmenovat v\00FDchoz\00ED sestavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776424021398880)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('p\0159ejmenovat sestavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758211050398866)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'cs'
,p_message_text=>'Sestava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852567874398935)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'cs'
,p_message_text=>'Sestavy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732702422398848)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 interaktivn\00ED sestava s\00A0aliasem %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782938739398884)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>'Sestava neexistuje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732848472398848)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E9 ID interaktivn\00ED sestavy %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110774731012398878)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'cs'
,p_message_text=>unistr('Nastaven\00ED sestavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755506253398864)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED sestavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759453668398867)
,p_name=>'APEXIR_RESET'
,p_message_language=>'cs'
,p_message_text=>'Obnovit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740716721398854)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'cs'
,p_message_text=>unistr('Obnovte v\00FDchoz\00ED nastaven\00ED sestavy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735907578398850)
,p_name=>'APEXIR_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848608936398932)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'cs'
,p_message_text=>unistr('ROWID nelze pou\017E\00EDt jako sloupec prim\00E1rn\00EDho kl\00ED\010De pro datov\00FD zdroj REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765918837398872)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825542284398915)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dk\016F na str\00E1nku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800868889398897)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupce \0159\00E1dku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800686834398897)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec \0159\00E1dku %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801235152398897)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Je nutn\00E9 zadat sloupec \0159\00E1dku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801470762398898)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec \0159\00E1dk\016F se mus\00ED li\0161it od sloupce operace pivot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780051128398882)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Filtr \0159\00E1dk\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755609461398864)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dek %0 z %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759681280398867)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'cs'
,p_message_text=>unistr('Text \0159\00E1dky obsahuje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735235684398850)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770054462398875)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 sestava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769917848398875)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Een\00E1 sestava\00A0=\00A0\201E%0\201C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772135239398876)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED nastaven\00ED sestavy bude pou\017Eito jako v\00FDchoz\00ED pro v\0161echny u\017Eivatele.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110835197123398922)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit v\00FDchoz\00ED sestavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110759386019398867)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit sestavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873857365398951)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit sestavu *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826558884398916)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110764804543398871)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Panel hled\00E1n\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110873706659398951)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832060082398920)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'cs'
,p_message_text=>'Vyhledat sestavu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816036958398908)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybran\00E9 sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736903618398851)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('-\00A0Vybrat sloupec\00A0-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758675565398866)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>'Vybrat sloupce'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740495940398853)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('-\00A0Vybrat funkci\00A0-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765603531398872)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('-\00A0Vyberte volbu Seskupit podle sloupce\00A0-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800354534398897)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('\2013\00A0Vybrat sloupec operace pivot\00A0\2013')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851525645398934)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybrat \0159\00E1dek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800468607398897)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('\2013\00A0Vybrat sloupec \0159\00E1dku\00A0\2013')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709181559398830)
,p_name=>'APEXIR_SEND'
,p_message_language=>'cs'
,p_message_text=>'Odeslat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715426791398835)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'cs'
,p_message_text=>'Odeslat jako e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735667608398850)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'cs'
,p_message_text=>'Sekvence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758810537398867)
,p_name=>'APEXIR_SORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768112327398874)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit vzestupn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768259633398874)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Se\0159adit sestupn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854088047398936)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\0159ad\00ED \0159azen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762674377398869)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'cs'
,p_message_text=>'mezera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773762534398878)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'cs'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824264453398914)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'cs'
,p_message_text=>'Subskripce'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850958541398934)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'cs'
,p_message_text=>unistr('Ukon\010Den\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705334708398828)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esko\010Dit, pokud Nebyly nalezeny \017E\00E1dn\00E9 \00FAdaje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110850810585398934)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010D\00E1tek')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851741728398934)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'cs'
,p_message_text=>unistr('Sou\010Det %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841757137398927)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'cs'
,p_message_text=>unistr('Oblast\00A0=\00A0%0, Sestava\00A0=\00A0%1, Zobrazen\00ED\00A0=\00A0%2, Za\010D\00E1tek zobrazen\00FDch \0159\00E1dek\00A0=\00A0%3, Konec zobrazen\00FDch \0159\00E1dek\00A0=\00A0%4, Celkem \0159\00E1dek\00A0=\00A0%5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762309074398869)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Oblast\00A0=\00A0%0, Sestava\00A0=\00A0%1, Zobrazen\00ED\00A0=\00A0%2, Za\010D\00E1tek zobrazen\00FDch \0159\00E1dek\00A0=\00A0%3, Konec zobrazen\00FDch \0159\00E1dek\00A0=\00A0%4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734500619398849)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'cs'
,p_message_text=>'Barva textu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751631019398861)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'cs'
,p_message_text=>'dny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751585398398861)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'cs'
,p_message_text=>'hodiny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751415151398861)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'cs'
,p_message_text=>'minuty'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751853784398862)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('m\011Bs\00EDce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751765935398862)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('t\00FDdny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110751934508398862)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'cs'
,p_message_text=>'roky'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110854400770398936)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159epnout')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767449677398873)
,p_name=>'APEXIR_TOP'
,p_message_language=>'cs'
,p_message_text=>unistr('Na za\010D\00E1tek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847651607398931)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Neseskupen\00FD sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768918872398874)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev zv\00FDrazn\011Bn\00ED mus\00ED b\00FDt jedine\010Dn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739242139398853)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('nepodporovan\00FD typ dat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767588552398873)
,p_name=>'APEXIR_UP'
,p_message_language=>'cs'
,p_message_text=>'Nahoru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769116011398874)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'cs'
,p_message_text=>'Zadejte platnou barvu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769286657398874)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadejte platnou masku form\00E1tu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110736454059398851)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'cs'
,p_message_text=>'Hodnota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110768094208398873)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev osy pro hodnotu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775826208398879)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\017Eadovan\00E1 hodnota')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739836462398853)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Vertik\00E1ln\00ED sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110843597380398928)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Vertik\00E1ln\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775170927398879)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit graf'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830387822398918)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110875926530398953)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00A0sestav\011B nen\00ED definov\00E1no zobrazen\00ED %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830420426398918)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit Seskupeno podle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830290208398918)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit ikony'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800147781398897)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit operaci pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110775257778398879)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit sestavu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824467183398914)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'cs'
,p_message_text=>unistr('T\00FDdn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758198347398866)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDkaz pr\00E1ce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853169396398935)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 dny/dn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853085454398935)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'cs'
,p_message_text=>'%0 hodin(y)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110852903517398935)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'cs'
,p_message_text=>'%0 minut(y)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853323068398936)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 m\011Bs\00EDce/m\011Bs\00EDc\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853292072398936)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 t\00FDdny/t\00FDdn\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110853405003398936)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'cs'
,p_message_text=>'%0 roky/let'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110851123521398934)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'cs'
,p_message_text=>'Rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110734217144398849)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'cs'
,p_message_text=>unistr('\017Elut\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110735750920398850)
,p_name=>'APEXIR_YES'
,p_message_language=>'cs'
,p_message_text=>'Ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110767893826398873)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 obsahuje < or > co\017E jsou neplatn\00E9 znaky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110790683520398890)
,p_name=>'APEX_REGION'
,p_message_language=>'cs'
,p_message_text=>'Oblast'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110718800085398838)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'cs'
,p_message_text=>unistr('Podm\00EDnka API byla poru\0161ena')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738306795398852)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze z\00EDskat hodnotu pro nastaven\00ED aplikace %0, proto\017Ee mo\017Enost p\0159idru\017Een\00E9ho sestaven\00ED je zak\00E1z\00E1na.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738235563398852)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze nastavit hodnotu pro nastaven\00ED aplikace %0, proto\017Ee mo\017Enost p\0159idru\017Een\00E9ho sestaven\00ED je zak\00E1z\00E1na.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845954561398930)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnota nastaven\00ED aplikace %0 je neplatn\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110845875513398930)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'cs'
,p_message_text=>unistr('Nastaven\00ED po\017Eadovan\00E9 aplikac\00ED %0 nen\00ED definov\00E1no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846040421398930)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Nastaven\00ED aplikace %0 z\0159ejm\011B nen\00ED nastaveno na hodnotu null')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726923694398844)
,p_name=>'BACK'
,p_message_language=>'cs'
,p_message_text=>unistr('Zp\011Bt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713907455398834)
,p_name=>'BUILDER'
,p_message_language=>'cs'
,p_message_text=>'Tvorba'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778000950398881)
,p_name=>'BUTTON LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('Popisek tla\010D\00EDtka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713008162398833)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'cs'
,p_message_text=>unistr('T\0159\00EDdy CSS tla\010D\00EDtka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742249882398855)
,p_name=>'BUTTON_ID'
,p_message_language=>'cs'
,p_message_text=>unistr('Generovan\00E9 ID tla\010D\00EDtka bude statick\00E9, pokud je definov\00E1no. Pokud nen\00ED, bude intern\011B generovan\00E9 ID ve form\00E1tu ''B'' || [Intern\00ED ID tla\010D\00EDtka]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705701549398828)
,p_name=>'CANDLESTICK'
,p_message_language=>'cs'
,p_message_text=>unistr('Sv\00ED\010Dkov\00FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787270786398887)
,p_name=>'CENTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Na st\0159ed')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737230691398851)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\017Eadavek %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728618053398845)
,p_name=>'CHECK$'
,p_message_language=>'cs'
,p_message_text=>unistr('voli\010D \0159\00E1dek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110847722592398931)
,p_name=>'CHECKED'
,p_message_language=>'cs'
,p_message_text=>unistr('za\0161krtnuto')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823273296398913)
,p_name=>'COLUMN'
,p_message_language=>'cs'
,p_message_text=>'Sloupec'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783751528398885)
,p_name=>'COMMENTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Koment\00E1\0159e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765200501398871)
,p_name=>'CONTINUE'
,p_message_language=>'cs'
,p_message_text=>unistr('Pokra\010Dovat')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727230127398844)
,p_name=>'COPYRIGHT'
,p_message_language=>'cs'
,p_message_text=>unistr('Copyright &copy; %0, V\0161echna pr\00E1va vyhrazena.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770962994398876)
,p_name=>'COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('po\010Det')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777611944398881)
,p_name=>'CREATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159it')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829939260398918)
,p_name=>'CREATED'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830096628398918)
,p_name=>'CREATED_BY'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159il(a)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754833657398864)
,p_name=>'CREATED_ON'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159eno')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765417376398871)
,p_name=>'CUSTOM'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159izp\016Fsoben\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776601259398880)
,p_name=>'CUSTOMIZE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159izp\016Fsobit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778240311398881)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'cs'
,p_message_text=>unistr('Obnoven\00ED p\0159edvoleb str\00E1nky pro u\017Eivatele %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778380138398881)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edvolby zm\011Bn\011Bny pro u\017Eivatele %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778100664398881)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'cs'
,p_message_text=>unistr('Obnoven\00ED p\0159edvoleb str\00E1nky pro u\017Eivatele %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741952209398855)
,p_name=>'DAILY'
,p_message_language=>'cs'
,p_message_text=>unistr('Denn\011B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110713590710398834)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'cs'
,p_message_text=>unistr('Odeslan\00FD soubor je neplatn\00FD nebo m\00E1 nespr\00E1vnou p\0159\00EDponu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737452182398851)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Byl pou\017Eit neplatn\00FD selektor XML nebo JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706728001398829)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'cs'
,p_message_text=>unistr('Datov\00FD profil a\00A0nahran\00FD soubor neobsahuj\00ED \017E\00E1dn\00FD sloupec c\00EDlov\00E9 tabulky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792409811398891)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00A0nahran\00E9m souboru nebyla nalezena \017E\00E1dn\00E1 data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792538028398891)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'cs'
,p_message_text=>unistr('V listu \201E%0\201C nebyla nalezena \017E\00E1dn\00E1 data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110712370511398833)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00FD soubor nen\00ED ve form\00E1tu XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110702755866398826)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDt\00E1n\00ED dat dokon\010Deno: %0 \0159\00E1dek zpracov\00E1no.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703978163398827)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDt\00E1n\00ED dat dokon\010Deno: %0\00A0\0159\00E1dek zpracov\00E1no s\00A01\00A0chybou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704258461398827)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDt\00E1n\00ED dat dokon\010Deno: %0\00A0\0159\00E1dek zpracov\00E1no s\00A0%1\00A0chybami.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704008039398827)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDt\00E1n\00ED dat dokon\010Deno: zpracov\00E1na 1\00A0\0159\00E1dka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707028427398829)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDt\00E1n\00ED dat dokon\010Deno: 1\00A0\0159\00E1dek zpracov\00E1n s\00A0chybou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704160157398827)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010D\00EDt\00E1n\00ED dat dokon\010Deno: 1\00A0\0159\00E1dka zpracov\00E1na bez chyby.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797790193398895)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'cs'
,p_message_text=>unistr('C\00EDlov\00FD sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797826822398895)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'cs'
,p_message_text=>unistr('Zdrojov\00FD sloupec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798676262398896)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Form\00E1t data/\010D\00EDsla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862060733398942)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010Dten\00ED vyhled\00E1vac\00ED hodnoty selhalo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110830559588398918)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'cs'
,p_message_text=>unistr('Mapov\00E1n\00ED dat/tabulek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798716696398896)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794271569398892)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'cs'
,p_message_text=>'Pravidlo transformace selhalo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770557632398875)
,p_name=>'DATE'
,p_message_language=>'cs'
,p_message_text=>'Datum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744622141398856)
,p_name=>'DAY'
,p_message_language=>'cs'
,p_message_text=>'den'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744761437398857)
,p_name=>'DAYS'
,p_message_language=>'cs'
,p_message_text=>'dny'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783450797398885)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'cs'
,p_message_text=>unistr('Lad\011Bn\00ED nen\00ED pro tuto aplikaci povoleno.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110832296617398920)
,p_name=>'DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745483509398857)
,p_name=>'DELETE'
,p_message_language=>'cs'
,p_message_text=>'odstranit'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110705609217398828)
,p_name=>'DIAL_PCT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyt\00E1\010Den\00ED (v\00A0procentech)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720141862398839)
,p_name=>'DOWNLOAD'
,p_message_language=>'cs'
,p_message_text=>unistr('St\00E1hnout')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831366768398919)
,p_name=>'DUP_USER'
,p_message_language=>'cs'
,p_message_text=>unistr('Seznam obsahuje duplicitn\00ED u\017Eivatelsk\00E9 jm\00E9no.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727786978398844)
,p_name=>'EDIT'
,p_message_language=>'cs'
,p_message_text=>'Upravit'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737174237398851)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('E-mailov\00E1 adresa \201E%0\201C nebyla nalezena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722203015398840)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'cs'
,p_message_text=>'Tento e-mail odeslal(a) %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831533055398919)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'cs'
,p_message_text=>unistr('E-mailov\00E1 adresa je p\0159\00EDli\0161 dlouh\00E1. Limit je 240\00A0znak\016F.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765116571398871)
,p_name=>'ERROR'
,p_message_language=>'cs'
,p_message_text=>'Chyba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794391967398892)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze nastavit zdrojovou hodnotu polo\017Eky str\00E1nky pro oblast \010D\00E1ste\010Dn\00E9ho obnoven\00ED str\00E1nky')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756681636398865)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159il(a)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722523125398840)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Platnost hesla vypr\0161ela')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110716664203398836)
,p_name=>'FILE_EMPTY'
,p_message_language=>'cs'
,p_message_text=>unistr('Soubor je pr\00E1zdn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796894277398894)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Velikost nahran\00E9ho souboru je v\011Bt\0161\00ED ne\017E %0\00A0MB. Nahrajte men\0161\00ED soubor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724610141398842)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Ov\011B\0159en\00ED u\017Eivatele selhalo a nebyl nahr\00E1n jeden nebo v\00EDce soubor\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724781336398842)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Tato instance neumo\017E\0148uje u\017Eivatel\016Fm bez opr\00E1vn\011Bn\00ED nahr\00E1vat soubory.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777754985398881)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Do\0161lo k\00A01\00A0chyb\011B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776916718398880)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Do\0161lo k\00A0%0\00A0chyb\00E1m')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727174971398844)
,p_name=>'FORM_OF'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 z\00A0%1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761815651398869)
,p_name=>'GO'
,p_message_language=>'cs'
,p_message_text=>'Spustit'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861603443398942)
,p_name=>'HELP'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1pov\011Bda')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714006802398834)
,p_name=>'HOME'
,p_message_language=>'cs'
,p_message_text=>unistr('Dom\016F')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744489069398856)
,p_name=>'HOUR'
,p_message_language=>'cs'
,p_message_text=>'hodina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744585567398856)
,p_name=>'HOURS'
,p_message_language=>'cs'
,p_message_text=>'hodiny'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728540744398845)
,p_name=>'ICON'
,p_message_language=>'cs'
,p_message_text=>'Ikona %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778538232398881)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E9 ov\011B\0159ovac\00ED \00FAdaje pro p\0159ihl\00E1\0161en\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110878086979398954)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 hodnota parametru: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773208256398877)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'cs'
,p_message_text=>unistr('Jako v\00FDchoz\00ED nastaven\00ED sestavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773361859398877)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'cs'
,p_message_text=>unistr('Jako uveden\00E1 sestava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755797384398864)
,p_name=>'IR_ERROR'
,p_message_language=>'cs'
,p_message_text=>'Chyba %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755420169398864)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze propo\010D\00EDtat navigaci ve formul\00E1\0159i. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733025923398848)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Interaktivn\00ED sestava nebyla nalezena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732425377398848)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Interaktivn\00ED oblast sestavy neexistuje v\00A0aplikaci %0, na str\00E1nce\00A0%1 a\00A0v oblasti %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110773116326398877)
,p_name=>'IR_STAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazeno pouze pro v\00FDvoj\00E1\0159e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761503102398868)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Dotaz na sestavu pot\0159ebuje jedine\010Dn\00FD kl\00ED\010D k\00A0identifikaci ka\017Ed\00E9 \0159\00E1dky. Zadan\00FD kl\00ED\010D nelze pro tento dotaz pou\017E\00EDt. Definujte jedine\010Dn\00FD kl\00ED\010Dov\00FD sloupec. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761671105398869)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'cs'
,p_message_text=>unistr('Dotaz na sestavu pot\0159ebuje jedine\010Dn\00FD kl\00ED\010D k\00A0identifikaci ka\017Ed\00E9 \0159\00E1dky. Zadan\00FD kl\00ED\010D nelze pro tento dotaz pou\017E\00EDt. Upravte atributy sestavy a\00A0definujte jedine\010Dn\00FD kl\00ED\010Dov\00FD sloupec %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798979853398896)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'cs'
,p_message_text=>'Vybrat soubor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798870218398896)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159et\00E1hn\011Bte soubor sem nebo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727492332398844)
,p_name=>'ITEMS'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756810617398865)
,p_name=>'ITEM_VALUE'
,p_message_language=>'cs'
,p_message_text=>unistr('Hodnota polo\017Eky')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771270781398876)
,p_name=>'LABEL'
,p_message_language=>'cs'
,p_message_text=>unistr('\0160t\00EDtek')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783399623398885)
,p_name=>'LANGUAGE'
,p_message_language=>'cs'
,p_message_text=>'Jazyk'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745161891398857)
,p_name=>'LAST'
,p_message_language=>'cs'
,p_message_text=>unistr('minul\00FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724553998398842)
,p_name=>'LENGTH'
,p_message_language=>'cs'
,p_message_text=>unistr('D\00E9lka')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777842184398881)
,p_name=>'LOGIN'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ihl\00E1\0161en\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816447704398908)
,p_name=>'MANAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Prov\00E1d\011Bt spr\00E1vu')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881008592398956)
,p_name=>'MAXIMIZE'
,p_message_language=>'cs'
,p_message_text=>'Maximalizovat'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744247907398856)
,p_name=>'MINUTE'
,p_message_language=>'cs'
,p_message_text=>'minuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744307605398856)
,p_name=>'MINUTES'
,p_message_language=>'cs'
,p_message_text=>'minuty'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831741700398919)
,p_name=>'MISSING_AT'
,p_message_language=>'cs'
,p_message_text=>unistr('V e-mailov\00E9 adrese chyb\00ED znak \201E@\201C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831947673398919)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'cs'
,p_message_text=>unistr('Upozorn\011Bn\00ED: Pro Dialogovou str\00E1nku %0 v\00A0aplikaci %1 nebyla definov\00E1na \017E\00E1dn\00E1 \0161ablona Dialogov\00E9 str\00E1nky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831697345398919)
,p_name=>'MISSING_DOT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00A0dom\00E9n\011B e-mailov\00E9 adresy chyb\00ED znak \201E.\201C.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780805414398883)
,p_name=>'MODULE'
,p_message_language=>'cs'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737988910398852)
,p_name=>'MONTH'
,p_message_language=>'cs'
,p_message_text=>unistr('M\011Bs\00EDc')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741737285398854)
,p_name=>'MONTHLY'
,p_message_language=>'cs'
,p_message_text=>unistr('M\011Bs\00ED\010Dn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738055173398852)
,p_name=>'MONTHS'
,p_message_language=>'cs'
,p_message_text=>unistr('m\011Bs\00EDce')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770806081398876)
,p_name=>'MOVE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838304112398924)
,p_name=>'MOVE_FROM'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout z')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838489364398924)
,p_name=>'MOVE_TO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159esunout do')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110758079086398866)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba operace odstran\011Bn\00ED v\00EDce \0159\00E1dek: \0159\00E1dka\00A0=\00A0%0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757088454398865)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'cs'
,p_message_text=>unistr('Nesm\00ED to b\00FDt ve\0159ejn\00FD u\017Eivatel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714232497398834)
,p_name=>'NAME'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771009885398876)
,p_name=>'NEW'
,p_message_language=>'cs'
,p_message_text=>unistr('Vytvo\0159it')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737710195398851)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'cs'
,p_message_text=>unistr('M\016F\017Eete se p\0159ihl\00E1sit do %0 tak, \017Ee p\0159ejdete na:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737810679398852)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Nov\00E1 upozorn\011Bn\00ED \00FA\010Dtu: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861803801398942)
,p_name=>'NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780702357398883)
,p_name=>'NO'
,p_message_language=>'cs'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110876035573398953)
,p_name=>'NOBODY'
,p_message_language=>'cs'
,p_message_text=>'nikdo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745587762398857)
,p_name=>'NOT'
,p_message_language=>'cs'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786332762398887)
,p_name=>'NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('nen\00ED null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757188532398865)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'cs'
,p_message_text=>unistr('Nen\00ED %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776788319398880)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('nenalezena \017E\00E1dn\00E1 data')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785839826398886)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Nebyla nalezena \017E\00E1dn\00E1 aktualizovateln\00E1 sestava. V\00EDce\0159\00E1dkov\00E9 operace aktualizace a\00A0odstra\0148ovan\00ED lze prov\00E1d\011Bt pouze na tabulkov\00FDch formul\00E1\0159\00EDch typu \201EAktualizovateln\00E1 sestava\201C.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786756728398887)
,p_name=>'OK'
,p_message_language=>'cs'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782405362398884)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'cs'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110879899394398956)
,p_name=>'ORA_06550'
,p_message_language=>'cs'
,p_message_text=>unistr('ORA-06550: \0159\00E1dka %0, sloupec %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829329860398918)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'cs'
,p_message_text=>unistr('Pou\017E\00EDv\00E1te zastaral\00FD webov\00FD prohl\00ED\017Ee\010D. Seznam podporovan\00FDch prohl\00ED\017Ee\010D\016F najdete v\00A0instala\010Dn\00ED p\0159\00EDru\010Dce Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730782837398846)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 sada po\017Eadovan\00FDch \0159\00E1dek, zdrojov\00E1 data sestavy byla upravena.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750822490398861)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Je t\0159eba zadat platn\00E9 \010D\00EDslo str\00E1nky (P/N), nap\0159\00EDklad P/N\00A0=\00A01234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754408108398863)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Dal\0161\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754510832398863)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1sleduj\00EDc\00ED sada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754697258398864)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110754791989398864)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED sada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861716254398942)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybrat str\00E1nkov\00E1n\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792383314398891)
,p_name=>'PASSWORD'
,p_message_language=>'cs'
,p_message_text=>'Heslo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737017026398851)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'cs'
,p_message_text=>unistr('Va\0161e heslo pro %0 bylo zm\011Bn\011Bno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726834735398844)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo neodpov\00EDd\00E1 pravidl\016Fm pro slo\017Eitost hesla t\00E9to webov\00E9 aplikace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725932671398843)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Nov\00E9 heslo se mus\00ED od star\00E9ho hesla li\0161it alespo\0148 %0 znaky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726555972398843)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo nesm\00ED obsahovat u\017Eivatelsk\00E9 jm\00E9no.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726752236398843)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo obsahuje zak\00E1zan\00E9 jednoduch\00E9 slovo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726669160398843)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo nesm\00ED obsahovat n\00E1zev pracovn\00EDho prostoru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725850075398843)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo mus\00ED obsahovat alespo\0148 %0 znak\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726004370398843)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo mus\00ED obsahovat alespo\0148 jedno p\00EDsmeno (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726423871398843)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo mus\00ED obsahovat alespo\0148 jedno mal\00E9 p\00EDsmeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726170405398843)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo mus\00ED obsahovat alespo\0148 jedeno \010D\00EDslo (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726279666398843)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo mus\00ED obsahovat alespo\0148 jeden interpunk\010Dn\00ED znak (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110726397307398843)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo mus\00ED obsahovat alespo\0148 jedno velk\00E9 p\00EDsmeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737567188398851)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Upozorn\011Bn\00ED na obnoven\00ED hesla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724844817398842)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Heslo nem\016F\017Ee b\00FDt pou\017Eito, proto\017Ee ji\017E bylo pou\017Eito b\011Bhem posledn\00EDch %0 dn\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805186176398900)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110805273073398900)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782209706398884)
,p_name=>'PERCENT'
,p_message_language=>'cs'
,p_message_text=>'Procenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752513986398862)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Obra\0165te se na spr\00E1vce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110861934224398942)
,p_name=>'PREVIOUS'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159edchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797348024398895)
,p_name=>'PRINT'
,p_message_language=>'cs'
,p_message_text=>'Tisk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781064960398883)
,p_name=>'PRIVILEGES'
,p_message_language=>'cs'
,p_message_text=>unistr('Opr\00E1vn\011Bn\00ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750977418398861)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'cs'
,p_message_text=>'Odkazy na oblasti'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771132489398876)
,p_name=>'REPORT'
,p_message_language=>'cs'
,p_message_text=>'Sestava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780968165398883)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'cs'
,p_message_text=>unistr('Vykazovan\00E9 obdob\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862169350398942)
,p_name=>'REPORT_LABEL'
,p_message_language=>'cs'
,p_message_text=>'Sestava: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781657476398883)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'cs'
,p_message_text=>'Sestava celkem'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730821853398846)
,p_name=>'RESET'
,p_message_language=>'cs'
,p_message_text=>unistr('Obnovit str\00E1nkov\00E1n\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756770949398865)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Obnovit str\00E1nkov\00E1n\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785705024398886)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'cs'
,p_message_text=>'Obnovit heslo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762574293398869)
,p_name=>'RESTORE'
,p_message_language=>'cs'
,p_message_text=>'Obnovit'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110794449730398892)
,p_name=>'RESULTS'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDsledky')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786806180398887)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1vrat do aplikace.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110787194674398887)
,p_name=>'RIGHT'
,p_message_language=>'cs'
,p_message_text=>'Vpravo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816709595398909)
,p_name=>'ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158\00E1dka %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770794487398876)
,p_name=>'ROW_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\010Det \0159\00E1dek')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110786275484398887)
,p_name=>'SAVE'
,p_message_language=>'cs'
,p_message_text=>unistr('Ulo\017Eit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782847223398884)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('Alternativn\00ED v\00FDchoz\00ED nastaven\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783234190398885)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'cs'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782753502398884)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('Prim\00E1rn\00ED v\00FDchoz\00ED nastaven\00ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783530692398885)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'cs'
,p_message_text=>unistr('K\00A0dispozici je v\00EDce ne\017E %0\00A0\0159\00E1dek. Nav\00FD\0161en\00EDm selektoru \0159\00E1dek zobraz\00EDte v\00EDce \0159\00E1dek.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848914452398932)
,p_name=>'SEARCH'
,p_message_language=>'cs'
,p_message_text=>unistr('Vyhled\00E1v\00E1n\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744124270398856)
,p_name=>'SECONDS'
,p_message_language=>'cs'
,p_message_text=>'sekundy'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782394517398884)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'cs'
,p_message_text=>unistr('Viz p\0159\00EDloha')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840051507398925)
,p_name=>'SELECT_ROW'
,p_message_language=>'cs'
,p_message_text=>unistr('Vybrat \0159\00E1dek')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782036637398884)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'cs'
,p_message_text=>unistr('Vypn\011Bte re\017Eim \010Dte\010Dky obrazovky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782186953398884)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'cs'
,p_message_text=>unistr('Zapn\011Bte re\017Eim \010Dte\010Dky obrazovky')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778435399398881)
,p_name=>'SHOW'
,p_message_language=>'cs'
,p_message_text=>'Zobrazit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841842035398927)
,p_name=>'SHOW_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazit v\0161e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110867951605398947)
,p_name=>'SIGN_IN'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ihl\00E1sit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110817514131398909)
,p_name=>'SIGN_OUT'
,p_message_language=>'cs'
,p_message_text=>unistr('Odhl\00E1sit se')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771708163398876)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed %0\00A0dny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778943617398882)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Od t\00E9to chv\00EDle za %0\00A0dn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771614411398876)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed %0\00A0hodinami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778879880398881)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Od t\00E9to chv\00EDle za %0\00A0hodin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771515816398876)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('p\0159ed %0\00A0minutami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778712365398881)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Od t\00E9to chv\00EDle za %0\00A0minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771925290398876)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed %0\00A0m\011Bs\00EDci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779114002398882)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Od t\00E9to chv\00EDle za %0\00A0m\011Bs\00EDc\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779355362398882)
,p_name=>'SINCE_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Nyn\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771494269398876)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('p\0159ed %0\00A0sekundami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110778638548398881)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Od t\00E9to chv\00EDle za %0\00A0sekund')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110771830662398876)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed %0\00A0t\00FDdny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779052130398882)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Od t\00E9to chv\00EDle za %0\00A0t\00FDdn\016F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110772027721398876)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ed %0\00A0lety')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779275919398882)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Od t\00E9to chv\00EDle za %0\00A0let')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765579885398872)
,p_name=>'STANDARD'
,p_message_language=>'cs'
,p_message_text=>unistr('Standardn\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781949291398884)
,p_name=>'START_DATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Datum zah\00E1jen\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722489348398840)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'cs'
,p_message_text=>unistr('Tento e-mail jste obdr\017Eeli ze subskripce Interaktivn\00ED sestavy vytvo\0159en\00E9 u\017Eivatelem %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877187132398954)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'cs'
,p_message_text=>'Subskripce'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825238981398915)
,p_name=>'TAB'
,p_message_language=>'cs'
,p_message_text=>'Karta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744082811398856)
,p_name=>'TITLE'
,p_message_language=>'cs'
,p_message_text=>'Nadpis'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727004335398844)
,p_name=>'TODAY'
,p_message_language=>'cs'
,p_message_text=>'Dnes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781533164398883)
,p_name=>'TOTAL'
,p_message_language=>'cs'
,p_message_text=>'Celkem'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728032225398844)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'cs'
,p_message_text=>unistr('Lze vybrat maxim\00E1ln\011B %0\00A0sloupc\016F.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706577253398829)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Sbalit v\0161e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706800751398829)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Sbalit v\0161e n\00ED\017Ee')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706494066398829)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozbalit v\0161e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706685307398829)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Rozbalit v\0161e n\00ED\017Ee')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706965265398829)
,p_name=>'TREE.REPARENT'
,p_message_language=>'cs'
,p_message_text=>unistr('Nad\0159adit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799172266398896)
,p_name=>'TREES'
,p_message_language=>'cs'
,p_message_text=>unistr('Stromov\00E1 struktura')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110842688206398927)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Povinn\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110766289200398872)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'cs'
,p_message_text=>unistr('Neopr\00E1vn\011Bn\00FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110813072099398906)
,p_name=>'UNAVAILABLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Nen\00ED k\00A0dispozici')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779790357398882)
,p_name=>'UNKNOWN'
,p_message_language=>'cs'
,p_message_text=>unistr('Nezn\00E1m\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723373881398841)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Do\0161lo k\00A0nerozpoznan\00E9 chyb\011B ov\011B\0159ov\00E1n\00ED.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725332138398842)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'cs'
,p_message_text=>unistr('Pokud si ji\017E nep\0159ejete dost\00E1vat e-maily, m\016F\017Eete kliknut\00EDm na <a href="%0">zru\0161it subskripci</a> upravit svou subskripci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110722336441398840)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Pokud si ji\017E nep\0159ejete dost\00E1vat e-maily, m\016F\017Eete prov\00E9st spr\00E1vu sv\00E9 subskripce v n\00E1sleduj\00EDc\00EDm odkazu:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110757280385398865)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Nepodporovan\00FD typ dat')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745345788398857)
,p_name=>'UPDATE'
,p_message_language=>'cs'
,p_message_text=>'aktualizace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743945137398856)
,p_name=>'UPDATED'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktualizov\00E1no')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750657047398861)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'cs'
,p_message_text=>unistr('Po\017Eadovan\00E1 adresa URL byla zak\00E1z\00E1na. Kontaktujte sv\00E9ho spr\00E1vce.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110770637329398875)
,p_name=>'USER'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110792205307398891)
,p_name=>'USERNAME'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatelsk\00E9 jm\00E9no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831807691398919)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatelsk\00E9 jm\00E9no je p\0159\00EDli\0161 dlouh\00E9. Limit je %0\00A0znak\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777450264398880)
,p_name=>'USERS'
,p_message_language=>'cs'
,p_message_text=>unistr('u\017Eivatel\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110831461177398919)
,p_name=>'USER_EXISTS'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatelsk\00E9 jm\00E9no ji\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110846104178398930)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Profilov\00FD obr\00E1zek u\017Eivatele %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733753063398849)
,p_name=>'VALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Platn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727312803398844)
,p_name=>'VALIDATIONS'
,p_message_language=>'cs'
,p_message_text=>unistr('Ov\011B\0159en\00ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783019136398884)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'cs'
,p_message_text=>unistr('Mus\00ED b\00FDt zad\00E1na hodnota')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826411937398916)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro %0 mus\00ED b\00FDt zad\00E1na hodnota')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752979038398862)
,p_name=>'VERTICAL'
,p_message_language=>'cs'
,p_message_text=>unistr('vertik\00E1ln\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745214717398857)
,p_name=>'VIEW'
,p_message_language=>'cs'
,p_message_text=>unistr('zobrazen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777599384398881)
,p_name=>'VIEWS'
,p_message_language=>'cs'
,p_message_text=>unistr('zobrazen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783862317398885)
,p_name=>'VIEW_ALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazit v\0161e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110765008635398871)
,p_name=>'WARNING'
,p_message_language=>'cs'
,p_message_text=>unistr('Upozorn\011Bn\00ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744853765398857)
,p_name=>'WEEK'
,p_message_language=>'cs'
,p_message_text=>unistr('t\00FDden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741838918398854)
,p_name=>'WEEKLY'
,p_message_language=>'cs'
,p_message_text=>unistr('T\00FDdn\011B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110744923708398857)
,p_name=>'WEEKS'
,p_message_language=>'cs'
,p_message_text=>unistr('t\00FDdny')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110783115831398885)
,p_name=>'WELCOME_USER'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00EDtejte: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781305644398883)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'cs'
,p_message_text=>unistr('Nalezen\00E1 neplatn\00E1 hodnota, ov\011B\0159te zadan\00E1 data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781476152398883)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Nalezen\00E1 neplatn\00E1 hodnota, ov\011B\0159te zadan\00E1 data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724445933398842)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'cs'
,p_message_text=>unistr('Nalezeno neplatn\00E9 datum, ov\011B\0159te form\00E1t data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110781215309398883)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'cs'
,p_message_text=>unistr('Nalezena neplatn\00E1 hodnota \010D\00EDsla, ov\011B\0159te form\00E1t \010D\00EDsla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733328778398848)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'cs'
,p_message_text=>unistr('Nalezeno neplatn\00E9 \010Dasov\00E9 raz\00EDtko. Ov\011B\0159te form\00E1t \010Dasov\00E9ho raz\00EDtka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110755886559398864)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('\201E%0\201C nelze v\00E1zat. Pro v\00EDcebajtov\00E9 polo\017Eky pou\017Eijte dvojit\00E9 uvozovky nebo ov\011B\0159te, \017Ee d\00E9lka polo\017Eky nen\00ED v\00EDce ne\017E 30\00A0bajt\016F. Pro odkaz na polo\017Eky del\0161\00ED ne\017E 30\00A0bajt\016F pou\017Eijte syntaxi v().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746369461398858)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDstup byl odep\0159en kontrolou zabezpe\010Den\00ED %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748890809398859)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Aplikace nen\00ED dostupn\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747213387398858)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'cs'
,p_message_text=>'CHYBA-1014 Aplikace nebyla nalezena.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747329316398858)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('aplikace\00A0=\00A0%0 pracovn\00ED prostor\00A0=\00A0%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747742475398859)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDstup k\00A0t\00E9to aplikaci je omezen. Opakujte pokus pozd\011Bji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747644037398859)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDstup k\00A0t\00E9to aplikaci je vyhrazen pouze pro v\00FDvoj\00E1\0159e aplikac\00ED. Opakujte pokus pozd\011Bji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746848742398858)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-7744 Nelze zpracovat v\011Btev na funkci vracej\00EDc\00ED adresu URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746772391398858)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-7744 Nelze zpracovat v\011Btev na funkci vracej\00EDc\00ED str\00E1nku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747027479398858)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-1430 Vol\00E1n\00ED zobrazen\00ED z\00A0procesu str\00E1nky nen\00ED podporov\00E1no: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748134516398859)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-1018 Chyba p\0159i maz\00E1n\00ED pam\011Bti krok\016F pam\011Bti cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746514351398858)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-1005 Nezn\00E1m\00FD typ v\00FDpo\010Dtu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747418567398858)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-1201 ID relace nen\00ED nastaveno na p\0159izp\016Fsoben\00E9 ov\011B\0159ov\00E1n\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747535517398859)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('strana\00A0=\00A0%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110747135310398858)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-7620 Nelze ur\010Dit pracovn\00ED prostor pro aplikaci (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729572245398846)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'cs'
,p_message_text=>'Upravit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746209948398858)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-1802 Nelze naj\00EDt ID polo\017Eky \201E%0\201C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745906059398857)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-1002 v\00A0aplikaci \201E%1\201C nelze naj\00EDt ID polo\017Eky \201E%0\201C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746074773398857)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'cs'
,p_message_text=>unistr('Neo\010Dek\00E1van\00E1 chyba. Na \00FArovni aplikace nebo str\00E1nky nelze naj\00EDt n\00E1zev polo\017Eky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746439065398858)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Ji\017E jste na prvn\00ED str\00E1nce dat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110761919447398869)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'cs'
,p_message_text=>unistr('ID polo\017Eky (%0) nen\00ED polo\017Eka definovan\00E1 na aktu\00E1ln\00ED str\00E1nce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724070479398841)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eka nemus\00ED b\00FDt nastavena p\0159ed\00E1n\00EDm argument\016F aplikaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724313934398842)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'cs'
,p_message_text=>unistr('(Nebyl poskytnut \017E\00E1dn\00FD kontroln\00ED sou\010Det)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723806934398841)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eka m\016F\017Ee b\00FDt nastavena, pokud je doprov\00E1zena kontroln\00EDm sou\010Dtem \201Ez\00E1lo\017Eky na \00FArovni u\017Eivatele\201C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723758728398841)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eka m\016F\017Ee b\00FDt nastavena, pokud je doprov\00E1zena kontroln\00EDm sou\010Dtem \201Ez\00E1lo\017Eky na \00FArovni aplikace\201C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723971401398841)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eku lze nastavit, pokud je doprov\00E1zena kontroln\00EDm sou\010Dtem \201Erelace\201C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723652328398841)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eka nem\00E1 \017E\00E1dnou ochranu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748298505398859)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'cs'
,p_message_text=>unistr('\017D\00E1dn\00E1 n\00E1pov\011Bda str\00E1nky nen\00ED k\00A0dispozici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110737325722398851)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'cs'
,p_message_text=>unistr('Pracovn\00ED prostor %0 nem\00E1 \017E\00E1dn\00E1 opr\00E1vn\011Bn\00ED k\00A0anal\00FDze jako sch\00E9ma %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746667983398858)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-1010 Byl p\0159ekro\010Den limit rekurze zpracov\00E1n\00ED v\011Btve na str\00E1nku. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724241439398842)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'cs'
,p_message_text=>unistr('Tuto str\00E1nku nelze vyvolat pomoc\00ED adresy URL nebo pomoc\00ED p\0159\00EDkazu GET nebo POST pro proceduru zobrazen\00ED. Str\00E1nka mus\00ED b\00FDt vol\00E1na pomoc\00ED typu v\011Btve "V\011Btev na str\00E1nku".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110800917489398897)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i pokusu o\00A0ulo\017Een\00ED ne\010D\00EDseln\00E9 hodnoty v\00A0polo\017Ece %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739071228398852)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Sch\00E9ma anal\00FDzy aplikace \201E%0\201C v\00A0datab\00E1zi neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110739190868398853)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'cs'
,p_message_text=>unistr('\00DA\010Dty na VNIT\0158N\00CDM pracovn\00EDm prostoru lze pou\017E\00EDt pouze pro p\0159\00EDstup do &PRODUCT_NAME. <a href="%0"> Slu\017Eby spr\00E1vy </a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745881990398857)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA\20111029 Nelze ulo\017Eit informace o\00A0relaci. Relace\00A0=\00A0%0 polo\017Eka\00A0=\00A0%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748962117398859)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze zastavit trasov\00E1n\00ED: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110746142396398858)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Neo\010Dek\00E1van\00E1 chyba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756140287398865)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba v\00A0update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749021877398860)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('K\00A0zobrazen\00ED n\00E1pov\011Bdy je t\0159eba uv\00E9st aplikaci a\00A0str\00E1nku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110769506294398875)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>'Automatizace nenalezena.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750119518398860)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'cs'
,p_message_text=>unistr('Vymaz\00E1no %0\00A0relac\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709441236398831)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'cs'
,p_message_text=>unistr('K\00F3d %0 nelze spustit! Nen\00ED podporov\00E1n datab\00E1z\00ED nebo nen\00ED povolen parametrem instance MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110709236895398831)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00EDcejazy\010Dn\00FD modul nen\00ED v\00A0t\00E9to verzi datab\00E1ze k\00A0dispozici!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730009168398846)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Pole kolekce aplikac\00ED nesm\00ED m\00EDt hodnotu null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729858659398846)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00E9 \010D\00EDslo atributu prvku %0 je neplatn\00E9. \010C\00EDslo atributu mus\00ED b\00FDt mezi 1 a\00A0%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730393126398846)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Kolekce aplikac\00ED existuje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730150732398846)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev kolekce nesm\00ED m\00EDt hodnotu null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730228467398846)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'cs'
,p_message_text=>unistr('N\00E1zev kolekce nesm\00ED b\00FDt del\0161\00ED ne\017E 255\00A0znak\016F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729628346398846)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Kolekce aplikac\00ED %0 neexistuje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730422759398846)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'cs'
,p_message_text=>unistr('Kurzor je\0161t\011B nen\00ED otev\0159en\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729783094398846)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sekvence prvk\016F %0 v\00A0kolekci aplikac\00ED %1 neexistuje'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110729956328398846)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Sekvence prvk\016F %0 v\00A0kolekci aplikac\00ED \201E%1\201C neexistuje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801799080398898)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Kryptografick\00E1 funkce \201E%0\201C nen\00ED v\00A0tomto syst\00E9mu podporov\00E1na.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855218926398937)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDstupnost testov\00E1na')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749648962398860)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'cs'
,p_message_text=>unistr('Zav\0159\00EDt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749759549398860)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'cs'
,p_message_text=>unistr('Volby p\0159izp\016Fsoben\00ED str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749887100398860)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00FDchoz\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749968766398860)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'cs'
,p_message_text=>'Zobrazeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750092593398860)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'cs'
,p_message_text=>'Skryto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749427458398860)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'cs'
,p_message_text=>unistr('Zkontrolujte oblasti, kter\00E9 chcete na t\00E9to str\00E1nce zahrnout. Za\0161krtnut\00E9 oblasti se nemus\00ED zobrazit, pokud nejste ve spr\00E1vn\00E9m kontextu aplikace nebo nem\00E1te spr\00E1vn\00E1 opr\00E1vn\011Bn\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749560173398860)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'cs'
,p_message_text=>unistr('Tuto str\00E1nku nelze p\0159izp\016Fsobit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855530084398937)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'cs'
,p_message_text=>unistr('Vzhled t\00E9to aplikace si m\016F\017Eete p\0159izp\016Fsobit zm\011Bnou stylu motivu. Vyberte styl motivu ze seznamu n\00ED\017Ee a\00A0klikn\011Bte na Pou\017E\00EDt zm\011Bny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110856346479398938)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'cs'
,p_message_text=>unistr('Zobrazen\00ED oblasti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855487090398937)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'cs'
,p_message_text=>unistr('Pou\017E\00EDt v\00FDchoz\00ED styl aplikace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110855327610398937)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'cs'
,p_message_text=>'Vzhled '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798358432398895)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Index sloupce uveden\00FD v\00A0agregaci %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110701666942398825)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'cs'
,p_message_text=>unistr('CLOB v\00FDstup nen\00ED podporov\00E1n pro form\00E1t %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798076880398895)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159eru\0161eni sloupce mus\00ED b\00FDt na za\010D\00E1tku pole sloupc\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798133428398895)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Index skupiny sloupc\016F odkazovan\00FD v\00A0%0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110715604730398835)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'cs'
,p_message_text=>'exportovat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110720898018398839)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'cs'
,p_message_text=>unistr('Form\00E1t exportu mus\00ED b\00FDt XML pomoc\00ED ORDS jako tiskov\00E9ho serveru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798473225398895)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Index sloupce uveden\00FD ve zv\00FDrazn\011Bn\00ED %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714131041398834)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD form\00E1t exportu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110798216049398895)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Index nad\0159azen\00E9 skupiny uveden\00FD v\00A0%0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110823460375398913)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec %1 tabulky %0 je sloupec identity \201EGENERATED ALWAYS\201C. Ujist\011Bte se, \017Ee \017E\00E1dn\00FD sloupec zdroje nen\00ED v\00A0dialogov\00E9m okn\011B Konfigurovat namapov\00E1n na sloupec %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740831370398854)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00FD interval potvrzen\00ED je p\0159\00EDli\0161 n\00EDzk\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110740967019398854)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro na\010D\00EDt\00E1n\00ED dat nebyly poskytnuty \017E\00E1dn\00E9 sloupce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742116668398855)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro selektor \0159\00E1dek \201E%0\201C nebyly nalezeny \017E\00E1dn\00E9 sloupce. Zkuste automatickou detekci nebo zkontrolujte strukturu JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750463896398861)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00A0souboru XLSX nebyly nalezeny \017E\00E1dn\00E9 listy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750337033398860)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00FD list v\00A0souboru XLSX neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110730516904398846)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED verze dat v\00A0datab\00E1zi se od zah\00E1jen\00ED procesu aktualizace u\017Eivatelem zm\011Bnila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732919876398848)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i aktualizaci sloupc\016F sestavy: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837689749398924)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 nelze p\0159ev\00E9st na SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777136009398880)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec %0, kter\00FD je datov\00E9ho typu %1, nelze p\0159ev\00E9st na VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784129135398885)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec \201E%0\201C uveden\00FD pro atribut \201E%1\201C nebyl ve zdroji dat nalezen!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725482528398843)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'cs'
,p_message_text=>unistr('Typ filtru %0 nen\00ED pro sloupce s\00A0v\00EDce hodnotami podporov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110841034920398926)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD filtr \201Emezi\201C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707591713398829)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Byl zad\00E1n neplatn\00FD typ seznamu hodnot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707467463398829)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00FD typ dotazu. Typ dotazu mus\00ED b\00FDt Tabulka, SQL dotaz nebo funkce PL/SQL vracej\00EDc\00ED SQL dotaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777245295398880)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Anal\00FDza dotazu SQL selhala!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784218576398885)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00E1 pozice sloupce %0 pro atribut \201E%1\201C nebyla v\00A0p\0159\00EDkazu SQL nalezena!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110706038990398828)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'cs'
,p_message_text=>unistr('Ve v\00EDcehodnotov\00E9m filtru bylo pou\017Eito p\0159\00EDli\0161 mnoho polo\017Eek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784021437398885)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro atribut \201E%0\201C nen\00ED zad\00E1n \017E\00E1dn\00FD sloupec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707338871398829)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('T\011Blo funkce PL/SQL nevr\00E1tilo hodnotu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110797249296398895)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'cs'
,p_message_text=>unistr('Datov\00FD zdroj REST neobsahuje operaci ke zpracov\00E1n\00ED po\017Eadovan\00E9 akce DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110703219930398826)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159evod GeoJSON na SDO_GEOMETRY (sloupec\00A0%0) nen\00ED v\00A0t\00E9to datab\00E1zi k\00A0dispozici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704353431398827)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159evod SDO_GEOMETRY (sloupec %0) nen\00ED pro datov\00E9 zdroje XML podporov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110711668776398832)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'cs'
,p_message_text=>unistr('Znak %0 nen\00ED podporov\00E1n jako odd\011Blova\010D v\00EDce hodnot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110838902601398925)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Tuto funkci nelze v\00A0kontextu dotazu pou\017E\00EDt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110704412427398827)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>'Neshoda typu dat sloupce.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707245843398829)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'cs'
,p_message_text=>unistr('Intern\00ED limity vazby ORDS OUT byly p\0159ekro\010Deny. Sni\017Ete pros\00EDm po\010Det \0159\00E1dk\016F DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110785047831398886)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Odpov\011B\010F JSON ze vzd\00E1len\00E9ho serveru nelze analyzovat: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110707192053398829)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Nezn\00E1m\00FD nebo nespr\00E1vn\00FD typ kontextu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110801628294398898)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Analyz\00E1tor tento typ souboru nepodporuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756265297398865)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Neopr\00E1vn\011Bn\00FD p\0159\00EDstup (wwv_flow_api.set_credentials nen\00ED nastaveno).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733266344398848)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'cs'
,p_message_text=>unistr('Pracovn\00ED prostor se nevytvo\0159il, proto\017Ee ji\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110733118184398848)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'cs'
,p_message_text=>unistr('Skupina u\017Eivatel\016F nebyla vytvo\0159ena, proto\017Ee ji\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743498290398856)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'cs'
,p_message_text=>unistr('Bylo nalezeno duplicitn\00ED u\017Eivatelsk\00E9 jm\00E9no pro %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743550839398856)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i na\010D\00EDt\00E1n\00ED u\017Eivatel\016F. Selhalo u\00A0u\017Eivatele %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753476376398863)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Na\010Detlo by %0\00A0u\017Eivatel\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753274950398863)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'cs'
,p_message_text=>'Heslo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753305689398863)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'cs'
,p_message_text=>unistr('Opr\00E1vn\011Bn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753098956398862)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'cs'
,p_message_text=>unistr('U\017Eivatelsk\00E9 jm\00E9no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829531466398918)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i vykreslov\00E1n\00ED polo\017Eky str\00E1nky #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749107261398860)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Polo\017Eku str\00E1nky nelze zobrazit, proto\017Ee formul\00E1\0159 HTML je\0161t\011B nebyl otev\0159en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110714464317398834)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i v\00FDpo\010Dtu v\00FDchoz\00ED hodnoty polo\017Eky str\00E1nky #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748434444398859)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba v\00A0n\00E1sledn\00E9m v\00FDpo\010Dtu polo\017Eky pro polo\017Eku str\00E1nky #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748383773398859)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i v\00FDpo\010Dtu zdrojov\00E9 hodnoty polo\017Eky pro polo\017Eku str\00E1nky #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728158857398845)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'cs'
,p_message_text=>unistr('Neautorizovan\00FD p\0159\00EDstup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748699253398859)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'cs'
,p_message_text=>unistr('JavaScript nen\00ED podporov\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748769694398859)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'cs'
,p_message_text=>'Seznam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110749331612398860)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'cs'
,p_message_text=>'Nelze inicializovat dotaz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756580626398865)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktualizace %0 nen\00ED podporov\00E1na.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110750775979398861)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E9 ID polo\017Eky: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110777072959398880)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro tuto polo\017Eku neexistuje \017E\00E1dn\00E1 n\00E1pov\011Bda.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741526053398854)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'cs'
,p_message_text=>unistr('Generov\00E1n\00ED dotazu pro graf selhalo. Zkontrolujte nastaven\00ED zdroje a mapov\00E1n\00ED sloupc\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836369502398923)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159\00EDloha o\00A0velikosti %0\00A0MB p\0159esahuje maxim\00E1ln\00ED velikost p\0159\00EDlohy %1\00A0MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742467915398855)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E1 hodnota parametru p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110859877428398940)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ekro\010Dili jste maxim\00E1ln\00ED po\010Det e-mailov\00FDch zpr\00E1v na pracovn\00ED prostor. Obra\0165te se na sv\00E9ho spr\00E1vce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723446151398841)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'cs'
,p_message_text=>unistr('Tento postup mus\00ED b\00FDt vyvol\00E1n z\00A0relace aplikace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742394152398855)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro parametr %0 byla zad\00E1na hodnota null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796344728398894)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('\0160ablona e-mailu \201E%0\201C nebyla v\00A0aplikaci %1 nalezena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110872883110398950)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro odes\00EDl\00E1n\00ED e-mail\016F mus\00ED b\00FDt nastaven parametr instance SMTP_HOST_ADDRESS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742015682398855)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Pokud chcete odeslat po\0161tu, mus\00EDte zadat p\0159\00EDjemce zpr\00E1vy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110862264435398942)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze nav\00E1zat spojen\00ED SMTP pomoc\00ED konfigurovan\00E9ho e-mailov\00E9ho serveru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110836476638398923)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'cs'
,p_message_text=>unistr('Neplatn\00E9 vol\00E1n\00ED Ajax!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727872002398844)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro modul plugin %0 nebyla definov\00E1na \017E\00E1dn\00E1 funkce Ajax')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826898195398916)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro modul plug-in %0 nebyla definov\00E1na \017E\00E1dn\00E1 funkce spu\0161t\011Bn\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727970556398844)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro modul plugin %0 nebyla definov\00E1na \017E\00E1dn\00E1 funkce vykreslen\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837342595398923)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Modul plugin \201E%0\201C datov\00E9ho zdroje REST neobsahuje funkci \201EMo\017Enosti"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837251501398923)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Modul plugin \201E%0\201C datov\00E9ho zdroje REST neobsahuje funkci DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837497563398923)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Modul plugin \201E%0\201C datov\00E9ho zdroje REST neobsahuje funkci spu\0161t\011Bn\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110837594205398923)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'cs'
,p_message_text=>unistr('Modul plugin \201E%0\201C datov\00E9ho zdroje REST neobsahuje funkci na\010Dten\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725636424398843)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('B\011Bhem zpracov\00E1n\00ED modulu plugin do\0161lo k\00A0chyb\011B v\00A0k\00F3du PLSQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732286683398848)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Mus\00ED b\00FDt zad\00E1na hodnota.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762869552398869)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'cs'
,p_message_text=>unistr('Typ dat %0 nelze p\0159ev\00E9st na VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848409507398931)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec \201E%0\201C uveden\00FD pro atribut \201E%1\201C nebyl v\00A0p\0159\00EDkazu SQL nalezen!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824727614398914)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro %0 mus\00ED b\00FDt zad\00E1n dotaz na seznam hodnot nebo pojmenovan\00FD seznam hodnot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110826349222398915)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'cs'
,p_message_text=>unistr('Chybn\00FD po\010Det sloupc\016F vybran\00FDch v\00A0dotazu LOV SQL pro %0. Viz p\0159\00EDklady platn\00FDch v\00FDrok\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848292479398931)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'cs'
,p_message_text=>unistr('Pro atribut \201E%0\201C nen\00ED zad\00E1n \017E\00E1dn\00FD sloupec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877988793398954)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00E1 hodnota %0 pro atribut \201E%1\201C nen\00ED \010D\00EDseln\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110829862697398918)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('%0 m\00E1 ve v\00FDroku nespr\00E1vn\00FD typ dat. Sloupec#\00A0%1 je\00A0%2, ale o\010Dek\00E1v\00E1 se %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110848350773398931)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec \201E%0\201C uveden\00FD pro atribut \201E%1\201C m\00E1 typ dat %2, ale m\011Bl by m\00EDt %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110724999732398842)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'cs'
,p_message_text=>unistr('Nelze naj\00EDt rozlo\017Een\00ED sestavy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784957133398886)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'cs'
,p_message_text=>unistr('Funkci Compute Sum nelze pou\017E\00EDt pro sestavy zalo\017Een\00E9 na zdroji dat REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110748555867398859)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('CHYBA-2904 Nelze nastavit hodnotu z\00E1stupce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110752895566398862)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba: Nezn\00E1m\00FD typ z\00E1stupce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110742854987398855)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('V\00A0aplikaci %0 nelze na\010D\00EDst sch\00E9ma ov\011B\0159ov\00E1n\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110816392215398908)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'cs'
,p_message_text=>unistr('ID z\00E1kazn\00EDka ji\017E pro aktu\00E1ln\00ED relaci existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110753174339398863)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'cs'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877381790398954)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'cs'
,p_message_text=>unistr('Ov\011B\0159en\00ED selhalo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110779670704398882)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'cs'
,p_message_text=>unistr('Jeden nebo v\00EDce soubor\016F cookie v\00A0apex_util.g_request_cookies obsahuj\00ED neplatnou hodnotu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110762137398398869)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'cs'
,p_message_text=>unistr('Odpov\011B\010F z\00A0registru UDDI byla neplatn\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110725772441398843)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'cs'
,p_message_text=>unistr('Zadan\00E1 adresa URL nevr\00E1tila platn\00FD dokument WSDL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110728249523398845)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'cs'
,p_message_text=>unistr('Dokument WSDL obsahuje v\00EDce vazeb SOAP. &PRODUCT_NAME. podporuje pouze WSDL s\00A0jednou vazbou SOAP. Kliknut\00EDm na Vytvo\0159it odkaz na webovou slu\017Ebu ru\010Dn\011B pokra\010Dujte ve vytv\00E1\0159en\00ED reference pro tuto slu\017Ebu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110796609646398894)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'cs'
,p_message_text=>unistr('Odpov\011B\010F slu\017Eby nebyla ve form\00E1tu XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877237354398954)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'cs'
,p_message_text=>unistr('Token p\0159\00EDstupu OAuth nen\00ED k\00A0dispozici nebo jeho platnost vypr\0161ela.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110840483936398926)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'cs'
,p_message_text=>unistr('P\0159ekro\010Dili jste maxim\00E1ln\00ED po\010Det po\017Eadavk\016F na webov\00E9 slu\017Eby pro pracovn\00ED prostor. Obra\0165te se na sv\00E9ho spr\00E1vce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110877463473398954)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'cs'
,p_message_text=>unistr('Server odpov\011Bd\011Bl nepodporovan\00FDm typem tokenu OAuth.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727664625398844)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'cs'
,p_message_text=>unistr('Dokument WSDL neobsahoval vazbu pro SOAP, kter\00E1 je nutn\00E1 pro p\0159id\00E1n\00ED odkazu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110723540611398841)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'cs'
,p_message_text=>unistr('Toto WSDL vy\017Eaduje p\0159ihla\0161ovac\00ED \00FAdaje pro ov\011B\0159en\00ED. N\00ED\017Ee zadejte u\017Eivatelsk\00E9 jm\00E9no a\00A0heslo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110732314539398848)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'cs'
,p_message_text=>unistr('Modul vykreslen\00ED nerozum\00ED dokumentu WSDL. Kliknut\00EDm na Vytvo\0159it odkaz na webovou slu\017Ebu ru\010Dn\011B pokra\010Dujte ve vytv\00E1\0159en\00ED reference pro tuto slu\017Ebu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110799257002398896)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'cs'
,p_message_text=>'Aktualizaci nelze zpracovat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110825088719398915)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'cs'
,p_message_text=>unistr('Sloupec v\00FDsledk\016F a\00A0zobrazen\00ED v\00A0seznamu hodnot jsou stejn\00E9!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110824900009398914)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('Seznam hodnot neobsahuje sloupec v\00FDsledk\016F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756409531398865)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i na\010D\00EDt\00E1n\00ED hodnoty sloupce: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780486238398883)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'cs'
,p_message_text=>unistr('Aktu\00E1ln\00ED data tabulkov\00E9ho formul\00E1\0159e jsou zastaral\00E1. Zdrojov\00E1 data byla upravena.<br/> Klikn\011Bte <strong><a href="%0">sem</a></strong> pro zru\0161en\00ED proveden\00FDch zm\011Bn a\00A0znovu na\010Dt\011Bte data z\00A0datab\00E1ze.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738537692398852)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i ur\010Dov\00E1n\00ED str\00E1nkovac\00EDho \0159et\011Bzce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738413930398852)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('nelze ur\010Dit z\00E1hlav\00ED dotaz\016F:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738661981398852)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'cs'
,p_message_text=>unistr('chyba p\0159i prov\00E1d\011Bn\00ED v\00FDm\011Bny z\00E1pat\00ED zpr\00E1vy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738798944398852)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('anal\00FDza dotazu SQL selhala:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743770417398856)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'cs'
,p_message_text=>unistr('Minim\00E1ln\00ED po\017Eadovan\00FD po\010Det \0159\00E1dek: %0, nalezen\00E9, ale nezobrazen\00E9 \0159\00E1dky: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741204725398854)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'cs'
,p_message_text=>unistr('sloupec dotazu \010D\00EDslo %0 (%1) je neplatn\00FD, sloupce, kter\00E9 pou\017E\00EDvaj\00ED HTML, vy\017Eaduj\00ED aliasov\00E9 n\00E1zvy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110756316700398865)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'cs'
,p_message_text=>unistr('Chyba p\0159i z\00EDsk\00E1v\00E1n\00ED z\00E1hlav\00ED dotazu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738886157398852)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'chyba sestavy:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110776562637398880)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'cs'
,p_message_text=>unistr('\0158adit podle tohoto sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741318883398854)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'cs'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Dotaz nelze analyzovat, zkontrolujte syntaxi dotazu.',
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780583855398883)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'cs'
,p_message_text=>unistr('Tento formul\00E1\0159 obsahuje neulo\017Een\00E9 zm\011Bny. Klikn\011Bte na tla\010D\00EDtko \201EOk\201C pro pokra\010Dov\00E1n\00ED bez ulo\017Een\00ED zm\011Bn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110784895208398886)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'cs'
,p_message_text=>unistr('Sch\00E9ma str\00E1nkov\00E1n\00ED sestavy (%0) nen\00ED u\00A0vybran\00E9ho zdroje dat podporov\00E1no.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110741129599398854)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'cs'
,p_message_text=>unistr('sloupec dotazu \010D\00EDslo %0 (%1) je neplatn\00FD, pou\017Eijte alias sloupce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743834937398856)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'cs'
,p_message_text=>unistr('\0159\00E1dky\00A0%0\2013%1 z\00A0v\00EDce ne\017E %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110782568655398884)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'cs'
,p_message_text=>unistr('%0\2013%1 z\00A0v\00EDce ne\017E %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110743639059398856)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'cs'
,p_message_text=>unistr('\0159\00E1dky\00A0%0\2013%1 z\00A0%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110727529878398844)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'cs'
,p_message_text=>unistr('%0\2013%1 z\00A0%2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738911582398852)
,p_name=>'Y'
,p_message_language=>'cs'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110745072150398857)
,p_name=>'YEAR'
,p_message_language=>'cs'
,p_message_text=>'rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110738124780398852)
,p_name=>'YEARS'
,p_message_language=>'cs'
,p_message_text=>'let'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110780696408398883)
,p_name=>'YES'
,p_message_language=>'cs'
,p_message_text=>'Ano'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4496)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4496)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('Pracovn\00ED plocha')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4496
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4496)
,p_name=>unistr('Zpr\00E1vy')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('Zpr\00E1vy')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
