prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4499
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4499 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4499
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101448073403461')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'da'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4499)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113349'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4499)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4499)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4499)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4499)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4499)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4499)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4499)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4499)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4499)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4499)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4499)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4499)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4499)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.da'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4499
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4499)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4499)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4499)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4499)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4499)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4499)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4499)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.da'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4499
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4499)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4499)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4499)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4499)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4499)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4499)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4499)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.da'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4499
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4499)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4499)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4499)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.da'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4499
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4499)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4499)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4499)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4499)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4499)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4499)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4499)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4499)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4499)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4499)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4499)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4499)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4499)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4499)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4499)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.da'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4499
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4499)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4499)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4499)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4499)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4499)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4499)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4499)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4499)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4499)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4499)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4499)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4499)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4499)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4499)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4499)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.da'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4499
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4499)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4499)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4499)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4499)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4499)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4499)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4499)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4499)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4499)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4499)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4499)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4499)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4499)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4499)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4499)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.da'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4499
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4499)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4499)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4499)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4499)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4499)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4499)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4499)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4499)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4499)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4499)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4499)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4499)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4499)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4499)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4499)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4499
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4499)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4499
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4499)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4499
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4499)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4499
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4499)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4499
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4499)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4499
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4499
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4499)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4499)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4499)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4499)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4499)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4499)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4499)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4499)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4499)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4499)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4499)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4499)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4499)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4499)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4499)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4499)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4499)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4499)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4499)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4499)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4499)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4499)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4499)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4499)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4499)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4499)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4499)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4499)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4499)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4499
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4499)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4499)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4499)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4499
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4499)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4499
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4499)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4499
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4499)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4499
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4499)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4499
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4499)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4499
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4499)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4499)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4499)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4499)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4499)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4499)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4499)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4499)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4499)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4499
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4499)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4499)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4499)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4499)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4499)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4499)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4499)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4499
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4499)
,p_page_name=>'winlov'
,p_page_title=>unistr('S\00F8gedialogboks')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('S\00F8g')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Luk'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('N\00E6ste &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Forrige'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">R\00E6kke(r) #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4499
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4499)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4499
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4499)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4499)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4499)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4499)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4499)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4499)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4499)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4499)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4499)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4499)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4499)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4499)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4499)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4499)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4499)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4499)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4499)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4499)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4499)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4499)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4499)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4499)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4499)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4499)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4499)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4499)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4499)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4499)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4499)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4499)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4499)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4499)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4499)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4499)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4499)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4499)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4499)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4499)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4499)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4499)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4499)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4499)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4499)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4499)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4499)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4499)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4499)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4499)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4499)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4499)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4499)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4499)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4499)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4499)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4499)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4499)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4499)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4499)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4499)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4499)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4499)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4499)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4499)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4499)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4499)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4499)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4499)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4499)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4499)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4499)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4499)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4499)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4499)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4499)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4499)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4499)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4499)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4499)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4499)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4499)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4499)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4499)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4499)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4499)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4499)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4499)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4499)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4499)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4499)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4499)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4499)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4499)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4499)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4499)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4499)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4499)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4499)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4499)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4499)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4499)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4499)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4499)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4499)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4499)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4499)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4499)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4499)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4499)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4499)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4499)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4499)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4499)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4499)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4499)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4499)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4499)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4499)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4499)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4499)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4499)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4499)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4499)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4499)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4499)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4499)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4499)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4499)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4499)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4499)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4499)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4499)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4499)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4499)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4499)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4499)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4499)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4499)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4499)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4499)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4499)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4499)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4499)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4499)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4499)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4499)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4499)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4499)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4499)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4499)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4499)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4499)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4499)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4499)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4499)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4499)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4499)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4499)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4499)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4499)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4499)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4499)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4499)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4499)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4499)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4499)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4499)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4499)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4499)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4499)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4499)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4499)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4499)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4499)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4499)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4499)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4499)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4499)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4499)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4499)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4499)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4499)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4499)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4499)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4499)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4499)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4499)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913624337398987)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'da'
,p_message_text=>'Kolonne %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900780226398977)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'da'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900690320398977)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'da'
,p_message_text=>'Brugernavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957976677399019)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'da'
,p_message_text=>unistr('Adgang n\00E6gtet')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917625837398990)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'da'
,p_message_text=>'Din %0-konto er oprettet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903228366398979)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'da'
,p_message_text=>unistr('Kontoen er l\00E5st.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893112163398972)
,p_name=>'AM_PM'
,p_message_language=>'da'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027558766399069)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'da'
,p_message_text=>'Skift %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035641886399075)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'da'
,p_message_text=>'(Aktiv)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005141414399053)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'da'
,p_message_text=>'Ajax-kald returnerede serverfejl %0 for %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935964962399003)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'da'
,p_message_text=>'Applikationsaliasset "%0" kan ikke konverteres til et entydigt applikations-ID.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936003226399003)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Applikation med aliasset "%0" findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925664812398995)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'ERR-1816 Uventet fejl under konvertering af applikationsalias p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018513197399063)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'da'
,p_message_text=>unistr('Kontrolsummen for applikationen g\00F8r det nemt at fastl\00E6gge, om den samme applikation er taget i brug p\00E5 tv\00E6rs af arbejdsomr\00E5der. Du kan sammenligne denne kontrolsum for at fastl\00E6gge, om der er et match. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911420511398985)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af autentificeringsfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896882888398975)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af autentificeringsfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060384416399093)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'da'
,p_message_text=>unistr('Lejernavnet %0, som er returneret af Oracle Cloud Identity Management, er ikke autoriseret for dom\00E6net %1!<br/>Du skal <a href="&LOGOUT_URL.">logge p\00E5 igen</a> og angive et autoriseret lejernavn eller \00E6ndre din URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894508103398973)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'da'
,p_message_text=>unistr('Din konto "%0" har ikke de n\00F8dvendige udviklingsprivilegier (DB_DEVELOPER eller DB_ADMINISTRATOR)<br/>til arbejdsomr\00E5det "%1"! Du skal <a href="&LOGOUT_URL.">logge p\00E5 igen</a>, n\00E5r privilegier er leveret.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893659781398972)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'da'
,p_message_text=>unistr('Det lejernavn, som er returneret af Oracle Cloud Identity Management, er ikke autoriseret for det aktuelle arbejdsomr\00E5de!<br/>Du skal <a href="&LOGOUT_URL.">logge p\00E5 igen</a> og angive et autoriseret lejernavn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894675699398973)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'da'
,p_message_text=>unistr('Af sikkerhedshensyn er det ikke tilladt at k\00F8re applikationer af dette arbejdsomr\00E5de via dom\00E6net i URL''en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911117514398985)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'da'
,p_message_text=>unistr('Bed din databaseadministrator om at k\00F8re $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911001563398985)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'da'
,p_message_text=>'SYS.DBMS_LDAP-pakke findes ikke eller er ugyldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910926501398985)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af LDAP-brugerfunktion til redigering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911265126398985)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af LDAP-autentificering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912076957398986)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'da'
,p_message_text=>'Fejl i p_flow_page-argument til login_page-procedure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911645335398985)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'da'
,p_message_text=>'Ugyldig p_session i wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959587228399020)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'da'
,p_message_text=>'Forkert udformet argument til wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911715779398985)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'da'
,p_message_text=>'NULL-brugernavn er videregivet til logonprocedure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900598627398977)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'da'
,p_message_text=>unistr('Vent <span id="apex_login_throttle_sec">%0</span> sekunder, f\00F8r du logger p\00E5 igen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901881306398978)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('Fors\00F8get p\00E5 logon er blokeret.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957369491399018)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Autentificeringen "%0" blev ikke fundet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902182942398978)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'da'
,p_message_text=>'ID for sikkerhedsgruppe er NULL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911537199398985)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under udf\00F8relse af efterautentificeringsproces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911342818398985)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under behandling af f\00F8rautentificeringsproces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912557361398986)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C5bn URL''en i den samme browser, hvor du initierede anmodningen Nulstil adgangskode. Hvis du klikker p\00E5 URL''en til nulstilling af adgangskode og omdirigeres til '),
'logonsiden, skal du initiere Nulstil adgangskode igen og lade',
unistr('browseren forblive \00E5ben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057885404399091)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'da'
,p_message_text=>'URL til nulstilling af adgangskode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894863865398973)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'da'
,p_message_text=>'Ressourcestyringens forbrugergruppe %0 er ikke tildelt %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894964754398973)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'da'
,p_message_text=>'Brug DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP til at tildele det manglende privilegie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922964897398993)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af sessionsadvarselsfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923057751398993)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af sessionsverificeringsfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923271241398994)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'da'
,p_message_text=>'Bed din %0-administrator om at konfigurere programmet til Oracle Application Server Single Sign-On.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932710957399000)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'da'
,p_message_text=>'Ugyldig %0 i %1-token returneret af SSO.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911929655398986)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'da'
,p_message_text=>unistr('Rediger autentificeringsskemaet, og tilf\00F8j applikationsnavnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932448195399000)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'da'
,p_message_text=>'Ugyldig opkalder for %0-procedure:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932687458399000)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'da'
,p_message_text=>'Ugyldig app-session i URLC-token: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932201856399000)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'da'
,p_message_text=>'Fejl i portal_sso_redirect: manglende oplysninger om applikationsregistrering: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923162484398994)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'da'
,p_message_text=>'WWSEC_SSO_ENABLER_PRIVATE-pakke findes ikke eller er ugyldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110911868060398985)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'da'
,p_message_text=>'Kan ikke finde registreret partnerapplikationsnavn i autentificeringsskema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932322837399000)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'da'
,p_message_text=>'Registrer denne applikation som beskrevet i installationsvejledningen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923320800398994)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af SSO-autentificering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032703375399073)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'da'
,p_message_text=>'Uautoriseret URL:  %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922715513398993)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af autentificering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894769431398973)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'da'
,p_message_text=>unistr('Arbejdsomr\00E5det "%0" er inaktivt. Kontakt din administrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895184948398974)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'da'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901543751398978)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'da'
,p_message_text=>unistr('Adgang n\00E6gtet af sikkerhedskontrol for applikation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901620707398978)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'da'
,p_message_text=>unistr('Adgang n\00E6gtet af sikkerhedskontrol for side')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901722832398978)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af autorisation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965122524399024)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'da'
,p_message_text=>unistr('Bygget med %0 ved hj\00E6lp af %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965291104399024)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'da'
,p_message_text=>unistr('k\00E6rlighed')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023073374399066)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'da'
,p_message_text=>'Beskrivelse af begivenhed'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022827000399066)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'da'
,p_message_text=>'Slutdato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023187566399066)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'da'
,p_message_text=>'Begivenheds-ID'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022745754399066)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'da'
,p_message_text=>'Startdato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022919120399066)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Navn p\00E5 begivenhed')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913564226398987)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'da'
,p_message_text=>'Indholdsfejl i kontrolsum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913448202398987)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'da'
,p_message_text=>'Formatfejl i kontrolsum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977466517399033)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'da'
,p_message_text=>'Kopieret til Udklipsholder.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977157028399033)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'da'
,p_message_text=>unistr('Denne browser underst\00F8tter ikke kopiering fra en knap eller menu. Pr\00F8v Ctrl+C eller Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965604706399025)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'da'
,p_message_text=>'Luk underretning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021657876399065)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'da'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016167881399061)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'da'
,p_message_text=>'Aktuel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016045588399061)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'da'
,p_message_text=>'Oprindelig'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020203709399064)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re en gyldig farve. Eksempel: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015983294399061)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg en farve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016239241399061)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('\00C6ndr farveformat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055478956399089)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'da'
,p_message_text=>unistr('Liste over v\00E6rdier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055598369399089)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'da'
,p_message_text=>unistr('\00C5bn liste for: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035750014399075)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'da'
,p_message_text=>unistr('(Fuldf\00F8rt)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928054442398997)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'da'
,p_message_text=>'Kontakt din applikationsadministrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942481130399008)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Kontakt din applikationsadministrator.',
unistr('Detaljer om denne h\00E6ndelse er tilg\00E6ngelige via fejlfindings-ID''et "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020574312399064)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'da'
,p_message_text=>unistr('Ret fejl, f\00F8r du gemmer.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966589206399025)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'da'
,p_message_text=>'%0 matchninger fundet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966493597399025)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'da'
,p_message_text=>'Ingen matchninger blev fundet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036239721399075)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'da'
,p_message_text=>'Aktuel status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020918699399064)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Filen, der er angivet i elementet %0, findes ikke i APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009471116399056)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'da'
,p_message_text=>unistr('Aktuel version af data i database er \00E6ndret, siden brugeren initierede opdateringsprocessen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978558280399034)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'da'
,p_message_text=>unistr('Indl\00E6s ikke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025524578399068)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'da'
,p_message_text=>'Forbehandlingsfejl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025348811399068)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'da'
,p_message_text=>unistr('Inds\00E6t r\00E6kke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039426990399077)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'da'
,p_message_text=>'Sekvens: handling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025406836399068)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'da'
,p_message_text=>unistr('Opdater r\00E6kke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966982655399025)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'da'
,p_message_text=>'Pop op-kalender: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889514237398969)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889637256398970)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'da'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025769812399068)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal have en v\00E6rdi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025667675399068)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re en gyldig dato, for eksempel %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893296414398972)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re mellem %0 og %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893361632398972)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re p\00E5 eller efter %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893441745398972)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re p\00E5 eller f\00F8r %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970441709399028)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'da'
,p_message_text=>'#LABEL# ligger efter den angivne maksimumdato %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970826616399028)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'da'
,p_message_text=>'#LABEL# matcher ikke formatet %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970311216399028)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# ligger f\00F8r den angivne minimumdato %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970585507399028)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'da'
,p_message_text=>'#LABEL# er ikke i det gyldige interval fra %0 til %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970726056399028)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# er ikke i den gyldige \00E5rr\00E6kke fra %0 til %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020832735399064)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'da'
,p_message_text=>'Annuller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048046356399084)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'da'
,p_message_text=>'Luk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050025917399085)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020628188399064)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'da'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020713074399064)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'da'
,p_message_text=>'Gem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926931429398996)
,p_name=>'APEX.ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894306292398973)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'da'
,p_message_text=>unistr('F\00F8lgende fejl opstod under udf\00F8relse af fejlh\00E5ndteringstilbagekald: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903008611398979)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl opstod under maling af fejlside: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895000760398973)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'da'
,p_message_text=>'Intern fejl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034891007399074)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Kontakt din administrator.',
unistr('Detaljer om denne h\00E6ndelse er tilg\00E6ngelige via fejlfindings-ID "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029105255399070)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'da'
,p_message_text=>unistr('Databasen er \00E5ben for skivebeskyttet adgang.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059714315399092)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'da'
,p_message_text=>unistr('ORA-28353: Kunne ikke \00E5bne wallet. Applikationsdata er p.t. ikke tilg\00E6ngelige.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029270059399070)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'da'
,p_message_text=>unistr('Denne side er ikke tilg\00E6ngelig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896770416398975)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'da'
,p_message_text=>'Tekniske oplysninger (kun synlige for udviklere)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992800006399044)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'da'
,p_message_text=>'Fejlmeddelelse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006723671399054)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'da'
,p_message_text=>'Forventet format: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973488081399030)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'da'
,p_message_text=>unistr('Bruger er allerede p\00E5 adgangskontrolliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973342511399030)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'da'
,p_message_text=>unistr('Bekr\00E6ft tilf\00F8jelse af f\00F8lgende %0 bruger(e) p\00E5 <strong>%1</strong>-adgangskontrollisten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973883823399030)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'da'
,p_message_text=>'Dubleret bruger findes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973501579399030)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'da'
,p_message_text=>'Manglende snabel-a (@) i e-mailadresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973663534399030)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'da'
,p_message_text=>'Manglende punktum (@) i e-mailadresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973782949399030)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'da'
,p_message_text=>'Brugernavn er for langt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974090080399031)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'da'
,p_message_text=>unistr('Kun brugere, der er defineret p\00E5 applikationens adgangskontrolliste, kan f\00E5 adgang til denne applikation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974126136399031)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'da'
,p_message_text=>unistr('Uventet indstillingsv\00E6rdi: %0 for adgangskontrol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973942180399030)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'da'
,p_message_text=>unistr('Alle autentificerede brugere kan f\00E5 adgang til denne applikation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016789161399061)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'da'
,p_message_text=>'Deaktiveret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016681671399061)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'da'
,p_message_text=>'Aktiveret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016910375399062)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'da'
,p_message_text=>'%0: Er deaktiveret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016874492399061)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'da'
,p_message_text=>'%0: Er aktiveret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016536604399061)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'da'
,p_message_text=>'ikke identificeret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009624301399056)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'da'
,p_message_text=>'Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966162739399025)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'da'
,p_message_text=>'Anvendt filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007247544399055)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'da'
,p_message_text=>'Anvend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892107689398971)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8jlediagram')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019999031399064)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'da'
,p_message_text=>'Andre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892293491398971)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'da'
,p_message_text=>'Cirkeldiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018660690399063)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'da'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891946229398971)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'da'
,p_message_text=>'Antal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007781635399055)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'da'
,p_message_text=>'Ryd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007867025399055)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'da'
,p_message_text=>'Ryd alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007967155399055)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'da'
,p_message_text=>'Ryd %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025189169399067)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'da'
,p_message_text=>unistr('Kolonnen %1, som facetten %0 refererer til, er ikke tilg\00E6ngelig eller er uautoriseret.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882336453398964)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg filtre, der skal vises')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964370625399024)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'da'
,p_message_text=>'%0 resultater'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964423643399024)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'da'
,p_message_text=>'%0 valgt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967054645399026)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'da'
,p_message_text=>'Aktuelle filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883884771398965)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'da'
,p_message_text=>'Filterliste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023677294399066)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'da'
,p_message_text=>unistr('Den distinkte v\00E6rdigr\00E6nse (%0) er overskredet for facetten %1.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009240523399056)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('Facetten %0 underst\00F8ttes ikke for DATE- eller TIMESTAMP-kolonner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007349322399055)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'da'
,p_message_text=>'Filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007493369399055)
,p_name=>'APEX.FS.GO'
,p_message_language=>'da'
,p_message_text=>unistr('G\00E5 til')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008818080399056)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'da'
,p_message_text=>'lig med %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892905040398972)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'da'
,p_message_text=>'indeholder %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892639408398972)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'da'
,p_message_text=>unistr('st\00F8rre end %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892770515398972)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'da'
,p_message_text=>unistr('st\00F8rre end eller lig med %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892418925398972)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'da'
,p_message_text=>'mindre end %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892599160398972)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'da'
,p_message_text=>'mindre end eller lig med %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892878380398972)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'da'
,p_message_text=>'starter med %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895377720398974)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Datatypen %0 (%1) underst\00F8ttes ikke for facetten Inputfelt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885508789398967)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'da'
,p_message_text=>unistr('Facetter med flere v\00E6rdier kr\00E6ver 12.2 eller h\00F8jere databaser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009021367399056)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'da'
,p_message_text=>unistr('Ingen s\00F8gekolonner er leveret for facetten %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882483825398964)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'da'
,p_message_text=>'Flere filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964562783399024)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'da'
,p_message_text=>'Intervalstart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008541085399056)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'da'
,p_message_text=>'%0 til %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008616237399056)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'da'
,p_message_text=>'Over %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008786621399056)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'da'
,p_message_text=>'Under %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964638970399024)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'da'
,p_message_text=>'Intervalslut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027481851399069)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'da'
,p_message_text=>'LOV-elementnr. %2 ("%1") for intervalfacetten %0 er ugyldigt (separatoren "|" mangler).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008917451399056)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'da'
,p_message_text=>unistr('Manuelt input for intervalfacetten %0 underst\00F8ttes p.t. ikke, da kolonnen er DATE eller TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008291050399055)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'da'
,p_message_text=>'til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892008516398971)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'da'
,p_message_text=>'Fjern diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961109622399021)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'da'
,p_message_text=>'Nulstil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007624011399055)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007547227399055)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008463195399055)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'da'
,p_message_text=>unistr('- V\00E6lg -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891877856398971)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'da'
,p_message_text=>'Vis diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008006300399055)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'da'
,p_message_text=>unistr('Vis f\00E6rre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008121609399055)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'da'
,p_message_text=>'Vis flere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111008397707399055)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'da'
,p_message_text=>'%0 stjerner og op'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966036512399025)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'da'
,p_message_text=>'Filtrer forslag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009157036399056)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('Tekstfeltfacetten %0 underst\00F8ttes p.t. kun for NUMBER-kolonner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882212813398964)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'da'
,p_message_text=>unistr('Samlet antal r\00E6kker')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025206501399067)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Datatypen %0 (%1) underst\00F8ttes ikke for facetteret s\00F8gning.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017135462399062)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('G\00E5 til fejl')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974765447399031)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'da'
,p_message_text=>'Aggreger.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982364364399037)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'da'
,p_message_text=>'Skjul kontrolbrud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974848618399031)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'da'
,p_message_text=>'Kontrolbrud.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982294746399037)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'da'
,p_message_text=>'Udvid kontrolbrud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060955052399093)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'da'
,p_message_text=>'Kolonne %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982093076399036)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'da'
,p_message_text=>unistr('%0 r\00E6kker slettet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052495144399087)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'da'
,p_message_text=>'Dubleret identitet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971733169399029)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'da'
,p_message_text=>unistr('F\00F8rste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975075178399031)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'da'
,p_message_text=>'Gruppeoverskrift.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974944510399031)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'da'
,p_message_text=>'Overskrift.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971879090399029)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'da'
,p_message_text=>'Sidste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991855024399043)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'da'
,p_message_text=>unistr('Indl\00E6s flere r\00E6kker')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971588384399029)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975147480399031)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'da'
,p_message_text=>unistr('Sider\00E6kker')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971967787399029)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'da'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972036878399029)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'da'
,p_message_text=>'%0 - %1 af %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028099529399069)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'da'
,p_message_text=>'Sidevalg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971638855399029)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'da'
,p_message_text=>'Forrige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052282292399087)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8jet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052305187399087)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'da'
,p_message_text=>unistr('\00C6ndret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060730406399093)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke %0, Kolonne %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060823305399093)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052137032399087)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'da'
,p_message_text=>'Slettet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975341739399031)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkeoverskrift')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970901214399028)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'da'
,p_message_text=>'%0 celler valgt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972105081399029)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'da'
,p_message_text=>unistr('%0 r\00E6kker valgt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012478685399058)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg alle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982112028399036)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'da'
,p_message_text=>'Side %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975284552399031)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg r\00E6kke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975415269399032)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'da'
,p_message_text=>'Sorter stigende %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975590793399032)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'da'
,p_message_text=>'Sorter faldende %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971080492399028)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'da'
,p_message_text=>'Sorter stigende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971341739399029)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'da'
,p_message_text=>'Sorter stigende %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971144999399028)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'da'
,p_message_text=>'Sorter faldende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971406523399029)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'da'
,p_message_text=>'Sorter faldende %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110971231219399029)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'da'
,p_message_text=>'Sorter ikke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981940765399036)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'da'
,p_message_text=>'I alt %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908366393398983)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'da'
,p_message_text=>'HTTP-anmodningen til "%0" fejlede.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049692763399085)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'da'
,p_message_text=>unistr('%0 kolonner og %1 r\00E6kker fra gittervalgliste. Brug piletaster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981858809399036)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'da'
,p_message_text=>unistr('%0 r\00E6kker fra valglisten. Brug piletaster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060519592399093)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'da'
,p_message_text=>'Interaktivt gitter %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968654493399027)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'da'
,p_message_text=>'Handlinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969637312399027)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969520970399027)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j r\00E6kke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054007243399088)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'da'
,p_message_text=>'Aggreger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039534536399078)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'da'
,p_message_text=>'Aggregering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041296245399079)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'da'
,p_message_text=>'Alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997602762399048)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Alle tekstkolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998868018399048)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'da'
,p_message_text=>'Alternativ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999943184399049)
,p_name=>'APEX.IG.AND'
,p_message_language=>'da'
,p_message_text=>'og'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019328845399063)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'da'
,p_message_text=>'Omtrentligt antal distinkte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055017360399089)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet omtrentligt antal distinkte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038107770399077)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'da'
,p_message_text=>unistr('Omr\00E5de')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040084190399078)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'da'
,p_message_text=>'Stigende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998953597399049)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'da'
,p_message_text=>'Autorisation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054163864399088)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'da'
,p_message_text=>'Automatisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019774621399063)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'da'
,p_message_text=>'Gennemsnit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054707449399089)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet gennemsnit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037645352399076)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'da'
,p_message_text=>'Etiketaksetitel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037802385399076)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'da'
,p_message_text=>'Decimalpladser'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037703087399076)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdiaksetitel')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043858265399081)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'da'
,p_message_text=>'Baggrundsfarve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038214265399077)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8jle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994261876399045)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'da'
,p_message_text=>'mellem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045055206399082)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'da'
,p_message_text=>'Begge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038384378399077)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'da'
,p_message_text=>'Boble'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969898143399028)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'da'
,p_message_text=>'Annuller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999869155399049)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'da'
,p_message_text=>unistr('Forskel p\00E5 sm\00E5 og store bogstaver')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055607543399089)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'da'
,p_message_text=>unistr('(Forskel p\00E5 store og sm\00E5 bogstaver)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026590841399068)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'da'
,p_message_text=>unistr('\00C6ndringerne er gemt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970286419399028)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'da'
,p_message_text=>'Skift visning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000949006399050)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'da'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997481908399047)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'da'
,p_message_text=>unistr('Din foresp\00F8rgsel overskrider det maksimale antal p\00E5 %0 datapunkter pr. diagram. Anvend et filter for at reducere antallet af records i din basisforesp\00F8rgsel.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968568318399027)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'da'
,p_message_text=>'Diagramvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975804134399032)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'da'
,p_message_text=>'Ryd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037110451399076)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Lukke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044073222399081)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'da'
,p_message_text=>'Farver'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020149083399064)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'da'
,p_message_text=>'Eksempel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999218382399049)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'da'
,p_message_text=>'Kolonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968786932399027)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045843006399082)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Kolonneform\00E5l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999392168399049)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'da'
,p_message_text=>'Kompleks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968992966399027)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'da'
,p_message_text=>'Beregn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994867123399046)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'da'
,p_message_text=>'indeholder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001178046399050)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'da'
,p_message_text=>'Kontrolbrud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975671243399032)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'da'
,p_message_text=>'Kopier til Udklipsholder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975705863399032)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'da'
,p_message_text=>'Kopier ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019140527399063)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'da'
,p_message_text=>'Antal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019285312399063)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'da'
,p_message_text=>'Antal distinkte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054952197399089)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet antal distinkte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054816593399089)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet antal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052527155399087)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'da'
,p_message_text=>'Opret %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997849761399048)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'da'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045660281399082)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>'Datatype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045274774399082)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'da'
,p_message_text=>'Dato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026314915399068)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig datov\00E6rdi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995515960399046)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'da'
,p_message_text=>'dage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998531926399048)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'Standardindstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998371281399048)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'da'
,p_message_text=>'Standardtype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969735334399027)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'da'
,p_message_text=>'Slet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046843301399083)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'da'
,p_message_text=>unistr('Er du sikker p\00E5, at du vil slette denne rapport?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002975710399051)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('Slet r\00E6kke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001718426399051)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Slet r\00E6kker')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040154172399078)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'da'
,p_message_text=>'Faldende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000640179399050)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'da'
,p_message_text=>'Detalje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968233165399026)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'da'
,p_message_text=>'Detaljevisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028833461399070)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkef\00F8lge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000340487399050)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'da'
,p_message_text=>'Deaktiveret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994919789399046)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'da'
,p_message_text=>'indeholder ikke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995124024399046)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'da'
,p_message_text=>'starter ikke med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038432708399077)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'da'
,p_message_text=>'Krans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001390729399050)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'da'
,p_message_text=>'Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900001635398977)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'da'
,p_message_text=>'Kun data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047823133399084)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg format')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912643773398986)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'da'
,p_message_text=>'Downloadformatet %0 er ikke aktiveret.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040857472399079)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'da'
,p_message_text=>'Dubletaggregering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040971385399079)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'da'
,p_message_text=>'Dubletkontrolbrud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002831924399051)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('Dubleret r\00E6kke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001629124399051)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Dublerede r\00E6kker')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969378899399027)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'da'
,p_message_text=>'Rediger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039941078399078)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'da'
,p_message_text=>'Rediger diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051409288399086)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'da'
,p_message_text=>'Rediger Grupper efter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047412876399083)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'da'
,p_message_text=>'Blind kopi (Bcc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047626675399083)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'da'
,p_message_text=>'Meddelelse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047388626399083)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'da'
,p_message_text=>'Kopi (Cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047099737399083)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'da'
,p_message_text=>'E-mail sendt.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047544994399083)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'da'
,p_message_text=>'Emne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047232218399083)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'da'
,p_message_text=>'Modtager (til)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000035881399049)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'da'
,p_message_text=>'Aktiveret'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993284353399044)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'da'
,p_message_text=>'er lig med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046479445399083)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'da'
,p_message_text=>'Eksempel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000141241399049)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'da'
,p_message_text=>'Udtryk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046380589399082)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'da'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012319444399058)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'da'
,p_message_text=>'Fil er klargjort. Starter download.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110975929553399032)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'da'
,p_message_text=>'Udfyld'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977034081399033)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'da'
,p_message_text=>'Udfyld valgte med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976963171399033)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'da'
,p_message_text=>'Udfyld valgte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968897337399027)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'da'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999445797399049)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'da'
,p_message_text=>'Filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054408056399088)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'da'
,p_message_text=>'Filtrer...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040368613399078)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'da'
,p_message_text=>unistr('F\00F8rste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969096185399027)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'da'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997901430399048)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'da'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044995611399082)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'da'
,p_message_text=>'Formateringsmaske'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046705316399083)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'da'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046659775399083)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'da'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959485415399020)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'da'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898758418398976)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'da'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002533532399051)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'da'
,p_message_text=>'Fastfrys'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000283684399050)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'da'
,p_message_text=>'Funktioner og operatorer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038588424399077)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'da'
,p_message_text=>'Tragt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019031394399063)
,p_name=>'APEX.IG.GO'
,p_message_language=>'da'
,p_message_text=>unistr('G\00E5 til')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993845158399045)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'da'
,p_message_text=>unistr('st\00F8rre end')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993939625399045)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'da'
,p_message_text=>unistr('st\00F8rre end eller lig med')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000503394399050)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'da'
,p_message_text=>'Gitter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968024965399026)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'da'
,p_message_text=>'Gittervisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041156072399079)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'da'
,p_message_text=>'Gruppe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000733970399050)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'da'
,p_message_text=>'Grupper efter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968312984399026)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'da'
,p_message_text=>'Gruppevisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045544808399082)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'da'
,p_message_text=>'Betingelsestype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044436601399081)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'da'
,p_message_text=>'Overskrift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044605049399081)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'da'
,p_message_text=>'Justering af overskrift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054314614399088)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049871954399085)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Du kan inds\00E6tte, opdatere og slette data direkte i dette interaktive gitter.</p>'),
'',
unistr('<p>Inds\00E6t en ny r\00E6kke ved at klikke p\00E5 knappen Tilf\00F8j r\00E6kke.</p>'),
'',
unistr('<p>Rediger eksisterende data ved at dobbeltklikke p\00E5 en specifik celle. For st\00F8rre redigeringsarbejde skal du klikke p\00E5 Rediger for at g\00E5 i redigeringstilstand. I redigeringstilstand kan du enkeltklikke eller bruge tastaturet til at redigere specifik')
||'ke celler.</p>',
'',
unistr('<p>Brug menuen \00C6ndr til at duplikere og slette r\00E6kker. Du kan aktivere menuen \00C6ndr ved at bruge afkrydsningsfelterne til at v\00E6lge en eller flere r\00E6kker.</p>'),
'',
unistr('<p>Dupliker en valgt r\00E6kke ved at klikke p\00E5 menuen \00C6ndr og v\00E6lge Duplikerede r\00E6kker. Slet en valgt r\00E6kke ved at klikke p\00E5 menuen \00C6ndr og v\00E6lge Slet r\00E6kke.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051990447399087)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'da'
,p_message_text=>'Redigeringsmuligheder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052070118399087)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Et interaktivt gitter pr\00E6senterer et s\00E6t data i en s\00F8gbar rapport, der kan tilpasses. Du kan udf\00F8re talrige operationer for at begr\00E6nse det antal records, der returneres, og \00E6ndre den m\00E5de, som dataene vises p\00E5.</p>'),
'',
unistr('<p>Brug feltet S\00F8g til at filtrere de returnerede records. Klik p\00E5 Handlinger for at f\00E5 adgang til talrige valgmuligheder for modificering af rapportlayoutet, eller brug menuerne Kolonneoverskrift p\00E5 viste kolonner.</p>'),
'',
unistr('<p>Brug rapportindstillinger til at gemme dine tilpasninger af en rapport. Du kan ogs\00E5 downloade dataene fra rapporten til en ekstern fil eller sende dataene via e-mail til dig selv eller andre.</p>'),
'',
unistr('<p>Se "Using Interactive Grids" i <em>Oracle Application Express End User''s Guide</em> for at f\00E5 flere oplysninger.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051725722399086)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'da'
,p_message_text=>'Oversigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049796301399085)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Du kan tilpasse det interaktive gitter til at vise data p\00E5 forskellige m\00E5der ved hj\00E6lp af de indbyggede funktioner.</p>'),
'',
unistr('<p>Brug menuen Kolonneoverskrift eller Handlinger til at bestemme, hvilke kolonner der skal vises i hvilken r\00E6kkef\00F8lge, og fastfryse kolonner. Du kan ogs\00E5 definere forskellige datafiltre og sortere de data, der returneres.</p>'),
'',
unistr('<p>Brug knappen Vis (ud for feltet S\00F8g) til at \00E5bne andre datavisninger, som kan v\00E6re defineret af applikationsudvikleren. Du kan ogs\00E5 oprette et diagram eller se et eksisterende diagram.</p>  '),
'',
unistr('<p><em>Bem\00E6rk: Klik p\00E5 <strong>Hj\00E6lp</strong> i de interaktive gitterdialogbokse for at f\00E5 mere detaljerede oplysninger om den valgte funktion.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051836265399087)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'da'
,p_message_text=>'Rapporteringsmuligheder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001581917399050)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til interaktivt gitter')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048626850399084)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at aggregere kolonner. Aggregerede v\00E6rdier vises under dataene eller under hvert brud, hvis kontrolbrud er defineret.</p>'),
'',
'<p><strong>Aggregeringsliste</strong><br>',
unistr('Aggregeringslisten viser definerede aggregeringer. Du kan deaktivere en eksisterende aggregering ved at frav\00E6lge den.<br>'),
unistr('Klik p\00E5 Tilf\00F8j ( &plus; ) for at oprette en ny aggregering eller Slet ( &minus; ) for at fjerne en eksisterende aggregering.</p>'),
'',
'<p><strong>Aggregeringsindstillinger</strong><br>',
unistr('Brug formularen i h\00F8jre side til at definere aggregeringen.<br>'),
unistr('V\00E6lg kolonnenavnet og aggregeringstypen.<br>'),
unistr('Indtast eventuelt et v\00E6rkst\00F8jstip til aggregeringen.<br>'),
unistr('Hvis du har defineret et kontrolbrud, vil valg af <strong>Vis overordnet v\00E6rdi</strong> vise overordnet gennemsnit, total eller lignende v\00E6rdi under dataene.</p>'),
'',
unistr('<p><em>Bem\00E6rk: \00C5bn dialogboksen Aggregering i menuen Handlinger eller ved at klikke p\00E5 kolonneoverskriften og Sum ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050830656399086)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til aggregering')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049306521399085)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Brug denne dialogboks til at definere et diagram, der vises som en separat datavisning.<br>',
unistr('V\00E6lg en diagramtype og diagramattributter.</p>'),
'<p><strong>Diagramattributter</strong></br>',
unistr('De tilg\00E6ngelige diagramattributter varierer afh\00E6ngigt af diagramtypen.</p>'),
'<p>',
'<ul>',
unistr('  <li>V\00E6lg den kolonne, der indeholder v\00E6rdien for attributten:'),
'    <ul>',
'      <li>Etiket - Teksten til hvert datapunkt.</li>',
unistr('      <li>V\00E6rdi - De data, som skal plottes.</li>'),
unistr('      <li>Serie - Til at definere din dynamiske foresp\00F8rgsel p\00E5 flere serier.</li>'),
unistr('      <li>\00C5bne - Den daglige aktie\00E5bningskurs (kun Aktie).</li>'),
'      <li>Lukke - Den daglige aktielukkekurs (kun Aktie).</li>',
unistr('      <li>H\00F8j - Den h\00F8jeste v\00E6rdi (kun Interval og Aktie).</li>'),
unistr('      <li>Lav - Den laveste v\00E6rdi (kun Interval og Aktie).</li>'),
unistr('      <li>Volumen - Den daglige aktiem\00E6ngde (kun Aktie).</li>'),
unistr('      <li>M\00E5l - M\00E5lv\00E6rdien (kun Tragt).</li>'),
unistr('      <li>X - V\00E6rdien p\00E5 x-aksen (kun Boble og Punkt).</li>'),
unistr('      <li>Y - V\00E6rdien p\00E5 y-aksen (kun Boble og Punkt).</li>'),
unistr('      <li>Z - S\00F8jlens bredde eller boblens radius (kun S\00F8jle, Boble og Interval).</li>'),
'    </ul>',
'  </li>',
'  <li>Retning - Lodret eller vandret.</li>',
unistr('  <li>Aggregering - V\00E6lg, hvordan diagramv\00E6rdierne skal aggregeres.</li>'),
'  <li>Stablet - Angiv, om dataelementer er stablet.</li>',
unistr('  <li>Sorter efter - Sorter efter etikketen eller v\00E6rdi(er).'),
'    <ul>',
unistr('      <li>R\00E6kkef\00F8lge - Sorter efter stigende eller faldende v\00E6rdier.</li>'),
unistr('      <li>NULL-v\00E6rdier - Angiv, hvordan records med NULL-v\00E6rdier sorteres i forhold til records med ikke-NULL-v\00E6rdier.</li>'),
'    </ul>',
'  </li>',
'  <li>Decimalpladser</li>',
unistr('  <li>Titel p\00E5 etiketaksen</li>'),
unistr('  <li>Titel p\00E5 v\00E6rdiaksen</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051297747399086)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til diagrammer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048350114399084)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at v\00E6lge, hvilke kolonner der skal vises i hvilken r\00E6kkef\00F8lge.</p>'),
'',
unistr('<p>Skjul en kolonne ved at frav\00E6lge den.<br>'),
unistr('Reorganiser kolonner ved at klikke p\00E5 Flyt op ( &uarr; ) eller Flyt ned ( &darr; ).<br>'),
unistr('Brug rullev\00E6lgeren til at vise Alle kolonner, Viste kolonner eller Ikke viste kolonner.</p>'),
'',
'<p>Du kan bruge formularen til at angive minimumbredden af en kolonne i pixel.</p>',
'',
unistr('<p><em>Bem\00E6rk: Du kan ogs\00E5 reorganisere de viste kolonner ved at klikke p\00E5 tr\00E6kh\00E5ndtaget (i starten af kolonneoverskriften) og tr\00E6kke kolonnen mod venstre eller h\00F8jre. Du kan ogs\00E5 \00E6ndre kolonnebredden af de viste kolonner ved at v\00E6lge kolonneseparato')
||unistr('ren mellem overskrifterne og flytte den mod venstre eller h\00F8jre.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051177854399086)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til kolonner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048754377399084)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at definere flere kolonner baseret p\00E5 matematiske og funktionelle beregninger, der er udf\00F8rt p\00E5 eksisterende kolonner.</p>'),
'',
'<p><strong>Beregningsliste</strong><br>',
unistr('Beregningslisten viser definerede beregninger. Deaktiver en eksisterende beregning ved at frav\00E6lge den.<br>'),
unistr('Klik p\00E5 Tilf\00F8j ( &plus; ) for at tilf\00F8je en ny beregning eller Slet ( &minus; ) for at fjerne en eksisterende beregning.</p>'),
'',
'<p><strong>Beregningsindstillinger</strong><br>',
'Brug formularen til at definere beregningen.<br>',
'Indtast kolonnedetaljer som for eksempel overskrift, etiket og udvalgte justeringsindstillinger.<br> ',
unistr('Brug tekstomr\00E5det Udtryk til at indtaste kolonne(r) og tilknyttede funktioner for beregningen.<br>'),
unistr('V\00E6lg den \00F8nskede datatype og eventuelt en formatmaske for den nye kolonne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050701948399086)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til beregning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049010700399084)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at definere et kontrolbrud p\00E5 en eller flere kolonner.</p>'),
'',
'<p><strong>Kontrolbrudsliste</strong><br>',
unistr('Kontrolbrudslisten viser definerede kontrolbrud. Deaktiver en eksisterende kolonne med kontrolbrud ved at frav\00E6lge den.<br>'),
unistr('Klik p\00E5 Tilf\00F8j ( &plus; ) for at medtage en ny kolonne i kontrolbruddet eller Slet ( &minus; ) for at fjerne en eksisterende kolonne fra kontrolbruddet.<br>'),
unistr('Hvis du vil omarrangere kolonner, skal du klikke p\00E5 Flyt op ( &uarr; ) eller Flyt ned ( &darr; ) for at flytte den valgte kolonne op eller ned i forhold til andre kolonner.</p>'),
'',
'<p><strong>Indstillinger for kontrolbrud</strong><br>',
'Brug formularen til at definere kolonnen med kontrolbrud.<br>',
unistr('V\00E6lg en kolonne med kontrolbrud, sorteringsr\00E6kkef\00F8lgen, og hvordan NULL-kolonner skal arrangeres (kolonner uden en v\00E6rdi).</p>'),
'',
unistr('<p><em>Bem\00E6rk: Under visning af det interaktive gitter kan du definere et kontrolbrud ved at klikke p\00E5 en kolonneoverskrift og v\00E6lge kontrolbrudsikonet.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050424317399085)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til kontrolbrud')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049222618399085)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at downloade alle de aktuelle r\00E6kker til en ekstern fil. Filen vil kun indeholde de aktuelt viste kolonner ved hj\00E6lp af eventuelle filtre og sorteringer, der er anvendt p\00E5 dataene.</p>'),
'',
unistr('<p>V\00E6lg filformatet, og klik p\00E5 Download.<br>'),
unistr('Bem\00E6rk: CSV medtager ikke tekstformatering som for eksempel aggregeringer og kontrolbrud.</p>'),
'',
unistr('<p>Hvis du vil sende filen via e-mail, skal du v\00E6lge Send som e-mail og indtaste e-maildetaljerne (Modtager, Emne og Meddelelse).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050264511399085)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til download')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048479090399084)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at konfigurere datafiltre, som begr\00E6nser de returnerede r\00E6kker.</p>'),
'',
'<p><strong>Filterlisten</strong><br>',
unistr('Filterlisten viser definerede filtre. Deaktiver et eksisterende filter ved at frav\00E6lge det.<br>'),
unistr('Klik p\00E5 Tilf\00F8j ( &plus; ) for at oprette et nyt filter eller Slet ( &minus; ) for at fjerne et eksisterende filter.</p>'),
'',
'<p><strong>Filterindstillinger</strong><br>',
'Brug formularen til at definere filteregenskaberne.<br>',
unistr('V\00E6lg den \00F8nskede filtertype:<br>'),
unistr('&nbsp;&nbsp;&nbsp;R\00E6kke - filtrer efter et udtryk i enhver kolonne, der kan filtreres.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Kolonne - filtrer en specifik kolonne med en specificeret operator og v\00E6rdi.</p>'),
'',
unistr('<p><em>Bem\00E6rk: Under visning af det interaktive gitter kan du definere r\00E6kkefiltre ved at skrive direkte i feltet S\00F8g. Klik p\00E5 V\00E6lg kolonner, der skal s\00F8ges i, for at begr\00E6nse s\00F8gningen til en specifik kolonne. Alternativt kan du \00E5bne menuen Kolonneo')
||unistr('verskrift og v\00E6lge en v\00E6rdi for at oprette et kolonnefilter.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051090898399086)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til filtrering')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048880656399084)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at se dataene, som de var p\00E5 et tidligere tidspunkt.</p>'),
unistr('<p>Indtast antal minutter siden for at udf\00F8re flashback-foresp\00F8rgslen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050623796399086)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til flashback')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051396172399086)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til Grupper efter')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048986696399084)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at fremh\00E6ve r\00E6kker eller kolonner med data baseret p\00E5 den indtastede betingelse.</p>'),
'',
unistr('<p><strong>Fremh\00E6vningsliste</strong><br>'),
unistr('Fremh\00E6vningslisten viser definerede fremh\00E6vninger. Deaktiver en eksisterende fremh\00E6vning ved at frav\00E6lge den.<br>'),
unistr('Klik p\00E5 Tilf\00F8j ( &plus; ) for at oprette en ny fremh\00E6vning eller Slet ( &minus; ) for at fjerne en eksisterende fremh\00E6vning.</p>'),
'',
unistr('<p><strong>Fremh\00E6vningsindstillinger</strong><br>'),
unistr('Brug formularen til at definere fremh\00E6vningsegenskaberne.<br>'),
unistr('Indtast navnet, v\00E6lg R\00E6kke eller Kolonne, og v\00E6lg HTML-farvekoderne for baggrunden og teksten.<br>'),
unistr('V\00E6lg den \00F8nskede <strong>Betingelsestype</strong> for at fremh\00E6ve specifikke data:<br>'),
unistr('&nbsp;&nbsp;&nbsp;R\00E6kke - fremh\00E6v udtrykket i enhver kolonne.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Kolonne - fremh\00E6v i en specifik kolonne baseret p\00E5 den specificerede operator og v\00E6rdi.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050508337399086)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til fremh\00E6vning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049139038399084)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at gemme dine \00E6ndringer af det aktuelle gitterlayout og konfigurationen.<br>'),
unistr('Applikationsudviklere kan definere flere alternative rapportlayouts. Hvis det er tilladt, kan du og andre slutbrugere gemme en rapport som offentlig, s\00E5 rapporten bliver tilg\00E6ngelig for alle andre brugere af gitteret. Du kan ogs\00E5 gemme en rapport som')
||' en privat rapport, som kun du kan se.</p>',
unistr('<p>V\00E6lg mellem de tilg\00E6ngelige typer, og indtast et navn til den gemte rapport.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050302089399085)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Hj\00E6lp til rapport'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048542636399084)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brug denne dialogboks til at s\00E6tte visningsr\00E6kkef\00F8lgen.</p>'),
'',
'<p><strong>Sorteringsliste</strong><br>',
'Dialogboksen Sorter viser en liste over konfigurerede sorteringsregler.<br>',
unistr('Klik p\00E5 Tilf\00F8j ( &plus; ) for at oprette en sorteringskolonne eller Slet ( &minus; ) for at fjerne en sorteringskolonne.<br>'),
unistr('Klik p\00E5 Flyt op ( &uarr; ) og Flyt ned ( &darr; ) for at flytte den valgte sorteringskolonne op og ned i forhold til de andre sorteringskolonner.</p>'),
'',
'<p><strong>Sorteringsindstillinger</strong><br>',
unistr('V\00E6lg en sorteringskolonne, sorteringsr\00E6kkef\00F8lgen, og hvordan NULL-kolonner skal arrangeres (kolonner uden en v\00E6rdi).</p>'),
'',
unistr('<p><em>Bem\00E6rk: Data kan sorteres efter kolonner, der ikke er vist, men det er ikke sikkert, at alle kolonner kan sorteres.</em><br>'),
unistr('<em>Viste kolonner kan sorteres ved at trykke p\00E5 Pil op (stigende) eller Pil ned (faldende) i slutningen af kolonneoverskrifterne. Hvis du vil tilf\00F8je en efterf\00F8lgende kolonne i en eksisterende sortering, skal du holde Shift-tasten nede, mens du klik')
||unistr('ker p\00E5 Pil op eller Pil ned.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050944079399086)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til sortering')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111050134777399085)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til abonnement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002432241399051)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'da'
,p_message_text=>'Skjul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969271780399027)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037208661399076)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('H\00F8j')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038039216399076)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'da'
,p_message_text=>'Vandret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995475855399046)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'da'
,p_message_text=>'timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000435444399050)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'da'
,p_message_text=>'Ikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968199432399026)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'da'
,p_message_text=>'Ikonvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993641238399045)
,p_name=>'APEX.IG.IN'
,p_message_language=>'da'
,p_message_text=>'i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002018255399051)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'da'
,p_message_text=>'Inaktiv indstilling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002101148399051)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'Inaktive indstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009779827399056)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'da'
,p_message_text=>'Der opstod en intern fejl under behandling af den interaktive gitteranmodning.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905597729398981)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Kolonnefiltertypen "%0" underst\00F8ttes ikke for kolonnen "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049947597399085)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt datoformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024100636399067)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Interaktivt gitter underst\00F8tter ikke definition af et filter p\00E5 kolonnen %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024024981399067)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'da'
,p_message_text=>'%0 er ikke en gyldig filtertype til definition af et interaktivt gitterfilter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910683487398985)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt talformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052658146399087)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'da'
,p_message_text=>'Ugyldig indstilling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052702848399087)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'Ugyldige indstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043786608399081)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'da'
,p_message_text=>'Sorter efter er sat til %0, men ingen kolonne er valgt for %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041090693399079)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig v\00E6rdi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036169318399075)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'da'
,p_message_text=>'Ikke vist'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994471687399045)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'da'
,p_message_text=>'i de sidste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994602871399045)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('i de n\00E6ste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993544926399045)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>'er ikke tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993477326399045)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'da'
,p_message_text=>'er tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044570762399081)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'da'
,p_message_text=>'Etiket'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036576274399075)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Etiket'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040419520399078)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'da'
,p_message_text=>'Sidste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983700115399038)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'da'
,p_message_text=>'Sidste dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983935241399038)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'da'
,p_message_text=>'Sidste time'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984494253399038)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'da'
,p_message_text=>'Sidste minut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983416154399037)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('Sidste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983503071399037)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'da'
,p_message_text=>'Sidste uge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983662397399037)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'da'
,p_message_text=>'Sidste %0 dage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983841900399038)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'da'
,p_message_text=>'Sidste %0 timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984512127399038)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'da'
,p_message_text=>'Sidste %0 minutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984303046399038)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('Sidste %0 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984206039399038)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'da'
,p_message_text=>'Sidste %0 uger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983243183399037)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('Sidste %0 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983308277399037)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('Sidste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044775634399081)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'da'
,p_message_text=>'Cellejustering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044818637399081)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'da'
,p_message_text=>'Brug gruppe til'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994085715399045)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'da'
,p_message_text=>'mindre end'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994125560399045)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'da'
,p_message_text=>'mindre end eller lig med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038614940399077)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'da'
,p_message_text=>'Linje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038753133399077)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'da'
,p_message_text=>'Linje med areal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045174855399082)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'da'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037336523399076)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Lav'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047743549399083)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'da'
,p_message_text=>'Adskil flere adresser med kommaer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995251564399046)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'da'
,p_message_text=>'matcher almindeligt udtryk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019614356399063)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'da'
,p_message_text=>'Maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055277367399089)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019808638399064)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'da'
,p_message_text=>'Median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055352080399089)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019516142399063)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'da'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995363436399046)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'da'
,p_message_text=>'minutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020390384399064)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'da'
,p_message_text=>'Minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055179180399089)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995763810399046)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002308616399051)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'da'
,p_message_text=>unistr('Dataene indeholder mere end %0 r\00E6kker, hvilket overskrider det tilladte maksimumantal. Anvend flere filtre for at se resultaterne.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029002377399070)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('Regions statiske ID skal v\00E6re angivet, da siden indeholder flere interaktive gitre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998447542399048)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'da'
,p_message_text=>'Navn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998642647399048)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'da'
,p_message_text=>'Navngivet rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982630615399037)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste dag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982428762399037)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste time')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984606625399038)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982936033399037)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982837409399037)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste uge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982701720399037)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 dage')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110982583155399037)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 timer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984770425399038)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 minutter')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984051988399038)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984184175399038)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 uger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983117504399037)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110983064856399037)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994371249399045)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'da'
,p_message_text=>'ikke mellem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993314497399044)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'da'
,p_message_text=>'er ikke lig med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059500803399092)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Region med ID''et %0 er ikke en Interaktiv gitterregion eller findes ikke i applikationen %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993713722399045)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'da'
,p_message_text=>'ikke i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994546585399045)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'da'
,p_message_text=>'ikke i de sidste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110994767691399046)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('ikke i de n\00E6ste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002229037399051)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'da'
,p_message_text=>'Ingen data blev fundet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040280075399078)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'da'
,p_message_text=>unistr('NULL-v\00E6rdier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045324694399082)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'da'
,p_message_text=>'Numerisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040526703399078)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'da'
,p_message_text=>'Fra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040614843399078)
,p_name=>'APEX.IG.ON'
,p_message_language=>'da'
,p_message_text=>'Til'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992595971399044)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'da'
,p_message_text=>'For 1 minut siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048216293399084)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'da'
,p_message_text=>unistr('\00C5bn farvev\00E6lger: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037007063399076)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('\00C5bne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999522992399049)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'da'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036408882399075)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'da'
,p_message_text=>'Retning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038887808399077)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'da'
,p_message_text=>'Cirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111000860166399050)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'da'
,p_message_text=>'Pivoter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110968464217399027)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'da'
,p_message_text=>'Pivotvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111048177507399084)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'da'
,p_message_text=>unistr('Adskil v\00E6rdier med "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111038911606399077)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'da'
,p_message_text=>'Polar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044263937399081)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'da'
,p_message_text=>'Centreret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044368278399081)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'da'
,p_message_text=>'Slut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111044161126399081)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'da'
,p_message_text=>'Start'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998708886399048)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'da'
,p_message_text=>unistr('Prim\00E6r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999027862399049)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'da'
,p_message_text=>unistr('Prim\00E6r standard')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015584316399061)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'da'
,p_message_text=>unistr('Prim\00E6r rapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897770497398975)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'da'
,p_message_text=>unistr('Inkluder tilg\00E6ngelighedstags')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896448792398974)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'da'
,p_message_text=>'Liggende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896508283398975)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'da'
,p_message_text=>unistr('St\00E5ende')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896398963398974)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'da'
,p_message_text=>'Sideretning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896213942398974)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'da'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896113994398974)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'da'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897845227398975)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'da'
,p_message_text=>'Tilpasset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895992728398974)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'da'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895864795398974)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'da'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896033293398974)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'da'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895731323398974)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'da'
,p_message_text=>unistr('Sidest\00F8rrelse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885973039398967)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'da'
,p_message_text=>'Fjern RTF-formatering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039073900399077)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'da'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039187682399077)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'da'
,p_message_text=>'Interval'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049428712399085)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'da'
,p_message_text=>'Opfrisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003089514399052)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('Opfrisk r\00E6kke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001833958399051)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Opfrisk r\00E6kker')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007032570399054)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Interaktiv gitterregion findes ikke i applikationen %0, side %1 og region %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969929207399028)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'da'
,p_message_text=>'Fjern %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998124755399048)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'da'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058778994399091)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'da'
,p_message_text=>'Rapport slettet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058447351399091)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'da'
,p_message_text=>'Alternativ rapport gemt for alle brugere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058376161399091)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'da'
,p_message_text=>'Standardrapport gemt for alle brugere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058655333399091)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'da'
,p_message_text=>'Privat rapport gemt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058548868399091)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'da'
,p_message_text=>'Offentlig rapport gemt for alle brugere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111007103497399055)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Gemt interaktivt gitter med navnet %0 findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992460550399044)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'da'
,p_message_text=>'Rapporter data, som de var for %0 minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992378256399044)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'da'
,p_message_text=>'Rapporter data, som de var for 1 minut siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932049142399000)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Interaktiv gitterrapport findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051673571399086)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'da'
,p_message_text=>'Rapport - Rediger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006910529399054)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Gemt interaktivt gitter med ID''et %0 findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111051517285399086)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'da'
,p_message_text=>'Rapport - Gem som'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970096947399028)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'Rapportindstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059628272399092)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Gemt interaktivt gitter med det statiske ID %0 findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054558853399088)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'da'
,p_message_text=>'Rapportvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969116574399027)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'da'
,p_message_text=>'Nulstil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003128451399052)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'da'
,p_message_text=>unistr('Tilbagef\00F8r \00E6ndringer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001908397399051)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Tilbagef\00F8r r\00E6kker')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999135208399049)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998049812399048)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kker pr. side')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059216114399092)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkehandlinger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060486368399093)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'da'
,p_message_text=>unistr('Handlinger for r\00E6kke %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110969465088399027)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'da'
,p_message_text=>'Gem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012177304399058)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'da'
,p_message_text=>'gemt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967629060399026)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'da'
,p_message_text=>'Gemte rapporter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967778406399026)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'da'
,p_message_text=>'Standard'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942256431399007)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'da'
,p_message_text=>'En gemt rapport med navnet %0 findes allerede. Indtast et nyt navn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967891593399026)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'da'
,p_message_text=>'Privat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967982567399026)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'da'
,p_message_text=>'Offentlig'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054243670399088)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'da'
,p_message_text=>'Gem som'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001242232399050)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'Gem rapportindstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039275889399077)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'da'
,p_message_text=>'Punkt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967599315399026)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046503641399083)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g: alle tekstkolonner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967476947399026)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g i: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045743746399082)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g: fuld tekst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992273762399044)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g efter ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035807176399075)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'da'
,p_message_text=>unistr('- V\00E6lg -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976023577399032)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'da'
,p_message_text=>'Valg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028740989399070)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg 1 r\00E6kke i masteromr\00E5det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967381745399026)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg kolonner, der skal s\00F8ges i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058957291399092)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'da'
,p_message_text=>'Handlinger for valg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976201539399032)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'da'
,p_message_text=>'Cellevalg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976120863399032)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkevalg')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047136986399083)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'da'
,p_message_text=>'Send som e-mail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039654458399078)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Serie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965303289399024)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'da'
,p_message_text=>'Vis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017951528399062)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('Vis overordnet v\00E6rdi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002746716399051)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'da'
,p_message_text=>unistr('Enkeltr\00E6kkevisning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001026070399050)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'da'
,p_message_text=>'Sortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039716166399078)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'da'
,p_message_text=>'Sorter efter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059301007399092)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Du kan kun definere \00E9n sortering pr. kolonne.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059166408399092)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'da'
,p_message_text=>unistr('Menuen \00C6ndr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111040791020399078)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'da'
,p_message_text=>'Stablet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995064417399046)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'da'
,p_message_text=>'starter med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039302268399077)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'da'
,p_message_text=>'Aktie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960371914399021)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('Str\00E6k kolonnebredder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111001436132399050)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'da'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111019484918399063)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'da'
,p_message_text=>'Sum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060632203399093)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'da'
,p_message_text=>'Interaktiv gitterrapport: %0, Visning: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111054653510399089)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'da'
,p_message_text=>'Overordnet sum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037575706399076)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043999873399081)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'da'
,p_message_text=>'Tekstfarve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970162551399028)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'da'
,p_message_text=>'Skift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017844309399062)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rkt\00F8jstip')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110998224330399048)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'da'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111002670901399051)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'da'
,p_message_text=>unistr('Oph\00E6v fastfrysning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999703131399049)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'da'
,p_message_text=>'Enhed'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046939440399083)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'da'
,p_message_text=>unistr('Der er \00E6ndringer, som ikke er gemt. Vil du forts\00E6tte?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110999693847399049)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036686969399076)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041513137399079)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('En v\00E6rdi er p\00E5kr\00E6vet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026429897399068)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi (tidszone kan ikke \00E6ndres)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045424035399082)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'da'
,p_message_text=>'Tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037948030399076)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'da'
,p_message_text=>'Lodret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997763775399048)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'da'
,p_message_text=>'Vis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035943731399075)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'da'
,p_message_text=>'Vist'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111037429894399076)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Volumen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995642191399046)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'da'
,p_message_text=>'uger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036075158399075)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'da'
,p_message_text=>'Mindste kolonnebredde (pixel)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986898519399040)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'da'
,p_message_text=>'%0 mellem %1 og %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986568291399040)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'da'
,p_message_text=>'%0 indeholder %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986665490399040)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'da'
,p_message_text=>'%0 indeholder ikke %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964751012399024)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'da'
,p_message_text=>'%0 starter ikke med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985314153399039)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'da'
,p_message_text=>'%0 er lig med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985546005399039)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'da'
,p_message_text=>unistr('%0 er st\00F8rre end %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985685822399039)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'da'
,p_message_text=>unistr('%0 er st\00F8rre end eller lig med %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986397951399039)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'da'
,p_message_text=>'%0 i %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987509420399040)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'da'
,p_message_text=>'%0 inden for de sidste %1 dage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987320507399040)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'da'
,p_message_text=>'%0 i de sidste %1 timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987155054399040)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'da'
,p_message_text=>'%0 i de sidste %1 minutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987915269399041)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i de sidste %1 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987769594399040)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'da'
,p_message_text=>'%0 i de sidste %1 uger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988161127399041)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i de sidste %1 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987455405399040)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'da'
,p_message_text=>'%0 inden for den sidste dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987239118399040)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'da'
,p_message_text=>'%0 i den sidste time'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987055701399040)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'da'
,p_message_text=>'%0 i det sidste minut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987883925399041)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i den sidste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110987642967399040)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'da'
,p_message_text=>'%0 i den sidste uge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988016439399041)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i det sidste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989991082399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 inden for de n\00E6ste %1 dage')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989703647399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i de n\00E6ste %1 timer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989551756399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i de n\00E6ste %1 minutter')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990325240399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i de n\00E6ste %1 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990197923399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i de n\00E6ste %1 uger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990592113399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i de n\00E6ste %1 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989842589399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'da'
,p_message_text=>unistr('%0 inden for den n\00E6ste dag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989684126399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i den n\00E6ste time')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989432243399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i det n\00E6ste minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990256135399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i den n\00E6ste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990033705399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i den n\00E6ste uge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990437974399042)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 i det n\00E6ste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986076967399039)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>'%0 er ikke tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985922101399039)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'da'
,p_message_text=>'%0 er tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985789631399039)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'da'
,p_message_text=>'%0 er mindre end %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985886957399039)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'da'
,p_message_text=>'% er mindre end eller lig med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986134437399039)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'da'
,p_message_text=>'%0 som %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986731118399040)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'da'
,p_message_text=>'%0 matcher almindeligt udtryk %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992618286399044)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'da'
,p_message_text=>'For %0 minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986932544399040)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'da'
,p_message_text=>'%0 ikke mellem %1 og %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985482214399039)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'da'
,p_message_text=>'%0 er ikke lig med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986421207399040)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'da'
,p_message_text=>'%0 ikke i %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988784423399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'da'
,p_message_text=>'%0 ikke inden for de sidste %1 dage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988544763399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'da'
,p_message_text=>'%0 ikke i de sidste %1 timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988354404399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'da'
,p_message_text=>'%0 ikke i de sidste %1 minutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989181856399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i de sidste %1 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988905491399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'da'
,p_message_text=>'%0 ikke i de sidste %1 uger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989389217399042)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i de sidste %1 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988615625399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'da'
,p_message_text=>'%0 ikke inden for den sidste dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988499606399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'da'
,p_message_text=>'%0 ikke i den sidste time'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988270754399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'da'
,p_message_text=>'%0 ikke i det sidste minut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989035699399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i den sidste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110988877432399041)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'da'
,p_message_text=>'%0 ikke i den sidste uge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110989261963399042)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i det sidste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991130559399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke inden for de n\00E6ste %1 dage')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990910858399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i de n\00E6ste %1 timer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990703000399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i de n\00E6ste %1 minutter')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991563409399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i de n\00E6ste %1 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991384498399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i de n\00E6ste %1 uger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991793258399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i de n\00E6ste %1 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991040290399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke inden for den n\00E6ste dag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990804945399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i den n\00E6ste time')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110990606367399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i det n\00E6ste minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991444705399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i den n\00E6ste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991263113399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i den n\00E6ste uge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991678220399043)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 ikke i det n\00E6ste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110986280205399039)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'da'
,p_message_text=>'%0 ikke som %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993136106399044)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'da'
,p_message_text=>'%0 starter med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036797806399076)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'da'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995804668399046)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('\00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036838875399076)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036902041399076)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111045942585399082)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'da'
,p_message_text=>'Mandag den 12. januar 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046001983399082)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'da'
,p_message_text=>'Januar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046191980399082)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'da'
,p_message_text=>'for 16 timer siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111046255622399082)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'da'
,p_message_text=>'om 16 timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901265587398978)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig filtype. Underst\00F8ttede filtyper %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028143810399069)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'da'
,p_message_text=>'Gennemse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027851390399069)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027938217399069)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg filer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901018827398978)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'da'
,p_message_text=>unistr('Tr\00E6k og slip')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901430715398978)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'da'
,p_message_text=>unistr('Tr\00E6k og slip filer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902628995398979)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg en fil, eller slip en her.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902770611398979)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg eller slip filer her.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902851549398979)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg en fil, eller slip en her.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902917475398979)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg eller slip filer her.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901305072398978)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'da'
,p_message_text=>'%0 filer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901102627398978)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'da'
,p_message_text=>unistr('Fil er for stor. Maks. filst\00F8rrelse er %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888936013398969)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('Adresse p\00E5kr\00E6vet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887846036398968)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'da'
,p_message_text=>'By'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888228792398969)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'da'
,p_message_text=>'Landekode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887950761398968)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'da'
,p_message_text=>'Husnr.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888881707398969)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'da'
,p_message_text=>'Breddegrad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888748947398969)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'da'
,p_message_text=>unistr('L\00E6ngdegrad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888656865398969)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'da'
,p_message_text=>unistr('Vis p\00E5 kort')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888308680398969)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'da'
,p_message_text=>'Score'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888033517398968)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'da'
,p_message_text=>'Postnr.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888113681398968)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'da'
,p_message_text=>'Stat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887787658398968)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'da'
,p_message_text=>'Gade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887667408398968)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'da'
,p_message_text=>'Geokodningsresultater'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900263066398977)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'da'
,p_message_text=>'Geokodet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900310862398977)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'da'
,p_message_text=>'Ikke geokodet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888539240398969)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'da'
,p_message_text=>'Kort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110888473934398969)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'da'
,p_message_text=>'Ingen adresser fundet.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889007934398969)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('%0 er p\00E5kr\00E6vet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058885876399092)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lpetekst: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952219130399015)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'da'
,p_message_text=>'Markeret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952300451399015)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'da'
,p_message_text=>'Ikke markeret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898238870398976)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'da'
,p_message_text=>'#LABEL# er ikke i det gyldige interval fra %0 til %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898338618398976)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'da'
,p_message_text=>'#LABEL# er ikke et multiplum af %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897950779398976)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal matche v\00E6rdierne %0 og %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898175744398976)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'da'
,p_message_text=>'Nej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976482250399032)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'da'
,p_message_text=>'Fra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976593017399032)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'da'
,p_message_text=>'Til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898099517398976)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'da'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881476719398964)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j post')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010613252399057)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010716029399057)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'da'
,p_message_text=>'Fjern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881591269398964)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'da'
,p_message_text=>'Valgte poster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014478541399060)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'da'
,p_message_text=>'Avanceret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014740649399060)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'da'
,p_message_text=>'Annuller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014503293399060)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'da'
,p_message_text=>unistr('F\00E6lles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014869249399060)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'da'
,p_message_text=>'Live-skabelonvalg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015442532399060)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'da'
,p_message_text=>unistr('Skabelonvalg er ikke tilg\00E6ngelige, fordi denne komponent ikke er gengivet p\00E5 siden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014377495399060)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'da'
,p_message_text=>'Ingen skabelonvalg blev fundet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014609755399060)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'da'
,p_message_text=>'Gem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889932175398970)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'da'
,p_message_text=>'Ryd cirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891768711398971)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'da'
,p_message_text=>'Tilpassede typografier har ikke gyldigt JSON-format.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890205237398970)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'da'
,p_message_text=>unistr('Afstandsv\00E6rkt\00F8j')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890011430398970)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'da'
,p_message_text=>'Tegn cirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882623949398965)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'da'
,p_message_text=>unistr('Facetteret s\00F8gning kr\00E6ver en datakilde p\00E5 regionsniveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885226180398966)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'da'
,p_message_text=>'Aktuel lokation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886378908398967)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'da'
,p_message_text=>unistr('F\00F8rste positionskoordinater er ugyldige.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883792874398965)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('F\00F8rste position skal v\00E6re en punktgeometri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886178527398967)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'da'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884760770398966)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'da'
,p_message_text=>'Lag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018041811399062)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'da'
,p_message_text=>'Lag: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889333586398969)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'da'
,p_message_text=>'Kort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882568375398964)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'da'
,p_message_text=>'Meddelelser'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886244512398967)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'da'
,p_message_text=>'miles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017054597399062)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'da'
,p_message_text=>unistr('Dataene indeholder mere end %0 r\00E6kker, hvilket overskrider det tilladte maksimumantal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884548571398966)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'da'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Vilk\00E5r</a> &nbsp;&nbsp; Kortdata &copy; 2017 HER')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883459770398965)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'da'
,p_message_text=>unistr('Datatypen SDO_GEOMETRY er ikke tilg\00E6ngelig i denne database.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884665179398966)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'da'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap-bidragydere </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884823797398966)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'da'
,p_message_text=>'Punkter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018128117399062)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'da'
,p_message_text=>'%0 punkter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890114337398970)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'da'
,p_message_text=>'Rektangelzoom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889862888398970)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'da'
,p_message_text=>'Fjern'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885157487398966)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'da'
,p_message_text=>'Nulstil retning til Nord'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965405421399024)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'da'
,p_message_text=>'Skift til 2D-tilstand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965551141399024)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'da'
,p_message_text=>'Skift til 3D-tilstand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889707405398970)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'da'
,p_message_text=>unistr('Sl\00E5 bem\00E6rkning om copyright til/fra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890358682398970)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'da'
,p_message_text=>'Samlet afstand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884992038398966)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'da'
,p_message_text=>'Zoom ind'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885043139398966)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'da'
,p_message_text=>'Zoom ud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012561176399058)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'da'
,p_message_text=>'Fed'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013482908399059)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'da'
,p_message_text=>'Billede'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013072376399059)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'da'
,p_message_text=>'Indbygget kode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026698479399068)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'da'
,p_message_text=>unistr('Inds\00E6t billede')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026799082399068)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'da'
,p_message_text=>unistr('Inds\00E6t link')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012674717399058)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'da'
,p_message_text=>'Kursiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027336103399069)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'da'
,p_message_text=>'Link'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013348145399059)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'da'
,p_message_text=>'Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013213677399059)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'da'
,p_message_text=>'Sorteret liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012798441399059)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'da'
,p_message_text=>'Eksempel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012812080399059)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'da'
,p_message_text=>'Intet at vise som eksempel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012916145399059)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'da'
,p_message_text=>'Gennemstreget'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013128137399059)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'da'
,p_message_text=>'Ikke-sorteret liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992099996399044)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'da'
,p_message_text=>'aktuel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111049526411399085)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'da'
,p_message_text=>'Flere...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110991941339399043)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'da'
,p_message_text=>unistr('Indl\00E6ser')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023760787399066)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'da'
,p_message_text=>'Meddelelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997043734399047)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re et tal, der er mindre end eller lig med %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997151266399047)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re et gyldigt tal.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997243012399047)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'da'
,p_message_text=>'#LABEL# matcher ikke talformatet %0 (eksempel: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996939819399047)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re et tal, der er st\00F8rre end eller lig med %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996825227399047)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal v\00E6re et tal mellem %0 og %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992127626399044)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'da'
,p_message_text=>unistr('\00E5bnes i nyt vindue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945374850399010)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'da'
,p_message_text=>'Denne side er allerede afsendt og kan ikke afsendes igen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927992108398997)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Applikation "%0" side "%1" blev ikke fundet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961796100399022)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('#LABEL# skal have en v\00E6rdi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905066312398981)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011033611399057)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'da'
,p_message_text=>'Luk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010960776399057)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'da'
,p_message_text=>'Find%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011228004399057)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011109534399057)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'da'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897148846398975)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'da'
,p_message_text=>unistr('Indtast et s\00F8geord p\00E5 mindst %0 tegn.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966671464399025)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'da'
,p_message_text=>unistr('Pop op-liste med v\00E6rdier: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897261780398975)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'da'
,p_message_text=>unistr('Indtast et s\00F8geord.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897038304398975)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'da'
,p_message_text=>'Ingen resultater fundet.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896996062398975)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'da'
,p_message_text=>'Fjern %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984838809399038)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8geord')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010809501399057)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021527166399065)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'da'
,p_message_text=>'Behandler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895510605398974)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('F\00F8j til startsk\00E6rm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891563534398971)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Din enhed eller browser ser ikke ud til at underst\00F8tte installationen af progressive webapps lige nu.</p>'),
unistr('    <p class="a-pwaDialog-intro">Hvis denne applikation allerede er installeret p\00E5 din enhed, skal du \00E5bne den fra din startsk\00E6rm.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891189563398971)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet. F\00F8j den til din startsk\00E6rm for at bruge den i fuld sk\00E6rm.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryk p\00E5 ikonet <strong>Menu</strong> i den nederste navigation</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryk p\00E5 <strong>Installer</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryk p\00E5 <strong>Tilf\00F8j</strong> for at bekr\00E6fte</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891208170398971)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet, der giver den bedste oplevelse i Chrome eller Edge.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryk p\00E5 ikonet <strong>Menu</strong> ved siden af adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryk p\00E5 <strong>Installer</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890842051398970)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet, der giver den bedste oplevelse i Safari.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryk p\00E5 ikonet <strong>Del</strong> i den nederste navigation</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryk p\00E5 <strong>\00C5bn i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890543761398970)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet. F\00F8j den til din startsk\00E6rm for at f\00E5 den bedste oplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryk p\00E5 ikonet <strong>Del</strong> ved siden af adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryk p\00E5 <strong>F\00F8j til startsk\00E6rm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryk p\00E5 <strong style="color:#007AE1;">Tilf\00F8j</strong> for at bekr\00E6fte</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890477236398970)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet. F\00F8j den til din startsk\00E6rm for at f\00E5 den bedste oplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryk p\00E5 ikonet <strong>Del</strong> i den nederste navigation</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Rul ned, og tryk p\00E5 <strong>F\00F8j til startsk\00E6rm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryk p\00E5 <strong style="color:#007AE1;">Tilf\00F8j</strong> for at bekr\00E6fte</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885424617398967)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet. F\00F8j det til din startsk\00E6rm for at f\00E5 den bedste oplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryk p\00E5 ikonet <strong>Mere</strong> ved siden af adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryk p\00E5 <strong>F\00F8j til startsk\00E6rm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryk p\00E5 <strong style="color:#007AE1;">Tilf\00F8j</strong> for at bekr\00E6fte</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890770554398970)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet. F\00F8j den til din startsk\00E6rm for at f\00E5 den bedste oplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryk p\00E5 ikonet <strong>Del</strong> ved siden af adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryk p\00E5 <strong>\00C5bn i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890675856398970)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet. F\00F8j den til din startsk\00E6rm for at f\00E5 den bedste oplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryk p\00E5 ikonet <strong>Del</strong> i den nederste navigation</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryk p\00E5 <strong>\00C5bn i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891433339398971)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet, der giver den bedste oplevelse i Chrome.</p>',
unistr('    <p class="a-pwaDialog-intro">Firefox underst\00F8tter ikke installation af webapps i \00F8jeblikket.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110890956575398970)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet, der giver den bedste oplevelse i Chrome eller Edge.</p>',
unistr('    <p class="a-pwaDialog-intro">Firefox underst\00F8tter ikke installation af webapps p\00E5 macOS i \00F8jeblikket.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891090298398971)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet, der giver den bedste oplevelse i Chrome eller Edge.</p>',
unistr('    <p class="a-pwaDialog-intro">Safari underst\00F8tter ikke installation af webapps p\00E5 macOS i \00F8jeblikket.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891371558398971)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Denne website har app-funktionalitet, der giver den bedste oplevelse i Chrome eller Edge.</p>',
unistr('    <p class="a-pwaDialog-intro">Firefox underst\00F8tter ikke installation af webapps p\00E5 Windows i \00F8jeblikket.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893825665398973)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Kan ikke oprette forbindelse</h1>',
'    <p>Du skal have forbindelse til internettet for at bruge denne app.</p>',
unistr('    <button type="button">Pr\00F8v igen</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893711928398973)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'da'
,p_message_text=>'Kan ikke oprette forbindelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033599138399073)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977976811399033)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'da'
,p_message_text=>'Heldags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056882341399090)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'da'
,p_message_text=>'Send invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056678199399090)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'da'
,p_message_text=>'Valgmuligheder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979740086399035)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'da'
,p_message_text=>'Dagsvisning af hele dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979515196399035)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'da'
,p_message_text=>'Dagsvisning af data med tid '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024447362399067)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'da'
,p_message_text=>'Dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018860105399063)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'da'
,p_message_text=>'Beskrivelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909433174398984)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'da'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909237681398984)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'da'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909134590398983)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'da'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909399544398984)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'da'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908833906398983)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'da'
,p_message_text=>'Slutdato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909037780398983)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'da'
,p_message_text=>'Begivenhedsnavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056788809399090)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'da'
,p_message_text=>'Invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024567391399067)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'da'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024291728399067)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027088753399069)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041317072399079)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'da'
,p_message_text=>'Ingen begivenheder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057030346399090)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'da'
,p_message_text=>'Rediger en eksisterende begivenhed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056993982399090)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'da'
,p_message_text=>'Sender en invitation via e-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027110808399069)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'da'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035143382399074)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'da'
,p_message_text=>'Send e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034933193399074)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'da'
,p_message_text=>'Send e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057727479399091)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('Alle felter er p\00E5kr\00E6vet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057625246399091)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'da'
,p_message_text=>'Send invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056503503399090)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'da'
,p_message_text=>'Emne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035071657399074)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'da'
,p_message_text=>'Til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908959754398983)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'da'
,p_message_text=>'Startdato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032858940399073)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'da'
,p_message_text=>unistr('Formular p\00E5 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979321775399034)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'da'
,p_message_text=>'Tid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027225254399069)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'da'
,p_message_text=>'I dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025024182399067)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'da'
,p_message_text=>'Vis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024324372399067)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'da'
,p_message_text=>'Uge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979661686399035)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'da'
,p_message_text=>'Ugevisning af hele dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979436073399035)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'da'
,p_message_text=>'Ugevisning af data med tid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024945831399067)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('\00C5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024681254399067)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Kolonner...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024721246399067)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'da'
,p_message_text=>unistr('Indl\00E6s flere...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956884250399018)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'da'
,p_message_text=>'Tilbage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903188576398979)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'da'
,p_message_text=>unistr('Indl\00E6s flere...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905202699398981)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111024871717399067)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'da'
,p_message_text=>unistr('Indl\00E6s flere...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026952991399069)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Regions-ID''et %0 blev ikke fundet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905192318398981)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'da'
,p_message_text=>'Ingen data fundet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929276633398998)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'da'
,p_message_text=>'Kan ikke nulstille regionssideinddeling.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897435096398975)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under indstilling af regionssideinddeling.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018263556399062)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Kolonner...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026813777399069)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'da'
,p_message_text=>unistr('Regionstypen %0 underst\00F8ttes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897309708398975)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under gengivelse af regionen "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961890334399022)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('#COLUMN_HEADER# skal have en v\00E6rdi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056169299399090)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'da'
,p_message_text=>'%0, RTF-editor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963904341399023)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'da'
,p_message_text=>unistr('Rich Text HTML-markup overskrider elementets maksimuml\00E6ngde (faktisk %0, tilladt %1 tegn)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023839542399066)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'da'
,p_message_text=>'Slet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015632666399061)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'da'
,p_message_text=>'Dupliker'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013962364399059)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'da'
,p_message_text=>'Viste kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013882400399059)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Ekskluder NULL-v\00E6rdier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023982532399067)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977577617399033)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'da'
,p_message_text=>'Flyt ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977677567399033)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'da'
,p_message_text=>'Flyt op'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013687184399059)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014203008399060)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'da'
,p_message_text=>'Andre kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013706143399059)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'da'
,p_message_text=>'Forrige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014006006399059)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014188645399060)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke %0 af %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015706148399061)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'da'
,p_message_text=>'Opfrisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015838767399061)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'da'
,p_message_text=>unistr('Tilbagef\00F8r \00E6ndringer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111013512830399059)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'da'
,p_message_text=>'Menuen Indstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974592941399031)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'da'
,p_message_text=>'For eksempel %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882037524398964)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'da'
,p_message_text=>unistr('Log p\00E5 igen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881901097398964)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'da'
,p_message_text=>'Din session er afsluttet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882127575398964)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'da'
,p_message_text=>unistr('Forl\00E6ng')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881720244398964)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'da'
,p_message_text=>unistr('Din session afsluttes klokken %0. Vil du forl\00E6nge den?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881801761398964)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'da'
,p_message_text=>unistr('Din session afsluttes klokken %0 og kan ikke forl\00E6nges. Gem alt arbejde nu for at undg\00E5 at miste data')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034731092399074)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af kode til oprydning af databasesession.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927829638398997)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under behandling af kode til ops\00E6tning af databasesession.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110901996043398978)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'da'
,p_message_text=>'Din session er afsluttet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033676556399073)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'da'
,p_message_text=>unistr('Luk denne dialogboks, og tryk p\00E5 din browsers Genindl\00E6s-knap for at f\00E5 en ny session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052944103399087)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'da'
,p_message_text=>'Klik <a href="%0">her</a> for at oprette en ny session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939543555399005)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'da'
,p_message_text=>'Session ikke gyldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979001046399034)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'da'
,p_message_text=>'Ingen dynamiske roller kunne aktiveres i Real Application Security-sessionen for brugeren "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925754690398995)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'ERR-99900 Kunne ikke oprette entydigt sessions-ID: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942008011399007)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'da'
,p_message_text=>unistr('Overtr\00E6delse af sessionstilstandsbeskyttelse: Det kan skyldes manuel \00E6ndring af det beskyttede sideelement %0. Hvis du er usikker p\00E5 \00E5rsagen til denne fejl, skal du kontakte systemadministratoren for at f\00E5 hj\00E6lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061104991399093)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'da'
,p_message_text=>unistr('Overtr\00E6delse af sidebeskyttelse: Det kan skyldes afsendelse af en side, der ikke er f\00E6rdigindl\00E6st, eller en manuel \00E6ndring af beskyttede sideelementer. Kontakt applikationsadministratoren for at f\00E5 yderligere hj\00E6lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060104824399092)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 indeholder et af f\00F8lgende ugyldige tegn &<>"/;,*|=% eller --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060292316399093)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'da'
,p_message_text=>unistr('%0 indeholder et af f\00F8lgende ugyldige tegn &<>"/;,*|=% eller -- eller linjeskift.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059967082399092)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'da'
,p_message_text=>'%0 indeholder specialtegn. Kun tegnene a-Z, 0-9 og mellemrum er tilladt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111060049319399092)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'da'
,p_message_text=>'%0 indeholder <, > eller ", som er ugyldige tegn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904183155398980)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'da'
,p_message_text=>unistr('Ingen kontrolsum blev angivet for at vise behandling af en side, der kr\00E6ver en kontrolsum, n\00E5r en eller flere v\00E6rdier for anmodning, rydning af cache eller argument videregives som parametre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936998295399004)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'da'
,p_message_text=>unistr('Overtr\00E6delse af sessionstilstandsbeskyttelse: Det kan skyldes manuel \00E6ndring af en URL, der indeholder en kontrolsum, eller brug af et link med forkert eller manglende kontrolsum. Hvis du er usikker p\00E5 \00E5rsagen til denne fejl, skal du kontakte systema')
||unistr('dministratoren for at f\00E5 hj\00E6lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111014943927399060)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'da'
,p_message_text=>unistr('Sl\00E5 h\00F8j kontrasttilstand fra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015052787399060)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'da'
,p_message_text=>unistr('Sl\00E5 h\00F8j kontrasttilstand til')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933661073399001)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'da'
,p_message_text=>'Nederst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933880984399001)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'da'
,p_message_text=>'Ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933903095399001)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'da'
,p_message_text=>'Flyt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934020998399001)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'da'
,p_message_text=>'Flyt alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934144682399001)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'da'
,p_message_text=>'Fjern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934215595399002)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'da'
,p_message_text=>'Fjern alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934398167399002)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'da'
,p_message_text=>'Nulstil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933561521399001)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'da'
,p_message_text=>unistr('\00D8verst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933794706399001)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'da'
,p_message_text=>'Op'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042667394399080)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'da'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043325025399080)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'om %0 dag(e)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042510171399080)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'da'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043463431399080)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'om %0 time(r)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042396052399080)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'da'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043527586399080)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'om %0 minut(ter)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042953728399080)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'da'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043185038399080)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>unistr('om %0 m\00E5ned(er)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042432408399080)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'da'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043213403399080)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'om %0 sekund(er)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042752288399080)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'da'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043661960399081)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'om %0 uge(r)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042849943399080)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'da'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111043003512399080)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>unistr('om %0 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882937386398965)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'da'
,p_message_text=>'[Linje]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883369530398965)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'da'
,p_message_text=>'[Flere linjer]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883127179398965)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'da'
,p_message_text=>'[Flere punkter]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883526579398965)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'da'
,p_message_text=>'[Flere polygoner]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883634608398965)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'da'
,p_message_text=>'[Geometrisk objekt]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882860853398965)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'da'
,p_message_text=>'[Punkt (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883006003398965)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'da'
,p_message_text=>'[Polygon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960202877399021)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'da'
,p_message_text=>'Skjul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960173208399020)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'da'
,p_message_text=>'Gendan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006639175399054)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'da'
,p_message_text=>unistr('Ryd bed\00F8mmelse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996513007399047)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'da'
,p_message_text=>unistr('%0 er ikke i det gyldige bed\00F8mmelsesinterval fra 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996678318399047)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'da'
,p_message_text=>'%0 er ikke numerisk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992723518399044)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'da'
,p_message_text=>unistr('Meddelelse om udf\00F8relse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055811273399089)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055758464399089)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'da'
,p_message_text=>'Forrige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041401968399079)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rkt\00F8jslinje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056228288399090)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'da'
,p_message_text=>'Udvid/skjul navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056335367399090)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'da'
,p_message_text=>'Udvid/skjul sidekolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965921006399025)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'da'
,p_message_text=>'Hovednavigering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972995013399030)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'da'
,p_message_text=>'1 dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972762877399030)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'da'
,p_message_text=>'1 time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973058814399030)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'da'
,p_message_text=>'%0 dage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972854634399030)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'da'
,p_message_text=>'%0 timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972621151399030)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'da'
,p_message_text=>'%0 minutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973209645399030)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'da'
,p_message_text=>'%0 uger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110973132652399030)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'da'
,p_message_text=>'1 uge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059438596399092)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'da'
,p_message_text=>'Start af side'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921425403398992)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'da'
,p_message_text=>'Aktiveret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895291481398974)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under behandling af anmodningen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974653876399031)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi p\00E5kr\00E6vet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057563563399091)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'da'
,p_message_text=>unistr('Vent, indtil siden er fuldt indl\00E6st, og pr\00F8v igen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017793683399062)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'da'
,p_message_text=>unistr('Denne side har ikke-gemte \00E6ndringer.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898614306398976)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'da'
,p_message_text=>'Projektmappen har ikke noget aktivt regneark.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898585822398976)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'da'
,p_message_text=>'Projektmappen er ikke initialiseret.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898472846398976)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'da'
,p_message_text=>'Der opstod en intern fejl under oprettelse af XLSX-filen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900931504398978)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'da'
,p_message_text=>'Ark'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032634966399073)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'da'
,p_message_text=>'Handlinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950123881399013)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'da'
,p_message_text=>'Menuen Handlinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945847952399010)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j funktion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945700220399010)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j Grupper efter kolonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979972321399035)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j pivotkolonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980017003399035)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j r\00E6kkekolonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920248987398992)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'da'
,p_message_text=>'Aggreger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956389896399018)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'da'
,p_message_text=>'Aggregering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937498055399004)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'da'
,p_message_text=>'Gennemsnit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941753039399007)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'da'
,p_message_text=>'Antal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937540270399004)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'da'
,p_message_text=>'Maksimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937793794399004)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'da'
,p_message_text=>'Median'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937616458399004)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'da'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937330299399004)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'da'
,p_message_text=>'Sum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938465312399005)
,p_name=>'APEXIR_ALL'
,p_message_language=>'da'
,p_message_text=>'Alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919543707398991)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Alle kolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902022312398978)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Alle r\00E6kker')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029670318399071)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'da'
,p_message_text=>'Alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031208917399072)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'da'
,p_message_text=>'Alternativ standard:  %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932135400399000)
,p_name=>'APEXIR_AND'
,p_message_language=>'da'
,p_message_text=>'og'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921672230398993)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'da'
,p_message_text=>'Anvend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915303824398988)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'da'
,p_message_text=>'Stigende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934945124399002)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'da'
,p_message_text=>'Pr. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031883228399072)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'da'
,p_message_text=>'Gennemsnit %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023270729399066)
,p_name=>'APEXIR_BAR'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8jle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921064599398992)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'da'
,p_message_text=>'mellem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914115179398987)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'da'
,p_message_text=>'Baggrundsfarve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916026927398988)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'da'
,p_message_text=>unistr('bl\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947754431399011)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'da'
,p_message_text=>'Nederst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916694590398989)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'da'
,p_message_text=>'Annuller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922576883398993)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'da'
,p_message_text=>'Kategori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914012943398987)
,p_name=>'APEXIR_CELL'
,p_message_language=>'da'
,p_message_text=>'Celle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938360974399005)
,p_name=>'APEXIR_CHART'
,p_message_language=>'da'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948675905399012)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'da'
,p_message_text=>'Initialiserer...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110984948128399038)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Diagrametiket skal v\00E6re angivet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997397208399047)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'da'
,p_message_text=>unistr('Din foresp\00F8rgsel overskrider det maksimale antal p\00E5 %0 datapunkter pr. diagram. Anvend et filter for at reducere antallet af records i din basisforesp\00F8rgsel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996216195399047)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'da'
,p_message_text=>unistr('Det maksimale antal r\00E6kker for en diagramforesp\00F8rgsel begr\00E6nser antallet af r\00E6kker i basisforesp\00F8rgslen, ikke det viste antal r\00E6kker. Din basisforesp\00F8rgsel overskrider det maksimale antal r\00E6kker, som er %0. Anvend et filter til at reducere antallet a')
||unistr('f records i basisforesp\00F8rgslen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919681708398991)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'da'
,p_message_text=>'Diagramtype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110992921998399044)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'da'
,p_message_text=>'Marker alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935344652399002)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg rapportformat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942796201399008)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'da'
,p_message_text=>'ryd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916516037398989)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953917995399016)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026219639399068)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'da'
,p_message_text=>'Filtrer...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944745649399009)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'da'
,p_message_text=>'Kolonneoverskriftsmenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948471933399012)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'da'
,p_message_text=>'Kolonneoplysninger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028557761399070)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'da'
,p_message_text=>'Kolonneetiket'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946173660399010)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'da'
,p_message_text=>'Kolonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930285858398999)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'da'
,p_message_text=>'indeholder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931156903398999)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'da'
,p_message_text=>'indeholder ikke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915004508398988)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'da'
,p_message_text=>'i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931385907398999)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'da'
,p_message_text=>'er ikke inden for de sidste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939841184399006)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('er ikke i de n\00E6ste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931299754398999)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'da'
,p_message_text=>'er inden for de sidste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939790570399006)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('er i de n\00E6ste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914975536398988)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>'er ikke NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914812650398988)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'da'
,p_message_text=>'er NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914660874398987)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'da'
,p_message_text=>'som'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915105714398988)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'da'
,p_message_text=>'ikke i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914722208398988)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'da'
,p_message_text=>'ikke som'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930524117398999)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'da'
,p_message_text=>'matcher almindeligt udtryk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935284396399002)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'da'
,p_message_text=>'Beregning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110995977425399046)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'da'
,p_message_text=>'Beregningsudtryk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954271813399016)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'da'
,p_message_text=>unistr('Opret en beregning ved hj\00E6lp af kolonnealiasser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954334652399016)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'da'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954481280399016)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'da'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954591063399017)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'da'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900497907398977)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'da'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939199752399005)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'da'
,p_message_text=>'Beregn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946705291399011)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'da'
,p_message_text=>'Kontrolbrud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949706356399013)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'da'
,p_message_text=>'Kontrolbrud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034139680399074)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Kontrolbrudskolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897587184398975)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'da'
,p_message_text=>'Antal distinkte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032383383399072)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'da'
,p_message_text=>'Antal distinkte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032252235399072)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'da'
,p_message_text=>'Antal %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004360193399052)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'da'
,p_message_text=>'Dagligt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059008130399092)
,p_name=>'APEXIR_DATA'
,p_message_language=>'da'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948581837399012)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'da'
,p_message_text=>'Rapporter data, som de var for %0 minutter siden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022043160399065)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'da'
,p_message_text=>unistr('Datagitter - Hj\00E6lp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920329136398992)
,p_name=>'APEXIR_DATE'
,p_message_language=>'da'
,p_message_text=>'Dato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952475068399015)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'da'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029404832399070)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'da'
,p_message_text=>'Standardrapporttype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916743620398989)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'da'
,p_message_text=>'Slet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920648173398992)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'da'
,p_message_text=>'Vil du slette disse rapportindstillinger?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015307604399060)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'da'
,p_message_text=>'Slet standardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946497019399010)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'da'
,p_message_text=>'Slet rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915451667398988)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'da'
,p_message_text=>'Faldende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922682388398993)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'da'
,p_message_text=>'Beskrivelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944643946399009)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'da'
,p_message_text=>unistr('Enkeltr\00E6kkevisning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952902978399015)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkef\00F8lge %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953849936399016)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'da'
,p_message_text=>'Deaktiveret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916257480398989)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'da'
,p_message_text=>'Vist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919445996398991)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Viste kolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952861045399015)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'da'
,p_message_text=>'Vis i rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947605928399011)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'da'
,p_message_text=>'Ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939242606399005)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'da'
,p_message_text=>'Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952702998399015)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'da'
,p_message_text=>'Vis ikke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018760711399063)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6vning med samme betingelse findes allerede.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034350649399074)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Duplikeret pivotkolonne. Pivotkolonneliste skal v\00E6re entydig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034558208399074)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'da'
,p_message_text=>'Rediger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948701116399012)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'da'
,p_message_text=>'Rediger diagramindstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955321591399017)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'da'
,p_message_text=>'Rediger diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955792107399017)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'da'
,p_message_text=>'Rediger filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010181366399057)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'da'
,p_message_text=>'Rediger Grupper efter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955665371399017)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'da'
,p_message_text=>unistr('Rediger fremh\00E6vning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980244243399035)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'da'
,p_message_text=>'Rediger pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029778799399071)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'da'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908483246398983)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'da'
,p_message_text=>'E-mailadresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030076919399071)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'da'
,p_message_text=>'Bcc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030229557399071)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'da'
,p_message_text=>'Indhold'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029947742399071)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'da'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030790266399071)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'da'
,p_message_text=>'Frekvens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912175987398986)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'da'
,p_message_text=>'E-mail er endnu ikke konfigureret for denne applikation. Kontakt din administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003620831399052)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'da'
,p_message_text=>'E-mailadresse skal angives.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030348058399071)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'da'
,p_message_text=>unistr('Se vedh\00E6ftet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030171971399071)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'da'
,p_message_text=>'Emne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004689245399053)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'da'
,p_message_text=>'E-mailemne skal angives.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029864012399071)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'da'
,p_message_text=>'Til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913823863398987)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'da'
,p_message_text=>'Aktiveret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955512455399017)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'da'
,p_message_text=>'Aktiver/deaktiver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955058612399017)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954609707399017)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'da'
,p_message_text=>'Eksempler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955448406399017)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'da'
,p_message_text=>'Eksempler:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919357452398991)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Ekskluder NULL-v\00E6rdier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956058952399018)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'da'
,p_message_text=>'Udvid/skjul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953610262399016)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'da'
,p_message_text=>'Udtryk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938739794399005)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'da'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949641877399013)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'da'
,p_message_text=>'Filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959900736399020)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'da'
,p_message_text=>'Filterudtryk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056454093399090)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'da'
,p_message_text=>'Filterudtrykket er for langt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959880709399020)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'da'
,p_message_text=>'Filtertype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956216060399018)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg kolonner, der skal s\00F8ges i')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939028968399005)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'da'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953427948399016)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'da'
,p_message_text=>unistr('En flashback-foresp\00F8rgsel giver dig mulighed for at vise dataene, som de var p\00E5 et tidligere tidspunkt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004063597399052)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'da'
,p_message_text=>'Varighed af flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005472180399053)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'da'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935135472399002)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'da'
,p_message_text=>'Formateringsmaske %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946380068399010)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'da'
,p_message_text=>'Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954136153399016)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'da'
,p_message_text=>'Funktioner %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029355970399070)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'da'
,p_message_text=>'Funktioner/Operatorer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946029518399010)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'da'
,p_message_text=>'Funktion %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938590471399005)
,p_name=>'APEXIR_GO'
,p_message_language=>'da'
,p_message_text=>unistr('G\00E5 til')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914398990398987)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'da'
,p_message_text=>unistr('gr\00F8n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110897619020398975)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'da'
,p_message_text=>'Grupper efter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030453819399071)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Grupper efter kolonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985050624399038)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Grupper efter kolonne skal v\00E6re angivet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996174889399047)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'da'
,p_message_text=>unistr('Det maksimale antal r\00E6kker for en Grupper efter-foresp\00F8rgsel begr\00E6nser antallet af r\00E6kker i basisforesp\00F8rgslen, ikke det viste antal r\00E6kker. Din basisforesp\00F8rgsel overskrider det maksimale antal r\00E6kker, som er %0. Anvend et filter til at reducere ant')
||unistr('allet af records i basisforesp\00F8rgslen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976708166399033)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'da'
,p_message_text=>'Grupper efter sortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034296922399074)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'da'
,p_message_text=>unistr('Grupper efter sorteringsr\00E6kkef\00F8lge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919738764398991)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'da'
,p_message_text=>'Vandret kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951344641399014)
,p_name=>'APEXIR_HELP'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943100223399008)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Interaktive rapporter giver slutbrugere mulighed for at tilpasse rapporter. Brugere kan \00E6ndre layoutet af rapportdata ved at v\00E6lge kolonner, anvende filtre, fremh\00E6ve og sortere data. Brugere kan ogs\00E5 definere brud, aggregeringer, diagrammer, grupperi')
||unistr('nger og tilf\00F8je deres egne beregninger. Brugere kan ogs\00E5 konfigurere et abonnement, s\00E5 en HTML-version af rapporten sendes til dem pr. e-mail med et angivet interval. Brugere kan oprette flere varianter af en rapport og gemme dem som navngivne rappor')
||'ter til enten offentlig eller privat visning. ',
'<p/>',
unistr('De f\00F8lgende afsnit opsummerer m\00E5der, som du kan tilpasse en interaktiv rapport p\00E5. Hvis du vil l\00E6re mere, skal du se "Using Interactive Reports" i <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950226321399013)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'da'
,p_message_text=>unistr('Handlingsmenuen vises til h\00F8jre for knappen Start p\00E5 s\00F8gelinjen. Brug denne menu til at tilpasse en interaktiv rapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943956072399009)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aggregeringer er matematiske beregninger, der udf\00F8res mod en kolonne. Aggregeringer vises efter hvert kontrolbrud og i slutningen af rapporten inden for den kolonne, hvor de er defineret. Valgmuligheder inkluderer:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Aggregering</strong> giver dig mulighed for at v\00E6lge en tidligere'),
'defineret aggregering, der skal redigeres.</li>',
unistr('<li><strong>Funktion</strong> er den funktion, der skal udf\00F8res (for eksempel SUM, MIN).</li>'),
unistr('<li><strong>Kolonne</strong> bruges til at v\00E6lge den kolonne, som den matematiske funktion skal anvendes p\00E5. Kun numeriske'),
'kolonner vises.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944096450399009)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definere \00E9t diagram pr. gemt rapport. N\00E5r'),
unistr('det er defineret, kan du skifte mellem diagram- og rapportvisningerne ved hj\00E6lp af visningsikonerne p\00E5 s\00F8gelinjen.'),
'Valgmuligheder omfatter: ',
'<p>',
'</p><ul>',
'<li><strong>Diagramtype</strong> identificerer den diagramtype, der skal inkluderes.',
unistr('V\00E6lg mellem vandret s\00F8jle, lodret s\00F8jle, cirkel eller linje.</li>'),
unistr('<li><strong>Etiket</strong> giver dig mulighed for at v\00E6lge den kolonne, der skal bruges som etiket.</li>'),
unistr('<li><strong>Aksetitel til etiket</strong> er den titel, der vises p\00E5 aksen, som er associeret med den kolonne, der er valgt til'),
unistr('Etiket. Den er ikke tilg\00E6ngelig for et cirkeldiagram.</li>'),
unistr('<li><strong>V\00E6rdi</strong> giver dig mulighed for at v\00E6lge den kolonne, der skal bruges som v\00E6rdien. Hvis din funktion'),
unistr('er en COUNT, er det ikke n\00F8dvendigt at v\00E6lge en v\00E6rdi.</li>'),
unistr('<li><strong>Aksetitel til v\00E6rdi</strong> er den titel, der vises p\00E5 aksen, som er associeret med den kolonne, der er valgt til '),
unistr('V\00E6rdi. Den er ikke tilg\00E6ngelig for et cirkeldiagram.</li>'),
unistr('<li><strong>Funktion</strong> er en valgfri funktion, der skal udf\00F8res p\00E5 den kolonne, som er valgt til V\00E6rdi.</li>'),
unistr('<li><strong>Sorter</strong> giver dig mulighed for at sortere resultats\00E6ttet.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943316596399008)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E5r du klikker p\00E5 en kolonneoverskrift, vises en kolonneoverskriftsmenu. Valgmuligheder omfatter:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Sorter stigende</strong>-ikonet sorterer rapporten efter kolonnen i stigende r\00E6kkef\00F8lge.</li>'),
unistr('<li><strong>Sorter faldende</strong>-ikonet sorterer rapporten efter kolonnen i faldende r\00E6kkef\00F8lge.</li>'),
'<li><strong>Skjul kolonne</strong> skjuler kolonnen. Ikke alle kolonner kan skjules. Hvis en kolonne ikke kan skjules, er der ikke noget Skjul kolonne-ikon.</li>',
unistr('<li><strong>Brudkolonne</strong> opretter en brudgruppe p\00E5 kolonnen. Den tr\00E6kker kolonnen ud af rapporten som en masterrecord.</li>'),
unistr('<li><strong>Kolonneoplysninger</strong> viser hj\00E6lpetekst om kolonnen, hvis den er tilg\00E6ngelig.</li>'),
unistr('<li><strong>Tekstomr\00E5de</strong> bruges til at indtaste s\00F8gekriterier, hvor der skelnes mellem store og sm\00E5 bogstaver'),
unistr('(intet behov for jokertegn). Hvis du indtaster en v\00E6rdi, reduceres listen over v\00E6rdier'),
unistr('nederst i menuen. Du kan derefter v\00E6lge en v\00E6rdi fra'),
unistr('bunden, og den valgte v\00E6rdi oprettes som et filter ved hj\00E6lp af ''='''),
unistr('(for eksempel <code>column = ''ABC''</code>). Du kan ogs\00E5 klikke p\00E5 Flashlight-ikonet og indtaste en v\00E6rdi, der skal oprettes som et filter med ''LIKE''-modifikatoren'),
'(for eksempel <code>column LIKE ''%ABC%''</code>).</li>',
unistr('<li><b>Liste over entydige v\00E6rdier</b> indeholder de f\00F8rste 500 entydige'),
unistr('v\00E6rdier, der overholder dine filterkriterier. Hvis kolonnen er en dato, vises der i stedet'),
unistr('en liste med datointervaller. Hvis du v\00E6lger en v\00E6rdi, oprettes der'),
unistr('et filter ved hj\00E6lp af ''='' (for eksempel <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943879517399009)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Giver dig mulighed for at f\00F8je beregnede kolonner til din rapport. De kan v\00E6re matematiske beregninger (for eksempel <code>NBR_HOURS/24</code>) eller'),
unistr('Oracle-standardfunktioner, der anvendes p\00E5 eksisterende kolonner. Nogle vises som eksempler, og andre (for eksempel <code>TO_DATE)</code> kan ogs\00E5 bruges). Valgmuligheder inkluderer:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Beregning</strong> giver dig mulighed for at v\00E6lge en tidligere defineret beregning, der skal redigeres.</li>'),
unistr('<li><strong>Kolonneoverskrift</strong> er kolonneoverskriften p\00E5 den nye kolonne.</li>'),
unistr('<li><strong>Formateringsmaske</strong> er en Oracle-formateringsmaske, der skal anvendes p\00E5 kolonnen (for eksempel S9999).</li>'),
unistr('<li><strong>Beregning</strong> er den beregning, der foretages. I beregningen refereres der til kolonner ved hj\00E6lp af de viste aliasser.</li>'),
'</ul>',
unistr('<p>Under beregning vises kolonnerne i din foresp\00F8rgsel med'),
unistr('deres tilknyttede alias. N\00E5r der klikkes p\00E5 kolonnenavnet eller -aliasset, inkluderes'),
'de i beregningen. Ud for Kolonner vises der et tastatur. Dette tastatur fungerer som',
unistr('en genvej til ofte benyttede taster. Helt til h\00F8jre er Funktioner.</p>'),
unistr('<p>Den f\00F8lgende eksempelberegning demonstrerer, hvordan total kompensation vises:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
'(hvor A er ORGANIZATION, B er SALARY, og C er COMMISSION)</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950342816399013)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'da'
,p_message_text=>unistr('Bruges til at oprette en brudgruppe p\00E5 en eller flere kolonner. Dette tr\00E6kker kolonnerne ud af den interaktive rapport og viser dem som en masterrecord.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944517577399009)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'da'
,p_message_text=>unistr('Hvis du vil se detaljerne for en enkelt r\00E6kke ad gangen, skal du klikke p\00E5 ikonet for visning af enkelt r\00E6kke p\00E5 den r\00E6kke, som du vil se. Hvis det er tilg\00E6ngeligt, er enkeltr\00E6kkevisning altid den f\00F8rste kolonne. Afh\00E6ngigt af tilpasningen af den inte')
||unistr('raktive rapport er enkeltr\00E6kkevisning muligvis standardvisningen eller en tilpasset side, som kan tillade opdatering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944472443399009)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('G\00F8r det muligt at downloade det aktuelle resultats\00E6t. Downloadformaterne'),
unistr('varierer afh\00E6ngigt af din installation og rapportdefinitionen, men'),
'kan inkludere CSV, HTML, E-mail, XLS, PDF eller RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943505979399008)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fokuserer rapporten ved at tilf\00F8je eller modificere <code>WHERE</code>-klausulen p\00E5 foresp\00F8rgslen. Du kan filtrere efter kolonne eller r\00E6kke. '),
unistr('<p>Hvis du filtrerer efter kolonne, skal du v\00E6lge en kolonne (det beh\00F8ver ikke v\00E6re den'),
unistr('viste kolonne), v\00E6lge en Oracle-standardoperator (=, !=, ikke i, mellem) og indtaste et udtryk, der skal sammenlignes med. Der skelnes mellem store og sm\00E5 bogstaver i udtryk. Brug % som jokertegn (for eksempel <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>Hvis du filtrerer efter r\00E6kke, kan du oprette komplekse <code>WHERE</code>-klausuler ved hj\00E6lp af'),
'kolonnealiasser og alle Oracle-funktioner eller -operatorer (for eksempel <code>G = ''VA'' or G = ''CT''</code>, hvor',
'<code>G</code> er aliasset for <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944199082399009)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('En flashback-foresp\00F8rgsel giver dig mulighed for at vise dataene, som de var p\00E5 et tidligere tidspunkt.'),
unistr('Standardtidsrummet, som du kan g\00E5 tilbage, er 3 timer (eller 180'),
'minutter), men det faktiske tidsrum varierer for hver enkelt database.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005392815399053)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Med et format kan du tilpasse visningen af rapporten.',
unistr('Format indeholder f\00F8lgende undermenu:</p>'),
'<ul><li>Sorter</li>',
'<li>Kontrolbrud</li>',
unistr('<li>Fremh\00E6v</li>'),
'<li>Beregn</li>',
'<li>Aggreger</li>',
'<li>Diagram</li>',
'<li>Grupper efter</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003584010399052)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definere \00E9n Grupper efter-visning pr. gemt rapport. N\00E5r den er defineret, kan du skifte mellem Grupper efter- og rapportvisningerne'),
unistr('ved hj\00E6lp af visningsikonerne p\00E5 s\00F8gelinjen. Hvis du vil oprette en Grupper efter-visning, skal du v\00E6lge: '),
'<p></p>',
'<ul>',
'<li>de kolonner, der skal grupperes</li>',
unistr('<li>de kolonner, der skal aggregeres sammen med den funktion, som skal udf\00F8res (gennemsnit, sum, antal osv.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943722895399008)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Giver dig mulighed for at definere et filter. De r\00E6kker, der overholder filterkriterierne, vises fremh\00E6vet ved hj\00E6lp af den karakteristik, der er associeret med filteret. Valgmuligheder omfatter:</p>'),
'<ul>',
'<li><strong>Navn</strong> bruges kun til visning.</li>',
unistr('<li><strong>Sekvens</strong> identificerer den r\00E6kkef\00F8lge, som reglerne evalueres i.</li>'),
'<li><strong>Aktiveret</strong> identificerer, om en regel er aktiveret eller deaktiveret.</li>',
unistr('<li><strong>Fremh\00E6vningstype</strong> identificerer, om r\00E6kken eller cellen skal v\00E6re'),
unistr('fremh\00E6vet. Hvis Celle er valgt, fremh\00E6ves den kolonne, der refereres til i'),
unistr('Fremh\00E6vningsbetingelse.</li>'),
unistr('<li><strong>Baggrundsfarve</strong> er den nye farve for baggrunden af det fremh\00E6vede omr\00E5de.</li>'),
unistr('<li><strong>Tekstfarve</strong> er den nye farve af teksten i det fremh\00E6vede omr\00E5de.</li>'),
unistr('<li><strong>Fremh\00E6vningsbetingelse</strong> definerer din filterbetingelse.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881387256398964)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definere \00E9n pivotvisning pr. gemt rapport. N\00E5r den er defineret, kan du skifte mellem pivot- og rapportvisningerne ved hj\00E6lp af visningsikonerne p\00E5 s\00F8gelinjen. Hvis du vil oprette en pivotvisning, skal du v\00E6lge: '),
'<p></p>',
'<ul>',
'<li>de kolonner, der skal pivoteres</li>',
unistr('<li>de kolonner, der skal vises som r\00E6kker</li>'),
unistr('<li>de kolonner, der skal aggregeres sammen med den funktion, som skal udf\00F8res (gennemsnit, sum, antal osv.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954810671399017)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hvis du tilpasser en interaktiv rapport, vises rapportindstillingerne',
unistr('under s\00F8gelinjen og over rapporten. Dette omr\00E5de kan skjules og vises ved hj\00E6lp af ikonet til venstre.'),
'<p>',
'For hver rapportindstilling kan du:',
'</p><ul>',
unistr('<li>Redigere en indstilling ved at klikke p\00E5 navnet.</li>'),
unistr('<li>Deaktivere/aktivere en indstilling ved at markere eller fjerne markeringen i afkrydsningsfeltet Aktiver/deaktiver. Brug dette kontrolelement til midlertidigt at sl\00E5 en indstilling til og fra.</li>'),
unistr('<li>Fjerne en indstilling ved at klikke p\00E5 ikonet Fjern.</li>'),
'</ul>',
'<p>Hvis du har oprettet et diagram, en gruppering eller en pivot, kan du skifte mellem dem',
unistr('og basisrapporten ved hj\00E6lp af linkene Rapportvisning, Diagramvisning, Gruppevisning og Pivotvisning,'),
unistr('der vises til h\00F8jre. Hvis du ser diagrammet, grupperingen eller pivoten, kan'),
unistr('du ogs\00E5 bruge linket Rediger til at redigere indstillingerne.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944330081399009)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'da'
,p_message_text=>'Nulstiller rapporten til standardindstillingerne og fjerner eventuelle tilpasninger, som du har foretaget.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005663214399053)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'da'
,p_message_text=>unistr('S\00E6tter det antal records, der skal vises pr. side.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944202748399009)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gemmer den tilpassede rapport til senere brug. Du angiver et navn og en valgfri beskrivelse og kan g\00F8re rapporten offentligt tilg\00E6ngelig (det vil sige alle brugere, der kan f\00E5 adgang til den prim\00E6re standardrapport). Du kan gemme fire typer af int')
||'eraktive rapporter:</p>',
'<ul>',
unistr('<li><strong>Prim\00E6r standard</strong> (kun udviklere). Den prim\00E6re standard er den rapport, der vises til at begynde med. Prim\00E6re standardrapporter kan ikke omd\00F8bes eller slettes.</li>'),
unistr('<li><strong>Alternativ rapport</strong> (kun udviklere). Giver udviklere mulighed for at oprette flere rapportlayouts. Kun udviklere kan gemme, omd\00F8be eller slette en alternativ rapport.</li>'),
unistr('<li><strong>Offentlig rapport</strong> (slutbrugere). Kan gemmes, omd\00F8bes eller slettes af den slutbruger, der oprettede den. Andre brugere kan vise og gemme layoutet som en anden rapport.</li>'),
unistr('<li><strong>Privat rapport</strong> (slutbrugere). Kun den slutbruger, der har oprettet rapporten, kan vise, gemme, omd\00F8be eller slette rapporten.</li>'),
'</ul>',
unistr('<p>Hvis du gemmer tilpassede rapporter, vises der en rapportv\00E6lger p\00E5 s\00F8gelinjen til venstre for r\00E6kkev\00E6lgeren (hvis denne funktion er aktiveret).</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943225091399008)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'da'
,p_message_text=>unistr('\00D8verst p\00E5 hver rapportside findes et s\00F8geomr\00E5de. Dette omr\00E5de (eller s\00F8gelinjen) indeholder f\00F8lgende funktioner:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006233930399054)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'da'
,p_message_text=>unistr('<li><strong>Menuen Handlinger</strong> g\00F8r det muligt at tilpasse en rapport. Se nedenst\00E5ende afsnit.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005773461399053)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'da'
,p_message_text=>unistr('<li><strong>Ikonet V\00E6lg kolonner</strong> g\00F8r det muligt at identificere den kolonne, der skal s\00F8ges i (eller alle).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006065275399054)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'da'
,p_message_text=>'<li><strong>Rapporter</strong> viser alternative standardrapporter og gemte private eller offentlige rapporter.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005993137399054)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('<li><strong>R\00E6kker</strong> s\00E6tter det antal records, der skal vises pr. side.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005818230399054)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Tekstomr\00E5de</strong> g\00F8r det muligt at indtaste s\00F8gekriterier uden forskel p\00E5 store og sm\00E5 bogstaver (jokertegn er implicitte).</li>'),
unistr('<li><strong>Knappen G\00E5 til</strong> udf\00F8rer s\00F8gningen. Tryk p\00E5 Enter-tasten udf\00F8rer ogs\00E5 s\00F8gningen, n\00E5r mark\00F8ren er i s\00F8getekstomr\00E5det.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006199635399054)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'da'
,p_message_text=>'<li><strong>Vis-ikoner</strong> skifter mellem ikon-, rapport-, detalje-, diagram-, Grupper efter- og pivotvisninger af rapporten, hvis de er defineret.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022118599399065)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'da'
,p_message_text=>unistr('<li><strong>H\00E5ndter</strong> g\00F8r det muligt for dig at h\00E5ndtere egenskaberne, kolonnerne, r\00E6kkerne og visningshistorikken for rapporten eller datagitteret.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943433131399008)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('Bruges til at modificere de viste kolonner. Kolonnerne til h\00F8jre vises. Kolonnerne til venstre er skjult. Du kan \00E6ndre r\00E6kkef\00F8lgen p\00E5 de viste kolonner ved hj\00E6lp af pilene helt til h\00F8jre. Beregnede kolonner har pr\00E6fikset <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943685054399008)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruges til at \00E6ndre de kolonner, der skal sorteres p\00E5, og bestemmer, om '),
unistr('der sorteres i stigende eller faldende r\00E6kkef\00F8lge. Du kan ogs\00E5 angive, hvordan du vil h\00E5ndtere'),
unistr('<code>NULL-v\00E6rdier</code>. Standardindstillingen viser altid <code>NULL-v\00E6rdier</code> sidst eller viser dem altid f\00F8rst. Den resulterende sortering vises til h\00F8jre for'),
'kolonneoverskrifterne i rapporten.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003306114399052)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E5r du tilf\00F8jer et abonnement, angiver du en e-mailadresse (eller flere e-mailadresser adskilt af kommaer), et e-mailemne, frekvens og start- og slutdatoer. De resulterende e-mails inkluderer en HTML-version af den interaktive rapport, som indeholder')
||unistr(' de aktuelle data, ved hj\00E6lp af den rapportindstilling, der fandtes, da abonnementet blev tilf\00F8jet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021901978399065)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Datagitre er grundl\00E6ggende redigerbare rapporter, der kan tilpasses en hel del. Brugere kan \00E6ndre layoutet af rapportdata ved at v\00E6lge kolonner, anvende filtre, fremh\00E6ve og sortere data. Brugere kan ogs\00E5 definere brud, aggregeringer, diagrammer, Grup')
||unistr('per efter-funktioner og tilf\00F8je deres egne beregninger. Brugere kan oprette flere variationer af en rapport og gemme dem som navngivne rapporter til privat visning. '),
'<p/>',
unistr('Et datagitter kan tilpasses ved hj\00E6lp af s\00F8gelinjen, menuen Handlinger, menuen H\00E5ndter eller menuen Kolonneoverskrift.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033743794399073)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'da'
,p_message_text=>unistr('Handlingsmenuen vises til h\00F8jre for knappen G\00E5 til p\00E5 s\00F8gelinjen. Brug denne menu til at tilpasse en datagitterrapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022413223399065)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'da'
,p_message_text=>unistr('Tilf\00F8j/rediger r\00E6kkeside')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022577918399066)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Du kan f\00F8je en r\00E6kke til datagitteret ved at klikke p\00E5 Tilf\00F8j r\00E6kke. Hvis du vil redigere detaljerne for en r\00E6kke, skal du klikke p\00E5 ikonet Rediger r\00E6kke (f\00F8rste kolonne) p\00E5 den r\00E6kke, som du vil redigere. Siden Tilf\00F8j/Rediger r\00E6kke vises med kolo')
||'nnerne i datagitteret. </p>',
'',
unistr('<p>Under redigering af en r\00E6kke kan du:</p>'),
'',
'<p><ul>',
unistr('<li><strong>Slette</strong> r\00E6kken.</li>'),
unistr('<li><strong>Anvende \00E6ndringer</strong> for at gemme \00E6ndringerne af r\00E6kken.</li>'),
unistr('<li>Tilf\00F8je en r\00E6kke, tilf\00F8je filer, noter, links eller tags i <strong>Handlinger</strong> og gennemse historikken.</li>'),
unistr('<li>Navigere til <strong>N\00E6ste og forrige</strong> r\00E6kker.</li>'),
unistr('<li>Angive kolonneegenskaber, kolonnegrupper, valideringer og v\00E6rdilister i <strong>H\00E5ndter</strong>.</li>'),
'</ul></p>',
'',
unistr('<p>Omr\00E5det Anm\00E6rkninger nederst p\00E5 siden viser eventuelle filer, noter, links eller tags, som er knyttet til den aktuelle r\00E6kke.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033842930399073)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'da'
,p_message_text=>unistr('Bruges til at oprette en brudgruppe p\00E5 en eller flere kolonner. Dette tr\00E6kker kolonnerne ud af datagitteret og viser dem som en masterrecord.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022378233399065)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('G\00F8r det muligt at downloade det aktuelle resultats\00E6t. Downloadformaterne'),
'inkluderer CSV, HTML og E-mail.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033975296399074)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hvis du tilpasser en datagitterrapport, vises rapportindstillingerne',
unistr('under s\00F8gelinjen og over rapporten. Dette omr\00E5de kan skjules og vises ved hj\00E6lp af ikonet til venstre.'),
'<p>',
'For hver rapportindstilling kan du:',
'</p><ul>',
unistr('<li>Redigere en indstilling ved at klikke p\00E5 navnet.</li>'),
unistr('<li>Deaktivere/aktivere en indstilling ved at markere eller fjerne markeringen i afkrydsningsfeltet Aktiver/deaktiver. Brug dette kontrolelement til midlertidigt at sl\00E5 en indstilling til og fra.</li>'),
unistr('<li>Fjerne en indstilling ved at klikke p\00E5 ikonet Fjern.</li>'),
'</ul>',
'<p>Hvis du har oprettet et diagram, en gruppering eller en pivot, kan du skifte mellem dem',
unistr('og basisrapporten ved hj\00E6lp af linkene Rapportvisning, Diagramvisning, Grupper efter-visning og Pivotvisning,'),
unistr('der vises til h\00F8jre. Hvis du ser diagrammet, grupperingen eller pivoten, kan'),
unistr('du ogs\00E5 bruge linket Rediger til at redigere indstillingerne.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022233439399065)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gemmer det tilpassede datagitter til senere brug. Du angiver et navn og en valgfri beskrivelse. Du kan gemme tre typer af rapportlayouts for datagitteret:</p>',
'<ul>',
unistr('<li><strong>Prim\00E6r standard</strong> (kun administrator). Den prim\00E6re standard er det layout, der vises indledningsvist. Prim\00E6re standardrapporter kan ikke omd\00F8bes eller slettes.</li>'),
unistr('<li><strong>Alternativ rapport</strong> (kun administrator). Giver administratorer mulighed for at oprette flere rapportlayouts. Det er kun administratorer, som kan gemme, omd\00F8be eller slette en alternativ rapport.</li>'),
unistr('<li><strong>Privat rapport</strong> (alle brugere). Den bruger, der har oprettet rapportlayoutet, kan vise, gemme, omd\00F8be eller slette rapporten.</li>'),
'</ul>',
unistr('<p>Hvis du gemmer tilpassede rapporter, vises der en rapportv\00E6lger p\00E5 s\00F8gelinjen til venstre for r\00E6kkev\00E6lgeren (hvis denne funktion er aktiveret).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948399807399012)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Skjul kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938955922399005)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949832944399013)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6vninger')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954990627399017)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6vningsbetingelse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003921089399052)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6vningstypografi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913921766398987)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6vningstype')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023400331399066)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'da'
,p_message_text=>'Vandret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053054257399087)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'da'
,p_message_text=>'1 inaktiv indstilling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053130060399087)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'%0 inaktive indstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944912986399009)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp til interaktiv rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955965422399018)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'da'
,p_message_text=>'Ugyldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949301734399013)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt beregningsudtryk. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908765544398983)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'da'
,p_message_text=>unistr('Slutdatoen skal v\00E6re st\00F8rre end startdatoen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963635103399023)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt filterudtryk. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031425895399072)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig filterforesp\00F8rgsel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053273141399088)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'da'
,p_message_text=>'1 ugyldig indstilling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053349537399088)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'%0 ugyldige indstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004167536399052)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'da'
,p_message_text=>'(i minutter)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021105971399064)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'da'
,p_message_text=>'%0 er inden for de sidste %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021300344399065)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('%0 er inden for de n\00E6ste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021227795399065)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'da'
,p_message_text=>'%0 er ikke inden for de sidste %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021445244399065)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('%0 er ikke inden for de n\00E6ste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954063256399016)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'da'
,p_message_text=>'Tastatur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920182968398991)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'da'
,p_message_text=>'Etiket %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947998884399012)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'da'
,p_message_text=>'Aksetitel til etiket'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940404305399006)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'da'
,p_message_text=>'Sidste dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940640046399006)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'da'
,p_message_text=>'Sidste time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940167428399006)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('Sidste m\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940268003399006)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'da'
,p_message_text=>'Sidste uge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940361926399006)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'da'
,p_message_text=>'Sidste %0 dage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940549688399006)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'da'
,p_message_text=>'Sidste %0 timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939987410399006)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('Sidste %0 \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940094761399006)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('Sidste \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920096205398991)
,p_name=>'APEXIR_LINE'
,p_message_language=>'da'
,p_message_text=>'Linje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916800871398989)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'da'
,p_message_text=>'Linje med areal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031306766399072)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'da'
,p_message_text=>unistr('Kortl\00E6g det')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948810124399012)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'da'
,p_message_text=>unistr('Foresp\00F8rgslen estimeres at overskride de maksimalt tilladte ressourcer. Modificer dine rapportindstillinger, og pr\00F8v igen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931051119398999)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'da'
,p_message_text=>unistr('Det maksimale antal r\00E6kker for denne rapport er %0 r\00E6kker. Anvend et filter for at reducere antallet af records i din foresp\00F8rgsel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031957674399072)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'da'
,p_message_text=>'Maksimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032115759399072)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'da'
,p_message_text=>'Median %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935048266399002)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'da'
,p_message_text=>'For %0 minutter siden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032072667399072)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'da'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031085508399071)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004593704399053)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5nedligt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947139673399011)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'da'
,p_message_text=>'Flyt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947057532399011)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'da'
,p_message_text=>'Flyt alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058284008399091)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('Regions statiske ID skal v\00E6re angivet, da siden indeholder flere interaktive rapporter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915597682398988)
,p_name=>'APEXIR_NAME'
,p_message_language=>'da'
,p_message_text=>'Navn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942992468399008)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'da'
,p_message_text=>'Ny aggregering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053901692399088)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'da'
,p_message_text=>'Ny kategori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110943069788399008)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'da'
,p_message_text=>'Ny beregning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937855173399004)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940948039399006)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste dag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940704329399006)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste time')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941252530399007)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste m\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941140868399007)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste uge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941089355399007)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 dage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110940846064399006)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 timer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941495418399007)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste %0 \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941318831399007)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915896900398988)
,p_name=>'APEXIR_NO'
,p_message_language=>'da'
,p_message_text=>'Nej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956188160399018)
,p_name=>'APEXIR_NONE'
,p_message_language=>'da'
,p_message_text=>'- Ingen -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003748861399052)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'da'
,p_message_text=>'Ikke en gyldig e-mailadresse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952606854399015)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'da'
,p_message_text=>unistr('NULL-v\00E6rdier altid f\00F8rst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952544433399015)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'da'
,p_message_text=>unistr('NULL-v\00E6rdier altid sidst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953071829399015)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'da'
,p_message_text=>'NULL-sortering %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949446258399013)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'da'
,p_message_text=>unistr('Flashback-tid skal v\00E6re numerisk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949060678399012)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'da'
,p_message_text=>unistr('Sekvens skal v\00E6re numerisk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953585980399016)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'da'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914463567398987)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'da'
,p_message_text=>'orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023348768399066)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'da'
,p_message_text=>'Retning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916313997398989)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'da'
,p_message_text=>'Andet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899115207398976)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'da'
,p_message_text=>'Sideretning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899891553398977)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'da'
,p_message_text=>'Liggende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899930384398977)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'da'
,p_message_text=>unistr('St\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899064936398976)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'da'
,p_message_text=>unistr('Sidest\00F8rrelse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899667642398977)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'da'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899570306398977)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'da'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899701832398977)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'da'
,p_message_text=>'Tilpasset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899314095398976)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'da'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899289933398976)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'da'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110899443167398977)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'da'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032413424399072)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'da'
,p_message_text=>'Procent af samlet antal %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031667047399072)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'da'
,p_message_text=>'Procent af samlet sum %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030695076399071)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'da'
,p_message_text=>'Procent af samlet antal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030582184399071)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'da'
,p_message_text=>'Procent af samlet sum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919906456398991)
,p_name=>'APEXIR_PIE'
,p_message_language=>'da'
,p_message_text=>'Cirkel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979885462399035)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'da'
,p_message_text=>'Pivoter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981368542399036)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Aggregatfunktion skal v\00E6re angivet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981542913399036)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'da'
,p_message_text=>unistr('Du kan ikke aggregere p\00E5 en kolonne, der er valgt som r\00E6kkekolonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980734238399035)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Pivotkolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980575676399035)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'da'
,p_message_text=>'Pivotkolonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981181452399036)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Pivotkolonne skal v\00E6re angivet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881231070398964)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'da'
,p_message_text=>unistr('Det maksimale antal r\00E6kker for en pivotforesp\00F8rgsel begr\00E6nser antallet af r\00E6kker i basisforesp\00F8rgslen, ikke det viste antal r\00E6kker. Din basisforesp\00F8rgsel overskrider det maksimale antal r\00E6kker, som er %0. Anvend et filter til at reducere antallet af ')
||unistr('records i basisforesp\00F8rgslen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981014068399036)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'da'
,p_message_text=>'Pivotsortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950437087399013)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'da'
,p_message_text=>unistr('Pivotkolonnen indeholder for mange distinkte v\00E6rdier - pivot-SQL kan ikke genereres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003807154399052)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'da'
,p_message_text=>'Eksempel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937919671399004)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'da'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111029527622399070)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'da'
,p_message_text=>unistr('Prim\00E6r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004864931399053)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'da'
,p_message_text=>unistr('Prim\00E6r rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898976400398976)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'da'
,p_message_text=>unistr('Inkluder tilg\00E6ngelighedstags')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885865294398967)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'da'
,p_message_text=>'Fjern RTF-formatering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962601414399022)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'da'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920535122398992)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'da'
,p_message_text=>'Offentlig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916189738398989)
,p_name=>'APEXIR_RED'
,p_message_language=>'da'
,p_message_text=>unistr('r\00F8d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058137903399091)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Regionens statiske ID %0 findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947266624399011)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'da'
,p_message_text=>'Fjern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947347341399011)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'da'
,p_message_text=>'Fjern alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053408890399088)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'da'
,p_message_text=>'Fjern diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946899161399011)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'da'
,p_message_text=>'Fjern kontrolbrud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946537199399011)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'da'
,p_message_text=>'Fjern filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946671175399011)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'da'
,p_message_text=>'Fjern flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053509355399088)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'da'
,p_message_text=>'Fjern Grupper efter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946907227399011)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'da'
,p_message_text=>unistr('Fjern fremh\00E6vning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053628876399088)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'da'
,p_message_text=>'Fjern pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034627695399074)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'da'
,p_message_text=>'Fjern rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015264851399060)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'da'
,p_message_text=>unistr('Omd\00F8b standardrapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956409093399018)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'da'
,p_message_text=>unistr('Omd\00F8b rapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938271634399004)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'da'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032592494399073)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'da'
,p_message_text=>'Rapporter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912718217398986)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Gemt interaktiv rapport med aliasset %0 findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962937783399023)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Rapport findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912834831398986)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Det gemte interaktive rapport-ID %0 findes ikke.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110954799686399017)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'da'
,p_message_text=>'Rapportindstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935558348399002)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'da'
,p_message_text=>'Rapportvisning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939409366399005)
,p_name=>'APEXIR_RESET'
,p_message_language=>'da'
,p_message_text=>'Nulstil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920750271398992)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'da'
,p_message_text=>'Gendan rapport til standardindstillingerne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915926625398988)
,p_name=>'APEXIR_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028677053399070)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'da'
,p_message_text=>unistr('Du kan ikke bruge ROWID som den prim\00E6re n\00F8glekolonne til en REST-datakilde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945918609399010)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kker')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005500777399053)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kker pr. side')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980895139399036)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkekolonner')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980643513399035)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkekolonne %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981224968399036)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkekolonne skal v\00E6re angivet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981427746399036)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkekolonnen skal v\00E6re forskellig fra pivotkolonnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960057008399020)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kkefilter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935630899399003)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke %0 af %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939688198399006)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kketekst indeholder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915204367398988)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'da'
,p_message_text=>'Gem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950029285399013)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'da'
,p_message_text=>'Gemt rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949927717399013)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'da'
,p_message_text=>'Gemt rapport = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952160935399015)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'da'
,p_message_text=>'De aktuelle rapportindstillinger anvendes som standard for alle brugere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111015126597399060)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'da'
,p_message_text=>'Gem standardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110939303533399005)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'da'
,p_message_text=>'Gem rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053836251399088)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'da'
,p_message_text=>'Gem rapport *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006591123399054)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110944833635399009)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8gelinje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111053749366399088)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g i: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012011374399058)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g i rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996071888399046)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'da'
,p_message_text=>'Valgte kolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916957522398989)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('- V\00E6lg kolonne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938665682399005)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg kolonner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920408871398992)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'da'
,p_message_text=>unistr('- V\00E6lg funktion -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945607589399010)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('- V\00E6lg Grupper efter kolonne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980380010399035)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('- V\00E6lg pivotkolonne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031509008399072)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg r\00E6kke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980441506399035)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('- V\00E6lg r\00E6kkekolonne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889189958398969)
,p_name=>'APEXIR_SEND'
,p_message_language=>'da'
,p_message_text=>'Send'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895425734398974)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'da'
,p_message_text=>'Send som e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915682693398988)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'da'
,p_message_text=>'Sekvens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938863563399005)
,p_name=>'APEXIR_SORT'
,p_message_language=>'da'
,p_message_text=>'Sorter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948137887399012)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'da'
,p_message_text=>'Sorter stigende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948277242399012)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'da'
,p_message_text=>'Sorter faldende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034090420399074)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'da'
,p_message_text=>unistr('Sorteringsr\00E6kkef\00F8lge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942684658399008)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'da'
,p_message_text=>'mellemrum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953750949399016)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'da'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004228387399052)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'da'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030906996399071)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'da'
,p_message_text=>'Slutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885356276398967)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'da'
,p_message_text=>'Spring over, hvis ingen data blev fundet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111030894170399071)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'da'
,p_message_text=>'Starter fra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031717892399072)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'da'
,p_message_text=>'Sum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021759606399065)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'da'
,p_message_text=>unistr('Region = %0, Rapport = %1, Visning = %2, Start p\00E5 viste r\00E6kker = %3, Slut p\00E5 viste r\00E6kker  = %4, R\00E6kker i alt = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942310805399007)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'da'
,p_message_text=>unistr('Region = %0, Rapport = %1, Visning = %2, Start p\00E5 viste r\00E6kker = %3, Slut p\00E5 viste r\00E6kker = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914585154398987)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'da'
,p_message_text=>'Tekstfarve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931677497399000)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'da'
,p_message_text=>'dage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931588789398999)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'da'
,p_message_text=>'timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931441469398999)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'da'
,p_message_text=>'minutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931861104399000)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('m\00E5neder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931736556399000)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'da'
,p_message_text=>'uger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110931965345399000)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111034412607399074)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'da'
,p_message_text=>'Skift'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947465632399011)
,p_name=>'APEXIR_TOP'
,p_message_language=>'da'
,p_message_text=>unistr('\00D8verst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027617099399069)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Ikke-grupperet kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948979503399012)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'da'
,p_message_text=>unistr('Fremh\00E6vningsnavn skal v\00E6re entydigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919296214398991)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('ikke-underst\00F8ttet datatype')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947534726399011)
,p_name=>'APEXIR_UP'
,p_message_language=>'da'
,p_message_text=>'Op'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949135089399012)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'da'
,p_message_text=>'Indtast en gyldig farve.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949229279399013)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'da'
,p_message_text=>'Angiv en gyldig formateringsmaske.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110916498380398989)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110948089728399012)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'da'
,p_message_text=>unistr('Aksetitel til v\00E6rdi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955869132399017)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi p\00E5kr\00E6vet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919802321398991)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'da'
,p_message_text=>'Lodret kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111023514178399066)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'da'
,p_message_text=>'Lodret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955188913399017)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'da'
,p_message_text=>'Vis diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010307765399057)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'da'
,p_message_text=>'Vis detaljer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111055910506399089)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Rapporten har ikke nogen %0-visning defineret.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010427290399057)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'da'
,p_message_text=>'Vis gruppe efter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010220704399057)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'da'
,p_message_text=>'Vis ikoner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980178978399035)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'da'
,p_message_text=>'Vis pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110955216849399017)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'da'
,p_message_text=>'Vis rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004419059399053)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'da'
,p_message_text=>'Ugentligt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938180508399004)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'da'
,p_message_text=>'Arbejdsrapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033137185399073)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'da'
,p_message_text=>'%0 dage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033001824399073)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'da'
,p_message_text=>'%0 timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111032959230399073)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'da'
,p_message_text=>'%0 minutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033367160399073)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 m\00E5neder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033226464399073)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'da'
,p_message_text=>'%0 uger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111033463795399073)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('%0 \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111031120092399072)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('\00C5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110914234159398987)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'da'
,p_message_text=>'gul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110915720402398988)
,p_name=>'APEXIR_YES'
,p_message_language=>'da'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110947866351399011)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'da'
,p_message_text=>'%0 indeholder < eller >, som er ugyldige tegn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110970628060399028)
,p_name=>'APEX_REGION'
,p_message_language=>'da'
,p_message_text=>'Region'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110898830236398976)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'da'
,p_message_text=>unistr('API-foruds\00E6tning overskredet')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918311945398990)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'da'
,p_message_text=>unistr('Kan ikke hente v\00E6rdi for applikationsindstillingen %0, fordi tilknyttet build-valg er deaktiveret.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918239727398990)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'da'
,p_message_text=>unistr('Kan ikke s\00E6tte v\00E6rdi for applikationsindstillingen %0, fordi tilknyttet build-valg er deaktiveret.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025955416399068)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdien af applikationsindstillingen %0 er ugyldig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111025861862399068)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'da'
,p_message_text=>'Anmodet applikationsindstilling %0 er ikke defineret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026048211399068)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Applikationsindstillingen %0 m\00E5 ikke v\00E6re sat til en NULL-v\00E6rdi')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906966672398982)
,p_name=>'BACK'
,p_message_language=>'da'
,p_message_text=>'Tilbage'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893956706398973)
,p_name=>'BUILDER'
,p_message_language=>'da'
,p_message_text=>'Generator'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958027655399019)
,p_name=>'BUTTON LABEL'
,p_message_language=>'da'
,p_message_text=>'Knapetiket'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893026186398972)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'da'
,p_message_text=>'Knap-CSS-klasser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922230779398993)
,p_name=>'BUTTON_ID'
,p_message_language=>'da'
,p_message_text=>unistr('Genereret knap-ID vil enten v\00E6re knappens statiske ID, hvis det er defineret, eller et internt genereret ID i formatet ''B'' || [Internt knap-ID]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885797080398967)
,p_name=>'CANDLESTICK'
,p_message_language=>'da'
,p_message_text=>'Lysestage'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967235043399026)
,p_name=>'CENTER'
,p_message_language=>'da'
,p_message_text=>'Centreret'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917282071398989)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'da'
,p_message_text=>'%0-anmodning'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908673035398983)
,p_name=>'CHECK$'
,p_message_language=>'da'
,p_message_text=>unistr('r\00E6kkev\00E6lger')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111027780614399069)
,p_name=>'CHECKED'
,p_message_language=>'da'
,p_message_text=>'markeret'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003269033399052)
,p_name=>'COLUMN'
,p_message_language=>'da'
,p_message_text=>'Kolonne'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963798337399023)
,p_name=>'COMMENTS'
,p_message_language=>'da'
,p_message_text=>'Kommentarer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945262602399010)
,p_name=>'CONTINUE'
,p_message_language=>'da'
,p_message_text=>unistr('Forts\00E6t')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907210854398982)
,p_name=>'COPYRIGHT'
,p_message_language=>'da'
,p_message_text=>'Copyright &copy; %0, Alle rettigheder forbeholdes.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950964103399014)
,p_name=>'COUNT'
,p_message_language=>'da'
,p_message_text=>'Antal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957677384399019)
,p_name=>'CREATE'
,p_message_language=>'da'
,p_message_text=>'Opret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009971608399057)
,p_name=>'CREATED'
,p_message_language=>'da'
,p_message_text=>'Oprettet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010001694399057)
,p_name=>'CREATED_BY'
,p_message_language=>'da'
,p_message_text=>'Oprettet af'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934816358399002)
,p_name=>'CREATED_ON'
,p_message_language=>'da'
,p_message_text=>'Oprettet den'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945459663399010)
,p_name=>'CUSTOM'
,p_message_language=>'da'
,p_message_text=>'Tilpasset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956614809399018)
,p_name=>'CUSTOMIZE'
,p_message_language=>'da'
,p_message_text=>'Tilpas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958267669399019)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'da'
,p_message_text=>unistr('Sidepr\00E6ferencer nulstillet for brugeren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958383781399019)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'da'
,p_message_text=>unistr('Pr\00E6ferencer \00E6ndret for brugeren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958142347399019)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'da'
,p_message_text=>unistr('Sidepr\00E6ferencer nulstillet for brugeren %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921955825398993)
,p_name=>'DAILY'
,p_message_language=>'da'
,p_message_text=>'Dagligt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110893588706398972)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'da'
,p_message_text=>'Uploadet fil er ugyldig eller har den forkerte filtype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917458602398989)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig XML- eller JSON-v\00E6lger anvendt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886712458398967)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'da'
,p_message_text=>unistr('Dataprofil og uploadet fil indeholder ikke en m\00E5ltabelkolonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972461765399029)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'da'
,p_message_text=>'Ingen data fundet i uploadet fil.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972525441399029)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'da'
,p_message_text=>'Ingen data fundet i regnearket "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110892398273398972)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'da'
,p_message_text=>'Den angivne fil er ikke en XLSX-fil.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110882775263398965)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'da'
,p_message_text=>unistr('Dataindl\00E6sning afsluttet: %0 r\00E6kker behandlet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883967587398965)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('Dataindl\00E6sning afsluttet: %0 r\00E6kker behandlet med 1 fejl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884289049398966)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Dataindl\00E6sning afsluttet: %0 r\00E6kker behandlet med %1 fejl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884014137398966)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'da'
,p_message_text=>unistr('Dataindl\00E6sning afsluttet: 1 r\00E6kke behandlet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887050614398968)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('Dataindl\00E6sning afsluttet: 1 r\00E6kke behandlet med fejl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884171640398966)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Dataindl\00E6sning afsluttet: 1 r\00E6kke behandlet uden fejl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977706903399033)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5lkolonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977865624399033)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'da'
,p_message_text=>'Kildekolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978637673399034)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'da'
,p_message_text=>'Dato-/talformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042074508399079)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'da'
,p_message_text=>unistr('Kunne ikke hente opslagsv\00E6rdien.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111010505109399057)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'da'
,p_message_text=>'Data-/tabel-mapping'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978763987399034)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974209560399031)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'da'
,p_message_text=>'Transformationsreglen fejlede'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950570891399014)
,p_name=>'DATE'
,p_message_language=>'da'
,p_message_text=>'Dato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924671508398995)
,p_name=>'DAY'
,p_message_language=>'da'
,p_message_text=>'dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924723938398995)
,p_name=>'DAYS'
,p_message_language=>'da'
,p_message_text=>'dage'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963423758399023)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'da'
,p_message_text=>'Fejlfinding er ikke aktiveret for denne applikation.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111012274147399058)
,p_name=>'DEFAULT'
,p_message_language=>'da'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925490694398995)
,p_name=>'DELETE'
,p_message_language=>'da'
,p_message_text=>'slet'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110885661411398967)
,p_name=>'DIAL_PCT'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5ler (procent)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900130513398977)
,p_name=>'DOWNLOAD'
,p_message_language=>'da'
,p_message_text=>'Download'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011308935399058)
,p_name=>'DUP_USER'
,p_message_language=>'da'
,p_message_text=>unistr('Dubleret brugernavn p\00E5 liste.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907761814398982)
,p_name=>'EDIT'
,p_message_language=>'da'
,p_message_text=>'Rediger'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917156160398989)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'E-mailadressen "%0" blev ikke fundet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902285189398978)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'da'
,p_message_text=>'Denne e-mail er sendt af %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011569800399058)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'da'
,p_message_text=>unistr('E-mailadressen er for lang. Gr\00E6nsen er 240 tegn.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945126836399009)
,p_name=>'ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974371088399031)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'da'
,p_message_text=>unistr('Kan ikke s\00E6tte sideelements kildev\00E6rdi for delvis sideopfriskningsomr\00E5de')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936664179399003)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'da'
,p_message_text=>'Oprettet af'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902564807398979)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode er udl\00F8bet')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110896602253398975)
,p_name=>'FILE_EMPTY'
,p_message_language=>'da'
,p_message_text=>'Filen er tom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976839678399033)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'da'
,p_message_text=>unistr('Den uploadede fil var st\00F8rre end %0 MB. Upload en mindre fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904615299398980)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'da'
,p_message_text=>'Brugerautentificering fejlede, og en eller flere filer blev ikke uploadet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904719015398980)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'da'
,p_message_text=>'Denne instans tillader ikke, at uautentificerede brugere uploader filer.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957736128399019)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('1 fejl er opst\00E5et')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956940580399018)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('%0 fejl er opst\00E5et')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907142449398982)
,p_name=>'FORM_OF'
,p_message_language=>'da'
,p_message_text=>'%0 af %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941885340399007)
,p_name=>'GO'
,p_message_language=>'da'
,p_message_text=>unistr('G\00E5 til')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041667396399079)
,p_name=>'HELP'
,p_message_language=>'da'
,p_message_text=>unistr('Hj\00E6lp')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894056269398973)
,p_name=>'HOME'
,p_message_language=>'da'
,p_message_text=>'Startside'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924459920398994)
,p_name=>'HOUR'
,p_message_language=>'da'
,p_message_text=>'time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924556469398995)
,p_name=>'HOURS'
,p_message_language=>'da'
,p_message_text=>'timer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908527787398983)
,p_name=>'ICON'
,p_message_language=>'da'
,p_message_text=>'Ikonet %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958509657399019)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'da'
,p_message_text=>'Ugyldige logon-legitimationsoplysninger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111058062663399091)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig v\00E6rdi for parameter: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953200095399016)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'da'
,p_message_text=>'Som standardrapportindstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953347728399016)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'da'
,p_message_text=>'Som navngivet rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935791734399003)
,p_name=>'IR_ERROR'
,p_message_language=>'da'
,p_message_text=>'%0-fejl. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935414321399002)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'da'
,p_message_text=>'Kan ikke beregne formularnavigation. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913047998398986)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Interaktiv rapport ikke fundet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912487164398986)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>unistr('Interaktivt rapportomr\00E5de findes ikke i applikationen %0, side %1 og region %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110953126674399016)
,p_name=>'IR_STAR'
,p_message_language=>'da'
,p_message_text=>'Vises kun for udviklere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941554568399007)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('Rapportforesp\00F8rgslen skal have en entydig n\00F8gle for at identificere hver r\00E6kke. Den angivne n\00F8gle kan ikke bruges til denne foresp\00F8rgsel. Definer en entydig n\00F8glekolonne. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941674709399007)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'da'
,p_message_text=>unistr('Rapportforesp\00F8rgslen skal have en entydig n\00F8gle for at identificere hver r\00E6kke. Den angivne n\00F8gle kan ikke bruges til denne foresp\00F8rgsel. Rediger rapportattributterne for at definere en entydig n\00F8glekolonne. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978979802399034)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978877699399034)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'da'
,p_message_text=>unistr('Tr\00E6k og slip filen her, eller')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907414908398982)
,p_name=>'ITEMS'
,p_message_language=>'da'
,p_message_text=>'Elementer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936846084399003)
,p_name=>'ITEM_VALUE'
,p_message_language=>'da'
,p_message_text=>unistr('Elementv\00E6rdi')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951294945399014)
,p_name=>'LABEL'
,p_message_language=>'da'
,p_message_text=>'Etiket'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963379961399023)
,p_name=>'LANGUAGE'
,p_message_language=>'da'
,p_message_text=>'Sprog'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925165436398995)
,p_name=>'LAST'
,p_message_language=>'da'
,p_message_text=>'sidste'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904512821398980)
,p_name=>'LENGTH'
,p_message_language=>'da'
,p_message_text=>unistr('L\00E6ngde')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957875385399019)
,p_name=>'LOGIN'
,p_message_language=>'da'
,p_message_text=>'Logon'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996413008399047)
,p_name=>'MANAGE'
,p_message_language=>'da'
,p_message_text=>unistr('H\00E5ndter')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061029109399093)
,p_name=>'MAXIMIZE'
,p_message_language=>'da'
,p_message_text=>'Maksimer'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924231176398994)
,p_name=>'MINUTE'
,p_message_language=>'da'
,p_message_text=>'minut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924360572398994)
,p_name=>'MINUTES'
,p_message_language=>'da'
,p_message_text=>'minutter'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011702481399058)
,p_name=>'MISSING_AT'
,p_message_language=>'da'
,p_message_text=>'Manglende "@" i e-mailadresse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011966861399058)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'da'
,p_message_text=>'Advarsel: Ingen dialogbokssideskabelon er defineret for dialogbokssiden %0 i applikationen %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011693525399058)
,p_name=>'MISSING_DOT'
,p_message_language=>'da'
,p_message_text=>unistr('Manglende "." i e-mailadressedom\00E6ne.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960895069399021)
,p_name=>'MODULE'
,p_message_language=>'da'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917949212398990)
,p_name=>'MONTH'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921714053398993)
,p_name=>'MONTHLY'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5nedligt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918029750398990)
,p_name=>'MONTHS'
,p_message_language=>'da'
,p_message_text=>unistr('m\00E5neder')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950839541399014)
,p_name=>'MOVE'
,p_message_language=>'da'
,p_message_text=>'Flyt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018383703399062)
,p_name=>'MOVE_FROM'
,p_message_language=>'da'
,p_message_text=>'Flyt fra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018442337399063)
,p_name=>'MOVE_TO'
,p_message_language=>'da'
,p_message_text=>'Flyt til'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110938040915399004)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under sletteoperation p\00E5 flere r\00E6kker: r\00E6kke= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937089494399004)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'da'
,p_message_text=>unistr('M\00E5 ikke v\00E6re en offentlig bruger')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894293492398973)
,p_name=>'NAME'
,p_message_language=>'da'
,p_message_text=>'Navn'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951005242399014)
,p_name=>'NEW'
,p_message_language=>'da'
,p_message_text=>'Ny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917711032398990)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'da'
,p_message_text=>unistr('Du kan logge p\00E5 %0 ved at g\00E5 til:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917804694398990)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'da'
,p_message_text=>'Underretning om ny %0-konto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041807744399079)
,p_name=>'NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960752332399021)
,p_name=>'NO'
,p_message_language=>'da'
,p_message_text=>'Nej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111056039485399090)
,p_name=>'NOBODY'
,p_message_language=>'da'
,p_message_text=>'ingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925586424398995)
,p_name=>'NOT'
,p_message_language=>'da'
,p_message_text=>'Ikke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966304652399025)
,p_name=>'NOT_NULL'
,p_message_language=>'da'
,p_message_text=>'Ikke NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937107390399004)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'da'
,p_message_text=>'Ikke %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956730295399018)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'da'
,p_message_text=>'ingen data er fundet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965879036399025)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'da'
,p_message_text=>unistr('Ingen rapport, der kan opdateres, blev fundet. Operationer til opdatering og sletning af flere r\00E6kker kan kun udf\00F8res p\00E5 tabelformater af typen ''Rapport, der kan opdateres''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966792294399025)
,p_name=>'OK'
,p_message_language=>'da'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962403504399022)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'da'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111059876297399092)
,p_name=>'ORA_06550'
,p_message_language=>'da'
,p_message_text=>'ORA-06550: linje %0, kolonne %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009369099399056)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'da'
,p_message_text=>unistr('Du bruger en for\00E6ldet webbrowser. Du kan se en liste over underst\00F8ttede browsere i installationsvejledningen til Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910704690398985)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'da'
,p_message_text=>unistr('Der er anmodet om et ugyldigt s\00E6t af r\00E6kker. Kildedataene i rapporten er modificeret.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930867034398999)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'da'
,p_message_text=>'Et gyldigt sidetal skal angives, for eksempel p?n=1234.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934455268399002)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934524681399002)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'da'
,p_message_text=>unistr('N\00E6ste s\00E6t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934628311399002)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'da'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110934771281399002)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'da'
,p_message_text=>unistr('Forrige s\00E6t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041733800399079)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg sideinddeling')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972377222399029)
,p_name=>'PASSWORD'
,p_message_language=>'da'
,p_message_text=>'Adgangskode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917018953398989)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'da'
,p_message_text=>unistr('Din adgangskode til %0 er \00E6ndret.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906827994398982)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'da'
,p_message_text=>'Adgangskode overholder ikke sitens regler for adgangskodekompleksitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905975230398981)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'da'
,p_message_text=>'Ny adgangskode skal indeholde mindst %0 tegn, der ikke indgik i den gamle adgangskode.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906565360398982)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode m\00E5 ikke indeholde brugernavnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906743179398982)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'da'
,p_message_text=>'Adgangskode indeholder et forbudt simpelt ord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906613798398982)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode m\00E5 ikke indeholde arbejdsomr\00E5denavnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905833971398981)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'da'
,p_message_text=>'Adgangskode skal indeholde mindst %0 tegn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906078461398981)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode skal indeholde mindst \00E9t alfabetisk tegn (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906486492398982)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode skal indeholde mindst \00E9t lille bogstav.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906102982398981)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode skal indeholde mindst \00E9t numerisk tegn (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906263372398981)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode skal indeholde mindst \00E9t tegns\00E6tningstegn (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110906317554398981)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskode skal indeholde mindst \00E9t stort bogstav.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917597222398990)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'da'
,p_message_text=>'Underretning om nulstilling af adgangskode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904825453398980)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('Adgangskoden kan ikke anvendes, fordi den har v\00E6ret anvendt inden for de seneste %0 dage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985143679399039)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'da'
,p_message_text=>'Elementer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110985250925399039)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'da'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962295880399022)
,p_name=>'PERCENT'
,p_message_language=>'da'
,p_message_text=>'Procent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932564845399000)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'da'
,p_message_text=>'Kontakt administratoren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111041993076399079)
,p_name=>'PREVIOUS'
,p_message_language=>'da'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977352177399033)
,p_name=>'PRINT'
,p_message_language=>'da'
,p_message_text=>'Udskriv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961036245399021)
,p_name=>'PRIVILEGES'
,p_message_language=>'da'
,p_message_text=>'Privilegier'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930945064398999)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'da'
,p_message_text=>'Regionreferencer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951155382399014)
,p_name=>'REPORT'
,p_message_language=>'da'
,p_message_text=>'Rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960901984399021)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'da'
,p_message_text=>'Rapporteringsperiode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042195590399079)
,p_name=>'REPORT_LABEL'
,p_message_language=>'da'
,p_message_text=>'Rapport: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961606582399022)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'da'
,p_message_text=>'Rapporttotal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910842943398985)
,p_name=>'RESET'
,p_message_language=>'da'
,p_message_text=>'Nulstil sideinddeling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936794092399003)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'da'
,p_message_text=>'Nulstil sideinddeling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965701056399025)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'da'
,p_message_text=>'Nulstil adgangskode'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942583939399008)
,p_name=>'RESTORE'
,p_message_language=>'da'
,p_message_text=>'Gendan'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110974466445399031)
,p_name=>'RESULTS'
,p_message_language=>'da'
,p_message_text=>'Resultater'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966805531399025)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'da'
,p_message_text=>'Returner til applikation.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110967173667399026)
,p_name=>'RIGHT'
,p_message_language=>'da'
,p_message_text=>unistr('H\00F8jre')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996718026399047)
,p_name=>'ROW'
,p_message_language=>'da'
,p_message_text=>unistr('R\00E6kke %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950736712399014)
,p_name=>'ROW_COUNT'
,p_message_language=>'da'
,p_message_text=>unistr('Antal r\00E6kker')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110966222384399025)
,p_name=>'SAVE'
,p_message_language=>'da'
,p_message_text=>'Gem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962822678399023)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'da'
,p_message_text=>'Alternativ standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963239862399023)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'da'
,p_message_text=>'Beskrivelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962748582399022)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'da'
,p_message_text=>unistr('Prim\00E6r standard')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963536110399023)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'da'
,p_message_text=>unistr('Mere end %0 r\00E6kker tilg\00E6ngelige. For\00F8g r\00E6kkev\00E6lger for at se flere r\00E6kker.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028944869399070)
,p_name=>'SEARCH'
,p_message_language=>'da'
,p_message_text=>unistr('S\00F8g')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924174846398994)
,p_name=>'SECONDS'
,p_message_language=>'da'
,p_message_text=>'sekunder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962394708399022)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'da'
,p_message_text=>unistr('Se vedh\00E6ftet')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020070793399064)
,p_name=>'SELECT_ROW'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6lg r\00E6kke')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962072007399022)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'da'
,p_message_text=>unistr('Sl\00E5 sk\00E6rml\00E6sningstilstand fra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962122979399022)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'da'
,p_message_text=>unistr('Sl\00E5 sk\00E6rml\00E6sningstilstand til')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958474971399019)
,p_name=>'SHOW'
,p_message_language=>'da'
,p_message_text=>'Vis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021896709399065)
,p_name=>'SHOW_ALL'
,p_message_language=>'da'
,p_message_text=>'Vis alle'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111047958741399084)
,p_name=>'SIGN_IN'
,p_message_language=>'da'
,p_message_text=>unistr('Log p\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110997522243399048)
,p_name=>'SIGN_OUT'
,p_message_language=>'da'
,p_message_text=>'Log af'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951749728399015)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'da'
,p_message_text=>'For %0 dage siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958914599399020)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'%0 dage fra nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951672170399014)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'da'
,p_message_text=>'For %0 timer siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958816147399020)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'%0 timer fra nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951568846399014)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'da'
,p_message_text=>'For %0 minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958777768399019)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'%0 minutter fra nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951958629399015)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'da'
,p_message_text=>unistr('For %0 m\00E5neder siden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959135920399020)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>unistr('%0 m\00E5neder fra nu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959365189399020)
,p_name=>'SINCE_NOW'
,p_message_language=>'da'
,p_message_text=>'Nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951427892399014)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'da'
,p_message_text=>'For %0 sekunder siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110958649987399019)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'%0 sekunder fra nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110951808970399015)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'da'
,p_message_text=>'For %0 uger siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959049648399020)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>'%0 uger fra nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110952095127399015)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'da'
,p_message_text=>unistr('For %0 \00E5r siden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959291611399020)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'da'
,p_message_text=>unistr('%0 \00E5r fra nu')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945544579399010)
,p_name=>'STANDARD'
,p_message_language=>'da'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961904439399022)
,p_name=>'START_DATE'
,p_message_language=>'da'
,p_message_text=>'Startdato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902401000398979)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'da'
,p_message_text=>'Du modtager denne e-mail fra et interaktivt rapportabonnement, der er oprettet af %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057148111399090)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'da'
,p_message_text=>'Abonnementer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005262684399053)
,p_name=>'TAB'
,p_message_language=>'da'
,p_message_text=>'Fane'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924067999398994)
,p_name=>'TITLE'
,p_message_language=>'da'
,p_message_text=>'Titel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907047104398982)
,p_name=>'TODAY'
,p_message_language=>'da'
,p_message_text=>'I dag'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961554852399022)
,p_name=>'TOTAL'
,p_message_language=>'da'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908009752398983)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'da'
,p_message_text=>unistr('Der kan maksimalt v\00E6lges %0 kolonner.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886512580398967)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'da'
,p_message_text=>'Skjul alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886858737398968)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'da'
,p_message_text=>'Skjul alle under'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886428863398967)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'da'
,p_message_text=>'Udvid alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886633327398967)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'da'
,p_message_text=>'Udvid alle under'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886951729398968)
,p_name=>'TREE.REPARENT'
,p_message_language=>'da'
,p_message_text=>'Giv ny overordnet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979123940399034)
,p_name=>'TREES'
,p_message_language=>'da'
,p_message_text=>unistr('Tr\00E6er')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111022670151399066)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('P\00E5kr\00E6vet')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110946205657399010)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'da'
,p_message_text=>'Uautoriseret'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110993001108399044)
,p_name=>'UNAVAILABLE'
,p_message_language=>'da'
,p_message_text=>unistr('Ikke tilg\00E6ngelig')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959772517399020)
,p_name=>'UNKNOWN'
,p_message_language=>'da'
,p_message_text=>'Ukendt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903358930398979)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'da'
,p_message_text=>unistr('En ikke-genkendt autentificeringsfejl er opst\00E5et.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905324142398981)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'da'
,p_message_text=>unistr('Hvis du ikke l\00E6ngere \00F8nsker at modtage e-mails, skal du klikke p\00E5 <a href="%0">opsig abonnement</a> for at administrere dit abonnement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110902310610398979)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'da'
,p_message_text=>unistr('Hvis du ikke l\00E6ngere \00F8nsker at modtage e-mails, skal du g\00E5 til f\00F8lgende URL for at administrere dit abonnement:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110937204638399004)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('ikke-underst\00F8ttet datatype')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925343009398995)
,p_name=>'UPDATE'
,p_message_language=>'da'
,p_message_text=>'opdater'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923940915398994)
,p_name=>'UPDATED'
,p_message_language=>'da'
,p_message_text=>'Opdateret'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930698363398999)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'da'
,p_message_text=>'Den anmodede URL er forbudt. Kontakt din administrator.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110950680013399014)
,p_name=>'USER'
,p_message_language=>'da'
,p_message_text=>'Bruger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110972213410399029)
,p_name=>'USERNAME'
,p_message_language=>'da'
,p_message_text=>'Brugernavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011808628399058)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'da'
,p_message_text=>unistr('Brugernavnet er for langt. Gr\00E6nsen er %0 tegn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957436059399019)
,p_name=>'USERS'
,p_message_language=>'da'
,p_message_text=>'brugere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111011489538399058)
,p_name=>'USER_EXISTS'
,p_message_language=>'da'
,p_message_text=>'Brugernavn findes allerede.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111026161716399068)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'da'
,p_message_text=>'Profilbillede for bruger %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913752512398987)
,p_name=>'VALID'
,p_message_language=>'da'
,p_message_text=>'Gyldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907377839398982)
,p_name=>'VALIDATIONS'
,p_message_language=>'da'
,p_message_text=>'Valideringer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963006626399023)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi skal v\00E6re angivet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006406483399054)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi skal v\00E6re angivet for %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932992689399001)
,p_name=>'VERTICAL'
,p_message_language=>'da'
,p_message_text=>'lodret'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925227191398995)
,p_name=>'VIEW'
,p_message_language=>'da'
,p_message_text=>'vis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957502397399019)
,p_name=>'VIEWS'
,p_message_language=>'da'
,p_message_text=>'visninger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963873510399023)
,p_name=>'VIEW_ALL'
,p_message_language=>'da'
,p_message_text=>'Vis alle'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110945028135399009)
,p_name=>'WARNING'
,p_message_language=>'da'
,p_message_text=>'Advarsel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924834842398995)
,p_name=>'WEEK'
,p_message_language=>'da'
,p_message_text=>'uge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921885594398993)
,p_name=>'WEEKLY'
,p_message_language=>'da'
,p_message_text=>'Ugentligt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110924997109398995)
,p_name=>'WEEKS'
,p_message_language=>'da'
,p_message_text=>'uger'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110963151451399023)
,p_name=>'WELCOME_USER'
,p_message_language=>'da'
,p_message_text=>'Velkommen: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961330899399021)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'da'
,p_message_text=>unistr('Fandt ugyldig v\00E6rdi, verificer de indtastede data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961457650399021)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Fandt ugyldig v\00E6rdi, verificer de indtastede data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904424336398980)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'da'
,p_message_text=>unistr('Fandt ugyldig datov\00E6rdi. Verificer datoformatet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110961269932399021)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'da'
,p_message_text=>unistr('Fandt ugyldig talv\00E6rdi, verificer talformatet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913325706398987)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'da'
,p_message_text=>unistr('Fandt ugyldig tidsstempelv\00E6rdi. Verificer tidsstempelformatet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110935800914399003)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Kan ikke binde "%0". Brug dobbelte anf\00F8rselstegn til flerbyteelementer, eller verificer, at l\00E6ngden af elementet er 30 byte eller mindre. Brug v()-syntaks til at referere til elementer, som er l\00E6ngere end 30 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926319656398996)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'da'
,p_message_text=>unistr('Adgang n\00E6gtet af %0-sikkerhedskontrol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928825922398998)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'da'
,p_message_text=>unistr('Applikation ikke tilg\00E6ngelig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927218726398996)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'da'
,p_message_text=>'ERR-1014 Applikation ikke fundet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927365274398997)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('applikation=%0  arbejdsomr\00E5de=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927723328398997)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'da'
,p_message_text=>unistr('Adgang til denne applikation er begr\00E6nset. Pr\00F8v igen senere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927627827398997)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'da'
,p_message_text=>unistr('Adgang til denne applikation er begr\00E6nset til applikationsudviklere. Pr\00F8v igen senere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926894532398996)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'da'
,p_message_text=>'ERR-7744 Kan ikke behandle forgrening til funktion, der returnerer URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926775329398996)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'da'
,p_message_text=>'ERR-7744 Kan ikke behandle forgreningtil funktion, der returnerer side.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927073281398996)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('ERR-1430 Kald til visning fra sideproces underst\00F8ttes ikke: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928101408398997)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'da'
,p_message_text=>'ERR-1018 Fejl under rydning af trincache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926597890398996)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'da'
,p_message_text=>'ERR-1005 Ukendt beregningstype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927493055398997)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('ERR-1201 Sessions-ID ikke sat p\00E5 tilpasset autentificering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927592381398997)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'da'
,p_message_text=>'side=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110927162316398996)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('ERR-7620 Kunne ikke bestemme arbejdsomr\00E5de for applikationen (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909558248398984)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'da'
,p_message_text=>'Rediger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926249230398996)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'da'
,p_message_text=>'ERR-1802 Kan ikke finde element-ID''et "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925974248398996)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'da'
,p_message_text=>'ERR-1002 Kan ikke finde element-ID for elementet "%0" i applikationen "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926064564398996)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'da'
,p_message_text=>unistr('Uventet fejl, kan ikke finde elementnavn p\00E5 applikations- eller sideniveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926484012398996)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Du er allerede p\00E5 den f\00F8rste side med data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110941948836399007)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'da'
,p_message_text=>unistr('Element-ID''et (%0) er ikke et element, der er defineret p\00E5 den aktuelle side.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904064623398980)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'da'
,p_message_text=>unistr('Element kan ikke s\00E6ttes ved at videregive argumenter til applikationen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904323453398980)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'da'
,p_message_text=>'(Ingen kontrolsum blev angivet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903807099398980)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'da'
,p_message_text=>unistr('Element kan s\00E6ttes, n\00E5r det f\00F8lges af en kontrolsum af typen "bogm\00E6rke p\00E5 brugerniveau".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903707016398980)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'da'
,p_message_text=>unistr('Element kan s\00E6ttes, n\00E5r det f\00F8lges af en kontrolsum af typen "bogm\00E6rke p\00E5 applikationsniveau".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903973766398980)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'da'
,p_message_text=>unistr('Element kan s\00E6ttes, n\00E5r det f\00F8lges af en kontrolsum af typen "session".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903675915398980)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'da'
,p_message_text=>'Element har ingen beskyttelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928293226398997)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'da'
,p_message_text=>unistr('Ingen sidehj\00E6lp tilg\00E6ngelig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110917392574398989)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'da'
,p_message_text=>unistr('Arbejdsomr\00E5det %0 har ikke privilegier til at analysere som skemaet %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926607363398996)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('ERR-1010 Rekursionsgr\00E6nse for forgrening til sideacceptbehandling overskredet. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904203379398980)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'da'
,p_message_text=>unistr('Denne side kan ikke kaldes ved hj\00E6lp af en URL eller ved at bruge en GET eller POST til visningsproceduren. Den skal kaldes ved hj\00E6lp af en forgrening af typen "Forgrening til side".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110980919771399036)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under fors\00F8g p\00E5 at gemme ikke-numerisk v\00E6rdi i elementet %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919096890398991)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'da'
,p_message_text=>'Applikationens analyseskema "%0" findes ikke i databasen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110919153207398991)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'da'
,p_message_text=>unistr('Konti i INTERNAL-arbejdsomr\00E5det kan kun bruges til at f\00E5 adgang til &PRODUCT_NAME. <a href="%0">Administrationsservices</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925821920398995)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'da'
,p_message_text=>'ERR-1029 Kan ikke lagre sessionsoplysninger.  session=%0 element=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928978536398998)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'da'
,p_message_text=>'Kan ikke stoppe sporing: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110926118785398996)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'da'
,p_message_text=>'Uventet fejl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936157274399003)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'da'
,p_message_text=>'Fejl i update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929059687398998)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Applikation og side skal angives for at vise hj\00E6lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110949564710399013)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Automatisering ikke fundet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930153553398999)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'da'
,p_message_text=>'Ryddede %0 sessioner.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889492089398969)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'da'
,p_message_text=>unistr('Kan ikke udf\00F8re %0-kode! Den underst\00F8ttes ikke af databasen eller er ikke aktiveret af instansparameteren MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110889230814398969)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'da'
,p_message_text=>unistr('Multilingual Engine er ikke tilg\00E6ngeligt i denne databaseversion!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910038958398984)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Applikationssamlings-array kan ikke v\00E6re NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909829161398984)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'da'
,p_message_text=>unistr('Det angivne medlemsattributnr. %0 er ugyldigt. Attributnr. skal v\00E6re mellem 1 og %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910320945398984)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'da'
,p_message_text=>'Applikationssamling findes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910164089398984)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('Samlingsnavn kan ikke v\00E6re NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910229549398984)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'da'
,p_message_text=>unistr('Samlingsnavn kan ikke v\00E6re l\00E6ngere end 255 tegn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909652380398984)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Applikationssamlingen %0 findes ikke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910418379398984)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'da'
,p_message_text=>unistr('Mark\00F8r er endnu ikke \00E5ben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909772472398984)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Medlemssekvensen %0 findes ikke i applikationssamlingen %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110909916165398984)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'da'
,p_message_text=>'Medlemssekvensen %0 findes ikke i applikationssamlingen "%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981748002399036)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'da'
,p_message_text=>unistr('Den kryptografiske funktion "%0" underst\00F8ttes ikke i dette system.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035225386399075)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'da'
,p_message_text=>unistr('Tilg\00E6ngelighedstestet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929606364398998)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'da'
,p_message_text=>'Luk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929759344398998)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'da'
,p_message_text=>'Valgmuligheder for sidetilpasning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929887668398998)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'da'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929980579398998)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'da'
,p_message_text=>'Vist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930038258398998)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'da'
,p_message_text=>'Skjult'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929426373398998)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'da'
,p_message_text=>unistr('Marker de regioner, som du vil inkludere p\00E5 denne side. Markerede regioner vises muligvis ikke, hvis du ikke er i den rigtige applikationskontekst eller ikke har de rette privilegier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929575598398998)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'da'
,p_message_text=>'Denne side kan ikke tilpasses.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035548752399075)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'da'
,p_message_text=>unistr('Du kan tilpasse udseendet af denne applikation ved at \00E6ndre tematypografien, V\00E6lg en tematypografi p\00E5 listen nedenfor, og klik p\00E5 Anvend \00E6ndringer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111036379865399075)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'da'
,p_message_text=>unistr('Omr\00E5devisning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035470333399075)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'da'
,p_message_text=>'Brug applikationsstandardtypografi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111035377108399075)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'da'
,p_message_text=>'Udseende '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978377902399034)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Det kolonneindeks, der refereres til i aggregatfunktionen %0, findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110881682298398964)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'da'
,p_message_text=>unistr('CLOB-output underst\00F8ttes ikke for %0-format.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978000421399033)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'da'
,p_message_text=>unistr('Kolonneskiftet skal v\00E6re i begyndelsen af kolonne-array.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978109321399034)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Kolonnegruppeindekset, der refereres til i %0, findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110895685554398974)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'da'
,p_message_text=>'eksport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110900854618398978)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'da'
,p_message_text=>unistr('Eksportformatet skal v\00E6re XML med ORDS som printserver.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978430728399034)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>unistr('Det kolonneindeks, der refereres til i fremh\00E6vningen %0, findes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894104160398973)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt eksportformat: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110978282924399034)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Det overordnede gruppeindeks, der refereres til i %0, findes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111003484981399052)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Kolonnen %1 i tabellen %0 er en "GENERATED ALWAYS"-identitetskolonne. S\00F8rg for, at ingen kildekolonne er mappet til kolonnen %1 i dialogboksen Konfigurer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920847466398992)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'da'
,p_message_text=>unistr('Angivet bekr\00E6ftelsesinterval er for lille.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110920938153398992)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'da'
,p_message_text=>unistr('Ingen kolonner er angivet til dataindl\00E6sning.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922155743398993)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'da'
,p_message_text=>unistr('Ingen kolonner fundet for r\00E6kkev\00E6lger "%0". Pr\00F8v at registrere automatisk, eller gennemse JSON-strukturen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930443173398999)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'da'
,p_message_text=>'Ingen regneark fundet i XLSX-fil.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930389913398999)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'da'
,p_message_text=>'Angivet regneark findes ikke i XLSX-fil.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110910543232398985)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'da'
,p_message_text=>unistr('Aktuel version af data i database er \00E6ndret, siden brugeren initierede opdateringsprocessen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912966605398986)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'da'
,p_message_text=>'Fejl under opdatering af rapportkolonner: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017682627399062)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'da'
,p_message_text=>'Kan ikke konvertere %0 til SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957108919399018)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'da'
,p_message_text=>'Kolonnen %0, som er af datatypen %1, kan ikke konverteres til VARCHAR2!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964133400399023)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Kolonnen "%0", der er angivet for attributten "%1", blev ikke fundet i datakilden!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905476988398981)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'da'
,p_message_text=>unistr('Filtertypen %0 underst\00F8ttes ikke for kolonner med flere v\00E6rdier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111021033367399064)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt "mellem"-filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887537843398968)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'da'
,p_message_text=>'Ugyldig LOV-type angivet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887439994398968)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig foresp\00F8rgselstype. Foresp\00F8rgselstype skal v\00E6re Tabel, SQL-foresp\00F8rgsel eller PL/SQL-funktion, der returnerer SQL-foresp\00F8rgsel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957299309399018)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kunne ikke analysere SQL-foresp\00F8rgsel!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964226381399024)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>unistr('Den angivne kolonneposition %0 for attributten "%1" blev ikke fundet i SQL-s\00E6tningen!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110886020737398967)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'da'
,p_message_text=>unistr('For mange elementer brugt i filter med flere v\00E6rdier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964045102399023)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'da'
,p_message_text=>'Ingen kolonne angivet for attributten "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887350164398968)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'da'
,p_message_text=>unistr('PL/SQL-funktionsbr\00F8dtekst returnerede ikke en v\00E6rdi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110977293161399033)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'da'
,p_message_text=>unistr('REST-datakilden indeholder ikke en operation til h\00E5ndtering af den anmodede DML-handling.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110883285501398965)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'da'
,p_message_text=>unistr('Konvertering fra GeoJSON til SDO_GEOMETRY (kolonne %0) er ikke tilg\00E6ngelig i denne database.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884369954398966)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'da'
,p_message_text=>unistr('SDO_GEOMETRY-konvertering (kolonne %0) underst\00F8ttes ikke for XML-datakilder.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110891667437398971)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'da'
,p_message_text=>unistr('Tegnet %0 underst\00F8ttes ikke som separator for flere v\00E6rdier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111018955097399063)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Denne funktion kan ikke bruges p\00E5 en foresp\00F8rgselskontekst.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110884429780398966)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>'Uoverensstemmende kolonnedatatype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887232428398968)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'da'
,p_message_text=>unistr('Interne ORDS OUT-bindingsgr\00E6nser er overskredet. Reducer antallet af DML-r\00E6kker.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110965093479399024)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'JSON-svaret fra fjernserveren kunne ikke analyseres: ',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110887186179398968)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'da'
,p_message_text=>'Ukendt eller forkert konteksttype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110981691458399036)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('Denne filtype underst\00F8ttes ikke af parseren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936270272399003)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'da'
,p_message_text=>'Uautoriseret adgang (wwv_flow_api.set_credentials ikke sat).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913204835398986)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'da'
,p_message_text=>unistr('Arbejdsomr\00E5de blev ikke oprettet, fordi det allerede findes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110913187383398986)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'da'
,p_message_text=>'Brugergruppe ikke oprettet, fordi den allerede findes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923492685398994)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'da'
,p_message_text=>'Dubleret brugernavn fundet for %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923504905398994)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under indl\00E6sning af brugere. Fejlede p\00E5 brugeren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933499174399001)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'da'
,p_message_text=>unistr('Ville have indl\00E6st %0 brugere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933206853399001)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'da'
,p_message_text=>'Adgangskode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933355820399001)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'da'
,p_message_text=>'Privilegier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933053162399001)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'da'
,p_message_text=>'Brugernavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009523435399056)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'da'
,p_message_text=>'Fejl under gengivelse af sideelementet #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929189425398998)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Kan ikke vise sideelement, fordi HTML-formularen endnu ikke var \00E5bnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110894434741398973)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under beregning af elementstandardv\00E6rdi for sideelementet #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928433675398997)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'da'
,p_message_text=>'Fejl under efterberegning af element for sideelementet #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928322700398997)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under beregning af elementkildev\00E6rdi for sideelementet #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908175879398983)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'da'
,p_message_text=>'Uautoriseret adgang.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928643619398997)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'da'
,p_message_text=>unistr('JavaScript underst\00F8ttes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928709479398998)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'da'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110929335391398998)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'da'
,p_message_text=>unistr('Kan ikke initialisere foresp\00F8rgsel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936553009399003)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Opdatering af %0 underst\00F8ttes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110930764404398999)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt element-ID: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110957054525399018)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'da'
,p_message_text=>unistr('Der er ingen hj\00E6lp til dette element.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921508376398992)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'da'
,p_message_text=>unistr('Generering af diagramforesp\00F8rgsel fejlede. Kontroller indstillinger for kilde- og kolonne-mapping.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016306270399061)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'da'
,p_message_text=>unistr('Vedh\00E6ftningen af st\00F8rrelse %0 MB overskrider maksimumst\00F8rrelsen p\00E5 %1 MB for vedh\00E6ftning.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922412737398993)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'da'
,p_message_text=>unistr('Ugyldig v\00E6rdi for parameteren p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111039841525399078)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'da'
,p_message_text=>unistr('Du har overskredet det maksimale antal e-mailmeddelelser pr. arbejdsomr\00E5de. Kontakt din administrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903493966398979)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'da'
,p_message_text=>'Denne procedure skal startes fra en applikationssession.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922362164398993)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'da'
,p_message_text=>unistr('NULL-v\00E6rdi angivet for parameteren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976340660399032)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'da'
,p_message_text=>'Mailskabelonen "%0" blev ikke fundet i applikationen %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111052866712399087)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('Instansparameteren SMTP_HOST_ADDRESS skal v\00E6re sat til at sende mails.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922051604398993)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'da'
,p_message_text=>'Du skal angive en meddelelsesmodtager for at sende e-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111042286146399080)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'da'
,p_message_text=>'Kan ikke oprette SMTP-forbindelse til den konfigurerede e-mailserver.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111016413980399061)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'da'
,p_message_text=>'Ugyldigt Ajax-kald!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907815530398983)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'da'
,p_message_text=>'Ingen Ajax-funktion er defineret for plug-in''en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006837517399054)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'da'
,p_message_text=>unistr('Ingen udf\00F8relsesfunktion er defineret for plug-in''en %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907961402398983)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'da'
,p_message_text=>'Ingen gengivelsesfunktion er defineret for plug-in''en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017363193399062)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'da'
,p_message_text=>'REST-datakildens plug-in "%0" indeholder ikke en "Funktioner"-funktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017237217399062)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'da'
,p_message_text=>'REST-datakildens plug-in "%0" indeholder ikke en DML-funktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017407821399062)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'da'
,p_message_text=>unistr('REST-datakildens plug-in "%0" indeholder ikke en udf\00F8relsesfunktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111017562016399062)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'da'
,p_message_text=>'REST-datakildens plug-in "%0" indeholder ikke en hentefunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905601564398981)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl i PLSQL-kode opst\00E5et under plug-in-behandling.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912257686398986)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('V\00E6rdi skal v\00E6re angivet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942894536399008)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'da'
,p_message_text=>'Datatypen %0 kan ikke konverteres til VARCHAR2!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028407234399070)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>unistr('Kolonnen "%0", der er angivet for attributten "%1", blev ikke fundet i SQL-s\00E6tning!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004721981399053)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'da'
,p_message_text=>unistr('En foresp\00F8rgsel p\00E5 en liste over v\00E6rdier (LOV) eller en navngivet liste over v\00E6rdier skal angives for %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111006326269399054)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'da'
,p_message_text=>unistr('Forkert antal kolonner er valgt i SQL-foresp\00F8rgslen V\00E6rdiliste for %0. Se eksempel p\00E5 gyldige s\00E6tninger.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028281842399070)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'da'
,p_message_text=>'Ingen kolonne angivet for attributten "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057916011399091)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'da'
,p_message_text=>unistr('Den indtaste v\00E6rdi %0 for attributten "%1" er ikke numerisk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111009841990399056)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>unistr('%0 har en forkert datatype i SQL-s\00E6tning. Kolonnenr. %1 er %2, men %3 var forventet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111028328527399070)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'da'
,p_message_text=>'Kolonnen "%0", der er angivet for attributten "%1", har datatypen %2, men skulle have %3.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110904961658398981)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'da'
,p_message_text=>'Kan ikke finde rapportlayoutet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964926353399024)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'da'
,p_message_text=>unistr('Funktionen Beregn sum kan ikke bruges til rapporter baseret p\00E5 en REST-datakilde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110928587390398997)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('ERR-2904 Kan ikke s\00E6tte genvejsv\00E6rdi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110932870996399000)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'da'
,p_message_text=>'Fejl: Ukendt genvejstype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110922859923398993)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'da'
,p_message_text=>'Kan ikke hente authentication_scheme i applikationen %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110996325659399047)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'da'
,p_message_text=>'Lejer-ID''et findes allerede for den aktuelle session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110933142946399001)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'da'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057340584399090)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'da'
,p_message_text=>'Autentificering fejlede.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110959687427399020)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'da'
,p_message_text=>unistr('En eller flere cookies, der er sat i apex_util.g_request_cookies, indeholder en ugyldig v\00E6rdi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110942190543399007)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'da'
,p_message_text=>'Svaret fra UDDI-registreringsdatabasen var ugyldigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110905758485398981)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'da'
,p_message_text=>'Den angivne URL returnerede ikke et gyldigt WSDL-dokument.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110908215702398983)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'da'
,p_message_text=>unistr('WSDL-dokumentet indeholder flere SOAP-bindinger. &PRODUCT_NAME. underst\00F8tter kun WSDL''er med \00E9n SOAP-binding. Klik p\00E5 Opret webservicereference manuelt for at forts\00E6tte med at oprette en reference til denne service.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110976677812399032)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'da'
,p_message_text=>'Svaret fra servicen var ikke XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057222165399090)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'da'
,p_message_text=>unistr('OAuth-adgangstoken er ikke tilg\00E6ngeligt eller er udl\00F8bet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111020462736399064)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'da'
,p_message_text=>unistr('Du har overskredet det maksimale antal webserviceanmodninger pr. arbejdsomr\00E5de. Kontakt din administrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111057457029399091)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'da'
,p_message_text=>unistr('Server svarede med ikke-underst\00F8ttet OAuth-tokentype.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907656756398982)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'da'
,p_message_text=>unistr('WSDL-dokumentet indeholdt ikke en binding til SOAP, hvilket er p\00E5kr\00E6vet for at tilf\00F8je referencen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110903518849398979)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'da'
,p_message_text=>unistr('Dette WSDL kr\00E6ver autentificeringslegitimation. Angiv brugernavn og adgangskode nedenfor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110912346488398986)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'da'
,p_message_text=>unistr('Gengivelsesprogrammet kunne ikke forst\00E5 WSDL-dokumentet. Klik p\00E5 Opret webservicereference manuelt for at forts\00E6tte med at oprette en reference til denne service.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110979276002399034)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'da'
,p_message_text=>'Kan ikke behandle opdatering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111005054595399053)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'da'
,p_message_text=>unistr('Retur- og visningskolonne for liste over v\00E6rdier er ens!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111004927745399053)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'da'
,p_message_text=>unistr('Liste over v\00E6rdier har ingen returkolonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936448795399003)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under hentning af kolonnev\00E6rdi: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960410778399021)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'da'
,p_message_text=>unistr('Aktuelle data i tabelformat er for gamle. Kildedataene er modificeret.<br/> Klik <strong><a href="%0">her</a></strong> for at kassere dine \00E6ndringer og genindl\00E6se dataene fra databasen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918560360398990)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'da'
,p_message_text=>'Fejl under bestemmelse af sideinddelingsstreng'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918489262398990)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kan ikke bestemme foresp\00F8rgselsoverskrifter:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918661996398990)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'da'
,p_message_text=>unistr('fejl under erstatning af rapportsidef\00F8dder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918754572398990)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kunne ikke analysere SQL-foresp\00F8rgsel:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923768645398994)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'da'
,p_message_text=>unistr('Mindste antal anmodede r\00E6kker: %0, r\00E6kker fundet, men ikke vist: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921291432398992)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'da'
,p_message_text=>unistr('foresp\00F8rgselskolonne nr. %0 (%1) er ugyldig, kolonner, der bruger HTML, skal have aliasnavne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110936393629399003)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'da'
,p_message_text=>unistr('Fejl under hentning af foresp\00F8rgselsoverskrifter: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918877339398991)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'rapportfejl:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110956558977399018)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'da'
,p_message_text=>'Sorter efter denne kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921374517398992)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'da'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Foresp\00F8rgsel kan ikke analyseres. Kontroller syntaksen for din foresp\00F8rgsel.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960509124399021)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'da'
,p_message_text=>unistr('Denne formular indeholder \00E6ndringer, der ikke er gemt. Tryk p\00E5 "OK" for at forts\00E6tte uden at gemme dine \00E6ndringer. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110964892442399024)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'da'
,p_message_text=>unistr('Rapportsideinddelingsskemaet (%0) underst\00F8ttes ikke med den valgte datakilde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110921117107398992)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'da'
,p_message_text=>unistr('foresp\00F8rgselskolonne nr. %0 (%1) er ugyldig, brug kolonnealias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923838405398994)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'da'
,p_message_text=>unistr('r\00E6kke(r) %0 - %1 af mere end %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110962523829399022)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'da'
,p_message_text=>'%0 - %1 af mere end %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110923603520398994)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'da'
,p_message_text=>unistr('r\00E6kke(r) %0 - %1 af %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110907582813398982)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'da'
,p_message_text=>'%0 - %1 af %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918938681398991)
,p_name=>'Y'
,p_message_language=>'da'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110925017261398995)
,p_name=>'YEAR'
,p_message_language=>'da'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110918188221398990)
,p_name=>'YEARS'
,p_message_language=>'da'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110960682725399021)
,p_name=>'YES'
,p_message_language=>'da'
,p_message_text=>'Ja'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4499)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4499)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Skrivebord'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4499
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4499)
,p_name=>'Meddelelser'
,p_alias=>'MESSAGES'
,p_step_title=>'Meddelelser'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
