prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4353
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4353 - Oracle APEX Workspace Administration
--
-- Application Export:
--   Application:     4353
--   Name:            Oracle APEX Workspace Administration
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    129
--       Items:                  266
--       Computations:            29
--       Validations:             96
--       Processes:              104
--       Regions:                422
--       Buttons:                230
--       Dynamic Actions:         43
--     Shared Components:
--       Logic:
--         Items:                  8
--         Processes:              1
--         Computations:           4
--         Build Options:          3
--       Navigation:
--         Lists:                 34
--         Breadcrumbs:            1
--           Entries:            122
--         NavBar Entries:         4
--       Security:
--         Authentication:         1
--         Authorization:         12
--       User Interface:
--         Templates:
--           Page:                10
--           Region:              41
--           Label:               12
--           List:                14
--           Popup LOV:            1
--           Calendar:             2
--           Breadcrumb:           2
--           Button:              13
--           Report:               9
--         LOVs:                  66
--         Shortcuts:              3
--         Plug-ins:              13
--       Globalization:
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Workspace Administration')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110304402895360931')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt=>'59558075A3FE81DB011B5D7DBE6C1948FC163FC46B10F1DAAA23B861B1AB4902'
,p_checksum_salt_last_reset=>'20141222083238'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'de'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(539691214090646644.4353)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'W'
,p_security_scheme=>wwv_flow_api.id(1367105411776376234)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_friendly_url=>'N'
,p_substitution_string_01=>'LOGOUT'
,p_substitution_value_01=>'Abmelden'
,p_substitution_string_02=>'PRODUCT_NAME'
,p_substitution_value_02=>'Oracle APEX'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Workspace: &COMPANY.'
,p_substitution_string_04=>'MSG_LANGUAGE'
,p_substitution_value_04=>'Sprache'
,p_substitution_string_05=>'MSG_COPYRIGHT'
,p_substitution_value_05=>'Copyright &copy; 1999, 2021, Oracle und/oder verbundene Unternehmen.'
,p_substitution_string_06=>'MSG_USER'
,p_substitution_value_06=>'Benutzer'
,p_substitution_string_07=>'MSG_JSCRIPT'
,p_substitution_value_07=>unistr('Wenn Sie dieses Produkt ausf\00FChren, muss JavaScript aktiviert sein.')
,p_substitution_string_08=>'MSG_TBL_SUMMARY'
,p_substitution_value_08=>unistr('Tabelle f\00FCr das Seitenlayout')
,p_substitution_string_09=>'DONE'
,p_substitution_value_09=>'Fertig'
,p_substitution_string_10=>'TOP'
,p_substitution_value_10=>'Oben'
,p_substitution_string_11=>'CLOSE'
,p_substitution_value_11=>unistr('Schlie\00DFen')
,p_substitution_string_12=>'EDIT'
,p_substitution_value_12=>'Bearbeiten'
,p_substitution_string_13=>'DATE_FORMAT'
,p_substitution_value_13=>'dd.mm.rr'
,p_substitution_string_14=>'LONG_DATE_FORMAT'
,p_substitution_value_14=>'fmDay, dd. Month yyyy'
,p_substitution_string_15=>'TIME_FORMAT'
,p_substitution_value_15=>'hh24:mi:ss'
,p_substitution_string_16=>'DATE_TIME_FORMAT'
,p_substitution_value_16=>'dd.mm.rr hh24:mi:ss'
,p_substitution_string_17=>'DELETE_MSG'
,p_substitution_value_17=>unistr('Soll dieser L\00F6schvorgang ausgef\00FChrt werden?')
,p_substitution_string_18=>'HELP'
,p_substitution_value_18=>'Hilfe'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112644'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(882616872498402.4353)
,p_name=>'monitor.reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(883603843504111.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Am h\00E4ufigsten angezeigte Seiten aller Anwendungen')
,p_list_item_link_target=>'f?p=&APP_ID.:190:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(886617134517436.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Monatskalender der Seitenansichten pro Tag'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_calendar.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9402215610184148.4353)
,p_list_item_display_sequence=>33
,p_list_item_link_text=>unistr('Liniendiagramm f\00FCr Nutzung pro Tag')
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1027331717491838.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Pro gewichteter Seiten-Performance'
,p_list_item_link_target=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(231672816230382135.4353)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Seiten-Caching-Performance pro Anwendung'
,p_list_item_link_target=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_required_patch=>wwv_flow_api.id(231647503239340557.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(231673121771383712.4353)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Seiten-Caching-Performance pro Seite'
,p_list_item_link_target=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_required_patch=>wwv_flow_api.id(231647503239340557.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486724123619155183.4353)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Websheet-Seitenansichten'
,p_list_item_link_target=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/user_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4869427763068324.4353)
,p_name=>'user reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(182264209824455263.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Schema-Tablespace-Nutzung'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(67222825207706896.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Datenbankberechtigungen pro Schema'
,p_list_item_link_target=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4936425863455707.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Workspace-Schemas'
,p_list_item_link_target=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47074825204475016.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Bericht Tablespace-Nutzung (Popup)'
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(199868595682626900.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Webservice-Aktivit\00E4tslog')
,p_list_item_link_target=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/task_request_storage
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6621926453040443.4353)
,p_name=>'task.request.storage'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6623112732045993.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Speicherplatz anfordern'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/error_reporting
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(9787313686564805.4353)
,p_name=>'Error Reporting'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9787701696570857.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Anwendungsfehler'
,p_list_item_link_target=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/p22_application_changes
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(22853420277011168.4353)
,p_name=>'p22 Application Changes'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20238719980680877.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Pro Entwickler'
,p_list_item_link_target=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9828203951309455.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Balkendiagramm pro Entwickler'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_piechart.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1760803479628418008.4353)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Pro Entwickler pro Stunde'
,p_list_item_link_target=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6684624783765017.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Pro Tag'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1175007942169208.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Pro Anwendung'
,p_list_item_link_target=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(58181920001360047.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Anwendungs\00E4nderungen, detailliert')
,p_list_item_link_target=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42038019608233730.4353)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Pro Tag, Monatsansicht'
,p_list_item_link_target=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_calendar.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(166218023992861164.4353)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Komponentennutzungsdiagramm'
,p_list_item_link_target=>'f?p=&APP_ID.:97:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_login_access
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(26405214790138770.4353)
,p_name=>'monitor.login_access'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(26405620677140498.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Anmeldeversuche'
,p_list_item_link_target=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42725912639812593.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Anmeldeversuche pro Authentifizierungsergebnis'
,p_list_item_link_target=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10275514161901974.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Anmeldungszusammenfassung Entwickler'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_websheet_database_objects
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(26634012226707545.4353)
,p_name=>'manage websheet database objects'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(26634606470715299.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Websheet-Datenbankobjekte entfernen'
,p_list_item_link_target=>'f?p=&APP_ID.:2010:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_setup.setup_exists then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>unistr('L\00F6schen Sie Websheet-Datenbankobjekte und Daten aus dem Schema.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(26634814089717510.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Websheet-Datenbankobjekte validieren'
,p_list_item_link_target=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-validate-websheet-database'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_setup.setup_exists then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>unistr('Validieren Sie die Integrit\00E4t von Websheet-Datenbankobjekten, und l\00F6sen Sie ermittelte Probleme.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(32740318925964227.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Websheet-Datenbankobjekte erstellen'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_ws_setup.setup_exists then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'Erstellen Sie Datenbankobjekte, die zur Speicherung von Websheet-Daten erforderlich sind.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_websheet_database_object_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(33675020974963348.4353)
,p_name=>'create websheet database object progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33675402058967381.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Schema und Objekte'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33675605522968427.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Best\00E4tigen')
,p_list_item_link_target=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1020'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_caching
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(41424809053067534.4353)
,p_name=>'Manage Caching'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(41425317018069852.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Gecachte Regionen pro Region l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie den Cache f\00FCr eine Region, indem Sie mindestens eine Region ausw\00E4hlen.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10313118719357406.4353)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>unistr('Gecachte Regionen pro Anwendung l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie alle gecachten Regionen f\00FCr die angegebene Anwendung.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10314514001365509.4353)
,p_list_item_display_sequence=>12
,p_list_item_link_text=>unistr('Gecachte Regionen pro Workspace l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie alle gecachten Regionen f\00FCr den aktuellen Workspace.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(41425624290071958.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Gecachte Seiten pro Seite l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie alle gecachten Regionen auf einer Seite, indem Sie mindestens eine Seite ausw\00E4hlen.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10316706991382400.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Gecachte Seiten pro Anwendung l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie alle gecachten Seiten f\00FCr die angegebene Anwendung.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10318214741394151.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Abgelaufene gecachte Seiten pro Anwendung l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie nur gecachte Seiten, die f\00FCr die angegebene Anwendung abgelaufen sind.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_workspace
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(41758527939236654.4353)
,p_name=>'Manage Workspace'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(41759000215236656.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Serviceanforderung senden'
,p_list_item_link_target=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:49:::'
,p_list_item_icon=>'icon-admin-service-request'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>unistr('Fordern Sie Zugriff auf ein Datenbankschema, zus\00E4tzlichen Speicher oder zur Beendigung des Workspace an.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47234208185608874.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Workspace-Voreinstellungen festlegen'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-admin-workspace-preferences'
,p_list_text_01=>unistr('Konfigurieren Sie die Funktionalit\00E4t, die f\00FCr Entwickler in diesem Workspace verf\00FCgbar ist.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(173249312901228720.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Workspace-Nachricht definieren'
,p_list_item_link_target=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-admin-edit-announcement'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_text_01=>'Definieren Sie die Workspace-Nachricht.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(145773694894328470.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Umgebungsbanner definieren'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-sc-app-process'
,p_list_text_01=>'Definieren Sie das Banner auf Workspace-Ebene, das auf allen Seiten angezeigt wird.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'105'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168269607070943956.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Workspace-Nutzung'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-admin-workspace-utilization'
,p_list_text_01=>unistr('Zeigen Sie den Workspace-\00DCberblicksbericht an, einschlie\00DFlich Schema- und Aktivit\00E4tsdetails.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'101'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_logs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(41778218420271753.4353)
,p_name=>'Manage Logs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(41778402469271753.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Entwickleraktivit\00E4tslog verwalten')
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP,30:::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'30'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42463902076904417.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Clickthrough Log verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'84'
);
end;
/
prompt --application/shared_components/navigation/lists/page_21_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(41809121808367332.4353)
,p_name=>'Page 21 Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492151931609850014.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Gespeicherte Berichte'
,p_list_item_link_target=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-download-xlif-translation '
,p_list_text_01=>unistr('Pr\00FCfen Sie gespeicherte Berichte f\00FCr Desktop- und Websheet-Anwendungen. Berichte, mit Ausnahme des prim\00E4ren Standardberichts, k\00F6nnen ebenfalls gel\00F6scht werden.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48515414990925228.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-subscriptions'
,p_list_text_01=>unistr('Pr\00FCfen Sie Abonnements f\00FCr Desktopanwendungen. Abonnements k\00F6nnen auch gel\00F6scht werden.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/administration_home
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(46082227723554970.4353)
,p_name=>'Administration - Home'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46083626824639868.4353)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Service verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-service'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46082624737563617.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Benutzer und Gruppen verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-users'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46083204567576672.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Aktivit\00E4t \00FCberwachen')
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-monitor-activity'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47341025593948125.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-dashboards'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20635613776358966.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Auslastungsbericht'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'admin-utilization-report'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/dashboards
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(46989621592546067.4353)
,p_name=>'Dashboards'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47002219860895685.4353)
,p_list_item_display_sequence=>8
,p_list_item_link_text=>'Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'33'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46989826094547451.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Benutzer'
,p_list_item_link_target=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'60'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46991211942571754.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Aktivit\00E4t')
,p_list_item_link_target=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'13'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47333325078635734.4353)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>unistr('Entwickleraktivit\00E4t')
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'71'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47357220547457512.4353)
,p_list_item_display_sequence=>27
,p_list_item_link_text=>'Performance'
,p_list_item_link_target=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'78'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47440329895210523.4353)
,p_list_item_display_sequence=>28
,p_list_item_link_text=>'Websheets'
,p_list_item_link_target=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'81'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47998210717122914.4353)
,p_list_item_display_sequence=>29
,p_list_item_link_text=>'Anwendungen'
,p_list_item_link_target=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'91'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47392009342570705.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Datenbank'
,p_list_item_link_target=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'79'
);
end;
/
prompt --application/shared_components/navigation/lists/users_and_groups_apex_4_0
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47054717520943020.4353)
,p_name=>'users and groups APEX 4.0'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47055126870945672.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Benutzer'
,p_list_item_link_target=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'55'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47055330333946679.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Gruppen'
,p_list_item_link_target=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'53'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(132385410060946836.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Gruppenzuweisungen'
,p_list_item_link_target=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:RP,51:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_service_manage_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47244730835700645.4353)
,p_name=>'manage service / manage tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(563487671205228278.4353)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Data-Dictionary-Cache'
,p_list_item_link_target=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:RP,800:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47245532136719927.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Entwickleraktivit\00E4tslogs und Clickthrough Logs')
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47246012527723718.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Sessionzustand'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47246916814734445.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Anwendungscache'
,p_list_item_link_target=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47247422140745413.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Websheet-Datenbankobjekte verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47252112237827709.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Erstellstatus f\00FCr die Anwendung')
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168483331958366150.4353)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Dateinutzung'
,p_list_item_link_target=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(493060207510038405.4353)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('Einstellungen f\00FCr interaktive Berichte')
,p_list_item_link_target=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_49_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47296115483238304.4353)
,p_name=>'page 49 tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47296330028242448.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Detaillierter Bericht zur Tablespace-Nutzung'
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(177278408603201894.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('F\00FCr weiteren Workspace anmelden')
,p_list_item_link_target=>'f?p=4700:1:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUEST_FLOW'' ) <> ''MANUAL'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/request_train
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47297014014256767.4353)
,p_name=>'request train'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168280130450988464.4353)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Anforderung angeben'
,p_list_item_link_target=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'96'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47297223018259334.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Anforderung definieren'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'49,48,50'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47297426827260442.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Best\00E4tigen')
,p_list_item_link_target=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'69,510,66'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_calendar_views
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47721323591663284.4353)
,p_name=>'monitor activity / calendar views'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47721606407667742.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\00C4nderungen pro Entwickler')
,p_list_item_link_target=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'20'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47721810909669094.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Von Entwickler erstellte neue Seiten'
,p_list_item_link_target=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'82'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47768504965263316.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Seiten\00E4nderungen pro Tag')
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'89'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_session_state_2
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(49193021558761543.4353)
,p_name=>'Manage Session State 2'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49193803030761544.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Aktuelle Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-recent-sessions'
,p_list_text_01=>unistr('Pr\00FCfen Sie letzte Sessions mit der M\00F6glichkeit, einen Drilldown zu einer einzelnen Session durchzuf\00FChren und die gespeicherten Elemente im Sessionzustand f\00FCr diese Session anzuzeigen.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49233018235845734.4353)
,p_list_item_display_sequence=>21
,p_list_item_link_text=>unistr('Sessionzustand f\00FCr aktuelle Session')
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-report-session-state'
,p_list_text_01=>unistr('Zeigen Sie einen Bericht aller Elemente an, die im Sessionzustand f\00FCr Ihre aktuelle Session gespeichert sind. ')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49194117294761544.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Sessions nach Alter l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie gespeicherte Sessionzustandsinformationen, die \00E4lter sind als ein angegebener Zeitrahmen. ')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49193217092761543.4353)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Sessionzustand f\00FCr aktuelle Session l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie Sessionzustandsinformationen, die f\00FCr Ihre aktuelle Session gespeichert sind.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_preferences_home
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(49208419658798799.4353)
,p_name=>'Manage Preferences Home'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49209216188798800.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Voreinstellungen pro Benutzer'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-preferences-by-user'
,p_list_text_01=>unistr('Pr\00FCfen Sie Voreinstellungen, die von einzelnen Benutzern gespeichert wurden.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49237210055852837.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Aktuelle Benutzervoreinstellungen'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-report-session-state'
,p_list_text_01=>'Zeigen Sie Voreinstellungen an, die Sie gespeichert haben.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49209526179798800.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Voreinstellungen pro Benutzer l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.:46:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie gespeicherte Voreinstellungen f\00FCr einen bestimmten Benutzer.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49208912194798800.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Voreinstellungen f\00FCr aktuellen Benutzer l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('L\00F6schen Sie Voreinstellungen, die Sie gespeichert haben.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/environment_monitoring_options
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(56633624548029155.4353)
,p_name=>'environment monitoring options'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(56635027334029158.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Pro Benutzer-Agent'
,p_list_item_link_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(56635314999029158.4353)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Pro Browser'
,p_list_item_link_target=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(56635603329029158.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Pro externer Klicks'
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(56635916722029158.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Pro Betriebssystem'
,p_list_item_link_target=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_charts
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(61339238287578026.4353)
,p_name=>'monitor.charts'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(383677460582131171.4353)
,p_list_item_display_sequence=>0
,p_list_item_link_text=>'Nach View - Facettensuche'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(26641602494492148.4353)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Pro Ansicht'
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15610782962052240.4353)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Pro Benutzer'
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1760816402430436488.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Pro Benutzer und Stunde'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(26157704446429203.4353)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Pro Anwendung'
,p_list_item_link_target=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30526206851676352.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Pro Anwendung und Seite'
,p_list_item_link_target=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9443402534511474.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Pro Tag'
,p_list_item_link_target=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47745331041053325.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Pro Stunde'
,p_list_item_link_target=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(196265008149398549.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Pro interaktiven Bericht'
,p_list_item_link_target=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_apex_demo_objects
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(161065115373372140.4353)
,p_name=>'Manage APEX$DEMO Objects'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/create_apex_demo_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(161192747617951712.4353)
,p_name=>'Create APEX$Demo progress'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/activity_log_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(162250901435797798.4353)
,p_name=>'Activity Log List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162251210785800461.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Echtzeitaktivit\00E4t')
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'22'
);
end;
/
prompt --application/shared_components/navigation/lists/summary_log_pages
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(162256322822822923.4353)
,p_name=>'summary log pages'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(397448666726572548.4353)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Nach Anwendung und Monat'
,p_list_item_link_target=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162256503352822924.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Pro Anwendung pro Tag'
,p_list_item_link_target=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(219127363831431945.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Anwendungs-Hash pro Tag'
,p_list_item_link_target=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162257102425822925.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Pro Anwendung'
,p_list_item_link_target=>'f?p=&APP_ID.:354:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880569998372629663.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Diagramm der Workspace-Aktivit\00E4t pro Tag')
,p_list_item_link_target=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/component_utilization
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(166186215913459085.4353)
,p_name=>'Component Utilization'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(166186401888459086.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Bericht f\00FCr Nutzung nativer Komponenten')
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(166186830094459086.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Diagramm f\00FCr Nutzung nativer Komponenten')
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_tasks_page_3
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(166211911060758908.4353)
,p_name=>'admin_tasks_page_3'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16347303877035542.4353)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>unistr('Mein Kennwort \00E4ndern')
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:3::#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(1309004604808814)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30385011201348523.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Aktivit\00E4t \00FCberwachen')
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'1'
,p_security_scheme=>wwv_flow_api.id(178931223495737450)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30385223668352082.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Service verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'1'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46969711288174181.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Benutzergruppen verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46981012486411024.4353)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Benutzer erstellen'
,p_list_item_link_target=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52,EDIT_USER_PRIVS:::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46981208807419423.4353)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Mehrere Benutzer erstellen'
,p_list_item_link_target=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:99:::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(487230503095185923.4353)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>unistr('Mehrere Benutzer l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:RIR:::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492151212216844406.4353)
,p_list_item_display_sequence=>104
,p_list_item_link_text=>unistr('Einstellungen f\00FCr interaktive Berichte verwalten')
,p_list_item_link_target=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168469522898909489.4353)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Export-Repository verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168861426713853535.4353)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Websheet-Datenbankobjekte verwalten'
,p_list_item_link_target=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(621160827306560828.4353)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Neuen Workspace anfordern'
,p_list_item_link_target=>'f?p=4700:1:&APP_SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(147758823396318362.4353)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Umgebungsbanner definieren'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105:::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_sessions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(167617332155424156.4353)
,p_name=>'monitor.sessions'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(167617812546427943.4353)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Aktive Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9410309863267579.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Balkendiagramm f\00FCr aktive Sessions pro Stunde')
,p_list_item_link_target=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_barchart.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/saved_ir_view_mode
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(492707417463467235.4353)
,p_name=>'saved_ir_view_mode'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492708632354471515.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Datenbankanwendungsberichte'
,p_list_item_link_target=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'98'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492708806512473583.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Websheet-Anwendungsberichte'
,p_list_item_link_target=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'100'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(697508149859311566.4353)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697508379122311567.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Administration'
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697508646749311568.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697508954423311568.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Service verwalten'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697509272437311568.4353)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Service verwalten'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697508954423311568.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697509589201311568.4353)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(697508954423311568.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697509890224311568.4353)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Serviceanforderung senden'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(697508954423311568.4353)
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697510102039311568.4353)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Workspace-Voreinstellungen festlegen'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(697508954423311568.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697510424442311568.4353)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Workspace-Nachricht definieren'
,p_list_item_link_target=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(697508954423311568.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180636861560637301.4353)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Umgebungsbanner definieren'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(697508954423311568.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697510729732311568.4353)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Workspace-Nutzung'
,p_list_item_link_target=>'f?p=4350:101:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697508954423311568.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697511092305311569.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Benutzer und Gruppen verwalten'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697511311568311569.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Aktivit\00E4t \00FCberwachen')
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697511632930311569.4353)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1253566117341334456.4353)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Mein Kennwort \00E4ndern')
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(697513111062314247.4353)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697513395064314247.4353)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dokumentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2105953653789032029.4353)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Diskussionsforum'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2185497476192539882.4353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Weitere Informationen zu Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697514231251314249.4353)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697514582567314249.4353)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Info'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(719024906222154750.4353)
,p_name=>'APEX 5 - Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::P1500_SHOW::'
,p_list_item_icon_alt_attribute=>'App Builder Drilldown'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_api.id(178931223495737450)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719025442346154751.4353)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Datenbankanwendungen'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::P1500_SHOW:DATABASE:'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719026009370154751.4353)
,p_list_item_display_sequence=>125
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719026385964154751.4353)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Erstellen'
,p_list_item_link_target=>'f?p=4000:56:&SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID:'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719026624198154752.4353)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Importieren'
,p_list_item_link_target=>'f?p=4000:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719026946930154752.4353)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Exportieren'
,p_list_item_link_target=>'f?p=4000:523:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719027247767154752.4353)
,p_list_item_display_sequence=>155
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Workspace-Utilitys'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719027815679154753.4353)
,p_list_item_display_sequence=>161
,p_list_item_link_text=>'Alle Workspace-Utilitys'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719028109015154753.4353)
,p_list_item_display_sequence=>162
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719028431141154754.4353)
,p_list_item_display_sequence=>163
,p_list_item_link_text=>'App Builder-Standardwerte'
,p_list_item_link_target=>'f?p=4000:800:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719029022709154754.4353)
,p_list_item_display_sequence=>165
,p_list_item_link_text=>'Workspace Themes'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719029300308154755.4353)
,p_list_item_display_sequence=>166
,p_list_item_link_text=>'Anwendungsgruppen'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719029687746154755.4353)
,p_list_item_display_sequence=>167
,p_list_item_link_text=>'Application Express-Views'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719029978772154755.4353)
,p_list_item_display_sequence=>168
,p_list_item_link_text=>unistr('Anwendungs\00FCbergreifende Berichte')
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719027511617154752.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719030232218154755.4353)
,p_list_item_display_sequence=>169
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(719025111754154750.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719030888019154756.4353)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=4500:3002:&SESSION.'
,p_list_item_icon_alt_attribute=>'SQL Workshop Drilldown'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_api.id(178931519479737472)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719031124656154756.4353)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Objektbrowser'
,p_list_item_link_target=>'f?p=4500:1001:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719030888019154756.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719031458397154756.4353)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'SQL-Befehle'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719030888019154756.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719031703587154756.4353)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'SQL-Skripts'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719030888019154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Utilitys'
,p_parent_list_item_id=>wwv_flow_api.id(719030888019154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719032382647154757.4353)
,p_list_item_display_sequence=>241
,p_list_item_link_text=>'Alle Utilitys'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719032635816154757.4353)
,p_list_item_display_sequence=>242
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719032955597154757.4353)
,p_list_item_display_sequence=>243
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719033222480154757.4353)
,p_list_item_display_sequence=>244
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713697277248449084.4353)
,p_list_item_display_sequence=>245
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(670887786645958062.4353)
,p_list_item_display_sequence=>246
,p_list_item_link_text=>'Beispiel-Datasets'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719033598800154757.4353)
,p_list_item_display_sequence=>247
,p_list_item_link_text=>'DDL generieren'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719033825052154757.4353)
,p_list_item_display_sequence=>248
,p_list_item_link_text=>unistr('Benutzeroberfl\00E4chen-Standards')
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719035308907154759.4353)
,p_list_item_display_sequence=>249
,p_list_item_link_text=>'Schemavergleich'
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719034150049154757.4353)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Methoden auf Tabellen'
,p_list_item_link_target=>'f?p=4500:120:&SESSION.::NO::P117_CREATE_PACKAGE:TABLE'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719035619948154759.4353)
,p_list_item_display_sequence=>251
,p_list_item_link_text=>'Papierkorb'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719034768041154757.4353)
,p_list_item_display_sequence=>252
,p_list_item_link_text=>'Objektberichte'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719034459353154757.4353)
,p_list_item_display_sequence=>253
,p_list_item_link_text=>'Info zur Datenbank'
,p_list_item_link_target=>'f?p=4500:36:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719035054803154758.4353)
,p_list_item_display_sequence=>254
,p_list_item_link_text=>unistr('Datenbank\00FCberwachung')
,p_list_item_link_target=>'f?p=4500:11:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(719032044422154756.4353)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719035949725154759.4353)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:500:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(719030888019154756.4353)
,p_security_scheme=>wwv_flow_api.id(802975422996792935)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719036265816154759.4353)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Team Development Drilldown'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_api.id(178932029578737472)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719036528727154759.4353)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Labels'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(719036265816154759.4353)
,p_security_scheme=>wwv_flow_api.id(438804333233472199)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719036845294154759.4353)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Meilensteine'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(719036265816154759.4353)
,p_security_scheme=>wwv_flow_api.id(438804333233472199)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719037185918154759.4353)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(719036265816154759.4353)
,p_security_scheme=>wwv_flow_api.id(438804333233472199)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719037431531154759.4353)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Utilitys'
,p_list_item_link_target=>'f?p=4600:2000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719036265816154759.4353)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719038069849154760.4353)
,p_list_item_display_sequence=>355
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(719036265816154759.4353)
,p_security_scheme=>wwv_flow_api.id(438804333233472199)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719038374173154760.4353)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(719036265816154759.4353)
,p_security_scheme=>wwv_flow_api.id(438804333233472199)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(719042571176154767.4353)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Galerie'
,p_list_item_link_target=>'f?p=4750:50:&APP_SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_api.id(438804333233472199)
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(812019673460140.4353)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1658706047402744.4353)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14858900882941039.4353)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91990218532572393.4353)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844733195888905.4353)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128807885506820.4353)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236054414709447.4353)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072435389712055.4353)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780149340994154.4353)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917632266890939884.4353)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_builder_workspace_authentication
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(1309004604808814.4353)
,p_name=>'APEX Builder Workspace Authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication = ''APEX'';'
,p_error_message=>'Die Entwicklungsumgebung verwendet die externe Authentifizierung'
,p_reference_id=>786940505486177571.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(6738625560859071.4353)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>'Builder-SSO ist nicht aktiviert'
,p_reference_id=>6738410669854771.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12518728403445471.4353)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>unistr('Sie sind nicht f\00FCr das Verwalten von Anwendungen autorisiert:')
,p_reference_id=>12511219858301010.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/user_is_a_developer
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(47302021031728224.4353)
,p_name=>'user is a developer'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_security.user_can_develop_any_flow;'
,p_error_message=>'Es kann nicht ermittelt werden, ob der Benutzer ein Entwickler ist (f4350)'
,p_reference_id=>786938431231163276.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178931223495737450.4353)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>unistr('Keine Berechtigung f\00FCr versuchten Vorgang')
,p_reference_id=>786516029127697713.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178931519479737472.4353)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'Sie sind nicht berechtigt, SQL Workshop zu verwenden.'
,p_reference_id=>786516265251697717.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178932029578737472.4353)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>unistr('Team Development ist f\00FCr diesen Workspace nicht aktiviert')
,p_reference_id=>786516861027697723.4353
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(438804333233472199.4353)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>unistr('Sie sind nicht f\00FCr das Verwalten von Anwendungen autorisiert:')
,p_reference_id=>12511219858301010.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/websheet_create_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(771323113864288687.4353)
,p_name=>'Websheet Create Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce( wwv_flow_platform.get_preference(''WEBSHEET_CREATE_ENABLED''), ''N'' ) = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>unistr('F\00FCr den Zugriff auf diese Seite muss die Websheet-Anwendung aktiviert sein.')
,p_reference_id=>771322804043281981.4353
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(802975422996792935.4353)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>unistr('Keine Berechtigung f\00FCr versuchten Vorgang')
,p_reference_id=>786519856057734816.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/service_requests_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(916538108136873611.4353)
,p_name=>'Service Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>unistr('Keine Berechtigung f\00FCr versuchten Vorgang.')
,p_reference_id=>786932326296107981.4353
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_administration_app_access
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(1367105411776376234.4353)
,p_name=>'APEX 5.0 Administration App Access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  if :APP_PAGE_ID in (0, 1, 3, 9, 11, 28, 58, 68, 102, 577) then',
'      --',
'      -- approved unrestricted pages for development environment',
'      -- - 0 ....... global page',
'      -- - 1 ....... start page',
'      -- - 3 ....... Edit Profile',
'      -- - 9 ....... about page',
'      -- - 11 ...... current user preferences',
'      -- - 28 ...... purge preferences',
'      -- - 58/68 ... change password',
'      -- - 102 ..... preferences',
'      -- - 577 ..... help',
'      --',
'      return true;',
'',
'  else',
'      --',
'      -- developer or admin',
'      --',
'      return    wwv_flow_authorization.is_authorized_developer (',
'                    p_developer_authorization => ''EDIT'' )',
'             or wwv_flow_authorization.is_authorized_developer (',
'                    p_developer_authorization => ''ADMIN'' );',
'  end if;'))
,p_error_message=>unistr('Keine Berechtigung f\00FCr versuchten Vorgang.')
,p_reference_id=>1367104867544331898.4353
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(1364606893206165.4353)
,p_icon_sequence=>10
,p_icon_subtext=>'Workspace &COMPANY.'
,p_icon_target=>'f?p=4500:1000:&SESSION.'
,p_icon_image_alt=>'Workspace &COMPANY.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(334060323997944127.4353)
,p_icon_sequence=>20
,p_icon_subtext=>'( <span style="text-decoration:underline;">Workspace wechseln</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'Workspace wechseln'
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond=>'73'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_api.id(6738625560859071)
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(39960115843641093.4353)
,p_icon_sequence=>30
,p_icon_subtext=>'( <span style="text-decoration:underline;">Abmelden</span> )'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Abmelden'
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond=>'73'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(203635014114430938.4353)
,p_icon_sequence=>40
,p_icon_subtext=>'Feedback'
,p_icon_target=>'javascript:popupURL(''f?p=4350:102:&SESSION.:::102:P102_APPLICATION_ID,P102_PAGE_ID:&APP_ID.,&APP_PAGE_ID.'');'
,p_nav_entry_is_feedback_yn=>'Y'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/spotlightindex
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(234080313327980030.4353)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'spotlightIndex'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_spotlight_dev.emit_spotlight_index(',
'    p_app_id           => wwv_flow.g_x01,',
'    p_get_apps_list    => wwv_flow.g_x02);'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/logic/application_items/auth_type
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(344359629554721697.4353)
,p_name=>'AUTH_TYPE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(47267012470443025.4353)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4350_password_region_title
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(288025200211732904.4353)
,p_name=>'F4350_PASSWORD_REGION_TITLE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(61498215760312449.4353)
,p_name=>'FB_FLOW_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'same as flow 4000 fb_flow_id'
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_page_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(61665618599751270.4353)
,p_name=>'FB_FLOW_PAGE_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(72751304929301595.4353)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
);
end;
/
prompt --application/shared_components/logic/application_items/g_user_default_date_format
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(367481423382175901.4353)
,p_name=>'G_USER_DEFAULT_DATE_FORMAT'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This global item is included here, in case the user edits themselves on 4350:56, or via the Preferences dialog in the account mega menu.  For now, though, this item value is really only used in 4500 - to set the default date format for a user in SQL '
||'Workshop.'
);
end;
/
prompt --application/shared_components/logic/application_items/last_view
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(48609214118039317.4353)
,p_name=>'LAST_VIEW'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(47267211793445016.4353)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Workspace-Name kann nicht berechnet werden.'
);
end;
/
prompt --application/shared_components/logic/application_computations/f4350_password_region_title
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(288081418528785501.4353)
,p_computation_sequence=>10
,p_computation_item=>'F4350_PASSWORD_REGION_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.''||replace(wwv_flow_authentication_dev.get_internal_authentication,''DB'',''LDAP'')||''-AUTH'')'
,p_compute_when=>'F4350_PASSWORD_REGION_TITLE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/shared_components/logic/application_computations/auth_type
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(344361727169737998.4353)
,p_computation_sequence=>10
,p_computation_item=>'AUTH_TYPE'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_authentication_dev.get_internal_authentication'
);
end;
/
prompt --application/shared_components/logic/application_computations/last_view
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(486954604915667072.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'1'
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/account_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2740022841418968.4353)
,p_lov_name=>'ACCOUNT STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(2740022841418968.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2740201351418968.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gesperrte Accounts'
,p_lov_return_value=>'LOCKED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2741315831435879.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Abgelaufener Account'
,p_lov_return_value=>'EXPIRED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2740411765418968.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Entsperrte Accounts'
,p_lov_return_value=>'UNLOCKED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2740609662418968.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Mein Account'
,p_lov_return_value=>'MY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12456720246979195.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Entwickler-Accounts'
,p_lov_return_value=>'DEV'
);
end;
/
prompt --application/shared_components/user_interface/lovs/account_lock_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6949526744661130.4353)
,p_lov_name=>'ACCOUNT_LOCK_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(6949526744661130.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6949718368661130.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gesperrt'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6949911078661130.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Entsperrt'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/activity_log_request_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1569139039593351202.4353)
,p_lov_name=>'ACTIVITY_LOG.REQUEST_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(1569139039593351202.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1569139334794351203.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Weitere'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1569139617444351205.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Verarbeitung'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1569139936155351205.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Rendering'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1569140273759351210.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'AJAX'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1570578733042936737.4353)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Abmelden'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1570579027818937857.4353)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Authentifizierungs-Callback'
,p_lov_return_value=>'5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_opt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87986129403049299.4353)
,p_lov_name=>'APPLICATION.OPT'
,p_lov_query=>'.'||wwv_flow_api.id(87986129403049299.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87986300136049300.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Alle Anwendungen'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87986529393049300.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nach Anwendung gruppieren'
,p_lov_return_value=>'F'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_build_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(128034726363912582.4353)
,p_lov_name=>'APPLICATION_BUILD_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(128034726363912582.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(128035028761912584.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Anwendung nur ausf\00FChren')
,p_lov_return_value=>'RUN_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(128035201383912585.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Anwendung ausf\00FChren und erstellen')
,p_lov_return_value=>'RUN_AND_BUILD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_naming
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(27067106427412398.4353)
,p_lov_name=>'AUDIT_NAMING'
,p_lov_query=>'.'||wwv_flow_api.id(27067106427412398.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27067418961412413.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Anwendungsattribute'
,p_lov_return_value=>'WWV_FLOWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27067615785412414.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Seitentemplate'
,p_lov_return_value=>'WWV_FLOW_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27067821285412414.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Navigationsleiste'
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27068018297412414.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Anwendungsprozess'
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27068231633412415.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Anwendungselement'
,p_lov_return_value=>'WWV_FLOW_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27068428780412415.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Anwendungsberechnung'
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27068600233412415.4353)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Registerkarten'
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27068829004412415.4353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('\00DCbergeordnete Registerkarte')
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27069029470412416.4353)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Werteliste'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES$'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27069224657412416.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Statische Wertelistenwerte'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES_DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192815107467123331.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Navigationspfadeintrag'
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192920211428952731.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Themes'
,p_lov_return_value=>'WWV_FLOW_THEMES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27069403307412416.4353)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Seitenattribute'
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27069616679412416.4353)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Seitenschaltfl\00E4che')
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27069821202412416.4353)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Seitenverzweigung'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27070027988412417.4353)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Seitenverzweigungsargumente'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCH_ARGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27070221339412417.4353)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Seitenelement'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27071724781417713.4353)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Seitenberechnung'
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27072029975419290.4353)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Seitenvalidierung'
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27072303095420909.4353)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Seitenprozess'
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27072608636422556.4353)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Regionstemplate'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27072914523424290.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Zeilentemplate'
,p_lov_return_value=>'WWV_FLOW_ROW_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27073219717425765.4353)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Listentemplate'
,p_lov_return_value=>'WWV_FLOW_LIST_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27073525951427595.4353)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Regionsattribute'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27073802879430378.4353)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Nachrichten'
,p_lov_return_value=>'WWV_FLOW_MESSAGES$'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27074108074431803.4353)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Erstelloptionen'
,p_lov_return_value=>'WWV_FLOW_PATCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27074413269433395.4353)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Anwendungsentwickler (Administration)'
,p_lov_return_value=>'WWV_FLOW_DEVELOPERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27074718809434925.4353)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Listen'
,p_lov_return_value=>'WWV_FLOW_LISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27075025043436756.4353)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'Listenelement'
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27075332315438853.4353)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>'Effektive Benutzer-ID (Administration)'
,p_lov_return_value=>'WWV_FLOW_EFFECTIVE_USERID_MAP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27075705781440636.4353)
,p_lov_disp_sequence=>29
,p_lov_disp_value=>'Shortcuts'
,p_lov_return_value=>'WWV_FLOW_SHORTCUTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27076012361442576.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Hilfetext f\00FCr Seitenelement')
,p_lov_return_value=>'WWV_FLOW_STEP_ITEM_HELP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27076318248444200.4353)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Authentifizierungsschemas'
,p_lov_return_value=>'WWV_FLOW_AUTHENTICATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27076624481446067.4353)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Einstiegspunkte'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27076929330447428.4353)
,p_lov_disp_sequence=>33
,p_lov_disp_value=>'Einstiegspunktargumente'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINT_ARGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/available_applications
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(249067832108758740.4353)
,p_lov_name=>'AVAILABLE.APPLICATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/build_option_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(140229800819566260.4353)
,p_lov_name=>'BUILD OPTION STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(140229800819566260.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(140230006090566264.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ausschlie\00DFen')
,p_lov_return_value=>'EXCLUDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(140230221897566265.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Einbeziehen'
,p_lov_return_value=>'INCLUDE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cache_mode_page_and_region
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(672366941474304666.4353)
,p_lov_name=>'CACHE_MODE (PAGE AND REGION)'
,p_lov_query=>'.'||wwv_flow_api.id(672366941474304666.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(672367283233304668.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deaktiviert'
,p_lov_return_value=>'NOCACHE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(672367558201304670.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Aktiviert'
,p_lov_return_value=>'CACHE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(672367830895304670.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Cache pro Benutzer'
,p_lov_return_value=>'USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(672368194869304670.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Nach Session cachen'
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_selector
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(46971429951226857.4353)
,p_lov_name=>'CHART SELECTOR'
,p_lov_query=>'.'||wwv_flow_api.id(46971429951226857.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46971618940226861.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seitenereignisse pro Tag'
,p_lov_return_value=>'DAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46971819569226863.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Seitenereignisse pro Stunde'
,p_lov_return_value=>'HOUR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_mult_user_strip_domain
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(486946000320608950.4353)
,p_lov_name=>'CREATE.MULT.USER.STRIP.DOMAIN'
,p_lov_query=>'.'||wwv_flow_api.id(486946000320608950.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(486946203862608959.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Benutzername auf vollst\00E4ndige E-Mail-Adresse festlegen')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(486946418606608967.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('@ Domain als Teil des Benutzernamens ausschlie\00DFen')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/debug_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(370258657315557256.4353)
,p_lov_name=>'DEBUG_LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(370258657315557256.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370258984893557257.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Fehler'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370259375821557258.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Warnen'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370260147407557258.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Informationen'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370260586898557259.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Application Enter'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370260960387557259.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Application Trace'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370261795886557259.4353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'APEX Enter'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370262151966557260.4353)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'APEX Trace'
,p_lov_return_value=>'9'
);
end;
/
prompt --application/shared_components/user_interface/lovs/developer_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(19716823057593749.4353)
,p_lov_name=>'DEVELOPER TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(19716823057593749.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19717103805593761.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ja'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19717515342593765.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Nein'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/error_components
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(213967127754264881.4353)
,p_lov_name=>'ERROR COMPONENTS'
,p_lov_query=>'.'||wwv_flow_api.id(213967127754264881.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213967320847264904.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Numerisches Element'
,p_lov_return_value=>'numeric_item'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213967522885264905.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Deeplink'
,p_lov_return_value=>'deep_link'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213967714663264905.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Prozess "Element festlegen"'
,p_lov_return_value=>'set_item_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213967927620264905.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Prozess "Tabellarisches Formular hinzuf\00FCgen"')
,p_lov_return_value=>'add_rows_to_tabular_form'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213968132430264906.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Prozess "Tabellarisches Formular aktualisieren"'
,p_lov_return_value=>'multi_row_update_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213968319995264906.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Prozess "Tabellarisches Formular l\00F6schen"')
,p_lov_return_value=>'multi_row_delete_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213968503762264906.4353)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Prozess "Zeile abrufen"'
,p_lov_return_value=>'dml_fetch_row_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213968724423264906.4353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Prozess "Web Service"'
,p_lov_return_value=>'web_service_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213968927764264907.4353)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Prozess "Zeilenprozess"'
,p_lov_return_value=>'dml_process_row_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6204524790478230.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bericht'
,p_lov_return_value=>'report'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213969130796264907.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ajax Callback-Prozess'
,p_lov_return_value=>'on_demand_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213991320267272102.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Element auf Voreinstellungsberechnung festlegen'
,p_lov_return_value=>'set_item_eq_preference_computation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217558320349371396.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PL/SQL-Bedingung'
,p_lov_return_value=>'plsql_condition'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217562125113391685.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'SQL-Bedingung'
,p_lov_return_value=>'sql_condition'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217566117626398980.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bedingung "Exists" oder "Not exists"'
,p_lov_return_value=>'exists_condition'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213969326112264907.4353)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('N\00E4chsten oder vorherigen Prim\00E4rschl\00FCsselprozess abrufen')
,p_lov_return_value=>'get_next_or_prev_pk_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213969502182264907.4353)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Voreinstellungsprozess festlegen'
,p_lov_return_value=>'set_preference_process'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213970706415268145.4353)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Abfrageberechnung'
,p_lov_return_value=>'query_computation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213991925115273511.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'SQL- oder PL/SQL-Berechnung'
,p_lov_return_value=>'sql_or_plsql_computation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217558927275373351.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Bedingung f\00FCr PL/SQL-Funktionsbody')
,p_lov_return_value=>'plsql_function_body_condition'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213992700658275906.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Berechnung des PL/SQL-Funktionsbodys'
,p_lov_return_value=>'plsql_function_body_computation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213993708970278348.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Validierung von SQL Exists oder Not Exists'
,p_lov_return_value=>'exists_noexists_validation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213994314164279816.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Validierung von PL/SQL-Fehler'
,p_lov_return_value=>'plsql_error_validation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213995019705281413.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Validierung von Funktionsbody'
,p_lov_return_value=>'function_body_validation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213997002867286002.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('PL/SQL-Funktionsbody, der eine boolesche Validierung zur\00FCckgibt')
,p_lov_return_value=>'function_body_returning_boolean_validation'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213998211525288587.4353)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Verzweigung'
,p_lov_return_value=>'branch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213999116719290082.4353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Element festlegen'
,p_lov_return_value=>'set_page_item_source'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(213999821568291451.4353)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'VPD festlegen'
,p_lov_return_value=>'set_vpd'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214000123646292003.4353)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('Cacheinhalt l\00F6schen')
,p_lov_return_value=>'clear_cache'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214000527455293116.4353)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Sessionzustand speichern'
,p_lov_return_value=>'save_session_state'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214000932650294668.4353)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Validierung'
,p_lov_return_value=>'error_performing_validations'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214001904037295831.4353)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Validierung'
,p_lov_return_value=>'error_performing_after_submit_processes'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214002814080298744.4353)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'PL/SQL-Ausdrucksbedingung'
,p_lov_return_value=>'check_cond_plsql_expresion'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214003320660300665.4353)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('Funktion, die eine SQL-Abfrage zur\00FCckgibt')
,p_lov_return_value=>'function_returning_sql_query'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214004324469301777.4353)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Shortcut'
,p_lov_return_value=>'shortcut'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214004928625302922.4353)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'SVG-Diagramm'
,p_lov_return_value=>'svg_chart'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214005332434304022.4353)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'web_service'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214005802437304830.4353)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Diagramm'
,p_lov_return_value=>'chart'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214007008324306555.4353)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'PL/SQL-Prozess'
,p_lov_return_value=>'plsql_procedure'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214007511094307342.4353)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Kalender'
,p_lov_return_value=>'calendar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214007915250308517.4353)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Hilfeprozess'
,p_lov_return_value=>'help'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214008318713309562.4353)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'URL-Region'
,p_lov_return_value=>'url_region'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214009321483310394.4353)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Liste'
,p_lov_return_value=>'list'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214009624600311246.4353)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Listeneintrag'
,p_lov_return_value=>'list_entry'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(214010231180313173.4353)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>unistr('PL/SQL-Funktion, die SQL-Abfrage zur\00FCckgibt')
,p_lov_return_value=>'function_returning_sql_query'
);
end;
/
prompt --application/shared_components/user_interface/lovs/expire_user_accounts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4834509455047185.4353)
,p_lov_name=>'EXPIRE USER ACCOUNTS'
,p_lov_query=>'.'||wwv_flow_api.id(4834509455047185.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4834812383047193.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Aktivieren'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4835016591047194.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Deaktivieren'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/f4350_fnd_group_ids
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(226642419934369326.4353)
,p_lov_name=>'F4350_FND_GROUP_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/f4350_p54_fnd_group_ids
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(132393417969824419.4353)
,p_lov_name=>'F4350_P54_FND_GROUP_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
'   and (:F4350_P54_ID is null or id <> :F4350_P54_ID)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_developers
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17062423464336902.4353)
,p_lov_name=>'FLOW_DEVELOPERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(USERID) d, USERID r',
'from  WWV_FLOW_developers',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fnd_users
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17066627882357077.4353)
,p_lov_name=>'FND USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) d, user_name r',
'from wwv_flow_fnd_user',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fnd_user_ids
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(132392525949820706.4353)
,p_lov_name=>'FND_USER_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) d, user_id r',
'  from wwv_flow_fnd_user',
' where security_group_id = :flow_security_group_id',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(488871706659155481.4353)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/geometry_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(564913925652056229.4353)
,p_lov_name=>'GEOMETRY_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(564913925652056229.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564914217900056240.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Punkte'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#|map-points'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564914657535056250.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Linien'
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#|map-lines'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564915040581056251.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Polygone'
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#|map-polygons'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564915422094056251.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Heatmap'
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#|map-heatmap'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564915841668056252.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Extrudierte Polygone'
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#|map-extruded-polgygons'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564983430244090637.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Unbekannt'
,p_lov_return_value=>'UNKNOWN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/group_grantee_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(132386709008105935.4353)
,p_lov_name=>'GROUP_GRANTEE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(132386709008105935.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(132387009720105943.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Benutzer'
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(132387327177105947.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Gruppe'
,p_lov_return_value=>'G'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_or_detail
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(135219829572410772.4353)
,p_lov_name=>'ICON OR DETAIL'
,p_lov_query=>'.'||wwv_flow_api.id(135219829572410772.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135220002122410781.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Symbole'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135220205520410794.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(48455120589630644.4353)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_api.id(48455120589630644.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48455420960630650.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('T\00E4glich')
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48455617407630651.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('W\00F6chentlich')
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48455822694630651.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Monatlich'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(619315906303328344.4353)
,p_lov_name=>'IR_NOTIFY_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(619315906303328344.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(619316124110328372.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Weitergeleitet'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(619316313660328373.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Gesendet'
,p_lov_return_value=>'SENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(619316501456328373.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Fehler'
,p_lov_return_value=>'ERROR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/issues_fs_limit
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(567784794163789852.4353)
,p_lov_name=>'ISSUES_FS_LIMIT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'RV'
,p_display_column_name=>'DV'
);
end;
/
prompt --application/shared_components/user_interface/lovs/license_terms
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87991106556118398.4353)
,p_lov_name=>'LICENSE.TERMS'
,p_lov_query=>'.'||wwv_flow_api.id(87991106556118398.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87991314955118399.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Sie sind kein Staatsb\00FCrger oder Einwohner der L\00E4nder Kuba, Iran, Sudan, Irak, Libyen (Volksrepublik), Nordkorea und Syrien und Sie werden auch nicht von den Regierungen dieser L\00E4nder kontrolliert. Dies gilt au\00DFerdem f\00FCr alle anderen L\00E4nder, f\00FCr die E')
||unistr('xportbeschr\00E4nkungen mit den USA gelten.')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87991524166118399.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Sie verpflichten sich, die Programme weder direkt noch indirekt in den oben angegebenen L\00E4ndern und auch nicht den Staatsb\00FCrgern bzw. Einwohnern dieser L\00E4nder zum Herunterladen oder anderweitigen Export bzw. Reexport zur Verf\00FCgung zu stellen.')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87991705582118400.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Sie werden nicht in den Listen "Specially Designated Nationals", "Specially Designated Terrorists" oder "Specially Designated Narcotic Traffickers" des United States Department of Treasury gef\00FChrt. Au\00DFerdem sind Sie nicht in der "Table of Denial Orde')
||'rs" des United States Department of Commerce registriert.'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87991919165118400.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Sie verpflichten sich, die Programme weder direkt noch indirekt den Personen auf den oben angegebenen Listen zum Herunterladen oder anderweitigen Export bzw. Reexport zur Verf\00FCgung zu stellen.')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87992103676118400.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Sie verpflichten sich, die Programme ausschlie\00DFlich im Rahmen der Gesetzgebung der USA zu verwenden bzw. deren Verwendung nicht zuzulassen, wenn dadurch gegen die geltenden gesetzlichen Bestimmungen der USA versto\00DFen wird. Hierzu geh\00F6ren ohne Einschr')
||unistr('\00E4nkung die Entwicklung, das Design, die Herstellung oder Produktion nuklearer, chemischer oder biologischer Waffen zur Massenvernichtung.')
,p_lov_return_value=>'5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_schemas
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(47395026667651380.4353)
,p_lov_name=>'LIST SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(upper(c.schema)) d, ',
'       upper(c.schema) v',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u ',
'where  c.security_group_id = :flow_security_group_id and ',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :app_user and ',
'       (',
'           u.ALLOW_ACCESS_TO_SCHEMAS is null or ',
'           instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(75646032643247381.4353)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_database_websheet_app
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(492205918121347540.4353)
,p_lov_name=>'LIST_DATABASE_WEBSHEET_APP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id d, id r',
'from wwv_flows',
'where security_group_id = :flow_security_group_id',
'union all',
'select id d, id r',
'from wwv_flow_ws_applications',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flow_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(473904019503385140.4353)
,p_lov_name=>'LIST_FLOW_STATUS'
,p_reference_id=>634347472712995.4353
,p_lov_query=>'.'||wwv_flow_api.id(473904019503385140.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741165654528290723.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Verf\00FCgbar')
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741165942786290723.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Mit Entwicklersymbolleiste verf\00FCgbar')
,p_lov_return_value=>'AVAILABLE_W_EDIT_LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741166239367290723.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Nur f\00FCr Entwickler verf\00FCgbar')
,p_lov_return_value=>'DEVELOPERS_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741166576972290723.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Eingeschr\00E4nkter Zugriff')
,p_lov_return_value=>'RESTRICTED_ACCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741166880777290723.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Nicht verf\00FCgbar')
,p_lov_return_value=>'UNAVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741167165338290723.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Nicht verf\00FCgbar (Status mit PL/SQL angezeigt)')
,p_lov_return_value=>'UNAVAILABLE_PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741167446373290724.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Nicht verf\00FCgbar (Zu URL umleiten)')
,p_lov_return_value=>'UNAVAILABLE_URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_status_codes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42705425134693211.4353)
,p_lov_name=>'LOGIN STATUS CODES'
,p_lov_query=>'.'||wwv_flow_api.id(42705425134693211.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42705704364693212.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normale, erfolgreiche Authentifizierung'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42705921465693213.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unbekannter Benutzername'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42706121390693213.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Account gesperrt'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42706310776693213.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Account abgelaufen'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42706524529693213.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Falsches Kennwort'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42706719666693213.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Erste Verwendung des Kennworts'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42706921482693213.4353)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Maximale Anmeldeversuche \00FCberschritten')
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42707119263693213.4353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Unbekannter interner Fehler'
,p_lov_return_value=>'7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_a
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87960028308944903.4353)
,p_lov_name=>'MAX_ROWS_A'
,p_lov_query=>'.'||wwv_flow_api.id(87960028308944903.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87960228677944903.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87960404998944904.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87960630117944904.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87960804805944904.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87961014605944904.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87961204075944904.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87961414470944905.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87961615644944905.4353)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87961828775944905.4353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_b
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87962402466946929.4353)
,p_lov_name=>'MAX_ROWS_B'
,p_lov_query=>'.'||wwv_flow_api.id(87962402466946929.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87962624364946930.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87962825427946930.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87963028889946930.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87963219513946930.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87963422128946931.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87963617026946932.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87963820242946932.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87964018632946932.4353)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87964228487946933.4353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_c
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87964809046948816.4353)
,p_lov_name=>'MAX_ROWS_C'
,p_lov_query=>'.'||wwv_flow_api.id(87964809046948816.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87965020267948816.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87965202237948817.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87965404786948817.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87965623655948817.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87965801422948818.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'40'
,p_lov_return_value=>'40'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87966019499948818.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87966204425948818.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87966405087948818.4353)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87966620020948818.4353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87966830048948820.4353)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87967016319948821.4353)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87967217418948821.4353)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87967415888948821.4353)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'50000'
,p_lov_return_value=>'50000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_d
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87968118050951423.4353)
,p_lov_name=>'MAX_ROWS_D'
,p_lov_query=>'.'||wwv_flow_api.id(87968118050951423.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87968314659951424.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87968522241951424.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87968709744951424.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87968903454951425.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87969114479951425.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87969329781951426.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87969508652951427.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87969708972951427.4353)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87969903261951427.4353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_or_existing_schema
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(245496725063109254.4353)
,p_lov_name=>'NEW_OR_EXISTING_SCHEMA'
,p_lov_query=>'.'||wwv_flow_api.id(245496725063109254.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(245497113141109261.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Neues Schema anfordern'
,p_lov_return_value=>'YES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(245496930435109257.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Vorhandenes Schema verwenden'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/operating_systems
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87980828664020704.4353)
,p_lov_name=>'OPERATING.SYSTEMS'
,p_lov_query=>'.'||wwv_flow_api.id(87980828664020704.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87981029047020705.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'HP-Tru64Unix'
,p_lov_return_value=>'HP-Tru64Unix'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87981205950020705.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'HP-UX'
,p_lov_return_value=>'HP-UX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87981403269020706.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'IBM-AIX'
,p_lov_return_value=>'IBM-AIX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87981618293020706.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Linux'
,p_lov_return_value=>'Linux'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87981814646020706.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'MS-NT'
,p_lov_return_value=>'MS-NT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87982016496020707.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'MS-WIN2000'
,p_lov_return_value=>'MS-WIN2000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87982226769020707.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'MS-XP'
,p_lov_return_value=>'MS-XP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87982430599020707.4353)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Weitere'
,p_lov_return_value=>'Other'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87982601452020707.4353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'OtherUnix'
,p_lov_return_value=>'OtherUnix'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87982816960020707.4353)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Sun-Solaris'
,p_lov_return_value=>'Sun-Solaris'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p105_banner_colors
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2923311877329862.4353)
,p_lov_name=>'P105_BANNER_COLORS'
,p_lov_query=>'.'||wwv_flow_api.id(2923311877329862.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2923606335329869.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Akzent 1'
,p_lov_return_value=>'accent-1'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--1" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2924030617329871.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Akzent 2'
,p_lov_return_value=>'accent-2'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--2" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2924482125329871.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Akzent 3'
,p_lov_return_value=>'accent-3'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--3" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2924844373329871.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Akzent 4'
,p_lov_return_value=>'accent-4'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--4" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2925210600329872.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Akzent 5'
,p_lov_return_value=>'accent-5'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--5" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2925682541329872.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Akzent 6'
,p_lov_return_value=>'accent-6'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--6" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2926003654329872.4353)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Akzent 7'
,p_lov_return_value=>'accent-7'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--7" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2926498633329872.4353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Akzent 8'
,p_lov_return_value=>'accent-8'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--8" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1705927812985375.4353)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Akzent 9'
,p_lov_return_value=>'accent-9'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--9" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1706293063985375.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Akzent 10'
,p_lov_return_value=>'accent-10'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--10" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1706622516985375.4353)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Akzent 11'
,p_lov_return_value=>'accent-11'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--11" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1707047271985376.4353)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Akzent 12'
,p_lov_return_value=>'accent-12'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--12" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1707417007985376.4353)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Akzent 13'
,p_lov_return_value=>'accent-13'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--13" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1707841564985376.4353)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Akzent 14'
,p_lov_return_value=>'accent-14'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--14" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1708237027985376.4353)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Akzent 15'
,p_lov_return_value=>'accent-15'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--15" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1708692327985376.4353)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Akzent 16'
,p_lov_return_value=>'accent-16'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--16" aria-label="#DISPLAY_VALUE#"></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p105_banner_pos
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(146455139760592304.4353)
,p_lov_name=>'P105_BANNER_POS'
,p_lov_query=>'.'||wwv_flow_api.id(146455139760592304.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(146455485967592300.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Links'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(146455844060592294.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oben'
,p_lov_return_value=>'TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2020_ws_obj_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(628838348305108438.4353)
,p_lov_name=>'P2020_WS_OBJ_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(628838348305108438.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(628838684612108439.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('G\00FCltig')
,p_lov_return_value=>'VALID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(628838943749108440.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Ung\00FCltig')
,p_lov_return_value=>'INVALID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2020_ws_obj_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(628812792905024497.4353)
,p_lov_name=>'P2020_WS_OBJ_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(628812792905024497.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(628813001940024498.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabelle'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(628813323857024500.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sequenz'
,p_lov_return_value=>'SEQUENCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p216_monitor
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22415219367679656.4353)
,p_lov_name=>'P216_MONITOR'
,p_lov_query=>'.'||wwv_flow_api.id(22415219367679656.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22415404656679665.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seitenansichten'
,p_lov_return_value=>'PV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22416003914684720.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Browserinformationen'
,p_lov_return_value=>'BI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22416612918687252.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Werte f\00FCr den Sessionzustand')
,p_lov_return_value=>'SS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(228539708561074614.4353)
,p_lov_name=>'PAGE MODE'
,p_lov_query=>'.'||wwv_flow_api.id(228539708561074614.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(228539924927074625.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamisch'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(228540132030074635.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cache erstellt'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(228540313915074635.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Gecacht'
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(130988608718459028.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Seitenverarbeitung'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131016603205684510.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seitenbestandteile'
,p_lov_return_value=>'P'
);
end;
/
prompt --application/shared_components/user_interface/lovs/person_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87979323684009856.4353)
,p_lov_name=>'PERSON.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(87979323684009856.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87979519786009857.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mitarbeiter'
,p_lov_return_value=>'E'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87979702743009857.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Vertragspartner'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plsql_editing_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113937100137241641.4353)
,p_lov_name=>'PLSQL EDITING STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(113937100137241641.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113937313482241642.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bearbeiten von PL/SQL-Programmblock zulassen'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113937510829241642.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Bearbeiten von PL/SQL-Programmblock nicht zulassen'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/preference_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42506917060665623.4353)
,p_lov_name=>'PREFERENCE TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(42506917060665623.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42507201651665624.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Seitensortierung'
,p_lov_return_value=>'SORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42507416214665624.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Weitere'
,p_lov_return_value=>'OTHER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42507628021665624.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Session\00FCbergreifender Elementwert')
,p_lov_return_value=>'ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/preference_window_mgmt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(698047789180011733.4353)
,p_lov_name=>'PREFERENCE_WINDOW_MGMT'
,p_lov_query=>'.'||wwv_flow_api.id(698047789180011733.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698048021582011735.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('In neuem Fenster \00F6ffnen, wenn Fokus erzwungen werden muss')
,p_lov_return_value=>'FOCUS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698048351664011737.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Einzelnes Fenster f\00FCr alle Anwendungen')
,p_lov_return_value=>'ONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/privileges
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87973907708976827.4353)
,p_lov_name=>'PRIVILEGES'
,p_lov_query=>'.'||wwv_flow_api.id(87973907708976827.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87974125418976828.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Administration'
,p_lov_return_value=>'ADMIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87974326105976828.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Durchsuchen'
,p_lov_return_value=>'BROWSE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87974520374976829.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Erstellen'
,p_lov_return_value=>'CREATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87974700192976829.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Data Loader'
,p_lov_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87974908440976829.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('DB-\00DCberwachung')
,p_lov_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87975104201976829.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Bearbeiten'
,p_lov_return_value=>'EDIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87975319689976830.4353)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Hilfe'
,p_lov_return_value=>'HELP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87975514156976830.4353)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('\00DCberwachen')
,p_lov_return_value=>'MONITOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87975715979976830.4353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87975929098976830.4353)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Benutzer-Manager'
,p_lov_return_value=>'USER_MANAGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(876530482469714.4353)
,p_lov_name=>'RECENT TIME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time_archive
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(880120182357116546.4353)
,p_lov_name=>'RECENT_TIME_ARCHIVE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual  union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual  union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual  union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual  union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_caching_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42414417202633712.4353)
,p_lov_name=>'REGION CACHING OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(42414417202633712.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42414713865633714.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Gecacht'
,p_lov_return_value=>'CACHED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42414915904633714.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Gecacht pro Benutzer'
,p_lov_return_value=>'CACHED_BY_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42415123252633714.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Nicht gecacht'
,p_lov_return_value=>'NOT_CACHED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reporting_period
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(180662003103161233.4353)
,p_lov_name=>'REPORTING PERIOD'
,p_lov_query=>'.'||wwv_flow_api.id(180662003103161233.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180662201590161236.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1 Tag'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180662407591161239.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'1 Woche'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180663409336163078.4353)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'2 Wochen'
,p_lov_return_value=>'2W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180662601241161239.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'1 Monat'
,p_lov_return_value=>'M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180708018527279245.4353)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'2 Monate'
,p_lov_return_value=>'2M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180713228570282104.4353)
,p_lov_disp_sequence=>31.5
,p_lov_disp_value=>'3 Monate'
,p_lov_return_value=>'3M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180713023722280779.4353)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'6 Monate'
,p_lov_return_value=>'6M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180662822420161239.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'1 Jahr'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180714418789298237.4353)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'2 Jahre'
,p_lov_return_value=>'2Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180714621214298964.4353)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5 Jahre'
,p_lov_return_value=>'5Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reqeuest_service
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(168289505113227142.4353)
,p_lov_name=>'REQEUEST SERVICE'
,p_lov_query=>'.'||wwv_flow_api.id(168289505113227142.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168289817280227144.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Schema anfordern'
,p_lov_return_value=>'SCHEMA'
,p_lov_template=>'#DISPLAY_VALUE#| icon-request-schema'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168290023589227145.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Speicherplatz anfordern'
,p_lov_return_value=>'STORAGE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-request-storage'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168290203148227145.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Ende anfordern'
,p_lov_return_value=>'TERMINATION'
,p_lov_template=>'#DISPLAY_VALUE#| icon-request-termination'
);
end;
/
prompt --application/shared_components/user_interface/lovs/request_statuses
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(378143515851142224.4353)
,p_lov_name=>'REQUEST_STATUSES'
,p_lov_query=>'.'||wwv_flow_api.id(378143515851142224.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378143812022142228.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'In Arbeit'
,p_lov_return_value=>'IN_PROGRESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378144114463142229.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Angefordert'
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378144422710142229.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Akzeptiert'
,p_lov_return_value=>'ACCEPTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378144722168142229.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Abgelehnt'
,p_lov_return_value=>'DECLINED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378145031757142229.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Genehmigt'
,p_lov_return_value=>'APPROVED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378145330379142229.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Vorgang wird beendet'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378145610822142229.4353)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Vorgang wird beendet'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378145905326142229.4353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Vorgang wird beendet'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378146205625142229.4353)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Vorgang wird beendet'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378146515175142230.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vorgang wird beendet'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378146800022142230.4353)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Vorgang wird beendet'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(378147120846142230.4353)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Beendet'
,p_lov_return_value=>'TERMINATED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1402706982624090.4353)
,p_lov_name=>'SECONDS'
,p_lov_query=>'.'||wwv_flow_api.id(1402706982624090.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1403090812624094.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 Minute'
,p_lov_return_value=>'60'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1403420883624096.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5 Minuten'
,p_lov_return_value=>'300'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1403804695624096.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'10 Minuten'
,p_lov_return_value=>'600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1404259929624097.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'30 Minuten'
,p_lov_return_value=>'1800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1404676599624097.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'1 Stunde'
,p_lov_return_value=>'3600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1405062127624098.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'2 Stunden'
,p_lov_return_value=>'7200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1405454859624098.4353)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5 Stunden'
,p_lov_return_value=>'18000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1405868110624098.4353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'10 Stunden'
,p_lov_return_value=>'36000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds_small
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1508766038293211.4353)
,p_lov_name=>'SECONDS_SMALL'
,p_lov_query=>'.'||wwv_flow_api.id(1508766038293211.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1509043919293211.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 Minute'
,p_lov_return_value=>'60'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1509405530293212.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 Minuten'
,p_lov_return_value=>'120'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1509881833293213.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 Minuten'
,p_lov_return_value=>'180'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1510274552293213.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 Minuten'
,p_lov_return_value=>'240'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1510691299293213.4353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 Minuten'
,p_lov_return_value=>'300'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1511001625293214.4353)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'10 Minuten'
,p_lov_return_value=>'600'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(784569817799474890.4353)
,p_lov_name=>'SERVICE.REQUEST.NAME'
,p_reference_id=>110368323210290856.4353
,p_lov_query=>'.'||wwv_flow_api.id(784569817799474890.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784573162881474938.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Neues Schema'
,p_lov_return_value=>'NEW_SCHEMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784573584378474939.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Workspace entfernen'
,p_lov_return_value=>'REMOVE_EXISTING_SERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784573945933474940.4353)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Schema entfernen'
,p_lov_return_value=>'REMOVE_EXISTING_SCHEMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784574357497474940.4353)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Speicherplatz anfordern'
,p_lov_return_value=>'CHANGE_DB_SIZE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(784574699206474941.4353)
,p_lov_name=>'SERVICE.REQUEST.STATUS'
,p_reference_id=>87755726864223308.4353
,p_lov_query=>'.'||wwv_flow_api.id(784574699206474941.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784579496484474945.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Genehmigt'
,p_lov_return_value=>'APPROVED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784579845934474945.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Abgelehnt'
,p_lov_return_value=>'DECLINED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784580299124474945.4353)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'In Arbeit'
,p_lov_return_value=>'IN_PROGRESS'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'26'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784580698196474945.4353)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Angefordert'
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784581020670474945.4353)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Beendet'
,p_lov_return_value=>'TERMINATED'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(784581436523474946.4353)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Akzeptiert'
,p_lov_return_value=>'ACCEPTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_trace_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(370223717115128950.4353)
,p_lov_name=>'SESSION_TRACE_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(370223717115128950.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370224060587128958.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL Trace'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_or_cached_pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42450922059777772.4353)
,p_lov_name=>'SHOW ALL OR CACHED PAGES'
,p_lov_query=>'.'||wwv_flow_api.id(42450922059777772.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42451116170777773.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Alle Seiten'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42451322267777773.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Gecachte Seiten'
,p_lov_return_value=>'CACHED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_more_columns_checkbox
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17777219154823135.4353)
,p_lov_name=>'SHOW MORE COLUMNS CHECKBOX'
,p_lov_query=>'.'||wwv_flow_api.id(17777219154823135.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17777414218823135.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Zus\00E4tzliche Berichtsspalten anzeigen')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/team_dev_fs_limit
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2541925202710283317.4353)
,p_lov_name=>'TEAM_DEV_FS_LIMIT'
,p_reference_id=>2541932940202319161.4353
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ts_schema_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(25622114385279132.4353)
,p_lov_name=>'TS_SCHEMA_OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(25622114385279132.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25622422573279176.4353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vorhandenes Schema'
,p_lov_return_value=>'EXISTING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25622617415279177.4353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Neues Schema'
,p_lov_return_value=>'NEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_or_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157815226475866526.4353)
,p_lov_name=>'YES_NO_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157815523644866535.4353)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ja'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157815717308866538.4353)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nein'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/administration
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(4090422833267509.4353)
,p_name=>'administration'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2469622445716674.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Betriebssystem'
,p_link=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
,p_page_id=>63
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2474403886740449.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Sessions pro Browser'
,p_link=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:::'
,p_page_id=>64
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4092600585280040.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>unistr('Aktivit\00E4t \00FCberwachen')
,p_link=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_page_id=>22
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4107331322307772.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Benutzer'
,p_link=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::'
,p_page_id=>25
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4148213370406694.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Externe Klicks'
,p_link=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::'
,p_page_id=>34
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4151832202421647.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Benutzer-Agent'
,p_link=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::'
,p_page_id=>37
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4190227850581237.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>unistr('Sessionzustand l\00F6schen')
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>5
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4195726034599646.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Anwendungs\00E4nderungen pro Anwendung')
,p_link=>'f?p=&FLOW_ID.:38:&SESSION.::&DEBUG.:::'
,p_page_id=>38
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4206226857609277.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Benutzer und Gruppen verwalten'
,p_link=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:::'
,p_page_id=>55
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4209018677616407.4353)
,p_parent_id=>wwv_flow_api.id(4206226857609277.4353)
,p_short_name=>'Benutzer erstellen'
,p_link=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:::'
,p_page_id=>52
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4271821999882293.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Anwendung'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>26
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4281101764933173.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Aktuelle Seitenansichten'
,p_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_page_id=>29
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4283911241944016.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro gewichteter Seiten-Performance'
,p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_page_id=>31
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4318016496108751.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Monatskalender der Seitenansichten pro Tag'
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4323002682130309.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>unistr('Entwickleraktivit\00E4tslog')
,p_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_page_id=>30
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4325919922137501.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Service verwalten'
,p_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_page_id=>21
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4361400414268083.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>unistr('Sessions l\00F6schen')
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4363126928271060.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>'Aktuelle Sessions'
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4364521967273337.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>unistr('Voreinstellungen l\00F6schen')
,p_link=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.:::'
,p_page_id=>46
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4365816792275696.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>'Voreinstellungen pro Benutzer'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4375107937294978.4353)
,p_parent_id=>wwv_flow_api.id(4380108356309988.4353)
,p_short_name=>'Benutzergruppe'
,p_link=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_page_id=>54
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4380108356309988.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Benutzer und Gruppen verwalten'
,p_link=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:::'
,p_page_id=>53
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4381802749312589.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Benutzer und Gruppen verwalten'
,p_link=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:::'
,p_page_id=>51
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4383226459316770.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Speicherplatz anfordern'
,p_link=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_page_id=>49
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4384618480320519.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Service-Ende anfordern'
,p_link=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_page_id=>50
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4393511782338849.4353)
,p_parent_id=>wwv_flow_api.id(4206226857609277.4353)
,p_short_name=>'Benutzer bearbeiten'
,p_link=>'f?p=&FLOW_ID.:56:&SESSION.'
,p_page_id=>56
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4933731196448238.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Workspace-Schemas'
,p_link=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:::'
,p_page_id=>72
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(5909921448840002.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Schema-Tablespace-Nutzung'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
,p_page_id=>2
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7257808624858752.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>'Sessionzustandsdetails'
,p_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7259930824863624.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>'Aktuelle Benutzervoreinstellungen'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7453117390591593.4353)
,p_parent_id=>wwv_flow_api.id(4283911241944016.4353)
,p_short_name=>'Seiten-Performance'
,p_link=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:::'
,p_page_id=>65
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9016821830861763.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Info &PRODUCT_NAME.'
,p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_page_id=>9
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9408012888223819.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Sessionaktivit\00E4t pro Stunde')
,p_link=>'f?p=&FLOW_ID.:15:&SESSION.'
,p_page_id=>15
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9446414777586270.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Workspace-Voreinstellungen festlegen'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10268429641818276.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Anmeldungszusammenfassung Entwickler'
,p_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::'
,p_page_id=>6
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10585025472876168.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Provisioning: Service-Ende anfordern'
,p_link=>'f?p=&FLOW_ID.:510:&SESSION.'
,p_page_id=>510
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11927127220739284.4353)
,p_parent_id=>wwv_flow_api.id(4363126928271060.4353)
,p_short_name=>'Sessiondetails'
,p_link=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:::'
,p_page_id=>40
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17101518098296684.4353)
,p_parent_id=>wwv_flow_api.id(.4353)
,p_short_name=>'Ansichten pro Seite'
,p_link=>'f?p=&FLOW_ID.:32:&SESSION.'
,p_page_id=>32
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17191212558696158.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Anwendungs\00E4nderungen, detailliert')
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20246528779701431.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Anwendungs\00E4nderungen pro Entwickler')
,p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_page_id=>8
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20253824023718817.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Anwendungs\00E4nderungen pro Entwickler')
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20590301090617183.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Tag'
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20693525446844867.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Stunde'
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22594908160282978.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_page_id=>18
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22818825242809738.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_link=>'f?p=&FLOW_ID.:20:&SESSION.::&DEBUG.:::'
,p_page_id=>20
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(25558521888584227.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Anwendung und Seite'
,p_link=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_page_id=>75
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(25619701716212765.4353)
,p_parent_id=>wwv_flow_api.id(26633620827671901.4353)
,p_short_name=>'Erstellen'
,p_link=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_page_id=>1000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(25638421686309874.4353)
,p_parent_id=>wwv_flow_api.id(26633620827671901.4353)
,p_short_name=>'Erstellen'
,p_link=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.:::'
,p_page_id=>1020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26445104999779395.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Anmeldeversuche'
,p_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP::'
,p_page_id=>70
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26633620827671901.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Websheet-Datenbankobjekte'
,p_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
,p_page_id=>2000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26636125294745766.4353)
,p_parent_id=>wwv_flow_api.id(26633620827671901.4353)
,p_short_name=>'Entfernen'
,p_link=>'f?p=&APP_ID.:2010:&SESSION.::&DEBUG.:::'
,p_page_id=>2010
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27257108953740456.4353)
,p_parent_id=>wwv_flow_api.id(.4353)
,p_short_name=>'<span class="u-VisuallyHidden">Administration</span><span class="a-Icon icon-breadcrumb-previous" title="Administration"></span>'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30025321432264022.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_page_id=>60
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30327713625356854.4353)
,p_parent_id=>wwv_flow_api.id(30025321432264022.4353)
,p_short_name=>'Mehrere Benutzer erstellen'
,p_link=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:::'
,p_page_id=>99
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30343815513719877.4353)
,p_parent_id=>wwv_flow_api.id(4206226857609277.4353)
,p_short_name=>'Benutzer suchen'
,p_link=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:::'
,p_page_id=>8000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34516114490236116.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Am h\00E4ufigsten angezeigte Seiten aller Anwendungen')
,p_link=>'f?p=&APP_ID.:190:&SESSION.::&DEBUG.:::'
,p_page_id=>190
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34710616986796822.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Datenbankschema anfordern'
,p_link=>'f?p=&FLOW_ID.:48:&SESSION.'
,p_page_id=>48
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(41507328141454714.4353)
,p_parent_id=>wwv_flow_api.id(47295000777189375.4353)
,p_short_name=>unistr('Gecachte Regionen pro Region l\00F6schen')
,p_link=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:::'
,p_page_id=>301
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(41692321367095915.4353)
,p_parent_id=>wwv_flow_api.id(47295000777189375.4353)
,p_short_name=>unistr('Gecachte Regionen pro Anwendung l\00F6schen')
,p_link=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:::'
,p_page_id=>303
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(41861202885553198.4353)
,p_parent_id=>wwv_flow_api.id(47295000777189375.4353)
,p_short_name=>unistr('Gecachte Regionen pro Workspace l\00F6schen')
,p_link=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::'
,p_page_id=>300
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42341004664643420.4353)
,p_parent_id=>wwv_flow_api.id(47295000777189375.4353)
,p_short_name=>unistr('Gecachte Seiten pro Anwendung l\00F6schen')
,p_link=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:::'
,p_page_id=>304
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42426220372298687.4353)
,p_parent_id=>wwv_flow_api.id(47295000777189375.4353)
,p_short_name=>unistr('Gecachte Seiten pro Seite l\00F6schen')
,p_link=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:::'
,p_page_id=>302
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42468214129256219.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Clickthrough Log'
,p_link=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_page_id=>84
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42714907058726008.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Anmeldeversuche pro Authentifizierungsergebnis'
,p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::'
,p_page_id=>4
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(46991002925568555.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47001932630888950.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47260107410925385.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Sessionzustand'
,p_link=>'f?p=&FLOW_ID.:36:&SESSION.'
,p_page_id=>36
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47295000777189375.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Anwendungscache'
,p_link=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:::'
,p_page_id=>47
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47308310413778595.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Speicherplatz anfordern'
,p_link=>'f?p=&FLOW_ID.:69:&SESSION.'
,p_page_id=>69
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47332515905632680.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>71
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47356100656454148.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:::'
,p_page_id=>78
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47393027682585246.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.:::'
,p_page_id=>79
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47440031058206587.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
,p_page_id=>81
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47723114753679446.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Neu erstellte Seiten'
,p_link=>'f?p=&FLOW_ID.:82:&SESSION.'
,p_page_id=>82
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47745822639055625.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Stunde'
,p_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:::'
,p_page_id=>87
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47768305657260927.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Seiten\00E4nderungen pro Tag')
,p_link=>'f?p=&FLOW_ID.:89:&SESSION.'
,p_page_id=>89
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48002713439212955.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::'
,p_page_id=>91
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48516105867959355.4353)
,p_parent_id=>wwv_flow_api.id(493061632558056672.4353)
,p_short_name=>'Subscriptions'
,p_link=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_page_id=>92
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(49167127607716830.4353)
,p_parent_id=>wwv_flow_api.id(47260107410925385.4353)
,p_short_name=>unistr('Voreinstellungen zur\00FCcksetzen')
,p_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(51200624276230133.4353)
,p_parent_id=>wwv_flow_api.id(47295000777189375.4353)
,p_short_name=>unistr('Abgelaufene gecachte Seiten pro Anwendung l\00F6schen')
,p_link=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:::'
,p_page_id=>90
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(65419012862652752.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Bericht zu Seitenansichten pro Tag'
,p_link=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:::'
,p_page_id=>74
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(67231725243730948.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Datenbankberechtigungen'
,p_link=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_page_id=>86
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(127643119606506595.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>unistr('Erstellstatus f\00FCr die Anwendung')
,p_link=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:::'
,p_page_id=>41
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162263605460882715.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_link=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:::'
,p_page_id=>352
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162267111917894830.4353)
,p_parent_id=>wwv_flow_api.id(.4353)
,p_short_name=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_link=>'f?p=&FLOW_ID.:353:&SESSION.'
,p_page_id=>353
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162270607148927500.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Zusammenfassung Aktivit\00E4tslog pro Anwendung')
,p_link=>'f?p=&APP_ID.:354:&SESSION.::&DEBUG.:::'
,p_page_id=>354
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(166213224187830380.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Diagramm f\00FCr Nutzung nativer Komponenten')
,p_link=>'f?p=&APP_ID.:97:&SESSION.'
,p_page_id=>97
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(167555425410082684.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Aktive Sessions'
,p_link=>'f?p=&FLOW_ID.:7:&SESSION.'
,p_page_id=>7
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(167633330874520798.4353)
,p_parent_id=>wwv_flow_api.id(167555425410082684.4353)
,p_short_name=>'Sessiondetail'
,p_link=>'f?p=&FLOW_ID.:19:&SESSION.'
,p_page_id=>19
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168316116904810067.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Service anfordern'
,p_link=>'f?p=&FLOW_ID.:96:&SESSION.'
,p_page_id=>96
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168433621304028939.4353)
,p_parent_id=>wwv_flow_api.id(26633620827671901.4353)
,p_short_name=>'Validieren'
,p_link=>'f?p=&FLOW_ID.:2020:&SESSION.'
,p_page_id=>2020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168440510037690155.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Workspace-Nutzung'
,p_link=>'f?p=&FLOW_ID.:101:&SESSION.'
,p_page_id=>101
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168471800193925286.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>'Export-Repository verwalten'
,p_link=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:::'
,p_page_id=>150
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(169504715330846340.4353)
,p_parent_id=>wwv_flow_api.id(168433621304028939.4353)
,p_short_name=>unistr('Ung\00FCltige Objekte korrigieren')
,p_link=>'f?p=&APP_ID.:2030:&SESSION.::&DEBUG.:::'
,p_page_id=>2030
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(173260815365250672.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>unistr('Workspace-Ank\00FCndigung')
,p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::'
,p_page_id=>35
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(180929821403245891.4353)
,p_parent_id=>wwv_flow_api.id(168440510037690155.4353)
,p_short_name=>'E-Mail'
,p_link=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.:::'
,p_page_id=>83
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(196301728610881937.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro interaktiven Bericht'
,p_link=>'f?p=&FLOW_ID.:93:&SESSION.'
,p_page_id=>93
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(199842555555432288.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Webservice-Aktivit\00E4tslog')
,p_link=>'f?p=&APP_ID.:77:&SESSION.'
,p_page_id=>77
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(211677204186361292.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Anwendungsfehler'
,p_link=>'f?p=&FLOW_ID.:62:&SESSION.'
,p_page_id=>62
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(219108507235410015.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Anwendungs-Hash pro Tag'
,p_link=>'f?p=&APP_ID.:103:&SESSION.'
,p_page_id=>103
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(227883632574956797.4353)
,p_parent_id=>wwv_flow_api.id(168433621304028939.4353)
,p_short_name=>unistr('Ung\00FCltige Objekte korrigieren')
,p_link=>'f?p=&FLOW_ID.:2040:&SESSION.'
,p_page_id=>2040
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(227921003048164942.4353)
,p_parent_id=>wwv_flow_api.id(26633620827671901.4353)
,p_short_name=>'Erstellen'
,p_link=>'f?p=&APP_ID.:1030:&SESSION.'
,p_page_id=>1030
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(231647913974343694.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seiten-Caching-Performance pro Seite'
,p_link=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_page_id=>61
,p_required_patch=>wwv_flow_api.id(231647503239340557.4353)
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(231670515622363077.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seiten-Caching-Performance pro Anwendung'
,p_link=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.:::'
,p_page_id=>67
,p_required_patch=>wwv_flow_api.id(231647503239340557.4353)
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(246324709362747681.4353)
,p_parent_id=>wwv_flow_api.id(34710616986796822.4353)
,p_short_name=>unistr('Schema-Anforderung best\00E4tigen')
,p_link=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_page_id=>66
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(370346095636891220.4353)
,p_parent_id=>wwv_flow_api.id(4281101764933173.4353)
,p_short_name=>'Debugging-Meldungen'
,p_link=>'f?p=&APP_ID.:24:&SESSION.'
,p_page_id=>24
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(388567689401599597.4353)
,p_parent_id=>wwv_flow_api.id(.4353)
,p_short_name=>'Seite null'
,p_link=>'f?p=&FLOW_ID.:0:&SESSION.'
,p_page_id=>0
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(395882286281059468.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten'
,p_link=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_page_id=>73
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(397449678515589812.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Anwendungsansichten nach Monat'
,p_link=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:RP,80::'
,p_page_id=>80
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(435132825806181421.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>unistr('Zeitrahmen f\00FCr Berichtserstellung festlegen')
,p_link=>'f?p=&FLOW_ID.:59:&SESSION.'
,p_page_id=>59
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(452547101449603350.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Dateinutzung'
,p_link=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::'
,p_page_id=>85
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(486717514398109366.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Aktuelle Websheet-Ansichten'
,p_link=>'f?p=&FLOW_ID.:94:&SESSION.'
,p_page_id=>94
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(486997905678291815.4353)
,p_parent_id=>wwv_flow_api.id(30025321432264022.4353)
,p_short_name=>'Mehrere Benutzer erstellen'
,p_link=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
,p_page_id=>95
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(487218900991020779.4353)
,p_parent_id=>wwv_flow_api.id(27257108953740456.4353)
,p_short_name=>unistr('Mehrere Benutzer l\00F6schen')
,p_link=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_page_id=>57
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(492154414688867777.4353)
,p_parent_id=>wwv_flow_api.id(493061632558056672.4353)
,p_short_name=>'Gespeicherte Berichte'
,p_link=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::'
,p_page_id=>98
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(492713621337622804.4353)
,p_parent_id=>wwv_flow_api.id(493061632558056672.4353)
,p_short_name=>'Gespeicherte Berichte'
,p_link=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:::'
,p_page_id=>100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(493061632558056672.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>unistr('Einstellungen f\00FCr interaktive Berichte verwalten')
,p_link=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:::'
,p_page_id=>104
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(563547281943439302.4353)
,p_parent_id=>wwv_flow_api.id(563644659835658277.4353)
,p_short_name=>'Tabellenspaltencache'
,p_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_page_id=>801
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(563644659835658277.4353)
,p_parent_id=>wwv_flow_api.id(4325919922137501.4353)
,p_short_name=>'Data-Dictionary-Cache'
,p_link=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_page_id=>800
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(880570494862638647.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Workspace-Aktivit\00E4t pro Tag')
,p_link=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:RP::'
,p_page_id=>76
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1760797156082373066.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>unistr('Anwendungs\00E4nderungen pro Entwickler pro Stunde')
,p_link=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:::'
,p_page_id=>23
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1760815418654431335.4353)
,p_parent_id=>wwv_flow_api.id(4092600585280040.4353)
,p_short_name=>'Seitenansichten pro Benutzer pro Stunde'
,p_link=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::'
,p_page_id=>39
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/done_popup
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(80887301212076531.4353)
,p_theme_id=>3
,p_name=>'(Done) Popup.de'
,p_internal_name=>'DONE_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'    <title>#TITLE#</title>',
'    <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'    ',
'    #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="aPopupPage">',
'    <noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>#REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##BODY#</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>19940022257958945.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017461170349539.4353)
,p_page_template_id=>wwv_flow_api.id(80887301212076531.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017594877349539.4353)
,p_page_template_id=>wwv_flow_api.id(80887301212076531.4353)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017679349349539.4353)
,p_page_template_id=>wwv_flow_api.id(80887301212076531.4353)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017771658349539.4353)
,p_page_template_id=>wwv_flow_api.id(80887301212076531.4353)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017852932349539.4353)
,p_page_template_id=>wwv_flow_api.id(80887301212076531.4353)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017954292349539.4353)
,p_page_template_id=>wwv_flow_api.id(80887301212076531.4353)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140018034154349539.4353)
,p_page_template_id=>wwv_flow_api.id(80887301212076531.4353)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_rw_faceted_search
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(383691245467261189.4353)
,p_theme_id=>3
,p_name=>'APEX RW - Faceted Search.de'
,p_internal_name=>'APEX_RW_-_FACETED_SEARCH'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES# a-Page--facetedSearch" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <aside class="a-Side" style="width: 280px">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>383682332851249713.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(383705806466264682.4353)
,p_page_template_id=>wwv_flow_api.id(383691245467261189.4353)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(383706359356264682.4353)
,p_page_template_id=>wwv_flow_api.id(383691245467261189.4353)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(383706805887264683.4353)
,p_page_template_id=>wwv_flow_api.id(383691245467261189.4353)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(383707379748264683.4353)
,p_page_template_id=>wwv_flow_api.id(383691245467261189.4353)
,p_name=>'Facets'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(383707813839264683.4353)
,p_page_template_id=>wwv_flow_api.id(383691245467261189.4353)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(383708304297264683.4353)
,p_page_template_id=>wwv_flow_api.id(383691245467261189.4353)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(383708845504264683.4353)
,p_page_template_id=>wwv_flow_api.id(383691245467261189.4353)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(485889499804058937.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.de'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020135178349536.4353)
,p_page_template_id=>wwv_flow_api.id(485889499804058937.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020216208349536.4353)
,p_page_template_id=>wwv_flow_api.id(485889499804058937.4353)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020377938349535.4353)
,p_page_template_id=>wwv_flow_api.id(485889499804058937.4353)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog_with_right_sidebar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(492730147881440540.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog with Right Sidebar.de'
,p_internal_name=>'APEX_5.0_DIALOG_WITH_RIGHT_SIDEBAR'
,p_is_popup=>true
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody" class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'    <div id="apex-two-col">',
'      <div id="apex-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</div>',
'      <div id="apex-content">#REGION_POSITION_02#',
'        <div id="apex-splash"><div id="BB">#BODY#</div></div>',
'      </div>',
'    </div>',
'  </div>',
'  <div>#REGION_POSITION_04#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>18525411970780075.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022377863349533.4353)
,p_page_template_id=>wwv_flow_api.id(492730147881440540.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022439375349533.4353)
,p_page_template_id=>wwv_flow_api.id(492730147881440540.4353)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022574565349533.4353)
,p_page_template_id=>wwv_flow_api.id(492730147881440540.4353)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022669577349533.4353)
,p_page_template_id=>wwv_flow_api.id(492730147881440540.4353)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022747461349533.4353)
,p_page_template_id=>wwv_flow_api.id(492730147881440540.4353)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022811634349532.4353)
,p_page_template_id=>wwv_flow_api.id(492730147881440540.4353)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(692762523503114201.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.de'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022951714349532.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023033876349532.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023140119349532.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023246221349532.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023368683349532.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023416660349532.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159337545580470361.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159338037318470361.4353)
,p_page_template_id=>wwv_flow_api.id(692762523503114201.4353)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(692762974728114205.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.de'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023558808349531.4353)
,p_page_template_id=>wwv_flow_api.id(692762974728114205.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023668479349531.4353)
,p_page_template_id=>wwv_flow_api.id(692762974728114205.4353)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023773974349531.4353)
,p_page_template_id=>wwv_flow_api.id(692762974728114205.4353)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023807895349531.4353)
,p_page_template_id=>wwv_flow_api.id(692762974728114205.4353)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140023977783349531.4353)
,p_page_template_id=>wwv_flow_api.id(692762974728114205.4353)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024016569349531.4353)
,p_page_template_id=>wwv_flow_api.id(692762974728114205.4353)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024121404349531.4353)
,p_page_template_id=>wwv_flow_api.id(692762974728114205.4353)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(692763410753114205.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.de'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159341999297470365.4353)
,p_page_template_id=>wwv_flow_api.id(692763410753114205.4353)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159342405358470365.4353)
,p_page_template_id=>wwv_flow_api.id(692763410753114205.4353)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159342929042470365.4353)
,p_page_template_id=>wwv_flow_api.id(692763410753114205.4353)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159343432428470366.4353)
,p_page_template_id=>wwv_flow_api.id(692763410753114205.4353)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159343967801470366.4353)
,p_page_template_id=>wwv_flow_api.id(692763410753114205.4353)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159344416583470366.4353)
,p_page_template_id=>wwv_flow_api.id(692763410753114205.4353)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159344975950470367.4353)
,p_page_template_id=>wwv_flow_api.id(692763410753114205.4353)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(718401914085176458.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.de'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024228777349530.4353)
,p_page_template_id=>wwv_flow_api.id(718401914085176458.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024368154349530.4353)
,p_page_template_id=>wwv_flow_api.id(718401914085176458.4353)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024485967349530.4353)
,p_page_template_id=>wwv_flow_api.id(718401914085176458.4353)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024502795349530.4353)
,p_page_template_id=>wwv_flow_api.id(718401914085176458.4353)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024662601349530.4353)
,p_page_template_id=>wwv_flow_api.id(718401914085176458.4353)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024723416349529.4353)
,p_page_template_id=>wwv_flow_api.id(718401914085176458.4353)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024815314349529.4353)
,p_page_template_id=>wwv_flow_api.id(718401914085176458.4353)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_workspace_login
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(797610818331805206.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Workspace Login.de'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN'
,p_is_popup=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(function() {',
'  $(''a[href*="#"]:not([href="#"])'').click(function() {',
'    if (location.pathname.replace(/^\//,'''') == this.pathname.replace(/^\//,'''') && location.hostname == this.hostname) {',
'      var target = $(this.hash);',
'      target = target.length ? target : $(''[name='' + this.hash.slice(1) +'']'');',
'      if (target.length) {',
'        $(''html,body'').animate({',
'          scrollTop: target.offset().top',
'        }, 500);',
'        return false;',
'      }',
'    }',
'  });',
'});'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--login #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide" id="top">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Login-container">',
'  #BODY#',
'  </div>',
'  <div class="a-Login-slideNav a-Login-slideNav--down">',
'    <a href="#info" class="a-Login-slideNavLink"><span class="a-Icon icon-shuttle-down"></span></a>',
'  </div>',
'</div>',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide a-Login-slide--secondary" id="info">',
'  <div class="a-Login-secondaryContent">',
'  #REGION_POSITION_03#',
'  </div>',
'  <div class="a-Login-slideNav  a-Login-slideNav--up">',
'    <a href="#top" class="a-Login-slideNavLink"><span class="a-Icon icon-shuttle-up"></span></a>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>781632627194221102.4353
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020442662349535.4353)
,p_page_template_id=>wwv_flow_api.id(797610818331805206.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020525679349535.4353)
,p_page_template_id=>wwv_flow_api.id(797610818331805206.4353)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020654260349535.4353)
,p_page_template_id=>wwv_flow_api.id(797610818331805206.4353)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020718323349535.4353)
,p_page_template_id=>wwv_flow_api.id(797610818331805206.4353)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020837347349535.4353)
,p_page_template_id=>wwv_flow_api.id(797610818331805206.4353)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_workspace_login_secondary_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(797616476051845768.4353)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Workspace Login Secondary Page.de'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_SECONDARY_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--login #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide" id="top">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Login-container">',
'  #BODY#',
'  </div>',
'</div>',
'#REGION_POSITION_03#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140020969796349535.4353)
,p_page_template_id=>wwv_flow_api.id(797616476051845768.4353)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021020701349535.4353)
,p_page_template_id=>wwv_flow_api.id(797616476051845768.4353)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021199076349534.4353)
,p_page_template_id=>wwv_flow_api.id(797616476051845768.4353)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021246433349534.4353)
,p_page_template_id=>wwv_flow_api.id(797616476051845768.4353)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021376323349534.4353)
,p_page_template_id=>wwv_flow_api.id(797616476051845768.4353)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_image_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3791829543328.4353)
,p_template_name=>'HTML image (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_IMAGE_LEGACY_APEX_5_MIGRATION'
,p_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_hot_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_next_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(208548517895320411.4353)
,p_template_name=>'APEX 4.2 - Next Button'
,p_internal_name=>'APEX_4.2_NEXT_BUTTON'
,p_template=>'<button class="aButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextBlack" alt=""/></span></button>'
,p_hot_template=>'<button class="aButton hotButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextWhite" alt=""/></span></button>'
,p_reference_id=>40780910892272674.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_previous_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(208548713965320411.4353)
,p_template_name=>'APEX 4.2 - Previous Button'
,p_internal_name=>'APEX_4.2_PREVIOUS_BUTTON'
,p_template=>'<button title="#LABEL!ATTR#" class="aButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevBlack" alt="#LABEL!ATTR#" /></span></button>'
,p_hot_template=>'<button title="#LABEL!ATTR#" class="aButton hotButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevWhite" alt="#LABEL!ATTR#" /></span></button>'
,p_reference_id=>40781222929295107.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_icon_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(258479618231884825.4353)
,p_template_name=>'APEX 4.2 - Icon Button'
,p_internal_name=>'APEX_4.2_ICON_BUTTON'
,p_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_hot_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_reference_id=>46198532248154431.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>0
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="xpbutton" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tbody class="FFFFFF">',
'<tr>',
'<td class="L" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'<td class="C"><a href="#LINK#">#LABEL#</a></td>',
'<td class="R" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'</tr>',
'</tbody>',
'</table>'))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(297663202145957383.4353)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_reference_id=>275775519061831382.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(388537948307476852.4353)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(388538190684476853.4353)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(485869694622026879.4353)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(486003960305193183.4353)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(486004148112193187.4353)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(486004439750193187.4353)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(486004758462193187.4353)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/dialog_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(486005281398193188.4353)
,p_template_name=>'Dialog Button'
,p_internal_name=>'DIALOG_BUTTON'
,p_template=>'"#LABEL!ATTR#":#BUTTON_ATTRIBUTES#'
,p_reference_id=>428602020814722967.4353
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/no_buttons_no_title
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(18911811464281343.4353)
,p_layout=>'TABLE'
,p_template=>'<table class="htmldbRR" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#"><tbody><tr><td colspan="2" class="B">#BODY#</td></tr></tbody></table>'
,p_page_plug_template_name=>'No Buttons No Title'
,p_internal_name=>'NO_BUTTONS_NO_TITLE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>90546300508951267.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463944375344552.4353)
,p_plug_template_id=>wwv_flow_api.id(18911811464281343.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464047853344551.4353)
,p_plug_template_id=>wwv_flow_api.id(18911811464281343.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(29439604845311434.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>29333927116050844.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464168846344551.4353)
,p_plug_template_id=>wwv_flow_api.id(29439604845311434.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464288416344551.4353)
,p_plug_template_id=>wwv_flow_api.id(29439604845311434.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_large
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(30016706698215740.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Rounded Corner Large'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_LARGE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>27763613494297374.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464364059344551.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464415604344551.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464540703344551.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464669572344551.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464789659344551.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464876589344551.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140464986994344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465012104344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465113774344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465222397344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465394971344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465476364344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30016706698215740.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_blue_top
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(30017504140215775.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Rounded Corner Small (Blue Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_BLUE_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>26881811222918187.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465588709344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465607112344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465732394344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465899001344550.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140465911740344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466064761344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466150208344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466200384344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466392013344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466478262344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466548716344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466642332344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30017504140215775.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/div_with_id_c_htmldbhid
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(30347228019736370.4353)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'Div  with ID (c:htmldbHID)'
,p_internal_name=>'DIV_WITH_ID_C:HTMLDBHID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>245224629509817478.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466777324344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30347228019736370.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466862251344549.4353)
,p_plug_template_id=>wwv_flow_api.id(30347228019736370.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_gray_top
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(32633710970357971.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Rounded Corner Small (Gray Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_GRAY_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>32612420016685806.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140466964299344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467016805344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467194660344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467227830344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467309049344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467495015344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467520560344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467668431344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467738924344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467841989344548.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140467986273344547.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468062375344547.4353)
,p_plug_template_id=>wwv_flow_api.id(32633710970357971.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_100
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(34074202387975945.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion buttonRegion" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    #BODY#',
'    <span class="aButtonContainer">',
'      #CLOSE##COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#',
'    </span>',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Top Bar (100%)'
,p_internal_name=>'APEX_4.0_TOP_BAR_100%'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17357218626599946.4353
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468180121344547.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468251135344547.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468335158344547.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468457394344547.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468528556344547.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468664657344547.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468757320344547.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468834623344546.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140468950370344546.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469027458344546.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469127418344546.4353)
,p_plug_template_id=>wwv_flow_api.id(34074202387975945.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(40275409253350646.4353)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #COMPONENT_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469208278344546.4353)
,p_plug_template_id=>wwv_flow_api.id(40275409253350646.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469368623344546.4353)
,p_plug_template_id=>wwv_flow_api.id(40275409253350646.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/gray_box_c_htmldbgbr_100_from_4999
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(47252630300569314.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading editRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'      <a href="#" class="aIconButton" onclick="uF();return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" class="upIcon" alt="&TOP." /></a>',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'Gray Box (c:htmldbGBR) (100%)  From 4999'
,p_internal_name=>'GRAY_BOX_C:HTMLDBGBR_100%_FROM_4999'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17353903289599940.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469405241344546.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469502486344546.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469615159344546.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469727668344546.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469878799344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140469917290344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470067389344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470127018344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470256000344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470370333344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470480652344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470578570344545.4353)
,p_plug_template_id=>wwv_flow_api.id(47252630300569314.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(48533119259303364.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470607941344545.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470758050344545.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470864911344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140470904703344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471073356344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471182379344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471280355344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471313390344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471470111344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471521283344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471640818344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471720135344544.4353)
,p_plug_template_id=>wwv_flow_api.id(48533119259303364.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/report_region_c_htmldbreportregion_from_4999
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(60932116232746047.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'Report Region (c:htmldbReportRegion)  From 4999'
,p_internal_name=>'REPORT_REGION_C:HTMLDBREPORTREGION_FROM_4999'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471891158344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140471916412344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472088444344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472179442344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472261536344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472300294344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472400991344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472572125344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472681279344543.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472703725344542.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472833519344542.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140472919212344542.4353)
,p_plug_template_id=>wwv_flow_api.id(60932116232746047.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/info_c_htmldbinfo_from_4999
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(79598426990781464.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'Info (c:htmldbInfo) from 4999'
,p_internal_name=>'INFO_C:HTMLDBINFO_FROM_4999'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473062394344542.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473176770344542.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473265633344542.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473347233344542.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473461549344542.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473570902344542.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473612083344542.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473736230344541.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473814504344541.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140473972972344541.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474070323344541.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474149843344541.4353)
,p_plug_template_id=>wwv_flow_api.id(79598426990781464.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(106671321669750604.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box'
,p_internal_name=>'WIZARD_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474245875344541.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474324868344541.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474436809344541.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474555331344541.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474685561344540.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474731595344540.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474834543344540.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140474983896344540.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475052364344540.4353)
,p_plug_template_id=>wwv_flow_api.id(106671321669750604.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_99
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(169070213366124294.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="topbar" style="width:99%;clear:both;" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="topbar-top"><div class="topbar-top-r"></div></div>',
'  <div class="topbar-body"><div class="topbar-body-r"><div class="topbar-content">',
'      <div style="float:left">#BODY#</div>',
'      <div style="float:right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</div>',
'   </div></div></div>',
'  <div class="topbar-bottom"><div class="topbar-bottom-r"></div></div>',
'</div>',
'<br />'))
,p_page_plug_template_name=>'APEX 4.0 - Top Bar (99%)'
,p_internal_name=>'APEX_4.0_TOP_BAR_99%'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>169048010062038708.4353
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435774646344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435845294344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435959111344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436001662344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436149744344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436291725344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436360596344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436470736344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436529715344580.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436626080344579.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436720848344579.4353)
,p_plug_template_id=>wwv_flow_api.id(169070213366124294.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box_confirm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202306221419259440.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box (Confirm)'
,p_internal_name=>'APEX_4.0_WIZARD_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436837512344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140436955050344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437002605344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437137239344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437264438344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437378507344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437426870344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437551152344579.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437611429344578.4353)
,p_plug_template_id=>wwv_flow_api.id(202306221419259440.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(208383713787306085.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body'
,p_internal_name=>'APEX_4.2_WIZARD_BODY'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209615589242480.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437774399344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208383713787306085.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437896197344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208383713787306085.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(208384206154306085.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140437940918344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438090819344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438166333344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438251972344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438330035344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438480928344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438589901344578.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438629148344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438748128344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438802496344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140438935162344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439091142344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384206154306085.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(208384700309306086.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h1><a href="javascript:void(0);" onclick="$(''##REGION_STATIC_ID#_content'').slideToggle();$(''##REGION_STATIC_ID#_img'').toggleClass(''expanded'');" class="hideShowLink"><img src="#IMAGE_PREFIX#f_spacer.gif" class="hideShow" alt="" id="#REGION_STATIC'
||'_ID#_img"/>#TITLE#</a></h1>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_HIDE/SHOW'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210116661242480.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439104620344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439292787344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439399999344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439433082344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439536836344577.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439649882344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439747959344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439807358344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140439997037344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440093277344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440139491344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440255680344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208384700309306086.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_buttons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(208385230078306087.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardButtonsContainer" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="leftButtons">',
'    #PREVIOUS##DELETE##CHANGE##CLOSE#',
'  </div>',
'  <div class="rightButtons">',
'    #EDIT##CREATE##NEXT#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Buttons'
,p_internal_name=>'APEX_4.2_WIZARD_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210411889242480.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440326573344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440477623344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440599836344576.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440611999344575.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440708281344575.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440857962344575.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140440931896344575.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441004192344575.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441172629344575.4353)
,p_plug_template_id=>wwv_flow_api.id(208385230078306087.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(388531674152470979.4353)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441287338344575.4353)
,p_plug_template_id=>wwv_flow_api.id(388531674152470979.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441306259344575.4353)
,p_plug_template_id=>wwv_flow_api.id(388531674152470979.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441441806344575.4353)
,p_plug_template_id=>wwv_flow_api.id(388531674152470979.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441574645344574.4353)
,p_plug_template_id=>wwv_flow_api.id(388531674152470979.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_warning
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(451939821989914545.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion warningRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Warning)'
,p_internal_name=>'WIZARD_BOX_WARNING'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>162320107014603380.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441620044344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441727047344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441864007344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140441986874344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442065573344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442105914344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442225824344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442369275344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442432568344574.4353)
,p_plug_template_id=>wwv_flow_api.id(451939821989914545.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_navigation
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(466721715306301967.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion sideNavRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Sidebar Navigation'
,p_internal_name=>'APEX_4.0_SIDEBAR_NAVIGATION'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>456726627253419549.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442577411344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442659850344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442706172344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442843367344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140442998995344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443019554344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443117873344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443270652344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443301273344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443452715344573.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443586641344572.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443678051344572.4353)
,p_plug_template_id=>wwv_flow_api.id(466721715306301967.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(486010891028205826.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4353
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443733852344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443809299344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140443930808344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444067716344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444187825344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444216128344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444318057344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444470230344572.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444522603344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444659049344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444796416344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444825916344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140444965587344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_top_buttons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(486011409944205836.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--left">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--right">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Top Buttons)'
,p_internal_name=>'APEX_5.0_REGION_TOP_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174747104640428780.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445072319344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445120828344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445226401344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445300605344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445441953344571.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445545990344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445606834344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445736480344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445862235344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140445926695344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446048784344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446169979344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446229764344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486011409944205836.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(486012234812205837.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613705533399534.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446335983344570.4353)
,p_plug_template_id=>wwv_flow_api.id(486012234812205837.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446491339344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012234812205837.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446585172344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012234812205837.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446612517344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012234812205837.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_left
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(486012902426205838.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--left #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Left)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_LEFT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174628415239478085.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446787206344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446860299344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140446908566344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447009997344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447105513344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447277614344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447350980344569.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447417610344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447553847344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447651530344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447733677344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447838944344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140447945839344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486012902426205838.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_right
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(486013619316205838.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--right #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Right)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_RIGHT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174629130392501406.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448090596344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448115306344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448259687344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448349720344568.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448475161344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448556013344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448615589344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448709850344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448878459344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140448986477344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449090237344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449188677344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449206430344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486013619316205838.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(486014333429205839.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449381161344567.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449430915344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449580498344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449678828344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449738732344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449834225344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140449977938344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450090364344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450171560344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450209182344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450333710344566.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450410619344565.4353)
,p_plug_template_id=>wwv_flow_api.id(486014333429205839.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_hidden_heading
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717841909277073684.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Hidden Heading)'
,p_internal_name=>'APEX_5.0_REGION_HIDDEN_HEADING'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>717832816842067694.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475171918344540.4353)
,p_plug_template_id=>wwv_flow_api.id(717841909277073684.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475236456344540.4353)
,p_plug_template_id=>wwv_flow_api.id(717841909277073684.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(720158679964358138.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475387128344540.4353)
,p_plug_template_id=>wwv_flow_api.id(720158679964358138.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475421752344540.4353)
,p_plug_template_id=>wwv_flow_api.id(720158679964358138.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(720159283194358177.4353)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475529304344540.4353)
,p_plug_template_id=>wwv_flow_api.id(720159283194358177.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475649240344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720159283194358177.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(720165508600362771.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_preset_template_options=>'a-ButtonRegion--noUI'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475795004344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475853052344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140475967447344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476080044344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476173057344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476247768344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476398045344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476489384344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476555189344539.4353)
,p_plug_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(720186138525572350.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476673571344538.4353)
,p_plug_template_id=>wwv_flow_api.id(720186138525572350.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476745775344538.4353)
,p_plug_template_id=>wwv_flow_api.id(720186138525572350.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(797568474776479154.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476840196344538.4353)
,p_plug_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140476957409344538.4353)
,p_plug_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477088417344538.4353)
,p_plug_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477113831344538.4353)
,p_plug_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477242750344538.4353)
,p_plug_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477349558344538.4353)
,p_plug_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(797573769515479165.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-region a-Form--stretchInputs #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Login-header">',
'    <span class="a-Login-logo gi-icon-apex-logo-icon"></span>',
'    <h1 class="a-Login-title">#TITLE#</h1>',
'  </div>',
'  <div class="a-Login-body">',
'    #BODY#',
'  </div>',
'  <div class="a-Login-buttons">',
'    #NEXT#',
'  </div>',
'  <div class="a-Login-links">',
'    #EDIT##CREATE#',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Workspace Login Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>781637364422290692.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477405153344538.4353)
,p_plug_template_id=>wwv_flow_api.id(797573769515479165.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477555619344537.4353)
,p_plug_template_id=>wwv_flow_api.id(797573769515479165.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477635210344537.4353)
,p_plug_template_id=>wwv_flow_api.id(797573769515479165.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477793948344537.4353)
,p_plug_template_id=>wwv_flow_api.id(797573769515479165.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477830871344537.4353)
,p_plug_template_id=>wwv_flow_api.id(797573769515479165.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(829445215771671657.4353)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140477900120344537.4353)
,p_plug_template_id=>wwv_flow_api.id(829445215771671657.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478025019344537.4353)
,p_plug_template_id=>wwv_flow_api.id(829445215771671657.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478117723344537.4353)
,p_plug_template_id=>wwv_flow_api.id(829445215771671657.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478230990344537.4353)
,p_plug_template_id=>wwv_flow_api.id(829445215771671657.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_accordion_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(829454386558680645.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Accordion Region'
,p_internal_name=>'APEX_5.0_ACCORDION_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>747596346966613593.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140488518270344526.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140488687038344526.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140488716235344526.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140488851738344526.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140488973904344526.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489043191344526.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489128191344526.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489252792344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489377303344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489451246344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489526446344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489658117344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489712708344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(829458533922680656.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489830542344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140489970758344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490081242344525.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490101437344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490236257344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490374103344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490450535344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490574609344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490622121344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490727759344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490801515344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140490945851344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491047109344524.4353)
,p_plug_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(829463798599680667.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #SUB_REGION_HEADERS#',
'  #SUB_REGIONS#',
'</div>',
'<script type="text/javascript">',
'    $("##REGION_STATIC_ID#").tabs({',
'      create: function() {',
'        $(this).addClass(''ui-tabs--simpleInset'')',
'      }',
'    });',
'</script>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#">#SUB_REGION_TITLE#</a></li>'
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer-item" id="#SUB_REGION_ID#">',
'#SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Tabs'
,p_internal_name=>'APEX_5.0_TABS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>183211208341566300.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491121587344523.4353)
,p_plug_template_id=>wwv_flow_api.id(829463798599680667.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491201018344523.4353)
,p_plug_template_id=>wwv_flow_api.id(829463798599680667.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_subregion
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(854957815491167190.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="subRegion">',
'<h2>#TITLE#</h2>',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 4.0 - Sub-Region'
,p_internal_name=>'APEX_4.0_SUBREGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491369432344523.4353)
,p_plug_template_id=>wwv_flow_api.id(854957815491167190.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491488199344523.4353)
,p_plug_template_id=>wwv_flow_api.id(854957815491167190.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>698829239393878937.4353
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491535869344523.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491678659344523.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491777359344523.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491820338344523.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140491951373344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492055564344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492183622344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492277970344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492320830344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492487656344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492524929344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492658093344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492757596344522.4353)
,p_plug_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(17819003571010282.4353)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728.4353
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(20165427056621106.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_reference_id=>20148806760577112.4353
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(38499417503989888.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_horizontal_list_with_images
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(77000120193659142.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="current">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="noncurrent">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_name=>'APEX 4.0 - Horizontal List with Images'
,p_internal_name=>'APEX_4.0_HORIZONTAL_LIST_WITH_IMAGES'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-list-horizontal">'
,p_list_template_after_rows=>'</div>'
,p_reference_id=>17386714276888490.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(168717528748286543.4353)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs (2)'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705.4353
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_pull_down_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(187163514263710745.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_name=>'APEX 4.0 - Pull Down Tabs'
,p_internal_name=>'APEX_4.0_PULL_DOWN_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div id="tabs" class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="S#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="aTabs dhtmlSubMenu pulldown-tabs" style="display:none;">',
''))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_reference_id=>9651611091899590.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_wizard_progress_bar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(208376827287299755.4353)
,p_list_template_current=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_noncurrent=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_name=>'APEX 4.2 - Wizard Progress Bar'
,p_internal_name=>'APEX_4.2_WIZARD_PROGRESS_BAR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardProgress">',
'<ul>'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'</div>'))
,p_reference_id=>42216127932260877.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(388535020971474291.4353)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(388535333575474292.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(692750374873071023.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(717846892308122004.4353)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4353
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(720190141563578035.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs_002
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(829468732055693490.4353)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705.4353
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(829471944455703874.4353)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(6659715068668103.4353)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report from 4999'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/quick_pick_list_items
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(11670410466357416.4353)
,p_row_template_name=>'quick_pick_list_items'
,p_internal_name=>'QUICK_PICK_LIST_ITEMS'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(43021310970202834.4353)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(46765105410141325.4353)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_row_template_one_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(47025022336023416.4353)
,p_row_template_name=>'APEX 4.0 - Portlet Row Template (one column)'
,p_internal_name=>'APEX_4.0_PORTLET_ROW_TEMPLATE_ONE_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="report-row">',
'  <div class="report-col-hdr">#1#</div>',
'</div>',
''))
,p_row_template_before_rows=>'<div class="report-portlet" #REPORT_ATTRIBUTES# id="#REGION_ID#"><div class="report-record">'
,p_row_template_after_rows=>'</div></div>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46783029065220201.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(770822958504300751.4353)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(770827785027300814.4353)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(770828451758300816.4353)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(770829717235300818.4353)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/label_tag_only
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(4927331448760529.4353)
,p_template_name=>'LABEL Tag Only'
,p_internal_name=>'LABEL_TAG_ONLY'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(7301320786376802.4353)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(107534131274292840.4353)
,p_template_name=>'FormField_Optional'
,p_internal_name=>'FORMFIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041.4353
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_required
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(107535006471295136.4353)
,p_template_name=>'FormField_Required'
,p_internal_name=>'FORMFIELD_REQUIRED'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>2
,p_reference_id=>17388508175892042.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/htmldb_greenarealabel_c_htmldbgalabel
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(355525708739902293.4353)
,p_template_name=>'htmldb_GreenAreaLabel (c:htmldbGALabel)'
,p_internal_name=>'HTMLDB_GREENAREALABEL_C:HTMLDBGALABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_4_0_top_bar_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(450569121489682306.4353)
,p_template_name=>'APEX 4.0 - Top Bar Label'
,p_internal_name=>'APEX_4.0_TOP_BAR_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(489153051785943514.4353)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(489153170799943531.4353)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(797617751200847238.4353)
,p_template_name=>'APEX 5.0 - Workspace Login Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Icon a-Login-iconLabel">'
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'</div></div>'
,p_after_element=>'<span class="a-Login-iconValidation a-Icon icon-check"></span>#ERROR_TEMPLATE#'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span class="u-VisuallyHidden">#CURRENT_ITE'
||'M_HELP_LABEL#</span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>781637020106265852.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(805713983989099558.4353)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(829426714251135780.4353)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(829426906030135803.4353)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(4094616517288262.4353)
,p_name=>'breadcrumbs'
,p_internal_name=>'BREADCRUMBS'
,p_current_page_option=>'<span class="htmldbBreadcrumb">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#" class="htmldbBreadcrumb" title="#NAME#">#NAME#</a>'
,p_between_levels=>'<span class="htmldbBreadcrumbSep"><img alt="" src="#IMAGE_PREFIX#apex/apex_top_sep.gif"></span>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>60115300853820165.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(388538606549481005.4353)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4353
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(13478004473367504.4353)
,p_page_name=>'winlov'
,p_page_title=>'Suchdialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Suche'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('Schlie\00DFen')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Weiter &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; Zur\00FCck')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Zeilen #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4353
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/htmldb_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(50595123809626578.4353)
,p_cal_template_name=>'HTMLDB Calendar'
,p_internal_name=>'HTMLDB_CALENDAR'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4353
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/apex_4_0_default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(429989326510150689.4353)
,p_cal_template_name=>'APEX 4.0 Default Calander'
,p_internal_name=>'APEX_4.0_DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(72331295244515034.4353)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(204023711571766699.4353)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556398380302103261.4353)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556398801399103962.4353)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689640285334993975.4353)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689641104387993975.4353)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689641890550993975.4353)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689643729287993977.4353)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(692750780606071026.4353)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(697086486123403004.4353)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(697256069906708874.4353)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746393654795391886.4353)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746394927367391887.4353)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746395298555391888.4353)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746395536106391888.4353)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746396667408391888.4353)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746396989722391888.4353)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746397289357391888.4353)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746397595401391891.4353)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746397833448391891.4353)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746398369579391892.4353)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746398688326391894.4353)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(770823390186300758.4353)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(770823825914300766.4353)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(770830294703300821.4353)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(770830568775300821.4353)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(770830880737300822.4353)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(770831461915300822.4353)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(797568847627479160.4353)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(797569107979479163.4353)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697205003669627560.4353)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697205322334627560.4353)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697205656478627560.4353)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697205962987627560.4353)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697206272842627560.4353)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697206541642627561.4353)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697206893304627561.4353)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697207116811627561.4353)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697207482365627561.4353)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697207795800627561.4353)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720168495179362789.4353)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720168737661362789.4353)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720169093834362789.4353)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720169320057362789.4353)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720169612442362790.4353)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720169962201362790.4353)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720170263853362790.4353)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720170590608362790.4353)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(720165508600362771.4353)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746393738081391886.4353)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746393946513391887.4353)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746394166942391887.4353)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746394309853391887.4353)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746394522694391887.4353)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746394779452391887.4353)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746395019878391887.4353)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(746394927367391887)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746395380241391888.4353)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746395600089391888.4353)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(746395536106391888)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746395886384391888.4353)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746396068348391888.4353)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746396210061391888.4353)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746396402377391888.4353)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(746395536106391888)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746396798561391888.4353)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(746396667408391888)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746397056950391888.4353)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(746396989722391888)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746397329794391888.4353)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(746397289357391888)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746397664395391891.4353)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(746397595401391891)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746397991614391892.4353)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(746397833448391891)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746398179522391892.4353)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(746395536106391888)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746398463551391892.4353)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(746398369579391892)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746398734776391894.4353)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(746398688326391894)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746398858248391894.4353)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746399096840391894.4353)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(746397289357391888)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746399252498391894.4353)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(746397595401391891)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746399411992391894.4353)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(746397833448391891)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746399588502391894.4353)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(746399637338391898.4353)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770825244829300814.4353)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770825494601300814.4353)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770825628874300814.4353)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770825870229300814.4353)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770826028180300814.4353)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770826263361300814.4353)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770826410150300814.4353)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770826644429300814.4353)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770826826983300814.4353)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770827012098300814.4353)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770827235754300814.4353)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770827447408300814.4353)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770827697507300814.4353)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770822958504300751.4353)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787128846439949734.4353)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770829717235300818.4353)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(770830294703300821)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787129076990949734.4353)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770829717235300818.4353)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(770830568775300821)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787129211664949734.4353)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770829717235300818.4353)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(770830880737300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787129478553949735.4353)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770829717235300818.4353)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(770830880737300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787129664604949735.4353)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770829717235300818.4353)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(770830880737300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787129797417949735.4353)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770829717235300818.4353)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787129942802949735.4353)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770829717235300818.4353)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(770831461915300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797570360313479164.4353)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797570478965479164.4353)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797570646853479165.4353)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797570895501479165.4353)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797571042081479165.4353)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797571272421479165.4353)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797571447867479165.4353)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797571501534479165.4353)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(797571791611479165.4353)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(797568474776479154.4353)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829456396120680656.4353)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829456489387680656.4353)
,p_theme_id=>3
,p_name=>'ADDBOTTOMBORDER'
,p_display_name=>'Add Bottom Border'
,p_display_sequence=>13
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--bottomBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829456523812680656.4353)
,p_theme_id=>3
,p_name=>'ADDLEFTBORDER'
,p_display_name=>'Add Left Border'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--borderLeft'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829456697529680656.4353)
,p_theme_id=>3
,p_name=>'ADDRIGHTBORDER'
,p_display_name=>'Add Right Border'
,p_display_sequence=>11
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--rightBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829456721655680656.4353)
,p_theme_id=>3
,p_name=>'ADDTOPBORDER'
,p_display_name=>'Add Top Border'
,p_display_sequence=>12
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--borderTop'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829456928276680656.4353)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829457167899680656.4353)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829457377910680656.4353)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829457428483680656.4353)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829457686604680656.4353)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829457873432680656.4353)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829458099623680656.4353)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(829458157107680656.4353)
,p_theme_id=>3
,p_name=>'SHOWTOPBUTTON'
,p_display_name=>'Show Top Button'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829454386558680645.4353)
,p_css_classes=>'a-Region--showTopButton'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926399656957707535.4353)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(388535333575474292.4353)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926399745454707535.4353)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(388535333575474292.4353)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(940696690156341580.4353)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1199561127830032419.4353)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(746398369579391892)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525661359651182107.4353)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525661463198182107.4353)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525661538921182107.4353)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525661634515182108.4353)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525661803623182108.4353)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525662055051182108.4353)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525664505544182122.4353)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525664603775182122.4353)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525664790107182122.4353)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525664816420182122.4353)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525665087495182122.4353)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525665273167182122.4353)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544816639795478003.4353)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770828451758300816.4353)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544816735968478004.4353)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770828451758300816.4353)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544816822442478004.4353)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(770828451758300816.4353)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544817297983478008.4353)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(11670410466357416.4353)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544817313883478008.4353)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(11670410466357416.4353)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544817462934478008.4353)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(11670410466357416.4353)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554821911032408403.4353)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554822194319408403.4353)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554822304112408403.4353)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554822529201408404.4353)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554822705386408404.4353)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689641104387993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554822968912408404.4353)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554823153887408404.4353)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554823379060408404.4353)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554823546082408404.4353)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554823609760408404.4353)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554823847364408404.4353)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(486010891028205826.4353)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(689641890550993975)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554834147729526820.4353)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(829445215771671657.4353)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554834211041526820.4353)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829445215771671657.4353)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554834394928526820.4353)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829445215771671657.4353)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554850993386542287.4353)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554851087148542287.4353)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554851242750542287.4353)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554851473200542287.4353)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554851654292542287.4353)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689641104387993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554851832381542288.4353)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554852037917542288.4353)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554852288217542288.4353)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554852446766542288.4353)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554852695350542289.4353)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829458533922680656.4353)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554864460392550809.4353)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554864671291550809.4353)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554864855569550809.4353)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554865036396550809.4353)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554865266775550809.4353)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554865459115550809.4353)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554865662563550810.4353)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554865849887550810.4353)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554866021273550810.4353)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689641104387993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554866292270550810.4353)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1029955071738136284.4353)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(140268206065172819.4353)
,p_build_option_name=>'Database Monitoring'
,p_build_option_status=>'INCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(231647503239340557.4353)
,p_build_option_name=>'Page Caching'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(693461267865622287.4353)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/item_help
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(2123222599612374.4353)
,p_shortcut_name=>'ITEM_HELP'
,p_shortcut_type=>'HTML_TEXT'
,p_error_text=>unistr('Anzeigen der Hilfe nicht m\00F6glich.')
,p_shortcut=>'<a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999"><img src="#IMAGE_PREFIX#infoicon_status_gray.gif" width=16 height=16 border=0></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/admin_home
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(75628231717105217.4353)
,p_shortcut_name=>'ADMIN_HOME'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<table><tr><td>&nbsp;</td><td><table bgcolor="#ffffff" cellspacing=0 cellpadding=0 border="1"><tr><td><a href="f?p=4350:3:&SESSION."><img src="#IMAGE_PREFIX#people2.gif" width="100" height="75" border="0"></a><br><font size="-2" face="arial">Administ'
||'rator - Home...</font></td></tr></table></td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(116152925483353324.4353)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('Soll dieser L\00F6schvorgang ausgef\00FChrt werden?')
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(539691214090646644.4353)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040.4353
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12505007847150358.4353)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Entwicklerautorisierung'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(651531538148363703.4353)
,p_plugin_id=>wwv_flow_api.id(12505007847150358.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651531971028363707.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651532410279363708.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651532900147363708.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651533402536363708.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651533967722363709.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651534419559363709.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651534958084363709.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651535467421363709.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651535927394363710.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651536428628363710.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651536997776363710.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651537439919363711.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(651531538148363703.4353)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(44506226589251870.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(61354352634419491.4353)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Suchfeld'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513169841697230028.4353)
,p_plugin_id=>wwv_flow_api.id(61354352634419491.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513170249930230028.4353)
,p_plugin_id=>wwv_flow_api.id(61354352634419491.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(113748807145665438.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'Apex-Authentifizierung'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(118564054404916668.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL - Social Sign-In'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328097468530426989.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328097862098426989.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328098360285426989.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328098899744426990.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328099337692426990.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328099894223426990.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328100200175426990.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328100627746426991.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328101031104426991.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328101449827426991.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Application Express automatically adds the "openid" scope. The authent'
||'ication provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328101870816426991.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328102298017426991.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328102617526426992.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328103067272426992.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328103468053426992.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328097468530426989.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328103836981426992.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328103468053426992.4353)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328104304974426992.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328103468053426992.4353)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328104890236426993.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328103468053426992.4353)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328105369442426993.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(328103468053426992.4353)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328105811655426993.4353)
,p_plugin_id=>wwv_flow_api.id(118564054404916668.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (e.g. "email_verified" for Username Attribute "email"). If this is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356675029883447688.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNAL - Oracle Cloud Identity Management'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356678220661447691.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNAL - Datenbankaccounts'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356739011564447745.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNAL - HTTP-Headervariable'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43206421388381414.4353)
,p_plugin_id=>wwv_flow_api.id(356739011564447745.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43208631302381414.4353)
,p_plugin_id=>wwv_flow_api.id(356739011564447745.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43210400201381415.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(43208631302381414.4353)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43212165984381415.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(43208631302381414.4353)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43214308184381415.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(43208631302381414.4353)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43216652190381415.4353)
,p_plugin_id=>wwv_flow_api.id(356739011564447745.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43208631302381414.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43218688802381416.4353)
,p_plugin_id=>wwv_flow_api.id(356739011564447745.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(43208631302381414.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43219759485381416.4353)
,p_plugin_id=>wwv_flow_api.id(356739011564447745.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43208631302381414.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'BUILTIN_URL,URL'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43221689703381416.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(43219759485381416.4353)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43223772012381416.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(43219759485381416.4353)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43225985115381416.4353)
,p_plugin_id=>wwv_flow_api.id(356739011564447745.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356812805052447803.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNAL - LDAP-Verzeichnis'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528.4353
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Geben Sie den Benutzernamen und das Kennwort f\00FCr die Authentifizierung beim LDAP-Verzeichnis ein, das auf der Anmeldeseite angegeben wird. Beachten Sie, dass bei der Kennworteingabe m\00F6glicherweise zwischen Gro\00DF- und Kleinschreibung unterschieden w')
||'ird.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356813001684447803.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356813412150447803.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356813831745447803.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356814217919447803.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(356813831745447803.4353)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356814706404447803.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(356813831745447803.4353)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356815206641447804.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(356813831745447803.4353)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356815700428447804.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356816131324447804.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356816504735447804.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(356816131324447804.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356816917591447805.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356817328277447805.4353)
,p_plugin_id=>wwv_flow_api.id(356812805052447803.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356817719903447805.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(356817328277447805.4353)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356818206709447805.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(356817328277447805.4353)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356818717907447807.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(356817328277447805.4353)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356821829039447810.4353)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNAL - Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859.4353
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_html5_bar_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_display_name=>'HTML 5-Balkendiagramm ***'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.HTML5_BAR_CHART'),'#IMAGE_PREFIX#plugins/com.oracle.apex.html5_bar_chart/1.0/')
,p_javascript_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.js'
,p_css_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.css'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FUNCTION RENDER (',
'    P_REGION IN APEX_PLUGIN.T_REGION,',
'    P_PLUGIN IN APEX_PLUGIN.T_PLUGIN,',
'    P_IS_PRINTER_FRIENDLY IN BOOLEAN',
') RETURN APEX_PLUGIN.T_REGION_RENDER_RESULT IS',
'BEGIN',
'    sys.HTP.PRN(''<div id="''||APEX_ESCAPE.HTML_ATTRIBUTE(P_REGION.STATIC_ID)||''_chart" class="hbc">'');',
'    sys.HTP.PRN(''</div>'');',
'    ',
'    APEX_JAVASCRIPT.ADD_ONLOAD_CODE (',
'        P_CODE => ''com_oracle_apex_html5_bar_chart(''||',
'            APEX_JAVASCRIPT.ADD_VALUE(P_REGION.STATIC_ID)||',
'            ''{''||',
'                -- Why is this attribute needed if is not used?',
'                APEX_JAVASCRIPT.ADD_ATTRIBUTE(',
'                    ''pageItems'', ',
'                    APEX_PLUGIN_UTIL.PAGE_ITEM_NAMES_TO_JQUERY(P_REGION.AJAX_ITEMS_TO_SUBMIT)',
'                )||',
'                APEX_JAVASCRIPT.ADD_ATTRIBUTE(',
'                    ''ajaxIdentifier'', ',
'                    APEX_PLUGIN.GET_AJAX_IDENTIFIER, ',
'                    FALSE, ',
'                    FALSE',
'                )||',
'            ''}''||',
'        '');''',
'    );',
'    ',
'    RETURN NULL;',
'END RENDER;',
'',
'FUNCTION AJAX (',
'    P_REGION IN APEX_PLUGIN.T_REGION,',
'    P_PLUGIN IN APEX_PLUGIN.T_PLUGIN',
') RETURN APEX_PLUGIN.T_REGION_AJAX_RESULT IS',
'    -- Map region attributes to function constants',
'    -- MODERN, CLASSIC',
'    C_CHART_TYPE CONSTANT VARCHAR2(7) := P_REGION.ATTRIBUTE_15;',
'    -- MODERN, MODERN_2, SOLAR, METRO, CUSTOM, COLUMN',
'    C_COLOR_SCHEME CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_17;',
'    C_CUSTOM_CHART_COLORS CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_10;',
'    C_COLOR_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_19;',
'    -- NONE, IMAGE, ICON, INITIALS',
'    C_ICON_TYPE CONSTANT VARCHAR2(8) := case when C_CHART_TYPE = ''ICON'' then P_REGION.ATTRIBUTE_01 end;',
'    C_LABEL_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_02;',
'    C_LABEL_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_03;',
'    C_VALUE_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_04;',
'    C_VALUE_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_05;',
'    -- ABOVE, AROUND',
'    C_TEXT_POSITION VARCHAR2(6) := P_REGION.ATTRIBUTE_18;',
'    C_CHART_CSS_CLASSES CONSTANT VARCHAR2(32767) := P_REGION.ATTRIBUTE_06;',
'    C_IMAGE_URL CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_07;',
'    C_CSS_ICON_CLASS_NAME CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_08;',
'    C_INITIALS_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_09;',
'    -- ABSOLUTE, RELATIVE',
'    C_BAR_WIDTH_CALCULATION CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_16;',
'    C_DISPLAY CONSTANT VARCHAR2(19) := P_REGION.ATTRIBUTE_11;',
'    C_PREFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_12;',
'    C_POSTFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_13;',
'    C_MAXIMUM_ROWS CONSTANT NUMBER := P_REGION.ATTRIBUTE_14;',
'    C_MESSAGE_WHEN_NO_DATA_FOUND CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_20;',
'    ',
'    L_COLOR_COLUMN_NUMBER PLS_INTEGER;',
'    L_LABEL_COLUMN_NUMBER PLS_INTEGER;',
'    L_VALUE_COLUMN_NUMBER PLS_INTEGER;',
'    L_INITIALS_COLUMN_NUMBER PLS_INTEGER;',
'    ',
'    L_COLUMN_VALUE_LIST APEX_PLUGIN_UTIL.T_COLUMN_VALUE_LIST2;',
'    ',
'    L_COLOR VARCHAR2(4000) := NULL;',
'    L_LABEL VARCHAR2(4000) := NULL;',
'    L_LABEL_LINK VARCHAR2(4000) := NULL;',
'    L_VALUE VARCHAR2(4000) := NULL;',
'    L_VALUE_LINK VARCHAR2(4000) := NULL;',
'    L_IMAGE_URL VARCHAR2(4000) := NULL;',
'    L_CSS_ICON_CLASS_NAME VARCHAR2(4000) := NULL;',
'    L_INITIALS VARCHAR2(4000) := NULL;',
'    L_MESSAGE_WHEN_NO_DATA_FOUND VARCHAR2(4000) := NULL;',
'',
'    L_CUSTOM_CHART_COLORS_TABLE APEX_APPLICATION_GLOBAL.VC_ARR2;',
'    L_CUSTOM_CHART_COLORS VARCHAR2(32767) := NULL;',
'BEGIN',
'    L_COLUMN_VALUE_LIST := APEX_PLUGIN_UTIL.GET_DATA2(',
'        P_SQL_STATEMENT  => P_REGION.SOURCE,',
'        P_MIN_COLUMNS    => 1,',
'        P_MAX_COLUMNS    => NULL,',
'        P_COMPONENT_NAME => P_REGION.NAME,',
'        P_MAX_ROWS => C_MAXIMUM_ROWS',
'    );',
'',
'    L_COLOR_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Color Column'',',
'        P_COLUMN_ALIAS      => C_COLOR_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => C_COLOR_SCHEME = ''COLUMN'',',
'        P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_LABEL_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Label Column'',',
'        P_COLUMN_ALIAS      => C_LABEL_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_VALUE_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Value Column'',',
'        P_COLUMN_ALIAS      => C_VALUE_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    if C_ICON_TYPE = ''INITIALS'' then',
'        L_INITIALS_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'            P_ATTRIBUTE_LABEL   => ''Initials Column'',',
'            P_COLUMN_ALIAS      => C_INITIALS_COLUMN,',
'            P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'            P_IS_REQUIRED       => true,',
'            P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'        );',
'    end if;',
'    -- Begin output as JSON',
'    sys.OWA_UTIL.MIME_HEADER(''application/json'', FALSE);',
'    sys.HTP.P(''Cache-Control: no-cache'');',
'    sys.HTP.P(''Pragma: no-cache'');',
'    sys.OWA_UTIL.HTTP_HEADER_CLOSE;',
'    ',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        L_CUSTOM_CHART_COLORS_TABLE := APEX_UTIL.STRING_TO_TABLE(CASE WHEN C_CUSTOM_CHART_COLORS IS NOT NULL THEN TRIM(BOTH '''''''' FROM APEX_ESCAPE.JS_LITERAL(C_CUSTOM_CHART_COLORS)) END, '':'');',
'        L_CUSTOM_CHART_COLORS := ''"color_scheme":['';',
'        FOR I IN L_CUSTOM_CHART_COLORS_TABLE.FIRST .. L_CUSTOM_CHART_COLORS_TABLE.LAST LOOP',
'            IF I > 1 THEN',
'                L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||'','';',
'            END IF;',
'            L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''"''||L_CUSTOM_CHART_COLORS_TABLE(I)||''"'';',
'        END LOOP;',
'        L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''],'';',
'    END IF;',
'',
'    L_MESSAGE_WHEN_NO_DATA_FOUND := APEX_ESCAPE.HTML_WHITELIST(',
'        APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                P_VALUE  => C_MESSAGE_WHEN_NO_DATA_FOUND,',
'                P_ESCAPE => FALSE',
'            )',
'        );',
'',
'    sys.HTP.PRN(',
'        ''{''||',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''chart_type'',',
'                C_CHART_TYPE,',
'                FALSE,',
'                TRUE',
'            )',
'    );',
'    sys.HTP.PRN(',
'        APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'            ''message_when_no_data_found'',',
'            L_MESSAGE_WHEN_NO_DATA_FOUND,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'            ''chart_css_class_names'',',
'            C_CHART_CSS_CLASSES,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'            ''icon_type'',',
'            C_ICON_TYPE,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        sys.HTP.PRN(',
'            L_CUSTOM_CHART_COLORS',
'        );',
'    ELSE',
'        sys.HTP.PRN(',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''color_scheme'',',
'                C_COLOR_SCHEME,',
'                TRUE,',
'                TRUE',
'            )',
'        );',
'    END IF;',
'    sys.HTP.PRN(',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''text_position'',',
'                C_TEXT_POSITION,',
'                FALSE,',
'                TRUE',
'            )||',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''bar_width_calculation'',',
'                C_BAR_WIDTH_CALCULATION,',
'                FALSE,',
'                TRUE',
'            )||',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''display'',',
'                C_DISPLAY,',
'                FALSE,',
'                TRUE',
'            )||',
'            CASE ',
'            	WHEN C_DISPLAY IN (''VALUE'') THEN',
'					APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''prefix_for_value'',',
'						C_PREFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)||',
'					APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''postfix_for_value'',',
'						C_POSTFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)',
'			END||',
'            ''"items":[''',
'    );',
'    ',
'    --FOR L_ROW_NUMBER IN L_COLUMN_VALUE_LIST(1).VALUE_LIST.FIRST .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.LAST LOOP',
'    FOR L_ROW_NUMBER IN 1 .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.COUNT LOOP',
'        BEGIN',
'            APEX_PLUGIN_UTIL.SET_COMPONENT_VALUES (',
'                P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'                P_ROW_NUM => L_ROW_NUMBER ',
'            );',
'            ',
'            IF L_ROW_NUMBER > 1 THEN',
'            	sys.HTP.PRN('', '');',
'            END IF;',
'            ',
'            sys.HTP.PRN(''{'');',
'            ',
'            L_LABEL := APEX_PLUGIN_UTIL.ESCAPE (',
'                APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                    P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).DATA_TYPE,',
'                    P_VALUE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                ),',
'                P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''label'',',
'                    L_LABEL,',
'                    FALSE',
'            	)',
'            );',
'            L_LABEL_LINK := ',
'                CASE ',
'                    WHEN C_LABEL_LINK IS NOT NULL THEN ',
'                        APEX_UTIL.PREPARE_URL (',
'                            APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_LABEL_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'            sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''label_link'',',
'                    L_LABEL_LINK',
'                )',
'            );',
'            L_VALUE := APEX_PLUGIN_UTIL.ESCAPE (',
'               APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                   P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).DATA_TYPE,',
'                   P_VALUE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'               ),',
'               P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''value'',',
'                    L_VALUE,',
'                    FALSE,',
'                    C_VALUE_LINK IS NOT NULL OR L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            L_VALUE_LINK := ',
'                CASE ',
'                    WHEN C_VALUE_LINK IS NOT NULL THEN ',
'                        APEX_UTIL.PREPARE_URL (',
'                            APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_VALUE_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'             sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''value_link'',',
'                    L_VALUE_LINK,',
'                    TRUE,',
'                    L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            IF L_COLOR_COLUMN_NUMBER IS NOT NULL THEN',
'                L_COLOR := APEX_PLUGIN_UTIL.ESCAPE (',
'                   APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                       P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).DATA_TYPE,',
'                       P_VALUE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                   ),',
'                   P_REGION.ESCAPE_OUTPUT',
'                );',
'                sys.HTP.PRN(',
'                    APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                        ''color'',',
'                        L_COLOR,',
'                        FALSE,',
'                        C_CHART_TYPE = ''ICON''',
'                    )',
'                );',
'            END IF;',
'            IF C_ICON_TYPE = ''IMAGE'' THEN',
'				L_IMAGE_URL := ',
'                    CASE ',
'                        WHEN C_IMAGE_URL IS NOT NULL THEN ',
'                            APEX_UTIL.PREPARE_URL (',
'                                APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                    P_VALUE  => C_IMAGE_URL,',
'                                    P_ESCAPE => FALSE',
'                                )',
'                            )',
'                    END;',
'				sys.HTP.PRN(',
'					APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''image_url'',',
'						L_IMAGE_URL,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''ICON'' THEN',
'				L_CSS_ICON_CLASS_NAME := APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                    P_VALUE  => C_CSS_ICON_CLASS_NAME,',
'                    P_ESCAPE => TRUE',
'                );',
'				sys.HTP.PRN(',
'                	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''icon_css_class_name'',',
'						L_CSS_ICON_CLASS_NAME,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''INITIALS'' THEN',
'				L_INITIALS := APEX_PLUGIN_UTIL.ESCAPE (',
'					APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'						P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).DATA_TYPE,',
'						P_VALUE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'					),',
'					P_REGION.ESCAPE_OUTPUT',
'				);',
'				sys.HTP.PRN(',
'                	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    	''initials'',',
'	                    L_INITIALS,',
'	                    FALSE,',
'	                    FALSE',
'    	            )',
'    	        );',
'            END IF;',
'            ',
'			sys.HTP.PRN(''}'');',
'            ',
'            APEX_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'        EXCEPTION',
'            WHEN OTHERS THEN',
'                APEX_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'                RAISE;',
'        END;',
'    END LOOP;',
'    sys.HTP.PRN(',
'            '']''||',
'        ''}''',
'    );',
'    ',
'    RETURN NULL;',
'END AJAX;'))
,p_api_version=>1
,p_render_function=>'RENDER'
,p_ajax_function=>'AJAX'
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_reference_id=>5610141522737396215.4353
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'	Dieses Plug-in zeichnet horizontale Balkendiagramme, die Labels, Werte und sogar Symbole enthalten.</p>'))
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702334718872248058.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INITIALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702342810423248065.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Image</strong>: Adds an image HTML element on the left side of the chart.</li>',
'    <li><strong>CSS Icon</strong>: Unlike the &quot;Image&quot; icon, instead of displaying an image HTML element, it displays an icon with the given CSS class.</li>',
'    <li><strong>Initials</strong>: Opposed to both, the &quot;Image&quot; and &quot;CSS Icon&quot; icons, this one displays a colored circle containing the given initials.</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702335171470248059.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702334718872248058.4353)
,p_display_sequence=>10
,p_display_value=>'Image'
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702335675058248060.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702334718872248058.4353)
,p_display_sequence=>20
,p_display_value=>'CSS Icon'
,p_return_value=>'ICON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702336137978248060.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702334718872248058.4353)
,p_display_sequence=>30
,p_display_value=>'Initials'
,p_return_value=>'INITIALS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702336688801248060.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Label Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702337000944248061.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Label Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the label is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702337476819248061.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Value Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given. Notice that this value is not displayed on the chart items when the chart has been configured to display the bar width percentage instead.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702337891068248061.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Value Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the displayed value is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702338214151248062.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>'Chart CSS Class Names'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'<p>CSS class names to be added to the root element of the chart separated with spaces.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702338638281248062.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>13
,p_prompt=>'Image URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702334718872248058.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_help_text=>'<p>The Image URL to be displayed as the chart icon. This attribute supports Substitution strings referring to som query column like in <strong>&amp;IMAGE_URL.</strong> which would reference the <strong>IMAGE_URL</strong> column value for each of the '
||'bars presented on the char. Notice that substitutions with no value will be replaced with an empty string.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702339094280248062.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>12
,p_prompt=>'CSS Icon Class Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702334718872248058.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_help_text=>'<p>The Icon CSS Class Name.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702339499744248062.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>14
,p_prompt=>'Initials Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702334718872248058.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INITIALS'
,p_help_text=>'<p>A query column from which initials to be displayed as an icon are given.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702339807094248063.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>7
,p_prompt=>'Custom Chart Colors'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'CUSTOM'
,p_help_text=>'<p>A list of CSS supported colors separated by colons.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702340226884248063.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Display'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Displays either the item value or the calculated bar width on the right most text in the chart item.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702340619514248063.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702340226884248063.4353)
,p_display_sequence=>10
,p_display_value=>'Value'
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702341146963248064.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702340226884248063.4353)
,p_display_sequence=>20
,p_display_value=>'Bar Width'
,p_return_value=>'BAR_WIDTH'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702341650689248064.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Prefix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1702340226884248063.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is prepended to it.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702342001349248064.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Postfix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1702340226884248063.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is appended to it.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702342462654248065.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Maximum Rows'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_help_text=>'<p>The maximum number of items to be displayed inside the region. Notice bar width calculations are made based on the number of items displayed.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702342810423248065.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>4
,p_prompt=>'Chart Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines how the chart will be displayed. There are two types of chart: </p>',
'<ul>',
'    <li><strong>Icon Chart</strong>: Displays bars with the label and value above and add an icon on the left.</li>',
'    <li><strong>Text Chart</strong>: Displays bars with the label and value either above or inline with the bar.</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702343211589248065.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702342810423248065.4353)
,p_display_sequence=>10
,p_display_value=>'Icon Chart'
,p_return_value=>'ICON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702343724597248066.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702342810423248065.4353)
,p_display_sequence=>20
,p_display_value=>'Text Chart'
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702344281829248066.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>105
,p_prompt=>'Bar Width Calculation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ABSOLUTE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Bar widths for each one of the chart items can be calculated in two ways:</p>',
'<ul>',
'    <li><strong>Absolute</strong>: 100% bar width is represented by the maximum value on the displayed chart items.</li>',
'    <li><strong>Relative</strong>: 100% bar width is represented by the sum of the values of all the displayed chart items.</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702344685135248067.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702344281829248066.4353)
,p_display_sequence=>10
,p_display_value=>'Absolute'
,p_return_value=>'ABSOLUTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702345182204248067.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702344281829248066.4353)
,p_display_sequence=>20
,p_display_value=>'Relative'
,p_return_value=>'RELATIVE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>6
,p_prompt=>'Color Scheme'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MODERN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The colors to be used in the chart bars. There are two special types of configuration: </p>',
'<ul>',
'    <li><strong>Custom</strong>: Provides a text box to receive a colon separated list of css supported colors.</li>',
'</ul>',
'<ul>',
'    <li><strong>Query Column</strong>: Provides a select list with the query columns which expects a css valid color.</li>',
'</ul>',
''))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702346097919248068.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_display_sequence=>5
,p_display_value=>'Default'
,p_return_value=>'DEFAULT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702346538929248068.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_display_sequence=>10
,p_display_value=>'Modern'
,p_return_value=>'MODERN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702347083560248069.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_display_sequence=>20
,p_display_value=>'Modern 2'
,p_return_value=>'MODERN_2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702347505297248069.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_display_sequence=>30
,p_display_value=>'Solar'
,p_return_value=>'SOLAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702348056927248069.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_display_sequence=>40
,p_display_value=>'Metro'
,p_return_value=>'METRO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702348548765248070.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_display_sequence=>50
,p_display_value=>'Custom'
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702349044832248070.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_display_sequence=>60
,p_display_value=>'Query Column'
,p_return_value=>'COLUMN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702349545275248070.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>55
,p_prompt=>'Text Position'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AROUND'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702342810423248065.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'TEXT'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When displaying a text chart, two options are available for displaying the label and value texts:</p>',
'<ul>',
'    <li><strong>Above the bar</strong>: The label and value texts are displayed above the bar at the left and right most sides of it respectively.</li>',
'    <li><strong>Inline with the bar</strong>: The label, the bar and the value are displayed in one line on that order.</li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702349966426248071.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702349545275248070.4353)
,p_display_sequence=>10
,p_display_value=>'Above the bar'
,p_return_value=>'ABOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702350427006248071.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(1702349545275248070.4353)
,p_display_sequence=>20
,p_display_value=>'Inline with the bar'
,p_return_value=>'AROUND'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702350916802248071.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>8
,p_prompt=>'Chart Colors Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702345651994248067.4353)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'COLUMN'
,p_help_text=>'<p>A query column from which CSS supported colors are given.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702351321939248072.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>'Message When No Data Found'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'No data found.'
,p_is_translatable=>true
,p_help_text=>'<p>Message to be displayed when no data was found.</p>'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1702355088636248078.4353)
,p_plugin_id=>wwv_flow_api.id(1591049479124636231.4353)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2180265113361711031.4353)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>'Assistentenauswahl'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_reference_id=>3260301366184169092.4353
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2180265308752711037.4353)
,p_plugin_id=>wwv_flow_api.id(2180265113361711031.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2180265799725711042.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(2180265308752711037.4353)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2180266212595711047.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(2180265308752711037.4353)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2180266731458711048.4353)
,p_plugin_attribute_id=>wwv_flow_api.id(2180265308752711037.4353)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2180267217007711048.4353)
,p_plugin_id=>wwv_flow_api.id(2180265113361711031.4353)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845155782990834528.4353)
,p_plugin_id=>wwv_flow_api.id(2180265113361711031.4353)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2448108135531494687.4353)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>unistr('Kontrollk\00E4stchen "Alle pr\00FCfen" hinzuf\00FCgen')
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512.4353
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die dynamische Aktion "Kontrollk\00E4stchen Alle pr\00FCfen hinzuf\00FCgen" macht eine Spalten\00FCberschrift, die die Zeichenfolge #CHECK_ALL_CHECKBOX# enth\00E4lt, zu einem zug\00E4nglichen Kontrollk\00E4stchen "Alle pr\00FCfen", das alle Kontrollk\00E4stchen in der entsprechenden')
||unistr(' Spalte w\00E4hlt bzw. deren Auswahl aufhebt.<p>'),
'<p>',
unistr('Zur Verwendung dieses Plug-ins m\00FCssen die folgenden Attribute festgelegt sein:'),
'<ol>',
unistr('<li>In der Berichtsspalte ist ''#CHECK_ALL_CHECKBOX#'' als \00DCberschriftenwert definiert.</li>'),
unistr('<li>F\00FCr das When-Attribut der dynamischen Aktion muss die Berichtsregion ausgew\00E4hlt sein, die die Spalte enth\00E4lt.</li>'),
unistr('<li>Die dynamische Aktion zur Ausl\00F6sung von "Nach Refresh" und die Aktion "Bei Laden von Seite ausl\00F6sen" m\00FCssen definiert sein. (Beide sind entsprechend als Standardwert definiert, wenn die dynamische Aktion durch Auswahl der Region im Abschnitt "Ren')
||'dering" des Page Designers erstellt wird und die dynamische Aktion von dort erstellt wird.</li>',
unistr('<li>Dadurch wird die Zug\00E4nglichkeit der Kontrollk\00E4stchen nicht festgelegt, die auf jeder Zeile wiedergegeben werden, dies muss separat in der Regionsquelle erfolgen. (Ein Beispiel finden Sie unter 4000:656 "Region").</li>'),
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4969311180302342.4353)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=4500:1000:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>.4353
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seite null'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215451130329541858)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30352322089771992.4353)
,p_plug_name=>'JS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>4
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'    function submitenter(myfield,e)',
'    {',
'        var keycode;',
'        if (window.event) keycode = window.event.keyCode;',
'        else if (e) keycode = e.which;',
'        else return true;',
'',
'        if (keycode == 13)',
'        {',
'            redirect(''f?p=&APP_ID.:8000:&SESSION.:::RIR:IR_ROWFILTER:''+$v(''P0_SEARCH''));',
'            return false;',
'        }',
'        else',
'            return true;',
'    }',
'    ',
'    function initSearch(searchField) ',
'    {',
'        searchField.value = "";',
'        searchField.style.color = "#000000";',
'    }',
'//-->',
'</script>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388539809791523187.4353)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-workspace-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'68'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388540086737523188.4353)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_api.id(388539809791523187.4353)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1582031051259050.4353)
,p_plug_name=>'Application Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_api.id(388540086737523188.4353)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(719024906222154750.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(388535020971474291.4353)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388540217286523188.4353)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_api.id(388540086737523188.4353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<a href="f?p=4500:1000:''||:APP_SESSION||''::''||:DEBUG||''::::" class="a-Header-logo" title="''||wwv_flow_lang.system_message(''HOME_NAV'')||''"><span class="a-Header-apexLogo"></span></a>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388540417683523188.4353)
,p_plug_name=>'APEX 5 - Home Link'
,p_parent_plug_id=>wwv_flow_api.id(388540086737523188.4353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388540652992523188.4353)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_api.id(388539809791523187.4353)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388540854983523188.4353)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_api.id(388540652992523188.4353)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388566674203594195.4353)
,p_plug_name=>'APEX 5 - Header Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(697508149859311566.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(388535333575474292.4353)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486772128588301731.4353)
,p_plug_name=>'APEX 5 - Header Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(697513111062314247.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(388535333575474292.4353)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388541051943523188.4353)
,p_plug_name=>'APEX 5 - Header Account'
,p_parent_plug_id=>wwv_flow_api.id(388540652992523188.4353)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(642566440163156401.4353)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_api.id(388540652992523188.4353)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'sys.htp.p(''  <div class="a-SearchBox-field">'');',
'sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.SEARCH'')||''</label>'');',
'sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.SEARCH.USERS'')||''">'');',
'sys.htp.p(''  </div>'');',
'sys.htp.p(''</div>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388541233076523188.4353)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-workspace-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1,68'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388541479862523188.4353)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_api.id(388541233076523188.4353)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388567311021599596.4353)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_api.id(388541479862523188.4353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(4090422833267509.4353)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(388538606549481005.4353)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388541658700523189.4353)
,p_plug_name=>'APEX 5 - Control Bar Right'
,p_parent_plug_id=>wwv_flow_api.id(388541233076523188.4353)
,p_region_css_classes=>'a-ControlBar-col'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>100
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(388546581076568901.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(388540417683523188.4353)
,p_button_name=>'Home'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>'Home'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4500:1000:&APP_SESSION.'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-home'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(735034227876168737.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Upgrade verf\00FCgbar')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-calendar u-info-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(735034183175168736.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upgrade in Bearbeitung'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-warning u-danger-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(233600835088079607.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_button_name=>'SPOTLIGHT'
,p_button_static_id=>'header-spotlightSearch'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>'Spotlight-Suche'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-search'
,p_button_cattributes=>'data-action="spotlight-search"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(388546746057568903.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_button_name=>'Administration'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388537948307476852.4353)
,p_button_image_alt=>'Administration'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink a-Button--activeTab tab-admin'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(388546906930568903.4353)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_button_name=>'Feedback'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>'Feedback'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_api.id(693461267865622287.4353)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(388547181746568903.4353)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(388540854983523188.4353)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388537948307476852.4353)
,p_button_image_alt=>'Hilfe'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Administration'
,p_step_title=>'Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_hm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27257417764751845.4353)
,p_plug_name=>'Aufgaben'
,p_region_css_classes=>'a-Region--stacked a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(166211911060758908.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29223409612811479.4353)
,p_plug_name=>'Workspace-Meldung'
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>'');',
'wwv_flow_4000_ui.show_workspace_notification (',
'   p_workspace_id       => :flow_security_group_id,',
'   p_session            => :app_session);',
'sys.htp.p(''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Admins always see the region so they can edit the announcement, while',
'-- Developers see the region only when announcement has been defined.',
'wwv_flow_4000_ui.workspace_notification_exists(',
'    p_workspace_id => :flow_security_group_id',
')',
'or wwv_flow_authorization_api.is_authorized(''Flow: ADMIN'')'))
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29444404444314439.4353)
,p_plug_name=>'System Message'
,p_region_css_classes=>'a-SystemMessage a-Region--noTopBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_source=>'wwv_flow_4050_ui.show_system_message(p_app_session => :APP_SESSION);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4050_ui.system_message_exists()'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30612511381129844.4353)
,p_plug_name=>'Seitenvoreinstellungen'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_required_role=>wwv_flow_api.id(12518728403445471)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(42997223242377527.4353)
,p_name=>'Benutzer'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P1b */',
'   count(*) user_count,',
'   sum(decode(developer_type,null,1,0)) end_user_count,',
'   sum(decode(is_developer,''Y'',1,0)) developer_count,',
'   sum(decode(developer_type,''ADMIN'',1,0)) workspace_admin_count,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 1),sysdate -1,0,1)) created_last_24_hours,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 7),sysdate -7,0,1)) created_last_week',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(42997223242377527.4353)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(42997508990377534.4353)
,p_query_column_id=>1
,p_column_alias=>'USER_COUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzer'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(42997608538377535.4353)
,p_query_column_id=>2
,p_column_alias=>'END_USER_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Endbenutzer'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(42997711215377535.4353)
,p_query_column_id=>3
,p_column_alias=>'DEVELOPER_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Anwendungsentwickler'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(42997926989377535.4353)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_ADMIN_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace-Administratoren'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46347512034168203.4353)
,p_query_column_id=>5
,p_column_alias=>'CREATED_LAST_24_HOURS'
,p_column_display_sequence=>5
,p_column_heading=>'Erstellt in letzten 24 Stunden'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46347722423171255.4353)
,p_query_column_id=>6
,p_column_alias=>'CREATED_LAST_WEEK'
,p_column_display_sequence=>6
,p_column_heading=>'Erstellt in letzter Woche'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(43023106337252491.4353)
,p_name=>unistr('Aktivit\00E4t')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P1c */ ',
'  page_events,',
'  median_elap,',
'  distinct_users,',
'  distinct_sessions,',
'  errors_raised,',
'  distinct_applications,',
'  wwv_flow_4000_ui.get_timeframe(:P1_TIME) reporting_timeframe',
'from',
'(',
'select ',
'    count(*) page_events,',
'    median(elap) median_elap,',
'    count(distinct(userid)) distinct_users,',
'    count(distinct(flow_id)) distinct_applications,',
'    count(distinct(session_id)) distinct_sessions,',
'    sum(decode(sqlerrm,null,0,1)) errors_raised',
'from (',
'select /*+ INDEX(wwv_flow_activity_log1$ WWV_FLOW_ACTIVITY_LOG1$_IDX1) */',
'    elap, userid, flow_id, session_id, sqlerrm',
'  from wwv_flow_activity_log1$',
'where security_group_id = :flow_security_group_id and',
'time_stamp > sysdate - :P1_TIME',
'union all',
'select /*+ INDEX(wwv_flow_activity_log2$ WWV_FLOW_ACTIVITY_LOG2$_IDX1) */',
'    elap, userid, flow_id, session_id, sqlerrm',
'  from wwv_flow_activity_log2$',
'where security_group_id = :flow_security_group_id and',
'time_stamp > sysdate - :P1_TIME',
')',
') r'))
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(43023106337252491.4353)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(43024030925259558.4353)
,p_query_column_id=>1
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_column_heading=>'Seitenereignisse'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(43024106979259558.4353)
,p_query_column_id=>2
,p_column_alias=>'MEDIAN_ELAP'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Medianwert f\00FCr Seitenbereitstellungsdauer')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(43024307318259558.4353)
,p_query_column_id=>3
,p_column_alias=>'DISTINCT_USERS'
,p_column_display_sequence=>5
,p_column_heading=>'Eindeutige Benutzer'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(43024526001259558.4353)
,p_query_column_id=>4
,p_column_alias=>'DISTINCT_SESSIONS'
,p_column_display_sequence=>6
,p_column_heading=>'Eindeutige Sessions'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(43024622128259559.4353)
,p_query_column_id=>5
,p_column_alias=>'ERRORS_RAISED'
,p_column_display_sequence=>7
,p_column_heading=>'Fehler'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RP,RIR:IRNN_SQLERRM:'
,p_column_linktext=>'#ERRORS_RAISED#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(435137310696295572.4353)
,p_query_column_id=>6
,p_column_alias=>'DISTINCT_APPLICATIONS'
,p_column_display_sequence=>4
,p_column_heading=>'Eindeutige Anwendungen'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(435137129565263152.4353)
,p_query_column_id=>7
,p_column_alias=>'REPORTING_TIMEFRAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Zeitrahmen f\00FCr Berichtserstellung')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:59::'
,p_column_linktext=>'#REPORTING_TIMEFRAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46082728200564532.4353)
,p_plug_name=>'Workspace &COMPANY. verwalten.'
,p_region_sub_css_classes=>'workspace-admin'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(46082227723554970.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(717846892308122004.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46088231420697995.4353)
,p_name=>'Service'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P1a */',
'    :company workspace_name,',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_files f, wwv_flow_fnd_user u',
' where u.security_group_id = :flow_security_group_id',
'   and u.user_name = :APP_USER',
'   and f.file_type = ''SCRIPT''',
') as sql_scripts,',
'(',
'select count(*)',
'  from wwv_flow_ws_applications ws',
' where ws.security_group_id = :flow_security_group_id',
') as websheets,',
'(',
'select count(*)',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id',
') as schemas,',
'--',
'(select sum(open_requests) open_reqests',
'from',
'(',
'select count(*) open_requests',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id and',
'      project_status = ''REQUESTED''',
'union all',
'select count(*) open_requests',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      m.request_status = ''REQUESTED''',
') q ) open_requests',
'from dual'))
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(46088231420697995.4353)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46089516576722100.4353)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace-Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46345109003448326.4353)
,p_query_column_id=>2
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Datenbankanwendungen'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47468531354816438.4353)
,p_query_column_id=>3
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>5
,p_column_heading=>'SQL-Skripts'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47468207459809511.4353)
,p_query_column_id=>4
,p_column_alias=>'WEBSHEETS'
,p_column_display_sequence=>3
,p_column_heading=>'Websheet-Anwendungen'
,p_use_as_row_header=>'N'
,p_report_column_required_role=>wwv_flow_api.id(771323113864288687)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47468626466816438.4353)
,p_query_column_id=>5
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>6
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47469028977844130.4353)
,p_query_column_id=>6
,p_column_alias=>'OPEN_REQUESTS'
,p_column_display_sequence=>7
,p_column_heading=>'Offene Anforderungen'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48537315419306557.4353)
,p_plug_name=>'Info'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00DCber Workspace-Administration k\00F6nnen Sie Ihren Account verwalten. Sie k\00F6nnen diesen Workspace Ihren Berechtigungen entsprechend \00FCberwachen und verwalten.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/understanding-workspace-administration.html#GUID-B13D2792-6E50-4295-8830-0A341B6ABB00">Weitere Informationen...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168483501399376268.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46082728200564532.4353)
,p_button_name=>'CHANGE_PW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(297663202145957383.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Mein Kennwort \00E4ndern')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:RP,58:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32641004454198704.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(29223409612811479.4353)
,p_button_name=>'EDIT_ANNOUNCEMENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>'Workspace-Nachricht definieren'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:35::'
,p_icon_css_classes=>'icon-edit'
,p_button_cattributes=>'alt="&EDIT." title="&EDIT." height="16" width="16"'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30527919163801184.4353)
,p_name=>'P1_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30612511381129844.4353)
,p_source=>'select to_number(''0.125'',''9.999'',''NLS_NUMERIC_CHARACTERS='''',.'''''') from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Zeigen Sie die Echtzeitstatistiken f\00FCr diesen Zeitraum an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30192404188098919.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_api.create_page(
 p_id=>2.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Schema-Tablespace-Nutzung'
,p_step_title=>'Schema-Tablespace-Nutzung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5783706478780036.4353)
,p_name=>'Schema-Tablespace-Zuordnungen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>54
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P2a */ a.schema, u.default_tablespace',
'  from wwv_flow_company_schemas a, sys.dba_users u',
' where a.schema            = u.username',
'   and a.schema            = :p2_schema',
'   and a.security_group_id = wwv_flow.get_sgid',
'order by 1'))
,p_display_when_condition=>'P2_SCHEMA'
,p_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(5783706478780036.4353)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5784013471780043.4353)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1475461198068625316.4353)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_TABLESPACE'
,p_column_display_sequence=>2
,p_column_heading=>'Default Tablespace'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5784712365781713.4353)
,p_name=>'Freier Speicherplatz nach Tablespace (Megabyte)'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>64
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ts as (',
'    select distinct tablespace_name',
'      from sys.dba_segments',
'     where owner = :P2_SCHEMA ),',
'ddf as (',
'    select f.file_id,',
'           f.tablespace_name,',
'           f.file_name,',
'           decode (f.autoextensible,',
'            ''YES'', greatest (f.bytes, f.maxbytes), f.bytes) df_size,',
'           decode (f.autoextensible,',
'            ''YES'', case',
'                       when (f.maxbytes > f.bytes)',
'                       then (f.maxbytes - f.bytes)',
'                       else 0',
'                   end, 0 ) growth',
'      from sys.dba_data_files f,',
'           ts',
'     where f.tablespace_name = ts.tablespace_name )',
'select ddf.tablespace_name name,',
'       round ((sum (nvl (freebytes, 0)) + sum (growth))/1024/1024 ) free',
'  from ddf,',
'       (select d.file_id, sum (d.bytes) freebytes',
'          from sys.dba_free_space d,',
'               ts',
'         where d.tablespace_name = ts.tablespace_name',
'         group by file_id) dfs',
' where ddf.file_id = dfs.file_id(+)',
' group by ddf.tablespace_name        '))
,p_display_when_condition=>'P2_SCHEMA'
,p_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(5784712365781713.4353)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5904028247808259.4353)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5904325214808260.4353)
,p_query_column_id=>2
,p_column_alias=>'FREE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5871829174600336.4353)
,p_plug_name=>'Schemadetails'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Jeder Workspace hat Zugriff auf Datenbankschemas. Auf dieser Seite werden die Details zum jeweiligen Schema aufgelistet.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5873031776638945.4353)
,p_name=>'Workspace-Schemas'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P2c */ schema',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11670410466357416.4353)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 07-APR-2004 15:37:37'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5873328941638951.4353)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>'SCHEMA'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::P2_SCHEMA:#SCHEMA#'
,p_column_linktext=>'#SCHEMA#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6624822428048770.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(6621926453040443.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_platform.get_preference( ''SERVICE_REQUESTS_ENABLED'' ) = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(182271012856475081.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>44
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(182440902719115584.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(182271012856475081.4353)
,p_button_name=>'P2_GO'
,p_button_static_id=>'P2_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(182441124506115587.4353)
,p_branch_action=>'f?p=&FLOW_ID.:2:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5875420478645168.4353)
,p_name=>'P2_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(182271012856475081.4353)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(a.schema) d, a.schema r',
'  from wwv_flow_company_schemas a',
' where a.security_group_id = (select wwv_flow.get_sgid from dual)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Schema ausw\00E4hlen -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Geben Sie ein Schema an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432753604790034958.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P2_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler'
,p_process_when=>'P2_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_api.create_page(
 p_id=>3.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Profil bearbeiten'
,p_page_mode=>'MODAL'
,p_step_title=>'Profil bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'550'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/aadm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(485918486401411525.4353)
,p_plug_name=>'Profildetails'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 19-FEB-2000 22:09:25'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1142730838556397048.4353)
,p_plug_name=>'Profilfoto'
,p_parent_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_header=>unistr('Ihr Profilfoto personalisiert Ihre Aktivit\00E4t, indem es in der Liste "Top Benutzer" angezeigt wird. Sie k\00F6nnen Ihr Foto hinzuf\00FCgen, \00E4ndern oder entfernen.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1142730993807397049.4353)
,p_plug_name=>'<a name="pwd"></a>&F4350_PASSWORD_REGION_TITLE.'
,p_region_name=>'PWD'
,p_parent_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Wenn Sie Ihr Kennwort \00E4ndern m\00F6chten, geben Sie ein neues Kennwort sein. Andernfalls lassen Sie die Kennwortfelder leer, und das aktuelle Kennwort wird nicht ge\00E4ndert.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(485930812856411538.4353)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P3_WEB_PASSWORD := null;',
':F4350_P3_USER_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(485932134912411539.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(534309773003323583.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1142730838556397048.4353)
,p_button_name=>'P3_DELETE'
,p_button_static_id=>'P3_DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Aktuelles Foto'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user',
' where user_id = :F4350_P3_USER_ID',
'   and sys.dbms_lob.getlength( profile_image ) > 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(485932789329411544.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(485932134912411539.4353)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
,p_button_condition=>'F4350_P3_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(485932354419411539.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(485932134912411539.4353)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485918673324411527.4353)
,p_name=>'F4350_P3_USER_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_use_cache_before_default=>'NO'
,p_source=>'USER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485918831775411527.4353)
,p_name=>'F4350_P3_COMPANY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'a-Form-field a-Form-field--readOnly'
,p_tag_attributes=>' '
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt an, welchem Workspace dieser Benutzer angeh\00F6rt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485919355052411527.4353)
,p_name=>'F4350_P3_USER_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Benutzername'
,p_source=>'USER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'a-Form-field a-Form-field--readOnly'
,p_tag_attributes=>' '
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gibt den Benutzernamen f\00FCr die Anmeldung beim System an. F\00FCr Benutzernamen gelten folgende Einschr\00E4nkungen:</p>'),
'<ul>',
unistr('    <li>maximale L\00E4nge von 100 Zeichen</li>'),
'    <li>keine Leerzeichen</li>',
unistr('    <li>nur folgende Sonderzeichen sind zul\00E4ssig: @ und Punkte (.)</li>'),
'</ul>',
unistr('<p>Der Benutzername kann au\00DFerdem als Referenz zur Benutzeraktivit\00E4t bei Monitoranwendungen verwendet werden. Die Bind-Variable <code>:APP_USER</code> gibt den Wert des aktuellen Benutzers zur\00FCck, wenn Anwendungen erstellt werden.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485919804537411527.4353)
,p_name=>'F4350_P3_EMAIL_ADDRESS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'E-Mail-Adresse'
,p_source=>'EMAIL_ADDRESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_security_scheme=>'!'||wwv_flow_api.id(6738625560859071)
,p_help_text=>unistr('Gibt die E-Mail-Adresse zum Beispiel f\00FCr die allgemeine Korrespondenz, f\00FCr Benachrichtigungen zum Zur\00FCcksetzen von Kennw\00F6rtern an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485920363918411527.4353)
,p_name=>'F4350_P3_ORG_EMAIL_ADDRESS'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_use_cache_before_default=>'NO'
,p_source=>'&F4350_P3_EMAIL_ADDRESS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485921331431411529.4353)
,p_name=>'F4350_P3_FIRST_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Vorname'
,p_source=>'FIRST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den Vornamen an, um den Benutzer weiter zu identifizieren. Dieses optionale Feld wird nur zu Informationszwecken verwendet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485921884101411529.4353)
,p_name=>'F4350_P3_LAST_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nachname'
,p_source=>'LAST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den Nachnamen an, um den Benutzer weiter zu identifizieren. Dieses optionale Feld wird nur zu Informationszwecken verwendet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485933179379411545.4353)
,p_name=>'F4350_P3_WEB_PASSWORD'
,p_item_sequence=>96
,p_item_plug_id=>wwv_flow_api.id(1142730993807397049.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Neues Kennwort eingeben'
,p_placeholder=>'Neues Kennwort'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Das Kennwort f\00FCr die Anmeldung beim System. Geben Sie nur dann ein Kennwort ein, wenn Sie das aktuelle Kennwort \00E4ndern m\00F6chten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485933686391411545.4353)
,p_name=>'F4350_P3_USER_PASSWORD'
,p_item_sequence=>106
,p_item_plug_id=>wwv_flow_api.id(1142730993807397049.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Kennwort best\00E4tigen')
,p_placeholder=>unistr('Kennwort best\00E4tigen')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Geben Sie das Kennwort erneut ein. Geben Sie nur dann ein Kennwort ein, wenn Sie das aktuelle Kennwort \00E4ndern m\00F6chten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485934109258411546.4353)
,p_name=>'P3_UPDATE_PW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485934575979411546.4353)
,p_name=>'P3_FIRST_PWD_USE_OCCURRED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(485918486401411525.4353)
,p_use_cache_before_default=>'NO'
,p_source=>'FIRST_PASSWORD_USE_OCCURRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486809306138103564.4353)
,p_name=>'P3_PROFILE_IMAGE'
,p_item_sequence=>86
,p_item_plug_id=>wwv_flow_api.id(1142730838556397048.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Foto'
,p_source=>'PROFILE_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('W\00E4hlen Sie ein Foto, um den Benutzer n\00E4her zu identifizieren. Dieses optionale Feld wird nur zu Informationszwecken verwendet. Um ein Bild ohne Verzerrung anzuzeigen, sollte die Bildgr\00F6\00DFe im Idealfall 32x32 betragen. Sie k\00F6nnen das vorhandene Foto er')
||unistr('setzen, indem Sie ein neues Foto hochladen, oder indem Sie auf die Schaltfl\00E4che <strong>Aktuelles Foto l\00F6schen</strong> klicken. Klicken Sie auf die Schaltfl\00E4che "Durchsuchen", um ein Foto vom Festplattenlaufwerk hochzuladen. ')
,p_attribute_01=>'DB_COLUMN'
,p_attribute_02=>'PROFILE_MIMETYPE'
,p_attribute_03=>'PROFILE_FILENAME'
,p_attribute_04=>'PROFILE_CHARSET'
,p_attribute_05=>'PROFILE_LAST_UPDATE'
,p_attribute_06=>'N'
,p_attribute_11=>'image/*'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(538621678004238307.4353)
,p_name=>'P3_CURRENT_PHOTO'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(1142730838556397048.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Aktuelles Foto'
,p_source=>'PROFILE_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_tag_css_classes=>'u-circlePhoto'
,p_tag_attributes=>'height="64" width="64" alt="Profile image for &F4350_P3_USER_NAME."'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user',
' where user_id = :F4350_P3_USER_ID',
'   and sys.dbms_lob.getlength( profile_image ) > 0'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Zeigt das aktuell zur Identifizierung des Benutzers verwendete Foto an. Sie k\00F6nnen das vorhandene Foto ersetzen, indem Sie ein neues Foto hochladen oder auf die Schaltfl\00E4che <strong>Aktuelles Foto entfernen</strong> klicken.')
,p_attribute_01=>'DB_COLUMN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1000725807551503640.4353)
,p_name=>'F4350_P3_CURRENT_PASSWORD'
,p_item_sequence=>86
,p_item_plug_id=>wwv_flow_api.id(1142730993807397049.4353)
,p_prompt=>'Aktuelles Kennwort eingeben'
,p_placeholder=>'Aktuelles Kennwort'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
' * require current password if',
' * - builder requires password (e.g. APEX auth - not SSO auth)',
' * - user password has already been changed',
' */',
' ',
'not wwv_flow_authentication_dev.is_builder_password_required (',
'        p_developer_yn => ''N'' )',
' or :P3_FIRST_PWD_USE_OCCURRED=''Y'''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Geben Sie Ihr aktuelles Kennwort ein. Geben Sie nur dann ein Kennwort ein, wenn Sie das aktuelle Kennwort \00E4ndern m\00F6chten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1252825859703086130.4353)
,p_name=>'P3_CURRENT_PHOTO_ALT'
,p_item_sequence=>96
,p_item_plug_id=>wwv_flow_api.id(1142730838556397048.4353)
,p_source=>'wwv_flow_lang.system_message(''USER_PROFILE_IMAGE'',:F4350_P3_USER_NAME)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(485937869389411549.4353)
,p_computation_sequence=>40
,p_computation_item=>'P3_UPDATE_PW'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'length(:F4350_P3_USER_PASSWORD)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(528338806493397505.4353)
,p_computation_sequence=>50
,p_computation_item=>'F4350_P3_COMPANY'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_security.find_company_name ( p_security_group_id => wwv_flow_security.g_security_group_id );'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(485938428402411550.4353)
,p_validation_name=>'validate email'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_at  number;',
'    l_dot number;',
'begin',
'    l_at  := instr(nvl(:F4350_P3_EMAIL_ADDRESS,''x''),''@'');',
'    l_dot := instr(nvl(:F4350_P3_EMAIL_ADDRESS,''x''),''.'',l_at);',
'',
'    return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltige E-Mail-Adresse.')
,p_when_button_pressed=>wwv_flow_api.id(485932789329411544.4353)
,p_associated_item=>wwv_flow_api.id(485919804537411527.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_security_scheme=>'!'||wwv_flow_api.id(6738625560859071)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(485939238468411551.4353)
,p_validation_name=>'if change username, must reset password'
,p_validation_sequence=>105
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select user_name',
'     from wwv_flow_fnd_user',
'    where user_id = :F4350_P3_USER_ID',
'      and security_group_id = :flow_security_group_id )',
'loop',
'   if c1.user_name != :F4350_P3_USER_NAME and',
'      :F4350_P3_WEB_PASSWORD is null then',
'   return false;',
'   else return true;',
'   end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Wenn Sie den Benutzernamen \00E4ndern, m\00FCssen Sie ein neues Kennwort angeben.')
,p_when_button_pressed=>wwv_flow_api.id(485932789329411544.4353)
,p_associated_item=>wwv_flow_api.id(485933179379411545.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1223161803819919527.4353)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>115
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_api.is_login_password_valid(',
'  p_username=>:APP_USER,',
'  p_password=>:F4350_P3_CURRENT_PASSWORD);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr(' Ung\00FCltiges aktuelles Kennwort')
,p_validation_condition=>'F4350_P3_CURRENT_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(485932789329411544.4353)
,p_associated_item=>wwv_flow_api.id(1000725807551503640.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1000725983139503641.4353)
,p_validation_name=>'Current Password Must Be Defined'
,p_validation_sequence=>125
,p_validation=>'F4350_P3_CURRENT_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Aktuelles Kennwort muss angegeben werden.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
' * require current password if new password given and either',
' * - builder requires password (e.g. APEX auth - not SSO auth)',
' * - user password has already been changed',
' */',
' ',
':F4350_P3_WEB_PASSWORD is not null',
'and (not wwv_flow_authentication_dev.is_builder_password_required (',
'             p_developer_yn => ''N'' )',
'     or :P3_FIRST_PWD_USE_OCCURRED=''Y'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(485932789329411544.4353)
,p_associated_item=>wwv_flow_api.id(1000725807551503640.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(485939464738411551.4353)
,p_validation_name=>'match password'
,p_validation_sequence=>135
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P3_WEB_PASSWORD != :F4350_P3_USER_PASSWORD then',
'  :F4350_P3_WEB_PASSWORD  := null;',
'  :F4350_P3_USER_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Kennwort zur Best\00E4tigung stimmt nicht mit dem neuen Kennwort \00FCberein.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P3_WEB_PASSWORD is not null or',
':F4350_P3_USER_PASSWORD is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(485932789329411544.4353)
,p_associated_item=>wwv_flow_api.id(485933686391411545.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(485939677017411551.4353)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>145
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username       => :F4350_P3_USER_NAME,',
'      p_password       => :F4350_P3_WEB_PASSWORD,',
'      p_old_password   => :F4350_P3_CURRENT_PASSWORD,',
'      p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_when_button_pressed=>wwv_flow_api.id(485932789329411544.4353)
,p_associated_item=>wwv_flow_api.id(485933179379411545.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'do not run for non-developers in SSO authentication mode'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(485957776630485888.4353)
,p_name=>'Cancel Dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(485932354419411539.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(485958052927485889.4353)
,p_event_id=>wwv_flow_api.id(485957776630485888.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1223302827707202942.4353)
,p_name=>'Go to Current Password'
,p_event_sequence=>80
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'self.location.hash === "#pwd"'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1223303044233202944.4353)
,p_event_id=>wwv_flow_api.id(1223302827707202942.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4350_P3_CURRENT_PASSWORD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253547838832954903.4353)
,p_event_id=>wwv_flow_api.id(1223302827707202942.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Because of the hash tag in the URL, the parent window will also scroll.',
'// Let''s put it back where it was',
'setTimeout( function(){',
'    if ( parent.window.scrollY !== 0 ) {',
'        parent.window.scrollTo( 0, 0 );',
'    }',
'}, 1 );'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(485940145256411552.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
':F4350_P3_ORG_EMAIL_ADDRESS := :F4350_P3_EMAIL_ADDRESS;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(528326649481046882.4353)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Current Image'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_fnd_user',
'   set profile_image = EMPTY_BLOB(),',
'       profile_image_name = null,',
'       profile_mimetype = null,',
'       profile_filename = null,',
'       profile_last_update = null,',
'       profile_charset = null',
' where user_id = :F4350_P3_USER_ID',
'   and security_group_id =  wwv_flow_security.g_security_group_id;',
' commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Beim Entfernen des aktuellen Profilbildes sind Probleme aufgetreten.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(534309773003323583.4353)
,p_process_when=>'F4350_P3_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Profilbild wurde erfolgreich entfernt'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(485940378778411553.4353)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit User'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p1                        varchar2(256)               := v(''F4350_P3_WEB_PASSWORD'');',
'  l_p2                        varchar2(256)               := v(''F4350_P3_USER_PASSWORD'');',
'  l_profile_image             blob default empty_blob();',
'begin',
'',
'  -- Retrieve Profile Image Content from Temporary table wwv_flow_files, used by File Browse item',
'  if :P3_PROFILE_IMAGE is not null then',
'      -- Get the uploaded file from the common wwv_flow_files table.',
'      select blob_content',
'        into l_profile_image',
'        from wwv_flow_files',
'       where name = :P3_PROFILE_IMAGE; ',
'  end if;',
'',
'  wwv_flow_fnd_user_api.edit_fnd_user (',
'      p_user_id                      => :F4350_P3_USER_ID,       ',
'      p_first_name                   => :F4350_P3_FIRST_NAME,          ',
'      p_last_name                    => :F4350_P3_LAST_NAME,',
'      p_web_password                 => l_p1,    ',
'      p_new_password                 => l_p2,                     ',
'      p_email_address                => nvl(:F4350_P3_EMAIL_ADDRESS, :F4350_P3_ORG_EMAIL_ADDRESS),',
'      p_first_password_use_occurred  => case when l_p1 is not null then ''Y'' else :P3_FIRST_PWD_USE_OCCURRED end,',
'      p_profile_image                => l_profile_image);',
'     ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Aktualisieren von Benutzer.'
,p_process_when_button_id=>wwv_flow_api.id(485932789329411544.4353)
,p_process_when=>'F4350_P3_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Benutzer "&F4350_P3_USER_NAME." aktualisiert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(487249722605107455.4353)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Email Address updated'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_product_name  varchar2(500);',
'  l_msg           varchar2(4000);',
'  l_body_html     varchar2(32767) := null;',
'begin',
'',
'  --',
'  -- Mail the change of Email address',
'  --',
'  if :F4350_P3_ORG_EMAIL_ADDRESS <> :F4350_P3_EMAIL_ADDRESS then',
'    l_msg := l_msg || wwv_flow_lang.system_message(''NEW_EMAIL_ADDRESS'') || chr(10) || :F4350_P3_EMAIL_ADDRESS || chr(10) || chr(10) || chr(10);',
'    l_msg := l_msg || wwv_flow_utilities.host_url(''SCRIPT'') || chr(10);',
'   ',
'    l_body_html := wwv_flow_mail.convert_txt_to_html (',
'                       p_txt_message       => l_msg,',
'                       p_security_group_id => :flow_security_group_id );',
'                       ',
'    l_product_name := nvl(v(''PRODUCT_NAME''),''Oracle Application Express'');',
'',
'    wwv_flow_mail.send ( ',
'        p_to        => :F4350_P3_ORG_EMAIL_ADDRESS,',
'        p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),:F4350_P3_ORG_EMAIL_ADDRESS),',
'        p_body      => l_msg,',
'        p_body_html => l_body_html,',
'        p_subj      => wwv_flow_lang.system_message(''CHANGE_PW_REQUEST'',l_product_name) );',
'        ',
'  end if;',
'',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(485932789329411544.4353)
,p_security_scheme=>'!'||wwv_flow_api.id(6738625560859071)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(485957562238481403.4353)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(485932789329411544.4353)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(528328136769125728.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set User ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- fetch id of current user',
'--',
'select user_id',
'  into :F4350_P3_USER_ID',
'  from wwv_flow_fnd_user',
' where user_name         = wwv_flow_security.g_user',
'   and security_group_id = wwv_flow_security.g_security_group_id;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(528291553770752921.4353)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch User Information DML'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER'
,p_attribute_03=>'F4350_P3_USER_ID'
,p_attribute_04=>'USER_ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    user_name         = v(''APP_USER'')',
'and security_group_id = v(''WORKSPACE_ID'')'))
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_api.create_page(
 p_id=>4.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Anmeldeversuche pro Authentifizierungsergebnis'
,p_step_title=>'Anmeldeversuche pro Authentifizierungsergebnis'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42713916288726001.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47363926027704900.4353)
,p_plug_name=>'Anmeldeversuche'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P4a */',
'  l.attempts,',
'  l.login_name,',
'  l.application,',
'  l.owner,',
'  l.authentication_method,',
'  l.access_date,',
'  l.ip_address,',
'  decode(nvl(l.authentication_result,0),',
'     0,m.AUTH_SUCCESS,',
'     1,m.AUTH_UNKNOWN_USER,',
'     2,m.AUTH_ACCOUNT_LOCKED,',
'     3,m.AUTH_ACCOUNT_EXPIRED,',
'     4,m.AUTH_PASSWORD_INCORRECT,',
'     5,m.AUTH_PASSWORD_FIRST_USE,',
'     6,m.AUTH_ATTEMPTS_EXCEEDED,',
'     7,m.AUTH_INTERNAL_ERROR,',
'     l.authentication_result) authentication_result,',
'     l.authentication_result authentication_result_code',
'from',
'(',
'select ',
'  count(*) attempts,',
'  count(distinct upper(login_name)) login_name,',
'  count(distinct application) application,',
'  count(distinct owner) owner,',
'  count (distinct authentication_method) authentication_method,',
'  count( distinct to_char(access_date,''YYYY.MM.DD'')) access_date,',
'  count( distinct ip_address) ip_address,',
'  nvl(authentication_result,0) authentication_result',
'from   wwv_flow_user_access_log_v l',
'where  security_group_id = :flow_security_group_id',
'and access_date >= sysdate - nvl(:p4_time,1)',
' and ( :P4_APPLICATION is null or application like ''%''||:P4_APPLICATION||''%'')',
'and (:P4_USER is null or lower(login_name) like ''%''||lower(:P4_USER)||''%'')',
'group by nvl(authentication_result,0)',
') l,',
'(select',
'wwv_flow_lang.system_message(''AUTH_SUCCESS'') auth_success,',
'wwv_flow_lang.system_message(''AUTH_UNKNOWN_USER'') auth_unknown_user,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_LOCKED'') auth_account_locked,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_EXPIRED'') auth_account_expired,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_INCORRECT'') auth_password_incorrect,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_FIRST_USE'') auth_password_first_use,',
'wwv_flow_lang.system_message(''AUTH_ATTEMPTS_EXCEEDED'') auth_attempts_exceeded,',
'wwv_flow_lang.system_message(''AUTH_INTERNAL_ERROR'') auth_internal_error',
'from dual) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47364014627704900.4353)
,p_name=>'Login Attempts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47364232661704916.4353)
,p_db_column_name=>'ATTEMPTS'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Versuche'
,p_column_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RIR,70:IR_AUTHENTICATION_RESULT_CODE,P70_TIME:#AUTHENTICATION_RESULT_CODE#,&P4_TIME.'
,p_column_linktext=>'#ATTEMPTS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47364309638704923.4353)
,p_db_column_name=>'LOGIN_NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Anmeldenamen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47364405831704923.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47364505224704924.4353)
,p_db_column_name=>'OWNER'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Anwendungseigent\00FCmer')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47364601629704924.4353)
,p_db_column_name=>'AUTHENTICATION_METHOD'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Authentifizierungsmethoden'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47364714754704925.4353)
,p_db_column_name=>'ACCESS_DATE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Anmeldetage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47364805925704925.4353)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'IP-Adressen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450633625112963474.4353)
,p_db_column_name=>'AUTHENTICATION_RESULT'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Authentifizierungsergebnis'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340579706612701073.4353)
,p_db_column_name=>'AUTHENTICATION_RESULT_CODE'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>unistr('Code f\00FCr Authentifizierungsergebnis')
,p_display_in_default_rpt=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42715026364726009.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(42713916288726001.4353)
,p_button_name=>'P4_GO'
,p_button_static_id=>'P4_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450597432759842665.4353)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(42713916288726001.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42717220135726012.4353)
,p_branch_action=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(42715026364726009.4353)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42717409726726015.4353)
,p_branch_action=>'70'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42715711720726010.4353)
,p_name=>'P4_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(42713916288726001.4353)
,p_prompt=>'Anwendung'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Um nach Anwendung zu filtern, geben Sie eine Anwendungs-ID ein und klicken anschlie\00DFend auf <strong>Los</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42716223347726010.4353)
,p_name=>'P4_USER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(42713916288726001.4353)
,p_prompt=>'Anmeldename'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Um nach Anmeldename zu filtern, geben Sie einen Anmeldenamen ein und klicken anschlie\00DFend auf <strong>Los</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42736507800886950.4353)
,p_name=>'P4_TIME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(42713916288726001.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_api.create_page(
 p_id=>5.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Sessionzustand l\00F6schen')
,p_step_title=>unistr('Sessionzustand l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_help_text=>'AEADM/aadm_purge_session.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41820802378409076.4353)
,p_plug_name=>'Sessionzustand'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Der Sessionzustand bietet Persistenz f\00FCr Elemente. &PRODUCT_NAME. verwendet eine zustandslose Architektur, um den Sessionzustand in der Datenbank zu speichern.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48658815589767957.4353)
,p_plug_name=>'Sessionzustand'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select count(*) c from wwv_flow_data where flow_instance = :flow_session) loop',
'sys.htp.p(''<span class="instructiontext">''||wwv_flow_lang.system_message(''F4350_SESSION_STATE'',:flow_session,c1.c) );',
'end loop;',
'sys.htp.p(wwv_flow_lang.system_message(''F4350_RESET_SESSION'') || ''</span>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48661616984968577.4353)
,p_plug_name=>'button box'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174256217975087222.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48658815589767957.4353)
,p_button_name=>'SessionDetails'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Sessionzustand anzeigen'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48658988453771579.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48658815589767957.4353)
,p_button_name=>'ResetCache'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Sessionzustand l\00F6schen')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48659251907771584.4353)
,p_branch_action=>'5'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(48658988453771579.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48659428631783734.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset-sessionstate'
,p_attribute_01=>'RESET_SESSION_STATE'
,p_process_error_message=>unistr('L\00F6schen von Sessionzustand nicht m\00F6glich.')
,p_process_when_button_id=>wwv_flow_api.id(48658988453771579.4353)
,p_process_success_message=>unistr('Sessionzustand wurde gel\00F6scht.')
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_api.create_page(
 p_id=>6.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Anmeldungszusammenfassung Entwickler'
,p_step_title=>'Anmeldungszusammenfassung Entwickler'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10264909617798279.4353)
,p_plug_name=>'Entwickleranmeldungen'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P6a */',
'      u.user_id,',
'      u.user_name,',
'      u.email_address "eMail",',
'      u.first_name,',
'      u.last_name,',
'      replace(u.default_schema,''%''||''null%'',null) default_schema,',
'u.DESCRIPTION,',
'u.LAST_AGENT,',
'u.LAST_IP,',
'u.FAILED_ACCESS_ATTEMPTS,',
'decode(nvl(d.is_admin,''N''),''Y'',',
'  m.admin,decode(nvl(d.is_developer,''N''),',
'  ''Y'',m.dev,m.end_user)) dev_type,',
'decode (nvl(d.is_developer,''N''),''Y'',last_login,null) last_login,',
'decode (nvl(d.is_developer,''N''),''Y'',',
'          nvl(builder_login_count,0),null) builder_login_count',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d,',
'    (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes,',
'            wwv_flow_lang.system_message(''PASSWORD_VALID'') password_valid,',
'            wwv_flow_lang.system_message(''PASSWORD_EXPIRED'') password_expired,',
'            wwv_flow_lang.system_message(''NO_DEVELOPER_PRIV'') no_developer_priv,',
'            wwv_flow_lang.system_message(''DEVELOPER'') dev,',
'wwv_flow_lang.system_message(''ADMINISTRATOR'') admin,',
'wwv_flow_lang.system_message(''END_USER'') end_user',
'     from dual) m',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id and',
'     d.is_developer = ''Y'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10265008216798279.4353)
,p_name=>'Developer Logins'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_base_pk1=>'USER_ID'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-view.png" class="apex-edit-view" alt="">'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265215153798286.4353)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzer-ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265331595798286.4353)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Benutzername'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265415681798287.4353)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'E-Mail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265526984798287.4353)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Vorname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265626077798287.4353)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Nachname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265728301798287.4353)
,p_db_column_name=>'DEFAULT_SCHEMA'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Standardschema'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265811005798287.4353)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10265910207798287.4353)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Letzter Agent'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10266007407798288.4353)
,p_db_column_name=>'LAST_IP'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'IP-Adresse'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10266219176798288.4353)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Nicht erfolgreiche Zugriffversuche'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10266319338798288.4353)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Entwicklertyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10270413936835709.4353)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Letzte Anmeldung'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10270524884835710.4353)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Anzahl Anmeldungen beim Builder'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450634229745974263.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10264909617798279.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_api.create_page(
 p_id=>7.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Aktive Sessions'
,p_step_title=>'Aktive Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9412131855285339.4353)
,p_plug_name=>'Aktive Sessions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sd as (',
'    select	s.ID as "ID",',
'           s.security_group_id,',
'           s.username session_owner,',
'           s.created_on,',
'           count(*) item_cache_count,',
'           count(distinct(d.flow_id)) distinct_applications,',
'           s.remote_addr ip_address,',
'           s.idle_timeout_on,',
'           s.life_timeout_on,',
'           s.session_lang,',
'           s.session_territory,',
'           s.session_time_zone,',
'           s.debug_level,',
'           s.trace_mode',
' from	 WWV_FLOW_DATA d,',
'	     WWV_FLOW_SESSIONS$ s',
' where   s.ID = d.FLOW_INSTANCE (+)',
'   and   s.security_group_id = :flow_security_group_id',
'group by s.ID,',
'         s.security_group_id,',
'         s.username,',
'         s.created_on,',
'         s.remote_addr,',
'         s.idle_timeout_on,',
'         s.life_timeout_on,',
'         s.session_lang,',
'         s.session_territory,',
'         s.session_time_zone,',
'         s.debug_level,',
'         s.trace_mode),',
'     mt as (select l.session_id, max(l.time_stamp) most_recent_view',
'        from WWV_FLOW_ACTIVITY_LOG l',
'       where l.security_group_id = :flow_security_group_id',
'       group by l.session_id)',
'select /* APEX4350P7a */ /*+ FIRST_ROWS(21) */',
'        sd.id,',
'        sd.session_owner,',
'        sd.created_on,',
'        sd.item_cache_count,',
'        sd.ip_address,',
'        mt.most_recent_view,',
'        sd.distinct_applications,',
'        sd.idle_timeout_on,',
'        sd.life_timeout_on,',
'        sd.session_lang,',
'        sd.session_territory,',
'        sd.session_time_zone,',
'        sd.debug_level,',
'        sd.trace_mode',
'  from sd, mt',
' where sd.id = mt.session_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9412205627285339.4353)
,p_name=>'Active Sessions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9412428176285340.4353)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Aktive Session'
,p_column_link=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:RP,:P19_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9412501728285340.4353)
,p_db_column_name=>'SESSION_OWNER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Benutzername'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9412608456285340.4353)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9412708051285340.4353)
,p_db_column_name=>'ITEM_CACHE_COUNT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Sessionelemente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9412818327285341.4353)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'IP-Adresse'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22432609427809248.4353)
,p_db_column_name=>'MOST_RECENT_VIEW'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Letzte Ansicht'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22435506226827241.4353)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Eindeutige Anwendungen'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265416632100318130.4353)
,p_db_column_name=>'IDLE_TIMEOUT_ON'
,p_display_order=>17
,p_column_identifier=>'H'
,p_column_label=>unistr('Inaktivit\00E4tstimeout')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265416784868318131.4353)
,p_db_column_name=>'LIFE_TIMEOUT_ON'
,p_display_order=>27
,p_column_identifier=>'I'
,p_column_label=>unistr('Aktivit\00E4tstimeout')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265416893890318132.4353)
,p_db_column_name=>'SESSION_LANG'
,p_display_order=>37
,p_column_identifier=>'J'
,p_column_label=>'Sprache'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265416996345318133.4353)
,p_db_column_name=>'SESSION_TERRITORY'
,p_display_order=>47
,p_column_identifier=>'K'
,p_column_label=>'Gebiet'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265417082583318134.4353)
,p_db_column_name=>'SESSION_TIME_ZONE'
,p_display_order=>57
,p_column_identifier=>'L'
,p_column_label=>'Zeitzone'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265417123142318135.4353)
,p_db_column_name=>'DEBUG_LEVEL'
,p_display_order=>67
,p_column_identifier=>'M'
,p_column_label=>'Debugging-Ebene'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265417254052318136.4353)
,p_db_column_name=>'TRACE_MODE'
,p_display_order=>77
,p_column_identifier=>'N'
,p_column_label=>'Tracemodus'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(370223717115128950)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200809731468694255.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(9412131855285339.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(167564317393131991.4353)
,p_branch_action=>'f?p=&FLOW_ID.:7:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_api.create_page(
 p_id=>8.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen pro Entwickler')
,p_step_title=>unistr('Anwendungs\00E4nderungen pro Entwickler')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6115202769688783.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9830103673330851.4353)
,p_plug_name=>unistr('Anwendungs\00E4nderungen pro Entwickler')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(',
'select /* APEX4350P8a */ count(*) tpv',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p8_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P8_APPLICATION = 0 or flow_id = :P8_APPLICATION)',
')',
'select the_link, developer, page_views, 100*page_views/tpv pct, round(100*page_views/tpv) graph,',
'pages_visited,',
'distinct_applications,',
'''<div class="hour-graph">''||',
'''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-value"'
||'>''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-value"'
||'>''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-value"'
||'>''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-value"'
||'>''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-value"'
||'>''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-value"'
||'>''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-value"'
||'>''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-value"'
||'>''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-value"'
||'>''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-value"'
||'>''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-value"'
||'>''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-value"'
||'>''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-value"'
||'>''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-value"'
||'>''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-value"'
||'>''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-value"'
||'>''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-value"'
||'>''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-value"'
||'>''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-value"'
||'>''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-value"'
||'>''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-value"'
||'>''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-value"'
||'>''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-value"'
||'>''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-value"'
||'>''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'''</div>'' hours',
'from',
'(',
'select ',
'''f?p=4350:42:''||:app_session||'':::RP:P42_USER,P42_TIME:''||flow_user||'',''||:p8_time the_link,',
'  flow_user developer,',
'  count(*) page_views,',
'  count(distinct(page_id)) pages_visited,',
'  count(distinct(flow_id)) distinct_applications,',
'  sum(decode(to_char(audit_date,''HH24''),0,1,0)) h00,',
'  sum(decode(to_char(audit_date,''HH24''),1,1,0)) h01,',
'  sum(decode(to_char(audit_date,''HH24''),2,1,0)) h02,',
'  sum(decode(to_char(audit_date,''HH24''),3,1,0)) h03,',
'  sum(decode(to_char(audit_date,''HH24''),4,1,0)) h04,',
'  sum(decode(to_char(audit_date,''HH24''),5,1,0)) h05,',
'  sum(decode(to_char(audit_date,''HH24''),6,1,0)) h06,',
'  sum(decode(to_char(audit_date,''HH24''),7,1,0)) h07,',
'  sum(decode(to_char(audit_date,''HH24''),8,1,0)) h08,',
'  sum(decode(to_char(audit_date,''HH24''),9,1,0)) h09,',
'  sum(decode(to_char(audit_date,''HH24''),10,1,0)) h10,',
'  sum(decode(to_char(audit_date,''HH24''),11,1,0)) h11,',
'  sum(decode(to_char(audit_date,''HH24''),12,1,0)) h12,',
'  sum(decode(to_char(audit_date,''HH24''),13,1,0)) h13,',
'  sum(decode(to_char(audit_date,''HH24''),14,1,0)) h14,',
'  sum(decode(to_char(audit_date,''HH24''),15,1,0)) h15,',
'  sum(decode(to_char(audit_date,''HH24''),16,1,0)) h16,',
'  sum(decode(to_char(audit_date,''HH24''),17,1,0)) h17,',
'  sum(decode(to_char(audit_date,''HH24''),18,1,0)) h18,',
'  sum(decode(to_char(audit_date,''HH24''),19,1,0)) h19,',
'  sum(decode(to_char(audit_date,''HH24''),20,1,0)) h20,',
'  sum(decode(to_char(audit_date,''HH24''),21,1,0)) h21,',
'  sum(decode(to_char(audit_date,''HH24''),22,1,0)) h22,',
'  sum(decode(to_char(audit_date,''HH24''),23,1,0)) h23',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p8_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P8_APPLICATION = 0 or flow_id = :P8_APPLICATION)',
'group by ',
'  flow_user) d, total_page_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.APPCHANGES'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9830202023330851.4353)
,p_name=>'Application Changes by Developer'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9830429030330852.4353)
,p_db_column_name=>'THE_LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9830502357330852.4353)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Entwickler'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9830612188330852.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Komponenten\00E4nderungen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9830716530330853.4353)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Prozentsatz'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9830808496330853.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9830926209330853.4353)
,p_db_column_name=>'PAGES_VISITED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Eindeutige Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9932001315661346.4353)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Eindeutige Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760555872015323225.4353)
,p_db_column_name=>'HOURS'
,p_display_order=>17
,p_column_identifier=>'H'
,p_column_label=>unistr('Aktivit\00E4t pro Stunde')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200631711636281729.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(6115202769688783.4353)
,p_button_name=>'P8_SET'
,p_button_static_id=>'P8_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200631503324279375.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(6115202769688783.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:8,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20242415263688933.4353)
,p_branch_action=>'f?p=&FLOW_ID.:8:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20239730370683894.4353)
,p_name=>'P8_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6115202769688783.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47682732034325129.4353)
,p_name=>'P8_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6115202769688783.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cHeight=>1
,p_tag_attributes=>'style="max-width:200px"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_api.create_page(
 p_id=>9.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Info &PRODUCT_NAME.'
,p_page_mode=>'MODAL'
,p_step_title=>'Info &PRODUCT_NAME.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215451130329541858)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div.subRegion h2 {',
'	font: bold 13px/20px Arial, sans-serif;',
'	color: #333;',
'}',
'table.aboutReportTop {',
'	padding: 0 0 10px 0;',
'}',
'table.aboutReportTop tr:first-child th,',
'table.aboutReportTop tr:first-child td {',
'border-top: none;',
'}',
'table.aboutReportTop td {',
'padding: 5px;',
'text-align: left;',
'font: normal 12px/16px Arial, sans-serif;',
'color: #333;',
'border-top: 1px solid #DDD;',
'}',
'table.aboutReportTop td.textHere {',
'font-weight: bold;',
'}',
'',
'#memorial { padding: 24px; color: #FFF; background-color: #000; line-height: 1.5; text-align: center; display: flex; flex-direction: column; align-items: center; min-height: 100vh; justify-content: center;}',
'#memorial b { display: block; margin-top: 12px; font-size: 18px; }',
'#memorial p span { opacity: 0.65; display: block; }',
'#memorial .heart { background-image: url(''data:image/svg+xml;base64,PHN2ZyB2ZXJzaW9uPSIxLjEiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgd2lkdGg9IjE2IiBoZWlnaHQ9IjE2IiB2aWV3Qm94PSIwIDAgMTYgMTYiIGZpbGw9InJnYigyMDIsIDc3LCA2MCkiPgo8dGl0bGU+aGVhcnQ8L3'
||'RpdGxlPgo8cGF0aCBkPSJNMTQuODI0IDMuMTc2Yy0xLjU2NC0xLjU2NC00LjExMy0xLjU2NC01LjY3OCAwbC0xLjE0NiAxLjE0Ni0xLjE0Ni0xLjE0NmMtMS41NjQtMS41NjQtNC4xMTMtMS41NjQtNS42NzggMHMtMS41NjQgNC4xMTIgMCA1LjY3OGw2LjQ3MSA2LjQ3MWMwLjA5MyAwLjA5MyAwLjIyIDAuMTQ2IDAuMzUzIDAuMTQ2'
||'czAuMjYtMC4wNTMgMC4zNTQtMC4xNDZsNi40NzEtNi40NzFjMS41NjQtMS41NjYgMS41NjQtNC4xMTMtMC4wMDEtNS42Nzh6Ij48L3BhdGg+Cjwvc3ZnPg==''); background-repeat: no-repeat; background-size: 100%; background-position: center; display: inline-block; width: 24px; height: '
||'24px; margin-bottom: 8px; }',
'#memorial .heart:hover {animation: apexheartpulse 2s infinite ease;}'))
,p_step_template=>wwv_flow_api.id(485889499804058937.4353)
,p_page_css_classes=>'about-page'
,p_dialog_height=>'500'
,p_dialog_width=>'490'
,p_dialog_attributes=>'scroll:''auto'''
,p_help_text=>'AEADM/aadm_htmldb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(77811317279722052.4353)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-Dialog-about">',
'              <span class="a-Dialog-icon gi-icon-apex-logo-icon"></span>',
'              <span class="a-Dialog-aboutTitle">''||:PRODUCT_NAME||''</span>',
'          </div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20123129051163000.4353)
,p_name=>'Datenbankversion'
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if sys.dbms_db_version.version >= 18 then',
'    return q''~',
'           select banner_full as banner',
'             from sys.v_$version',
'            order by case when banner like ''Oracle%'' then 1 else 2 end, upper(banner)',
'           ~'';',
'else',
'    return q''~',
'           select banner',
'             from sys.v_$version',
'            order by case when banner like ''Oracle%'' then 1 else 2 end, upper(banner)',
'           ~'';',
'end if;'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Es wurden keine Informationen zur Datenbankversion gefunden.'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(20123710246163013.4353)
,p_query_column_id=>1
,p_column_alias=>'BANNER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space: pre-line'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186769128691535740.4353)
,p_plug_name=>'CGI-Umgebung'
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.print_cgi_env',
' (p_html_table_attr=>''class="u-Report u-Report--stretch u-Report--staticBG u-Report--inline u-Report--firstColLabel" role="presentation" cellpadding="0" cellspacing="0" border="0"'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(198701826510091307.4353)
,p_plug_name=>'Zeichensatz'
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table role="presentation" class="u-Report u-Report--staticBG u-Report--stretch u-Report--inline  u-Report--firstColLabel">'');',
'for c1 in (',
'select ''NLS_CHARACTERSET'' n, value v ',
'from sys.nls_database_parameters ',
'where upper(parameter)= ''NLS_CHARACTERSET'') loop',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(c1.n);',
'sys.htp.prn(''<td class="textHere">''||wwv_flow_escape.html(c1.v)||''</td>'');',
'sys.htp.p(''</tr>'');',
'end loop;',
'',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(''DAD CHARACTERSET'');',
'sys.htp.prn(''<td class="textHere">''||',
'   wwv_flow_escape.html(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''</table>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(842425152910300825.4353)
,p_plug_name=>'Parameter zur Datenbankinitialisierung'
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table role="presentation" class="u-Report u-Report--staticBG u-Report--stretch u-Report--inline  u-Report--firstColLabel">'');',
'',
'for c1 in (',
'select ''JOB_QUEUE_PROCESSES'' n, value v',
'from sys.v_$parameter where lower(name) = ''job_queue_processes'') loop',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(c1.n);',
'sys.htp.prn(''<td class="textHere">''||',
'   wwv_flow_escape.html(c1.v)||''</td>'');',
'sys.htp.p(''</tr>'');',
'end loop;',
'',
'sys.htp.p(''</table>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(878525955445395737.4353)
,p_plug_name=>'Memorial'
,p_region_name=>'memorial'
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="heart" aria-hidden="true"></span>',
'<p>In liebevoller Erinnerung an <b>Joel R. Kallman</b> <span>1966-2021</span></p>',
unistr('<p>Du wirst f\00FCr immer in unserem Herzen bleiben.</p>'),
'<!-- Share your memories on apex.oracle.com/joel -->'))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1093539312009113721.4353)
,p_plug_name=>'Details'
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table class="u-Report u-Report--stretch u-Report--staticBG u-Report--inline u-Report--firstColLabel" role="presentation">'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.PRODUCT_BUILD''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(wwv_flows_release)||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.SCHEMA_COMPATIBILITY''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(wwv_flows_version)||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'for c1 in (select patch_version, to_char(installed_on,''&DATE_TIME_FORMAT.'') lddt',
'             from wwv_flow_pses',
'            where installed_on = (select max(installed_on) from wwv_flow_pses) ) loop',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.PATCH_VERSION''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.patch_version)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.LAST_PATCH_TIME''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.lddt)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'for c1 in (select to_char(last_ddl_time,''&DATE_TIME_FORMAT.'') as lddt',
'             from sys.dba_objects',
'            where owner = wwv_flow.g_flow_schema_owner',
'              and object_name = ''WWV_FLOW''',
'              and object_type = ''PACKAGE BODY'' ) loop',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.LAST_DDL_TIME''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.lddt)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'for c1 in (select user as u from sys.dual) loop',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.HOST_SCHEMA''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.u)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'sys.htp.tableRowOpen;',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.APPLICATION_OWNER''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(''#FLOW_OWNER#'')||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.WORKSPACE_ID''));',
'sys.htp.prn(''<td>''||wwv_flow_security.g_security_group_id||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'-- wwv_flow.get_company_name returns already escaped output',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.WORKSPACE_NAME''));',
'sys.htp.prn(''<td>''||wwv_flow.get_company_name||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.CURRENT_USER''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(v(''USER''))||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.LANGUAGE_PREFERENCE''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(wwv_flow.g_browser_language)||''</td>'');',
'wwv_htp.tableRowClose;',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.CURRENT_TIME_ON_SERVER''));',
'sys.htp.prn(''<td>''||to_char(systimestamp,''&DATE_TIME_FORMAT. TZH:TZM'')||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'wwv_htp.tableClose;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267106411492305004.4353)
,p_plug_name=>'Copyright-Hinweis '
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>&MSG_COPYRIGHT.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267106527297305005.4353)
,p_plug_name=>unistr('Lizenzeinschr\00E4nkungen/Haftungsausschluss bei Folgesch\00E4den ')
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('<p>Diese Software und zugeh\00F6rige Dokumentation werden unter einem Lizenzvertrag zur Verf\00FCgung gestellt, der Einschr\00E4nkungen hinsichtlich Nutzung und Offenlegung enth\00E4lt, und sind durch Gesetze zum Schutz geistigen Eigentums gesch\00FCtzt. Sofern nicht au')
||unistr('sdr\00FCcklich in Ihrem Lizenzvertrag vereinbart oder gesetzlich gestattet, darf diese Software weder ganz noch teilweise in irgendeiner Form oder durch irgendein Mittel zu irgendeinem Zweck genutzt, kopiert, reproduziert, \00FCbersetzt, gesendet, ver\00E4ndert,')
||unistr(' lizenziert, \00FCbertragen, verteilt, ausgestellt, vorgef\00FChrt, ver\00F6ffentlicht oder angezeigt werden. Reverse Engineering, Disassemblierung oder Dekompilierung der Software ist untersagt, es sei denn, dies ist gesetzlich vorausgesetzt aus Gr\00FCnden der Int')
||unistr('eroperabilit\00E4t.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267106619336305006.4353)
,p_plug_name=>unistr('Gew\00E4hrleistungsausschluss ')
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('<p>Die hier enthaltenen Informationen k\00F6nnen jederzeit und ohne vorherige Ank\00FCndigung ge\00E4ndert werden. Wir \00FCbernehmen keine Gew\00E4hr f\00FCr deren Richtigkeit. Sollten Sie Fehler oder Unstimmigkeiten finden, bitten wir Sie, uns diese schriftlich mitzuteile')
||'n.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267106773028305007.4353)
,p_plug_name=>unistr('Hinweis zu eingeschr\00E4nkten Rechten')
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('<p>Handelt es sich hier um Software oder zugeh\00F6rige Dokumentation, die an die Regierung der Vereinigten Staaten von Amerika oder an einen in ihrem Auftrag handelnden Lizenznehmer geliefert wird, dann gilt der folgende Hinweis:</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267106847747305008.4353)
,p_plug_name=>unistr('Hinweis f\00FCr gef\00E4hrliche Anwendungen ')
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('<p>Diese Software oder Hardware ist f\00FCr die allgemeine Nutzung in diversen Informationsmanagementanwendungen entwickelt worden. Sie ist nicht f\00FCr den Einsatz in schon an sich gef\00E4hrlichen Anwendungen entwickelt oder intendiert, einschlie\00DFlich von Anw')
||unistr('endungen, die m\00F6glicherweise ein Risiko von Personensch\00E4den mit sich bringen. Falls Sie die Software oder Hardware f\00FCr gef\00E4hrliche Anwendungen nutzen, sind Sie daf\00FCr verantwortlich, s\00E4mtliche angemessenen Ma\00DFnahmen wie Fail-Safe, Backups und Redundan')
||unistr('cy zu ergreifen, um den sicheren Einsatz zu gew\00E4hrleisten. Die Oracle Corporation und ihre verbundenen Unternehmen schlie\00DFen jegliche Haftung f\00FCr Sch\00E4den aus, die durch den Einsatz dieser Software oder Hardware in gef\00E4hrlichen Anwendungen verursacht ')
||'werden.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267106921786305009.4353)
,p_plug_name=>'Markenhinweis '
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle und Java sind eingetragene Marken der Oracle Corporation und/oder ihrer verbundenen Unternehmen. Andere Namen und Bezeichnungen k\00F6nnen Marken ihrer jeweiligen Inhaber sein.'),
'',
'Intel und Intel Inside sind Marken oder eingetragene Marken der Intel Corporation. Alle SPARC-Marken werden in Lizenz verwendet und sind Marken oder eingetragene Marken der SPARC International, Inc. AMD, Epyc und das AMD-Logo sind Marken oder eingetr'
||'agene Marken von Advanced Micro Devices. UNIX ist eine eingetragene Marke von The Open Group.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267107051355305010.4353)
,p_plug_name=>'Haftungsausschluss bei Inhalten, Produkten und Serviceleistungen Dritter '
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('<p>Diese Software oder Hardware und die Dokumentation k\00F6nnen Zugriffsm\00F6glichkeiten auf oder Informationen \00FCber Inhalte, Produkte und Serviceleistungen von Dritten enthalten. Sofern nicht ausdr\00FCcklich in einem Vertrag mit Oracle vereinbart, \00FCbernehmen')
||unistr(' die Oracle Corporation und ihre verbundenen Unternehmen keine Verantwortung f\00FCr Inhalte, Produkte und Serviceleistungen von Dritten und lehnen ausdr\00FCcklich jegliche Art von Gew\00E4hrleistung diesbez\00FCglich ab. Sofern nicht ausdr\00FCcklich in einem Vertrag ')
||unistr('mit Oracle vereinbart, \00FCbernehmen die Oracle Corporation und ihre verbundenen Unternehmen keine Verantwortung f\00FCr Verluste, Kosten oder Sch\00E4den, die aufgrund des Zugriffs oder der Verwendung von Inhalten, Produkten und Serviceleistungen von Dritten e')
||'ntstehen.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267107170924305011.4353)
,p_plug_name=>'Hinweise zu Drittanbietern '
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Die Dokumentation mit Hinweisen zu Drittanbietern finden Sie unter:<br /> ',
'<a rel="noreferrer" href="https://apex.oracle.com/thirdparty" target="_blank">https://apex.oracle.com/thirdparty</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267107200044305012.4353)
,p_plug_name=>unistr('Hinweis zu eingeschr\00E4nkten Rechten')
,p_parent_plug_id=>wwv_flow_api.id(77811317279722052.4353)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717841909277073684.4353)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Implemented as PL/SQL region to exclude the following text from translations per Legal (see bug 28606120)',
'htp.p(''<p>U.S. GOVERNMENT END USERS: Oracle programs (including any operating system, integrated software, any programs embedded, installed or activated on delivered hardware, and modifications of such programs) and Oracle computer documentation or o'
||unistr('ther Oracle data delivered to or accessed by U.S. Government end users are "commercial computer software" or \201Ccommercial computer software documentation\201D pursuant to the applicable Federal Acquisition Regulation and agency-specific supplemental regul')
||'ations. As such, the use, reproduction, duplication, release, display, disclosure, modification, preparation of derivative works, and/or adaptation of i) Oracle programs (including any operating system, integrated software, any programs embedded, ins'
||'talled or activated on delivered hardware, and modifications of such programs), ii) Oracle computer documentation and/or iii) other Oracle data, is subject to the rights and limitations specified in the license contained in the applicable contract. T'
||unistr('he terms governing the U.S. Government\2019s use of Oracle cloud services are defined by the applicable contract for such services. No other rights are granted to the U.S. Government.</p>'');')))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_api.create_page(
 p_id=>10.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen pro Entwickler')
,p_step_title=>unistr('Anwendungs\00E4nderungen pro Entwickler')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(131241908734176090.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1591303603291709019.4353)
,p_plug_name=>unistr('Entwickleraktivit\00E4t pro Entwickler')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P10a */',
'  null l,',
'  flow_user,',
'  count(*) c',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p10_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (nvl(:p10_application,0) = 0 or flow_id = :p10_application)',
'group by ',
'  flow_user',
'order by 3 desc'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_plug_query_num_rows=>15
,p_attribute_01=>'INITIALS'
,p_attribute_02=>'FLOW_USER'
,p_attribute_04=>'C'
,p_attribute_11=>'VALUE'
,p_attribute_14=>'500'
,p_attribute_15=>'TEXT'
,p_attribute_16=>'ABSOLUTE'
,p_attribute_17=>'MODERN'
,p_attribute_18=>'AROUND'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450735531935533076.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(131241908734176090.4353)
,p_button_name=>'P10_SET'
,p_button_static_id=>'P10_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20263732195741193.4353)
,p_branch_action=>'f?p=&FLOW_ID.:10:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20260920074737670.4353)
,p_name=>'P10_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(131241908734176090.4353)
,p_item_default=>'.25'
,p_prompt=>'Seit'
,p_source=>'.25'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, '),
unistr('die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47683931950344036.4353)
,p_name=>'P10_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(131241908734176090.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_api.create_page(
 p_id=>11.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Aktuelle Benutzervoreinstellungen'
,p_alias=>'PREF'
,p_step_title=>'Aktuelle Benutzervoreinstellungen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_user_pref.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46076724243052275.4353)
,p_plug_name=>'Voreinstellungen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    user_id,',
'    preference_name,',
'    attribute_value',
'from WWV_FLOW_PREFERENCES$',
'where user_id = :flow_user',
'and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(46076811301052275.4353)
,p_name=>'Preferences'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46077020433052289.4353)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46077103585052295.4353)
,p_db_column_name=>'PREFERENCE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Voreinstellung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46077204057052295.4353)
,p_db_column_name=>'ATTRIBUTE_VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Wert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174210501299954701.4353)
,p_plug_name=>'Benutzervoreinstellungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('In diesem Bericht werden die Voreinstellungen angezeigt, die f\00FCr den aktuellen Benutzer festgelegt wurden. Diese Sessionzustandswerte werden zwischen den Anmeldungen beibehalten.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452413709019800121.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46076724243052275.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(122221606249170943.4353)
,p_branch_action=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_api.create_page(
 p_id=>12.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Tag'
,p_step_title=>'Seitenansichten pro Tag'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46757621766940957.4353)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692991422006464140.4353)
,p_plug_name=>'Seitenereignisse pro Tag'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(692991541290464141.4353)
,p_region_id=>wwv_flow_api.id(692991422006464140.4353)
,p_chart_type=>'line'
,p_height=>'450'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(692991695243464142.4353)
,p_chart_id=>wwv_flow_api.id(692991541290464141.4353)
,p_seq=>10
,p_name=>'Anzeigen'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(TIME_STAMP) day, to_char(TIME_STAMP,''mm/dd/yyyy'') day_format,',
'       count(*) views',
'from   WWV_FLOW_ACTIVITY_LOG',
'where  security_group_id = :flow_security_group_id and page_mode != ''A''',
'group by trunc(time_stamp),to_char(TIME_STAMP,''mm/dd/yyyy'')',
'order by trunc(time_stamp) desc'))
,p_items_value_column_name=>'VIEWS'
,p_items_label_column_name=>'DAY_FORMAT'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'afterMarker'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(692991991244464145.4353)
,p_chart_id=>wwv_flow_api.id(692991541290464141.4353)
,p_seq=>20
,p_name=>'Akzeptieren'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(TIME_STAMP) day, to_char(TIME_STAMP,''dd/mm/yyyy'') day_format,',
'       count(*) views',
'from   WWV_FLOW_ACTIVITY_LOG',
'where  security_group_id = :flow_security_group_id and page_mode = ''A''',
'group by trunc(time_stamp),to_char(TIME_STAMP,''dd/mm/yyyy'')',
'order by trunc(time_stamp) desc'))
,p_items_value_column_name=>'VIEWS'
,p_items_label_column_name=>'DAY_FORMAT'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'aboveMarker'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692991712252464143.4353)
,p_chart_id=>wwv_flow_api.id(692991541290464141.4353)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692991826812464144.4353)
,p_chart_id=>wwv_flow_api.id(692991541290464141.4353)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(46757903889945188.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46757621766940957.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(46972209650230505.4353)
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P12_VIEW'
,p_branch_condition_text=>'DAY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(46972816707241959.4353)
,p_branch_action=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P12_VIEW'
,p_branch_condition_text=>'HOUR'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46971321293224408.4353)
,p_name=>'P12_VIEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(46757621766940957.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'DAY'
,p_prompt=>'Anzeigen'
,p_source=>'DAY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SELECTOR'
,p_lov=>'.'||wwv_flow_api.id(46971429951226857.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_api.create_page(
 p_id=>13.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Dashboard f\00FCr Workspace-Aktivit\00E4t')
,p_step_title=>unistr('Dashboard f\00FCr Workspace-Aktivit\00E4t')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46992417268582735.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46994113983619638.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46994605803626706.4353)
,p_name=>'Topanwendungen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13b */ substr(',
'       (select name from wwv_flows where id = application),1,25) application_name,',
'       page_events,',
'       application',
'from (',
'select ',
'    flow_id application,',
'    count(*) page_events',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'(flow_id not between 4000 and 4999 or :flow_security_group_id = 10) and',
'time_stamp > sysdate - :P13_TIME',
'group by flow_id',
'order by 2 desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(46994605803626706.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47022315799968072.4353)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46998018981781834.4353)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46996430446737873.4353)
,p_query_column_id=>3
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46996702442758171.4353)
,p_name=>'Topbenutzer'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P13a */ lower(substr(top_user,1,50)) top_user,',
'        event_count,',
'        top_user full_username',
'from (',
'select ',
'    userid top_user,',
'    count(*) event_count',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'       time_stamp > sysdate - :P13_TIME and',
'(flow_id not between 4000 and 4999 or :flow_security_group_id = 10) and',
'     userid is not null',
'group by userid',
') order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46997232225766749.4353)
,p_query_column_id=>1
,p_column_alias=>'TOP_USER'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46997301255766749.4353)
,p_query_column_id=>2
,p_column_alias=>'EVENT_COUNT'
,p_column_display_sequence=>2
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46997430501766749.4353)
,p_query_column_id=>3
,p_column_alias=>'FULL_USERNAME'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46998326861803030.4353)
,p_name=>'Letzte Anmeldungen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13d */ ',
'  lower(login_name)||'' ''||application login_attempt,',
'  access_date',
'from   wwv_flow_user_access_log_v l',
'where  security_group_id = :flow_security_group_id',
'and access_date >= sysdate - nvl(:P13_TIME,1)',
'order by access_date desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(46998326861803030.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46998916257809499.4353)
,p_query_column_id=>1
,p_column_alias=>'LOGIN_ATTEMPT'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46999007472809499.4353)
,p_query_column_id=>2
,p_column_alias=>'ACCESS_DATE'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46999814572837357.4353)
,p_name=>'Letzte Fehler'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>70
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13e */ ',
'   substr(	',
'   flow_id||'':''||step_id||'' - ''||',
'     substr((substr(sys.utl_i18n.unescape_reference(SQLERRM),1,30)||'' ''||',
'     substr(sys.utl_i18n.unescape_reference(USERID),1,20)),1,35),',
'     1,35) error_and_user,',
'   TIME_STAMP',
'from WWV_FLOW_ACTIVITY_LOG',
'where   security_group_id = :flow_security_group_id and',
'  sqlerrm is not null and',
'  TIME_STAMP >= sysdate - nvl(:P13_TIME,1)',
'order by TIME_STAMP desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(46999814572837357.4353)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47000330633851422.4353)
,p_query_column_id=>1
,p_column_alias=>'ERROR_AND_USER'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47000415198851422.4353)
,p_query_column_id=>2
,p_column_alias=>'TIME_STAMP'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47007806364967405.4353)
,p_name=>'Topseiten'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13c */ substr(',
'        application_id||'':''||page_id ||'' ''||',
'        substr((select name ',
'        from wwv_flow_steps ',
'        where id=page_id and flow_id=application_id),1,20),',
'        1,25)',
'       application_page,',
'       page_events',
'from',
'(',
'select ',
'    flow_id application_id,',
'    step_id page_id,',
'    count(*) page_events',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'(flow_id not between 4000 and 4999 or :flow_security_group_id = 10) and',
'time_stamp > sysdate - :P13_TIME',
'group by flow_id, step_id',
'order by 3 desc',
')',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47522024859162462.4353)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_PAGE'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47008119491967405.4353)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47029628200141872.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(166211911060758908.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47344306471037176.4353)
,p_plug_name=>unistr('Benutzeraktivit\00E4t')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Zeigen Sie eine Zusammenfassung der Workspace-Benutzeraktivit\00E4t f\00FCr den ausgew\00E4hlten Zeitrahmen an.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955889255851997303.4353)
,p_plug_name=>'Platzhalter'
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder '
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168425924484598602.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46992417268582735.4353)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Aktivit\00E4t \00FCberwachen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(258482011097943097.4353)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(46998326861803030.4353)
,p_button_name=>'MONITOR_LOGINS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Anmeldungen \00FCberwachen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'gotoIcon'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(46992700430587274.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46992417268582735.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(258480610204905780.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46999814572837357.4353)
,p_button_name=>'VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>'Anzeigen'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'gotoIcon'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(258481411636934581.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(46994605803626706.4353)
,p_button_name=>'VIEW_APPLICATIONS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>'Anwendungen anzeigen'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'gotoIcon'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(46993519262602210.4353)
,p_branch_action=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46993309565599388.4353)
,p_name=>'P13_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(46992417268582735.4353)
,p_prompt=>'Anzeigen'
,p_source=>'select  3/24  from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Zeitrahmen f\00FCr die Berichtserstellung an. Das Anzeigen gr\00F6\00DFerer Zeitrahmen kann mehr Zeit beanspruchen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_api.create_page(
 p_id=>14.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Stunde'
,p_step_title=>'Seitenansichten pro Stunde'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46754721279855631.4353)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692992000648464146.4353)
,p_plug_name=>'Seitenereignisse pro Stunde'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(692992186674464147.4353)
,p_region_id=>wwv_flow_api.id(692992000648464146.4353)
,p_chart_type=>'line'
,p_height=>'450'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(692992209787464148.4353)
,p_chart_id=>wwv_flow_api.id(692992186674464147.4353)
,p_seq=>10
,p_name=>'Anzeigen'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_date||'' - ''||substr(long_date,9)||'':00'' date_tooltip, short_date||'' ''||substr(long_date,9)||'':00'' short_date_format, nvl(events,0) events from (',
'     select ',
'       count(*) events,',
'       to_char(time_stamp,''YYYYMMDDHH24'') long_date,',
'       to_char(time_stamp,''mm/dd/yyyy'') short_date',
'     from   ',
'       WWV_FLOW_ACTIVITY_LOG l',
'     where',
'       security_group_id = :flow_security_group_id and',
'       page_mode != ''A'' and',
'       time_stamp >= sysdate - 2',
'     group by to_char(time_stamp,''YYYYMMDDHH24''),to_char(time_stamp,''mm/dd/yyyy'')',
'     order by 2 desc)'))
,p_items_value_column_name=>'EVENTS'
,p_items_label_column_name=>'SHORT_DATE_FORMAT'
,p_items_short_desc_column_name=>'DATE_TOOLTIP'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(713094373045315401.4353)
,p_chart_id=>wwv_flow_api.id(692992186674464147.4353)
,p_seq=>20
,p_name=>'Akzeptieren'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_date||'' - ''||substr(long_date,9)||'':00'' date_tooltip, short_date||'' ''||substr(long_date,9)||'':00'' short_date_format, nvl(events,0) events from (',
'     select ',
'       count(*) events,',
'       to_char(time_stamp,''YYYYMMDDHH24'') long_date,',
'       to_char(time_stamp,''mm/dd/yyyy'') short_date',
'     from   ',
'       WWV_FLOW_ACTIVITY_LOG l',
'     where',
'       security_group_id = :flow_security_group_id and',
'       page_mode = ''A'' and',
'       time_stamp >= sysdate - 2',
'     group by to_char(time_stamp,''YYYYMMDDHH24''),to_char(time_stamp,''mm/dd/yyyy'')',
'     order by 2 desc)'))
,p_items_value_column_name=>'EVENTS'
,p_items_label_column_name=>'SHORT_DATE_FORMAT'
,p_items_short_desc_column_name=>'DATE_TOOLTIP'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692992358838464149.4353)
,p_chart_id=>wwv_flow_api.id(692992186674464147.4353)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'time-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692992481730464150.4353)
,p_chart_id=>wwv_flow_api.id(692992186674464147.4353)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>100
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'on'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(46754900978859248.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46754721279855631.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(297663202145957383.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(46973210258249523.4353)
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P14_VIEW'
,p_branch_condition_text=>'DAY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21106400138500046.4353)
,p_branch_action=>'f?p=&FLOW_ID.:14:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46754325341800080.4353)
,p_name=>'P14_CURRENT_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(46754721279855631.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Aktuelle Zeit:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(sysdate,''DL FMTS'') d',
'from dual'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46972609781239990.4353)
,p_name=>'P14_VIEW'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(46754721279855631.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HOUR'
,p_prompt=>'Anzeigen'
,p_source=>'HOUR'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SELECTOR'
,p_lov=>'.'||wwv_flow_api.id(46971429951226857.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_api.create_page(
 p_id=>15.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Sessionaktivit\00E4t pro Stunde')
,p_step_title=>unistr('Sessionaktivit\00E4t pro Stunde')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692990466454464130.4353)
,p_plug_name=>unistr('Seitenansichten pro Stunde \00FCber die letzten 48 Stunden')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_column=>1
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>unistr('<p>Anzahl der einzelnen Sessions mit Seitenansichten der letzten 48 Stunden. Die Stunden werden entsprechend der Uhrzeit f\00FCr den Server angezeigt.</p>')
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(692990595257464131.4353)
,p_region_id=>wwv_flow_api.id(692990466454464130.4353)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(692990638467464132.4353)
,p_chart_id=>wwv_flow_api.id(692990595257464131.4353)
,p_seq=>10
,p_name=>'Seitenansichten'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_timestamp(r.long_date||'':00'',''YYYYMMDDHH24:MI'') long_date,',
'       r.short_date short_date,',
'       nvl(l.views,0) views',
'from   ',
'    (',
'    select ',
'       count(distinct session_id) views,',
'       to_char(time_stamp,''YYYYMMDDHH24'') long_date',
'     from   ',
'       WWV_FLOW_ACTIVITY_LOG l',
'     where',
'       security_group_id = :flow_security_group_id and',
'       page_mode != ''A'' and',
'       time_stamp >= sysdate - 2',
'     group by to_char(time_stamp,''YYYYMMDDHH24'')) l,',
'     (select to_char((select (sysdate-1)+((rnum)/24) from dual),''HH24'') hr,',
'     				 to_char((select (sysdate-2)+((rnum)/24) from dual),''YYYYMMDDHH24'') long_date,',
'                     to_char((select (sysdate-2)+((rnum)/24) from dual),''mm/dd/yyyy'') short_date,',
'     				 rnum',
'				from',
'				(select rownum rnum ',
'				   from sys.dba_objects ',
'				  where rownum < 49)) r',
' where l.long_date(+) = r.long_date',
' order by r.rnum'))
,p_max_row_count=>250
,p_items_value_column_name=>'VIEWS'
,p_items_label_column_name=>'LONG_DATE'
,p_items_short_desc_column_name=>'SHORT_DATE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692990756467464133.4353)
,p_chart_id=>wwv_flow_api.id(692990595257464131.4353)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'time-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'on'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692990871921464134.4353)
,p_chart_id=>wwv_flow_api.id(692990595257464131.4353)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_api.create_page(
 p_id=>16.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Sessionzustandsdetails'
,p_step_title=>'Sessionzustandsdetails'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_purge_session.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10298124982245880.4353)
,p_plug_name=>'Sessionzustand'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       session_id flow_instance,',
'       item_name  i,',
'       item_value,',
'       session_state_status,',
'       application_id flow_id,',
'       application_name,',
'       page_id,',
'       page_name',
'  from wwv_flow_data_view',
' where session_id = :FLOW_SESSION'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10298231278245880.4353)
,p_name=>'Session State'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10298425155245907.4353)
,p_db_column_name=>'FLOW_INSTANCE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10298501271245908.4353)
,p_db_column_name=>'I'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Element'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10298701631245908.4353)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10298809834245908.4353)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10300416585252734.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10302523080273547.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10303115939280913.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22411130140635457.4353)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Elementwert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452409822478775583.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10298124982245880.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(174246003001070427.4353)
,p_branch_action=>'16'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_api.create_page(
 p_id=>17.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Workspace-Voreinstellungen festlegen'
,p_step_title=>'Workspace-Voreinstellungen festlegen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p17_checkdisable()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
'function p17_checkdisable(){ ',
'var ltext_0 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_0''); ',
'var ltext_1 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_1''); ',
'var ltext; ',
'if(ltext_0.checked == true){ltext = ltext_0}else{ltext = ltext_1} ',
'html_DisableOnValue(ltext,''N'',''P17_ACCOUNT_LIFETIME_DAYS'',''P17_USER_MAX_LOGIN_FAILURES'') ',
'} ',
'',
'//-->',
'</script>'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*apex.jQuery(''#P17_WORKSPACE_IMAGE ~ a'').each(function() {',
'    if (this.href.match(/apex_util.get_blob_file/)) {',
'        $x("public_workspace_img").src = this.href;',
'    }',
'});*/'))
,p_step_template=>wwv_flow_api.id(692762523503114201.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_prefs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1221407852620126.4353)
,p_plug_name=>'Team Development'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1589815800325020.4353)
,p_plug_name=>'Sessiontimeout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5171608747872545.4353)
,p_plug_name=>unistr('Accountsteuerung f\00FCr die Anmeldung')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5181326820057615.4353)
,p_plug_name=>'Voreinstellungen festlegen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Steuerungsfunktionalit\00E4t zu den Voreinstellungen f\00FCr den Workspace.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46267907729679029.4353)
,p_plug_name=>unistr('Selektor f\00FCr Regionsanzeige')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40275409253350646.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(113858225820003007.4353)
,p_plug_name=>'Workspace-Voreinstellungen festlegen'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173246109288066858.4353)
,p_plug_name=>'SQL Workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173247816392106815.4353)
,p_plug_name=>'App Builder'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(327482312829627868.4353)
,p_plug_name=>'Team Development'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>Wenn das Hochladen von Dateien in Team Development aktiviert ist, wird eine APEX$-Tabelle erstellt.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113887204096053504.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(113858225820003007.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113889631108061313.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(113858225820003007.4353)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(113889809101061315.4353)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(113889631108061313.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1221686539620128.4353)
,p_name=>'P17_ALLOW_ISSUE_FILES_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1221407852620126.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Vorgangsdatei-Repository aktivieren'
,p_source=>'ALLOW_ISSUE_FILES_YN'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FILES_YN'')',
'    when ''Y'' then :P17_ALLOW_ISSUE_FILES_YN',
'    else ''N''',
'end;'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FILES_YN''), ''N'') = ''N'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie <strong>Ja</strong> aus, damit Dateien in das zentrale Datei-Repository von Team Development hochgeladen werden k\00F6nnen. W\00E4hlen Sie <strong>Nein</strong> aus, damit Dateien nicht in das zentrale Repository hochgeladen werden k\00F6nnen. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1221742845620129.4353)
,p_name=>'P17_ISSUE_FS_LIMIT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1221407852620126.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Maximale Vorgangsdateigr\00F6\00DFe (in MB)')
,p_source=>'ISSUE_FS_LIMIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ISSUES_FS_LIMIT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die maximale Dateigr\00F6\00DFe f\00FCr eine Datei, die in das zentrale Datei-Repository von Team Development hochgeladen wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1590413138325026.4353)
,p_name=>'P17_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1589815800325020.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximale Sessiondauer in Sekunden'
,p_source=>'MAX_SESSION_LENGTH_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(1402706982624090.4353)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Definiert, wie lange (in Sekunden) Sessions vorhanden sein und von Anwendungen in diesem Workspace verwendet werden k\00F6nnen. Diese Einstellung wird durch die entsprechende Einstellung auf Anwendungsebene au\00DFer Kraft gesetzt.'),
'',
'<ul>',
'    <li>Geben Sie eine positive Ganzzahl ein, um zu steuern, wie lange eine Session vorhanden sein kann.</li>',
unistr('    <li>Geben Sie 0 f\00FCr eine unbegrenzte Sessiondauer ein.</li>'),
'    <li>Lassen Sie den Wert leer, um die auf Instanzebene definierte Sessiondauer zu verwenden.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1590581631325027.4353)
,p_name=>'P17_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1589815800325020.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximale Session-Leerlaufzeit in Sekunden'
,p_source=>'MAX_SESSION_IDLE_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(1402706982624090.4353)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Die Sessionleerlaufzeit ist die Zeit zwischen der letzten Seitenanforderung und der n\00E4chsten Seitenanforderung. Diese Einstellung wird durch die entsprechende Einstellung'),
'auf Anwendungsebene ersetzt.',
'',
'<ul>',
unistr('    <li>Geben Sie eine positive Ganzzahl ein, um die Standardleerlaufzeit f\00FCr Sessions zu bestimmen, die von Anwendungen in diesem Workspace verwendet wird.</li>'),
'    <li>Lassen Sie den Wert leer, um die auf Instanzebene definierte Leerlaufzeit zu verwenden.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1590607064325028.4353)
,p_name=>'P17_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1589815800325020.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sessiontimeoutwarnung in Sekunden'
,p_source=>'SESSION_TIMEOUT_WARNING_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_api.id(1508766038293211.4353)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die Zeit f\00FCr die Sessiontimeoutwarnung legt fest, wie lange (in Sekunden) vor dem Sessiontimeout (entweder maximale Sessionl\00E4nge oder maximale Sessioninaktivit\00E4tszeit) eine Warnung angezeigt wird. Bei der Warnung wegen Sessioninaktivit\00E4t k\00F6nnen Be')
||unistr('nutzer die Session verl\00E4ngern. Bei einer Warnung wegen maximaler Sessionl\00E4nge werden Benutzer aufgefordert, ihre Arbeit zu speichern, damit keine Daten verloren gehen, wenn die maximale Sessionzeit erreicht wird.</p>'),
unistr('<p>Hinweis: Diese Einstellung wird durch die entsprechende Einstellung auf Anwendungsebene au\00DFer Kraft gesetzt.</p>'),
'<p>',
'    <ul>',
unistr('        <li>Geben Sie eine positive Ganzzahl ein, um die Standardinaktivit\00E4tszeit f\00FCr Sessions von Anwendungen in diesem Workspace zu steuern.</li>'),
unistr('        <li>Geben Sie 0 ein, um Sessiontimeoutwarnungen f\00FCr Sessions von Anwendungen in diesem Workspace auszuschalten.</li>'),
'        <li>Lassen Sie den Wert leer, um die auf Instanzebene definierte Warnzeit zu verwenden.</li>',
'    </ul>  ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4828217458002138.4353)
,p_name=>'P17_EXPIRE_FND_USER_ACCOUNTS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5171608747872545.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ablauf und Sperre des Accounts:'
,p_source=>'EXPIRE_FND_USER_ACCOUNTS'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'  when wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'')=''Y'' then ''Y''',
'  else nvl(:P17_EXPIRE_FND_USER_ACCOUNTS,''N'')',
'end'))
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXPIRE USER ACCOUNTS'
,p_lov=>'.'||wwv_flow_api.id(4834509455047185.4353)||'.'
,p_tag_attributes=>'onchange="p17_checkdisable()"'
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS''),''N'') = ''Y'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Treffen Sie eine Auswahl, um zu bestimmen, ob &PRODUCT_NAME.-Endbenutzeraccounts ablaufen oder gesperrt werden k\00F6nnen. Dieses Feature gilt nur f\00FCr'),
unistr('Endbenutzeraccounts, die mit der &PRODUCT_NAME.-Benutzerverwaltungsoberfl\00E4che erstellt wurden.'),
unistr(' Verf\00FCgbare Optionen:'),
'<ul>',
'<li>Aktivieren</li>',
'<li>Deaktivieren</li>',
'</ul>',
unistr('Dieses Feature bietet Anwendungen zus\00E4tzliche Authentifizierungssicherheit.'),
unistr('Wenn Sie <strong>Aktivieren</strong> ausw\00E4hlen, laufen die Benutzeraccountkennw\00F6rter nach einem konfigurierbaren Zeitraum ab.'),
unistr('Au\00DFerdem werden Accounts nach Erreichen einer konfigurierbaren Anzahl von nicht erfolgreichen Authentifizierungsversuchen gesperrt, und Accountkennw\00F6rter k\00F6nnen nach der ersten Verwendung ablaufen.'),
'<p>',
unistr('Wenn der &PRODUCT_NAME.-Administrator f\00FCr diese Installation die Umgebungseinstellung <strong>Mit Ablauf und Sperre des Benutzeraccounts</strong> auf "Ja" gesetzt hat, muss dieses Feature f\00FCr alle Workspaces aktiviert werden. Das Element zeigt dann <')
||unistr('strong>Aktivieren</strong> an und kann nicht vom Workspace-Administrator ge\00E4ndert werden.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4829116550011426.4353)
,p_name=>'P17_USER_MAX_LOGIN_FAILURES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5171608747872545.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl (',
'    wwv_flow_platform.get_preference(''MAX_LOGIN_FAILURES''),',
'    4 )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Maximal zul\00E4ssige nicht erfolgreiche Anmeldeversuche:')
,p_source=>'FND_USER_MAX_LOGIN_FAILURES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie eine positive Ganzzahl ein, die angibt, wie viele aufeinanderfolgende, nicht erfolgreiche Authentifizierungsversuche zul\00E4ssig sind, bevor ein Endbenutzer-Account gesperrt wird.'),
unistr('Wenn Sie in diesem Feld keinen Wert eingeben, wird die Umgebungseinstellung <strong>Maximal zul\00E4ssige nicht erfolgreiche Anmeldeversuche</strong> auf Site-Ebene verwendet.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5483624971767521.4353)
,p_name=>'P17_ACCOUNT_LIFETIME_DAYS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5171608747872545.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl (',
'    wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),',
'    45 )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('G\00FCltigkeitsdauer Endbenutzer-Account (Tage):')
,p_source=>'ACCOUNT_LIFETIME_DAYS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie eine positive Ganzzahl als maximale Anzahl der Tage vor Ablauf des Accounts an.',
unistr('Wenn Sie in diesem Feld keinen Wert angeben, wird die Umgebungseinstellung <strong>G\00FCltigkeitsdauer f\00FCr das Account-Kennwort</strong> auf Site-Ebene verwendet.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8483028405465485.4353)
,p_name=>'P17_PROVISIONING_COMPANY_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(113858225820003007.4353)
,p_use_cache_before_default=>'NO'
,p_source=>'PROVISIONING_COMPANY_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113919310002206635.4353)
,p_name=>'P17_PLSQL_EDITING'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(173246109288066858.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'PL/SQL bearbeiten:'
,p_source=>'ALLOW_PLSQL_EDITING'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'  when wwv_flow_platform.get_preference(''PLSQL_EDITING'')=''N'' then ''N''',
'  else nvl(:P17_PLSQL_EDITING,''Y'')',
'end'))
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PLSQL EDITING STATUS'
,p_lov=>'.'||wwv_flow_api.id(113937100137241641.4353)||'.'
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''PLSQL_EDITING''),''Y'') = ''N'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie anhand einer Auswahl, ob Entwickler die PL/SQL-Programmbl\00F6cke im Objektbrowser bearbeiten und kompilieren k\00F6nnen. Verf\00FCgbare Optionen:'),
'<ul>',
'<li>Bearbeiten von PL/SQL-Programmblock zulassen</li>',
'<li>Bearbeiten von PL/SQL-Programmblock nicht zulassen</li>',
'</ul>',
unistr('Dieses Feature erm\00F6glicht Programmierern, den PL/SQL-Code au\00DFerhalb des Data Dictionarys zu \00E4ndern. Wenn Sie <strong>Bearbeiten von PL/SQL-Programmblock nicht zulassen</strong> w\00E4hlen, k\00F6nnen Entwickler weiterhin PL/SQL-Programmbl\00F6cke mit Skripts ode')
||'r in SQL Command Processor erstellen und ersetzen.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173267514604352193.4353)
,p_name=>'P17_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(173247816392106815.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'App Builder aktivieren'
,p_source=>'ALLOW_APP_BUILDING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob App Builder-Verwendung und -Entwicklung f\00FCr den aktuellen Workspace aktiviert werden soll. W\00E4hlen Sie <strong>Ja</strong> oder <strong>Nein</strong> aus.<br><br>'),
unistr('Diese Einstellung bestimmt auch die Verf\00FCgbarkeit von Produktivit\00E4ts- und Beispielanwendungen f\00FCr den aktuellen Workspace.'),
unistr('Verwenden Sie App Builder zur Assemblierung einer Anwendung aufsetzend auf vorhandenen Datenbankobjekten wie Tabellen oder Prozeduren. Produktivit\00E4tsanwendungen werden von Oracle unterst\00FCtzt.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173268016167390540.4353)
,p_name=>'P17_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(173246109288066858.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'SQL Workshop aktivieren'
,p_source=>'ALLOW_SQL_WORKSHOP_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob SQL Workshop im aktuellen Workspace aktiviert werden soll. W\00E4hlen Sie <strong>Ja</strong> oder <strong>Nein</strong>.<br>'),
unistr('Mit SQL Workshop k\00F6nnen Sie auf Tools zum Anzeigen und Verwalten von Datenbankobjekten zugreifen. ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173268926472412387.4353)
,p_name=>'P17_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1221407852620126.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'"Team Development" aktivieren'
,p_source=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob Team Development im aktuellen Workspace aktiviert werden soll. W\00E4hlen Sie <strong>Ja</strong> oder <strong>Nein</strong> aus.<br>'),
unistr('Mit Team Development k\00F6nnen Sie Vorg\00E4nge interaktiv verfolgen und verwalten. Sie k\00F6nnen Vorg\00E4nge mithilfe von Labels klassifizieren, Benutzer zu Vorg\00E4ngen zuweisen, einen Vorgang mit Meilensteinen verkn\00FCpfen sowie Dateien an einen Vorgang anh\00E4ngen.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314428629679648088.4353)
,p_name=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1221407852620126.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Feedbackdatei-Repository aktivieren'
,p_source=>'ALLOW_TEAM_DEV_FILES_YN'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FILES_YN'')',
'    when ''Y'' then :P17_ALLOW_TEAM_DEV_FILES_YN',
'    else ''N''',
'end;'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FILES_YN''), ''N'') = ''N'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Geben Sie an, ob das Hochladen von Dateien f\00FCr Feedback aktiviert werden soll. Wenn Sie <strong>Ja</strong> ausw\00E4hlen, wird eine lokale APEX$-Tabelle zur Speicherung der Dateien erstellt.'),
'</p>',
'<p>',
unistr('    Dieses Attribut kann nur ge\00E4ndert werden, wenn die Featurekonfiguration "Feedbackdatei-Repository aktivieren" in der internen Verwaltung von &PRODUCT_NAME. auf "Ja" gesetzt ist.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(319101421909723145.4353)
,p_name=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(173246109288066858.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'RESTful Services aktivieren'
,p_source=>'ALLOW_RESTFUL_SERVICES_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''RESTFUL_SERVICES_ENABLED'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie an, ob RESTful Services im aktuellen Workspace aktiviert werden soll. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(319102415427741291.4353)
,p_name=>'P17_PATH_PREFIX'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_api.id(173246109288066858.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Pfad-Pr\00E4fix')
,p_source=>'PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'not wwv_flow_global.g_cloud'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das URI-Pfadpr\00E4fix f\00FCr den Zugriff auf RESTful Services im aktuellen Workspace an. Der Standardwert des Pfadpr\00E4fixes ist der Name des Workspace.</p>'),
'',
unistr('<p>Beispiel: Bei einem Workspace namens <strong>QA_1</strong> k\00F6nnte ein Pfadpr\00E4fix <strong>QA</strong> festgelegt werden. In diesem Fall ist der Beispiel-RESTful Service verf\00FCgbar unter:</p>'),
'',
'<p><code>http://www.example.com/apex<strong>/qa/</strong>hr/employees/</code></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529293356266976427.4353)
,p_name=>'P17_MANUAL_PATH_PREFIX'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(173246109288066858.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('ORDS-Schemaalias au\00DFer Kraft setzen')
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_pattern varchar2(255);',
'begin',
'    if wwv_flow_global.g_cloud then',
'        return false;',
'    end if;',
'    ',
'    begin',
'        l_pattern := wwv_flow_dynamic_exec.get_first_row_result_varchar2(',
'            p_sql_statement => ''select pattern',
'                                  from user_ords_schemas',
'                                 where upper(pattern) = upper(:P17_PATH_PREFIX)'',',
'            p_parse_as_schema => wwv_flow_user_api.get_default_schema );',
'            ',
'        if l_pattern is not null then ',
'            return true; ',
'        else',
'            return false;',
'        end if;',
'    exception',
'        when others then return false;',
'    end;',
'exception',
'    when others then return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Das Standardschema f\00FCr diesen Workspace ist f\00FCr RESTful Services basierend auf dem Oracle REST Data Services-(ORDS-)Repository aktiviert. Ein Schemaalias ist in den ORDS-Metadaten konfiguriert und darf nur in <strong>RESTful Services</strong> in ')
||unistr('SQL Workshop ge\00E4ndert werden. '),
'</p>',
'<p>',
unistr('    Wenn Sie diese Einstellung auf <strong>Ein</strong> setzen, k\00F6nnen Sie das REST-Pfadpr\00E4fix nur f\00FCr das &PRODUCT_NAME.-Repository au\00DFer Kraft setzen. Oracle empfiehlt <em>nicht</em>, verschiedene Werte f\00FCr den ORDS-Schemaalias und das &PRODUCT_NAM')
||unistr('E.-Workspace-Pfadpr\00E4fix zu verwenden.'),
'</p>',
'<p>',
'  Belassen Sie diese Einstellung auf <strong>Aus</strong>, wenn Sie keine anderslautenden Anweisungen erhalten haben.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(655281725315073604.4353)
,p_name=>'P17_TEAM_DEV_FS_LIMIT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1221407852620126.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Maximale Feedbackdateigr\00F6\00DFe (in MB)')
,p_source=>'TEAM_DEV_FS_LIMIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEAM_DEV_FS_LIMIT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die maximale Dateigr\00F6\00DFe f\00FCr eine Datei aus, die in das Feedbackdatei-Repository hochgeladen wird. Der Standardwert betr\00E4gt 15 MB.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(755295374237836819.4353)
,p_name=>'P17_ALLOW_PACKAGED_APP_INS_YN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(173247816392106815.4353)
,p_use_cache_before_default=>'NO'
,p_source=>'ALLOW_PACKAGED_APP_INS_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5488712607896482.4353)
,p_computation_sequence=>10
,p_computation_item=>'P17_EXPIRE_FND_USER_ACCOUNTS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS''),''N'') = ''Y''',
'  then return ''Y'';',
'else',
'  return v(''P17_EXPIRE_FND_USER_ACCOUNTS'');',
'end if;'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(620836494241373127.4353)
,p_computation_sequence=>10
,p_computation_item=>'P17_PATH_PREFIX'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P17_PATH_PREFIX)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5225431816970359.4353)
,p_validation_name=>'Expire FND User Accounts in Y/N or null'
,p_validation_sequence=>10
,p_validation=>'nvl(:P17_EXPIRE_FND_USER_ACCOUNTS,''N'') in (''Y'',''N'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Der Wert liegt au\00DFerhalb des g\00FCltigen Bereichs.')
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(4828217458002138.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5500703800083172.4353)
,p_validation_name=>'max login failures positive'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P17_USER_MAX_LOGIN_FAILURES );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der Wert muss eine positive Ganzzahl sein.'
,p_validation_condition=>'P17_USER_MAX_LOGIN_FAILURES'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(4829116550011426.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5501825617089452.4353)
,p_validation_name=>'account lifetime positive'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P17_ACCOUNT_LIFETIME_DAYS );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der Wert muss eine positive Ganzzahl sein.'
,p_validation_condition=>'P17_ACCOUNT_LIFETIME_DAYS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(5483624971767521.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(319144900453128092.4353)
,p_validation_name=>'Path Prefix Must Have Value'
,p_validation_sequence=>40
,p_validation=>'P17_PATH_PREFIX'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>':P17_ALLOW_SQL_WORKSHOP_YN = ''Y'' and :P17_ALLOW_RESTFUL_SERVICES_YN = ''Y'' and not wwv_flow_global.g_cloud'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(319102415427741291.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(320869816918414854.4353)
,p_validation_name=>'Path Prefix Already Exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1',
'             from wwv_flow_companies',
'            where path_prefix = upper(:P17_PATH_PREFIX)',
'             and provisioning_company_id <> :flow_security_group_id ) loop',
'   return false;',
'   exit;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# ist bereits vorhanden.'
,p_validation_condition=>':P17_ALLOW_SQL_WORKSHOP_YN = ''Y'' and :P17_ALLOW_RESTFUL_SERVICES_YN = ''Y'' and not wwv_flow_global.g_cloud'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(319102415427741291.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(620836305429373126.4353)
,p_validation_name=>'Restricted Path Prefix Characters'
,p_validation_sequence=>60
,p_validation=>'P17_PATH_PREFIX'
,p_validation2=>'^[ABCDEFGHIJKLMNOPQRSTUVWXYZ[:digit:]_-]+$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# darf nur alphanumerische Zeichen, "-" oder "_" enthalten.'
,p_validation_condition=>':P17_ALLOW_SQL_WORKSHOP_YN = ''Y'' and :P17_ALLOW_RESTFUL_SERVICES_YN = ''Y'' and not wwv_flow_global.g_cloud'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(319102415427741291.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1406037678336507.4353)
,p_validation_name=>'P17_MAX_SESSION_LENGTH_SEC is positive integer'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P17_MAX_SESSION_LENGTH_SEC is null ',
'       or to_number(:P17_MAX_SESSION_LENGTH_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der Wert muss eine positive Ganzzahl sein.'
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(1590413138325026.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1406124020336508.4353)
,p_validation_name=>'P17_MAX_SESSION_IDLE_SEC is positive integer'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P17_MAX_SESSION_IDLE_SEC is null ',
'       or to_number(:P17_MAX_SESSION_IDLE_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der Wert muss eine positive Ganzzahl sein.'
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(1590581631325027.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1406276358336509.4353)
,p_validation_name=>'P17_SESSION_TIMEOUT_WARN_SEC is positive integer'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P17_SESSION_TIMEOUT_WARN_SEC is null ',
'       or to_number(:P17_SESSION_TIMEOUT_WARN_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der Wert muss eine positive Ganzzahl sein.'
,p_when_button_pressed=>wwv_flow_api.id(113889631108061313.4353)
,p_associated_item=>wwv_flow_api.id(1590607064325028.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504160631041512755.4353)
,p_name=>'Set PL/SQL Editing'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_SQL_WORKSHOP_YN'
,p_condition_element=>'P17_ALLOW_SQL_WORKSHOP_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504160921379512755.4353)
,p_event_id=>wwv_flow_api.id(504160631041512755.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PLSQL_EDITING'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(319137025988009917.4353)
,p_event_id=>wwv_flow_api.id(504160631041512755.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504161117126512756.4353)
,p_event_id=>wwv_flow_api.id(504160631041512755.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PLSQL_EDITING'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(319137222968011341.4353)
,p_event_id=>wwv_flow_api.id(504160631041512755.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN,P17_PATH_PREFIX'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(321989200019520191.4353)
,p_event_id=>wwv_flow_api.id(504160631041512755.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P17_ALLOW_RESTFUL_SERVICES_YN = ''N'' then',
'  return ''Y'';',
'end if;'))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(321953223841387573.4353)
,p_event_id=>wwv_flow_api.id(504160631041512755.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(319105500624780088.4353)
,p_name=>'REST = Yes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_condition_element=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(319147932500219616.4353)
,p_event_id=>wwv_flow_api.id(319105500624780088.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(319106230675780091.4353)
,p_event_id=>wwv_flow_api.id(319105500624780088.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(655281866528073605.4353)
,p_name=>'Show/Hide P17_TEAM_DEV_FS_LIMIT'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_condition_element=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(655281943393073606.4353)
,p_event_id=>wwv_flow_api.id(655281866528073605.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(655282003570073607.4353)
,p_event_id=>wwv_flow_api.id(655281866528073605.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(763672849397287394.4353)
,p_name=>'App Builder Setting Updates Prod and Sample Apps setting'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_APP_BUILDING_YN'
,p_condition_element=>'P17_ALLOW_APP_BUILDING_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(763673102850287396.4353)
,p_event_id=>wwv_flow_api.id(763672849397287394.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_PACKAGED_APP_INS_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(763673738110292514.4353)
,p_event_id=>wwv_flow_api.id(763672849397287394.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_PACKAGED_APP_INS_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(529293549089976429.4353)
,p_name=>'Show Hide Path Prefix'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_MANUAL_PATH_PREFIX'
,p_condition_element=>'P17_MANUAL_PATH_PREFIX'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(529293648787976430.4353)
,p_event_id=>wwv_flow_api.id(529293549089976429.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(529293824678976432.4353)
,p_event_id=>wwv_flow_api.id(529293549089976429.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1221801671620130.4353)
,p_name=>'Hide/Show Issue File Size'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_ISSUE_FILES_YN'
,p_condition_element=>'P17_ALLOW_ISSUE_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1221961000620131.4353)
,p_event_id=>wwv_flow_api.id(1221801671620130.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ISSUE_FS_LIMIT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1222032644620132.4353)
,p_event_id=>wwv_flow_api.id(1221801671620130.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ISSUE_FS_LIMIT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(150596498043090708.4353)
,p_name=>'Hide/show File Repo Items'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_TEAM_DEVELOPMENT_YN'
,p_condition_element=>'P17_ALLOW_TEAM_DEVELOPMENT_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150596537207090709.4353)
,p_event_id=>wwv_flow_api.id(150596498043090708.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_ISSUE_FILES_YN,P17_ALLOW_TEAM_DEV_FILES_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150596715458090711.4353)
,p_event_id=>wwv_flow_api.id(150596498043090708.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_ISSUE_FILES_YN,P17_ISSUE_FS_LIMIT,P17_TEAM_DEV_FS_LIMIT,P17_ALLOW_TEAM_DEV_FILES_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150596848658090712.4353)
,p_event_id=>wwv_flow_api.id(150596498043090708.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(''P17_ALLOW_ISSUE_FILES_YN'')==''Y'') {',
'   $x_Show(''P17_ISSUE_FS_LIMIT'');',
'}',
'',
'if ($v(''P17_ALLOW_TEAM_DEV_FILES_YN'')==''Y'') {',
'   $x_Show(''P17_TEAM_DEV_FS_LIMIT'');',
'}',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3301819794507903.4353)
,p_name=>'toggle label and color'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_BANNER_ENABLE'
,p_condition_element=>'P17_BANNER_ENABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3301922574507904.4353)
,p_event_id=>wwv_flow_api.id(3301819794507903.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_BANNER_LABEL,P17_BANNER_COLOR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3302093196507905.4353)
,p_event_id=>wwv_flow_api.id(3301819794507903.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_BANNER_LABEL,P17_BANNER_COLOR'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(113888522450058819.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'override with instance settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'')=''Y'' then',
'    :P17_EXPIRE_FND_USER_ACCOUNTS := ''Y'';',
'end if;',
'',
'if wwv_flow_platform.get_preference(''PLSQL_EDITING'') = ''N'' then',
'    :P17_PLSQL_EDITING := ''N'';',
'end if;',
'',
'if wwv_flow_platform.get_preference(''RESTFUL_SERVICES_ENABLED'') = ''N'' then',
'    :P17_ALLOW_RESTFUL_SERVICES_YN := ''N'';',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Anwenden von Workspace-Voreinstellungen nicht m\00F6glich.')
,p_process_when_button_id=>wwv_flow_api.id(113889631108061313.4353)
,p_process_success_message=>'Workspace-Voreinstellungen wurden angewendet.'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8487030576522859.4353)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Save WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P17_PROVISIONING_COMPANY_ID'
,p_attribute_04=>'PROVISIONING_COMPANY_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(113889631108061313.4353)
,p_process_when=>':P17_PROVISIONING_COMPANY_ID = wwv_flow_security.g_security_group_id'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(317482715965499118.4353)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create team dev file table'
,p_process_sql_clob=>'wwv_flow_team_file.install(p_filesize_quota => :P17_TEAM_DEV_FS_LIMIT);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'APEX$TEAM_DEV_FILE-Tabelle kann nicht erstellt werden'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(113889631108061313.4353)
,p_process_when=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8492310799564500.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set provisioning_company_id'
,p_process_sql_clob=>':P17_PROVISIONING_COMPANY_ID := wwv_flow_security.g_security_group_id;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9046701053701699.4353)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'fetch wwv_flow_companies'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P17_PROVISIONING_COMPANY_ID'
,p_attribute_04=>'PROVISIONING_COMPANY_ID'
,p_attribute_14=>'N'
);
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_api.create_page(
 p_id=>18.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_step_title=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9837022786686597.4353)
,p_plug_name=>unistr('Entwickleraktivit\00E4t pro Tag')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P18a */',
'         day, to_char(day,''Day'') day_of_week, to_char(day,''Month'') month_of_year, sum(application_changes) application_changes, count(distinct flow_user) developers,',
'100 * (sum(application_changes) / nvl(max(c.total_views),1)) pct,',
'round(100 * (sum(application_changes) / nvl(max(c.total_views),1)))  graph',
'from',
'(',
'select trunc(audit_date) day, flow_user, count(*) application_changes',
'          from wwv_flow_builder_audit_trail',
'         where security_group_id = :flow_security_group_id and',
'     audit_date >= sysdate - :P18_SINCE',
'         group by trunc(audit_date), flow_user',
'         ) x,',
'(select count(*) total_views ',
' from wwv_flow_builder_audit_trail',
' where security_group_id = :flow_security_group_id and',
'     audit_date >= sysdate - :P18_SINCE and',
'     (nvl(:P18_APPLICATION,0) = 0 or flow_id = :P18_APPLICATION)',
') c',
'group by day'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9837112284686597.4353)
,p_name=>'Developer activity by day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9837326990686601.4353)
,p_db_column_name=>'DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Datum'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9837516879686602.4353)
,p_db_column_name=>'DEVELOPERS'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Entwickler'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9837410597686601.4353)
,p_db_column_name=>'APPLICATION_CHANGES'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>unistr('Komponenten\00E4nderungen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9837607047686602.4353)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Prozentsatz'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9837709593686602.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9840017550720187.4353)
,p_db_column_name=>'DAY_OF_WEEK'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9840115860720188.4353)
,p_db_column_name=>'MONTH_OF_YEAR'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Monat'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47680424022294433.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201288915809201314.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47680424022294433.4353)
,p_button_name=>'P18_SET'
,p_button_static_id=>'P18_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'APPLY_CHANGES'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201288706805198715.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47680424022294433.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:18,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22676605669426783.4353)
,p_branch_action=>'f?p=&FLOW_ID.:18:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9845330691922599.4353)
,p_name=>'P18_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47680424022294433.4353)
,p_item_default=>'7'
,p_prompt=>'Seit'
,p_source=>'7'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47687424293389127.4353)
,p_name=>'P18_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47680424022294433.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_api.create_page(
 p_id=>19.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Sessiondetail'
,p_step_title=>'Sessiondetail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762523503114201.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_sessions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22420117774719228.4353)
,p_plug_name=>unistr('Elementwerte f\00FCr Sessionzustand')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>54
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select session_id,',
'       item_name,',
'       item_value,',
'       session_state_status,',
'       application_id application',
'  from wwv_flow_data_view',
' where session_id        = :P19_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(22420231632719228.4353)
,p_name=>'Session State Item Values'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22420407165719244.4353)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Session-ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22420517867719244.4353)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Elementname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22420626985719244.4353)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Elementwert'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22420714744719244.4353)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22420820054719244.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167635406631549268.4353)
,p_plug_name=>'Sessionattribute'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>34
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167911012318802431.4353)
,p_plug_name=>'Seitenansichten'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>44
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  l.TIME_STAMP,  ',
'        l.ELAP,  ',
'        l.FLOW_ID application,',
'        (select name from wwv_flows where id = l.flow_id) application_Name,  ',
'        l.STEP_ID page, p.name page_name,',
'        num_rows rows_processed,',
'        l.page_view_type,',
'        l.request_value,',
'        l.debug_page_view_id,',
'        l.sqlerrm',
'from    WWV_FLOW_ACTIVITY_LOG l,',
'        wwv_flow_steps p',
'where   l.security_group_id = :flow_security_group_id and',
'        p.id = l.step_id and',
'        p.flow_id = l.flow_id and l.session_id = :p19_id',
'order by l.time_stamp desc'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_customized=>'1'
,p_plug_customized_name=>'Bericht zu Seitenansichten anzeigen'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(370270886963630406.4353)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'15'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'CHRISTIAN'
,p_internal_uid=>370270886963630406
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370270968790630407.4353)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Seitenansicht'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271085137630408.4353)
,p_db_column_name=>'ELAP'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Verstrichen'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271113707630409.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271243588630410.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271325538630411.4353)
,p_db_column_name=>'PAGE'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271444106630412.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271557928630413.4353)
,p_db_column_name=>'ROWS_PROCESSED'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Verarbeitete Zeilen'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271636847630414.4353)
,p_db_column_name=>'PAGE_VIEW_TYPE'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Seitenansichtstyp'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1569139039593351202)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271796589630415.4353)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Anforderungswert'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271871497630416.4353)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Debugging-ID'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,24:P24_PAGE_VIEW_ID:#DEBUG_PAGE_VIEW_ID#'
,p_column_linktext=>'#DEBUG_PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370271955763630417.4353)
,p_db_column_name=>'SQLERRM'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Fehlermeldung'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(173534120886956086.4353)
,p_name=>'Browserinformationen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>64
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 min(user_agent) user_agent',
' from	 WWV_FLOW_ACTIVITY_LOG',
'where SESSION_ID = :P19_ID and user_agent is not null'))
,p_customized=>'1'
,p_customized_name=>'Browserinformationen'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Keine Browserinformationen gefunden.'
,p_query_num_rows_item=>'P19_ROWS'
,p_query_row_count_max=>150000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(173534427356956091.4353)
,p_query_column_id=>1
,p_column_alias=>'USER_AGENT'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzer-Agent'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(370270399737630401.4353)
,p_plug_name=>unistr('Selektor f\00FCr Regionsanzeige')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40275409253350646.4353)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(370270418652630402.4353)
,p_plug_name=>'Sessiondetail'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(370270758542630405.4353)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Auf dieser Seite k\00F6nnen Sie Sessioninformationen pr\00FCfen und Sessioninstrumentierung aktivieren.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(370270600890630404.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(370270418652630402.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:RP,7,19::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(370270504762630403.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(370270418652630402.4353)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(167636715289551739.4353)
,p_name=>'P19_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session-ID'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265417466045318138.4353)
,p_name=>'P19_CREATED_ON'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Erstellt'
,p_format_mask=>'SINCE'
,p_source=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265417543246318139.4353)
,p_name=>'P19_USERNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Anwendungsbenutzername'
,p_source=>'USERNAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265417990532318143.4353)
,p_name=>'P19_SESSION_TIME_ZONE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Zeitzone'
,p_source=>'SESSION_TIME_ZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265418061774318144.4353)
,p_name=>'P19_SESSION_LANG'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sprache'
,p_source=>'SESSION_LANG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265418121288318145.4353)
,p_name=>'P19_SESSION_TERRITORY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Gebiet'
,p_source=>'SESSION_TERRITORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265418292059318146.4353)
,p_name=>'P19_DEBUG_LEVEL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Debugging-Ebene'
,p_source=>'DEBUG_LEVEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DEBUG_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(370258657315557256.4353)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Deaktiviert'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265418369440318147.4353)
,p_name=>'P19_TRACE_MODE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tracemodus'
,p_source=>'TRACE_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION_TRACE_MODE'
,p_lov=>'.'||wwv_flow_api.id(370223717115128950.4353)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Deaktiviert'
,p_cHeight=>1
,p_display_when=>'nvl(wwv_flow_platform.get_preference(''TRACING_ENABLED''),''Y'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370272835189630426.4353)
,p_name=>'P19_LIFE_TIMEOUT_ON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aktivit\00E4tstimeout')
,p_format_mask=>'SINCE'
,p_source=>'LIFE_TIMEOUT_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370272953055630427.4353)
,p_name=>'P19_IDLE_TIMEOUT_ON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(167635406631549268.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Inaktivit\00E4tstimeout')
,p_format_mask=>'SINCE'
,p_source=>'IDLE_TIMEOUT_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(265418580158318149.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Update Session'
,p_attribute_02=>'WWV_FLOW_SESSIONS$'
,p_attribute_03=>'P19_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(370270504762630403.4353)
,p_process_success_message=>'Session aktualisiert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(265418480221318148.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Session'
,p_attribute_02=>'WWV_FLOW_SESSIONS$'
,p_attribute_03=>'P19_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_api.create_page(
 p_id=>20.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_step_title=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47681802813307159.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47721915411670378.4353)
,p_plug_name=>unistr('Aktivit\00E4t/Kalenderansichten \00FCberwachen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47721323591663284.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119155357036390616.4353)
,p_plug_name=>unistr('\00C4nderungen pro Entwickler')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P20a */',
'  trunc(audit_date) audit_date,',
'  lower(flow_user) || '' ('' || to_char(count(*),''FM999G999G999G999G990'') || '')'' as display_title',
'from wwv_flow_builder_audit_trail',
'where security_group_id = :flow_security_group_id and',
'   (nvl(:P20_APPLICATION,0) = 0 or flow_id = :P20_APPLICATION) and',
'   audit_date > sysdate - nvl(:P20_SINCE,45)',
'group by trunc(audit_date), flow_user',
'order by 1, 2'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attribute_01=>'AUDIT_DATE'
,p_attribute_03=>'DISPLAY_TITLE'
,p_attribute_09=>'navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450754120469577083.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47681802813307159.4353)
,p_button_name=>'P20_GO'
,p_button_static_id=>'P20_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47707423582587524.4353)
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47705414400547071.4353)
,p_name=>'P20_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47681802813307159.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'45'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47706119595548538.4353)
,p_name=>'P20_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47681802813307159.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_api.create_page(
 p_id=>21.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Service verwalten'
,p_step_title=>'Service verwalten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_deep_linking=>'Y'
,p_help_text=>'AEADM/aadm_mg_service.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10332709377780494.4353)
,p_plug_name=>'Metadaten verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47244730835700645.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41760803829239203.4353)
,p_plug_name=>'Service verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--noBadge:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(41758527939236654.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42491430107461218.4353)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf der Seite "Service verwalten" k\00F6nnen Sie Serviceanforderungen verwalten, Workspace-Voreinstellungen konfigurieren, Ank\00FCndigungen bearbeiten, Berichte anzeigen, Logdateien und gecachte Inhalte l\00F6schen und Workspace-Metadaten verwalten.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/using-the-manage-service-page.html#GUID-3F3A55C8-68BA-48DC-8B9C-304A04C077E8">Weitere Informationen...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(42494607906502196.4353)
,p_name=>'Workspace-Schemas'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47025022336023416.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(42494607906502196.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(42494926575502200.4353)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47052711371922266.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47255117001847942.4353)
,p_name=>'Service'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    :company workspace_name,',
'(',
'select trim(to_char(count(*),''999G999G999G999G990'')) c',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_files f, wwv_flow_fnd_user u',
' where u.security_group_id = :flow_security_group_id',
'   and u.user_name = :APP_USER',
'   and f.file_type = ''SCRIPT''',
') as sql_scripts,',
'(',
'select count(*)',
'  from wwv_flow_ws_applications ws',
' where ws.security_group_id = :flow_security_group_id',
') as websheets,',
'(',
'select count(*)',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id',
') as schemas,',
'--',
'(select sum(open_requests)',
'from',
'(',
'select count(*) open_requests',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id and',
'      project_status = ''REQUESTED''',
'union all',
'select count(*) open_requests',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      m.request_status = ''REQUESTED''',
') q ) open_requests',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47255310491847944.4353)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace-Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47255925410847950.4353)
,p_query_column_id=>2
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Datenbankanwendungen'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47463231074646060.4353)
,p_query_column_id=>3
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>5
,p_column_heading=>'SQL-Skripts'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47462810726621215.4353)
,p_query_column_id=>4
,p_column_alias=>'WEBSHEETS'
,p_column_display_sequence=>3
,p_column_heading=>'Websheet-Anwendungen'
,p_use_as_row_header=>'N'
,p_report_column_required_role=>wwv_flow_api.id(771323113864288687)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47463017568642176.4353)
,p_query_column_id=>5
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>6
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47470904838902402.4353)
,p_query_column_id=>6
,p_column_alias=>'OPEN_REQUESTS'
,p_column_display_sequence=>7
,p_column_heading=>'Offene Anforderungen'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47470232749892527.4353)
,p_name=>'Letzte Serviceanforderungen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    wwv_flow_lang.system_message(''WORKSPACE_REQUEST'') ||'' - ''|| wwv_flow_item.text_from_lov(project_status,''REQUEST_STATUSES'') || '' - '' ||',
'    DATABASE_SIZE||''MB'' the_request,',
'    request_date',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''CHANGE_REQUEST'')||'' ''||m.service_name ||'' - ''||wwv_flow_item.text_from_lov(m.request_status,''REQUEST_STATUSES'')||'' - ''||',
'       m.service_attribute_1 the_request,',
'       m.requested_on',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id',
'order by 2 desc '))
,p_display_when_condition=>'not wwv_flow_global.g_cloud'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47470426188892527.4353)
,p_query_column_id=>1
,p_column_alias=>'THE_REQUEST'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47470505834892527.4353)
,p_query_column_id=>2
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168449430106381735.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'21'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_api.create_page(
 p_id=>22.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Aktivit\00E4t \00FCberwachen')
,p_step_title=>unistr('Aktivit\00E4t \00FCberwachen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(868317340432334.4353)
,p_plug_name=>'Seitenansichten'
,p_icon_css_classes=>'icon-util-page-views'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(61339238287578026.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(882110638496600.4353)
,p_plug_name=>'Analyse der Seitenansicht'
,p_icon_css_classes=>'icon-database-object'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_api.id(882616872498402.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9786901912561394.4353)
,p_plug_name=>'Anwendungsfehler'
,p_icon_css_classes=>'icon-util-bugs'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(9787313686564805.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22852102269006022.4353)
,p_plug_name=>unistr('Entwickleraktivit\00E4t')
,p_icon_css_classes=>'icon-util-developer-activity'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(22853420277011168.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26365204158918140.4353)
,p_plug_name=>'Anmeldeversuche'
,p_icon_css_classes=>'icon-util-login-attempts'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(26405214790138770.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46999427470822221.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(56636630435030858.4353)
,p_plug_name=>'Umgebung'
,p_icon_css_classes=>'icon-util-attribute-dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(56633624548029155.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162250516888792819.4353)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167618427091432137.4353)
,p_plug_name=>'Sessions'
,p_icon_css_classes=>'icon-util-recent-sessions'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(167617332155424156.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168441310760704445.4353)
,p_plug_name=>'Workspace-Schema und andere Berichte'
,p_icon_css_classes=>'icon-util-attribute-dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(4869427763068324.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder apex-col--rightBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466730619047324921.4353)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Diese Seite enth\00E4lt Links zu Berichten und Diagrammen, mit denen Sie die Benutzer- und Entwickleraktivit\00E4t \00FCberwachen k\00F6nnen.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/monitoring-activity-within-a-workspace.html">Weitere Informationen...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1042393970073998159.4353)
,p_plug_name=>unistr('Archivierte Aktivit\00E4tsberichte')
,p_icon_css_classes=>'icon-database-object'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1029955071738136284.4353)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(162256322822822923.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(167828924727656009.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(162250516888792819.4353)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Dashboard anzeigen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47753609495141634.4353)
,p_branch_action=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00023
begin
wwv_flow_api.create_page(
 p_id=>23.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen pro Entwickler pro Stunde')
,p_step_title=>unistr('Anwendungs\00E4nderungen pro Entwickler pro Stunde')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1766905126878061686.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1770620027781703754.4353)
,p_plug_name=>unistr('Anwendungs\00E4nderungen pro Entwickler pro Stunde')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(',
'select /* APEX4350P23a */ count(*) tpv',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p23_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P23_APPLICATION = 0 or flow_id = :P23_APPLICATION)',
')',
'select the_date,',
'       developer, ',
'       page_views,',
'pages_visited,',
'distinct_applications,',
'''<div class="hour-graph">''||',
'''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-value"'
||'>''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-value"'
||'>''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-value"'
||'>''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-value"'
||'>''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-value"'
||'>''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-value"'
||'>''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-value"'
||'>''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-value"'
||'>''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-value"'
||'>''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-value"'
||'>''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-value"'
||'>''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-value"'
||'>''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-value"'
||'>''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-value"'
||'>''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-value"'
||'>''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-value"'
||'>''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-value"'
||'>''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-value"'
||'>''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-value"'
||'>''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-value"'
||'>''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-value"'
||'>''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-value"'
||'>''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-value"'
||'>''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-value"'
||'>''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'''</div>'' hours',
'from',
'(',
'select ',
'    trunc(audit_date) the_date,',
'  flow_user developer,',
'  count(*) page_views,',
'  count(distinct(page_id)) pages_visited,',
'  count(distinct(flow_id)) distinct_applications,',
'  sum(decode(to_char(audit_date,''HH24''),0,1,0)) h00,',
'  sum(decode(to_char(audit_date,''HH24''),1,1,0)) h01,',
'  sum(decode(to_char(audit_date,''HH24''),2,1,0)) h02,',
'  sum(decode(to_char(audit_date,''HH24''),3,1,0)) h03,',
'  sum(decode(to_char(audit_date,''HH24''),4,1,0)) h04,',
'  sum(decode(to_char(audit_date,''HH24''),5,1,0)) h05,',
'  sum(decode(to_char(audit_date,''HH24''),6,1,0)) h06,',
'  sum(decode(to_char(audit_date,''HH24''),7,1,0)) h07,',
'  sum(decode(to_char(audit_date,''HH24''),8,1,0)) h08,',
'  sum(decode(to_char(audit_date,''HH24''),9,1,0)) h09,',
'  sum(decode(to_char(audit_date,''HH24''),10,1,0)) h10,',
'  sum(decode(to_char(audit_date,''HH24''),11,1,0)) h11,',
'  sum(decode(to_char(audit_date,''HH24''),12,1,0)) h12,',
'  sum(decode(to_char(audit_date,''HH24''),13,1,0)) h13,',
'  sum(decode(to_char(audit_date,''HH24''),14,1,0)) h14,',
'  sum(decode(to_char(audit_date,''HH24''),15,1,0)) h15,',
'  sum(decode(to_char(audit_date,''HH24''),16,1,0)) h16,',
'  sum(decode(to_char(audit_date,''HH24''),17,1,0)) h17,',
'  sum(decode(to_char(audit_date,''HH24''),18,1,0)) h18,',
'  sum(decode(to_char(audit_date,''HH24''),19,1,0)) h19,',
'  sum(decode(to_char(audit_date,''HH24''),20,1,0)) h20,',
'  sum(decode(to_char(audit_date,''HH24''),21,1,0)) h21,',
'  sum(decode(to_char(audit_date,''HH24''),22,1,0)) h22,',
'  sum(decode(to_char(audit_date,''HH24''),23,1,0)) h23',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p23_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P23_APPLICATION = 0 or flow_id = :P23_APPLICATION)',
'group by ',
'  flow_user, trunc(audit_date)',
') d, ',
'  total_page_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.APPCHANGES'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m',
'  '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1770620126131703754.4353)
,p_name=>'Application Changes by Developer'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1770620126131703754
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(756684373254357823.4353)
,p_db_column_name=>'THE_DATE'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Tag'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760793840281373040.4353)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Entwickler'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760794295093373041.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>unistr('Komponenten\00E4nderungen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760795409411373043.4353)
,p_db_column_name=>'PAGES_VISITED'
,p_display_order=>40
,p_column_identifier=>'F'
,p_column_label=>'Eindeutige Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760795833804373043.4353)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>50
,p_column_identifier=>'G'
,p_column_label=>'Eindeutige Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760796276224373044.4353)
,p_db_column_name=>'HOURS'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>unistr('Aktivit\00E4t pro Stunde')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1760790628228372995.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1766905126878061686.4353)
,p_button_name=>'P23_SET'
,p_button_static_id=>'P8_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1760791063081373001.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1766905126878061686.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_redirect_url=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:8,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1760797413294373078.4353)
,p_branch_action=>'f?p=&FLOW_ID.:23:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1760791473437373006.4353)
,p_name=>'P23_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1766905126878061686.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1760792302886373021.4353)
,p_name=>'P23_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1766905126878061686.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cHeight=>1
,p_tag_attributes=>'style="max-width:200px"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_api.create_page(
 p_id=>24.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Debugging-Meldungen'
,p_step_title=>'Debugging-Meldungen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table td {',
'    padding: 4px 8px;',
'}',
'.a-IRR-table td[headers=pct] {',
'    max-width: 120px;',
'}',
'.a-IRR-table td[headers=message] {',
'    max-width: 600px;',
'    overflow-x: auto;',
'}',
'pre {',
'    font-size: 11px;',
'    line-height: 14px;',
'    margin: 0;',
'}',
'.l1, .l2 {',
'    font-weight: bold;',
'    color: red;',
'}',
'.l3 {',
'    font-weight: bold;',
'}'))
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(370273743162630435.4353)
,p_plug_name=>unistr('Debugging-Meldungen f\00FCr Seitenansichts-ID &P24_PAGE_VIEW_ID.')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(370331955215891191.4353)
,p_plug_name=>'Debugging-Meldungen'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>34
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select elapsed_seconds,',
'       execution_time,',
'       message,',
'       message_level,',
'       percent_of_max,',
'       call_stack,',
'       session_id,',
'       flow_id,',
'       page_id,',
'       apex_user,',
'       to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as message_anchor,',
'       message_timestamp',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p class="padding-sm">Spalten f\00FCr die verstrichene Zeit werden in Sekunden gemeldet.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(370332345019891192.4353)
,p_name=>'Recent Page Views'
,p_max_row_count=>'100000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 100.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_download_filename=>'pagelog'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>370332345019891192
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370334083525891194.4353)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370334833824891195.4353)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Session-ID'
,p_column_link=>'f?p=&FLOW_ID.:19:&SESSION.::&DEBUG.:RP,:P19_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370272278628630420.4353)
,p_db_column_name=>'MESSAGE_LEVEL'
,p_display_order=>38
,p_column_identifier=>'AG'
,p_column_label=>'Ebene'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370272332017630421.4353)
,p_db_column_name=>'MESSAGE'
,p_display_order=>48
,p_column_identifier=>'AH'
,p_column_label=>'Nachricht'
,p_column_html_expression=>'<a name="#MESSAGE_ANCHOR#"></a><pre class="l#MESSAGE_LEVEL#">#MESSAGE#</pre>'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_static_id=>'message'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370272477626630422.4353)
,p_db_column_name=>'CALL_STACK'
,p_display_order=>58
,p_column_identifier=>'AI'
,p_column_label=>'Aufrufstack'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370272585833630423.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>68
,p_column_identifier=>'AJ'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370273362565630431.4353)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>78
,p_column_identifier=>'AL'
,p_column_label=>'Verstrichen'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D99999'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370273442678630432.4353)
,p_db_column_name=>'EXECUTION_TIME'
,p_display_order=>88
,p_column_identifier=>'AM'
,p_column_label=>unistr('Ausf\00FChrung')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D99999'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370273549836630433.4353)
,p_db_column_name=>'PERCENT_OF_MAX'
,p_display_order=>98
,p_column_identifier=>'AN'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_static_id=>'pct'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(370273643623630434.4353)
,p_db_column_name=>'APEX_USER'
,p_display_order=>108
,p_column_identifier=>'AO'
,p_column_label=>'Benutzername'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(735031303744168708.4353)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>118
,p_column_identifier=>'AP'
,p_column_label=>'Zeitstempel'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(815130010357112131.4353)
,p_db_column_name=>'MESSAGE_ANCHOR'
,p_display_order=>128
,p_column_identifier=>'AQ'
,p_column_label=>'Meldungsanker'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(815129527890112126.4353)
,p_plug_name=>'Debugging-Diagramm'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(815129654988112127.4353)
,p_region_id=>wwv_flow_api.id(815129527890112126.4353)
,p_chart_type=>'combo'
,p_height=>'120'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'off'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'N'
,p_value_position=>'auto'
,p_sorting=>'value-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(815129747009112128.4353)
,p_chart_id=>wwv_flow_api.id(815129654988112127.4353)
,p_seq=>10
,p_name=>'Neu'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       sum(execution_time) over (order by page_view_row_number) execution_agg',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
' order by page_view_row_number'))
,p_series_type=>'area'
,p_items_value_column_name=>'EXECUTION_AGG'
,p_items_label_column_name=>'LABEL'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(815130112289112132.4353)
,p_chart_id=>wwv_flow_api.id(815129654988112127.4353)
,p_seq=>20
,p_name=>'Warnungen/Fehler'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       1 warnings_errors',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
'   and message_level <= 2',
' order by page_view_row_number'))
,p_series_type=>'line'
,p_items_value_column_name=>'WARNINGS_ERRORS'
,p_items_label_column_name=>'LABEL'
,p_color=>'#ff0000'
,p_line_style=>'dotted'
,p_line_width=>2
,p_line_type=>'none'
,p_marker_rendered=>'auto'
,p_marker_shape=>'circle'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(815129869856112129.4353)
,p_chart_id=>wwv_flow_api.id(815129654988112127.4353)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(815129914598112130.4353)
,p_chart_id=>wwv_flow_api.id(815129654988112127.4353)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(815130245811112133.4353)
,p_chart_id=>wwv_flow_api.id(815129654988112127.4353)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(370347559432891227.4353)
,p_branch_action=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370272753381630425.4353)
,p_name=>'P24_PAGE_VIEW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(370331955215891191.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370274575345630443.4353)
,p_name=>'P24_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(370273743162630435.4353)
,p_prompt=>'Anwendung'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370274696671630444.4353)
,p_name=>'P24_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(370273743162630435.4353)
,p_prompt=>'Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370274705241630445.4353)
,p_name=>'P24_SESSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(370273743162630435.4353)
,p_prompt=>'Session-ID'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370274820535630446.4353)
,p_name=>'P24_USER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(370273743162630435.4353)
,p_prompt=>'Benutzername'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370274976895630447.4353)
,p_name=>'P24_START_TIMESTAMP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(370273743162630435.4353)
,p_prompt=>'Gestartet'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(370275085933630448.4353)
,p_name=>'P24_ELAPSED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(370273743162630435.4353)
,p_prompt=>'Verstrichen'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(370346386219891224.4353)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P24_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(370346714321891226.4353)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P24_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(370347056258891226.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(370274433756630442.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch page view info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select min(flow_id)||case when min(flow_id) <> max(flow_id) then ''->''||max(flow_id) end application,',
'       min(page_id)||case when min(page_id) <> max(page_id) then ''->''||max(page_id) end page,',
'       min(session_id)||case when min(session_id) <> max(session_id) then ''->''||max(session_id) end session_id,',
'       min(apex_user)||case when min(apex_user) <> max(apex_user) then ''->''||max(apex_user) end apex_user,',
'       htmldb_util.get_since_tswtz(min(message_timestamp)) start_timestamp,',
'       to_char(max(elapsed_seconds), ''999G990D9999'') elapsed_seconds',
'  into :P24_APPLICATION,',
'       :P24_PAGE,',
'       :P24_SESSION,',
'       :P24_USER,',
'       :P24_START_TIMESTAMP,',
'       :P24_ELAPSED',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00025
begin
wwv_flow_api.create_page(
 p_id=>25.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Benutzer'
,p_step_title=>'Seitenansichten pro Benutzer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5180512459865310.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9307603421462905.4353)
,p_plug_name=>'Seitenansichten pro Benutzer'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as',
'(select /* APEX4350P25a */ count(*) tpv ',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P25_DATE',
'and   security_group_id = :flow_security_group_id)',
'select developer, ',
'       page_views, ',
'       page_events,',
'       page_processing,',
'       100* page_events/tpv pct,',
'       round(100* page_events/tpv) graph , ',
'       report_rows, ',
'       CONTENT_LENGTH,',
'       pages distinct_pages,',
'       applications,elapsed_time,',
'       distinct_hours,',
'       distinct_days, ',
'       last_view, ',
'       first_view, ',
'       nvl(cached_pages,0) cached_pages, ',
'       nvl(cached_regions,0) cached_regions, ',
'       average_elapsed_time, partial_page_views,',
'      ''<div class="hour-graph">''||',
'      ''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-'
||'value">''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-'
||'value">''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-'
||'value">''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-'
||'value">''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-'
||'value">''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-'
||'value">''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-'
||'value">''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-'
||'value">''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-'
||'value">''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-'
||'value">''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-'
||'value">''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-'
||'value">''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-'
||'value">''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-'
||'value">''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-'
||'value">''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-'
||'value">''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-'
||'value">''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-'
||'value">''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-'
||'value">''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-'
||'value">''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-'
||'value">''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-'
||'value">''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-'
||'value">''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-'
||'value">''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'      ''</div>'' hours',
'from',
'(',
'select upper(USERID) developer, ',
'       count(*) page_events,',
'       sum(decode(page_mode,''A'',0,1)) page_views,',
'       sum(decode(page_mode,''A'',1,0)) page_processing,',
'       sum(num_rows) report_rows,',
'       count(distinct(flow_id||''.''||step_id)) pages,',
'       count(distinct(flow_id)) applications,',
'      sum(elap) elapsed_time,',
'      avg(elap) average_elapsed_time,',
'      count(distinct to_char(time_stamp,''YYYY.MM.DD.HH24'')) distinct_hours,',
'      count(distinct to_char(time_stamp,''YYYY.MM.DD'')) distinct_days,',
'      max(time_stamp) last_view,',
'      min(time_stamp) first_view,',
'      sum(decode(page_mode,''R'',1,0)) cached_pages,',
'      sum(cached_regions) cached_regions,',
'      sum(decode(page_mode,''P'',1,0)) partial_page_views,',
'      sum(nvl(CONTENT_LENGTH,0)) content_length,',
'      sum(decode(to_char(time_stamp,''HH24''),0,1,0)) h00,',
'      sum(decode(to_char(time_stamp,''HH24''),1,1,0)) h01,',
'      sum(decode(to_char(time_stamp,''HH24''),2,1,0)) h02,',
'      sum(decode(to_char(time_stamp,''HH24''),3,1,0)) h03,',
'      sum(decode(to_char(time_stamp,''HH24''),4,1,0)) h04,',
'      sum(decode(to_char(time_stamp,''HH24''),5,1,0)) h05,',
'      sum(decode(to_char(time_stamp,''HH24''),6,1,0)) h06,',
'      sum(decode(to_char(time_stamp,''HH24''),7,1,0)) h07,',
'      sum(decode(to_char(time_stamp,''HH24''),8,1,0)) h08,',
'      sum(decode(to_char(time_stamp,''HH24''),9,1,0)) h09,',
'      sum(decode(to_char(time_stamp,''HH24''),10,1,0)) h10,',
'      sum(decode(to_char(time_stamp,''HH24''),11,1,0)) h11,',
'      sum(decode(to_char(time_stamp,''HH24''),12,1,0)) h12,',
'      sum(decode(to_char(time_stamp,''HH24''),13,1,0)) h13,',
'      sum(decode(to_char(time_stamp,''HH24''),14,1,0)) h14,',
'      sum(decode(to_char(time_stamp,''HH24''),15,1,0)) h15,',
'      sum(decode(to_char(time_stamp,''HH24''),16,1,0)) h16,',
'      sum(decode(to_char(time_stamp,''HH24''),17,1,0)) h17,',
'      sum(decode(to_char(time_stamp,''HH24''),18,1,0)) h18,',
'      sum(decode(to_char(time_stamp,''HH24''),19,1,0)) h19,',
'      sum(decode(to_char(time_stamp,''HH24''),20,1,0)) h20,',
'      sum(decode(to_char(time_stamp,''HH24''),21,1,0)) h21,',
'      sum(decode(to_char(time_stamp,''HH24''),22,1,0)) h22,',
'      sum(decode(to_char(time_stamp,''HH24''),23,1,0)) h23',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P25_DATE and',
'      security_group_id = :flow_security_group_id',
'group by upper(USERID) ',
') pv, total_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Spalten f\00FCr die verstrichene Zeit werden in Sekunden gemeldet.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9307709001462905.4353)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308031484462911.4353)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Benutzer'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR:IR_USERID:#DEVELOPER#'
,p_column_linktext=>'#DEVELOPER#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308206855462912.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308119375462912.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308328702462912.4353)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Seitenverarbeitung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308415410462912.4353)
,p_db_column_name=>'PCT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Prozent von Gesamt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308515590462912.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Prozent von Gesamt'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308600863462913.4353)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Berichtszeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308713826462913.4353)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308817645462913.4353)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309624075462914.4353)
,p_db_column_name=>'AVERAGE_ELAPSED_TIME'
,p_display_order=>11
,p_column_identifier=>'R'
,p_column_label=>'Durchschnittlich verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9308910611462913.4353)
,p_db_column_name=>'ELAPSED_TIME'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309004373462913.4353)
,p_db_column_name=>'DISTINCT_HOURS'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Eindeutige Stunden'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309116716462913.4353)
,p_db_column_name=>'DISTINCT_DAYS'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Eindeutige Tage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309204584462914.4353)
,p_db_column_name=>'LAST_VIEW'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'Letzte Ansicht'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309326606462914.4353)
,p_db_column_name=>'FIRST_VIEW'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>'Erste Ansicht'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309703372462914.4353)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>17
,p_column_identifier=>'S'
,p_column_label=>'Seitenbestandteil-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309408920462914.4353)
,p_db_column_name=>'CACHED_PAGES'
,p_display_order=>18
,p_column_identifier=>'P'
,p_column_label=>'Gecachte Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9309514341462914.4353)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>19
,p_column_identifier=>'Q'
,p_column_label=>'Gecachte Regionen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200270403673529201.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760555663993323223.4353)
,p_db_column_name=>'HOURS'
,p_display_order=>30
,p_column_identifier=>'U'
,p_column_label=>unistr('Aktivit\00E4t pro Stunde')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200574906058977363.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5180512459865310.4353)
,p_button_name=>'P25_SET'
,p_button_static_id=>'P25_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200270517871533277.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5180512459865310.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:25,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(131170811232636848.4353)
,p_branch_action=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(874931239464688.4353)
,p_name=>'P25_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5180512459865310.4353)
,p_item_default=>'to_number(.125)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, '),
'',
unistr('die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_api.create_page(
 p_id=>26.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Anwendung'
,p_step_title=>'Seitenansichten pro Anwendung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9290610815383521.4353)
,p_plug_name=>unistr('Aktivit\00E4t pro Anwendung')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P26a */',
'       flow_id application, ',
'       page_events, v, page_processing, u, p, v/u v_per_user, ',
'       decode(v,0,0,v/(:P26_SINCE*24*60*60)) vs, ',
'       e,',
'       m,',
'       min,',
'       mints, ',
'       maxts,',
'       rr report_rows,',
'       sqlerrm errors,',
'       dynamic_views,',
'       cached_views,',
'       cached_regions,',
'       CONTENT_LENGTH,',
'      ''<div class="hour-graph">''||',
'      ''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-'
||'value">''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-'
||'value">''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-'
||'value">''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-'
||'value">''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-'
||'value">''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-'
||'value">''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-'
||'value">''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-'
||'value">''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-'
||'value">''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-'
||'value">''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-'
||'value">''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-'
||'value">''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-'
||'value">''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-'
||'value">''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-'
||'value">''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-'
||'value">''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-'
||'value">''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-'
||'value">''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-'
||'value">''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-'
||'value">''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-'
||'value">''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-'
||'value">''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-'
||'value">''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-'
||'value">''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'      ''</div>'' hours',
'from (',
'select flow_id, ',
'       count(*) page_events,',
'       sum(decode(page_mode,''A'',0,1)) v, ',
'       sum(decode(page_mode,''A'',1,0)) page_processing,',
'       count(distinct userid) u,',
'       avg(elap) e, max(elap) m, min(elap) min,',
'       min(time_stamp) mints, max(time_stamp) maxts,',
'       count(distinct(step_id)) p,',
'       sum(num_rows) rr,',
'       sum(decode(sqlerrm,null,0,1)) sqlerrm,',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    sum(decode(page_mode,''D'',0,''C'',0,''A'',0,''P'',1)) cached_views,',
'    sum(cached_regions) cached_regions,',
'    sum(nvl(CONTENT_LENGTH,0)) CONTENT_LENGTH,',
'    sum(decode(to_char(time_stamp,''HH24''),0,1,0)) h00,',
'    sum(decode(to_char(time_stamp,''HH24''),1,1,0)) h01,',
'    sum(decode(to_char(time_stamp,''HH24''),2,1,0)) h02,',
'    sum(decode(to_char(time_stamp,''HH24''),3,1,0)) h03,',
'    sum(decode(to_char(time_stamp,''HH24''),4,1,0)) h04,',
'    sum(decode(to_char(time_stamp,''HH24''),5,1,0)) h05,',
'    sum(decode(to_char(time_stamp,''HH24''),6,1,0)) h06,',
'    sum(decode(to_char(time_stamp,''HH24''),7,1,0)) h07,',
'    sum(decode(to_char(time_stamp,''HH24''),8,1,0)) h08,',
'    sum(decode(to_char(time_stamp,''HH24''),9,1,0)) h09,',
'    sum(decode(to_char(time_stamp,''HH24''),10,1,0)) h10,',
'    sum(decode(to_char(time_stamp,''HH24''),11,1,0)) h11,',
'    sum(decode(to_char(time_stamp,''HH24''),12,1,0)) h12,',
'    sum(decode(to_char(time_stamp,''HH24''),13,1,0)) h13,',
'    sum(decode(to_char(time_stamp,''HH24''),14,1,0)) h14,',
'    sum(decode(to_char(time_stamp,''HH24''),15,1,0)) h15,',
'    sum(decode(to_char(time_stamp,''HH24''),16,1,0)) h16,',
'    sum(decode(to_char(time_stamp,''HH24''),17,1,0)) h17,',
'    sum(decode(to_char(time_stamp,''HH24''),18,1,0)) h18,',
'    sum(decode(to_char(time_stamp,''HH24''),19,1,0)) h19,',
'    sum(decode(to_char(time_stamp,''HH24''),20,1,0)) h20,',
'    sum(decode(to_char(time_stamp,''HH24''),21,1,0)) h21,',
'    sum(decode(to_char(time_stamp,''HH24''),22,1,0)) h22,',
'    sum(decode(to_char(time_stamp,''HH24''),23,1,0)) h23',
'from wwv_flow_activity_log',
'where time_stamp >= sysdate - :P26_SINCE and',
'      security_group_id = :flow_security_group_id ',
'group by flow_id) r,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m',
'where u > 0'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Spalten f\00FCr die verstrichene Zeit werden in Sekunden gemeldet.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9290710598383521.4353)
,p_name=>'Activity By Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9290914669383534.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Anwendung'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR:IR_FLOW_ID:#APPLICATION#'
,p_column_linktext=>'#APPLICATION#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291325676383538.4353)
,p_db_column_name=>'U'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>'Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291427844383538.4353)
,p_db_column_name=>'P'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291030843383537.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291118900383537.4353)
,p_db_column_name=>'V'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291210445383538.4353)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Seitenverarbeitung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291510665383538.4353)
,p_db_column_name=>'V_PER_USER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Seitenansichten pro Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291601918383538.4353)
,p_db_column_name=>'VS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Ansichten pro Sekunde'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D00000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291727414383538.4353)
,p_db_column_name=>'E'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Durchschnittlich verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'99G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291825367383539.4353)
,p_db_column_name=>'M'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Maximal verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9291915185383540.4353)
,p_db_column_name=>'MIN'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Minimal verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'9G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9292014541383540.4353)
,p_db_column_name=>'MINTS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Erste Ansicht'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9292120461383541.4353)
,p_db_column_name=>'MAXTS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Letzte Ansicht'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9292231539383541.4353)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Berichtszeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9292315896383541.4353)
,p_db_column_name=>'ERRORS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Fehler'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9292414571383541.4353)
,p_db_column_name=>'DYNAMIC_VIEWS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Dynamische Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9292527076383541.4353)
,p_db_column_name=>'CACHED_VIEWS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Gecachte Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9292617059383541.4353)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Gecachte Regionen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200271025621544978.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760555766693323224.4353)
,p_db_column_name=>'HOURS'
,p_display_order=>29
,p_column_identifier=>'T'
,p_column_label=>unistr('Aktivit\00E4t pro Stunde')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200477803138815713.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200580507536034608.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200477803138815713.4353)
,p_button_name=>'P26_SET'
,p_button_static_id=>'P26_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200580824505039429.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200477803138815713.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:26,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(131128420332626091.4353)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200579710522025924.4353)
,p_name=>'P26_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200477803138815713.4353)
,p_item_default=>'to_number(.125)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, die '),
'',
unistr('f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie "1 Tag" ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.   ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9906602353212915.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_api.create_page(
 p_id=>27.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Monatskalender der Seitenansichten pro Tag'
,p_step_title=>'Monatskalender der Seitenansichten pro Tag'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47775113894360528.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(233523126780054135.4353)
,p_plug_name=>'Seitenansichten pro Tag'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P27a */',
'       trunc(TIME_STAMP) ts,',
'       t.v||'': ''||to_char(count(*),''999G999G999G990'') || chr(10) ||',
'       t.u||'': ''||to_char(count(distinct upper(USERID)),''999G999G999G990'')|| chr(10) ||',
'       t.a||'': ''||to_char(count(distinct flow_id),''999G999G999G990'')|| chr(10) ||',
'       t.p||'': ''||to_char(count(distinct step_id),''999G999G999G990'') as display',
'    from   WWV_FLOW_ACTIVITY_LOG,',
'(select wwv_flow_lang.system_message(''views'') v,',
'        wwv_flow_lang.system_message(''users'') u,',
'        wwv_flow_lang.system_message(''applications'') a,',
'        wwv_flow_lang.system_message(''pages'') p',
' from dual) t',
'    where  security_group_id = :flow_security_group_id and page_mode != ''A'' and',
'    (nvl(:P27_APPLICATION,0) = 0 or flow_id = :P27_APPLICATION) and',
'    TIME_STAMP > sysdate - nvl(:P27_TIME,7) ',
'group by trunc(time_stamp), t.v, t.u, t.a, t.p'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'TS'
,p_attribute_03=>'DISPLAY'
,p_attribute_09=>'navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(429994131751180568.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(47775113894360528.4353)
,p_button_name=>'P27_SET'
,p_button_static_id=>'P27_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'APPLY_CHANGES'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(233186907690029293.4353)
,p_branch_action=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47775420235360528.4353)
,p_name=>'P27_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47775113894360528.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(7)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47775926911360530.4353)
,p_name=>'P27_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47775113894360528.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_api.create_page(
 p_id=>28.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Voreinstellungen l\00F6schen')
,p_step_title=>unistr('Voreinstellungen l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_user_pref.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49166307683716829.4353)
,p_plug_name=>unistr('Benutzervoreinstellungen zur\00FCcksetzen')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<span class="instructiontext">'');',
'for c1 in (select count(*) c from wwv_flow_preferences$ where user_id = :flow_user and security_group_id = :flow_security_group_id) loop',
'sys.htp.p( wwv_flow_lang.system_message(''F4350_USER_PREFS'',:flow_user,c1.c));',
'end loop;',
'sys.htp.p(wwv_flow_lang.system_message(''F4350_RESET_PREFS'')||''</span>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49186429261744804.4353)
,p_plug_name=>'Voreinstellungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('In diesem Bericht werden die Voreinstellungen angezeigt, die f\00FCr den aktuellen Benutzer festgelegt wurden. Diese Sessionzustandswerte werden zwischen den Anmeldungen beibehalten.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49167831098716830.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(49166307683716829.4353)
,p_button_name=>'ViewPreferences'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Voreinstellungen anzeigen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:pref:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49167427147716830.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(49166307683716829.4353)
,p_button_name=>'ResetPref'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Voreinstellungen zur\00FCcksetzen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49179822550733432.4353)
,p_branch_action=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49168016057716831.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'reset user preferences'
,p_attribute_01=>'RESET_USER_PREFERENCES'
,p_process_error_message=>unistr('Zur\00FCcksetzen von Benutzervoreinstellungen nicht m\00F6glich.')
,p_process_when_button_id=>wwv_flow_api.id(49167427147716830.4353)
,p_process_success_message=>unistr('Die Benutzervoreinstellungen wurden zur\00FCckgesetzt (entfernt).')
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_api.create_page(
 p_id=>29.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Aktuelle Seitenansichten'
,p_step_title=>'Aktuelle Seitenansichten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9294728475405715.4353)
,p_plug_name=>'Aktuelle Seitenansichten'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /*+ FIRST_ROWS(21) */',
'    time_stamp,',
'    elap,',
'    num_rows query_rows,',
'    userid userid, ',
'    flow_id,',
'    (select name from wwv_flows where id = l.flow_id) application_name,',
'    (select name from wwv_flow_steps where id = l.step_id and flow_id = l.flow_id) page_name,',
'    step_id,',
'    session_id,',
'    substr(user_agent,1,100) user_agent,',
'    86400 * (time_stamp - lag(time_stamp) over (order by userid, time_stamp)) thinktime,',
'    sqlerrm,',
'    page_mode page_mode_code,',
'    cached_regions,',
'    decode(page_mode,',
'        ''A'',m.m_PAGE_PROCESSING,',
'        ''C'',m.m_CACHE_CREATED,',
'        ''D'',m.m_DYNAMIC,',
'        ''P'',m.m_PARTIAL_PAGE, ',
'        ''R'',m.m_CACHED,',
'        page_mode) page_mode,',
'   to_char(time_stamp,''YYYYMMDD'') day,',
'   websheet_id,',
'   decode(l.flow_id,4900,(select name from wwv_flow_ws_applications where id = l.websheet_id),null) websheet_name,',
'   worksheet_id,',
'   ir_search,',
'   CONTENT_LENGTH,',
'   page_view_type,',
'   request_value,',
'   debug_page_view_id,',
'   ecid',
'from WWV_FLOW_ACTIVITY_LOG l,',
'   (select wwv_flow_lang.system_message(''PAGE_PROCESSING'') m_PAGE_PROCESSING,',
'           wwv_flow_lang.system_message(''CACHE_CREATED'') m_CACHE_CREATED,',
'           wwv_flow_lang.system_message(''F4000.DYNAMIC'') m_DYNAMIC,',
'           wwv_flow_lang.system_message(''PARTIAL_PAGE'') m_PARTIAL_PAGE,',
'           wwv_flow_lang.system_message(''CACHED'') m_CACHED',
'    from dual) m',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P29_TIME,1)) and',
'    (nvl(:P29_APPLICATION,0)=0 or :P29_APPLICATION = flow_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Spalten f\00FCr die verstrichene Zeit werden in Sekunden gemeldet.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9294827650405715.4353)
,p_name=>'Recent Page Views'
,p_max_row_count=>'100000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 100.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_download_filename=>'pagelog'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295014155405725.4353)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Datum'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295117155405725.4353)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295310019405725.4353)
,p_db_column_name=>'USERID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295401265405725.4353)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295528247405726.4353)
,p_db_column_name=>'STEP_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295815278405726.4353)
,p_db_column_name=>'THINKTIME'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Think Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295623845405726.4353)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Session'
,p_column_link=>'f?p=&FLOW_ID.:19:&SESSION.::&DEBUG.:RP,:P19_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295706080405726.4353)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Benutzer-Agent'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9295910992405726.4353)
,p_db_column_name=>'SQLERRM'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Fehlermeldung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9296009036405726.4353)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Seitenmodus'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9296123584405727.4353)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Gecachte Regionen '
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9298118980428251.4353)
,p_db_column_name=>'PAGE_MODE_CODE'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Code f\00FCr Seitenmodus')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9388006803020796.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9388218924024234.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9916615317476149.4353)
,p_db_column_name=>'DAY'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30837825687419856.4353)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Gew\00E4hltes Websheet')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30837931182419860.4353)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Gew\00E4hlter Bericht')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30838006696419860.4353)
,p_db_column_name=>'IR_SEARCH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Suche nach interaktivem Bericht'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200269825228516466.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486710304301055040.4353)
,p_db_column_name=>'WEBSHEET_NAME'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Websheet'
,p_column_type=>'STRING'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(36918123274457464.4353)
,p_db_column_name=>'QUERY_ROWS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Zeilen abfragen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475460529806625310.4353)
,p_db_column_name=>'PAGE_VIEW_TYPE'
,p_display_order=>33
,p_column_identifier=>'AD'
,p_column_label=>'Seitenansichtstyp'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(1569139039593351202)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1569135249109283180.4353)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>43
,p_column_identifier=>'Y'
,p_column_label=>'Anforderungswert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1569135368749283180.4353)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>53
,p_column_identifier=>'Z'
,p_column_label=>'Debugging-ID'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,24:P24_PAGE_VIEW_ID:#DEBUG_PAGE_VIEW_ID#'
,p_column_linktext=>'#DEBUG_PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(342360591742652522.4353)
,p_db_column_name=>'ECID'
,p_display_order=>63
,p_column_identifier=>'AE'
,p_column_label=>'ECID'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47755428326156622.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200579121127019533.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47755428326156622.4353)
,p_button_name=>'P29_SET'
,p_button_static_id=>'P29_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196197132719904196.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47755428326156622.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:29,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130990623956463449.4353)
,p_branch_action=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47755701430156625.4353)
,p_name=>'P29_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47755428326156622.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47756221007156625.4353)
,p_name=>'P29_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47755428326156622.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(158494820430118826.4353)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P29_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(22676108663323154.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(158497003245123320.4353)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P29_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(22676713857324576.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(961201412394966.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_api.create_page(
 p_id=>30.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Entwickleraktivit\00E4tslog')
,p_step_title=>unistr('Entwickleraktivit\00E4tslog')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215462122626558552)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1004413391363499.4353)
,p_plug_name=>unistr('Entwickleraktivit\00E4tslog verwalten')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'   c_click pls_integer := 0;',
'begin',
'   sys.htp.p(''<table class="instructiontext" role="presentation" cellspacing="0" cellpadding="0">'');',
'   -- wwv_flow_builder_audit_trail ',
'   select count(*) into c_dev from wwv_flow_builder_audit_trail ',
'   where security_group_id = :flow_security_group_id;',
'   sys.htp.prn(''<tr><td>''||wwv_flow_lang.system_message(''F4350_DEV_LOG_ENTRIES'')||''</td><td align="right" class="fielddatabold">&nbsp;'');',
'   sys.htp.prn(to_char(c_dev,''999,999,999,999,999,990''));',
'   sys.htp.prn(''</td></tr></table><p />'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Die Entwickleraktivit\00E4t ist ein Log der Entwickler\00E4nderungen an der Anwendung innerhalb des Workspace. Das Log protokolliert den Entwickler, die Anwendung, die ge\00E4nderte Komponente und das Datum. Die Entwickler-Log-Informationen werden einen Monat la')
||unistr('ng beibehalten. Auf dieser Seite k\00F6nnen Sie die Eintr\00E4ge im Entwickleraktivit\00E4tslog l\00F6schen.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47260804113938827.4353)
,p_plug_name=>'Manage Logs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:50%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(41778218420271753.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6889902515000422.4353)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_api.id(1004413391363499.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2554514135549743.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1004413391363499.4353)
,p_button_name=>'PURGE_DEVELOPER_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Entwickler-Log leeren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1119314682357438.4353)
,p_branch_action=>'30'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1115827233342122.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge builder audit'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_builder_audit_trail ',
'where security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Leeren von Log nicht m\00F6glich')
,p_process_when_button_id=>wwv_flow_api.id(2554514135549743.4353)
,p_process_success_message=>unistr('Entwickleraktivit\00E4tslog wurde geleert.')
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_api.create_page(
 p_id=>31.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro gewichteter Seiten-Performance'
,p_step_title=>'Seitenansichten pro gewichteter Seiten-Performance'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9772622807334494.4353)
,p_plug_name=>'Gewichtete Seiten-Performance'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P31a */',
'       flow_id                  application_id, ',
'       step_id                  page_id, ',
'       (select name from wwv_flows where id = l.flow_id) application_name,',
'       (select name from wwv_flow_steps where id = l.step_id and flow_id = l.flow_id) page_name,',
'       count (*)                page_events,',
'       avg(elap)                average_elapsed_time, ',
'       avg(elap)*count(*)       weighted_average,',
'       median(elap)             median_elapsed_time,',
'       median(elap)*count(*)    weighted_median,',
'       (median(elap)*count(*)) - (avg(elap)*count(*)) median_to_avg_delta,',
'       max(elap)                maximum_elapsed_time,',
'       min(elap)                minimum_elapsed_time,',
'       max(elap) - min(elap)    maximum_minimum_delta,',
'       median(content_length)  median_content_length',
'from wwv_flow_activity_log l',
'where security_group_id = :flow_security_group_id and ',
'    (:app_security_group_id = 10 or flow_id not between 4000 and 4999) and',
'    time_stamp >= (sysdate - nvl(:P31_TIME,1)) and',
'    (nvl(:P31_APPLICATION,0) = 0 or flow_id = :P31_APPLICATION)',
'group by flow_id, step_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<br/><p>Die Spalten f\00FCr die abgelaufene Zeit werden in Sekunden gemeldet. Der gewichtete Durchschnitt wird durch Multiplizieren der Seitenereignisse mit der durchschnittlichen Rendering-Zeit der Seite in Sekunden berechnet. Der Medianwert f\00FCr den Dur')
||unistr('chschnitt wird durch Multiplizieren der Seitenereignisse mit dem Medianwert f\00FCr die Rendering-Zeit der Seite in Sekunden berechnet. Die Seitenereignisse umfassen Seitenwiedergabe- und Seitenverarbeitungsereignisse.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9772730274334494.4353)
,p_name=>'Weighted Page Performance'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9772901477334499.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9773030460334504.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seite'
,p_column_link=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:65:P65_APPLICATION,P65_PAGE:#APPLICATION_ID#,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9773123964334504.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9773202731334504.4353)
,p_db_column_name=>'AVERAGE_ELAPSED_TIME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Durchschnittlich verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9773308278334504.4353)
,p_db_column_name=>'WEIGHTED_AVERAGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Gewichteter Durchschnitt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9773428200334504.4353)
,p_db_column_name=>'MEDIAN_ELAPSED_TIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Verstrichen, Medianwert'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9773513323334505.4353)
,p_db_column_name=>'WEIGHTED_MEDIAN'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Gewichteter Medianwert'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9775813452422841.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9776320294443708.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9779126574473944.4353)
,p_db_column_name=>'MEDIAN_TO_AVG_DELTA'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Medianwert f\00FCr durchschnittliches Delta')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9779729822484382.4353)
,p_db_column_name=>'MAXIMUM_ELAPSED_TIME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Maximal verstrichene Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9779827213484382.4353)
,p_db_column_name=>'MINIMUM_ELAPSED_TIME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Minimal verstrichene Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9780325105492393.4353)
,p_db_column_name=>'MAXIMUM_MINIMUM_DELTA'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Maximum-Minimum-Delta'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201290225421223045.4353)
,p_db_column_name=>'MEDIAN_CONTENT_LENGTH'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Medianwert f\00FCr Inhalt')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107716719694045280.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450602812552903078.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(107716719694045280.4353)
,p_button_name=>'P31_SET'
,p_button_static_id=>'P31_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201290305120226615.4353)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(107716719694045280.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:31,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1022424529470850.4353)
,p_branch_action=>'31'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1016914440439483.4353)
,p_name=>'P31_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107716719694045280.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47771328953327091.4353)
,p_name=>'P31_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107716719694045280.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_api.create_page(
 p_id=>32.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Ansichten pro Seite'
,p_step_title=>'Ansichten pro Seite'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5470717896084547.4353)
,p_name=>'Ansichten pro Seite'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>21
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as ',
'(',
'select count(*) tpv ',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P32_TIME',
'and   security_group_id = :flow_security_group_id and',
'(userid = :p32_user or nvl(:p32_user,''0'') = ''0'') and',
'flow_id = :p32_flow',
')',
'select page_id, ',
'       (select name from wwv_flow_steps where flow_id = :p32_flow and id = page_id) page_name,',
'       page_views,',
'       100*page_views/tpv pct, ',
'       round(300*page_views/tpv) graph,',
'      report_rows,',
'      elapsed_time',
'from',
'(',
'select step_id page_id, count(*) page_views , sum(num_rows) report_rows, sum(elap) elapsed_time',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P32_TIME',
'and   security_group_id = :flow_security_group_id and',
'(userid = :p32_user or nvl(:p32_user,''0'') = ''0'') and',
'flow_id = :p32_flow',
'group by step_id',
') d, total_page_views'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(6659715068668103.4353)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5471007240084565.4353)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Seite'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5479500806145870.4353)
,p_query_column_id=>2
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Seitenname'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5471131441084565.4353)
,p_query_column_id=>3
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>3
,p_column_heading=>'Seitenansichten'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5472106945090809.4353)
,p_query_column_id=>4
,p_column_alias=>'PCT'
,p_column_display_sequence=>4
,p_column_heading=>'Prozentsatz'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5472226421090810.4353)
,p_query_column_id=>5
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>5
,p_column_heading=>'&nbsp;'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div style="width:300px;height:14px;background:#dddddd;border-top:1px solid #aaaaaa;border-left:1px solid #aaaaaa;border-bottom:1px solid #ffffff;border-right:1px solid #ffffff;">',
'<img src="#IMAGE_PREFIX#1px_trans.gif" width="#GRAPH#" height="14" border="0" style="background:#3f863f;"></div>'))
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7706002830600313.4353)
,p_query_column_id=>6
,p_column_alias=>'REPORT_ROWS'
,p_column_display_sequence=>6
,p_column_heading=>'Berichtszeilen'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7706104497600318.4353)
,p_query_column_id=>7
,p_column_alias=>'ELAPSED_TIME'
,p_column_display_sequence=>7
,p_column_heading=>'Verstrichene Zeit'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5476109416119971.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17104217220309693.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(5476109416119971.4353)
,p_button_name=>'P32_GO'
,p_button_static_id=>'P32_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17109729518351162.4353)
,p_branch_action=>'32'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17103004407306062.4353)
,p_name=>'P32_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5476109416119971.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('W\00E4hlen Sie den Zeitrahmen f\00FCr die Suche aus.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17103612025308220.4353)
,p_name=>'P32_FLOW'
,p_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5476109416119971.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt die ausgew\00E4hlte Anwendung an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17106013195318054.4353)
,p_name=>'P32_USER'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(5476109416119971.4353)
,p_prompt=>'Benutzer'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FND USERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) d, user_name r',
'from wwv_flow_fnd_user',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Benutzer -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Geben Sie einen Benutzernamen f\00FCr den Bericht an')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_api.create_page(
 p_id=>33.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Workspace-Dashboard'
,p_step_title=>'Workspace-Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47002328518898200.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47002505100900835.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47003323454906127.4353)
,p_name=>'Service'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P33a */',
'    :company workspace_name,',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_files f, wwv_flow_fnd_user u',
' where u.security_group_id = :flow_security_group_id',
'   and u.user_name = :APP_USER',
'   and f.file_type = ''SCRIPT''',
') as sql_scripts,',
'(',
'select count(*)',
'  from wwv_flow_ws_applications ws',
' where ws.security_group_id = :flow_security_group_id',
') as websheets,',
'(',
'select count(*)',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id',
') as schemas,',
'--',
'(select sum(open_requests)',
'from',
'(',
'select count(*) open_requests',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id and',
'      project_status = ''REQUESTED''',
'union all',
'select count(*) open_requests',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      m.request_status = ''REQUESTED''',
') q ) open_requests',
'from dual',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47003528304906129.4353)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace-Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47004106466906132.4353)
,p_query_column_id=>2
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Datenbankanwendungen'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47031110155184041.4353)
,p_query_column_id=>3
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>5
,p_column_heading=>'SQL-Skripts'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47433727639171977.4353)
,p_query_column_id=>4
,p_column_alias=>'WEBSHEETS'
,p_column_display_sequence=>3
,p_column_heading=>'Websheet-Anwendungen'
,p_use_as_row_header=>'N'
,p_report_column_required_role=>wwv_flow_api.id(771323113864288687)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47434208162185271.4353)
,p_query_column_id=>5
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>6
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47469209715848022.4353)
,p_query_column_id=>6
,p_column_alias=>'OPEN_REQUESTS'
,p_column_display_sequence=>7
,p_column_heading=>'Offene Anforderungen'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47023120479007239.4353)
,p_name=>unistr('Verf\00FCgbare Schemas')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P33b */ schema',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47023120479007239.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47024118532016069.4353)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47031617128214415.4353)
,p_name=>'Dateien'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce (',
'           c.max_file_bytes,',
'           to_number(wwv_flow_platform.get_preference(''WORKSPACE_MAX_FILE_BYTES'')) ) max_s,',
'       f.file_types,',
'       f.s,',
'       f.c',
'  from ( select max_file_bytes',
'           from wwv_flow_companies c',
'          where c.provisioning_company_id = :flow_security_group_id ) c,',
'       ( select count(distinct f.file_type) file_types,',
'                sum(f.file_bytes) s,',
'                sum(f.file_count) c',
'           from wwv_flow_company_filestats f',
'          where f.security_group_id=:flow_security_group_id ) f',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47031617128214415.4353)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(620835445096373117.4353)
,p_query_column_id=>1
,p_column_alias=>'MAX_S'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Maximale Dateigr\00F6\00DFe')
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191599015501538189.4353)
,p_query_column_id=>2
,p_column_alias=>'FILE_TYPES'
,p_column_display_sequence=>4
,p_column_heading=>'Dateitypen'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(168480132258259834.4353)
,p_query_column_id=>3
,p_column_alias=>'S'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Gesamtdateigr\00F6\00DFe')
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(168480211187259834.4353)
,p_query_column_id=>4
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'Anzahl Dateien'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47409020218009023.4353)
,p_name=>'Letzte Serviceanforderungen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P33d */',
'    wwv_flow_lang.system_message(''WORKSPACE_REQUEST'') ||'' - ''|| wwv_flow_item.text_from_lov(project_status,''REQUEST_STATUSES'') || '' - ''||',
'    DATABASE_SIZE||''MB'' the_request,',
'    request_date',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''CHANGE_REQUEST'')||'' ''||m.service_name ||'' - ''||wwv_flow_item.text_from_lov(m.request_status,''REQUEST_STATUSES'')||'' - ''||',
'       m.service_attribute_1 the_request,',
'       m.requested_on',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id',
'order by 2 desc '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47409020218009023.4353)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47411608321071843.4353)
,p_query_column_id=>1
,p_column_alias=>'THE_REQUEST'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47411726856071844.4353)
,p_query_column_id=>2
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445571526299029605.4353)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00DCber die Seite "Dashboard" k\00F6nnen Sie Details zum aktuellen Workspace anzeigen und die gesamte Workspace-Aktivit\00E4t \00FCberwachen.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/viewing-workspace-dashboards.html">Weitere Informationen...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47073006110441131.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47002505100900835.4353)
,p_button_name=>'MANAGE_SERVICES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Service verwalten'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168467711714773751.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47002505100900835.4353)
,p_button_name=>'REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Berichtsnutzung'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47003001103900837.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47002505100900835.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47004305924910594.4353)
,p_branch_action=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_api.create_page(
 p_id=>34.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Externe Klicks'
,p_step_title=>'Externe Klicks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215673320866031164)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108236726284086228.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(450803907194232568.4353)
,p_plug_name=>'Externe Klicks'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P34a */ trunc(CLICKDATE) CLICKDATE,category, count(*) c, FLOW_USER',
'from wwv_flow_clickthru_log',
'where clickdate >= (sysdate - :p34_time)',
'group by trunc(CLICKDATE), category, flow_user'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('Sie k\00F6nnen die Anzahl der Mausklicks von einer &PRODUCT_NAME.-Anwendung zu einer externen Site mit der Prozedur APEX_UTIL.COUNT_CLICK oder der Kurzversion "Procedure Z" ermitteln.')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(450804016593232568.4353)
,p_name=>'External Clicks'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450804304300232575.4353)
,p_db_column_name=>'CATEGORY'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Kategorie'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450804530803232577.4353)
,p_db_column_name=>'FLOW_USER'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450804221494232574.4353)
,p_db_column_name=>'CLICKDATE'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Datum'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450804405100232576.4353)
,p_db_column_name=>'C'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Anzahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1107911902280875.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(108236726284086228.4353)
,p_button_name=>'P34_GO'
,p_button_static_id=>'P34_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450806006223244673.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(108236726284086228.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1104019911256897.4353)
,p_branch_action=>'34'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 29-NOV-2002 15:17:50'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1106521121274075.4353)
,p_name=>'P34_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108236726284086228.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, '),
'',
unistr('die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00035
begin
wwv_flow_api.create_page(
 p_id=>35.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Workspace-Meldung'
,p_page_mode=>'MODAL'
,p_step_title=>'Workspace-Meldung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p17_checkdisable()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
'function p17_checkdisable(){ ',
'var ltext_0 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_0''); ',
'var ltext_1 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_1''); ',
'var ltext; ',
'if(ltext_0.checked == true){ltext = ltext_0}else{ltext = ltext_1} ',
'html_DisableOnValue(ltext,''N'',''P17_ACCOUNT_LIFETIME_DAYS'',''P17_USER_MAX_LOGIN_FAILURES'') ',
'} ',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_dialog_height=>'320'
,p_dialog_width=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500'
,p_help_text=>'AEADM/aadmin_wrksp_mess.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173255013158240412.4353)
,p_plug_name=>'Workspace-Meldung'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173255902160240415.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173256329637240416.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(173255902160240415.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173256126055240416.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(173255902160240415.4353)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(173258603234240426.4353)
,p_branch_name=>'Go To Page &LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(173256126055240416.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173255206337240413.4353)
,p_name=>'P35_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(173255013158240412.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nachricht'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select builder_notification_message ',
'from wwv_flow_companies ',
'where PROVISIONING_COMPANY_ID = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>1300
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Geben Sie eine Meldung an, die auf der Workspace-Homepage und der Administrations-Homepage angezeigt wird. Klicken Sie auf <strong>\00C4nderungen anwenden</strong>, um die \00C4nderungen zu speichern.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(173258322158240424.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update WWV_FLOW_COMPANIES',
'   set builder_notification_message = :P35_MESSAGE',
' where PROVISIONING_COMPANY_ID = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Workspace-Meldung kann nicht aktualisiert werden.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(173256126055240416.4353)
,p_process_success_message=>'Workspace-Meldung aktualisiert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(722740953443798637.4353)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Cancel Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(173256329637240416.4353)
);
end;
/
prompt --application/pages/page_00036
begin
wwv_flow_api.create_page(
 p_id=>36.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Sessionzustand'
,p_step_title=>'Sessionzustand'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_sessions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47246122917726657.4353)
,p_plug_name=>'Sessionzustand verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(49193021558761543.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47246327765728122.4353)
,p_plug_name=>'Voreinstellungen verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(49208419658798799.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47262618836980927.4353)
,p_plug_name=>'Sessionzustand'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Der Sessionzustand wird in der Datenbank verwaltet. In diesem Bericht werden die aktuellen Sessions mit Links zu detaillierteren Sessioninformationen angezeigt.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_api.create_page(
 p_id=>37.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Benutzer-Agent'
,p_step_title=>'Seitenansichten pro Benutzer-Agent'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6102001637631613.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10277804766920989.4353)
,p_plug_name=>'Seitenansichten pro Browser'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(',
'select /* APEX4350P37a */count(*) tpv',
'from wwv_flow_activity_log',
'     where security_group_id = :flow_security_group_id ',
'       and page_mode != ''A''',
'       and time_stamp >= sysdate - nvl(:P37_TIME,1)',
')',
'select d.user_agent, d.page_views, 100*d.page_views/tpv pct, round(100*d.page_views/tpv) graph',
'from',
'(',
'select user_agent, sum(the_count) page_views',
'  from',
'   (select session_id, max(substr(nvl(user_agent,'' Unknown''),1,100)) user_agent, count(*) the_count',
'      from wwv_flow_activity_log l',
'     where security_group_id = :flow_security_group_id ',
'       and page_mode != ''A''',
'       and time_stamp >= sysdate - nvl(:P37_TIME,1)',
'     group by session_id)',
' group by user_agent) d, total_page_views'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10277931910920989.4353)
,p_name=>'Page Views by Browser'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10278118066920992.4353)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzer-Agent'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10278213834920993.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10278328204920993.4353)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Prozentsatz'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10278404764920993.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450801327039203398.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6102001637631613.4353)
,p_button_name=>'P37_GO'
,p_button_static_id=>'P37_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(430039324460377116.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(6102001637631613.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:37,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1150113046770141.4353)
,p_branch_action=>'37'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 29-NOV-2002 16:43:22'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1177821232182544.4353)
,p_name=>'P37_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6102001637631613.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_api.create_page(
 p_id=>38.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen pro Anwendung')
,p_step_title=>unistr('Anwendungs\00E4nderungen pro Anwendung')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9853502075969658.4353)
,p_plug_name=>unistr('Anwendungs\00E4nderungen pro Anwendung')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(select /* APEX4350P38a */ count(*) tpv',
'from wwv_flow_builder_audit_trail',
'where security_group_id = :flow_security_group_id',
'and audit_date >= sysdate - nvl(:P38_TIME,1)',
'and flow_id is not null)',
'select ',
'the_link, ',
'application, ',
'(select name from wwv_flows where id = application) application_name,',
'page_views, ',
'100*page_views/tpv pct, ',
'round(100*page_views/tpv) graph,',
'''<div class="hour-graph">''||',
'''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-value"'
||'>''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-value"'
||'>''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-value"'
||'>''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-value"'
||'>''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-value"'
||'>''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-value"'
||'>''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-value"'
||'>''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-value"'
||'>''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-value"'
||'>''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-value"'
||'>''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-value"'
||'>''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-value"'
||'>''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-value"'
||'>''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-value"'
||'>''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-value"'
||'>''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-value"'
||'>''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-value"'
||'>''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-value"'
||'>''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-value"'
||'>''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-value"'
||'>''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-value"'
||'>''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-value"'
||'>''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-value"'
||'>''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-value"'
||'>''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'''</div>'' hours',
'from ',
'(',
'select ''f?p=4350:28:''||:flow_session||''::NO::P28_FLOW,P28_TIME:''||',
'       flow_id||'',''||nvl(:p38_time,''1'') the_link,',
'       flow_id application, ',
'       count(*) page_views,',
'      sum(decode(to_char(audit_date,''HH24''),0,1,0)) h00,',
'      sum(decode(to_char(audit_date,''HH24''),1,1,0)) h01,',
'      sum(decode(to_char(audit_date,''HH24''),2,1,0)) h02,',
'      sum(decode(to_char(audit_date,''HH24''),3,1,0)) h03,',
'      sum(decode(to_char(audit_date,''HH24''),4,1,0)) h04,',
'      sum(decode(to_char(audit_date,''HH24''),5,1,0)) h05,',
'      sum(decode(to_char(audit_date,''HH24''),6,1,0)) h06,',
'      sum(decode(to_char(audit_date,''HH24''),7,1,0)) h07,',
'      sum(decode(to_char(audit_date,''HH24''),8,1,0)) h08,',
'      sum(decode(to_char(audit_date,''HH24''),9,1,0)) h09,',
'      sum(decode(to_char(audit_date,''HH24''),10,1,0)) h10,',
'      sum(decode(to_char(audit_date,''HH24''),11,1,0)) h11,',
'      sum(decode(to_char(audit_date,''HH24''),12,1,0)) h12,',
'      sum(decode(to_char(audit_date,''HH24''),13,1,0)) h13,',
'      sum(decode(to_char(audit_date,''HH24''),14,1,0)) h14,',
'      sum(decode(to_char(audit_date,''HH24''),15,1,0)) h15,',
'      sum(decode(to_char(audit_date,''HH24''),16,1,0)) h16,',
'      sum(decode(to_char(audit_date,''HH24''),17,1,0)) h17,',
'      sum(decode(to_char(audit_date,''HH24''),18,1,0)) h18,',
'      sum(decode(to_char(audit_date,''HH24''),19,1,0)) h19,',
'      sum(decode(to_char(audit_date,''HH24''),20,1,0)) h20,',
'      sum(decode(to_char(audit_date,''HH24''),21,1,0)) h21,',
'      sum(decode(to_char(audit_date,''HH24''),22,1,0)) h22,',
'      sum(decode(to_char(audit_date,''HH24''),23,1,0)) h23',
'from wwv_flow_builder_audit_trail',
'where security_group_id = :flow_security_group_id',
'and audit_date >= sysdate - nvl(:P38_TIME,1)',
'and flow_id is not null',
'group by  ''f?p=4350:28:''||:flow_session||''::NO::P28_FLOW,P28_TIME:''||',
'       flow_id||'',''||nvl(:p38_time,''1''), flow_id',
') pv, total_page_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.APPCHANGES'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9853630321969658.4353)
,p_name=>'Application Changes by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9853807298969667.4353)
,p_db_column_name=>'THE_LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Der Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9853905207969668.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1122614471336989.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9854011889969668.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>unistr('Komponenten\00E4nderungen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9854115048969668.4353)
,p_db_column_name=>'PCT'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Prozentsatz'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9854212253969668.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760555978034323226.4353)
,p_db_column_name=>'HOURS'
,p_display_order=>16
,p_column_identifier=>'G'
,p_column_label=>unistr('Aktivit\00E4t pro Stunde')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20163722246444952.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450749324578549892.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20163722246444952.4353)
,p_button_name=>'P38_GO'
,p_button_static_id=>'P38_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450749502892553117.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20163722246444952.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1169219720138463.4353)
,p_branch_action=>'38'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 29-NOV-2002 17:44:45'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1171000407148095.4353)
,p_name=>'P38_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20163722246444952.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_api.create_page(
 p_id=>39.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Benutzer und Stunde'
,p_step_title=>'Seitenansichten pro Benutzer und Stunde'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1765984845471296621.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1770111936432894216.4353)
,p_plug_name=>'Seitenansichten pro Benutzer pro Stunde'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select the_day,',
'       developer, ',
'       page_events,',
'       applications,',
'      ''<div class="hour-graph">''||',
'      ''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-'
||'value">''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-'
||'value">''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-'
||'value">''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-'
||'value">''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-'
||'value">''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-'
||'value">''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-'
||'value">''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-'
||'value">''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-'
||'value">''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-'
||'value">''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-'
||'value">''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-'
||'value">''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-'
||'value">''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-'
||'value">''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-'
||'value">''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-'
||'value">''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-'
||'value">''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-'
||'value">''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-'
||'value">''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-'
||'value">''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-'
||'value">''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-'
||'value">''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-'
||'value">''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-'
||'value">''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'      ''</div>'' hours',
'from',
'(',
'select ',
'       upper(USERID) developer,',
'       trunc(time_stamp) the_day,',
'       count(*) page_events,',
'       count(distinct(flow_id||''.''||step_id)) pages,',
'       count(distinct(flow_id)) applications,',
'      sum(decode(to_char(time_stamp,''HH24''),0,1,0)) h00,',
'      sum(decode(to_char(time_stamp,''HH24''),1,1,0)) h01,',
'      sum(decode(to_char(time_stamp,''HH24''),2,1,0)) h02,',
'      sum(decode(to_char(time_stamp,''HH24''),3,1,0)) h03,',
'      sum(decode(to_char(time_stamp,''HH24''),4,1,0)) h04,',
'      sum(decode(to_char(time_stamp,''HH24''),5,1,0)) h05,',
'      sum(decode(to_char(time_stamp,''HH24''),6,1,0)) h06,',
'      sum(decode(to_char(time_stamp,''HH24''),7,1,0)) h07,',
'      sum(decode(to_char(time_stamp,''HH24''),8,1,0)) h08,',
'      sum(decode(to_char(time_stamp,''HH24''),9,1,0)) h09,',
'      sum(decode(to_char(time_stamp,''HH24''),10,1,0)) h10,',
'      sum(decode(to_char(time_stamp,''HH24''),11,1,0)) h11,',
'      sum(decode(to_char(time_stamp,''HH24''),12,1,0)) h12,',
'      sum(decode(to_char(time_stamp,''HH24''),13,1,0)) h13,',
'      sum(decode(to_char(time_stamp,''HH24''),14,1,0)) h14,',
'      sum(decode(to_char(time_stamp,''HH24''),15,1,0)) h15,',
'      sum(decode(to_char(time_stamp,''HH24''),16,1,0)) h16,',
'      sum(decode(to_char(time_stamp,''HH24''),17,1,0)) h17,',
'      sum(decode(to_char(time_stamp,''HH24''),18,1,0)) h18,',
'      sum(decode(to_char(time_stamp,''HH24''),19,1,0)) h19,',
'      sum(decode(to_char(time_stamp,''HH24''),20,1,0)) h20,',
'      sum(decode(to_char(time_stamp,''HH24''),21,1,0)) h21,',
'      sum(decode(to_char(time_stamp,''HH24''),22,1,0)) h22,',
'      sum(decode(to_char(time_stamp,''HH24''),23,1,0)) h23',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P39_DATE and',
'      security_group_id = :flow_security_group_id and',
'      userid is not null',
'group by upper(USERID), trunc(time_stamp)',
') pv,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1770112042012894216.4353)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1770112042012894216
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(756684479750357824.4353)
,p_db_column_name=>'THE_DAY'
,p_display_order=>10
,p_column_identifier=>'V'
,p_column_label=>'Tag'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760807004141431322.4353)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760807896667431323.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760810192721431327.4353)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1760814568114431332.4353)
,p_db_column_name=>'HOURS'
,p_display_order=>90
,p_column_identifier=>'U'
,p_column_label=>unistr('Aktivit\00E4t pro Stunde')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1760805001689431312.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1765984845471296621.4353)
,p_button_name=>'P39_SET'
,p_button_static_id=>'P25_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1760805403925431313.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1765984845471296621.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:25,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1760815757934431336.4353)
,p_branch_action=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1760805852429431314.4353)
,p_name=>'P39_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1765984845471296621.4353)
,p_item_default=>'to_number(.125)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, '),
'',
unistr('die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_api.create_page(
 p_id=>40.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Sessiondetails'
,p_step_title=>'Sessiondetails'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_purge_session.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1187818640219648.4353)
,p_name=>'Sessioninformation'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.ID,',
'       s.cookie_value,',
'       s.CREATED_ON,',
'       s.username,',
'       s.ON_NEW_INSTANCE_FIRED_FOR, ',
'       s.idle_timeout_on,',
'       s.life_timeout_on,',
'       s.SECURITY_GROUP_ID,',
'       c.short_name',
'  from WWV_FLOW_SESSIONS$ s,',
'       wwv_flow_companies c',
'where s.security_group_id = c.provisioning_company_id',
'  and s.id = :P40_SESSION_ID'))
,p_display_when_condition=>'P40_SESSION_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Session nicht gefunden.'
,p_query_num_rows_type=>'COMPUTED_BUT_NOT_DISPLAYED'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48590718591771072.4353)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Session'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(89507316220587728.4353)
,p_query_column_id=>2
,p_column_alias=>'COOKIE_VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Cookiewert'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48591007320771072.4353)
,p_query_column_id=>3
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>2
,p_column_heading=>'Erstellt'
,p_use_as_row_header=>'N'
,p_column_format=>'Day &DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(89507410079587728.4353)
,p_query_column_id=>4
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>6
,p_column_heading=>'Benutzername'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48591227385771073.4353)
,p_query_column_id=>5
,p_column_alias=>'ON_NEW_INSTANCE_FIRED_FOR'
,p_column_display_sequence=>3
,p_column_heading=>'Besuchte Anwendungen'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(89507515994587728.4353)
,p_query_column_id=>6
,p_column_alias=>'IDLE_TIMEOUT_ON'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Inaktivit\00E4tstimeout ein')
,p_use_as_row_header=>'N'
,p_column_format=>'Day &DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(89507616997587729.4353)
,p_query_column_id=>7
,p_column_alias=>'LIFE_TIMEOUT_ON'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Aktivit\00E4tstimeout ein')
,p_use_as_row_header=>'N'
,p_column_format=>'Day &DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48591516713771073.4353)
,p_query_column_id=>8
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(89507728617587729.4353)
,p_query_column_id=>9
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Kurzname'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1274829139181317.4353)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22439802147847987.4353)
,p_plug_name=>'Sessionzustand'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_name,',
'       data_item_id   item_id,',
'       application_id flow_id,',
'       application_name,',
'       page_id,',
'       item_value,',
'       session_state_status',
'  from wwv_flow_data_view',
' where session_id        = :P40_SESSION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(22439916909847987.4353)
,p_name=>'Session State'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22440113334847990.4353)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Elementname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22440227904847990.4353)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Element'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22440630720847991.4353)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Status'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22440313394847991.4353)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22440505071847991.4353)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Wert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22441729952871920.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22443011776904530.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1272927622171455.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1274829139181317.4353)
,p_button_name=>'P40_GO'
,p_button_static_id=>'P40_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452210802432972277.4353)
,p_button_sequence=>12
,p_button_plug_id=>wwv_flow_api.id(1274829139181317.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1567803922839518.4353)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(1187818640219648.4353)
,p_button_name=>'DELETE_STATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Zustand entfernen'
,p_button_position=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1576114883908923.4353)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(1187818640219648.4353)
,p_button_name=>'REMOVE_SESSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Session entfernen'
,p_button_position=>'DELETE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_user    varchar2(256);',
'  l_session varchar2(256);',
'  l_sgid    number;',
'begin',
'  wwv_flow_security.session_cookie_info_internal(',
'    p_user    => l_user,',
'    p_session => l_session,',
'    p_sgid    => l_sgid);',
'  if :P40_SESSION_ID in (:FLOW_SESSION, l_session) then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(780817511296213041.4353)
,p_branch_action=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1576114883908923.4353)
,p_branch_sequence=>5
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1275500873182590.4353)
,p_branch_action=>'40'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1272319311168970.4353)
,p_name=>'P40_SESSION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1274829139181317.4353)
,p_prompt=>'Session'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' - ''||',
'       nvl(wwv_flow_escape.html(username),',
'           wwv_flow_lang.system_message(''NULL_IN_PAREN'')) a,',
'       id',
'from wwv_flow_sessions$ where security_group_id = :flow_security_group_id ',
'order by created_on desc'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Geben Sie an, welche Session angezeigt werden soll'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1283615080262379.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1570021715854150.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete state'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id from wwv_flow_sessions$ where id = :P40_SESSION_ID and security_group_id = :flow_security_group_id) loop',
'   delete from wwv_flow_data where FLOW_INSTANCE = c1.id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim Entfernen des Sessionzustands f\00FCr &P40_SESSION_ID..')
,p_process_when_button_id=>wwv_flow_api.id(1567803922839518.4353)
,p_process_success_message=>unistr('Sessionzustand f\00FCr &P40_SESSION_ID. wurde entfernt.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1577101161914367.4353)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'removme session'
,p_process_sql_clob=>'delete from wwv_flow_sessions$ where id = :P40_SESSION_ID and security_group_id = :flow_security_group_id'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Entfernen von Session.'
,p_process_when_button_id=>wwv_flow_api.id(1576114883908923.4353)
,p_process_success_message=>'Session wurde entfernt.'
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_api.create_page(
 p_id=>41.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Erstellstatus f\00FCr die Anwendung')
,p_step_title=>unistr('Erstellstatus f\00FCr die Anwendung')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_build_status.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(127686007289679931.4353)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452282817862712315.4353)
,p_plug_name=>'Anwendungen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, build_status, ',
'       apex_item.select_list_from_lov(1, build_status,',
'             ''APPLICATION_BUILD_STATUS'',null,''NO'',''%null%'',''%'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''STATUS_LABEL'',name)) || ',
'              apex_item.hidden(2,id) build_status2,',
'       flow_status,',
'       apex_item.select_list_from_lov(3,flow_status,',
'             ''LIST_FLOW_STATUS'',''NO'',''%null%'',''%'', ''f''||lpad(''''||3,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''BUILD_STATUS_LABEL'',name)) flow_status2,',
'       id app_id, LAST_UPDATED_ON,',
'       decode(group_id,null,null,',
'             (select max(group_name) n ',
'                from wwv_flow_application_groups ',
'               where id = f.group_id)) Groupname',
'  from wwv_flow_visible_flows f',
' where build_status <> ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(452282915693712315.4353)
,p_name=>'Run Only Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452283126086712535.4353)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Anwendung'
,p_column_link=>'f?p=4000:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452283207040712537.4353)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452283304109712538.4353)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Erstellstatus'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452283409354712539.4353)
,p_db_column_name=>'APP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'App_Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452283624250712541.4353)
,p_db_column_name=>'GROUPNAME'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Gruppe'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452283526289712540.4353)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452308503310136246.4353)
,p_db_column_name=>'BUILD_STATUS2'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Erstellstatus'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(128034726363912582)
,p_rpt_show_filter_lov=>'2'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(473822112480267445.4353)
,p_db_column_name=>'FLOW_STATUS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Ablaufstatus'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(473822218842267449.4353)
,p_db_column_name=>'FLOW_STATUS2'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Status'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(473904019503385140)
,p_rpt_show_filter_lov=>'2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452408919099755753.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(127686007289679931.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(127887103676868191.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(127686007289679931.4353)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(127687732181683054.4353)
,p_branch_action=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(128174803123953163.4353)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update build status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_id            number;',
'   l_build_status  varchar2(255);',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_build_status := wwv_flow.g_f01(i);',
'  if l_build_status in (''RUN_AND_BUILD'',''RUN_ONLY'') then',
'  update wwv_flows',
'  set build_status = l_build_status',
'  where id = l_id and',
'        security_group_id = :flow_security_group_id and',
'        build_status != nvl(l_build_status,''x'') and',
'        build_status is not null;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(127887103676868191.4353)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0; l_id number; l_build_status varchar2(255);',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_build_status := wwv_flow.g_f01(i);',
'  if l_build_status in (''RUN_AND_BUILD'',''RUN_ONLY'') then',
'  for c1 in (select 1 from wwv_flows where id = l_id and',
'             security_group_id = :flow_security_group_id and',
'             build_status != nvl(l_build_status,''x'') and',
'             build_status is not null) loop',
'    c := c + 1;',
'   end loop;',
'  end if;',
'end loop;',
'if c > 0 then return true;',
'else',
'  return false;',
'end if;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Aktion wurde verarbeitet'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(473866102315330737.4353)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_id            number;',
'   l_flow_status   varchar2(30);',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_flow_status := wwv_flow.g_f03(i);',
'  update wwv_flows',
'  set flow_status = l_flow_status',
'  where id = l_id',
'    and security_group_id = :flow_security_group_id',
'    and l_flow_status != flow_status;',
'end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(127887103676868191.4353)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0; l_id number; l_flow_status varchar2(30);',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_flow_status := wwv_flow.g_f03(i);',
'  for c1 in (select 1 from wwv_flows where id = l_id and',
'             security_group_id = :flow_security_group_id and',
'             l_flow_status != flow_status) loop',
'    c := c + 1;',
'   end loop;',
'end loop;',
'if c > 0 then return true;',
'else',
'  return false;',
'end if;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Aktion wurde verarbeitet'
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_api.create_page(
 p_id=>42.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen, detailliert')
,p_step_title=>unistr('Anwendungs\00E4nderungen, detailliert')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9858324202065705.4353)
,p_plug_name=>unistr('Entwickleraktivit\00E4t pro Benutzer')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P42a */',
'  t.flow_user tu, ',
'  t.flow_id flow,',
'  (select name from wwv_flows where id = t.flow_id) application_name,',
'  t.page_id page, ',
'  (select name from wwv_flow_steps where id = t.page_id and flow_id = t.flow_id) page_name,',
'  t.audit_date d,',
'  initcap(',
'  replace(replace(replace(replace(replace(replace(replace(',
'  replace(replace(replace(replace(replace(replace(t.flow_table,',
'     ''LIST_ITEMS'',''List Entry''),',
'     ''WWV_FLOWS'',''Application''),',
'     ''WWV_FLOW_'',null),''_'','' ''),',
'     ''FLOW'',''Application''),',
'     ''SECURITY SCHEMES'',''Authorization Scheme''),',
'     ''LOAD TABLES'',''Data Loading''),',
'     ''PLUGINS'',''Plug-in''),',
'     ''STEP'',''Page''),',
'     ''PLUG'',''Region''),',
'     ''OPTION'',''Entry''),',
'     ''MESSAGES$'',''Text Message''),',
'     ''MENU'',''Breadcrumb'')',
'  ) flow_table,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) c,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK,',
'  t.flow_table apex_table_name,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'  ',
'where  ',
'  t.audit_date >= (sysdate - nvl(:P42_TIME,1)) and',
'  t.security_group_id = :flow_security_group_id and',
'  (nvl(:P42_APPLICATION,0) = 0 or t.flow_id = :P42_APPLICATION)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9858405979065705.4353)
,p_name=>'Developer Activity by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9858700866065713.4353)
,p_db_column_name=>'FLOW'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9858924570065714.4353)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Seite'
,p_column_link=>'f?p=4000:4500:#FLOW_SESSION#::::FB_FLOW_ID,FB_FLOW_PAGE_ID:#FLOW#,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9859110322065715.4353)
,p_db_column_name=>'D'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Datum'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9859217381065715.4353)
,p_db_column_name=>'FLOW_TABLE'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>'Komponente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9859327325065715.4353)
,p_db_column_name=>'C'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>'Aktion'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9858604039065713.4353)
,p_db_column_name=>'TU'
,p_display_order=>6
,p_column_identifier=>'A'
,p_column_label=>'Entwickler'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9858808008065713.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>7
,p_column_identifier=>'C'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9859015957065715.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>8
,p_column_identifier=>'E'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47724708709734627.4353)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47724826781734634.4353)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Auditkommentar'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47725028102740289.4353)
,p_db_column_name=>'FLOW_TABLE_PK'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Komponentenschl\00FCssel')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47725222000747936.4353)
,p_db_column_name=>'APEX_TABLE_NAME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'APEX-Tabellenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47725407024762510.4353)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Komponentenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(265571819175286412.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450751510988564840.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(265571819175286412.4353)
,p_button_name=>'P42_SET'
,p_button_static_id=>'P42_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47704400763533648.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(265571819175286412.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17183729171655135.4353)
,p_branch_action=>'42'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17177809301639896.4353)
,p_name=>'P42_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(265571819175286412.4353)
,p_item_default=>'1'
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Zeitrahmen f\00FCr die Suche aus.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47689130789409845.4353)
,p_name=>'P42_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(265571819175286412.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_api.create_page(
 p_id=>43.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Aktuelle Sessions'
,p_step_title=>'Aktuelle Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_help_text=>'AEADM/aadm_purge_session.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1267303896126727.4353)
,p_plug_name=>'Sessions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Der Sessionzustand wird in der Datenbank verwaltet. In diesem Bericht werden die aktuellen Sessions mit Links zu detaillierteren Sessioninformationen angezeigt.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10291912967175450.4353)
,p_plug_name=>'Aktuelle Sessions'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="f?p=&FLOW_ID.:40:''||:FLOW_SESSION||'':::40:P40_SESSION_ID:''||s.ID||''">''||s.ID||''</a>'' ID,',
'    s.username,',
'    s.created_on,',
'    s.created_on s,',
'    s.on_new_instance_fired_for,',
'    s.security_group_id,',
'    s.idle_timeout_on,',
'    s.life_timeout_on,',
'    s.remote_addr,',
'    c.short_name',
'from WWV_FLOW_SESSIONS$ s,',
'     wwv_flow_companies c',
'where s.security_group_id = c.provisioning_company_id',
'  and s.security_group_id = :flow_security_group_id',
'  and s.created_on >= sysdate - nvl(:p43_time,1)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10292026503175450.4353)
,p_name=>'Recent Sessions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10292209368175460.4353)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Session'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10292410662175460.4353)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Erstellungsdatum'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10292530731175461.4353)
,p_db_column_name=>'S'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Erstellung'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10292616396175461.4353)
,p_db_column_name=>'ON_NEW_INSTANCE_FIRED_FOR'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Neue Instanz'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10292716393175461.4353)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(89509122031600248.4353)
,p_db_column_name=>'USERNAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Benutzername'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(89509328057612571.4353)
,p_db_column_name=>'IDLE_TIMEOUT_ON'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Inaktivit\00E4tstimeout ein')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(89509425220612571.4353)
,p_db_column_name=>'LIFE_TIMEOUT_ON'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Aktivit\00E4tstimeout ein')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(89509510547612571.4353)
,p_db_column_name=>'REMOTE_ADDR'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Remote-Adr.'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(89509626443612572.4353)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Kurzname'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(122208606764133208.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452206030436952008.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(122208606764133208.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1252821901052158.4353)
,p_branch_action=>'43'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1258011898081713.4353)
,p_name=>'P43_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(122208606764133208.4353)
,p_prompt=>'Anzeigen'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_api.create_page(
 p_id=>44.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Voreinstellungen pro Benutzer'
,p_step_title=>'Voreinstellungen pro Benutzer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_help_text=>'AEADM/aadm_user_pref.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10339007894846227.4353)
,p_plug_name=>'Voreinstellungen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_id, preference_name, attribute_value, security_group_id,',
'   preference_type, application',
'from (',
'select ',
'    user_id,',
'    preference_name,',
'    attribute_value,',
'    security_group_id,',
'    decode(substr(attribute_value,1,8),''fsp_sort'',''SORT'',',
'    decode(substr(preference_name,1,16),''PERSISTENT_ITEM_'',''ITEM'',',
'    decode(substr(preference_name,1,3),''FSP'',',
'    decode(substr(preference_name,length(preference_name)-4,5),''_SORT'',''SORT'',''OTHER''),',
'    ''OTHER''))) preference_type,',
'    decode(substr(preference_name,1,3),',
'        ''FSP'',',
'        decode(instr(preference_name,''_''),0,null,substr(preference_name,4,instr(preference_name,''_'')-4)),',
'        null',
'         ) application',
'from WWV_FLOW_PREFERENCES$',
'where security_group_id = :flow_security_group_id',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10339121225846227.4353)
,p_name=>'Preferences'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10339300770846234.4353)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10339410084846235.4353)
,p_db_column_name=>'PREFERENCE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10339532428846235.4353)
,p_db_column_name=>'ATTRIBUTE_VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Wert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10339607085846235.4353)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10339714191846235.4353)
,p_db_column_name=>'PREFERENCE_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Voreinstellungstyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10339819416846235.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Anwendung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452411127803786608.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10339007894846227.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1587125578000668.4353)
,p_branch_action=>'44'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_api.create_page(
 p_id=>45.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Sessions l\00F6schen')
,p_step_title=>unistr('Sessions l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_help_text=>'AEADM/aadm_purge_session.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1615024869157863.4353)
,p_plug_name=>unistr('Sessions l\00F6schen')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_sessions_count pls_integer := 0;',
'   l_old_sessions pls_integer := 0;',
'   l_users pls_integer := 0;',
'begin',
'for c1 in (select count(*) c , count(distinct username) u',
'           from wwv_flow_sessions$ ',
'           where security_group_id = :flow_security_group_id) loop',
'   l_sessions_count := c1.c;',
'   l_users := c1.u;',
'end loop;',
'for c1 in (select count(*) c',
'           from wwv_flow_sessions$ ',
'           where security_group_id = :flow_security_group_id and',
'                 created_on <= (sysdate - nvl(:p45_time,1)) ) loop',
'           l_old_sessions := c1.c;',
'end loop; ',
'sys.htp.p(''<ul>'');',
'--sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_TOTAL_SESSIONS'',:company,l_sessions_count)||''</li>'');',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_TOTAL_SESSIONS2'',to_char(l_sessions_count,''999G999G999G999G990''))||''</li>'');',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_DISTINCT_USERS'',l_users)||''</li>'');',
'if :p45_time >=1 then',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_SESSIONS_OLDER_THAN'',:p45_time,l_old_sessions)||''</li>'');',
'else',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_SESSIONS_OLDER_THAN_MINS'',round(:p45_time*24*60,3),l_old_sessions)||''</li>'');',
'end if;',
'sys.htp.p(''</ul>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>'Sessions werden verwendet, um den Benutzerzustand zu verwalten.<p />'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6896421131024683.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1615024869157863.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1613502921141984.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1615024869157863.4353)
,p_button_name=>'REPORT_SESSIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Sessions melden'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1609312917116469.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1615024869157863.4353)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Sessions l\00F6schen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1610017072117764.4353)
,p_branch_action=>'45'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1608603220113714.4353)
,p_name=>'P45_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1615024869157863.4353)
,p_prompt=>unistr('Sessions, die \00E4lter sind als:')
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(107534131274292840.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie ein Datum an, ab dem die Sessiondaten gel\00F6scht werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1624325664290467.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge sessions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_user    varchar2(256);',
'  l_session varchar2(256);',
'  l_sgid    number;',
'begin',
'  wwv_flow_security.session_cookie_info_internal(',
'    p_user    => l_user,',
'    p_session => l_session,',
'    p_sgid    => l_sgid);',
'  delete from wwv_flow_sessions$',
'  where',
'    security_group_id = :flow_security_group_id and',
'    created_on <= (sysdate - nvl(:P45_TIME,1)) and',
'    id not in (:FLOW_SESSION, l_session);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Entfernen von Sessions.'
,p_process_when_button_id=>wwv_flow_api.id(1609312917116469.4353)
,p_process_success_message=>'Sessions wurden entfernt.'
);
end;
/
prompt --application/pages/page_00046
begin
wwv_flow_api.create_page(
 p_id=>46.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Voreinstellungen l\00F6schen')
,p_step_title=>unistr('Voreinstellungen l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215469304188572178)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_help_text=>'AEADM/aadm_user_pref.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1689606689991219.4353)
,p_plug_name=>unistr('Voreinstellungen l\00F6schen')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in (select count(*) c, count(distinct user_id) u',
'  from WWV_FLOW_PREFERENCES$',
'  where security_group_id = :flow_security_group_id) loop',
'  sys.htp.p(''<strong>''||wwv_flow_lang.system_message(''F4350_SUMMARY'')||''</strong><br>''||',
'--wwv_flow_lang.system_message(''F4350_PREFS_EXISTS_FOR'',c1.c,c1.u,:company));',
'wwv_flow_lang.system_message(''F4350_PREFS_EXISTS_FOR2'',c1.c,c1.u));',
'  end loop;',
'  sys.htp.p(''<br>&nbsp;<br><strong>''|| wwv_flow_lang.system_message(''F4350_SELECTED_USER'') ||''</strong><br>'');',
'  if :P46_USER is null then',
'    sys.htp.p( wwv_flow_lang.system_message(''F4350_NO_USER_SELECTED'')||''<p />'');',
'  else',
'    for c1 in (select count(*) c',
'  from WWV_FLOW_PREFERENCES$',
'  where security_group_id = :flow_security_group_id and ',
'        user_id = upper(:p46_user) ) loop',
'      sys.htp.p(wwv_flow_lang.system_message(''F4350_USER_HAS_X_PREFS'',wwv_flow_escape.html(:p46_user),c1.c));',
'',
'  end loop;',
'  end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1690324697996432.4353)
,p_plug_name=>'Voreinstellungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Bei Voreinstellungen wird der Zustand pro Benutzer verwaltet. Sie k\00F6nnen mehrere Sessions umfassen. Voreinstellungen k\00F6nnen gel\00F6scht werden, nachdem ein Benutzer eingegeben wurde.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1698306052095099.4353)
,p_name=>'User Preferences'
,p_template=>wwv_flow_api.id(388531674152470979.4353)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    user_id,',
'    preference_name,',
'    attribute_value,',
'    security_group_id',
'from WWV_FLOW_PREFERENCES$',
'where security_group_id = :flow_security_group_id and',
'      user_id = upper(:p46_user)',
'order by preference_name'))
,p_display_when_condition=>'P46_USER'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(6659715068668103.4353)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Es wurden keine Voreinstellungen gefunden.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48848318967772537.4353)
,p_query_column_id=>1
,p_column_alias=>'USER_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzer'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48848426607772537.4353)
,p_query_column_id=>2
,p_column_alias=>'PREFERENCE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Voreinstellung'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48848523057772537.4353)
,p_query_column_id=>3
,p_column_alias=>'ATTRIBUTE_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Wert'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48848615680772537.4353)
,p_query_column_id=>4
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1702529517120847.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1689606689991219.4353)
,p_button_name=>'PURGE_USER_PREFERENCES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Benutzervoreinstellungen l\00F6schen')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct user_id d',
'  from WWV_FLOW_PREFERENCES$',
' where security_group_id = :flow_security_group_id',
'   and user_id = upper(:P46_USER)'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1693208121019989.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1689606689991219.4353)
,p_button_name=>'REPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Bericht'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6893815805013744.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1689606689991219.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1691215477003220.4353)
,p_branch_action=>'46'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1692011107011376.4353)
,p_name=>'P46_USER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1689606689991219.4353)
,p_prompt=>'Benutzer'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct user_id d, user_id v',
'  from WWV_FLOW_PREFERENCES$',
' where security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie einen Benutzer an, f\00FCr den Voreinstellungen gel\00F6scht werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(46075113198002110.4353)
,p_validation_name=>'user valid'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct user_id d',
'  from WWV_FLOW_PREFERENCES$',
' where security_group_id = :flow_security_group_id',
'   and user_id = upper(:P46_USER)'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Benutzer ist nicht vorhanden oder verf\00FCgt \00FCber keine Voreinstellungen.')
,p_validation_condition=>'P46_USER'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(1693208121019989.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1704030340130527.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge preferences for user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete ',
'from WWV_FLOW_PREFERENCES$',
'where security_group_id = :flow_security_group_id and',
'      user_id = upper(:p46_user)'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim L\00F6schen der Voreinstellungen f\00FCr den Benutzer &P46_USER..')
,p_process_when_button_id=>wwv_flow_api.id(1702529517120847.4353)
,p_process_success_message=>unistr('Die Voreinstellungen f\00FCr den Benutzer &P46_USER. wurden gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1713702598169784.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(1693208121019989.4353)
);
end;
/
prompt --application/pages/page_00047
begin
wwv_flow_api.create_page(
 p_id=>47.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Anwendungscache'
,p_step_title=>'Anwendungscache'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_help_text=>'AEADM/aadmn_mg_cache.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47247130666738439.4353)
,p_plug_name=>'Anwendungscache verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(41424809053067534.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
);
end;
/
prompt --application/pages/page_00048
begin
wwv_flow_api.create_page(
 p_id=>48.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Datenbankschema anfordern - Anforderung definieren'
,p_step_title=>'Datenbankschema anfordern - Anforderung definieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1993922974139464.4353)
,p_plug_name=>'Schema angeben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>'');',
'sys.htp.p(wwv_flow_lang.system_message(''F4350_WORKSPACE_SCHEMAS'')||'':<strong>'');',
'for c1 in (select schema',
'           from wwv_flow_company_schemas',
'           where security_group_id=:flow_security_group_id',
'           order by schema) loop',
'   sys.htp.p (wwv_flow_escape.html(c1.schema));',
'end loop;',
'sys.htp.p(''</strong>'');',
'sys.htp.p(''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<input type="text" style="display:none;" />'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32643316621230690.4353)
,p_plug_name=>'request schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47297014014256767.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208559426831334965.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113506440695874.4353)
,p_plug_name=>'Datenbankschema anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168313623258767902.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208559426831334965.4353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2006525707187473.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208559426831334965.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2009011986193021.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208559426831334965.4353)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(245533631539678851.4353)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':SR_NAME is null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(245526615721532377.4353)
,p_branch_action=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2009011986193021.4353)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12199828843371901.4353)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2010524107196472.4353)
,p_name=>'SR_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1993922974139464.4353)
,p_prompt=>'Schemaname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Geben Sie den Namen eines vorhandenen Schemas ein, das dem Workspace zugewiesen werden soll. Sie k\00F6nnen auch den Namen eines neuen Schemas eingeben, das erstellt und dem Workspace zugewiesen werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(245498531773120633.4353)
,p_name=>'P48_NEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1993922974139464.4353)
,p_item_default=>'YES'
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NEW_OR_EXISTING_SCHEMA'
,p_lov=>'.'||wwv_flow_api.id(245496725063109254.4353)||'.'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Erstellen Sie ein neues Schema, oder fordern Sie Workspace-Zugriff f\00FCr ein vorhandenes Schema an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246260024880572305.4353)
,p_computation_sequence=>10
,p_computation_item=>'SR_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:SR_NAME)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2013003459199990.4353)
,p_validation_name=>'schema name not null'
,p_validation_sequence=>10
,p_validation=>'SR_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Der Schemaname muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-DEC-2002 12:35'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2014803590209500.4353)
,p_validation_name=>'no spaces'
,p_validation_sequence=>20
,p_validation=>'SR_NAME'
,p_validation_type=>'ITEM_CONTAINS_NO_SPACES'
,p_error_message=>'Der Schemaname darf keine Leerzeichen enthalten.'
,p_validation_condition=>'SR_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245516700774423917.4353)
,p_validation_name=>'no quotes in name'
,p_validation_sequence=>30
,p_validation=>'instr(:SR_NAME,'''''''')+instr(:SR_NAME,''"'') = 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Der Schemaname darf keine Anf\00FChrungszeichen enthalten.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P48_NEW = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245518314411437321.4353)
,p_validation_name=>'schema name valid'
,p_validation_sequence=>40
,p_validation=>'wwv_flow_utilities.is_valid_identifier(:SR_NAME)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Der Schemaname ist keine g\00FCltige Oracle-Bezeichnung.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P48_NEW = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245514313063389629.4353)
,p_validation_name=>'schema exists'
,p_validation_sequence=>50
,p_validation=>'select null from sys.all_users where username = upper(:SR_NAME)'
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Ung\00FCltiges Schema')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P48_NEW = ''NO'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245519627009450426.4353)
,p_validation_name=>'new schema does not exist'
,p_validation_sequence=>60
,p_validation=>'select 1 from sys.dba_users where username = upper(:SR_NAME)'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ung\00FCltiges Schema')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P48_NEW = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245520630949461024.4353)
,p_validation_name=>'new schema not a role'
,p_validation_sequence=>70
,p_validation=>'select null from sys.dba_roles where role = upper(:SR_NAME)'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ung\00FCltiges Schema')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P48_NEW = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245521603161471970.4353)
,p_validation_name=>'schema is not restricted when admin is restricted'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provision.schema_name_valid(',
'    p_schema            => :SR_NAME,',
'    p_workspace_name    =>  wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Schema ist reserviert oder eingeschr\00E4nkt')
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245526022863524970.4353)
,p_validation_name=>'new schema not used in existing workspace'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_company_schemas ',
'where schema = upper(:SR_NAME)',
'and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ung\00FCltiges Schema')
,p_validation_condition=>'SR_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(2009011986193021.4353)
,p_associated_item=>wwv_flow_api.id(2010524107196472.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00049
begin
wwv_flow_api.create_page(
 p_id=>49.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Speicherung anfordern - Anforderung definieren'
,p_step_title=>'Speicherung anfordern - Anforderung definieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47296413190247132.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(47296115483238304.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47297500292262313.4353)
,p_plug_name=>'Train'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47297014014256767.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(100110829319376668.4353)
,p_plug_name=>'Speicherplatz anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208563318782351569.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113628692695875.4353)
,p_plug_name=>'Speicherplatz anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2032017105289086.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208563318782351569.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2032705116295146.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208563318782351569.4353)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168281130581997999.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208563318782351569.4353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(916968811824940971.4353)
,p_branch_action=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2032705116295146.4353)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2030628749283010.4353)
,p_name=>'P49_STORAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(100110829319376668.4353)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''C''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Hinzuzuf\00FCgende Speicherkapazit\00E4t (MB):')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
' order by to_number(d)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den hinzuzuf\00FCgenden Speicherplatz an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(19387910105227426.4353)
,p_validation_name=>'Validate storage request size'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
'   and req_size = :P49_STORAGE'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Ung\00FCltige Speicherkapazit\00E4t angefordert.')
,p_when_button_pressed=>wwv_flow_api.id(2032705116295146.4353)
,p_associated_item=>wwv_flow_api.id(2030628749283010.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(663453485838166125.4353)
,p_validation_name=>'Check Max Storage Request'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_storage       number;',
'    l_max_storage   constant number := to_number(wwv_flow_platform.get_preference(''MAX_WKSP_STORAGE_REQ_MB''));',
'begin',
'',
'    select sum(s.database_size) total_storage into l_storage',
'      from (select database_size ',
'              from wwv_flow_provision_company ',
'             where security_group_id = :flow_security_group_id',
'             union all ',
'            select to_number(service_attribute_1) database_size ',
'              from wwv_flow_provision_serice_mod ',
'             where service_name = ''CHANGE_DB_SIZE'' ',
'               and request_status != ''DECLINED'' ',
'               and security_group_id = :flow_security_group_id ) s;',
'',
'    l_storage := l_storage + to_number(:P49_STORAGE);',
'',
'    if l_storage > l_max_storage then',
'        return wwv_flow_lang.system_message(''F4050.DENY_ADD_STORAGE_EMAIL'',:P49_STORAGE,:company);',
'    else',
'        return null;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'wwv_flow_platform.get_preference(''MAX_WKSP_STORAGE_REQ_MB'') is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2032705116295146.4353)
,p_associated_item=>wwv_flow_api.id(2030628749283010.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_api.create_page(
 p_id=>50.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Beendigung der Serviceanforderung - Anforderung definieren'
,p_step_title=>'Beendigung der Serviceanforderung - Anforderung definieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47463728350673648.4353)
,p_name=>'Datenbankanwendungen'
,p_template=>wwv_flow_api.id(486014333429205839.4353)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id || ''. '' || f.name as name',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN''',
'order by f.id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Keine Datenbankanwendungen gefunden'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47464210473677951.4353)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47465804464742441.4353)
,p_name=>'Websheet-Anwendungen'
,p_template=>wwv_flow_api.id(486014333429205839.4353)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ws.name',
'from wwv_flow_ws_applications ws',
'where ws.security_group_id = :flow_security_group_id',
'order by ws.name'))
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_ws_applications ws',
'where ws.security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Keine Websheet-Anwendungen gefunden'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47466417278746102.4353)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(100113926811394963.4353)
,p_name=>'Service-Ende Workspace'
,p_template=>wwv_flow_api.id(720158679964358138.4353)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ',
'   "WWV_FLOW_COMPANIES"."PROVISIONING_COMPANY_ID" "PROVISIONING_COMPANY_ID", ',
'   "WWV_FLOW_COMPANIES"."SHORT_NAME" "SHORT_NAME", ',
'   "WWV_FLOW_COMPANIES"."FIRST_SCHEMA_PROVISIONED" "FIRST_SCHEMA_PROVISIONED"',
'FROM ',
'   "WWV_FLOW_COMPANIES"',
'WHERE (("WWV_FLOW_COMPANIES"."PROVISIONING_COMPANY_ID" =wwv_flow.get_sgid))'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Workspace-Administratoren k\00F6nnen auf dieser Seite das Beenden des Service anfordern.</p>'),
'',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100114116170394967.4353)
,p_query_column_id=>1
,p_column_alias=>'PROVISIONING_COMPANY_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100114228842394967.4353)
,p_query_column_id=>2
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace-Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100114320671394967.4353)
,p_query_column_id=>3
,p_column_alias=>'FIRST_SCHEMA_PROVISIONED'
,p_column_display_sequence=>3
,p_column_heading=>'Erstes durch Provisioning bereitgestelltes Schema'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(100115402008397222.4353)
,p_name=>'Schemas'
,p_template=>wwv_flow_api.id(486014333429205839.4353)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.schema, u.default_tablespace name2',
'  from wwv_flow_company_schemas a, ',
'       sys.dba_users u',
' where a.schema = u.username',
'   and a.security_group_id = wwv_flow.get_sgid',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100115611210397225.4353)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(175696032163297164.4353)
,p_query_column_id=>2
,p_column_alias=>'NAME2'
,p_column_display_sequence=>2
,p_column_heading=>'Default Tablespace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(100118630059405357.4353)
,p_name=>'Anwendungsentwickler'
,p_template=>wwv_flow_api.id(486014333429205839.4353)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select userid as the_name',
'from WWV_FLOW_DEVELOPERS',
'where SECURITY_GROUP_ID = :flow_security_group_id',
'order by userid'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from WWV_FLOW_DEVELOPERS',
'where SECURITY_GROUP_ID = :flow_security_group_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47465607450733862.4353)
,p_query_column_id=>1
,p_column_alias=>'THE_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168316517118822887.4353)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47297014014256767.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208567423546371811.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113739388695875.4353)
,p_plug_name=>'Service-Ende anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168318118550851644.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208567423546371811.4353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2041318322327334.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208567423546371811.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2042126980329817.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208567423546371811.4353)
,p_button_name=>'REQUEST_SERVICE_TERMINATION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(917086616803951863.4353)
,p_branch_action=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2042126980329817.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(917202521436962653.4353)
,p_branch_action=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(168318118550851644.4353)
,p_branch_sequence=>20
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_api.create_page(
 p_id=>51.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Gruppenzuweisungen'
,p_step_title=>'Gruppenzuweisungen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_groups.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63231316426439799.4353)
,p_plug_name=>'Gruppenzuweisungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('In diesem Bericht werden Gruppen aufgef\00FChrt, die Benutzern und anderen Gruppen zugewiesen wurden. Sie k\00F6nnen Gruppen zur Kategorisierung und Verwaltung von Berechtigungen verwenden.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132384215654937539.4353)
,p_plug_name=>'users and groups APEX 4 0'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47054717520943020.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441077028778796807.4353)
,p_plug_name=>'Gruppenzuweisungen'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select grantee_name,',
'       granted_name,',
'       grantee_type,',
'       case grantee_type',
'         when ''U'' then wwv_flow_utilities.prepare_url(''f?p=&APP_ID.:56:'' || :APP_SESSION ||',
'                                                      ''::NO::F4350_P56_USER_ID,LAST_VIEW:'' || grantee_id || '',&APP_PAGE_ID.'')',
'         when ''G'' then wwv_flow_utilities.prepare_url(''f?p=&APP_ID.:54:'' || :APP_SESSION ||',
'                                                      ''::NO::F4350_P54_ID,LAST_VIEW:'' || grantee_id || '',&APP_PAGE_ID.'')',
'       end as grantee_url',
'/*',
'       case granted_security_group_id',
'         when security_group_id then wwv_flow_utilities.prepare_url(''f?p=&APP_ID.:54:'' || :APP_SESSION ||',
'                                                                    ''::NO::F4350_P54_ID,LAST_VIEW:'' || granted_id || '',&APP_PAGE_ID.'')',
'         else ''#''',
'       end as granted_url',
'*/',
'  from wwv_flow_group_grants',
' where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441077109644796807.4353)
,p_name=>'User Group Assignments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132386230855089063.4353)
,p_db_column_name=>'GRANTEE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Berechtigter'
,p_column_html_expression=>'<a href="#GRANTEE_URL#">#GRANTEE_NAME#</a>'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132386305744089068.4353)
,p_db_column_name=>'GRANTED_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Gruppe'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132386400368089068.4353)
,p_db_column_name=>'GRANTEE_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Typ'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(132386709008105935)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132386503304089068.4353)
,p_db_column_name=>'GRANTEE_URL'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'URL des Berechtigten'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(132384701504940813.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(441077028778796807.4353)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Dashboard anzeigen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_00052
begin
wwv_flow_api.create_page(
 p_id=>52.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Benutzer erstellen'
,p_step_title=>'Benutzer erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_step_template=>wwv_flow_api.id(692762523503114201.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_new_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4597004638216477.4353)
,p_plug_name=>'Accountberechtigungen'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63567744865578431.4353)
,p_plug_name=>'Benutzeridentifikation'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63571066572605837.4353)
,p_plug_name=>'Benutzer'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seite k\00F6nnen Sie den Zugriff f\00FCr Anwendungsentwickler, Workspace-Administratoren und Endbenutzer von &PRODUCT_NAME. kontrollieren.</p>'),
unistr('<p>Entwickler k\00F6nnen Anwendungen erstellen und bearbeiten sowie Datenbankobjekte erstellen und \00E4ndern.</p>'),
unistr('<p>Workspace-Administratoren k\00F6nnen au\00DFerdem Benutzeraccounts erstellen und bearbeiten sowie Gruppen und Entwicklungs-Services verwalten.</p>'),
unistr('<p>Endbenutzer haben keine Entwicklungsberechtigungen. Endbenutzeraccounts werden definiert, um die Zugriffskontrolle f\00FCr Anwendungen zur Verf\00FCgung zu stellen, die kein externes Authentifizierungsschema verwenden.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187400734286303164.4353)
,p_plug_name=>'Benutzer erstellen'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187414449357326556.4353)
,p_plug_name=>'Gruppenzuweisungen'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(504198401567901625.4353)
,p_plug_name=>'&F4350_PASSWORD_REGION_TITLE.'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(762729260417462701.4353)
,p_plug_name=>unistr('Selektor f\00FCr Regionsanzeige')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40275409253350646.4353)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63567961253578435.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(187400734286303164.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(39238412884699357.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(187400734286303164.4353)
,p_button_name=>'CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Erstellen und weitere erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63568042920578435.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(187400734286303164.4353)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Benutzer erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(63570246176578443.4353)
,p_branch_action=>'55'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(63568042920578435.4353)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(39244700248733466.4353)
,p_branch_action=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52,EDIT_USER_PRIVS:P52_DEVELOPER,P52_ADMIN:&P52_DEVELOPER.,&P52_ADMIN.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(39238412884699357.4353)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2748803393523351.4353)
,p_name=>'P52_ACCOUNT_LOCKED'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Account-Verf\00FCgbarkeit festlegen')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ACCOUNT_LOCK_STATUS'
,p_lov=>'.'||wwv_flow_api.id(6949526744661130.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie <strong>Gesperrt</strong>, um zu verhindern, dass der Account verwendet wird. W\00E4hlen Sie <strong>Freigegeben</strong>, um die Verwendung dieses Accounts zuzulassen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2749004588523351.4353)
,p_name=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(504198401567901625.4353)
,p_item_default=>'Y'
,p_prompt=>unistr('Kennwort muss nach erster Verwendung ge\00E4ndert werden')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('W\00E4hlen Sie <strong>Ja</strong>, wenn der Benutzer dieses Accounts das Kennwort unmittelbar nach der ersten Anmeldung mit dem aktuellen Kennwort \00E4ndern muss. Diese Regel gilt bei Verwendung dieses Accounts f\00FCr die Workspace-Administration oder Entwick')
||unistr('lung sowie f\00FCr die Anmeldung bei entwickelten Anwendungen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63568348763578436.4353)
,p_name=>'F4350_P52_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(63567744865578431.4353)
,p_prompt=>'Benutzername'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Benutzernamen f\00FCr die Anmeldung beim System an. Die Benutzernamen haben folgende Einschr\00E4nkungen: <ul><li>'),
unistr('maximale L\00E4nge von 100 Zeichen</li><li>'),
'keine Leerzeichen</li>',
unistr('<li>nur folgende Sonderzeichen sind zul\00E4ssig: @ und Punkte (.)</li></ul>'),
unistr('<p>Der Benutzername kann au\00DFerdem als Referenz zur Benutzeraktivit\00E4t bei Monitoranwendungen verwendet werden. Die Bind-Variable <code>:app_user </code>gibt den Wert des aktuellen Benutzers zur\00FCck, wenn Anwendungen erstellt werden.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63568549286578437.4353)
,p_name=>'F4350_P52_FIRST_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(63567744865578431.4353)
,p_prompt=>'Vorname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den Vornamen an, um den Benutzer weiter zu identifizieren. Dieses optionale Feld wird nur zu Informationszwecken verwendet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63568751448578438.4353)
,p_name=>'F4350_P52_LAST_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(63567744865578431.4353)
,p_prompt=>'Nachname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den Nachnamen an, um den Benutzer weiter zu identifizieren. Dieses optionale Feld wird nur zu Informationszwecken verwendet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63568945841578439.4353)
,p_name=>'F4350_P52_DESCRIPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(63567744865578431.4353)
,p_prompt=>'Beschreibung'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>200
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Dieses Feld wird f\00FCr die Erfassung von Kommentaren zum Benutzer verwendet und dient nur zu Informationszwecken.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63569221717578439.4353)
,p_name=>'F4350_P52_EMAIL_ADDRESS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(63567744865578431.4353)
,p_prompt=>'E-Mail-Adresse'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>240
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie die E-Mail-Adresse f\00FCr die allgemeine Korrespondenz, f\00FCr Benachrichtigungen zum Zur\00FCcksetzen von Kennw\00F6rtern usw. an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63569351113578440.4353)
,p_name=>'F4350_P52_WEB_PASSWORD'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(504198401567901625.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Kennwort'
,p_post_element_text=>unistr('<span class="instructiontext">Bei Kennw\00F6rtern wird die Gro\00DF-/Kleinschreibung beachtet</span>')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie ein Kennwort an. Bei der Kennworteingabe wird die Gro\00DF-/Kleinschreibung ber\00FCcksichtigt. Entwickler k\00F6nnen ihre Kennw\00F6rter \00E4ndern. Wenn Entwickler mit der Administratorberechtigung ausgestattet sind, k\00F6nnen sie die Kennw\00F6rter der Benutzer in')
||unistr('nerhalb desselben Workspace \00E4ndern.')
,p_attribute_01=>'N'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63569543152578441.4353)
,p_name=>'F4350_P52_GROUP_IDS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(187414449357326556.4353)
,p_prompt=>'Gruppenzuweisungen:'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'F4350_FND_GROUP_IDS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
' order by 1'))
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Der Benutzer geh\00F6rt den markierten Gruppen an. Um einen Benutzer zur Gruppe hinzuzuf\00FCgen, markieren Sie den Namen, indem Sie darauf klicken. Um eine Gruppe zu entfernen, klicken Sie erneut darauf, damit die Markierung aufgehoben wird. </p>'),
unistr('<p>\00DCber Gruppenzuweisungen k\00F6nnen Entwickler den Zugriff auf bestimmte Features und Funktionen pro Gruppe steuern.'),
unistr(' Diese Gruppenfunktionalit\00E4t ist in App Builder integriert und kann am besten (und benutzerfreundlichsten) bei der auf Cookies basierenden Authentifizierung verwendet werden. '),
unistr('Diese Benutzergruppenfunktionalit\00E4t ist jedoch nicht \00FCber verschiedene Authentifizierungsschemas portierbar. </p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(66055244597705294.4353)
,p_name=>'F4350_P52_ALLOW_SCHEMA_ACCESS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_prompt=>unistr('Verf\00FCgbare Schemas (Leer f\00FCr alle)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Geben Sie eine durch Doppelpunkte getrennte Liste der Schemas ein, auf die dieser Entwickler Berechtigungen hat, wenn SQL Workshop verwendet wird. Die Schemaliste, die Sie hier angeben, beschr\00E4nkt den Benutzer auf eine Teilmenge der gesamten Schemas,')
||unistr(' die f\00FCr den Workspace bereitgestellt wurden. Sie bestimmt au\00DFerdem, welche Schemanamen der Benutzer in SQL Workshop sehen kann.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(66067229562721999.4353)
,p_name=>'F4350_P52_DEFAULT_SCHEMA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Standardschema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Geben Sie das Standardschema f\00FCr das Durchsuchen von Daten, Erstellen von Anwendungen und Ausf\00FChren von SQL-Skripts an. Wenn Sie Workspaces verwenden, bei denen mehrere Schemas verf\00FCgbar sind, ist dieses Schema das Standardschema zum Erstellen von An')
||unistr('wendungen, Ausf\00FChren von SQL-Abfragen usw. Dieses Feature steuert nicht die Sicherheit, sondern nur die Benutzervoreinstellung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157872609565288125.4353)
,p_name=>'P52_DEVELOPER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_item_default=>'N'
,p_prompt=>'Benutzer ist Entwickler:'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P52_ADMIN_0.checked) document.forms[0].P52_DEVELOPER_0.checked = true;"'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob diesem Benutzer Entwicklerberechtigungen zugewiesen werden sollen. Entwickler m\00FCssen auf App Builder und/oder SQL-Workshop zugreifen k\00F6nnen.'),
'',
unistr('Komponenten, die von Instanzadministratoren deaktiviert wurden, stehen nicht zur Verf\00FCgung.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157873517877290564.4353)
,p_name=>'P52_ADMIN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_item_default=>'N'
,p_prompt=>'Benutzer ist Workspace-Administrator:'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P52_ADMIN_0.checked) document.forms[0].P52_DEVELOPER_0.checked = true;"'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob diesem Benutzer Workspace-Administratorberechtigungen zugewiesen werden. Administratoren erhalten Zugriff auf alle Komponenten. Zudem k\00F6nnen sie Benutzeraccounts, Gruppen und Entwicklungsdienste verwalten.'),
'',
unistr('Komponenten, die von Instanzadministratoren deaktiviert wurden, stehen nicht zur Verf\00FCgung.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180046203499305667.4353)
,p_name=>'P52_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'App Builder-Zugriff'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Legt fest, ob ein Entwickler Zugriff auf App Builder hat.<br>',
'<br>',
'Ein Administrator hat immer Zugriff auf App Builder.<br>',
'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.<br>',
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der App Builder-Zugriff f\00FCr den Workspace von einem Administrator deaktiviert ist.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180046412157308127.4353)
,p_name=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Zugriff auf SQL Workshop'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Legt fest, ob ein Entwickler Zugriff auf SQL Workshop erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Zugriff auf SQL Workshop.<br>',
unistr('Entwickler m\00FCssen auf App Builder und/oder SQL Workshop zugreifen k\00F6nnen.<br>'),
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der Administrator den Zugriff auf SQL Workshop f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180047014712318343.4353)
,p_name=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Team Development-Zugriff'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                  where provisioning_company_id = :flow_security_group_id',
'                     and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob der Benutzer Team Development-Zugriff erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Team Development-Zugriff.<br> <br>',
unistr('Dieses Attribut wird deaktiviert, wenn der Administrator den Team Development-Zugriff f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(240206601092761513.4353)
,p_name=>'F4350_P52_PASSWD_CONFIRM'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(504198401567901625.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Kennwort best\00E4tigen')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Geben Sie das Kennwort erneut ein.'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(367460908194031003.4353)
,p_name=>'P52_DEFAULT_DATE_FORMAT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(63567744865578431.4353)
,p_prompt=>'Standarddatumsformat'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie das Oracle-Standarddatumsformat f\00FCr den Benutzer ein. Dies bestimmt das Standarddatumsformat in SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499933401325546095.4353)
,p_name=>'P52_DISALLOW_APP_BUILDING'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'App Builder-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Legt fest, ob ein Entwickler Zugriff auf App Builder hat.<br>',
'<br>',
'Ein Administrator hat immer Zugriff auf App Builder.<br>',
'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.<br>',
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der App Builder-Zugriff f\00FCr den Workspace von einem Administrator deaktiviert ist.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499934427298553622.4353)
,p_name=>'P52_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Zugriff auf SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Legt fest, ob ein Entwickler Zugriff auf SQL Workshop erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Zugriff auf SQL Workshop.<br>',
unistr('Entwickler m\00FCssen auf App Builder und/oder SQL Workshop zugreifen k\00F6nnen.<br>'),
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der Administrator den Zugriff auf SQL Workshop f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499934906305556944.4353)
,p_name=>'P52_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(4597004638216477.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                  where provisioning_company_id = :flow_security_group_id',
'                     and NVL(allow_team_development_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob der Benutzer Team Development-Zugriff erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Team Development-Zugriff.<br> <br>',
unistr('Dieses Attribut wird deaktiviert, wenn der Administrator den Team Development-Zugriff f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(504649626390067456.4353)
,p_name=>'P52_SP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(504198401567901625.4353)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63976551899006266.4353)
,p_validation_name=>'F4350_P52_USER_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4350_P52_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Ein Benutzername muss angegeben werden.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(63568348763578436.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JUN-2001 19:34'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(88216016849515325.4353)
,p_validation_name=>'UserNameValid'
,p_validation_sequence=>20
,p_validation=>'F4350_P52_USER_NAME'
,p_validation2=>'< >'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>unistr('Ung\00FCltiger Benutzername.')
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(63568348763578436.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(69047703326983643.4353)
,p_validation_name=>'user doesn''t already exist'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_fnd_user',
' where user_name = upper(:F4350_P52_USER_NAME)',
'   and security_group_id = (select wwv_flow.get_sgid from dual where rownum = 1)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Der Benutzer &F4350_P52_USER_NAME. ist bereits vorhanden.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(63568348763578436.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63976943003006267.4353)
,p_validation_name=>'F4350_P52_EMAIL_ADDRESS Not Null'
,p_validation_sequence=>40
,p_validation=>'F4350_P52_EMAIL_ADDRESS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die E-Mail-Adresse muss angegeben werden.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(63569221717578439.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JUN-2001 19:34'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(437392827624179971.4353)
,p_validation_name=>'F4350_P52_EMAIL_ADDRESS valid format'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at number;',
'  l_dot number;',
'begin',
'  l_at := instr(nvl(:F4350_P52_EMAIL_ADDRESS,''x''),''@'');',
'  l_dot := instr(nvl(:F4350_P52_EMAIL_ADDRESS,''x''),''.'',l_at);',
'  return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltige E-Mail-Adresse.')
,p_validation_condition=>'F4350_P52_EMAIL_ADDRESS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(63569221717578439.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(109107321494746966.4353)
,p_validation_name=>'default schema in accessible schemas'
,p_validation_sequence=>60
,p_validation=>'instr(upper(:F4350_P52_ALLOW_SCHEMA_ACCESS),:F4350_P52_DEFAULT_SCHEMA) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Das Standardschema muss in den verf\00FCgbaren Schemas enthalten sein.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in (''SUBMIT'',''CREATE_ANOTHER'') and ',
':F4350_P52_ALLOW_SCHEMA_ACCESS is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(66067229562721999.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(499468123446723658.4353)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF nvl(:P52_DEVELOPER,''Y'') = ''Y'' and nvl(:P52_ADMIN,''N'') = ''N'' THEN',
'    IF nvl(:P52_ALLOW_APP_BUILDING_YN,''N'') = ''N''',
'    AND nvl(:P52_ALLOW_SQL_WORKSHOP_YN,''N'') = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(157872609565288125.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240211930659779511.4353)
,p_validation_name=>'Validate Password'
,p_validation_sequence=>120
,p_validation=>':F4350_P52_PASSWD_CONFIRM = :F4350_P52_WEB_PASSWORD'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Die Kennw\00F6rter stimmen nicht \00FCberein. ')
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(240206601092761513.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25671017599539184.4353)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username       => :F4350_P52_USER_NAME,',
'      p_password       => :F4350_P52_WEB_PASSWORD,',
'      p_old_password   => null,',
'      p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':request in (''SUBMIT'',''CREATE_ANOTHER'') and wwv_flow_authentication_dev.is_builder_password_required (p_developer_yn => :P52_DEVELOPER ) and wwv_flow_authentication_dev.get_internal_authentication <> ''DB'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(63569351113578440.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384616595866738717.4353)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>145
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4050_ui.p79_validate_password (',
'           p_username => upper(:F4350_P52_USER_NAME),',
'           p_password => :F4350_P52_WEB_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Kennwort entspricht nicht der Kennwort-Policy der Datenbank.'
,p_validation_condition=>':REQUEST in (''SUBMIT'',''CREATE_ANOTHER'') and :P52_DEVELOPER = ''Y'' and wwv_flow_authentication_dev.get_internal_authentication = ''DB'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(570550019351871809.4353)
,p_validation_name=>'admin / dev username validate'
,p_validation_sequence=>150
,p_validation=>'return regexp_like(:F4350_P52_USER_NAME,wwv_flow_platform.get_preference(''USERNAME_VALIDATION''));'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Benutzername stimmt nicht mit dem f\00FCr die Instanz definierten Ausdruck \00FCberein.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    nvl(wwv_flow_platform.get_preference(''USERNAME_VALIDATION''),''*'') != ''*''',
'and (:P52_ADMIN = ''Y'' or :P52_DEVELOPER = ''Y'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(63568348763578436.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(499427518420684435.4353)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_ADMIN'
,p_condition_element=>'P52_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499427820153684438.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DEVELOPER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499428823786684440.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>11
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DEVELOPER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504130609805948509.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DEVELOPER'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499429031223684440.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499919627701307745.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>31
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499428009207684439.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499804524250282146.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499920117574323684.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>71
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499803201394275502.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499923126672383077.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499923332212384708.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>91
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499428621934684440.4353)
,p_event_id=>wwv_flow_api.id(499427518420684435.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(384616999390738721.4353)
,p_name=>'Set Admin Defaults - ADW'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_ADMIN'
,p_condition_element=>'P52_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384617013498738722.4353)
,p_event_id=>wwv_flow_api.id(384616999390738721.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384617289052738724.4353)
,p_event_id=>wwv_flow_api.id(384616999390738721.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(499429526731686804.4353)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DEVELOPER'
,p_condition_element=>'P52_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499430212016686834.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499430411680686834.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>11
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499431025041686835.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499429814977686805.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>21
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499805312607288217.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499807025205301265.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>51
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150597633713090720.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>61
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499805929576293162.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150597546514090719.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>71
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499807709059306138.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>81
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150597307895090717.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150597453590090718.4353)
,p_event_id=>wwv_flow_api.id(499429526731686804.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(384618639510738738.4353)
,p_name=>'Set Developer Defaults - ADW'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DEVELOPER'
,p_condition_element=>'P52_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384618795887738739.4353)
,p_event_id=>wwv_flow_api.id(384618639510738738.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384618872797738740.4353)
,p_event_id=>wwv_flow_api.id(384618639510738738.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384618907212738741.4353)
,p_event_id=>wwv_flow_api.id(384618639510738738.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384619013190738742.4353)
,p_event_id=>wwv_flow_api.id(384618639510738738.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504051507879708569.4353)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504051813577708569.4353)
,p_event_id=>wwv_flow_api.id(504051507879708569.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DISALLOW_APP_BUILDING'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504052404893717114.4353)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504052727798717115.4353)
,p_event_id=>wwv_flow_api.id(504052404893717114.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504052917360720736.4353)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504053220034720737.4353)
,p_event_id=>wwv_flow_api.id(504052917360720736.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9364306003603574.4353)
,p_name=>'set email if user name contains @'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4350_P52_USER_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''F4350_P52_USER_NAME'').match(/@/)!=null'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9364618112603580.4353)
,p_event_id=>wwv_flow_api.id(9364306003603574.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4350_P52_EMAIL_ADDRESS'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''F4350_P52_USER_NAME'')'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(384616434560738716.4353)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create DB user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_num number;',
'begin',
'    select count(*) into l_num from sys.dba_users where username = upper(:F4350_P52_USER_NAME);',
'    ',
'    if l_num = 0 then',
'        wwv_flow_provision.create_user(',
'            p_username    => upper(:F4350_P52_USER_NAME),',
'            p_password    => :F4350_P52_WEB_PASSWORD );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in (''SUBMIT'',''CREATE_ANOTHER'') and :P52_DEVELOPER = ''Y'' and wwv_flow_authentication_dev.get_internal_authentication = ''DB'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63569943284578442.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create User PL/SQL API Call'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_user_id                      number        := wwv_flow_id.next_val;',
'  l_p                            varchar2(256) := :F4350_P52_WEB_PASSWORD;',
'  l_change_password_on_first_use varchar2(1)   := ''N'';',
'  l_developer_roles              varchar2(255) := NULL;',
'begin',
'  if :P52_CHANGE_PWD_ON_FIRST_USE = ''Y'' then',
'    l_change_password_on_first_use := ''Y'';',
'  end if;',
'  ',
'  wwv_flow.update_cache_with_write(''F4350_P52_WEB_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''F4350_P52_PASSWD_CONFIRM'',null);',
'  ',
'  WWV_FLOW_FND_USER_API.CREATE_FND_USER(',
'      P_USER_ID                      => l_user_id,',
'      P_USER_NAME                    => :F4350_P52_USER_NAME,',
'      P_FIRST_NAME                   => :F4350_P52_FIRST_NAME,',
'      P_LAST_NAME                    => :F4350_P52_LAST_NAME,',
'      P_DESCRIPTION                  => :F4350_P52_DESCRIPTION,',
'      P_EMAIL_ADDRESS                => :F4350_P52_EMAIL_ADDRESS,',
'      P_WEB_PASSWORD                 => l_p,',
'      P_GROUP_IDS                    => :F4350_P52_GROUP_IDS,',
'      P_DEVELOPER_PRIVS              => null,',
'      P_DEFAULT_SCHEMA               => :F4350_P52_DEFAULT_SCHEMA,',
'      p_default_date_format          => :P52_DEFAULT_DATE_FORMAT,',
'      P_ALLOW_ACCESS_TO_SCHEMAS      => :F4350_P52_ALLOW_SCHEMA_ACCESS,',
'      P_ACCOUNT_EXPIRY               => trunc(sysdate),',
'      P_ACCOUNT_LOCKED               => nvl(:P52_ACCOUNT_LOCKED,''N''),',
'      p_failed_access_attempts       =>   0, ',
'      p_change_password_on_first_use => l_change_password_on_first_use,',
'      p_first_password_use_occurred  => ''N'' );',
'',
'  --',
'  -- Set User Component Privileges',
'  --',
'  if :P52_ADMIN = ''Y'' then',
'    wwv_flow_fnd_developer_api.set_component_privs (',
'        P_user_id                   => l_user_id,',
'        p_ALLOW_APP_BUILDING_YN     => ''Y'',',
'        p_ALLOW_WEBSHEET_DEV_YN     => ''Y'',',
'        p_ALLOW_SQL_WORKSHOP_YN     => ''Y'',',
'        p_ALLOW_TEAM_DEVELOPMENT_YN => ''Y'');',
'',
'  elsif :P52_DEVELOPER= ''Y'' then',
'    wwv_flow_fnd_developer_api.set_component_privs (',
'        P_user_id                   => l_user_id,',
'        p_ALLOW_APP_BUILDING_YN     => nvl(:P52_ALLOW_APP_BUILDING_YN,''Y''),',
'        p_ALLOW_WEBSHEET_DEV_YN     => ''Y'',',
'        p_ALLOW_SQL_WORKSHOP_YN     => nvl(:P52_ALLOW_SQL_WORKSHOP_YN,''Y''),',
'        p_ALLOW_TEAM_DEVELOPMENT_YN => nvl(:P52_ALLOW_TEAM_DEVELOPMENT_YN,''Y'') );',
'',
'  else',
'    wwv_flow_fnd_developer_api.set_component_privs (',
'        P_user_id                   => l_user_id,',
'        p_ALLOW_APP_BUILDING_YN     => ''N'',',
'        p_ALLOW_WEBSHEET_DEV_YN     => ''N'',',
'        p_ALLOW_SQL_WORKSHOP_YN     => ''N'',',
'        p_ALLOW_TEAM_DEVELOPMENT_YN => ''N'');',
'',
'  end if;',
'',
'  --',
'  -- Developer and Admin roles',
'  --',
'  if :P52_ADMIN = ''N'' and :P52_DEVELOPER= ''N'' then',
'    null;',
'  else',
'    -- {Trigger on WWV_FLOW_DEVELOPERS sets all developer roles for ADMINS ',
'    --  irrespective of what set here providing includes ''ADMIN''} ',
'    if :P52_ADMIN = ''Y'' then ',
'      l_developer_roles := ''ADMIN'';',
'    end if;',
'    if nvl(v(''P52_ALLOW_APP_BUILDING_YN''),''Y'') = ''Y'' then ',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''CREATE:EDIT:HELP:MONITOR'';',
'    end if;',
'    if nvl(v(''P52_ALLOW_SQL_WORKSHOP_YN''),''Y'') = ''Y'' then',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''SQL:MONITOR:DATA_LOADER'';',
'    end if;',
'    wwv_flow_fnd_developer_api.edit_developer_role(',
'      p_id => 1,',
'      p_user_id => l_user_id,',
'      p_user_name => :F4350_P52_USER_NAME,',
'      p_developer_roles => l_developer_roles);',
'  end if;',
'',
'end;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler: #SQLERRM#'
,p_process_when=>'SUBMIT,CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Benutzer wurde erstellt.'
,p_process_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359780407415827856.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4350_P52_WEB_PASSWORD,F4350_P52_PASSWD_CONFIRM'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(356667601476363227.4353)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'always developer if admin'
,p_process_sql_clob=>':P52_DEVELOPER := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P52_ADMIN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(356496320516542527.4353)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'generate random password for SSO accounts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P52_WEB_PASSWORD   := wwv_flow_authentication_dev.create_shadow_user_password;',
':F4350_P52_PASSWD_CONFIRM := :F4350_P52_WEB_PASSWORD;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :request in (''SUBMIT'',''CREATE_ANOTHER'')',
'and :F4350_P52_WEB_PASSWORD is null',
'and not wwv_flow_authentication_dev.is_builder_password_required (',
'            p_developer_yn => :P52_DEVELOPER )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00053
begin
wwv_flow_api.create_page(
 p_id=>53.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Benutzergruppen'
,p_step_title=>'Benutzergruppen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_groups.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34954322794221837.4353)
,p_plug_name=>'Gruppen'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   ''icon-apex-user'' img,',
'   null alt,',
'''f?p=4350:54:''||:flow_session||''::NO::F4350_P54_ID,LAST_VIEW:''||g.ID||'',53'' link,',
'   g.GROUP_NAME,',
'   g.GROUP_DESC des,',
'   g.id,',
'   (select count(*) from WWV_FLOW_FND_GROUP_USERS u where u.group_id = g.id and u.security_group_id = :flow_security_group_id)',
'    +',
'   (select count(*) from WWV_FLOW_FND_GROUP_GROUPS gg where gg.granted_group_id = g.id and gg.security_group_id = :flow_security_group_id)',
'   member_count',
'from   WWV_FLOW_FND_USER_GROUPS_NOAPP g',
'where g.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P53_VIEW,''ICON'') = ''ICON'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(34954404769221837.4353)
,p_name=>'Groups (Icon View)'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#GROUP_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34954920422221901.4353)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>1
,p_column_identifier=>'D'
,p_column_label=>'Gruppenname'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34954624173221865.4353)
,p_db_column_name=>'IMG'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Bild'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34954707553221901.4353)
,p_db_column_name=>'ALT'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34954805025221901.4353)
,p_db_column_name=>'LINK'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34955004281221902.4353)
,p_db_column_name=>'DES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34955120410221902.4353)
,p_db_column_name=>'ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(503921408095649048.4353)
,p_db_column_name=>'MEMBER_COUNT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Anzahl Mitglieder'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46981912186439286.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(166211911060758908.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829471944455703874.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47055717997952583.4353)
,p_plug_name=>'users and groups APEX 4 0'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47054717520943020.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(829468732055693490.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63111618781819469.4353)
,p_plug_name=>'Benutzergruppen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sie k\00F6nnen mit Benutzergruppen den Zugriff auf verschiedene Teile einer Anwendung einschr\00E4nken. Benutzergruppen sind jedoch nicht \00FCber verschiedene Authentifizierungsschemas portierbar. Benutzergruppen sind besonders sinnvoll, wenn eine Authentifizie')
||'rung mit &PRODUCT_NAME.-Account-Zugangsdaten verwendet wird.',
unistr('<p />Um eine vorhandene Benutzergruppe zu bearbeiten, w\00E4hlen Sie die gew\00FCnschte Gruppe. Klicken Sie auf <strong>Erstellen</strong>, um eine neue Gruppe zu erstellen.')))
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(167828701739639874.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34954322794221837.4353)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Dashboard anzeigen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2194729132936059.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34954322794221837.4353)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Benutzergruppe erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51105802473026585.4353)
,p_branch_action=>'f?p=&FLOW_ID.:54:&SESSION.::&DEBUG.:54::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2194729132936059.4353)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(136263600341812777.4353)
,p_branch_action=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(63110747673808833.4353)
,p_computation_sequence=>10
,p_computation_item=>'F4350_P101_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2411429028503676.4353)
,p_computation_sequence=>20
,p_computation_item=>'LAST_VIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'53'
,p_compute_when=>'CREATE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00054
begin
wwv_flow_api.create_page(
 p_id=>54.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Benutzergruppe erstellen/bearbeiten'
,p_step_title=>'Benutzergruppe erstellen/bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_step_template=>wwv_flow_api.id(692762523503114201.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_groups.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63108043743808817.4353)
,p_plug_name=>'Gruppendetails'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 17-MAY-2001 00:33:59'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63112545982838982.4353)
,p_plug_name=>'Benutzergruppen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sie k\00F6nnen Benutzergruppen erstellen, um den Zugriff auf verschiedene Teile einer Anwendung einzuschr\00E4nken. Benutzergruppen sind jedoch nicht \00FCber verschiedene Authentifizierungsschemas portierbar. Benutzergruppen sind besonders sinnvoll, wenn die')
||' &PRODUCT_NAME. Workspace-Authentifizierung verwendet wird.</p>',
'<p>Um eine neue Benutzergruppe zu erstellen, geben Sie den Gruppennamen und optional eine Beschreibung an.</p>'))
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132399701351851203.4353)
,p_plug_name=>'Gruppenberechtigungen'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187692154521667589.4353)
,p_plug_name=>'Benutzergruppen'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'&F4350_P54_GROUP_NAME.'
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(327483512183656133.4353)
,p_plug_name=>unistr('Selektor f\00FCr Regionsanzeige')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40275409253350646.4353)
,p_plug_display_sequence=>20
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63108356545808819.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(187692154521667589.4353)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63108545013808820.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(187692154521667589.4353)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>'F4350_P54_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63108764367808820.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(187692154521667589.4353)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
,p_button_condition=>'F4350_P54_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63108953870808821.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(187692154521667589.4353)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Gruppe erstellen'
,p_button_position=>'CREATE'
,p_button_condition=>'F4350_P54_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(242266817857922918.4353)
,p_branch_name=>'Last view'
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63109151798808823.4353)
,p_name=>'F4350_P54_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(63108043743808817.4353)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63109395349808825.4353)
,p_name=>'F4350_P54_GROUP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(63108043743808817.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Gruppenname'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Geben Sie einen Namen f\00FCr die Gruppe ein, die erstellt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63109742671808826.4353)
,p_name=>'F4350_P54_GROUP_DESC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(63108043743808817.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Beschreibung'
,p_source=>'GROUP_DESC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Geben Sie eine Beschreibung f\00FCr die Gruppe ein, die erstellt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(132396514075841416.4353)
,p_name=>'F4350_P54_GRANTED_GROUP_IDS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(132399701351851203.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Gruppen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_string.join (',
'    wwv_flow_fnd_user_int.get_group_group_grants (',
'        p_group_id => :F4350_P54_ID ),',
'    '':'' )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'F4350_P54_FND_GROUP_IDS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
'   and (:F4350_P54_ID is null or id <> :F4350_P54_ID)',
' order by 1'))
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Die aktuelle Gruppe ist Mitglied der Gruppen auf der rechten Seite. Um die aktuelle Gruppe zu einem Mitglied einer zus\00E4tzlichen Gruppe zumachen, w\00E4hlen Sie die Gruppe und klicken auf <strong>Verschieben</strong>. Um die Mitgliedschaft zu entfernen, w')
||unistr('\00E4hlen Sie die Gruppe und klicken auf <strong>Entfernen</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(168786622708605094.4353)
,p_name=>'P54_ORIG_GROUP_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(63108043743808817.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168796825263615287.4353)
,p_computation_sequence=>10
,p_computation_item=>'P54_ORIG_GROUP_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name from wwv_flow_fnd_user_groups',
' where id = :F4350_P54_ID'))
,p_compute_when=>'F4350_P54_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(137486121551787082.4353)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_group_name (',
'  p_name => :F4350_P54_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''Create'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(63109395349808825.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(68844119894184093.4353)
,p_validation_name=>'group doesn''t already exist'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_fnd_user_groups_noapp',
' where group_name        = :F4350_P54_GROUP_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'&F4350_P54_GROUP_NAME. der Gruppe ist bereits vorhanden.'
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''Create'') and nvl(:P54_ORIG_GROUP_NAME,''-1x0'') != :F4350_P54_GROUP_NAME'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(63109395349808825.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63109949663808827.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_FND_USER_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER_GROUPS'
,p_attribute_03=>'F4350_P54_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id=:FLOW_SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Fehler beim Abrufen von Zeile.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63110150899808829.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_FND_USER_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER_GROUPS'
,p_attribute_03=>'F4350_P54_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id=:FLOW_SECURITY_GROUP_ID'
,p_attribute_09=>'F4350_P54_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Fehler beim Verarbeiten von Zeile der Tabelle WWV_FLOW_FND_USER_GROUPS.'
,p_process_success_message=>'Die angeforderte Aktion bei der Gruppe &F4350_P54_GROUP_NAME. wurde verarbeitet.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(132921012163290292.4353)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set_group_grants'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_int.set_group_group_grants (',
'    p_group_id          => :F4350_P54_ID,',
'    p_granted_group_ids => wwv_flow_string.split_numbers (',
'                               :F4350_P54_GRANTED_GROUP_IDS,',
'                               '':'' ));'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Apply_Changes,Create'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00055
begin
wwv_flow_api.create_page(
 p_id=>55.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Benutzer verwalten'
,p_step_title=>'Benutzer verwalten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10236218638033455.4353)
,p_plug_name=>'Accounts'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ''icon-apex-user'' as icon_view_class,',
'    alt,',
'    link,',
'    icon_view_name,',
'    user_id,',
'    "USER",',
'    "eMail",',
'    first_name,',
'    last_name,',
'    df, -- default schema',
'    developer,',
'    last_login,',
'    last_login2,',
'    builder_login_count,',
'    ul, -- is user locked?',
'    expiration,',
'    description,',
'    password_lifespan_days,',
'    password_lifespan_accesses,',
'    password_accesses_left,',
'    last_agent,',
'    last_ip,',
'    account_expiry,',
'    failed_access_attempts,',
'    change_password_on_first_use,',
'    first_password_use_occurred,',
'    dev_type,',
'    group_id,',
'    group_name,',
'    last_update_date,',
'    last_updated_by,',
'    creation_date,',
'    created_by,',
'    developer_type,',
'    allow_app_building,',
'    allow_sql_workshop,',
'    allow_team_devopment',
'from wwv_flow_workspace_users',
'where workspace_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10236304983033455.4353)
,p_name=>'Internal Accounts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_VIEW_CLASS#"></span><span class="a-IRR-iconName">#ICON_VIEW_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10236920075033495.4353)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>'USER_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237013673033495.4353)
,p_db_column_name=>'USER'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'Benutzer'
,p_column_link=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:RP:F4350_P56_USER_ID,LAST_VIEW:#USER_ID#,55:'
,p_column_linktext=>'#USER#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237132197033496.4353)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'E-Mail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237206635033496.4353)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'H'
,p_column_label=>'Vorname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237325678033496.4353)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Nachname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237400246033496.4353)
,p_db_column_name=>'DF'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Standardschema'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237809965033497.4353)
,p_db_column_name=>'UL'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>'Gesperrt'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10238005252033499.4353)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Accounttyp'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237527416033496.4353)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Kennwortstatus'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237917271033498.4353)
,p_db_column_name=>'EXPIRATION'
,p_display_order=>10
,p_column_identifier=>'O'
,p_column_label=>'Endbenutzer-Account'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237623779033496.4353)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>unistr('Datum f\00FCr letzte Anmeldung beim Builder')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10237719465033497.4353)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Anzahl Anmeldungen beim Builder'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10236603197033493.4353)
,p_db_column_name=>'ALT'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10236716695033493.4353)
,p_db_column_name=>'LINK'
,p_display_order=>15
,p_column_identifier=>'C'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10236820465033493.4353)
,p_db_column_name=>'ICON_VIEW_NAME'
,p_display_order=>16
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10242328997102158.4353)
,p_db_column_name=>'LAST_LOGIN2'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Letzte Anmeldung beim Builder'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10249601218188649.4353)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10249711398188650.4353)
,p_db_column_name=>'PASSWORD_LIFESPAN_DAYS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Kennwortg\00FCltigkeitsdauer in Tagen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10249815190188650.4353)
,p_db_column_name=>'PASSWORD_LIFESPAN_ACCESSES'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Kennwortg\00FCltigkeitsdauer Zugriffe')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10249915247188650.4353)
,p_db_column_name=>'PASSWORD_ACCESSES_LEFT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Verbleibende Kennwortzugriffe'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10250027892188659.4353)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Letzter Agent'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10250112673188659.4353)
,p_db_column_name=>'LAST_IP'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Letzte IP-Adresse'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10250207006188659.4353)
,p_db_column_name=>'ACCOUNT_EXPIRY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Accountablauf'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10250324219188659.4353)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Nicht erfolgreiche Zugriffversuche'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10250432727188659.4353)
,p_db_column_name=>'CHANGE_PASSWORD_ON_FIRST_USE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>unistr('Kennwort bei erster Verwendung \00E4ndern')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10250517976188660.4353)
,p_db_column_name=>'FIRST_PASSWORD_USE_OCCURRED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Erste Verwendung des Kennworts aufgetreten'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10256910961219854.4353)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Gruppenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2987726658504251.4353)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2987802854504258.4353)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2987914456504258.4353)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2988019496504258.4353)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(19726026576048845.4353)
,p_db_column_name=>'DEVELOPER_TYPE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Entwicklertyp'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(179030605646968794.4353)
,p_db_column_name=>'ALLOW_APP_BUILDING'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'App Builder'
,p_column_type=>'STRING'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(179030711961968799.4353)
,p_db_column_name=>'ALLOW_SQL_WORKSHOP'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'SQL Workshop'
,p_column_type=>'STRING'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(179030904660968800.4353)
,p_db_column_name=>'ALLOW_TEAM_DEVOPMENT'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>'Team Development'
,p_column_type=>'STRING'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9297316101992856.4353)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'Gruppen-ID'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(649535305137618336.4353)
,p_db_column_name=>'ICON_VIEW_CLASS'
,p_display_order=>49
,p_column_identifier=>'AN'
,p_column_label=>'Symbolansichtsklasse'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46969402630171623.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(166211911060758908.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46988702152512130.4353)
,p_plug_name=>'Benutzer verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(replace(',
'    case when wwv_flow_global.g_cloud and wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'' then wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION_CLOUD'')',
'         else wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION'', ''&SYSTEM_HELP_URL.'') end,',
'    ''#IMAGE_PREFIX''||''#'',',
'    :image_prefix));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47053011848931923.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47055403799948453.4353)
,p_plug_name=>'users and groups APEX 4 0'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47054717520943020.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179031100713986245.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10236218638033455.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:55,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(167827029959610172.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(10236218638033455.4353)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Dashboard anzeigen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(44453823677220822.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(10236218638033455.4353)
,p_button_name=>'create_multiple'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_image_alt=>'Mehrere Benutzer erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:RP,99::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2218831266040742.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(10236218638033455.4353)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Benutzer erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2219115242040743.4353)
,p_branch_action=>'f?p=4350:52:&SESSION.:::52,EDIT_USER_PRIVS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2218831266040742.4353)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8952907044209733.4353)
,p_branch_action=>'55'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1939534275325928.4353)
,p_computation_sequence=>10
,p_computation_item=>'F4350_P4802_USER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2400705910478090.4353)
,p_computation_sequence=>20
,p_computation_item=>'LAST_VIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'55'
,p_compute_when=>'CREATE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_api.create_page(
 p_id=>56.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Benutzer bearbeiten'
,p_step_title=>'Benutzer bearbeiten'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="javascript">',
'<!--',
'function confirmaction(){',
'        if (document.wwv_flow.F4350_P56_EMAIL_ADDRESS.value != document.wwv_flow.F4350_P56_ORG_EMAIL_ADDRESS.value){',
'	if(confirm("Are you sure you want to change the email address?")){',
'		doSubmit(''ApplyChanges'') ;',
'          }',
'        }else{',
'            doSubmit(''ApplyChanges'') ;',
'        }',
' }',
'//-->',
'</script>'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(document).on (',
'    "apexpagesubmit",',
'    function() {',
'        $(":disabled").removeProp("disabled");',
'        $("#P56_DEVELOPER").removeProp("disabled");',
'    });'))
,p_step_template=>wwv_flow_api.id(692762523503114201.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_help_text=>'AEADM/aadm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1939534236325904.4353)
,p_plug_name=>'Benutzer bearbeiten'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 19-FEB-2000 22:09:25'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1939836620202510.4353)
,p_plug_name=>'&PRODUCT_NAME.-Benutzer'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dieser Benutzer-Manager verwaltet Accounts f\00FCr Authentifizierungsschemas, die die Authentifizierung in Bezug auf den Benutzernamen und das Kennwort f\00FCr diese Accounts ausf\00FChren.</p>'),
unistr('<p>Wenn Sie ein Benutzerkennwort \00E4ndern m\00F6chten, geben Sie ein neues Kennwort ein. Wenn Sie in die Kennwortspalten nichts eingeben, wird das aktuelle Kennwort nicht ge\00E4ndert.</p>')))
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R:L:L:L:L:L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2842809782477294.4353)
,p_plug_name=>'Accountberechtigungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32838311033428820.4353)
,p_plug_name=>'reset'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P56_WEB_PASSWORD := null;',
':F4350_P56_USER_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33631616489003252.4353)
,p_plug_name=>'Benutzer verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(replace(',
'    case when wwv_flow_global.g_cloud and wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'' then wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION_CLOUD'')',
'         else wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION'') end,',
'    ''#IMAGE_PREFIX''||''#'',',
'    :image_prefix));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46268225340679031.4353)
,p_plug_name=>unistr('Selektor f\00FCr Regionsanzeige')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40275409253350646.4353)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63228665418367633.4353)
,p_plug_name=>'Gruppenzuweisungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(96413246392446128.4353)
,p_plug_name=>'Benutzer: &F4350_P56_USER_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192198837219940283.4353)
,p_plug_name=>'&F4350_PASSWORD_REGION_TITLE.'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1939534237325907.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(96413246392446128.4353)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1939534238325908.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(96413246392446128.4353)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Benutzer l\00F6schen')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''Delete'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P56_USER_ID is not null',
' and wwv_flow_fnd_user_int.can_delete_user (',
'         p_user_id => :F4350_P56_USER_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1939534239325908.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(96413246392446128.4353)
,p_button_name=>'ApplyChanges'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmaction();'
,p_button_condition=>'F4350_P56_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3911809366516124.4353)
,p_branch_action=>'56'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'ADD_PRIV'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30381123923255056.4353)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534241325916.4353)
,p_name=>'F4350_P56_USER_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534242325916.4353)
,p_name=>'F4350_P56_USER_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_prompt=>'Benutzername'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_read_only_when=>'F4350_P56_USER_NAME'
,p_read_only_when2=>'&APP_USER.'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gibt den Benutzernamen f\00FCr die Anmeldung beim System an. Die Benutzernamen haben folgende Einschr\00E4nkungen: <ul><li>'),
unistr('maximale L\00E4nge von 100 Zeichen</li><li>'),
'keine Leerzeichen</li>',
unistr('<li>nur folgende Sonderzeichen sind zul\00E4ssig: @ und Punkte (.)</li></ul>'),
unistr('<p>Der Benutzername kann au\00DFerdem als Referenz zur Benutzeraktivit\00E4t bei Monitoranwendungen verwendet werden. Die Bind-Variable <code>:app_user </code>gibt den Wert des aktuellen Benutzers zur\00FCck, wenn Anwendungen erstellt werden.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534251325919.4353)
,p_name=>'F4350_P56_START_DATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534252325919.4353)
,p_name=>'F4350_P56_END_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534259325921.4353)
,p_name=>'F4350_P56_EMPLOYEE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534260325921.4353)
,p_name=>'F4350_P56_PERSON_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_item_default=>'E'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534261325921.4353)
,p_name=>'F4350_P56_EMAIL_ADDRESS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_prompt=>'E-Mail-Adresse'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt die E-Mail-Adresse zum Beispiel f\00FCr die allgemeine Korrespondenz, f\00FCr Benachrichtigungen zum Zur\00FCcksetzen von Kennw\00F6rtern an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534264325922.4353)
,p_name=>'F4350_P56_USER_PASSWORD'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Kennwort best\00E4tigen')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Geben Sie das Kennwort erneut ein. Geben Sie nur dann ein Kennwort ein, wenn Sie das aktuelle Kennwort \00E4ndern m\00F6chten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534265325922.4353)
,p_name=>'F4350_P56_FIRST_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_prompt=>'Vorname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den Vornamen an, um den Benutzer weiter zu identifizieren. Dieses optionale Feld wird nur zu Informationszwecken verwendet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939534267325923.4353)
,p_name=>'F4350_P56_WEB_PASSWORD'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Kennwort'
,p_post_element_text=>unistr('<span class="instructiontext">Bei Kennw\00F6rtern wird die Gro\00DF-/Kleinschreibung beachtet</span>')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Das Kennwort f\00FCr die Anmeldung beim System. Geben Sie nur dann ein Kennwort ein, wenn Sie das aktuelle Kennwort \00E4ndern m\00F6chten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939557108193755.4353)
,p_name=>'F4350_P56_COMPANY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt an, welchem Workspace dieser Benutzer angeh\00F6rt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1939836784851988.4353)
,p_name=>'F4350_P56_LAST_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_prompt=>'Nachname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den Nachnamen an, um den Benutzer weiter zu identifizieren. Dieses optionale Feld wird nur zu Informationszwecken verwendet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2729632398336567.4353)
,p_name=>'P56_ACCOUNT_LOCKED'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_item_default=>'N'
,p_prompt=>unistr('Accountverf\00FCgbarkeit')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ACCOUNT_LOCK_STATUS'
,p_lov=>'.'||wwv_flow_api.id(6949526744661130.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie <strong>Gesperrt</strong>, um zu verhindern, dass der Account verwendet wird. W\00E4hlen Sie <strong>Freigegeben</strong>, um die Verwendung dieses Accounts zu erm\00F6glichen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2733307164357615.4353)
,p_name=>'P56_ACCOUNT_EXPIRY'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3419605623465159.4353)
,p_name=>'P56_FAILED_ACCESS_ATTEMPTS'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4174018563862024.4353)
,p_name=>'P56_DESCRIPTION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_prompt=>'Beschreibung'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>200
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Dieses Feld wird f\00FCr die Erfassung von Kommentaren zum Benutzer verwendet und dient nur zu Informationszwecken.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6646713211577222.4353)
,p_name=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_prompt=>unistr('Kennwort muss nach erster Verwendung ge\00E4ndert werden')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('W\00E4hlen Sie <strong>Ja</strong>, wenn der Benutzer dieses Accounts das Kennwort unmittelbar nach der ersten Anmeldung mit dem aktuellen Kennwort \00E4ndern muss. Diese Regel gilt bei Verwendung dieses Accounts f\00FCr die Workspace-Administration oder Entwick')
||unistr('lung sowie f\00FCr die Anmeldung bei entwickelten Anwendungen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6647326024580973.4353)
,p_name=>'P56_FIRST_PWD_USE_OCCURRED'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6836403653427495.4353)
,p_name=>'P56_EXPIRATION_STATUS1'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_prompt=>'Entwickler-/Administratorkennwort'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P56_EXPIRATION_STATUS1'
,p_display_when2=>'NA'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt an, ob das Kennwort abgelaufen ist oder f\00FCr die Anmeldung als Entwickler oder Workspace-Administrator g\00FCltig ist.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6844512750836962.4353)
,p_name=>'P56_EXPIRE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Kennwortablauf'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'select null d, ''Y'' r from dual'
,p_display_when=>'P56_SHOW_EXPIRE_FLAG'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Aktivieren Sie dieses Kontrollk\00E4stchen, damit das Benutzerkennwort abl\00E4uft. Davon ist sowohl die Anmeldung als Entwickler/Administrator als auch der Zugriff als Endbenutzer betroffen. Wenn das Kennwort abgelaufen ist, muss der Benutzer beim n\00E4chsten ')
||unistr('Account-Zugriff das alte Kennwort zusammen mit einem neuen Kennwort eingeben, um sich anmelden zu k\00F6nnen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6849820425943301.4353)
,p_name=>'P56_EXPIRATION_STATUS2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_prompt=>'Endbenutzerkennwort'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P56_EXPIRATION_STATUS2'
,p_display_when2=>'NA'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt an, ob das Kennwort abgelaufen ist oder f\00FCr die Anmeldung als Endbenutzer g\00FCltig ist.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6855306572639406.4353)
,p_name=>'P56_SHOW_EXPIRE_FLAG'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32491914843797683.4353)
,p_name=>'F4350_P56_ORG_EMAIL_ADDRESS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_source=>'&F4350_P56_ORG_EMAIL_ADDRESS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63228442637365892.4353)
,p_name=>'F4350_P56_GROUPS'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(63228665418367633.4353)
,p_prompt=>'Gruppenzuweisungen'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'F4350_FND_GROUP_IDS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
' order by 1'))
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Mit Gruppenzuweisungen k\00F6nnen Entwickler den Zugriff auf bestimmte Features und Funktionen nach Gruppen kontrollieren. '),
unistr('Diese Gruppenfunktionalit\00E4t ist in App Builder integriert und funktioniert am besten (und bequemsten) mit der Authentifizierung von <em>Application Express-Accounts</em>. '),
'</p>',
'<p>',
unistr('Der Benutzer geh\00F6rt zu den Gruppen auf der rechten Seite.'),
'Um dem Benutzer eine andere Gruppe zuzuweisen, ',
unistr('w\00E4hlen Sie die Gruppe auf der linken Seite aus und verwenden das Symbol ">", um sie auf die rechte Seite zu verschieben.'),
'Um dem Benutzer alle Gruppen zuzuweisen, ',
'klicken Sie auf das Symbol ">>".',
'Um eine Zuweisung aufzuheben, ',
unistr('w\00E4hlen Sie die Gruppe auf der rechten Seite aus und klicken auf das Symbol "<".'),
'Um alle Zuweisungen zu entfernen, ',
'klicken Sie auf das Symbol "<<".',
'</p> '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'and user_id = :F4350_P56_USER_ID',
'',
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(65943898362184724.4353)
,p_name=>'F4350_P56_ACCESS_TO_SCHEMAS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_prompt=>unistr('Verf\00FCgbare Schemas (Leer f\00FCr alle)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Geben Sie eine durch Doppelpunkte getrennte Liste der Schemas ein, auf die dieser Entwickler Berechtigungen hat, wenn SQL Workshop verwendet wird. Die Schemaliste, die Sie hier angeben, beschr\00E4nkt den Benutzer auf eine Teilmenge der gesamten Schemas,')
||unistr(' die f\00FCr den Workspace bereitgestellt wurden. Sie bestimmt au\00DFerdem, welche Schemanamen der Benutzer in SQL Workshop sehen kann.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(65973729260237471.4353)
,p_name=>'F4350_P56_DEFAULT_SCHEMA'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_prompt=>'Standardschema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Schema ausw\00E4hlen -')
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Gibt das Standardschema f\00FCr das Durchsuchen von Daten, Erstellen von Anwendungen und Ausf\00FChren von SQL-Skripts an. Wenn Sie Workspaces verwenden, bei denen mehrere Schemas verf\00FCgbar sind, ist dieses Schema das Standardschema zum Erstellen von Anwendu')
||unistr('ngen, Ausf\00FChren von SQL-Abfragen usw. Dieses Feature steuert nicht die Sicherheit, sondern nur die Benutzervoreinstellung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(88564124466917904.4353)
,p_name=>'F4350_P56_DEVELOPER_ROLE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(127630432271025900.4353)
,p_name=>'P56_UPDATE_PW'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(192198837219940283.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157817015229873453.4353)
,p_name=>'P56_DEVELOPER'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_item_default=>'N'
,p_prompt=>'Benutzer ist ein Entwickler'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob diesem Benutzer Entwicklerberechtigungen zugewiesen werden sollen. Entwickler m\00FCssen auf App Builder und/oder SQL-Workshop zugreifen k\00F6nnen.'),
'',
unistr('Komponenten, die von Instanzadministratoren deaktiviert wurden, stehen nicht zur Verf\00FCgung.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157818110858881656.4353)
,p_name=>'P56_ADMIN'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_item_default=>'N'
,p_prompt=>'Benutzer ist ein Workspace-Administrator'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob diesem Benutzer Workspace-Administratorberechtigungen zugewiesen werden. Administratoren erhalten Zugriff auf alle Komponenten. Zudem k\00F6nnen sie Benutzeraccounts, Gruppen und Entwicklungsdienste verwalten.'),
'',
unistr('Komponenten, die von Instanzadministratoren deaktiviert wurden, stehen nicht zur Verf\00FCgung.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173536824865172817.4353)
,p_name=>'P56_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'App Builder-Zugriff'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(ALLOW_APP_BUILDING_YN,''Y'')',
'from wwv_flow_fnd_user ',
'where user_id = :F4350_P56_USER_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Legt fest, ob ein Entwickler Zugriff auf App Builder hat.<br>',
'<br>',
'Ein Administrator hat immer Zugriff auf App Builder.<br>',
'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.<br>',
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der App Builder-Zugriff f\00FCr den Workspace von einem Administrator deaktiviert ist.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173539020840181069.4353)
,p_name=>'P56_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Zugriff auf SQL Workshop'
,p_source=>'select ALLOW_SQL_WORKSHOP_YN from wwv_flow_fnd_user where user_id = :F4350_P56_USER_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Legt fest, ob ein Entwickler Zugriff auf SQL Workshop erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Zugriff auf SQL Workshop.<br>',
unistr('Entwickler m\00FCssen auf App Builder und/oder SQL Workshop zugreifen k\00F6nnen.<br>'),
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der Administrator den Zugriff auf SQL Workshop f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173548426643201698.4353)
,p_name=>'P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Team Development-Zugriff'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ALLOW_TEAM_DEVELOPMENT_YN ',
'from wwv_flow_fnd_user ',
'where user_id = :F4350_P56_USER_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob der Benutzer Team Development-Zugriff erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Team Development-Zugriff.<br> <br>',
unistr('Dieses Attribut wird deaktiviert, wenn der Administrator den Team Development-Zugriff f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(367459414269982539.4353)
,p_name=>'P56_DEFAULT_DATE_FORMAT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(1939534236325904.4353)
,p_prompt=>'Standarddatumsformat'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie das Oracle-Standarddatumsformat f\00FCr den Benutzer ein. Dies bestimmt das Standarddatumsformat in SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499924228974449999.4353)
,p_name=>'P56_DISALLOW_APP_BUILDING'
,p_item_sequence=>201
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'App Builder-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Legt fest, ob ein Entwickler Zugriff auf App Builder hat.<br>',
'<br>',
'Ein Administrator hat immer Zugriff auf App Builder.<br>',
'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.<br>',
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der App Builder-Zugriff f\00FCr den Workspace von einem Administrator deaktiviert ist.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499927725127496225.4353)
,p_name=>'P56_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Zugriff auf SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Legt fest, ob ein Entwickler Zugriff auf SQL Workshop erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Zugriff auf SQL Workshop.<br>',
unistr('Entwickler m\00FCssen auf App Builder und/oder SQL Workshop zugreifen k\00F6nnen.<br>'),
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der Administrator den Zugriff auf SQL Workshop f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499928914176502544.4353)
,p_name=>'P56_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(2842809782477294.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob der Benutzer Team Development-Zugriff erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Team Development-Zugriff.<br> <br>',
unistr('Dieses Attribut wird deaktiviert, wenn der Administrator den Team Development-Zugriff f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(6865929128024449.4353)
,p_computation_sequence=>10
,p_computation_item=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P56_CHANGE_PWD_ON_FIRST_USE,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;',
'',
''))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(6867330429043779.4353)
,p_computation_sequence=>20
,p_computation_item=>'P56_EXPIRE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P56_EXPIRE,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(6868607489056034.4353)
,p_computation_sequence=>30
,p_computation_item=>'P56_ACCOUNT_LOCKED'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P56_ACCOUNT_LOCKED,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(127631126515033687.4353)
,p_computation_sequence=>40
,p_computation_item=>'P56_UPDATE_PW'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'length(:F4350_P56_USER_PASSWORD)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(189706509679038825.4353)
,p_validation_name=>'F4350_P56_USER_NAME not null'
,p_validation_sequence=>10
,p_validation=>'F4350_P56_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Sie m\00FCssen einen Benutzernamen angeben.')
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(1939534242325916.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(111517930900067043.4353)
,p_validation_name=>'F4350_P56_USER_NAME'
,p_validation_sequence=>20
,p_validation=>'F4350_P56_USER_NAME'
,p_validation2=>'< >'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>unistr('Ung\00FCltiger Benutzername.')
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(1939534242325916.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(189791113029531872.4353)
,p_validation_name=>'validate email'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at  number;',
'  l_dot number;',
'begin',
'  l_at  := instr(nvl(:F4350_P56_EMAIL_ADDRESS,''x''),''@'');',
'  l_dot := instr(nvl(:F4350_P56_EMAIL_ADDRESS,''x''),''.'',l_at);',
'  return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltige E-Mail-Adresse.')
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(1939534261325921.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(109168713538170465.4353)
,p_validation_name=>'default schema in accessible schemas'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'instr(upper(:F4350_P56_ACCESS_TO_SCHEMAS),:F4350_P56_DEFAULT_SCHEMA) > 0 or',
'v(''F4350_P56_ACCESS_TO_SCHEMAS'') is null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Das Standardschema muss in den verf\00FCgbaren Schemas enthalten sein.')
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(65973729260237471.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(159963211620773707.4353)
,p_validation_name=>'can''t remove admin from yourself'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P56_USER_ID = wwv_flow_user_api.get_user_id(:FLOW_USER) and nvl(:P56_ADMIN,''N'') = ''N'' then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Sie k\00F6nnen sich keine Administratorrechte entziehen.')
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(157818110858881656.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(499406131374423262.4353)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF nvl(:P56_DEVELOPER,''Y'') = ''Y'' and nvl(:P56_ADMIN,''N'') = ''N'' THEN',
'    IF nvl(:P56_ALLOW_APP_BUILDING_YN,''N'') = ''N''',
'    AND nvl(:P56_ALLOW_SQL_WORKSHOP_YN,''N'') = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.'
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(157817015229873453.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1533378731762979439.4353)
,p_validation_name=>'F4350_P56_USER_NAME unique if changed'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_fnd_user',
' where user_name = upper(:F4350_P56_USER_NAME)',
'   and security_group_id = :flow_security_group_id ',
'   and user_id != :F4350_P56_USER_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Benutzername ist bereits vorhanden.'
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(1939534242325916.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488436717457786543.4353)
,p_validation_name=>'if change username, must reset password'
,p_validation_sequence=>105
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select user_name',
'     from wwv_flow_fnd_user',
'    where user_id = :F4350_P56_USER_ID',
'      and security_group_id = :flow_security_group_id )',
'loop',
'   if c1.user_name != :F4350_P56_USER_NAME and',
'      :F4350_P56_WEB_PASSWORD is null then',
'   return false;',
'   else return true;',
'   end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Wenn Sie den Benutzernamen \00E4ndern, m\00FCssen Sie ein neues Kennwort angeben.')
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(1939534267325923.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1939534308824103.4353)
,p_validation_name=>'match password'
,p_validation_sequence=>120
,p_validation=>':F4350_P56_WEB_PASSWORD = :F4350_P56_USER_PASSWORD'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Das Kennwort wurde nicht korrekt best\00E4tigt. Die Best\00E4tigung muss mit der ersten Kennworteingabe exakt \00FCbereinstimmen.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P56_WEB_PASSWORD is not null or',
':F4350_P56_USER_PASSWORD is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(1939534264325922.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25666918114501495.4353)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username       => :F4350_P56_USER_NAME,',
'      p_password       => :F4350_P56_WEB_PASSWORD,',
'      p_old_password   => null,',
'      p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.is_builder_password_required (',
'    p_developer_yn => :P56_DEVELOPER ) and wwv_flow_authentication_dev.get_internal_authentication <> ''DB'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1939534239325908.4353)
,p_associated_item=>wwv_flow_api.id(1939534267325923.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'do not run for non-developers in SSO authentication mode'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(70798336525897014.4353)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P56_WEB_PASSWORD is null then',
'    return false;',
'else',
'    return wwv_flow_4050_ui.p79_validate_password (',
'           p_username => upper(:F4350_P56_USER_NAME),',
'           p_password => :F4350_P56_WEB_PASSWORD );',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Das Kennwort entspricht nicht den Komplexit\00E4tsregeln f\00FCr Kennw\00F6rter der Datenbank.')
,p_validation_condition=>'return :REQUEST = ''ApplyChanges'' and :P56_DEVELOPER = ''Y'' and :F4350_P56_DEVELOPER_ROLE is null and wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_associated_item=>wwv_flow_api.id(1939534267325923.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(499209416736012184.4353)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_ADMIN'
,p_condition_element=>'P56_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(364738319517328603.4353)
,p_event_id=>wwv_flow_api.id(499209416736012184.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DEVELOPER,P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499840224680613417.4353)
,p_event_id=>wwv_flow_api.id(499209416736012184.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DEVELOPER,P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(364738260492328602.4353)
,p_event_id=>wwv_flow_api.id(499209416736012184.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DEVELOPER,P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(499225332629064137.4353)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DEVELOPER'
,p_condition_element=>'P56_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(364738126056328601.4353)
,p_event_id=>wwv_flow_api.id(499225332629064137.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(364738550708328605.4353)
,p_event_id=>wwv_flow_api.id(499225332629064137.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(364738433387328604.4353)
,p_event_id=>wwv_flow_api.id(499225332629064137.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499347501358272656.4353)
,p_event_id=>wwv_flow_api.id(499225332629064137.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(82670098641701898.4353)
,p_name=>'Set Admin Defaults - ADW'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_ADMIN'
,p_condition_element=>'P56_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82670436864701912.4353)
,p_event_id=>wwv_flow_api.id(82670098641701898.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82671427031701914.4353)
,p_event_id=>wwv_flow_api.id(82670098641701898.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(82672318133704761.4353)
,p_name=>'Set Developer Defaults - ADW'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DEVELOPER'
,p_condition_element=>'P56_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82672793706704761.4353)
,p_event_id=>wwv_flow_api.id(82672318133704761.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82673259140704761.4353)
,p_event_id=>wwv_flow_api.id(82672318133704761.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82673735178704762.4353)
,p_event_id=>wwv_flow_api.id(82672318133704761.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82674260816704764.4353)
,p_event_id=>wwv_flow_api.id(82672318133704761.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(168246085352411202.4353)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(168246110055411203.4353)
,p_event_id=>wwv_flow_api.id(168246085352411202.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DISALLOW_APP_BUILDING'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(168246275445411204.4353)
,p_name=>'Disable Disallow Websheet Dev'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DISALLOW_WEBSHEET_DEV'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(168246350707411205.4353)
,p_event_id=>wwv_flow_api.id(168246275445411204.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DISALLOW_WEBSHEET_DEV'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(168246439075411206.4353)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(168246509636411207.4353)
,p_event_id=>wwv_flow_api.id(168246439075411206.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(168246664883411208.4353)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(168246709948411209.4353)
,p_event_id=>wwv_flow_api.id(168246664883411208.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1939534268325924.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.fetch_fnd_user (',
'     p_user_id       => :F4350_P56_USER_ID,',
'     p_company       => :F4350_P56_COMPANY,',
'     p_user_name     => :F4350_P56_USER_NAME,',
'     p_first_name    => :F4350_P56_FIRST_NAME,',
'     p_last_name     => :F4350_P56_LAST_NAME,',
'     p_web_password  => :F4350_P56_WEB_PASSWORD,',
'     p_email_address => :F4350_P56_EMAIL_ADDRESS,',
'     p_start_date    => :F4350_P56_START_DATE,',
'     p_end_date      => :F4350_P56_END_DATE,',
'     p_employee_id   => :F4350_P56_EMPLOYEE_ID,',
'     p_allow_access_to_schemas => :F4350_P56_ACCESS_TO_SCHEMAS,',
'     p_person_type     => :F4350_P56_PERSON_TYPE,',
'     p_default_schema  => :F4350_P56_DEFAULT_SCHEMA,',
'     p_groups          => :F4350_P56_GROUPS,',
'     p_developer_role  => :F4350_P56_DEVELOPER_ROLE,',
'     p_description     => :P56_DESCRIPTION,',
'     p_account_expiry  => :P56_ACCOUNT_EXPIRY,',
'     p_account_locked  => :P56_ACCOUNT_LOCKED,',
'     p_failed_access_attempts => :P56_FAILED_ACCESS_ATTEMPTS,',
'     p_change_password_on_first_use => :P56_CHANGE_PWD_ON_FIRST_USE,',
'     p_first_password_use_occurred => :P56_FIRST_PWD_USE_OCCURRED',
'     );',
':P56_DB_ACCT_PWD := :F4350_P56_WEB_PASSWORD;',
'for c1 in (select default_date_format',
'             from wwv_flow_fnd_user',
'            where user_id = :F4350_P56_USER_ID',
'              and security_group_id =  :flow_security_group_id) loop',
'    :P56_DEFAULT_DATE_FORMAT := c1.default_date_format;',
'    exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Abrufen von Benutzerinformationen.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(157783521762846932.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_site_account_lifetime number := ',
'    nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated date;',
'  l_dev_admin_expired boolean := false;',
'  l_end_user_expired boolean := false;',
'  l_found boolean := false;',
'begin',
':F4350_P56_ORG_EMAIL_ADDRESS := :F4350_P56_EMAIL_ADDRESS;',
'if :F4350_P56_DEVELOPER_ROLE is null then',
'  :P56_DEVELOPER := ''N'';',
'  :P56_ADMIN := ''N'';',
'elsif instr(:F4350_P56_DEVELOPER_ROLE,''ADMIN'') > 0 then',
'  :P56_DEVELOPER := ''Y'';',
'  :P56_ADMIN := ''Y'';',
'else',
'  :P56_DEVELOPER := ''Y'';',
'  :P56_ADMIN := ''N'';',
'end if;',
'--',
'-- account expiration notices',
'--',
'l_account_last_updated := nvl(:P56_ACCOUNT_EXPIRY, trunc(sysdate));',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where provisioning_company_id = :flow_security_group_id) loop',
'  l_workspace_account_lifetime := nvl(c1.account_lifetime_days,l_site_account_lifetime);',
'end loop;',
'',
':P56_SHOW_EXPIRE_FLAG := ''N'';',
'if :P56_DEVELOPER = ''Y'' then',
'  if l_account_last_updated + l_site_account_lifetime < sysdate then',
'    l_dev_admin_expired := true;',
'    :P56_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P56_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''VALID'');',
'    :P56_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'else',
'  :P56_EXPIRATION_STATUS1 := ''NA'';',
'end if;',
'',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where (',
'             EXPIRE_FND_USER_ACCOUNTS = ''Y'' or ',
'             wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'') = ''Y'')',
'           and provisioning_company_id = :flow_security_group_id) loop',
'  l_found := true;',
'  if l_account_last_updated + l_workspace_account_lifetime < sysdate then',
'    l_end_user_expired := true;',
'    :P56_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P56_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''VALID'');',
'    :P56_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'end loop;',
'if not l_found then',
'  :P56_EXPIRATION_STATUS2 := ''NA'';',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(70800964830989107.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create DB user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_num number;',
'    l_sql varchar2(32767);',
'begin',
'    select count(*) into l_num from sys.dba_users where username = upper(:F4350_P56_USER_NAME);',
'    ',
'    if l_num = 0 then',
'        wwv_flow_provision.create_user(',
'            p_username    => upper(:F4350_P56_USER_NAME),',
'            p_password    => :F4350_P56_WEB_PASSWORD );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST = ''ApplyChanges'' and :P56_DEVELOPER = ''Y'' and :F4350_P56_DEVELOPER_ROLE is null and wwv_flow_authentication_dev.get_internal_authentication = ''DB'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1939534269325925.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p1 varchar2(256) := v(''F4350_P56_WEB_PASSWORD'');',
'  l_p2 varchar2(256) := v(''F4350_P56_USER_PASSWORD'');',
'  l_msg varchar2(4000);',
'  l_body_html varchar2(32767) := null;',
'  l_product_name      varchar2(500);',
'  l_developer_roles varchar2(255) := null;',
'  l_ALLOW_APP_BUILDING_YN         varchar2(1);',
'  l_ALLOW_SQL_WORKSHOP_YN         varchar2(1);',
'  l_ALLOW_WEBSHEET_DEV_YN         varchar2(1);',
'  l_ALLOW_TEAM_DEVELOPMENT_YN     varchar2(1);',
'begin',
'    if :F4350_P56_DEFAULT_SCHEMA is not null then',
'        wwv_flow_sw_api.check_priv(p_schema=>:F4350_P56_DEFAULT_SCHEMA);',
'    end if;',
'',
'    if nvl(:P56_ADMIN,''N'') = ''Y'' or nvl(:P56_DEVELOPER,''N'') = ''Y'' then',
'        l_ALLOW_APP_BUILDING_YN     := nvl(v(''P56_ALLOW_APP_BUILDING_YN''),''Y'');',
'        l_ALLOW_SQL_WORKSHOP_YN     := nvl(v(''P56_ALLOW_SQL_WORKSHOP_YN''),''Y'');',
'        l_ALLOW_WEBSHEET_DEV_YN     := ''Y'';  ',
'        l_ALLOW_TEAM_DEVELOPMENT_YN := nvl(v(''P56_ALLOW_TEAM_DEVELOPMENT_YN''),''Y'');  ',
'    else',
'        l_ALLOW_APP_BUILDING_YN     := nvl(v(''P56_ALLOW_APP_BUILDING_YN''),''N'');',
'        l_ALLOW_SQL_WORKSHOP_YN     := nvl(v(''P56_ALLOW_SQL_WORKSHOP_YN''),''N'');',
'        l_ALLOW_WEBSHEET_DEV_YN     := ''N'';',
'        l_ALLOW_TEAM_DEVELOPMENT_YN := nvl(v(''P56_ALLOW_TEAM_DEVELOPMENT_YN''),''N'');  ',
'    end if;',
'',
' --   l_ALLOW_TEAM_DEVELOPMENT_YN := case when :P56_ADMIN = ''N'' and :P56_DEVELOPER = ''N'' then ''N'' else nvl(v(''P56_ALLOW_TEAM_DEVELOPMENT_YN''),''Y'') end;',
'    ',
'    wwv_flow.update_cache_with_write(''F4350_P56_WEB_PASSWORD'',null);',
'    wwv_flow.update_cache_with_write(''F4350_P56_USER_PASSWORD'',null);',
'    ',
'    wwv_flow_fnd_developer_api.edit_fnd_user (',
'     p_user_id                      => :F4350_P56_USER_ID,           ',
'     p_user_name                    => :F4350_P56_USER_NAME,         ',
'     p_first_name                   => :F4350_P56_FIRST_NAME,          ',
'     p_last_name                    => :F4350_P56_LAST_NAME,',
'     p_web_password                 => l_p1,    ',
'     p_new_password                 => l_p2,                     ',
'     p_email_address                => :F4350_P56_EMAIL_ADDRESS,       ',
'     p_allow_access_to_schemas      => :F4350_P56_ACCESS_TO_SCHEMAS,   ',
'     p_default_schema               => :F4350_P56_DEFAULT_SCHEMA, ',
'     p_default_date_format          => :P56_DEFAULT_DATE_FORMAT,',
'     p_group_ids                    => :F4350_P56_GROUPS,',
'     P_DESCRIPTION                  => :P56_DESCRIPTION,',
'     --',
'     P_ACCOUNT_EXPIRY               => :P56_ACCOUNT_EXPIRY,',
'     P_ACCOUNT_LOCKED               => :P56_ACCOUNT_LOCKED,',
'     p_change_password_on_first_use => :P56_CHANGE_PWD_ON_FIRST_USE,',
'     p_first_password_use_occurred  => case when l_p1 is not null then ''N'' else :P56_FIRST_PWD_USE_OCCURRED end,',
'     --',
'     p_ALLOW_APP_BUILDING_YN        => l_ALLOW_APP_BUILDING_YN,',
'     p_ALLOW_SQL_WORKSHOP_YN        => l_ALLOW_SQL_WORKSHOP_YN,',
'     p_ALLOW_WEBSHEET_DEV_YN        => l_ALLOW_WEBSHEET_DEV_YN,',
'     p_ALLOW_TEAM_DEVELOPMENT_YN    =>  l_ALLOW_TEAM_DEVELOPMENT_YN ',
'    );',
'',
'  --',
'  -- Mail the change of Email address',
'  --',
'  If :F4350_P56_ORG_EMAIL_ADDRESS <> :F4350_P56_EMAIL_ADDRESS then',
'    l_msg       := l_msg || wwv_flow_lang.system_message(''NEW_EMAIL_ADDRESS'') || chr(10) ',
'                      || :F4350_P56_EMAIL_ADDRESS || chr(10) || chr(10) || chr(10);',
'    l_msg       := l_msg || wwv_flow_utilities.host_url(''SCRIPT'') || chr(10);',
'   ',
'    l_body_html := wwv_flow_mail.convert_txt_to_html (',
'                       p_txt_message       => l_msg,',
'                       p_security_group_id => :flow_security_group_id );',
'    l_product_name := nvl(v(''PRODUCT_NAME''),''Oracle Application Express'');',
'',
'    wwv_flow_mail.send ( p_to        => :F4350_P56_ORG_EMAIL_ADDRESS,',
'                         p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),:F4350_P56_ORG_EMAIL_ADDRESS),',
'                         p_body      => l_msg,',
'                         p_body_html => l_body_html,',
'                         p_subj      => wwv_flow_lang.system_message(''CHANGE_PW_REQUEST'',l_product_name) );',
'  end if;',
'',
'  --',
'  -- Developer and Admin roles',
'  --',
'  if nvl(:P56_ADMIN,''N'') = ''N'' and nvl(:P56_DEVELOPER,''N'') = ''N'' then',
'    delete from wwv_flow_developers where user_id = :F4350_P56_USER_ID;',
'  else',
'    -- {Trigger on WWV_FLOW_DEVELOPERS sets all developer roles for ADMINS ',
'    --  irrespective of what set here providing includes ''ADMIN''} ',
'    if nvl(:P56_ADMIN,''N'') = ''Y'' then ',
'      l_developer_roles := l_developer_roles||''ADMIN:CREATE:EDIT:HELP:MONITOR:SQL:MONITOR:DATA_LOADER'';',
'    else',
'        if nvl(v(''P56_ALLOW_APP_BUILDING_YN''),''Y'') = ''Y'' then ',
'          if l_developer_roles is not null then',
'            l_developer_roles := l_developer_roles||'':'';',
'          end if;',
'          l_developer_roles := l_developer_roles||''CREATE:EDIT:HELP:MONITOR'';',
'        end if;',
'        if nvl(v(''P56_ALLOW_SQL_WORKSHOP_YN''),''Y'') = ''Y'' then',
'          if l_developer_roles is not null then',
'            l_developer_roles := l_developer_roles||'':'';',
'          end if;',
'          l_developer_roles := l_developer_roles||''SQL:MONITOR:DATA_LOADER'';',
'        end if;',
'    end if;',
'    wwv_flow_fnd_developer_api.edit_developer_role(',
'             p_id              => 1,',
'             p_user_id         => :F4350_P56_USER_ID,',
'             p_user_name       => :F4350_P56_USER_NAME,',
'             p_developer_roles => l_developer_roles);',
'  end if;',
'',
'  --',
'  -- If the current user is the one being edited in this workspace, then also',
'  -- update the session state value for the user default date format',
'  --',
'  if :APP_USER = upper(:F4350_P56_USER_NAME) then',
'      if trim(:P56_DEFAULT_DATE_FORMAT) is null then',
'          :G_USER_DEFAULT_DATE_FORMAT := :DATE_FORMAT;      ',
'      else',
'          :G_USER_DEFAULT_DATE_FORMAT := :P56_DEFAULT_DATE_FORMAT;',
'      end if;',
'  end if;',
'  ',
'',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Aktualisieren von Benutzer.'
,p_process_when_button_id=>wwv_flow_api.id(1939534239325908.4353)
,p_process_success_message=>'Benutzer "&F4350_P56_USER_NAME." wurde aktualisiert.'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(50610502602911549.4353)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.remove_fnd_user(',
'             p_user_id => :F4350_P56_USER_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim L\00F6schen von &F4350_P56_USER_NAME..')
,p_process_when_button_id=>wwv_flow_api.id(1939534238325908.4353)
,p_process_success_message=>unistr('Benutzer &F4350_P56_USER_NAME. wurde gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359782111702838596.4353)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4350_P56_WEB_PASSWORD,F4350_P56_USER_PASSWORD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6871003183243994.4353)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'expire account'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_site_account_lifetime      number := nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated       date;',
'  l_account_next_updated       date;',
'begin',
'  l_account_last_updated := nvl(:P56_ACCOUNT_EXPIRY, trunc(sysdate));',
'  for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'              where provisioning_company_id = :flow_security_group_id)',
'  loop',
'      l_workspace_account_lifetime := nvl(c1.account_lifetime_days,l_site_account_lifetime);',
'  end loop;',
'  l_account_next_updated := trunc(sysdate) - greatest(l_workspace_account_lifetime,l_site_account_lifetime);',
'',
'  update wwv_flow_fnd_user ',
'     set account_expiry = l_account_next_updated ',
'   where :F4350_P56_USER_ID = user_id',
'     and security_group_id = :flow_security_group_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(1939534239325908.4353)
,p_process_when=>':P56_EXPIRE = ''Y'' and nvl(:P56_UPDATE_PW,0) = 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(356667829527371372.4353)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'always developer if admin'
,p_process_sql_clob=>':P56_DEVELOPER := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P56_ADMIN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
end;
/
prompt --application/pages/page_00057
begin
wwv_flow_api.create_page(
 p_id=>57.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Mehrere Benutzer l\00F6schen')
,p_step_title=>unistr('Mehrere Benutzer l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_del_multi_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487212527825020723.4353)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487213714635020731.4353)
,p_plug_name=>'Benutzer'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when u."USER"=:APP_USER then',
'               null',
'           else',
'               wwv_flow_item.checkbox(1,wwv_flow_escape.html(user_id),''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(u."USER"))||''"'')',
'       end c,',
'       alt,',
'       "USER",',
'       "eMail",',
'       first_name,',
'       last_name,',
'       df, -- default schema',
'       developer,',
'       last_login,',
'       last_login2,',
'       builder_login_count,',
'       ul, -- is user locked?',
'       expiration,',
'       description,',
'       password_lifespan_days,',
'       password_lifespan_accesses,',
'       password_accesses_left,',
'       last_agent,',
'       last_ip,',
'       account_expiry,',
'       failed_access_attempts,',
'       change_password_on_first_use,',
'       first_password_use_occurred,',
'       dev_type,',
'       group_id,',
'       group_name,',
'       last_update_date,',
'       last_updated_by,',
'       creation_date,',
'       created_by,',
'       allow_app_building,',
'       allow_sql_workshop,',
'       allow_team_devopment',
'  from wwv_flow_workspace_users u',
' where workspace_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(487213921192020742.4353)
,p_name=>'Internal Accounts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487215710241020761.4353)
,p_db_column_name=>'USER'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'Benutzer'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487215802188020762.4353)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'E-Mail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487215931922020762.4353)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'H'
,p_column_label=>'Vorname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216002599020762.4353)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Nachname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216119102020763.4353)
,p_db_column_name=>'DF'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Standardschema'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216529936020763.4353)
,p_db_column_name=>'UL'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>'Gesperrt'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216719903020764.4353)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Accounttyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216201732020763.4353)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Kennwortstatus'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216623847020764.4353)
,p_db_column_name=>'EXPIRATION'
,p_display_order=>10
,p_column_identifier=>'O'
,p_column_label=>'Endbenutzer-Account'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216317773020763.4353)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>unistr('Datum f\00FCr letzte Anmeldung beim Builder')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216402426020763.4353)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Anzahl Anmeldungen beim Builder'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487215318605020760.4353)
,p_db_column_name=>'ALT'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216811649020764.4353)
,p_db_column_name=>'LAST_LOGIN2'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Letzte Anmeldung beim Builder'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487216902657020764.4353)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217002481020765.4353)
,p_db_column_name=>'PASSWORD_LIFESPAN_DAYS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Kennwortg\00FCltigkeitsdauer in Tagen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217129654020765.4353)
,p_db_column_name=>'PASSWORD_LIFESPAN_ACCESSES'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Kennwortg\00FCltigkeitsdauer Zugriffe')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217219249020765.4353)
,p_db_column_name=>'PASSWORD_ACCESSES_LEFT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Verbleibende Kennwortzugriffe'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217314732020765.4353)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Letzter Agent'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217421986020766.4353)
,p_db_column_name=>'LAST_IP'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Letzte IP-Adresse'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217508236020766.4353)
,p_db_column_name=>'ACCOUNT_EXPIRY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Accountablauf'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217618067020766.4353)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Nicht erfolgreiche Zugriffversuche'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487217731681020766.4353)
,p_db_column_name=>'CHANGE_PASSWORD_ON_FIRST_USE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>unistr('Kennwort bei erster Verwendung \00E4ndern')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214111454020755.4353)
,p_db_column_name=>'FIRST_PASSWORD_USE_OCCURRED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Erste Verwendung des Kennworts aufgetreten'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214203186020756.4353)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Gruppen-ID'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214320781020756.4353)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Gruppenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214407401020757.4353)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214531320020757.4353)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214627862020758.4353)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214728627020758.4353)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487214921039020759.4353)
,p_db_column_name=>'ALLOW_APP_BUILDING'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'App Builder'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487215009223020759.4353)
,p_db_column_name=>'ALLOW_SQL_WORKSHOP'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'SQL Workshop'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487215206440020759.4353)
,p_db_column_name=>'ALLOW_TEAM_DEVOPMENT'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>'Team Development'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487221529442070599.4353)
,p_db_column_name=>'C'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(487212710054020727.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(487213714635020731.4353)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Benutzer l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(487213112910020728.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(487213714635020731.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(487219710852020784.4353)
,p_branch_action=>'57'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(487228209066168747.4353)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Es muss mindestens ein Benutzer f\00FCr den L\00F6schvorgang ausgew\00E4hlt werden.')
,p_when_button_pressed=>wwv_flow_api.id(487212710054020727.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199175162192878427.4353)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(487213714635020731.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199175204816878428.4353)
,p_event_id=>wwv_flow_api.id(1199175162192878427.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(487229823742182498.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete users'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   wwv_flow_fnd_user_api.remove_fnd_user(',
'             p_user_id => to_number(wwv_flow.g_f01(i)));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Benutzer konnten nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(487212710054020727.4353)
,p_process_success_message=>unistr('Benutzer gel\00F6scht.')
);
end;
/
prompt --application/pages/page_00058
begin
wwv_flow_api.create_page(
 p_id=>58.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Kennwort \00E4ndern')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Kennwort \00E4ndern')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_inline_css=>'#htmldbMessageHolder {position: inherit !important; margin: -10px auto 12px auto !important};'
,p_step_template=>wwv_flow_api.id(485889499804058937.4353)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32840111164438374.4353)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P58_PASSWORD := null;',
':F4350_P58_CONFIRM_PASSWORD := null;',
':P58_ENTER_CURRENT_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(97733238886811092.4353)
,p_plug_name=>unistr('Kennwort \00E4ndern')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'CONFIRM'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(970051444988740602.4353)
,p_plug_name=>unistr('Schaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(97747647431861977.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(970051444988740602.4353)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
,p_button_condition=>'CONFIRM'
,p_button_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(97746535656858507.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(970051444988740602.4353)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Schlie\00DFen')
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(167163108516013325.4353)
,p_branch_action=>'f?p=&APP_ID.:58:&SESSION.:CONFIRM:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(97737538442826474.4353)
,p_name=>'F4350_P58_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(97733238886811092.4353)
,p_prompt=>'Benutzername:'
,p_source=>':flow_user'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Der Name des Benutzers, dessen Kennwort ge\00E4ndert werden soll')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(97738659564831832.4353)
,p_name=>'F4350_P58_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(97733238886811092.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Neues Kennwort eingeben'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Neues Kennwort eingeben'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(97739354173834336.4353)
,p_name=>'F4350_P58_CONFIRM_PASSWORD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(97733238886811092.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Neues Kennwort best\00E4tigen')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Neues Kennwort erneut eingeben'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195381121107968260.4353)
,p_name=>'P58_ENTER_CURRENT_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(97733238886811092.4353)
,p_prompt=>'Aktuelles Kennwort eingeben'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Geben Sie das aktuelle Kennwort ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458944904898444327.4353)
,p_validation_name=>':FLOW_USER is not null'
,p_validation_sequence=>10
,p_validation=>'FLOW_USER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Der Benutzername wurde nicht korrekt festgelegt. Schlie\00DFen Sie den Browser, und versuchen Sie erneut, das Kennwort zu \00E4ndern.')
,p_associated_item=>wwv_flow_api.id(97737538442826474.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Implemented on Display Only field due to issues with Username being null in some instances. Issue often reported on apex.oracle.com with users being unable to change their password until they have restarted their browser -- David Peake',
''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(195491431842321459.4353)
,p_validation_name=>'P58_ENTER_CURRENT_PASSWORD'
,p_validation_sequence=>20
,p_validation=>'P58_ENTER_CURRENT_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Das Kennwort muss angegeben werden.'
,p_associated_item=>wwv_flow_api.id(195381121107968260.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(97742065159844461.4353)
,p_validation_name=>'F4350_P58_PASSWORD Not Null'
,p_validation_sequence=>30
,p_validation=>'F4350_P58_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Das Kennwort muss angegeben werden.'
,p_associated_item=>wwv_flow_api.id(97738659564831832.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 07-AUG-2002 16:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(97742336858844466.4353)
,p_validation_name=>'F4350_P58_CONFIRM_PASSWORD Not Null'
,p_validation_sequence=>40
,p_validation=>'F4350_P58_CONFIRM_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('"Kennwort best\00E4tigen" muss angegeben werden.')
,p_associated_item=>wwv_flow_api.id(97739354173834336.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 07-AUG-2002 16:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(97743950494851241.4353)
,p_validation_name=>'passwd = confirm passwd'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P58_PASSWORD != :F4350_P58_CONFIRM_PASSWORD then',
'  :F4350_P58_PASSWORD := null;',
'  :F4350_P58_CONFIRM_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Die Kennwortbest\00E4tigung stimmt nicht mit dem Kennwort \00FCberein.')
,p_validation_condition=>':F4350_P58_PASSWORD is not null and :F4350_P58_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(97739354173834336.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(195618500159768013.4353)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_api.is_login_password_valid(',
'  p_username=>:APP_USER,',
'  p_password=>:P58_ENTER_CURRENT_PASSWORD);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltiges Kennwort')
,p_validation_condition=>'P58_ENTER_CURRENT_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(195381121107968260.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(97500109914962040.4353)
,p_validation_name=>'strong password'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username              => :F4350_P58_USER_NAME,',
'      p_password              => :F4350_P58_PASSWORD,',
'      p_old_password          => :P58_ENTER_CURRENT_PASSWORD,',
'      p_workspace_name        => ',
'              wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>':F4350_P58_PASSWORD is not null and :F4350_P58_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(97738659564831832.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(97750634955873614.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p varchar2(256) := v(''F4350_P58_PASSWORD'');',
'begin',
'  wwv_flow.update_cache_with_write(''F4350_P58_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''F4350_P58_CONFIRM_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''P58_ENTER_CURRENT_PASSWORD'',null);',
'  wwv_flow_api.g_fnd_user_password_action := true;',
'  update wwv_flow_fnd_user ',
'    set web_password = l_p',
'  where security_group_id = :flow_security_group_id ',
'    and user_id = (select user_id ',
'                    from wwv_flow_fnd_user ',
'                   where security_group_id = :flow_security_group_id ',
'                     and user_name = :flow_user);',
'  wwv_flow_api.g_fnd_user_password_action := false;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim \00C4ndern von Kennwort.')
,p_process_when=>':F4350_P58_PASSWORD = :F4350_P58_CONFIRM_PASSWORD'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Kennwort wurde ge\00E4ndert.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(60831518199464683.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'58'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(970051351448740601.4353)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(97746535656858507.4353)
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_api.create_page(
 p_id=>59.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Zeitrahmen f\00FCr Berichtserstellung festlegen')
,p_step_title=>unistr('Zeitrahmen f\00FCr Berichtserstellung festlegen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_hm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435132419277175057.4353)
,p_plug_name=>unistr('Zeitrahmen f\00FCr Berichtserstellung festlegen')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(435134109039200452.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(435132419277175057.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(435134317383200454.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(435132419277175057.4353)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(435134722545204415.4353)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435133125746186382.4353)
,p_name=>'P59_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(435132419277175057.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Anzeigen'
,p_source=>'nvl(:P1_TIME,.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Zeigen Sie die Echtzeitstatistiken f\00FCr diesen Zeitraum an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(435135231895207087.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set reporting Timeframe'
,p_process_sql_clob=>':P1_TIME := :P59_TIME;'
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Aktion wurde verarbeitet'
);
end;
/
prompt --application/pages/page_00060
begin
wwv_flow_api.create_page(
 p_id=>60.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Benutzer-Dashboard'
,p_step_title=>'Benutzer-Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30379719851234976.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(166211911060758908.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(33618923744803860.4353)
,p_name=>'Zuletzt erstellte'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60d */',
'      substr(lower(u.user_name),1,50) user_name,',
'      u.CREATION_DATE,',
'      u.USER_ID,',
'      u.email_address "eMail"',
'from  WWV_FLOW_FND_USER u',
'where security_group_id = :flow_security_group_id',
'and (:AUTH_TYPE=''APEX'' or not exists (select null from wwv_flow_developers d where u.user_id = d.user_id and u.security_group_id = d.security_group_id))',
'order by creation_date desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Es wurden keine Benutzer gefunden.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(33618923744803860.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33619332489803868.4353)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4350:56:&SESSION.::&DEBUG.:EDIT_USER_PRIVS:F4350_P56_USER_ID,LAST_VIEW:#USER_ID#,60'
,p_column_linktext=>'#USER_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33619518264803868.4353)
,p_query_column_id=>2
,p_column_alias=>'CREATION_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46860326857226944.4353)
,p_query_column_id=>3
,p_column_alias=>'USER_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46860401547226946.4353)
,p_query_column_id=>4
,p_column_alias=>'eMail'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46746423788487369.4353)
,p_name=>'Workspace-Benutzer'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60b */',
'   count(*) user_count,',
'   sum(decode(developer_type,null,1,0)) end_user_count,',
'   sum(decode(is_developer,''Y'',1,0)) developer_count,',
'   sum(decode(developer_type,''ADMIN'',1,0)) workspace_admin_count,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 1),sysdate -1,0,1)) created_last_24_hours,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 7),sysdate -7,0,1)) created_last_week',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(46746423788487369.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46746605762487374.4353)
,p_query_column_id=>1
,p_column_alias=>'USER_COUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzer'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46746713956487375.4353)
,p_query_column_id=>2
,p_column_alias=>'END_USER_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Endbenutzer'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46746831538487375.4353)
,p_query_column_id=>3
,p_column_alias=>'DEVELOPER_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Anwendungsentwickler'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46747023926487375.4353)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_ADMIN_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace-Administratoren'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46747130355487375.4353)
,p_query_column_id=>5
,p_column_alias=>'CREATED_LAST_24_HOURS'
,p_column_display_sequence=>5
,p_column_heading=>'Erstellt in letzten 24 Stunden'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46747226758487375.4353)
,p_query_column_id=>6
,p_column_alias=>'CREATED_LAST_WEEK'
,p_column_display_sequence=>6
,p_column_heading=>'Erstellt in letzter Woche'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46762420099120193.4353)
,p_name=>'Benutzergruppen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60c */',
'   g.group_name,',
'   count(*) user_count',
'from  WWV_FLOW_FND_USER_GROUPS_NOAPP g,',
'      WWV_FLOW_FND_GROUP_USERS u',
'where g.security_group_id = :flow_security_group_id',
'  and g.id = u.group_id(+)',
'group by g.group_name',
'order by count(*) desc, upper(g.group_name)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Gruppen gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46767109411145456.4353)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Gruppenname'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46767228078145460.4353)
,p_query_column_id=>2
,p_column_alias=>'USER_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Benutzeranzahl'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46994318485620885.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47004408825920869.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47026829183038160.4353)
,p_name=>'Mein Account'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P60a */',
'       substr(:app_user,1,50) your_username,',
'       substr(:company,1,50) workspace,',
'       (select substr(EMAIL_ADDRESS,1,50)',
'        from WWV_FLOW_FND_USER',
'       where SECURITY_GROUP_ID = :flow_security_group_id and ',
'            USER_NAME= :app_user and rownum = 1) email,',
'       (select creation_date',
'        from WWV_FLOW_FND_USER',
'       where SECURITY_GROUP_ID = :flow_security_group_id and ',
'             USER_NAME= :app_user and rownum = 1) user_created,',
'       (select ',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              wwv_flow_lang.system_message(''NO'')',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              wwv_flow_lang.system_message(''YES'')',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              wwv_flow_lang.system_message(''NO'')',
'           else',
'              wwv_flow_lang.system_message(''NO'') ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id and USERID = :app_user and rownum = 1) user_privilege,',
'       (select ',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              wwv_flow_lang.system_message(''NO'')',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              wwv_flow_lang.system_message(''YES'')',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              wwv_flow_lang.system_message(''YES'')',
'           else',
'              wwv_flow_lang.system_message(''NO'')',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id and USERID = :app_user and rownum = 1) application_Developer',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Keine Entwicklungsaktivit\00E4t')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47027413731043129.4353)
,p_query_column_id=>1
,p_column_alias=>'YOUR_USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzername'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47028506851069487.4353)
,p_query_column_id=>2
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47028800927115137.4353)
,p_query_column_id=>3
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>6
,p_column_heading=>'E-Mail-Adresse'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47028915848115137.4353)
,p_query_column_id=>4
,p_column_alias=>'USER_CREATED'
,p_column_display_sequence=>5
,p_column_heading=>'Benutzer erstellt'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47027507283043129.4353)
,p_query_column_id=>5
,p_column_alias=>'USER_PRIVILEGE'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace-Administrator'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47027606772043129.4353)
,p_query_column_id=>6
,p_column_alias=>'APPLICATION_DEVELOPER'
,p_column_display_sequence=>4
,p_column_heading=>'Anwendungsentwickler'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47343220276012869.4353)
,p_plug_name=>'Benutzer und Gruppen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Zeigen Sie eine Zusammenfassung der Workspace-Benutzer an. Aktivit\00E4tsattribute werden entsprechend dem ausgew\00E4hlten Zeitrahmen angezeigt.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47628322357056758.4353)
,p_name=>'Benutzerstatus'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>70
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60e */',
'     sum(',
'         case ',
'         when (wwv_flow_fnd_user_api.end_user_account_days_left(',
'               wwv_flow_user_api.get_username(user_id)) > 0) ',
'         then 1',
'         else 0',
'         end) valid_passwords,',
'     sum(',
'         case ',
'         when (wwv_flow_fnd_user_api.end_user_account_days_left(',
'               wwv_flow_user_api.get_username(user_id)) > 0) ',
'         then 0',
'         else 1',
'         end) expired_passwords,',
'     sum(decode(nvl(u.account_locked,''N''),''Y'',1,0)) locked_accounts,',
'     sum(decode(nvl(u.account_locked,''N''),''Y'',0,1)) unlocked_accounts,',
'     sum(decode(u.email_address,null,1,0)) no_email_specified',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47628322357056758.4353)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47629025820057702.4353)
,p_query_column_id=>1
,p_column_alias=>'VALID_PASSWORDS'
,p_column_display_sequence=>1
,p_column_heading=>unistr('G\00FCltige Kennw\00F6rter')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47629127065057702.4353)
,p_query_column_id=>2
,p_column_alias=>'EXPIRED_PASSWORDS'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Abgelaufene Kennw\00F6rter')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47629710152072093.4353)
,p_query_column_id=>3
,p_column_alias=>'LOCKED_ACCOUNTS'
,p_column_display_sequence=>3
,p_column_heading=>'Gesperrte Accounts'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47629828778072093.4353)
,p_query_column_id=>4
,p_column_alias=>'UNLOCKED_ACCOUNTS'
,p_column_display_sequence=>4
,p_column_heading=>'Entsperrte Accounts'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47630110629081753.4353)
,p_query_column_id=>5
,p_column_alias=>'NO_EMAIL_SPECIFIED'
,p_column_display_sequence=>5
,p_column_heading=>'Keine E-Mail angegeben'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955889190717997302.4353)
,p_plug_name=>'Platzhalter'
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(167828417885635073.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47004408825920869.4353)
,p_button_name=>'MANAGE_USERS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_image_alt=>'Benutzer verwalten'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_security_scheme=>wwv_flow_api.id(12518728403445471)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47004908790920880.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47004408825920869.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47005119561923913.4353)
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30218521333841738.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'60'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00061
begin
wwv_flow_api.create_page(
 p_id=>61.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seiten-Caching Performance pro Seite'
,p_step_title=>'Seiten-Caching Performance pro Seite'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(231623005580185250.4353)
,p_name=>'Performance der gecachten Seite'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    flow_id,',
'    step_id,',
'    count(*),',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    avg(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_avg,',
'    min(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_min,',
'    max(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_max,',
'    sum(decode(page_mode,''R'',1,0)) cached_views,',
'    avg(decode(page_mode,''R'',elap,null)) cached_views_avg,',
'    min(decode(page_mode,''R'',elap,null)) cached_views_min,',
'    max(decode(page_mode,''R'',elap,null)) cached_views_max',
'from WWV_FLOW_ACTIVITY_LOG',
'where security_group_id = :flow_security_group_id and ',
'      time_stamp >= sysdate - nvl(:p61_time,1) and',
'      (:p61_user is null or instr(userid,upper(:p61_user)) > 0 ) and',
'      (:p61_flow is null or flow_id = :p61_flow) and',
'      (:p61_page is null or step_id = :p61_page) and',
'      (:flow_security_group_id = 10 or flow_id not between 4000 and 4999)',
'group by flow_id, step_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(6659715068668103.4353)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden.'
,p_query_num_rows_item=>'P61_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Herunterladen'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 29-NOV-2002 09:59:34'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231623604289185255.4353)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Anwendung'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231623725824185255.4353)
,p_query_column_id=>2
,p_column_alias=>'STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Seite'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231636620283250883.4353)
,p_query_column_id=>3
,p_column_alias=>'COUNT(*)'
,p_column_display_sequence=>3
,p_column_heading=>'Ansichten'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231630720105212957.4353)
,p_query_column_id=>4
,p_column_alias=>'DYNAMIC_VIEWS'
,p_column_display_sequence=>4
,p_column_heading=>'Dynamische Ansichten'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231630813154212957.4353)
,p_query_column_id=>5
,p_column_alias=>'DYNAMIC_VIEWS_AVG'
,p_column_display_sequence=>5
,p_column_heading=>'Durchschnitt'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231630929661212957.4353)
,p_query_column_id=>6
,p_column_alias=>'DYNAMIC_VIEWS_MIN'
,p_column_display_sequence=>6
,p_column_heading=>'Minimum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231631001189212958.4353)
,p_query_column_id=>7
,p_column_alias=>'DYNAMIC_VIEWS_MAX'
,p_column_display_sequence=>7
,p_column_heading=>'Maximum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231631106423212958.4353)
,p_query_column_id=>8
,p_column_alias=>'CACHED_VIEWS'
,p_column_display_sequence=>8
,p_column_heading=>'Gecachte Ansichten'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231631201524212958.4353)
,p_query_column_id=>9
,p_column_alias=>'CACHED_VIEWS_AVG'
,p_column_display_sequence=>9
,p_column_heading=>'Durchschnitt'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231631330699212958.4353)
,p_query_column_id=>10
,p_column_alias=>'CACHED_VIEWS_MIN'
,p_column_display_sequence=>10
,p_column_heading=>'Minimum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231631420325212958.4353)
,p_query_column_id=>11
,p_column_alias=>'CACHED_VIEWS_MAX'
,p_column_display_sequence=>11
,p_column_heading=>'Maximum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231624522756185257.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231627203542185270.4353)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(231624522756185257.4353)
,p_button_name=>'P61_GO'
,p_button_static_id=>'P61_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231628005946185275.4353)
,p_branch_action=>'61'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231624727504185257.4353)
,p_name=>'P61_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(231624522756185257.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Zeitrahmen f\00FCr die Suche aus.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231625218731185265.4353)
,p_name=>'P61_USER'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(231624522756185257.4353)
,p_prompt=>'Benutzer'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Um nach Benutzer zu filtern, geben Sie einen Benutzernamen ein und klicken anschlie\00DFend auf <strong>Los</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231625727901185266.4353)
,p_name=>'P61_FLOW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(231624522756185257.4353)
,p_prompt=>'Anwendung'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Um nach Anwendung zu filtern, geben Sie eine Anwendungs-ID ein und klicken anschlie\00DFend auf <strong>Los</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231626200649185267.4353)
,p_name=>'P61_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(231624522756185257.4353)
,p_prompt=>'Seite'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Geben Sie eine Seite f\00FCr den Bericht an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231626702193185269.4353)
,p_name=>'P61_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(231624522756185257.4353)
,p_item_default=>'20'
,p_prompt=>'Zeilen'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,50,100,200,500,1000,5000'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Anzahl der Zeilen, die angezeigt werden sollen, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231627401261185271.4353)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P61_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(231625727901185266.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231627607194185273.4353)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P61_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(231626200649185267.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(231627813188185273.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00062
begin
wwv_flow_api.create_page(
 p_id=>62.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Anwendungsfehler'
,p_step_title=>'Anwendungsfehler'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9823818362293578.4353)
,p_plug_name=>'Anwendungsfehler'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P62a */ /*+ FIRST_ROWS(21) */',
'	 utl_i18n.unescape_reference(sqlerrm) sqlerrm, -- prevent over-escaping; column has Escape Special Characters = true',
'	 USERID,',
'	 FLOW_ID application,',
'	 STEP_ID page,',
'	 SESSION_ID,',
'	 TIME_STAMP,',
'     sqlerrm_component_type,',
'     sqlerrm_component_name,',
'     debug_page_view_id',
' from WWV_FLOW_ACTIVITY_LOG',
'where security_group_id = :flow_security_group_id',
'  and sqlerrm is not null',
'  and time_stamp >= sysdate - nvl(:P62_TIME,1)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9823928358293578.4353)
,p_name=>'Application Errors'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824329546293581.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824418129293581.4353)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824204038293581.4353)
,p_db_column_name=>'USERID'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824603394293582.4353)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Datum'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824105979293581.4353)
,p_db_column_name=>'SQLERRM'
,p_display_order=>5
,p_column_identifier=>'A'
,p_column_label=>'Fehlermeldung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824714138293582.4353)
,p_db_column_name=>'SQLERRM_COMPONENT_TYPE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Kontext'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824832214293582.4353)
,p_db_column_name=>'SQLERRM_COMPONENT_NAME'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Komponente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9824506005293582.4353)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>8
,p_column_identifier=>'E'
,p_column_label=>'Session'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RR,29:IREQ_SESSION_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(787517387018850122.4353)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>'Debugging-ID'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,24:P24_PAGE_VIEW_ID:#DEBUG_PAGE_VIEW_ID#'
,p_column_linktext=>'#DEBUG_PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(211672831474340524.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450636024120991561.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(211672831474340524.4353)
,p_button_name=>'P62_GO'
,p_button_static_id=>'P62_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184358929848038872.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(211672831474340524.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:62,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(211681529393379974.4353)
,p_branch_action=>'f?p=&FLOW_ID.:62:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211692922395432530.4353)
,p_name=>'P62_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(211672831474340524.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, '),
'',
unistr('die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00063
begin
wwv_flow_api.create_page(
 p_id=>63.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Betriebssystem'
,p_step_title=>'Seitenansichten pro Betriebssystem'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10287529721985354.4353)
,p_plug_name=>'Seitenansichten pro Betriebssystem'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(select /* APEX4350P63a */ count(*) a ',
'from wwv_flow_activity_log ',
'where security_group_id = :flow_security_group_id and ',
'time_stamp >= sysdate - nvl(:P63_TIME,1)) ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, max(decode(user_agent,null,''  '',',
'       nvl(',
'       decode(instr(lower(user_agent),''mac os x''),0,'''',''Mac OS X'')||',
'       decode(instr(lower(user_agent),''linux''),0,'''',''Linux'')||',
'       decode(instr(lower(user_agent),''windows nt 5.0''),0,'''',''Windows 2000'')||',
'       decode(instr(lower(user_agent),''windows nt 5.1''),0,'''',''Windows XP'')||',
'       decode(instr(lower(user_agent),''windows nt 7.0''),0,'''',''Windows 7'')||',
'       decode(instr(lower(user_agent),''windows nt 6.0''),0,'''',''Windows Vista'')||',
'       decode(instr(lower(user_agent),''windows nt 6.1''),0,'''',''Windows 7'')||',
'       decode(instr(lower(user_agent),''windows nt 6.2''),0,'''',''Windows 8'')||',
'       decode(instr(lower(user_agent),''windows nt 6.3''),0,'''',''Windows 8.1'')||    ',
'       decode(instr(lower(user_agent),''windows nt 10.0''),0,'''',''Windows 10''),',
'       ''Other''))) os, count(*) c',
'from wwv_flow_activity_log',
'where security_group_id = :flow_security_group_id',
'       and page_mode != ''A''',
'       and time_stamp >= sysdate - nvl(:P63_TIME,1)',
'group by session_id',
') x',
'group by os) d, total_count'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10287608164985354.4353)
,p_name=>'Page Views By Operating System'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10287804767985355.4353)
,p_db_column_name=>'OS'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Betriebssystem'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10287902469985355.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10288021409985356.4353)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Prozentsatz'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10288102347985356.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107705722979008325.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450807025270250213.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(107705722979008325.4353)
,p_button_name=>'P63_GO'
,p_button_static_id=>'P63_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(430061325545405776.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(107705722979008325.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:63,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(450807202005250214.4353)
,p_branch_action=>'f?p=&FLOW_ID.:63:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3176719630549097.4353)
,p_name=>'P63_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107705722979008325.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00064
begin
wwv_flow_api.create_page(
 p_id=>64.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Browser'
,p_step_title=>'Seitenansichten pro Browser'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10282703232952066.4353)
,p_plug_name=>'Seitenansichten pro Browser'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(select /* APEX4350P64a */ count(*) a ',
'from wwv_flow_activity_log ',
'where security_group_id = :flow_security_group_id and ',
'user_agent is not null and',
'time_stamp >= sysdate - nvl(:P64_TIME,1)) ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, max(',
'       (case ',
'          when instr(lower(user_agent),''msie'') > 0 then ''MSIE''',
'          when instr(lower(user_agent),''firefox'') > 0 then ''Firefox''',
'          when instr(lower(user_agent),''chrome'') > 0 then ''Chrome''',
'          when instr(lower(user_agent),''opera'') > 0 then ''Opera''',
'          when instr(lower(user_agent),''applewebkit'') > 0 then ''Safari''',
'          when instr(lower(user_agent),''safari'') > 0 then ''Safari''',
'          else ''Other''',
'       end ) ) os,',
'       count(*) c',
'from wwv_flow_activity_log',
'where security_group_id = :flow_security_group_id',
'       and user_agent is not null',
'       and time_stamp >= sysdate - nvl(:P64_TIME,1)',
'group by session_id',
') x',
'group by os) d, total_count'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Der Benutzer-Agent wird nur f\00FCr die erste Ansicht einer Benutzersession protokolliert.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10282831738952066.4353)
,p_name=>'Page Views By Browser'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10283021922952070.4353)
,p_db_column_name=>'OS'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Browser'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10283123000952070.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10283225584952070.4353)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Prozentsatz'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10283319370952070.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108232131347078237.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200776422932625565.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(108232131347078237.4353)
,p_button_name=>'P64_SET'
,p_button_static_id=>'P64_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200776004578620262.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(108232131347078237.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:64,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3189523196682526.4353)
,p_branch_action=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3187912114679378.4353)
,p_name=>'P64_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108232131347078237.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_api.create_page(
 p_id=>65.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seiten-Performance'
,p_step_title=>'Seitenansichten pro Benutzer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7431322625516464.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7431522370516465.4353)
,p_name=>'Seitenansichten'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id, step_id, elap, userid , num_rows, time_stamp, session_id',
'from wwv_flow_activity_log',
'    where time_stamp >= (sysdate - :P65_DATE) ',
'    and security_group_id = :flow_security_group_id',
'    and (:app_security_group_id = 10 or flow_id not between 4000 and 4999)',
'  and flow_id = :P65_APPLICATION and step_id = :P65_page'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(6659715068668103.4353)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden.'
,p_query_num_rows_item=>'P65_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7434815944525496.4353)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Anwendung'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7434928870525496.4353)
,p_query_column_id=>2
,p_column_alias=>'STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Seite'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7435011919525496.4353)
,p_query_column_id=>3
,p_column_alias=>'ELAP'
,p_column_display_sequence=>3
,p_column_heading=>'Verstrichene Zeit'
,p_column_format=>'999G999G999G999G990D0000'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7435117103525496.4353)
,p_query_column_id=>4
,p_column_alias=>'USERID'
,p_column_display_sequence=>4
,p_column_heading=>'Benutzer'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7448511751571566.4353)
,p_query_column_id=>5
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>5
,p_column_heading=>'Berichtszeilen'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7448627754571566.4353)
,p_query_column_id=>6
,p_column_alias=>'TIME_STAMP'
,p_column_display_sequence=>6
,p_column_heading=>'Datum'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7454300024596530.4353)
,p_query_column_id=>7
,p_column_alias=>'SESSION_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Session'
,p_column_link=>'f?p=4350:19:&SESSION.::NO:RP,:P19_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7432704933516474.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(7431322625516464.4353)
,p_button_name=>'65_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7433631510516483.4353)
,p_branch_action=>'65'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
,p_branch_comment=>'Generated 28-NOV-2002 23:10:50'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7432206165516470.4353)
,p_name=>'P65_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7431322625516464.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Zeitrahmen f\00FCr die Suche aus.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7432925561516475.4353)
,p_name=>'P65_ROWS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(7431322625516464.4353)
,p_item_default=>'20'
,p_prompt=>'Zeilen'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,50,100,200,500,1000,5000'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Anzahl der Zeilen, die angezeigt werden sollen, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7441403870550395.4353)
,p_name=>'P65_APPLICATION'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(7431322625516464.4353)
,p_prompt=>'Anwendung:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt die ausgew\00E4hlte Anwendung an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7442009411551982.4353)
,p_name=>'P65_PAGE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(7431322625516464.4353)
,p_prompt=>'Seite:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt die ausgew\00E4hlte Seite an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7433417398516480.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00066
begin
wwv_flow_api.create_page(
 p_id=>66.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Datenbankschema anfordern - Best\00E4tigen')
,p_step_title=>unistr('Datenbankschema anfordern - Best\00E4tigen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32643808441237723.4353)
,p_plug_name=>'request schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47297014014256767.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177082418885844451.4353)
,p_plug_name=>unistr('Best\00E4tigung')
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208560620383342557.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113874768695875.4353)
,p_plug_name=>'Datenbankschema anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177083008639844469.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208560620383342557.4353)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177082609759844459.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208560620383342557.4353)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177082802719844469.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208560620383342557.4353)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Fertigstellen'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177087718493844511.4353)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177087913566844514.4353)
,p_branch_action=>'48'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(177083008639844469.4353)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177084702792844486.4353)
,p_name=>'P66_RESTRICTED_SCHEMA_WARNING'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(177082418885844451.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Warnung'
,p_post_element_text=>'<p />'
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4700.P26_WARN_RESTRICTED_SCHEMA'',p0=>v(''PRODUCT_NAME''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from dual where',
' wwv_flow_provisioning.restricted_schema_i(:SR_NAME,wwv_flow_security.find_company_name(:WORKSPACE_ID)) = ''1'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(805713983989099558.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177084927778844486.4353)
,p_name=>'P66_SHARED_SCHEMA_WARNING'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(177082418885844451.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Warnung'
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4700.P26_WARN_SHARED_SCHEMA'',p0=>v(''PRODUCT_NAME''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_display_when=>'select 1 from wwv_flow_company_schemas where schema = upper(:SR_NAME)'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(805713983989099558.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(246264012675587717.4353)
,p_name=>'P66_REQUEST'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(177082418885844451.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Anfordern'
,p_post_element_text=>'<p />'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P48_NEW=''YES'' then',
'return wwv_flow_lang.system_message(p_name=>''F4350.CONFIRM_SCHEMA_NEW'',p0=>:SR_NAME);',
'else',
'return wwv_flow_lang.system_message(p_name=>''F4350.CONFIRM_SCHEMA_EXISTING'',p0=>:SR_NAME);',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(805713983989099558.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(245495300905083394.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'make request'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.make_modification_request (',
'    p_service_name        => ''NEW_SCHEMA'',',
'    p_service_attribute_1 => upper(:SR_NAME),',
'    p_service_attribute_2 => wwv_flow_user_api.get_email(p_username => upper(wwv_flow.g_user)));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim Weiterleiten einer Provisioning-Anforderung f\00FCr ein zus\00E4tzliches Workspace-Schema')
,p_process_when_button_id=>wwv_flow_api.id(177082802719844469.4353)
,p_process_success_message=>unistr('Die Provisioning-Anforderung f\00FCr ein zus\00E4tzliches Workspace-Schema wurde weitergeleitet.')
,p_security_scheme=>wwv_flow_api.id(916538108136873611)
);
end;
/
prompt --application/pages/page_00067
begin
wwv_flow_api.create_page(
 p_id=>67.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seiten-Caching-Performance pro Anwendung'
,p_step_title=>'Seiten-Caching-Performance pro Anwendung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(231651204956355825.4353)
,p_name=>'Performance der gecachten Anwendung'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    flow_id,',
'    count(*),',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    avg(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_avg,',
'    min(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_min,',
'    max(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_max,',
'    sum(decode(page_mode,''R'',1,0)) cached_views,',
'    avg(decode(page_mode,''R'',elap,null)) cached_views_avg,',
'    min(decode(page_mode,''R'',elap,null)) cached_views_min,',
'    max(decode(page_mode,''R'',elap,null)) cached_views_max',
'from WWV_FLOW_ACTIVITY_LOG',
'where security_group_id = :flow_security_group_id and ',
'      time_stamp >= sysdate - nvl(:p67_time,1) and',
'      (:p67_user is null or instr(userid,upper(:p67_user)) > 0 ) and',
'      (:p67_flow is null or flow_id = :p67_flow) and',
'      (:flow_security_group_id = 10 or flow_id not between 4000 and 4999)',
'group by flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(6659715068668103.4353)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden.'
,p_query_num_rows_item=>'P67_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Herunterladen'
,p_comment=>'generated 29-NOV-2002 09:59:34'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231652312962355827.4353)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Anwendung'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231651421644355826.4353)
,p_query_column_id=>2
,p_column_alias=>'COUNT(*)'
,p_column_display_sequence=>2
,p_column_heading=>'Ansichten'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231651531679355826.4353)
,p_query_column_id=>3
,p_column_alias=>'DYNAMIC_VIEWS'
,p_column_display_sequence=>3
,p_column_heading=>'Dynamische Ansichten'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231651603288355826.4353)
,p_query_column_id=>4
,p_column_alias=>'DYNAMIC_VIEWS_AVG'
,p_column_display_sequence=>4
,p_column_heading=>'Durchschnitt'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231651728696355826.4353)
,p_query_column_id=>5
,p_column_alias=>'DYNAMIC_VIEWS_MIN'
,p_column_display_sequence=>5
,p_column_heading=>'Minimum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231651801794355827.4353)
,p_query_column_id=>6
,p_column_alias=>'DYNAMIC_VIEWS_MAX'
,p_column_display_sequence=>6
,p_column_heading=>'Maximum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231651918587355827.4353)
,p_query_column_id=>7
,p_column_alias=>'CACHED_VIEWS'
,p_column_display_sequence=>7
,p_column_heading=>'Gecachte Ansichten'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231652014723355827.4353)
,p_query_column_id=>8
,p_column_alias=>'CACHED_VIEWS_AVG'
,p_column_display_sequence=>8
,p_column_heading=>'Durchschnitt'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231652119430355827.4353)
,p_query_column_id=>9
,p_column_alias=>'CACHED_VIEWS_MIN'
,p_column_display_sequence=>9
,p_column_heading=>'Minimum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(231652206725355827.4353)
,p_query_column_id=>10
,p_column_alias=>'CACHED_VIEWS_MAX'
,p_column_display_sequence=>10
,p_column_heading=>'Maximum'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231652725358355828.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231655430238355834.4353)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(231652725358355828.4353)
,p_button_name=>'P67_GO'
,p_button_static_id=>'P67_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231656209964355838.4353)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231652925714355829.4353)
,p_name=>'P67_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(231652725358355828.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Zeitrahmen f\00FCr die Suche aus.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231653429287355830.4353)
,p_name=>'P67_USER'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(231652725358355828.4353)
,p_prompt=>'Benutzer'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Um nach Benutzer zu filtern, geben Sie einen Benutzernamen ein und klicken anschlie\00DFend auf <strong>Los</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231653924321355831.4353)
,p_name=>'P67_FLOW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(231652725358355828.4353)
,p_prompt=>'Anwendung'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Um nach Anwendung zu filtern, geben Sie eine Anwendungs-ID ein und klicken anschlie\00DFend auf <strong>Los</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231654901550355833.4353)
,p_name=>'P67_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(231652725358355828.4353)
,p_item_default=>'15'
,p_prompt=>'Zeilen'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,50,100,200,500,1000,5000'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Anzahl der Zeilen, die angezeigt werden sollen, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231655810439355835.4353)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P67_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(231653924321355831.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231655612507355834.4353)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P67_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(231654413812355832.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(231656019846355836.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00068
begin
wwv_flow_api.create_page(
 p_id=>68.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Kennwort \00E4ndern')
,p_step_title=>unistr('Kennwort \00E4ndern')
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_javascript_code_onload=>'$("#P68_CONFIRM_PASSWORD_CONTAINER .a-Login-iconValidation.icon-check").attr("id","confirm_check");'
,p_step_template=>wwv_flow_api.id(797616476051845768.4353)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8156126956870309.4353)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_PASSWORD := null;',
':P68_CONFIRM_PASSWORD := null;',
':P68_ENTER_CURRENT_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8156307899870309.4353)
,p_plug_name=>unistr('Kennwort \00E4ndern')
,p_region_css_classes=>'a-Form--stretchInputs'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797573769515479165.4353)
,p_plug_display_sequence=>14
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'CONFIRM'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620834693002373109.4353)
,p_plug_name=>unistr('Eingeschr\00E4nkter Endbenutzerzugriff')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_region_attributes=>'style="width:auto;"'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('<p>&P68_USER_NAME., da Sie kein Entwickler in diesem Workspace sind, k\00F6nnen Sie nur Ihr Kennwort auf dieser Seite \00E4ndern.</p>')
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P68_IS_END_USER'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8156708906870311.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Kennwort \00E4ndern')
,p_button_position=>'NEXT'
,p_button_condition=>'P68_USER_SGID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(620834709155373110.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_button_name=>'RETURN_TO_LOGIN'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zu Anmeldeseite zur\00FCckgehen')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4550:1:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8157104633870312.4353)
,p_name=>'P68_USER_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_prompt=>'Benutzername'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_css_classes=>'u-textLower'
,p_display_when=>'P68_USER_SGID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(797617751200847238.4353)
,p_item_css_classes=>'icon-login-username'
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8157624556870314.4353)
,p_name=>'P68_PASSWORD'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Neues Kennwort eingeben'
,p_placeholder=>'Neues Kennwort'
,p_post_element_text=>'<span class="a-Login-iconValidation a-Icon icon-remove is-danger" id="confirm_error" style="display: none;"></span><span class="a-Login-iconValidation a-Icon icon-check" id="confirm_check"></span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_display_when=>'P68_USER_SGID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(797617751200847238.4353)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8158108037870314.4353)
,p_name=>'P68_CONFIRM_PASSWORD'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Neues Kennwort best\00E4tigen')
,p_placeholder=>unistr('Kennwort best\00E4tigen')
,p_post_element_text=>'<span class="a-Login-iconValidation a-Icon icon-remove is-danger" id="confirm_error"></span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_display_when=>'P68_USER_SGID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(797617751200847238.4353)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8158623021870315.4353)
,p_name=>'P68_ENTER_CURRENT_PASSWORD'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_prompt=>'Aktuelles Kennwort eingeben'
,p_placeholder=>'Aktuelles Kennwort'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_display_when=>'P68_ASK_CURRENT'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(797617751200847238.4353)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12371025948321672.4353)
,p_name=>'P68_USER_SGID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(620834876264373111.4353)
,p_name=>'P68_IS_END_USER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1617424838043257710.4353)
,p_name=>'P68_ASK_CURRENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1617425085874257712.4353)
,p_name=>'P68_USER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8156307899870309.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(492140308650710920.4353)
,p_validation_name=>'P68_USER_NAME'
,p_validation_sequence=>1
,p_validation=>'P68_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Der Benutzername ist nicht verf\00FCgbar. Schlie\00DFen Sie den Browser vollst\00E4ndig. Nach dem Neustart des Browsers sollte der Benutzername korrekt angezeigt werden.')
,p_when_button_pressed=>wwv_flow_api.id(8156708906870311.4353)
,p_associated_item=>wwv_flow_api.id(8157104633870312.4353)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8159201565870317.4353)
,p_validation_name=>'P68_ENTER_CURRENT_PASSWORD'
,p_validation_sequence=>10
,p_validation=>'P68_ENTER_CURRENT_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Das Kennwort muss angegeben werden.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')',
'and :P68_ASK_CURRENT = ''Y'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(8158623021870315.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8159407041870317.4353)
,p_validation_name=>'P68_PASSWORD Not Null'
,p_validation_sequence=>20
,p_validation=>'P68_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Das Kennwort muss angegeben werden.'
,p_validation_condition=>'P68_CONFIRM_PASSWORD,Save'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(8157624556870314.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 07-AUG-2002 16:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8159625001870317.4353)
,p_validation_name=>'P68_CONFIRM_PASSWORD Not Null'
,p_validation_sequence=>30
,p_validation=>'P68_CONFIRM_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('"Kennwort best\00E4tigen" muss angegeben werden.')
,p_validation_condition=>'P68_CONFIRM_PASSWORD,Save'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(8158108037870314.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 07-AUG-2002 16:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8159816351870318.4353)
,p_validation_name=>'passwd = confirm passwd'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P68_PASSWORD != :P68_CONFIRM_PASSWORD then',
'  :P68_PASSWORD := null;',
'  :P68_CONFIRM_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Die Kennwortbest\00E4tigung stimmt nicht mit dem Kennwort \00FCberein.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_PASSWORD is not null and :P68_CONFIRM_PASSWORD is not null',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(8158108037870314.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8160202229870318.4353)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.is_workspace_password_valid (',
'           p_workspace_id => :P68_USER_SGID,',
'           p_username     => :P68_USER_NAME,',
'           p_password     => :P68_ENTER_CURRENT_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltiges Kennwort')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_ENTER_CURRENT_PASSWORD is not null',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')',
'and :P68_ASK_CURRENT = ''Y'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(8158623021870315.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25683811693736222.4353)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_workspace_name   varchar2(4000) := wwv_flow_security.find_company_name(:P68_USER_SGID);',
'  l_use_strong_rules boolean;',
'begin',
'  l_use_strong_rules := nvl(wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD''),''N'') = ''Y''',
'                        and l_workspace_name = ''INTERNAL'';',
'  return wwv_flow_security.strong_password_validation (',
'      p_username              => :P68_USER_NAME,',
'      p_password              => :P68_PASSWORD,',
'      p_old_password          => :P68_ENTER_CURRENT_PASSWORD,',
'      p_workspace_name        => l_workspace_name,',
'      p_use_strong_rules      => l_use_strong_rules );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(374506600102087826.4353)
,p_name=>'Password match'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P68_CONFIRM_PASSWORD'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$("#P68_CONFIRM_PASSWORD").val() === $("#P68_PASSWORD").val() '
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(374506702297087827.4353)
,p_event_id=>wwv_flow_api.id(374506600102087826.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#confirm_check").show();',
'$("#confirm_error").hide();'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(374506809011087828.4353)
,p_event_id=>wwv_flow_api.id(374506600102087826.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#confirm_check").hide();',
'$("#confirm_error").show();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(374506951597087829.4353)
,p_name=>'Do Passwords Match'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P68_CONFIRM_PASSWORD'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$("#P68_CONFIRM_PASSWORD").val() != $("#P68_PASSWORD").val() '
,p_bind_type=>'bind'
,p_bind_event_type=>'focusout'
,p_display_when_type=>'NEVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(374507076362087830.4353)
,p_event_id=>wwv_flow_api.id(374506951597087829.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#confirm_error").show();'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(374507147182087831.4353)
,p_event_id=>wwv_flow_api.id(374506951597087829.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#confirm_error").hide();'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8160323013870319.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_login.change_password_and_log_in (',
'    p_workspace_id => :P68_USER_SGID,',
'    p_username     => :P68_USER_NAME,',
'    p_new_password => :P68_PASSWORD );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim \00C4ndern von Kennwort.')
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_PASSWORD = :P68_CONFIRM_PASSWORD ',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Kennwort wurde ge\00E4ndert.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1617424418589257706.4353)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Is End User'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_user in ( select user_name,',
'                       security_group_id',
'                  from wwv_flow_fnd_user',
'                 where user_id = :P68_USER_ID )',
'loop',
'    :P68_USER_SGID   := l_user.security_group_id;',
'    :P68_USER_NAME   := l_user.user_name;',
'    :P68_IS_END_USER := case',
'                        when l_user.security_group_id=''10'' then ''N'' /*instance admin*/',
'                        when wwv_flow_fnd_user_int.get_user_roles (',
'                                 p_security_group_id => l_user.security_group_id,',
'                                 p_username          => l_user.user_name ) is null',
'                        then ''Y''',
'                        else ''N''',
'                        end;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Ung\00FCltiger Benutzercode')
,p_process_when=>'P68_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12359720551314582.4353)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set notification'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P68_IS_END_USER = ''N'' and nvl(:REQUEST,''xy5993-'') <> ''CONFIRM'' then ',
'    wwv_flow.g_notification := wwv_flow_lang.system_message(''PASSWORD_MUST_BE_CHANGED'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00069
begin
wwv_flow_api.create_page(
 p_id=>69.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Speicherung anfordern - Best\00E4tigen')
,p_step_title=>unistr('Speicherung anfordern - Best\00E4tigen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47302007175663547.4353)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47297014014256767.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47302213587663566.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(47296115483238304.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47305100924725759.4353)
,p_plug_name=>'Speicherplatz anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Best\00E4tigen Sie Ihre Anforderung.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208565622723362124.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113900410695875.4353)
,p_plug_name=>'Speicherplatz anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47307221272750562.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208565622723362124.4353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47303014767663580.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208565622723362124.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47303213706663589.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208565622723362124.4353)
,p_button_name=>'ADJUST_STORAGE_SIZE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Speicherplatz anfordern'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47304431358663641.4353)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47303412447663590.4353)
,p_name=>'P69_STORAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47305100924725759.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''C''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Hinzuzuf\00FCgende Speicherkapazit\00E4t (MB):')
,p_source=>'&P49_STORAGE.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den erforderlichen Speicherplatz an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47304023468663624.4353)
,p_validation_name=>'Validate storage request size'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
'   and req_size = :P49_STORAGE'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Ung\00FCltige Speicherkapazit\00E4t angefordert.')
,p_when_button_pressed=>wwv_flow_api.id(47303213706663589.4353)
,p_associated_item=>wwv_flow_api.id(47303412447663590.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47304116019663631.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'request change of size'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_changesize  number := :P49_STORAGE;',
'begin',
'  wwv_flow_provisioning.make_modification_request (',
'      p_service_name        => ''CHANGE_DB_SIZE'',',
'      p_service_attribute_1 => l_changesize,',
'      p_service_attribute_2 => wwv_flow_user_api.get_email(p_username => upper(wwv_flow.g_user)));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim Anfordern von zus\00E4tzlichem Speicherplatz.')
,p_process_when_button_id=>wwv_flow_api.id(47303213706663589.4353)
,p_process_success_message=>unistr('Sie haben zus\00E4tzliche &P49_STORAGE. MB Speicherplatz angefordert.')
,p_security_scheme=>wwv_flow_api.id(916538108136873611)
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_api.create_page(
 p_id=>70.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Anmeldeversuche'
,p_step_title=>'Anmeldeversuche'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12733116132664461.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(450591815485785448.4353)
,p_plug_name=>'Anmeldungen'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P70a */',
'upper(login_name) login_name,',
'application,',
'owner,',
'decode(authentication_method,''FND_ACCOUNT'',v(''PRODUCT_NAME''),',
'  ''CUSTOM'',wwv_flow_lang.system_message(''CUSTOM_AUTH_SCHEME_DESC''),',
'  ''$SITE_INTERNAL$'',wwv_flow_lang.system_message(''SERVICE_LOGIN''),',
'  ''$WORKSPACE_INTERNAL$'',wwv_flow_lang.system_message(''WORKSPACE_LOGIN''),',
'  ''DB ACCOUNT'',wwv_flow_lang.system_message(''DBACCOUNT_AUTH_SCHEME_DESC''),',
'  ''LDAP'',wwv_flow_lang.system_message(''LDAP_AUTH_SCHEME_DESC''),',
'   authentication_method) authentication_method,',
' access_date,',
'access_date access_date2,',
' ip_address,',
' remote_user,',
'decode(nvl(authentication_result,0),',
'0,m.AUTH_SUCCESS,',
'1,m.AUTH_UNKNOWN_USER,',
'2,m.AUTH_ACCOUNT_LOCKED,',
'3,m.AUTH_ACCOUNT_EXPIRED,',
'4,m.AUTH_PASSWORD_INCORRECT,',
'5,m.AUTH_PASSWORD_FIRST_USE,',
'6,m.AUTH_ATTEMPTS_EXCEEDED,',
'7,m.AUTH_INTERNAL_ERROR,',
'authentication_result) authentication_result,',
'custom_status_text,',
'authentication_result authentication_result_code',
'from   wwv_flow_user_access_log_v l,',
'(select',
'wwv_flow_lang.system_message(''AUTH_SUCCESS'') auth_success,',
'wwv_flow_lang.system_message(''AUTH_UNKNOWN_USER'') auth_unknown_user,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_LOCKED'') auth_account_locked,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_EXPIRED'') auth_account_expired,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_INCORRECT'') auth_password_incorrect,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_FIRST_USE'') auth_password_first_use,',
'wwv_flow_lang.system_message(''AUTH_ATTEMPTS_EXCEEDED'') auth_attempts_exceeded,',
'wwv_flow_lang.system_message(''AUTH_INTERNAL_ERROR'') auth_internal_error',
'from dual) m',
'where  security_group_id = :flow_security_group_id',
'and access_date >= sysdate - nvl(:p70_time,1)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'In diesem Bericht werden die aktuellen Anmeldungen bei Anwendungen in diesem Workspace angezeigt. Alle Endbenutzeranmeldungen bei Anwendungen, die die &PRODUCT_NAME.-Anmeldungs-API im Authentifizierungsschema verwenden, werden protokolliert.'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(450591914456785448.4353)
,p_name=>'Logins'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592121502785460.4353)
,p_db_column_name=>'LOGIN_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592213656785462.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592331673785463.4353)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Anwendungseigent\00FCmer')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592401150785464.4353)
,p_db_column_name=>'AUTHENTICATION_METHOD'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Authentifizierungsmethode'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592509011785465.4353)
,p_db_column_name=>'ACCESS_DATE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Anmeldedatum'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592622993785466.4353)
,p_db_column_name=>'ACCESS_DATE2'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Anmeldezeit'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592915591785469.4353)
,p_db_column_name=>'AUTHENTICATION_RESULT'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Authentifizierungsergebnis'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592722758785467.4353)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'IP-Adresse'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450593010180785469.4353)
,p_db_column_name=>'CUSTOM_STATUS_TEXT'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Benutzerdefinierter<br />Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450592816468785468.4353)
,p_db_column_name=>'REMOTE_USER'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>'Session-<br />benutzer'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340735915925751020.4353)
,p_db_column_name=>'AUTHENTICATION_RESULT_CODE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Code f\00FCr Authentifizierungsergebnis')
,p_display_in_default_rpt=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12734905755664463.4353)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(12733116132664461.4353)
,p_button_name=>'P70_GO'
,p_button_static_id=>'P70_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450595927040803209.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(12733116132664461.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42735601566885113.4353)
,p_name=>'P70_TIME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(12733116132664461.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00071
begin
wwv_flow_api.create_page(
 p_id=>71.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Dashboard f\00FCr Entwickleraktivit\00E4t')
,p_step_title=>unistr('Dashboard f\00FCr Entwickleraktivit\00E4t')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47329131074632655.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47329309079632659.4353)
,p_name=>'Topseiten'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P71c */ application||'':''||page_id||'' - ''||',
'       substr((select name ',
'               from wwv_flow_steps ',
'               where flow_id = q.application and id = q.page_id and security_group_id = :flow_security_group_id),1,20)',
'       application_page, ',
'       page_events',
'from (',
'select ',
'  flow_id application,',
'  page_id page_id,',
'  count(*) page_events',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id and',
'  flow_id is not null and',
'  page_id is not null',
'group by ',
'  flow_id, page_id',
'order by count(*) desc) q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47337230207807503.4353)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_PAGE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47337328266807503.4353)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47329800292632669.4353)
,p_name=>unistr('Aktuelle \00C4nderungen')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P71d */ lower(substr(developer,1,35)) developer,',
'       audit_date',
'from (',
'select ',
'  flow_id||'':''||page_id||'' - ''||flow_user developer,',
'  audit_date ',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id',
'order by audit_date desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47329800292632669.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47338028869835547.4353)
,p_query_column_id=>1
,p_column_alias=>'DEVELOPER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47338100649835547.4353)
,p_query_column_id=>2
,p_column_alias=>'AUDIT_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47330216560632671.4353)
,p_name=>'Topanwendungen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P71b */ application||'': ''||',
'       substr((select name from wwv_flows where id = q.application and security_group_id = :flow_security_group_id),1,20)',
'       application, ',
'       page_events',
'from (',
'select ',
'  flow_id application,',
'  count(*) page_events',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id and',
'  flow_id is not null',
'group by ',
'  flow_id',
'order by count(*) desc) q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47330216560632671.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47330424910632671.4353)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47330518229632671.4353)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47330824997632672.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47331015612632673.4353)
,p_name=>'Topentwickler'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P71a */  lower(substr(developer,1,25)) developer,',
'       page_events events',
'from (',
'select ',
'  flow_user developer,',
'  count(*) page_events',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id and',
'  flow_user is not null',
'group by ',
'  flow_user',
'order by count(*) desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47335420286738415.4353)
,p_query_column_id=>1
,p_column_alias=>'DEVELOPER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47337022804795953.4353)
,p_query_column_id=>2
,p_column_alias=>'EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47331502407632675.4353)
,p_name=>unistr('Letzte Bearbeitungsvorg\00E4nge f\00FCr Anwendungen')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>70
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(application||'': ''||',
'       substr((select name from wwv_flows where id = q.application),1,40),',
'       1,35)',
'       application, ',
'       audit_date',
'from (',
'select ',
'  flow_id application,',
'  max(audit_date) audit_date',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id',
'group by',
'   flow_id',
'order by 2 desc) q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47331502407632675.4353)
,p_plug_column_width=>' apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47338609738848986.4353)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47338704519848986.4353)
,p_query_column_id=>2
,p_column_alias=>'AUDIT_DATE'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47345001407045172.4353)
,p_plug_name=>unistr('Entwickleraktivit\00E4t')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Zeigen Sie eine Zusammenfassung der Anwendungs- und Seiten\00E4nderungen durch Entwickler f\00FCr den ausgew\00E4hlten Zeitrahmen an.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168426205915602709.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47329131074632655.4353)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Aktivit\00E4t \00FCberwachen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47332605505632683.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47329131074632655.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47333103023632698.4353)
,p_branch_action=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47332823415632688.4353)
,p_name=>'P71_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47329131074632655.4353)
,p_prompt=>'Anzeigen'
,p_source=>'select  3/24  t from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Zeitrahmen f\00FCr die Berichtserstellung an. Das Anzeigen gr\00F6\00DFerer Zeitrahmen kann mehr Zeit beanspruchen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00072
begin
wwv_flow_api.create_page(
 p_id=>72.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Workspace-Schemas'
,p_step_title=>'Workspace-Schemas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215677404159045218)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4926714172433408.4353)
,p_plug_name=>'Workspace-Schemas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Ihr Workspace ist berechtigt, SQL-Anweisungen mit folgenden Datenbankschemas zu parsen. Die Begriffe Datenbankschema und Datenbankbenutzer k\00F6nnen synonym verwendet werden.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47080910170530643.4353)
,p_plug_name=>'Workspace-Schemas'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P72a */',
'    schema,',
'    (select count(*) from sys.dba_sys_privs where grantee = c.schema) privs,',
'    (select count(*) from wwv_flows ',
'     where security_group_id = :flow_security_group_id and ',
'     owner = c.schema) flows',
'from WWV_FLOW_COMPANY_SCHEMAS c',
'where security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47081002154530643.4353)
,p_name=>'Workspace Schemas'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47081224767530656.4353)
,p_db_column_name=>'SCHEMA'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47081323558530662.4353)
,p_db_column_name=>'PRIVS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'DB-Berechtigungen'
,p_column_link=>'f?p=&FLOW_ID.:86:#FLOW_SESSION#:::RP:P86_SCHEMA:#SCHEMA#'
,p_column_linktext=>'#PRIVS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47081404348530663.4353)
,p_db_column_name=>'FLOWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4910310827337046.4353)
,p_branch_action=>'72'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00073
begin
wwv_flow_api.create_page(
 p_id=>73.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Facettensuche - Letzte Pageviews'
,p_step_title=>'Facettensuche - Letzte Pageviews'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(383691245467261189.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(392834092731162901.4353)
,p_name=>'Aktuelle Seitenansichten'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>24
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /*+ FIRST_ROWS(21) */',
'    time_stamp,',
'    elap *1000 milliseconds,',
'    num_rows query_rows,',
'    userid userid, ',
'    (select id||''. ''||name from wwv_flows where id = l.flow_id) application_name,',
'    (select id||''. ''||name from wwv_flow_steps where id = l.step_id and flow_id = l.flow_id) page_name,',
'    decode(sqlerrm,null,m.m_NO,m.m_YES) error_raised,',
'      case l.page_view_type',
'         when 0 then m.m_other',
'         when 1 then m.m_processing',
'         when 2 then m.m_rendering',
'         when 3 then m.m_ajax',
'         when 4 then m.m_logout',
'         when 5 then m.auth_callback',
'         end   page_view_type,',
'    case WHEN elap * 1000 >= 10000 then ''> 10 ''||m.m_seconds',
'            WHEN elap * 1000 >= 5000 then ''5 - 10 ''||m.m_seconds',
'            WHEN elap * 1000 >= 2000 then ''2 - 5 ''||m.m_seconds',
'            WHEN elap * 1000 >= 1000 then ''1 - 2 ''||m.m_seconds',
'            WHEN elap * 1000 >= 750  then ''750 - 1000 ''||m.m_ms',
'            WHEN elap * 1000 >= 500  then ''500 - 750 ''||m.m_ms',
'            WHEN elap * 1000 >= 250  then ''250 - 500 ''||m.m_ms',
'            WHEN elap * 1000 >= 100  then ''100 - 250 ''||m.m_ms',
'            WHEN elap * 1000 >= 50   then ''50 - 100 ''||m.m_ms',
'            else ''< 50 ''||m.m_ms end performance_bucket,',
'    case when time_stamp >= sysdate - (1/24) then ''< 1 ''||m.m_hour',
'            when time_stamp >= sysdate - (1/12) then ''1 - 2 ''||m.m_hours',
'            when time_stamp >= sysdate - (1/3)  then ''2 - 8 ''||m.m_hours',
'            when time_stamp >= sysdate - 1      then ''8 - 24 ''||m.m_hours',
'            when time_stamp >= sysdate - 2      then ''1 - 2 ''||m.m_days',
'            when time_stamp >= sysdate - 7      then ''2 - 7 ''||m.m_days',
'            else ''> 7 ''||m.m_days end timeframe_bucket,',
'     sqlerrm',
'from WWV_FLOW_ACTIVITY_LOG l,',
'   (select wwv_flow_lang.system_message(''SECONDS'') m_seconds,',
'           wwv_flow_lang.system_message(''HOURS'') m_hours,',
'           wwv_flow_lang.system_message(''HOUR'') m_hour,',
'           wwv_flow_lang.system_message(''DAYS'') m_days,',
'           wwv_flow_lang.system_message(''F4350_AJAX'') m_ajax,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.CHART_RENDERING.PROMPT'') m_rendering,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'') m_processing,',
'           wwv_flow_lang.system_message(''WWV_FLOW.LOGOUT'') m_logout,',
'           wwv_flow_lang.system_message(''F4350_AUTHENTICATION_CALLBACK'') auth_callback,',
'           wwv_flow_lang.system_message(''NO'') m_NO,',
'           wwv_flow_lang.system_message(''YES'') m_YES,',
'           wwv_flow_lang.system_message(''OTHER'') m_other,',
'           wwv_flow_lang.system_message(''MILLISECONDS_MS'') m_ms',
'    from dual) m',
'where security_group_id = :WORKSPACE_ID and ',
'      --flow_id not between 4000 and 4999 and',
'      time_stamp > sysdate - 7'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916432889655196610.4353)
,p_query_column_id=>1
,p_column_alias=>'TIME_STAMP'
,p_column_display_sequence=>1
,p_column_heading=>'Zeitstempel'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916435386992196635.4353)
,p_query_column_id=>2
,p_column_alias=>'MILLISECONDS'
,p_column_display_sequence=>5
,p_column_heading=>'Zeit (ms)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916433073859196612.4353)
,p_query_column_id=>3
,p_column_alias=>'QUERY_ROWS'
,p_column_display_sequence=>9
,p_column_heading=>'Zeilen abfragen'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916433140709196613.4353)
,p_query_column_id=>4
,p_column_alias=>'USERID'
,p_column_display_sequence=>2
,p_column_heading=>'Benutzer'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916433325586196615.4353)
,p_query_column_id=>5
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Anwendung'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916433464429196616.4353)
,p_query_column_id=>6
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Seite'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916435474183196636.4353)
,p_query_column_id=>7
,p_column_alias=>'ERROR_RAISED'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916436739682196649.4353)
,p_query_column_id=>8
,p_column_alias=>'PAGE_VIEW_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Typ'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916436212110196644.4353)
,p_query_column_id=>9
,p_column_alias=>'PERFORMANCE_BUCKET'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916436397298196645.4353)
,p_query_column_id=>10
,p_column_alias=>'TIMEFRAME_BUCKET'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(916436574370196647.4353)
,p_query_column_id=>11
,p_column_alias=>'SQLERRM'
,p_column_display_sequence=>11
,p_column_heading=>'Fehlermeldung'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(793348069796898716.4353)
,p_plug_name=>'Berichtsaktionen'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(916435595575196637.4353)
,p_plug_name=>'Suche'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(392834092731162901.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'E'
,p_attribute_08=>'#active_facets'
,p_attribute_09=>'N'
,p_attribute_13=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(397462569634814101.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(793348069796898716.4353)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RR,73::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(383554456377757409.4353)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(916435693556196638.4353)
,p_name=>'P73_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(916435595575196637.4353)
,p_prompt=>'Suche'
,p_source=>'USERID,APPLICATION_NAME,PAGE_NAME,PAGE_VIEW_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(916435751364196639.4353)
,p_name=>'P73_PAGE_VIEW_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(916435595575196637.4353)
,p_prompt=>'Typ'
,p_source=>'PAGE_VIEW_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(916435948347196641.4353)
,p_name=>'P73_APPLICATION_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(916435595575196637.4353)
,p_prompt=>'Anwendung'
,p_source=>'APPLICATION_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(916436002720196642.4353)
,p_name=>'P73_USERID'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(916435595575196637.4353)
,p_prompt=>'Benutzer'
,p_source=>'USERID'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(916436197252196643.4353)
,p_name=>'P73_ERROR_RAISED'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(916435595575196637.4353)
,p_prompt=>unistr('Ausgel\00F6ster Fehler')
,p_source=>'ERROR_RAISED'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(916436433845196646.4353)
,p_name=>'P73_PERFORMANCE_BUCKET'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(916435595575196637.4353)
,p_prompt=>'Performance'
,p_source=>'PERFORMANCE_BUCKET'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(383553283775757406.4353)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P73_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(383553612865757408.4353)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P73_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(383553973273757408.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00074
begin
wwv_flow_api.create_page(
 p_id=>74.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Bericht zu Seitenansichten pro Tag'
,p_alias=>'DAILY_USAGE'
,p_step_title=>'Bericht zu Seitenansichten pro Tag'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9414725804303289.4353)
,p_plug_name=>unistr('T\00E4gliche Verwendung')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P74a */',
'       the_date,',
'       to_char(the_date,''YYYYMMDD'') passable_date,',
'       to_char(the_date,''Day'') day_of_week,',
'       to_char(the_date,''Month'') month,',
'       flows applications,',
'       users users,',
'       avg_time,',
'       max_time,',
'       graph pct_of_total,',
'       cached_regions cached_region_views,',
'       cached_pages cached_page_views,',
'       hits page_events,',
'       page_views,',
'       page_posts,',
'       sessions,',
'       ip_addresses,',
'       content_length',
'from (',
'select ',
'  trunc(time_stamp) the_date,',
'  count(1) hits,',
'  sum(decode(page_mode,''A'',1,0)) page_posts,',
'  sum(decode(page_mode,''A'',0,1)) page_views,',
'  count(distinct l.FLOW_ID) flows,',
'  count(distinct l.USERID) users,',
'  count(distinct l.session_id) sessions,',
'  count(distinct l.ip_address) ip_addresses,',
'  avg(l.ELAP) avg_time,',
'  max(l.ELAP) max_time,',
'  ceil(greatest(trunc(100*to_number(count(1)))/nvl(l2.total_hits,1))) graph,',
'  sum(cached_regions) cached_regions,',
'  sum(decode(page_mode,''R'',1,0)) cached_pages,',
'  sum(nvl(content_length,0)) content_length',
'from wwv_flow_activity_log l, ',
'   ( select count(1) total_hits ',
'     from   wwv_flow_activity_log ',
'     where time_stamp >= sysdate - :P74_DATE and  ',
'            security_group_id = :app_security_group_id) l2',
'where security_group_id = :app_security_group_id and',
'          time_stamp >= sysdate - :P74_DATE ',
'group by trunc(time_stamp), to_char(time_stamp,''YYYYMMDD''), l2.total_hits',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9414825652303289.4353)
,p_name=>'Daily Usage '
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9415509703303291.4353)
,p_db_column_name=>'USERS'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9415600783303291.4353)
,p_db_column_name=>'AVG_TIME'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>'Durchschnittliche Dauer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9415725607303292.4353)
,p_db_column_name=>'MAX_TIME'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Maximale Dauer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FM999G999G999G999G990D0'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9415103029303291.4353)
,p_db_column_name=>'PASSABLE_DATE'
,p_display_order=>8
,p_column_identifier=>'B'
,p_column_label=>'Datum'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9418708487342884.4353)
,p_db_column_name=>'THE_DATE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Datum'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR,CIR:IR_DAY:#PASSABLE_DATE#'
,p_column_linktext=>'#THE_DATE#'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9420118230374155.4353)
,p_db_column_name=>'DAY_OF_WEEK'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9420204189374156.4353)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9420308298374156.4353)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Prozent von Gesamt'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9420426120374156.4353)
,p_db_column_name=>'CACHED_REGION_VIEWS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Gecachte Regionsansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9420512515374156.4353)
,p_db_column_name=>'CACHED_PAGE_VIEWS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Gecachte Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9422317107392664.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9425419924421856.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9425532175421856.4353)
,p_db_column_name=>'PAGE_POSTS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Seitenbeitr\00E4ge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9426020056431402.4353)
,p_db_column_name=>'SESSIONS'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9426111688431403.4353)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'IP-Adressen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9426826420442721.4353)
,p_db_column_name=>'MONTH'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Monat'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200592112694083310.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200589313686055284.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200590311175055291.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200589313686055284.4353)
,p_button_name=>'P74_SET'
,p_button_static_id=>'P74_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200589513125055288.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200589313686055284.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:74,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(65688607487081499.4353)
,p_name=>'P74_MONTH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(200589313686055284.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(65689110950082561.4353)
,p_name=>'P74_YEAR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(200589313686055284.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200589727148055289.4353)
,p_name=>'P74_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200589313686055284.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, die '),
'',
unistr('f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie "1 Tag" ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.   ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00075
begin
wwv_flow_api.create_page(
 p_id=>75.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Anwendung und Seite'
,p_step_title=>'Seitenansichten pro Anwendung und Seite'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9333706545598192.4353)
,p_plug_name=>'Aktuelle Seitenansichten'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P75a */',
'    flow_id application_id,',
'    (select name from wwv_flows where l.flow_id = id) application_name,',
'    step_id page_id,',
'    (select name from wwv_flow_steps where l.flow_id = flow_id and id = l.step_id)',
'       page_name,',
'    avg(elap) average_elapsed,',
'    count(distinct userid) distinct_users,',
'    count(distinct session_id) distinct_sessions,',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    sum(decode(page_mode,''D'',0,''C'',0,''A'',0,''P'',0,1)) static_views,',
'    sum(decode(page_mode,''A'',1,0)) page_processing,',
'    count(*) page_events,',
'    sum(decode(page_mode,''A'',0,1)) page_views,',
'    sum(decode(page_mode,''P'',1,0)) partial_page_views,',
'    sum(cached_regions) cached_regions,',
'    sum(nvl(CONTENT_LENGTH,0)) CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and ',
'      time_stamp >= sysdate - nvl(:p75_time,1) ',
'group by flow_id, step_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Spalten f\00FCr die verstrichene Zeit werden in Sekunden gemeldet.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9333811522598192.4353)
,p_name=>'Recent Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_download_filename=>'pagelog.csv'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334010730598193.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334107402598194.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334205659598194.4353)
,p_db_column_name=>'AVERAGE_ELAPSED'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Durchschnittlich verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334327729598194.4353)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Eindeutige Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334407901598194.4353)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Eindeutige Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334824883598195.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>6
,p_column_identifier=>'I'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334928340598195.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>7
,p_column_identifier=>'J'
,p_column_label=>'Seitenansichten'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:29,RIR:IR_FLOW_ID,IR_STEP_ID:#APPLICATION_ID#,#PAGE_ID#'
,p_column_linktext=>'#PAGE_VIEWS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334720032598195.4353)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Seitenverarbeitung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334504581598194.4353)
,p_db_column_name=>'DYNAMIC_VIEWS'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'Dynamische Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9334604255598194.4353)
,p_db_column_name=>'STATIC_VIEWS'
,p_display_order=>10
,p_column_identifier=>'G'
,p_column_label=>'Gecachte Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9335018746598195.4353)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Seitenbestandteil-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9335132030598195.4353)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Gecachte Regionen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1841307827980708.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1841404754980714.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200274628485602553.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Inhaltsl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25557900928584220.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(187863112933130731.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(25557900928584220.4353)
,p_button_name=>'P75_SET'
,p_button_static_id=>'P75_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200274719958609605.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(25557900928584220.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:75,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(131136302502658767.4353)
,p_branch_action=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25558617894584228.4353)
,p_name=>'P75_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(25557900928584220.4353)
,p_prompt=>'Seit'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein. Geben Sie die Dauer an, '),
'',
unistr('die f\00FCr den Bericht ber\00FCcksichtigt werden soll, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.<p />'),
unistr('Wenn Sie 1 Tag ausw\00E4hlen, werden nur die letzten 24 Stunden angezeigt.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00076
begin
wwv_flow_api.create_page(
 p_id=>76.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Workspace-Aktivit\00E4t pro Tag')
,p_step_title=>unistr('Workspace-Aktivit\00E4t pro Tag')
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(880560319171598064.4353)
,p_plug_name=>unistr('Workspace-Aktivit\00E4t pro Tag')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(880560786780598064.4353)
,p_region_id=>wwv_flow_api.id(880560319171598064.4353)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_initial_zooming=>'first'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'on'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(880561968177598065.4353)
,p_chart_id=>wwv_flow_api.id(880560786780598064.4353)
,p_seq=>10
,p_name=>'Datenreihe 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(LOG_DAY,''yyyy.mm.dd'') LOG_DAY_FORMAT,',
'       sum(page_events) PAGE_EVENTS,',
'       to_char(LOG_DAY,''yyyy.mm.dd'') ||'' - ''||sum(page_events) TOOLTIP',
' from WWV_FLOW_LOG_HISTORY ',
' where workspace_id = :flow_security_group_id and',
'       log_day >= sysdate - (NVL(:P76_SINCE,365)+1)',
'group by LOG_DAY',
'',
'',
'',
'',
''))
,p_items_value_column_name=>'PAGE_EVENTS'
,p_group_name_column_name=>'LOG_DAY_FORMAT'
,p_items_label_column_name=>'LOG_DAY_FORMAT'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(880561169222598065.4353)
,p_chart_id=>wwv_flow_api.id(880560786780598064.4353)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(880561594966598065.4353)
,p_chart_id=>wwv_flow_api.id(880560786780598064.4353)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1638624795426924351.4353)
,p_plug_name=>'Button Region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(880570927407645943.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1638624795426924351.4353)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(880571397489645944.4353)
,p_name=>'P76_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1638624795426924351.4353)
,p_item_default=>'365'
,p_prompt=>'Seit'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual  union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual  union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual  union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual  union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00077
begin
wwv_flow_api.create_page(
 p_id=>77.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Webservice-Aktivit\00E4tslog')
,p_step_title=>unistr('Webservice-Aktivit\00E4tslog')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(199844885760455501.4353)
,p_plug_name=>unistr('Webservice-Aktivit\00E4tslog')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(l.url,''/'',''/<wbr>'') "url", ',
'       l.http_method,',
'       l.content_length,',
'       l.status_code,',
'       l.resp_content_length,',
'       l.elapsed_sec,',
'       l.flow_user application_user,',
'       l.request_date',
' from wwv_flow_webservice_log l',
'where l.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(199844958697455502.4353)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'JASON'
,p_internal_uid=>199844958697455502
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845091982455503.4353)
,p_db_column_name=>'url'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845180444455504.4353)
,p_db_column_name=>'HTTP_METHOD'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'HTTP-Methode'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845263521455505.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>unistr('Inhaltsl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845341616455506.4353)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Statuscode'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845450932455507.4353)
,p_db_column_name=>'RESP_CONTENT_LENGTH'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>unistr('Anforderungsinhaltsl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845552594455508.4353)
,p_db_column_name=>'ELAPSED_SEC'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Abgelaufen (s)'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845685374455509.4353)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Anwendungsbenutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(199845831100455511.4353)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Anforderungsdatum'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(199842848545432289.4353)
,p_branch_action=>'77'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00078
begin
wwv_flow_api.create_page(
 p_id=>78.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Dashboard f\00FCr Seitenperformance')
,p_step_title=>unistr('Dashboard f\00FCr Seitenperformance')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47352717485454057.4353)
,p_plug_name=>'Seiten-Performance'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Die Seitenperformance f\00FCr die Seiten mit der schlechtesten Performance wird durch Multiplizieren der Seitenereignisse mit dem Medianwert f\00FCr die verstrichene Zeit f\00FCr die Seitenwiedergabe durch den Server berechnet. Die Seitenereignisse umfassen d')
||unistr('as Abrufen von Seiten und Seitenbestandteilen sowie das Bereitstellen von Seitenbeitr\00E4gen.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47353109345454129.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47354527507454133.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169333713395245920.4353)
,p_plug_name=>'Seiten-Performance'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P78a */',
'       application_id,',
'       page_id,',
'       substr((select name ',
'                 from wwv_flows ',
'                 where id = q.application_id),1,30) application_name,',
'       substr((select name ',
'                 from wwv_flow_steps ',
'                 where id = q.page_id ',
'                 and flow_id = q.application_id),1,30) page_name,',
'       page_events,',
'       median_elapsed_time,',
'       page_events * median_elapsed_time weighted_cost',
'from',
'(',
'select flow_id                  application_id, ',
'       step_id                  page_id, ',
'       count(*)                 page_events,',
'       median(elap)             median_elapsed_time,',
'       median(elap)*count(*)    weighted_median',
'from wwv_flow_activity_log l',
'where security_group_id = :flow_security_group_id and ',
'    (:app_security_group_id = 10 or flow_id not between 4000 and 4999) and',
'    time_stamp >= (sysdate - nvl(:P78_TIME,.125))',
'group by flow_id, step_id',
'order by 5 desc',
') q'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(169333814048245920.4353)
,p_name=>'Highest Weighted (Page events multiplied by median elapsed time)'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169334007414245927.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169334426112254508.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169334527617254511.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169334629806254511.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169334708691254512.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169334821938254512.4353)
,p_db_column_name=>'MEDIAN_ELAPSED_TIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Medianwert f\00FCr verstrichene Zeit')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169335527629264440.4353)
,p_db_column_name=>'WEIGHTED_COST'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Gewichtete Kosten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168428423455674045.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47353109345454129.4353)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Aktivit\00E4t \00FCberwachen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184360719768083311.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47353109345454129.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:78,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47356225121454151.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47353109345454129.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47357006428454166.4353)
,p_branch_action=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47356408929454155.4353)
,p_name=>'P78_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47353109345454129.4353)
,p_prompt=>'Anzeigen'
,p_source=>'select  3/24  t from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Zeitrahmen f\00FCr die Berichtserstellung an. Das Anzeigen gr\00F6\00DFerer Zeitrahmen kann mehr Zeit beanspruchen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_api.create_page(
 p_id=>79.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Datenbank-Dashboard'
,p_step_title=>'Datenbank-Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47385826626567270.4353)
,p_plug_name=>'Datenbank'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Zeigen Sie eine Zusammenfassung der Datenbankobjekte pro Schema an. Die Zeilenanzahl beruht auf den Datenbanktabellenstatistiken.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47386011360567273.4353)
,p_name=>'Zuletzt erstellte Tabellen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79c */ object_name,',
'       created, ',
'       object_id',
'from sys.dba_objects',
'where ',
'      object_name not like ''BIN$%'' and',
'      owner = :P79_SCHEMA and',
'      object_type = ''TABLE''',
'order by created desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47386011360567273.4353)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47392204279578734.4353)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Objektname'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47392309148578736.4353)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>2
,p_column_heading=>'Erstellt'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47392418555578739.4353)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Objekt-ID'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47386915474567281.4353)
,p_name=>unistr('Zuletzt ge\00E4nderte Programmbl\00F6cke')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79a */ object_name||'' - ''||lower(object_type) object_name,',
'       the_date',
'from (',
'select object_name,',
'       object_type,',
'       nvl(last_ddl_time,created) the_date, ',
'       object_id',
'       --owner, ',
'       --last_DDL_time, ',
'       --object_type',
'from sys.dba_objects',
'where ',
'      object_name not like ''BIN$%'' and',
'      owner = :P79_SCHEMA and',
'      object_type in (''PACKAGE'',''PACKAGE BODY'',''PROCEDURE'',''FUNCTION'',''TRIGGER'')',
'order by nvl(last_ddl_time,created) desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47397730785699847.4353)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47398210830703565.4353)
,p_query_column_id=>2
,p_column_alias=>'THE_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47387531298567282.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47387719649567283.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47388326573567284.4353)
,p_name=>'Anzahl Objekte'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79b */ object_type,',
'       count_of_objects',
'from (',
'select ',
'       object_type,',
'       count(*) count_of_objects',
'from sys.dba_objects',
'where ',
'      object_name not like ''BIN$%'' and',
'      owner = :P79_SCHEMA and',
'      object_type in (',
'        ''PACKAGE'',',
'        ''PACKAGE BODY'',',
'        ''PROCEDURE'',',
'        ''FUNCTION'',',
'        ''TRIGGER'',',
'        ''SEQUENCE'',',
'        ''VIEW'',',
'        ''TABLE'',',
'        ''SEQUNCE'',',
'        ''DATABASE LINK'',',
'        ''SYNONYM'',',
'        ''INDEX'')',
'group by object_type',
'order by 2 desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47388326573567284.4353)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47401812786770361.4353)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47401921711770361.4353)
,p_query_column_id=>2
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47389605673567291.4353)
,p_name=>'Toptabellen pro Zeilenanzahl'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79d */ table_name,',
'       num_rows',
'from (',
'select table_name,',
'       num_rows',
'from sys.dba_tables',
'where owner = :P79_SCHEMA and',
'      table_name not like ''DR$%IDX%'' and',
'      num_rows is not null',
'order by 2 desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47389605673567291.4353)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47403912318836436.4353)
,p_query_column_id=>1
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47403521191829525.4353)
,p_query_column_id=>2
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47390120449567291.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47387719649567283.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47391730194567302.4353)
,p_branch_action=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47395210652665698.4353)
,p_name=>'P79_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47387719649567283.4353)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(upper(c.schema)) d, ',
'       upper(c.schema) v',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u ',
'where  c.security_group_id = :flow_security_group_id and ',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :app_user and ',
'       (',
'           u.ALLOW_ACCESS_TO_SCHEMAS is null or ',
'           instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0',
'       )'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168453819941445045.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'79'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432754229162051527.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P79_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47395713339685353.4353)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>':P79_SCHEMA := upper(wwv_flow_user_api.get_default_schema);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P79_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432754418904057984.4353)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P79_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00080
begin
wwv_flow_api.create_page(
 p_id=>80.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Nach Anwendung und Monat'
,p_step_title=>'Nach Anwendung und Monat'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(383691245467261189.4353)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(395885337124084611.4353)
,p_plug_name=>'Suche'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(788752398959361811.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'E'
,p_attribute_08=>'#active_facets'
,p_attribute_09=>'N'
,p_attribute_13=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(395885828777084616.4353)
,p_plug_name=>'Berichtsaktionen'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(788752398959361811.4353)
,p_name=>unistr('Pageview-\00DCbersicht')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>24
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /*+ FIRST_ROWS(21) */',
'    to_char(log_day,''YYYY.MM'') Log_month,',
'    APPLICATION_ID||''. ''||APPLICATION_NAME APPLICATION_NAME,',
'    sum(page_events) PAGE_EVENTS,',
'    max(distinct_pages) MAX_DAILY_PAGES,',
'    max(DISTINCT_USERS) max_daily_users,',
'    max(DISTINCT_SESSIONS) max_daily_sessions,',
'    sum(ERROR_COUNT) errors_raised,',
'    median(AVERAGE_RENDER_TIME)*1000 median_elap,',
'    case WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 10000 then ''> 10 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 5000 then ''5 - 10 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 2000 then ''2 - 5 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 1000 then ''1 - 2 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 750  then ''750 - 1000 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 500  then ''500 - 750 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 250  then ''250 - 500 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 100  then ''100 - 250 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 50   then ''50 - 100 ''||m.m_ms',
'         else ''< 50 ''||m.m_ms end performance_bucket,',
'     application_id',
'from WWV_FLOW_LOG_HISTORY h,',
'   (select wwv_flow_lang.system_message(''SECONDS'') m_seconds,',
'           wwv_flow_lang.system_message(''HOURS'') m_hours,',
'           wwv_flow_lang.system_message(''HOUR'') m_hour,',
'           wwv_flow_lang.system_message(''DAYS'') m_days,',
'           wwv_flow_lang.system_message(''F4350_AJAX'') m_ajax,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.CHART_RENDERING.PROMPT'') m_rendering,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'') m_processing,',
'           wwv_flow_lang.system_message(''WWV_FLOW.LOGOUT'') m_logout,',
'           wwv_flow_lang.system_message(''F4350_AUTHENTICATION_CALLBACK'') auth_callback,',
'           wwv_flow_lang.system_message(''NO'') m_NO,',
'           wwv_flow_lang.system_message(''YES'') m_YES,',
'           wwv_flow_lang.system_message(''MILLISECONDS_MS'') m_ms',
'    from dual) m',
'where workspace_id = :flow_security_group_id',
'group by to_char(log_day,''YYYY.MM''), application_name, APPLICATION_ID, m.m_seconds, m.m_seconds, m.m_ms',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395884466766084602.4353)
,p_query_column_id=>1
,p_column_alias=>'LOG_MONTH'
,p_column_display_sequence=>2
,p_column_heading=>'Monat'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:RR,352:IR_APPLICATION_ID,IR_LOG_MONTH:#APPLICATION_ID#,#LOG_MONTH#'
,p_column_linktext=>'#LOG_MONTH#'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395921419795198916.4353)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Anwendung'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395884687226084604.4353)
,p_query_column_id=>3
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>3
,p_column_heading=>'Seitenereignisse'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395884805831084606.4353)
,p_query_column_id=>4
,p_column_alias=>'MAX_DAILY_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>'Maximale referenzierte Seiten'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395884944043084607.4353)
,p_query_column_id=>5
,p_column_alias=>'MAX_DAILY_USERS'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Maximale t\00E4gliche Benutzer')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395885034466084608.4353)
,p_query_column_id=>6
,p_column_alias=>'MAX_DAILY_SESSIONS'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Maximale t\00E4gliche Sessions')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395885182569084609.4353)
,p_query_column_id=>7
,p_column_alias=>'ERRORS_RAISED'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Ausgel\00F6ste Fehler')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395886047493084618.4353)
,p_query_column_id=>8
,p_column_alias=>'MEDIAN_ELAP'
,p_column_display_sequence=>8
,p_column_heading=>'Mittlere Zeit (ms)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395886153093084619.4353)
,p_query_column_id=>9
,p_column_alias=>'PERFORMANCE_BUCKET'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395886499842084622.4353)
,p_query_column_id=>10
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(395885954644084617.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(395885828777084616.4353)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:RR,80::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395885452726084612.4353)
,p_name=>'P80_APPLICATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(395885337124084611.4353)
,p_prompt=>'Anwendung'
,p_source=>'APPLICATION_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395885526647084613.4353)
,p_name=>'P80_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(395885337124084611.4353)
,p_prompt=>'Suche'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395885643103084614.4353)
,p_name=>'P80_LOG_MONTH'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(395885337124084611.4353)
,p_prompt=>'Monat'
,p_source=>'LOG_MONTH'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>24
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395886286146084620.4353)
,p_name=>'P80_PERFORMANCE_BUCKET'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(395885337124084611.4353)
,p_prompt=>'Medianwert Performance'
,p_source=>'PERFORMANCE_BUCKET'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>20
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
end;
/
prompt --application/pages/page_00081
begin
wwv_flow_api.create_page(
 p_id=>81.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Dashboard'
,p_step_title=>'Websheet-Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47435502788202636.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47436210227202642.4353)
,p_name=>'Zuletzt erstellte'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P81c */ name, ',
'       created_on',
'  from wwv_flow_ws_applications',
' where security_group_id = :flow_security_group_id',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47436210227202642.4353)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47440927948219434.4353)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47441003453219435.4353)
,p_query_column_id=>2
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47437210971202644.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47437929479202645.4353)
,p_name=>'Aktuelle Seitenansichten'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P81b */',
'    nvl((',
'    select  name n',
'      from  wwv_flow_ws_applications w',
'     where w.ID = q.websheet_id),q.websheet_id) websheet_name,',
'     time_stamp',
'from',
'(',
'select ',
'   websheet_id,',
'   max(time_stamp) time_stamp',
'from WWV_FLOW_ACTIVITY_LOG',
'where security_group_id = :flow_security_group_id and',
'      websheet_id is not null and',
'      time_stamp > sysdate - nvl(:P81_TIME,.125)',
'group by websheet_id',
'order by time_stamp desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47437929479202645.4353)
,p_plug_column_width=>'apex-col--leftBorder '
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47441903108269027.4353)
,p_query_column_id=>1
,p_column_alias=>'WEBSHEET_NAME'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47438202575202645.4353)
,p_query_column_id=>2
,p_column_alias=>'TIME_STAMP'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47438325533202645.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(166211911060758908.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(38499417503989888.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47438523327202645.4353)
,p_plug_name=>'Websheets'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Zeigen Sie eine Zusammenfassung der Websheet-Aktivit\00E4t f\00FCr den ausgew\00E4hlten Zeitrahmen an.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47443503856373252.4353)
,p_name=>'Zuletzt aktualisiert'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P81d */ name, ',
'       updated_on',
'  from wwv_flow_ws_applications',
' where security_group_id = :flow_security_group_id and',
'       updated_on is not null',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47443503856373252.4353)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47443813016373253.4353)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47444009397374908.4353)
,p_query_column_id=>2
,p_column_alias=>'UPDATED_ON'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47444211868403995.4353)
,p_name=>'Workspace-Zusammenfassung'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P81a */ count(*) websheet_count,',
'       sum(decode(status,''AVAILABLE'',1,0)) available,',
'       sum(decode(status,''UNAVAILABLE'',1,0)) unavailable,',
'       sum(decode(status,''DEVELOPERS_ONLY'',1,0)) developers_only,             ',
'       sum(decode(greatest(created_on,sysdate - 7), sysdate-7,0,1))',
'         created_last_week,',
'       sum(decode(greatest(nvl(updated_on,sysdate-8),sysdate - 7), ',
'         sysdate-7,0,1))',
'         updated_last_week',
'  from wwv_flow_ws_applications',
' where security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47444922781444997.4353)
,p_query_column_id=>1
,p_column_alias=>'WEBSHEET_COUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Websheet-Anwendungen'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(179289308782787760.4353)
,p_query_column_id=>2
,p_column_alias=>'AVAILABLE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Verf\00FCgbar')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(179289421380787761.4353)
,p_query_column_id=>3
,p_column_alias=>'UNAVAILABLE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nicht verf\00FCgbar')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(179289523848787761.4353)
,p_query_column_id=>4
,p_column_alias=>'DEVELOPERS_ONLY'
,p_column_display_sequence=>4
,p_column_heading=>'Nur Entwickler'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47446217849462479.4353)
,p_query_column_id=>5
,p_column_alias=>'CREATED_LAST_WEEK'
,p_column_display_sequence=>5
,p_column_heading=>'Erstellt in letzter Woche'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47448024560473848.4353)
,p_query_column_id=>6
,p_column_alias=>'UPDATED_LAST_WEEK'
,p_column_display_sequence=>6
,p_column_heading=>'Aktualisiert in letzter Woche'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47438719798202646.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47435502788202636.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47439517870202652.4353)
,p_branch_action=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47438927857202647.4353)
,p_name=>'P81_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47435502788202636.4353)
,p_prompt=>'Anzeigen'
,p_source=>'select  3/24  from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Zeitrahmen f\00FCr die Berichtserstellung an. Das Anzeigen gr\00F6\00DFerer Zeitrahmen kann mehr Zeit beanspruchen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168454310029451612.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'81'
);
end;
/
prompt --application/pages/page_00082
begin
wwv_flow_api.create_page(
 p_id=>82.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_step_title=>unistr('Anwendungs\00E4nderungen pro Tag')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47714431819630069.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47714818455630078.4353)
,p_plug_name=>'Von Entwickler erstellte neue Seiten'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select created_on, ',
'       flow_id || '':'' || id || ''. '' || name || '' ('' || lower(created_by) || '')'' as display_title',
'  from wwv_flow_steps',
' where security_group_id = :flow_security_group_id',
'   and (nvl(:P82_APPLICATION,0) = 0 or flow_id = :P82_APPLICATION)',
'   and created_on > sysdate - nvl(:P82_SINCE,45)',
' order by trunc(created_on), flow_id, id'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attribute_01=>'CREATED_ON'
,p_attribute_03=>'DISPLAY_TITLE'
,p_attribute_09=>'navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47722122683672427.4353)
,p_plug_name=>unistr('Aktivit\00E4t/Kalenderansichten \00FCberwachen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47721323591663284.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450757429520608018.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47714431819630069.4353)
,p_button_name=>'P82_SET'
,p_button_static_id=>'P82_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47716525087630105.4353)
,p_branch_action=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47715423374630085.4353)
,p_name=>'P82_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47714431819630069.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'45'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47715921153630087.4353)
,p_name=>'P82_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47714431819630069.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00083
begin
wwv_flow_api.create_page(
 p_id=>83.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'E-Mail-Bericht'
,p_step_title=>'E-Mail-Bericht'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_service.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180925501846212191.4353)
,p_plug_name=>'E-Mail'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180926025265217801.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(180925501846212191.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180926216468217806.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(180925501846212191.4353)
,p_button_name=>'email'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'E-Mail'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(180927714099233541.4353)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180926505657221589.4353)
,p_name=>'P83_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(180925501846212191.4353)
,p_prompt=>'Bis'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select email_address ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id and ',
'      user_name = :app_user;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie g\00FCltige E-Mail-Adressen ein. Trennen Sie mehrere Eintr\00E4ge mit Kommas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180926910491221594.4353)
,p_name=>'P83_SUBJECT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(180925501846212191.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Betreff'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(',
'           ''WORKSPACE_WORKSPACE_SUMMARY'',',
'           coalesce(display_name, short_name)) m',
'from wwv_flow_companies',
'where provisioning_company_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie Text f\00FCr die Meldung ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180927122293221594.4353)
,p_name=>'P83_BODY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(180925501846212191.4353)
,p_prompt=>'Body'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie optionalen Haupttext ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180935011937251769.4353)
,p_name=>'P83_REPORTING_PERIOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(180925501846212191.4353)
,p_item_default=>'D'
,p_prompt=>'Berichtszeitraum'
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_api.id(180662003103161233.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie ein Zeitintervall f\00FCr den Bericht.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(852015655140525052.4353)
,p_validation_name=>'P83_TO Not Null'
,p_validation_sequence=>10
,p_validation=>'P83_TO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die E-Mail-Adresse muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(180926216468217806.4353)
,p_associated_item=>wwv_flow_api.id(180926505657221589.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JUN-2001 19:34'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(852015845228527563.4353)
,p_validation_name=>'P83_TO valid format'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at number;',
'  l_dot number;',
'begin',
'  l_at := instr(nvl(:P83_TO,''x''),''@'');',
'  l_dot := instr(nvl(:P83_TO,''x''),''.'',l_at);',
'  return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltige E-Mail-Adresse.')
,p_validation_condition=>'P83_TO'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(180926216468217806.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(180952012507668237.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'send email'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4350_ui.p83_send_ws_usage_mail (',
'    p_to               => :P83_TO,',
'    p_subject          => :P83_SUBJECT,',
'    p_body             => :P83_BODY,',
'    p_reporting_period => :P83_REPORTING_PERIOD,',
'    p_date_time_format => :DATE_TIME_FORMAT );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(180926216468217806.4353)
,p_process_success_message=>'E-Mail gesendet an &P83_TO.'
);
end;
/
prompt --application/pages/page_00084
begin
wwv_flow_api.create_page(
 p_id=>84.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Clickthrough Log'
,p_step_title=>'Clickthrough Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215462122626558552)
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42467211201256215.4353)
,p_plug_name=>'Clickthrough Log verwalten'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'   c_click pls_integer := 0;',
'begin',
'   sys.htp.prn(''<table class="instructiontext" role="presentation" cellspacing="0" cellpadding="0">'');',
'   -- WWV_FLOW_CLICKTHRU_LOG$',
'   select count(*) into c_click from WWV_FLOW_CLICKTHRU_LOG;',
'   sys.htp.prn(''<tr><td>''||wwv_flow_lang.system_message(''F4350_CLICKTHRU_LOG_ENTRIES'')||''&nbsp;</td><td align="right" class="fielddatabold">'');',
'   sys.htp.prn(to_char(c_click,''999G999G999G999G990'')||''</td></tr></table><p />'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42467400750256217.4353)
,p_plug_name=>'Clickthrough Log'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Auf dieser Seite k\00F6nnen Sie die Eintr\00E4ge aus dem Clickthrough Log l\00F6schen. Das Clickthrough Log verwaltet die Anzahl der Klicks auf externe Sites.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47261006537939619.4353)
,p_plug_name=>'Manage Logs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:50%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(41778218420271753.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42468326851256219.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42467211201256215.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42468703382256220.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(42467211201256215.4353)
,p_button_name=>'PURGE_CLICK_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Clickthrough Log leeren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42469424294256221.4353)
,p_branch_action=>'84'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42469115669256220.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'puge click through log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_clickthru_log$',
'where security_group_id = :flow_security_group_id;',
'delete from wwv_flow_clickthru_log2$',
'where security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Clickthrough Log kann nicht geleert werden.'
,p_process_when_button_id=>wwv_flow_api.id(42468703382256220.4353)
,p_process_success_message=>'Das Clickthrough Log wurde geleert.'
);
end;
/
prompt --application/pages/page_00085
begin
wwv_flow_api.create_page(
 p_id=>85.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Dateinutzung'
,p_step_title=>'Dateinutzung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_wrkspc_rprt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452551108492691311.4353)
,p_plug_name=>'Dateien'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(file_type) file_type,',
'       sum(file_bytes) s,',
'       sum(file_count) c,',
'       max(file_newest) newest_file,',
'       min(file_oldest) oldest_file',
'  from wwv_flow_company_filestats',
' where security_group_id = :flow_security_group_id',
' group by file_type'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(452551212367691311.4353)
,p_name=>'Files'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452551430431691329.4353)
,p_db_column_name=>'FILE_TYPE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Dateityp'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452551509577691331.4353)
,p_db_column_name=>'S'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Gesamtdateigr\00F6\00DFe')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452551631735691332.4353)
,p_db_column_name=>'C'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Anzahl Dateien'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452557317497814833.4353)
,p_db_column_name=>'NEWEST_FILE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Neueste Datei'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452557404080814835.4353)
,p_db_column_name=>'OLDEST_FILE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('\00C4lteste Datei')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452552119519711425.4353)
,p_plug_name=>'Dateinutzung'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Jedem Workspace wird eine bestimmte Speicherkapazit\00E4t zugewiesen. Dieser Speicherplatz kann durch Dateien schnell belegt werden. Mit diesem Bericht k\00F6nnen Sie Bereiche mit \00FCberm\00E4\00DFiger Speicherbelegung ermitteln.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452553408961746157.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(452551108492691311.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00086
begin
wwv_flow_api.create_page(
 p_id=>86.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Datenbankberechtigungen'
,p_step_title=>'Datenbankberechtigungen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215677404159045218)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5565405532403790.4353)
,p_plug_name=>unistr('Auswahl f\00FCr Bericht zu Datenbankberechtigungen')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47242027449673013.4353)
,p_plug_name=>'Datenbankberechtigungen'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P86a */ grantee, privilege ',
'from sys.dba_sys_privs ',
'where grantee = :P86_SCHEMA'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47242113516673013.4353)
,p_name=>'Database Privileges'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47242412834673034.4353)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Berechtigung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47242300127673028.4353)
,p_db_column_name=>'GRANTEE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Berechtigter'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(67348921856914073.4353)
,p_plug_name=>'Datenbankberechtigungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Um DDL und DML in SQL Workshop auszuf\00FChren, ben\00F6tigt das ausgew\00E4hlte Datenbankschema bestimmte Datenbankberechtigungen. Um beispielsweise eine Tabelle erstellen zu k\00F6nnen, ben\00F6tigt das ausgew\00E4hlte Schema die Berechtigung <b>Tabelle erstellen</b>.<')
||unistr('/p> <p>Bei Oracle Database-Servern vor Version 10.2.0.3 m\00FCssen diese Berechtigungen direkt dem Schema erteilt werden. Bei Oracle Database-Servern ab Version 10.2.0.3 k\00F6nnen diese Berechtigungen dem Schema direkt oder \00FCber eine Rolle erteilt werden, d')
||unistr('amit SQL Workshop den Vorgang mit dem ausgew\00E4hlten Schema ausf\00FChren kann.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(67233501836737996.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5565405532403790.4353)
,p_button_name=>'P86_GO'
,p_button_static_id=>'P86_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450809001075271602.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5565405532403790.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(67234817766742659.4353)
,p_branch_action=>'f?p=&FLOW_ID.:86:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(67232723176734667.4353)
,p_name=>'P86_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5565405532403790.4353)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    wwv_flow_escape.html(schema) d, schema r',
'from WWV_FLOW_COMPANY_SCHEMAS',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Geben Sie an, f\00FCr welches Schema die Berechtigungen angezeigt werden sollen')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(190090924272869615.4353)
,p_computation_sequence=>10
,p_computation_item=>'P86_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select first_schema_provisioned from wwv_flow_companies where provisioning_company_id = :flow_security_group_id'
,p_compute_when=>'P86_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432754600335062133.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P86_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler'
);
end;
/
prompt --application/pages/page_00087
begin
wwv_flow_api.create_page(
 p_id=>87.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro Stunde'
,p_step_title=>'Seitenansichten pro Stunde'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47740509929035806.4353)
,p_plug_name=>unistr('Aktivit\00E4t pro Anwendung')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P87a */',
'       flow_id application_id,',
'       to_char(time_stamp,''YYYY.MM.DD HH24'') hour,',
'       count(*) page_views ,',
'       sum(num_rows) report_rows,',
'       count(distinct(flow_id||''.''||step_id)) pages,',
'      sum(elap) elapsed_time,',
'      avg(elap) avg_elapsed_time,',
'      median(elap) median_elapsed_time,',
'      count(distinct session_id) sessions,',
'      count(distinct userid) distinct_users,',
'    sum(decode(page_mode,''R'',1,0)) pages_from_cache,',
'    sum(decode(page_mode,''A'',0,1)) just_page_views,',
'    sum(decode(page_mode,''A'',1,0)) page_processing,',
'    sum(cached_regions) regions_from_cache,',
'    count(distinct to_char(time_stamp,''YYYYMMDDHH24MI'')) distinct_minutes,',
'    max(t.c) total_page_events,',
'    100 * count(*) / max(t.c) pct_of_total,',
'    100 * count(*) / max(t.c) graph',
'from  WWV_FLOW_ACTIVITY_LOG l,',
'    (select count(*) c',
'     from WWV_FLOW_ACTIVITY_LOG',
'     where ',
'        (nvl(:P87_APPLICATION,0)=0 or flow_id = :P87_APPLICATION )',
'        and time_stamp >= sysdate - nvl(:P87_TIME,1)',
'        and   security_group_id = :flow_security_group_id) t',
'where ',
'(nvl(:P87_APPLICATION,0)=0 or flow_id = :P87_APPLICATION ) ',
'and time_stamp >= sysdate - nvl(:P87_TIME,1)',
'and   security_group_id = :flow_security_group_id',
'group by flow_id, to_char(time_stamp,''YYYY.MM.DD HH24'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Spalten f\00FCr die verstrichene Zeit werden in Sekunden gemeldet.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47740701180035807.4353)
,p_name=>'Activity By Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47741128249035810.4353)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Seitenverarbeitung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47742116882035814.4353)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Berichtszeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47743412902038553.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47743526533038555.4353)
,p_db_column_name=>'HOUR'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Stunde'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47743604701038562.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47743727872038562.4353)
,p_db_column_name=>'PAGES'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47743802111038563.4353)
,p_db_column_name=>'ELAPSED_TIME'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47743905822038563.4353)
,p_db_column_name=>'AVG_ELAPSED_TIME'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Durchschnittlich verstrichen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744003940038564.4353)
,p_db_column_name=>'MEDIAN_ELAPSED_TIME'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Medianwert f\00FCr verstrichene Zeit')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744119550038564.4353)
,p_db_column_name=>'SESSIONS'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744232433038565.4353)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744311335038566.4353)
,p_db_column_name=>'PAGES_FROM_CACHE'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Gecachte Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744419283038566.4353)
,p_db_column_name=>'JUST_PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744511617038567.4353)
,p_db_column_name=>'REGIONS_FROM_CACHE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Gecachte Regionen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744612380038567.4353)
,p_db_column_name=>'DISTINCT_MINUTES'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Eindeutige Minuten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744723311038568.4353)
,p_db_column_name=>'TOTAL_PAGE_EVENTS'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Ereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744807922038568.4353)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Prozent von Gesamt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47744906853038569.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47746323899060711.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(429959221652073590.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47746323899060711.4353)
,p_button_name=>'P87_SET'
,p_button_static_id=>'P87_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47747618500060722.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47746323899060711.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RIR,87::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47743018719035824.4353)
,p_branch_action=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47746611640060714.4353)
,p_name=>'P87_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47746323899060711.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47747104482060716.4353)
,p_name=>'P87_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47746323899060711.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47742722259035817.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00088
begin
wwv_flow_api.create_page(
 p_id=>88.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Detaillierter Bericht zur Tablespace-Nutzung'
,p_page_mode=>'MODAL'
,p_step_title=>'Detaillierter Bericht zur Tablespace-Nutzung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215677404159045218)
,p_step_template=>wwv_flow_api.id(485889499804058937.4353)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'300'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(100071023152204639.4353)
,p_name=>'Tablespace-Nutzung'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with workspace_tablespace as',
'    ( select distinct default_tablespace',
'        from sys.dba_users',
'       where username in ',
'             (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = (select wwv_flow.get_sgid from sys.dual where rownum = 1))',
'    )',
'select tm.tablespace_name name,',
'       tm.tablespace_size * ts.block_size bytes,',
'       (tm.tablespace_size-tm.used_space) * ts.block_size free,',
'       tm.used_space * ts.block_size used,',
'       tm.used_percent pct_used',
'  from workspace_tablespace wt,',
'       sys.dba_tablespaces  ts,',
'       sys.dba_tablespace_usage_metrics tm',
' where wt.default_tablespace = ts.tablespace_name',
'   and ts.tablespace_name    = tm.tablespace_name',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P4651a */ name, bytes, bytes-free used, free, (bytes-free)/bytes*100 pct_used from',
'(select t.tablespace_name name,',
'       ( select sum(user_blocks * t.block_size)',
'             from sys.dba_data_files',
'            where tablespace_name = t.tablespace_name ) bytes,',
'       ( select sum(bytes)',
'             from sys.dba_free_space',
'            where tablespace_name = t.tablespace_name ) free ',
'   from sys.dba_tablespaces t',
'  where tablespace_name in (select default_tablespace',
'           from sys.dba_users where username in (select schema from wwv_flow_company_schemas',
'           where security_group_id= (select wwv_flow.get_sgid ',
'                                       from dual ',
'                                      where rownum = 1))))',
'  order by 1  '))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26776828303573819.4353)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Tablespace-Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100071521567204659.4353)
,p_query_column_id=>2
,p_column_alias=>'BYTES'
,p_column_display_sequence=>2
,p_column_heading=>'Byte'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100071715083204660.4353)
,p_query_column_id=>3
,p_column_alias=>'FREE'
,p_column_display_sequence=>4
,p_column_heading=>'Freier Betrag'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100071603085204659.4353)
,p_query_column_id=>4
,p_column_alias=>'USED'
,p_column_display_sequence=>3
,p_column_heading=>'Verwendeter Betrag'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100071820491204660.4353)
,p_query_column_id=>5
,p_column_alias=>'PCT_USED'
,p_column_display_sequence=>5
,p_column_heading=>'Verwendeter Prozentsatz'
,p_use_as_row_header=>'N'
,p_column_format=>'999D99'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(722742080310798648.4353)
,p_plug_name=>unistr('Schaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722742223736798650.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(722742080310798648.4353)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2171305307718550621.4353)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(722742223736798650.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2171305796821550623.4353)
,p_event_id=>wwv_flow_api.id(2171305307718550621.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_api.create_page(
 p_id=>89.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Seiten\00E4nderungen pro Tag')
,p_step_title=>unistr('Seiten\00E4nderungen pro Tag')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47765501589258984.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47765923866258985.4353)
,p_plug_name=>unistr('Seiten\00E4nderungen pro Tag')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select last_updated_on,',
'       flow_id || '':'' || id || ''. '' || name as display_title',
'  from wwv_flow_steps',
' where security_group_id = :flow_security_group_id',
'   and (nvl(:P89_APPLICATION,0) = 0 or flow_id = :P89_APPLICATION)',
'   and last_updated_on > sysdate - nvl(:P89_SINCE,45)',
' order by trunc(last_updated_on), flow_id, id'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attribute_01=>'LAST_UPDATED_ON'
,p_attribute_03=>'DISPLAY_TITLE'
,p_attribute_09=>'navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47766328642258989.4353)
,p_plug_name=>unistr('Aktivit\00E4t/Kalenderansichten \00FCberwachen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47721323591663284.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450759905110638890.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47765501589258984.4353)
,p_button_name=>'P89_GO'
,p_button_static_id=>'P89_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47767811663259012.4353)
,p_branch_action=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47766701303258999.4353)
,p_name=>'P89_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47765501589258984.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'45'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47767221639259000.4353)
,p_name=>'P89_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47765501589258984.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Anwendungen -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Anwendungen oder eine bestimmte Anwendung einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_api.create_page(
 p_id=>90.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Abgelaufene gecachte Seiten pro Anwendung l\00F6schen')
,p_step_title=>unistr('Abgelaufene gecachte Seiten pro Anwendung l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51199603672230132.4353)
,p_plug_name=>unistr('Abgelaufene gecachte Seiten pro Anwendung l\00F6schen')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51200911677230134.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(51199603672230132.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51200726672230133.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(51199603672230132.4353)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Abgelaufene Seiten l\00F6schen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51201901360230135.4353)
,p_branch_action=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51201119105230134.4353)
,p_name=>'P90_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(51199603672230132.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||''. ''||wwv_flow_escape.html(f.name)||'' (''||count(*)||'')'' n, f.id ',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is null',
'group by f.id, f.name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Anwendung ausw\00E4hlen -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie die Anwendung an, f\00FCr die aus dem Seitencache abgelaufene Seiten gel\00F6scht werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51201628317230134.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Expired'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
'id = :P90_APPLICATION) loop',
'   wwv_flow_utilities.cache_purge_stale (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Verarbeitung nicht m\00F6glich')
,p_process_when=>'P90_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>'Aktion wurde verarbeitet'
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_api.create_page(
 p_id=>91.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Anwendungs-Dashboard'
,p_step_title=>'Anwendungs-Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47992107522118726.4353)
,p_plug_name=>'Anwendungen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Zeigen Sie eine Zusammenfassung der Datenbankanwendungen an.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47993227283118731.4353)
,p_name=>'Zuletzt erstellte'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P91c */ id||''. ''||substr(name,1,35)',
'       name,',
'       created_on',
'  from wwv_flow_visible_flows f',
' where f.created_on is not null',
'   and f.build_status != ''RUN_AND_HIDDEN''',
' order by created_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47993227283118731.4353)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47998706346131055.4353)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47998826225131055.4353)
,p_query_column_id=>2
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47994503004118734.4353)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(46989621592546067.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47994726036118735.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47996205859118740.4353)
,p_name=>'Anwendungsgruppen'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P91b */',
'   g.group_name,',
'   (select count(*) from wwv_flows f where f.group_id = g.id) app_count',
'from wwv_flow_application_groups g',
'where security_group_id = :flow_security_group_id',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46765105410141325.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Gruppen gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47996205859118740.4353)
,p_plug_column_width=>'apex-col--leftBorder '
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47996432056118740.4353)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Gruppenname'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48001220076201311.4353)
,p_query_column_id=>2
,p_column_alias=>'APP_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Anzahl Anwendungen'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(48003712551255842.4353)
,p_name=>'Workspace-Zusammenfassung'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P91a */',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f,',
'       wwv_flow_steps p',
' where f.id = p.flow_id',
'   and f.security_group_id = p.security_group_id',
'   and f.build_status != ''RUN_AND_HIDDEN''',
') as pages,',
'(',
' select count(*)',
'  from wwv_flow_themes t',
' where theme_security_group_id = :flow_security_group_id',
'   and security_group_id = 11',
') as workspace_themes',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48004019225255934.4353)
,p_query_column_id=>1
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>1
,p_column_heading=>'Datenbankanwendungen'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48005022032268031.4353)
,p_query_column_id=>2
,p_column_alias=>'PAGES'
,p_column_display_sequence=>2
,p_column_heading=>'Seiten'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48008721780324751.4353)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE_THEMES'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace Themes'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(48013230531384046.4353)
,p_name=>'Standards'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P91d */',
'(',
'select DEFAULT_APPLICATION_THEME',
'from WWV_FLOW_APP_BUILD_PREF',
'where SECURITY_GROUP_ID = :flow_security_group_id',
') theme,',
'(',
'select DEFAULT_TABS',
'from WWV_FLOW_APP_BUILD_PREF',
'where SECURITY_GROUP_ID = :flow_security_group_id',
') tabs,',
'(',
'select DEFAULT_AUTHENTICATION_SCHEME',
'from WWV_FLOW_APP_BUILD_PREF',
'where SECURITY_GROUP_ID = :flow_security_group_id',
') authentication_scheme',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(48013230531384046.4353)
,p_plug_column_width=>'apex-col--leftBorder  apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48014208498387137.4353)
,p_query_column_id=>1
,p_column_alias=>'THEME'
,p_column_display_sequence=>1
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48014330975387137.4353)
,p_query_column_id=>2
,p_column_alias=>'TABS'
,p_column_display_sequence=>2
,p_column_heading=>'Registerkarten'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48014414049387137.4353)
,p_query_column_id=>3
,p_column_alias=>'AUTHENTICATION_SCHEME'
,p_column_display_sequence=>3
,p_column_heading=>'Authentifizierungsschema'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47996609303118741.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47994726036118735.4353)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aktualisieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47997709504118768.4353)
,p_branch_action=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168453117732434905.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'91'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_api.create_page(
 p_id=>92.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Abonnements interaktiver Berichte'
,p_step_title=>'Abonnements interaktiver Berichte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_ir_notifi.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48027402901804000.4353)
,p_plug_name=>'Subscriptions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'wwv_flow_item.checkbox(1, n.id, null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''IR_SUBSCRIPTION_LABEL'',i.flow_id,i.page_id,n.owner)) id,',
'i.flow_id nflow_id,',
'i.page_id npage_id,',
'region_id nregion_id,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'n.session_id,',
'n.owner    application_user,',
'n.language language,',
'decode(n.download_format,',
'    ''XLSX'',''Excel'',',
'    n.download_format) download_format,',
'decode(n.strip_rich_text,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) strip_rich_text,',
'decode(n.data_only,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no,',
'    m.m_no) data_only,',
'decode(n.pdf_page_size,',
'    ''A3'',m.m_a3,',
'    ''A4'',m.m_a4,',
'    ''LEGAL'',m.m_legal,',
'    ''LETTER'',m.m_letter,',
'    ''CUSTOM'',m.m_custom,',
'    ''TABLOID'',m.m_tabloid,',
'    pdf_page_size) pdf_page_size,',
'decode(n.pdf_page_orientation,',
'    ''VERTICAL'',m.m_vertical,',
'    ''HORIZONTAL'',m.m_horizontal,',
'    pdf_page_orientation) pdf_page_orientation,',
'decode(n.pdf_accessible,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) pdf_accessible,',
'decode(n.skip_no_data_found,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) skip_no_data_found,',
'n.start_date at time zone sessiontimezone start_date,',
'n.end_date at time zone sessiontimezone end_date,',
'case when nvl(n.end_date,systimestamp) >= systimestamp then',
'    n.offset_date',
'end offset_date,',
'wwv_flow_item.text_from_lov(n.notify_interval,''IR_NOTIFY_INTERVAL'') notify_interval,',
'n.status,',
'n.notify_error,',
'n.email_from,',
'n.email_address,',
'n.created_by,',
'n.created_on,',
'case when :flow_security_group_id!=10 and i.flow_id between 4000 and 4999 then',
'  null',
'else',
'  ''f?p=4000:1:''||:app_session||''::NO:RP:FB_FLOW_ID,F4000_P1_FLOW:''||i.flow_id||'',''||i.flow_id',
'end application_link,',
'case when :flow_security_group_id!=10 and i.flow_id between 4000 and 4999 then',
'  null',
'else',
'  ''f?p=4000:4150:''||:app_session||''::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:''||i.flow_id||'',''||i.page_id',
'end page_link',
'from wwv_flow_worksheet_notify n,',
'wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_VERTICAL'') m_vertical,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_HORIZONTAL'') m_horizontal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A3'') m_a3,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A4'') m_a4,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LEGAL'') m_legal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LETTER'') m_letter,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_CUSTOM'') m_custom,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_TABLOID'') m_tabloid',
'from dual) m',
'where n.worksheet_id = i.id',
'and n.report_id = r.id',
'and n.websheet_id is null',
'and n.security_group_id = :flow_security_group_id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48027503431804000.4353)
,p_name=>'Interactive Reports with Notification'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Subscription gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:EMAIL'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48511609702866940.4353)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'AA'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48527911620681091.4353)
,p_db_column_name=>'NFLOW_ID'
,p_display_order=>2
,p_column_identifier=>'AB'
,p_column_label=>'Anwendung'
,p_column_link=>'#APPLICATION_LINK#'
,p_column_linktext=>'#NFLOW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48528022095681092.4353)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'AC'
,p_column_label=>'Seite'
,p_column_link=>'#PAGE_LINK#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48446920926555091.4353)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>4
,p_column_identifier=>'X'
,p_column_label=>'Region'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.:RP,1,4150:FB_FLOW_ID,F4000_P1_FLOW,FB_FLOW_PAGE_ID:#NFLOW_ID#,#NFLOW_ID#,#NPAGE_ID##5110:#NREGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218135830707197801.4353)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>14
,p_column_identifier=>'AS'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(167816820814522394.4353)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>24
,p_column_identifier=>'AE'
,p_column_label=>'Abonniert von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48028419846804017.4353)
,p_db_column_name=>'NOTIFY_INTERVAL'
,p_display_order=>34
,p_column_identifier=>'H'
,p_column_label=>unistr('H\00E4ufigkeit')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48029015454804020.4353)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>44
,p_column_identifier=>'N'
,p_column_label=>'E-Mail an'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48457108858666691.4353)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>54
,p_column_identifier=>'Z'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48457014187666690.4353)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>64
,p_column_identifier=>'Y'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48528511451718887.4353)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>74
,p_column_identifier=>'AD'
,p_column_label=>'Regions-ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619313810684318613.4353)
,p_db_column_name=>'STATUS'
,p_display_order=>84
,p_column_identifier=>'AI'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(619315906303328344)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619313907524318614.4353)
,p_db_column_name=>'NOTIFY_ERROR'
,p_display_order=>94
,p_column_identifier=>'AJ'
,p_column_label=>'Fehlermeldung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619446121222909742.4353)
,p_db_column_name=>'START_DATE'
,p_display_order=>104
,p_column_identifier=>'AK'
,p_column_label=>'Startdatum'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619446215230909743.4353)
,p_db_column_name=>'END_DATE'
,p_display_order=>114
,p_column_identifier=>'AL'
,p_column_label=>'Enddatum'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619446306135909743.4353)
,p_db_column_name=>'OFFSET_DATE'
,p_display_order=>124
,p_column_identifier=>'AM'
,p_column_label=>'Offset-Datum'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619446421497909743.4353)
,p_db_column_name=>'APPLICATION_LINK'
,p_display_order=>134
,p_column_identifier=>'AN'
,p_column_label=>'Anwendungslink'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619446516757909744.4353)
,p_db_column_name=>'PAGE_LINK'
,p_display_order=>144
,p_column_identifier=>'AO'
,p_column_label=>'Seitenlink'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(18808423409746055.4353)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>154
,p_column_identifier=>'AQ'
,p_column_label=>'Sprache'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(18808508451746058.4353)
,p_db_column_name=>'EMAIL_FROM'
,p_display_order=>164
,p_column_identifier=>'AR'
,p_column_label=>'E-Mail von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3801935667307217.4353)
,p_db_column_name=>'DOWNLOAD_FORMAT'
,p_display_order=>174
,p_column_identifier=>'AT'
,p_column_label=>'Format'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802033977307218.4353)
,p_db_column_name=>'STRIP_RICH_TEXT'
,p_display_order=>184
,p_column_identifier=>'AU'
,p_column_label=>'Rich Text entfernen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802168392307219.4353)
,p_db_column_name=>'DATA_ONLY'
,p_display_order=>194
,p_column_identifier=>'AV'
,p_column_label=>'Nur Daten'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802232092307220.4353)
,p_db_column_name=>'PDF_PAGE_SIZE'
,p_display_order=>204
,p_column_identifier=>'AW'
,p_column_label=>unistr('PDF-Seitengr\00F6\00DFe')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802391362307221.4353)
,p_db_column_name=>'PDF_PAGE_ORIENTATION'
,p_display_order=>214
,p_column_identifier=>'AX'
,p_column_label=>'PDF-Seitenausrichtung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802434756307222.4353)
,p_db_column_name=>'PDF_ACCESSIBLE'
,p_display_order=>224
,p_column_identifier=>'AY'
,p_column_label=>'PDF - Barrierefrei'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(4162892338589923.4353)
,p_db_column_name=>'SKIP_NO_DATA_FOUND'
,p_display_order=>234
,p_column_identifier=>'AZ'
,p_column_label=>unistr('\00DCberspringen, wenn keine Daten gefunden wurden')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452527601203308717.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48027402901804000.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48508510217829186.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(48027402901804000.4353)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Alle l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:apex.confirm(''&DELETE_MSG.'',''DELETE_ALL'')'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_worksheet_notify',
'where security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48507810647810417.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(48027402901804000.4353)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_worksheet_notify',
'where security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48508132288810418.4353)
,p_branch_action=>'f?p=&FLOW_ID.:92:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48507810647810417.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48508824512829187.4353)
,p_branch_name=>'Go To Page 92'
,p_branch_action=>'f?p=&FLOW_ID.:92:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48508510217829186.4353)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(172208015461138088.4353)
,p_branch_name=>'Go To Page &LAST_VIEW.'
,p_branch_action=>'f?p=&FLOW_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48510019137850696.4353)
,p_validation_name=>'must select notification to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Subscription muss zum L\00F6schen ausgew\00E4hlt werden.')
,p_when_button_pressed=>wwv_flow_api.id(48507810647810417.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199175378251878429.4353)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(48027402901804000.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199175471012878430.4353)
,p_event_id=>wwv_flow_api.id(1199175378251878429.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48507407746800061.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for c1 in (select id,',
'                      worksheet_id,',
'                      report_id,',
'                      created_by',
'               from wwv_flow_worksheet_notify',
'               where id = wwv_flow.g_f01(i)',
'               and security_group_id = :flow_security_group_id)           ',
'    loop',
'        wwv_flow_worksheet_api.delete_notify (',
'            p_worksheet_id    => c1.worksheet_id,',
'            p_app_user        => c1.created_by,',
'            p_report_id       => c1.report_id,',
'            p_notify_id       => c1.id);',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Subscription kann nicht entfernt werden.'
,p_process_when_button_id=>wwv_flow_api.id(48507810647810417.4353)
,p_process_success_message=>'Subscriptions entfernt.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48509131688835426.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete all'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id,',
'                  worksheet_id,',
'                  report_id,',
'                  created_by',
'           from wwv_flow_worksheet_notify',
'           where security_group_id = :flow_security_group_id)           ',
'loop',
'    wwv_flow_worksheet_api.delete_notify (',
'        p_worksheet_id    => c1.worksheet_id,',
'        p_app_user        => c1.created_by,',
'        p_report_id       => c1.report_id,',
'        p_notify_id       => c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Subscriptions k\00F6nnen nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(48508510217829186.4353)
,p_process_success_message=>unistr('Alle Subscriptions f\00FCr den aktuellen Workspace wurden gel\00F6scht.')
);
end;
/
prompt --application/pages/page_00093
begin
wwv_flow_api.create_page(
 p_id=>93.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Seitenansichten pro interaktiven Bericht'
,p_step_title=>'Seitenansichten pro interaktiven Bericht'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196294221377763742.4353)
,p_plug_name=>'Seitenansichten pro interaktiven Bericht'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P93a */',
'       x.application_id,',
'       x.page_id,',
'       x.report_id,',
'       x.report_type,',
'       x.report_name,',
'       x.owner,',
'       x.userid,',
'       x.workspace,',
'       max(x.time_stamp) maxts',
'from',
'(select case when l.websheet_id is null then',
'           l.flow_id',
'       else',
'           l.websheet_id',
'       end application_id,',
'       l.step_id page_id,',
'       l.ir_report_id report_id,',
'       case when r.is_default = ''Y''then ',
'            decode(r.application_user,',
'                   ''APXWS_DEFAULT'',sm.primary_def, ',
'                   ''APXWS_ALTERNATIVE'',sm.alt_def)',
'            when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'                sm.spublic',
'            when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'                 sm.private',
'       end report_type, ',
'       case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'           wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'       else',
'           r.name',
'       end report_name,',
'       decode(r.application_user,',
'              ''APXWS_DEFAULT'',null,',
'              ''APXWS_ALTERNATIVE'',null,',
'              r.application_user) owner,              ',
'       l.time_stamp,',
'       l.userid,',
'       (select short_name from wwv_flow_companies where provisioning_company_id=l.security_group_id) workspace',
'from wwv_flow_activity_log l,',
'     wwv_flow_worksheets w,',
'     wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'             wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,             ',
'             wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'             wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic',
'      from dual) sm     ',
'where w.id = r.worksheet_id',
'and w.flow_id = l.flow_id',
'and w.page_id = l.step_id',
'and l.ir_report_id = r.id',
'and w.security_group_id = :flow_security_group_id',
'and l.ir_report_id is not null) x',
'group by x.application_id,x.page_id,x.report_id,x.report_type,x.report_name,x.owner, x.userid, x.workspace'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(196294324251763742.4353)
,p_name=>'Page Views by Interactive Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196294501230763753.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196294602758763754.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196294717883763755.4353)
,p_db_column_name=>'REPORT_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Berichts-ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196294832326763755.4353)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Berichtstyp'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196294901177763756.4353)
,p_db_column_name=>'REPORT_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Berichtsname'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196295028099763757.4353)
,p_db_column_name=>'OWNER'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Eigent\00FCmer')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196333027540154323.4353)
,p_db_column_name=>'USERID'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Angezeigt von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196350416449425550.4353)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>':flow_security_group_id = 10'
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196295106259763758.4353)
,p_db_column_name=>'MAXTS'
,p_display_order=>9
,p_column_identifier=>'G'
,p_column_label=>'Letzte Ansicht'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196335608456196129.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196336009280205827.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(196335608456196129.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:93,RIR::'
);
end;
/
prompt --application/pages/page_00094
begin
wwv_flow_api.create_page(
 p_id=>94.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Aktuelle Websheet-Ansichten'
,p_step_title=>'Aktuelle Websheet-Ansichten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486712904057109157.4353)
,p_plug_name=>'Aktuelle Seitenansichten'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    time_stamp,',
'    elap,',
'    userid userid,',
'    session_id,',
'    substr(user_agent,1,100) user_agent,',
'    86400 * (time_stamp - lag(time_stamp) over (order by userid, time_stamp)) thinktime,',
'    sqlerrm,',
'   to_char(time_stamp,''YYYYMMDD'') day,',
'   websheet_id,',
'   (select name from wwv_flow_ws_applications where id = l.websheet_id) websheet_name,',
'   worksheet_id,',
'   CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l,',
'   (select wwv_flow_lang.system_message(''PAGE_PROCESSING'') m_PAGE_PROCESSING,',
'           wwv_flow_lang.system_message(''CACHE_CREATED'') m_CACHE_CREATED,',
'           wwv_flow_lang.system_message(''F4000.DYNAMIC'') m_DYNAMIC,',
'           wwv_flow_lang.system_message(''PARTIAL_PAGE'') m_PARTIAL_PAGE,',
'           wwv_flow_lang.system_message(''CACHED'') m_CACHED',
'    from dual) m',
'where security_group_id = :flow_security_group_id and',
'    flow_id = 4900 and',
'    websheet_id is not null and',
'    (time_stamp > sysdate - nvl(:P94_TIME,1)) and',
'    (nvl(:P94_APPLICATION,0)=0 or :P94_APPLICATION = l.websheet_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Spalten f\00FCr die verstrichene Zeit werden in Sekunden gemeldet.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(486713121947109159.4353)
,p_name=>'Recent Page Views'
,p_max_row_count=>'100000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 100.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_download_filename=>'pagelog.csv'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486713200075109164.4353)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Datum'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486713325909109164.4353)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Verstrichene Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486713528090109168.4353)
,p_db_column_name=>'USERID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486714004021109170.4353)
,p_db_column_name=>'THINKTIME'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Think Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486713823518109170.4353)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Session'
,p_column_link=>'f?p=&FLOW_ID.:19:&SESSION.::&DEBUG.:RP,:P19_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486713913040109170.4353)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Benutzer-Agent'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486714120292109171.4353)
,p_db_column_name=>'SQLERRM'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Fehlermeldung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486714707840109172.4353)
,p_db_column_name=>'DAY'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486714905478109173.4353)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Gew\00E4hltes Websheet')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486715005364109173.4353)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Gew\00E4hlter Bericht')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486715202090109173.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(486715329785109174.4353)
,p_db_column_name=>'WEBSHEET_NAME'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Websheet'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486715620070109179.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486717022647109219.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(486715620070109179.4353)
,p_button_name=>'P94_SET'
,p_button_static_id=>'P94_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486715819238109180.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(486715620070109179.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:29,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(486718312127109407.4353)
,p_branch_action=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486716024587109191.4353)
,p_name=>'P94_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(486715620070109179.4353)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seit'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Schr\00E4nken Sie den Bericht auf einen bestimmten Zeitrahmen ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486716513334109217.4353)
,p_name=>'P94_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(486715620070109179.4353)
,p_item_default=>'0'
,p_prompt=>'Websheet'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_ws_applications f',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Websheets -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtern Sie die Berichtsausgabe, um alle Websheets oder ein bestimmtes Websheet einzuschlie\00DFen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(486717727618109388.4353)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P94_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(486717904325109394.4353)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P94_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486718131939109394.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00095
begin
wwv_flow_api.create_page(
 p_id=>95.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Mehrere Benutzer erstellen'
,p_step_title=>'Mehrere Benutzer erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487003305223414569.4353)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(487004000637432136.4353)
,p_name=>unistr('G\00FCltige Benutzer')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 username, c002 email',
'  from apex_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Keine g\00FCltigen E-Mail-Adressen gefunden.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(487004330571432146.4353)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzername'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(487004403742432150.4353)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>'E-Mail'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(487004809987434849.4353)
,p_name=>unistr('Ung\00FCltige Benutzer')
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 username, c002 email, c003 error',
'  from apex_collections',
' where collection_name = ''BULK_USER_INVALID''',
'order by c001'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Keine ung\00FCltigen Daten gefunden.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(487005024748434852.4353)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzername'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(487005101831434852.4353)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>'E-Mail'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(487040628734818656.4353)
,p_query_column_id=>3
,p_column_alias=>'ERROR'
,p_column_display_sequence=>3
,p_column_heading=>'Fehler'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755295582942836821.4353)
,p_plug_name=>'Mehrere Benutzer erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(487006116960465275.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(487003305223414569.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(487006524000465276.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(487003305223414569.4353)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('G\00FCltige Benutzer erstellen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(487006324723465276.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(487003305223414569.4353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(487084306271190673.4353)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(487041729211828298.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Users'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.create_user_from_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_web_password              => :P99_WEB_PASSWORD,',
'    p_allow_access_to_schemas   => :P99_ALLOW_ACCESS_TO_SCHEMAS,',
'    p_default_schema            => :P99_DEFAULT_SCHEMA,',
'    p_developer                 => :P99_DEVELOPER,',
'    p_admin                     => :P99_ADMIN,',
'    p_allow_app_building_yn     => nvl(:P99_ALLOW_APP_BUILDING_YN,''Y''),',
'    p_allow_sql_workshop_yn     => nvl(:P99_ALLOW_SQL_WORKSHOP_YN,''Y''),',
'    p_allow_websheet_dev_yn     => ''Y'',',
'    p_allow_team_development_yn => nvl(:P99_ALLOW_TEAM_DEVELOPMENT_YN,''Y''));',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unerwarteter Fehler beim Erstellen von Benutzern'
,p_process_success_message=>'Benutzer erstellt'
);
end;
/
prompt --application/pages/page_00096
begin
wwv_flow_api.create_page(
 p_id=>96.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Service anfordern - Anforderung identifizieren'
,p_step_title=>'Service anfordern - Anforderung identifizieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168274915363961081.4353)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47297014014256767.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168275112410961086.4353)
,p_plug_name=>'Aufgaben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(47296115483238304.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168278722008976619.4353)
,p_plug_name=>'Anforderung angeben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185602275935580522.4353)
,p_name=>'Serviceanfragenhistorie'
,p_template=>wwv_flow_api.id(829458533922680656.4353)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SERVICE_NAME,',
'       SERVICE_ATTRIBUTE_1,',
'       REQUESTED_ON,',
'       REQUESTED_BY,',
'       LAST_STATUS_CHANGE_ON,',
'       LAST_STATUS_CHANGE_BY,',
'       REQUEST_STATUS,',
'       case',
'       when request_comments is null',
'       then null',
'       when regexp_like(request_comments,''^\d+$'')',
'       then wwv_flow_lang.system_message (',
'                ''APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'',',
'                request_comments )',
'       else request_comments',
'       end request_comments',
'  from WWV_FLOW_PROVISION_SERICE_MOD',
' where security_group_id = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(770829717235300818.4353)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4391117861432846649.4353)
,p_query_column_id=>1
,p_column_alias=>'SERVICE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Angeforderte \00C4nderung')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(784569817799474890)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4391117950492846650.4353)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_ATTRIBUTE_1'
,p_column_display_sequence=>2
,p_column_heading=>'Wert'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(829739099475116201.4353)
,p_query_column_id=>3
,p_column_alias=>'REQUESTED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Angefordert am'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(829739142343116202.4353)
,p_query_column_id=>4
,p_column_alias=>'REQUESTED_BY'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(829739231203116203.4353)
,p_query_column_id=>5
,p_column_alias=>'LAST_STATUS_CHANGE_ON'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Letzte Status\00E4nderung am')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(829739377532116204.4353)
,p_query_column_id=>6
,p_column_alias=>'LAST_STATUS_CHANGE_BY'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(829739479526116205.4353)
,p_query_column_id=>7
,p_column_alias=>'REQUEST_STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(378143515851142224)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(829739545295116206.4353)
,p_query_column_id=>8
,p_column_alias=>'REQUEST_COMMENTS'
,p_column_display_sequence=>8
,p_column_heading=>'Kommentare'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208402307523310453.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752114026620695876.4353)
,p_plug_name=>'Service anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168290619658231382.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208402307523310453.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168290808223231383.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208402307523310453.4353)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168291020616231383.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208402307523310453.4353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168314820535795538.4353)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P96_SERVICE'
,p_branch_condition_text=>'STORAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168315100234799114.4353)
,p_branch_action=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P96_SERVICE'
,p_branch_condition_text=>'TERMINATION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168315408545801461.4353)
,p_branch_name=>'Go To Page 48'
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:48::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P96_SERVICE'
,p_branch_condition_text=>'SCHEMA'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168277330803961102.4353)
,p_branch_action=>'69'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(168291628100243235.4353)
,p_name=>'P96_SERVICE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(168278722008976619.4353)
,p_item_default=>'STORAGE'
,p_prompt=>'Geben Sie den Typ des Service an, der angefordert werden soll:'
,p_source=>'STORAGE'
,p_source_type=>'STATIC'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'REQEUEST SERVICE'
,p_lov=>'.'||wwv_flow_api.id(168289505113227142.4353)||'.'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie eine Service-\00C4nderungsanforderung, und klicken Sie auf <strong>Weiter</strong>.')
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00097
begin
wwv_flow_api.create_page(
 p_id=>97.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Diagramm f\00FCr Nutzung nativer Komponenten')
,p_step_title=>unistr('Diagramm f\00FCr Nutzung nativer Komponenten')
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166213497169830380.4353)
,p_plug_name=>unistr('Diagramm f\00FCr Nutzung nativer Komponenten')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(166213878845830380.4353)
,p_region_id=>wwv_flow_api.id(166213497169830380.4353)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>false
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(166215517076830381.4353)
,p_chart_id=>wwv_flow_api.id(166213878845830380.4353)
,p_seq=>10
,p_name=>'Datenreihe 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''FLASHMAP'', wwv_flow_lang.system_message(''FLASHMAP''),',
'           ''FLASH_MAP'', wwv_flow_lang.system_message(''FLASHMAP''),',
'           ''FLASH_CHART5'', wwv_flow_lang.system_message(''FLASH_CHART5''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from   wwv_flow_page_plugs r',
'where  plug_source_type not like ''PLUGIN%'' and ',
'       security_group_id = :flow_security_group_id',
'group by substr(plug_source_type,8)',
'order by 2 desc',
''))
,p_max_row_count=>1000
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_group_short_desc_column_name=>'REGION_TYPE'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(166214383419830380.4353)
,p_chart_id=>wwv_flow_api.id(166213878845830380.4353)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>true
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(166214910253830381.4353)
,p_chart_id=>wwv_flow_api.id(166213878845830380.4353)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00098
begin
wwv_flow_api.create_page(
 p_id=>98.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Gespeicherte interaktive Berichte'
,p_step_title=>'Gespeicherte interaktive Berichte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_ir_notifi.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492167616838140245.4353)
,p_plug_name=>'Gespeicherte Berichte'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'case when r.is_default!=''Y'' or r.application_user!=''APXWS_DEFAULT'' then',
'    wwv_flow_item.checkbox(1, r.id,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''REPORT_LABEL'',case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'else',
'    wwv_flow_escape.html(r.name)',
'end))',
'end id,',
'i.flow_id napp_id,',
'i.page_id npage_id,',
'i.region_id nregion_id,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'case when r.is_default = ''Y''then ',
'     decode(r.application_user,',
'            ''APXWS_DEFAULT'',sm.primary_def, ',
'            ''APXWS_ALTERNATIVE'',sm.alt_def)',
'     when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'         sm.spublic',
'     when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'         sm.private',
'end report_type, ',
'case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'else',
'    r.name',
'end name,',
'decode(r.application_user,',
'       ''APXWS_DEFAULT'',null,',
'       ''APXWS_ALTERNATIVE'',null,',
'       r.application_user) owner,',
'substr(r.description,1,50) description,        ',
'r.report_alias report_alias,',
'(select short_name from wwv_flow_companies where provisioning_company_id =r.security_group_id) workspace',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,               ',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic',
' from sys.dual) sm',
'where r.worksheet_id = i.id',
'and r.websheet_id is null',
'and r.session_id is null',
'and r.security_group_id = :flow_security_group_id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492167702514140245.4353)
,p_name=>'Saved Reports'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492167909521140253.4353)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492168003007140253.4353)
,p_db_column_name=>'NAPP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_link=>'f?p=4000:1:&SESSION.::NO:RP:FB_FLOW_ID,F4000_P1_FLOW:#NAPP_ID#,#NAPP_ID#'
,p_column_linktext=>'#NAPP_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492168331066140254.4353)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Seite'
,p_column_link=>'f?p=4000:4500:&SESSION.::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:#NAPP_ID#,#NPAGE_ID#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492168423761140254.4353)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Regions-ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492168526042140254.4353)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Regionsname'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.:1:FB_FLOW_ID,F4000_P1_FLOW,FB_FLOW_PAGE_ID:#NAPP_ID#,#NAPP_ID#,#NPAGE_ID##5110:#NREGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492168807889140255.4353)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Berichtstyp'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492168920154140255.4353)
,p_db_column_name=>'NAME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Berichtsname'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492169023789140255.4353)
,p_db_column_name=>'OWNER'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Eigent\00FCmer')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492169119427140255.4353)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492169224320140256.4353)
,p_db_column_name=>'REPORT_ALIAS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Berichtsalias'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492169405190140256.4353)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>':flow_security_group_id = 10'
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492712515226580152.4353)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(492707417463467235.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492130606552564654.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(492167616838140245.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492130017533564651.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(492167616838140245.4353)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_worksheet_rpts',
'where security_group_id = :flow_security_group_id',
'and session_id is null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(492131426696564661.4353)
,p_branch_action=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(492130807596564657.4353)
,p_validation_name=>'must select report to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Bericht muss zum L\00F6schen ausgew\00E4hlt werden.')
,p_when_button_pressed=>wwv_flow_api.id(492130017533564651.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199175567534878431.4353)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(492167616838140245.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199175632656878432.4353)
,p_event_id=>wwv_flow_api.id(1199175567534878431.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492131213822564659.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for c1 in (select id report_id, worksheet_id, application_user, is_default, report_type',
'               from wwv_flow_worksheet_rpts',
'               where id = wwv_flow.g_f01(i)',
'               and security_group_id=:flow_security_group_id)',
'    loop                ',
'        wwv_flow_worksheet_api.delete_saved_report (            ',
'            p_worksheet_id      => c1.worksheet_id,               ',
'            p_report_id         => c1.report_id,',
'            p_is_default        => c1.is_default);        ',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Bericht kann nicht entfernt werden.'
,p_process_when_button_id=>wwv_flow_api.id(492130017533564651.4353)
,p_process_success_message=>'Berichte entfernt.'
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_api.create_page(
 p_id=>99.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Mehrere Benutzer erstellen'
,p_step_title=>'Mehrere Benutzer erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function clob_Submit(){',
'	var clob = new apex.ajax.clob(function (){',
'		if(p.readyState == 1){',
'				$x_Show(''AjaxLoading'');',
'		}else if(p.readyState == 2){',
'		}else if(p.readyState == 3){',
'		}else if(p.readyState == 4){',
'				$s(''P99_USERS'','''');',
'				doSubmit(''SUCCESS'');',
'				return;',
'		}else{return false;}',
'});',
'	clob._set($v(''P99_USERS''));',
'	return;',
'}'))
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_new_users_multi.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30327808490361225.4353)
,p_plug_name=>'Benutzer'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>24
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Um mehrere Benutzer gleichzeitig zu erstellen, geben Sie E-Mail-Adressen getrennt durch Kommas, Semikolons oder Zeilenvorsch\00FCbe ein, bzw. kopieren Sie E-Mail-Adressen, und f\00FCgen Sie diese ein.  '),
'',
unistr('<p>Beachten Sie, dass das angegebene Kennwort jedem Benutzer zugewiesen wird. Benutzer m\00FCssen ihre Kennw\00F6rter bei der Anmeldung \00E4ndern.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473029411149560842.4353)
,p_plug_name=>'Accountberechtigungen'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>34
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473038025479574436.4353)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(504234007342045185.4353)
,p_plug_name=>'Kennwort'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>44
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755295411614836820.4353)
,p_plug_name=>'Mehrere Benutzer erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30328532039368082.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(473038025479574436.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30328722239368083.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(473038025479574436.4353)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Weiter'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30329122127374620.4353)
,p_branch_action=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30328117494363863.4353)
,p_name=>'P99_USERS'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30327808490361225.4353)
,p_prompt=>'Liste der E-Mail-Adressen'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Geben Sie E-Mail-Adressen getrennt durch Kommas, Semikolons oder Zeilenvorsch\00FCbe ein, bzw. kopieren Sie E-Mail-Adressen, und f\00FCgen Sie diese ein. Beachten Sie, dass \00FCberfl\00FCssiger Text beim Kopieren und Einf\00FCgen von E-Mail-Adressen aus E-Mail-Nachrich')
||'ten ausgefiltert wird.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473029603549560853.4353)
,p_name=>'P99_ALLOW_ACCESS_TO_SCHEMAS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_prompt=>unistr('Verf\00FCgbare Schemas (Leer f\00FCr alle)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Geben Sie eine durch Doppelpunkte getrennte Liste der Schemas ein, auf die dieser Entwickler Berechtigungen hat, wenn SQL Workshop verwendet wird. Die Schemaliste, die Sie hier angeben, beschr\00E4nkt den Benutzer auf eine Teilmenge der gesamten Schemas,')
||unistr(' die f\00FCr den Workspace bereitgestellt wurden. Sie bestimmt au\00DFerdem, welche Schemanamen der Benutzer in SQL Workshop sehen kann.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473030100858560866.4353)
,p_name=>'P99_DEFAULT_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Standardschema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Geben Sie das Standardschema f\00FCr das Durchsuchen von Daten, Erstellen von Anwendungen und Ausf\00FChren von SQL-Skripts an. Wenn Sie Workspaces verwenden, bei denen mehrere Schemas verf\00FCgbar sind, ist dieses Schema das Standardschema zum Erstellen von An')
||unistr('wendungen, Ausf\00FChren von SQL-Abfragen usw. Dieses Feature steuert nicht die Sicherheit, sondern nur die Benutzervoreinstellung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473030704653560869.4353)
,p_name=>'P99_DEVELOPER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_item_default=>'N'
,p_prompt=>'Benutzer sind Entwickler'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DEVELOPER TYPE'
,p_lov=>'.'||wwv_flow_api.id(19716823057593749.4353)||'.'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Geben Sie an, ob diese Benutzer Entwicklerberechtigungen erhalten sollen. Entwickler k\00F6nnen Anwendungen und Datenbankobjekte erstellen und \00E4ndern.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473031302367560872.4353)
,p_name=>'P99_ADMIN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_item_default=>'N'
,p_prompt=>'Benutzer sind Workspace-Administratoren'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Geben Sie an, ob diese Benutzer Workspace-Administratorberechtigungen erhalten sollen. Workspace-Administratoren k\00F6nnen wie Entwickler Anwendungen und Datenbankobjekte erstellen und \00E4ndern. Au\00DFerdem k\00F6nnen sie Benutzeraccounts, Gruppen und Entwicklun')
||'gs-Services verwalten.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473031924854560874.4353)
,p_name=>'P99_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'App Builder-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Legt fest, ob ein Entwickler Zugriff auf App Builder hat.<br>',
'<br>',
'Ein Administrator hat immer Zugriff auf App Builder.<br>',
'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.<br>',
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der App Builder-Zugriff f\00FCr den Workspace von einem Administrator deaktiviert ist.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473033110373560878.4353)
,p_name=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Zugriff auf SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Legt fest, ob ein Entwickler Zugriff auf SQL Workshop erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Zugriff auf SQL Workshop.<br>',
unistr('Entwickler m\00FCssen auf App Builder und/oder SQL Workshop zugreifen k\00F6nnen.<br>'),
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der Administrator den Zugriff auf SQL Workshop f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473033703172560879.4353)
,p_name=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob der Benutzer Team Development-Zugriff erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Team Development-Zugriff.<br> <br>',
unistr('Dieses Attribut wird deaktiviert, wenn der Administrator den Team Development-Zugriff f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473035819699564808.4353)
,p_name=>'P99_WEB_PASSWORD'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(504234007342045185.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Kennwort'
,p_post_element_text=>unistr('<span class="instructiontext">Bei Kennw\00F6rtern wird die Gro\00DF-/Kleinschreibung beachtet</span>')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie ein Kennwort an. Bei der Kennworteingabe wird die Gro\00DF-/Kleinschreibung ber\00FCcksichtigt. Entwickler k\00F6nnen ihre Kennw\00F6rter \00E4ndern. Wenn Entwickler mit der Administratorberechtigung ausgestattet sind, k\00F6nnen sie die Kennw\00F6rter der Benutzer in')
||unistr('nerhalb desselben Workspace \00E4ndern.')
,p_attribute_01=>'N'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473036413910564809.4353)
,p_name=>'P99_PASSWD_CONFIRM'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(504234007342045185.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Kennwort best\00E4tigen')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Geben Sie das Kennwort erneut ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486482110592743896.4353)
,p_name=>'P99_MSG'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486718608551113029.4353)
,p_name=>'P99_STRIP_DOMAIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30327808490361225.4353)
,p_item_default=>'N'
,p_prompt=>'Benutzernamen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.MULT.USER.STRIP.DOMAIN'
,p_lov=>'.'||wwv_flow_api.id(486946000320608950.4353)||'.'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob die vollst\00E4ndige E-Mail-Adresse aufgenommen werden soll oder ob der Domainname ausgeschlossen wird. Verf\00FCgbare Optionen:'),
'<ul>',
unistr('<li>Benutzername auf vollst\00E4ndige E-Mail-Adresse festlegen - Enth\00E4lt die vollst\00E4ndige E-Mail-Adresse.</li>'),
unistr('<li>@ Domain als Teil des Benutzernamens ausschlie\00DFen - Entfernt den gesamten Text nach dem @-Symbol (Beispiel: <code>user1@example.com</code> wird zu <code>user1</code>).</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(504099131099566705.4353)
,p_name=>'P99_DISALLOW_APP_BUILDING'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_item_default=>'N'
,p_prompt=>'App Builder-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Legt fest, ob ein Entwickler Zugriff auf App Builder hat.<br>',
'<br>',
'Ein Administrator hat immer Zugriff auf App Builder.<br>',
'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.<br>',
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der App Builder-Zugriff f\00FCr den Workspace von einem Administrator deaktiviert ist.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(504113220550677208.4353)
,p_name=>'P99_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Zugriff auf SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Legt fest, ob ein Entwickler Zugriff auf SQL Workshop erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Zugriff auf SQL Workshop.<br>',
unistr('Entwickler m\00FCssen auf App Builder und/oder SQL Workshop zugreifen k\00F6nnen.<br>'),
'<br>',
unistr('Dieses Attribut ist immer deaktiviert, wenn der Administrator den Zugriff auf SQL Workshop f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(504113703020681605.4353)
,p_name=>'P99_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(473029411149560842.4353)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development-Zugriff'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen Sie, ob der Benutzer Team Development-Zugriff erh\00E4lt.<br>'),
'<br>',
'Administratoren erhalten automatisch Team Development-Zugriff.<br> <br>',
unistr('Dieses Attribut wird deaktiviert, wenn der Administrator den Team Development-Zugriff f\00FCr einen Workspace deaktiviert.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(504139727785076630.4353)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF :P99_DEVELOPER = ''Y'' THEN',
'    IF :P99_ALLOW_APP_BUILDING_YN = ''N''',
'    AND :P99_ALLOW_SQL_WORKSHOP_YN = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Ein Entwickler muss Zugriff auf App Builder und/oder SQL Workshop haben.'
,p_when_button_pressed=>wwv_flow_api.id(30328722239368083.4353)
,p_associated_item=>wwv_flow_api.id(473030704653560869.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(487087823895242993.4353)
,p_validation_name=>'Passwords match'
,p_validation_sequence=>20
,p_validation=>'P99_WEB_PASSWORD'
,p_validation2=>'&P99_PASSWD_CONFIRM.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Kennwort und Best\00E4tigung stimmen nicht \00FCberein.')
,p_validation_condition=>'P99_WEB_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(30328722239368083.4353)
,p_associated_item=>wwv_flow_api.id(473035819699564808.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1617426223151257724.4353)
,p_validation_name=>'Password Verification'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_separator_chars varchar2(20) := unistr(''\0009\000a\000d ,;:<>'');',
'begin',
'    if :P99_STRIP_DOMAIN = ''Y'' then',
'        l_separator_chars := l_separator_chars||''@'';',
'    end if;',
'    return wwv_flow_security.strong_password_validation(',
'          p_username       => -- extract 1st username',
'                              regexp_substr (',
'                                  :P99_users,',
'                                  ''^[''||l_separator_chars||'']+'' ),',
'          p_password       => :P99_WEB_PASSWORD,',
'          p_old_password   => null,',
'          p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'xx'
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504127119886904125.4353)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_ADMIN'
,p_condition_element=>'P99_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SSC :',
'PLSQL EXPRESSION ',
'',
'not wwv_flow_authentication_dev.can_edit_builder_users'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504127423599904126.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DEVELOPER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504127611210904126.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DEVELOPER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504129619240932237.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504130425950943648.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DEVELOPER'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504128813221921032.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504129824781933907.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_WEBSHEET_DEV_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504128015861912409.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504130030321935430.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504129027074925095.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_WEBSHEET_DEV_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504130203441937125.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504128222787914378.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_WEBSHEET_DEV_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504129232615926716.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504128429367916303.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504129407812928935.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504128603179918211.4353)
,p_event_id=>wwv_flow_api.id(504127119886904125.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504136521242027451.4353)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DEVELOPER'
,p_condition_element=>'P99_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504136819618027452.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504137000309027452.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504137606829032716.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504139120250055506.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504137400941031026.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504138704320050926.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_WEBSHEET_DEV_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504137825529038121.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_WEBSHEET_DEV_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504139328215057829.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_WEBSHEET_DEV_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504137228515029573.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_WEBSHEET_DEV_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504138910554052775.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504138003843041353.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504139504451060487.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150597732539090721.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150597942201090723.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150597836503090722.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150598056886090724.4353)
,p_event_id=>wwv_flow_api.id(504136521242027451.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504142015280120362.4353)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504142315878120363.4353)
,p_event_id=>wwv_flow_api.id(504142015280120362.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DISALLOW_APP_BUILDING'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504143315065129756.4353)
,p_name=>'Disable Disallow Websheet Development'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DISALLOW_WEBSHEET_DEV'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504143628374129757.4353)
,p_event_id=>wwv_flow_api.id(504143315065129756.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DISALLOW_WEBSHEET_DEV'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504142932249125214.4353)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504143205311125215.4353)
,p_event_id=>wwv_flow_api.id(504142932249125214.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504143702036135420.4353)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504144016081135421.4353)
,p_event_id=>wwv_flow_api.id(504143702036135420.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486696024809616323.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create collection of user names'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.create_user_coll_from_csv (',
'    p_users => :p99_users,',
'    p_security_group_id => :flow_security_group_id,',
'    p_strip_domain => :P99_STRIP_DOMAIN );',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(30328722239368083.4353)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(487181205520836565.4353)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'init collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.CREATE_OR_TRUNCATE_COLLECTION (''BULK_USER_INVALID'');',
'wwv_flow_collection.CREATE_OR_TRUNCATE_COLLECTION (''BULK_USER_CREATE'');'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_api.create_page(
 p_id=>100.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Gespeicherte interaktive Berichte'
,p_step_title=>'Gespeicherte interaktive Berichte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_ir_notifi.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492703317944462055.4353)
,p_plug_name=>'Gespeicherte Berichte'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'case when r.is_default!=''Y'' or r.application_user!=''APXWS_DEFAULT'' then',
'    wwv_flow_item.checkbox(',
'        1,',
'        r.id,null, null,'':'',',
'        ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'         wwv_flow_escape.html(',
'                          wwv_flow_lang.system_message(',
'                           ''WEBSHEET_LABEL'',',
'                           ws.websheet_name || ''( '' ||',
'                           case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'                             wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'                           else',
'                             r.name',
'                           end  || '' )'')))',
'end id,',
'a.id napp_id,',
'ws.websheet_name websheet_name,',
'case when ws.websheet_type = ''DATA'' then',
'       sm.data_grid',
'     when ws.websheet_type = ''REPORT'' then',
'       sm.report',
'end websheet_type,',
'case when r.is_default = ''Y''then ',
'     decode(r.application_user,',
'            ''APXWS_DEFAULT'',sm.primary_def, ',
'            ''APXWS_ALTERNATIVE'',sm.alt_def)',
'     when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'         sm.spublic',
'     when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'         sm.private',
'end report_type, ',
'case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'else',
'    r.name',
'end name,',
'decode(r.application_user,',
'       ''APXWS_DEFAULT'',null,',
'       ''APXWS_ALTERNATIVE'',null,',
'       r.application_user) owner,',
'substr(r.description,1,50) description,        ',
'r.report_alias report_alias,',
'(select short_name from wwv_flow_companies where provisioning_company_id =r.security_group_id) workspace',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'wwv_flow_ws_applications a,',
'wwv_flow_ws_websheet_attr ws,',
'(select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,               ',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic,',
'      wwv_flow_lang.system_message(''DATA_GRID'') data_grid,',
'      wwv_flow_lang.system_message(''REPORT'') report',
' from sys.dual) sm',
'where a.id = ws.ws_app_id',
'and ws.worksheet_id = i.id',
'and r.worksheet_id = i.id',
'and r.websheet_id is not null',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492703532092462058.4353)
,p_name=>'Saved Reports'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492703607434462063.4353)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492703713824462065.4353)
,p_db_column_name=>'NAPP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_link=>'f?p=4000:933:&SESSION.::&DEBUG.:RP:P933_ID:#NAPP_ID#'
,p_column_linktext=>'#NAPP_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492704407638462068.4353)
,p_db_column_name=>'WEBSHEET_TYPE'
,p_display_order=>3
,p_column_identifier=>'I'
,p_column_label=>'Datentyp'
,p_column_type=>'STRING'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492704300730462068.4353)
,p_db_column_name=>'WEBSHEET_NAME'
,p_display_order=>4
,p_column_identifier=>'H'
,p_column_label=>'Daten'
,p_column_type=>'STRING'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492704506342462068.4353)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>5
,p_column_identifier=>'J'
,p_column_label=>'Berichtstyp'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492704631336462068.4353)
,p_db_column_name=>'NAME'
,p_display_order=>6
,p_column_identifier=>'K'
,p_column_label=>'Berichtsname'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492704716990462069.4353)
,p_db_column_name=>'OWNER'
,p_display_order=>7
,p_column_identifier=>'L'
,p_column_label=>unistr('Eigent\00FCmer')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492704822480462069.4353)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>8
,p_column_identifier=>'M'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492704914952462069.4353)
,p_db_column_name=>'REPORT_ALIAS'
,p_display_order=>9
,p_column_identifier=>'N'
,p_column_label=>'Berichtsalias'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492705106579462070.4353)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>10
,p_column_identifier=>'P'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>':flow_security_group_id = 10'
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492709220018477482.4353)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(492707417463467235.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168717528748286543.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492706004651462075.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(492703317944462055.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492705620856462072.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(492703317944462055.4353)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_worksheet_rpts',
'where security_group_id = :flow_security_group_id',
'and session_id is null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(492707201521462080.4353)
,p_branch_action=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(492706627909462077.4353)
,p_validation_name=>'must select report to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Bericht muss zum L\00F6schen ausgew\00E4hlt werden.')
,p_when_button_pressed=>wwv_flow_api.id(492705620856462072.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199175716331878433.4353)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(492703317944462055.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199175868254878434.4353)
,p_event_id=>wwv_flow_api.id(1199175716331878433.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492707029336462079.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for c1 in (select id report_id, worksheet_id, application_user, is_default, report_type',
'               from wwv_flow_worksheet_rpts',
'               where id = wwv_flow.g_f01(i)',
'               and security_group_id=:flow_security_group_id)',
'    loop                ',
'        wwv_flow_worksheet_api.delete_saved_report (            ',
'            p_worksheet_id      => c1.worksheet_id,               ',
'            p_report_id         => c1.report_id,',
'            p_is_default        => c1.is_default);        ',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Bericht kann nicht entfernt werden.'
,p_process_when_button_id=>wwv_flow_api.id(492705620856462072.4353)
,p_process_success_message=>'Berichte entfernt.'
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_api.create_page(
 p_id=>101.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Workspace-Nutzung'
,p_step_title=>'Workspace-Nutzung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_wrkspc_rprt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168460915364538362.4353)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179695032676844855.4353)
,p_plug_name=>'Zusammenfassender Workspace-Bericht'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_workspace_reports.report_workspace_usage (',
'    p_security_group_id => :flow_security_group_id,',
'    p_time_frame_DWMY => :P101_REPORTING_PERIOD,',
'    p_date_format => :DATE_TIME_FORMAT);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180924728812199858.4353)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Bericht werden die Workspace-Aktivit\00E4ten und -Inhalte zusammengefasst.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/understanding-workspace-administration.html#GUID-B1B06D95-5D2E-4EFD-814F-92E195F1DC20">Weitere Informationen...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168466525819721064.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168460915364538362.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180927325396227273.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168460915364538362.4353)
,p_button_name=>'EMAIL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'E-Mail'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.:83:P83_REPORTING_PERIOD:&P101_REPORTING_PERIOD.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168906114987545321.4353)
,p_branch_action=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180661715523136421.4353)
,p_name=>'P101_REPORTING_PERIOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(168460915364538362.4353)
,p_item_default=>'D'
,p_prompt=>'Anzeigen'
,p_source=>'D'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_api.id(180662003103161233.4353)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie ein Zeitintervall.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(188411624638171691.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'21'
,p_compute_when=>'LAST_VIEW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00102
begin
wwv_flow_api.create_page(
 p_id=>102.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Voreinstellungen'
,p_page_mode=>'MODAL'
,p_step_title=>'Voreinstellungen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="javascript">',
'<!--',
'function confirmaction(){',
'        if (document.wwv_flow.F4350_P56_EMAIL_ADDRESS.value != document.wwv_flow.F4350_P56_ORG_EMAIL_ADDRESS.value){',
'	if(confirm("Are you sure you want to change the email address?")){',
'		doSubmit(''ApplyChanges'') ;',
'          }',
'        }else{',
'            doSubmit(''ApplyChanges'') ;',
'        }',
' }',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(485889499804058937.4353)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'480'
,p_dialog_width=>'720'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/aadm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488532238706405715.4353)
,p_plug_name=>'Voreinstellungen bearbeiten'
,p_region_css_classes=>'a-Form a-Form--small a-Form--dialog'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_api.id(1939532588110833.4353)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 19-FEB-2000 22:09:25'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488545976130405767.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488546592296405774.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(488545976130405767.4353)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
,p_button_condition=>'F4350_P102_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488546199036405767.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(488545976130405767.4353)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(385808991793243614.4353)
,p_name=>'P102_WINDOW_MGMT_MODE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(488532238706405715.4353)
,p_prompt=>unistr('Anwendung in neuem Fenster ausf\00FChren')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_preferences.get_preference(''APEX_WINDOW_MGMT_MODE''), ''FOCUS'') = ''FOCUS'' then',
'  return ''Y'';',
'else',
'  return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, wie &PRODUCT_NAME. Fenster und Registerkarten bei der Ausf\00FChrung von Anwendungen aus App Builder verwaltet.</p>'),
unistr('<p>Diese Option hat f\00FCr Sie nur Auswirkungen, wenn Sie Mozilla Firefox und Microsoft Internet Explorer verwenden. Sie bleibt bei anderen '),
'Browsern wie Google Chrome und Apple Safari wirkungslos. Wenn diese Option auf den Standardwert <strong>Ein</strong>',
unistr('gesetzt ist, werden die Browsereinstellungen ignoriert, und es wird stets ein neues Fenster ge\00F6ffnet. Bei <strong>Aus</strong>'),
unistr('wird die Laufzeitanwendung je nach Browsereinstellungen in einem neuen Fenster oder einer neuen Registerkarte ge\00F6ffnet. '),
'Mozilla Firefox und Microsoft Internet Explorer setzen den Fokus generell nicht auf eine andere Registerkarte',
unistr('in demselben Fenster, au\00DFer beim ersten Start dieser Registerkarte.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488533148621405743.4353)
,p_name=>'F4350_P102_USER_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(488532238706405715.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Benutzername'
,p_source=>'USER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'a-Form-field a-Form-field--readOnly'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gibt den Benutzernamen f\00FCr die Anmeldung beim System an. F\00FCr Benutzernamen gelten folgende Einschr\00E4nkungen:</p>'),
'<ul>',
unistr('    <li>maximale L\00E4nge von 100 Zeichen</li>'),
'    <li>keine Leerzeichen</li>',
unistr('    <li>nur folgende Sonderzeichen sind zul\00E4ssig: @ und Punkte (.)</li>'),
'</ul>',
unistr('<p>Der Benutzername kann au\00DFerdem als Referenz zur Benutzeraktivit\00E4t bei Monitoranwendungen verwendet werden. Die Bind-Variable <code>:APP_USER</code> gibt den Wert des aktuellen Benutzers zur\00FCck, wenn Anwendungen erstellt werden.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488536626516405749.4353)
,p_name=>'P102_DEFAULT_DATE_FORMAT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(488532238706405715.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Standarddatumsformat'
,p_source=>'DEFAULT_DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie das Oracle-Standarddatumsformat f\00FCr den Benutzer ein. Dies bestimmt das Standarddatumsformat in SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488537560001405751.4353)
,p_name=>'F4350_P102_DEFAULT_SCHEMA'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(488532238706405715.4353)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Standardschema'
,p_source=>'DEFAULT_SCHEMA'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Schema ausw\00E4hlen -')
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Gibt das Standardschema f\00FCr das Durchsuchen von Daten, Erstellen von Anwendungen und Ausf\00FChren von SQL-Skripts an. Wenn Sie Workspaces verwenden, bei denen mehrere Schemas verf\00FCgbar sind, ist dieses Schema das Standardschema zum Erstellen von Anwendu')
||unistr('ngen, Ausf\00FChren von SQL-Abfragen usw. Dieses Feature steuert nicht die Sicherheit, sondern nur die Benutzervoreinstellung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517712894932154580.4353)
,p_name=>'F4350_P102_USER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(488532238706405715.4353)
,p_use_cache_before_default=>'NO'
,p_source=>'USER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(655324308017394132.4353)
,p_name=>'P102_UNICODE_CSV_DOWNLOAD'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(488532238706405715.4353)
,p_item_default=>'N'
,p_prompt=>'Unicode-CSV-Downloads'
,p_source=>'F4500_CSV_DOWNLOAD_UNICODE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie an, ob SQL Workshop-CSV-Downloads in Unicode bereitgestellt werden sollen. Diese Einstellung wirkt sich nur auf SQL Workshop und nicht auf benutzerdefinierte Anwendungen aus.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(702957815921571307.4353)
,p_name=>'P102_WINDOW_MGMT_SHARE_WINDOW'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(488532238706405715.4353)
,p_prompt=>unistr('Einzelnes Fenster zur Ausf\00FChrung aller Anwendungen verwenden')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_preferences.get_preference(''APEX_WINDOW_MGMT_SHARE_WINDOW'') = ''Y'' then',
'  return ''Y'';',
'else',
'  return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob unterschiedliche Anwendungen dasselbe Anwendungslaufzeitfenster oder dieselbe Anwendungslaufzeit-Registerkarte wiederverwenden.</p>',
unistr('<p>Wenn dieser Wert auf <strong>Ein</strong> gesetzt ist, verwendet jede Anwendung, die Sie aus App Builder ausf\00FChren, '),
unistr('ein Fenster oder eine Registerkarte wieder, das oder die zur Ausf\00FChrung der vorherigen Anwendung verwendet wurde.'),
unistr('Wenn dieser Wert auf <strong>Aus</strong> gesetzt ist, wird jede Anwendung, die Sie ausf\00FChren, in einem eigenen Fenster oder einer eigenen Registerkarte ge\00F6ffnet.</p>'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(517711537090061237.4353)
,p_computation_sequence=>10
,p_computation_item=>'F4350_P102_USER_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_security.g_user'
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(488574979206479852.4353)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(488546199036405767.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(488575269793479854.4353)
,p_event_id=>wwv_flow_api.id(488574979206479852.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488836287971036219.4353)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :F4350_P102_DEFAULT_SCHEMA is not null then',
'        wwv_flow_sw_api.check_priv(p_schema=>:F4350_P102_DEFAULT_SCHEMA);',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(488546592296405774.4353)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488835539302014014.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Save User Preferences'
,p_attribute_02=>'WWV_FLOW_FND_USER'
,p_attribute_03=>'F4350_P102_USER_ID'
,p_attribute_04=>'USER_ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    user_name         = :APP_USER',
'and security_group_id = :WORKSPACE_ID'))
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(488546592296405774.4353)
,p_process_success_message=>'Voreinstellungen wurden gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488554112604405798.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Session Date Format'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  --',
'  -- If the current user is the one being edited in this workspace, then also',
'  -- update the session state value for the user default date format',
'  --',
'  if :APP_USER = upper(:F4350_P102_USER_NAME) then',
'      if trim(:P102_DEFAULT_DATE_FORMAT) is null then',
'          :G_USER_DEFAULT_DATE_FORMAT := :DATE_FORMAT;      ',
'      else',
'          :G_USER_DEFAULT_DATE_FORMAT := :P102_DEFAULT_DATE_FORMAT;',
'      end if;',
'      APEX_UTIL.SET_SESSION_STATE (''G_USER_DEFAULT_DATE_FORMAT'',v(''G_USER_DEFAULT_DATE_FORMAT''));',
'  end if;',
'  ',
'  commit;',
'  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Aktualisieren von Benutzer.'
,p_process_when_button_id=>wwv_flow_api.id(488546592296405774.4353)
,p_process_success_message=>'Benutzer "&F4350_P102_USER_NAME." aktualisiert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(385809079149243615.4353)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Window Mgmt Preferences'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_preferences.set_preference(',
'        p_preference => ''APEX_WINDOW_MGMT_MODE'',',
'        p_value      => case when :P102_WINDOW_MGMT_MODE = ''Y'' then ''FOCUS'' ',
'                          else ''BROWSER'' ',
'                        end);',
'',
'    wwv_flow_preferences.set_preference(',
'        p_preference => ''APEX_WINDOW_MGMT_SHARE_WINDOW'',',
'        p_value      => :P102_WINDOW_MGMT_SHARE_WINDOW );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_MODE'',',
'        p_application_id => 4000 );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_SHARE_WINDOW'',',
'        p_application_id => 4000 );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_MODE'',',
'        p_application_id => 4750 );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_SHARE_WINDOW'',',
'        p_application_id => 4750 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(488546592296405774.4353)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(655324481856394133.4353)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Unicode CSV Download preference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P102_UNICODE_CSV_DOWNLOAD = ''Y'' then',
'        wwv_flow_preferences.set_preference(',
'            p_preference => ''F4500_CSV_DOWNLOAD_UNICODE'',',
'            p_value      => ''Y'' );',
'    else',
'        wwv_flow_preferences.remove_preference(',
'            p_preference => ''F4500_CSV_DOWNLOAD_UNICODE'' );',
'    end if;',
'end;',
'        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(488546592296405774.4353)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(690210945477382214.4353)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488575454565484164.4353)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488576740665547455.4353)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch User Information'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER'
,p_attribute_03=>'F4350_P102_USER_ID'
,p_attribute_04=>'USER_ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    user_name         = :APP_USER',
'and security_group_id = :WORKSPACE_ID'))
);
end;
/
prompt --application/pages/page_00103
begin
wwv_flow_api.create_page(
 p_id=>103.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Anwendungs-Hash pro Tag'
,p_step_title=>'Anwendungs-Hash pro Tag'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(381353083347254854.4353)
,p_plug_name=>'Anwendungs-Hash pro Tag'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    APPLICATION_NAME,',
'    LOG_DAY,',
'    WORKSPACE_ID,',
'    APPLICATION_ID,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash',
'from  WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id',
'      and instr(additional_attributes,''"hash":'') > 0'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(381353182660254854.4353)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>381353182660254854
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219094448124410000.4353)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Tag der Protokollierung'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219094853991410000.4353)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219095282350410001.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219094052812410000.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>184
,p_column_identifier=>'V'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219101612145410007.4353)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>194
,p_column_identifier=>'W'
,p_column_label=>'Anwendungs-Hash'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219108010573410014.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(381353083347254854.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00104
begin
wwv_flow_api.create_page(
 p_id=>104.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Einstellungen f\00FCr interaktive Berichte verwalten')
,p_step_title=>unistr('Einstellungen f\00FCr interaktive Berichte verwalten')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_ir_notifi.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(493061118723051127.4353)
,p_plug_name=>unistr('Einstellungen f\00FCr interaktive Berichte verwalten')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(41809121808367332.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(493062125087062445.4353)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Mit diesen Utilitys k\00F6nnen Sie Einstellungen f\00FCr gespeicherte interaktive Berichte und E-Mail-Subscriptions melden und l\00F6schen. Diese Einstellungen k\00F6nnen von Endbenutzern erstellt werden, die interaktive Berichte verwenden.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00105
begin
wwv_flow_api.create_page(
 p_id=>105.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Workspace-Umgebungsbanner'
,p_alias=>'ENVIRONMENT-BANNER'
,p_page_mode=>'MODAL'
,p_step_title=>'Workspace-Umgebungsbanner'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_dialog_width=>'640'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145785163484283101.4353)
,p_plug_name=>'Workspace-Umgebungsbanner definieren'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145785616730283106.4353)
,p_plug_name=>unistr('Schaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177716258227191001.4353)
,p_plug_name=>'Instanzbanner aktiviert'
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>14
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Hinweis: Das Umgebungsbanner f\00FCr diese &PRODUCT_NAME.-Instanz ist derzeit <strong>aktiviert</strong>. '),
unistr('Sie k\00F6nnen dieses Banner auf Instanzebene au\00DFer Kraft setzen, indem Sie unten ein Banner auf Workspace-Ebene festlegen.')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'coalesce( wwv_flow_platform.get_preference( ''ENV_BANNER_ENABLE'' ), ''N'' ) = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145786002247283110.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(145785616730283106.4353)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145785711767283107.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(145785616730283106.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(145793944165217003.4353)
,p_branch_name=>'Go To Page &LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145785230216283102.4353)
,p_name=>'P105_ENABLE_BANNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(145785163484283101.4353)
,p_prompt=>'Banner aktivieren'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157815226475866526.4353)||'.'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob das Umgebungsbanner f\00FCr diesen Workspace aktiviert werden soll.</p>'),
'<p>Wenn der Workspace aktiviert ist, wird er in der gesamten &PRODUCT_NAME.-Entwicklungsumgebung angezeigt.</p>'))
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145785403480283104.4353)
,p_name=>'P105_BANNER_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(145785163484283101.4353)
,p_prompt=>'Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie ein kurzes aussagekr\00E4ftiges Label ein, das in diesem Umgebungsbanner angezeigt wird. Beispiel:</p>'),
'<ul>',
'    <li>APEX 21.2 Apps</li>',
'    <li>Marvel UAT</li>',
'    <li>JKALLMAN Prod Env</li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145785572990283105.4353)
,p_name=>'P105_BANNER_COLOR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(145785163484283101.4353)
,p_prompt=>'Farbe'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P105_BANNER_COLORS'
,p_lov=>'.'||wwv_flow_api.id(2923311877329862.4353)||'.'
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_css_classes=>'a-EnvBanner-colorSelector'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie eine Hintergrundfarbe f\00FCr die Bannernachricht aus. Diese Farbe wird auch auf die Entwicklersymbolleiste angewendet.')
,p_attribute_01=>'8'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(883418688394822206.4353)
,p_name=>'P105_BANNER_POS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(145785163484283101.4353)
,p_prompt=>'Position'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P105_BANNER_POS'
,p_lov=>'.'||wwv_flow_api.id(146455139760592304.4353)||'.'
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Anzeigeposition des Banners aus.')
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145793748330217001.4353)
,p_validation_name=>'if enabled, label required'
,p_validation_sequence=>10
,p_validation=>'P105_BANNER_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss angegeben werden.'
,p_validation_condition=>'P105_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(145786002247283110.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145793847377217002.4353)
,p_validation_name=>'if enabled, color required'
,p_validation_sequence=>20
,p_validation=>'P105_BANNER_COLOR'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss angegeben werden.'
,p_validation_condition=>'P105_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(145786002247283110.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(145785800019283108.4353)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(145785711767283107.4353)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(145785965618283109.4353)
,p_event_id=>wwv_flow_api.id(145785800019283108.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(145802697662189309.4353)
,p_name=>'toggle banner configuration'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P105_ENABLE_BANNER'
,p_condition_element=>'P105_ENABLE_BANNER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(145802764549189310.4353)
,p_event_id=>wwv_flow_api.id(145802697662189309.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P105_BANNER_POS,P105_BANNER_LABEL,P105_BANNER_COLOR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(145802834921189311.4353)
,p_event_id=>wwv_flow_api.id(145802697662189309.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P105_BANNER_POS,P105_BANNER_LABEL,P105_BANNER_COLOR'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(145802598642189308.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save env banner'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_companies',
'   set env_banner_yn = :P105_ENABLE_BANNER,',
'       env_banner_label = :P105_BANNER_LABEL,',
'       env_banner_color = :P105_BANNER_COLOR,',
'       env_banner_pos   = :P105_BANNER_POS',
' where PROVISIONING_COMPANY_ID = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Umgebungsbanner auf Workspace-Ebene kann nicht gespeichert werden.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(145786002247283110.4353)
,p_process_success_message=>'Das Umgebungsbanner auf Workspace-Ebene wurde gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(145802470467189307.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch workspace env banner'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_env_banner in (',
'    select env_banner_yn,',
'           env_banner_label,',
'           env_banner_color,',
'           env_banner_pos',
'      from wwv_flow_companies',
'     where provisioning_company_id = :flow_security_group_id )',
'loop',
'    :P105_ENABLE_BANNER := l_env_banner.env_banner_yn;',
'    :P105_BANNER_LABEL  := l_env_banner.env_banner_label;',
'    :P105_BANNER_COLOR  := l_env_banner.env_banner_color;',
'    :P105_BANNER_POS    := coalesce( l_env_banner.env_banner_pos, ''LEFT'' );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(145803082296189313.4353)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'if disabled, set pos, label, color to NULL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P105_BANNER_POS   := null;',
':P105_BANNER_LABEL := null;',
':P105_BANNER_COLOR := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(145786002247283110.4353)
,p_process_when=>'P105_ENABLE_BANNER'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'N'
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_api.create_page(
 p_id=>150.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Export-Repository verwalten'
,p_step_title=>'Export-Repository verwalten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_export_repos.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168469924987916319.4353)
,p_plug_name=>'Export-Repository'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ''<input type="checkbox" NAME="f01" VALUE="''||id||''">'' cb,',
'    flow_id application_id,',
'    decode(',
'       (select count(*) from wwv_flows f where d.flow_id = f.id and f.security_group_id = :flow_security_group_id),',
'       0,''No'',''Yes'') application_exists,',
'    nvl(title, name) title,',
'    mime_type,',
'    sys.dbms_lob.getlength(blob_content) download,',
'    sys.dbms_lob.getlength(blob_content) file_size,',
'    created_by,',
'    created_on,',
'    file_type,',
'    id',
'from WWV_FLOW_FILE_OBJECTS$ d',
'where security_group_id = :flow_security_group_id and',
'deleted_as_of = to_date(''01.01.0001'',''MM.DD.YYYY'')'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(168470000722916319.4353)
,p_name=>'Manage Export Repository'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470207926916321.4353)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('L\00F6schen')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470313889916324.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470414959916324.4353)
,p_db_column_name=>'APPLICATION_EXISTS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Anwendung ist vorhanden'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470530188916324.4353)
,p_db_column_name=>'TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('\00DCberschrift')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1146879893424737848.4353)
,p_db_column_name=>'DOWNLOAD'
,p_display_order=>14
,p_column_identifier=>'K'
,p_column_label=>'Herunterladen'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_format_mask=>'DOWNLOAD:WWV_FLOW_FILE_OBJECTS$:BLOB_CONTENT:ID::MIME_TYPE:FILENAME:::attachment:#TITLE#:'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470622836916325.4353)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>24
,p_column_identifier=>'E'
,p_column_label=>'MIME-Typ'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470709960916325.4353)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>34
,p_column_identifier=>'F'
,p_column_label=>unistr('Dateigr\00F6\00DFe')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470800258916326.4353)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>44
,p_column_identifier=>'G'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168470923329916326.4353)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>54
,p_column_identifier=>'H'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168471007452916327.4353)
,p_db_column_name=>'FILE_TYPE'
,p_display_order=>64
,p_column_identifier=>'I'
,p_column_label=>'Dateityp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168471117925916327.4353)
,p_db_column_name=>'ID'
,p_display_order=>74
,p_column_identifier=>'J'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(434337900505154290.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168469924987916319.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:150,RIR,RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(434341411680214256.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168469924987916319.4353)
,p_button_name=>'DELETE_REQUESTED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(434341232674210836.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete requested'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i) and',
'           security_group_id = :flow_security_group_id',
'   ;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(434341411680214256.4353)
,p_process_success_message=>unistr('Ausgew\00E4hlte Dateien wurden gel\00F6scht.')
);
end;
/
prompt --application/pages/page_00190
begin
wwv_flow_api.create_page(
 p_id=>190.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Am h\00E4ufigsten angezeigte Seiten aller Anwendungen')
,p_alias=>'A'
,p_step_title=>unistr('Am h\00E4ufigsten angezeigte Seiten aller Anwendungen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450408166535437)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9344821301743320.4353)
,p_plug_name=>'Topseitenansichten'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P190a */',
'      flow_id,',
'      (select name from wwv_flows where id = x.flow_id) name,',
'      step_id,',
'      rnk,cnt, ( rtr * 100) rtr, ',
'      round(( rtr * 100)) graph,',
'      (select name from wwv_flow_steps where id = x.step_id and flow_id = x.flow_id) page_name,',
' (select decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''unknown'') page_type from wwv_flow_steps where id = x.step_id and flow_id = x.flow_id) page_type',
'  from(',
'    select flow_id,step_id,cnt,',
'           dense_rank() over(order by cnt desc) rnk,',
'           ratio_to_report(cnt) over () rtr',
'      from (',
'        select flow_id,step_id,count(*) cnt',
'          from wwv_flow_activity_log l',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID and page_mode != ''A''',
'         group by flow_id,step_id',
'        having exists',
'                 (select 1',
'                    from wwv_flows',
'                   where id = l.flow_id',
'                     and security_group_id = :FLOW_SECURITY_GROUP_ID))',
'      ) x,',
'(select ',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''CALENDAR_TYPE'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''PAGE_ZERO'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from dual)  sm',
' where rnk < to_number(:P190_N) + 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>unistr('<p>Seitenverarbeitungseintr\00E4ge werden ausgelassen.</p>')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9344928950743320.4353)
,p_name=>'Top Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9345110175743323.4353)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9345202962743323.4353)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9345305868743323.4353)
,p_db_column_name=>'STEP_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9345426864743323.4353)
,p_db_column_name=>'RNK'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Rang'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9345505548743323.4353)
,p_db_column_name=>'CNT'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Anzahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9345608395743324.4353)
,p_db_column_name=>'RTR'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'% Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9345707890743324.4353)
,p_db_column_name=>'GRAPH'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Diagramm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9380508609926649.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9384030389980303.4353)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Seitentyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30380917465045384.4353)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30491307413316931.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(30380917465045384.4353)
,p_button_name=>'P190_GO'
,p_button_static_id=>'P190_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200658627668418842.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30380917465045384.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:190:&SESSION.::&DEBUG.:190,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30495310445336766.4353)
,p_branch_action=>'f?p=&FLOW_ID.:190:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30479428275304064.4353)
,p_name=>'P190_N'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30380917465045384.4353)
,p_item_default=>'10'
,p_prompt=>'Topseitenansichten'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>4
,p_cattributes_element=>'valign="top"'
,p_tag_attributes=>'style="padding:0px; "'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Geben Sie die Anzahl der Seiten ein, f\00FCr die die Topseitenansichten angezeigt werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47504127115684653.4353)
,p_validation_name=>'CheckNumber'
,p_validation_sequence=>10
,p_validation=>'P190_N'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Der Wert muss numerisch sein.'
,p_associated_item=>wwv_flow_api.id(30479428275304064.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00300
begin
wwv_flow_api.create_page(
 p_id=>300.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Gecachte Regionen pro Workspace l\00F6schen')
,p_step_title=>unistr('Gecachte Regionen pro Workspace l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_reg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41860601486553192.4353)
,p_plug_name=>unistr('Gecachte Regionen pro Workspace l\00F6schen')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41861530818553199.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(41860601486553192.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41861331112553199.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(41860601486553192.4353)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Alle gecachten Regionen l\00F6schen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41862518476553203.4353)
,p_branch_action=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41861715868553200.4353)
,p_name=>'P300_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(41860601486553192.4353)
,p_item_default=>'0'
,p_prompt=>'Anzahl gecachter Regionen:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt die Anzahl der gecachten Regionen an, die gel\00F6scht werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(148453911726971659.4353)
,p_computation_sequence=>10
,p_computation_item=>'P300_APPLICATION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is not null'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41862208989553202.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cached Regions by workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id)',
'loop',
'   wwv_flow_page_cache_api.purge_regions_by_app (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('L\00F6schen von gecachten Regionen nicht m\00F6glich')
,p_process_when_button_id=>wwv_flow_api.id(41861331112553199.4353)
,p_process_when=>'P300_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>unistr('Alle gecachten Regionen wurden gel\00F6scht')
);
end;
/
prompt --application/pages/page_00301
begin
wwv_flow_api.create_page(
 p_id=>301.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Gecachte Regionen pro Region l\00F6schen')
,p_step_title=>unistr('Gecachte Regionen pro Region l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_reg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10306117384310103.4353)
,p_plug_name=>'Gecachte Regionen verwalten'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(388531674152470979.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   APEX_ITEM.CHECKBOX(1, r.id,null,null, '':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''PURGE_LABEL'', r.plug_name)) cb,',
'   c.flow_id application_id,',
'   (select name from wwv_flows where id = c.flow_id) application_name,',
'   c.page_id, ',
'   (select name from wwv_flow_steps where flow_id = c.flow_id and id = c.page_id) page_name,',
'   c.region_id, ',
'   r.plug_name region_name,',
'       decode(r.PLUG_SOURCE_TYPE,',
'        ''PLSQL_PROCEDURE'',m.plsql,',
'        ''SIMPLE_CHART'',m.HTML_CHART,',
'        ''SQL_QUERY'',m.Report,',
'        ''STATIC_TEXT'',m.html_slash_text,',
'        ''STATIC_TEXT_ESCAPE_SC'',m.text_esc,',
'        ''STATIC_TEXT_WITH_SHORTCUTS'',m.html_text_with_shortcuts,',
'        ''STRUCTURED_QUERY'',m.Report,',
'        ''FUNCTION_RETURNING_SQL_QUERY'',m.Report,',
'        ''SVG_CHART'',m.svg_chart,',
'        ''TREE'',m.tree,',
'        ''UPDATABLE_SQL_QUERY'',m.tabular_form,',
'        ''URL'',''URL'',',
'        decode(substr(r.PLUG_SOURCE_TYPE,1,1),''M'',m.Breadcrumb,m.list))',
'                                         region_type,',
'   c.language, ',
'  sys.dbms_lob.getlength(c.page_text) text_length, ',
'  to_char(c.cached_on,''YYYY.MM.DD HH24:MI:SS'') cached_on, ',
'  round((sysdate - c.cached_on) * 3600 * 24,0) cache_age_in_seconds, ',
'    r.PLUG_CACHING_MAX_AGE_IN_SEC - round((sysdate - c.cached_on) * 3600 * 24,0) max_age_in_seconds,',
'  decode(greatest((sysdate - c.cached_on) * 3600 * 24,r.PLUG_CACHING_MAX_AGE_IN_SEC),r.PLUG_CACHING_MAX_AGE_IN_SEC,m.Unexpired,m.Expired) cache_status,',
'  r.PLUG_CACHING caching_method,',
'decode(decode(r.PLUG_CACHE_WHEN,null,''N'',''0'',''N'',''Y''),''N'',null,''<img src="#IMAGE_PREFIX#htmldb/builder/check_small_black.gif" border="0" height="15" width="15" alt="">'')',
'   conditional',
'from wwv_flow_page_cache c,',
'     wwv_flow_page_plugs r,',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired,',
'   wwv_flow_lang.system_message(''PLSQL'') plsql,',
'   wwv_flow_lang.system_message(''HTML_CHART'') html_chart,',
'   wwv_flow_lang.system_message(''REPORT'') report,',
'   wwv_flow_lang.system_message(''HTML_SLASH_TEXT'') html_slash_text,',
'   wwv_flow_lang.system_message(''LAYOUT.HTML_TEXT_ESCAPE_SC'') text_esc,',
'   wwv_flow_lang.system_message(''HTML_TEXT_WITH_SHORTCUTS'')',
'      html_text_with_shortcuts,',
'   wwv_flow_lang.system_message(''F4000_SVG_CHART'') svg_chart,',
'   wwv_flow_lang.system_message(''F4000_TREE'') tree,',
'   wwv_flow_lang.system_message(''F4000.LIST_INITCAP'') list,',
'   wwv_flow_lang.system_message(''BREADCRUMB'') Breadcrumb,',
'   wwv_flow_lang.system_message(''TABULAR_FORM'') tabular_form',
' from dual) m',
'where c.region_id = r.id and',
'      c.flow_id = r.flow_id and',
'      c.security_group_id = :flow_security_group_id and ',
'      c.region_id is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10306229448310103.4353)
,p_name=>'Manage Cached Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10306421748310114.4353)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('L\00F6schen')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10306512108310114.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10306624180310114.4353)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10306721504310114.4353)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10306829907310114.4353)
,p_db_column_name=>'REGION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Region'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10306904667310115.4353)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Regionsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307019944310115.4353)
,p_db_column_name=>'REGION_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Regionstyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307126409310115.4353)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Sprache'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307205454310115.4353)
,p_db_column_name=>'TEXT_LENGTH'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Textl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307314483310115.4353)
,p_db_column_name=>'CACHED_ON'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Gecacht'
,p_column_type=>'STRING'
,p_format_mask=>'&DATE_TIME_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307429626310115.4353)
,p_db_column_name=>'CACHE_AGE_IN_SECONDS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Cachealter'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307501893310115.4353)
,p_db_column_name=>'MAX_AGE_IN_SECONDS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307625649310116.4353)
,p_db_column_name=>'CACHE_STATUS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Status'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307705887310116.4353)
,p_db_column_name=>'CACHING_METHOD'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Methode'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(672366941474304666)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10307931291310116.4353)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Bedingt'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10311300580342753.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452473524714012768.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10306117384310103.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41674312075061773.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(10306117384310103.4353)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ausgew\00E4hlte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41517719933473648.4353)
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41681201255077529.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Puge Checked Regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    for c1 in (select flow_id, id from wwv_flow_page_plugs',
'        where id = to_number(wwv_flow.g_f01(j)) and',
'              security_group_id = :flow_security_group_id) loop',
'      wwv_flow_page_cache_api.purge_regions_by_id (',
'        p_application => c1.flow_id,',
'        p_region_id => c1.id);',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('L\00F6schen von gecachten Regionen nicht m\00F6glich')
,p_process_success_message=>unistr('Gecachte Regionen wurden gel\00F6scht')
);
end;
/
prompt --application/pages/page_00302
begin
wwv_flow_api.create_page(
 p_id=>302.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Gecachte Seiten pro Seite l\00F6schen')
,p_step_title=>unistr('Gecachte Seiten pro Seite l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10320916435416902.4353)
,p_plug_name=>'Gecachte Seiten verwalten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>12
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    apex_item.checkbox(1,id2) cb,',
'    flow_id application,',
'    (select name from wwv_flows where id = flow_id) application_name,',
'    id,',
'    name,',
'    cache_mode,',
'    cache_timeout_seconds timeout,',
'    cache_when_condition_type conditional,',
'    cached_pages,',
'    most_recent_cache',
'from',
'(',
'select ID,',
'       rowid id2,',
'       flow_id,',
'       NAME,',
'       cache_mode,',
'       cache_timeout_seconds,',
'       decode(cache_when_condition_type,',
'              null,null,',
'              ''<img src="#IMAGE_PREFIX#htmldb/builder/check_small_black.gif" border="0" height="15" width="15" alt="">'') cache_when_condition_type,',
'       (select count(*) from wwv_flow_page_cache where flow_id = s.flow_id and page_id = s.id and security_group_id = :flow_security_group_id) cached_pages,',
'       (select max(cached_on) co from wwv_flow_page_cache where flow_id = s.flow_id and page_id = s.id and security_group_id = :flow_security_group_id) most_recent_cache',
'from WWV_FLOW_STEPS s',
'where id = abs(id)',
'  and s.security_group_id = :flow_security_group_id',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10321019377416902.4353)
,p_name=>'Manage Cached Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10321208647416903.4353)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('L\00F6schen')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10321324196416904.4353)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10321426141416905.4353)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10321505286416905.4353)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10322006408416906.4353)
,p_db_column_name=>'CACHED_PAGES'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Gecachte Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10322110865416906.4353)
,p_db_column_name=>'MOST_RECENT_CACHE'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>'Letzte'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10321700406416905.4353)
,p_db_column_name=>'TIMEOUT'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10321926064416905.4353)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>'Bedingt'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10323023099424920.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(672358706301300327.4353)
,p_db_column_name=>'CACHE_MODE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Cachemodus '
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(672366941474304666)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452494407764159218.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10320916435416902.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42426332383298687.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(10320916435416902.4353)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ausgew\00E4hlte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42429221514298690.4353)
,p_branch_action=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42428913706298689.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Puge Checked Regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    for c1 in (select flow_id, id from wwv_flow_steps',
'        where rowid = wwv_flow.g_f01(j) and',
'              security_group_id = :flow_security_group_id) loop',
'      wwv_flow_page_cache_api.purge_by_page (',
'        p_application => c1.flow_id,',
'        p_page => c1.id,',
'        p_user_name => null);',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('L\00F6schen von gecachten Regionen nicht m\00F6glich')
,p_process_when_button_id=>wwv_flow_api.id(42426332383298687.4353)
,p_process_success_message=>unistr('Gecachte Regionen wurden gel\00F6scht')
);
end;
/
prompt --application/pages/page_00303
begin
wwv_flow_api.create_page(
 p_id=>303.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Gecachte Regionen pro Anwendung l\00F6schen')
,p_step_title=>unistr('Gecachte Regionen pro Anwendung l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_reg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41695813638100063.4353)
,p_plug_name=>unistr('Gecachte Regionen pro Anwendung l\00F6schen')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41722502434163040.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(41695813638100063.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41709609660136734.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(41695813638100063.4353)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Gecachte Regionen l\00F6schen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41711215547138478.4353)
,p_branch_action=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41705405242116590.4353)
,p_name=>'P303_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(41695813638100063.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||''. ''||wwv_flow_escape.html(f.name)||'' (''||count(*)||'')'' n, f.id ',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is not null',
'group by f.id, f.name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Anwendung ausw\00E4hlen -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie die Anwendung an, aus der alle gecachten Regionen gel\00F6scht werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41715118795148887.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cached Regions by Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
'id = :P303_APPLICATION) loop',
'   wwv_flow_utilities.purge_regions_by_app (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('L\00F6schen von gecachten Regionen nicht m\00F6glich')
,p_process_when=>'P303_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>unistr('Gecachte Regionen wurden gel\00F6scht')
);
end;
/
prompt --application/pages/page_00304
begin
wwv_flow_api.create_page(
 p_id=>304.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Gecachte Seiten pro Anwendung l\00F6schen')
,p_step_title=>unistr('Gecachte Seiten pro Anwendung l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42340424785643419.4353)
,p_plug_name=>unistr('Gecachte Seiten pro Anwendung l\00F6schen')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42341306028643420.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(42340424785643419.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42341112259643420.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42340424785643419.4353)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Gecachte Seiten l\00F6schen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42342314925643421.4353)
,p_branch_action=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42341519571643420.4353)
,p_name=>'P304_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(42340424785643419.4353)
,p_item_default=>'0'
,p_prompt=>'Anwendung:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||''. ''||wwv_flow_escape.html(f.name)||'' (''||count(*)||'')'' n, f.id ',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is null',
'group by f.id, f.name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Anwendung ausw\00E4hlen -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie die Anwendung an, aus der alle gecachten Seiten gel\00F6scht werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42342010845643421.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cached Pages by Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
'id = :P304_APPLICATION) loop',
'   wwv_flow_utilities.cache_purge_by_application (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Gecachte Seiten l\00F6schen nicht m\00F6glich')
,p_process_when=>'P304_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>unistr('Gecachte Seiten wurden gel\00F6scht')
);
end;
/
prompt --application/pages/page_00352
begin
wwv_flow_api.create_page(
 p_id=>352.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_step_title=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162260122382844861.4353)
,p_plug_name=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    APPLICATION_NAME,',
'    LOG_DAY,',
'    to_char(log_day,''YYYY.MM'') log_month,',
'    WORKSPACE_ID,',
'    APPLICATION_ID,',
'    PAGE_EVENTS,',
'    PAGE_VIEWS,',
'    PAGE_ACCEPTS,',
'    PARTIAL_PAGE_VIEWS,',
'    WEBSHEET_VIEWS,',
'    ROWS_FETCHED,',
'    IR_SEARCHES,',
'    DISTINCT_PAGES,',
'    DISTINCT_USERS,',
'    DISTINCT_SESSIONS,',
'    AVERAGE_RENDER_TIME,',
'    MEDIAN_RENDER_TIME,',
'    MAXIMUM_RENDER_TIME,',
'    TOTAL_RENDER_TIME,',
'    ERROR_COUNT,',
'    content_length,',
'    public_page_events,',
'    additional_attributes,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash,',
'    nvl(decode(instr(additional_attributes,''"pages":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8),'','')-1)),''0'')  pages,',
'    nvl(decode(instr(additional_attributes,''"jetCharts":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12),'','')-1)),''0'') jetcharts,',
'    nvl(decode(instr(additional_attributes,''"interactiveReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21),'','')-1)),''0'')  interactiveReports,',
'    nvl(decode(instr(additional_attributes,''"classicReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3),'','')-1)),''0'')  classicReports,',
'    nvl(decode(instr(additional_attributes,''"interactiveGrids":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3),'','')-1)),''0'')  interactiveGrids,',
'    nvl(decode(instr(additional_attributes,''"aclUsers":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3),'','')-1)),''0'')  aclUsers,        ',
'    nvl(decode(instr(additional_attributes,''"appSettings":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3),'','')-1)),''0'')  appSettings,          ',
'    nvl(decode(instr(additional_attributes,''"buildOptions":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3),'','')-1)),''0'')  buildOptions,         ',
'    nvl(decode(instr(additional_attributes,''"emailTemplates":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3),'','')-1)),''0'')  emailTemplates,         ',
'    nvl(decode(instr(additional_attributes,''"plugins":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3),'','')-1)),''0'')  plugins,        ',
'    nvl(decode(instr(additional_attributes,''"tabularForms":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3),'','')-1)),''0'')  tabularForms',
'from WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(162260221695844861.4353)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162260401162844862.4353)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Tag der Protokollierung'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162260508477844863.4353)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162260600823844863.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162260732507844864.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582264628062682817.4353)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>14
,p_column_identifier=>'T'
,p_column_label=>unistr('\00D6ffentliche Seite - Ereignisse')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162260817985844864.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>24
,p_column_identifier=>'E'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162260902753844864.4353)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>34
,p_column_identifier=>'F'
,p_column_label=>unistr('Seitenbest\00E4tigungsvorg\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261002694844865.4353)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>44
,p_column_identifier=>'G'
,p_column_label=>'Seitenbestandteil-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261129873844865.4353)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>54
,p_column_identifier=>'H'
,p_column_label=>'Websheet-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261206726844866.4353)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>64
,p_column_identifier=>'I'
,p_column_label=>'Abgerufene Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261301710844866.4353)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>74
,p_column_identifier=>'J'
,p_column_label=>'IR-Suchen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261406930844867.4353)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>84
,p_column_identifier=>'K'
,p_column_label=>'Aktive Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261527481844867.4353)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>94
,p_column_identifier=>'L'
,p_column_label=>'Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261618519844867.4353)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>104
,p_column_identifier=>'M'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261703810844868.4353)
,p_db_column_name=>'AVERAGE_RENDER_TIME'
,p_display_order=>114
,p_column_identifier=>'N'
,p_column_label=>'Durchschnittliche Render-Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261813499844868.4353)
,p_db_column_name=>'MEDIAN_RENDER_TIME'
,p_display_order=>124
,p_column_identifier=>'O'
,p_column_label=>unistr('Medianwert f\00FCr Render-Zeit')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162261905907844869.4353)
,p_db_column_name=>'MAXIMUM_RENDER_TIME'
,p_display_order=>134
,p_column_identifier=>'P'
,p_column_label=>'Maximale Render-Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162262025277844869.4353)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>144
,p_column_identifier=>'Q'
,p_column_label=>'Gesamte Render-Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162262111135844869.4353)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>154
,p_column_identifier=>'R'
,p_column_label=>'Fehleranzahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201285925412147292.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>164
,p_column_identifier=>'S'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84538686011706812.4353)
,p_db_column_name=>'ADDITIONAL_ATTRIBUTES'
,p_display_order=>174
,p_column_identifier=>'U'
,p_column_label=>unistr('Zus\00E4tzliche Attribute')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84538829661706814.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>184
,p_column_identifier=>'V'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176253754674916937.4353)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>194
,p_column_identifier=>'W'
,p_column_label=>'Anwendungs-Hash'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176253802394916938.4353)
,p_db_column_name=>'PAGES'
,p_display_order=>204
,p_column_identifier=>'X'
,p_column_label=>'Seiten'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176253901895916939.4353)
,p_db_column_name=>'JETCHARTS'
,p_display_order=>214
,p_column_identifier=>'Y'
,p_column_label=>'JET-Diagramme'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254060245916940.4353)
,p_db_column_name=>'INTERACTIVEREPORTS'
,p_display_order=>224
,p_column_identifier=>'Z'
,p_column_label=>'Interaktive Berichte'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254116102916941.4353)
,p_db_column_name=>'CLASSICREPORTS'
,p_display_order=>234
,p_column_identifier=>'AA'
,p_column_label=>'Klassische Berichte'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254290645916942.4353)
,p_db_column_name=>'INTERACTIVEGRIDS'
,p_display_order=>244
,p_column_identifier=>'AB'
,p_column_label=>'Interaktive Grids'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254381122916943.4353)
,p_db_column_name=>'ACLUSERS'
,p_display_order=>254
,p_column_identifier=>'AC'
,p_column_label=>'ACL-Benutzer'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254476997916944.4353)
,p_db_column_name=>'APPSETTINGS'
,p_display_order=>264
,p_column_identifier=>'AD'
,p_column_label=>'Anwendungseinstellungen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254504216916945.4353)
,p_db_column_name=>'BUILDOPTIONS'
,p_display_order=>274
,p_column_identifier=>'AE'
,p_column_label=>'Erstelloptionen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254650832916946.4353)
,p_db_column_name=>'EMAILTEMPLATES'
,p_display_order=>284
,p_column_identifier=>'AF'
,p_column_label=>'E-Mail-Templates'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254768246916947.4353)
,p_db_column_name=>'PLUGINS'
,p_display_order=>294
,p_column_identifier=>'AG'
,p_column_label=>'Plug-ins'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176254969597916949.4353)
,p_db_column_name=>'TABULARFORMS'
,p_display_order=>314
,p_column_identifier=>'AI'
,p_column_label=>'Tabellarische Formulare'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(395886365186084621.4353)
,p_db_column_name=>'LOG_MONTH'
,p_display_order=>324
,p_column_identifier=>'AJ'
,p_column_label=>'Logmonat'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450813015470464956.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(162260122382844861.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:RR,RIR::'
,p_icon_css_classes=>'icon-undo'
);
end;
/
prompt --application/pages/page_00353
begin
wwv_flow_api.create_page(
 p_id=>353.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_step_title=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162264332021892953.4353)
,p_plug_name=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(websheet_views) WEBSHEET_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id',
'group by LOG_DAY, workspace_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(162264515119892954.4353)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162264604274892956.4353)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Logdatum'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162264720651892957.4353)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162264928769892957.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265007935892958.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265104003892958.4353)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Seitenbest\00E4tigungsvorg\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265211713892959.4353)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Seitenbestandteil-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265314502892959.4353)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Websheet-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265430194892959.4353)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Abgerufene Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265515694892960.4353)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'IR-Suchen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265626522892960.4353)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Eindeutige Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265711965892961.4353)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Eindeutige Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162265801323892961.4353)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Eindeutige Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162266206251892963.4353)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Gesamte Render-Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162266325784892963.4353)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Fehleranzahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162267612358914457.4353)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Anwendungen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168906831310578374.4353)
,p_db_column_name=>'DAY'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201285117877126238.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582264703034682818.4353)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>31
,p_column_identifier=>'V'
,p_column_label=>unistr('\00D6ffentliche Seite - Ereignisse')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450811631699441244.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(162264332021892953.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169323723183650261.4353)
,p_branch_action=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00354
begin
wwv_flow_api.create_page(
 p_id=>354.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Zusammenfassung Aktivit\00E4tslog pro Anwendung')
,p_step_title=>unistr('Zusammenfassung Aktivit\00E4tslog pro Anwendung')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162268108872925636.4353)
,p_plug_name=>unistr('Zusammenfassung Aktivit\00E4tslog')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>14
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    application_id,',
'    application_id||''. ''||(select name from wwv_flows where id = application_id) application_name,',
'    WORKSPACE_ID,',
'    count(distinct log_day) days,',
'    min(log_day)     since_date,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(websheet_views) WEBSHEET_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(total_render_time)/sum(page_events) avg_elap_time,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id and',
'log_day >= sysdate - (NVL(:P354_SINCE,365)+1)',
'group by application_id, workspace_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(162268324547925637.4353)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162268510942925638.4353)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162268612852925638.4353)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Seitenereignisse'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162268710082925639.4353)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162268807643925639.4353)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Seitenbest\00E4tigungsvorg\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162268923860925640.4353)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Seitenbestandteil-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269019615925640.4353)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Websheet-Ansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269128509925640.4353)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Abgerufene Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269209021925641.4353)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'IR-Suchen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269305309925641.4353)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Eindeutige Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269400875925642.4353)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Eindeutige Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269513271925642.4353)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Eindeutige Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269615521925642.4353)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Gesamte Render-Zeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162269717928925643.4353)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Fehleranzahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162271418161935037.4353)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162271523526935038.4353)
,p_db_column_name=>'DAYS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162271718984944751.4353)
,p_db_column_name=>'SINCE_DATE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'"Seit"-Datum'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(180654932380933226.4353)
,p_db_column_name=>'AVG_ELAP_TIME'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Durchschnittliche Dauer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(180659706033048576.4353)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Anwendungsname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201286518879173836.4353)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582264873008682819.4353)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>34
,p_column_identifier=>'Y'
,p_column_label=>unistr('\00D6ffentliche Seite - Ereignisse')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(758054138318278409.4353)
,p_plug_name=>'Button Region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(758054330875278411.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(758054138318278409.4353)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Festlegen'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450812207720453197.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(162268108872925636.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:354:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(758054273020278410.4353)
,p_name=>'P354_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(758054138318278409.4353)
,p_item_default=>'365'
,p_prompt=>'Seit'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual  union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual  union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual  union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual  union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00510
begin
wwv_flow_api.create_page(
 p_id=>510.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Provisioning: Service-Ende anfordern'
,p_step_title=>unistr('Beendigung von Service anfordern - Best\00E4tigen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215667724760013351)
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2052917115364783.4353)
,p_plug_name=>unistr('Service-Ende best\00E4tigen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Auf dieser Seite kann der Administrator eines Workspace die Beendigung des Services anfordern, zu dem derzeit eine Verbindung besteht.<br/><br/>',
'',
'<strong>WICHTIG</strong>: Alle Daten, Datenbankobjekte, Datenbankschemas, Tablespaces, Anwendungen, Skripte, Dateien usw. werden nach Beendigung des Services entfernt.</p>',
'',
unistr('<p>Pr\00FCfen Sie, ob Sie den Service beenden m\00F6chten.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168317330063836088.4353)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47297014014256767.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208569609956386814.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752114113873695876.4353)
,p_plug_name=>'Service-Ende anfordern'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2055131313368908.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208569609956386814.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056209627372145.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208569609956386814.4353)
,p_button_name=>'TERMINATE_SERVICE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Service beenden'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2056515355372147.4353)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(2056209627372145.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57798221433994955.4353)
,p_validation_name=>'terminate service request exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from WWV_FLOW_PROVISION_SERICE_MOD',
' where request_status = ''REQUESTED''',
'   and service_name = ''REMOVE_EXISTING_SERVICE''',
'   and SECURITY_GROUP_ID = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('F\00FCr diesen Workspace ist bereits eine Anforderung f\00FCr das Service-Ende vorhanden.')
,p_when_button_pressed=>wwv_flow_api.id(2056209627372145.4353)
,p_associated_item=>wwv_flow_api.id(.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2058222440375829.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'terminate service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_provisioning.make_modification_request(',
'    p_security_group_id    => :flow_security_group_id,',
'    p_service_name         => ''REMOVE_EXISTING_SERVICE'',',
'    p_service_attribute_2  => wwv_flow_user_api.get_email(p_username => upper(wwv_flow.g_user)));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim Weiterleiten von Anforderung f\00FCr Service-Ende.')
,p_process_when_button_id=>wwv_flow_api.id(2056209627372145.4353)
,p_process_success_message=>unistr('Die Anforderung f\00FCr das Service-Ende wurde weitergeleitet.')
,p_security_scheme=>wwv_flow_api.id(916538108136873611)
);
end;
/
prompt --application/pages/page_00577
begin
wwv_flow_api.create_page(
 p_id=>577.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Hilfe'
,p_step_title=>'Hilfe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(80887301212076531.4353)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107606024046537921.4353)
,p_plug_name=>'Suchen'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie mit diesen Steuerelementen die Abfragekriterien ein, und klicken Sie anschlie\00DFend auf <b>Los</b>.<p/>'),
'',
unistr('Viele Berichte enthalten das Steuerelement <strong>Anzeige</strong>. Legen Sie mithilfe dieser Liste die maximale Anzahl der Zeilen fest, die pro Seite angezeigt werden. Diese Einstellung gilt f\00FCr die aktuelle Session. Manche Berichte enthalten dar\00FCb')
||unistr('er hinaus das Steuerelement <b>Ansicht</b>. Legen Sie mithilfe dieser Liste fest, wie die Seite angezeigt werden soll. Verf\00FCgbare Ansichtsoptionen:<p/>'),
'<ul>',
unistr('<li><strong>Symbole</strong> (Standard): Bietet ein \00FCbersichtliches, einfaches Layout und zeigt jedes Element als gro\00DFes Symbol an.</li>'),
'<li><strong>Details</strong>: Bietet mehr Details und zeigt jedes Element als Zeile in einem Bericht an. ',
'</ul>',
'',
unistr('Sofern nicht anders angegeben, wird bei allen Abfragen die Gro\00DF-/Kleinschreibung nicht ber\00FCcksichtigt. Platzhalter sind nicht notwendig.<p/>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107843910343762607.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(107606024046537921.4353)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Schlie\00DFen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
end;
/
prompt --application/pages/page_00800
begin
wwv_flow_api.create_page(
 p_id=>800.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Data-Dictionary-Cache'
,p_step_title=>'Data-Dictionary-Cache'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(562149085230879325.4353)
,p_plug_name=>'APEX Data Dictionary - Gecachte Objekte'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       APX_COL_CACHE_DATE,',
'       OBJECT_ID,',
'       OBJECT_OWNER,',
'       OBJECT_NAME,',
'       OBJECT_PREFIX,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       OBJECT_LAST_DDL_TIME,',
'       OBJECT_PK_COLUMNS,',
'       DISPLAY_COL_1,',
'       DISPLAY_COL_2,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       PREFIX_REMOVED_TAB_NAME,',
'       SINGULAR_DISPLAY_LABEL,',
'       PLURAL_DISPLAY_LABEL,',
'       GEOMETRY_TYPE,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES,',
'       decode(HAS_PRIMARY_KEY_YN,''Y'',m.yes,''N'',m.n,HAS_PRIMARY_KEY_YN)   HAS_PRIMARY_KEY_YN,',
'       decode(HAS_LONG_COLUMNS_YN,''Y'',m.yes,''N'',m.n,HAS_LONG_COLUMNS_YN) HAS_LONG_COLUMNS_YN',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
'  where SECURITY_GROUP_ID = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(562149154323879326.4353)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y_OF_Z'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>562149154323879326
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562149235754879327.4353)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562149394679879328.4353)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'APX-Cachedatum'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562149449289879329.4353)
,p_db_column_name=>'APX_COL_CACHE_DATE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Cachedatum'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562149995631879334.4353)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Objekt-ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150022397879335.4353)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>unistr('Objekteigent\00FCmer')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150118797879336.4353)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Objektname'
,p_column_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:RP,801:P801_OBJECT_CACHE_ID:#ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150275189879337.4353)
,p_db_column_name=>'OBJECT_PREFIX'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>unistr('Objektpr\00E4fix')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150340069879338.4353)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Objekttyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150467501879339.4353)
,p_db_column_name=>'OBJECT_CREATED'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Objekt erstellt'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150569991879340.4353)
,p_db_column_name=>'OBJECT_LAST_DDL_TIME'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>'Letzte DDL-Zeit des Objekts'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150620019879341.4353)
,p_db_column_name=>'OBJECT_PK_COLUMNS'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>unistr('Prim\00E4rschl\00FCsselspalten')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(579566043165721528.4353)
,p_db_column_name=>'DISPLAY_COL_1'
,p_display_order=>160
,p_column_identifier=>'Y'
,p_column_label=>unistr('Prim\00E4re Anzeigespalte')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(579566131649721529.4353)
,p_db_column_name=>'DISPLAY_COL_2'
,p_display_order=>170
,p_column_identifier=>'Z'
,p_column_label=>unistr('Sekund\00E4re Anzeigespalte')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150773491879342.4353)
,p_db_column_name=>'TAB_LAST_ANALYZED'
,p_display_order=>180
,p_column_identifier=>'P'
,p_column_label=>'Statistik erfasst'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562150886525879343.4353)
,p_db_column_name=>'TAB_CACHE_NUM_ROWS'
,p_display_order=>190
,p_column_identifier=>'Q'
,p_column_label=>'Anzahl Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562151049130879345.4353)
,p_db_column_name=>'PREFIX_REMOVED_TAB_NAME'
,p_display_order=>200
,p_column_identifier=>'S'
,p_column_label=>unistr('Entfernten Registerkartennamen als Pr\00E4fix voranstellen')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562151141348879346.4353)
,p_db_column_name=>'SINGULAR_DISPLAY_LABEL'
,p_display_order=>210
,p_column_identifier=>'T'
,p_column_label=>unistr('Label f\00FCr Singular')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562151298567879347.4353)
,p_db_column_name=>'PLURAL_DISPLAY_LABEL'
,p_display_order=>220
,p_column_identifier=>'U'
,p_column_label=>unistr('Label f\00FCr Plural')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(564900753579013102.4353)
,p_db_column_name=>'GEOMETRY_TYPE'
,p_display_order=>230
,p_column_identifier=>'AA'
,p_column_label=>'Geometrietyp'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(564913925652056229)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562151310865879348.4353)
,p_db_column_name=>'HAS_FK_REFERENCES'
,p_display_order=>240
,p_column_identifier=>'V'
,p_column_label=>unistr('Hat Fremdschl\00FCsselreferenzen')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562151464931879349.4353)
,p_db_column_name=>'HAS_PRIMARY_KEY_YN'
,p_display_order=>250
,p_column_identifier=>'W'
,p_column_label=>unistr('Hat Prim\00E4rschl\00FCssel')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(562151538805879350.4353)
,p_db_column_name=>'HAS_LONG_COLUMNS_YN'
,p_display_order=>260
,p_column_identifier=>'X'
,p_column_label=>'Hat Long-Spalten J/N'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(563501190102271401.4353)
,p_plug_name=>'Workspace-Dictionary-Cachefilter'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>2
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(563501331978271403.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(563501190102271401.4353)
,p_button_name=>'analyze_refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Statistik erfassen und Cache aktualisieren'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(563501541561271405.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(563501190102271401.4353)
,p_button_name=>'refresh_only'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Nur Cache aktualisieren'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(563501759262271407.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.set_workspace_cache(',
'    p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'    p_gather_stats            => false,',
'    p_max_cache_stale_seconds => 2,  ',
'    p_max_tables_per_schema   => 1000);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(563501541561271405.4353)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(563501842267271408.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats_analyze'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.set_workspace_cache(',
'    p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'    p_gather_stats            => true,',
'    p_max_stats_age_seconds   => 10,',
'    p_max_cache_stale_seconds => 10,    -- seconds',
'    p_max_tables_per_schema   => 1000,   -- tables',
'    p_stats_mode              => ''estimate'',',
'    p_max_elap_exec_time_sec  => 600     -- seconds to exit exit',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(563501331978271403.4353)
);
end;
/
prompt --application/pages/page_00801
begin
wwv_flow_api.create_page(
 p_id=>801.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Tabellenspaltencache'
,p_step_title=>'Tabellenspaltencache'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5108313447012897)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(563550339948454910.4353)
,p_name=>'Tabellendetails'
,p_template=>wwv_flow_api.id(486010891028205826.4353)
,p_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       OBJECT_NAME,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       OBJECT_LAST_DDL_TIME,',
'       OBJECT_PK_COLUMNS,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
' where id = :P801_OBJECT_CACHE_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(43021310970202834.4353)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563550404021454911.4353)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563550536479454912.4353)
,p_query_column_id=>2
,p_column_alias=>'APX_CACHE_DATE'
,p_column_display_sequence=>6
,p_column_heading=>'Cachedatum'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563550925216454916.4353)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Objektname'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563551070383454917.4353)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Objekttyp'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563551193585454918.4353)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_CREATED'
,p_column_display_sequence=>4
,p_column_heading=>'Objekt erstellt'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563551279071454919.4353)
,p_query_column_id=>6
,p_column_alias=>'OBJECT_LAST_DDL_TIME'
,p_column_display_sequence=>5
,p_column_heading=>'Letzte DDL des Objekts'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563551382932454920.4353)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_PK_COLUMNS'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Prim\00E4rschl\00FCsselspalten')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563551438728454921.4353)
,p_query_column_id=>8
,p_column_alias=>'TAB_LAST_ANALYZED'
,p_column_display_sequence=>7
,p_column_heading=>'Statistik erfasst'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563551597874454922.4353)
,p_query_column_id=>9
,p_column_alias=>'TAB_CACHE_NUM_ROWS'
,p_column_display_sequence=>9
,p_column_heading=>'Zeilen'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(563551727262454924.4353)
,p_query_column_id=>10
,p_column_alias=>'HAS_FK_REFERENCES'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Hat Fremdschl\00FCsselreferenzen')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(581927513832097302.4353)
,p_plug_name=>'Tabellenabfrage'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>34
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select sys.dbms_lob.substr(DEFAULT_QUERY,32767,1) DEFAULT_QUERY',
'  from WWV_DICTIONARY_CACHE_OBJ',
' where id = :P801_OBJECT_CACHE_ID ) ',
'loop',
'',
'    sys.htp.prn(''<pre class="padding-md">'');',
'    sys.htp.prn(wwv_flow_escape.html(c1.DEFAULT_QUERY));',
'    sys.htp.prn(''</pre>'');',
'',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1125686563202318612.4353)
,p_plug_name=>'Data-Dictionary-Spaltencache'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       OBJECT_CACHE_ID,',
'       APX_CACHE_DATE,',
'       OWNER_NAME,',
'       TABLE_NAME,',
'       COLUMN_NAME,',
'       DATA_TYPE_DISPLAY,',
'       lower(data_type) DATA_TYPE,',
'       DATA_LENGTH,',
'       DATA_SCALE,',
'       DATA_PRECISION,',
'       has_char_semantics_yn,',
'       NULLABLE,',
'       DENSITY,',
'       NUM_NULLS,',
'       LAST_ANALYZED,',
'       AVG_COL_LEN,',
'       NUM_DISTINCT,',
'       COLUMN_ID,',
'       --',
'       decode(ITEM_DISPLAY_AS,',
'          ''TEXT'',m.m_text,',
'          ''NUMBER'',m.m_number,',
'          ''CHECKBOX'',m.checkbox,',
'          ''DATE_PICKER'',m.date_picker,',
'          ''TEXTAREA'',m.TEXTAREA,',
'          ITEM_DISPLAY_AS)',
'          ITEM_DISPLAY_AS,',
'       decode(FILTER_DISPLAY_AS,''CHECKBOX'',m.checkbox,',
'          ''RANGE'',m.range,',
'          ''DATE_PICKER'',m.date_picker,',
'          FILTER_DISPLAY_AS)',
'          FILTER_DISPLAY_AS,',
'       --',
'       LABEL,',
'       FORMAT_MASK,',
'       --',
'       decode(RECOMMEND_DISP_ON_RPT_YN,    ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_RPT_YN,',
'       decode(RECOMMEND_DISP_ON_FORMS_YN,  ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_FORMS_YN,',
'       decode(HAS_LEADING_IDX_YN,          ''Y'',m.yes,''N'',m.n) HAS_LEADING_IDX_YN,    ',
'       decode(IS_SINGLE_COL_PK_YN,         ''Y'',m.yes,''N'',m.n) IS_SINGLE_COL_PK_YN,',
'       --',
'       PK_POSITION,',
'       is_identity_yn,',
'       IS_FK_YN,',
'       IS_FK_INDEXED_YN,',
'       LOW_VALUE,',
'       HIGH_VALUE,',
'       LOW_NUMBER,',
'       HIGH_NUMBER,',
'       LOW_DATE,',
'       HIGH_DATE,',
'       FILTERABLE_SCORE,',
'       PCT_NULL',
'  from WWV_DICTIONARY_CACHE_COL cc,',
'        (select wwv_flow_lang.system_message(''F4000.NO'')    n,',
'                wwv_flow_lang.system_message(''F4000.YES'')   yes,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_CHECKBOX'')    checkbox,',
'                wwv_flow_lang.system_message(''APEX.IG.RANGE'')                range,',
'                wwv_flow_lang.system_message(''ITEM_NAME.TEXT'')               m_text,',
'                wwv_flow_lang.system_message(''WS_NUMBER'')                    m_number,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DATE_PICKER'') date_picker,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_RADIOGROUP'')  RADIOGROUP,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_TEXTAREA'')    TEXTAREA',
'         from dual) m',
'  where OBJECT_CACHE_ID = :P801_OBJECT_CACHE_ID',
'  and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1125686632295318613.4353)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1125686632295318613
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563538059581439289.4353)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563538486455439290.4353)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Cachedatum'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563501928066271409.4353)
,p_db_column_name=>'OBJECT_CACHE_ID'
,p_display_order=>30
,p_column_identifier=>'Y'
,p_column_label=>'Objektcache-ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502020761271410.4353)
,p_db_column_name=>'OWNER_NAME'
,p_display_order=>40
,p_column_identifier=>'Z'
,p_column_label=>unistr('Eigent\00FCmername')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502124363271411.4353)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>50
,p_column_identifier=>'AA'
,p_column_label=>'Tabellenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502272165271412.4353)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>60
,p_column_identifier=>'AB'
,p_column_label=>'Spaltenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502370236271413.4353)
,p_db_column_name=>'DATA_TYPE_DISPLAY'
,p_display_order=>70
,p_column_identifier=>'AC'
,p_column_label=>'Elementanzeige'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502488541271414.4353)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>80
,p_column_identifier=>'AD'
,p_column_label=>'Datentyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502584445271415.4353)
,p_db_column_name=>'DATA_LENGTH'
,p_display_order=>90
,p_column_identifier=>'AE'
,p_column_label=>unistr('Datenl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502698655271416.4353)
,p_db_column_name=>'DATA_SCALE'
,p_display_order=>100
,p_column_identifier=>'AF'
,p_column_label=>'Nachkommastellen der Daten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502778121271417.4353)
,p_db_column_name=>'DATA_PRECISION'
,p_display_order=>110
,p_column_identifier=>'AG'
,p_column_label=>'Gesamtstellenzahl bei Daten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(606264190961993801.4353)
,p_db_column_name=>'HAS_CHAR_SEMANTICS_YN'
,p_display_order=>120
,p_column_identifier=>'BO'
,p_column_label=>'Zeichensemantik wird verwendet'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502846649271418.4353)
,p_db_column_name=>'NULLABLE'
,p_display_order=>130
,p_column_identifier=>'AH'
,p_column_label=>'Auf Null setzbar'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563502977339271419.4353)
,p_db_column_name=>'DENSITY'
,p_display_order=>140
,p_column_identifier=>'AI'
,p_column_label=>'Dichte'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503037550271420.4353)
,p_db_column_name=>'NUM_NULLS'
,p_display_order=>150
,p_column_identifier=>'AJ'
,p_column_label=>'Anzahl Nullwerte'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503199017271421.4353)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>160
,p_column_identifier=>'AK'
,p_column_label=>'Statistik erfasst'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503270403271422.4353)
,p_db_column_name=>'AVG_COL_LEN'
,p_display_order=>170
,p_column_identifier=>'AL'
,p_column_label=>unistr('Durchschnittliche Datenl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503389059271423.4353)
,p_db_column_name=>'NUM_DISTINCT'
,p_display_order=>180
,p_column_identifier=>'AM'
,p_column_label=>'Eindeutig'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503428867271424.4353)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>190
,p_column_identifier=>'AN'
,p_column_label=>'Spalten-ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503576029271425.4353)
,p_db_column_name=>'ITEM_DISPLAY_AS'
,p_display_order=>200
,p_column_identifier=>'AO'
,p_column_label=>'Elementanzeige'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503665016271426.4353)
,p_db_column_name=>'FILTER_DISPLAY_AS'
,p_display_order=>210
,p_column_identifier=>'AP'
,p_column_label=>'Facet-Anzeige'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503706778271427.4353)
,p_db_column_name=>'LABEL'
,p_display_order=>220
,p_column_identifier=>'AQ'
,p_column_label=>'Label'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503829018271428.4353)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>230
,p_column_identifier=>'AR'
,p_column_label=>'Formatmaske'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563503938940271429.4353)
,p_db_column_name=>'RECOMMEND_DISP_ON_RPT_YN'
,p_display_order=>240
,p_column_identifier=>'AS'
,p_column_label=>'Anz. in Ber. empfehlen J/N'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563504041407271430.4353)
,p_db_column_name=>'RECOMMEND_DISP_ON_FORMS_YN'
,p_display_order=>250
,p_column_identifier=>'AT'
,p_column_label=>'Anz. in Formularen empfehlen J/N'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563504123489271431.4353)
,p_db_column_name=>'HAS_LEADING_IDX_YN'
,p_display_order=>260
,p_column_identifier=>'AU'
,p_column_label=>unistr('Hat f\00FChrenden Index J/N')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563504211806271432.4353)
,p_db_column_name=>'IS_SINGLE_COL_PK_YN'
,p_display_order=>270
,p_column_identifier=>'AV'
,p_column_label=>unistr('Einzelspalten-Prim\00E4rschl\00FCssel')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563504605701271436.4353)
,p_db_column_name=>'PK_POSITION'
,p_display_order=>280
,p_column_identifier=>'AZ'
,p_column_label=>unistr('Prim\00E4rschl\00FCsselposition')
,p_column_type=>'NUMBER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(606264262564993802.4353)
,p_db_column_name=>'IS_IDENTITY_YN'
,p_display_order=>290
,p_column_identifier=>'BP'
,p_column_label=>'ID-Spalte'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563504716242271437.4353)
,p_db_column_name=>'IS_FK_YN'
,p_display_order=>300
,p_column_identifier=>'BA'
,p_column_label=>unistr('Fremdschl\00FCssel')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563504893078271438.4353)
,p_db_column_name=>'IS_FK_INDEXED_YN'
,p_display_order=>310
,p_column_identifier=>'BB'
,p_column_label=>unistr('Fremdschl\00FCssel indexiert')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563505263626271442.4353)
,p_db_column_name=>'LOW_VALUE'
,p_display_order=>320
,p_column_identifier=>'BF'
,p_column_label=>'Niedriger Wert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563505307307271443.4353)
,p_db_column_name=>'HIGH_VALUE'
,p_display_order=>330
,p_column_identifier=>'BG'
,p_column_label=>'Hoher Wert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563505431326271444.4353)
,p_db_column_name=>'LOW_NUMBER'
,p_display_order=>340
,p_column_identifier=>'BH'
,p_column_label=>'Niedrige Zahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563505571837271445.4353)
,p_db_column_name=>'HIGH_NUMBER'
,p_display_order=>350
,p_column_identifier=>'BI'
,p_column_label=>'Hohe Zahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563505667750271446.4353)
,p_db_column_name=>'LOW_DATE'
,p_display_order=>360
,p_column_identifier=>'BJ'
,p_column_label=>'Niedriges Datum'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563505789428271447.4353)
,p_db_column_name=>'HIGH_DATE'
,p_display_order=>370
,p_column_identifier=>'BK'
,p_column_label=>'Hohes Datum'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563505823249271448.4353)
,p_db_column_name=>'FILTERABLE_SCORE'
,p_display_order=>380
,p_column_identifier=>'BL'
,p_column_label=>'Facet-Suchscore'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(563506094284271450.4353)
,p_db_column_name=>'PCT_NULL'
,p_display_order=>390
,p_column_identifier=>'BN'
,p_column_label=>'Prozent Null'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1127038668073710688.4353)
,p_plug_name=>'Workspace-Dictionary-Cachefilter'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>2
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(563546320122439299.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1127038668073710688.4353)
,p_button_name=>'analyze_refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Statistik erfassen und Cache aktualisieren'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(563546787400439301.4353)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1127038668073710688.4353)
,p_button_name=>'refresh_only'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Nur Cache aktualisieren'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563550051497454907.4353)
,p_name=>'P801_OBJECT_CACHE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1127038668073710688.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563550130372454908.4353)
,p_name=>'P801_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1127038668073710688.4353)
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_owner',
'from wwv_dictionary_cache_obj',
'where id = :P801_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563550297380454909.4353)
,p_name=>'P801_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1127038668073710688.4353)
,p_prompt=>'Tabellenname'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select OBJECT_NAME',
'from wwv_dictionary_cache_obj',
'where id = :P801_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(489153051785943514.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(563547427786439302.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :WORKSPACE_ID,',
'                                 p_object_id                => :P801_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => false );',
'                                 ',
'    :P801_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(563546787400439301.4353)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(563547818193439303.4353)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats_analyze'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :WORKSPACE_ID,',
'                                 p_object_id                => :P801_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => true );',
'                                 ',
'    :P801_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(563546320122439299.4353)
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_api.create_page(
 p_id=>1000.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Datenbankobjekte erstellen - Schema und Objekte'
,p_step_title=>'Websheet-Datenbankobjekte erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/aadm_mg_ser_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25617731813142209.4353)
,p_plug_name=>'Websheet-Datenbankobjekte erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'wwv_flow_ws_setup.display_setup_info(p_session_id=>:app_session);'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(629202612753058435.4353)
,p_plug_name=>'Multiple Schemas'
,p_parent_plug_id=>wwv_flow_api.id(25617731813142209.4353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(30347228019736370.4353)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_setup.display_setup_multi_schemas(',
'  p_schema=>:P1000_WS_SCHEMA,',
'  p_session_id=>:app_session);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'IF wwv_flow_ws_setup.one_workspace_schema_exists THEN',
'  RETURN FALSE;',
'ELSE',
'  RETURN TRUE;',
'END IF;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(629216429600129448.4353)
,p_plug_name=>'Select Schema'
,p_parent_plug_id=>wwv_flow_api.id(25617731813142209.4353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(30347228019736370.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'IF wwv_flow_ws_setup.one_workspace_schema_exists THEN',
'  RETURN FALSE;',
'ELSE',
'  RETURN TRUE;',
'END IF;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33675711755970184.4353)
,p_plug_name=>'create progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(33675020974963348.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208570508702395920.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752114256066695876.4353)
,p_plug_name=>'Websheet-Datenbankobjekte erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25618420348186194.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208570508702395920.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25619002817190600.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208570508702395920.4353)
,p_button_name=>'CONTINUE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25667724709452330.4353)
,p_branch_action=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.:1020::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(25619002817190600.4353)
,p_branch_sequence=>10
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_setup.one_workspace_schema_exists then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6146932536169821.4353)
,p_name=>'P1000_REQUIRED_SPACE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(629216429600129448.4353)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(629186017096823134.4353)
,p_name=>'P1000_WS_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(629216429600129448.4353)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Schema ausw\00E4hlen -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(489153170799943531.4353)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('W\00E4hlen Sie das Schema f\00FCr die Websheet-Objekte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(629246819266930726.4353)
,p_computation_sequence=>10
,p_computation_item=>'P1000_WS_SCHEMA'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema',
'from wwv_flow_company_schemas',
'where security_group_id = :flow_security_group_id',
'and rownum = 1'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1000_WS_SCHEMA is null then',
'    if wwv_flow_ws_setup.one_workspace_schema_exists THEN',
'      return true;',
'    else',
'      return false;',
'    end if;',
'end if;'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(630945407555874104.4353)
,p_validation_name=>'P1000_WS_SCHEMA not null if multi schema'
,p_validation_sequence=>10
,p_validation=>'P1000_WS_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_setup.one_workspace_schema_exists then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(25619002817190600.4353)
,p_associated_item=>wwv_flow_api.id(629186017096823134.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2229608132252939.4353)
,p_validation_name=>'P1000_WS_SCHEMA can build in its default tablespace'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from dual ',
' where exists (select 1 ',
'                 from sys.dba_ts_quotas a, sys.dba_users b',
'                where a.tablespace_name = b.default_tablespace',
'                  and a.username = :P1000_WS_SCHEMA',
'                  and a.username = b.username) ',
'union ',
'select 1 ',
'  from dual ',
'  where exists (select 1 ',
'                  from sys.dba_sys_privs ',
'                 where grantee = :P1000_WS_SCHEMA ',
'                   and privilege = ''UNLIMITED TABLESPACE'')'))
,p_validation_type=>'EXISTS'
,p_error_message=>'&P1000_WS_SCHEMA. kann nicht im Default Tablespace erstellt werden (keine Quota).'
,p_associated_item=>wwv_flow_api.id(629186017096823134.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2230112297329775.4353)
,p_validation_name=>'P1000_WS_SCHEMA can create tables'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_sys_privs ',
' where grantee = :P1000_WS_SCHEMA',
'   and privilege = ''CREATE TABLE'''))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('&P1000_WS_SCHEMA. hat keine Berechtigung f\00FCr das Erstellen von Tabellen.')
,p_associated_item=>wwv_flow_api.id(629186017096823134.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2232203611450322.4353)
,p_validation_name=>'P1000_WS_SCHEMA can create triggers'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_sys_privs ',
' where grantee = :P1000_WS_SCHEMA',
'   and privilege = ''CREATE TRIGGER'''))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('&P1000_WS_SCHEMA. hat keine Berechtigung f\00FCr das Erstellen von Triggern.')
,p_associated_item=>wwv_flow_api.id(629186017096823134.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6146227725121086.4353)
,p_validation_name=>'P1000_WS_SCHEMA has enough space'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_setup.enough_space_available(',
'    p_schema           => :P1000_WS_SCHEMA,',
'    p_additional_space => :P1000_REQUIRED_SPACE);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Im ausgew\00E4hlten Schema ist nicht ausreichend Platz zur Installation von Websheet-Datenbankobjekten vorhanden. Es sind zus\00E4tzliche &P1000_REQUIRED_SPACE. MB erforderlich, um Websheet-Datenbankobjekte zu erstellen. Wenden Sie sich wegen zus\00E4tzlichem Sp')
||'eicherplatz an den Administrator.'
,p_when_button_pressed=>wwv_flow_api.id(25619002817190600.4353)
,p_associated_item=>wwv_flow_api.id(629186017096823134.4353)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(629205807820075942.4353)
,p_name=>'Show Sub Region'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1000_WS_SCHEMA'
,p_condition_element=>'P1000_WS_SCHEMA'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(629206112703075942.4353)
,p_event_id=>wwv_flow_api.id(629205807820075942.4353)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(629202612753058435.4353)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(629206305512075942.4353)
,p_event_id=>wwv_flow_api.id(629205807820075942.4353)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(629202612753058435.4353)
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01020
begin
wwv_flow_api.create_page(
 p_id=>1020.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>unistr('Websheet-Datenbankobjekte erstellen - Best\00E4tigen')
,p_step_title=>'Websheet-Datenbankobjekte erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/aadm_mg_ser_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25637617549308429.4353)
,p_plug_name=>'Websheet-Datenbankobjekte erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'wwv_flow_ws_setup.display_setup_confirm(p_schema=>:P1000_WS_SCHEMA);'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33676524353983301.4353)
,p_plug_name=>'create progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720186138525572350.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(33675020974963348.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(720190141563578035.4353)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208572721992409299.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752114367257695877.4353)
,p_plug_name=>'Websheet-Datenbankobjekte erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25638528977311635.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208572721992409299.4353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(388538190684476853.4353)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25645219290384531.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208572721992409299.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25638706944314757.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208572721992409299.4353)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25639021836319126.4353)
,p_branch_action=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(25638706944314757.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25668125186461991.4353)
,p_branch_action=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(25638528977311635.4353)
,p_branch_sequence=>20
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_setup.one_workspace_schema_exists then',
'  return true;',
'else',
'  return false;',
'end if;'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25921821246168250.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create websheet objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_security.g_parse_as_schema_override := :P1000_WS_SCHEMA;',
'wwv_flow_ws_setup.install (',
'    p_schema   => :P1000_WS_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Websheet-Datenbankobjekte erstellt.'
);
end;
/
prompt --application/pages/page_01030
begin
wwv_flow_api.create_page(
 p_id=>1030.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Objekt erstellen - Erfolg'
,p_step_title=>'Websheet-Objekt erstellen - Erfolg'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227919626131164940.4353)
,p_plug_name=>'Websheet-Objekt erstellen - Erfolg'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>20
,p_plug_source=>'sys.htp.p( wwv_flow_lang.system_message(''CREATE_WS_OBJ_SUCCESS_MSG'') );'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227919809624164941.4353)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227920211842164941.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(227919809624164941.4353)
,p_button_name=>'VALIDATE_WS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Websheet-Objekte verwalten'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_02000
begin
wwv_flow_api.create_page(
 p_id=>2000.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Datenbankobjekte'
,p_step_title=>'Websheet-Datenbankobjekte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692763410753114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/aadm_mg_ser_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26634925171720748.4353)
,p_plug_name=>'Websheet-Datenbankobjekte'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--noBadge:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>11
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_api.id(26634012226707545.4353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692750374873071023.4353)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484343205668459370.4353)
,p_plug_name=>'Websheet-Datenbankobjekte'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Alle Websheet-Anwendungsdaten werden in Tabellen gespeichert, deren Eigent\00FCmer ein mit diesem Workspace '),
unistr('verkn\00FCpftes Schema ist. Die Tabellen haben alle das Pr\00E4fix <code>APEX$_</code>. Auf dieser Seite k\00F6nnen Sie diese Tabellen verwalten.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(170036404105777627.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'2000'
);
end;
/
prompt --application/pages/page_02010
begin
wwv_flow_api.create_page(
 p_id=>2010.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Datenbankobjekte entfernen'
,p_step_title=>'Websheet-Datenbankobjekte entfernen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/aadm_mg_ser_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26636330758750727.4353)
,p_plug_name=>'Websheet-Datenbankobjekte entfernen'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>14
,p_plug_new_grid_row=>false
,p_plug_source=>'wwv_flow_ws_setup.display_remove_confirm;'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388072419141289608.4353)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26636901070798877.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(388072419141289608.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26637107996800908.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(388072419141289608.4353)
,p_button_name=>'REMOVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Entfernen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(26637412498802212.4353)
,p_branch_action=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(26637107996800908.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(26637626097862899.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove websheet database objects'
,p_process_sql_clob=>'wwv_flow_ws_setup.remove;'
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Websheet-Datenbankobjekte entfernt.'
);
end;
/
prompt --application/pages/page_02020
begin
wwv_flow_api.create_page(
 p_id=>2020.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Datenbankobjekte validieren'
,p_step_title=>'Websheet-Datenbankobjekte validieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/aadm_mg_ser_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169512402279989072.4353)
,p_plug_name=>'Websheet-Datenbankobjekte validieren'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829445215771671657.4353)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 object_name,',
'c002 object_type,',
'c003 obj_exists,',
'c004 column_status,',
'c005 index_status,',
'c006 constraint_status,',
'c007 trigger_status',
'from wwv_flow_collections',
'where collection_name = ''APEX$_OBJECT_STATUS''',
'order by seq_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(169512526721989072.4353)
,p_name=>'Validate APEX$ Tables'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(628811278157004753.4353)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>10
,p_column_identifier=>'G'
,p_column_label=>'Objektname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(628811333329004756.4353)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'H'
,p_column_label=>'Objekttyp'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(628812792905024497)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(628811469278004756.4353)
,p_db_column_name=>'OBJ_EXISTS'
,p_display_order=>30
,p_column_identifier=>'I'
,p_column_label=>'Ist vorhanden'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169512912814989079.4353)
,p_db_column_name=>'COLUMN_STATUS'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Spalten'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(628838348305108438)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169513020058989079.4353)
,p_db_column_name=>'INDEX_STATUS'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Indizes'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(628838348305108438)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169513117202989079.4353)
,p_db_column_name=>'CONSTRAINT_STATUS'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Constraints'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(628838348305108438)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169513210224989080.4353)
,p_db_column_name=>'TRIGGER_STATUS'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Trigger'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(628838348305108438)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(452521314185274683.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(169512402279989072.4353)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(170035429601775500.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(169512402279989072.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169390223509266042.4353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(169512402279989072.4353)
,p_button_name=>'CORRECT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486004758462193187.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ung\00FCltige Objekte korrigieren')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2030:&SESSION.::&DEBUG.:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_ws_setup.all_object_valid (',
'    p_get_object_status  => ''N''',
'    );'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
,p_security_scheme=>wwv_flow_api.id(771323113864288687)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169521020137104340.4353)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get object status'
,p_process_sql_clob=>'wwv_flow_ws_setup.get_object_status;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Websheet-Datenbankobjektstatus kann nicht abgerufen werden.'
);
end;
/
prompt --application/pages/page_02030
begin
wwv_flow_api.create_page(
 p_id=>2030.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Datenbankobjekte validieren'
,p_step_title=>'Websheet-Datenbankobjekte validieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'AEADM/aadm_mg_ser_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169859719952750949.4353)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="max-height: 300px; overflow: auto;"'
,p_plug_template=>wwv_flow_api.id(486014333429205839.4353)
,p_plug_display_sequence=>20
,p_plug_source=>'wwv_flow_ws_setup.display_invalid_obj_ddl;'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169872526400093369.4353)
,p_plug_name=>'Recreate Invalid Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(720158679964358138.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'wwv_flow_ws_setup.display_recreate_confirm;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(247990918586955889.4353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752114556704695877.4353)
,p_plug_name=>'Websheet-Datenbankobjekte validieren'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720159283194358177.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(170032332455757410.4353)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(247990918586955889.4353)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169627129849725626.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(247990918586955889.4353)
,p_button_name=>'CORRECT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Richtig'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169627410187725632.4353)
,p_branch_action=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(169627129849725626.4353)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(168299714201911003.4353)
,p_name=>'P2030_WS_SCHEMA'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Ws Schema'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(107534131274292840.4353)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169860509001757233.4353)
,p_name=>'P2030_DDL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(169859719952750949.4353)
,p_prompt=>'DDL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>20
,p_tag_attributes=>'readonly="readonly"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(7301320786376802.4353)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168300210869919432.4353)
,p_computation_sequence=>10
,p_computation_item=>'P2030_WS_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_setup.get_apex$_schema;'
,p_computation_error_message=>'APEX$-Schema kann nicht abgerufen werden'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169994219811365870.4353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'recreate invalid objects'
,p_process_sql_clob=>'wwv_flow_ws_setup.recreate_invalid_objects;'
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>unistr('Ung\00FCltige Objekte korrigiert.')
);
end;
/
prompt --application/pages/page_02040
begin
wwv_flow_api.create_page(
 p_id=>2040.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Websheet-Objekte korrigieren - Erfolgreich'
,p_step_title=>'Websheet-Objekte korrigieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(718401914085176458.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(771323113864288687)
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227878422384893335.4353)
,p_plug_name=>'Websheet-Objekte korrigieren'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(797568474776479154.4353)
,p_plug_display_sequence=>20
,p_plug_source=>'sys.htp.p( wwv_flow_lang.system_message(''INVALID_WS_OBJ_SUCCESS_MSG'') );'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227878914025900029.4353)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(720165508600362771.4353)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227885020483968091.4353)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(227878914025900029.4353)
,p_button_name=>'VALIDATE_WS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(486003960305193183.4353)
,p_button_image_alt=>'Websheet-Objekte verwalten'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_api.create_page(
 p_id=>8000.4353
,p_user_interface_id=>wwv_flow_api.id(4969311180302342.4353)
,p_name=>'Benutzer suchen'
,p_step_title=>'Benutzer suchen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215450104703534414)
,p_step_template=>wwv_flow_api.id(692762974728114205.4353)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30339228864719822.4353)
,p_plug_name=>'Accounts'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(486010891028205826.4353)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'case ',
'     -- unlocked, expired',
'     when (nvl(u.account_locked,''N'') = ''N'' and ',
'            ((wwv_flow_fnd_user_api.workspace_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)) <= 0) or',
'            (nvl(wwv_flow_fnd_user_api.end_user_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)),1) <= 0))) ',
'     then ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'          decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'          decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))',
'          ||''_exp.gif''',
'     -- locked, expired',
'     when (nvl(u.account_locked,''N'') = ''Y'' and ',
'            ((wwv_flow_fnd_user_api.workspace_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)) <= 0) or',
'            (nvl(wwv_flow_fnd_user_api.end_user_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)),1) <= 0))) ',
'     then ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'          decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'          decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))',
'          ||''_locked_exp.gif''',
'     -- locked, unexpired',
'     when (nvl(u.account_locked,''N'') = ''Y'' and ',
'            (wwv_flow_fnd_user_api.workspace_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)) > 0) and',
'            (nvl(wwv_flow_fnd_user_api.end_user_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)),1) > 0)) ',
'     then ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'          decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'          decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))',
'          ||''_locked.gif''',
'else',
'    -- unlocked and unexpired',
'    ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'    decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'    decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))||''.gif''',
'end icon_view_icon,',
'u.email_address alt,',
'''f?p=4350:56:''||:flow_session||',
'   ''::NO:EDIT_USER_PRIVS:F4350_P56_USER_ID,LAST_VIEW:''||USER_ID||'',55:'' link,',
'replace(replace(replace(u.user_name,''_'','' ''),''.'',''. ''),''@'',''@ '') icon_view_name,',
'-- ',
'      USER_ID,',
'      u.user_name "USER",',
'      u.email_address "eMail",',
'      u.first_name,',
'      u.last_name,',
'      replace(u.default_schema,''%''||''null%'',null) df,',
'      decode(nvl(d.is_developer,''N''),''Y'', (select case',
'              when (wwv_flow_fnd_user_api.workspace_account_days_left(',
'                    wwv_flow_user_api.get_username(user_id)) > 0) ',
'              then m.password_valid',
'	      else m.password_expired',
'              end expiration from dual),',
'             m.no_developer_priv) developer,',
'      decode (nvl(d.is_developer,''N''),''Y'',last_login,null) last_login,',
'      decode (nvl(d.is_developer,''N''),''Y'',last_login,null) last_login2,',
'      decode (nvl(d.is_developer,''N''),''Y'',',
'          nvl(builder_login_count,0),null) builder_login_count,',
'      decode(nvl(u.account_locked,''N''),''Y'',m.yes,m.n)ul,',
'     case ',
'     when (wwv_flow_fnd_user_api.end_user_account_days_left(',
'           wwv_flow_user_api.get_username(user_id)) > 0) ',
'     then m.password_valid',
'     else m.password_expired',
'    end expiration,',
'u.DESCRIPTION,',
'u.PASSWORD_LIFESPAN_DAYS,',
'u.PASSWORD_LIFESPAN_ACCESSES,',
'u.PASSWORD_ACCESSES_LEFT,',
'u.LAST_AGENT,',
'u.LAST_IP,',
'u.ACCOUNT_EXPIRY,',
'u.FAILED_ACCESS_ATTEMPTS,',
'u.CHANGE_PASSWORD_ON_FIRST_USE,',
'u.FIRST_PASSWORD_USE_OCCURRED,  ',
'decode(nvl(d.is_admin,''N''),''Y'',',
'  m.admin,decode(nvl(d.is_developer,''N''),',
'  ''Y'',m.dev,m.end_user)) dev_type,',
'(select group_id from WWV_FLOW_FND_GROUP_USERS where user_id = u.user_id) group_id,',
'(select GROUP_NAME from WWV_FLOW_FND_USER_GROUPS where id = (select group_id from WWV_FLOW_FND_GROUP_USERS where user_id = u.user_id)) group_name,',
'LAST_UPDATE_DATE,',
'LAST_UPDATED_BY,',
'CREATION_DATE,',
'CREATED_BY,',
'nvl(d.developer_type,''END_USER'') developer_type',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d,',
'    (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes,',
'            wwv_flow_lang.system_message(''PASSWORD_VALID'') password_valid,',
'            wwv_flow_lang.system_message(''PASSWORD_EXPIRED'') password_expired,',
'            wwv_flow_lang.system_message(''NO_DEVELOPER_PRIV'') no_developer_priv,',
'            wwv_flow_lang.system_message(''DEVELOPER'') dev,',
'            wwv_flow_lang.system_message(''ADMINISTRATOR'') admin,',
'            wwv_flow_lang.system_message(''END_USER'') end_user,',
'            wwv_flow_lang.system_message(''BASIC_DEVELOPER'') basic_developer',
'     from dual) m',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30339431409719823.4353)
,p_name=>'Internal Accounts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'LINK'
,p_icon_view_img_src_column=>'ICON_VIEW_ICON'
,p_icon_view_label_column=>'ICON_VIEW_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340720658719851.4353)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>'Bearbeiten'
,p_column_link=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.::F4350_P56_USER_ID,LAST_VIEW:#USER_ID#,55'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="">'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340807591719851.4353)
,p_db_column_name=>'USER'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'Benutzer'
,p_column_link=>'f?p=4350:57:&SESSION.::NO::P57_USERID,LAST_VIEW:#USER_ID#,60'
,p_column_linktext=>'#USER#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340932657719851.4353)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'E-Mail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341007259719852.4353)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'H'
,p_column_label=>'Vorname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341115903719852.4353)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Nachname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341216671719852.4353)
,p_db_column_name=>'DF'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Standardschema'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341624479719853.4353)
,p_db_column_name=>'UL'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>'Gesperrt'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341829960719853.4353)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Accounttyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341312303719852.4353)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Kennwortstatus'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341701840719853.4353)
,p_db_column_name=>'EXPIRATION'
,p_display_order=>10
,p_column_identifier=>'O'
,p_column_label=>'Endbenutzer-Account'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341408222719852.4353)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>unistr('Datum f\00FCr letzte Anmeldung beim Builder')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341508580719852.4353)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Anzahl Anmeldungen beim Builder'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30339525401719843.4353)
,p_db_column_name=>'ICON_VIEW_ICON'
,p_display_order=>13
,p_column_identifier=>'A'
,p_column_label=>'Symbol'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340415388719850.4353)
,p_db_column_name=>'ALT'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340501058719850.4353)
,p_db_column_name=>'LINK'
,p_display_order=>15
,p_column_identifier=>'C'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340605855719850.4353)
,p_db_column_name=>'ICON_VIEW_NAME'
,p_display_order=>16
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30341917359719853.4353)
,p_db_column_name=>'LAST_LOGIN2'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Letzte Anmeldung beim Builder'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342016012719853.4353)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342114024719853.4353)
,p_db_column_name=>'PASSWORD_LIFESPAN_DAYS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Kennwortg\00FCltigkeitsdauer in Tagen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342220166719854.4353)
,p_db_column_name=>'PASSWORD_LIFESPAN_ACCESSES'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Kennwortg\00FCltigkeitsdauer Zugriffe')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342300491719854.4353)
,p_db_column_name=>'PASSWORD_ACCESSES_LEFT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Verbleibende Kennwortzugriffe'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342415979719854.4353)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Letzter Agent'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342519574719854.4353)
,p_db_column_name=>'LAST_IP'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Letzte IP-Adresse'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342607632719854.4353)
,p_db_column_name=>'ACCOUNT_EXPIRY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Accountablauf'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342708175719854.4353)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Nicht erfolgreiche Zugriffversuche'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30342831491719855.4353)
,p_db_column_name=>'CHANGE_PASSWORD_ON_FIRST_USE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>unistr('Kennwort bei erster Verwendung \00E4ndern')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30339605976719848.4353)
,p_db_column_name=>'FIRST_PASSWORD_USE_OCCURRED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Erste Verwendung des Kennworts aufgetreten'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30339725059719848.4353)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Gruppen-ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30339818967719849.4353)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Gruppenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30339918103719849.4353)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340030221719849.4353)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340122309719849.4353)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340227868719849.4353)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30340317761719850.4353)
,p_db_column_name=>'DEVELOPER_TYPE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Entwicklertyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30345026463719899.4353)
,p_branch_action=>'8000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30344406934719892.4353)
,p_computation_sequence=>1
,p_computation_item=>'F4350_P4802_USER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30344615543719895.4353)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'55'
,p_compute_when=>'CREATE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
