prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4414
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4414 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4414
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110305373447363813')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'de'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4414)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112713'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4414)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4414)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Abmelden'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>'Von Application Express abmelden'
,p_list_text_09=>'Y'
,p_list_text_10=>'abmelden beenden verlassen :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4414)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Anwendung anhand einer Kalkulationstabelle erstellen'
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>'Excel- oder CSV-Dateien importieren und eine Anwendung erstellen'
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('Excel CSV XSL XSLX Kalkulationstabellendaten einf\00FCgen laden importieren')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4414)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Oracle APEX Home'
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>'Homepage Start '
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4414)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Font APEX-Symbole durchsuchen'
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('Durchsuchen Sie Font APEX-Symbole, f\00FCgen Sie Modifikatoren hinzu, und kopieren Sie ben\00F6tigte CSS- oder HTML-Elemente.')
,p_list_text_09=>'Y'
,p_list_text_10=>'Symbole, Font APEX-Library, Grafiken'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4414)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4414)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Anwendung exportieren'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>'Anwendung {APP_ID} als SQL-Datei exportieren'
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4414)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Nicht verwendete Listen'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4414)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4414)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4414)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4414)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4414)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4414)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4414)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4414)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4414)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4414)
,p_theme_id=>1
,p_name=>'One Level Tabs.de'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4414)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4414)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4414)
,p_theme_id=>1
,p_name=>'Printer Friendly.de'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4414)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4414)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4414)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4414)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4414)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4414)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4414)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4414)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4414)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4414)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4414)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4414)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4414)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4414)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4414)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4414)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>'Suchdialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>'Suche'
,p_close_button_text=>unistr('Schlie\00DFen')
,p_next_button_text=>'Weiter >'
,p_prev_button_text=>unistr('< Zur\00FCck')
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4414)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4414)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4414)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164003187302818)
,p_name=>'2DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'2D-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166181608302819)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'de'
,p_message_text=>'2D-Spaltenzeile'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164199027302818)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'de'
,p_message_text=>'2D-Ring'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165928365302819)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'de'
,p_message_text=>'Gestapelte horizontale 2D-Spalte (Prozent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164295719302818)
,p_name=>'2DLINE'
,p_message_language=>'de'
,p_message_text=>'2D-Linie'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164360273302818)
,p_name=>'2DPIE'
,p_message_language=>'de'
,p_message_text=>'2D-Kreis'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165798664302819)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'de'
,p_message_text=>'Gestapelte 2D-Spalte (Prozent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164409432302818)
,p_name=>'3DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'3D-Spalte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166019366302819)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'de'
,p_message_text=>'Gestapelte horizontale 3D-Spalte (Prozent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164521627302818)
,p_name=>'3DPIE'
,p_message_language=>'de'
,p_message_text=>'3D-Kreis'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165891805302819)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'de'
,p_message_text=>'Gestapelte 3D-Spalte (Prozent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933931238303445)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'de'
,p_message_text=>unistr('0 Elemente zum Einf\00FCgen in das Attribut-Dictionary')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933798968303445)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'de'
,p_message_text=>unistr('0 Elemente f\00FCr die Aktualisierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934185774303445)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'de'
,p_message_text=>'0 Elemente zur Aktualisierung des Attribut-Dictionarys'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934573544303445)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'de'
,p_message_text=>unistr('0 Berichtsspalten zum Einf\00FCgen in das Attribut-Dictionary')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934712947303446)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'de'
,p_message_text=>'0 Berichtsspalten zum Aktualisieren des Attribut-Dictionarys'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933699340303445)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Elemente f\00FCr die Aktualisierung pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934334063303445)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'de'
,p_message_text=>'0 Berichtsspalten zur Aktualisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933897413303445)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Elemente f\00FCr die Einbindung in das Attribut-Dictionary pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934019797303445)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'de'
,p_message_text=>unistr('%0-Elemente f\00FCr die Aktualisierung des Attribut-Dictionarys pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934494285303445)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Berichtsspalten zum Einf\00FCgen in das Attribut-Dictionary pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934248831303445)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Berichtsspalten zur Aktualisierung pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934613237303446)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Berichtsspalten zum Aktualisieren des Attribut-Dictionarys pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726360200303277)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'de'
,p_message_text=>'Der Wert muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711543888303264)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'de'
,p_message_text=>unistr('<span class="fielddata"> Neuanordnung nicht m\00F6glich, weil die Regionssequenzen nicht eindeutig sind.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711655322303264)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'de'
,p_message_text=>unistr('<span class="fielddata">Neuanordnung nicht m\00F6glich, weil die Schaltfl\00E4chensequenzen nicht eindeutig sind.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711707782303264)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'de'
,p_message_text=>unistr('<span class="fielddata">Neuanordnung nicht m\00F6glich, weil die Navigationsleistensequenzen nicht eindeutig sind.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711846803303264)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'de'
,p_message_text=>unistr('<span class="fielddata">Neuanordnung nicht m\00F6glich, weil die Regionselementsequenzen nicht eindeutig sind.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780722633303321)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295424214302923)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung bearbeiten: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685079163303240)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Das angegebene Datumsformat ist ung\00FCltig. F\00FCr den Kalender muss ein Datum im Format YYYYMMDD angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731037355303281)
,p_name=>'4000_TREE'
,p_message_language=>'de'
,p_message_text=>'Baum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780845071303321)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'de'
,p_message_text=>'Workspace-ID'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575461981303149)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen des neuen Schemas an, das erstellt werden soll. W\00E4hlen Sie ein Kennwort f\00FCr das Schema und anschlie\00DFend den Default Tablespace sowie den Temporary Tablespace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575503420303149)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen des vorhandenen Schemas ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575608785303149)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie zum Abschluss auf <strong>Weiter</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445769518303045)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'de'
,p_message_text=>unistr('Tablespaces und zugeh\00F6rige Datendateien l\00F6schen: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445661560303045)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Datenbankbenutzer l\00F6schen: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309532136303759)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'de'
,p_message_text=>unistr('Webservice-Aktivit\00E4tslogeintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157636543302812)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'de'
,p_message_text=>unistr('REST-Synchronisierungslogeintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158472267302813)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'de'
,p_message_text=>unistr('Automatisierungslogeintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569300816303144)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tslog-Eintr\00E4ge f\00FCr den Entwickler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208236207302852)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge im Zugriffslog f\00FCr die Anmeldung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568875775303144)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungsanforderungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568931144303144)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'de'
,p_message_text=>'Runtime-Anforderungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568697757303143)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'de'
,p_message_text=>'Workspace-Anforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571159765303145)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'de'
,p_message_text=>unistr('Historieneintr\00E4ge von SQL Command Processor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571083269303145)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungslog-Eintr\00E4ge f\00FCr Kontrolldatei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570909413303145)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungslog-Eintr\00E4ge f\00FCr Skriptdatei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571211812303145)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Archiveintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572946777303147)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'de'
,p_message_text=>'Aktive Log-Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573047751303147)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Lognummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573199087303147)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'de'
,p_message_text=>'Aktueller Logzeitstempel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573710415303147)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'de'
,p_message_text=>unistr('Stunden bis zum n\00E4chsten Logwechsel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573361548303147)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'de'
,p_message_text=>'Intervall in Tagen (konstant)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573623149303147)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chster Logwechsel geplant f\00FCr')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574018165303148)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tslog-Eintr\00E4ge f\00FCr den Entwickler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574204513303148)
,p_name=>'4050_71_CLICK'
,p_message_language=>'de'
,p_message_text=>unistr('Clickthrough Log-Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575048812303148)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'de'
,p_message_text=>unistr('Historieneintr\00E4ge von SQL Command Processor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574918167303148)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungslog-Eintr\00E4ge f\00FCr Kontrolldatei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574758993303148)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungslog-Eintr\00E4ge f\00FCr Skriptdatei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575199045303148)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Archiveintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575276027303149)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Der Workspace %1 hat %2 Anwendungen und %3 Benutzer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575312283303149)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Clickthrough Log-Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756475057303302)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Produktivit\00E4ts- und Beispiel-Apps')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756513195303303)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'de'
,p_message_text=>'Beispiel-Websheets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755752030303302)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'de'
,p_message_text=>'Workspace-Anzahl'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502874383303091)
,p_name=>'4350_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502968811303091)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung bearbeiten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222785326302864)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'de'
,p_message_text=>'Oracle Database Express Edition 2 Day DBA.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222814450302864)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'de'
,p_message_text=>'Oracle Database Express Edition 2 Day Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222653352302864)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Express 2 Day Plus Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222933015302864)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'de'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus Java Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223066909302864)
,p_name=>'4500 800 HD NET'
,p_message_language=>'de'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus .NET Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223131004302864)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'de'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus PHP Developer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223212626302864)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'de'
,p_message_text=>unistr('Erl\00E4utert allgemeine, t\00E4glich auszuf\00FChrende administrative Aufgaben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223371791302864)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'de'
,p_message_text=>unistr('Erl\00E4utert, wie Sie die Vorteile der Oracle Database Express Edition-Entwicklungsumgebung nutzen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223404943302864)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'de'
,p_message_text=>'Bietet eine Reihe von Tutorials, die die Erstellung von auf Datenbanken basierenden Webanwendungen beschreiben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223649592302865)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Dokument bietet ein Tutorial, das zeigt, wie Sie sich mit Java und JDBC bei Oracle Database XE anmelden. Au\00DFerdem erfahren Sie, wie Sie damit eine einfache Java-Anwendung entwickeln, die auf Daten zugreift und diese \00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223770929302865)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Dokument beschreibt die Haupt-Features von Oracle Data Provider for .NET und Oracle Developer Tools for Visual Studio .NET. Es f\00FChrt Sie durch die Installation und Konfiguration und zeigt, wie Sie einfache Anwendungen mit Oracle Data Provider ')
||unistr('for .NET und Oracle Developer Tools for Visual Studio .NET erstellen. Au\00DFerdem erfahren Sie, wie Sie gespeicherte PL/SQL- sowie .NET-Prozeduren erstellen und verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223596530302864)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'de'
,p_message_text=>'Dieses Dokument bietet ein Tutorial, das zeigt, wie Sie Apache und die Zend Core PHP-Treiber herunterladen und installieren. Danach erfahren Sie, wie Sie sich mit PHP bei Oracle Database XE anmelden und eine einfache Anwendung entwickeln, die auf Dat'
||unistr('en zugreift und diese \00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194224908302842)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Aliasname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194147700302841)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194416405302842)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'de'
,p_message_text=>'Bedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626021164303188)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194882869302842)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194966474302842)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'de'
,p_message_text=>'Gruppieren nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194368053302842)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'de'
,p_message_text=>'Objekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194770932302842)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194566731302842)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'de'
,p_message_text=>'Sortiertyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194693954302842)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'de'
,p_message_text=>'Sortierreihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197411888302844)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'de'
,p_message_text=>'Join'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191236542302839)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie hier, um die Spalte f\00FCr den Join auszuw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197838241302844)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'de'
,p_message_text=>unistr('Es k\00F6nnen maximal 60 Spalten ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191114324302839)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191061017302839)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'de'
,p_message_text=>'Spalten ein-/ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197515999302844)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'de'
,p_message_text=>'bis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190028859302838)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'de'
,p_message_text=>unistr('Ergebnisse von %0, ausgef\00FChrt um %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446346001303046)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zur urspr\00FCnglichen Abfrage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205241830302850)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'de'
,p_message_text=>'Die ersten %0 angezeigten Spalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653671921303209)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'de'
,p_message_text=>'Ereignis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653502851303209)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'de'
,p_message_text=>'Kilobyte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653475965303209)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'de'
,p_message_text=>'Megabyte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226063272302866)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chen-Standards werden von App Builder verwendet, um die Ausgangswerte f\00FCr die Regions- und Elementeigenschaften aufzuf\00FCllen, und gew\00E4hrleisten eine Konsistenz bei mehreren Seiten einer oder mehrerer Anwendungen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256183871302890)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Anwendung m\00FCssen Cookies aktiviert sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256066220302890)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Anwendung muss JavaScript aktiviert sein.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683396634303238)
,p_name=>'ABOUT'
,p_message_language=>'de'
,p_message_text=>'Info'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376874351303816)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen Sie, dass die folgenden %0 Benutzer Ihrem Workspace hinzugef\00FCgt werden sollen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694884674303249)
,p_name=>'ACCEPTED'
,p_message_language=>'de'
,p_message_text=>'Angenommen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662956481303216)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'de'
,p_message_text=>unistr('Verf\00FCgbarkeitsbeauftragter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661059740303214)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'de'
,p_message_text=>'Auswirkung der Barrierefreiheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663317070303216)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'de'
,p_message_text=>'Status Barrierefreiheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427701318303859)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'de'
,p_message_text=>'Barrierefreiheit getestet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336560737302954)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'de'
,p_message_text=>'Administrationsrechte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202804437302848)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Administrationsseite f\00FCr die Zugriffskontrolle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615226983303179)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'de'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720119936303271)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'de'
,p_message_text=>'Diese Rolle wird Anwendungsadministratoren zugewiesen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203045047302848)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'de'
,p_message_text=>'Anwendungsadministration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203660822302849)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'de'
,p_message_text=>'Anwendungsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203582656302849)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, wie der Zugriff auf diese Anwendung kontrolliert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204649682302849)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeiten der Anforderung zum Festlegen des Anwendungsmodus nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204753393302849)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsmodus festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336925849302955)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen sich nicht selbst l\00F6schen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337090020302955)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen die Administratorberechtigung f\00FCr sich selbst nicht entfernen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202916558302848)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615113732303179)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'de'
,p_message_text=>'Beitragsrechte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615315042303179)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'de'
,p_message_text=>'Beitragender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720227633303271)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'de'
,p_message_text=>'Diese Rolle wird Anwendungsbeitragenden zugewiesen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655834900303211)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Die folgenden Anwendungseinstellungen werden erstellt:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615491999303179)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'de'
,p_message_text=>'Die folgenden Anwendungszugriffsrollen werden erstellt:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220299986302862)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Die folgenden Autorisierungsschemas werden erstellt:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276041731302907)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen der Zugriffskontrollseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275984976302907)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen der Zugriffskontrolltabellen nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338327994302956)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'de'
,p_message_text=>unistr('Sie d\00FCrfen keine doppelten Benutzernamen eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336645311302954)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle - Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204352099302849)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Abfragekriterien ohne Ber\00FCcksichtigung der Gro\00DF-/Kleinschreibung ein, und klicken Sie anschlie\00DFend auf <strong>Los</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204495329302849)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen des Modus f\00FCr die Anwendungsadministration nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204200001302849)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'de'
,p_message_text=>unistr('Zuletzt ge\00E4ndert von')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203922450302849)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'de'
,p_message_text=>'Access Control-Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203196296302848)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'de'
,p_message_text=>'Voller Zugriff auf alle, Access Control-Liste nicht verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203263078302848)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'de'
,p_message_text=>unistr('Eingeschr\00E4nkter Zugriff. Nur in der Access Control-Liste definierte Benutzer sind zugelassen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203351746302848)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'de'
,p_message_text=>unistr('Nur \00F6ffentlicher Lesezugriff. Berechtigungen f\00FCr das Bearbeiten und die Administration werden \00FCber die Access Control-Liste gesteuert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203431189302849)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'de'
,p_message_text=>'Nur Administratorzugriff.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204577870302849)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Berechtigung f\00FCr versuchte Aktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204153419302849)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'de'
,p_message_text=>'Berechtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655711742303211)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'de'
,p_message_text=>'Leserrechte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655620688303210)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'de'
,p_message_text=>'Leser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720391337303271)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'de'
,p_message_text=>'Diese Rolle wird Anwendungsleseberechtigten zugewiesen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221090227302862)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'de'
,p_message_text=>'Identifizieren Sie Benutzernamen, die diesem Anwendungsautorisierungsschema entsprechen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203732455302849)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'de'
,p_message_text=>'Anwendungsmodus festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302151063302928)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Zugriffskontrollseiten wurden erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615530286303179)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Zugriffskontrollrolle verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220902919302862)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Vorhandenes Autorisierungsschema verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220134495302862)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Tabelle verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336760301302955)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle - Anzeigen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223991958302865)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'de'
,p_message_text=>'Account wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909629817303424)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC "Account"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643554521303201)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643727199303201)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigt, keine Aktion')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704272847303257)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312872859303762)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'de'
,p_message_text=>'Zugriffs-Dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312961590303762)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'de'
,p_message_text=>unistr('Auf \00DCberwachungsaktivit\00E4t zugreifen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312459699303762)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen/\00C4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312722246303762)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'de'
,p_message_text=>'Administration bei laufender Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311640571303761)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'de'
,p_message_text=>'Administration von App Builder aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312353381303762)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'de'
,p_message_text=>'Annotationen (Dateien, Tags, Anmerkungen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311388017303761)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'de'
,p_message_text=>unistr('Authentifizierung f\00FCr Application Express-Accounts ohne Access Control-Liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311287109303761)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung mithilfe der Access Control-Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312088172303762)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'de'
,p_message_text=>'SQL-Zugriff und vorgeschlagene Objekte bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316006951303765)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Nachdem ein Benutzer f\00FCr eine Anwendung authentifiziert wurde, wird mithilfe der Zugriffskontrolle kontrolliert, was er innerhalb der Anwendung tun darf. In der untenstehenden Tabelle wird angegeben, welche Funktionen den verschiedenen Benutzertypen ')
||unistr('aufgrund der f\00FCr diese Anwendung verwendeten Authentifizierung zur Verf\00FCgung stehen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313084510303762)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'de'
,p_message_text=>'Access Control-Liste pflegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312188200303762)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren und Anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311837975303761)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'de'
,p_message_text=>'Anwendungseigenschaften aktualisieren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929130860303441)
,p_name=>'ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310746943303760)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'de'
,p_message_text=>unistr('Aktionsmen\00FCeinstellungen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232437088302872)
,p_name=>'ACTIVE'
,p_message_language=>'de'
,p_message_text=>'Aktiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622587901303185)
,p_name=>'ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664298053303217)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aktivit\00E4tszusammenfassung'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864817577303387)
,p_name=>'ADDED_BY'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzugef\00FCgt von')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307117681303757)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Der Bereinigungsliste hinzugef\00FCgt')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922060899303435)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'de'
,p_message_text=>unistr('Zus\00E4tzliche Informationen angefordert')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582343929303154)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'de'
,p_message_text=>unistr('Argument hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572764103303147)
,p_name=>'ADD_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770009596303313)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen von Spalte %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411966172303018)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'de'
,p_message_text=>unistr('Constraint hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570850444303145)
,p_name=>'ADD_MORE...'
,p_message_language=>'de'
,p_message_text=>unistr('Weitere hinzuf\00FCgen...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636680447303196)
,p_name=>'ADD_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775109246303317)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che hinzuf\00FCgen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778684475303320)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'de'
,p_message_text=>'Durch Provisioning bereitgestellten Speicherplatz um %0 MB anpassen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569526414303144)
,p_name=>'ADMIN'
,p_message_language=>'de'
,p_message_text=>'Admin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158353993302813)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'de'
,p_message_text=>'Bannerfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158136589302813)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'de'
,p_message_text=>'Umgebungsbanner aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158210455302813)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'de'
,p_message_text=>'Bannerlabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577560444303150)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'de'
,p_message_text=>'Bannerposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216341674302859)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'de'
,p_message_text=>'Workspace-Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664061665303217)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'de'
,p_message_text=>'Administratoren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576218692303149)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Adresse des Administrators muss angegeben werden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728554032303279)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'de'
,p_message_text=>'Barrierefreiheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238875761302877)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239142111302877)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>'Performance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239207548302877)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'de'
,p_message_text=>unistr('Qualit\00E4tssicherung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238914147302877)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'de'
,p_message_text=>'Sicherheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239388687302877)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'de'
,p_message_text=>'Verwendbarkeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239048462302877)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833586188303362)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'de'
,p_message_text=>unistr('Element "%1" ist gesch\00FCtzt und kann nicht \00FCber einen Ajax-Aufruf festgelegt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833665695303362)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Element "%1" ist gesch\00FCtzt und kann nicht \00FCber einen Ajax-Aufruf festgelegt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862934531303386)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Element "%1" ist gesch\00FCtzt und kann nicht \00FCber einen Ajax-Aufruf festgelegt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265287051302898)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('SYS-Schemapr\00E4fix fehlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969230984303478)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'de'
,p_message_text=>'Verwendung von WWV_FLOW APIs (verwenden Sie stattdessen APEX APIs)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919500335303432)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Spalte %0 ist in SQL-Anweisung der Regionsquelle nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248957427302885)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Die interaktive Berichtsspalte %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246601375302883)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'%0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226946855302867)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Spalte %0 ist in SQL-Anweisung der Regionsquelle nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999340945303503)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Tabellenspalte %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246702221302883)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'de'
,p_message_text=>'%0 kann nicht als Name des Anwendungs- oder Seitenelements referenziert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381940484303820)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>unistr('Ajax Callback-Prozess ist nicht durch ein Autorisierungsschema gesch\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381536947303819)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>unistr('Seite ist nicht durch ein Autorisierungsschema gesch\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247659351302884)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Zielseite %1 (in Anwendung %0) wurde kein Autorisierungsschema definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383277684303821)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'de'
,p_message_text=>unistr('Die Autorisierung dieser Seite unterscheidet sich von der Autorisierung "%1" der \00FCbergeordneten Seite %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247776013302884)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'de'
,p_message_text=>'Autorisierung "%0" auf Zielseite ist nicht identisch mit "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246295146302883)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'%0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246154930302883)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfung der Bind-Variablensyntax konnte nicht durchgef\00FChrt werden. Fehler: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246369878302883)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Auf %0 kann nicht mit der Bind-Variablensyntax verwiesen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248377860302884)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'de'
,p_message_text=>'Verzweigung ohne Bedingung vor anderen Verzweigungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381396833303819)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('"Automatisch vervollst\00E4ndigen" ist f\00FCr eine Seite, die Kennwortelemente enth\00E4lt, auf "Ein" gesetzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381421708303819)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'de'
,p_message_text=>unistr('"Cachen" l\00E4sst zu, dass der Browser vertrauliche Daten cacht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181050904303648)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'de'
,p_message_text=>unistr('"In Frames einbetten" macht die Anwendung f\00FCr Clickjacking-Angriffe anf\00E4llig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181109849303648)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'de'
,p_message_text=>'"HTML-Escape-Modus" maskiert nur eine begrenzte Gruppe von Zeichen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169628208302822)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'de'
,p_message_text=>unistr('Elemente m\00FCssen Sonderzeichen maskieren, um Cross-Site-Scripting-(XSS)-Angriffe zu verhindern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188131780303654)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Der HTTP-Anforderungsheader "Referrer" kann vertrauliche Sessioninformationen an Dritte weitergeben.',
'In Anwendungen sollte die "Referrer Policy" auf "strict-origin" gesetzt werden.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185701843302835)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ID in den Schaltfl\00E4chenattributen f\00FCr eine Schaltfl\00E4che gefunden, die in einer dynamischen Aktion (%0) referenziert wird. '),
'',
unistr('Wenn eine ID in den Schaltfl\00E4chenattributen definiert ist, f\00FChrt dies dazu, dass die dynamischen Aktionen, die die Schaltfl\00E4che referenzieren, nicht funktionieren. Sie sollten diese ID entfernen, weil die Schaltfl\00E4che automatisch eine ID generiert.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185812650302835)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Schaltfl\00E4chen-Template, das von einer Schaltfl\00E4che verwendet wird, die selbst in einer dynamischen Aktion (%0) referenziert wird, enth\00E4lt die Ersetzungszeichenfolge #BUTTON_ID# nicht.'),
'',
'Template:',
'%1',
'',
unistr('Sie sollten entweder die Ersetzungszeichenfolge #BUTTON_ID# diesem Template hinzuf\00FCgen oder das Schaltfl\00E4chen-Template in ein Template \00E4ndern, das die Zeichenfolge #BUTTON_ID# enth\00E4lt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189180466302838)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Aktion" ist nicht ''Von dynamischer Aktion definiert'' f\00FCr eine Schaltfl\00E4che, die in einer dynamischen Aktion (%0) referenziert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195288067302842)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Schaltfl\00E4che (%0) ist eine "Aktion" gleich "Von dynamischer Aktion definiert" festgelegt, es ist jedoch keine entsprechende dynamische Aktion vorhanden, die diese Schaltfl\00E4che referenziert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247329533302883)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schcacheseite %0 ist nicht die aktuelle Seite oder die Zielseite %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246095323302882)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'%0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355157905303798)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>'Der Attributwert ist veraltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357614134303800)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Dieser Komponententyp ist veraltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833738045303362)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'de'
,p_message_text=>unistr('Gesch\00FCtzte Elemente in Ajax-Aufrufen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265101773302898)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'de'
,p_message_text=>'Code-Smell (APEX intern)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244158824302881)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'de'
,p_message_text=>'Deklarative Referenzen von Anwendungselementen, Seitenelementen, Spalten oder interaktiven Berichtsfiltern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381218365303819)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>'Autorisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243855896302881)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'de'
,p_message_text=>'Referenzen mit Bind-Variablensyntax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245297467302882)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Verzweigung ohne Bedingung vor anderen Verzweigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381762081303820)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'de'
,p_message_text=>'Browser-Sicherheitseinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185686668302835)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che ist mit dynamischen Aktionen nicht kompatibel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195081688302842)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'de'
,p_message_text=>unistr('Inkonsistente Referenzen zwischen dynamischen Aktionen und Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244414617302881)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'de'
,p_message_text=>unistr('Seitennummer f\00FCr L\00F6schcache entspricht Zielseite oder aktueller Seite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243731939302881)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'de'
,p_message_text=>'Referenzen mit Spaltensyntax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355038991303798)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Veraltete Attributwerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244750555302881)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'de'
,p_message_text=>unistr('Fetch-, DML-, MR*-Prozesse sind g\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245186703302882)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'de'
,p_message_text=>'Hartcodierte Anwendungs-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640884068303199)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'de'
,p_message_text=>'Seitenelement hat Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728342632303279)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'de'
,p_message_text=>'Seite hat Seitentitel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752547415303299)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Element zum Anzeigen von Bildern ist ALT-Bildtext definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180803388303648)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungsattribute, die gesperrt werden k\00F6nnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243912657302881)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'de'
,p_message_text=>'Referenziertes Element befindet sich auf der aktuellen Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244051229302881)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'de'
,p_message_text=>'Referenziertes Element ist Seitenelement der Zielseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729030115303279)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenelement verursacht keine unerwartete Kontext\00E4nderung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729768312303280)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'de'
,p_message_text=>'Seitenelement hat Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245466123302882)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4nge des Element- oder tabellarischen Formular-Spaltennamens')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244212913302881)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'de'
,p_message_text=>'Referenzen von Seitenelementen in einer Zeichenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244390353302881)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Referenzierte Seitennummer ist vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728613315303279)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'de'
,p_message_text=>'Region hat Zeilenheader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245618977302882)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'de'
,p_message_text=>'Bericht hat Standardreihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381856096303820)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Schutz f\00FCr den Sessionzustand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244890367302881)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'de'
,p_message_text=>'Unpassende Verwendung der Ersetzungssyntax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243625356302881)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'de'
,p_message_text=>'Referenzen mit Ersetzungssyntax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244604479302881)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'de'
,p_message_text=>unistr('Autorisierung der Zielseite ist auch f\00FCr aktuelle Komponente eingerichtet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728891991303279)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'de'
,p_message_text=>'Theme-Stil auf Barrierefreiheit getestet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823649672303355)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che umfasst Kompatibilit\00E4ts-JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245326042302882)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Verkn\00FCpftes Element oder verkn\00FCpfte Spalte der Validierungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244585167302881)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'de'
,p_message_text=>unistr('Ist g\00FCltiger SQL- oder PL/SQL-Code')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245002738302882)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'de'
,p_message_text=>unistr('CLOB-Eigenschaft pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98244986227302882)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'de'
,p_message_text=>'In SQL-Anweisungen verwendete V-Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245571724302882)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'de'
,p_message_text=>unistr('Referenzierte Schaltfl\00E4che ist in "Bei geklickter Schaltfl\00E4che" vorhanden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247987691302884)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'de'
,p_message_text=>'Kompilierungsfehler - %0 Anweisung: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248254134302884)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Link enth\00E4lt die aktuelle Anwendungs-ID als hartcodierten Wert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640790925303199)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>'Kein Hilfetext definiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728433643303279)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Seite hat keinen Titel. Aussagekr\00E4ftige Seitentitel sind wichtig f\00FCr die Barrierefreiheit, damit Benutzer den Inhalt und den Zweck der aktuellen Seite richtig verstehen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752637751303299)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr das Element fehlt der f\00FCr das Bild erforderliche alternative Text. Verwenden Sie hierf\00FCr einen Text, mit dem der Inhalt des Bildes zutreffend beschrieben wird. Au\00DFerdem sollte der Text keine Informationen enthalten, die im Zusammenhang mit dem Bi')
||unistr('ld auf der Seite angezeigt werden (zur Vermeidung einer m\00F6glichen Duplizierung). Hinweis: Wird das Bild von Benutzern zur Verf\00FCgung gestellt, sollten diese auch den alternativen Bildtext erstellen. Stellen Sie den Benutzern entsprechende Anweisungen ')
||unistr('zum Erstellen ad\00E4quater Texte zur Verf\00FCgung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180940303303648)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'de'
,p_message_text=>unistr('"Laufzeit-API-Verwendung" l\00E4sst Anwendungs- und Workspace-\00C4nderung zu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246499271302883)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'de'
,p_message_text=>'%0 ist kein Element von Seite %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246571719302883)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'de'
,p_message_text=>'%0 ist kein Element von Zielseite %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729144438303279)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Die Einstellung "Seitenaktion bei Auswahl" f\00FCr das Seitenelement k\00F6nnte eine unerwartete Kontext\00E4nderung f\00FCr den Benutzer verursachen. Sie k\00F6nnen die Einstellung in "Kein Wert" \00E4ndern, damit keine Kontext\00E4nderung stattfindet, und die Funktionalit\00E4t d')
||unistr('urch dynamische Aktionen oder kaskadierende Wertelisten ersetzen (falls Sie auf derselben Seite bleiben m\00FCssen). Alternativ k\00F6nnen Sie den Benutzer dar\00FCber informieren, was geschehen wird (beispielsweise durch Hinzuf\00FCgen von "Startet neue Seite" im L')
||'abel). '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752463125303299)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr das Element muss ein Label definiert sein. Wenn Sie kein sichtbares Label anzeigen m\00F6chten, sollten Sie trotzdem ein Label definieren und das Labeltemplate "Ausgeblendet" ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729881176303280)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr das Element ist der Wert "Wertplatzhalter" definiert, aber kein Label. Platzhaltertext alleine reicht als Label f\00FCr das Element nicht aus und f\00FChrt zu Problemen bei der Barrierefreiheit. F\00FCr eine bessere Barrierefreiheit sollte ein Elementlabel d')
||unistr('efiniert sein. Wenn Sie kein sichtbares Label anzeigen m\00F6chten, sollten Sie trotzdem ein Label definieren und das Labeltemplate "Ausgeblendet" ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248689522302885)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Der Namen ist %0 Zeichen lang, darf aber h\00F6chstens 30 Zeichen lang sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246837467302883)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ist m\00F6glicherweise nicht vorhanden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98246993708302883)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ist m\00F6glicherweise kein Seiten- oder Anwendungselement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247235307302883)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schcacheseite %1 (in Anwendung %0) ist nicht vorhanden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247008517302883)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Seite %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247124124302883)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Zielseite %1 (in Anwendung %0) ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655942832303211)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Spaltenumschaltregion verf\00FCgt nicht \00FCber eine Spalte, bei der "Als Zeilenheader verwenden" auf "Ja" gesetzt ist. Die Spalte "Zeilenheader" sollte die Spalte sein, die die aktuelle Zeile am besten identifiziert (beispielsweise ein Kundenname in ')
||'einem Bericht mit Kundeninformationen).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656021798303211)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Reflow-Region verf\00FCgt nicht \00FCber eine Spalte, bei der "Als Zeilenheader verwenden" auf "Ja" gesetzt ist. Die Spalte "Zeilenheader" sollte die Spalte sein, die die aktuelle Zeile am besten identifiziert (beispielsweise ein Kundenname in einem Be')
||'richt mit Kundeninformationen).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728702133303279)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Diese tabellarische Formularregion verf\00FCgt nicht \00FCber eine Spalte, bei der "Als Zeilenheader verwenden" auf "Ja" gesetzt ist. Die Spalte "Zeilenheader" sollte die Spalte sein, die die aktuelle Zeile am besten identifiziert (beispielsweise ein Kundenn')
||unistr('ame in einer Tabelle mit Kundeninformationen). Diese Informationen werden dann beim Rendering des tabellarischen Formulars verwendet, um eindeutige Labels f\00FCr die Formularfelder der einzelnen Zeilen bereitzustellen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248834031302885)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'de'
,p_message_text=>'Bericht hat keine Standardreihenfolge.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181208165303649)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('"Lesezeichen f\00FCr Hashfunktion setzen" ist auf einen veralteten Algorithmus festgelegt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181332816303649)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('"Schutz f\00FCr den Sessionzustand" ist deaktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381632666303820)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Auf einer Seite mit einem Fetch-Prozess m\00FCssen Sie "Seitenzugriffsschutz" verwenden und den Schutz f\00FCr die Elemente aktivieren, die Sie \00FCber die URL \00FCbergeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218469973302860)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'de'
,p_message_text=>unistr('Region enth\00E4lt "f?p"-URL, die nicht von APEX_UTIL.PREPARE_URL \00FCbergeben wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248070277302884)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6gliche SQL-Injection erkannt. %0 wird mit Ersetzungssyntax in SQL-, PL/SQL-Code oder Prozesstabellenname verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245841691302882)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'%0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245905010302882)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Auf %0 kann nicht mit der Ersetzungssyntax verwiesen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247828119302884)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Zielseite %1 (in Anwendung %0) wurde ein Autorisierungsschema definiert, f\00FCr die aktuelle Komponente jedoch nicht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728935604303279)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'de'
,p_message_text=>unistr('Der aktuelle Theme-Stil f\00FCr die Anwendung wurde nicht auf Barrierefreiheit getestet. W\00E4hlen Sie entweder einen Theme-Stil aus, bei dem "Barrierefreiheit getestet" auf "Ja" gesetzt ist, oder setzen Sie das Attribut "Barrierefreiheit getestet" in den T')
||'heme-Einstellungen auf "Ja", wenn der aktuelle Theme-Stil getestet wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823826091303355)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'de'
,p_message_text=>unistr('Die Benutzeroberfl\00E4che umfasst jQuery Migrate. jQuery Migrate bietet Unterst\00FCtzung bei der Migration auf eine neuere Version von jQuery, indem entfernte APIs wiederhergestellt werden. Au\00DFerdem werden Warnungen in der Browserkonsole angezeigt, wenn en')
||unistr('tfernte oder veraltete APIs verwendet werden. Dazu geh\00F6rt eine zus\00E4tzliche JavaScript-Datei f\00FCr jede Seite in Ihrer App. Informationen zum Entfernen dieser Datei finden Sie im jQuery Migrate-Upgradehandbuch. Es enth\00E4lt Angaben dazu, welche APIs ge\00E4nd')
||unistr('ert werden m\00FCssen. Wenn Sie sich sicher sind, dass Sie diese APIs nicht mehr ben\00F6tigen, setzen Sie "jQuery Migrate einbeziehen" auf "Nein".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823764493303355)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Benutzeroberfl\00E4che umfasst veraltete oder nicht mehr unterst\00FCtzte JavaScript-Funktionen. Dazu geh\00F6rt eine zus\00E4tzliche JavaScript-Datei f\00FCr jede Seite in Ihrer App. Informationen zum Entfernen dieser Datei finden Sie in den Versionshinweisen im Ab')
||unistr('schnitt "Veraltete Features". Dort finden Sie Anweisungen zum Pr\00FCfen, ob Abh\00E4ngigkeiten f\00FCr veraltete oder nicht mehr unterst\00FCtzte Funktionen vorliegen, und wie Sie erreichen, dass diese nicht mehr in Ihre App einbezogen werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248557525302884)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Verkn\00FCpftes Element oder verkn\00FCpfte Spalte ist nicht definiert, ist aber f\00FCr "Position f\00FCr die Fehlermeldung" erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248402539302884)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'de'
,p_message_text=>unistr('Verkn\00FCpftes Element oder verkn\00FCpfte Spalte entspricht nicht dem in Validierungsausdruck 1 angegebenen Wert "%0".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247485399302884)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'de'
,p_message_text=>'Kompilierungsfehler - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98247502498302884)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>'Kein SQL- oder PL/SQL-Code definiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98245756183302882)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Ist l\00E4nger als 32767. Nur die ersten 32767 werden gepr\00FCft. L\00E4nge: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248110070302884)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'de'
,p_message_text=>unistr('Enth\00E4lt einen V/NV/DV-Funktionsaufruf in einer SQL-Anweisung (kann ein Performanceproblem sein).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98248712547302885)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Die referenzierte Schaltfl\00E4che ist nicht mehr vorhanden.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628447348303189)
,p_name=>'AFTER'
,p_message_language=>'de'
,p_message_text=>'Nach'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575700786303149)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'de'
,p_message_text=>'Vereinbarung fehlt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369857037302979)
,p_name=>'ALIAS'
,p_message_language=>'de'
,p_message_text=>'Aliasname'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972002756303480)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'de'
,p_message_text=>'Anwendungserstellung zulassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913421612303427)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lassen Sie die Installation von Produktivit\00E4ts- und Beispielanwendungen zu.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815252024303348)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'de'
,p_message_text=>'Verwendung von RESTful Services zulassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972170709303480)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'Verwendung von SQL Workshop zulassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972322175303481)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'de'
,p_message_text=>'Verwendung von Team Development zulassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971962907303480)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Workspace zulassen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972272941303481)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'de'
,p_message_text=>'Websheet-Entwicklung zulassen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389059647302999)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Alle Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206264736302851)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'de'
,p_message_text=>'- Alles -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206046615302850)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'de'
,p_message_text=>'Alle Kategorien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206344085302851)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'de'
,p_message_text=>'- Alle Kategorien -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974636819303483)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'de'
,p_message_text=>'Alle Meilensteine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754067999303300)
,p_name=>'ALL_RELEASES'
,p_message_language=>'de'
,p_message_text=>'Alle Releases'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393492532303002)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'de'
,p_message_text=>'Alle statischen Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392044712303001)
,p_name=>'ALL_THEMES'
,p_message_language=>'de'
,p_message_text=>'Alle Themes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992728543303498)
,p_name=>'ALL_TYPES'
,p_message_language=>'de'
,p_message_text=>'Alle Typen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993173207303498)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'de'
,p_message_text=>'- Alle Typen -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389177889302999)
,p_name=>'ALL_USERS'
,p_message_language=>'de'
,p_message_text=>'Alle Benutzer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377083876303816)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'de'
,p_message_text=>'Benutzer hat bereits einen APEX-Account'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366921444303807)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'de'
,p_message_text=>'Benutzer ist bereits im Workspace vorhanden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333342325303780)
,p_name=>'ALWAYS'
,p_message_language=>'de'
,p_message_text=>'Immer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643309732303201)
,p_name=>'ANALYSIS'
,p_message_language=>'de'
,p_message_text=>'%0-Analyse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643408887303201)
,p_name=>'ANALYZE'
,p_message_language=>'de'
,p_message_text=>'Analysieren pro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771012095303314)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'de'
,p_message_text=>'Analysieren mit Methode %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390963926303000)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'de'
,p_message_text=>'anonymer Block'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252009730302887)
,p_name=>'ANSWERS'
,p_message_language=>'de'
,p_message_text=>'Antworten'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218166243302860)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'de'
,p_message_text=>'(Beliebiger Entwickler)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419048884303852)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungs\00E4nderungen:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418939380303852)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'de'
,p_message_text=>'Stunde:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423058045303855)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'de'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419186596303852)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenansichten: '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175780194303644)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Ein API-Aufruf wurde untersagt.',
'Wenden Sie sich an den Administrator.',
unistr('Details zu diesem Vorfall k\00F6nnen \00FCber Debugging-ID "%0" abgerufen werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277371622302908)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'de'
,p_message_text=>unistr('Der API-Aufruf "%0" wird in Application Express Version %1 nicht mehr unterst\00FCtzt. Details zu diesem Vorfall finden Sie unter Debugging-ID "%2".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653274641303209)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'de'
,p_message_text=>'#LABEL# ist in Liste nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930466448303442)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('"Nur Verzweigungen anzeigen" wird nicht unterst\00FCtzt, wenn das Seitenattribut "Bei Weiterleitung erneut laden" auf "Nur bei Erfolg" festgelegt ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395194363303004)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Verzweigung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184490482302834)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Berechnung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375264750302983)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Bedingung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426782359303030)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'de'
,p_message_text=>'Unbekannter Bedingungstyp "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180493800302831)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Das Dateisuchelement %0 muss die Tabelle APEX_APPLICATION_TEMP_FILES verwenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157850188302812)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Der Ladetyp "Zusammenf\00FChren" wird f\00FCr das Laden in Collections nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311069304303761)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr den Ladetyp "Zusammenf\00FChren" ist mindestens eine Prim\00E4rschl\00FCsselspalte im Datenprofil erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310838596303761)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage der Ladequelle kann nicht geparst werden: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310907135303761)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage der Ladequelle muss VARCHAR2, CLOB oder BLOB zur\00FCckgeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588126244303159)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung %0 Dialogseite %1 kann nicht erfolgreich wiedergegeben werden. Stellen Sie sicher, dass das auf Seite %1 verwendete Template den Typ "Dialogseite" hat und der entsprechende Code zur Initialisierung, zum Schlie\00DFen und Abbrechen des JavaScrip')
||'t-Dialogs definiert ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408058423303842)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'de'
,p_message_text=>'Copyright &copy; %0, Oracle und/oder verbundene Unternehmen. All rights reserved. Alle Rechte vorbehalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408819220303843)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Workspace erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407908836303842)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'de'
,p_message_text=>'Dies ist eine systemgenerierte Nachricht. Beantworten Sie diese nicht.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416414867303850)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'de'
,p_message_text=>'Umgebung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427083695303858)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Express-Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409428639303844)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'de'
,p_message_text=>'Erste Schritte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408195590303842)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'de'
,p_message_text=>'Hallo %0,'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409179852303843)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'de'
,p_message_text=>'Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416554786303850)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Workspace verhindern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409383167303843)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen verhindern, dass Ihr Workspace gel\00F6scht wird, indem Sie auf die Schaltfl\00E4che unten klicken und den Anweisungen auf dem Bildschirm folgen. Wenn Sie nicht innerhalb von %0 Tag(en) reagieren, wird Ihr Workspace automatisch entfernt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416291541303849)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie Ihren Workspace nicht mehr ben\00F6tigen, ist keine Aktion erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416720341303850)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('Ihr Workspace wird in K\00FCrze gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416080261303849)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Ihren Workspace %0 wurden in letzter Zeit keine Aktivit\00E4ten verzeichnet, deshalb wird er in K\00FCrze gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415928472303849)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung. Ihr Workspace "%0" wird in K\00FCrze gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416383049303850)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schendatum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417053257303850)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen Sie Ihre Workspace-Anforderung ab.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416898154303850)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'de'
,p_message_text=>'Ihr Workspace "%0" ist bereit.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417124349303850)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'de'
,p_message_text=>'Ihr Workspace "%0" wurde genehmigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416966039303850)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'de'
,p_message_text=>'Ihre Workspace-Anforderung wurde abgelehnt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408754438303843)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416686885303850)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408646372303843)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408246350303842)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'de'
,p_message_text=>'Workspace-Anforderung genehmigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408989461303843)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf die Schaltfl\00E4che unten, um den Genehmigungsprozess abzuschlie\00DFen und Ihr Kennwort festzulegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408489529303843)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'de'
,p_message_text=>'Ihre Workspace-Anforderung wurde genehmigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409065971303843)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie unten auf die Schaltfl\00E4che, um zu beginnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409298990303843)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'de'
,p_message_text=>'Ihr Workspace ist bereit.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408318779303843)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'de'
,p_message_text=>'Workspace-Anforderung abgelehnt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99408534851303843)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'de'
,p_message_text=>'Ihre Workspace-Anforderung wurde leider abgelehnt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184878075302834)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Downloads werden nicht unterst\00FCtzt, wenn das Seitenattribut "Bei Weiterleitung neu laden" auf "Nur bei Erfolg" gesetzt ist. \00C4ndern Sie das Seitenattribut "Bei Weiterleitung neu laden" in "Immer", oder verwenden Sie einen "Vor Header"-Prozess.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718646070303270)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'de'
,p_message_text=>'In Queue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718708494303270)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'de'
,p_message_text=>'Gesendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214645444302857)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Feedbackeintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214722952302857)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Offene Feedback-Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214867412302857)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553818748303132)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Gruppe "%0" konnte nicht gefunden werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388887109303825)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'de'
,p_message_text=>'Dokumentation anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296751730302924)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Der HTTP-Header %0 wurde zweimal gesendet. Das k\00F6nnte auf einen Angriff hinweisen.'),
'<ul>',
'<li>Erster Wert: "%1"</li>',
'<li>Zweiter Wert: "%2"</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333904870302952)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Die Druckunterst\00FCtzung muss STANDARD, ADVANCED, APEX_LISTENER, AOP oder NONE sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334008900302952)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Das erste bereitgestellte Schema kann nicht entfernt werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237367336302876)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Anwendungs-ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753452073303300)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige E-Mail-Adresse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229615800302869)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'de'
,p_message_text=>'Der Wert muss null oder eine positive Ganzzahl sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334189787302953)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Portnummer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781118671303322)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Abonnement-ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334224233302953)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'de'
,p_message_text=>'Der Wallet-Pfad muss in der Form-Datei sein:<filesystempath>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413172719303019)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Der Workspace wurde nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413092987303019)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Workspace-ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438460695303039)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'de'
,p_message_text=>unistr('Wert darf nicht gr\00F6\00DFer als %0 sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348830362302964)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert "%1" von Instanzparameter "%0" entspricht nicht dem regul\00E4ren Ausdruck "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348741778302963)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Der Instanzparameter "%0" muss einen Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334304648302953)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'de'
,p_message_text=>'Instanzparameter nicht gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777264839303319)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'de'
,p_message_text=>'Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184591455302834)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppen (nur f\00FCr Authentifizierung mit Workspace-Benutzeraccount-Repository)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969695020303478)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppen (nur f\00FCr Authentifizierung mit Workspace-Benutzeraccount-Repository)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862833737303386)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppen (nur f\00FCr Authentifizierung mit Workspace-Benutzeraccount-Repository)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268851820302901)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppen (nur f\00FCr Authentifizierung mit Workspace-Benutzeraccount-Repository)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492057129303083)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppen (nur f\00FCr Authentifizierung mit Workspace-Benutzeraccount-Repository)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777161341303318)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppen (nur f\00FCr Authentifizierung mit Workspace-Benutzeraccount-Repository)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336228413302954)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'de'
,p_message_text=>'Das Druckserverprotokoll muss entweder HTTP oder HTTPS sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336362822302954)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Das Schema ist nicht vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336472110302954)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'de'
,p_message_text=>unistr('Das Schema ist eingeschr\00E4nkt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209770653302853)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209550129302853)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Anwendung nicht mehr vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014436824303515)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'de'
,p_message_text=>'Zuweisen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411303801303018)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Anh\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341400830303787)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'de'
,p_message_text=>'Karten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215172762302858)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'de'
,p_message_text=>'Geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211610551302855)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'de'
,p_message_text=>'Kommentiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211560038302855)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'de'
,p_message_text=>'Kommentare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215250130302858)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596671416303165)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'de'
,p_message_text=>'hat diesen Vorgang erstellt: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186275697302835)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186099444302835)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie diesen Kommentar wirklich l\00F6schen?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998804484303503)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'de'
,p_message_text=>unistr('Vorgang l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195991885302843)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie diesen Vorgang wirklich l\00F6schen?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213209816302856)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'de'
,p_message_text=>'Dokument'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212101572302855)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'de'
,p_message_text=>'Dokumente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186184379302835)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126924047303606)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'de'
,p_message_text=>'Kommentar bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127096638303606)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'de'
,p_message_text=>'Vorgang bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210354789302854)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Anwendung ist in diesem Workspace nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210757323302854)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Versuch, den Kommentar zu l\00F6schen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210686030302854)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Kommentar nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210979390302854)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Vorgang nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211066888302854)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Versuch, den Vorgang zum L\00F6schen zu markieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210454839302854)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Seite ist in diesem Workspace oder in der angegebenen Anwendung nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210877819302854)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer ist nicht autorisiert, diesen Kommentar zu l\00F6schen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211109335302854)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer ist nicht autorisiert, diesen Vorgang zu l\00F6schen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210586640302854)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer ist nicht autorisiert, die Sichtbarkeit dieses Kommentars zu \00E4ndern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220496490303679)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Beim Pr\00FCfen der Dateigr\00F6\00DFen ist ein Problem aufgetreten. Wenden Sie sich an den Systemadministrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220314688303679)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Eine dieser Dateien \00FCberschreitet die maximale Dateigr\00F6\00DFe von %0 Byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220224016303679)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Datei \00FCberschreitet die maximale Dateigr\00F6\00DFe von %0 Byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186377039302835)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213096446302856)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211974526302855)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'de'
,p_message_text=>'Bilder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209320642302853)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Vorgang, der nicht im System gefunden wurde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158747610302813)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'de'
,p_message_text=>unistr('Voreinstellung f\00FCr Benutzer hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211704996302855)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'de'
,p_message_text=>unistr('Dateien anh\00E4ngen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211480852302855)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'de'
,p_message_text=>'Geschlossen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345324121303790)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212771900302856)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'de'
,p_message_text=>'ist leer.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212593725302856)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'de'
,p_message_text=>'Eine dieser Dateien ist'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211324915302855)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213802201302857)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Auswahl dauerhaft l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999742579303504)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'de'
,p_message_text=>unistr('Alle l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213765832302856)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'de'
,p_message_text=>'Auswahl wiederherstellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211812749302855)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Antwortvorlagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212645995302856)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'de'
,p_message_text=>unistr('zu gro\00DF zum Hochladen. <br>Dateien m\00FCssen kleiner sein als')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212973735302856)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzte Dateitypen: ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195374455303660)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein Antworttemplate aus')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212404745302855)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'de'
,p_message_text=>'Diese Datei ist'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212835547302856)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('kein unterst\00FCtzter Dateityp.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942256170303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'de'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942811143303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'de'
,p_message_text=>'Dokumentationsvorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942395349303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'de'
,p_message_text=>'Erweiterungsanforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942439029303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'de'
,p_message_text=>'Featureanforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942763528303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'de'
,p_message_text=>'Installationsvorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942612930303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'de'
,p_message_text=>'Performancevorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942546946303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'de'
,p_message_text=>'Sicherheitsvorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942911162303452)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'de'
,p_message_text=>'Schulungsvorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943610800303453)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'de'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943372289303453)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'de'
,p_message_text=>'CSS / HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943407774303453)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktionen/JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943129791303452)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'de'
,p_message_text=>'Datenbank'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943726924303453)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'de'
,p_message_text=>'Externe Systemintegration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943288684303452)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'de'
,p_message_text=>'REST-Integration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943572393303453)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'de'
,p_message_text=>'Sicherheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943089506303452)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'de'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942191254303452)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'de'
,p_message_text=>'Kategorie, die dem Vorgang zugewiesen wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941298887303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'de'
,p_message_text=>'Kategorie'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98942010564303452)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'de'
,p_message_text=>'Funktionsbereich, der von dem Vorgang betroffen ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941319381303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'de'
,p_message_text=>'Funktionsbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941929780303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'de'
,p_message_text=>'Wichtigkeit, die dem Vorgang beigemessen wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941405866303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'de'
,p_message_text=>'Wichtigkeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941874221303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'de'
,p_message_text=>'Mit dem Vorgang verbundener Aufwand.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941528955303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'de'
,p_message_text=>'Aufwand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941794677303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'de'
,p_message_text=>'Fortschritt in Bezug auf den Vorgang.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941636525303451)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'de'
,p_message_text=>'Fortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944164396303453)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'de'
,p_message_text=>'Backlog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943850339303453)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'de'
,p_message_text=>'Kritisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98943909345303453)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'de'
,p_message_text=>'Wichtig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944040008303453)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944258352303453)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'de'
,p_message_text=>'Wird nicht behoben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944346403303453)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'de'
,p_message_text=>'Einfacher Fix'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944564121303454)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'de'
,p_message_text=>unistr('Gro\00DFer Entwicklungsaufwand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944456351303454)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'de'
,p_message_text=>unistr('M\00E4\00DFiger Aufwand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944923063303454)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'de'
,p_message_text=>'Kann nicht behoben werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945015583303454)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944746937303454)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'de'
,p_message_text=>'Weitere Info erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944845026303454)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'de'
,p_message_text=>'Warten auf Drittanbieter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98944685283303454)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'de'
,p_message_text=>'In Bearbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955139471303466)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Labelgruppe kann nicht gel\00F6scht werden, weil mindestens eines der zugeh\00F6rigen Mitglieder einem Vorgang zugewiesen ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214938677302858)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Zuletzt aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98211248430302855)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'de'
,p_message_text=>'Markiert als Duplikat von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999259052303503)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'de'
,p_message_text=>'Beauftragte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999199302303503)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'de'
,p_message_text=>'Labels'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999672824303503)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'de'
,p_message_text=>'Meilensteine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999041299303503)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'de'
,p_message_text=>'Status'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209197490302853)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'de'
,p_message_text=>'Meilensteine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945442949303454)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'de'
,p_message_text=>'Codesperrung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945637991303455)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'de'
,p_message_text=>unistr('Endg\00FCltiges Release')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945548921303454)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'de'
,p_message_text=>'UI-Sperrung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213662639302856)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'de'
,p_message_text=>unistr('%0 hat %2 einen Kommentar zu %1 hinzugef\00FCgt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157738408302812)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('hat sich ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962758464303473)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Vorgangsnummer %0 in Workspace %1 wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220112152303679)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'de'
,p_message_text=>'Es wurden keine Labels definiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215073783302858)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212375245302855)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'de'
,p_message_text=>'Weitere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209865386302853)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209681901302853)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Seite nicht mehr vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338967923303785)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Alle l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014503589303516)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209452307302853)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungs- und Seitenverkn\00FCpfung entfernt von')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210102873302854)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'Anhang entfernt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313626800303763)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie Ihren aktuellen Kommentar durch dieses Template ersetzen?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315644022303765)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hallo, ',
'',
unistr('Sie haben Ihren allerersten Vorgang erstellt. Sie k\00F6nnen Vorg\00E4nge erstellen, um Aufgaben, Features, Bugs und Feedback f\00FCr alle APEX-Projekte zu verfolgen. Sie k\00F6nnen Vorg\00E4ngen Labels und Beauftragte hinzuf\00FCgen, Meilensteine festlegen und sogar Format')
||unistr('ierungen mit Markdown-K\00FCrzeln anwenden.  '),
'',
unistr('Nachfolgend finden Sie ein kurzes Beispiel f\00FCr die Verwendung von Markdown:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315520779303765)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'de'
,p_message_text=>'Willkommen bei Team Development in Oracle APEX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014629523303516)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'de'
,p_message_text=>unistr('- Ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210240710302854)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'de'
,p_message_text=>' Status festlegen auf'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186500144302836)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Aktionen anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315499050303765)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'de'
,p_message_text=>'Mehr anzeigen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209927260302854)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'de'
,p_message_text=>'Abonniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220543050303679)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr %0 in Workspace %1 liegen %2 neue Benachrichtigungen vor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938756403303449)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'de'
,p_message_text=>'Template, das zum Loggen eines Bugs verwendet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938623961303449)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'de'
,p_message_text=>'Bugtemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938591522303449)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Erwartetes Verhalten**',
'- Geben Sie an, was Ihrer Meinung nach geschehen soll.',
'',
'',
'**Aktuelles Verhalten**',
'- Geben Sie an, was geschieht.',
'',
'',
'**Wer ist betroffen**',
'- Geben Sie an, wer/was betroffen ist. ',
'',
unistr('**M\00F6gliche L\00F6sung**'),
unistr('- Falls m\00F6glich, geben Sie eine Empfehlung zur Korrektur dieses Bugs.'),
'',
'**Schritte zur Reproduktion**',
unistr('- Geben Sie eindeutige Schritte zur Reproduktion des Bugs an, einschlie\00DFlich Screenshots und Code-Snippets, falls zutreffend.'),
'1.',
'2.',
'3.',
'',
'**Kontext**',
'- Was wollten Sie gerade erreichen, als der Bug auftrat. Tritt der Bug nur unter bestimmten Bedingungen oder zu bestimmten Tageszeiten usw. auf.',
'',
'**Umgebung**',
'',
'- Version: ',
'- Plattform: ',
'- Subsystem:',
'',
'______',
'',
unistr('_**HINWEIS:** Um einen Vorgang mit einer Anwendung und/oder Seite zu verkn\00FCpfen, loggen Sie zuerst den Vorgang. Verkn\00FCpfen Sie anschlie\00DFend Anwendung und Seite \00FCber das Dropdown-Listenfeld **AKTIONEN**._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939822432303450)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'de'
,p_message_text=>'Ein Bug wurde gemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939756502303450)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'de'
,p_message_text=>'Bug gemeldet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939999580303450)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Ein **Bug** wurde im entsprechenden externen System erfasst.',
'',
'- Bugtrackingsystem: ',
'- Bug-ID: ',
'- URL zu Bug: ',
'',
'Kommentare:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938956742303449)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'de'
,p_message_text=>'Template, das zum Loggen einer Featureanforderung verwendet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938819039303449)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'de'
,p_message_text=>'Featureanforderungstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939021094303449)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**Feature\00FCbersicht**'),
unistr(' - Geben Sie in einem Absatz eine allgemeine \00DCbersicht \00FCber die Featureanforderung an.'),
'',
'',
'**Kontext**',
' - Bezieht sich diese Anforderung auf eine bestimmte Situation oder einen bestimmten Prozess? Beispiel: "Ich bin immer frustriert, wenn [...]"',
'',
'',
unistr(' - Geben Sie Zusatzinformationen an, einschlie\00DFlich Screenshots, Anwendungsf\00E4lle usw.'),
'',
'',
unistr('**Bevorzugte L\00F6sung**'),
unistr('- Geben Sie eine klare Beschreibung der gew\00FCnschten Implementierungen an.'),
'',
'',
unistr('**Alternative L\00F6sungen**'),
unistr('- Geben Sie eine Beschreibung in Erw\00E4gung gezogener alternativer L\00F6sungen oder Features bzw. verwendeter Workarounds an.'),
'',
'',
'______',
unistr('_**HINWEIS:** Um einen Vorgang mit einer Anwendung und/oder Seite zu verkn\00FCpfen, loggen Sie zuerst den Vorgang. Verkn\00FCpfen Sie anschlie\00DFend Anwendung und Seite \00FCber das Dropdown-Listenfeld **AKTIONEN**._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940189846303450)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'de'
,p_message_text=>'Eine Featureanforderung wurde erfasst.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940077046303450)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'de'
,p_message_text=>'Featureanforderung erfasst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940251187303450)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Eine **Featureanforderung** wurde im entsprechenden externen System erfasst.',
'',
'- Featuretrackingsystem: ',
'- Feature-ID: ',
'- URL zu Featuredefinition: ',
'',
'Kommentare:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941044495303451)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist eine Folgema\00DFnahme erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940971395303451)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Folgema\00DFnahme erforderlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98941146565303451)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('F\00FChren Sie folgende Ma\00DFnahmen aus: '),
'',
'1.',
'2.',
'3.',
'4.',
'',
'Kommentare: '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939266052303449)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'de'
,p_message_text=>'Template, das zum Stellen einer prozeduralen Frage verwendet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939126352303449)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'de'
,p_message_text=>'Anleitungen ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939349035303449)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Frage**',
unistr('- Geben Sie Ihre Frage oder Anforderung so eindeutig wie m\00F6glich an.'),
'',
'**Allgemeiner Kontext**',
'- Was versuchen Sie zu erreichen? ',
'',
'',
'- Wo haben Sie sonst noch nach Antworten gesucht, bzw. wen haben Sie sonst noch kontaktiert, um eine Antwort zu erhalten? ',
'',
'',
'**Umgebung** ',
'Bezieht sich diese Frage auf eine bestimmte Umgebung, Programmiersprache oder auf einen bestimmten anderen Bereich?',
'',
'______',
unistr('_**HINWEIS:** Um einen Vorgangmit einer Anwendung und/oder Seite zu verkn\00FCpfen, loggen Sie zuerst den Vorgang. Verkn\00FCpfen Sie anschlie\00DFend Anwendung und Seite \00FCber das Dropdown-Listenfeld **AKTIONEN**._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940796647303450)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'de'
,p_message_text=>'Referenzieren Sie ein bekanntes Problem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940662163303450)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'de'
,p_message_text=>'Bekanntes Problem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940832196303451)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Die Pr\00FCfung hat ergeben, dass es sich um ein bekanntes Problem handelt (siehe Details unten).'),
'',
'- Bugtrackingsystem: ',
'- Bug-ID: ',
'- URL zu Bug: ',
'',
'Kommentare: '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940455666303450)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'de'
,p_message_text=>'Anforderung weiterer Informationen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940374087303450)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'de'
,p_message_text=>'Weitere Informationen erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98940582497303450)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Zu diesem Vorgang sind weitere Informationen erforderlich:**',
'',
'Geben Sie die angeforderten Informationen unten ein. Ohne diese Informationen ist es schwierig, den Vorgang einzuordnen und weiter zu bearbeiten.',
'',
'',
'Kommentare:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939574969303450)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Bei diesem Vorgang wird keine Ma\00DFnahme ergriffen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939409812303449)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Ma\00DFnahme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98939626669303450)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nach sorgf\00E4ltiger Pr\00FCfung **wird keine weitere Ma\00DFnahme bez\00FCglich dieses Vorgangs ergriffen**. '),
'',
'Kommentare:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213311866302856)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'de'
,p_message_text=>'Textdatei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212217761302855)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'de'
,p_message_text=>'Textdateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209091961302853)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'de'
,p_message_text=>'dieser Vorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963822875303473)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>unistr('hat Anhang %0 %2 zu %1 hinzugef\00FCgt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962833513303473)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'de'
,p_message_text=>unistr('hat %0 %2 zu %1 hinzugef\00FCgt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964465624303474)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'de'
,p_message_text=>unistr('hat %0 %2 zu %1 hinzugef\00FCgt				')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963061980303473)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'de'
,p_message_text=>'hat %0 %2 zu %1 zugewiesen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963471003303473)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'de'
,p_message_text=>unistr('hat %0 %2 mit %1 verkn\00FCpft')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213595577302856)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'de'
,p_message_text=>unistr('hat einen Kommentar bearbeitet f\00FCr %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411258054303018)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'de'
,p_message_text=>'hat Vorgang bearbeitet: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964371206303474)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Der Vorgang wurde ausgeblendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963257570303473)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'de'
,p_message_text=>'hat %0 %2 als Duplikat von %1 markiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964285242303474)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 wurde ge\00F6ffnet von')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963958680303474)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'hat den Anhang %0 %2 aus %1 entfernt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962913126303473)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'de'
,p_message_text=>'hat %0 %2 aus %1 entfernt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964504286303474)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'de'
,p_message_text=>'hat %0 %2 aus %1 entfernt 			'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964073968303474)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'de'
,p_message_text=>unistr('hat den Status f\00FCr %0 %2 auf %1 gesetzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963681860303473)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'de'
,p_message_text=>'hat %1 %0 abonniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963172840303473)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'de'
,p_message_text=>'hat Zuweisung von %0 zu %1 %2 aufgehoben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963545344303473)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'de'
,p_message_text=>unistr('hat %1 die Anwendungs- und Seitenverkn\00FCpfung von %0 entfernt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963349060303473)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'de'
,p_message_text=>'hat Markierung von %0 als Duplikat %1 aufgehoben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98963706804303473)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'de'
,p_message_text=>'hat das Abonnement von %0 %1 aufgehoben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964159320303474)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'de'
,p_message_text=>'hat Duplikat von %0 %1 durch %2 markiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98209299909302853)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Nicht zugeordnet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186410446302835)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'de'
,p_message_text=>'Einblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98210092160302854)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'de'
,p_message_text=>'Subscription aufgehoben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998961845303503)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213152384302856)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'de'
,p_message_text=>'ZIP-Datei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98212044214302855)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'de'
,p_message_text=>'ZIP-Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170345198302823)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'de'
,p_message_text=>'%0 ist kein Geocode-Adresselement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308662102303759)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Element %0 nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199008561303662)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seitenpr\00FCfsumme bietet eine einfache M\00F6glichkeit, um festzustellen, ob dieselbe Seite anderswo bereitgestellt wird. Sie k\00F6nnen diese Pr\00FCfsumme vergleichen, um zu pr\00FCfen, ob eine \00DCbereinstimmung vorliegt. \00C4nderungen an auf dieser Seite verwendeten')
||unistr(' gemeinsamen Komponenten werden in dieser Pr\00FCfsumme nicht ber\00FCcksichtigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354652514303797)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'de'
,p_message_text=>'Info zur Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354469827303797)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Konfigurationsoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354550614303797)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'de'
,p_message_text=>'Theme-Stilauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187085565302836)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'de'
,p_message_text=>unistr('Nur Compact Font Format-(CFF-)Schriftarten mit einer Schriftart sind zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187187916302836)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'de'
,p_message_text=>unistr('Nur Compact Font Format-(CFF-)Schriftarten mit einem Top DICT-Element sind zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187210961302836)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'de'
,p_message_text=>unistr('Nur Compact Font Format-(CFF-)Schriftarten mit Zeichenfolgenformat Typ 2 sind zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199497517302845)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Die Schriftart wurde nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199320138302845)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'de'
,p_message_text=>unistr('Nur cmap-Tabellen vom Format 4 und 12 werden unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199776342302846)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Seitenausrichtung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199551120302846)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'de'
,p_message_text=>'Die PDF ist nicht initialisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199267381302845)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'de'
,p_message_text=>unistr('Keine g\00FCltigen cmap-Untertabellen in der Schriftart gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199682424302846)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'de'
,p_message_text=>unistr('Die PDF enth\00E4lt keine Seiten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634669120303194)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Beim Erstellen der PDF-Datei ist ein interner Fehler aufgetreten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205036074302850)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Dem Prozess "%0" wurde eine ung\00FCltige (nicht mehrzeilige) bearbeitbare Region zugewiesen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193162895302841)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen des n\00E4chsten oder vorherigen Prim\00E4rschl\00FCsselwertes nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862640395303385)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Der Webservice wurde nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400459435303009)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten des Prozesses.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219755459302861)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Application Express konnte die Anforderung wegen Ressourceneinschr\00E4nkungen der Datenbanksession nicht verarbeiten. Wiederholen Sie den Vorgang sp\00E4ter.'),
'<p/>',
'Details zu diesem Vorfall finden Sie unter Debugging-ID "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193991633302841)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'de'
,p_message_text=>'Beim Bereitstellen der Anwendung ist der folgende Fehler aufgetreten: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196698821302843)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0 wurde erfolgreich beim Remoteserver bereitgestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200375687302846)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0 wurde erfolgreich als %1 beim Remoteserver bereitgestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834890655303363)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Authentifizierung f\00FCr REST-f\00E4higen SQL-Service nicht erfolgreich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220012641302862)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei der Authentifizierung. Werteliste verwendet eine REST-f\00E4hige SQL-Datenquelle, die auf ung\00FCltige Webzugangsdaten verweist, die verhindern, dass Sie Spalteninformationen f\00FCr diese Werteliste \00E4ndern k\00F6nnen. Pr\00FCfen Sie die Zugangsdaten f\00FCr die')
||' Authentifizierung. '
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341176327303786)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'de'
,p_message_text=>unistr('Kommunikationsfehler. Beim Aufrufen der von der Werteliste referenzierten REST-f\00E4higen SQL-Datenquelle ist ein Problem aufgetreten, das verhindert, dass Sie Spalteninformationen f\00FCr die Werteliste bearbeiten k\00F6nnen. Pr\00FCfen Sie, ob die REST-f\00E4hige SQL')
||unistr('-Datenquelle ordnungsgem\00E4\00DF arbeitet und ob die entsprechenden Zugangsdaten f\00FCr die Authentifizierung korrekt sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836164922303364)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler auf Remoteserver: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810984119303345)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Angegebene ORDS-REST-f\00E4hige SQL-Instanz nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416765142303022)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'de'
,p_message_text=>'Server hat eine Umleitung zu: %0 gesendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711238296303264)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Anweisung ist l\00E4nger als 32.767 Byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729914115303280)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hallo, Application Express! Sie sind als #USER# angemeldet.',
'Der lokale Datenbankzeitstempel ist: #SYSDATE#.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955045714303466)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Sie bearbeiten den Alias f\00FCr das Standardschema des Workspace. Wenn Sie diesen Alias festlegen, wird auch das Pfadpr\00E4fix auf Workspace-Ebene ge\00E4ndert. Dies wirkt sich auf die URL f\00FCr alle definierten APEX-basierten RESTful Services aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708908420303262)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'de'
,p_message_text=>'%0 Referenzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946319701303455)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'de'
,p_message_text=>'Utilitys'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946497965303455)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Anwendungsutilitys\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953879594303465)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'de'
,p_message_text=>'Zur Seite gehen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953736566303465)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'de'
,p_message_text=>'Zu "Gemeinsame Komponenten" navigieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946505102303455)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'de'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946605662303455)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'de'
,p_message_text=>'App Builder-Aufgaben > '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946726231303455)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Anwendungselemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946825019303456)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Anwendungselemente\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946900117303456)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'de'
,p_message_text=>'Anwendungslogik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947061267303456)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947106211303456)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Sicherheitsauthentifizierungsschemas\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947287317303456)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947329062303456)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Sicherheitsautorisierungsschemas\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947463516303456)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'de'
,p_message_text=>'Navigationspfade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947511354303456)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Navigationspfade\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947603582303456)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Erstelloptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947739109303456)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Erstelloptionen\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947826917303456)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Komponenteneinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98947997641303456)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Komponenteneinstellungen\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948021842303457)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'de'
,p_message_text=>'Berechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948121614303457)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Anwendungsberechnungen\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948245134303457)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'de'
,p_message_text=>'Anwendungselement erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948360735303457)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschema erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948440512303457)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'de'
,p_message_text=>'Erstelloption erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948548844303457)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948663832303457)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Template erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948791807303457)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'de'
,p_message_text=>'Plug-in erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948834930303457)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'de'
,p_message_text=>'Theme erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98948944128303457)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>'Webzugangsdaten erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949051544303457)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'de'
,p_message_text=>'Datenladedefinitionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949146958303457)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Datenladedefinitionen\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949214250303457)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'de'
,p_message_text=>'Datenquellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949324968303458)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Definitionsattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949473921303458)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949598985303458)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'de'
,p_message_text=>'Berichtslayouts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949661348303458)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Berichtslayouts\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949735425303458)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'de'
,p_message_text=>'Legacy-Webservices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949827352303458)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Legacy-Webservices\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98949947078303458)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'de'
,p_message_text=>'Navigationslisten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950095814303458)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Klassische Navigationslisten\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950162715303458)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950205507303458)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Werteliste\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950367194303458)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950438311303458)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'de'
,p_message_text=>'Weitere Komponenten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950524325303459)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'de'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950678629303459)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Plug-ins\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950775921303459)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'de'
,p_message_text=>'Prozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950890822303459)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Anwendungsprozesse\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98950965837303459)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'de'
,p_message_text=>'Berichtsabfragen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951012498303459)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Berichtsabfragen\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951149973303459)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'de'
,p_message_text=>'Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951258591303459)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951342503303459)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Navigieren Sie zu: Gemeinsame Komponenten\005CREST-f\00E4hige SQL\005C%LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951495284303459)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'de'
,p_message_text=>'Sicherheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951547070303459)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Schutz f\00FCr den Sessionzustand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951633225303459)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Schutz f\00FCr den Anwendungsstatus festlegen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951833534303464)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponenten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951986749303464)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952095147303464)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'Shortcuts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952146934303464)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Shortcuts\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952224358303464)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten (Legacy)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952353475303464)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952492480303464)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\UI-Templates\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952592130303464)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'de'
,p_message_text=>'Themes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952682502303464)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\UI-Themes\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952791839303464)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952808903303465)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>'Webzugangsdaten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98952965222303465)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\Sicherheitswebzugangsdaten\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953082839303465)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953102576303465)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Navigieren Sie zu: Gemeinsame Komponenten\REST-Datenquellen\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953269580303465)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953329157303465)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'de'
,p_message_text=>'Objekt erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953491910303465)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'%LIST_ITEM_NAME% in SQL Workshop erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953514813303465)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'de'
,p_message_text=>'Skripteditor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953611938303465)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'de'
,p_message_text=>'SQL Workshop-Aufgaben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412409454303846)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenelement %0 basiert auf einer Datenbankspalte, das Attribut ''Verwendete Quelle'' ist jedoch auf ''Nur wenn aktueller Wert in Sessionzustand Null ist'' festgelegt. Dies ist sehr gef\00E4hrlich und kann dazu f\00FChren, dass Daten \00FCberschrieben werden, wenn ')
||unistr('mehrere Datens\00E4tze angezeigt und gespeichert werden. Legen Sie ''Verwendete Quelle'' immer auf ''Vorhandene Werte im Sessionzustand immer ersetzen'' fest.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349710028303793)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'de'
,p_message_text=>'Zugriff auf Sessionzustand ist deaktiviert, Lese-/Schreibversuch wurde blockiert. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233133033302872)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurde versucht, das Element %0 im Sessionzustand w\00E4hrend der show-Verarbeitung zu speichern. Das Element ist nur intern gesch\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225923009302866)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurde versucht, das Element %0 im Sessionstatus w\00E4hrend der accept-Verarbeitung zu speichern. Das Element ist nur intern gesch\00FCtzt oder ist kein Formularelement, bei dem ein POST-Vorgang ausgef\00FChrt werden kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225730165302866)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Die berechnete Pr\00FCfsumme f\00FCr Anforderungen, L\00F6schvorg\00E4nge beim Cacheinhalt oder Argumentnamen und -werte (%0) stimmt nicht mit der Pr\00FCfsumme \00FCberein, die an die show-Prozedur (%1) \00FCbergeben wurde.'),
'',
'Hinweis: Endbenutzer erhalten eine andere Fehlermeldung.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225207047302866)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Es wurde versucht, das Element %0 im Sessionzustand w\00E4hrend der Verarbeitung von "show" zu speichern. Die Schutzebene f\00FCr das Element gibt Folgendes an: '),
'"%1"',
'',
unistr('Es wurde keine Pr\00FCfsumme \00FCbergeben, oder die \00FCbergebene Pr\00FCfsumme ist f\00FCr ein Element mit der Schutzebene "%2" geeignet.'),
'',
'Hinweis: Endbenutzer erhalten eine andere Fehlermeldung.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400262180303009)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1022 Speichern von Attributen nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169852384302823)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'de'
,p_message_text=>'SDO_GEOMETRY-Wert kann nicht in GeoJSON konvertiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167317724302821)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'de'
,p_message_text=>'Text kann nicht in ein SDO_GEOMETRY-Objekt konvertiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168518533302821)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt keine g\00FCltige GeoJSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184166603302834)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Berechnen des Standardwertes f\00FCr Spalte #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185035756302834)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Verarbeiten des Prozesses zum L\00F6schen mehrerer Zeilen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427232457303030)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'de'
,p_message_text=>unistr('Die Pr\00FCfsumme-Spalte (FCS) ist erforderlich, wurde aber nicht angegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427440261303031)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurden keine Prim\00E4rschl\00FCsselwerte angegeben. Um Aktualisierungen ausf\00FChren zu k\00F6nnen, muss mindestens eine Zeile angegeben werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428248659303031)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurden keine Sekund\00E4rwerte f\00FCr die angegebene Sekund\00E4rschl\00FCsselspalte angegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567823757303143)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'de'
,p_message_text=>'Keine Daten auf tabellarischem Formular gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427131066303030)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Prim\00E4rschl\00FCsselspalte wurde nicht angegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428140543303031)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Sekund\00E4rschl\00FCsselspalte wurde in der Auswahlliste der Abfrage nicht ermittelt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427002712303030)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'de'
,p_message_text=>'Der Tabellenname wurde nicht angegeben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426964781303030)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('Der Tabelleneigent\00FCmer wurde nicht angegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448152917303047)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten des Prozesses zum Update mehrerer Zeilen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208318687302852)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'de'
,p_message_text=>'Theme "%0" kann nicht in Anwendung "%1" kopiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405927692303841)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Das importierte Theme ist nicht mit dem aktuellen Theme kompatibel.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388023301303825)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'de'
,p_message_text=>unistr('Theme-Nummer ist ung\00FCltig oder Theme ist kein aktuelles UI-Theme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348855019303793)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spalten "Prim\00E4rschl\00FCssel" und "\00DCbergeordneter Schl\00FCssel" sind zum Berechnen der Hierarchie erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348999245303793)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Die Spalten "Knotenebene" und "Knotenstatus" sind erforderlich, wenn die Hierarchie nicht berechnet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367213025303808)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Darstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126279542303605)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340778605302957)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'de'
,p_message_text=>'Dunkelmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340816015302958)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126145688303605)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'de'
,p_message_text=>'Heller Modus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769619418303313)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Benutzeroberfl\00E4che aus der Liste unten:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771969100303315)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 - Benutzeroberfl\00E4chenauswahl')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311431437302936)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'de'
,p_message_text=>unistr('Unberechtigter Zugriff (Package-Variable f\00FCr die Sicherheitsgruppe kein festgelegt).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311890651302936)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzerinformationen k\00F6nnen nicht abgerufen werden. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297626079302925)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer %0 ben\00F6tigt ADMIN-Berechtigungen f\00FCr die Ausf\00FChrung dieses Vorgangs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311706386302936)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'de'
,p_message_text=>'Der Benutzer %0 hat keine E-Mail-Adresse angegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267507314302900)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'de'
,p_message_text=>'Unberechtigter Zugriff.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311670171302936)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Benutzer %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226620787302867)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Der Validierung "%0" wurde eine ung\00FCltige (nicht mehrzeilige) bearbeitbare Region zugewiesen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400369313303009)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Validierung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350176066303794)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'de'
,p_message_text=>'Application Express kann ein Datenprofil aus den Antwortdaten des Typs: %0 nicht berechnen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816822418303350)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'de'
,p_message_text=>'Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816741576303350)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336720728303783)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'de'
,p_message_text=>unistr('Der Filterausdruck ist keine g\00FCltige JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329960695303777)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Filter wird von Oracle REST Data Services nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708811463303261)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'de'
,p_message_text=>'Paginierungs-URL-Parameter "%0" steht mit einem REST-Quellenparameter in Konflikt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811785833303346)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'de'
,p_message_text=>'HTTP 200: Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811800293303346)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'de'
,p_message_text=>'HTTP 201: Erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811210726303345)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'de'
,p_message_text=>unistr('HTTP 400: Ung\00FCltige Anforderung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811024983303345)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'de'
,p_message_text=>'HTTP 401: Nicht autorisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811360298303345)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'de'
,p_message_text=>unistr('HTTP 403: Unzul\00E4ssig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811132495303345)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'de'
,p_message_text=>'HTTP 404: Nicht gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811411416303345)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'de'
,p_message_text=>unistr('HTTP 405: Methode nicht zul\00E4ssig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169115956302822)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'de'
,p_message_text=>'HTTP 407: Proxyauthentifizierung erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169431132302822)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'de'
,p_message_text=>'HTTP 409: Konflikt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169216231302822)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'de'
,p_message_text=>unistr('HTTP 412: Voraussetzung nicht erf\00FCllt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169379065302822)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'de'
,p_message_text=>'HTTP 428: Voraussetzung erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811569999303345)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'de'
,p_message_text=>'HTTP 500: Interner Serverfehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811681652303346)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'de'
,p_message_text=>unistr('HTTP 502: Ung\00FCltiges Gateway')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350550668303794)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'de'
,p_message_text=>unistr('HTTP 503: Service nicht verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350624210303794)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'de'
,p_message_text=>'HTTP 504: Gatewaytimeout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192774245303658)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'de'
,p_message_text=>unistr('REST-Datenquelle hat einen HTTP-Fehler zur\00FCckgegeben: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810874904303345)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquelle nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366663707302977)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenselektor "%0" hat kein Objektarray ausgew\00E4hlt, das als Tabelle behandelt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366739426302977)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenselektor "%0" hat kein Objekt ausgew\00E4hlt, das als einzelne Zeile behandelt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172325851302825)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Der Ratengrenzwert der REST-Datenquelle (%0 Anforderungen in %1 Sekunden) wurde \00FCberschritten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161326437302815)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'de'
,p_message_text=>unistr('Der Ratengrenzwert der REST-Datenquelle (%0 Anforderungen in %1 Sekunden) wurde \00FCberschritten, und die erforderliche Wartezeit ist zu lang.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192679039303657)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'de'
,p_message_text=>'Erforderlicher IN-REST-Quellparameter "%0" des Typs "%1" muss einen Wert haben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110646744303593)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Antworttext ist zu gro\00DF f\00FCr die Anzeige.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776068128303318)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Legacy-ORDS-REST-Service verwendet eine kleine feste Seitengr\00F6\00DFe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175971221302827)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Mit diesem API-Aufruf werden die Tabellenspalten dynamisch mit dem ',
unistr('-- Datenprofil der REST-Datenquelle synchronisiert. Dazu werden ALTER TABLE-Anweisungen ausgef\00FChrt. '),
unistr('-- Wenn der Datentyp einer Spalte nicht mit ALTER TABLE ge\00E4ndert werden kann, wird eine '),
unistr('-- Fehlermeldung ausgel\00F6st.'),
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174809804302827)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Datenprofil\00E4nderungen k\00F6nnen nicht automatisch angewendet werden. Lokale Tabellenspalten m\00FCssen manuell angepasst werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176018901302828)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- Ab %0 wird dabei Folgendes ausgef\00FChrt:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174090131302826)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die Synchronisierungsmethode "Konsolidieren" muss ein Prim\00E4rschl\00FCssel im Datenprofil definiert sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174309773302826)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Die lokale Tabelle und das Datenprofil weisen keine gemeinsamen Spalten auf.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160964595302815)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'de'
,p_message_text=>'Job abgebrochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174508233302826)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174690967302827)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('Unvollst\00E4ndig (Anforderungsgrenzwert \00FCberschritten)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174782180302827)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'de'
,p_message_text=>unistr('Job wird bereits ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161893411302816)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'de'
,p_message_text=>unistr('Wird ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161941192302816)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'de'
,p_message_text=>'Geplant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174432238302826)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174179212302826)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'de'
,p_message_text=>'Synchronisierungsschritt %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174264010302826)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'de'
,p_message_text=>'%0 (Neu)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658927827303213)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'de'
,p_message_text=>'Testvorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730024194303280)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Timeout wurde beim Abrufen aller REST-Quellendaten \00FCberschritten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705943926303259)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'de'
,p_message_text=>unistr('Die aktuellen lokalen SQL-Filter erfordern zu viele "N\00E4chste Seite"-Anforderungen an den REST-Service.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775917865303318)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Feste Seitengr\00F6\00DFe f\00FCr Legacy-ORDS-REST-Service ist unbekannt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482341474303075)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zur Admin-Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456842493303054)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478439001303072)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'de'
,p_message_text=>'Auskommentiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462907638303059)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463285052303059)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'de'
,p_message_text=>unistr('%0 hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463692009303060)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463794982303060)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463872055303060)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462607776303059)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen anwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462792197303059)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462869812303059)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462585371303059)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'de'
,p_message_text=>'Erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451824639303050)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463070078303059)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'de'
,p_message_text=>unistr('Markierte Elemente l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463125776303059)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463317904303059)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'de'
,p_message_text=>'Fertigstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451617112303050)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'de'
,p_message_text=>'Los'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452377184303051)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'de'
,p_message_text=>'Daten laden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463483658303060)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'de'
,p_message_text=>'Anmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452005457303050)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451917218303050)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451711335303050)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452182636303050)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'de'
,p_message_text=>'Speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452243029303050)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463989915303060)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98463567880303060)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'de'
,p_message_text=>'Details anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456769490303054)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'de'
,p_message_text=>'Label %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475967952303070)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'de'
,p_message_text=>'Datenreihe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468371699303064)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'de'
,p_message_text=>'Rollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456535178303054)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467373347303063)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4t pro Stunde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466601105303062)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-Sessions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456457050303054)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'Anhang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455696917303053)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'de'
,p_message_text=>'Automatisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466229630303062)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Durchschnittlich verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465663728303061)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'de'
,p_message_text=>'Komponentenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467228891303063)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Kontext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464540616303060)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'de'
,p_message_text=>'Aktueller Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464276250303060)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466545814303062)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455425775303053)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465309849303061)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468249017303063)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'de'
,p_message_text=>'Beendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465974824303062)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455582117303053)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468187893303063)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'de'
,p_message_text=>'Fehlerzeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464084764303060)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'de'
,p_message_text=>'Feature'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456116847303054)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455911917303053)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'de'
,p_message_text=>'Eingereicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468551775303064)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'de'
,p_message_text=>'Eingereicht von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467022767303062)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'de'
,p_message_text=>'Ganze Seitenansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465827502303062)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'de'
,p_message_text=>'IR-Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464684752303061)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464923029303061)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Letzte Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466105976303062)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Maximal verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466332699303062)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Verstrichen, Medianwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467778232303063)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Meldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467823360303063)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'de'
,p_message_text=>'Meldungstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466021158303062)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Mindestens verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467639661303063)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'de'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465763752303061)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'de'
,p_message_text=>'Anzahl Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467116670303063)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'de'
,p_message_text=>'Vorkommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465479378303061)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467497372303063)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'de'
,p_message_text=>'Seitenereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465509069303061)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'de'
,p_message_text=>'Modus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465076910303061)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466729390303062)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466945611303062)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenbestandteil-Ansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467915302303063)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Wert des Prim\00E4rschl\00FCssels ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456003766303053)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'de'
,p_message_text=>'Bewertung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468460234303064)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'de'
,p_message_text=>'Grund'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456258589303054)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'de'
,p_message_text=>'Antwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98467581957303063)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'de'
,p_message_text=>'Abgerufene Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455842799303053)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'de'
,p_message_text=>'Geplant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455726435303053)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'de'
,p_message_text=>'Gestartet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464156256303060)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468095756303063)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'de'
,p_message_text=>'Erfolgreiche Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465235984303061)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'de'
,p_message_text=>'Zeitstempel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466809661303062)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen gesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464417310303060)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464324383303060)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98465101883303061)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464875103303061)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456322129303054)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'de'
,p_message_text=>'Benutzer-Agent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98464756545303061)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98466417432303062)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>'Gewichtete Performance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449075933303048)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'de'
,p_message_text=>'Dialog geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461904723303058)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'de'
,p_message_text=>'Dialog abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462421475303059)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'de'
,p_message_text=>unistr('Filter \00E4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462088481303058)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che erstellen - Dialog geschlossen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462176775303058)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'de'
,p_message_text=>'Bericht bearbeiten - Dialog geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462279915303059)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'de'
,p_message_text=>unistr('Suche ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98462379789303059)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451563077303050)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'de'
,p_message_text=>'Datei-Zeichensatz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451123202303050)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'de'
,p_message_text=>'Rollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474713676303069)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die Zugriffskontrolle aktiviert ist, k\00F6nnen Administratoren den Zugriff auf bestimmte Anwendungsfeatures f\00FCr authentifizierte Benutzer einschr\00E4nken. Diese Anwendung unterst\00FCtzt die folgenden drei Rollen: Leseberechtigter, Beitragender und Adm')
||'inistrator.<p>',
'<ul>',
unistr('  <li><strong>Leseberechtigte</strong> haben schreibgesch\00FCtzten Zugriff auf alle Informationen und k\00F6nnen Berichte anzeigen.</li>'),
unistr('  <li><strong>Beitragende</strong> k\00F6nnen Informationen erstellen, bearbeiten und l\00F6schen sowie Berichte anzeigen.</li>'),
unistr('  <li><strong>Administratoren</strong> k\00F6nnen zus\00E4tzlich zu den Berechtigungen der Beitragenden auch die Anwendung konfigurieren.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474523709303068)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'de'
,p_message_text=>'Jeder authentifizierte Benutzer darf auf diese Anwendung zugreifen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474686721303069)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie <strong>Nein</strong>, wenn alle Benutzer in der Access Control-Liste definiert sind. W\00E4hlen Sie <strong>Ja</strong>, wenn authentifizierte Benutzer, die nicht in der Access Control-Liste aufgef\00FChrt sind, die Anwendung ebenfalls verwenden ')
||unistr('d\00FCrfen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472851571303067)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Zu verwendende Datums-/Zahlenformate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472988644303067)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, ob benutzerdefinierte Formatmasken oder Standardformatmasken verwendet werden sollen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475385000303069)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'Anhang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474315993303068)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'de'
,p_message_text=>'Automatisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473061149303067)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'de'
,p_message_text=>'Datei-Zeichensatz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471801366303066)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'de'
,p_message_text=>unistr('Durch Begrenzungszeichen getrennte Daten kopieren und einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473124126303067)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrungssymbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473244773303067)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Ihre Daten ein internationales W\00E4hrungssymbol enthalten, geben Sie dieses hier ein. Beispiel: Wenn Ihre Daten "&euro;1,234.56" oder "&yen;1,234.56" enthalten, geben Sie "&euro;" oder "&yen;" ein. Andernfalls werden die Daten nicht ordnungsgem\00E4\00DF ')
||'geladen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471516126303066)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'de'
,p_message_text=>'Importieren aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473571481303068)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'de'
,p_message_text=>'Dezimalzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473609276303068)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Das Dezimalzeichen trennt bei einer Zahl die Ganzzahl von den Dezimalstellen.</p><p> Sie k\00F6nnen ein beliebiges Zeichen als Dezimalzeichen festlegen. Das angegebene Zeichen muss ein Ein-Byte-Zeichen sein, und das Dezimalzeichen darf nicht mit dem G')
||unistr('ruppentrennzeichen identisch sein. Bei dem Zeichen kann es sich um ein Leerzeichen handeln. Numerische Zeichen oder folgende Sonderzeichen sind nicht zul\00E4ssig:</p>'),
'<ul class="noIndent">',
'<li>Plus (+)</li>',
'<li>Bindestrich (-)</li>',
'<li>Kleiner-als-Zeichen (<)</li>',
unistr('<li>Gr\00F6\00DFer-als-Zeichen (>)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450701210303049)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475479759303069)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Anh\00E4nge aktivieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472169091303067)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'de'
,p_message_text=>'Optional umschlossen von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451057106303049)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie ein Begrenzungszeichen ein. Dieses Zeichen bestimmt den Anfangs- und Endwert zur Begrenzung eines Datenwertes. Wenn Sie ein Begrenzungszeichen angeben, ignoriert Data Workshop Leerzeichen vor dem Anfangs- und Endwert eines Datenwertes. Sie '
||unistr('k\00F6nnen mit dieser Option auch einen Datenwert mit dem angegebenen Begrenzungszeichen umschlie\00DFen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475204349303069)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'de'
,p_message_text=>'Erfahrung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472517172303067)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'de'
,p_message_text=>'Fehlerhafte Zeilen:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451237247303050)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475571182303069)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'de'
,p_message_text=>'Eingereicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471646423303066)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'de'
,p_message_text=>'Dateiname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471755367303066)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Name der Datei, die hochgeladen werden soll'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472239593303067)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie dieses Kontrollk\00E4stchen, wenn Ihre Daten Spaltennamen in der ersten Zeile enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473314880303068)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'de'
,p_message_text=>'Gruppentrennzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473409125303068)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ein Gruppentrennzeichen trennt Gruppen von Ganzzahlen, beispielsweise Tausender und Millionen.</p>',
unistr('<p>Sie k\00F6nnen ein beliebiges Zeichen als Gruppentrennzeichen verwenden. Das angegebene Zeichen muss ein Ein-Byte-Zeichen sein und darf nicht einem anderen Dezimalzeichen identisch sein. Bei dem Zeichen kann es sich um ein Leerzeichen handeln. Numeris')
||unistr('che Zeichen oder folgende Sonderzeichen sind nicht zul\00E4ssig:</p><ul class="noIndent">'),
'<li>Plus (+)</li>',
'<li>Bindestrich (-)</li>',
'<li>Kleiner-als-Zeichen (<)</li>',
unistr('<li>Gr\00F6\00DFer-als-Zeichen (>)</li> </ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472327075303067)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Eingef\00FCgte Zeilen:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451357554303050)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450936570303049)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'de'
,p_message_text=>'Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475610162303069)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'de'
,p_message_text=>'Bewertung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471396324303066)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzernamen speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471410516303066)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen aktivieren, speichert die Anwendung Ihren Benutzernamen in einem dauerhaften Browsercookie namens "LOGIN_USERNAME_COOKIE".'),
unistr('Beim n\00E4chsten Aufruf der Anmeldeseite'),
unistr('wird das Benutzernamenfeld automatisch mit diesem Wert gef\00FCllt.'),
'</p>',
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen deaktivieren und Ihr Benutzername bereits im Cookie gespeichert wurde,'),
unistr('\00FCberschreibt die Anwendung ihn mit einem leeren Wert.'),
unistr('Sie k\00F6nnen auch die Entwicklertools des Browsers verwenden, um das Cookie komplett zu entfernen.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475746194303069)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'de'
,p_message_text=>'Antwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472685888303067)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Zu pr\00FCfende Zeile(n):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450563447303049)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450666016303049)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'de'
,p_message_text=>'Suchen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471986868303066)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'de'
,p_message_text=>'Trennzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472074004303066)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Spaltentrennzeichen ein. Verwenden Sie <code>\005Ct</code> f\00FCr Tabulatoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472783253303067)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigen Sie erweiterte Einstellungen f\00FCr das Laden von Daten an: W\00E4hrungssymbol, Dezimalzeichen, Dateicodierung oder Datumsformate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474486341303068)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'de'
,p_message_text=>'Gestartet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98451404274303050)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474086989303068)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'de'
,p_message_text=>'Endbenutzer-Theme-Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474186542303068)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn diese Option aktiviert ist, d\00FCrfen Endbenutzer ihren eigenen Theme-Stil \00FCber den Link "Anpassen" ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473874398303068)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'de'
,p_message_text=>'Desktop-Theme-Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473923969303068)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Standard-Theme-Stil gilt f\00FCr alle Benutzer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98473704486303068)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'de'
,p_message_text=>'Zeitrahmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98472474803303067)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'de'
,p_message_text=>'Aktualisierte Zeilen:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450829248303049)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474837406303069)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'de'
,p_message_text=>'Benutzernamen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475077630303069)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Benutzernamen getrennt durch Komma, Semikolon oder Leerzeichen ein. Vorhandene oder doppelte Benutzernamen werden automatisch ignoriert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474938248303069)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'de'
,p_message_text=>'Benutzernamen hier eingeben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475127049303069)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Benutzernamenformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98475897159303070)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'de'
,p_message_text=>'Benutzer-Agent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98474241056303068)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'de'
,p_message_text=>'Anzeigen als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453534191303051)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453475208303051)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tsberichte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478155718303071)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsadministration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453381441303051)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungskonfiguration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453779576303052)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453669323303052)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478074245303071)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Seitennavigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453870156303052)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'de'
,p_message_text=>'Jobberichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477982792303071)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478253736303071)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453226448303051)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478384650303072)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'de'
,p_message_text=>'Komponente verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454006502303052)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'de'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454167151303052)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'de'
,p_message_text=>'Abmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453925434303052)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'de'
,p_message_text=>'Schritt %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476140503303070)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile pro Seite melden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477616170303071)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477019112303070)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'de'
,p_message_text=>unistr('Diagrammseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477890706303071)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'de'
,p_message_text=>'Geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476392283303070)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'de'
,p_message_text=>unistr('Kopieren und einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476664769303070)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'de'
,p_message_text=>'Standardformatmasken der Anwendung verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476778097303070)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzerdefinierte Formate f\00FCr hochgeladene Spalten bereitstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477153045303071)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Adressen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476883597303070)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Endbenutzer d\00FCrfen Theme-Stil ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476439047303070)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Erste Zeile enth\00E4lt Spaltennamen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477455556303071)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'de'
,p_message_text=>'Negativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477309146303071)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'de'
,p_message_text=>'Neutral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477578549303071)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'de'
,p_message_text=>'Keine Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477788035303071)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98477224263303071)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'de'
,p_message_text=>'Positiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476903873303070)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Berichtsseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476588263303070)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Einstellungen verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476283872303070)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'de'
,p_message_text=>'Datei hochladen, durch Kommas (*.csv) oder Tabulatoren getrennt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480218548303073)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'de'
,p_message_text=>unistr('Dashboard-Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454790964303052)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere Benutzer hinzuf\00FCgen - Schritt %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454938026303053)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479819580303073)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'de'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479988739303073)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf der Administrationsseite k\00F6nnen Anwendungseigent\00FCmer (Administratoren) die Anwendung konfigurieren und allgemeine anwendungsweit verwendete Daten verwalten.'),
unistr('Durch Auswahl einer der verf\00FCgbaren Einstellungen k\00F6nnen Administratoren potenziell \00E4ndern, wie die Anwendung angezeigt wird und/oder welche Features f\00FCr die Endbenutzer zur Verf\00FCgung stehen.</p>'),
unistr('<p>Der Zugriff auf diese Seite sollte ausschlie\00DFlich f\00FCr Administratoren m\00F6glich sein.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480450946303073)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'de'
,p_message_text=>'Automatisierungslog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480568503303073)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Diese Seite enth\00E4lt einen interaktiven Bericht des Automatisierungslogs.</p>'),
unistr('<p>Pr\00FCfen Sie die protokollierten Informationen zu vorherigen Automatisierungsausf\00FChrungen: Das Log enth\00E4lt Start- und Endzeitstempel sowie Details zu verarbeiteten Zeilen (erfolgreich und mit Fehlern). F\00FChren Sie einen Drilldown in "Meldungen" durch')
||unistr(', um einzelne Meldungen f\00FCr verarbeitete Zeilen anzuzeigen.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480195142303073)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Konfigurationseinstellungen erm\00F6glichen Ihnen, bestimmte Funktionen f\00FCr Endbenutzer entweder verf\00FCgbar zu machen (zu aktivieren) oder nicht verf\00FCgbar zu machen (zu deaktivieren).</p>'),
unistr('<p>Wenn eine bestimmte Funktion nicht 100-prozentig einsatzbereit ist oder vor\00FCbergehend entfernt werden muss, klicken Sie auf <strong>Deaktiviert</strong>.'),
unistr('Wenn Sie wieder verf\00FCgbar gemacht werden soll, klicken Sie einfach auf <strong>Aktiviert</strong>.</p>'),
unistr('<p><em><strong>Hinweis:</strong> An dieser Stelle vorgenommene \00C4nderungen werden f\00FCr einzelne Endbenutzer, die gerade die Anwendung ausf\00FChren, nicht angezeigt. Wenn sich der Endbenutzer bei der Anwendung ab- und anschlie\00DFend wieder anmeldet, werden d')
||unistr('ie ge\00E4nderten Featureeinstellungen aufgerufen.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481562237303074)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'de'
,p_message_text=>'Access Control konfigurieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481617405303074)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Treffen Sie die passende Auswahl f\00FCr authentifizierte Benutzer.<br>'),
unistr('Wenn Sie <strong>Nein</strong> w\00E4hlen, wird die Anwendung sicherer, da nur bestimmte Benutzer auf die Anwendung zugreifen k\00F6nnen.'),
unistr('Wenn Ihre Anwendung jedoch von einer gro\00DFen Benutzercommunity verwendet und die Verwaltung der Benutzer m\00FChselig wird, kann es ratsam sein, <strong>Ja</strong> zu w\00E4hlen und nur Anwendungsadministratoren und eventuell Beitragende einzugeben.<br>'),
unistr('Wenn Sie <strong>Ja</strong> w\00E4hlen, m\00FCssen Sie auch festlegen, wie Benutzer, die nicht in der Liste enthalten sind, behandelt werden.</p>'),
unistr('<p>W\00E4hlen Sie aus, ob f\00FCr Benutzernamen E-Mail-Adressen oder alphanumerische Werte angegeben werden m\00FCssen.<br>'),
unistr('In der Regel empfiehlt es sich, f\00FCr diese Einstellung <strong>E-Mail-Adresse</strong> festzulegen, wenn Ihre Anwendung ein zentrales Authentifizierungsschema verwendet (bzw. daf\00FCr konfiguriert wird), beispielsweise Oracle Access Manager oder SSO.</p>'),
unistr('<p><em><strong>Hinweis:</strong> Diese Anwendung unterst\00FCtzt die folgenden drei Zugriffsebenen: Leseberechtigter, Beitragender und Administrator.'),
'<ul>',
unistr('  <li><strong>Leseberechtigte</strong> haben schreibgesch\00FCtzten Zugriff auf alle Informationen und k\00F6nnen Berichte anzeigen.</li>'),
unistr('  <li><strong>Beitragende</strong> k\00F6nnen Informationen erstellen, bearbeiten und l\00F6schen sowie Berichte anzeigen.</li>'),
unistr('  <li><strong>Administratoren</strong> k\00F6nnen zus\00E4tzlich zu den Berechtigungen der Beitragenden die Anwendung konfigurieren, indem sie auf den Administrationsbereich der Anwendung zugreifen.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481011785303074)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'de'
,p_message_text=>'Anwendungsfehlerlog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481114472303074)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite bietet einen interaktiven Bericht zu allen unerwarteten Fehlern, die von dieser Anwendung protokolliert werden.</p>',
unistr('<p>Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen. Klicken Sie auf die Schalt')
||unistr('fl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481881888303074)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481991853303075)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Feedbackeinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482075838303075)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p><strong>Anh\00E4nge aktivieren</strong>: Wenn diese Option auf "Ja" gesetzt ist, k\00F6nnen Benutzer zus\00E4tzlich zum Feedback einen Anhang hochladen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454825341303053)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'de'
,p_message_text=>'Feedback weitergeleitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454527064303052)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'de'
,p_message_text=>'Globale Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454218768303052)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'de'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478954729303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'<p>Klicken Sie von einer beliebigen Seite der Anwendung aus auf das Feedbacksymbol ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) in der Navigationsleiste, um den Anwendungsadministratoren Feedback zu geben.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478798354303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Dies ist die Homepage der Anwendung. Klicken Sie auf die Karten, um auf die verschiedenen Seiten in der Anwendung zuzugreifen, oder verwenden Sie das Navigationsmen\00FC am seitlichen Rand der Seite.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479303801303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Klicken Sie in der Navigationsleiste auf das Dropdown-Men\00FC mit Ihrem Namen, um sich von der Anwendung abzumelden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479278401303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Klicken Sie in der Navigationsleiste auf das Benutzermen\00FC ( <span class="fa fa-user" aria-hidden="true"></span> ), um Ihre Zeitzonenvoreinstellung zu aktualisieren und um sich von der Anwendung abzumelden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478676503303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'de'
,p_message_text=>'Homepage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478890746303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Dies ist die Homepage der Anwendung. Klicken Sie auf die Karten, um auf die verschiedenen Seiten in der Anwendung zuzugreifen, oder verwenden Sie das Navigationsmen\00FC am oberen Rand der Seite.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479144593303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Klicken Sie in der Navigationsleiste (oben rechts auf der Seite) auf das Benutzermen\00FC ( <span class="fa fa-user" aria-hidden="true"></span> ), um auf Ihr Benutzerprofil zuzugreifen und um sich von der Anmeldung abzumelden.<br>'),
unistr('Wenn Sie auf <strong>Mein Profil anzeigen</strong> klicken, k\00F6nnen Sie anschlie\00DFend auf <strong>Profil aktualisieren</strong> klicken, um Ihre pers\00F6nlichen Daten einzugeben und ein Foto oder einen Avatar hochzuladen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479020953303072)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Klicken Sie in der Navigationsleiste auf das Benutzermen\00FC ( <span class="fa fa-user" aria-hidden="true"></span> ), um auf Ihr Benutzerprofil zuzugreifen, Ihre Zeitzonenvoreinstellung zu aktualisieren und um sich von der Anmeldung abzumelden.<br>'),
unistr('Wenn Sie auf <strong>Mein Profil anzeigen</strong> klicken, k\00F6nnen Sie anschlie\00DFend auf <strong>Profil aktualisieren</strong> klicken, um Ihre pers\00F6nlichen Daten einzugeben und ein Foto oder einen Avatar hochzuladen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479512722303073)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem interaktiven Grid k\00F6nnen Sie Daten direkt einf\00FCgen, aktualisieren und l\00F6schen.<br>'),
unistr('  F\00FCgen Sie eine neue Zeile ein, indem Sie auf die Schaltfl\00E4che "Zeile hinzuf\00FCgen" klicken.<br>'),
unistr('  Um Datenwerte zu aktualisieren, doppelklicken Sie auf eine Zelle, oder klicken Sie auf die Schaltfl\00E4che <strong>Bearbeiten</strong>, wie bei der Bearbeitung von Daten in einer  Kalkulationstabelle.</p>'),
'',
unistr('<p>\00DCber das Men\00FC "Zeilenaktionen" (<span class="fa fa-bars" aria-hidden="true"></span>) am Anfang des Berichts k\00F6nnen Sie ausgew\00E4hlte Zeilen duplizieren, l\00F6schen, aktualisieren oder wiederherstellen.<br>'),
unistr('  Wenn Sie das Men\00FC "Zeilenaktionen" f\00FCr einzelne Zeilen verwenden, k\00F6nnen Sie auf die Single-Row-Ansicht zugreifen oder eine neue Zeile hinzuf\00FCgen.</p>'),
'',
unistr('<p>Geben Sie zum Suchen von Daten einen Suchbegriff in das Dialogfeld "Suchen" ein, oder klicken Sie auf die Spalten\00FCberschriften, um die zur\00FCckgegebenen Datens\00E4tze einzuschr\00E4nken.</p>'),
'',
unistr('<p>Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreiche Funktionen ausf\00FChren, beispielsweise die angezeigten/ausgeblendeten Spalten und ihre Anzeigereihenfolge ausw\00E4hlen sowie mehrere Daten- und Formatfunktionen ausf')
||unistr('\00FChren. Dar\00FCber hinaus k\00F6nnen Sie mit der Diagrammoption eine zus\00E4tzliche Datenansicht definieren.</p>'),
'',
unistr('<p>Wenn Sie Ihre Anpassungen speichern m\00F6chten, w\00E4hlen Sie "Bericht" aus, oder klicken Sie auf "Herunterladen", um die Daten zu entladen.<p>'),
'',
unistr('<p>Weitere Informationen erhalten Sie, wenn Sie unten im Aktionsmen\00FC auf "Hilfe" klicken.</p> '),
'',
unistr('<p>Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um das interaktive Grid auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479604781303073)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zum Suchen von Daten einen Suchbegriff in das Dialogfeld "Suchen" ein, oder klicken Sie auf die Spalten\00FCberschriften, um die zur\00FCckgegebenen Datens\00E4tze einzuschr\00E4nken.</p>'),
'',
unistr('<p>Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreiche Funktionen ausf\00FChren, beispielsweise die angezeigten/ausgeblendeten Spalten und ihre Anzeigereihenfolge ausw\00E4hlen sowie mehrere Daten- und Formatfunktionen ausf')
||unistr('\00FChren. Dar\00FCber hinaus k\00F6nnen Sie mit der Diagrammoption eine zus\00E4tzliche Datenansicht definieren.</p>'),
'',
unistr('<p>Wenn Sie Ihre Anpassungen speichern m\00F6chten, w\00E4hlen Sie "Bericht", oder klicken Sie auf "Herunterladen", um die Daten zu entladen.<p>'),
'<br>',
unistr('<p>Weitere Informationen erhalten Sie, wenn Sie unten im Aktionsmen\00FC auf "Hilfe" klicken.</p>'),
'',
unistr('<p>Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479459789303073)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zum Suchen von Daten einen Suchbegriff in das Dialogfeld "Suchen" ein, oder klicken Sie auf die Spalten\00FCberschriften, um die zur\00FCckgegebenen Datens\00E4tze einzuschr\00E4nken.</p>'),
'',
unistr('<p>Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreiche Funktionen ausf\00FChren, beispielsweise die angezeigten/ausgeblendeten Spalten und ihre Anzeigereihenfolge ausw\00E4hlen sowie mehrere Daten- und Formatfunktionen ausf')
||unistr('\00FChren. Dar\00FCber hinaus k\00F6nnen Sie mit den Optionen "Diagramm", "Gruppieren nach" und "Pivot" zus\00E4tzliche Datenansichten definieren.</p>'),
'',
unistr('<p>Wenn Sie Ihre Anpassungen speichern m\00F6chten, w\00E4hlen Sie "Bericht", oder klicken Sie auf "Herunterladen", um die Daten zu entladen. Geben Sie Ihre E-Mail-Adresse und den Zeitrahmen f\00FCr das Abonnement ein, damit Ihnen die Daten regelm\00E4\00DFig zugesendet')
||' werden.<p>',
'',
unistr('<p>Weitere Informationen erhalten Sie, wenn Sie unten im Aktionsmen\00FC auf "Hilfe" klicken.</p>'),
'',
unistr('<p>Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454343860303052)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'de'
,p_message_text=>'Anmeldeseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454400515303052)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'de'
,p_message_text=>'%0 - Anmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481269977303074)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'de'
,p_message_text=>'Logmeldungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482131507303075)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482272190303075)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Endbenutzer k\00F6nnen Feedback auf allen normalen Seiten der Anwendung eingeben.</p>'),
'<p>Dieser Bericht zeigt das eingegebene Feedback, die Antworten der Administratoren und den Feedbackstatus.</p>',
'<p>Klicken Sie auf das Symbol "Bearbeiten" (gelber Stift), um eine Antwort einzugeben oder den Feedbackstatus zu aktualisieren.</p>',
unistr('<p><em><strong>Hinweis:</strong> Wenn Feedbackempf\00E4nger definiert wurden, wird weitergeleitetes Feedback auch per E-Mail an die in der Liste der Feedbackempf\00E4nger aufgef\00FChrten E-Mail-Adressen gesendet.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481301636303074)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'de'
,p_message_text=>'Benutzerzugriff verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481450402303074)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite zeigt einen Bericht zu den Anwendungsbenutzern und den erteilten Zugriffsebenen.</p>',
unistr('<p>Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen.<br>'),
unistr('Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>'),
unistr('<p>Klicken Sie auf das Symbol "Bearbeiten" (gelber Stift), um die Benutzerdetails und die Zugriffsebene zu bearbeiten oder um den Benutzer zu l\00F6schen.</p>'),
unistr('<p>Klicken Sie am oberen Rand des Berichts auf <strong>Benutzer hinzuf\00FCgen</strong>, um einen neuen Benutzer und dessen Zugriffsebene hinzuzuf\00FCgen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98481714541303074)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In diesem Formular geben Sie Benutzer mit ihrer E-Mail-Adresse und Zugriffsebene ein.',
'Die unter <em>Zugriffskontrolle konfigurieren</em> definierten Einstellungen bestimmen, ob der Benutzername die E-Mail-Adresse sein muss oder ein beliebiger alphanumerischer Eintrag sein kann.</p>',
unistr('<p>Diese Anwendung unterst\00FCtzt die folgenden drei Zugriffsebenen: Leseberechtigter, Beitragender und Administrator.</p>'),
'<ul>',
unistr('  <li><strong>Leseberechtigte</strong> haben schreibgesch\00FCtzten Zugriff auf alle Informationen und k\00F6nnen Berichte anzeigen.</li>'),
unistr('  <li><strong>Beitragende</strong> k\00F6nnen Informationen erstellen, bearbeiten und l\00F6schen sowie Berichte anzeigen.</li>'),
unistr('  <li><strong>Administratoren</strong> k\00F6nnen zus\00E4tzlich zu den Berechtigungen der Beitragenden die Anwendung konfigurieren, indem sie auf den Administrationsbereich der Anwendung zugreifen.</li>'),
'</ul>',
unistr('<p>Bei der Bearbeitung eines vorhandenen Benutzers k\00F6nnen Sie dessen Account sperren, um den Benutzer am Zugriff auf die Anwendung zu hindern.</p>'),
unistr('<p><em><strong>Hinweis:</strong> Wenn Oracle Application Express-Accounts verwendet werden, m\00FCssen die hier eingetragenen Benutzer auch von einem Workspace-Administrator, der auch die Kennw\00F6rter festlegen kann, als Endbenutzer definiert werden.</em><')
||'/p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98479763641303073)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Berichtsseite werden prim\00E4re Datens\00E4tze in einer Auswahl am Rand der Seite angezeigt. '),
unistr('  W\00E4hlen Sie einen Datensatz, um den Masterdatensatz und alle definierten Detaildatens\00E4tze anzuzeigen.<br> '),
'  Klicken Sie auf das Symbol "Bearbeiten" ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ), um den Masterdatensatz zu bearbeiten.',
unistr('  Die Detaildatens\00E4tze werden angezeigt, wenn Sie am Anfang der jeweiligen Zeilen auf den Stift zur Bearbeitung des Datensatzes klicken.</p>'),
'<p>Um die in der Auswahl angezeigten Daten zu begrenzen, geben Sie im Dialogfeld "Suchen" einen Suchbegriff ein.</p>',
'',
unistr('<p>Um einen neuen Masterdatensatz hinzuzuf\00FCgen, klicken Sie am oberen Rand der Seite auf <strong>Erstellen</strong>.'),
unistr('  Detaildatens\00E4tze werden angezeigt, wenn Sie am oberen Rand der Detailregion auf das Plussymbol (+) klicken, um einen Detaildatensatz hinzuzuf\00FCgen.</p>'),
'',
unistr('<p>Klicken Sie im oberen Bereich der Seite auf <strong>Zur\00FCcksetzen</strong>, um die Seite auf die Standardeinstellungen zur\00FCckzusetzen. Dabei werden alle zuvor definierten Suchbegriffe und Filter entfernt.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480809104303074)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>'Seiten-Performance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480921575303074)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite bietet einen interaktiven Bericht zur Performance und Beliebtheit der Seite. Der Bericht wird nach <strong>Gewichtete Performance</strong> sortiert, die berechnet wird, indem der Medianwert der verstrichenen Zeit mit der Anzahl der Sei'
||'tenansichten multipliziert wird.</p>',
unistr('<p>W\00E4hlen Sie gegebenenfalls am oberen Rand der Seite den Zeitrahmen f\00FCr die Berichtserstellung (Standard = 1 Tag).<br>'),
unistr('Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen. Klicken Sie auf die Schaltfl\00E4')
||unistr('che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480678442303074)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480716447303074)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite bietet einen interaktiven Bericht zu den letzten Seitenansichten.</p>',
unistr('<p>W\00E4hlen Sie gegebenenfalls am oberen Rand der Seite den Zeitrahmen f\00FCr die Berichtserstellung (Standard = 1 Tag).<br>'),
unistr('Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen. Klicken Sie auf die Schaltfl\00E4')
||unistr('che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480099461303073)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie das Standardfarbschema aus, das f\00FCr die Anzeige der Anwendung verwendet wird.</p>'),
unistr('<p>Wenn <strong>Endbenutzer d\00FCrfen Theme-Stil ausw\00E4hlen</strong> aktiviert ist, kann jeder Endbenutzer durch Klicken auf den Link <em>Anpassen</em> in der unteren linken Ecke der Homepage eine Auswahl aus den verf\00FCgbaren Theme-Stilen treffen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98454655609303052)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'de'
,p_message_text=>'Topbenutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98480346557303073)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit diesem Bericht und Diagramm zeigen Sie die Benutzer mit den h\00E4ufigsten Seitenansichten f\00FCr den angegebenen Zeitrahmen an.</p>'),
unistr('<p>W\00E4hlen Sie am oberen Rand der Seite den Zeitrahmen f\00FCr die Berichtserstellung aus (Standard = 1 Tag), und w\00E4hlen Sie dann entweder das Bericht- oder das Diagrammsymbol.</p>'),
unistr('<p>Verwenden Sie bei interaktiven Berichten das Suchfeld, oder w\00E4hlen Sie die Spalten\00FCberschrift <strong>Benutzer</strong>, um einen bestimmten Benutzer auszuw\00E4hlen. Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreic')
||unistr('he Funktionen ausf\00FChren, Beispiel: die angezeigten/ausgeblendeten Spalten ausw\00E4hlen, Zeilen pro Seite angeben, filtern usw. Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FC')
||'ckzusetzen.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470729181303065)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer zur Access-Control-Liste hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470843019303066)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer hinzugef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469099069303064)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Seitencacheinhalt l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452657128303051)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'de'
,p_message_text=>unistr('Dialog schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470654720303065)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'de'
,p_message_text=>'Collections erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452990254303051)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>unistr('Feedback l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453087568303051)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Feedback gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470533113303065)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'de'
,p_message_text=>'Formular %0 verarbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471213772303066)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'de'
,p_message_text=>'Datei-ID abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470276364303065)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Logdetails abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469505314303064)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chsten oder vorherigen Prim\00E4rschl\00FCsselwert abrufen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468906948303064)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'de'
,p_message_text=>'Benutzername-Cookie abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468606539303064)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'de'
,p_message_text=>'%0 - Interaktive Grid-Daten speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470459542303065)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'de'
,p_message_text=>'Formular %0 initialisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469481535303064)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Aktion wurde verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452701143303051)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'de'
,p_message_text=>'Daten laden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469614616303065)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'de'
,p_message_text=>'Datenladen nicht erfolgreich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452809859303051)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Auf Feedback antworten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452497287303051)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'de'
,p_message_text=>unistr('Seitennummerierung zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468765319303064)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'de'
,p_message_text=>unistr('Berichtsuche zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98452596629303051)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470371188303065)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolleinstellungen wurden gespeichert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470095986303065)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470187952303065)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Konfigurationsoptionen wurden aktualisiert. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471196618303066)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Einstellung speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98468842407303064)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'de'
,p_message_text=>'Benutzername-Cookie festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98470908978303066)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98471078215303066)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Feedback weitergeleitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469130197303064)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('#MRD_COUNT#-Zeile(n) gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469248973303064)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Aktualisierung angewendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469347043303064)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('#MRU_COUNT#-Zeile(n) wurde(n) aktualisiert, #MRI_COUNT#-Zeile(n) wurde(n) eingef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469945078303065)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'de'
,p_message_text=>'Endbenutzer-Stilvoreinstellung speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98453166966303051)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Einstellungen f\00FCr die Darstellung der Anwendung wurden gespeichert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469780538303065)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'de'
,p_message_text=>'Theme-Stil speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98469889144303065)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Einstellungen f\00FCr die Darstellung der Anwendung wurden gespeichert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459492668303056)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459346381303056)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrollaktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461168245303058)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'de'
,p_message_text=>'Konfiguration der Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459589640303056)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'de'
,p_message_text=>'ACL-Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459156466303056)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tsberichte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450179733303049)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'de'
,p_message_text=>'Anwendungsadministration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458921411303056)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungskonfiguration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460933484303057)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'de'
,p_message_text=>unistr('Automatisierungsausf\00FChrung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449275364303048)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458089297303055)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450058065303049)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458843941303056)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Konfiguration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459235131303056)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Darstellung konfigurieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449549200303048)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458460897303055)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht erfolgreiche Datens\00E4tze')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458521297303056)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'de'
,p_message_text=>unistr('Datens\00E4tze von einem anderen Benutzer ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458394430303055)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'Datenladeassistent - Fortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449821913303048)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Die maximale Anzahl der Zeilen f\00FCr diesen Bericht ist %0. Wenden Sie einen Filter an, um die Anzahl der Datens\00E4tze in der Abfrage zu reduzieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449794761303048)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'de'
,p_message_text=>'Keine Daten gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459937650303057)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461366668303058)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'de'
,p_message_text=>'Ausnahmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459633444303056)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450401509303049)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'de'
,p_message_text=>'Feedback weitergeleitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460698987303057)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461834811303058)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'de'
,p_message_text=>unistr('Region f\00FCr Formularelemente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449608621303048)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461798520303058)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendete Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460146417303057)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'de'
,p_message_text=>unistr('St\00FCndliche Seitenereignisse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458206968303055)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'de'
,p_message_text=>'Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460010817303057)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'de'
,p_message_text=>'Jobberichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459775897303057)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'de'
,p_message_text=>'Sprachselektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460488077303057)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Letzte Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460512762303057)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurden keine Aktivit\00E4ten gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458623228303056)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'de'
,p_message_text=>unistr('Masterdatens\00E4tze')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461037985303058)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'de'
,p_message_text=>'Nachrichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460212415303057)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'de'
,p_message_text=>'Aktivste Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449972938303049)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Seitennavigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449408337303048)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Datens\00E4tze ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458778763303056)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Datens\00E4tze ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461580689303058)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'de'
,p_message_text=>unistr('Keine g\00FCltigen Benutzer vorhanden - Seiteninfo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461659547303058)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('Keine g\00FCltigen neuen Benutzer gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460388194303057)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'de'
,p_message_text=>'Letzte Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449320522303048)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'de'
,p_message_text=>unistr('Selektor f\00FCr Regionsanzeige')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450282141303049)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98449163864303048)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460792658303057)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'de'
,p_message_text=>'Topbenutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98460800595303057)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm Top-Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98450382177303049)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'de'
,p_message_text=>unistr('%0 hinzuzuf\00FCgende Benutzer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459809529303057)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht zur Benutzeranzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98459021518303056)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461494004303058)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'de'
,p_message_text=>unistr('G\00FCltige Benutzer vorhanden - Seiteninfo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98461264039303058)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'de'
,p_message_text=>'Assistentencontainer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98458121716303055)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'Assistentenfortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98478564754303072)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'de'
,p_message_text=>'Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98476048723303070)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie diese Seite wirklich verlassen, ohne die \00C4nderungen zu speichern?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456620591303054)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'de'
,p_message_text=>'%0 Zeile(n) wurde(n) aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457894553303055)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Mindestens ein Feedbackeintrag erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457916465303055)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Feedback zu Ihrer Erfahrung an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457669469303055)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen sich nicht selbst als Administrator entfernen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457762397303055)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen sich die Administratorrolle nicht selbst entziehen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457179250303054)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('#COLUMN_HEADER# muss ein g\00FCltiges Datum sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98456957844303054)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'de'
,p_message_text=>'#COLUMN_HEADER# muss einen Wert aufweisen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457047175303054)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'de'
,p_message_text=>'#COLUMN_HEADER# muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457234871303054)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('#COLUMN_HEADER# muss ein g\00FCltiger Zeitstempelwert sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455217448303053)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 muss ein g\00FCltiges Datum sein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457438501303055)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss ein g\00FCltiges Datum sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457311640303054)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss einen Wert haben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98457501799303055)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss ein g\00FCltiger Zeitstempel sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455094655303053)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'%0 nicht Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455143471303053)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'de'
,p_message_text=>'%0 muss numerisch sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98455345607303053)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'de'
,p_message_text=>unistr('%0 muss ein g\00FCltiger Zeitstempel sein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372556235303812)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Interaktive Grid-Spalte ''%0'', die f\00FCr die dynamische Aktion ''#COMPONENT_NAME#'' angegeben wurde, ist nicht vorhanden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372709296303812)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'de'
,p_message_text=>unistr('Prozess ''%0'' hat ''%1'' bei der Ausf\00FChrung einer Zeilensperre ausgel\00F6st. Dieser Fehler kann auftreten, wenn der Prozess eine SELECT FOR UPDATE-Anweisung bei einer komplexen View mit einem Instead-of-Trigger ausgibt, um die Zeile zu sperren. Legen Sie d')
||'as Prozessattribut ''Zeile sperren'' auf ''Nein'' oder ''PL/SQL-Code'' fest.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372646397303812)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Prozess ''%0'' hat ''%1'' bei der Ausf\00FChrung eines DML-Befehls ausgel\00F6st. Dieser Fehler kann auftreten, wenn eine Spalte auf einer Aggregation oder einem SQL-Ausdruck basiert. Legen Sie das Spaltenattribut ''Nur Abfrage'' auf ''Ja'' fest, um die Spalte aus d')
||unistr('er INSERT- und UPDATE-Anweisung auszuschlie\00DFen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994343153303499)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Master/Detailspalte ''%0'' enth\00E4lt keinen Wert. Stellen Sie sicher, dass der Prozess ''%1'' nach dem entsprechenden Prozess der Masterregion ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354813343303798)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr interaktives Grid ''%0'' ist keine Masterspalte definiert; dies ist bei einer Master/Detailbeziehung erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769265233303312)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr interaktives Grid ''%0'' ist keine Prim\00E4rschl\00FCsselspalte definiert; dies ist f\00FCr die Bearbeitung oder in einer Master/Detailbeziehung erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332243086303779)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'de'
,p_message_text=>'Bei einem editierbaren interaktiven Grid muss das Seitenattribut "Bei Weiterleitung neu laden" auf "Nur bei Erfolg" festgelegt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303256578303754)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'de'
,p_message_text=>'Codeeditor: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303388533303754)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'de'
,p_message_text=>'%0 ausblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303484704303754)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'de'
,p_message_text=>'Farbauswahl: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303587520303754)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'de'
,p_message_text=>'Komponente bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303640150303754)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'de'
,p_message_text=>' (Fehler)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303728487303754)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'de'
,p_message_text=>'%0 einblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303144149303754)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303833554303754)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'de'
,p_message_text=>'Keine Ergebnisse gefunden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303927456303754)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Ergebnisse gefunden. Versuchen Sie, alle Eigenschaften zu durchsuchen, indem Sie auf die Schaltfl\00E4che "Alle anzeigen" oben klicken.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304060981303754)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'de'
,p_message_text=>'Filtereigenschaften'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304163390303755)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('%0 (Ung\00FCltig)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304277112303755)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'de'
,p_message_text=>'Werteliste: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304377543303755)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304446523303755)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'de'
,p_message_text=>unistr('Die ausgew\00E4hlten Komponenten haben keine gemeinsamen Eigenschaften.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305670700303756)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Aktuell sind keine Komponenten ausgew\00E4hlt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304543068303755)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304684104303755)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'de'
,p_message_text=>'Pin-Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304762413303755)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'de'
,p_message_text=>'Schnellauswahl: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304876778303755)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'de'
,p_message_text=>unistr('Auswahl l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99304945654303755)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Erforderlich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305043179303755)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305159596303755)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'de'
,p_message_text=>unistr('- Ausw\00E4hlen -')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305265651303756)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'de'
,p_message_text=>' (Wert variiert)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305301130303756)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305491475303756)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'de'
,p_message_text=>' (Warnung)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305596217303756)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332325971303779)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Bei einem tabellarischen Formular muss das Seitenattribut ''Bei Weiterleitung neu laden'' auf ''Immer'' festgelegt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111905198303594)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Die statische Regions-ID muss angegeben werden, da die Seite mehrere interaktive Grids enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337115903302955)
,p_name=>'APEXIR_3D'
,p_message_language=>'de'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447618108303047)
,p_name=>'APEXIR_ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929888193303442)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Subscription hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586640278303157)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Aggregate werden nach jedem Kontrollgruppenwechsel und am Ende des Berichts angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502585782303091)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'de'
,p_message_text=>unistr('Nur eindeutige Reihen z\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448070580303047)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'de'
,p_message_text=>'Modus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330057105303777)
,p_name=>'APEXIR_AREA'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927604541303439)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'de'
,p_message_text=>'Schwarz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448337819303047)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554279706303132)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362212742303804)
,p_name=>'APEXIR_DAY'
,p_message_language=>'de'
,p_message_text=>'Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482597755303075)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'de'
,p_message_text=>unistr('Markierte Elemente l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586934790303158)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'de'
,p_message_text=>unistr('Soll dieser L\00F6schvorgang ausgef\00FChrt werden?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565982248303141)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'de'
,p_message_text=>'Deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337323587302955)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315041553302938)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'de'
,p_message_text=>'Ring'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186685141302836)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'de'
,p_message_text=>'Nur Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337254657302955)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'de'
,p_message_text=>'- Nicht aggregieren -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313244279303763)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Alternativen Standardwert bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565858062303141)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'de'
,p_message_text=>'Aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586798888303157)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Flashback-Anforderung kann nicht ausgef\00FChrt werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916920607303430)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Funktionsspalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927791692303439)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'de'
,p_message_text=>'Grau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314840427302938)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'de'
,p_message_text=>'Markieren wenn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862706654303386)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('Labelpr\00E4fix')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918778257303432)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie <a href=''%0''>hier</a>, um die Subscription zu verwalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587548519303158)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'de'
,p_message_text=>'Weitere Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332951983302952)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'de'
,p_message_text=>'- Neue Kategorie -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482661944303075)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'de'
,p_message_text=>'Keine Aggregation definiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410797175303017)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Spalteninformationen verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482745745303075)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'de'
,p_message_text=>'Keine Berechnung definiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362196227303804)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'de'
,p_message_text=>'- Kein Enddatum -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415851280303849)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine andere Zeilenspalte. Der HTML-Ausdruck oder -Link in der Zeilenspalte enth\00E4lt die Spalte als Pivot- oder Aggregatspalte definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447799707303047)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'de'
,p_message_text=>'Aggregat entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816478372303349)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anzahl der Anzeigespalten im Bericht hat den Grenzwert erreicht. Klicken Sie im Men\00FC "Aktionen" auf "Spalten ausw\00E4hlen", um die Liste der Berichtsanzeigespalten zu minimieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421924485303026)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'de'
,p_message_text=>'Zeilenreihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185928597302835)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anzahl der Anzeigespalten im Bericht hat den Grenzwert erreicht. Klicken Sie im Men\00FC "Aktionen" auf "Spalten ausw\00E4hlen", um die Liste der Berichtsanzeigespalten zu minimieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482497940303075)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Als Standard speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314960992302938)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'de'
,p_message_text=>unistr('- Kategorie ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587603644303158)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Vor berechneten Spalten steht **.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362025888303803)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('- Sortierspalte ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587449802303158)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Wert ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361991716303803)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Sortierspalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916871411303430)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'de'
,p_message_text=>'Endeinheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586867583303158)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'de'
,p_message_text=>'Nicht autorisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564143428303140)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten\00FCberschrift muss eindeutig sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362386906303804)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'de'
,p_message_text=>'Woche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183247204302833)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'de'
,p_message_text=>unistr('Administration Services f\00FCr Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313526429303763)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Anwendung ist keine Authentifizierung konfiguriert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625810028303187)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden Datenbankobjekte werden in das ausgew\00E4hlte Schema %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625998930303187)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Die folgenden Datenbankobjekte wurden erfolgreich %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001038037303505)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'de'
,p_message_text=>'Bildlauf nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001112712303505)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'de'
,p_message_text=>'Zum Anfang scrollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189395923302838)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'de'
,p_message_text=>'Navigationsformular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313162114303763)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780964199303322)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Objekte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366348772303807)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'de'
,p_message_text=>'Es sind keine Peer-Seiten vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316489247303766)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'de'
,p_message_text=>'Zu erstellende Objekte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316644764303766)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'de'
,p_message_text=>unistr('Aus Tabellen l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316818046303766)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'de'
,p_message_text=>unistr('Objekte l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935899635303447)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'de'
,p_message_text=>unistr('Tabellen l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935191406303446)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'de'
,p_message_text=>'Diese Objekte werden im Schema <strong>%0</strong> erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316970447303766)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Objekte sind im Schema <strong>%0</strong> bereits vorhanden und werden von anderen Workspaces verwendet. Wenn Sie fortfahren, werden die bestehenden, <strong>%0</strong> zugeh\00F6rigen Websheet-Objekte auch diesem Workspace zugeordnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317056804303766)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das f\00FCr diese Objekte zu verwendende Schema:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317157390303766)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'de'
,p_message_text=>'Zu verwendende bestehende Tabellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317952743303767)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Datenbankobjekte werden mit den folgenden Informationen erneut verwendet. Best\00E4tigen Sie die Anforderung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935224320303446)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie die Websheet-Objekte in einem neuen Schema erstellen m\00F6chten, verwenden Sie den Assistenten <a href=%0>Datenbankschema anfordern</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935359398303446)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'de'
,p_message_text=>unistr('Um Websheets ausf\00FChren zu k\00F6nnen, m\00FCssen die folgenden Objekte vorhanden sein:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935446219303446)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Datenbankobjekte werden mit den folgenden Informationen erstellt. Best\00E4tigen Sie die Anforderung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935550268303446)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'de'
,p_message_text=>'Zu erstellende Tabellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935695767303446)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'de'
,p_message_text=>unistr('Sie m\00F6chten Websheet-Datenbankobjekte entfernen. Hierdurch werden au\00DFer den Websheet-Datenbankobjekten auch die internen Daten im Workspace gel\00F6scht, die Websheet-Komponenten enthalten. M\00F6chten Sie fortfahren? ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935993996303447)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden ung\00FCltigen Objekte m\00FCssen korrigiert werden, damit Websheets ordnungsgem\00E4\00DF ausgef\00FChrt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316532441303766)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'de'
,p_message_text=>unistr('Sie m\00F6chten die Websheet-Definitionen f\00FCr diesen Workspace entfernen. Da diese Websheet-Datenbankobjekte auch von anderen Workspaces verwendet werden, werden sie nicht gel\00F6scht. M\00F6chten Sie fortfahren? ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936078957303447)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'de'
,p_message_text=>'Objektname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936129064303447)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Objekttyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935793813303446)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316343861303766)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'de'
,p_message_text=>'Zu verwendende vorhandene Objekte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238632069302877)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238551799302877)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774745565303317)
,p_name=>'APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835761372303364)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'de'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690436128303245)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Anwendungsberechnung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693201985303248)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'de'
,p_message_text=>'Anwendungsbild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690518850303245)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Anwendungsprozess')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621574158303184)
,p_name=>'APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756001681303302)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'de'
,p_message_text=>'Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664617097303221)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungsaktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702687202303256)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'de'
,p_message_text=>unistr('Aliasname f\00FCr die Anwendung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700764677303254)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung wurde gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183059851302833)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'de'
,p_message_text=>'Anwendungsentwicklung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701655072303255)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'de'
,p_message_text=>'Gibt die Anwendung an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661425398303215)
,p_name=>'APPLICATION_ID'
,p_message_language=>'de'
,p_message_text=>'Anwendungsnummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561365976303138)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'de'
,p_message_text=>'Die Anwendungs-ID ist reserviert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561281114303138)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Die Anwendungs-ID muss eine positive Ganzzahl sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976081008303484)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsbilder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730788835303280)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'de'
,p_message_text=>'Anwendungselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264512003302898)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Anwendungselemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233415954302872)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'de'
,p_message_text=>'Anwendung: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702513671303256)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'de'
,p_message_text=>'Anwendungsname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365994774303807)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsnamen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812492785303346)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-Override-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700205824303254)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungseigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365897647303807)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsseiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339944331302957)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700432402303254)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsstatus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776305728303318)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsversion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198156818302844)
,p_name=>'APPLICATION_X'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649015823303205)
,p_name=>'APPROVED'
,p_message_language=>'de'
,p_message_text=>'Genehmigt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706847814303260)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Anwendung wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368416880303809)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Templateanwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231363639302871)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'de'
,p_message_text=>'Datenbankanwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231442754302871)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'de'
,p_message_text=>unistr('Produktivit\00E4ts- oder Beispielanwendung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727608937303278)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'de'
,p_message_text=>'Beispiel-Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231289216302871)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'de'
,p_message_text=>'Websheet-Anwendung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648504550303205)
,p_name=>'ARCHIVED'
,p_message_language=>'de'
,p_message_text=>'Archiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233722969302873)
,p_name=>'ARCHIVELOG'
,p_message_language=>'de'
,p_message_text=>'Logarchivierung: Ein'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484600328303077)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'de'
,p_message_text=>unistr('Argumente m\00FCssen Pr\00FCfsumme haben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572215848303146)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'de'
,p_message_text=>'Argumentname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572404450303146)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Argumenttyp'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642774320303201)
,p_name=>'ASAP'
,p_message_language=>'de'
,p_message_text=>unistr('So schnell wie m\00F6glich')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640061625303198)
,p_name=>'ASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Zugeordnet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337528536302955)
,p_name=>'ASSIGNEE'
,p_message_language=>'de'
,p_message_text=>'Beauftragter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388155542303825)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'de'
,p_message_text=>' %0 zuweisen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393563013303003)
,p_name=>'ASSOCIATED'
,p_message_language=>'de'
,p_message_text=>unistr('zugeh\00F6rig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339150898302956)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'de'
,p_message_text=>'Zugeordnete Features'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669839862303225)
,p_name=>'ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'Anhang'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395931355303832)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Gef\00E4hrdet')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365088619302976)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'de'
,p_message_text=>'Sie sind im Begriff, die benutzerdefinierten Authentifizierungsoptionen zu einem Authentifizierungsschema zu migrieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364544960302975)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Authentifizierungsmethode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364903260302976)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion f\00FCr eine benutzerdefinierte Authentifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364649894302975)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'de'
,p_message_text=>'Anmeldeseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364835625302976)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'de'
,p_message_text=>'Anmelde-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364700258302975)
,p_name=>'AUTH.NONE'
,p_message_language=>'de'
,p_message_text=>'Kein Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370082327302979)
,p_name=>'AUTHENTICATION'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691413619303246)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsfunktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691183927303246)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385081556302995)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie sind im Begriff, ein Authentifizierungsschema aus der Anwendung %0 zu l\00F6schen. Wenn die Anwendung aktuell nicht die SCHEME-Authentifizierung verwendet oder SCHEME nicht das aktuelle Authentifizierungsschema ist und Sie das Schema l\00F6schen, hat die')
||unistr('s keine Auswirkung auf den Vorgang der Anwendung. Wenn die Anwendung die SCHEME-Authentifizierung verwendet und es sich hierbei um das aktuelle Authentifizierungsschema handelt, f\00FChrt die Anwendung weiterhin die SCHEME-Authentifizierung durch, und zw')
||unistr('ar mit einem Standardauthentifizierungsschema. Hierbei wird eine integrierte Anmeldeseite mit einer "Open Door"-Zugangsdatenverifizierung verwendet (bei der jeder Benutzer berechtigt ist, die Anwendung auszuf\00FChren). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387057165302997)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie auf <b>Als aktuelles Element festlegen</b>, damit Ihre Anwendung dieses Authentifizierungsschema verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863064192303386)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'de'
,p_message_text=>'Application Express-Accounts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179600819302830)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'de'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863126255303386)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863402050303386)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'de'
,p_message_text=>'Keine Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863216717303386)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'de'
,p_message_text=>'Datenbankaccounts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124887641303604)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'de'
,p_message_text=>'HTTP-Headervariable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863616128303386)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863327944303386)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'de'
,p_message_text=>'LDAP-Verzeichnis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863501884303386)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'de'
,p_message_text=>'Open Door-Zugangsdaten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157559028302812)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'de'
,p_message_text=>'SAML-Anmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208140724302852)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'de'
,p_message_text=>'Social Sign-In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731759819303281)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691009371303246)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179743876302830)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'de'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198328196302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Exists-SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198403941302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktion, die Boolean zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553988545303132)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'de'
,p_message_text=>'Ist in Rolle oder Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554062216303132)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'de'
,p_message_text=>'Ist nicht in Rolle oder Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198534731302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert von Element in Ausdruck 1 ist gleich Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198638833302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Element in Ausdruck 1 ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198754035302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'de'
,p_message_text=>'Element in Ausdruck 1 ist NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198819791302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert des Elements in Ausdruck 1 ist nicht gleich Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198985186302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Not Exists-SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199024933302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert der Voreinstellung in Ausdruck 1 = Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199149782302845)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert von Voreinstellung in Ausdruck 1 ist NICHT gleich Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250237287302886)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr jede Seitenansicht auswerten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250310381302886)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'de'
,p_message_text=>'Einmal pro Session auswerten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202061283302847)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'de'
,p_message_text=>'Account abgelaufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201996900302847)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Account gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202331937302848)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Maximale Anmeldeversuche \00FCberschritten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202452790302848)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Unbekannter interner Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202272142302848)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'de'
,p_message_text=>'Erste Verwendung des Kennworts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202179756302848)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'de'
,p_message_text=>'Falsches Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201768105302847)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Normale, erfolgreiche Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201817776302847)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'de'
,p_message_text=>'Unbekannter Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296626592302924)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Unbekannter Workspace-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306706565302932)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'de'
,p_message_text=>'Unbekannter Workspace-Name: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427745548303031)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'de'
,p_message_text=>'COMMIT-Anweisung nicht anwendbar. Alle Anweisungen werden automatisch festgeschrieben.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125844793303605)
,p_name=>'AUTOMATIONS'
,p_message_language=>'de'
,p_message_text=>'Automatisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125967169303605)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Automatisierungsaktion'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756695564303303)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'de'
,p_message_text=>'Provisioning-Modus'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177268599302828)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'de'
,p_message_text=>'Erstes Element'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778193176303319)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'de'
,p_message_text=>unistr('Verf\00FCgbarkeit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206488729302851)
,p_name=>'AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913000004303427)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Nur f\00FCr Entwickler verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912994143303427)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'de'
,p_message_text=>unistr('Mit Entwicklersymbolleiste verf\00FCgbar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665420249303222)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'de'
,p_message_text=>'Durchschnittliche Rendering-Zeit (Sekunden)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646939598303204)
,p_name=>'BAR_CHART'
,p_message_language=>'de'
,p_message_text=>'Balkendiagramm'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964741662303474)
,p_name=>'BASIC'
,p_message_language=>'de'
,p_message_text=>'Einfach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220360431302862)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'de'
,p_message_text=>'Basisentwickler'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628306480303189)
,p_name=>'BEFORE'
,p_message_language=>'de'
,p_message_text=>'Vor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371257158303811)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'de'
,p_message_text=>'Vor Listeneintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387242499303824)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'de'
,p_message_text=>'Vor erstem'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694357770303249)
,p_name=>'BIND_LABEL'
,p_message_language=>'de'
,p_message_text=>'Bind-Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693733170303248)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'de'
,p_message_text=>'Bind-Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693897257303249)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Label Bind-Variable'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708361850303261)
,p_name=>'BLACK_TEXT'
,p_message_language=>'de'
,p_message_text=>'Schwarzer Text'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183611519302833)
,p_name=>'BLANK'
,p_message_language=>'de'
,p_message_text=>'Leer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669099945303224)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'de'
,p_message_text=>'BLOB-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814186224303348)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232364832302871)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'de'
,p_message_text=>'BLOB-Format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814513412303348)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'Anhang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814246235303348)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814343966303348)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'de'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814473022303348)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'de'
,p_message_text=>'Inline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670092643303225)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>'BLOB-Format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669554411303225)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'de'
,p_message_text=>'BLOB Zuletzt aktualisierte Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668916690303224)
,p_name=>'BLOB_TABLE'
,p_message_language=>'de'
,p_message_text=>'BLOB-Tabelle'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708271426303261)
,p_name=>'BLUE_TEXT'
,p_message_language=>'de'
,p_message_text=>'Blauer Text'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685435650303240)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Verzweigung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254094768302889)
,p_name=>'BRANCHES'
,p_message_language=>'de'
,p_message_text=>'Verzweigungen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448508602303047)
,p_name=>'BREADCRUMB'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629039962303190)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad-Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629152799303190)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Langer Name f\00FCr Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448657286303048)
,p_name=>'BREADCRUMBS'
,p_message_language=>'de'
,p_message_text=>'Navigationspfade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717185273303269)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadeintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730928536303281)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadeintrag: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561654331303138)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadseiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636523948303196)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310652127302935)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Der Navigationspfad wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631693542303192)
,p_name=>'BROWSE_ICON'
,p_message_language=>'de'
,p_message_text=>'Durchsuchen-Symbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631468715303192)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'de'
,p_message_text=>'Package durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572034666303146)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle durchsuchen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163323164302817)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-ACLs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159641443302814)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207922373302852)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'de'
,p_message_text=>'Beim Sichern der Anwendung ist ein Fehler aufgetreten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159755173302814)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Anwendungselemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159950161302814)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207607503302852)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0 wurde aus Revision %1 wiederhergestellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159534494302814)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970428547303479)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungseigenschaften: Ge\00E4ndert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713766958303266)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160609536302815)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160754683302815)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162324549302816)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'de'
,p_message_text=>'Navigationspfade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162486472302816)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>unistr('Templates f\00FCr Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159878264302814)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Erstelloptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162698583302817)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>unistr('Templates f\00FCr Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162512748302816)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Kalendertemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713538513303266)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'de'
,p_message_text=>'Komponenten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124766833303604)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124689198303604)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ge\00E4ndert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124524815303604)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'de'
,p_message_text=>'%0 neue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161089006302815)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Komponenteneinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167594494302821)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>'Zugangsdaten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163813181302818)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'de'
,p_message_text=>'Laden von Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171758915302824)
,p_name=>'BU.DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171852714302824)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'de'
,p_message_text=>'Entwickler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161217802302815)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208036156302852)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungsbackup wird ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162901467302817)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Labeltemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713912297303266)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'de'
,p_message_text=>'Letztes Backup: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713479647303265)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'de'
,p_message_text=>'Letzte Aktualisierung: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160010237302814)
,p_name=>'BU.LISTS'
,p_message_language=>'de'
,p_message_text=>'Listen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162893550302817)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207793600302852)
,p_name=>'BU.LOCKED'
,p_message_language=>'de'
,p_message_text=>'Gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160339784302815)
,p_name=>'BU.LOVS'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163284962302817)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Wertelistentemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167459505302821)
,p_name=>'BU.MESSAGES'
,p_message_language=>'de'
,p_message_text=>'Nachrichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171632068302824)
,p_name=>'BU.MODIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ge\00E4ndert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160560279302815)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713646383303266)
,p_name=>'BU.NEW'
,p_message_language=>'de'
,p_message_text=>'%0 neue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162257146302816)
,p_name=>'BU.PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124437465303604)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124393302303604)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ge\00E4ndert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124296074303604)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'de'
,p_message_text=>'%0 neue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160459354302815)
,p_name=>'BU.PLUGINS'
,p_message_language=>'de'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162791409302817)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Regionstemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167719801302821)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'de'
,p_message_text=>'Server entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163684322302817)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'de'
,p_message_text=>'Berichtslayouts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163105960302817)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Berichtstemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668721459303224)
,p_name=>'BU.RESTORED'
,p_message_language=>'de'
,p_message_text=>'Wiederhergestellte Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198025088302844)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Anwendung wurde aus Backuprevision %0 wiederhergestellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161751750302816)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163577400302817)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'de'
,p_message_text=>'Gemeinsam verwendete Abfragen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161139296302815)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'Shortcuts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161414626302816)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'de'
,p_message_text=>'Statische Anwendungsdateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161525257302816)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'de'
,p_message_text=>'Statische Workspace-Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204993119302850)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungs\00FCbersicht nicht verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163051995302817)
,p_name=>'BU.TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98161622639302816)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'de'
,p_message_text=>'Textnachrichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160205186302815)
,p_name=>'BU.THEMES'
,p_message_language=>'de'
,p_message_text=>'Themes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163478792302817)
,p_name=>'BU.TREES'
,p_message_language=>'de'
,p_message_text=>unistr('B\00E4ume')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207840267302852)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Entsperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160198571302815)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chenattribute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98160810647302815)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>'Webzugangsdaten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163753198302818)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'de'
,p_message_text=>'Webservices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167671106302821)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187583908302836)
,p_name=>'BUFFER CACHE'
,p_message_language=>'de'
,p_message_text=>'Puffercache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643258533303201)
,p_name=>'BUG'
,p_message_language=>'de'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666525182303222)
,p_name=>'BUGS'
,p_message_language=>'de'
,p_message_text=>'Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687900091303243)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Zugewiesene Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725190537303276)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'de'
,p_message_text=>'Zugewiesene Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216185021302859)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'de'
,p_message_text=>'Geschlossene Bugs (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993663205303498)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz geschlossener Bugs (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725263959303276)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'de'
,p_message_text=>'Nicht zugewiesene Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725356492303276)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Korrekturf\00E4lligkeitsdaten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994062236303499)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'de'
,p_message_text=>'Bugs: %1 von %0 geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392534568303829)
,p_name=>'BUG_LABEL'
,p_message_language=>'de'
,p_message_text=>'Bug: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681616119303236)
,p_name=>'BUILD QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171438783302824)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171307700302824)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171213598302824)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171517994302824)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171175855302824)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775712550303317)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'de'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773159105303315)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'de'
,p_message_text=>unistr('[Nicht unterst\00FCtzt]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972406052303481)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Workspace-Meldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377208081302989)
,p_name=>'BUILD_OPTION'
,p_message_language=>'de'
,p_message_text=>'Erstelloption'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822716523303354)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'de'
,p_message_text=>'Erstelloption: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391207055303828)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'de'
,p_message_text=>'Build-Status: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823505766303355)
,p_name=>'BUILD_VERSION'
,p_message_language=>'de'
,p_message_text=>'Build-Version'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719058618303270)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Integriertes Berichtstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627659642303189)
,p_name=>'BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815862866303349)
,p_name=>'BUTTON.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195744407302843)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Die Schaltfl\00E4chenattribute der ausgew\00E4hlten Schaltfl\00E4che d\00FCrfen keine ID enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195647113302843)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'de'
,p_message_text=>unistr('Die ausgew\00E4hlte Schaltfl\00E4che muss eine Schaltfl\00E4che mit einer Aktion sein, f\00FCr die "Von dynamischer Aktion definiert" festgelegt wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195837889302843)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Die ausgew\00E4hlte Schaltfl\00E4che verwendet ein ''Schaltfl\00E4chen-Template'', das die Ersetzungszeichenfolge #BUTTON_ID# nicht enth\00E4lt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815636678303349)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254284866302889)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Die Seite muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232937522302872)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'de'
,p_message_text=>'Die Berichtsabfrage muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231044955302870)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('Eine Schaltfl\00E4chenanforderung muss f\00FCr alle Quelltypen von Schaltfl\00E4chenanforderungen angegeben werden, au\00DFer der Quelltyp der Schaltfl\00E4chenanforderung ist "Immer null".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231798546302871)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Quelltyp f\00FCr Schaltfl\00E4chenanforderung muss angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254355775302889)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'de'
,p_message_text=>'Das Ziel der URL muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197763680302844)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die Aktion ''Von dynamischer Aktion definiert" ist, d\00FCrfen die Schaltfl\00E4chenattribute keine ID enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255468338302890)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255553594302890)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'de'
,p_message_text=>'Format-Template muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255332858302890)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Das Template muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197670850302844)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn der Schaltfl\00E4chenstil "Template-basierte Schaltfl\00E4che" und Aktion "Von dynamischer Aktion definiert ist", muss das ausgew\00E4hlte Schaltfl\00E4chentemplate die Ersetzungszeichenfolge #BUTTON_ID# enthalten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185539097302835)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che kann nicht gel\00F6scht werden, weil sie in einer dynamischen Aktion referenziert wird (Seite: %0, Dynamische Aktion: ''%1'', Aktion: ''%2'', Attribut: ''Betroffenes Element'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185403059302835)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che kann nicht gel\00F6scht werden, weil sie in einer dynamischen Aktion referenziert wird (Seite: %0, Dynamische Aktion: ''%1'', Attribut: ''When'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815735047303349)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98811966174303346)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'de'
,p_message_text=>'Muss in einem "Onclick"-Attribut verwendet werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815164865303348)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'de'
,p_message_text=>'Muss in einem "href"-Attribut verwendet werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254120641302889)
,p_name=>'BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694702759303249)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chenattribute')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391035135303828)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699002685303253)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen-Template')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251499688302887)
,p_name=>'BYTES'
,p_message_language=>'de'
,p_message_text=>'Byte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642836814303201)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'de'
,p_message_text=>unistr('Nach n\00E4chstem Patch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642971637303201)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'de'
,p_message_text=>unistr('Nach n\00E4chster Version')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465601868303890)
,p_name=>'CA.ABOUT'
,p_message_language=>'de'
,p_message_text=>'Info'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431930733303862)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'de'
,p_message_text=>'Info-Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431842553303862)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nehmen Sie eine Seite mit Informationen zu dieser Anwendung auf, die eine Beschreibung der Anwendung, die Anwendungsversion und eine Seitenanzahl enth\00E4lt.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354859120302968)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'de'
,p_message_text=>'Inhaltscontainer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465872133303890)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Info-Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465948033303890)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'de'
,p_message_text=>'Text zu dieser Anwendung kann hier platziert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465573201303890)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'de'
,p_message_text=>'Info zu dieser Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476716850303899)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'de'
,p_message_text=>'Informationen zum Vorschaurelease'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314768550302938)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen sich nicht selbst als Administrator entfernen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314615132302938)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen sich die Administratorrolle nicht selbst entziehen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432225483303863)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468135741303892)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrollaktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457613297303883)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Konfiguration der Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430693403303861)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'de'
,p_message_text=>'Rollenbasierte Benutzerauthentifizierung aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432328882303863)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Integrieren Sie rollenbasierte Benutzerauthentifizierung in Ihre Anwendung.',
unistr('Benutzer k\00F6nnen als Administratoren, Beitragende oder Leseberechtigte definiert werden.'),
unistr('Sie k\00F6nnen dann leicht definieren, dass verschiedenen Rollen ein jeweils unterschiedlicher Zugriff auf verschiedene Komponenten in Ihrer Anwendung gew\00E4hrt wird, beispielsweise auf Seiten, Men\00FCeintr\00E4ge, Regionen, Spalten, Elemente, Schaltfl\00E4chen und s')
||'o weiter.</p>',
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
'<li>Region auf der Administrationsseite mit Links zu Zugriffskontrollfeatures</li>',
'<li>Benutzertabelle zur Verwaltung der Zugriffskontrolle</li>',
unistr('<li>Konfigurationsseite zum Festlegen der Zugriffsebene f\00FCr authentifizierte Benutzer</li>'),
'<li>Konfigurationsseite zur Angabe, ob Benutzernamen E-Mail-Adressen sind</li>',
'<li>Seite zum Verwalten des Benutzerzugriffs, um den Benutzerzugriff zu melden und zu bearbeiten</li>',
unistr('<li>Seite "Benutzer hinzuf\00FCgen", um einen einzelnen Benutzer hinzuzuf\00FCgen</li>'),
unistr('<li>Seite zum Hinzuf\00FCgen mehrerer Benutzer, \00FCber die mehrere Benutzer (nur E-Mail-Benutzernamen) hinzugef\00FCgt werden k\00F6nnen</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456519642303882)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'de'
,p_message_text=>'Rolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457214419303883)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'de'
,p_message_text=>'Zugriffsrollen-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286399499302915)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'de'
,p_message_text=>'Rollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456603150303882)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'de'
,p_message_text=>'Account gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314253455302938)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467980518303891)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'de'
,p_message_text=>'ACL-Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468607341303892)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'de'
,p_message_text=>'Keine ausreichenden Berechtigungen. Benutzer ist kein Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468744370303892)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'de'
,p_message_text=>unistr('Sie sind nicht berechtigt, diese Anwendung anzuzeigen. Entweder wurde Ihnen kein Zugriff gew\00E4hrt, oder Ihr Account ist gesperrt. Wenden Sie sich an den Anwendungsadministrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468837263303892)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'de'
,p_message_text=>'Keine ausreichenden Berechtigungen. Benutzer ist kein Beitragender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458399115303884)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolleinstellungen wurden gespeichert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463071900303888)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'de'
,p_message_text=>unistr('HTML f\00FCr Aktionsschaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461948815303887)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'de'
,p_message_text=>'Aktionslabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462043734303887)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'de'
,p_message_text=>'Aktionslink'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464690797303889)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'de'
,p_message_text=>unistr('HTML f\00FCr Aktionslink')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450135403303877)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'de'
,p_message_text=>'Aktion wurde verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455612063303882)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4t pro Stunde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488850867303909)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'de'
,p_message_text=>unistr('Dashboard-Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432451733303863)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tsberichte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431607320303862)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Berichte zu Benutzeraktivit\00E4t und Fehlern einbeziehen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432500701303863)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nehmen Sie zahlreiche Berichte zur Endbenutzeraktivit\00E4t f\00FCr Ihre Anwendung auf. Bestimmen Sie die aktivsten Benutzer, die am h\00E4ufigsten verwendeten Seiten, die Performance der Seiten und die ausgel\00F6sten Fehler. Dies erm\00F6glicht ein besseres Verst\00E4n')
||unistr('dnis dar\00FCber, wie Ihre Anwendung genutzt wird, und zeigt Bereiche mit Verbesserungspotenzial auf.</p>'),
'<p>Umfasst Folgendes:',
'<ul>',
'<li>Bericht zu Top-Benutzern</li>',
'<li>Bericht zum Anwendungsfehlerlog</li>',
unistr('<li>Seitenperformance, Aktivit\00E4t und Performance nach Seite</li>'),
unistr('<li>Bericht zur Anwendungsaktivit\00E4t nach Seite</li>'),
'<li>Detailbericht zu Seitenansichten</li>',
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678660059303234)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'de'
,p_message_text=>unistr('Tats\00E4chliches Startdatum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467878227303891)
,p_name=>'CA.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463273598303888)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('E-Mail-Template hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479715423303901)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere Benutzer hinzuf\00FCgen - Schritt 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466133749303890)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'de'
,p_message_text=>unistr('Neues %0 hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449181370303876)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Benachrichtigung hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354742358303798)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Seite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457353429303883)
,p_name=>'CA.ADD.USER'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480105774303902)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434092483303864)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'de'
,p_message_text=>unistr('Seiten werden hinzugef\00FCgt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434558706303864)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Klicken Sie auf <strong>Seite hinzuf\00FCgen</strong>, um der Anwendung eine Seite hinzuzuf\00FCgen. W\00E4hlen Sie anschlie\00DFend einen Seitentyp (z.B. Leer, Diagramm, Formular, Bericht usw.) aus, und definieren Sie die zugeh\00F6rigen Attribute. M\00F6glicherweise m\00FC')
||unistr('ssen Sie auch eine g\00FCltige Tabelle oder View angeben oder Datenbankobjekte im Workspace mit SQL Workshop vorbereiten.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464087628303888)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Erweitert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677943854303233)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'de'
,p_message_text=>unistr('Zus\00E4tzliche Informationen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457042224303883)
,p_name=>'CA.ADDRESS'
,p_message_language=>'de'
,p_message_text=>'Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437224578303867)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437843381303867)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Zugriffsebene f\00FCr authentifizierte Benutzer dieser Anwendung festlegen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436328243303866)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tsberichte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437398497303867)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439050084303868)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'de'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437794586303867)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'de'
,p_message_text=>'Administratoren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711199179303264)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungskonfiguration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810759792303345)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472641508303896)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsadministration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472740087303896)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'de'
,p_message_text=>'Komponente verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435970321303866)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Theme-Stilauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436071950303866)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'de'
,p_message_text=>'Look-and-Feel der Standardanwendung festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435699052303865)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Konfigurationsoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435567215303865)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'de'
,p_message_text=>'Anwendungsfeatures aktivieren oder deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436607897303866)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'de'
,p_message_text=>'Anwendungsfehlerlog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436734139303866)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'de'
,p_message_text=>'Bericht zu Fehlern, die von dieser Anwendung protokolliert wurden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436150149303866)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436251980303866)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'de'
,p_message_text=>'Anwendungsname und Kurzbeschreibung festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435701317303865)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsupdates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435800434303865)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'de'
,p_message_text=>'Liste der Anwendungsupdates verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435263292303865)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Konfiguration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437627876303867)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'de'
,p_message_text=>'Beitragende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487650807303908)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'de'
,p_message_text=>'Dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487531407303908)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Metriken zur Anwendungsaktivit\00E4t anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440767442303870)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'de'
,p_message_text=>'Standardzeitzone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440889404303870)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Standardzeitzone f\00FCr diese Anwendung festlegen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438512259303868)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440955330303870)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Einstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441054533303870)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Festlegen, ob E-Mail gesendet werden soll, und wenn ja, Person f\00FCr "Antwort an" angeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438072948303867)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438350559303868)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Feedbackeinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438493014303868)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Verwalten, ob Anh\00E4nge zul\00E4ssig sein sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438173779303867)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Benutzerfeedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438249124303868)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'de'
,p_message_text=>'Bericht zum gesamten von Anwendungsbenutzern abgegebenen Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438663316303868)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438721893303868)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'de'
,p_message_text=>'Die von dieser Anwendung verwendeten HTML- und CSS-E-Mail-Templates verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435377322303865)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435492435303865)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigungen auf der Homepage anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473392866303896)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'de'
,p_message_text=>'Administrationsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355423619303798)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'de'
,p_message_text=>'Automatisierungslog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355520265303798)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht \00FCber Automatisierungsausf\00FChrungen und -meldungen, die von dieser Anwendung protokolliert wurden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436842734303866)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>'Seiten-Performance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436946825303866)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht zu Aktivit\00E4t und Performance nach Anwendungsseite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437059072303866)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437163613303866)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht zu jeder Seitenansicht nach Benutzer, einschlie\00DFlich Zugriffsdatum und verstrichene Zeit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437599711303867)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'de'
,p_message_text=>'Leseberechtigte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480869047303902)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480920915303902)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'de'
,p_message_text=>'Auf Template basierende E-Mail von dieser Anwendung senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436410368303866)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'de'
,p_message_text=>'Topbenutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99436510008303866)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'de'
,p_message_text=>'Bericht zu Seitenansichten, nach Benutzer zusammengefasst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437475673303867)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99437958024303867)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Zugriffskontrolleinstellungen \00E4ndern und Zugriffskontrolle deaktivieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438811339303868)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99438988170303868)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'de'
,p_message_text=>'Das von dieser Anwendung gesendete E-Mail-Log anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446498056303046)
,p_name=>'CA.ADVANCED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Erweitert</strong> - Damit k\00F6nnen Sie erweiterte Optionen einblenden.'),
'    <ul>',
unistr('      <li><strong>Als Homepage festlegen</strong> - Legen Sie diese Seite als Homepage f\00FCr die Anwendung fest.<br>'),
'      &nbsp;&nbsp;&nbsp;Alle zuvor als Homepage definierten Seiten werden aktualisiert.</li>',
unistr('      <li><strong>Als Administrationsseite festlegen</strong> - F\00FCgen Sie diese Seite unter "Administration" und nicht als normale Seite in der Anwendung hinzu. Greifen Sie darauf zu, indem Sie im Hauptmen\00FC auf "Administration" klicken und die Seite ')
||unistr('in der Liste "Anwendungsadministration" ausw\00E4hlen.<br>'),
'        <em><strong>Hinweis:</strong> Eine Seite kann nicht sowohl Homepage als auch Administrationsseite sein.</em></li>',
'      &nbsp;<br>',
unistr('      <li><strong>Hilfe zu den Seiten</strong> - Geben Sie Text ein, der dem Hilfetext f\00FCr die Seite hinzugef\00FCgt werden soll.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333548719302952)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
' <li><strong>Erweitert</strong> - Blenden Sie erweiterte Optionen ein.',
'    <ul>',
unistr('      <li><strong>Hilfe zu den Seiten</strong> - Geben Sie Text ein, der zum Hilfetext f\00FCr die Seite hinzugef\00FCgt werden soll.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473737000303897)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Einstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473834446303897)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Legen Sie zus\00E4tzliche Definitionen, Sicherheit und Globalisierungseinstellungen fest. Diese Einstellungen k\00F6nnen w\00E4hrend der Erstellung der Anwendung festgelegt und nach der Erstellung auch bearbeitet werden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475761817303898)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'de'
,p_message_text=>'<p>Weitere Informationen zu den jeweiligen Einstellungen finden Sie in der entsprechenden Hilfe ( <span class="fa fa-question-circle" aria-hidden="true"></span> ).</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481585939303903)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'de'
,p_message_text=>'Nach Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462996971303887)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'de'
,p_message_text=>unistr('HTML f\00FCr "Nach Zeilen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466036439303890)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'de'
,p_message_text=>'Alle Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462128526303887)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'de'
,p_message_text=>'Opt-out zulassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671578754303226)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungen im eingeschr\00E4nkten Modus zulassen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455522524303882)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'de'
,p_message_text=>'Anwendungsfehlerlog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451498380303878)
,p_name=>'CA.APP.NAME'
,p_message_language=>'de'
,p_message_text=>'Anwendungsname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721538282303272)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'de'
,p_message_text=>'Gibt an, ob die Zugriffskontrolle eingeschaltet ist oder nicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721614170303272)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'de'
,p_message_text=>'Die Standardzugriffsebene, die authentifizierten Benutzern erteilt wird, die nicht in der Access-Control-Liste enthalten sind'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451857186303879)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellungen wurden aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451686585303878)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'de'
,p_message_text=>'Kurzbeschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451781853303878)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'de'
,p_message_text=>'Der hier eingegebene Text wird auf der Homepage der Anwendung unter dem Anwendungsnamen angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441159162303870)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Darstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441278176303870)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Definieren Sie das Standardfarbschema f\00FCr die Anwendung (Theme-Stil), die Position der Navigation und das f\00FCr die Anwendung verwendete Symbol.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460616291303886)
,p_name=>'CA.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447789016303875)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Darstellung der Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441734485303870)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'de'
,p_message_text=>'Anwendungssymbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441808129303870)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Klicken Sie auf <strong>Neues Symbol ausw\00E4hlen</strong>, um die Symbolfarbe und eines der verf\00FCgbaren Symbole auszuw\00E4hlen. Ihre Auswahl wird auf der Homepage der Anwendung angezeigt.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442186912303871)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442219090303871)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie eine eindeutige, numerische ID f\00FCr die Anwendung ein. Dieses Feld enth\00E4lt standardm\00E4\00DFig eine automatisch generierte ID.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461229224303886)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'de'
,p_message_text=>'Anwendungsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453474619303880)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-Sessions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432001901303862)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430980552303862)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'de'
,p_message_text=>'Anwendungsname und Kurzbeschreibung festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432111071303863)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erm\00F6glichen Sie Anwendungsadministratoren, verschiedene Einstellungen zu aktualisieren, beispielsweise den Namen und eine Beschreibung der Anwendung, die Standardzeitzone und mehr.</p>'),
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
unistr('<li>Listeneintrag und Formular f\00FCr Administrationsseite</li>'),
unistr('<li>M\00F6glichkeit zum Festlegen des Anwendungsnamens</li>'),
unistr('<li>M\00F6glichkeit zum Festlegen eines Untertitels in der Hero-Region der Homepage</li>'),
unistr('<li>M\00F6glichkeit zum Festlegen von Feedbackempf\00E4ngern, falls Feedback verwendet wird</li>'),
unistr('<li>M\00F6glichkeit zum Festlegen einer Standardzeitzone f\00FCr die Anwendung</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486622796303907)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'de'
,p_message_text=>'Anwendungselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488494490303908)
,p_name=>'CA.APPLY'
,p_message_language=>'de'
,p_message_text=>'Anwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490210642303910)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsstandardwerte werden angewendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446981961303875)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen anwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488289395303908)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filter anwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808867210303343)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'de'
,p_message_text=>'Anwendung wurde mit Assistent zum Erstellen von Anwendungen %0 erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810124138303344)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'de'
,p_message_text=>'Einstellung speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492417765303912)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'Anhang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548350305303128)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Anzahl von Anh\00E4ngen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492502797303912)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'de'
,p_message_text=>'Anhangname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548201728303128)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Anhangsgr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488560927303908)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'de'
,p_message_text=>unistr('Attributstandardwerte wurden bereits definiert f\00FCr: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457706239303883)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'de'
,p_message_text=>'Jeder authentifizierte Benutzer darf auf diese Anwendung zugreifen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442937973303871)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443071047303871)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>W\00E4hlen Sie aus, wie Benutzer in der Anwendung authentifiziert werden sollen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674201832303229)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'de'
,p_message_text=>unistr('Automatisches L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356176203303799)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'de'
,p_message_text=>unistr('Automatisierungsausf\00FChrung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454133958303880)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Durchschnittlich verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718876886303270)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zum Jobbericht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549014055303128)
,p_name=>'CA.BCC'
,p_message_language=>'de'
,p_message_text=>'Bcc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481462333303903)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'de'
,p_message_text=>'Vor Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462800933303887)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'de'
,p_message_text=>unistr('HTML f\00FCr "Vor Zeilen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464342189303889)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Vor Zeileninhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439631654303869)
,p_name=>'CA.BLANK'
,p_message_language=>'de'
,p_message_text=>unistr('Leere Seite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439753337303869)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erstellen Sie eine leere Seite als Platzhalter. Sobald Sie die Anwendung erstellt haben, k\00F6nnen Sie in Page Designer leicht Regionen auf der Seite erstellen.</p>'),
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
'<!--  <li><strong>Seitennavigation einbeziehen</strong> - Aktivieren Sie diese Option, um eine Kartenliste aller anderen in der Anwendung definierten Seiten anzuzeigen.<br>',
'      &nbsp;&nbsp;&nbsp;Diese Option wird in der Regel auf der Homepage Ihrer Anwendung verwendet.</li>',
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473079798303896)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-Blueprint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473122363303896)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Im Blueprint ist die Anwendungsdefinition im JSON-Format angegeben.</p>',
unistr('<p>Wenn Sie diese Seite zum ersten Mal \00F6ffnen, wird die aktuelle Anwendungsdefinition in ein JSON-Dokument umgewandelt und angezeigt. Sie k\00F6nnen das Dokument bearbeiten und die Anwendungseigenschaften aktualisieren. Klicken Sie dann auf <strong>Bluep')
||unistr('rint anwenden</strong>, um die aktuellen Anwendungsdetails zu \00E4ndern.</p>'),
'<p>&nbsp;</p>',
unistr('<p>Wenn Sie eine gro\00DFe Anzahl \00E4hnlicher Seiten erstellen m\00FCssen, kopieren Sie den relevanten JSON-Code f\00FCr eine Seite, f\00FCgen Sie ihn mehrmals ein und passen Sie ihn dann geringf\00FCgig an. Diese Methode ist erheblich schneller, als die manuelle Erstellu')
||unistr('ng einzelner Seiten \00FCber <strong>Seite hinzuf\00FCgen</strong>.</p>'),
unistr('<p>Klicken Sie auf <strong>Vorherigen Blueprint laden</strong>, um den Blueprint mit der Definition aus einer zuvor generierten Anwendung zu ersetzen. Auf diese Weise k\00F6nnen Sie ein Anwendungsdesign einfach replizieren, indem Sie zus\00E4tzliche Seiten h')
||unistr('inzuf\00FCgen, die Features \00E4ndern oder die Einstellungen optimieren, bevor Sie die Anwendung erneut generieren.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461701111303886)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Text f\00FCr Hauptteil 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461848469303887)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Text f\00FCr Hauptteil 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481806783303903)
,p_name=>'CA.BOTH'
,p_message_language=>'de'
,p_message_text=>'Beide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448169114303876)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zur Admin-Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445098475303045)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chenleiste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447838663303875)
,p_name=>'CA.BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440317850303869)
,p_name=>'CA.CALENDAR'
,p_message_language=>'de'
,p_message_text=>unistr('Kalenderseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440429641303869)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Erstellen Sie eine Seite, die einen Kalender anzeigt.</p>',
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Tabelle oder View</strong> (Obligatorisch) - W\00E4hlen Sie das Datenbankobjekt f\00FCr den Kalender aus.</li>'),
unistr('  <li><strong>Anzeigespalte</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die in den Kalenderereignissen angezeigt werden soll.</li>'),
unistr('  <li><strong>Startdatumsspalte</strong> (Obligatorisch) - W\00E4hlen Sie die Datumsspalte aus der Tabelle oder View aus, die als Startdatum f\00FCr Kalenderereignisse verwendet werden soll.</li>'),
unistr('  <li><strong>Enddatumsspalte</strong> - W\00E4hlen Sie die Datumsspalte aus der Tabelle oder View aus, die als Enddatum f\00FCr Kalenderereignisse verwendet werden soll.<br>'),
'      &nbsp;&nbsp;&nbsp;Wenn das Enddatum angegeben ist, werden dauerbasierte Ereignisse angezeigt. </li>',
unistr('  <li><strong>Zeit anzeigen</strong> - W\00E4hlen Sie <strong>Ja</strong> aus, um den Zeitanteil f\00FCr Ereignisse anzuzeigen und um Wochen- und Tageskalenderansichten zu aktivieren. W\00E4hlen Sie <strong>Nein</strong> aus, um nur die Datumsangaben f\00FCr Ereigni')
||'sse anzuzeigen.</li>',
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446824974303875)
,p_name=>'CA.CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448715870303876)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'de'
,p_message_text=>'Dialog abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426059787303029)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'de'
,p_message_text=>'Modalmodus abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458603750303884)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen aus Ihrem eigenen Datensatz keine Administrationsrechte entfernen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489441762303909)
,p_name=>'CA.CARD'
,p_message_language=>'de'
,p_message_text=>unistr('Kartenseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489340943303909)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Erstellen Sie eine Seite, die Karten anzeigt.</p>',
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Tabelle oder View</strong> (Obligatorisch) - W\00E4hlen Sie das Datenbankobjekt f\00FCr die Karte aus.</li>'),
unistr('  <li><strong>Kartentitel</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Titel f\00FCr die Karte verwendet werden soll.</li>'),
unistr('  <li><strong>Beschreibungsspalte</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Beschreibung f\00FCr die Karte verwendet werden soll.</li>'),
unistr('  <li><strong>Spalte mit zus\00E4tzlichem Text</strong> - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als sekund\00E4re Beschreibung f\00FCr die Karte verwendet werden soll.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487938478303908)
,p_name=>'CA.CARDS'
,p_message_language=>'de'
,p_message_text=>'Karten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488012828303908)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'de'
,p_message_text=>'Kartenansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549100216303128)
,p_name=>'CA.CC'
,p_message_language=>'de'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809598720303344)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'de'
,p_message_text=>unistr('Filter \00E4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439443230303868)
,p_name=>'CA.CHART'
,p_message_language=>'de'
,p_message_text=>unistr('Diagrammseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439508928303869)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erstellen Sie eine Seite, die entweder ein Fl\00E4chen-, Balken-, Linien- oder Tortendiagramm anzeigt.</p>'),
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Diagrammtyp</strong> - W\00E4hlen Sie den anzuzeigenden Diagrammtyp aus [<strong>Fl\00E4che</strong>, <strong>Balken</strong>, <strong>Linie</strong>, <strong>Torte</strong>].</li>'),
unistr('  <li><strong>Tabelle oder View</strong> (Obligatorisch) - W\00E4hlen Sie das Datenbankobjekt f\00FCr das Diagramm aus.</li>'),
unistr('  <li><strong>Labelspalte</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Label f\00FCr das Diagramm verwendet werden soll.</li>'),
'  <li><strong>Wertaggregation</strong> - Legen Sie fest, wie die Wertspalte angezeigt bzw. aggregiert werden soll<br>',
'      &nbsp;&nbsp;&nbsp;[Spaltenwert, Summe, Anzahl].</li>',
unistr('  <li><strong>Wertspalte</strong> (Obligatorisch) - W\00E4hlen Sie eine numerische Spalte aus der Tabelle oder View aus, die zur Berechnung der angezeigten Diagrammwerte verwendet wird.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439820336303869)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>Beispiele</h3>',
'<p>Sehen Sie sich die Beispiele zur Verwendung der unterschiedlichen <strong>Zusammenfassung</strong>stypen an:</p>',
unistr('<p><strong>Beispiel 1:</strong> Zeigen Sie ein Mitarbeiterdiagramm mit der Personalnummer des Managers f\00FCr jeden Mitarbeiter an.'),
'<code><ul>',
unistr('  <li>Tabelle oder View - W\00E4hlen Sie EMP.</li>'),
unistr('  <li>Labelspalte - W\00E4hlen Sie ENAME.</li>'),
unistr('  <li>Zusammenfassung - W\00E4hlen Sie <u><strong>Spaltenwert</strong></u>.</li>'),
unistr('  <li>Wertspalte - W\00E4hlen Sie MGR.</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>Beispiel 2:</strong> Zeigen Sie ein Mitarbeiterdiagramm an, das das Gesamtgehalt f\00FCr jede Stelle zeigt.'),
'<code><ul>',
unistr('  <li>Tabelle oder View - W\00E4hlen Sie EMP.</li>'),
unistr('  <li>Labelspalte - W\00E4hlen Sie JOB.</li>'),
unistr('  <li>Zusammenfassung - W\00E4hlen Sie <u><strong>Summe</strong></u>.</li>'),
unistr('  <li>Wertespalte - W\00E4hlen Sie SAL.</li>'),
'</ul></code>',
'</p>',
'<p><strong>Beispiel 3:</strong> Zeigen Sie ein Mitarbeiterdiagramm an, das die Anzahl der Mitarbeiter in den einzelnen Abteilungen zeigt.',
'<code><ul>',
unistr('  <li>Tabelle oder View - W\00E4hlen Sie EMP.</li>'),
unistr('  <li>Labelspalte - W\00E4hlen Sie DEPTNO.</li>'),
unistr('  <li>Zusammenfassung - W\00E4hlen Sie <u><strong>Anzahl</strong></u>.</li>'),
unistr('  <li>Wertespalte - W\00E4hlen Sie EMPNO.</li>'),
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676209829303231)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'de'
,p_message_text=>'Client-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492682306303912)
,p_name=>'CA.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314134040302938)
,p_name=>'CA.CLOSED'
,p_message_language=>'de'
,p_message_text=>'Geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490676851303910)
,p_name=>'CA.COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467653081303891)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'de'
,p_message_text=>'Spalte 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467778719303891)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'de'
,p_message_text=>'Spalte 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455009587303881)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'de'
,p_message_text=>'Spaltenalias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486480240303907)
,p_name=>'CA.COMMENTS'
,p_message_language=>'de'
,p_message_text=>'Kommentare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452789493303879)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'de'
,p_message_text=>'Komponentenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457503241303883)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'de'
,p_message_text=>'Access Control konfigurieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447949417303875)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Darstellung konfigurieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448012642303875)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'de'
,p_message_text=>'<p>Die Darstellung der Anwendung wird durch den Theme-Stil definiert.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451352511303878)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'de'
,p_message_text=>'Konfigurationsoptionen wurden aktualisiert. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433261439303863)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Konfigurationsoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431543813303862)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'de'
,p_message_text=>'Anwendungsfeatures aktivieren oder deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433370340303863)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Damit k\00F6nnen Anwendungsadministratoren bestimmte Funktionen in der Anwendung aktivieren oder deaktivieren. Dieses Feature ist n\00FCtzlich, wenn Sie Features ausw\00E4hlen, bei denen zus\00E4tzliche Entwicklungsaufgaben ausgef\00FChrt werden m\00FCssen, bevor sie von')
||unistr(' Endbenutzern verwendet werden k\00F6nnen.<br>'),
unistr('Dieses Feature kann auch auf anwendungsspezifische Features ausgedehnt werden. Wenn Entwickler zus\00E4tzliche Erstelloptionen definieren und mit einer spezifischen Funktion in der Anwendung verkn\00FCpfen, k\00F6nnen diese zu den Konfigurationseinstellungen f\00FCr')
||unistr(' Administratoren hinzugef\00FCgt werden. Beispiel: In der App "Customer Tracker" k\00F6nnen Administratoren Features wie Kontakte, Laden von Daten, Geografie und mehr aktivieren oder deaktivieren.'),
'</p>',
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
unistr('<li>Anwendungsfunktionen k\00F6nnen aktiviert und deaktiviert werden</li>'),
unistr('<li>Je nach Deployment k\00F6nnen selektive Features erm\00F6glicht werden</li>'),
unistr('<li>Erm\00F6glicht die Gruppierung zusammengeh\00F6riger Anwendungseinstellungen</li>'),
unistr('<li>Anwendungsentwickler k\00F6nnen Komponenten mit Erstelloptionen steuern</li>'),
unistr('<li>Verf\00FCgbar \00FCber die Administrationsseite</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671170729303226)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Zugangsdatenname f\00FCr Anmeldung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671299627303226)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Zugangsdateneigent\00FCmer f\00FCr Anmeldung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337616141303783)
,p_name=>'CA.CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Kontext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458023250303884)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'de'
,p_message_text=>'Beitragender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678168895303233)
,p_name=>'CA.CPU.USED'
,p_message_language=>'de'
,p_message_text=>'Belegte CPU'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466507233303890)
,p_name=>'CA.CREATE'
,p_message_language=>'de'
,p_message_text=>'Erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471666067303895)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'de'
,p_message_text=>'Administrationsseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469201727303892)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'de'
,p_message_text=>'Anwendung wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470300910303893)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnungen werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469658329303893)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'de'
,p_message_text=>'Anwendungssymbol wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470279276303893)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'de'
,p_message_text=>'Anwendungselemente werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470474591303894)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozesse werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346704094303791)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellungen werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476550506303899)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720077414303271)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsrollen werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469857769303893)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschemas werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470649595303894)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'de'
,p_message_text=>'Leere Seite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469778602303893)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'de'
,p_message_text=>'Erstelloptionen werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471032816303894)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'de'
,p_message_text=>'Kalenderseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482829082303904)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'de'
,p_message_text=>'Kartenseite erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470803103303894)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'de'
,p_message_text=>'Diagrammseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471373219303895)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite mit klassischem Bericht wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470984080303894)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'de'
,p_message_text=>'Dashboard-Seite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469126641303892)
,p_name=>'CA.CREATE.END'
,p_message_language=>'de'
,p_message_text=>'Fertigstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490168616303910)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'de'
,p_message_text=>'Facet-Suchseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471953468303895)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'de'
,p_message_text=>'Features werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487419790303908)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite mit gefilterten Inhalten erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470766875303894)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'de'
,p_message_text=>'Formularseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469301179303893)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'de'
,p_message_text=>'Globale Seite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471511820303895)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'de'
,p_message_text=>'Navigationsliste der Homepage wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471418222303895)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite mit interaktivem Grid wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471258602303895)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite mit interaktivem Bericht wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180683659302831)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'de'
,p_message_text=>'Kartenseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476210223303899)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'de'
,p_message_text=>'Master/Detail-Seiten erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470095657303893)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleisten werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473286066303896)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'de'
,p_message_text=>'Seitengruppe erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471835022303895)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbersetzung wird ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471763248303895)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbersetzung von %0 wird ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99471163930303895)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'de'
,p_message_text=>'Bericht- und Formularseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476452567303899)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'de'
,p_message_text=>'Blueprint speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470151019303893)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'de'
,p_message_text=>unistr('Verkn\00FCpfung wird erstellt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99470513994303894)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'de'
,p_message_text=>'Anmeldeseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180315326302831)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite "Intelligente Filter erstellen"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469088142303892)
,p_name=>'CA.CREATE.START'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469404419303893)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objektskripte werden erstellt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469912152303893)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'de'
,p_message_text=>'Textnachrichten werden erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482946038303904)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'de'
,p_message_text=>'Timelineseite erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490306482303910)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'de'
,p_message_text=>'Assistentenseite wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450671957303878)
,p_name=>'CA.CREATED'
,p_message_language=>'de'
,p_message_text=>'Erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450722349303878)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'de'
,p_message_text=>'Erstellt von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439114870303868)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung wird erstellt ...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671850931303227)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'de'
,p_message_text=>'Zugangsdatenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678017234303233)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer der Zugangsdaten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451233907303878)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'de'
,p_message_text=>'Aktueller Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472237529303895)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761042629303306)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniertes Theme verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761161637303306)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Legen Sie fest, dass der Assistent ein benutzerdefiniertes Theme anstelle des Universal Themes verwendet.</p>',
'',
unistr('<p>W\00E4hlen Sie ein Workspace Theme f\00FCr die Anwendung aus. Wenn das Theme Theme-Stile unterst\00FCtzt, k\00F6nnen Sie auch den Stil ausw\00E4hlen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425790748303029)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniertes Theme'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472848939303896)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'de'
,p_message_text=>unistr('Dashboard-Seite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336621712303783)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'de'
,p_message_text=>'Diagramm %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472912562303896)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Erstellen Sie eine Dashboard-Seite mit mehreren Diagrammen.</p>',
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
'  </ul>',
'</ul>',
'&nbsp;<br>',
'<p>Jedes Diagramm (Diagramm 1, Diagramm 2, Diagramm 3 und Diagramm 4) hat einen anderen Diagrammtyp als Standard und basiert auf <em>Beispieldaten</em>. ',
unistr('  Daher m\00FCssen Sie keine weiteren Details zum Hinzuf\00FCgen dieser Seite eingeben.'),
unistr('  Sie k\00F6nnen allerdings jedes Diagramm anpassen, indem Sie die Standardwerte durch eigene Werte ersetzen.<br>'),
'  Geben Sie die folgenden Attribute ein, um ein Diagramm anzupassen:</p>',
'<ul>',
unistr('  <li><strong>Diagrammname</strong> (Obligatorisch) - Geben Sie den Namen f\00FCr das Diagramm ein.</li>'),
unistr('  <li><strong>Diagrammtyp</strong> - W\00E4hlen Sie den anzuzeigenden Diagrammtyp aus [<strong>Fl\00E4che</strong>, <strong>Balken</strong>, <strong>Linie</strong>, <strong>Torte</strong>].</li>'),
unistr('  <li><strong>Tabelle oder View</strong> (Obligatorisch) - W\00E4hlen Sie das Datenbankobjekt f\00FCr das Diagramm aus.</li>'),
unistr('  <li><strong>Labelspalte</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Label f\00FCr das Diagramm verwendet werden soll.</li>'),
'  <li><strong>Wertaggregation</strong> - Legen Sie fest, wie die Wertspalte angezeigt bzw. aggregiert werden soll<br>',
'      &nbsp;&nbsp;&nbsp;[Spaltenwert, Summe, Anzahl].</li>',
unistr('  <li><strong>Wertspalte</strong> (Obligatorisch) - W\00E4hlen Sie eine numerische Spalte aus der Tabelle oder View aus, die zur Berechnung der angezeigten Diagrammwerte verwendet wird.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483576946303904)
,p_name=>'CA.DATATYPE'
,p_message_language=>'de'
,p_message_text=>'Datentyp'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484615246303905)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'de'
,p_message_text=>'Datumsformatmaske'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451955519303879)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'de'
,p_message_text=>'Standardzeitzone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452000765303879)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'de'
,p_message_text=>'Standardzeitzone wurde aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473634968303897)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Standardwerte Anwendungsattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473961715303897)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Mit diesem JSON-Dokument haben Sie feingranulierte Steuerung \00FCber die Generierung von Namen f\00FCr Berichts- und Formularspalten, Formatmasken usw. Sie k\00F6nnen auch Wertelisten und andere gemeinsame Komponenten definieren. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489970702303910)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'de'
,p_message_text=>'Wertelistenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490032535303910)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCgen Sie ein Wertelistenattribut hinzu. Wertelisten k\00F6nnen in Tabellenspaltendefinitionen verwendet werden.</p>'),
'<p>Geben Sie die folgenden Attribute ein:',
'  <ul>',
unistr('    <li><strong>Name</strong> (obligatorisch): Geben Sie den Namen f\00FCr die Werteliste ein.</li>'),
unistr('    <li><strong>Typ</strong>: W\00E4hlen Sie den Wertelistentyp [Strukturiert, Dynamisch, Statisch] aus.<br>'),
unistr('      F\00FCr den Typ <u>Strukturiert</u>:'),
'      <ul>',
unistr('          <li><strong>Tabelle</strong> (obligatorisch): W\00E4hlen Sie die Tabelle oder View aus, auf der die Werteliste basieren soll.</li>'),
unistr('          <li><strong>Anzeigespalte</strong> (obligatorisch): W\00E4hlen Sie die Spalte aus, die Endbenutzern angezeigt werden soll.</li>'),
unistr('          <li><strong>Schl\00FCsselspalte</strong> (obligatorisch): W\00E4hlen Sie den Spaltenwert aus, der zur\00FCckgegeben werden soll. Dies ist im Allgemeinen der Prim\00E4rschl\00FCssel f\00FCr die Tabelle.</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      F\00FCr den Typ <u>Dynamisch</u>:'),
'      <ul>',
unistr('          <li><strong>SQL-Abfrage</strong> (obligatorisch): Geben Sie eine g\00FCltige SQL-SELECT-Anweisung ein, die zwei Werte zur\00FCckgibt (Anzeigewert und R\00FCckgabewert).</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      F\00FCr den Typ <u>Statisch</u>:'),
'      <ul>',
unistr('          <li><strong>Statische Werteliste</strong> (obligatorisch): Geben Sie eine g\00FCltige statische Liste in einem der folgenden Formate ein:'),
'          <ul>',
'            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>Liste wird in der Eingabereihenfolge angezeigt</li>',
'            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>Liste wird alphabetisch sortiert</li>',
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>Anzeigewert und R\00FCckgabewert sind identisch</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491145536303911)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'de'
,p_message_text=>'Berichtsattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491221141303911)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bearbeiten Sie die Attribute f\00FCr alle Berichte.</p>'),
'<p>Geben Sie die folgenden Attribute ein:',
'  <ul>',
unistr('    <li><strong> Zeilen pro Seite</strong>: Geben Sie an, wie viele Berichtszeilen standardm\00E4\00DFig angezeigt werden sollen.</li>'),
'    <li><strong>Paginierungsmethode</strong>: Legen Sie fest, wie die Berichtspaginierung angezeigt wird.</li>',
unistr('    <li><strong>Zahlenformatmaske</strong>: Geben Sie die Formatmaske f\00FCr Zahlenspalten und -elemente ein.</li>'),
unistr('    <li><strong>Datumsformatmaske</strong>: Geben Sie die Formatmaske f\00FCr Datumsspalten und -elemente ein.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490991042303910)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabellenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490779448303910)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'de'
,p_message_text=>'Tabellenspaltenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490810584303910)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bearbeiten Sie die Attribute f\00FCr die ausgew\00E4hlte Tabellenspalte.</p>'),
'<p>Geben Sie die folgenden Attribute ein:',
'  <ul>',
unistr('    <li><strong>Tabelle</strong> (nur Anzeige): Die verkn\00FCpfte Tabelle.</li>'),
'    <li><strong>Spalte</strong> (nur Anzeige): Die Spalte, mit der die Attribute definiert sind.</li>',
unistr('    <li><strong>Label</strong>: Geben Sie das Label f\00FCr Berichts\00FCberschriften und Formularlabels ein.</li>'),
unistr('    <li><strong>Formularsteuerelement</strong>: W\00E4hlen Sie den Elementtyp f\00FCr Formulare.</li>'),
unistr('    <li><strong>Werteliste</strong>: W\00E4hlen Sie eine vorhandene Werteliste, mit der benutzerfreundliche Namen entsprechend angezeigt werden.</li>'),
'    <li><strong>Formatmaske</strong>: Geben Sie eine geeignete Formatmaske basierend auf dem Spaltentyp ein (Text, Zahl, Datum usw.).</li>',
unistr('    <li><strong>Statischer Standardwert</strong>: Geben Sie einen Textstandardwert f\00FCr die Spalte ein.</li>'),
'    <li><strong>In Formulare aufnehmen</strong>: Klicken Sie auf "Ja", wenn die Spalte in Formulare aufgenommen werden soll.</li>',
'    <li><strong>In Berichten aufnehmen</strong>: Klicken Sie auf "Ja", wenn die Spalte in Berichte aufgenommen werden soll.</li>',
unistr('    <li><strong>Erforderlich</strong>: Klicken Sie auf "Ja", wenn in Formularen Daten in diese Spalte eingegeben werden m\00FCssen.</li>'),
unistr('    <li><strong>Hilfe</strong>: Geben Sie Hilfetext ein, der dem Attribut zur Elementhilfe hinzugef\00FCgt wird.</li>'),
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491030917303911)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bearbeiten Sie die Attribute f\00FCr die ausgew\00E4hlte Tabelle.</p>'),
'<p>Geben Sie die folgenden Attribute ein:',
'  <ul>',
unistr('    <li><strong>Tabelle</strong> (nur Anzeige): Die verkn\00FCpfte Tabelle.</li>'),
unistr('    <li><strong>Label, Singular</strong> (obligatorisch): Geben Sie das Label f\00FCr Formularseiten ein.</li>'),
unistr('    <li><strong>Label, Plural</strong> (obligatorisch): Geben Sie das Label f\00FCr Regions\00FCberschriften und Seitennamen ein.</li>'),
unistr('    <li><strong>Prim\00E4re Anzeigespalte</strong>: W\00E4hlen Sie die erste anzuzeigende Spalte (z.B. in Kartenregionen).</li>'),
unistr('    <li><strong>Sekund\00E4re Anzeigespalte</strong>: W\00E4hlen Sie die zweite anzuzeigende Spalte (z.B. in Kartenregionen).</li>'),
unistr('    <li><strong>Prim\00E4rschl\00FCsselspalte</strong>: W\00E4hlen Sie die eindeutige Prim\00E4rschl\00FCsselspalte f\00FCr die Tabelle.</li>'),
unistr('    <li><strong>Beschreibung</strong>: Geben Sie eine Beschreibung f\00FCr die Tabelle ein.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671698500303226)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'de'
,p_message_text=>unistr('Verz\00F6gertes L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485276075303906)
,p_name=>'CA.DEFINITION'
,p_message_language=>'de'
,p_message_text=>'Definition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468950945303892)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Deinstallation abgeschlossen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449272681303876)
,p_name=>'CA.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468509222303892)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Soll dieser L\00F6schvorgang ausgef\00FChrt werden?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434828866303865)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie diese Seite wirklich l\00F6schen?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459057599303884)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'de'
,p_message_text=>unistr('Foto l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449943385303877)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467122676303891)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467077660303891)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448239777303876)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'de'
,p_message_text=>'Desktop-Theme-Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448313000303876)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Der Standard-Theme-Stil gilt f\00FCr alle Benutzer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672077397303227)
,p_name=>'CA.DESTINATION'
,p_message_language=>'de'
,p_message_text=>'Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672103543303227)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Zieleigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425806745303029)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Dialogfeldschaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463545030303888)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'de'
,p_message_text=>unistr('E-Mails \00FCbermitteln')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482052692303903)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'de'
,p_message_text=>'Legt fest, ob E-Mails vom E-Mail-Framework gesendet werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449755272303877)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'de'
,p_message_text=>'Anzeigen von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449659408303877)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Anzeigereihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449811739303877)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'de'
,p_message_text=>'Anzeigen bis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483709674303905)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Anzeigespalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453351462303880)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466639767303890)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473549168303896)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'de'
,p_message_text=>'Ziehen, um Seite neu anzuordnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446579540303046)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr('  <li><strong>Drilldown-Link</strong> - Damit k\00F6nnen Sie Attribute zum Definieren eines Drilldown-Links einblenden.'),
'&nbsp;<br>',
'    <em><strong>Hinweis:</strong> "Drilldown-Link" wird nur angezeigt, wenn die aktuelle Seite auf einer Tabelle oder View basiert und den Berichtstyp "Interaktiver Bericht" aufweist und Sie einen Bericht (Interaktiver Bericht) oder eine Master-Detai'
||'l-Seite (Master-Detail) definiert haben.</em>',
'  <ul>',
unistr('    <li><strong>Linkspalte</strong> - W\00E4hlen Sie die Spalte aus, die in eine Linkspalte im Bericht ge\00E4ndert werden soll.</li>'),
unistr('    <li><strong>Linkschl\00FCssel</strong> - W\00E4hlen Sie die Linkschl\00FCssel-(Fremdschl\00FCssel-)Spalte aus, mit der der jeweilige Datensatz in der zu verlinkenden Seite identifiziert wird.</li>'),
unistr('    <li><strong>Link zur Seite</strong> - W\00E4hlen Sie die Berichts- oder Formularseite aus, zu der der Link navigiert.</li>'),
unistr('    <li><strong>Zielschl\00FCssel</strong> - W\00E4hlen Sie die Zielschl\00FCssel-(Prim\00E4rschl\00FCssel-)Spalte in der Tabelle aus, zu der der Link navigiert und auf der er basiert.'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452482620303879)
,p_name=>'CA.ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435043009303865)
,p_name=>'CA.EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Framework'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481623521303903)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Adressen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491614771303911)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434996619303865)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion zum Konfigurieren und Senden von E-Mails hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99435134244303865)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die Funktion zum Senden von E-Mails aus Ihrer Anwendung heraus hinzuf\00FCgen. Mit dem Beispiel-E-Mail-Template k\00F6nnen Sie professionell gestaltete E-Mails an Benutzer senden. Die gesendeten E-Mails werden protokolliert, damit Administratoren die E-Ma')
||unistr('il-Aktivit\00E4t verfolgen k\00F6nnen.</p>'),
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
'<li>Erweiterbares HTML-E-Mail-Templatesystem</li>',
unistr('<li>PL/SQL-Package zum Senden von E-Mails \00FCber APEX-Packages</li>'),
unistr('<li>Logging von E-Mail-Aktivit\00E4t und -Status</li>'),
'<li>Administrative UI zur Verwaltung von Templates</li>',
'<li>Administrative UI zur Anzeige von E-Mail-Logs</li>',
'<li>Administrative UI zum Senden von E-Mails</li>',
'</ul>',
'</p>',
unistr('<p><em>Hinweis: Dieses Feature wird aktiviert, wenn "Feedback" ausgew\00E4hlt ist</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487332518303907)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'de'
,p_message_text=>'E-Mail von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462553704303887)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492271037303911)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Angaben zu E-Mail-Einstellungen erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491750584303911)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Absenderadresse ist keine g\00FCltige E-Mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483297788303904)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Absenderadresse ist keine g\00FCltige E-Mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482480233303904)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'de'
,p_message_text=>'E-Mail verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549477461303129)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721711304303273)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'de'
,p_message_text=>'Bericht mit allen in der Sendequeue enthaltenen und bereits gesendeten E-Mails'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463428435303888)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Einstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463801834303888)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Einstellungen wurden aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487761200303908)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463988298303888)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'de'
,p_message_text=>'Details E-Mail-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970169978303479)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'de'
,p_message_text=>unistr('Geplanter Ausfall f\00FCr #SERVICE_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768426323303312)
,p_name=>'CA.EMAIL2'
,p_message_language=>'de'
,p_message_text=>'E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462494901303887)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'de'
,p_message_text=>'Gesendete E-Mails'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491810790303911)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Anh\00E4nge aktivieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677139042303232)
,p_name=>'CA.ENABLED'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674340560303229)
,p_name=>'CA.END.DATE'
,p_message_language=>'de'
,p_message_text=>'Enddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464511354303889)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Nach Zeileninhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355829668303799)
,p_name=>'CA.ENDED'
,p_message_language=>'de'
,p_message_text=>'Beendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479512205303901)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzernamen hier eingeben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453088188303880)
,p_name=>'CA.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455343029303881)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'de'
,p_message_text=>'Fehler-Backtrace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455291343303881)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'de'
,p_message_text=>'Fehlercode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454591855303881)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678895731303234)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'de'
,p_message_text=>'Fehlernummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677890887303233)
,p_name=>'CA.ERRORS'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356078801303799)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'de'
,p_message_text=>'Fehlerzeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674728512303230)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'de'
,p_message_text=>'Ereignisbedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674816353303230)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'de'
,p_message_text=>'Agent der Ereignisqueue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674957984303230)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'de'
,p_message_text=>'Name der Ereignisqueue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675024876303230)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer der Ereignisqueue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674626558303230)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'de'
,p_message_text=>'Ereignisregel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479843183303901)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'de'
,p_message_text=>'Ausnahmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492743707303912)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'de'
,p_message_text=>'Erfahrung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676878940303232)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Nicht erfolgreich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451006562303878)
,p_name=>'CA.FEATURE'
,p_message_language=>'de'
,p_message_text=>'Feature'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125663730303605)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsversion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125754216303605)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809912421303344)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer zur Access-Control-Liste hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809733767303344)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Gehe zum n\00E4chsten Schritt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809876642303344)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'de'
,p_message_text=>'Collections erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809648269303344)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'de'
,p_message_text=>unistr('Der letzte Administrator kann nicht ge\00E4ndert werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125301737303605)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Letzte Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809481305303344)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurden keine Aktivit\00E4ten gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125517656303605)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'de'
,p_message_text=>'Grund'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810018653303344)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Mindestens ein Feedbackeintrag erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810368394303345)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'de'
,p_message_text=>'Datei-ID abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808920809303343)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'de'
,p_message_text=>'Theme-Stil speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809054149303344)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'de'
,p_message_text=>'Endbenutzer-Stilvoreinstellung speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125413489303605)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439265272303868)
,p_name=>'CA.FEATURES'
,p_message_language=>'de'
,p_message_text=>'Features'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439336069303868)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Features liefern Funktionen auf Anwendungsebene und werden in der Regel einmal pro Anwendung hinzugef\00FCgt. W\00E4hlen Sie die Features aus, die in Ihre Anwendung aufgenommen werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433107173303863)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431135864303862)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'de'
,p_message_text=>'Benutzerfeedback zulassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433068047303863)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Stellen Sie ein Verfahren f\00FCr Endbenutzer bereit, mit dem diese allgemeine Kommentare an die Anwendungsadministratoren und -entwickler senden k\00F6nnen. Die Posts enthalten n\00FCtzliche Informationen zum Sessionstatus, anhand derer leichter bestimmt wer')
||unistr('den kann, von wo der Endbenutzer das Feedback gesendet hat. Die Bereitstellung einer solch einfachen Feedbackschleife erleichtert die Kommunikation zwischen der Benutzercommunity und den Anwendungseigent\00FCmern, was zu einer deutlich h\00F6heren Zufriedenh')
||unistr('eit der Endbenutzer f\00FChrt.</p>'),
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
unistr('<li>M\00F6glichkeit f\00FCr Endbenutzer, durch Klicken auf ein Symbol in der Navigationsleiste Feedback abzugeben</li>'),
'<li>Administrativer Bericht zum Anzeigen und Aktualisieren von Feedback</li>',
'<li>Feedback erfasst Informationen zu Benutzer, Datum und Uhrzeit sowie Benutzer-Agent</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493181988303912)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Feedback zu Ihrer Erfahrung an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492181262303911)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'de'
,p_message_text=>'Senden an'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491538546303911)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Feedbackeinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460543954303886)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'de'
,p_message_text=>'Feedbackeinstellungen aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492387021303912)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Feedback weitergeleitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674417557303229)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'de'
,p_message_text=>'Name File-Watcher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674546336303230)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('File-Watcher-Eigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332621934302951)
,p_name=>'CA.FILED'
,p_message_language=>'de'
,p_message_text=>'Eingereicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332788476302952)
,p_name=>'CA.FILED.BY'
,p_message_language=>'de'
,p_message_text=>'Eingereicht von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487875634303908)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht filtern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464924138303889)
,p_name=>'CA.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490530482303910)
,p_name=>'CA.FINISH'
,p_message_language=>'de'
,p_message_text=>'Fertigstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459223721303885)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'de'
,p_message_text=>'Vorname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671494021303226)
,p_name=>'CA.FLAGS'
,p_message_language=>'de'
,p_message_text=>'Flags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440671525303869)
,p_name=>'CA.FORM'
,p_message_language=>'de'
,p_message_text=>unistr('Formularseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440501822303869)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erstellen Sie eine Seite, auf der eine Formularseite angezeigt wird, auf der Endbenutzer Daten verwalten k\00F6nnen.</p>'),
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Tabelle</strong> (Obligatorisch) - W\00E4hlen Sie die Tabelle f\00FCr das Formular aus.</li>'),
unistr('<li><strong>Bericht einbeziehen</strong> (Obligatorisch) - W\00E4hlen Sie diese Option aus, um einen Bericht und ein Formular zu erstellen. Die erste Seite ist ein interaktiver Bericht. Jede Zeile enth\00E4lt einen Link zu einem Formular, in dem Benutzer den')
||unistr(' Datensatz aktualisieren k\00F6nnen. </li>'),
'  &nbsp;<br>',
unistr('<li><strong>Erweitert</strong> - Damit k\00F6nnen Sie erweiterte Optionen einblenden.'),
'     <ul>',
unistr('      <li><strong>Hilfe zu den Seiten</strong> - Geben Sie Text ein, der dem Hilfetext f\00FCr die Seite hinzugef\00FCgt werden soll.</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445148727303045)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Region f\00FCr Formularelemente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466832961303891)
,p_name=>'CA.FORM.ON'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479373393303901)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der Formulartyp ist kein g\00FCltiger Typ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485757815303906)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'de'
,p_message_text=>'Formatmaske'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484744671303905)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'de'
,p_message_text=>'Formularsteuerelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450404308303877)
,p_name=>'CA.FROM'
,p_message_language=>'de'
,p_message_text=>'Von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463651409303888)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'de'
,p_message_text=>'Absenderadresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487224321303907)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Einstellung "Absenderadresse"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483136966303904)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'de'
,p_message_text=>'Von E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483091147303904)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'de'
,p_message_text=>'Von wem'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176049436303644)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'de'
,p_message_text=>'%0 Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453901609303880)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'de'
,p_message_text=>'Ganze Seitenansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462616738303887)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'de'
,p_message_text=>unistr('HTML f\00FCr vollst\00E4ndiges Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484260801303905)
,p_name=>'CA.FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433591623303864)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Globale Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431316634303862)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Suchfunktion f\00FCr Anwendung bereitstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433476417303864)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erm\00F6glichen Sie Endbenutzern, in wichtigen Tabellen oder Views der Anwendung nach Text zu suchen. Die Seite "Erweiterte Suche" enth\00E4lt Filter, mit denen Endbenutzer ihre Suchergebnisse leicht eingrenzen k\00F6nnen.<br>'),
unistr('Bei diesem \00E4u\00DFerst leistungsstarken Feature m\00FCssen einige Entwicklungsaufgaben zur Definition der SQL (basierend auf den bereitgestellten Beispielen) ausgef\00FChrt werden.</p>'),
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
'<li>Zeigt ein Suchsymbol in der Headerleiste an</li>',
unistr('<li>Enth\00E4lt eine Seite mit detaillierten Suchergebnissen mit einem Filter in der seitlichen Leiste</li>'),
'<li>Entwickler muss die SQL implementieren, um die App-Suche zu definieren</li>',
unistr('<li>Enth\00E4lt Beispieldaten zur Veranschaulichung</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676169566303231)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'de'
,p_message_text=>'Globale eindeutige ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808542687303343)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'de'
,p_message_text=>'Globale Seite - Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425901196303029)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'de'
,p_message_text=>'Gehe zur Admin-Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440165568303869)
,p_name=>'CA.GRID'
,p_message_language=>'de'
,p_message_text=>unistr('Seite mit interaktivem Grid hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440215934303869)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erstellen Sie eine Seite, die als interaktives Grid angezeigt wird, das einer Kalkulationstabelle \00E4hnelt. Wenn es editierbar ist, k\00F6nnen Benutzer mehrere Zeilen direkt auf der Seite bearbeiten (wenn "Bearbeitung zulassen" aktiviert ist).</p>'),
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Abfragetyp</strong> - W\00E4hlen Sie die Quelle f\00FCr den Bericht aus [<strong>Tabelle oder View</strong> oder <strong>SQL-Abfrage</strong>].<br>'),
'    <strong>Tabelle oder View</strong>:',
'    <ul>',
unistr('      <li><strong>Tabelle oder View</strong> (Obligatorisch) - W\00E4hlen Sie das Datenbankobjekt f\00FCr das Grid aus.</li>'),
'    </ul>',
'    <strong>SQL-Abfrage</strong>:',
'    <ul>',
unistr('      <li><strong>SQL-Abfrage</strong> (Obligatorisch) - Geben Sie eine g\00FCltige SQL-Anweisung ein, die eindeutige Spalten zur\00FCckgibt.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>Grid-Typ</strong> - Legen Sie fest, ob Benutzer die Zeilen im Grid bearbeiten d\00FCrfen [<strong>Bearbeitung zulassen</strong> oder <strong>Schreibgesch\00FCtzt</strong>]. Um die Bearbeitung zu aktivieren, w\00E4hlen Sie <strong>Bearbeitung zulass')
||'en</strong> aus.</li>',
'  &nbsp;<br>',
unistr('  <em><strong>Warnung:</strong> Wenn Sie den Abfragetyp <strong>SQL-Abfrage</strong> und den Grid-Typ <strong>Bearbeitung zulassen</strong> ausw\00E4hlen und Ihre Abfrage mindestens zwei Tabellen verkn\00FCpft, erzeugt das generierte interaktive Grid Fehler,')
||unistr(' wenn Benutzer versuchen, Datens\00E4tze zu aktualisieren.'),
unistr('Wenn der ausgew\00E4hlte Grid-Typ au\00DFerdem <strong>Bearbeitung zulassen</strong> ist und die Abfrage (oder die ausgew\00E4hlte Tabelle oder View) eine View verwendet, die nicht aktualisiert werden kann, erzeugt das generierte interaktive Grid ebenfalls Fehle')
||unistr('r, wenn Benutzer versuchen, Datens\00E4tze zu aktualisieren.</em><br>'),
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465475303303889)
,p_name=>'CA.HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355663350303798)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Diese Seite enth\00E4lt einen interaktiven Bericht des Automatisierungslogs.</p>'),
unistr('<p>Pr\00FCfen Sie die protokollierten Informationen zu vorherigen Automatisierungsausf\00FChrungen: Das Log enth\00E4lt Start- und Endzeitstempel sowie Details zu verarbeiteten Zeilen (erfolgreich und mit Fehlern). F\00FChren Sie einen Drilldown in "Meldungen" durch')
||unistr(', um einzelne Meldungen f\00FCr verarbeitete Zeilen anzuzeigen.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457857776303883)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie <strong>Nein</strong>, wenn alle Benutzer in der Access Control-Liste definiert sind. W\00E4hlen Sie <strong>Ja</strong>, wenn authentifizierte Benutzer, die nicht in der Access Control-Liste aufgef\00FChrt sind, die Anwendung ebenfalls verwenden ')
||unistr('d\00FCrfen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451562385303878)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der hier eingegebene Text wird in der gesamten Anwendung verwendet, vor allem in der oberen linken Ecke auf jeder Seite. Die \00C4nderung wird f\00FCr den ausf\00FChrenden Administrator umgehend wirksam, aber die anderen Benutzer sehen die \00C4nderung erst bei eine')
||unistr('r neuen Session (zum Beispiel bei der n\00E4chsten Anmeldung).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446194788303874)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'<p>Klicken Sie von einer beliebigen Seite der Anwendung aus auf das Feedbacksymbol ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) in der Navigationsleiste, um den Anwendungsadministratoren Feedback zu geben.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445885353303874)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Dies ist die Homepage der Anwendung. Klicken Sie auf die Karten, um auf die verschiedenen Seiten in der Anwendung zuzugreifen, oder verwenden Sie das Navigationsmen\00FC am seitlichen Rand der Seite.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446043530303874)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Dies ist die Homepage der Anwendung. Klicken Sie auf die Karten, um auf die verschiedenen Seiten in der Anwendung zuzugreifen, oder verwenden Sie das Navigationsmen\00FC am oberen Rand der Seite.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446251965303874)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'de'
,p_message_text=>'<p>Geben Sie auf dieser Seite einen Suchbegriff in das Feld <strong>Anwendung durchsuchen</strong> ein, oder klicken Sie von einer beliebigen Seite aus auf das Suchsymbol ( <span class="fa fa-search" aria-hidden="true"></span> ) in der Navigationslei'
||'ste, um in der Anwendung nach dem Begriff zu suchen.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446582589303874)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Klicken Sie in der Navigationsleiste auf das Dropdown-Men\00FC mit Ihrem Namen, um sich von der Anwendung abzumelden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446424437303874)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Klicken Sie in der Navigationsleiste auf das Benutzermen\00FC ( <span class="fa fa-user" aria-hidden="true"></span> ), um Ihre Zeitzonenvoreinstellung zu aktualisieren und um sich von der Anwendung abzumelden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445940232303874)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'de'
,p_message_text=>'Homepage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446666138303874)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Klicken Sie in der Navigationsleiste (oben rechts auf der Seite) auf das Benutzermen\00FC ( <span class="fa fa-user" aria-hidden="true"></span> ), um auf Ihr Benutzerprofil zuzugreifen und um sich von der Anmeldung abzumelden.<br>'),
unistr('Wenn Sie auf <strong>Mein Profil anzeigen</strong> klicken, k\00F6nnen Sie anschlie\00DFend auf <strong>Profil aktualisieren</strong> klicken, um Ihre pers\00F6nlichen Daten einzugeben und ein Foto oder einen Avatar hochzuladen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446318099303874)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Klicken Sie in der Navigationsleiste auf das Benutzermen\00FC ( <span class="fa fa-user" aria-hidden="true"></span> ), um auf Ihr Benutzerprofil zuzugreifen, Ihre Zeitzonenvoreinstellung zu aktualisieren und um sich von der Anmeldung abzumelden.<br>'),
unistr('Wenn Sie auf <strong>Mein Profil anzeigen</strong> klicken, k\00F6nnen Sie anschlie\00DFend auf <strong>Profil aktualisieren</strong> klicken, um Ihre pers\00F6nlichen Daten einzugeben und ein Foto oder einen Avatar hochzuladen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472448680303896)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zum Suchen von Daten einen Suchbegriff in das Dialogfeld "Suchen" ein, oder klicken Sie auf die Spalten\00FCberschriften, um die zur\00FCckgegebenen Datens\00E4tze einzuschr\00E4nken.</p>'),
'',
unistr('<p>Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreiche Funktionen ausf\00FChren, beispielsweise die angezeigten/ausgeblendeten Spalten und ihre Anzeigereihenfolge ausw\00E4hlen sowie mehrere Daten- und Formatfunktionen ausf')
||unistr('\00FChren. Dar\00FCber hinaus k\00F6nnen Sie mit der Diagrammoption eine zus\00E4tzliche Datenansicht definieren.</p>'),
'',
unistr('<p>Wenn Sie Ihre Anpassungen speichern m\00F6chten, w\00E4hlen Sie "Bericht", oder klicken Sie auf "Herunterladen", um die Daten zu entladen.<p>'),
'<br>',
unistr('<p>Weitere Informationen erhalten Sie, wenn Sie unten im Aktionsmen\00FC auf "Hilfe" klicken.</p>'),
'',
unistr('<p>Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472342386303896)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem interaktiven Grid k\00F6nnen Sie Daten direkt einf\00FCgen, aktualisieren und l\00F6schen.<br>'),
unistr('  F\00FCgen Sie eine neue Zeile ein, indem Sie auf die Schaltfl\00E4che "Zeile hinzuf\00FCgen" klicken.<br>'),
unistr('  Um Datenwerte zu aktualisieren, doppelklicken Sie auf eine Zelle, oder klicken Sie auf die Schaltfl\00E4che <strong>Bearbeiten</strong>, wie bei der Bearbeitung von Daten in einer  Kalkulationstabelle.</p>'),
'',
unistr('<p>\00DCber das Men\00FC "Zeilenaktionen" (<span class="fa fa-bars" aria-hidden="true"></span>) am Anfang des Berichts k\00F6nnen Sie ausgew\00E4hlte Zeilen duplizieren, l\00F6schen, aktualisieren oder wiederherstellen.<br>'),
unistr('  Wenn Sie das Men\00FC "Zeilenaktionen" f\00FCr einzelne Zeilen verwenden, k\00F6nnen Sie auf die Single-Row-Ansicht zugreifen oder eine neue Zeile hinzuf\00FCgen.</p>'),
'',
unistr('<p>Geben Sie zum Suchen von Daten einen Suchbegriff in das Dialogfeld "Suchen" ein, oder klicken Sie auf die Spalten\00FCberschriften, um die zur\00FCckgegebenen Datens\00E4tze einzuschr\00E4nken.</p>'),
'',
unistr('<p>Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreiche Funktionen ausf\00FChren, beispielsweise die angezeigten/ausgeblendeten Spalten und ihre Anzeigereihenfolge ausw\00E4hlen sowie mehrere Daten- und Formatfunktionen ausf')
||unistr('\00FChren. Dar\00FCber hinaus k\00F6nnen Sie mit der Diagrammoption eine zus\00E4tzliche Datenansicht definieren.</p>'),
'',
unistr('<p>Wenn Sie Ihre Anpassungen speichern m\00F6chten, w\00E4hlen Sie "Bericht" aus, oder klicken Sie auf "Herunterladen", um die Daten zu entladen.<p>'),
'',
unistr('<p>Weitere Informationen erhalten Sie, wenn Sie unten im Aktionsmen\00FC auf "Hilfe" klicken.</p> '),
'',
unistr('<p>Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um das interaktive Grid auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445726323303874)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zum Suchen von Daten einen Suchbegriff in das Dialogfeld "Suchen" ein, oder klicken Sie auf die Spalten\00FCberschriften, um die zur\00FCckgegebenen Datens\00E4tze einzuschr\00E4nken.</p>'),
'',
unistr('<p>Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreiche Funktionen ausf\00FChren, beispielsweise die angezeigten/ausgeblendeten Spalten und ihre Anzeigereihenfolge ausw\00E4hlen sowie mehrere Daten- und Formatfunktionen ausf')
||unistr('\00FChren. Dar\00FCber hinaus k\00F6nnen Sie mit den Optionen "Diagramm", "Gruppieren nach" und "Pivot" zus\00E4tzliche Datenansichten definieren.</p>'),
'',
unistr('<p>Wenn Sie Ihre Anpassungen speichern m\00F6chten, w\00E4hlen Sie "Bericht", oder klicken Sie auf "Herunterladen", um die Daten zu entladen. Geben Sie Ihre E-Mail-Adresse und den Zeitrahmen f\00FCr das Abonnement ein, damit Ihnen die Daten regelm\00E4\00DFig zugesendet')
||' werden.<p>',
'',
unistr('<p>Weitere Informationen erhalten Sie, wenn Sie unten im Aktionsmen\00FC auf "Hilfe" klicken.</p>'),
'',
unistr('<p>Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480332360303902)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Berichtsseite werden prim\00E4re Datens\00E4tze in einer Auswahl am Rand der Seite angezeigt. '),
unistr('  W\00E4hlen Sie einen Datensatz, um den Masterdatensatz und alle definierten Detaildatens\00E4tze anzuzeigen.<br> '),
'  Klicken Sie auf das Symbol "Bearbeiten" ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ), um den Masterdatensatz zu bearbeiten.',
unistr('  Die Detaildatens\00E4tze werden angezeigt, wenn Sie am Anfang der jeweiligen Zeilen auf den Stift zur Bearbeitung des Datensatzes klicken.</p>'),
'<p>Um die in der Auswahl angezeigten Daten zu begrenzen, geben Sie im Dialogfeld "Suchen" einen Suchbegriff ein.</p>',
'',
unistr('<p>Um einen neuen Masterdatensatz hinzuzuf\00FCgen, klicken Sie am oberen Rand der Seite auf <strong>Erstellen</strong>.'),
unistr('  Detaildatens\00E4tze werden angezeigt, wenn Sie am oberen Rand der Detailregion auf das Plussymbol (+) klicken, um einen Detaildatensatz hinzuzuf\00FCgen.</p>'),
'',
unistr('<p>Klicken Sie im oberen Bereich der Seite auf <strong>Zur\00FCcksetzen</strong>, um die Seite auf die Standardeinstellungen zur\00FCckzusetzen. Dabei werden alle zuvor definierten Suchbegriffe und Filter entfernt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443793030303872)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf der Administrationsseite k\00F6nnen Anwendungseigent\00FCmer (Administratoren) die Anwendung konfigurieren und allgemeine anwendungsweit verwendete Daten verwalten.'),
unistr('Durch Auswahl einer der verf\00FCgbaren Einstellungen k\00F6nnen Administratoren potenziell \00E4ndern, wie die Anwendung angezeigt wird und/oder welche Features f\00FCr die Endbenutzer zur Verf\00FCgung stehen.</p>'),
unistr('<p>Der Zugriff auf diese Seite sollte ausschlie\00DFlich f\00FCr Administratoren m\00F6glich sein.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444943775303873)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Treffen Sie die passende Auswahl f\00FCr authentifizierte Benutzer.<br>'),
unistr('Wenn Sie <strong>Nein</strong> w\00E4hlen, wird die Anwendung sicherer, da nur bestimmte Benutzer auf die Anwendung zugreifen k\00F6nnen.'),
unistr('Wenn Ihre Anwendung jedoch von einer gro\00DFen Benutzercommunity verwendet und die Verwaltung der Benutzer m\00FChselig wird, kann es ratsam sein, <strong>Ja</strong> zu w\00E4hlen und nur Anwendungsadministratoren und eventuell Beitragende einzugeben.<br>'),
unistr('Wenn Sie <strong>Ja</strong> w\00E4hlen, m\00FCssen Sie auch festlegen, wie Benutzer, die nicht in der Liste enthalten sind, behandelt werden.</p>'),
unistr('<p>W\00E4hlen Sie aus, ob f\00FCr Benutzernamen E-Mail-Adressen oder alphanumerische Werte angegeben werden m\00FCssen.<br>'),
unistr('In der Regel empfiehlt es sich, f\00FCr diese Einstellung <strong>E-Mail-Adresse</strong> festzulegen, wenn Ihre Anwendung ein zentrales Authentifizierungsschema verwendet (bzw. daf\00FCr konfiguriert wird), beispielsweise Oracle Access Manager oder SSO.</p>'),
unistr('<p><em><strong>Hinweis:</strong> Diese Anwendung unterst\00FCtzt die folgenden drei Zugriffsebenen: Leseberechtigter, Beitragender und Administrator.'),
'<ul>',
unistr('  <li><strong>Leseberechtigte</strong> haben schreibgesch\00FCtzten Zugriff auf alle Informationen und k\00F6nnen Berichte anzeigen.</li>'),
unistr('  <li><strong>Beitragende</strong> k\00F6nnen Informationen erstellen, bearbeiten und l\00F6schen sowie Berichte anzeigen.</li>'),
unistr('  <li><strong>Administratoren</strong> k\00F6nnen zus\00E4tzlich zu den Berechtigungen der Beitragenden die Anwendung konfigurieren, indem sie auf den Administrationsbereich der Anwendung zugreifen.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445198138303873)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In diesem Formular geben Sie Benutzer mit ihrer E-Mail-Adresse und Zugriffsebene ein.',
'Die unter <em>Zugriffskontrolle konfigurieren</em> definierten Einstellungen bestimmen, ob der Benutzername die E-Mail-Adresse sein muss oder ein beliebiger alphanumerischer Eintrag sein kann.</p>',
unistr('<p>Diese Anwendung unterst\00FCtzt die folgenden drei Zugriffsebenen: Leseberechtigter, Beitragender und Administrator.</p>'),
'<ul>',
unistr('  <li><strong>Leseberechtigte</strong> haben schreibgesch\00FCtzten Zugriff auf alle Informationen und k\00F6nnen Berichte anzeigen.</li>'),
unistr('  <li><strong>Beitragende</strong> k\00F6nnen Informationen erstellen, bearbeiten und l\00F6schen sowie Berichte anzeigen.</li>'),
unistr('  <li><strong>Administratoren</strong> k\00F6nnen zus\00E4tzlich zu den Berechtigungen der Beitragenden die Anwendung konfigurieren, indem sie auf den Administrationsbereich der Anwendung zugreifen.</li>'),
'</ul>',
unistr('<p>Bei der Bearbeitung eines vorhandenen Benutzers k\00F6nnen Sie dessen Account sperren, um den Benutzer am Zugriff auf die Anwendung zu hindern.</p>'),
unistr('<p><em><strong>Hinweis:</strong> Wenn Oracle Application Express-Accounts verwendet werden, m\00FCssen die hier eingetragenen Benutzer auch von einem Workspace-Administrator, der auch die Kennw\00F6rter festlegen kann, als Endbenutzer definiert werden.</em><')
||'/p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445040827303873)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite zeigt einen Bericht zu den Anwendungsbenutzern und den erteilten Zugriffsebenen.</p>',
unistr('<p>Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen.<br>'),
unistr('Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>'),
unistr('<p>Klicken Sie auf das Symbol "Bearbeiten" (gelber Stift), um die Benutzerdetails und die Zugriffsebene zu bearbeiten oder um den Benutzer zu l\00F6schen.</p>'),
unistr('<p>Klicken Sie am oberen Rand des Berichts auf <strong>Benutzer hinzuf\00FCgen</strong>, um einen neuen Benutzer und dessen Zugriffsebene hinzuzuf\00FCgen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458578050303884)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die Zugriffskontrolle aktiviert ist, k\00F6nnen Administratoren den Zugriff auf bestimmte Anwendungsfeatures f\00FCr authentifizierte Benutzer einschr\00E4nken. Diese Anwendung unterst\00FCtzt die folgenden drei Rollen: Leseberechtigter, Beitragender und Adm')
||'inistrator.<p>',
'<ul>',
unistr('  <li><strong>Leseberechtigte</strong> haben schreibgesch\00FCtzten Zugriff auf alle Informationen und k\00F6nnen Berichte anzeigen.</li>'),
unistr('  <li><strong>Beitragende</strong> k\00F6nnen Informationen erstellen, bearbeiten und l\00F6schen sowie Berichte anzeigen.</li>'),
unistr('  <li><strong>Administratoren</strong> k\00F6nnen zus\00E4tzlich zu den Berechtigungen der Beitragenden auch die Anwendung konfigurieren.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479457048303901)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Benutzernamen getrennt durch Komma, Semikolon oder Leerzeichen ein. Vorhandene oder doppelte Benutzernamen werden automatisch ignoriert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443923583303872)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Konfigurationseinstellungen erm\00F6glichen Ihnen, bestimmte Funktionen f\00FCr Endbenutzer entweder verf\00FCgbar zu machen (zu aktivieren) oder nicht verf\00FCgbar zu machen (zu deaktivieren).</p>'),
unistr('<p>Wenn eine bestimmte Funktion nicht 100-prozentig einsatzbereit ist oder vor\00FCbergehend entfernt werden muss, klicken Sie auf <strong>Deaktiviert</strong>.'),
unistr('Wenn Sie wieder verf\00FCgbar gemacht werden soll, klicken Sie einfach auf <strong>Aktiviert</strong>.</p>'),
unistr('<p><em><strong>Hinweis:</strong> An dieser Stelle vorgenommene \00C4nderungen werden f\00FCr einzelne Endbenutzer, die gerade die Anwendung ausf\00FChren, nicht angezeigt. Wenn sich der Endbenutzer bei der Anwendung ab- und anschlie\00DFend wieder anmeldet, werden d')
||unistr('ie ge\00E4nderten Featureeinstellungen aufgerufen.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444048886303872)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie das Standardfarbschema aus, das f\00FCr die Anzeige der Anwendung verwendet wird.</p>'),
unistr('<p>Wenn <strong>Endbenutzer d\00FCrfen Theme-Stil ausw\00E4hlen</strong> aktiviert ist, kann jeder Endbenutzer durch Klicken auf den Link <em>Anpassen</em> in der unteren linken Ecke der Homepage eine Auswahl aus den verf\00FCgbaren Theme-Stilen treffen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444652441303873)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite bietet einen interaktiven Bericht zu allen unerwarteten Fehlern, die von dieser Anwendung protokolliert werden.</p>',
unistr('<p>Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen. Klicken Sie auf die Schalt')
||unistr('fl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444503481303873)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit diesem Bericht und Diagramm zeigen Sie die Benutzer mit den h\00E4ufigsten Seitenansichten f\00FCr den angegebenen Zeitrahmen an.</p>'),
unistr('<p>W\00E4hlen Sie am oberen Rand der Seite den Zeitrahmen f\00FCr die Berichtserstellung aus (Standard = 1 Tag), und w\00E4hlen Sie dann entweder das Bericht- oder das Diagrammsymbol.</p>'),
unistr('<p>Verwenden Sie bei interaktiven Berichten das Suchfeld, oder w\00E4hlen Sie die Spalten\00FCberschrift <strong>Benutzer</strong>, um einen bestimmten Benutzer auszuw\00E4hlen. Wenn Sie auf die Schaltfl\00E4che <strong>Aktionen</strong> klicken, k\00F6nnen Sie zahlreic')
||unistr('he Funktionen ausf\00FChren, Beispiel: die angezeigten/ausgeblendeten Spalten ausw\00E4hlen, Zeilen pro Seite angeben, filtern usw. Klicken Sie auf die Schaltfl\00E4che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FC')
||'ckzusetzen.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444792102303873)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite bietet einen interaktiven Bericht zur Performance und Beliebtheit der Seite. Der Bericht wird nach <strong>Gewichtete Performance</strong> sortiert, die berechnet wird, indem der Medianwert der verstrichenen Zeit mit der Anzahl der Sei'
||'tenansichten multipliziert wird.</p>',
unistr('<p>W\00E4hlen Sie gegebenenfalls am oberen Rand der Seite den Zeitrahmen f\00FCr die Berichtserstellung (Standard = 1 Tag).<br>'),
unistr('Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen. Klicken Sie auf die Schaltfl\00E4')
||unistr('che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444801769303873)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Diese Seite bietet einen interaktiven Bericht zu den letzten Seitenansichten.</p>',
unistr('<p>W\00E4hlen Sie gegebenenfalls am oberen Rand der Seite den Zeitrahmen f\00FCr die Berichtserstellung (Standard = 1 Tag).<br>'),
unistr('Klicken Sie auf die Spalten\00FCberschriften, um Daten zu sortieren und zu filtern, oder klicken Sie auf die Schaltfl\00E4che <strong>Aktionen</strong>, um die Spaltenanzeige und viele zus\00E4tzliche erweiterte Features anzupassen. Klicken Sie auf die Schaltfl\00E4')
||unistr('che <strong>Zur\00FCcksetzen</strong>, um den interaktiven Bericht auf die Standardeinstellungen zur\00FCckzusetzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443888287303872)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Wenn Benachrichtigungen aktiviert sind, werden diese auf der Homepage angezeigt.</p>',
'<p>Dieser Bericht zeigt an, welche Benachrichtigungen definiert sind und in welchem Zeitraum sie angezeigt werden.</p>',
unistr('<p>Klicken Sie auf das Symbol "Bearbeiten" (gelber Stift), um eine vorhandene Benachrichtigung zu bearbeiten, oder klicken Sie auf <strong>Benachrichtigung hinzuf\00FCgen</strong>, um eine neue Benachrichtigung einzuf\00FCgen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444197606303872)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Anwendungsnamen und eine kurze Beschreibung f\00FCr die Anwendung ein.</p>'),
'<p>Der Name der Anwendung wird auf der Homepage angezeigt. Die Kurzbeschreibung wird unter dem Anwendungsnamen angezeigt.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444347853303872)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Endbenutzer k\00F6nnen Feedback auf allen normalen Seiten der Anwendung eingeben.</p>'),
'<p>Dieser Bericht zeigt das eingegebene Feedback, die Antworten der Administratoren und den Feedbackstatus.</p>',
'<p>Klicken Sie auf das Symbol "Bearbeiten" (gelber Stift), um eine Antwort einzugeben oder den Feedbackstatus zu aktualisieren.</p>',
unistr('<p><em><strong>Hinweis:</strong> Wenn Feedbackempf\00E4nger definiert wurden, wird weitergeleitetes Feedback auch per E-Mail an die in der Liste der Feedbackempf\00E4nger aufgef\00FChrten E-Mail-Adressen gesendet.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460414045303885)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine durch Komma getrennte Liste mit E-Mail-Adressen an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444435877303873)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'de'
,p_message_text=>unistr('<p><strong>Anh\00E4nge aktivieren</strong>: Wenn diese Option auf "Ja" gesetzt ist, k\00F6nnen Benutzer zus\00E4tzlich zum Feedback einen Anhang hochladen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445419713303873)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seite werden die definierten E-Mail-Templates aufgef\00FChrt. Dar\00FCber hinaus wird angegeben, wie h\00E4ufig das Template in gesendeten E-Mails referenziert wurde.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445243980303873)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seite werden die gesendeten E-Mails aufgef\00FChrt.</p>'),
'<p>Klicken Sie auf das Lupensymbol, um weitere Details zu den gesendeten E-Mails anzuzeigen.</p>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445382436303873)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCllen Sie die folgenden Felder aus, um ein E-Mail-Template zu definieren:</p>'),
'<ul>',
unistr('  <li><strong>Templatename</strong> (obligatorisch): Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr das Template ein.</li>'),
unistr('  <li><strong>HTML-Template</strong> (obligatorisch): Geben Sie den HTML-Code zum Erstellen einer E-Mail ein, die an Empf\00E4nger gesendet wird, die die Zustellung von HTML-basierten E-Mails zulassen.'),
unistr('    Die folgenden Substitutionsvariablen sind verf\00FCgbar:'),
'    <ul>',
'        <li><strong>#APP_NAME#</strong>: Wird durch den Namen der Anwendung ersetzt</li>',
unistr('        <li><strong>#BODY1#</strong>: Wird durch den Wert ersetzt, der als p_body1_text \00FCbergeben wurde</li> '),
unistr('        <li><strong>#TABLE#</strong>: Wird durch den Wert ersetzt, der mit Table Open HTML, Table Row HTML und Table Close HTML als p_table_content \00FCbergeben wurde</li>'),
unistr('        <li><strong>#BODY2#</strong>: Wird durch den Wert ersetzt, der als p_body2_text \00FCbergeben wurde</li> '),
unistr('        <li><strong>#ACTION#</strong>: Wird durch den Wert ersetzt, der mit der Vorlage "Aktionslink" als p_action_label und p_action_link \00FCbergeben wurde</li>'),
'      </ul></li>',
unistr('  <li><strong>Nur-Text-Vorlage</strong> (obligatorisch): Geben Sie den Nur-Text zum Erstellen einer E-Mail ein, die an Empf\00E4nger gesendet wird, die keine HTML-basierten E-Mails akzeptieren. Diese Option verwendet dieselben Ersetzungen wie die HTML-Vo')
||'rlage, jedoch werden #TABLE# und #ACTION# als Nur-Text wiedergegeben.</li>',
'<ul>',
unistr('<p>Es gibt weitere HTML-Templates, die E-Mails mit zus\00E4tzlichen Elementen erm\00F6glichen.  Dazu geh\00F6ren:</p>'),
'<ul>',
unistr('  <li><strong>Vor Zeilen</strong>: Geben Sie HTML ein, das #TABLE# in der HTML-Vorlage ersetzt. Wird nur verwendet, wenn p_table_content \00FCbergeben wird.</li>'),
unistr('  <li><strong>Zeilentemplate</strong>: Geben Sie HTML f\00FCr die Wiedergabe der einzelnen Tabellenzeilen ein. Dazu geh\00F6rt "Zeilen \00F6ffnen/schlie\00DFen" und "Daten \00F6ffnen/schlie\00DFen" mit den #LABEL#- und #VALUE#-Ersetzungen. Wird nur verwendet, wenn p_table_c')
||unistr('ontent \00FCbergeben wird.</li>'),
unistr('  <li><strong>Nach Zeilen</strong>: Geben Sie HTML ein, um die Tabelle oder Div zu schlie\00DFen. Wird nur verwendet, wenn p_table_content \00FCbergeben wird.</li>'),
unistr('  <li><strong>HTML f\00FCr Aktionslink</strong>: Geben Sie HTML ein, um #ACTION# in der HTML-Template zu ersetzen. HTML sollte #ACTION_LINK# und #ACTION_TEXT# enthalten. Wird nur verwendet, wenn p_action_label und p_action_link \00FCbergeben werden.</li>'),
'</ul>',
unistr('<p><em><strong>Hinweis</strong>: Verwenden Sie die Eintr\00E4ge in der <strong>Standardvorlage</strong> als Ausgangsbasis f\00FCr die Entwicklung Ihrer eigenen Vorlage. In der Standardvorlage werden viele der Substitutionsvariablen verwendet, die Sie m\00F6glich')
||unistr('erweise auch in Ihrem eigenen E-Mail-Template einf\00FCgen m\00F6chten.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445596119303873)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Aktivieren oder deaktivieren Sie das Senden von E-Mails durch Auswahl einer der Optionen f\00FCr <strong>E-Mails \00FCbermitteln</strong>.</p>'),
unistr('<p>Machen Sie eine Angabe unter <strong>E-Mails von</strong>. Geben Sie die E-Mail-Adresse des prim\00E4ren Kontakts bei Anwendungsproblemen ein. Dieser Wert kann bei Verwendung der E-Mail-Features verwendet oder \00FCberschrieben werden.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463797089303888)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'de'
,p_message_text=>unistr('Dies ist die Adresse, von der aus E-Mails gesendet werden. Sie kann bei Verwendung des E-Mail-Features \00FCberschrieben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481005366303902)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCllen Sie die folgenden Felder aus, und klicken Sie auf [E-Mail senden]. Alle gesendeten E-Mails werden im E-Mail-Log protokolliert.'),
'    <ul>',
unistr('        <li><strong>Von</strong>: Wenn in den E-Mail-Einstellungen eine "Absenderadresse" festgelegt wurde, wird diese Adresse als Absenderoption aufgef\00FChrt. Wenn diese Anwendung E-Mail-Adressen als Benutzernamen verwendet, k\00F6nnen Sie wahlweise E-Mai')
||unistr('ls von Ihrer Adresse aus senden. Sie k\00F6nnen dar\00FCber hinaus festlegen, dass die Absenderadresse dieselbe wie die Empf\00E4ngeradresse ist.</li>'),
unistr('        <li><strong>Empf\00E4nger</strong>: Wenn diese Anwendung E-Mail-Adressen als Benutzername verwendet, k\00F6nnen Sie festlegen, ob E-Mails an E-Mail-Adressen und/oder Benutzer gesendet werden sollen.</li>'),
unistr('        <li><strong>E-Mail-Adressen</strong>: Durch Komma getrennte Liste von E-Mail-Adressen, an die E-Mails gesendet werden k\00F6nnen. Ung\00FCltige Adressen werden nicht aufgenommen.</li>'),
unistr('        <li><strong>Rolle</strong>: Sie k\00F6nnen festlegen, ob E-Mails an alle Benutzer einer ausgew\00E4hlten Rolle oder an alle definierten Benutzer gesendet werden sollen. Die Auswahlliste enth\00E4lt eine Liste von Rollen und die Anzahl der Benutzer innerh')
||'alb dieser Rolle.</li>',
unistr('        <li><strong>Template</strong>: W\00E4hlen Sie das E-Mail-Template, die zur Erstellung des Hauptteils der E-Mail verwendet werden soll.</li>'),
'        <li><strong>Betreff</strong>: Der Betreff der E-Mail-Nachricht.</li>',
'        <li><strong>E-Mail-Text</strong>: Der Text, der in die E-Mail aufgenommen werden soll.</li>',
unistr('        <li><strong>Opt-out zulassen</strong>: Einige E-Mails m\00FCssen gesendet werden, auch wenn der Benutzer den Erhalt von E-Mails abgew\00E4hlt hat. Dazu geh\00F6ren beispielsweise Meldungen zu Ausf\00E4llen. Mit diesem Kennzeichen wird angegeben, ob die Opt-o')
||unistr('ut-Option f\00FCr diese E-Mail zul\00E4ssig ist oder ob die E-Mail unabh\00E4ngig von den Voreinstellungen des Benutzers gesendet werden soll.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482776043303904)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCllen Sie die die folgenden Felder aus, und klicken Sie auf [E-Mail senden].  Alle gesendeten E-Mails werden im E-Mail-Protokoll aufgezeichnet.'),
'    <ul>',
unistr('        <li><strong>Von</strong>: Ist in den E-Mail-Einstellungen eine "Absenderadresse" festgelegt, wird diese als Adressenoption angezeigt. Andernfalls k\00F6nnen Sie die Absenderadresse ebenfalls als Empf\00E4ngeradresse angeben.</li>'),
unistr('        <li><strong>E-Mail-Adressen</strong>: Durch Komma getrennte Liste der E-Mail-Adressen, an die E-Mails gesendet werden k\00F6nnen. Ung\00FCltige Adressen sind nicht aufgef\00FChrt.</li>'),
unistr('        <li><strong>Template</strong>: W\00E4hlen Sie das E-Mail-Template zur Erstellung des E-Mail-Textes.</li>'),
'        <li><strong>Betreff</strong>: Der Betreff der E-Mail.</li>',
'        <li><strong>E-Mail-Text</strong>: Text, der in die E-Mail aufgenommen werden soll.</li>',
unistr('        <li><strong>Opt-out zulassen</strong>: Einige E-Mails m\00FCssen gesendet werden, auch wenn der Benutzer den Erhalt von E-Mails abgew\00E4hlt hat. Dazu geh\00F6ren beispielsweise Meldungen zu Ausf\00E4llen. Mit diesem Flag wird angegeben, ob die Opt-out-Opti')
||unistr('on f\00FCr die E-Mail zul\00E4ssig ist oder ob die E-Mail unabh\00E4ngig von den Voreinstellungen des Benutzers gesendet werden soll.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99444224641303872)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Standardzeitzone f\00FCr alle Benutzer dieser Anwendung.</p>'),
unistr('<p>Einzelne Benutzer k\00F6nnen diese Einstellung \00FCberschreiben, indem Sie auf ihren Benutzernamen (oben rechts) klicken und <strong>Voreinstellungen</strong> ausw\00E4hlen. Alternativ k\00F6nnen sie auch auf den Zeitzonenlink klicken, der am unteren Rand der Ho')
||'mepage angezeigt wird.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460137828303885)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>unistr('Auf diese Seite kann nicht direkt \00FCber die UI zugegriffen werden. Sie wird f\00FCr den Download des Profilfotos verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459826830303885)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'de'
,p_message_text=>unistr('Auf der Seite "Benutzerprofil" k\00F6nnen Sie relevante Informationen zu einem Benutzer in einem benutzerfreundlichen Bildschirm anzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459548505303885)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'de'
,p_message_text=>unistr('Laden Sie ein Foto mit einem quadratischen Seitenverh\00E4ltnis hoch, da es andernfalls m\00F6glicherweise verzerrt dargestellt wird. Die bevorzugte Bildgr\00F6\00DFe ist 250 x 250 Pixel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99445607795303874)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Formular k\00F6nnen Sie Ihre pers\00F6nlichen Daten aktualisieren und ein Foto oder einen Avatar hochladen.</p>'),
unistr('<p>Um ein Bild hochzuladen, klicken Sie auf <strong>Durchsuchen</strong>, oder ziehen Sie das Bild per Drag-and-Drop auf die Schaltfl\00E4che.<br>'),
unistr('Laden Sie ein Foto mit einem quadratischen Seitenverh\00E4ltnis hoch, da es andernfalls m\00F6glicherweise verzerrt dargestellt wird. Die bevorzugte Bildgr\00F6\00DFe ist 250 x 250 Pixel.</p>'),
unistr('<p>Klicken Sie auf <strong>Foto l\00F6schen</strong>, um das Bild zu entfernen.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465726068303890)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'de'
,p_message_text=>unistr('Von dieser Seite aus kann auf den gesamten Hilfetext f\00FCr die Anwendung zugegriffen werden. Die Links in der Region "Dokumentation" bieten ausf\00FChrlichere Erkl\00E4rungen zu den Features und Funktionen der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99446713723303874)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber diese Seite k\00F6nnen Sie Anwendungsvoreinstellungen f\00FCr Ihren Account festlegen. Die Voreinstellungen k\00F6nnen verschiedene Aspekte der Anwendung betreffen, Beispiel: Zeitzone. Klicken Sie auf die Hilfesymbole auf Elementebene, um zu erfahren, welch')
||'e Auswirkungen jede Voreinstellung hat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549571068303129)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'de'
,p_message_text=>'<p>In diesem Bericht werden alle in der Sendequeue enthaltenen und bereits gesendeten E-Mails angezeigt.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671038299303226)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Diese Berichte umfassen alle Jobs, die von dieser Anwendung \00FCberwacht werden. Sie k\00F6nnen weitere Details zu jedem Job anzeigen, indem Sie auf den Jobnamen klicken.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677648404303233)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Dieser Bericht umfasst die Ausf\00FChrungsdetails zu den Jobs, die von dieser Anwendung \00FCberwacht werden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431022438303862)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Seite mit Informationen zu dieser Anwendung hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447442499303875)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'de'
,p_message_text=>unistr('Setzen Sie diese Option auf "Nein", wenn Sie keine E-Mails von dieser Anwendung empfangen m\00F6chten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480559127303902)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie einen Suchbegriff in das Dialogfeld "Suchen" ein, und klicken Sie auf <strong>Suchen</strong>.<br>',
unistr('Klicken Sie eine beliebige Ergebnis\00FCberschrift, um zu dem jeweiligen Datensatz zu navigieren.</p>'),
'<p>Um die Suche einzugrenzen, deaktivieren Sie eine oder mehrere Quellen, wodurch die jeweiligen Berichte aus den Suchergebnissen entfernt werden.</p>',
unistr('<p>Klicken Sie auf <strong>Zur\00FCcksetzen</strong>, um den aktuellen Suchbegriff zu entfernen alle Quellen zu aktivieren.</p> ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447213160303875)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie Ihre bevorzugte Zeitzone f\00FCr die Anwendung fest.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445467776303045)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendete Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467367485303891)
,p_name=>'CA.HOME'
,p_message_language=>'de'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99473427461303896)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'de'
,p_message_text=>'Homepage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488757965303909)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'de'
,p_message_text=>unistr('St\00FCndliche Seitenereignisse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548628131303128)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('HTML-Hauptteilgr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464154969303888)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'HTML-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460883363303886)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'de'
,p_message_text=>'In Arbeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484967706303906)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'de'
,p_message_text=>'In Formulare aufnehmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484818866303906)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'de'
,p_message_text=>'In Berichten aufnehmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99469599716303893)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objektskripte werden installiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671799447303227)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'de'
,p_message_text=>'Instanz-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672984594303228)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'de'
,p_message_text=>'Instanz-Stickiness'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443280619303872)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Willkommen bei dieser cloudbasierten Vorschau eines neuen und verbesserten Verfahrens zur Erstellung von Anwendungen mit noch mehr leistungsstarken Features. Mit dem Standardassistenten zur Erstellung einer Anwendung k\00F6nnen Sie lediglich Seiten au')
||unistr('sw\00E4hlen, die erstellt werden sollen. Dieser Assistent dagegen erm\00F6glicht Ihnen, schnell eine Reihe von zus\00E4tzlichen Features im Voraus in Ihre Anwendung zu laden.</p>'),
unistr('<p>Mit diesem Assistenten erstellte Anwendungen werden vollst\00E4ndig unterst\00FCtzt und k\00F6nnen zudem unterst\00FCtzende Objekte f\00FCr ausgew\00E4hlte Features enthalten, Beispiel: Zugriffskontrolle, E-Mail-Framework, Feedback und mehr.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443476136303872)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zun\00E4chst einen Anwendungsnamen ein. F\00FCgen Sie dann mindestens eine Seite zu der Anwendung hinzu. W\00E4hlen Sie die Features aus, die Sie einbeziehen m\00F6chten. Entscheiden Sie sich, wie die Anwendung dargestellt werden soll, und pr\00FCfen Sie da')
||'nn die Einstellungen.<br>',
'So einfach geht das. Klicken Sie auf <strong>Anwendung erstellen</strong>, und schon sind Sie fertig.</p>',
'<p>Klicken Sie auf <strong>Blueprint anzeigen</strong>, um das Modell einer zuvor generierten Anwendung wiederzuverwenden oder Seiten schnell zu replizieren.</p>',
unistr('<p><em><strong>Hinweis:</strong> In jedem Abschnitt und auf jeder neu hinzugef\00FCgten Seite finden Sie detaillierte Hilfe zur weiteren Unterst\00FCtzung.</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443323004303872)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'de'
,p_message_text=>'Verwendung dieses Assistenten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476940045303899)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Im Folgenden werden wesentliche Probleme zum Zeitpunkt der Freigabe aufgef\00FChrt:'),
'<ol>',
unistr('  <li>Der Assistent zum Erstellen der Anwendung vom Blueprint wird nicht \00FCbersetzt.</li>'),
unistr('  <li>Von diesem Assistenten generierte \00FCbersetzte Anwendungen werden nur teilweise \00FCbersetzt.</li>'),
unistr('  <li>Im Rahmen des Drilldowns von Berichten ist nur eine Drilldown-Spalte m\00F6glich.</li>'),
unistr('  <li>Es k\00F6nnen keine Filterberichtsseiten generiert werden.</li>'),
unistr('  <li>Das E-Mail-Feature bietet die API auf niedriger Ebene, umfasst jedoch noch keine E-Mail-Featuresauf h\00F6herer Ebene.</li>'),
'  <li>Die Generierung von Anwendungen von Blueprints, die auf nicht vorhandene Tabellen verweisen, scheitert mit einem Fehler.</li>',
'  <li>Erweiterte Einstellungen - Auf die generierte Anwendung werden keine Datumsformate angewendet.</li>',
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476866568303899)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'de'
,p_message_text=>'Bekannte Probleme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443648628303872)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Freigegeben %0.</p>',
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443509548303872)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'de'
,p_message_text=>'Releasedetails'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99443108733303871)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'de'
,p_message_text=>'Anwendung mit einem Blueprint-Assistenten erstellen {Cloudbasierte Vorschau}'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454784458303881)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'de'
,p_message_text=>'IP-Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452992048303879)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'de'
,p_message_text=>'IR-Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455954678303882)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'de'
,p_message_text=>'IR-Suchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483388876303904)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'de'
,p_message_text=>'Objektname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675745048303231)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'de'
,p_message_text=>'Job-Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677248500303232)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'de'
,p_message_text=>'Job-Klasse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676321875303231)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'de'
,p_message_text=>'Job-Ersteller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677489537303232)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'de'
,p_message_text=>'Job-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673975079303229)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'de'
,p_message_text=>unistr('Job-Priorit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670977189303226)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'de'
,p_message_text=>'Jobberichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711085998303263)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Status und Ausf\00FChrungsdetails von Jobs anzeigen, die diese Anwendung unterst\00FCtzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677572899303232)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'de'
,p_message_text=>'Details des Job-Runs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676421917303231)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'de'
,p_message_text=>'Job-Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676554956303231)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'de'
,p_message_text=>'Job-Untername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675821710303231)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'de'
,p_message_text=>'Job-Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672509057303227)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'de'
,p_message_text=>'Job-Gewichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483856756303905)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Schl\00FCsselspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485654185303906)
,p_name=>'CA.LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484112764303905)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Labelspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485860894303906)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'de'
,p_message_text=>'Label Plural'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485551891303906)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'de'
,p_message_text=>'Label Singular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442312876303871)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442431371303871)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die prim\00E4re Sprache f\00FCr diese Anwendung aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476370329303899)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die prim\00E4re Sprache gibt die Sprache zur Anzeige der Seiten und Komponenten an, die im App Builder generiert wurden. Wenn Sie mehrere \00DCbersetzungen ausw\00E4hlen, haben Ihre Endbenutzer mehrere Sprachen zur Auswahl, in denen die Laufzeitumgebung wiede')
||'rgegeben werden kann.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808738180303343)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'de'
,p_message_text=>'Sprachselektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459383188303885)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'de'
,p_message_text=>'Nachname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676632123303232)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'de'
,p_message_text=>unistr('Dauer der letzten Ausf\00FChrung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676742626303232)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'de'
,p_message_text=>'Letztes Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489188357303909)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Letzte Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485020435303906)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480433079303902)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'de'
,p_message_text=>'Blueprint laden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679021178303234)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'de'
,p_message_text=>'Logdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679186863303234)
,p_name=>'CA.LOG.ID'
,p_message_language=>'de'
,p_message_text=>'Log-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673226333303228)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'de'
,p_message_text=>'Protokollierungsebene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356487589303799)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'de'
,p_message_text=>'Logmeldungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446603072303046)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Lookup-Spalten</strong> - Damit k\00F6nnen Sie Attribute zum Definieren eines Lookups in einer anderen Tabelle einblenden. Verwenden Sie Lookup-Spalten, um IDs durch eine Anzeigespalte zu ersetzen (z.B. um den Abteilungsnamen anstelle der Ab')
||'teilungsnummer anzuzeigen).<br>',
'<em><strong>Hinweis:</strong> Lookup-Spalten werden nur angezeigt, wenn die aktuelle Seite auf einer Tabelle oder View basiert und Foreign Key Constraints zu einer anderen Tabelle aufweist.',
'  <ul>',
unistr('    <li><strong>Lookup-Schl\00FCssel</strong> - W\00E4hlen Sie die Spalte aus, die ge\00E4ndert werden soll, um die Anzeigespalte auszugeben.</li>'),
unistr('    <li><strong>Anzeigespalte</strong> - W\00E4hlen Sie die anzuzeigende Spalte (in der Lookup-Tabelle) aus.</li>'),
'    &nbsp;<br>',
unistr('    <em><strong>Hinweis:</strong> W\00E4hlen Sie nur Spalten aus, die eine andere Tabelle (\00FCber einen Fremdschl\00FCssel) referenzieren.</em></li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463387477303888)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Templates verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461376906303886)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457447627303883)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'de'
,p_message_text=>'Benutzerzugriff verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489719880303909)
,p_name=>'CA.MASTER'
,p_message_language=>'de'
,p_message_text=>unistr('Master/Detail-Seite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489884824303910)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erstellen Sie eine Seite, auf der eine Master/Detail-Seite angezeigt wird, auf der Endbenutzer Daten anzeigen und verwalten k\00F6nnen.<br>'),
'&nbsp;</p>',
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Seitentyp</strong> - W\00E4hlen Sie den Typ der Seite [Nebeneinander, Gestapelt] aus.<br>'),
'    <strong>Nebeneinander</strong>: <br>',
'<em>Ein einseitiges Master/Detail, das nebeneinander angeordnete Layouts und Berichtsregionen mit modalen Bearbeitungsfenstern verwendet.</em>',
'    <ul>',
unistr('      <li><strong>Tabelle</strong> (Obligatorisch) - W\00E4hlen Sie die Mastertabelle f\00FCr die Seite aus.</li>'),
unistr('      <li><strong>Prim\00E4re Anzeigespalte</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus, die in der Liste der Masterdatens\00E4tze angezeigt werden soll.</li>'),
unistr('      <li><strong>Sekund\00E4re Anzeigespalte</strong> (Obligatorisch) - W\00E4hlen Sie die beschreibende Spalte aus, die in der Liste der Masterdatens\00E4tze unter der prim\00E4ren Anzeigespalte angezeigt werden soll.</li>'),
unistr('      <li><strong>Detailtabelle 1</strong> (Obligatorisch) - W\00E4hlen Sie die erste Detailtabelle f\00FCr die Seite aus.</li>'),
unistr('      <li><strong>Detailtabelle 2</strong> - W\00E4hlen Sie die zweite Detailtabelle f\00FCr die Seite aus.</li>'),
unistr('      <li><strong>Detailtabelle 3</strong> - W\00E4hlen Sie die dritte Detailtabelle f\00FCr die Seite aus.</li>'),
unistr('      <li><strong>Detailtabelle 4</strong> - W\00E4hlen Sie die vierte Detailtabelle f\00FCr die Seite aus.</li>'),
'    </ul>',
'   <strong>Gestapelt</strong>: <br>',
'<em>Ein einseitiges Master/Detail, das editierbare interaktive Grids verwendet.</em>',
'    <ul>',
unistr('      <li><strong>Tabelle</strong> (Obligatorisch) - W\00E4hlen Sie die Mastertabelle f\00FCr das editierbare interaktive Grid aus.</li>'),
unistr('      <li><strong>Detailtabelle</strong> (Obligatorisch) - W\00E4hlen Sie die Detailtabelle f\00FCr die Seite aus.</li>'),
unistr('      <em><strong>Hinweis:</strong> Mit dem Assistenten kann nur eine Detailtabelle (editierbares interaktives Grid) hinzugef\00FCgt werden. Nach der Generierung k\00F6nnen Sie ganz einfach weitere Detailtabellen hinzuf\00FCgen.</em>'),
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808614169303343)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'de'
,p_message_text=>unistr('Masterdatens\00E4tze')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453654214303880)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Maximal verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673765922303229)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'de'
,p_message_text=>'Max. Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673330392303228)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'de'
,p_message_text=>unistr('Maximale Ausf\00FChrungsdauer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673894876303229)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'de'
,p_message_text=>unistr('Maximale Ausf\00FChrungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484095556303905)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'de'
,p_message_text=>'Maximale Zeilenanzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487034135303907)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'de'
,p_message_text=>'Maximale Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477610359303900)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'de'
,p_message_text=>unistr('Filter hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478094374303900)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'de'
,p_message_text=>unistr('%0 hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477598678303900)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filter anwenden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478405075303900)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'de'
,p_message_text=>'Datumswert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478549503303900)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'de'
,p_message_text=>'Datumswert 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477754166303900)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477123792303899)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477033348303899)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478189326303900)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Keine Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477454226303900)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Datens\00E4tze ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477396569303899)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Datens\00E4tze gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477993395303900)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477803663303900)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'de'
,p_message_text=>'%0 aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99477210148303899)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478236895303900)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478356700303900)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'de'
,p_message_text=>'Wert 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453129624303880)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Verstrichen, Medianwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462248241303887)
,p_name=>'CA.MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Meldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356268248303799)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'de'
,p_message_text=>'Meldungstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486510771303907)
,p_name=>'CA.METRIC'
,p_message_language=>'de'
,p_message_text=>'Metrik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454095720303880)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Mindestens verstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456829066303883)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'de'
,p_message_text=>'Mobiltelefon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452660230303879)
,p_name=>'CA.MODE'
,p_message_language=>'de'
,p_message_text=>'Modus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466460770303890)
,p_name=>'CA.MORE'
,p_message_language=>'de'
,p_message_text=>'Mehr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456056202303882)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'de'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488947807303909)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'de'
,p_message_text=>'Aktivste Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446738648303046)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'de'
,p_message_text=>'Mehrere Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446868731303046)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Aktivieren Sie mindestens einen Tabellen- oder View-Namen. Alternativ k\00F6nnen Sie das Kontrollk\00E4stchen im Header aktivieren, um alle aufgelisteten Datenbankobjekte auszuw\00E4hlen oder deren Auswahl aufzuheben.</p>'),
unistr('<p>Eine Seite mit einem interaktiven Bericht wird f\00FCr jedes ausgew\00E4hlte Datenbankobjekt hinzugef\00FCgt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450049543303877)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss ein g\00FCltiger Zeitstempel sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486307117303907)
,p_name=>'CA.NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441500555303870)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441665332303870)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Legen Sie fest, ob das Men\00FC am seitlichen oder oberen Rand der Anwendung angezeigt werden soll.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493068671303912)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'de'
,p_message_text=>'Negativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492976219303912)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'de'
,p_message_text=>'Neutral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479077782303901)
,p_name=>'CA.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673528355303229)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chstes Ausf\00FChrungsdatum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672460026303227)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'de'
,p_message_text=>'NLS-Umgebung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761412575303306)
,p_name=>'CA.NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460970409303886)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'de'
,p_message_text=>'Keine Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472587950303896)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Seite ist keine Hilfe verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445578152303045)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'de'
,p_message_text=>unistr('Keine g\00FCltigen Benutzer vorhanden - Seiteninfo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480025036303902)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Keine g\00FCltigen neuen Benutzer gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476186555303898)
,p_name=>'CA.NONE'
,p_message_language=>'de'
,p_message_text=>'Kein Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457150405303883)
,p_name=>'CA.NOTE'
,p_message_language=>'de'
,p_message_text=>'Hinweis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432612360303863)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431489246303862)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigungen auf der Homepage anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432761673303863)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Damit k\00F6nnen Anwendungsadministratoren entweder Alerts (gelb) oder Fehler (rot) angeben, die allen Endbenutzern auf der Homepage der Anwendung angezeigt werden. Dieses Feature ist hilfreich, um wichtige Informationen an die Endbenutzercommunity we')
||'iterzugeben.</p>',
'<p>Umfasst die folgenden Komponenten:<ul>',
unistr('<li>M\00F6glichkeit zum Definieren von Benachrichtigungen</li>'),
'<li>Anzeige von Benachrichtigungen auf der Anwendungshomepage</li>',
unistr('<li>M\00F6glichkeit zur Kontrolle des Zeitfensters f\00FCr die Anzeige von Benachrichtigungen</li>'),
unistr('<li>Unterst\00FCtzung der Farbcodierung von Benachrichtigungen nach Typ</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449392455303877)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452822802303879)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'de'
,p_message_text=>'Anzahl Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675677958303231)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'de'
,p_message_text=>'Anzahl der Argumente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672252868303227)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'de'
,p_message_text=>'Anzahl Ziele'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484582002303905)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'de'
,p_message_text=>'Zahlenformatmaske      '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454319429303881)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'de'
,p_message_text=>'Vorkommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493230252303912)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen diese Aktion nur ausf\00FChren, wenn ein anderer Administrator verf\00FCgbar ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461160257303886)
,p_name=>'CA.OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434170463303864)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten werden angeordnet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434424331303864)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sie k\00F6nnen die Seiten in der Reihenfolge anordnen, in der sie in der Anwendung angezeigt werden sollen. <br>'),
unistr('Um Seiten in der Liste neu anzuordnen, klicken Sie am Ende einer Seitenliste auf das Symbol <em>Ziehen, um Seite neu anzuordnen</em> (<span class="fa fa-bars" aria-hidden="true"></span>), und verschieben Sie die Seite bei gedr\00FCcktem Symbol per Drag-a')
||'nd-Drop nach oben oder unten.</p>',
'<p>Die Homepage wird immer zuerst angezeigt und kann nicht neu angeordnet werden.<br>',
unistr('Administrationsseiten werden immer am Ende der Liste angezeigt. Die hier festgelegte Reihenfolge wird auf der Seite "Administration" in der Liste "Anwendungsadministration" \00FCbernommen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677707090303233)
,p_name=>'CA.OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Ausgabe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678933330303234)
,p_name=>'CA.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452538724303879)
,p_name=>'CA.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455749470303882)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'de'
,p_message_text=>'Seitenereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468214203303892)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu den Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454837273303881)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'de'
,p_message_text=>'Seitenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810464577303345)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'de'
,p_message_text=>'Masterdatensatz bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810606315303345)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'de'
,p_message_text=>unistr('Suche ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452106273303879)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'de'
,p_message_text=>'Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467506154303891)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Seitennavigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454256706303881)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>'Seiten-Performance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479113445303901)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der Seitentyp "%0" ist kein g\00FCltiger Typ.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453596677303880)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434608703303865)
,p_name=>'CA.PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434768956303865)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Hier definieren Sie die Seiten, die in Ihre anf\00E4ngliche Anwendung aufgenommen werden sollen. Sie m\00FCssen mindestens eine Seite definieren, um eine Anwendung erstellen zu k\00F6nnen.</p>'),
unistr('<p>Sie k\00F6nnen Ihre Anwendung mit Stubs versehen, indem Sie mit diesem Assistenten beliebig viele Seiten erstellen. Nachdem Sie die Anwendung erstellt haben, k\00F6nnen Sie mit dem Assistenten "Seite erstellen" weitere Seiten hinzuf\00FCgen.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484408173303905)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'de'
,p_message_text=>unistr('Methode f\00FCr Seitenumbruch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453899368303880)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenbestandteil-Ansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459694536303885)
,p_name=>'CA.PHOTO'
,p_message_language=>'de'
,p_message_text=>'Foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460250596303885)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Foto gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459796040303885)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'de'
,p_message_text=>'Fotoname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459401397303885)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'de'
,p_message_text=>'Fotoupload'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356334796303799)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Wert des Prim\00E4rschl\00FCssels ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464205861303888)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Nur-Text-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492803637303912)
,p_name=>'CA.POSITIVE'
,p_message_language=>'de'
,p_message_text=>'Positiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447092902303875)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'de'
,p_message_text=>'Voreinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99490461203303910)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485147044303906)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4re Anzeigespalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486020603303906)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschl\00FCsselspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486107649303907)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4re \00FCbergeordnete Tabelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454452565303881)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'de'
,p_message_text=>'Prozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447613791303875)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Voreinstellung wurde aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810248243303344)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356564240303799)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Logdetails abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448853226303876)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Einstellungen f\00FCr die Darstellung der Anwendung wurden gespeichert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447511483303875)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Zeitzonenvoreinstellung wurde aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460044362303885)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'Download des Profilfotos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675938287303231)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'de'
,p_message_text=>'Programmname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676058868303231)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Programmeigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188931639302837)
,p_name=>'CA.PWA'
,p_message_language=>'de'
,p_message_text=>'Progressive Web-App installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188872205302837)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Erm\00F6glichen Sie Benutzern, die App zu installieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189070510302838)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Progressive Web-Apps sind funktionsf\00E4hige, zuverl\00E4ssige und installierbare Webanwendungen. Eine progressive Web-App wirkt wie eine plattformspezifische Anwendung.</p>'),
'<p>Wenn Sie diese Option aktivieren, geschieht Folgendes:</p>',
'<ul>',
unistr('<li>Der neue Navigationsleisteneintrag "App installieren" wird hinzugef\00FCgt</li>'),
unistr('<li>Benutzer k\00F6nnen diese APEX-App auf Ger\00E4ten installieren</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184990883302834)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'de'
,p_message_text=>'App installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485431532303906)
,p_name=>'CA.QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672765996303228)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Ereignisse ausl\00F6sen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314401615302938)
,p_name=>'CA.RATING'
,p_message_language=>'de'
,p_message_text=>'Bewertung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99457979907303883)
,p_name=>'CA.READERS'
,p_message_language=>'de'
,p_message_text=>'Leseberechtigte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447367617303875)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'de'
,p_message_text=>'E-Mails empfangen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489020830303909)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'de'
,p_message_text=>'Letzte Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125116255303605)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125203617303605)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449528001303877)
,p_name=>'CA.RED'
,p_message_language=>'de'
,p_message_text=>'Rot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99463163656303888)
,p_name=>'CA.REFERENCED'
,p_message_language=>'de'
,p_message_text=>'Referenziert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809316919303344)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'de'
,p_message_text=>'Admin-Seite aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426615852303030)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Bei Schlie\00DFen von Dialogfeld aktualisieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98810585729303345)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449074972303876)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chenregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448959030303876)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'de'
,p_message_text=>unistr('Region f\00FCr Formularelemente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454932132303881)
,p_name=>'CA.REGION.ID'
,p_message_language=>'de'
,p_message_text=>'Regions-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466909272303891)
,p_name=>'CA.RELEASE'
,p_message_language=>'de'
,p_message_text=>'Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434276801303864)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten werden entfernt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99434308158303864)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Klicken Sie auf <strong>Bearbeiten</strong>, um die Seite auszuw\00E4hlen, und klicken Sie anschlie\00DFend auf <strong>Seite l\00F6schen</strong>, um eine Seite aus Ihrer Anwendung zu entfernen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677389493303232)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'de'
,p_message_text=>'Wiederholungsintervall'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549232367303129)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'de'
,p_message_text=>'Antwort an'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99440037193303869)
,p_name=>'CA.REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Berichtsseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99439939251303869)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Erstellen Sie eine Seite, die entweder einen interaktiven oder einen klassischen Bericht anzeigt.</p>',
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Abfragetyp</strong> - W\00E4hlen Sie die Quelle f\00FCr den Bericht aus [<strong>Tabelle oder View</strong> oder <strong>SQL-Abfrage</strong>].<br>'),
'    <strong>Tabelle oder View</strong>:',
'    <ul>',
unistr('      <li>Tabelle oder View (Obligatorisch) - W\00E4hlen Sie das Datenbankobjekt f\00FCr den Bericht aus.</li>'),
unistr('      <li>Formular einbeziehen - Aktivieren Sie diese Option, um eine verkn\00FCpfte Formularseite aufzunehmen, damit Benutzer die Tabellenwerte verwalten k\00F6nnen.</li>'),
'    </ul>',
'    <strong>SQL-Abfrage</strong>:',
'    <ul>',
unistr('      <li>SQL-Abfrage (Obligatorisch) - Geben Sie eine g\00FCltige SQL-Anweisung ein, die eindeutige Spalten zur\00FCckgibt.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>Berichtstyp</strong> - W\00E4hlen Sie den Typ des Berichts aus [<strong>Interaktiver Bericht</strong> oder <strong>Klassischer Bericht</strong>].</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431726537303862)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'de'
,p_message_text=>'%0 mit Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314302417303764)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'de'
,p_message_text=>'%0 Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488144397303908)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'de'
,p_message_text=>'Berichtsansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486752832303907)
,p_name=>'CA.REPORTS'
,p_message_language=>'de'
,p_message_text=>'Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678730642303234)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'de'
,p_message_text=>'Angefordertes Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486904414303907)
,p_name=>'CA.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465019741303889)
,p_name=>'CA.RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461005621303886)
,p_name=>'CA.RESOLVED'
,p_message_language=>'de'
,p_message_text=>unistr('Gel\00F6st')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460758669303886)
,p_name=>'CA.RESPONSE'
,p_message_language=>'de'
,p_message_text=>'Antwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674076994303229)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'de'
,p_message_text=>'Neustart bei Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98674174703303229)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'de'
,p_message_text=>'Neustart bei Recovery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671358979303226)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'de'
,p_message_text=>'Kann neu gestartet werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673644941303229)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Wiederholungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481977588303903)
,p_name=>'CA.ROLE'
,p_message_language=>'de'
,p_message_text=>'Rolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455130387303881)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'de'
,p_message_text=>'Zeilennummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464474028303889)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Zeilentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481320496303903)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'de'
,p_message_text=>unistr('HTML f\00FCr Zeilentemplate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482663451303904)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'de'
,p_message_text=>'Zeileninhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455892581303882)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'de'
,p_message_text=>'Abgerufene Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99484356322303905)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'de'
,p_message_text=>'Zeilen pro Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98676995389303232)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Anzahl von Ausf\00FChrungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678541667303233)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungsdauer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673449473303228)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'de'
,p_message_text=>unistr('Grenzwert des Ausf\00FChrungsplans')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675464718303230)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Name des Ausf\00FChrungsplans')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675532413303231)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer des Ausf\00FChrungsplans')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675369922303230)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Typ des Ausf\00FChrungsplans')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442586406303871)
,p_name=>'CA.SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442603082303871)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>W\00E4hlen Sie das Datenbankschema aus, in dem die Datenbankobjekte gespeichert sind, die Sie in dieser Anwendung verwenden m\00F6chten.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483490046303904)
,p_name=>'CA.SCOPE'
,p_message_language=>'de'
,p_message_text=>'Geltungsbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465107806303889)
,p_name=>'CA.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465255064303889)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99465343318303889)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'de'
,p_message_text=>'Suchdialog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488312112303908)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Suchfilter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472027469303895)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Diese Seite wird aus der Liste der gemeinsamen Komponenten, der sogenannten durchsuchten Tabellen entfernt.',
'',
unistr('Alle Seiten f\00FCr den interaktiven Bericht, die vom Assistenten zum Erstellen von Anwendungen anf\00E4nglich generiert wurden, werden der Liste automatisch hinzugef\00FCgt. Um der Liste eigene Tabellen hinzuzuf\00FCgen und dann zu "Gemeinsame Komponenten" zu navig')
||unistr('ieren, w\00E4hlen Sie "Listen" und klicken auf "Durchsuchte Tabellen".'),
'  Geben Sie die folgenden Attribute ein:',
unistr('    Eintrag: Listeneintragslabel - Geben Sie den Anzeigenamen f\00FCr die Tabelle ein.'),
unistr('    Ziel: Seite - W\00E4hlen Sie die Seite, zu der navigiert werden soll (vorzugsweise ein interaktiver Bericht)'),
unistr('    Ziel: Cacheinhalt l\00F6schen - Geben Sie alle Seiten ein, die gel\00F6scht werden m\00FCssen (meist dieselbe Anzahl wie unter "Seite" eingegeben).'),
unistr('       Wenn Sie zu einer Seite f\00FCr einen interaktiven Bericht navigieren, geben Sie CIR,RIR ein, um vorhandene Filter usw. zu l\00F6schen'),
unistr('    Ziel: Diese Elemente festlegen - W\00E4hlen Sie das korrekte auszuf\00FCllende Seitenelement aus (oder geben Sie es ein).'),
'       Geben Sie IR_[COLUMN_NAME] ein, um zu einer Seite mit interaktivem Bericht zu navigieren.',
'    Ziel: Mit diesen Werten - Geben Sie =PK= ein',
unistr('    Benutzerdefinierte Attribute: 1 - Geben Sie den zu suchenden Tabellennamen in Gro\00DFbuchstaben ein.'),
unistr('    Benutzerdefinierte Attribute: 2 - Geben Sie den Namen der prim\00E4ren Spalte in Gro\00DFbuchstaben ein.'),
'    Benutzerdefinierte Attribute: 3 (optional) - durch Komma getrennte Liste der zu durchsuchenden Spalten.',
unistr('       Falls keine Spalten angegeben werden, werden die Spalten f\00FCr Nur-Text (varchar2) und Character Large Object (clob) durchsucht.'),
'',
unistr('Hinweis: Eine Liste der verf\00FCgbaren zu durchsuchenden Tabellen wird Benutzern nur angezeigt, wenn mehr als eine Tabelle aufgef\00FChrt ist.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464877695303889)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'de'
,p_message_text=>'Suchergebnisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485985086303906)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Sekund\00E4re Anzeigespalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461442495303886)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hltes Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548527368303128)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'de'
,p_message_text=>'Sendebeginn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548980356303128)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Sendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548470989303128)
,p_name=>'CA.SEND.END'
,p_message_language=>'de'
,p_message_text=>'Sendeende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548891154303128)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'de'
,p_message_text=>'Sendefehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491951232303911)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'de'
,p_message_text=>'E-Mails senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99492024288303911)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'de'
,p_message_text=>'Legt fest, ob E-Mails gesendet werden sollen, wenn neues Feedback empfangen wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99488639979303909)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'de'
,p_message_text=>'Absenderadresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481125247303903)
,p_name=>'CA.SEND.TO'
,p_message_language=>'de'
,p_message_text=>'Senden an'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466761137303890)
,p_name=>'CA.SERIES'
,p_message_language=>'de'
,p_message_text=>'Datenreihe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678447507303233)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'de'
,p_message_text=>'Session-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483669500303905)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Schutz f\00FCr den Sessionzustand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441996660303870)
,p_name=>'CA.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Einstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442017011303871)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'de'
,p_message_text=>'<p>Geben Sie die Einstellungen ein, die zur Generierung der Anwendung verwendet werden.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466397192303890)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'de'
,p_message_text=>'Alles anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426137183303030)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'de'
,p_message_text=>'Geltungsbereich ein-/ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467473543303891)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'de'
,p_message_text=>'Zeitzone anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99467207512303891)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'de'
,p_message_text=>'Anmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468491627303892)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'de'
,p_message_text=>'Abmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678340651303233)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'de'
,p_message_text=>'Untergeordnete PID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672329482303227)
,p_name=>'CA.SOURCE'
,p_message_language=>'de'
,p_message_text=>'Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479280015303901)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der Quelltyp ist kein g\00FCltiger Typ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99472116829303895)
,p_name=>'CA.SOURCES'
,p_message_language=>'de'
,p_message_text=>'Quellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675234800303230)
,p_name=>'CA.START.DATE'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355750878303798)
,p_name=>'CA.STARTED'
,p_message_language=>'de'
,p_message_text=>'Gestartet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98677022928303232)
,p_name=>'CA.STATE'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486878339303907)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'de'
,p_message_text=>'Statischer Standardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99451111272303878)
,p_name=>'CA.STATUS'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673091097303228)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Bei Schlie\00DFen von Fenster stoppen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98673176557303228)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Ausgabe speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461685752303886)
,p_name=>'CA.SUBJECT'
,p_message_language=>'de'
,p_message_text=>'Betreff'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99460354374303885)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355982324303799)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'de'
,p_message_text=>'Erfolgreiche Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99483962569303905)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'de'
,p_message_text=>'Empfohlene Visualisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475855418303898)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objekte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475906504303898)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie Code in das Installationsskript ein. In der Regel erstellen oder bearbeiten Sie damit Datenbankobjekte oder f\00FChren Einf\00FCge-, Aktualisierungs- oder L\00F6schvorg\00E4nge f\00FCr vorhandene Datens\00E4tze aus. Geben Sie Code in das Deinstallationsskript e')
||unistr('in, um Datenbankobjekte zu entfernen (l\00F6schen). Diese Skripte werden in die unterst\00FCtzenden Objekte eingebunden, sodass beim Export der Anwendung dieselben Aktualisierungen in den Test- und Production-Umgebungen durchgef\00FChrt werden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476084548303898)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie g\00FCltige SQL- und/oder PL/SQL-Anweisungen in das Installationsskript ein, die beim Import der Anwendung ausgef\00FChrt werden.</p>'),
unistr('<p>Wenn diese Anweisungen nicht nur beim Import in eine andere Umgebung, sondern auch in der aktuellen Umgebung ausgef\00FChrt werden sollen, klicken Sie auf <strong>Bei Erstellung der Anwendung ausf\00FChren</strong>.</p>'),
unistr('<p>Geben Sie g\00FCltige SQL- und/oder PL/SQL-Anweisungen in das Deinstallationsskript ein, die ausgef\00FChrt werden, wenn die Anwendung vom App Builder gel\00F6scht wird.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672664982303228)
,p_name=>'CA.SYSTEM'
,p_message_language=>'de'
,p_message_text=>'System'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99485324324303906)
,p_name=>'CA.TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442707637303871)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00E4fix f\00FCr Framework-Objekt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99442871160303871)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie ein Objektpr\00E4fix ein, das von der Anwendung verwendet werden soll. Einige Features f\00FCgen dieses Pr\00E4fix zu den von ihnen erstellen Datenbankobjekten hinzu (einschlie\00DFlich Packages und Tabellen).</p>'),
unistr('<p>Warnung: Stellen Sie sicher, dass Sie ein eindeutiges Pr\00E4fix eingeben, das nicht von anderen Anwendungen verwendet wird. Wenn das Pr\00E4fix nicht eindeutig ist, werden bei der Erstellung der Anwendung m\00F6glicherweise Fehler ausgel\00F6st, und die Anwendun')
||'g funktioniert nicht richtig.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99486257811303907)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'de'
,p_message_text=>'Tabellenspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481285144303903)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99464705592303889)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'de'
,p_message_text=>'Dieser Template-Name wird bereits verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99461591807303886)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'de'
,p_message_text=>'Templatename'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450266247303877)
,p_name=>'CA.TEXT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548775180303128)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Textteilgr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462760274303887)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Texttemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448453953303876)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'de'
,p_message_text=>'Endbenutzer-Theme-Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448684036303876)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn diese Option aktiviert ist, d\00FCrfen Endbenutzer ihren eigenen Theme-Stil \00FCber den Link "Anpassen" ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99448590922303876)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Endbenutzer d\00FCrfen Theme-Stil ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432865830303863)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'de'
,p_message_text=>'Theme-Stilauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99431283415303862)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'de'
,p_message_text=>'Look-and-Feel der Standardanwendung aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99432914581303863)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Damit k\00F6nnen Administratoren ein Standardfarbschema (Theme-Stil) f\00FCr die Anwendung ausw\00E4hlen. Administratoren k\00F6nnen auch festlegen, ob Endbenutzer ihren eigenen Theme-Stil ausw\00E4hlen d\00FCrfen. Endbenutzer k\00F6nnen einfach unten auf der Homepage auf di')
||unistr('e Schaltfl\00E4che <em>Anpassen</em> klicken und eine Auswahl aus den verf\00FCgbaren Theme-Stilen treffen. Beispiel: Benutzer mit Sehbeeintr\00E4chtigung bevorzugen m\00F6glicherweise den Theme-Stil <em>Vista</em>, der einen sehr viel h\00F6heren Farbkontrast bietet.</')
||'p>',
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
unistr('<li>Administratoren d\00FCrfen den Standard-Theme-Stil definieren</li>'),
unistr('<li>Endbenutzer d\00FCrfen verschiedene Theme-Stile ausw\00E4hlen</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441386462303870)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'de'
,p_message_text=>'Designformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99441494887303870)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Standard-Theme-Stil aus, mit dem die Anwendung angezeigt werden soll.</p>'),
unistr('<p>Der Stil kann leicht in einen anderen vordefinierten Stil ge\00E4ndert oder nach der Generierung angepasst werden. Um den Stil zu \00E4ndern, f\00FChren Sie die Anwendung aus, und klicken Sie in der Entwicklersymbolleiste auf <strong>Theme Roller</strong>.</p')
||'>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99455448593303881)
,p_name=>'CA.TIME'
,p_message_language=>'de'
,p_message_text=>'Uhrzeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99447114390303875)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'de'
,p_message_text=>'Zeitzone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433915352303864)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzung f\00FCr Zeitzonen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430800584303862)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'de'
,p_message_text=>'Standard- und Benutzerzeitzonen festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433691797303864)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erm\00F6glichen Sie Endbenutzern, die lokale Zeitzone einzustellen. Dies ist wichtig, wenn in Ihren Anwendungstabellen zeitzonenbasierte Datumstypen verwendet werden (Beispiel: Zeitstempel mit lokaler Zeitzone), damit Berichte und Dateneintr\00E4ge den St')
||'andort der Endbenutzer widerspiegeln.</p>',
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
unistr('<li>Administratoren d\00FCrfen die Standardzeitzone festlegen</li>'),
unistr('<li>Endbenutzer d\00FCrfen ihre Zeitzonenvoreinstellung ausw\00E4hlen</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489220292303909)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'de'
,p_message_text=>'Zeitrahmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489575477303909)
,p_name=>'CA.TIMELINE'
,p_message_language=>'de'
,p_message_text=>unistr('Timelineseite hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99489632800303909)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erstellen Sie eine Seite, die eine Timeline anzeigt. Dies eignet sich besonders f\00FCr die Anzeige von Updates.</p>'),
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Seitenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Tabelle oder View</strong> (Obligatorisch) - W\00E4hlen Sie das Datenbankobjekt f\00FCr die Timeline aus.</li>'),
unistr('  <li><strong>Benutzername</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Benutzer f\00FCr die Timelineeintr\00E4ge verwendet werden soll.</li>'),
unistr('  <li><strong>Datum</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Datum f\00FCr die Timelineeintr\00E4ge verwendet werden soll.</li>'),
unistr('  <li><strong>Ereignisname</strong> (Obligatorisch) - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Titel f\00FCr die Timelineeintr\00E4ge verwendet werden soll.</li>'),
unistr('  <li><strong>Beschreibung</strong> - W\00E4hlen Sie die Spalte aus der Tabelle oder View aus, die als Beschreibung f\00FCr die Timelineeintr\00E4ge verwendet werden soll.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452381842303879)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'de'
,p_message_text=>'Zeitstempel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456980833303883)
,p_name=>'CA.TITLE'
,p_message_language=>'de'
,p_message_text=>'Anrede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549366920303129)
,p_name=>'CA.TO'
,p_message_language=>'de'
,p_message_text=>'An'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456161864303882)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'de'
,p_message_text=>'Topbenutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456297798303882)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm Top-Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453746727303880)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen gesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458151596303884)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'de'
,p_message_text=>unistr('Standardrolle f\00FCr Benutzer, die nicht in der Access-Control-Liste enthalten sind:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450311660303877)
,p_name=>'CA.TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760847629303306)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chen-Standards')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760991982303306)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie Standardwerte f\00FCr Einstellungen der Benutzeroberfl\00E4che fest, wie Zeilen pro Seite, und f\00FCgen Sie eine Liste mit Wertdefinitionen hinzu. Diese Einstellungen werden beim Generieren von Komponenten in der Anwendung verwendet. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450529999303878)
,p_name=>'CA.UNTIL'
,p_message_language=>'de'
,p_message_text=>'Bis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809160544303344)
,p_name=>'CA.UPDATE'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459983552303885)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'de'
,p_message_text=>'Profil aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450804326303878)
,p_name=>'CA.UPDATED'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99450991686303878)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99452235130303879)
,p_name=>'CA.USER'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478714728303901)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere Benutzer hinzuf\00FCgen - Schritt 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478843906303901)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere Benutzer hinzuf\00FCgen - Schritt 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478990699303901)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere Benutzer hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99454612794303881)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'de'
,p_message_text=>'Benutzer-Agent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468074269303892)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht zur Benutzeranzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456456111303882)
,p_name=>'CA.USER.NAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458937369303884)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'de'
,p_message_text=>'Benutzerprofil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433878571303864)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'de'
,p_message_text=>'Benutzerprofile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430729239303861)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer d\00FCrfen ihr Profil aktualisieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99433778220303864)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erm\00F6glichen Sie Endbenutzern, zus\00E4tzliche Informationen \00FCber sich selbst, darunter ein Bild oder einen Avatar, einzugeben, um ihren Account zu personalisieren.</p>'),
'<p>Umfasst die folgenden Komponenten:',
'<ul>',
unistr('<li>Einstellungsseite, auf der Endbenutzer ihr Profil festlegen k\00F6nnen</li>'),
unistr('<li>M\00F6glichkeit zum Hochladen eines Fotos/Avatars</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99459151420303884)
,p_name=>'CA.USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458223338303884)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'de'
,p_message_text=>'Format Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479696901303901)
,p_name=>'CA.USERNAMES'
,p_message_language=>'de'
,p_message_text=>'Benutzernamen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768383355303312)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Benutzernamenformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480245516303902)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer hinzugef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99481710373303903)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'de'
,p_message_text=>'Benutzer nach Rollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99462334057303887)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'de'
,p_message_text=>'Einbezogene Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99479980501303902)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuzuf\00FCgende Benutzer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458434079303884)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'de'
,p_message_text=>'Format des Benutzernamens wurde gespeichert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445330776303045)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'de'
,p_message_text=>unistr('G\00FCltige Benutzer vorhanden - Seiteninfo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474073530303897)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anwendungs-ID ist bereits vorhanden oder f\00FCr eine andere Anwendung reserviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715603437303267)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'de'
,p_message_text=>'Der Anwendungsname muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482325382303903)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Muss E-Mail-Adressen bereitstellen, an die Ihre E-Mail gesendet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482171554303903)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Muss E-Mail-Adressen bereitstellen oder eine Benutzergruppe ausw\00E4hlen, an die Ihre E-Mail gesendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482273287303903)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Muss eine Benutzergruppe ausw\00E4hlen, an die Ihre E-Mail gesendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474118107303897)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('Das Pr\00E4fix der Tabelle darf h\00F6chstens sechs Zeichen umfassen, muss mit einem Buchstaben beginnen und darf nur Buchstaben, Zahlen und Unterstriche enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474278037303897)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein anderes Tabellenpr\00E4fix ein. Die folgenden Datenbankobjekte sind bereits vorhanden: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458850164303884)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Das E-Mail-Adressformat f\00FCr den Benutzernamen ist ung\00FCltig. Beachten Sie das f\00FCr die Anwendung geltende Format des Benutzernamens unten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99458730661303884)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('E-Mail-Format pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456388340303882)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'de'
,p_message_text=>'Anzeigen als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99476624749303899)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'de'
,p_message_text=>'Blueprint anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99466238599303890)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'de'
,p_message_text=>'Details anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99482529674303904)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99468322260303892)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'de'
,p_message_text=>'Mein Profil anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99453207118303880)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>'Gewichtete Performance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99487154314303907)
,p_name=>'CA.WIDTH'
,p_message_language=>'de'
,p_message_text=>'Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491389244303911)
,p_name=>'CA.WIZARD'
,p_message_language=>'de'
,p_message_text=>'Assistentenseiten erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445294625303045)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'de'
,p_message_text=>'Assistentencontainer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99491470345303911)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erstellen Sie eine Collection von Seiten, die als Assistent verwendet werden sollen. Im Allgemeinen werden Assistenten f\00FCr die Eingabe von Daten in mehreren Schritten eingesetzt.</p>'),
'<p>Geben Sie die folgenden Attribute ein:</p>',
'<ul>',
unistr('  <li><strong>Assistentenname</strong> (Obligatorisch) - Geben Sie einen Namen f\00FCr diese Seite ein.</li>'),
unistr('  <li><strong>Symbol festlegen</strong> - W\00E4hlen Sie ein Symbol aus, das im Navigationsmen\00FC f\00FCr diese Seite angezeigt werden soll.</li>'),
unistr('  <li><strong>Seitenmodus</strong> (Obligatorisch) - Legen Sie fest, ob die Assistentenschritte als modale oder normale Seiten angezeigt werden. W\00E4hlen Sie entweder <strong>Modale Seite</strong> oder <strong>Ganze Seite</strong> aus.</li>'),
unistr('  <li><strong>Schritt 1 ... 8</strong> - Geben Sie den Seitennamen f\00FCr die Schritte des Assistenten ein.<br><em><strong>Hinweis:</strong> Schritte 5 - 8 werden angezeigt, wenn Namen f\00FCr die einzelnen vorherigen Schritte eingegeben werden.</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99456732767303883)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'de'
,p_message_text=>unistr('Telefon gesch\00E4ftlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99449404395303877)
,p_name=>'CA.YELLOW'
,p_message_language=>'de'
,p_message_text=>'Gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761361354303306)
,p_name=>'CA.YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314323424302938)
,p_name=>'CACHED'
,p_message_language=>'de'
,p_message_text=>'Gecacht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217572438302860)
,p_name=>'CACHE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Cache erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205148644302850)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'de'
,p_message_text=>unistr('"Daten l\00F6schen"-Funktionalit\00E4t ist deaktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190105274302838)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'de'
,p_message_text=>unistr('"Daten hinzuf\00FCgen"-Funktionalit\00E4t ist deaktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190218057302838)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'de'
,p_message_text=>unistr('"Daten aktualisieren"-Funktionalit\00E4t ist deaktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343071945302959)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342923818302959)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229332140302869)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'de'
,p_message_text=>'Einfacher Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247282208303707)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Kalendereintrag bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178627541302830)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'de'
,p_message_text=>unistr('Kalender-Popup f\00FCr %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310009722302935)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Der Kalender wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699660347303253)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Vorg\00E4ngerkalender-Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229283688302869)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'de'
,p_message_text=>'Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562640697303139)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Kalendertemplates bei dem Versuch gefunden, aus Anwendung %0 und Template-ID %1 zu kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701020665303255)
,p_name=>'CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185179960302834)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Kartenaktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933070659303444)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'de'
,p_message_text=>'Kaskadierende Stylesheets'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780456653303321)
,p_name=>'CHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357544641303800)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Authentifizierung \00E4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696363584303251)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Datenbankgr\00F6\00DFe \00E4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696187153303250)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungsanforderung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909852905303424)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Workspace \00E4ndern')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669634264303225)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Zeichensatz')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391211608303000)
,p_name=>'CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173935873302826)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ung\00FCltige Diagrammabfrage: %0<br><br>'),
'Verwenden Sie folgende Syntax:',
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
unistr('<tr><td>LABEL</td><td>Text f\00FCr den Balken</td></tr>'),
unistr('<tr><td>VALUE</td><td>Numerische Spalte f\00FCr die Definition der Balkengr\00F6\00DFe</td></tr>'),
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338818182302956)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ung\00FCltige Diagrammabfrage.<br /><br /> Verwenden Sie folgende Syntax: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>Numerische Spalte f\00FCr die Definition des Dial-Wertes.</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>Numerische Spalte f\00FCr die Definition des maximalen Dial-Wertes.</td>'),
'</tr>',
'<tr>',
'<td>LOW (optional)</td>',
unistr('<td>Numerische Spalte f\00FCr die Definition des minimalen vorherigen Dial-Wertes.</td>'),
'</tr>',
'<tr>',
'<td>HIGH (optional)</td>',
unistr('<td>Numerische Spalte f\00FCr die Definition des maximalen vorherigen Dial-Wertes.</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405671877303013)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Diagrammtyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173865705302826)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Parsen von SQL-Abfrage nicht erfolgreich.',
'<p>%0</p>',
unistr('Bestimmte Abfragen k\00F6nnen nur in Ihrer Anwendung ausgef\00FChrt werden. Wenn Ihre Abfrage syntaktisch korrekt ist, k\00F6nnen Sie Ihre Abfrage ohne Validierung speichern. Die entsprechenden Optionen werden unter der Abfragequelle angezeigt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397181602303833)
,p_name=>'CHART_DEGREES'
,p_message_language=>'de'
,p_message_text=>'Grad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647189939303204)
,p_name=>'CHART_PAGE'
,p_message_language=>'de'
,p_message_text=>'%0-Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205607999302850)
,p_name=>'CHART_SERIES'
,p_message_language=>'de'
,p_message_text=>'Diagrammreihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692816948303248)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei Diagrammdatenreihe %0 f\00FCr %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301872474302928)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Das Diagramm wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650944297303207)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsumme erforderlich: Anwendungsebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484043776303076)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsumme erforderlich: Sessionebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483919128303076)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsumme erforderlich: Benutzerebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483897005303076)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsumme erforderlich: Anwendungsebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397933334303834)
,p_name=>'CHECK_ALL'
,p_message_language=>'de'
,p_message_text=>unistr('Alle ausw\00E4hlen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636441505303196)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Klassischer Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639145012303198)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'de'
,p_message_text=>'Klassischer Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337665420302955)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten von klassischem Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636859771303196)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'de'
,p_message_text=>'Klassischer Baum'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634739971303194)
,p_name=>'CLEAN_UP'
,p_message_language=>'de'
,p_message_text=>'Seite bereinigen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200458552302846)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'de'
,p_message_text=>unistr('Befehl l\00F6schen')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644095299303202)
,p_name=>'CLOSED'
,p_message_language=>'de'
,p_message_text=>'Geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689644340303244)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'de'
,p_message_text=>'In den letzten 7 Tagen geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442704050303043)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'de'
,p_message_text=>unistr('Fenster schlie\00DFen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178130644303646)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'de'
,p_message_text=>'Barrierefreiheitsmodus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474341573303897)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475358181303898)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'de'
,p_message_text=>'Suchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475224064303898)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'de'
,p_message_text=>unistr('Automatisch vervollst\00E4ndigen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302937615303753)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'de'
,p_message_text=>'Einzug'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474665187303897)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Einzugsgr\00F6\00DFe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474872376303897)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'de'
,p_message_text=>unistr('Mit Tabulatortaste Leerzeichen einf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178232843303646)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Element %0 ist nicht vorhanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179313041303647)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'de'
,p_message_text=>'Minikarte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179257366303647)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'de'
,p_message_text=>'Nur wenn >100 Zeilen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99478620916303901)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'de'
,p_message_text=>'Query Builder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475438059303898)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'de'
,p_message_text=>'Wiederholen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475047580303898)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Einstellungen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474978148303898)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'de'
,p_message_text=>'Zeilennummern anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474487564303897)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'de'
,p_message_text=>'Schieberegler anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179171951303647)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Vorschl\00E4ge anzeigen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474792922303897)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'de'
,p_message_text=>'Tabulatorweite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99474528251303897)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'de'
,p_message_text=>'Theme'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179025984303647)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178962727303647)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'de'
,p_message_text=>'Dunkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178783249303647)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'de'
,p_message_text=>'Hoher Kontrast - dunkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178870354303647)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'de'
,p_message_text=>'Hell'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178601576303647)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'de'
,p_message_text=>unistr('Transformation \2013 Gro\00DF-/Kleinbuchstaben f\00FCr Code')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475527319303898)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'de'
,p_message_text=>unistr('R\00FCckg\00E4ngig')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178425513303646)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'de'
,p_message_text=>'Aus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178504764303646)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'de'
,p_message_text=>'Ein'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475111750303898)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'de'
,p_message_text=>'Validieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99475604544303898)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Validierung erfolgreich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178301021303646)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'de'
,p_message_text=>'Leerzeichen anzeigen'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581889688303154)
,p_name=>'COLLAPSE'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213400217302856)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'de'
,p_message_text=>'Farbpalette'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402811885303011)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'de'
,p_message_text=>'Analog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402405599303011)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'de'
,p_message_text=>unistr('Komplement\00E4r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403092602303011)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'de'
,p_message_text=>unistr('Komplement\00E4rfarben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402935089303011)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'de'
,p_message_text=>'Monochromatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402512323303011)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'de'
,p_message_text=>unistr('Teil-komplement\00E4r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402777698303011)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'de'
,p_message_text=>'Tetrade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402627601303011)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'de'
,p_message_text=>'Triade'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390822671303827)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'de'
,p_message_text=>'Anzeigename: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574345309303148)
,p_name=>'COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>'Spaltenname'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762531888303307)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Alle authentifizierten Benutzer k\00F6nnen auf diese Anwendung zugreifen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762610996303307)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Nur in der Access-Control-Liste definierte Benutzer k\00F6nnen auf diese Anwendung zugreifen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762747676303307)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>'Unerwarteter Zugriffskontroll-Einstellungswert: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206526125302851)
,p_name=>'COMING_SOON'
,p_message_language=>'de'
,p_message_text=>unistr('In K\00FCrze verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574854389303148)
,p_name=>'COMMENT'
,p_message_language=>'de'
,p_message_text=>'Kommentar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443846574303044)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'de'
,p_message_text=>'Kompilierung nicht erfolgreich. Zeile <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775053968303317)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'de'
,p_message_text=>'Kompilierung nicht erfolgreich. Zeile %0 (%2) Zeilennummern bei Kompilierungsfehlern beziehen sich auf die erste BEGIN-Anweisung. Dies betrifft nur die Kompilierung von Datenbanktriggern.<br />%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443723933303044)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Code erfolgreich kompiliert (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641406240303200)
,p_name=>'COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648416994303205)
,p_name=>'COMPLETED'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655309476303210)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'de'
,p_message_text=>unistr('Abgeschlossen/Keine Vorg\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690176470303245)
,p_name=>'COMPONENT'
,p_message_language=>'de'
,p_message_text=>'Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818212113303351)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'de'
,p_message_text=>'Komponentenname: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009204751303511)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'de'
,p_message_text=>'Komponente nicht aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305486532302931)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Komponente wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388559991303825)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'de'
,p_message_text=>'Komponentenzusammenfassung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253920948302889)
,p_name=>'COMPUTATIONS'
,p_message_language=>'de'
,p_message_text=>'Berechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712319070303265)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Anwendungskomponenten erfolgreich installiert.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444374043303044)
,p_name=>'CONDITIONAL'
,p_message_language=>'de'
,p_message_text=>'Bedingt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560062096303137)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634264325303194)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'de'
,p_message_text=>'immer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365891865302976)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365210817302976)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365386230302976)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte=Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365402121302976)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte nicht null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179421930303647)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365978859302976)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366052691302976)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'de'
,p_message_text=>'Kein Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365684434302976)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'de'
,p_message_text=>'Seite in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365731033302976)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'de'
,p_message_text=>'Seite nicht in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365581247302976)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'de'
,p_message_text=>'Anforderung=e1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376922432302988)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'de'
,p_message_text=>'Bedingungstyp'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597228893303165)
,p_name=>'CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166394166302820)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Master-Detail (2 Seiten)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166298846302820)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Master-Detail (3 Seiten)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351793630302966)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Tats\00E4chlicher Name')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641299617303199)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'de'
,p_message_text=>'Aggregieren pro Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641396917303200)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Zu verwendende Aggregatfunktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349127950302964)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362614812302974)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Aliasname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362741878302974)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'de'
,p_message_text=>'Standardsprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362543934302974)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259534844302894)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'de'
,p_message_text=>unistr('Ergebnisbaum f\00FCr Bericht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259633969302894)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'de'
,p_message_text=>unistr('Ergebnisparameter f\00FCr Bericht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362889585302974)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816324267303349)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zu Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565512886303141)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechselspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351592278302966)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'de'
,p_message_text=>unistr('%0-Schaltfl\00E4chenverzweigung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351418249302966)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigetext f\00FCr die Schaltfl\00E4che "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186881423302836)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen von Daten aktivieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186742591302836)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'de'
,p_message_text=>'Drag-and-Drop aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764832854303309)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'de'
,p_message_text=>'Verzweigung abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816198248303349)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Label f\00FCr die Schaltfl\00E4che "Abbrechen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808236780303343)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'de'
,p_message_text=>unistr('Gro\00DF-/Kleinschreibung beachten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442209851303042)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die \00C4nderung der Abfrage f\00FCr den interaktiven Bericht angefordert. Wenn Sie Spalten aus der Abfrage entfernt haben, werden vorhandene Filter, Markierungsregeln und andere Berichtseinstellungen f\00FCr diese Spalten deaktiviert. Best\00E4tigen Sie I')
||'hre Anforderung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352635477302966)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'de'
,p_message_text=>'Diagrammachse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701426842303255)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'de'
,p_message_text=>'Dial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701590670303255)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'de'
,p_message_text=>'Dial (Sweep)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353370442302967)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'de'
,p_message_text=>'Horizontaler Balken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353599091302967)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352809557302967)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'de'
,p_message_text=>'Zahlenmaske'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353412029302967)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'de'
,p_message_text=>'Kreis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352565954302966)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'de'
,p_message_text=>'Diagrammabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352719651302967)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'de'
,p_message_text=>'Nachkommastellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353697694302967)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'de'
,p_message_text=>'Streudiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353139577302967)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Diagrammgr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353062009302967)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Diagramm\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352945322302967)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'de'
,p_message_text=>'Diagrammtyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353268228302967)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'de'
,p_message_text=>'Vertikaler Balken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259771205302894)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Name f\00FCr die tempor\00E4re Ergebnismenge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349912929302964)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565318312303141)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten\00FCberschriften')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728082611303278)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>'Spaltenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765000097303309)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'de'
,p_message_text=>'Spaltenname(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362231576302974)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'de'
,p_message_text=>unistr('Sortierung nach Spalten\00FCberschriften')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486238697303078)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Kopieren einer Anwendung mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360810381302973)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Kopieren einer Seite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350474525302965)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'de'
,p_message_text=>'Eine neue Registerkartengruppe "%0" wird erstellt und von dieser Seite verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362494359302974)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Anwendung mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354910272302968)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Kalenderseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358171859302971)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Seite f\00FCr einen Aufgliederungsbericht mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411019873303018)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Erstellung einer Seite f\00FCr einen interaktiven Bericht angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361128130302973)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Berichtsseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369552549303810)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben angefordert, dass eine Datenbankanwendung mit derselben ID wie eine vorhandene Datenbankanwendung im aktuellen Workspace erstellt wird. Die vorhandene Datenbankanwendung wird gel\00F6scht und dann durch die neue Datenbankanwendung ersetzt. Best')
||unistr('\00E4tigen Sie die Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724936858303276)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen von Form- und Listenansichtsseiten mit folgenden Attributen angefordert. Best\00E4tigen Sie die Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640922458303199)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Form und einer Berichtsseite mit Analyseseiten angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354553418302968)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen eines Formulars basierend auf einer SQL-Abfrage mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354410710302968)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen eines Formulars basierend auf einer gespeicherten Prozedur mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354300936302968)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen eines Formulars basierend auf einer Tabellenseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230076978302870)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen eines Formulars basierend auf einer Webservicereferenz-Seite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270284910302902)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Form und eines Berichts \00FCber eine Webservicereferenz-Seite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668501238303224)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Kartenseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98163949690302818)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen von Master-Detailseiten mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356134522302969)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Navigationspfadregion und Navigationspfadoption mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647229457303204)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'de'
,p_message_text=>'Modus erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354153892302968)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Seite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418598055303852)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'de'
,p_message_text=>'Seite erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418638395303852)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Seitenname erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356958817302970)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen von Form- und Berichtseiten mit folgenden Attributen angefordert. Best\00E4tigen Sie Ihre Wahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365487876303806)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Seite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360946400302973)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Berichtsseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354613735302968)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer HTML-Balkendiagrammseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360518477302972)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Zusammenfassungsseite mit folgenden Attributen angefordert. Klicken Sie auf <b>Weitere hinzuf\00FCgen</b>, um zus\00E4tzliche Elemente von anderen Seiten und/oder Regionen hinzuzuf\00FCgen. Klicken Sie auf <b>Beenden</b>, um die Zus')
||'ammenfassungselemente zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354783840302968)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer SVG-Diagrammseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354053101302968)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer tabellarischen Formularseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355221336302968)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen einer Baumseite mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98354278835302968)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen eines Assistenten mit folgenden Attributen angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369469986303810)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben angefordert, dass eine Websheet-Anwendung mit derselben ID wie eine vorhandene Websheet-Anwendung im aktuellen Workspace erstellt wird. Die vorhandene Websheet-Anwendung wird gel\00F6scht und dann durch die neue Websheet-Anwendung ersetzt. Best')
||unistr('\00E4tigen Sie die Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562025698303138)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'de'
,p_message_text=>'Link-Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306117477303756)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'de'
,p_message_text=>'Datenladedefinitionsname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376579221303815)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Diese Datenladedefinition wird mit den vorhandenen Tabellen-Lookups und Transformationsregeln neu erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808364604303343)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seitennummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355015698302968)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Datumsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647309043303204)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Standard-Authentifizierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353980230302967)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358888281302971)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'de'
,p_message_text=>'%0-Anzeigespalten - Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166727819302820)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Detail-Anzeigespalte(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360467200302972)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'de'
,p_message_text=>'Detail-Navigationspfadspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359675510302972)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'de'
,p_message_text=>'Detail-Tabelle %0 anordnen nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358314218302971)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'de'
,p_message_text=>'Detailseite %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166661697302820)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'de'
,p_message_text=>'Detail-Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358691018302971)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'de'
,p_message_text=>'Der Name der Detail-Tabelle %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358425376302971)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Label f\00FCr Detailregisterkarte %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765377878303309)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Uploadspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352075172302966)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727718864303278)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'de'
,p_message_text=>'Uploadspalte 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727875754303278)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'de'
,p_message_text=>'Uploadspalte 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356348721302969)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426122328303858)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426201864303858)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Seitenname bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551963852303131)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'de'
,p_message_text=>'CSV-Ausgabe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552623177303131)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Druckausgabe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553217793303132)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'de'
,p_message_text=>unistr('Sortieren der Spalten\00FCberschriften aktivieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599159069303167)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Der vorhandenen Administrationsseite wird eine Region hinzugef\00FCgt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764951467303309)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'de'
,p_message_text=>'Verzweigung beenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357433348302970)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'de'
,p_message_text=>'Formularseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357554376302970)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Form-Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357788467302970)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'de'
,p_message_text=>'Formularseiten-Registerkartenlabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357684219302970)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'de'
,p_message_text=>'Formularseiten-Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647463568303204)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponenten importieren aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994263915303499)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzerdefinierten Kalender einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166922111302820)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'de'
,p_message_text=>'Master-Bericht einbeziehen?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360142204302972)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad einbeziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351241887302965)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Informations-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351316239302965)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'de'
,p_message_text=>'Informations-Standardtext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230253012302870)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Form-Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259952370302894)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Form-Regionstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259862630302894)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Formularregions\00FCberschrift:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353721952302967)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351013077302965)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'de'
,p_message_text=>'Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765230032303309)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('R\00FCckgabespalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764182256303309)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'de'
,p_message_text=>unistr('Lookup-Schl\00FCsselspalte 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764268297303309)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'de'
,p_message_text=>unistr('Schl\00FCsselspalte 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764355469303309)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'de'
,p_message_text=>unistr('Schl\00FCsselspalte 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355128081302968)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Labelspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727950766303278)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Lookup-Eigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765195251303309)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'de'
,p_message_text=>'Lookup-Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167071222302820)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'de'
,p_message_text=>'Master-Detail-Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166561127302820)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Master-Anzeigespalte(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166847970302820)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'de'
,p_message_text=>'Master-Datensatz navigieren nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98166420573302820)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'de'
,p_message_text=>'Mastertabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565436369303141)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Maximale Anzahl von Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561842316303138)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen pro Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418106087303023)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356638971302969)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad-Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360260658302972)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad-Root'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356410003302969)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356758952302969)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadtext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232754440302872)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben ein Upgrade des HTML-Diagramms auf ein neues HTML5-Diagramm angefordert. Best\00E4tigen Sie die Anforderung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385100722303822)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben ein Upgrade von jsTree auf eine neue Baumstruktur angefordert. Best\00E4tigen Sie die Anforderung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342883343302959)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Das Upgrade des SVG-Diagramm erfolgt mit folgenden Einschr\00E4nkungen:  '),
'<ul>',
'<li>',
'Es werden nur Zahlenformate migriert, die in Achsenformat-Zeichenfolgen definiert sind. Datums- und Zeitformate werden ignoriert.',
'</li>',
'<li>',
'Es werden Zahlenformatelemente migriert, die Folgendes enthalten:',
'<br />',
'0,9,D,G,, (Komma),. (Punkt),$,C,L,FM',
'</li>',
'<li>',
unistr('Das Label f\00FCr die Datenreihe im Flash-Diagramm wird vom Spaltenaliasnamen der Datenreihe abgeleitet.  '),
'Bei SVG-Diagrammen wird hingegen das Label der jeweiligen Datenreihe vom Namensattribut der Datenreihe abgeleitet.',
'</li>',
'<li>',
unistr('In Flash Dial-Diagrammen werden anstelle von Prozents\00E4tzen die tats\00E4chlichen Werte angezeigt.'),
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306841170302932)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben ein Upgrade des SVG-Diagramms auf ein HTML5-Diagramm angefordert. Best\00E4tigen Sie die Anforderung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365240833303806)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363169550302974)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976558648303484)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FCliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658794806303213)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Eine neue Administrationsseite wird hinzugef\00FCgt. Seite:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442465420303042)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Neue Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351803308302966)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Neues Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815954588303349)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Label der Schaltfl\00E4che "Weiter"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350376598302965)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Seite wurde keine Registerkartengruppe ausgew\00E4hlt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350992681302965)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Kein Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230307971302870)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Ausgabeelemente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352256820302966)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349226576302964)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362978274302974)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349304472302964)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350210437302965)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Seiten\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358784740302971)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Anzeigespalten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356866851302970)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordneter Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360379999302972)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Navigationspfadspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358993722302971)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Tabelle anordnen nach')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358288776302971)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Seite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358506662302971)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der Name der \00FCbergeordneten Tabelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350853570302965)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Label f\00FCr \00FCbergeordnete Registerkarte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350792277302965)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkartengruppe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442165373303042)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Parsingschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448811688303048)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Aktualisierung von Seitenbestandteilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816052821303349)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Label der Schaltfl\00E4che "Zur\00FCck"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350132843302965)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschl\00FCsselspalte %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357847329302970)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschl\00FCsselspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562179472303139)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Ausgabeformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565616237303141)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Link-Label drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562226929303139)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Bericht drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352115112302966)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Prozessoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561959867303138)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Regionsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351182894302965)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Regionstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349423601302964)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Regions\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356224556302969)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'de'
,p_message_text=>'Regionstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442374601303042)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Entfernte Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357935097302970)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581989222303154)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'de'
,p_message_text=>'Berichtimplementierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357036025302970)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Berichtsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357153950302970)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Berichtsseitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357310417302970)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'de'
,p_message_text=>'Berichtsseiten-Registerkartenlabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98357287327302970)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'de'
,p_message_text=>'Berichtsseiten-Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260199617302894)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Berichtsregions-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260057271302894)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Berichts-Regions\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361205153302973)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Berichtstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262608402302896)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Zeilenversionsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361476722302973)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'de'
,p_message_text=>'Standard: HTML (Standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361788937302973)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'de'
,p_message_text=>'Standard: Darstellung 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361834364302973)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'de'
,p_message_text=>'Standard: Darstellung 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441967149303042)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'de'
,p_message_text=>'Standard: Darstellung 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442017030303042)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'de'
,p_message_text=>'Standard: Darstellung 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260666930302895)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'de'
,p_message_text=>'Standard: Darstellung 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361509685302973)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'de'
,p_message_text=>'Standard: Vertikaler Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361967074302973)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'de'
,p_message_text=>'Exportieren: CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362073790302973)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'de'
,p_message_text=>'Exportieren: XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361625989302973)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'de'
,p_message_text=>'Standard: vertikaler Bericht, Darstellung 1 (Null-Spalten einbeziehen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441758320303042)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'de'
,p_message_text=>unistr('Standard: vertikaler Bericht, Darstellung 2 (Null-Spalten ausschlie\00DFen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441851110303042)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'de'
,p_message_text=>'Standard: vertikaler Bericht, Darstellung 2 (Null-Spalten einbeziehen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765471874303310)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'de'
,p_message_text=>'Regelname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765649307303310)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765761935303310)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'de'
,p_message_text=>'Regeltyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205381298302850)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ausf\00FChrung des folgenden Skripts angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356521754302969)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361379772302973)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'de'
,p_message_text=>'Sortieroption'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352425830302966)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448701067303048)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596894436303165)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'de'
,p_message_text=>'Mehrere Seiten werden erstellt, beginnend mit Seite:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98352394891302966)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'de'
,p_message_text=>'Name der gespeicherten Prozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443661241303043)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer der gespeicherten Prozedur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816283054303349)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Label f\00FCr die Schaltfl\00E4che "Fertigstellen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380504961303819)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'de'
,p_message_text=>'Theme abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351693109302966)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'de'
,p_message_text=>'Vorgeschlagener Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641051180303199)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle/View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641187429303199)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'de'
,p_message_text=>'Zusammenfassen pro Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827306623303358)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'de'
,p_message_text=>'Tabellen-Lookups'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349804147302964)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'de'
,p_message_text=>'Tabellenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349736726302964)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Tabelleneigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927491167303439)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'de'
,p_message_text=>'Transformationsregel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765824402303310)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'de'
,p_message_text=>'Transformationsregeln'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442620588303043)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'de'
,p_message_text=>'Tabellen-/View-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442541821303043)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Tabellen-/View-Eigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363083942302974)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350678891302965)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung. Informationen zur Registerkartengruppe sind unvollst\00E4ndig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349679367302964)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'de'
,p_message_text=>'Registerkartenlabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98361023619302973)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'de'
,p_message_text=>'Registerkartenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349545682302964)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'de'
,p_message_text=>'Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362171522302973)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355881331302969)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'de'
,p_message_text=>'Basiert auf neuem Element mit Popup-Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355524619302969)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'de'
,p_message_text=>'Maximale Ebenen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355310865302968)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'de'
,p_message_text=>'Baumname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355732817302969)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'de'
,p_message_text=>'Baumabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355999618302969)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'de'
,p_message_text=>'Auf einer SQL-Abfrage basierend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355606973302969)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'de'
,p_message_text=>'Ausgangsbaum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98356022606302969)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98355408733302969)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'de'
,p_message_text=>'Baumtyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363255594302974)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363319416302974)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'de'
,p_message_text=>'Blau und Gelbbraun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363482719302974)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'de'
,p_message_text=>'Rot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363504939302975)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'de'
,p_message_text=>'Marineblau und Grau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363619544302975)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'de'
,p_message_text=>unistr('Olivgr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363735608302975)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'de'
,p_message_text=>'Kastanienbraun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363867873302975)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'de'
,p_message_text=>'Einfaches Blau und Gelbbraun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98363917214302975)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'de'
,p_message_text=>'Blau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364094691302975)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350080306302964)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Aktualisierbare Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98353893744302967)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98350545880302965)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'de'
,p_message_text=>'Diese Seite verwendet die vorhandene Registerkartengruppe "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230198041302870)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'de'
,p_message_text=>'Webservicereferenz, Vorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98358045516302970)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'de'
,p_message_text=>'WHERE-Klausel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631577122303192)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'de'
,p_message_text=>unistr('Symbol f\00FCr die Best\00E4tigung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641890570303200)
,p_name=>'CONFIRMED'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642132646303200)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'de'
,p_message_text=>unistr('Von QA best\00E4tigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562482904303139)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechselspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562386756303139)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Druckformat'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669710261303225)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'de'
,p_message_text=>'Content Disposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702409654303256)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'de'
,p_message_text=>'Behandelter Inhalt'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480635230303902)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'de'
,p_message_text=>'Beitragende'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395268820303831)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'de'
,p_message_text=>'Neue statische ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441508103303042)
,p_name=>'COPY_ACTION'
,p_message_language=>'de'
,p_message_text=>'Aktion kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306674987302932)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Anwendung wurde kopiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420923311303025)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei Ausf\00FChrung von copy_button: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486822046303078)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'de'
,p_message_text=>'Objektdefinitionsattribute kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281783126302912)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'de'
,p_message_text=>'Anwendung kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725706325303276)
,p_name=>'COPY_FEATURE'
,p_message_language=>'de'
,p_message_text=>'Feature kopieren: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486411261303078)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Aus Anwendung kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867311159303389)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Basierend auf Templateanwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486570567303078)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'de'
,p_message_text=>'Aus Name kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310410414302935)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Listeneintrag kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421347465303026)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei Ausf\00FChrung von copy_named_lov: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421243508303026)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'de'
,p_message_text=>'Wertelisten-ID "%0" nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421111247303025)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'de'
,p_message_text=>'Wertelisten-ID "%0" ist nicht numerisch.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707260733303260)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'de'
,p_message_text=>'Kopie aus Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707394852303260)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'de'
,p_message_text=>'Kopie in Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706377704303259)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>unistr('- Autorisierung ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706209586303259)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('- Liste ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706121302303259)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('- Werteliste ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770545258303313)
,p_name=>'COPY_TABLE'
,p_message_language=>'de'
,p_message_text=>'Kopieren von %0 in Tabelle %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486678441303078)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'In Anwendung kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486728290303078)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'de'
,p_message_text=>'In Name kopieren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393372846303002)
,p_name=>'CORE'
,p_message_language=>'de'
,p_message_text=>'Kern'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836392751303364)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836437799303364)
,p_name=>'CREATE OBJECT'
,p_message_language=>'de'
,p_message_text=>'Objekt erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725482252303276)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'de'
,p_message_text=>'In den letzten 7 Tagen erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281828904302912)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Aus einem Anwendungstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308934599303759)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'de'
,p_message_text=>'Kerzendiagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308778435303759)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'de'
,p_message_text=>'2D- und 3D-Spalten-, Balken- und Stapeldiagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309470790303759)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'de'
,p_message_text=>'Skalen- und Skalen-(Prozent)-Diagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308831015303759)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'de'
,p_message_text=>'2D- und 3D-Kreis- und Ringdiagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309120185303759)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'de'
,p_message_text=>'Projekt-Gantt-Diagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309343591303759)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'de'
,p_message_text=>'2D- und 3D-Bereichsdiagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309282241303759)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'de'
,p_message_text=>'Ressourcen-Gantt-Diagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309061657303759)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'de'
,p_message_text=>'Streumarkerdiagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386761375302997)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'de'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386573306302996)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'de'
,p_message_text=>'Pfeil nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386612765302996)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'de'
,p_message_text=>'Pfeil nach rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386372502302996)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386429700302996)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'de'
,p_message_text=>'Bedingungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386846092302997)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'de'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386983663302997)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'de'
,p_message_text=>'Vorschaubedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726149974303277)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie unten auf "Berechtigungen erteilen", um %0 mit diesen Berechtigungen auszustatten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725981359303277)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'de'
,p_message_text=>'%0 hat nicht die Berechtigung CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE oder CREATE PROCEDURE und kann somit die Demoanwendung nicht installieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726077432303277)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 hat keine Ausf\00FChrungsberechtigung f\00FCr CTX_DOC und CTX_DDL und kann somit die Demo "President''s Inaugural" nicht installieren. F\00FChren Sie folgende Berechtigungserteilungen als berechtigter Benutzer aus: '),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969939570303479)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che erstellen - Dialog geschlossen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202789577302848)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'de'
,p_message_text=>'Dynamische Liste erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443456743303043)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'de'
,p_message_text=>'Dynamische Werteliste erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180745430302831)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'de'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219832982302861)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'de'
,p_message_text=>'Datenbankaccount'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861072107303384)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Authentifizierung f\00FCr Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726563931303277)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'de'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365378400303806)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FCliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861158691303384)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'de'
,p_message_text=>'Keine Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860799152303384)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'de'
,p_message_text=>'Keine Registerkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860843197303384)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten mit einer Ebene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726623291303277)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'de'
,p_message_text=>'Single Sign On (SSO)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860966435303384)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten mit zwei Ebenen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281630841302911)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'de'
,p_message_text=>'Aus einem Spreadsheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175373138302827)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Komponenten f\00FCr die globale Seite werden auf allen Seiten angezeigt, wenn der Anzeigepunkt ihrer Region im ausgew\00E4hlten Seitentemplate enthalten ist. Bedingte Anzeigeattribute k\00F6nnen zum Unterdr\00FCcken der Anzeige verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412045317303018)
,p_name=>'CREATE_INDEX'
,p_message_language=>'de'
,p_message_text=>'Index erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585360032303156)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Keine zugeh\00F6rige Region')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393065755303002)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'de'
,p_message_text=>'Neue Anmeldeseite erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388421667302998)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zum Assistenten zum Erstellen von Tabellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387949857302998)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'de'
,p_message_text=>'Package durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387809026302998)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'de'
,p_message_text=>'Das Package "%0" wurde im "%1"-Schema erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388598556302998)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'de'
,p_message_text=>'Erstellen von Tabelle "%0" nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388308866302998)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'de'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388184272302998)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388246601302998)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388055303302998)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'de'
,p_message_text=>'Home SQL Workshop '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383642646302994)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Elemente gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383209006302994)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Seitenelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383545610302994)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Prompt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383304470302994)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383456752302994)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie hier, um die Region festzulegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381380577302992)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Seitenelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381436353302992)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387784973302997)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'de'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387512597302997)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387477091302997)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'de'
,p_message_text=>unistr('Skript ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387119804302997)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'de'
,p_message_text=>unistr('Das Skript zum Erstellen von Tabellen f\00FCr die Tabelle %0 wurde im SQL-Skript-Repository erstellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387227141302997)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'de'
,p_message_text=>'Gehe zu Skript-Repository'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387639141302997)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98387301752302997)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'de'
,p_message_text=>'Home SQL Workshop '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816931120303350)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'de'
,p_message_text=>'Tabellarisches Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383155542303821)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'de'
,p_message_text=>'To-do erstellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771163531303314)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'de'
,p_message_text=>'Erstellen von Trigger %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717466566303269)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Websheet-Datenbankobjekte erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98671944924303227)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer der Zugangsdaten')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636338871303196)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Kalender'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559706471303137)
,p_name=>'CURRENT'
,p_message_language=>'de'
,p_message_text=>'Aktuell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628887123303190)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'de'
,p_message_text=>'Aktueller Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628594561303189)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'de'
,p_message_text=>'Aktuelles Formularelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403167748303011)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Hilfetext f\00FCr aktuelles Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628640394303190)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Element-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628712859303190)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'de'
,p_message_text=>'Aktueller Elementlabelname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684406542303239)
,p_name=>'CURRENT TAB'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Registerkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369725413302979)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376569259302988)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'de'
,p_message_text=>'Aktuelles Bild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910031503303425)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'de'
,p_message_text=>'ID, die in einem Containerelement, das das aktuelle Feld umbricht, im Attribut "Vor Label und Element" verwendet werden kann.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387886675303825)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Hilfetextlabel f\00FCr aktuelles Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338299418302956)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'de'
,p_message_text=>'Aktueller Meilenstein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375673711302984)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653199537303209)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'de'
,p_message_text=>unistr('Aktuelle Seite enth\00E4lt keine Elemente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624483507303186)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'de'
,p_message_text=>'Link anpassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184064042303651)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201644454302847)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'de'
,p_message_text=>'Entwicklerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416839495303022)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338497689302956)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine beliebige Zeichenfolge als Ihre Benutzer-ID f\00FCr diese Session ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338523099302956)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Benutzernamen und das Kennwort f\00FCr %0 ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338670954302956)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Benutzernamen und das Kennwort f\00FCr die Verifizierung durch den LDAP-Host ein: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338792147302956)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Benutzernamen und das Kennwort f\00FCr das Datenbankschema ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994511010303499)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Erneut laden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999530073303503)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'de'
,p_message_text=>'Enddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999427506303503)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772048345303315)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die Aktion mit Status "True" "Wert festlegen" mit einer festgelegten SQL-Anweisung ist, m\00FCssen Sie die betroffenen Elemente in der Reihenfolge definieren, die der Spaltenreihenfolge Ihrer SQL-Anweisung entspricht. Die von Ihnen definierte SQL')
||'-Anweisung war:</p>',
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569685565303144)
,p_name=>'DATA'
,p_message_language=>'de'
,p_message_text=>'Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835939219303364)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'Data Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424717935303028)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'de'
,p_message_text=>'Alle %0 Spalten wurden automatisch der Tabelle %1 zugeordnet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425509242303029)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('Daten in Tabelle <code>%0</code> wurden mit <b id="incompl_success_row_count"></b> neuen Zeilen angeh\00E4ngt. <b class="u-danger-text" id="incompl_fail_row_count"></b> Zeilen wurden abgelehnt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425179153303029)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Daten in Tabelle <code>%0</code> wurden mit <b id="success_row_count"></b> neuen Zeilen angeh\00E4ngt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425373167303029)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Daten in Tabelle <code>%0</code> wurden mit <b id="err_success_row_count"></b> neuen Zeilen angeh\00E4ngt. <b class="u-danger-text" id="err_fail_row_count"></b> Zeilen wurden abgelehnt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177889860302829)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172426193302825)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Die Spaltenzuordnung muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215462101302858)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'de'
,p_message_text=>'Konfiguration gespeichert.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177418027302829)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'de'
,p_message_text=>'Datenprofil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177567925302829)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'de'
,p_message_text=>'Datenprofilspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176849633302828)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'de'
,p_message_text=>'Datenquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424812573303028)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'de'
,p_message_text=>'Definieren Sie die Spaltenzuordnung, um diese Daten in die Tabelle %0 zu laden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177307737302829)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'de'
,p_message_text=>'Datenladedefinition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177741108302829)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'de'
,p_message_text=>'Datei per Drag-and-Drop hier ablegen oder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177643444302829)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzte Formate: CSV, XLSX, TXT, XML, JSON')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833944162303362)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Ausf\00FChrung des Datenladejobs wurde unerwartet gestoppt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776873345303318)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'de'
,p_message_text=>'Datenladejob in Workspace %0: Laden in Tabelle %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177078597302828)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'de'
,p_message_text=>'Geladene Datei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424939190303029)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'de'
,p_message_text=>'%0 von %1 Spalten wurden automatisch der Tabelle %2 zugeordnet. Konfigurieren Sie die verbleibenden %3 Spalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815045995303348)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'de'
,p_message_text=>unistr('Eingef\00FCgte Daten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425693811303029)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'de'
,p_message_text=>'Daten in Tabelle <code>%0</code> wurden mit <b id="incompl_success_row_count"></b> neuen Zeilen ersetzt. <b class="u-danger-text" id="incompl_fail_row_count"></b> Zeilen wurden abgelehnt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425255990303029)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Daten in Tabelle <code>%0</code> wurden mit <b id="success_row_count"></b> neuen Zeilen ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425471386303029)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'de'
,p_message_text=>'Daten in Tabelle <code>%0</code> wurden mit <b id="err_success_row_count"></b> neuen Zeilen ersetzt. <b class="u-danger-text" id="err_fail_row_count"></b> Zeilen wurden abgelehnt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98425041360303029)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die zu ladenden Spalten aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157952933302813)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzte Formate %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176982054302828)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'de'
,p_message_text=>'Datei hochladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177103204302828)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'de'
,p_message_text=>'XLSX-Arbeitsblatt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377296409303816)
,p_name=>'DATABASE'
,p_message_language=>'de'
,p_message_text=>'Datenbank'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836571216303364)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'de'
,p_message_text=>'Database-Browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322332747303771)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'de'
,p_message_text=>'Datenbankanwendung (Beispiel)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377345397303816)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Datenbankanwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221339804302863)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Datenbankanwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236932023302875)
,p_name=>'DATABASE_APPS'
,p_message_language=>'de'
,p_message_text=>'Datenbankanwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712173899303264)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Anwendung <strong>%0</strong> erfolgreich installiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614811892303179)
,p_name=>'DATABASE_LINK'
,p_message_language=>'de'
,p_message_text=>'Datenbanklink'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664339493303217)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'de'
,p_message_text=>'Anzahl Datenbankobjekte nach Objekttyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667597930303223)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'de'
,p_message_text=>unistr('Berechtigungen f\00FCr Datenbankrolle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232693575302872)
,p_name=>'DATABASE_USERS'
,p_message_language=>'de'
,p_message_text=>'Datenbank'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766329560303310)
,p_name=>'DATA_GRID'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312294731303762)
,p_name=>'DATA_GRIDS'
,p_message_language=>'de'
,p_message_text=>'Datenraster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312610397303762)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid-Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299193582303750)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Erweiterte Einstellungen f\00FCr Datenladen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312370301302936)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Zu verwendende Datums-/Zahlenformate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312407327302936)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, ob benutzerdefinierte Formatmasken oder Standardformatmasken verwendet werden sollen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233090146302872)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'de'
,p_message_text=>'Datei-Zeichensatz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825740021303356)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'de'
,p_message_text=>'Spaltennamen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710277664303263)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'de'
,p_message_text=>'Spaltenaliasnamen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965141882303474)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'de'
,p_message_text=>'Die Daten wurde erfolgreich in die Tabelle hochgeladen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970699711303479)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'de'
,p_message_text=>unistr('Kopieren und einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959589638303470)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'de'
,p_message_text=>unistr('Durch Begrenzungszeichen getrennte Daten kopieren und einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341664973303787)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrungssymbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341725623303787)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Ihre Daten ein internationales W\00E4hrungssymbol enthalten, geben Sie dieses hier ein. Beispiel: Wenn Ihre Daten "&euro;1,234.56" oder "&yen;1,234.56" enthalten, geben Sie "&euro;" oder "&yen;" ein. Andernfalls werden die Daten nicht ordnungsgem\00E4\00DF ')
||'geladen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237783346302876)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'de'
,p_message_text=>'Laden von Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299264988303750)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'de'
,p_message_text=>'Standardformatmasken der Anwendung verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299339478303750)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzerdefinierte Formate f\00FCr hochgeladene Spalten bereitstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342930883303788)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Das Dezimalzeichen trennt bei einer Zahl die Ganzzahl von den Dezimalstellen.</p><p> Sie k\00F6nnen ein beliebiges Zeichen als Dezimalzeichen festlegen. Das angegebene Zeichen muss ein Ein-Byte-Zeichen sein, und das Dezimalzeichen darf nicht mit dem G')
||unistr('ruppentrennzeichen identisch sein. Bei dem Zeichen kann es sich um ein Leerzeichen handeln. Numerische Zeichen oder folgende Sonderzeichen sind nicht zul\00E4ssig:</p>'),
'<ul class="noIndent">',
'<li>Plus (+)</li>',
'<li>Bindestrich (-)</li>',
'<li>Kleiner-als-Zeichen (<)</li>',
unistr('<li>Gr\00F6\00DFer-als-Zeichen (>)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342023100303787)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'de'
,p_message_text=>'Dezimalzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340976925302958)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Ein Dezimalzeichen ist erforderlich, wenn ein Gruppentrennzeichen f\00FCr die Tabellenspalte %0 definiert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710451900303263)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776909810303318)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'de'
,p_message_text=>'Der Tabellenspalte %0 sind mehrere Quellspalten zugeordnet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108315868303591)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'de'
,p_message_text=>'Fehlerhafte Zeilen:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323726311303772)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht erfolgreiche Datens\00E4tze')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341293925303786)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'de'
,p_message_text=>'Der Name der Datei, die hochgeladen werden soll'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967721234303477)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Erste Zeile enth\00E4lt Spaltennamen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341308029303786)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie dieses Kontrollk\00E4stchen, wenn Ihre Daten Spaltennamen in der ersten Zeile enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341536959303787)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'de'
,p_message_text=>'Globalization'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341921151303787)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ein Gruppentrennzeichen trennt Gruppen von Ganzzahlen, beispielsweise Tausender und Millionen.</p>',
unistr('<p>Sie k\00F6nnen ein beliebiges Zeichen als Gruppentrennzeichen verwenden. Das angegebene Zeichen muss ein Ein-Byte-Zeichen sein und darf nicht einem anderen Dezimalzeichen identisch sein. Bei dem Zeichen kann es sich um ein Leerzeichen handeln. Numeris')
||unistr('che Zeichen oder folgende Sonderzeichen sind nicht zul\00E4ssig:</p><ul class="noIndent">'),
'<li>Plus (+)</li>',
'<li>Bindestrich (-)</li>',
'<li>Kleiner-als-Zeichen (<)</li>',
unistr('<li>Gr\00F6\00DFer-als-Zeichen (>)</li> </ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341846079303787)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'de'
,p_message_text=>'Gruppentrennzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108197115303591)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Eingef\00FCgte Zeilen:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338714376303784)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Abfrage gibt \00FCber #MAX_ROW_COUNT# Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709158390303262)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'de'
,p_message_text=>unistr('Datens\00E4tze von einem anderen Benutzer ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332323581302951)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'de'
,p_message_text=>unistr('Gro\00DF-/Kleinschreibung beachten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332231360302951)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931275517303443)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'de'
,p_message_text=>'Datenladen nicht erfolgreich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931372951303443)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Aktion verarbeitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955335491303467)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'de'
,p_message_text=>'Importieren aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764503389303309)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'de'
,p_message_text=>'Schritt 2 - Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389641277303826)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Dateivorschau verf\00FCgbar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340401454303786)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Optional umschlossen von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302693877303753)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'de'
,p_message_text=>'Datenladeassistent - Fortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764722514303309)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'de'
,p_message_text=>'Schritt 4 - Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710333395303263)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708642517303261)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Zu pr\00FCfende Zeile(n):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822809286303354)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate);',
'',
'my_func(p_1  => :SAL,',
'        p_2  => :COMM);',
'',
'wobei SAL und COMM Spaltennamen der hochgeladenen Daten sind',
unistr('und my_func die Funktion ist, die den Wert zur\00FCckgibt, der zum neuen Wert'),
unistr('f\00FCr die Spalte wird, f\00FCr die diese Transformationsregel definiert wird.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823000663303354)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result   number;',
'begin',
'   l_result := :SAL * :COMM',
'   return l_result;',
'end;',
'',
unistr('Auch hier wird das zur\00FCckgegebene Ergebnis zum neuen Wert der Spalte, f\00FCr die diese Transformationsregel definiert wird.'),
'',
':SAL und :COMM beziehen sich auf die Spaltennamen SAL und COMM der hochgeladenen Daten.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822965552303354)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'',
'select depno',
'  from dept',
'  where dname = :DEPTNAME',
'  and   loc = :LOC',
'',
'wobei :DEPNAME und :LOC sich auf die Spaltennamen DEPNAME und LOC der hochgeladenen Daten beziehen.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98349082329302964)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen nicht dasselbe Zeichen als Gruppentrennzeichen und Dezimalzeichen in der Tabellenspalte %0 definieren. Geben Sie unterschiedliche Zeichen ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340239258303786)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Spaltentrennzeichen ein. Verwenden Sie <code>\005Ct</code> f\00FCr Tabulatoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340304790303786)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'de'
,p_message_text=>'Trennzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710580939303263)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298927537303750)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Einstellungen verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299034574303750)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigen Sie erweiterte Einstellungen f\00FCr das Laden von Daten an: W\00E4hrungssymbol, Dezimalzeichen, Dateicodierung oder Datumsformate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975269870303483)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'de'
,p_message_text=>'Datenladequelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764455397303309)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'de'
,p_message_text=>'Schritt 1 - Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377598056303816)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'de'
,p_message_text=>unistr('(\005Ct f\00FCr Tabulator)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339094596303785)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108205455303591)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'de'
,p_message_text=>'Aktualisierte Zeilen:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418871859303852)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'de'
,p_message_text=>'Nullwert wurde hochgeladen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970530543303479)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'de'
,p_message_text=>'Datei hochladen, durch Kommas (*.csv) oder Tabulatoren getrennt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975431938303483)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'de'
,p_message_text=>'Datenladeergebnisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975372845303483)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Datenvalidierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764651543303309)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'de'
,p_message_text=>'Schritt 3 - Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768760971303312)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'de'
,p_message_text=>'Die Seiten des Datenladeassistenten wurden erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931456757303443)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'de'
,p_message_text=>'Daten-/Tabellenzuordnung nicht erfolgreich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931577737303443)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Aktion verarbeitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637576365303197)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'de'
,p_message_text=>'Spaltenzuordnung beim Hochladen von Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98362337672302974)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'de'
,p_message_text=>'Spaltentyp: Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224172429302865)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'de'
,p_message_text=>'Dezimalzeichen: Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224346129302865)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>'Formatmaske: Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224270266302865)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'de'
,p_message_text=>'Gruppentrennzeichen: Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224549821302865)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Zuordnen zu: Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411480811303018)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'de'
,p_message_text=>unistr('Maximale L\00E4nge: Spalte %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224461318302865)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'de'
,p_message_text=>'- Nicht zugeordnete Spalte -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757681492303303)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der hervorgehobene Datumsattributwert %0 f\00FCr Element %1 entspricht nicht dem Format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762883834303308)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Element %1 eingegebener Attributwert %0 f\00FCr hervorgehobenes Datum ist kein relatives Datum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757877291303304)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der f\00FCr Element %1 eingegebene Attributwert f\00FCr das sp\00E4teste Datum %0 entspricht nicht dem Format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763048929303308)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Element %1 eingegebener Attributwert %0 f\00FCr sp\00E4testes Datum ist kein relatives Datum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175122875302827)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der eingegebene maximale statische Attributwert %0 f\00FCr Element %1 entspricht nicht dem Format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757739233303303)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der eingegebene Wert f\00FCr das fr\00FCheste Datum %0 f\00FCr Element %1 entspricht nicht dem Format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762955083303308)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Element %1 eingegebener Attributwert %0 f\00FCr fr\00FChestes Datum ist kein relatives Datum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175035134302827)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Der eingegebene minimale statische Attributwert %0 f\00FCr Element %1 entspricht nicht dem Format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864991967303387)
,p_name=>'DATE_ADDED'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzugef\00FCgt am')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309613052303760)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'de'
,p_message_text=>unistr('Zuletzt ausgef\00FChrte Oracle APEX-Datenbank-Jobs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687436940303242)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'de'
,p_message_text=>'zu letztem Meilenstein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687536880303242)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'de'
,p_message_text=>'zu letztem Meilenstein von Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762206169303307)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'de'
,p_message_text=>unistr('Klasse hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315055461303764)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'de'
,p_message_text=>'Alert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313851438303763)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'de'
,p_message_text=>'Ereignis abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315253732303765)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315110658303765)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154566412302809)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'de'
,p_message_text=>'Dialog abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154663243302809)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Dialog schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306599323302932)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'de'
,p_message_text=>'Deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306451130302932)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'de'
,p_message_text=>'Aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306702441303757)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Code ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306354909302932)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682704202303237)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Code ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936995505303447)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762313945303307)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'de'
,p_message_text=>'Klasse entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762472163303307)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'de'
,p_message_text=>'Stil festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919875994303432)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'de'
,p_message_text=>'Fokus festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682658402303237)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306258253302932)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919942548303433)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901444331303418)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'de'
,p_message_text=>'Baum ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901370521303418)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'de'
,p_message_text=>'Baum einblenden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98203877236302849)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'de'
,p_message_text=>'Datenbankaccount'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679350138303234)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'de'
,p_message_text=>unistr('Bei Datenbanktabellen- und Spaltennamen muss die Gro\00DF-/Kleinschreibung beachtet werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779089170303320)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'de'
,p_message_text=>'Ausnahme beim Erstellen von Datenbankobjekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217414067302860)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'de'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367749814303808)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Aliasname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364454624303805)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'de'
,p_message_text=>'Alle MIME-Typen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367462408303808)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'de'
,p_message_text=>'Handler erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364720496303806)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'de'
,p_message_text=>'Methode erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364543823303806)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'de'
,p_message_text=>'Parameter erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364657300303806)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371619514303811)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'de'
,p_message_text=>'RESTful Servicemodul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367308880303808)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'de'
,p_message_text=>'Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372101481303812)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'de'
,p_message_text=>'Handler Bind-Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344517259303789)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'de'
,p_message_text=>'Handler-Methode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372420285303812)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'de'
,p_message_text=>'Handler-Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344659022303789)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'de'
,p_message_text=>'Handler-Quelltyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364263156303805)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'de'
,p_message_text=>'Methode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371719956303811)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'de'
,p_message_text=>'Modulname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372271595303812)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'de'
,p_message_text=>unistr('URI-Pr\00E4fix des Moduls')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364836996303806)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'de'
,p_message_text=>'Keine Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364143518303805)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371997331303812)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'de'
,p_message_text=>'RESTful Services'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364389961303805)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372371156303812)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'de'
,p_message_text=>'URI-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344449166303789)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'de'
,p_message_text=>'Uniform Resource Identifier (URI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371400712303811)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'de'
,p_message_text=>unistr('URI-Pr\00E4fix')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371588577303811)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'URI-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344720730303789)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'de'
,p_message_text=>'Eine Zeile abfragen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588618048303159)
,p_name=>'DEBUG'
,p_message_language=>'de'
,p_message_text=>'Debuggen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695062812303249)
,p_name=>'DECLINED'
,p_message_language=>'de'
,p_message_text=>'Abgelehnt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417321641303850)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Region "Dialogfeldschaltfl\00E4che"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417285182303850)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Region "Dialogfeldinhalt"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932116518303444)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Standardseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574483197303148)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'de'
,p_message_text=>'Default Tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576052760303149)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'de'
,p_message_text=>'Default Tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824569318303356)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standardtemplate'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199879738302846)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'de'
,p_message_text=>'Von dynamischer Aktion definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990894816303496)
,p_name=>'DEFINED_TABS'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Anwendung hat %0 Registerkarten, die in %1 Registerkartengruppen aufgeteilt sind. Au\00DFerdem enth\00E4lt sie %2 \00FCbergeordnete Registerkarten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443315896303043)
,p_name=>'DEFINE_LOV'
,p_message_language=>'de'
,p_message_text=>'Werteliste definieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624529500303186)
,p_name=>'DEFINITION'
,p_message_language=>'de'
,p_message_text=>'Definition'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776722402303318)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'de'
,p_message_text=>'Deinstallationsskript'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295067559302922)
,p_name=>'DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311790795303761)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817063988303350)
,p_name=>'DELETE_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98809214538303344)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('%0 l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227003677302867)
,p_name=>'DELETE_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Soll dieser L\00F6schvorgang ausgef\00FChrt werden?')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251374995302887)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'de'
,p_message_text=>unistr('Mit "Collections Showcase" k\00F6nnen Datenzeilen zur Verwendung in einer Oracle APEX-Session gespeichert werden. Diese Datenbankanwendung zeigt, wie Sie mithilfe von PL/SQL einen auf Collections basierenden Sessionzustand erstellen und verwalten k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251185923302886)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'de'
,p_message_text=>'Beispielanwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251277994302887)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'de'
,p_message_text=>unistr('"Product Portal" ist eine Beispielanwendung, die allgemeine Designkonzepte beschreibt. Sie umfasst dedizierte Seiten f\00FCr Kunden, Produkte und Auftr\00E4ge und veranschaulicht die Verwendung von Berichten, Diagrammen, Kalender, Karten und Baum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645420117303203)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'de'
,p_message_text=>'Demonstrierbar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372161328302981)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'de'
,p_message_text=>unistr('Beispiele f\00FCr stabile Berichte und Konzepte f\00FCr die Seitennummerierung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371886727302981)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'de'
,p_message_text=>unistr('Beispiel f\00FCr einen Online-Store, der mit %0 erstellt wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372500407302981)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'de'
,p_message_text=>unistr('Wissenswertes \00FCber das Verwenden von Oracle Text mit %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372929475302982)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'de'
,p_message_text=>'Beispiel einer Anwendung zur Protokollierung des Projektstatus, die mit %0 erstellt wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372311598302981)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'de'
,p_message_text=>unistr('Wissenswertes \00FCber die Verwendung der Web Services mit %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370746069302980)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368649586302978)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368372771302978)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'de'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372041262302981)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'de'
,p_message_text=>'Business Look'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370822844302980)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'de'
,p_message_text=>'Collection Showcase'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368493256302978)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'de'
,p_message_text=>'CONTEXT INDEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367823538302978)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'de'
,p_message_text=>'Sie sind im Begriff, die Basic Examples-Demoanwendung zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366444813302977)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'de'
,p_message_text=>'Sie sind im Begriff, die Business Look-Demoanwendung (neu) zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367914878302978)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'de'
,p_message_text=>'Sie sind im Begriff, die Collections Showcase-Demoanwendung zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368037829302978)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'de'
,p_message_text=>'In Schema %0 erstellen oder neu erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366336576302977)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen Sie eine Beispielanwendung f\00FCr die Demonstration von Web Services.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366574050302977)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'de'
,p_message_text=>'Sie sind im Begriff, die WorldCup Mania-Demoanwendung zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207573763302852)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370567818302980)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'de'
,p_message_text=>'Demoanwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368986671302979)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Es stehen Ihnen etwa %0 MB zur Verf\00FCgung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371318339302980)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'de'
,p_message_text=>'Installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371004015302980)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'de'
,p_message_text=>'Installiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503020223303091)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'de'
,p_message_text=>'Sie sind im Begriff, die Beispielanwendung zu installieren, die die wichtigsten Features von %0 zeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371986764302981)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'de'
,p_message_text=>'Jetzt installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370994715302980)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'de'
,p_message_text=>unistr('Wissenswertes \00FCber die Konzepte bei %0-Warenkorb.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812018937303346)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'de'
,p_message_text=>'Gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368740745302978)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr das Presidential Inaugural Address-Demo sind etwa 7 MB freier Speicherplatz erforderlich. Die Installation in Ihr Schema dauert ungef\00E4hr zwei Minuten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502729436303091)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist nicht gen\00FCgend Speicherplatz zum Erstellen dieser Demo verf\00FCgbar. Fordern Sie zus\00E4tzlichen Speicher an, indem Sie auf der Seite f\00FCr die Administration zu den Provisioning-Services navigieren und auf den Link zum Anfordern von zus\00E4tzlicher Spei')
||unistr('cherkapazit\00E4t klicken. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371261118302980)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'de'
,p_message_text=>'Nicht installiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367273920302977)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366172415302976)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367194936302977)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368280181302978)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'de'
,p_message_text=>'Objektname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366227659302977)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'nicht vorhanden ist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366854014302977)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'de'
,p_message_text=>'Die folgenden Datenbankobjekte werden neu erstellt, falls sie vorhanden sind'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367056144302977)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Objekttyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367763066302978)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'de'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371795721302981)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'de'
,p_message_text=>'Pet-Speicher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372446704302981)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'de'
,p_message_text=>'Presidential Inaugural Addresses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372744043302981)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'de'
,p_message_text=>'Projektprotokollierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579945488303152)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'de'
,p_message_text=>'Neu installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371170251302980)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98366976250302977)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367504679302978)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370688929302980)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367343939302977)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370401476302980)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'de'
,p_message_text=>'Demoanwendung installieren - Statusbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367666215302978)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'de'
,p_message_text=>'Trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812173060303346)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Entsperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232832154302872)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Update verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390435780303827)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden ung\00FCltigen Objekte m\00FCssen korrigiert werden, damit Websheets ordnungsgem\00E4\00DF ausgef\00FChrt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372298136302981)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'de'
,p_message_text=>'Webservices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369099145302979)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Es tritt gegebenenfalls ein Fehler auf, wenn Sie diese Demo nicht neu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314048355302938)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Es steht nicht gen\00FCgend Speicherplatz zum Erstellen dieser Demo zur Verf\00FCgung. Fordern Sie zus\00E4tzliche Speicherkapazit\00E4t an, indem Sie zur Seite f\00FCr die Administration navigieren und anschlie\00DFend auf "\00C4nderungen beim aktuellen Service anfordern" klic')
||'ken.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313989277302938)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Die %0-Demoanwendung wurde erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969367986303478)
,p_name=>'DEPRECATED'
,p_message_language=>'de'
,p_message_text=>'Verworfen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265022557302898)
,p_name=>'DERIVED$'
,p_message_language=>'de'
,p_message_text=>'Abgeleitete Spalte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645375489303203)
,p_name=>'DESIRABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Gew\00FCnscht')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718136287303270)
,p_name=>'DETAIL'
,p_message_language=>'de'
,p_message_text=>'Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774827411303317)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'de'
,p_message_text=>'Details'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718262161303270)
,p_name=>'DETAIL_2'
,p_message_language=>'de'
,p_message_text=>'Detail 2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216400422302859)
,p_name=>'DEVELOPER'
,p_message_language=>'de'
,p_message_text=>'Entwickler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780240843303321)
,p_name=>'DEVELOPERS'
,p_message_language=>'de'
,p_message_text=>'Entwickler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664988415303221)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'de'
,p_message_text=>unistr('Zusammenfassung Entwickleraktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688719693303243)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'de'
,p_message_text=>unistr('Entwickler\00FCbersicht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173251114302825)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682025463303237)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'de'
,p_message_text=>'App-Anpassung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838113949303366)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838032333303365)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'de'
,p_message_text=>'Kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186412609303653)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'de'
,p_message_text=>'Anpassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864319946303387)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'de'
,p_message_text=>'Debug (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863848624303386)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'de'
,p_message_text=>'Standard-Debug-Ebene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864050048303387)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'de'
,p_message_text=>'Info (Standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864148522303387)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'de'
,p_message_text=>'App-Trace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864288370303387)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'de'
,p_message_text=>unistr('Vollst\00E4ndiges Trace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173324741302825)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827230751303358)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'de'
,p_message_text=>'Seit die Seite geladen wurde, ist mindestens ein Fehler aufgetreten. Die Fehler werden in der JavaScript-Konsole des Browsers angezeigt.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827482545303358)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Fehler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186577405303653)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'de'
,p_message_text=>'Logo bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901003220303417)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Funktionalit\00E4t erfordert, dass das Application Express App Builder-Fenster ge\00F6ffnet ist. M\00F6chten Sie den Builder in diesem Fenster \00F6ffnen?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897145058303414)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Optionen der Entwicklersymbolleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898848684303415)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'de'
,p_message_text=>'Automatisch ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899066247303415)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Anzeigeposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898917067303415)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'de'
,p_message_text=>'Nur Symbole anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899298060303415)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'de'
,p_message_text=>'Unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899138280303415)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'de'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899302855303416)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'de'
,p_message_text=>'Rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900672393303417)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833171289303362)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'de'
,p_message_text=>'Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833367869303362)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Timing f\00FCr Seitenperformance')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897234817303414)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'de'
,p_message_text=>'Schnellbearbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833249486303362)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'de'
,p_message_text=>unistr('Timing f\00FCr Seitenanzeige')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398185257303834)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'de'
,p_message_text=>'Theme Roller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898782888303415)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'de'
,p_message_text=>'Entwicklersymbolleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639611555303198)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'de'
,p_message_text=>'Entwicklungsaufgabe'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807967176303343)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'de'
,p_message_text=>'Alert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807817412303343)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'de'
,p_message_text=>'Hoch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807716319303343)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'de'
,p_message_text=>'Mindestwert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157054898302812)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'de'
,p_message_text=>'Seitenelementgruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239453891302877)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241847373302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241999858302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241046952302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240917563302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'de'
,p_message_text=>'Navigationspfade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427589632303859)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Erstelloptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240694582302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240809858302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Anwendungselemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241104472302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'de'
,p_message_text=>'Listen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241288080302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241378934302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190610796302839)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'de'
,p_message_text=>'Wertelistenspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241413486302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241529634302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleisten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239565911302877)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240513983302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'de'
,p_message_text=>'Verzweigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239968199302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614396087303179)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'de'
,p_message_text=>'Diagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614520658303179)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'de'
,p_message_text=>'Achsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614433561303179)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'de'
,p_message_text=>'Reihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240255343302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'de'
,p_message_text=>'Berechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281196801302911)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281298206302911)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktion - Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240042767302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'de'
,p_message_text=>'IR-Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240103980302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239734534302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Seitenelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240443329302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'de'
,p_message_text=>'Prozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239693419302877)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'de'
,p_message_text=>'Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180673338303648)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98239806156302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362696612303804)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'de'
,p_message_text=>unistr('B\00E4ume')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240342789302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'de'
,p_message_text=>'Validierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241632113302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkarten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98240749596302878)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388365240303825)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'de'
,p_message_text=>'Berichtslayouts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388618707303825)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'de'
,p_message_text=>'SQL-Anweisungen der Berichtsabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388237441303825)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'de'
,p_message_text=>'Berichtsabfragen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337312536303783)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242089691302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'Shortcuts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237575324302876)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'de'
,p_message_text=>'Anwendungsdateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243537327302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'de'
,p_message_text=>'Ersetzungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427268558303859)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objekte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427360445303859)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objekte - Erstelloptionen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243331245302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'de'
,p_message_text=>unistr('Objektvalidierungen unterst\00FCtzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243482113302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'de'
,p_message_text=>unistr('Objektskripts unterst\00FCtzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98241741906302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242452680302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'de'
,p_message_text=>unistr('Templates f\00FCr Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242529272302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Templates f\00FCr Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242698955302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Kalendertemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305992045302931)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'de'
,p_message_text=>'Grid-Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242741055302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'de'
,p_message_text=>'Labeltemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242818763302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242937531302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seitentemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243013196302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'de'
,p_message_text=>unistr('Templates f\00FCr Popup-Wertelisten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243166147302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'de'
,p_message_text=>'Regionstemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98243228642302880)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'de'
,p_message_text=>'Berichtstemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242381207302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'de'
,p_message_text=>'Themes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230914332302870)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'de'
,p_message_text=>'Theme-Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178711422302830)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'de'
,p_message_text=>'Theme-Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670150486303225)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'de'
,p_message_text=>'Textnachrichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224700724302865)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'de'
,p_message_text=>unistr('Dynamische \00DCbersetzungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224828093302865)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbersetzbarer Text')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242278089302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'de'
,p_message_text=>unistr('B\00E4ume')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98242171685302879)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'de'
,p_message_text=>'Webservices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354270592303797)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'de'
,p_message_text=>'Rollen Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354338554303797)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrollbenutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709339736303262)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzerrollenzuweisung f\00FCr Zugriffskontrolle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167801309302821)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'de'
,p_message_text=>'Automatisierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168041638302821)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Automatisierung - Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390167496303827)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'de'
,p_message_text=>'Verkettete Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195357752302842)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'de'
,p_message_text=>unistr('Datenladevorg\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621850123303184)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'de'
,p_message_text=>unistr('Profile f\00FCr Datenparsing')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621963869303184)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'de'
,p_message_text=>unistr('Profilspalten f\00FCr Datenparsing')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405597464303840)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'de'
,p_message_text=>'Entwicklerkommentare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369225087303809)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927336572303439)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'de'
,p_message_text=>'Datenladetabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921676859303434)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'de'
,p_message_text=>'Datenladetabellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921727381303434)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'de'
,p_message_text=>'Datenladetabellen-Lookups'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921820779303434)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'de'
,p_message_text=>unistr('Transformationsregeln f\00FCr Datenladetabellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185290602302835)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'de'
,p_message_text=>'Kalenderseiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184242402302834)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'de'
,p_message_text=>'Karten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184315214302834)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Kartenaktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898216058303415)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'de'
,p_message_text=>'Interaktive Grid-Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898309745303415)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898442050303415)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'de'
,p_message_text=>'Spaltengruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159200477302814)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'de'
,p_message_text=>'Karten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159358799302814)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'de'
,p_message_text=>'Kartenlayer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257154351302891)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'de'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257259449302891)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668610227303224)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'de'
,p_message_text=>'Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312150326302936)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'de'
,p_message_text=>'Ereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259314780302894)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'de'
,p_message_text=>'Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718481364303270)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filteroperatoren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427464865303859)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Komponenteneinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368164562303808)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'de'
,p_message_text=>unistr('Metadaten f\00FCr Plug-in-Standardattribut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621743174303184)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL-Server')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180536299303648)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Templateoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427132992303859)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'de'
,p_message_text=>'Templateoptionsgruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343430390303788)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'de'
,p_message_text=>'Templateoptionsgruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396656529303832)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'de'
,p_message_text=>'Positionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396757926303832)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'de'
,p_message_text=>'Positionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310505058302935)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'de'
,p_message_text=>'Theme-Anzeigepunkte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237452712302876)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622480265303185)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'de'
,p_message_text=>unistr('REST-Quellenparameter f\00FCr Komponente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622179782303185)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622270525303185)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'de'
,p_message_text=>unistr('REST-Quellenvorg\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622367158303185)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenparameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622084148303184)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'de'
,p_message_text=>'Remoteserver der REST-Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168382456302821)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'de'
,p_message_text=>'REST-Synchronisierungsschritte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168219583302821)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'de'
,p_message_text=>'Automatisierungslog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168415375302821)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'de'
,p_message_text=>'Automatisierungsmeldungslog'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370893098303811)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Weiter" deaktiviert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370797301303811)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Zur\00FCck" deaktiviert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771493578303314)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'de'
,p_message_text=>'Deaktivieren von Trigger %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376805490302988)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'de'
,p_message_text=>'Anzeigebedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377027641302988)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'de'
,p_message_text=>'Bedingungstext anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817166950303350)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'de'
,p_message_text=>'Anzeigereihenfolge: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263314161302897)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'de'
,p_message_text=>'Anzeigetyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426868355303858)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'de'
,p_message_text=>'Anzeigewert: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366104064303807)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366245380303807)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Benutzer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190390438302839)
,p_name=>'DML_FORM'
,p_message_language=>'de'
,p_message_text=>'DML-Form'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484508776303077)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'de'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660756826303214)
,p_name=>'DOC_IMPACT'
,p_message_language=>'de'
,p_message_text=>'Dokumentationsauswirkung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661960113303215)
,p_name=>'DOC_STATUS'
,p_message_language=>'de'
,p_message_text=>'Dokumentationsstatus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662149239303215)
,p_name=>'DOC_WRITER'
,p_message_language=>'de'
,p_message_text=>'Schreiber der Dokumentation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549704478303129)
,p_name=>'DOWN'
,p_message_language=>'de'
,p_message_text=>'Nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669980344303225)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Link-Text f\00FCr Download')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484283984303076)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Keine Anwendungselemente aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484340602303076)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Keine Dateneintragselemente aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484444910303076)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'de'
,p_message_text=>unistr('Keine schreibgesch\00FCtzten Elemente aktualisieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484104086303076)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'de'
,p_message_text=>'Keine Seiten aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484943927303077)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Keine Seitenelemente aktualisieren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346973763302962)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'de'
,p_message_text=>'Drag-and-Drop'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254798611302889)
,p_name=>'DRILLDOWN'
,p_message_language=>'de'
,p_message_text=>'Mehr Verzweigungsebenen anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254697429302889)
,p_name=>'DRILLUP'
,p_message_language=>'de'
,p_message_text=>'Weniger Verzweigungsebenen anzeigen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392260298303001)
,p_name=>'DRIVEN'
,p_message_language=>'de'
,p_message_text=>'gesteuert'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771268204303314)
,p_name=>'DROP TRIGGER'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Trigger %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770319310303313)
,p_name=>'DROP_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Spalte %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917752058303431)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'de'
,p_message_text=>'Zugriffsmethode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917563472303431)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'de'
,p_message_text=>'Bind-Variablenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917948315303431)
,p_name=>'DS_HANDLER'
,p_message_language=>'de'
,p_message_text=>'Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918300278303431)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'de'
,p_message_text=>'Elemente pro Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918176715303431)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Zul\00E4ssige MIME-Typen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918269416303431)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Ursprung zul\00E4ssig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917866725303431)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'de'
,p_message_text=>'Parametertyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918458814303431)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'de'
,p_message_text=>'Sicherheits-Constraint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917624607303431)
,p_name=>'DS_SOURCE'
,p_message_language=>'de'
,p_message_text=>'Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918047509303431)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'de'
,p_message_text=>'Quelltyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918511611303431)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('URI-Pr\00E4fix')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917256801303430)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'URI-Template'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388725149303825)
,p_name=>'DUE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00E4llig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661776786303215)
,p_name=>'DUE_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00E4llig am')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642279273303200)
,p_name=>'DUPLICATE'
,p_message_language=>'de'
,p_message_text=>'Duplizieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366868095303807)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'de'
,p_message_text=>'Doppelt in Liste vorhandener Benutzer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179128331302830)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179051369302830)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189291902302838)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'de'
,p_message_text=>'Dynamische Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295194841302923)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'de'
,p_message_text=>'Dynamische HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345878281302961)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'de'
,p_message_text=>'Interaktiver Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172263518302825)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Dynamische Referenz'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441633703303042)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Durch die hinzugef\00FCgte Bedingung wurde die Abfrage ung\00FCltig.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183796710302833)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'de'
,p_message_text=>'Seitengruppe bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702394320303256)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie auf OK klicken, gehen nicht gespeicherte \00C4nderungen verloren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215796230302858)
,p_name=>'EDIT_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442813196303043)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Alle Seitendefinitionsattribute bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697289623303251)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'de'
,p_message_text=>'Alle Elemente in dieser Region bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627940607303189)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716960650303268)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>'Attribut bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311928537303762)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706753839303260)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'de'
,p_message_text=>'Komponente bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717054087303269)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'de'
,p_message_text=>'Komponentendefinition bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808471272303343)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'de'
,p_message_text=>'%0 bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716814669303268)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'de'
,p_message_text=>'Listendefinition bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380715418303819)
,p_name=>'EDIT_LOCK'
,p_message_language=>'de'
,p_message_text=>'Bearbeitungssperre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588437123303159)
,p_name=>'EDIT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444995294303045)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Seitenattribute bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975841144303484)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'de'
,p_message_text=>'Profil bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993244320303498)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer 0% hat keine Berechtigung zur Aktualisierung der Informationen f\00FCr einen anderen Benutzer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706509835303259)
,p_name=>'EDIT_REGION'
,p_message_language=>'de'
,p_message_text=>'Region bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781047527303322)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'de'
,p_message_text=>unistr('Zeitrahmen f\00FCr Berichtserstellung bearbeiten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706643153303260)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970084944303479)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'de'
,p_message_text=>'Bericht bearbeiten - Dialog geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696545706303251)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Systemmeldung bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931963452303443)
,p_name=>'EDIT_TAB'
,p_message_language=>'de'
,p_message_text=>'Register bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718330636303270)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>'Dieses Attribut bearbeiten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570715447303145)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'de'
,p_message_text=>'Verstrichene Zeit'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649382481303206)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'de'
,p_message_text=>'<a href="#MY_APPLICATION_LINK#">Gehen Sie zu "Meine Anwendung", und verwalten Sie Ihre E-Mail-Voreinstellungen</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656202128303211)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'de'
,p_message_text=>'<b style="font-size: 24px;">Meine Anwendung</b>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770737336303314)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Hallo #INVITEE#,</strong><br>',
'<br>',
'dies ist eine Erinnerung an ein bevorstehendes Ereignis, zu dem Sie eingeladen wurden. Die Ereignisdetails lauten wie folgt:<br>',
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Organisator</th>',
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Ereignisdatum</th>',
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Startzeit</th>',
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Dauer</th>',
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Ort</th>',
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Notizen</th>',
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649222165303206)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Hallo #CUSTOMER_NAME#</strong>,<br>',
'<br>',
unistr('vielen Dank f\00FCr Ihre Bestellung.<br>'),
'<br>',
'<strong>Bestelldetails</strong><br>',
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Bestelldatum</th>',
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Bestellnummer</th>',
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Versand an</th>',
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Versandadresse</th>',
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Bestellte Produkte</th>',
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Bestellsumme</th>',
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('M\00F6chten Sie Ihre Bestellung \00E4ndern? <a href="#ORDER_URL#">Verwalten Sie Ihre Bestellung #ORDER_NUMBER# hier.</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970369774303479)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hallo #SERVICE_USER#,<br>',
'<br>',
unistr('denken Sie daran, dass f\00FCr Ihren Service #SERVICE_NAME# ein geplanter Ausfall bevorsteht.<br>'),
unistr('Der Ausfall beginnt plangem\00E4\00DF um #OUTAGE_START# und dauert voraussichtlich #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.<br>'),
'<br>',
unistr('W\00E4hrend dieses geplanten Ausfalls wird Folgendes durchgef\00FChrt:<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
'Wenden Sie sich bei Problemen im Zusammenhang mit diesem Ausfall an #OUTAGE_CONTACT#.<br>',
'<br>',
unistr('Vielen Dank f\00FCr Ihr Verst\00E4ndnis,<br>'),
'#SERVICE_TEAM#',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969744427303479)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'de'
,p_message_text=>'Ereigniserinnerung: #EVENT_NAME#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969865008303479)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'de'
,p_message_text=>unistr('Bestellung (#ORDER_NUMBER#) best\00E4tigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770943452303314)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hallo #INVITEE#,',
'',
unistr('diese E-Mail soll Sie an ein bevorstehendes Ereignis erinnern, mit dem Sie verkn\00FCpft sind.'),
'',
'Ereignisdatum: #EVENT_DATE#',
'Startzeit: #START_TIME#',
'Dauer:   #DURATION#',
'Organisator:  #ORGANIZER#',
'Ort:   #LOCATION#',
'URL:        #URL_NAME# (#URL_LINK#)',
'Notizen:      #NOTES#',
'',
'Weitere Ereignisdetails finden Sie hier: #EVENT_LINK#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770848701303314)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hallo #CUSTOMER_NAME#,',
'',
unistr('vielen Dank f\00FCr Ihre Bestellung.'),
'',
'Bestelldetails',
'--------------------------------------------------------------------------------',
'  Bestelldatum: #ORDER_DATE#',
'  Bestellnummer: #ORDER_NUMBER#',
'  Versand an: #SHIP_TO#',
'  Versandadresse: #SHIPPING_ADDRESS_LINE_1#',
'                    #SHIPPING_ADDRESS_LINE_2#',
'  Bestellte Produkte: #ITEMS_ORDERED#',
'  Bestellsumme:      #ORDER_TOTAL#',
'--------------------------------------------------------------------------------',
'',
unistr('M\00F6chten Sie Ihre Bestellung \00E4ndern? Verwalten Sie Ihre Bestellung #ORDER_NUMBER# hier: #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970260068303479)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hallo #SERVICE_USER#,',
'',
unistr('denken Sie daran, dass f\00FCr Ihren Service #SERVICE_NAME# ein geplanter Ausfall bevorsteht.'),
unistr('Der Ausfall beginnt plangem\00E4\00DF um #OUTAGE_START# und dauert voraussichtlich #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.'),
'',
unistr('W\00E4hrend dieses geplanten Ausfalls wird Folgendes durchgef\00FChrt:'),
'#OUTAGE_REASON#',
'',
'Wenden Sie sich bei Problemen im Zusammenhang mit diesem Ausfall an #OUTAGE_CONTACT#.',
'',
unistr('Vielen Dank f\00FCr Ihr Verst\00E4ndnis,'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700510808303254)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'de'
,p_message_text=>'Debugging aktivieren (Ja oder Nein)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771316184303314)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'de'
,p_message_text=>'Aktivieren von Trigger %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217943606302860)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Die L\00E4nge des zu verschl\00FCsselnden Wertes darf 4000 Byte nicht \00FCberschreiten.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216522201302859)
,p_name=>'END_USER'
,p_message_language=>'de'
,p_message_text=>'Endbenutzer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639334039303198)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'de'
,p_message_text=>'Erweiterungsanforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993978075303499)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'de'
,p_message_text=>'Erweiterungsanforderungen: %1 von %0 geschlossen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641786472303200)
,p_name=>'ENTERED'
,p_message_language=>'de'
,p_message_text=>'Eingegeben '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182962204302833)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>unistr('Zugangsdaten f\00FCr Websheets eingeben.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629533076303190)
,p_name=>'ENTRY LINK'
,p_message_language=>'de'
,p_message_text=>'Eintrags-Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629424133303190)
,p_name=>'ENTRY TEXT'
,p_message_language=>'de'
,p_message_text=>'Eintragstext'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684806747303239)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Fehlerseite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547932753303128)
,p_name=>'ERRORPAGE'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldungsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697577407303252)
,p_name=>'ERRORS'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630702663303191)
,p_name=>'ERROR_ICON'
,p_message_language=>'de'
,p_message_text=>'Fehlersymbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387758316303825)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622951581303185)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'de'
,p_message_text=>unistr('<br><strong>Escape-Daten \00FCberschreiten den zul\00E4ssigen Grenzwert. Die Ergebnisse werden auf 32 KB gek\00FCrzt </strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391403704303001)
,p_name=>'ESCAPE_SC'
,p_message_language=>'de'
,p_message_text=>'Escape bei Sonderzeichen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663119127303216)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'de'
,p_message_text=>unistr('Gesch\00E4tzter Aufwand in Stunden')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917412492303430)
,p_name=>'ETAG_QUERY'
,p_message_language=>'de'
,p_message_text=>'ETag-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917314096303430)
,p_name=>'ETAG_TYPE'
,p_message_language=>'de'
,p_message_text=>'ETag-Typ'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639865817303198)
,p_name=>'EVENT'
,p_message_language=>'de'
,p_message_text=>'Ereignis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974443469303482)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'de'
,p_message_text=>'Nach Aktualisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974750055303483)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'de'
,p_message_text=>'Vor Seitenweiterleitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974396469303482)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'de'
,p_message_text=>'Vor Aktualisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976941088303485)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'de'
,p_message_text=>'Browserereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438094316303039)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'de'
,p_message_text=>'Doppeltippen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438212891303039)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'de'
,p_message_text=>'Schwenken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438104983303039)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'de'
,p_message_text=>unistr('Dr\00FCcken')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438375673303039)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'de'
,p_message_text=>'Streichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437989354303039)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'de'
,p_message_text=>'Tippen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973823512303482)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973169796303481)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'de'
,p_message_text=>'Klick'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973261545303481)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'de'
,p_message_text=>'Doppelklick'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972653071303481)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'de'
,p_message_text=>'Fokus erhalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972507437303481)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'de'
,p_message_text=>'Fokus verlieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974030747303482)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'de'
,p_message_text=>'Taste nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974182852303482)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'de'
,p_message_text=>unistr('Taste dr\00FCcken')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974232922303482)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'de'
,p_message_text=>'Taste loslassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972784164303481)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'de'
,p_message_text=>'Ressourcenladevorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973316428303481)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'de'
,p_message_text=>unistr('Maustaste dr\00FCcken')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973644814303482)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'de'
,p_message_text=>'Mauseintritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973772477303482)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'de'
,p_message_text=>'Mausaustritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973549877303482)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'de'
,p_message_text=>'Maus bewegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973418872303482)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'de'
,p_message_text=>'Maustaste loslassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181974519302832)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausrichtungs\00E4nderung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980209490303487)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'de'
,p_message_text=>'Seitenladevorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972851113303481)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'de'
,p_message_text=>'Skalieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98972969404303481)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'de'
,p_message_text=>'Scrollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182093406302832)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'de'
,p_message_text=>'Bildlauf - Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182101804302832)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'de'
,p_message_text=>'Bildlauf - Stopp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973974002303482)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'de'
,p_message_text=>unistr('Ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181126444302831)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'de'
,p_message_text=>'Streichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181282448302831)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'de'
,p_message_text=>'Nach links streichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181383078302832)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'de'
,p_message_text=>'Nach rechts streichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180987566302831)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'de'
,p_message_text=>'Tippen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181005914302831)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'de'
,p_message_text=>'Tippen und halten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98973074675303481)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'de'
,p_message_text=>'Seitenentladevorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181738512302832)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'de'
,p_message_text=>'Virtueller Klick'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181819524302832)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'de'
,p_message_text=>unistr('Ber\00FChrung - Abbrechen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181498284302832)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'de'
,p_message_text=>unistr('Ber\00FChrung - Anfang')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181537705302832)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'de'
,p_message_text=>unistr('Ber\00FChrung - Bewegung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98181614738302832)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'de'
,p_message_text=>unistr('Ber\00FChrung - Ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977178910303485)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'de'
,p_message_text=>'Komponentenereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98177970892302829)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniertes Ereignis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178005971302829)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977018322303485)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'de'
,p_message_text=>'Framework-Ereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554318720303132)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'de'
,p_message_text=>'Dialogfeld geschlossen oder abgebrochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706414061303259)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'de'
,p_message_text=>'Dialog geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395619897303832)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'de'
,p_message_text=>'Nach Aktualisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395757536303832)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'de'
,p_message_text=>'Vor Seitenweiterleitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395540216303831)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'de'
,p_message_text=>'Vor Aktualisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624679350303186)
,p_name=>'EVENTS'
,p_message_language=>'de'
,p_message_text=>'Ereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661899699303215)
,p_name=>'EVENT_ID'
,p_message_language=>'de'
,p_message_text=>'Nummer Meilenstein'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702757978303256)
,p_name=>'EXACT_SUBS'
,p_message_language=>'de'
,p_message_text=>'Exakte Ersetzungen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816594925303349)
,p_name=>'EXAMPLE_1'
,p_message_language=>'de'
,p_message_text=>'Beispiel 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98816677787303349)
,p_name=>'EXAMPLE_2'
,p_message_language=>'de'
,p_message_text=>'Beispiel 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316792054303766)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Hier ein Beispiel f\00FCr die in einer XML-Datenbankspalte enthaltenen Daten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366745694303807)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'de'
,p_message_text=>'Beispiel-URI'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772405409303315)
,p_name=>'EXCLUDE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausschlie\00DFen')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752045626303299)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'de'
,p_message_text=>'Vorhandener Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694073269303249)
,p_name=>'EXISTS'
,p_message_language=>'de'
,p_message_text=>'Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249330491302885)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage EXISTS'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964639896303474)
,p_name=>'EXPANDED'
,p_message_language=>'de'
,p_message_text=>'Eingeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362596637303804)
,p_name=>'EXPAND_ALL'
,p_message_language=>'de'
,p_message_text=>'Alles einblenden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98314534860302938)
,p_name=>'EXPIRED'
,p_message_language=>'de'
,p_message_text=>'Abgelaufen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628112997303189)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'de'
,p_message_text=>'Explain-Plan'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624965190303187)
,p_name=>'EXPORT'
,p_message_language=>'de'
,p_message_text=>'Exportieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933270971303444)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'de'
,p_message_text=>'Export-Repository'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707043915303260)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Aus einem anderen Workspace oder einer anderen Anwendung exportiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707174670303260)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Aus aktuellem Workspace exportiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776406003303318)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung exportieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780687379303321)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'de'
,p_message_text=>unistr('Verwenden Sie diese Links, um diese Anwendung und die entsprechenden datenbankunterst\00FCtzenden Objekte f\00FCr das Deployment in einer anderen Oracle APEX-Installation herunterzuladen. Die heruntergeladenen Dateien sind SQL-Skripte, die aus SQL*Plus, SQL ')
||unistr('Developer oder SQL-Skripten in Oracle APEX ausgef\00FChrt werden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776599665303318)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objekte exportieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625268200303187)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'de'
,p_message_text=>'Anwendungsexport '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625493514303187)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'de'
,p_message_text=>'CSS-Export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625653813303187)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'de'
,p_message_text=>'Statischer Dateiexport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625509342303187)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'de'
,p_message_text=>'Bild exportieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625313940303187)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'de'
,p_message_text=>'Seite exportieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625735145303187)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'de'
,p_message_text=>'Skriptdatei exportieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621665834303184)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chen-Standards')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552794799303131)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550761659303130)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'de'
,p_message_text=>'Anwendungselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552551358303131)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98367429432302977)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'de'
,p_message_text=>'Die Anwendungs-IDs von 3000 bis 8999 sind reserviert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250530309302886)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'de'
,p_message_text=>'Diese Anwendung wurde aus dem aktuellen Workspace exportiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250670558302886)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'de'
,p_message_text=>'Diese Anwendung wurde aus einem anderen Workspace exportiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184383465303651)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>unistr('Zugangsdaten des Remotedruckservers f\00FCr Anwendung %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184159729303651)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'de'
,p_message_text=>unistr('Remotedruckserver f\00FCr Anwendung %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552442662303131)
,p_name=>'F4000.BRANCH'
,p_message_language=>'de'
,p_message_text=>'Verzweigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566362981303142)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'de'
,p_message_text=>'Verzweigung von Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566508741303142)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zu Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552083517303131)
,p_name=>'F4000.BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693036446303248)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chenelement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305843489302931)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428328929303031)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Kalenderspalte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566977049303142)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Spaltenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330944711303778)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'de'
,p_message_text=>unistr('Der angegebene Spaltenname ist ein f\00FCr Oracle reserviertes Wort. W\00E4hlen Sie einen anderen Namen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694491554303249)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'de'
,p_message_text=>'Listeneintrag kopieren: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580273347303153)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'de'
,p_message_text=>'Dynamisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264752247302898)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250428187302886)
,p_name=>'F4000.EXPORT'
,p_message_language=>'de'
,p_message_text=>'Exportieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582430842303154)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'de'
,p_message_text=>'Fix Me'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579890878303152)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Benutzer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579769154303152)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Benutzersession')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566649888303142)
,p_name=>'F4000.FROM'
,p_message_language=>'de'
,p_message_text=>'Von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368596434302978)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'de'
,p_message_text=>'Header muss die Tags <strong>&lt;head&gt;</strong> und <strong>&lt;/head&gt;</strong> enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368872745302978)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'de'
,p_message_text=>'<strong>#HEAD#</strong>-Ersetzungszeichenfolge muss zwischen den Tags <strong> &lt;head&gt;</strong> und <strong>&lt;/head&gt;</strong> angezeigt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637468656303196)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei "%0" hat einen ung\00FCltigen Typ.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551742898303130)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Elementanzeige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551828505303131)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Schreibgesch\00FCtztes Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197133757302844)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'de'
,p_message_text=>'Legacy-SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720444797303271)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Link-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584906289303156)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553165574303132)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'de'
,p_message_text=>'Listenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197088954302844)
,p_name=>'F4000.LOCAL'
,p_message_language=>'de'
,p_message_text=>'Lokal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553475503303132)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Wertelisteneintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566781586303142)
,p_name=>'F4000.MENU'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553314727303132)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadeintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596797818303165)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'de'
,p_message_text=>unistr('Es muss mindestens ein Element f\00FCr den Kopiervorgang oder die Subscription ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552818373303131)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Eintrag der Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483545483303076)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'de'
,p_message_text=>'Symbol&nbsp;der&nbsp;Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550615134303130)
,p_name=>'F4000.NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580327519303153)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'de'
,p_message_text=>'Nicht referenziert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564863798303141)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Daten gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390296385303827)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0 ist in aktuellem Workspace nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991167211303496)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'de'
,p_message_text=>unistr('Updatepr\00FCfung deaktiviert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589588363303160)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Name f\00FCr die \00FCbergeordnete Registerkarte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253295054302888)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'de'
,p_message_text=>unistr('Verzweigung f\00FCr Schaltfl\00E4che Abbrechen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252813611302888)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigetext f\00FCr die Schaltfl\00E4che Abbrechen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253337942302888)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'de'
,p_message_text=>unistr('Verzweigung f\00FCr Schaltfl\00E4che Fertigstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252922799302888)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigetext f\00FCr die Schaltfl\00E4che Fertigstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253101266302888)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigetext f\00FCr die Schaltfl\00E4che Weiter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253031801302888)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigetext f\00FCr die Schaltfl\00E4che Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589610862303160)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'de'
,p_message_text=>'Baumseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589784426303160)
,p_name=>'F4000.P119.GO'
,p_message_language=>'de'
,p_message_text=>'Los'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589840194303160)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Es werden die Templates einer vorhandenen Anwendung verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392729879303829)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'de'
,p_message_text=>'%0 kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394427960303831)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Autorisierungsschemas aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394739272303831)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Navigationspfad-Templates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394886128303831)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Schaltfl\00E4chen-Templates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394911118303831)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Kalendertemplates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176538241302828)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Datenladedefinitionen aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394348627303830)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Labeltemplates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394111646303830)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Listentemplates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393885893303830)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Wertelisten aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394626244303831)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Navigationsleisteneintr\00E4ge aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393957956303830)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Seiten-Templates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395086517303831)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Plug-ins aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395188790303831)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Popup-Wertelisten-Templates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394069768303830)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Regionstemplates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394277390303830)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Berichtstemplates aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99394512815303831)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden Shortcuts aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753186530303300)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ver\00F6ffentlichung von <strong>%0</strong> angefordert. Dadurch werden die folgenden REST-Datenquellen aktualisiert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597521547303166)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'de'
,p_message_text=>'Kopie von %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392669254303829)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'de'
,p_message_text=>'Lookup-Definition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390321536303827)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'de'
,p_message_text=>'Regionsname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98368164221302978)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Es muss mindestens ein Element angegeben werden, um eine NOT NULL-Validierung zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302535077303753)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Druckserver f\00FCr Anwendung %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014379982303515)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Standardexporteinstellungen aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126026532303605)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'de'
,p_message_text=>'Aktion='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633748205303193)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'de'
,p_message_text=>'Kommentar='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631879791303192)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Wird f\00FCr die Ausf\00FChrung der Berechnung verwendet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399197966303835)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'de'
,p_message_text=>'Verkettete Datei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632499030303193)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'de'
,p_message_text=>'Anzeigewert='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399018244303835)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'de'
,p_message_text=>'file='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632170274303192)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'de'
,p_message_text=>'Symbolleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632684109303193)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'de'
,p_message_text=>'Werteliste='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632317354303192)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'de'
,p_message_text=>'Wertelistendaten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632265884303192)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'de'
,p_message_text=>'name='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631780012303192)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die Seitenanzeige')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633672244303193)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'de'
,p_message_text=>'Seitenverzweigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632789476303193)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632070819303192)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Wird f\00FCr die Prozessausf\00FChrung verwendet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631973152303192)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632562184303193)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'de'
,p_message_text=>unistr('R\00FCckgabewert=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395394220303831)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Listeneintrag neu zuordnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427954889303031)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'de'
,p_message_text=>unistr('Sie m\00FCssen mindestens eine Region f\00FCr den Erstellvorgang angeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550392445303129)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Der Workspace wird nicht erstellt, weil er bereits vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550472158303129)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Der Workspace wird erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396121561303832)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'de'
,p_message_text=>'Sperre anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428069236303031)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'de'
,p_message_text=>unistr('Sie m\00FCssen mindestens eine Seite f\00FCr den Erstellvorgang angeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396283875303832)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Diese Seite ist aktuell entsperrt. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959667039303470)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590207136303160)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'de'
,p_message_text=>'Pos.1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590313247303160)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'de'
,p_message_text=>'Pos.2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590474654303160)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'de'
,p_message_text=>'Pos. 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590537019303160)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'de'
,p_message_text=>'Pos.4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188403137302837)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'de'
,p_message_text=>'Pos. 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757395180303303)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'de'
,p_message_text=>'Pos. 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757491272303303)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'de'
,p_message_text=>'Pos. 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757533937303303)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'de'
,p_message_text=>'Pos. 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590678415303160)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('DML- und Seitennummerierungsschaltfl\00E4chen ben\00F6tigen bestimmte Schaltfl\00E4chennamen. Weitere Informationen hierzu finden Sie im Hilfetext.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392806499303829)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'de'
,p_message_text=>unistr('%0 (Klasse stimmt \00FCberein)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590722843303160)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'de'
,p_message_text=>'Verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399427671303835)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Urspr\00FCnglicher Wert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590807622303161)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'de'
,p_message_text=>'Ersetzungszeichenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590914232303161)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'de'
,p_message_text=>'Ersetzungswert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564223706303140)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">In dieser Region wird mit der folgenden Syntax die Seiten- und Elementhilfe f\00FCr die aktuelle Seite angezeigt:<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591069190303161)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591121542303161)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'de'
,p_message_text=>'Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315242127302939)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'de'
,p_message_text=>'Verzweigung='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583320547303155)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'de'
,p_message_text=>'Button='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205908206302850)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'de'
,p_message_text=>'Diagrammreihe='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583557419303155)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'de'
,p_message_text=>'Computation='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582949121303155)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'de'
,p_message_text=>'Icon Subtext='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582816156303154)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'de'
,p_message_text=>'Image='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583495807303155)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'de'
,p_message_text=>'Item='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583047444303155)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'de'
,p_message_text=>'List='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315318941302939)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'de'
,p_message_text=>'Navigationspfadeintrag='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583243237303155)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'de'
,p_message_text=>'Page='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583602298303155)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'de'
,p_message_text=>'Process='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205873149302850)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'de'
,p_message_text=>'Region='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580410443303153)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Wird von jeder Seite der Anwendung ben\00F6tigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582581870303154)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582648952303154)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582700847303154)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583801381303155)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'de'
,p_message_text=>'Tab Name='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583990285303155)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'de'
,p_message_text=>'Tab Set='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583176876303155)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'de'
,p_message_text=>'Text='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98583700299303155)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'de'
,p_message_text=>'Validation='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592861666303162)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593467407303162)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'de'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592440223303162)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'de'
,p_message_text=>'Standarddarstellung 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592525945303162)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'de'
,p_message_text=>'Standarddarstellung 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592624422303162)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'de'
,p_message_text=>'Standarddarstellung 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592729559303162)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'de'
,p_message_text=>'Standarddarstellung 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591595582303161)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'de'
,p_message_text=>unistr('Extern erstellte Schaltfl\00E4chen f\00FCr die Seitennummerierung verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592343462303162)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'de'
,p_message_text=>'HTML-Standarddarstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593056892303162)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'de'
,p_message_text=>'Darstellung 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593120771303162)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'de'
,p_message_text=>'Darstellung 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593266863303162)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'de'
,p_message_text=>'Darstellung 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593341637303162)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'de'
,p_message_text=>'Darstellung 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592033433303161)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'de'
,p_message_text=>'Zeilen X bis Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591781309303161)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche 1-15 16-30 in Auswahlliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592263419303162)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'de'
,p_message_text=>'Suchmaschine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591810382303161)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'de'
,p_message_text=>'Suchmaschine 1,2,3,4 (auf Gruppe basierte Seitennummerierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592115011303162)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'de'
,p_message_text=>'Auswahlliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591378949303161)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Standards festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591436303303161)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'de'
,p_message_text=>'Seitennummerierung deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591946491303161)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen f\00FCr die Seitennummerierung verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593589086303163)
,p_name=>'F4000.P420.XML'
,p_message_language=>'de'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98592961993303162)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'de'
,p_message_text=>'XML-Export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593656435303163)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'de'
,p_message_text=>'Link generieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591689885303161)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenbereiche X bis Y (mit den n\00E4chsten und vorherigen Links)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418792194303852)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'de'
,p_message_text=>'Null'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717653803303269)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'de'
,p_message_text=>'DB-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717806414303269)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717901547303269)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717714744303269)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717515129303269)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'de'
,p_message_text=>'Statischer Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593799196303163)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('DML-Schaltfl\00E4chen ben\00F6tigen bestimmte Schaltfl\00E4chennamen. Weitere Informationen hierzu finden Sie im Hilfetext.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260349797302894)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'de'
,p_message_text=>'Neues Plug-in wird in Anwendung %0 erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260286851302894)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'de'
,p_message_text=>'Vorhandenes Plug-in in Anwendung %0 wird ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593864857303163)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'HTML mit Shortcuts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594005725303163)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'de'
,p_message_text=>'PLSQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584755271303156)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Schaltfl\00E4chen-Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305771517302931)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standard-Kalendertemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415005431303848)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Diagrammregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305596050302931)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standardtemplate f\00FCr Dialogseite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415148922303848)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Formularregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415518984303849)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr interaktive Berichtsregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584606841303156)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standardlabeltemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415281122303849)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Listenregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584553086303156)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standard-Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415713165303849)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Navigationspfadregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584824425303156)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standard-Navigationspfad-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414833483303848)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Navigationsleistenlisten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414568657303848)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Navigationsmen\00FClisten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414365020303848)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'de'
,p_message_text=>'Optionales Standardlabeltemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584254447303156)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standardseitentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584343834303156)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standard-Regionstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415317766303849)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Berichtsregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584474138303156)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standard-Berichtstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414407583303848)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'de'
,p_message_text=>'Erforderliches Standardlabeltemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414756653303848)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr seitliche Navigationsmen\00FClisten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415467604303849)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr tabellarische Formularregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414666196303848)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr obere Navigationsmen\00FClisten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99415608056303849)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Assistentenregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584102489303155)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standardfehlerseiten-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414950670303848)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Standard-Template f\00FCr Anmeldeseite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98584051329303155)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Standarddruckmodus-Seiten-Template:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98591266161303161)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht f\00FCr %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587898598303158)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'de'
,p_message_text=>'Alert-Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588086586303158)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'de'
,p_message_text=>'Neue Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587709028303158)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'de'
,p_message_text=>unistr('Sie m\00FCssen mindestens eine Region erstellen, bevor Sie ein Seitenelement erstellen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587965709303158)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'de'
,p_message_text=>'Verwenden Sie einen Assistenten, um eine neue Region zu erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589218133303159)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'de'
,p_message_text=>'wird alphabetisch sortiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589459663303160)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'de'
,p_message_text=>'Beispiel 4: Werteliste mit Bind-Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589386180303159)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'de'
,p_message_text=>'In Reihenfolge des Erstellvorgangs sortiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588919882303159)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Beispiel 2: Liste der Werte mit demselben Anzeige- und R\00FCckgabewert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681710314303237)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'de'
,p_message_text=>unistr('Beispiel 5: Die Abfrage enth\00E4lt eine Inline-Abfrage. Es muss sichergestellt werden, dass die erste FROM-Klausel der SQL-Anweisung kein Bestandteil der Inline-Abfrage ist')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588866163303159)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'de'
,p_message_text=>'Beispiel 1: Werteliste, die auf SQL-Abfrage basiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589135989303159)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Beispiel 3: Beispiele f\00FCr statische Listen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589003205303159)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie dieselbe Spalte f\00FCr die Anzeige- und R\00FCckgabewerte ausw\00E4hlen, verwenden Sie einen Spaltenaliasnamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259258898302894)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'de'
,p_message_text=>unistr('Ja/Nein anzeigen, Y und N zur\00FCckgeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594608304303163)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Nach der Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594343666303163)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'de'
,p_message_text=>'Vor den Berechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594578737303163)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Vor der Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594443748303163)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'de'
,p_message_text=>'Vor Validierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265683501302899)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594735510303163)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'de'
,p_message_text=>'Anwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262521202302896)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594985227303164)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'de'
,p_message_text=>'Fertigstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594809396303164)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595127697303164)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seitennummerierung wird f\00FCr alle Seiten in dieser Anwendung zur\00FCckgesetzt, wenn diese Prozedur ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607272112303173)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('WARNUNG: Sie haben eine Validierung vom Typ "Regul\00E4rer Ausdruck" ausgew\00E4hlt, die von Ihrer Datenbankversion nicht unterst\00FCtzt wird. Diese Validierung gibt immer TRUE zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344193381303789)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbersetzungen f\00FCr diese Anwendung sind aktuell nicht aktiviert. Hierzu wird auf die Einstellung <em>Anwendungssprache abgeleitet aus</em> in <a href="%0">Globalisierungsattribute</a> verwiesen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406304464303841)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'de'
,p_message_text=>'Wenn "Maximale Sessionleerlaufzeit" nicht festgelegt ist, wird der Workspace- oder Instanzebenenwert verwendet (aktuell %0 Sekunden).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406452638303841)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn "Maximale Sessionl\00E4nge" nicht festgelegt ist, wird der Workspace- oder Instanzebenenwert verwendet (aktuell %0 Sekunden).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396855940303833)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'de'
,p_message_text=>'Neue Verzweigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707959174303261)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Komponenten wurden aus einer anderen Anwendung bzw. aus einer Anwendung in einem anderen Workspace exportiert und k\00F6nnen in dieser Anwendung nicht installiert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711979421303264)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Dateien wurden aus einem anderen Workspace exportiert und k\00F6nnen in diesem Workspace nicht installiert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396998158303833)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'In Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397708094303833)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'de'
,p_message_text=>'Option "Kopieren": %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397836526303834)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Werteliste: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648864924303205)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Diese Seite wurde aus einer anderen Anwendung bzw. aus einer Anwendung in einem anderen Workspace exportiert und kann in dieser Anwendung nicht installiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550272230303129)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Diese Seite wurde aus einer Anwendung in einem anderen Workspace exportiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550123241303129)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Diese Seite wurde aus einer Anwendung im aktuellen Workspace exportiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969164923303478)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Seite ist derzeit gesperrt. Sie k\00F6nnen keinen Import \00FCber eine gesperrte Seite vornehmen. Entsperren Sie die Seite, und f\00FChren Sie anschlie\00DFend die Installation durch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395489712303831)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordneten Eintrag l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397209344303833)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter %0 ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369125485302979)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'de'
,p_message_text=>unistr('Es muss mindestens ein Schema f\00FCr den Kopiervorgang ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397481413303833)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'de'
,p_message_text=>unistr('Wert f\00FCr HTTP-Header %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397330743303833)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'de'
,p_message_text=>unistr('Wert f\00FCr Eingabeparameter %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397665517303833)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'de'
,p_message_text=>unistr('Header l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397558069303833)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter l\00F6schen: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596905833303165)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'de'
,p_message_text=>'Erforderliches Stylesheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566062221303142)
,p_name=>'F4000.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580633741303153)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenschaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552100312303131)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Seitenberechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306932269302932)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'de'
,p_message_text=>'Seite Dynamische Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167957051302821)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'de'
,p_message_text=>'Seite "Dynamische Aktion" - Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550863040303130)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Seitenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170148266302823)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'de'
,p_message_text=>'Seitenelementgruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585079531303156)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'de'
,p_message_text=>'Seite(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566151900303142)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Seitenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552231905303131)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Seitenprozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580594755303153)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'de'
,p_message_text=>'Seitenregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580772075303153)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Seitenvalidierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553002011303131)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkarte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567005944303142)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Popup-Werteliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184269243303651)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>'Zugangsdaten des Remotedruckservers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567616129303143)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551620891303130)
,p_name=>'F4000.REGION'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180706583303648)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Regionsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566227751303142)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Zugeh\00F6rige Seite(n) und Komponenten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184488258303651)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681550506303236)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197271135302844)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567589522303143)
,p_name=>'F4000.SEED'
,p_message_language=>'de'
,p_message_text=>'Seed'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552903020303131)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'de'
,p_message_text=>'Standardregisterkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580135808303152)
,p_name=>'F4000.STATIC'
,p_message_language=>'de'
,p_message_text=>'Static'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566884521303142)
,p_name=>'F4000.TAB'
,p_message_language=>'de'
,p_message_text=>'Registerkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567179959303142)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410926429303018)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Templatename(n) %0 bereits vorhanden. Geben Sie einen neuen Namen ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369250283302979)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'de'
,p_message_text=>'Der Templatename muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567352756303142)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'de'
,p_message_text=>'Neues Theme wird in Anwendung %0 erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567433520303143)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'de'
,p_message_text=>'Vorhandenes Theme in Anwendung %0 wird ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98566445301303142)
,p_name=>'F4000.TO'
,p_message_language=>'de'
,p_message_text=>'bis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553580576303132)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'de'
,p_message_text=>'Unbekanntes Anwendungselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567784936303143)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Aktualisierbare Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692971125303248)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'de'
,p_message_text=>unistr('Zu den Utilitys geh\00F6ren Seiten f\00FCr "Im Grid bearbeiten" und Berichte zu allen Seiten innerhalb der ausgew\00E4hlten Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98552316743303131)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Validierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197343094302844)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184590778303651)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550546219303130)
,p_name=>'F4000.YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626608225303188)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'de'
,p_message_text=>'Datum MMDDYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780313217303321)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332494803302951)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'de'
,p_message_text=>'Als Anwendung auf einer Datenbanktabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585400619303156)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'de'
,p_message_text=>'Als Anwendung auf Datenbanktabellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597001590303165)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Schaltfl\00E4chenposition ist nicht in Ihrem Regionstemplate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333006972303780)
,p_name=>'F4000_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597333905303165)
,p_name=>'F4000_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613943338303178)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'de'
,p_message_text=>'Kopieren und abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597645286303166)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'de'
,p_message_text=>'Datumsformat nicht erkannt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265385198302899)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696751602303251)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'de'
,p_message_text=>'Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779482994303320)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Wertelistenname(n) %0 bereits vorhanden. Geben Sie einen neuen Namen ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620541079303183)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576889036303150)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'de'
,p_message_text=>'Keine Anwendung zugewiesen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208675602302853)
,p_name=>'F4000_OFF'
,p_message_language=>'de'
,p_message_text=>'Aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208523168302852)
,p_name=>'F4000_ON'
,p_message_language=>'de'
,p_message_text=>'Ein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268943801302901)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'de'
,p_message_text=>'Kalendertemplates, die dieses Template referenzieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649717098303206)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten dieses Typs anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378291521302989)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr dieses Element ist keine Hilfe verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370210355302979)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung - Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370158888302979)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Dieses Template bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385772174302996)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'de'
,p_message_text=>unistr('CSS zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991212978303496)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Seite ist bereits in dieser Anwendung vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265712730302899)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'de'
,p_message_text=>'Die Seite muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265817165302899)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'de'
,p_message_text=>'Die Seite muss eine positive Zahl darstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265936455302899)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'de'
,p_message_text=>'Die Seite muss eine Ganzzahl darstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698024477303252)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema(s) importieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647534244303204)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschema(s) importieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698175246303252)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste(n) importieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647661818303204)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'de'
,p_message_text=>'Theme importieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595519731303164)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'de'
,p_message_text=>'Tabellarisches Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626364371303188)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'de'
,p_message_text=>'Berechtigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626446742303188)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618240732303181)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Keine Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598897997303167)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Anwendung ist aktuell nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347756209302963)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'de'
,p_message_text=>'Datum: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347851749302963)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'de'
,p_message_text=>'Datum, flexibel: %0 mit beliebigem Trennzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348514581302963)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'de'
,p_message_text=>'Datumsformat nicht erkannt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348481627302963)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Datum muss im Format %0 sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347259282302962)
,p_name=>'F4000_P430_IP'
,p_message_language=>'de'
,p_message_text=>'IP-Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348083140302963)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige IP-Adresse')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347399579302962)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'de'
,p_message_text=>'Telefonnummer, USA: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347471953302962)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'de'
,p_message_text=>'Telefonnummer, USA (flexibel): 999.999.9999, (999)-999-9999, 999 999 9999 usw.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348203741302963)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Das Format f\00FCr die Telefonnummer wurde nicht erkannt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348163441302963)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'de'
,p_message_text=>'Die Telefonnummer muss im Format %0 sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347145229302962)
,p_name=>'F4000_P430_URL'
,p_message_language=>'de'
,p_message_text=>'URL: http(s)://domain/path/doc.(pdf)(html)(etc...)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347938637302963)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347511563302963)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'de'
,p_message_text=>'Postleitzahl: 99999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347614714302963)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'de'
,p_message_text=>'ZIP + 4: 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348339227302963)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'de'
,p_message_text=>'Die Postleitzahl muss im Format %0 sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278611245302909)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278708693302909)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'de'
,p_message_text=>'Hierbei handelt es sich um die "Master"-Kopie dieses Authentifizierungsschemas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278959475302909)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Es gibt keine Abonnenten f\00FCr dieses Authentifizierungsschema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278837244302909)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Schemas, die dieses Authentifizierungsschema abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333628081302952)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'de'
,p_message_text=>'- Kein Schema -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594157721303163)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Bericht 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598987461303167)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf Stored Procedure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98594217778303163)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Diagramm 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598236610303166)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Nur anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598194065303166)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597833455303166)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'de'
,p_message_text=>unistr('Elementcacheinhalt l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597779694303166)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Seitencacheinhalt l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620875183303184)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'de'
,p_message_text=>unistr('Seitennummerierung zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598034016303166)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'de'
,p_message_text=>'Element mit PL/SQL-Funktionsbody festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597901494303166)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'de'
,p_message_text=>'Statische Elementzuweisung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595092995303164)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'de'
,p_message_text=>'Alle nicht in der aktuellen Anwendung gecachten Seitenelemente werden auf Null initialisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598656423303166)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598386654303166)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Element nicht Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598420310303166)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'de'
,p_message_text=>'Element nicht Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598573811303166)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626894855303188)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'de'
,p_message_text=>'Datum DDMMYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626722996303188)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'de'
,p_message_text=>'Telefonnummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365180083303806)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'de'
,p_message_text=>'Datenbankobjekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595248958303164)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'de'
,p_message_text=>'In Browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595384648303164)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'de'
,p_message_text=>'Kalender 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333815182302952)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'de'
,p_message_text=>unistr('(mit Spalte f\00FCr das Datum oder den Timestamp)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813681687303347)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'de'
,p_message_text=>'Syntax: Auswahl-ID, Name, Datum ab...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813964007303347)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'de'
,p_message_text=>'Beispiel unter Verwendung einer ROWID-Pseudospalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814029035303347)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'de'
,p_message_text=>unistr('Beispiel unter Verwendung des Prim\00E4rschl\00FCssels der Quelltabelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813709824303347)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'de'
,p_message_text=>unistr('1. Sie m\00FCssen mindestens zwei Spalten einbeziehen, und eine davon muss eine DATE-Spalte sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813859541303347)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'de'
,p_message_text=>unistr('2. Die erste Spalte sollte die Prim\00E4rschl\00FCsselspalte identifizieren, mit der Data Manipulation Language-(DML-)Vorg\00E4nge verwaltet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595426689303164)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Formular 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708526445303261)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'de'
,p_message_text=>unistr('Manifest f\00FCr Komponentenexport    ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649686428303206)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'de'
,p_message_text=>'Seitendefinition anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595636391303164)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Zusammenfassung (Seite)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614254029303178)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie hier, um die Registerkartengruppe festzulegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868314254303390)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'de'
,p_message_text=>unistr('Das Seitentemplate unterst\00FCtzt Registerkarten auf zwei Ebenen, die Standardregisterkarte identifiziert jedoch kein \00FCbergeordnetes Registerkartenset')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868271046303390)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'de'
,p_message_text=>'Keine Registerkarten, auf dieser Seite werden keine Registerkarten angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868091057303390)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'de'
,p_message_text=>'Auf dieser Seite wird eine Ebene von Registerkarten angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868420738303390)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'de'
,p_message_text=>'Seiten ohne Registerkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868528648303390)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr %0 Seiten insgesamt sind keine Registerkarten definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867974426303390)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Registerkartenanzeige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868106434303390)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'de'
,p_message_text=>'Auf dieser Seite werden zwei Ebenen von Registerkarten angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315892364303765)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0 ist verf\00FCgbar.</strong> Ihre Instanz wird automatisch am <strong>%1</strong> upgegradet. Der Instanzadministrator kann das Upgrade zu einem beliebigen Zeitpunkt vor diesem Datum in Administration Services initiieren.</p>'),
unistr('<p>In der <a href="%2" target="_blank" rel="noreferrer">Ank\00FCndigung</a> erhalten Sie weitere Informationen zu neuen Features und Verbesserungen in Oracle APEX %0.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315742928303765)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'de'
,p_message_text=>unistr('<strong>Ihre %0-Instanz wird auf ein neueres Release upgegradet.</strong> \00C4nderungen an Ihren Anwendungen werden w\00E4hrend des Upgradeprozesses f\00FCr einen gewissen Zeitraum deaktiviert. Der Zugriff auf Ihre Anwendungen und %0-Entwicklungsumgebung wird f')
||unistr('\00FCr bis zu %1 Minuten unterbrochen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277537370302908)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278461071302909)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'de'
,p_message_text=>'Dieses Schema als aktuelles Schema festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278590024302909)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'de'
,p_message_text=>'Als aktuelles Element festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333429206302952)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'de'
,p_message_text=>'Aktuell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278283992302909)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'de'
,p_message_text=>unistr('Status in inaktiv \00E4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277014108302908)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'de'
,p_message_text=>'Details'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277192143302908)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'de'
,p_message_text=>'Integrierte Sessionverwaltungslogik, eine integrierte Anmeldeseite und die Benutzerauthentifizierung beim internen "Cookie User"-Account-Repository.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277282314302908)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'de'
,p_message_text=>'Diese Methode wurde durch die SCHEME-Authentifizierung ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331462146302951)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'de'
,p_message_text=>'Verworfene Authentifizierungsattribute bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331508544302951)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'de'
,p_message_text=>'Verworfene Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331695741302951)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'de'
,p_message_text=>unistr('oder belassen Sie diese, bis Sie als Authentifizierungsmethode %0 festlegen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331956090302951)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'de'
,p_message_text=>'Gibt verworfene Authentifizierungsattribute an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332130494302951)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'de'
,p_message_text=>'oder migrieren Sie diese zu einem Authentifizierungsschema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331113555302950)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278100771302909)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'de'
,p_message_text=>'Verwalten Sie Authentifizierungsschemas mit dem oben angegebenen Bericht.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276966795302908)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'de'
,p_message_text=>'Methode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333341805302952)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'de'
,p_message_text=>'(Kann nicht bearbeitet werden)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278302794302909)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'de'
,p_message_text=>'(aktuell)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331201463302950)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'de'
,p_message_text=>'(verworfen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98278058840302909)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'de'
,p_message_text=>'(keine)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277477483302908)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'de'
,p_message_text=>unistr('Seiten ver\00F6ffentlichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277625510302908)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfen oder bearbeiten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277707351302908)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'de'
,p_message_text=>'oder bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277843039302908)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'de'
,p_message_text=>'Attribute der Sessionverwaltung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98277975622302909)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'de'
,p_message_text=>unistr('dieser Anwendung auf der Seite f\00FCr die Anwendungsattribute. Oder verwenden Sie den oben angegebenen Bericht, um Authentifizierungsschemas zu erstellen und zu verwalten, die verwendet werden k\00F6nnen, wenn Sie als Authentifizierungsmethode %0 festlegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331798918302951)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00DCberpr\00FCfen oder bearbeiten Sie die Attribute f\00FCr die Sessionverwaltung'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332088622302951)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Elemente \00FCberpr\00FCfen oder bearbeiten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331371632302950)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'de'
,p_message_text=>'Die %0-Authentifizierung ist eine verworfene Methode. Klicken Sie in einem der Authentifizierungsschemas dieser Anwendung auf <b>Als aktuelles Element festlegen</b> (siehe oben), oder erstellen Sie ein neues Authentifizierungsschema, das Sie anschlie'
||unistr('\00DFend als aktuelles Schema festlegen. Das INTERNAL-SETUP-Authentifizierungsschema entspricht der %0-Methode.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331803328302951)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Verwendet Authentifizierungsschemas zur Steuerung der Benutzerauthentifizierung und allen anderen Aspekten der Sessionverwaltung f\00FCr Ihre Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595916722303164)
,p_name=>'F4000_P805_X'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben im vorherigen Schritt eine Seiten-Sentry-Funktion erstellt. Die Funktion ist f\00FCr die Sessionverifizierung auf jeder Seite zust\00E4ndig, deshalb kann hier keine Funktion f\00FCr die Sessionverifizierung eingegeben werden. Wenn dies nicht Ihren Vors')
||unistr('tellungen entspricht, k\00F6nnen Sie in diesem Assistenten zu einer vorherigen Seite zur\00FCckkehren und \00C4nderungen vornehmen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334494872302953)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'de'
,p_message_text=>'Integrierte Anmeldeseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334800172302953)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334504582302953)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'de'
,p_message_text=>'Seite in dieser Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334726468302953)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334629433302953)
,p_name=>'F4000_P806_URL'
,p_message_language=>'de'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98334962415302953)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Verwenden Sie den %0-Account-Benutzernamen und das Kennwort f\00FCr die Authentifizierung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220770675302862)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Verwenden Sie den Benutzernamen und das Kennwort des Datenbank-Accounts f\00FCr die Authentifizierung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335086521302953)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'de'
,p_message_text=>'Keine Zugangsdaten verifizieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335258868302953)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'de'
,p_message_text=>unistr('Meine benutzerdefinierte Funktion f\00FCr die Authentifizierung verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335193917302953)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'de'
,p_message_text=>unistr('LDAP-Server f\00FCr die Authentifizierung verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599088140303167)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'- Kein Seitenname -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279656883302910)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Authentifizierungsfunktion',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280473861302911)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'de'
,p_message_text=>'Cookiedomain'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280290138302910)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'de'
,p_message_text=>'Cookiename'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280331478302911)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'de'
,p_message_text=>'Cookiepfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217830174302860)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'de'
,p_message_text=>'Sicher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279448637302910)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Sessionziel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279998889302910)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'de'
,p_message_text=>unistr('Basis f\00FCr die LDAP-Suche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280062478302910)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'de'
,p_message_text=>'LDAP-Benutzername bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279779979302910)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'de'
,p_message_text=>'LDAP-Host'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279825548302910)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'de'
,p_message_text=>'LDAP-Port'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280585452302911)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'de'
,p_message_text=>'Abmelde-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279156575302910)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279048485302909)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'de'
,p_message_text=>'(Integriert)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280671449302911)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'de'
,p_message_text=>'(Datenbank-Authentifizierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279271103302910)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'de'
,p_message_text=>'Seiten-Sentry-Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280198299302910)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'de'
,p_message_text=>'Prozess nach der Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279589457302910)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'de'
,p_message_text=>'Prozess vor der Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98279391653302910)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion f\00FCr die Sessionverifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335468555302954)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'de'
,p_message_text=>'Als Kopie eines vorhandenen Authentifizierungsschemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335567090302954)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'de'
,p_message_text=>'Basiert auf einem vorkonfigurierten Schema aus der Galerie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335340684302953)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'de'
,p_message_text=>'Basiert auf einem vorkonfigurierten Schema aus der Galerie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293212575302921)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Aktualisieren von Authentifizierungsschemas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280852528302911)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsmethode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348658956302963)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung: Sie sind im Begriff, das aktuelle Authentifizierungsschema f\00FCr diese Anwendung zu l\00F6schen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281081389302911)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280762404302911)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98280980902302911)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336020742302954)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On (Meine Anwendung als Partneranwendung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335643628302954)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'de'
,p_message_text=>'Anmeldeseite anzeigen und %0-Account-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335720130302954)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'de'
,p_message_text=>'Integrierte Anmeldeseite anzeigen und Open Door-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335867305302954)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'de'
,p_message_text=>'Anmeldeseite anzeigen und LDAP-Verzeichnis-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98335924575302954)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On (%0-Engine als Partneranwendung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281367867302911)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Authentifizierungsmethode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293394162302921)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'de'
,p_message_text=>'Single Sign-On (nur Oracle)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293446743302921)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On (%0 als Partneranwendung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293581439302921)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On (Meine Anwendung als Partneranwendung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293617040302921)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'de'
,p_message_text=>'Integrierte Anmeldeseite: %0-Account-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316141095302939)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'de'
,p_message_text=>'Neu erstellte Anmeldeseite: %0-Account-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316269837302939)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Anmeldeseite: %0-Account-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293720916302921)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'de'
,p_message_text=>'Integrierte Anmeldeseite: Open Door-Zugangsdaten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293801627302922)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'de'
,p_message_text=>'Integrierte Anmeldeseite: LDAP-Verzeichnis-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315943702302939)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'de'
,p_message_text=>'Neu erstellte Anmeldeseite: LDAP-Verzeichnis-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316064020302939)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Anmeldeseite: LDAP-Verzeichnis-Zugangsdaten verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293912760302922)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'de'
,p_message_text=>'Basiert auf dem Authentifizierungsschema der Galerie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336137656302954)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'de'
,p_message_text=>'Neu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372853022302982)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Das Undo Feature von %0 verwendet das integrierte Datenbank-Feature "Flashback Query", mit dem Sie die Daten zeitorientiert abfragen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98372695830302981)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie eine Zeit fest, zu der Sie zur\00FCckgehen m\00F6chten, und klicken Sie auf "Anwenden", um die Quelle wieder in die Bearbeitungsseite der Region zur\00FCckzuschreiben, und schlie\00DFen Sie dieses Dialogfeld.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373030857302982)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen - basierend auf dem Datenbankparameter UNDO_RETENTION - nur \00C4nderungen r\00FCckg\00E4ngig machen, die innerhalb der letzten %0 Stunde(n) vorgenommen wurden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373556259302982)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Standardregisterkarte in Anwendung best\00E4tigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373903692302982)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Es wird eine neue Registerkartengruppe %0 erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373878247302982)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'de'
,p_message_text=>'Seite %0 verwendet die vorhandene Registerkartengruppe "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373668967302982)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung. Informationen zur Registerkartengruppe sind unvollst\00E4ndig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815366149303348)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'de'
,p_message_text=>unistr('Wert f\00FCr %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597454754303166)
,p_name=>'F4000_PREV'
,p_message_language=>'de'
,p_message_text=>'Vorherige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585799189303157)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie auf <strong>Beenden</strong>, um Ihre Anwendung zu erstellen oder zu erweitern.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585580163303157)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'de'
,p_message_text=>'Navigationspfade einbeziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585634993303157)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschl\00FCssel auf Berichtsseite ausblenden')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731241194303281)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'de'
,p_message_text=>'Shortcut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491812041303083)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'de'
,p_message_text=>'SVG-Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98597196489303165)
,p_name=>'F4000_TOP'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696881508303251)
,p_name=>'F4000_TREE'
,p_message_language=>'de'
,p_message_text=>'Baum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812244830303346)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249117370302885)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'de'
,p_message_text=>'Gesamtes Antwortdokument'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259175671302893)
,p_name=>'F400_P107_STEP'
,p_message_language=>'de'
,p_message_text=>'Schritt %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229838971302869)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'de'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813582772303347)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'de'
,p_message_text=>'Angenommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683519752303238)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'de'
,p_message_text=>'Das Schema wird dem Workspace zugeordnet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683672981303238)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'de'
,p_message_text=>unistr('Das Schema wird dem Workspace aus folgenden Gr\00FCnden nicht zugeordnet:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683146067303238)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Zus\00E4tzliches Schema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578350622303151)
,p_name=>'F4050.ADJUST'
,p_message_language=>'de'
,p_message_text=>'Anpassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577652276303150)
,p_name=>'F4050.ALL'
,p_message_language=>'de'
,p_message_text=>'Alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813066849303347)
,p_name=>'F4050.APPROVED'
,p_message_language=>'de'
,p_message_text=>'Genehmigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233688246302873)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Anforderung f\00FCr einen Workspace wurde genehmigt. Zugangsdaten wurden an die E-Mail-Adresse gesendet, die Sie bei der Registrierung angegeben haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651753645303208)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Anforderung f\00FCr einen Account wurde genehmigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651648378303207)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'de'
,p_message_text=>unistr('Genehmigt: Account-Anforderung f\00FCr %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652144071303208)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Anforderung f\00FCr zus\00E4tzliche %0 MB Speicher im Workspace %1 wurde genehmigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812767391303346)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Zugeordnet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324047395303772)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812651773303346)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404217627303839)
,p_name=>'F4050.BROKEN'
,p_message_language=>'de'
,p_message_text=>'Unterbrochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404699146303839)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'de'
,p_message_text=>'Gruppe blockiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652512881303208)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungsanforderung genehmigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652613304303208)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungsanforderung abgelehnt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404120287303839)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683204425303238)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Schema wird erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813140291303347)
,p_name=>'F4050.DECLINED'
,p_message_language=>'de'
,p_message_text=>'Abgelehnt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652068516303208)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'de'
,p_message_text=>unistr('Abgelehnt: Account-Anforderung f\00FCr %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652489093303208)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Anforderung f\00FCr zus\00E4tzliche %0 MB Speicher im Workspace %1 wurde abgelehnt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652211983303208)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Anforderung f\00FCr das Datenbankschema %0 im Workspace %1 wurde abgelehnt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652379103303208)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Anforderung f\00FCr das Beenden des Service f\00FCr Workspace %0 wurde abgelehnt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403808913303839)
,p_name=>'F4050.DISABLED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229798900302869)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Klicken Sie auf den Link unten, um den Genehmigungsprozess abzuschlie\00DFen. Danach erhalten Sie Ihre Workspace-Zugangsdaten in einer Folge-E-Mail.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651976680303208)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Klicken Sie auf den Link unten, um zu beginnen.',
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404323167303839)
,p_name=>'F4050.FAILED'
,p_message_language=>'de'
,p_message_text=>'Nicht erfolgreich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257407560302892)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf <a href=''%0''>here</a> um den Genehmigungsvorgang abzuschlie\00DFen und Ihre Zugangsdaten zu erhalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567912926303143)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'de'
,p_message_text=>'Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579158457303152)
,p_name=>'F4050.INSTALL'
,p_message_language=>'de'
,p_message_text=>'Installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813200369303347)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'In Arbeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577914134303151)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'de'
,p_message_text=>'Keine Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596032068303164)
,p_name=>'F4050.P23.USE'
,p_message_language=>'de'
,p_message_text=>'Verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407318328303842)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisierungspr\00FCfung f\00FCr gesamte Instanz deaktiviert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596179678303165)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683092795303238)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578282401303151)
,p_name=>'F4050.PROVISION'
,p_message_language=>'de'
,p_message_text=>'Provisioning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651495486303207)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungsanforderung genehmigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651365261303207)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Anforderung f\00FCr das Datenbankschema %0 im Workspace %1 wurde genehmigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404422839303839)
,p_name=>'F4050.REMOTE'
,p_message_language=>'de'
,p_message_text=>'Remote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813322025303347)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'de'
,p_message_text=>'Angefordert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577450089303150)
,p_name=>'F4050.RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651509116303207)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung: Das angeforderte Schema ist eingeschr\00E4nkt aufgrund von Site-spezifischen Policys oder weil es ein Oracle-Standardschema ist. Eingeschr\00E4nkte Schemas k\00F6nnen Workspaces nicht zugeordnet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403989504303839)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'de'
,p_message_text=>'Wiederholung geplant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683498205303238)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Vorhandenes Schema wird wiederverwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404024876303839)
,p_name=>'F4050.RUNNING'
,p_message_language=>'de'
,p_message_text=>unistr('Wird ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403711696303839)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'de'
,p_message_text=>'Geplant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651100796303207)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Warnung: Das angeforderte Schema ist bereits Workspaces zugeordnet. Vergewissern Sie sich, dass dieses Schema entsprechend der Sicherheits-Policys Ihrer Site mehreren Workspaces zugeordnet werden kann, bevor Sie diese Anforderung genehmigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651096072303207)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Warnung: Das angeforderte Schema ist bereits vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683744987303238)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Das Schema ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683955607303239)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'de'
,p_message_text=>'Das Schema ist reserviert und kann keinem Workspace zugeordnet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651219376303207)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung: Das angeforderte Schema ist eingeschr\00E4nkt aufgrund von Site Policys, oder weil es ein Oracle-Standardschema ist. Wenn Sie dieses Schema dem Workspace zuordnen, indem Sie fortfahren, erhalten die Entwickler dieses Workspace vollen Zugriff auf')
||' das Schema. Vergewissern Sie sich, dass diese Aktion in Einklang mit den Sicherheits-Policys Ihrer Site ist, bevor Sie diese Anforderung genehmigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98683897001303239)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'de'
,p_message_text=>unistr('Das Schema ist aufgrund von Sicherheits-Policys eingeschr\00E4nkt. Eingeschr\00E4nkte Schemas k\00F6nnen Workspaces nicht zugeordnet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652701615303208)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'de'
,p_message_text=>'Service beendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652814358303208)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'de'
,p_message_text=>'Der Entwicklungs-Service "%0" wurde beendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404542113303839)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'de'
,p_message_text=>'Erfolgreich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812834633303346)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'de'
,p_message_text=>'Unterbrochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812907420303347)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'de'
,p_message_text=>'Beenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98813475271303347)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'de'
,p_message_text=>'Beendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403651905303839)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'Vorgang wird beendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578582896303151)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'de'
,p_message_text=>'View-Anforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578956407303152)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'de'
,p_message_text=>'Export des Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344968536302961)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'de'
,p_message_text=>'Workspace-Homepage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345034708302961)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'de'
,p_message_text=>'Anmeldung am Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648747166303205)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Der Workspace kann nicht erstellt werden, weil bereits ein Workspace mit dieser ID vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648610836303205)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Der Workspace kann nicht erstellt werden, weil bereits ein Workspace mit diesem Namen vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421562471303026)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'de'
,p_message_text=>unistr('Workspace %0 wurde bei %1 erstellt. Eine Best\00E4tigung wurde an die E-Mail-Adresse gesendet, die Sie bei der Registrierung angegeben haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250720237302886)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Der Workspace wird nicht erstellt, weil er bereits vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250871563302886)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Der Workspace wird erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485911277303078)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'de'
,p_message_text=>'Neues Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485888297303078)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Das Account-Kennwort wurde f\00FCr den Benutzer %0 ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485747844303078)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Ihr Kennwort wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368837343303809)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Seite steuert, ob %0 sofort upgegradet wird, wenn das n\00E4chste Release verf\00FCgbar ist, oder ob das Upgrade bis zu %1 Tage lang verz\00F6gert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368911062303809)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf "Upgrade jetzt ausf\00FChren", um das Upgrade jetzt und nicht am %0 zu starten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368528151303809)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'de'
,p_message_text=>'System befindet sich auf dem neuesten Stand.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368635266303809)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 %1 ist <a href="%2" target="_blank" rel="noreferrer">verf\00FCgbar</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367694127303808)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'de'
,p_message_text=>unistr('Sobald ein neues %0-Release verf\00FCgbar ist, wird Ihre Instanz <strong>sofort</strong> upgegradet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368363823303809)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Instanz wird automatisch am <strong>%0</strong> upgegradet. Klicken Sie auf das Zahnradsymbol, um das Upgrade jetzt auszuf\00FChren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367596894303808)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'de'
,p_message_text=>unistr('%0-Upgrades Ihrer Instanz werden <strong>verz\00F6gert</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909572296303424)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'de'
,p_message_text=>'%0 wird gerade auf %1 upgegradet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237681906302876)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'de'
,p_message_text=>'Datenbankbenutzer %0 mit Default Tablespace %1 und Datendatei %2 erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254445618302889)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'de'
,p_message_text=>'Workspace %0 mit Administrator %1 durch Provisioning bereitgestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386256129302996)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'de'
,p_message_text=>'Alle Workspaces anzeigen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377539874302989)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spaltenl\00E4nge darf nicht Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377494239302989)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spaltenl\00E4nge darf nicht Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377784123302989)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'de'
,p_message_text=>unistr('Spaltennamen d\00FCrfen nicht mehr als %0 Zeichen enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377856297302989)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>unistr('Spaltennamen d\00FCrfen nicht Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378355106302989)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'de'
,p_message_text=>'Der Name <strong>%0</strong> wird bereits von einem vorhandenen Objekt verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378526905302990)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('<strong>%0</strong> ist kein g\00FCltiger Sequenz-Name.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377127164302988)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Der Tabellenname ist bereits vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378126617302989)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('<strong>%0</strong> ist kein g\00FCltiger Prim\00E4rschl\00FCsselname.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596243471303165)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'de'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98567286824303142)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'de'
,p_message_text=>'Arbeitsblattimport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378009926302989)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'de'
,p_message_text=>unistr('Tabellennamen m\00FCssen k\00FCrzer als %0 Zeichen sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388788827302998)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Die erste Zeile enth\00E4lt Spaltennamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714523720303266)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'de'
,p_message_text=>'Text importieren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414507448303020)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungseigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577221771303150)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('(verf\00FCgbar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577064730303150)
,p_name=>'F4350.CHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752114632303299)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'de'
,p_message_text=>'Sie fordern die Zuweisung des vorhandenen Schemas %0 zu Ihrem Workspace an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752291604303299)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'de'
,p_message_text=>'Sie fordern die Erstellung von Schema %0 und die Zuweisung zu Ihrem Workspace an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576715449303150)
,p_name=>'F4350.CREATE'
,p_message_language=>'de'
,p_message_text=>'Erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420675606303025)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Workspace wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577193166303150)
,p_name=>'F4350.CURRENT'
,p_message_language=>'de'
,p_message_text=>'(aktuell)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415095174303021)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Uhrzeit (auf dem Server)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414867264303021)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'de'
,p_message_text=>'Aktueller Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576964736303150)
,p_name=>'F4350.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421711745303026)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'de'
,p_message_text=>unistr('Die Workspace-Erstellung wurde vor\00FCbergehend deaktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414400897303020)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Hostschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576443754303149)
,p_name=>'F4350.INSERTED'
,p_message_language=>'de'
,p_message_text=>unistr('Eingef\00FCgt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414927660303021)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Voreinstellung f\00FCr Sprache')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414355652303020)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'de'
,p_message_text=>'Letzte DDL-Zeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898148121303415)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'de'
,p_message_text=>'Letzte Patchzeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221271513302863)
,p_name=>'F4350.MORE'
,p_message_language=>'de'
,p_message_text=>'%0 weitere...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898056522303415)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'de'
,p_message_text=>'Patchversion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414135795303020)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'de'
,p_message_text=>'Produkt-Build'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945996555303455)
,p_name=>'F4350.RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414298615303020)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'de'
,p_message_text=>unistr('Schemakompatibilit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221150381302863)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>unistr('(+%0 \00FCbersetzte Anwendungen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576625586303150)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'de'
,p_message_text=>'Unbekannt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576585480303150)
,p_name=>'F4350.UPDATED'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414633839303020)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'de'
,p_message_text=>'Workspace-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414742834303020)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'de'
,p_message_text=>'Workspace-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122844585303603)
,p_name=>'F4350_AJAX'
,p_message_language=>'de'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122781498303603)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungs-Callback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578142713303151)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Clickthrough Log-Eintr\00E4ge:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578050352303151)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tslog-Eintr\00E4ge f\00FCr den Entwickler:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578603257303151)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Benutzer bei allen Sessions = %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579099882303152)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Kein Benutzer ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579339259303152)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Voreinstellungen sind f\00FCr %1 Benutzer in Workspace "%2" vorhanden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195507081302842)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Voreinstellungen sind f\00FCr %1 Benutzer vorhanden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577857045303151)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'de'
,p_message_text=>unistr('Setzen Sie Ihre Voreinstellungen zur\00FCck, wenn Sie Ihre Anwendung ohne voreingestellte Werte ausf\00FChren m\00F6chten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252577854302888)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'de'
,p_message_text=>unistr('Setzen Sie den Sessionzustand zur\00FCck, wenn die Anwendung ohne im Voraus festgelegte Werte ausgef\00FChrt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579433225303152)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlter Benutzer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578726312303151)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'de'
,p_message_text=>unistr('Sessions, die \00E4lter als %0 Tag(e) sind = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578879371303151)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'de'
,p_message_text=>unistr('Sessions, die \00E4lter als %0 Minute(n) sind = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577343429303150)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Session wird von %0 identifiziert und enth\00E4lt %1 Eintr\00E4ge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580081835303152)
,p_name=>'F4350_SQL'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579280326303152)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'de'
,p_message_text=>'Zusammenfassung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98578450239303151)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Gesamtanzahl der Sessions f\00FCr den Workspace "%0" betr\00E4gt %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195483545302842)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'de'
,p_message_text=>'Gesamte Sessions: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579576624303152)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'de'
,p_message_text=>'Der Benutzer %0 hat %1 Voreinstellungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98577725736303150)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr den aktuellen Benutzer %0 sind %1 Voreinstellungen festgelegt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98579618796303152)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'de'
,p_message_text=>'Workspace-Schemas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582166025303154)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'de'
,p_message_text=>'Die Anzeigesequenz in Forms muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582233702303154)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'de'
,p_message_text=>'Die Anzeigesequenz in Reports muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385610548302996)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'de'
,p_message_text=>'Der Argumentname <strong>%0</strong> wird mehrmals in dieser Funktion verwendet.<br/>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585210710303156)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'de'
,p_message_text=>unistr('Die Ausf\00FChrungsreihenfolge muss angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585179016303156)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'de'
,p_message_text=>unistr('Die Ausf\00FChrungsreihenfolge muss numerisch sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568010332303143)
,p_name=>'F4500.FIND'
,p_message_language=>'de'
,p_message_text=>'Suchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596492823303165)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'de'
,p_message_text=>'SQL ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568463229303143)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'de'
,p_message_text=>unistr('Vergr\00F6\00DFern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568353833303143)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'de'
,p_message_text=>'Spalte nach unten verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568217354303143)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'de'
,p_message_text=>'Spalte nach oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379384772302990)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die eindeutige Nummer f\00FCr die Ausf\00FChrungsreihenfolge ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180510981302831)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Neu hinzuzuf\00FCgende Spalten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378991325302990)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('<strong>%0</strong> ist kein g\00FCltiger Objektname.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378718279302990)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('<strong>%0</strong> ist kein g\00FCltiger Tabellenname.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568111324303143)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'de'
,p_message_text=>'Kein Bild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568505120303143)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'de'
,p_message_text=>'Auf Null setzbar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681875817303237)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'de'
,p_message_text=>unistr('Vorherige Ausf\00FChrungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385194662302995)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'de'
,p_message_text=>'Die Spaltennamen <strong>%0</strong> werden mehrmals in dieser Tabelle verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385585192302996)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'de'
,p_message_text=>unistr('Sie m\00FCssen den Namen von mindestens einer Spalte eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385424106302995)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname <strong>%0</strong> ist ung\00FCltig.<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385262229302995)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'de'
,p_message_text=>unistr('Die Gesamtstellenzahl f\00FCr die Spalte <strong>%0</strong> ist ung\00FCltig.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385387639302995)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anzahl der Nachkommastellen f\00FCr die Spalte <strong>%0</strong> ist ung\00FCltig.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235669522302874)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anzahl der Nachkommastellen f\00FCr die Spalte <strong>%0</strong> ist erforderlich.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596525274303165)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'de'
,p_message_text=>unistr('Synonym erstellen f\00FCr')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98596380800303165)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'de'
,p_message_text=>'SQL anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379020962302990)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Tabelle <strong>%0</strong> wurde in Schema <strong>%1</strong> nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184612000302834)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'de'
,p_message_text=>'Warnungshinweise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581271213303153)
,p_name=>'F4500_BROKEN'
,p_message_language=>'de'
,p_message_text=>'Unterbrochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581756108303154)
,p_name=>'F4500_BYTES'
,p_message_language=>'de'
,p_message_text=>'Byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581631590303154)
,p_name=>'F4500_CARD'
,p_message_language=>'de'
,p_message_text=>'Karte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581030880303153)
,p_name=>'F4500_CHECK'
,p_message_language=>'de'
,p_message_text=>'Check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573533213303147)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie hier, um das Abfragefeld aufzuf\00FCllen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581587854303153)
,p_name=>'F4500_COST'
,p_message_language=>'de'
,p_message_text=>'Kostenfaktor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572838091303147)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Erstellvorgang wurde erfolgreich ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350973541303794)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Objekte ohne Standardwerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350888025303794)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Objekte mit Standardwerten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572142170303146)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der L\00F6schvorgang wurde erfolgreich ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224611816302865)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'de'
,p_message_text=>'Fremd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486172929303078)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'de'
,p_message_text=>unistr('Fremdschl\00FCssel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385956154302996)
,p_name=>'F4500_NATIVE'
,p_message_language=>'de'
,p_message_text=>'Natives Dateiformat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571864995303146)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'de'
,p_message_text=>'kann nicht bearbeitet werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581380219303153)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'de'
,p_message_text=>'kann nicht durchsucht werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581132745303153)
,p_name=>'F4500_OF'
,p_message_language=>'de'
,p_message_text=>'Von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98581402987303153)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'de'
,p_message_text=>'Optimizer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573814801303147)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Vorgang wurde erfolgreich ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561542632303138)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Keine Workspace-Nachricht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714498113303266)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'de'
,p_message_text=>'VARCHAR-Spaltentypen sind nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258812483302893)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'de'
,p_message_text=>'Skript wird geparst. Bitte warten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205559787302850)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'de'
,p_message_text=>'Anzahl der Anweisungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447334405303046)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'de'
,p_message_text=>'am %0 von %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569225597303144)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie Parameter im Skript haben, definieren Sie diese vor der Ausf\00FChrung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205428754302850)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'de'
,p_message_text=>'Skriptname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447287839303046)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Skriptgr\00F6\00DFe in Byte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443589436303043)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569422929303144)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728138836303278)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben den Import der folgenden Skripts angefordert. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98728220506303279)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Die von Ihnen f\00FCr den Import angeforderten Skripts \00FCberschreiten den maximal zul\00E4ssigen Speicher. Wenden Sie sich an Ihren %0-Administrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729227509303279)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'de'
,p_message_text=>unistr('Skript f\00FCr den Import')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569996114303144)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'de'
,p_message_text=>'Kein Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569784840303144)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'de'
,p_message_text=>'Num'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549687397303129)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Ausgabe anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630557239303191)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'de'
,p_message_text=>'Sequenzen durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630648157303191)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Erstellvorgang f\00FCr Sequenzen war aus folgendem Grund nicht erfolgreich:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630447038303191)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Die Sequenz "%0" wurde im "%1"-Schema erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570141016303145)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'de'
,p_message_text=>'Anweisung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630971043303191)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'de'
,p_message_text=>'Datenbanksynonyme durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631177276303192)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Erstellvorgang f\00FCr Synonyme war aus folgendem Grund nicht erfolgreich:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630862823303191)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Das Synonym "%0" wurde im "%1"-Schema erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631260982303192)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Der Erstellvorgang f\00FCr Packages war aus folgendem Grund nicht erfolgreich:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631302258303192)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Das Package "%0" wurde im "%1"-Schema erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412935745303019)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'de'
,p_message_text=>'In Arbeitsblatt speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570400439303145)
,p_name=>'F4500_P25_BY'
,p_message_language=>'de'
,p_message_text=>'Von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570341570303145)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'de'
,p_message_text=>'Erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570206445303145)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'de'
,p_message_text=>'Dateiname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226399471302867)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'de'
,p_message_text=>'Abgelaufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226433566302867)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Abgelaufen und gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226268069302867)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226188199302866)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630317933303191)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'de'
,p_message_text=>'Der Vorgang war aus folgendem Grund nicht erfolgreich:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607403207303173)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'de'
,p_message_text=>unistr('Daten k\00F6nnen nicht eingef\00FCgt werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630213603303191)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'de'
,p_message_text=>'Datenbank-View durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629986372303191)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Erstellvorgang f\00FCr Views war aus folgendem Grund nicht erfolgreich:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630027236303191)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'de'
,p_message_text=>'Home SQL Workshop '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98630167805303191)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'de'
,p_message_text=>'Die View "%0" wurde im "%1"-Schema erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98598751191303166)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'de'
,p_message_text=>'Spaltenkommentar abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756384901303302)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'de'
,p_message_text=>unistr('Identit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257388801302891)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Kein Datentyp f\00FCr %0 angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571937583303146)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Tabellenvorgang wurde erfolgreich ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569044777303144)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'de'
,p_message_text=>'Diese Datei hat %0-Anweisungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569179703303144)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'de'
,p_message_text=>'Der Benutzer hat folgende %0-Parameter definiert:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386122080302996)
,p_name=>'F4500_PARSE'
,p_message_language=>'de'
,p_message_text=>'Dieses Skript parsen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580829694303153)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'de'
,p_message_text=>'Primary'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189707109302838)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'de'
,p_message_text=>'Referential'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98386036652302996)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Dokument als Text anzeigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98580994244303153)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Unique'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430320225303861)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'de'
,p_message_text=>'Es gibt Probleme mit der Konfiguration der statischen Dateien in Ihrer Umgebung. Lesen Sie den Abschnitt "Configuring Static File Support" im Application Express Installation Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773765268303316)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'de'
,p_message_text=>'Willkommen bei Oracle APEX! Melden Sie sich mit dem Administratorkennwort (ADMIN) von Autonomous Database an.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426400063303858)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'de'
,p_message_text=>'Sie erhalten diese E-Mail, weil Sie einen Oracle APEX Workspace angefordert haben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426366681303858)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'de'
,p_message_text=>unistr('Aktion erforderlich: Accountanforderung f\00FCr %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650071102303206)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'de'
,p_message_text=>'(wird verwendet, um Ihre Zugangsdaten per E-Mail zu senden)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650220207303206)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Datenbankschema ein, das bereits in Ihrer Oracle-Datenbank vorhanden ist. Es kann aus Sicherheitsgr\00FCnden keine Werteliste zur Verf\00FCgung gestellt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650176303303206)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen f\00FCr das Oracle-Datenbankschema ein, das f\00FCr Ihren Workspace erstellt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649480072303206)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie unten in der Beschreibung an, warum Sie ein eingeschr\00E4nktes Schema anfordern.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649568367303206)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Geben Sie unten in der Beschreibung an, warum Sie ein Schema anfordern, das bereits in anderen Workspaces verwendet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649904685303206)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung: Das angeforderte Schema ist aus Sicherheitsgr\00FCnden eingeschr\00E4nkt. Der %0-Administrator wird m\00F6glicherweise Ihre Anforderung verweigern, dieses Schema Ihrem Workspace zuzuordnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649821518303206)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung: Das angeforderte Schema wird bereits von anderen Workspaces verwendet. Der %0-Administrator wird m\00F6glicherweise Ihre Anforderung verweigern, dieses Schema Ihrem Workspace zuzuordnen. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646864268303204)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'de'
,p_message_text=>unistr('Das neue Schema, das Sie f\00FCr Ihren Workspace angefordert haben, ist ein Oracle-Standardschema oder wurde aus Sicherheitsgr\00FCnden f\00FCr Ihre Site eingeschr\00E4nkt und ist m\00F6glicherweise nicht f\00FCr einen Workspace geeignet. Der Siteadministrator lehnt die Pro')
||'visioning-Anforderung ab, falls dadurch eine Sicherheits-Policy bei Ihrer Site verletzt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646740855303204)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'de'
,p_message_text=>unistr('Das Schema, das Sie f\00FCr Ihren Workspace angefordert haben, ist bereits %0 Workspace(s) zugeordnet.  Der Siteadministrator lehnt die Provisioning-Anforderung ab, falls dadurch eine Sicherheits-Policy bei Ihrer Site verletzt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222022490302863)
,p_name=>'F4700P1_A'
,p_message_language=>'de'
,p_message_text=>unistr('Oracle APEX erm\00F6glicht den Zugriff auf eine Oracle-Datenbank und browserbasierte Entwicklungstools.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222164466302863)
,p_name=>'F4700P1_B'
,p_message_language=>'de'
,p_message_text=>'Webanwendungen deklarativ erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222295246302863)
,p_name=>'F4700P1_C'
,p_message_language=>'de'
,p_message_text=>'Datenbankobjekte erstellen und verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222337465302863)
,p_name=>'F4700P1_D'
,p_message_language=>'de'
,p_message_text=>'Meilensteine, Bugs, Features und Aufgaben verfolgen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360899536303803)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anwendung wurde erfolgreich installiert. Um die Anwendung jedoch mit der Application Express-Accountauthentifizierung auszuf\00FChren, muss ein Application Express-Benutzeraccount eingerichtet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360913792303803)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Websheet wurde erfolgreich installiert. Um das Websheet jedoch mit der Application Express-Accountauthentifizierung auszuf\00FChren, muss ein Administrator mit Application Express-Account eingerichtet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714673513303266)
,p_name=>'F4750.VERSION'
,p_message_language=>'de'
,p_message_text=>'Version'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384946435303822)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>unistr('Beispieldaten von RESTful Services k\00F6nnen nicht zur\00FCckgesetzt werden: Schema <code>%0</code> ist nicht vorhanden.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959707519303470)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Diese Anwendung verwendet das Authentifizierungsschema %0.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994155995303499)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'de'
,p_message_text=>'Facet-Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967503806303477)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'de'
,p_message_text=>'Der Assistent kann keine Facet-Suche mithilfe der Berichtsquelle erstellen. Es sind keine Spalten zum Durchsuchen vorhanden.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779362881303320)
,p_name=>'FAILURE'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570630544303145)
,p_name=>'FAILURES'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645035719303202)
,p_name=>'FDASH1'
,p_message_language=>'de'
,p_message_text=>'%0 Features'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686595646303241)
,p_name=>'FEATURE'
,p_message_language=>'de'
,p_message_text=>'Feature'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405323255303840)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'de'
,p_message_text=>unistr('Featureeigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359052871302971)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Info-Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359722125302972)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Seite mit Informationen zu dieser Anwendung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359103910302971)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359819270302972)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie die rollenbasierte Benutzerauthentifizierung in Ihre Anwendung auf, und verwalten Sie Zuordnungen zwischen Benutzernamen und Anwendungsrollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359255607302971)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tsberichte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359913694302972)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Nehmen Sie zahlreiche Berichte und Diagramme zur Endbenutzeraktivit\00E4t auf.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359313230302971)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Konfigurationsoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360761527302972)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Lassen Sie zu, dass Anwendungsadministratoren bestimmte Funktionen, die mit einer Application Express-Erstelloption verkn\00FCpft sind, in der Anwendung aktivieren oder deaktivieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658825235303213)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'de'
,p_message_text=>'Die folgenden Erstelloptionen werden erstellt:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719506293303271)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719673047303271)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'de'
,p_message_text=>'Beinhalten einen Bericht zur APEX_SEND()-E-Mail-Queue.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776221609303318)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Umfasst einen Bericht, in dem die zu sendenden E-Mails zusammen mit dem Log der bereits gesendeten E-Mails angezeigt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359440306302971)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360065181302972)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Verfahren an, mit dem Endbenutzer allgemeine Kommentare an Anwendungsadministratoren und -entwickler senden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719740738303271)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'de'
,p_message_text=>'Jobberichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719871434303271)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Beinhalten einen Bericht zu Datenbankjobs mit der M\00F6glichkeit zum Drilldown in einen bestimmten Job, um weitere Details anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98359515708302972)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'de'
,p_message_text=>'Theme-Stilauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98360695555302972)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Lassen Sie zu, dass Administratoren ein Standardfarbschema (Theme-Stil) f\00FCr die Anwendung ausw\00E4hlen. Administratoren k\00F6nnen auch festlegen, dass Endbenutzer ihre eigenen Theme-Stile ausw\00E4hlen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666791660303223)
,p_name=>'FEATURES'
,p_message_language=>'de'
,p_message_text=>'Features'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974849506303483)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'de'
,p_message_text=>'Features 100 %'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723936586303275)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'de'
,p_message_text=>'Features 100 % (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689124248303244)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'de'
,p_message_text=>'Features 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217132590302859)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'de'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215936384302858)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossene Features (%0 / %1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217014675302859)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'de'
,p_message_text=>'%0 abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977396454303485)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'de'
,p_message_text=>unistr('Features f\00FCr Release %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724184158303275)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberf\00E4llig (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993400783303498)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz der funktional abgeschlossenen Features (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724005498303275)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'de'
,p_message_text=>'Mit Datumsangaben (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756280554303302)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Featurekonfiguration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662266302303215)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'de'
,p_message_text=>'Beitragender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723824643303275)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'de'
,p_message_text=>'Featureanzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970865024303479)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Features, %1 vollst\00E4ndig abgeschlossen, in %2 Releases')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970958474303480)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'de'
,p_message_text=>'%0 Features der obersten Ebene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971034240303480)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'de'
,p_message_text=>unistr('%0 haben kein F\00E4lligkeitsdatum, %1 haben das F\00E4lligkeitsdatum \00FCberschritten und < 80 % abgeschlossen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971161695303480)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'de'
,p_message_text=>'%0 Features sind funktional abgeschlossen, %1 sind nicht abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974531141303482)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'de'
,p_message_text=>'%0% Features sind zu 100 % abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660509585303214)
,p_name=>'FEATURE_DESC'
,p_message_language=>'de'
,p_message_text=>'Featurebeschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661509627303215)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'de'
,p_message_text=>unistr('Erw\00FCnschtheit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392431217303829)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Feature: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660149802303214)
,p_name=>'FEATURE_NAME'
,p_message_language=>'de'
,p_message_text=>'Featurename'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660295969303214)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Featureeigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661215704303215)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'de'
,p_message_text=>unistr('Priorit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661363685303215)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661101790303215)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'de'
,p_message_text=>'Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405419433303840)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'de'
,p_message_text=>'Nicht zugeordnet'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407847242303842)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'de'
,p_message_text=>'%0 protokolliert und %1 zugewiesen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686499806303241)
,p_name=>'FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702068659303255)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die folgenden Informationen ein, die als Feedback protokolliert werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772587767303315)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'de'
,p_message_text=>'Feedback-Dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666315410303222)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Feedbackeintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216289577302859)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'de'
,p_message_text=>unistr('%2 offene Feedback-Eintr\00E4ge (%0 Geschlossen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701841706303255)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Ihr Feedback ein, und klicken Sie auf die Schaltfl\00E4che "Feedback weiterleiten".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993702335303499)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz geschlossener Feedbacks (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697021157303251)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'de'
,p_message_text=>'Feedbacktyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701979745303255)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Art des bereitgestellten Feedbacks an.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864714225303387)
,p_name=>'FILENAME'
,p_message_language=>'de'
,p_message_text=>'Dateiname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669474776303225)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Dateinamen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912107075303426)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'de'
,p_message_text=>'Dateiname: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667953966303224)
,p_name=>'FILES'
,p_message_language=>'de'
,p_message_text=>'Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347499840303792)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'de'
,p_message_text=>'%0 Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667419350303223)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'de'
,p_message_text=>'%0 Dateien, %1 K werden verbraucht'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392268434303829)
,p_name=>'FILE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Datei: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98195117290302842)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'de'
,p_message_text=>unistr('Die Textdatei ist so gro\00DF, dass sie nicht bearbeitet werden kann. Um den Inhalt zu \00E4ndern, m\00FCssen Sie die Datei auf Ihrem lokalen Rechner bearbeiten und wieder hochladen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229510740302869)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Keine g\00FCltige Session vorhanden. Eine oder mehrere Dateien wurden hochgeladen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229414213302869)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrend dieser Anforderung wurden mehr Dateien hochgeladen als die Anzahl der auf der Seite definierten Dateielementtypen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719958748303271)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Meinen Workspace suchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200548133302846)
,p_name=>'FIND_TABLES'
,p_message_language=>'de'
,p_message_text=>'Tabellen suchen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427628316303859)
,p_name=>'FINISH'
,p_message_language=>'de'
,p_message_text=>'Fertigstellen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572538885303146)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Erster Eintrag'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725699195303276)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'de'
,p_message_text=>unistr('Korrektur \00FCberf\00E4llig')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642003430303200)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'de'
,p_message_text=>'Fest in Entwicklung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660347712303214)
,p_name=>'FOCUS_AREA'
,p_message_language=>'de'
,p_message_text=>'Fokusbereich'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443001929303043)
,p_name=>'FOOTER'
,p_message_language=>'de'
,p_message_text=>'Footertext'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182216483302832)
,p_name=>'FORM'
,p_message_language=>'de'
,p_message_text=>'Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390972228303828)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'de'
,p_message_text=>'Formatmaske: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724202078303275)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'de'
,p_message_text=>'Formular und Listenansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724394103303275)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht mit Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560223231303137)
,p_name=>'FORM_ON'
,p_message_language=>'de'
,p_message_text=>'Formular in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301708080302928)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703529086303257)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Die Form f\00FCr eine Abfrage wurde erfolgreich erstellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703816908303257)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Form und der Bericht basierend auf einer Webservicereferenz wurden erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701110707303255)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Form wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703668424303257)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Zusammenfassungsseite wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703269216303256)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die auf einer Tabelle basierende Form wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703737741303257)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die auf einer Webservicereferenz basierende Form wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250978726302886)
,p_name=>'FORWARD'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760746511303306)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'de'
,p_message_text=>'von Attribut-Dictionary'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389268986302999)
,p_name=>'FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650568798303207)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('Funktional vollst\00E4ndig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640381199303199)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'de'
,p_message_text=>'Funktionsimplementierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444660113303044)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390650030303000)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700888632303254)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der einen Ref-Cursor zur\00FCckgibt')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693957701303249)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der einen booleschen Wert zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249707581302885)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktion, die Boolean zur\00FCckgibt')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687652503303242)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'de'
,p_message_text=>unistr('Zuk\00FCnftige Meilensteine')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340161657303786)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'de'
,p_message_text=>'Baselinedatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340063670303785)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'de'
,p_message_text=>'Baselineende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339944125303785)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'de'
,p_message_text=>'Baselinestart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693556850303248)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'de'
,p_message_text=>'Enddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693452658303248)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927595418303439)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'de'
,p_message_text=>'Aufgabe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339631993303785)
,p_name=>'GANTT_DATE'
,p_message_language=>'de'
,p_message_text=>'Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339525022303785)
,p_name=>'GANTT_END'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339711581303785)
,p_name=>'GANTT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339831675303785)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'Fortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339358231303785)
,p_name=>'GANTT_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339467093303785)
,p_name=>'GANTT_START'
,p_message_language=>'de'
,p_message_text=>'Start'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124949300303604)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'de'
,p_message_text=>'Tabellenstatistik erfassen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643121746303201)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'de'
,p_message_text=>'Allgemeiner Kommentar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993840533303499)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'de'
,p_message_text=>'Allgemeine Kommentare: %1 von %0 geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254845038302889)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'de'
,p_message_text=>'Diese Tabelle wurde mit dem Tabellenassistenten erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339292281302956)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen gespeichert.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98649184291303206)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'de'
,p_message_text=>'Statische Werteliste erstellen oder bearbeiten'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662422408303216)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'de'
,p_message_text=>' Beauftragter Globalization'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660653456303214)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'de'
,p_message_text=>'Globalization-Auswirkung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663409431303216)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'de'
,p_message_text=>'Globalization-Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183405280302833)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'de'
,p_message_text=>'Globale Seite'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708057219303261)
,p_name=>'GRAY_TEXT'
,p_message_language=>'de'
,p_message_text=>'Grauer Text'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682913912303238)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'de'
,p_message_text=>'Layoutspalten ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682889774303238)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'de'
,p_message_text=>'Layoutspalten anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281517635302911)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Grid-Template'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625043590303187)
,p_name=>'GROUPS'
,p_message_language=>'de'
,p_message_text=>'Gruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817500550303350)
,p_name=>'GROUP_LABEL'
,p_message_language=>'de'
,p_message_text=>'Gruppe: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98442944817303043)
,p_name=>'HEADER'
,p_message_language=>'de'
,p_message_text=>'Headertext'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817339713303350)
,p_name=>'HEADING_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387989278303825)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Hilfe-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391076451303000)
,p_name=>'HELP_TEXT'
,p_message_language=>'de'
,p_message_text=>'Hilfetext'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486083531303078)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgeblendet und gesch\00FCtzt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644214414303202)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4u\00DFerst w\00FCnschenswert')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346970415303791)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'de'
,p_message_text=>'Hoher Kontrast'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108535675303591)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'de'
,p_message_text=>unistr('Umschalter f\00FCr Hoher Kontrast')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624838543303187)
,p_name=>'HISTORY'
,p_message_language=>'de'
,p_message_text=>'Historie'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700621549303254)
,p_name=>'HOME_LINK'
,p_message_language=>'de'
,p_message_text=>'Home-Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179335274302830)
,p_name=>'HOME_NAV'
,p_message_language=>'de'
,p_message_text=>'Oracle APEX Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232119411302871)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'de'
,p_message_text=>'Benutzer:'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418067649303023)
,p_name=>'HORIZONTAL'
,p_message_language=>'de'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164602206302818)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Horizontale 2D-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164765253302818)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Horizontale 3D-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164814780302818)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Horizontale 2D-Bereichsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98164987863302819)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Horizontale 3D-Bereichsspalte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387312884303824)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Hot Template'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222574523302864)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Sperre von HR-Account wurde aufgehoben.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392156012303001)
,p_name=>'HTML'
,p_message_language=>'de'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411140380303018)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'HTML mit Shortcuts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410822722303017)
,p_name=>'HTML_BODY'
,p_message_language=>'de'
,p_message_text=>'HTML-Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253439147302888)
,p_name=>'HTML_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('HTML-Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262882062302896)
,p_name=>'HTML_CHART'
,p_message_language=>'de'
,p_message_text=>'HTML-Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443245423303043)
,p_name=>'HTML_HEADER'
,p_message_language=>'de'
,p_message_text=>'HTML-Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262998979302897)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'de'
,p_message_text=>'HTML/Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390786136303000)
,p_name=>'HTML_TEXT'
,p_message_language=>'de'
,p_message_text=>'HTML-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263013279302897)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'HTML-Text (mit Shortcuts)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387515433303824)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'de'
,p_message_text=>'Symbol-CSS-Klassen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323262730303771)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'de'
,p_message_text=>'Gibt an, dass das Thema IE 6-kompatibel ist.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730311815303280)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten zulassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730497972303280)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Schreibgesch\00FCtzt')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392383330303001)
,p_name=>'IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933120860303444)
,p_name=>'IMAGES'
,p_message_language=>'de'
,p_message_text=>'Bilder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376768076302988)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Bildattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700027949303254)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('Bildpr\00E4fix')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637930345303197)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Import aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399298932303835)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'de'
,p_message_text=>unistr('Neuer Wert f\00FCr Ersetzungszeichenfolge %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867821218303390)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die importierte Datei befindet sich im <a href="%0">Export-Repository</a>. Entfernen Sie diese Datei, sofern Sie nicht eine erneute Installation beabsichtigen.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573433271303147)
,p_name=>'IN/OUT'
,p_message_language=>'de'
,p_message_text=>'In/Out'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189903700302838)
,p_name=>'INACTIVE'
,p_message_language=>'de'
,p_message_text=>'Inaktiv'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772375977303315)
,p_name=>'INCLUDE'
,p_message_language=>'de'
,p_message_text=>'Aufnehmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391855260303828)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Einbeziehen: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389380399302999)
,p_name=>'INDEX'
,p_message_language=>'de'
,p_message_text=>'Index'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769798393303313)
,p_name=>'INDEX_NOUN'
,p_message_language=>'de'
,p_message_text=>'Index'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333743287302952)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547794424303127)
,p_name=>'INLINE'
,p_message_language=>'de'
,p_message_text=>'Inline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337283691303783)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Inline-Hilfetemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547666555303127)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Inline und in Benachrichtigung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693665672303248)
,p_name=>'INPUT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Eingabetyp'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390088252302999)
,p_name=>'INSERT'
,p_message_language=>'de'
,p_message_text=>unistr('einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779139749303320)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Ausnahme beim Einf\00FCgen in wwv_flow_companies:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709770286303262)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'de'
,p_message_text=>'CSS (Anwendung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709548225303262)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild (Anwendung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709986121303262)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'de'
,p_message_text=>'Statische Datei (Anwendung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218880382302861)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Erstelloptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276374863302907)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen die folgenden Erstelloptionen einbeziehen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218716672302861)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Anwendungsbezogene Ersetzungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276298606302907)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen die folgenden Attribute der Anwendung konfigurieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219087099302861)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'de'
,p_message_text=>unistr('Installationsbest\00E4tigung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276508663302907)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen Sie, dass Sie die unterst\00FCtzenden Objekte dieser Anwendung installieren m\00F6chten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219408233302861)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'de'
,p_message_text=>unistr('Deinstallationsbest\00E4tigung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98194044580302841)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'de'
,p_message_text=>'Deinstall-Skript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219566020302861)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Deinstallation - Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276811807302908)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Deinstallation abgeschlossen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563755909303140)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fehler bei der Ausf\00FChrung der Installationspr\00FCfung "%0":'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563827491303140)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fehler bei der Ausf\00FChrung des Installationsskripts "%0":'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218677113302860)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei Pr\00FCfung von Vorhandensein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219259840302861)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'de'
,p_message_text=>'Post-Installation - Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276752872302908)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Installation der Datenbankobjekte und Seed-Daten nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626130099303188)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Das Anwendungsinstallationsprogramm hat ermittelt, dass die unterst\00FCtzenden Objekte dieser Anwendung zuvor installiert wurden. Bevor diese Anwendung installiert werden kann, m\00FCssen die Objekte mit SQL Workshop entfernt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219389974302861)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'de'
,p_message_text=>'Lizenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214592988302857)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214430514302857)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219174481302861)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Post-Installation - Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276666717302908)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre unterst\00FCtzenden Objekte wurden installiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315682502302939)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen Sie, dass Sie bei den unterst\00FCtzenden Objekten dieser Anwendung ein Upgrade ausf\00FChren m\00F6chten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315519108302939)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Das Upgrade der unterst\00FCtzenden Objekte dieser Anwendung wurde nicht erfolgreich ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315105333302938)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Das Anwendungsinstallationsprogramm hat ermittelt, dass die unterst\00FCtzenden Objekte dieser Anwendung zuvor installiert wurden. Dieser Assistent unterst\00FCtzt Sie beim Upgrade dieser unterst\00FCtzenden Objekte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315432334302939)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Die unterst\00FCtzenden Objekte dieser Anwendung wurden installiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218907068302861)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Validierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276431560302907)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden Validierungen werden durchgef\00FChrt, um sicherzustellen, dass das System mit dieser Anwendung kompatibel ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218512190302860)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'de'
,p_message_text=>'Willkommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98276134444302907)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Anwendungsinstallationsprogramm f\00FChrt Sie durch den Prozess zum Erstellen von Datenbankobjekten und Seed-Daten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709608326303262)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'de'
,p_message_text=>'CSS (Workspace)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709447905303262)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'de'
,p_message_text=>'Bild (Workspace)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709883783303262)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'de'
,p_message_text=>'Statische Datei (Workspace)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206801946302851)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'App installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710049594303262)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'de'
,p_message_text=>'Beispielanwendung installieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107948440303591)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'de'
,p_message_text=>'Oracle APEX Administration Services-Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757239438303303)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Instanzeinstellungen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659243075303213)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Instanz wird im manuellen Provisioning-Modus ausgef\00FChrt. Daher werden keine Serviceanforderungen akzeptiert.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752398913303299)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'de'
,p_message_text=>'Nicht ausreichend Speicherplatz zur Installation dieser Anwendung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640480162303199)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Integration abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645630267303203)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'de'
,p_message_text=>'Abmeldung Integration'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636177188303195)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'de'
,p_message_text=>'Interaktives Grid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411802282303018)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'de'
,p_message_text=>'Interaktiver Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665611857303222)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'de'
,p_message_text=>'Interaktive Berichtsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230837628302870)
,p_name=>'INTERNAL'
,p_message_language=>'de'
,p_message_text=>'Intern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183166220302833)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'de'
,p_message_text=>'Interne Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232595764302872)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'de'
,p_message_text=>'Intern'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559864553303137)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Ein g\00FCltiger Name muss eingegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189899101302838)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'de'
,p_message_text=>unistr('Die Datei ist kein g\00FCltiges Anwendungsarchiv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560320508303137)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Ein g\00FCltiger Gruppenname muss eingegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251675998302887)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'de'
,p_message_text=>unistr('Das Objekt %0 ist ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913570082303427)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Ein g\00FCltiger Seitengruppename muss eingegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428184471303859)
,p_name=>'INVALID_POSITION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Position [Nicht wiedergegeben]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778847902303320)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Schemanname')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692670636303247)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'de'
,p_message_text=>unistr('Der ung\00FCltige Wert f\00FCr den Eintrag muss eine Zahl sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376915982303816)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zeichenfolgen waren ung\00FCltige Benutzernamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778718694303320)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Workspace-Name')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719387652303270)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Websheet-Objekte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717268551303269)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Websheet-Objekte korrigiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719464539303271)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Die Datenbankobjekte, die f\00FCr das Erstellen von Websheet-Anwendungen erforderlich sind, sind entweder ung\00FCltig oder nicht vorhanden. Wenden Sie sich an den Workspace-Administrator.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165000717302819)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'de'
,p_message_text=>'Inverse 2D-Linie'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641940503303200)
,p_name=>'IN_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'In Bearbeitung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337781740302955)
,p_name=>'IR_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten von interaktivem Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586154964303157)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'de'
,p_message_text=>'Entwickler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586093539303157)
,p_name=>'IR_END_USER'
,p_message_language=>'de'
,p_message_text=>'Endbenutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586431175303157)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'de'
,p_message_text=>'Interaktiver Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562517030303139)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'de'
,p_message_text=>'Ein interaktiver Bericht kann pro Seite angezeigt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586201743303157)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'de'
,p_message_text=>unistr('Dieser Dialog wird nur f\00FCr Entwickler angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585964055303157)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'de'
,p_message_text=>'Bericht speichern *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586359983303157)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'de'
,p_message_text=>'Speichern *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391496594303828)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'de'
,p_message_text=>'Anwendung: %0, Seite: %1, Abonniert von: %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705245255303258)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Seite "Interaktiver Bericht" wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98586589950303157)
,p_name=>'IR_UNITS'
,p_message_language=>'de'
,p_message_text=>'Einheiten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126634081303606)
,p_name=>'ISSUES'
,p_message_language=>'de'
,p_message_text=>unistr('Vorg\00E4nge')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574175918303148)
,p_name=>'IS_WRAPPED'
,p_message_language=>'de'
,p_message_text=>'ist mit Wrapper konvertiert'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685385117303240)
,p_name=>'ITEM CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263256337302897)
,p_name=>'ITEM NAME'
,p_message_language=>'de'
,p_message_text=>'Objektname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230570702302870)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Elementschaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412127865303846)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'de'
,p_message_text=>'Aktueller Elementspaltenbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250037596302886)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'de'
,p_message_text=>'Wert von Element in Ausdruck 1 ist gleich Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98250150708302886)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'de'
,p_message_text=>'Wert von Element in Ausdruck 1 ist NICHT gleich Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249686897302885)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Element in Ausdruck 1 ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249536596302885)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'de'
,p_message_text=>'Element in Ausdruck 1 ist NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390698469303827)
,p_name=>'ITEM_LABEL'
,p_message_language=>'de'
,p_message_text=>'Element: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307751876302933)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'de'
,p_message_text=>'Datumsauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307897425302933)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650640082303207)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('Textfeld mit automatisch vervollst\00E4ndigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936336826303447)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306048645303756)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'de'
,p_message_text=>'Farbauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765946700303310)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'de'
,p_message_text=>'Datumsauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928520327303440)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'de'
,p_message_text=>'Datumsauswahl (klassisch)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175206480302827)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'de'
,p_message_text=>'Datumsauswahl (HTML5)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98970753204303479)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930075420303442)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'de'
,p_message_text=>'Nur anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969584752303478)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'de'
,p_message_text=>'Datei durchsuchen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305866809303756)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976476627303484)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'de'
,p_message_text=>'Listen-Manager'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992665919303498)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'de'
,p_message_text=>'Markdown-Editor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920414912303433)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'de'
,p_message_text=>'Zahlenfeld '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921987442303435)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'de'
,p_message_text=>'Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929286958303441)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936228633303447)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'de'
,p_message_text=>'Optionsgruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682112900303237)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'de'
,p_message_text=>'Rich Text-Editor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928617691303440)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'de'
,p_message_text=>'Auswahlliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930679019303442)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'de'
,p_message_text=>'Shuttle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196342992302843)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'de'
,p_message_text=>'Schieberegler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307966823302933)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'de'
,p_message_text=>'Grid-Layout stoppen und starten (verworfen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684168949303239)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'de'
,p_message_text=>'Textbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305986885303756)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'de'
,p_message_text=>'Textfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196087022302843)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'de'
,p_message_text=>'Ja/Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257508437302892)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'de'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308056878302933)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945377395303454)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'de'
,p_message_text=>'Sternebewertung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308195931302933)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345535712303790)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Post-Textelement-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345495645303790)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Pre-Textelement-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710696267303263)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'de'
,p_message_text=>'Zeile 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710794827303263)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'de'
,p_message_text=>'Zeile 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710843449303263)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'de'
,p_message_text=>'Zeile 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710900724303263)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'de'
,p_message_text=>'Zeile 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920346139303433)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Eingegebener H\00F6chstwert %0 f\00FCr Element %1 ist nicht numerisch. Wenn der Wert Dezimalstellen enth\00E4lt, geben Sie einen Punkt als Dezimalzeichen an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920207087303433)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Eingegebener Mindestwert %0 f\00FCr Element %1 ist nicht numerisch. Wenn der Wert Dezimalstellen enth\00E4lt, geben Sie einen Punkt als Dezimalzeichen an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196241938302843)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Eingegebener Schrittwert %0 f\00FCr Element %1 ist nicht numerisch. Wenn der Wert Dezimalstellen enth\00E4lt, geben Sie einen Punkt als Dezimalzeichen an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257969111302892)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258088180302892)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'de'
,p_message_text=>'Datei durchsuchen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258111852302892)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258276051302892)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgeblendet und gesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258338132302892)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'de'
,p_message_text=>'Popup-Farbauswahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258436303302892)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'de'
,p_message_text=>'Textfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258544201302893)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'de'
,p_message_text=>'Textfeld (deaktiviert, Zustand wird nicht gespeichert)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258649638302893)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'de'
,p_message_text=>'Textfeld (deaktiviert, Zustand wird gespeichert)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258716717302893)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'de'
,p_message_text=>unistr('Textfeld (leitet nach dem Dr\00FCcken der EINGABETASTE die Seite immer weiter)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635950583303195)
,p_name=>'JET_CHART'
,p_message_language=>'de'
,p_message_text=>'JET-Diagramm'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571384322303146)
,p_name=>'JOB'
,p_message_language=>'de'
,p_message_text=>'Job'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637173040303196)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'de'
,p_message_text=>'Spalte ein-/ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637077452303196)
,p_name=>'JQM REFLOW'
,p_message_language=>'de'
,p_message_text=>'Reflow-Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712612777303265)
,p_name=>'JQM_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712542070303265)
,p_name=>'JQM_HEADER'
,p_message_language=>'de'
,p_message_text=>'Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639057758303198)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'de'
,p_message_text=>'Listenansicht'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636295905303195)
,p_name=>'JSTREE'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Baum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662358508303215)
,p_name=>'JUSTIFICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Begr\00FCndung')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126721823303606)
,p_name=>'LABELS'
,p_message_language=>'de'
,p_message_text=>'Labels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412085389303846)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'de'
,p_message_text=>'Aktueller Labelspaltenbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405609270303840)
,p_name=>'LABEL_ID'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Elementlabel-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699187776303253)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Labeltemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364140841302975)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364272610302975)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'de'
,p_message_text=>'Dies ist die "Master"-Kopie des Templates.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364480212302975)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine Templates abonnieren dieses Template.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98364386135302975)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Labeltemplates, die dieses Template abonnieren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207337534302851)
,p_name=>'LANGUAGES'
,p_message_language=>'de'
,p_message_text=>'Sprachen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665144960303221)
,p_name=>'LAST_CHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Letzte \00C4nderung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572664413303147)
,p_name=>'LAST_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Letzter Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668017858303224)
,p_name=>'LAST_LOGIN'
,p_message_language=>'de'
,p_message_text=>'Letzte Anmeldung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184784404302834)
,p_name=>'LAYOUT'
,p_message_language=>'de'
,p_message_text=>'%0 - Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221759878302863)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'de'
,p_message_text=>'Nach Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561028279303138)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'de'
,p_message_text=>'After Error-Seitenheader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560770351303137)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Nach Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627086382303188)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'de'
,p_message_text=>'Nach Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975686144303483)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'de'
,p_message_text=>'Nach Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910246371303425)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'de'
,p_message_text=>'Nach Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910658033303425)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'de'
,p_message_text=>'Nach Label und Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312027902302936)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'de'
,p_message_text=>'Nach Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551566189303130)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Nach der Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560580514303137)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'de'
,p_message_text=>'Nach Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560832888303137)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Nach Weiterleitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221618868302863)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'de'
,p_message_text=>'Vor Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551209417303130)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Vor der Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561180436303138)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Vor Fehler-Seitenfooter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560682533303137)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Vor Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551149648303130)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'de'
,p_message_text=>'Vor Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975530922303483)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Vor Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910144208303425)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Vor Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910510783303425)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'de'
,p_message_text=>'Vor Label und Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551426671303130)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Vor der Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560483712303137)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'de'
,p_message_text=>'Vor Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551357213303130)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Vor der Validierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620754671303183)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'de'
,p_message_text=>'Verzweigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302739341302929)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber dem Feld')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302843219302929)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'de'
,p_message_text=>'Unter dem Feld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302981358302929)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'de'
,p_message_text=>'Unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303041515302929)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Template \00E4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303170703302929)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Template schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303204047302929)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'de'
,p_message_text=>'Template kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303361708302929)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'de'
,p_message_text=>'Template erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303497021302929)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Template l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303581622302930)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'de'
,p_message_text=>'Template bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303665703302930)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'de'
,p_message_text=>'Template erweitern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303783178302930)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chstes Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303805044302930)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'de'
,p_message_text=>'Vorheriges Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98303913624302930)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543912232303124)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "\00C4ndern"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614622271303179)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763465170303308)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'de'
,p_message_text=>'Reihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543167066303124)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Schlie\00DFen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543688506303124)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Kopieren"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543390155303124)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Erstellen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175442928302827)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763167657303308)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'de'
,p_message_text=>'Falsch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763242892303308)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'de'
,p_message_text=>'Wahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543564998303124)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "L\00F6schen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980073162303487)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'de'
,p_message_text=>'Leeres Label - #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387647632303824)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Fehlertemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543281242303124)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Anzeigen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485250854303077)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion, die eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763574942303308)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'de'
,p_message_text=>'Globale Seite:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543482191303124)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Hilfe"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975793492303484)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'de'
,p_message_text=>'Link zu Elementhilfe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980197880303487)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendet - #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485153556303077)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'de'
,p_message_text=>'HTML-Text (Escape bei Sonderzeichen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337104552303783)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'de'
,p_message_text=>'Inline-Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345790305303790)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'de'
,p_message_text=>'Post-Textelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345696919303790)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'de'
,p_message_text=>'Pre-Textelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543747271303124)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Weiter"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620670514303183)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'de'
,p_message_text=>'Keine Region am Anzeigepunkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763675721303308)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenelemente und Schaltfl\00E4chen ohne Region')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653362734303209)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'de'
,p_message_text=>'Ajax Callbacks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910459558303425)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'de'
,p_message_text=>'Bei einem Fehler - Nach Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910371472303425)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Bei einem Fehler - Vor Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553696470303132)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'de'
,p_message_text=>'Bei neuer Instanz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98553778315303132)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Beim Weiterleiten und vor der Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543858173303124)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Zur\00FCck"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763841517303308)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98152872544302808)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'de'
,p_message_text=>'Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763928304303308)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'de'
,p_message_text=>'Body {#0}'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98764023271303308)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'de'
,p_message_text=>'Position #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763382131303308)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766245278303310)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485380156303077)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'de'
,p_message_text=>'Einfaches Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485689251303077)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'de'
,p_message_text=>'Strukturierte Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766168277303310)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'de'
,p_message_text=>'Weiterleiten als "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637676059303197)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'de'
,p_message_text=>'Teilregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485528233303077)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'de'
,p_message_text=>'SVG-Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270354385302903)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'de'
,p_message_text=>'Von &PRODUCT_NAME. verwendete kaskadierende Dateien.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270730696302903)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'de'
,p_message_text=>'Von &PRODUCT_NAME. verwendete JavaScript-Dateien und Code.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389703587303826)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'de'
,p_message_text=>unistr('CSS-Dateien auf Benutzeroberfl\00E4chenebene definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270959021302903)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Dateien, die auf Benutzeroberfl\00E4chenebene definiert sind')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716428479303268)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'de'
,p_message_text=>unistr('Dialogattribute zur Definition von Dialogattributen, die nicht deklarativ unterst\00FCtzt werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338882097303784)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'de'
,p_message_text=>'Dialog CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716031739303268)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'de'
,p_message_text=>unistr('Dialogh\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716287734303268)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'de'
,p_message_text=>'Maximale Dialogbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716110596303268)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'de'
,p_message_text=>'Dialogbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410598654303844)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'de'
,p_message_text=>unistr('Label f\00FCr "Navigation einblenden/ausblenden"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410600350303845)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'de'
,p_message_text=>unistr('Label f\00FCr "Rechte Spalte einblenden/ausblenden"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380006074303818)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'de'
,p_message_text=>'Favicons-HTML-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270679120302903)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrend des Betriebs von Komponenten erstellte CSS-Dateien')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271061167302903)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrend des Betriebs von Komponenten erstellter JavaScript-Code')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716393654303268)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'de'
,p_message_text=>'Dialogseitenmodus (Beispiel: ''True'' bei modal, ''False'' bei nicht modal)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270591514302903)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'de'
,p_message_text=>'Auf Seitenebene definierte CSS-Dateien und Inlinestyle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264243512302898)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'de'
,p_message_text=>'Seiten-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919646687303432)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'de'
,p_message_text=>'Auf Seitenebene definierte JavaScript-Dateien und Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182445305302832)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'de'
,p_message_text=>'Statische Seiten-ID (Beispiel: "P100")'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178872757302830)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergang zur Navigation zu einer neuen Seite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715973151303268)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'de'
,p_message_text=>'Seiten-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178984343302830)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergang zum \00D6ffnen eines Popups.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719160098303270)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'de'
,p_message_text=>'Seiten-URL, die vom Browser angefordert wurde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389998538303827)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC (Seitlich)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270441944302903)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'de'
,p_message_text=>'Im Template definierte CSS-Dateien und Inlinestyle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270872056302903)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'de'
,p_message_text=>'Im Template definierte JavaScript-Dateien und Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271174840302903)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'de'
,p_message_text=>'CSS-Stylesheet-Dateien auf Theme-Ebene definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398742913303834)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'de'
,p_message_text=>'Auf Theme-Ebene definierte JavaScript-Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398810382303834)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'de'
,p_message_text=>'CSS-Dateien auf Theme-Formatvorlagenebene definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389871263303827)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC (Oben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716543301303268)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'de'
,p_message_text=>unistr('Ausl\00F6sendes Element (Beispiel: das aktuelle DOM-Element)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329515057302949)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919764529303432)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'de'
,p_message_text=>'Betroffene Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326561274302947)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'de'
,p_message_text=>'Anwendungsregisterkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322543156302944)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'de'
,p_message_text=>'Inaktiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326172573302947)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Body-\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321980918302943)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'de'
,p_message_text=>'Verzweigung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322645750302944)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che erstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325204475302946)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324300289302945)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326690447302947)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'de'
,p_message_text=>'Workspace-Bilder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321758503302943)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Berechnung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324943251302946)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'de'
,p_message_text=>'Kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324102403302945)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'de'
,p_message_text=>'Erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324290158302945)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'de'
,p_message_text=>'Erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324841991302946)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323990074302945)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324009141302945)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324669264302945)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Formular schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324595127302945)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('Formular \00F6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325701076302946)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Globale Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324797682302946)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322727444302944)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'de'
,p_message_text=>'Element erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325525083302946)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325003872302946)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325623400302946)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326472131302947)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkarten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325124930302946)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321686411302943)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Prozess erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321562679302943)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'de'
,p_message_text=>'Region erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98324448411302945)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'de'
,p_message_text=>'Regions-Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326281522302947)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'de'
,p_message_text=>'Regionsposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323836504302945)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Regions\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326341179302947)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'de'
,p_message_text=>'Registerkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325948851302946)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Erfolgsmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325815245302946)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'de'
,p_message_text=>'Template-Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326086900302946)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321833266302943)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Validierung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321477970302943)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766817978303311)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387137219303824)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadlabel (HTML-Zeichen werden maskiert)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977430670303485)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'de'
,p_message_text=>'When-Ereignis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327051860302947)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'de'
,p_message_text=>'Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214334283302857)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'de'
,p_message_text=>'Verzweigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319819578302942)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'de'
,p_message_text=>'Verzweigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768210736303312)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'de'
,p_message_text=>'Verzweigungsaktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304345997302930)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Verzweigung zu Funktion, die eine Seite zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304415329302930)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'de'
,p_message_text=>unistr('Verzweigung zu Funktion, die eine URL zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304055446302930)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zu PAGE ACCEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304108178302930)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zu Seite, angegeben von Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330052435302949)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'de'
,p_message_text=>'Gehe zu Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304554214302930)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zu PL/SQL-Prozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304241564302930)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'de'
,p_message_text=>'Verzweigung zu URL, angegeben von Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766994957303311)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'de'
,p_message_text=>'Erstelloption'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318520083302941)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329936448302949)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767653333303311)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chenaktion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945898919303455)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'de'
,p_message_text=>unistr('Validierungen ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323411327302945)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen ohne Regionen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768001354303312)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'de'
,p_message_text=>'Diagrammabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767975513303311)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386910384303824)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'de'
,p_message_text=>'Komponenten-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318710918302941)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Berechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330626756302950)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'de'
,p_message_text=>'Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318804429302941)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite 0 unterst\00FCtzt keine Berechnungen. Berechnungen, die auf jeder Seite auftreten sollen, m\00FCssen von Berechnungen auf Anwendungsebene verarbeitet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767375698303311)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'de'
,p_message_text=>'Berechnungstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329662782302949)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'de'
,p_message_text=>'Bedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766653673303310)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'de'
,p_message_text=>'Ausdruck 1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766701646303311)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'de'
,p_message_text=>'Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766516343303310)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'de'
,p_message_text=>'Bedingungstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316837414302940)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'de'
,p_message_text=>'Kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316664379302940)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'de'
,p_message_text=>'Erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385088821303822)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'de'
,p_message_text=>unistr('Text, der von der internen <em>APEX.CURRENT_PROGRESS</em>-Textnachricht abgeleitet wird (entspricht standardm\00E4\00DFig <em>Aktueller Fortschritt</em>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327542926302948)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329889308302949)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767702143303311)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'de'
,p_message_text=>'Anzeigen als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318338828302941)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'de'
,p_message_text=>'Anzeigepunkt:&nbsp;'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315926018303765)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316787851302940)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214291320302857)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'de'
,p_message_text=>'Seiten in Builder bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301910194302928)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Regionsattribute bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302580319302929)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldungsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329720518302949)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'de'
,p_message_text=>'Exp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321319095302943)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'de'
,p_message_text=>'Keine Verzweigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321065004302943)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Keine Berechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320883512302943)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Seite ausgew\00E4hlt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321112363302943)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Keine Prozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320935474302943)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'de'
,p_message_text=>'Keine Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98321278954302943)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Keine Validierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327169032302947)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Footer-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328412684302948)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('HTML-Formular schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327923219302948)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('HTML-Formular \00F6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327492868302947)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'de'
,p_message_text=>'Von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319346892302942)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Die globale Seite unterst\00FCtzt keine Verzweigungen, Berechnungen, Prozesse oder Validierungen. Berechnungen und Prozesse, die auf jeder Seite auftreten sollen, m\00FCssen von Berechnungen und Prozessen auf Anwendungsebene verarbeitet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979809134303487)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'de'
,p_message_text=>'Grid-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698735061303253)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'de'
,p_message_text=>'Grid-Spaltenanzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326972987302947)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Headertemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302348100302929)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'de'
,p_message_text=>'Inline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302221565302929)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Inline+Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317589051302940)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318626603302941)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'de'
,p_message_text=>'Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650778207303207)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323747540302945)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'de'
,p_message_text=>unistr('Elementanzahl \00FCberschreitet das Maximum von 200.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767858799303311)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188028183302837)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'de'
,p_message_text=>'Listen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371308052303811)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Listen-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302658083302929)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346639577302962)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'de'
,p_message_text=>'Wertelisten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187916678302837)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'de'
,p_message_text=>'Navigationspfade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979935966303487)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330253483302950)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'de'
,p_message_text=>'Navigiert zur Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320520679302942)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645749908303203)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304947872302931)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698409467303252)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'de'
,p_message_text=>'Neues Grid starten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698647872303252)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Neue Grid-Spalte starten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698594346303252)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'de'
,p_message_text=>'Neue Grid-Zeile starten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326851086302947)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304645201302930)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'de'
,p_message_text=>'Kein Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302437030302929)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328088126302948)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319992162302942)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'de'
,p_message_text=>'Seite "%0" hat keine Verzweigungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323531818302945)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Seite "%0" hat keine Schaltfl\00E4chen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323689401302945)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'de'
,p_message_text=>'Seite "%0" hat keine Elemente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188205481302837)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'de'
,p_message_text=>'Keine Listen verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346782882302962)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'de'
,p_message_text=>'Es werden keine gemeinsam verwendeten Wertelisten verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188366709302837)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'de'
,p_message_text=>'Keine Navigationspfade verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320603121302943)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'de'
,p_message_text=>'Die Anwendung "%0" hat keine Navigationsleiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319071260302941)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Die Seite "%0" hat keine onLoad-Berechnungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319231881302941)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Die Seite "%0" hat keine onLoad-Prozesse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319492545302942)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Die Seite "%0" hat keine onSubmit-Berechnungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319721896302942)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Die Seite "%0" hat keine onSubmit-Prozesse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316444519302939)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Seite ausgew\00E4hlt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320196412302942)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Registerkarten der \00FCbergeordneten Ebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318460708302941)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'de'
,p_message_text=>'Seite "%0" hat keine Regionen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320478407302942)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die Seite %0 ist keine Registerkarte festgelegt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346887036302962)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Keine Templates verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319677974302942)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Seite "%0" hat keine Validierungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98302092216302928)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'de'
,p_message_text=>'%0 Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316535065302939)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317320126302940)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Aliasname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317993580302941)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317710552302940)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>'Autorisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328270547302948)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'de'
,p_message_text=>'Seiten-Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328364321302948)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Seiten-Body-\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317820608302940)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'de'
,p_message_text=>'Erstelloption'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327854910302948)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'de'
,p_message_text=>'Seitenheader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317164882302940)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317067258302940)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Seite nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327631689302948)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'de'
,p_message_text=>'Seite Onload'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318069580302941)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318111135302941)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317617310302940)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'de'
,p_message_text=>'Standard-Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317477614302940)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98317221775302940)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327737939302948)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'de'
,p_message_text=>unistr('Seiten\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320039253302942)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkarten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319196100302941)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Prozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330590744302950)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'de'
,p_message_text=>'Prozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318924755302941)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite 0 unterst\00FCtzt keine Prozesse. Prozesse, die auf jeder Seite auftreten sollen, m\00FCssen von Prozessen auf Anwendungsebene verarbeitet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768176819303312)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'de'
,p_message_text=>'Prozesstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330133832302950)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'de'
,p_message_text=>'Gehe zu Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327388785302947)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'de'
,p_message_text=>'Referenziert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387015486303824)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'de'
,p_message_text=>'Referenziert von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98318250395302941)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'de'
,p_message_text=>'Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330980002302950)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639220268303198)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Regionsattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178433051302829)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'de'
,p_message_text=>'Regions-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638017414303197)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Regions-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697384371303251)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'de'
,p_message_text=>'Regionsposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328533816302948)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'de'
,p_message_text=>'Region Position1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632907017303193)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633002488303193)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 11'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633127775303193)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633271836303193)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 13'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633365418303193)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633469297303193)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 15'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633517887303193)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328684839302948)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'de'
,p_message_text=>'Region Position2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328747665302948)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'de'
,p_message_text=>'Region Position3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328855128302948)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'de'
,p_message_text=>'Region Position4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328967959302949)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'de'
,p_message_text=>'Region Position5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329022944302949)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'de'
,p_message_text=>'Region Position6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329191172302949)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'de'
,p_message_text=>'Region Position7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329284065302949)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'de'
,p_message_text=>'Region Position8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98632806429303193)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638196494303197)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'de'
,p_message_text=>'Statische Regions-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979765312303487)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'de'
,p_message_text=>'Regionstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304810417302930)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'de'
,p_message_text=>'Standardbedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320253349302942)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'de'
,p_message_text=>'Standardregisterkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98327245528302947)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'de'
,p_message_text=>'Ersetzung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638885461303198)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Teilregionen - Template f\00FCr Headereintrag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638928161303198)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Teilregionen - Header Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638785916303197)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Teilregionen - Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638571316303197)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'de'
,p_message_text=>'Teilregionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638674137303197)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'de'
,p_message_text=>'Header der Teilregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638448056303197)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge im Header der Teilregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638231615303197)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'de'
,p_message_text=>'Statische ID der Teilregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98638316793303197)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift der Teilregion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98328105467302948)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Erfolgsmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187700050302836)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'de'
,p_message_text=>'Tabellarisches Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320383112302942)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'de'
,p_message_text=>'Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325320935302946)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345926471302961)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322436344302944)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'de'
,p_message_text=>'Verzweigung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322951930302944)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che erstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322196907302944)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Berechnung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323189917302944)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Element erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322235103302944)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Prozess erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322059971302944)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'de'
,p_message_text=>'Region erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322300022302944)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Validierung erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323045725302944)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Bearbeiten, Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323218673302944)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chenelement bearbeiten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98323351961302944)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'de'
,p_message_text=>'Element bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98322846620302944)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'de'
,p_message_text=>unistr('Regions\00FCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767583093303311)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'de'
,p_message_text=>'When-Bedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767445222303311)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'de'
,p_message_text=>'When-Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98304769115302930)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'de'
,p_message_text=>'Ohne Bedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98319522485302942)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Validierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330443166302950)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'de'
,p_message_text=>'Validierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945722239303455)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'de'
,p_message_text=>unistr('Immer ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767122116303311)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'de'
,p_message_text=>'Validierungsausdruck 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767288218303311)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'de'
,p_message_text=>'Validierungsausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98767095172303311)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'de'
,p_message_text=>'Validierungstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316998237302940)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766470550303310)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'de'
,p_message_text=>unistr('Bei geklickter Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98326760517302947)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485433847303077)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'Aktualisierbare SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447410920303047)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Anwendungsstandard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98763770769303308)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'de'
,p_message_text=>'Validieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444477159303044)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487149638303079)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691671535303246)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Bearbeitungsfunktion f\00FCr den LDAP-Benutzernamen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204029680302849)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'de'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98222497300302864)
,p_name=>'LEARN MORE'
,p_message_language=>'de'
,p_message_text=>'Weitere Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340341371302957)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'de'
,p_message_text=>'Weitere Informationen zu Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340103237302957)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'de'
,p_message_text=>'Weitere Informationen zu App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98348984340302964)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'de'
,p_message_text=>'Weitere Informationen zu Page Designer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340230404302957)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'de'
,p_message_text=>unistr('Weitere Informationen zu Produktivit\00E4ts-Apps')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340050425302957)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'Weitere Informationen zu SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945135777303454)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie hier, um Informationen zu Websheets zu erhalten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754242757303301)
,p_name=>'LEFT'
,p_message_language=>'de'
,p_message_text=>'Links'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398655092303834)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'de'
,p_message_text=>unistr('Vorg\00E4ngerkalender')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229148569302869)
,p_name=>'LINES'
,p_message_language=>'de'
,p_message_text=>'Zeilen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994439359303499)
,p_name=>'LINK'
,p_message_language=>'de'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264934500302898)
,p_name=>'LINK$'
,p_message_language=>'de'
,p_message_text=>'Spalten-Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666156051303222)
,p_name=>'LINKS'
,p_message_language=>'de'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392118196303829)
,p_name=>'LINK_LABEL'
,p_message_language=>'de'
,p_message_text=>'Link: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771777948303314)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'de'
,p_message_text=>unistr('Verkn\00FCpfen mit %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98585808101303157)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Links zu diesem Seitenelement %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391901122303001)
,p_name=>'LIST'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690687798303245)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Listenelement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687189362303242)
,p_name=>'LIST OF VALUES'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260452084302895)
,p_name=>'LISTVIEW'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724448077303275)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Form und die Listenansicht wurden erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730877530303281)
,p_name=>'LIST_ENTRY'
,p_message_language=>'de'
,p_message_text=>'Listeneintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430595891303861)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'de'
,p_message_text=>'Listeneintragslabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718963014303270)
,p_name=>'LIST_INITCAP'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835336063303363)
,p_name=>'LIST_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Listenelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635811634303195)
,p_name=>'LIST_REGION'
,p_message_language=>'de'
,p_message_text=>'Listenregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699240563303253)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411620546303018)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447166021303046)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'de'
,p_message_text=>'Listennutzung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724715447303276)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Listenansichtsseiten-Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725036559303276)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'de'
,p_message_text=>'Listenansichtsseiten-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724603659303276)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Seite f\00FCr Listenansicht')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377678445303816)
,p_name=>'LOAD_DATA'
,p_message_language=>'de'
,p_message_text=>'Daten laden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774139823303316)
,p_name=>'LOCK'
,p_message_language=>'de'
,p_message_text=>'Sperren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862166055303385)
,p_name=>'LOCKED'
,p_message_language=>'de'
,p_message_text=>'Gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559937083303137)
,p_name=>'LOCKED BY'
,p_message_language=>'de'
,p_message_text=>'Gesperrt von: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380424820303819)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'de'
,p_message_text=>'%0 von %1 gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380684739303819)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'de'
,p_message_text=>'Skript sperren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98572309309303146)
,p_name=>'LOG'
,p_message_language=>'de'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700143879303254)
,p_name=>'LOGGING'
,p_message_language=>'de'
,p_message_text=>'Logging'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768598428303312)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzernamen speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768670909303312)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen aktivieren, speichert die Anwendung Ihren Benutzernamen in einem dauerhaften Browsercookie namens "LOGIN_USERNAME_COOKIE".'),
unistr('Beim n\00E4chsten Aufruf der Anmeldeseite'),
unistr('wird das Benutzernamenfeld automatisch mit diesem Wert gef\00FCllt.'),
'</p>',
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen deaktivieren und Ihr Benutzername bereits im Cookie gespeichert wurde,'),
unistr('\00FCberschreibt die Anwendung ihn mit einem leeren Wert.'),
unistr('Sie k\00F6nnen auch die Entwicklertools des Browsers verwenden, um das Cookie komplett zu entfernen.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699928386303254)
,p_name=>'LOGIN_URL'
,p_message_language=>'de'
,p_message_text=>'URL der Anmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699807305303253)
,p_name=>'LOGO'
,p_message_language=>'de'
,p_message_text=>'Logo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186208636303652)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'de'
,p_message_text=>'Kein Bild festgelegt.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186395462303653)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'de'
,p_message_text=>'Anwendungslogotext'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184788133303651)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'de'
,p_message_text=>'Anwendungslogo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185260360303652)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Datei \00FCberschreitet den zul\00E4ssigen Grenzwert von %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185784211303652)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'de'
,p_message_text=>'In Application Builder kann ein benutzerdefiniertes Logo-Markup festgelegt werden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185600048303652)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'de'
,p_message_text=>unistr('Dateien per Drag-and-Drop verschieben oder durch Klicken ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185504021303652)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185848484303652)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese App wird kein Logo angezeigt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185481414303652)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'de'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185337968303652)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186012381303652)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diesen Logotyp ist ein Logobild erforderlich.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186143338303652)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Logo erfolgreich gespeichert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185954253303652)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diesen Logotyp ist ein Logotext erforderlich.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185173041303652)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Nur Bilder sind zul\00E4ssig')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366532622303807)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Vielen Dank f\00FCr Ihr Feedback, f\00FCr diesen Vorgang wurde ein Bug erstellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368051492303808)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Vielen Dank f\00FCr Ihr Feedback, diese Anfrage wird in einem zuk\00FCnftigen Release ber\00FCcksichtigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991304285303496)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Vielen Dank f\00FCr Ihr Feedback, in unserem System wurde ein Vorgang geloggt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368269026303809)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Vielen Dank f\00FCr Ihr Feedback, zum Kl\00E4ren dieses Vorgangs wurde eine Aufgabe erstellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396088652303832)
,p_name=>'LOG_IN'
,p_message_language=>'de'
,p_message_text=>'Anmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573202086303147)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'de'
,p_message_text=>'Logintervall'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687098136303242)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'de'
,p_message_text=>'Wertelisten-Elementbedingung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644900175303202)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'de'
,p_message_text=>unistr('Niedrige Priorit\00E4t')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188119458302837)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'de'
,p_message_text=>'Seitengruppen verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836883053303365)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'de'
,p_message_text=>'Service verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836699681303364)
,p_name=>'MANAGE USERS'
,p_message_language=>'de'
,p_message_text=>'Benutzer verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836016897303364)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Workspace verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780575332303321)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Verwalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402138386303010)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Nicht zugeordnete Seiten verwalten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219659147302861)
,p_name=>'MANUAL'
,p_message_language=>'de'
,p_message_text=>'Manuell'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158076637302813)
,p_name=>'MAP_LAYER='
,p_message_language=>'de'
,p_message_text=>'Layer='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159443147302814)
,p_name=>'MAP_LAYERS'
,p_message_language=>'de'
,p_message_text=>'Kartenlayer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305380879302931)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Zuordnung wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644155071303202)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'de'
,p_message_text=>'Laufschriftfeature'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718060353303269)
,p_name=>'MASTER'
,p_message_language=>'de'
,p_message_text=>'Master'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703307481303257)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Master-Detailseiten wurden erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156700662302811)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156900197302812)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'de'
,p_message_text=>'%0 Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156843487302811)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'de'
,p_message_text=>'%0 bearbeiten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769851292303313)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'de'
,p_message_text=>'Materialized View'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665526162303222)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'de'
,p_message_text=>'Maximale Rendering-Zeit (Sekunden)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756749843303303)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'de'
,p_message_text=>'Maximale Session-Leerlaufzeit in Sekunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756866762303303)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'de'
,p_message_text=>'Maximale Sessiondauer in Sekunden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339831677302957)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Das L\00F6schen von Meilensteinen mit verkn\00FCpften Features ist nicht zul\00E4ssig.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232011227302871)
,p_name=>'MEMORY'
,p_message_language=>'de'
,p_message_text=>'Speicher:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390388951303000)
,p_name=>'MENU'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690765641303246)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Navigationspfadelement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699505048303253)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Navigationspfad')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932670428303444)
,p_name=>'MIGRATION FILES'
,p_message_language=>'de'
,p_message_text=>'Migrationsdateien'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686679808303241)
,p_name=>'MILESTONE'
,p_message_language=>'de'
,p_message_text=>'Meilenstein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666693225303223)
,p_name=>'MILESTONES'
,p_message_language=>'de'
,p_message_text=>'Meilensteine'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122983581303603)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'de'
,p_message_text=>'ms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669366393303225)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr MIME-Typ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642631869303201)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'de'
,p_message_text=>'Minimale Auswirkung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207181884302851)
,p_name=>'MIN_VERSION'
,p_message_language=>'de'
,p_message_text=>'Mindestversion'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367108430303808)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'de'
,p_message_text=>'@-Zeichen fehlt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590155887303160)
,p_name=>'MODEL_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644319152303202)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'de'
,p_message_text=>unistr('M\00E4\00DFig w\00FCnschenswert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642520656303200)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'de'
,p_message_text=>unistr('M\00E4\00DFige Auswirkung')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329369870302949)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt ein ge\00E4ndertes Attribut an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770153524303313)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4ndern von Spalte %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98569874956303144)
,p_name=>'MONITOR'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberwachen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836710964303364)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4t \00FCberwachen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695957203303250)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'de'
,p_message_text=>'Weitere...'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665025729303221)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'%0 aktivste Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660001919303214)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'de'
,p_message_text=>'Letzter Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960615822303471)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'de'
,p_message_text=>'Die aktuellste Datei ist %0, hochgeladen von %1 %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428432949303031)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'de'
,p_message_text=>'Fehler in MRU: row= %0, %1, %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427308170303031)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Prim\00E4rschl\00FCsselspalte wurde in der Auswahlliste der Abfrage nicht ermittelt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428581295303031)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'de'
,p_message_text=>unistr('Die aktuelle Version der Daten in der Datenbank wurde ge\00E4ndert, seit der Benutzer einen Update-Prozess eingeleitet hat. Aktuelle Pr\00FCfsumme = "%0" Element-Pr\00FCfsumme = "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426889779303030)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Es sind keine Zeilen f\00FCr die Verarbeitung vorhanden')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344704387302960)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'de'
,p_message_text=>'Vergewissern Sie sich, dass der Dateityp der Berichtslayoutdatei XSL-FO und die Dateierweiterung ''.xsl'' ist.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253660335302888)
,p_name=>'MY_PAGE'
,p_message_language=>'de'
,p_message_text=>'Meine Seite'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366061561303807)
,p_name=>'NAMES'
,p_message_language=>'de'
,p_message_text=>'Namen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774036783303316)
,p_name=>'NAVBAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686897724303241)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Navbar-Element')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369640399303810)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'de'
,p_message_text=>'Zum Anfang gehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684718414303239)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699774272303253)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'de'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187841014302837)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'de'
,p_message_text=>'Navigationsseite'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179245470302830)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'de'
,p_message_text=>'Zur App Builder-Homepage navigieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405848570303840)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'de'
,p_message_text=>'Implementierung: Liste %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405776833303840)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'de'
,p_message_text=>'Implementierung: Klassisch'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655088033303210)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfung erforderlich')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648145787303205)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'de'
,p_message_text=>unistr('Informationen werden ben\00F6tigt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666215635303222)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Neuigkeitseintr\00E4ge')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399523904303835)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Neuer Wert f\00FCr Bind-Variable %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409182963303016)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'de'
,p_message_text=>unistr('Die neue E-Mail-Adresse f\00FCr Ihren Application Express-Account.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643607649303201)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'de'
,p_message_text=>'Neue Featureanforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575868955303149)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'de'
,p_message_text=>'Neu(e) oder vorhanden(e)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751929004303299)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'de'
,p_message_text=>'Neuer Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659358540303213)
,p_name=>'NEW_SERVICE'
,p_message_language=>'de'
,p_message_text=>'Neuer Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390261490303000)
,p_name=>'NEW_TABSET'
,p_message_language=>'de'
,p_message_text=>'Neue Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384843257303822)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'de'
,p_message_text=>unistr('- Kein \00FCbergeordnetes Objekt ausgew\00E4hlt -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696245278303250)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'de'
,p_message_text=>'Neue Worksapce-Anforderung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704411575303258)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'de'
,p_message_text=>'Keine entsprechende Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637720976303197)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die Tabelle sind keine Prim\00E4rschl\00FCssel definiert. Ein Prim\00E4rschl\00FCssel ist erforderlich, wenn Berichte mit Forms erstellt werden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233872690302873)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'de'
,p_message_text=>'Logarchivierung: Aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628939259303190)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'de'
,p_message_text=>'Nicht aktueller Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684590264303239)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'de'
,p_message_text=>'Nicht aktuelle Registerkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689081320303244)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'de'
,p_message_text=>'Keine angegeben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376695134302988)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Bild f\00FCr nicht aktuelles Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753651337303300)
,p_name=>'NON_PACKAGE'
,p_message_language=>'de'
,p_message_text=>unistr('-Keine Produktivit\00E4ts- oder Beispiel-App-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644889804303202)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'de'
,p_message_text=>unistr('Normale Priorit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366648516303807)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392052878303828)
,p_name=>'NOTE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Hinweis: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547893722303127)
,p_name=>'NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641582723303200)
,p_name=>'NOT_A_BUG'
,p_message_language=>'de'
,p_message_text=>'Kein Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398510719303834)
,p_name=>'NOT_CURRENT'
,p_message_language=>'de'
,p_message_text=>'Nicht aktuell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644535438303202)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht w\00FCnschenswert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694112280303249)
,p_name=>'NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Nicht vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249471347302885)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage NOT EXISTS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98641606024303200)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'de'
,p_message_text=>unistr('Behebung nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773884015303316)
,p_name=>'NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405279628303840)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'80 % oder weniger abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706971279303260)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'de'
,p_message_text=>'Nicht installiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390109048303000)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'de'
,p_message_text=>'Nicht in Data Dictionary'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645299385303203)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Priorit\00E4t festgelegt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643076876303201)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'de'
,p_message_text=>'Nicht priorisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689219149303244)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'de'
,p_message_text=>'Nicht bereitgestellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964927275303474)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Nicht erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647947668303205)
,p_name=>'NOT_STARTED'
,p_message_language=>'de'
,p_message_text=>'Nicht gestartet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726401219303277)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('<strong>%0</strong> ist kein g\00FCltiger View-Name.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206690680302851)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Anwendungen gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98710170795303263)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist keine Anwendung ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484705461303077)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Argumente zul\00E4ssig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640667820303199)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'de'
,p_message_text=>unistr('Keine zugewiesene Priorit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252410648302887)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Kein Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689424676303244)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'de'
,p_message_text=>unistr('Es sind keine Queueprozesse f\00FCr den Datenbank-Job verf\00FCgbar. Bitten Sie den Administrator, den Initialisierungsparameter JOB_QUEUE_PROCESSES zu erh\00F6hen, oder warten Sie, bis andere Jobs abgeschlossen sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563338632303139)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Navigationspfad-Templates in Theme gefunden. Mindestens ein Navigationspfad-Template ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563442740303139)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Schaltfl\00E4chen-Templates in Theme gefunden. Mindestens ein Schaltfl\00E4chen-Template ist erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562933810303139)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Kalendertemplates in Theme gefunden. Mindestens ein Kalendertemplate ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338989751302956)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'de'
,p_message_text=>'Kein Datum angegeben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588755202303159)
,p_name=>'NO_DEBUG'
,p_message_language=>'de'
,p_message_text=>'Kein Debuggen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200840273302847)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'de'
,p_message_text=>'Keine Entwicklerberechtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262242938302896)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'de'
,p_message_text=>'- Keine Anzeige -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217335243302859)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'de'
,p_message_text=>'Keine Zielfeatures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560914659303138)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr dieses Seitenelement ist keine Hilfe verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425901734303858)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'de'
,p_message_text=>'Kein Symbol gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311110503302935)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Bilder gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548131866303128)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'de'
,p_message_text=>'Kein Bild gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392534789303002)
,p_name=>'NO_ITEM'
,p_message_language=>'de'
,p_message_text=>'kein Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754140954303300)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'de'
,p_message_text=>unistr('Der Queueprozess f\00FCr den Datenbank-Job ist nicht aktiviert worden. Bitten Sie den Administrator, den Initialisierungsparameter JOB_QUEUE_PROCESSES festzulegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563005624303139)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Labeltemplates in Theme gefunden. Mindestens ein Labeltemplate ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294744683302922)
,p_name=>'NO_LAYOUT'
,p_message_language=>'de'
,p_message_text=>unistr('Kein Berichtslayout ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563209171303139)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Listentemplates in Theme gefunden. Mindestens ein Listentemplate ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643899614303201)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'de'
,p_message_text=>'Kein Vorgang mehr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252276987302887)
,p_name=>'NO_LOV'
,p_message_language=>'de'
,p_message_text=>'Keine Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687711843303242)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'de'
,p_message_text=>'Keine Meilensteine definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914412923303428)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FCliste nicht anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294608635302922)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'de'
,p_message_text=>'Der Entwickler hat keine Berechtigungen zu Erstellen von Komponenten auf dieser Seite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563642176303140)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'de'
,p_message_text=>'Es wurde versucht, das Theme zu kopieren und keine Seitentemplates wurden in Anwendung %0 gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562790051303139)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Seitentemplates in Theme gefunden. Mindestens ein Seitentemplate ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486357455303078)
,p_name=>'NO_PARENT'
,p_message_language=>'de'
,p_message_text=>unistr('Kein \00FCbergeordneter Navigationspfadeintrag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934833903303446)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine \00FCbergeordneten Registerkarten wurden definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695842515303250)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'de'
,p_message_text=>'Keine ausstehenden Anforderungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563524812303140)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Popup-Wertelisten-Templates in Theme gefunden. Mindestens ein Popup-Wertelisten-Template ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645165977303202)
,p_name=>'NO_PRIORITY'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Priorit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732185637303282)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Diese Regionsposition ist nicht in Ihrem Seitentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98562812116303139)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Regionstemplates in Theme gefunden. Mindestens ein Regionstemplate ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563116869303139)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'de'
,p_message_text=>'Keine Berichtstemplates in Theme gefunden. Mindestens ein Bericht-Template ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252368664302887)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'de'
,p_message_text=>'Kein Shortcut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647857554303205)
,p_name=>'NO_STATUS'
,p_message_language=>'de'
,p_message_text=>'Kein Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696480327303251)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'de'
,p_message_text=>'Keine Systemmeldung definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990746422303496)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Anwendung wurden keine Registerkarten definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98935041516303446)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Registerkarten gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932206389303444)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'de'
,p_message_text=>'Es wurden keine Registerkarten definiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98934993446303446)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Registerkarten ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99366431431303807)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Tags gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392482389303002)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Kein Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98484806982303077)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'de'
,p_message_text=>'Kein URL-Zugriff'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976777754303484)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Bevor Sie SQL-Tags verwenden k\00F6nnen, m\00FCssen Sie aus Sicherheitsgr\00FCnden eine Liste zul\00E4ssiger Tabellen definieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642398781303200)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Kein Workaround verf\00FCgbar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388644240302998)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'de'
,p_message_text=>'(null)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773252228303316)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726233947303277)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217206721302859)
,p_name=>'NUM_TOTAL'
,p_message_language=>'de'
,p_message_text=>'%0 gesamt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624723987303187)
,p_name=>'OBJECTS'
,p_message_language=>'de'
,p_message_text=>'Objekte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920135331303433)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Objekte ohne Standardwerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920037231303433)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Objekte mit Standardwerten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391602872303828)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Objekt: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713012887303265)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'de'
,p_message_text=>'kaskadieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654314613303209)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'de'
,p_message_text=>'Der CHECK Constraint muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208403064302852)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'de'
,p_message_text=>'%0 Fehler.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714125986303266)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'de'
,p_message_text=>'Constraint-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714278723303266)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte(n)/\00DCberpr\00FCfung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654189585303209)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'de'
,p_message_text=>'Der Constraint-Name muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654529083303210)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'de'
,p_message_text=>'Constraint-Name wird bereits verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712771419303265)
,p_name=>'OB_FK_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Fremdschl\00FCssel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653767730303209)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>unistr('Der Fremdschl\00FCsselname muss angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654419240303210)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'de'
,p_message_text=>unistr('Der Fremdschl\00FCsselname wird bereits verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712862641303265)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'de'
,p_message_text=>'Referenzierte Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712991007303265)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'de'
,p_message_text=>'Referenzierte Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654052869303209)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Fremdschl\00FCssel-Referenzspalten m\00FCssen ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653943781303209)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Die Fremdschl\00FCssel-Referenztabelle muss ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653801947303209)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Fremdschl\00FCsselspalten m\00FCssen ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774599656303316)
,p_name=>'OB_POSITION'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714342100303266)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'de'
,p_message_text=>unistr('- Datentyp ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713145953303265)
,p_name=>'OB_SET_NULL'
,p_message_language=>'de'
,p_message_text=>'auf Null festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654252345303209)
,p_name=>'OB_UK_COLS'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr den eindeutigen Schl\00FCssel m\00FCssen Spalten angegeben werden.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123171446303603)
,p_name=>'ODG.API.START'
,p_message_language=>'de'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123097103303603)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'de'
,p_message_text=>'%0 nicht behandelte Ausnahme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123223996303603)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'de'
,p_message_text=>'Nicht behandelte integrierte data_source: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124025639303604)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Blueprint nicht gefunden oder nicht erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175631100302827)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'de'
,p_message_text=>'Der Name der Datenquelle darf maximal 26 Zeichen enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175516791302827)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Importieren: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123972289303604)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der INSERT-SELECT-SQL-Anweisung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123401025303603)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'de'
,p_message_text=>'%0 beim Abrufen von JSON-Daten. URL: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99124139940303604)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'de'
,p_message_text=>'INSERT INTO-Skript:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175824104302827)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige integrierte Datenquelle: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123848069303603)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'de'
,p_message_text=>'Fehler: JSON-Daten sind Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123578824303603)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'de'
,p_message_text=>unistr('Kein g\00FCltiges Objekt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123648607303603)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'de'
,p_message_text=>'Fehler. Keine Zeilen angefordert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123355955303603)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Zu viele Zeilen angefordert, maximal sind %0 Zeilen zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99123784443303603)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Unerwarteter Fehler beim Laden von %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98175718266302827)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'de'
,p_message_text=>'%0 muss "Y" oder "N" sein'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253534705302888)
,p_name=>'ONE'
,p_message_language=>'de'
,p_message_text=>'Eins'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206141438302851)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'de'
,p_message_text=>'Nur installierte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443132414303043)
,p_name=>'ON_LOAD'
,p_message_language=>'de'
,p_message_text=>'Beim Laden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98643928728303202)
,p_name=>'OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689516757303244)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'de'
,p_message_text=>unistr('In den letzten 7 Tagen ge\00F6ffnet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688657255303243)
,p_name=>'OPEN_BUGS'
,p_message_language=>'de'
,p_message_text=>'Offene Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688314180303243)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'de'
,p_message_text=>'Offene Features'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922134098303435)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Offen, Feedback wird verarbeitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688536127303243)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'de'
,p_message_text=>'Offene To-dos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295702596302923)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'de'
,p_message_text=>unistr(' Websheet %0 \00F6ffnen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629768478303190)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>'Optionales Attribut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409968891303844)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'de'
,p_message_text=>'Optionale Symbol-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629600620303190)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'de'
,p_message_text=>'Optionales Bild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629888827303190)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Optionale Bildattribute'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932774744303444)
,p_name=>'ORACLE FORMS'
,p_message_language=>'de'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337537566303783)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Oracle REST Data Services-basiertes Drucken ist in Oracle APEX 19.1 veraltet und wird nicht mehr unterst\00FCtzt.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187693965302836)
,p_name=>'OTHER'
,p_message_language=>'de'
,p_message_text=>'Weitere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933370906303445)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'de'
,p_message_text=>'Andere Workspace-Dateien'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682202630303237)
,p_name=>'OTN'
,p_message_language=>'de'
,p_message_text=>'Oracle Technology Network'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682345077303237)
,p_name=>'OTN_FORUM'
,p_message_language=>'de'
,p_message_text=>'Oracle Technology Network - Diskussionsforum'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812336615303346)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'de'
,p_message_text=>'Override-ID'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388474132303825)
,p_name=>'OVERVIEW'
,p_message_language=>'de'
,p_message_text=>'Zusammenfassung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369901533302979)
,p_name=>'OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216987066302859)
,p_name=>'OWNERS'
,p_message_language=>'de'
,p_message_text=>unistr('Eigent\00FCmer')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98593955232303163)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfragefunktion. Body'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731516674303281)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344365194302960)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Werteliste kann nicht gel\00F6scht werden. Sie wird auf Seite(n) %0 verwendet.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694243973303249)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'de'
,p_message_text=>'Bind-Element (Elementnamen eingeben)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343036334303788)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'de'
,p_message_text=>unistr('Muss m\00F6glicherweise aktualisiert werden.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345817018303790)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Deployment-Server hinzuf\00FCgen')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620456969303183)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'de'
,p_message_text=>'Datenbanklinks durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616488618303180)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Erstellvorgang f\00FCr den Datenbanklink war aus folgendem Grund nicht erfolgreich:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616520957303180)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Der Datenbanklink "%0" wurde im "%1"-Schema erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389417800302999)
,p_name=>'PACKAGE'
,p_message_language=>'de'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564053909303140)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Produktivit\00E4ts- oder Beispielanwendung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226719110302867)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Produktivit\00E4ts- und Beispiel-Apps')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775863717303317)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler bei der Installation der Anwendung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607128512303173)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'de'
,p_message_text=>'Package Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753597771303300)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'de'
,p_message_text=>'-Global-'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371433220302980)
,p_name=>'PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691897505303247)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Seitenberechnung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772134481303315)
,p_name=>'PAGE HEADER'
,p_message_language=>'de'
,p_message_text=>'Seitenheader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684300735303239)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'de'
,p_message_text=>unistr('Header, Body und Footer f\00FCr die Seite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692151433303247)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'de'
,p_message_text=>unistr('Standard f\00FCr Seitenelement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692315515303247)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr die Anzeige von Seitenelementen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692572356303247)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Werteliste f\00FCr Seitenelemente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692256304303247)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Seitenelement nach der Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692451254303247)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr die Anzeige von schreibgesch\00FCtzten Seitenelementen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692051278303247)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'de'
,p_message_text=>'Seitenelementquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607523028303173)
,p_name=>'PAGE ITEMS'
,p_message_language=>'de'
,p_message_text=>'Seitenelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685191527303240)
,p_name=>'PAGE PROCESS'
,p_message_language=>'de'
,p_message_text=>'Seitenprozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685240191303240)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr den Seitenprozess')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691912442303247)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Seitenvalidierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621444531303184)
,p_name=>'PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835596491303364)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Seitenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666044404303222)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'de'
,p_message_text=>'Seitenereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702222600303256)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'de'
,p_message_text=>'Seitenereignisse: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418497949303851)
,p_name=>'PAGE_FINDER'
,p_message_language=>'de'
,p_message_text=>'Seitensuche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180872220302831)
,p_name=>'PAGE_GROUP'
,p_message_language=>'de'
,p_message_text=>'Seitengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701706662303255)
,p_name=>'PAGE_HELP'
,p_message_language=>'de'
,p_message_text=>'Gibt die Seite innerhalb der Anwendung an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866948551303389)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Seite %0 gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867036857303389)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Sperre von Seite %0 aufgehoben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712285033303264)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Anwendungsseite erfolgreich installiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608048537303174)
,p_name=>'PAGE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Seitenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818137473303351)
,p_name=>'PAGE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Seite: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98652974478303208)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Seite wurde gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561439833303138)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'de'
,p_message_text=>'Seite wurde gesperrt von %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681946066303237)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenname ist f\00FCr alle Seiten erforderlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665865687303222)
,p_name=>'PAGE_POSTS'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenbeitr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835671224303364)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'de'
,p_message_text=>'Seitenprozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217625206302860)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Seitenverarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703057740303256)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'de'
,p_message_text=>'Seitenschutz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382947958302993)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383142109302994)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'de'
,p_message_text=>'Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383050092302993)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382727254302993)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382803239302993)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382695173302993)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'de'
,p_message_text=>'Quelle ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382540354302993)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'de'
,p_message_text=>'Quelle anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382319803302993)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382153590302993)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'de'
,p_message_text=>'Baumname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382496144302993)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'de'
,p_message_text=>'Baumabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382264510302993)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305172464302931)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Seite %0 wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684234154303239)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98653059611303209)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Seite entsperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665926119303222)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenansichten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98661615440303215)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Nummer \00FCbergeordnetes Feature')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771896643303314)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Berichtsspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933505108303445)
,p_name=>'PARENT_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkarte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931803211303443)
,p_name=>'PARENT_TABS'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkarten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376133748302988)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkartengruppe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376230557302988)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'de'
,p_message_text=>unistr('Neue \00FCbergeordnete Registerkartengruppe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376351202302988)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Text in \00FCbergeordneter Registerkarte')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932506831303444)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkartengruppe')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220840524302862)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Parsingschema'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98217789763302860)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seitenbestandteile'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201007397302847)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'de'
,p_message_text=>'Kennwort abgelaufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188760344302837)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Das Kennwort f\00FCr diesen Account muss ge\00E4ndert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200924467302847)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'de'
,p_message_text=>unistr('Kennwort g\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208780752302853)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'de'
,p_message_text=>unistr('Kennwort (wird nach Dr\00FCcken der EINGABETASTE weitergeleitet)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725501578303276)
,p_name=>'PAST_DUE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberf\00E4llig')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815472065303349)
,p_name=>'PATH'
,p_message_language=>'de'
,p_message_text=>'Pfad'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98974912010303483)
,p_name=>'PCT_CLOSED'
,p_message_language=>'de'
,p_message_text=>'% geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971229203303480)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Grafische Formatierung f\00FCr Prozents\00E4tze, Ganzzahlen zwischen 0 und 100')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884010475303403)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884132877303403)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220671539303679)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220775629303679)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Anwendungsberechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886012524303405)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Anwendungselemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886129914303405)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Anwendungselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220871884303680)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220914874303680)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Anwendungsprozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886497034303405)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886559070303405)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886658049303405)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Autorisierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886763150303405)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Autorisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121296926303601)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Automatisierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121309417303602)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Automatisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357917890303800)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Automatisierungsaktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358083352303800)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Automatisierungsaktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890274369303408)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Verzweigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890391978303408)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Verzweigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886818094303405)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Navigationspfade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886913001303406)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221015799303680)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationspfadeintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221177169303680)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadeintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885495908303404)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Templates f\00FCr Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885566044303404)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886293008303405)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Erstelloptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98886381697303405)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Erstelloption'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889086078303407)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889167747303407)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885094926303404)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Templates f\00FCr Schaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885195574303404)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen-Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885671773303404)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Vorg\00E4ngerkalender-Templates')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885771813303405)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Vorg\00E4ngerkalender-Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201453997303664)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201539016303664)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201670320303665)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201710672303665)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903610655303419)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903739576303420)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891867680303410)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891951574303410)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892017348303410)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892121543303410)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981231827303488)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981398756303488)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188236853303654)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Datenladedefinitionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188336228303654)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Datenladedefinition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887861303303406)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Legacy-Datenladedefinitionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887973342303406)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Legacy-Datenladedefinition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889461434303408)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889528539303408)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889247237303407)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889397792303408)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445829741303045)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98445986062303045)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121540230303602)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Facets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121653244303602)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192829692303658)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Facet-Gruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192914333303658)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Facet-Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193044901303658)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193188004303658)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884843374303404)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Feld-Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884913999303404)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Feld-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732392817303282)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732410548303282)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732744715303282)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732881104303282)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732538455303282)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Spaltengruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732644585303282)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Spaltengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732969985303282)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733075632303282)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199686668303663)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Gespeicherte Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200348936303663)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Gespeicherter Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890453250303408)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890545829303409)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891088704303409)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891180596303409)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890874143303409)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Spaltengruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890951734303409)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Spaltengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981050376303488)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981102078303488)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890635646303409)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Gespeicherte Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890798027303409)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Gespeicherter Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779781776303321)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779853282303321)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779549727303320)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Achsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779679338303320)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779967289303321)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Reihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780047118303321)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Reihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350394686303794)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350489506303794)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887048356303406)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Listen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887194381303406)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221220777303680)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Listeneintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221398713303680)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Listeneintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885260738303404)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885352867303404)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887228685303406)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Wertelisten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887382982303406)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221480247303680)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Wertelisteneintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221582660303680)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Wertelisteneintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127327822303606)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127463532303606)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127511821303606)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127693925303606)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127113987303606)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127295113303606)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888622527303407)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888725611303407)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889875199303408)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Berechnungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889990538303408)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888435212303407)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Seitengruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888597037303407)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Seitengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587098586303158)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Seitenelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587107095303158)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Seitenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890026915303408)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Prozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98890155185303408)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Prozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891614258303409)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter f\00FCr die Basisauthentifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891754842303409)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter f\00FCr die Basisauthentifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891243741303409)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'de'
,p_message_text=>'IN-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891322446303409)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'In-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891412683303409)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'de'
,p_message_text=>'OUT-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98891555081303409)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Out-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884437807303404)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Seitentemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884563924303404)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222098585303681)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222103247303681)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888835407303407)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888999265303407)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180089042303648)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180132289303648)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116703888303598)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116825854303598)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884624399303404)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Regionstemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884727002303404)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Regionstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827852226303358)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827951897303358)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608458117303174)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Remotedatenbanken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608529863303174)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988259552303494)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Berichtslayouts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988358421303494)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Berichtslayout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885833470303405)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Klassische Berichtstemplates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98885948779303405)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Klassisches Berichtstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554432793303133)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554565773303133)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554670734303133)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Gruppen filtern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554741783303133)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Filtergruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554888462303133)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554969795303133)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221624018303680)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Shortcuts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221776380303680)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Shortcut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888058908303406)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Standard-Registerkartengruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888102206303407)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Standard-Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894046270303411)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894103788303411)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894245285303411)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894375691303412)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981441996303488)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981590904303488)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884213735303403)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Themes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98884322772303403)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221845317303680)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('B\00E4ume')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99221906154303680)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Baum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888209573303407)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98888312946303407)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889687089303408)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Validierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98889787784303408)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Validierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887453122303406)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Webservicereferenzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887568558303406)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Webservicereferenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887612322303406)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Webservicevorg\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98887781028303406)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Webservicevorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357028404303800)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter f\00FCr die Basisauthentifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357119020303800)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter f\00FCr die Basisauthentifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357240179303800)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'de'
,p_message_text=>'HTTP-Headerparameter'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357388238303800)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'HTTP-Headerparameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356609601303799)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'de'
,p_message_text=>'IN-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356796396303799)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'In-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356884384303799)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'de'
,p_message_text=>'OUT-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99356947960303799)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Out-Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721824951303273)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721990303303273)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832542896303361)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenparameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832637666303361)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenparameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827643188303358)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('REST-Quellenvorg\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827738987303358)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenvorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832766527303362)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter f\00FCr REST-Quellenvorgang')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832812556303362)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>unistr('Parameter f\00FCr REST-Quellenvorgang')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832926347303362)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenparameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833072231303362)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenparameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722006636303273)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722109149303273)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843466917303370)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC "Aktionen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358112206303800)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'de'
,p_message_text=>unistr('Zus\00E4tzliche Codeausf\00FChrung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504810956303093)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'de'
,p_message_text=>'Erweitert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505175771303093)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'de'
,p_message_text=>'Betroffene Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782116626303322)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'de'
,p_message_text=>'Animation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506114399303094)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Darstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503336392303092)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153044340302808)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'de'
,p_message_text=>'Auditinformationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504911650303093)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>'Autorisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222395255303681)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900992001303417)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'de'
,p_message_text=>'Automatische Aktualisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506016390303094)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'de'
,p_message_text=>'Verhalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876090523303397)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'de'
,p_message_text=>'BLOB-Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202045428303665)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'de'
,p_message_text=>'Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878316683303399)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechselformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911023234303425)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Kalenderstatuselemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201875759303665)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'de'
,p_message_text=>'Karte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867569605303390)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'de'
,p_message_text=>'Kaskadierende Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902502923303419)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372967978303812)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'de'
,p_message_text=>'Clientseitige Bedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358255749303800)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'de'
,p_message_text=>'Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904271544303420)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'de'
,p_message_text=>'Farben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981914897303489)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980310226303487)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'de'
,p_message_text=>'Spaltenfilter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838238886303366)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'de'
,p_message_text=>'Spaltenformatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981852843303489)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten\00FCberschriften')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781498775303322)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'de'
,p_message_text=>'Spaltenzuordnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503426374303092)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'de'
,p_message_text=>'Kommentare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504756495303093)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503617547303092)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'de'
,p_message_text=>'Konfiguration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415180629303021)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913684811303427)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'de'
,p_message_text=>'Steuerelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503716442303092)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'de'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600382245303168)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'de'
,p_message_text=>'Anpassung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904028683303420)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Tages- und Wochenkalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222476198303681)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'de'
,p_message_text=>'Datenbanksession'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902685819303419)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781382069303322)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'de'
,p_message_text=>'Datencursor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505269308303093)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867433814303389)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'de'
,p_message_text=>unistr('Abh\00E4ngig von')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843541055303370)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843638397303370)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'de'
,p_message_text=>'Detailansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912208261303426)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'de'
,p_message_text=>'Dialog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843789561303370)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904394731303420)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'de'
,p_message_text=>'Drag-and-Drop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782073087303322)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'de'
,p_message_text=>'2Y-Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733274044303283)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865548238303388)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'de'
,p_message_text=>'Autorisierung bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505360249303093)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733122669303282)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer k\00F6nnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911139735303425)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'de'
,p_message_text=>'Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503539780303092)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503850907303092)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'de'
,p_message_text=>'Fehlerhandling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504699666303093)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungsoptionen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871914278303393)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'de'
,p_message_text=>'Exportieren/Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878413794303399)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Externe Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126381463303605)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902417677303418)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'de'
,p_message_text=>'Zeitrahmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324141894303772)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'de'
,p_message_text=>'Viewport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902044381303418)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'de'
,p_message_text=>'Gauge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503940989303092)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Header und Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878602996303399)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504007920303092)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505460703303093)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'de'
,p_message_text=>'Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504184417303092)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'de'
,p_message_text=>'HTML-Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202252292303665)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'de'
,p_message_text=>'Symbol und Badge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843829552303370)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'de'
,p_message_text=>'Symbolansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503132689303092)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'de'
,p_message_text=>'ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504270567303092)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505588958303093)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506268575303094)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'de'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901578238303418)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'de'
,p_message_text=>'Legende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781593838303322)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858692628303382)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'de'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965504257303475)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Listeneintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505648230303094)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904140355303420)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Kalender zur Agendaansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333956078303780)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Lokale Nachverarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599767999303167)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Anmeldungsverarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781771002303322)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'de'
,p_message_text=>'Grobteilungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127892800303607)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'de'
,p_message_text=>'Zoomfaktoren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127722363303607)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'de'
,p_message_text=>'Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128367699303607)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'de'
,p_message_text=>'Infofenster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99127910882303607)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4ngliche Position und Zoom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128143026303607)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'de'
,p_message_text=>'Punkt-Clustering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128042172303607)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'de'
,p_message_text=>'Punktobjekte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128299328303607)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'de'
,p_message_text=>'Zeilenzuweisung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901676826303418)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'de'
,p_message_text=>'Rand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781676753303322)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'de'
,p_message_text=>'Marker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927181711303439)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202306604303665)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'de'
,p_message_text=>'Medien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878547810303399)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'de'
,p_message_text=>'Nachrichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781880210303322)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'de'
,p_message_text=>'Feinteilungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903833384303420)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Monatlicher Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306102223302932)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'de'
,p_message_text=>'Mehrere Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635491622303195)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'de'
,p_message_text=>'Daten von Diagramm mit mehreren Reihen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222521398303681)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646054153303203)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410015361303844)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989937962303495)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Ausgabe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781225256303322)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'de'
,p_message_text=>'Zusammenfassung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981795713303488)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982117581303489)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Seitenfooter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982084877303489)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'de'
,p_message_text=>'Seitenheader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843932417303370)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'de'
,p_message_text=>'Seitenumbruch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863925737303387)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'de'
,p_message_text=>'Parameter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733483776303283)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'de'
,p_message_text=>'Performance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599816209303167)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'de'
,p_message_text=>'Post-Abmelde-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896401632303413)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('Quelle f\00FCr Prim\00E4rschl\00FCssel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98981656000303488)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222256443303681)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505783228303094)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'de'
,p_message_text=>'Schnellauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504304486303093)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599944964303167)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'de'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345171234302961)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'de'
,p_message_text=>'Referenzlinien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865011759303387)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608604287303174)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'de'
,p_message_text=>'Remotecache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824257824303355)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'de'
,p_message_text=>'Suchleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202100737303665)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'de'
,p_message_text=>unistr('Sekund\00E4rer Hauptteil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504400422303093)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'de'
,p_message_text=>'Sicherheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901776904303418)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'de'
,p_message_text=>'Reihenfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98504521848303093)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'de'
,p_message_text=>'Servercache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372817768303812)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'de'
,p_message_text=>'Serverseitige Bedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222681193303681)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'de'
,p_message_text=>'Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600094961303167)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Sessioncookieattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600176822303168)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'de'
,p_message_text=>unistr('Session nicht g\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98503244146303092)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Einstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844133871303371)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'de'
,p_message_text=>'Single Row-Ansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844009222303370)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'de'
,p_message_text=>'Sortieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505832651303094)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'de'
,p_message_text=>'Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600204162303168)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Subscription'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201911527303665)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'de'
,p_message_text=>'Untertitel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859529090303383)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Erfolgsmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555051515303133)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Vorschl\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410164041303844)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237842633302876)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'de'
,p_message_text=>'Schwellenwerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98781994622303322)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'de'
,p_message_text=>'Teilungslabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116283838303597)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'de'
,p_message_text=>unistr('Zeitma\00DFstab')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902321381303418)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733310032303283)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'de'
,p_message_text=>'Symbolleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902238329303418)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'de'
,p_message_text=>'QuickInfo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895237829303412)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'de'
,p_message_text=>'UI-Standardwerte - Referenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505935844303094)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Validierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902109172303418)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903998730303420)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Wochenkalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98505067067303093)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'de'
,p_message_text=>'Wenn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901805414303418)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'de'
,p_message_text=>'X-Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901974453303418)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'de'
,p_message_text=>'Y-Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828063480303358)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'de'
,p_message_text=>'Zoomskalierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735133260303284)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie ein Autorisierungsschema an, um zu begrenzen, wer Zeilen hinzuf\00FCgen kann.'),
unistr('Damit ein Endbenutzer Zeilen hinzuf\00FCgen kann, muss die Auswertung dieses Autorisierungsschemas TRUE f\00FCr diesen Benutzer ergeben.'),
unistr('Wenn kein Autorisierungsschema angegeben wird, kann jeder Benutzer Zeilen in diesem interaktiven Grid hinzuf\00FCgen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735038264303284)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738197954303287)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie ein alternatives Label f\00FCr die Schaltfl\00E4che "Hinzuf\00FCgen" an. Das Standardlabel ist <em>Zeile hinzuf\00FCgen</em>.</p>'),
unistr('        <p>Beispiel: Geben Sie <em>Mitarbeiter hinzuf\00FCgen</em> f\00FCr ein interaktives Grid an, in dem Mitarbeiter verwaltet werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738002349303287)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Label der Schaltfl\00E4che "Hinzuf\00FCgen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736345870303285)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob eine neue Zeile hinzugef\00FCgt werden soll, wenn f\00FCr das interaktive Grid aktuell keine Datens\00E4tze zur\00FCckgegeben werden.'),
'        Die Meldung <em>Keine Daten gefunden</em> wird nie angezeigt, weil immer mindestens ein Datensatz angezeigt wird.</p>',
unistr('        <p>Hinweis - Wenn keine Updates an dem Datensatz vorgenommen wurden, der hinzugef\00FCgt wurde, wird er nicht eingef\00FCgt, wenn die Region gespeichert wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736215170303285)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen, wenn leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219894470303679)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu diesem Facet hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194812483303659)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die dieser Facet-Gruppe hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere durch Leerzeichen getrennte Klassen hinzuf\00FCgen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751507699303298)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen ein, die dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('        <p>Hinweis: Mit dieser Eigenschaft k\00F6nnen Sie Stil\00E4nderungen am entsprechenden Element vornehmen, wenn das interaktive Grid bearbeitbar ist.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196592160303660)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen ein, die dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
'        <p>Hinweis: Diese CSS-Klassen werden auf das HTML-Formularelementtag angewendet.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558427765303136)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu diesem Filter hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559118261303136)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Filtergruppe hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195939255303660)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>F\00FCgt die CSS-Klassen <code>articlenumber</code> und <code>highlight</code> dem HTML-Tag der betroffenen Komponente hinzu:'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195892586303660)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie durch Leerzeichen begrenzte zus\00E4tzliche CSS-Klassen ein, die in der Komponente aufgenommen werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195784302303660)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538230739303120)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die von dieser Aktion betroffene Schaltfl\00E4che.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538173636303120)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373857635303813)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie mindestens eine Spalte ein, die von dieser Aktion betroffen sein soll. ',
' Bei mehreren Spalten trennen Sie die Spaltennamen durch ein Komma. ',
unistr('<p>Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Spalten ausw\00E4hlen. '),
unistr('Wenn Sie einen Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Spaltennamen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373715419303813)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538675906303120)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie ein DOM-Objekt (<code>document</code>, <code>window</code>) oder die <em>ID</em> eines DOM-Objekts (<code>myElementID</code>) als das Element an, das von dieser Aktion betroffen ist.</p>',
'<p>Hinweis: <em>DOM-Objekt</em> ist veraltet und muss durch <em>JavaScript-Ausdruck</em> oder <em>jQuery Selektor</em> ersetzt werden.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538550807303120)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'DOM-Objekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538486732303120)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie mindestens ein Seitenelement ein, das von dieser Aktion betroffen sein soll. ',
' Bei mehreren Elementen trennen Sie die Elementnamen durch ein Komma. ',
unistr('<p>Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Elementen ausw\00E4hlen. '),
unistr('Wenn Sie einen Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Elementnamen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538310146303120)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element(e)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370213241303810)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Gibt eine Referenz zu dem <code>window-</code>DOM-Objekt des Browsers zur\00FCck.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>Gibt eine Referenz zu dem <code>document</code>-DOM-Objekt des Browsers zur\00FCck.</dt>'),
'<dd>document</dd>',
unistr('<dt>jQuery-Selektor w\00E4hlt alle DIV-Elemente mit der Klasse ''alert'' und gibt dann ein jQuery-Objekt zur\00FCck, das alle \00FCbergeordneten Elemente enth\00E4lt.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370134646303810)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den JavaScript-Ausdruck an, der ausgewertet werden muss, um ein einzelnes DOM-Objekt, ein Array mit DOM-Objekten oder ein jQuery-Objekt als die Elemente zur\00FCckzugeben, auf die sich diese Aktion auswirken soll. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370074643303810)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028676680303527)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zur Auswahl eines Seitenelements mit einer DOM-ID <code>my_id</code></dt>',
'<dd><pre>#my_id</pre></dd>',
'<dt>Zur Auswahl aller Seitenelemente mit einer Klasse <code>my_class</code></dt>',
'<dd><pre>.my_class</pre></dd>',
'<dt>Zur Auswahl aller Seitenelemente, bei denen es sich um Eingaben handelt</dt>',
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538835823303120)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die jQuery-Selektorsyntax ein, um mindestens ein Seitenelement zur\00FCckzugeben, das von dieser Aktion betroffen ist. Die jQuery Library enth\00E4lt eine sehr leistungsf\00E4hige Selektorsyntax, mit der auf einfache Weise auf mindestens ein Element')
||' aus einer Seite zugegriffen werden kann.</p>',
unistr('<p>Weitere Informationen \00FCber die Selektorsyntax finden Sie in der offiziellen Dokumentation, die mit der <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery-Homepage</a> aufgerufen werden kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538785608303120)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'jQuery-Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538026425303120)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die von dieser Aktion betroffene Region.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537989211303119)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537808085303119)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie die von dieser Aktion betroffenen Seitenkomponenten definiert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027484702303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027532455303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Aktion wirkt sich auf die ausgew\00E4hlte Schaltfl\00E4che aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373157960303813)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Spalte(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373258327303813)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Diese Aktion wirkt sich auf mindestens eine Spalte aus, die Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027812592303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'de'
,p_message_text=>'DOM-Objekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027911940303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Aktion wirkt sich auf das Seitenelement aus, das von dem DOM-Objekt oder der DOM-ID identifiziert wird, die Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028430186303527)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'de'
,p_message_text=>'Ereignisquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028575524303527)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die Aktion wirkt sich auf das Seitenelement aus, aus dem das Ereignis stammt. Dies kann in einigen F\00E4llen nicht das "Ausl\00F6sende Element" sein.</p>'),
unistr('<p>In dieser erweiterten Konfiguration ist das angegebene ausl\00F6sende Element im Allgemeinen ein Containerelement (wie eine Region), das Ereignisse verarbeitet, die von allen Unterelementen (wie Seitenelementen in dieser Region) ausgel\00F6st wurden.'),
unistr('Dieser Auswahltyp kann dann verwendet werden, um das Unterelement zu bearbeiten, das das Ereignis ausgel\00F6st hat, und nicht das Containerelement.'),
unistr('Beispiel: Wenn eine dynamische Aktion vorhanden ist, die ein Ereignis <strong>''\00C4ndern''</strong> in einer Region auf Ihrer Seite definiert, wirkt sich die Aktion auf das eigentliche Element in der Region aus, die ge\00E4ndert wurde.</p>'),
unistr('<p>Die Verwendung von <em>''Ereignisquelle''</em> kann eine effizientere M\00F6glichkeit zur Definition allgemeiner Verhaltensweisen sein, die sich auf diese Seitenelemente auswirken.'),
unistr('Die M\00F6glichkeit, dass Containerelemente Ereignisse abfangen, die von Unterelementen ausgel\00F6st werden, wird vom Ereignistyp bestimmt.'),
unistr('Die folgenden Ereignistypen unterst\00FCtzen dies:</p>'),
'<ul>',
'  <li><b>Nach Aktualisierung</b> (apexafterrefresh)</li>',
'  <li><b>Vor Aktualisierung</b> (apexbeforerefresh)</li>',
unistr('  <li><b>\00C4ndern</b> (change)</li>'),
'  <li><b>Klick</b> (click)</li>',
'  <li><b>Doppelklick</b> (dblclick)</li>',
'  <li><b>Fokus erhalten</b> (focus)</li>',
'  <li><b>Taste nach unten</b> (keydown)</li>',
unistr('  <li><b>Taste dr\00FCcken</b> (keypress)</li>'),
'  <li><b>Taste loslassen</b> (keyup)</li>',
'  <li><b>Fokus verlieren</b> (blur)</li>',
unistr('  <li><b>Maustaste dr\00FCcken</b> (mousedown)</li>'),
'  <li><b>Maustaste loslassen</b> (mouseup)</li>',
'  <li><b>Maus bewegen</b> (mousemove)</li></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027292085303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element(e)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027343900303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>'Diese Aktion wirkt sich auf mindestens ein Seitenelement aus, das Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369862503303810)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369911057303810)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Aktion wirkt sich auf die Seitenelemente aus, die mit dem JavaScript-Ausdruck zur\00FCckgegeben werden, den Sie eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028027398303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'de'
,p_message_text=>'jQuery-Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028114485303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Aktion wirkt sich auf die Seitenelemente aus, die mit der jQuery-Selektorsyntax zur\00FCckgegeben werden, die Sie eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027635255303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027749347303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Aktion wirkt sich auf die ausgew\00E4hlte Region aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028240955303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Ausl\00F6sendes Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028340119303526)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Aktion wirkt sich auf das Seitenelement oder die Komponente aus, das bzw. die die dynamische Aktion ausgel\00F6st hat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537717211303119)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Auswahltyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650342105303206)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Keine Aggregation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650456171303206)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt die Wertspalte zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300664918303751)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, wie die verkn\00FCpfte Diagrammwertspalte aggregiert werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302182197303753)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Ungef\00E4hre Anzahl eindeutige Werte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302244893303753)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt die ungef\00E4hre Anzahl eindeutiger Werte zur\00FCck. Diese Aggregation ist beim Verarbeiten gro\00DFer Datenmengen bedeutend schneller als die Option <em>Nur eindeutige Reihen z\00E4hlen</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301110163303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'de'
,p_message_text=>'Durchschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301244338303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt den Durchschnitt der Wertspalte zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300768591303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'de'
,p_message_text=>'Anzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300869267303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt die Anzahl der Datens\00E4tze zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301922537303753)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Nur eindeutige Reihen z\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302095257303753)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt die genaue Anzahl der eindeutigen Werte zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301737087303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'de'
,p_message_text=>'Maximal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301891012303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt den H\00F6chstwert zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301379685303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'de'
,p_message_text=>'Medianwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301412675303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt den Medianwert unter Ignorierung der Nullwerte zur\00FCck. Diese Aggregation eignet sich am besten f\00FCr ein kontinuierliches Verteilungsmodell, da sie den Wert in der Mitte zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301502074303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'de'
,p_message_text=>'Minimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301656455303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt den Mindestwert zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300962167303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'de'
,p_message_text=>'Summe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99301023799303752)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt die Summe der Wertspalte zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300596392303751)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wertaggregation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517128073303103)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie, ob der Endbenutzer dieselbe Seite mehrmals weiterleiten darf. '),
unistr('Mit diesem Feature k\00F6nnen Sie mehrfache INSERT-Vorg\00E4nge in dieselbe Tabelle verhindern. '),
unistr('Dies kann vorkommen, wenn ein Endbenutzer im Browser auf die Schaltfl\00E4che <span class="fielddatabold">Zur\00FCck</span> klickt und anschlie\00DFend die Seite erneut weiterleitet oder im Browser auf die Schaltfl\00E4che zum Neuladen klickt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018772685303519)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Nein - Seite nicht erneut posten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018846200303519)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>'Ja - Seite erneut posten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517093054303103)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Mehrere Seitenweiterleitungen aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846985497303373)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob Nullspalten in der Single Record-Ansicht ausgeblendet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846823228303373)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Nullwerte ausschlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847154967303373)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob nur die derzeit angezeigten Spalten in der Single Record View angezeigt werden. Wenn Sie <strong>Aus</strong> angeben, k\00F6nnen die ausgeblendeten Berichtsspalten ebenfalls in der Single Record View angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847083355303373)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nur angezeigte Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841049084303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte aggregieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840989850303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aggregat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841465821303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte in einem Diagramm verwenden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841320997303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841217057303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte in einer Berechnungsspalte verwenden k\00F6nnen, die sie definieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841136703303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Berechnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840809360303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte in einem Gruppenwechsel verwenden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840712314303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Kontrollgruppenwechsel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840446668303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte filtern k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840396058303367)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841613317303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer nach dieser Spalte gruppieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841551803303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gruppieren nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840073016303367)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte ausblenden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839905781303367)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840618629303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte markieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840558392303368)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Markierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153837955302809)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt an, ob Endbenutzer eine Pivot-Aufgliederung in diesem Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153749885302809)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854989420303379)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer ihre aktuelle Berichtsdefinition als <em>\00D6ffentlichen</em> Bericht speichern k\00F6nnen.</p>'),
unistr('<p>\00D6ffentliche Berichte werden in einer Auswahlliste der verf\00FCgbaren Berichte in der Suchleiste angezeigt. Sie werden f\00FCr jedermann angezeigt.'),
unistr('Die Option im Men\00FC "Aktionen" ist nur f\00FCr authentifizierte Benutzer verf\00FCgbar und ist au\00DFerdem weiter eingeschr\00E4nkt, wenn Sie auch das Feld <strong>Autorisierung f\00FCr \00F6ffentlichen Bericht speichern</strong> auff\00FCllen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854864620303379)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlichen Bericht speichern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854796414303379)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer ihre aktuelle Berichtsdefinition als <em>Privaten</em> Bericht speichern k\00F6nnen.</p>'),
unistr('<p>Private Berichte werden in einer Auswahlliste der verf\00FCgbaren Berichte in der Suchleiste angezeigt. Sie werden nur f\00FCr den Benutzer angezeigt, der den Bericht gespeichert hat, vorausgesetzt, sie sind authentifiziert. '),
unistr('Die Option im Men\00FC "Aktionen" ist nur f\00FCr authentifizierte Benutzer verf\00FCgbar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854623599303379)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bericht speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855167903303379)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Benutzer Berichtskategorien speichern k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855058122303379)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Berichtskategorien speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840237967303367)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte sortieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98840106401303367)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sortierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741844228303290)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie das alternative Label zur Verwendung in Dialogfeldern und in der Single Row-Ansicht an.',
unistr('        Verwenden Sie ein alternatives Label, wenn die \00DCberschrift eine zus\00E4tzliche Formatierung enth\00E4lt, wie HTML-Tags, die nicht ordnungsgem\00E4\00DF angezeigt werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741755042303290)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Alternatives Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618631775303182)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob diese Validierung immer ausgef\00FChrt wird.'),
unistr('Wenn der Wert auf <strong>Ein</strong> gesetzt ist, wird diese Validierung immer durchgef\00FChrt, ungeachtet der Einstellung <em>Validierungen ausf\00FChren</em>, die f\00FCr die Schaltfl\00E4che definiert ist, die die Seite weitergeleitet hat.'),
unistr('Wenn dieser Wert auf <strong>Aus</strong> gesetzt ist, wird diese Validierung nur ausgewertet, wenn f\00FCr die ausl\00F6sende Schaltfl\00E4che <em>Ein</em> bei <strong>Validierungen ausf\00FChren</strong> festgelegt ist.</p>'),
unistr('<p>Hinweis: Diese Validierung muss au\00DFerdem die angegebenen Bedingungen erf\00FCllen, bevor sie ausgewertet wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618589970303182)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Immer ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784718382303325)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, ob die Animation angezeigt wird, wenn Daten in dem Diagramm ge\00E4ndert werden. Eine Daten\00E4nderung kann auftreten, wenn das Diagramm automatisch aktualisiert wird, wenn beim Klicken auf ein Legendenelement ein- oder ausgeblendet wird oder')
||unistr(' wenn Diagrammdaten programmgesteuert \00FCber benutzerdefinierten JavaScript-Code oder eine dynamische Aktion aktualisiert werden.</p>'),
unistr('        <p>Die Optionen <strong>Nach links schieben</strong> und <strong>Nach rechts schieben</strong> gelten nicht f\00FCr Dial-Diagramme</p>.  ')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784824541303325)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915339676303429)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'de'
,p_message_text=>'Wenden Sie die in Oracle JET definierten Standardanimationseinstellungen auf das Diagramm an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785113874303325)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924835899303437)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Daten ge\00E4ndert werden, wird keine Animation f\00FCr das Diagramm angewendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784993767303325)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'de'
,p_message_text=>'Nach links schieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924661236303437)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Datenelemente werden nach links verschoben, wenn Daten ge\00E4ndert werden. Diese Einstellung gilt nicht f\00FCr Gantt-Diagramme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785061121303325)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Nach rechts schieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924750694303437)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Datenelemente werden nach rechts verschoben, wenn Daten ge\00E4ndert werden. Diese Einstellung gilt nicht f\00FCr Gantt-Diagramme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784681110303324)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Bei Daten\00E4nderung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784189004303324)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Animationstyp, der bei der ersten Anzeige des Diagramms verwendet werden soll.</p>'),
unistr('        <p>Die Optionen <strong>Alpha verblassend</strong> und <strong>Zoomen</strong> k\00F6nnen f\00FCr Dial-Diagramme nicht verwendet werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784313072303324)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'de'
,p_message_text=>'Alpha verblassend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915095866303428)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Blendet das Diagramm bei der ersten Anzeige ein. Diese Einstellung gilt nicht f\00FCr Gantt-Diagramme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784238419303324)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914955254303428)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'de'
,p_message_text=>'Wenden Sie die in Oracle JET definierten Standardanimationseinstellungen auf das Diagramm an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784549647303324)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915293489303429)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Bei der ersten Anzeige wird keine Animation f\00FCr das Diagramm verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784468926303324)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'de'
,p_message_text=>'Zoomen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915176573303429)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Vergr\00F6\00DFert das Diagramm bei der ersten Anzeige. Diese Einstellung gilt nicht f\00FCr Gantt-Diagramme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98784058490303324)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bei Anzeige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196693153303661)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219759572303679)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197402585303661)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche durch Leerzeichen begrenzte CSS-Klassen ein, die Ihrem Bericht hinzugef\00FCgt werden sollen. Ihr Berichtstemplate muss die Ersetzungszeichenfolge <code>#COMPONENT_CSS_CLASSES#</code> enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751390638303298)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen ein, die dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
'        <p>Hinweis: Diese CSS-Klassen werden auf die Zellen im interaktiven Grid angewendet. Um CSS-Klassen auf das entsprechende Element anzuwenden, sehen Sie sich die Eigenschaft "CSS-Klassen" unter der Gruppe "Erweitert" an.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196381882303660)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196425620303660)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen ein, die zu diesem Element hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie sie durch Leerzeichen trennen.<p/>'),
unistr('        <p>Mit dieser Eigenschaft k\00F6nnen Stil\00E4nderungen - \00FCber Templateoptionen hinaus - f\00FCr das Element vorgenommen werden. Sie bietet auch eine einfachere M\00F6glichkeit zur Auswahl dieses Elements \00FCber JavaScript.</p>'),
unistr('        <p>Hinweis: Um CSS-Klassen f\00FCr das HTML-Formularelementtag anzuwenden, wird auf die Eigenschaft "CSS-Klassen" unter der Gruppe "Erweitert" verwiesen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196773474303661)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197631495303661)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197599699303661)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche durch Leerzeichen begrenzte CSS-Klassen ein, die Ihrem Bericht hinzugef\00FCgt werden sollen. Ihr Berichtstemplate muss die Ersetzungszeichenfolge <code>#COMPONENT_CSS_CLASSES#</code> enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196262300303660)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>F\00FCgt die CSS-Klassen <code>articlenumber</code> und <code>highlight</code> der Komponente hinzu:'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196180421303660)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196084463303660)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155303565302810)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Geltungsbereich dieses Anwendungselements. Geben Sie <strong>Global</strong> an, wenn die &PRODUCT_NAME.-Session von mehr als einer Anwendung gemeinsam verwendet wird und der Wert des Elements f\00FCr alle Anwendungen identisch sein mus')
||'s.',
unistr('Sonst w\00E4hlen Sie <strong>Anwendung</strong> (dies ist der Standardgeltungsbereich).</p>'),
unistr('<p>Anwendungen k\00F6nnen dieselbe Session gemeinsam verwenden, wenn ihre Authentifizierungen dieselben <em>Sessioncookieattribute</em> haben.'),
'Das Geltungsbereichsattribut der Anwendungselemente muss bei diesen Anwendungen identisch sein.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050580119303545)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050670086303545)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'de'
,p_message_text=>'Global'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155281526302810)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Geltungsbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801314739303337)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob die aktuelle Datenreihe der 2Y-Achse zugewiesen ist, die in dem Diagramm gerendert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801221542303337)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zugewiesen zu 2Y-Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619216722303182)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte, die mit der Seitenverarbeitungskomponente verkn\00FCpft ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619188159303182)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Verkn\00FCpfte Spalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619076847303182)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie das Element, in dem diese Fehlermeldung angezeigt wird.'),
unistr('Wenn Sie ein Element w\00E4hlen und <em>Position f\00FCr die Fehlermeldung</em> "Inline mit Feld" enth\00E4lt, wird die Fehlermeldung unter dem Label des angegebenen Elements angezeigt.'),
unistr('Wenn <em>Position f\00FCr die Fehlermeldung</em> "Inline mit Feld" nicht enth\00E4lt, wirkt sich dieses Attribut nicht auf die Anzeige der Fehlermeldung aus.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618940241303182)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Zugeh\00F6riges Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222785022303681)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601011855303168)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schematyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546659571303127)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Autorisierungsschema, das auf die Seite angewendet werden soll. Autorisierungsschemas werden auf Anwendungsebene definiert und k\00F6nnen auf zahlreiche Elemente innerhalb der Anwendung angewendet werden.</p>'),
unistr('<p>Ein Autorisierungsschema wird entweder einmal f\00FCr jede Anwendungssession (bei der Sessionerstellung) oder einmal f\00FCr jede Seitenansicht ausgewertet. Wenn f\00FCr das ausgew\00E4hlte Autorisierungsschema <strong>TRUE</strong> gilt, wird die Seite unter Ber')
||unistr('\00FCcksichtigung anderer definierter Bedingungen angezeigt. Wenn <strong>FALSE</strong> gilt, wird eine Fehlermeldung aufgerufen und die Seite nicht angezeigt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516377097303102)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein Autorisierungsschema, um diese Komponente zu kontrollieren. Die Auswertung der Autorisierung muss TRUE ergeben, damit diese Komponente wiedergegeben oder ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516258440303102)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507284434303095)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, welches Autorisierungsschema angewendet wird. Die folgenden Autorisierungstypen werden unterst\00FCtzt:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Je nach Anwendungskonfiguration sind hier zus\00E4tzliche Plug-ins f\00FCr den Autorisierungstyp verf\00FCgbar.'),
'Sie werden als <em>&lt;My Plug-in&gt; [Plug-in]</em> angezeigt.',
'Die folgenden Plug-ins sind in den gemeinsam verwendeten Komponenten dieser Anwendung installiert:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507191326303095)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359125499303801)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359441164303801)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359343457303801)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359254071303801)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359592126303802)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359096668303801)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360368398303802)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Quelle der Daten an, die w\00E4hrend der Ausf\00FChrung der Automatisierung ausgewertet werden. Automatisierungen k\00F6nnen auf Tabellen, SQL-Abfragen oder PL/SQL-Funktionen basieren, die eine SQL-Abfrage zur\00FCckgeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360279041303802)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360129782303802)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360022028303802)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Quelle der Daten an, die w\00E4hrend der Ausf\00FChrung der Automatisierung ausgewertet werden. Automatisierungen k\00F6nnen auf Tabellen, SQL-Abfragen oder PL/SQL-Funktionen basieren, die eine SQL-Abfrage zur\00FCckgeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359923448303802)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359869701303802)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359765977303802)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Quelle der Daten an, die w\00E4hrend der Ausf\00FChrung der Automatisierung ausgewertet werden. Automatisierungen k\00F6nnen auf Tabellen, SQL-Abfragen oder PL/SQL-Funktionen basieren, die eine SQL-Abfrage zur\00FCckgeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99359662141303802)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360512312303802)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Quelle der Daten an, die w\00E4hrend der Ausf\00FChrung der Automatisierung ausgewertet werden. Automatisierungen k\00F6nnen auf Tabellen, SQL-Abfragen oder PL/SQL-Funktionen basieren, die eine SQL-Abfrage zur\00FCckgeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360433570303802)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358690055303801)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358595599303801)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358482272303801)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Quelle der Daten an, die w\00E4hrend der Ausf\00FChrung der Automatisierung ausgewertet werden. Automatisierungen k\00F6nnen auf Tabellen, SQL-Abfragen oder PL/SQL-Funktionen basieren, die eine SQL-Abfrage zur\00FCckgeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358367537303801)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Quelltyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358993423303801)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358808049303801)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Typ der Aktion aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99358720629303801)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657636639303212)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob die entsprechende Benutzeroberfl\00E4che automatisch ermittelt wird.'),
unistr('Wenn die automatische Ermittlung <strong>Ein</strong> ist, wird der Benutzer automatisch zur entsprechenden Anmeldeseite oder Homepage umgeleitet, je nach Gr\00F6\00DFe des verwendeten Ger\00E4ts.'),
unistr('Welche Benutzeroberfl\00E4che angezeigt werden soll, wird mit Mediaabfragen ermittelt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657518063303212)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Automatisch erkennen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803387147303339)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den H\00F6chstwert der Achse ein. Ist standardm\00E4\00DFig null bei der automatischen Berechnung basierend auf den Daten.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803278242303339)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Maximal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803183766303339)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Mindestwert der Achse ein. Ist standardm\00E4\00DFig null bei der automatischen Berechnung basierend auf den Daten.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803008705303339)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Minimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804127125303340)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position der Labels, die in dem Diagramm gerendert werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804222555303340)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804631542303340)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804426749303340)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804368139303340)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804557949303340)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804046921303340)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826514888303357)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Achsenskalierung. Gilt nur f\00FCr numerische Achsen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826659694303357)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'de'
,p_message_text=>'Linear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826744818303357)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'de'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826492925303357)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nachkommastellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803923617303340)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Inkrement zwischen Grobteilungen an. Ist standardm\00E4\00DFig null bei der automatischen Berechnung basierend auf den Daten. Gilt nur f\00FCr Zeit- und numerische Achsen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803875155303339)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210814466303672)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Badge verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210759124303672)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Badgespalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211035457303672)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210956772303672)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Badge-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211384041303672)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Filmbewertungen anzeigen</dt>',
'    <dd>Die Badgespalte kann die RATING-Spalte sein, und das Badgelabel kann "Sterne" lauten</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211296059303672)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr den Badge zur Beschreibung des Badgewertes ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211119883303672)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Badgelabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906343329303422)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Kalenderbeginn an. Wenn Sie diese Option ausw\00E4hlen, wird ein Kalender erstellt, der ein gesamtes Intervall (beispielsweise einen Monat) umfasst.</p>'),
'<ul>',
'  <li>Wenn "Beim Start des Intervalls beginnen" auf <strong>Ein</strong> gesetzt ist und das Datum auf den 15. Juni bei einer Monatsanzeige, umfasst der Kalender den Bereich vom 1. Juni bis zum 30. Juni.</li>',
'  <li>Wenn "Beim Start des Intervalls beginnen" auf <strong>Aus</strong> gesetzt ist und das Datum auf den 15. Juni bei einer Monatsanzeige, umfasst der Kalender den Bereich vom 15. Juni bis zum 30. Juni.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906266074303421)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Beim Start des Intervalls beginnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877614176303398)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Zeichensatzspalte aus der Tabelle, in der der anzuzeigende BLOB-Inhalt gespeichert wird. Das Bild wird wahrscheinlich nicht angezeigt, wenn Sie eine Spalte mit dem falschen Datentyp ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877528877303398)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Zeichensatz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876627869303397)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die BLOB-Spalte aus der Tabelle, in der der anzuzeigende BLOB-Inhalt gespeichert wird. Das Bild wird wahrscheinlich nicht angezeigt, wenn Sie eine Spalte mit dem falschen Datentyp ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876594686303397)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'BLOB-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877452581303398)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Dateinamensspalte in der Tabelle ein, in der der anzuzeigende BLOB-Inhalt gespeichert wird. Das Bild wird wahrscheinlich nicht angezeigt, wenn Sie eine Spalte mit dem falschen Datentyp ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877378307303398)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Dateinamen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877816150303398)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die letzte aktualisierte Spalte aus der Tabelle, in der der anzuzeigende BLOB-Inhalt gespeichert wird. Wenn bereits eine Spalte <code>UPDATED</code> mit einem verkn\00FCpften Trigger zur Verwaltung des Datums vorhanden ist, k\00F6nnen Sie diese Sp')
||unistr('alte verwenden anstatt eine neue Spalte zu definieren, besonders wenn das Bild zuletzt aktualisiert wurde. Wenn jedoch Spalten, mit Ausnahme des BLOB-Inhalts, regelm\00E4\00DFig aktualisiert werden, wirkt sich dies negativ auf das Bild-Caching aus. Das Bild ')
||unistr('wird wahrscheinlich nicht angezeigt, wenn Sie eine Spalte mit dem falschen Datentyp w\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877749930303398)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zuletzt aktualisierte Spalte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877276265303398)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die MIME-Typspalte aus der Tabelle, in der der anzuzeigende BLOB-Inhalt gespeichert wird. Das Bild wird wahrscheinlich nicht angezeigt, wenn Sie eine Spalte mit dem falschen Datentyp ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877106537303398)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr MIME-Typ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876876904303397)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die erste Prim\00E4rschl\00FCsselspalte aus der Tabelle, in der der anzuzeigende BLOB-Inhalt gespeichert wird. Wenn der Prim\00E4rschl\00FCssel der Tabelle mehr als zwei Spalten enth\00E4lt, m\00FCssen Sie die Spalte <code>ROWID</code> w\00E4hlen. Das Bild wird wahrs')
||unistr('cheinlich nicht angezeigt, wenn Sie eine Spalte mit dem falschen Datentyp w\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876766189303397)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877092049303398)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die zweite Prim\00E4rschl\00FCsselspalte nur, wenn der Prim\00E4rschl\00FCssel f\00FCr Ihre Tabelle zwei Spalten enth\00E4lt. Wenn Sie <code>ROWID</code> f\00FCr die erste Prim\00E4rschl\00FCsselspalte ausw\00E4hlen, m\00FCssen Sie diese Spalte nicht auff\00FCllen. Das Bild wird wahrsch')
||unistr('einlich nicht angezeigt, wenn Sie eine Spalte mit dem falschen Datentyp ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876996081303397)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876474422303397)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie den Tabellennamen ein, in dem der anzuzeigende BLOB-Inhalt gespeichert wird.',
unistr('Sie k\00F6nnen den Tabellennamen eingeben oder aus der Liste der verf\00FCgbaren Tabellen ausw\00E4hlen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876338731303397)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Tabellenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876243049303397)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Schema, das Eigent\00FCmer der Tabelle ist, in der der anzuzeigende BLOB-Inhalt gespeichert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98876181864303397)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Tabelleneigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206443543303668)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Komponente mit einer Spalte oder mit erweiterter Formatierung unter Verwendung von HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206387132303668)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Formatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206673147303668)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Hauptteil verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206543249303668)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207111176303669)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207048090303669)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515990465303102)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie Text oder HTML-Code ein, der vor Regionen auf der aktuell ausgef\00FChrten Seite angezeigt wird. '),
'Text, den Sie hier eingeben, wird vor der Ersetzungszeichenfolge <code>#BODY#</code> des Seitentemplates angezeigt.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515837177303102)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Body-Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206944360303669)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Hintergrund- und Textfarben \00E4ndern</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\00DCberschrift 2 verwenden</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Eine dynamische Klasse aus der SQL-Abfrage verwenden</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&COLUMN_CLASS.</code> und <code>&EMPLOYEE_STATUS.</code> in diesem Beispiel sind Spalten, die in der Berichts-SQL-Abfrage ausgew\00E4hlt werden.</dd>'),
'  <dt>Beim  Mouseover ein Bild und ein QuickInfo anzeigen</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206853735303669)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die in dieser Spalte angezeigt werden sollen. Verwenden Sie die <code>&COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206784169303669)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897555245303414)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Anforderung ein, die in dem Verzweigungslink aufgenommen werden muss.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897470487303414)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anfordern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295864643303747)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296113120303747)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296011885303747)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295963060303747)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296236286303748)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295708668303747)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871231459303393)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Seiten- oder Anwendungselement ein, das eine Seitennummer oder URL enth\00E4lt, zu der umgeleitet werden soll.'),
'Dieses Element kann von einer aufrufenden Seite oder von einem Prozess festgelegt werden, wenn die Seite das erste Mal geladen wird.',
unistr('Durch Angabe eines Elements kann die Verzweigung f\00FCr Seiten auf einfache Weise dynamisch festgelegt werden, die von vielen anderen Seiten aufgerufen werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871178344303393)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297056568303748)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Java-Funktionsbody ein, der eine Seitennummer oder URL zur\00FCckgibt, zu der die Umleitung vorgenommen werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296948461303748)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296894626303748)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296770582303748)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den JavaScript-Funktionsbody ein, der eine Seitennummer oder URL zur\00FCckgibt, zu der die Umleitung vorgenommen werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296643727303748)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617520747303181)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Seite an, zu der diese Verzweigung umgeleitet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617449151303181)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitennummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617707521303181)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den PL/SQL-Code ein, der von der Verzweigung ausgef\00FChrt wird. Die PL/SQL-Prozedur ist f\00FCr den Aufruf der erforderlichen URL verantwortlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617660184303181)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296581718303748)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296411388303748)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den PL/SQL-Funktionsbody ein, der eine Seitennummer oder URL zur\00FCckgibt, zu der die Umleitung vorgenommen werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99296340878303748)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617193589303181)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie fest, an welcher Stelle der Seitenwiedergabe oder -verarbeitung diese Verzweigung ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039039584303536)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'de'
,p_message_text=>'Nach der Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328676234303776)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'de'
,p_message_text=>'Verarbeitung: Verzweigt sich nach der Verarbeitung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038755319303535)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'de'
,p_message_text=>'Nach Weiterleitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328351670303776)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeitung: Verzweigt sich nach der Weiterleitung der Seite und nach der Ausf\00FChrung von Berechnungen, Validierungen und Prozessen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039136451303536)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'de'
,p_message_text=>'Vor Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328779687303776)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>'Rendering: Verzweigt sich vor der Wiedergabe der Seite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038919022303536)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'de'
,p_message_text=>'Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328598047303776)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'de'
,p_message_text=>'Verarbeitung: Verzweigt sich vor der Verarbeitung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038859105303535)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'de'
,p_message_text=>'Validieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328426178303776)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeitung: Verzweigt sich vor der Ausf\00FChrung von Validierungen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617004128303181)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Punkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297275276303748)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Python-Funktionsbody ein, der eine Seitennummer oder URL zur\00FCckgibt, zu der die Umleitung vorgenommen werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297170924303748)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616903531303180)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Typ der durchzuf\00FChrenden Seitenverzweigung aus.</p>'),
'<dl>',
'<dt>Umleitungsverzweigungen</dt>',
unistr('<dd>&PRODUCT_NAME. gibt die neue Seite oder URL an den Browser zur\00FCck, der eine neue Anforderung ausf\00FChrt, bevor die Ergebnisseite angezeigt wird.'),
unistr('Der Hauptvorteil besteht darin, dass die Endbenutzer die Seite aktualisieren k\00F6nnen, ohne den Kontext zu verlieren, weil die Browseradresse die vollst\00E4ndige Seiten-URL enth\00E4lt.'),
unistr('Der Nachteil besteht darin, dass der Browser eine zus\00E4tzliche Anforderung zur Anzeige der Seite ausf\00FChrt.</dd>'),
'<dt>Nur Verzweigungen anzeigen</dt>',
unistr('<dd>&PRODUCT_NAME. gibt die neue Seite sofort als Bestandteil der aktuellen Seitenverarbeitung wieder, ohne eine weitere Anforderung auszuf\00FChren.'),
unistr('Dies hat den Vorteil, dass der Browser keine zus\00E4tzliche Anforderung ausf\00FChren muss.'),
'Der Hauptnachteil besteht darin, dass die Browseradresse <code>wwv_flow.accept</code> lautet.',
unistr('Wenn die Endbenutzer die Seite aktualisieren, fordert der Browser das erneute Senden der Daten an, weil die Browseradresse keine vollst\00E4ndige Seiten-URL ist.</dd>'),
'</dl>',
unistr('<p>Oracle empfiehlt aus Gr\00FCnden der Benutzerfreundlichkeit, dass Sie einen der Umleitungsverzweigungstypen ausw\00E4hlen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038194980303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion, die eine Seite zur\00FCckgibt (Nur anzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038269987303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion, die eine URL zur\00FCckgibt (Umleiten)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038661717303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'de'
,p_message_text=>'Seitenverarbeitung {not common}'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038482594303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Von Element identifizierte Seite (Nur anzeigen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038036975303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'de'
,p_message_text=>'Seite (nur anzeigen)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038513868303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Von Element identifizierte URL (Umleiten)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99038373749303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Prozedur [Legacy]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037975614303535)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'de'
,p_message_text=>'Seite oder URL (Umleiten)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616848439303180)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155116123302810)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Navigationspfad-Template, das mit diesem Navigationspfad verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155009565302810)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Navigationspfad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883287711303403)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der nach Gruppenwechselspalten angezeigt wird, wenn eine Gruppenwechselzeile angezeigt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883140681303402)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nach Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882815424303402)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der vor Gruppenwechselspalten angezeigt wird, wenn eine Gruppenwechselzeile angezeigt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882745215303402)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Vor Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893595452303411)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Kein Umbruch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894777855303412)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Kein Umbruch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882089360303402)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie viele Berichtsspalten in der Gruppenwechselformatierung ber\00FCcksichtigt werden sollen. Die Spalten m\00FCssen fortlaufende Spalten ab der ersten Spalte sein, die in dem Bericht angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061022489303553)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>'Erste Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061160413303554)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'de'
,p_message_text=>'Erste und zweite Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061204857303554)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'de'
,p_message_text=>'Erste, zweite und dritte Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881985234303402)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechselspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882216037303402)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie sich die Gruppenwechsel auf die Formatierung der Berichtsanzeige auswirken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061504385303554)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechselformat (Standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061696732303554)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Gruppenwechsel werden in einem einzelnen Bericht angezeigt, ohne die \00DCberschriften f\00FCr jeden Gruppenwechsel zu wiederholen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061311830303554)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschriften bei Gruppenwechsel wiederholen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061485884303554)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Bericht wird in Form verschiedener Unterberichte mit sich wiederholenden \00DCberschriften f\00FCr jeden Gruppenwechsel angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882153491303402)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882630225303402)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der in Berichtsgruppenwechseln angezeigt wird. Verwenden Sie <code>#SUM_COLUMN_HEADER#</code>-Ersetzungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882523671303402)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Format von Berichtsgruppenwechsel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883016876303402)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr die Gruppenwechselspalte an, wenn ein Berichtsgruppenwechsel angezeigt wird. Sie k\00F6nnen <code>#COLUMN_VALUE#</code>-Ersetzungen verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882993467303402)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Format von Spaltengruppenwechsel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882487929303402)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr die sich wiederholenden \00DCberschriften an, die f\00FCr Berichtsgruppenwechsel angezeigt werden. Sie k\00F6nnen <code>#COLUMN_VALUE#</code>-Ersetzungen verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98882344277303402)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Format sich wiederholender \00DCberschriften')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892763671303410)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Anwendungsstandardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333821677303780)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwendet die Einstellung, die in den Anwendungssicherheitsattributen definiert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517978490303104)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Durch Aktivierung des Cache kann der Browser den Inhalt Ihrer Anwendungsseiten in seinem Cache sowohl im Speicher als auch auf dem Datentr\00E4ger speichern.'),
unistr('Wenn ein Benutzer auf die Schaltfl\00E4che "Zur\00FCck" des Browsers klickt, wird die Seite im Allgemeinen aus dem Cache und nicht aus dem Server geladen.'),
'Wenn der Cache deaktiviert ist, wird der Browser angewiesen, den Seiteninhalt nicht zu speichern, sondern erneut aus dem Server anzufordern.</p>',
'<p>Von einer Sicherheitsperspektive aus gesehen sollte der Cache deaktiviert werden,',
unistr('sodass der Browser keine vertraulichen Daten speichert und Seiten immer anfordert, wenn sich die URL \00E4ndert.'),
unistr('Sonst kann sogar nach einer Abmeldung in der Browserhistorie zur\00FCckgegangen und gecachter Inhalt der fr\00FCheren Session angezeigt werden.'),
unistr('Die Deaktivierung des Browsercache verhindert auch spezielle Probleme mit der Schaltfl\00E4che "Zur\00FCck" bei Seiten, die Teilseitenaktualisierungen f\00FCr Beispielseiten mit interaktiven Berichten verwenden.</p>'),
'<p>Wenn dieses Attribut auf "Deaktiviert" gesetzt ist, sendet &PRODUCT_NAME. den HTTP-Header',
unistr('<em>cache-control: no-store</em>, der den Browser anweist, den Seiteninhalt nicht im Speicher oder auf Datentr\00E4ger zu cachen.'),
unistr('Wenn dieser Wert auf "Anwendungsstandard" festgelegt ist, wird der Wert zur Laufzeit aus dem Attribut <em>Browsercache</em> der Anwendung \00FCbernommen.</p>'),
unistr('<p>Hinweis: Dieses Feature erfordert moderne Browser, die die HTTP-Header-Antwortvariable "cache-control" unterst\00FCtzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021128331303521)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021061749303521)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517872935303103)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Browsercache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402762478303838)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. Sie entwickeln eine Anwendung, f\00FCr die es viele Installationen geben wird.'),
unistr('                                        Bei jeder Installation kann ausgew\00E4hlt werden, ob bestimmte Anwendungsfunktionen aktiviert oder deaktiviert werden sollen.'),
unistr('                                        Mit Erstelloptionen k\00F6nnen Sie eine Anwendung entwickeln; wenn diese installiert ist, k\00F6nnen Erstelloptionen konfiguriert werden, um die zugeh\00F6rige Anwendungsfunktionalit\00E4t zu aktivieren oder zu deaktivieren.'),
unistr('                                        Sie k\00F6nnen dieses Feature innerhalb der Anwendung auch mit der API zur Verf\00FCgung stellen.'),
unistr('                                        Auf diese Weise k\00F6nnen privilegierte Endbenutzer die Anwendungsfunktionalit\00E4t selektiv aktivieren oder deaktivieren.</p>'),
unistr('                                      <p>2. Sie entwickeln eine Funktionalit\00E4t, die noch nicht vollst\00E4ndig abgeschlossen ist, sodass Sie sie Endbenutzern nicht zur Verf\00FCgung stellen m\00F6chten.'),
unistr('									    Mit Erstelloptionen k\00F6nnen Sie diese Funktionalit\00E4t in der Anwendung deaktivieren, wenn diese in der Test- und Production-Umgebung generiert wird.'),
unistr('									    Der Vorteil dieser L\00F6sung besteht darin, dass die Anwendung auch ohne die unvollst\00E4ndige Funktionalit\00E4t bereitgestellt werden kann.</p>'),
unistr('                                      <p>3. Sie entfernen eine Funktionalit\00E4t, von der Sie glauben, dass sie von der Anwendung nicht ben\00F6tigt wird, wissen jedoch nicht, ob dieser Vorgang sicher ist.'),
unistr('                                        In diesem Fall k\00F6nnen Sie Erstelloptionen verwenden, um eine bestimmte Funktionalit\00E4t "auszukommentieren".'),
unistr('									    Wenn beim Deployment festgestellt wurde, dass die entfernte Funktionalit\00E4t erforderlich ist, kann sie wieder instanziiert werden.'),
unistr('									    Wenn diese Funktionalit\00E4t als nicht erforderlich erachtet wurde, kann sie sicher aus der Anwendung entfernt werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518190711303104)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie eine Erstelloption f\00FCr diese Komponente aus.</p>'),
unistr('                                     <p>Mit Erstelloptionen k\00F6nnen Anwendungskomponenten und -funktionalit\00E4t bei der Installation der Anwendung oder zur Laufzeit \00FCber die API (APEX_UTIL.SET_BUILD_OPTION_STATUS) bedingt aktiviert oder deaktiviert werd')
||'en.<br>',
unistr('                                       Erstelloptionen k\00F6nnen festlegen, dass diese Komponente in der Laufzeitanwendung einbezogen oder ausgeschlossen wird:</p>'),
'                                     <p><strong>Einbezogen</strong> - Komponente ist aktiviert und Bestandteil der Anwendung.</p>',
'									 <p><strong>Ausgeschlossen</strong> - Komponente ist deaktiviert und nicht Bestandteil der Anwendung.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518075385303104)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erstelloption'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506634598303094)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Erstelloptionsstatus f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015020642303516)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Ausschlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015182680303516)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die &PRODUCT_NAME. Engine betrachtet diese Komponente als nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014826861303516)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'de'
,p_message_text=>'Aufnehmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014964566303516)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die &PRODUCT_NAME. Engine betrachtet diese Komponente zur Laufzeit als Bestandteil der Anwendungsdefinition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506510714303094)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620269918303183)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Aktion, die beim Klicken auf diese Schaltfl\00E4che ausgef\00FChrt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040816163303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'de'
,p_message_text=>'Von dynamischer Aktion definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040943841303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Leitet die Seite nicht weiter oder nimmt keine Umleitung zu einer anderen Seite vor. Stattdessen wird das Schaltfl\00E4chen-Verhalten von einer dynamischen Aktion definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041216665303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste Seite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041387502303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Umleitung zur n\00E4chsten Seite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041410415303538)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'de'
,p_message_text=>'Vorherige Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041586807303538)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Umleitung zur vorherigen Seite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040468457303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in einer anderen Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040531739303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nehmen Sie eine Umleitung zu einer Seite in einer anderen Anwendung vor, mit optionalen zus\00E4tzlichen Attributen zum Zur\00FCcksetzen des Seitenumbruchs, Festlegen des Anforderungswertes, L\00F6schen des Cache und Festlegen der Elementwerte auf der Zielsei')
||'te.</p>',
unistr('<p>Hinweis: F\00FCr die Umleitung zu einer Seite in einer anderen Anwendung muss Deeplinking in der Zielanwendung aktiviert sein. Gehen Sie hierf\00FCr zu den Attributen f\00FCr <em>Sicherheit</em> der Anwendung, und aktivieren Sie <em>Deeplinking</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040294871303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in dieser Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040390461303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Nehmen Sie eine Umleitung zu einer Seite in der aktuellen Anwendung vor, mit optionalen zus\00E4tzlichen Attributen zur Zur\00FCcksetzung des Seitenumbruchs, Festlegung des Anforderungswertes, L\00F6schen des Cache und Festlegen der Elementwerte auf der Zielseit')
||'e.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040651259303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'de'
,p_message_text=>'Zu URL umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040759903303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu der von Ihnen angegebenen Ziel-URL vor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041075258303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041117392303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Setzen Sie die Seite zur\00FCck, indem Sie eine vollst\00E4ndige Seitenaktualisierung und keine teilweise Seitenaktualisierung (PPR, Partial Page Refresh) vornehmen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040028395303536)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'de'
,p_message_text=>'Seite senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99040156888303537)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Leiten Sie die aktuelle Seite mit einem REQUEST-Wert weiter, der identisch mit dem Schaltfl\00E4chennamen ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620136246303183)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523573984303108)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den Typ des SQL-Vorgangs, der bei Klicken auf diese Schaltfl\00E4che ausgef\00FChrt wird.'),
unistr('Diese Auswahl wird verwendet, um die angegebene Datenbankaktion innerhalb der integrierten automatischen Zeilenverarbeitung (DML) auszul\00F6sen.'),
unistr('Wenn Sie keinen Typ w\00E4hlen, wird die Datenbankverarbeitung basierend auf dem REQUEST-Wert ausgef\00FChrt, der gem\00E4\00DF dem f\00FCr diese Schaltfl\00E4che definierten <strong>Schaltfl\00E4chennamen</strong> festgelegt wird.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035047593303532)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'de'
,p_message_text=>'SQL DELETE-Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034824131303532)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'de'
,p_message_text=>'SQL INSERT-Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034916294303532)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'de'
,p_message_text=>'SQL UPDATE-Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523476551303108)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenbankaktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218229429303677)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Schaltfl\00E4chenanzeigetyp aus, um die Darstellung dieser Schaltfl\00E4che zu definieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218585598303678)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'de'
,p_message_text=>'Symbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218681569303678)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt nur ein Symbol an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218368202303678)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218461210303678)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt nur das Schaltfl\00E4chenlabel an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218702257303678)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'de'
,p_message_text=>'Text mit Symbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218844249303678)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt ein Symbol neben dem Schaltfl\00E4chenlabel an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218117252303677)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigetyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320000246303769)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zus\00E4tzliche Attribute ein, die nach der HTML-Tabellenzelle angezeigt werden, in der jede einzelne Option in einer Optionsgruppe oder einer Gruppe von Kontrollk\00E4stchen angezeigt wird.'),
unistr('Sie k\00F6nnen HTML, JavaScript und Shortcuts aufnehmen.</p>'),
unistr('<p>Sie k\00F6nnen die folgenden Ersetzungszeichenfolgen referenzieren:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ruft den Namen des HTML-Form-Elements auf, mit dem dieses Seitenelement verkn\00FCpft ist.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ruft den Namen des aktuellen Seitenelements ab.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319998946303769)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Post-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319844632303769)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zus\00E4tzliche Attribute ein, die vor der HTML-Tabellenzelle angezeigt werden, in der jede einzelne Option in einer Optionsgruppe oder einer Gruppe von Kontrollk\00E4stchen angezeigt wird.'),
unistr('Sie k\00F6nnen HTML, JavaScript und Shortcuts aufnehmen.</p>'),
unistr('<p>Sie k\00F6nnen die folgenden Ersetzungszeichenfolgen referenzieren:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ruft den Namen des HTML-Form-Elements auf, mit dem dieses Seitenelement verkn\00FCpft ist.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ruft den Namen des aktuellen Seitenelements ab.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319777693303769)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Pre-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523398043303108)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die Seite weitergeleitet wird und dieses Attribut auf <strong>Ein</strong> gesetzt ist, werden alle f\00FCr die Seite definierten Validierungen sowie die integrierten Validierungen (wie "erforderlich", "g\00FCltige Zahl" oder "g\00FCltiges Datum") auf de')
||unistr('r Serverseite ausgef\00FChrt.'),
unistr('Wenn dar\00FCber hinaus der <em>Kompatibilit\00E4tsmodus</em> der Anwendung auf <strong>5.1</strong> oder h\00F6her gesetzt ist, f\00FChrt &PRODUCT_NAME. au\00DFerdem clientseitige Validierungen durch, wie beispielsweise "Element erforderlich". N\00E4here Einzelheiten finde')
||unistr('n Sie in den Versionshinweisen unter "Kompatibilit\00E4tsmodus".'),
'Die Seite wird erst weitergeleitet, wenn alle Probleme behoben sind.</p>',
unistr('<p>Wenn der Wert auf <strong>Aus</strong> gesetzt ist, wird keine der definierten Validierungen und integrierten Validierungen ausgef\00FChrt.'),
unistr('Wenn eine bestimmte Validierung unabh\00E4ngig von dieser Einstellung ausgef\00FChrt werden soll, \00E4ndern Sie die Validierung, und setzen Sie das Validierungsattribut <strong>Immer ausf\00FChren</strong> auf <strong>Ein</strong>.</p>'),
unistr('<p>Dieses Attribut ist besonders f\00FCr Schaltfl\00E4chen wie "L\00F6schen" oder "Abbrechen" n\00FCtzlich, bei denen die meisten Validierungen nicht ausgef\00FChrt werden m\00FCssen.'),
unistr('Benutzer sollten im Allgemeinen nicht an der Ausf\00FChrung derartiger Aktionen gehindert werden, wenn ein Element Null ist oder den falschen Typ hat.'),
unistr('Wenn jedoch Aktionen wie "L\00F6schen" nur von autorisierten Benutzern ausgef\00FChrt werden sollen, muss das entsprechende Validierungsattribut <strong>Immer ausf\00FChren</strong> unbedingt auf <strong>Ein</strong> gesetzt werden. Alternativ muss sichergestell')
||unistr('t sein, dass eine entsprechende Bedingung f\00FCr die Schalfl\00E4che selbst definiert ist, damit die Schaltfl\00E4che nur autorisierten Benutzern angezeigt wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523252633303108)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Validierungen ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219656708303679)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob der Typ <strong>Normal</strong> oder <strong>Online</strong> beim Rendering dieser Schaltfl\00E4che verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522918455303108)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob das Schaltfl\00E4chentemplate <strong>Normal</strong> oder <strong>Online</strong> beim Rendering dieser Schaltfl\00E4che verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522872593303108)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Online'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219463754303678)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text ein, der auf der Schaltfl\00E4che angezeigt werden soll. Hat die Schaltfl\00E4che den Anzeigetyp "Symbol", wird dieser Text zum ALT-Text f\00FCr das Symbolbild.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536239179303118)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die Schaltfl\00E4che aus Text besteht, geben Sie den Text ein, der auf der Schaltfl\00E4che angezeigt wird. Wenn die Schaltfl\00E4che ein Bild ist, wird dieser Text zum ALT-Text f\00FCr das Bild.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536170662303118)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547147648303127)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen ein, mit dem Sie die Schaltfl\00E4che referenzieren, auf die geklickt wird. Wenn diese Seite weitergeleitet ist, wird der Wert REQUEST auf den Schaltfl\00E4chennamen gesetzt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536034779303118)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen ein, mit dem diese Schaltfl\00E4che bei nachfolgenden Seitenverarbeitungen identifiziert wird.'),
unistr('Wenn die Seite weitergeleitet wird, wird der REQUEST-Wert durch Klicken auf diese Schaltfl\00E4che auf den eingegebenen Namen festgelegt.</p>'),
unistr('<p>Der Schaltfl\00E4chenname muss f\00FCr Schaltfl\00E4chen auf derselben Seite oder in derselben Region nicht eindeutig sein.'),
unistr('Sie k\00F6nnen mehrere Schaltfl\00E4chen mit demselben Schaltfl\00E4chennamen definieren. Dadurch wird derselbe REQUEST-Wert festgelegt, wenn auf die Schaltfl\00E4che geklickt wird.'),
unistr('Dies eignet sich zur Definition von Schaltfl\00E4chen mit unterschiedlichen <strong>Schaltfl\00E4chenlabels</strong> oder Bedingungen, die dieselbe Seitenverarbeitung ausf\00FChren m\00FCssen, indem einfach der gemeinsame REQUEST-Wert ausgewertet wird.</p>'),
unistr('<p>Wenn Sie die Schaltfl\00E4che <code>FLOW_RESET_BUTTON</code> benennen, setzt die Schaltfl\00E4che die aktuelle Seite zur\00FCck, ohne eine Seite weiterzuleiten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535965676303118)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Name der Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319471648303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn auf diese Schaltfl\00E4che geklickt wird, wird die Seite weitergeleitet und die Seitenanforderung wird auf diesen Wert gesetzt. Wenn dieser Wert nicht angegeben ist und <em>Quelltyp der Anforderung</em> dem Typ <em>Statischer Wert</em> entspricht, w')
||unistr('ird der Schaltfl\00E4chenname als Anforderungswert verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319304088303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anforderungsquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317334272303766)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Identifiziert den Ausdruckstyp, der in dem Anforderungsquellattribut enthalten ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319174141303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319282962303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf Null festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317610912303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317770807303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den in <em>Datenbankspalte</em> eingegebenen Wert festgelegt, der aus einer integrierten Prozedur zum Abruf von Zeilen abgerufen wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318598977303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318686779303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der sich aus der Ausf\00FChrung des eingegebenen <em>PL/SQL-Ausdrucks</em> ergibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318716827303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318804237303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der von dem eingegebenen <em>PL/SQL-Funktionsbody</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317892789303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318014228303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Element</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318989013303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319023044303768)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Wert der eingegebenen <em>Voreinstellung</em> festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318177231303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage (einzelner Wert wird zur\00FCckgegeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318218478303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den ersten Wert festgelegt, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318304456303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage (durch Doppelpunkte getrennten Wert zur\00FCckgeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99318407587303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf einen einzelnen durch Doppelpunkt getrennten Wert festgelegt, der jeden Zeilenwert verkettet, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317482266303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317529685303767)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Text festgelegt, der in <em>Statischen Wert</em> eingegeben wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99317226127303766)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Quelltyp der Anforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523181509303108)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf das Ziel, um einen modalen Dialog aufzurufen. Sie k\00F6nnen das Ziel eingeben, das aufgerufen werden muss, wenn auf diese Schaltfl\00E4che geklickt wird. Geben Sie nur ein Ziel f\00FCr Schaltfl\00E4chen an, die keine Seitenverarbeitung aufrufen soll')
||unistr('en, wenn auf sie geklickt wird. (Beispiel: Eine Schaltfl\00E4che "Abbrechen".)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523074884303108)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522757656303107)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein Schaltfl\00E4chentemplate aus, um die Darstellung dieser Schaltfl\00E4che zu definieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522623731303107)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen-Template')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198947343303662)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Seitenstandardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99220070972303679)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfung auf nicht gespeicherte \00C4nderungen erfolgt, wenn auf die Schaltfl\00E4che geklickt wird und die Pr\00FCfung auf Seitenebene aktiviert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198641764303662)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob der Benutzer gewarnt wird, wenn er versucht, durch Klicken auf die Schaltfl\00E4che aus der Seite zu navigieren, w\00E4hrend diese nicht gespeicherte \00C4nderungen enth\00E4lt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198751982303662)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201327267303664)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Pr\00FCfung auf nicht gespeicherte \00C4nderungen wird nicht ausgef\00FChrt, wenn auf die Schaltfl\00E4che geklickt wird. Diese Einstellung muss f\00FCr die Schaltfl\00E4chen "Abbrechen", "L\00F6schen" und "\00C4nderungen anwenden" verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198570249303662)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung bei nicht gespeicherten \00C4nderungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249273037303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249637911303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249511391303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249464089303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249768633303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249354160303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249157226303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251227977303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251543224303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251488219303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251373564303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251619521303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251150291303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524731865303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524603462303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526152158303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526079728303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250825592303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250784443303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252496170303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252313455303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250690628303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250519816303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250494419303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252275030303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252162764303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252056905303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524908897303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Doppelpunkt getrennte Liste der Werte f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524820460303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525357425303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Seitennummer f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525209375303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525581066303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Komma getrennte Liste mit Seitennummern f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525457602303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250305240303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist oder ein Manager ist:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250294481303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250169840303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251952356303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251801551303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251721073303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525133876303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Benutzervoreinstellung ein, die mit dem angegebenen Wert f\00FCr diese Bedingung verglichen wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525038688303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99251072817303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250901657303710)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252638959303712)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252511235303711)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99250008902303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter ein Manager ist und sich die Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          wobei deptno = :P2_DEPTNO',
'            und loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249981751303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249849082303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403204281303838)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn eine oder mehrere Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 30',
'</pre></dd>',
unistr('<dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn keine Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 40 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524302949303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524207061303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525779769303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Textwert f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525604193303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526310742303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526242316303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606777268303173)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Bedingungstyp, der erf\00FCllt werden muss, damit die Region gecacht werden kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524143680303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Bedingung ein. Wenn die Bedingung <strong>TRUE</strong> zur\00FCckgibt, wird die Seite aus dem Cache angezeigt. Wenn die Bedingung <strong>FALSE</strong> zur\00FCckgibt, wird die Seite dynamisch wiedergegeben und nicht aus dem Cache abgerufen.')
||' '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089410627303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'de'
,p_message_text=>'Immer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230968923303693)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Komponente wird immer wiedergegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088007657303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Microsoft Internet Explorer 7.0 oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088133264303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: XHTML-/CSS-f\00E4higer Browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087930226303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Mozilla, Netscape 6.x/7x oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088282570303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Andere Browser (oder \00E4ltere Version)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086636596303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Element enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088642248303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234595525303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088354939303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234741634303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088578758303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234611992303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088450979303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234887104303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085884376303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233394182303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086041505303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233593427303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085910950303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233417994303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht nicht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086145788303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist NICHT in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233688031303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist nicht in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088703424303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088843720303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087593816303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234300604303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird auf der Seite nach einer Weiterleitung der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086990543303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086700229303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086831026303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087077518303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083567316303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCckgegebene Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231088622303693)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt mindestens eine Zeile zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248977312303708)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99249037729303709)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Auswertung des Ausdrucks ergibt TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083745488303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231252409303693)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Funktionsbody gibt TRUE zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089186599303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089247421303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087233213303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist NICHT schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234012549303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite bzw. \00FCbergeordnete Region wird normal angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087145318303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233966534303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Auswertung der Bedingung "Schreibgesch\00FCtzt" der Seite bzw. \00FCbergeordneten Region ergibt TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085080825303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt keine Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232520997303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> enth\00E4lt keine Leerzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085306315303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist alphanumerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232839027303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist alphanumerisch und enth\00E4lt nur Buchstaben oder Zahlen und keine Sonderzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084547615303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232055246303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085296971303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232745137303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084711300303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232260921303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084446777303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231955150303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084801310303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL oder Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232385554303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer oder entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085198525303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232638014303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084657691303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232145955303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084998307303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL und NICHT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232414438303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer und entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087758698303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Weiter" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087811097303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Zur\00FCck" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089325473303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087661948303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler nicht angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234442975303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird nicht auf der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083653715303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Zeilen zur\00FCckgegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231154734303693)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt keine Zeilen zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086478939303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich im Druckversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233748718303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086510556303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich nicht im Druckerversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233887471303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer nicht in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083889203303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231381082303693)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084040743303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231582286303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083953772303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231418731303693)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084161244303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231666707303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist nicht in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99088993421303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089013950303576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087324902303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist berechtigt (nicht \00F6ffentlich)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234119223303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99087453913303575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist der \00F6ffentliche Benutzer (Benutzer ist nicht berechtigt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234237580303696)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist nicht bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085638159303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung = Wert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233158580303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085723609303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233234235303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085427178303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99232963668303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99085502155303573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99233086185303695)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingegeben haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084262660303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231729138303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99084343608303572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99231890656303694)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086336541303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99086253133303574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524004096303108)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524540699303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Wert ein, mit dem die Bedingung verglichen werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98524434774303109)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525918135303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98525885823303110)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343847282303789)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Komma getrennte Liste der Elemente ein, von denen gecachter Inhalt abh\00E4ngt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343713178303788)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00E4ngt von Elementen ab')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337879239303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie die &PRODUCT_NAME. Engine den HTML-Text auf der Serverseite cachen kann. Wenn das Caching verwendet werden kann, wird das gecachte Ergebnis ausgegeben, anstatt es erneut zu berechnen. Dadurch wird teure Berechnungszeit auf dem Server ')
||unistr('verringert. Dieses Feature ist nicht mit den Caching-M\00F6glichkeiten des Browsers verkn\00FCpft.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338108833303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338237187303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'de'
,p_message_text=>'Inhalt ist gecacht und wird von allen Benutzern verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337900989303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338079334303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Inhalt ist nicht f\00FCr jede Anforderung gecacht und berechnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338502371303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'de'
,p_message_text=>'Nach Session cachen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338632854303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Inhalt ist speziell f\00FCr jede Session gecacht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338386993303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'de'
,p_message_text=>'Cache pro Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99338447754303784)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Inhalt ist speziell f\00FCr jeden Benutzer gecacht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337789462303783)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Caching'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517730259303103)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie lange eine gecachte Seite g\00FCltig ist. Nachfolgende Seitenanforderungen nutzen die gecachte Seite nicht, wenn der Timeout abgelaufen ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019119130303519)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'de'
,p_message_text=>'10 Sekunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019779562303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'de'
,p_message_text=>'3 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020637341303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'de'
,p_message_text=>'2 Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019803187303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'de'
,p_message_text=>'4 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020296107303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'de'
,p_message_text=>'2 Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019435894303519)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'de'
,p_message_text=>'30 Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019988003303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'de'
,p_message_text=>'6 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020742341303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'de'
,p_message_text=>'4 Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020323196303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'de'
,p_message_text=>'3 Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020916982303521)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'de'
,p_message_text=>'1 Jahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020404954303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'de'
,p_message_text=>'4 Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019500707303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'de'
,p_message_text=>'1 Stunde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020052716303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'de'
,p_message_text=>'12 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019254541303519)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'de'
,p_message_text=>'1 Minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019302250303519)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'de'
,p_message_text=>'10 Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020582904303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'de'
,p_message_text=>'1 Woche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020890044303521)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'de'
,p_message_text=>'10 Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019625917303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'de'
,p_message_text=>'2 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99020167621303520)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'de'
,p_message_text=>'1 Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517618649303103)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Cachetimeout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064783067303556)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt Spaltenwerte an</dt>',
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
'<dt>Zeigt ein Bild in einem Kalenderereignis an.</dt>',
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910981023303425)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie benutzerdefinierten Text zur Anzeige in Kalenderzellen ein. Sie k\00F6nnen HTML-Ausdr\00FCcke eingeben und die <code>#COLUMN_NAME#</code>-Syntax zur Anzeige von Spaltenwerten verwenden. Mit diesem Anzeigetyp k\00F6nnen Sie mehrere Spalten in der Anzeig')
||'e eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910884143303425)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniertes Anzeigeformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905117951303421)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie das Seiten- oder Anwendungselement, das das Startdatum des Kalenders enth\00E4lt, der aktuell f\00FCr den Endbenutzer angezeigt wird.'),
unistr('Dieses Element wird von der &PRODUCT_NAME. Engine verwendet, wenn der Endbenutzer zu dem vorherigen oder n\00E4chsten Zeitraum navigiert.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905004316303421)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905717929303421)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die in dem Kalender angezeigten Werte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064177846303556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064201410303556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verwendet das Attribut <strong>Spalte anzeigen</strong>, um die in der Kalenderzelle anzuzeigende Spalte zu w\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064334330303556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064422940303556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Erm\00F6glicht die Eingabe eines benutzerdefinierten Spaltenformats mit HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064548103303556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Kein Anzeigewert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064602661303556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>'In den Kalenderzellen werden keine Daten angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905611973303421)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigetyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905346282303421)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie das Seiten- oder Anwendungselement, das das Enddatum des Kalenders enth\00E4lt, der aktuell f\00FCr den Endbenutzer angezeigt wird.'),
unistr('Dieses Element wird von der &PRODUCT_NAME. Engine verwendet, wenn der Endbenutzer zu dem vorherigen oder n\00E4chsten Zeitraum navigiert.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905280921303421)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Enddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904548569303420)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein Template, das bei der Wiedergabe des Kalenders verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904451787303420)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905520458303421)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Seiten- oder Anwendungselement, das den Kalendertyp enth\00E4lt, der aktuell f\00FCr den Endbenutzer angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905402816303421)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217947088303677)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Anzahl der Karten ein, die pro Seite angezeigt werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217812783303677)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Karten pro Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216707303303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Bestimmt die Position der Schaltfl\00E4che auf der Karte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216818483303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'de'
,p_message_text=>'Primary'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216988020303677)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Sekund\00E4r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216656117303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215586984303675)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Typ der Aktion aus, die der Komponente hinzugef\00FCgt werden soll.</p>'),
unistr('<p>Sie k\00F6nnen mehrere Aktionen des gleichen Typs definieren. Es werden jedoch nur Schaltfl\00E4chenaktionen mehrfach gerendert.'),
'Bei allen anderen Aktionstypen wird die erste TRUE-Anzeigebedingung gerendert, und der Rest wird ignoriert.</p>',
unistr('<p>Anzeigebedingungen k\00F6nnen auf der Basis der Spaltenwerte definiert werden, wenn die Ausf\00FChrungsbedingung auf Pr\00FCfung f\00FCr jede Zeile eingestellt ist.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215604518303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215770101303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt der Karte Schaltfl\00E4chen hinzu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215897350303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'de'
,p_message_text=>'Ganze Karte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215959861303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('F\00FCgt der ganzen Karte einen Link hinzu. In der Regel muss eine Aktion dieses Typs definiert werden.'),
unistr('Werden mehrere definiert, f\00FCgen Sie eine Anzeigebedingung auf der Basis des Spaltenwertes hinzu, und stellen Sie sie auf Pr\00FCfung jeder Zeile ein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216480351303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'de'
,p_message_text=>'Medien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216524753303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('F\00FCgt den Kartenmedien einen Link hinzu. In der Regel muss eine Aktion dieses Typs definiert werden.'),
unistr('Werden mehrere definiert, f\00FCgen Sie eine Anzeigebedingung auf der Basis des Spaltenwertes hinzu, und stellen Sie sie auf Pr\00FCfung jeder Zeile ein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216275425303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'de'
,p_message_text=>'Untertitel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216345116303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('F\00FCgt dem Kartenuntertitel einen Link hinzu. In der Regel muss eine Aktion dieses Typs definiert werden.'),
unistr('Werden mehrere definiert, f\00FCgen Sie eine Anzeigebedingung auf der Basis des Spaltenwertes hinzu, und stellen Sie sie auf Pr\00FCfung jeder Zeile ein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216062773303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'de'
,p_message_text=>'Titel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99216120107303676)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('F\00FCgt dem Kartentitel einen Link hinzu. In der Regel muss eine Aktion dieses Typs definiert werden.'),
unistr('Werden mehrere definiert, f\00FCgen Sie eine Anzeigebedingung auf der Basis des Spaltenwertes hinzu, und stellen Sie sie auf Pr\00FCfung jeder Zeile ein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215463522303675)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204489903303667)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie CSS-Klassen ein, die jeder einzelnen Karte hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204349676303667)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209637852303671)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Nach rechts zeigendes Chevron anzeigen</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209593613303671)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen f\00FCr das Symbol ein, das Sie zu der Komponente hinzuf\00FCgen m\00F6chte. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('        <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209455260303671)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310557222303760)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Nach rechts zeigendes Chevron anzeigen</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310445154303760)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen f\00FCr das Symbol ein, das Sie zu der Komponente hinzuf\00FCgen m\00F6chte. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('        <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310322137303760)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202841120303665)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Diese Eigenschaft bestimmt, wie die Karten auf der Seite angeordnet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203108897303666)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'de'
,p_message_text=>'Gleitkomma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203234450303666)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Karten werden auf die n\00E4chste Zeile ger\00FCckt, wenn sie in horizontaler Richtung nicht mehr auf den Bildschirm passen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202992548303666)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'de'
,p_message_text=>'Grid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203049373303666)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'de'
,p_message_text=>'Ordnet die Karten in einem Spaltenraster an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203343859303666)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'de'
,p_message_text=>'Horizontal (Zeile)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203436859303666)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Karten werden \00FCbereinander angeordnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202797873303665)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217132842303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Aktion aus, die beim Klicken auf den angegebenen Aktionstyp ausgef\00FChrt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217435270303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in einer anderen Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217524204303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nehmen Sie eine Umleitung zu einer Seite in einer anderen Anwendung vor, mit optionalen zus\00E4tzlichen Attributen zum Zur\00FCcksetzen des Seitenumbruchs, Festlegen des Anforderungswertes, L\00F6schen des Cache und Festlegen der Elementwerte auf der Zielsei')
||'te.</p>',
unistr('<p>Hinweis: F\00FCr die Umleitung zu einer Seite in einer anderen Anwendung muss Deeplinking in der Zielanwendung aktiviert sein. Gehen Sie hierf\00FCr zu den Attributen f\00FCr <em>Sicherheit</em> der Anwendung, und aktivieren Sie <em>Deeplinking</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217211849303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in dieser Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217353940303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Nehmen Sie eine Umleitung zu einer Seite in der aktuellen Anwendung vor, mit optionalen zus\00E4tzlichen Attributen zum Zur\00FCcksetzen der Paginierung, Festlegen des Anforderungswertes, L\00F6schen des Cache und Festlegen der Elementwerte auf der Zielseite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217666501303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'de'
,p_message_text=>'Zu URL umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217766015303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu der von Ihnen angegebenen Ziel-URL vor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99217097237303677)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330225468303777)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die erste Prim\00E4rschl\00FCsselspalte in der Regionsquelle aus. Wenn der Prim\00E4rschl\00FCssel dieser Tabelle mehr als zwei Spalten enth\00E4lt, m\00FCssen Sie die Spalte <code>ROWID</code> ausw\00E4hlen. Wenn die Paginierung per Scrollen f\00FCr die Region festgeleg')
||unistr('t ist, wird anhand des Prim\00E4rschl\00FCssels verhindert, dass doppelte Zeilen angezeigt werden. Wenn die Region ein Bild aus einer BLOB-Spalte anzeigt, wird das Bild mit dem Prim\00E4rschl\00FCssel abgerufen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330183265303777)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330669256303777)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die erste Prim\00E4rschl\00FCsselspalte in der Regionsquelle aus. Wenn der Prim\00E4rschl\00FCssel dieser Tabelle mehr als zwei Spalten enth\00E4lt, m\00FCssen Sie die Spalte <code>ROWID</code> ausw\00E4hlen. Wenn die Paginierung per Scrollen f\00FCr die Region festgeleg')
||unistr('t ist, wird anhand des Prim\00E4rschl\00FCssels verhindert, dass doppelte Zeilen angezeigt werden. Wenn die Region ein Bild aus einer BLOB-Spalte anzeigt, wird das Bild mit dem Prim\00E4rschl\00FCssel abgerufen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330589081303777)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330477916303777)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die zweite Prim\00E4rschl\00FCsselspalte nur aus, wenn der Prim\00E4rschl\00FCssel f\00FCr die Regionsquelle zwei Spalten enth\00E4lt. Wenn Sie <code>ROWID</code> f\00FCr die erste Prim\00E4rschl\00FCsselspalte ausw\00E4hlen, d\00FCrfen Sie diese Spalte nicht auff\00FCllen. Wenn die Pag')
||unistr('inierung per Scrollen f\00FCr die Region festgelegt ist, wird anhand des zweiten Prim\00E4rschl\00FCssels verhindert, dass doppelte Zeilen angezeigt werden. Wenn die Region ein Bild aus einer BLOB-Spalte anzeigt, wird das Bild mit dem zweiten Prim\00E4rschl\00FCssel abg')
||'erufen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330361504303777)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330801101303778)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die zweite Prim\00E4rschl\00FCsselspalte nur aus, wenn der Prim\00E4rschl\00FCssel f\00FCr die Regionsquelle zwei Spalten enth\00E4lt. Wenn Sie <code>ROWID</code> f\00FCr die erste Prim\00E4rschl\00FCsselspalte ausw\00E4hlen, d\00FCrfen Sie diese Spalte nicht auff\00FCllen. Wenn die Pag')
||unistr('inierung per Scrollen f\00FCr die Region festgelegt ist, wird anhand des zweiten Prim\00E4rschl\00FCssels verhindert, dass doppelte Zeilen angezeigt werden. Wenn die Region ein Bild aus einer BLOB-Spalte anzeigt, wird das Bild mit dem zweiten Prim\00E4rschl\00FCssel abg')
||'erufen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99330734650303778)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218097502303677)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Karte verwendet BLOB-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870784436303392)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Datenbankspaltennamen der Werteliste unter Beachtung der Gro\00DF-/Kleinschreibung ein, mit dem die Werteliste anhand des \00FCbergeordneten Facet- oder Filterwertes abgefragt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870630695303392)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wertelistenspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407604511303842)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Spalten ein, die die Aktualisierung dieser Werteliste ausl\00F6sen.'),
'Trennen Sie bei mehreren Spalten die Spaltennamen durch ein Komma.',
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Spalten ausw\00E4hlen.'),
unistr('Wenn Sie den Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Spaltennamen.</p>'),
unistr('<p>Diese Werteliste wird jedes Mal aktualisiert, wenn der Wert von einer der angegebenen Spalten auf dieser Seite ge\00E4ndert wird.</p>'),
unistr('<p>Sie m\00FCssen die in diesem Attribut angegebenen Spalten innerhalb der <em>Where-Klausel</em> dieser Wertelisten-SQL-Abfrage verwenden, um die zur\00FCckgegebenen Werte einzuschr\00E4nken.</p>'),
unistr('<p>Beispiel: Wenn Spalten f\00FCr Fahrzeugfabrikat und -modell vorhanden sind, k\00F6nnten Sie "Fahrzeugfabrikat" als "Kaskadierendes \00FCbergeordnetes Wertelistenelement" innerhalb der Wertelistendefinition f\00FCr "Modell" angeben und "Fahrzeugfabrikat" innerhalb')
||unistr(' der Where-Klausel f\00FCr diese Werteliste verwenden.'),
unistr('Wenn danach "Fahrzeugfabrikat" ge\00E4ndert wird, wird die Werteliste f\00FCr Fahrzeugmodell aktualisiert und die Liste zeigt nur Werte f\00FCr das aktuell ausgew\00E4hlte Fahrzeugfabrikat an.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407518988303842)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Spalte(n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870918480303392)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein Facet aus, das die Aktualisierung dieser Werteliste ausl\00F6st.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870873040303392)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnetes Facet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557362733303135)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Filter aus, der die Aktualisierung dieser Werteliste ausl\00F6st.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557220322303135)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordneter Filter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522491942303107)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Seiten- oder Anwendungselemente ein, die die Aktualisierung dieser Werteliste ausl\00F6sen.'),
'Trennen Sie bei mehreren Elementen die Elementnamen durch ein Komma.',
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.'),
unistr('Wenn Sie den Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Elementnamen.</p>'),
unistr('<p>Diese Werteliste wird jedes Mal aktualisiert, wenn der Wert von einem der angegebenen Elemente auf dieser Seite ge\00E4ndert wird.</p>'),
unistr('<p>Sie m\00FCssen die in diesem Attribut angegebenen Seitenelemente innerhalb der <em>Where-Klausel</em> dieser Wertelisten-SQL-Abfrage verwenden, um die zur\00FCckgegebenen Werte einzuschr\00E4nken.</p>'),
unistr('<p>Beispiel: Wenn Seitenelemente f\00FCr Fahrzeugfabrikat und -modell vorhanden sind, k\00F6nnten Sie "Fahrzeugfabrikat" als "\00DCberlappendes \00FCbergeordnetes Wertelistenelement" innerhalb der Wertelistendefinition f\00FCr "Modell" angeben und "Fahrzeugfabrikat" inn')
||unistr('erhalb der Where-Klausel f\00FCr diese Werteliste verwenden.'),
unistr('Wenn danach "Fahrzeugfabrikat" ge\00E4ndert wird, wird die Werteliste f\00FCr Fahrzeugmodell aktualisiert und die Liste zeigt nur Werte f\00FCr das aktuell ausgew\00E4hlte Fahrzeugfabrikat an.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522352451303107)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete(s) Element(e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867789191303390)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, unter welchen Bedingungen diese Werteliste aktualisiert wird.</p>',
unistr('<p>Wenn dieser Wert auf <strong>Ein</strong> gesetzt ist, wird der Aktualisierungsaufruf zum Abrufen neuer Werte nur ausgef\00FChrt, wenn alle <em>kaskadierenden \00FCbergeordneten Wertelistenelemente</em> ungleich Null sind.'),
unistr('Wenn ein Element Null ist, wird davon ausgegangen, dass die Wertelistenabfrage keine Zeilen zur\00FCckgibt.'),
unistr('In diesen F\00E4llen werden die Auswahllisteneintr\00E4ge einfach im Browser gel\00F6scht, ohne eine Aktualisierung durchzuf\00FChren.</p>'),
unistr('<p>Wenn die Option auf <strong>Aus</strong> gesetzt ist, wird die Aktualisierung immer durchgef\00FChrt.'),
unistr('Diese Option wird nur verwendet, wenn Sie auf Null setzbare <em>kaskadierende \00FCbergeordnete Wertelistenelemente</em> in der <em>Where-Klausel</em> dieser Wertelisten-SQL-Abfrage speziell verarbeiten.'),
unistr('Wenn auf Null setzbare Seitenelemente nicht ordnungsgem\00E4\00DF verarbeitet werden, werden nicht erforderliche Aktualisierungsaufrufe ausgef\00FChrt, die niemals Zeilen zur\00FCckgeben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867675546303390)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnetes Element erforderlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153247485302808)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Benutzerzugangsdaten des Entwicklers an, der dieses Attribut zuletzt aktualisiert hat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153101256302808)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ge\00E4ndert von')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153467869302808)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt an, wann dieses Attribut zuletzt aktualisiert wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153341350302808)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ge\00E4ndert am')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903217047303419)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die H\00F6he des Diagramms in Pixel an. Die H\00F6he definiert eine feste H\00F6he f\00FCr die Diagrammregion. Um die automatische Skalierung f\00FCr die Diagrammh\00F6he zu aktivieren, lassen Sie dieses Element leer.'),
unistr('Die H\00F6he basiert dann auf der H\00F6he des Browsers.</p>'),
unistr('<p>Standardm\00E4\00DFig wird f\00FCr ein Diagramm, das mit der jQuery Mobile Smartphone-Benutzeroberfl\00E4che auf einer Seite erstellt wird, kein Wert f\00FCr die H\00F6he festgelegt. Sie wird automatisch entsprechend dem Ger\00E4t skaliert, auf dem sie wiedergegeben wird.</p')
||'>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903163580303419)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903327561303419)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927092160303439)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die maximale Breite des Diagramms in Pixel an. Die maximale Breite definiert eine feste Breite f\00FCr die Diagrammregion. Um die automatische Skalierung f\00FCr die Diagrammbreite zu aktivieren, lassen Sie dieses Element leer. Die Breite wird a')
||'utomatisch auf 100 % der Region festgelegt.</p>',
unistr('<p>Standardm\00E4\00DFig wird f\00FCr ein Diagramm, das mit der jQuery Mobile Smartphone-Benutzeroberfl\00E4che auf einer Seite erstellt wird, kein Wert f\00FCr die Breite festgelegt. Sie wird automatisch entsprechend dem Ger\00E4t skaliert, auf dem sie wiedergegeben wird.<')
||'/p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921494120303434)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Maximale Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921524322303434)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'de'
,p_message_text=>' Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900189373303417)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Titel ein, der oben im Diagramm angezeigt wird. Bei Gantt-Diagrammen dient dieser Wert lediglich zur Definition des zug\00E4nglichen Diagrammtitels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900023192303416)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128553633303607)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Speicherort der Daten aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128678058303607)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'de'
,p_message_text=>'Lokale Datenbank'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128773507303607)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Daten werden aus der lokalen Datenbank bezogen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129213797303608)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'de'
,p_message_text=>'Regionsquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129380544303608)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>'Daten werden aus dem Speicherort bezogen, der in der Regionsquelldefinition angegeben ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128855593303607)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128919456303607)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Daten werden aus einer Remotedatenbank bezogen, sofern die Verbindung \00FCber eine REST-f\00E4hige SQL definiert ist. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129052785303608)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'de'
,p_message_text=>'REST-Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129139248303608)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Daten werden aus einem RESTful Webservice bezogen, der \00FCber REST-Datenquellen definiert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99128459051303607)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893802464303411)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Basis f\00FCr diese Berichtsspalte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051632787303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'de'
,p_message_text=>'* Datumsauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051524361303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'de'
,p_message_text=>'* Datumsauswahl (klassisch)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051462111303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'de'
,p_message_text=>'* Als Text anzeigen (speichert Status)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051143882303545)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'de'
,p_message_text=>'BLOB herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228595737303686)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Link zum Herunterladen der Datei an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051397162303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendete Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228735314303686)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte nicht an, ist jedoch referenzierbar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052113602303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'de'
,p_message_text=>'* Ausgeblendetes Feld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051031827303545)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'de'
,p_message_text=>'Bild anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228495790303685)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Bild an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050962110303545)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'de'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228352869303685)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Link an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051268604303545)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'de'
,p_message_text=>'Prozentdiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228602454303686)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Prozentdiagramm an. Der abgerufene Wert muss zwischen 0 und 100 liegen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050769205303545)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'de'
,p_message_text=>'Nur Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228155806303685)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt den Spaltenwert an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050866218303545)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'de'
,p_message_text=>'Nur Text (basierend auf Werteliste)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228226266303685)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt den Wert an, der aus der angegebenen Werteliste zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052211408303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'de'
,p_message_text=>'* Popup-Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052335217303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'de'
,p_message_text=>unistr('* Popup-Schl\00FCsselwerteliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052051731303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'de'
,p_message_text=>'* Optionsgruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299610177303750)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299779228303751)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Rendert die Spalte mit HTML oder Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052577803303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'de'
,p_message_text=>'* Zeilenselektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051937827303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'de'
,p_message_text=>unistr('* Liste ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052460738303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'de'
,p_message_text=>unistr('* Einfaches Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051774184303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'de'
,p_message_text=>'* Textfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99051828420303546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'de'
,p_message_text=>'* Textbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893743424303411)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893462750303411)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Keine Seitennummerierung (alle Zeilen werden angezeigt)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894659519303412)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Keine Seitennummerierung (alle Zeilen werden angezeigt)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879897136303400)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Seitennummerierungstyp f\00FCr diesen Bericht.'),
'Im Allgemeinen wird aktuell nur eine Teilmenge der Ergebnisse in dem Bericht angezeigt.',
unistr('Durch die Seitennummerierung erh\00E4lt der Benutzer Informationen \00FCber die Anzahl von Zeilen und die aktuelle Position innerhalb der Ergebnismenge. Die Seitennummerierung definiert au\00DFerdem den Stil der Links oder Schaltfl\00E4chen, die zur Navigation zur n')
||unistr('\00E4chsten oder vorherigen Seite verwendet werden.</p>'),
unistr('<p>Seitennummern k\00F6nnen \00FCber und/oder unter dem Bericht auf der linken oder rechten Seite angezeigt werden.</p>'),
unistr('<p>Sie k\00F6nnen auch einen vereinfachten Seitennummerierungsstil verwenden, um die Performance zu verbessern, wie <strong>Zeilenbereiche X bis Y (mit "Weiter"- und "Zur\00FCck"-Links)</strong>.'),
unistr('Bei der Verwendung von Seitennummerierungstypen in Form von "X bis Y von Z" muss die &PRODUCT_NAME. Engine zwei Abfragen ausf\00FChren, um die Ergebnisse zur\00FCckzugeben.'),
unistr('Eine Abfrage ruft die aktuell anzuzeigenden Datens\00E4tze ab, und eine weitere Abfrage ruft die Gesamtanzahl von Datens\00E4tzen ab, die in der Kontrolle der Seitennummerierung angezeigt werden soll.'),
unistr('Bei Berichten, die auf \00FCberm\00E4\00DFig gro\00DFen Datensets basieren oder bei sehr aufwendigen CPU-Abfragen, wie zahlreichen nicht-optimalen Tabellen-Joins oder aufwendigen Bedingungen, kann diese zus\00E4tzliche Abfrage zur h\00F6herer Verarbeitungszeit f\00FChren, wodur')
||unistr('ch die Wiedergabe des Berichts l\00E4nger dauert.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060272164303553)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'de'
,p_message_text=>unistr('Extern erstellte Schaltfl\00E4chen f\00FCr die Seitennummerierung verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060306320303553)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenbereiche X bis Y (mit den n\00E4chsten und vorherigen Links)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059602512303552)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche X bis Y (keine Seitennummerierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059783312303552)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche X bis Y von Z (keine Seitennummerierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059950518303552)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche 1-15 16-30 (mit festgelegter Seitennummerierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060014934303553)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche 1-15 16-30 in Auswahlliste (mit Seitennummerierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059847623303552)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche X bis Y von Z (mit Seitennummerierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060155279303553)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'de'
,p_message_text=>'Suchmaschine 1,2,3,4 (auf Gruppe basierte Seitennummerierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879700227303400)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849365746303375)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Anzahl von Symbolen, die pro Zeile in der Symbolansicht angezeigt werden sollen. Bei einem Wert von 5 werden 5 Symbole pro Zeile des Berichts angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047712479303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047862147303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047983750303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'de'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048041591303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'de'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048120437303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'de'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048263459303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'de'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048375939303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'de'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048476167303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'de'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048541781303543)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'de'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849229179303375)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalten pro Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839857910303367)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spaltenanzeigeausrichtung. Beachten Sie, dass Ihre Auswahl vom ausgew\00E4hlten Berichtstemplate unterst\00FCtzt werden muss.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043849947303539)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043719326303539)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043999540303540)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839781109303367)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spaltenausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896150975303413)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Standardtyp f\00FCr den Spaltenwert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063731637303556)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063680362303556)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896013041303413)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751099437303298)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr die Gruppen\00FCberschrift ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839074454303366)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr die \00DCberschrift der Berichtsspalte ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838966862303366)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268717293302901)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ist sortierbar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177966002303646)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die den eindeutigen Schl\00FCssel zum Identifizieren einer Zeile enth\00E4lt. Damit k\00F6nnen Sie den Prim\00E4rschl\00FCsselwert f\00FCr benutzerdefinierten JavaScript-Code oder Zuordnungsereignis-Handler bereitstellen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177876289303646)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschl\00FCsselspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838453848303366)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Spaltennamen f\00FCr diese Berichtsspalte ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838367820303366)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spaltenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893629275303411)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895017452303412)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874163422303395)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob diese Spalte in absteigender Reihenfolge sortiert wird. Wenn keine Angabe gemacht wird, wird die Spalte in aufsteigender Reihenfolge sortiert (Standardwert).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056934426303550)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'de'
,p_message_text=>'Absteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874009332303395)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Richtung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873960909303395)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Sortiersequenz f\00FCr diese Spalte.'),
unistr('Jede Spalte muss eine eindeutige Sequenz haben, damit die Berichtsausgabe ordnungsgem\00E4\00DF angeordnet wird.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056110745303549)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056206265303549)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056352014303550)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'de'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056410097303550)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'de'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056599491303550)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'de'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056606161303550)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'de'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056762605303550)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'de'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056852630303550)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'de'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873812700303395)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Standardsequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838673441303366)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Datentyp f\00FCr die Berichtsspalte ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838578304303366)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872359509303394)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie die Spaltenbreite in Pixel ein. ',
'Verwenden Sie dieses Attribut, wenn Berichte in einem Browser angezeigt werden. ',
unistr('Beachten Sie, dass die Einstellung der Spaltenbreite von dem ausgew\00E4hlten Berichtstemplate unterst\00FCtzt werden muss.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872277689303393)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zellenbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902703266303419)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507040649303095)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie hier Entwicklerkommentare oder -hinweise ein. Diese Kommentare werden nur in App Builder und niemals bei der Ausf\00FChrung der Anwendung angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506955515303095)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Kommentare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204274700303667)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie CSS-Klassen ein, die auf diese Komponente angewendet werden sollen. Diese Klasse gilt f\00FCr den Kartencontainer. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204178822303666)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264221995303721)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264663199303722)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264562541303722)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264490686303721)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264733084303722)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264322409303721)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264173896303721)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266263146303723)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266500814303723)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266420544303723)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266391555303723)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266660445303723)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266141388303723)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511046214303098)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das mit dieser Berechnung aufgef\00FCllt wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510910841303098)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Objektname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511873657303099)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Element ein, dessen Wert zur Auff\00FCllung des Berechnungselements verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511739498303099)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Objektname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265844624303723)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Ausdruck ein, der einen Wert erzeugt, mit dem das Berechnungselement gef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265731378303722)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267439749303724)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen Wert zur\00FCckgibt, mit dem das Berechnungselement gef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267306366303724)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265645930303722)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265509977303722)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Ausdruck ein, der einen Wert erzeugt, mit dem das Berechnungselement gef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265410509303722)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267259167303724)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267116678303724)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen Wert zur\00FCckgibt, mit dem das Berechnungselement gef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267049553303724)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265364987303722)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265225301303722)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck ein, die einen Wert erzeugt, der zur Auff\00FCllung des Berechnungselements verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265128127303722)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266902147303723)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266822822303723)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, die einen Wert zur\00FCckgibt, der zur Auff\00FCllung des Berechnungselements verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266793010303723)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512487356303099)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie aus, an welcher Stelle in der Seitenwiedergabe oder -verarbeitung diese Berechnung ausgef\00FChrt wird.'),
unistr('Der am h\00E4ufigsten verwendete Berechnungspunkt ist <strong>Nach Weiterleitung</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024484133303523)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Nach Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325874016303774)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird nach der Wiedergabe der Regionen ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024696291303524)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'de'
,p_message_text=>'Nach Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326048889303774)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird nach der Wiedergabe des Footers ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024224682303523)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'de'
,p_message_text=>'Nach Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325638386303773)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird nach der Wiedergabe des Headers ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024709596303524)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'de'
,p_message_text=>'Nach Weiterleitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326138810303774)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeitung: Wird nach der Weiterleitung, aber vor der Verarbeitung der Seite ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024340122303523)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Vor Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325712101303773)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird vor der Wiedergabe der Regionen ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024583156303524)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'de'
,p_message_text=>'Vor Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325924338303774)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird vor der Wiedergabe des Footers ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024117575303523)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'de'
,p_message_text=>'Vor Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325536337303773)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird vor der Wiedergabe der Seite ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024078357303523)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'de'
,p_message_text=>'Neue Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325482137303773)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird beim Generieren einer neuen Session ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512320224303099)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Punkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512003410303099)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Benutzervoreinstellung ein, die einen Wert enth\00E4lt, der zur Auff\00FCllung des Berechnungselements verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511996402303099)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99266089506303723)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Ausdruck ein, der einen Wert erzeugt, mit dem das Berechnungselement gef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265992781303723)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267656188303724)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen Wert zur\00FCckgibt, mit dem das Berechnungselement gef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267562561303724)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230853621303693)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage ein, die einen Wert bereitstellt, mit dem das Berechnungselement aufgef\00FCllt wird. Wenn das Ergebnis mehrere Zeilen enth\00E4lt, wird der Wert aus jeder Zeile zu einem einzelnen durch Doppelpunkt begrenzten Wert zusammengef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230750731303693)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99265077860303722)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter ein Manager ist und sich seine Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264934454303722)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen SQL-Ausdruck ein, der einen Wert erzeugt, mit dem das Berechnungselement gef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264861415303722)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511677768303099)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage ein, die einen Wert bereitstellt, mit dem das Berechnungselement aufgef\00FCllt wird. Wenn das Ergebnis mehrere Zeilen enth\00E4lt, wird nur der Wert aus der ersten Zeile zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511528449303098)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511494318303098)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text ein, der zur Auff\00FCllung des Berechnungselements verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511321408303098)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511295113303098)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Berechnungstyp aus der folgenden Liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247365399303707)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247461353303707)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der sich aus der Ausf\00FChrung des eingegebenen <em>Ausdrucks</em> ergibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023504310303523)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225986182303684)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der vom eingegebenen <em>Funktionsbody</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023861813303523)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225688783303683)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Element</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023635173303523)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage (einzelner Wert wird zur\00FCckgegeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225729612303683)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den ersten Wert festgelegt, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023747444303523)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage (durch Doppelpunkte getrennten Wert zur\00FCckgeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225805008303683)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf einen einzelnen durch Doppelpunkt getrennten Wert festgelegt, der jeden Zeilenwert verkettet, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023944894303523)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226096692303684)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Wert der eingegebenen <em>Voreinstellung</em> festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023423323303523)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225507212303683)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Text festgelegt, der in <em>Statischen Wert</em> eingegeben wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98511142713303098)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872165759303393)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie f\00FCr diese Spalte an, ob die Summe berechnet und am Ende des Berichts angezeigt wird. '),
'Bei der Verwendung mit Gruppenwechselspalten werden bei jedem Gruppenwechsel die Gesamtsumme sowie die jeweilige Summe angezeigt.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872096133303393)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Summe berechnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256874187303715)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257299625303715)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257180859303715)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257039005303715)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257382444303716)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256942759303715)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256796259303715)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258827511303717)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259168783303717)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259033784303717)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258942333303717)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259284382303717)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258743012303717)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544500750303125)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544439708303125)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545925289303126)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545874290303126)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258409422303716)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258325822303716)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260018350303718)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259916214303718)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258289541303716)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258131400303716)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258093384303716)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259878107303718)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259727037303718)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259615408303717)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544759393303125)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Doppelpunkt getrennte Liste der Werte f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544632955303125)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545100095303125)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Seitennummer f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545070962303125)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545314707303125)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Komma getrennte Liste mit Seitennummern f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545264225303125)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257988245303716)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist oder ein Manager ist:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257820271303716)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257708693303716)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259574217303717)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259469171303717)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99259357742303717)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544937118303125)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Benutzervoreinstellung ein, die mit dem angegebenen Wert f\00FCr diese Bedingung verglichen wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544894074303125)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258601773303717)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99258553465303717)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260208989303718)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260161919303718)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257613306303716)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter ein Manager ist und sich die Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          wobei deptno = :P2_DEPTNO',
'            und loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257577658303716)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99257443753303716)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403425888303838)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn eine oder mehrere Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 30',
'</pre></dd>',
unistr('<dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn keine Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 40 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544106338303124)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544086903303124)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545553984303126)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Textwert f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545431639303126)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546177455303126)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546048145303126)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919429430303432)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Bedingungstyp aus, der erf\00FCllt werden muss, damit diese Aktion aktiviert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547079668303127)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Bedingungstyp, der erf\00FCllt werden muss, damit diese dynamische Aktion aktiviert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98543090069303124)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Bedingungstyp aus, der erf\00FCllt werden muss, damit diese Komponente verarbeitet oder wiedergegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101429026303586)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'de'
,p_message_text=>'Immer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239015971303700)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Komponente wird immer wiedergegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100024535303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Microsoft Internet Explorer 7.0 oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100185282303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: XHTML-/CSS-f\00E4higer Browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099976105303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Mozilla, Netscape 6.x/7x oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100292245303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Andere Browser (oder \00E4ltere Version)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098687042303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Element enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100614891303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242677428303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100302242303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242830747303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100567135303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242723044303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100418814303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242966008303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097839914303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241422461303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098010553303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241647463303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097915225303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241570885303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht nicht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098179756303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist NICHT in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241782604303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist nicht in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100768363303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100885653303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099534507303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242437765303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird auf der Seite nach einer Weiterleitung der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098993895303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098728665303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098849717303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099038907303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095571279303581)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCckgegebene Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239162364303700)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt mindestens eine Zeile zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256594390303715)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256604259303715)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Auswertung des Ausdrucks ergibt TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095781224303581)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239318017303700)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Funktionsbody gibt TRUE zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101176036303586)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101260358303586)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099232700303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist NICHT schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242188460303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite bzw. \00FCbergeordnete Region wird normal angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099135356303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242027427303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Auswertung der Bedingung "Schreibgesch\00FCtzt" der Seite bzw. \00FCbergeordneten Region ergibt TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097044755303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt keine Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240647241303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> enth\00E4lt keine Leerzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097388588303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist alphanumerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240962460303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist alphanumerisch und enth\00E4lt nur Buchstaben oder Zahlen und keine Sonderzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096566897303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240117644303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097294732303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240815150303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096758080303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240309627303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096484612303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240024113303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096841065303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL oder Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240488600303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer oder entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097186762303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240722046303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096631665303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240212236303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096928736303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL und NICHT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99240512922303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer und entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099718722303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Weiter" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099893750303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Zur\00FCck" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101334521303586)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243083663303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Die Komponente wird niemals wiedergegeben.</p>',
unistr('<p>Hinweis: Wenn Sie eine Bedingung in <strong>Niemals</strong> \00E4ndern, wird jede vorhandene Bedingung entfernt. Um eine Komponente vor\00FCbergehend zu deaktivieren, empfiehlt Oracle stattdessen die Verwendung des Attributs <em>Erstelloption</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099662113303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler nicht angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242500354303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird nicht auf der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095682800303581)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Zeilen zur\00FCckgegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239297311303700)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt keine Zeilen zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098400263303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich im Druckversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241800979303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098555754303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich nicht im Druckerversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241989635303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer nicht in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095812102303581)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239433096303700)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096061253303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239648865303700)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095924544303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239533787303700)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096195954303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239729535303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist nicht in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99100913596303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101079087303585)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099322922303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist berechtigt (nicht \00F6ffentlich)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242283147303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99099495476303584)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist der \00F6ffentliche Benutzer (Benutzer ist nicht berechtigt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99242398510303703)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist nicht bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097676628303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241231058303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097700852303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241373856303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097455692303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241094403303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99097571423303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99241160741303702)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingegeben haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096271264303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239817723303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99096399688303582)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99239988264303701)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098390283303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99098289024303583)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542987129303124)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544362730303125)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Wert ein, mit dem die Bedingung verglichen werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98544278899303125)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545718413303126)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98545672995303126)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415360954303021)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sch\00FCtzen Sie das Verhalten der Schaltfl\00E4che mit einem Best\00E4tigungs-Prompt. Dieser zeigt ein Best\00E4tigungsdialogfeld nach dem Klicken auf die Schaltfl\00E4che an. Dort muss der Benutzer den Vorgang best\00E4tigen, bevor die Schaltfl\00E4chenaktion ausgef\00FChrt wi')
||'rd.</p>',
unistr('<p>Mit dieser Funktion k\00F6nnen Sie sicherstellen, dass Benutzer nicht versehentlich wichtige Aktionen ausf\00FChren, wie das L\00F6schen eines Datensatzes.</p>'),
unistr('<p>Hinweis: Die Best\00E4tigungsschaltfl\00E4che im Dialogfeld \00FCbernimmt das Label vom Label der Hauptschaltfl\00E4che.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415294509303021)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigung erforderlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415647825303021)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>unistr('<pre>M\00F6chten Sie den Mitarbeiter &amp;P1_ENAME. &lt;strong&gt;wirklich&lt;&#x2F;strong&gt; l\00F6schen?</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415547140303021)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Meldung ein, die im Best\00E4tigungsdialogfeld angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415484048303021)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Meldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416382351303022)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415888624303021)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Stil des Dialogfeldes an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416165395303021)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'de'
,p_message_text=>'Gefahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415958501303021)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'de'
,p_message_text=>'Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416276062303022)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416025649303021)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'de'
,p_message_text=>'Warnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98415755810303021)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878251164303399)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Content-Disposition aus der verf\00FCgbaren Liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057197407303550)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'de'
,p_message_text=>'Anhang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057272344303550)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'de'
,p_message_text=>'Inline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878155941303398)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Content Disposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603424807303170)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das URL-Domainattribut f\00FCr das Sessioncookie ein.'),
unistr('Wenn der Vergleich des Endes der Anforderungs-URL nicht mit der angegebenen Domain \00FCbereinstimmt, wird das Cookie nicht an den Browser gesendet.'),
'Der Standardwert ist der Hostname der Anforderungs-URL.</p>',
unistr('<p>Verwenden Sie dieses Attribut, um eine weniger restriktive Domain anzugeben, wenn Sie Sessioncookies f\00FCr Anwendungen gemeinsam verwenden m\00F6chten, die gemeinsame Domains haben.'),
unistr('Beispiel: <code>my.yahoo.com</code>, <code>sport.yahoo.com</code> und <code>finance.yahoo.com</code> k\00F6nnten alle auf dasselbe Cookie zugreifen, wenn eine Domain <code>yahoo.com</code> eingegeben wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603351285303170)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Cookiedomain'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603087334303170)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen f\00FCr das Sessioncookie, der zur Identifizierung einer &PRODUCT_NAME.-Session erforderlich ist, zusammen mit der Session-ID in die URL ein.'),
'Wenn Sie keinen Sessioncookienamen angeben, verwendet &PRODUCT_NAME. einen Standardwert.</p>',
'<p>Durch Eingabe desselben Cookienamens in mehrere Anwendungen, kann jede der Anwendungen dasselbe Sessioncookie nutzen.',
'Deshalb erfordert ein URL-Aufruf aus einer &PRODUCT_NAME.-Anwendung an eine andere &PRODUCT_NAME.-Anwendung mit demselben Cookienamen keine erneute Authentifizierung des Benutzers, weil die neue Anwendung das vorhandene Sessioncookie verwenden kann.<'
||'/p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602970891303170)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Cookiename'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603272368303170)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das URL-Pfadattribut f\00FCr das Sessioncookie ein.'),
unistr('Wenn der Beginn der Anforderungs-URL nicht mit dem angegebenen Pfad \00FCbereinstimmt, wird das Cookie nicht an den Browser gesendet.'),
'Der Standardwert ist der Pfad der Anforderungs-URL.</p>',
unistr('<p>Verwenden Sie dieses Attribut, um einen weniger restriktiven Pfad anzugeben, wenn Sie Sessioncookies f\00FCr Anwendungen gemeinsam verwenden m\00F6chten, die anf\00E4nglich konforme URL-Pfade haben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603194961303170)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Cookiepfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023286653303522)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Standarddateireferenz</dt>',
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>Standarddateireferenz, die die minimierte Datei main.min.css aus /mycss/minified/ bei regul\00E4ren Seitenansichten und main.css aus /mycss/ im Debugmodus oder bei Ausf\00FChrung der Anwendung aus App Builder l\00E4dt.</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
'<dt>Bedingte Medienabfrage</dt>',
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>Dateireferenz mit einer Abfragezeichenfolge in der URL, die die Anwendungsversion referenziert, sodass der Browser beim Upgrade der Anwendung (und Erh\00F6hen der Version) angewiesen wird, immer die neue Datei zu laden und vorher gecachte Dateien zu ')
||'ignorieren.</dt>',
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509886490303097)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die URLs der CSS-Datei ein, die auf dieser Seite geladen sind. Jede URL muss auf einer eigenen Zeile stehen.',
unistr('Wenn Sie eine minimierte Version Ihrer Datei bereitstellen, k\00F6nnen Sie die Ersetzungszeichenfolge <code>#MIN#</code> verwenden, um <code>.min</code> oder <code>#MIN_DIRECTORY#</code> einzubeziehen, damit <code>minified/</code> in der Datei-URL f\00FCr ei')
||unistr('ne regul\00E4re Seitenansicht und eine leere Zeichenfolge einbezogen wird, wenn die Seite im Debugmodus angezeigt wird oder wenn die Anwendung aus App Builder ausgef\00FChrt wird.'),
unistr('Sie haben auch Zugriff auf die Ersetzungszeichenfolge <code>#APP_VERSION#</code>, wenn Sie die Version der Anwendung in der Datei-URL einbeziehen m\00F6chten.</p>'),
'<p>Datei-URLs, die Sie hier eingeben, ersetzen die Ersetzungszeichenfolge <code>#PAGE_CSS#</code> in dem Seitentemplate.</p>',
unistr('<p>Hinweis: Sie m\00FCssen keine \00F6ffnenden oder schlie\00DFenden <code>Link</code>-Tags einbeziehen. Beziehen Sie einfach die Datei-URL ein.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509755274303097)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datei-URLs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99056083794303549)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Wenn dieses Attribut auf <code>color:#FF0000;</code> festgelegt wird, wird die Textfarbe der Spalte in rot ge\00E4ndert und die folgende HTML wird generiert</dt>'),
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Beispieldaten&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873597782303394)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die CSS-Formatvorlagen ein, die f\00FCr den Wert dieser Spalte angewendet werden sollen. Sie k\00F6nnen die CSS-Formatvorlage eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873443802303394)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Formatvorlage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846545546303372)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Begrenzungszeichen ein. Dieses Zeichen bestimmt den Anfangs- und Endwert zur Begrenzung des Datenwertes. Standardm\00E4\00DFig werden doppelte Anf\00FChrungszeichen als Begrenzungszeichen verwendet.</div>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846497151303372)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSV-Begrenzungszeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881490585303401)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer den Berichtsinhalt in eine CSV-Datei herunterladen k\00F6nnen. Um <em>CSV-Downloads</em> zu aktivieren, m\00FCssen Sie ein Berichtstemplate mit einer <code>#CSV_LINK#</code>-Ersetzungszeichenfolge verwenden und diese Option auf <')
||'strong>Ein</strong> setzen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881322054303401)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSV-Export aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846352073303372)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie ein Spaltentrennzeichen ein. Wenn Sie keinen Wert eingeben, wird - entsprechend den aktuellen NLS-Einstellungen - ein Komma oder Semikolon verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846214364303372)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSV-Trennzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514356260303101)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob der Cursor beim ersten Aufruf der Seite fokussiert ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016827986303517)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Erstes Element auf Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016949954303517)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Cursorfokus steht auf dem ersten Feld der Seite, die JavaScript verwendet, das von der &PRODUCT_NAME. Engine generiert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017094315303517)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Cursor nicht als Fokus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017179346303518)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Der Cursor ist nicht fokussiert und es wird kein JavaScript generiert.<br>',
unistr('W\00E4hlen Sie diese Option, wenn das generierte JavaScript mit dem benutzerdefinierten JavaScript nicht vereinbar ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508982828303096)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Cursorfokus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607096467303173)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, ob die Anzeigeattribute in dieser Region vom Benutzer angepasst werden d\00FCrfen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037880267303535)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'de'
,p_message_text=>'Nicht von Endbenutzern anpassbar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037748205303535)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>unistr('Anpassbar und standardm\00E4\00DFig angezeigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037636960303534)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>unistr('Anpassbar und nicht standardm\00E4\00DFig angezeigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606979820303173)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anpassbar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606074801303172)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Label f\00FCr den Link ein, der unter dieser Region angezeigt wird und Zugriff auf die Seite zur Regionsanpassung gibt.'),
unistr('Dieses Label wird nur f\00FCr Regionen angezeigt, die angepasst werden k\00F6nnen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605993361303172)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911593476303426)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie HTML-Text f\00FCr diese Schaltfl\00E4che ein:'),
'<ul>',
unistr('  <li>Bei Schaltfl\00E4chen vom Typ <strong>HTML-Schaltfl\00E4che</strong> wird dieser Text zu der HTML-Elementdefinition hinzugef\00FCgt.</li>'),
unistr('  <li>Bei Schaltfl\00E4chen, die auf Templates basieren, muss das Template die Ersetzungszeichenfolge <code>#BUTTON_ATTRIBUTES#</code> enthalten.</li>'),
'</ul>',
unistr('<p>Mit diesem Attribut k\00F6nnen Sie Tabstopps kontrollieren</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911755231303426)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Ersetzungszeichenfolge <code>#REPORT_ATTRIBUTES#</code> des Berichtstemplates wird durch diesen Wert ersetzt.  Die Ersetzungszeichenfolge <code>#REPORT_ATTRIBUTES#</code> wird nur in dem Before Rows-Attribut des Berichtstemplates ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751611123303298)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche Attribute ein, die in dem HTML-Tag des Form-Elements aufgenommen werden sollen. Die HMTL-Attribute <code>size</code> und <code>id</code> werden generiert und m\00FCssen deshalb nicht angegeben werden. F\00FCr das HTML-Attribut <code>cla')
||'ss</code> wird empfohlen, stattdessen das Attribut <em>CSS-Klassen</em> zu verwenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911432690303426)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche Attribute ein, die in dem HTML-Tag des Form-Elements aufgenommen werden sollen. Die HMTL-Attribute <code>size</code> und <code>id</code> werden generiert und m\00FCssen deshalb nicht angegeben werden. F\00FCr das HTML-Attribut <code>cla')
||'ss</code> wird empfohlen, stattdessen das Attribut <em>CSS-Klassen</em> zu verwenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911667478303426)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den ersetzten Wert in Regionsattribute ein. Regionstemplates, die die Ersetzungszeichenfolge <code>#REGION_ATTRIBUTES#</code> enthalten, werden durch diesen Wert ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911803164303426)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Ersetzungszeichenfolge <code>#REPORT_ATTRIBUTES#</code> des Berichtstemplates wird durch diesen Wert ersetzt.  Die Ersetzungszeichenfolge <code>#REPORT_ATTRIBUTES#</code> wird nur in dem Before Rows-Attribut des Berichtstemplates ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911304957303426)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie zus\00E4tzliche durch Leerzeichen begrenzte Attribute ein, die in dem Elementtag aufgenommen werden sollen.'),
'Bei dem HTML CLASS-Attribut empfiehlt Oracle die Verwendung des dedizierten Attributs "CSS-Klassen".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911286948303425)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822639964303354)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen der benutzerdefinierten Spalte an, die f\00FCr die Definition einer benutzerdefinierten QuickInfo oder von datenbankbezogenen Farben f\00FCr die Diagrammelemente verwendet werden kann. Bei einem Boxplot-Diagramm darf die Spalte nicht mit ')
||unistr('der ausgew\00E4hlten Wertspaltenzuordnung \00FCbereinstimmen. Wenn eine Spalte ausgew\00E4hlt wird, die mit der Wertspaltenzuordnung \00FCbereinstimmt, wird keine benutzerdefinierte Spalte f\00FCr das Diagramm verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822533290303354)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte Spalte '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512899701303099)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen benutzerdefinierten JavaScript-Ereignisnamen an, wenn die angegebenen deklarativen Ereignisse nicht ausreichen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512738556303099)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniertes Ereignis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829374719303359)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Datenbankvorgang aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829800142303359)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829479175303359)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'de'
,p_message_text=>'Zeilen abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829509815303359)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'de'
,p_message_text=>'Einzelne Zeile abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829652452303359)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829799382303359)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'de'
,p_message_text=>'Zeile aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829282301303359)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenbankvorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067121472303558)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907797620303423)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Hintergrund der in diesem Kalender angezeigten Daten ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907663245303423)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenhintergrund'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342572436302959)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Spaltennamen, der als Quelle f\00FCr diesen Elementwert verwendet wird, unter Beachtung der Gro\00DF-/Kleinschreibung ein.</p>'),
'<p>Diese Spalte muss in der Datenquelle enthalten sein, die in der Formularregion angegeben ist.',
unistr('Ein Fehler wird zur Laufzeit ausgel\00F6st, und die Seite wird nicht geladen, wenn der Spaltenname nicht in der referenzierten Tabelle vorhanden ist.'),
unistr('Wenn kein integrierter Prozess f\00FCr den Zeilenabruf definiert wurde und ein Element mit dem Quelltyp <strong>Datenbankspalte</strong> vorhanden ist, wird ebenfalls ein Fehler ausgel\00F6st. Die Seite wird dann nicht geladen, wenn Sie versuchen, sie zu ren')
||'dern.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342402578302959)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342345462302959)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die zugeh\00F6rige Formularregion f\00FCr dieses Seitenelement aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342289154302959)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formularregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107634903303591)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907911134303423)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr die Daten in diesem Kalender ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907862778303423)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datentext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747584474303295)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Datentyp der zugrunde liegenden Datenbankspalte aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413900960303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'de'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413714853303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'de'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413640762303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'de'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413041965303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'de'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413532201303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'de'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413411602303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'de'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412932259303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'de'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413896926303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'de'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413213545303019)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'de'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413192959303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'de'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413325081303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'de'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99413247507303847)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'de'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412827301303846)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'de'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747445364303295)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904715154303420)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus der Tabelle oder Abfrage mit dem Datum, das in den Kalender platziert werden soll. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904601619303420)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datumsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904958971303420)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Sie nur Zeit- oder nur Datumswerte in Ihrem Kalender anzeigen m\00F6chten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98904819285303420)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Uhrzeit anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872728290303394)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Formatmaske, die f\00FCr die Datumsauswahl f\00FCr diese Spalte angewendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053123257303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'de'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052950711303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'de'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053098236303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'de'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053749696303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'de'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053572271303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'de'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053620458303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'de'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053427302303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'de'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053242628303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'de'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053345570303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'de'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053875805303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'de'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054039915303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'de'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99053965502303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'de'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054163744303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'de'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054342193303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'de'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054236049303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'de'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054411984303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'de'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054610500303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'de'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054513692303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'de'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054704276303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'de'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054923348303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'de'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99054860891303548)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'de'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052602385303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'de'
,p_message_text=>'Datumsformat der Anwendung verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052706766303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'de'
,p_message_text=>'Formatmaske der Anwendung verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99052845263303547)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'de'
,p_message_text=>'Formatmaske des Elements verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055044078303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'de'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055292016303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'de'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055117325303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'de'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055321081303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'de'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055761425303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'de'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055879363303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'de'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055572483303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'de'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055621806303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'de'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055455241303549)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'de'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872689668303394)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatmaske'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909099582303424)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf "Ziel", um einen modalen Dialog aufzurufen. Sie k\00F6nnen den Ziellink eingeben, den der Kalender aufruft, wenn ein Ereignis erstellt wird, indem auf eine Kalenderzelle au\00DFerhalb eines vorhandenen Ereignisses geklickt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908991558303424)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ziel erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537264621303119)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, welche Aktion ausgef\00FChrt werden soll. Die folgenden Aktionen werden unterst\00FCtzt:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Je nach Anwendungskonfiguration sind hier zus\00E4tzliche Plug-ins f\00FCr dynamische Aktionen verf\00FCgbar.'),
'Sie werden als <em>&lt;My Plug-in&gt; [Plug-in]</em> angezeigt.',
'Die folgenden Plug-ins sind in den gemeinsam verwendeten Komponenten dieser Anwendung installiert:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537130975303119)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860622857303384)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das entsprechende dynamische Aktionsereignis aus der verf\00FCgbaren Liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860576072303384)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ereignis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223738242303682)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Code f\00FCr Bereinigung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223652616303682)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Code f\00FCr Initialisierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892604765303410)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Anwendungsstandardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333742152303780)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwendet die Einstellung, die in den Anwendungssicherheitsattributen definiert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516739847303103)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie, wie externe URL-Anforderungen an diese Seite verarbeitet werden.'),
unistr('Seitenanforderungen aus dieser Anwendung f\00FCr diese Seite werden nicht als Deeplinking betrachtet und unterliegen nicht der Einstellung dieses Attributs.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017795974303518)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017808245303518)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die URL keine g\00FCltige Session-ID enth\00E4lt, startet &PRODUCT_NAME. eine neue Session und leitet den Benutzer zu der Anwendungshomepage und nicht zu dieser Seite um.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017552429303518)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017681603303518)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn diese Seite als Zielseite in einer URL angegeben wird, erfolgt die Umleitung endg\00FCltig zu dieser Seite.<br>'),
unistr('Wenn der Benutzer noch nicht authentifiziert ist und die Seite nicht \00F6ffentlich ist, wird der Benutzer zur Anmeldung aufgefordert.'),
'Nach der erfolgreichen Anmeldung bei der Anwendung wird der Benutzer zu dieser Seite umgeleitet.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516622032303102)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Deeplinking'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657862492303212)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Benutzeroberfl\00E4che die Standardanwendungsoberfl\00E4che ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657787274303212)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506800086303095)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Standard-Erstelloption, die f\00FCr diese Komponente beim Exportieren angewendet wird. Diese Option kann von Exportoptionen au\00DFer Kraft gesetzt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015289212303516)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Ausschlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325230042303773)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert und nicht Teil der Anwendung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015384096303516)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'de'
,p_message_text=>'Aufnehmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325304416303773)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'de'
,p_message_text=>'Aktiviert und Teil der Anwendung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506704061303094)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Standard bei Export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748321758303295)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie der Standardwert dieser Spalte bestimmt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248353538303708)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248480605303708)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der vom eingegebenen <em>Ausdruck</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248524406303708)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248673748303708)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der vom eingegebenen <em>Funktionsbody</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748607593303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748744430303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie das Element auf den Wert fest, der vom Sessionzustand f\00FCr das ausgew\00E4hlte <em>Element</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749213549303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749314824303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Wird auf den Wert gesetzt, der von der eingegebenen <em>Sequenz</em> zur\00FCckgegeben wurde. Dies ist ein "spezieller" Standardtyp: Er wird als Teil des DML-Prozesses des interaktiven Grids und <em>nicht</em> w\00E4hrend des Ladens der Seite ausgef\00FChrt. ')
||unistr('Verwenden Sie diesen Typ f\00FCr automatisch generierte Prim\00E4rschl\00FCsselwerte, wenn <strong>Prim\00E4rschl\00FCssel nach Einf\00FCgen zur\00FCckgeben</strong> nicht verwendet werden kann, wie beispielsweise bei der Arbeit mit Views und INSTEAD OF-Triggern oder mit Datenb')
||unistr('ankverkn\00FCpfungen. Bei dem Sequenznamen ist die Gro\00DF-/Kleinschreibung zu beachten. Verwenden Sie doppelte Anf\00FChrungszeichen, um eine Mischung aus Gro\00DF- und Kleinbuchstaben beim Sequenznamen anzuzeigen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748820539303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748930813303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie diese auf den Wert fest, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749057299303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage, die eine durch Doppelpunkt begrenzte Liste zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749144269303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Legen Sie diese Option auf die durch Doppelpunkt begrenzte Werteliste fest, die von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.</p>'),
unistr('        <p>Hinweis - Durch Doppelpunkt begrenzte Listen sind erforderlich, wenn die Spalte als Kontrollk\00E4stchen, Optionsgruppe oder Shuttle angezeigt wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748428459303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748545808303296)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Legen Sie dies auf den Wert fest, der in <em>Statischer</em> Wert eingegeben wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748264234303295)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271437685303727)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271850040303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271791920303727)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271645437303727)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271919801303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271566480303727)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271310900303727)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273465299303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273756704303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273601617303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273544055303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273862023303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273371064303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896325991303413)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Standardwert enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896277637303413)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273018765303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Java-Ausdruck ein, der den Wert f\00FCr dieses Element erzeugt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272956043303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274663658303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Java-Funktionsbody ein, der den Wert f\00FCr dieses Element zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274589809303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272876657303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272716624303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den JavaScript-Ausdruck ein, der den Wert f\00FCr dieses Element erzeugt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272643547303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274474026303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274360863303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den JavaScript-Funktionsbody ein, der den Wert f\00FCr dieses Element zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274285730303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272520635303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272464268303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den PL/SQL-Ausdruck ein, der den Wert f\00FCr dieses Element erzeugt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272305501303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274114198303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274034417303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der den Wert f\00FCr dieses Element zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273921051303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273248214303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Python-Ausdruck ein, der den Wert f\00FCr dieses Element erzeugt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99273129258303729)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274894164303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Python-Funktionsbody ein, der den Wert f\00FCr dieses Element zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274752466303730)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749909188303297)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen der Datenbanksequenz ein, die den Standardwert f\00FCr diese Spalte zur\00FCckgibt.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749885488303297)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272201894303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter ein Manager ist und sich seine Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272134132303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den SQL-Ausdruck ein, der den Wert f\00FCr dieses Element erzeugt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99272021350303728)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749533808303296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Abfrage ein, die den Standardwert f\00FCr diese Spalte zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749400354303296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749726998303297)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Abfrage ein, die die durch Doppelpunkt begrenzte Standardwerteliste f\00FCr diese Spalte zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98749649178303297)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage - Doppelpunkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530492732303113)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Standardwert f\00FCr dieses Element an. Der Standardwert wird verwendet, wenn der Elementwert nicht aus dem Sessionzustand abgeleitet wird und der Quellwert Null ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530364483303113)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530285178303113)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Standardwerttyp f\00FCr dieses Element.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247786870303707)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247898512303707)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der von dem eingegebenen <em>Ausdruck</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247928698303708)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248021079303708)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der vom eingegebenen <em>Funktionsbody</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341112742302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341272856302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie das Element auf den Wert fest, der vom Sessionzustand f\00FCr das ausgew\00E4hlte <em>Element</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341715097302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341822047302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Wird auf den Wert gesetzt, der von der eingegebenen <em>Sequenz</em> zur\00FCckgegeben wurde. Dies ist ein "spezieller" Standardtyp: Er wird als Teil des DML-Prozesses der Formularregion und <em>nicht</em> w\00E4hrend des Ladens der Seite ausgef\00FChrt. Verw')
||unistr('enden Sie diesen Typ f\00FCr automatisch generierte Prim\00E4rschl\00FCsselwerte, wenn <strong>Prim\00E4rschl\00FCssel nach Einf\00FCgen zur\00FCckgeben</strong> nicht verwendet werden kann, wie beispielsweise bei der Arbeit mit Views und INSTEAD OF-Triggern oder mit Datenbankv')
||unistr('erkn\00FCpfungen. Bei dem Sequenznamen ist die Gro\00DF-/Kleinschreibung zu beachten.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341391265302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341407052302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie diese auf den Wert fest, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341544114302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage, die eine durch Doppelpunkt begrenzte Liste zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341662561302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Legen Sie diese Option auf die durch Doppelpunkt begrenzte Werteliste fest, die von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.</p>'),
unistr('        <p>Hinweis - Durch Doppelpunkt begrenzte Listen sind erforderlich, wenn die Spalte als Kontrollk\00E4stchen, Optionsgruppe oder Shuttle angezeigt wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032551720303530)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'de'
,p_message_text=>'Statisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341030337302958)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'de'
,p_message_text=>'Legen Sie dies auf den Wert fest, der in <em>Statischer</em> Wert eingegeben wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530105297303113)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759952916303305)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob Endbenutzer ein Diagramm f\00FCr dieses interaktive Grid definieren k\00F6nnen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759853591303305)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Diagrammansicht definieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735506134303284)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie ein Autorisierungsschema, um zu begrenzen, wer Zeilen l\00F6schen kann.'),
unistr('Damit ein Endbenutzer Zeilen l\00F6schen kann, muss die Auswertung dieses Autorisierungsschemas TRUE f\00FCr diesen Benutzer ergeben.'),
unistr('Wenn kein Autorisierungsschema angegeben wird, kann jeder Benutzer Zeilen in diesem interaktiven Grid l\00F6schen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735423079303284)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868928736303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Bedingung an, die den Wert eines anderen Facets oder Filters pr\00FCft, um zu steuern, ob das aktuelle Facet oder der aktuelle Filter angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869082078303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'de'
,p_message_text=>'gleich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869125196303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des <em>Facets oder Filters </em> unter "Abh\00E4ngig von" gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869469387303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'de'
,p_message_text=>'in Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869565516303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des <em>Facets oder Filters</em> unter "Abh\00E4ngig von" in der angegebenen <em>Liste</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869230993303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'de'
,p_message_text=>'nicht gleich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869374786303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des <em>Facets oder Filters </em> unter "Abh\00E4ngig von" ungleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869689966303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'de'
,p_message_text=>'nicht in Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869765974303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des <em>Facets oder Filters</em> unter "Abh\00E4ngig von" nicht in der angegebenen <em>Liste</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870080421303392)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'ist nicht Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870180311303392)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des <em>Facets oder Filters</em> unter "Abh\00E4ngig von" nicht leer ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869841158303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'de'
,p_message_text=>'ist Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98869995793303392)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des <em>Facets oder Filters</em> unter "Abh\00E4ngig von" leer ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868806180303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870510766303392)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Komma getrennte Liste der Werte f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870418706303392)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870398300303392)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98870271332303392)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868782853303391)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das zugeh\00F6rige Facet aus, das gepr\00FCft werden soll, um zu bestimmen, ob das aktuelle Facet angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98868621662303390)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194261169303659)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das verkn\00FCpfte Kontrollk\00E4stchen aus, das aktiviert werden muss, um zu entscheiden, ob das aktuelle Kontrollk\00E4stchen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194116068303659)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556742855303134)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den verkn\00FCpften Filter aus, der aktiviert werden muss, um zu entscheiden, ob der aktuelle Filter angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556661592303134)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556946518303134)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das verkn\00FCpfte Kontrollk\00E4stchen aus, das aktiviert werden muss, um zu entscheiden, ob das aktuelle Kontrollk\00E4stchen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556848535303134)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108804358303592)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'$$$ DJP derzeit ausgeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899793430303416)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Abgeleitete Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414204057303848)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Beschreibung f\00FCr diesen interaktiven Bericht ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843357444303370)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Beschreibung f\00FCr die Spaltengruppe ein. Diese Beschreibung wird niemals f\00FCr Endbenutzer angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510883415303098)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine Beschreibung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510781234303098)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049279982303544)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/Tabelle&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851590496303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den HTML-Code an, der nach Berichtszeilen angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851430280303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nach Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049020477303544)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;Tabelle&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851173269303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den HTML-Code an, der vor Berichtszeilen angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851007698303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Vor Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750861635303298)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Detailansicht aktiviert ist. Durch Auswahl von <strong>Ein</strong> wird das Symbol "Details anzeigen" zur Suchleiste f\00FCr interaktive Berichte oder zur Schaltfl\00E4che "Ansicht" des interaktiven Grids hinzugef\00FCgt. Damit k\00F6nnen Benut')
||'zer auf diese Ansicht zugreifen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850931940303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Detailansicht aktiviert ist. Durch Auswahl von <strong>Ein</strong> wird das Symbol "Details anzeigen" zur Suchleiste f\00FCr interaktive Berichte oder zur Schaltfl\00E4che "Ansicht" des interaktiven Grids hinzugef\00FCgt. Damit k\00F6nnen Benut')
||'zer auf diese Ansicht zugreifen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850876076303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411712859303845)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411812904303846)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Body f\00FCr Berichtszeilen in der Detailansicht an.</p>'),
unistr('<p>Die folgenden Ersetzungszeichenfolgen sind verf\00FCgbar:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - Ersetzungszeichenfolgen f\00FCr Spaltennamen.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - Ersetzungszeichenfolgen f\00FCr Spaltenlabels.</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - Die Datensatz-ID f\00FCr die Zeile.</li>'),
'<li><code>&APEX$ROW_INDEX.</code> - Die Folgenummer der Datensatzanzeige.</li>',
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - Der Datensatzstatus, z.B. <code>is-inserted</code> oder <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049161832303544)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851327024303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Haupttext f\00FCr Berichtsspalten in der Detailansicht an. Verwenden Sie die <code>#COLUMN_NAME#</code>-Ersetzungszeichenfolgen f\00FCr Spaltennamen und Spaltenlabels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851266620303376)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr jede Zeile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510662230303098)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dialogunterst\00FCtzung in &PRODUCT_NAME. variiert je nach Benutzeroberfl\00E4che der Seite.'),
unistr('Eine Teilmenge von Dialogattributen wird deklarativ unterst\00FCtzt: <em>H\00F6he, Breite und maximale Breite</em>.'),
'Um weitere Dialogattribute zu definieren, geben Sie die Name/Wert-Paarungen in eine durch Komma getrennte Liste ein.</p>',
'<p>Die Ersetzungszeichenfolge <code>#DIALOG_ATTRIBUTES#</code> im Initialisierungscode des Dialogs, der auf Seitentemplate-Ebene definiert wird, wird durch Werte ersetzt, die in dieses Element eingegeben werden.</p>',
unistr('<p>Bei Seiten, die die Desktopbenutzeroberfl\00E4che verwenden, wird das jQuery-UI-Dialogwidget verwendet.'),
unistr('Bei Seiten, die die jQuery Mobile Smartphone-Benutzeroberfl\00E4che verwenden, wird das jQuery Mobile-Dialogwidget verwendet.</p>'),
unistr('<p>Beispiel: F\00FCr eine Dialogseite, die eine Desktopbenutzeroberfl\00E4che verwendet, k\00F6nnten die folgenden Attribute verwendet werden: <code>resizable:true, draggable:true</code></p>'),
unistr('<p>Weitere Informationen \00FCber die verf\00FCgbaren Attribute finden Sie in der <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">Dokumentation f\00FCr das jQuery-UI-Dialogwidget</a> und der <a rel="noreferrer" target="_blank" href="ht')
||unistr('tp://api.jqueryui.com/dialog/">Dokumentation f\00FCr das jQuery Mobile-Dialogwidget</a>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510510934303098)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Attribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201172930303664)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie <strong>Ein</strong> aus, wenn dieses Dialogfeld von einem anderen Dialogfeld ge\00F6ffnet wird und dasselbe Dialogfenster verwenden soll.'),
unistr('Beispiel: Dieses Dialogfeld ist Bestandteil eines Dialogassistenten mit mehreren Seiten, und Sie m\00F6chten das Dialogfenster f\00FCr jeden Schritt des Assistenten wiederverwenden.<p><p>'),
unistr('W\00E4hlen Sie <strong>Aus</strong>, wenn dieses Dialogfeld von einem anderen Dialogfeld ge\00F6ffnet wird und in einem neuen Dialogfenster ge\00F6ffnet werden soll. Beispiel: Dieses Dialogfeld ist modal,'),
unistr('und Sie m\00F6chten es in einem \00FCbergeordneten modalen Dialogfenster \00F6ffnen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201011810303664)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Verkettet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912401429303426)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912306255303426)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600944483303168)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die H\00F6he des Dialogs in Pixel ein, Beispiel: <strong><em>500</em></strong>.'),
unistr('Die Ersetzungszeichenfolge <code>#DIALOG_HEIGHT#</code> im Initialisierungscode f\00FCr den Dialog des Seitentemplates wird durch den eingegebenen Wert ersetzt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600875121303168)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510402059303098)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die maximale Breite des Dialogs in Pixel ein.',
'Die Ersetzungszeichenfolge <code>#DIALOG_MAX_WIDTH#</code> im Initialisierungscode des Dialogs des Seitentemplates wird durch den in dieses Element eingegebenen Wert ersetzt.</p>',
unistr('<p>Bei einer Seite, die die jQuery Mobile Smartphone-Benutzeroberfl\00E4che verwendet, ist die maximale Breite <strong><em>500</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510381031303097)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Maximale Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892371314303410)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Theme-Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645972624303203)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Dialogfeldtemplate aus, um Darstellung und Layout dieser Seite zu definieren.</p>'),
'        <p>Dialogfeldtemplates werden im Anwendungs-Theme definiert.',
'        Wenn eine Dialogfeldseite erstellt wird, wird das Template automatisch auf <em>Theme-Standard</em> gesetzt, sodass die Seite mit dem Standardseitentemplate gerendert wird, das im aktuellen Theme definiert ist.',
unistr('        Wenn hier eine Auswahl getroffen wird, setzt sie das Standarddialogfeldtemplate au\00DFer Kraft.</p>'),
'        <p>Universal Theme stellt die folgenden Dialogfeldtemplates bereit:',
'          <dl>',
'            <dt>Modales Dialogfeld</dt>',
unistr('              <dd>Wird f\00FCr die meisten Anwendungsf\00E4lle von Dialogfeldern verwendet.</dd>'),
'            <dt>Modale Dialogfeldassistenten</dt>',
unistr('              <dd>Stellt eine optimierte Benutzeroberfl\00E4che bereit und eignet sich besonders f\00FCr modale Dialogfeldassistenten, Alerts, Benachrichtigungen oder kleine Formulare.</dd>'),
'          </dl>',
'          Siehe auch: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645860109303203)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Dialog-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510270540303097)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Breite des Dialogs in Pixel oder Prozent ein.',
'Die Ersetzungszeichenfolge <code>#DIALOG_WIDTH#</code> im Initialisierungscode des Dialogs des Seitentemplates wird durch den in dieses Element eingegebenen Wert ersetzt.</p>',
unistr('<p>Bei einer Seite, die eine Desktopbenutzeroberfl\00E4che verwendet, wird der Wert in Pixel festgelegt, wie <strong><em>500</em></strong>.'),
unistr('Bei einer Seite, die die jQuery Mobile Smartphone-Benutzeroberfl\00E4che verwendet, wird der Wert in Prozent festgelegt, wie <strong><em>80 %</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510165531303097)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828287810303358)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Richtung des Parameters aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828339646303358)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'de'
,p_message_text=>'In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828511479303359)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'de'
,p_message_text=>'In/Out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828474023303358)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'de'
,p_message_text=>'Out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828137812303358)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Richtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874339039303395)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob diese Spalte vom Endbenutzer verwendet werden kann, um den Bericht zu sortieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874260244303395)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sortierbar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905948115303421)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die einzelne Spalte, die in den Kalenderzellen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98905868496303421)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigespalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521610497303107)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ein Element kann einen Wert f\00FCr den Sessionzustand haben, der in der Definition der angegebenen Werteliste nicht angezeigt wird. '),
unistr('Geben Sie an, ob in dieser Werteliste der zus\00E4tzliche Wert f\00FCr den Sessionzustand angegeben werden soll.'),
unistr(' Wenn Sie festlegen, dass dieser Wert nicht angezeigt werden soll und kein \00FCbereinstimmender Wert in der Wertelistendefinition vorhanden ist, wird der erste Wert ausgew\00E4hlt und angezeigt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521547312303107)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Zus\00E4tzliche Werte anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521847626303107)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die f\00FCr dieses Element verwendete Werteliste einen NULL-Wert am Anfang der Liste anzeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521707611303107)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nullwert anzeigen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564411500303140)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position aus, die zur Anzeige dieser Komponente verwendet wird. Die Positionen werden von den Anzeigepunkten dem entsprechenden Seiten- oder Regionstemplate abgeleitet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564383294303140)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219500389303678)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die Anzeigefolge f\00FCr diese Aktion ein.'),
'Sie dient zur Auswertung der Anzeigebedingung und zum Rendern in der angegebenen Reihenfolge.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751279947303298)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Anzeigesequenz f\00FCr diese Spalte ein. Die Sequenzeinstellung bestimmt, wo diese Spalte bezogen auf andere Spalten innerhalb der Region angezeigt wird.</p>'),
unistr('<p>Hinweis: Wenn zwei Spalten innerhalb derselben Region denselben Sequenzwert haben, k\00F6nnen sie in einer anderen Reihenfolge angezeigt werden, wenn die Anwendung exportiert und in eine andere Umgebung importiert wird, wie eine Test- oder Production-')
||'Umgebung.',
unistr(' Im Hinblick auf Konsistenz empfiehlt Oracle, dass Sie eindeutige Folgenummern f\00FCr jedes Element oder zumindest f\00FCr Elemente innerhalb derselben Region angeben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843210735303370)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Anzeigereihenfolge f\00FCr diese Spaltengruppe ein. Dies bestimmt die Reihenfolge, in der die Spaltengruppen in der Detailansicht angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177061193303645)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Anzeigesequenz f\00FCr diesen Layer ein. Die Sequenzeinstellung bestimmt die Reihenfolge, in der Kartenlayer \00FCbereinander angezeigt werden. Layer mit h\00F6heren Werten werden \00FCber den Layern mit niedrigeren Werten angezeigt.</p>'),
unistr('<p>Hinweis: Wenn zwei Kartenlayer denselben Sequenzwert haben, k\00F6nnen sie in einer anderen Reihenfolge angezeigt werden, wenn die Anwendung exportiert und in eine andere Umgebung importiert wird, wie eine Test- oder Produktionsumgebung.'),
unistr('Im Hinblick auf Konsistenz empfiehlt Oracle, dass Sie eindeutige Sequenznummern f\00FCr jeden Layer oder zumindest f\00FCr Layer innerhalb derselben Kartenregion angeben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540002738303121)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Anzeigesequenz f\00FCr dieses Element ein. Die Sequenz und andere Layouteinstellungen bestimmen, ob dieses Element bezogen auf andere Elemente innerhalb der Region angezeigt wird.</p>'),
unistr('<p>Hinweis: Wenn zwei Elemente innerhalb derselben Region denselben Sequenzwert haben, k\00F6nnen sie in einer anderen Reihenfolge angezeigt werden, wenn die Anwendung exportiert und in eine andere Umgebung importiert wird, wie eine Test- oder Production')
||unistr('-Umgebung. Im Hinblick auf Konsistenz empfiehlt Oracle, dass Sie eindeutige Folgenummern f\00FCr jedes Element oder zumindest f\00FCr Elemente innerhalb derselben Region angeben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539989589303121)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361106819303803)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Autorisierungsschema aus, um zu begrenzen, wer Elemente herunterladen kann.'),
unistr('		Damit ein Endbenutzer Elemente herunterladen kann, muss die Auswertung dieses Autorisierungsschemas f\00FCr diesen Benutzer TRUE ergeben.</p>'),
unistr('		<p>Hinweis: Wenn kein Autorisierungsschema angegeben wird, k\00F6nnen Elemente von jedem Benutzer heruntergeladen werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361027568303803)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Autorisierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883753444303403)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Namen f\00FCr die CSV-Downloaddatei an. Wenn Sie keinen Namen angeben, wird der Regionsname mit der Erweiterung CSV verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894889156303412)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Namen f\00FCr die CSV-Downloaddatei an. Wenn Sie keinen Namen angeben, wird der Regionsname mit der Erweiterung CSV verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878884123303399)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Dateinamen f\00FCr das Dokument beim Download ein. Geben Sie keine Dateierweiterung an, diese wird automatisch hinzugef\00FCgt. Wenn Sie dieses Attribut leer lassen, wird der Regionsname als Dateiname verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878748102303399)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Dateiname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846131752303372)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Pr\00FCfen Sie, welche Downloadformate Benutzer verwenden k\00F6nnen, um die aktuell angezeigten Spalten herunterzuladen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046544878303542)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'de'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046614363303542)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'de'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046757046303542)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'de'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121430670303602)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'de'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846029475303372)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881642639303401)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr den Link ein, der das Herunterladen der CSV-Datei aufruft.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881594193303401)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Link-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878005947303398)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text ein, der f\00FCr den Downloadlink auf der Seite verwendet werden soll. Endbenutzer k\00F6nnen diesen Link verwenden, um den BLOB-Inhalt herunterzuladen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98877914211303398)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Text herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909467998303424)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie ein Autorisierungsschema aus, um zu begrenzen, wer zur Aktualisierung von vorhandenen Kalenderereignissen per Drag-and-Drop berechtigt ist.'),
'Wenn dieses Attribut angegeben wird, muss die Auswertung dieses Autorisierungsschemas TRUE ergeben, damit der Drag-and-Drop-Vorgang verarbeitet werden kann.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909349020303424)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068074825303559)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Benutzerdefinierter Prozess</dt>',
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909270681303424)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Definieren Sie den Prozess, der ausgef\00FChrt werden soll, wenn ein Kalendereintrag per Drag-and-Drop verschoben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909119135303424)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Prozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750193819303297)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob f\00FCr die Spalte standardm\00E4\00DFig der vorhandene Spaltenwert verwendet werden soll, wenn der Datensatz dupliziert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750039738303297)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Duplikat kopiert vorhandenen Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98548097130303128)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pr\00FCfen Sie, welche DML-(Data Manipulation Language-)Vorg\00E4nge unterst\00FCtzt werden. Dieser Prozess f\00FChrt DML-Vorg\00E4nge aus, die auf dem Attribut <strong>Datenbankaktion</strong> der Schaltfl\00E4che zum Weiterleiten der Seite basieren. Wenn dieses Attribu')
||unistr('t nicht festgelegt ist, wird der Vorgang vom Anforderungswert der Schaltfl\00E4che bestimmt, der anhand des Schaltfl\00E4chennamens wie folgt festgelegt wird:</p>'),
'<ul>',
unistr('<li><strong>Zeile hinzuf\00FCgen</strong> wird von diesen Anforderungswerten ausgel\00F6st: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN</li>'),
unistr('<li><strong>Zeile aktualisieren</strong> wird von diesen Anforderungswerten ausgel\00F6st: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%</li>'),
unistr('<li><strong>Zeile l\00F6schen</strong> wird von diesen Anforderungswerten ausgel\00F6st: DELETE, REMOVE, DELETE ROW, DROP</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734431276303283)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfen Sie, welche Datenverarbeitungsvorg\00E4nge bei diesem interaktiven Grid zul\00E4ssig sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734771449303284)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734508712303284)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734664078303284)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'de'
,p_message_text=>'Zeile aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734388409303283)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Zul\00E4ssige Vorg\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734917943303284)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie eine Spalte, in der der Spaltenwert angibt, ob die Zeile aktualisiert und/oder gel\00F6scht werden kann. Die zul\00E4ssigen Werte sind:'),
'        <dl>',
'          <dt>U</dt>',
'            <dd>Zeile kann aktualisiert werden</dd>',
'          <dt>D</dt>',
unistr('            <dd>Zeile kann gel\00F6scht werden</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>Zeile kann aktualisiert oder gel\00F6scht werden</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734883897303284)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte "Zugelassene Zeilenvorg\00E4nge"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526617105303110)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Ausrichtung f\00FCr das Element in der umgebenden HTML-Tabellenzelle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030242184303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Mitte unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030385250303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte zentriert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030496668303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'de'
,p_message_text=>'Mitte oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030179130303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Zentriert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030682731303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Links unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030740203303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030860452303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'de'
,p_message_text=>'Links oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030507255303528)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031040768303529)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Rechts unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031122055303529)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031231781303529)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'de'
,p_message_text=>'Rechts oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030972511303529)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522507349303107)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527293457303111)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die H\00F6he (etwaige Anzahl von Zeilen) f\00FCr Textbereiche, Shuttles, Mehrfachauswahllisten und Plug-in-Elementtypen ein, die das Attribut "Enth\00E4lt ein H\00F6henattribut" unterst\00FCtzen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527135870303111)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912748982303427)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'de'
,p_message_text=>'Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527090449303111)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die H\00F6chstanzahl von Zeichen ein, die Benutzer in dieses Element eingeben k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526961676303111)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Maximale L\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912872008303427)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'de'
,p_message_text=>'Zeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527666459303111)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche, durch Leerzeichen begrenzte Attribute f\00FCr die HTML-Tabellenzelle ein, die f\00FCr die Anzeige der jeweiligen Option in einer Options- oder Kontrollk\00E4stchengruppe verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527531045303111)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Option "HTML-Attribute"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528040940303112)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zus\00E4tzliche Attribute ein, die nach der HTML-Tabellenzelle angezeigt werden, in der jede einzelne Option in einer Optionsgruppe oder einer Gruppe von Kontrollk\00E4stchen angezeigt wird.'),
unistr('Sie k\00F6nnen HTML, JavaScript und Shortcuts aufnehmen.</p>'),
unistr('<p>Sie k\00F6nnen die folgenden Ersetzungszeichenfolgen referenzieren:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ruft den Namen des HTML-Form-Elements auf, mit dem dieses Seitenelement verkn\00FCpft ist.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ruft den Namen des aktuellen Seitenelements ab.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527974557303111)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Post-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527855871303111)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zus\00E4tzliche Attribute ein, die vor der HTML-Tabellenzelle angezeigt werden, in der jede einzelne Option in einer Optionsgruppe oder einer Gruppe von Kontrollk\00E4stchen angezeigt wird.'),
unistr('Sie k\00F6nnen HTML, JavaScript und Shortcuts aufnehmen.</p>'),
unistr('<p>Sie k\00F6nnen die folgenden Ersetzungszeichenfolgen referenzieren:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ruft den Namen des HTML-Form-Elements auf, mit dem dieses Seitenelement verkn\00FCpft ist.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ruft den Namen des aktuellen Seitenelements ab.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527785562303111)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Pre-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527476619303111)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Hinweistext an, der in diesem Element angezeigt wird, wenn kein Wert f\00FCr dieses Element eingegeben wird. Sobald Text in das Element eingegeben wird, wird der Hinweis entfernt.</p>'),
'<p>Dieses Platzhalterattribut gibt einen kurzen Hinweis an, der zur Beschreibung des erwarteten Wertes eines Seitenelements verwendet werden kann.',
'Derartige Hinweise eignen sich zur Angabe eines Beispielwertes, eines Beispiels des erwarteten Formats oder zur Angabe von Anweisungen wie: Suche nach Titel, Beschreibung und Tag.',
unistr('Aus Gr\00FCnden der Barrierefreiheit darf dieses Attribut nicht als Alternative zu einem ordnungsgem\00E4\00DF definierten, aussagekr\00E4ftigen Label verwendet werden.</p>'),
unistr('<p><strong>Achtung:</strong> Dies ist ein HTML5-Feature und kann nur in modernen Browsern verwendet werden. \00C4ltere Browser zeigen den in dieses Attribut eingegebenen Text nicht an.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98527357589303111)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wertplatzhalter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526886141303111)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Breite des Form-Elements ein, die zur Anzeige dieses Elements verwendet werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526770402303111)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912629420303427)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'de'
,p_message_text=>'Zeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047681630303543)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848961844303374)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine g\00FCltige E-Mail-Adresse zur Verwendung als <em>Von</em>-Adresse beim Senden von E-Mails aus diesem Bericht an. E-Mails werden aus diesem Bericht f\00FCr Downloads vom Typ E-Mail und f\00FCr Subscriptions gesendet.</p>'),
unistr('<p>Der Wert kann eine literale Zeichenfolge, die eine g\00FCltige E-Mail-Adresse enth\00E4lt, oder eine statische Ersetzungsreferenz sein, die in der Anwendung mit Ersetzungssyntax definiert ist.'),
unistr('Die Verwendung einer Seiten- oder Anwendungselementersetzung wird NICHT empfohlen, weil sie nur in E-Mail-Downloads verwendet werden kann und dazu f\00FChrt, dass Subscription-E-Mails nicht erfolgreich gesendet werden, weil auf diese Elemente nicht au\00DFer')
||unistr('halb einer g\00FCltigen Session zugegriffen werden kann.'),
'Subscriptions werden direkt aus der &PRODUCT_NAME. Engine und nicht aus einer Benutzersession gesendet.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848834236303374)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Absenderadresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760597142303306)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer diese Spalte bei Kontrollgruppenwechseln und Aggregaten verwenden k\00F6nnen.</p>'),
unistr('        <p>Hinweis - Das Zulassen dieser Vorg\00E4nge kann zu Performanceproblemen f\00FChren, insbesondere bei gro\00DFen Datasets oder wenn keine entsprechenden Spaltenindizes verf\00FCgbar sind.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760480629303306)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechsel/Aggregat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738910286303288)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer den Bericht in einem der angegebenen Downloadformate herunterladen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738858637303288)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743074391303291)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte filtern k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742927508303291)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759703310303305)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer Flashback Querys f\00FCr dieses interaktive Grid verwenden k\00F6nnen.</p>'),
unistr('<p>In Flashback Querys werden Daten mithilfe der Oracle Flashback-Technologie und Database Point-in-Time Recovery so angezeigt, wie sie zu einem vorherigen Zeitpunkt vorhanden waren. Benutzer k\00F6nnen diese Daten nur abfragen und k\00F6nnen keine Daten\00E4nde')
||unistr('rungen r\00FCckg\00E4ngig machen. Wie weit zur\00FCck ein Flashback erfolgreich vorgenommen werden kann, h\00E4ngt davon ab, wann die Redo-Logdateien zuletzt in der Oracle-Datenbank gewechselt wurden, weil diese Technologie das RMAN-Backup verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759630279303305)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760382859303306)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer diese Spalte ausblenden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760263587303305)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739515253303288)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer eine E-Mail mit dem heruntergeladenen Bericht als Anhang senden k\00F6nnen.</p>'),
unistr('<p>E-Mail ist nur f\00FCr authentifizierte Benutzer verf\00FCgbar und erfordert, dass das SMTP innerhalb der &PRODUCT_NAME. Administration Services-Anwendung von einem Instanzadministrator konfiguriert wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739496876303288)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Als E-Mail senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988551176303494)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob der Berichtsdruck aktiviert werden soll. Wenn Sie <strong>Ein</strong> ausw\00E4hlen, k\00F6nnen Benutzer einen Bericht in verschiedenen Formaten herunterladen. Hierzu geh\00F6ren PDF, Microsoft Word, Microsoft Excel und HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988475741303494)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738348060303287)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer ihre aktuelle Berichtsdefinition als <em>\00D6ffentlichen</em> Bericht speichern k\00F6nnen.</p>'),
unistr('<p>\00D6ffentliche Berichte werden in einer Auswahlliste der verf\00FCgbaren Berichte in der Symbolleiste angezeigt. Sie werden f\00FCr jedermann angezeigt.<p>'),
unistr('		<p>Hinweis - Diese Option ist nur f\00FCr authentifizierte Benutzer verf\00FCgbar und ist au\00DFerdem weiter eingeschr\00E4nkt, wenn Sie auch das Feld <strong>Autorisierung f\00FCr \00F6ffentlichen Bericht speichern</strong> ausf\00FCllen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738235719303287)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlichen Bericht speichern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748168812303295)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer diese Spalte beim Sortieren verwenden k\00F6nnen.</p>'),
unistr('        <p>Hinweis - Das Zulassen eines Sortiervorgangs kann zu Performanceproblemen f\00FChren, insbesondere bei gro\00DFen Datasets oder wenn keine entsprechenden Spaltenindizes verf\00FCgbar sind.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98748032166303295)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sortierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738706756303287)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Subscription-Einstellungen f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738627141303287)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Subscription'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535434952303117)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob dieses Element verschl\00FCsselt werden soll, wenn es im Sessionzustand gespeichert wird.'),
unistr('Wenn der Inhalt eines Elements sensible Daten enth\00E4lt, m\00FCssen Sie den Wert verschl\00FCsseln, wenn er in den Tabellen zur Verwaltung des &PRODUCT_NAME.-Sessionzustands gespeichert wird.'),
'Andernfalls kann jeder Benutzer mit der Berechtigung zum Lesen der &PRODUCT_NAME.-Metadatentabellen potenziell eine Abfrage zur Extraktion dieser sensiblen Daten schreiben.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535337471303117)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Wert verschl\00FCsselt in Sessionzustand speichern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906994129303422)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den letzten Wochentag, der in dem Wochenkalender angezeigt wird.'),
unistr('Sie k\00F6nnen dieses Attribut in Verbindung mit <strong>Starttag</strong> verwenden, um die angezeigten Wochentage zu begrenzen, oder k\00F6nnen den Tag vor dem Wert f\00FCr <strong>Starttag</strong> w\00E4hlen, um alle sieben Tage anzuzeigen.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066235201303557)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'de'
,p_message_text=>'Sonntag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066355066303558)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'de'
,p_message_text=>'Montag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066449903303558)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'de'
,p_message_text=>'Dienstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066502097303558)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'de'
,p_message_text=>'Mittwoch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066617911303558)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'de'
,p_message_text=>'Donnerstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066773603303558)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'de'
,p_message_text=>'Freitag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066886467303558)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'de'
,p_message_text=>'Samstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906882203303422)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Endtag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907517043303423)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Endstunde an, um die Anzeige des Wochen- und Tageskalenders zu fokussieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907447815303422)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Endstunde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908814086303424)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf "Ziel", um einen modalen Dialog aufzurufen. Sie k\00F6nnen den Ziellink eingeben, den der Kalender aufruft, um die Details eines vorhandenen Ereignisses anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908742430303423)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ereignisziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509073831303096)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den Namen der PL/SQL-Funktion ein, die aufgerufen wird, wenn ein Fehler innerhalb der Anwendung auftritt.',
unistr('Mit dieser Funktion k\00F6nnen Sie verschiedene Fehlercodes bearbeiten, einschlie\00DFlich der aus der Oracle-Datenbank stammenden Codes, und k\00F6nnen diese Fehler gegebenenfalls in einer benutzerdefinierten Tabelle protokollieren, die Sie definieren.'),
unistr('Die Funktion kann eine Logik zur \00C4nderung der Fehlermeldung und Anzeige des Verzeichnisses enthalten. mit der Oracle-Datenbankfehler in benutzerfreundliche Meldungen umgewandelt werden.'),
unistr('Beispiel: Sie k\00F6nnen eine eindeutige Schl\00FCsselverletzung bei <code>DEMO_CUSTOMERS</code> erfassen und die Meldung <code>ORA-00001</code> durch diesen Text ersetzen: Der Kundenname muss eindeutig sein.'),
'Wenn Sie die Sample Database Application aus den mitgelieferten Anwendungen installieren, wird das Package <code>SAMPLE_PKG</code> erstellt, das die Funktion <code>demo_error_handling</code> umfasst.',
unistr('Diese Beispielfunktion f\00FCr das Fehlerhandling enth\00E4lt umfassende Kommentare, die Sie einfach als Grundlage zur Definition Ihrer eigenen Funktion verwenden k\00F6nnen.</p>'),
'<p>Der eingegebene Funktionsname kann eine Packagefunktion oder Standalone-Funktion in der Datenbank referenzieren. Beispiel:',
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>Wenn ein PL/SQL-Datenbankpackage oder eine Standalone-Funktion referenziert wird, k\00F6nnen Sie die Ersetzungszeichenfolge <code>#OWNER#</code> zur Referenzierung des Parsingschemas der aktuellen Anwendung verwenden. Beispiel:'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>Wenn eine Funktion f\00FCr das Fehlerhandling auf einer Seite angegeben wird, wird diese anstelle dieser Einstellung auf Anwendungsebene f\00FCr diese Seite verwendet.</p>'),
unistr('<p>Funktionen f\00FCr das Fehlerhandling m\00FCssen die folgende Schnittstelle implementieren:'),
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
'<p>Im API-Referenzhandbuch finden Sie eine Beschreibung des Packages <code>apex_error</code>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518697483303104)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Fehlerhandlingfunktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225217037303683)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine Fehlermeldung an, die angezeigt wird, wenn diese Berechnung nicht erfolgreich verl\00E4uft. '),
unistr('Verwenden Sie <code>#SQLERRM#</code> als Ersetzungszeichenfolge f\00FCr die SQL-Fehlermeldung, die sich aus einer nicht erfolgreichen Berechnung ergibt.</p>'),
unistr('<p>Berechnungen sind so ausgelegt, dass sie immer erfolgreich verlaufen. Nur unerwartete Fehler f\00FChren dazu, dass sie nicht erfolgreich verlaufen.'),
unistr('Es wird nicht empfohlen, eine Berechnung zu implementieren, die regelm\00E4\00DFig fehlerhaft ist und als Pseudovalidierung mit dieser Fehlermeldung fungiert.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546845261303127)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine Fehlermeldung an, die angezeigt wird, wenn diese Berechnung nicht erfolgreich verl\00E4uft. '),
unistr('Verwenden Sie <code>#SQLERRM#</code> als Ersetzungszeichenfolge f\00FCr die SQL-Fehlermeldung, die sich aus einer nicht erfolgreichen Berechnung ergibt.</p>'),
unistr('<p>Berechnungen sind so ausgelegt, dass sie immer erfolgreich verlaufen. Nur unerwartete Fehler f\00FChren dazu, dass sie nicht erfolgreich verlaufen.'),
unistr('Es wird nicht empfohlen, eine Berechnung zu implementieren, die regelm\00E4\00DFig fehlerhaft ist und als Pseudovalidierung mit dieser Fehlermeldung fungiert.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860407277303384)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Fehlermeldung f\00FCr diesen Prozess ein.'),
unistr('Diese Meldung wird angezeigt, wenn eine unbehandelte Ausnahme ausgel\00F6st wird. Nachdem eine Fehlerverarbeitung gestoppt wurde, wird ein Rollback ausgegeben und eine Fehlermeldung angezeigt.</p>'),
unistr('<p>Hinweis: Die SQL-Fehlermeldung (sqlerrm) wird standardm\00E4\00DFig angezeigt, wenn <strong>Fehlermeldungsseite</strong> als Ort f\00FCr die Anzeige des Fehler definiert ist. Sie m\00FCssen <code>#SQLERRM#</code> nicht zu dem Fehlertext hinzuf\00FCgen.</p>'),
unistr('<p>Fehlermeldungen k\00F6nnen die folgenden Ersetzungszeichenfolgen enthalten:</p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
'  <dd>Text der Fehlermeldung ohne Fehlernummer.</dd>',
'  <dt><code>#SQLERRM#</code></dt>',
unistr('  <dd>Vollst\00E4ndige Fehlermeldung.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419606430303852)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss einen Wert haben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507432446303095)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den Text ein, der angezeigt werden soll, wenn die Validierung nicht erfolgreich ist.</p>',
unistr('<p>Sie k\00F6nnen <code>#LABEL#</code> als Platzhalter f\00FCr das Label des zugeh\00F6rigen Seitenelements oder <code>#COLUMN_HEADER#</code> als \00DCberschrift der zugeh\00F6rigen editierbaren Regionsspalte verwenden. Die Platzhalter werden nicht unterst\00FCtzt, wenn als')
||' Fehleranzeigeposition "Auf Fehlerseite" festgelegt ist.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507336234303095)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618884099303182)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie, wo die Fehlermeldung f\00FCr diese Validierung angezeigt wird.'),
'Validierungsfehlermeldungen werden auf einer separaten Fehlerseite oder inline mit der vorhandenen Seite angezeigt.',
unistr('Inline-Fehlermeldungen werden unter dem Label <em>Verkn\00FCpftes Element</em> und/oder in einem Benachrichtigungsbereich angezeigt, der als Bestandteil des Seitentemplates definiert ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039468978303536)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'de'
,p_message_text=>'Inline in Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039398906303536)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'de'
,p_message_text=>'Inline mit Feld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039232540303536)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'de'
,p_message_text=>'Inline mit Feld und in Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039538165303536)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldungsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618716199303182)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigeposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535634318303118)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Um Cross-Site Scripting-(XSS-)Angriffe zu verhindern, setzen Sie dieses Attribut immer auf <strong>Ein</strong>.',
unistr('Wenn Sie HTML-Tags wiedergeben m\00FCssen, die im Seitenelement oder in den Eintr\00E4gen einer Werteliste gespeichert sind, k\00F6nnen Sie dieses Kennzeichen auf <strong>Aus</strong> setzen.'),
unistr('In diesen F\00E4llen sollten Sie zus\00E4tzliche Vorkehrungen treffen, um sicherzustellen, dass Benutzereingaben in diese Felder ordnungsgem\00E4\00DF maskiert werden, wenn sie eingegeben und bevor sie gespeichert werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535576197303118)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Escape bei Sonderzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507624666303095)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Autorisierungsschemas werden bei der ersten Verwendung in einer Session ausgewertet.',
unistr('W\00E4hlen Sie den entsprechenden Auswertungspunkt aus, um zu bestimmen, ob die nachfolgende Verwendung der angegebenen Autorisierung das Ergebnis aus dem Arbeitsspeicher abruft oder das Autorisierungsschema erneut auswertet.</p>'),
'#LOV_VALUES#',
'<p>Der Standardwert <em>Einmal pro Session</em> ist der effizienteste Wert.',
unistr('W\00E4hlen Sie einen anderen Wert aus, wenn die Autorisierungspr\00FCfung von der \00C4nderung des Sessionstatus oder von anderen Faktoren abh\00E4ngt, die nicht f\00FCr den Verlauf einer Session konsistent sind.'),
unistr('Die Optionen <em>Einmal pro Komponente</em> und <em>Immer (Kein Caching)</em> stellen zus\00E4tzliche Parameter bereit, die f\00FCr das Autorisierungsschema definiert werden k\00F6nnen.'),
unistr('In Autorisierungs-Plug-ins k\00F6nnen Sie die Attribute <em>component.type</em>, <em>component.id</em> und <em>component.name</em> des Parameters <em>t_authorization</em> verwenden.'),
unistr('F\00FCr die integrierten Schematypen <em>Exists-SQL-Abfrage</em> und <em>Funktionsbody</em> sind \00E4quivalente Bind-Variablen <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> und <em>:APP_COMPONENT_NAME</em> verf\00FCgbar.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015856886303517)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'de'
,p_message_text=>'Einmal pro Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015932398303517)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird einmal f\00FCr jede Komponente ausgewertet, die das Autorisierungsschema referenziert, speichert das Ergebnis jedoch in der Session. Weitere Anforderungen zur Wiedergabe oder Verarbeitung des Schemas verwenden das Ergebnis im Speicher.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015630540303516)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'de'
,p_message_text=>'Einmal pro Seitenansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015772819303516)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird einmal f\00FCr jede Anforderung ausgewertet, die verarbeitet wird. Verwenden Sie das Ergebnis im Speicher, wenn das Autorisierungsschema in mehr als einer Komponente auf der Seite referenziert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015462072303516)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'de'
,p_message_text=>'Einmal pro Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99015518762303516)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Wird nur einmal ausgewertet und verwendet dann das Ergebnis im Speicher.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016003550303517)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'de'
,p_message_text=>'Immer (Kein Caching)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016131882303517)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'de'
,p_message_text=>'Das Autorisierungsschema wird immer ausgewertet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507574183303095)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Auswertungspunkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512642456303099)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Ereignis an, das die dynamische Aktion ausl\00F6st.'),
'Informationen zu spezifischen Ereignissen finden Sie in dem entsprechenden Abschnitt im <em>App Builder User''s Guide</em>.</p>',
'Ereignisse werden in folgende Typen kategorisiert:',
'<dl>',
'  <dt>Browserereignisse</dt>',
'    <dd>Standardbrowserereignisse.</dd>',
'  <dt>Frameworkereignisse</dt>',
unistr('    <dd>Frameworkereignisse werden aus dem Application Express Framework ausgel\00F6st.</dd>'),
'  <dt>Komponentenereignisse</dt>',
unistr('    <dd>Nur verf\00FCgbar, wenn eine Komponente in Ihrer Anwendung verf\00FCgbar ist, die ein benutzerdefiniertes Ereignis ausl\00F6st. Diese Ereignisse werden entweder aus nativen Komponenten oder Plug-in-Komponenten ausgel\00F6st, die Sie in Ihrer Anwendung instal')
||'liert haben.</dd>',
'  <dt>Benutzerdefiniertes Ereignis</dt>',
unistr('    <dd>Beliebiges benutzerdefiniertes Ereignis, das aus Ihrer Anwendung ausgel\00F6st wird.</dd>'),
'</dl>',
unistr('<p>Hinweis: Die angezeigten Ereignisse unterscheiden sich je nach aktuellem Benutzeroberfl\00E4chentyp der Seite.'),
unistr('Wenn Sie ein Ereignis w\00E4hlen m\00F6chten, das einem anderen Typ entspricht, k\00F6nnen Sie <strong>Nicht unterst\00FCtzte anzeigen</strong> w\00E4hlen.'),
unistr('Mit dieser Option werden alle Ereignisse angezeigt, einschlie\00DFlich der Ereignisse, die dem aktuellen Typ nicht entsprechen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512554970303099)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ereignis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536892429303119)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Geltungsbereich des Ereignisses, der bestimmt, wann das Ereignis ein zweites oder weiteres Mal ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026404764303525)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'de'
,p_message_text=>'Static'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026538467303525)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Bindet den Event Handler an die ausl\00F6senden Elemente w\00E4hrend der G\00FCltigkeitsdauer der aktuellen Seite, ist jedoch nicht mehr gebunden, wenn ein ausl\00F6sendes Element \00FCber die teilweise Seitenaktualisierung (PPA, Partial Page Refresh) aktualisiert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026622793303525)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'de'
,p_message_text=>'Dynamisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026712588303525)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Bindet den Event Handler an die ausl\00F6senden Elemente w\00E4hrend der G\00FCltigkeitsdauer der aktuellen Seite, unabh\00E4ngig davon, ob ausl\00F6sende Elemente \00FCber die teilweise Seitenaktualisierung (PPA, Partial Page Refresh) neu erstellt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026854275303525)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'de'
,p_message_text=>'Einmal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026999577303525)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Bindet den Event Handler nur einmal an die ausl\00F6senden Elemente. Die dynamische Aktion wird erst erneut ausgel\00F6st, nachdem die Seite vollst\00E4ndig aktualisiert wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536792298303119)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ereignisbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344339930303789)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Sie diesen Titel aus der \00DCbersetzung ausschlie\00DFen m\00F6chten. Dieses Attribut ist wirkungslos, es sei denn, die Anwendung wird in eine andere Sprache \00FCbersetzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344299229303789)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift aus \00DCbersetzung ausschlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177507569303646)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie aus, wie oft diese Layerbedingung ausgef\00FChrt wird.'),
unistr('Wenn Sie in Ihrer Bedingung <em>Spalten</em> referenzieren, m\00FCssen Sie <strong>F\00FCr jede Zeile</strong> angeben, damit die Bedingung f\00FCr jede Zeile in der Layerabfrage ausgewertet wird.'),
unistr('Sonst legen Sie <strong>Einmal</strong> fest, um die Validierungen einmal f\00FCr die Region auszuwerten.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619609187303183)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie, wie oft die Validierung dieser editierbaren Region ausgef\00FChrt wird.'),
unistr('Wenn Sie in Ihrer Bedingung <em>Spalten</em> referenzieren, m\00FCssen Sie <strong>F\00FCr jede Zeile</strong> angeben, damit die Bedingung f\00FCr jede Zeile in der editierbaren Region ausgewertet wird.'),
unistr('Sonst legen Sie <strong>Einmal</strong> fest, um die Validierungen einmal f\00FCr die Region auszuwerten.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039928658303536)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Einmal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039838759303536)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr jede Zeile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619530866303182)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750348260303297)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie diese Option, wenn die schreibgesch\00FCtzte Bedingung ausgef\00FChrt wird.</p>'),
unistr('        <p>Wenn Sie <em>Spalten</em> in der schreibgesch\00FCtzten Bedingung referenzieren, m\00FCssen Sie <strong>F\00FCr jede Zeile</strong> angeben, damit die Bedingung f\00FCr jede Zeile des interaktiven Grids ausgewertet wird.'),
unistr('		Sonst legen Sie <strong>Einmal</strong> fest, um die Bedingung nur einmal f\00FCr die Region auszuwerten.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750560452303297)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Einmal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866328693303389)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Werten Sie die schreibgesch\00FCtzte Bedingung nur einmal f\00FCr die gesamte Region aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750476056303297)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr jede Zeile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866258710303388)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Werten Sie die schreibgesch\00FCtzte Bedingung unabh\00E4ngig f\00FCr jede Zeile aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750230193303297)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619476699303182)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den Ausf\00FChrungsgeltungsbereich f\00FCr die Validierung dieser editierbaren Region.'),
unistr('W\00E4hlen Sie <strong>F\00FCr erstellte und ge\00E4nderte Zeilen</strong>, wenn diese Validierung f\00FCr neue und aktualisierte Zeilen in Ihrer editierbaren Region ausgewertet werden soll.'),
unistr('Wenn diese Validierung f\00FCr jede weitergeleitete Zeile ausgewertet werden soll, w\00E4hlen Sie <strong>Alle weitergeleiteten Zeilen</strong> aus.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039721630303536)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Alle weitergeleiteten Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99039641553303536)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr erstellt und ge\00E4nderte Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619392235303182)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrungsgeltungsbereich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512288540303099)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Reihenfolge f\00FCr die Komponente an. Sie bestimmt die Reihenfolge der Ausf\00FChrung.</p>'),
unistr('<p>Hinweis: Wenn zwei Komponenten denselben Reihenfolgewert haben, k\00F6nnen sie in einer anderen Reihenfolge ausgef\00FChrt werden, wenn die Anwendung exportiert und in eine andere Umgebung importiert wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512109794303099)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Reihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335896816303782)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Filtern Sie bei einem ORDS-REST-Service alle Datens\00E4tze heraus, bei denen das Attribut "sal" weniger als 3000 betr\00E4gt.</dt>'),
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335750109303782)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Filterausdruck an, der an den externen REST-Service \00FCbergeben werden soll. Der Ausdruck wird unver\00E4ndert an den Remoteserver \00FCbergeben. Die Syntax ist vom Typ der REST-Datenquelle abh\00E4ngig. Beispiel: Bei Oracle REST Data Services (ORD')
||'S) wird JSON-Syntax erwartet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335669162303782)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Externer Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336150711303782)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Sortieren Sie Daten in einem ORDS-REST-Service aufsteigend nach dem Attribut "job" und dann absteigend nach "ename".</dt>',
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336017611303782)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Order-by-Ausdruck an, der an den externen REST-Service \00FCbergeben werden soll. Der Ausdruck wird unver\00E4ndert an den Remoteserver \00FCbergeben. Die Syntax ist vom Typ der REST-Datenquelle abh\00E4ngig. Beispiel: Bei Oracle REST Data Services (')
||'ORDS) wird JSON-Syntax erwartet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335905919303782)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Externer Order-By-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883975250303403)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die externe Nachverarbeitung f\00FCr diesen Bericht aktiviert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883840081303403)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883686795303403)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr den Link an, auf den Endbenutzer klicken, um die externe Verarbeitungs-Engine aufzurufen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883546206303403)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Link-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883410082303403)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die URL zu einem Server f\00FCr die Nachverarbeitung dieses Berichts an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98883305630303403)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193415119303658)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Facet-Gruppe aus, mit der dieses Kontrollk\00E4stchen verkn\00FCpft wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193333358303658)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Facet-Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121808895303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Wertelistentyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122544406303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122669408303603)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Werteliste basiert auf einer automatisch generierten Abfrage, mit der die eindeutigen Spaltenwerte ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248769083303708)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248883017303708)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die dynamische Werteliste basiert auf der SQL-Abfrage, die vom eingegebenen Funktionsbody zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121975972303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122020239303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Werteliste basiert auf einer vordefinierten Werteliste, die in "Gemeinsame Komponenten" definiert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122110089303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122202795303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>'Die dynamische Werteliste basiert auf der SQL-Abfrage, die Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122348165303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99122424755303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Die statische Werteliste basiert auf dem Textwert, den Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121711558303602)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966773370303476)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob das Facet ausblendbar ist. Wenn diese Option auf <strong>Ein</strong> gesetzt ist, wird ein Umschalter links neben dem Facet angezeigt, um die zugeh\00F6rigen Listeneintr\00E4ge ein-/auszublenden. Wenn die Option auf <strong>Aus</strong> ')
||unistr('gesetzt ist, sind das Facet und die zugeh\00F6rigen Listeneintr\00E4ge immer sichtbar.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966692319303476)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausblendbar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385444214303823)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob die Anzahl der Listeneintr\00E4ge f\00FCr das Facet oder den Filter berechnet werden soll. Eine Verwendung dieser Option hat Auswirkungen auf die Performance.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385312827303823)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzahl berechnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193670185303658)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, wie Filter in dieser Gruppe kombiniert werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193941329303658)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'de'
,p_message_text=>'AND (Schnittmenge)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194069986303659)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Filter werden mit "AND" kombiniert. Das hei\00DFt, das Ergebnis ist die Schnittmenge aus den Ergebnissen der einzelnen Filter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193747580303658)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'de'
,p_message_text=>'OR (Vereinigungsmenge)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193818125303658)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Filter werden mit "OR" kombiniert. Das hei\00DFt, das Ergebnis ist die Vereinigungsmenge der Ergebnisse der einzelnen Filter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193592024303658)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Filter kombinieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966117935303475)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob eine clientseitige Filterung der Listeneintr\00E4ge f\00FCr das Facet oder den Filter zul\00E4ssig ist. Wenn die Option auf <strong>Ein</strong> gesetzt ist, wird \00FCber den Listeneintr\00E4gen ein Suchfeld gerendert, mit dem Endbenutzer die Liste ')
||unistr('filtern k\00F6nnen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966048614303475)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Clientseitige Filterung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194639885303659)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Gibt an, ob das Diagramm anfangs angezeigt wird. Diese Eigenschaft gilt nur, wenn die Regionseigenschaft der Facet-Suche "Diagramme anzeigen" auf "Selektor" gesetzt ist. \00C4nderungen an dieser Eigenschaft sind m\00F6glicherweise nicht sofort sichtbar, d')
||unistr('a die vom Benutzer angezeigten Diagramme in der Browsersession persistiert werden. Um die Auswirkung von \00C4nderungen an dieser Eigenschaft zu sehen, setzen Sie den Bericht \00FCber die Cache-Control-Option "Regionen zur\00FCcksetzen" zur\00FCck, z.B. mit der vom ')
||unistr('Assistenten generierten Schaltfl\00E4che "Zur\00FCcksetzen".</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194516970303659)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Diagramm anfangs anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966993566303476)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Gibt an, ob das Facet anfangs ausgeblendet angezeigt werden soll. \00C4nderungen an dieser Eigenschaft sind m\00F6glicherweise nicht sofort sichtbar, da die Erweiterung in der Browsersession persistiert wird. Um die Auswirkung von \00C4nderungen an dieser Eig')
||unistr('enschaft zu sehen, setzen Sie den Bericht \00FCber die Cache-Control-Option "Regionen zur\00FCcksetzen" zur\00FCck, z.B. mit der vom Assistenten generierten Schaltfl\00E4che "Zur\00FCcksetzen".</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966878425303476)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4nglich ausgeblendet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199553840303663)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Bestimmt, ob das Facet standardm\00E4\00DFig angezeigt werden soll. \00C4nderungen an dieser Eigenschaft sind m\00F6glicherweise nicht sofort sichtbar, da der Anzeigestatus in der Browsersession persistiert wird. Um die Auswirkung von \00C4nderungen an dieser Eigensc')
||unistr('haft zu sehen, setzen Sie den Bericht \00FCber die Cache-Control-Option "Regionen zur\00FCcksetzen" zur\00FCck, z.B. mit der vom Assistenten generierten Schaltfl\00E4che "Zur\00FCcksetzen".</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199465985303663)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4nglich angezeigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967113912303476)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die maximale H\00F6he f\00FCr das Facet in Pixel ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967030269303476)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Maximale H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967295769303476)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309429702302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, wie einzelne Werte beim Filtern kombiniert werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309792405302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'de'
,p_message_text=>'AND (Schnittmenge)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309878616302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Werte werden mit "AND" kombiniert. Das hei\00DFt, das Ergebnis ist die Schnittmenge aller einzelnen Werte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309574088302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'de'
,p_message_text=>'OR (Vereinigungsmenge)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309672683302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Werte werden mit "OR" kombiniert. Das hei\00DFt, das Ergebnis ist die Vereinigungsmenge der einzelnen Werte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309331847302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Filterkombination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309073601302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Normale Zeichen:</dt>',
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
'<dt>Steuerzeichen:</dt>',
'<dd>Tabulator (<em>ASCII: 9</em>) <pre>\t</pre></dd>',
'<dd>Zeilenvorschub (<em>ASCII: 10</em>) <pre>\n</pre></dd>',
'<dt>Andere Zeichen:</dt>',
'<dd>Verwenden Sie einen Unicode-Codierungswert im Format "\xxxx", wobei "xxxx" der Hexadezimalwert eines Zeichens im UCS-2-Codierungsformat ist.</dd>',
unistr('<dd>Start der \00DCberschrift (<em>ASCII: 1</em>) <pre>\005C0001</pre></dd>'),
'<dd>"@"-Symbol (<em>ASCII: 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308951649302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Identifiziert das Zeichen, das Werte voneinander trennt. Beachten Sie, dass die Zeichen <strong>"</strong> (doppelte Anf\00FChrungszeichen) und <strong>\005C</strong> (umgekehrter Schr\00E4gstrich) nicht als Werttrennzeichen unterst\00FCtzt werden (auch nicht im ')
||'Format <strong>\xxxx</strong>).</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308806343302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Trennzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309201931302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gibt an, ob vor- und nachgestellte Leerzeichen von einzelnen Werten nach dem Aufteilen abgeschnitten werden sollen.</p>',
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>Wenn "Leerzeichen abschneiden" <em>deaktiviert</em> ist, werden die folgenden individuellen Werte gez\00E4hlt:</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('<dt>Wenn "Leerzeichen abschneiden" <em>aktiviert</em> ist, werden die folgenden individuellen Werte gez\00E4hlt:</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>Beachten Sie, dass das Abschneiden von Leerzeichen die Abfrageperformance erheblich beeintr\00E4chtigen kann. Erw\00E4gen Sie bei gr\00F6\00DFeren Datasets stattdessen eine Datenbereinigung.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309177327302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Leerzeichen abschneiden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310164217302935)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310279611302935)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spalte enth\00E4lt nicht mehrere Werte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558616794303136)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558734418303136)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spalte enth\00E4lt nicht mehrere Werte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308382739302933)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Bestimmt, ob die Quellspalte mehrere Werte enth\00E4lt und wie diese codiert werden.</p><p><em>Mehrwertige Facets oder Filter werden nur in Datenbanken mit Oracle 12.2 oder h\00F6her unterst\00FCtzt. Bei einer Datenbank mit 12.1 l\00F6st &PRODUCT_NAME. einen Lauf')
||'zeitfehler aus, wenn ein mehrwertiges Facet oder ein mehrwertiger Filter definiert werden.</em></p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308656991302933)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'de'
,p_message_text=>'JSON-Array'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308747267302934)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Quellspalte enth\00E4lt ein JSON-Array mit skalaren Werten. &PRODUCT_NAME. l\00F6st Fehlermeldungen aus, wenn die Spalte ung\00FCltige JSON-Syntax enth\00E4lt.</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308465560302933)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'de'
,p_message_text=>'Begrenzte Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308503559302933)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Spalte enth\00E4lt Werte als Liste mit Begrenzungszeichen.</p><pre>APEX,SQL,PL/SQL</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98308231262302933)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194446236303659)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Gibt an, ob eine Schaltfl\00E4che neben dem Facet angezeigt wird, sodass der Benutzer ein Diagramm der Anzahl an Facet-Listeneintr\00E4gen anzeigen kann. Diese Eigenschaft gilt nur, wenn die Regionseigenschaft der Facet-Suche "Diagramme anzeigen" nicht au')
||'f "Nein" gesetzt ist.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194387493303659)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'de'
,p_message_text=>'"Diagramm" anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965944064303475)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob die Anzahl der Vorkommen der Listeneintr\00E4ge f\00FCr das Facet oder den Filter angezeigt werden soll. Wenn die Option auf <strong>Ein</strong> gesetzt ist, wird die Anzahl in Klammen neben dem Listeneintrag angezeigt. Beispiel: KING (3')
||').</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965852986303475)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzahl anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966579600303476)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie die maximale Anzahl von Listeneintr\00E4gen an, die f\00FCr das Facet angezeigt werden sollen. Wenn ein Wert angegeben ist und die Liste mehr als die angegebene Anzahl von Eintr\00E4gen enth\00E4lt, wird unten in der Liste der Link <strong>Mehr anzeigen')
||unistr('</strong> gerendert. Wenn kein Wert angegeben ist, werden alle Listeneintr\00E4ge angezeigt.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966456423303476)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Maximal angezeigte Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966354363303475)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob ausgew\00E4hlte Listeneintr\00E4ge in der Liste f\00FCr das Facet oder den Filter zuerst angezeigt werden. Dieses Attribut gilt nicht, wenn die mit dem Facet verkn\00FCpfte Werteliste Gruppen definiert.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98966299419303475)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlte zuerst anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595857505303164)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Listeneintr\00E4ge f\00FCr das Facet oder den Filter sortiert werden sollen. Bei <strong>Ein</strong> werden die Listeneintr\00E4ge absteigend nach der Anzahl sortiert. Bei <strong>Aus</strong> werden die Listeneintr\00E4ge in der durch die Wert')
||'eliste definierten Reihenfolge angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98595762319303164)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Absteigend nach Anzahl sortieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199300171303663)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob Endbenutzer das Facet anzeigen oder ausblenden k\00F6nnen. Wenn diese Option f\00FCr mindestens ein Facet aktiviert ist, wird eine Schaltfl\00E4che "Mehr Facets" hinzugef\00FCgt, mit der Sie ausw\00E4hlen k\00F6nnen, welche Facets Sie anzeigen oder ausbl')
||unistr('enden m\00F6chten. Das Berechnen der Anzahl nicht angezeigter Facets hat keine Auswirkungen auf die Performance.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199287367303663)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigeumschaltung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385648110303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, wie Listeneintr\00E4ge mit der Anzahl Null f\00FCr das Facet oder den Filter angezeigt werden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385955055303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'de'
,p_message_text=>'Deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386051520303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Zeigen Sie alle Eintr\00E4ge an, aber deaktivieren Sie nicht filterbare Eintr\00E4ge.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385749598303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385809912303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Zeigen Sie nur filterbare Listeneintr\00E4ge an.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386162776303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'de'
,p_message_text=>'Zuletzt anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386283739303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Zeigen Sie alle Eintr\00E4ge an, aber deaktivieren Sie nicht filterbare Eintr\00E4ge, und zeigen Sie sie in der Liste f\00FCr das Facet oder den Filter zuletzt an. Diese Option wird ignoriert, wenn f\00FCr die zugeh\00F6rige Werteliste das Gruppenfeature verwendet wi')
||'rd.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385516448303823)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge mit Anzahl Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519030565303104)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche Attribute ein, die in der HTML-Tabellenzelle verwendet werden, die dieses Label enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518978883303104)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Tabellenzellenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874945439303396)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Feld-Template, das beim Rendering des tabellarischen Formularfelds verwendet werden muss. Wenn kein Template ausgew\00E4hlt ist, wird das Feld mit dem Standardlabel wiedergegeben, das mit den Eingabehilfen konform ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895121018303412)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Feld-Template, das beim Rendering des tabellarischen Formularfelds verwendet werden muss. Wenn kein Template ausgew\00E4hlt ist, wird das Feld mit dem Standardlabel wiedergegeben, das mit den Eingabehilfen konform ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518835779303104)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Labeltemplate zur Definition von Darstellung und Layout dieses Elementlabels aus.</p>'),
'        <p>Labeltemplates werden im Anwendungs-Theme definiert.',
'        Wird ein Element erstellt, wird das Template automatisch auf das Standardelementtemplate festgelegt, das im aktuellen Theme definiert ist.</p>',
'        <p>Viele Themes enthalten Labeltemplates zur Anzeige von erforderlichen, optionalen und ausgeblendeten Labels.<br>',
'        Universal Theme stellt die folgenden Labeltemplates bereit:',
'          <dl>',
'            <dt>Ausgeblendet</dt>',
'              <dd>Verwenden Sie dieses Template, wenn das Label nicht auf dem Bildschirm angezeigt werden soll. Beachten Sie, dass assistive Technologie das Label aber weiterhin lesen kann.',
unistr('              "Ausgeblendet" wird bei Kontrollk\00E4stchenelementen ignoriert, weil ein Label nach dem Kontrollk\00E4stchen angezeigt werden muss.</dd>'),
'            <dt>Optional</dt>',
unistr('              <dd>Verwenden Sie dieses Template f\00FCr optionale Formularelemente. Das Label wird neben dem Element angezeigt.</dd>'),
unistr('            <dt>Optional - \00DCber</dt>'),
unistr('              <dd>Verwenden Sie dieses Template f\00FCr optionale Formularelemente. Das Label wird \00FCber dem Element angezeigt.</dd>'),
'            <dt>Optional - Unverankert</dt>',
unistr('              <dd>Verwenden Sie dieses Template f\00FCr optionale Formularelemente. Das Label wird innerhalb des Eingabeelements angezeigt und verkleinert sich automatisch, wenn das Eingabefeld einen Wert enth\00E4lt.</dd>'),
'            <dt>Erforderlich</dt>',
unistr('              <dd>Dieses Labeltemplate zeigt ein rotes Sternchen neben dem Label an. Es wird f\00FCr Formularelemente verwendet, bei denen eine Benutzereingabe erforderlich ist. Das Label wird neben dem Element angezeigt.</dd>'),
unistr('            <dt>Erforderlich - \00DCber</dt>'),
unistr('              <dd>Dieses Labeltemplate zeigt ein rotes Sternchen neben dem Label an. Es wird f\00FCr Formularelemente verwendet, bei denen eine Benutzereingabe erforderlich ist. Das Label wird \00FCber dem Element angezeigt. Mit Elementtemplates k\00F6nnen Sie d')
||unistr('ie Benutzeroberfl\00E4chenattribute als Teil eines Themes definieren und diese Definition f\00FCr viele Seitenelemente gemeinsam verwenden.</dd>'),
'            <dt>Erforderlich - Unverankert</dt>',
unistr('              <dd>Dieses Labeltemplate zeigt ein rotes Sternchen neben dem Label an. Es wird f\00FCr Formularelemente verwendet, bei denen eine Benutzereingabe erforderlich ist. Das Label wird innerhalb des Eingabeelements angezeigt und verkleinert sich ')
||unistr('automatisch, wenn das Eingabefeld einen Wert enth\00E4lt. Mit Elementtemplates k\00F6nnen Sie die Benutzeroberfl\00E4chenattribute als Teil eines Themes definieren und diese Definition f\00FCr viele Seitenelemente gemeinsam verwenden.</dd>'),
'          </dl>',
'          Siehe auch: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal-Theme-Beispielanwendung</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518717132303104)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332066832303779)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datentyp filtern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746091172303293)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob eine Suche mit genauer \00DCbereinstimmung ausgef\00FChrt werden soll, wenn der Endbenutzer Text in einen Spaltenfilter eingibt.'),
unistr('        Wenn dieser Wert auf <strong>Aus</strong> gesetzt ist, f\00FChrt der Filter eine "Enth\00E4lt"-Suche anstelle einer "Ist Gleich"-Suche aus.</p>'),
unistr('      <p>Beispiel: Bei einer Spalte namens TAGS entspricht dies TAGS = "<<Wert>>". Wenn "Genaue \00DCbereinstimmung" auf <strong>Aus</strong> gesetzt ist, entspricht dies TAGS LIKE "%<<Wert>>%". ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745976521303293)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Genaue \00DCbereinstimmung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744471847303292)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob immer ein Filter f\00FCr diese Spalte erforderlich ist.</p>'),
unistr('        <p>Hinweis - Ein Filter ist immer f\00FCr diese spezifische Spalte erforderlich, bevor Daten zur\00FCckgegeben werden, ungeachtet der Option <strong>Filter erforderlich</strong> in den interaktiven Grid-Attributen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744342349303292)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744608456303292)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie die Werteliste f\00FCr den Filter abgeleitet wird, wenn ein Benutzer auf die Spalten\00FCberschrift oder in Filter-Dialogfeldern klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744981360303292)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745060923303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Eindeutige Spaltenwerte werden f\00FCr VARCHAR2- und NUMBER-Spalten angezeigt. DATE- und TIMESTAMP-Spalten nutzen die integrierten vordefinierten Datumsbereiche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331018772303778)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'de'
,p_message_text=>'Werteliste verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331172782303778)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'de'
,p_message_text=>'Werte werden aus Werteliste abgeleitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744757763303292)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744859209303292)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Deaktivieren Sie Werte, die in dem Filter angezeigt werden.',
unistr('        Diese Option eignet sich f\00FCr gro\00DFe Spalten, bei denen die meisten Werte im Allgemeinen mehr als 50 Zeichen enthalten, oder wenn eine Liste sich zur Auswahl eines bestimmten Datensatzes nicht eignet.'),
'        Stattdessen kann der Endbenutzer einfach einen Teilwert eingeben und dann die Ergebnisse anzeigen.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745710946303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745839635303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Werte werden aus dem PL/SQL-Funktionsbody abgeleitet, der eine SQL-Abfrage zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745375703303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745443779303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'de'
,p_message_text=>'Werte werden aus einer vorhandenen Werteliste abgeleitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745111424303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745253112303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>'Werte werden aus der SQL-Abfragedefinition abgeleitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745596068303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98745678754303293)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Werte werden aus einer statischen Werteliste abgeleitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744539653303292)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wertelistentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743241403303291)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, welche Filteroperatoren Endbenutzer f\00FCr diese Spalte verwenden k\00F6nnen.</p>'),
unistr('        <p>Je nach Gr\00F6\00DFe des Datasets und der Spaltenindizes k\00F6nnen Sie bestimmte Filteroperatoren deaktivieren, um Performanceprobleme f\00FCr die Endbenutzer zu vermeiden.'),
'        Bestimmte Operatoren verwenden Full Table Scans anstelle von Spaltenindizes.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914501289303428)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'de'
,p_message_text=>unistr('Enth\00E4lt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914672594303428)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Filter gibt Ergebnisse von Spaltenwerten zur\00FCck, die den Filterwert enthalten.'),
'        &PRODUCT_NAME. verwendet <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code> in der Where-Klausel.</p>',
unistr('        <p>Hinweis - Dieser Operator verhindert, dass Spaltenindizes verwendet werden, die zu einem Full Table Scan f\00FChren k\00F6nnen.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743408639303291)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Gro\00DF-/Kleinschreibung nicht beachten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866013055303388)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Filter gibt Ergebnisse von Spaltenwerten ungeachtet von Unterschieden in der Schreibweise des Spalten- und Filterwertes zur\00FCck.'),
'        &PRODUCT_NAME. verwendet einen <code>UPPER(column) <em>Operator</em> UPPER(filtervalue)</code> in der Where-Klausel.</p>',
unistr('        <p>Hinweis - Im Allgemeinen verhindert die Verwendung von UPPER f\00FCr Spalten- und Filterwert die Verwendung von Spaltenindizes, au\00DFer bei funktionsbasierten Spaltenindizes mit UPPER(<em>column</em>).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743394286303291)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Regul\00E4rer Ausdruck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866145043303388)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Filter gibt Ergebnisse basierend auf dem eingegebenen regul\00E4ren Ausdruck zur\00FCck.</p>'),
unistr('        <p>Hinweis - Die Verwendung von REGEXP-Operatoren ist komplex und wird im Allgemeinen nur von erfahrenen Benutzern verwendet. Diese Operatoren k\00F6nnen zu einer sehr schlechten Performance f\00FChren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914705857303428)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'de'
,p_message_text=>'Beginnt mit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914820698303428)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Filter gibt Ergebnisse von Spaltenwerten zur\00FCck, die mit dem Filterwert beginnen.'),
'        &PRODUCT_NAME. verwendet <code>column LIKE filtervalue<strong>%</strong></code> in der Where-Klausel.</p>',
unistr('        <p>Hinweis - Dieser Operator kann verf\00FCgbare Spaltenindizes verwenden. {Ausnahmen werden in <strong>Gro\00DF-/Kleinschreibung nicht beachten</strong> aufgef\00FChrt.}</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743125811303291)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Operatoren, die die Performance beeintr\00E4chtigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743636210303291)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie aus, mit welcher Schreibweise Text innerhalb des Spaltenwertes gespeichert wird.</p>'),
unistr('        <p>Wenn die Spalte immer mit Gro\00DFbuchstaben angegeben wird, z.B. <em>Benutzername</em>, oder immer mit Kleinbuchstaben, kann die Performance beim Abrufen von Filterergebnissen verbessert werden.'),
unistr('          Wenn <strong>Gro\00DFbuchstaben</strong> oder <strong>Kleinbuchstaben</strong> ausgew\00E4hlt ist, werden ausgew\00E4hlte Suchen immer unter Beachtung der Gro\00DF-/Kleinschreibung ausgef\00FChrt.</p>'),
unistr('        <p>Hinweis - Wenn "Gemischt" ausgew\00E4hlt ist, k\00F6nnen Endbenutzer <strong>Gro\00DF-/Kleinschreibung beachten</strong> in den Dialogfeldern "Suchen und Filtern" angeben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743946652303292)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'de'
,p_message_text=>'Kleinschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744087173303292)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Der Spaltenwert wird immer in Kleinbuchstaben gespeichert.',
'        &PRODUCT_NAME. verwendet einen <code>column <em>operator</em> LOWER(filtervalue)</code> in der Where-Klausel.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744158264303292)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'de'
,p_message_text=>'Gemischt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98744244766303292)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenwert wird in gemischter Schreibweise gespeichert. Die Einstellung f\00FCr den Operator <strong>Gro\00DF-/Kleinschreibung nicht beachten</strong> bestimmt die verwendete Where-Klausel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743721426303292)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Gro\00DFschreibung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743846785303292)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Der Spaltenwert wird immer in Gro\00DFbuchstaben gespeichert.'),
'        &PRODUCT_NAME. verwendet einen <code>column <em>operator</em> UPPER(filtervalue)</code> in der Where-Klausel.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98743521692303291)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Gro\00DF-/Kleinschreibung f\00FCr Text')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537639195303119)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob die Aktion bei der Initialisierung ausgel\00F6st wird.</p>'),
'        							<p>Initialisierung hat je nach Definition der dynamischen Aktion eine etwas andere Bedeutung. Bei dynamischen',
unistr('        							Aktionen, die bei interaktiven Grid-Spalten ausgel\00F6st werden sollen, gibt dies an, ob die Aktion ausgel\00F6st wird, wenn die interaktive'),
unistr('        							Grid-Zeile zur Bearbeitung aktiviert wird. Bei allen anderen dynamischen Aktionen gibt dies an, ob die Aktion ausgel\00F6st wird, wenn'),
'        							die Seite geladen wird.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537520016303119)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Bei Initialisierung ausl\00F6sen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537427456303119)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob diese Aktion ausgel\00F6st wird, wenn die ausl\00F6sende Elementbedingung erf\00FCllt ist, indem Sie <strong>True</strong> (True-Aktion) w\00E4hlen, oder wenn sie nicht erf\00FCllt ist, indem Sie <strong>False</strong> (False-Aktion) w\00E4hlen.</p>'),
unistr('<p>Hinweis: Wenn keine Bedingung angegeben wird, werden nur <strong>True</strong>-Aktionen ausgel\00F6st.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027110098303526)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'de'
,p_message_text=>'Falsch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99027036196303525)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'de'
,p_message_text=>'Wahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537358673303119)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ausl\00F6sen, wenn das Ereignisergebnis wie folgt ist')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411240854303845)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Spaltenheader des Berichts am Anfang der <strong>Seite</strong> oder am Anfang der <strong>Region</strong> fixiert werden sollen, sodass die Spaltenheader sichtbar bleiben, w\00E4hrend der Benutzer vertikal durch den Bericht scrollt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412298305303846)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412370542303846)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>'Berichtsheader ist nicht fixiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411456907303845)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411644898303845)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Fixiert den Berichtsheader oben auf der Seite. W\00E4hrend der Benutzer vertikal durch die Seite scrollt, bleibt der Berichtsheader oben auf der Seite fixiert. Auf <strong>Seitenebene</strong> fixierte \00DCberschriften sind hilfreich, wenn der Bericht den H')
||unistr('auptinhalt der Seite darstellt. Diese Einstellung wird nicht unterst\00FCtzt, wenn sich die Region in einem Dialogfeld befindet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411328474303845)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411503228303845)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Fixiert den Berichtsheader am Anfang der aktuellen Region. W\00E4hrend der Benutzer vertikal in der Region scrollt, bleibt der Berichtsheader am Anfang der Region fixiert. Auf <strong>Regionsebene</strong> fixierte \00DCberschriften sind auch f\00FCr Seiten mit ')
||'mehreren Regionen wie Dashboard-Seiten geeignet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411110880303845)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Fixiert bei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412690378303846)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die maximale H\00F6he f\00FCr den Bericht in Pixel ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412510897303846)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Maximale Berichtsh\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99412784191303846)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920671435303433)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die feste H\00F6he f\00FCr den Bericht in Pixel ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920532764303433)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Feste Berichtsh\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920726169303433)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737174845303286)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob das interaktive Grid mit einer festen Zeilenh\00F6he angezeigt werden soll.</p>'),
unistr('        <p>Wenn diese Option auf <em>Ja</em> gesetzt ist, werden Auslassungszeichen (...) am Ende der Daten f\00FCr Spalten angezeigt, die zu schmal sind, um alle Daten anzuzeigen.'),
unistr('        Wenn diese Option auf <em>Nein</em> festgelegt ist, werden die Daten gegebenenfalls \00FCber mehrere Zeilen umbrochen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737003849303286)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Feste Zeilenh\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606587186303173)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie einen Regionsfooter ein, der direkt nach dem jeweiligen Hauptinhalt nach <code>#BODY#</code> im Regionstemplate angezeigt werden soll. ',
unistr('Sie k\00F6nnen Shortcuts und die Ersetzungszeichenfolge <code>#TIMING#</code> verwenden, um die Dauer f\00FCr die Wiedergabe der Region anzugeben.</p>'),
unistr('<p>Verwenden Sie bei Berichtsregionen folgende Ersetzungszeichenfolgen f\00FCr die Seitennummerierung:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt> ',
unistr('    <dd>Gibt die Anzahl der Zeilen an, die von der Berichts-Engine abgerufen werden (die Seitengr\00F6\00DFe). Mit diesen Ersetzungszeichenfolgen k\00F6nnen Sie dem Benutzer benutzerdefinierte Meldungen anzeigen.</dd>'),
'<dt><code>#TOTAL_ROWS#</code></dt> ',
unistr('  <dd>Zeigt die Gesamtanzahl der Zeilen an, die eine SQL-Abfrage f\00FCr einen Bericht erf\00FCllen. Beispiel: Das "Z" in "Zeilen X - Y von Z"</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt> ',
'    <dd>Das "X" in "Zeilen X - Y von Z"</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt> ',
'    <dd>Das "Y" in "Zeilen X - Y von Z"</dd>',
'</dl>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516127702303102)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Text oder HTML-Code ein, der vor dem Footer der Seitentemplate angezeigt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516022094303102)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Footertext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99055927086303549)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Wenn dieses Attribut auf <code>fielddatabold</code> festgelegt wird, wird folgende HTML generiert</dt>',
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Beispieldaten&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873382923303394)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie CSS-Klassen ein, die f\00FCr den Wert dieser Spalte angewendet werden sollen. Sie k\00F6nnen die CSS-Klasse eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.</p>'),
unistr('<p>Diese Klasse wird standardm\00E4\00DFig auf allen &PRODUCT_NAME.-Seiten aufgenommen. Sie ist folgenderma\00DFen definiert <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873251520303394)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874872004303396)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Formatmaske ein, die f\00FCr diese Spalte angewendet werden soll.'),
unistr('    Sie k\00F6nnen die Formatmaske eingeben oder aus der vordefinierten Liste ausw\00E4hlen, entsprechend einer Beispieldarstellung der Anzeige dieser Formatmaske.</p>'),
unistr('    <p>Zahlenformatmasken d\00FCrfen nur f\00FCr Spalten angewendet werden, die Zahlen enthalten, und Datumsformatmasken nur f\00FCr Spalten, die Datumsangaben enthalten..'),
unistr('    Sonst wird ein Laufzeitfehler ausgel\00F6st, wenn ein Datensatz einen Wert enth\00E4lt, der mit der angegebenen Formatmaske nicht konvertiert werden kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894999559303412)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Formatmaske ein, die f\00FCr diese Spalte angewendet werden soll.'),
unistr('    Sie k\00F6nnen die Formatmaske eingeben oder aus der vordefinierten Liste ausw\00E4hlen, entsprechend einer Beispieldarstellung der Anzeige dieser Formatmaske.</p>'),
unistr('    <p>Zahlenformatmasken d\00FCrfen nur f\00FCr Spalten angewendet werden, die Zahlen enthalten, und Datumsformatmasken nur f\00FCr Spalten, die Datumsangaben enthalten..'),
unistr('    Sonst wird ein Laufzeitfehler ausgel\00F6st, wenn ein Datensatz einen Wert enth\00E4lt, der mit der angegebenen Formatmaske nicht konvertiert werden kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520870694303106)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Formatmaske ein, die f\00FCr diese Komponente angewendet werden soll.'),
unistr('    Sie k\00F6nnen die Formatmaske eingeben oder aus der Liste mit vordefinierten Formatmasken ausw\00E4hlen, entsprechend einer Beispieldarstellung dieser Formatmaske.</p>'),
unistr('    <p>Zahlenformatmasken d\00FCrfen nur f\00FCr Komponenten angewendet werden, die Zahlen enthalten, und Datumsformatmasken nur f\00FCr Komponenten, die Datumsangaben enthalten.'),
unistr('    Sonst wird ein Laufzeitfehler ausgel\00F6st, wenn eine Komponente einen Wert enth\00E4lt, der mit der angegebenen Formatmaske nicht konvertiert werden kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520772094303106)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatmaske'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521066991303106)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie eine Datumsformatmaske f\00FCr diese Komponente ein.'),
unistr('Sie k\00F6nnen die Formatmaske eingeben oder aus der Liste der vordefinierten Formatmasken ausw\00E4hlen, basierend auf einer Beispieldarstellung der Anzeige dieser Formatmaske.'),
unistr('Sie k\00F6nnen auch eine Ersetzungssyntax zur Referenzierung einer dynamischen Formatmaske auf einem Anwendungs- oder Seitenelement verwenden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520920580303106)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatmaske'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521267294303106)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie eine Zahlenformatmaske f\00FCr diese Komponente ein.'),
unistr('Sie k\00F6nnen die Formatmaske eingeben oder aus der Liste der vordefinierten Formatmasken ausw\00E4hlen, basierend auf einer Beispieldarstellung der Anzeige dieser Formatmaske.'),
unistr('Sie k\00F6nnen auch eine Ersetzungssyntax zur Referenzierung einer dynamischen Formatmaske auf einem Anwendungs- oder Seitenelement verwenden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521152666303106)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatmaske'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517562748303103)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob die automatische Vervollst\00E4ndigung f\00FCr diese Seite deaktiviert ist. Der Wert <strong>Ein</strong> wirkt sich nicht auf diese Seite aus. Der Wert <strong>Aus</strong> generiert die folgende HTML im FORM-Tag:'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>Hinweis: Verschiedene Browser haben m\00F6glicherweise unterschiedliche Regeln dazu, wann <code>autocomplete="off"</code> beachtet oder ignoriert wird. Denken Sie immer daran, wenn Sie diese Option auf <strong>Aus</strong> setzen, und testen Sie die E')
||'instellung in Ihren Zielbrowsern.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99019021320303519)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'de'
,p_message_text=>'Aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018911936303519)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'de'
,p_message_text=>'Ein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517450250303103)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Formular automatisch vervollst\00E4ndigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228933205302869)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, mit denen die Labels des Diagramms definiert werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228871433302869)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871881655303393)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die maximale Anzahl der generischen Berichtsspalten ein. ',
'Berichte mit generischen Spaltennamen werden nur zur Laufzeit geparst. Deshalb ist die Anzahl der Spalten beim Bearbeiten des Berichts nicht bekannt.</p>',
'<p> Die maximale Anzahl der Berichtsspalten muss der erwarteten Anzahl der Berichtsspalten entsprechen.',
unistr('Wenn die tats\00E4chliche Anzahl kleiner ist, wird der Bericht mit der tats\00E4chlichen Anzahl der Spalten wiedergegeben. '),
unistr('Wenn die tats\00E4chliche Anzahl gr\00F6\00DFer als die maximale Anzahl ist, wird zur Laufzeit eine Fehlermeldung angezeigt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871776748303393)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Generische Spaltenanzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658681725303213)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die globale Seite f\00FCr die aktuelle Benutzeroberfl\00E4che, sofern sie definiert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658582011303213)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Globale Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319524559303768)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892845961303410)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893156406303411)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519817765303105)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine spezifische Layoutspalte. Verwenden Sie <strong>Automatisch</strong>, um die n\00E4chste verf\00FCgbare Layoutspalte automatisch zu bestimmen, in der die Komponente angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519759372303105)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520695779303106)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche Attribute ein, die f\00FCr die Layoutspalte festgelegt werden. Dieser Wert ersetzt den Ersetzungsplatzhalter <code>#ATTRIBUTES#</code> im Layoutspaltentemplate.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520512286303106)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spaltenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219053112303678)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Auto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203660313303666)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Legen Sie fest, wie viele Layoutspalten diese Komponente belegt. Mit "Automatisch" k\00F6nnen Sie die verf\00FCgbaren Layoutspalten \00FCber alle Komponenten in der gleichen Zeile hinweg anordnen.</p>'),
'<dl>',
'  <dt>Auto</dt>',
unistr('    <dd>Karten haben eine anf\00E4ngliche Breite und werden automatisch auf eine neue Zeile ger\00FCckt, wenn sie nicht mehr auf den Bildschirm passen.</dd>'),
'  <dt>2, 3, 4, 5 Spalten</dt>',
unistr('    <dd>Karten werden so angeordnet, dass sie in die ausgew\00E4hlte Anzahl an Spalten pro Zeile passen. Das Layout kann die Spaltenzahlen auf Basis der Viewport-Breite reduzieren.</dd>'),
unistr('  <dt>Sie k\00F6nnen die Breite der Karten mit einer CSS-Variablen konfigurieren.</dt>'),
unistr('    <dd>Sie k\00F6nnen zum Beispiel das folgende Snippet hinzuf\00FCgen, um die Kartenbreite auf 320 px zu setzen: <pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203778236303666)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>'2 Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203857370303666)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'de'
,p_message_text=>'3 Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203905640303666)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'de'
,p_message_text=>'4 Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204091173303666)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'de'
,p_message_text=>'5 Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99203594243303666)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Rasterspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414135278303848)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die CSS-Klassen ein, die Sie f\00FCr die Layoutspalte anwenden m\00F6chten, die diese Region enth\00E4lt. Sie k\00F6nnen mehrere Klassen durch Leerzeichen getrennt hinzuf\00FCgen.</p>'),
unistr('        <p>Mit dieser Eigenschaft wird eine fein granulierte Kontrolle \00FCber Reaktionsf\00E4higkeit und Layout der Layoutspalte der Region bei \00C4nderung der Viewport-Gr\00F6\00DFe bereitgestellt.'),
unistr('        Bei Universal Theme-Anwendungen k\00F6nnen Sie eine Reihe von CSS-Modifikatoren verwenden, um die Seitenkomponenten zu erweitern. Weitere Informationen finden Sie im Abschnitt "Referenz" der Universal Theme-Beispielanwendung.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99414066418303848)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalten-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99319664505303769)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892998381303410)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893238834303411)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520287689303105)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, wie viele Layoutspalten diese Komponente belegen soll. Mit <strong>Automatisch</strong> werden die verf\00FCgbaren Layoutspalten in allen Komponenten in derselben Zeile ausgeglichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520181889303105)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spaltenanzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411079966303845)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Seiten-Templatestandard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410989260303845)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, wie viele Layoutspalten das Label belegt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410830287303845)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Labelspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520084252303105)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Komponente in der n\00E4chsten Spalte oder in derselben Spalte wie die vorherige Komponente angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519922310303105)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Neue Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519494661303105)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob diese Komponente in einem neuen Layout oder in demselben Layout wie die vorherige Komponente angezeigt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519343902303105)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Neues Layout starten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519621531303105)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Komponente in der n\00E4chsten Zeile nach der vorherigen Komponente angezeigt wird oder in derselben Zeile.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519590299303105)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Neue Zeile beginnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177724309303646)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die CSS-Klassen ein, die Sie f\00FCr die Layoutzeile anwenden m\00F6chten, die diese Region enth\00E4lt. Sie k\00F6nnen mehrere Klassen durch Leerzeichen getrennt hinzuf\00FCgen.</p>'),
unistr('        <p>Mit dieser Eigenschaft wird eine fein granulierte Kontrolle \00FCber Reaktionsf\00E4higkeit und Layout der Layoutzeile der Region bei \00C4nderung der Viewport-Gr\00F6\00DFe bereitgestellt.'),
unistr('        Bei Universal Theme-Anwendungen k\00F6nnen Sie eine Reihe von CSS-Modifikatoren verwenden, um die Seitenkomponenten zu erweitern. Weitere Informationen finden Sie im Abschnitt "Referenz" der Universal Theme-Beispielanwendung.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177689985303646)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilen-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520403694303106)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, wie viele Zeilen innerhalb der HTML-Tabelle diese Komponente belegt. Komponenten werden in HTML-Tabellen angeordnet. Dieses Attribut bestimmt den Wert, der f\00FCr das Attribut <em>ROWSPAN</em> in der Tabellenzelle f\00FCr diese Komponente verw')
||'endet werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98520300838303106)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilenanzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796975587303334)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen aus, der f\00FCr die Definition einer kurzen aussagekr\00E4ftigen benutzerdefinierten QuickInfo zu den Reihennamen in der Diagrammlegende verwendet werden soll. Bei einem Boxplot-Diagramm darf die Spalte nicht mit der ausgew\00E4hlten')
||unistr(' Wertspaltenzuordnung \00FCbereinstimmen. Wenn eine Spalte ausgew\00E4hlt wird, die mit der Wertspaltenzuordnung \00FCbereinstimmt, wird keine QuickInfo f\00FCr die Legende im Diagramm wiedergegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796895825303334)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Legenden-QuickInfo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797197967303334)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen aus, der f\00FCr die Definition einer kurzen aussagekr\00E4ftigen benutzerdefinierten QuickInfo zu den X-Achsenlabels des Diagramms verwendet werden soll. Bei einem Boxplot-Diagramm darf die Spalte nicht mit der ausgew\00E4hlten Werts')
||unistr('paltenzuordnung \00FCbereinstimmen. Wenn eine Spalte ausgew\00E4hlt wird, die mit der Wertspaltenzuordnung \00FCbereinstimmt, wird keine QuickInfo f\00FCr die Labels im Diagramm wiedergegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797039417303334)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label-QuickInfo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871695377303393)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie an, ob die Spaltendefinitionen aus der SQL-Abfrage abgeleitet werden sollen.',
'In diesem Fall muss &PRODUCT_NAME. die Abfrage parsen.',
unistr('Wenn die Abfrage jetzt nicht geparst werden soll, w\00E4hlen Sie generische Spaltennamen aus, die Definitionen f\00FCr Platzhalterspalten erzeugen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871523162303393)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Generische Spaltennamen verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606409536303172)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie HTML-Text ein, der oben in der Region (direkt vor dem <code>#BODY#</code>-Inhalt) angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515767137303102)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Text oder HTML-Code ein, der unmittelbar nach dem Seitenheader und vor dem Hauptinhalt angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515680932303102)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Headertext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879054080303399)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie \00DCberschriften f\00FCr Ihren Bericht definiert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057710523303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>unistr('Angepasste \00DCberschriften')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057851903303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Mit dieser Option k\00F6nnen Sie Ihre eigenen \00DCberschriften eingeben. Anf\00E4nglich werden Standardwerte f\00FCr die \00DCberschriften verwendet, basierend auf einer Abfrage der Spaltennamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057936712303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058041373303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellt \00DCberschriften basierend auf einer PL/SQL-Funktion, die eine durch Doppelpunkt begrenzte Namensliste zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058138750303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058225885303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Bericht wird ohne Berichts\00FCberschriften angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057357148303550)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'de'
,p_message_text=>'Spaltennamen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057411044303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Generiert \00DCberschriften basierend auf einer Abfrage der Spaltennamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057524561303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('Spaltennamen (gro\00DFe Anfangsbuchstaben)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057604199303551)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Generiert \00DCberschriften, die in die anf\00E4ngliche Schreibweise konvertiert werden, basierend auf einer Abfrage der Spaltennamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98878984850303399)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839635819303367)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die \00DCberschriftenausrichtung. Beachten Sie, dass Ihre Auswahl vom ausgew\00E4hlten Berichtstemplate unterst\00FCtzt werden muss.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043550657303539)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043452538303539)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043681033303539)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839588444303367)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058395481303551)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Gibt die \00DCberschriften f\00FCr einen Bericht basierend auf der DEPT-Tabelle an</dt>'),
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879257028303399)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine PL/SQL-Funktion ein, um eine Zeichenfolge mit Spalten\00FCberschriften zur\00FCckzugeben, die durch Doppelpunkte begrenzt werden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879166815303399)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750926786303298)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Verwenden Sie dieses Attribut, um Hilfetext f\00FCr das interaktive Grid einzugeben. Der eingegebene Hilfetext wird zusammen mit dem Standardhilfeinhalt unter der Hilfe zu dem Aktionsmen\00FC angezeigt.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751839936303298)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Hilfetext f\00FCr diese Seite ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893996341303411)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Hilfetext f\00FCr dieses Element ein. Der Hilfetext kann f\00FCr die Kontexthilfe auf Feldebene verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518586817303104)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit diesem Attribut k\00F6nnen Sie den Hilfetext f\00FCr die aktuelle Seite eingeben. Die Hilfe auf Seitenebene unterst\00FCtzt Shortcuts mit folgender Syntax:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>Hilfetext f\00FCr die Seite wird nicht standardm\00E4\00DFig angezeigt. Sie k\00F6nnen jedoch jederzeit ein Hilfesystem entwickeln, das Hilfetext ausgibt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518480832303104)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772907772303315)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit diesem Attribut k\00F6nnen Sie den Hilfetext f\00FCr die aktuelle Seite eingeben. Die Hilfe auf Seitenebene unterst\00FCtzt Shortcuts mit folgender Syntax:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>Hilfetext f\00FCr die Seite wird nicht standardm\00E4\00DFig angezeigt. Sie k\00F6nnen jedoch jederzeit ein Hilfesystem entwickeln, das Hilfetext ausgibt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772831181303315)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555189464303133)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180252500303648)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Regionstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792898421303331)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie das Aus- und Einblendverhalten, wenn auf ein Legendenelement geklickt wird.'),
unistr('        Beispiel: Wenn die Auswahl eines Legendenelements aufgehoben wird, werden die zugeh\00F6rigen Datenreihen in dem Diagramm ausgeblendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792907122303331)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916510156303430)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr(' F\00FCr das Diagramm ist kein Aus- und Einblendverhalten aktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793185368303331)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'de'
,p_message_text=>'Nicht erneut skalieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916744445303430)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr(' Die Diagrammachsen werden nicht neu skaliert. Dadurch \00E4ndert sich der Kontext f\00FCr den Benutzer nicht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793003041303331)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'de'
,p_message_text=>'Erneut skalieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916690888303430)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr(' Die Diagrammachsen werden neu skaliert, wenn die Mindest- und H\00F6chstwerte der sichtbaren Daten erh\00F6ht oder verringert werden. Dies eignet sich f\00FCr Datenreihen mit sehr unterschiedlichen Werten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792798650303331)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aus- und Einblendverhalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873755465303395)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie Zeichenfolgen an, die in einer Berichtspalte markiert werden sollen. ',
unistr('Verwenden Sie bei mehreren markierten W\00F6rtern eine durch Kommas getrennte Liste. '),
unistr('Anwendungs- oder Seitenelemente k\00F6nnen mit der <code>&amp;ITEM.</code>-Syntax referenziert werden. '),
unistr('Beispiel: Sie k\00F6nnen Zeichenfolgen markieren, die in ein Suchfeld eingegeben wurden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873613755303395)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('W\00F6rter markieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658079883303212)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Homepage der Anwendung f\00FCr die Benutzeroberfl\00E4che an. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657961297303212)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Home-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536479041303118)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>W\00E4hlen Sie die horizontale Ausrichtung f\00FCr diese Schaltfl\00E4che innerhalb der angegebenen Template-Position.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034600367303532)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034786444303532)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536378424303118)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Horizontale Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045531031303541)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\00C4ndert die Hintergrund- und Textfarben</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
unistr('  <dt>Verwendet \00DCberschrift 2</dt>'),
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
'  <dt>Verwendet eine dynamische Klasse aus der SQL-Abfrage</dt>',
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>#COLUMN_CLASS#</code> und <code>#EMPLOYEE_STATUS#</code> in diesem Beispiel sind Spalten, die in der Berichts-SQL-Abfrage ausgew\00E4hlt werden.</dd>'),
'  <dt>Zeigt ein Bild und eine QuickInfo an, wenn darauf gezeigt wird</dt>',
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842264557303369)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die in dieser Spalte angezeigt werden sollen. Verwenden Sie die <code>#COLUMN#</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842195231303369)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515326916303101)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie Text ein, um die <code>#HEAD#</code>-Ersetzungszeichenfolge im Header des Seiten-Templates zu ersetzen.',
unistr('Die hier eingegebenen Werte werden im Anschluss an das HTML-Tag <code>&lt;head&gt;</code> eingef\00FCgt. Verwenden Sie dieses Seitenattribut, um seitenspezifische Metatags hinzuzuf\00FCgen.'),
'</p>',
unistr('<p>Hinweis: JavaScript-Code oder CSS m\00FCssen den dedizierten JavaScript- und CSS-Attributen hinzugef\00FCgt werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515207729303101)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209180184303670)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die das BLOB f\00FCr die Symbolbildquelle zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209050112303670)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bildspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208906473303670)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Symbolbildquelle verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208873676303670)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbolspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557601110303135)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Klassen f\00FCr das Symbol ein, das Sie zum Identifizieren dieses Facets verwenden m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('            <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie die <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557707501303135)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Klassen f\00FCr das Symbol ein, das Sie zum Identifizieren dieses Facets verwenden m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('            <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie die <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557863955303135)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Klassen f\00FCr das Symbol ein, das Sie zum Identifizieren dieses Facets verwenden m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('            <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie die <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336528011303782)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Klassen f\00FCr das Symbol ein, das Sie zu der Komponente hinzuf\00FCgen m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie sie durch Leerzeichen trennen.</p>'),
unistr('        <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>'),
'        <p>Hinweis: Dieses Symbol wird innerhalb des Elements angezeigt, und nicht als Teil des Labels.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336487562303782)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Klassen f\00FCr das Symbol ein, das Sie zu der Komponente hinzuf\00FCgen m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie sie durch Leerzeichen trennen.</p>'),
unistr('        <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>'),
'        <p>Hinweis: Dieses Symbol wird innerhalb des Elements angezeigt, und nicht als Teil des Labels.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558089009303135)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen f\00FCr das Symbol ein, das Sie zum Identifizieren dieses Filters verwenden m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('            <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie die <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558936262303136)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen f\00FCr das Symbol ein, das Sie zum Identifizieren dieses Filters verwenden m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('            <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie die <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559319435303136)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen f\00FCr das Symbol ein, das Sie zum Identifizieren dieses Filters verwenden m\00F6chten. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('            <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie die <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195624468303660)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Nach rechts zeigendes Chevron anzeigen</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195584135303660)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen f\00FCr das Symbol ein, das Sie zu der Komponente hinzuf\00FCgen m\00F6chte. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('        <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195452695303660)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210672944303672)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Dieser Text beschreibt das Symbol und kann f\00FCr QuickInfos und alternativen Text f\00FCr Bilder verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210579710303672)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbolbeschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209383512303671)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die URL f\00FCr die Symbolbildquelle ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209292169303671)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bild-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209896563303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Bestimmt die Position des Symbols im Kartenheader.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210336440303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210408157303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'de'
,p_message_text=>'Richtet das Symbol an der Endposition (in der Regel rechts) des Headers aus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210158722303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210278307303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'de'
,p_message_text=>'Richtet das Symbol an der Anfangsposition (in der Regel links) des Headers aus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209976140303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99210045186303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt das Symbol oben im Header an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99209798224303671)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbolposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219115857303678)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Kein Symbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208289479303670)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Symbolquelle f\00FCr das Symbol aus, das im Header der Kartenkomponente angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208753551303670)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'de'
,p_message_text=>'Bild-BLOB-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208523209303670)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'de'
,p_message_text=>'Symbolklassenspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208392234303670)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'de'
,p_message_text=>'Initialen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208489452303670)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'de'
,p_message_text=>'Symbolklasse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208642765303670)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'de'
,p_message_text=>'Bild-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208142451303670)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbolquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739845682303288)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739727828303288)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die benutzerdefinierte Spalten-HTML f\00FCr die Symbolansicht ein.</p>'),
unistr('<p>Die folgenden Ersetzungszeichenfolgen sind verf\00FCgbar:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - Ersetzungszeichenfolgen f\00FCr Spaltennamen.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - Ersetzungszeichenfolgen f\00FCr Spaltenlabels.</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - Die Datensatz-ID f\00FCr die Zeile.</li>'),
'<li><code>&APEX$ROW_INDEX.</code> - Die Folgenummer der Datensatzanzeige.</li>',
'<li><code>&APEX$ROW_URL.</code> - Die Referenz zum angegebenen Linkziel.</li>',
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - Der Datensatzstatus, z.B. <code>is-inserted</code> oder <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739671332303288)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniertes Symbol'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048986448303544)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850767568303376)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Spaltenlink f\00FCr die Symbolansicht an. Verwenden Sie die <code>#COLUMN_NAME#</code>-Ersetzungszeichenfolge nach Bedarf f\00FCr Spaltennamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850623249303376)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierter Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750771016303298)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Symbolansicht aktiviert ist. Durch Auswahl von <strong>Ein</strong> wird das Symbol "Symbole anzeigen" zur Suchleiste f\00FCr interaktive Berichte oder zur Schaltfl\00E4che "Ansicht" des interaktiven Grids hinzugef\00FCgt. Damit k\00F6nnen Benut')
||'zer auf diese Ansicht zugreifen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849189136303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Symbolansicht aktiviert ist. Durch Auswahl von <strong>Ein</strong> wird das Symbol "Symbole anzeigen" zur Suchleiste f\00FCr interaktive Berichte oder zur Schaltfl\00E4che "Ansicht" des interaktiven Grids hinzugef\00FCgt. Damit k\00F6nnen Benut')
||'zer auf diese Ansicht zugreifen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849075327303374)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850358910303376)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den HTML ALT-Text f\00FCr das Bild ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850239643303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML ALT-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850597165303376)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das HTML-TITLE-Tag f\00FCr das Bild ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850442190303376)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML TITLE-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741002285303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Symbolbildattribute f\00FCr das HTML-IMG-Tag an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740936213303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbolattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740420428303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die interaktive Grid-Spalte, die das BLOB f\00FCr die Quelle des Symbolbildes zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740384510303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bildspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740813637303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die interaktive Grid-Spalte, die die CSS-Klassen f\00FCr die Quelle des Symbolbildes zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740786464303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740051100303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltentyp, der die Quelle f\00FCr das Symbolbild enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740247540303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'de'
,p_message_text=>'Symbol-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740184948303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'de'
,p_message_text=>'Bild in URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739939187303288)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symboltyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740696541303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die interaktive Grid-Spalte, die die URL f\00FCr die Quelle des Symbolbildes zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98740517261303289)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850150823303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Bildattribute f\00FCr das HTML IMG-Tag an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98850053239303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bildattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048743981303543)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Pr\00FCft die Spalte <code>IMAGE</code></dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849731179303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Berichtsspalte, die die Bildquelle zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849616869303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bildquellenspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048859579303544)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Pr\00FCft die Spalte <code>ENAME</code></dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849941904303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Berichtsspalte, die das Bildlabel zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849877763303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Labelspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723106668303274)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Spalte <code>ENAME</code> pr\00FCfen</dt>'),
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723007195303274)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Berichtsspalte, die das Bildlabel zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722959883303274)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Labelspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741476811303290)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie HTML-Attribute ein, die mit der Anzeige jedes <strong>Linkziels</strong> verkn\00FCpft sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741389920303290)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Linkattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99048656634303543)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Pr\00FCft die Spalte <code>LINK</code></dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849543384303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Berichtsspalte, die das Linkziel des Symbols zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98849432649303375)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Link-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276698982303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276995865303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276855173303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276782414303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277079595303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276576565303731)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277831246303733)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen Java-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen.</p>'),
unistr('<p>Die SQL-Abfrage muss nur eine Spalte zur\00FCckgeben. Wenn die Abfrage mehrere Spalten zur\00FCckgibt, wird nur die erste Spalte in der Filtersuche verwendet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277738920303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Java-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277697108303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Abteilungsnamen anzeigen, Abteilungsnummer festlegen</dt>',
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277503779303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen JavaScript-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen.</p>'),
unistr('<p>Die SQL-Abfrage muss nur eine Spalte zur\00FCckgeben. Wenn die Abfrage mehrere Spalten zur\00FCckgibt, wird nur die erste Spalte in der Filtersuche verwendet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277475192303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277393434303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>So wird der Abteilungsname zur\00FCckgegeben:</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277245620303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen PL/SQL-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen.</p>'),
unistr('<p>Die SQL-Abfrage muss nur eine Spalte zur\00FCckgeben. Wenn die Abfrage mehrere Spalten zur\00FCckgibt, wird nur die erste Spalte in der Filtersuche verwendet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277150140303732)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278018440303733)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen Python-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen.</p>'),
unistr('<p>Die SQL-Abfrage muss nur eine Spalte zur\00FCckgeben. Wenn die Abfrage mehrere Spalten zur\00FCckgibt, wird nur die erste Spalte in der Filtersuche verwendet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99277912968303733)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Python-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746342295303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>'<pre>Cow,Dog,Cat,Lion</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746219820303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine durch Komma getrennte Werteliste f\00FCr diese statische Liste ein.</p>'),
'        <p>Hinweis - Die statischen Werte werden immer in derselben Reihenfolge angezeigt, in der sie angegeben werden, und nicht alphabetisch.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746136413303293)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742010544303290)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Gruppe f\00FCr diese Spalte. Gruppen werden zur Verkn\00FCpfung von Spalten in dem Grid und der Single Row-Ansicht verwendet.</p>'),
unistr('        <p>Hinweis - Gruppen werden hinzugef\00FCgt, indem der Ordner "Attribute" in der Rendering-Baumstruktur eingeblendet wird und mit der rechten Maustaste auf "Spaltengruppen" geklickt wird, um eine neue Gruppe zu erstellen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741953101303290)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746580653303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Quelltyp, auf dem der Wert dieser Spalte basiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746634699303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746747427303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Legen Sie diesen Wert auf den Spaltenwert fest, der in <em>Datenbankspalte</em> eingegeben wurde und aus der SQL-Abfrage der Regionsquelle abgerufen wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747095239303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747151317303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Spaltenwert wird nicht aus einer Quelle abgerufen. Beispiel: Die Spalten APEX$ROW_SELECTOR und APEX$ROW_ACTION haben keine Quelle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746890013303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746947322303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie diesen auf den Wert fest, der von dem eingegebenen <em>SQL-Ausdruck</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98746431575303294)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739175045303288)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Pr\00FCfen Sie, welche Downloadformate Benutzer verwenden k\00F6nnen, um die aktuell angezeigten Spalten herunterzuladen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739247703303288)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'de'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739353199303288)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'de'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897354950303414)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'de'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182660594302833)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'de'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98739009510303288)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741226403303289)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf das Linkziel, um einen modalen Dialog aufzurufen. Sie k\00F6nnen ein benutzerdefiniertes Ziel eingeben, das aufgerufen werden soll, wenn auf das Symbol geklickt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741152577303289)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Linkziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737325480303286)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Seitenumbruchstyp f\00FCr diesen Bericht. H\00E4ufig werden nicht alle Berichtszeilen in dem Bericht angezeigt.'),
unistr('		Um zus\00E4tzliche Zeilen anzuzeigen, kann der Endbenutzer den angegebenen Seitenumbruch verwenden.</p>'),
unistr('		<p>Der Seitenumbruch stellt dem Endbenutzer Informationen \00FCber die angezeigte Anzahl von Zeilen bereit, und gibt die aktuelle Position innerhalb der Ergebnismenge an.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737589248303286)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'de'
,p_message_text=>'Scrollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865954039303388)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Urspr\00FCnglich werden  gen\00FCgend Zeilen angezeigt, um die H\00F6he des interaktiven Grids auszuf\00FCllen.'),
unistr('        Wenn der Endbenutzer scrollt, werden weitere Zeilen angezeigt, sodass mehr Daten vom Server abgerufen werden, als ben\00F6tigt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737418531303286)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865863283303388)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Die ersten Zeilen werden basierend auf der Zahl angezeigt, die in <em>Zeilen pro Seite</em> angegeben wird.',
unistr('        Wenn zus\00E4tzliche Zeilen vorhanden sind, werden Steuerelemente zu dem Berichtsfooter hinzugef\00FCgt, damit Endbenutzer zwischen Rowsets vor- und zur\00FCcknavigieren k\00F6nnen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737218064303286)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407401490303842)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Interaktive Grid-Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200859541303664)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Aliasnamen f\00FCr diesen gespeicherten Bericht ein. Mit diesem Aliasnamen k\00F6nnen Sie einen aussagekr\00E4ftigeren URL-Link f\00FCr diesen spezifischen gespeicherten Bericht definieren. Mit diesem Link kann direkt eine Verbindung zu dieser Anwend')
||'ung von einer anderen Stelle hergestellt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199844626303663)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aliasname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200932476303664)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigen Sie die gespeicherte Berichtskategorie an, die bestimmt, wo dieser Bericht innerhalb der Auswahlliste "Berichte" angezeigt wird. Dieses Attribut kann nur angezeigt, jedoch nicht aktualisiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200099543303663)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'de'
,p_message_text=>'Alternative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200577138303664)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Entwicklern gespeicherte, nachfolgende Berichtslayouts, die Endbenutzer ausw\00E4hlen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199919697303663)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'de'
,p_message_text=>'Primary'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200451506303664)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Entwicklern gespeicherter Bericht, der standardm\00E4\00DFig angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200265596303663)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'de'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200778336303664)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Endbenutzern gespeicherte Berichtslayouts, die nur der Endbenutzer ausw\00E4hlen kann, der sie gespeichert hat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200158124303663)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99200601947303664)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Endbenutzern gespeicherte Berichtslayouts, die alle anderen Endbenutzer ausw\00E4hlen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199731219303663)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sichtbarkeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742275032303290)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wo die Gruppe zur Anzeige dieser Spalte verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742320524303290)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'de'
,p_message_text=>'Beides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742420088303290)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Gruppe wird sowohl in der Berichts\00FCberschrift als auch in der Single Row-Ansicht angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742721741303291)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742820328303291)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Gruppe wird nur in der Berichts\00FCberschrift angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742562470303291)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'de'
,p_message_text=>'Single Row-Ansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742641925303291)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Gruppe wird nur in der Single Row-Ansicht angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98742109779303290)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppe verwenden f\00FCr')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605834824303172)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Bildtagattribute ein, die in die Bild-HTML aufgenommen werden sollen. Diese Option kann f\00FCr Attribute wie H\00F6he, Breite oder Bild-ALT-Text (wenn das Bild nicht dekorativ ist) verwendet werden.</p>'),
unistr('<p>Hinweis: Wenn kein ALT in den Bildtagattributen definiert wird, zeigt &PRODUCT_NAME. das Bild standardm\00E4\00DFig als dekoratives Bild an (z.B. mit einem leeren ALT-Tag).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605725187303172)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bildtagattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874593678303395)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob diese Spalte einbezogen wird, wenn der Bericht in CSV exportiert oder gedruckt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874482979303395)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bei Export/Druck einbeziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386480179303823)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob am Anfang der Werteliste eine NULL-Option angezeigt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386348802303823)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'NULL-Option einbeziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726911343303277)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Pseudospalte ROWID ausgew\00E4hlt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726870873303277)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'ROWID-Spalte einbeziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844368001303371)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Eine Suchleiste wird \00FCber dem Bericht angezeigt. Wenn Sie die Suchleiste aufnehmen, k\00F6nnen Sie auch vollst\00E4ndig anpassen, welche Funktionen angezeigt werden sollen.</p>'),
'Die Suchleiste kann folgende Komponenten enthalten:',
'<dl>',
'  <dt>Suchfeld</dt>',
unistr('    <dd>Zeigt ein Textfeld in der Suchleiste an, in dem die Suchkriterien eingegeben werden k\00F6nnen.</dd>'),
'  <dt>Finder-Dropdown-Liste</dt>',
unistr('    <dd>In dem <em>Suchfeld</em> eingebettet wird eine Dropdown-Liste der angezeigten Spalten angezeigt. Wenn eine Spalte ausgew\00E4hlt wird, wird die Suche nur f\00FCr die Werte in der ausgew\00E4hlten Spalte ausgef\00FChrt.</dd>'),
unistr('  <dt>Auswahlliste f\00FCr Berichte</dt>'),
unistr('    <dd>Zeigt eine Liste aller verf\00FCgbaren Berichte f\00FCr den Benutzer an, einschlie\00DFlich prim\00E4rer, alternativer, \00F6ffentlicher und privater Berichte. Diese Liste wird nur angezeigt, wenn der Benutzer auf einen Bericht, mit Ausnahme des Prim\00E4rberichts, ')
||'zugreifen kann.</dd>',
unistr('  <dt>Selektor f\00FCr Zeilen pro Seite</dt>'),
'    <dd>Zeigt eine Auswahlliste zur Auswahl der Anzahl von Zeilen an, die pro Seite angezeigt werden sollen.</dd>',
unistr('  <dt>Men\00FC "Aktionen"</dt>'),
unistr('    <dd>Zeigt die Schaltfl\00E4che f\00FCr das Men\00FC "Aktionen" an, das im Allgemeinen ein umfassendes Set von Optionen enth\00E4lt. Mit diesen Optionen kann der Endbenutzer den Bericht basierend auf den Funktionen anpassen, die Sie zur Verf\00FCgung stellen.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844281726303371)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Suchleiste aufnehmen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515102680303101)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. erfordert im Allgemeinen spezifische JavaScript- und CSS-Dateien.',
unistr('Bei einigen Anwendungen, wie Apps, m\00F6chten Sie m\00F6glicherweise die Aufnahme dieser Dateien auf der Seite unterdr\00FCcken.</p>'),
unistr('<p>Um die Standard-&PRODUCT_NAME.- und JavaScript-Dateien aufzunehmen, w\00E4hlen Sie <strong>Ein</strong> aus. Bei Auswahl von <strong>Aus</strong> wird die Aufnahme dieser Dateien im HTML-Header unterdr\00FCckt.</p>'),
unistr('<p>Die Unterdr\00FCckung der Aufnahme dieser Dateien kann sich negativ auf eine Anwendung auswirken und zu deren Ausfall f\00FChren.'),
'Deshalb wird die Deaktivierung dieses Attributs nur erfahrenen Entwicklern empfohlen.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515086795303101)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Standard-JavaScript und CSS einbeziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136841028303614)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die die anf\00E4ngliche Kartenposition als GeoJSON-Punktobjekt enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136700693303614)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'GeoJSON-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136661803303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die SDO_GEOMETRY-Spalte aus, die die anf\00E4ngliche Kartenposition als Punktobjekt enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136579796303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Geometriespalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135838459303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt den Spaltentyp an, der f\00FCr die anf\00E4ngliche Kartenposition verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136183115303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'de'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136256654303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'de'
,p_message_text=>'GeoJSON, als VARCHAR2- oder CLOB-Spaltentypen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136362465303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngen-/Breitengrad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136447195303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngen- und Breitengrad als zwei NUMBER-Spalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135983809303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'de'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136068381303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'de'
,p_message_text=>'Oracle-Typ SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135730321303613)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Geometriespalten-Datentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134738985303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Gibt an, ob die Karte an der aktuellen Position vom Browser zentriert werden soll. Wenn die Option aktiviert ist und der Browser auf die aktuelle Position zugreifen kann, hat diese Position Vorrang vor der anf\00E4nglichen Position, die gem\00E4\00DF der Konf')
||unistr('iguration oben mit "Statische Werte", "SQL-Abfrage" oder "Basierend auf r\00E4umlichen Ergebnissen" festgelegt wurde.</p><p>Dies gilt nur f\00FCr das Laden der ersten Seite innerhalb einer APEX-Session. Wird die Kartenseite w\00E4hrend der APEX-Session erneut be')
||'sucht, wird die Karte an der letzten Position zentriert.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134694297303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position von Browser abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137266484303614)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die den Breitengrad der anf\00E4nglichen Kartenposition enth\00E4lt. Der zur\00FCckgegebene Wert muss zwischen -90 und 90 liegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137180229303614)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4ngliche Breitengradspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135417300303613)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Breitengrad der anf\00E4nglichen Kartenposition an. Verwenden Sie Werte zwischen -90 (S\00FCd) und 90 (Nord) sowie "." als Dezimalzeichen. Beispiel: <strong>45.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135329734303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Breitengrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137005288303614)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die den L\00E4ngengrad der anf\00E4nglichen Kartenposition enth\00E4lt. Der zur\00FCckgegebene Wert muss zwischen -180 und 180 liegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99136923822303614)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4ngliche L\00E4ngengradspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135204415303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den L\00E4ngengrad der anf\00E4nglichen Kartenposition an. Verwenden Sie Werte zwischen -180 (West) und 180 (Ost) sowie "." als Dezimalzeichen. Beispiel: <strong>100.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135193564303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngengrad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135084359303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Abfrage, die NUMBER-Spalten zur Bestimmung der anf\00E4nglichen Kartenposition und des Zoomfaktors zur\00FCckgibt:</p>'),
'<pre>',
'select -133.5 longitude,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>Abfrage, die eine SDO_GEOMETRY-Spalte zur Bestimmung der anf\00E4nglichen Kartenposition und eine NUMBER-Spalte f\00FCr den Zoomfaktor zur\00FCckgibt.</p>'),
'<pre>',
'select sdo_geometry( 2001,                                 -- zweidimensionaler Punkt',
unistr('                     4326,                                 -- L\00E4ngengrad/Breitengrad (WGS84)'),
'                     sdo_point_type( -133.5, 35.2, null ), -- konkrete Koordinaten',
unistr('                     null,                                 -- nicht f\00FCr Punkte verwendet'),
unistr('                     null                                  -- nicht f\00FCr Punkte verwendet'),
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134921095303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Abfrage zur Bestimmung der anf\00E4nglichen Kartenposition und des Zoomfaktors ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134885320303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133998751303611)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, wie die anf\00E4ngliche Kartenposition und der Zoomfaktor f\00FCr eine neue APEX-Session oder nach einem Vorgang vom Typ <strong>L\00F6schen</strong> oder <strong>Zur\00FCcksetzen</strong> bestimmt werden. Innerhalb einer APEX-Session speichert die Kar')
||unistr('tenregion die aktuelle Position und den Zoomfaktor \00FCber Seitenanforderungen hinweg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134466191303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Basierend auf r\00E4umlichen Ergebnissen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134586433303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Karte wird so positioniert, dass Abfrageergebnisse des Layers sichtbar sind. <em>Hinweis: Diese Option wird nicht unterst\00FCtzt, wenn GeoJSON als Geometriespaltentyp des Layers ausgew\00E4hlt wurde</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134286266303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134385546303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage an, die Werte f\00FCr die anf\00E4ngliche Kartenposition zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134013073303611)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99134195251303612)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie statische Werte f\00FCr die anf\00E4ngliche Kartenposition an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133819306303611)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137401159303614)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die den anf\00E4nglichen Zoomfaktor enth\00E4lt. Der zur\00FCckgegebene Wert sollte zwischen 1 und 18 liegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137300717303614)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4ngliche Zoomfaktorspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135680833303613)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den anf\00E4nglichen Zoomfaktor an. Verwenden Sie ganzzahlige Werte zwischen 1 und 18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99135537320303613)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zoomfaktor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023336809303523)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Legt die CSS-Klasse <code>display_only</code> auf Fettschrift fest</dt>',
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98510045286303097)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den CSS-Code ein, der auf dieser Seite verwendet werden soll. ',
unistr('Wenn dasselbe CSS auf mehreren Seiten verwendet wird, k\00F6nnen Sie den Code in einer externen Datei ablegen, um Duplizierungen zu vermeiden und das Browser-Caching von statischen Dateien zu nutzen.</p>'),
'<p>Der hier eingegebene Code ersetzt die Ersetzungszeichenfolge <code>#PAGE_CSS#</code> im Seitentemplate.</p>',
unistr('<p>Hinweis: Sie m\00FCssen keine \00F6ffnenden oder schlie\00DFenden <code>style</code>-Tags einf\00FCgen. F\00FCgen Sie einfach den CSS-Code ein.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509915725303097)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Inline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518364371303104)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Fehlermeldung ein, die angezeigt wird, wenn auf dieser Seite ein Fehler auftritt. Die Fehlermeldung wird im Seitentemplate f\00FCr <code>#NOTIFICATION_MESSAGE#</code> eingesetzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98518215055303104)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Inline-Fehler (Benachrichtigungstext)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336369982303782)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Inline-Hilfetext f\00FCr dieses Element an. Der Hilfetext wird unmittelbar mit dem Element angezeigt und kann als kontextbezogener Hilfetext auf Feldebene verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336249064303782)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Inline-Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601840805303169)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, wohin &PRODUCT_NAME. umleitet, wenn die Session nicht erfolgreich ist.'),
unistr('Dies geschieht, wenn die <strong>Sentry-Funktion</strong> oder die <strong>Pr\00FCfungsfunktion</strong> FALSE bei normalen Seitenanforderungen zur\00FCckgibt, jedoch nicht bei Ajax-Anforderungen.</p>'),
'<p>Hinweis: Bei Verwendung des Authentifizierungsschematyps <strong>''Benutzerdefiniert''</strong> kann auch das Attribut <strong>''Sentry-Funktion''</strong> im Authentifizierungsschema verwendet werden.',
'Bei Plug-in-Authentifizierungsschematypen wird dies von dem Plug-in-Entwickler in dem Callback <strong>''Session-Sentry-Funktionsname''</strong> definiert.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036331091303533)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'de'
,p_message_text=>'Integrierte Anmeldeseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036492554303533)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu der URL vor, die in <code>wwv_flow_custom_auth_std.login_page</code> definiert ist, die von &PRODUCT_NAME. bereitgestellt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036155972303533)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'de'
,p_message_text=>'Anmeldeseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036285017303533)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu der Anmelde-URL vor, die in den Anwendungsattributen definiert ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036585741303534)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'de'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036691391303534)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu der von Ihnen eingegebenen URL ein, wie <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601777032303169)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Sessionumleitung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602013779303169)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine URL an, zu der &PRODUCT_NAME. eine Umleitung vornehmen soll, wenn die Session Sentry-Funktion FALSE zur\00FCckgibt. Dabei w\00FCrde es sich im Allgemeinen um eine URL zu einer Anmeldeseite oder einem Single Sign-On-Portal handeln. Beispiel: f?')
||'p=&amp;APP_ID.:101:&amp;SESSION'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601902464303169)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Session-URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843094595303370)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den entsprechenden Spaltenanzeigetyp, um zu definieren, wie Spaltenwerte angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043046877303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'de'
,p_message_text=>'BLOB herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227352150303685)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Link zum Herunterladen der Datei an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043356230303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendete Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227655405303685)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte nicht an, ist jedoch referenzierbar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042981508303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'de'
,p_message_text=>'Bild anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227202427303685)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Bild an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042806986303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'de'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227129182303684)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Link an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043102660303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'de'
,p_message_text=>'Prozentdiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227466047303685)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Prozentdiagramm an. Der abgerufene Wert muss zwischen 0 und 100 liegen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042644474303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'de'
,p_message_text=>'Nur Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226975818303684)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt den Spaltenwert an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042739256303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'de'
,p_message_text=>'Nur Text (basierend auf Werteliste)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227098804303684)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt den Wert an, der aus der angegebenen Werteliste zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299418078303750)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299547355303750)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Rendert die Spalte mit HTML oder Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99043233661303539)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'de'
,p_message_text=>'HTML entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227586799303685)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt den Spaltenwert an, nachdem HTML-Tags entfernt und Sonderzeichen maskiert wurden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842900717303370)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927237189303439)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Zur R\00FCckgabe des Abteilungsnamens:</dt>'),
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861388650303384)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine SQL-Abfrage ein, die eine Spalte zur\00FCckgeben muss. Wenn die Abfrage mehrere Spalten zur\00FCckgibt, wird nur die erste Spalte in der Werteliste verwendet.</p>'),
'<p>Die Eingabe einer SQL-Abfrage kann die Performance in einigen Berichten verbessern oder kann die angezeigten Werte begrenzen.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861217357303384)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980756216303488)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine definierte benannte Werteliste. Der Spaltenfilter verwendet nur die erste Spalte der dynamischen Wertelistenabfrage oder den Anzeigewert der statischen Werteliste, um die Berichtsdaten zu filtern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980609555303488)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benannte Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841869618303369)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, wie die Filter abgeleitet werden sollen, die in der Dropdown-Liste der Berichtsspalte angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044815132303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>unistr('Benannte Werteliste zum Filtern der exakten \00DCbereinstimmung verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044926078303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie die Werteliste von der benannten Werteliste ab, um einen Equal-Filter zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045094185303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>'Benannte Werteliste zum Filtern des Worts verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045163802303541)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie die Werteliste von der benannten Werteliste ab, um einen Contains-Filter zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044602317303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'de'
,p_message_text=>'Definierte Werteliste zum Filtern des Worts verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044766453303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie die Werteliste von einer definierten Wertelisten-SQL-Abfrage ab, um einen Contains-Filter zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044244625303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'de'
,p_message_text=>'Standard basierend auf Spaltentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044356389303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'de'
,p_message_text=>'STRING- und NUMBER-Spalten leiten die Werteliste aus eindeutigen Spaltenwerten ab. DATE-Spalten leiten die Werteliste aus vordefinierten Datumsbereichen ab.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044036084303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044196288303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diesen Bericht ist kein Spaltenfilter bereitgestellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044417429303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'de'
,p_message_text=>unistr('Definierte Werteliste zum Filtern der exakten \00DCbereinstimmung verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99044544023303540)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Leiten Sie die Werteliste von einer definierten Wertelisten-SQL-Abfrage ab, um einen Equal-\00DCbereinstimmungsfilter zu erstellen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841720258303369)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842876359303369)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Gruppe f\00FCr diese Spalte. Mit Gruppen k\00F6nnen Spalten in logischen Gruppen in der Single Row-Ansicht angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842794531303369)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846738196303373)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den Linkspaltentyp f\00FCr diesen Bericht.'),
unistr('Wenn Sie die Linkspalte w\00E4hlen, wird sie immer als erste Spalte in dem Bericht angezeigt und kann nicht vom Benutzer ausgeblendet werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047005293303542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'de'
,p_message_text=>'Link zu benutzerdefiniertem Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047121840303542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer wird zu einer anderen Seite geleitet, je nach Ziel-URL, die Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047209383303542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>unistr('Linkspalte ausschlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047334586303542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Linkspalte wird nicht angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046813925303542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>'Link zu Single Row-Ansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046940029303542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer wird zu einer Seite geleitet, die die Spaltenwerte f\00FCr die angegebene Zeile enth\00E4lt. Verschiedene Berichts- und Spaltenattribute bestimmen, was und wie Spalten angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98846689216303373)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Link-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893352497303411)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844510099303371)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Seitennummerierungstyp f\00FCr diesen Bericht. Oft wird nur eine bestimmte Anzahl von Berichtszeilen auf einer Seite angezeigt. '),
unistr('Um weitere Zeilen einzubeziehen, muss der Anwendungsendbenutzer zur n\00E4chsten Seite des Berichts navigieren.</p>'),
'<p>Die Seitennummerierung liefert dem Benutzer Informationen zur Anzahl der Zeilen und zur aktuellen Position innerhalb der Ergebnismenge.</p>',
unistr('<p>Die Seitennummerierung kann \00FCber oder unter dem Bericht angezeigt werden (oder an beiden Stellen). Sie l\00E4sst sich auch links oder rechts positionieren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045888809303541)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche X bis Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045742565303541)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenbereiche X bis Y von Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844495704303371)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859066699303383)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Aliasnamen f\00FCr diesen gespeicherten Bericht ein. Mit diesem Aliasnamen k\00F6nnen Sie einen aussagekr\00E4ftigeren URL-Link f\00FCr diesen spezifischen gespeicherten Bericht definieren. Mit diesem Link kann direkt eine Verbindung zu dieser Anwend')
||'ung von einer anderen Stelle hergestellt werden.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858925505303382)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aliasname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859462014303383)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigen Sie die gespeicherte Berichtskategorie an, die bestimmt, wo dieser Bericht innerhalb der Auswahlliste "Berichte" angezeigt wird. Dieses Attribut kann nur angezeigt, jedoch nicht aktualisiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049486589303544)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'de'
,p_message_text=>'Alternativer Standardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227814884303685)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Entwicklern gespeicherte, nachfolgende Berichtslayouts, die Endbenutzer ausw\00E4hlen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049305997303544)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rer Standardwert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227727537303685)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Entwicklern gespeicherter Bericht, der standardm\00E4\00DFig angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049632050303544)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'de'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228056496303685)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Endbenutzern gespeicherte Berichtslayouts, die nur der Endbenutzer ausw\00E4hlen kann, der sie gespeichert hat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049513773303544)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99227994426303685)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Von Endbenutzern gespeicherte Berichtslayouts, die alle anderen Endbenutzer ausw\00E4hlen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859349810303383)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sichtbarkeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693347510303248)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer diese Formularregion bearbeiten k\00F6nnen.</p>'),
'        <p>Hinweis - Wenn die Formularregion editierbar gemacht wird, wird automatisch ein Prozess zur Verarbeitung der Zeile erstellt.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734281985303283)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer dieses interaktive Grid bearbeiten k\00F6nnen.</p>'),
'        <p>Hinweis - Wenn das interaktive Grid editierbar gemacht wird, wird automatisch ein Prozess zur Verarbeitung der Zeilen erstellt.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734104183303283)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332196797303779)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ist globale Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747910265303295)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Spalte einer der Prim\00E4rschl\00FCsselwerte f\00FCr die zugrunde liegenden Tabellen ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747877422303295)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschl\00FCssel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747756734303295)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob die Spalte aus DML-Vorg\00E4ngen ausgeschlossen werden soll.</p>'),
unistr('        <p>Wenn dieser Wert auf <strong>Ein</strong> gesetzt ist, verwendet &PRODUCT_NAME. die Spalte nicht, wenn "Interaktives Grid - Automatische Zeilenverarbeitung (DML)" ausgef\00FChrt wird.'),
unistr('        Beispiel: Sie m\00FCssen Spalten ausschlie\00DFen, deren Definitionen Verkettungen, Inner Selects, Funktionsaufrufe oder eine Spalte in einer aktualisierbaren View enthalten, die auf einem Ausdruck basiert.</p>'),
unistr('        <p>F\00FCr alle Spalten, die in INSERT- oder UPDATE-Anweisungen einbezogen werden m\00FCssen, muss diese Option auf <strong>Aus</strong> gesetzt werden.</p>'),
'        <p>Hinweis: Spalten vom Typ <em>Nur anzeigen</em> werden <u>ebenfalls</u> in die automatische Zeilenverarbeitung einbezogen, es sei denn, diese Option ist auf <strong>Ein</strong> gesetzt.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747645324303295)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nur Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828782934303359)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob der Parameter nur einmal mit einem statischen Wert festgelegt oder auf Komponentenebene au\00DFer Kraft gesetzt werden kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828620736303359)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180494158303648)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, warum diese Spalte angezeigt oder ausgeblendet ist. Selbst wenn sie ausgeblendet sind, k\00F6nnen Spalten immer mit Ersetzungssyntax <code>&amp;COLUMN_NAME.</code> referenziert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99180356797303648)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720801906303272)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen aus, der f\00FCr die Definition des hohen Wertes in diesem Diagramm verwendet werden soll. Wenn keine Spalte ausgew\00E4hlt ist, basiert der h\00F6chste Wert im Boxplot-Diagramm auf dem Dataset. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720627492303272)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hoch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720706633303272)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen aus, der f\00FCr die Definition des niedrigen Wertes in diesem Diagramm verwendet werden soll. Wenn keine Spalte ausgew\00E4hlt ist, basiert der niedrigste Wert im Boxplot-Diagramm auf dem Dataset. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720531549303272)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Niedrig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795756724303333)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des Schlusswertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795657950303333)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795376712303333)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des H\00F6chstwertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795231385303333)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hoch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797341122303334)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen zur Definition der X-Achsenlabels in dem Diagramm. Bei einem Aktiendiagramm muss die Spalte den Datentyp "Datum/Zeittempel" aufweisen, um die Aktieninformationen auf einer Zeitachse darzustellen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797212599303334)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626500979303188)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802741306303339)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Geben Sie eine CSS-Stilzeichenfolge ein, die den Stil der Labels in diesem Diagramm definiert.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802691580303339)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826985346303357)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn bei Bereichsdatenreihen ein Array mit zwei Werten angegeben wird, werden der erste und der zweite Wert auf den niedrigen bzw. hohen Punkt angewendet. Der Wert <strong>Au\00DFerhalb von Segment</strong> gilt nur f\00FCr Tortendiagramme.'),
unistr('        Die Werte <strong>\00DCber Marker</strong>, <strong>Unter Marker</strong>, <strong>Vor Marker</strong> und <strong>Nach Marker</strong> gelten nur f\00FCr Linien-, Fl\00E4chen-, Streu- und Blasendatenreihen. Die Werte <strong>Innerhalb von Balkenrand</st')
||unistr('rong> und <strong>Au\00DFerhalb von Balkenrand</strong> '),
unistr('        gelten nur f\00FCr nicht polare Balkendatenreihen. Gestapelte Balken unterst\00FCtzen <strong>Au\00DFerhalb von Balkenrand</strong> nicht. Der Wert <strong>Start</strong> gilt nur f\00FCr horizontale und vertikale Statusgaugediagramme. Das Diagramm passt das')
||unistr(' Layout derzeit nicht an, damit Labels in den Darstellungsbereich passen. \00DCberlappungen zwischen Labels  werden ebenfalls nicht korrigiert.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801793270303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position der Labels, die in dem Diagramm gerendert werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801909230303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber Marker')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802268259303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'de'
,p_message_text=>'Nach Marker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802561601303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802181854303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'de'
,p_message_text=>'Vor Marker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802049343303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'de'
,p_message_text=>'Unter Marker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801865817303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Zentriert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802325595303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'de'
,p_message_text=>'Innerhalb von Balkenrand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826322136303357)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802474288303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Au\00DFerhalb von Balkenrand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826204603303357)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Au\00DFerhalb von Segment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262156399302896)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801641588303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801573114303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Labels in dem Diagramm gerendert werden sollen. Diese Einstellung gilt f\00FCr die Sichtbarkeit des Metrikwerts in einem Dial-Diagramm.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801436403303338)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795197354303333)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des Niedrigstwertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795067918303333)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Niedrig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796767387303334)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des Maximalwertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796625038303334)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Maximalwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898675974303415)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des Mindestwertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98898536030303415)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Mindestwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795591116303333)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des Er\00F6ffnungswertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795438601303333)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797503567303335)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen aus, der f\00FCr die Definition einer kurzen aussagekr\00E4ftigen benutzerdefinierten QuickInfo zu den Datenpunkten des Diagramms verwendet werden soll. Um die Wiedergabe einer QuickInfo zu Diagrammdatenpunkten sicherzustellen, mu')
||unistr('ss das QuickInfo-Attribut <strong>Anzeigen</strong> des Diagramms auf <strong>Ein</strong> gesetzt werden. Bei einem Boxplot-Diagramm darf die Spalte nicht mit der ausgew\00E4hlten Wertspaltenzuordnung \00FCbereinstimmen. Wenn eine Spalte ausgew\00E4hlt wird, di')
||unistr('e mit der Wertspaltenzuordnung \00FCbereinstimmt, wird keine benutzerdefinierte QuickInfo im Diagramm angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797405999303334)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte QuickInfo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796593585303334)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen zur Definition des Zielwertes in diesem Diagramm. Wenn festgelegt definiert das Wertattribut die ausgef\00FCllte Fl\00E4che innerhalb des Segments, und diese stellt den Wert des ganzen Segments dar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796403206303334)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zielwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794981533303333)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen aus, der f\00FCr die Definition des Wertes in diesem Diagramm verwendet werden soll. Bei einem Boxplot-Diagramm wird diese Spalte f\00FCr die Definition der Mindestwerte, Quartile, Mittel- und H\00F6chstwerte des numerischen Datasets ')
||'verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794812483303332)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795940655303333)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen zur Definition des Volumenwertes in diesem Diagramm. Wenn Werte angegeben werden, wird das Volumen auf der 2Y-Achse angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98795820893303333)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Volumen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796189960303333)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des X-Wertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796037901303333)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796391273303334)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition des Y-Wertes in diesem Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98796240370303334)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793725052303332)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen aus, der f\00FCr die Definition des Z-Wertes in diesem Diagramm verwendet werden soll. Der Z-Wert definiert den Blasenradius bei einem Blasendiagramm, die Breite eines Boxplot-Elements und die Balkenbreite bei einem Balken- od')
||'er Kombinationsdiagramm. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793660111303332)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605268785303171)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie diese Option aus, wenn die Regionskomponenten (Unterregionen, Elemente, Schaltfl\00E4chen) \00FCber oder unter dem Inhalt der Hauptregion angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037492903303534)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber Inhalt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037521189303534)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'de'
,p_message_text=>'Unter Inhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605177439303171)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Komponenten rendern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539894535303121)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen dieses Elements ein. Elementnamen m\00FCssen g\00FCltige Oracle-IDs sein. Elementnamen sollten maximal 30 Byte umfassen, damit sie als Bind-Variablen in SQL-Abfragen verwendet werden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539744644303121)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751174822303298)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, wie diese Spalte gerendert wird. Die folgenden Spaltentypen werden unterst\00FCtzt:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Je nach Anwendungskonfiguration sind hier zus\00E4tzliche Plug-ins f\00FCr den Spaltentyp verf\00FCgbar.'),
'Sie werden als <em>&lt;My Plug-in&gt; [Plug-in]</em> angezeigt.',
'Die folgenden Plug-ins sind in den gemeinsam verwendeten Komponenten dieser Anwendung installiert:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539445409303121)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, wie dieses Element wiedergegeben wird. Die folgenden Elementtypen werden unterst\00FCtzt:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Je nach Anwendungskonfiguration sind hier zus\00E4tzliche Plug-ins f\00FCr den Elementtyp verf\00FCgbar.'),
'Sie werden als <em>&lt;My Plug-in&gt; [Plug-in]</em> angezeigt.',
'Die folgenden Plug-ins sind in den gemeinsam verwendeten Komponenten dieser Anwendung installiert:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539316284303121)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198850074303662)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Seitenstandardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219968382303679)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Element in Pr\00FCfung auf nicht gespeicherte \00C4nderungen einbeziehen, wenn die Pr\00FCfung auf Seitenebene aktiviert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198383574303662)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob das Seitenelement bei der Pr\00FCfung auf nicht gespeicherte \00C4nderungen einbezogen wird, bei der der Benutzer gewarnt wird, wenn er versucht, aus der Seite zu navigieren, w\00E4hrend die Seite nicht gespeicherte \00C4nderungen enth\00E4lt. Einige El')
||unistr('emente m\00FCssen m\00F6glicherweise nicht gepr\00FCft werden (beispielsweise weil sie nicht auf einer Datenbankspalte basieren, wie ein Suchelement), sodass festgelegt werden kann, dass sie ignoriert werden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198444392303662)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'de'
,p_message_text=>'Ignorieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99201204781303664)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen an dem Element werden bei der Pr\00FCfung auf nicht gespeicherte \00C4nderungen ignoriert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198224816303662)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung bei nicht gespeicherten \00C4nderungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343185914303788)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761609422303307)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine JavaScript-Funktion ein, die ein Konfigurationsobjekt f\00FCr das interaktive Grid verwendet, das Objekt \00E4ndert und zur\00FCckgibt. Dies erm\00F6glicht eine erweiterte Anpassung der Darstellung, der Features und des Verhaltens des interaktiven Gri')
||unistr('ds, einschlie\00DFlich Symbolleiste, Men\00FCs und Aktionen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343230825303788)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897939120303414)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine JavaScript-Funktion ein, die ein Konfigurationsobjekt f\00FCr die Spalte \00E4ndert und zur\00FCckgibt. Dies erm\00F6glicht eine erweiterte Anpassung von Darstellung, Features und Verhalten der Spalte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343328179303788)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
'    // Richtet eine Callback-Funktion ein, die aufgerufen wird, wenn Daten abgerufen werden. Mit ihr kann die Reihe bearbeitet werden',
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
'    // Legt Optionen zur Diagramminitialisierung fest',
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807326968303342)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Geben Sie JavaScript-Code ein, um das Diagramm anzupassen.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343962640303789)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741611446303290)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie eine JavaScript-Funktion ein, die ein Konfigurationsobjekt f\00FCr die Komponente verwendet, das Objekt \00E4ndert und zur\00FCckgibt. Dies erm\00F6glicht eine erweiterte Anpassung von Darstellung, Features und Verhalten der Komponente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98741586946303290)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Initialisierungscode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112687265303595)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Position der gr\00F6\00DFeren und kleineren Achse im Diagramm an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113387495303595)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113279647303595)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112557632303595)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Achsenposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116192718303597)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Zeitma\00DFstab an, der f\00FCr die Achse im Diagramm verwendet werden soll. Dieser wird f\00FCr die korrekte Wiedergabe des Gantt-Diagramms ben\00F6tigt. Der ausgew\00E4hlte Zeitma\00DFstab wird zum Zoomen verwendet, wenn keine Zoomskalierungsoptionen ausgew\00E4')
||'hlt wurden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114206263303596)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'de'
,p_message_text=>'Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114199729303596)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'de'
,p_message_text=>'Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113802663303596)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'de'
,p_message_text=>'Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114605135303596)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'de'
,p_message_text=>'Monate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114854105303596)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'de'
,p_message_text=>'Quartale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113785564303595)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'de'
,p_message_text=>'Sekunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114490790303596)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'de'
,p_message_text=>'Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115050882303597)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'de'
,p_message_text=>'Jahre'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116027994303597)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nachkommastellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782373529303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Diagrammtyp. Der Diagrammtyp bestimmt die Visualisierung f\00FCr das Rendering des Diagramms.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782454979303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923106748303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4chendiagramme werden besonders verwendet, um Trends kumulativer Werte im Laufe der Zeit zu vergleichen, wie Aufgliederungen von Verkaufstrends.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782536892303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'de'
,p_message_text=>'Balken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923223093303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Balkendiagramme werden besonders f\00FCr den Vergleich von Werten \00FCber Kategorien hinweg oder im Laufe der Zeit verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704088923303257)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'de'
,p_message_text=>'Boxplot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704163866303257)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Mit Boxplotdiagrammen k\00F6nnen Sie die Verteilung von Daten analysieren, die Mindestwerte, Quartile, Mittel- und H\00F6chstwerte von numerischen Datengruppen anzeigen. Boxplots werden auch Box-Whisker-Plots genannt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782665467303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'de'
,p_message_text=>'Blase'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923372766303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Blasendiagramme definieren Datenelemente mit X-, Y- und Z-Werten und sind somit besonders zur Anzeige von Beziehungen zwischen 3 Dimensionen geeignet. Die dritte Dimension wird mit der Gr\00F6\00DFe der Blase dargestellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782759642303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'de'
,p_message_text=>'Kombination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923495542303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('In Kombinationsdiagrammen k\00F6nnen Balken-, Linien- und Fl\00E4chendatenreihen in demselben Diagramm angezeigt werden. Am h\00E4ufigsten werden Linien mit Balken oder Linien mit gestapelten Balken verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782865411303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'de'
,p_message_text=>'Statusgauge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923520168303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Statusgauges werden verwendet, um einen Metrikwert bezogen auf die m\00F6glichen Mindest- und H\00F6chstwerte f\00FCr diese Metrik anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817980079303350)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'de'
,p_message_text=>'Ring'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923673770303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'de'
,p_message_text=>'Ringdiagramme sind Tortendiagramme mit einem Loch in der Mitte. Sie eignen sich zur Anzeige von Teilen eines Ganzen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782969633303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'de'
,p_message_text=>'Trichter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923720657303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Trichterdiagramme eignen sich zur Anzeige von Daten der Phasen eines Prozesses, beispielweise der Phasen eines Verkaufsprozesses. Die Fl\00E4che eines Trichtersegments ist proportional zum Wert der entsprechenden Phase. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113006881303595)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'de'
,p_message_text=>'Gantt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113172546303595)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gantt-Diagramme sind n\00FCtzlich f\00FCr die Anzeige von Projektzeitpl\00E4nen, da sie Balken anzeigen, die Start- und Enddatum der Aufgaben angeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783088638303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'de'
,p_message_text=>'Linie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923874349303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Liniendiagramme eignen sich zur Anzeige von Trends in einem Set von Werten im Laufe der Zeit und zum Vergleich dieser Werte \00FCber Datenreihen hinweg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783142371303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Linien/Fl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923944965303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Linien-/Fl\00E4chendiagramme sind identisch mit Liniendiagrammen, wobei die Fl\00E4che unter jeder Linie ausgef\00FCllt ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783265215303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'de'
,p_message_text=>'Kreis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924003183303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'de'
,p_message_text=>'Tortendiagramme eignen sich besonders zur Anzeige von Teilen eines Ganzen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817677255303350)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'de'
,p_message_text=>'Polar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924107029303436)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Polardiagramme haben eine radiale Y-Achse und eine tangentiale X-Achse. Polardiagramme k\00F6nnen als Balken-, Linien-, Fl\00E4chen-, Kombinations-, Streu- oder Blasendiagrammdatenreihen gerendert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616663642303180)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'de'
,p_message_text=>'Pyramide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616788651303180)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Mit Pyramidendiagrammen k\00F6nnen hierarchische, proportionale und grundlagenbasierte Beziehungen, Prozessschritte, Organisationsschichten oder thematische Zusammenh\00E4nge visualisiert werden. Die Gr\00F6\00DFe eines Pyramidenst\00FCcks ist proportional zum zugeh\00F6rig')
||unistr('en Wert f\00FCr die entsprechende Phase.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817738207303350)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'de'
,p_message_text=>'Radar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924219462303437)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Grid-Diagramme sind Polardiagramme mit einer polygonalen Grid-Form anstelle eines Kreises. Sie werden f\00FCr Linien- und Fl\00E4chendiagrammdatenreihen unterst\00FCtzt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817806933303350)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'de'
,p_message_text=>'Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924313145303437)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Bereichsdiagramme zeigen H\00F6chst- und Mindestwerte (hoch/niedrig) f\00FCr jeden Eintrag an, wobei Balken oder Fl\00E4chen verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783322785303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'de'
,p_message_text=>'Streudiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924448611303437)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Streudiagramme definieren Datenelemente mit X- und Y-Werten, sodass sie besonders zur Anzeige von Beziehungen zwischen 2 Dimensionen verwendet werden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783469690303324)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'de'
,p_message_text=>'Aktien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924510171303437)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Aktiendiagramme werden zur Anzeige von Informationen zu einer Aktie auf einer Zeitachse verwendet. Aktiendiagramme heben sich durch die Kerzeneigenschaft <strong>Aktie rendern als</strong> ab, mit der Er\00F6ffnungs-, Schluss-, H\00F6chst- und Niedrigstwerte')
||unistr(' f\00FCr den Aktienkurs angezeigt werden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98782283112303323)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721031853303272)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob L\00FCcken in den Daten von Diagrammen mit mehreren Reihen auf einen Wert von Null oder 0 (Null) gesetzt werden sollen.'),
unistr('        <p>Ist die Option auf <strong>Ein</strong> gesetzt, werden L\00FCcken in Daten wie Null behandelt. Bei einem Liniendiagramm wird dadurch sichergestellt, dass die Linie als fortlaufende Linie gerendert wird. Bei einem gestapelten Balkendiagramm, b')
||unistr('ei dem das Stapellabel auf "Ein" gesetzt ist, wird dadurch sichergestellt, dass das Stapellabel f\00FCr die einzelnen Stapel gerendert wird.</p>'),
unistr('        <p>Ist die Option auf <strong>Aus</strong> gesetzt, werden L\00FCcken in Daten wie 0 (Null) behandelt. Bei einem Liniendiagramm wird die Linie als unterbrochene Linie mit L\00FCcken f\00FCr die Nulldatenpunkte gerendert.<p>'),
unistr('        <p>Diese Einstellung wird auf Diagrammtypen mit mehreren Datenreihen angewendet, die das Rendering als Balken und Linie unterst\00FCtzen, beispielsweise Balken, Linie, Linien/Fl\00E4chen, Kombination, Fl\00E4che, Polar, Radar und Streudiagramm. Die Stand')
||'ardeinstellung ist <strong>Ein</strong>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98720904919303272)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('L\00FCcke als Null rendern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785367744303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie aus, ob der Datencursor in dem Diagramm aktiviert ist.'),
unistr('        Der Datencursor ist eine n\00FCtzliche Alternative zu QuickInfos, wenn die Navigation zu Datenelementen schwierig ist, insbesondere bei Touchger\00E4ten.<p/>'),
unistr('        <p/>Wenn dieser Wert auf <strong>Automatisch</strong> festgelegt ist, wird der Datencursor nur f\00FCr Linien- oder Fl\00E4chendiagramme auf Touchger\00E4ten angezeigt.<p/>'),
unistr('        <p> Hinweis - Der Datencursor wird nicht angezeigt, wenn die QuickInfo Null ist. Au\00DFerdem wird er bei Polardiagrammen nicht unterst\00FCtzt.</p> ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785443996303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98924962323303437)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenden Sie die in Oracle JET definierte Standardanzeige f\00FCr den Datencursor auf das Diagramm an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785694576303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925145505303437)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Datencursor wird nicht angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785522895303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925068591303437)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Datencursor wird immer angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785282937303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Cursor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785851118303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Verhalten des Datencursors in dem Diagramm.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785939688303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915406800303429)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'de'
,p_message_text=>'Wenden Sie das in Oracle JET definierte Standard-Datencursorverhalten auf das Diagramm an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786037125303326)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'de'
,p_message_text=>unistr('Gleichm\00E4\00DFig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925218923303437)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Der Datencursor gibt die Mausbewegung gleichm\00E4\00DFig wieder, wobei die QuickInfo angezeigt wird, sobald der Datencursor auf einen Teil eines Datenelements zeigt und nicht nur auf bestimmte Datenpunkte. Ein Indikator gibt das aktuell ausgew\00E4hlte Daten')
||'element an.</p>',
unistr('        <p>Hinweis - Setzen Sie <strong>Cursor</strong> auf <strong>Ja</strong>, damit diese Visualisierung ordnungsgem\00E4\00DF funktioniert.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786179140303326)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'de'
,p_message_text=>'Einrasten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925366880303437)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Der Datencursor springt zu einem Datenelement (rastet ein), wenn eine Mausbewegung/Ber\00FChrung \00FCber dem Diagramm erfolgt, wobei die QuickInfo angezeigt wird, sobald der Datencursor auf ein Datenelement zeigt. Ein Indikator identifiziert das aktuell ')
||unistr('ausgew\00E4hlte Datenelement.</p>'),
unistr('        <p>Hinweis - Setzen Sie den <strong>Cursor</strong> auf <strong>Ja</strong>, damit diese Visualisierung ordnungsgem\00E4\00DF funktioniert.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98785780544303325)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Verhalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635621916303195)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob L\00FCcken in den Daten von Diagrammen mit mehreren Reihen automatisch gef\00FCllt werden sollen. Diese Einstellung gilt nicht f\00FCr Diagramme mit nur einer Reihe und nicht f\00FCr die folgenden Diagrammtypen: Blase, Ring, Trichter, Gantt, Torte, ')
||unistr('Pyramide, Streuung und Aktien. Wenn die Option auf <strong>Ein</strong> gesetzt ist, wird die in Oracle Application Express 5.1.3 eingef\00FChrte Datenverdichtungslogik auf die Diagrammdaten angewendet. Wenn die Option auf <strong>Aus</strong> gesetzt is')
||unistr('t, werden L\00FCcken in Daten nicht gef\00FCllt, und es kann zu ungenauem Diagrammrendering kommen. Die Standardeinstellung ist <strong>Ein</strong>.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635523313303195)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('L\00FCcken in Diagrammdaten f\00FCllen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349590902303793)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie CSS-Klassen ein, die auf Baselineleisten im Gantt-Diagramm angewendet werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie sie durch Leerzeichen trennen. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Ersetzungen verwenden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349410728303793)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Baseline-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119793838303600)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Baselineenddatums im Gantt-Diagramm verwendet werden soll. Ein Baselineenddatum ist das urspr\00FCnglich geplante Enddatum der Aufgabe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119604620303600)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Baselineenddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119500009303600)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Baselinestartdatums im Gantt-Diagramm verwendet werden soll. Ein Baselinestartdatum ist das urspr\00FCnglich geplante Startdatum der Aufgabe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119451056303600)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Baselinestartdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117993480303599)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Enddatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117868645303599)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Enddatumsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118126654303599)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Seite oder das Anwendungselement aus, das bzw. die zum Definieren des Enddatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118042100303599)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Enddatumselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117163065303598)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Quelle aus, die zum Definieren des Enddatums des Gantt-Diagramms verwendet werden soll. Ein Enddatum ist f\00FCr die Wiedergabe des Diagramms erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117359085303598)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117479780303598)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den in <em>Enddatumsspalte</em> eingegebenen Spaltenwert gesetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117656362303599)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117760000303599)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Enddatumselement</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117279792303598)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Quelltyp f\00FCr Enddatum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119991804303600)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Aufgabenfortschritts im Gantt-Diagramm verwendet werden soll. Der Wert des Fortschritts muss zwischen 0 und 1 liegen. Wenn der Wert ung\00FCltig ist, wird kein Fortschritt angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119819458303600)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Fortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349372134303793)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie CSS-Klassen ein, die auf Fortschrittsleisten im Gantt-Diagramm angewendet werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie sie durch Leerzeichen trennen. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Ersetzungen verwenden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349269619303793)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Fortschritts-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118329590303599)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren der Zeilen-ID im Gantt-Diagramm verwendet werden soll. Eine Zeilen-ID ist f\00FCr die Wiedergabe mehrerer Aufgaben pro Zeile erforderlich. Wenn keine Zuordnung zwischen Zeilen-ID und Spalte definier')
||'t ist, wird jede Aufgabe als einzige Aufgabe pro Zeile wiedergegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118223666303599)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilen-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118501904303599)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Zeilennamens im Gantt-Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118445726303599)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117057810303598)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Startdatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116946067303598)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Startdatumspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126561104303606)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Seite oder das Anwendungselement aus, das bzw. die zum Definieren des Startdatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99117586851303598)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Startdatumselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113562451303595)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Quelle aus, die zum Definieren des Startdatums f\00FCr das Gantt-Diagramm verwendet werden soll. Ein Startdatum ist f\00FCr die erfolgreiche Wiedergabe des Diagramms erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116314515303598)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116416716303598)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den in <em>Startdatumsspalte</em> eingegebenen Spaltenwert gesetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116511553303598)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99116627516303598)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Startdatumselement</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113430629303595)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Quelltyp f\00FCr Startdatum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349169249303793)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie CSS-Klassen ein, die auf Aufgabenleisten im Gantt-Diagramm angewendet werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie sie durch Leerzeichen trennen. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Ersetzungen verwenden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349046824303793)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aufgaben-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119398691303600)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Aufgabenenddatums im Gantt-Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119291775303600)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aufgabenenddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118783573303599)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren der Aufgaben-ID im Gantt-Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118678181303599)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aufgaben-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118994257303600)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Aufgabennamens im Gantt-Diagramm verwendet werden soll. Wenn keine Zuordnung zwischen Zeilenname und Spalte definiert ist, wird der Aufgabenname als Zeilenlabel in der Zeilenachse des Diagra')
||'mms verwendet. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99118816780303600)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aufgabenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119159404303600)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Aufgabenstartdatums im Gantt-Diagramm verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99119025461303600)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aufgabenstartdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329776225303777)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Viewport-Enddatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324790623303773)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Enddatumsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329883979303777)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Seite oder das Anwendungselement aus, das bzw. die zum Definieren des Viewport-Enddatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324542820303772)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Enddatumselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329460508303776)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Quelle aus, die zum Definieren des Enddatums f\00FCr den Viewport des Gantt-Diagramms verwendet werden soll. Ein Viewport ist ein Datumsbereich, durch dessen Definition das anf\00E4ngliche Zoomen eines Diagramms bei der Wiedergabe gesteuert we')
||'rden kann. Das Diagramm wird auf den angegebenen Datumsbereich gezoomt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324978640303773)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329585725303777)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den in <em>Enddatumsspalte</em> eingegebenen Spaltenwert gesetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325197072303773)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329640647303777)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Enddatumselement</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324447951303772)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Quelltyp f\00FCr Enddatum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329295218303776)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen der Spalte aus, die zum Definieren des Viewport-Startdatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324630647303773)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Startdatumspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329351909303776)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Seite oder das Anwendungselement aus, das bzw. die zum Definieren des Viewport-Startdatums des Gantt-Diagramms verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324366148303772)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Startdatumselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328960233303776)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, welche Quelle zum Definieren des Startdatums f\00FCr den Viewport des Gantt-Diagramms verwendet werden soll. Ein Viewport ist ein Datumsbereich, durch dessen Definition das anf\00E4ngliche Zoomen eines Diagramms bei der Wiedergabe gesteuert w')
||'erden kann. Das Diagramm wird auf den angegebenen Datumsbereich gezoomt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324834413303773)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329007775303776)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den in <em>Startdatumsspalte</em> eingegebenen Spaltenwert gesetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99325080224303773)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99329158706303776)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Startdatumselement</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99324254337303772)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Quelltyp f\00FCr Startdatum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228514651302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Winkelausma\00DF f\00FCr das Statusgaugediagramm mit kreisf\00F6rmiger Ausrichtung in Grad an. Das Winkelausma\00DF ist ein tats\00E4chlicher Winkel der kreisf\00F6rmigen Ausrichtung. Positive Werte geben einen Winkel im Uhrzeigesinn an. Negative Werte geben e')
||unistr('inen Winkel entgegen dem Uhrzeigersinn an. Sie k\00F6nnen den kreisf\00F6rmigen Gauge in jedem beliebigen Winkel zeichnen und seine Form entsprechend dem gew\00FCnschten Winkel \00E4ndern. Die Form des Gauges h\00E4ngt von zwei Einstellungen ab: <strong>Anfangswinkel</s')
||unistr('trong> und <strong>Winkelausma\00DF</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228300564302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Winkelausma\00DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227966149302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Verh\00E4ltnis der relativen Dicke des Indikators zum Darstellungsbereich an. Der Standardwert lautet 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227803003302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Indikatorgr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228036656302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den inneren Radius eines Statusgaugediagramms mit kreisf\00F6rmiger Ausrichtung an (definiert durch den Abstand zwischen der Mitte des Gauges und der inneren Kante des Indikators und Darstellungsbereichs). G\00FCltige Werte: Prozentsatz oder Verh\00E4l')
||'tnis von 0 bis 1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228125519302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Innerer Radius'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227527563302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Typ des anzuzeigenden Statusgaugediagramms aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227214962302867)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'de'
,p_message_text=>unistr('Kreisf\00F6rmig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227344851302867)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'de'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227483521302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'de'
,p_message_text=>'Vertikal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227145357302867)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227775831302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob der Darstellungsbereich eines Statusgaugediagramms angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98227639630302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Darstellungsbereich anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98341993339302958)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238109664302876)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe ein, die f\00FCr den Darstellungsbereich eines Statusgaugediagramms angezeigt werden soll. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Ersetzungen verwenden. Diese Farbe wird nur angewendet, wenn keine Schwellenwertfarben f\00FCr das Diagra')
||'mm definiert wurden.</p>',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie bei der Suche nach "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238058425302876)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbe des Darstellungsbereichs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228475420302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Anfangswinkel f\00FCr das Statusgaugediagramm mit kreisf\00F6rmiger Ausrichtung in Grad an. Positive Werte geben den Anfangswinkel im Uhrzeigesinn an. Negative Werte geben den Anfangswinkel entgegen dem Uhrzeigersinn an. Sie k\00F6nnen den kreisf\00F6r')
||unistr('migen Gauge in jedem beliebigen Winkel zeichnen und seine Form entsprechend dem gew\00FCnschten Winkel \00E4ndern. Die Form des Gauges h\00E4ngt von zwei Einstellungen ab: <strong>Anfangswinkel</strong> und <strong>Winkelausma\00DF</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228202434302868)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anfangswinkel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112952173303595)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob horizontale Grid-Linien im Diagramm angezeigt werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112208079303594)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Horizontales Raster anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786388642303326)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie das Verhalten an, das angewendet werden soll, wenn im Diagramm auf Datenelemente gezeigt wird.<p/>',
unistr('        W\00E4hlen Sie <strong>Ein</strong> aus, um alle Datenelemente zu dimmen, auf die aktuell nicht gezeigt wird, und nur das aktuelle Datenelement hervorzuheben, auf das gezeigt wird.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786227977303326)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Beim Mouseover abblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374011852303813)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das anf\00E4ngliche Zooming des Diagramms aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374185486303813)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'de'
,p_message_text=>'Erste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374267923303813)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zoomen Sie anf\00E4nglich die ersten Datenpunkte, die in die Zeichnungsfl\00E4che des Diagramms passen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374345362303814)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'de'
,p_message_text=>'Letzte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374430181303814)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zoomen Sie anf\00E4nglich die letzten Datenpunkte, die in die Zeichnungsfl\00E4che des Diagramms passen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374505010303814)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Kein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374615142303814)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Deaktiviert das anf\00E4ngliche Zooming.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373955486303813)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4ngliches Zooming')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759507161303305)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502270459303091)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige der Schriftart f\00FCr das angegebene Attribut ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499279208303088)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500866807303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Schriftartfamilie aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499487336303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'de'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499336168303088)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'de'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499585717303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'de'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499602741303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'de'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499876282303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'de'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499741962303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499966480303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'de'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500064575303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'de'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500103913303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500227256303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'de'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500312399303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'de'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500527217303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'de'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500474157303089)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500652432303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'de'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500733535303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'de'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498984470303088)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftartfamilie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501333283303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftgr\00F6\00DFe ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501579683303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'de'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501674566303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'de'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501769778303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'de'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501872824303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'de'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501922857303091)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'de'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502094291303091)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'de'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502147292303091)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'de'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501476502303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'de'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499124043303088)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98500919344303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Schriftschnitt aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501123200303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'de'
,p_message_text=>'Kursiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501049531303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98501260019303090)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schr\00E4g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98499056314303088)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98309948949302934)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, wie die Labels in den Segmenten des Tortendiagramms angezeigt werden sollen. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353547012303797)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'de'
,p_message_text=>'Label - Prozentsatz ( Wert )'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354086467303797)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Die Labels zeigen die Label-, Wert- und Prozentsatzinformationen im folgenden Format an: Label - Prozentsatz ( Wert ). Beispiel: <strong>Bugs - 15 % ( 18 )</strong>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353602261303797)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz ( Wert )'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354142752303797)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Labels werden basierend auf der ausgew\00E4hlten Wertspaltenzuordnung als numerische Werte angezeigt. Beispiel: <strong>15 % ( 18 )</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353237865303796)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353792877303797)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Labels werden in den Segmenten des Diagramms angezeigt, basierend auf der ausgew\00E4hlten Labelspaltenzuordnung. Beispiel: <strong>Bugs</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697882525303252)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'de'
,p_message_text=>'Label - Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697949836303252)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Die Labels zeigen die Label- und Wertinformationen in folgendem Format an: label - value. Beispiel: <strong>Bugs - 18</strong>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353324749303796)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353836635303797)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Labels werden basierend auf der ausgew\00E4hlten Wertspaltenzuordnung als Werte zwischen 0 % und 100 % angezeigt. Der Wert ist ein Prozentsatz der im Diagramm dargestellten Gesamtwerte. Beispiel: <strong>15 %</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353476733303796)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353911486303797)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Labels werden basierend auf der ausgew\00E4hlten Wertspaltenzuordnung als numerische Werte angezeigt.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353149255303796)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759446983303305)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496287430303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige der Schriftart f\00FCr das angegebene Attribut ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495844125303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495923621303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Schriftartfamilie aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496456591303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'de'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496394991303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'de'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496527734303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'de'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496653831303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'de'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496802370303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'de'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496780425303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496964770303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'de'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497048545303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'de'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497167790303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497213746303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'de'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497341100303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'de'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497585086303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'de'
,p_message_text=>'Times New Roman'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497499580303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497677007303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'de'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497750045303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'de'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495543438303085)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftartfamilie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496101053303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftgr\00F6\00DFe ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498253294303088)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'de'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498337128303088)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'de'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498480842303088)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'de'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498510652303088)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'de'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498677504303088)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'de'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498724418303088)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'de'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498828024303088)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'de'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498183895303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'de'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495705831303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98496080029303086)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Schriftschnitt aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497937679303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'de'
,p_message_text=>'Kursiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98497822951303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98498029855303087)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schr\00E4g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495633677303085)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345750591302961)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Eine durch Komma getrennte Liste mit Farben:</dt>',
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Seiten- oder Anwendungselementen, die Farben zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>-Syntax. Beispiel: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Spalten, die Farben zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>-Syntax. Beispiel: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345665941302961)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie die Farben ein, mit denen die anzuzeigenden Referenzlinien in einem Statusgaugediagramm identifiziert werden.',
'Geben Sie mehrere Referenzlinien in einer durch Komma getrennten Liste ein.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345322916302961)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345503131302961)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Eine durch Komma getrennte Liste mit statischen numerischen Werten:</dt>',
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Seiten- oder Anwendungselementen, die numerische Werte zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>-Syntax. Beispiel: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Spalten, die numerische Werte zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>-Syntax. Beispiel: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345462556302961)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie die Zahlen ein, mit denen die anzuzeigenden Referenzlinien in einem Statusgaugediagramm identifiziert werden.',
'Geben Sie mehrere Referenzlinien in einer durch Komma getrennten Liste ein.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98345214110302961)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112782133303595)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob die Zeilenlabels im Diagramm wiedergegeben werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112417521303594)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilenachse anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797893851303335)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797792957303335)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr die Datenelemente ein, die mit dieser Diagrammreihe verkn\00FCpft sind. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Ersetzungen verwenden. Bei einem Statusgaugediagramm wird diese Farbe auf den Indikator angewendet, au\00DFer wenn Schwe')
||'llenwerte definiert wurden und das Attribut <strong>Schwellenwertanzeige</strong> auf <strong>Bei Indikator</strong> gesetzt ist.</p>',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie durch die Suche nach "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797694491303335)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723644762303275)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723401785303275)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe ein, die f\00FCr das Q2-Segment der Boxplot-Diagrammreihe angezeigt werden soll. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Ersetzungen verwenden.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723237456303274)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbe Q2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723742505303275)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723530970303275)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe ein, die f\00FCr das Q3-Segment der Boxplot-Diagrammreihe angezeigt werden soll. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Ersetzungen verwenden.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98723329089303274)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbe Q3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98718572894303270)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Diagrammdatenreihentyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705407372303258)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705523036303258)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'de'
,p_message_text=>'Balken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705384181303258)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'de'
,p_message_text=>'Boxplot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705617771303259)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'de'
,p_message_text=>'Linie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705755252303259)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Linien/Fl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705873472303259)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819816596303352)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenreihentyp - Spaltenzuordnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820076220303352)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Diagrammreihentyp. Sie k\00F6nnen auch ein Diagramm erstellen, in dem unterschiedliche Reihentypen in derselben Datendarstellung kombiniert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820105380303352)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820630267303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'de'
,p_message_text=>'Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820273517303352)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'de'
,p_message_text=>'Balken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820537337303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'de'
,p_message_text=>'Balken/Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820359699303352)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820436506303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Linien/Fl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819990776303352)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821250836303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Diagrammdatenreihentyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821356043303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821925492303354)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'de'
,p_message_text=>'Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821453666303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'de'
,p_message_text=>'Balken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821837251303354)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'de'
,p_message_text=>'Balken/Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821764834303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'de'
,p_message_text=>'Blase'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821543573303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109056445303592)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Linien/Fl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821653302303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'de'
,p_message_text=>'Streudiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821143405303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822135281303354)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Diagrammdatenreihentyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822258228303354)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822303850303354)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'de'
,p_message_text=>'Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822412691303354)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98822044154303354)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820889245303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Diagrammdatenreihentyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98821038073303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'de'
,p_message_text=>'Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820980185303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'de'
,p_message_text=>'Balken/Bereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98820724227303353)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802955296303339)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob die Achse in dem Diagramm gerendert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98802877612303339)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Achse anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344254165302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob die Baselineinformationen in der QuickInfo im Diagramm angezeigt werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343694603302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Baseline anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344020920302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob das Enddatum in der QuickInfo im Diagramm angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343415873302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Enddatum anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344129725302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob der Fortschritt in der QuickInfo im Diagramm angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343585072302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Fortschritt anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343718446302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob Zeileninformationen in der QuickInfo im Diagramm angezeigt werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343190762302959)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeile anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343934553302960)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob das Startdatum in der QuickInfo im Diagramm angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343339374302959)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Startdatum anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228727818302869)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob der Wert im Diagramm gerendert werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98228616258302868)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343823657302960)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob das Label in der QuickInfo im Diagramm angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98343234496302959)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791165773303330)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob eine QuickInfo in dem Diagramm gerendert werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791009953303329)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791796434303330)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob Werte in der QuickInfo des Diagramms angezeigt werden sollen. Werte werden von Ihrer Diagrammabfrage abgeleitet und neben den Diagrammdaten angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791600953303330)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126418056303606)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Diagrammsortierreihenfolge der Daten in einem Diagramm mit mehreren Reihen entweder anhand des Wertes oder anhand des Labels des Diagramms aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111039719303593)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'de'
,p_message_text=>'Label - Aufsteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111429653303594)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'de'
,p_message_text=>'Legen Sie diese Option fest, um das Diagramm anhand der X-Achsenlabels in aufsteigender Reihenfolge zu sortieren. Dies ist die Standardsortierreihenfolge. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111139286303593)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'de'
,p_message_text=>'Label - Absteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111554537303594)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'de'
,p_message_text=>'Legen Sie diese Option fest, um das Diagramm anhand der X-Achsenlabels in absteigender Reihenfolge zu sortieren. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110803028303593)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'de'
,p_message_text=>'Wert - Aufsteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111232790303594)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie diese Option fest, um das Diagramm anhand der Werte in aufsteigender Reihenfolge (1, 2, 3 usw.) zu sortieren. Diese Einstellung darf nur f\00FCr Tortendiagramme, Balken-/Linien-/Fl\00E4chendiagramme mit einer Reihe oder gestapelte Balken-/Fl\00E4chendi')
||'agramme verwendet werden. Die Sortierung wird bei Verwendung einer hierarchischen Gruppenachse nicht angewendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110901641303593)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'de'
,p_message_text=>'Wert - Absteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111369478303594)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie diese Option fest, um das Diagramm anhand der Werte in absteigender Reihenfolge (10, 9, 8 usw.) zu sortieren. Diese Einstellung darf nur f\00FCr Tortendiagramme, Balken-/Linien-/Fl\00E4chendiagramme mit einer Reihe oder gestapelte Balken-/Fl\00E4chendi')
||'agramme verwendet werden. Die Sortierung wird bei Verwendung einer hierarchischen Gruppenachse nicht angewendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110703873303593)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sortierreihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956294504303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956118383303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige der Schriftart f\00FCr das angegebene Attribut ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955747458303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955876990303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Schriftartfamilie aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957537899303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'de'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957450802303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'de'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957629558303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'de'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957736621303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'de'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957963963303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'de'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957823488303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958006580303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'de'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958124115303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'de'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958284155303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958384112303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'de'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958480197303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'de'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958699218303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'de'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958504022303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958733017303469)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'de'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958877917303470)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'de'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955479005303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftartfamilie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956072686303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftgr\00F6\00DFe ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956404730303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'de'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956559464303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'de'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956600512303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'de'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956719057303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'de'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956804248303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'de'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956959913303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'de'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957048413303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'de'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98956331990303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'de'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955684639303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955984752303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Schriftschnitt aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957290707303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'de'
,p_message_text=>'Kursiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957122721303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98957395166303468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schr\00E4g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955512517303467)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120145596303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position der Aufgabenlabels im Gantt-Diagramm aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120446378303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120814230303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'de'
,p_message_text=>'Das Aufgabenlabel wird am Ende der Taskleiste im Gantt-Diagramm dargestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120593595303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'de'
,p_message_text=>'Innere Mitte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120995835303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'de'
,p_message_text=>'Das Aufgabenlabel wird in der inneren Mitte der Taskleiste im Gantt-Diagramm dargestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120767297303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'de'
,p_message_text=>'Inneres Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121128207303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'de'
,p_message_text=>'Das Aufgabenlabel wird am inneren Ende der Taskleiste im Gantt-Diagramm dargestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120680897303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'de'
,p_message_text=>'Innerer Anfang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99121036331303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'de'
,p_message_text=>'Das Aufgabenlabel wird am inneren Anfang der Taskleiste im Gantt-Diagramm dargestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120235754303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120345794303601)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'de'
,p_message_text=>'Das Aufgabenlabel wird am Anfang der Taskleiste im Gantt-Diagramm dargestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99120048052303600)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aufgabenlabelposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257000821302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Eine durch Komma getrennte Liste mit Farben:</dt>',
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Seiten- oder Anwendungselementen, die Farben zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>-Syntax. Beispiel: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Spalten, die Farben zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>-Syntax. Beispiel: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256953880302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie die Farben ein, mit denen die obere Grenze der anzuzeigenden Schwellenwerte in einem Statusgaugediagramm identifiziert werden.',
'Geben Sie mehrere Schwellenwerte in einer durch Komma getrennten Liste ein.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238321498302876)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342051778302958)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, wie Schwellenwerte im Statusgaugediagramm angezeigt werden sollen. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256417904302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'de'
,p_message_text=>'Alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256574146302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'de'
,p_message_text=>'Alle Schwellenwerte, die mit dem Attribut <strong>Schwellenwerte</strong> definiert wurden, werden im Darstellungsbereich des Diagramms angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256704254302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'de'
,p_message_text=>'Nur aktueller Schwellenwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256887864302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'de'
,p_message_text=>'Der aktuelle Schwellenwert, der mit dem Attribut <strong>Schwellenwerte</strong> definiert wurde, wird im Darstellungsbereich des Diagramms angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256684565302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'de'
,p_message_text=>'Bei Indikator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342163043302959)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'de'
,p_message_text=>'Der aktuelle Schwellenwert, der mit dem Attribut <strong>Schwellenwerte</strong> definiert wurde, wird auf dem Indikator des Diagramms angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256382259302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98256277636302891)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Eine durch Komma getrennte Liste mit statischen numerischen Werten:</dt>',
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Seiten- oder Anwendungselementen, die numerische Werte zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>-Syntax. Beispiel: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Eine durch Komma getrennte Liste mit Spalten, die numerische Werte zur\00FCckgeben, mit:</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>-Syntax. Beispiel: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238217503302876)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie die Zahlen ein, mit denen die obere Grenze der anzuzeigenden Schwellenwerte in einem Statusgaugediagramm identifiziert werden.',
'Geben Sie mehrere Schwellenwerte in einer durch Komma getrennten Liste ein.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237941944302876)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759361095303305)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495439575303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige der Schriftart f\00FCr das angegebene Attribut ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492484840303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494031148303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Schriftartfamilie aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492608906303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'de'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492513588303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'de'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492784236303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'de'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492887526303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'de'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493019730303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'de'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492951445303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493137709303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'de'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493242250303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'de'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493314675303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493498080303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'de'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493559443303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'de'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493718265303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'de'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493688179303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493819651303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'de'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98493900670303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'de'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492194342303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftartfamilie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494586038303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftgr\00F6\00DFe ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494768637303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'de'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494841338303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'de'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494990935303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'de'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495035834303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'de'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495144973303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'de'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495299858303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'de'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98495321731303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'de'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494650062303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'de'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492379602303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494140578303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Schriftschnitt aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494327076303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'de'
,p_message_text=>'Kursiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494227814303084)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98494423965303085)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schr\00E4g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98492225963303083)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786516930303326)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Typ der Zeitachse, die in dem Diagramm angezeigt werden soll. Diese Einstellung rendert die Diagrammdaten automatisch in chronologischer Reihenfolge und darf nicht verwendet werden, wenn die Daten in umgekehrter chronologischer Reihenf')
||unistr('olge gerendert werden m\00FCssen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786621565303326)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915545807303429)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenden Sie die in Oracle JET definierte Standardeinstellung f\00FCr die Zeitachse auf das Diagramm an. Grundlage sind die zu rendernden Daten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786791132303326)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915611680303429)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenden Sie keine Einstellung f\00FCr den Zeitachsentyp auf das Diagramm an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786857418303326)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915798814303429)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenden Sie eine Einstellung f\00FCr den Zeitachsentyp auf das Diagramm an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786904766303326)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Gemischte H\00E4ufigkeit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825897126303357)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die auf der Diagrammachse angezeigten Zeitwerte werden in gemischter H\00E4ufigkeit angegeben. Da der Zeitwert der Daten variieren kann, wird die Stapelung nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825980309303357)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'de'
,p_message_text=>unistr('L\00FCcken \00FCberspringen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826014270303357)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die auf der Diagrammachse angezeigten Zeitwerte werden in regelm\00E4\00DFigen Abst\00E4nden gerendert, ungeachtet eventueller Zeitl\00FCcken in den Daten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98786462953303326)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeitachsentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759251225303305)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491629773303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige der Schriftart f\00FCr das angegebene Attribut ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491579682303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491244159303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Schriftartfamilie aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489843532303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'de'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489700512303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'de'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489971677303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'de'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490005016303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'de'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490256526303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'de'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490170277303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490345528303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'de'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490431032303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'de'
,p_message_text=>'Georgia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490591158303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490639730303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'de'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490799016303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'de'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490980897303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'de'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98490858417303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491049156303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'de'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491177833303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'de'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488364833303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftartfamilie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491422744303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftgr\00F6\00DFe ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489059131303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'de'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489178405303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'de'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489291933303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'de'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489399950303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'de'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489445209303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'de'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489550966303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'de'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98489614774303081)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'de'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488969177303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'de'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488546220303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491390978303082)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Schriftschnitt aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488757312303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'de'
,p_message_text=>'Kursiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488657825303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488808052303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schr\00E4g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488417464303080)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112885499303595)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob vertikale Grid-Linien im Diagramm angezeigt werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112314831303594)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Vertikales Raster anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826889672303357)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Verhalten des Diagramms beim Zoomen und Scrollen an. <strong>Live</strong> bedeutet, dass das Diagramm kontinuierlich aktualisiert wird, w\00E4hrend es bearbeitet wird,'),
unistr('        w\00E4hrend <strong>Verz\00F6gert</strong> bedeutet, dass das Update erst erfolgt, wenn das Zoomen und Scrollen abgeschlossen ist. W\00E4hrend das <strong>Live</strong>-Zoomen und -Scrollen am benutzerfreundlichsten ist, gibt es keine Garantien '),
unistr('        bez\00FCglich der Renderingperformance oder Verwendbarkeit bei gro\00DFen Datasets oder langsamen Clientumgebungen. Wenn die Performance wichtig ist, sollte stattdessen f\00FCr das Zoomen und Scrollen <strong>Verz\00F6gert</strong> verwendet werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787147300303326)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie das Verhalten des Diagramms beim Zoomen und Scrollen an.',
unistr('        Beim Zoomen und Scrollen kann der Endbenutzer Gesten verwenden, wie das Ziehen im Darstellungsbereich, das Verwenden des Mausrads oder das Zusammendr\00FCcken mit zwei Fingern, um die Gr\00F6\00DFe der angezeigten Werte zu \00E4ndern und innerhalb des Diagra')
||'mms zu navigieren, um andere Diagrammwerte anzuzeigen.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787308106303327)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'de'
,p_message_text=>unistr('Verz\00F6gert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866521551303389)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Mit der \00C4nderung an der Datenanzeige wird gewartet, bis das Zoomen/Scrollen abgeschlossen ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787442759303327)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Nur verz\00F6gertes Scrollen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866673748303389)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Mit der \00C4nderung an der Datenanzeige wird gewartet, bis das Scrollen abgeschlossen ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787562159303327)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'de'
,p_message_text=>'Live'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866704798303389)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Liveverhalten bedeutet, dass das Diagramm kontinuierlich aktualisiert wird, w\00E4hrend es bearbeitet wird.'),
unistr('        Bei gro\00DFen Datasets oder langsamen Clientumgebungen wird empfohlen, <strong>Verz\00F6gert</strong> zu w\00E4hlen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787674941303327)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'de'
,p_message_text=>'Nur Live-Scrollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866829502303389)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Das "Nur Live-Scrollen" bedeutet, dass das Diagramm kontinuierlich w\00E4hrend des Bildlaufs aktualisiert wird.'),
unistr('        Bei gro\00DFen Datasets oder langsamen Clientumgebungen sollten Sie <strong>Nur verz\00F6gertes Scrollen</strong> ausw\00E4hlen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787224534303327)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98866442336303389)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zoomen und scrollen sind f\00FCr das Diagramm deaktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787005604303326)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zoomen und scrollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331369629303778)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Zoomrichtung des Diagramms aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331447645303778)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Beide Achsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331507037303778)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'de'
,p_message_text=>'Zoomt in Richtung der X- und Y-Achsen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331662000303778)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'de'
,p_message_text=>'X-Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331784294303778)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'de'
,p_message_text=>'Zoomt nur in Richtung der X-Achse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331859416303778)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>'Y-Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331954031303779)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'de'
,p_message_text=>'Zoomt nur in Richtung der y-Achse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99331203301303778)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zoomrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115583693303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Tagesbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114393049303596)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115440728303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Stundenbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114081531303596)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115324462303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Minutenbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113994587303596)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115753765303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Monatsbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114797713303596)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Monate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115806335303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Quartalsbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114980666303596)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Quartale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115256730303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Sekundenbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99113646639303595)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sekunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115656168303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Wochenbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99114563787303596)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115966284303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob im Diagramm das Zoomen in den Jahresbereich zul\00E4ssig sein soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99115101095303597)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Jahre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919165560303432)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine clientseitige Bedingung an, um zu steuern, ob die Aktion ausgel\00F6st wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514267786303101)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie eine clientseitige Bedingung an, um zu kontrollieren, ob True- oder False-Aktionen ausgel\00F6st werden. Wenn die Auswertung der Bedingung'),
unistr('                                  True ergibt, werden True-Aktionen ausgel\00F6st; wenn die Auswertung False ergibt, werden False-Aktionen ausgel\00F6st.'),
unistr('                                  Wenn keine Bedingung angegeben wird, werden nur True-Aktionen ausgel\00F6st.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025362022303524)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'de'
,p_message_text=>'Element = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382095910303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025508648303524)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'de'
,p_message_text=>'Element > Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382246047303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> gr\00F6\00DFer als der angegebene <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025617406303524)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'de'
,p_message_text=>'Element >= Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382371284303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> gr\00F6\00DFer als oder gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026133074303525)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist in Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382811359303821)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> in der angegebenen <em>Liste</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026323795303525)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383073643303821)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Wertet den angegebenen JavaScript-Ausdruck aus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025758788303524)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'de'
,p_message_text=>'Element < Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382432675303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> kleiner als der angegebene <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025887144303525)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'de'
,p_message_text=>'Element <= Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382590021303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> kleiner als oder gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025407711303524)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'de'
,p_message_text=>'Element != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382144886303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> nicht gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026218445303525)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht in Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382929776303821)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> nicht in der angegebenen <em>Liste</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99026080670303525)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382765091303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob das ausgew\00E4hlte <em>Element</em> nicht leer ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025960130303525)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99382657957303820)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob das ausgew\00E4hlte <em>Element</em> leer ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514101409303100)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383483190303821)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Spalte aus, die in dieser Bedingung verwendet wird.</p>'),
unistr('<p>Hinweis: In den meisten F\00E4llen sollte dies die oben in <em>When-Spalte(n)</em> angegebene Spalte sein,'),
unistr('deshalb ist sie die Standardspalte. Sie k\00F6nnen die Bedingung jedoch auch auf einer anderen Spalte basieren,'),
unistr('beispielsweise mit einem interaktiven Grid basierend auf der EMP-Tabelle, wenn Sie immer eine dynamische Aktion ausl\00F6sen m\00F6chten, '),
unistr('wenn sich der Wert <code>SAL</code> \00E4ndert, jedoch nur, wenn <code>JOB</code> gleich <em>SALESMAN</em> ist, in diesem Fall w\00FCrden Sie dieses Attribut in <code>JOB</code> \00E4ndern.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378055655303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384777846303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, ob ein <em>Element</em> oder eine <em>Spalte</em> in dieser Bedingung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373581298303813)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373464999303813)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373312357303813)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Komponententyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919220516303432)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie das Seitenelement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919019768303432)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie das Seitenelement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383502404303821)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Sie das Seitenelement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste mit verf\00FCgbaren Elementen ausw\00E4hlen.</p>'),
unistr('<p>Hinweis: In den meisten F\00E4llen sollte dies das oben in <em>When-Element(e)</em> angegebene Element sein,'),
unistr('deshalb ist dies das Standardelement. Sie k\00F6nnen die Bedingung jedoch auch auf einem anderen Seitenelement basieren,'),
unistr('beispielsweise mit einem Formular basierend auf der EMP-Tabelle, wenn Sie immer eine dynamische Aktion ausl\00F6sen m\00F6chten, wenn sich der Wert <code>P2_SAL</code> \00E4ndert, jedoch nur'),
unistr(', wenn <code>P2_SAL</code> gleich <em>SALESMAN</em> ist, in diesem Fall w\00FCrden Sie dieses Attribut in <code>P2_JOB</code> \00E4ndern.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373617706303813)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383389510303821)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seitenelement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377923136303816)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98919374389303432)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine clientseitige Bedingung an, um zu steuern, ob die Aktion ausgel\00F6st wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378252824303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie eine clientseitige Bedingung an, um zu kontrollieren, ob True- oder False-Aktionen ausgel\00F6st werden. Wenn die Auswertung der Bedingung'),
unistr('                                  True ergibt, werden True-Aktionen ausgel\00F6st; wenn die Auswertung False ergibt, werden False-Aktionen ausgel\00F6st.'),
unistr('                                  Wenn keine Bedingung angegeben wird, werden nur True-Aktionen ausgel\00F6st.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378384892303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte=Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383617240303821)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378570568303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte>Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383833249303821)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> gr\00F6\00DFer als der angegebene <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378612226303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte>=Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383926322303821)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> gr\00F6\00DFer als oder gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379129848303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte ist in Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384451319303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> in der angegebenen <em>Liste</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379356267303818)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384617417303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Wertet den angegebenen JavaScript-Ausdruck aus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378758856303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte<Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384026621303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> kleiner als der angegebene <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378897339303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte<=Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384104944303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> kleiner als oder gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378426305303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte!=Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99383738336303821)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> nicht gleich dem angegebenen <em>Wert</em> ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379235620303818)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte ist nicht in Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384576586303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob der Wert des ausgew\00E4hlten <em>Elements</em> oder der ausgew\00E4hlten <em>Spalte</em> nicht in der angegebenen <em>Liste</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379084360303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte ist nicht null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384366812303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob das ausgew\00E4hlte <em>Element</em> oder die ausgew\00E4hlte <em>Spalte</em> nicht leer ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378978128303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element/Spalte ist null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99384281549303822)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCft, ob das ausgew\00E4hlte <em>Element</em> oder die ausgew\00E4hlte <em>Spalte</em> leer ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99378115462303817)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918961386303432)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den JavaScript-Ausdruck ein, der f\00FCr diese Bedingung ausgewertet werden muss.'),
'Der Code hat Zugriff auf die folgenden Attribute, die sich auf die dynamische Aktion beziehen:</p>',
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>Eine Referenz auf das DOM-Objekt des Elements, das die dynamische Aktion ausgel\00F6st hat.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>Das Ereignisobjekt, das das Ereignis ausgel\00F6st hat. Hinweis: Beim Laden ist dies identisch mit ''load''.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>Optionale zus\00E4tzliche Daten, die von dem Event Handler \00FCbergeben werden k\00F6nnen.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918806464303432)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379906884303818)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den JavaScript-Ausdruck ein, der f\00FCr diese Bedingung ausgewertet werden muss.'),
'Der Code hat Zugriff auf die folgenden Attribute, die sich auf die dynamische Aktion beziehen:</p>',
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>Eine Referenz auf das DOM-Objekt des Elements, das die dynamische Aktion ausgel\00F6st hat.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>Das Ereignisobjekt, das das Ereignis ausgel\00F6st hat. Hinweis: Beim Laden ist dies identisch mit ''load''.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>Optionale zus\00E4tzliche Daten, die von dem Event Handler \00FCbergeben werden k\00F6nnen.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379876273303818)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377882650303816)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Komma getrennte Liste der Werte f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377799711303816)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379746456303818)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die durch Komma getrennte Liste mit Werten f\00FCr die zu testende Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379607104303818)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418325615303851)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418277387303851)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379539094303818)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert f\00FCr die zu testende Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99379470345303818)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514911868303101)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie JavaScript-Code ein, der beim Laden der Seite ausgef\00FChrt wird.'),
unistr('Dieser Code wird nach dem von &PRODUCT_NAME. generierten JavaScript-Code ausgef\00FChrt.</p>'),
'<p>Die Ersetzungszeichenfolge <code>#GENERATED_JAVASCRIPT#</code> wird durch den hier eingegebenen Code im Seitentemplate ersetzt.</p>',
'',
unistr('<p>Hinweis: Sie m\00FCssen keine \00F6ffnenden oder schlie\00DFenden <code>Skript</code>-Tags, sondern nur den JavaScript-Code einf\00FCgen.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514800707303101)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Beim Laden der Seite ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017288712303518)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Standarddateireferenz</dt>',
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>Standarddateireferenz, die die minimierte Datei <code>main.min.js</code> aus <code>/myjs/minified/</code> bei regul\00E4ren Seitenansichten und <code>main.js</code> aus <code>/myjs/</code> im Debug-Modus oder bei Ausf\00FChrung der Anwendung aus App Buil')
||unistr('der l\00E4dt.</dt>'),
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>Verwenden Sie diese Syntax, wenn die Library auch aus einem Require-Aufruf "RequireJS" verwendet wird. Der Define-Name muss mit den Angaben in den requirejs.config-Pfaden \00FCbereinstimmen, und der Wert muss das globale Symbol sein, das von der Libr')
||unistr('ary verf\00FCgbar gemacht wird. Gilt nur, wenn RequireJS verwendet wird. Dadurch wird verhindert, dass RequireJS diese Library ein zweites Mal l\00E4dt.</dt>'),
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>Verwenden Sie diese Syntax, wenn die Datei von RequireJS abh\00E4ngt. Dadurch wird RequireJS automatisch vor dieser Datei geladen.</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>Verwenden Sie diese Syntax, wenn die Datei von Oracle JET abh\00E4ngt. Dadurch werden RequireJS und die Oracle JET RequireJS-Konfiguration automatisch vor dieser Datei geladen.</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>Dateireferenz, die eine Abfragezeichenfolge in der URL verwendet, die die Anwendungsversion referenziert, sodass der Browser beim Upgrade der Anwendung (und bei Erh\00F6hung der Version) angewiesen wird, immer die neue Datei zu laden und vorher gecac')
||'hte Dateien zu ignorieren.</dt>',
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514536570303101)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die URLs der JavaScript-Datei f\00FCr Code ein, der auf dieser Seite geladen wird Jede URL muss auf einer eigenen Zeile stehen.'),
unistr('Wenn Sie eine minimierte Version Ihrer Datei bereitstellen, k\00F6nnen Sie die Ersetzungszeichenfolge <code>#MIN#</code> verwenden, um <code>.min</code> oder <code>#MIN_DIRECTORY#</code> einzubeziehen, damit <code>minified/</code> in der Datei-URL f\00FCr ei')
||unistr('ne regul\00E4re Seitenansicht und eine leere Zeichenfolge einbezogen wird, wenn die Seite im Debugmodus angezeigt wird oder wenn die Anwendung aus App Builder ausgef\00FChrt wird.'),
unistr('Sie haben auch Zugriff auf die Ersetzungszeichenfolge <code>#APP_VERSION#</code>, wenn Sie die Version der Anwendung in der Datei-URL einbeziehen m\00F6chten.</p>'),
'<p>URLs der JavaScript-Datei, die Sie hier eingeben, ersetzen die Ersetzungszeichenfolge <code>#PAGE_JAVASCRIPT#</code> in dem Seitentemplate.</p>',
unistr('<p>Hinweis: Sie m\00FCssen keine \00F6ffnenden oder schlie\00DFenden <code>Link</code>-Tags einbeziehen. Beziehen Sie einfach die Datei-URL ein.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514406248303101)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datei-URLs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514707629303101)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie JavaScript-Code wie Funktionen oder globale Variablendeklarationen ein, die auf dieser Seite referenziert werden.',
'Um einen Shortcut zu referenzieren, verwenden Sie <code>"SHORTCUTNAME"</code>.',
'Wenn dasselbe JavaScript auf mehreren Seiten erforderlich ist, sollten Sie den Code in eine externe JavaScript-Datei setzen, um eine Duplizierung zu vermeiden und um das Browser-Caching von statischen Dateien zu nutzen.</p>',
'<p>Code, den Sie hier eingeben, ersetzt die Ersetzungszeichenfolge <code>#PAGE_JAVASCRIPT#</code> in dem Seitentemplate.</p>',
unistr('<p>Hinweis: Sie m\00FCssen keine \00F6ffnenden oder schlie\00DFenden <code>script</code>-Tags aufnehmen. Nehmen Sie einfach den JavaScript-Code auf.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514686626303101)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Deklaration der Funktion und globalen Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355335378303798)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Label f\00FCr das Facet ein.'),
unistr('    Das Label wird nur auf der Seite angezeigt, wenn das Facet angezeigt wird. Das Label f\00FCr den Typ <strong>Suche</strong> wird ausgeblendet, ist aber f\00FCr assistive Technologien verf\00FCgbar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194719252303659)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>'~Geben Sie das Label der Facet-Gruppe ein.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99194978549303659)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Label f\00FCr das Facet ein.'),
unistr('    Das Label wird nur auf der Seite angezeigt, wenn das Facet angezeigt wird. Das Label f\00FCr den Typ <strong>Suche</strong> wird ausgeblendet, ist aber f\00FCr assistive Technologien verf\00FCgbar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557933600303135)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Label f\00FCr den Filter ein.'),
unistr('    Das Label wird nur auf der Seite angezeigt, wenn der Filter angezeigt wird. Das Label f\00FCr den Typ <strong>Suche</strong> wird ausgeblendet, ist aber f\00FCr assistive Technologien verf\00FCgbar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558814924303136)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>'~Geben Sie das Label der Filtergruppe ein.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559297061303136)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Label f\00FCr den Filter ein.'),
unistr('    Das Label wird nur auf der Seite angezeigt, wenn der Filter angezeigt wird. Das Label f\00FCr den Typ <strong>Suche</strong> wird ausgeblendet, ist aber f\00FCr assistive Technologien verf\00FCgbar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540438967303121)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Feldlabel f\00FCr das Seitenelement ein. '),
'Das Label wird nur dann auf der Seite angezeigt, wenn das Element angezeigt wird. ',
'Je nach Labelausrichtung und Anzeige wird das Label in einer eigenen HTML-Tabellenzelle oder in derselben Zelle angezeigt</p>. ',
unistr('Elementlabels k\00F6nnen Shortcuts mit der Syntax <code>"SHORTCUT_NAME"</code> enthalten.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540334440303121)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540634934303122)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Labelausrichtung. Ein Label kann \00FCber, unter oder links neben dem Element angezeigt werden. '),
'Wenn das Label neben dem Formularelement angezeigt wird, belegt es eine eigene HTML-Tabellenzelle. ',
unistr('Wenn Sie die Ausrichtung hier \00E4ndern, kontrollieren Sie die Labelposition innerhalb der Tabellenzelle.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028713423303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028856840303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'de'
,p_message_text=>'Unter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029032096303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Mitte unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029168588303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte zentriert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029280975303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'de'
,p_message_text=>'Mitte oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99028906870303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Zentriert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029484104303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Links unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029549872303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029639986303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'de'
,p_message_text=>'Links oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029351607303527)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029857970303528)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Rechts unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029964363303528)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99030011046303528)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'de'
,p_message_text=>'Rechts oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99029771394303528)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540574256303122)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357873456303800)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob die Region unabh\00E4ngig von den Daten f\00FCr die Region geladen werden soll.</p>'),
'        <p>Wenn Lazy Loading angegeben ist, wird die Seite sofort gerendert, wobei eine leere Region angezeigt wird, bis die Daten geladen sind.',
'        Im Allgemeinen wird die Seite erst angezeigt, wenn die gesamte Seite geladen wurde und zum Rendering bereit ist.',
unistr('        Wenn es also 5 Sekunden dauert, die gesamten Daten f\00FCr eine Region zu laden, muss der Endbenutzer ohne Lazy Loading 5 Sekunden auf den Beginn des Renderings der Seite warten.</p>'),
unistr('		<p>Hinweis: Lazy Loading sollte nur f\00FCr Datasets verwendet werden, deren Ladevorgang lange dauert, da diese Vorgehensweise die Datenbank mit unn\00F6tigem Verarbeitungsoverhead bei Regionen belastet, die schnell geladen werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736727704303285)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob die Region unabh\00E4ngig von den Daten f\00FCr die Region geladen werden soll.</p>'),
'        <p>Wenn Lazy Loading angegeben ist, wird die Seite sofort gerendert, wobei eine leere Region angezeigt wird, bis die Daten geladen sind.',
'        Im Allgemeinen wird die Seite erst angezeigt, wenn die gesamte Seite geladen wurde und zum Rendering bereit ist.',
unistr('        Wenn es also 5 Sekunden dauert, die gesamten Daten f\00FCr eine Region zu laden, muss der Endbenutzer ohne Lazy Loading 5 Sekunden auf den Beginn des Renderings der Seite warten.</p>'),
unistr('		<p>Hinweis: Lazy Loading sollte nur f\00FCr Datasets verwendet werden, deren Ladevorgang lange dauert, da diese Vorgehensweise die Datenbank mit unn\00F6tigem Verarbeitungsoverhead bei Regionen belastet, die schnell geladen werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736608816303285)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Lazy Loading'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176430185303645)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob die Sichtbarkeit des Layers durch Klicken auf den jeweiligen Namen in der Legende umgeschaltet werden kann.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176312850303645)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zum Ausblenden aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176693179303645)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Symbol an, das f\00FCr diesen Layer in der Legende angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176509095303645)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792169771303330)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position einer Legende in dem Diagramm.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792294532303330)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792551422303331)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'de'
,p_message_text=>'Unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792436244303331)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792358644303331)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792605113303331)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98792098312303330)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791917404303330)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob eine Legende in dem Diagramm gerendert werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791819074303330)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176887870303645)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Titel der Legende an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903001071303419)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine \00DCberschrift an, die oben in der Diagrammlegende angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902969586303419)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798045003303335)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Stil der Linie an, die in dem Diagramm gerendert werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798220510303335)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'de'
,p_message_text=>'Gestrichelt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798133429303335)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'de'
,p_message_text=>'Gepunktet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798378372303335)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'de'
,p_message_text=>'Durchgezogen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98797989261303335)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798808571303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Typ der Linie an, die in dem Diagramm gerendert werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798947817303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799271259303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'de'
,p_message_text=>'Zentriert segmentiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799068262303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'de'
,p_message_text=>'Zentriert schrittweise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799128066303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'de'
,p_message_text=>unistr('Kurvenf\00F6rmig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799575495303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799400769303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'de'
,p_message_text=>'Segmentiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799313714303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'de'
,p_message_text=>'Schrittweise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799681348303336)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Gerade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798743174303335)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798569499303335)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Breite der Linie an, die in dem Diagramm gerendert werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798484663303335)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98798684888303335)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'de'
,p_message_text=>' Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045678288303541)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\00D6ffnet den Link  in einem neuen Fenster</dt>'),
'<dd><pre>target="_blank"</pre></dd>',
'<dt>Zeigt eine QuickInfo an, wenn darauf gezeigt wird</dt>',
'<dd><pre>title="Zum Bearbeiten klicken"</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842689979303369)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie zus\00E4tzliche Spaltenlinkattribute ein, die in dem <code>&lt;a href=...&gt;</code>-Tag aufgenommen werden sollen, einschlie\00DFlich Linkziel, Klassen oder Formatvorlagen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842552059303369)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Linkattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848389561303374)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein Autorisierungsschema zur Verkn\00FCpfung mit der Linkspalte. Die Auswertung dieses Autorisierungsschemas muss TRUE ergeben, damit die Linkspalte in dem Bericht wiedergegeben werden kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848221595303374)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260667441303718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261081871303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260910847303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260848848303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261114919303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260756861303718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260591240303718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262695510303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262964989303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262876875303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262716296303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263009444303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262573700303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856959441303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856810333303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858381787303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858242088303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262229579303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262181160303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263884492303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263791825303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262021156303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261998292303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261837910303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263638711303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263522460303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263428367303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857196585303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Doppelpunkt getrennte Liste der Werte f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857043790303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857558471303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Seitennummer f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857497936303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857779455303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Komma getrennte Liste mit Seitennummern f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857665883303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261780991303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist oder ein Manager ist:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261611580303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261513359303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263352735303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263222489303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263152300303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857383166303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Benutzervoreinstellung ein, die mit dem angegebenen Wert f\00FCr diese Bedingung verglichen wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857294966303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262487533303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99262340618303720)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99264070174303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99263922612303721)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261461572303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter ein Manager ist und sich die Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          wobei deptno = :P2_DEPTNO',
'            und loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261318594303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99261226451303719)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403579817303838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn eine oder mehrere Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 30',
'</pre></dd>',
unistr('<dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn keine Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 40 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856582159303380)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856475188303380)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857953592303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Textwert f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98857883374303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858533241303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858499005303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856388611303380)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Bedingungstyp aus, der erf\00FCllt sein muss, damit dieser Link wiedergegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107474129303591)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'de'
,p_message_text=>'Immer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243194667303703)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Komponente wird immer wiedergegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106096958303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Microsoft Internet Explorer 7.0 oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106173573303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: XHTML-/CSS-f\00E4higer Browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105975059303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Mozilla, Netscape 6.x/7x oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106297782303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Andere Browser (oder \00E4ltere Version)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104678818303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Element enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106697588303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246784135303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106314243303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246967439303707)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106551671303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246867446303707)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106490885303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247079959303707)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103896041303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245540214303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104026618303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245760204303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103935670303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245671265303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht nicht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104177150303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist NICHT in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245888156303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist nicht in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106704003303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106881866303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105512450303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246514086303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird auf der Seite nach einer Weiterleitung der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104943620303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104700189303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104828182303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105021509303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101555757303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCckgegebene Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243255953303703)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt mindestens eine Zeile zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260392121303718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99260493152303718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Auswertung des Ausdrucks ergibt TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101714192303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243454652303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Funktionsbody gibt TRUE zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107139304303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107239165303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105258022303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist NICHT schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246252384303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite bzw. \00FCbergeordnete Region wird normal angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105162160303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246102676303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Auswertung der Bedingung "Schreibgesch\00FCtzt" der Seite bzw. \00FCbergeordneten Region ergibt TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103044669303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt keine Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244762274303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> enth\00E4lt keine Leerzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103364954303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist alphanumerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245015713303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist alphanumerisch und enth\00E4lt nur Buchstaben oder Zahlen und keine Sonderzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102517752303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244220958303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103291816303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244977523303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102756370303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244424850303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102401175303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244185050303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102831101303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL oder Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244502502303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer oder entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103169907303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244853091303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102668141303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244334764303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102904457303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL und NICHT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244669881303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer und entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105759288303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Weiter" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105894171303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Zur\00FCck" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107301846303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247146218303707)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Die Komponente wird niemals wiedergegeben.</p>',
unistr('<p>Hinweis: Wenn Sie eine Bedingung in <strong>Niemals</strong> \00E4ndern, wird jede vorhandene Bedingung entfernt. Um eine Komponente vor\00FCbergehend zu deaktivieren, empfiehlt Oracle stattdessen die Verwendung des Attributs <em>Erstelloption</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105602071303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler nicht angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246669082303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird nicht auf der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101609902303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Zeilen zur\00FCckgegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243373003303703)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt keine Zeilen zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104427136303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich im Druckversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245971108303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104556587303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich nicht im Druckerversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246077301303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer nicht in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101828728303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243512562303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102044317303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243726452303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99101971101303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243642136303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102159829303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243860268303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist nicht in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99106902064303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107017687303590)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105352829303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist berechtigt (nicht \00F6ffentlich)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246319541303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99105419065303589)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist der \00F6ffentliche Benutzer (Benutzer ist nicht berechtigt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99246425858303706)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist nicht bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103688977303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung = Wert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245303037303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103761910303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245461386303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103496868303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245177572303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99103511773303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99245282212303705)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingegeben haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102201667303586)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99243994926303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99102313483303587)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99244040430303704)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104343121303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99104255333303588)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856202836303380)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bedingungstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856702661303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Wert ein, mit dem die Bedingung verglichen werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856601308303381)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858118583303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858041631303382)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989858207303495)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Berichtsregionen k\00F6nnen mit dem Standarddrucklink, der unter der Berichtsregion angezeigt wird, oder mit einer Seitenschaltfl\00E4che gedruckt werden. Wenn Sie eine Schaltfl\00E4che verwenden m\00F6chten, entfernen Sie das Linklabel und erstellen eine Schaltf')
||unistr('l\00E4che auf der Seite, wobei die URL, die in <b>Druck-URL</b> angegeben wird, als Schaltfl\00E4chenziel verwendet wird.</p>'),
unistr('<p>Bei der Verwendung von Schaltfl\00E4chen f\00FCr das Drucken von Berichtsregionen kann der Sessionzustand festgelegt werden. Dies ist von Vorteil, wenn Sie in mehreren Ausgabeformaten (Word, Excel, PDF usw.) drucken und f\00FCr jede Option eine Schaltfl\00E4che, ')
||unistr('einen Link oder ein Bild anzeigen m\00F6chten. F\00FCr diese Implementierung verwenden Sie das Ausgabeformat, das von der Elementoption abgeleitet wurde, und nehmen den Elementnamen und -wert in der Druck-URL auf.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99218905146303678)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigen Sie den URL-Link f\00FCr diesen gespeicherten Bericht an. Dieses Attribut kann nur angezeigt werden, es kann nicht aktualisiert werden.</p>'),
unistr('    <p>Mit diesem Attribut k\00F6nnen Sie die angezeigte URL schnell kopieren. Mit dieser URL kann direkt von einer anderen Stelle in der Anwendung eine Verbindung zu diesem gespeicherten Bericht hergestellt werden. </p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990489898303496)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Berichtsregionen k\00F6nnen mit dem Standarddrucklink, der unter der Berichtsregion angezeigt wird, oder mit einer Seitenschaltfl\00E4che gedruckt werden. Wenn Sie eine Schaltfl\00E4che verwenden m\00F6chten, entfernen Sie das Linklabel und erstellen eine Schaltf')
||unistr('l\00E4che auf der Seite, wobei die URL, die in <b>Druck-URL</b> angegeben wird, als Schaltfl\00E4chenziel verwendet wird.</p>'),
unistr('<p>Bei der Verwendung von Schaltfl\00E4chen f\00FCr das Drucken von Berichtsregionen kann der Sessionzustand festgelegt werden. Dies ist von Vorteil, wenn Sie in mehreren Ausgabeformaten (Word, Excel, PDF usw.) drucken und f\00FCr jede Option eine Schaltfl\00E4che, ')
||unistr('einen Link oder ein Bild anzeigen m\00F6chten. F\00FCr diese Implementierung verwenden Sie das Ausgabeformat, das von der Elementoption abgeleitet wurde, und nehmen den Elementnamen und -wert in der Druck-URL auf.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859289537303383)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigen Sie den URL-Link f\00FCr diesen gespeicherten Bericht an. Dieses Attribut kann nur angezeigt werden, es kann nicht aktualisiert werden.</p>'),
unistr('<p>Mit diesem Attribut k\00F6nnen Sie die angezeigte URL schnell kopieren. Mit dieser URL kann direkt von einer anderen Stelle in der Anwendung eine Verbindung zu diesem gespeicherten Bericht hergestellt werden. </p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859157927303383)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Linkbeispiel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848111199303374)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den HTML-Code ein, der f\00FCr den Link verwendet werden soll. Verwenden Sie ein Bildtag, um Bilder anzuzeigen, oder w\00E4hlen Sie ein Bild aus der Liste mit Standardbildern. Wenn keine Definition vorhanden ist, wird <code>#IMAGE_PREFIX#ws/small_p')
||'age.gif</code> verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848061830303374)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Linksymbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858862811303382)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Klicken Sie auf das Ziel, um ein modales Dialogfeld aufzurufen. Sie k\00F6nnen ein benutzerdefiniertes Ziel eingeben, das aufgerufen werden soll, wenn auf die Linkspalte geklickt wird.</p>'),
unistr('        <p>W\00E4hlen Sie den entsprechenden Typ in "Link-Builder - Ziel" je nach Ihren Anforderungen aus:'),
'        <dl>',
'        <dt>Seite in dieser Anwendung</dt>',
'        <dd>Geben Sie Folgendes ein:',
'        <ul>',
unistr('        <li>Seite - Geben Sie die Seitennummer oder den Seitenalias ein, zu dem navigiert werden soll. Sie k\00F6nnen die Seitennummer auch aus der Auswahlliste ausw\00E4hlen.</li>'),
unistr('        <li>Elemente festlegen: Name - Geben Sie Seitenelemente (<code>P3_ID</code>), Anwendungselemente (<code>LAST_PAGE</code>) oder interaktive Berichtsfilter (<code>IR_EMPNO</code>) ein bzw. w\00E4hlen diese aus, die in Sessionzustand festgelegt werd')
||unistr('en m\00FCssen.</li>'),
unistr('        <li>Elemente festlegen: Wert - Geben Sie eine Berichtsspalte (<code>#ID#</code>) ein bzw. w\00E4hlen diese aus, geben Sie ein Anwendungs- oder Seitenelement ein (<code>&P2_EMPNO.</code>), oder geben Sie einen statischen Wert ein (<code>2</code>).')
||'</li>',
unistr('        <li>Cacheinhalt l\00F6schen - Geben Sie eine durch Komma getrennte Liste mit Seitennummern (<code>2,3</code>), Elementen (<code>P3_EMPNO,LAST_PAGE</code>) und Berichtseinstellungen ein, die gel\00F6scht werden sollen. Um den Seitenumbruch f\00FCr einen B')
||unistr('ericht zur\00FCckzusetzen, geben Sie <code>RP</code> ein. Um interaktive Berichtseinstellungen zu l\00F6schen oder zur\00FCckzusetzen, geben Sie <code>CIR</code> oder <code>RIR</code> ein.</li>'),
unistr('        <li>Seitenumbruch zur\00FCcksetzen - W\00E4hlen Sie "Ja" aus, um den Seitenumbruch - bis zur\00FCck zum ersten Set mit Datens\00E4tzen - f\00FCr Berichte auf der Zielseite zur\00FCckzusetzen. Dies hat dieselbe Auswirkung wie die \00DCbergabe von <code>RP</code> in "Cach')
||unistr('einhalt l\00F6schen".</li>'),
'        <li>Erweitert: Anforderung - Geben Sie die zu verwendende Anforderung ein.</li>',
'        </ul>',
'        </dd>',
'        <dt>Seite in einer anderen Anwendung</dt>',
unistr('        <dd>Geben Sie dieselben Attribute ein wie f\00FCr "Seite in dieser Anwendung". Nur m\00FCssen Sie au\00DFerdem die Anwendungs-ID oder den Anwendungsalias f\00FCr die Anwendung eingeben.</dd>'),
'        <dt>URL</dt>',
'        <dd>Geben Sie die URL ein</dd>',
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98858711422303382)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177279784303645)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Aktion aus, die beim Klicken auf ein Objekt auf der Karte ausgef\00FChrt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793924077303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Aktion, die beim Klicken auf dieses Diagramm ausgef\00FChrt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753218398303300)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zu der von der ersten Spalte zur\00FCckgegebenen URL umleiten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753378472303300)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Leiten Sie zu der Ziel-URL um, die von der ersten Spalte der SQL-Abfrage zur\00FCckgegeben wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794288343303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in einer anderen Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794346514303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nehmen Sie eine Umleitung zu einer Seite in einer anderen Anwendung vor, mit optionalen zus\00E4tzlichen Attributen zum Zur\00FCcksetzen des Seitenumbruchs, Festlegen des Anforderungswertes, L\00F6schen des Cache und Festlegen der Elementwerte auf der Zielsei')
||'te.</p>',
unistr('<p>Hinweis: F\00FCr die Umleitung zu einer Seite in einer anderen Anwendung muss Deeplinking in der Zielanwendung aktiviert sein. Gehen Sie hierf\00FCr zu den Attributen f\00FCr <em>Sicherheit</em> der Anwendung, und aktivieren Sie <em>Deeplinking</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794096794303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in dieser Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794163342303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Nehmen Sie eine Umleitung zu einer Seite in der aktuellen Anwendung vor, mit optionalen zus\00E4tzlichen Attributen zur Zur\00FCcksetzung des Seitenumbruchs, Festlegung des Anforderungswertes, Zur\00FCcksetzen der Cache- und Einstellungselementwerte auf der Ziel')
||'seite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794490232303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'de'
,p_message_text=>'Zu URL umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794514881303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu der von Ihnen angegebenen Ziel-URL vor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793872927303332)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842479898303369)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den HTML-Text ein, der als Link angezeigt werden soll. Verwenden Sie ein Image Tag, um Bilder anzuzeigen, oder treffen Sie in der Liste der Standardbilder eine Auswahl.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842396937303369)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Link-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154931557302810)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Template, um die Darstellung und das Layout dieser Liste zu definieren.</p>'),
'        <p>Listentemplates sind im Anwendungs-Theme definiert.',
unistr('        Beim Erstellen einer Listenregion wird f\00FCr das Template automatisch das Standardlistentemplate festgelegt, das im aktuellen Theme definiert ist.</p>'),
'        <p>Universal Theme stellt die folgenden Listentemplates bereit:',
'          <dl>',
'            <dt>Badgeliste</dt>',
'            <dt>Karten</dt>',
'            <dt>Linkliste</dt>',
'            <dt>Medienliste</dt>',
unistr('            <dt>Men\00FCleiste</dt>'),
unistr('            <dt>Men\00FC-Popup</dt>'),
'            <dt>Navigationsleiste</dt>',
unistr('            <dt>Seitliches Navigationsmen\00FC</dt>'),
'            <dt>Registerkarten</dt>',
unistr('            <dt>Oberes Navigationsmen\00FC</dt>'),
'            <dt>Assistentenfortschritt</dt>',
'          </dl>',
'          Siehe auch: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154804723302810)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222964124303681)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Listentyp aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223455715303682)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223502603303682)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die dynamische Liste basiert auf der SQL-Abfrage, die vom eingegebenen PL/SQL-Funktionsbody zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223240882303681)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223368338303682)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>'Die dynamische Liste basiert auf der SQL-Abfrage, die Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223042107303681)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223164283303681)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Die statische Liste basiert auf dem Textwert, den Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99222876875303681)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908321321303423)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Gesamtanzahl an Tagen ein, die in der Agendaansicht angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908213170303423)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908458346303423)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'de'
,p_message_text=>'Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908153721303423)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Tage, die f\00FCr die Listenansicht angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067673911303559)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067787262303559)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigen Sie die Kalendereintr\00E4ge basierend auf der von Ihnen eingegebenen Anzahl von Tagen an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067293063303558)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'de'
,p_message_text=>'Aktueller Monat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067324010303558)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigen Sie die Kalendereintr\00E4ge f\00FCr den aktuellen Monat an. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067412420303558)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelles Jahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067548885303559)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigen Sie die Kalendereintr\00E4ge f\00FCr das aktuelle Jahr an. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908080334303423)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658248000303212)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Anmeldeseite der Anwendung f\00FCr die Benutzeroberfl\00E4che an. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658125439303212)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anmelde-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602680851303169)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie ein, wohin &PRODUCT_NAME. nach der Abmeldung umleitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036750530303534)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'de'
,p_message_text=>'Homepage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036849616303534)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu dem Home-Linkwert vor, der in den Anwendungsattributen angegeben wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036961756303534)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'de'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037089327303534)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'de'
,p_message_text=>'Nehmen Sie eine Umleitung zu der von Ihnen eingegebenen URL ein, wie <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602588242303169)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Abmeldetyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735712200303285)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, wie Daten vor verlorenen Updates gesch\00FCtzt werden sollen.</p> '),
unistr('<p>Zu verlorenen Updates kommt es, wenn zwei oder mehr Personen versuchen, dieselben Daten zu aktualisieren und das letzte Update Updates \00FCberschreibt, die vom ersten Benutzer vorgenommen wurden, um die \00C4nderungen zu speichern. '),
unistr('Um dies zu verhindern, k\00F6nnen Updates die vorhandenen Spaltenwerte in der Datenbank mit den Werten vergleichen, die abgerufen wurden, als der Datensatz urspr\00FCnglich abgefragt wurde.</p>'),
'<p>Beispiel:',
'  <ol>',
unistr('    <li>Benutzer A fragt Mitarbeiterdatens\00E4tze (EMP) ab.</li>'),
unistr('    <li>Benutzer B fragt dieselben Mitarbeiterdatens\00E4tze ab.</li>'),
unistr('    <li>Benutzer B aktualisiert Mitarbeiterdetails f\00FCr EMPNO = 7839 und \00FCbernimmt (speichert) die \00C4nderungen in der Datenbank.</li>'),
unistr('    <li>Benutzer A aktualisiert Mitarbeiterdetails f\00FCr EMPNO = 7839 und versucht, die \00C4nderungen in der Datenbank zu \00FCbernehmen.</li>'),
'  </ol>',
unistr('Wenn Benutzer A denselben Datensatz erfolgreich aktualisiert, sind die \00C4nderungen von Benutzer B verloren.'),
unistr('Wenn Benutzer A versucht, den Mitarbeiterdatensatz zu speichern, sind die Daten in der Datenbank nicht mehr identisch mit den Daten, die Benutzer A urspr\00FCnglich abgefragt hat. '),
unistr('In Schritt 1 oben k\00F6nnen die urspr\00FCnglich von Benutzer A abgefragten Spaltenwerte erfasst werden. '),
unistr('In Schritt 4 oben k\00F6nnen die Werte mit den aktuellen Werten in der Datenbank verglichen werden. '),
unistr('Dieser Vergleich l\00F6st einen Fehler f\00FCr Benutzer A aus, weil die Datenbankwerte von Benutzer B in Schritt 3 aktualisiert wurden. '),
unistr('Dadurch wird verhindert, dass ein Benutzer \00C4nderungen \00FCberschreibt, die von einem anderen Benutzer an derselben Zeile vorgenommen wurden.</p>'),
unistr('<p>Hinweis - "Verlorenes Update - Typ" wird nur verwendet, wenn f\00FCr den entsprechenden Prozess, "Interaktives Grid - Automatische Zeilenverarbeitung (DML) " die Option <strong>Verlorene Updates verhindern </strong> angegeben ist.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735935449303285)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenversionsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865773604303388)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die Datenbanktabelle eine Spalte enth\00E4lt, die jedes Mal erh\00F6ht wird, wenn ein Datensatz aktualisiert wird, vorzugsweise durch einen Datenbanktrigger, kann diese Spalte verwendet werden, anstatt Pr\00FCfsummen zu berechnen.'),
'        Diese Option darf nicht verwendet werden, wenn das interaktive Grid Daten in mehreren Tabellen aktualisiert.</p>',
unistr('        <p>Hinweis - Die Spalte mit der Zeilenversion muss in der SQL-Quelle f\00FCr die Region enthalten sein.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735842296303285)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenwerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865659715303388)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ein Pr\00FCfsummenwert wird f\00FCr jede Zeile berechnet, wenn die Daten anf\00E4nglich abgefragt werden.'),
unistr('        Die Pr\00FCfsumme wird berechnet, indem alle aktualisierbaren Spalten in einer Zeichenfolge verkettet werden und dann ein eindeutiger Wert generiert wird.'),
unistr('        Wenn der aktualisierte Datensatz gespeichert wird, wird diese Pr\00FCfsumme mit dem Pr\00FCfsummenwert des aktuellen Datenbankdatensatzes verglichen.'),
unistr('        Wenn diese nicht identisch sind, wird ein Fehler ausgel\00F6st.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735698906303285)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Verlorenes Update - Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275010203303730)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275392049303731)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275235777303730)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275152763303730)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275465145303731)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99274982232303730)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276200958303731)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen Java-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias f\00FCr jede Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276154162303731)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Java-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276003774303731)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Abteilungsnamen anzeigen, Abteilungsnummer festlegen</dt>',
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275958849303731)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen JavaScript-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias f\00FCr jede Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275863022303731)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871445615303393)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen dieser Werteliste ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871323335303393)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600563898303168)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Spalten-, Seiten- oder Anwendungselemente ein, die in den Sessionzustand gesetzt werden m\00FCssen, wenn der Wert von einem der angegebenen kaskadierenden \00FCbergeordneten Wertelistenelemente ge\00E4ndert wird.'),
'Trennen Sie mehrere Elementnamen durch ein Komma.',
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente w\00E4hlen.'),
unistr('Wenn Sie aus der Liste w\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem Elementnamen, der aus der Liste zur\00FCckgegeben wird.</p>'),
unistr('<p>Sie m\00FCssen die in diesem Attribut angegebenen Seitenelemente innerhalb der <em>Where-Klausel</em> dieser Wertelisten-SQL-Abfrage verwenden, um die zur\00FCckgegebenen Werte einzuschr\00E4nken.</p>'),
unistr('<p>Hinweis: Die in <em>Kaskadierende Wertelistenelemente</em> definierten Seitenelemente werden automatisch \00FCbertragen und m\00FCssen nicht in dieses Attribut eingegeben werden.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600435402303168)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Weiterzuleitende Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275777569303731)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt Abteilungsname an, legt Abteilungsnummer fest</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275615291303731)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen PL/SQL-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias auf jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99275551626303731)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276474575303731)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen Python-Funktionsbody ein, der eine SQL-Abfrage zur\00FCckgibt, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias f\00FCr jede Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99276359738303731)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Python-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339295718303785)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfragedefinition ein, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias in jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>'),
unistr('<p>Hinweis: Wenn Sie beim Definieren eines Elementtyps "Popup-Werteliste" mehrere Spalten im Popup anzeigen m\00F6chten, m\00FCssen Sie Ihre Werteliste stattdessen mit den erforderlichen zus\00E4tzlichen Metadaten'),
unistr('in "Gemeinsame Komponenten" definieren. Inline-Wertelisten k\00F6nnen nur verwendet werden, um einzelne Spalten f\00FCr Popup-Wertelisten anzuzeigen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195094712303659)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfragedefinition ein, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias in jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>'),
unistr('<p>Hinweis: Wenn Sie beim Definieren eines Elementtyps "Popup-Werteliste" mehrere Spalten im Popup anzeigen m\00F6chten, m\00FCssen Sie Ihre Werteliste stattdessen mit den erforderlichen zus\00E4tzlichen Metadaten'),
unistr('in "Gemeinsame Komponenten" definieren. Inline-Wertelisten k\00F6nnen nur verwendet werden, um einzelne Spalten f\00FCr Popup-Wertelisten anzuzeigen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99355260431303798)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfragedefinition ein, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias in jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>'),
unistr('<p>Hinweis: Wenn Sie beim Definieren eines Elementtyps "Popup-Werteliste" mehrere Spalten im Popup anzeigen m\00F6chten, m\00FCssen Sie Ihre Werteliste stattdessen mit den erforderlichen zus\00E4tzlichen Metadaten'),
unistr('in "Gemeinsame Komponenten" definieren. Inline-Wertelisten k\00F6nnen nur verwendet werden, um einzelne Spalten f\00FCr Popup-Wertelisten anzuzeigen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99339175064303785)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfragedefinition ein, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias in jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>'),
unistr('<p>Hinweis: Wenn Sie beim Definieren eines Elementtyps "Popup-Werteliste" mehrere Spalten im Popup anzeigen m\00F6chten, m\00FCssen Sie Ihre Werteliste stattdessen mit den erforderlichen zus\00E4tzlichen Metadaten'),
unistr('in "Gemeinsame Komponenten" definieren. Inline-Wertelisten k\00F6nnen nur verwendet werden, um einzelne Spalten f\00FCr Popup-Wertelisten anzuzeigen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558146524303135)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfragedefinition ein, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias in jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>'),
unistr('<p>Hinweis: Wenn Sie beim Definieren eines Elementtyps "Popup-Werteliste" mehrere Spalten im Popup anzeigen m\00F6chten, m\00FCssen Sie Ihre Werteliste stattdessen mit den erforderlichen zus\00E4tzlichen Metadaten'),
unistr('in "Gemeinsame Komponenten" definieren. Inline-Wertelisten k\00F6nnen nur verwendet werden, um einzelne Spalten f\00FCr Popup-Wertelisten anzuzeigen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559416797303136)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfragedefinition ein, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias in jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>'),
unistr('<p>Hinweis: Wenn Sie beim Definieren eines Elementtyps "Popup-Werteliste" mehrere Spalten im Popup anzeigen m\00F6chten, m\00FCssen Sie Ihre Werteliste stattdessen mit den erforderlichen zus\00E4tzlichen Metadaten'),
unistr('in "Gemeinsame Komponenten" definieren. Inline-Wertelisten k\00F6nnen nur verwendet werden, um einzelne Spalten f\00FCr Popup-Wertelisten anzuzeigen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110502797303593)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt Abteilungsname an, legt Abteilungsnummer fest</dt>',
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861511882303385)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfragedefinition ein, um diese Werteliste aufzuf\00FCllen. Im Allgemeinen haben Wertelistenabfragen folgende Form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Jede ausgew\00E4hlte Spalte muss einen eindeutigen Namen oder Alias haben. Oracle empfiehlt, dass Sie einen Alias auf jeder Spalte verwenden, die einen SQL-Ausdruck enth\00E4lt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861474955303384)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861915039303385)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Werte f\00FCr diese statische Werteliste ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861893094303385)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861738992303385)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Wertelistentyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248189634303708)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99248239805303708)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die dynamische Werteliste basiert auf der SQL-Abfrage, die vom eingegebenen Funktionsbody zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733573305303283)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733690453303283)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Werteliste basiert auf einer vordefinierten Werteliste, die in "Gemeinsame Komponenten" definiert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733799848303283)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733881586303283)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>'Die dynamische Werteliste basiert auf der SQL-Abfrage, die Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050310994303545)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050453907303545)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Die statische Werteliste basiert auf dem Textwert, den Sie eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98861643051303385)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530050273303113)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, wie der Sessionzustand beibehalten wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487538320303079)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Pro Anforderung (nur Arbeitsspeicher)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487642168303079)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Speichern Sie den Zustand nicht in der Datenbank. Der Zustand ist nur verf\00FCgbar, wenn die aktuelle Anforderung verarbeitet wird. Wenn AJAX-Anforderungen ein Element verwenden m\00FCssen, achten Sie darauf, den Elementnamen \00FCber "Weiterzuleitende Seitenel')
||unistr('emente" zu \00FCbergeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032443260303530)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'de'
,p_message_text=>unistr('Pro Benutzer (Datentr\00E4ger)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326966742303774)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr einen Benutzer pflegen, indem der Wert in der Datenbank gespeichert wird, um session\00FCbergreifend darauf zuzugreifen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032331668303530)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('Pro Session (Datentr\00E4ger)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326897452303774)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr jede Session pflegen, indem der Wert in der Datenbank gespeichert wird, um anforderungs\00FCbergreifend darauf zuzugreifen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529913253303113)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sessionzustand beibehalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487806661303079)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, wie der Sessionzustand beibehalten wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487984865303079)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Pro Anforderung (nur Arbeitsspeicher)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488009748303079)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Speichern Sie den Zustand nicht in der Datenbank. Der Zustand ist nur verf\00FCgbar, wenn die aktuelle Anforderung verarbeitet wird. Wenn AJAX-Anforderungen ein Element verwenden m\00FCssen, achten Sie darauf, den Elementnamen \00FCber "Weiterzuleitende Seitenel')
||unistr('emente" zu \00FCbergeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488117546303080)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('Pro Session (Datentr\00E4ger)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98488276625303080)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr jede Session pflegen, indem der Wert in der Datenbank gespeichert wird, um anforderungs\00FCbergreifend darauf zuzugreifen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487761452303079)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sessionzustand beibehalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804860215303340)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, ob Grobteilungen gerendert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804970314303340)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805131900303340)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805005134303340)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98804755592303340)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149987019303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149856441303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die F\00FCllfarbe zum Anzeigen eines Punktclusters an.'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149751595303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCllfarbe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149142184303623)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Symbol-CSS-Klassen an, die zum Anzeigen eines Punktclusters verwendet werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149041538303623)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148941994303623)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die URL zu dem Bild an, das zum Anzeigen eines Punktclusters verwendet werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148888003303623)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149337715303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SVG-Form zum Anzeigen eines Punktclusters an. W\00E4hlen Sie eine der vordefinierten Formen aus, oder geben Sie den Namen einer <em>benutzerdefinierten SVG-Form</em> ein, die im Kartenregionsattribut <strong>Benutzerdefinierte SVG-Stile</st')
||unistr('rong> angegeben ist. Wenn der angegebene Name nicht in der Liste der standardm\00E4\00DFigen oder benutzerdefinierten SVG-Stile enthalten ist, wird der <strong>Standardmarker</strong> verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182860162303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'de'
,p_message_text=>'Kamera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190699547303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187472061303653)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'de'
,p_message_text=>'Check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191903067303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182997582303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'de'
,p_message_text=>'Kreis alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190824179303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149548423303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'de'
,p_message_text=>'Kreis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190765833303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182784531303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190580737303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183015345303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'de'
,p_message_text=>'Gesicht Stirnrunzeln'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190996384303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183102709303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'de'
,p_message_text=>'Gesicht ausdruckslos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191033026303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183207421303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Gesicht L\00E4cheln')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191152171303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187999328303654)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'de'
,p_message_text=>'Flagge - Wimpel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192445753303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188068570303654)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'de'
,p_message_text=>'Flagge - Doppelstander'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192597461303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183698219303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'de'
,p_message_text=>'Herz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191699485303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187535900303653)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'de'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192029251303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183756615303651)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCnfeck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191737193303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183454768303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'de'
,p_message_text=>'Pin Kreis'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191448598303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183532154303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'de'
,p_message_text=>'Pin Quadrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191531602303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187784290303654)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'de'
,p_message_text=>'Glanz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192285682303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187677753303654)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schr\00E4gstrich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192110056303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183300018303650)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'de'
,p_message_text=>'Quadrat alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191381355303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149486293303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'de'
,p_message_text=>'Quadrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191215319303656)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187824114303654)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'de'
,p_message_text=>'Street View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99192395767303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149640773303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'de'
,p_message_text=>'Dreieck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99191896357303657)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99149298698303624)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183903867303651)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Skalierungsfaktor f\00FCr die SVG-Form zum Anzeigen eines Punktclusters an. Die maximale Skalierung ist <strong>10</strong>, und die Kartenkomponente rundet den Wert auf die erste Dezimalstelle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99183868715303651)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formskalierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153120655303627)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Der Clusterradius in Pixel. Ist ein Wert von <strong>80</strong> angegeben, werden Punkte innerhalb eines Radius von 80 Pixeln',
'zu einem Punktcluster aggregiert.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153082338303626)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Clustering-Radius'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153267237303627)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173971194303643)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die als QuickInfo angezeigt werden sollen, wenn Sie mit der Maus auf einen Clustermarker auf der Karte zeigen. Verwenden Sie die Platzhalter <strong>&LAYER.</strong> und <strong>&COUNT.</strong>, um den Layernamen un')
||'d die Anzahl der Kartenobjekte im Cluster zu referenzieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173843541303643)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'QuickInfo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139439300303616)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Copyright-Hinweis an, der im Footer der Karte eingef\00FCgt werden soll. Ist dieses Feld leer, wird ein Hinweis f\00FCr die verwendete Hintergrundkarte generiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139357372303616)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Copyright-Hinweis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141191261303617)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141097513303617)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Definitionen f\00FCr benutzerdefinierte SVG-Formen an, die als Kartenmarker verwendet werden k\00F6nnen. Die hier definierten Stile k\00F6nnen als das Attribut <strong>SVG-Form</strong> in einem Punktlayer verwendet werden.</p>'),
unistr('<p>Die SVG-Form muss eine Breite und H\00F6he von jeweils <strong>20</strong> aufweisen. Der Marker wird so auf der Karte positioniert, dass die Mitte der Formunterseite (SVG-Koordinate <strong>10</strong>, <strong>20</strong>) zum Kartenobjekt zeigt.</p')
||'>',
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">SVG-Marker haben eine Breite und H\00F6he von jeweils 20 und zeigen auf die Kartenposition x=10 und y=20.</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140985501303617)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte SVG-Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171644823303641)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die einen Wert zur\00FCckgibt, um die H\00F6he des extrudierten Polygons zu bestimmen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171561431303641)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Extrusionswertspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173313301303642)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Einheit zur Bestimmung der H\00F6he des extrudierten Polygons aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173691113303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Fu\00DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173596241303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'de'
,p_message_text=>'Kilometer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173467829303642)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'de'
,p_message_text=>'Meter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173718195303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'de'
,p_message_text=>'Meile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173268951303642)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Einheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145800612303621)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145791279303621)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die F\00FCllfarbe an.'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145608741303621)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCllfarbe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154623547303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob f\00FCr diesen Layer ein <em>Farbschema</em> verwendet werden soll. Ein Farbschema ist eine Liste von Farben. Basierend auf einem Wert sowie den Mindest- und Maximalwerten w\00E4hlt das Kartenwidget die tats\00E4chliche Anzeigefarbe f\00FCr dieses O')
||'bjekt in der Liste aus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154579568303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbschema verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307433891303758)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Farbliste im Bereich von Rot bis Wei\00DF</dt>'),
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Farbliste im Bereich von Blau bis Schwarz</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154802217303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein benutzerdefiniertes <em>Farbschema</em> f\00FCr diesen Layer an. Ein Farbschema ist eine Liste von Farben. Basierend auf einem Wert sowie den Mindest- und Maximalwerten w\00E4hlt das Kartenwidget die tats\00E4chliche Anzeigefarbe f\00FCr dieses Objekt ')
||'in der Liste aus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154778632303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte Farbliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155053153303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die einen Wert zur Bestimmung der Anzeigefarbe aus dem Schema zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154905501303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbwertspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146052703303621)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die F\00FClltransparenz an. Sie k\00F6nnen aus einem Bereich zwischen Null (vollst\00E4ndig transparent) und 1.0 (nicht transparent) ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145917155303621)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FClltransparenz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155266924303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die den Wert zur Bestimmung der Anzeigefarbe aus dem Schema zur\00FCckgibt. Ist keine Spalte ausgew\00E4hlt, wird die Anzeigefarbe nur durch die Punktdichte bestimmt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155168517303628)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wertspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151058347303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob das Informationsfenster mit Spalten oder mit erweiterter Formatierung unter Verwendung von HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen angezeigt werden soll. Das Informationsfenster wird als Popup angezeigt, wenn Sie au')
||'f ein Objekt auf der Karte klicken.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150949689303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Formatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151480803303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Body f\00FCr das Informationsfenster verwendet werden soll. Das Informationsfenster wird als Popup angezeigt, wenn Sie auf ein Objekt auf der Karte klicken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151356288303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hauptteilspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151999571303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie CSS-Klassen ein, die beim Rendering des Popup-Infofensters verwendet werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151831924303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151746854303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Hintergrund- und Textfarben \00E4ndern</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\00DCberschrift 2 verwenden</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Eine dynamische Klasse aus der SQL-Abfrage verwenden</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&COLUMN_CLASS.</code> und <code>&EMPLOYEE_STATUS.</code> in diesem Beispiel sind Spalten, die in der Berichts-SQL-Abfrage ausgew\00E4hlt werden.</dd>'),
'  <dt>Beim Mouseover ein Bild und eine QuickInfo anzeigen</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151694291303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die als Popup-Infofenster angezeigt werden sollen, wenn Sie auf ein r\00E4umliches Objekt klicken. Verwenden Sie die <code>&COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151559443303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151297271303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Titel f\00FCr das Informationsfenster verwendet werden soll. Das Informationsfenster wird als Popup angezeigt, wenn Sie auf ein Objekt auf der Karte klicken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99151104436303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Titelspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174844686303644)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Label, das f\00FCr die Anzeige in der Legende oder in QuickInfos verwendet wird. Ist kein Wert angegeben, wird das Attribut <strong>Name</strong> verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174665641303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label an, das f\00FCr diesen Layer in der Legende und in QuickInfos verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174540257303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174440475303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174322521303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die F\00FCllfarbe des Markers an.'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174206255303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCllfarbe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174107357303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die F\00FClltransparenz an. Sie k\00F6nnen aus einem Bereich zwischen Null (vollst\00E4ndig transparent) und 1.0 (nicht transparent) ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174092309303643)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FClltransparenz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171952109303641)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171854751303641)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie die Strichfarbe an.',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171726384303641)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Strichfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172117402303641)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Strichbreite an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172085646303641)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Strichbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152149063303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die verwendet werden soll, um Zeilen aus der Regionsquelle diesem Layer zuzuweisen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152078017303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152327427303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie f\00FCr die <strong>Zeilenzuweisungsspalte</strong> den <em>Wert</em> an, der verwendet wird, um Zeilen aus der Regionsquelle diesem Layer zuzuweisen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152220434303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Wert f\00FCr diesen Layer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145319734303620)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145222537303620)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie die Strichfarbe an.',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145127372303620)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Strichfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152520461303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Strichstil an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152886513303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'de'
,p_message_text=>'Gestrichelt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152735651303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'de'
,p_message_text=>'Gepunktet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152902964303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'de'
,p_message_text=>'Strichpunktiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152652852303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'de'
,p_message_text=>'Durchgezogen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99152493902303626)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Strichstil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145500535303621)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Strichbreite an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145469658303621)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Strichbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150125384303624)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die QuickInfo mit einer Spalte oder mit erweiterter Formatierung unter Verwendung von HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen angezeigt werden soll. Die QuickInfo wird angezeigt, wenn Sie mit der Maus auf ein Objekt')
||' auf der Karte zeigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150017790303624)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Formatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150367833303624)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als QuickInfo verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150290886303624)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150821702303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie CSS-Klassen ein, die beim Rendering der QuickInfo verwendet werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150763905303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150646119303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Hintergrund- und Textfarben \00E4ndern</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\00DCberschrift 2 verwenden</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Eine dynamische Klasse aus der SQL-Abfrage verwenden</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&COLUMN_CLASS.</code> und <code>&EMPLOYEE_STATUS.</code> in diesem Beispiel sind Spalten, die in der Berichts-SQL-Abfrage ausgew\00E4hlt werden.</dd>'),
'  <dt>Beim Mouseover ein Bild und eine QuickInfo anzeigen</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150559111303625)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die als QuickInfo angezeigt werden sollen, wenn Sie mit der Maus auf ein Objekt auf der Karte zeigen. Verwenden Sie die <code>&COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99150481853303624)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144437872303620)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte, die GeoJSON-Objekte zur\00FCckgibt, die auf der Karte angezeigt werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144331608303620)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'GeoJSON-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144652984303620)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('SDO_GEOMETRY-Spalte, die Geometrieobjekte zur\00FCckgibt, die auf der Karte angezeigt werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144583731303620)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Geometriespalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143027933303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Datentyp der Geometriespalte an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143338649303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'de'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143499458303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'de'
,p_message_text=>'GeoJSON, als VARCHAR2- oder CLOB-Typen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143547431303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngen-/Breitengrad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143694479303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngen- und Breitengrad als zwei NUMBER-Spalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143189352303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'de'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143231578303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'de'
,p_message_text=>'Oracle-Typ SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142960984303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Geometriespalten-Datentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143855533303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Datentyp der Geometriespalte an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143937735303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'de'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144031081303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'de'
,p_message_text=>'GeoJSON, als VARCHAR2- oder CLOB-Typen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144177871303620)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngen-/Breitengrad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144246190303620)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngen- und Breitengrad als zwei NUMBER-Spalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99143750305303619)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Geometriespalten-Datentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142837117303619)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Aktivieren Sie diese Option, wenn die zugrunde liegende Tabelle einen r\00E4umlichen Index enth\00E4lt, den das Kartenwidget beim Abrufen von Zeilen aus der Datenbank verwenden soll. In diesem Fall ruft das Widget <em>nur</em> Zeilen f\00FCr das aktuelle Kart')
||unistr('enfenster aus der Datenbank ab. Dadurch entsteht ein Performancevorteil, wenn die Datenquelle eine gro\00DFe Anzahl an Zeilen enth\00E4lt.</p><p>Ein r\00E4umlicher Index kann f\00FCr eine SDO_GEOMETRY-Spalte in SQL Workshop erstellt werden.</p>'),
unistr('<p>Hinweis: In folgenden Situationen wird <em>kein</em> r\00E4umlicher Index verwendet:</p>'),
'<ul>',
'<li>Die <strong>Regionsquelle</strong> wird von mehreren Layern als Datenquelle referenziert.</li>',
unistr('<li>Das Kartenfenster ist zu gro\00DF, d.h. es umfasst mehr als die H\00E4lfte der Welt.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142765728303618)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('R\00E4umlichen Index verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99145006819303620)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('NUMBER-Spalte, die den Breitengrad der r\00E4umlichen Objekte enth\00E4lt, die auf der Karte angezeigt werden sollen. Die zur\00FCckgegebenen Werte m\00FCssen zwischen -90 und 90 liegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144944233303620)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Breitengradspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160679578303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eines der vordefinierten divergierenden Farbschemas aus. Diese sind zur Visualisierung divergierender Werte von einem Extrem zu einem anderen geeignet. Farbschemas von CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/carto')
||'color" target="_blank">CARTOcolor auf GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160773679303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Armeegr\00FCn bis rosa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160817707303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161936277303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'de'
,p_message_text=>'Erdfarben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162041055303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160947800303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'de'
,p_message_text=>'Herbstfarben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161014401303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161150765303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'de'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161290092303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161597689303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blaugr\00FCn bis rosa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161638142303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161309717303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'de'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161463214303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161715870303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'de'
,p_message_text=>'Tropische Farben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99161808440303633)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160562962303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162261989303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eines der vordefinierten qualitativen Farbschemas aus. Diese sind zur Visualisierung eindeutiger Werte geeignet. Farbschemas von CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor auf G')
||'itHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162355628303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'de'
,p_message_text=>'Antik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162447322303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162536711303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'de'
,p_message_text=>'Fett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162605321303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162774259303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'de'
,p_message_text=>'Pastell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162810343303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162920936303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'de'
,p_message_text=>'Prisma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163010581303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163191439303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'de'
,p_message_text=>'Sicher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163232037303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163385005303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'de'
,p_message_text=>'Lebhaft'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163440762303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99162143239303634)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156608073303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eines der vordefinierten sequenziellen Farbschemas aus. Diese sind zur Visualisierung sequenzieller Werte von einem niedrigen zu einem hohen Wert geeignet. Farbschemas von CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/c')
||'artocolor" target="_blank">CARTOcolor auf GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158131642303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blau bis gr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158275092303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158774634303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'de'
,p_message_text=>'Blau bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158805616303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160332159303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'de'
,p_message_text=>'Braun bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160499007303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156763173303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'de'
,p_message_text=>'Burgunderrot'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156855129303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156907548303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'de'
,p_message_text=>'Burgunderrot bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157058554303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158310446303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'de'
,p_message_text=>'Dunkelmint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158495597303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158595099303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'de'
,p_message_text=>unistr('Smaragdgr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158677950303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159961970303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'de'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160039779303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157981354303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'de'
,p_message_text=>'Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158063973303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157395264303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'de'
,p_message_text=>'Orange bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157425204303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157506678303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'de'
,p_message_text=>'Pfirsichfarben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157604846303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157720814303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'de'
,p_message_text=>'Rosa bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157870519303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159374605303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'de'
,p_message_text=>'Violett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159480809303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159544309303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'de'
,p_message_text=>'Violett bis orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159698488303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157135387303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'de'
,p_message_text=>'Rot bis orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99157278695303630)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159752701303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'de'
,p_message_text=>'Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159879804303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160195864303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'de'
,p_message_text=>'Dark Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99160277885303632)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99158959426303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blaugr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159083214303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159121090303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blaugr\00FCn bis gr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99159287188303631)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156553246303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175281779303644)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175337257303644)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine durch Komma getrennte Liste der HTML-Farben (#rrggbb) an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155814237303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Farbschematyp aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156162993303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'de'
,p_message_text=>'Divergierend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156250932303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'de'
,p_message_text=>'Dieses Farbschema ist zur Visualisierung divergierender Werte von einem Extrem zu einem anderen geeignet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156329982303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'de'
,p_message_text=>'Qualitativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156435821303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'de'
,p_message_text=>'Dieses Farbschema ist zur Visualisierung eindeutiger Werte geeignet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155986465303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'de'
,p_message_text=>'Sequenziell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99156015593303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Dieses Farbschema ist zur Visualisierung sequenzieller Werte von einem niedrigen zu einem hohen Wert geeignet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155746737303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307882369303758)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Farbliste im Bereich von Rot bis Wei\00DF</dt>'),
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Farbliste im Bereich von Blau bis Schwarz</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171492157303641)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein benutzerdefiniertes <em>Farbschema</em> f\00FCr diesen Heatmap-Layer an. Ein Farbschema ist eine Liste von Farben. Basierend auf einem Wert sowie den Mindest- und Maximalwerten w\00E4hlt das Kartenwidget die tats\00E4chliche Anzeigefarbe f\00FCr dieses')
||' Objekt in der Liste aus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171388647303641)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierte Farbliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168466152303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eines der vordefinierten divergierenden Farbschemas aus. Diese sind zur Visualisierung divergierender Werte von einem Extrem zu einem anderen geeignet. Farbschemas von CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/carto')
||'color" target="_blank">CARTOcolor auf GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168597267303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Armeegr\00FCn bis rosa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168607795303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169768393303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'de'
,p_message_text=>'Erdfarben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169813439303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168745290303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'de'
,p_message_text=>'Herbstfarben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168854980303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168979999303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'de'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169031032303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169317606303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blaugr\00FCn bis rosa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169401385303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169150581303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'de'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169262061303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169516388303639)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'de'
,p_message_text=>'Tropische Farben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169632108303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168315768303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170060893303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eines der vordefinierten qualitativen Farbschemas aus. Diese sind zur Visualisierung eindeutiger Werte geeignet. Farbschemas von CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor auf G')
||'itHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170108730303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'de'
,p_message_text=>'Antik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170294083303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170326515303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'de'
,p_message_text=>'Fett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170432830303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170512960303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'de'
,p_message_text=>'Pastell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170673802303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170741124303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'de'
,p_message_text=>'Prisma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170825888303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99170964606303641)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'de'
,p_message_text=>'Sicher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171022093303641)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171110801303641)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'de'
,p_message_text=>'Lebhaft'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99171203101303641)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99169943519303640)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164409472303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eines der vordefinierten sequenziellen Farbschemas aus. Diese sind zur Visualisierung sequenzieller Werte von einem niedrigen zu einem hohen Wert geeignet. Farbschemas von CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/c')
||'artocolor" target="_blank">CARTOcolor auf GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165966875303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blau bis gr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166015935303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166553847303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'de'
,p_message_text=>'Blau bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166663124303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168183762303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'de'
,p_message_text=>'Braun bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168290271303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164546875303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'de'
,p_message_text=>'Burgunderrot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164603229303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164740018303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'de'
,p_message_text=>'Burgunderrot bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164859081303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166142462303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'de'
,p_message_text=>'Dunkelmint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166293042303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166353465303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'de'
,p_message_text=>unistr('Smaragdgr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166415301303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167783708303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'de'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167819648303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165740099303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'de'
,p_message_text=>'Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165872293303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165155952303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'de'
,p_message_text=>'Orange bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165221642303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165385442303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'de'
,p_message_text=>'Pfirsichfarben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165468930303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165534138303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'de'
,p_message_text=>'Rosa bis gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165682453303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167184258303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'de'
,p_message_text=>'Violett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167249899303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167300406303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'de'
,p_message_text=>'Violett bis orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167477807303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164908928303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'de'
,p_message_text=>'Rot bis orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99165045301303636)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167516007303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'de'
,p_message_text=>'Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167635093303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167939785303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'de'
,p_message_text=>'Dark Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99168037932303638)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166704481303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blaugr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166849583303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99166965304303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'de'
,p_message_text=>unistr('Blaugr\00FCn bis gr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99167078704303637)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'de'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164357136303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175497268303644)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175528153303644)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine durch Komma getrennte Liste der HTML-Farben (#rrggbb) an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163603447303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Farbschematyp aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163992968303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'de'
,p_message_text=>'Divergierend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164026715303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'de'
,p_message_text=>'Dieses Farbschema ist zur Visualisierung divergierender Werte von einem Extrem zu einem anderen geeignet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164107198303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'de'
,p_message_text=>'Qualitativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99164267942303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'de'
,p_message_text=>'Dieses Farbschema ist zur Visualisierung eindeutiger Werte geeignet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163704714303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'de'
,p_message_text=>'Sequenziell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163805683303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Dieses Farbschema ist zur Visualisierung sequenzieller Werte von einem niedrigen zu einem hohen Wert geeignet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99163562544303635)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Farbschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153422073303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Typ dieses Layers an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154162970303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'de'
,p_message_text=>'Heatmap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154255317303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'de'
,p_message_text=>'Punktobjekte, die als Heatmap angezeigt werden. Heatmaps sind zur Visualisierung der Dichte von Punktobjekten hilfreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153742781303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'de'
,p_message_text=>'Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153811827303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'de'
,p_message_text=>'Linienobjekte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153551376303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'de'
,p_message_text=>'Punkte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153639870303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'de'
,p_message_text=>'Punktobjekte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153940100303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'de'
,p_message_text=>'Polygone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154086429303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'de'
,p_message_text=>'Polygonobjekte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154367477303628)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'de'
,p_message_text=>'Extrudierte Polygone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99154497106303628)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('"Extrudierte" Polygone als 3D-Objekte. Die H\00F6he basiert auf einem Ergebnisspaltenwert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99153312915303627)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ebenentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155643093303629)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den maximalen Zoomfaktor an, damit dieser Layer sichtbar bleibt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155525905303628)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Maximal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155438901303628)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den minimalen Zoomfaktor an, damit dieser Layer sichtbar wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99155305696303628)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Minimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144844061303620)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('NUMBER-Spalte, die den L\00E4ngengrad der r\00E4umlichen Objekte enth\00E4lt, die auf der Karte angezeigt werden sollen. Die zur\00FCckgegebenen Werte m\00FCssen zwischen -180 und 180 liegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99144709392303620)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngengradspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148788367303623)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'de'
,p_message_text=>'Gibt an, ob zusammen positionierte Punkte auf der Karte geclustert werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148605131303623)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146264434303621)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Gibt an, wie Punktobjekte angezeigt werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146591236303621)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'de'
,p_message_text=>'Symbol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146624613303622)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'de'
,p_message_text=>'Anzeige als Symbol.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146334279303621)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'de'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146471301303621)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'de'
,p_message_text=>'Anzeige als SVG-Form.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146138681303621)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148209397303623)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SVG-Form zum Anzeigen von Punktobjekten an. W\00E4hlen Sie eine der vordefinierten Formen aus, oder geben Sie den Namen einer der <em>benutzerdefinierten SVG-Formen</em> ein, die im Kartenregionsattribut <strong>Benutzerdefinierte SVG-Stile')
||unistr('</strong> angegeben sind. Wenn kein Name angegeben ist oder der angegebene Name nicht in der Liste der standardm\00E4\00DFigen oder benutzerdefinierten SVG-Formen enthalten ist, wird die <strong>Standardform</strong> verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181529335303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'de'
,p_message_text=>'Kamera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188582897303654)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186799841303653)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'de'
,p_message_text=>'Check'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189847268303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181665536303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'de'
,p_message_text=>'Kreis alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188739735303654)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148460071303623)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'de'
,p_message_text=>'Kreis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188685692303654)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181434570303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188445493303654)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181715780303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'de'
,p_message_text=>'Gesicht Stirnrunzeln'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188890448303654)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181845027303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'de'
,p_message_text=>'Gesicht ausdruckslos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99188916574303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99181927846303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Gesicht L\00E4cheln')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189066796303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187276925303653)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'de'
,p_message_text=>'Flagge - Wimpel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190322898303656)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187352988303653)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'de'
,p_message_text=>'Flagge - Doppelstander'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190497346303656)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182334072303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'de'
,p_message_text=>'Herz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189564742303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186812333303653)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'de'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189918110303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182467023303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCnfeck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189681945303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182197533303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'de'
,p_message_text=>'Pin Kreis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189360835303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182238915303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'de'
,p_message_text=>'Pin Quadrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189454090303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187031212303653)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'de'
,p_message_text=>'Glanz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190117363303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186964740303653)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schr\00E4gstrich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190065704303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182022762303649)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'de'
,p_message_text=>'Quadrat alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189298126303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148342640303623)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'de'
,p_message_text=>'Quadrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189174482303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99187191229303653)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'de'
,p_message_text=>'Street View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99190211186303656)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148502451303623)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'de'
,p_message_text=>'Dreieck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99189700256303655)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'de'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148167222303623)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182698535303650)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Skalierungsfaktor f\00FCr die SVG-Form an. Die maximale Skalierung ist <strong>10</strong>. Wenn eine Spaltenersetzung verwendet wird und der Wert gr\00F6\00DFer ist als <strong>10</strong>, wird eine Nachricht an die JavaScript-Konsole geschrieben')
||', und der Marker wird mit einem Skalierungsfaktor von <strong>10</strong> angezeigt. Die Kartenkomponente rundet den Wert auf die erste Dezimalstelle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99182528172303650)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formskalierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147655398303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die Symbol-CSS-Klassen enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147543393303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbolspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99148079567303623)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen, die als Symbolquelle verwendet werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147932448303623)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol-CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147887049303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die URL f\00FCr die Bildquelle ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147799206303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bild-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146884707303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Quelle f\00FCr das Symbol aus, um den Punkt auf der Karte anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147194416303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'de'
,p_message_text=>'Symbolklassenspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147229412303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verwenden Sie individuelle CSS-Klassen f\00FCr die einzelnen Zeilen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146968503303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'de'
,p_message_text=>'Symbolklasse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147028194303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verwenden Sie eine statische CSS-Klasse f\00FCr alle Zeilen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147310580303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'de'
,p_message_text=>'Bild-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99147422019303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('URL zu einem Bild, das f\00FCr die Anzeige von Punkten verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99146710217303622)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbolquelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137655296303614)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'de'
,p_message_text=>'Aktivieren oder deaktivieren Sie verschiedene Widgetfeatures der Karte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138782029303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'de'
,p_message_text=>'Browserposition abrufen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138875805303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'de'
,p_message_text=>'Rufen Sie die aktuelle Position des Benutzers vom Browser ab.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138990308303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'de'
,p_message_text=>'Kreistool'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139098409303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Mit dem Kreistool k\00F6nnen Endbenutzer einen Kreis auf die Karte zeichnen. Wenn der Vorgang abgeschlossen ist, wird ein Ereignis ausgel\00F6st, sodass der Kreis von dynamischen Aktionen oder JavaScript-Code verarbeitet werden kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139197734303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'de'
,p_message_text=>'Entfernungstool'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139244161303616)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Erm\00F6glicht Endbenutzern das Messen von Entfernungen zwischen Punkten auf der Karte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138564331303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'de'
,p_message_text=>'Endloskarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138604005303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'de'
,p_message_text=>'Endloses Kartenscrolling.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137788516303614)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'de'
,p_message_text=>'Mausradzoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137872559303614)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verkleinern oder vergr\00F6\00DFern Sie mit dem Mausrad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138302058303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Karten\00FCbersicht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138488927303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigen Sie unten rechts eine \00DCbersichtskarte an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137956089303614)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'de'
,p_message_text=>'Rechteckzoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138039071303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'de'
,p_message_text=>'Zoomen Sie die Karte in einen Bereich, indem Sie ein Rechteck auf die Karte ziehen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138113452303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'de'
,p_message_text=>unistr('Ma\00DFstabsleiste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99138255033303615)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigen Sie eine Ma\00DFstabsleiste auf der Karte an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99137595501303614)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Optionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142527612303618)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die H\00F6he der Kartenregion an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142496372303618)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142653746303618)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140879378303617)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie CSS-Klassen ein, die zur Legende hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140763220303617)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140667234303617)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('jQuery-Selektor f\00FCr das Element, in dem die Legende angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140532485303617)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139887654303616)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Position der Legende an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140136374303616)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140256025303616)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Legende an der Endposition (in der Regel unter der Karte) an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140343221303616)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'de'
,p_message_text=>'Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140484634303617)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen jQuery-Selektor f\00FCr das Element an, in dem die Legende angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139976070303616)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99140008004303616)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt die Legende an der Startposition (in der Regel \00FCber der Karte) an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139764177303616)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174734485303643)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307605614303758)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Layermeldungen nicht anzeigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141367819303617)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, wo die Meldungen "Keine Daten gefunden" und "Wenn weitere Daten gefunden werden" f\00FCr den Kartenlayer angezeigt werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141424586303617)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141526784303617)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Meldungen \00FCber der Karte anzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141650841303618)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'de'
,p_message_text=>'Unter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141771440303618)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'de'
,p_message_text=>'Meldungen unter der Karte anzeigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141808434303618)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'de'
,p_message_text=>'Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141904401303618)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen jQuery-Selektor f\00FCr das Element an, in dem die Nachrichten angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99141265151303617)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Meldungsposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142101141303618)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('jQuery-Selektor f\00FCr das Element, in dem die Nachrichten angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142049746303618)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nachrichtenselektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139650393303616)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob eine Legende angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99139529872303616)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142393332303618)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn Sie ein Seitenelement ausw\00E4hlen, beh\00E4lt die Kartenregion immer den Begrenzungsrahmen der aktuellen Karte, im GeoJSON-Format, als Wert dieses Elements bei. Dies ist hilfreich, um die Karte mit einer weiteren APEX-Komponente (z.B. einem klassis')
||unistr('chen oder interaktiven Bericht) zu verbinden: Der Inhalt des Begrenzungsrahmenelements kann von der anderen Komponente verwendet werden, um eine r\00E4umliche Abfrage auszuf\00FChren und nur auf der Karte sichtbare Daten anzuzeigen.</p>'),
unistr('<p>Beispiel f\00FCr den Inhalt des Begrenzungsrahmenelements nach einer Kartenverschiebung oder einer \00C4nderung des Zoomfaktors:</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('Mit der dynamischen Aktion <strong>Aktualisieren</strong> kann die Karte mit einer Berichtsregion verbunden werden. Die Berichtsregion kann einen r\00E4umlichen Filter anwenden, damit nur die Ergebnisse angezeigt werden, die auch auf der Karte sichtbar s')
||'ind.</p>',
unistr('<p>Beispiel f\00FCr eine Berichtsabfrage:</p>'),
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column], ',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] ) ',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99142235892303618)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Begrenzungsrahmenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172357331303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Einheitensystem aus, das f\00FCr die Ma\00DFstabsleiste und das Entfernungstool verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172630280303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'de'
,p_message_text=>'Imperial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172708793303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwenden Sie das imperiale System.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172868517303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Von Element ableiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172933233303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie das Einheitensystem von dem Wert eines Seiten- oder Anwendungselements ab.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172458338303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'de'
,p_message_text=>'Metrik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172591426303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwenden Sie das metrische System.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99172216547303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Einheitensystem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173150234303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Seiten- oder Anwendungselement ein, das den Wert enth\00E4lt, der als Einheitensystem f\00FCr die Karte verwendet werden soll: <strong>METRIC</strong> (<strong>M</strong>) oder <strong>IMPERIAL</strong> (<strong>I</strong>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99173079914303642)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Einheitensystemelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799887652303336)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob ein Marker auf den Datenelementen des Diagramms gerendert werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799956763303336)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800139615303337)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800085205303336)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98799791310303336)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800398766303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Form des Markers, der auf den Datenelementen des Diagramms gerendert werden soll. Nur <strong>Auto</strong> wird bei Bereichsdatenreihen unterst\00FCtzt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800437045303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800513872303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'de'
,p_message_text=>'Kreis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800634571303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'de'
,p_message_text=>'Raute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800765043303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'de'
,p_message_text=>'Person'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800804053303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'de'
,p_message_text=>'Plus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800998527303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'de'
,p_message_text=>'Quadrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98826198136303357)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'de'
,p_message_text=>'Stern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801063160303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'de'
,p_message_text=>'Dreieck nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98801111051303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'de'
,p_message_text=>'Dreieck nach oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98800265993303337)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916220029303429)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn diese Spalte eine Fremdschl\00FCsselspalte f\00FCr die interaktive Grid-Masterregion ist, wie mit <strong>Masterregion</strong> in den "Erweiterten Einstellungen" der Region angegeben, w\00E4hlen Sie die entsprechende Prim\00E4rschl\00FCsselspalte aus der Master')
||'tabelle aus.</p>',
unistr('        <p>Beispiel: Wenn die Masterregion DEPT und dieses interaktive Grid EMP w\00E4re, w\00FCrden Sie die Spalte DEPTNO in dem interaktiven EMP-Grid und danach die DEPTNO-Spalte aus der Liste der DEPT-Spalten f\00FCr die Masterspalte ausw\00E4hlen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916157421303429)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Masterspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98734090605303283)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Masterregion, zu der diese Detailregion geh\00F6rt.<br>'),
'        Dies muss festgelegt werden, wenn diese Region die Detailregion in einer Master/Detail-Beziehung mit einer anderen Region auf dieser Seite ist.</p>',
unistr('        <p>Damit die Master/Detail-Beziehung ordnungsgem\00E4\00DF funktioniert, w\00E4hlen Sie die Spalten in dieser Region, bei denen es sich um Fremdschl\00FCssel f\00FCr die Masterregion handelt, und geben Sie die <strong>Masterspalte</strong> entsprechend an.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98733960955303283)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Masterregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845983954303372)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die H\00F6chstanzahl von Zeilen ein, die im Selektor "Zeilen pro Seite" angezeigt werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845803468303372)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Max. Zeilen pro Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177402131303646)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die maximale Anzahl der Zeilen ein, die f\00FCr diesen Layer verarbeitet werden kann. Dieser Wert kann als Ma\00DFeinheit verwendet werden, wenn zu viele r\00E4umliche Objekte heruntergeladen und auf der Karte angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845145152303371)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die maximale Anzahl von Zeilen ein, die von der Abfrage verarbeitet werden k\00F6nnen. Wenn die maximale Anzahl von zu verarbeitenden Zeilen den Grenzwert \00FCberschreitet, wird eine Fehlermeldung anstelle von Daten angezeigt.'),
'Eine benutzerdefinierte Meldung kann definiert werden, indem eine Meldung in <strong>Wenn weitere Daten gefunden werden</strong> angegeben wird.</p>',
unistr('<p>Dieses Attribut soll verhindern, dass Endbenutzer Aktionen, wie Sortiervorg\00E4nge oder Aggregationen mit allen Datens\00E4tzen in sehr gro\00DFen Tabellen oder Views ausf\00FChren, die m\00F6glicherweise nicht performant sind.'),
unistr('Stattdessen muss die Anzahl von zu verarbeitenden Datens\00E4tzen zuerst reduziert werden, indem zus\00E4tzliche Filter hinzugef\00FCgt werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845007670303371)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Maximal zu verarbeitende Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211595712303672)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Komponente in einer Spalte oder mit erweiterter Formatierung mit HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211406015303672)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Formatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219390720303678)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Auto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213934323303674)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmt das Seitenverh\00E4ltnis f\00FCr die Medien.'),
unistr('<strong>Auto</strong> Passt die Gr\00F6\00DFe dem Originalmedienformat an.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214082752303674)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'de'
,p_message_text=>'Quadrat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214145642303674)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wendet ein quadratisches Seitenverh\00E4ltnis an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214249285303674)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'de'
,p_message_text=>'Breitbild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214399546303675)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wendet ein Breitbild-Seitenverh\00E4ltnis an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213888568303674)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Darstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212978250303673)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die das BLOB f\00FCr die Medienquelle zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212818080303673)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'BLOB-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215122579303675)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215088932303675)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215310957303675)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Dieser Text beschreibt die Medien und kann f\00FCr QuickInfos und alternativen Text f\00FCr Bilder verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99215294238303675)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bildbeschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213143063303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Bestimmt die Position der Medienkomponente auf der Karte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213650163303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'de'
,p_message_text=>'Als Hintergrundbild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213725354303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'de'
,p_message_text=>'Medien werden als Kartenhintergrund angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213476787303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'de'
,p_message_text=>'Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213556290303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'de'
,p_message_text=>'Medien werden im Kartenhauptteil angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213209920303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'de'
,p_message_text=>'Davor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213306953303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'de'
,p_message_text=>'Medien werden vor dem Kartenheader angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99213073566303674)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211848006303673)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Hintergrund- und Textfarbe \00E4ndern</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\00DCberschrift 2 verwenden</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Eine dynamische Klasse aus der SQL-Abfrage verwenden</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&COLUMN_CLASS.</code> und <code>&EMPLOYEE_STATUS.</code> in diesem Beispiel sind in der Berichts-SQL-Abfrage ausgew\00E4hlte Spalten.</dd>'),
'  <dt>Beim Mouseover ein Bild und ein QuickInfo anzeigen</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211775275303673)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die in dieser Spalte angezeigt werden sollen. Verwenden Sie die <code>&COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211664325303672)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214533699303675)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Bestimmt die Gr\00F6\00DFe der Medien in der Medienkomponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214894158303675)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'de'
,p_message_text=>'Deckungsgleich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214928999303675)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Passt die Gr\00F6\00DFe so an, dass die Medien den Medienanzeigebereich ausf\00FCllen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214683649303675)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'de'
,p_message_text=>'Anpassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214767959303675)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Passt die Gr\00F6\00DFe so an, dass die Medien in den Medienanzeigebereich passen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99214474116303675)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Skalierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99219200297303678)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Keine Medien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212053409303673)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Medienquellentyp aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212339645303673)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'de'
,p_message_text=>'BLOB-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212273907303673)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'de'
,p_message_text=>'URL-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212186379303673)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'de'
,p_message_text=>'Bild-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99211936124303673)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509612790303097)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Internet-Medientyp ein. Bei einem Internet-Medientyp handelt es sich um eine zweiteilige ID f\00FCr Dateiformate im Internet. '),
'Ein Medientyp setzt sich mindestens aus zwei Teilen zusammen: einem Typ, einem Subtyp sowie mindestens einem optionalen Parameter. ',
'Dieser Medientyp wird im Content-Type-HTTP-Header beim Seitenrendering verwendet. ',
unistr('<p>Der Medientyp auf Seitenebene setzt den Medientyp auf Anwendungsebene au\00DFer Kraft. '),
unistr('Wenn die Werte auf Seitenebene und Anwendungsebene f\00FCr den Medientyp <code>NULL</code> sind, wird der Medientyp <code>text</code> oder <code>html</code> verwendet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509535080303097)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Medientyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212528685303673)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die URL f\00FCr die Medienquelle ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212423765303673)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212761727303673)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Medienquelle verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99212602689303673)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'URL-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805796284303341)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Inkrement zwischen Feinteilungen an. Ist standardm\00E4\00DFig null bei der automatischen Berechnung basierend auf den Daten. Gilt nur f\00FCr numerische Achsen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805668906303341)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805577152303341)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob Feinteilungen gerendert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805493840303341)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805309268303341)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie das minimale Inkrement zwischen Grobteilungen ein. Dies wird im Allgemeinen verwendet, um Bruchachsenwerte bei diskreten Kennzahlen zu verhindern.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805289839303340)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Minimaler Schritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225323230303683)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen des Anwendungsprozesses an, damit dieser von Entwicklern schnell ermittelt werden kann.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606808852303173)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen ein, den Anwendungsentwickler zur Referenzierung dieses Authentifizierungsschemas verwenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546364398303126)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen eindeutigen Namen ein, der dieses Autorisierungsschema angibt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620018615303183)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen der Verzweigung ein, damit diese von Entwicklern schnell identifiziert werden kann.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656924087303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses Navigationspfadtemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546268519303126)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Namen f\00FCr diese Erstelloption ein. Erstelloptionen sind vordefinierte Einstellungen, die bestimmen, ob Komponenten innerhalb einer Anwendung aktiviert sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656679070303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses Schaltfl\00E4chentemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657042174303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses Kalendertemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546917995303127)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen der dynamischen Aktion ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656702510303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses Elementtemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98843179206303370)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen der Spaltengruppe an. Dieser wird als Regionsheader in der detaillierten Ansicht angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656867236303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses Listentemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176991084303645)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagef\00E4higen Namen f\00FCr diese Komponente ein. Verwenden Sie das Attribut <strong>Label</strong>, falls HTML oder Ersetzungen f\00FCr die Anzeige des Labels in der Kartenregion erforderlich sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546433985303126)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen der aktuellen Seite ein. Dieser Name wird in zahlreichen Seiten und Berichten von &PRODUCT_NAME. zusammen mit der Seitennummer und der Seiten\00FCberschrift verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546779781303127)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen der Seitengruppe ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547556013303127)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Namen des Seitenprozesses an, damit dieser von Entwicklern schnell ermittelt werden kann.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656420783303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses spezifische Seitentemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656529858303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses Regionstemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657112229303212)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr dieses Berichtstemplate ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656327502303211)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine kurze Beschreibung f\00FCr dieses Theme ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657246137303212)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Namen f\00FCr diese Benutzeroberfl\00E4che ein. Der Name wird in Assistenten angezeigt, wie dem Assistenten zum Erstellen vom Themes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619726955303183)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen f\00FCr die Validierung ein. Dieser Name muss aussagekr\00E4ftig sein, sodass Entwickler gepr\00FCfte Bedingungen einfach identifizieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506431513303094)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen aussagekr\00E4ftigen Namen f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98506311834303094)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521473018303106)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Namen einer vorhandenen Werteliste aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521398359303106)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133336086303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position der Navigationsleiste auf der Karte aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133644782303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133739349303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Navigationsleiste an der Endposition (in der Regel rechts neben der Karte) an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133441226303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133568776303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Navigationsleiste an der Startposition (in der Regel links neben der Karte) an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133201633303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Navigationsleistenposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132593129303610)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Typ der zu verwendenden Navigationsleiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133080236303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'de'
,p_message_text=>'Zoom und Kompass'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99133199353303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'de'
,p_message_text=>'Zoomsteuerelemente und Kompass zur Steuerung der Kartenausrichtung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132605027303610)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132760792303610)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'de'
,p_message_text=>'Keine Navigationsleiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132838956303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'de'
,p_message_text=>'Nur Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132929498303611)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Nur Steuerelemente zum Verkleinern und Vergr\00F6\00DFern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132444933303610)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389540908303826)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FCliste nicht anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646493781303203)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Navigationsmen\00FCliste, die zur Navigation auf dieser Seite verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646358458303203)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389041994303826)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position f\00FCr die Navigationsmen\00FCliste auf dieser Seite aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389281631303826)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389168670303826)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99388905340303826)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Listenposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646635413303204)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Navigationsmen\00FClisten-Template, das mit der Navigationsmen\00FCliste auf dieser Seite verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646572364303204)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Listentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389478643303826)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>W\00E4hlen Sie Templateoptionen aus, um die Benutzeroberfl\00E4che dieser Navigationsliste anzupassen.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99389318450303826)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Templateoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202602460303665)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Nach rechts zeigendes Chevron anzeigen</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202598291303665)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Klassen f\00FCr das Symbol ein, das Sie zu der Komponente hinzuf\00FCgen m\00F6chte. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.</p>'),
unistr('        <p>Wenn Ihr Theme Font APEX verwendet, pr\00FCfen Sie <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>. Diese Beispielanwendung enth\00E4lt verf\00FCgbare Symbole und Modifikatoren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99202439960303665)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Symbol "Keine Daten gefunden"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386701068303824)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der innerhalb der NULL-Option der Liste oben in der Liste angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195149081303659)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der innerhalb der NULL-Option der Liste oben in der Liste angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558259704303135)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der innerhalb der NULL-Option der Liste oben in der Liste angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559568188303136)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der innerhalb der NULL-Option der Liste oben in der Liste angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522027431303107)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der innerhalb der NULL-Option am Anfang der Liste angezeigt werden soll. Dieser Wert wird auch beim Rendering des Elements angezeigt, wenn der Wert Null ist. Wenn Sie keinen Text eingeben, wird der Wert als leere Zeile in der '
||'Liste und als leeres Element bei der Wiedergabe angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98521943852303107)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Null-Anzeigewert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522282704303107)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der zur\00FCckgegeben werden muss, wenn der NULL-Wert in dieser Werteliste ausgew\00E4hlt wird. Wenn Sie keinen Wert angeben, bleibt der Elementwert Null, wenn die NULL-Option aus der Liste ausgew\00E4hlt wird. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98522140658303107)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Null-R\00FCckgabewert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880432685303400)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Anzahl der Berichtszeilen ein, die pro Seite angezeigt werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880379672303400)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880618031303400)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Element, dessen Wert die Anzahl von Berichtszeilen angibt, die pro Berichtsseite angezeigt werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880501177303400)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880260968303400)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie die Anzahl von Zeilen f\00FCr diesen Bericht eingegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060542437303553)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Basierend auf Elementwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060484475303553)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880100017303400)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Zeilen - Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517399351303103)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein URL-Ziel f\00FCr den Fall ein, in dem ein Endbenutzer eine zweite Seitenweiterleitung versucht. &PRODUCT_NAME. zeigt eine Fehlermeldung und einen Link zu dieser URL an, damit der Benutzer fortfahren kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98517222680303103)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bei mehrfach vorhandenen Seitenweiterleitungen navigieren zu URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908663798303423)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Seite oder URL die aktuelle Seite ersetzt oder in einem Dialog ge\00F6ffnet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067972404303559)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'de'
,p_message_text=>'Dialog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067897815303559)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'de'
,p_message_text=>'Selbes Fenster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98908554897303423)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Link \00F6ffnen in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832473735303361)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Vorgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721343288303272)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Beim Zugriff auf die Tabelle <code>employee</code> versuchen, den Index <code>emp_department_ix</code> zu verwenden</dt>',
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
'<dt>Die Verwendung der Klausel <code>WITH plsql_declarations</code> in der SQL-Abfrage aktivieren</dt>',
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721218013303272)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Oracle Optimizer-Hinweis ein, der beim Ausf\00FChren der SQL-Abfrage der obersten Anweisung hinzugef\00FCgt wird.'),
unistr('        Ein Hinweis ist eine Anweisung f\00FCr den Optimizer. Wenn Sie SQL schreiben, haben Sie m\00F6glicherweise Informationen zu den Daten, die dem Optimizer unbekannt sind. Mit Hinweisen k\00F6nnen Sie Entscheidungen treffen, die normalerweise vom Optimizer ')
||'getroffen werden.',
unistr('        Dadurch w\00E4hlt der Optimizer in manchen F\00E4llen einen Plan aus, den er eigentlich als teurer ansieht.</p>'),
unistr('        <p>Beispiel: Angenommen Sie wissen, dass ein bestimmter Index f\00FCr gewisse Abfragen selektiver ist. Aufgrund dieser Informationen sind Sie m\00F6glicherweise in der Lage, einen effizienteren Ausf\00FChrungsplan auszuw\00E4hlen als der Optimizer.'),
unistr('        Verwenden Sie in einem solchen Fall Hinweise, um den Optimizer zur Verwendung des optimalen Ausf\00FChrungsplans zu zwingen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721111246303272)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Optimizer-Hinweis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393738632303830)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie eine Spalte aus, die von einem Oracle Text-Index indexiert ist.</p>'),
unistr('<p>Die Zeilensuche gibt Ergebnisse basierend auf dem eingegebenen Oracle Text-Operator zur\00FCck, vorausgesetzt der entsprechende Oracle Text-Index wurde f\00FCr die Spalte erstellt.'),
'Diese Option darf nur aktiviert werden, wenn der erforderliche Index vorhanden ist und die Endbenutzer in der Verwendung der Oracle Text-Suchoperatoren geschult wurden.',
unistr('Um die Oracle Text-Syntax f\00FCr Endbenutzer zu vereinfachen, k\00F6nnen Sie eine Funktion f\00FCr die Komponenteneinstellung <em>Oracle Text-PL/SQL-Funktionsname</em> f\00FCr interaktive Grids in gemeinsamen Komponenten angeben.<br>'),
unistr('Siehe <a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Entwicklerhandbuch f\00FCr Oracle Text-Anwendung</a>.</p>'),
unistr('<p>Hinweis: Wenn Endbenutzer die Oracle Text-Operatoren ordnungsgem\00E4\00DF eingeben, sollte sich die Performance der Suche wesentlich verbessern.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393603289303830)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Oracle Text-Indexspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225002957303683)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bereinigungscode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224902379303683)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Initialisierungscode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783678165303324)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Ausrichtung dieses Diagramms.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783745193303324)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'de'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914399183303428)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Datenelemente des Diagramms horizontal an. Beispiel: Die Balken in einem Balkendiagramm werden horizontal angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914109725303428)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'de'
,p_message_text=>'Vertikal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914259731303428)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Datenelemente des Diagramms vertikal an. Beispiel: Die Balken in einem Balkendiagramm werden vertikal angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783599480303324)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793555441303331)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die H\00F6he der \00DCberblicksbildlaufleiste in Pixel (z.B. 50 px) oder Prozent (z.B. 15 %) ein, die in dem Diagramm gerendert werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793417808303331)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793345135303331)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob eine \00DCberblicksbildlaufleiste in dem Diagramm gerendert werden soll.'),
unistr('        Aktuell wird diese Option nur bei vertikalen Balken-, Linien-, Fl\00E4chen-, Aktien- und Kombinationsdiagramme sowie Linien-/Fl\00E4chendiagrammen unterst\00FCtzt.</p>'),
unistr('        <p>Hinweis: Die Option <strong>Zoomen und scrollen</strong> muss aktiviert sein, damit die \00DCberblicksbildlaufleiste angezeigt wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98793271454303331)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646273315303203)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die Standardnavigation auf Benutzeroberfl\00E4chenebene \00FCberschrieben wird. Dies kann verwendet werden, wenn keine Navigation f\00FCr die aktuelle Seite gew\00FCnscht wird, oder wenn eine alternative Navigation f\00FCr die aktuelle Seite ausgew\00E4hlt ')
||'werden soll (beispielsweise eine andere Navigation um einen Unterabschnitt Ihrer App).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98646172489303203)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chenebene \00FCberschreiben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516961054303103)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, welcher Schutz f\00FCr den Sessionzustand f\00FCr diese Seite implementiert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018194825303518)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'de'
,p_message_text=>unistr('Argumente m\00FCssen Pr\00FCfsumme haben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018203290303518)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Argumente "Anforderung", "Cacheinhalt l\00F6schen" oder "Name/Wert-Paare" in der URL angezeigt werden, muss auch eine Pr\00FCfsumme angegeben werden.<br>'),
unistr('Der Pr\00FCfsummentyp muss mit dem stringentesten Attribut f\00FCr den <em>Sessionzustandsschutz</em> aller Elemente kompatibel sein, die als Argumente \00FCbergeben werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018528346303519)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'de'
,p_message_text=>'Kein URL-Zugriff'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018654529303519)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Auf die Seite kann nicht mit einer URL zugegriffen werden.<br>',
'Die Seite kann jedoch das Ziel eines Verzweigungstyps <em>Zu Seite verzweigen</em> sein, weil dabei keine URL-Umleitung erfolgt.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017959642303518)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>unistr('Uneingeschr\00E4nkt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018046088303518)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite kann mit einer URL, mit oder ohne Sessionzustandsargumente und ohne eine erforderliche Pr\00FCfsumme angefordert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018364147303519)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Argumente unterst\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99018421152303519)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Eine URL kann zur Anforderung der Seite verwendet werden, die URL darf jedoch die Argumente "Anforderung", "Cacheinhalt l\00F6schen" oder "Name/Wert-Paar" nicht enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516824120303103)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schutz f\00FCr den Seitenzugriff')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507855145303095)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie einen alphanumerischen Aliasnamen f\00FCr diese Seite ein. Sie k\00F6nnen den Aliasnamen verwenden, um statt einer Seitennummer eine Seite zu referenzieren. '),
unistr('Wenn Sie beispielsweise bei Seite 1 von Anwendung 100 sind, k\00F6nnen Sie den Aliasnamen <code>home</code> erstellen. '),
unistr('Sie k\00F6nnen dann anschlie\00DFend von anderen Seiten aus \00FCber folgende f?p-Syntax auf diese Seite zugreifen:'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507752599303095)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitenalias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516573419303102)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob diese Seite \00F6ffentlich ist oder eine Authentifizierung erfordert.'),
unistr('Wenn es sich um eine \00F6ffentliche Seite handelt, kann sie von jedem Benutzer angezeigt werden, der auf die Seite zugreift.'),
unistr('Die Seiten-Sentry-Funktion der Anwendung kann auf dieses Seitenattribut zugreifen, um Seiten zu ermitteln, die ohne vorherige Authentifizierung angezeigt werden k\00F6nnen.'),
unistr('Die Implementierung der Seiten-Sentry-Funktion f\00FCr das Authentifizierungsschema bestimmt, ob dieses Attribut wirksam ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017319421303518)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite ben\00F6tigt Authentifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99017445965303518)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite ist \00F6ffentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98516481903303102)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508087317303095)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die Seitengruppe an, die Sie dieser Seite zuordnen m\00F6chten. '),
'Seitengruppen wirken sich nicht auf die Funktionen aus, sondern helfen Entwicklern bei der Verwaltung von Seiten innerhalb einer Anwendung.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98507912566303095)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515588772303102)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie Text ein, durch den die <code>#ONLOAD#</code>-Ersetzungszeichenfolge des Seitentemplate ersetzt werden soll. Damit dieses Feature verwendet werden kann, muss das Seitentemplate die <code>#ONLOAD#</code>#-Ersetzungszeichenfolge enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98515410305303101)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seiten-HTML-Body-Attribut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508280233303096)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Seitenmodus f\00FCr diese Seite.</p>'),
'#LOV_VALUES#',
unistr('<p>Die Optionen <em>Modales</em> und <em>Nicht-modales Dialogfeld</em> k\00F6nnen nur ausgew\00E4hlt werden, wenn das aktuelle Anwendungs-Theme ein <em>Standarddialogfeld-Seitentemplate</em> enth\00E4lt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016421747303517)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'de'
,p_message_text=>'Modales Dialogfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016556766303517)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Die Seite wird als modaler Dialog dargestellt.<br>',
unistr('Ein modaler Dialog ist ein Overlay-Fenster im Viewport, das aktiv und fokussiert bleibt, bis der Endbenutzer es schlie\00DFt.'),
unistr('Die zugrunde liegende Seite wird ausgegraut, sodass Benutzerinteraktionen mit dieser Seite erst nach Schlie\00DFen des Dialogs wieder m\00F6glich sind.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016645857303517)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'de'
,p_message_text=>'Nicht-modales Dialogfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016768626303517)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Die Seite wird als nicht modaler Dialog dargestellt.<br>',
'Ein nicht modaler Dialog ist ein Overlay-Fenster im Viewport, in dem der Endbenutzer mit dem Dialog und Inhalt der Seite interagieren kann, von der aus der Dialog gestartet wurde.',
unistr('Ein nicht modaler Dialog kann verwendet werden, wenn die angeforderten Informationen zur Fortsetzung des Vorgangs nicht unbedingt erforderlich sind. Die Arbeit kann an anderer Stelle fortgesetzt werden, w\00E4hrend das Fenster weiterhin ge\00F6ffnet ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016288289303517)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99016384301303517)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seite wird als normale &PRODUCT_NAME.-Anwendungsseite dargestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508173936303096)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitenmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357723050303800)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Navigationstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716701320303268)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, welcher Prozesstyp ausgef\00FChrt wird. Die folgenden Prozesstypen werden unterst\00FCtzt:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Je nach Anwendungskonfiguration sind hier zus\00E4tzliche Plug-ins f\00FCr den Prozesstyp verf\00FCgbar.'),
'Sie werden als <em>&lt;My Plug-in&gt; [Plug-in]</em> angezeigt.',
'Die folgenden Plug-ins sind in den gemeinsam verwendeten Komponenten dieser Anwendung installiert:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539635517303121)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340845455303786)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Parameter verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340720942303786)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340683613303786)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das als Quelle f\00FCr diesen Parameter verwendet werden soll. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340551132303786)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99341082111303786)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie mindestens ein Seiten- oder Anwendungselement ein, das als Ziel f\00FCr diesen Parameter verwendet wird. '),
' Bei mehreren Elementen trennen Sie die Elementnamen durch ein Komma.</p> ',
unistr('<p>Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Elementen w\00E4hlen. '),
unistr('Wenn Sie einen Namen aus der Liste w\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Elementnamen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99340951865303786)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element(e)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342290138303787)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Quelle f\00FCr den Parameter aus der verf\00FCgbaren Liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342777875303788)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342847027303788)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der von dem eingegebenen <em>PL/SQL-Funktionsbody</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342382079303787)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342485124303787)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Element</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342557137303787)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342678341303788)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Text festgelegt, der in <em>Statischen Wert</em> eingegeben wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99342109115303787)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864576422303387)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert f\00FCr diesen Parameter ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864445842303387)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892275253303410)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Theme-Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508414048303096)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Seitentemplate aus, um Darstellung und Layout dieser Seite zu definieren.</p>'),
'        <p>Seitentemplates werden im Anwendungs-Theme definiert.',
'        Wenn eine Seite erstellt wird, wird das Template automatisch auf <em>Theme-Standard</em> gesetzt. Dabei wird die Seite mit einem Standardseitentemplate gerendert, das im aktuellen Theme definiert ist.',
unistr('        Wenn hier eine Auswahl getroffen wird, wird das Standardseitentemplate au\00DFer Kraft gesetzt.</p>'),
unistr('        <p>Viele Themes enthalten Seitentemplates f\00FCr spezifische Zwecke, beispielsweise zur Anzeige von Inhalt mit Randspalten, Anmeldeseiten, Dialogseiten usw.<br>'),
'        Universal Theme stellt die folgenden Seitentemplates bereit:',
'          <dl>',
'            <dt>Standard</dt>',
unistr('              <dd>Das Standardseitentemplate. Eignet sich besonders f\00FCr Homepages, Dashboards, gro\00DFe Berichte und andere Layouts, bei denen maximale Bildschirmnutzung gew\00FCnscht wird.</dd>'),
'            <dt>Linke Spalte</dt>',
unistr('              <dd>Stellt eine linke Anzeigeposition bereit, die sich besonders f\00FCr Such- und Filterseiten eignet.</dd>'),
'            <dt>Rechte Spalte</dt>',
unistr('              <dd>Stellt eine rechte Anzeigeposition bereit, die ausgeblendet werden kann. Sie eignet sich besonders zur Anzeige von aktionsorientierten Steuerelementen, wie Schaltfl\00E4chen oder Listen.</dd>'),
'            <dt>Linke und rechte Spalten</dt>',
unistr('              <dd>Stellt sowohl die linke als auch die rechte Spalte bereit, die ausgeblendet werden kann. Dies eignet sich besonders f\00FCr sehr komplexe Seiten.</dd>'),
'            <dt>Anmeldung</dt>',
unistr('              <dd>Wird ausschlie\00DFlich f\00FCr die Anmeldeseite der Anwendung verwendet.</dd>'),
'            <dt>Laufschrift</dt>',
unistr('              <dd>Stellt eine rechte Spalte, die ausgeblendet werden kann, und einen Titelleistenbereich bereit, der Prim\00E4rinformationen enth\00E4lt.'),
unistr('              Dieses Seitentemplate eignet sich besonders zur Anzeige eines einzelnen Datensatzes, der \00FCber verschiedene zugeh\00F6rige Berichte oder Daten verf\00FCgt.'),
unistr('              Laufschrift wird im Allgemeinen zur Anzeige von Master/Detailbeziehungen verwendet, bei denen ein einzelner Masterdatensatz zuerst aus einem Bericht ausgew\00E4hlt wird. </dd>'),
'            <dt>Minimal (Keine Navigation)</dt>',
unistr('              <dd>Wird f\00FCr sehr einfache Seiten, Haftungsausschl\00FCsse, Anwendungen mit einer einzelnen Seite oder F\00E4lle verwendet, bei denen keine Navigation erforderlich ist.</dd>'),
'          </dl>',
'          Siehe auch: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>',
'        </p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508395187303096)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892468754303410)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Theme-Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333477508303780)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwendet die in den Theme-Standardwerten definierte Einstellung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509273087303097)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den \00DCbergang an, der bei der Navigation zu einer neuen Seite oder bei der Weiterleitung der Seite verwendet wird.</p>'),
unistr('<p>\00C4ltere Browser, die keine 3D-Transformationen verwenden, k\00F6nnen die meisten \00DCberg\00E4nge nicht nutzen. '),
unistr('Standardm\00E4\00DFig blenden Ger\00E4te, die keine 3D-Unterst\00FCtzung haben (wie Android 2.x), alle \00DCbergangstypen aus.'),
'Weitere Einzelheiten finden Sie in der jQuery Mobile-Dokumentation.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021378744303521)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberblenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021463171303521)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'de'
,p_message_text=>'Spiegeln'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021557344303521)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'de'
,p_message_text=>unistr('Flie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021217870303521)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021691644303521)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'de'
,p_message_text=>'Einblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021761518303521)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'de'
,p_message_text=>'Schieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021889655303521)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'de'
,p_message_text=>'Nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99021969178303522)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schieben/\00DCberblenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022077878303522)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'de'
,p_message_text=>'Nach oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022160395303522)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'de'
,p_message_text=>'Drehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509111967303097)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Seiten\00FCbergang')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197332352303661)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob der Benutzer gewarnt wird, wenn er versucht, aus der Seite zu navigieren, w\00E4hrend die Seite nicht gespeicherte \00C4nderungen enth\00E4lt.'),
unistr('        Seitenelemente und Schaltfl\00E4chen bieten au\00DFerdem eine genauere Kontrolle \00FCber die Ausf\00FChrung dieser Pr\00FCfung und deren Inhalt.'),
unistr('        Bei Schaltfl\00E4chen k\00F6nnen Sie angeben, ob die Pr\00FCfung beim Klicken auf die Schaltfl\00E4che ausgef\00FChrt wird.'),
unistr('        Bei Seitenelementen k\00F6nnen Sie angeben, ob \00C4nderungen am Element bei der Pr\00FCfung einbezogen oder ignoriert werden (hierzu wird auf das Attribut <em>Warnung bei nicht gespeicherten \00C4nderungen</em> f\00FCr beide F\00E4lle verwiesen).</p>'),
unistr('        <p>Hinweis: Diese Einstellung gilt nicht f\00FCr Endbenutzer, die ein Modaldialogfeld schlie\00DFen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197248450303661)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung bei nicht gespeicherten \00C4nderungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844752723303371)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wo die Seitennummerierung des Berichts angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045931559303541)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Unten links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046056868303541)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Unten rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046327111303541)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Oben und unten links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046408951303542)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Oben und unten rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046107167303541)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Oben links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99046252520303541)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Oben rechts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844688996303371)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigeposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99357483706303800)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Parameter-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828994858303359)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob dieser Parameter erforderlich ist und immer festgelegt sein muss.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98828882783303359)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829163821303359)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Standardwert oder einen statischen Wert f\00FCr diesen Parameter an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829016090303359)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564783942303140)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Kein \00FCbergeordnetes Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523708501303108)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die \00FCbergeordnete Region aus, in der die Region angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523617334303108)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Region')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880002656303400)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob die teilweise Seitenaktualisierung (PPA, Partial Page Refresh) zur Aktualisierung der Berichtsanzeige verwendet werden soll.</p>',
unistr('Wenn der Endbenutzer eine Aktion ausf\00FChrt, wie eine Paginierungsanforderung oder die Auswahl einer neuen Sortierspalte, m\00FCssen die aktuellen Berichtszeilen aktualisiert werden. Wenn Sie dieses Attribut auf <strong>Ein</strong> setzen, wird nur die Be')
||'richtsregion aktualisiert. Wenn Sie dieses Attribut auf <strong>Aus</strong> setzen, wird die ganze Seite aktualisiert.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879902203303400)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktualisierung von Seitenbestandteilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99057014832303550)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875554648303396)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Hintergrund dieses Diagramms ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875447567303396)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hintergrundfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875943905303397)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Breite f\00FCr dieses Balkendiagramm in Pixel an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875848733303397)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Balkenbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98902845221303419)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'de'
,p_message_text=>'Pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107585194303591)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875709516303396)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Vordergrund dieses Diagramms ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875637230303396)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Vordergrundfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787845067303327)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Teil des ganzen Tortendiagramms ein, unter dem die Segmente zu einem Segment "Weitere" aggregiert werden. G\00FCltige Werte gehen von 0 (Standard) bis 1</p>'),
unistr('        <p>Beispiel: Ein Wert von 0,15 w\00FCrde alle Segmente, die weniger als 15 % der Torte darstellen, in dem Segment "Weitere" aggregieren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787798129303327)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Tortendiagramm - Schwellenwert f\00FCr "Weitere"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818457057303351)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Effekt, der bei Auswahl eines Kreissegments angewendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818587071303351)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'de'
,p_message_text=>'Absetzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818724010303351)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Markierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818622168303351)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'de'
,p_message_text=>'Markieren und absetzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818380054303351)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Tortendiagramm - Auswahleffekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896848702303414)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck ein, der einen Wert f\00FCr den Prim\00E4rschl\00FCssel bereitstellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896799261303413)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897073322303414)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Namen f\00FCr den Prim\00E4rschl\00FCssel ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896925916303414)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896671730303413)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Quelltyp f\00FCr den Prim\00E4rschl\00FCssel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063964130303556)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064066839303556)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063887617303556)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'de'
,p_message_text=>'Vorhandener Trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98896503429303413)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980921619303488)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage ein, die anstelle einer automatisch generierten Abfrage verwendet werden muss, die eindeutige Spaltenwerte w\00E4hlt. Die SQL-Abfrage muss eine Spalte zur\00FCckgeben. Durch Eingabe einer SQL-Abfrage kann die Performance in einigen')
||' Berichten verbessert werden. Die Werteliste wird angezeigt, wenn ein Benutzer auf einen Spaltenheader klickt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980839287303488)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980574443303487)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie die Werteliste f\00FCr den Filter in der Dropdown-Liste der Berichtsspalte abgeleitet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068911243303560)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>unistr('Benannte Werteliste zum Filtern der exakten \00DCbereinstimmung verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069039511303560)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie die Werteliste von der benannten Werteliste ab, um einen Equal-Filter zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069195203303560)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>'Benannte Werteliste zum Filtern des Worts verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069247521303560)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie die Werteliste von der benannten Werteliste ab, um einen Contains-Filter zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068754128303559)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'de'
,p_message_text=>'Definierte Werteliste zum Filtern des Worts verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068861996303560)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie die Werteliste von einer definierten Wertelisten-SQL-Abfrage ab, um einen Contains-Filter zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068363587303559)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'de'
,p_message_text=>'Standard basierend auf Spaltentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068438789303559)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'de'
,p_message_text=>'STRING- und NUMBER-Spalten leiten die Werteliste aus eindeutigen Spaltenwerten ab. DATE-Spalten leiten die Werteliste aus vordefinierten Datumsbereichen ab.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068160303303559)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068231667303559)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>'Deaktivieren Sie Filter in der Werteliste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068589721303559)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'de'
,p_message_text=>unistr('Definierte Werteliste zum Filtern der exakten \00DCbereinstimmung verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99068637788303559)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'de'
,p_message_text=>'Leiten Sie die Werteliste von einer definierten Wertelisten-SQL-Abfrage ab, um einen Equal-Filter zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98980465243303487)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225452526303683)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den auszuf\00FChrenden PL/SQL-Code ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834710224303363)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den PL/SQL-Code ein, der in der Remotedatenbank ausgef\00FChrt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834653405303363)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den PL/SQL-Code zur Generierung der HTML-Ausgabe ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601431832303169)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die PL/SQL-Quelle ein, die in diesem Authentifizierungsschema verwendet wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601342751303168)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834171143303363)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie fest, wo der Prozess ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834233395303363)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'de'
,p_message_text=>'Lokale Datenbank'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834332165303363)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Code wird in der lokalen Datenbank ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834462436303363)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834592087303363)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Code wird in einer Remotedatenbank ausgef\00FChrt, sofern die Verbindung \00FCber eine REST-f\00E4hige SQL definiert ist. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834000787303363)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715805744303268)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, unter welcher Kategorie das Plug-in in der Benutzeroberfl\00E4che angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041830737303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'de'
,p_message_text=>'Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041914471303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'de'
,p_message_text=>'Effekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042024250303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042162844303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'de'
,p_message_text=>'Initialisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042287221303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'de'
,p_message_text=>'Verschiedenes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042309243303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'de'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042423859303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99042547543303538)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'de'
,p_message_text=>'Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715713498303267)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Kategorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367940056303808)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie JavaScript-Code ein, der ausgef\00FChrt werden kann. Hinweis: Die genaue Ausf\00FChrung h\00E4ngt vom aktuellen Plug-in ab.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367813425303808)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Initialisierungscode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98892544214303410)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Theme-Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333568294303780)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwendet die in den Theme-Standardwerten definierte Einstellung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509401910303097)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den \00DCbergang an, der beim \00D6ffnen eines Popups verwendet wird.</p>'),
unistr('<p>\00C4ltere Browser, die keine 3D-Transformationen verwenden, k\00F6nnen die meisten \00DCberg\00E4nge nicht nutzen. '),
unistr('Standardm\00E4\00DFig blenden Ger\00E4te, die keine 3D-Unterst\00FCtzung haben (wie Android 2.x), alle \00DCbergangstypen aus.'),
'Weitere Einzelheiten finden Sie in der jQuery Mobile-Dokumentation.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022389252303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberblenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022405709303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'de'
,p_message_text=>'Spiegeln'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022511867303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'de'
,p_message_text=>unistr('Flie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022268333303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022654700303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'de'
,p_message_text=>'Einblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022701762303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'de'
,p_message_text=>'Schieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022885251303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'de'
,p_message_text=>'Nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99022914217303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schieben/\00DCberblenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023009612303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'de'
,p_message_text=>'Nach oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99023112598303522)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'de'
,p_message_text=>'Drehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98509309349303097)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Popup-\00DCbergang')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602430047303169)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Namen einer Prozedur ein, die von der &PRODUCT_NAME.-Anmeldeprozedur (Anmelde-API) nach der Authentifizierung (Pr\00FCfung der Anmeldedaten) ausgef\00FChrt werden soll. '),
unistr('Die Anmeldeprozedur f\00FChrt diesen Code aus, nachdem die \00FCblichen Anmeldeaufgaben ausgef\00FChrt wurden, wie Festlegen eines Cookies und Registrieren der Session, jedoch vor der Umleitung zu der gew\00FCnschten Anwendungsseite. '),
'Diese Prozedur kann in dem Attribut "PL/SQL-Code" oder in der Datenbank definiert werden.'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602333724303169)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name der Post-Authentifizierungsprozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529818347303113)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen PL/SQL-Ausdruck ein, um den Wert f\00FCr das Element genauer zu definieren.</p>'),
unistr('<p>Wenn dieses Element beispielsweise <code>P1_X</code> hei\00DFt, k\00F6nnen Ausdr\00FCcke nach der Berechnung, wie <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X, :P2_Y - 200)</code>, <code>NVL(:P1_X, :P2_Y)</code> bzw. ein Funktionsau')
||unistr('fruf wie <code>my_func(:P1_X);</code> verwendet werden, um den endg\00FCltigen Wert f\00FCr dieses Element festzulegen.'),
unistr('Diese Beispiele geben an, dass die Ausdr\00FCcke nicht das aktuelle Element referenzieren m\00FCssen oder ein beliebiges anderes Element im Sessionzustand referenzieren k\00F6nnen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529768670303113)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Berechnung nach der Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602899745303170)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die URL ein, zu der die Anwendung umgeleitet wird, nachdem &PRODUCT_NAME. die Benutzersession bereinigt hat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602765841303170)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Post-Abmelde-URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279848530303734)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280154521303734)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280098380303734)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279915829303734)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280240343303734)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279726227303734)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281028779303735)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, bei dem die zur\00FCckgegebene SQL-Abfrage die von der Webquelle abgerufenen Daten transformiert. Die vom Java-Funktionsbody zur\00FCckgegebene SQL-Abfrage muss einen Eintrag in der Pseudotabelle #APEX$SOURCE_DATA# aus')
||unistr('w\00E4hlen und im Datenprofil verf\00FCgbare Spalten lesen. Das Miteinbeziehen von Unterabfragen mit der SQL-WITH-Klausel wird hierbei nicht unterst\00FCtzt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280915133303735)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Java-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280851324303735)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Spalten EMPNO, ENAME und SAL ausw\00E4hlen und alle Zeilen mit einem SAL-Wert unter 3000 herausfiltern.</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280785210303735)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, bei dem die zur\00FCckgegebene SQL-Abfrage die von der Webquelle abgerufenen Daten transformiert. Die vom JavaScript-Funktionsbody zur\00FCckgegebene SQL-Abfrage muss einen Eintrag in der Pseudotabelle #APEX$SOUR')
||unistr('CE_DATA# ausw\00E4hlen und im Datenprofil verf\00FCgbare Spalten lesen. Das Miteinbeziehen von Unterabfragen mit der SQL-WITH-Klausel wird hierbei nicht unterst\00FCtzt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280661864303735)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335381083303781)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Die zuletzt eingestellten Mitarbeiter zuerst und die noch nicht eingestellten Mitarbeiter zuletzt anzeigen. Bei identischem Datum werden die Mitarbeiter nach Abteilungsnummer sortiert.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335228467303781)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie mindestens eine durch Komma getrennte Spalte (einschlie\00DFlich Direktiven) ein, um die Reihenfolge zu definieren, in der Datens\00E4tze abgerufen werden.</p>'),
'        <p>Direktiven umfassen:',
'          <ul>',
unistr('            <li>ASC - Spalte in aufsteigender Reihenfolge zur\00FCckgeben</li>'),
unistr('            <li>DESC - Spalte in absteigender Reihenfolge zur\00FCckgeben</li>'),
unistr('            <li>NULLS FIRST - Spalten ohne Wert vor Spalten mit Werten zur\00FCckgeben</li>'),
unistr('            <li>NULLS LAST - Spalten mit Werten vor Spalten ohne Wert zur\00FCckgeben</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335102750303781)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sortieren nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280554824303735)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>W\00E4hlen Sie die Spalten EMPNO, ENAME und SAL aus, und filtern Sie alle Zeilen mit einem SAL-Wert unter 3000 heraus.</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280493764303735)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, bei dem die zur\00FCckgegebene SQL-Abfrage die von der Webquelle abgerufenen Daten transformiert. Die vom PL/SQL-Funktionsbody zur\00FCckgegebene SQL-Abfrage muss aus der Pseudotabelle #APEX$SOURCE_DATA# w\00E4hlen und i')
||unistr('m Datenprofil verf\00FCgbare Spalten lesen. Das Miteinbeziehen von Unterabfragen mit der SQL-Klausel WITH wird hierbei nicht unterst\00FCtzt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99280359804303734)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281263178303735)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, bei dem die zur\00FCckgegebene SQL-Abfrage die von der Webquelle abgerufenen Daten transformiert. Die vom Python-Funktionsbody zur\00FCckgegebene SQL-Abfrage muss einen Eintrag in der Pseudotabelle #APEX$SOURCE_DATA#')
||unistr(' ausw\00E4hlen und im Datenprofil verf\00FCgbare Spalten lesen. Das Miteinbeziehen von Unterabfragen mit der SQL-WITH-Klausel wird hierbei nicht unterst\00FCtzt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281158446303735)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Python-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336866189303783)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>W\00E4hlen Sie die Spalten EMPNO, ENAME und SAL aus, und filtern Sie alle Zeilen mit einem SAL-Wert unter 3000 heraus.</dt>'),
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335548681303782)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage ein, um die von der REST-Datenquelle abgerufenen Daten zu transformieren. W\00E4hlen Sie einen Eintrag in der Pseudotabelle #APEX$SOURCE_DATA# aus, und geben Sie im Datenprofil verf\00FCgbare Spalten an. Das Miteinbeziehen von Unte')
||unistr('rabfragen mit der SQL-Klausel WITH wird hierbei nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335442042303782)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99335035982303781)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Nur Mitarbeiter einbeziehen, die einen Manager haben oder SALESMAN sind.</dt>',
'<dd><pre>',
'( MGR ist nicht Null oder JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334948476303781)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine g\00FCltige SQL-Where-Bedingung ein, mit der die abgerufenen Datens\00E4tze eingeschr\00E4nkt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334895646303781)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'WHERE-Klausel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602242162303169)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen der Prozedur an, die nach Weiterleitung der Anmeldeseite und direkt vor der Pr\00FCfung der Zugangsdaten ausgef\00FChrt werden soll. '),
'Diese Prozedur kann im Attribut "PL/SQL-Code" oder innerhalb der Datenbank definiert werden.',
'<p/>',
unistr('<p>Authentifizierungsschemas, bei denen die Benutzerzugangsdaten au\00DFerhalb von &PRODUCT_NAME. gepr\00FCft werden, f\00FChren die Pre-Authentifizierungsprozedur normalerweise nicht aus. '),
'Beispiele: <em>HTTP-Headervariable</em>, <em>Oracle Application Server Single Sign-On</em> und benutzerdefinierte Authentifizierungsschemas, die <code>apex_authentication.post_login</code> anstelle von <code>apex_authentication.login</code> verwenden'
||'.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98602188113303169)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name der Pre-Authentifizierungsprozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906150084303421)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCssel f\00FCr die Tabelle enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906044184303421)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rschl\00FCsselspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070704383303561)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983712740303490)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige des Rahmens f\00FCr das angegebene Attribut ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983639325303490)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Randfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983550303303490)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Breite in Pixel f\00FCr die Tabellenr\00E4nder ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983438397303490)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Randbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107858106303591)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986978591303493)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige des Hintergrunds f\00FCr diese Komponente ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986888208303493)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hintergrundfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072845571303563)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986772112303493)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Farbe zur Anzeige dieser Komponente ein.</p>',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986642770303493)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986132481303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftart f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072543875303563)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072337568303562)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072459391303563)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986028641303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986552523303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Schriftgrad f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986454459303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986376059303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftst\00E4rke f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072732646303563)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'de'
,p_message_text=>'Fett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072634450303563)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98986218912303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftst\00E4rke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99107731341303591)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985912149303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe zur Anzeige des Hintergrunds f\00FCr diese Komponente ein.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985853302303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hintergrundfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072251786303562)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985756559303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Farbe zur Anzeige dieser Komponente ein.</p>',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985607525303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985150884303491)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftart f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071901052303562)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071705796303562)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071890054303562)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985021685303491)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985599908303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Schriftgrad f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985460746303492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985386027303491)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftst\00E4rke f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072135383303562)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'de'
,p_message_text=>'Fett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072066567303562)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98985261097303491)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftst\00E4rke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874781369303395)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Spaltenbreite zur Skalierung dieser Spalte ein, wenn der Bericht gedruckt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98874637922303395)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Druckbreite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989523039303495)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Einheiten zur Definition der Werte f\00FCr die Spaltenbreite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074378944303564)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'de'
,p_message_text=>'Prozent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074463883303564)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'de'
,p_message_text=>'Punkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989493525303495)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Breiteneinheiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988783910303494)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie einen Namen f\00FCr das heruntergeladene Dokument ein. Wenn Sie hier nichts eingeben, wird der Regionsname als Dateiname verwendet.'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988634908303494)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Dateiname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983355204303490)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die H\00F6he dieser Seite ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983213927303490)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990164434303495)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Text f\00FCr den Link zum Herunterladen an. Um den Link durch eine andere Navigationskomponente( beispielsweise durch eine Schaltfl\00E4che) zu ersetzen, geben sie in diesem Feld nichts ein. Sie k\00F6nnen die andere Komponente f\00FCr den Start des')
||' Druckprozesses einrichten, indem Sie eine URL mit folgender Syntax als Ziel verwenden: </p>',
'',
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
'',
'<p><strong>Hinweis</strong>: Ersetzen Sie in der obigen Zeichenfolge [REGION_ID] durch Ihre Regions-ID.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990083397303495)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Link-Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982766958303489)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Ausrichtung f\00FCr die Seite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070278535303561)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'de'
,p_message_text=>'Querformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070187354303561)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'de'
,p_message_text=>'Hochformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982610628303489)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989692251303495)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Von Element ableiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990268107303495)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Von Element ableiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988955325303494)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Format der Berichtsausgabe. Das Ausgabeformat kann auch von einem Element angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074147516303564)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'de'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073871781303564)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'de'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073988381303564)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'de'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074098734303564)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'de'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074247061303564)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'de'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988894352303494)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989107743303495)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Seiten- oder Anwendungselement ein, das den Formatwert enth\00E4lt. Sie k\00F6nnen ein Seitenelement <em>Liste ausw\00E4hlen</em> f\00FCr Benutzer aufnehmen, um das Ausgabeformat zur Laufzeit zu w\00E4hlen. G\00FCltige Werte sind:</p>'),
'<dl>',
'<dt>PDF</dt>',
unistr('<dd>\00D6ffnet das Dokument in einer PDF-Vorschau</dd>'),
'<dt>RTF</dt>',
unistr('<dd>\00D6ffnet das Dokument in Microsoft Word</dd>'),
'<dt>XLS</dt>',
unistr('<dd>\00D6ffnet das Dokument in Microsoft Excel</dd>'),
'<dt>HTM</dt>',
unistr('<dd>L\00E4dt das Dokument als HTML-Datei herunter</dd>'),
'<dt>XML</dt>',
unistr('<dd>L\00E4dt das Dokument als XML-Datei herunter</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989043462303495)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987956581303494)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Ausrichtung f\00FCr den Seitenfooter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073684327303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073597023303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073743780303564)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987842878303494)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073420910303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987710956303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Farbe zur Anzeige dieser Komponente ein.</p>',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987657564303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987102958303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftart f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073165505303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99072970095303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073086026303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987068760303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987576666303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Schriftgrad f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987458930303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987316554303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftst\00E4rke f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073304178303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'de'
,p_message_text=>'Fett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99073236119303563)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98987224590303493)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftst\00E4rke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988167636303494)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr den Footerabschnitt des Dokuments ein. Um die Werte der Seiten- oder Anwendungselemente anzuzeigen, verwenden Sie die <code>&amp;ITEM_NAME.</code>-Syntax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98988096248303494)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitenfootertext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984705818303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Ausrichtung f\00FCr den Seitenheader.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071585544303562)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Mitte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071484689303562)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'de'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071638482303562)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'de'
,p_message_text=>'Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984654355303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071351365303562)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984533322303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Farbe zur Anzeige dieser Komponente ein.</p>',
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hex'
||unistr('adezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter "HTML-Farbcodes" den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984457357303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983916718303490)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftart f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071050064303561)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'de'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070828969303561)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'de'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070915150303561)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'de'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983804720303490)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984302833303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Schriftgrad f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984258761303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schriftgrad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984198690303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schriftst\00E4rke f\00FCr diese Komponente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071276388303562)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'de'
,p_message_text=>'Fett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99071115642303561)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'de'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984028649303490)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schriftst\00E4rke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984929216303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr den Headerabschnitt des Dokuments ein. Um die Werte der Seiten- oder Anwendungselemente anzuzeigen, verwenden Sie die <code>&amp;ITEM_NAME.</code>-Syntax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98984868727303491)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitenheadertext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982521187303489)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Gr\00F6\00DFe f\00FCr die Berichtsseite. Um eigene Werte f\00FCr die Breite und H\00F6he der Seite festzulegen, w\00E4hlen Sie <strong>Benutzerdefiniert</strong>. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069910454303560)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'de'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069853433303560)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'de'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070006535303561)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069687975303560)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'de'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069522065303560)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'de'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069714155303560)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'de'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982469373303489)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Gr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982948983303489)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Einheiten zur Angabe von Seitenbreite und -h\00F6he.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070595353303561)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'de'
,p_message_text=>'Zentimeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070377395303561)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'de'
,p_message_text=>'Zoll'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070426942303561)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'de'
,p_message_text=>'Millimeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99070625086303561)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'de'
,p_message_text=>'Punkte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982883783303489)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Einheiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982370118303489)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Content Disposition f\00FCr das Druckdokument. "Content Disposition" ist eine Erweiterung des MIME-Protokolls, mit der angegeben wird, wie der Browser das Dokument anzeigen soll. Wenn Sie <strong>Attachment</strong> w\00E4hlen, wird der Browse')
||unistr('r angewiesen, eine Datei auf Datentr\00E4ger zu speichern, anstatt sie inline anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069387062303560)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'de'
,p_message_text=>'Anhang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99069423473303560)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'de'
,p_message_text=>'Inline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98982263249303489)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datei anzeigen als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983118660303490)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Breite dieser Seite ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98983093348303490)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342740502302959)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die zugeh\00F6rige Formularregion f\00FCr dieses Seitenelement aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98342676794302959)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formularregion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860005610303383)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wo diese Prozessfehlermeldung angezeigt wird, wenn der Prozess nicht erfolgreich ausgef\00FChrt werden kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049961529303544)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'de'
,p_message_text=>'Inline in Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050087799303544)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Prozessfehlermeldung wird im Bereich "Benachrichtigung" (der als Bestandteil des Seitentemplates definiert ist) angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050165034303545)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldungsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99050279089303545)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Prozessfehlermeldung wird auf der Fehlerseite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859977247303383)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigeposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523995598303108)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie fest, an welcher Stelle der Seitenwiedergabe oder -verarbeitung dieser Prozess ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035565539303533)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Nach Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327400688303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird nach der Wiedergabe der Regionen ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035779818303533)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'de'
,p_message_text=>'Nach Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327636024303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird nach der Wiedergabe der Seite ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035346027303532)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'de'
,p_message_text=>'Nach Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327282258303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird nach der Wiedergabe des Headers ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035994209303533)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'de'
,p_message_text=>'Verarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327888438303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeitung: Wird nach der Ausf\00FChrung von Validierungen und Berechnungen w\00E4hrend der Seitenverarbeitung ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035468414303533)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Vor Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327345466303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird vor der Wiedergabe der Regionen ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035622051303533)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'de'
,p_message_text=>'Vor Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327592884303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird vor der Wiedergabe des Footers ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035255881303532)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'de'
,p_message_text=>'Vor Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327195894303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Rendering: Wird vor der Wiedergabe der Seite ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99036086910303533)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'de'
,p_message_text=>'Ajax Callback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327984029303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird bei Aufruf durch apex.server-JavaScript-APIs ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035198501303532)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'de'
,p_message_text=>'Neue Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327040634303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird beim Generieren einer neuen Session ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99035891010303533)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'de'
,p_message_text=>'Nach Weiterleitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99327783675303775)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeitung: Wird nach der Weiterleitung der Seite, aber vor der Ausf\00FChrung von Berechnungen, Validierungen und Seitenprozessen ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98523888631303108)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Punkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860286383303384)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Region, die mit diesem Prozess verkn\00FCpft werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860158466303383)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Editierbare Region'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738594494303287)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Autorisierungsschema, um zu begrenzen, wer \00F6ffentliche Berichtsdefinitionen speichern kann.'),
unistr('		Damit ein Endbenutzer einen \00F6ffentlichen Bericht speichern kann, muss die Auswertung dieses Autorisierungsschemas TRUE ergeben.</p>'),
unistr('		<p>Hinweis - Wenn kein Autorisierungsschema angegeben wird, k\00F6nnen \00F6ffentliche Berichte von jedem Benutzer gespeichert werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98738496077303287)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Autorisierung f\00FCr \00F6ffentlichen Bericht speichern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108715675303592)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'de'
,p_message_text=>'$$$ DJP derzeit ausgeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899448590303416)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Abfrage-ID der Berichtsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531025526303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die erste <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530950567303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531491714303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die zweite <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531328889303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531891439303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die dritte <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531719853303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532211707303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die vierte <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532141556303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532648752303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die f\00FCnfte <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532555993303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533022417303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die sechste <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532968780303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533446547303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die siebte <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533361098303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533865594303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die achte <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533771416303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534274887303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die neunte <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534130172303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534640453303117)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Label f\00FCr die zehnte <strong>Schnellauswahl</strong> ein. Diesen Labeltext sieht der Endbenutzer der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534577087303117)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530857223303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie HTML-Attribute ein, die mit der Anzeige jedes <strong>Schnellauswahl</strong>-Links verkn\00FCpft sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530705274303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Linkattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531215368303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der ersten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531141847303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531645830303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der zweiten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531566017303114)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532084381303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der dritten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98531923549303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532437815303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der vierten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532329322303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532871674303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der f\00FCnften <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98532741900303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533256266303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der sechsten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533186120303115)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533681228303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der siebten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533530024303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534058671303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der achten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98533939148303116)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534465444303117)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der neunten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534396422303117)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534839755303117)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit der zehnten <strong>Schnellauswahl</strong> verkn\00FCpft ist. Dieser Wert ersetzt den vorhandenen Elementwert, wenn der Benutzer auf diese Schnellauswahl klickt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534797184303117)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872971340303394)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Anzahl von Spalten an, die f\00FCr diese Optionsgruppenspalte angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872834356303394)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604015575303171)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie eine durch Doppelpunkt getrennte Liste der dynamischen Real Application Security-Rollen ein, wie:',
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. aktiviert diese Rollen bei der Anmeldung, indem sie \00FCber den Parameter <em>enable_dynamic_roles</em> von <em>sys.dbms_xs_sessions.assign_user</em> \00FCbergeben werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603987794303170)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Dynamische Rollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603897325303170)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie aus, wie Oracle Real Application Security (RAS) in dieser Anwendung verwendet wird.</p>'),
'<p>Wenn Sie den RAS-Modus aktivieren, stellen Sie sicher, dass die Benutzer zum Zugriff auf die Schemaobjekte der Anwendung berechtigt sind.',
unistr('Beispiel: F\00FCr <strong>externe Benutzer</strong> k\00F6nnen Sie Datenbankberechtigungen f\00FCr eine <em>dynamische RAS-Anwendungsrolle</em> erteilen und diese in diesem Authentifizierungsschema als <em>dynamische Rolle</em> konfigurieren.'),
unistr('Sie k\00F6nnen Rollen auch \00FCber einen Aufruf von <em>apex_authorization.enable_dynamic_groups</em> aktivieren, beispielsweise in einer Post-Authentifizierungsprozedur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037126071303534)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328074344303775)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'de'
,p_message_text=>'Real Application Security wird in der Anwendung nicht verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037244963303534)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>'Externe Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328179335303775)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('&PRODUCT_NAME. geht davon aus, dass alle Benutzer intern sind, und \00FCbergibt <em>false</em> \00FCber den Parameter <em>is_external</em> an <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99037336353303534)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>'Interne Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328201434303776)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('&PRODUCT_NAME. \00FCbergibt <em>true</em> \00FCber den Parameter <em>is_external</em> an <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603730847303170)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'RAS-Modus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604221647303171)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie eine durch Doppelpunkt getrennte Liste von Real Application Security Namespace Templates ein, wie:',
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. aktiviert diese Namespaces bei der Anmeldung, indem sie \00FCber den Parameter <em>namespaces</em> von <em>sys.dbms_xs_sessions.assign_user</em> \00FCbergeben werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604163034303171)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Namespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253038183303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253429482303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253351427303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253264775303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253545663303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253194023303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252955313303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255068714303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255313268303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255203521303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255110636303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255425834303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254974647303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541210368303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541168925303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542609416303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das in dieser Bedingung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542524894303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254683183303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254589989303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256205763303715)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256109194303715)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254415063303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254338002303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254284648303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256011258303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255995364303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255875610303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541412063303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Doppelpunkt getrennte Liste der Werte f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541352966303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541867233303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Seitennummer f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541789124303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542040183303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine durch Komma getrennte Liste mit Seitennummern f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541954758303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254198736303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist oder ein Manager ist:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254002999303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253918513303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255725465303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche R\00FCckgabe, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255639083303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99255546363303714)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541651982303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Benutzervoreinstellung ein, die mit dem angegebenen Wert f\00FCr diese Bedingung verglichen wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541541100303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254855517303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99254780269303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256451481303715)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen booleschen Wert f\00FCr diese Bedingung zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99256323612303715)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253876740303713)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn der Mitarbeiter ein Manager ist und sich die Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          wobei deptno = :P2_DEPTNO',
'            und loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253713451303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen SQL-Ausdruck f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99253649988303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403362657303838)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn eine oder mehrere Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 30',
'</pre></dd>',
unistr('<dt>F\00FCr einen R\00FCckgabewert "Erfolgreich", wenn keine Zeilen vorhanden sind, und wenn gepr\00FCft wird, ob der Mitarbeiter in Abteilung 40 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540830089303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine SQL-Abfrage f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540750621303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542200608303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Textwert f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542154151303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542864049303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542724566303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751750078303298)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie einen Bedingungstyp, der erf\00FCllt werden muss, damit diese Komponente als schreibgesch\00FCtzte Komponente wiedergegeben wird. Wenn Sie keine Bedingung ausw\00E4hlen, wird das Element normal wiedergegeben. '),
unistr('Ein schreibgesch\00FCtztes Element wird mit denselben Einstellungen wie ein Element "Nur anzeigen" wiedergegeben.</p>'),
'<p>Hinweis: Setzen Sie den Bedingungstyp auf <strong>Nie</strong>, wenn das Element immer als Feld angezeigt werden soll, in das ein Wert eingegeben werden kann. ',
unistr('Dadurch wird jede Schreibschutz-Bedingungseinstellung auf Regions- oder Seitenebene \00FCberschrieben.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155749105302810)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie einen Bedingungstyp, der erf\00FCllt werden muss, damit diese Komponente als schreibgesch\00FCtzte Komponente wiedergegeben wird. Wenn Sie keine Bedingung ausw\00E4hlen, wird das Element normal wiedergegeben. '),
unistr('Ein schreibgesch\00FCtztes Element wird mit denselben Einstellungen wie ein Element "Nur anzeigen" wiedergegeben.</p>'),
'<p>Hinweis: Setzen Sie den Bedingungstyp auf <strong>Nie</strong>, wenn das Element immer als Feld angezeigt werden soll, in das ein Wert eingegeben werden kann. ',
unistr('Dadurch wird jede Schreibschutz-Bedingungseinstellung auf Regions- oder Seitenebene \00FCberschrieben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606602292303173)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie einen Bedingungstyp aus der Liste aus, der erf\00FCllt werden muss, damit Seitenelemente in dieser Region schreibgesch\00FCtzt wiedergegeben werden. '),
unistr('Wenn Sie keine Bedingung ausw\00E4hlen, werden die Seitenelemente normal wiedergegeben.</p>'),
unistr('<p>Hinweis: Wenn ein Seitenelement dieser Region (z.B. ein Suchfeld) unabh\00E4ngig von der Auswertung dieser Bedingung immer als bearbeitbares Seitenelement wiedergegeben werden soll, m\00FCssen Sie die Schreibschutzbedingung dieses Seitenelements auf "Nie"')
||unistr(' setzen, um die Regionseinstellung zu \00FCberschreiben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526548041303110)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie einen Bedingungstyp aus, der erf\00FCllt werden muss, damit Seitenelemente auf dieser Seite schreibgesch\00FCtzt wiedergegeben werden. Wenn Sie keine Bedingung ausw\00E4hlen, werden die Seitenelemente normal wiedergegeben. '),
unistr('Die Schreibschutzbedingung wird ausgewertet, nachdem die Prozesse mit dem Verarbeitungspunkt <em>Vor Header</em> ausgef\00FChrt wurden.</p>'),
unistr('<p>Hinweis: Wenn einige Seitenelemente (z.B. ein Suchfeld) oder alle Seitenelemente einer speziellen Region unabh\00E4ngig von der Auswertung dieser Bedingung immer als bearbeitbare Seitenelemente wiedergegeben werden sollen, m\00FCssen Sie die Schreibschutz')
||unistr('bedingung dieser Regionen/Seitenelemente auf <strong>Nie</strong> setzen, um die \00FCbergeordnete Einstellung zu \00FCberschreiben.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095417571303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'de'
,p_message_text=>'Immer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99234943236303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Komponente wird immer als schreibgesch\00FCtzt zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094098514303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Microsoft Internet Explorer 7.0 oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094194768303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: XHTML-/CSS-f\00E4higer Browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093998181303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Mozilla, Netscape 6.x/7x oder h\00F6her')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094215961303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Clientbrowser: Andere Browser (oder \00E4ltere Version)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092612091303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Element enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094684305303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238585163303700)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094338239303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238773405303700)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094535479303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238633036303700)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in der Sprache aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094434105303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Sprache ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238892567303700)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Endbenutzer f\00FChrt die Anwendung aktuell nicht in einer der Sprachen aus, die Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091865523303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237381030303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092024617303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237562134303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091909292303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237477114303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite entspricht nicht dem Wert, den Sie in <em>Seite</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092116420303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite ist NICHT in durch Komma begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237611218303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite ist nicht in der durch Komma getrennten Liste enthalten, die Sie in <em>Seiten</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094748494303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094816784303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: DAD_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093511714303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238392115303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird auf der Seite nach einer Weiterleitung der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092973964303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092733148303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092877443303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093049687303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Text != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089513889303576)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCckgegebene Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235060868303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt mindestens eine Zeile zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252784653303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99252885922303712)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Auswertung des Ausdrucks ergibt TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089765984303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235248834303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Funktionsbody gibt TRUE zur\00FCck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095154090303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095225264303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: HTTP_HOST != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093277190303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist NICHT schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238092518303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite bzw. \00FCbergeordnete Region wird normal angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093194965303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Seite/Region ist schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237967893303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Auswertung der Bedingung "Schreibgesch\00FCtzt" der Seite bzw. \00FCbergeordneten Region ergibt TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091057827303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt keine Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236570327303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> enth\00E4lt keine Leerzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091398840303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist alphanumerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236883005303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist alphanumerisch und enth\00E4lt nur Buchstaben oder Zahlen und keine Sonderzeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090500161303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236095216303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091275601303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236771127303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090796607303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236281942303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090428267303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235995927303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090857898303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NULL oder Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236379734303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist leer oder entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091195373303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236638247303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090613048303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236175379303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090928381303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL und NICHT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236480767303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht leer und entspricht nicht der Zahl Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093744737303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Weiter" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093808610303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Berichte (auf "OK" klicken, um die Schaltfl\00E4che "Zur\00FCck" anzuzeigen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095343597303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238906247303700)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Komponente wird normal wiedergegeben, ungeachtet der Schreibschutzbedingung f\00FCr die \00FCbergeordneten Komponenten. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093662716303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'de'
,p_message_text=>'Inline-Validierungsfehler nicht angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238460522303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'de'
,p_message_text=>'Ein Inline-Validierungsfehler wird nicht auf der Seite angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089617121303576)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Zeilen zur\00FCckgegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235109754303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die SQL-Abfrage gibt keine Zeilen zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092410591303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich im Druckversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237755107303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092564512303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite befindet sich nicht im Druckerversionsmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237858786303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die aktuelle Seite wurde vom Endbenutzer nicht in "Druckversionsmodus" umgeschaltet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089841163303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235367825303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090054554303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235534475303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99089943685303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235436549303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090110908303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'Anforderung ist nicht in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235637521303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Seitenanforderung ist nicht in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99094974074303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99095054715303581)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'de'
,p_message_text=>'CGI_ENV: SERVER_NAME != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093374357303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist berechtigt (nicht \00F6ffentlich)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238183350303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99093437252303580)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer ist der \00F6ffentliche Benutzer (Benutzer ist nicht berechtigt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99238231105303699)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Endbenutzer ist nicht bei der Anwendung angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091682883303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237151077303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091746115303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Benutzervoreinstellung != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237258740303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>'Der Wert der eingegebenen <em>Voreinstellung</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091430497303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99236998350303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99091510757303578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Element ist nicht in durch Doppelpunkt begrenzter Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99237003479303698)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> ist nicht vollst\00E4ndig in dem Text enthalten, den Sie in das Attribut <em>Wert</em> eingegeben haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090299076303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235765143303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99090366381303577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'de'
,p_message_text=>'Element != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99235838131303697)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Wert des ausgew\00E4hlten <em>Elements</em> entspricht nicht dem Text, den Sie in das Attribut <em>Wert</em> eingeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092336917303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite != Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99092277753303579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Seite = Seite weitergeleitet (gepostet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98526404831303110)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98541023258303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Wert ein, mit dem die Bedingung verglichen werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540991288303122)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542495154303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert, einschlie\00DFlich <code>&ITEM.</code>-Ersetzungszeichenfolgen, f\00FCr diese Bedingung ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98542373387303123)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032643199303530)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535073701303117)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Attribute ein, die in dem Tag der HTML-Tabellenzelle des Elements, <code>&lt;td&gt;</code>, enthalten sind, wenn die Anzeige schreibgesch\00FCtzt erfolgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98534975852303117)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schreibgesch\00FCtzte HTML-Attribute')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819605695303352)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Intervall zwischen Diagrammaktualisierungen in Sekunden an. Von sehr kleinen Updateintervallen, wie 2 Sekunden, wird abgeraten, weil sie zu ernsthaften Problemen bei der Datenbankperformance f\00FChren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819576903303352)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Intervall'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819770049303352)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'de'
,p_message_text=>'Sekunden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547359835303127)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Region aus, in der die Schaltfl\00E4che angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564629620303140)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Kein \00FCbergeordnetes Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155656917302810)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Region aus, in der das Element angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564501009303140)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Kein \00FCbergeordnetes Element')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540249767303121)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Region aus, in der diese Komponente verkn\00FCpft ist. Wenn die Komponente angezeigt wird, wird sie innerhalb der angegebenen Region und relativ zu anderen Komponenten innerhalb dieser Region angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98540190473303121)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605482586303172)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie <strong>Ein</strong> an, wenn diese Region in den Regionsanzeigeselektor aufgenommen werden soll.',
unistr('Dieses Attribut wird nur verwendet, wenn der Regionstyp <em>Selektor f\00FCr Regionsanzeige</em> definiert und auf der Seite sichtbar ist.</p>'),
unistr('<p>Wenn ein Benutzer auf einen Regionsnamen klickt, der im Regionsanzeigeselektor enthalten ist, wird nur die ausgew\00E4hlte Region angezeigt, und alle anderen Regionen sind ausgeblendet.'),
unistr('Der erste Eintrag im Regionsanzeigeselektor ist <em>Alle anzeigen</em>. Damit k\00F6nnen Benutzer alle verf\00FCgbaren Regionen und nicht nur die vorher ausgew\00E4hlte Region anzeigen.</p>'),
'<p>Wenn eine Region aufgrund der Regionsbedingungen nicht angezeigt werden kann, ist sie nicht in der Liste der Regionen innerhalb des Regionsanzeigeselektors enthalten.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605311103303172)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Selektor f\00FCr Regionsanzeige')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606253444303172)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine PL/SQL-Funktion ein, die eine SQL-Abfrage zur\00FCckgibt, die als Basis f\00FCr diese Region verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606147538303172)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604470570303171)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Regionsquelle oder den Regionsinhalt ein, je nach ausgew\00E4hltem <em>Regionstyp</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604302661303171)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605604699303172)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Referenz zu einem Bild ein, das oben links in der Region angezeigt wird. Das f\00FCr die Anzeige dieses Bildes verwendete Tabellentag kann nicht gesteuert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605531791303172)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Regionsbild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899635005303416)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Textquelle f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899515098303416)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600733169303168)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Quelle f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98600673930303168)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98605040741303171)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Regionstemplate aus, um die Darstellung und das Layout dieser Region zu definieren.</p>'),
'        <p>Regionstemplates sind im Anwendungs-Theme definiert.',
unistr('        Bei der Erstellung einer Region wird f\00FCr das Template automatisch das im aktuellen Theme definierte Standardregionstemplate festgelegt.</p>'),
unistr('        <p>Zahlreiche Themes enthalten Regionstemplates f\00FCr die Anzeige von Berichten, Formularen, Alerts, Schaltfl\00E4chen, ausblendbaren Inhalten (Ausblenden/Anzeigen), Anmeldeformularen usw.<br>'),
'        Universal Theme stellt die folgenden Regionstemplates bereit:',
'          <dl>',
'            <dt>Alert</dt>',
'            <dt>Leer mit Attributen</dt>',
unistr('            <dt>Schaltfl\00E4chencontainer</dt>'),
'            <dt>Karussellcontainer</dt>',
'            <dt>Ausblendbar</dt>',
'            <dt>Inhaltsblock</dt>',
'            <dt>Hero</dt>',
'            <dt>Inlinedialogfeld</dt>',
'            <dt>Inline-Popup-Fenster</dt>',
'            <dt>Interaktiver Bericht</dt>',
'            <dt>Anmeldung</dt>',
'            <dt>Standard</dt>',
'            <dt>Registerkartencontainer</dt>',
'            <dt>Titelleiste</dt>',
'            <dt>Assistentencontainer</dt>',
'          </dl>',
'          Siehe auch: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal-Theme-Beispielanwendung</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604946050303171)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98716664616303268)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, wie diese Region wiedergegeben wird. Die folgenden Regionstypen werden unterst\00FCtzt:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Je nach Anwendungskonfiguration sind hier zus\00E4tzliche Plug-ins f\00FCr den Regionstyp verf\00FCgbar.'),
'Sie werden als <em>&lt;My Plug-in&gt; [Plug-in]</em> angezeigt.',
'Die folgenden Plug-ins sind in den gemeinsam verwendeten Komponenten dieser Anwendung installiert:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539577923303121)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978605513303486)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Gleichheitstyp, der f\00FCr diese Validierung getestet werden soll. Je nach Auswahl ist mindestens ein Attribut erforderlich, um diese Validierung vollst\00E4ndig zu definieren.</p>'),
'<p>Wenn die Validierung den Gleichheitstest besteht oder als TRUE ausgewertet wird, wird keine Validierungsfehlermeldung angezeigt.',
unistr('Validierungsfehlermeldungen werden angezeigt, wenn die Validierung den Gleichheitstest nicht besteht, als FALSE ausgewertet wird, oder wenn eine leere Zeichenfolge zur\00FCckgegeben wird.</p>'),
unistr('<p>Ein Validierungsfehler stoppt die Auswertung nachfolgender Validierungen nicht, deshalb kann jede nachfolgende Validierung eine zus\00E4tzliche Validierungsfehlermeldung ausl\00F6sen. Wenn Sie die Ausf\00FChrung nachfolgender Validierungen stoppen m\00F6chten, m\00FC')
||unistr('ssen Sie zus\00E4tzliche Logik zu der ersten nicht erfolgreiche Validierung hinzuf\00FCgen, beispielsweise ein Seitenelement auf einen bestimmten Wert festlegen, und dann die bedingte Logik nach Bedarf f\00FCr nachfolgende Validierungen erweitern. Nachfolgende P')
||unistr('rozesse und Verzweigungen werden nicht ausgef\00FChrt, wenn mindestens eine Validierung nicht erfolgreich ausgewertet werden kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079363467303568)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCckgegebene Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079412810303568)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn die SQL-Abfrage mindestens eine Zeile zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn die SQL-Abfrage keine Zeilen zur\00FCckgibt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286777773303740)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286886328303740)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn die Auswertung des Ausdrucks TRUE ergibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn die Auswertung des Ausdrucks FALSE ergibt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079920582303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsbody (der booleschen Wert zur\00FCckgibt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080015943303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Funktionsbody TRUE zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Funktionsbody FALSE zur\00FCckgibt.<br>'),
unistr('Hinweis: Das von der Funktion zur\00FCckgegebene Ergebnis muss ein boolescher Wert sein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080100490303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsbody (der Fehlertext zur\00FCckgibt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080271598303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Funktionsbody eine leere Zeichenfolge zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Funktionsbody eine nicht leere Zeichenfolge zur\00FCckgibt. Die zur\00FCckgegebene Zeichenfolge wird als Fehlermeldung zur Validierung angezeigt.<br>'),
unistr('Hinweis: Das von der Funktion zur\00FCckgegebene Ergebnis muss eine Textzeichenfolge sein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080966005303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte enth\00E4lt keine Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081066761303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert keine Leerzeichen enth\00E4lt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert Leerzeichen enth\00E4lt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082928079303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte enth\00E4lt mindestens eines der Zeichen in Wert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083022815303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert mindestens ein Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert keines der Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083182568303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt KEINES der Zeichen in Wert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083266674303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert keines der Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert mindestens eines der Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082784592303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte enth\00E4lt nur Zeichen, die in Wert angegeben werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082887045303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert nur Zeichen enth\00E4lt, die in dem Text enthalten sind, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert Zeichen enth\00E4lt, die nicht in dem Text enthalten sind, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081903270303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Spalte = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082046794303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert nicht identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082336380303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Spalte ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082459347303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert nicht vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082100903303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Spalte != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082213795303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert nicht identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082579734303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Spalte ist NICHT in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99082675077303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert nicht vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081188056303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Spalte ist alphanumerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081256603303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert alphanumerisch ist und nur Buchstaben und Zahlen und keine Sonderzeichen enth\00E4lt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert Sonderzeichen enth\00E4lt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081563537303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte ist ein g\00FCltiges Datum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081629867303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert ein g\00FCltiges Datum ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert kein g\00FCltiges Datum ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081375565303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Spalte ist numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081457205303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert numerisch ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert nicht numerische Zeichen, ein schlie\00DFlich Leerzeichen mit Ausnahme von f\00FChrenden Leerzeichen enth\00E4lt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081742125303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte ist ein g\00FCltiger Zeitstempel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99081861879303570)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert ein g\00FCltiger Zeitstempel ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert kein g\00FCltiger Zeitstempel ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080303718303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Spalte ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080432840303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert nicht leer ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert leer ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080591656303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Spalte ist NOT NULL oder Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080625653303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert nicht leer ist und nicht der Zahl Null entspricht.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert leer ist oder der Zahl Null entspricht')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080750460303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Spalte ist NICHT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99080838968303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert nicht der Zahl Null entspricht.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert der Zahl Null entspricht.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079513533303568)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Zeilen zur\00FCckgegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079639614303568)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn die SQL-Abfrage keine Zeilen zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn die SQL-Abfrage mindestens eine Zeile zur\00FCckgibt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079753026303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079849381303569)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der PL/SQL-Code ausgef\00FChrt wird, ohne einen Fehler zu generieren.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der PL/SQL-Ausdruck bei der Ausf\00FChrung einen Fehler generiert.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083374133303571)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte stimmt mit regul\00E4rem Ausdruck \00FCberein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99083483167303572)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Spaltenwert mit dem Ausdruck \00FCbereinstimmt, den Sie in das Attribut <em>Wert</em> eingeben.'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Spaltenwert nicht mit dem regul\00E4ren Ausdruck \00FCbereinstimmt, den Sie in das Attribut <em>Wert</em> eingeben.<br>'),
unistr('Hinweis: Mit regul\00E4ren Ausdr\00FCcken k\00F6nnen Sie nach Mustern in Zeichenfolgendaten suchen, indem Sie standardisierte Syntaxkonventionen anstelle von einfachen Zeichenvergleichen verwenden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978543881303486)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979211726303486)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Spaltennamen f\00FCr diese Validierung ein. Bei dem Namen muss die Gro\00DF-/Kleinschreibung beachtet werden. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Spalten ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979124799303486)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288651132303741)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289019789303742)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288929709303741)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288881587303741)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289101493303742)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288777218303741)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288548310303741)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290639095303743)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290955395303743)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290828637303743)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290722551303743)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291006953303743)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290575066303743)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287079203303740)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287378789303740)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287231191303740)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287151429303740)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287415541303740)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286906751303740)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290201590303743)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Java-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290181717303742)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291896535303744)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291714979303744)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288289682303741)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288158005303741)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Java-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290045547303742)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche Validierung ohne Ausl\00F6sung einer Fehlermeldung, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289910536303742)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen JavaScript-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289886878303742)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291663779303744)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche Validierung ohne Ausl\00F6sung einer Fehlermeldung, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291579740303744)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291478078303744)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288014373303741)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche Validierung ohne Ausl\00F6sung der angegebenen Fehlermeldung, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287993358303741)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287872110303741)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403153511303838)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und die angegebene Fehlermeldung nicht auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979066875303486)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck ein, der einen Fehler ausl\00F6st, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978977462303486)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Code, der einen Fehler ausl\00F6st')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289779105303742)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und keine Fehlermeldung auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist oder ein Manager ist:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289611333303742)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen PL/SQL-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289587386303742)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291344557303743)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und keine Fehlermeldung auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291239215303743)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291110153303743)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287798534303740)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und die angegebene Fehlermeldung nicht auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287695128303740)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99287501818303740)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290477495303743)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Python-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99290319440303743)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292061941303744)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99291953778303744)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288468341303741)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99288368257303741)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Python-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979625258303487)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den regul\00E4ren Ausdruck ein, der f\00FCr den Vergleich mit der f\00FCr diese Validierung angegebenen Spalte verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979572195303487)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Regul\00E4rer Ausdruck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289490082303742)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und keine Fehlermeldung auszul\00F6sen, wenn der Mitarbeiter ein Manager ist oder sich die Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          wobei deptno = :P2_DEPTNO',
'            und loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289358749303742)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen SQL-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99289299286303742)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99403093978303838)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Damit <strong>Zur\00FCckgegebene Zeilen</strong> die Validierung besteht und keine Fehlermeldung ausl\00F6st, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 30',
'</pre></dd>',
unistr('<dt>Damit <strong>Keine Zeilen zur\00FCckgegeben</strong> die Validierung besteht und keine Fehlermeldung ausl\00F6st, wenn der Mitarbeiter in Abteilung 40 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978833124303486)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine SQL-Abfrage zur Definition dieser Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978783806303486)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979431175303487)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit dem Wert der Spalte verglichen wird, die f\00FCr diese Validierung angegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98979377623303487)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993042394303498)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Anwendungsstandardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333603714303780)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbernimmt die f\00FCr die Anwendung definierte Einstellung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992983695303498)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit diesem Attribut k\00F6nnen Sie kontrollieren, ob &PRODUCT_NAME. Anwendungs-URLs unterst\00FCtzen soll, die keine Session-IDs enthalten.'),
unistr('Wenn "Sessions erneut beitreten" aktiviert ist, versucht &PRODUCT_NAME., das Sessioncookie zu verwenden, um eine vorhandene Session zu verkn\00FCpfen, wenn eine URL keine Session-ID enth\00E4lt.'),
'</p>',
unistr('<p>Eine restriktivere Einstellung auf Instanzebene \00FCberschreibt diesen Wert auf Seitenebene.'),
'</p>',
unistr('<p><em><strong>Hinweis:</em></strong> Durch Aktivierung von "Sessions erneut beitreten" wird Ihre Anwendung m\00F6glichen Sicherheitsrisiken ausgesetzt,'),
unistr('weil Angreifer vorhandene Endbenutzersessions \00FCbernehmen k\00F6nnen.'),
'Weitere Informationen finden Sie in den Abschnitten <em>Rejoin Sessions</em> im Kapitel "Managing Application Security" im App Builder User''s Guide.',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074550324303564)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074694001303564)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die URL keine Session-ID enth\00E4lt, erstellt &PRODUCT_NAME. eine neue Session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074797885303564)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr \00F6ffentliche Sessions aktiviert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074880051303564)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn die URL zu einer \00F6ffentlichen Seite f\00FChrt und keine Session-ID enth\00E4lt, versucht &PRODUCT_NAME. das vorhandene Sessioncookie zu verwenden, das f\00FCr diese Anwendung festgelegt wurde.'),
unistr('Bei Anwendungen mit \00F6ffentlichen und authentifizierten Seiten, wird eine Session-ID nach der Authentifizierung des Endbenutzers definiert.'),
unistr('&PRODUCT_NAME. tritt nur \00FCber das Cookie bei, wenn die Session noch nicht authentifiziert ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99074982478303565)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr alle Sessions aktiviert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075069965303565)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die URL keine Session-ID enth\00E4lt, versucht &PRODUCT_NAME. das vorhandene Sessioncookie zu verwenden, das f\00FCr diese Anwendung festgelegt wurde, vorausgesetzt, die folgenden Bedingungen sind erf\00FCllt::</p>'),
'<p><ul>',
unistr('  <li>Schutz f\00FCr den Sessionzustand ist f\00FCr die Anwendung aktiviert und die URL umfasst eine g\00FCltige Pr\00FCfsumme.'),
unistr('    Bei \00F6ffentlichen Lesezeichen muss der restriktivste Schutz auf Elementebene <em>Uneingeschr\00E4nkt</em> oder <em>Pr\00FCfsumme erforderlich - Anwendungsebene</em> sein.</li>'),
unistr('  <li>ODER, die URL enth\00E4lt keine Payload (Anforderungsparameter, Cacheinhalt l\00F6schen (Clear-Cache) oder Datenwertpaare).</li>'),
'</ul></p>',
unistr('<p>Diese Einstellung erfordert, dass <em>In Frames einbetten</em> auf <em>Aus selbem Ursprung zulassen</em> oder auf <em>Ablehnen</em> f\00FCr die Anwendung festgelegt ist.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992829718303498)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sessions erneut beitreten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920999738303434)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie diese Option, wenn die Seite nach einer Weiterleitung neu geladen werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921002203303434)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'de'
,p_message_text=>'Immer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921191961303434)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'de'
,p_message_text=>'Laden Sie die Seite immer neu, um Fehler- und Erfolgsmeldungen anzuzeigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921279344303434)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'de'
,p_message_text=>'Nur bei Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98921342808303434)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt Fehler dynamisch an, ohne die Seite neu zu laden, l\00E4dt die Seite jedoch nach einer erfolgreichen Verarbeitung neu. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98920823435303434)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Bei Weiterleitung neu laden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302313741303753)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302454316303753)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Daten werden nicht gecacht und jedes Mal angefordert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175000266303644)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175137792303644)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Daten werden nicht gecacht und jedes Mal angefordert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612451869303177)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612572926303177)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Ergebnis wird nicht gecacht. Die Daten werden f\00FCr jede Anforderung aus der Remotedatenbank abgerufen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610604988303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie aus, wie die &PRODUCT_NAME.-Engine Daten in der lokalen Datenbank cachen kann.'),
'        Wenn Caching verwendet werden kann, wird die Komponente basierend auf den gecachten Ergebnissen wiedergegeben. In diesem Fall erfolgt kein Datenabruf aus der Remotedatenbank.',
unistr('        Gecachte Ergebnisse sorgen f\00FCr eine wesentliche Verbesserung der Performance, insbesondere bei bestehender Latenz zwischen lokaler und Remotedatenbank.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610703331303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr alle Benutzer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610873927303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'de'
,p_message_text=>'Das Ergebnis wird gecacht und von allen Benutzern verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611127250303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'de'
,p_message_text=>'Pro Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611231634303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Ergebnis wird speziell f\00FCr jede Benutzersession gecacht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610977714303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'de'
,p_message_text=>'Pro Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611041488303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Ergebnis wird speziell f\00FCr jeden Benutzer \00FCber Sessions hinweg gecacht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610549625303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Caching'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611582763303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Daten laufen 15 Minuten nach dem Cachen ab</dt>',
'  <dd><pre>15</pre></dd>',
'<dt>Daten laufen zur vollen Stunde ab</dt>',
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
'<dt>Daten laufen um Mitternacht ab</dt>',
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611474657303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie ein, wann gecachte Daten ung\00FCltig werden sollen.'),
'        Geben Sie entweder die Anzahl der Minuten oder eine DBMS_SCHEDULER-Kalenderzeichenfolge ein.</p>',
unistr('        <p>F\00FCr die DBMS_SCHEDULER-Kalenderzeichenfolge k\00F6nnen Sie festlegen, dass die gecachten Daten zur vollen Stunde, um Mitternacht oder zu einem anderen wiederkehrenden Zeitpunkt ung\00FCltig werden.'),
unistr('        N\00E4here Einzelheiten finden Sie in der Dokumentation zu DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611310747303176)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Cachetimeout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848581797303374)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie einen alphanumerischen Alias f\00FCr diese Region von interaktiven Berichten ein. '),
'Der Alias muss in der Anwendung eindeutig sein. ',
unistr('Sie k\00F6nnen einen Alias verwenden, um eine Region von interaktiven Berichten im benutzerdefinierten API-Aufruf zu referenzieren. '),
unistr('Beispiel: Sie k\00F6nnen eine Funktion schreiben, um die <code>INTERACTIVE_REPORT_ID</code> zur\00FCckzugeben, indem Sie die <code>ALIAS</code>-Spalte in der Ansicht <code>APEX_APPLICATION_PAGE_IR</code> abfragen. '),
unistr('Da sich der Wert <code>INTERACTIVE_REPORT_ID</code> \00E4ndern kann, wenn Sie die Anwendung in eine andere Instanz exportieren und importieren, wird empfohlen, die interaktiven Berichtsregionen mit einem Alias zu referenzieren.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848435534303374)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Regionsaliasname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98842018976303369)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Einschr\00E4nkungen f\00FCr den Datumsbereich der Werteliste. '),
unistr('F\00FCr Datumsspalten kann die Werteliste Optionen f\00FCr die Vergangenheit und/oder Zukunft im Filter in der Dropdown-Liste der Berichtsspalten anzeigen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045295884303541)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'de'
,p_message_text=>'Alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045495669303541)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'de'
,p_message_text=>'Zukunft'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99045304740303541)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'de'
,p_message_text=>'Vergangenheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98841951050303369)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datumsbereiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848772528303374)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie ein Seiten- oder Anwendungsobjekt, in dessen Wert die gespeicherte Berichts-ID gespeichert wird. '),
unistr('Der interaktive Bericht verwendet diesen Elementwert f\00FCr die Verkn\00FCpfung zu einem gespeicherten Bericht. '),
unistr('Beispiel: Sie k\00F6nnen die Liste der gespeicherten Berichte mit Links mit definiertem Elementnamen und gespeicherter Berichts-ID als Wert zur Verkn\00FCpfung mit gespeicherten Standardberichten, \00F6ffentlichen oder privaten Berichten verwenden. '),
'Die gespeicherte Berichts-ID kann aus der View <code>APEX_APPLICATION_PAGE_IR_RPT</code> abgerufen werden. '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98848656518303374)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Berichts-ID-Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989737793303495)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Standardberichtslayout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990324647303496)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Standardberichtslayout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989321244303495)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Berichtslayout f\00FCr das Ausdrucken des Berichts.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98989268436303495)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879667456303400)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein vordefiniertes Berichtstemplate f\00FCr die Anzeige dieses Berichts.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058842215303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'de'
,p_message_text=>'HTML (Standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058900284303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'de'
,p_message_text=>'Erstellt eine Standard-HTML-Tabelle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059025701303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'de'
,p_message_text=>'Vertikaler Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059171957303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt jede Spalte in einer separaten Zeile an'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059278541303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'de'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059345465303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'de'
,p_message_text=>'Exportiert den Bericht als CSV-Datei.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059427609303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'de'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99059529690303552)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'de'
,p_message_text=>'Exportiert den Bericht als XML-Datei.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879527858303400)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881893816303401)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der neben den Berichtssummenwerten angezeigt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881706741303401)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Berichtssummenlabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875171820303396)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Berichtstemplate aus, um Darstellung und Layout dieses klassischen Berichts zu definieren.</p>'),
'        <p>Berichtstemplates werden im Anwendungs-Theme definiert.',
'        Wenn ein klassischer Bericht erstellt wird, wird das Template automatisch auf das Standardberichtstemplate festgelegt, das im aktuellen Theme definiert ist.</p>',
unistr('        <p>Viele Themes enthalten klassische Berichtstemplates zur Anzeige von Daten in einer Tabelle, in Schl\00FCssel/Wert-Paaren, in Suchergebnissen, Karten usw.'),
unistr('        Beachten Sie, dass einige Berichtstemplates, wie Karten und Suchergebnisse, "zeilenbasiert" sind und erwarten, dass Ihre SQL-Abfrage ein bestimmtes Set von Spaltenaliasnamen zur\00FCckgibt, die in dem Template ersetzt werden.<br>'),
'        Universal Theme stellt die folgenden Berichtstemplates bereit:',
'          <dl>',
'            <dt>Alerts</dt>',
'              <dd>Zeigt eine beliebige Anzahl von horizontalen Alerts oder Benachrichtigungen auf Ihrer Seite an.</dd>',
'            <dt>Badge-Liste</dt>',
unistr('              <dd>Zeigt Schl\00FCssel/Wert-Paare in einer dashboard\00E4hnlichen Benutzeroberfl\00E4che an.</dd>'),
'            <dt>Karten</dt>',
unistr('              <dd>Zeigt Berichtsdaten in Karten oder kleinen Bl\00F6cken an und wird besonders zur Darstellung verschiedener Informationen verwendet. Karten k\00F6nnen \00FCber Templateoptionen umfassend angepasst werden.</dd>'),
'            <dt>Kommentare</dt>',
'              <dd>Zeigt Kommentare und andere Meldungen an.</dd>',
'            <dt>Suchergebnisse</dt>',
'              <dd>Zeigt Suchergebnisse im Stil einer Suchmaschine an</dd>',
'            <dt>Standard</dt>',
'              <dd>Dies ist das Standardberichtstemplate zur Anzeige von Daten in einer Tabelle. Es kann mit Templateoptionen umfassend angepasst werden.</dd>',
'            <dt>Timeline</dt>',
unistr('              <dd>Zeigt eine Timeline von Aktionen an. Es ist besonders f\00FCr Homepages, \00C4nderungslogs und andere Bereiche geeignet, bei denen ein Aktivit\00E4tsfeed der letzten Aktionen ben\00F6tigt wird.</dd>'),
'            <dt>Wert/Attribut-Paare - Spalte</dt>',
unistr('              <dd>Zeigt Schl\00FCssel/Wert-Paare f\00FCr spaltenbasierte Abfragen an. Es verwendet den Spaltenheader als Label f\00FCr jedes Element.</dd>'),
'            <dt>Wert/Attribut-Paare - Zeile</dt>',
unistr('              <dd>Zeigt Schl\00FCssel/Wert-Paare f\00FCr zeilenbasierte Abfragen an. Es verwendet die erste Spalte f\00FCr Labels und die zweite Spalte f\00FCr Werte.</dd>'),
'          </dl>',
'          Siehe auch: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme-Beispielanwendung</a>',
'        </p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875006036303396)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736979568303286)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob verhindert werden soll, dass das interaktive Grid Daten anzeigt, wenn nicht mindestens ein Filter f\00FCr eine der Berichtsspalten angegeben ist.'),
unistr('		Diese Option soll die Daten begrenzen, die aus einem sehr gro\00DFen Dataset geladen werden, indem die zur\00FCckgegebenen Zeilen basierend auf einem Filter eingeschr\00E4nkt werden.</p>'),
unistr('		<p>F\00FCr einzelne Spalten kann <strong>Spaltenfilter erforderlich</strong> aktiviert werden, sodass ein Filter f\00FCr diese Spalte erforderlich ist, w\00E4hrend diese Option nur einen Filter spalten\00FCbergreifend erfordert.</p>'),
'		<p>Hinweis - Wenn diese Option festgelegt ist und aktuell keine Filter definiert sind. wird eine Meldung angezeigt, mit der die Benutzer zur Eingabe eines Filters aufgefordert werden.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736801573303286)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erfordert Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98893055722303411)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Alle Zeichen k\00F6nnen gespeichert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535827611303118)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, wie die Zeichen begrenzt werden, die im Sessionzustand gespeichert werden k\00F6nnen.'),
unistr('&PRODUCT_NAME. zeigt eine Fehlermeldung an, wenn ein Benutzer versucht, Daten zu speichern, die der ausgew\00E4hlten Zeichenbegrenzung nicht entsprechen.</p>'),
unistr('<p>Die Begrenzung der Zeichen verbessert die Anwendungssicherheit und ist eine m\00F6gliche Gegenma\00DFname gegen Angriffe durch website\00FCbergreifendes Skripting (XSS).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034124878303531)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'de'
,p_message_text=>'&<>"/;,*|=% und -- auf Sperrliste setzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034250263303531)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden Zeichen: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % and "--" (PL/SQL-Kommentar) k\00F6nnen NICHT gespeichert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034377187303532)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'de'
,p_message_text=>'&<>"/;,*|=% oder -- und Zeilenvorschub auf Sperrliste setzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034406488303532)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden Zeichen: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % and "--" und Zeilenvorschubzeichen k\00F6nnen NICHT gespeichert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033707659303531)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'de'
,p_message_text=>unistr('Ausnahmeliste f\00FCr a-Z, 0-9 und Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033812509303531)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Nur die Zeichen a-z, A-Z, 0-9 und Leerzeichen k\00F6nnen gespeichert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033998031303531)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'de'
,p_message_text=>'HTML-Befehlszeichen (<>") auf Sperrliste setzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034042615303531)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Reservierte HTML-Zeichen k\00F6nnen NICHT gespeichert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99034591846303532)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'de'
,p_message_text=>'Workspace-Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535730029303118)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Eingeschr\00E4nkte Zeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299949939303751)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Eingabeformat f\00FCr den gerenderten Inhalt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300039824303751)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'de'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300165190303751)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Inhalt enth\00E4lt HTML-Tags und wird ohne die Anwendung maskierter Sonderzeichen gerendert. Stellen Sie sicher, dass die Daten sicher sind und keine vom Endbenutzer eingegebenen Daten enthalten, um Sicherheitsl\00FCcken durch Cross-Side Scripting (XSS) ')
||'zu verhindern.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300286018303751)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'de'
,p_message_text=>'Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300354380303751)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Der Inhalt enth\00E4lt Markdown-Tags, die vor dem Rendering in sichere HTML-Tags \00FCbersetzt werden. Durch das \00DCbersetzen bekannter Markdown-Tags werden Sicherheitsl\00FCcken durch Cross-Side Scripting (XSS) <strong>verhindert</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99299863627303751)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736168124303285)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte, in der die Zeilenversionsnummer f\00FCr die zu aktualisierende Tabelle gespeichert ist. Diese Spalte wird in der Pr\00FCfung auf verlorenes Update verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736007966303285)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilenversionsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859736267303383)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie oft dieser Prozess ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049823533303544)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Einmal pro Seitenaufruf (Standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99049729255303544)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'de'
,p_message_text=>unistr('Einmal pro Session oder beim Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859695894303383)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Prozess ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845553288303372)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie ein Autorisierungsschema, um zu begrenzen, wer \00F6ffentliche Berichtsdefinitionen speichern kann.'),
unistr('Damit ein Endbenutzer einen \00F6ffentlichen Bericht speichern kann, muss die Auswertung dieses Autorisierungsschemas TRUE ergeben.'),
unistr('Wenn kein Autorisierungsschema angegeben wird, k\00F6nnen Berichte von jedem Benutzer gespeichert werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845408999303372)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Autorisierung f\00FCr \00F6ffentlichen Bericht speichern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617924631303181)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob Werte im Sessionzustand in der Datenbank gespeichert werden, bevor die Verzweigung ausgef\00FChrt wird.'),
unistr('Sie m\00FCssen dieses Attribut auf <strong>Ein</strong> setzen, wenn Sie zu einer anderen Anwendung navigieren, die auf die Sessionzustandswerte aus dieser Anwendung zugreifen muss.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617874375303181)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Status vor dem Verzweigen speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604880327303171)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das als Override-Parsingschema verwendet werden soll. Dies gilt nur f\00FCr interne Anwendungen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604740960303171)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schema-Override-Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224798321303683)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224652096303683)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223969762303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Legen Sie fest, wie dieses Autorisierungsschema angewendet werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224098537303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>'Exists-SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224149973303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Autorisierung ist erfolgreich, wenn die Abfrage einen Wert zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224425511303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktion, die Boolean zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224551025303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen booleschen Wert zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224292468303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>'Not Exists-SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224371131303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Autorisierung ist erfolgreich, wenn die Abfrage keinen Wert zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99223859324303682)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schematyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845799029303372)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text f\00FCr das Label der Suchschaltfl\00E4che ein. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845673011303372)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Label der Suchen-Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207333241303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Komponente mit einer Spalte oder mit erweiterter Formatierung unter Verwendung von HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207220938303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Formatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207528071303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als sekund\00E4rer Hauptteil verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207448567303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99208026319303670)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207941236303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207896848303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Hintergrund- und Textfarben \00E4ndern</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\00DCberschrift 2 verwenden</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Eine dynamische Klasse aus der SQL-Abfrage verwenden</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&COLUMN_CLASS.</code> und <code>&EMPLOYEE_STATUS.</code> in diesem Beispiels sind Spalten, die in der Berichts-SQL-Abfrage ausgew\00E4hlt werden.</dd>'),
'  <dt>Beim Mouseover ein Bild und ein QuickInfo anzeigen</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207792087303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die in dieser Spalte angezeigt werden sollen. Verwenden Sie die <code>&COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99207655050303669)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603603951303170)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie <strong>Ein</strong> an, damit das Sessionmanagementcookie vom Browser nur gesendet wird, wenn das HTTPS-Protokoll verwendet wird.',
unistr('W\00E4hlen Sie <strong>Aus</strong>, damit das Sessionmanagementcookie vom Browser gesendet wird, wenn das HTTP- oder HTTPS-Protokoll verwendet wird.</p>'),
unistr('<p>Wenn SSL auf Ihrem Webserver konfiguriert ist, w\00E4hlen Sie <strong>Ein</strong> aus, um die Sicherheit Ihrer Anwendung zu verbessern, indem unverschl\00FCsselter HTTP-Traffic vermieden wird.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98603535649303170)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sicher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760133950303305)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob die erste Zeile automatisch ausgew\00E4hlt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760033393303305)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Erste Zeile ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900213958303417)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenreihendiagrammtyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794733548303332)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Spaltennamen, der f\00FCr die Definition Ihrer dynamischen Abfrage mit mehreren Datenreihen verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98794604512303332)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenreihenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535294109303117)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Schutzebene f\00FCr den Sessionzustand.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032976601303530)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsumme erforderlich: Anwendungsebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033027354303530)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann festgelegt werden, indem es in einer URL \00FCbergeben wird, die eine Pr\00FCfsumme enth\00E4lt, die f\00FCr den Workspace und die Anwendung spezifisch ist. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033570302303531)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'de'
,p_message_text=>unistr('Eingeschr\00E4nkt: Darf nicht vom Browser festgelegt werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033661607303531)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Das Element kann nicht mit URL oder POSTDATA ge\00E4ndert werden.'),
unistr('W\00E4hlen Sie diese Option, um einzuschr\00E4nken, was den Elementwert auf interne Prozesse, Berechnungen usw. setzen kann.'),
unistr('Dieses Attribut gilt nur f\00FCr Elemente, die nicht als Dateneintrag verwendet werden und immer beobachtet werden, selbst wenn "Sessionzustandsschutz" deaktiviert ist.'),
unistr('Verwenden Sie dieses Attribut f\00FCr Seiten- oder Anwendungselemente, die die folgenden Typen f\00FCr <strong>Anzeigen als</strong> haben:'),
'<ul>',
'  <li>Nur anzeigen (Status speichern=Nein)</li>',
'  <li>Textfeld (Deaktiviert, speichert Status nicht)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032785754303530)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>unistr('Uneingeschr\00E4nkt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032891360303530)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann festgelegt werden, indem es in einer URL oder einer Form \00FCbergeben wird. In der URL ist keine Pr\00FCfsumme erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033133191303530)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsumme erforderlich: Benutzerebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033205608303531)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann festgelegt werden, indem es in einer URL \00FCbergeben wird, die eine Pr\00FCfsumme enth\00E4lt, die f\00FCr den Workspace, die Anwendung und den Benutzer spezifisch ist. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033382252303531)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsumme erforderlich: Sessionebene')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99033403928303531)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann festgelegt werden, indem es in einer URL \00FCbergeben wird, die eine  f\00FCr die Session spezifische Pr\00FCfsumme enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98535165799303117)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schutz f\00FCr den Sessionzustand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557114889303135)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Filtergruppe aus, mit der dieses Kontrollk\00E4stchen verkn\00FCpft wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557083969303135)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Filtergruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320480706303769)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99224862273303683)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320598040303769)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855944285303380)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob das Men\00FC <em>Aktionen</em> in der Suchleiste enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855865155303380)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC "Aktionen" einbeziehen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853163723303378)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Aggregate f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853033207303378)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aggregat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838821201303366)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Spalte standardm\00E4\00DFig in dem Bericht angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98838709567303366)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Standardm\00E4\00DFig anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853322736303378)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Diagramme f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853244224303378)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852938384303378)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Berechnungsspalten f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852810389303378)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Berechnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852521415303377)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Gruppenwechsel f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852412040303377)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Kontrollgruppenwechsel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557576981303135)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob das Facet-Label neben den zugeh\00F6rigen ausgew\00E4hlten Werten in der Liste der aktuellen Facets angezeigt werden soll. Blenden Sie das Label aus, wenn der ausgew\00E4hlte Wert selbsterkl\00E4rend ist, z.B. bei einem Bestellstatus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98557423597303135)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Label f\00FCr aktuelles Facet anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855517591303380)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie an, ob ein separater Dropdown-Zeilenselektor in der Suchleiste enthalten ist.',
unistr('Sie sollten dieses Attribut nicht zusammen mit <strong>Zeilen pro Seite</strong> ausw\00E4hlen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855403765303380)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilen pro Seite-Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854328992303379)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer den Bericht in einem der angegebenen Downloadformate herunterladen k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854220090303379)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851715439303377)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Filter f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851637353303377)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855390641303380)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie an, ob das Dropdown-Feld f\00FCr die Suche am Anfang des Suchfeldes in der Suchleiste enthalten ist.'),
unistr('Das Dropdown-Feld f\00FCr die Suche ist eine Liste mit Spalten, mit der Benutzer die Suche auf eine bestimmte Spalte begrenzen k\00F6nnen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855208553303379)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Dropdown f\00FCr Suche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853961628303378)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer Flashback Querys f\00FCr diesen Bericht verwenden k\00F6nnen.</p>'),
unistr('<p>Flashback-Abfragen nutzen die Oracle Flashback-Technologie und das Database Point-in-Time Recovery zur Anzeige von Daten, wie sie zu einem vorherigen Zeitpunkt vorhanden waren. Benutzer k\00F6nnen nur diese Daten abfragen, k\00F6nnen jedoch keine Daten\00E4nd')
||unistr('erungen r\00FCckg\00E4ngig machen. Wie weit zur\00FCck ein Flashback erfolgreich vorgenommen werden kann, h\00E4ngt davon ab, wann die Redo-Logdateien zuletzt in der Oracle-Datenbank gewechselt wurden, weil diese Technologie das RMAN-Backup verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853805131303378)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853768828303378)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer "Gruppieren nach"-Aufgliederungen f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853619577303378)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gruppieren nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791520928303330)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob der Gruppenname in der QuickInfo angezeigt werden soll, die in dem Diagramm gerendert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791452155303330)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gruppenname anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854528095303379)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer den integrierten modalen Hilfedialog f\00FCr interaktive Berichte aufrufen k\00F6nnen.</p>'),
unistr('<p>Im Hilfedialog werden nur die Optionen aufgef\00FChrt, die f\00FCr den aktuellen Benutzer verf\00FCgbar sind.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854425923303379)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852716316303377)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Markierungen f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852628829303377)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Markierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176241152303645)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob dieser Layer in der Legende angezeigt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176197567303645)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853574520303378)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Subscription-Einstellungen f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98853497877303378)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Subscription'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844989370303371)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Text an, der f\00FCr Nullspalten angezeigt werden soll.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98844882445303371)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nullwerte anzeigen als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153689773302809)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt an, ob Endbenutzer Pivot-Aufgliederungen f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153503338302809)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530604596303114)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Schnellauswahlm\00F6glichkeiten f\00FCr dieses Seitenelement angezeigt werden.'),
unistr('Mit einer Schnellauswahl k\00F6nnen Benutzer vordefinierte Werte nur mit einem Klick w\00E4hlen, anstatt Text eingeben oder eine Auswahl aus einer Liste mit verf\00FCgbaren Optionen treffen zu m\00FCssen.</p>'),
unistr('<p>Sie sollten Schnellauswahlm\00F6glichkeiten bei einer relativ kleinen, \00FCberschaubaren Menge von <em>allgemeinen</em> Eingabewerten angeben.'),
unistr('F\00FCr ein Element k\00F6nnen maximal zehn Schnellauswahlm\00F6glichkeiten definiert werden.'),
unistr('Diese Benutzerhilfen eignen sich besonders gut, wenn sie f\00FCr ein Element mit einer l\00E4ngeren Auswahlliste verf\00FCgbarer Werte definiert werden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98530519499303113)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Schnellauswahl anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856138102303380)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob die Berichtsauswahlliste in der Suchleiste angezeigt wird.</p>',
unistr('<p>Die Berichtsauswahlliste wird nur angezeigt, wenn ein Bericht, mit Ausnahme des Prim\00E4rberichts, f\00FCr den Benutzer zug\00E4nglich ist.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98856023703303380)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Berichtauswahlliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854184146303379)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Endbenutzer ihre Berichte aus dem Men\00FC "Aktionen" zur\00FCcksetzen k\00F6nnen.</p>'),
unistr('<p>Wenn der Bericht zur\00FCckgesetzt wird, werden alle vom Benutzer vorgenommenen oder von der aufrufenden URL angegebenen Anpassungen wiederhergestellt. Danach wird der Prim\00E4rbericht wieder angezeigt. </p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98854069243303378)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852162691303377)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer die Anzahl von Zeilen \00E4ndern k\00F6nnen, die f\00FCr diesen Bericht angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852005363303377)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilen pro Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855778721303380)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob das Suchfeld in der Suchleiste enthalten ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98855689177303380)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Suchfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851961053303377)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer im Men\00FC "Aktionen" <strong>Spalten ausw\00E4hlen</strong> verwenden k\00F6nnen, um die in diesem Bericht angezeigten Spalten zu \00E4ndern. Benutzer k\00F6nnen mit dieser Option mehrere Spalten ausw\00E4hlen (oder anzeigen), deren Auswahl au')
||'fheben (sie ausblenden) oder sie neu anordnen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98851834217303377)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791397028303330)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob der Datenreihenname in der QuickInfo angezeigt werden soll, die in dem Diagramm gerendert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98791266973303330)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenreihenname anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852331049303377)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Endbenutzer Sortierspalten f\00FCr diesen Bericht definieren k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98852250369303377)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sortierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556511344303134)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob das Label des Filters oder nur der Wert im Suggestion-Chip angezeigt werden soll. Blenden Sie das Label aus, wenn der vorgeschlagene Wert selbsterkl\00E4rend ist, z. B. bei einem Bestellstatus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556487479303134)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737928555303287)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob eine Symbolleiste \00FCber dem Bericht angezeigt wird. Die Symbolleiste kann Funktionen zu Suche, Berichtstyp, gespeicherten Berichten, Aktionen, \00C4nderung und Zur\00FCcksetzung enthalten. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737820210303286)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737726351303286)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob die Gesamtanzahl von Zeilen im Berichtsfooter angezeigt werden soll.<p/>',
unistr('        <p>Hinweis - Eine zus\00E4tzliche Abfrage wird ausgef\00FChrt, um die Gesamtanzahl von Zeilen abzurufen; dies kann sich negativ auf die Performance auswirken, insbesondere bei sehr gro\00DFen Datasets.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98737660075303286)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gesamtanzahl von Zeilen anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873120303303394)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bei dem Anzeigetyp "Einfaches Kontrollk\00E4stchen" geben Sie entweder einen Wert oder zwei durch Komma getrennte Werte ein.'),
unistr('Der erste Wert wird weitergeleitet, wenn das Kontrollk\00E4stchen ausgew\00E4hlt wird. Der zweite Wert, sofern definiert, wird weitergeleitet, wenn die Auswahl des Kontrollk\00E4stchens aufgehoben wird.'','),
'        p_examples           => q''~<dl>',
unistr('<dt>Leitet "Ja" weiter, wenn es ausgew\00E4hlt wird, und "Nein", wenn die Auswahl aufgehoben wird</dt>'),
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98873087978303394)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchenwerte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839494653303367)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie das Spaltenlabel ein, das in der Single Row-Ansicht verwendet werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839324427303366)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881059582303401)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie bei Berichtsspalten, bei denen nach Spalten\00FCberschrift sortiert werden kann, wie die Datens\00E4tze mit Nullwerten bezogen auf Datens\00E4tze mit Nicht-Nullwerten sortiert werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060609559303553)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'de'
,p_message_text=>'Erster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060734956303553)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Datens\00E4tze mit einem Nullwert werden vor Spalten mit Nicht-Nullwerten angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060845629303553)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'de'
,p_message_text=>'Letzte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99060966785303553)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Datens\00E4tze mit Nicht-Nullwerten werden vor Spalten mit Nullwerten angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880923934303401)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Nullen sortieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154386231302809)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Navigationspfadliste, die mit dieser Seite verkn\00FCpft ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154210965302809)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386890530303824)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie den Datenbankspaltennamen unter Beachtung der Gro\00DF-/Kleinschreibung ein, der als Quelle f\00FCr dieses Facet verwendet wird.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99195297970303659)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie den Datenbankspaltennamen unter Beachtung der Gro\00DF-/Kleinschreibung ein, der als Quelle f\00FCr dieses Facet verwendet wird.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558559367303136)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie den Datenbankspaltennamen unter Beachtung der Gro\00DF-/Kleinschreibung ein, der als Quelle f\00FCr diesen Filter verwendet wird.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559695967303137)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie den Datenbankspaltennamen unter Beachtung der Gro\00DF-/Kleinschreibung ein, der als Quelle f\00FCr diesen Filter verwendet wird.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529479277303113)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Datenbankspaltennamen unter Beachtung der Gro\00DF-/Kleinschreibung ein, der als Quelle f\00FCr diesen Elementwert verwendet wird.</p>'),
unistr('<p>Diese Spalte muss in der Tabelle enthalten sein, die in dem integrierten Prozess f\00FCr den Zeilenabruf angegeben wird, der auf dieser Seite definiert wird.'),
unistr('Ein Fehler wird ausgel\00F6st und die Seite wird nicht geladen, wenn der Datenbankspaltenname in der referenzierten Tabelle nicht vorhanden ist.'),
unistr('Wenn kein integrierter Prozess f\00FCr den Zeilenabruf definiert ist, und ein Element mit einem Quelltyp <strong>Datenbankspalte</strong> vorhanden ist, wird ebenfalls ein Fehler ausgel\00F6st und die Seite wird nicht geladen, wenn versucht wird, die Seite w')
||'iederzugeben.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529342599303113)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267879648303724)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268245401303725)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268181250303724)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268033753303724)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268350484303725)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267905516303724)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99267791406303724)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965799197303475)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Region aus, die mit dieser Facet-Suche oder einer Region mit intelligentem Filter verkn\00FCpft ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965625311303475)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Gefilterte Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269875417303726)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270160022303726)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270079419303726)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269955220303726)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270227362303726)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269762925303726)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529277214303112)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Seiten- oder Anwendungselement ein, das als Quelle f\00FCr diesen Elementwert verwendet werden soll. '),
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529100307303112)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298610399303750)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den auszuf\00FChrenden Java-Code ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298538851303750)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269435470303726)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269388612303725)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271040319303727)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen Wert zur\00FCckgibt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270989652303727)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298477679303749)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Gehalt um 3 % erh\00F6hen f\00FCr Mitarbeiter, denen eine Gehaltserh\00F6hung zusteht:</dt>'),
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
unistr('    //  Platzhalter f\00FCr komplizierte Logik zur Berechnung, ob dem Mitarbeiter eine Gehaltserh\00F6hung zusteht'),
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298356618303749)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den auszuf\00FChrenden JavaScript-Code ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298233715303749)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269256839303725)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269194678303725)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269039830303725)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270841229303727)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270704608303727)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270604426303727)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154124812302809)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Quelle f\00FCr diese Liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154021861302809)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611772276303176)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Speicherort der Daten aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611848099303177)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'de'
,p_message_text=>'Lokale Datenbank'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611968889303177)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'de'
,p_message_text=>'Daten werden aus der lokalen Datenbank bezogen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612035079303177)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4hige SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612108520303177)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Daten werden aus einer Remotedatenbank bezogen, sofern die Verbindung \00FCber eine REST-f\00E4hige SQL definiert ist. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722218936303273)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'de'
,p_message_text=>'REST-Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99328831781303776)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Daten werden aus einem RESTful Webservice bezogen, der \00FCber REST-Datenquellen definiert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98611610805303176)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807449504303342)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine durch Komma getrennte Liste mit Seitenelementen auf der aktuellen Seite an, die im Sessionzustand festgelegt werden sollen, wenn die Diagrammdaten mit einer separaten Anforderung gelesen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99174937509303644)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine durch Komma getrennte Liste mit Seitenelementen auf der aktuellen Seite an, die im Sessionzustand festgelegt werden sollen, wenn die Kartendaten mit einer separaten Anforderung abgerufen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604673017303171)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Seiten- oder Anwendungselemente ein, die in den Sessionzustand gesetzt werden sollen, wenn die Region durch eine teilweise Seitenaktualisierung aktualisiert wird.',
'Trennen Sie mehrere Elementnamen durch ein Komma.',
unistr('Sie k\00F6nnen den Namen eingeben oder aus einer Liste der verf\00FCgbaren Elemente ausw\00E4hlen.'),
unistr('Wenn Sie den Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird ein Komma an das Ende des vorhandenen Textes gesetzt, gefolgt von dem Elementnamen, der aus der Liste zur\00FCckgegeben wird.</p>'),
unistr('<p>Die Region kann mit einer teilweisen Seitenaktualisierung w\00E4hrend der Paginierung aktualisiert werden, wenn <em>Aktualisierung von Seitenbestandteilen aktivieren</em> auf <strong>Ein</strong>) gesetzt ist. Sie kann aber auch mit der Aktualisierung')
||'saktion innerhalb einer dynamischen Aktion aktualisiert werden.</p>',
unistr('Diese Seitenelemente k\00F6nnen dann in der <em>Where-Bedingung</em> der SQL-Abfrage f\00FCr die Regionsquelle verwendet werden, um das Abfrageergebnis einzugrenzen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98604583567303171)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Weiterzuleitende Seitenelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298110048303749)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Gehalt um 3 % erh\00F6hen f\00FCr Mitarbeiter, denen eine Gehaltserh\00F6hung zusteht:</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298059859303749)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den auszuf\00FChrenden PL/SQL-Code ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297949472303749)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268984953303725)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268863015303725)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268784613303725)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270578878303726)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270489465303726)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99270343370303726)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334131899303780)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'de'
,p_message_text=>'Legen Sie fest, wie die abgerufenen REST-Quellendaten in der lokalen Datenbank nachverarbeitet werden sollen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334651481303781)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334762715303781)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, bei dem die zur\00FCckgegebene SQL-Abfrage die abgerufenen Daten transformiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334499825303781)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334518358303781)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine SQL-Abfrage ein, um die abgerufenen Daten zu transformieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334244328303781)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'de'
,p_message_text=>'Where-/Order By-Klausel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334361709303781)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Where- und/oder Order by-Klausel ein, um die abgerufenen Daten einzuschr\00E4nken oder zu sortieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99334011421303780)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529634277303113)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Benutzervoreinstellung ein, die als Quelle f\00FCr diesen Elementwert verwendet werden muss.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529587481303113)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298834918303750)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den auszuf\00FChrenden Python-Code ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99298746270303750)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269605883303726)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99269518960303726)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271259759303727)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen Wert zur\00FCckgibt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99271196053303727)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528867536303112)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Abfrage ein, die als Quelle f\00FCr diesen Elementwert verwendet wird. Wenn mehr als eine Zeile zur\00FCckgegeben wird, wird der Wert der ersten Zeile verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528724230303112)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98529080104303112)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Abfrage ein, die mindestens eine Zeile zur\00FCckgibt, die als Quelle f\00FCr diesen Elementwert verwendet werden muss. Wenn das Ergebnis mehrere Zeilen enth\00E4lt, wird der Wert aus jeder Zeile zu einem einzelnen durch Doppelpunkt begrenzten ')
||'Wert geformt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528983714303112)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278235863303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278583302303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278497611303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278399710303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278611051303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278132223303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279449052303734)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der eine SQL-Abfrage f\00FCr die Diagrammreihe zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279337224303734)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Java-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279201167303734)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Spalten EMPNO, ENAME und SAL ausw\00E4hlen und alle Zeilen mit einem SAL-Wert unter 3000 herausfiltern.</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279176083303734)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der eine SQL-Abfrage f\00FCr die Diagrammreihe zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279053292303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610211470303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Die zuletzt eingestellten Mitarbeiter zuerst und die noch nicht eingestellten Mitarbeiter zuletzt anzeigen. Bei identischem Datum werden die Mitarbeiter nach Abteilungsnummer sortiert.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610110350303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie mindestens eine durch Komma getrennte Spalte (einschlie\00DFlich Direktiven) ein, um die Reihenfolge zu definieren, in der Datens\00E4tze abgerufen werden.</p>'),
'        <p>Direktiven umfassen:',
'          <ul>',
unistr('            <li>ASC - Spalte in aufsteigender Reihenfolge zur\00FCckgeben</li>'),
unistr('            <li>DESC - Spalte in absteigender Reihenfolge zur\00FCckgeben</li>'),
unistr('            <li>NULLS FIRST - Spalten ohne Wert vor Spalten mit Werten zur\00FCckgeben</li>'),
unistr('            <li>NULLS LAST - Spalten mit Werten vor Spalten ohne Wert zur\00FCckgeben</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610065214303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sortieren nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609411787303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Schema aus, dem die Tabelle geh\00F6rt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609365921303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Tabelleneigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722813361303274)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine PL/SQL-Funktion ein, die eine SQL-Abfrage zur\00FCckgibt, die als Basis f\00FCr diese Region verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722741679303274)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278955270303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Spalten EMPNO, ENAME und SAL ausw\00E4hlen und alle Zeilen mit einem SAL-Wert unter 3000 herausfiltern.</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278862003303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der eine SQL-Abfrage f\00FCr die Diagrammreihe zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99278728100303733)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279690081303734)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der eine SQL-Abfrage f\00FCr die Diagrammreihe zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99279518912303734)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Python-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609655361303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609545881303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Tabellenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609031739303174)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie aus, wie die Daten abgefragt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722302002303273)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722496497303273)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Daten werden basierend auf der SQL-Abfrage abgerufen, die durch Ausf\00FChren eines Funktionsbodys zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612262060303177)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612347393303177)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Daten werden anhand einer SQL-Abfrage abgerufen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609137720303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'de'
,p_message_text=>'Tabelle/View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609206592303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'de'
,p_message_text=>'Die Daten werden anhand einer Tabelle oder View abgerufen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608913428303174)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609905011303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Nur Mitarbeiter einbeziehen, die einen Manager haben oder SALESMAN sind.</dt>',
'<dd><pre>',
'( MGR ist nicht Null oder JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609811010303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine g\00FCltige SQL-Where-Bedingung ein, mit der die abgerufenen Datens\00E4tze eingeschr\00E4nkt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98609718647303175)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'WHERE-Klausel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608889944303174)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Remotedatenbankserver aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608747845303174)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Remoteserver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297484605303749)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Code ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297720311303749)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297678460303749)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297571842303749)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297893606303749)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99297348116303749)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98923063839303436)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zur Verkettung zweier Spalten:</dt>',
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
'<dt>Inner Select einbeziehen:</dt>',
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747351048303295)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den SQL-Ausdruck ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98747224238303294)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268662527303725)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter ein Manager ist und sich seine Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268545178303725)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen SQL-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99268467967303725)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177114498303645)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Abfrage, die L\00E4ngen- und Breitengradwerte als NUMBER-Spalten zur\00FCckgibt:</p>'),
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>Abfrage, die den Kundenstandort als SDO_GEOMETRY-Spalte zur\00FCckgibt:</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610412374303175)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Quelle f\00FCr diese Komponente ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98610307522303175)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528653954303112)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den statischen Wert ein, der als Quelle f\00FCr diesen Elementwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528565033303112)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528457875303112)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Quelltyp des Wertes aus, auf dem dieses Element basiert.</p>'),
unistr('<p>Hinweis: Wenn <strong>Quelle: Verwendet</strong> auf <em>Nur, wenn der aktuelle Wert im Sessionzustand Null ist</em> festgelegt ist, wird die Quelle nicht verwendet, wenn f\00FCr dieses Element ein Wert im Sessionzustand festgelegt wurde.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031598774303529)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226821038303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>'Wird auf Null festgelegt, weil kein Wert angegeben ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031788845303529)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226251783303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den in <em>Datenbankspalte</em> eingegebenen Wert festgelegt, der aus einer integrierten Prozedur zum Abruf von Zeilen abgerufen wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247501164303707)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99247666683303707)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der sich aus der Ausf\00FChrung des eingegebenen <em>Ausdrucks</em> ergibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032012073303529)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226691944303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert gesetzt, der vom eingegebenen <em>Funktionsbody</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032125112303530)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226319260303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Element</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99032257742303530)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226771526303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Wert der eingegebenen <em>Voreinstellung</em> festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031875095303529)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage (einzelner Wert wird zur\00FCckgegeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226402699303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den ersten Wert festgelegt, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031939607303529)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage (durch Doppelpunkte getrennten Wert zur\00FCckgeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226501883303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf einen einzelnen durch Doppelpunkt getrennten Wert festgelegt, der jeden Zeilenwert verkettet, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031630628303529)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99226153105303684)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Text festgelegt, der in <em>Statischen Wert</em> eingegeben wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528310664303112)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528275326303112)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p> W\00E4hlen Sie, welcher Wert Priorit\00E4t hat: der Wert aus dem Sessionzustand oder der Wert der Elementquelle.</p>'),
unistr('<p>F\00FCr Elemente mit dem Quelltyp <strong>Datenbankspalte</strong> m\00FCssen Sie <strong>Immer</strong> ausw\00E4hlen, es sei denn, Sie m\00F6chten nicht, dass der zugewiesene Vorgang f\00FCr den Zeilenabruf das Element auff\00FCllt, falls die Seite eine Verzweigung zur')
||unistr('\00FCck zu sich selbst ausf\00FChrt. '),
unistr('Bei Elementen mit anderen Quelltypen m\00FCssen Sie entsprechend der jeweiligen Seitenverwendung entscheiden, ob der vorherige Quellwert angezeigt oder der Quelltyp f\00FCr jede Seitenansicht neu angewendet werden soll.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031338221303529)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Werte im Sessionzustand immer ersetzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99031428208303529)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'de'
,p_message_text=>'Nur, wenn der aktuelle Wert im Sessionzustand Null ist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98528164324303112)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Verwendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722661532303274)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die REST-Datenquelle aus, die das Abrufen einer Collection unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98722595287303274)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'REST-Quelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807271027303342)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie in einem geteilten 2Y-Diagramm den Bruchteil des Platzes an, der dem Y-Achsen-Unterdiagramm zugewiesen wird. G\00FCltige Werte sind Zahlen von 0 bis 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807197031303342)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Teilungsposition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806773731303342)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob der Darstellungsbereich in zwei Abschnitte geteilt wird, sodass Datensets, die unterschiedlichen Y-Achsen zugewiesen sind, in unterschiedlichen Teilen des Darstellungsbereichs angezeigt werden. Bei Aktiendiagrammen darf <strong>Nein<'
||'/strong> nicht angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806809609303342)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807014700303342)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806947807303342)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806680313303342)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783969751303324)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Geben Sie an, ob die Datenelemente gestapelt sind.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98783882279303324)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stapel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408038944303015)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen der Stapelkategorie an, der diese Reihe zugewiesen werden soll. Standardm\00E4\00DFig werden alle Reihen eines gestapelten Diagramms in demselben Stapel gruppiert. Um diese Reihe in einem anderen Stapel zu gruppieren, legen Sie eine Stape')
||unistr('lkategorie fest. Sie k\00F6nnen <code>&COLUMN_VALUE.</code>-Substitutionen verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407999105303015)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stapelkategorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407861806303015)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Geben Sie an, ob die Gesamtwerte gestapelter Datenelemente angezeigt werden sollen. Gilt nur f\00FCr Balkendiagramme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407781043303015)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Stapellabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508660307303096)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Standard-Registerkartengruppe f\00FCr diese Seite. Eine Standard-Registerkartengruppe ist einer bestimmten Seitennummer zugeordnet. Sie k\00F6nnen mit Standardregisterkarten Benutzerlinks zu einer bestimmten Seite erstellen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508502167303096)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Standard-Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906719458303422)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den ersten Wochentag aus, der in dem Wochenkalender angezeigt wird.'),
unistr('Sie k\00F6nnen dieses Attribut in Verbindung mit <strong>Endtag</strong> verwenden, um die angezeigten Wochentage zu begrenzen, oder k\00F6nnen einfach den ersten angezeigten Wochentag angeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065597919303557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'de'
,p_message_text=>'Sonntag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065612883303557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'de'
,p_message_text=>'Montag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065787886303557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'de'
,p_message_text=>'Dienstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065836970303557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'de'
,p_message_text=>'Mittwoch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065951065303557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'de'
,p_message_text=>'Donnerstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066077003303557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'de'
,p_message_text=>'Freitag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066129771303557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'de'
,p_message_text=>'Samstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906601242303422)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Starttag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906541870303422)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'de'
,p_message_text=>'Bestimmt den Wochentag, an dem der Monatskalender beginnt. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064881658303556)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'de'
,p_message_text=>'Sonntag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99064972184303556)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'de'
,p_message_text=>'Montag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065047619303557)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'de'
,p_message_text=>'Dienstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065178914303557)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'de'
,p_message_text=>'Mittwoch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065250264303557)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'de'
,p_message_text=>'Donnerstag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065347307303557)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'de'
,p_message_text=>'Freitag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99065460480303557)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'de'
,p_message_text=>'Samstag'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98906455212303422)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Starttag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907310972303422)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Startstunde an, um die Anzeige des Wochen- und Tageskalenders zu fokussieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907266236303422)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Startstunde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98537028395303119)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie den statischen Container eines jQuery-Selektors zur Verwendung durch diese dynamische Aktion ein. ',
unistr('Sie k\00F6nnen die Performance von dynamischen Aktionen verbessern, die einen Ereignisbereich von <strong>Dynamisch</strong> haben.'),
unistr('Dies muss ein Element auf der Seite sein, das selbst nicht neu erstellt wird, sondern die ausl\00F6senden Elemente enth\00E4lt, die mit der teilweisen Seitenaktualisierung (PPR, Partial Page Refresh) neu erstellt werden.'),
'Diese Elementreferenz muss als jQuery-Selektor definiert werden.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536923775303119)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statischer Container (jQuery-Selektor)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547274724303127)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die statische ID f\00FCr die Schaltfl\00E4che ein. Wenn sie definiert ist, wird die statische ID als ID f\00FCr die Schaltfl\00E4che verwendet. Die statische ID kann bei der Entwicklung von benutzerdefiniertem JavaScript-Verhalten f\00FCr die Schaltfl\00E4che n\00FCtz')
||unistr('lich sein. Wenn die statische ID nicht definiert ist, generiert die Schaltfl\00E4che eine interne ID.</p>'),
unistr('<p>Hinweis: Das Template muss die Ersetzungszeichenfolge <code>#BUTTON_ID#</code> enthalten, damit die Schaltfl\00E4che die eingegebene statische ID nutzen kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98751473679303298)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die statische ID f\00FCr die Spalte ein. Die statische ID kann beim Entwickeln des benutzerdefinierten JavaScript-Verhaltens oder des benutzerdefinierten Stils f\00FCr das Spaltenelement n\00FCtzlich sein. Wenn die statische ID nicht definiert ist, wir')
||'d die interne ID als Spaltenelement-ID verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428624861303860)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die statische ID f\00FCr die Spalte ein. Wenn definiert, wird die statische ID als die ID f\00FCr die entsprechende Tabellenheader-(TH-)Zelle und als HEADERS-Wert f\00FCr entsprechende Tabellendaten-(TD-)Zellen verwendet. Die statische ID wird besonder')
||unistr('s bei der Entwicklung von benutzerdefiniertem JavaScript-Verhalten oder benutzerdefinierten Formatvorlagen f\00FCr die Spalte verwendet. Wenn die statische ID nicht definiert ist, generiert die Tabelle eine interne ID f\00FCr diese Attributwerte.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807695159303342)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine statische ID f\00FCr die Diagrammachse an. Die statische ID kann besonders bei der Entwicklung von benutzerdefiniertem JavaScript-Verhalten f\00FCr Diagrammachsen verwendet werden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98807549616303342)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine statische ID f\00FCr die Diagrammdatenreihe an. Die statische ID kann besonders bei der Entwicklung von benutzerdefiniertem JavaScript-Verhalten f\00FCr Diagrammdatenreihen verwendet werden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98606352821303172)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die statische ID f\00FCr diese Region ein. Wenn sie definiert ist, wird sie als ID f\00FCr die Region verwendet, wobei die Ersetzungszeichenfolge <code>#REGION_STATIC_ID#</code> verwendet wird. Dies kann bei der Entwicklung von benutzerdefiniert')
||unistr('em JavaScript-Verhalten f\00FCr die Region n\00FCtzlich sein. Wenn sie nicht definiert ist, generiert die Region eine interne ID.</p>'),
'<p>Hinweis: Das Template muss die Ersetzungszeichenfolge <code>#REGION_STATIC_ID#</code> enthalten, damit die Region die eingegebene statische ID verwendet.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536648607303118)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die statische ID f\00FCr diese Komponente an. Wenn sie definiert ist, ist diese ID n\00FCtzlich, wenn benutzerdefiniertes JavaScript-Verhalten f\00FCr die Komponente entwickelt wird.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98536594633303118)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statische ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818933841303351)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Datenreihentyp f\00FCr das gerenderte Aktiendiagramm.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819000025303351)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Fl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819103105303351)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'de'
,p_message_text=>'Balken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819228321303351)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'de'
,p_message_text=>'Kerzendiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819354566303352)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98819421782303352)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Linien/Fl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818896526303351)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Rendern als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539020109303120)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob die Verarbeitung aller anderen ausstehenden Aktionen gestoppt wird, wenn ein Fehler bei der Ausf\00FChrung der aktuellen Aktion auftritt.</p>'),
unistr('<p>Hinweis: Die Reihenfolge der Ausf\00FChrung bestimmter Aktionen wird von der f\00FCr jede Aktion angegebenen Sequenz bestimmt. Um sicherzustellen, dass Aktionen in derselben Reihenfolge ausgef\00FChrt werden, empfiehlt Oracle, dass die Folgenummern f\00FCr alle T')
||'rue-Aktionen und alle False-Aktionen eindeutig sind.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98538902353303120)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChrung bei Fehler stoppen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616272747303180)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Berichtseinstellung verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616343654303180)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die vom Endbenutzer festgelegte Berichtseinstellung f\00FCr <strong>Dehnen</strong> bestimmt, ob die Spalte gedehnt werden soll oder nicht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615760843303180)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob die Spalte gedehnt werden soll, wenn ausreichend Platz auf dem Bildschirm vorhanden ist. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616022071303180)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'de'
,p_message_text=>'Immer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98616199351303180)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spalte wird immer gedehnt, unabh\00E4ngig davon, welche Berichtseinstellung f\00FCr <strong>Dehnen</strong> der Endbenutzer festgelegt hat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615804846303180)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'de'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615943294303180)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spalte wird nicht gedehnt und immer nur mit der angegebenen Breite angezeigt. Dies bietet sich f\00FCr Spalten mit kurzem Inhalt an, wie "Ja/Nein" oder Zahlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615621812303179)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Dehnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880898117303401)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob HTML-Tags aus den urspr\00FCnglichen Spaltenwerten entfernt werden sollen.'),
unistr('Dies ist besonders f\00FCr Spalten wichtig, die HTML-Ausdr\00FCcke nutzen, in Spaltenlinks verwendet werden oder in CSV-Dateien exportiert werden.</p>'),
unistr('<p>Wenn Sie Werte aus der Datenbank w\00E4hlen, die bereits HTML-Tags enthalten, k\00F6nnen diese Tags zu Konflikten mit dem HTML-Code, der f\00FCr Ihre HTML-Ausdr\00FCcke generiert wurden, oder mit einer URL f\00FChren, die f\00FCr Spaltenlinks generiert wurde.'),
'Wenn derartige Werte exportiert werden, werden die vorhandenen HTML-Tags als einfacher Text in der generierten CSV-Datei aufgenommen.',
'Wenn diese Option aktiviert ist, wird nur der eigentliche Datenteil Ihres Spaltenwertes verwendet.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98880722781303401)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('HTML k\00FCrzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736569313303285)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob gepr\00FCfte Zeilen in der Seitenverarbeitung einbezogen werden sollen, die im Allgemeinen durch eine benutzerdefinierte Schaltfl\00E4che gestartet wird, wie <strong>Als abgeschlossen markieren</strong>.'),
unistr('        Diese gepr\00FCften Zeilen k\00F6nnen dann in einem benutzerdefinierten Prozess zur Ausf\00FChrung der erforderlichen Aktion verwendet werden.</p>'),
unistr('        <p>Hinweis - Die ausgew\00E4hlten Zeilen werden verarbeitet, selbst wenn nichts in der Zeile aktualisiert wurde. Im Allgemeinen werden nur Zeilen, die eingef\00FCgt, aktualisiert oder gel\00F6scht wurden, verarbeitet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98736420192303285)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Weiterleitung bezieht ausgew\00E4hlte Zeilen ein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601237901303168)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Anwendung, deren Authentifizierungsschema dieses Schema abonnieren soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601157885303168)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Abonniert von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205573801303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Komponente mit einer Spalte oder mit erweiterter Formatierung mit HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205474883303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Formatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205777448303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Untertitel verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205627761303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206256270303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206132068303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99206032496303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Hintergrund- und Textfarben \00E4ndern</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\00DCberschrift 2 verwenden</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Eine dynamische Klasse aus der SQL-Abfrage verwenden</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&COLUMN_CLASS.</code> und <code>&EMPLOYEE_STATUS.</code> in diesem Beispiel sind Spalten, die in der Berichts-SQL-Abfrage ausgew\00E4hlt werden.</dd>'),
'  <dt>Beim Mouseover ein Bild und ein QuickInfo anzeigen</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205939755303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die in dieser Spalte angezeigt werden sollen. Verwenden Sie die <code>&COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205897155303668)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98860307179303384)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Erfolgsmeldung f\00FCr diesen Prozess ein.'),
unistr('Wenn der Prozess ausgef\00FChrt wird und keinen Fehler generiert, wird diese Erfolgsmeldung f\00FCr den Prozess im Benachrichtigungsabschnitt der daraufhin angezeigten Ergebnisseite angezeigt.'),
unistr('Wenn Sie \00FCber eine URL-Umleitung eine Verzweigung zu einer anderen Seite vornehmen, m\00FCssen Sie m\00F6glicherweise das Attribut <em>Erfolgsmeldung beibehalten</em> aktivieren.</p>'','),
unistr('<p>Bei mehrzeiligen Prozessen kann die folgende Ersetzungszeichenfolge verwendet werden, um die Anzahl von verarbeiteten Datens\00E4tzen abzurufen:</p>'),
'<ul>',
'  <li>Insert: <code>#MRI_COUNT#</code></li>',
'  <li>Update: <code>#MRU_COUNT#</code></li>',
'  <li>Delete: <code>#MRD_COUNT#</code></li>',
'</ul>',
'<p>Bei dem Prozesstyp "E-Mail senden" kann die Ersetzungszeichenfolge <code>#TO#</code> verwendet werden, um die Adressaten der E-Mail zu ermitteln.</p>',
unistr('<p>Plug-ins k\00F6nnen \00FCber ihre eigenen Ersetzungszeichenfolge verf\00FCgen. Weitere Informationen finden Sie in der Plug-in-Dokumentation.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014776040303516)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den Text ein, der im Bereich "Benachrichtigung" (der als Teil des Seitentemplates definiert ist) angezeigt werden muss, wenn dieser Prozess erfolgreich abgeschlossen wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98859807305303383)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erfolgsmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556384209303134)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die SQL-Abfrage als Quelle f\00FCr Vorschl\00E4ge ein.</p>'),
unistr('<p>Hinweis: Die Reihenfolge, in der die Werte angezeigt werden, wird durch die Reihenfolge bestimmt, in der sie zur\00FCckgegeben wurden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556205191303134)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556109005303134)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine durch Komma getrennte Liste statischer Werte als Quelle f\00FCr Vorschl\00E4ge ein.</p>'),
'<p>Hinweis: Die Reihenfolge, in der die Werte angezeigt werden, wird durch die Reihenfolge bestimmt, in der sie angegeben wurden.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98556047643303134)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98558310403303136)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Kein Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98559067925303136)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Kein Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555337584303133)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie aus, wie Vorschl\00E4ge f\00FCr diesen Filter bestimmt werden.</p>'),
unistr('<p>Hinweis: Die angegebenen Werte werden nach wie vor gegen die sichtbaren Eintr\00E4ge der Werteliste gepr\00FCft und nur bei \00DCbereinstimmung verwendet.'),
unistr('Wenn ein Wert nicht gefunden wird, wird dieser \00FCbersprungen, und der n\00E4chste Wert wird gepr\00FCft.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555480223303133)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'de'
,p_message_text=>'Dynamisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555504106303133)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlt den <strong>ersten</strong> sichtbaren Eintrag aus der Werteliste aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555871659303134)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555970900303134)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Werte werden aus der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555662860303133)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statische Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555751371303134)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Durch Komma getrennte Werteliste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98555272181303133)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824001399303355)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Text ein, der oben in den heruntergeladenen Dateien angezeigt wird. Sie k\00F6nnen die Datenklassifizierung, rechtliche Hinweise oder Warnmeldungen zu den Daten in der Datei eingeben.</p>'),
unistr('        <p> Hinweis: Der eingegebene Text wird in alle Formate von Berichtsdownloads aufgenommen. Wenn der CSV-Download aktiviert ist, macht der definierte Text das CSV-Dateiformat ung\00FCltig.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823959401303355)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Zus\00E4tzlicher Text')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839254275303366)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie dieses Attribut an, wenn Sie den Text der Spalten\00FCberschrift als Label in der Detailansicht verwenden m\00F6chten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98839195124303366)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten\00FCberschrift verwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894512511303412)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Basis f\00FCr diese tabellarisches Formularspalte.</p>'),
'<p>Die Auswahl bestimmt, ob diese Spalte innerhalb des tabellarischen Formulars aktualisierbar ist.',
unistr('Updates k\00F6nnen nur durchgef\00FChrt werden, wenn ein mehrzeiliges Update definiert ist oder ein PL/SQL-Prozess zur Verarbeitung der aktualisierten Daten implementiert ist.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061975249303554)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'de'
,p_message_text=>'Datumsauswahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230398201303693)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Datum ein, oder w\00E4hlen Sie das Datum mit der Datumsauswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061810429303554)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'de'
,p_message_text=>'Datumsauswahl (klassisch)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230445326303693)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das Datum ein, oder w\00E4hlen Sie das Datum mit der Datumsauswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99061758933303554)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'de'
,p_message_text=>'Plain Text (speichert Status)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229010849303686)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt den Spaltenwert an und speichert den Wert im Sessionzustand. Diese Spalte kann bei der Seitenverarbeitung verwendet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063497278303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'de'
,p_message_text=>'BLOB herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229430767303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Link zum Herunterladen der Datei an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062959271303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendete Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230527548303693)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte nicht an, ist jedoch referenzierbar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062416603303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendete Spalte (speichert Status)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230676734303693)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte nicht an, ist jedoch referenzierbar. Diese Spalte kann bei der Seitenverarbeitung verwendet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063396755303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'de'
,p_message_text=>'Bild anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229366781303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Bild an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063255302303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'de'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229233571303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Link an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063536800303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'de'
,p_message_text=>'Prozentdiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229549580303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt die Spalte als Prozentdiagramm an. Der abgerufene Wert muss zwischen 0 und 100 liegen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063048026303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'de'
,p_message_text=>'Nur Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228966747303686)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt den Spaltenwert an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99063189008303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'de'
,p_message_text=>'Nur Text (basierend auf Werteliste)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229130704303686)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt den Wert an, der aus der angegebenen Werteliste zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062554903303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Popup-Werteliste (zeigt R\00FCckgabewert)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230045538303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Wert aus dem Popup-Feld. Der R\00FCckgabewert aus der Werteliste wird angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062687089303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste (zeigt Anzeigewert)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229942566303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Wert aus dem Popup-Feld. Der Anzeigewert aus der Werteliste wird angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062338370303554)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'de'
,p_message_text=>'Optionsgruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230133348303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein einzelnes Optionsfeld aus der angegebenen Werteliste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062862116303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'de'
,p_message_text=>'Zeilenselektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99228855787303686)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Enth\00E4lt ein Kontrollk\00E4stchen am Anfang jeder Zeile.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062293861303554)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'de'
,p_message_text=>'Auswahlliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229878766303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Wert aus der angegebenen Werteliste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062758017303555)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'de'
,p_message_text=>unistr('Einfaches Kontrollk\00E4stchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99230229853303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivieren oder deaktivieren Sie ein einzelnes Kontrollk\00E4stchen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062024676303554)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'de'
,p_message_text=>'Textfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229660438303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Wert in ein Textfeld ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99062133019303554)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'de'
,p_message_text=>'Textbereich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99229786576303692)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Wert in ein Textbereichsfeld ein.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98894479648303412)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617317169303181)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Klicken Sie auf das Ziel, um einen modalen Dialog aufzurufen. Sie k\00F6nnen das Ziel eingeben, das aufgerufen wird, wenn diese Verzeichnung aufgerufen wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98617233596303181)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197860193303661)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie Templateoptionen aus, um die Benutzeroberfl\00E4che dieser Komponente anzupassen.</p>'),
unistr('<p>Sie k\00F6nnen die Templateoptionen auch w\00E4hrend der Ausf\00FChrung der Anwendung mit <strong>Livetemplateoptionen</strong> \00E4ndern.'),
unistr('Mit Livetemplateoptionen k\00F6nnen Sie Ihre Anwendung im Echtzeitverfahren anpassen, sodass Sie eine Vorschau der verschiedenen Optionen anzeigen und diese anwenden k\00F6nnen.'),
unistr('Um Livetemplateoptionen aufzurufen, f\00FChren Sie die Anwendung aus Application Builder aus und klicken auf <em>Schnellbearbeitung</em> in der Entwicklersymbolleiste.'),
unistr('Zeigen Sie mit dem Mauszeiger auf eine Seitenkomponente, wie eine Region, und klicken Sie auf das Schraubenschl\00FCsselsymbol ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) in der oberen linken Ecke.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197770043303661)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Templateoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198013440303662)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie Templateoptionen aus, um die Benutzeroberfl\00E4che dieser Komponente anzupassen.</p>'),
unistr('<p>Sie k\00F6nnen die Templateoptionen auch w\00E4hrend der Ausf\00FChrung der Anwendung mit <strong>Livetemplateoptionen</strong> \00E4ndern.'),
unistr('Mit Livetemplateoptionen k\00F6nnen Sie Ihre Anwendung im Echtzeitverfahren anpassen, sodass Sie eine Vorschau der verschiedenen Optionen anzeigen und diese anwenden k\00F6nnen.'),
unistr('Um Livetemplateoptionen aufzurufen, f\00FChren Sie die Anwendung aus Application Builder aus und klicken auf <em>Schnellbearbeitung</em> in der Entwicklersymbolleiste.'),
unistr('Zeigen Sie mit dem Mauszeiger auf eine Seitenkomponente, wie eine Region, und klicken Sie auf das Schraubenschl\00FCsselsymbol ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) in der oberen linken Ecke.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197947118303662)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Templateoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446118747303046)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'de'
,p_message_text=>'Platzhalter in einem E-Mail-Template.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446044968303045)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Templateplatzhalter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879412718303400)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Templatetyp f\00FCr diesen Bericht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058610936303552)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'de'
,p_message_text=>'Vordefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058785376303552)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Vordefinierte Berichtstemplates, die nicht direkt mit Themes verkn\00FCpft sind. Weil keine Korrelation zwischen diesen vordefinierten Templates und Ihrem aktuellen Theme vorhanden ist, bleibt das Berichtslayout unver\00E4ndert, selbst wenn Sie das Anwendung')
||unistr('s-Theme \00E4ndern. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058401628303551)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99058557956303551)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Berichtstemplates, die in dem entsprechenden Theme vorhanden sind, basierend auf dem aktuellen Theme f\00FCr die Benutzeroberfl\00E4che dieser Seite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98879337927303399)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Templatetyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386647936303824)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie je nach angegebenem <strong>Suchtyp</strong> einen oder eine Liste von Datenbankspaltennamen ein, die f\00FCr die Textsuche verwendet werden.</p>'),
'<ul>',
unistr('  <li><strong>Zeilensuche</strong>: Geben Sie eine durch Komma getrennte Liste mit Datenbankspaltennamen (unter Beachtung der Gro\00DF-/Kleinschreibung) vom Typ VARCHAR2 f\00FCr die Textsuche ein. Wenn keine Spalte angegeben ist, werden automatisch alle VARC')
||'HAR2-Spalten verwendet.</li>',
unistr('  <li><strong>Oracle Text</strong>: Geben Sie den Datenbankspaltennamen unter Beachtung der Gro\00DF-/Kleinschreibung ein, der den Oracle Text-Index enth\00E4lt.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99386533846303824)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Datenbankspalte(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658485774303213)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Theme, das mit der aktuellen Benutzeroberfl\00E4che verkn\00FCpft werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98658393818303212)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806304579303341)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Position der Teilungslabels im Darstellungsbereich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806592268303342)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'de'
,p_message_text=>'Innen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806449166303342)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Au\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806258282303341)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805958705303341)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, ob die Teilungslabels gerendert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98805815189303341)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806102546303341)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie an, ob das Diagramm die Labels automatisch um 90 Grad dreht, damit mehr Labels auf die Achse passen.',
'        Die Drehung wird nur bei Kategorielabels auf einer horizontalen Achse verwendet.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98806072218303341)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Rotation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99176763874303645)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'de'
,p_message_text=>'Wie Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307501253303758)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Dieselbe Hintergrundkarte f\00FCr hellen Modus und Dunkelmodus verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131319618303609)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Kachellayer aus, der als Hintergrundkarte verwendet werden soll, wenn der Dunkelmodus aktiviert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132265681303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'de'
,p_message_text=>'Oracle BI-Weltkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132398243303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige Basiskarte auf der Grundlage von HERE-Kartendaten. Bei diesem Basiskartenstil wird der Speicherortkontext f\00FCr Ihre Daten bereitgestellt, und die Visualisierung Ihrer Daten wird hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131822483303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'de'
,p_message_text=>'OpenStreetMap - Hell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131997294303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Allgemeine Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden Details zum Speicherortkontext f\00FCr Ihre Daten bereitgestellt.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131490376303609)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'de'
,p_message_text=>'OpenStreetMap - Dunkel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131529457303609)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Unauff\00E4llige, helle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131618579303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'de'
,p_message_text=>'OpenStreetMap - Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131769927303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige, dunkle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132070186303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'de'
,p_message_text=>'Oracle-Weltkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99132180806303610)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Allgemeine Basiskarte auf der Grundlage von HERE-Kartendaten. Bei diesem Basiskartenstil wird der Speicherortkontext f\00FCr Ihre Daten bereitgestellt, und die Visualisierung Ihrer Daten wird hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131263288303609)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Dunkelmodus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130114315303608)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Kachellayer aus, der als Hintergrundkarte verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131058203303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'de'
,p_message_text=>'Oracle BI-Weltkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99131135466303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige Basiskarte auf der Grundlage von HERE-Kartendaten. Bei diesem Basiskartenstil wird der Speicherortkontext f\00FCr Ihre Daten bereitgestellt, und die Visualisierung Ihrer Daten wird hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130641767303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'de'
,p_message_text=>'OpenStreetMap - Hell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130701497303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Allgemeine Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden Details zum Speicherortkontext f\00FCr Ihre Daten bereitgestellt.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130425564303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'de'
,p_message_text=>'OpenStreetMap - Dunkel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130573075303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige, dunkle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130291000303608)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'de'
,p_message_text=>'OpenStreetMap - Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130300376303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige, helle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130809179303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'de'
,p_message_text=>'Oracle-Weltkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130930775303609)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Allgemeine Basiskarte auf der Grundlage von HERE-Kartendaten. Bei diesem Basiskartenstil wird der Speicherortkontext f\00FCr Ihre Daten bereitgestellt, und die Visualisierung Ihrer Daten wird hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99130036988303608)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129563400303608)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die zu verwendende Hintergrundkarte aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129816038303608)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129922459303608)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Kartenkachellayer aus, die f\00FCr die Hintergrundkarte verwendet werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129613444303608)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129755019303608)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwenden Sie die Standard-Hintergrundkarteneinstellungen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99129446868303608)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Hintergrund'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907128017303422)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, wie das Zeitformat angezeigt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99066932953303558)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'de'
,p_message_text=>'12 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99067060007303558)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'de'
,p_message_text=>'24 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98907040894303422)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeitformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99395883444303832)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Titel f\00FCr die Achse ein. Der Titel beschreibt die Informationen, die auf der Achse Ihres Diagramms dargestellt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98546500532303126)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine \00DCberschrift in die Titelleiste des Browserfensters ein. Die &PRODUCT_NAME.-Engine verwendet die angegebene \00DCberschrift anstelle der <code>#TITLE#</code>-Ersetzungszeichenfolge in der Seitentemplate. Diese \00DCberschrift wird zwischen die ')
||unistr('HTML-Tags <code>&lt;TITLE&gt;</code> und <code>&lt;/TITLE&gt;</code> eingef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98547452041303127)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Regions\00FCberschrift ein. Die Regions\00FCberschrift wird nur angezeigt, wenn diese im Regionstemplate definiert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508810216303096)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Seiten\00FCberschrift ein. Sie wird in der Titelleiste des Browserfensters angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98508730595303096)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204620114303667)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob diese Komponente mit einer Spalte oder mit erweiterter Formatierung unter Verwendung von HTML-Ausdr\00FCcken und unterst\00FCtzten Ersetzungszeichenfolgen angezeigt werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204597818303667)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Erweiterte Formatierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204817907303667)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Titel verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204792060303667)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205350214303667)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie Klassen ein, die zu dieser Komponente hinzugef\00FCgt werden sollen. Sie k\00F6nnen mehrere Klassen hinzuf\00FCgen, indem Sie diese durch Leerzeichen trennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205269080303667)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'CSS-Klassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205191898303667)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Hintergrund- und Textfarben \00E4ndern</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\00DCberschrift 2 verwenden</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Eine dynamische Klasse aus der SQL-Abfrage verwenden</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&COLUMN_CLASS.</code> und <code>&EMPLOYEE_STATUS.</code> in diesem Beispiel sind Spalten, die in der Berichts-SQL-Abfrage ausgew\00E4hlt werden.</dd>'),
'  <dt>Beim Mouseover ein Bild und ein QuickInfo anzeigen</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99205023447303667)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die in dieser Spalte angezeigt werden sollen. Verwenden Sie die <code>&COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99204921071303667)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'HTML-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758161930303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfen Sie, welche zus\00E4tzlichen Steuerelemente in der Symbolleiste angezeigt werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758613817303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC "Aktionen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758789867303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt das Men\00FC "Aktionen" an, das im Allgemeinen zahlreiche Optionen umfasst. Mit diesen Optionen kann der Endbenutzer den Bericht basierend auf den zur Verf\00FCgung gestellten Funktionen anpassen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758878753303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758903443303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt die Schaltfl\00E4che "Zur\00FCcksetzen" an. \00DCber diese Schaltfl\00E4che werden Anpassungen wie Filter, Spaltenbreite und Sortierung entfernt, und die Berichtsdefinition wird erneut vom Server geladen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759088842303305)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che "Speichern"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98759140641303305)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Zeigt die Schaltfl\00E4che "Speichern" an. \00DCber diese Schaltfl\00E4che werden nur die \00C4nderungen an diesem interaktiven Grid gespeichert, ohne dass die ganze Seite gespeichert werden muss.'),
unistr('        <p>Die Schaltfl\00E4che "Speichern" wird nur angezeigt, wenn das interaktive Grid editierbar ist und der Endbenutzer die Berechtigung zum Hinzuf\00FCgen, Aktualisieren oder L\00F6schen hat.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758246857303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Spaltenauswahl durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758327039303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt eine Dropdown-Liste der angezeigten nicht numerischen Spalten an. Ist eine Spalte ausgew\00E4hlt, wird die Suche nur anhand der Werte in der ausgew\00E4hlten Spalte ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758453477303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'de'
,p_message_text=>'Suchfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758589955303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'de'
,p_message_text=>'Zeigt in der Suchleiste ein Textfeld zur Eingabe der Suchkriterien an.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98758022848303304)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Steuerelemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320601012303769)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99225112130303683)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Baumabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320706860303769)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862518891303385)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'de'
,p_message_text=>'Gibt an, ob diese Spalte zeitzonenbasiert ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862455362303385)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeitzonenbasiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895825899303413)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den Namen der Spalte, die diese Berichtsspalte referenziert. '),
unistr('Dieser Wert wird verwendet, um Referenzen auf Spalten in Anwendungen mit Benutzeroberfl\00E4chenstandards zu vergleichen. '),
unistr('Diese Referenz wird nach M\00F6glichkeit immer manuell verwaltet, nachdem sie von einem Assistenten initialisiert wurde.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895796526303413)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895686377303413)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Tabelle oder View, die diese Spalte referenziert. '),
unistr('Dieses Attribut wird verwendet, um Referenzen auf Spalten in Anwendungen mit Benutzeroberfl\00E4chenstandards zu vergleichen. '),
unistr('Diese Referenz wird nach M\00F6glichkeit immer manuell verwaltet, nachdem sie von einem Assistenten initialisiert wurde.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895511754303413)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Tabellenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895475866303412)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie das Schema, das Eigent\00FCmer der Referenztabelle ist. '),
unistr('Dieses Attribut wird verwendet, um Referenzen auf Spalten in Anwendungen mit Benutzeroberfl\00E4chen-Standardwerden zu vergleichen. '),
unistr('Diese Referenz wird nach M\00F6glichkeit immer manuell verwaltet, nachdem sie von einem Assistenten initialisiert wurde.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895388485303412)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Tabelleneigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847324149303373)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den Spaltentyp zur Identifizierung der aktuellen Zeile, wenn die Linkspalte verwendet wird.'),
unistr('Standardm\00E4\00DFig wird <strong>ROWID</strong> zur eindeutigen Identifizierung der Zeilen in einem Bericht verwendet. Sie k\00F6nnen jedoch auch eine andere Spalte verwenden, indem Sie <strong>Eindeutige Spalte</strong> w\00E4hlen.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047581319303542)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99047413081303542)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'de'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847205013303373)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Zeilen eindeutig identifizieren durch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847585373303373)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die erste Spalte zur eindeutigen Identifizierung von Zeilen f\00FCr diese Komponente.</p>'),
unistr('<p><strong>ROWID</strong> ist auch in der Liste der verf\00FCgbaren Spalten zur Abw\00E4rtskompatibilit\00E4t enthalten.</p>'),
unistr('<p>Hinweis: F\00FCr einen interaktiven Bericht, bei dem das Attribut <em>Linkspalte</em> auf <strong>Link zu Single Row-Ansicht</strong> festgelegt ist, kann nur eine einzelne eindeutige Spalte ausgew\00E4hlt werden. Andere Komponenten unterst\00FCtzen die Auswa')
||'hl von maximal drei Spalten.</p> '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847418364303373)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847709161303373)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die zweite Spalte, die zur eindeutigen Identifizierung der Zeilen f\00FCr diese Komponente verwendet werden soll. Verwenden Sie dieses Attribut, wenn Ihre Tabelle \00FCber einen zweiteiligen Prim\00E4rschl\00FCssel verf\00FCgt.</p>'),
unistr('<p><strong>ROWID</strong> ist aus Gr\00FCnden der Abw\00E4rtskompatibilit\00E4t auch in der Liste der verf\00FCgbaren Spalten enthalten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847653207303373)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Spalte 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847981332303374)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die dritte Spalte zur eindeutigen Identifizierung von Zeilen f\00FCr diese Komponente. Verwenden Sie dieses Attribut, wenn Ihre Tabelle einen dreiteiligen Prim\00E4rschl\00FCssel enth\00E4lt. </p>'),
unistr('<p><strong>ROWID</strong> ist aus Gr\00FCnden der Abw\00E4rtskompatibilit\00E4t ebenfalls in der Liste der verf\00FCgbaren Spalten enthalten.</p>'),
unistr('<p>Hinweis: Wenn der Prim\00E4rschl\00FCssel Ihrer Tabelle mehr als drei Spalten enth\00E4lt, m\00FCssen Sie die Zeilen eindeutig mit <strong>ROWID</strong> identifizieren.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98847803622303374)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Eindeutige Spalte 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735380920303284)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie ein Autorisierungsschema, um zu begrenzen, wer Zeilen aktualisieren kann.'),
unistr('Damit ein Endbenutzer Zeilen aktualisieren kann, muss die Auswertung dieses Autorisierungsschemas TRUE f\00FCr diesen Benutzer ergeben.'),
'Wenn kein Autorisierungsschema angegeben wird, kann jeder Benutzer Zeilen in diesem interaktiven Grid aktualisieren.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98735283732303284)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622812008303185)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Zeigt die Benutzeroberfl\00E4che f\00FCr diese Seite an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622772125303185)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657440244303212)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Benutzeroberfl\00E4chentyp f\00FCr diese Seite. W\00E4hlen Sie <strong>Desktop</strong> f\00FCr Seiten, die prim\00E4r f\00FCr die Desktopverwendung entwickelt wurden. W\00E4hlen Sie f\00FCr andere Benutzeroberfl\00E4chen, wie Smartphones oder Tablets, die entsprechend')
||'e Option.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041682898303538)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'de'
,p_message_text=>'Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99041788847303538)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'de'
,p_message_text=>'jQuery Mobile-Smartphone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98657307813303212)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzeroberfl\00E4chentyp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872508664303394)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob diese Spalte auch in dem Zeilenheader angezeigt wird.',
unistr('Durch Aufnahme eines Spaltenwertes kann die Barrierefreiheit f\00FCr Form-Felder, die in einem Bericht gerendert werden, wesentlich verbessert werden.'),
unistr('Wenn dies angegeben wird, wird der Zeilenheader zusammen mit dem Spaltenheader verwendet, um die Labels f\00FCr die Form-Felder in dem Bericht im Format <code>''&lt;Spaltenheader&gt; : &lt;Zeilenheader&gt;''</code> zu rendern.</p>'),
unistr('<p>Beispiel: Angenommen die EMP-Tabelle enth\00E4lt einen Bericht und Sie definieren die ENAME-Spalte als Zeilenheader. Bei einer Zeile, bei der ENAME ''JONES'' ist, w\00E4re das Label f\00FCr das Feld "Salary" in dieser Zeile "Salary : JONES".'),
unistr('Mit dieser L\00F6sung kann ein Benutzer der Bildschirmsprachausgabe nach den Form-Feldern in dem Bericht navigieren und dennoch verstehen, welche Form-Felder sich auf welche Zeile beziehen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98872427953303394)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Als Zeilenheader verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900822721303417)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie an, ob Sie einen benutzerdefinierten Link f\00FCr die Symbolansicht definieren m\00F6chten. Diese Option bietet eine gr\00F6\00DFere Flexibilit\00E4t bei der Definition des Inhalts der Symbolansicht, einschlie\00DFlich der M\00F6glichkeit, mehr als eine Spalte zu nutz')
||'en.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900771469303417)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619991657303183)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die verkn\00FCpfte Region f\00FCr diese Validierung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98619829339303183)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Editierbare Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618488168303182)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Gleichheitstyp, der f\00FCr diese Validierung getestet werden soll. Je nach Auswahl ist mindestens ein Attribut erforderlich, um diese Validierung vollst\00E4ndig zu definieren.</p>'),
'<p>Wenn die Validierung den Gleichheitstest besteht oder als TRUE ausgewertet wird, wird keine Validierungsfehlermeldung angezeigt.',
unistr('Validierungsfehlermeldungen werden angezeigt, wenn die Validierung den Gleichheitstest nicht besteht, als FALSE ausgewertet wird, oder wenn eine leere Zeichenfolge zur\00FCckgegeben wird.</p>'),
unistr('<p>Ein Validierungsfehler stoppt die Auswertung nachfolgender Validierungen nicht, deshalb kann jede nachfolgende Validierung eine zus\00E4tzliche Validierungsfehlermeldung ausl\00F6sen. Wenn Sie die Ausf\00FChrung nachfolgender Validierungen stoppen m\00F6chten, m\00FC')
||unistr('ssen Sie zus\00E4tzliche Logik zu der ersten nicht erfolgreiche Validierung hinzuf\00FCgen, beispielsweise ein Seitenelement auf einen bestimmten Wert festlegen, und dann die bedingte Logik nach Bedarf f\00FCr nachfolgende Validierungen erweitern. Nachfolgende P')
||unistr('rozesse und Verzweigungen werden nicht ausgef\00FChrt, wenn mindestens eine Validierung nicht erfolgreich ausgewertet werden kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075130558303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCckgegebene Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075258170303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn die SQL-Abfrage mindestens eine Zeile zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn die SQL-Abfrage keine Zeilen zur\00FCckgibt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281328777303735)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281403534303735)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn die Auswertung des Ausdrucks TRUE ergibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn die Auswertung des Ausdrucks FALSE ergibt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075710423303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsbody (der booleschen Wert zur\00FCckgibt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075894056303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Funktionsbody TRUE zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Funktionsbody FALSE zur\00FCckgibt.<br>'),
unistr('Hinweis: Das von der Funktion zur\00FCckgegebene Ergebnis muss ein boolescher Wert sein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075993295303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsbody (der Fehlertext zur\00FCckgibt)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076031725303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Funktionsbody eine leere Zeichenfolge zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Funktionsbody eine nicht leere Zeichenfolge zur\00FCckgibt. Die zur\00FCckgegebene Zeichenfolge wird als Fehlermeldung zur Validierung angezeigt.<br>'),
unistr('Hinweis: Das von der Funktion zur\00FCckgegebene Ergebnis muss eine Textzeichenfolge sein.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076714637303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt keine Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076835232303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert keine Leerzeichen enth\00E4lt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert Leerzeichen enth\00E4lt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078798870303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt mindestens eines der Zeichen in Wert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078830486303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert mindestens ein Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert keines der Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078917450303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt KEINES der Zeichen in Wert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079071438303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert keines der Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert mindestens eines der Zeichen aus dem Text enth\00E4lt, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078542118303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element enth\00E4lt nur Zeichen, die in Wert angegeben werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078676189303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert nur Zeichen enth\00E4lt, die in dem Text enthalten sind, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert Zeichen enth\00E4lt, die nicht in dem Text enthalten sind, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077769387303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Element = Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077864864303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert nicht identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078131450303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Element ist in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078242557303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert nicht vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077972359303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Element != Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078004039303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert nicht identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert identisch mit dem Text ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078324209303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NICHT in Wert enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99078411356303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert nicht vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben. <br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert vollst\00E4ndig in dem Text enthalten ist, den Sie in das Attribut <em>Wert</em> eingeben.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076961704303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist alphanumerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077098451303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert alphanumerisch ist und nur Buchstaben und Zahlen und keine Sonderzeichen enth\00E4lt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert Sonderzeichen enth\00E4lt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077311710303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element ist ein g\00FCltiges Datum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077462109303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert ein g\00FCltiges Datum ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert kein g\00FCltiges Datum ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077182432303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'de'
,p_message_text=>'Element ist numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077257855303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert numerisch ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert nicht numerische Zeichen, ein schlie\00DFlich Leerzeichen mit Ausnahme von f\00FChrenden Leerzeichen enth\00E4lt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077553831303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element ist ein g\00FCltiger Zeitstempel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99077604064303567)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert ein g\00FCltiger Zeitstempel ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert kein g\00FCltiger Zeitstempel ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076125923303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076232641303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert nicht leer ist.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert leer ist.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076329060303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT NULL oder Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076475984303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert nicht leer ist und nicht der Zahl Null entspricht.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert leer ist oder der Zahl Null entspricht')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076577565303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Element ist NOT Null (0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99076621428303566)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert nicht der Zahl Null entspricht.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert der Zahl Null entspricht.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075386746303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Zeilen zur\00FCckgegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075470725303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn die SQL-Abfrage keine Zeilen zur\00FCckgibt.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn die SQL-Abfrage mindestens eine Zeile zur\00FCckgibt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075549742303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99075639236303565)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der PL/SQL-Code ausgef\00FChrt wird, ohne einen Fehler zu generieren.<br>'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der PL/SQL-Ausdruck bei der Ausf\00FChrung einen Fehler generiert.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079107295303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>unistr('Element stimmt mit regul\00E4rem Ausdruck \00FCberein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99079224332303568)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verl\00E4uft erfolgreich, wenn der Elementwert mit dem Ausdruck \00FCbereinstimmt, den Sie in das Attribut <em>Wert</em> eingeben.'),
unistr('Verl\00E4uft nicht erfolgreich, wenn der Elementwert nicht mit dem regul\00E4ren Ausdruck \00FCbereinstimmt, den Sie in das Attribut <em>Wert</em> eingeben.<br>'),
unistr('Hinweis: Mit regul\00E4ren Ausdr\00FCcken k\00F6nnen Sie nach Mustern in Zeichenfolgendaten suchen, indem Sie standardisierte Syntaxkonventionen anstelle von einfachen Zeichenvergleichen verwenden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618346256303182)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803581600303339)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie, ob die Achsen-Baseline bei dem Mindestwert der Daten oder bei null beginnt. Gilt nur f\00FCr numerische Datenachsen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803624128303339)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'de'
,p_message_text=>'Minimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803718422303339)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'de'
,p_message_text=>'Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98803499750303339)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Baseline-Skalierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835277139303363)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Namen der Collection ein. Die Quelle f\00FCr diesen Parameterwert basiert auf dem Wert der CLOB-Spalte aus der ersten Zeile der Collection.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835104564303363)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789878611303329)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die W\00E4hrung ein, die beim Formatieren des Wertes im Diagramm verwendet wird.'),
unistr('        Der Wert muss ein alphabetischer W\00E4hrungscode gem\00E4\00DF ISO 4217 sein. Wenn das Format auf "W\00E4hrung" gesetzt und f\00FCr die Eigenschaft <strong>W\00E4hrung<strong> keine W\00E4hrung definiert ist, wird die W\00E4hrung bei der Wiedergabe des Diagramms automatisc')
||'h von der Anwendungssprache abgeleitet.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789767773303328)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915924360303429)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Anzahl von Dezimalstellen f\00FCr den numerischen Wert in dem Diagramm an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903583959303419)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Anzahl der Dezimalstellen in Wertelabels ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98903453171303419)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Dezimalstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292260715303744)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292626889303745)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292531305303744)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292455543303744)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292778653303745)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292358465303744)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292166439303744)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790266486303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie das Skalierungsverhalten des Wertes in dem Diagramm.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790486175303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790703865303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'de'
,p_message_text=>'Milliarde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790658723303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'de'
,p_message_text=>'Million'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790344201303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'de'
,p_message_text=>'Keine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790991292303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'de'
,p_message_text=>'Billiarde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790559989303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'de'
,p_message_text=>'Tausend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790833279303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'de'
,p_message_text=>'Billion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790101643303329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatskalierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98915852050303429)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den Typ der Formatierung an, die auf den Wert im Diagramm angewendet werden soll. ',
unistr('        Die Formate <strong>Dezimal</strong>, <strong>Prozent</strong> oder <strong>W\00E4hrung</strong> gelten nur f\00FCr numerische Werte.'),
unistr('        Die Formate <strong>Datum</strong>, <strong>Zeit</strong> und <strong>DateTime</strong> gelten nur f\00FCr Werte dieses Datentyps im Diagramm.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788268551303327)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen numerischen, Datums- und/oder Uhrzeitformatierungstyp. der f\00FCr den Wert in dem Diagramm angewendet werden soll. Bei der Datums- und/oder Uhrzeitformatierung muss sichergestellt werden, dass das Diagrammattribut <strong>Zeitachsentyp<')
||unistr('/strong> je nach Diagrammdaten auf einen der folgenden Werte festgelegt ist: <strong>Aktiviert</strong>, <strong>Gemischte H\00E4ufigkeit</strong> oder <strong>L\00FCcken \00FCberspringen</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789577933303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926818673303439)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn eine Zahl als W\00E4hrung formatiert ist, muss die Eigenschaft "W\00E4hrung" auf die W\00E4hrung festgelegt werden, die bei der Formatierung der Zahl verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788646085303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'de'
,p_message_text=>unistr('Datum - Vollst\00E4ndig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925717254303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn ein Datum in der vollst\00E4ndigen Form formatiert ist, enth\00E4lt das formatierte Datum den ausgeschriebenen Wochentag (EEEE), das Jahr (y), den ausgeschriebenen Monat (MMMM), den Tag (d). Beispiel: Mittwoch, 6. Januar 2016.'),
'        Bei einigen Sprachen werden ausgeschriebene Monate nicht verwendet. Beispiel: In Japanisch wird der Monat in Form von Zahlen in Mustern verwendet.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788532633303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'de'
,p_message_text=>'Datum - Lang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925692020303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn das Datum in der langen Form formatiert wird, enth\00E4lt das formatierte Datum Jahr, Monat ausgeschrieben, Tag. Beispiel: 6. Januar 2016.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788476363303327)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'de'
,p_message_text=>'Datum - Mittel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925504209303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn das Datum mit der mittleren Form formatiert wird, enth\00E4lt das formatierte Datum Jahr, abgek\00FCrzten Monat (MMM), Tag. Beispiel: 6. Jan. 2016.'),
unistr('        Bei einigen Sprachen werden abgek\00FCrzte Monate nicht verwendet, in diesem Fall enth\00E4lt das mittlere Format den Monat in Zahlen (MM/M).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788374828303327)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'de'
,p_message_text=>'Datum - Kurz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925457675303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn ein Datum in Kurzform formatiert wird, enth\00E4lt das formatierte Datum Jahr, Monat in Zahlen (MM/M), Tag. Beispiel: 1/6/16.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926502240303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'de'
,p_message_text=>unistr('DateTime - Vollst\00E4ndig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926618979303439)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Datum/Uhrzeit vollst\00E4ndig formatiert wird, enth\00E4lt es ausgeschriebenen Wochentag (EEEE), Jahr (y), ausgeschriebenen Monat (MMMM), Tag (d), Stunde (h/H), Minute (mm), Sekunde (ss) und Zone (zzzz). Beispiel: Mittwoch, 6. Januar 6 2016 7 h 30 min 2')
||'1 s.',
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Zeitformat verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789341686303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'de'
,p_message_text=>'DateTime - Lang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926424513303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Datum/Uhrzeit in der langen Form formatiert wird, enth\00E4lt es Jahr, ausgeschriebenen Monat, Tag, Stunde, Minute, Sekunde und Zone (z). Beispiel: Jan 6, 2016 7:30:21 AM.'),
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Zeitformat verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789214237303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'de'
,p_message_text=>'DateTime - Mittel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926362981303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Datum/Uhrzeit in der mittleren Form formatiert wird, enth\00E4lt es Jahr, abgek\00FCrzten Monat (MMM), Tag, Stunde, Minute, Sekunde und Zone (z). Beispiel: Jan 6, 2016 7:30:21 AM.'),
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Zeitformat verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789193534303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'de'
,p_message_text=>'DateTime - Kurz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926220139303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Datum/Uhrzeit in Kurzform formatiert wird, enth\00E4lt es Jahr, Monat in Zahlen (MM/M), Tag, Stunde, Minute. Beispiel: 1/6/16 7:30 AM.'),
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Format verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789498281303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'de'
,p_message_text=>'Dezimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926751963303439)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn eine Zahl als Dezimalzahl formatiert ist, wird das Dezimalzeichen durch das zutreffendste Symbol f\00FCr das Gebietsschema ersetzt. Im Englischen ist dies ein Dezimalpunkt ("."), w\00E4hrend es in vielen Gebietsschemas ein Dezimalkomma (",") ist. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789611640303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'de'
,p_message_text=>'Prozent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926939729303439)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'de'
,p_message_text=>'Wenn eine Zahl als Prozent formatiert ist, werden die Werte in dem Diagramm mit 100 multipliziert, damit sie in Prozent angezeigt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789068171303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'de'
,p_message_text=>unistr('Zeit - Vollst\00E4ndig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926125812303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn eine Zeitangabe in der vollst\00E4ndigen Form formatiert wird, enth\00E4lt die formatierte Zeit Stunde (h/H), Minute (mm), Sekunde (ss) und Zone (zzzz). Beispiel: 7 h30 min 21 s.'),
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Zeitformat verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788968975303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'de'
,p_message_text=>'Zeit -Lang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98926096216303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn eine Zeitangabe in der langen Form formatiert wird, enth\00E4lt die formatierte Zeit Stunde, Minute, Sekunde und Zone (z). Beispiel: 7:30:21 AM.'),
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Zeitformat verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788857954303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'de'
,p_message_text=>'Zeit - Mittel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925972936303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn eine Zeitangabe in der mittleren Form formatiert wird, enth\00E4lt die formatierte Zeit Stunde, Minute, Sekunde. Beispiel: 7:30:21 AM.'),
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Zeitformat verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788766057303328)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'de'
,p_message_text=>'Zeit - Kurz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98925817047303438)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn eine Zeitangabe in Kurzform formatiert wird, enth\00E4lt die formatierte Zeit Stunde, Minute. Beispiel: 7:30 AM.'),
unistr('        Das Stundenformat h\00E4ngt davon ab, ob die Anwendungssprache das 12-Stunden-Zeitformat verwendet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788177892303327)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Formatieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294211351303746)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294534707303746)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294499786303746)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294328395303746)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294666223303746)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294181501303746)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832192448303361)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Seiten- oder Anwendungselement ein, das als Quelle f\00FCr diesen Parameterwert verwendet wird.'),
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832091928303361)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293889318303746)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Java-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293766021303745)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295472794303747)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Java-Funktionsbody ein, der einen Wert zur\00FCckgibt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295368239303747)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293611210303745)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293501173303745)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den JavaScript-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293423070303745)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295264789303747)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295122333303747)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den JavaScript-Funktionsbody ein, der einen Wert zur\00FCckgibt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295054263303747)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98788058995303327)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Mindestwert f\00FCr das Diagramm an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98787902752303327)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Minimium'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916038658303429)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie das numerische Muster f\00FCr den numerischen Wert in dem Diagramm an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407703273303842)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Numerisches Muster zur Darstellung von Temperaturen in Fahrenheit. Beispiel: 15&deg;F:</dt>',
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
'<dt>Numerisches Muster zur Darstellung von Zahlen in einem bestimmten Format. Beispiel: 12.30.00:</dt>',
'<dd><pre>',
'##.##.##',
'</pre></dd>',
'<dt>Numerisches Muster zur Darstellung von Zahlen in Millimeter:</dt>',
'<dd><pre>',
'# mm',
'</pre></dd>',
'<dt>Datumsmuster zur Darstellung des Datums als Monat Jahr. Beispiel: Jul 2016:</dt>',
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
'<dt>Datumsmuster zur Darstellung des Datums als Monat. Beispiel: Jul:</dt>',
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98790076748303329)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie ein optionales lokalisiertes numerisches oder Datumsmuster ein, bei dem die in dem Muster verwendeten Zeichen dem Unicode-CLDR f\00FCr Datums-/Uhrzeitformate entsprechen.'),
unistr('        Wenn angegeben, setzt dies das ausgew\00E4hlte Format au\00DFer Kraft.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98789994892303329)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Muster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293361480303745)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293268483303745)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den PL/SQL-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293187221303745)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294980931303746)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294831654303746)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den PL/SQL-Funktionsbody ein, der einen Wert zur\00FCckgibt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294747433303746)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261431154302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie die Position an, in der der Wert im Diagramm angezeigt werden soll.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260882627302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261528372302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Der Wert wird in der Standardposition f\00FCr das Diagramm angezeigt (also au\00DFerhalb des Darstellungsbereichs).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260907781302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'de'
,p_message_text=>'Zentriert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261623522302896)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Der Wert wird in der Mitte des Indikators im Diagramm angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261007676302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'de'
,p_message_text=>'Innerhalb von Indikatorrand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261755287302896)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Der Wert wird innerhalb des Indikatorrands im Diagramm angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261114606302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'de'
,p_message_text=>unistr('Au\00DFerhalb von Indikatorrand')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261898839302896)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Der Wert wird au\00DFerhalb des Indikatorrands im Diagramm angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261240437302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'de'
,p_message_text=>unistr('Au\00DFerhalb von Darstellungsbereich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261954178302896)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Der Wert wird au\00DFerhalb des Darstellungsbereichs im Diagramm angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98261323046302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'de'
,p_message_text=>'Mit Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262069780302896)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Wenn das Label gerendert wird, wird der Wert in derselben Position wie das Label angezeigt. Wenn das Label nicht gerendert wird, wird der Wert au\00DFerhalb des Darstellungsbereichs des Diagramms angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260771289302895)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832346114303361)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Benutzervoreinstellung ein, die als Quelle f\00FCr diesen Parameterwert verwendet werden soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98832252289303361)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99294090534303746)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Python-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293954297303746)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295659902303747)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Python-Funktionsbody ein, der einen Wert zur\00FCckgibt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99295553646303747)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831931287303361)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die SQL-Abfrage ein, die als Quelle f\00FCr diesen Parameterwert verwendet wird. Wenn mehr als eine Zeile zur\00FCckgegeben wird, wird der Wert der ersten Zeile verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831893335303361)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519245080303105)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn diese Option auf <strong>Ein</strong> gesetzt und das Seitenelement sichtbar ist, f\00FChrt &PRODUCT_NAME. automatisch eine NOT NULL-Validierung aus, wenn die Seite weitergeleitet wird.</p>'),
'<p>Wenn eine Meldung mit Namen <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> in "Gemeinsame Komponenten" > "Textnachrichten" definiert wird, kann der vordefinierte Fehlertext durch eine anwendungsspezifische Fehlermeldung ersetzt werden.</p>',
unistr('<p>Die Anzeigeposition der Meldung wird durch die Anwendungsebeneneinstellung <strong>Standardposition f\00FCr die Fehleranzeige</strong> festgelegt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98519142934303105)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99293014483303745)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr den R\00FCckgabewert YES, wenn der Mitarbeiter ein Manager ist und sich seine Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292944743303745)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den SQL-Ausdruck ein, der einen Wert erzeugt, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99292800502303745)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831763173303361)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den statischen Wert ein, der als Quelle f\00FCr diesen Parameterwert verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831673098303361)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98914030048303428)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie an, wie der Wert im Diagramm angezeigt werden soll (entweder als Zahl oder als Prozent des Gesamtwertes).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913864516303428)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'de'
,p_message_text=>'Nummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916336293303430)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Der Wert wird als Zahl im Diagramm angezeigt.</p> <p>Hinweis: Das Attribut <strong>Format</strong> darf nur f\00FCr die benutzerdefinierte Dezimal- oder W\00E4hrungsformatierung f\00FCr das Label und den Wert verwendet werden, die im Diagramm angezeigt werden')
||'.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913925751303428)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'de'
,p_message_text=>'Prozent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98916487541303430)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Der Wert wird als Prozentsatz zwischen 0 % und 100 % angezeigt.</p> <p>Hinweis: Wenn <strong>Format</strong> auf <strong>Prozent</strong> gesetzt ist, werden die Werte im Diagramm mit 100 multipliziert, um sie als Prozentwert zu formatieren. Wenn '
||unistr('Sie das Attribut "Format" verwenden m\00F6chten, stellen Sie sicher, dass der Labeltyp auf eine Zahl gesetzt ist.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913780503303427)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Werttyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830123502303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie fest, wie dieser Parameter aufgef\00FCllt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98834978871303363)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'de'
,p_message_text=>'Collection (CLOB)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835023654303363)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie den CLOB-Spaltenwert aus der ersten Zeile der eingegebenen <em>Collection</em> ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112060575303594)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'de'
,p_message_text=>'REST-Quellenstandard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99112126420303594)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'de'
,p_message_text=>'Verwenden Sie den Wert, der als Standard innerhalb der REST-Datenquelle definiert ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830430476303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830572556303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der im Sessionzustand f\00FCr das ausgew\00E4hlte <em>Element</em> enthalten ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831412317303361)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'de'
,p_message_text=>'Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831598400303361)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'de'
,p_message_text=>'Wird auf Null festgelegt, weil kein Wert angegeben ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830884017303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830926374303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der sich aus der Ausf\00FChrung des eingegebenen <em>PL/SQL-Ausdrucks</em> ergibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831009658303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831199941303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den Wert festgelegt, der von dem eingegebenen <em>PL/SQL-Funktionsbody</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831233589303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'de'
,p_message_text=>'Voreinstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98831308311303361)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Wert der eingegebenen <em>Voreinstellung</em> festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830622111303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Abfrage (einzelner Wert wird zur\00FCckgegeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830763588303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Auf den ersten Wert festgelegt, der von der eingegebenen <em>SQL-Abfrage</em> zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830235629303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'de'
,p_message_text=>'Statischer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830381749303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'de'
,p_message_text=>'Auf den Text festgelegt, der in <em>Statischen Wert</em> eingegeben wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98830015222303360)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283201439303737)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Ausdruck ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283664726303737)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283592438303737)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283416077303737)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283773869303737)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283385462303737)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'de'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283157108303737)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285210715303738)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285506200303739)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285461821303739)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285311413303738)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285658533303739)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285164324303738)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281683017303735)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Sprache aus, mit der der eingegebene Funktionsbody ausgewertet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281929506303736)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'de'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281861808303736)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281731744303736)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282051102303736)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'de'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99281510152303735)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978022987303485)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie ein Seiten- oder Anwendungselement ein, das in dieser Validierung verwendet wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977987130303485)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284804276303738)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Java-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284722207303738)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286421494303739)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286317532303739)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Java-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282846868303736)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Java-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282762478303736)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Java-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284658157303738)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche Validierung ohne Ausl\00F6sung einer Fehlermeldung, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt oder ein Manager ist:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284599338303738)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen JavaScript-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284430643303738)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286271890303739)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche Validierung ohne Ausl\00F6sung einer Fehlermeldung, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286185772303739)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286052777303739)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282627971303736)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>F\00FCr eine erfolgreiche Validierung ohne Ausl\00F6sung der angegebenen Fehlermeldung, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282537887303736)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen JavaScript-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282471313303736)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402910217303838)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und die angegebene Fehlermeldung nicht auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977897077303485)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Ausdruck ein, der einen Fehler ausl\00F6st, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977707600303485)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Code, der einen Fehler ausl\00F6st')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284343172303738)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und keine Fehlermeldung auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist oder ein Manager ist:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284220191303738)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen PL/SQL-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284140769303738)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285971683303739)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und keine Fehlermeldung auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285847439303739)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285748731303739)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282333411303736)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und die angegebene Fehlermeldung nicht auszul\00F6sen, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282229545303736)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen PL/SQL-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282123320303736)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99285007905303738)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Python-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284965057303738)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286633396303740)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der einen BOOLEAN-Wert zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99286553085303739)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Python-Funktionsbody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283021632303737)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Python-Funktionsbody ein, der den Fehlermeldungstext zur\00FCckgibt, der als Basis f\00FCr diese Validierung verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99282977890303737)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Python-Funktionsbody, der Fehlertext zur\00FCckgibt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978437627303486)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den regul\00E4ren Ausdruck ein, der f\00FCr den Vergleich mit dem f\00FCr diese Validierung angegebenen Element verwendet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978332429303486)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Regul\00E4rer Ausdruck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99284013252303737)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Um die Validierung zu bestehen und keine Fehlermeldung auszul\00F6sen, wenn der Mitarbeiter ein Manager ist oder sich die Abteilung in Chicago befindet:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          wobei deptno = :P2_DEPTNO',
'            und loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283942796303737)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen SQL-Ausdruck zur Definition der Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99283868787303737)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402828701303838)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Damit <strong>Zur\00FCckgegebene Zeilen</strong> die Validierung besteht und keine Fehlermeldung ausl\00F6st, wenn der Mitarbeiter in Abteilung 30 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno = 30',
'</pre></dd>',
unistr('<dt>Damit <strong>Keine Zeilen zur\00FCckgegeben</strong> die Validierung besteht und keine Fehlermeldung ausl\00F6st, wenn der Mitarbeiter in Abteilung 40 besch\00E4ftigt ist:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' wobei empno  = :P2_EMPNO',
'   und deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977657327303485)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine SQL-Abfrage zur Definition dieser Validierung ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977564047303485)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978256661303486)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Wert ein, der mit dem Wert der Elementspalte verglichen wird, die f\00FCr diese Validierung angegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98978121431303486)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108996194303592)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Begrenzt die Verwendung einer Anwendung auf bestimmte Gesch\00E4ftsstunden</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601653064303169)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Namen einer Funktion ein, die aufgerufen wird, nachdem die Session-Sentry erfolgreich zur\00FCckgegeben wurde.'),
'Die Funktion kann in dem Attribut "PL/SQL-Code" oder in der Datenbank definiert werden.',
unistr('Das Ergebnis muss ein boolescher Wert sein, wobei "True" bedeutet, dass der Benutzer gepr\00FCft wurde, und "False", dass die Pr\00FCfung des Benutzers nicht erfolgreich war.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98601569806303169)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Funktionsname pr\00FCfen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539285569303121)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob alle ausstehenden Aktionen auf das Ergebnis der aktuellen Aktion warten.',
unistr('Setzen Sie dieses Attribut auf <strong>Ein</strong>, wenn ausstehende Aktionen vom Ergebnis dieser Aktion abh\00E4ngen,'),
unistr('oder auf <strong>Aus</strong>, wenn keine Abh\00E4ngigkeit vorhanden ist und sie asynchron ausgef\00FChrt werden k\00F6nnen, ohne zu warten.</p>'),
unistr('<p>Hinweis: Die Reihenfolge der Ausf\00FChrung spezifischer Aktionen wird von der f\00FCr jede Aktion angegebenen Sequenz bestimmt.'),
unistr('Um sicherzustellen, dass Aktionen in derselben Reihenfolge ausgef\00FChrt werden, empfiehlt Oracle, dass die Folgenummern f\00FCr alle True-Aktionen und alle False-Aktionen eindeutig sind.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98539159428303120)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Auf Ergebnis warten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627287889303188)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt an, ob die REST-Datenquelle eine lokale Synchronisierungstabelle enth\00E4lt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627156813303188)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('REST-Datenquelle enth\00E4lt eine Synchronisierungstabelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98829938502303360)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627452375303189)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'de'
,p_message_text=>'<p>Aktivieren Sie diese Option, um die lokale Tabelle zu verwenden, die im Abschnitt <strong>Synchronisierung</strong> der REST-Datenquelle konfiguriert ist, anstatt den externen REST-Service zu kontaktieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627373195303188)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Synchronisierungstabelle verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513474263303100)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Schaltfl\00E4che, die die dynamische Aktion ausl\00F6sen soll.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513344433303100)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618144004303181)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn diese Seitenverarbeitungskomponente nur ausgef\00FChrt werden soll, wenn auf die angegebene Schaltfl\00E4che geklickt wird, ausw\00E4hlen Sie eine Schaltfl\00E4che aus der Liste. Sie k\00F6nnen diese Schaltfl\00E4chenbedingung zur weiteren Verfeinerung mit anderen Bedi')
||unistr('ngungen kombinieren, wenn diese Seitenverarbeitungskomponente ausgef\00FChrt wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98618022230303181)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Bei geklickter Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374842369303814)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie mindestens eine Spalte ein, um die dynamische Aktion auszul\00F6sen.'),
'Bei mehreren Spalten trennen Sie die einzelnen Elementnamen durch Kommas.',
unistr('Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Spalten ausw\00E4hlen.'),
unistr('Wenn Sie einen Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Spaltennamen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374708289303814)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Spalte(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513866090303100)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie ein DOM-Objekt (<code>document</code>, <code>window</code>) oder die <em>ID</em> eines DOM-Objekts (<code>myElementID</code>) als das Element an, das die dynamische Aktion ausl\00F6sen soll.</p>'),
'<p>Hinweis: <em>DOM-Objekt</em> ist veraltet und muss durch <em>JavaScript-Ausdruck</em> oder <em>jQuery Selektor</em> ersetzt werden.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513779849303100)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'DOM-Objekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513637947303100)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie Seiten- oder Anwendungselemente ein, die die dynamische Aktion ausl\00F6sen sollen. '),
'Bei mehreren Elementen trennen Sie die Elementnamen durch ein Komma. ',
unistr('Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Elementen ausw\00E4hlen. '),
unistr('Wenn Sie einen Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Elementnamen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513549235303100)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Element(e)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370519165303810)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Gibt eine Referenz zu dem <code>window-</code>DOM-Objekt des Browsers zur\00FCck.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>Gibt eine Referenz zu dem <code>document</code>-DOM-Objekt des Browsers zur\00FCck.</dt>'),
'<dd><code>document</code></dd>',
unistr('<dt>jQuery-Selektor w\00E4hlt alle DIV-Elemente mit der Klasse ''alert'' und gibt dann ein jQuery-Objekt zur\00FCck, das alle \00FCbergeordneten Elemente enth\00E4lt.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370424772303810)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den JavaScript-Ausdruck ein, der ausgewertet werden muss, um ein einzelnes DOM-Objekt, ein Array mit DOM-Objekten oder ein jQuery-Objekt als die Elemente zur\00FCckzugeben, die die dynamische Aktion ausl\00F6sen sollen. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370383096303810)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025226727303524)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zur Auswahl eines Seitenelements mit einer DOM-ID <code>my_id</code></dt>',
'<dd><pre>#my_id</pre></dd>',
'<dt>Zur Auswahl aller Seitenelemente mit einer Klasse <code>my_class</code></dt>',
'<dd><pre>.my_class</pre></dd>',
'<dt>Zur Auswahl aller Seitenelemente, bei denen es sich um Eingaben handelt</dt>',
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98514037189303100)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die jQuery-Selektorsyntax ein, um mindestens ein Seitenelement zur\00FCckzugeben, das die dynamische Aktion ausl\00F6st. Die jQuery Library enth\00E4lt eine sehr leistungsf\00E4hige Selektorsyntax, mit der auf einfache Weise auf mindestens ein Element a')
||'us einer Seite zugegriffen werden kann.</p>',
unistr('<p>Weitere Informationen \00FCber die Selektorsyntax finden Sie in der offiziellen Dokumentation, die mit der <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery-Homepage</a> aufgerufen werden kann.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513954477303100)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'de'
,p_message_text=>'jQuery-Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98750608328303297)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die Textnachricht ein, die angezeigt wird, wenn der Grenzwert <strong>Maximal zu verarbeitenden Zeilen</strong> \00FCberschritten wird.'),
unistr('Die Standardnachricht weist Endbenutzer an, zus\00E4tzliche Filter hinzuzuf\00FCgen, um die Anzahl von zu verarbeitenden Datens\00E4tzen zu begrenzen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98895948604303413)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Textmeldung ein, die angezeigt wird, wenn mehr Zeilen aus der Abfrage zur\00FCckgegeben werden als die eingegebene maximale Zeilenanzahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99177302974303645)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Textnachricht ein, die im Bereich <strong>Nachrichten</strong> angezeigt wird, wenn der Grenzwert f\00FCr <strong>Maximal zu verarbeitende Zeilen</strong> f\00FCr den Layer \00FCberschritten wird. Verwenden Sie die Ersetzung <strong>#MAX_ROW_COUNT#')
||unistr('</strong> f\00FCr die tats\00E4chlich abgerufene Anzahl von Zeilen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881274677303401)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Textmeldung ein, die angezeigt wird, wenn mehrere Berichtsspalten vorhanden sind. ',
unistr('Verwenden Sie diese L\00F6sung als Alternative zur Seitennummerierung, insbesondere wenn ein Bericht generell nur eine diskrete Datensatzmenge enth\00E4lt.'),
unistr('Wenn die Berichtsabfrage zus\00E4tzliche Zeilen zur\00FCckgibt, kann der Endbenutzer mit dieser Meldung auf die Anomalie aufmerksam gemacht werden, anstatt einfach geringf\00FCgig andere Seitennummerierungskontrollen anzuzeigen.'),
unistr('Die Textmeldung kann auch einen "Aufruf zur Aktion" enthalten, damit Endbenutzer Anleitungen erhalten, wie auf dieses ungew\00F6hnliche Abfrageergebnis reagiert werden soll. Sie kann auch Seiten- oder URL-Links enthalten.</p>'),
unistr('<p>Die folgenden Ersetzungszeichenfolgen f\00FCr die Seitennummerierung k\00F6nnen in Ihrer Meldung verwendet werden:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>Die Anzahl von anzuzeigenden Zeilen (Seitengr\00F6\00DFe)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
'    <dd>Das "Z" in "Zeilen X - Y von Z"</dd>',
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>Das "X" in "Zeilen X - Y von Z"</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>Das "Y" in "Zeilen X - Y von Z"</dd>',
'  <dt><code>#ROW_RANGES"</code></dt>',
'    <dd>Zeigt Folgendes an: Zeilen 1-15 16-30 30-32</dd>',
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
'    <dd>Wie Zeilenbereiche, jedoch in einer Auswahlliste<dd>',
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
'    <dd>Seitenmengen: 1 2 3 4 5 6</dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98881120120303401)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wenn weitere Daten gefunden werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99354997435303798)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Textmeldung ein, die angezeigt werden soll, wenn die Diagrammabfrage keine Zeilen zur\00FCckgibt. Wenn keine Angabe gemacht wird, verwendet Oracle JET automatisch die Standardmeldung "Keine anzuzeigenden Daten".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307740456303758)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie die Textmeldung ein, die im Bereich <strong>Meldungen</strong> angezeigt wird, wenn die Layerabfrage keine Zeilen zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845340687303371)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine Textnachricht ein, die angezeigt werden soll, wenn die Abfrage keine Zeilen zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98845246538303371)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Wenn keine Daten gefunden werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513226858303100)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie den Namen der Region, die die dynamische Aktion ausl\00F6st.'),
unistr('Beispiel: Dies k\00F6nnte eine "Interaktive Berichtsregion" sein, die in Verbindung mit einem Ereignis "Nach Aktualisierung" verwendet wird, um eine dynamische Aktion zu definieren, die ausgel\00F6st wird, wenn der Bericht aktualisiert wird.</p>'),
unistr('<p>Die Ausl\00F6sung einer dynamischen Aktion durch eine Region wird besonders verwendet, wenn Sie ein \00E4hnliches Verhalten f\00FCr mehrere Seitenelemente in einer Region definieren m\00F6chten. Dies ist jedoch nur bei bestimmten Ereignissen m\00F6glich, die von Elem')
||unistr('enten innerhalb dieser Region ausgel\00F6st werden.'),
unistr('Eine Liste der Ereignisse, die diesen Definitionstyp unterst\00FCtzen und ein Beispiel f\00FCr deren Verwendung finden Sie in der Hilfe zu den Elementen <em>Betroffene Elemente</em> &gt; <em>Auswahltyp</em> von "Ereignisbereich" auf der Seite "Aktion".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513186408303100)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98513047929303100)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Typ des Seitenelements oder Konstrukts, das zur Ausl\00F6sung des Ereignisses verwendet wird. Beispiele zur Verwendung eines spezifischen Auswahltyps finden Sie in der Hilfe zu dem entsprechenden Attribut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024949789303524)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326362174303774)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird von einer Schaltfl\00E4che ausgel\00F6st.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99373057507303812)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'de'
,p_message_text=>'Spalte(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326597339303774)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wird von mindestens einer Spalte ausgel\00F6st.'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
unistr('        p_help_text     => q''~<p>Wird vom DOM-Objekt (<code>document</code>, <code>window</code>) oder der <em>ID</em> eines DOM-Objekts (<code>myElementID</code>) ausgel\00F6st.</p>'),
'        <p>Hinweis: Das <em>DOM-Objekt</em> ist veraltet und sollte durch <em>JavaScript-Ausdruck</em> oder <em>jQuery-Selektor</em> ersetzt werden.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99024819901303524)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'de'
,p_message_text=>'Element(e)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326222702303774)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird von mindestens einem Seitenelement ausgel\00F6st.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369743478303810)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'de'
,p_message_text=>'JavaScript-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326755746303774)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird von den Seitenelementen ausgel\00F6st, die vom JavaScript-Ausdruck zur\00FCckgegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025103171303524)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'de'
,p_message_text=>'jQuery-Selektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326645664303774)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird von mindestens einem Seitenelement ausgel\00F6st, das vom jQuery-Selektor zur\00FCckgegeben wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99025049955303524)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99326427351303774)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Wird von einer Region ausgel\00F6st.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98512955171303100)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Auswahltyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98568765069303144)
,p_name=>'PENDING'
,p_message_language=>'de'
,p_message_text=>'ausstehend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659106007303213)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'de'
,p_message_text=>unistr('Ausstehende Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667818010303223)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'de'
,p_message_text=>'Ausstehende Anforderungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689947199303245)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'de'
,p_message_text=>'Prozent geschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687864976303243)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Prozent abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690036458303245)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'de'
,p_message_text=>unistr('Prozent ge\00F6ffnet')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647026865303204)
,p_name=>'PIE_CHART'
,p_message_language=>'de'
,p_message_text=>'Tortendiagramm'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669101426303224)
,p_name=>'PKC1'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98669240447303225)
,p_name=>'PKC2'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte f\00FCr Prim\00E4rschl\00FCssel 2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361466742303803)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'de'
,p_message_text=>unistr('Zur Installation verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361529256303803)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'de'
,p_message_text=>unistr('Zum Upgrade verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361681481303803)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'de'
,p_message_text=>unistr('Produktivit\00E4ts-/Beispiel-App-Ereignisse: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365000150303806)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'de'
,p_message_text=>'%0 Benutzer - %1 Views'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404742467303840)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die folgenden Voraussetzungspr\00FCfungen waren nicht erfolgreich. Die Installation dieser Anwendung und deren unterst\00FCtzender Objekte kann erst fortgesetzt werden, wenn diese Probleme behoben wurden.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404945134303840)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Objekt ist vorhanden:<br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99404868653303840)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Erforderliche Berechtigungen: <br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390079926303827)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seite k\00F6nnen Sie den Zugriff f\00FCr Workspace-Administratoren, Anwendungsentwickler und Endbenutzer von Application Express steuern.</p>'),
'',
unistr('<p><strong>Workspace-Administratoren</strong> k\00F6nnen Anwendungen installieren, entfernen oder upgraden sowie Benutzeraccounts und Entwicklungsservices verwalten.</p>'),
'',
unistr('<p><strong>Entwickler</strong> k\00F6nnen Anwendungen installieren, entfernen oder upgraden.</p>'),
'',
unistr('<p><strong>Endbenutzer</strong> haben keine Entwicklungsberechtigungen und k\00F6nnen nur auf Anwendungen zugreifen, die kein externes Authentifizierungsschema verwenden.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361316449303803)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Workspace aus der Liste unten:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98631009279303191)
,p_name=>'PLSQL'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444819393303044)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'PLSQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697767994303252)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Eine Werteliste, die auf einen PL/SQL-Funktionsbody basiert, der eine SQL-Anweisung zur\00FCckgibt, enth\00E4lt Fehler.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390830767303000)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637338879303196)
,p_name=>'PLSQL_REGION'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Region'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932308719303444)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'de'
,p_message_text=>'Plug-in-Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98910710522303425)
,p_name=>'PLUGIN'
,p_message_language=>'de'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314907084303764)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'de'
,p_message_text=>'Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314663398303764)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'de'
,p_message_text=>'Effekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314849497303764)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365737532303806)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'de'
,p_message_text=>'Initialisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314404505303764)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'de'
,p_message_text=>'Verschiedenes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99305707117303756)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314748070303764)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314523327303764)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'de'
,p_message_text=>'Stil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98864646740303387)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'de'
,p_message_text=>'[Veraltet]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98650800814303207)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'de'
,p_message_text=>' [Plug-in]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197159201303661)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'de'
,p_message_text=>' [Legacy]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817289659303350)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'de'
,p_message_text=>'Authentifizierungsschematyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196906215302844)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschematyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264609686302898)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264049470302897)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962267386303472)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'de'
,p_message_text=>'Prozess'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264147214302898)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681429731303236)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426604038303858)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Verwenden Sie bei der Eingabe einer URL die Ersetzungszeichenfolgen <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> und <code>&amp;DEBUG.</code> und die Syntax <code>&amp;COLUMN_NAME.</code>, um die Zeilen-ID oder den Prim\00E4rschl\00FCssel auf der')
||unistr(' Zielseite festzulegen oder um zus\00E4tzliche Attributwerte festzulegen.</p>'),
'<p><strong>Beispiele</strong></p>',
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
'<p>Weitere Einzelheiten zur <code>f?p</code>-Syntax finden Sie im Application Express Builder User''s Guide.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682502625303237)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Das Plug-in wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014286644303515)
,p_name=>'PNONUS'
,p_message_language=>'de'
,p_message_text=>unistr('Prozentsatz der Mitarbeiter au\00DFerhalb der Vereinigten Staaten')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392643168303002)
,p_name=>'POPUP_LOV'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731162236303281)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Popup-Werteliste')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691512090303246)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'de'
,p_message_text=>'Prozess nach der Authentifizierung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691316745303246)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'de'
,p_message_text=>'Prozess vor der Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574651042303148)
,p_name=>'PRECISION'
,p_message_language=>'de'
,p_message_text=>'Gesamtstellenzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98911948505303426)
,p_name=>'PREFERENCES'
,p_message_language=>'de'
,p_message_text=>'Voreinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383725729302994)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'de'
,p_message_text=>'Berechtigungen anwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384384402302995)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Keine Aktion erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384034248302994)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'de'
,p_message_text=>'Berechtigungen entziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249899483302885)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'de'
,p_message_text=>'Wert von Voreinstellung in Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249987568302886)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'de'
,p_message_text=>'Wert von Voreinstellung in Ausdruck 1 ist NICHT gleich Ausdruck 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98351914208302966)
,p_name=>'PRESENTATION'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00E4sentation')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411546660303018)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'de'
,p_message_text=>unistr('Aktuell k\00F6nnen keine Berichte gedruckt werden, weil kein Druckserver konfiguriert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659584577303213)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'de'
,p_message_text=>'Erweitert (erfordert Oracle BI Publisher)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659625274303213)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644702308303202)
,p_name=>'PRIORITIZED'
,p_message_language=>'de'
,p_message_text=>unistr('Priorit\00E4t festgelegt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655228543303210)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'de'
,p_message_text=>'Probleme korrigiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655115182303210)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'de'
,p_message_text=>'Probleme identifiziert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389562399302999)
,p_name=>'PROCEDURE'
,p_message_language=>'de'
,p_message_text=>'Prozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99303026826303753)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'de'
,p_message_text=>'Laden von Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167127579302820)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'de'
,p_message_text=>unistr('Code ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98167265407302820)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253838648302889)
,p_name=>'PROCESSES'
,p_message_language=>'de'
,p_message_text=>'Prozesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187371773302836)
,p_name=>'PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Ihre Anforderung wird verarbeitet, bitte warten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976883984303484)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'de'
,p_message_text=>'Produktion heruntergefahren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377187055303816)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'de'
,p_message_text=>'Product Portal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391963559303828)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Prompt: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206960522302851)
,p_name=>'PROVIDER'
,p_message_language=>'de'
,p_message_text=>'Provider'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207082349302851)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'de'
,p_message_text=>'Provider-E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663990980303217)
,p_name=>'PROVISIONED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bereitgestellt',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778420930303319)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'de'
,p_message_text=>'Vorhandener durch Provisioning bereitgestellter Speicherplatz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659747160303214)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'de'
,p_message_text=>'Nach Benutzeranforderung mit E-Mail-Verifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659924820303214)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'de'
,p_message_text=>'Manuell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659845398303214)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'de'
,p_message_text=>'Nach Benutzeranforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398105981303007)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'de'
,p_message_text=>'Administratorinformationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399107244303008)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'de'
,p_message_text=>'Tablespace wird erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399369909303008)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datendatei f\00FCr Tablespace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397968751303007)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398361801303007)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399218255303008)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'de'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397644090303006)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397488566303006)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das neue Provisioning f\00FCr %0 angefordert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398971113303007)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398726157303007)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Vorhandenes Schema erneut verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398678626303007)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'de'
,p_message_text=>'Schemainformationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399094972303007)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397761676303006)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'de'
,p_message_text=>'Workspace-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397809041303006)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Vom System zugewiesen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398418677303007)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398247561303007)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397541764303006)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'de'
,p_message_text=>'Informationen zum Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398854765303007)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702907642303256)
,p_name=>'PROXY_SERVER'
,p_message_language=>'de'
,p_message_text=>'Proxyserver'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384875129302995)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'de'
,p_message_text=>'Sie haben die Aktualisierung der folgenden Elementhilfe angefordert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384947934302995)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'de'
,p_message_text=>'Wenn dies der Fall ist, klicken Sie auf <b>Alles aktualisieren</b>. Klicken Sie andernfalls auf <b>Abbrechen</b>.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008695067303511)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'de'
,p_message_text=>'Administratoren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004369001303507)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Workspace %0 wird eingeleitet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004198865303507)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Tablespace %0 aus Workspace %1 wird eingeleitet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003755530303507)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Benutzer %0 aus Workspace %1 wird eingeleitet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003321981303507)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Bereinigen von Workspace %0 wird eingeleitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008591502303511)
,p_name=>'PURGE.BYTES'
,p_message_language=>'de'
,p_message_text=>'Byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004610006303508)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim L\00F6schen von Workspace %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004279371303507)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim L\00F6schen von Tablespace %0 aus Workspace %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004019469303507)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim L\00F6schen von Benutzer %0 aus Workspace %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003135697303506)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Sehr geehrter Oracle APEX-Benutzer,',
'',
unistr('Workspace %0 auf %1 war in der letzten Zeit nicht aktiv. Ihr nicht aktiver Workspace wird am oder nach dem %2 gel\00F6scht.'),
'',
unistr('Wenn Ihr Workspace nicht entfernt werden soll, klicken Sie auf die untenstehende URL und w\00E4hlen Sie aus, dass Ihr Workspace nicht gel\00F6scht werden soll. Sie m\00FCssen dies in den n\00E4chsten %3 Tagen tun. Wenn Sie diesen Workspace nicht mehr ben\00F6tigen, m\00FCss')
||'en Sie nichts tun.',
'',
unistr('Best\00E4tigungslink:  %4')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003288602303506)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'de'
,p_message_text=>unistr('Zu l\00F6schender Oracle APEX Workspace: Workspace %0 auf %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004461770303507)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Workspace %0 wird beendet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99315365874303765)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Tablespace %0 aus Workspace %1 wird beendet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003977525303507)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Benutzer %0 aus Workspace %1 wird beendet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001230970303505)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Workspace %0 zur Bereinigungsliste hinzuf\00FCgen, seit mindestens %1 Tagen nicht aktiv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001388624303505)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Workspace %0 wird zur Bereinigungsliste hinzugef\00FCgt, da er seit einiger Zeit nicht aktiv war.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001469908303505)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail gesendet an %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001864108303505)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'de'
,p_message_text=>'Workspace %0 wurde von der Beibehaltungsliste zur Bereinigungsliste verschoben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007758153303510)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'de'
,p_message_text=>'Byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005101269303508)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007649265303510)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'de'
,p_message_text=>'Datendateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007311576303510)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'de'
,p_message_text=>'Schemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005095738303508)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'de'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005404019303508)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Wurde aus der Bereinigungsliste (aufgrund k\00FCrzlicher Aktivit\00E4t) entfernt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006189824303509)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'de'
,p_message_text=>unistr('Wurde der Bereinigungsliste erneut hinzugef\00FCgt (wurde beibehalten, weist aber seit %0 Tagen keine Aktivit\00E4t auf)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005807080303508)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'de'
,p_message_text=>unistr('Wurde der Bereinigungsliste neu hinzugef\00FCgt (keine Aktivit\00E4t seit %0 Tagen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006724785303509)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'de'
,p_message_text=>'Heute bereinigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005699005303508)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'de'
,p_message_text=>'Beibehalten (der Administrator hat angefordert, dass der Workspace nicht bereinigt wird)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006342936303509)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'de'
,p_message_text=>'Wird in %0 Tagen bereinigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007499862303510)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'de'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007207723303510)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'de'
,p_message_text=>'Workspaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006861868303509)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'de'
,p_message_text=>'Verbleibende Workspaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001675533303505)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'de'
,p_message_text=>'Die aufgezeichnete Antwort von E-Mail %0 hat den Wert %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008359959303510)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003440434303507)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'de'
,p_message_text=>unistr('Status von Schema %0 wird f\00FCr Workspace %2 auf Status %1 gesetzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003588258303507)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'de'
,p_message_text=>unistr('Status von Tablespace %0 wird f\00FCr Workspace %2 auf Status %1 gesetzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013872359303515)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Application Express: T\00E4gliche Zusammenfassung der bereinigten Workspaces')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008437050303511)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'de'
,p_message_text=>'Tablespace-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008997116303511)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'de'
,p_message_text=>unistr('Der Bereinigungsliste erneut hinzugef\00FCgte Workspaces (wurden beibehalten, zeigten aber seit %0 Tagen keine Aktivit\00E4t)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008812280303511)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'de'
,p_message_text=>unistr('Neu zur Bereinigungsliste hinzugef\00FCgte Workspaces (keine Aktivit\00E4t seit %0 Tagen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007899102303510)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'de'
,p_message_text=>'Zusammenfassung der bereinigten Workspaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008054772303510)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'de'
,p_message_text=>'Heute bereinigte Workspaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009095291303511)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'de'
,p_message_text=>unistr('Aus der Bereinigungsliste aufgrund k\00FCrzlicher Aktivit\00E4t entfernte Workspaces')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009174206303511)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'de'
,p_message_text=>'Beibehaltene Workspaces (der Administrator hat angefordert, dass die Workspaces nicht bereinigt werden)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008741868303511)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'de'
,p_message_text=>'Workspaces, die in %0 Tagen zu bereinigen sind'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008216704303510)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'de'
,p_message_text=>'Workspace-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004949659303508)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Bereinigen von Workspace %0 beendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306830303303757)
,p_name=>'PURGED'
,p_message_language=>'de'
,p_message_text=>'Bereinigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391564267303828)
,p_name=>'PURGE_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769068589303312)
,p_name=>'QB_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'&nbsp;Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446220165303046)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine g\00FCltige Abfrage ein, um die Ergebnisse anzuzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768889704303312)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Der Name wird von einer vorhandenen Abfrage in Query Builder oder SQL Command Processor bereits verwendet.<br> ',
unistr('W\00E4hlen Sie einen neuen Namen und speichern Sie erneut.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627563748303189)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'de'
,p_message_text=>'Es ist nichts zum Speichern vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607789632303173)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage wurde gespeichert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774329990303316)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Tabellenaktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774449665303316)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Aktionen anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727158430303278)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Die aktuelle Abfrage kann in Visual Query Builder nicht ge\00F6ffnet werden.<br>'),
unistr('Klicken Sie auf <b>Erstellen</b>, um die aktuelle Abfrage durch eine neue zu ersetzen. Oder klicken Sie auf <b>Zur\00FCck</b>, um die aktuelle Abfrage beizubehalten.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727040942303278)
,p_name=>'QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252129024302887)
,p_name=>'QUERY BUILDER'
,p_message_language=>'de'
,p_message_text=>'Query Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419052250303024)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Abfrage, keine SELECT-Anweisung gefunden')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251924739302887)
,p_name=>'QUESTIONS'
,p_message_language=>'de'
,p_message_text=>'Fragen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971359502303480)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'de'
,p_message_text=>'Numerische Formatmaske: 999G999G999G999G990'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777337975303319)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'de'
,p_message_text=>'Info zu Quick SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777477745303319)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit Quick SQL k\00F6nnen Sie die erforderliche SQL zum Erstellen eines relationalen Datenmodells aus einem einger\00FCckten Textdokument schnell generieren. Dieses Tool reduziert den Zeit- und Arbeitsaufwand beim Erstellen von SQL-Tabellen, Triggern und I')
||unistr('ndexstrukturen. Es ist nicht als Ersatz f\00FCr die Datenmodellierung konzipiert, sondern stellt lediglich eine schnelle M\00F6glichkeit dar, ein Skript f\00FCr einfache Tabellen und Views zu entwickeln. Nach ihrer Generierung kann die SQL angepasst und erweiter')
||'t werden.</p>',
'',
unistr('<p>Wichtigste Anwendungsf\00E4lle:'),
'<ul>',
'  <li>Robuste Datenmodelle schnell erstellen</li>',
unistr('  <li>Quick SQL-K\00FCrzelsyntax als Modell speichern, um Modell\00E4nderungen zu iterieren, oder zur Verwendung als Templatemodell, um das n\00E4chste Modelldesign zu beschleunigen</li>'),
'  <li>Zufallsdaten einfach generieren</li>',
unistr('  <li>SQL-Syntax f\00FCr Tabellenerstellung, Ausw\00E4hlen, Einf\00FCgen, Index, Trigger, PL/SQL-Package und Anzeigen anhand bereitgestellter Beispiele erlernen</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670291380303225)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Diese Einstellung steuert die Syntax, die zum Unterst\00FCtzen von Auditspalten generiert wird. Das hei\00DFt, werden Auditspalten aktiviert, werden Trigger generiert, um den Ersteller einer Zeile zu verwalten sowie den Benutzer, der zuletzt eine Zeile aktua')
||'lisiert hat. Wenn diese Einstellung aktiviert ist, wird die folgende Funktion verwendet:',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670320229303225)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'de'
,p_message_text=>'Wenn sie nicht aktiviert ist, wird die folgende Funktion verwendet:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670442494303225)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Generieren Sie PL/SQL-APIs f\00FCr alle Tabellen zum Erstellen, Einf\00FCgen, Aktualisieren, L\00F6schen und Abfragen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670597362303226)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt zus\00E4tzliche Spalten (created, created_by, updated und updated_by) zu jeder erstellten Tabelle hinzu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670615826303226)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn diese Einstellung aktiviert ist, werden alle Tabellen komprimiert erstellt. Standardm\00E4\00DFig wird keine Komprimierung eingesetzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670774556303226)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Auditspalten aktiviert sind, wird standardm\00E4\00DFig mit der Spalte CREATED_BY verfolgt, wer eine Zeile erstellt hat. Mit dieser Einstellung k\00F6nnen Sie den Namen der Standardauditspalte au\00DFer Kraft setzen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98670810393303226)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Auditspalten aktiviert sind, wird standardm\00E4\00DFig mit der Spalte CREATED verfolgt, wer eine Zeile erstellt hat. Mit dieser Einstellung k\00F6nnen Sie den Namen der Standardauditspalte au\00DFer Kraft setzen. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98672893661303228)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Standardm\00E4\00DFig werden alle DATE-Spalten mit dem Oracle-Datentyp DATE erstellt. Mit dieser Einstellung k\00F6nnen Sie diese Standardeinstellung au\00DFer Kraft setzen. G\00FCltige Werte:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98675187705303230)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Gibt die Datenbankversion an, mit der die Syntax kompatibel sein sollte. G\00FCltige Werte:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679595136303234)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347179602303791)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'de'
,p_message_text=>'Abteilungen und Mitarbeiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347758642303792)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Abgek\00FCrzte SQL-Syntax, die eine DEPARTMENTS- und eine EMPLOYEES-Tabelle mit einer SQL-Join-VIEW erstellt. Zufallsdaten werden mit /INSERT-Syntax ebenfalls generiert. /NN f\00FCgt einen NOT NULL SQL-Spalten-Constraint hinzu. Einger\00FCckte Listen werden zum ')
||unistr('Definieren von Tabellen, Spalten und untergeordneten Tabellen verwendet. Prim\00E4r- und Fremdschl\00FCsselspalten werden automatisch hinzugef\00FCgt. Sie m\00FCssen keine Prim\00E4r- oder Fremdschl\00FCsselspalten angeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599693194303167)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98678283094303233)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Nehmen Sie SQL-Befehle auf, um jedes erstellte Datenbankobjekt zu l\00F6schen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347323162303792)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'de'
,p_message_text=>'Mitarbeiterqualifikationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347575430303792)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellt eine Tabelle f\00FCr DEPARTMENTS, EMPLOYEES und SKILLS, in der \00FCber- und untergeordnete Tabellen per Einzug identifiziert werden. Kurzsyntax VC255 wird verwendet, um einen SQL-Datentyp anzugeben. Die /INSERT-Syntax wird verwendet, um Zufallsdate')
||'n zu generieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599402315303167)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'de'
,p_message_text=>'Beispiel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777735668303319)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'de'
,p_message_text=>'Beispiel %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680271007303235)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Generieren Sie automatisch eine ID-Prim\00E4rschl\00FCsselspalte f\00FCr jede Tabelle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777570097303319)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'de'
,p_message_text=>'Erste Schritte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777678239303319)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Namen \00FCbergeordneter Tabellen ohne Einzug ein. Geben Sie Tabellenspalten mit einem einheitlichen Einzug von mindestens 2 Leerzeichen ein. Im Allgemeinen sollten Sie am besten keine Prim\00E4rschl\00FCssel angeben, da diese vom System generie')
||unistr('rt werden. Eltern-Kind-Beziehungen werden einfach erstellt, indem Sie untergeordnete Tabellen unter \00FCbergeordneten Tabellen einr\00FCcken.</p>'),
'',
unistr('<p>Als Datentypstandard wird in der Regel VARCHAR2 verwendet. Wenn Sie eine Spalte mit einem anderen Datentyp verwenden m\00F6chten, f\00FCgen Sie ein Leerzeichen und NUM, INT, DATE an das Ende eines Spaltennamens an. Das System leitet einige Spaltennamen ba')
||unistr('sierend auf dem englischen Text im Spaltennamen ab (wenn kein Datentyp angegeben ist). Beispiel: Wenn der Spaltenname das Wort DATE enth\00E4lt, wird als Datentyp "Datum" verwendet. Wenn der Spaltenname das Wort NUMBER oder NUM enth\00E4lt, wird als Datentyp')
||unistr(' "Zahl" verwendet. Wenn Sie eine bestimmte VARCHAR2-L\00E4nge angeben m\00F6chten, geben Sie "VCn" ein, wobei "n" f\00FCr die VARCHAR2-L\00E4nge steht. Klicken Sie auf die Schaltfl\00E4che "Syntax", um die verf\00FCgbare Syntax anzuzeigen. Objektnamen werden automatisch for')
||unistr('matiert, wobei Leerzeichen durch Unterstriche ersetzt werden. Sie k\00F6nnen also Leerzeichen in Spalten- und Tabellennamen verwenden.</p>'),
'',
unistr('<p>Klicken Sie auf die Schaltfl\00E4che "Einstellungen", um zahlreiche Generierungsoptionen anzuzeigen. Sie k\00F6nnen automatisch "WHO-Spalten" hinzuf\00FCgen, um beispielsweise anzugeben, wer eine Zeile wann erstellt oder zuletzt aktualisiert hat. Sie k\00F6nnen e')
||unistr('ine Zeilensequenzspalte hinzuf\00FCgen, die bei jeder Zeilenaktualisierung automatisch um 1 erh\00F6ht wird. Eine Zeilensequenz kann n\00FCtzlich sein, um die Erkennung verloren gegangener Aktualisierungen zu vereinfachen. Sie k\00F6nnen au\00DFerdem eine PL/SQL-API gen')
||unistr('erieren, die ein Package pro Tabelle sowie Prozeduren zum Abfragen, Einf\00FCgen, Aktualisieren und L\00F6schen von Zeilen bereitstellt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352467465303796)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'de'
,p_message_text=>unistr('Generieren Sie eine PL/SQL-Package-API, um Daten in einer Tabelle abzufragen, einzuf\00FCgen, zu aktualisieren und zu l\00F6schen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352525157303796)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt Oracle-Auditing hinzu, standardm\00E4\00DFig AUDIT ALL ON [TABLE NAME].')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352657965303796)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt automatisch Spalten f\00FCr UPDATED, UPDATED_BY, INSERTED und INSERTED_BY sowie die Triggerlogik zum Festlegen von Spaltenwerten hinzu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351868048303795)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt der Spalte einen Between Check Constraint hinzu. Beispiel: /between 1 and 100')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351272607303795)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'de'
,p_message_text=>'Erstellt einen Check Constraint mit durch Komma oder Leerzeichen getrennten Werten. Beispiel: /check Yes, No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681351417303236)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('Stellen Sie allen Spalten einer Tabelle diesen Wert voran. Dabei wird automatisch ein Unterstrich hinzugef\00FCgt, wenn nicht angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98721421651303272)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>'Spaltenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352236886303796)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen Sie Kommentare in eckige Klammern oder doppelte Bindestriche ein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352761124303796)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'de'
,p_message_text=>'Tabelle wird komprimiert erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351366462303795)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'de'
,p_message_text=>'Setzen Sie diese Spalte beim Generieren von Daten auf einen konstanten Wert. Beispiel: /constant NYC.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184671937303651)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt einen Standardwert hinzu, wenn die Spalte Null ist')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681287207303236)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt eine BLOB-Spalte und die Spalten _FILENAME, _CHARSET, _MIMETYPE, _LASTUPD hinzu, die den Dateidownload \00FCber einen Browser verbessern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352069858303795)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'de'
,p_message_text=>unistr('Fremdschl\00FCsselreferenzen. Beispiel: /references table_name. Beachten Sie, dass Sie Tabellen referenzieren k\00F6nnen, die nicht Teil des Modells sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351972477303795)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendete Spalten werden mit "select * from table" nicht angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98945230608303454)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellt einen nicht eindeutigen Index in der verkn\00FCpften Spalte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352879030303796)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'de'
,p_message_text=>'Generieren Sie <strong>NN</strong> SQL INSERT-Anweisungen mit Zufallsdaten. Beispiel: /INSERT 20. (Maximum = 1000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351638666303795)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'de'
,p_message_text=>'Erzwingt Kleinbuchstaben in Spaltenwerten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352367119303796)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'de'
,p_message_text=>unistr('NNN steht f\00FCr eine Zahl zwischen 1 und 32767.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351791180303795)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgt der Spalte einen Not Null Constraint hinzu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352191164303795)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'de'
,p_message_text=>unistr('Identifiziert eine Spalte als Prim\00E4rschl\00FCssel der Tabelle. Es wird empfohlen, Prim\00E4rschl\00FCssel nicht manuell anzugeben, sondern zuzulassen, dass diese Anwendung Prim\00E4rschl\00FCsselspalten automatisch erstellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99353084897303796)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'de'
,p_message_text=>unistr('Macht die Tabelle REST-f\00E4hig mit Oracle REST Data Services (ORDS)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99352935975303796)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'de'
,p_message_text=>unistr('Generieren Sie eine SQL SELECT-Anweisung, nachdem Daten f\00FCr jede Tabelle generiert wurden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98486982630303079)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Unique Constraint auf Tabellenebene generieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351177891303795)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Erstellt einen Unique Constraint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351563830303795)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'de'
,p_message_text=>unistr('Erzwingt Gro\00DFbuchstaben in Spaltenwerten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351473988303795)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'de'
,p_message_text=>unistr('Durch Komma getrennte Werteliste f\00FCr die Generierung von Daten. Beispiel: /values 1, 2, 3, 4 oder /values Yes, No.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98780139375303321)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'de'
,p_message_text=>'Datenbankobjekte erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808055626303343)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn Sie das Quick SQL-K\00FCrzel vollst\00E4ndig eingegeben und die jeweiligen Einstellungen angewendet haben, k\00F6nnen Sie die SQL verwenden, um die Datenbankobjekte zu erstellen und potenziell die Tabellen mit Zufallsdaten aufzuf\00FCllen. F\00FChren Sie dazu di')
||'e folgenden Schritte aus:<br>',
'<ol>',
unistr('  <li>Klicken Sie auf <strong>Modell speichern</strong>, um die Quick SQL-K\00FCrzelsyntax als Modell zu speichern, das Sie in Zukunft wiederverwenden k\00F6nnen.</li>'),
'  <li>Geben Sie einen Modellnamen ein.</li>',
'  <li>Klicken Sie auf <strong>SQL-Skript speichern</strong>, um die Ausgabe als Skript zu speichern.</li>',
'  <li>Geben Sie einen Skriptnamen ein.</li>',
unistr('  <li>Klicken Sie auf <strong>Pr\00FCfen und ausf\00FChren</strong>, um zum Skripteditor zu navigieren.</li>'),
unistr('  <li>Pr\00FCfen Sie im Skripteditor, ob der Skriptinhalt richtig ist.</li>'),
unistr('  <li>Klicken Sie auf <strong>Ausf\00FChren</strong>, um die Datenbankobjekte zu erstellen.</li>'),
unistr('  <li>Klicken Sie auf der Skriptbest\00E4tigungsseite auf <strong>Jetzt ausf\00FChren</strong>.</li>'),
unistr('  <li>Pr\00FCfen Sie auf der Ergebnisseite, welche Anweisungen erfolgreich und welche mit Fehlern verarbeitet wurden.<br>'),
'  Wenn Fehler gemeldet werden, navigieren Sie durch die Ergebnisseiten, um die spezifischen Oracle-Fehlermeldungen anzuzeigen.</li>',
'  <li>Klicken Sie optional auf <strong>App aus Skript erstellen</strong>, um zum Assistenten zur Anwendungserstellung zu gehen und Seiten basierend auf den im Skript angegebenen Tabellen und Views automatisch generieren zu lassen.</li>',
'</ol>',
'</p>',
'',
unistr('<p><em><strong>Hinweis:</strong> Oracle empfiehlt, das SQL-K\00FCrzel auf Ihren Rechner herunterzuladen, wenn Sie dasselbe SQL-K\00FCrzel in Zukunft aktualisieren m\00F6chten. Wenn Sie Einstellungen angegeben haben, navigieren Sie im Oracle-SQL-Ausgabebereich na')
||unistr('ch unten, und kopieren Sie die Zeile, die mit <code># settings =</code> beginnt, nach oben in den Bereich "Quick SQL-K\00FCrzel".<br>'),
'Klicken Sie auf <strong>Herunterladen</strong>, um die SQL-Datei auf Ihrem Rechner zu speichern.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679299679303234)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Generieren Sie Daten f\00FCr INSERT-Anweisungen mit dieser Sprache. Der Standardwert ist "Englisch". Unterst\00FCtzte Sprachen: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679435796303234)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Identifiziert die Verwendung l\00E4ngerer IDs f\00FCr Datenbankobjektnamen. Wenn l\00E4ngere IDs aktiviert sind, k\00F6nnen Objektnamen bis zu 128 Zeichen enthalten. Wenn sie nicht aktiviert sind, betr\00E4gt die H\00F6chstl\00E4nge eines Objektnamens 30 Zeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679606611303234)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Erm\00F6glicht die Verwendung l\00E4ngerer IDs f\00FCr Datenbankobjektnamen. Bei l\00E4ngeren IDs k\00F6nnen VARCHAR2-Spalten bis zu 32.767 Zeichen enthalten. Wenn die Option nicht festgelegt ist, betr\00E4gt die H\00F6chstl\00E4nge einer VARCHAR2-Spalte 4.000 Zeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679796505303235)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Einstellung steuert ON DELETE-Fremdschl\00FCsseleinstellungen. G\00FCltige Werte: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679853368303235)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn diese Option aktiviert ist, werden alle \00FCber die Benutzeroberfl\00E4che festgelegten Anwendungseinstellungen ignoriert, und nur im Skript festgelegte Einstellungen werden verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98679975112303235)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Bestimmt, wie der Prim\00E4rschl\00FCssel festgelegt wird. Prim\00E4rschl\00FCssel k\00F6nnen mit SYS_GUID, Identit\00E4tsspalte oder Sequenz festgelegt werden. G\00FCltige Werte:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680195876303235)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Stellen Sie Datenbanktabellenspalten f\00FCr Prim\00E4rschl\00FCssel den Namen einer Tabelle als Pr\00E4fix voran. Beispiel: Der Prim\00E4rschl\00FCssel der EMPLOYEE-Tabelle w\00E4re EMPLOYEE_ID. Ohne diese Einstellung ist der Name der implizit erstellten Prim\00E4rschl\00FCsselspalten')
||' die ID.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680020503303235)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Datenbankobjektpr\00E4fix. Ein Unterstrich wird angeh\00E4ngt, wenn nicht angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347215520303791)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'de'
,p_message_text=>'Produktverkauf'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347819982303792)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Abgek\00FCrzte Syntax, die ein Sternschema mit Tabellen f\00FCr PRODUCTS, CUSTOMERS, CHANNELS, PROMOTIONS und SALES erstellt. Die SALES-Tabelle enth\00E4lt Fremdschl\00FCsselreferenzen zu den anderen Tabellen. Eine SQL-VIEW wird ebenfalls erstellt, um alle 5 Tabelle')
||unistr('n zu verkn\00FCpfen. Zuf\00E4llige Beispieldaten werden ebenfalls generiert. Numerische Spalten werden durch NUM-Syntax identifiziert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347061118303791)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'de'
,p_message_text=>'Project Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347601832303792)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellt eine PROJECT_MANAGEMENT- und vier Detailtabellen. Zwei Views werden mit /VIEW-Syntax erstellt. Datenbank-CHECK-Constraints werden mit /CHECK-Syntax ebenfalls hinzugef\00FCgt. Verwendet au\00DFerdem #APEX zum Festlegen von Einstellungen, die die SQL-')
||'Syntaxgenerierung steuern.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680310922303235)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Setzt alle Anwendungseinstellungen auf Standardwerte zur\00FCck. Mit dieser Option werden alle Anwendungseinstellungen, die derzeit f\00FCr Ihre Session aktiv sind, ignoriert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680495754303235)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgen Sie f\00FCr jede erstellte Tabelle eine ROW_KEY-Spalte hinzu, die eine alphanumerische ID generiert. Werte der ROW_KEY-Spalte werden von Triggerlogik f\00FCr die generierte Datenbanktabelle festgelegt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680608182303235)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgen Sie f\00FCr jede generierte Tabelle eine ROW_VERSION-Spalte hinzu, die bei jeder Aktualisierung um 1 erh\00F6ht wird. Wenn diese Option aktiviert ist, wird Triggerlogik f\00FCr die Datenbanktabelle generiert, um Zeilenversionen bei Aktualisierungen zu erh\00F6')
||'hen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680776326303236)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Stellen Sie Objektnamen einen Schemanamen als Pr\00E4fix voran. Standardm\00E4\00DFig gibt es kein Schemapr\00E4fix f\00FCr Objektnamen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680592112303235)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgen Sie f\00FCr jede Tabelle eine TENANT_ID-Spalte hinzu, um mehrmandantenf\00E4hige Anwendungen zu unterst\00FCtzen. Der Wert dieser Spalte wird der Tabelle einfach hinzugef\00FCgt. Die Verwaltung dieses Wertes unterliegt dem Entwickler.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681157381303236)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen keine Spaltensemantik oder BYTE- bzw. CHAR-Semantik ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599532376303167)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'de'
,p_message_text=>'Einstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662739786303216)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sie k\00F6nnen Inline-Einstellungen eingeben, um Generierungsoptionen in SQL-Syntax explizit festzulegen. Alternativ k\00F6nnen Sie oben im rechten Bereich auf <strong>Einstellungen</strong> klicken, um die Generierungsoptionen deklarativ festzulegen.</p>'),
'',
unistr('<p>Durch direkte Eingabe von Einstellungen in den Bereich "Quick SQL-K\00FCrzel" wird sichergestellt, dass dieselben SQL-Generierungsoptionen verwendet werden, selbst wenn Sie das Skript herunterladen und sp\00E4ter wieder einf\00FCgen. Beispiel: Geben Sie Folge')
||unistr('ndes ein, um allen Tabellennamen das Pr\00E4fix "TEST" voranzustellen und die Generierung f\00FCr das Schema OBE durchzuf\00FChren:<br>'),
'<code># settings = { prefix: "test", schema: "OBE" }</code>.<br>',
'Geben Sie alternativ dazu jede Einstellung in einer eigenen Zeile ein, um dasselbe Ergebnis zu erreichen:<br>',
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>Hinweis:</strong> Die Einstellungen m\00FCssen in einer neuen Zeile anfangen und mit <code># settings = </code> beginnen, um mehrere Einstellungen einzugeben, oder mit <code># </code>, um nur eine Einstellung pro Zeile einzugeben. Bei alle')
||unistr('n Werten wird die Gro\00DF-/Kleinschreibung ignoriert. Klammern, Leerzeichen und Kommas k\00F6nnen zur Verdeutlichung hinzugef\00FCgt werden, werden aber ignoriert. Um alle Einstellungen zu generieren, verwenden Sie <code># verbose: true</code>.</em> '),
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599286834303167)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'de'
,p_message_text=>'Syntax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369009469303809)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'de'
,p_message_text=>'To-dos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369123458303809)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellt eine ASSIGNEES- und eine TODOS-Tabelle. Dieses Element dient als Ausgangspunkt, um das Erstellen eines angepassten To-do-Systems in Minutenschnelle zu erm\00F6glichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680807954303236)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Auditspalten aktiviert sind, k\00F6nnen Sie mit dieser Einstellung den Namen der Standardauditspalte au\00DFer Kraft setzen. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98680928069303236)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Auditspalten aktiviert sind, k\00F6nnen Sie mit dieser Einstellung den Namen der Standardauditspalte au\00DFer Kraft setzen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98681006736303236)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'de'
,p_message_text=>'Zeigt alle Einstellungen an und nicht nur Einstellungen, die vom Standard abweichen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98599378260303167)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'de'
,p_message_text=>'Stellen Sie sicher, dass der View-Name und die Tabellennamen keine Leerzeichen enthalten. Trennen Sie Tabellennamen durch Leerzeichen oder Komma.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98808155871303343)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Datenladebericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447520304303047)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'de'
,p_message_text=>'Analyse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655467463303210)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'de'
,p_message_text=>'Durchschnitt %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330807675302950)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'de'
,p_message_text=>'Pro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447933941303047)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'de'
,p_message_text=>'Diagramme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330731194302950)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'de'
,p_message_text=>'Diagramm pro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98329400773302949)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'de'
,p_message_text=>'Detailansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447828462303047)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'de'
,p_message_text=>'Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98655591477303210)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'de'
,p_message_text=>'Summe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823476020303355)
,p_name=>'QUICK_SQL'
,p_message_language=>'de'
,p_message_text=>'Quick SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165181003302819)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'2D-Bereichsspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165275674302819)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'3D-Bereichsspalte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99480718329303902)
,p_name=>'READERS'
,p_message_language=>'de'
,p_message_text=>'Leseberechtigte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99397021601303833)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'de'
,p_message_text=>'Element erneut zuweisen: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188583137302837)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'de'
,p_message_text=>'Seiten erneut zuweisen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98573976365303147)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'de'
,p_message_text=>'Papierkorb'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777864965303319)
,p_name=>'REDIRECT'
,p_message_language=>'de'
,p_message_text=>'Umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778030571303319)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Schaltfl\00E4che leitet eine URL um und sorgt in aller Regel daf\00FCr, dass die Seite nicht weitergeleitet wird. Wenn die Schaltfl\00E4che die Seite weiterleiten soll, geben Sie keinen Befehl oder URL f\00FCr die Umleitung an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444280120303044)
,p_name=>'REDIRECT_TO'
,p_message_language=>'de'
,p_message_text=>'Umleiten zu %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909973466303424)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'de'
,p_message_text=>'Umleitung zu Anwendung %0, Seite %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444132984303044)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'de'
,p_message_text=>'Umleiten zu Seite %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251751854302887)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in dieser Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251868154302887)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'de'
,p_message_text=>'Zu URL umleiten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98625150537303187)
,p_name=>'REFERENCED'
,p_message_language=>'de'
,p_message_text=>'Referenziert'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252755465302888)
,p_name=>'REGEN_VER'
,p_message_language=>'de'
,p_message_text=>'Verifizierungscode erneut generieren'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627724793303189)
,p_name=>'REGION'
,p_message_language=>'de'
,p_message_text=>'Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772256496303315)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'de'
,p_message_text=>unistr('Positionen f\00FCr Regionsschaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691799703303246)
,p_name=>'REGION CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Region')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684986845303240)
,p_name=>'REGION CONTENT'
,p_message_language=>'de'
,p_message_text=>'Regionsinhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230621087302870)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Regionsschaltfl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98253744135302889)
,p_name=>'REGIONS'
,p_message_language=>'de'
,p_message_text=>'Regionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98411792637303018)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'de'
,p_message_text=>unistr('Regionslisten-Template au\00DFer Kraft setzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636019556303195)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'de'
,p_message_text=>unistr('Selektor f\00FCr Regionsanzeige')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154486843302809)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900379730303417)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172679394302825)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'de'
,p_message_text=>'Karten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620395277303183)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'de'
,p_message_text=>'Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196810145302843)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'de'
,p_message_text=>'Spaltenzuordnung beim Hochladen von Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634471399303194)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'de'
,p_message_text=>unistr('Selektor f\00FCr Regionsanzeige')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965006380303474)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'de'
,p_message_text=>'Facet-Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754363871303301)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'de'
,p_message_text=>'Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155546507302810)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'de'
,p_message_text=>'Hilfetext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761575201303306)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'de'
,p_message_text=>'Interaktives Grid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875229280303396)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'de'
,p_message_text=>'Interaktiver Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614774695303179)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333148942303780)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'de'
,p_message_text=>'Spaltenumschaltbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196749074302843)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'de'
,p_message_text=>'Listenansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99333226765303780)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'de'
,p_message_text=>'Reflow-Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900568873303417)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'de'
,p_message_text=>'Baum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98153915491302809)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337010316303783)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'de'
,p_message_text=>'Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975036438303483)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'de'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899957551303416)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm (HTML - LEGACY)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98871031993303392)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975127550303483)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'de'
,p_message_text=>'Statischer Inhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98899854124303416)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm (SVG - LEGACY)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98875356746303396)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'de'
,p_message_text=>'Tabellarisches Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98900468704303417)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'de'
,p_message_text=>'Klassischer Baum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98154761357302810)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'de'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98320743426302943)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Kein Template'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639737951303198)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'de'
,p_message_text=>'Abgelehnt oder doppelt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660442023303214)
,p_name=>'RELEASE'
,p_message_language=>'de'
,p_message_text=>'Release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207277368302851)
,p_name=>'RELEASED'
,p_message_language=>'de'
,p_message_text=>'Herausgegeben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690388061303245)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'de'
,p_message_text=>'Releasezusammenfassung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690230506303245)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Releasezusammenfassung f\00FCr Workspace: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365606708303806)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'de'
,p_message_text=>'Weitere Informationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406711352303841)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Web-Toolkit %0 erforderlich <a href="%1" target="_blank">[Weitere Informationen]</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406536963303841)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Patchset %0 ist verf\00FCgbar <a href="%1" target="_blank">[Weitere Informationen]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406649678303841)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Oracle APEX %0 ist verf\00FCgbar <a href="%1" target="_blank">[Weitere Informationen]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99365594128303806)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'de'
,p_message_text=>'System befindet sich auf dem neuesten Stand'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307012250303757)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Wegen Aktivit\00E4t entfernt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98206709540302851)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99198187236303662)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anwendungsdefinition wird entfernt, ebenso wie alle erstellten unterst\00FCtzenden Objekte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98706062888303259)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Der Workspace wurde erfolgreich entfernt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770283271303313)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Umbenennen von Spalte %0 in %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770448712303313)
,p_name=>'RENAME_TABLE'
,p_message_language=>'de'
,p_message_text=>'Umbenennen von Tabelle %0 in %1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487376467303079)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Regionsschaltfl\00E4chen neu anordnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502407321303091)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'de'
,p_message_text=>unistr('Eintr\00E4ge der Navigationsleiste neu anordnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487478513303079)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'de'
,p_message_text=>'Regionen neu anordnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487083522303079)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Regionselemente neu anordnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502327486303091)
,p_name=>'REORDER_TABS'
,p_message_language=>'de'
,p_message_text=>'Registerkarten neu anordnen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607653821303173)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390752892303827)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'de'
,p_message_text=>'Berichtsalias: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607951622303174)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Berichtspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724565887303275)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699384865303253)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Berichtsspalten-Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698954176303253)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Formular und Bericht wurden erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663748541303217)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'de'
,p_message_text=>'Bericht generiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731422212303281)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'de'
,p_message_text=>'Berichtslayout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98560106217303137)
,p_name=>'REPORT_ON'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht f\00FCr %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98724878832303276)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Berichtsseitenattribute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98316319587302939)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Abfrage ist g\00FCltig. Bind-Variablen wurden geparst.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731345159303281)
,p_name=>'REPORT_QUERY'
,p_message_language=>'de'
,p_message_text=>'Berichtsabfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98564956692303141)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'de'
,p_message_text=>'Schritt 1 - XML-Datei herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565041168303141)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'de'
,p_message_text=>'Schritt 2 - Berichtslayout entwerfen und als RTF-Datei speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565275256303141)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'de'
,p_message_text=>'Schritt 2 - XSL-FO-Datei hochladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565177636303141)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'de'
,p_message_text=>'Schritt 3 - RTF-Datei hochladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697472881303251)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'de'
,p_message_text=>'Abgerufene Berichtszeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98765594835303310)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Der Bericht wurde erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98699452637303253)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Berichtstemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704696220303258)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Seite "Bericht zu Web Service" wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621252902303184)
,p_name=>'REQUEST'
,p_message_language=>'de'
,p_message_text=>'Anfordern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694980333303249)
,p_name=>'REQUESTED'
,p_message_language=>'de'
,p_message_text=>'Angefordert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959152296303470)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 von Workspace "%1" hat die \00C4nderung der Datenbankgr\00F6\00DFe um zus\00E4tzliche %2 angefordert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959008886303470)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('%0 hat ein neues Schema f\00FCr Workspace "%1" mit %2 angefordert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98958964003303470)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 fordert den neuen Workspace "%1" mit einer Gr\00F6\00DFe von %2 an')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208930936302853)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'%0 fordert neuen Workspace an "%1"'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648010937303205)
,p_name=>'RESEARCHING'
,p_message_language=>'de'
,p_message_text=>'Recherche erfolgt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183541382302833)
,p_name=>'RESET_4000'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230493973302870)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Auf Nullwert zur\00FCcksetzen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215353873302858)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'de'
,p_message_text=>'Resource Manager-Nutzungsgruppe'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913112081303427)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Eingeschr\00E4nkter Zugriff')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483648042303076)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'de'
,p_message_text=>unistr('Eingeschr\00E4nkt: Darf nicht vom Browser festgelegt werden')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701260916303255)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Die Webservicereferenz wurde der Anwendung %0 hinzugef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313234412302937)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'de'
,p_message_text=>'Mit Aliasnamen versehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111824634303594)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die APEX-RESTful Services befinden sich im schreibgesch\00FCtzten Modus.</p>'),
'',
unistr('<p>Sie k\00F6nnen die APEX-basierten RESTful Services gem\00E4\00DF ihrer Definition verwenden. Oracle empfiehlt jedoch eine Migration dieser Services zu ORDS. Klicken Sie dazu auf <strong>Zu ORDS-RESTful Services migrieren</strong>.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108436201303591)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'de'
,p_message_text=>unistr('Aktuell ausgef\00FChrte Version von ORDS nicht gefunden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312699525302937)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111721491303594)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit dieser Aktion wird die Registrierung aller ORDS-REST-Servicedefinitionen f\00FCr das ausgew\00E4hlte Schema aufgehoben, und die Definitionen werden entfernt. Diese Aktion kann nicht r\00FCckg\00E4ngig gemacht werden.</p>'),
'',
unistr('<p>M\00F6chten Sie die Registrierung dieses Schemas wirklich aufheben?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98561767072303138)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'de'
,p_message_text=>unistr('Ein APEX-Pfadpr\00E4fix mit diesem Wert ist bereits f\00FCr einen anderen Workspace definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623043336303185)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Dieser Schemaalias wird bereits von einem anderen Schema verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312512703302936)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348231630303792)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Insgesamt aktivierte Objekte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296323843302923)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'de'
,p_message_text=>unistr('Das Glob-Zeichen (*) darf nur als letztes Zeichen in einem Routenmuster vorkommen und darf nur hinter einem benannten Parameter oder einem Schr\00E4gstrich (/) stehen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961393730303471)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'de'
,p_message_text=>'Handler erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961530783303472)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Handler gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931016744303443)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'de'
,p_message_text=>'Handler-ID erwartet und NULL empfangen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961498221303472)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Handler aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296258404302923)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'de'
,p_message_text=>unistr('In den Literalteilen des Routenmusters wurden ung\00FCltige Zeichen gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333111426302952)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'de'
,p_message_text=>'Autorisierung erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381102838303819)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">Durch Klicken auf die Schaltfl\00E4che "Migrieren" werden die Metadaten f\00FCr alle APEX-basierten REST-Services nach ORDS kopiert. Die Definitionen der bestehenden APEX-basierten Services bleiben intakt, werden ')
||unistr('jedoch nicht ausgef\00FChrt, solange ein passender Service in ORDS vorhanden ist. '),
'',
unistr('Es wird empfohlen, dass Sie die migrierten ORDS-basierten Services nach der Migration validieren und testen. Nachdem Sie sie verifiziert haben, exportieren und l\00F6schen Sie die APEX-basierten Services.</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99381092211303819)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX hat festgestellt, dass Ihr Workspace mindestens 2 APEX-basierte REST-Module mit NULL-URI-Pr\00E4fixen enth\00E4lt. ORDS l\00E4sst h\00F6chstens ein Modul mit demselben Basis-URI-Pr\00E4fix zu. </p>'),
'',
'<p>Um diese Services nach ORDS zu migrieren, werden die folgenden Regeln angewendet: </p>',
'',
'<ul>',
'<li>Alle betroffenen Module werden in einem einzigen ORDS-Modul mit dem Namen <em><strong>merged.apex.rest.services</strong></em> zusammengefasst.</li>',
unistr('<li>Wenn <strong><em>eines</em></strong> der APEX-basierten Module, die zusammengef\00FChrt werden, ver\00F6ffentlicht wird, wird das neue zusammengef\00FChrte Modul <strong><em>ver\00F6ffentlicht</em></strong>.</li>'),
unistr('<li>Wenn <strong><em>keines</em></strong> der APEX-basierten Module, die zusammengef\00FChrt werden, ver\00F6ffentlicht wird, wird das neue zusammengef\00FChrte Modul <strong><em>nicht ver\00F6ffentlicht</em></strong>.</li>'),
unistr('<li><strong><em>Alle Rollen</em></strong>, die mit den APEX-basierten Modulen, die zusammengef\00FChrt werden, verkn\00FCpft sind, <strong><em>werden dem neuen zusammengef\00FChrten Modul zugewiesen</em></strong>.</li>'),
unistr('<li>Die <strong><em>Gr\00F6\00DFe der Seitennummerierung</em></strong> des zusammengef\00FChrten Moduls wird auf die <strong><em>gr\00F6\00DFte Gr\00F6\00DFe der Seitennummerierung</em></strong> der Module, die zusammengef\00FChrt werden, gesetzt.</li>'),
'<li>Wenn APEX-Module mit NULL-Basis-URIs vorhanden sind, die auch doppelte Template-URIs haben, passiert Folgendes:',
'',
'<ul>',
unistr('<li>Das zuletzt aktualisierte Template beh\00E4lt die doppelte URI</li>'),
unistr('<li>Alle anderen Templates werden mit dem Pr\00E4fix "dup001_*" versehen</li>'),
unistr('<li>Der Kommentar f\00FCr das Template enth\00E4lt den Namen des Originalmoduls, aus dem das Template migriert wurde, und die URI des Originaltemplates</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380992513303819)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX hat festgestellt, dass Ihr Workspace mindestens 2 APEX-basierte REST-Module mit NULL-URI-Pr\00E4fixen enth\00E4lt. ORDS l\00E4sst h\00F6chstens ein Modul mit demselben Basis-URI-Pr\00E4fix zu. </p>'),
'',
unistr('<p>Es ist derzeit nicht m\00F6glich, Ihre APEX-basierten REST-Services nach ORDS zu migrieren. Die Migration ist ab ORDS Version 18.2 verf\00FCgbar.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99347973610303792)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Module gesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960740213303471)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Modul erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960923047303471)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Modul gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930872044303443)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'de'
,p_message_text=>'Modul-ID erwartet und NULL empfangen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960840122303471)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Modul aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296039581302923)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'de'
,p_message_text=>unistr('Ein benannter Parameter im Routenmuster enth\00E4lt ung\00FCltige Zeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99178044238303646)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'de'
,p_message_text=>'Dieses Schema wurde noch nicht bei ORDS RESTful Data Services registriert. Klicken Sie auf <strong>Schema bei ORDS registrieren</strong>, um dieses Schema zu registrieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296471906302924)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'de'
,p_message_text=>unistr('Die URI stimmte nicht mit dem URI- oder ROUTE-Stilmuster \00FCberein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296587001302924)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere aufeinander folgende Schr\00E4gstriche sind nicht zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295930131302923)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr ein Routenmuster darf keine Abfragezeichenfolge verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98199927214302846)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'de'
,p_message_text=>unistr('<p>APEX wird derzeit in der CDB ausgef\00FChrt. Sie k\00F6nnen keine ORDS-basierten REST-Services in der CDB definieren.</p><p>Die APEX-basierten RESTful Services k\00F6nnen Sie weiterhin verwenden.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99111695382303594)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die derzeit installierte ORDS-Version (%0) unterst\00FCtzt nicht alle Funktionen, die f\00FCr das Aktivieren der ORDS-basierten RESTful Services in Application Express erforderlich sind. Mindestens Version %1 muss installiert sein.</p>'),
unistr('<p>Sie k\00F6nnen die APEX-basierten RESTful Services weiterhin verwenden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296114977302923)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'de'
,p_message_text=>'Das Optional-Zeichen (?) darf nur als letztes Zeichen in einem Routenmuster vorkommen und darf nur hinter einem benannten Parameter stehen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294934537302922)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Das System konnte das ORDS_METADATA-Schema nicht finden, das f\00FCr die Aktivierung des ORDS-REST-Workshops erforderlich ist. Informationen zu den Installationsschritten finden Sie im Oracle REST Data Services-Installationshandbuch.</p> <p>Sie k\00F6nnen')
||' die APEX-basierten RESTful Services weiterhin verwenden.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313109777302937)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'de'
,p_message_text=>'Teilweise gesichert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294883552302922)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Dieses System verwendet derzeit das eingebettete PL/SQL Gateway von Oracle. Sie m\00FCssen Version %0 oder h\00F6her von Oracle REST Data Services installieren, um den Zugriff auf den ORDS-REST-Workshop zu aktivieren.</p> <p>Sie k\00F6nnen die APEX-basierten ')
||'RESTful Services weiterhin verwenden.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348029297303792)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Berechtigungen gesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961937311303472)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Berechtigung erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962122972303472)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Berechtigung gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962062165303472)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Berechtigung aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312760297302937)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlicht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313871627302937)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit dieser Aktion werden das Modul <strong>oracle.example.hr</strong> sowie zugeh\00F6rige Datenbankobjekte im derzeit ausgew\00E4hlten Schema gel\00F6scht und neu erstellt. Alle vorgenommenen \00C4nderungen oder Erg\00E4nzungen gehen verloren und k\00F6nnen nicht wieder')
||'hergestellt werden.</p>',
unistr('<p>M\00F6chten Sie den Beispielservice wirklich zur\00FCcksetzen?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348183878303792)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Rollen gesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961616709303472)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Rolle erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961881039303472)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Rolle gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961787924303472)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Rolle aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333045632302952)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'de'
,p_message_text=>'Zugriffsstatus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98333225014302952)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'de'
,p_message_text=>'Schemaalias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108626704303592)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Das hochgeladene Skript ist zu gro\00DF. Application Express hat einen Grenzwert von 32 MB (32767 Byte).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312929247302937)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'de'
,p_message_text=>'Gesichert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930937567303443)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Sequenz-ID f\00FCr Parameter erwartet und NULL empfangen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348449476303792)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348337215303792)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348536372303792)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961091614303471)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Template wurde erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961236499303471)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Template wurde gel\00F6scht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931180956303443)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'de'
,p_message_text=>'Template-ID erwartet und NULL empfangen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231122589302871)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'de'
,p_message_text=>'Das URI-Template darf nicht Null sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98961188294303471)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Template aktualisiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313452366302937)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'de'
,p_message_text=>'Aktivierte Objekte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313533721302937)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'de'
,p_message_text=>'Module'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313626404302937)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'de'
,p_message_text=>'Berechtigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313726048302937)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'de'
,p_message_text=>'Rollen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99336912155303783)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'de'
,p_message_text=>'RESTful Data Services'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313310116302937)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'de'
,p_message_text=>'Nicht mit Aliasnamen versehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312887030302937)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht ver\00F6ffentlicht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98313029712302937)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'de'
,p_message_text=>'Nicht gesichert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295899300302923)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'de'
,p_message_text=>'Mindestens eine URI-Variable weist einen Syntaxfehler auf.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912052402303426)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Das Skript, das Sie laden m\00F6chten, ist ein Export eines APEX-basierten RESTful Service. Es kann nicht mit der Importseite "ORDS-RESTful Services" geladen werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175604701303644)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'de'
,p_message_text=>unistr('Das Skript, das Sie laden m\00F6chten, ist ein Export eines ORDS-basierten RESTful Service. Es kann nicht mit der Importseite "APEX-RESTful Services" geladen werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348698219303793)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'de'
,p_message_text=>'In Zwischenablage kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99348724291303793)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'de'
,p_message_text=>unistr('Vollst\00E4ndige URL in Zwischenablage kopieren')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306998566303757)
,p_name=>'RETAINED'
,p_message_language=>'de'
,p_message_text=>'Beibehalten'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421601470303026)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zur %0-Anmeldeseite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426985804303858)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'de'
,p_message_text=>unistr('R\00FCckgabewert: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648303631303205)
,p_name=>'REVIEWING'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfung erfolgt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98909764757303424)
,p_name=>'ROLE'
,p_message_language=>'de'
,p_message_text=>'Rolle'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427804383303031)
,p_name=>'ROLLBACK'
,p_message_language=>'de'
,p_message_text=>'ROLLBACK-Anweisung nicht anwendbar. Alle Anweisungen werden automatisch festgeschrieben.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771624885303314)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zeilen zur\00FCckgegeben in %1 Sekunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251505648302887)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilen zur\00FCckgegeben in')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862372075303385)
,p_name=>'RUN'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176683667302828)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren und entwickeln')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98627836932303189)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865174057303388)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung ausf\00FChren: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424539885303028)
,p_name=>'RUN_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Nur ausf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867122604303389)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Seite ausf\00FChren: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98230759537302870)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Beispielanwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824980117303356)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4nder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825279497303356)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Auflistung von L\00E4ndern, Bev\00F6lkerung und Kapital.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412328878303019)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'de'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412422305303019)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'de'
,p_message_text=>'Die generischen EMP- und DEPT-Tabellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825072423303356)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'de'
,p_message_text=>'Formel 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825413107303356)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'de'
,p_message_text=>'Formel 1-Weltmeister'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306290115303757)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'de'
,p_message_text=>'Gesundheitsaktualisierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306318328303757)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Vereinfachte, vom Patienten gemeldete Aktualisierungen des Gesundheitszustands f\00FCr Gesundheitsdienstleister.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412547200303019)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'de'
,p_message_text=>'HR-Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412604039303019)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'de'
,p_message_text=>'Die generischen HR-Tabellen, die meist von Oracle Education verwendet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865239488303388)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'de'
,p_message_text=>'Kundenbestellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865351246303388)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Eine Sammlung von Kunden, Gesch\00E4ften, Produkten und Bestellungen. Dieses Dataset enth\00E4lt JSON-Daten f\00FCr die Produktbeschreibung sowie L\00E4ngengrad/Breitengrad f\00FCr die Gesch\00E4fte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412118686303018)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'de'
,p_message_text=>'Projektdaten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412243039303019)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Eine Collection von Projekten, Meilensteinen, Aufgaben und mehr. Dieses Dataset umfasst Master-Detail-Detail-Beziehungen und eine n\00FCtzliche Ansicht zur Diagrammerstellung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412701441303019)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'de'
,p_message_text=>'Aufgabenkalkulationstabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98412859493303019)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Eine einzelne Tabelle mit nicht normalisierten Daten, die Aufgaben, Termine, Statusangaben, Beauftragte, Kosten und Budget enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824846925303356)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'de'
,p_message_text=>'Tennis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825372632303356)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'de'
,p_message_text=>'Gewinner und Zweitplatzierte der Herren und Damen bei Grand Slam-Turnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825191776303356)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'de'
,p_message_text=>'WM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825564177303356)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'de'
,p_message_text=>unistr('Fu\00DFball-WM-Ergebnisse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708785063303261)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'de'
,p_message_text=>'Beispiel-Websheet'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695502220303250)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Linkalias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695615167303250)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'de'
,p_message_text=>'Linkbeispiel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695754861303250)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'de'
,p_message_text=>'Weitere gespeicherte Berichte...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695277334303250)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'de'
,p_message_text=>'Hauptbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694502840303249)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'de'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98694691142303249)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>'Private Subscription'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695111872303250)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695421879303250)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'de'
,p_message_text=>'Berichtsname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98695359005303250)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Berichtstyp'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339511723302957)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationspfadeintrag gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339760814302957)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadeintrag erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339664891302957)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Navigationspfadeintrag aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339440039302957)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationspfad gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339314588302956)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311311859302936)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Interaktive Grid-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311208843302935)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Seitenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667731085303223)
,p_name=>'SCHEMAS'
,p_message_language=>'de'
,p_message_text=>'Schemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98779235342303320)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Ausnahme beim Einf\00FCgen in wwv_flow_companies-Schema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778207296303319)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Das Schema "%0" ist verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778353241303319)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Das Schema "%0" ist aktuell NICHT verf\00FCgbar und kann nicht erstellt werden, weil es mit einem vorhandenen Benutzer in Konflikt ger\00E4t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98575985048303149)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'de'
,p_message_text=>'Schemakennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392721965303002)
,p_name=>'SCHEMES'
,p_message_language=>'de'
,p_message_text=>'Schemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346815028303791)
,p_name=>'SCREEN_READER'
,p_message_language=>'de'
,p_message_text=>'Bildschirmsprachausgabe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698858051303253)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'de'
,p_message_text=>'Bildschirmsprachausgabe umschalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729423015303279)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Datei wurde aus einem anderen Workspace (%0) exportiert, der m\00F6glicherweise von einer anderen %1-Datenbank stammt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371024023303811)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Skript %0 gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370905478303811)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Skript %0 entsperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380173605303818)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Skript ist nicht gesperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98656184845303211)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'Um ein Objekt zu beschreiben, geben Sie oben im Befehlsfenster <br><br> ',
'',
unistr('DESCRIBE &lt Objektname &gt ein, und klicken Sie auf <b>Ausf\00FChren</b>.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685602672303240)
,p_name=>'SC_NAME_NN'
,p_message_language=>'de'
,p_message_text=>'Der Abfragename darf nicht Null sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697644918303252)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
'Das zu beschreibende Objekt konnte nicht gefunden werden.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688259133303243)
,p_name=>'SC_SC'
,p_message_language=>'de'
,p_message_text=>'Nicht visuelle Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98622610821303185)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'de'
,p_message_text=>unistr('SQL-Anweisung wird ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688171391303243)
,p_name=>'SC_VQ'
,p_message_language=>'de'
,p_message_text=>'Visuelle Abfrage'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310635887303760)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Suchleisteneinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730627173303280)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'de'
,p_message_text=>'Suchfeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576321086303149)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'de'
,p_message_text=>'Es sind keine varchar-Spalten in dieser Abfrage vorhanden. Die Suche kann nicht aktiviert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98565746474303141)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Es sind keine varchar-Spalten f\00FCr die Suche vorhanden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730524052303280)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'de'
,p_message_text=>unistr('Produktivit\00E4ts- und Beispielanwendungen durchsuchen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99125059726303604)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'de'
,p_message_text=>'Suchergebnisse'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99312563333303762)
,p_name=>'SECTIONS'
,p_message_language=>'de'
,p_message_text=>'Abschnitte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371531032302981)
,p_name=>'SECURITY'
,p_message_language=>'de'
,p_message_text=>'Sicherheit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662800921303216)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'de'
,p_message_text=>'Sicherheitsbeauftragter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013768896303515)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Sicherheitsgruppen-ID (Ihre Workspace-ID) ist ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660970308303214)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'de'
,p_message_text=>'Sicherheitsauswirkung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702820567303256)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689367246303244)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Darf kein \00F6ffentlicher Benutzer sein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663201318303216)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'de'
,p_message_text=>'Sicherheitsstatus'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688858913303244)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Siehe angeh\00E4ngten Bericht')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224081479302865)
,p_name=>'SELECT_ALL'
,p_message_language=>'de'
,p_message_text=>unistr('Alle ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570032909303145)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178536319302829)
,p_name=>'SELECT_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie ein Datum aus der Spalte. Aktueller Monat = %0, Aktuelles Jahr = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99197058536303661)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'de'
,p_message_text=>unistr('Dynamische Aktion ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381164864302992)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381066888302992)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380964677302992)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380891250302992)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381220090302992)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398042541303834)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile ausw\00E4hlen: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833495467303362)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie einen Workspace unten, um die Application Express-Entwicklungsumgebung zu \00F6ffnen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757072629303303)
,p_name=>'SELF_SERVICE'
,p_message_language=>'de'
,p_message_text=>'Self-Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756926539303303)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Self-Service mit E-Mail-\00DCberpr\00FCfung')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99370636659303810)
,p_name=>'SEPARATOR'
,p_message_language=>'de'
,p_message_text=>'Trennzeichen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389680586302999)
,p_name=>'SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98818024736303351)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Sequenz: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254924747302890)
,p_name=>'SERIES'
,p_message_language=>'de'
,p_message_text=>'Datenreihe %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659460475303213)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Service-\00C4nderung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202518483302848)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'de'
,p_message_text=>'Site-Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639532303303198)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'de'
,p_message_text=>'Serviceanforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397232856303006)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie den Verifizierungscode unter Ber\00FCcksichtigung der Gro\00DF-/Kleinschreibung ein, und klicken Sie anschlie\00DFend auf <strong>Anforderung weiterleiten</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396157473303005)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'de'
,p_message_text=>'Administratorinformationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397143918303006)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Datenbankgr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396061879303005)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396427997303005)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396276667303005)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'de'
,p_message_text=>'Vorname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395858046303005)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Begr\00FCndung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396342271303005)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'de'
,p_message_text=>'Nachname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395711278303004)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396970604303006)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396531543303005)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'de'
,p_message_text=>'Telefon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396746267303005)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Vorhandenes Schema erneut verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396695710303005)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'de'
,p_message_text=>'Schemainformationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397008401303006)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'de'
,p_message_text=>'Schemaname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395654016303004)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'de'
,p_message_text=>'Informationen zum Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98396898087303005)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588586998303159)
,p_name=>'SESSION'
,p_message_language=>'de'
,p_message_text=>'Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98691203249303246)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion f\00FCr die Sessionverifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98232207068302871)
,p_name=>'SESSIONS'
,p_message_language=>'de'
,p_message_text=>'Sessions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754952764303301)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'de'
,p_message_text=>'Puffer:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754720492303301)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'de'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754447614303301)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'de'
,p_message_text=>'Aktuell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754826192303301)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'de'
,p_message_text=>unistr('Datentr\00E4ger:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754667321303301)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'de'
,p_message_text=>'Verstrichen:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98754563482303301)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315801193302939)
,p_name=>'SET_BINDS'
,p_message_language=>'de'
,p_message_text=>unistr('Beim Testen einer Abfrage m\00FCssen Werte f\00FCr alle Bind-Variablen festgelegt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218065523302860)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('Legen Sie das F\00E4lligkeitsdatum der %0 unvollst\00E4ndigen Features, die %1 f\00FCr Release %2 zugewiesen sind, auf das Datum des Meilensteins fest.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337883739302955)
,p_name=>'SET_MILESTONE'
,p_message_language=>'de'
,p_message_text=>'Meilenstein festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218349217302860)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'de'
,p_message_text=>unistr('Setzen Sie Features mit fehlenden Meilensteinen auf Meilenstein (%3) f\00FCr die %0 unvollst\00E4ndigen Features, die %1 f\00FCr Release %2 zugewiesen sind')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98218237409302860)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4ndern Sie den Meilenstein von %0 unvollst\00E4ndigen Features, die %1 f\00FCr Release %2 zugewiesen sind, der einem abgelaufenen Meilenstein entspricht, in Meilenstein (%3).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337436090302955)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'de'
,p_message_text=>unistr('%0 offene Features werden dem ausgew\00E4hlten Meilenstein zugewiesen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98337996046302955)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'de'
,p_message_text=>unistr('F\00E4lligkeitsdatum von %0 offenen Features wird auf das Meilensteindatum festgelegt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375128962303814)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'de'
,p_message_text=>'Voreinstellungen festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338145919302956)
,p_name=>'SET_RELEASE'
,p_message_language=>'de'
,p_message_text=>'Release festlegen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753731370303300)
,p_name=>'SHARED'
,p_message_language=>'de'
,p_message_text=>'Gemeinsam verwendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932934955303444)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponenten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690996516303246)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame dynamische Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98187416702302836)
,p_name=>'SHARED POOL'
,p_message_language=>'de'
,p_message_text=>'Shared Pool'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98690813322303246)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr gemeinsame statische Werteliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262473413302896)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930277218303442)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Validierung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392841038303002)
,p_name=>'SHORTCUT'
,p_message_language=>'de'
,p_message_text=>'Shortcut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835456133303364)
,p_name=>'SHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'Shortcuts'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98642428439303200)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'de'
,p_message_text=>'Erhebliche Auswirkung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98645557872303203)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'Bedeutender Fortschritt'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391325486303001)
,p_name=>'SIMPLE'
,p_message_language=>'de'
,p_message_text=>'einfach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636915003303196)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'de'
,p_message_text=>'Einfaches Diagramm'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714028985303266)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'de'
,p_message_text=>'vor 16 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773550205303316)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'de'
,p_message_text=>'Vor 1 Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773415861303316)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'de'
,p_message_text=>'Vor 1 Stunde '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393459976303830)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'de'
,p_message_text=>'in 16 Std.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773684867303316)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'de'
,p_message_text=>'Vor 1 Woche'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229044407302869)
,p_name=>'SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Gr\00F6\00DFe')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349851229303794)
,p_name=>'SL.APP'
,p_message_language=>'de'
,p_message_text=>'Anwendung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345972218303790)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'de'
,p_message_text=>'Seite %0 in Anwendung %1 bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346055567303790)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'de'
,p_message_text=>'Gehe zu Anwendung %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175823077303644)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('1 \00DCbereinstimmung gefunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99175934630303644)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('%0 \00DCbereinstimmungen gefunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99193273476303658)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Keine \00DCbereinstimmung gefunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349965718303794)
,p_name=>'SL.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98867284388303389)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'de'
,p_message_text=>'Suche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98912500187303426)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'de'
,p_message_text=>'Alle Anwendungen nach %0 durchsuchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346390601303791)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'de'
,p_message_text=>'Diese Anwendung nach %0 durchsuchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99108084488303591)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie mindestens zwei Buchstaben f\00FCr die Suche ein')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346264700303791)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite nach %0 durchsuchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346454452303791)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'de'
,p_message_text=>'Team Development nach %0 durchsuchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346585289303791)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'de'
,p_message_text=>'Benutzer %0 suchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346602132303791)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'de'
,p_message_text=>'Workspace nach %0 durchsuchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99346115109303790)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'de'
,p_message_text=>'Gemeinsame Komponenten von Anwendung %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639462583303198)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'de'
,p_message_text=>unistr('Software besch\00E4digt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644431704303202)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Etwas w\00FCnschenswert')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971833996303480)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'de'
,p_message_text=>'Quell-ID'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778509048303320)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Speicherplatzauslastung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628091812303189)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('SQL nicht verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98835856047303364)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98771511172303314)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'de'
,p_message_text=>'SQL-Befehle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666802517303223)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'de'
,p_message_text=>'SQL-Befehlshistorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444760937303044)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'SQL-Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705115034303258)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704802466303258)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'de'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704995023303258)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'de'
,p_message_text=>'Prozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704708057303258)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98705075785303258)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'de'
,p_message_text=>'Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990505304303496)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'de'
,p_message_text=>unistr('SQL- und PL/SQL-Zugriff ist f\00FCr diese Anwendung nicht aktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990674989303496)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'de'
,p_message_text=>unistr('SQL- und PL/SQL-Zugriff ist f\00FCr diese Instanz nicht aktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390417906303000)
,p_name=>'SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196473398302843)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Abfrage, keine SELECT-Anweisung gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491976432303083)
,p_name=>'SQL_REPORT'
,p_message_language=>'de'
,p_message_text=>'SQL-Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295343450302923)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384125559302994)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384673866302995)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'de'
,p_message_text=>'Sortierspalte deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383884408302994)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'de'
,p_message_text=>'Anzeigewert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384251267302994)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rsortierspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295282449302923)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'de'
,p_message_text=>'Ersetzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98383948171302994)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('R\00FCckgabewert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384471500302995)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'de'
,p_message_text=>unistr('Sekund\00E4rsortierspalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384517761302995)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667084228303223)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'de'
,p_message_text=>'SQL-Skripts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666908760303223)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'de'
,p_message_text=>'SQL-Skriptergebnisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976692868303484)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden Datenbankobjekte m\00FCssen in der Liste zul\00E4ssiger Tabellen definiert werden: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667155460303223)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98447020307303046)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Der angegebene Alias wird bereits von einem anderen Objekt verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98446920428303046)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben einen ung\00FCltigen Objektalias angegeben. G\00FCltige Aliasnamen d\00FCrfen nur Buchstaben, Zahlen, Unterstriche und Bindestriche enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98760677912303306)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Schema ist nicht bei ORDS RESTful Data Services registriert. Um dieses Schema zu registrieren, navigieren Sie zu <strong>RESTful Services > ORDS RESTful Services</strong>, und klicken Sie auf die Schaltfl\00E4che <strong>Schema bei ORDS registrier')
||'en</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775624801303317)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'de'
,p_message_text=>unistr('APEX wird derzeit in der CDB ausgef\00FChrt. Sie k\00F6nnen keine ORDS-basierten REST-Services in der CDB definieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775464789303317)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'de'
,p_message_text=>unistr('Die aktuell installierte ORDS-Version (%0) unterst\00FCtzt nicht alle Funktionen, die erforderlich sind, um REST f\00FCr Datenbankobjekte zu aktivieren. Mindestens Version %1 muss installiert sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775264328303317)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Das System konnte das ORDS_METADATA-Schema nicht finden, das f\00FCr das Aktivieren der ORDS RESTful Services erforderlich ist. Informationen zu den Installationsschritten finden Sie im Oracle REST Data Services-Installationshandbuch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775533818303317)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'de'
,p_message_text=>'ORDS-Version <strong>%0</strong>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98775333112303317)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses System verwendet derzeit das Oracle Embedded PL/SQL Gateway. Sie m\00FCssen Version %0 oder h\00F6her von Oracle REST Data Services installieren, um REST f\00FCr Datenbankobjekte zu aktivieren.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165312717302819)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Gestapelte 2D-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165452528302819)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Gestapelte 3D-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165597133302819)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Gestapelte horizontale 2D-Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98165606559302819)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Gestapelte horizontale 3D-Spalte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931706294303443)
,p_name=>'STANDARD _TABS'
,p_message_language=>'de'
,p_message_text=>'Standardregisterkarten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98933448652303445)
,p_name=>'STANDARD_TAB'
,p_message_language=>'de'
,p_message_text=>'Standardregisterkarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98371634142302981)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'de'
,p_message_text=>'Standard-Registerkartengruppe'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257802084302892)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'de'
,p_message_text=>'Statische Anwendungsdateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257733784302892)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'de'
,p_message_text=>'Statische Workspace-Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428488006303860)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie mindestens ein Schl\00FCsselwort ein, das mindestens zwei Zeichen enth\00E4lt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428567367303860)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Es konnten keine Ergebnisse gefunden werden, die mit Ihrer Suchabfrage \00FCbereinstimmen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444587817303044)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'de'
,p_message_text=>'Statische Zuweisung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777073533303318)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Keine Anwendung zugewiesen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98188648919302837)
,p_name=>'STATIC_HTML'
,p_message_language=>'de'
,p_message_text=>'Statische HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172127653302824)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Statische Referenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635788994303195)
,p_name=>'STATIC_REGION'
,p_message_language=>'de'
,p_message_text=>'Statische Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700390387303254)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'de'
,p_message_text=>'Statische Ersetzungszeichenfolgen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391173554303828)
,p_name=>'STATUS_LABEL'
,p_message_language=>'de'
,p_message_text=>'Status: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571579761303146)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('Status wurde ge\00E4ndert')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686925019303242)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'de'
,p_message_text=>unistr('Bedingung f\00FCr Standardregisterkarte')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380276949303818)
,p_name=>'STEAL_LOCK'
,p_message_language=>'de'
,p_message_text=>'Sperre stehlen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231992726302871)
,p_name=>'STORAGE'
,p_message_language=>'de'
,p_message_text=>'Speicherung:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98390591256303000)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'de'
,p_message_text=>'Strukturierte Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98491796256303082)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'de'
,p_message_text=>'Strukturierter Bericht'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98777937400303319)
,p_name=>'SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571488231303146)
,p_name=>'SUBMITTED'
,p_message_language=>'de'
,p_message_text=>'Weitergeleitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98487239224303079)
,p_name=>'SUBMIT_AS'
,p_message_language=>'de'
,p_message_text=>'Weiterleiten als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98697134844303251)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'de'
,p_message_text=>'Feedback weiterleiten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629261166303190)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'de'
,p_message_text=>'Untergeordneter aktueller Eintrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98629341317303190)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'de'
,p_message_text=>'Untergeordneter nicht aktueller Eintrag'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406003680303841)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'de'
,p_message_text=>'Nicht vorhandener Master'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406293181303841)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406149037303841)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'de'
,p_message_text=>'Theme-Repository'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373772208302982)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374048049302982)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'de'
,p_message_text=>'Hierbei handelt es sich um die "Master"-Kopie dieses Autorisierungsschemas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374214614302983)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine Autorisierungsschemas abonnieren dieses Autorisierungsschema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374113975302983)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschemas abonnieren dieses Autorisierungsschema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176120697302828)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176412820302828)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'de'
,p_message_text=>'Dies ist die "Master"-Kopie dieser Datenladedefinition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176335514302828)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine Datenladedefinitionen abonnieren diese Definition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176257913302828)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Datenladedefinition, die diese Definition abonniert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373161808302982)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373229102302982)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'de'
,p_message_text=>'Hierbei handelt es sich um die "Master"-Kopie dieser Elementhilfe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373472709302982)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Elemente abonnieren diesen Text f\00FCr die Elementhilfe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98373353400302982)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Elemente abonnieren diesen Text f\00FCr die Elementhilfe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375737344302984)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375802504302984)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'de'
,p_message_text=>'Dies ist die "Master"-Kopie dieser Werteliste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376096761302988)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine Wertelisten abonnieren diese Werteliste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375943725302984)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Wertelisten, die diese Werteliste abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263873511302897)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377381536302989)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'de'
,p_message_text=>'Hierbei handelt es sich um die "Master"-Kopie dieser Navigationsleiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377983661302989)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine Navigationsleisten abonnieren diese Navigationsleiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98377676803302989)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Navigationsleisten abonnieren diese Navigationsleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263422911302897)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263593922302897)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'de'
,p_message_text=>'Dies ist die "Master"-Kopie dieses Plug-ins.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263782968302897)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Dieses Plug-in haben keine Plug-ins abonniert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263645834302897)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Plug-ins, die dieses Plug-in abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374542220302983)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374707848302983)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'de'
,p_message_text=>'Hierbei handelt es sich um die "Master"-Kopie dieses Shortcuts.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375018009302983)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine Shortcuts abonnieren diesen Shortcut.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374945506302983)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Shortcuts, die dieses Shortcut abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369370117302979)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369507033302979)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'de'
,p_message_text=>'Dies ist die "Master"-Kopie dieses Templates.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369641093302979)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine Templates abonnieren dieses Template.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98369477208302979)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Template f\00FCr Popup-Werteliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380452222302991)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Templates, die dieses Template abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344846208303789)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Bei Anwendungs-Theme eingeschrieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99387498830303824)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'de'
,p_message_text=>'Bei Standard-Theme eingeschrieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345200005303790)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'de'
,p_message_text=>'Dies ist die "Master"-Kopie dieses Themes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345185954303790)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Dieses Theme wird von keinen Themes abonniert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344995770303789)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Theme f\00FCr Popup-Werteliste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99345040828303790)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Themes, die dieses Theme abonnieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752731522303299)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752845276303299)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'de'
,p_message_text=>'Dies ist die "Master"-Kopie dieser REST-Datenquelle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753008188303300)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Keine REST-Datenquellen abonnieren diese Quelle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98752979385303299)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquellen, die diese Quelle abonnieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379457746302990)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'de'
,p_message_text=>'Kopiert aus Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380226057302991)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'de'
,p_message_text=>unistr('Dies ist die "Master"-Kopie dieses Schaltfl\00E4chen-Templates.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380693239302991)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Templates abonnieren dieses Schaltfl\00E4chen-Template.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380570791302991)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen-Templates abonnieren dieses Schaltfl\00E4chen-Template.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98207463653302852)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'de'
,p_message_text=>'Verwendung der Ersetzungszeichenfolge'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608177195303174)
,p_name=>'SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684656677303239)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Erfolgsmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98570542430303145)
,p_name=>'SUCCESSES'
,p_message_language=>'de'
,p_message_text=>'Erfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437238488303038)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'de'
,p_message_text=>'Cluster wurde geleert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433512142303035)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'de'
,p_message_text=>unistr('Befehl ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436344475303038)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Kontext gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436590845303038)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'de'
,p_message_text=>'Datenbanklink wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436417747303038)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Datenbanklink gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437467841303038)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432442628303035)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'de'
,p_message_text=>'Funktion wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435319221303037)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437033828303038)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Indextyp wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436234608303038)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Indextyp wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432887244303035)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'de'
,p_message_text=>'Index wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435601196303037)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Index wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433116454303035)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'de'
,p_message_text=>'Materialized View erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435792046303037)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Materialized View wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437351917303038)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Package wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432665851303035)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'de'
,p_message_text=>'Package Body wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432756558303035)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'de'
,p_message_text=>'Package wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434694515303036)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Package wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437514775303039)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Prozedur wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432584086303035)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Prozedur wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435409671303037)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Prozedur wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433273878303035)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Rolle wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435867462303037)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Rolle wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434086182303036)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zeile(n) wurde(n) gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433832197303036)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zeile(n) wurde(n) eingef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433708362303036)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'de'
,p_message_text=>'%0 Zeile(n) wurde(n) aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437678805303039)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Sequenz wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433358083303035)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'de'
,p_message_text=>'Sequenz wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435034880303037)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Sequenz wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159039623302814)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'de'
,p_message_text=>'Zeile wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158900851302814)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158840019302813)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Zeile wurde aktualisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193807433302841)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'de'
,p_message_text=>'Anweisung wurde verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433423243303035)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'de'
,p_message_text=>'Synonym wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435983692303037)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Synonym wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435192616303037)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Tabelle wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432052977303034)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Tabelle wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434592058303036)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Tabelle wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436601559303038)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'de'
,p_message_text=>'Tabelle wurde umbenannt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437150862303038)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'de'
,p_message_text=>'Tabelle wurde geleert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436954117303038)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Trigger wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432327896303034)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'de'
,p_message_text=>'Trigger wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436026795303037)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Trigger wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436808267303038)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Typ wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432923423303035)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Typ wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436177225303037)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Typ wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437795404303039)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433015519303035)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'de'
,p_message_text=>'Benutzer wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434746316303036)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzer wurde gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98436765059303038)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'de'
,p_message_text=>unistr('View wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432153549303034)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'de'
,p_message_text=>'View wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434872320303036)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'de'
,p_message_text=>unistr('View wurde gel\00F6scht.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776650995303318)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objekte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313310767303763)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Objektdefinition wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313419944303763)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'de'
,p_message_text=>'Das Objekt ist nicht mehr vorhanden.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637271465303196)
,p_name=>'SVG CHART'
,p_message_language=>'de'
,p_message_text=>'SVG-Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98726792633303277)
,p_name=>'SVG PLUGIN'
,p_message_language=>'de'
,p_message_text=>'Installieren Sie SVG Viewer, um das Diagramm anzuzeigen.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157370825302812)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen kein leeres SQL-Skript bearbeiten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157481340302812)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen kein Skript bearbeiten, das gr\00F6\00DFer als 30 000 Byte ist.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389719669302999)
,p_name=>'SYNONYM'
,p_message_language=>'de'
,p_message_text=>'Synonym'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991081769303496)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'de'
,p_message_text=>'(Synonym)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769933341303313)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'de'
,p_message_text=>'Synonym'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901180331303417)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Systemmeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571605041303146)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'de'
,p_message_text=>'Systemstatus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98571778828303146)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('Systemstatus wurde ge\00E4ndert')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389898408302999)
,p_name=>'TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98637895767303197)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ist kein g\00FCltiger Name f\00FCr eine Tabelle oder View.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667697744303223)
,p_name=>'TABLESPACES'
,p_message_language=>'de'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388820941302998)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'de'
,p_message_text=>'(Tabelle)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98684000437303239)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Der Tabellenname %0 \00FCberschreitet die zul\00E4ssige Gr\00F6\00DFe.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696953155303251)
,p_name=>'TABULAR_FORM'
,p_message_language=>'de'
,p_message_text=>'Tabellarisches Formular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703456141303257)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Das tabellarische Formular wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98384741207302995)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung: \00DCbergeordnetes Registerkartenziel "%0" referenziert m\00F6glicherweise eine Seite, die nicht vorhanden ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98376487805302988)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Registerkartensequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375301214302983)
,p_name=>'TAB_SET'
,p_message_language=>'de'
,p_message_text=>'Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98931617588303443)
,p_name=>'TAB_SETS'
,p_message_language=>'de'
,p_message_text=>'Registerkartengruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375588560302984)
,p_name=>'TAB_TEXT'
,p_message_language=>'de'
,p_message_text=>'Registerkartentext'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392320728303829)
,p_name=>'TAG_LABEL'
,p_message_language=>'de'
,p_message_text=>'Tag: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216893049302859)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'de'
,p_message_text=>'Zielfeatures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430436318303861)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'de'
,p_message_text=>'Zielseiten-ID oder benutzerdefinierte URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640515839303199)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Aufgabe abgeschlossen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664743551303221)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'de'
,p_message_text=>'Team Development'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98370325292302980)
,p_name=>'TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419522796303852)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'de'
,p_message_text=>'Aktion: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624236220303186)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'de'
,p_message_text=>'Nach Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624361498303186)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Vor Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419247210303852)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'de'
,p_message_text=>'Template kopieren: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419462603303852)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Neues Template: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98152999909302808)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate-Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623995402303186)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate-Body 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624062054303186)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate-Body 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98624118917303186)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'de'
,p_message_text=>'Seitentemplate-Body 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419353276303852)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'de'
,p_message_text=>'Templatevorschau: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623173642303185)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623282129303185)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623341329303185)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 11'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623436384303186)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623505618303186)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 13'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623658346303186)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623732197303186)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 15'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98623889532303186)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'de'
,p_message_text=>'Regionsposition 16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99126818038303606)
,p_name=>'TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Templates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757139154303303)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Templateanwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98186958317302836)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen einer Anwendung basierend auf einer Templateanwendung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824102728303355)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'de'
,p_message_text=>'Template-gesteuert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755207897303301)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'de'
,p_message_text=>'Erweitert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755165134303301)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'de'
,p_message_text=>'Allgemein'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99199106780303663)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755088008303301)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'de'
,p_message_text=>'Allgemein'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316212283303765)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'de'
,p_message_text=>unistr('Keine \00FCbereinstimmenden Templateoptionen definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323974827303772)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('- Keine Option ausgew\00E4hlt -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99300449987303751)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'de'
,p_message_text=>'Templatestandardwerte verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406876343303841)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht \00FCbereinstimmende Templateoptionen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427946297303859)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Template hat das entsprechende Template im Master-Theme abonniert. Um dieses Template zu bearbeiten, bearbeiten Sie das Master-Template und aktualisieren dann das Theme. Alternativ k\00F6nnen Sie eine lokale, nicht abonnierte Kopie dieses Template')
||unistr('s erstellen. Nicht abonnierte Templates k\00F6nnen bearbeitet werden und werden bei einer Theme-Aktualisierung nicht \00FCberschrieben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99427801951303859)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Dieses Template ist in dieser Anwendung lokal und sein Abonnement ist aufgehoben. ',
unistr('Individuelle Templates k\00F6nnen nicht abonniert werden, wenn das zugeh\00F6rige Theme abonniert ist.'),
unistr('Als Alternative zur Definition lokaler Templates k\00F6nnten Sie neue Templates zu dem Master-Theme hinzuf\00FCgen und diese dann einfach in diese Anwendung \00FCbertragen oder aus dieser Anwendung abrufen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381511243302992)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Als Anwendungs-Standardtemplate referenziert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381710956302992)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Als Fehler-Template referenziert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381909327302993)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'de'
,p_message_text=>'Dieses Seitentemplate wird NICHT referenziert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98382031043302993)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'de'
,p_message_text=>'Dieses Seitentemplate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381801201302992)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'de'
,p_message_text=>'Referenziert in Seite(n)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98381675270302992)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Wird als Druckversions-Template referenziert.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98576123414303149)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'de'
,p_message_text=>'Temporary Tablespace'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98437808722303039)
,p_name=>'TEST'
,p_message_language=>'de'
,p_message_text=>'Testen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662658110303216)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'de'
,p_message_text=>'Testbeauftragter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98660809602303214)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'de'
,p_message_text=>'Testauswirkung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663024827303216)
,p_name=>'TESTING_STATUS'
,p_message_language=>'de'
,p_message_text=>'Teststatus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729327961303279)
,p_name=>'TEST_QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage testen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932873083303444)
,p_name=>'TEXT FILES'
,p_message_language=>'de'
,p_message_text=>'Textdateien'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98331097427302950)
,p_name=>'THEME'
,p_message_language=>'de'
,p_message_text=>'Theme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98257606461302892)
,p_name=>'THEME FILES'
,p_message_language=>'de'
,p_message_text=>'Theme-Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932464069303444)
,p_name=>'THEME IMAGES'
,p_message_language=>'de'
,p_message_text=>'Theme-Bilder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393535566303830)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'de'
,p_message_text=>'Kompatibel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184844664303651)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'de'
,p_message_text=>'Theme'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98325418531302946)
,p_name=>'THEMES'
,p_message_language=>'de'
,p_message_text=>'Themes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428056271303859)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen das Abonnement einzelner Templates nicht aufheben, die Bestandteil eines Themes sind, das bei einem anderen Theme auf derselben Theme-Ebene abonniert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428377521303860)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'de'
,p_message_text=>'Diese Anwendung kann nicht in ein Theme mit der registerkartenbasierten Navigation konvertiert werden, weil sie die listenbasierte Navigation verwendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428213826303859)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'de'
,p_message_text=>'Diese Anwendung kann mit der listenbasierten Navigation nicht in ein Theme konvertiert werden, weil sie zwei Registerkartenebenen verwendet. Aktualisieren Sie die Anwendung, und legen Sie die aktuellen Registerkarteneinstellungen so fest, dass nur ei'
||'ne Registerkartenebene verwendet wird, bevor das Theme gewechselt wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98644600965303202)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'de'
,p_message_text=>'Ein Desktop-Theme kann nicht zu einem mobilen Theme gewechselt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98551034009303130)
,p_name=>'THEME_TYPE'
,p_message_language=>'de'
,p_message_text=>'Theme-Typ'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391754475303828)
,p_name=>'TITLE_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98639906765303198)
,p_name=>'TO DO'
,p_message_language=>'de'
,p_message_text=>'To-do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686745875303241)
,p_name=>'TODO'
,p_message_language=>'de'
,p_message_text=>'To-do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98666437585303222)
,p_name=>'TODOS'
,p_message_language=>'de'
,p_message_text=>'To-dos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216037097302858)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'To-do abgeschlossen (%0 / %1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971466162303480)
,p_name=>'TODO_DASH_1'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Eintr\00E4ge, %1 offen, %2 abgeschlossen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971528719303480)
,p_name=>'TODO_DASH_2'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Eintr\00E4ge sind teilweise abgeschlossen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971620058303480)
,p_name=>'TODO_DASH_3'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Eintr\00E4ge sind teilweise abgeschlossen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665296810303221)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'de'
,p_message_text=>'%0 Toptabellen nach Zeilenzahl, nach Schema gemeldet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689836108303245)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'de'
,p_message_text=>'Geschlossen insgesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687355464303242)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'de'
,p_message_text=>'Meilensteine insgesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98689703463303244)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'de'
,p_message_text=>unistr('Ge\00F6ffnet insgesamt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665390460303222)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'de'
,p_message_text=>'Gesamtzeit Rendering (Sekunden)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307243143303757)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'de'
,p_message_text=>unistr('Wird bereinigt (in den n\00E4chsten 7 Tagen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688463638303243)
,p_name=>'TO_DOS'
,p_message_language=>'de'
,p_message_text=>'To-dos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993521258303498)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz abgeschlossener To-dos (%0/%1):'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391821299303001)
,p_name=>'TREE'
,p_message_language=>'de'
,p_message_text=>'Baum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814631749303348)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'de'
,p_message_text=>'Ausgangsbaum basiert auf vorhandenem Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814727482303348)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'Ausgangsbaum basiert auf SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814907615303348)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'de'
,p_message_text=>'Ausgangsbaumwert ist NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98814812202303348)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'de'
,p_message_text=>'Ausgangsbaum basiert auf statischem Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305068097302931)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Der Baum wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98389979059302999)
,p_name=>'TRIGGER'
,p_message_language=>'de'
,p_message_text=>'Trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266707633302900)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chennamen d\00FCrfen nicht mit dem Namen von vorhandenen Registerkarten identisch sein')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772723592303315)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-ID und aktueller Sicherheitsgruppen-ID sind nicht konsistent.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266658724302900)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Sicherheitsgruppen-ID 20 ist f\00FCr den Workspace ORACLE reserviert')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98770663913303313)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'de'
,p_message_text=>'Leeren von Tabelle %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98815527973303349)
,p_name=>'TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98817435348303350)
,p_name=>'TYPE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Typ: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98766054812303310)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierter Elementtyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98772676712303315)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'de'
,p_message_text=>'Spaltendefinition der Datenbank anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98659058156303213)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'de'
,p_message_text=>'Zum Hauptinhalt wechseln'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179882504302830)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'de'
,p_message_text=>'Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179929116302831)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'de'
,p_message_text=>unistr('Mobilger\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180072719302831)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'de'
,p_message_text=>'jQuery Mobile-Tablet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180167622302831)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'de'
,p_message_text=>unistr('jQuery Mobile-Smartphone f\00FCr PhoneGap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98180265167302831)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'de'
,p_message_text=>unistr('jQuery Mobile-Tablet f\00FCr PhoneGap')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98338063629302955)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'de'
,p_message_text=>'Meilensteindatum kann nicht ermittelt werden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709262525303262)
,p_name=>'UNASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Nicht zugeordnet'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732265560303282)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'de'
,p_message_text=>'Nicht authentifizierter Benutzer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913390204303427)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht verf\00FCgbar (Zu URL umleiten)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98913249948303427)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht verf\00FCgbar (Status mit PL/SQL angezeigt)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98647711597303204)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'de'
,p_message_text=>'Wird diskutiert'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262791455302896)
,p_name=>'UNEXPIRED'
,p_message_language=>'de'
,p_message_text=>'Nicht abgelaufen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774219297303316)
,p_name=>'UNLOCK'
,p_message_language=>'de'
,p_message_text=>'Sperre aufheben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862295417303385)
,p_name=>'UNLOCKED'
,p_message_language=>'de'
,p_message_text=>'Entsperrt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226834346302867)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Entsperrte Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98223840053302865)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Sperre aufheben'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483746620303076)
,p_name=>'UNRESTRICTED'
,p_message_language=>'de'
,p_message_text=>unistr('Uneingeschr\00E4nkt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438538218303039)
,p_name=>'UP'
,p_message_language=>'de'
,p_message_text=>'Nach oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391674327303001)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'de'
,p_message_text=>'aktualisierbarer Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98971713267303480)
,p_name=>'UPDATED_BY'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421823866303026)
,p_name=>'UPDATED_ON'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert am'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824307123303355)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'de'
,p_message_text=>unistr('Update f\00FCr Anwendungsversion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824434479303355)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'de'
,p_message_text=>'Update auf Version'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323819716303772)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht unterst\00FCtztes Datumsformat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994601487303499)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Datumsformat wird nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99374960052303814)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'de'
,p_message_text=>'Stellen Sie nach dem Upgrade sicher, dass das Reihenattribut "Labelspalte" einer "Datum/Zeitstempel"-Spalte zugeordnet ist.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391779153303001)
,p_name=>'URL'
,p_message_language=>'de'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98628285147303189)
,p_name=>'URL LINK'
,p_message_language=>'de'
,p_message_text=>'URL-Link'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98651869015303208)
,p_name=>'USERID'
,p_message_language=>'de'
,p_message_text=>'Benutzer-ID'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668157921303224)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'de'
,p_message_text=>'%0 Benutzer, Zuletzt erstellter Benutzer %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773009458303315)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'de'
,p_message_text=>'Keine globale Seite definiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662525950303216)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'de'
,p_message_text=>unistr('Beauftragter Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98662015169303215)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'de'
,p_message_text=>unistr('Auswirkung Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663561431303216)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'de'
,p_message_text=>unistr('Status Benutzeroberfl\00E4che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281427619302911)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seite k\00F6nnen Sie den Zugriff f\00FCr Workspace-Administratoren, Anwendungsentwickler und Endbenutzer von Application Express steuern.</p>'),
'',
unistr('<p><strong>Workspace-Administratoren</strong> k\00F6nnen Anwendungen und Datenbankobjekte erstellen und \00E4ndern sowie Benutzeraccounts, Gruppen und Entwicklungsservices verwalten.</p>'),
'',
unistr('<p><strong>Entwickler</strong> k\00F6nnen Anwendungen und Datenbankobjekte erstellen und \00E4ndern.</p>'),
'',
unistr('<p><strong>Endbenutzer</strong> haben keine Entwicklungsberechtigungen und k\00F6nnen nur auf Anwendungen zugreifen, die kein externes Authentifizierungsschema verwenden.</p>'),
'',
'<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">Weitere Informationen...</a></p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305630624302931)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seite k\00F6nnen Sie den Zugriff f\00FCr Application Express-Endbenutzer kontrollieren.</p>'),
'',
unistr('<p><strong>Endbenutzer</strong> haben keine Entwicklungsberechtigungen und k\00F6nnen nur auf Anwendungen zugreifen, die kein externes Authentifizierungsschema verwenden.</p>'),
'',
unistr('<p><strong>Workspace-Administratoren</strong> und <strong>Entwickler</strong> werden mit der Identit\00E4tskonsole verwaltet. Immer wenn sich ein Workspace-Administrator oder Entwickler bei Application Express anmeldet, wird ein "Schattenaccount" erstell')
||unistr('t. Diese "Schattenbenutzer" k\00F6nnen gegebenenfalls gel\00F6scht werden.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393142673303002)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'de'
,p_message_text=>'Integrierte Anmeldeseite verwenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98392956897303002)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite %0 als Anmeldeseite verwenden.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755937694303302)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verwenden Sie das Attribut <strong>Cacheinhalt l\00F6schen</strong>, um den Sessionzustand f\00FCr eine durch Komma getrennte Liste mit Seiten zu entfernen. Die folgende Syntax zum L\00F6schen des Cache ist au\00DFerdem verf\00FCgbar:'),
'<ul>',
'<li>RIR - Reset Interactive Report</li>',
'<li>CIR - Clear Interactive Report</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98778965361303320)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Vorhandenes Schema verwenden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400637528303836)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400990525303836)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'de'
,p_message_text=>'Codeeditor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400879144303836)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'de'
,p_message_text=>'Maximieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400759717303836)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'de'
,p_message_text=>'Minimieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402073657303837)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Durch \00C4nderung der Theme-Formatvorlage werden die ungespeicherten \00C4nderungen zur\00FCckgesetzt. Dieser Vorgang kann nicht r\00FCckg\00E4ngig gemacht werden. M\00F6chten Sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429339950303860)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'de'
,p_message_text=>unistr('Theme \00E4ndern')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400566287303836)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'de'
,p_message_text=>'Stil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400385264303836)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399757207303835)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429056308303860)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'de'
,p_message_text=>'Kopieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400164972303836)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400257924303836)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'de'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428947122303860)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr(' Sie haben \00C4nderungen in einem schreibgesch\00FCtzten Theme vorgenommen. Wenn Sie diese \00C4nderungen im aktuellen Theme vornehmen, werden diese gel\00F6scht. M\00F6chten Sie wirklich fortfahren? ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400470570303836)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'de'
,p_message_text=>'Stilname'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399801226303835)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429164609303860)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99400089857303835)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425696241303857)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCgen Sie die folgende Codezeile in die JS-Konsole ein, um die aktuelle Konfiguration in Theme Roller zu laden:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425762914303857)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Theme Roller muss ge\00F6ffnet sein und die aktuelle Formatvorlage muss g\00FCltig sein, damit die Konfiguration ausgegeben werden kann.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313791450303763)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrastverh\00E4ltnis:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407103065303842)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'de'
,p_message_text=>'Nicht erfolgreich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409564658303844)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Text \00FCber 18pt oder Fettschrift \00FCber 14pt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407265664303842)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Validierungen werden entsprechend den Richtlinien f\00FCr barrierefreie Inhalte (WCAG 2.0) f\00FCr Farbkontraste bei Schriftarten mit normalen Schriftgrad durchgef\00FChrt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99407022131303841)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'de'
,p_message_text=>'Erfolgreich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99406930182303841)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'de'
,p_message_text=>'Farbkontrastinformationen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428848553303860)
,p_name=>'UTR.CURRENT'
,p_message_language=>'de'
,p_message_text=>'Aktuell'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401850682303837)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniertes CSS'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401986454303837)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Dieser Code wird am Ende des Stylesheets aufgenommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410738840303845)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'de'
,p_message_text=>'Dieser CSS-Code blendet das Dialogfeld "Theme Roller" aus. Er wird nicht auf die Seite angewendet.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991533938303497)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991828575303497)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'de'
,p_message_text=>unistr('Dateien per Drag-and-Drop verschieben oder durch Klicken ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992081967303497)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'de'
,p_message_text=>'LESS-Kompilierung aktivieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399974866303835)
,p_name=>'UTR.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402452797303838)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'de'
,p_message_text=>'Theme-Formatvorlage konnte nicht erstellt werden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410468362303844)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Laden von mindestens einer CSS-Datei-URL.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402279658303837)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'de'
,p_message_text=>unistr('Der LESS-Code f\00FCr diese Theme-Formatvorlage ist ung\00FCltig')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402659032303838)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Theme-Formatvorlage konnte nicht geladen werden. Stellen Sie sicher, dass das App Builder-Fenster noch ge\00F6ffnet ist und Ihre Session g\00FCltig ist.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429269350303860)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Das ausgew\00E4hlte Theme konnte nicht als aktuelles Theme der Anwendung verwendet werden.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402191368303837)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'de'
,p_message_text=>unistr('These Theme-Fortvorlage unterst\00FCtzt die Theme Roller-Anpassung nicht.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402398097303837)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Theme verf\00FCgt \00FCber keine Theme-Formatvorlagen. W\00E4hlen Sie ein Theme mit Theme-Formatvorlagen, um Theme Roller verwenden zu k\00F6nnen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99402540225303838)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'de'
,p_message_text=>'Theme-Formatvorlage konnte nicht aktualisiert werden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302789197303753)
,p_name=>'UTR.FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409640717303844)
,p_name=>'UTR.HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409782692303844)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'de'
,p_message_text=>unistr('Mit Theme Roller kann die Benutzeroberfl\00E4che Ihrer Anwendung einfach angepasst werden, indem Sie Farben ausw\00E4hlen und Formatvorlagen f\00FCr verschiedene Anwendungskomponenten festlegen k\00F6nnen. F\00FCr eine Anwendung kann eine beliebige Anzahl von Theme-Form')
||unistr('atvorlagen definiert werden. Die Anwendung wird jedoch nur mit der "aktuellen" Theme-Formatvorlage f\00FCr Endbenutzer angezeigt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99409802487303844)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nachdem \00C4nderungen vorgenommen wurden, k\00F6nnen Attribute einfach wiederhergestellt werden, entweder f\00FCr die vollst\00E4ndige Theme-Formatvorlage durch Klicken auf die Schaltfl\00E4che "Zur\00FCcksetzen" oder durch Klicken auf das Symbol "Zur\00FCcksetzen" f\00FCr die Gru')
||'ppe. ',
'',
unistr('Bei Attributen, mit denen Vorder- und Hintergrundfarben ausgew\00E4hlt werden k\00F6nnen, enth\00E4lt das Kontrollk\00E4stchen vor den beiden Farbauswahloptionen Farbkontrastinformationen basierend auf den Web Content Accessibility Guidelines (WCAG) 2.0. Ein h\00F6herer')
||' berechneter Kontrastwert bedeutet, dass die Farbkombination barrierefreier ist.'))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99186683060303653)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'de'
,p_message_text=>'Inlineeditor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711394005303264)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'de'
,p_message_text=>'Akzent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421424915303854)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte "Aktionen"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424971332303857)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'de'
,p_message_text=>'Aktiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425550031303857)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'de'
,p_message_text=>'Aktiver Status'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423474444303856)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'de'
,p_message_text=>'Hintergrund'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98711425873303264)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'de'
,p_message_text=>'Badge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421321575303854)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'de'
,p_message_text=>'Body'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421228516303854)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'de'
,p_message_text=>'Body-Akzent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425896463303858)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'de'
,p_message_text=>'Maximale Breite von Haupttextinhalt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422020650303854)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'de'
,p_message_text=>'Randradius'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420185653303853)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423661391303856)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'de'
,p_message_text=>'Farbe 1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424491757303856)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'de'
,p_message_text=>'Farbe 10'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99392901125303829)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'de'
,p_message_text=>'Farbe 11'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393083614303829)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'de'
,p_message_text=>'Farbe 12'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393149057303829)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'de'
,p_message_text=>'Farbe 13'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393283335303830)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'de'
,p_message_text=>'Farbe 14'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99393385463303830)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'de'
,p_message_text=>'Farbe 15'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423737199303856)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'de'
,p_message_text=>'Farbe 2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424530716303856)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'de'
,p_message_text=>'Farbe 3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423809986303856)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'de'
,p_message_text=>'Farbe 4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423988938303856)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'de'
,p_message_text=>'Farbe 5'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424020522303856)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'de'
,p_message_text=>'Farbe 6'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424140894303856)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'de'
,p_message_text=>'Farbe 7'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424225282303856)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'de'
,p_message_text=>'Farbe 8'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424320127303856)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'de'
,p_message_text=>'Farbe 9'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420261107303853)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'de'
,p_message_text=>'Container'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424629221303857)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'de'
,p_message_text=>'Containerrandradius'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422418184303855)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'de'
,p_message_text=>'Gefahr'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422813133303855)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421776781303854)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'de'
,p_message_text=>'Fokusgliederung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423238257303855)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'de'
,p_message_text=>'Vordergrund'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430077943303861)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'de'
,p_message_text=>'Formulare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419947326303853)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'de'
,p_message_text=>'Globale Farben'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423593696303856)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'de'
,p_message_text=>'Header'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421146048303854)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'de'
,p_message_text=>'Headerakzent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713841871303266)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'de'
,p_message_text=>unistr('Headerh\00F6he')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422214045303855)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'de'
,p_message_text=>'Online'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425235107303857)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'de'
,p_message_text=>'Mouseover'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425309396303857)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'de'
,p_message_text=>'Mouseover-Status'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424830223303857)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'de'
,p_message_text=>'Symbol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422921677303855)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'de'
,p_message_text=>'Informationen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421026063303854)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'de'
,p_message_text=>'Interaktive Berichte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430109229303861)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'de'
,p_message_text=>'Element'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99430218816303861)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420381416303853)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'de'
,p_message_text=>'Layout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421939386303854)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Linke Spalte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421619218303854)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'de'
,p_message_text=>'Farbe des Links '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423144830303855)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99416193813303849)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FCs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98757983595303304)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'de'
,p_message_text=>unistr('Mouseover-Status des Men\00FCelements')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420446253303853)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>'Navigation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99424743176303857)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'de'
,p_message_text=>'Navigationsbaumstruktur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422176067303855)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'de'
,p_message_text=>'Normal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425012851303857)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'de'
,p_message_text=>'Nicht aktiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420760860303853)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'de'
,p_message_text=>'Palette'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422325305303855)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'de'
,p_message_text=>'Primary'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587231478303158)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rer Akzent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420007575303853)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'de'
,p_message_text=>'Regionen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421894091303854)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'de'
,p_message_text=>'Header'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405021496303840)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'de'
,p_message_text=>'Berichte und Grids'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322251488303771)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'de'
,p_message_text=>'Bodyhintergrund'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322104138303771)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'de'
,p_message_text=>'Body-Header'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322957662303771)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'de'
,p_message_text=>'Anzeigemodus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323187738303771)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'de'
,p_message_text=>'Kompakt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323079849303771)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'de'
,p_message_text=>'Standard (Standard)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306651446303757)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'de'
,p_message_text=>'Layout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310293106303760)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'de'
,p_message_text=>'Enthalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310047350303760)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'de'
,p_message_text=>'Kante zu Kante (Standard)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99310120674303760)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'de'
,p_message_text=>'Unverankert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306541715303757)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'de'
,p_message_text=>'Modus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309800805303760)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'de'
,p_message_text=>'Dunkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309969291303760)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'de'
,p_message_text=>'Dunkler Body'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323352833303771)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Dunkel (Standard)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99309784829303760)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'de'
,p_message_text=>'Hell'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323478400303772)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Hell (Standard)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99306473760303757)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'de'
,p_message_text=>'Pillar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321949944303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'de'
,p_message_text=>'Beige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321557563303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'de'
,p_message_text=>'Lila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320913992303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'de'
,p_message_text=>'Neutral (Standard)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321409038303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'de'
,p_message_text=>'Ozeanblau'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321024648303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'de'
,p_message_text=>'Kieselgrau'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321201995303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'de'
,p_message_text=>unistr('Tannengr\00FCn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321877164303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'de'
,p_message_text=>'Pflaume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321684629303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'de'
,p_message_text=>'Rosa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321711065303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'de'
,p_message_text=>'Sienna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321121812303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'de'
,p_message_text=>'Schiefergrau'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99321374328303770)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'de'
,p_message_text=>unistr('Blaugr\00FCn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322014036303770)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'de'
,p_message_text=>'Darstellung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320808185303769)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'de'
,p_message_text=>'Redwood-Optionen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98502637196303091)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'de'
,p_message_text=>'Nachkommastellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98587368116303158)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'de'
,p_message_text=>unistr('Sekund\00E4rer Akzent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425106010303857)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99425454236303857)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'de'
,p_message_text=>unistr('Gew\00E4hlter Status')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422718796303855)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'de'
,p_message_text=>'Einfach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420551421303853)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'de'
,p_message_text=>'Staaten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422671910303855)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99423333828303855)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'de'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99421597292303854)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'de'
,p_message_text=>'Titelleiste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99422528530303855)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99302834955303753)
,p_name=>'UTR.LOADING'
,p_message_language=>'de'
,p_message_text=>'Wird geladen...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98305236398302931)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'de'
,p_message_text=>'Alternativer Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954909696303466)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954807607303466)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen das Logo-Markup in Application Builder bearbeiten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992596192303497)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Logodaten konnten nicht geladen werden. Stellen Sie sicher, dass das App Builder-Fenster noch ge\00F6ffnet und Ihre Session g\00FCltig ist.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954796880303466)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994745094303499)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'de'
,p_message_text=>'Kein Bild geladen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954669209303466)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'de'
,p_message_text=>'Bild und Text'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992126938303497)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Datei aus, die kleiner ist als %0 KB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954564517303466)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'de'
,p_message_text=>'Kein Wert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992224419303497)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'de'
,p_message_text=>unistr('Nur Bilddateien sind zul\00E4ssig')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991434017303497)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'de'
,p_message_text=>'Logo speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992300543303497)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'de'
,p_message_text=>'Das Logo konnte nicht gespeichert werden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98992451305303497)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Das Logo wurde erfolgreich gespeichert.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954405037303466)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'de'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954221401303466)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954144883303466)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Dateien per Drag-and-Drop verschieben oder durch Klicken ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99184927352303651)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'de'
,p_message_text=>'Logo bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991996312303497)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Nur JSON-Dateien sind zul\00E4ssig')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417738458303851)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'de'
,p_message_text=>'Angrenzend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417519725303851)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'de'
,p_message_text=>'Basis-RGB'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429828218303861)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'de'
,p_message_text=>'Dual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417671600303851)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'de'
,p_message_text=>'Monochrom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418118732303851)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'de'
,p_message_text=>'Trennung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417947541303851)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'de'
,p_message_text=>'Tetrad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417861656303851)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'de'
,p_message_text=>'Triade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99418057808303851)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'de'
,p_message_text=>'Mit Komplement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713264941303265)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Logo\00E4nderungen nicht gespeichert.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98713310382303265)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Theme-\00C4nderungen nicht gespeichert.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420979720303854)
,p_name=>'UTR.REDO'
,p_message_language=>'de'
,p_message_text=>'Wiederholen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401691581303837)
,p_name=>'UTR.RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401782071303837)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie das CSS wirklich zur\00FCcksetzen? Alle \00C4nderungen gehen verloren. Dieser Vorgang kann nicht r\00FCckg\00E4ngig gemacht werden.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429475958303860)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'de'
,p_message_text=>unistr('Formatvorlage zur\00FCcksetzen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401303237303837)
,p_name=>'UTR.SAVE'
,p_message_language=>'de'
,p_message_text=>'Speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401444291303837)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren Sie den Namen, um die aktuelle Theme-Formatvorlage umzubenennen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401579890303837)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Theme-Formatvorlage wurde erfolgreich aktualisiert.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401036165303836)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'de'
,p_message_text=>'Speichern unter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401135176303836)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie einen Namen f\00FCr die neue Theme-Formatvorlage ein.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99401265654303837)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Theme-Formatvorlage wurde erfolgreich erstellt.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99417442749303851)
,p_name=>'UTR.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99185068128303652)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'de'
,p_message_text=>unistr('Theme ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99428772728303860)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'de'
,p_message_text=>'Als Aktuell festlegen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429518459303861)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'de'
,p_message_text=>'Als aktuelle Formatvorlage des Theme festlegen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429651991303861)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Das ausgew\00E4hlte Theme ist jetzt das aktuelle Theme der Anwendung.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429793864303861)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben \00C4nderungen in einem schreibgesch\00FCtzten Theme vorgenommen. Wenn Sie dieses Theme als "aktuelles" Theme der Anwendung festlegen, werden Ihre \00C4nderungen gel\00F6scht. M\00F6chten Sie wirklich fortfahren?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954031778303466)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'de'
,p_message_text=>'Logo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98953945917303465)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'de'
,p_message_text=>'Designformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399602600303835)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'de'
,p_message_text=>'Theme Roller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410330187303844)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'de'
,p_message_text=>'Alles anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99410275725303844)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'de'
,p_message_text=>'Allgemeine anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426503772303858)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'de'
,p_message_text=>'Farbrad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420874417303853)
,p_name=>'UTR.UNDO'
,p_message_language=>'de'
,p_message_text=>unistr('R\00FCckg\00E4ngig')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991612500303497)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'de'
,p_message_text=>'Hochladen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98991743115303497)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'de'
,p_message_text=>'Konfigurationsdatei hochladen'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401559012303010)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1812 Unerwarteter Fehler beim Konvertieren von Anwendungsaliasname (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99390591163303827)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'de'
,p_message_text=>'Validierung: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182769929302833)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'de'
,p_message_text=>'Alle Seitengruppen anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182867506302833)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'de'
,p_message_text=>'Alle Seitentypen anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98330325481302950)
,p_name=>'VIEWS2'
,p_message_language=>'de'
,p_message_text=>'Ansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930734298303442)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'de'
,p_message_text=>'Debugging anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98205758509302850)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'de'
,p_message_text=>'Details anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774935206303317)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200757089302846)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeige f\00FCr den Druck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959262939303470)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'de'
,p_message_text=>'Historie anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99349614479303793)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98388957516302999)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'de'
,p_message_text=>'(View)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380386521303818)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'de'
,p_message_text=>'Sperrhistorie anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311165422303761)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'de'
,p_message_text=>unistr('Diese SQL-Abfrage wird verwendet, um die nach einem Klick auf die Schaltfl\00E4che <strong>XML anzeigen</strong> angezeigte XML-Datei zu generieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183386794302833)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'de'
,p_message_text=>'Seiten dieses Typs anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98954359794303466)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'de'
,p_message_text=>unistr('"%0"-Seiten\00E4nderungshistorie anzeigen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295506879302923)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4t anzeigen f\00FCr: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703190762303256)
,p_name=>'VPD'
,p_message_language=>'de'
,p_message_text=>'VPD (Virtual Private Database)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715172136303267)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'de'
,p_message_text=>'Anwendung wird installiert...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396393225303832)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'de'
,p_message_text=>'Anwendung entfernen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396569406303832)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'de'
,p_message_text=>'Anwendung entsperren...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99396436662303832)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'de'
,p_message_text=>'Anwendung aktualisieren...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715223381303267)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'de'
,p_message_text=>'Anforderung wird verarbeitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715397245303267)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'de'
,p_message_text=>unistr('Unterst\00FCtzende Objekte werden installiert')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824771061303356)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'de'
,p_message_text=>unistr('Keine \00FCbereinstimmende Klasse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98824686947303356)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrere \00DCbereinstimmungen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170092002302823)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'de'
,p_message_text=>unistr('Service hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171052823302824)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'de'
,p_message_text=>unistr('Aus Katalog hinzuzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170806324302823)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'de'
,p_message_text=>'Service entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98636729879303196)
,p_name=>'WEBSHEET'
,p_message_language=>'de'
,p_message_text=>'Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667306655303223)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Anh\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376735976303816)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'de'
,p_message_text=>'AnyCo IT Department'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376667010303815)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'de'
,p_message_text=>unistr('"AnyCo IT Department" zeigt, wie die Features und Funktionen von Websheets f\00FCr die gemeinsame Verwendung von webbasiertem Content und das Erstellen von gesch\00E4ftskritischen Daten verwendet werden k\00F6nnen. Diese Beispiel-Websheet-Anwendung enth\00E4lt mehre')
||'re Daten-Grids und stellt dar, wie Daten in eingebetteten Berichten und Diagrammen einbezogen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322498388303771)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'de'
,p_message_text=>'Big Cats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322772077303771)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'de'
,p_message_text=>unistr('"Big Cats" markiert viele Features und Funktionen von Websheets, einschlie\00DFlich dem Einbetten von Images und Seitenlinks.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236858576302875)
,p_name=>'WEBSHEETS'
,p_message_language=>'de'
,p_message_text=>'Websheets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013274005303514)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Anwendungen sind Webseiten, die Text mit Daten verbinden. Solche Anwendungen sind in hohem Ma\00DFe dynamisch und benutzerdefiniert. Die Anwendungen verf\00FCgen \00FCber Navigationssteuerelemente, Suchm\00F6glichkeiten sowie Funktionen zum Hinzuf\00FCgen von A')
||unistr('nnotationen (Dateien, Anmerkungen, Tags usw.). Die Anwendungen k\00F6nnen mithilfe von Access Control-Listen und verschiedenen, integrierten Authentifizierungsmodellen gesichert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013321813303515)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Anwendungen erm\00F6glichen es Autorengruppen, unter ausschlie\00DFlicher Verwendung eines Webbrowsers schnell informative Seiten zusammenzustellen. Solche Seiten k\00F6nnen Diagramme und Berichte beinhalten. Benutzer k\00F6nnen auf einfache Weise Texte und')
||' lokale Daten (sogenannte Daten-Grids) verwalten und gleichzeitig Daten aus SQL-Abfragen anzeigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013485988303515)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Anwendung \00E4hneln in ihrer Funktionsweise WIKIs, sind aber f\00FCr die Integration und die Anzeige von Daten optimiert. Beispiel: Sie k\00F6nnen Daten-Grids erstellen, in denen tabellarische Informationen gespeichert werden, Berichte f\00FCr bestehende T')
||'abellen definieren, oder einfach SQL-Tags verwenden, um die Datenbankdaten auf einer Seite anzuzeigen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013541106303515)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'de'
,p_message_text=>unistr('Daten-Grids sind Websheet-Komponenten, die Arbeitsbl\00E4ttern \00E4hneln und es Ihnen erm\00F6glichen, auf einfache Weise tabellarische Informationen zu pflegen. Einer der wichtigsten Unterschiede ist, dass Websheet-Daten nicht in lokalen Dateien sondern in der')
||unistr(' zentralen Oracle-Datenbank gespeichert werden. Mithilfe von Daten-Grids k\00F6nnen Sie jeder Datenzeile Annotationen hinzuf\00FCgen (Dateien, Anmerkungen, Tags, Links usw.). Zus\00E4tzlich k\00F6nnen die Daten mit der Anwendungssuche durchsucht werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013920319303515)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL-Tags erm\00F6glichen es Benutzern, Berichte auf einfache Weise mithilfe von f\00FCr Datenbanktabellen definierten SQL-Ausdr\00FCcken in Seiten zu integrieren. Mit SQL k\00F6nnen Benutzer Daten direkt aus ihren bevorzugten Tabellen abrufen. Beispiel: Mit dem folg')
||unistr('enden Tag k\00F6nnen alle ausstehenden Bugs angezeigt werden: '),
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('Diese Abfrage wird bei jedem \00D6ffnen der Seite ausgef\00FChrt, wodurch dynamische Daten und nicht nur ein typischer Snapshot angezeigt werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013648918303515)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Websheet-Anwendungen erleichtern den Austausch von Content und stellen informelle, grundlegende Berichte zur Verf\00FCgung. Die Struktur und der Content von Websheet-Anwendungen wird vollst\00E4ndig von den Benutzern (d.h. den Beitragenden und den Administra')
||unistr('toren) bestimmt. Datenbankanwendungen dagegen stellen Datenverwaltungs- und Berichtsfunktionen auf einer formelleren, h\00F6her entwickelten und spezialisierteren Ebene zur Verf\00FCgung. Die Struktur von Datenbankanwendungen wird durch die Entwickler bestim')
||'mt; ihr Inhalt dagegen wird typischerweise vom Endbenutzer bestimmt.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012744198303514)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'de'
,p_message_text=>'Was ist ein Websheet?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012984099303514)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'de'
,p_message_text=>'Welche Vorteile hat die Erstellung einer Websheet-Anwendung?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013032149303514)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'de'
,p_message_text=>'Inwiefern unterscheidet sich eine Websheet-Anwendung von einem WIKI?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99013150968303514)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'de'
,p_message_text=>unistr('Sind Websheet-Anwendungen Onlinearbeitsbl\00E4tter?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014088946303515)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'de'
,p_message_text=>'Was ist ein SQL-Tag?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012826170303514)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'de'
,p_message_text=>'Inwiefern unterscheidet sich eine Websheet-Anwendung von einer Datenbankanwendung?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98295606632302923)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'de'
,p_message_text=>'Komponente nicht installiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398443335303834)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'de'
,p_message_text=>'Websheet-Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99377482693303816)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Websheet-Anwendung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221452797302863)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Websheet-Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98964853825303474)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung %0 ist derzeit nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668433427303224)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Anh\00E4nge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959345671303470)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Inhalt zuletzt aktualisiert: %0 von %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959440970303470)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'de'
,p_message_text=>'Seite erstellt: %0 von %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322870041303771)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Sie sind im Begriff, die Websheet-Beispielanwendung zu installieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99391374221303828)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'de'
,p_message_text=>'Websheet: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98951769384303464)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Seite zuletzt aktualisiert: %0 von %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98667290739303223)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'de'
,p_message_text=>'Websheet keine BLOB-Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362427867303804)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'de'
,p_message_text=>unistr('Websheet-Objekte sind nicht g\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712082440303264)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Websheet-Anwendung %0 wurde installiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976302701303484)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Die folgenden Objekte k\00F6nnen mit dem SQL-Markup Tag abgefragt werden oder sind aus Berichten verf\00FCgbar. Mit doppelten Anf\00FChrungszeichen werden Objektnamen angegeben, bei denen die Gro\00DF-/Kleinschreibung beachtet werden muss.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98665733195303222)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'de'
,p_message_text=>'Seitenansichten Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696672024303251)
,p_name=>'WEB_SERVICE'
,p_message_language=>'de'
,p_message_text=>'Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391169375303000)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'de'
,p_message_text=>'Web Service-Ergebnis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156505531302811)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'de'
,p_message_text=>'Oracle Cloud Applications (SaaS) REST Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156327930302811)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'de'
,p_message_text=>'Einfaches HTTP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156605463302811)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'de'
,p_message_text=>'Oracle Cloud Infrastructure (OCI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156481689302811)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'de'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216603388302859)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen Sie den Registrierungsassistenten ab, um einen Oracle APEX-Workspace anzufordern.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708165540303261)
,p_name=>'WHITE_TEXT'
,p_message_language=>'de'
,p_message_text=>unistr('Wei\00DFer Text')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249200724302885)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'de'
,p_message_text=>unistr('Innerhalb des n\00E4chsten Tages')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99316173799303765)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'de'
,p_message_text=>unistr('In den n\00E4chsten %0 Tagen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668237700303224)
,p_name=>'WITH_ADMIN'
,p_message_language=>'de'
,p_message_text=>'mit Admin-Option'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98391580822303001)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'de'
,p_message_text=>'Mit Shortcuts'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773942812303316)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'de'
,p_message_text=>'Seitennummer ist bereits in dieser Anwendung vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98773309970303316)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'de'
,p_message_text=>'Seitennummer ist reserviert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424662860303028)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'de'
,p_message_text=>unistr('Markierte Elemente l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301692887302928)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'de'
,p_message_text=>'Auskommentiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98159110894302814)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Seite zur\00FCcksetzen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196982816303661)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Kartenspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172557264302825)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'de'
,p_message_text=>'Karten erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000007586303504)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'de'
,p_message_text=>'Klassischen Bericht erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965296523303475)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'de'
,p_message_text=>'Facet-Suche erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000583628303504)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'de'
,p_message_text=>'Formular und Listenansicht erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000906184303505)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf Prozedur erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000874112303505)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf SQL-Abfrage erstellen '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000735130303504)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'de'
,p_message_text=>'Formular erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375099219303814)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf Webservice erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179492481302830)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'de'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999938650303504)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'de'
,p_message_text=>'Interaktives Grid erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98999819805303504)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'de'
,p_message_text=>'Interaktiven Bericht erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170762456302823)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'de'
,p_message_text=>'Kartenseite erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000173037303504)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'de'
,p_message_text=>'Master-Detail erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000379880303504)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000477044303504)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'de'
,p_message_text=>'Bericht mit Formular erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178349560302829)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'de'
,p_message_text=>'Intelligente Filter erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98179593239302830)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000665882303504)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'de'
,p_message_text=>'Tabellarisches Formular erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99000294735303504)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'de'
,p_message_text=>'Bericht zu Webservice erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344621523302960)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diesen Assistenten ist eine Universal-Theme-basierte Anwendung erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158630862302813)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'de'
,p_message_text=>'Formular %0 verarbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98158593640302813)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'de'
,p_message_text=>'Formular %0 initialisieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755473193303302)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755338576303301)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769186998303312)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'de'
,p_message_text=>'%0 - Interaktive Grid-Daten speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761908859303307)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'de'
,p_message_text=>'Klassischer Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761872901303307)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'de'
,p_message_text=>'Interaktives Grid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761743557303307)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'de'
,p_message_text=>'Interaktiver Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762123075303307)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98762065480303307)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'de'
,p_message_text=>'Bericht zu Webservice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98365167786302976)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss einen Wert haben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685802009303240)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Bei der Validierung ist ein Fehler aufgetreten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685744360303240)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'#COLUMN_HEADER# muss einen Wert aufweisen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98719255888303270)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Assistentenseiten wurden erfolgreich erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426095954303858)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'Assistentenfortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704521105303258)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>'Die Seite "Assistentenbericht" wurde erfolgreich erstellt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393217249303002)
,p_name=>'WORKSPACE'
,p_message_language=>'de'
,p_message_text=>'Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98693130144303248)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'de'
,p_message_text=>'Workspace-Bild'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755679414303302)
,p_name=>'WORKSPACES'
,p_message_language=>'de'
,p_message_text=>'Workspaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664552532303221)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'de'
,p_message_text=>'Workspace-Anwendungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664816844303221)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivit\00E4tszusammenfassung Workspace-Aktivit\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307348597303757)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Anzahl der Workspaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663806791303217)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'de'
,p_message_text=>'Workspace-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98975976644303484)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'de'
,p_message_text=>'Workspace-Bilder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98756195302303302)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'de'
,p_message_text=>'Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98574511157303148)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'de'
,p_message_text=>'Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233575932302872)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Workspace: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98202694831302848)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'de'
,p_message_text=>'Anmeldung am Workspace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98901230336303417)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Workspace-Meldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98663625498303216)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'de'
,p_message_text=>'Workspace-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98812575481303346)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'de'
,p_message_text=>'Workspace Override-ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98696092429303250)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'de'
,p_message_text=>'Workspace-Anforderung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664448074303217)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'de'
,p_message_text=>'Workspace-Schemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98252633865302888)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'de'
,p_message_text=>'Sobald diese Anforderung genehmigt wurde, erhalten Sie eine E-Mail, um den Workspace zu aktivieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755815237303302)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'de'
,p_message_text=>'Workspace-Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668321451303224)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'de'
,p_message_text=>'Workspace Websheets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98664126108303217)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'de'
,p_message_text=>'%0 Workspace-Zusammenfassung'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640158000303199)
,p_name=>'WORK_INITIATED'
,p_message_language=>'de'
,p_message_text=>'Arbeit gestartet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98640267402303199)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'de'
,p_message_text=>'Arbeitsfortschritt'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648265251303205)
,p_name=>'WRITING'
,p_message_language=>'de'
,p_message_text=>'Schreiben'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311501191303761)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'de'
,p_message_text=>unistr('Leistungsf\00E4higkeit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99311495042303761)
,p_name=>'WS.READER'
,p_message_language=>'de'
,p_message_text=>'Leser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98703935313303257)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'de'
,p_message_text=>unistr('Die Webservicereferenz wurde der Anwendung %0 hinzugef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193097431302841)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'de'
,p_message_text=>'Zugriffskontrolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937047888303448)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375220039303814)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist nicht gen\00FCgend Speicherplatz zum Hinzuf\00FCgen der Datei verf\00FCgbar. Fordern Sie zus\00E4tzlichen Speicher an, indem Sie zu der Administrationsseite und zu "Service verwalten" navigieren und auf "Speicherplatz anfordern" klicken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960486037303471)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'de'
,p_message_text=>unistr('Link hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995321648303500)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'de'
,p_message_text=>unistr('Neue hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960539855303471)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'de'
,p_message_text=>unistr('Hinweis hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959916465303470)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960354245303471)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'de'
,p_message_text=>unistr('Tags hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004538130303507)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192808499302840)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'de'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936612356303447)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Der Alias muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98185365478302835)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'de'
,p_message_text=>'Alias muss alphanumerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196588199302843)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Alias ist zu lang. Er darf h\00F6chstens 255 Zeichen enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001550723303505)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'de'
,p_message_text=>'Alle Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995472385303500)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'de'
,p_message_text=>'Anmerkungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192944515302841)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'de'
,p_message_text=>'Anwendungseigenschaften'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010049407303512)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Der ausgew\00E4hlte Anzeigentyp kann die Werteliste nicht verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012474537303514)
,p_name=>'WS_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Ge\00E4ndert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996882335303501)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Spaltentyp \00E4ndern')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012677681303514)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die \00C4nderung der Berichtsabfrage angefordert. Wenn Sie Spalten zu der Abfrage hinzugef\00FCgt haben, werden diese bei der Ausf\00FChrung des Berichts nicht angezeigt. Sie m\00FCssen das Men\00FC "Aktionen" verwenden und die Spalten w\00E4hlen oder auf <strong>')
||unistr('Zur\00FCcksetzen</strong> klicken. Wenn Sie Spalten aus der Abfrage entfernt haben, werden vorhandene Filter, Markierungsregeln und andere Berichteinstellungen deaktiviert, die diese Spalten referenzieren. Best\00E4tigen Sie diese Anforderung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190449063302839)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997380753303502)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'de'
,p_message_text=>'Spaltenausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960236427303471)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'de'
,p_message_text=>'Spaltengruppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371835112303811)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Der Spaltenname ist bereits vorhanden. Geben Sie einen anderen Namen ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960146287303471)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'de'
,p_message_text=>'Spalteneigenschaften'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998363668303502)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen Sie diesen L\00F6schvorgang')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009870086303512)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Das Spaltenlabel muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011174775303513)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'de'
,p_message_text=>unistr('Die Zeile, deren Wert ge\00E4ndert werden soll, muss ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011385709303513)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'de'
,p_message_text=>unistr('Die Zeile, deren Wert ersetzt werden soll, muss ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010485188303512)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Die Spaltenname muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009762493303512)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'de'
,p_message_text=>unistr('Es muss eine zu bearbeitende Zeile ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010579190303512)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'de'
,p_message_text=>unistr('Die zu entfernenden Zeilen m\00FCssen ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996333522303501)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'de'
,p_message_text=>'Durch Komma getrennte Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998021589303502)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'de'
,p_message_text=>'Geben Sie eine durch Komma getrennte Liste ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009476957303511)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen Sie den L\00F6schvorgang.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99385241077303823)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'de'
,p_message_text=>'Systemsteuerung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308358409303758)
,p_name=>'WS_COPY'
,p_message_language=>'de'
,p_message_text=>'Kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922961055303435)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'de'
,p_message_text=>'Neue Seite als Kopie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946002403303455)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben das Erstellen eines Websheets mit folgenden Attributen angefordert. Best\00E4tigen Sie die Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922345611303435)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'de'
,p_message_text=>'Diagrammabschnitt erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98701343571303255)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922436002303435)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'de'
,p_message_text=>'Datenabschnitt erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996525839303501)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'de'
,p_message_text=>'Aktuelles Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922604447303435)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'de'
,p_message_text=>'Navigationsabschnitt erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922804510303435)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98226572122302867)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'de'
,p_message_text=>'PL/SQL-Abschnitt erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922221173303435)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'de'
,p_message_text=>'Bereich erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922503020303435)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'de'
,p_message_text=>'Textabschnitt erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996653177303501)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'de'
,p_message_text=>'Aktueller Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192619155302840)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'de'
,p_message_text=>'Dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169984817302823)
,p_name=>'WS_DATA'
,p_message_language=>'de'
,p_message_text=>'Daten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98682481481303237)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'de'
,p_message_text=>unistr('Die H\00F6chstanzahl der f\00FCr den Spaltentyp verf\00FCgbaren Spalten wurde erreicht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99372049993303812)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'de'
,p_message_text=>'Doppelte Spaltennamen ermittelt. Spaltenname muss eindeutig sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99337476630303783)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Der Daten-Grid-Name ist bereits vorhanden. Geben Sie einen anderen Namen ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996752938303501)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'de'
,p_message_text=>'Standardtext'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996486942303501)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Standardtyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398995796303834)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid-Spalten definieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998173517303502)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98932079119303443)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'de'
,p_message_text=>unistr('Daten-Grid l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002540953303506)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilen l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998234132303502)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie die Spalte(n) aus, die zusammen mit den Daten dauerhaft gel\00F6scht werden soll(en):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215588342302858)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'de'
,p_message_text=>unistr('Die erste Spalte muss der Prim\00E4rschl\00FCssel von Data Grid sein, um den Link "Zeile bearbeiten" oder "Zeile hinzuf\00FCgen" anzuzeigen. F\00FCgen Sie die Ersetzungszeichenfolge "APXWS_DATA_GRID_PK" als erste Spalte in der Select-Anweisung hinzu, um den Prim\00E4rsc')
||unistr('hl\00FCssel einzubeziehen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98208847957302853)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfrage darf Data Grid nur einmal referenzieren, um den Link "Zeile bearbeiten" oder "Zeile hinzuf\00FCgen" anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215677899302858)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfrage enth\00E4lt mehr als eine Select-Anweisung. F\00FCgen Sie die Ersetzungszeichenfolge "APXWS_DATA_GRID_PK" als erste Spalte in der Select-Anweisung hinzu, um den Link "Zeile bearbeiten" oder "Zeile hinzuf\00FCgen" anzuzeigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99014104066303515)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'de'
,p_message_text=>'Syntax von SQLVALUE-Tag:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98761233084303306)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'de'
,p_message_text=>'Syntax des SQL-Tags:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995976844303500)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'de'
,p_message_text=>'Anzeigen als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995875634303500)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'de'
,p_message_text=>'Dokument'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936583154303447)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen nicht dieselbe Spalte als Prim\00E4rschl\00FCssel ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995196174303500)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'de'
,p_message_text=>'Anhang bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308401104303758)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Attribute bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191746469302840)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'de'
,p_message_text=>'Datei bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191344566302839)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'de'
,p_message_text=>'Hinweis bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98922732505303435)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308569579303759)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929967761303442)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'de'
,p_message_text=>'Abschnitt bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98993360933303498)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'de'
,p_message_text=>'Abschnitte bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191851813302840)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'de'
,p_message_text=>'Tag bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255684166302890)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'de'
,p_message_text=>'Tags bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231823924302871)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite per E-Mail senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998776515303503)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'de'
,p_message_text=>'Leere Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930585148303442)
,p_name=>'WS_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99008188837303510)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011805350303513)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Die Fehlermeldung muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962339462303472)
,p_name=>'WS_FILE'
,p_message_language=>'de'
,p_message_text=>'Datei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938111283303448)
,p_name=>'WS_FILES'
,p_message_language=>'de'
,p_message_text=>'Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99420669205303853)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Datei muss einen Wert haben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002175739303506)
,p_name=>'WS_FILL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCllen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002218796303506)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'de'
,p_message_text=>unistr('Nullspaltenwerte mit den Spaltenwerten der dar\00FCberliegenden Zellen f\00FCllen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001992166303505)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'de'
,p_message_text=>'Suchen nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917057877303430)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit Websheet-Anwendungen k\00F6nnen Endbenutzer strukturierte und nicht strukturierte Daten ohne Unterst\00FCtzung durch den Entwickler verwalten. Mit Websheets k\00F6nnen Benutzer:</p> '),
'',
'<ul>',
unistr('<li>Content \00FCber das Web mit einem Webbrowser erstellen und gemeinsam verwenden</li>'),
unistr('<li>Seiten in einer Hierarchie organisieren und Seiten verkn\00FCpfen (mithilfe der [[ Seitenname ]]-Syntax).</li>'),
'',
'<li>Tabellarische Daten mithilfe eingebetteter Features, den so genannten Daten-Grids, erstellen und verwalten</li>',
'<li>Interaktive Berichte mit SQL auf vorhandenen Datenstrukturen in der Datenbank erstellen.</li>',
unistr('<li>Daten-Grid- und Berichtsdaten in Seiten als Diagramm oder Bericht ver\00F6ffentlichen.</li>'),
unistr('<li>Seiten mit Anmerkungen in Form von Dateien, Tags und Hinweisen versehen. Zugeh\00F6rige Images k\00F6nnen inline im Seitencontent angezeigt werden (mithilfe der [[Image: Dateiname]]-Syntax).</li>'),
'<li>Seitencontent durchsuchen (mit der integrierten Suchfunktion).</li>',
'<li>Verwalten, wer sich anmelden darf, und nach der Anmeldung kontrollieren, wer in der Anwendung lesen, schreiben oder sie verwalten darf (Authentifizierung und Autorisierung).</li>',
'</ul>',
unistr('<p>Klicken Sie auf "Hilfe" f\00FCr weitere Informationen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996935153303501)
,p_name=>'WS_GROUP'
,p_message_language=>'de'
,p_message_text=>'Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002923086303506)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'de'
,p_message_text=>'Gruppenname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010893614303512)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Der Name der Gruppe muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997242408303502)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschriftenausrichtung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997668984303502)
,p_name=>'WS_HEIGHT'
,p_message_language=>'de'
,p_message_text=>unistr('H\00F6he')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011077463303513)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Spalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009644516303511)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Spaltenname')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967805027303477)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Daten-Grid-Name oder -alias ung\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938392627303449)
,p_name=>'WS_LINKS'
,p_message_language=>'de'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003664888303507)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'de'
,p_message_text=>'Linkname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936865418303447)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'de'
,p_message_text=>'Link zu dieser Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002499880303506)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'de'
,p_message_text=>'Ladereihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010279672303512)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Es ist bereits eine Werteliste mit diesem Namen vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996264070303501)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'de'
,p_message_text=>'Definition der Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010358175303512)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Der Definition der Werteliste muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997882223303502)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'de'
,p_message_text=>unistr('Wertelisten dienen zur Einschr\00E4nkung der Spaltenwerte, die der Benutzer eingeben kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997923753303502)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen definierte Wertelisten bei der Bearbeitung der Spalteneigenschaften einer Spalte zuordnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009930474303512)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die ausgew\00E4hlten Anzeigetypen muss eine Werteliste definiert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010168834303512)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Der Name der Werteliste muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996131965303501)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'de'
,p_message_text=>'Name der Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937937137303448)
,p_name=>'WS_MAP'
,p_message_language=>'de'
,p_message_text=>'Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997542923303502)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'de'
,p_message_text=>'Maximale Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769578466303313)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'de'
,p_message_text=>unistr('Die maximale Breite darf nicht \00FCber 4000 liegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995205262303500)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'de'
,p_message_text=>'Minimieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98960029713303470)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322623409303771)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'de'
,p_message_text=>'%0 entspricht nicht dem Datumsformat von %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010989492303512)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Der neue Daten-Grid-Name muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936424975303447)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Der Name muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998571152303503)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'de'
,p_message_text=>'Neue Spaltenwerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192490481302840)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'de'
,p_message_text=>'Neues Daten-Grid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002741592303506)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'de'
,p_message_text=>'Neuer Daten-Grid-Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002844282303506)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'de'
,p_message_text=>'Neue Gruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98996084869303500)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'de'
,p_message_text=>'Neue Werteliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997743691303502)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'de'
,p_message_text=>'Neue Werteliste auf Grundlage der aktuellen Werte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192215284302840)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'de'
,p_message_text=>'Neue Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192591869302840)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'de'
,p_message_text=>'Neuer Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192139883302840)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'de'
,p_message_text=>'Neuer Abschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004730745303508)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Neue Validierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012234444303514)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'de'
,p_message_text=>'Neuer Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897705168303414)
,p_name=>'WS_NOTE'
,p_message_language=>'de'
,p_message_text=>'Hinweis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938233828303448)
,p_name=>'WS_NOTES'
,p_message_language=>'de'
,p_message_text=>'Hinweise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897816482303414)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Hinweis muss einen Wert enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192013175302840)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Spalten gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191606377302840)
,p_name=>'WS_NO_FILES'
,p_message_language=>'de'
,p_message_text=>'Keine Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190532917302839)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Datei ausgew\00E4hlt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191448238302839)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'de'
,p_message_text=>'Keine Anmerkungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191962990302840)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'de'
,p_message_text=>'Keine Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995730517303500)
,p_name=>'WS_NUMBER'
,p_message_language=>'de'
,p_message_text=>'Nummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012154753303514)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'de'
,p_message_text=>'Alter Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002356380303506)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'de'
,p_message_text=>'Sortieren nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962519147303472)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'de'
,p_message_text=>'Seitenalias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231688582302871)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Seite erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962630739303473)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Seitenbeschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192383960302840)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'de'
,p_message_text=>'Seitenverzeichnis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98192761736302840)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'de'
,p_message_text=>'Seitenhistorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360732695303802)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'de'
,p_message_text=>'Hierarchische Seitenliste mit untergeordneten Seiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308045691303758)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'de'
,p_message_text=>'Eigenschaften'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009359140303511)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Abfrage gibt \00FCber 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976268824303484)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Abfrage zu internen Anwendungsobjekten nicht zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997154456303501)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Schreibgesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011969795303513)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'de'
,p_message_text=>unistr('Die neuesten \00C4nderungen werden unten aufgelistet:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308243049303758)
,p_name=>'WS_REPLACE'
,p_message_language=>'de'
,p_message_text=>'Ersetzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002090912303505)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'de'
,p_message_text=>'Ersetzen durch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012038821303513)
,p_name=>'WS_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99002636822303506)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'de'
,p_message_text=>'Zeilen mit leeren Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320233221303769)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'de'
,p_message_text=>'Zeile %0 erstellt %1 von %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320178724303769)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenschl\00FCssel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99320346314303769)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'de'
,p_message_text=>'Inhalt zuletzt aktualisiert: %0 von %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011254749303513)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'de'
,p_message_text=>unistr('Die Zeile, deren Spaltenwert ge\00E4ndert werden soll, muss ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938032530303448)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'de'
,p_message_text=>'Zeilenreihenfolge'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99009583651303511)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'de'
,p_message_text=>unistr('Es muss eine zu l\00F6schende Zeile ausgew\00E4hlt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946142938303455)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'de'
,p_message_text=>'Muster-Homepage wird erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98959827713303470)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'de'
,p_message_text=>unistr('Speichern und weitere hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361770622303803)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'de'
,p_message_text=>'Suchbericht %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98962472830303472)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'de'
,p_message_text=>'Abschnittsinhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98231530583302871)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'de'
,p_message_text=>'Abschnitt erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98946277499303455)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'de'
,p_message_text=>'Abschnittstitel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998667719303503)
,p_name=>'WS_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99001773442303505)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlte Zeilen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997030358303501)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'de'
,p_message_text=>unistr('Spaltengruppe ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98918641307303431)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie den Berichtsnamen zur Anzeige der Spalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010731285303512)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'de'
,p_message_text=>'Die Sequenz muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99010609463303512)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Die Sequenz muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98998484668303502)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'de'
,p_message_text=>'Spaltenwerte festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99368793989303809)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'de'
,p_message_text=>'<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Oracle-Datenschutzrichtlinie</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361284022303803)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'de'
,p_message_text=>unistr('Durch Klicken auf die Schaltfl\00E4che "Weiter" unten sind Sie sich bewusst und stimmen zu, dass die Nutzung der Website von Oracle den <a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Nutzungsbedingungen von Oracle.com</a> unterl')
||unistr('iegt. Weitere Einzelheiten zur Erhebung und Nutzung Ihrer personenbezogenen Daten durch Oracle, einschlie\00DFlich Informationen zu Zugriff, Speicherung, Berichtigung, L\00F6schung, Sicherheit, internationalen Datentransfers und sonstigen Themen sind der <a ')
||'href="https://www.oracle.com/legal/privacy/index.html" target="_new">Datenschutzrichtlinie von Oracle</a> zu entnehmen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995687650303500)
,p_name=>'WS_STRING'
,p_message_language=>'de'
,p_message_text=>'Zeichenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011411003303513)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Die zu suchende Zeichenfolge muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98938458312303449)
,p_name=>'WS_TAGS'
,p_message_language=>'de'
,p_message_text=>'Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99308112891303758)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen umschalten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99004876977303508)
,p_name=>'WS_TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003052507303506)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Nicht zugeordnete Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995552705303500)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'de'
,p_message_text=>'Eindeutige ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99003855636303507)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'de'
,p_message_text=>'URL-Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011595886303513)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'de'
,p_message_text=>'Das Ziel der URL muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012335231303514)
,p_name=>'WS_USER'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99367003962303808)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>'Benutzername zu lang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99322572978303771)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'de'
,p_message_text=>'%0 muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98897627005303414)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'(Wert erforderlich)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007913238303510)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'Validierungsausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011650353303513)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Der Validierungsname muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005730842303508)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte entspricht NICHT dem Zeichenfolgenliteral im Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99011763904303513)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Die Validierungssequenz muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005385800303508)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Spalte enth\00E4lt mindestens eines der Zeichen in Ausdruck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007008386303509)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte ist alphanumerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006461752303509)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte ist im Ausdruck enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006591999303509)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte ist NICHT null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006231674303509)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte ist NICHT im Ausdruck enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006974625303509)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte ist NICHT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006651384303509)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Spalte enth\00E4lt keine Leerzeichen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007180216303510)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte ist numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99007505606303510)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Spalte ist ein g\00FCltiges Datum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99006027769303509)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Spalte entspricht dem Zeichenfolgenliteral im Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005910722303509)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Spalte enth\00E4lt keines der Zeichen im Ausdruck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005281165303508)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Angegebene Spalte ist NICHT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99005542703303508)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Spalte enth\00E4lt nur Zeichen im Ausdruck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99012555284303514)
,p_name=>'WS_VIEW'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99360611952303802)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994866015303499)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'de'
,p_message_text=>'Dateien anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98995016452303500)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'de'
,p_message_text=>'Hinweise anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98994933325303500)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'de'
,p_message_text=>'Tags anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98936742338303447)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Alias ist bereits vorhanden. Geben Sie einen anderen Alias ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99307955366303758)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'de'
,p_message_text=>'Websheet-Eigenschaften'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98917143181303430)
,p_name=>'WS_WELCOME'
,p_message_language=>'de'
,p_message_text=>'Willkommen bei Websheets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98997458320303502)
,p_name=>'WS_WIDTH'
,p_message_language=>'de'
,p_message_text=>'Breite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937285717303448)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'de'
,p_message_text=>'Ohne Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937668386303448)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'de'
,p_message_text=>'Ohne Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937875411303448)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'de'
,p_message_text=>'Ohne Speicherort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937481990303448)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'de'
,p_message_text=>'Ohne Hinweise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937127476303448)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'de'
,p_message_text=>'Mit Dateien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937599513303448)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'de'
,p_message_text=>'Mit Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937780179303448)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'de'
,p_message_text=>'Mit Speicherort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98937324599303448)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'de'
,p_message_text=>'Mit Hinweisen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688948646303244)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Abfrage muss mindestens eine Spalte f\00FCr das Datum oder den Zeitstempel enthalten. \00DCberpr\00FCfen Sie die Abfrage. (%0) </p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424226341303028)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Der Schl\00FCssel muss 8, 16 oder 24 Byte enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193443323302841)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0 ist in diesem Workspace nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193602362302841)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Laden von Tabelle %0 war nicht erfolgreich. Fehler wurden in Tabelle %1 protokolliert. Diese Tabelle muss vor dem erneuten Ausf\00FChren gel\00F6scht werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193368454302841)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'de'
,p_message_text=>'Keine Datei generiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193281612302841)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'de'
,p_message_text=>'Zeilen exportiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193732641302841)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Fehlertabelle %0 ist bereits vorhanden. Diese Tabelle muss vor dem erneuten Ausf\00FChren gel\00F6scht werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98193548287302841)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Alle einbezogenen Spalten sind nicht unterst\00FCtzte Datentypen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170620753302823)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'de'
,p_message_text=>unistr('Das %0-Schema ben\00F6tigt READ- und WRITE-Berechtigungen f\00FCr das Verzeichnis DATA_PUMP_DIR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98174922432302827)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'de'
,p_message_text=>unistr('Die ausgew\00E4hlte Objektspeicherdatei ist zu gro\00DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162088655302816)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Bei der Verarbeitung der DBMS_CLOUD-Anforderung ist ein interner Fehler aufgetreten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98162199042302816)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Zugangsdatentyp f\00FCr eine Objektspeicherreferenz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170595111302823)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Das %0-Schema ben\00F6tigt Zugriffsberechtigungen f\00FCr das Verzeichnis DATA_PUMP_DIR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173564330302826)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'de'
,p_message_text=>unistr('Das DBMS_CLOUD-Package ist in diesem System nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170472177302823)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Das %0-Schema ben\00F6tigt die EXECUTE-Berechtigung f\00FCr das DBMS_CLOUD-Package.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405978415303014)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'de'
,p_message_text=>'Parse-Fehler: Funktionsbody darf nicht Null sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406034543303014)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Parsen: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398515776303007)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'de'
,p_message_text=>'Anwendung=%0 Aktueller Workspace=%1 Angeforderter Workspace=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98398007953303007)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1014 Anwendung nicht gefunden. Ung\00FCltiger Workspace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400142685303009)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'de'
,p_message_text=>'Application=%0 Seite=%1 Anforderung=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394189482303003)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1082 Fehler beim Ausf\00FChren von Code f\00FCr Autorisierungsschema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394975693303004)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1007 Verzweigungspunkt darf nicht Null sein: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395026153303004)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1008 Fehler beim Ausf\00FChren von Verzweigung zu Seite %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155453971302810)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-7746 Verzweigung von einer Dialogseite zu einer Seite eines anderen Seitenmodus kann nicht verarbeitet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403317157303011)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Abrufen von Schaltfl\00E4chen-Template-ID=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393736755303003)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'de'
,p_message_text=>'<p>Klicken Sie <a href="%0">hier</a>, um sich anzumelden</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394494935303003)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1030 Fehler beim Ausf\00FChren von Berechnungsausdruck.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394513027303003)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1004 Berechnen von Funktion nicht m\00F6glich. computation_point=%0 computation_type=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394395365303003)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1003 Fehler beim Ausf\00FChren von Berechnungsabfrage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394274363303003)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1001 Unerwarteter Fehler beim Erstellen von Element: FSP_PROCESS_STATE_%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393951957303003)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1001 Unerwarteter Fehler in make_deeplinking_item session=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395547665303004)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Es wird erwartet, dass das p_company- oder wwv_flow_company-Cookie die Sicherheitsgruppen-ID des Anwendungseigent\00FCmers enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399804171303008)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-7621 Bestimmen des Workspace f\00FCr Anwendung (%0) bei Anwendungsannahme nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399950971303008)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Es wird erwartet, dass das p_company- oder wwv_flow_company-Cookie die Sicherheitsgruppen-ID des Anwendungseigent\00FCmers enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395386528303004)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1011 Ung\00FCltiger Auswertungstyp: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403210049303011)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'de'
,p_message_text=>'Anwendungsfehler in fetch_value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394016921303003)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1902 Element-ID ist Null in find_item_name-Routine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394866898303004)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1021 Ausf\00FChren von "function body returning boolean"-Validierung nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394735120303004)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1024 Ausf\00FChren von "function body returning text"-Validierung nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395499185303004)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1812 Unerwarteter Fehler beim Zuweisen von G_FLOW_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400091422303008)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-9988 Es wurden nicht gen\00FCgend Informationen f\00FCr diese Anforderung angegeben: M\00F6glicherweise haben Sie nicht gewartet, bis die vorherige Seite vollst\00E4ndig geladen wurde. Klicken Sie auf <b>Zur\00FCck</b> und <b>Neu laden</b> Ihres Browsers, oder navig')
||'ieren Sie zur Homepage Ihrer Anwendungen, um fortzufahren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395984295303005)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1555 Nicht beim Oracle-Login-Server angemeldet. Es wurde kein \00F6ffentlicher Benutzer angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399509873303008)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'de'
,p_message_text=>'Abmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393645769303003)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht angemeldet. Das Cookie f\00FCr die Form zur Authentifizierung war nicht vorhanden oder ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400506857303009)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1777: Die Seite %0 hat keine Seite f\00FCr die Verzweigung zur Verf\00FCgung gestellt. Melden Sie diesen Fehler Ihrem Anwendungsadministrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399682854303008)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1013 Keine Berechtigung f\00FCr den Vorgang von Benutzer %0. Es ist die Rolle %1 erforderlich. Wenden Sie sich an den Anwendungsadministrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225482961302866)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite kann mit Argumenten angefordert werden, wenn eine Pr\00FCfsumme an die show-Prozedur \00FCbergeben wird')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225641959302866)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'de'
,p_message_text=>'Auf die Seite kann nur mit einer Verzweigung vom Typ "Verzweigung zu Seite" von einer anderen Seite zugegriffen werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225503861302866)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'de'
,p_message_text=>'Auf die Seite kann nur ohne Argumente zugegriffen werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225817134302866)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Argumente wurden an eine Seite \00FCbergeben, die keine Argumente akzeptiert (Anforderung, Cacheinhalt l\00F6schen, Element).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225366775302866)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Seite ist nicht gesch\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399409379303008)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'de'
,p_message_text=>'Die erforderliche Rolle ist nicht aktiviert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400622937303009)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'de'
,p_message_text=>'<a href="f?p=%0">Anwendung neu starten</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98393863998303003)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1001 Unerwarteter Fehler in Speicherroutine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98395229936303004)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1910 Fehler beim Auswerten von SQL-Ausdruck in Headertext.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426445408303030)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist nicht m\00F6glich, Sie zur Homepage weiterzuleiten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98399788042303008)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1512 Aufl\00F6sen von Seiten-Aliasname (%0) nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403500921303012)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Festlegen von timed_statistics nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403405649303011)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Trace nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98397341672303006)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1444 Authentifizierungsschema nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98394691014303003)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1006 Fehler in Validierungsroutine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406196891303014)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'de'
,p_message_text=>'Verworfen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434356034303036)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim L\00F6schen von Entwicklerrolle. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434205086303036)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzerinformationen k\00F6nnen nicht abgerufen werden. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634378202303194)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'de'
,p_message_text=>'Warnung: Der Benutzer %0 hat keine Entwicklerberechtigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301400054302928)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'de'
,p_message_text=>unistr('COMPATIBLE (Dieser Import wird in der Regel ohne Probleme ausgef\00FChrt.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179652009303647)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('WARNUNG f\00FCr Zugangsdaten "%0" (statische ID):'),
'',
'- Application Express-Exportdateien enthalten keine Zugangsdateninformationen.',
'- Verwenden Sie die Prozedur APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL, um die',
'- Zugangsdaten nach dem Import der Anwendung festzulegen. Die Zugangsdaten werden',
unistr('- \00FCber ihre statische ID "%0" referenziert')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296932774302924)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'de'
,p_message_text=>'Ihre Aktuelle Version:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769472326303313)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendung %0 kann nicht gel\00F6scht werden, sie ist in einem anderen Workspace installiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301034441302928)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Name f\00FCr das Authentifizierungsschema=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299604707302926)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Verzweigungs-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300837726302927)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Bug-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298145694302925)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen des Namens f\00FCr Erstelloption=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298254934302925)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Einrichten von Erstelloptions-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299578024302926)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Schaltfl\00E4chenname="%0" id="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654949899303210)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen des Namens der Unteraktion der dynamischen Aktion="%0" id="%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654821570303210)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen der Seite f\00FCr dynamische Aktion="%0" name="%1" id="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98339074825302956)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'de'
,p_message_text=>'Error page=%0 item="%1" id="%2" hat denselben Namen wie ein vorhandenes Element auf Anwendungsebene.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298723739302926)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendungsberechnungselement="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298698266302926)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendungselement-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255973034302890)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der Attribut-ID des Plug-ins="%0"	'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98668814038303224)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der Attributwerte-ID als Plug-in="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255890083302890)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der Plug-in-ID ="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98312202374302936)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der Ereignis-ID des Plug-ins="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298401618302925)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendungsprozess-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343619855303788)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der Templateoptions-ID der Anwendung="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99343504348303788)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der Templateoptionsgruppen-ID der Anwendung="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300641699302927)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Der vorhandenen Seite %0 wurde eine Form hinzugef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275631343302907)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Importieren der Attribut-ID f\00FCr die Datenbankobjektinstallation nicht m\00F6glich="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275747876302907)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen der Installationsskript-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300370853302927)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Berichtstyp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300166254302927)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Anwendungs-\00DCbersetzungszuordnung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98197951053302844)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Werteliste, Spalten-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299196004302926)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Wertelisten-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298390082302925)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Navigationsleisten-Element-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299820851302927)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Seite f\00FCr die Seitenberechnung=%0 item=%1 id="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299207292302926)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Seitenname="%0" id="%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98709004307303262)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Seitengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300518823302927)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seite %0 hat bereits Schaltfl\00E4chen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299303595302926)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Seite %0 f\00FCr den Hilfetext:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299737754302926)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldungsseite=%0 Element="%1" id="%2"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299495561302926)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Aktualisieren von Seitenname="%0" id="%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300238653302927)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Seite auf Tabelle "%0" nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300002151302927)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Seite f\00FCr den Seitenprozess=%0 name=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299968865302927)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Seite f\00FCr die Seitenvalidierung=%0 name=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98299033707302926)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von \00FCbergeordneter Registerkarten-ID="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298580149302925)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Einrichten von Prozess-SQL-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300459469302927)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Berichtsseite %0 ist vorhanden, die Berichtsregion wurde hinzugef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300763035302927)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'de'
,p_message_text=>'Die Seite %0 wurde nicht erstellt, weil sie bereits vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98300927949302928)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Shortcut-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298871234302926)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Standardregisterkarten-ID="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298964695302926)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Umbenennen von Registerkartengruppe %1 in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98298062229302925)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Templatename=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98296878892302924)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'de'
,p_message_text=>'API zuletzt erweitert:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301321999302928)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Exportdatei ist mit der Application Express-Version inkompatibel, in die Sie die Datei importieren m\00F6chten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297816669302925)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'de'
,p_message_text=>unistr('Die Prozedur %0 wurde ohne Wert f\00FCr p_id aufgerufen. Es muss eine Anwendungs-ID angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157101246302812)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungs-ID "%0" liegt nicht im zul\00E4ssigen Bereich (%1 - %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98768937534303312)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-ID "%0" kann nicht verwendet werden. Der Bereich (%1 - %2) ist reserviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301216510302928)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anwendungs-ID %0 ist f\00FCr die Oracle Corporation reserviert ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98157202390302812)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungs-ID "%0" ist f\00FCr einen anderen Workspace reserviert und kann hier nicht verwendet werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297921838302925)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anwendung %0 wurde nicht gel\00F6scht. Der Import wird nicht eingeleitet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297049316302924)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'de'
,p_message_text=>'Der Import ist kompatibel zu Version:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727422974303278)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Importieren von Skript nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297562503302925)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Kombination aus Benutzername, Kennwort oder Workspace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297177396302924)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'de'
,p_message_text=>'Ihr Anwendungsimport hat keine Exportversion angegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179574392303647)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr den Remoteserver mit der statischen ID "%0" wurden keine Werte angegeben. Verwenden Sie APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER, bevor Sie die Anwendung installieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727338182303278)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'de'
,p_message_text=>'neu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301561015302928)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'de'
,p_message_text=>unistr('NICHT KOMPATIBEL (Ihr Export enth\00E4lt m\00F6glicherweise Aufrufe, die von Ihrer %0-Version nicht unterst\00FCtzt werden.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179940456303648)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('WARNUNG f\00FCr Remoteserver "%0" (statische ID).'),
'',
unistr('- Attribute f\00FCr diesen Remoteserver wurden \00FCber APEX_APPLICATION_INSTALL festgelegt.'),
'- Beachten Sie, dass dieses Remoteserverobjekt auch von anderen Anwendungen verwendet wird.',
'',
'Die Workspace-Remoteserverattribute wurden daher aktualisiert.',
'- Basis-URL:      %1',
'- HTTPS-Host:    %2',
'- ORDS-Zeitzone: %3'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179818747303647)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('WARNUNG f\00FCr Remoteserver "%0" (statische ID).'),
'',
'- Das Attribut PROMPT_ON_INSTALL ist auf YES gesetzt.',
unistr('- \00DCber APEX_APPLICATION_INSTALL wurden keine Attribute angegeben.'),
'',
unistr('Die Workspace-Remoteservereinstellungen bleiben daher unver\00E4ndert.'),
'- Basis-URL:      %1',
'- HTTPS-Host:    %2',
'- ORDS-Zeitzone: %3',
'',
unistr('Verwenden Sie APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER zum \00C4ndern der Attribute.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99179799688303647)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('WARNUNG f\00FCr Remoteserver "%0" (statische ID).'),
'',
'- Das Attribut PROMPT_ON_INSTALL ist auf NO gesetzt.',
'- Die Einstellungen aus der Anwendungsimportdatei weichen von vorhandenen Attributen ab.',
'- Dieser Remoteserver wird auch von anderen Anwendungen in diesem Workspace verwendet.',
'',
unistr('Die Workspace-Remoteservereinstellungen bleiben daher unver\00E4ndert.'),
'- Basis-URL:      %1',
'- HTTPS-Host:    %2',
'- ORDS-Zeitzone: %3',
'',
unistr('Verwenden Sie APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER zum \00C4ndern der Attribute.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727271611303278)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'de'
,p_message_text=>'ersetzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965431094303475)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen Feedback nicht in dasselbe System importieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98727572616303278)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'de'
,p_message_text=>unistr('Die Skriptgr\00F6\00DFe von %0 Byte \00FCberschreitet die maximal zul\00E4ssige Gr\00F6\00DFe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98301153936302928)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'de'
,p_message_text=>'Die Package-Variable g_security_group_id muss festgelegt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297748144302925)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Package-Variable g_security_group_id muss f\00FCr den Import einer Anwendung festgelegt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297388903302924)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'de'
,p_message_text=>'Die letzte API-Version Ihrer Engine konnte nicht eingerichtet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297221965302924)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'de'
,p_message_text=>'Die Version Ihrer Engine konnte nicht eingerichtet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98297418117302924)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Sie m\00FCssen ein Upgrade ausf\00FChren, um diesen Anwendungsexport importieren zu k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98965386380303475)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'de'
,p_message_text=>unistr('Feedback wurde f\00FCr dieses Deployment-System nicht exportiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169730050302822)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'de'
,p_message_text=>unistr('Automatisierungen, die REST-Datenquellen referenzieren, k\00F6nnen nicht aus einer anderen Anwendung kopiert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168164097302821)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'de'
,p_message_text=>'Neue Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346241227302962)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody, der eine SQL-Abfrage zur\00FCckgibt, ist erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346112656302961)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346340444302962)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('REST-f\00E4higer SQL-Service ist erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346037072302961)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Tabellenname muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346485048302962)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'REST-Datenquelle ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98346515278302962)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'WHERE- oder ORDER BY-Klausel ist erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401603707303010)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'de'
,p_message_text=>'Anwendung:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417942099303023)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist keine Anwendung ausgew\00E4hlt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401943624303010)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'de'
,p_message_text=>'<span class="tiny">Keine Seiten gefunden.</font>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401764624303010)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402063206303010)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'de'
,p_message_text=>'%0 <font size=-2>Seiten</span>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588232077303159)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl Seiten:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98588386108303159)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'de'
,p_message_text=>'Seitenliste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401836515303010)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL %0 %1 enth\00E4lt %2 Zeilen Quellcode.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836911150303365)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Codeerg\00E4nzung wird f\00FCr Remote-SQL nicht unterst\00FCtzt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98836274117303364)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Query Builder wird f\00FCr Remote-SQL nicht unterst\00FCtzt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434420774303036)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Parse-Fehler f\00FCr aktualisierbaren Bericht: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99369349409303809)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Umleitung von einer Dialogseite zu einer normalen Seite nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406313683303014)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'de'
,p_message_text=>'veraltet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406223297303014)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 mehrfach vorhandene Sessions wurden gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374608928302983)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen nur Ihr eigenes Kennwort \00E4ndern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374862980302983)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Unerwarteter Fehler beim Verarbeiten Ihrer Anforderungen zur Kennwort\00E4nderung: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374329673302983)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'de'
,p_message_text=>unistr('Es m\00FCssen das Kennwort und die Kennwortbest\00E4tigung angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98374462743302983)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'de'
,p_message_text=>unistr('Die Kennw\00F6rter stimmen nicht \00FCberein. F\00FChren Sie den Vorgang erneut aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375434406302983)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'de'
,p_message_text=>'Oracle-Fehler: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98375172579302983)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'de'
,p_message_text=>'ERR-1025 Fehler beim Verarbeiten von PL/SQL-Ausdruck. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266065144302899)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Mitgliedsattributnummer %0 ist ung\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406712248303014)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Exists/Not Exists-Bedingung: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406582635303014)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Funktionsbodybedingung: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406422544303014)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige PL/SQL-Ausdrucksbedingung: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406637198303014)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige SQL-Ausdrucksbedingung: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420820820303025)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei Ausf\00FChrung von wwv_flow_copy: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155805571302811)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Die \00FCbersetzte Anwendungs-ID ist ung\00FCltig. Die Anwendungs-ID wird von einer vorhandenen Anwendung verwendet. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420762645303025)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'de'
,p_message_text=>'Sicherheitsgruppen-ID (Ihre Workspace-ID) ist nicht festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98708473544303261)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'de'
,p_message_text=>unistr('Der Kompatibilit\00E4tsmodus der Anwendung "%0" muss f\00FCr eine Theme-Aktualisierung auf mindestens 21.2 gesetzt sein. Sie k\00F6nnen den Kompatibilit\00E4tsmodus in der Anwendungsdefinition unter den Eigenschaften \00E4ndern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99405152899303840)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'de'
,p_message_text=>unistr('Das aktuelle Theme ist nicht mit dem ausgew\00E4hlten Master-Theme kompatibel, die Theme-IDs stimmen nicht \00FCberein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98833837890303362)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Template nicht m\00F6glich, weil das \00FCbergeordnete Template nicht gefunden wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274075922302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ver\00F6ffentlichen von Authentifizierungsschema nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273451851302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ver\00F6ffentlichen von Schaltfl\00E4chen-Template nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427625248303031)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ver\00F6ffentlichen von Kalendertemplate nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273276702302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Feld-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274149287302906)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ver\00F6ffentlichen von Elementhilfe nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273015478302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Listentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273978500302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ver\00F6ffentlichen von Werteliste nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273541064302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ver\00F6ffentlichen von Navigationspfad-Template nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273826285302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Navigationsleiste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272891137302904)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Seitentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273380019302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Template f\00FCr Popup-Werteliste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272978791302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Regionstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273194426302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Berichtstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273670232302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'de'
,p_message_text=>unistr('Ver\00F6ffentlichen von Sicherheitsschema nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98273759139302905)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ver\00F6ffentlichen von Shortcut nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271288440302903)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Authentifizierungsschema-Referenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270173221302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Schaltfl\00E4chen-Templatereferenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98427514965303031)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Abonnieren von Kalendertemplate nicht m\00F6glich. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269444217302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Feldreferenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271329694302903)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Elementhilfe-Referenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269294681302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Listenreferenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269838971302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Referenz-ID f\00FCr Werteliste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98270073569302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Navigationspfad-Templatereferenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269794164302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Navigationsleisten-Referenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269073644302901)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Seitenreferenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269966492302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Referenz-ID f\00FCr Popup-Werteliste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269127498302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Regionsreferenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269361558302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Berichtsreferenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269573881302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Sicherheitsschema-Referenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98269647866302902)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Shortcut-Referenz-ID nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272666076302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Authentifizierungsschema nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272193375302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Schaltfl\00E4chen-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364928161303806)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Kalendertemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271834476302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Feld-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272776838302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Elementhilfe nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271676054302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Listentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272574142302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Werteliste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272037601302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Navigationspfad-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272415897302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Navigationsleiste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271435553302903)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Seitentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271963373302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Template f\00FCr Popup-Werteliste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271554004302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Regionstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98271711998302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Berichtstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272234644302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Sicherheitsschema nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98272381109302904)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'de'
,p_message_text=>unistr('Abonnieren von Shortcut nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99344022547303789)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Theme-Optionen k\00F6nnen nicht abonniert werden. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434973556303036)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei Ausf\00FChrung von wwv_flow_copy_page: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421042140303025)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei Ausf\00FChrung von wwv_flow_copy_page_item: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294043442302922)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 (%1) f\00FCr den Kopiervorgang nicht gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621380844303184)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'de'
,p_message_text=>'Ein Shortcut mit dem Namen %0 ist bereits vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98421499596303026)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Shortcut (%0) f\00FCr den Kopiervorgang nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422443021303027)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Berichtstemplates erstellen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423066932303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Registerkartenziele berechnen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426314472303030)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Authentifizierungsschemas kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426281578303030)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Autorisierungsschemas kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423845293303028)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Anwendung (Schaltfl\00E4chen-Templates kopieren): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423345014303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Feld-Template kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423676357303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Listentemplates kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424035543303028)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Werteliste kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423740503303028)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Navigationspfad-Templates kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423961082303028)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Navigationsleiste kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423251432303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Seitentemplate kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423587825303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Regionstemplates kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423408202303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Berichtstemplates kopieren): %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424138028303028)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Sicherheitsschema kopieren): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422398240303026)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Feld-Template erstellen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422666359303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Listentemplates erstellen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422790999303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Navigationspfad-Templates erstellen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422116829303026)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Seite erstellen): %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98423127143303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Anwendung (\00FCbergeordnete Registerkarten erstellen): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422201462303026)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Seitentemplate erstellen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422825427303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Erstellen von Anwendung (Template f\00FCr Popup-Werteliste erstellen): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422544050303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Regionstemplates erstellen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422928556303027)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Anwendung (Standardregisterkarten erstellen): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98422013893303026)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('%0-Fehler \00FCberpr\00FCfen: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621156362303184)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilen hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98621031281303184)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'de'
,p_message_text=>'MRD anwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98620917745303184)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'de'
,p_message_text=>'MRU anwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608265706303174)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'de'
,p_message_text=>'%0 erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685921435303241)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Formularseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98712440379303265)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von globaler Seite nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99196844727303661)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'de'
,p_message_text=>'Interaktive Grid-Seite kann nicht erstellt werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686143339303241)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Seiten. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686092460303241)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Seite f\00FCr tabellarisches Formular nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686240984303241)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile abrufen aus %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729669297303280)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'de'
,p_message_text=>'Benutzername-Cookie abrufen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98825618934303356)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationsmen\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98685570236303240)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FCseite %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98686387208303241)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile von %0 verarbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98774669142303317)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'de'
,p_message_text=>'Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613894503303178)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgeblendete Elemente zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607391648303173)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'de'
,p_message_text=>unistr('Berichtsuche zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98702102056303256)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile pro Seite melden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698284449303252)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'de'
,p_message_text=>unistr('Skript wird ausgef\00FChrt: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98729512754303280)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'de'
,p_message_text=>'Benutzername-Cookie festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98615045015303179)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Diese Prozedur muss innerhalb einer Anwendungssession aufgerufen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98176777381302828)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'de'
,p_message_text=>unistr('Zugangsdaten d\00FCrfen f\00FCr diesen URL-Endpunkt nicht verwendet werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170255950302823)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'de'
,p_message_text=>unistr('URLs in der Liste m\00FCssen mit http:// oder https:// beginnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715502453303267)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'de'
,p_message_text=>unistr('Zugangsdaten f\00FCr %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424389447303028)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von CSS nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730262237303280)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('Drag-and-Drop wird f\00FCr REST-Datenquellen nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405837943303013)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen anwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287379558302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seiten-Sentry-Funktion gibt das boolesche Ergebnis der integrierten Pr\00FCfung f\00FCr die Sessionverifizierung an die Engine zur\00FCck. Wenn das Ergebnis TRUE lautet, wird die Engine die Seite weiterhin anzeigen oder akzeptieren. Wenn das Ergebnis FALSE l')
||unistr('autet, f\00FChrt die Engine eine Umleitung zur Seite f\00FCr die ung\00FCltige Session oder zur URL aus, die in diesem Authentifizierungsschema angegeben ist (siehe unten).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288678181302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die Seiten-Sentry-Funktion TRUE zur\00FCckgibt, wird mit dem Rendering bzw. der Verarbeitung der Seite fortgefahren. Wenn das Ergebnis FALSE lautet, muss die Engine beendet werden, weil im Authentifizierungsschema kein ung\00FCltiges Sessionziel angegeb')
||unistr('en ist. In diesem Fall wird die vom Benutzer zur Verf\00FCgung gestellte Seiten-Sentry-Funktion an eine Anmeldeseite au\00DFerhalb der %0-Umgebung umgeleitet, und zwar m\00F6glicherweise zu einem externen Authentifizierungsportal. Bei der Funktion muss au\00DFerdem ')
||'die globale Variable "g_unrecoverable_error := true" festgelegt sein, damit die Engine angewiesen wird, ohne Fehlermeldungsseite beendet zu werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288720256302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'de'
,p_message_text=>unistr('Die Engine f\00FChrt folgenden Code aus, der als Prozess vor der Authentifizierung f\00FCr dieses Authentifizierungsschema angegeben wird:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288803491302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'de'
,p_message_text=>unistr('Dies wird als anonymer Block ausgef\00FChrt, der keinen Wert zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288982825302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist kein benutzerdefinierter Code f\00FCr die Ausf\00FChrung vor der Authentifizierung in diesem Schema angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289147107302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'de'
,p_message_text=>unistr('Jede in der Anmelde-Form eingegebene Kombination aus Benutzername/Kennwort ist g\00FCltig. Der eingegebene Benutzername wird als Name f\00FCr den angemeldeten Benutzer w\00E4hrend der Dauer der Session verwendet. Diese Technik ist n\00FCtzlich, wenn Sie Ihre Anwendu')
||unistr('ng entwickeln, bevor tats\00E4chliche Benutzeraccounts eingerichtet sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289265375302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfen Sie den Benutzernamen und das Kennwort in dem Anmeldeformular mit den Angaben f\00FCr die Cookie User-Accounts von App Builder. Hierbei handelt es sich um dieselben Accounts, die von Ihrem Workspace f\00FCr die Anmeldung bei %0 verwendet werden. D')
||unistr('iese Technik ist n\00FCtzlich, wenn die Benutzer Ihrer Anwendung Entwickler sind, die %0 Accounts in derselben Datenbank und demselben Workspace haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221513221302863)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfen Sie den Benutzernamen und das Kennwort in der Anmelde-Form mit den Angaben f\00FCr die Oracle-Datenbank-Accounts. Diese Technik ist n\00FCtzlich, wenn die Benutzer Ihrer Anwendung Accounts in der Datenbank haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289350758302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfen Sie den Benutzernamen und Kennwort in der Anmelde-Form in Bezug auf das LDAP-Verzeichnis, das in diesem Authentifizierungsschema angegeben ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289498934302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'de'
,p_message_text=>unistr('Die LDAP-Parameter sind folgenderma\00DFen gesetzt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290164952302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FChren Sie den folgenden benutzerdefinierten Code aus, um die Zugangsdaten zu \00FCberpr\00FCfen:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290304387302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfen Sie, ob in der integrierten Sessiontabelle die Session enthalten ist, die von der integrierten Anmeldeseite verwendet wird. Wenn die Session vorhanden ist und noch keinem anderen Benutzer geh\00F6rt, legen Sie fest, dass sie jetzt dem berechti')
||unistr('gten Benutzer (\00FCber den Benutzernamen auf der Anmelde-Form) geh\00F6rt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287476054302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seiten-Sentry-Funktion gibt das boolesche Ergebnis der integrierten Pr\00FCfung f\00FCr die Sessionverifizierung mit einer AND-Kombination des Ergebnisses der vom Benutzer angegebenen Pr\00FCfung f\00FCr die Sessionverifizierung an die Engine zur\00FCck. Wenn das Er')
||unistr('gebnis TRUE lautet, wird die Engine die Seite weiterhin anzeigen oder akzeptieren. Wenn das Ergebnis FALSE lautet, f\00FChrt die Engine eine Umleitung zur Seite f\00FCr das ung\00FCltige Sessionziel aus, das in diesem Authentifizierungsschema angegeben ist (sieh')
||'e unten).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290439091302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'de'
,p_message_text=>unistr('Setzen Sie das Cookie %0 auf einen Wert, der die Zeile in der Tabelle f\00FCr die internen Sessions angibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290505681302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'de'
,p_message_text=>'Bestimmen Sie, dass die URL beim Klick auf "Weiter" umgeleitet wird. Wenn ein "Deeplink" im Sessionzustand von der Rendering Engine erfasst wurde, verwenden Sie diesen als Navigations-URL. Navigieren Sie andernfalls zur URL, die als Home-Linkattribut'
||' der Anwendung angegeben ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290709088302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'de'
,p_message_text=>unistr('Nach der Zugangsdatenverifizierung f\00FChrt die Engine folgenden Code aus, der als Prozess nach der Authentifizierung f\00FCr dieses Authentifizierungsschema angegeben wird:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290832458302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'de'
,p_message_text=>unistr('Dies wird als anonymer Block ausgef\00FChrt, der keinen Wert zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290924364302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist kein benutzerdefinierter Code f\00FCr die Ausf\00FChrung nach der Authentifizierung in diesem Schema angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291051365302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FChren Sie die Umleitung zum oben angegebenen URL aus. Dadurch wird das Ende der Anmeldungsverarbeitung mit der integrierten Anmeldeseite und den APIs, die diese Seite aufrufen, gekennzeichnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287566325302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'de'
,p_message_text=>unistr('Verwenden Sie eine benutzerdefinierte Logik, um Seiten-Sentry-Aufgaben auszuf\00FChren. Die Engine f\00FChrt f\00FCr jede Seitenanforderung folgenden Code aus:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287607740302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'de'
,p_message_text=>unistr('Das boolesche Ergebnis des oben angegebenen Blocks wird an die Engine zur\00FCckgegeben. Wenn das Ergebnis TRUE lautet, wird die Engine die Seite weiterhin anzeigen oder akzeptieren. Wenn das Ergebnis FALSE lautet, f\00FChrt die Engine eine Umleitung zur Sei')
||unistr('te f\00FCr das ung\00FCltige Sessionziel aus, das in diesem Authentifizierungsschema angegeben ist (siehe unten).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287718497302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'de'
,p_message_text=>unistr('Die integrierte Methode f\00FCr die Sessionverifizierung ist f\00FCr den %0-Entwickler \00FCber den API-Aufruf verf\00FCgbar:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287889221302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'de'
,p_message_text=>unistr('Das Ergebnis dieser booleschen Funktion kann mit anderen Pr\00FCfungen in der vom Benutzer zur Verf\00FCgung gestellten Seiten-Sentry-Funktion in einem Authentifizierungsschema kombiniert werden. Beim Aufruf dieser API wird das Cookie %0 gepr\00FCft')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287925819302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn das Cookie vorhanden ist und der decodierte Wert eine Zeile in der Tabelle der internen Sessions ermittelt, ist die Session g\00FCltig, und es wird TRUE an die aufrufende Seiten-Sentry-Funktion zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288109235302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die Seiten-Sentry-Funktion TRUE zur\00FCckgibt, wird mit dem Rendering oder der Verarbeitung der Seite fortgefahren. Lautet das Ergebnis jedoch FALSE, ruft die Engine die Seite %0 auf, bei der es sich um die Anmeldeseite der Anwendung handelt, die a')
||unistr('ufgrund der Position im Authentifizierungsschema die ung\00FCltige Sessionseite ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288511294302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'de'
,p_message_text=>unistr('Die Seiten-Sentry-Funktion gibt ein boolesches Ergebnis an die Engine zur\00FCck. Bei R\00FCckgabe von TRUE wird mit dem Rendering oder der Verarbeitung der Seite fortgefahren. Wenn das Ergebnis FALSE lautet, erfolgt seitens der Engine eine Umleitung zu %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291132867302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'de'
,p_message_text=>unistr('In der Regel enth\00E4lt die Seite eine Anmelde-Form zum Erfassen der Zugangsdaten des Benutzers. Anschlie\00DFend wird nach den Weiterleitungsprozessen f\00FCr die Seite ein Authentifizierungsmodul zur \00DCberpr\00FCfung der Zugangsdaten aufgerufen. Nach der Authentif')
||unistr('izierung f\00FChrt die Seite Aufgaben f\00FCr die Sessionregistrierung und Cookieeinstellung aus. Abschlie\00DFend erfolgt eine Umleitung zur Startseite der Anwendung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291249252302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'de'
,p_message_text=>unistr('Die %0-API wwv_flow_custom_auth_std kann von derartigen Prozessen nach der Weiterleitung aufgerufen werden, um die oben beschriebenen Schritte auszuf\00FChren. Es stehen zwei Einstiegspunkte zur Verf\00FCgung:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291349262302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'de'
,p_message_text=>unistr('Rufen Sie die Anmeldeprozedur auf, damit die Engine alle Schritte ausf\00FChrt. Die Engine verwendet die integrierte Sessiontabelle und f\00FChrt die Aufgabe f\00FCr die Sessionregistrierung und Cookieeinstellung f\00FCr Sie aus. Wenn Sie benutzerdefinierten Code in')
||unistr(' dieses Authentifizierungsschema eingeben, wird dieser am Punkt vor der Authentifizierung, w\00E4hrend der Authentifizierung oder nach der Authentifizierung ausgef\00FChrt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291405988302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'de'
,p_message_text=>unistr('Rufen Sie die Prozedur post_login auf, wenn Sie die Authentifizierung selbst ausf\00FChren und m\00F6chten, dass %0 die Prozesse nach der Authentifizierung f\00FCr Sie ausf\00FChrt. Sie k\00F6nnen mit diesen beiden Einstiegspunkten beliebige integrierte Schritte f\00FCr die')
||unistr(' Anmeldungsverarbeitung in Verbindung mit Ihrer eigenen Anmeldeseite und den Prozessen verwenden, die darauf ausgef\00FChrt werden. Wenn Sie die integrierten Prozesse nach der Authentifizierung verwenden, k\00F6nnen Sie auch vom Integrierten Seiten-Sentry- u')
||'nd Sessionverifizierungsprozess profitieren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288204833302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'de'
,p_message_text=>'die integrierte Anmeldeseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291568198302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'de'
,p_message_text=>'Externe Anmeldungsverarbeitung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292322598302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anmelde-URL %0 gibt keine %1-Anwendungsseite als ung\00FCltiges Sessionziel an. Au\00DFerdem befinden sich im Authentifizierungsschema keine Werte f\00FCr die Login-Verarbeitung. Auf dieser Seite werden folgende Schritte ausgef\00FChrt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292437744302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die bei diesem URL aufgerufenen Services zur Unterst\00FCtzung von Sessionregistrierungsaufgaben nicht die %0-API wwv_custom_auth_std verwenden, kann Ihre Anwendung die integrierte Seiten-Sentry- oder Sessionverifizierungsverarbeitung nicht nutzen. ')
||'Bitte verwenden Sie in diesem Fall ein eigenes, geeignetes Verfahren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292711648302921)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anmelde-URL %0 gibt keine %1-Anwendungsseite als ung\00FCltiges Sessionziel an. Auf dieser Seite werden folgende Schritte ausgef\00FChrt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292893242302921)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'de'
,p_message_text=>unistr('Die Werte f\00FCr die Anmeldungsverarbeitung im Authentifizierungsschema werden nachstehend angezeigt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292970049302921)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'de'
,p_message_text=>unistr('Bei der in diesem Schema angegebenen Anmeldeseite handelt es sich um die Seite [%0] in dieser Anwendung. Diese Seite ist f\00FCr die Ausf\00FChrung folgender Schritte zust\00E4ndig:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293052460302921)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'de'
,p_message_text=>unistr('Es befinden sich im Authentifizierungsschema keine Werte f\00FCr die Anmeldungsverarbeitung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98293152556302921)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'de'
,p_message_text=>unistr('Da es sich bei dieser Seite um die Anmeldeseite f\00FCr die Anwendung handelt, k\00F6nnen bestimmte Aktionen nicht auf der Seite ausgef\00FChrt werden, wenn die Seite zuerst angezeigt wird, weil die Benutzerauthentifizierung noch nicht ausgef\00FChrt wurde. Au\00DFerdem')
||unistr(' k\00F6nnen bestimmte Sessionzustand- und Session-ID-Variablen nicht f\00FCr Seitenberechnungen oder Prozesse verwendet werden, weil diese sich auf konventionellen Seiten befinden, die nach der Authentifizierung verarbeitet werden. Deshalb ist die Spezifikat')
||unistr('ion einer Anmeldeseite nach Seitennummer in einem Authentifizierungsschema nur f\00FCr Seiten geeignet, die keine Funktionalit\00E4t aufweisen bzw. lediglich die Verarbeitung der Anmelde-Form ausf\00FChren. Wenn Sie eine aktivere Anmeldeseite verwenden m\00F6chten, ')
||unistr('verwenden Sie die Anmelde-URL-Angabe im Assistenten f\00FCr das Authentifizierungsschema, oder bearbeiten Sie die Seite. Wenn Sie mittels der Seitenattribut-Form mit dem Builder das \00F6ffentliche Seitenattribut auf "Ja - Diese Seite ist \00F6ffentlich" setzen,')
||unistr(' kann die Anmeldeseite alle %0-Funktionen verwenden und au\00DFerdem als Anmeldeseite in Ihrer Anwendung eingesetzt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291666992302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Authentifizierungsschema gibt weder eine Anmeldeseite noch eine URL f\00FCr das ung\00FCltige Sessionziel an. Es wird vorausgesetzt, dass die Seiten-Sentry-Funktion diesen Vorgang ausf\00FChrt. M\00F6glicherweise erfolgt eine Umleitung zu einem SSO-Portal ode')
||unistr('r einem anderen Login-Server. Au\00DFerdem gibt es im Authentifizierungsschema keine Werte f\00FCr die Anmeldungsverarbeitung. Wenn dies nicht Ihren Vorstellungen entspricht, bearbeiten Sie dieses Authentifizierungsschema, und geben Sie eine ung\00FCltige Sessio')
||unistr('nseite oder eine URL an. Untersuchen Sie anschlie\00DFend diese Diagramm-View erneut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291733715302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Authentifizierungsschema gibt weder eine Anmeldeseite noch eine URL f\00FCr das ung\00FCltige Sessionziel an. Dabei wird vorausgesetzt, dass die Seiten-Sentry-Funktion diesen Fall verarbeitet. M\00F6glicherweise erfolgt eine Umleitung zu einem SSO-Portal ')
||unistr('oder einem anderen Login-Server. Es sind jedoch Werte f\00FCr die Anmeldungsverarbeitung im Authentifizierungsschema festgelegt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291829311302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anmelde-URL %0 gibt m\00F6glicherweise eine %1-Anwendungsseite als ung\00FCltiges Sessionziel an. Es befinden sich jedoch im Authentifizierungsschema keine Werte f\00FCr die Login-Verarbeitung. Auf dieser Seite werden folgende Schritte ausgef\00FChrt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98291931963302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'de'
,p_message_text=>unistr('Damit die %0-Engine die Anmeldeseite in Ihrer Anwendung anzeigen oder annehmen kann, m\00FCssen Sie das Seitenattribut <b>Ja - diese Seite ist \00F6ffentlich</b> auf der Seite <b>Seitenattribute</b> in App Builder angeben. Andernfalls versucht die Engine, di')
||unistr('e Seiten-Sentry-Funktion vor der Anzeige der Seite auszuf\00FChren. Wenn Sie sich noch nicht angemeldet haben, wird eine Umleitung zu derselben URL ausgef\00FChrt. Dadurch entsteht eine st\00F6rende Schleife. Wenn Sie Ihre eigene Seiten-Sentry-Funktion codieren,')
||unistr(' m\00FCssen Sie gegebenenfalls ermitteln, wann die aktuelle Seite die Anmeldeseite ist und diese anders als andere Seiten behandeln. Wenn die Seite direkt anhand der Seitennummer erkannt werden kann, ist das sicherlich die einfachste Methode. Ein etwas a')
||unistr('llgemeineres Verfahren bietet die Verwendung der booleschen Funktion wwv_flow_custom_auth.current_page_is_public, um dieses \00F6ffentliche Attribut der Anmeldeseite oder einer anderen Seite in Ihrer Anwendung zu erkennen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292001112302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anmelde-URL %0 gibt m\00F6glicherweise eine %1-Anwendungsseite als ung\00FCltiges Sessionziel an. Auf dieser Seite werden folgende Schritte ausgef\00FChrt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292100161302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'de'
,p_message_text=>unistr('Die Werte f\00FCr die Anmeldungsverarbeitung im Authentifizierungsschema werden nachstehend angezeigt:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292292419302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'de'
,p_message_text=>unistr('Der Oracle Application Server Single Sign-On-Server nimmt nach der Benutzer-Authentifizierung wieder eine Umleitung zur\00FCck zu dieser Anwendung vor. Der Einstiegspunkt ist die Prozedur wwv_flow_custom_auth_sso.process_success in dem Schema %0. %0 ist ')
||unistr('als Oracle Application Server Single Sign-On-Partneranwendung registriert und kann alle Schnittstellen zu dem Login-Server f\00FCr Sie verwalten. Wenn Sie jedoch eine eigene Anwendung in Ihrem eigenen Schema registrieren m\00F6chten, ist dies auch m\00F6glich. S')
||unistr('ie k\00F6nnen Ihre eigene Seiten-Sentry-Funktion schreiben oder einfach ein Authentifizierungsschema basierend auf dem Portal-SSO-Schema (meine Anwendung als Partneranwendung) aus der Galerie mit Authentifizierungsschemas erstellen. Das Ergebnisschema ru')
||'ft die integrierte SSO-Seiten-Sentry-Funktion wwv_flow_custom_auth_std.portal_sso_sentry_v1 auf. Diese Funktion erfordert, dass das aktuelle Authentifizierungsschema den Namen der Partneranwendung kennt, wie mit Oracle Application Server Single Sign-'
||unistr('On registriert. Der Assistent f\00FCr das Erstellen des Authentifizierungsschemas fordert Sie zur Angabe des Namens der Partneranwendung auf. Dieser kann jedoch auch hinzugef\00FCgt oder durch Bearbeiten des Schemas ge\00E4ndert werden, nachdem dieses erstellt w')
||unistr('urde. Der Name muss genau wie registriert eingegeben werden, wobei die Gro\00DF-/Kleinschreibung ber\00FCcksichtigt werden muss. Au\00DFerdem m\00FCssen Sie Ihre eigene URLC-Empf\00E4ngerprozedur schreiben und die API wwv_flow_custom_auth_sso.process_success aus dieser ')
||unistr('Prozedur aufrufen, indem Sie den Namen der Anwendung \00FCbergeben, so wie er mit Oracle Application Server Single Sign-On registriert wurde. Dadurch wird die Session mit %0 nach der Authentifizierung registriert. Wenn Sie eine eigene Seiten-Sentry-Funkt')
||unistr('ion schreiben, kann die API wwv_flow_custom_auth_sso.portal_sso_redirect von der Seiten-Sentry-Funktion aufgerufen werden, um die Umleitung zu dem Login-Server vorzunehmen, wenn festgestellt wird, dass eine Authentifizierung erforderlich ist. Sie m\00FCs')
||unistr('sen den registrierten Namen der Partneranwendung an diese Prozedur \00FCbergeben. Weitere Einzelheiten finden Sie in der %0 Dokumentation und der %1 Dokumentation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292656098302921)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'de'
,p_message_text=>'Prozess nach der Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98292548268302920)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'de'
,p_message_text=>'Prozess vor der Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287044447302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfen Sie mithilfe der integrierten Logik das Cookie [%0]. Wenn das Cookie vorhanden ist und der decodierte Wert eine Zeile in der Tabelle f\00FCr interne Sessions ermittelt, gehen Sie davon aus, dass die Session g\00FCltig ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287285453302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('R\00FCckgabewert berechnen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289077869302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'de'
,p_message_text=>'Zugangsdatenverifizierung (Authentifizierung)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290637960302919)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefinierter Prozess nach der Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283739844302913)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Einstiegspunktargument f\00FCr wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283601109302913)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'de'
,p_message_text=>'Null p_session_id-Argument an wwv_flow_custom_auth_std.login--p_flow_page:%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283588947302913)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren von Funktion zum Pr\00FCfen der Authentifizierungszugangsdaten nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288008539302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Sessionziel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289715377302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'de'
,p_message_text=>unistr('Basis f\00FCr die LDAP-Suche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289835798302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'de'
,p_message_text=>unistr('Der folgende Block wird f\00FCr den Aufruf einer Funktion verwendet, bevor DBMS_LDAP.SIMPLE_BIND_S aufgerufen wird. Der in der Anmelde-Form erfasste Benutzername wird an die Funktion \00FCbergeben, die einen Wert zur\00FCckgibt, der %LDAP_USER% in der LDAP Searc')
||'h Base (siehe oben) ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289970450302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'de'
,p_message_text=>'Der Codeblock muss diese Signatur haben:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290026529302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'de'
,p_message_text=>unistr('Mit diesem Feature k\00F6nnen Sie den in der Anmelde-Form eingegebenen Benutzernamen in ein Format f\00FCr Ihren LDAP-Verzeichniseintrag konvertieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289537493302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'de'
,p_message_text=>'LDAP-Host:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98289654795302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'de'
,p_message_text=>'LDAP-Port:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286504340302915)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'de'
,p_message_text=>'Diese Anwendung (%0) verwendet die Seite %1 als Anmeldeseite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286670708302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn die Seite %0 angefordert wird, werden keine weiteren \00DCberpr\00FCfungen der Authentifizierung ausgef\00FChrt, und die Seite wird angezeigt oder akzeptiert. Dadurch kann die Anmeldeseite vor der Ausf\00FChrung der Authentifizierung angezeigt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286432048302915)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'de'
,p_message_text=>'Handling der Anmeldeseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286701926302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Seiten-Sentry-Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286858222302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen mit der integrierten Logik Seiten-Sentry-Aufgaben ausf\00FChren. Die Seiten-Sentry-Funktion f\00FChrt f\00FCr jede Seitenanforderung eine Sessionverifizierung aus und berechnet den R\00FCckgabewert.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98290256763302918)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'de'
,p_message_text=>'Prozess nach der Authentifizierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98287176452302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'de'
,p_message_text=>unistr('Verwenden Sie zus\00E4tzlichen vom Benutzer zur Verf\00FCgung gestellten Code, um zu bestimmen, ob die Session g\00FCltig ist. Nachdem oben von der integrierten Pr\00FCfung f\00FCr die Sessionverifizierung TRUE zur\00FCckgegeben wird, f\00FChren Sie folgenden Code aus, und noti')
||unistr('eren Sie sich den booleschen R\00FCckgabewert:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286986682302916)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion f\00FCr die Sessionverifizierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288378509302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On-Server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98288403438302917)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'de'
,p_message_text=>'der URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435255804303037)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173628428302826)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'de'
,p_message_text=>'Datenladejob wurde gestartet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344527814302960)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'de'
,p_message_text=>unistr('%0-Dateien mit mehr als %1 MB k\00F6nnen nicht geladen werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98730138796303280)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger SQL-Ausdruck: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263981857302897)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'%0 analysieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264301424302898)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'de'
,p_message_text=>'Anzeigen nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98424484845303028)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Datumsformat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404053007303012)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'de'
,p_message_text=>'Debuggen:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404156113303012)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Feature wird in dieser Version nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401239398303009)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1101 Verarbeiten von Funktionsbody, der die Abfrage zur\00FCckgibt, nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404381127303012)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'de'
,p_message_text=>'Fehler 4323- In der Hilfe-Anforderung ist keine numerische Seiten-ID angegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401046613303009)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1025 Fehler beim Verarbeiten von PL/SQL-Ausdruck: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401131833303009)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'de'
,p_message_text=>'Anwendung=%0 Seite=%1 SQLERRM=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403826464303012)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Drucken von Shortcut nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401351274303010)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1108 Verarbeiten von aktueller Elementbedingung nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403966709303012)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Rendering von Diagramm: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98554128085303132)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Wiedergabe von Komponente nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98198207482302845)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Rendering der dynamischen Listenregion: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404216488303012)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler 4322- F\00FCr die Hilfe-Anforderung wurde die falsche Syntax verwendet. Die Anforderung war Null, wobei eine g\00FCltige Seitennummer erwartet wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430808800303033)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Binden von "%0 "nicht m\00F6glich. Verwenden Sie doppelte Anf\00FChrungszeichen f\00FCr Mehr-Byte-Elemente, oder pr\00FCfen Sie, ob die L\00E4nge des Elements maximal 30 Byte betr\00E4gt. Verwenden Sie die v()-Syntax, um Elemente zu referenzieren, die l\00E4nger sind als 30 Byt')
||'e. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968973812303478)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>'Erwartet wird ein BLOB-Spaltenname in Berichtsspalten-Formatmaske DOWNLOAD:TABLE_NAME:BLOB_COLUMN...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323545195303772)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Spalte %0 wurde in Tabelle %1 nicht gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98426542542303030)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler in DML: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98260560090302895)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren von INSERT-Vorgang nicht m\00F6glich. %0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98582077576303154)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger numerischer Wert %0 f\00FCr Spalte %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267215913302900)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Aktion %0 bei diesem Objekt. (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968005205303477)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Tabelleneigent\00FCmer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968155715303477)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967924831303477)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('Zuletzt aktualisierte Datenspalte "%0" mit Datentyp "%1" f\00FCr das \00DCberwachen von Updates zu "%2" muss den Datentyp "Datum" oder "Zeitstempel" haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968292536303477)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler: Aufruf muss von Formularseite erfolgen, die Elementnamen des Typs FILE enth\00E4lt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968544963303477)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>'Keine Formatmaske gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969050235303478)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>unistr('Erwartet wird ein Prim\00E4rschl\00FCssel 1-Spaltenname in Berichtsspalten-Formatmaske DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99323652602303772)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Tabelle oder View %0 nicht gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968844301303478)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>'Erwartet wird ein Tabellenname in Berichtsspalten-Formatmaske DOWNLOAD:TABLE_NAME...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968734189303478)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>'Formatmaske muss mindestens 4 durch Doppelpunkt getrennte Argumente enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968670117303477)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'de'
,p_message_text=>'Formatmaske muss mit DOWNLOAD oder IMAGE beginnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614119390303178)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" ist f\00FCr die SQL-Abfrage ung\00FCltig. Stellen Sie sicher, dass Sie eindeutige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259477667302894)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('Dieser Vorgang ist f\00FCr die REST-Datenquelle nicht zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614043995303178)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Falsche Anzahl von Spalten in der SQL-Abfrage ausgew\00E4hlt. In der Hilfe der Attribute finden Sie weitere Details.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169507010302822)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>'%0 hat einen falschen Datentyp in der SQL-Anweisung. Spaltennummer %1 ist %2, es wird aber %3 erwartet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715079801303267)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" wird in der SQL-Abfrage bereits verwendet. Stellen Sie sicher, dass Sie eindeutige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714914546303267)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" ist f\00FCr die SQL-Abfrage der Werteliste ung\00FCltig. Stellen Sie sicher, dass Sie g\00FCltige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714717826303267)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Parsing hat Abfrageergebnisse in "%0" zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98714871870303267)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Falsche Anzahl von Spalten in der SQL-Abfrage ausgew\00E4hlt. In der Hilfe der Attribute finden Sie weitere Details.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98169049013302822)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('REST-Datenquellentyp %0 wird nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98170962954302824)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'de'
,p_message_text=>'Doppelter Dateiname: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363384171303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'de'
,p_message_text=>'Anwendungselement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363181716303804)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'de'
,p_message_text=>'Konstante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362843104303804)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363902613303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'de'
,p_message_text=>unistr('Schl\00FCsselwort')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363832926303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'de'
,p_message_text=>'Materialized View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363402600303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'de'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363225860303804)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'de'
,p_message_text=>'Seitenelement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362773158303804)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'de'
,p_message_text=>'Prozedur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363561781303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363694813303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99364006643303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99362927115303804)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363087164303804)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'de'
,p_message_text=>'Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99363782836303805)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927960957303440)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'de'
,p_message_text=>'Die SQL-Abfrage der Werteliste konnte nicht geparst werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98692729442303248)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Abfragefilter weitergeleitet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928860841303441)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" wird in der SQL-Abfrage der Werteliste bereits verwendet. Stellen Sie sicher, dass Sie eindeutige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928764530303440)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" ist f\00FCr die SQL-Abfrage der Werteliste ung\00FCltig. Stellen Sie sicher, dass Sie g\00FCltige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98927831774303439)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('In der SQL-Abfrage der Werteliste ist eine falsche Anzahl von Spalten ausgew\00E4hlt. G\00FCltige Anweisungen siehe Beispiele.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267036567302900)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'de'
,p_message_text=>'Beim Server ist ein Fehler beim Entfernen von Datei "%0" aufgetreten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267106467302900)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'de'
,p_message_text=>unistr('Entfernen von Datei %0 nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266808525302900)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Schreiben in das physische Dateiverzeichnis "%0". (%1: %2)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402318741303010)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'de'
,p_message_text=>unistr('Maximaler Grenzwert f\00FCr die Gr\00F6\00DFe von nicht internen Workspace-Dateien wurde \00FCberschritten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266958851302900)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist keine Datei zum Schreiben f\00FCr ID %0 vorhanden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98402226381303010)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Maximaler Grenzwert f\00FCr die Gr\00F6\00DFe von allen Workspace-Dateien wurde \00FCberschritten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98435545438303037)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim L\00F6schen von Entwicklerrolle. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311551015302936)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'de'
,p_message_text=>'Der Benutzer kann aus folgendem Grund nicht erstellt werden: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98976103700303484)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ist eine ung\00FCltige E-Mail-Adresse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429239388303032)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'de'
,p_message_text=>'Element %0 vom Typ <b>select list</b> mit JS-Umleitung hat keine Abfrage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429130105303032)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'de'
,p_message_text=>'Element %0 vom Typ <b>select list</b> hat keine Abfrage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429358378303032)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'de'
,p_message_text=>'Element %0 vom Typ <b>select list</b> mit URL-Umleitung hat keine Abfrage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429463128303032)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>'Element %0 vom Typ <b>select list</b> mit URL-Umleitung zur Seite hat keine Abfrage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403717847303012)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'de'
,p_message_text=>'Element %0 bearbeiten - %1 , Sequenz: %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400870427303009)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1904 Berechnen von Elementstandard nicht m\00F6glich: type = Function Body computation_type= %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400707674303009)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1020 Fehler beim Verarbeiten von PLSQL-Element (Funktion).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98400984574303009)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'de'
,p_message_text=>unistr('Rechtschreibpr\00FCfung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98403634599303012)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Konvertieren von Wert "%0" in Datumsformatmaske %1 nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168776590302822)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Elemente mit Datentyp BLOB werden f\00FCr REST-f\00E4hige SQL- oder REST-Datenquelle nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168919003302822)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'de'
,p_message_text=>unistr('Metadaten f\00FCr Regions-ID %s k\00F6nnen nicht abgerufen werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98648971185303205)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'de'
,p_message_text=>'Formular-DML- oder Initialisierungsprozess wurde keine Formularregion zugewiesen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654619164303210)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Migrieren von Legacy-Formularseite zu Formularregion: In DML-Prozess referenzierte Tabelle kann nicht beschrieben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98385826806302996)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Pr\00FCfsumme f\00FCr das Erkennen von verlorenen Updates gefunden. F\00FCr vorhandene Zeilen kann nur UPDATE oder DELETE ausgef\00FChrt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98955214473303467)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Formular-DML kann in einer REST-Quelle mit aktivierter Synchronisierung nicht ausgef\00FChrt werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168619894302822)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Formularregion %0 wurde kein Prim\00E4rschl\00FCsselelement definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98168896392302822)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'de'
,p_message_text=>'Element %0 hat den falschen Datentyp.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98336872924302955)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Es gibt einen Domainindex im ausgew\00E4hlten %0. Der Befehl "DDL generieren" kann kein DDL f\00FCr den Domainindex generieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275340339302906)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Rem Generieren von DDL f\00FCr %0 %1 nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98306001685302931)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'de'
,p_message_text=>'%0 zum Generieren von DDL nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275501316302907)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'de'
,p_message_text=>'Save_ddl-Fehler %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98263199826302897)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Speichern von DDL als Skriptdatei nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275461209302907)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Parsen von DDL-Skript. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429548712303032)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler: Packagename %0 ist ung\00FCltig oder bereits vergeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410692025303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('-- Tabellen-API f\00FCr Anwendung %0, %1 generiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409360869303016)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'PL/SQL-Package %0 mit folgenden Prozeduren erstellen:',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410217817303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'de'
,p_message_text=>unistr('Zum Einf\00FCgen von Daten in %0. Der Prim\00E4rschl\00FCssel muss angegeben werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410362463303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'de'
,p_message_text=>unistr('Hiermit k\00F6nnen Sie Daten in %0 aktualisieren, die nach Prim\00E4rschl\00FCssel angegeben werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410415283303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'de'
,p_message_text=>unistr('verwenden, um Daten anhand von Prim\00E4rschl\00FCsseln aus %0 zu l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410516238303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'de'
,p_message_text=>unistr('Zum Abrufen von Daten anhand von Prim\00E4rschl\00FCsseln aus %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410159189303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409916556303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'de'
,p_message_text=>'Body herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409892058303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'de'
,p_message_text=>'Spezifikation herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409720955303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'de'
,p_message_text=>'Body ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409548842303016)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'de'
,p_message_text=>'Spezifikation ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483351824303076)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'de'
,p_message_text=>'-- Package Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483476388303076)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'de'
,p_message_text=>'-- Package-Spezifikation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409686862303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'de'
,p_message_text=>'Body anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409467297303016)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'de'
,p_message_text=>'Spezifikation anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98410088131303017)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'de'
,p_message_text=>'Unterprogramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482883037303075)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('-- Prozedur f\00FCr Tabelle "%0" erstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483090244303075)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('-- Prozedur f\00FCr Tabelle "%0" l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483111907303075)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('-- Prozedur f\00FCr Tabelle "%0" abrufen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98483204354303076)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('-- MD5-Funktion f\00FCr Tabelle "%0" erstellen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98482941004303075)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'de'
,p_message_text=>unistr('-- Prozedur f\00FCr Tabelle "%0" aktualisieren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429629122303032)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967397680303476)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'de'
,p_message_text=>'Quell-ID des Workspace muss definiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967490521303476)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'de'
,p_message_text=>'Deployment-System muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307624859302933)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Komponente <strong>%0</strong> kann in <strong>Spalte %1</strong> nicht wiedergegeben werden, weil bereits eine andere Komponente in dieser Spalte vorhanden ist.</p>',
unistr('<p>Durch Festlegung der Spalte auf <strong>Automatisch</strong> wird dieses Problem im Allgemeinen gel\00F6st.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99411928113303846)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Label von Seitenelement <strong>%0</strong> kann nicht wiedergegeben werden, weil die Grid-Einstellung des Labelspaltenbereichs f\00FCr dieses Seitenelement ung\00FCltig ist. Sie ist zur Anzeige mit einem<strong>Labelspaltenbereich von %1</strong> festgel')
||unistr('egt. Dies wird nicht unterst\00FCtzt, weil das Seitenelement selbst nur <strong>%2 Spalte(n)</strong> zur Verf\00FCgung hat.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307421667302933)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Komponente <strong>%0</strong> kann nicht wiedergegeben werden, weil die Grid-Einstellungen f\00FCr diese Komponente ung\00FCltig sind. Sie sind auf eine Anzeige mit <strong>Spalte %1</strong> mit einem <span>Spaltenbereich von %2</strong> festgelegt. Die')
||unistr('s wird nicht unterst\00FCtzt, weil das Grid auf dieser Seite nur maximal <strong>%3 Spalten</strong> unterst\00FCtzt.</p>'),
unistr('<p>Durch Festlegung der Spalte und des Spaltenbereichs auf <strong>Automatisch</strong> f\00FCr alle Komponenten wird dieses Problem im Allgemeinen gel\00F6st.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307514142302933)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Komponente <strong>%0</strong> kann nicht wiedergegeben werden, weil die Grid-Einstellungen f\00FCr diese Komponente ung\00FCltig sind. Sie sind auf eine Anzeige mit <strong>Spalte %1</strong> mit einem <strong>Spaltenbereich von %2</strong> festgelegt. D')
||unistr('ies wird nicht unterst\00FCtzt, weil das Grid auf dieser Seite nur maximal <strong>%3 Spalten</strong> unterst\00FCtzt.</p>'),
unistr('<p>Durch Festlegung der Spalte und des Spaltenbereichs auf <strong>Automatisch</strong> f\00FCr alle Komponenten wird dieses Problem im Allgemeinen gel\00F6st.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189640411302838)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'de'
,p_message_text=>'2 Day DBA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189500184302838)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'de'
,p_message_text=>'2 Day + Developer''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98155960766302811)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'de'
,p_message_text=>'Application Administration Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156049705302811)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'de'
,p_message_text=>'API-Referenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731819502303281)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'de'
,p_message_text=>'Inhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98725899646303276)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'de'
,p_message_text=>'Info: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731900606303281)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'de'
,p_message_text=>'Suchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98189439407302838)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'de'
,p_message_text=>'App Builder User''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837881504303365)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'de'
,p_message_text=>'Das erstmalige Erstellen des Index kann einige Sekunden dauern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156148320302811)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'de'
,p_message_text=>'Application Migration Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98731617618303281)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'de'
,p_message_text=>unistr('Datei f\00FCr Dokumentationszuordnung nicht gefunden: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98732060083303282)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'de'
,p_message_text=>'Bewertung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98156299218302811)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'de'
,p_message_text=>'SQL Workshop and Utilities Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438798941303039)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'de'
,p_message_text=>'Create Normalize-Fehler: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98614935546303179)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Sie haben keinen Zugriff auf das Schema, das Sie importieren. Import nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438600674303039)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'de'
,p_message_text=>'remove_table_hint wurde ohne p_table_id aufgerufen. Es muss eine Tabelle angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344419061302960)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hrend der Workspace-Installation ist ein zweiter create_company-Aufruf aufgetreten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307270095302932)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'de'
,p_message_text=>'GET_BLOCK-Fehler. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307163665302932)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'de'
,p_message_text=>'GET_STMT-Fehler. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307304589302933)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'de'
,p_message_text=>'Datei nicht gefunden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173411209302826)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('ZIP-Archiv nicht g\00FCltig, keine Installationsmanifestdatei gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310765640302935)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'de'
,p_message_text=>'Sie haben keine Berechtigungen auf dem %0-Schema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98307026430302932)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Die Ausf\00FChrung der Anweisung war nicht erfolgreich. %0<pre>%1</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98347024239302962)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'de'
,p_message_text=>unistr('API-Aufruf f\00FCr die remove_page-Prozedur in einem gro\00DFen Block der Exportdatei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98608361742303174)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr dieses Element ist kein Label verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225148156302866)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'de'
,p_message_text=>unistr('Bei Ihrer Umgebung liegt ein Problem vor, weil die Application Express-Dateien nicht auf dem neuesten Stand sind. Die Dateien f\00FCr Version #LOADED_VERSION# wurden geladen, jedoch wird %0 erwartet. Pr\00FCfen Sie, ob Sie das Images-Verzeichnis in Ihren Anw')
||'endungsserver kopiert haben, wie im Installation Guide angegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98225072708302866)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'de'
,p_message_text=>unistr('Bei Ihrer Umgebung liegt ein Problem vor, weil die Application Express-Dateien nicht geladen wurden. Pr\00FCfen Sie, ob Sie das Images-Verzeichnis in Ihren Anwendungsserver kopiert haben, wie im Installation Guide angegeben. Pr\00FCfen Sie au\00DFerdem, ob der I')
||unistr('mage-Pr\00E4fixpfad korrekt ist. Ihr aktueller Pfad ist %0 (er muss sowohl die f\00FChrenden als auch die abschlie\00DFenden Schr\00E4gstriche enthalten, wie der Standardpfad /i/). Verwenden Sie das SQL-Skript reset_image_prefix.sql, wenn sie ihn \00E4ndern m\00FCssen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428647137303032)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Unberechtigter Versuch, Job %0 pro Schema %1 in Anwendung %2 auszuf\00FChren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439206693303040)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Collection nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438897636303040)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98438922382303040)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Suchen von Datentyp: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439119827303040)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Abrufen von Datentyp: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439083830303040)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler1 beim Abrufen der maximalen Spaltenl\00E4nge: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626937920303188)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'de'
,p_message_text=>unistr('Einf\00FCgen von Zeile mit mehr als 32 KB Daten nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439367169303040)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer %0 hat keine Berechtigungen f\00FCr das %1-Schema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430317243303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Bedingungstyp f\00FCr Seitenverzweigung nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430239374303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Bedingungstyp f\00FCr Seitenschaltfl\00E4che nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430001498303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Anwendungsberechnungstyp nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429981343303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Anwendungsprozess bei Bedingungstyp nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430769748303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Aktualisieren von falsch geschriebenen W\00F6rtern. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429804028303032)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Bedingungstyp f\00FCr die Anzeige der Navigationsleiste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430469150303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Berechnungstyp nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430636392303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Seitenprozesstyp nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430140115303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Typ f\00FCr die Seitenuntertitel nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430528627303033)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisieren von Seitenvalidierungstyp nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98977251576303485)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'de'
,p_message_text=>unistr('%0: "\00DCberlappende \00FCbergeordnete Wertelistenelemente" kann nur verwendet werden, wenn "Lazy Loading" auf "Ja" gesetzt ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968496429303477)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler: Es kann h\00F6chstens ein DML-Prozess pro Seite deklariert werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98968307826303477)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler: Kein entsprechender DML-Prozess f\00FCr Seite %0 gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98969436015303478)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 muss eine g\00FCltige BLOB-Spalte als Quelle haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930188074303442)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Element %0 muss ein PL/SQL-Code angegeben werden, der HTML ver\00F6ffentlicht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440218589303041)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Bulk Collect nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439900165303040)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Es kann nicht gepr\00FCft werden, ob der Code geparst wurde: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440014201303040)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren von Kontrolldatei nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440702894303041)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfen von Kontrolldatei-Statistiken nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440675422303041)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von geparsten Informationen nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440568234303041)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anweisung konnte nicht erfolgreich ausgef\00FChrt werden: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439470387303040)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'de'
,p_message_text=>'Datei nicht gefunden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439680219303040)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen von Anweisung %0 nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405795636303013)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenl\00E4nge %0 \00FCberschreitet Maximum %1 bei Zeile %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440403538303041)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'de'
,p_message_text=>'Warnung: Package Body wurde mit Kompilierungsfehlern erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440189139303041)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren von Code nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440349871303041)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren von Anweisung nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439743211303040)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Speichern von Parameter in Datenbank nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439506447303040)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen von Codeblock nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98439838969303040)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validieren der Datei "%0" nicht m\00F6glich. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440871586303041)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Parsen von Datei nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823229784303355)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Plug-in %0 wurde keine Authentifizierungsfunktion definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823343103303355)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Plug-in %0 wurde keine Post-Abmelde-Funktion definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98823129234303355)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Plug-in %0 wurde keine Session-Sentry-Funktion definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376470489303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'de'
,p_message_text=>'Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375606893303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'de'
,p_message_text=>'Von dynamischer Aktion definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375372329303814)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Zu Seite in dieser Anwendung umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375585839303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'de'
,p_message_text=>'Zu URL umleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375416834303814)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Seite senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376060137303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'de'
,p_message_text=>unistr('Cacheinhalt l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928051493303440)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfrage der Werteliste ist ung\00FCltig. Ein Anzeige- und ein R\00FCckgabewert sind erforderlich. Au\00DFerdem d\00FCrfen die Spaltennamen nicht identisch sein. Wenn Ihre Abfrage eine Inline-Abfrage enth\00E4lt, darf die erste FROM-Klausel der SQL-Anweisung kein Bes')
||'tandteil der Inline-Abfrage sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929722658303442)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'de'
,p_message_text=>'Die Abfrage der Regionsquelle kann nicht geparst werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310829941302935)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage konnte nicht geparst werden.  %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99399395319303835)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'de'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928106337303440)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Die statische Werteliste ist ung\00FCltig. Ein Anzeige- und ein R\00FCckgabewert sind erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98863766333303386)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'de'
,p_message_text=>'Tabelle, View oder Synonym ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310376661302935)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'de'
,p_message_text=>unistr('- Ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928465325303440)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Elemente dieses Anzeigetyps muss eine Abfrage der Werteliste (LOV) oder eine benannte Werteliste angegeben werden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928344973303440)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Eine benannte Werteliste (LOV) wird nur f\00FCr Elementtypen unterst\00FCtzt, f\00FCr die mindestens zwei Wertelistenspalten erforderlich sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311085148302935)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'de'
,p_message_text=>'Der Wert muss eine Ganzzahl sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98310971809302935)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'de'
,p_message_text=>'Der Wert muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375748725303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'de'
,p_message_text=>'Seite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236651742302875)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte hat den falschen Datentyp. F\00FCr dieses Attribut muss die Spalte einen der folgenden Datentypen haben: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98224947494302866)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte ist nicht vorhanden, oder Abfrage der Regionsquelle ist ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236765194302875)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>'falscher Datentyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929346606303441)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Regionen mit diesem Regionstyp muss eine Regionsquelle angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929437442303441)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" wird in der Abfrage der Regionsquelle bereits verwendet. Stellen Sie sicher, dass Sie eindeutige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929524979303441)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" ist f\00FCr die Abfrage der Regionsquelle ung\00FCltig. Stellen Sie sicher, dass Sie eindeutige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929630823303441)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('In der Abfrage der Regionsquelle ist die falsche Anzahl von Spalten ausgew\00E4hlt. G\00FCltige Anweisungen siehe Bespiele.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375931896303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'de'
,p_message_text=>'Anfordern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99375875350303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenumbruch f\00FCr diese Seite zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376104360303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Diese Elemente festlegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98929008062303441)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" wird in der SQL-Abfrage bereits verwendet. Stellen Sie sicher, dass Sie eindeutige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928971230303441)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Der Spaltenname "%0" ist f\00FCr die SQL-Abfrage ung\00FCltig. Stellen Sie sicher, dass Sie eindeutige Aliasnamen f\00FCr Ihre Spalten verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98311982831302936)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('Falsche Anzahl von Spalten in der SQL-Abfrage ausgew\00E4hlt. In der Hilfe der Attribute finden Sie weitere Details.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98928200528303440)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Statische Werteliste (LOV) wird nur f\00FCr Elementtypen unterst\00FCtzt, f\00FCr die mindestens zwei Wertelistenspalten erforderlich sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376377033303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'de'
,p_message_text=>'URL-Ziel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99376274046303815)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'de'
,p_message_text=>'Mit diesen Werten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98430921972303033)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1711 Popup-Wertelisten-ID kann in Anforderung nicht konvertiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431054504303033)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1721 Element f\00FCr Popup-Wertelisten-ID in Anforderung nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98204828341302850)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'de'
,p_message_text=>'Die Druck-Engine konnte nicht erreicht werden, weil entweder der angegebene URL falsch ist oder ein Proxy-URL angegeben werden muss.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109438019303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber der Region')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109886341303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'de'
,p_message_text=>'Unter der Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109993061303593)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'de'
,p_message_text=>'Unten auf der Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109566975303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'de'
,p_message_text=>'Links neben Titel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109142708303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'de'
,p_message_text=>'Rechts neben der Suchleiste des interaktiven Berichts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109632365303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'de'
,p_message_text=>'Rechts neben Titel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109766719303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Regionsstandard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109280857303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'de'
,p_message_text=>'Am Anfang der Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99109338418303592)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'de'
,p_message_text=>'Am Anfang und unten auf der Region'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110090781303593)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'de'
,p_message_text=>'Nach Header'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110139010303593)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Vor Footer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332671674303779)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Komponente nicht gefunden. Sie wurde m\00F6glicherweise von einem anderen Benutzer gel\00F6scht. Laden Sie die Seite neu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332589250303779)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen nicht m\00F6glich, weil Komponente ''%0'' diese Komponente referenziert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332401404303779)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen nicht m\00F6glich, weil Komponente ''%0'' auf Seite %1 diese Komponente referenziert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332773628303779)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Attribut wurde bereits von einem anderen Benutzer ge\00E4ndert. Laden Sie die Seite neu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332906789303779)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Attribut ist in diesem Kontext nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99332807324303779)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Komponente wurde von einem anderen Benutzer ge\00E4ndert und dieses Attribut ist nicht mehr vorhanden. Laden Sie die Seite neu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827190024303357)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Parsing hat Abfrageergebnisse in "%0" zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419771874303852)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Parsing hat Abfrageergebnisse in "%0" zur\00FCckgegeben. Wenn Sie der Meinung sind, dass Ihre Abfrage syntaktisch korrekt ist, aktivieren Sie das Kontrollk\00E4stchen "Generische Spaltennamen verwenden", um ohne Parsen fortzufahren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99371160813303811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Muss eindeutig sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110264358303593)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>'Kein Template'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827098590303357)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Von dem PL/SQL-Block wurde keine Abfrage zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99419824512303853)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Von PL/SQL-Block wurde keine Abfrage zur\00FCckgegeben. Wenn Sie der Meinung sind, dass Ihr Code syntaktisch korrekt ist, aktivieren Sie das Kontrollk\00E4stchen "Generische Spaltennamen verwenden", um ohne Parsen fortzufahren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110473059303593)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Seite ist von einem anderen Benutzer gesperrt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99110373110303593)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Seite ist aktuell von %0 gesperrt. \00C4nderungen k\00F6nnen nicht gespeichert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98717337917303269)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'de'
,p_message_text=>unistr('Der Tablespace konnte nicht erweitert werden, weil f\00FCr %0 keine Schemas mehr vorhanden sind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431157742303034)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler in drop_tablespace. p_name ist Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431333834303034)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler in drop_user. Kein l_username.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99426745109303858)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('Das Verschl\00FCsselungs-Wallet ist nicht ge\00F6ffnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98229970810302870)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'de'
,p_message_text=>unistr('An wwv_flow_provision.create_user wurde unzul\00E4ssige Kennwortzeichenfolge \00FCbergeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431937733303034)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler in remove_provisioned_company. Workspace ist Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431746695303034)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'de'
,p_message_text=>'Tablespace kann nicht erstellt werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431674610303034)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'de'
,p_message_text=>'Benutzer kann nicht erstellt werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431223131303034)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Tablespace nicht m\00F6glich. Fehler: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431463131303034)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Benutzer nicht m\00F6glich. Fehler: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431890445303034)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Erteilen von Ausgangsberechtigungen nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98196181841302843)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Tablespace kann derzeit nicht erstellt werden. F\00FChren Sie den Vorgang sp\00E4ter erneut aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98431525120303034)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler mit: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274592757302906)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'de'
,p_message_text=>unistr('Das automatische Provisioning war w\00E4hrend der "MAKE_REQUEST"-Phase nicht erfolgreich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294151377302922)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bestimmen der Sicherheitsgruppen-ID f\00FCr die angegebene Workspace-ID = "%0" nicht m\00F6glich'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274861935302906)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'de'
,p_message_text=>'Der Workspace %0 ist ein reservierter Name. Die Anforderung wurde verweigert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274604820302906)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Beim Hinzuf\00FCgen eines Benutzers zum Workspace %0 ist ein Fehler aufgetreten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98432252066303034)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98414060392303020)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'de'
,p_message_text=>'Nicht implementiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274320911302906)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'de'
,p_message_text=>'Es wurde kein Workspace mit folgender Workspace-ID gefunden: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274484066302906)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurde kein Schema f\00FCr die Workspace-ID zugeordnet: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294206947302922)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen mit dieser Funktion nicht das letzte Schema eines Workspace entfernen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275262308302906)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Anforderung %0 nicht gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275043074302906)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'de'
,p_message_text=>'Die Anforderung %0 konnte nicht verarbeitet werden. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274778927302906)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'de'
,p_message_text=>'Diese Anforderung wurde verarbeitet oder wird gerade verarbeitet. Der Status muss "%0" lauten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294556399302922)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'de'
,p_message_text=>'Der Benutzername %0 ist in Workspace %1 nicht vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294424608302922)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Es ist nicht zul\00E4ssig, das Kennwort f\00FCr ein Schema zur\00FCckzusetzen, das nicht Ihrem Workspace zugeordnet ist. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98294307267302922)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen von Kennwort f\00FCr Schema %0 nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275156647302906)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Die Anforderung %0 konnte nicht verarbeitet werden, weil das Schema %1 in der %2-Tabelle vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274961562302906)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'de'
,p_message_text=>'Der Schemaname %0 ist ein reserviertes Schema und kann nicht durch Provisioning bereitgestellt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98274219632302906)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Benutzer %0 besitzt keine Zugriffsberechtigung auf das %1-Schema.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234281265302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'de'
,p_message_text=>'%0-Analyse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237084139302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'de'
,p_message_text=>'Analysieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98219910224302862)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'de'
,p_message_text=>'Verwenden Sie Datenbankaccount-Zugangsdaten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98251079126302886)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'de'
,p_message_text=>'Zugangsdaten von internem %0 Account und Anmeldeseite in dieser Anwendung verwenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98930326521303442)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Server Single Sign-On verwenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234300892302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'de'
,p_message_text=>'%0-Diagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234193446302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('W\00E4hlen Sie eine Spalte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236364461302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen von Cacheinhalt nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99313925289303763)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'#COLUMN_HEADER# muss einen Wert aufweisen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264457459302898)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Analyseseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282684373302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Schaltfl\00E4chen-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283448332302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Diagrammseite nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282068676302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen der Anwendung nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283871062302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Homepage nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283245531302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Einf\00FCgeformular nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282235498302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Labeltemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283958991302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Liste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284056648302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Listenelement nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98281919289302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Listentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283039491302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'de'
,p_message_text=>'Navigationspfad kann nicht erstellt werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282579492302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Navigationspfad-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284478593302914)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Modulen nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282935442302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Navigationsleiste nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234551720302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'de'
,p_message_text=>'%0 neu erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237241281302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'de'
,p_message_text=>'Neu erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282107948302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Seitentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282487667302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Regionstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283197655302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Berichtsseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282398630302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Berichtstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284109622302914)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Erfolgsseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282879547302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Standardregisterkarten nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98283352755302913)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Aktualisierungsformular nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236223842302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'de'
,p_message_text=>'Arbeitsblatt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314135173303764)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('#COLUMN_HEADER# muss ein g\00FCltiges Datum sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284210073302914)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'de'
,p_message_text=>'Definieren Sie die Standardtemplates zu Erstellen der Anwendung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238797197302877)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigen von Seitenregion nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235738644302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Auf dieser Seite wird die Hilfe f\00FCr eine Seite angezeigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236001441302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'de'
,p_message_text=>unistr('%0 einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234476769302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'de'
,p_message_text=>unistr('Einf\00FCgeformular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235298369302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'de'
,p_message_text=>unistr('Weiteres Element einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236515232302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Einf\00FCgen von Zeile in %0 nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235120917302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Daten wurden erfolgreich eingef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98698343989303252)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss ein g\00FCltiges Datum sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234953069302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss eine Zahl sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634504844303194)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss ein g\00FCltiger Zeitstempel sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235982905302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'de'
,p_message_text=>'%0 Navigationspfad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234832542302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'%0 Name muss einen Wert haben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314077293303763)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'de'
,p_message_text=>'#COLUMN_HEADER# muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98282793170302912)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Template f\00FCr Popup-Werteliste nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98237111631302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'de'
,p_message_text=>'Melden und bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236183373302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigen von Bericht nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98236462657302875)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen von Seitennummerierung nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235434693302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zur Homepage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235833151302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zur vorherigen Seite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233938066302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suchbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99351031074303795)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'de'
,p_message_text=>'Alle Anwendungen durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350294494303794)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'de'
,p_message_text=>'Anwendung durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350022948303794)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'de'
,p_message_text=>'Team Development durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99350749809303794)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'de'
,p_message_text=>'Benutzer suchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234073723302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'de'
,p_message_text=>'Diagramm anzeigen nach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98238465171302876)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Anzeigen von Navigationspfad nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235593166302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Erfolg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235071951302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'de'
,p_message_text=>'Erfolgsseite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99314263549303764)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('#COLUMN_HEADER# muss ein g\00FCltiger Zeitstempelwert sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234780754302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'de'
,p_message_text=>'%0 aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98234687656302873)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'de'
,p_message_text=>'Aktualisierungsformular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284398535302914)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen die Anwendung nur mit einer Registerkarte f\00FCr eine Ebene erstellen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98235396913302874)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265494021302899)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'de'
,p_message_text=>'Info'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98265527360302899)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'de'
,p_message_text=>'Verzweigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429705916303032)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255768261302890)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Bei einer verschachtelten Liste wird nur "Clientseitig" als Suchtyp unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417825218303023)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'de'
,p_message_text=>'Unerwarteter Fehler %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98401420204303010)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'de'
,p_message_text=>'Warnung: Baum-Root-ID "%0" nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613787121303178)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler im PLSQL-Code, der w\00E4hrend der Remote-SQL-Verarbeitung ausgel\00F6st wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173763526302826)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'de'
,p_message_text=>'Kartenseite kann nicht erstellt werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98755538569303302)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Instanz ist der Zugriff mit REST nicht aktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753828393303300)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Die Region konnte nicht gefunden werden oder ist nicht REST-f\00E4hig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98753980870303300)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'de'
,p_message_text=>'Es wurde keine Ausgabemethode angegeben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404400243303012)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Workspace erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404575028303012)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Anwendung erforderlich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404618561303013)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Benutzername "%0" bzw. ung\00FCltiges Kennwort.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633964839303194)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 neue Attribute wurden eingef\00FCgt. Es ist m\00F6glicherweise eine \00DCbersetzung erforderlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634075231303194)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Attribute wurden gel\00F6scht, und es ist keine \00DCbersetzung mehr erforderlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266336619302899)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim L\00F6schen von Ausgangswert: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266238905302899)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Einf\00FCgen von Ausgangswert: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634104398303194)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'de'
,p_message_text=>unistr('Insgesamt %0 Attribute aktualisiert, f\00FCr die m\00F6glicherweise eine \00DCbersetzung erforderlich ist')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266108425302899)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('%0 \00DCbersetzung von Anwendung %1 nicht gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98633871636303194)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 vorhandene Attribute aktualisiert. Es ist m\00F6glicherweise eine \00DCbersetzung erforderlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98440919119303041)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98704352159303257)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'de'
,p_message_text=>'Kein Index auf %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635008411303194)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'de'
,p_message_text=>unistr('<b id="incompl_success_row_count"></b> neue Dokumente wurden an Daten in Collection <code>%0</code> angeh\00E4ngt. <b class="u-danger-text" id="incompl_fail_row_count"></b> Dokumente wurden abgelehnt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634807973303194)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('<b id="success_row_count"></b> neue Dokumente wurden an Daten in Collection <code>%0</code> angeh\00E4ngt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172882400302825)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'de'
,p_message_text=>'Inhalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635228488303195)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Gr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173031307302825)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'de'
,p_message_text=>'Erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172768664302825)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'de'
,p_message_text=>unistr('Schl\00FCssel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98173166274302825)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'de'
,p_message_text=>unistr('Zuletzt ge\00E4ndert am')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172992461302825)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'de'
,p_message_text=>'Medientyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178151214302829)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Datentabelle nicht verf\00FCgbar. Entweder enth\00E4lt die Collection keine Daten, oder es wurde noch kein JSON-Suchindex erstellt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98172021565302824)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'de'
,p_message_text=>'Laden Sie JSON-, TXT- oder ZIP-Dateien hoch.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98178213391302829)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Collection-Metadaten sind nicht verf\00FCgbar. Pr\00FCfen Sie den Collection-Namen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635166550303195)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'de'
,p_message_text=>'Daten in Collection <code>%0</code> wurden durch <b id="incompl_success_row_count"></b> neue Dokumente ersetzt. <b class="u-danger-text" id="incompl_fail_row_count"></b> Dokumente wurden abgelehnt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98634987526303194)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>'Daten in Collection <code>%0</code> wurden durch <b id="success_row_count"></b> neue Dokumente ersetzt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418709628303024)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Achsenintervall muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418520016303023)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Maximum der Achse muss gr\00F6\00DFer als das Minimum der Achse sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418926363303024)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Maximum der Achse muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418883296303024)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Minimum der Achse muss gr\00F6\00DFer oder gleich 0 sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418674445303023)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Die Balkenbreite muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418216405303023)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420294815303025)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Abrufen: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420084169303025)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion, die SQL-Abfrage zur\00FCckgibt: Die Abfrage kann innerhalb von App Builder nicht geparst werden. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419123686303024)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Der Abstand zwischen den Balken muss gr\00F6\00DFer oder gleich 0 sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418330478303023)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Die maximale Anzahl der anzuzeigenden Zeilen muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420562920303025)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Weitere Daten gefunden. Es k\00F6nnen jedoch nur maximal 30 Werte angezeigt werden.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420175637303025)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Parsen: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420471371303025)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'de'
,p_message_text=>'SVG-Diagrammfehler: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98420323576303025)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Berechnen von Position f\00FCr Seite null von Diagramm nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419952246303025)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen von Farbe %0 nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419319414303024)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das X-Achsenintervall muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419748524303024)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Maximum der X-Achse muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419551996303024)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Minimum der X-Achse muss gr\00F6\00DFer oder gleich 0 sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419454829303024)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Y-Achsenintervall muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419233137303024)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Maximum der Y-Achse muss gr\00F6\00DFer als das Minimum der Achse sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419897489303024)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Maximum der Y-Achse muss gr\00F6\00DFer als Null sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98419651907303024)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Validierung nicht erfolgreich: Das Minimum der Y-Achse muss gr\00F6\00DFer oder gleich 0 sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416498545303022)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Hinzuf\00FCgen von Member')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220674476302862)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'de'
,p_message_text=>unistr('%0-Befehl blockiert. Ausf\00FChrung aus SQL Workshop nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413392286303019)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'de'
,p_message_text=>unistr('Der Benutzer %0 hat keine Berechtigungen f\00FCr das %1-Schema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233368476302872)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'de'
,p_message_text=>unistr('Das Schema %0 hat keine Auswahlberechtigungen f\00FCr die Tabelle oder View %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416668422303022)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Skript.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413473777303019)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'de'
,p_message_text=>'Plantabelle zur einfachen Erstellung der Explain-Plan-Anweisung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413975409303020)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Erstellen von Skriptdatei.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413564378303020)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'de'
,p_message_text=>'Fehler in Zeile %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413755084303020)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Einf\00FCgen von Skript in Dateitabelle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99361808552303803)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Zeilen-ID: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413841496303020)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Parsen von Skript.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98413649463303020)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'de'
,p_message_text=>'Das Schema "%0" ist in der Datenbank nicht vorhanden. Wenden Sie sich bzgl. des korrekten Standardschemas an Ihren Workspace-Administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214124327302857)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'de'
,p_message_text=>'Fehler in run_sql_arr. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416552614303022)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Aktualisieren von Mitglied.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98233269255302872)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'de'
,p_message_text=>unistr('Die Skriptzeile \00FCberschreitet 32767 Byte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200143194302846)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'de'
,p_message_text=>'Abgebrochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448928343303048)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201107959302847)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201522660302847)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'de'
,p_message_text=>'%0 Sekunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200260808302846)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'de'
,p_message_text=>unistr('Wird ausgef\00FChrt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98259057763302893)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ausf\00FChrung eines Skripts mit unbekannten Anweisungen angefordert. Entfernen Sie die folgenden Anweisungen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201220845302847)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'In Arbeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98258994707302893)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'de'
,p_message_text=>'Zeilennummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220515506302862)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1004 Skripts k\00F6nnen maximal auf %0 Ebenen verschachtelt sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221862609302863)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1005 Die Skriptausgabe hat die maximale Gr\00F6\00DFe erreicht. Legen Sie fest, dass Ihr Skript eine geringere Ausgabe generiert, oder bitten Sie den Administrator, die maximale Gr\00F6\00DFe f\00FCr das Skriptergebnis zu erh\00F6hen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550094519303129)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Das Skript \00FCberschreitet die maximal zul\00E4ssige Gr\00F6\00DFe von %0 Byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98221963768302863)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1005 Die Skriptausgabe hat die maximale Gr\00F6\00DFe f\00FCr das Workspace-Ergebnis erreicht. L\00F6schen Sie vorhandene Ergebnisse, oder bitten Sie den Administrator, die maximale Gr\00F6\00DFe f\00FCr das Workspace-Ergebnis zu erh\00F6hen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98485084542303077)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Anweisung im Puffer, die ausgef\00FChrt werden kann.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98215871116302858)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'de'
,p_message_text=>unistr('SELECT-Anweisung darf nicht gr\00F6\00DFer sein als 32 KB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201381886302847)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'de'
,p_message_text=>'%0 Zeile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98201465692302847)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'de'
,p_message_text=>'%0 Zeilen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98216726535302859)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zeilen ausgew\00E4hlt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98444021934303044)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ausf\00FChrung eines Skripts angefordert, das keine ausf\00FChrbaren Anweisungen enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98213934572302857)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren von Skript nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98214096337302857)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler in run_statement. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98443952181303044)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die Ausf\00FChrung eines Skripts mit Anweisungen angefordert, die von SQL Workshop ignoriert werden. Bitte best\00E4tigen Sie Ihre Auswahl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98220489258302862)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'ERR-1001 Skript nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200075083302846)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'de'
,p_message_text=>'Weitergeleitet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448412471303047)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'de'
,p_message_text=>'Unbekannte Anweisung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98448285215303047)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'de'
,p_message_text=>'%0% verwendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433908832303036)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen des Packages aufgrund ung\00FCltiger SQL-Syntax nicht erfolgreich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98433636054303035)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen der Tabelle aufgrund ung\00FCltiger SQL-Syntax nicht erfolgreich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266549517302900)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'de'
,p_message_text=>'Synchronisierungsfehler: %0.%1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98590091553303160)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'de'
,p_message_text=>'Referenziert von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98589901611303160)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'de'
,p_message_text=>'Referenzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98264826598302898)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurde versucht, auf eine tabellarische Formularspalte zuzugreifen, die dem PL/SQL-Array apex_application.g_f%0 zugeordnet w\00FCrde, es werden jedoch nur %1 Spalten unterst\00FCtzt, die Status speichern. Reduzieren Sie die Anzahl von Spalten, in denen Sta')
||'tus gespeichert wird.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98827560382303358)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Neue \00FCbergeordnete Registerkarte hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612960247303177)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Neue Standardregisterkarte hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613510830303178)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'de'
,p_message_text=>unistr('Neue Registerkartengruppe (Sie k\00F6nnen eine Standardregisterkarte in einer neuen Registerkartengruppe erstellen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441253520303041)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Neue Registerkartengruppe f\00FCr \00FCbergeordnete Registerkarten-ID = %0 nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441145720303041)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Alte Registerkartengruppe f\00FCr Registerkarten-ID = %0 nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441390255303041)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>'Seiten-ID %0 ist keine Zahl.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613079225303177)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCbergeordnete Registerkarte. Sequenz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613478348303178)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'de'
,p_message_text=>unistr('ist keiner \00FCbergeordneten Registerkarte zugewiesen und wird als \00FCbergeordnete Pseudo-Registerkarte angezeigt, damit Sie die Standardregisterkarten in dieser Registerkartengruppe bearbeiten k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613696777303178)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Standardregisterkarte ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613257065303178)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlte \00FCbergeordnete Registerkarte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613129858303178)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlte \00FCbergeordnete Pseudo-Registerkarte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441074580303041)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'de'
,p_message_text=>'Die Sicherheitsgruppen-ID muss festgelegt sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98441479495303042)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Es muss eine neue Registerkartengruppe f\00FCr die Registerkarten-ID = %0 angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612888174303177)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'de'
,p_message_text=>'Standardregisterkarte. Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612778323303177)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Registerkarte auch aktuell f\00FCr Seiten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98612622083303177)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Registerkarte aktuell f\00FCr Seite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98613307942303178)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'de'
,p_message_text=>'Die Registerkartengruppe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267724397302900)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen-Template (%0) in Anwendung "%1" Workspace "%2" f\00FCr den Kopiervorgang nicht gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268608805302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Schaltfl\00E4chen-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98434155243303036)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267411858302900)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Feld-Template (%0) in Anwendung "%1" Workspace "%2" f\00FCr den Kopiervorgang nicht gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268396357302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Feld-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268266120302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Listentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267678482302900)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Navigationspfad-Template (%0) in Anwendung "%1" Workspace "%2" f\00FCr den Kopiervorgang nicht gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268409175302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Navigationspfad-Template nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267973972302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Seitentemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268571174302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Template f\00FCr Popup-Werteliste nicht m\00F6glich.%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98550974925303130)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Popup-Template (%0) in Anwendung "%1" Workspace "%2" f\00FCr den Kopiervorgang nicht gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268084994302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Regionstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98268157925302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von Berichtstemplate nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267313328302900)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Template (%0) f\00FCr den Kopiervorgang nicht gefunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98267892956302901)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'de'
,p_message_text=>unistr('Ersetzen von %0-Template nicht m\00F6glich. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99380818156303819)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Theme-Stil ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398325953303834)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Formatvorlage kann nicht aktualisiert werden, sie ist schreibgesch\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99398239350303834)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'de'
,p_message_text=>'Name wird bereits von einer bestehenden Vorlage verwendet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98266445746302899)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Aktualisieren von Ausgangswert: %0.%1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98715499563303267)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Application Express wird ein Upgrade auf eine neuere Version ausgef\00FChrt. \00C4nderungen an Anwendungen sind erst wieder m\00F6glich, wenn das Upgrade abgeschlossen ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378681589302990)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183922003302834)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0 ist nicht als Datenbankbenutzer %1 angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98184017589302834)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Anwendung %0 Seite %1 ist nicht als Datenbankbenutzer %2 angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379606150302991)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'de'
,p_message_text=>'Kalender'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407639529303015)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Auswerten von Kontrollk\00E4stchen-Abfrage: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379792095302991)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407215739303015)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler: Schreibgesch\00FCtzte Wertelisten m\00FCssen zwei Spalten ausw\00E4hlen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378446782302990)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'de'
,p_message_text=>'Werteliste kann nicht bestimmt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380013190302991)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'de'
,p_message_text=>'Find%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98429068016303032)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Generieren von Popup-Werteliste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406978510303014)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Generieren der Abfrage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407020801303015)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Initialisieren der Werteliste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407523178303015)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'de'
,p_message_text=>'Die Abfrage konnte nicht initialisiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332837027302952)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfrage der Popup-Werteliste ist ung\00FCltig. Es muss ein Anzeigewert und R\00FCckgabewert angegeben werden. Au\00DFerdem m\00FCssen die Spaltennamen unterschiedlich sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380142642302991)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript wird nicht unterst\00FCtzt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380389963302991)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98380778283302992)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei der Ausf\00FChrung der Wertelistenabfrage,')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379530584302990)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379153609302990)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'de'
,p_message_text=>unistr('Keine \00DCbereinstimmungen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379879953302991)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'de'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428772254303032)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste muss mit "select" beginnen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98406843264303014)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste mit Filter kann nicht erstellt werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428910137303032)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Initialisieren von Popup-Werteliste mit Filter: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98428883521303032)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Initialisieren von Popup-Werteliste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407393942303015)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung der Popup-Werteliste nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407434491303015)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberpr\00FCfung der Pr\00FCfsumme f\00FCr die Popup-Werteliste nicht erfolgreich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379251418302990)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98378845058302990)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98379916335302991)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'de'
,p_message_text=>'Suchdialog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98990970700303496)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Anzeigen des Bildes. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408124077303015)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'de'
,p_message_text=>'Fett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408559967303016)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'de'
,p_message_text=>unistr('Aufz\00E4hlung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408949545303016)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'de'
,p_message_text=>unistr('Links einger\00FCckt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409051837303016)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'de'
,p_message_text=>unistr('Nach rechts einr\00FCcken')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408255195303015)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'de'
,p_message_text=>'Kursiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408737242303016)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'de'
,p_message_text=>'Zentrieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408671380303016)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'de'
,p_message_text=>unistr('Linksb\00FCndig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408836187303016)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'de'
,p_message_text=>unistr('Rechtsb\00FCndig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408473005303016)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'de'
,p_message_text=>'Nummerierung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98408322407303016)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'de'
,p_message_text=>'Unterstrichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98407184938303015)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Binden von "%0" nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98183863204302833)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Websheet-Anwendung %0 ist nicht als Datenbankbenutzer %1 angemeldet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98607821119303174)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'de'
,p_message_text=>unistr('Der Webservice konnte nicht erreicht werden, da die angegebene URL ung\00FCltig war, die Umgebung eine g\00FCltige Proxyserveradresse f\00FCr HTTP-Anforderungen ben\00F6tigt, die Anforderung wegen Timeout abgebrochen wurde oder ein Wallet f\00FCr HTTPS-Anforderungen kon')
||'figuriert werden muss. SQLERRM: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98254552857302889)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Das WSDL-Dokument konnte nicht abgerufen werden, weil der angegebene URL ung\00FCltig war oder Ihre Umgebung eine g\00FCltige Proxyserveradresse f\00FCr HTTP-Anforderungen ben\00F6tigt, die f\00FCr diese Anwendung nicht definiert wurde, oder es muss ein Wallet f\00FCr diese')
||unistr(' Instanz von &PRODUCT_NAME. f\00FCr HTTPS-Anforderungen konfiguriert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255279652302890)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'de'
,p_message_text=>'Aktion wurde verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837274754303365)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen von Zeilen nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98249066723302885)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4che kann nicht erstellt werden. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285588517302915)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Kalenderseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285249568302914)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Diagrammseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98967622590303477)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'de'
,p_message_text=>'Datenladeprozess kann nicht abgeschlossen werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285964531302915)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Excel-Diagramm nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285602458302915)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Formular basierend auf Equi Join nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284823463302914)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Formular basierend auf SP nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284976452302914)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Formular basierend auf Tabelle nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285046955302914)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Einf\00FCgeformular nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98769332962303313)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'de'
,p_message_text=>'Oracle JET-Diagramm kann nicht erstellt werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98171932235302824)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Master-Detailseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98654766217303210)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'de'
,p_message_text=>'Dynamische Aktion kann nicht erstellt werden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285195518302914)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Abfrage und Aktualisierung der Seite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285408296302914)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Berichtsseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286050250302915)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Zusammenfassungsseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286157869302915)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von SVG-Diagrammseite nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285884364302915)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Baum nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284710914302914)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von aktualisierbarem Bericht nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285735727302915)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen von Assistenten zum Erstellen von Assistenten nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837173988303365)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeiten von L\00F6schvorgang nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837503381303365)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('#MRD_COUNT#-Zeile(n) gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190944906302839)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chsten oder vorherigen Prim\00E4rschl\00FCsselwert abrufen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190898656302839)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Schaltfl\00E4che wird f\00FCr den Prozess zum Abrufen des n\00E4chsten oder vorherigen Prim\00E4rschl\00FCsselwertes ben\00F6tigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98190705255302839)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses Element wird f\00FCr den Prozess zum Abrufen des n\00E4chsten oder vorherigen Prim\00E4rschl\00FCsselwertes ben\00F6tigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98191575632302839)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Ausf\00FChren von Prozess zum Abrufen des n\00E4chsten oder vorherigen Prim\00E4rschl\00FCsselwertes nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98200625570302846)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie diese Seite wirklich verlassen, ohne die \00C4nderungen zu speichern?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549971253303129)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen des Werts f\00FCr das Sekund\00E4rschl\00FCsselelement nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98549877403303129)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen des Werts f\00FCr das Prim\00E4rschl\00FCsselelement nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98285317238302914)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Berichtstyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98563925073303140)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Der interaktive Bericht ist bereits vorhanden. Sie k\00F6nnen nur einen interaktiven Bericht pro Seite hinzuf\00FCgen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98275883916302907)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Erstellen des Prozesses f\00FCr den Abruf des vorherigen Prim\00E4rschl\00FCsselwertes nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837064221303365)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Seite ist keine Hilfe verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284689737302914)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Parsen: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98284589465302914)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'de'
,p_message_text=>'Fehler 2 beim Parsen %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837608631303365)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Senden von Anforderung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837939604303365)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'de'
,p_message_text=>'Baumstruktur anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837712420303365)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'de'
,p_message_text=>'Baum-Root'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255059753302890)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen von Zeile nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98255179387302890)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeiten von Zeile der Tabelle %0 nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98286241134302915)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Die aktualisierbare SQL-Abfrage ist bereits vorhanden. Sie k\00F6nnen nur eine aktualisierbare SQL-Abfrage pro Seite hinzuf\00FCgen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837332118303365)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'de'
,p_message_text=>'Aktualisierung angewendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98837435311303365)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'de'
,p_message_text=>unistr('#MRU_COUNT#-Zeile(n) wurde(n) aktualisiert, #MRI_COUNT#-Zeile(n) wurde(n) eingef\00FCgt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707877305303261)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'de'
,p_message_text=>'Autorisierungsschema kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707682027303260)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'de'
,p_message_text=>'Liste kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707461972303260)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'de'
,p_message_text=>'Werteliste kopieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707701859303261)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Liste verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98707556712303260)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'de'
,p_message_text=>'Vorhandene Werteliste verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98409266806303016)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Wiedergeben von Bericht: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98865429346303388)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'de'
,p_message_text=>'%0 GB insgesamt | %1 GB belegt | %2 Prozent belegt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182532976302832)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Festlegen des neuen PGA-Aggregat-Ziels. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98182364759302832)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Festlegen des neuen SGA-Ziels. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99429947487303861)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten von %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404917427303013)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'de'
,p_message_text=>'Durchschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404838920303013)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'de'
,p_message_text=>'Achse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405486797303013)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'de'
,p_message_text=>'Erster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405585753303013)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'de'
,p_message_text=>'Los'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405371686303013)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'de'
,p_message_text=>'Letzte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405189439303013)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'de'
,p_message_text=>'Maximal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405225106303013)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'de'
,p_message_text=>'Minimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98404712988303013)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98405020193303013)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'de'
,p_message_text=>'Summe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340421301302957)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfrage kann nicht geparst werden. Der Cursor ist noch nicht ge\00F6ffnet, oder es wurde eine Funktion, die eine SQL-Abfrage zur\00FCckgibt, ohne Wert zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98700970049303254)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Abfrage enth\00E4lt mehrfach vorhandene Aliasnamen. Abfragen f\00FCr Berichte m\00FCssen eindeutige Aliasnamen haben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98332556018302951)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'de'
,p_message_text=>unistr('Verarbeiten von Funktionsbody nicht m\00F6glich, der Abfrage zur\00FCckgibt: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98418488238303023)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'de'
,p_message_text=>unistr('In der Abfrage ist eine ung\00FCltige Anzahl der Spalten definiert. Es werden %0 Spalten f\00FCr diesen Regionstyp ben\00F6tigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340569649302957)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Funktion f\00FCr die R\00FCckgabe der SQL-Abfrage: Die Abfrage kann nicht im Builder geparst werden. Wenn die Abfrage syntaktisch korrekt ist, aktivieren Sie das Kontrollk\00E4stchen <strong>Generische Spalten</strong> unter der Regionsquelle, um ohne Parsen for')
||'tzufahren.',
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98340606420302957)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Abfrage kann nicht im Builder geparst werden. Wenn die Abfrage syntaktisch korrekt ist, aktivieren Sie das Kontrollk\00E4stchen f\00FCr die generischen Spalten unter der Regionsquelle, um ohne Parsen fortzufahren. %0</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98416988725303022)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'de'
,p_message_text=>unistr('Wort hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417535586303023)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'de'
,p_message_text=>unistr('Zu Data Dictionary hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417431173303023)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen anwenden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417322644303022)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417282145303022)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'de'
,p_message_text=>'Fertig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98776145375303318)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Weiterleiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417167195303022)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'de'
,p_message_text=>'%0 ist bereits in Ihrem Data Dictionary.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417794941303023)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'de'
,p_message_text=>'Geben Sie ein neues Wort ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417655688303023)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'de'
,p_message_text=>unistr('Wort ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98635332099303195)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'de'
,p_message_text=>unistr('Rechtschreibpr\00FCfung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98417073000303022)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 wurde zu Ihrem Dictionary hinzugef\00FCgt.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98262392584302896)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'de'
,p_message_text=>'XML-Ladefehler.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98687228231303242)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'de'
,p_message_text=>'Weitere %0 Tags sind vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98688034172303243)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'de'
,p_message_text=>'%0 Bugs ohne Korrektur nach Datum'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98862004775303385)
,p_name=>'YEARLY'
,p_message_language=>'de'
,p_message_text=>'Jahr'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98315738381302939)
,p_name=>'YES_BY_USER'
,p_message_language=>'de'
,p_message_text=>'Ja, pro Benutzer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98344872556302961)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'de'
,p_message_text=>'Ihre E-Mail-Adresse ist mit einem Benutzer in den folgenden Workspaces registriert:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(98626293259303188)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'de'
,p_message_text=>'Sie sind jetzt abgemeldet.'
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4414)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>'Navigationspfad'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigen Sie den Navigationspfad f\00FCr die aktuelle Seite an.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>'Liste'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt Werte basierend auf einer statischen oder dynamischen Liste an. Im Allgemeinen werden sie verwendet, um zu Seiten in der Anwendung zu navigieren.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>'Dialog abbrechen'
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Bricht die aktuelle Dialogseite ab.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('Dialog schlie\00DFen')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Schlie\00DFt die aktuelle Dialogseite.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4414)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Zur\00FCckzugebende Elemente')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen von mindestens einem Seitenelement an, das von dem Dialogfeld zur\00FCckgegeben werden muss. Trennen Sie die Elementnamen bei mehreren Elementen durch ein Komma.</p>'),
unistr('<p>Sie k\00F6nnen auf die zur\00FCckgegebenen Elementwerte zugreifen, indem Sie eine dynamische Aktion definieren, die bei dem Ereignis <strong>Dialogfeld geschlossen</strong> f\00FCr das Element ausgel\00F6st wird, das das Dialogfeld \00F6ffnet, mit einer Aktion <stron')
||unistr('g>Wert festlegen</strong> und <em>Typ festlegen</em> f\00FCr <strong>Dialogfeldr\00FCckgabeelement</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('Selektor f\00FCr Regionsanzeige')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt Regionsnamen in einer horizontalen Liste an, sodass Endbenutzer eine Region zur Anzeige ausw\00E4hlen und andere Regionen ausblenden k\00F6nnen. Nur Seitenregionen, bei denen <em>Selektor f\00FCr Regionsanzeige</em> auf <strong>Ja</strong> gesetzt ist, wer')
||'den in dieser Region angezeigt.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4414)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Schieberegler einbeziehen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('F\00FCgen Sie dynamisch einen Schieberegler zu der Region hinzu, wenn die angezeigten Regionsnamen die Breite der Region \00FCberschreiten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4414)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Modus'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie Regionen, bei denen <em>Selektor f\00FCr Regionsanzeige</em> auf <strong>Ja</strong> gesetzt ist, auf der Seite angezeigt wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4414)
,p_display_sequence=>10
,p_display_value=>'Einzelne Region anzeigen'
,p_return_value=>'STANDARD'
,p_help_text=>unistr('Zeigen Sie Regionen als Registerkarten an. Durch Auswahl einer Registerkarte wird die entsprechende Region sichtbar, und die anderen Auswahlm\00F6glichkeiten werden ausgeblendet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4414)
,p_display_sequence=>20
,p_display_value=>'Bildlauffenster'
,p_return_value=>'JUMP'
,p_help_text=>'Zeigen Sie immer alle Regionen auf der Seite an. Bei Auswahl einer Registerkarte scrollt das Fenster in die entsprechende Region.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4414)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'"Alle anzeigen" einbeziehen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('Stellen Sie eine Registerkarte "Alle anzeigen" voran, in der - wenn sie ausgew\00E4hlt ist - alle Regionen auf der Seite angezeigt werden')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4414)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Letzte Auswahl speichern'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Beim Laden der Seite wird die Region, die Sie zuletzt ausgew\00E4hlt haben, angezeigt.')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Remote-Inhalt anzeigen, der aus einer URL stammt'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4414)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie eine URL f\00FCr den Remote-Inhalt ein.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4414)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Inklusionsmodus'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie der Remote-Inhalt aus der URL in der Seite einbezogen wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4414)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>'Remote-Inhalt als iframe einbetten.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4414)
,p_display_sequence=>20
,p_display_value=>'Inline-Text (Sonderzeichen maskieren)'
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('Lesen Sie Remote-Inhalt bei der Seitenwiedergabe, und betten Sie ihn ein, maskieren Sie jedoch HTML-Sonderzeichen, um website\00FCbergreifendes Skripting zu verhindern. ')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4414)
,p_display_sequence=>30
,p_display_value=>'Inline (keine Maskierung)'
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('Lesen Sie Remote-Inhalt bei der Seitenwiedergabe, und betten Sie ihn ein. Diese Option darf nur ausgew\00E4hlt werden, wenn dem Remote-Inhalt voll vertraut werden kann, da keine HTML-Maskierung erfolgt. Dadurch wird die Region f\00FCr website\00FCbergreifendes S')
||unistr('kripting anf\00E4llig.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4414)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'IFrame-Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('Breite="300" H\00F6he="300"'),
'</pre>'))
,p_help_text=>unistr('Geben Sie zus\00E4tzliche HTML-Elementattribute f\00FCr das iframe-Tag ein.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4414)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'HTML verwerfen bis'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Verwenden Sie dieses Attribut, wenn ein Clipping eines HTML-Bereichs aus einem gr\00F6\00DFeren Dokument ausgef\00FChrt wird. Geben Sie eine Zeichenfolge ein, die den Anfang des Zielbereichs angibt. Oder geben Sie den Punkt an, bis zu dem der HTML-Code verworfen')
||' wird.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4414)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'HTML verwerfen nach'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Verwenden Sie dieses Attribut, wenn ein Clipping eines HTML-Bereichs aus einem gr\00F6\00DFeren HTML-Dokument ausgef\00FChrt wird. Geben Sie eine Zeichenfolge ein, die das Ende des Zielbereichs angibt. Oder geben Sie den Punkt an, nach dem der verbleibende HTML-')
||unistr('Code verworfen wird. Diese Zeichenfolge, durch die das Ende des Zielbereichs identifiziert wird, ist nicht im zur\00FCckgegebenen Text enthalten.')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>'Hilfetext'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt eine besondere Hilferegion an, die in der dedizierten Hilfeseite verwendet wird. '
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>'Facet-Suche'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>Eine Region basierend auf der Quelle einer zugeordneten Facet-Suche, \00FCber die Endbenutzer zahlreiche Facets erhalten, mit denen die Suchergebnisse zur Laufzeit eingegrenzt werden k\00F6nnen. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Batch-Facet-\00C4nderungen')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie aus, ob die ausgew\00E4hlten Facets per Batchvorgang oder einzeln auf den Facet-Suchbericht angewendet werden sollen. Wenn Sie diese Option auf "Ja" setzen, wird die Filterung des Berichts beim Klicken auf die Schaltfl\00E4che "Anwenden" ausgef\00FChr')
||unistr('t. Wenn Sie "Nein" angeben, wird die Filterung des Berichts ausgef\00FChrt, sobald sich ein Facet-Wert \00E4ndert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Aktuelle Facets anzeigen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie an, ob der aktuelle Facets-Bereich angezeigt werden soll. Im aktuellen Facets-Bereich werden die Facets aufgelistet, die derzeit ausgew\00E4hlt sind. So erhalten Sie eine einfache M\00F6glichkeit, die Facets einzeln oder gleichzeitig zu entfernen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4414)
,p_display_sequence=>10
,p_display_value=>'Ja'
,p_return_value=>'Y'
,p_help_text=>'Die Liste der aktuellen Facets wird oben in der Facet-Suchregion angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4414)
,p_display_sequence=>20
,p_display_value=>'Nein'
,p_return_value=>'N'
,p_help_text=>'Die Liste der aktuellen Facets wird nicht angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4414)
,p_display_sequence=>30
,p_display_value=>'Selektor'
,p_return_value=>'E'
,p_help_text=>unistr('Der Bereich f\00FCr aktuelle Facets wird innerhalb des Elements angezeigt, das durch diesen Selektor angegeben ist. Dadurch k\00F6nnen Sie den Bereich f\00FCr aktuelle Facets an einer beliebigen Stelle auf der Seite platzieren.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Selektor f\00FCr aktuelle Facets')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>'Das ist der Selektor eines Elements auf der Seite, auf der die aktuellen Facets in der Facet-Suchregion angezeigt werden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Gesamtanzahl von Zeilen anzeigen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Geben Sie an, wo die Gesamtzeilenanzahl angezeigt werden soll.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4414)
,p_display_sequence=>10
,p_display_value=>'Nein'
,p_return_value=>'N'
,p_help_text=>'Die Gesamtzeilenanzahl wird nicht angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4414)
,p_display_sequence=>20
,p_display_value=>'Ja'
,p_return_value=>'Y'
,p_help_text=>'Die Gesamtzeilenanzahl wird oben im aktuellen Facet-Bereich angezeigt. Wenn "Aktuelle Facets anzeigen" auf "Nein" gesetzt wurde, wird die Gesamtzeilenanzahl oben in der Facet-Suchregion angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4414)
,p_display_sequence=>30
,p_display_value=>'Selektor'
,p_return_value=>'E'
,p_help_text=>unistr('Die Gesamtzeilenanzahl (ohne Label) wird innerhalb des Elements angezeigt, das durch diesen Selektor angegeben ist. Dadurch k\00F6nnen Sie die Gesamtzeilenanzahl an einer beliebigen Stelle auf der Seite platzieren.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Label f\00FCr Zeilenanzahl gesamt')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Label f\00FCr die Gesamtzeilenanzahl. Wenn hier kein Label angegeben wird, verwendet APEX die APEX.FS.TOTAL_ROW_COUNT_LABEL-Textnachricht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Selektor f\00FCr Gesamtzeilenzahl')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>'Das ist der Selektor eines Elements auf der Seite, auf der die Gesamtzeilenanzahl in der Facet-Suchregion angezeigt wird.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>unistr('Schwellenwert f\00FCr kompakte Zahlen')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie einen Schwellenwert an, \00FCber dem die Facet-Anzahl mit einem kompakten Zahlenformat angezeigt wird. Beim kompakten Zahlenformat wird der Wert<strong>1.234</strong> als <strong>1K</strong> angezeigt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Diagramme anzeigen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Geben Sie an, wo die Facet-Wertdiagramme angezeigt werden.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4414)
,p_display_sequence=>10
,p_display_value=>'Dialog'
,p_return_value=>'Y'
,p_help_text=>'Facet-Wertdiagramme werden in einem nicht modalen Dialogfeld angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4414)
,p_display_sequence=>20
,p_display_value=>'Nein'
,p_return_value=>'N'
,p_help_text=>unistr('Es gibt keine Schaltfl\00E4che f\00FCr Benutzer zum Anzeigen von Facet-Wertdiagrammen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4414)
,p_display_sequence=>30
,p_display_value=>'Selektor'
,p_return_value=>'E'
,p_help_text=>unistr('Facet-Wertdiagramme werden zum Element hinzugef\00FCgt, das durch diesen Selektor angegeben ist. Dadurch k\00F6nnen Sie die Diagramme an einer beliebigen Stelle auf der Seite platzieren und ein Dashboard f\00FCr Facet-Wertdiagramme erstellen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Diagrammselektor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>'Das ist der Selektor eines Elements auf der Seite, auf der Facet-Diagramme in der Facet-Suchregion angezeigt werden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Diagramm f\00FCr die ersten n Werte anzeigen')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>'Geben Sie an, wie viele Werte im Diagramm pro Facet angezeigt werden sollen. Ein Wert von <strong>10</strong> bedeutet, dass in den Facet-Diagrammen die <em>ersten 10</em> Elemente wie unter dem Facet angeordnet angezeigt werden. Wenn die Facet-Eigen'
||unistr('schaft "Absteigend nach Anzahl sortieren" aktiviert ist, handelt es sich hierbei um die <em>ersten 10</em> Elemente basierend auf der Anzahl der Vorkommen. \00C4nderungen an dieser Eigenschaft sind m\00F6glicherweise nicht sofort in derzeit aktiven Browserse')
||unistr('ssions sichtbar. Dieser Wert wird zusammen mit der Auswahl des Benutzers, ob die Werte in einem Torten- oder Balkendiagramm angezeigt werden sollen, in der Browsersession gespeichert. Um die Auswirkung von \00C4nderungen an dieser Eigenschaft zu sehen, s')
||unistr('etzen Sie den Bericht im Link-Builder-Dialogfeld \00FCber "Regionen zur\00FCcksetzen" oder eine Cache-Control-Option zur\00FCck, z.B. mit der vom Assistenten generierten Schaltfl\00E4che "Zur\00FCcksetzen".')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_name=>'facetsafterremovechart'
,p_display_name=>'Nach "Diagramm entfernen"'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>unistr('Vor "Diagramm hinzuf\00FCgen"')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4414)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4414)
,p_name=>'facetschange'
,p_display_name=>unistr('Facets-\00C4nderung')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>'SAML-Anmeldung'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>unistr('Zugangsdatenspeicher f\00FCr das Signieren von Anforderungen')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den Zugangsdatenspeicher aus, der das \00F6ffentliche Zertifikat und den Private Key zum Signieren von Nachrichten an den Identit\00E4tsprovider enth\00E4lt.'),
unistr('Sie m\00FCssen das Zertifikat beim Identit\00E4tsprovider registrieren.'),
'&PRODUCT_NAME. verwendet den Private Key zum Signieren von Anforderungen.',
unistr('Dieses Attribut ist zwar optional, aber das Signieren von Anforderungen wird aus Sicherheitsgr\00FCnden empfohlen.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'SAML-Attribute verwenden von'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>'Geben Sie an, ob eine SAML-Konfiguration auf Instanzebene oder eine anwendungsspezifische SAML-Konfiguration verwendet werden soll.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_display_sequence=>10
,p_display_value=>'Instanz'
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verwenden Sie die gemeinsame SAML-Konfiguration f\00FCr die gesamte &PRODUCT_NAME.-Instanz.'),
unistr('Hierf\00FCr muss Ihr Instanzadministrator SAML-Attribute auf Instanzebene konfiguriert haben.'),
'Ist dies nicht der Fall, treten Laufzeitfehler auf.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_display_sequence=>20
,p_display_value=>'Anwendung'
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>'Verwenden Sie eine anwendungsspezifische SAML-Konfiguration.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('Single-Sign-On-URL des Identit\00E4tsproviders')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('W\00E4hlen Sie die Single-Sign-On-POST-URL des Identit\00E4tsproviders aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('Single-Sign-Out-URL des Identit\00E4tsproviders')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Single-Sign-Out-POST-URL des Identit\00E4tsproviders aus.'),
'Ist dieses Feld leer, wird die Single-Sign-On-URL verwendet.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('Aussteller des Identit\00E4tsproviders')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den "Aussteller"-Wert des Identit\00E4tsproviders aus.'),
unistr('&PRODUCT_NAME. verifiziert diesen Wert in Nachrichten vom Identit\00E4tsprovider.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Benutzernameattribut'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Das SAML-Attribut, das den Benutzernamen enth\00E4lt.'),
unistr('Wird standardm\00E4\00DFig auf den Wert des Knotens "Assertion/Subject/NameID" gesetzt.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>unistr('Signaturzertifikat des Identit\00E4tsproviders')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Zertifikat ein, das der Identit\00E4tsprovider zum Signieren von Nachrichten verwendet.'),
unistr('&PRODUCT_NAME. verwendet dieses Zertifikat, um Antwortnachrichten vom Identit\00E4tsprovider zu verifizieren.'),
unistr('Dieses Attribut ist zwar optional, aber das Verifizieren von Antworten wird aus Sicherheitsgr\00FCnden empfohlen.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4414)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Benutzernamen in Gro\00DFbuchstaben konvertieren')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Konfigurieren Sie, ob die Attributwerte f\00FCr den Benutzernamen in Gro\00DFbuchstaben konvertiert werden sollen.')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>'Eingabefeld'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4414)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Vergleichsoperator'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_display_sequence=>10
,p_display_value=>'Ist gleich'
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_display_sequence=>30
,p_display_value=>'Kleiner als'
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_display_sequence=>40
,p_display_value=>'Kleiner oder gleich'
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_display_sequence=>50
,p_display_value=>unistr('Gr\00F6\00DFer als')
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_display_sequence=>60
,p_display_value=>unistr('Gr\00F6\00DFer oder gleich')
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_display_sequence=>70
,p_display_value=>'Beginnt mit'
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_display_sequence=>80
,p_display_value=>unistr('Enth\00E4lt')
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4414)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Gro\00DF-/Kleinschreibung beachten')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4414)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Werte klein/gro\00DF')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Wenn alle Datenwerte bereits in Klein- oder Gro\00DFbuchstaben geschrieben sind, kann das hier deklariert werden. Der vom Endbenutzer bereitgestellte Filter konvertiert Werte automatisch in die deklarierte Schreibung, sodass die Suche f\00FCr Endbenutzer una')
||unistr('bh\00E4ngig von der Gro\00DF- und Kleinschreibung erscheint, w\00E4hrend die eigentliche Datenbanksuche die Gro\00DF- und Kleinschreibung ber\00FCcksichtigt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Gro\00DF- und Kleinschreibung gemischt')
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4414)
,p_display_sequence=>20
,p_display_value=>'Kleinbuchstaben'
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4414)
,p_display_sequence=>30
,p_display_value=>unistr('Gro\00DFbuchstaben')
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4414)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Aktuelles Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'Filtern nach %0'
,p_help_text=>unistr('Geben Sie den Text ein, der f\00FCr dieses Facet im Bereich f\00FCr aktuelle Facets angezeigt werden soll. Der aktuelle Wert kann durch den Platzhalter <strong>%0</strong> referenziert werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4414)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Pr\00E4fixtext')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Geben Sie den Text ein, der vor dem Eingabefeld angezeigt werden soll.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4414)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Suffixtext'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Geben Sie den Text ein, der nach dem Eingabefeld angezeigt werden soll.'
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>'Karten'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Bericht, der auf einer SQL-Abfrage basiert, die Daten f\00FCr jede Zeile in Karten anzeigt. Mit Karten k\00F6nnen Sie die Daten einfach in Inhaltsbl\00F6cken visualisieren. Sie k\00F6nnen Header, Medien, Hauptteil oder Aktionen deklarativ anpassen.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4414)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4414)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4414)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>unistr('Seiten\00E4nderung')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4414)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Seitennummerierungstyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Keine Seitennummerierung'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Seitengr\00F6\00DFe und Abrufoffset')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Flexible Seitennummerierung, wenn die REST-API die Anforderung eines bestimmten Zeilensatzes mit den Parametern <em>Seitengr\00F6\00DFe</em> und <em>Offset</em> ("beginnen bei Zeile") zul\00E4sst. Die URL sieht normalerweise wie im folgenden Beispiel aus, bei')
||unistr(' dem <strong>20</strong> Zeilen \00FCbersprungen und die n\00E4chsten <strong>100</strong> Zeilen abgerufen werden:</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Seitengr\00F6\00DFe und Seitennummer')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seitennummerierung, wenn die REST-API die Anforderung eines Zeilensatzes mit den Parametern <em>Seitengr\00F6\00DFe</em> und <em>Seitennummer</em> zul\00E4sst. URLs sehen normalerweise wie im folgenden Beispiel aus, bei dem die Seitennummer <strong>2</strong>')
||unistr(' und die Seitengr\00F6\00DFe <strong>100</strong> angefordert werden. Die Zeilen 101 bis 200 werden zur\00FCckgegeben.'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_display_sequence=>30
,p_display_value=>'Seitennummer'
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seitennummerierung, wenn die REST-API die Anforderung eines Zeilensatzes mit dem Parameter <em>Seite</em> zul\00E4sst. Die Seitengr\00F6\00DFe ist fixiert und wird von der REST-API festgelegt. URLs sehen normalerweise wie im folgenden Beispiel aus, bei dem di')
||unistr('e Seitennummer <strong>2</strong> angefordert wird. Wenn die REST-API eine fixierte Seitengr\00F6\00DFe von <strong>20</strong> verwendet, werden die Zeilen 21 bis 40 zur\00FCckgegeben.'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Seitengr\00F6\00DFe - URL-Parameter')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den URL-Parameter an, um die <em>Seitengr\00F6\00DFe</em> festzulegen, die von der REST-API angefordert werden soll. Typische Werte sind <strong>limit</strong>, <strong>page_size</strong> oder </strong>per_page</strong>.</p>'),
unistr('<p><em>F\00FCgen Sie diesen Parameter nicht innerhalb der <strong>Parameter</strong> der REST-Datenquelle hinzu</em>. Dieser wird von &PRODUCT_NAME. automatisch bei der Ausf\00FChrung der HTTP-Anforderung hinzugef\00FCgt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Seitengr\00F6\00DFe - Maximum')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>'Zeilen'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die maximale Zeilenanzahl pro Seite an, deren Abruf die REST-API zul\00E4sst. &PRODUCT_NAME. wird nicht versuchen, mehr Zeilen pro Seite anzufordern.</p>'),
unistr('<p>Stellen Sie sicher, dass die REST-API diese Zeilenanzahl <em>tats\00E4chlich zur\00FCckgibt</em>, da &PRODUCT_NAME. eine angeforderte Seite als letzte Seite behandelt, wenn die Antwort weniger Zeilen als angefordert enth\00E4lt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Seitennummer - URL-Parameter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den URL-Parameter an, um die <em>Seitenzahl</em> anzugeben, die von der REST-API angefordert werden soll. Ein typischer Wert ist <strong>page</strong>.</p>',
unistr('<p><em>F\00FCgen Sie diesen Parameter nicht innerhalb der <strong>Parameter</strong> der REST-Datenquelle hinzu</em>. Dieser wird von &PRODUCT_NAME. automatisch bei der Ausf\00FChrung der HTTP-Anforderung hinzugef\00FCgt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Index der ersten Seite'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Legen Sie fest, ob die REST-API mit dem Z\00E4hlen der Seiten beim Index <strong>"0"</strong> oder <strong>"1"</strong> beginnt.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4414)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>'Die REST-API bezeichnet die erste Seite als Seite <strong>1</strong>.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4414)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>'Die REST-API bezeichnet die erste Seite als Seite <strong>0</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Feste Seitengr\00F6\00DFe')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>'Zeilen'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die <em>Seitengr\00F6\00DFe</em> (Anzahl der Zeilen pro Seite) an, die von der REST-API bestimmt wird.</p>'),
'<p>Informationen hierzu finden Sie in der Regel in der Dokumentation zur REST-API. Achten Sie darauf, hier den richtigen Wert anzugeben: Falls der Wert nicht richtig ist, sind Zeilen doppelt vorhanden oder fehlen, wenn &PRODUCT_NAME. Daten von der RE'
||'ST-API abruft.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Zeilenoffset - URL-Parameter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>'Zeilen'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den URL-Parameter an, um den <em>Offset</em> festzulegen. Der Offset bestimmt, wie viele Zeilen \00FCbersprungen werden, bevor die erste Zeile zur\00FCckgegeben wird.</p>'),
unistr('<p><em>F\00FCgen Sie diesen Parameter nicht innerhalb der <strong>Parameter</strong> der REST-Datenquelle hinzu</em>. Dieser wird von &PRODUCT_NAME. automatisch bei der Ausf\00FChrung der HTTP-Anforderung hinzugef\00FCgt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Zeilenoffsettyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie aus, ob der Parameter <strong>Offset</strong> die <em>Anzahl der zu \00FCberspringenden Zeilen</em> oder die <em>erste abzurufende Zeile</em> festlegt.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Zu \00FCberspringende Zeilen')
,p_return_value=>'OFFSET'
,p_help_text=>unistr('Der Offsetwert gibt die zu \00FCberspringenden Zeilen an. Beispiel: Beim Wert 100 gibt die REST-API Zeilen ab Indexposition 101 zur\00FCck.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4414)
,p_display_sequence=>20
,p_display_value=>'Erste abzurufende Zeile'
,p_return_value=>'START'
,p_help_text=>unistr('Der Offsetwert gibt die Zeile an, bei der der Abruf beginnen soll. Beispiel: Beim Wert 100 \00FCberspringt die REST-API die ersten 99 Zeilen und beginnt den Abruf bei Indexposition 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Hat mehr Zeilen-Selektor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn eine REST-API die folgende JSON-Antwort zur\00FCckgibt:</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
'Der <strong>Hat mehr Zeilen-Selektor</strong> ist dann <strong>metadata.pagination.moreRows</strong>.',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die Antwort der REST-API Informationen \00FCber etwaige weitere Seiten enth\00E4lt, stellen Sie den <em>Selektor</em> bereit, um dieses Attribut hier zu extrahieren.</p>'),
unistr('<p>Die Angabe eines <strong>Hat mehr Zeilen-Selektors</strong> ist nicht erforderlich. &PRODUCT_NAME. kann aber auf weitere HTTP-Anforderungen verzichten (die keine Daten zur\00FCckgeben w\00FCrden), wenn alle Daten bereits abgerufen wurden.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Hat mehr Zeilen, wenn Wert'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie aus, wie der Wert des Antwortattributs, das vom <strong>Hat mehr Zeilen-Selektor</strong> referenziert wird, ausgewertet werden soll.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4414)
,p_display_sequence=>10
,p_display_value=>'Ist gleich'
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('Es wird davon ausgegangen, dass weitere Zeilen verf\00FCgbar sind, wenn das vom <strong>Hat mehr Zeilen-Selektor</strong> referenzierte Antwortattribut diesen Wert enth\00E4lt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4414)
,p_display_sequence=>20
,p_display_value=>'Ist nicht Null'
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('Es wird davon ausgegangen, dass weitere Zeilen verf\00FCgbar sind, wenn das vom <strong>Hat mehr Zeilen-Selektor</strong> referenzierte Antwortattribut vorhanden und nicht leer ist.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Hat mehr Zeilen-Attributwert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p>&PRODUCT_NAME. geht davon aus, dass weitere Zeilen verf\00FCgbar sind, wenn das vom <strong>Hat mehr Zeilen-Selektor</strong> referenzierte Antwortattribut diesen Wert enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4414)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Gesamte Zeilen-Selektor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die REST-API die folgende JSON-Antwort zur\00FCckgibt:</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
'Der <strong>Hat mehr Zeilen-Selektor</strong> ist dann <strong>metadata.pagination.totalRows</strong>.',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn die Antwort der REST-API die <em>Gesamtanzahl Zeilen</em> (auf allen Seiten) enth\00E4lt, stellen Sie den <em>Selektor</em> bereit, um dieses Attribut hier zu extrahieren.</p>'),
unistr('<p>Die Angabe eines <strong>Hat mehr Zeilen-Selektors</strong> ist nicht erforderlich, erm\00F6glicht aber die Anzeige der Gesamtanzahl Zeilen in Komponenten von &PRODUCT_NAME., <em>solange die Daten nicht weiter gefiltert werden</em>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>'Geocode-Adresse'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dieser Elementtyp bietet Geocoding-Funktionalit\00E4t (Umwandlung einer Adresse in eine Koordinate).<p>'),
unistr('<p>Geocoding wird vom <em>Browser</em> mit einer REST-Anforderung an den <strong>Oracle Elocation</strong>-Geocoding-Service (elocation.oracle.com) ausgef\00FChrt. Daher muss der Browser mit dem Internet verbunden sein, um Geocoding vorzunehmen.</p>'),
unistr('<p>Geocoding-Eingabedaten stammen aus anderen Seitenelementen, die Adressteilen wie Stra\00DFe, Hausnummer, Postleitzahl oder Ort zugeordnet sind. Der Geocoder zeigt ein Popup-Fenster mit einer Liste m\00F6glicher \00DCbereinstimmungen an. Nachdem Sie eine \00DCbere')
||unistr('instimmung ausgew\00E4hlt haben, ist der Sessionzustandswert des Elements die Adresskoordinate im GeoJSON-Format. Wenn <strong>Adresse bereinigen</strong> aktiviert ist, werden Adressteilelemente mit den bereinigten Werten vom Geocoding-Service \00FCberschri')
||'eben.</p>',
unistr('<p>In einfacheren Anwendungsf\00E4llen k\00F6nnen Sie mit dem Modus <strong>Unstrukturierte Adresse</strong> nur ein Textfeld oder einen Textbereich zuordnen, in dem Endbenutzer Adressteile durch Kommas getrennt eingeben. In diesem Fall ist der Modus <strong')
||unistr('>Adresse bereinigen</strong> nicht verf\00FCgbar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Geocoder-Abgleichsmodus'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Der <strong>Abgleichsmodus</strong> bestimmt, wie genau die Attribute einer Eingabeadresse mit den f\00FCr das Geocoding verwendeten Daten \00FCbereinstimmen m\00FCssen.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4414)
,p_display_sequence=>10
,p_display_value=>'Genau'
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>Alle angegebenen Adressteile m\00FCssen \00FCbereinstimmen. Wenn allerdings Hausnummer, Stra\00DFenname oder Stra\00DFentyp nicht <em>alle</em> \00FCbereinstimmen, wird die erste \00DCbereinstimmung im Folgenden zur\00FCckgegeben: Postleitzahl, Ort und Bundesland. Beispiel: ')
||unistr('Wenn der Stra\00DFenname falsch ist, aber eine g\00FCltige Postleitzahl angegeben wurde, wird ein Ort in der Postleitzahl zur\00FCckgegeben.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Stra\00DFentyp lockern')
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>Der angegebene <em>Stra\00DFentyp</em> kann sich von den zum Geocoding verwendeten Daten unterscheiden. Beispiel: <strong>Main Street</strong> oder <strong>Main Blvd</strong> stimmt mit <strong>Main St</strong> \00FCberein, sofern kein anderes Vorkommen v')
||'on <strong>Main Blvd</strong> oder <strong>Main Street</strong> im relevanten Gebiet vorliegt.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4414)
,p_display_sequence=>30
,p_display_value=>'Hausnummer lockern'
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>Die Hausnummer und der Stra\00DFentyp k\00F6nnen sich von den zum Geocoding verwendeten Daten unterscheiden. Beispiel: <strong>123 Main St</strong> stimmt mit <strong>123 Main Lane</strong> und <strong>124 Main St</strong> \00FCberein, solange keine Mehrdeuti')
||unistr('gkeiten oder anderen \00DCbereinstimmungen vorliegen.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4414)
,p_display_sequence=>40
,p_display_value=>unistr('Stra\00DFennamen lockern')
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>Der <em>Basisname</em> der Stra\00DFe, die Hausnummer und der Stra\00DFentyp k\00F6nnen sich von den zum Geocoding verwendeten Daten unterscheiden. Beispiel: <strong>Pleasant Vale</strong> stimmt mit <strong>Pleasant Valley</strong> \00FCberein, solange keine Meh')
||unistr('rdeutigkeiten oder anderen \00DCbereinstimmungen in den Daten vorliegen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4414)
,p_display_sequence=>50
,p_display_value=>'Postleitzahl lockern'
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>Die Postleitzahl (sofern angegeben), der Stra\00DFenname, der Stra\00DFentyp und die Hausnummer k\00F6nnen sich von den zum Geocoding verwendeten Daten unterscheiden.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4414)
,p_display_sequence=>60
,p_display_value=>'Alle lockern'
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>Die Adresse kann au\00DFerhalb des angegebenen Ortes liegen, solange sie sich in demselben Landkreis befindet. Umfasst zudem die Merkmale von <strong>Postleitzahl lockern</strong>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Koordinaten in Popup anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>Bestimmen Sie, ob Adresskoordinaten (L\00E4ngengrad, Breitengrad) im Popup-Dialogfeld f\00FCr Geocoding-Ergebnisse angezeigt werden sollen.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Kartenvorschau'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Geben Sie an, ob die Vorschau der Geocode-Adresse auf einer Karte zul\00E4ssig ist.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4414)
,p_display_sequence=>10
,p_display_value=>'Ergebnis-Popup'
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigen Sie die Karte im Popup-Fenster mit den Geocoding-Ergebnissen an, damit Benutzer die Position pr\00FCfen k\00F6nnen, bevor sie ein Ergebnis ausw\00E4hlen.</p>'),
unistr('<p>Diese Option wird nur unterst\00FCtzt, wenn "Anzeigen als - Grid-Ansicht" aktiviert ist.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4414)
,p_display_sequence=>20
,p_display_value=>'Element'
,p_return_value=>'ITEM'
,p_help_text=>'Zeigen Sie eine Karte an, die den Adressort an der Elementposition visualisiert.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Hintergrund'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie die Hintergrundkarte aus, auf der Geocoding-Ergebnisse angezeigt werden.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4414)
,p_display_sequence=>5
,p_display_value=>'Standard'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Verwenden Sie den Standardkartenhintergrund.</p>',
unistr('<p>Es wird entweder "OpenStreetMap - Hell" oder "OpenStreetMap - Dunkel" f\00FCr dunkle Themes verwendet.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4414)
,p_display_sequence=>10
,p_display_value=>'OpenStreetMap - Hell'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Allgemeine Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden Details zum Speicherortkontext f\00FCr Ihre Daten bereitgestellt.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4414)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap - Dunkel'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige, dunkle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4414)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap - Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige, helle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4414)
,p_display_sequence=>40
,p_display_value=>'Oracle-Weltkarte'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Allgemeine Basiskarte auf der Grundlage von HERE-Kartendaten. Bei diesem Basiskartenstil wird der Speicherortkontext f\00FCr Ihre Daten bereitgestellt, und die Visualisierung Ihrer Daten wird hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von Oracle, USA.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('H\00F6he')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'Pixel'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die H\00F6he der angezeigten Karte (in Pixel) an.</p>'),
unistr('<p>Die Standardh\00F6he der Karte wird basierend auf ihrer Breite mit dem Seitenverh\00E4ltnis 3:2 berechnet.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Anzeigen als'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Legen Sie fest, wie die Geocoding-Ergebnisse angezeigt werden.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4414)
,p_display_sequence=>10
,p_display_value=>'Listenansicht'
,p_return_value=>'LIST'
,p_help_text=>'<p>Die Ergebnisse werden in einer Listenansicht angezeigt.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4414)
,p_display_sequence=>20
,p_display_value=>'Grid-Ansicht'
,p_return_value=>'GRID'
,p_help_text=>'<p>Die Ergebnisse werden in einer Grid-Ansicht angezeigt.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>'Strukturierte Adresse'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Adressteile <em>strukturiert</em> oder <em>unstrukturiert</em> an den Geocoding-Service \00FCbergeben werden.</p>'),
unistr('<p>"Strukturiert" bedeutet, dass explizite Seitenelemente Adressteilen wie Stra\00DFe, Postleitzahl, Ort oder Region zugeordnet werden. Damit erhalten Sie genauere Geocoding-Ergebnisse und k\00F6nnen die korrigierten '),
unistr('Adressen wieder den Seitenelementen zuf\00FChren.</p>'),
unistr('<p>"Unstrukturiert" bedeutet, dass nur ein Element f\00FCr die ganze Adresse verwendet wird. Die einzelnen Teile sind dabei durch Kommas getrennt. In diesem Modus k\00F6nnen keine korrigierten Adressen wieder an das Seitenelement \00FCbergeben werden.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('L\00E4ndertyp')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Legen Sie fest, ob ein statisches Land f\00FCr das Geocoding verwendet oder das Land von einem Element abgeleitet werden soll.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4414)
,p_display_sequence=>10
,p_display_value=>'Statisch'
,p_return_value=>'STATIC'
,p_help_text=>'<p>Verwenden Sie ein statisches Land aus einer Auswahlliste.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4414)
,p_display_sequence=>20
,p_display_value=>'Element'
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>Rufen Sie das Land von einem Anwendungs- oder Seitenelement ab. Das Element muss den zweistelligen ISO-Code f\00FCr ein Land enthalten. </p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Land'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><strong>US</strong>: USA</li>',
unistr('<li><strong>UK</strong>: Vereinigtes K\00F6nigreich</li>'),
'<li><strong>DE</strong>: Deutschland</li>',
unistr('<li><strong>AT</strong>: \00D6sterreich</li>'),
'</ul>'))
,p_help_text=>unistr('<p>W\00E4hlen Sie eine Seite oder ein Anwendungselement aus, von der bzw. dem das Land f\00FCr das Geocoding abgerufen werden soll. Das Element muss den zweistelligen ISO-Code f\00FCr ein Land enthalten.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Land'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Land f\00FCr das Geocoding aus.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>10
,p_display_value=>'USA'
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Gro\00DFbritannien')
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>30
,p_display_value=>'Deutschland'
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>40
,p_display_value=>'Frankreich'
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>50
,p_display_value=>'Italien '
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>60
,p_display_value=>'Kanada'
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>70
,p_display_value=>'Niederlande'
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>80
,p_display_value=>'Belgien'
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>90
,p_display_value=>unistr('\00D6sterreich')
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>100
,p_display_value=>'Schweiz'
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>110
,p_display_value=>'Spanien'
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>120
,p_display_value=>'Portugal'
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>130
,p_display_value=>unistr('Russische F\00F6deration')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>140
,p_display_value=>'Estland'
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>150
,p_display_value=>'Indien'
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>160
,p_display_value=>'Mexiko'
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>170
,p_display_value=>'Australien'
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>180
,p_display_value=>'Brasilien'
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>190
,p_display_value=>'Chile'
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>200
,p_display_value=>'Tschechische Republik'
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>210
,p_display_value=>'Norwegen'
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>220
,p_display_value=>'Finnland'
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>230
,p_display_value=>unistr('D\00E4nemark')
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>240
,p_display_value=>'Hongkong'
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>250
,p_display_value=>'Irland'
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>260
,p_display_value=>'Lettland'
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>270
,p_display_value=>unistr('Rum\00E4nien')
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>280
,p_display_value=>'Kolumbien'
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>290
,p_display_value=>'Polen'
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>300
,p_display_value=>'Vereinigte Arabische Emirate'
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>310
,p_display_value=>'Ungarn'
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>320
,p_display_value=>'Saudi-Arabien'
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4414)
,p_display_sequence=>330
,p_display_value=>unistr('S\00FCdafrika')
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>'Adresselement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Element aus, das unstrukturierte Adressteile durch Kommas getrennt enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>unistr('Stra\00DFenelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Element aus, das den Teil <em>Stra\00DFe</em> der Adresse enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>'Hausnummernelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Element aus, das den Teil <em>Hausnummer</em> der Adresse enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>'Ortsteilelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Element aus, das den Teil <em>Ortsteil</em> der Adresse enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>'Ortselement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Element aus, das den Teil <em>Ort</em> der Adresse enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Postleitzahlelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Element aus, das den Teil <em>Postleitzahl</em> der Adresse enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>'Regionselement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Element aus, das den Teil <em>Region (Bundesland)</em> der Adresse enth\00E4lt.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Adresse bereinigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Aktivieren Sie diesen Schalter, um Adressdaten aus dem Geocoding-Service wieder den zugeordneten Elementen zuzuf\00FChren.</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>unistr('\00DCbereinstimmungsvektorelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie ein Seitenelement aus, an das der Geocoder den <em>\00DCbereinstimmungsvektor</em> zur\00FCckgibt. Der \00DCbereinstimmungsvektor ist eine 17-stellige Zeichenfolge mit detaillierten Informationen dazu, wie jedes Adressattribut den zum Geocoding ver')
||'wendeten Daten zugeordnet wurde.</p>',
unistr('<p><strong>Die Ziffern des \00DCbereinstimmungsvektors k\00F6nnen die folgenden Werte aufweisen:</strong></p>'),
'<ul>',
'<li><p>0: Das Eingabeattribut ist nicht Null und wird einem Wert ungleich Null zugeordnet.</p></li>',
'<li><p>1: Das Eingabeattribut ist Null und wird einem Nullwert zugeordnet.</p></li>',
'<li><p>2: Das Eingabeattribut ist nicht Null und wird durch einen anderen Wert ungleich Null ersetzt.</p></li>',
'<li><p>3: Das Eingabeattribut ist nicht Null und wird durch einen Nullwert ersetzt.</p></li>',
'<li><p>4: Das Eingabeattribut ist Null und wird durch einen Wert ungleich Null ersetzt.</p></li>',
'</ul>',
'<br>',
unistr('<p><strong>\00DCbereinstimmungsvektorziffern und das Adressattribut entsprechen den folgenden Elementen:</strong></p>'),
'<ul>',
unistr('<li><p>3: Adresspunkt (genaue Adresse mit \00DCbereinstimmung in den zum Geocoding verwendeten Daten)</p></li>'),
unistr('<li><p>4: Name f\00FCr den jeweiligen Ort von Interesse</p></li>'),
'<li><p>5: Hausnummer</p></li>',
unistr('<li><p>6: Stra\00DFenpr\00E4fix</p></li>'),
unistr('<li><p>7: Stra\00DFenname</p></li>'),
unistr('<li><p>8: Stra\00DFensuffix</p></li>'),
unistr('<li><p>9: Stra\00DFentyp</p></li>'),
unistr('<li><p>10: Sekund\00E4re Einheit</p></li>'),
'<li><p>11: Ort</p></li>',
'<li><p>14: Region</p></li>',
'<li><p>15: Land</p></li>',
'<li><p>16: Postleitzahl</p></li>',
unistr('<li><p>17: Erg\00E4nzende Postleitzahl</p></li>'),
'<li><p><em>Andere Ziffern werden noch nicht verwendet.</em></p></li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Geocoding ausl\00F6sen')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Bestimmen Sie, wann das Geocoding ausgel\00F6st werden soll. Dabei f\00FChrt der Browser die REST-Anforderung an den Geocoding-Service aus und zeigt das Popup-Fenster mit m\00F6glichen \00DCbereinstimmungen an.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4414)
,p_display_sequence=>10
,p_display_value=>'Automatisch'
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geocoding wird automatisch ausgel\00F6st, bevor die Seite weitergeleitet wird.</p>'),
unistr('<p>Wenn ein abh\00E4ngiger Elementwert ge\00E4ndert wurde, z.B. der Wert von <em>P1_STREET</em>, und Geocoding noch nicht ausgef\00FChrt oder keine g\00FCltige Adresse ausgew\00E4hlt wurde, wird sichergestellt, dass Geocoding automatisch ausgel\00F6st wird. In diesem Fall w')
||unistr('ird der Weiterleitungsfluss der aktuellen Seitenweiterleitung unterbrochen und zun\00E4chst ein Popup-Fenster mit m\00F6glichen \00DCbereinstimmungen angezeigt. Wenn der Benutzer eine der \00DCbereinstimmungen ausw\00E4hlt, kann die Seite ohne weitere Unterbrechung weit')
||'ergeleitet werden.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4414)
,p_display_sequence=>20
,p_display_value=>'Dynamische Aktion'
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>Geocoding muss ausgel\00F6st werden, indem Sie die dynamische Aktion <em>Geocoding ausl\00F6sen</em> zur Seite hinzuf\00FCgen.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4414)
,p_display_sequence=>30
,p_display_value=>'jQuery-Selektor'
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>Geocoding wird basierend auf einem Ereignis im DOM-Element des Selektors ausgel\00F6st. Wenn ein Eingabefeld referenziert wird, wird Geocoding bei einer <em>\00C4nderung</em> des Elements ausgel\00F6st. Wenn eine Schaltfl\00E4che referenziert wird, wird Geocoding')
||unistr(' <em>beim Klicken</em> ausgel\00F6st.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Selektor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Prozess ausf\00FChren, wenn Elemente <em>P1_STREET</em> und <em>P1_ZIP_CODE</em> sich \00E4ndern, jQuery-Selektor:</p>'),
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>Geben Sie den jQuery-Selektor an, der das Element referenziert, das das Geocoding ausl\00F6st. Schaltfl\00E4chen l\00F6sen Geocoding <em>beim Klicken</em> aus. Andere Elemente l\00F6sen es <em>bei \00C4nderung</em> aus.</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_name=>'apexgeocoderresponse'
,p_display_name=>'Geocoding-Antwort'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4414)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4414)
,p_name=>'apexgeocoderselection'
,p_display_name=>'Ergebnisauswahl'
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>'Intelligente Filter'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>Eine Region basierend auf der Quelle eines verkn\00FCpften intelligenten Filters, \00FCber die Endbenutzer zahlreiche Filter erhalten, mit denen die Suchergebnisse zur Laufzeit eingegrenzt werden k\00F6nnen. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4414)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Maximale Anzahl Suggestions-Chips'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Geben Sie die maximale Anzahl der Suggestion-Chips an, die angezeigt werden sollen. Wenn keine Angabe erfolgt, wird ein Standardwert von 5 verwendet.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4414)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Weitere Filter - Suggestions-Chips'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob Filter, die nicht als Suggestion-Chips angezeigt werden, \00FCber das Dropdown-Men\00FC "Weitere Filter" ausgew\00E4hlt werden k\00F6nnen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4414)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Schwellenwert f\00FCr kompakte Zahlen')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie einen Schwellenwert an, \00FCber dem die Anzahl mit einem kompakten Zahlenformat angezeigt wird. Beim kompakten Zahlenformat wird der Wert<strong>1.234</strong> als <strong>1K</strong> angezeigt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4414)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Gesamtanzahl von Zeilen anzeigen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Geben Sie an, wo die Gesamtzeilenanzahl angezeigt werden soll.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4414)
,p_display_sequence=>10
,p_display_value=>'Nein'
,p_return_value=>'N'
,p_help_text=>'Die Gesamtzeilenanzahl wird nicht angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4414)
,p_display_sequence=>20
,p_display_value=>'Ja'
,p_return_value=>'Y'
,p_help_text=>'Die Gesamtzeilenanzahl wird unter den Suggestion-Chips angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4414)
,p_display_sequence=>30
,p_display_value=>'Selektor'
,p_return_value=>'E'
,p_help_text=>unistr('Die Gesamtzeilenanzahl (ohne Label) wird innerhalb des Elements angezeigt, das durch diesen Selektor angegeben ist. Dadurch k\00F6nnen Sie die Gesamtzeilenanzahl an einer beliebigen Stelle auf der Seite platzieren.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4414)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Label f\00FCr Zeilenanzahl gesamt')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Label f\00FCr die Gesamtzeilenanzahl. Wenn hier kein Label angegeben wird, verwendet APEX die APEX.FS.TOTAL_ROW_COUNT_LABEL-Textnachricht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4414)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Selektor f\00FCr Gesamtzeilenzahl')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Das ist der Selektor eines Elements auf der Seite, auf der die Gesamtzeilenanzahl in der Region f\00FCr intelligente Filter angezeigt wird.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4414)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4414)
,p_name=>'facetschange'
,p_display_name=>unistr('Filter\00E4nderung')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4414)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4414)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4414)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4414)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Gibt Legacy-ORDS-JSON zur\00FCck')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Aktivieren Sie diese Option, wenn dieser ORDS-REST-Service Daten in der <em>ORDS-Legacy-JSON-Darstellung</em> zur\00FCckgibt.')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>'Suche'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt ein Textfeld an, mit dem der Endbenutzer die Listeneintr\00E4ge der Facets in der Facet-Suchregion durchsuchen kann. Eine Facet-Suchregion unterst\00FCtzt ein Such-Facet, das immer oben in der Liste der Facets angezeigt wird, unabh\00E4ngig von der jeweili')
||'gen Sequenz.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4414)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Suchtyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4414)
,p_display_sequence=>10
,p_display_value=>'Zeilensuche'
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4414)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4414)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Eingabefeld'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4414)
,p_display_sequence=>10
,p_display_value=>'Oben in der Facet-Suchregion'
,p_return_value=>'FACET'
,p_help_text=>unistr('Ein Suchfeld wird oben in der Facet-Suchregion \00FCber den Facets gerendert.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4414)
,p_display_sequence=>20
,p_display_value=>'Externes Seitenelement'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('Ein Seitenelement kann mit dem zugeh\00F6rigen Attribut "Externes Seitenelement" ausgew\00E4hlt werden, damit es als Suchfeld f\00FCr die Facet-Suchregion verwendet werden kann.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4414)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Externes Seitenelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4414)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Ausgeblendetes Suchfeld'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob das Suchfeld f\00FCr "Intelligente Filter" anf\00E4nglich ausgeblendet wird.')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>'Map'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4414)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4414)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4414)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4414)
,p_name=>'spatialmapchanged'
,p_display_name=>unistr('Karte ge\00E4ndert')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4414)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4414)
,p_name=>'spatialmapclick'
,p_display_name=>'Auf Karte wurde geklickt'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4414)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4414)
,p_name=>'spatialmapinitialized'
,p_display_name=>'Karte initialisiert'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4414)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4414)
,p_name=>'spatialmapobjectclick'
,p_display_name=>'Auf Kartenobjekt wurde geklickt'
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>'Formular'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Formularregion, die verschiedene Datenquellen unterst\00FCtzt. Diese Formularregion enth\00E4lt Informationen zur Datenquelle (diese kann lokal, remote oder ein REST-Service sein) und ist mit Seitenelementen verkn\00FCpft. Jedes Element wird einer Formularregion')
||' und einer Anzeigeregion zugewiesen.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4414)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4414)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>'Formular - Automatische Zeilenverarbeitung (DML)'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Prozess zum Einf\00FCgen, Aktualisieren oder L\00F6schen von Zeilen der Formularregion.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Zieltyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Legen Sie fest, welche Zeilenverarbeitungstechnik ausgef\00FChrt wird, um Daten\00E4nderungen zu speichern, die an der Formularregion vorgenommen wurden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4414)
,p_display_sequence=>10
,p_display_value=>'Regionsquelle'
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCgt die SQL-Abfrage der Regionsquelle ein, aktualisiert und l\00F6scht sie.</p>'),
unistr('<p>Hinweis - Stellen Sie sicher, dass f\00FCr Spalten, die nicht eingef\00FCgt oder aktualisiert werden k\00F6nnen, <strong>Nur Abfrage</strong> auf <code>Ja</code> festgelegt ist, damit sie aus der Verarbeitung ausgeschlossen werden.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4414)
,p_display_sequence=>20
,p_display_value=>'Tabelle/View'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCgt eine andere Tabelle oder View in die in der SQL-Abfrage der Quellregion definierten Tabelle oder View ein, aktualisiert und l\00F6scht sie.'),
unistr('Beispiel: Die SQL-Abfrage ruft Daten aus einem Table-Join oder einer nicht aktualisierbaren View ab, und die DML-Verarbeitung muss mit einer einzelnen Basistabelle oder aktualisierbaren View ausgef\00FChrt werden.</p>'),
unistr('<p>Hinweis - Stellen Sie sicher, dass f\00FCr Spalten, die nicht eingef\00FCgt oder aktualisiert werden k\00F6nnen, <strong>Nur Abfrage</strong> auf <code>Ja</code> festgelegt ist, damit sie aus der Verarbeitung ausgeschlossen werden.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4414)
,p_display_sequence=>30
,p_display_value=>'PL/SQL-Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die Verarbeitung basiert auf benutzerdefiniertem PL/SQL-Code. Mit dieser Option k\00F6nnen Sie beliebigen PL/SQL-Code ausf\00FChren, um die Datenverarbeitung in der zugrunde liegenden Datenbank zu implementieren.</p>'),
unistr('<p>Diese Option muss bei der Verwendung von Datenbankpackages verwendet werden, wie Tabellen-APIs oder Aufrufen von RESTful Web Services, um Gesch\00E4ftslogik zu implementieren.</p>'),
unistr('<p>Hinweis - Der PL/SQL-Code wird f\00FCr jede Zeile aufgerufen, die eingef\00FCgt, aktualisiert oder gel\00F6scht wurde.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4414)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('PL/SQL-Code f\00FCr Insert/Update/Delete')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie PL/SQL-Code ein, um jede Zeile mit Daten zu verarbeiten, die in der Formularregion bearbeitet wird.</p>',
unistr('<p>Verwenden Sie den Spaltennamen als Bind-Variable, um auf den Wert einer Spalte zuzugreifen. Die Systemvariable <code>APEX$ROW_STATUS</code> gibt den Status einer Zeile zur\00FCck. Mit ihr kann gepr\00FCft werden, ob die Zeile erstellt, aktualisiert oder g')
||unistr('el\00F6scht wurde (dies wird im Beispiel unten dargestellt).</p>'),
unistr('<p><em>Hinweis:</em> Wenn Prim\00E4rschl\00FCsselspalten von einem Trigger oder im PL/SQL-Code aufgef\00FCllt werden, m\00FCssen die neuen Werte den Bind-Variablen der Prim\00E4rschl\00FCsselspalten zugewiesen werden, weil &PRODUCT_NAME. diese Werte f\00FCr den Abruf der Zeile ')
||unistr('nach einem Einf\00FCge- oder Aktualisierungsvorgang verwendet.</p>'),
'<p>Oracle empfiehlt den Aufruf von Prozeduren oder Funktionen innerhalb eines PL/SQL-Packages, um die Wiederverwendung und Wartbarkeit zu vereinfachen.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Verlorene Updates verhindern'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob die Verarbeitung sicherstellen soll, dass Updates nicht verloren gehen, wenn mehrere Benutzer denselben Datenbankdatensatz aktualisieren.</p> ',
unistr('<p>Zu verlorenen Updates kommt es, wenn zwei oder mehr Personen versuchen, dieselben Daten zu aktualisieren und das letzte Update Updates \00FCberschreibt, die vom ersten Benutzer vorgenommen wurden, um die \00C4nderungen zu speichern. Um dies zu verhindern,')
||unistr(' k\00F6nnen Updates die vorhandenen Spaltenwerte in der Datenbank mit den Werten vergleichen, die abgerufen wurden, als die Zeile urspr\00FCnglich abgefragt wurde.</p>'),
'<p>Beispiel:',
'  <ol>',
unistr('    <li>Benutzer A fragt Mitarbeiterdatens\00E4tze (EMP) ab.</li>'),
unistr('    <li>Benutzer B fragt dieselben Mitarbeiterdatens\00E4tze ab.</li>'),
unistr('    <li>Benutzer B aktualisiert Mitarbeiterdetails f\00FCr EMPNO = 7839 und \00FCbernimmt (speichert) die \00C4nderungen in der Datenbank.</li>'),
unistr('    <li>Benutzer A aktualisiert Mitarbeiterdetails f\00FCr EMPNO = 7839 und versucht, die \00C4nderungen in der Datenbank zu \00FCbernehmen.</li>'),
'  </ol>',
unistr('Wenn Benutzer A dieselbe Zeile erfolgreich aktualisiert, sind die \00C4nderungen von Benutzer B verloren.'),
unistr('Wenn Benutzer A versucht, die Mitarbeiterzeile zu speichern, sind die Daten in der Datenbank nicht mehr identisch mit den Daten, die Benutzer A urspr\00FCnglich abgerufen hat. In Schritt 1 oben k\00F6nnen die urspr\00FCnglich von Benutzer A abgefragten Daten erf')
||unistr('asst werden. In Schritt 4 oben k\00F6nnen die Werte mit den aktuellen Werten in der Datenbank verglichen werden. Dieser Vergleich l\00F6st einen Fehler f\00FCr Benutzer A aus, weil die Datenbankwerte von Benutzer B in Schritt 3 aktualisiert wurden. Dadurch wird ')
||unistr('verhindert, dass ein Benutzer \00C4nderungen \00FCberschreibt, die von einem anderen Benutzer an derselben Zeile vorgenommen wurden.</p>'),
unistr('<p>Hinweis - Wie die verlorenen Updates ermittelt werden, wird in den Attributen f\00FCr die Region "Interaktives Grid" basierend auf der Einstellung f\00FCr <strong>Verlorenes Update - Typ</strong> angegeben.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Zeile sperren'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie, ob jede Zeile, die aktualisiert oder gel\00F6scht werden soll, in der zugrundliegenden Tabelle gesperrt wird, bevor die Zeile verarbeitet wird.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4414)
,p_display_sequence=>10
,p_display_value=>'Ja'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeilen, die aktualisiert oder gel\00F6scht werden m\00FCssen, werden mit SELECT ... FOR UPDATE gesperrt, um zu verhindern, dass andere Transaktionen mit der Zeile durchgef\00FChrt werden, bis die Transaktion gespeichert wird.</p>'),
unistr('<p>Hinweis - Wenn ein Fehler ausgel\00F6st wird, wie bei aktualisierbaren Views, die eine Sperre nicht unterst\00FCtzen, k\00F6nnen Sie PL/SQL-Code nutzen, um die steuernde Tabelle zu sperren.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4414)
,p_display_sequence=>20
,p_display_value=>'Nein'
,p_return_value=>'N'
,p_help_text=>'Zeilen werden nicht gesperrt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4414)
,p_display_sequence=>30
,p_display_value=>'PL/SQL-Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>'Benutzerdefinierter PL/SQL-Code wird verwendet, um die Zeilen zu sperren, bis die Transaktion gespeichert wird.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'PL/SQL-Code zur Sperre von Zeilen'
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Geben Sie den PL/SQL-Code ein, um die Zeilen der Datenbanktabelle zu sperren, die aktualisiert und gel\00F6scht werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4414)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Prim\00E4rschl\00FCssel nach Einf\00FCgen zur\00FCckgeben')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Legen Sie fest, ob die Prim\00E4rschl\00FCsselspalten in die entsprechenden Regionselemente zur\00FCckgegeben werden sollen, nachdem die Zeile in die Datenbank eingef\00FCgt wurde.'),
unistr('Im Allgemeinen sollten Sie diese Option verwenden, wenn die Prim\00E4rschl\00FCsselspalten aus einem Datenbanktrigger oder einer Oracle Database 12 <em>c</em>-Identit\00E4tsspalte aufgef\00FCllt werden.</p>'),
unistr('<p>Hinweis: Wenn eine Fehlermeldung ausgegeben wird, dass die RETURNING INTO-Klausel nicht zul\00E4ssig ist, m\00FCssen Sie diese Option auf "Nein" setzen und die Prim\00E4rschl\00FCsselspalten im Voraus ausf\00FCllen.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>'Formular - Initialisierung'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Prozess zum Initialisieren von Elementen einer Formularregion. Bei der Initialisierung k\00F6nnen Daten aus der Regionsquelle abgerufen, Prim\00E4rschl\00FCsselwerte verwendet oder Elemente der Formularregion einfach initialisiert werden.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4414)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00E4chste(s) Prim\00E4rschl\00FCsselelement(e)')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4414)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Vorherige(s) Prim\00E4rschl\00FCsselelement(e)')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4414)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Aktuelle Zeile/Gesamtelemente'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>'Laden von Daten'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Prozess zum Laden von Daten in die Zieltabelle oder Collection basierend auf der angegebenen Datenladedefinition.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Datenladedefinition'
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die <strong>Datenladedefinition</strong> in "Gemeinsame Komponenten" aus. In der Datenladedefinition sind neben anderen Attributen die Zieltabelle oder Collection, die Lademethode und das <em>Datenprofil</em> definiert. Alle Informationen ')
||'zu Spaltenname, Spaltenzuordnung und Datentyp sind im Datenprofil gespeichert.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Quelldatentyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Geben Sie die Quelle der zu ladenden Daten an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4414)
,p_display_sequence=>10
,p_display_value=>'Dateisuchelement'
,p_return_value=>'FILE'
,p_help_text=>unistr('W\00E4hlen Sie den Namen eines Dateisuchelements auf der aktuellen Seite aus. APEX l\00E4dt Daten aus der ausgew\00E4hlten Datei.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4414)
,p_display_sequence=>20
,p_display_value=>'Name des Textbereichselements'
,p_return_value=>'TEXT'
,p_help_text=>unistr('W\00E4hlen Sie den Namen eines Textbereichselements aus, das die zu ladenden Daten enth\00E4lt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4414)
,p_display_sequence=>30
,p_display_value=>'SQL-Abfrage'
,p_return_value=>'SQL_QUERY'
,p_help_text=>unistr('Geben Sie eine SQL-Abfrage an, die ein CLOB oder ein BLOB zur\00FCckgibt, das die zu ladenden Daten enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Dateisuchelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('W\00E4hlen Sie das Dateisuchelement aus, aus dem Daten geladen werden sollen. Das Element muss <strong>APEX_APPLICATION_TEMP_FILES</strong> als <strong>Speichertyp</strong> verwenden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Textbereichselement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('W\00E4hlen Sie den Namen eines Textbereichselements aus, das die zu ladenden Daten enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'SQL-Abfrage'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>unistr('Geben Sie eine SQL-Abfrage an, die eine Zeile und eine Spalte mit einem BLOB oder CLOB zur\00FCckgibt, aus dem Daten geladen werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Seitenelement mit dem XLSX-Arbeitsblattnamen'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ein Auswahllisten- oder Popup-Wertelistenelement zum Anzeigen verf\00FCgbarer Arbeitsbl\00E4tter in der hochgeladenen XLSX-Datei w\00FCrde die folgende <em>Wertelisten-SQL-Abfrage</em> verwenden (<strong>PX_FILE</strong> ist das Dateisuchelement, das zum Hoch')
||unistr('laden der XLSX-Datei verwendet wird).</p><p>Hinweis: Das Attribut <strong>SHEET_FILE_NAME</strong> muss als die Wertelisten-R\00FCckgabespalte verwendet werden.</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>Geben Sie ein Seitenelement an, das einen Arbeitsblattnamen f\00FCr das Laden von XLSX-Dateien enth\00E4lt. Daten werden aus dem angegebenen Arbeitsblatt geladen. Ist kein Wert angegeben, l\00E4dt APEX Daten aus dem ersten Arbeitsblatt in der XLSX-Datei.</p><')
||unistr('p>Normalerweise werden hierf\00FCr <em>Auswahllistenelemente</em> verwendet: Verwenden Sie in der <em>Wertelistenabfrage</em> den Wert <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong>, um Anzeigenamen und interne Namen f\00FCr Arbeitsbl\00E4tter abzurufen.<')
||'/p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Element "Verarbeitete Zeilenanzahl"'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie ein Seitenelement aus, in dem die Anzahl der hochgeladenen (und verarbeiteten) Zeilen gespeichert wird. Der Wert ist nach Abschluss des Datenladeprozesses verf\00FCgbar und kann zur Anzeige in Nachrichten verwendet werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4414)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Element "Anzahl Fehlerzeilen"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie ein Seitenelement aus, in dem die Anzahl der Fehlerzeilen gespeichert wird. Der Wert ist nach Abschluss des Datenladeprozesses verf\00FCgbar und kann zur Anzeige in Nachrichten verwendet werden.')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>'Bereich'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Zeigt ein Element mit einem integrierten Wertelistenselektor an. Das Facet unterst\00FCtzt Einzel- oder Mehrfachauswahl sowie manuelle Eingabe. Bei der Einzelauswahl werden mehrere Werte als Optionsgruppe angezeigt, aus der der Endbenutzer einen einze')
||unistr('lnen Wert ausw\00E4hlen kann. Bei der Mehrfachauswahl werden mehrere Werte als Kontrollk\00E4stchen angezeigt, sodass der Endbenutzer mehrere Werte ausw\00E4hlen kann. Bei der manuellen Eingabe werden unterhalb des Facets Textfelder gerendert, in denen der Endbe')
||unistr('nutzer den Wertebereich manuell eingeben kann, den er zur Filterung der gefilterten Region verwenden m\00F6chte.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4414)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Mehrere ausw\00E4hlen')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob das Facet die Auswahl mehrerer Listeneintr\00E4ge unterst\00FCtzt. Wenn diese Option auf <strong>Ein</strong> gesetzt ist, wird das Facet zur Unterst\00FCtzung der Mehrfachauswahl als Kontrollk\00E4stchen gerendert. Wenn die Option auf <strong>Aus</')
||unistr('strong> gesetzt ist, wird das Facet zur Unterst\00FCtzung der Einzelauswahl als Optionsgruppe gerendert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4414)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Manuelle Eingabe'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob das Bereichs-Facet eine manuelle Eingabe unterst\00FCtzt. Wenn Sie diese Option auf <strong>Ein</strong> setzen, werden unterhalb des Facets Textfelder gerendert, in denen der Endbenutzer den Wertebereich manuell eingeben kann, den er zu')
||unistr('r Filterung der gefilterten Region verwenden m\00F6chte.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4414)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Bereichstext'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Geben Sie den Text ein, der zwischen den Textfeldern f\00FCr die manuelle Eingabe angezeigt werden soll.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4414)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Aktuelles Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'0% bis %1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4414)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Aktuelles Label - Offen - Hoch'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('\00DCber %0')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4414)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Aktuelles Label - Offen - Niedrig'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Unter %0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4414)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4414)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Auf SQL-Abfrage basierende Werteliste</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Werteliste mit demselben Anzeige- und R\00FCckgabewert</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Wenn dieselbe Spalte f\00FCr die Anzeige und R\00FCckgabewerte ausgew\00E4hlt wird, verwenden Sie einen Spaltenalias.</p>'),
'</dd>',
'<dt>Werteliste mit Bind-Variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>'Karte anzeigen'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt eine Karte basierend auf Koordinaten im GeoJSON-Punktformat an.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Hintergrund'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die zu verwendende Hintergrundkarte aus.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4414)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Verwenden Sie den Standardkartenhintergrund.</p>',
unistr('<p>Es wird entweder "OpenStreetMap - Hell" oder "OpenStreetMap - Dunkel" f\00FCr dunkle Themes verwendet.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4414)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap - Hell'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Allgemeine Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden Details zum Speicherortkontext f\00FCr Ihre Daten bereitgestellt.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4414)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap - Dunkel'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige, dunkle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4414)
,p_display_sequence=>40
,p_display_value=>'OpenStreetMap - Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Unauff\00E4llige, helle Basiskarte auf der Grundlage von OpenStreetMap-Daten. Bei diesem Basiskartenstil werden die Visualisierungen Ihrer Daten hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von KlokanTech.com und OpenMapTiles-Beitragenden, abgeleitet von "Mapbox Open Styles". Lizenziert im Rahmen der BSD/CC-BY-Lizenz. Die Kartografie von Stamen Design ist unter CC0 lizenziert.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Auf GitHub anzeigen</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4414)
,p_display_sequence=>50
,p_display_value=>'Oracle-Weltkarte'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Allgemeine Basiskarte auf der Grundlage von HERE-Kartendaten. Bei diesem Basiskartenstil wird der Speicherortkontext f\00FCr Ihre Daten bereitgestellt, und die Visualisierung Ihrer Daten wird hervorgehoben.</p>'),
'<p>Stilschema und -definitionen von Oracle, USA.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Zoomfaktor'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den Zoomfaktor an, damit dieser Layer sichtbar wird.</p>',
'<p>',
'Mindestwert: 1<br>',
unistr('H\00F6chstwert: 18'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Marker anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'<p>Geben Sie an, ob ein Marker angezeigt werden soll.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Markerfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die F\00FCllfarbe des Markers an.</p>'),
'<p>Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben. Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz jeweils die be'
||unistr('iden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen. RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'QuickInfo'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den QuickInfo-Text f\00FCr einen angezeigten Marker an.</p>'),
unistr('<p>Das QuickInfo-Attribut unterst\00FCtzt HTML und APEX-Templateanweisungen.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Kartensteuerelemente anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob Kartensteuerelemente angezeigt werden sollen.</p>',
unistr('<p>Dadurch werden der Karte Steuerelemente f\00FCr Zoom und Drehen hinzugef\00FCgt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Interaktive Karte'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob die Karte interaktiv sein soll.</p>',
unistr('<p>Bei "Nein" wird eine statische Karte ohne Interaktivit\00E4t erstellt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4414)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('H\00F6he')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'Pixel'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die H\00F6he der angezeigten Karte (in Pixel) an.</p>'),
unistr('<p>Die Standardh\00F6he der Karte wird basierend auf ihrer Breite mit dem Seitenverh\00E4ltnis 3:2 berechnet.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>'Exists-SQL-Abfrage'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Eine Abfrage, die dazu f\00FChrt, dass ein Autorisierungsschema erfolgreich ist, wenn es mindestens eine Zeile zur\00FCckgibt, und nicht erfolgreich, wenn keine Zeilen zur\00FCckgegeben werden.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4414)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL-Abfrage'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  aus apex_workspace_group_users',
' wobei user_name  = :APP_USER',
'   und group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>unistr('Eine Abfrage, die dazu f\00FChrt, dass ein Autorisierungsschema erfolgreich ist, wenn es mindestens eine Zeile zur\00FCckgibt, und nicht erfolgreich ist, wenn keine Zeilen zur\00FCckgegeben werden.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>'Not Exists-SQL-Abfrage'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Eine Abfrage, die dazu f\00FChrt, dass ein Autorisierungsschema erfolgreich ist, wenn es keine Zeilen zur\00FCckgibt, und nicht erfolgreich, wenn es mindestens eine Zeile zur\00FCckgibt.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4414)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL-Abfrage'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('Eine Abfrage, die dazu f\00FChrt, dass ein Autorisierungsschema nicht erfolgreich ist, wenn es mindestens eine Zeile zur\00FCckgibt, und erfolgreich ist, wenn keine Zeilen zur\00FCckgegeben werden.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>'Element ist NULL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Wert des Elements ist Null.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4414)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('Die Autorisierung verl\00E4uft erfolgreich, wenn der Wert des Elements null ist, sonst verl\00E4uft sie nicht erfolgreich.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>'Element ist NOT NULL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Wert des Elements ist nicht Null.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4414)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Die Autorisierung verl\00E4uft erfolgreich, wenn der Wert des Elements nicht null ist, sonst verl\00E4uft sie nicht erfolgreich.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('PL/SQL-Funktion, die Boolean zur\00FCckgibt')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ein PL/SQL-Funktionsbody, der True oder False zur\00FCckgibt. Bei False verl\00E4uft das Autorisierungsschema nicht erfolgreich. Bei True verl\00E4uft es erfolgreich.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4414)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'PL/SQL-Funktionsbody'
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ein PL/SQL-Funktionsbody, der True oder False zur\00FCckgibt. Bei False verl\00E4uft das Autorisierungsschema nicht erfolgreich. Bei True verl\00E4uft es erfolgreich.'),
'<p/>',
'Beispiel:',
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>'Voreinstellung entspricht Wert'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Wert der Voreinstellung entspricht Wert.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4414)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Voreinstellungsname'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Die Autorisierung verl\00E4uft erfolgreich, wenn der Wert dieser Voreinstellung gleich dem Wert in dem Feld unten ist. Sie verl\00E4uft nicht erfolgreich, wenn die Werte unterschiedlich sind.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4414)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'siehe oben'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>'Voreinstellung entspricht NICHT Wert'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Wert der Voreinstellung entspricht dem Wert nicht.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4414)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Voreinstellungsname'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Die Autorisierung verl\00E4uft erfolgreich, wenn der Wert dieser Voreinstellung nicht gleich dem Wert in dem Feld unten ist. Sie verl\00E4uft nicht erfolgreich, wenn die Werte gleich sind.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4414)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'siehe oben'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>'Element entspricht Wert'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Wert des Elements entspricht Wert.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4414)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Die Autorisierung verl\00E4uft erfolgreich, wenn der Wert dieses Elements gleich dem Wert in dem Feld unten ist. Sie verl\00E4uft nicht erfolgreich, wenn die Werte unterschiedlich sind.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4414)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'siehe oben'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>'Element entspricht NICHT Wert'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Wert des Elements entspricht nicht dem Wert.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4414)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Die Autorisierung verl\00E4uft erfolgreich, wenn der Wert dieses Elements nicht gleich dem Wert in dem Feld unten ist. Sie verl\00E4uft nicht erfolgreich, wenn die Werte gleich sind.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4414)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'siehe oben'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('Geocoding ausl\00F6sen')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>L\00F6sen Sie die Geocoding-Suche eines <em>Geocode-Adresselements</em> manuell aus.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>'Social Sign-In'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Unterst\00FCtzt die Authentifizierung mit Google, Facebook, generischem OpenID Connect und generischen OAuth2-Identit\00E4tsprovidern.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Zugangsdatenspeicher'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie den Zugangsdatenspeicher aus, der die Client-ID und das Client Secret f\00FCr den Authentifizierungsprovider enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentifizierungsprovider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect-Provider'
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>'Verwenden Sie einen OpenID Connect-basierten Authentifizierungsprovider. Geben Sie unten die OpenID-Discovery-URL des Providers ein.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_display_sequence=>20
,p_display_value=>'Generischer OAuth2-Provider'
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('Verwenden Sie einen OAuth2-Authentifizierungsprovider. Geben Sie unten die URLs f\00FCr die Autorisierungs-, Token- und Benutzerinformations-Endpunkte ein.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('Verwenden Sie vordefinierte Einstellungen f\00FCr die Google-Anmeldung.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('Verwenden Sie vordefinierte Einstellungen f\00FCr die Facebook-Anmeldung.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery-URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Geben Sie die Discovery-URL des OpenID Connect-Providers ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Autorisierungsendpunkt-URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Geben Sie die Autorisierungsendpunkt-URL des OAuth2-Providers ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Tokenendpunkt-URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Geben Sie die Tokenendpunkt-URL des OAuth2-Providers ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Benutzerinformations-Endpunkt-URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Geben Sie die Benutzerinformations-Endpunkt-URL des OAuth2-Providers ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Geltungsbereich'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'E-Mail,Profil'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Geben Sie eine durch Komma getrennte Liste von Berechtigungen ein, die f\00FCr den Benutzer angefordert werden sollen, der sich anmeldet.'),
unistr('Die zul\00E4ssigen Werte sind vom Authentifizierungsprovider abh\00E4ngig.'),
unistr('F\00FCr OpenID Connect und Google f\00FCgt Application Express automatisch den Geltungsbereich "openid" hinzu.'),
unistr('Der Authentifizierungsprovider gibt Benutzerattribute basierend auf diesen Berechtigungen zur\00FCck.'),
unistr('Sie k\00F6nnen diese Attribute Anwendungselementen zuordnen oder mit einer Post-Authentifizierungsprozedur verarbeiten und dabei die APEX_JSON.GET_%-Funktionen verwenden.'),
'</p><p>',
'Die Geltungsbereiche und Attribute von OpenID Connect (auch als Claims bezeichnet) sind hier aufgelistet: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentifizierungs-URI-Parameter'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('Geben Sie optionale Parameter f\00FCr die Authentifizierungs-URI ein. Informationen zu unterst\00FCtzten Parametern finden Sie in der Dokumentation des Authentifizierungsproviders.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Benutzername'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Geben Sie das Attribut ein, das den Benutzernamen enth\00E4lt, oder freien Text mit mindestens einer in "#" eingeschlossenen Attributsubstitution.'),
unistr('Sie k\00F6nnen den Namen des Authentifizierungsschemas mit #APEX_AUTH_NAME# referenzieren.'),
'Beispiel: "#email# (#APEX_AUTH_NAME#)" ergibt einen Benutzernamen, der aus der E-Mail-Adresse gefolgt von " (", gefolgt vom Namen des Authentifizierungsschemas, gefolgt von ")" besteht, wie "jane.doe@example.com (Google)".',
'</p><p>',
unistr('Informationen zu unterst\00FCtzten Attributen finden Sie in der Dokumentation des Authentifizierungsproviders.'),
unistr('Beachten Sie, dass Sie den erforderlichen Geltungsbereich festlegen m\00FCssen. Andernfalls sendet der Authentifizierungsprovider nicht alle Attribute.'),
'Die Geltungsbereiche und Attribute von OpenID Connect (auch als Claims bezeichnet) sind hier aufgelistet: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Zus\00E4tzliche Benutzerattribute')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'Link,Bild,E-Mail'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Geben Sie eine durch Komma getrennte Liste zus\00E4tzlicher Benutzerdatenattribute ein.'),
'</p><p>',
unistr('Informationen zu unterst\00FCtzten Attributen finden Sie in der Dokumentation des Authentifizierungsproviders.'),
unistr('Beachten Sie, dass Sie den erforderlichen Geltungsbereich festlegen m\00FCssen. Andernfalls sendet der Authentifizierungsprovider nicht alle Attribute.'),
'Die Geltungsbereiche und Attribute von OpenID Connect (auch als Claims bezeichnet) sind hier aufgelistet: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>unistr('Benutzernamen in Gro\00DFbuchstaben konvertieren')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Konfigurieren Sie, ob die Attributwerte f\00FCr den Benutzernamen in Gro\00DFbuchstaben konvertiert werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Tokenauthentifizierungsmethode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie ein, wie die Client-ID und das Client Secret der Zugangsdaten an den Server \00FCbergeben werden sollen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4414)
,p_display_sequence=>10
,p_display_value=>'Basisauthentifizierung'
,p_return_value=>'BASIC'
,p_help_text=>'Senden Sie Client-ID und Client Secret in einem Basisauthentifizierungsheader.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4414)
,p_display_sequence=>22
,p_display_value=>'Basisauthentifizierung und Client-ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Senden Sie Client-ID und Client Secret in einem Basisauthentifizierungsheader, aber auch die Client-ID im Anforderungsbody.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4414)
,p_display_sequence=>30
,p_display_value=>'Client-ID und Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Senden Sie Client-ID und Client Secret im Anforderungsbody.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4414)
,p_display_sequence=>40
,p_display_value=>'Client-ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Client-ID nur im Anforderungsbody senden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>'Attribute verifizieren'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Ist diese Option aktiviert, sucht &PRODUCT_NAME. nach dem Attribut "#name#_verified" (z.B. "email_verified" f\00FCr das Attribut "email").'),
unistr('OpenID definiert, dass der Identit\00E4tsprovider <code>"#name#_verified":false</code> f\00FCr nicht verifizierte "email"- und "phone_number"-Attribute sendet.'),
'&PRODUCT_NAME. ignoriert solche nicht verifizierten Attribute.',
unistr('Dies f\00FChrt zu einer nicht erfolgreichen Authentifizierung, wenn das Benutzernameattribut "#name#" lautet.'),
'</p><p>',
unistr('Wenn der Identit\00E4tsprovider zul\00E4sst, dass Angreifer nicht verifizierte Daten eingeben, die die Anwendung zur Authentifizierung verwendet,'),
unistr('k\00F6nnen andere Benutzer in der Anwendung impersoniert werden.'),
unistr('Dies kann von der Pr\00FCfung "Attribute verifizieren" verhindert werden.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4414)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>unistr('Zus\00E4tzliche Benutzerattribute zuordnen zu')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie eine durch Komma getrennte Liste der Anwendungselementnamen an, denen <em>Zus\00E4tzliche Benutzerattribute</em> zugeordnet sind. Beispiel: Wenn Sie folgende Einstellungen festlegen'),
'<ul>',
unistr('<li>Zus\00E4tzliche Benutzerattribute: email,profile,picture</li>'),
unistr('<li>Zus\00E4tzliche Benutzerattribute zuordnen zu: G_EMAIL,G_PROFILE,G_PICTURE</li>'),
'</ul>',
unistr('speichert APEX die Attributwerte f\00FCr die entsprechenden Elemente automatisch im Sessionzustand.')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>'Listenansicht'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigen Sie Daten in einer Liste an, durch die einfach navigiert werden kann. Sie k\00F6nnen auch zahlreiche Features aufnehmen, um die Listenansicht zu erweitern.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Features'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die Features, die f\00FCr die Listenansicht aktiviert sind.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_display_sequence=>5
,p_display_value=>'Erweiterte Formatierung'
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_display_sequence=>10
,p_display_value=>'Bild anzeigen'
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_display_sequence=>20
,p_display_value=>'Listentrennlinie anzeigen'
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_display_sequence=>50
,p_display_value=>unistr('Hat geteilte Schaltfl\00E4che')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_display_sequence=>55
,p_display_value=>'Suche aktivieren'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_display_sequence=>65
,p_display_value=>'Ist verschachtelte Listenansicht'
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_display_sequence=>70
,p_display_value=>'Vertiefte Liste'
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Textspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('W\00E4hlen Sie die Datenbankspalte, die den Hauptinhalt f\00FCr den Listenansichtseintrag enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Listenattribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Der Client erstellt Trennlinien basierend auf dem Listenelementtext</dt>',
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
unistr('<dt>Symbol \00E4ndern</dt>'),
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>Symbol f\00FCr geteilte Schaltfl\00E4che \00E4ndern</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Geben Sie zus\00E4tzliche Attribute f\00FCr das Listenelement ein. Einige Attribute, die sich auf die Listenansicht auswirken, finden Sie in den Beispielen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Listeneintragsattribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Legt Symbol f\00FCr zu l\00F6schenden Listeneintragslink fest.</dt>'),
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Geben Sie zus\00E4tzliche Attribute f\00FCr das Listenelement ein. Einige Attribute, die sich auf die Listenansicht auswirken, finden Sie in den Beispielen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Textformatierung'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt Name und darunter das Einstellungsdatum eines Mitarbeiters an</dt>',
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Hire date: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das HTML-Markup f\00FCr die Wiedergabe des Hauptinhalts eines Listenansichtseintrags an.</p>'),
'<p>Um Spaltenwerte der SQL-Anweisung in der Listenansicht zu referenzieren, verwenden Sie Ersetzungssyntax.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Spalte f\00FCr zus\00E4tzliche Informationen')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('W\00E4hlen Sie die Datenbankspalte, die zus\00E4tzliche Informationen f\00FCr den Listenansichtseintrag enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Formatierung f\00FCr zus\00E4tzliche Informationen')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt das Gehalt in Fettschrift an</dt>',
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das HTML-Markup f\00FCr die Wiedergabe erg\00E4nzender Informationen f\00FCr einen Listenansichtseintrag an.</p>'),
'<p>Um Spaltenwerte der SQL-Anweisung in der Listenansicht zu referenzieren, verwenden Sie Ersetzungssyntax.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Z\00E4hlerspalte')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Datenbankspalte, die den Wert enth\00E4lt, der im Z\00E4hlerblasendiagramm angezeigt werden soll.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Bildtyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, welche Bildart angezeigt wird und von wo das Bild gelesen wird. Das angezeigte Bild kann ein Symbol mit einer Gr\00F6\00DFe von 16x16 oder ein Thumbnail mit einer Gr\00F6\00DFe von 80x80 sein. Die Quelle f\00FCr das Bild kann eine Datenbank-BLOB-Spalte oder ')
||'eine URL zu einer statischen Datei sein.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4414)
,p_display_sequence=>20
,p_display_value=>'Symbol in BLOB gespeichert'
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4414)
,p_display_sequence=>30
,p_display_value=>'Symbol aus URL gelesen'
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4414)
,p_display_sequence=>40
,p_display_value=>'Bild in BLOB gespeichert'
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4414)
,p_display_sequence=>50
,p_display_value=>'Bild aus URL gelesen'
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Bild-BLOB-Spalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('W\00E4hlen Sie die Datenbankspalte mit dem Datentyp BLOB, die das Bild enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Bild-Prim\00E4rschl\00FCsselspalte 1')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('W\00E4hlen Sie die Prim\00E4rschl\00FCsselspalte oder eine eindeutige Datenbankspalte, mit der das Bild gesucht wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Bild-Prim\00E4rschl\00FCsselspalte 2')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('W\00E4hlen Sie einen zweiten Prim\00E4rschl\00FCssel oder eine eindeutige Datenbankspalte, mit dem bzw. der das Bild gesucht wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Bild-URL-Spalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>unistr('W\00E4hlen Sie die Datenbankspalte, die die URL zum Symbol/Bild enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Listentrennlinien-Spalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('W\00E4hlen Sie die Datenbankspalte, die die Trennlinie enth\00E4lt. Bei jeder \00C4nderung des Trennlinienwertes wird eine neue Trennlinie zwischen den Listenansichtseintr\00E4gen angezeigt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Listentrennlinien-Formatierung'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt Abteilungsname und Anzahl von Mitarbeitern als Badge an</dt>',
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das HTML-Markup f\00FCr die Wiedergabe der Trennlinie einer Listenansicht an.</p>'),
'<p>Um Spaltenwerte der SQL-Anweisung in der Listenansicht zu referenzieren, verwenden Sie Ersetzungssyntax.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Linkziel'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Geben Sie eine Zielseite ein, die aufgerufen werden soll, wenn der Benutzer auf einen Listeneintrag klickt.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('Geteiltes Schaltfl\00E4chenziel')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Geben Sie eine Zielseite ein, die aufgerufen werden soll, wenn der Benutzer auf einen Listeneintrag klickt.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'Suchtyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Legen Sie fest, wie die Suche ausgef\00FChrt wird.</p>'),
unistr('<p>Eine clientseitige Suche wird sofort ausgef\00FChrt, wenn der Benutzer mit der Eingabe beginnt. Bei allen serverbasierten Suchen muss der Benutzer die Eingabetaste dr\00FCcken, um die Suchergebnisse anzuzeigen. Nur bei serverbasierten Suchen werden die Gl')
||unistr('obalisierungsattribute f\00FCr den Zeichenwertvergleich ber\00FCcksichtigt, die f\00FCr die Anwendung definiert sind.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4414)
,p_display_sequence=>20
,p_display_value=>'Clientseitig'
,p_return_value=>'CLIENT'
,p_help_text=>unistr('Zur Ausf\00FChrung einer browserbasierten Suche m\00FCssen alle Ansichtseintr\00E4ge in den Browser geladen werden (das Attribut "Anzahl abgerufener Zeilen" wird in diesem Fall ignoriert). Verwenden Sie diese Suchoption nur bei einer kleinen Anzahl von Listenein')
||unistr('tr\00E4gen, um unn\00F6tig lange Seitenladevorg\00E4nge zu vermeiden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4414)
,p_display_sequence=>30
,p_display_value=>unistr('Server: Genaue \00DCbereinstimmung und Gro\00DF-/Kleinschreibung beachten')
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>'Suche verwendet LIKE [Suchwert]% zur Abfrage des Ergebnisses.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4414)
,p_display_sequence=>40
,p_display_value=>unistr('Server: Genaue \00DCbereinstimmung und Gro\00DF-/Kleinschreibung ignorieren')
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>'Suche verwendet LIKE UPPER( [Suchwert] )% zur Abfrage des Ergebnisses. Vorhandene Indizes auf der Spalte werden nicht verwendet, es sei denn, es handelt sich um einen funktionsbasierten Index, der einen UPPER-Ausdruck verwendet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4414)
,p_display_sequence=>50
,p_display_value=>unistr('Server: \00C4hnliche und Gro\00DF-/Kleinschreibung beachten')
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>'Suche verwendet LIKE %[Suchwert]% zur Abfrage des Ergebnisses. Dies verhindert die Verwendung eines vorhandenen Indexes auf dieser Spalte.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4414)
,p_display_sequence=>60
,p_display_value=>unistr('Server: \00C4hnliche und Gro\00DF-/Kleinschreibung ignorieren')
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>'Suche verwendet LIKE %UPPER ([Suchwert])% zur Abfrage des Ergebnisses. Dies verhindert die Verwendung eines vorhandenen Indexes auf dieser Spalte.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>'Suchspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('W\00E4hlen Sie eine alternative Datenbankspalte f\00FCr die Suche. Wenn Sie nichts angeben, wird die Textspalte verwendet.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>'Suchfeld-Platzhalter'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>'Geben Sie den Text ein, der im Suchfeld angezeigt wird. Wenn Sie keinen Wert angeben, wird der Wert der Systemmeldung <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong> verwendet.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>unistr('Spalte f\00FCr verschachtelte Liste')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('W\00E4hlen Sie die Datenbankspalte, die die Hierarchieebene einer verschachtelten Abfrage enth\00E4lt. Wenn Sie eine CONNECT BY-Abfrage verwenden, ist dies die Pseudospalte <code>LEVEL</code>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4414)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt alle Mitarbeiter nach Name sortiert an.</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Zeigt alle Mitarbeiter der aktuellen Abteilung nach Name sortiert an</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
'<p>Wenn Bind-Variablen zur Referenzierung von Seitenelementen verwendet werden, geben Sie diese als <strong>Weiterzuleitende Seitenelemente<strong> an.</p>',
'</dd>',
unistr('<dt>Verwendet ROWID als Prim\00E4rschl\00FCsselspalte</dt>'),
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
'<p>Bei Verwendung von ROWID ist ein Spaltenalias erforderlich.</p>',
'</dd>',
unistr('<dt>Verschachtelte Abfrage, die alle Mitarbeiter zur\00FCckgibt</dt>'),
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>',
''))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('Region schlie\00DFen')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Schlie\00DFt eine Region (z.B. ein Inline-Dialogfeld, ein Inline-Popup-Men\00FC oder ein ausblendbares Dialogfeld), die ge\00F6ffnet werden kann und derzeit ge\00F6ffnet ist.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('Region \00F6ffnen')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\00D6ffnet eine Region (z.B. ein Inline-Dialogfeld, ein Inline-Popup-Men\00FC oder ein ausblendbares Dialogfeld), die ge\00F6ffnet werden kann.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>'Ist in Rolle oder Gruppe'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4414)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Name(n)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Geben Sie einen oder mehrere durch Komma getrennte Gruppennamen ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4414)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Typ'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4414)
,p_display_sequence=>10
,p_display_value=>'Anwendungsrolle'
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4414)
,p_display_sequence=>20
,p_display_value=>'Workspace-Gruppe'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4414)
,p_display_sequence=>30
,p_display_value=>'Benutzerdefiniert'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4414)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>'Ist nicht in Rolle oder Gruppe'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4414)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Name(n)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Geben Sie einen oder mehrere durch Komma getrennte Gruppennamen ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4414)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Typ'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4414)
,p_display_sequence=>10
,p_display_value=>'Anwendungsrolle'
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4414)
,p_display_sequence=>20
,p_display_value=>'Workspace-Gruppe'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4414)
,p_display_sequence=>30
,p_display_value=>'Benutzerdefiniert'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>'Datumsauswahl'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigt ein Textfeld mit einem Kalendersymbol an. Endbenutzer k\00F6nnen das Datum entweder direkt in das Textelement eingeben oder auf ein Kalendersymbol klicken, um ein Datum und optional eine Zeit aus dem Kalender-Popup-Feld zu w\00E4hlen.</p>'),
unistr('<p>Die Zeit wird nur in dem Kalender-Popup-Feld angezeigt, wenn die <em>Formatmaske</em> f\00FCr dieses Element Zeitkomponenten umfasst.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Darstellung'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Steuert die Darstellung des Kalenders, in dem die Datumsangaben ausgew\00E4hlt werden.</p>'),
unistr('<p>Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben ist.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4414)
,p_display_sequence=>10
,p_display_value=>'Woche anzeigen'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>'Gibt an, ob die Woche im Jahr angezeigt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4414)
,p_display_sequence=>20
,p_display_value=>'Monatsauswahl'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Gibt an, ob der Monat als Schaltfl\00E4che gerendert werden soll, die eine Auswahl erm\00F6glicht, oder als Text.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4414)
,p_display_sequence=>30
,p_display_value=>'Jahresauswahl'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Gibt an, ob das Jahr als Schaltfl\00E4che gerendert werden soll, die eine Auswahl erm\00F6glicht, oder als Text.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Tage au\00DFerhalb des Monats')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gibt das Verhalten f\00FCr Tage au\00DFerhalb des aktuell angezeigten Monats vor.</p>'),
unistr('<p>Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben ist.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4414)
,p_display_sequence=>10
,p_display_value=>'Ausgeblendet'
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Tage au\00DFerhalb des aktuell angezeigten Monats werden verborgen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Ausw\00E4hlbar')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Tage au\00DFerhalb des aktuell angezeigten Monats sind sichtbar und ausw\00E4hlbar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4414)
,p_display_sequence=>30
,p_display_value=>'Sichtbar'
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('Tage au\00DFerhalb des aktuell angezeigten Monats sind sichtbar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Zeitinkrement'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>'Minuten'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeitinkrement in Minuten, das vom Steuerelement f\00FCr die Zeitauswahl verwendet wird. Hinweis: Hierbei wird nur das Steuerelement f\00FCr die Auswahl der Zeit gesteuert. Alle Zeitangaben au\00DFerhalb dieser Inkremente k\00F6nnen weiterhin manuell eingegeben un')
||'d gespeichert werden.</p>',
unistr('<p>Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben und gleichzeitig "Uhrzeit anzeigen" aktiviert ist.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Anzeigen bei'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Steuert, wann das Kalender-Popup-Fenster angezeigt wird. Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben ist.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4414)
,p_display_sequence=>10
,p_display_value=>'Elementfokus'
,p_return_value=>'FOCUS'
,p_help_text=>'Wenn das Element fokussiert oder auf das Kalendersymbol geklickt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4414)
,p_display_sequence=>20
,p_display_value=>'Klick auf Symbol'
,p_return_value=>'IMAGE'
,p_help_text=>'Nur wenn auf das Kalendersymbol geklickt wird.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Uhrzeit anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Gibt an, ob Zeitinformationen aufgenommen werden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Anzeigen als'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie den Anzeigemodus f\00FCr die Datumsauswahl.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4414)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>'Kalender wird in einem Popup-Fenster angezeigt, wenn das Element fokussiert oder auf das Kalendersymbol geklickt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4414)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Der Kalender wird immer inline auf der Seite angezeigt. Es wird kein Textfeld angezeigt, und die aktuelle Datumsauswahl wird in dem Kalender markiert.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4414)
,p_display_sequence=>30
,p_display_value=>'Native HTML'
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Rendern Sie mithilfe der nativen HTML-Eingabedatumstypen, sofern vom Browser unterst\00FCtzt. Wenn die Option "Uhrzeit anzeigen" deaktiviert ist, wird ein "date"-Typ gerendert. Wenn "Uhrzeit anzeigen" aktiviert ist, wird ein "datetime-local"-Typ geren')
||unistr('dert. Hinweis: Die exakte Anzeige dieser Datumstypen ist vom Browser abh\00E4ngig. "Native HTML" ist m\00F6glicherweise die bevorzugte Option, wenn die App auf einem Mobilger\00E4t verwendet wird.</p>'),
unistr('<p>Hinweis: Wenn Sie "Native HTML" verwenden, wird die "Formatmaske" des Elements automatisch von APEX festgelegt und kann nicht ge\00E4ndert werden, da die nativen Datumstypen sehr spezifische Datumsformate erfordern. Dieses Format wird aber nicht dem E')
||'ndbenutzer angezeigt. Der Endbenutzer sieht das Datum im Format seines Gebietsschemas.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Fr\00FChestes Datum')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie an, ob dieses Element \00FCber ein fr\00FChestes Datum verf\00FCgt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4414)
,p_display_sequence=>10
,p_display_value=>'Kein Wert'
,p_return_value=>'NONE'
,p_help_text=>unistr('Kein fr\00FChestes Datum definiert.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4414)
,p_display_sequence=>20
,p_display_value=>'Element'
,p_return_value=>'ITEM'
,p_help_text=>unistr('Das fr\00FCheste Datum wird dynamisch aus dem Wert eines anderen Elements abgeleitet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4414)
,p_display_sequence=>30
,p_display_value=>'Statisch'
,p_return_value=>'STATIC'
,p_help_text=>unistr('Das fr\00FCheste Datum ist ein statischer Wert, der als absoluter Wert oder relativer Wert zum heutigen Datum definiert wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Fr\00FChestes Datum - Statisch')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Mindestdatum ein, das eingegeben oder ausgew\00E4hlt werden kann.</p>'),
'<p>Der Datumswert kann ein absoluter Wert im Format <code>''YYYY-MM-DDTHH24:MI:SS''</code> oder <code>''YYYYMMDDHH24MI''</code>, ein relativer Wert bezogen auf das heutige Datum, wie <code>+7d</code>, oder ein dynamischer Wert mit Ersetzungssyntax sein, '
||unistr('vorausgesetzt die Ersetzung gibt das korrekte Datumsformat oder den korrekten relativen Wert zur\00FCck.</p>'),
'<p>Relative Datumswerte umfassen:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - Jahre ab dem heutigen Datum</dd>',
'  <dt>m</dt>',
'    <dd>+ / - Monate ab dem heutigen Datum</dd>',
'  <dt>w</dt>',
'    <dd>+ / - Wochen ab dem heutigen Datum</dd>',
'  <dt>d</dt>',
'    <dd>+ / - Tage ab dem heutigen Datum</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Minimales Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>Das Element, das den minimal zul\00E4ssigen Wert bestimmt. Dieses Seitenelement muss sich entweder auf der aktuellen oder einer globalen Seite befinden.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Sp\00E4testes Datum')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie an, ob dieses Element \00FCber ein sp\00E4testes Datum verf\00FCgt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4414)
,p_display_sequence=>10
,p_display_value=>'Kein Wert'
,p_return_value=>'NONE'
,p_help_text=>unistr('Kein sp\00E4testes Datum definiert.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4414)
,p_display_sequence=>20
,p_display_value=>'Element'
,p_return_value=>'ITEM'
,p_help_text=>unistr('Das sp\00E4teste Datum wird dynamisch aus dem Wert eines anderen Elements abgeleitet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4414)
,p_display_sequence=>30
,p_display_value=>'Statisch'
,p_return_value=>'STATIC'
,p_help_text=>unistr('Das sp\00E4teste Datum ist ein statischer Wert, der als absoluter Wert oder relativer Wert zum heutigen Datum definiert wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Sp\00E4testes Datum - Statisch')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das H\00F6chstdatum ein, das eingegeben oder ausgew\00E4hlt werden kann.</p>'),
'<p>Der Datumswert kann ein absoluter Wert im Format <code>''YYYY-MM-DDTHH24:MI:SS''</code> oder <code>''YYYYMMDDHH24MI''</code>, ein relativer Wert bezogen auf das heutige Datum, wie <code>+7d</code>, oder ein dynamischer Wert mit Ersetzungssyntax sein, '
||unistr('vorausgesetzt die Ersetzung gibt das korrekte Datumsformat oder den korrekten relativen Wert zur\00FCck.</p>'),
'<p>Relative Datumswerte umfassen:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - Jahre ab dem heutigen Datum</dd>',
'  <dt>m</dt>',
'    <dd>+ / - Monate ab dem heutigen Datum</dd>',
'  <dt>w</dt>',
'    <dd>+ / - Wochen ab dem heutigen Datum</dd>',
'  <dt>d</dt>',
'    <dd>+ / - Tage ab dem heutigen Datum</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Maximales Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>Das Element, das den maximal zul\00E4ssigen Wert bestimmt. Dieses Seitenelement muss sich entweder auf der aktuellen oder einer globalen Seite befinden.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Mehrere Monate'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>'Gibt an, ob der Kalender mehrere Monate anzeigt.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Anzahl Monate'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Die Anzahl der gleichzeitig anzuzeigenden Monate.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Standardwerte verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Gibt an, ob die f\00FCr diese Komponente unter "Gemeinsame Komponenten > Komponenteneinstellungen" definierten Standardwerte oder benutzerdefinierte Einstellungen verwendet werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Darstellung'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Steuert die Darstellung des Kalenders, in dem die Datumsangaben ausgew\00E4hlt werden.</p>'),
unistr('<p>Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben ist.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4414)
,p_display_sequence=>10
,p_display_value=>'Woche anzeigen'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>'Gibt an, ob die Woche im Jahr angezeigt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4414)
,p_display_sequence=>20
,p_display_value=>'Monatsauswahl'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Gibt an, ob der Monat als Schaltfl\00E4che gerendert werden soll, die eine Auswahl erm\00F6glicht, oder als Text.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4414)
,p_display_sequence=>30
,p_display_value=>'Jahresauswahl'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Gibt an, ob das Jahr als Schaltfl\00E4che gerendert werden soll, die eine Auswahl erm\00F6glicht, oder als Text.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('Tage au\00DFerhalb des Monats')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gibt das Verhalten f\00FCr Tage au\00DFerhalb des aktuell angezeigten Monats vor.</p>'),
unistr('<p>Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben ist.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4414)
,p_display_sequence=>10
,p_display_value=>'Ausgeblendet'
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Tage au\00DFerhalb des aktuell angezeigten Monats werden verborgen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Ausw\00E4hlbar')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Tage au\00DFerhalb des aktuell angezeigten Monats sind sichtbar und ausw\00E4hlbar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4414)
,p_display_sequence=>30
,p_display_value=>'Sichtbar'
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('Tage au\00DFerhalb des aktuell angezeigten Monats sind sichtbar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Zeitinkrement'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>'Minuten'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeitinkrement in Minuten, das vom Steuerelement f\00FCr die Zeitauswahl verwendet wird. Hinweis: Hierbei wird nur das Steuerelement f\00FCr die Auswahl der Zeit gesteuert. Alle Zeitangaben au\00DFerhalb dieser Inkremente k\00F6nnen weiterhin manuell eingegeben un')
||'d gespeichert werden.</p>',
unistr('<p>Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben und gleichzeitig "Uhrzeit anzeigen" aktiviert ist.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4414)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Anzeigen bei'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Steuert, wann das Kalender-Popup-Fenster angezeigt wird. Hinweis: Diese Option wird nur verwendet, wenn f\00FCr "Anzeigen als" entweder "Popup" oder "Inline" angegeben ist.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4414)
,p_display_sequence=>10
,p_display_value=>'Elementfokus'
,p_return_value=>'FOCUS'
,p_help_text=>'Wenn das Element fokussiert oder auf das Kalendersymbol geklickt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4414)
,p_display_sequence=>20
,p_display_value=>'Klick auf Symbol'
,p_return_value=>'IMAGE'
,p_help_text=>'Nur wenn auf das Kalendersymbol geklickt wird.'
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>unistr('Kontrollk\00E4stchen')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt ein einzelnes Kontrollk\00E4stchen an, das Benutzer aktivieren oder deaktivieren k\00F6nnen. Der definierte Wert f\00FCr "Aktiviert" oder "Deaktiviert" wird beim Weiterleiten im Sessionstatus gespeichert.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4414)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Gew\00E4hlter Wert')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Endbenutzer das Kontrollk\00E4stchen aktiviert. Der Wert kann bis zu 255 Zeichen lang sein.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4414)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Nicht ausgew\00E4hlter Wert')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Benutzer das Kontrollk\00E4stchen deaktiviert. Sie k\00F6nnen dieses Attribut auch leer lassen, wenn Sie <code>NULL</code> bei Aktivierung speichern m\00F6chten. Der Wert kann bis zu 255 Zei')
||'chen lang sein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4414)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Standardwerte verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Gibt an, ob die f\00FCr diese Komponente unter "Gemeinsame Komponenten > Komponenteneinstellungen" definierten Standardwerte oder benutzerdefinierte Einstellungen verwendet werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4414)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Gew\00E4hlter Wert')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Benutzer das Kontrollk\00E4stchen aktiviert. Der Wert kann maximal 255 Zeichen lang sein.</p>'),
'<p>',
unistr('Wenn das Facet auf einer Facet-Suchseite eine Abfragespalte <em>basierend auf einer Werteliste</em> filtert, muss dieser Wert mit dem Anzeige- <em>und</em> mit dem R\00FCckgabewert der Werteliste \00FCbereinstimmen. Wenn sich Anzeige- und R\00FCckgabewert unters')
||unistr('cheiden, k\00F6nnen Sie diesen Facet-Typ f\00FCr diese Spalte nicht verwenden. Verwenden Sie stattdessen das Facet <strong>Kontrollk\00E4stchengruppe</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4414)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Nicht ausgew\00E4hlter Wert')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Benutzer das Kontrollk\00E4stchen deaktiviert. Sie k\00F6nnen dieses Attribut auch leer lassen, wenn Sie <code>NULL</code> bei Deaktivierung speichern m\00F6chten. Der Wert kann bis zu 25')
||'5 Zeichen lang sein.</p>',
unistr('<p><em>Hinweis: Dieser Wert wird verwendet, wenn das Seitenelement mit einem Wert aufgef\00FCllt wird, der weder mit dem <strong>Wert f\00FCr "Aktiviert"</strong> noch mit dem <strong>Wert f\00FCr "Deaktiviert"</strong> \00FCbereinstimmt.</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>'Interaktives Grid'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Umfassende mehrzeilige Onlineregion basierend auf einer SQL-Abfrage, die Endbenutzern eine Vielzahl von Features f\00FCr die Anpassung zur Laufzeit zur Verf\00FCgung stellt. '),
unistr('Die Region kann entweder als editierbar oder schreibgesch\00FCtzt definiert werden.</p>'),
unistr('<p>Sie k\00F6nnen ein einzelnes interaktives Grid definieren, bei dem Endbenutzer die angezeigten Daten entsprechend ihren jeweiligen Anforderungen bearbeiten k\00F6nnen, sodass Sie nicht mehrere, \00E4hnliche Regionen mit unterschiedlichen Kriterien entwickeln ')
||unistr('m\00FCssen, um diese entsprechenden Anforderungen zu erf\00FCllen.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'apexbeginrecordedit'
,p_display_name=>'Zeileninitialisierung'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'gridpagechange'
,p_display_name=>unistr('Seiten\00E4nderung')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'interactivegridmodechange'
,p_display_name=>unistr('Modus\00E4nderung')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'interactivegridreportchange'
,p_display_name=>unistr('Berichts\00E4nderung')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'interactivegridsave'
,p_display_name=>'Speichern'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('Auswahl\00E4nderung')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4414)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4414)
,p_name=>'interactivegridviewchange'
,p_display_name=>unistr('View-\00C4nderung')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>'Zeilenselektor'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigt ein Kontrollk\00E4stchen in jeder Zeile eines interaktiven Grids an, das die Auswahl spezifischer Zeilen zur Zeilenverarbeitung erm\00F6glicht.</p>'),
unistr('<p>Standardm\00E4\00DFig ist die Spalte APEX$ROW_SELECTOR auf einen Zeilenselektor-Typ festgelegt. Diese Spalte wird automatisch hinzugef\00FCgt, wenn das interaktive Grid editierbar gemacht wird.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4414)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mehrfachauswahl aktivieren'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Auswahl mehrerer Zeilen zulassen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4414)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('"Alle ausw\00E4hlen" anzeigen')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Erlaubt dem Benutzer die Auswahl aller Zeilen \00FCber STRG+A oder, falls die Option <em>Steuerelemente ausblenden</em> auf <em>Nein</em> gesetzt ist, \00FCber ein Kontrollk\00E4stchen im Spaltenheader.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4414)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Steuerelement ausblenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Blenden Sie das Kontrollk\00E4stchen oder das Steuerelement aus, das auf jeder Zeile angezeigt wird.')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>unistr('Men\00FC "Aktionen"')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Zeigt das Aktionssymbol (Hamburger) in jeder Zeile eines interaktiven Grids an. ',
unistr('Das Aktionsmen\00FC enth\00E4lt Optionen wie "Single-Row-Ansicht", "Zeile hinzuf\00FCgen", "Zeile l\00F6schen", "Zeile aktualisieren" usw., je nach Grid-Attributen und Endbenutzerautorisierungen. Mit diesen Men\00FCoptionen k\00F6nnen Endbenutzer bestimmte Aktionen mit der ')
||unistr('aktuellen Zeile im Grid ausf\00FChren.</p>'),
unistr('<p>Sie k\00F6nnen das Aktionsmen\00FC sowohl in bearbeitbaren als auch in nicht bearbeitbaren interaktiven Grids verwenden, allerdings mit jeweils unterschiedlichen Men\00FCoptionen. Bei nicht bearbeitbaren interaktiven Grids enth\00E4lt das Men\00FC nur einen Teil der ')
||unistr('Optionen, wie "Single-Row-Ansicht" und "Zeile aktualisieren", aber nicht Bearbeitungsaktionen wie "Zeile hinzuf\00FCgen", "Zeile l\00F6schen" usw.</p>'),
unistr('<p>Wenn Sie ein interaktives Grid bearbeitbar machen, wird die Spalte APEX$ROW_ACTION automatisch hinzugef\00FCgt und auf einen Typ von Aktionsmen\00FC gesetzt. Bei nicht bearbeitbaren interaktiven Grids muss diese Spalte manuell hinzugef\00FCgt werden.</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>'Diagramm'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigen Sie Daten mit verschiedenen integrierten Diagrammtypen an.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4414)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4414)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>'Ausblenden'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Blendet die betroffenen Elemente aus.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4414)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Alle Seitenelemente in derselben Zeile verbergen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob alle Seitenelemente und Labels auf derselben Zeile wie die betroffenen Elemente ausgeblendet werden sollen.</p>',
unistr('<p>Hinweis: Dieses Attribut kann nicht f\00FCr Elemente auf Seiten verwendet werden, die kein Tabellen-Grid zur Anzeige von Formelementen verwenden. Dies umfasst jede Seite, die ein mobiles Seitentemplate verwendet.')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>'Aktivieren'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Aktiviert die betroffenen Elemente.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>'Deaktivieren'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Deaktiviert die betroffenen Elemente. Durch die Deaktivierung k\00F6nnen diese Elemente nicht mehr bearbeitet werden, sodass sie keine Elementwerte beibehalten, wenn die Seite weitergeleitet wird. ')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>'Wert festlegen'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Legt den Wert der betroffenen Elemente fest.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Typ festlegen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie die festzulegenden Werte abgeleitet werden sollen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_display_sequence=>10
,p_display_value=>'Statische Zuweisung'
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>'Legen Sie einen einzelnen statischen Wert fest.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_display_sequence=>15
,p_display_value=>'JavaScript-Ausdruck'
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>'Legen Sie mindestens einen Wert fest, der aus JavaScript abgeleitet oder berechnet wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_display_sequence=>20
,p_display_value=>'SQL-Anweisung'
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>'Legen Sie mindestens einen Wert basierend auf dem Ergebnis einer SQL-Abfrage fest.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_display_sequence=>40
,p_display_value=>'PL/SQL-Ausdruck'
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>'Legen Sie einen einzelnen Wert basierend auf dem Ergebnis eines PL/SQL-Ausdrucks fest.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_display_sequence=>50
,p_display_value=>'PL/SQL-Funktionsbody'
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>'Legen Sie einen einzelnen Wert basierend auf dem Ergebnis einer PL/SQL-Abfrage fest.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_display_sequence=>60
,p_display_value=>unistr('Dialogfeldr\00FCckgabeelement')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('Legen Sie einen einzelnen Wert basierend auf dem R\00FCckgabeelement eines Dialogfelds fest. Hinweis: Dieser Typ kann nur verwendet werden, wenn die dynamische Aktion f\00FCr das Ereignis <strong>Dialogfeld geschlossen</strong> ausgel\00F6st wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>'Geben Sie einen statischen Wert ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'SQL-Anweisung'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>Geben Sie in diesem Beispiel <code>P1_DEPTNO</code> in <strong>Weiterzuleitende Seitenelemente</strong> an. Au\00DFerdem m\00FCssen Sie zwei <em>Betroffene Elemente</em> f\00FCr die Spalten <code>loc</code> bzw. <code>dname</code> w\00E4hlen. Beispiel: P1_LOC und')
||' P1_DNAME.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine SQL-Anweisung ein, die zwischen 1 und 100 Spalten zur\00FCckgibt. Die Spalten, die Sie mit der SQL-Anweisung ausw\00E4hlen, m\00FCssen nach Position den Seitenelementen entsprechen, die Sie in <strong>Betroffene Elemente</strong> ausw\00E4hlen.</p>'),
unistr('<p>Sie k\00F6nnen Seiten- oder Anwendungselemente mit Bind-Syntax referenzieren, vorausgesetzt, Sie nehmen diese in <strong>Weiterzuleitende Seitenelemente</strong> auf.</p>'),
unistr('<p><em>Hinweis: Wenn die SQL-Anweisung nur eine einzelne Zeile zur\00FCckgibt, wird diese als Wert festgelegt. Wenn sie mehrere Zeilen zur\00FCckgibt, besteht der festgelegte Wert aus einer durch Komma getrennten Zeichenfolge aller Zeilen f\00FCr jeden Wert.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'PL/SQL-Ausdruck'
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
'<p>In diesem Beispiel geben Sie <code>P1_SAL</code> in <strong>Weiterzuleitende Seitenelemente</strong> ein.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie einen PL/SQL-Ausdruck ein, der zur Festlegung des Wertes verwendet wird.</p>',
unistr('<p>Sie k\00F6nnen Seiten- oder Anwendungselemente referenzieren, vorausgesetzt, Sie nehmen sie in <strong>Weiterzuleitende Seitenelemente</strong> auf.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'JavaScript-Ausdruck'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dieser Code greift auf die folgenden zu der dynamischen Aktion geh\00F6rigen Attribute zu:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>Eine Referenz auf das DOM-Objekt des Elements, das die dynamische Aktion ausgel\00F6st hat.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>Ein jQuery-Objekt, das alle betroffenen Elemente enth\00E4lt.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>Das Aktionsobjekt, das Details enth\00E4lt, wie den Aktionsnamen und zus\00E4tzliche Attributwerte.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>Das Ereignisobjekt des Ereignisses, das das Ereignis ausgel\00F6st hat. Hinweis: Beim Laden entspricht dies ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>Optionale zus\00E4tzliche Daten, die vom Event Handler \00FCbergeben werden k\00F6nnen.</dd>'),
'</dl>'))
,p_help_text=>unistr('Geben Sie einen JavaScript-Ausdruck ein, mit dem der Wert festgelegt wird. Dieser Ausdruck kann entweder zu einem einzelnen Wert oder einem Werte-Array f\00FChren (bei dem das Element, das festgelegt wird, mehrere Werte unterst\00FCtzt, beispielsweise ein Sh')
||'uttle).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'PL/SQL-Funktionsbody'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
'<p>In diesem Beispiel geben Sie <code>P1_SAL</code> und <code>P1_JOB</code> in <strong>Weiterzuleitende Seitenelemente</strong> ein.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie einen PL/SQL-Funktionsbody ein, der zur Festlegung des Wertes verwendet wird.</p>',
unistr('<p>Sie k\00F6nnen Seiten- oder Anwendungselemente referenzieren, vorausgesetzt, Sie nehmen sie in <strong>Weiterzuleitende Seitenelemente</strong> auf.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Weiterzuleitende Elemente'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Geben Sie weiterzuleitende Seiten- oder Anwendungselemente ein, wenn Sie diese Aktion ausf\00FChren. Bei mehreren Elementen trennen Sie die Elementnamen durch ein Komma. Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Elementen ausw\00E4hl')
||unistr('en. Wenn Sie einen Namen aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem aus der Liste zur\00FCckgegebenen Elementnamen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Escape bei Sonderzeichen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Geben Sie an, ob HTML-Sonderzeichen maskiert werden. Oracle empfiehlt unbedingt, dass dieses Attribut auf <strong>Ja</strong> gesetzt wird, um website\00FCbergreifende Skripting-(XSS-)Angriffe zu vermeiden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\00C4nderungsereignis unterdr\00FCcken')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob das \00C4nderungsereignis bei Elementen unterdr\00FCckt wird, die in <strong>Zur\00FCckzugebende Seitenelemente</strong> angegeben werden. Dies verhindert, dass nachfolgende auf <em>\00C4nderung</em> basierende dynamische Aktionen f\00FCr diese Elemente')
||unistr(' ausgel\00F6st werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4414)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>unistr('R\00FCckgabeobjekt')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('Geben Sie den Namen eines Seitenelements an, das von dem Dialogfeld zur\00FCckgegeben wird, mit dem der Wert festgelegt wird.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('JavaScript-Code ausf\00FChren')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Mit dieser Funktion k\00F6nnen Sie benutzerdefinierten, seitenspezifischen JavaScript-Code definieren oder aufrufen, der innerhalb des dynamischen Aktions-Frameworks verwendet werden soll. Wenn Sie JavaScript-Code definieren, der nur f\00FCr eine Seite spezi')
||unistr('fisch ist, k\00F6nnen Sie ihn mit dem Attribut <em>Funktion und globale Variablendeklaration</em> auf Seitenebene definieren. Dort definierte Funktionen und Variablen k\00F6nnen dann mit dieser Aktion referenziert werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4414)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Code'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dieser Code greift auf die folgenden zu der dynamischen Aktion geh\00F6rigen Attribute zu:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>Eine Referenz auf das DOM-Objekt des Elements, das die dynamische Aktion ausgel\00F6st hat.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>Ein jQuery-Objekt, das alle betroffenen Elemente enth\00E4lt.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>Das Aktionsobjekt, das Details enth\00E4lt, wie den Aktionsnamen und zus\00E4tzliche Attributwerte.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>Das Ereignisobjekt des Ereignisses, das das Ereignis ausgel\00F6st hat. Hinweis: Beim Laden entspricht dies ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>Optionale zus\00E4tzliche Daten, die vom Event Handler \00FCbergeben werden k\00F6nnen.</dd>'),
'</dl>'))
,p_help_text=>unistr('Geben Sie ein beliebiges, benutzerdefiniertes JavaScript ein, das f\00FCr die Seite oder dynamische Aktion spezifisch ist.')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>'Interaktives Grid - Automatische Zeilenverarbeitung (DML)'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Prozess zum Einf\00FCgen, Aktualisieren oder L\00F6schen von Zeilen des interaktiven Grids.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Zieltyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, welche Zeilenverarbeitungstechnik ausgef\00FChrt wird, um Daten\00E4nderungen zu speichern, die an dem interaktiven Grid vorgenommen wurden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4414)
,p_display_sequence=>10
,p_display_value=>'Regionsquelle'
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCgt die SQL-Abfrage der Regionsquelle ein, aktualisiert und l\00F6scht sie.</p>'),
unistr('<p>Hinweis - Stellen Sie sicher, dass f\00FCr Spalten, die nicht eingef\00FCgt oder aktualisiert werden k\00F6nnen, <strong>Nur Abfrage</strong> auf <code>Ja</code> festgelegt ist, damit sie aus der Verarbeitung ausgeschlossen werden.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4414)
,p_display_sequence=>20
,p_display_value=>'Tabelle/View'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00FCgt eine andere Tabelle oder View in die in der SQL-Abfrage der Quellregion definierten Tabelle oder View ein, aktualisiert und l\00F6scht sie.'),
unistr('Beispiel: Die SQL-Abfrage ruft Daten aus einem Table-Join oder einer nicht aktualisierbaren View ab, und die DML-Verarbeitung muss mit einer einzelnen Basistabelle oder aktualisierbaren View ausgef\00FChrt werden.</p>'),
unistr('<p>Hinweis - Stellen Sie sicher, dass f\00FCr Spalten, die nicht eingef\00FCgt oder aktualisiert werden k\00F6nnen, <strong>Nur Abfrage</strong> auf <code>Ja</code> festgelegt ist, damit sie aus der Verarbeitung ausgeschlossen werden.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4414)
,p_display_sequence=>30
,p_display_value=>'PL/SQL-Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die Verarbeitung basiert auf benutzerdefiniertem PL/SQL-Code. Mit dieser Option k\00F6nnen Sie beliebigen PL/SQL-Code ausf\00FChren, um die Datenverarbeitung in der zugrunde liegenden Datenbank zu implementieren.</p>'),
unistr('<p>Diese Option muss bei der Verwendung von Datenbankpackages verwendet werden, wie Tabellen-APIs oder Aufrufen von RESTful Web Services, um Gesch\00E4ftslogik zu implementieren.</p>'),
unistr('<p>Hinweis - Der PL/SQL-Code wird f\00FCr jede Zeile aufgerufen, die eingef\00FCgt, aktualisiert oder gel\00F6scht wurde.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4414)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('PL/SQL-Code f\00FCr Insert/Update/Delete')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie PL/SQL-Code ein, um jede Zeile mit Daten zu verarbeiten, die im interaktiven Grid bearbeitet wird.</p>',
unistr('<p>Verwenden Sie den Spaltennamen als Bind-Variable, um auf den Wert einer Spalte zuzugreifen. Die Systemvariable <code>APEX$ROW_STATUS</code> gibt den Status einer Zeile zur\00FCck. Mit ihr kann gepr\00FCft werden, ob die Zeile erstellt, aktualisiert oder g')
||unistr('el\00F6scht wurde (dies wird in dem Beispiel unten dargestellt).</p>'),
unistr('<p><em>Hinweis:</em> Wenn Prim\00E4rschl\00FCsselspalten von einem Trigger oder im PL/SQL-Code aufgef\00FCllt werden, m\00FCssen die neuen Werte den Bind-Variablen der Prim\00E4rschl\00FCsselspalten zugewiesen werden, weil &PRODUCT_NAME. diese Werte f\00FCr den Abruf der Zeile ')
||'nach einem Insert- oder Update-Vorgang verwendet.</p>',
'<p>Oracle empfiehlt den Aufruf von Prozeduren oder Funktionen innerhalb eines PL/SQL-Packages, um die Wiederverwendung und Wartbarkeit zu vereinfachen.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Verlorene Updates verhindern'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob die Verarbeitung sicherstellen soll, dass Updates nicht verloren gehen, wenn mehrere Benutzer denselben Datenbankdatensatz aktualisieren.</p> ',
unistr('<p>Zu verlorenen Updates kommt es, wenn zwei oder mehr Personen versuchen, dieselben Daten zu aktualisieren und das letzte Update Updates \00FCberschreibt, die vom ersten Benutzer vorgenommen wurden, um die \00C4nderungen zu speichern. Um dies zu verhindern,')
||unistr(' k\00F6nnen Updates die vorhandenen Spaltenwerte in der Datenbank mit den Werten vergleichen, die abgerufen wurden, als die Zeile urspr\00FCnglich abgefragt wurde.</p>'),
'<p>Beispiel:',
'  <ol>',
unistr('    <li>Benutzer A fragt Mitarbeiterdatens\00E4tze (EMP) ab.</li>'),
unistr('    <li>Benutzer B fragt dieselben Mitarbeiterdatens\00E4tze ab.</li>'),
unistr('    <li>Benutzer B aktualisiert Mitarbeiterdetails f\00FCr EMPNO = 7839 und \00FCbernimmt (speichert) die \00C4nderungen in der Datenbank.</li>'),
unistr('    <li>Benutzer A aktualisiert Mitarbeiterdetails f\00FCr EMPNO = 7839 und versucht, die \00C4nderungen in der Datenbank zu \00FCbernehmen.</li>'),
'  </ol>',
unistr('Wenn Benutzer A dieselbe Zeile erfolgreich aktualisiert, sind die \00C4nderungen von Benutzer B verloren.'),
unistr('Wenn Benutzer A versucht, die Mitarbeiterzeile zu speichern, sind die Daten in der Datenbank nicht mehr identisch mit den Daten, die Benutzer A urspr\00FCnglich abgerufen hat. In Schritt 1 oben k\00F6nnen die urspr\00FCnglich von Benutzer A abgefragten Daten erf')
||unistr('asst werden. In Schritt 4 oben k\00F6nnen die Werte mit den aktuellen Werten in der Datenbank verglichen werden. Dieser Vergleich l\00F6st einen Fehler f\00FCr Benutzer A aus, weil die Datenbankwerte von Benutzer B in Schritt 3 aktualisiert wurden. Dadurch wird ')
||unistr('verhindert, dass ein Benutzer \00C4nderungen \00FCberschreibt, die von einem anderen Benutzer an derselben Zeile vorgenommen wurden.</p>'),
unistr('<p>Hinweis - Wie die verlorenen Updates ermittelt werden, wird in den Attributen f\00FCr die Region "Interaktives Grid" basierend auf der Einstellung f\00FCr <strong>Verlorenes Update - Typ</strong> angegeben.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Zeile sperren'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie, ob jede Zeile, die aktualisiert oder gel\00F6scht werden soll, in der zugrundliegenden Tabelle gesperrt wird, bevor die Zeile verarbeitet wird.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4414)
,p_display_sequence=>10
,p_display_value=>'Ja'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeilen, die aktualisiert oder gel\00F6scht werden m\00FCssen, werden mit SELECT ... FOR UPDATE gesperrt, um zu verhindern, dass andere Transaktionen mit der Zeile durchgef\00FChrt werden, bis die Transaktion gespeichert wird.</p>'),
unistr('<p>Hinweis - Wenn ein Fehler ausgel\00F6st wird, wie bei aktualisierbaren Views, die eine Sperre nicht unterst\00FCtzen, k\00F6nnen Sie PL/SQL-Code nutzen, um die steuernde Tabelle zu sperren.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4414)
,p_display_sequence=>20
,p_display_value=>'Nein'
,p_return_value=>'N'
,p_help_text=>'Zeilen werden nicht gesperrt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4414)
,p_display_sequence=>30
,p_display_value=>'PL/SQL-Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>'Benutzerdefinierter PL/SQL-Code wird verwendet, um die Zeilen zu sperren, bis die Transaktion gespeichert wird.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'PL/SQL-Code zur Sperre von Zeilen'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Geben Sie den PL/SQL-Code ein, um die Zeilen der Datenbanktabelle zu sperren, die aktualisiert und gel\00F6scht werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4414)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Prim\00E4rschl\00FCssel nach Einf\00FCgen zur\00FCckgeben')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, ob die Prim\00E4rschl\00FCsselspalten in die entsprechende Zeile des interaktiven Grids zur\00FCckgegeben werden sollen, nachdem die Zeile in die Datenbank eingef\00FCgt wurde.'),
unistr('Im Allgemeinen sollte diese Option verwendet werden, wenn die Prim\00E4rschl\00FCsselspalten aus einem Datenbanktrigger oder einer Oracle Database 12 <em>c</em>-Identit\00E4tsspalte aufgef\00FCllt werden.</p>'),
unistr('<p>Hinweis - Wenn eine Fehlermeldung ausgegeben wird, dass die RETURNING INTO-Klausel nicht zul\00E4ssig ist, m\00FCssen Sie diese Option auf "Nein" festlegen und die Prim\00E4rschl\00FCsselspalten im Voraus ausf\00FCllen.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>unistr('Klasse hinzuf\00FCgen')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('F\00FCgt mindestens eine CSS-Klasse den betroffenen Elementen hinzu.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4414)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Klasse'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('F\00FCgt die CSS-Klassen <code>articlenumber</code> und <code>highlight</code> dem HTML-Tag der betroffenen Elemente hinzu:'),
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('Geben Sie mindestens eine Klasse an, die f\00FCr die betroffenen Elemente angewendet werden soll. Wenn Sie mehrere Klassen angeben, trennen Sie die Klassennamen durch ein Leerzeichen.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>'Klasse entfernen'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Entfernt mindestens eine CSS-Klasse aus den betroffenen Elementen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4414)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Klasse'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'	Geben Sie mindestens einen Klassennamen an, der aus den betroffenen Elementen entfernt werden soll. Trennen Sie mehrere Namen durch ein Leerzeichen. Lassen Sie das Feld leer, wenn alle Klassennamen von den betroffenen Elementen entfernt werden solle'
||'n.</p>',
''))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>'Stil festlegen'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Legt eine Formatvorlagen-(CSS-)Eigenschaft f\00FCr die betroffenen Elemente fest.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4414)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Stilname'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Namen der Stileigenschaft (CSS) an, die Sie f\00FCr die betroffenen Elemente festlegen m\00F6chten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4414)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Wert ein, mit dem die Stileigenschaft f\00FCr die betroffenen Elemente festgelegt wird. Lassen Sie das Feld leer, um die Stileigenschaft aus den betroffenen Elementen zu entfernen.')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>'Benutzerdefiniert'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ein Authentifizierungsschema, mit dem Sie Ihre eigenen PL/SQL-Funktionen zur Bestimmung der Benutzerauthentifizierung definieren k\00F6nnen.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Sentry-Funktionsname'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gibt PL/SQL-Code, der einen booleschen Wert zur\00FCckgibt, in dem ''PL/SQL-Code'' an -</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
'<p>Gibt eine PL/SQL-Datenbankfunktion an - </p>',
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen einer Funktion ein, die von der &PRODUCT_NAME. Engine zu Beginn einer an die Engine gestellten Anforderung, wie "Vor Anzeige oder Verarbeitung jeder Seite", oder bei der Ausgabe einer AJAX-Anforderung ausgef\00FChrt wird. '),
'Sie kann im PL/SQL-Code der Authentifizierung, innerhalb eines Packages oder als gespeicherte Funktion definiert werden. </p>',
unistr('<p>Wenn diese Funktion False zur\00FCckgibt (was m\00F6glicherweise bedeutet, dass der Benutzer nicht angemeldet ist), wird die Session als nicht g\00FCltig markiert und die <em>ung\00FCltige Sessionprozedur</em> wird aufgerufen.'),
unistr('Danach nimmt &PRODUCT_NAME. eine Umleitung zu der URL vor, die in "Session nicht g\00FCltig > Gehe zu" definiert wird.'),
'Wenn der Wert dieses Feldes leer ist,',
unistr('wird eine interne Standard-Sentry-Funktion aufgerufen, die versucht eine g\00FCltige Session aufzubauen, indem die Session-ID in der URL und die Sessioninformationen in dem Cookie des Authentifizierungsschemas verglichen werden (mit einem Fallback zu dem')
||unistr(' &PRODUCT_NAME. Builder-Cookie, falls dieser Vorgang nicht erfolgreich verl\00E4uft).</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Ung\00FCltiger Sessionprozedurname')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen einer PL/SQL-Prozedur ein, die aufgerufen wird, wenn eine ung\00FCltige Session ermittelt wurde.</p>'),
'',
'<p>Sie kann eine Funktion des anonymen PL/SQL-Codeblocks, eine Packagefunktion oder eine Standalone-Funktion in der Datenbank referenzieren. Beispiel: <code>invalid_session_basic_auth</code><p/>',
'',
unistr('<p>Wenn Sie eine PL/SQL-Datenbankpackage- oder eine Standalone-Funktion referenzieren, k\00F6nnen Sie die Ersetzungszeichenfolge <code>#OWNER#</code> zum Referenzieren des Parsingschemas der aktuellen Anwendung verwenden. Beispiel: <code>#OWNER#.invalid_')
||'session_basic_auth</code>.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Authentifizierungsfunktionsname'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den folgenden Code in den Textbereich ''PL/SQL-Code'' ein</p>',
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
'<p>und <code>my_authentication</code> als "Authentifizierungsfunktion".'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen der Funktion ein, die den Benutzernamen und das Kennwort des Benutzers pr\00FCft, nachdem diese auf einer Anmeldeseite eingegeben wurden.'),
unistr('Wenn keine Eingabe vorgenommen wird, werden Benutzername und Kennwort als g\00FCltig betrachtet.'),
'Die Funktion kann im Textbereich des PL/SQL-Codes der Authentifizierung innerhalb eines Packages oder als gespeicherte Funktion definiert werden.</p>',
'',
unistr('<p>Diese Funktion muss einen booleschen Wert an die Anmeldeprozedur zur\00FCckgeben, die sie aufruft. Sie enth\00E4lt 2 Eingabeparameter ''p_username'' und ''p_password'', mit denen auf die Werte zugegriffen werden kann, die ein Endbenutzer in die Anmeldeseite e')
||'ingegeben hat.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Post-Abmelde-Prozedurname'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gibt den folgenden Code in den Textbereich ''PL/SQL-Code'' ein</p>',
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
'<p>sowie <code>my_post_logout</code> als ''Post-Abmeldeprozedur''.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Der Name der Prozedur, die aufgerufen wird, nachdem der Endbenutzer auf die Abmelde-URL geklickt hat. Er kann f\00FCr das Logging verwendet werden.'),
'Die Prozedur selbst kann im Textbereich des PL/SQL-Codes der Authentifizierung, innerhalb eines Packages oder als gespeicherte Funktion definiert werden.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\00C4ltere Authentifizierungsattribute aktivieren')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Zus\00E4tzliche Authentifizierungsattribute werden sichtbar, wenn diese Auswahlliste auf "Ja" gesetzt wird.'),
unistr('Sie sind haupts\00E4chlich f\00FCr Kundenauthentifizierungen relevant, die von &PRODUCT_NAME. 4.0 und fr\00FCheren Versionen portiert wurden.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'SSO-Name der Partneranwendung'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Wenn Sie die Authentifizierung mit Oracle Application Server Single Sign-On vornehmen und die Anwendung eine registrierte Partneranwendung mit SSO ist, geben Sie genau den Namen ein, den Sie bei der Registrierung der Partneranwendung mit SSO verwende'
||'t haben.',
'',
'Wenn Sie sich darauf verlassen, dass Application Express die registrierte Partneranwendung ist, lassen Sie dieses Feld leer.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP-Host'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Der Hostname Ihres LDAP-Directory-Servers.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'LDAP-Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Die Portnummer Ihres LDAP-Directory-Hosts.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'SSL verwenden'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Legen Sie fest, ob SSL f\00FCr das Binding an das LDAP-Verzeichnis verwendet werden soll. Wenn SSL mit Authentifizierung ausgew\00E4hlt ist, muss ein Wallet f\00FCr die Application Express-Instanz konfiguriert sein.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4414)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4414)
,p_display_sequence=>20
,p_display_value=>'SSL mit Authentifizierung'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4414)
,p_display_sequence=>30
,p_display_value=>'Keine SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'LDAP-DN-Zeichenfolge'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Exakter DN</dt>',
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
'  <dt>Nicht-exakter DN (Suchbasis)</dt>',
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>'Geben Sie das Muster ein, das zum Erstellen der vollqualifizierten Distinguished Name-(DN-)Zeichenfolge als DBMS_LDAP.SIMPLE_BIND_S bei Verwendung der genauen DN oder der Suchbasis bei Verwendung der nicht-genauen DN verwendet wird. Verwenden Sie <st'
||unistr('rong>%LDAP_USER%</strong> als Platzhalter f\00FCr den Benutzernamen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Exakten Distinguished Name (DN) verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Legen Sie fest, ob die Zeichenfolge f\00FCr den LDAP Distinguished Name (DN) exakt oder nicht exakt ist. Wenn sie nicht exakt ist, ist LDAP Distinguished Name (DN) die Suchbasis, und Sie m\00FCssen einen Suchfilter angeben.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Suchfilter'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('Geben Sie den Suchfilter ein, wenn Sie nicht den genauen  Distinguished Name (DN) verwenden. Verwenden Sie <code>%LDAP_USER%</code> als Platzhalter f\00FCr den Benutzernamen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('Bearbeitungsfunktion f\00FCr den LDAP-Benutzernamen')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Der folgende Code ruft eine Funktion auf, die alle "."''s durch "_"''s in der DN-Zeichenfolge ersetzt:</p>',
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('Sie k\00F6nnen zus\00E4tzlichen Code angeben, mit dem der Benutzername in ein Format umgewandelt wird, das genau zu dem LDAP-Verzeichniseintrag oder LDAP-Benutzernamen passt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4414)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Benutzernamen-Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bevor <code><strong>%LDAP_USER%</strong></code> im LDAP Distinguished Name und der Suchzeichenfolge ersetzt wird, ',
'kann &PRODUCT_NAME. automatisch Sonderzeichen im Benutzernamen maskieren.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4414)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Maskieren Sie Sonderzeichen basierend auf RFC 4514 (bei Distinguished Names) und RFC 4515 (bei Suchzeichenfolgen).',
unistr('Maskieren Sie au\00DFerdem Unicode-Zeichen.'),
'Dies ist die sicherste Einstellung, kann jedoch bei einigen LDAP-Servern Probleme verursachen.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4414)
,p_display_sequence=>20
,p_display_value=>'Nur Sonderzeichen'
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Maskieren Sie Sonderzeichen basierend auf RFC 4514 (bei Distinguished Names) und RFC 4515 (bei Suchzeichenfolgen).',
'Maskieren Sie Unicode-Zeichen nicht.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4414)
,p_display_sequence=>30
,p_display_value=>'Kein Escaping'
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Maskieren Sie keine Zeichen. Diese Einstellung ist potenziell unsicher, ',
'es sei denn, eine <strong>Funktion zur Bearbeitung des Benutzernamens</strong> wird verwendet, die den ',
'Benutzernamen bereits maskiert (beispielsweise mit <code>apex_escape.ldap_dn</code> oder <code>apex_escape.ldap_search_filter</code>).'))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('Code ausf\00FChren')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Prozess, mit dem PL/SQL-Code ausgef\00FChrt wird.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('Dialog schlie\00DFen')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Prozess, mit dem die aktuelle modale oder nicht modale Dialogseite geschlossen wird.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4414)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Zur\00FCckzugebende Elemente')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen von mindestens einem Seitenelement an, das von dem Dialogfeld zur\00FCckgegeben werden muss. Trennen Sie die Elementnamen bei mehreren Elementen durch ein Komma.</p>'),
unistr('<p>Sie k\00F6nnen auf die zur\00FCckgegebenen Elementwerte zugreifen, indem Sie eine dynamische Aktion definieren, die bei dem Ereignis <strong>Dialogfeld geschlossen</strong> f\00FCr das Element ausgel\00F6st wird, das das Dialogfeld \00F6ffnet, mit einer Aktion <stron')
||unistr('g>Wert festlegen</strong> und <em>Typ festlegen</em> f\00FCr <strong>Dialogfeldr\00FCckgabeelement</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('Sessionzustand zur\00FCcksetzen')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Prozess, mit dem der Sessionzustand zur\00FCckgesetzt wird, der in &PRODUCT_NAME. gespeichert ist.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4414)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Typ'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie den Sessionzustandstyp, der zur\00FCckgesetzt werden soll.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_display_sequence=>1
,p_display_value=>unistr('Alle Elemente auf der aktuellen Seite l\00F6schen')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_display_sequence=>3
,p_display_value=>unistr('Alle Elemente auf Seite(n) l\00F6schen')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_display_sequence=>5
,p_display_value=>unistr('Elemente l\00F6schen ')
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_display_sequence=>7
,p_display_value=>unistr('Aktuelle Session l\00F6schen')
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_display_sequence=>9
,p_display_value=>unistr('Aktuelle Anwendung l\00F6schen')
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Anwendungen l\00F6schen')
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4414)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Anwendungen'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>'Geben Sie eine durch Komma getrennte Liste der Anwendungs-IDs ein, wie <code>100,101,105</code>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4414)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Element(e)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('W\00E4hlen Sie Seitenelemente, die aus dem Sessionzustand gel\00F6scht werden m\00FCssen, wie <code>P1_EMPNO,P1_ENAME</code>. Bei mehreren Elementen trennen Sie die Elementnamen durch ein Komma. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren El')
||unistr('emente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4414)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Seite(n)'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>'Geben Sie eine durch Komma getrennte Liste der Seitennummern ein, wie <code>1,2,5</code>.'
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('Seitennummerierung zur\00FCcksetzen')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Prozess, mit dem der Seitenumbruch von Berichten auf der aktuellen Seite zur\00FCckgesetzt wird.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4414)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Ziel'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, ob der Seitenumbruch auf allen Seiten, einigen Seiten oder der aktuellen  Seite zur\00FCckgesetzt werden soll.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4414)
,p_display_sequence=>10
,p_display_value=>'Diese Seite'
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4414)
,p_display_sequence=>20
,p_display_value=>'Seite(n)'
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4414)
,p_display_sequence=>30
,p_display_value=>'Alle Seiten'
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4414)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Seite(n)'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>'Geben Sie eine durch Komma getrennte Liste der Seitennummern ein.'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>unistr('Tabellarisches Formular - Zeilen hinzuf\00FCgen')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Prozess, mit dem eine Zeile zu einer tabellarischen Formularregion hinzugef\00FCgt wird.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4414)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Anzahl Zeilen'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>'Geben Sie die Anzahl der Zeilen ein.'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>'Tabellarisches Formular - Mehrzeiliges Update'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Prozess, mit dem mehrere Zeilen aus einer tabellarischen Formularregion aktualisiert werden. Dieser Prozess f\00FCgt auch Datens\00E4tze ein, die in der Region hinzugef\00FCgt wurden.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4414)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4414)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4414)
,p_help_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4414)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4414)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCsselwert enth\00E4lt. Bei Tabellen mit mehr als zweiteiligen Prim\00E4rschl\00FCsseln w\00E4hlen Sie <strong>ROWID</strong>.</p>'),
unistr('<p>Der Prim\00E4rschl\00FCssel wird zur Identifizierung von zu aktualisierenden Zeilen verwendet und darf im tabellarischen Formular nicht bearbeitet werden. Bei neuen Zeilen muss der Prim\00E4rschl\00FCsselwert leer sein.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4414)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4414)
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den zweiten Prim\00E4rschl\00FCsselwert enth\00E4lt. Dieses Attribut darf nur aufgef\00FCllt werden, wenn der Prim\00E4rschl\00FCssel aus zwei Spalten besteht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4414)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Laufzeit-WHERE-Klausel'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Begrenzen Sie die Abteilungen mit:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Geben Sie die SQL-WHERE-Klausel ein, die an alle generierten INSERT- und UPDATE-Anweisungen angeh\00E4ngt werden muss. Verwenden Sie dieses Attribut, um die Datens\00E4tze zu begrenzen, die innerhalb automatisch generierter SQL-Aufrufe verwendet werden.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>'Automatischer Zeilenabruf'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Prozess, mit dem Datens\00E4tze aus einer einzelnen Datenbanktabelle oder -View abgerufen werden. Mit diesem Prozess werden Form-Elemente mit einer Quelle vom Typ <strong>Datenbankspalte</strong> aufgef\00FCllt.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4414)
,p_help_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Prim\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Prim\00E4rschl\00FCsselspalte enthalten soll. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4414)
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCsselwert enth\00E4lt. Bei Tabellen mit mehr als zweiteiligen Prim\00E4rschl\00FCsseln, w\00E4hlen Sie <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der zweiten Prim\00E4rschl\00FCsselspalte enthalten soll. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4414)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den zweiten Prim\00E4rschl\00FCsselwert enth\00E4lt. Dieses Attribut darf nur aufgef\00FCllt werden, wenn der Prim\00E4rschl\00FCssel aus zwei Spalten besteht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Zeilenversionsspalte'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4414)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Spalte, die die Zeilenversion identifiziert. Diese Spalte muss auf der Seite nicht vorhanden sein. Lassen Sie dieses Attribut leer, um die integrierte Pr\00FCfsumme zu verwenden.</p>'),
unistr('<p>Die opportunistische Sperre verwendet die Ermittlung von verlorenen Updates, um die Datenintegrit\00E4t in Anwendungen sicherzustellen, bei denen nebenl\00E4ufig auf Daten zugegriffen werden kann. &PRODUCT_NAME. kann eine integrierte Pr\00FCfsumme verwenden, ')
||unistr('um verlorene Updates zu ermitteln und die Version der Zeile zu bestimmen. Die Pr\00FCfsumme ist eine Hashfunktion aller Spaltenwerte f\00FCr die spezifische Tabellenzeile. Sie wird abgerufen, wenn der Datensatz aus der Datenbank abgefragt wird, und wird dann')
||unistr(' mit dem Hash des aktuellen Datensatzes als Bestandteil der <em>Automatischen Zeilenverarbeitung</em> verglichen. Wenn die beiden Werte identisch sind, wird mit dem Update fortgefahren, sonst l\00F6st die automatische Zeilenverarbeitung einen Fehler aus.')
||'</p>',
unistr('<p>Mit diesem Attribut k\00F6nnen Sie eine einzelne Spalte angeben, die die Zeilenversion enth\00E4lt, als Alternative zur Verwendung der integrierten Pr\00FCfsummenverarbeitung. Diese Spalte muss aktualisiert werden, wenn ein Datensatz in der Datenbank aktualis')
||'iert wird. Oracle empfiehlt, dass Sie einen "Vor Update"-Datenbanktrigger auf der Tabelle implementieren, um die Spalte mit der Zeilenversion zu inkrementieren oder anderweitig zu aktualisieren. Es wird davon ausgegangen, dass NUMBER-Spalten eine Fol'
||unistr('genummer f\00FCr die Zeile enthalten. DATE- und TIMESTAMP-Spalten k\00F6nnen ebenfalls verwendet werden. Der Vorteil der Verwendung einer einzelnen Spalte besteht darin, dass die &PRODUCT_NAME. Engine nicht die gesamte Zeile hashen muss, sondern stattdessen ')
||'einen einzelnen Spaltenwert vergleichen kann.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Laufzeit-WHERE-Klausel'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Begrenzen Sie die Abteilungen mit:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Geben Sie die SQL-WHERE-Klausel ein, die an die generierte SELECT-Anweisung angeh\00E4ngt werden muss. Verwenden Sie dieses Attribut, um die Datens\00E4tze zu begrenzen, die innerhalb automatisch generierter SQL-Aufrufe verwendet werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4414)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Abrufmodus'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Diese Option ist nur aus Gr\00FCnden der Abw\00E4rtskompatibilit\00E4t vorhanden.'),
'Bei neuen Anwendungen muss diese Einstellung immer leer bleiben.',
'Die Option "Speichercache bei Anzeige festlegen" ist veraltet und wird in Prozessen, die mit diesem Release von &PRODUCT_NAME. generiert wurden, nicht genutzt.',
'</p>',
'<p>',
unistr('Wenn ein Prozess f\00FCr den automatisierten Zeilenabruf eine Zeile ausw\00E4hlt, werden die entsprechenden Seitenelemente auf die abgerufenen Spaltenwerte gesetzt. Der Zeitpunkt wird von der Einstellung f\00FCr den DML-Abrufmodus bestimmt. Der Standardmodus akt')
||unistr('ualisiert den Sessionzustand im Speicher, sobald die Zeile abgerufen wird. Der Modus "Speichercache bei Anzeige festlegen" aktualisiert diesen Sessionzustand nur, wenn (und falls) das Element wiedergegeben wird. Wenn Sie den abgerufenen Wert f\00FCr das ')
||unistr('Element mit einer Syntax f\00FCr Bind-Variablen oder <code>v(''ITEM_NAME'')</code>-Syntax zwischen dem Zeitpunkt des Zeilenabrufs und dem Zeitpunkt der Elementwiedergabe referenzieren m\00FCssen, m\00FCssen Sie den Standardabrufmodus verwenden. Wenn Sie einen neue')
||unistr('n Prozess f\00FCr den automatischen Zeilenabruf erstellen, wird als Abrufmodus dieser Standardmodus festgelegt. Wenn Ihre Seitenlogik nicht vom Verhalten "Bei Anzeige" abh\00E4ngt, aktualisieren Sie nach M\00F6glichkeit diesen Prozess zur Verwendung des Standard')
||unistr('verhaltens. Sie erhalten dann die maximale Flexibilit\00E4t zum Referenzieren von abgerufenen Spaltenwerten w\00E4hrend der Seitenwiedergabe.'),
''))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4414)
,p_display_sequence=>20
,p_display_value=>'Speichercache bei Anzeige festlegen [veraltet]'
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>'Web Service'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Prozess, mit dem der angegebene Webservice konsumiert wird.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4414)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Webservicevorgang'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('W\00E4hlen Sie einen Webservicevorgang.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4414)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Ergebnis speichern in'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4414)
,p_display_sequence=>10
,p_display_value=>'Element(e)'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4414)
,p_display_sequence=>20
,p_display_value=>'Collection'
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4414)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Collection-Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>'Formularseitenumbruch'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Prozess, mit dem der vorherige oder n\00E4chste Datensatz aus einer Datenbanktabelle oder -View abgerufen wird. Dieser Prozess kann f\00FCr den Seitenumbruch auf Formularseiten verwendet werden, sodass Endbenutzer den vorherigen oder n\00E4chsten Datensatz ab')
||unistr('rufen k\00F6nnen, ohne zu einem Bericht zur\00FCck navigieren zu m\00FCssen.</p>'),
unistr('<p><em>Hinweis: Wenn die Form die Aktualisierung von Daten zul\00E4sst, m\00FCssen Sie generell sicherstellen, dass die entsprechende Form-Verarbeitung vor der Ausf\00FChrung dieses Seitenumbruchprozesses vorgenommen wird. Sonst sind vom Endbenutzer vorgenommene')
||' Updates verloren, wenn dieser zu einem anderen Datensatz navigiert.</em></p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4414)
,p_help_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Prim\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Prim\00E4rschl\00FCsselspalte enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4414)
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCsselwert enth\00E4lt. Bei Tabellen mit mehr als zweiteiligen Prim\00E4rschl\00FCsseln, w\00E4hlen Sie <strong>ROWID>/strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der zweiten Prim\00E4rschl\00FCsselspalte enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4414)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den zweiten Prim\00E4rschl\00FCsselwert enth\00E4lt. Dieses Attribut darf nur aufgef\00FCllt werden, wenn der Prim\00E4rschl\00FCssel aus zwei Spalten besteht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Spalte f\00FCr die Navigationsreihenfolge')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4414)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Spalte ein, die den Wert der Navigationsreihenfolge enth\00E4lt.</p>'),
unistr('<p>Mit dieser Spalte werden die vorherigen und n\00E4chsten Zeilen ermittelt. Deshalb ist die Verwendung einer Spalte wie <code>DISPLAY_SEQ</code> ideal. Wenn Sie Datens\00E4tze in der Reihenfolge anordnen m\00F6chten, in der sie erstellt wurden, k\00F6nnten Sie ein')
||unistr('e Spalte wie <code>CREATED</code> oder <code>ID</code> verwenden, wenn diese aus einer Sequenz oder basierend auf einer Oracle Database 12<em>c</em>-Identit\00E4tsspalte aufgef\00FCllt wurde. Sie k\00F6nnen die Datens\00E4tze jedoch auch nach zwei beliebigen Spalten')
||' anordnen, wie <code>JOB</code> und <code>DEPTNO</code></p>',
unistr('<p><em>Hinweis: Der Spalten der Navigationsreihenfolge m\00FCssen mit den Standardspalten \00FCbereinstimmen, mit denen der Bericht angeordnet wurde, aus dem Endbenutzer zu dieser Form navigiert sind. Alternativ m\00FCssen Sie sicherstellen, dass Endbenutzer ver')
||unistr('stehen, wie die vorherigen und n\00E4chsten Zeilen bestimmt werden, beispielsweise mit Schaltfl\00E4chenlabels oder Hilfetext.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Spalte f\00FCr die sekund\00E4re Navigationsreihenfolge')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4414)
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den zweiten Wert der Navigationsreihenfolge enth\00E4lt. Dieses Attribut darf nur aufgef\00FCllt werden, wenn der Navigationsschl\00FCssel aus zwei Spalten besteht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('N\00E4chstes Prim\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Prim\00E4rschl\00FCsselspalte f\00FCr den <em>n\00E4chsten</em> Datensatz enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Vorheriges Prim\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Prim\00E4rschl\00FCsselspalte f\00FCr den <em>vorherigen</em> Datensatz enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('N\00E4chstes Sekund\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der zweiten Prim\00E4rschl\00FCsselspalte f\00FCr den <em>n\00E4chsten</em> Datensatz enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Vorheriges Sekund\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der zweiten Prim\00E4rschl\00FCsselspalte f\00FCr den <em>vorherigen</em> Datensatz enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Aktuelles Zeilenanzahlelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Seiten- oder Anwendungselement ein, das den Wert f\00FCr die Gesamtanzahl von Datens\00E4tze enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.</p>'),
unistr('<p>Wenn die Ergebnismenge mehr als 10.000 Zeilen enth\00E4lt, kann die Performance durch Definition dieses Elements beeintr\00E4chtigt werden.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4414)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Laufzeit-WHERE-Klausel'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>unistr('Geben Sie eine SQL-Anweisung ein, um die von der Abfrage zur\00FCckgegebenen Datens\00E4tze zu begrenzen.')
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>unistr('Vorg\00E4nger-Webservice')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Prozess, mit dem der angegebene Webservice konsumiert wird. Oracle empfiehlt, dass Sie diesen Prozess zu <strong>Webservice</strong> aktualisieren.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4414)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Webservicereferenz'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Geben Sie die Referenznummer des Webservice ein.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4414)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Ergebnis speichern in'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4414)
,p_display_sequence=>10
,p_display_value=>'Element(e)'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4414)
,p_display_sequence=>20
,p_display_value=>'Collection'
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4414)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Collection-Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>'Textbereich'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt einen mehrzeiligen Textbereich an.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4414)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Gr\00F6\00DFen\00E4nderung m\00F6glich')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Geben Sie an, ob die Skalierung des Textbereichs mit der Maus aktiviert ist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4414)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Autom. H\00F6he')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob die H\00F6he des Textbereichs je nach der eingegebenen Textmenge variiert. Mit dieser Option k\00F6nnen Sie den Textbereich an die Menge der Daten anpassen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4414)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Zeichenz\00E4hler')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob ein Z\00E4hler unter dem Textbereich angezeigt wird. Der Z\00E4hler zeigt die Anzahl von Zeichen an, die in das Feld eingegeben wurden, und die zul\00E4ssige Gesamtanzahl von Zeichen, wie <code>123 von 4000</code>. Das Attribut "Maximale L\00E4nge" ')
||'muss angegeben werden, wenn dies aktiviert ist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4414)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Leerzeichen abschneiden'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie der Elementwert nach Weiterleitung der Seite abgeschnitten werden soll. Diese Einstellung schneidet Leerzeichen, Tabulatorzeichen und Zeilenvorsch\00FCbe aus dem eingegebenen Text ab.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4414)
,p_display_sequence=>10
,p_display_value=>unistr('F\00FChrend')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Abschlie\00DFend')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4414)
,p_display_sequence=>30
,p_display_value=>unistr('F\00FChrend und abschlie\00DFend')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4414)
,p_display_sequence=>40
,p_display_value=>'Keine'
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>'Klassischer Bericht'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Vereinfachter Bericht basierend auf einer SQL-Abfrage. Klassische Berichte entsprechen interaktiven Berichten, umfassen jedoch zahlreiche Endbenutzeranpassungsoptionen nicht, die in interaktiven Berichten zur Verf\00FCgung stehen.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4414)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' wobei deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>'Tabellarisches Formular'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Zeigt mehrere Datenzeilen in einem Grid-Layout an, wobei Endbenutzer Werte direkt innerhalb eines Grid-Elements aktualisieren k\00F6nnen.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4414)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4414)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>'Interaktiver Bericht'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Umfassender Onlinebericht basierend auf einer SQL-Abfrage, der Endbenutzern zahlreiche Features f\00FCr die Anpassung des Berichtslayouts zur Laufzeit bereitstellt. Sie k\00F6nnen die Endbenutzerm\00F6glichkeiten steuern, indem Sie verschiedene Optionen zur B')
||'erichtsanpassung aktivieren oder deaktivieren.</p>',
unistr('<p>Sie k\00F6nnen einen einzelnen interaktiven Bericht definieren, bei dem Endbenutzer die angezeigten Daten entsprechend ihren spezifischen Berichtsanforderungen bearbeiten k\00F6nnen, sodass Sie nicht mehrere \00E4hnliche Berichte mit unterschiedlichen Kriteri')
||unistr('en entwickeln m\00FCssen, um diese Anforderungen zu erf\00FCllen.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4414)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Struktur des Men\00FCs "Aktionen"')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie an, ob die Struktur des Men\00FCs "Aktionen" mit der interaktiven Rasterkomponente konsistent sein soll oder ob die Legacy-Struktur verwendet werden soll.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4414)
,p_display_sequence=>10
,p_display_value=>'Legacy'
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4414)
,p_display_sequence=>20
,p_display_value=>'Interaktives Grid'
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4414)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' wobei deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>'Statischer Inhalt'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Zeigt Textinhalt oder einen Regionscontainer f\00FCr Seitenelemente an. Zur Ausgabe von HTML-Markup ohne Maskierung des Inhalts, setzen Sie <em>Ausgabe als</em> auf <strong>HTML</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4414)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>'Shortcuts einblenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>'Geben Sie an, ob &PRODUCT_NAME. Shortcuts im HTML-Body einblendet.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4414)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Ausgabe als'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie der Textinhalt ausgegeben wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4414)
,p_display_sequence=>10
,p_display_value=>'HTML-Text (Sonderzeichen maskieren)'
,p_return_value=>'TEXT'
,p_help_text=>'&PRODUCT_NAME. maskiert HTML-Sonderzeichen wie <code>"<", ">", "&"</code>, wenn die Regionsquelle ausgegeben wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4414)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME. nimmt HTML-Markup bei der Ausgabe der Regionsquelle auf. Dadurch kann die Region f\00FCr website\00FCbergreifendes Skripting anf\00E4llig werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4414)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('Zeilenumbr\00FCche anzeigen')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('Geben Sie an, ob Zeilenumbr\00FCche in der Regionsquelle zu Zeilenumbr\00FCchen in der Regionsausgabe f\00FChren.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4414)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4414)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>'Dynamischer PL/SQL-Inhalt'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt die HTML-Ausgabe aus dem PL/SQL-Code an.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4414)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4414)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>'SVG-Diagramm'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Zeigt Daten in einem SVG-Diagramm an. Dieser Regionstyp ist veraltet. Verwenden Sie den Regionstyp <em>Diagramm</em> f\00FCr neue Diagrammregionen. Oracle empfiehlt, dass Sie <em>Anwendung upgraden</em> verwenden, um diese Regionen auf die entsprechende ')
||'Diagrammregion zu aktualisieren.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4414)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4414)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>'Einfaches Diagramm'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Zeigen Sie Daten in einem HTML-Diagramm an. Dieser Regionstyp ist veraltet. Verwenden Sie den Regionstyp <em>Diagramm</em> f\00FCr neue Diagrammregionen. Oracle empfiehlt, dass Sie <em>Anwendung upgraden</em> verwenden, um diese Regionen auf die entsprec')
||'hende Diagrammregion zu aktualisieren.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>'Baum'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigen Sie Daten in einer hierarchischen Struktur basierend auf Eltern-Kind-Beziehungen zwischen Datens\00E4tzen an.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>'Knotenlink aktivieren mit'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie die Aktion aus, die zum Aktivieren von Knotenlinks im Baum erforderlich sein soll. Ein Baum kann haupts\00E4chlich zur Auswahl/Anzeige oder zur Navigation verwendet werden. Wenn er sowohl zur Auswahl als auch zur Navigation verwendet wird, ')
||unistr('wird empfohlen, die Aktion "Doppelklick" festzulegen, sodass ein Einzelklick lediglich zur Auswahl des Knotens f\00FChrt.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4414)
,p_display_sequence=>10
,p_display_value=>'Einzelklick'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4414)
,p_display_sequence=>20
,p_display_value=>'Doppelklick'
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('Gew\00E4hltes Knotenseitenelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie das Seiten- oder Anwendungselement aus, das den ausgew\00E4hlten Knotenwert enthalten soll. Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Elementen ausw\00E4hlen.</p>'),
unistr('<p>In diesem Element kann der Baumstatus gespeichert werden, indem der Wert des letzten ausgew\00E4hlten Knotens gespeichert wird. Der Wert des ausgew\00E4hlten Knotens kann im ausgew\00E4hlten Element \00FCber das Knotenlinkattribut oder \00FCber einen Seitenprozess ge')
||unistr('speichert werden. Beim erneuten Laden der Seite wird der Baum mit dem zuletzt ausgew\00E4hlten Knoten ge\00F6ffnet.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>'QuickInfo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, ob QuickInfos angezeigt werden, und geben Sie die Quelle f\00FCr die QuickInfo an. Wenn eine QuickInfo definiert ist, wird sie angezeigt, wenn der Endbenutzer ein Baumknotenlabel fokussiert oder darauf zeigt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4414)
,p_display_sequence=>10
,p_display_value=>'Keine'
,p_return_value=>'N'
,p_help_text=>'Keine QuickInfo wird angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4414)
,p_display_sequence=>20
,p_display_value=>'Legacy-Template'
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>'Verwenden Sie einen statischen QuickInfo-Wert mit den folgenden Datenquellenspalten-Ersetzungen: #VALUE#, #TITLE#, #LINK# und #TOOLTIP#'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4414)
,p_display_sequence=>30
,p_display_value=>'HTML-Ausdruck'
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('Geben Sie einen HTML-Ausdruck an, der als QuickInfo verwendet werden soll. Ersetzungen werden durchgef\00FChrt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4414)
,p_display_sequence=>40
,p_display_value=>'Datenbankspalte'
,p_return_value=>'DB'
,p_help_text=>'Verwenden Sie den Wert der <strong>QuickInfo-Spalte</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>'QuickInfo-Wert'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>'Geben Sie den Text ein, der angezeigt wird, wenn ein Endbenutzer auf ein Baumelement zeigt.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>'Statische Baum-ID'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Eine optionale eindeutige ID f\00FCr den Baum.</p>'),
unistr('<p>Es wird empfohlen, f\00FCr die Region eine statische ID zu definieren und die API apex.region("<i>static-id</i>").widget() f\00FCr den Zugriff auf das Baumelement zu verwenden.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>'Symboltyp-CSS-Klasse'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Eine CSS-Klasse, mit der der Typ der Symbole angegeben wird, die f\00FCr alle Knoten verwendet werden. Diese Klasse wird in CSS-Regeln verwendet, um Eigenschaften f\00FCr alle Symbole dieses Typs anzugeben. Der Symboltyp bestimmt zusammen mit dem Wert der')
||unistr(' Symbolspalte der Regionsquelle die f\00FCr jeden Knoten verwendeten Symbol-CSS-Klassen.</p>'),
'<p>Typische Werte:</p>',
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong> Erm\00F6glicht die Verwendung einer kleinen Anzahl integrierter APEX-Symbole wie <code>icon-circle</code> oder <code>icon-tree-folder</code>.</li>'),
unistr('<li><strong><code>fa</code></strong> Erm\00F6glicht die Verwendung von Font APEX- oder Font Awesome-Symbolen. Universal Theme stellt eine dieser Symbol-Librarys zur Verf\00FCgung.</li>'),
'</ul>',
'<p>Wenn kein Wert angegeben wird, gibt es keinen Symboltyp. Die CSS-Klasse des Symboltyps kann bei Bedarf in die Symbolspalte aufgenommen werden. Beispiel: Die Symbolspalte kann den Wert "fa fa-user" haben.',
unistr('Lassen Sie f\00FCr einen Baum ohne Symbole die Attribute "Symboltyp" und "Standardsymbol" leer. In der SQL-Abfragequelle muss die Symbolspalte auf Null gesetzt sein.'),
unistr('Benutzerdefinierte Themes oder Themes von Drittanbietern k\00F6nnen ihre eigene Schriftart- oder CSS-Sprite-Symbol-Library haben und einen anderen Symboltyp/eine andere Pr\00E4fixklasse verwenden, die bzw. den Sie hier angeben k\00F6nnen.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>'Standardsymbol-CSS-Klasse'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>Wenn unter "Symboltyp" <code>fa</code> f\00FCr "Font APEX" eingestellt ist, k\00F6nnen Sie unter anderem folgende Werte verwenden: <code>fa-user-circle-o</code>, <code>fa-file-o</code> oder <code>fa-arrow-circle-right</code>. Eine Liste aller Symbole find')
||'en Sie in der Universal Theme-App.</p>'
,p_help_text=>unistr('Das Standardsymbol, das verwendet werden soll, wenn die Symbolspalte f\00FCr die SQL-Abfrage Null ist. Der Wert ist ein CSS-Klassenname, der angibt, welches Symbol angezeigt wird. M\00F6gliche Werte sind vom Symboltyp abh\00E4ngig.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>'Knotenlabelspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr das Knotenlabel enth\00E4lt. Der Wert darf kein Markup enthalten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>'Hierarchieebenenspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr die Hierarchieebene des Knotens enth\00E4lt. Erforderlich, wenn das Attribut <strong>Hierarchie</strong> auf <strong>Nicht berechnet</strong> gesetzt ist.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>'Symbol-CSS-Klassenspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr die Symbol-CSS-Klasse enth\00E4lt, die auf den Knoten angewendet werden soll.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>'Knoten-ID-Spalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die die ID f\00FCr einen Knoten enth\00E4lt. Dies ist erforderlich, wenn die Hierarchie von Application Express berechnet wird. In der Regel wird hier eine Prim\00E4rschl\00FCsselspalte ausgew\00E4hlt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>unistr('\00DCbergeordnete Schl\00FCsselspalte')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr den \00FCbergeordneten Schl\00FCssel eines Knotens enth\00E4lt. Erforderlich, wenn Application Express die Hierarchie berechnet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>'Knotenstatusspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr den Knotenstatus enth\00E4lt. Erforderlich, wenn das Attribut <strong>Hierarchie</strong> auf <strong>Nicht berechnet</strong> gesetzt ist. Die Spalte muss <strong>0</strong> f\00FCr Blattknoten und <st')
||unistr('rong>1</strong> f\00FCr Knoten mit untergeordneten Elementen enthalten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>'Baum beginnen mit'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Dieses Attribut bestimmt, wie die Root des Baumes berechnet wird. Knoten, f\00FCr die die Spalte <strong>\00DCbergeordneter Schl\00FCssel</strong> den hier definierten Wert enth\00E4lt, werden als Root-Knoten betrachtet. Mehrere Roots sind m\00F6glich.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4414)
,p_display_sequence=>10
,p_display_value=>'Basierend auf vorhandenem Element'
,p_return_value=>'ITEM'
,p_help_text=>'Verwenden Sie einen Elementwert zum Beginnen des Baumes.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4414)
,p_display_sequence=>20
,p_display_value=>'Basierend auf SQL-Abfrage'
,p_return_value=>'SQL'
,p_help_text=>unistr('Verwenden Sie den von einer SQL-Abfrage zur\00FCckgegebenen Wert zum Beginnen des Baumes.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4414)
,p_display_sequence=>30
,p_display_value=>'Basierend auf statischem Wert'
,p_return_value=>'STATIC'
,p_help_text=>'Verwenden Sie einen statischen Wert zum Beginnen des Baumes.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4414)
,p_display_sequence=>40
,p_display_value=>'Wert ist NULL'
,p_return_value=>'NULL'
,p_help_text=>'Verwenden Sie SQL NULL zum Beginnen des Baumes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>'Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('W\00E4hlen Sie das Element mit dem Wert aus, mit dem der Baum begonnen wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>'SQL-Abfrage'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('Geben Sie die SQL-Abfrage an, die den Wert bestimmt, mit dem der Baum begonnen wird. Die SQL-Abfrage wird immer in der <em>lokalen Datenbank</em> ausgef\00FChrt und muss genau eine Spalte zur\00FCckgeben.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>'Statischer Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>'Statischer Wert, mit dem der Baum begonnen wird.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>'Knotenwertspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr den Knoten-"Wert" enth\00E4lt. Dieser Wert wird nicht angezeigt, aber zur Eigenschaft f\00FCr die Baumadapterknoten-ID hinzugef\00FCgt, auf die Sie mit JavaScript zugreifen k\00F6nnen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>'Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Link an, der ausgef\00FChrt werden soll, wenn auf einen Knoten geklickt wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>'QuickInfo-Spalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr die Knoten-QuickInfo enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>'Hierarchie'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Geben Sie an, ob Application Express die Baumhierarchie aus den Daten berechnen soll oder ob die Daten bereits alle Hierarchieinformationen enthalten.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_display_sequence=>10
,p_display_value=>'Mit SQL berechnet'
,p_return_value=>'SQL'
,p_help_text=>unistr('Die Hierarchie wird mit der SQL-Klausel START WITH CONNECT BY berechnet. Sie m\00FCssen eine <strong>\00DCbergeordnete Schl\00FCsselspalte</strong> angeben. Verwenden Sie diese Option nur, wenn die SQL-Abfrage noch <em>keine</em> START WITH CONNECT BY-Klausel en')
||unistr('th\00E4lt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_display_sequence=>20
,p_display_value=>'Nicht berechnet'
,p_return_value=>'LEVEL'
,p_help_text=>unistr('Alle Hierarchieinformationen sind bereits in den Daten enthalten. Die Zuordnung der Spalten <strong>Knotenebene</strong> und <strong>Knotenstatus</strong> ist f\00FCr diese Option erforderlich. Die <strong>Knotenebene</strong> muss die Hierarchieebene al')
||unistr('s numerischen Wert enthalten. Der <strong>Knotenstatus</strong> muss <strong>0</strong> f\00FCr einen Blattknoten und <strong>1</strong> f\00FCr einen Nicht-Blattknoten enthalten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>'Link-Spalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, die den Wert f\00FCr den Link enth\00E4lt, der beim Klicken auf einen Knoten ausgef\00FChrt werden soll.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>'Gleichrangige Objekte sortieren nach'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('W\00E4hlen Sie die Datenquellenspalte aus, mit der untergeordnete Elemente in einem \00FCbergeordneten Knoten sortiert werden.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine JavaScript-Funktion ein, die ein Optionsobjekt f\00FCr den Baum \00E4ndert und das Objekt zur\00FCckgibt. Dadurch wird w\00E4hrend der Initialisierung des treeView-Widgets eine erweiterte Anpassung des Baums erm\00F6glicht. Die verf\00FCgbaren Optionen fin')
||unistr('den Sie in der Dokumentation zur JavaScript-API f\00FCr das treeView-Widget.<p>'),
unistr('<p>Zus\00E4tzliche durch die Baumregion definierte Optionen:</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong> Dient zum Definieren eines benutzerdefinierten nodeAdapter. Diese Funktion verwendet dieselben Argumente wie makeDefaultNodeAdapter und muss eine treeNodeAdapter-Schnittstelle zur\00FCckgeben.</li>'),
unistr('<li><strong>initialSelectedNodeId</strong> Der Wert eines auszuw\00E4hlenden Knotens. Dieser Wert wird entsprechend dem Attribut "Gew\00E4hltes Knotenseitenelement" festgelegt.</li>'),
'<li><strong>nodeHasTooltip</strong> Dies wird entsprechend dem Attribut "QuickInfo" festgelegt. Wenn der Knoten eine QuickInfo hat, lautet der Wert "true", andernfalls "false".</li>',
unistr('<li><strong>regionStaticId</strong> Dies ist die f\00FCr diese Region verwendete Element-ID.</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Wenn das Hierarchieattribut auf "Mit SQL berechnet" gesetzt ist</dt>',
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
unistr('<p>Geben Sie EMPNO als Knoten-ID-Spalte, MGR als \00FCbergeordnete Schl\00FCsselspalte an</p>'),
'</dd>',
'<dt>Wenn das Hierarchieattribut auf "Nicht berechnet" gesetzt ist</dt>',
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
'<p>Geben Sie STATUS als Knotenstatusspalte, LEVEL als Hierarchieebenenspalte an.</p>',
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4414)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4414)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('Auswahl\00E4nderung')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>'Kalender'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Datumsangaben basierend auf verschiedenen Kalenderansichten anzeigen.</p>',
unistr('<p>Sie sollten <em>Kalender</em> anstelle dieses Regionstyps verwenden, wenn Sie neue Regionen erstellen. Klassische Kalenderregionen werden im Allgemeinen in &PRODUCT_NAME. Release 4.2 oder fr\00FCher erstellt.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4414)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4414)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>'Klassischer Baum'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Daten in einer hierarchischen Struktur basierend auf Eltern-Kind-Beziehungen zwischen Datens\00E4tzen anzeigen.</p>'),
'<p>Sie sollten <em>Baum</em> anstelle dieses Regionstyps verwenden, wenn Sie neue Regionen erstellen. </p>'))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4414)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Baumkomponenten-ID'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>'Baum einblenden'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Blenden Sie den aktuellen Knoten in einer Baumregion ein.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>'Baum ausblenden'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Blenden Sie den aktuellen Knoten in einer Baumregion aus.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>'Kennwort'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt ein HTML-Kennwort-Formularelement an. W\00E4hrend der Endbenutzer Text eingibt, wird ein schwarzer Punkt f\00FCr dieses Zeichen anstelle des eigentlich eingegebenen Zeichens angezeigt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4414)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nach Dr\00FCcken der EINGABETASTE weiterleiten')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob die Seite automatisch weitergeleitet wird, wenn in diesem Feld die <em>Eingabetaste</em> gedr\00FCckt wird.')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>'Grid-Layout stoppen und starten'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vorg\00E4ngerelement. Wird verwendet, um die vorherige HTML-Tabelle zu stoppen und eine neue HTML-Tabelle zu starten. Vor der Einf\00FChrung von <em>Grid-Layout</em> in &PRODUCT_NAME. Release xx wurde dieser Elementtyp h\00E4ufig zur individuellen Anpassung d')
||'er Anzeige von Seitenelementen verwendet.</p>',
unistr('<p>Oracle empfiehlt, dass Sie diese \00E4lteren Elementtypen l\00F6schen und die Option <em>Neues Grid starten</em> f\00FCr das n\00E4chste in dieser Region angezeigte Seitenelement auf <strong>Ja</strong> setzen. Dies ist funktional gleichbedeutend mit der Verwendu')
||'ng eines Elements "Grid-Layout stoppen und starten".</p>'))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>'Aktualisieren'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('L\00F6st eine Aktualisierung der betroffenen Elemente aus. Nicht alle Elemente unterst\00FCtzen eine Aktualisierungsaktion. Sie k\00F6nnen diese Aktion verwenden, um den Inhalt in interaktiven Berichten, klassischen Berichten und allen Elementtypen zu aktualisie')
||unistr('ren, die kaskadierende LOVs unterst\00FCtzen.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>'Anzeigen'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Zeigt die betroffenen Elemente an.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4414)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Alle in derselben Zeile anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie an, ob alle Seitenelemente und Labels auf derselben Zeile wie die betroffenen Elemente angezeigt werden sollen.</p>',
unistr('<p>Hinweis: Dieses Attribut kann nicht f\00FCr Elemente auf Seiten verwendet werden, die kein Tabellen-Grid zur Anzeige von Formelementen verwenden. Dies umfasst jede Seite, die ein mobiles Seitentemplate verwendet.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>'HTTP-Headervariable'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Extern authentifizieren, wobei der Benutzername in einer HTTP-Headervariable gespeichert wird, die vom Webserver festgelegt wird.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4414)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP-Headervariablenname'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gibt den Namen der HTTP-Headervariable an, die den Benutzernamen enth\00E4lt. Wenn keine Angabe gemacht wird, wird REMOTE_USER verwendet.</p>'),
'',
'<p>Die HTTP-Headervariable ist eine Variable, die vom Webserver festgelegt wurde.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4414)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Aktion, wenn "Benutzername" leer ist'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Gibt die Aktion an, die ausgef\00FChrt werden muss, wenn der Benutzername leer ist, der in der HTTP-Headervariable gespeichert ist. Die folgenden Optionen sind verf\00FCgbar:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>Zu integrierter URL umleiten</strong>, um eine Anmeldung durch den Webserver auszul\00F6sen. Diese integrierte URL muss so eingerichtet werden, dass sie vom Webserver gesch\00FCtzt wird, um eine Anmeldung zu erzwingen, wenn sie aufgerufen wird.')
||unistr(' Nach der Anmeldung muss der Webserver den validierten Benutzernamen in der HTTP-Headervariable speichern, damit er f\00FCr das Authentifizierungsschema verf\00FCgbar ist. Die integrierte URL ist'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('Das Pr\00E4fix <code>/apex/</code> h\00E4ngt von Ihrer Serverkonfiguration ab.'),
'</li>',
unistr('  <li><strong>Zu URL umleiten</strong>, um eine Anmeldung bei einem externen Server zu starten, der dann den validierten Benutzernamen in der HTTP-Headervariable festlegt. Der externe Server muss eine Umleitung zur\00FCck zu der Anwendung mit der URL vor')
||unistr('nehmen, die von dem Platzhalter <code>#CALLBACK#</code> generiert wird, um die Authentifizierung in der Anwendung abzuschlie\00DFen.</li>'),
unistr('  <li><strong>Fehler anzeigen</strong> zeigt die angegebene Fehlermeldung an. In der Anwendung wird keine Anmeldung durchgef\00FChrt.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4414)
,p_display_sequence=>10
,p_display_value=>'Zu integrierter URL umleiten'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4414)
,p_display_sequence=>20
,p_display_value=>'Zu URL umleiten'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4414)
,p_display_sequence=>30
,p_display_value=>'Fehler anzeigen'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4414)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('Gibt die URL eines externen Anmeldeservers an, der den validierten Benutzernamen in der HTTP-Headervariable festlegt. Der externe Server muss eine Umleitung zur\00FCck zu der Anwendung mit der URL vornehmen, die von dem Platzhalter <code>#CALLBACK#</code')
||unistr('> generiert wird, um die Authentifizierung in der Anwendung abzuschlie\00DFen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4414)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Fehlermeldung'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>unistr('Gibt die Fehlermeldung an, die angezeigt werden muss, wenn die HTTP-Headervariable keinen Wert enth\00E4lt oder die HTTP-Headervariable nicht vorhanden ist.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4414)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Benutzername verifizieren'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Gibt an, wie oft der in der HTTP-Headervariable gespeicherte Benutzername verifiziert wird. Die folgenden Optionen stehen zur Verf\00FCgung:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>Jede Anforderung</strong> erwartet, dass die CGI-Variable immer gesetzt wird, sobald die Anmeldung vom Webserver ausgef\00FChrt wurde. Wenn der Benutzername nicht identisch mit dem Namen ist, der in der aktuellen &PRODUCT_NAME.-Session gesp')
||unistr('eichert ist, wird die Session invalidiert und eine neue Anmeldung wird ausgel\00F6st. Dies ist die sicherste Option, weil sie Abmeldungen oder \00C4nderungen des Benutzernamens erkennt.'),
'  </li>',
unistr('  <li><strong>Nach Anmeldung</strong> verifiziert und speichert den Benutzernamen nur in der &PRODUCT_NAME.-Session, nachdem der Webserver die Anmeldung ausger\00FChrt hat und ruft den Callback auf, um die Authentifizierung in der Anwendung abzuschlie\00DFen')
||unistr('. F\00FCr den Callback wird auf die Konfiguration von "Aktion, wenn Benutzername leer ist" verwiesen.'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4414)
,p_display_sequence=>10
,p_display_value=>'Jede Anforderung'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4414)
,p_display_sequence=>20
,p_display_value=>'Nach Anmeldung'
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4414)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Abmelde-URL des SSO-Servers'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Beispiel: F\00FCr ein auf Oracle Access Manager basierendes SSO geben Sie Folgendes ein:</p>'),
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn das Authentifizierungsschema auf Oracle Access Manager oder \00E4hnlichen Servern basiert,'),
unistr('k\00F6nnen Sie mit diesem Attribut eine URL zum Abmelden von dem zentralen Single Sign-On-Server angeben.'),
'',
'Der Ersetzungsparameter <strong>%POST_LOGOUT_URL%</strong> wird durch eine codierte URL zur Anmeldeseite Ihrer Anwendung ersetzt.'))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>'HTML-Ausdruck'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt ein nicht-bearbeitbares Element basierend auf einem HTML-Ausdruck an.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4414)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTML-Ausdruck'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\00C4ndert die Hintergrund- und Textfarben</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Verwendet \00DCberschrift 2</dt>'),
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Verwendet eine dynamische Klasse aus der SQL-Abfrage</dt>',
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Die Ersetzungen <code>&amp;COLUMN_CLASS!ATTR.</code> und <code>&amp;EMPLOYEE_STATUS.</code> in diesem Beispiel sind Spalten, die in der SQL-Abfrage ausgew\00E4hlt sind.</dd>'),
'  <dt>Zeigt ein Bild und eine QuickInfo an, wenn darauf gezeigt wird</dt>',
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Geben Sie die HTML-Ausdr\00FCcke ein, die in dieser Spalte angezeigt werden sollen. Verwenden Sie die <code>&amp;COLUMN.</code>-Syntax, um Spaltenwerte in HTML anzuzeigen.')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>'Link'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt ein nicht bearbeitbares Element als Link an.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>unistr('Zur\00FCcksetzen')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('L\00F6scht die betroffenen Elemente.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>'Alert'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt eine Alert-Meldung mit einer einzelnen <em>OK</em>-Schaltfl\00E4che an. Verwenden Sie diese Option zur Anzeige von Informationen, die eine Reaktion erfordern, indem Sie auf die Schaltfl\00E4che klicken, w\00E4hrend mit der Ausf\00FChrung des Ereignisses fortge')
||'fahren wird.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4414)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Meldung'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>Mitarbeiter &amp;P1_ENAME. &lt;strong&gt;konnte nicht&lt;&#x2F;strong&gt; gel\00F6scht werden.</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die Meldung ein, die im Alertdialogfeld angezeigt werden soll.</p>',
'<p>Elemente werden zum Zeitpunkt der Dialogfeldanzeige auf Clientseite ersetzt.</p>'))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4414)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Titel'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'<p>Geben Sie optional einen Dialogfeldtitel an.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4414)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Stil'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Standard'
,p_help_text=>'Geben Sie den Stil des Dialogfeldes an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4414)
,p_display_sequence=>10
,p_display_value=>'Informationen'
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4414)
,p_display_sequence=>20
,p_display_value=>'Gefahr'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4414)
,p_display_sequence=>30
,p_display_value=>'Warnung'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4414)
,p_display_sequence=>40
,p_display_value=>'Erfolg'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4414)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Symbol'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Geben Sie ein optionales Dialogfeldsymbol an.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4414)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'CSS-Klassen'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Geben Sie optionale CSS-Klassen ein, die auf den Dialogfeldcontainer angewendet werden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4414)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Label f\00FCr "OK"')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Geben Sie das Label der Schaltfl\00E4che "OK" ein. Wenn Sie kein Label angeben, wird der Wert der Textnachricht <code>APEX.DIALOG.OK</code> verwendet.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>unistr('Best\00E4tigen')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt ein Best\00E4tigungsdialogfeld mit den Schaltfl\00E4chen "Abbrechen" und "Best\00E4tigen" an. Wenn der Benutzer <em>Abbrechen</em> ausw\00E4hlt, werden die nachfolgenden Aktionen nicht ausgef\00FChrt, und das aktuelle Ereignis wird abgebrochen.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4414)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Meldung'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>M\00F6chten Sie den Mitarbeiter &amp;P1_ENAME. &lt;strong&gt;wirklich&lt;&#x2F;strong&gt; l\00F6schen?</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Meldung ein, die im Best\00E4tigungsdialogfeld angezeigt werden soll.</p>'),
'<p>Elemente werden zum Zeitpunkt der Dialogfeldanzeige auf Clientseite ersetzt.</p>'))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4414)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Titel'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'<p>Geben Sie optional einen Dialogfeldtitel an.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4414)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Stil'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Standard'
,p_help_text=>'Geben Sie den Stil des Dialogfeldes an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4414)
,p_display_sequence=>10
,p_display_value=>'Informationen'
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4414)
,p_display_sequence=>20
,p_display_value=>'Warnung'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4414)
,p_display_sequence=>30
,p_display_value=>'Gefahr'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4414)
,p_display_sequence=>40
,p_display_value=>'Erfolg'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4414)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Symbol'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Geben Sie ein optionales Dialogfeldsymbol an.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4414)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'CSS-Klassen'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Geben Sie optionale CSS-Klassen ein, die auf den Dialogfeldcontainer angewendet werden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4414)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Label f\00FCr "Best\00E4tigen"')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Geben Sie das Label der Best\00E4tigungsschaltfl\00E4che ein. Wenn Sie kein Label angeben, wird der Wert der Textnachricht <code>APEX.DIALOG.OK</code> verwendet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4414)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Label f\00FCr "Abbrechen"')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Geben Sie das Label der Schaltfl\00E4che "Abbrechen" ein. Wenn Sie kein Label angeben, wird der Wert der Textnachricht <code>APEX.DIALOG.CANCEL</code> verwendet.')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>'Hochgeladene Daten parsen'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Prozess zum Parsen der vorbereiteten Arbeitsblattdaten vor dem Laden in eine vorhandene Tabelle. Dieser Prozesstyp wird von dem Assistenten "Seite erstellen" f\00FCr <em>Data Loading</em> generiert.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Datenladedefinition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Datenladedefinition aus "Gemeinsame Komponenten", die die zu ladende Tabelle definiert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Aus Element importieren'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das die vom Endbenutzer ausgew\00E4hlte Option <em>Importieren aus</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Trennzeichenelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Text f\00FCr das <em>Trennzeichen</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Element "Umschlossen von"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Text f\00FCr <em>Optional umschlossen von</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Erstes Zeilenelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Kontrollk\00E4stchenwert <em>Erste Zeile enth\00E4lt Spaltennamen</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Element "W\00E4hrungssymbol"')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Text f\00FCr das <em>W\00E4hrungssymbol</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Element "Gruppentrennzeichen"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Text f\00FCr das <em>Gruppentrennzeichen</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Element "Dezimalzeichen"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Text f\00FCr das <em>Dezimalzeichen</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Element "Dateiname"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Wert f\00FCr <em>Dateiname</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Element "Kopieren und Einf\00FCgen"')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Text f\00FCr <em>Datum mit Begrenzungszeichen kopieren und einf\00FCgen</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen')
||'.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Zeichensatzelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer ausgew\00E4hlten <em>Dateizeichensatz</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4414)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Datumsformatelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seitenelement ein, das den vom Endbenutzer eingegebenen Text f\00FCr das <em>Datumsformat</em> enthalten soll. Sie k\00F6nnen den Namen eingeben oder einen Namen aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>'Spaltenzuordnung beim Hochladen von Daten'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Ordnen Sie hochgeladene Arbeitsblattspalten Tabellenspalten zu. Dieser Regionstyp wird von dem Assistenten "Seite erstellen" f\00FCr <em>Data Loading</em> generiert.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4414)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Datenladedefinition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Geben Sie die Datenladedefinition ein, die in dem Prozess <em>Data Loading</em> definiert wurde.'
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>'Hochgeladene Daten vorbereiten'
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Prozess zum Vorbereiten von Arbeitsblattdaten f\00FCr das Hochladen in eine vorhandene Tabelle. Dieser Prozesstyp wird von dem Assistenten "Seite erstellen" f\00FCr <em>Data Loading</em> generiert.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4414)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Datenladedefinition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Datenladedefinition aus "Gemeinsame Komponenten", die die zu ladende Tabelle definiert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4414)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Element "Anzahl Eingef\00FCgte"')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von einzuf\00FCgenden Datens\00E4tzen enthalten soll. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4414)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Element "Anzahl Aktualisierte"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von zu aktualisierenden Datens\00E4tzen enthalten soll. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4414)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Element "Anzahl Fehler"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von Datens\00E4tzen mit Fehlern enthalten soll. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4414)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Pr\00FCfungsanzahlelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von gepr\00FCften Datens\00E4tzen enthalten soll.'),
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')))
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>'Hochgeladene Daten laden'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Prozess zum Laden der geparsten Arbeitsblattdaten in eine vorhandene Tabelle. Dieser Prozesstyp wird von dem Assistenten "Seite erstellen" f\00FCr <em>Data Loading</em> generiert.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4414)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Datenladedefinition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Datenladefinition aus "Gemeinsame Komponenten", die die zu ladende Tabelle definiert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4414)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Element "Anzahl Eingef\00FCgte"')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von eingef\00FCgten Datens\00E4tzen enthalten soll.'),
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4414)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Element "Anzahl Aktualisierte"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von aktualisierten Datens\00E4tzen enthalten soll.'),
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4414)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Element "Anzahl Fehler"'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von Datens\00E4tzen mit Fehlern enthalten soll. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4414)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Pr\00FCfungsanzahlelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Seiten- oder Anwendungselement ein, das die Anzahl von gepr\00FCften Datens\00E4tzen enthalten soll.'),
unistr('Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>'Application Express-Accounts'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Geben Sie den Benutzernamen und das Kennwort f\00FCr Ihren &PRODUCT_NAME.-Account ein. Jeder Workspace hat ein eigenes Benutzeraccount-Repository. Die Anwendung, bei der Sie sich anmelden, geh\00F6rt zu Workspace &amp;F4155_WORKSPACE_NAME.. Beachten Sie, ')
||unistr('dass bei der Kennworteingabe die Gro\00DF-/Kleinschreibung ber\00FCcksichtigt werden muss.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>'Open Door-Zugangsdaten'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Damit kann jeder Benutzer auf die Anwendung zugreifen. Geben Sie eine ID ein, mit der Sie sich w\00E4hrend dieser Session als Benutzer der Anwendung identifizieren. Dadurch wird der Wert der Variable APP_USER festgelegt.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>'Datenbankaccounts'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('F\00FCr dieses Authentifizierungsschema muss ein Datenbankbenutzer (Schema) in der lokalen Datenbank vorhanden sein. Bei Verwendung dieser Methode werden der Benutzername und das Kennwort des Datenbankaccounts zur Authentifizierung des Benutzers verwende')
||'t.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>'LDAP-Verzeichnis'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Authentifizierung des Benutzers/Kennworts mit einer Authentifizierungsanforderung an einen LDAP-Server.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Der Hostname Ihres LDAP-Directory-Servers.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'Die Portnummer des LDAP-Directory-Hosts. Der Standardwert ist 389.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'SSL verwenden'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Legen Sie fest, ob SSL f\00FCr das Binding an das LDAP-Verzeichnis verwendet werden soll. Wenn SSL mit Authentifizierung ausgew\00E4hlt ist, muss ein Wallet f\00FCr die &PRODUCT_NAME.-Instanz konfiguriert sein.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4414)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4414)
,p_display_sequence=>20
,p_display_value=>'SSL mit Authentifizierung'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4414)
,p_display_sequence=>30
,p_display_value=>'Keine SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name-(DN-)Zeichenfolge'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie das Muster zum Erstellen der vollqualifizierten Distinguished Name-(DN-)Zeichenfolge f\00FCr DBMS_LDAP.SIMPLE_BIND_S ein, wenn Sie den exakten DN verwenden, oder die Suchbasis, wenn Sie nicht den exakten DN verwenden. Verwenden Sie <strong>%LDA')
||unistr('P_USER%</strong> als Platzhalter f\00FCr den Benutzernamen. Beispiel:'),
'<p>',
'<strong>Exakter DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Nicht-exakter DN (Suchbasis)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Exakten Distinguished Name (DN) verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Legen Sie fest, ob die Zeichenfolge f\00FCr den LDAP Distinguished Name (DN) exakt oder nicht exakt ist. Wenn sie nicht exakt ist, ist LDAP Distinguished Name (DN) die Suchbasis, und Sie m\00FCssen einen Suchfilter angeben.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Suchfilter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Suchfilter ein, wenn Sie nicht den exakten Distinguished Name (DN) verwenden. Verwenden Sie <b>%LDAP_USER%</b> als Platzhalter f\00FCr den Benutzernamen. Beispiel:'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Bearbeitungsfunktion f\00FCr den LDAP-Benutzernamen')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Sie k\00F6nnen zus\00E4tzlichen Code angeben, der zur Umwandlung des Benutzernamens in ein Format ausgef\00FChrt werden soll, das dem LDAP-Verzeichniseintrag oder LDAP-Benutzernamen genau entspricht.'),
unistr('Die Bind-Variable :USERNAME enth\00E4lt den angegebenen Namen des Endbenutzers.'),
'Beispiel: Der folgende Code ruft eine Funktion auf, die alle "." durch "_" in der DN-Zeichenfolge ersetzt:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME. escapt den zur\00FCckgegebenen Benutzernamen basierend auf dem Authentifizierungsattribut <strong>Benutzernamen-Escaping</strong>.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4414)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Benutzernamen-Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bevor Sie <strong>%LDAP_USER%</strong> im LDAP-Distinguished Name und in der Suchzeichenfolge ersetzen,',
'kann &PRODUCT_NAME. Sonderzeichen im Benutzernamen automatisch escapen.',
'<p/>',
unistr('Die m\00F6glichen Regeln f\00FCr das Escaping lauten wie folgt:'),
'<ul>',
'<li><strong>Standard</strong>:',
unistr('Sonderzeichen basierend auf RFC 4514 (f\00FCr Distinguished Names) und RFC 4515 (f\00FCr Suchzeichenfolgen) escapen.'),
unistr('Dar\00FCber hinaus werden Unicode-Zeichen escapt.'),
unistr('Dies ist die sicherste Einstellung. Diese kann aber zu Problemen mit einigen LDAP-Servern f\00FChren.</li>'),
'<li><strong>Nur Sonderzeichen</strong>:',
unistr('Sonderzeichen basierend auf RFC 4514 (f\00FCr Distinguished Names) und RFC 4515 (f\00FCr Suchzeichenfolgen) escapen.'),
'Keine Unicode-Zeichen escapen.</li>',
'<li><strong>Kein Escaping</strong>:',
'Keine Zeichen escapen.',
'Diese Einstellung kann unsicher sein,',
'wenn nicht eine <strong>Funktion zum Bearbeiten des Benutzernamens</strong> eingesetzt wurde, die',
'den Benutzernamen bereits escapt (z.B. mit apex_escape.ldap_dn oder apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4414)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4414)
,p_display_sequence=>20
,p_display_value=>'Nur Sonderzeichen'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4414)
,p_display_sequence=>30
,p_display_value=>'Kein Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Dies delegiert die Authentifizierung an den Oracle AS Single Sign-On-(SSO-)Server. Zur Verwendung dieses Authentifizierungsschemas muss Ihre Site als Partneranwendung mit dem SSO-Server registriert worden sein.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4414)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Name der Partneranwendung'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Wenn Sie die Authentifizierung mit Oracle Application Server Single Sign-On vornehmen und die Anwendung eine registrierte Partneranwendung mit SSO ist, geben Sie genau den Namen ein, den Sie bei der Registrierung der Partneranwendung mit SSO verwe'
||'ndet haben.',
'</p>',
'<p>',
'Wenn Sie sich darauf verlassen, dass &PRODUCT_NAME. die registrierte Partner-Anwendung ist, lassen Sie dieses Feld leer.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4414)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Abmelde-URL des SSO-Servers'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Geben Sie den Abmeldepfad des Single Sign-On-Servers ein. Beispiel:',
'<em>https://login.example.com/sso/logout</em>.',
unistr('Beim Abmelden von der Anwendung verwendet &PRODUCT_NAME. diesen Wert, verkettet "?p_done_url=" mit der Anmelde-URL der Anwendung und verwendet die resultierende URL f\00FCr die Abmeldung von Single Sign-On, bevor wieder zur Anwendung umgeleitet wird.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4414)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>'Keine Authentifizierung'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\00DCbernimmt den aktuellen Datenbankbenutzer. Dies kann in Verbindung mit einer mod_plsql-DAD-Konfiguration verwendet werden, die die Basisauthentifizierung zur Festlegung des Datenbanksessionbenutzers verwendet.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4414)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Benutzername'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Benutzernamen f\00FCr die &PRODUCT_NAME.-Session ein. Wenn der Name leer ist, verwendet &PRODUCT_NAME. den Datenbanksessionbenutzer (in der Regel APEX_PUBLIC_USER).')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>'Kalender'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt datumsbasierte Eintr\00E4ge in vielen verschiedenen Kalenderansichten an. Wenn ein Enddatum aufgenommen wird, kann der Kalender auf Dauer basierende Ereignisse anzeigen. Kalender k\00F6nnen Datens\00E4tze auch direkt aktualisieren, wenn "Drag-and-Drop" akt')
||'iviert ist.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('API-Schl\00FCssel von Google Calendar [veraltet]')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den API-Schl\00FCssel von Google Calendar ein, damit Kalender innerhalb dieser Anwendung mit Google-Kalenderdaten integriert werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>'Startdatumspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die das Startdatum f\00FCr Ereignisse enth\00E4lt, die in diesem Kalender angezeigt werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Enddatumsspalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die das Enddatum f\00FCr Ereignisse enth\00E4lt, die in diesem Kalender angezeigt werden. Wenn dieses Attribut angegeben wird, zeigt der Kalender Ereignisse an, die auf Dauer basieren.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>'Anzeigespalte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den Text enth\00E4lt, der f\00FCr Ereignisse in diesem Kalender angezeigt wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCsselwert f\00FCr Kalenderereignisse enth\00E4lt. Wenn die Tabelle einen mehrteiligen Prim\00E4rschl\00FCssel enth\00E4lt, w\00E4hlen Sie <strong>ROWID</strong>.</p>'),
unistr('<p>Der Wert dieser Spalte wird in der Ersetzungsvariable <code>APEX$PK_VALUE</code> zur\00FCckgegeben. Verwenden Sie diese Variable im Attribut <em>Code per Drag-and-Drop verschieben</em>, um den zu aktualisierenden Datensatz nach dem Drag-and-Drop-Vorga')
||'ng im Kalender zu identifizieren.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>'Link anzeigen/bearbeiten'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Geben Sie eine Zielseite ein, die aufgerufen werden soll, wenn der Benutzer auf einen vorhandenen Eintrag klickt.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Link erstellen'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine Zielseite ein, die aufgerufen werden soll, wenn der Benutzer auf eine leere Zelle oder au\00DFerhalb eines vorhandenen Kalendereintrags klickt.</p>'),
unistr('<p>Sie m\00FCssen die besonderen Kalenderersetzungsvariablen <pre>&APEX$NEW_START_DATE.</pre> und <pre>&APEX$NEW_END_DATE.</pre> verwenden, um die ausgew\00E4hlten Daten von dem Kalender an die Zielseite zu \00FCbergeben.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>'Drag-and-Drop'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Drag-and-Drop-Vorg\00E4nge bei diesem Kalender zul\00E4ssig sind.</p>'),
unistr('<p><em>Hinweis: Wenn Drag-and-Drop aktiviert ist, haben Endbenutzer mit der Berechtigung zur Anzeige dieses Kalenders auch die Berechtigung zur Aktualisierung von Kalendereintr\00E4gen.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>'PL/SQL-Code per Drag-and-Drop verschieben'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Beispiel nur mit Startdatum (bei nicht auf Dauer basierenden Ereignissen)</dt>',
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'<dt>Beispiel mit Start- und Enddatum (bei auf Dauer basierenden Ereignissen)</dt>',
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den PL/SQL-Code zur Aktualisierung der zugrunde liegenden Tabellen oder aktualisierbaren Views ein, wenn ein Kalendereintrag per Drag-and-Drop aktualisiert wird.</p>',
unistr('<p>Wenn dieser Kalender auf Dauer basierende Ereignisse (durch Auswahl einer Spalte f\00FCr das Enddatum) anzeigt, muss der PL/SQL-Code diesen Wert auch aktualisieren. Wenn das ganze Ereignis per Drag gezogen wird, beh\00E4lt das Enddatum die aktuelle Dauer ')
||unistr('bei. Wenn das Ende des Ereignisses per Drag gezogen wird, wird die Dauer des Ereignisses aktualisiert. In diesen F\00E4llen bleibt das Startdatum unver\00E4ndert, das Enddatum wird jedoch entsprechend der ge\00E4nderten Dauer aktualisiert.</p>'),
unistr('<p>Die Ersetzungsvariablen f\00FCr Kalender umfassen:</p>'),
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>Gibt das ge\00E4nderte Startdatum zur\00FCck. Das Datumsformat ist <code>''YYYYMMDDHH24MISS''</code>, selbst wenn <em>Uhrzeit anzeigen</em> f\00FCr diesen Kalender <strong>Nein</strong> ist.</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>Gibt das ge\00E4nderte Enddatum f\00FCr auf Dauer basierende Ereignisse zur\00FCck. Das Datumsformat ist <code>''YYYYMMDDHH24MISS''</code>, selbst wenn das <em>Uhrzeit anzeigen</em> f\00FCr diesen Kalender <strong>Nein</strong> ist.</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
unistr('    <dd>Gibt den Wert der Spalte zur\00FCck, die in der Spalte "Prim\00E4rschl\00FCssel" angegeben wird.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>unistr('Zus\00E4tzliche Kalenderansichten')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, welche zus\00E4tzlichen Kalenderansichten angezeigt werden sollen. Die Monatsansicht wird immer angezeigt.</p>'),
unistr('<p>Hinweis: Die w\00F6chentlichen und t\00E4glichen Ansichten sind nicht verf\00FCgbar, wenn f\00FCr "Zeit anzeigen" <strong>Nein</strong> angegeben ist.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4414)
,p_display_sequence=>40
,p_display_value=>'Liste'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4414)
,p_display_sequence=>50
,p_display_value=>'Navigation'
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Exportieren'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, welche Exportlinks am unteren Rand des Kalenders angezeigt werden.</p>'),
unistr('<p><em>Hinweis: Auf diese Weise werden alle aktuell angezeigten Kalendereintr\00E4ge exportiert und nicht ein einzelner Kalendereintrag.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4414)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4414)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4414)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>'Kalenderansichten und Navigation'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie die anzuzeigenden Kalenderansichten aus. Mindestens <strong>Tag</strong>, <strong>Woche</strong> oder <strong>Monat</strong> muss ausgew\00E4hlt werden. Wenn nicht, zeigt der Kalender automatisch die <strong>Monatsansicht</strong> an.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4414)
,p_display_sequence=>10
,p_display_value=>'Monat'
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4414)
,p_display_sequence=>20
,p_display_value=>'Woche'
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4414)
,p_display_sequence=>30
,p_display_value=>'Tag'
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4414)
,p_display_sequence=>35
,p_display_value=>'Liste'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4414)
,p_display_sequence=>40
,p_display_value=>'Navigation'
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Google Calendar-ID'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>'<p>Google Calendar-ID: abc123@group.calendar.google.com</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Google Calendar-ID f\00FCr den Kalenderdatenfeed ein, der in diesem Kalender angezeigt werden soll.</p>'),
unistr('<p>In Anbetracht der Sicherheitseinschr\00E4nkungen von Google Calendar m\00FCssen diese Kalender entweder \00F6ffentliche Kalender oder Kalender sein, die f\00FCr alle Endbenutzer dieses Kalenders verf\00FCgbar sind.</p>'),
unistr('<p><em>Hinweis: Der API-Schl\00FCssel von Google Calendar muss eingegeben werden, damit Google-Kalender ordnungsgem\00E4\00DF funktionieren. Navigieren Sie zu "Geteilte Komponenten > Komponenteneinstellungen > Kalender", um den Schl\00FCssel f\00FCr die Anwendung festzu')
||'legen.</em</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>'Uhrzeit anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, ob der Zeitteil des Datums angezeigt werden soll. </p>'),
unistr('<p>Die Wochen- und Tagesansichten werden nur angezeigt, wenn "Zeit anzeigen" auf <strong>Ja</strong> gesetzt ist. Wenn die Spalten f\00FCr das Anfangs- oder Enddatum keine Zeitkomponenten enthalten, werden sie als 00:00 Uhr angezeigt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>'CSS-Klasse'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Format des Kalenders basierend auf Projektstatus festlegen</p>',
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Spalte, die die CSS-Klasse zur Formatierung der Ereignisse enth\00E4lt, die in diesem Kalender angezeigt werden. <br>'),
unistr('Es ist eine Reihe von Standardklassen verf\00FCgbar:'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('Informationen zum Hinzuf\00FCgen von zus\00E4tzlichen CSS-Klassen finden Sie in der Dokumentation.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'REST-Webservice (JSON)'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die URL f\00FCr einen RESTful Webservicefeed ein, der in diesem Kalender angezeigt werden soll. Der Kalender kann JSON-Daten rendern, die aus externen Quellen abgerufen werden, wie Oracle REST Data Services. Diese Webservices m\00FCssen entweder')
||unistr(' \00F6ffentlich oder f\00FCr alle Endbenutzer dieses Kalenders verf\00FCgbar sein.</p>'),
unistr('<p>Der JSON-Feed muss so formatiert sein, dass er Folgendes enth\00E4lt:</p>'),
'<ol>',
unistr('<li>Die Liste des Ereignis-Arrays enth\00E4lt - <code>items</code></li>'),
unistr('<li>Jedes Ereignisobjekt enth\00E4lt - <code>{ id, title, start, allday, end, description }</code><br>Die "title"- und "start"-Attribute sind obligatorisch.</li>'),
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('Zus\00E4tzliche Informationen')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zus\00E4tzliche HTML ein, die in der Listenansicht und der QuickInfo angezeigt wird. Verwenden Sie die &COLUMN.-Syntax, um Spaltenwerte in HTML anzuzeigen. </p>'),
unistr('<p>Hinweis: "QuickInfo anzeigen" muss auf <strong>Ja</strong> gesetzt sein, damit diese zus\00E4tzlichen Informationen in den Ansichten f\00FCr Monat, Woche und Tag angezeigt werden.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>'Wochenende anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie, ob Samstag und Sonntag f\00FCr diesen Kalender angezeigt werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>'Zeitformat'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>W\00E4hlen Sie das Zeitformat zur Anzeige des Zeitteils eines Ereignisses f\00FCr diesen Kalender.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4414)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'00'
,p_help_text=>unistr('Nutzt das Anwendungszeitstempelformat, das unter "Globalisierung" eingegeben wird. Wenn dieses Attribut nicht aufgef\00FCllt wird, wird die NLS-Einstellung der Datenbank verwendet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4414)
,p_display_sequence=>20
,p_display_value=>'12 Stunden'
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigt die Uhrzeit im 12-Stunden-Format, einschlie\00DFlich a.m. (aus dem Lateinischen <em>ante meridiem</em>, d.h. "vor Mittag") und p.m. (<em>post meridiem</em>, "nach Mittag") an, wie 8:00 a.m. und 4:00 p.m.</p>'),
unistr('<p>Das tats\00E4chliche Anzeigeformat f\00FCr a.m./p.m., wie Gro\00DF-/Kleinschreibung und Punkte, wird aus dem Zeitstempelformat abgeleitet.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4414)
,p_display_sequence=>30
,p_display_value=>'24 Stunden'
,p_return_value=>'24'
,p_help_text=>'Zeigt die Uhrzeit im 24-Stunden-Format an, wie 08:00 und 16:00.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>'QuickInfo anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, ob eine QuickInfo angezeigt wird, wenn Benutzer auf ein Ereignis in diesem Kalender zeigen.</p>'),
unistr('<p><em>In dem Dropdown-Dialogfeld werden der Ereignisname, zus\00E4tzliche Informationen und Datumsdetails angezeigt.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>'Erste Stunde'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Geben Sie eine Ganzzahl zwischen 0 und 23 an, um die erste Stunde anzugeben, die in den Wochen- und Tageskalendern angezeigt werden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>'Max. Ereignisse/Tag'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die maximale Anzahl von Ereignissen an, die f\00FCr jeden Tag in der Monatsansicht angezeigt werden sollen. </p>'),
unistr('<p>Wenn mehr als die angegebene Anzahl von Ansichten an einem bestimmten Tag vorhanden ist, enth\00E4lt dieser Tag die Option <strong>Weitere...</strong>. Wenn Sie auf dieses Element klicken, wird ein Popup-Fenster mit allen Ereignissen f\00FCr diesen bestim')
||'mten Tag angezeigt</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>'Mehrzeilige Ereignisse'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie <strong>Ja</strong>, damit Ereignisse \00FCber mehrere Zeilen je nach L\00E4nge des Textes der Anzeigespalte angezeigt werden. </p>'),
unistr('<p>W\00E4hlen Sie <strong>Nein</strong>, wenn jedes Ereignis nur auf einer einzelnen Zeile angezeigt und Text abgeschnitten werden soll, der nicht in die Anzeigebreite passt. Der vollst\00E4ndige Text wird in der QuickInfo angezeigt.</p>'),
unistr('<p>Hinweis: Die Einstellung f\00FCr mehrzeilige Ereignisse wird nur in der Monatsansicht verwendet. Bei Wochen- oder Tagesansichten bestimmt die Dauer des Ereignisses die H\00F6he des angezeigten Ereignisses.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>'Version'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3 ist veraltet und wird demn\00E4chst von FullCalendar 5 abgel\00F6st. Es empfiehlt sich, diese Umstellung jetzt vorzunehmen, um Anwendungsfehler in zuk\00FCnftigen Versionen zu vermeiden. Wenn Sie benutzerdefinierten JavaScript-Initialisierungsc')
||unistr('ode verwenden, beachten Sie, dass sich die API von FullCalendar ge\00E4ndert hat und der Code wahrscheinlich angepasst werden muss.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4414)
,p_display_sequence=>10
,p_display_value=>'FullCalendar 3 [Veraltet]'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
'    pOptions.titleFormat      = "[Conference Schedule]";                                // custom title',
'    pOptions.slotMinTime      = "07:00:00";                                             // hide slots before minTime',
'    pOptions.slotMaxTime      = "18:00:00";                                             // hide slots after maxTime',
'    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // week view column headings',
'    pOptions.slotDuration     = "00:15:00";                                             // custom slot duration',
'    pOptions.weekNumbers      = true;                                                   // show week numbers',
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('Geben Sie eine JavaScript-Funktion ein, um die FullCalendar-Standardinitialisierungsattribute zu \00FCberschreiben. Die Funktion muss ein Objekt zur\00FCckgeben, das die Kalenderinitialisierungsattribute als Parameter enth\00E4lt.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Format des Kalenders basierend auf Projektstatus festlegen</p>,',
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Spalte, die die CSS-Klasse zur Formatierung der Ereignisse enth\00E4lt, die in diesem Kalender angezeigt werden. '),
unistr('Es ist eine Reihe von Standardklassen verf\00FCgbar:</p>'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>Informationen zum Hinzuf\00FCgen von zus\00E4tzlichen CSS-Klassen finden Sie in der Dokumentation.</p>')))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_name=>'apexcalendardateselect'
,p_display_name=>unistr('Datum ausgew\00E4hlt')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_name=>'apexcalendareventselect'
,p_display_name=>unistr('Ereignis ausgew\00E4hlt')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4414)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4414)
,p_name=>'apexcalendarviewchange'
,p_display_name=>unistr('View ge\00E4ndert')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('Tabellarisches Formular - Mehrzeiliges L\00F6schen')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Prozess, mit dem mehrere Zeilen aus einer tabellarischen Formularregion gel\00F6scht werden.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4414)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4414)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4414)
,p_help_text=>unistr('Geben Sie den Tabellen- oder aktualisierbaren View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4414)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4414)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCsselwert enth\00E4lt. Bei Tabellen mit mehr als zweiteiligen Prim\00E4rschl\00FCsseln w\00E4hlen Sie <strong>ROWID</strong>.</p>'),
unistr('<p>Der Prim\00E4rschl\00FCssel wird zur Identifizierung von zu l\00F6schenden Zeilen verwendet und darf im tabellarischen Formular nicht bearbeitet werden. Bei neuen Zeilen muss der Prim\00E4rschl\00FCsselwert leer sein.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4414)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4414)
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den zweiten Prim\00E4rschl\00FCsselwert enth\00E4lt. Dieses Attribut darf nur aufgef\00FCllt werden, wenn der Prim\00E4rschl\00FCssel aus zwei Spalten besteht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4414)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Laufzeit-WHERE-Klausel'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Begrenzen Sie die Abteilungen mit:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Geben Sie die SQL-WHERE-Klausel ein, die an die generierte DELETE-Anweisung angeh\00E4ngt werden muss. Verwenden Sie dieses Attribut, um die Datens\00E4tze zu begrenzen, die innerhalb automatisch generierter SQL-Aufrufe verwendet werden.')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>'Benutzervoreinstellungen'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Prozess, mit dem Benutzervoreinstellungen f\00FCr den Endbenutzer festgelegt werden.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4414)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Typ'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie einen zur\00FCckzusetzenden Prozesstyp, oder legen Sie Benutzervoreinstellungen fest.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Voreinstellungen zur\00FCcksetzen (entfernt alle Voreinstellungen f\00FCr den aktuellen Benutzer)')
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4414)
,p_display_sequence=>20
,p_display_value=>'Auf Elementwert festlegen'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4414)
,p_display_sequence=>30
,p_display_value=>'Auf Elementwert festlegen, wenn nicht Null'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4414)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Voreinstellungsname'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>unistr('Geben Sie einen Namen f\00FCr die Voreinstellung ein:')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4414)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Element'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('W\00E4hlen Sie ein Seiten- oder Anwendungselement, das den Voreinstellungswert enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>'Automatische Zeilenverarbeitung (DML)'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Prozess, mit dem Datens\00E4tze in einer einzelnen Datenbanktabelle oder aktualisierbaren View eingef\00FCgt, aktualisiert oder gel\00F6scht werden k\00F6nnen. Dieser Prozess wird zur Verarbeitung von Form-Elementen mit einer Quelle vom Typ <strong>Datenbankspalte</')
||unistr('strong> verwendet. F\00FCr diesen Prozess eingegebene Attribute m\00FCssen mit den Attributen korrelieren, die in den Prozess <em>Automatisches Abrufen von Zeilen</em> eingegeben wurden.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4414)
,p_help_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Prim\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Prim\00E4rschl\00FCsselspalte enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4414)
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCsselwert enth\00E4lt. Bei Tabellen mit mehr als zweiteiligen Prim\00E4rschl\00FCsseln, w\00E4hlen Sie <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Sekund\00E4rschl\00FCsselspalte enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('Sekund\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4414)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den zweiten Prim\00E4rschl\00FCsselwert enth\00E4lt. Dieses Attribut darf nur aufgef\00FCllt werden, wenn der Prim\00E4rschl\00FCssel aus zwei Spalten besteht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Zeilenversionsspalte'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die Spalte, die die Zeilenversion identifiziert. Diese Spalte muss auf der Seite nicht vorhanden sein. Lassen Sie dieses Attribut leer, um die integrierte Pr\00FCfsumme zu verwenden.</p>'),
unistr('<p>Die opportunistische Sperre verwendet die Ermittlung von verlorenen Updates, um die Datenintegrit\00E4t in Anwendungen sicherzustellen, bei denen nebenl\00E4ufig auf Daten zugegriffen werden kann. &PRODUCT_NAME. kann eine integrierte Pr\00FCfsumme verwenden, ')
||unistr('um verlorene Updates zu ermitteln und die Version der Zeile zu bestimmen. Die Pr\00FCfsumme ist eine Hashfunktion aller Spaltenwerte f\00FCr die spezifische Tabellenzeile. Sie wird abgerufen, wenn der Datensatz aus der Datenbank in <em>Automatischer Zeilenab')
||unistr('ruf</em> abgefragt wird, und wird dann mit dem Hash des aktuellen Datensatzes im Rahmen dieses Prozesses verglichen. Wenn die beiden Werte identisch sind, wird mit dem Update fortgefahren, sonst l\00F6st dieser Prozess einen Fehler aus.</p>'),
unistr('<p>Mit diesem Attribut k\00F6nnen Sie eine einzelne Spalte angeben, die die Zeilenversion enth\00E4lt, als Alternative zur Verwendung der integrierten Pr\00FCfsummenverarbeitung. Diese Spalte muss aktualisiert werden, wenn ein Datensatz in der Datenbank aktualis')
||unistr('iert wird. Oracle empfiehlt, dass Sie einen <em>Vor Update</em>-Datenbanktrigger auf der Tabelle implementieren oder die Spalte mit der Zeilenversion anderweitig aktualisieren. Es wird davon ausgegangen, dass NUMBER-Spalten eine Folgenummer f\00FCr die Z')
||unistr('eile enthalten. DATE- und TIMESTAMP-Spalten k\00F6nnen jedoch ebenfalls verwendet werden. Der Vorteil der Verwendung einer einzelnen Spalte besteht darin, dass die &PRODUCT_NAME. Engine nicht die gesamte Zeile hashen muss, sondern stattdessen einen einze')
||'lnen Spaltenwert vergleichen kann.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Laufzeit-WHERE-Klausel'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Begrenzen Sie die Abteilungen:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Geben Sie die SQL-WHERE-Klausel ein, die an alle generierten INSERT-, UPDATE- und DELETE-Anweisungen angeh\00E4ngt werden muss. Verwenden Sie dieses Attribut, um die Datens\00E4tze zu begrenzen, die innerhalb automatisch generierter SQL-Aufrufe verwendet wer')
||'den.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Schl\00FCssel an Element zur\00FCckgeben')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Prim\00E4rschl\00FCsselspalte enthalten soll, der aus einer SQL INSERT-Anweisung zur\00FCckgegeben wird. Sie k\00F6nnen den Namen eingeben oder aus einer Liste mit verf\00FCgbaren Elementen ausw\00E4hlen.')
||'</p>',
unistr('<p>Geben Sie diese Spalte an, um die Prim\00E4rschl\00FCsselfelder zur\00FCck zu erhalten, die mit Sequenzen oder Datenbanktriggern aufgef\00FCllt sind. Dieser Wert wird vom Prozess in den Sessionzustand gesetzt. </p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Zweiten Schl\00FCssel an Element zur\00FCckgeben')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der zweiten Prim\00E4rschl\00FCsselspalte enthalten soll, der von einer SQL INSERT-Anweisung zur\00FCckgegeben wird. Sie k\00F6nnen den Namen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hle')
||'n.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Unterst\00FCtzte Vorg\00E4nge')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Pr\00FCfen Sie, welche DML-(Data Manipulation Language-)Vorg\00E4nge unterst\00FCtzt werden. Dieser Datenverarbeitungsprozess f\00FChrt DML aus, wenn der Anforderungswert einem der aufgef\00FChrten Werte entspricht. Wenn eine Schaltfl\00E4che zur Weiterleitung dieser Seite ')
||unistr('verwendet wird, wird der Anforderungswert von der Schaltfl\00E4che festgelegt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Einf\00FCgen')
,p_return_value=>'I'
,p_help_text=>unistr('Ausgel\00F6st von Anforderungswerten: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4414)
,p_display_sequence=>20
,p_display_value=>'Aktualisieren'
,p_return_value=>'U'
,p_help_text=>unistr('Ausgel\00F6st von Anforderungswerten: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4414)
,p_display_sequence=>30
,p_display_value=>unistr('L\00F6schen')
,p_return_value=>'D'
,p_help_text=>unistr('Ausgel\00F6st von Anforderungswerten: DELETE, REMOVE, DELETE ROW, DROP')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4414)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>'Zeile sperren'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('<p>W\00E4hlen Sie, ob jede Zeile, die aktualisiert oder gel\00F6scht werden soll, in der zugrundliegenden Tabelle gesperrt wird, bevor die Zeile verarbeitet wird.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>'Fokus festlegen'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Setzt den Fokus auf die betroffenen Elemente. Standardm\00E4\00DFig gilt dies f\00FCr das erste betroffene Element, wenn mehrere Elemente vorhanden sind. Dies kann besonders in Verbindung mit den Aktionen <em>Anzeigen</em> und <em>Aktivieren</em> n\00FCtzlich sein, ')
||unistr('damit der Benutzer direkt zu dem entsprechenden Element gef\00FChrt wird.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>'Seite senden'
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Leitet die Seite weiter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4414)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Anforderungs-/Schaltfl\00E4chenname')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Anforderungswert ein, der zur Weiterleitung der Seite verwendet wird. Er muss auf den Schaltfl\00E4chennamen festgelegt werden, wenn eine Schaltfl\00E4che die dynamische Aktion ausl\00F6st. Dadurch wird sichergestellt, dass das Attribut <em>Validie')
||unistr('rungen ausf\00FChren</em> der Schaltfl\00E4che bei der Verarbeitung der Seite ber\00FCcksichtigt wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4414)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Verarbeitung anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob die aktuelle Seite ausgegraut und beim Weiterleiten der Seite eine Formatvorlagenanimation f\00FCr den Verarbeitungsmodus angezeigt werden soll. Bei langwierigen Vorg\00E4ngen k\00F6nnen dadurch Benutzeraktionen verhindert werden, beispielsweise')
||unistr(' das wiederholte Klicken auf die Suchschaltfl\00E4che im Falle einer langsamen Berichtsaktualisierung.')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>'Zahlenfeld '
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Zeigt ein Zahlenfeld an. Dieser Elementtyp validiert automatisch, ob der Wert eine Zahl ist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4414)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mindestwert'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie den zul\00E4ssigen Mindestwert ein. Der Wert kann ein statischer oder dynamischer Wert sein, der eine Ersetzungssyntax verwendet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4414)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Maximalwert'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie den zul\00E4ssigen H\00F6chstwert ein. Der Wert kann ein statischer oder dynamischer Wert sein, der eine Ersetzungssyntax verwendet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4414)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Zahlenausrichtung'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie die angezeigte Zahl ausgerichtet werden soll. Diese Einstellung gilt nicht, wenn das Element als <em>Schreibgesch\00FCtzt</em> wiedergegeben wird und wenn <strong>HTML-Form-Elementattribute</strong> angegeben werden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4414)
,p_display_sequence=>10
,p_display_value=>'Links'
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4414)
,p_display_sequence=>20
,p_display_value=>'Zentriert'
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4414)
,p_display_sequence=>30
,p_display_value=>'Rechts'
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>'Schieberegler'
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt einen Elementtyp in Form eines Schiebereglers an, mit dem Benutzer den Elementwert aktualisieren k\00F6nnen, indem das Steuerelement nach links oder rechts verschoben wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4414)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mindestwert'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie den zul\00E4ssigen Mindestwert ein. Der Wert kann ein statischer oder dynamischer Wert sein, der eine Ersetzungssyntax verwendet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4414)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Maximalwert'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie den zul\00E4ssigen H\00F6chstwert ein. Der Wert kann ein statischer oder dynamischer Wert sein, der eine Ersetzungssyntax verwendet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4414)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Schrittinkrement'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>'Geben Sie einen Wert ein, damit der Schieberegler bei einem bestimmten Inkrement einrastet. Der Wert kann ein statischer Wert oder ein dynamischer Wert mit Ersetzungssyntax sein.'
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4414)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Gew\00E4hlte markieren')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Geben Sie an, ob der Schieberegler die Spur bis zur aktuellen Position des Schiebereglers markiert.'
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>'E-Mail senden'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Prozess, mit dem eine E-Mail und optional mindestens ein Anhang von der Anwendung gesendet werden.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Von'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie die E-Mail-Adresse ein, die als Absender der E-Mail angezeigt werden soll. Diese E-Mail-Adresse muss eine g\00FCltige Adresse sein. Sonst wird die Nachricht nicht gesendet. Verwenden Sie eine Ersetzungssyntax, wenn Sie einen dynamischen Wert ve')
||unistr('rwenden m\00F6chten. ')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'An'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie die E-Mail-Empf\00E4nger ein, indem Sie mindestens eine E-Mail-Adresse angeben. Bei mehreren E-Mail-Adressen verwenden Sie eine durch Komma getrennte Liste. Verwenden Sie eine Ersetzungssyntax, wenn Sie einen dynamischen Wert verwenden m\00F6chten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie die Cc E-Mail-Empf\00E4nger ein, indem Sie mindestens eine E-Mail-Adresse angeben. Bei mehreren E-Mail-Adressen verwenden Sie eine durch Komma getrennte Liste. Verwenden Sie eine Ersetzungssyntax, wenn Sie einen dynamischen Wert verwenden m\00F6cht')
||'en.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Bcc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Geben Sie die Bcc E-Mail-Empf\00E4nger ein, indem Sie mindestens eine E-Mail-Adresse angeben. Bei mehreren E-Mail-Adressen verwenden Sie eine durch Komma getrennte Liste. Verwenden Sie eine Ersetzungssyntax, wenn Sie einen dynamischen Wert verwenden m\00F6ch')
||'ten.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Antwort an'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>'Geben Sie die E-Mail-Adresse ein, an die Antworten gesendet werden sollen. Wenn keine Angabe gemacht wird, wird die in <strong>Von</strong> eingegebene E-Mail-Adresse verwendet. Verwenden Sie eine Ersetzungssyntax, wenn Sie einen dynamischen Wert ver'
||unistr('wenden m\00F6chten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Betreff'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4414)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('Geben Sie den Betreff der E-Mail an. Verwenden Sie eine Ersetzungssyntax (Beispiel: <code>&amp;P6_PRODUCT_NAME.</code>), wenn Sie einen dynamischen Wert einbeziehen m\00F6chten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>'Nur-Text des Hauptteils'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Text der E-Mail ein. Die Plain Text-Version wird verwendet, falls der E-Mail-Client des Empf\00E4ngers die Rich Text-Anzeige nicht unterst\00FCtzt. Verwenden Sie eine Ersetzungssyntax, wie <code>&amp;P6_PRODUCT_NAME.</code>, wenn Sie im Text')
||' dynamische Inhalte einsetzen wollen.</p>',
unistr('<p><em>Hinweis: Gem\00E4\00DF der SMTP/MIME-Spezifikation darf eine einzelne Zeile nie mehr als 1000 Zeichen beinhalten. Um dieser Einschr\00E4nkung gerecht zu werden, m\00FCssen Sie Zeilenschaltungen oder Zeilenvorsch\00FCbe einsetzen und den Text so in Bereiche von 10')
||unistr('00 Zeichen oder weniger unterteilen. Sonst werden Ihre E-Mail-Nachrichten fehlerhaft sein, d.h. m\00F6glicherweise unvollst\00E4ndig oder mit zus\00E4tzlichen Ausrufezeichen versehen.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>'Hauptteil-HTML'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4414)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Text f\00FCr eine mehrteilige HTML-Nachricht ein, die sowohl einfachen Text als auch HTML-Inhalt aufweist. Die Einstellungen und F\00E4higkeiten des E-Mail-Clients des Empf\00E4ngers bestimmen die Anzeige. Obwohl fast alle modernen E-Mail-Clients HT')
||unistr('ML-formatierte E-Mails lesen k\00F6nnen, kommt es vor, dass einige Benutzer diese Funktionalit\00E4t aus Sicherheitsgr\00FCnden deaktivieren. Verwenden Sie eine Ersetzungssyntax, wie <code>&amp;P6_PRODUCT_NAME.</code>, wenn dynamischer Inhalt in dem Text einbezo')
||'gen werden soll.</p>',
unistr('<p>Wenn Sie mit dem Tag &lt;img /&gt; auf Bilder verweisen, m\00FCssen Sie bedenken, dass der E-Mail-Client des Empf\00E4ngers auf diese Bilder zugreifen k\00F6nnen muss, um sie anzuzeigen. Beispiel: Angenommen, Sie verweisen auf ein Bild namens "hello.gif" auf ')
||'Ihrem Netzwerk wie folgt:</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>In diesem Beispiel wird das Bild nicht an die E-Mail angeh\00E4ngt, sondern von der E-Mail referenziert. Damit der Empf\00E4nger das Bild sehen kann, muss es \00FCber einen Webbrowser zug\00E4nglich sein. Wenn das Bild sich innerhalb einer Firewall und der Benutz')
||unistr('er sich au\00DFerhalb dieser Firewall befindet, dann wird das Bild nicht angezeigt. Sie sollten daher die Verwendung von Bildern vermeiden. Wenn Sie Bilder verwenden m\00FCssen, sollten Sie das Attribut ALT hinzuf\00FCgen und so eine textbasierte Beschreibung ve')
||unistr('rf\00FCgbar machen, falls das Bild nicht angezeigt werden kann.</p>'),
unistr('<p><em>Hinweis: Gem\00E4\00DF der SMTP/MIME-Spezifikation darf eine einzelne Zeile nie mehr als 1000 Zeichen beinhalten. Um dieser Einschr\00E4nkung gerecht zu werden, m\00FCssen Sie Zeilenschaltungen oder Zeilenvorsch\00FCbe einsetzen und den Text so in Bereiche von 10')
||unistr('00 Zeichen oder weniger unterteilen. Sonst werden Ihre E-Mail-Nachrichten fehlerhaft sein, d.h. m\00F6glicherweise unvollst\00E4ndig oder mit zus\00E4tzlichen Ausrufezeichen versehen.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Anhangs-SQL'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Die SQL-Anweisung muss das folgende Format aufweisen:</p>',
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>Die Spalten "mime_type" und "content_id" sind optional. Wenn "content_id" vorhanden ist, wird die Datei inline angeh\00E4ngt. Dann wird der content_id-Wert als CID des Anhangs verwendet.</p>'),
unistr('<p>Wenn die Spalte "content_id" den Wert "my_inline_content" enth\00E4lt, kann dieses Bild mit der folgenden HTML in die E-Mail eingebettet werden:</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine SQL-Anweisung ein, die BLOBs zur\00FCckgibt, die als Dateien an die E-Mail angeh\00E4ngt werden.</p>'),
unistr('<p>Wenn die Spalte "content_id" einen Nullwert enth\00E4lt, sind die zugeh\00F6rigen Dateien regul\00E4re Anh\00E4nge. Dateien wie Dokumente oder ZIP-Archive werden im Allgemeinen auf diese Weise angeh\00E4ngt.</p>'),
unistr('<p>Wenn der content_id-Wert nicht Null ist, wird die zugeh\00F6rige Datei als Inlineanhang markiert. Der Wert der Spalte "content_id" wird als CID (Inhalts-ID) des Anhangs verwendet. Dieser CID-Wert kann im HTML-Code der E-Mail verwendet werden, um Bilde')
||unistr('r direkt in den E-Mail-Inhalt einzubetten. Beachten Sie, dass einige E-Mail-Clients Inlineanh\00E4nge m\00F6glicherweise nicht automatisch anzeigen. Beachten Sie au\00DFerdem, dass E-Mail-Standards verschiedene Anforderungen zum Format von Inhalts-IDs vorschreib')
||'en. Oracle Application Express setzt keine Compliance mit diesen Standards durch.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Sofort senden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob diese E-Mail sofort gesendet wird. Dadurch werden auch alle E-Mails gesendet, die aktuell in der E-Mail-Queuetabelle von &PRODUCT_NAME. enthalten sind. Standardm\00E4\00DFig speichert &PRODUCT_NAME. nicht gesendete E-Mail-Nachrichten in eine')
||unistr('r Tabelle und stellt sie in regelm\00E4\00DFigen Abst\00E4nden zu, um so die Systemperformance zu verbessern.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>'E-Mail-Template'
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie das gew\00FCnschte E-Mail-Template aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>'Platzhalterwerte'
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Namen von Templateplatzhaltern zusammen mit den zu ersetzenden Werten.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4414)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>'Sprach-Override'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wenn ein Sprachcode angegeben wird, sucht der Prozess das Template aus einer Anwendungs\00FCbersetzung f\00FCr diese Sprache. Wenn keine \00DCbersetzung vorhanden ist, verwendet der Prozess die prim\00E4re Sprache der Anwendung. Ersetzungssyntax wird unterst\00FCtzt.')
||'</p>',
unistr('<p>Sprachcodehierarchie wird unterst\00FCtzt. Wenn der Wert "fr-ca" (Franz\00F6sisch - Kanada) angegeben wird, aber nur eine \00DCbersetzung f\00FCr "fr" (Franz\00F6sisch) vorhanden ist, wird diese \00DCbersetzung verwendet.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>'Datei durchsuchen...'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt ein Textfeld mit einer Schaltfl\00E4che <em>Durchsuchen...</em> an. Mit der Schaltfl\00E4che "Durchsuchen" kann der Benutzer eine Datei aus einem lokalen Dateisystem suchen und hochladen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Speichertyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die Datenbanktabelle, in der die hochgeladene Datei gespeichert ist.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_display_sequence=>10
,p_display_value=>'In Attribut "Elementquelle" angegebene BLOB-Spalte'
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('Speichert die hochgeladene Datei in der Tabelle, die von dem Prozess <strong>Automatische Zeilenverarbeitung (DML)</strong> verwendet wird, und der Spalte, die in dem Attribut f\00FCr die Elementquelle angegeben wird. Die Spalte muss den Datentyp BLOB au')
||'fweisen. Wenn die Datei heruntergeladen wird, wird der Name des Prozesses <strong>Automatischer Zeilenabruf</strong> verwendet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_display_sequence=>20
,p_display_value=>'Tabelle APEX_APPLICATION_TEMP_FILES'
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Speichert die hochgeladenen Dateien in einem tempor\00E4ren Verzeichnis, auf das Sie mit der View APEX_APPLICATION_TEMP_FILES zugreifen k\00F6nnen. &PRODUCT_NAME. l\00F6scht die Dateien am Ende der Session oder am Ende der Uploadanforderung automatisch, je na')
||unistr('chdem, welche Option Sie f\00FCr <strong>Datei l\00F6schen bei</strong> ausw\00E4hlen.</p>'),
'<p>So greifen Sie auf eine Datei zu, wenn <strong>Mehrere Dateien zulassen</strong> auf <strong>Nein</strong> gesetzt ist:</p>',
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
'<p>So greifen Sie auf Dateien zu, wenn <strong>Mehrere Dateien zulassen</strong> auf <strong>Ja</strong> gesetzt ist:</p>',
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_display_sequence=>30
,p_display_value=>'Tabelle WWV_FLOW_FILES'
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Speichert die hochgeladene Datei in der &PRODUCT_NAME.-Tabelle <code>WWV_FLOW_FILES</code>.</p>',
'<p>Verwenden Sie zum Zugriff auf die Datei:</p>',
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>unistr('Spalte f\00FCr MIME-Typ')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Geben Sie den Namen des Seiten- oder Anwendungselements in Gro\00DFbuchstaben ein, in dem der MIME-Typ der hochgeladenen Datei gespeichert werden soll. Anhand des MIME-Typs identifiziert der Browser, welche Anwendung zur Anzeige des Inhalts des BLOBs ver')
||'wendet wird, wenn die Datei heruntergeladen wird.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>unistr('Spalte f\00FCr Dateinamen')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Geben Sie das Seiten- oder Anwendungselement ein, in dem der Dateiname der hochgeladenen Datei gespeichert wird.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>unistr('Spalte f\00FCr Zeichensatz')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Geben Sie den Namen des Seiten- oder Anwendungselements in Gro\00DFbuchstaben ein, in dem der Zeichensatz der hochgeladenen Datei gespeichert wird. Der Zeichensatz des BLOB wird beim Hochladen nicht automatisch festgelegt. Endbenutzer m\00FCssen den Zeichens')
||unistr('atz f\00FCr das Dokument festlegen, das sie hochladen.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>'BLOB Zuletzt aktualisierte Spalte'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Geben Sie den Namen des Seiten- oder Anwendungselements in Gro\00DFbuchstaben ein, in dem der aktuelle Zeitstempel gespeichert wird, wenn eine Datei hochgeladen wird. Dieser Datumswert wird f\00FCr das Browser-Caching verwendet.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>'Downloadlink anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Geben Sie an, ob der Downloadlink angezeigt wird, wenn ein nicht-leeres BLOB mit diesem Element verkn\00FCpft ist. ')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>unistr('Link-Text f\00FCr Download')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Geben Sie den Text ein, der als Bestandteil des Downloadlinks angezeigt werden soll. Wenn keine Angabe gemacht wird, wird der Text angezeigt, der in der Textnachricht f\00FCr <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code> in "Gemeinsame Komponenten" ge')
||'speichert ist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>'Content Disposition'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, wie der Browser den Inhalt beim Herunterladen behandelt.</p>'),
unistr('<p><em>Hinweis: Nicht jeder Inhalt kann inline angezeigt werden. Die Unterst\00FCtzung zur Inline-Anzeige des Inhalts h\00E4ngt davon ab, ob der jeweilige MIME-Typ vom Browser unterst\00FCtzt wird.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4414)
,p_display_sequence=>10
,p_display_value=>'Inline'
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4414)
,p_display_sequence=>20
,p_display_value=>'Anhang'
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('Datei l\00F6schen bei')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Definieren Sie, wann &PRODUCT_NAME. die tempor\00E4re Datei entfernen soll.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4414)
,p_display_sequence=>10
,p_display_value=>'Ende der Session'
,p_return_value=>'SESSION'
,p_help_text=>unistr('Datei am Ende der aktuellen &PRODUCT_NAME.-Session l\00F6schen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4414)
,p_display_sequence=>20
,p_display_value=>'Ende der Anforderung'
,p_return_value=>'REQUEST'
,p_help_text=>unistr('Datei am Ende der aktuellen HTTP-Anforderung l\00F6schen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Mehrere Dateien zulassen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob mehrere Dateien gleichzeitig hochgeladen werden k\00F6nnen.</p>'),
'',
'<p>Hinweis - Mehrere Dateinamen werden als durch Doppelpunkte getrennte Liste in dem Seitenelement angezeigt.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'Dateitypen'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt>Gibt an, dass nur Bilddateien akzeptiert werden sollen</dt>',
'<dd><pre>image/*</pre></dd>',
'<dt>Gibt an, dass nur Bild- und Videodateien akzeptiert werden sollen</dt>',
'<dd><pre>image/*,video/*</pre></dd>',
'<dt>Gibt an, dass nur PNG-Bilddateien akzeptiert werden sollen</dt>',
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('Geben Sie eine durch Komma getrennte Liste der Dateitypen an, die vom Browser verwendet werden k\00F6nnten, um zu begrenzen, welche Dateien hochgeladen werden k\00F6nnen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>'Anzeigen als'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie einen Anzeigestil f\00FCr das Dateisuchelement aus.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4414)
,p_display_sequence=>10
,p_display_value=>'Inlinedateiensuche'
,p_return_value=>'INLINE'
,p_help_text=>unistr('Das Eingabefeld f\00FCr die Dateisuche \00E4hnlich wie andere Textfelder und Elemente auf der Seite anzeigen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4414)
,p_display_sequence=>20
,p_display_value=>'Inline-Drop-Bereich'
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('Das Eingabefeld f\00FCr die Dateisuche als Inline-Drop-Bereich anzeigen, der einen Titel und eine Beschreibung umfasst.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4414)
,p_display_sequence=>30
,p_display_value=>'Block-Drop-Bereich'
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('Das Eingabefeld f\00FCr die Dateisuche als Drop-Bereich im Stil eines Assistenten anzeigen, der einen Titel und eine Beschreibung sowie eine Schaltfl\00E4che zum Ausw\00E4hlen von Dateien umfasst.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4414)
,p_display_sequence=>40
,p_display_value=>'Native Dateisuche'
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Das Element f\00FCr die Dateisuche im nativen Format des Browsers anzeigen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>'Drop-Bereichstitel'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Titel f\00FCr den Drop-Bereich an.'),
'Bleibt dieses Feld leer, wird als Standardtext <code>APEX.ITEM.FILE.DROP_FILE</code> oder <code>APEX.ITEM.FILE.DROP_FILES</code> verwendet.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>'Drop-Bereichsbeschreibung'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Beschreibungstext f\00FCr den Drop-Bereich ein.</p>'),
'<p>Bleibt dieses Feld leer, wird je nach Eigenschaft "Anzeigen als" einer der folgenden Standardtexte verwendet.</p>',
'<p><strong>Block-Drop-Bereich</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
'<p><strong>Inline-Drop-Bereich</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4414)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Maximale Dateigr\00F6\00DFe')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie die maximale Dateigr\00F6\00DFe (in KB) ein, die f\00FCr \00FCber dieses Element hochgeladene Dateien akzeptiert werden soll.')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>'Listen-Manager'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigt ein Textelement mit einem Symbol f\00FCr eine Popup-Werteliste, die Schaltfl\00E4chen <em>Hinzuf\00FCgen</em> und <em>Entfernen</em> und eine Liste der ausgew\00E4hlten Werte an.</p>'),
unistr('<p>Sie k\00F6nnen den Wert eingeben oder aus der Liste der verf\00FCgbaren Elemente w\00E4hlen. Sie k\00F6nnen dann die ausgew\00E4hlten Werte mit den Schaltfl\00E4chen verwalten. Die ausgew\00E4hlten Werte werden in einer einzelnen, durch Doppelpunkt getrennten Zeichenfolge ge')
||'speichert.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4414)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Abrufen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie Daten angezeigt werden, wenn die POPUP-Werteliste ge\00F6ffnet wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4414)
,p_display_sequence=>10
,p_display_value=>'Nicht abfragen'
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4414)
,p_display_sequence=>20
,p_display_value=>'Erste Zeilenmenge abrufen'
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4414)
,p_display_sequence=>30
,p_display_value=>'Erste Zeilenmenge abrufen und aktuellen Wert filtern'
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4414)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Gro\00DF-/Kleinschreibung beibehalten')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob der Wert wie eingegeben \00FCbernommen oder in Gro\00DFbuchstaben konvertiert wird.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4414)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4414)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Auf SQL-Abfrage basierende Werteliste</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Werteliste mit demselben Anzeige- und R\00FCckgabewert</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Wenn dieselbe Spalte f\00FCr die Anzeige und R\00FCckgabewerte ausgew\00E4hlt wird, verwenden Sie einen Spaltenalias.</p>'),
'</dd>',
'<dt>Werteliste mit Bind-Variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4414)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('Automatische Zeilenverarbeitung - Vorg\00E4ngerversion')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Prozess, mit dem Datens\00E4tze in einer einzelnen Datenbanktabelle oder aktualisierbaren View eingef\00FCgt, aktualisiert oder gel\00F6scht werden k\00F6nnen. Dieser Prozess wird zur Verarbeitung von Form-Elementen mit einer Quelle vom Typ <strong>Datenbankspalte</')
||'strong> verwendet. Oracle empfiehlt, dass Sie diesen Prozesstyp in <strong>Automatische Zeilenverarbeitung (DML)</strong> aktualisieren.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4414)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Typ'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, welche Vorg\00E4nge der Datenmanipulationssprache (DML) unterst\00FCtzt werden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Einf\00FCgen')
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4414)
,p_display_sequence=>20
,p_display_value=>'Aktualisieren'
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4414)
,p_display_sequence=>30
,p_display_value=>unistr('L\00F6schen')
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4414)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Tabelleneigent\00FCmer')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie den Namen des Tabelleneigent\00FCmers (Schemas).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4414)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Tabellenname'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4414)
,p_help_text=>unistr('Geben Sie den Tabellen- oder View-Namen unter Beachtung der Gro\00DF-/Kleinschreibung ein. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4414)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('Prim\00E4rschl\00FCsselelement')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie das Seiten- oder Anwendungselement ein, das den Wert der Prim\00E4rschl\00FCsselspalte enth\00E4lt. Sie k\00F6nnen den Namen eingeben oder aus der Liste ausw\00E4hlen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4414)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4414)
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die den Prim\00E4rschl\00FCsselwert enth\00E4lt. Wenn die Tabelle einen mehrteiligen Prim\00E4rschl\00FCssel enth\00E4lt, w\00E4hlen Sie <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4414)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Laufzeit-WHERE-Klausel'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Begrenzen Sie die Abteilung:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Geben Sie die SQL-WHERE-Klausel ein, die an alle generierten SELECT-, UPDATE- und DELETE-Anweisungen angeh\00E4ngt werden muss. Verwenden Sie dieses Attribut, um die Datens\00E4tze zu begrenzen, die innerhalb automatisch generierter SQL-Aufrufe verwendet wer')
||'den.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>'Abbruchereignis'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Bricht das aktuelle Ereignis ab.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>'Datumsauswahl (jQuery)'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigt ein Textfeld mit einem Kalendersymbol an. Endbenutzer k\00F6nnen das Datum entweder direkt in das Textelement eingeben oder auf ein Kalendersymbol klicken, um ein Datum und optional eine Zeit aus dem Kalender-Popup-Feld zu w\00E4hlen.</p>'),
unistr('<p>Die Zeit wird nur in dem Kalender-Popup-Feld angezeigt, wenn die <em>Formatmaske</em> f\00FCr dieses Element Zeitkomponenten umfasst.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Hervorgehobenes Datum'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie einen Standarddatumswert ein, der markiert werden soll, wenn das Kalender-Popup aufgerufen wird. Wenn keine Angabe gemacht wird, markiert der Kalender das aktuelle Datum und die aktuelle Zeit.</p>',
'<p>Der Wert kann ein absoluter Wert im Format <code>''YYYY-MM-DDTHH24:MI:SS''</code> oder <code>''YYYYMMDDHH24MI''</code>, ein relativer Wert bezogen auf das heutige Datum, wie <code>+7d</code>, oder ein dynamischer Wert mit Ersetzungssyntax sein, voraus'
||unistr('gesetzt die Ersetzung gibt das korrekte Datumsformat oder den korrekten relativen Wert zur\00FCck.</p>'),
'<p>Relative Datumswerte umfassen:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - Jahre ab dem heutigen Datum</dd>',
'  <dt>m</dt>',
'    <dd>+ / - Monate ab dem heutigen Datum</dd>',
'  <dt>w</dt>',
'    <dd>+ / - Wochen ab dem heutigen Datum</dd>',
'  <dt>d</dt>',
'    <dd>+ / - Tage ab dem heutigen Datum</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Fr\00FChestes Datum')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das Mindestdatum ein, das eingegeben oder ausgew\00E4hlt werden kann.</p>'),
'<p>Der Datumswert kann ein absoluter Wert im Format <code>''YYYY-MM-DDTHH24:MI:SS''</code> oder <code>''YYYYMMDDHH24MI''</code>, ein relativer Wert bezogen auf das heutige Datum, wie <code>+7d</code>, oder ein dynamischer Wert mit Ersetzungssyntax sein, '
||unistr('vorausgesetzt die Ersetzung gibt das korrekte Datumsformat oder den korrekten relativen Wert zur\00FCck.</p>'),
'<p>Relative Datumswerte umfassen:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - Jahre ab dem heutigen Datum</dd>',
'  <dt>m</dt>',
'    <dd>+ / - Monate ab dem heutigen Datum</dd>',
'  <dt>w</dt>',
'    <dd>+ / - Wochen ab dem heutigen Datum</dd>',
'  <dt>d</dt>',
'    <dd>+ / - Tage ab dem heutigen Datum</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Sp\00E4testes Datum')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie das H\00F6chstdatum ein, das eingegeben oder ausgew\00E4hlt werden kann.</p>'),
'<p>Der Datumswert kann ein absoluter Wert im Format <code>''YYYY-MM-DDTHH24:MI:SS''</code> oder <code>''YYYYMMDDHH24MI''</code>, ein relativer Wert bezogen auf das heutige Datum, wie <code>+7d</code>, oder ein dynamischer Wert mit Ersetzungssyntax sein, '
||unistr('vorausgesetzt die Ersetzung gibt das korrekte Datumsformat oder den korrekten relativen Wert zur\00FCck.</p>'),
'<p>Relative Datumswerte umfassen:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - Jahre ab dem heutigen Datum</dd>',
'  <dt>m</dt>',
'    <dd>+ / - Monate ab dem heutigen Datum</dd>',
'  <dt>w</dt>',
'    <dd>+ / - Wochen ab dem heutigen Datum</dd>',
'  <dt>d</dt>',
'    <dd>+ / - Tage ab dem heutigen Datum</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Anzeigen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wann der Popup-Kalender zur Datumsauswahl angezeigt wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4414)
,p_display_sequence=>10
,p_display_value=>'Bei Fokus'
,p_return_value=>'focus'
,p_help_text=>'Das Kalender-Popup wird angezeigt, sobald das Element fokussiert wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4414)
,p_display_sequence=>20
,p_display_value=>'Bei Klick auf Symbol'
,p_return_value=>'button'
,p_help_text=>'Das Kalender-Popup wird angezeigt, wenn auf das Symbol geklickt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4414)
,p_display_sequence=>30
,p_display_value=>'Beides'
,p_return_value=>'both'
,p_help_text=>'Das Kalender-Popup wird angezeigt, sobald das Element fokussiert wird und danach, wenn auf das Symbol geklickt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4414)
,p_display_sequence=>40
,p_display_value=>'Inline'
,p_return_value=>'inline'
,p_help_text=>'Der Kalender wird immer inline auf der Seite angezeigt. Es wird kein Textfeld angezeigt, und die aktuelle Datumsauswahl wird in dem Kalender markiert.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Andere Monate anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob die f\00FChrenden Datumsangaben aus dem vorherigen Monat und die abschlie\00DFenden Datumsangaben f\00FCr den n\00E4chsten Monat angezeigt werden. Die f\00FChrenden und abschlie\00DFenden Datumsangaben f\00FCllen die erste und letzte Zeile des Kalenders voll au')
||unistr('f. Beispiel: Wenn der erste Tag der Woche Sonntag ist und der Erste des aktuell angezeigten Monats auf einen Mittwoch f\00E4llt, stellen Sonntag, Montag und Dienstag die letzten drei Tages des vorherigen Monats dar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Anzahl Monate'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
'    <dd>Zeigt drei Monate horizontal an.</dd>',
'  <dt>[2,3]</dt>',
'    <dd>Zeigt sechs Monate in zwei Zeilen mal drei Spalten an.</dd>',
'  <dt>[4,3]</dt>',
unistr('    <dd>Zeigt zw\00F6lf Monate in vier Zeilen mal drei Spalten an.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie ein, wie viele Monate in dem Kalender-Popup angezeigt werden sollen.</p>',
unistr('<p>Sie k\00F6nnen einen ganzzahligen Wert oder ein zweidimensionales Array mit <code>[<em>Zeile,Spalte</em>]</code> eingeben, um die Anzahl von anzuzeigenden Zeilen und Spalten zu definieren.</p>'),
'<p><em>Hinweis: Monate nach dem <strong>Markierten Datum</strong> werden angezeigt.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Navigationsliste f\00FCr')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, ob Auswahllisten innerhalb des Kalender-Popups f\00FCr Monat und/oder Jahr bereitgestellt werden. </p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4414)
,p_display_sequence=>5
,p_display_value=>'Keine'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4414)
,p_display_sequence=>10
,p_display_value=>'Monat'
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4414)
,p_display_sequence=>20
,p_display_value=>'Jahr'
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4414)
,p_display_sequence=>30
,p_display_value=>'Monat und Jahr'
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4414)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Jahresbereich'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
unistr('    <dd>Verwendet absolute Jahre, um die zul\00E4ssigen Jahre auf den Zeitraum zwischen 2000 und 2010 einschlie\00DFlich zu begrenzen.</dd>'),
'  <dt>-05:+05</dt>',
unistr('    <dd>Verwendet relative Datumsangaben, um die zul\00E4ssigen Jahre auf einen Zeitraum von +/- f\00FCnf Jahren ab dem aktuellen Jahr zu begrenzen.</dd>'),
'  <dt>+01:+03</dt>',
unistr('    <dd>Verwendet relative Datumsangaben, um die zul\00E4ssigen Jahre auf das n\00E4chste Jahr f\00FCr weitere zwei Jahre zu begrenzen.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen Bereich von zul\00E4ssigen Jahren an, die in der Auswahlliste <strong>Jahr</strong> in dem Kalender-Popup angezeigt werden.</p>'),
'<p>Der Jahreswert kann ein absoluter Wert im Format <code>''YYYY:YYYY''</code> oder ein 	relativer Wert im Format <code>''-nn:+nn''</code> sein, wobei <code>nn</code> ganzzahlige Werte darstellen.'))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>'Textfeld'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Zeigt ein Textfeld an.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4414)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('Nach Dr\00FCcken der EINGABETASTE weiterleiten')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob die Seite automatisch weitergeleitet wird, wenn in diesem Feld die <em>Eingabetaste</em> gedr\00FCckt wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4414)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Deaktiviert'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob dieses Element deaktiviert ist, sodass Endbenutzer den Wert nicht \00E4ndern k\00F6nnen.</p>'),
'<p>Ein deaktiviertes Textelement kann weiterhin mit derselben HTML-Formatierung angezeigt werden, im Gegensatz zu einem Elementtyp <em>Nur anzeigen</em>, bei dem die HTML-Formatierung entfernt wird. Deaktivierte Textelemente sind Bestandteil der Seit'
||'enquelle, sodass ihr Sessionzustand ausgewertet werden kann. Dagegen werden Nur-Anzeige-Elemente nicht im Sessionzustand gespeichert.</p>'))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4414)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Bei Seitenweiterleitung senden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Geben Sie an, ob der aktuelle Elementwert gesendet werden soll, wenn die Seite weitergeleitet wird.'
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4414)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>'Subtyp'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie den HTML5-Textsubtyp. Auf diese Weise k\00F6nnen Ger\00E4te mit Bildschirmtastaturen ein optimiertes Tastaturlayout, das f\00FCr den Subtyp spezifisch ist, zur einfacheren Dateneingabe anzeigen. die Subtypauswahl wird auch zur Wiedergabe eines entspre')
||unistr('chenden Links mit dem Wert des Seitenelements verwendet, wenn es als schreibgesch\00FCtztes Element wiedergegeben wird. Dieses Attribut \00E4ndert das Textelement oder den Dateneintrag nicht, wenn eine physische Tastatur verwendet wird.  '),
'</p>',
unistr('<p><strong><em>Hinweis:</strong> Dieses HTML5-Feature kann nur in modernen Browsern verwendet werden. \00C4ltere, Nicht-HTML5-konforme Browser ignorieren dieses Attribut und geben das Seitenelement als normales Textfeld wieder.</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4414)
,p_display_sequence=>5
,p_display_value=>'Text'
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4414)
,p_display_sequence=>10
,p_display_value=>'E-Mail'
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4414)
,p_display_sequence=>20
,p_display_value=>'Telefonnummer'
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4414)
,p_display_sequence=>25
,p_display_value=>'Suche'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4414)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4414)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>'Leerzeichen abschneiden'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie der Elementwert nach Weiterleitung der Seite abgeschnitten werden soll. Diese Einstellung schneidet Leerzeichen, Tabulatorzeichen und Zeilenvorsch\00FCbe aus dem eingegebenen Text ab.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4414)
,p_display_sequence=>10
,p_display_value=>unistr('F\00FChrend')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Abschlie\00DFend')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4414)
,p_display_sequence=>30
,p_display_value=>unistr('F\00FChrend und abschlie\00DFend')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4414)
,p_display_sequence=>40
,p_display_value=>'Keine'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4414)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>unistr('Gro\00DF-/Kleinschreibung f\00FCr Text')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Keine \00C4nderung')
,p_help_text=>unistr('Legen Sie fest, wie die Gro\00DF-/Kleinschreibung f\00FCr den Elementwerttext umgewandelt werden soll.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4414)
,p_display_sequence=>10
,p_display_value=>'Kleinschreibung'
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Gro\00DFschreibung')
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>'Ausgeblendet'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Elemente, die in der Seitenquelle enthalten sind, aber nicht wiedergegeben werden. Ausgeblendete Elementwerte werden im Sessionzustand gespeichert. Sie werden im Allgemeinen zur Speicherung von Werten verwendet, die von Seitenverarbeitungs- oder ande'
||unistr('ren Seitenelementen ben\00F6tigt werden, jedoch dem Endbenutzer nicht angezeigt werden sollen.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4414)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Gesch\00FCtzter Wert')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob das Element gesch\00FCtzt ist, sodass der Wert nicht bearbeitet werden kann, wenn die Seite gepostet wird.')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>'Bild anzeigen'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt ein Bild an, das in Datenbank-BLOB-Spalten gespeichert ist oder auf einer Bild-URL basiert.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Basiert auf'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, von wo das Bild abgerufen werden soll.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_display_sequence=>10
,p_display_value=>'In Seitenelementwert gespeicherter Bild-URL'
,p_return_value=>'URL'
,p_help_text=>unistr('Die Bild-URL wird aus dem Wert gelesen, der im Sessionzustand f\00FCr das angegebene Seitenelement gespeichert ist.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_display_sequence=>20
,p_display_value=>'In Elementquelle angegebene BLOB-Spalte'
,p_return_value=>'DB_COLUMN'
,p_help_text=>'Liest das Bild aus der BLOB-Spalte, die im Attribut <strong>Elementquelle</strong> angegeben wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_display_sequence=>30
,p_display_value=>unistr('Von SQL-Anweisung zur\00FCckgegebene BLOB-Spalte')
,p_return_value=>'SQL'
,p_help_text=>unistr('Zeigt das Bild basierend auf der BLOB-Spalte an, die von der angegebenen SQL-Anweisung zur\00FCckgegeben wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4414)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Alternativer Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>'Geben Sie den Text ein, der von Bildschirmsprachausgaben gelesen wird, wenn ein Endbenutzer zu diesem Element navigiert.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4414)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Spalte "Alternativer Text"'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Geben Sie den Seiten- oder Anwendungselementnamen in Gro\00DFbuchstaben ein, der den alternativen Text f\00FCr dieses Bild enth\00E4lt. Dieser Text wird von Sprachausgaben verwendet, wenn ein Endbenutzer zu diesem Element navigiert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4414)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Spalte f\00FCr Dateinamen')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Geben Sie den Namen des Seiten- oder Anwendungselements in Gro\00DFbuchstaben ein, das den Spaltenwert des Dateinamens enth\00E4lt, der mit der BLOB-Spalte verkn\00FCpft ist.')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4414)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'BLOB Zuletzt aktualisierte Spalte'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie den Namen des Seiten- oder Anwendungselements in Gro\00DFbuchstaben ein, das den Datumsspaltenwert enth\00E4lt, der angibt, wann das verkn\00FCpfte BLOB zuletzt aktualisiert wurde.</p>'),
unistr('<p>Dieser Wert wird f\00FCr das Browser-Caching und zur Feststellung verwendet, ob das Bild seit der letzten Anforderung vom Browser ge\00E4ndert wurde. Wenn das Bild nicht aktualisiert wird, wird es aus dem Browsercache abgerufen, sofern verf\00FCgbar.</p>')))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4414)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'SQL-Anweisung'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>unistr('Geben Sie die SQL-Anweisung an, um die BLOB-Spalte zur\00FCckzugeben, die das Bild enth\00E4lt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4414)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>unistr('Spalte f\00FCr MIME-Typ')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Geben Sie den Namen des Seiten- oder Anwendungselements in Gro\00DFbuchstaben ein, in dem der MIME-Typ der hochgeladenen Datei gespeichert werden soll. Anhand des MIME-Typs identifiziert der Browser, welche Anwendung zur Anzeige des Inhalts des BLOBs ver')
||'wendet wird, wenn die Datei heruntergeladen wird.'
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('Textfeld mit automatisch vervollst\00E4ndigen')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt ein Textfeld an, das eine Liste der m\00F6glichen Werte enth\00E4lt, basierend auf dem bereits vom Endbenutzer eingegebenen Text, inline mit dem Textelement. Diese Liste wird weiter verfeinert, w\00E4hrend der Endbenutzer weiteren Text eingibt.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4414)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Suche'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie, wie die Suche f\00FCr den eingegebenen Wert durchgef\00FChrt wird. Bei Verwendung von <em>Lazy Loading</em> kann sich diese Einstellung auf die Abfrageperformance auswirken.</p>'),
unistr('<p><em>Hinweis: Die Auswahl von <strong>Enth\00E4lt und Gro\00DF-/Kleinschreibung beachten</strong> oder <strong>Enth\00E4lt und Gro\00DF-/Kleinschreibung ignorieren</strong> verhindert die Verwendung von Spaltenindizes.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Enth\00E4lt und Gro\00DF-/Kleinschreibung beachten')
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Genaue \00DCbereinstimmung und Gro\00DF-/Kleinschreibung beachten')
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4414)
,p_display_sequence=>30
,p_display_value=>unistr('Enth\00E4lt und Gro\00DF-/Kleinschreibung ignorieren')
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4414)
,p_display_sequence=>40
,p_display_value=>unistr('Genaue \00DCbereinstimmung und Gro\00DF-/Kleinschreibung ignorieren')
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4414)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Lazy Loading'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob \00FCbereinstimmende Werte mit dem <em>Lazy Loading</em> aus der Datenbank abgerufen werden. Beim verz\00F6gerten Ladevorgang werden \00FCbereinstimmende Datens\00E4tze jedes Mal aus der Datenbank abgerufen, wenn der Benutzer ein Zeichen eingibt.')
||' Sonst werden alle Listenwerte beim Laden der Seite geladen.</p>',
unistr('<p>Oracle empfiehlt, dass Sie den <em>Verz\00F6gerten Ladevorgang</em> bei einer gro\00DFen Auswahlliste verwenden, da sich das Laden einer gro\00DFen Anzahl von Datens\00E4tzen auf die Zeit auswirken kann, die anf\00E4nglich zum Laden der Seite erforderlich ist.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4414)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Maximale Anzahl Werte in Liste'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie die maximale Anzahl von Elementen an, die in dem Auswahlfeld angezeigt werden sollen.</p> ',
unistr('<p>Mit diesem Wert k\00F6nnen Performanceprobleme durch R\00FCckgabe von zu vielen Zeilen verhindert werden. Au\00DFerdem kann eine sehr umfangreiche R\00FCckgabemenge vermieden werden, wenn nur einige wenige Buchstaben eingegeben wurden.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4414)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Minimumsuche'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>'Zeichen'
,p_is_translatable=>false
,p_help_text=>unistr('<p>Geben Sie die Mindestanzahl von Zeichen ein, die eingegeben werden m\00FCssen, bevor eine Suche ausgef\00FChrt wird.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4414)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>'Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Geben Sie an, ob die Suchergebnisse beim Abrufen \00FCbereinstimmender Datens\00E4tze mit Lazy Loading gecacht werden sollen.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4414)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Anzeige und Speicherung desselben Wertes in Seitenelement</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
'<dt>Anzeige von Mitarbeitern einer bestimmten Abteilung mit einer Bind-Variable</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4414)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4414)
,p_name=>'ojupdate'
,p_display_name=>'Aktualisieren'
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>'Rich Text-Editor'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt einen Textbereich mit umfassenden Textformatierungsoptionen an. Endbenutzer k\00F6nnen den angezeigten Inhalt \00E4hnlich wie bei einem Textverarbeitungsprogramm, wie Microsoft Word gestalten. Endbenutzer k\00F6nnen auch Dokumente im Rich Text-Format (RTF)')
||unistr(' in diesem Element <em>ausschneiden und einf\00FCgen</em>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Responsiv [Veraltet]'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob der Rich-Text-Editor sich automatisch an die Gr\00F6\00DFe der Containerregion anpassen soll. Dazu muss die Anwendung Universal Theme oder ein anderes responsives Theme verwenden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Symbolleiste'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die Anzahl von Textformatierungsoptionen, die in dem Editor verf\00FCgbar sind.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4414)
,p_display_sequence=>10
,p_display_value=>'Einfach'
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4414)
,p_display_sequence=>20
,p_display_value=>'Intermediate-Level'
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4414)
,p_display_sequence=>30
,p_display_value=>unistr('Vollst\00E4ndig')
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Erweiterte Symbolleiste'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('Geben Sie an, ob der Editor anf\00E4nglich in dem Textbereich eingeblendet ist.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Skin'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die Editorskin zur Formatierung des Editors.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4414)
,p_display_sequence=>1
,p_display_value=>'Mono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4414)
,p_display_sequence=>2
,p_display_value=>'Einfarbig'
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4414)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Symbolleistenposition'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>'Geben Sie an, an welcher Stelle im Textbereich der Editor angezeigt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4414)
,p_display_sequence=>10
,p_display_value=>'Oben'
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4414)
,p_display_sequence=>20
,p_display_value=>'Unten'
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>'Version'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'CK Editor 5'
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4 ist veraltet und wird demn\00E4chst von CKEditor 5 abgel\00F6st. Es empfiehlt sich, diese Umstellung jetzt vorzunehmen, um Anwendungsfehler in zuk\00FCnftigen Versionen zu vermeiden. Wenn Sie benutzerdefinierten JavaScript-Initialisierungscode verw')
||unistr('enden, beachten Sie, dass sich die API von CKEditor ge\00E4ndert hat und der Code wahrscheinlich angepasst werden muss.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4414)
,p_display_sequence=>10
,p_display_value=>'CK Editor 4 [Veraltet]'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Mindesth\00F6he')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>'Pixel'
,p_is_translatable=>false
,p_help_text=>unistr('Legen Sie die Mindesth\00F6he des bearbeitbaren Bereichs in Pixel fest.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Maximale H\00F6he')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>'Pixel'
,p_is_translatable=>false
,p_help_text=>unistr('Legen Sie die maximale H\00F6he des bearbeitbaren Bereichs in Pixel fest. Bleibt dieses Attribut leer, kann der Editor bei der Texteingabe unbegrenzt vergr\00F6\00DFert werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>'Formatieren'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie das Ausgabeformat f\00FCr den Inhalt an, der im Rich-Text-Editor eingegeben wurde.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4414)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('Verwenden Sie HTML f\00FCr Quelle und Ausgabe dieses Rich-Text-Editors.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4414)
,p_display_sequence=>20
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>unistr('Verwenden Sie das Markdown-Format f\00FCr Quelle und Ausgabe dieses Rich-Text-Editors.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4414)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4414)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
'    // Feature "Automatisch formatieren" deaktivieren',
'    options.editorOptions.removePlugins.push(''Autoformat'');',
'    // Benutzerdefinierte Symbolleiste anwenden',
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('Geben Sie eine JavaScript-Funktion zum \00DCberschreiben der Standardeditorkonfiguration ein. Die CKEditor5-spezifischen Optionen m\00FCssen auf <code>options.editorOptions</code> angewendet werden. Weitere Informationen finden Sie in der API-Dokumentation z')
||'u CKEditor5.'
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>'Farbauswahl'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Erm\00F6glicht die Auswahl oder Eingabe einer Farbe. Farben k\00F6nnen aus einem Farbspektrum ausgew\00E4hlt werden.')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Modus'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die in der Farbauswahl angezeigte Informationsmenge.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4414)
,p_display_sequence=>10
,p_display_value=>'Einfach'
,p_return_value=>'SIMPLE'
,p_help_text=>'Zeigt nur die Farbspektrum-Steuerelemente und Farbvoreinstellungen an, sofern definiert.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Vollst\00E4ndig')
,p_return_value=>'FULL'
,p_help_text=>unistr('Zeigt zus\00E4tzliche Felder zum Anzeigen oder zur Eingabe von Farben als Hexadezimal-, HSL- oder RGB-Werte mit optionalem Alphawert an (je nach Auswahl unter "Wert zur\00FCckgeben als"). Zeigt au\00DFerdem die anf\00E4nglichen und aktuellen Farben an.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Anzeigen als'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie aus, wie die Farbauswahl angezeigt wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4414)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>unistr('Eine Farbe kann in das Textfeld eingegeben oder aus der Popup-Farbauswahl ausgew\00E4hlt werden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4414)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Eine Farbauswahl wird inline angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4414)
,p_display_sequence=>30
,p_display_value=>'Popup "Nur Farbe"'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\00DCber eine Schaltfl\00E4che wird die Popup-Farbauswahl ge\00F6ffnet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4414)
,p_display_sequence=>40
,p_display_value=>'Native Farbauswahl'
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Eine native Browserfarbeingabe. Die Benutzeroberfl\00E4che ist vom Browser abh\00E4ngig.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Standardwerte verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Gibt an, ob die f\00FCr diese Komponente unter "Gemeinsame Komponenten > Komponenteneinstellungen" definierten Standardwerte oder benutzerdefinierte Einstellungen verwendet werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Modus'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W\00E4hlen Sie die in der Farbauswahl angezeigte Informationsmenge aus.</p>'),
unistr('<p>Hinweis: Dies gilt nicht, wenn f\00FCr "Anzeigen als" die Option "Native Farbauswahl" angegeben ist.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4414)
,p_display_sequence=>10
,p_display_value=>'Einfach'
,p_return_value=>'SIMPLE'
,p_help_text=>'Zeigt nur die Farbspektrum-Steuerelemente und Farbvoreinstellungen an, sofern definiert.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Vollst\00E4ndig')
,p_return_value=>'FULL'
,p_help_text=>unistr('Zeigt zus\00E4tzliche Felder zum Anzeigen oder zur Eingabe von Farben als Hexadezimal-, HSL- oder RGB-Werte mit optionalem Alphawert an (je nach Auswahl unter "Wert zur\00FCckgeben als"). Zeigt au\00DFerdem die anf\00E4nglichen und aktuellen Farben an.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Anzeigen als'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie aus, wie die Farbauswahl angezeigt wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4414)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>unistr('Eine Farbe kann in das Textfeld eingegeben oder aus der Popup-Farbauswahl ausgew\00E4hlt werden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4414)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Eine Farbauswahl wird inline angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4414)
,p_display_sequence=>30
,p_display_value=>'Popup "Nur Farbe"'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\00DCber eine Schaltfl\00E4che wird die Popup-Farbauswahl ge\00F6ffnet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4414)
,p_display_sequence=>40
,p_display_value=>'Native Farbauswahl'
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Eine native Browserfarbeingabe. Die Benutzeroberfl\00E4che ist vom Browser abh\00E4ngig.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Farbvoreinstellung'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, ob in der Farbauswahl eine Gruppe vordefinierter Farben angezeigt werden soll und ob diese Farben gegebenenfalls aus einem Theme stammen oder benutzerdefiniert sein sollen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4414)
,p_display_sequence=>10
,p_display_value=>'Kein Wert'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4414)
,p_display_sequence=>20
,p_display_value=>'Theme-Stilfarben'
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4414)
,p_display_sequence=>30
,p_display_value=>'Benutzerdefinierte Farben'
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Farben'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Liste der voreingestellten Farben, die im Dialogfeld f\00FCr die Farbauswahl angezeigt werden sollen.'),
'Trennen Sie mehrere Farben durch ein Semikolon.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Kontrast mit'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Erm\00F6glicht den Vergleich der Farbe dieses Elements mit der Farbe eines anderen Elements oder statischen Wertes und die Anzeige des Kontrastverh\00E4ltnisses zwischen ihnen in der Benutzeroberfl\00E4che f\00FCr die Farbauswahl.'),
unistr('Dies kann dem Benutzer die Auswahl von Farben mit ausreichendem Kontrast erleichtern, die f\00FCr alle Benutzer zug\00E4nglich sein sollen.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4414)
,p_display_sequence=>10
,p_display_value=>'Kein Wert'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4414)
,p_display_sequence=>20
,p_display_value=>'Seitenelement'
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4414)
,p_display_sequence=>30
,p_display_value=>'Statische Farbe'
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Kontrastelement'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('Element, das f\00FCr den Kontrastvergleich verwendet wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Kontrastfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('Farbe, die f\00FCr den Kontrastvergleich verwendet wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4414)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Wert zur\00FCckgeben als')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie das Format des von diesem Element zur\00FCckgegebenen Farbwertes an. Selbst wenn die Farbe in einem anderen g\00FCltigen Format eingegeben wird, wird sie in diesem Format dargestellt, zur\00FCckgegeben und an den Server gesendet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4414)
,p_display_sequence=>10
,p_display_value=>'Hex'
,p_return_value=>'HEX'
,p_help_text=>unistr('Hexadezimal-Farbwert. Alphawerte sind nicht zul\00E4ssig. Beispiel: #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4414)
,p_display_sequence=>20
,p_display_value=>'RGB'
,p_return_value=>'RGB'
,p_help_text=>unistr('Rot, Gr\00FCn, Blau in RGB-Funktionsnotation. Beispiel: rgb(34,68,238)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4414)
,p_display_sequence=>30
,p_display_value=>'RGB/RGBA'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Rot, Gr\00FCn, Blau, mit optionalem Alpha (Transparenz) in RGB-/RGBA-Funktionsnotation.'),
'Wenn die Farbe kein Alpha aufweist (Alpha gleich 1), wird ein RGB-Format verwendet.',
'Wenn die Farbe ein Alpha aufweist, wird ein RGBA-Format verwendet.',
'Beispiel: rgba(34,68,238,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4414)
,p_display_sequence=>40
,p_display_value=>'HSL'
,p_return_value=>'HSL'
,p_help_text=>unistr('Farbwert (Hue), Farbs\00E4ttigung (Saturation), Helligkeit (Lightness) in HSL-Funktionsnotation. Beispiel: hsl(230,86,53)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4414)
,p_display_sequence=>50
,p_display_value=>'HSL/HSLA'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Farbwert (Hue), Farbs\00E4ttigung (Saturation), Helligkeit (Lightness) mit optionalem Alpha (Transparenz) in HSL-/HSLA-Funktionsnotation.'),
'Wenn die Farbe kein Alpha aufweist (Alpha gleich 1), wird ein HSL-Format verwendet.',
'Wenn die Farbe ein Alpha aufweist, wird ein HSLA-Format verwendet.',
'Beispiel: hsla(230,86,53,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4414)
,p_display_sequence=>60
,p_display_value=>'Beliebiger CSS-Wert'
,p_return_value=>'CSS'
,p_help_text=>unistr('Jedes g\00FCltige CSS-Farbformat, einschlie\00DFlich Farbnamen, oder eine CSS-Variable.')
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>'Popup-Werteliste'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigt ein Textelement mit einem Popup-Wertelistensymbol an. Wenn der Endbenutzer auf das Symbol klickt, werden ein Popup-Fenster mit einem Suchfeld und eine Liste der unterst\00FCtzten Werte angezeigt.</p>'),
unistr('<p>Popup-Wertelisten eignen sich besonders gut f\00FCr gro\00DFe Listen, weil Endbenutzer Suchkriterien eingeben k\00F6nnen, um die angezeigten verf\00FCgbaren Werte zu reduzieren. Bei relativ kleinen Listen ist <em>Auswahlliste</em> oft besser geeignet.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Anzeigen als'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie aus, wie die Popup-Werteliste angezeigt wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4414)
,p_display_sequence=>10
,p_display_value=>'Modales Dialogfeld'
,p_return_value=>'DIALOG'
,p_help_text=>'Die Werteliste wird in einem modalen Dialogfeld angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4414)
,p_display_sequence=>20
,p_display_value=>'Inline-Popup-Fenster'
,p_return_value=>'POPUP'
,p_help_text=>'Die Werteliste wird in einem Inline-Popup-Fenster unter dem Feld angezeigt.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Erster Abruf'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie aus, wie Daten f\00FCr die Werteliste am Anfang abgerufen werden. Dies gilt nur beim ersten \00D6ffnen des Popup-Fensters nach dem Laden der Seite oder nach der Aktualisierung des Elements, zum Beispiel aufgrund einer \00DCberlappung. Siehe auch die I')
||'nformationen zum Attribut "Mindestanzahl Zeichen".'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4414)
,p_display_sequence=>10
,p_display_value=>'Auf Benutzeranforderung'
,p_return_value=>'NO_FETCH'
,p_help_text=>'Werteliste wird erst abgerufen, wenn der Benutzer mit oder ohne Suchbegriff eine Suche startet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4414)
,p_display_sequence=>20
,p_display_value=>'Automatisch'
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>'Werteliste anfangs auch ohne Suchbegriff abrufen.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4414)
,p_display_sequence=>30
,p_display_value=>'Automatisch mit aktuellem Wert'
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>'Werteliste anfangs mit aktuellem Wert als Suchbegriff abrufen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Mehrere Werte'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie an, ob dieses Element mehrere Werte oder nur einen Wert haben kann. Mehrere Werte werden als durch Komma getrennte Liste zur\00FCckgegeben.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Manuelle Eingabe'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie aus, ob eine manuelle Eingabe zul\00E4ssig ist oder nicht. Bei "Ja" k\00F6nnen Benutzer vorhandene Werte aus der Popup-Werteliste ausw\00E4hlen oder einen Wert manuell eingeben (Kombinationsfeld). Bei "Nein" k\00F6nnen Benutzer nur Werte aus der Popup-Wer')
||unistr('teliste ausw\00E4hlen (Auswahlliste). Wenn eine manuelle Eingabe zul\00E4ssig ist, muss der R\00FCckgabewert der entsprechenden Werteliste eingegeben werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Beim Eingeben suchen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Bei "Ja" wird die Werteliste bei der Eingabe von Zeichen in das Suchfeld gefiltert. Bei "Nein" wird die Werteliste erst gefiltert, wenn der Benutzer die Eingabetaste dr\00FCckt oder auf das Suchsymbol klickt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Mindestanzahl Zeichen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Geben Sie die Mindestanzahl Zeichen an, die der Suchbegriff enthalten muss, bevor die Werteliste abgerufen wird. So kann die Anzahl der Suchen eingeschr\00E4nkt werden, wenn die Abfrage der Werteliste kostspielig ist. Es werden nur Werte angezeigt, die m')
||'ehr Zeichen als dieses Minimum umfassen.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4414)
,p_display_sequence=>10
,p_display_value=>'Kein Mindestwert (0)'
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4414)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4414)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4414)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4414)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4414)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Titel'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Titel des Popup-Dialogfelds. Wenn das Feld leer ist, wird der Standardtitel verwendet.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Popup-Breite'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'Pixel'
,p_is_translatable=>false
,p_help_text=>'Breite des Popup-Fensters. Bleibt das Feld leer, wird ein Standardwert verwendet.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Popup-H\00F6he')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'Pixel'
,p_is_translatable=>false
,p_help_text=>unistr('H\00F6he des Popup-Fensters. Bleibt das Feld leer, wird ein Standardwert verwendet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Zus\00E4tzliche Ausgaben')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie zus\00E4tzliche Wertelistenspalten f\00FCr andere Seitenelemente und interaktive Grid-Spalten zur\00FCck. Definieren Sie eine Zuordnung zwischen Name der Wertelistenspalte und Seitenelementname oder statischer ID der interaktiven Grid-Spalte.</p>'),
unistr('<p>Hinweis: Dies gilt nur, wenn die Wertelistendefinition zus\00E4tzliche Spalten enth\00E4lt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>'Trennzeichen'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie eine JavaScript-Funktion ein, die ein Optionsobjekt f\00FCr das Popup-Wertelistenelement verwendet, das Objekt \00E4ndert und zur\00FCckgibt. Dies erm\00F6glicht eine erweiterte Anpassung des Dialogfelds des Popup-Wertelistenelements und des zugeh\00F6rigen')
||unistr(' Inhalts w\00E4hrend der Initialisierung.</p>'),
'',
unistr('<p>Die folgenden Optionen werden an das <code>popup</code>-Widget oder an das <code>dialog</code>-Widget der jQuery-UI \00FCbergeben:<br>'),
'draggable, resizable, width, height, minWidth, minHeight, maxWidth und maxHeight<br>',
unistr('Weitere Informationen finden Sie in der Dokumentation f\00FCr das Dialogfeld-Widget der JQuery-UI.</p>'),
'',
unistr('<p>Wenn die Ergebnisse in einer einfachen Liste angezeigt werden, ist die <code>defaultIconListOptions</code>-Option ein Objekt, das an das <code>tableModelView</code>-Widget \00FCbergeben wird. Weitere Informationen zu den verf\00FCgbaren Optionen finden Si')
||unistr('e in der Dokumentation f\00FCr das APEX-tableModelView-Widget.</p>'),
'',
unistr('<p>Wenn die Ergebnisse in einem Grid angezeigt werden, ist die <code>defaultGridOptions</code>-Option ein Objekt, das an das <code>grid</code>-Widget \00FCbergeben wird.'),
unistr('Weitere Informationen zu den verf\00FCgbaren Optionen finden Sie in der Dokumentation f\00FCr das APEX-Grid-Widget.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4414)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4414)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Auf SQL-Abfrage basierende Werteliste</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Werteliste mit demselben Anzeige- und R\00FCckgabewert</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Wenn dieselbe Spalte f\00FCr die Anzeige und R\00FCckgabewerte ausgew\00E4hlt wird, verwenden Sie einen Spaltenalias.</p>'),
'</dd>',
'<dt>Werteliste mit Bind-Variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4414)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('Serverseitigen Code ausf\00FChren')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('F\00FChrt Code auf dem Server aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4414)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'PL/SQL-Code'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Erh\00F6ht das Gehalt um 3 % f\00FCr Mitarbeiter, denen eine Gehaltserh\00F6hung zusteht:</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>In diesem Beispiel m\00FCssen Sie <code>P2_DEPTNO</code> in <strong>Weiterzuleitende Elemente</strong> eingeben.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen anonymen PL/SQL-Block nur zur Ausf\00FChrung an, der auf dem Server ausgef\00FChrt wird.</p>'),
unistr('<p>Sie k\00F6nnen andere Seiten- oder Anwendungselemente in Ihrer Anwendung mit Bind-Syntax referenzieren (Beispiel: <code>:P1_MY_ITEM</code>). Alle referenzierten Elemente m\00FCssen auch in <strong>Weiterzuleitende Seitenelemente</strong> aufgenommen werde')
||'n.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4414)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>'JavaScript-Code'
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Erh\00F6ht das Gehalt um 3 % f\00FCr Mitarbeiter, denen eine Gehaltserh\00F6hung zusteht:</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
unistr('  // Platzhalter f\00FCr komplizierte Logik zur Berechnung, ob dem Mitarbeiter eine Gehaltserh\00F6hung zusteht'),
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>In diesem Beispiel m\00FCssen Sie <code>P2_DEPTNO</code> in <strong>Weiterzuleitende Elemente</strong> eingeben.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie einen JavaScript-Block nur zur Ausf\00FChrung an, der auf dem Server ausgef\00FChrt wird.</p>'),
unistr('<p>Sie k\00F6nnen andere Seiten- oder Anwendungselemente in der Anwendung mit Bind-Syntax referenzieren (Beispiel: <code>apex.env.P1_MY_ITEM</code>). Alle referenzierten Elemente m\00FCssen auch in <strong>Weiterzuleitende Seitenelemente</strong> aufgenommen')
||' werden.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4414)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Weiterzuleitende Elemente'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie Seitenelemente in Gro\00DFbuchstaben ein, die an den Server weitergeleitet werden und somit innerhalb des <strong>PL/SQL-Codes</strong> verwendet werden k\00F6nnen.</p>'),
unistr('<p>Sie k\00F6nnen den Elementnamen eingeben oder aus der Liste der verf\00FCgbaren Elemente ausw\00E4hlen.'),
unistr('Wenn Sie ein Element aus der Liste ausw\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt vom Elementnamen aus der Liste.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4414)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Zur\00FCckzugebende Elemente')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
'<p>In diesem Beispiel geben Sie <code>P1_MY_ITEM</code> in dieses Attribut ein, damit ''New Value'' in diesem Element auf Ihrer Seite angezeigt wird.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Seitenelemente in Gro\00DFbuchstaben ein, die festgelegt werden, wenn der Aufruf an den Server zur\00FCckgegeben wird, basierend auf deren aktuellem Wert im Sessionzustand. Wenn der <strong>PL/SQL-Code</strong> mindestens einen Seitenelement')
||unistr('wert in Sessionzustand setzt, m\00FCssen Sie diese Elemente in diesem Attribut definieren.</p>'),
unistr('<p>Sie k\00F6nnen den Elementnamen eingeben oder aus der Liste der verf\00FCgbaren Elemente w\00E4hlen.'),
unistr('Wenn Sie den Namen aus der Liste w\00E4hlen und bereits Text eingegeben wurde, wird an das Ende des vorhandenen Textes ein Komma gesetzt, gefolgt von dem Elementnamen, der aus der Liste zur\00FCckgegeben wird.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4414)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\00C4nderungsereignis unterdr\00FCcken')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Geben Sie an, ob das \00C4nderungsereignis bei Elementen unterdr\00FCckt wird, die in <strong>Zur\00FCckzugebende Seitenelemente</strong> angegeben werden. Dies verhindert, dass nachfolgende auf <em>\00C4nderung</em> basierende dynamische Aktionen f\00FCr diese Elemente')
||unistr(' ausgel\00F6st werden.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4414)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Sprache'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>'Nur anzeigen'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Zeigt ein Textelement an, in das keine Eingabe m\00F6glich ist.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4414)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>'Bei Seitenweiterleitung senden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'Geben Sie an, ob der aktuelle Elementwert gesendet werden soll, wenn die Seite weitergeleitet wird.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4414)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Basiert auf'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie der angezeigte Wert bestimmt werden soll.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4414)
,p_display_sequence=>10
,p_display_value=>'Elementwert'
,p_return_value=>'VALUE'
,p_help_text=>'Der aktuelle Wert des Elements wird angezeigt.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4414)
,p_display_sequence=>20
,p_display_value=>'Anzeigewert der Werteliste'
,p_return_value=>'LOV'
,p_help_text=>'Der aktuelle Wert des Seitenelements wird einem anderen Anzeigewert mit einer Werteliste zugeordnet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4414)
,p_display_sequence=>30
,p_display_value=>'Ausgabe des PL/SQL-Codes'
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>'Der angegebene PL/SQL-Code gibt die angezeigte Ausgabe aus.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4414)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'PL/SQL-Code'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geben Sie den PL/SQL-Code mit <code>sys.htp.p</code> oder <code>sys.htp.prn</code> ein, um HTML-Code auszugeben.</p>',
'<p>Oracle empfiehlt, dass Sie <code>sys.htf.escape_sc</code> verwenden, um Daten zu maskieren, die aus der Datenbank abgerufen werden, um sicherzustellen, dass HTML-Tags maskiert werden.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4414)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Zeilenumbr\00FCche anzeigen')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie an, ob Zeilenumbr\00FCche in der Ausgabe beibehalten werden.</p>'),
unistr('<p>Weil die Ausgabe als HTML wiedergegeben wird, werden bei Angabe von <strong>Ja</strong> Zeilenumbr\00FCche in dem Anzeigewert in HTML-Zeilenumbr\00FCche konvertiert, sodass sie korrekt angezeigt werden.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4414)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>'Formatieren'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4414)
,p_display_sequence=>10
,p_display_value=>'Nur Text'
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4414)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4414)
,p_display_sequence=>30
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4414)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4414)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Beispiel 1: Werteliste basierend auf SQL-Abfrage.</strong>',
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'',
'<p>',
unistr('<strong>Beispiel 2: Beispiele f\00FCr statische Listen</strong>'),
'<ul>',
'<li>STATIC:Yes;Y,No;N (Ja/Nein anstelle von J/N anzeigen)</li>',
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>Beispiel 3: Werteliste mit zus\00E4tzlichen Beschr\00E4nkungen mit Bind-Variablen</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>'Sternebewertung'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Modernes Sternebewertungselement</strong></p>',
unistr('<p>Dieses Element zeigt einen numerischen Wert als eine bestimmte Anzahl von Sternen oder anderen Symbolen an. Der Endbenutzer kann den Wert \00E4ndern, indem er die gew\00FCnschte Anzahl von Sternen ausw\00E4hlt. Der Wert kann durch Anklicken der gew\00FCnschten An')
||'zahl von Sternen mit der Maus oder mithilfe der Tastatur angepasst werden.</p>',
unistr('<p>Das anzuzeigende Symbol, die Hintergrund- und Vordergrundfarben k\00F6nnen in den Komponenteneinstellungen oder in den individuellen Elementeinstellungen angepasst werden. Um individuelle Elemente und Farben zu verwenden, setzen Sie das Attribut <stro')
||'ng>Komponentenstandardwerte verwenden</strong> auf <strong>Nein</strong>.</p>',
unistr('<p>Als Symbole k\00F6nnen Sie ein beliebiges Symbol aus den verf\00FCgbaren Symbolzeichen in Ihrer Anwendung ausw\00E4hlen. F\00FCr Universal-Theme-Anwendungen k\00F6nnen Sie ein Symbol aus der <em>Font APEX</em>-Library verwenden.</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Standardsymbol'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('W\00E4hlen Sie das zu verwendende Standardsymbol aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Farbe f\00FCr aktiv')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Standardfarbe f\00FCr aktive Sterne aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Farbe f\00FCr inaktiv')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('W\00E4hlen Sie die Standardfarbe f\00FCr inaktive Sterne aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'QuickInfo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>'Bewertung: #VALUE# Sterne.'
,p_help_text=>unistr('Geben Sie das Template f\00FCr die QuickInfo an. Der Platzhalter "#VALUE#" wird durch den aktuellen Bewertungswert ersetzt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Anzahl der Sterne'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Gesamtanzahl der anzuzeigenden Sterne.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4414)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Standardwerte verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Gibt an, ob die f\00FCr diese Komponente unter "Gemeinsame Komponenten > Komponenteneinstellungen" definierten Standardwerte oder benutzerdefinierte Einstellungen verwendet werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Symbol'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>'Geben Sie das zu verwendende Symbol an.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Farbe f\00FCr aktiv')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('W\00E4hlen Sie die Standardfarbe f\00FCr aktive Sterne aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Farbe f\00FCr inaktiv')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('W\00E4hlen Sie die Standardfarbe f\00FCr inaktive Sterne aus.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'QuickInfo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'Bewertung: #VALUE# Sterne.'
,p_help_text=>unistr('Geben Sie das Template f\00FCr die QuickInfo an. Der Platzhalter "#VALUE#" wird durch den aktuellen Bewertungswert ersetzt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Schaltfl\00E4che "L\00F6schen" anzeigen')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('W\00E4hlen Sie aus, ob die Schaltfl\00E4che "L\00F6schen" angezeigt werden soll oder nicht.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Wert anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('W\00E4hlen Sie aus, ob ein Wert neben den Sternen angezeigt werden soll.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4414)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Schreibgesch\00FCtzte Anzeige')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie aus, was angezeigt werden soll, wenn das Element schreibgesch\00FCtzt ist.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4414)
,p_display_sequence=>20
,p_display_value=>'Sterne'
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4414)
,p_display_sequence=>30
,p_display_value=>'Wert'
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4414)
,p_display_sequence=>40
,p_display_value=>'Sterne und Wert'
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4414)
,p_display_sequence=>50
,p_display_value=>'Einzelner Stern und Wert'
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>unistr('Kontrollk\00E4stchengruppe')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Zeigt mehrere Werte als Kontrollk\00E4stchen an, sodass der Endbenutzer mehrere Werte ausw\00E4hlen kann. Eine Werteliste ist f\00FCr Elemente erforderlich, die als Kontrollk\00E4stchen angezeigt werden. Die Werte, die den Kontrollk\00E4stchen entsprechen, werden in ein')
||'er einzelnen durch Doppelpunkt getrennten Liste gespeichert.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4414)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Anzahl Spalten'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie die Anzahl von Layoutspalten an, die zur Anzeige der Kontrollk\00E4stchen verwendet werden. Beispiel: Ein Wert von 2 w\00FCrde zwei Spalten mit Kontrollk\00E4stchen anzeigen. Standardm\00E4\00DFig werden alle Werte in einer Spalte angezeigt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4414)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Anzeigeausrichtung'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, wie Kontrollk\00E4stchen wiedergegeben werden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4414)
,p_display_sequence=>10
,p_display_value=>'Vertikal'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4414)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4414)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4414)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Auf SQL-Abfrage basierende Werteliste</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Werteliste mit demselben Anzeige- und R\00FCckgabewert</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Wenn dieselbe Spalte f\00FCr die Anzeige und R\00FCckgabewerte ausgew\00E4hlt wird, verwenden Sie einen Spaltenalias.</p>'),
'</dd>',
'<dt>Werteliste mit Bind-Variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>'Auswahlliste'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zeigt ein Element mit einem integrierten Wertelistenselektor an. Wenn der Endbenutzer auf das Element klickt, wird die Liste der unterst\00FCtzten Werte direkt inline mit dem aktuellen Element angezeigt.</p>'),
unistr('<p>"Auswahlliste" ist f\00FCr relativ kleine, diskrete Listen am besten geeignet. Endbenutzer k\00F6nnen schnell einen Wert aus der Liste ausw\00E4hlen, ohne den Fokus auf einen Popup-Dialog setzen zu m\00FCssen. Bei gro\00DFen Listen ist <em>Popup-Werteliste</em> h\00E4ufi')
||'g besser geeignet.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Seitenaktion bei Auswahl'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, welche Aktion ausgef\00FChrt wird, wenn ein Listenwert ausgew\00E4hlt wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_display_sequence=>1
,p_display_value=>'Keine'
,p_return_value=>'NONE'
,p_help_text=>unistr('Wenn der Wert ge\00E4ndert wird, erfolgt keine unmittelbare Aktion.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_display_sequence=>5
,p_display_value=>'Seite senden'
,p_return_value=>'SUBMIT'
,p_help_text=>'Die Seite wird weitergeleitet, wobei Seiten-REQUEST auf den Namen des Seitenelements festgelegt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_display_sequence=>7
,p_display_value=>'Wert umleiten und festlegen'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('Der Browser wird zu der aktuellen Seite umgeleitet und der Sessionzustand f\00FCr das aktuelle Element wird auf den ausgew\00E4hlten Wert festgelegt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_display_sequence=>9
,p_display_value=>'Zu Seite umleiten'
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('Der Browser wird zu der Seite umgeleitet, die in dem ausgew\00E4hlten Wert enthalten ist. Die R\00FCckgabewerte in der Liste m\00FCssen g\00FCltige Seitennummern oder Seitenaliasnamen enthalten.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_display_sequence=>10
,p_display_value=>'Zu URL umleiten'
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('Der Browser wird zu der URL umgeleitet, die in dem ausgew\00E4hlten Wert enthalten ist. Die R\00FCckgabewerte in der Liste m\00FCssen g\00FCltige URLs enthalten.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4414)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mehrfachauswahl zulassen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('Geben Sie an, ob mehrere Werte oder nur ein einzelner Wert aus der Werteliste ausgew\00E4hlt werden kann. Mehrere Werte werden als durch Komma getrennte Liste zur\00FCckgegeben. ')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4414)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Validierungen ausf\00FChren')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Geben Sie an, ob basierend auf der Seitenaktionseinstellung <strong>Seite senden</strong> Validierungen durchgef\00FChrt werden, wenn die Seite gesendet wird.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4414)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4414)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Auf SQL-Abfrage basierende Werteliste</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Werteliste mit demselben Anzeige- und R\00FCckgabewert</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Wenn dieselbe Spalte f\00FCr die Anzeige und R\00FCckgabewerte ausgew\00E4hlt wird, verwenden Sie einen Spaltenalias.</p>'),
'</dd>',
'<dt>Werteliste mit Bind-Variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>'Spaltenumschaltbericht'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt einen Bericht an, in dem Endbenutzer die Spalten ausw\00E4hlen k\00F6nnen, die zur Laufzeit angezeigt werden sollen. Endbenutzer k\00F6nnen dann die Spalten basierend auf der Breite und Ausrichtung des Bildschirms \00E4ndern, den sie zur Anzeige des Berichts v')
||'erwenden.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Typ'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die Basis f\00FCr diese Berichtsspalte.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_display_sequence=>10
,p_display_value=>'Nur Text'
,p_return_value=>'PLAIN'
,p_help_text=>'Zeigt den Spaltenwert an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_display_sequence=>20
,p_display_value=>'Link'
,p_return_value=>'LINK'
,p_help_text=>'Zeigt die Spalte als Link an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_display_sequence=>30
,p_display_value=>'Prozentdiagramm'
,p_return_value=>'PCT_GRAPH'
,p_help_text=>'Zeigt die Spalte als Prozentdiagramm an. Der abgerufene Wert muss zwischen 0 und 100 liegen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Ziel'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Geben Sie eine Zielseite ein, die aufgerufen werden soll, wenn der Benutzer auf einen vorhandenen Eintrag klickt.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Link-Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Geben Sie den HTML-Text ein, der als Link angezeigt werden soll. Verwenden Sie ein Image Tag, um Bilder anzuzeigen, oder treffen Sie in der Liste der Standardbilder eine Auswahl.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Linkattribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Geben Sie zus\00E4tzliche Spaltenlinkattribute an, die in dem <code>&lt;a href=...&gt;</code>-Tag aufgenommen werden sollen, einschlie\00DFlich Linkziel, Klassen oder Formatvorlagen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Hintergrundfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Hintergrund dieses Diagramms an.'),
'Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben.</p>',
unistr('<p>Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter ''HTML-Farbcodes'' den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Vordergrundfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Vordergrund dieses Diagramms an.'),
'Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben.</p>',
unistr('<p>Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter ''HTML-Farbcodes'' den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Balkenbreite'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'Pixel'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Geben Sie die Breite f\00FCr dieses Balkendiagramm in Pixel an.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Als Zeilenheader verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Diese Option wird zur Barrierefreiheit verwendet, um die Spalte zu identifizieren, die den Zeileninhalt am besten repr\00E4sentiert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>unistr('Priorit\00E4t')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bei diesem Bericht werden Spalten basierend auf zwei Eingaben aus- und eingeblendet: Verf\00FCgbare Bildschirmbreite oder der Benutzer w\00E4hlt die anzuzeigenden Spalten in einem Men\00FC zur Spaltenauswahl. W\00E4hlen Sie einen Priorit\00E4tswert f\00FCr jede Spalte, d')
||unistr('ie responsiv angezeigt werden soll. Jede Spalte, der eine Priorit\00E4t zugewiesen wird, ist in dem Men\00FC zur Spaltenauswahl verf\00FCgbar.<p>'),
'',
unistr('<p>Um eine Spalte persistent zu machen, sodass sie niemals ausgeblendet wird, w\00E4hlen Sie <strong>Immer angezeigt</strong>. Dadurch wird die Spalte auch aus dem Men\00FC zur Spaltenauswahl entfernt.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_display_sequence=>5
,p_display_value=>unistr('St\00E4ndige Anzeige')
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_display_sequence=>10
,p_display_value=>'1 - Letzte ausblenden'
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4414)
,p_display_sequence=>60
,p_display_value=>'6 - Erste ausblenden'
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Layout-Optionen'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Pr\00FCfen Sie zus\00E4tzliche Berichtslayoutoptionen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4414)
,p_display_sequence=>10
,p_display_value=>'Stripes'
,p_return_value=>'STRIPE'
,p_help_text=>unistr('Abwechselnde Zeilenstripes in jeder Zeile hinzuf\00FCgen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4414)
,p_display_sequence=>20
,p_display_value=>'Strich'
,p_return_value=>'STROKE'
,p_help_text=>unistr('Horizontale Linien zwischen jeder Zeile hinzuf\00FCgen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'CSS-Klassen'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie durch Leerzeichen begrenzte zus\00E4tzliche CSS-Klassen ein, die in der Komponente aufgenommen werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Benutzerdefinierte Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Geben Sie zus\00E4tzliche Attribute an, die in das Tabellen-HTML-Tag aufgenommen werden sollen. Das HTML-Klassenattribut wird generiert und sollte somit nicht angegeben werden. Verwenden Sie stattdessen das dedizierte Attribut <em>CSS-Klassen</em>.</p')
||'>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Schaltfl\00E4chentext Spalte')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('Dies ist das Label f\00FCr die Schaltfl\00E4che, die das Popup-Feld f\00FCr die Spaltenauswahl \00F6ffnet. Wenn Sie keinen Text angeben, wird ein Standardlabel verwendet.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4414)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt alle Mitarbeiter nach Name sortiert an</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Zeigt alle Mitarbeiter der aktuellen Abteilung nach Name sortiert an</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
'<p>Bei der Verwendung von Bind-Variablen zur Referenzierung von Seitenelementen, geben Sie diese als <strong>Weiterzuleitende Seitenelemente</strong> an.</p>',
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>'Shuttle'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Wird als Liste zur Mehrfachauswahl angezeigt, die zwei Felder mit Listen enth\00E4lt. Die linke Liste zeigt die Quellwerteliste an, deren Werte noch nicht ausgew\00E4hlt wurden, und die rechte Liste enth\00E4lt die aktuell ausgew\00E4hlten Werte. Endbenutzer k\00F6nn')
||unistr('en mindestens einen Wert in einer Liste ausw\00E4hlen und die ausgew\00E4hlten Werte oder alle Werte dann mit den Shuttle-Steuerelementen verschieben.</p>'),
'<p>Die aktuellen Werte werden in einer einzelnen durch Doppelpunkt begrenzten Zeichenfolge gespeichert.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4414)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Steuerelemente anzeigen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, welche Steuerelemente zur Datenverschiebung in der Mitte des Shuttles angezeigt werden.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4414)
,p_display_sequence=>10
,p_display_value=>'Alle'
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4414)
,p_display_sequence=>20
,p_display_value=>'Nur verschieben'
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4414)
,p_display_sequence=>30
,p_display_value=>'Nur bestellen'
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4414)
,p_display_sequence=>40
,p_display_value=>'Keine'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4414)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4414)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Auf SQL-Abfrage basierende Werteliste</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Werteliste mit demselben Anzeige- und R\00FCckgabewert</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Wenn dieselbe Spalte f\00FCr die Anzeige und R\00FCckgabewerte ausgew\00E4hlt wird, verwenden Sie einen Spaltenalias.</p>'),
'</dd>',
'<dt>Werteliste mit Bind-Variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4414)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4414)
,p_name=>'shuttlechangeorder'
,p_display_name=>unistr('Reihenfolge \00E4ndern')
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>'Optionsgruppe'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt mehrere Werte als Optionsgruppe an, aus der der Endbenutzer einen einzelnen Wert ausw\00E4hlen kann.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4414)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Anzahl Spalten'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie die Anzahl von anzuzeigenden Optionsgruppenspalten ein. Beispiel: Ein Wert von <code>2</code> w\00FCrde 2 Spalten anzeigen, wenn also f\00FCnf Werte vorhanden w\00E4ren, w\00FCrden diese \00FCber drei Zeilen angezeigt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4414)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Seitenaktion bei Auswahl'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie, welche Aktion ausgef\00FChrt wird, wenn ein Optionsgruppenwert ausgew\00E4hlt wird.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4414)
,p_display_sequence=>10
,p_display_value=>'Keine'
,p_return_value=>'NONE'
,p_help_text=>unistr('Wenn der Wert ge\00E4ndert wird, erfolgt keine unmittelbare Aktion.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4414)
,p_display_sequence=>20
,p_display_value=>'Seite senden'
,p_return_value=>'SUBMIT'
,p_help_text=>'Die Seite wird weitergeleitet, wobei Seiten-REQUEST auf den Namen des Seitenelements festgelegt wird.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4414)
,p_display_sequence=>30
,p_display_value=>'Wert umleiten und festlegen'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('Der Browser wird zu der aktuellen Seite umgeleitet und der Sessionzustand f\00FCr das aktuelle Element wird auf den ausgew\00E4hlten Wert festgelegt.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4414)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Validierungen ausf\00FChren')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Geben Sie an, ob aufgrund der Seitenaktionseinstellung <strong>Seite senden</strong> Validierungen durchgef\00FChrt werden, wenn die Seite gesendet wird.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4414)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>'Anzeigeausrichtung'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die Ausrichtung zur Anzeige von Optionsgruppenwerten.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4414)
,p_display_sequence=>10
,p_display_value=>'Vertikal'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4414)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4414)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Optionsfelder ausblenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4414)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4414)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Auf SQL-Abfrage basierende Werteliste</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Werteliste mit demselben Anzeige- und R\00FCckgabewert</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Wenn dieselbe Spalte f\00FCr die Anzeige und R\00FCckgabewerte ausgew\00E4hlt wird, verwenden Sie einen Spaltenalias.</p>'),
'</dd>',
'<dt>Werteliste mit Bind-Variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Hinweis: Legen Sie das Attribut <em>\00DCberlappende \00FCbergeordnete Wertelistenelemente"</em> auf <code>P3_DEPTNO</code> fest, wenn <code>P3_DEPTNO</code> ein ver\00E4nderbares Seitenelement auf derselben Seite ist.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>'Reflow-Bericht'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt einen responsiven Bericht an, der eine Umwandlung von Spalten in Zeilen vornimmt, um Berichte in kleineren Browsergr\00F6\00DFen (Bildschirmgr\00F6\00DFen) anzuzeigen.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Typ'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('W\00E4hlen Sie die Basis f\00FCr diese Berichtsspalte.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_display_sequence=>10
,p_display_value=>'Nur Text'
,p_return_value=>'PLAIN'
,p_help_text=>'Zeigt den Spaltenwert an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_display_sequence=>20
,p_display_value=>'Link'
,p_return_value=>'LINK'
,p_help_text=>'Zeigt die Spalte als Link an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_display_sequence=>30
,p_display_value=>'Prozentdiagramm'
,p_return_value=>'PCT_GRAPH'
,p_help_text=>'Zeigt die Spalte als Prozentdiagramm an. Der abgerufene Wert muss zwischen 0 und 100 liegen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Ziel'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Geben Sie eine Zielseite ein, die aufgerufen werden soll, wenn der Benutzer auf einen vorhandenen Eintrag klickt.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Link-Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Geben Sie den HTML-Text ein, der als Link angezeigt werden soll. Verwenden Sie ein Image Tag, um Bilder anzuzeigen, oder treffen Sie in der Liste der Standardbilder eine Auswahl.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Linkattribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Geben Sie zus\00E4tzliche Spaltenlinkattribute an, die in dem <code>&lt;a href=...&gt;</code>-Tag aufgenommen werden sollen, einschlie\00DFlich Linkziel, Klassen oder Formatvorlagen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Hintergrundfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Hintergrund dieses Diagramms an.'),
'Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben.</p>',
unistr('<p>Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter ''HTML-Farbcodes'' den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Vordergrundfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Beispiele f\00FCr die HTML-Hauptfarbcodes umfassen -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Schwarz&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rot&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Gelb&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Gr\00FCn&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aquamarin&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blau&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Marineblau&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Wei\00DF&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Vordergrund dieses Diagramms an.'),
'Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben.</p>',
unistr('<p>Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter ''HTML-Farbcodes'' den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Balkenbreite'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'Pixel'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Geben Sie die Breite f\00FCr dieses Balkendiagramm in Pixel an.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Als Zeilenheader verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Diese Option wird zur Barrierefreiheit verwendet, um die Spalte zu identifizieren, die den Zeileninhalt am besten repr\00E4sentiert.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Layout-Optionen'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Pr\00FCfen Sie zus\00E4tzliche Berichtslayoutoptionen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4414)
,p_display_sequence=>10
,p_display_value=>'Stripes'
,p_return_value=>'STRIPE'
,p_help_text=>unistr('Abwechselnde Zeilenstripes in jeder Zeile hinzuf\00FCgen.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4414)
,p_display_sequence=>20
,p_display_value=>'Strich'
,p_return_value=>'STROKE'
,p_help_text=>unistr('Horizontale Linien zwischen jeder Zeile hinzuf\00FCgen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'CSS-Klassen'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie durch Leerzeichen begrenzte zus\00E4tzliche CSS-Klassen ein, die in der Komponente aufgenommen werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Benutzerdefinierte Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Geben Sie zus\00E4tzliche Attribute an, die in das Tabellen-HTML-Tag aufgenommen werden sollen. Das HTML-Klassenattribut wird generiert und sollte somit nicht angegeben werden. Verwenden Sie stattdessen das dedizierte Attribut <em>CSS-Klassen</em>.</p')
||'>'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4414)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4414)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Zeigt alle Mitarbeiter nach Name sortiert an</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Zeigt alle Mitarbeiter der aktuellen Abteilung nach Name sortiert an</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
'<p>Bei der Verwendung von Bind-Variablen zur Referenzierung von Seitenelementen, geben Sie diese als <strong>Weiterzuleitende Seitenelemente</strong> an.</p>',
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>'Prozentdiagramm'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt den Wert als Prozentdiagramm an. Der abgerufene Wert muss zwischen 0 und 100 liegen.'
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4414)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Wert anzeigen'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Geben Sie an, ob der Prozentwert sichtbar ist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4414)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Hintergrundfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Hintergrund dieses Diagramms an.'),
'Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben.</p>',
unistr('<p>Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter ''HTML-Farbcodes'' den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4414)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Vordergrundfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Vordergrund dieses Diagramms an.'),
'Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben.</p>',
unistr('<p>Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Im Internet finden Sie unter ''HTML-Farbcodes'' den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die Farbe, die Sie verwenden m\00F6chten.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4414)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Textfarbe'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Farbe f\00FCr den Text dieses Diagramms an.'),
'Die Farbe wird mit der Hexadezimalschreibweise (Hex), mit RGB-Farbcodes oder mit HTML-Farbnamen angegeben.</p>',
unistr('<p>Die Hex-Schreibweise wird als #xxyyzz (ein # gefolgt von einem sechsstelligen Hexadezimalcode) definiert, wobei xx, yy und zz die beiden Hexadezimalzeichenwerte f\00FCr rot, gr\00FCn bzw. blau darstellen.'),
unistr('RGB-Codes werden als RGB(xxx,xxx,xxx) definiert, wobei xxx eine Zahl zwischen 0 und 255 ist, die jeweils den einzelnen 8-Bit-Bytewert f\00FCr rot, gr\00FCn bzw. blau darstellt.</p>'),
unistr('<p>Suchen Sie im Internet nach "HTML-Farbcodes", um den entsprechenden Hexadezimalcode oder RGB-Code f\00FCr die gew\00FCnschte Farbe zu ermitteln.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4414)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Balkenbreite'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>'Pixel'
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie die Breite f\00FCr dieses Balkendiagramm in Pixel an.')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>'Markdown-Editor'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Zeigt einen Textbereich an, der Markdown-Eingaben unterst\00FCtzt, mit Textformatierungsoptionen, Unterst\00FCtzung f\00FCr das Einf\00FCgen von Bildern und eine Vorschauoption zum Anzeigen des formatierten Textes. Mit dem Markdown-Editor k\00F6nnen Sie Klartext schreib')
||unistr('en, der leicht zu lesen und zu schreiben ist, und diesen anschlie\00DFend mithilfe der bereitgestellten Optionen und der unterst\00FCtzten Syntax in HTML mit g\00FCltiger Struktur konvertieren.')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4414)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Symbolleiste'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Bietet mehrere Optionen zum Konfigurieren der Symbolleiste f\00FCr den Markdown-Editor')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4414)
,p_display_sequence=>10
,p_display_value=>'Einfach'
,p_return_value=>'SIMPLE'
,p_help_text=>'Zeigt allgemeine Formatierungssteuerelemente in der Symbolleiste an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4414)
,p_display_sequence=>20
,p_display_value=>unistr('Vollst\00E4ndig')
,p_return_value=>'FULL'
,p_help_text=>'Zeigt alle Formatierungssteuerelemente in der Symbolleiste an.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4414)
,p_display_sequence=>40
,p_display_value=>'Kein Wert'
,p_return_value=>'NONE'
,p_help_text=>'Blendet die Symbolleiste aus.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4414)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Syntaxhervorhebung'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gibt an, ob f\00FCr bestimmte Markdown-Elemente wie fett, kursiv, Codebl\00F6cke usw. die Syntaxhervorhebung angewendet werden soll.</p>'),
'<p>Hervorgehoben wird nur Inhalt mit weniger als 4000 Zeichen.</p>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4414)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4414)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>Geben Sie eine JavaScript-Funktion ein, die ein Konfigurationsobjekt f\00FCr den Markdown-Editor verwendet, das Objekt \00E4ndert und zur\00FCckgibt. Dies erm\00F6glicht eine erweiterte Anpassung der Darstellung, der Features und des Verhaltens des Markdown-Edito')
||unistr('rs, einschlie\00DFlich Symbolleiste, Men\00FCs und Aktionen.<p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4414)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4414)
,p_name=>'markdownified'
,p_display_name=>'per Markdown bearbeitet'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>'Wechseln'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Wird als Kippschalter angezeigt.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Ein-Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Endbenutzer die Option <strong>Ein</strong> ausw\00E4hlt. Der Wert kann bis zu 255 Zeichen lang sein.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Ein-Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Text ein, der f\00FCr die Option <strong>Ein</strong> angezeigt wird. Wenn Sie keinen Text eingeben, wird das Standardlabel des Systems verwendet.'),
unistr('<p>Hinweis: Wenn die Komponenteneinstellung "Darstellungsart" auf <strong>Wechseln</strong> gesetzt ist, wird dieses Attribut nur als Anzeigewert f\00FCr interaktive Grid-Spalten verwendet. Es wird nicht f\00FCr normale Seitenelemente angezeigt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Deaktiviert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Benutzer die Option <strong>Aus</strong> ausw\00E4hlt. Der Wert kann bis zu 255 Zeichen lang sein.</p>'),
unistr('<p><em>Hinweis: Dieser Wert wird verwendet, wenn das Seitenelement mit einem Wert aufgef\00FCllt wird, der weder mit dem <strong>Ein-Wert</strong> noch mit dem <strong>Aus-Wert</strong> \00FCbereinstimmt.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Aus-Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Text ein, der f\00FCr die Option <strong>Aus</strong> angezeigt wird. Wenn Sie keinen Text eingeben, wird das Standardlabel des Systems verwendet.'),
unistr('<p>Hinweis: Wenn die Komponenteneinstellung "Darstellungsart" auf <strong>Wechseln</strong> gesetzt ist, wird dieses Attribut nur als Anzeigewert f\00FCr interaktive Grid-Spalten verwendet. Es wird nicht f\00FCr normale Seitenelemente angezeigt.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>'Darstellungsart'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4414)
,p_display_sequence=>5
,p_display_value=>'Wechseln'
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4414)
,p_display_sequence=>10
,p_display_value=>unistr('Ovale Schaltfl\00E4che')
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4414)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4414)
,p_display_sequence=>20
,p_display_value=>'Auswahlliste'
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Standardwerte verwenden'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Gibt an, ob die f\00FCr diese Komponente unter "Gemeinsame Komponenten > Komponenteneinstellungen" definierten Standardwerte oder benutzerdefinierte Einstellungen verwendet werden sollen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Ein-Wert'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Benutzer die Option <strong>Ein</strong> ausw\00E4hlt. Der Wert kann bis zu 255 Zeichen lang sein.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Ein-Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Text ein, der f\00FCr die Option <strong>Ein</strong> angezeigt wird.'),
'<p>Hinweis: Wenn die Komponenteneinstellung "Darstellungsart" auf <strong>Wechseln</strong> gesetzt ist, hat dieses Attribut keine Auswirkungen.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Deaktiviert'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Wert ein, der im Seitenelement gespeichert wird, wenn der Benutzer die Option <strong>Aus</strong> ausw\00E4hlt. Dieses Attribut kann auch leer gelassen werden, wenn Sie <code>NULL</code> speichern m\00F6chten, wenn die Option "Aus" ausgew\00E4hlt ')
||'wird. Der Wert kann bis zu 255 Zeichen lang sein.</p>',
unistr('<p><em>Hinweis: Dieser Wert wird verwendet, wenn das Seitenelement mit einem Wert aufgef\00FCllt wird, der weder mit dem <strong>Ein-Wert</strong> noch mit dem <strong>Aus-Wert</strong> \00FCbereinstimmt.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4414)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4414)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Aus-Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den Text ein, der f\00FCr die Option <strong>Aus</strong> angezeigt wird.'),
'<p>Hinweis: Wenn die Komponenteneinstellung "Darstellungsart" auf <strong>Wechseln</strong> gesetzt ist, hat dieses Attribut keine Auswirkungen.</p>'))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4414)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4414
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4414)
,p_name=>'Nachrichten'
,p_step_title=>'Nachrichten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4414)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
