prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4473
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4473 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4473
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101581252403479')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'de'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4473)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113349'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4473)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4473)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4473)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4473)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4473)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4473)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4473)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4473)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4473)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4473)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4473)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4473)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4473)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.de'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4473
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4473)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4473)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4473)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4473)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4473)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4473)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4473)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.de'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4473
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4473)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4473)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4473)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4473)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4473)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4473)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4473)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.de'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4473
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4473)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4473)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4473)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.de'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4473
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4473)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4473)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4473)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4473)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4473)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4473)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4473)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4473)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4473)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4473)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4473)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4473)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4473)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4473)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4473)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.de'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4473
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4473)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4473)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4473)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4473)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4473)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4473)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4473)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4473)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4473)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4473)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4473)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4473)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4473)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4473)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4473)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.de'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4473
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4473)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4473)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4473)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4473)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4473)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4473)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4473)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4473)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4473)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4473)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4473)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4473)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4473)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4473)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4473)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.de'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4473
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4473)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4473)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4473)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4473)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4473)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4473)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4473)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4473)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4473)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4473)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4473)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4473)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4473)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4473)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4473)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4473
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4473)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4473
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4473)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4473
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4473)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4473
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4473)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4473
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4473)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4473
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4473
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4473)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4473)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4473)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4473)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4473)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4473)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4473)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4473)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4473)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4473)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4473)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4473)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4473)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4473)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4473)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4473)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4473)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4473)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4473)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4473)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4473)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4473)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4473)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4473)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4473)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4473)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4473)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4473)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4473)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4473
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4473)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4473)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4473)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4473)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4473)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4473
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4473)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4473
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4473)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4473
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4473)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4473
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4473)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4473
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4473)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4473
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4473)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4473)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4473)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4473)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4473)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4473)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4473)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4473)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4473)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4473
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4473)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4473)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4473)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4473)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4473)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4473)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4473)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4473
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4473)
,p_page_name=>'winlov'
,p_page_title=>'Dialogfeld "Suchen"'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Suche'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('Schlie\00DFen')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Weiter &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; Zur\00FCck')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Zeilen #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4473
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4473)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4473
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4473)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4473)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4473)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4473)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4473)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4473)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4473)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4473)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4473)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4473)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4473)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4473)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4473)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4473)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4473)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4473)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4473)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4473)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4473)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4473)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4473)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4473)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4473)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4473)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4473)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4473)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4473)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4473)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4473)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4473)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4473)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4473)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4473)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4473)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4473)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4473)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4473)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4473)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4473)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4473)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4473)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4473)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4473)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4473)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4473)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4473)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4473)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4473)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4473)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4473)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4473)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4473)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4473)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4473)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4473)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4473)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4473)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4473)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4473)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4473)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4473)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4473)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4473)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4473)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4473)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4473)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4473)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4473)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4473)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4473)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4473)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4473)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4473)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4473)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4473)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4473)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4473)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4473)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4473)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4473)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4473)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4473)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4473)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4473)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4473)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4473)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4473)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4473)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4473)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4473)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4473)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4473)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4473)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4473)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4473)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4473)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4473)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4473)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4473)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4473)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4473)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4473)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4473)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4473)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4473)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4473)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4473)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4473)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4473)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4473)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4473)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4473)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4473)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4473)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4473)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4473)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4473)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4473)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4473)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4473)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4473)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4473)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4473)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4473)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4473)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4473)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4473)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4473)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4473)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4473)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4473)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4473)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4473)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4473)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4473)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4473)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4473)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4473)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4473)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4473)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4473)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4473)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4473)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4473)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4473)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4473)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4473)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4473)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4473)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4473)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4473)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4473)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4473)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4473)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4473)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4473)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4473)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4473)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4473)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4473)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4473)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4473)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4473)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4473)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4473)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4473)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4473)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4473)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4473)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4473)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4473)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4473)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4473)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4473)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4473)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4473)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4473)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4473)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4473)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4473)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4473)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4473)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4473)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4473)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4473)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4473)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093629104399123)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'de'
,p_message_text=>'Spalte %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080707546399114)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'de'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080645732399114)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137931226399155)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'de'
,p_message_text=>'Zugriff verweigert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097676462399126)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'de'
,p_message_text=>'Ihr %0-Account wurde erstellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083214703399116)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'de'
,p_message_text=>'Account ist gesperrt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073104520399109)
,p_name=>'AM_PM'
,p_message_language=>'de'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207586757399206)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'de'
,p_message_text=>'%0 umschalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215649545399211)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'de'
,p_message_text=>'(Aktiv)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185152557399190)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Ajax-Aufruf hat Serverfehler %0 f\00FCr %1 zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115958584399139)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'de'
,p_message_text=>'Der Anwendungsaliasname "%0" kann nicht in eine eindeutige Anwendungs-ID konvertiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116080836399140)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Anwendung mit dem Alias "%0" ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105621182399132)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'ERR-1816 Unerwarteter Fehler beim Konvertieren von Anwendungsaliasname p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198511373399199)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Die Anwendungspr\00FCfsumme bietet eine einfache M\00F6glichkeit, um festzustellen, ob dieselbe Anwendung in mehreren Workspaces bereitgestellt wird. Sie k\00F6nnen diese Pr\00FCfsumme vergleichen, um zu pr\00FCfen, ob eine \00DCbereinstimmung vorliegt. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091468131399122)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Authentifizierungsfunktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076842064399111)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Authentifizierungsfunktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240320156399229)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'de'
,p_message_text=>unistr('Von Oracle Cloud Identity Management zur\00FCckgegebener Mandantenname %0 ist nicht f\00FCr die Domain %1 autorisiert.<br/><a href="&LOGOUT_URL.">Melden Sie sich erneut an</a>, und geben Sie einen autorisierten Mandantennamen an, oder \00E4ndern Sie die URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074562664399110)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'de'
,p_message_text=>unistr('Ihr Account "%0" verf\00FCgt nicht \00FCber die erforderlichen Entwicklungsberechtigungen (DB_DEVELOPER oder DB_ADMINISTRATOR)<br/>f\00FCr Workspace "%1". <a href="&LOGOUT_URL.">Melden Sie sich erneut an</a>, nachdem die Berechtigungen erteilt wurden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073626641399109)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'de'
,p_message_text=>unistr('Von Oracle Cloud Identity Management zur\00FCckgegebener Mandantenname ist nicht f\00FCr den aktuellen Workspace autorisiert. <br/><a href="&LOGOUT_URL.">Melden Sie sich erneut an</a>, und geben Sie einen autorisierten Mandantennamen an.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074683601399110)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'de'
,p_message_text=>unistr('Aus Sicherheitsgr\00FCnden ist das Ausf\00FChren von Anwendungen dieses Workspace \00FCber die Domain in der URL nicht zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091128583399122)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'de'
,p_message_text=>unistr('Bitten Sie Ihren Datenbankadministrator, die Datei $OH/rdbms/admin/catldap.sql auszuf\00FChren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091004095399122)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'de'
,p_message_text=>unistr('SYS.DBMS_LDAP-Package ist nicht vorhanden oder ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090910902399121)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der LDAP-Benutzerfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091267468399122)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der LDAP-Authentifizierung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092020595399122)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'de'
,p_message_text=>'Fehler in der Prozedur p_flow_page argument to login_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091626794399122)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige p_session in wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139552682399156)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'de'
,p_message_text=>unistr('Fehlerhaftes Argument f\00FCr wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091728707399122)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Null Benutzername an Anmeldeprozedur \00FCbergeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080595482399114)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'de'
,p_message_text=>'Warten Sie <span id="apex_login_throttle_sec">%0</span> Sekunden, bis Sie sich erneut anmelden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081853179399115)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'de'
,p_message_text=>'Der Anmeldeversuch wurde blockiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137364587399155)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung "%0" nicht gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082189112399115)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'de'
,p_message_text=>'Sicherheitsgruppen-ID ist Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091526879399122)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Ausf\00FChren des Post-Authentifizierungsprozesses.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091335391399122)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten des Pre-Authentifizierungsprozesses.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092593840399123)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00D6ffnen Sie die URL in dem Browser, in dem die Kennwortr\00FCcksetzung angefordert wurde. Wenn Sie auf "Kennwort-URL zur\00FCcksetzen" klicken, werden Sie zur'),
unistr('Anmeldeseite umgeleitet. Initiieren Sie die Option "Kennwort zur\00FCcksetzen" erneut, und lassen Sie das'),
unistr('Browserfenster ge\00F6ffnet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237805034399228)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'de'
,p_message_text=>unistr('Kennwort-URL zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074851071399110)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'de'
,p_message_text=>'Resource Manager-Nutzungsgruppe %0 wurde nicht %1 erteilt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074927435399110)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'de'
,p_message_text=>'Verwenden Sie DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP, um die fehlende Berechtigung zu erteilen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102983574399130)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Session-Sentry-Funktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103064302399130)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Sessionverifizierungsfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103213835399130)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'de'
,p_message_text=>unistr('Bitten Sie den %0 Administrator, die Engine f\00FCr Oracle Application Server Single Sign-On zu konfigurieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112709642399137)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges %0 in %1 Token von SSO zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091940945399122)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'de'
,p_message_text=>unistr('Bearbeiten Sie das Authentifizierungsschema, und f\00FCgen Sie den Anwendungsnamen hinzu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112416002399137)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Caller von %0-Prozedur:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112677186399137)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Anwendungssession in URLC-Token: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112207348399137)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'de'
,p_message_text=>'Fehler in portal_sso_redirect: Fehlende Informationen zur Anwendungsregistrierung: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103151355399130)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'de'
,p_message_text=>unistr('WWSEC_SSO_ENABLER_PRIVATE-Package ist nicht vorhanden oder ist ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111091882496399122)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'de'
,p_message_text=>'Name der registrierten Partneranwendung im Authentifizierungsschema nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112335852399137)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'de'
,p_message_text=>'Registrieren Sie diese Anwendung entsprechend der Beschreibung im Installation Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103376421399130)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der SSO-Authentifizierung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212728319399209)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'de'
,p_message_text=>'Nicht autorisierte URL: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102751094399130)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten der Authentifizierung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074716748399110)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'de'
,p_message_text=>'Workspace "%0" ist inaktiv. Wenden Sie sich an den Administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075164921399110)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'de'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081522792399115)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Zugriff von Sicherheitspr\00FCfung der Anwendung abgelehnt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081663158399115)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Zugriff von Sicherheitspr\00FCfung der Seite abgelehnt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081714659399115)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler bei Verarbeitung der Autorisierung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145116317399161)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'de'
,p_message_text=>'Erstellt mit %0 und %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145205151399161)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'de'
,p_message_text=>'Liebe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203073463399203)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Ereignisbeschreibung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202853264399202)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'de'
,p_message_text=>'Enddatum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203189526399203)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'de'
,p_message_text=>'Ereignis-ID'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202739629399202)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202951194399202)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'de'
,p_message_text=>'Ereignistitel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093542343399123)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsummeninhaltsfehler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093413488399123)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Pr\00FCfsummenformatfehler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157401865399170)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'de'
,p_message_text=>'In Zwischenablage kopiert.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157162248399169)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'de'
,p_message_text=>unistr('Dieser Browser unterst\00FCtzt das Kopieren \00FCber eine Schaltfl\00E4che oder ein Men\00FC nicht. Verwenden Sie STRG+C oder Befehlstaste+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145683333399161)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Benachrichtigung schlie\00DFen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201668197399202)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'de'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196123974399198)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'de'
,p_message_text=>'Aktuell'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196080224399197)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'de'
,p_message_text=>unistr('Anf\00E4nglich')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200256629399201)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss eine g\00FCltige Farbe sein. Beispiel: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195908034399197)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Eine Farbe ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196281099399198)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Farbformat \00E4ndern')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235497416399226)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235590908399226)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'de'
,p_message_text=>unistr('Liste \00F6ffnen f\00FCr: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215736166399212)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'de'
,p_message_text=>'(Abgeschlossen)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108076176399134)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'de'
,p_message_text=>'Wenden Sie sich an den Anwendungsadministrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122448705399144)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Wenden Sie sich an den Anwendungsadministrator.',
'Details zu diesem Vorfall finden Sie unter Debugging-ID "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200516653399201)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'de'
,p_message_text=>'Korrigieren Sie die Fehler, bevor Sie speichern.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146511235399162)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('%0 \00DCbereinstimmungen gefunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146497133399162)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'de'
,p_message_text=>unistr('Keine \00DCbereinstimmungen gefunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216228647399212)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'de'
,p_message_text=>'Aktueller Fortschritt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200929984399201)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Die im %0-Element angegebene Datei ist in APEX_APPLICATION_TEMP_FILES nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189418502399193)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Die aktuelle Version der Daten in der Datenbank wurde ge\00E4ndert, seit der Benutzer einen Update-Prozess eingeleitet hat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158524596399171)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'de'
,p_message_text=>'Nicht laden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205558946399204)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'de'
,p_message_text=>'Vorverarbeitungsfehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205324316399204)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile einf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219450389399214)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'de'
,p_message_text=>'Sequenz: Aktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205436270399204)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'de'
,p_message_text=>'Zeile aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146972582399162)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'de'
,p_message_text=>'Popup-Kalender: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069554950399106)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069626686399106)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205746734399204)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss einen Wert haben.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205660113399204)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss ein g\00FCltiges Datum sein. Beispiel: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073239204399109)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss zwischen %0 und %1 liegen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073328841399109)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss am oder nach dem %0 liegen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073428673399109)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss am oder vor dem %0 liegen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150478961399164)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# ist sp\00E4ter als das angegebene sp\00E4teste Datum %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150802657399165)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# stimmt nicht mit Format %0 \00FCberein.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150396325399164)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# ist fr\00FCher als das angegebene fr\00FCheste Datum %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150536320399165)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# liegt nicht im g\00FCltigen Bereich zwischen %0 und %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150719784399165)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# liegt nicht innerhalb des g\00FCltigen Jahresbereichs von %0 und %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200848622399201)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228005548399220)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230009130399222)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200689580399201)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'de'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200703806399201)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'de'
,p_message_text=>'Speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106996293399133)
,p_name=>'APEX.ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074370145399110)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Der folgende Fehler ist bei der Ausf\00FChrung des Callbacks f\00FCr das Fehlerhandling aufgetreten: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083042316399116)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim erstellen der Fehlerseite: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075012741399110)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'de'
,p_message_text=>'Interner Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214854995399211)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Wenden Sie sich an den Administrator.',
'Details zu diesem Vorfall finden Sie unter Debugging-ID "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209123255399207)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'de'
,p_message_text=>unistr('Die Datenbank ist schreibgesch\00FCtzt ge\00F6ffnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239731138399229)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'de'
,p_message_text=>unistr('ORA-28353: Wallet konnte nicht ge\00F6ffnet werden. Auf Anwendungsdaten kann derzeit nicht zugegriffen werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209225204399207)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Seite ist leider nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076760920399111)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'de'
,p_message_text=>unistr('Technische Informationen (nur f\00FCr Entwickler sichtbar)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172861585399181)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'de'
,p_message_text=>'Fehlermeldung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186793954399191)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Erwartetes Format: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153476901399167)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'de'
,p_message_text=>'Benutzer ist bereits in Access-Control-Liste enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153335800399167)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Best\00E4tigen Sie, dass die folgenden %0 Benutzer der <strong>%1</strong> Access-Control-Liste hinzugef\00FCgt werden sollen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153822604399167)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'de'
,p_message_text=>'Doppelter Benutzer vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153522347399167)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'de'
,p_message_text=>'Fehlendes At-Zeichen (@) in E-Mail-Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153604139399167)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'de'
,p_message_text=>'Fehlender Punkt (.) in E-Mail-Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153731787399167)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>'Benutzername ist zu lang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154032344399167)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Nur in der Access-Control-Liste definierte Benutzer k\00F6nnen auf diese Anwendung zugreifen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154101926399167)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>'Unerwarteter Zugriffskontroll-Einstellungswert: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153970315399167)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'de'
,p_message_text=>unistr('Alle authentifizierten Benutzer k\00F6nnen auf diese Anwendung zugreifen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196717060399198)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196688950399198)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196929024399198)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'de'
,p_message_text=>'%0: Ist deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196890055399198)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'de'
,p_message_text=>'%0: Ist aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196545309399198)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'de'
,p_message_text=>'nicht identifiziert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189632105399193)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146132856399161)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'de'
,p_message_text=>'Angewendeter Filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187245087399191)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'de'
,p_message_text=>'Anwenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072177594399108)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'de'
,p_message_text=>'Balkendiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199950198399200)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'de'
,p_message_text=>'Weitere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072279077399108)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'de'
,p_message_text=>'Tortendiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198634137399199)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071947132399108)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'de'
,p_message_text=>'Anzahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187759797399192)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187825271399192)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'de'
,p_message_text=>unistr('Alle l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187981760399192)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205121615399204)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte %1, referenziert durch Facet %0, ist nicht verf\00FCgbar oder nicht autorisiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062392369399101)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Anzuzeigende Filter ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144343400399160)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'de'
,p_message_text=>'%0 Ergebnisse'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144493357399160)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ausgew\00E4hlt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147097225399162)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'de'
,p_message_text=>'Aktuelle Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063813960399102)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'de'
,p_message_text=>'Filterliste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203604052399203)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Grenzwert f\00FCr eindeutigen Wert (%0) f\00FCr Facet %1 wurde \00FCberschritten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189246012399193)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Facet %0 wird f\00FCr DATE- oder TIMESTAMP-Spalten nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187365358399191)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'de'
,p_message_text=>'%0 filtern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187428504399191)
,p_name=>'APEX.FS.GO'
,p_message_language=>'de'
,p_message_text=>'Los'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188807694399192)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'de'
,p_message_text=>'gleich %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072931978399109)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'de'
,p_message_text=>unistr('enth\00E4lt %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072694115399108)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'de'
,p_message_text=>unistr('gr\00F6\00DFer als %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072760072399109)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'de'
,p_message_text=>unistr('gr\00F6\00DFer oder gleich %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072441581399108)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'de'
,p_message_text=>'kleiner als %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072572833399108)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'de'
,p_message_text=>'kleiner oder gleich %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072846037399109)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'de'
,p_message_text=>'beginnt mit %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075353056399110)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Der %0-Datentyp (%1) wird f\00FCr das Eingabefeld-Facet nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065540282399103)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrwertige Facets erfordern Datenbanken mit 12.2 oder h\00F6her.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189028614399193)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr das Facet %0 wurden keine Suchspalten angegeben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062488863399101)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'de'
,p_message_text=>'Mehr Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144516636399160)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'de'
,p_message_text=>'Bereichsanfang'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188586612399192)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'de'
,p_message_text=>'%0 bis %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188646083399192)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCber %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188713600399192)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'de'
,p_message_text=>'Unter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144690966399160)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'de'
,p_message_text=>'Bereichsende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207477464399206)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Wertelistenelement #%2 ("%1") f\00FCr Bereichs-Facet %0 ist ung\00FCltig (Trennzeichen "|" fehlt).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188932583399192)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr das Bereichs-Facet %0 wird eine manuelle Eingabe derzeit nicht unterst\00FCtzt, weil die Spalte den Typ DATE oder TIMESTAMP hat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188216049399192)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'de'
,p_message_text=>'bis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072070176399108)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm entfernen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141181564399158)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187697102399192)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'de'
,p_message_text=>'Suchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187580650399191)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'de'
,p_message_text=>'Suchen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188497806399192)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'de'
,p_message_text=>unistr('- Ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071801328399108)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188079523399192)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'de'
,p_message_text=>'Weniger anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188181396399192)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'de'
,p_message_text=>'Mehr anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111188366924399192)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'de'
,p_message_text=>'%0 Sterne und mehr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146099155399161)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Filtervorschl\00E4ge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189178013399193)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Das Textfeld-Facet %0 wird derzeit nur f\00FCr NUMBER-Spalten unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062224573399101)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Zeilenanzahl gesamt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205203032399204)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Datentyp %0 (%1) wird f\00FCr die Facet-Suche nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197121305399198)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'de'
,p_message_text=>'Gehen Sie zum Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154754788399168)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Aggregieren.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162305053399173)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechsel ausblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154825678399168)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Kontrollgruppenwechsel.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162274637399173)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechsel einblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240988234399230)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Spalte %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162028770399173)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zeilen gel\00F6scht')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232461332399224)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Identit\00E4t duplizieren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151786683399165)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'de'
,p_message_text=>'Erste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155023356399168)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Gruppenheader.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154994462399168)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Header.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151800130399165)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'de'
,p_message_text=>'Letzte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171882337399180)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'de'
,p_message_text=>'Weitere Zeilen laden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151530332399165)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'de'
,p_message_text=>'Weiter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155134917399168)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'de'
,p_message_text=>'Seitenzeilen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151922549399166)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'de'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152021637399166)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'de'
,p_message_text=>'%0 - %1 von %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208033307399206)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'de'
,p_message_text=>'Seitenauswahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151641998399165)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232266037399224)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzugef\00FCgt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232315881399224)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Ge\00E4ndert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240703948399230)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Zeile %0, Spalte %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240804395399230)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Zeile %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232160995399223)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Gel\00F6scht')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155365631399168)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'de'
,p_message_text=>'Zeilenheader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150949845399165)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zellen ausgew\00E4hlt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152158198399166)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Zeilen ausgew\00E4hlt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192487797399195)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'de'
,p_message_text=>unistr('Alle ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162108277399173)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'de'
,p_message_text=>'Seite %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155277924399168)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155450800399168)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend sortiert %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155549889399168)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'de'
,p_message_text=>'Absteigend sortiert %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151078100399165)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend sortieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151307925399165)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend sortieren %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151147881399165)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'de'
,p_message_text=>'Absteigend sortieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151489748399165)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'de'
,p_message_text=>'Absteigend sortieren %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111151206322399165)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'de'
,p_message_text=>'Nicht sortieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161970718399173)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'de'
,p_message_text=>'Gesamt %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088312201399120)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'de'
,p_message_text=>'Die HTTP-Anforderung an "%0" war nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229698480399222)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'de'
,p_message_text=>'Grid-Auswahlliste %0 Spalten %1 Zeilen. Verwenden Sie die Pfeiltasten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161870773399173)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'de'
,p_message_text=>'Auswahlliste %0 Zeilen. Verwenden Sie die Pfeiltasten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240512734399230)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'de'
,p_message_text=>'Interaktives Grid %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148641110399163)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149606291399164)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149507945399164)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234054515399225)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'de'
,p_message_text=>'Aggregieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219520279399214)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'de'
,p_message_text=>'Aggregation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221259938399215)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'de'
,p_message_text=>'Alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177678409399184)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Alle Textspalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178854798399185)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'de'
,p_message_text=>'Alternative'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179957537399186)
,p_name=>'APEX.IG.AND'
,p_message_language=>'de'
,p_message_text=>'und'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199350649399200)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'de'
,p_message_text=>unistr('Eindeutige Reihen z\00E4hlen - Ungef\00E4hr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235017649399226)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'de'
,p_message_text=>unistr('Eindeutige z\00E4hlen - Insgesamt gesch\00E4tzt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218131727399213)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'de'
,p_message_text=>'Bereich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220063437399215)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178979541399185)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'de'
,p_message_text=>'Autorisierung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234144410399225)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'de'
,p_message_text=>'Automatisch'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199789408399200)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'de'
,p_message_text=>'Durchschnitt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234766389399225)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'de'
,p_message_text=>'Gesamtdurchschnitt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217684264399213)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'de'
,p_message_text=>'Titel der Labelachse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217852711399213)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'de'
,p_message_text=>'Dezimalstellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217788647399213)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'de'
,p_message_text=>'Wert Achsentitel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223835198399217)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'de'
,p_message_text=>'Hintergrundfarbe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218291417399213)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'de'
,p_message_text=>'Balkendiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174200406399182)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'de'
,p_message_text=>'zwischen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225078447399218)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'de'
,p_message_text=>'Beide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218382785399213)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'de'
,p_message_text=>'Blasendiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149821182399164)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179868826399186)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'de'
,p_message_text=>unistr('Gro\00DF-/Kleinschreibung beachten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235614374399226)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'de'
,p_message_text=>unistr('(Gro\00DF-/Kleinschreibung beachten)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206525561399205)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen gespeichert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150223090399164)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'de'
,p_message_text=>unistr('Ansicht \00E4ndern')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180959152399187)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177456177399184)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Abfrage \00FCberschreitet die maximal zul\00E4ssigen %0 Datenpunkte pro Diagramm. Wenden Sie einen Filter an, um die Anzahl der Datens\00E4tze in der Basisabfrage zu reduzieren.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148527150399163)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'de'
,p_message_text=>'Diagrammansicht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155805414399169)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217175304399213)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224001256399218)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'de'
,p_message_text=>'Farben'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200145314399200)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'de'
,p_message_text=>'Vorschau'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179222857399185)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148731353399163)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225806482399219)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'de'
,p_message_text=>'Spaltenzweck'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179346503399185)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'de'
,p_message_text=>'Komplex'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148965409399163)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'de'
,p_message_text=>'Berechnen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174837011399182)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'de'
,p_message_text=>unistr('enth\00E4lt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181179839399187)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'de'
,p_message_text=>'Kontrollgruppenwechsel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155632988399168)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'de'
,p_message_text=>'In Zwischenablage kopieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155712341399168)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'de'
,p_message_text=>'Nach unten kopieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199111409399200)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199230289399200)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'de'
,p_message_text=>'Anzahl - eindeutig'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234917868399225)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'de'
,p_message_text=>unistr('Eindeutige z\00E4hlen - Insgesamt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234894538399225)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'de'
,p_message_text=>'Gesamtanzahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232521406399224)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'de'
,p_message_text=>'%0 erstellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177877921399184)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'de'
,p_message_text=>'Daten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225619966399219)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>'Datentyp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225267997399218)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'de'
,p_message_text=>'Datum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206325013399205)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Datumswert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175545003399183)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'de'
,p_message_text=>'Tage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178536624399185)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Standardeinstellungen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178318473399185)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Standardtyp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149776424399164)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226817702399220)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie diesen Bericht wirklich l\00F6schen?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182949830399188)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181703639399187)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilen l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220103608399215)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'de'
,p_message_text=>'Absteigend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180656219399186)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'de'
,p_message_text=>'Detail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148248401399163)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'de'
,p_message_text=>'Detailansicht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208854320399207)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'de'
,p_message_text=>'Richtung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180370379399186)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174903012399182)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'de'
,p_message_text=>unistr('enth\00E4lt nicht')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175173118399182)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'de'
,p_message_text=>'beginnt nicht mit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218470358399213)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'de'
,p_message_text=>'Ringdiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181382119399187)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080024878399114)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'de'
,p_message_text=>'Nur Daten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227857727399220)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Format ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092657385399123)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'de'
,p_message_text=>'Downloadformat %0 ist nicht aktiviert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220869147399215)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'de'
,p_message_text=>'Aggregation duplizieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220912448399215)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechsel duplizieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182811606399188)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile duplizieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181648372399187)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'de'
,p_message_text=>'Doppelte Zeilen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149312888399164)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219994268399215)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231433573399223)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'de'
,p_message_text=>'"Gruppieren nach" bearbeiten'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227463869399220)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'de'
,p_message_text=>'Blindkopie (Bcc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227672471399220)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'de'
,p_message_text=>'Nachricht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227317119399220)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'de'
,p_message_text=>'Kopie (Cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227001330399220)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'de'
,p_message_text=>'E-Mail wurde gesendet.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227501159399220)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'de'
,p_message_text=>'Betreff'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227233108399220)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'de'
,p_message_text=>unistr('Empf\00E4nger (an)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180088681399186)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173210000399181)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'de'
,p_message_text=>'gleich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226407700399219)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'de'
,p_message_text=>'Beispiel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180130646399186)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226390813399219)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192322620399195)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'de'
,p_message_text=>'Datei vorbereitet. Download wird gestartet.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111155952357399169)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCllen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157084870399169)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Auswahl f\00FCllen mit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156990371399169)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Auswahl f\00FCllen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148892752399163)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179488179399186)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234459046399225)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'de'
,p_message_text=>'Filtern...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220366007399215)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'de'
,p_message_text=>'Erste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149021508399163)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'de'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177938363399184)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'de'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224970457399218)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'de'
,p_message_text=>'Formatmaske'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226732242399220)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'de'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226680197399219)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'de'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139448229399156)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'de'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078724123399113)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'de'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182549954399188)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'de'
,p_message_text=>'Fixieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180290581399186)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'de'
,p_message_text=>'Funktionen und Operatoren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218519744399214)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'de'
,p_message_text=>'Trichter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199084393399200)
,p_name=>'APEX.IG.GO'
,p_message_language=>'de'
,p_message_text=>'Los'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173860010399182)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'de'
,p_message_text=>unistr('gr\00F6\00DFer als')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173921300399182)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'de'
,p_message_text=>unistr('gr\00F6\00DFer oder gleich')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180570048399186)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'de'
,p_message_text=>'Grid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148003684399163)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'de'
,p_message_text=>'Grid-Ansicht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221116693399215)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'de'
,p_message_text=>'Gruppieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180755452399187)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'de'
,p_message_text=>'Gruppieren nach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148379910399163)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'de'
,p_message_text=>'Ansicht "Gruppieren nach"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225539368399219)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'de'
,p_message_text=>'Bedingungstyp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224489212399218)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschrift')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224620641399218)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschriftenausrichtung')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234392472399225)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229899796399222)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sie k\00F6nnen Daten direkt innerhalb dieses interaktiven Grids einf\00FCgen, aktualisieren und l\00F6schen.</p>'),
'',
unistr('<p>F\00FCgen Sie eine neue Zeile ein, indem Sie auf die Schaltfl\00E4che "Zeile hinzuf\00FCgen" klicken.</p>'),
'',
unistr('<p>Bearbeiten Sie vorhandene Daten, indem Sie auf eine bestimmte Zelle doppelklicken. F\00FCr umfangreichere Bearbeitungen klicken Sie auf "Bearbeiten", um den Bearbeitungsmodus aufzurufen. Im Bearbeitungsmodus k\00F6nnen Sie bestimmte Zellen mit einem Einze')
||'lklick oder der Tastatur bearbeiten.</p>',
'',
unistr('<p>Verwenden Sie das Men\00FC "\00C4ndern", um Zeilen zu duplizieren und zu l\00F6schen. Um das Men\00FC "\00C4ndern" zu aktivieren, verwenden Sie die Kontrollk\00E4stchen, um eine oder mehrere Zeilen auszuw\00E4hlen.</p>'),
'',
unistr('<p>Duplizieren Sie eine ausgew\00E4hlte Zeile, indem Sie auf das Men\00FC "\00C4ndern" klicken und "Zeilen duplizieren" ausw\00E4hlen. L\00F6schen Sie eine ausgew\00E4hlte Zeile, indem Sie auf das Men\00FC "\00C4ndern" klicken und "Zeile l\00F6schen" ausw\00E4hlen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231978605399223)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'de'
,p_message_text=>'Bearbeitungsfunktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232093479399223)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In einem interaktiven Grid wird eine Gruppe von Daten in einem Bericht dargestellt, der durchsucht und angepasst werden kann. Sie k\00F6nnen viele Vorg\00E4nge ausf\00FChren, um die zur\00FCckgegebenen Datens\00E4tze zu begrenzen und die Art der Datenanzeige zu \00E4nder')
||'n.</p>',
'',
unistr('<p>Mit dem Suchfeld k\00F6nnen Sie die zur\00FCckgegebenen Datens\00E4tze filtern. Klicken Sie auf "Aktionen", um die verschiedenen Optionen zur \00C4nderung des Berichtslayouts aufzurufen. Sie k\00F6nnen auch das Men\00FC "Spalten\00FCberschrift" f\00FCr angezeigte Spalten verwend')
||'en.</p>',
'',
unistr('<p>Verwenden Sie "Berichtseinstellungen", um die Anpassungen in einem Bericht zu speichern. Sie k\00F6nnen die Daten aus dem Bericht auch in eine externe Datei herunterladen oder die Daten per E-Mail an sich selbst oder andere senden. </p>'),
'',
'<p>Weitere Informationen finden Sie unter "Using Interactive Grids" in <em>Oracle Application Express End User''s Guide</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231704642399223)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberblick')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229796213399222)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sie k\00F6nnen das interaktive Grid anpassen, um Daten mit den integrierten Funktionen auf unterschiedliche Weise anzuzeigen.</p>'),
'',
unistr('<p>Mit den Men\00FCs "Spalten\00FCberschrift" oder dem Men\00FC "Aktionen" k\00F6nnen Sie bestimmen, welche Spalten angezeigt werden sollen und in welcher Reihenfolge sie angezeigt werden sollen. Au\00DFerdem k\00F6nnen Sie Spalten fixieren. Sie k\00F6nnen auch verschiedene Dat')
||unistr('enfilter definieren und die zur\00FCckgegebenen Daten sortieren.</p>'),
'',
unistr('<p>Mit der Schaltfl\00E4che "Anzeigen" (neben dem Suchfeld) k\00F6nnen Sie andere Datenansichten aufrufen, die vom Anwendungsentwickler definiert wurden. Sie k\00F6nnen auch ein Diagramm erstellen oder ein vorhandenes Diagramm anzeigen.</p>  '),
'',
unistr('<p><em>Hinweis: Klicken Sie auf <strong>Hilfe</strong> in den Dialogfeldern des interaktiven Grids, um detailliertere Informationen zu der ausgew\00E4hlten Funktion zu erhalten.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231823641399223)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'de'
,p_message_text=>'Berichtsfunktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181576097399187)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu interaktivem Grid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228687613399221)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie Spalten aggregieren. Aggregierte Werte werden am Ende der Daten angezeigt, oder wenn Gruppenwechsel definiert sind, am Ende jedes Umbruchs.</p>'),
'',
'<p><strong>Aggregationsliste</strong><br>',
'Die Aggregationsliste zeigt definierte Aggregationen an. Deaktivieren Sie eine vorhandene Aggregation, indem Sie deren Auswahl aufheben.<br>',
unistr('Klicken Sie auf "Hinzuf\00FCgen" (&plus;), um eine neue Aggregation zu erstellen, oder auf "L\00F6schen" (&minus;), um eine vorhandene Aggregation zu entfernen.</p>'),
'',
'<p><strong>Aggregationseinstellungen</strong><br>',
'Mit dem Formular auf der rechten Seite definieren Sie die Aggregation.<br>',
unistr('W\00E4hlen Sie den Spaltennamen und Aggregationstyp aus.<br>'),
unistr('Geben Sie optional eine QuickInfo f\00FCr die Aggregation ein.<br>'),
unistr('Wenn Sie einen Gruppenwechsel definiert haben, wird durch Auswahl von <strong>Gesamtwert anzeigen</strong> der Gesamtdurchschnitt, die Gesamtsumme oder ein \00E4hnlicher Wert am Ende der Daten angezeigt.</p>'),
'',
unistr('<p><em>Hinweis: Rufen Sie das Dialogfeld "Aggregation" im Men\00FC "Aktionen" oder durch Klicken auf die Spalten\00FCberschrift und Summe (&sum;) auf.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230800378399223)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Aggregation"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229360372399221)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie ein Diagramm definieren, das als separate Datenansicht angezeigt wird.<br>'),
unistr('W\00E4hlen Sie einen Diagrammtyp und die Diagrammattribute aus.</p>'),
'<p><strong>Diagrammattribute</strong></br>',
unistr('Die verf\00FCgbaren Diagrammattribute variieren je nach Diagrammtyp.</p>'),
'<p>',
'<ul>',
unistr('  <li>W\00E4hlen Sie die Spalte mit dem Wert f\00FCr das Attribut aus:'),
'    <ul>',
unistr('      <li>Label: Der Text f\00FCr jeden Datenpunkt.</li>'),
'      <li>Wert: Die darzustellenden Daten.</li>',
'      <li>Reihe: Zur Definition einer dynamischen Abfrage mit mehreren Reihen.</li>',
unistr('      <li>Er\00F6ffnung: Der t\00E4gliche Er\00F6ffnungskurs der Aktien (nur Aktiendiagramme).</li>'),
unistr('      <li>Schluss: Der t\00E4gliche Schlusskurs der Aktien (nur Aktiendiagramme).</li>'),
unistr('      <li>Hoch: Der h\00F6chste Wert (nur Bereichs- und Aktiendiagramme).</li>'),
'      <li>Niedrig: Der niedrigste Wert (nur Bereichs- und Aktiendiagramme).</li>',
unistr('      <li>Volumen: Das t\00E4gliche Aktienvolumen (nur Aktiendiagramme).</li>'),
'      <li>Ziel: Der Zielwert (nur Trichterdiagramme).</li>',
'      <li>X: Der X-Achsenwert (nur Blasen- und Streudiagramme).</li>',
'      <li>Y: Der Y-Achsenwert (nur Blasen- und Streudiagramme).</li>',
'      <li>Z: Die Balkenbreite oder der Blasenradius (nur Balken-, Blasen- und Bereichsdiagramme).</li>',
'    </ul>',
'  </li>',
'  <li>Ausrichtung: Vertikal oder horizontal.</li>',
'  <li>Aggregation: Legen Sie fest, wie die Diagrammwerte aggregiert werden sollen.</li>',
'  <li>Stapel: Geben Sie an, ob die Datenelemente gestapelt werden.</li>',
'  <li>Sortieren nach: Sortieren Sie das Diagramm nach Label oder Werten.',
'    <ul>',
'      <li>Richtung: Sortieren Sie Werte in aufsteigender oder absteigender Reihenfolge.</li>',
unistr('      <li>Nullwerte: Geben Sie an, wie Datens\00E4tze mit Nullwerten bezogen auf Datens\00E4tze mit Nicht-Nullwerten sortiert werden sollen.</li>'),
'    </ul>',
'  </li>',
'  <li>Dezimalstellen</li>',
'  <li>Titel der Labelachse</li>',
'  <li>Titel der Wertachse</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231219350399223)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Diagramm"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228368478399221)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie ausw\00E4hlen, welche Spalten angezeigt werden und in welcher Reihenfolge sie angezeigt werden.</p>'),
'',
'<p>Blenden Sie eine Spalte aus, indem Sie ihre Auswahl aufheben.<br>',
'Ordnen Sie Spalten neu an, indem Sie auf "Nach oben verschieben" (&uarr;) oder "Nach unten verschieben" (&darr;) klicken.<br>',
'Verwenden Sie den Dropdown-Selektor, um "Alle Spalten", "Angezeigte Spalten" oder "Nicht angezeigte Spalten" aufzulisten.</p>',
'',
'<p>Geben Sie optional im Formular die Mindestbreite einer Spalte in Pixel an.</p>',
'',
unistr('<p><em>Hinweis: Sie k\00F6nnen angezeigte Spalten auch neu anordnen, indem Sie auf den Ziehpunkt (am Anfang der Spalten\00FCberschrift) klicken und die Spalte nach links oder rechts ziehen. Sie k\00F6nnen die Breite von angezeigten Spalten auch \00E4ndern, indem Sie')
||unistr(' die Spaltentrennlinie zwischen \00DCberschriften ausw\00E4hlen und nach links oder rechts verschieben.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231161525399223)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu Spalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228727577399221)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie zus\00E4tzliche Spalten basierend auf mathematischen und funktionalen Berechnungen definieren, die f\00FCr vorhandene Spalten ausgef\00FChrt werden.</p>'),
'',
'<p><strong>Berechnungsliste</strong><br>',
'In der Berechnungsliste werden definierte Berechnungen angezeigt. Deaktivieren Sie eine vorhandene Berechnung, indem Sie deren Auswahl aufheben.<br>',
unistr('Klicken Sie auf "Hinzuf\00FCgen" (&plus;), um eine neue Berechnung hinzuzuf\00FCgen, oder auf "L\00F6schen" (&minus;), um eine vorhandene Berechnung zu entfernen.</p>'),
'',
'<p><strong>Berechnungseinstellungen</strong><br>',
'Verwenden Sie das Formular zur Definition der Berechnung.<br>',
unistr('Geben Sie die Spaltendetails ein, wie \00DCberschrift und Label, und w\00E4hlen Sie Ausrichtungseinstellungen aus.<br> '),
unistr('Geben Sie im Ausdruckstextbereich die Spalten und verkn\00FCpften Funktionen f\00FCr die Berechnung ein.<br>'),
unistr('W\00E4hlen Sie den entsprechenden Datentyp und optional eine Formatmaske f\00FCr die neue Spalte aus.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230707288399222)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Berechnen"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229035581399221)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie einen Gruppenwechsel f\00FCr eine oder mehrere Spalten definieren.</p>'),
'',
'<p><strong>Gruppenwechselliste</strong><br>',
'In der Gruppenwechselliste werden definierte Gruppenwechsel angezeigt. Deaktivieren Sie eine vorhandene Gruppenwechselspalte, indem Sie deren Auswahl aufheben.<br>',
unistr('Klicken Sie auf "Hinzuf\00FCgen" (&plus;), um eine neue Spalte in den Gruppenwechsel einzubeziehen, oder auf "L\00F6schen" (&minus;), um eine vorhandene Spalte aus dem Gruppenwechsel zu entfernen.<br>'),
unistr('Um Spalten neu anzuordnen, klicken Sie auf "Nach oben verschieben" (&uarr;) oder "Nach unten verschieben" (&darr;), um die ausgew\00E4hlte Spalte bezogen auf andere Spalten nach oben oder unten zu verschieben.</p>'),
'',
'<p><strong>Gruppenwechseleinstellungen</strong><br>',
unistr('Im Formular k\00F6nnen Sie eine Gruppenwechselspalte definieren.<br>'),
unistr('W\00E4hlen Sie eine Gruppenwechselspalte und die Sortierrichtung aus, und geben Sie an, wie Nullspalten (Spalten ohne Wert) angeordnet werden sollen.</p>'),
'',
unistr('<p><em>Hinweis: Bei Anzeige des interaktiven Grids k\00F6nnen Sie einen Gruppenwechsel definieren, indem Sie auf eine Spalten\00FCberschrift klicken und das Gruppenwechselsymbol ausw\00E4hlen.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230496405399222)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Gruppenwechsel"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229207683399221)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie alle aktuellen Zeilen in eine externe Datei herunterladen. Die Datei enth\00E4lt nur die aktuell angezeigten Spalten, wobei f\00FCr die Daten angewendete Filter und Sortiervorg\00E4nge verwendet werden.</p>'),
'',
unistr('<p>W\00E4hlen Sie das Dateiformat aus, und klicken Sie auf "Herunterladen".<br>'),
unistr('Hinweis: Das CSV-Format enth\00E4lt keine Textformatierung, wie Aggregate und Gruppenwechsel.</p>'),
'',
unistr('<p>Um die Datei per E-Mail zu versenden, w\00E4hlen Sie "Als E-Mail senden" aus und geben die E-Mail-Details ein (Empf\00E4nger, Betreff und Nachricht).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230277498399222)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Download"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228426115399221)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie Datenfilter konfigurieren, die die zur\00FCckgegebenen Zeilen begrenzen.</p>'),
'',
'<p><strong>Filterliste</strong><br>',
'In der Filterliste werden definierte Filter angezeigt. Deaktivieren Sie einen vorhandenen Filter, indem Sie die Filterauswahl aufheben.<br>',
unistr('Klicken Sie auf "Hinzuf\00FCgen" (&plus;), um einen neuen Filter zu erstellen, oder auf "L\00F6schen" (&minus;), um einen vorhandenen Filter zu entfernen.</p>'),
'',
'<p><strong>Filtereinstellungen</strong><br>',
unistr('Im Formular k\00F6nnen Sie die Filtereigenschaften definieren.<br>'),
unistr('W\00E4hlen Sie den entsprechenden Filtertyp aus:<br>'),
'&nbsp;&nbsp;&nbsp;Zeile - Filtert nach einem Begriff in einer Spalte, die gefiltert werden kann.<br>',
'&nbsp;&nbsp;&nbsp;Spalte - Filtert eine bestimmte Spalte mit einem angegebenen Operator und Wert.<br>',
'',
unistr('<p><em>Hinweis: Bei Anzeige des interaktiven Grids k\00F6nnen Sie Zeilenfilter durch direkte Eingabe in das Suchfeld definieren. Klicken Sie auf "Zu suchende Spalten ausw\00E4hlen", um die Suche auf eine bestimmte Spalte zu begrenzen. \00D6ffnen Sie alternativ e')
||unistr('in Men\00FC "Spaltentitel", und w\00E4hlen Sie einen Wert aus, um einen Spaltenfilter zu erstellen.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231004567399223)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Filtern"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228840140399221)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie die Daten so anzeigen, wie sie zu einem fr\00FCheren Zeitpunkt vorhanden waren.</p>'),
unistr('<p>Geben Sie die Anzahl von Minuten in der Vergangenheit ein, um die Flashback-Abfrage auszuf\00FChren.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230609066399222)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Flashback"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231301675399223)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Gruppieren nach"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228993292399221)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie Zeilen oder Spalten mit Daten basierend auf der eingegebenen Bedingung markieren.</p>'),
'',
'<p><strong>Markierungsliste</strong><br>',
'In der Markierungsliste werden definierte Markierungen angezeigt. Deaktivieren Sie eine vorhandene Markierung, indem Sie deren Auswahl aufheben.<br>',
unistr('Klicken Sie auf "Hinzuf\00FCgen" (&plus;), um eine neue Markierung zu erstellen, oder auf "L\00F6schen" (&minus;), um eine vorhandene Markierung zu entfernen.</p>'),
'',
'<p><strong>Markierungseinstellungen</strong><br>',
unistr('Im Formular k\00F6nnen Sie die Markierungseigenschaften definieren.<br>'),
unistr('Geben Sie den Namen ein, w\00E4hlen Sie "Zeile" oder "Spalte", und w\00E4hlen Sie die HTML-Farbcodes f\00FCr Hintergrund und Text aus.<br>'),
unistr('W\00E4hlen Sie den entsprechenden <strong>Bedingungstyp</strong> aus, um bestimmte Daten zu markieren:<br>'),
'&nbsp;&nbsp;&nbsp;Zeile - Markiert den Begriff in jeder Spalte.<br>',
'&nbsp;&nbsp;&nbsp;Spalte - Markiert etwas innerhalb einer bestimmten Spalte basierend auf dem angegebenen Operator und Wert.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230577008399222)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Markieren"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229159777399221)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie \00C4nderungen speichern, die Sie an dem aktuellen Grid-Layout und der aktuellen Konfiguration vorgenommen haben.<br>'),
unistr('Anwendungsentwickler k\00F6nnen mehrere alternative Berichtslayouts erstellen. Wenn zul\00E4ssig, k\00F6nnen Sie und andere Endbenutzer einen Bericht als \00F6ffentlichen Bericht speichern, sodass der Bericht f\00FCr alle Benutzer des Grids verf\00FCgbar ist. Sie k\00F6nnen ein')
||unistr('en Bericht auch als privaten Bericht speichern, den nur Sie anzeigen k\00F6nnen.</p>'),
unistr('<p>W\00E4hlen Sie unter den verf\00FCgbaren Typen aus, und geben Sie einen Namen f\00FCr den gespeicherten Bericht ein.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230312242399222)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hilfe zu "Bericht"',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228502565399221)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In diesem Dialogfeld k\00F6nnen Sie die Anzeigereihenfolge festlegen.</p>'),
'',
'<p><strong>Sortierliste</strong><br>',
'Im Dialogfeld "Sortieren" wird eine Liste der konfigurierten Sortierregeln angezeigt.<br>',
unistr('Klicken Sie auf "Hinzuf\00FCgen" (&plus;), um eine Sortierspalte zu erstellen, oder auf "L\00F6schen" (&minus;), um eine Sortierspalte zu entfernen.<br>'),
unistr('Klicken Sie auf "Nach oben verschieben" (&uarr;) und "Nach unten verschieben" (&darr;), um die ausgew\00E4hlte Sortierspalte bezogen auf die anderen Sortierspalten nach oben oder unten zu verschieben.</p>'),
'',
'<p><strong>Sortiereinstellungen</strong><br>',
unistr('W\00E4hlen Sie eine Sortierspalte und die Sortierrichtung aus, und geben Sie an, wie Nullspalten (Spalten ohne Wert) angeordnet werden sollen.</p>'),
'',
unistr('<p><em>Hinweis: Daten k\00F6nnen nach Spalten sortiert werden, die nicht angezeigt werden, es k\00F6nnen jedoch nicht alle Spalten sortiert werden.</em><br>'),
unistr('<em>Angezeigte Spalten k\00F6nnen sortiert werden, indem Sie auf die Pfeile nach oben (aufsteigend) oder nach unten (absteigend) am Ende der Spalten\00FCberschriften klicken. Um eine nachfolgende Spalte zu einem vorhandenen Sortiervorgang hinzuzuf\00FCgen, halte')
||unistr('n Sie die Umschalttaste gedr\00FCckt, und klicken Sie auf den Pfeil nach oben oder unten.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230948562399223)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Sortieren"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111230182204399222)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu "Abonnement"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182488320399188)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149260148399164)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'de'
,p_message_text=>'Markieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217219368399213)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Hoch'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218021486399213)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'de'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175486708399183)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'de'
,p_message_text=>'Stunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180490454399186)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'de'
,p_message_text=>'Symbol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148118889399163)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'de'
,p_message_text=>'Symbolansicht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173683196399181)
,p_name=>'APEX.IG.IN'
,p_message_language=>'de'
,p_message_text=>'in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182044925399187)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'de'
,p_message_text=>'Inaktive Einstellung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182191394399188)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Inaktive Einstellungen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189723247399193)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Bei der Verarbeitung der Anforderung "Interaktives Grid" ist ein interner Fehler aufgetreten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085534120399118)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Spaltenfiltertyp "%0" wird f\00FCr Spalte "%1" nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229929774399222)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Datumsformat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204167654399203)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Interaktives Grid unterst\00FCtzt nicht das Definieren eines Filters f\00FCr Spalte %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204039703399203)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ist kein g\00FCltiger Filtertyp zum Definieren eines Filters f\00FCr ein interaktives Grid.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090634554399121)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Zahlenformat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232632619399224)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Einstellung')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232756713399224)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Einstellungen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223719037399217)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'de'
,p_message_text=>unistr('"Sortieren nach" wurde auf %0 festgelegt, es wurde jedoch keine Spalte f\00FCr %0 ausgew\00E4hlt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221050134399215)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Wert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216174996399212)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'de'
,p_message_text=>'Nicht angezeigt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174479999399182)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'de'
,p_message_text=>'in den letzten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174651641399182)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('in den n\00E4chsten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173500231399181)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'ist nicht leer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173408105399181)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'de'
,p_message_text=>'ist leer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224500605399218)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216558812399212)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220472869399215)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'de'
,p_message_text=>'Letzte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163784394399174)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'de'
,p_message_text=>'Letzter Tag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163944673399174)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'de'
,p_message_text=>'Letzte Stunde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164468136399175)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'de'
,p_message_text=>'Letzte Minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163408296399174)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'de'
,p_message_text=>'Letzter Monat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163527710399174)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'de'
,p_message_text=>'Letzte Woche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163698850399174)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Tage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163850932399174)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Stunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164526685399175)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164343805399175)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Monate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164290344399175)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Wochen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163229409399174)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Jahre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163333494399174)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'de'
,p_message_text=>'Letztes Jahr'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224750188399218)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'de'
,p_message_text=>'Zellenausrichtung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224857673399218)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppe verwenden f\00FCr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174013277399182)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'de'
,p_message_text=>'kleiner als'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174117894399182)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'de'
,p_message_text=>'kleiner oder gleich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218631556399214)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'de'
,p_message_text=>'Zeile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218798036399214)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'de'
,p_message_text=>unistr('Linien/Fl\00E4chen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225135087399218)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'de'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217305161399213)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Niedrig'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227791401399220)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'de'
,p_message_text=>'Trennen Sie mehrere Adressen durch Komma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175242129399183)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>unistr('entspricht regul\00E4rem Ausdruck')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199675739399200)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'de'
,p_message_text=>'Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235216079399226)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'de'
,p_message_text=>unistr('Gesamth\00F6chstwert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199812483399200)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'de'
,p_message_text=>'Medianwert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235302003399226)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'de'
,p_message_text=>'Gesamtmedianwert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199500046399200)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'de'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175315713399183)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'de'
,p_message_text=>'Minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200378566399201)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'de'
,p_message_text=>unistr('Minuten zur\00FCck')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235174055399226)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'de'
,p_message_text=>'Gesamtmindestwert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175774812399183)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'de'
,p_message_text=>'Monate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182374286399188)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Die Daten enthalten mehr als %0 Zeilen; dies \00FCberschreitet den zul\00E4ssigen H\00F6chstwert. Wenden Sie zus\00E4tzliche Filter an, um die Ergebnisse anzuzeigen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209055411399207)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Die statische Regions-ID muss angegeben werden, da die Seite mehrere interaktive Grids enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178435240399185)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178647431399185)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'de'
,p_message_text=>'Benannter Bericht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162633121399174)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chster Tag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162456773399173)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste Stunde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164600791399175)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste Minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162952990399174)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chster Monat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162866600399174)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste Woche')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162772018399174)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Tage')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111162560029399173)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Stunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164796794399175)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Minuten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164059350399175)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Monate')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164183867399175)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Wochen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163199857399174)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Jahre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111163017052399174)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chstes Jahr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174374207399182)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'de'
,p_message_text=>'nicht zwischen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173312494399181)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'de'
,p_message_text=>'ungleich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239567268399229)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Region mit ID %0 ist keine interaktive Rasterregion oder ist in Anwendung %1 nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173751332399182)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'de'
,p_message_text=>'nicht in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174568484399182)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'de'
,p_message_text=>'nicht in den letzten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111174723525399182)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('nicht in den n\00E4chsten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182241912399188)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Daten gefunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220251773399215)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'de'
,p_message_text=>'Nullwerte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225380141399219)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'de'
,p_message_text=>'Numerisch'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220566701399215)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'de'
,p_message_text=>'Aus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220608331399215)
,p_name=>'APEX.IG.ON'
,p_message_language=>'de'
,p_message_text=>'Ein'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172526589399181)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'de'
,p_message_text=>'Vor 1 Minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228271699399221)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'de'
,p_message_text=>unistr('Farbauswahl \00F6ffnen: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217052232399212)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffnen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179558361399186)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'de'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216464822399212)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218864004399214)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'de'
,p_message_text=>'Tortendiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111180810292399187)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'de'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111148494828399163)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'de'
,p_message_text=>'Pivot-Ansicht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111228197229399221)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'de'
,p_message_text=>'Werte durch %0 trennen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111218982975399214)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'de'
,p_message_text=>'Polardiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224248424399218)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'de'
,p_message_text=>'Mitte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224367032399218)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'de'
,p_message_text=>'Ende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111224177095399218)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'de'
,p_message_text=>'Anfang'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178792230399185)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179001102399185)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rer Standardwert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195541041399197)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'de'
,p_message_text=>'Hauptbericht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077726889399112)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Barrierefreiheitstags einbeziehen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076427182399111)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'de'
,p_message_text=>'Querformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076530167399111)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'de'
,p_message_text=>'Hochformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076391898399111)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Seitenausrichtung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076204513399111)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'de'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076170140399111)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'de'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077853736399112)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075952837399111)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'de'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075898422399111)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'de'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076020530399111)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'de'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075767875399111)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'de'
,p_message_text=>unistr('Seitengr\00F6\00DFe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065910960399104)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'de'
,p_message_text=>'Rich Text entfernen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219041938399214)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'de'
,p_message_text=>'Netzdiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219182312399214)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'de'
,p_message_text=>'Bereich'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229480064399222)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183048569399188)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile aktualisieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181844230399187)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen aktualisieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187048606399191)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Interaktive Grid-Region ist nicht in Anwendung %0, Seite %1 und Region %2 vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149904470399164)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'de'
,p_message_text=>'%0 entfernen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178107539399185)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238761421399228)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht gel\00F6scht')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238412722399228)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'de'
,p_message_text=>unistr('Alternativer Bericht f\00FCr alle Benutzer gespeichert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238383096399228)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'de'
,p_message_text=>unistr('Standardbericht f\00FCr alle Benutzer gespeichert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238613328399228)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'de'
,p_message_text=>'Privater Bericht gespeichert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238592279399228)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlicher Bericht f\00FCr alle Benutzer gespeichert')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111187174176399191)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Gespeichertes interaktives Grid mit Name %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172440266399181)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht f\00FCr Daten erstellen - Stand vor %0 Minuten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172338185399180)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht f\00FCr Daten erstellen - Stand vor 1 Minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112001797399137)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Interaktiver Grid-Bericht ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231602340399223)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'de'
,p_message_text=>'Bericht - Bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186941955399191)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Gespeichertes interaktives Grid mit ID %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111231584444399223)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'de'
,p_message_text=>'Bericht - Speichern unter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150063026399164)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Berichtseinstellungen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239611979399229)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Gespeichertes interaktives Raster mit statischer ID %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234522615399225)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'de'
,p_message_text=>'Berichtsansicht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149121936399163)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183158696399188)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen wiederherstellen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181981049399187)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen wiederherstellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179179103399185)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178085472399185)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'de'
,p_message_text=>'Zeilen pro Seite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239295558399229)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Zeilenaktionen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240453091399230)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktionen f\00FCr Zeile %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111149497049399164)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'de'
,p_message_text=>'Speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192114521399195)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'de'
,p_message_text=>'gespeichert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147655510399162)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'de'
,p_message_text=>'Gespeicherte Berichte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147760580399162)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standardwert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122237488399144)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Es ist bereits ein gespeicherter Bericht namens %0 vorhanden. Geben Sie einen neuen Namen ein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147891817399163)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'de'
,p_message_text=>'Privat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147993064399163)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlich')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234243619399225)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'de'
,p_message_text=>'Speichern unter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181252656399187)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Berichtseinstellungen speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219250273399214)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'de'
,p_message_text=>'Streudiagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147565849399162)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226554524399219)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Suchen: Alle Textspalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147444446399162)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'de'
,p_message_text=>'Suchen: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225719659399219)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'de'
,p_message_text=>'Suche: Volltextsuche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172207585399180)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'de'
,p_message_text=>'Nach ''%0'' suchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215888357399212)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'de'
,p_message_text=>unistr('- Ausw\00E4hlen -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156000625399169)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'de'
,p_message_text=>'Auswahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208731921399207)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'de'
,p_message_text=>unistr('1 Zeile in der Masterregion ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147348059399162)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'de'
,p_message_text=>unistr('Zu suchende Spalten ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238964764399228)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Auswahlaktionen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156223738399169)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'de'
,p_message_text=>'Zellenauswahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156126024399169)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeilenauswahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227184032399220)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'de'
,p_message_text=>'Als E-Mail senden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219666960399214)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Reihe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145309532399161)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197967139399199)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'de'
,p_message_text=>'Gesamtwert anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182733728399188)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'de'
,p_message_text=>'Single Row-Ansicht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181030179399187)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'de'
,p_message_text=>'Sortieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219759877399214)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'de'
,p_message_text=>'Sortieren nach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239316586399229)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Nur eine Sortierung pro Spalte zul\00E4ssig.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239189917399229)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC \00E4ndern')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111220770602399215)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'de'
,p_message_text=>'Stack'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175012519399182)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'de'
,p_message_text=>'beginnt mit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219340040399214)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'de'
,p_message_text=>'Aktien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140395968399157)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spaltenbreiten dehnen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111181412962399187)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111199480380399200)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'de'
,p_message_text=>'Summe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240695612399230)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'de'
,p_message_text=>'Interaktives Grid. Bericht: %0, Ansicht: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111234629080399225)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'de'
,p_message_text=>'Gesamtsumme'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217593178399213)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Ziel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223934041399218)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'de'
,p_message_text=>'Textfarbe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150183677399164)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'de'
,p_message_text=>'Umschalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197802860399199)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'de'
,p_message_text=>'QuickInfo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111178223332399185)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'de'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111182684577399188)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'de'
,p_message_text=>'Fixierung aufheben'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179757409399186)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'de'
,p_message_text=>unistr('Ma\00DFeinheit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226946085399220)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Es sind nicht gespeicherte \00C4nderungen vorhanden. M\00F6chten Sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111179692999399186)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216686568399212)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Wert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221560968399216)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Ein Wert ist erforderlich.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206489241399205)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'de'
,p_message_text=>unistr('Wert (Zeitzone darf nicht ge\00E4ndert werden)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225452363399219)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'de'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217907604399213)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'de'
,p_message_text=>'Vertikal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177759699399184)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215932267399212)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'de'
,p_message_text=>'Angezeigt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111217419084399213)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Volumen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175644277399183)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'de'
,p_message_text=>'Wochen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216085735399212)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'de'
,p_message_text=>'Minimale Spaltenbreite (Pixel)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166889115399177)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'de'
,p_message_text=>'%0 zwischen %1 und %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166533354399176)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166664317399176)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt nicht %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144752219399160)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'de'
,p_message_text=>'%0 beginnt nicht mit %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165379552399175)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'de'
,p_message_text=>'%0 gleich %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165525381399176)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'de'
,p_message_text=>unistr('%0 gr\00F6\00DFer als %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165678664399176)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'de'
,p_message_text=>unistr('%0 gr\00F6\00DFer als oder gleich %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166336552399176)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'de'
,p_message_text=>'%0 in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167574949399177)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'de'
,p_message_text=>'%0 in den letzten %1  Tagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167349948399177)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'de'
,p_message_text=>'%0 in den letzten %1 Stunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167132003399177)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'de'
,p_message_text=>'%0 in den letzten %1 Minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167976375399177)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'de'
,p_message_text=>'%0 in den letzten %1 Monaten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167763307399177)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'de'
,p_message_text=>'%0 in den letzten %1  Wochen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168188504399178)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'de'
,p_message_text=>'%0 in den letzten %1 Jahren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167411812399177)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'de'
,p_message_text=>'%0 am letzten Tag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167215166399177)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'de'
,p_message_text=>'%0 in der letzten Stunde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167058699399177)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'de'
,p_message_text=>'%0 in der letzten Minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167888530399177)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'de'
,p_message_text=>'%0 im letzten Monat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111167658985399177)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'de'
,p_message_text=>'%0 in der letzten  Woche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168048616399177)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'de'
,p_message_text=>'%0 im letzten Jahr'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169907318399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in den n\00E4chsten %1 Tagen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169757647399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in den n\00E4chsten %1 Stunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169521226399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in den n\00E4chsten %1 Minuten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170375790399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in den n\00E4chsten %1 Monaten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170164366399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in den n\00E4chsten %1 Wochen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170593868399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in den n\00E4chsten %1 Jahren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169897056399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'de'
,p_message_text=>unistr('%0 am n\00E4chsten Tag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169622530399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in der n\00E4chsten Stunde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169468814399178)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in der n\00E4chsten Minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170258757399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'de'
,p_message_text=>unistr('%0 im n\00E4chsten Monat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170018970399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'de'
,p_message_text=>unistr('%0 in der n\00E4chsten Woche')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170421330399179)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 im n\00E4chsten Jahr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166071299399176)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'%0 ist nicht leer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165923366399176)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'de'
,p_message_text=>'%0 ist leer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165741704399176)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'de'
,p_message_text=>'%0 kleiner als %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165830516399176)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'de'
,p_message_text=>'%0 kleiner als oder gleich %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166106846399176)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'de'
,p_message_text=>'%0 wie %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166789180399177)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'de'
,p_message_text=>unistr('%0 entspricht regul\00E4rem Ausdruck %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172688539399181)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166969315399177)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'de'
,p_message_text=>'%0 nicht zwischen %1  und %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165482754399176)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'de'
,p_message_text=>'%0 ungleich %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166418290399176)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168771142399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'de'
,p_message_text=>'%0 nicht an den letzten %1 Tagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168527537399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in den letzten %1 Stunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168339647399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in den letzten %1 Minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169139955399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in den letzten %1 Monaten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168920172399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in den letzten %1 Wochen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169398800399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in den letzten %1 Jahren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168614173399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'de'
,p_message_text=>'%0 nicht am letzten Tag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168427458399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in der letzten Stunde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168276788399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in der letzten Minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169098472399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'de'
,p_message_text=>'%0 nicht im letzten Monat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111168817907399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'de'
,p_message_text=>'%0 nicht in der letzten Woche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111169288760399178)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'de'
,p_message_text=>'%0 nicht im letzten Jahr'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171182581399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in den n\00E4chsten %1 Tagen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170924574399179)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in den n\00E4chsten %1 Stunden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170749779399179)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in den n\00E4chsten %1 Minuten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171527729399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in den n\00E4chsten %1 Monaten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171322336399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in den n\00E4chsten %1 Wochen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171751465399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in den n\00E4chsten %1 Jahren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171003547399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht am n\00E4chsten Tag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170821306399179)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in der n\00E4chsten Stunde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111170608961399179)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in der n\00E4chsten Minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171472791399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht im n\00E4chsten Monat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171290590399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht in der n\00E4chsten Woche')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171606744399180)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 nicht im n\00E4chsten Jahr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111166233585399176)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'de'
,p_message_text=>'%0 nicht wie %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173199783399181)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'de'
,p_message_text=>'%0 beginnt mit %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216744957399212)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'de'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175899529399183)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'de'
,p_message_text=>'Jahre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216830508399212)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216924965399212)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111225940287399219)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'de'
,p_message_text=>'Montag, 12. Januar 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226012354399219)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'de'
,p_message_text=>'Januar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226152610399219)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'de'
,p_message_text=>'vor 16 Stunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111226209324399219)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'de'
,p_message_text=>'in 16 Std.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081250839399115)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Dateityp. Unterst\00FCtzte Dateitypen: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208172837399206)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'de'
,p_message_text=>'Durchsuchen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207831605399206)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207937717399206)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'de'
,p_message_text=>unistr('Dateien ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081016375399114)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'de'
,p_message_text=>'Drag-and-Drop'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081403922399115)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'de'
,p_message_text=>'Dateien per Drag-and-Drop verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082662932399116)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei ausw\00E4hlen oder hier ablegen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082720129399116)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'de'
,p_message_text=>unistr('Dateien ausw\00E4hlen oder hier ablegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082892418399116)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei ausw\00E4hlen oder hier ablegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082900697399116)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'de'
,p_message_text=>unistr('Dateien ausw\00E4hlen oder hier ablegen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081379364399115)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'de'
,p_message_text=>'%0 Dateien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081178194399114)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei ist zu gro\00DF. Maximale Dateigr\00F6\00DFe: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068959349399106)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Adresse erforderlich.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067807378399105)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'de'
,p_message_text=>'Stadt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068297936399105)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ndercode')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067944990399105)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'de'
,p_message_text=>'Hausnummer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068819406399106)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'de'
,p_message_text=>'Breitengrad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068759510399106)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4ngengrad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068670092399106)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'de'
,p_message_text=>'Auf Karte anz.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068384511399105)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'de'
,p_message_text=>'Bewertung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068069134399105)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'de'
,p_message_text=>'Postleitzahl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068182085399105)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'de'
,p_message_text=>'Bundesland'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067784659399105)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'de'
,p_message_text=>unistr('Stra\00DFe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067673655399105)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'de'
,p_message_text=>'Geocode-Ergebnisse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080232480399114)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'de'
,p_message_text=>'Geocodiert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080332618399114)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'de'
,p_message_text=>'Nicht geocodiert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068598363399105)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'de'
,p_message_text=>'Karte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111068453611399105)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Adressen gefunden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069004323399106)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'%0 ist erforderlich.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238800741399228)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'de'
,p_message_text=>'Hilfetext: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132221383399151)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132324732399151)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078213060399112)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# liegt nicht im g\00FCltigen Bereich zwischen %0 und %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078379549399113)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'de'
,p_message_text=>'#LABEL# ist kein Mehrfaches von %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077949535399112)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss den Werten %0 und %1 entsprechen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078127090399112)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156435159399169)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'de'
,p_message_text=>'Aus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156598170399169)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'de'
,p_message_text=>'Ein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078087347399112)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061428119399100)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'de'
,p_message_text=>unistr('Eintrag hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190634601399194)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190782797399194)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061522600399100)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlte Eintr\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194455853399196)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'de'
,p_message_text=>'Erweitert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194702937399197)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194539517399196)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'de'
,p_message_text=>'Allgemein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194847583399197)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'de'
,p_message_text=>'Live-Templateoptionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195460530399197)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Templateoptionen sind nicht verf\00FCgbar, weil diese Komponente nicht auf der Seite gerendert wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194377922399196)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Templateoptionen gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194630039399197)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'de'
,p_message_text=>'Speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069941680399106)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'de'
,p_message_text=>unistr('Kreis l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071797155399108)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'de'
,p_message_text=>unistr('"Benutzerdefinierte Stile" ist keine g\00FCltige JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070256504399107)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'de'
,p_message_text=>'Entfernungstool'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070060763399107)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'de'
,p_message_text=>'Kreis zeichnen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062666912399101)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die Facet-Suche ist eine Datenquelle auf Regionsebene erforderlich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065254987399103)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'de'
,p_message_text=>'Aktueller Speicherort'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066309362399104)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Die Koordinaten der anf\00E4nglichen Position sind ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063732827399102)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Die anf\00E4ngliche Position muss eine Punktgeometrie sein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066192320399104)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'de'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064756811399103)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'de'
,p_message_text=>'Layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198065864399199)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'de'
,p_message_text=>'Layer: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069398999399106)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'de'
,p_message_text=>'Karte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062597031399101)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'de'
,p_message_text=>'Nachrichten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066266050399104)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'de'
,p_message_text=>'Meilen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197017102399198)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Die Daten enthalten mehr als %0 Zeilen; dies \00FCberschreitet den zul\00E4ssigen Maximalwert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064534928399103)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'de'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Bedingungen</a> &nbsp;&nbsp; Kartendaten &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063420649399102)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Datentyp SDO_GEOMETRY ist in dieser Datenbank nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064616508399103)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'de'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap-Beitragende </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064851845399103)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'de'
,p_message_text=>'Punkte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198181530399199)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'de'
,p_message_text=>'%0 Punkte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070124143399107)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'de'
,p_message_text=>'Rechteckzoom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069869292399106)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065153262399103)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'de'
,p_message_text=>unistr('Peilung auf Nord zur\00FCcksetzen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145412815399161)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'de'
,p_message_text=>'Zu 2D-Modus wechseln'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145570065399161)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'de'
,p_message_text=>'Zu 3D-Modus wechseln'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069774683399106)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'de'
,p_message_text=>'Copyright-Hinweis ein-/ausschalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070328950399107)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'de'
,p_message_text=>'Entfernung gesamt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064941607399103)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'de'
,p_message_text=>unistr('Vergr\00F6\00DFern')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065045393399103)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'de'
,p_message_text=>'Verkleinern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192579914399195)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'de'
,p_message_text=>'Fettdruck'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193485884399196)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'de'
,p_message_text=>'Bild'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193016252399195)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'de'
,p_message_text=>'Inline-Code'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206657299399205)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Bild einf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206792503399205)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'de'
,p_message_text=>unistr('Link einf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192638836399195)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'de'
,p_message_text=>'Kursiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207310288399206)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'de'
,p_message_text=>'Link'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193380970399196)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'de'
,p_message_text=>'Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193216614399196)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'de'
,p_message_text=>'Sortierte Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192782758399195)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'de'
,p_message_text=>'Vorschau'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192881308399195)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'de'
,p_message_text=>'Keine Vorschau vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192966315399195)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'de'
,p_message_text=>'Durchgestrichen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193128835399195)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'de'
,p_message_text=>'Unsortierte Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172089681399180)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'de'
,p_message_text=>'Aktuell'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111229513579399222)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'de'
,p_message_text=>'Mehr...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111171915126399180)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Wird geladen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203775588399203)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'de'
,p_message_text=>'Benachrichtigung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177075092399184)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss eine Zahl kleiner als oder gleich %0 sein.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177189106399184)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss eine g\00FCltige Zahl sein.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177209216399184)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'de'
,p_message_text=>'#LABEL# entspricht nicht dem Zahlenformat %0 (Beispiel: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176920576399184)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('#LABEL# muss eine Zahl gr\00F6\00DFer als oder gleich %0 sein.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176809597399184)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss eine Zahl zwischen %0 und %1 sein.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172136597399180)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'de'
,p_message_text=>unistr('Wird in neuem Fenster ge\00F6ffnet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125361092399146)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'de'
,p_message_text=>'Diese Seite wurde bereits weitergeleitet und kann nicht erneut weitergeleitet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107973852399134)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Anwendung "%0" Seite "%1" nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141700101399158)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'#LABEL# muss einen Wert haben.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085055145399117)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191020227399194)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190996791399194)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'de'
,p_message_text=>'Suchen%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191257945399194)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191156200399194)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077112251399112)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Suchbegriff aus mindestens %0 Zeichen ein.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146612709399162)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'de'
,p_message_text=>'Popup-Werteliste: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077261884399112)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'de'
,p_message_text=>'Geben Sie einen Suchbegriff ein.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077084929399112)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'de'
,p_message_text=>'Keine Ergebnisse gefunden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076949703399112)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'de'
,p_message_text=>'%0 entfernen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164846191399175)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suchbegriff'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190808761399194)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'de'
,p_message_text=>'Suchen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201586860399201)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'de'
,p_message_text=>'Verarbeitung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075502161399111)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'de'
,p_message_text=>'Zu Home-Bildschirm hinzuf.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071512725399108)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ihr Ger\00E4t bzw. Browser scheint die Installation von progressiven Web-Apps aktuell nicht zu unterst\00FCtzen.</p>'),
unistr('    <p class="a-pwaDialog-intro">Wenn die App bereits auf Ihrem Ger\00E4t installiert ist, \00F6ffnen Sie sie \00FCber den Home-Bildschirm.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071122672399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen. F\00FCgen Sie sie Ihrem Home-Bildschirm hinzu, um diese bestm\00F6glich nutzen zu k\00F6nnen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tippen Sie auf das Symbol <strong>Men\00FC</strong> unten in der Navigation</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tippen Sie auf <strong>Installieren</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tippen Sie zur Best\00E4tigung auf <strong style="color:#007AE1;">Hinzuf\00FCgen</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071254491399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen, die sich mit Chrome oder Edge am besten verwenden lassen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'         <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tippen Sie auf das Symbol <strong>Men\00FC</strong> neben der Adressleiste</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tippen Sie auf <strong>Installieren</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070804406399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen, die sich mit Safari am besten verwenden lassen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'          <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tippen Sie auf das Symbol <strong>Freigeben</strong> in der Navigation unten</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tippen Sie auf <strong>In Safari \00F6ffnen</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070554794399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen. F\00FCgen Sie sie Ihrem Home-Bildschirm hinzu, um diese bestm\00F6glich nutzen zu k\00F6nnen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tippen Sie auf das Symbol <strong>Mehr</strong> neben der Adressleiste</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tippen Sie auf <strong>Zu Home-Bildschirm hinzuf.</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tippen Sie zur Best\00E4tigung auf <strong style="color:#007AE1;">Hinzuf\00FCgen</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070454780399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen. F\00FCgen Sie sie Ihrem Home-Bildschirm hinzu, um diese bestm\00F6glich nutzen zu k\00F6nnen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tippen Sie auf das Symbol <strong>Freigeben</strong> in der Navigation unten</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Scrollen Sie nach unten, und tippen Sie auf <strong>Zu Home-Bildschirm hinzuf.</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tippen Sie zur Best\00E4tigung auf <strong style="color:#007AE1;">Hinzuf\00FCgen</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065415220399103)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen. F\00FCgen Sie sie Ihrem Home-Bildschirm hinzu, um diese bestm\00F6glich nutzen zu k\00F6nnen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tippen Sie auf das Symbol <strong>Mehr</strong> neben der Adressleiste</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tippen Sie auf <strong>Zu Home-Bildschirm hinzuf.</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tippen Sie zur Best\00E4tigung auf <strong style="color:#007AE1;">Hinzuf\00FCgen</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070730804399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen. F\00FCgen Sie sie Ihrem Home-Bildschirm hinzu, um diese bestm\00F6glich nutzen zu k\00F6nnen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'         <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tippen Sie auf das Symbol <strong>Freigeben</strong> neben der Adressleiste</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tippen Sie auf <strong>In Safari \00F6ffnen</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070699076399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen. F\00FCgen Sie sie Ihrem Home-Bildschirm hinzu, um diese bestm\00F6glich nutzen zu k\00F6nnen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'         <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tippen Sie auf das Symbol <strong>Freigeben</strong> in der Navigation unten</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tippen Sie auf <strong>In Safari \00F6ffnen</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071498196399108)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen, die sich mit Chrome am besten verwenden lassen.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox unterst\00FCtzt die Installation von Web-Apps derzeit nicht.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111070962741399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen, die sich mit Chrome oder Edge am besten verwenden lassen.</p>'),
unistr('    <p class="a-pwaDialog-intro">Unter macOS unterst\00FCtzt Firefox die Installation von Web-Apps derzeit nicht.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071053742399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen, die sich mit Chrome oder Edge am besten verwenden lassen.</p>'),
unistr('    <p class="a-pwaDialog-intro">Unter macOS unterst\00FCtzt Safari die Installation von Web-Apps derzeit nicht.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071356692399107)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Diese Website verf\00FCgt \00FCber App-Funktionen, die sich mit Chrome oder Edge am besten verwenden lassen.</p>'),
unistr('    <p class="a-pwaDialog-intro">Unter Windows unterst\00FCtzt Firefox die Installation von Web-Apps derzeit nicht.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073878728399109)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Verbinden nicht m\00F6glich</h1>'),
unistr('    <p>Sie ben\00F6tigen eine Internetverbindung, um diese App zu verwenden.</p>'),
'    <button type="button">Wiederholen</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073792260399109)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Verbinden nicht m\00F6glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213574775399210)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157960573399170)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'de'
,p_message_text=>unistr('Ganzt\00E4gig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236855521399227)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'de'
,p_message_text=>'Einladung senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236605573399227)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'de'
,p_message_text=>'Optionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159764053399171)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'de'
,p_message_text=>unistr('T\00E4gliche Anzeige f\00FCr jeden Tag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159506563399171)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'de'
,p_message_text=>unistr('T\00E4gliche Anzeige f\00FCr Daten mit Uhrzeit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204449542399203)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'de'
,p_message_text=>'Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198898525399199)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089468345399120)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'de'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089204708399120)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'de'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089120980399120)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'de'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089346175399120)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'de'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088884324399120)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'de'
,p_message_text=>'Enddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089019066399120)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'de'
,p_message_text=>'Ereignisname'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236789931399227)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'de'
,p_message_text=>'Einladung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204521290399204)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204283954399203)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'de'
,p_message_text=>'Monat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207010043399205)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221333106399216)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'de'
,p_message_text=>'Keine Ereignisse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237055528399227)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten Sie ein vorhandenes Ereignis.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236946057399227)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'de'
,p_message_text=>'Senden Sie die Einladung per E-Mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207114817399205)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215126062399211)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214959492399211)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'de'
,p_message_text=>'E-Mail senden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237720779399228)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Alle Felder sind Pflichtfelder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237660035399227)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'de'
,p_message_text=>'Einladung senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236546125399227)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'de'
,p_message_text=>'Betreff'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215044780399211)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'de'
,p_message_text=>'An'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088978258399120)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212884443399209)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'de'
,p_message_text=>'Formular basierend auf %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159385611399171)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'de'
,p_message_text=>'Zeit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207287419399205)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'de'
,p_message_text=>'Heute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205073703399204)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204309703399203)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'de'
,p_message_text=>'Woche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159647644399171)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'de'
,p_message_text=>unistr('W\00F6chentliche Anzeige f\00FCr jeden Tag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159450834399171)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'de'
,p_message_text=>unistr('W\00F6chentliche Anzeige f\00FCr Daten mit Uhrzeit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204971878399204)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'de'
,p_message_text=>'Jahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204639016399204)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204771228399204)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'de'
,p_message_text=>'Weitere laden...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136831217399154)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083124266399116)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'de'
,p_message_text=>'Weitere laden...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085261430399117)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suchen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111204872389399204)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'de'
,p_message_text=>'Weitere laden...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206967402399205)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Regions-ID %0 nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085197693399117)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Keine Daten gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109241812399135)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen von Seitennummerierung f\00FCr Region nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077483913399112)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Festlegen des Regionsumbruchs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198238164399199)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206878563399205)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Regionstyp %0 wird nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077369200399112)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Rendering von Region "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141838880399158)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'#COLUMN_HEADER# muss einen Wert haben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236132262399226)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'de'
,p_message_text=>'%0, Rich Text-Editor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143905602399160)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Das Rich-Text-HTML-Markup \00FCberschreitet die maximale L\00E4nge des Elements (tats\00E4chlich: %0, zul\00E4ssig: %1 Zeichen)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203871369399203)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195661206399197)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'de'
,p_message_text=>'Duplizieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193900203399196)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Angezeigte Spalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193880349399196)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'de'
,p_message_text=>unistr('Nullwerte ausschlie\00DFen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203952724399203)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157551881399170)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'de'
,p_message_text=>'Nach unten verschieben'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157656470399170)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'de'
,p_message_text=>'Nach oben verschieben'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193673363399196)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'de'
,p_message_text=>'Weiter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194228926399196)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'de'
,p_message_text=>'Andere Spalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193716503399196)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194082175399196)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'de'
,p_message_text=>'Zeile %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194141714399196)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'de'
,p_message_text=>'Zeile %0 von %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195720899399197)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'de'
,p_message_text=>'Aktualisieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195869324399197)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'de'
,p_message_text=>unistr('\00C4nderungen wiederherstellen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111193520365399196)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC "Einstellungen"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154553072399167)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Beispiel: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062096591399101)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'de'
,p_message_text=>'Erneut anmelden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061905800399101)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'de'
,p_message_text=>'Ihre Session wurde beendet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062176473399101)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'de'
,p_message_text=>unistr('Verl\00E4ngern')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061701371399101)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Session endet um %0. M\00F6chten Sie sie verl\00E4ngern?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061899234399101)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Session endet um %0 und kann nicht verl\00E4ngert werden. Speichern Sie Ihre Arbeit jetzt, damit keine Daten verloren gehen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214724460399211)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten des Cleanup-Codes der Datenbanksession.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107837570399134)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten des Setup-Codes der Datenbanksession.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111081923869399115)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'de'
,p_message_text=>'Ihre Session wurde beendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213680902399210)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen Sie dieses Dialogfeld, und dr\00FCcken Sie auf die Browserschaltfl\00E4che f\00FCr das erneute Laden, um eine neue Session aufzurufen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232910206399224)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'de'
,p_message_text=>'Klicken Sie <a href="%0">hier</a>, um eine neue Session zu erstellen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119576096399142)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'de'
,p_message_text=>unistr('Session nicht g\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159036577399171)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'de'
,p_message_text=>unistr('Es konnten keine dynamischen Rollen in der Real Application Security-Session f\00FCr Benutzer "%0" aktiviert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105752915399132)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-99900 Erstellen von eindeutiger Session-ID nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122003961399144)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Verletzung des Sessionzustandsschutzes: Dieser Fehler wurde m\00F6glicherweise verursacht, weil das gesch\00FCtzte Seitenelement %0 manuell ge\00E4ndert wurde. Wenn Sie nicht wissen, wodurch dieser Fehler verursacht wurde, wenden Sie sich an den Anwendungsadmini')
||'strator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241134202399230)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenschutzverletzung: Dies kann auftreten, wenn Sie eine Seite weiterleiten, die noch nicht vollst\00E4ndig geladen wurde, oder wenn Sie gesch\00FCtzte Seitenelemente manuell \00E4ndern. Wenden Sie sich an den Anwendungsadministrator, wenn Sie weitere Hilfe be')
||unistr('n\00F6tigen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240151117399229)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt eines der folgenden ung\00FCltigen Zeichen: &<>"/;,*|=% oder --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240209165399229)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt eines der folgenden ung\00FCltigen Zeichen: &<>"/;,*|=% oder -- oder Zeilenendmarke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239912036399229)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt Sonderzeichen. Nur die Zeichen a-Z, 0-9 und Leerzeichen sind zul\00E4ssig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111240013003399229)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt <, > oder ". Dies sind ung\00FCltige Zeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084103986399117)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'de'
,p_message_text=>unistr('Es wurde keine Pr\00FCfsumme f\00FCr die Verarbeitungsanzeige f\00FCr eine Seite zur Verf\00FCgung gestellt, die eine Pr\00FCfsumme ben\00F6tigt, wenn Werte f\00FCr Anforderungen, L\00F6schvorg\00E4nge beim Cacheinhalt oder Argumente als Parameter \00FCbergeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116955959399140)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'de'
,p_message_text=>unistr('Verletzung des Sessionzustandschutzes: Dieser Fehler wurde m\00F6glicherweise verursacht, weil der URL ge\00E4ndert wurde, der eine Pr\00FCfsumme enth\00E4lt. Es wurde m\00F6glicherweise auch ein Link mit einer falschen oder fehlenden Pr\00FCfsumme verwendet. Wenn Sie nicht')
||' wissen, wodurch dieser Fehler verursacht wurde, wenden Sie sich an den Anwendungsadministrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111194954631399197)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'de'
,p_message_text=>'Modus "Hoher Kontrast" deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195074580399197)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'de'
,p_message_text=>'Modus "Hoher Kontrast" aktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113687127399138)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'de'
,p_message_text=>'Unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113815994399138)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'de'
,p_message_text=>'Nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113960177399138)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'de'
,p_message_text=>'Verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114091443399138)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114144193399138)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114243742399138)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114353292399138)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113571209399138)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113739227399138)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'de'
,p_message_text=>'Nach oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222666519399217)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'de'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223321712399217)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'in %0 Tag(en)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222557875399216)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'de'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223455099399217)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'in %0 Stunde(n)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222392411399216)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'de'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223523768399217)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'in %0 Minute(n)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222964404399217)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'de'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223171629399217)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'in %0 Monat(en)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222451266399216)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'de'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223230685399217)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'in %0 Sekunde(n)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222747842399217)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'de'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223673330399217)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'in %0 Woche(n)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222894955399217)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'de'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111223067144399217)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'in %0 Jahr(en)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062952497399101)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'de'
,p_message_text=>'[Linie]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063394911399102)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'de'
,p_message_text=>'[Mehrere Linien]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063150517399102)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'de'
,p_message_text=>'[Mehrere Punkte]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063529489399102)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'de'
,p_message_text=>'[Mehrere Polygone]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063635115399102)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'de'
,p_message_text=>'[Geometrieobjekt]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062855504399101)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'de'
,p_message_text=>'[Punkt (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063027493399101)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'de'
,p_message_text=>'[Polygon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140218201399157)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'de'
,p_message_text=>'Ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140168455399157)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'de'
,p_message_text=>'Wiederherstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186646398399191)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'de'
,p_message_text=>unistr('Bewertung l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176588960399183)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 liegt nicht im g\00FCltigen Bewertungsbereich von 1 bis %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176629660399184)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'de'
,p_message_text=>'%0 ist nicht numerisch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172749912399181)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'de'
,p_message_text=>'Erfolgsmeldung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235881365399226)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235747531399226)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221440873399216)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'de'
,p_message_text=>'Symbolleiste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236203395399226)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'de'
,p_message_text=>'Navigation ein-/ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236360106399227)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'de'
,p_message_text=>'Rechte Spalte einblenden/ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145968119399161)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'de'
,p_message_text=>'Hauptnavigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152949022399166)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'de'
,p_message_text=>'1 Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152746130399166)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'de'
,p_message_text=>'1 Stunde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153086677399166)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'de'
,p_message_text=>'%0 Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152806057399166)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'de'
,p_message_text=>'%0 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152674636399166)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'de'
,p_message_text=>'%0 Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153222741399167)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'de'
,p_message_text=>'%0 Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111153107898399166)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'de'
,p_message_text=>'1 Woche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239423838399229)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'de'
,p_message_text=>'Seitenanfang'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101463189399129)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075299981399110)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Verarbeiten von Anforderung.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154620663399168)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Wert erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237574645399227)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'de'
,p_message_text=>unistr('Warten Sie, bis die Seite vollst\00E4ndig geladen ist, und wiederholen Sie den Vorgang.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197782330399199)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Seite enth\00E4lt nicht gespeicherte \00C4nderungen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078693072399113)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'de'
,p_message_text=>unistr('Die Arbeitsmappe enth\00E4lt kein aktives Arbeitsblatt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078506908399113)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'de'
,p_message_text=>'Die Arbeitsmappe ist nicht initialisiert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078467968399113)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'de'
,p_message_text=>'Beim Erstellen der XLSX-Datei ist ein interner Fehler aufgetreten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080988303399114)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'de'
,p_message_text=>'Arbeitsblatt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212681392399209)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130144784399150)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC "Aktionen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125877779399147)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Funktion hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125712835399146)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Gruppe nach Spalte hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159953239399172)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Pivot-Spalte hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160089541399172)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenspalte hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100289509399128)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'de'
,p_message_text=>'Aggregieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136304300399154)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'de'
,p_message_text=>'Aggregation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117482633399141)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'de'
,p_message_text=>'Durchschnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121714445399144)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117570082399141)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'de'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117734068399141)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'de'
,p_message_text=>'Medianwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117693049399141)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'de'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117314308399140)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'de'
,p_message_text=>'Summe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118435960399141)
,p_name=>'APEXIR_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099578821399128)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Alle Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082032235399115)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'de'
,p_message_text=>'Alle Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209694332399207)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'de'
,p_message_text=>'Alternative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211275307399208)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'de'
,p_message_text=>'Alternativer Standardwert: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112156729399137)
,p_name=>'APEXIR_AND'
,p_message_language=>'de'
,p_message_text=>'und'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101629152399129)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'de'
,p_message_text=>'Anwenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095325537399125)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114961124399139)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'de'
,p_message_text=>'Ab %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211874744399209)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'de'
,p_message_text=>'Durchschnitt %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203239690399203)
,p_name=>'APEXIR_BAR'
,p_message_language=>'de'
,p_message_text=>'Balkendiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101086913399129)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'de'
,p_message_text=>'zwischen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094107966399124)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'de'
,p_message_text=>'Hintergrundfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096057557399125)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'de'
,p_message_text=>'blau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127707920399148)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'de'
,p_message_text=>'Unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096627317399126)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102515276399130)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'de'
,p_message_text=>'Kategorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094017898399124)
,p_name=>'APEXIR_CELL'
,p_message_language=>'de'
,p_message_text=>'Zelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118316191399141)
,p_name=>'APEXIR_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128662110399149)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'de'
,p_message_text=>'Wird initialisiert...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111164951043399175)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Das Diagrammlabel muss angegeben werden.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177367689399184)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'de'
,p_message_text=>unistr('Ihre Abfrage \00FCberschreitet die maximal zul\00E4ssigen %0 Datenpunkte pro Diagramm. Wenden Sie einen Filter an, um die Anzahl der Datens\00E4tze in der Basisabfrage zu reduzieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176228108399183)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'de'
,p_message_text=>unistr('Die maximale Zeilenanzahl f\00FCr eine "Diagramm"-Abfrage begrenzt die Anzahl der Zeilen in der Basisabfrage, aber nicht die Anzahl der angezeigten Zeilen. Die Basisabfrage \00FCberschreitet die maximale Zeilenanzahl von %0. Wenden Sie einen Filter an, um di')
||unistr('e Anzahl der Datens\00E4tze in der Basisabfrage zu reduzieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099616238399128)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'de'
,p_message_text=>'Diagrammtyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111172998089399181)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'de'
,p_message_text=>unistr('Alle ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115384329399139)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Berichtsformat ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122750723399144)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'de'
,p_message_text=>unistr('l\00F6schen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096557493399126)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133906859399152)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206269193399205)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'de'
,p_message_text=>'Filtern...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124722480399146)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Men\00FC "Spalten\00FCberschrift"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128444270399148)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'de'
,p_message_text=>'Spalteninformationen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208590247399206)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'de'
,p_message_text=>'Spaltenlabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126135688399147)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'de'
,p_message_text=>'Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110202099399135)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'de'
,p_message_text=>unistr('enth\00E4lt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111161056399136)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'de'
,p_message_text=>unistr('enth\00E4lt nicht')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095025989399124)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'de'
,p_message_text=>'in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111328510399136)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'de'
,p_message_text=>'ist nicht in den letzten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119838835399142)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('ist nicht in den n\00E4chsten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111255611399136)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'de'
,p_message_text=>'ist in den letzten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119785803399142)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('ist in den n\00E4chsten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094972193399124)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'ist nicht Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094836496399124)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'de'
,p_message_text=>'ist Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094608756399124)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'de'
,p_message_text=>'wie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095159242399125)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'de'
,p_message_text=>'nicht in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094767682399124)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'de'
,p_message_text=>'nicht wie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110578967399136)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'de'
,p_message_text=>unistr('entspricht regul\00E4rem Ausdruck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115272864399139)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111175940856399183)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'Berechnungsausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134260992399153)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'de'
,p_message_text=>'Erstellen Sie eine Berechnung mit Spaltenaliasnamen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134323219399153)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'de'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134422053399153)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'de'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134538755399153)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'de'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080437854399114)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'de'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119100393399142)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'de'
,p_message_text=>'Berechnen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126770189399147)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'de'
,p_message_text=>'Kontrollgruppenwechsel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129714076399149)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'de'
,p_message_text=>'Kontrollgruppenwechsel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214156348399210)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Gruppenwechselspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077560348399112)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'de'
,p_message_text=>'Anzahl - eindeutig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212314435399209)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'de'
,p_message_text=>'Anzahl - eindeutig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212256493399209)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'de'
,p_message_text=>'Anzahl %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184305725399189)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'de'
,p_message_text=>unistr('T\00E4glich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239080859399228)
,p_name=>'APEXIR_DATA'
,p_message_language=>'de'
,p_message_text=>'Daten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128536263399149)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht f\00FCr Daten im Status vor %0 Minuten erstellen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202018985399202)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid-Hilfe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100314598399128)
,p_name=>'APEXIR_DATE'
,p_message_language=>'de'
,p_message_text=>'Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132411064399151)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209484877399207)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Standardm\00E4\00DFiger Berichtstyp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096740498399126)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100653910399128)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('M\00F6chten Sie diese Berichtseinstellungen l\00F6schen?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195383323399197)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Standardbericht l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126443934399147)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'de'
,p_message_text=>unistr('Bericht l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095476415399125)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'de'
,p_message_text=>'Absteigend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102670417399130)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124695313399146)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'de'
,p_message_text=>'Single Row-Ansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132969768399152)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'de'
,p_message_text=>'Richtung %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133895155399152)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'de'
,p_message_text=>'Deaktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096272989399125)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'de'
,p_message_text=>'Angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099415247399128)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Angezeigte Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132867498399152)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'de'
,p_message_text=>'In Bericht anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127608640399148)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'de'
,p_message_text=>'Nach unten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119298840399142)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132726247399152)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'de'
,p_message_text=>'Nicht anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198780778399199)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'de'
,p_message_text=>'Es ist bereits eine Hervorhebung mit derselben Bedingung vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214317124399211)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Doppelt vorhandene Pivotspalte. Pivotspaltenliste muss eindeutig sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214579227399211)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128739649399149)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagrammeinstellungen bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135383956399153)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'de'
,p_message_text=>'Diagramm bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135710889399154)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190129221399193)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'de'
,p_message_text=>'"Gruppieren nach" bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135676067399154)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'de'
,p_message_text=>'Markierung bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160277797399172)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'de'
,p_message_text=>'Pivot bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209781325399207)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088445002399120)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210065155399207)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'de'
,p_message_text=>'Bcc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210265661399208)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'de'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209928501399207)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'de'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210759608399208)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'de'
,p_message_text=>unistr('H\00E4ufigkeit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092120083399122)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diese Anwendung wurde keine E-Mail konfiguriert. Wenden Sie sich an den Administrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183633585399189)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Die E-Mail-Adresse muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210369974399208)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'de'
,p_message_text=>'Siehe Anhang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210195555399208)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'de'
,p_message_text=>'Betreff'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184696932399189)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Der Betreff der E-Mail muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209818968399207)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'de'
,p_message_text=>'An'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093855354399124)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'de'
,p_message_text=>'Aktiviert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135592876399154)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'de'
,p_message_text=>'Aktivieren/Deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135068500399153)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134658765399153)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'de'
,p_message_text=>'Beispiele'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135468202399153)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'de'
,p_message_text=>'Beispiele:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099376422399128)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'de'
,p_message_text=>unistr('Nullwerte ausschlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136089375399154)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'de'
,p_message_text=>'Einblenden/Ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133654578399152)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'Ausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118753986399141)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129662803399149)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'de'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139976674399157)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'de'
,p_message_text=>'Filterausdruck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236414771399227)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>'Der Filterausdruck ist zu lang.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139868646399157)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'de'
,p_message_text=>'Filtertyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136201090399154)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'de'
,p_message_text=>unistr('Zu suchende Spalten ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119011465399142)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'de'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133408945399152)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Mit Flashback Query k\00F6nnen Sie die Daten in dem Status anzeigen, den sie zu einem vorherigen Zeitpunkt hatten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184003982399189)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'de'
,p_message_text=>'Flashback-Dauer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185443908399190)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'de'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115176651399139)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>'Formatmaske %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126300614399147)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'de'
,p_message_text=>'Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134125215399153)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'de'
,p_message_text=>'Funktionen %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209350138399207)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'de'
,p_message_text=>'Funktionen/Operatoren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126039033399147)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'de'
,p_message_text=>'Funktion %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118512516399141)
,p_name=>'APEXIR_GO'
,p_message_language=>'de'
,p_message_text=>'Los'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094372832399124)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'de'
,p_message_text=>unistr('gr\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111077613506399112)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'de'
,p_message_text=>'Gruppieren nach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210426166399208)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Nach Spalte %0 gruppieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165073846399175)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'"Nach Spalte gruppieren" muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176170887399183)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'de'
,p_message_text=>unistr('Die maximale Zeilenanzahl f\00FCr eine "Gruppieren nach"-Abfrage begrenzt die Anzahl der Zeilen in der Basisabfrage, aber nicht die Anzahl der angezeigten Zeilen. Die Basisabfrage \00FCberschreitet die maximale Zeilenanzahl von %0. Wenden Sie einen Filter an')
||unistr(', um die Anzahl der Datens\00E4tze in der Basisabfrage zu reduzieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156765896399169)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'de'
,p_message_text=>'Nach Sortierung gruppieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214265792399210)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'de'
,p_message_text=>'Nach Sortierfolge gruppieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099743578399128)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Horizontale Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131387363399151)
,p_name=>'APEXIR_HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123122966399145)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('In den interaktiven Berichten k\00F6nnen Endbenutzer Berichte anpassen. Benutzer k\00F6nnen das Layout von Berichtsdaten \00E4ndern, indem sie Spalten ausw\00E4hlen, Filter anwenden, Bereiche markieren oder sortieren. Benutzer k\00F6nnen dar\00FCber hinaus Gruppenwechsel, A')
||unistr('ggregationen, Diagramme und Gruppierungen definieren und ihre eigenen Berechnungen hinzuf\00FCgen. Sie k\00F6nnen auch ein Abonnement einrichten, sodass sie HTML-Versionen des Berichts per E-Mail in einem festgelegten Intervall erhalten. Benutzer k\00F6nnen mehr')
||unistr('ere Varianten eines Berichts erstellen und diese als benannte Berichte speichern, die entweder \00F6ffentlich oder privat angezeigt werden k\00F6nnen.'),
'<p/>',
unistr('In den folgenden Abschnitten wird zusammengefasst, wie Sie einen interaktiven Bericht anpassen k\00F6nnen. Weitere Informationen finden Sie unter "Using Interactive Reports" in <a href="http://www.oracle.com/pls/topic/lookup?ctx=E37097_01&id=AEEUG453" ta')
||'rget="_blank"><i>Oracle Application Express End User''s Guide</i></a>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130223605399150)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Das Men\00FC "Aktion" wird in der Suchleiste rechts der Schaltfl\00E4che "Los" angezeigt. Mit diesem Men\00FC k\00F6nnen Sie interaktive Berichte anpassen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123918863399145)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aggregate sind mathematische Berechnungen f\00FCr eine Spalte. Aggregate werden nach jedem Kontrollgruppenwechsel und am Ende des Berichts in der Spalte angezeigt, in der sie definiert werden. Zu den Optionen geh\00F6ren:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Aggregation</strong>: Erm\00F6glicht die Wahl einer vorher'),
'definierten Aggregation zur Bearbeitung.</li>',
unistr('<li><strong>Funktion</strong>: Ist die auszuf\00FChrende Funktion (z.B. SUM, MIN).</li>'),
unistr('<li><strong>Spalte</strong>: Wird verwendet, um die Spalte zu w\00E4hlen, f\00FCr die die mathematische Funktion angewendet werden soll. Nur numerische Spalten werden angezeigt.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124023556399145)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sie k\00F6nnen ein Diagramm pro gespeicherten Bericht definieren. Nach der Definition k\00F6nnen Sie mit den Ansichtsymbolen in der Suchleiste zwischen der Diagramm- und Berichtsansicht wechseln. Zu den Optionen geh\00F6ren:'),
'<p>',
'</p><ul>',
'<li><strong>Diagrammtyp</strong>: Gibt den aufzunehmenden Diagrammtyp an.',
'Optionen: Horizontaler Balken, Vertikaler Balken, Kreis oder Linie.</li>',
unistr('<li><strong>Label</strong>: W\00E4hlen Sie die Spalte aus, die als Label verwendet werden soll.</li>'),
unistr('<li><strong>Achsenbeschriftung f\00FCr Label</strong>: Diese Beschriftung wird auf der Achse angezeigt, die mit der'),
unistr('als Label ausgew\00E4hlten Spalte verkn\00FCpft ist. Diese Option ist bei Tortendiagrammen nicht verf\00FCgbar.</li>'),
unistr('<li><strong>Wert</strong>: W\00E4hlen Sie die Spalte aus, die als Wert verwendet werden soll. Wenn als Funktion'),
unistr('COUNT verwendet wird, muss kein Wert ausgew\00E4hlt werden.</li>'),
unistr('<li><strong>Achsenbeschriftung f\00FCr Wert</strong>: Diese Beschriftung wird auf der Achse angezeigt, die mit der als'),
unistr('Wert ausgew\00E4hlten Spalte verkn\00FCpft ist. Diese Option ist bei Tortendiagrammen nicht verf\00FCgbar.</li>'),
unistr('<li><strong>Funktion</strong>: Ist eine optionale Funktion, die f\00FCr die als Wert ausgew\00E4hlte Spalte ausgef\00FChrt werden soll.</li>'),
'<li><strong>Sortieren</strong>: Zum Sortieren der Ergebnismenge.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123361730399145)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Sie auf einen Spaltentitel klicken, wird ein Men\00FC f\00FCr Spaltentitel angezeigt. Folgende Optionen sind enthalten:'),
'<p></p>',
'<ul>',
'<li>Symbol <strong>Aufsteigend sortieren</strong>: Sortiert den Bericht nach Spalte in aufsteigender Reihenfolge.</li>',
'<li>Symbol <strong>Absteigend sortieren</strong>: Sortiert den Bericht nach Spalte in absteigender Reihenfolge.</li>',
unistr('<li><strong>Spalte ausblenden</strong>: Blendet die Spalte aus. Nicht alle Spalten k\00F6nnen ausgeblendet werden. Spalten, die nicht ausgeblendet werden k\00F6nnen, haben kein Symbol "Spalte ausblenden".</li>'),
unistr('<li><strong>Gruppenwechselspalte</strong>: Erstellt einen Gruppenwechsel f\00FCr die Spalte. Dadurch wird die Spalte als Master-Datensatz aus dem Bericht herausgezogen.</li>'),
unistr('<li><strong>Spalteninformationen</strong>: Zeigt einen Hilfetext zur Spalte an, falls verf\00FCgbar.</li>'),
unistr('<li><strong>Textbereich</strong>: Wird zur Eingabe von Suchkriterien verwendet (keine Platzhalter erforderlich). Die Gro\00DF-/Kleinschreibung wird dabei ignoriert. Durch die Eingabe eines Wertes wird die Werteliste am Ende des Men\00FCs gek\00FCrzt. Sie k\00F6nnen ')
||unistr('dann einen Wert vom Ende der Liste ausw\00E4hlen, und der ausgew\00E4hlte Wert wird als Filter mit "=" erstellt (z.B. <code>column = ''ABC''</code>). Alternativ k\00F6nnen Sie auf das Taschenlampensymbol klicken und einen Wert eingeben, der dann als Filter mit dem')
||' Modifier "LIKE" erstellt wird (z.B. <code>column LIKE ''%ABC%''</code>).',
unistr('<li> <strong>Liste mit eindeutigen Werten</strong>: Enth\00E4lt die ersten 500 eindeutigen Werte, die den Filterkriterien entsprechen. Wenn die Spalte ein Datum darstellt, wird stattdessen eine Liste mit Datumsbereichen angezeigt. Wenn Sie einen Wert aus')
||unistr('w\00E4hlen, wird ein Filter mit "=" erstellt (z.B. <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123879431399145)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00E4sst Sie berechnete Spalten zu dem Bericht hinzuf\00FCgen. Dabei kann es sich um mathematische Berechnungen (z.B. <code>NBR_HOURS/24</code>) oder Oracle-Standardfunktionen handeln, die auf vorhandene Spalten angewendet werden. Einige werden als Beispiel')
||unistr(' angezeigt, andere, wie <code>TO_DATE</code>, k\00F6nnen ebenfalls verwendet werden. Zu den Optionen geh\00F6ren:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Berechnung</strong>: Erm\00F6glicht die Wahl einer vorher definierten Berechnung zur Bearbeitung.</li>'),
unistr('<li><strong>Spalten\00FCberschrift</strong>: Die \00DCberschrift der neuen Spalte.</li>'),
'<li><strong>Formatmaske</strong>: Eine Formatmaske von Oracle, die auf die Spalte angewendet werden soll (z.B. S9999).</li>',
unistr('<li><strong>Berechnung</strong>: Die auszuf\00FChrende Berechnung. Innerhalb der Berechnung werden Spalten mit den angezeigten Aliasnamen referenziert.</li>'),
'</ul>',
unistr('<p>Unter der Berechnung werden die Spalten in der Abfrage mit den zugeh\00F6rigen Aliasnamen angezeigt. Wenn Sie auf den Spalten- oder Aliasnamen klicken, wird dieser in die Berechnung eingef\00FCgt. Neben "Spalten" befindet sich eine Zehnertastatur. Sie ent')
||unistr('h\00E4lt Shortcuts f\00FCr h\00E4ufig verwendete Tasten. Ganz au\00DFen rechts stehen Funktionen.</p>'),
unistr('<p>Eine Beispielberechnung zur Anzeige der Gesamtverg\00FCtung folgt:'),
'<p/>',
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(wobei A f\00FCr ORGANIZATION [Unternehmen], B f\00FCr SALARY [Gehalt] und C f\00FCr COMMISSION [Provision] steht)</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130331124399150)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'de'
,p_message_text=>'Wird verwendet, um einen Gruppenwechsel auf einer oder mehreren Spalten zu erstellen. Dadurch werden die Spalten aus dem interaktiven Bericht herausgezogen und als Master-Datensatz angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124541533399146)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'de'
,p_message_text=>unistr('Um die Details von jeweils einer Zeile anzuzeigen, klicken Sie auf das Symbol f\00FCr die Single Row-Ansicht in der Zeile, die angezeigt werden soll. Wenn verf\00FCgbar, ist die Single Row-Ansicht immer die erste Spalte. Je nach Anpassung des interaktiven Be')
||unistr('richts kann die Single Row-Ansicht eine Standardansicht oder eine benutzerdefinierte Seite sein, die eine Aktualisierung zul\00E4sst.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124497212399146)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>unistr('Erm\00F6glicht das Herunterladen der aktuellen Ergebnismenge. Die Downloadformate variieren je nach Installation und Berichtsdefinition, k\00F6nnen jedoch CSV, HTML, E-Mail, XLS, PDF oder RTF umfassen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123566378399145)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fokussiert den Bericht durch Hinzuf\00FCgen oder \00C4ndern der <code>WHERE</code>-Klausel der Abfrage. Sie k\00F6nnen nach Spalte oder Zeile filtern.   '),
unistr('<p>IWenn Sie nach Spalte filtern, ausw\00E4hlen Sie zun\00E4chst eine Spalte (nicht unbedingt die angezeigte Spalte). W\00E4hlen Sie dann einen Operator aus der Liste mit Oracle-Standardoperatoren (=, !=, nicht in, zwischen), und geben Sie einen Ausdruck f\00FCr den')
||unistr(' Vergleich ein. Beim Ausdruck muss die Gro\00DF-/Kleinschreibung beachtet werden. Sie k\00F6nnen % als Platzhalterzeichen verwenden (Beispiel: <code>STATE_NAME wie A%)</code>.</p>'),
unistr('<p>Wenn Sie nach Zeile filtern, k\00F6nnen Sie komplexe <code>WHERE</code>-Klauseln mit'),
unistr('Spaltenaliasnamen und beliebigen Oracle-Funktionen oder -Operatoren erstellen (Beispiel: <code>G = ''VA'' oder G = ''CT''</code>, wobei <code>G</code> der Alias f\00FCr <code>CUSTOMER_STATE</code> ist).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124125428399145)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'de'
,p_message_text=>unistr('Flashback Query erm\00F6glicht Ihnen, die Daten in dem Status anzuzeigen, den sie zu einem fr\00FCheren Zeitpunkt hatten. Die Standardzeit f\00FCr das Flashback betr\00E4gt 3 Stunden (oder 180 Minuten), die tats\00E4chliche Zeit differiert jedoch je nach Datenbank.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185333395399190)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der Option "Formatieren" k\00F6nnen Sie das Erscheinungsbild des Berichts anpassen.'),
unistr('"Formatieren" enth\00E4lt das folgende Untermen\00FC:</p>'),
'<ul><li>Sortieren</li>',
'<li>Kontrollgruppenwechsel</li>',
'<li>Markieren</li>',
'<li>Berechnen</li>',
'<li>Aggregieren</li>',
'<li>Diagramm</li>',
'<li>Gruppieren nach</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183591469399189)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pro gespeicherten Bericht k\00F6nnen Sie eine Ansicht "Gruppieren nach" definieren. '),
unistr('Nach der Definition k\00F6nnen Sie zwischen den "Gruppieren nach"- und den Berichtsansichten umschalten. '),
unistr('Verwenden Sie hierf\00FCr die Ansichtssymbole in der Suchleiste. Um eine Ansicht "Gruppieren nach" zu erstellen,'),
unistr('w\00E4hlen Sie:'),
'<p></p><ul>',
'<li>die Spalten, nach denen gruppiert werden soll</li>',
unistr('<li>die Spalten, die zusammen mit der auszuf\00FChrenden Funktion (Durchschnitt, Summe, Anzahl usw.) aggregiert werden sollen</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123728438399145)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Erm\00F6glicht es Ihnen, Filter zu definieren. Die Zeilen, die den Filterkriterien entsprechen, werden wie gekennzeichnet mithilfe der Eigenschaften angezeigt, die mit dem Filter verkn\00FCpft sind. Zu den Optionen geh\00F6ren:</p>'),
'<ul>',
'<li><strong>Name</strong>: Wird nur zur Anzeige verwendet.</li>',
'<li><strong>Sequenz</strong>: Gibt die Reihenfolge an, in der die Regeln ausgewertet werden.</li>',
'<li><strong>Aktiviert</strong>: Gibt an, ob die Regel aktiviert oder deaktiviert ist.</li>',
unistr('<li><strong>Markierungstyp</strong>: Gibt an, ob die Zeile oder Zelle markiert werden soll. Wenn "Zelle" ausgew\00E4hlt wird, wird die Spalte markiert, die in der Markierungsbedingung referenziert wird.</li>'),
unistr('<li><strong>Hintergrundfarbe</strong>: Die neue Farbe f\00FCr den Hintergrund des markierten Bereichs.</li>'),
unistr('<li><strong>Textfarbe</strong>: Die neue Farbe f\00FCr den Text im markierten Bereich.</li>'),
'<li><strong>Markierungsbedingung</strong>: Definiert die Filterbedingung.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061376801399100)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sie k\00F6nnen eine Pivot-Ansicht pro gespeicherten Bericht definieren. Nach der Definition k\00F6nnen Sie zwischen der Pivot- und Berichtsansicht mit Ansichtsymbolen in der Suchleiste wechseln. Um eine Pivot-Ansicht zu erstellen, w\00E4hlen Sie Folgendes: '),
'<p></p>',
'<ul>',
'<li>die Spalten, die pivotiert werden sollen</li>',
'<li>die Spalten, die als Zeilen angezeigt werden sollen</li>',
unistr('<li>die Spalten, die zusammen mit der auszuf\00FChrenden Funktion aggregiert werden sollen (Durchschnitt, Summe, Anzahl usw.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134823892399153)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Sie einen interaktiven Bericht anpassen, werden die Berichtseinstellungen unter der Suchleiste und \00FCber dem Bericht angezeigt. Dieser Bereich kann mit dem Symbol auf der linken Seite aus- und eingeblendet werden.'),
'<p/>',
unistr('Sie k\00F6nnen f\00FCr Berichtseinstellungen folgende Aktionen durchf\00FChren:'),
'</p><ul>',
'<li>Bearbeiten</b>, indem Sie auf den Namen klicken.</li>',
unistr('<li><b>Deaktivieren/Aktivieren</b>, indem Sie das Kontrollk\00E4stchen "Aktivieren/Deaktivieren" w\00E4hlen oder die Wahl aufheben. Diese Option wird verwendet, um die Einstellung vor\00FCbergehend ein- und auszuschalten.</li>'),
unistr('<li><b>Entfernen</b>, indem Sie auf das Symbol f\00FCr Entfernen klicken.</li></ul>'),
'<p/>',
unistr('Wenn Sie ein Diagramm, "Gruppieren nach" oder "Pivot" erstellt haben, k\00F6nnen Sie mit den Links "Berichtsansicht", "Diagrammansicht" und "Nach Ansicht gruppieren" und "Pivot-Ansicht" '),
unistr('auf der rechten Seite zwischen den Diagrammen und dem Basisbericht umschalten. Im Diagramm oder der Ansicht "Gruppieren nach" k\00F6nnen Sie auch den Link "Bearbeiten" verwenden, um die Einstellungen zu bearbeiten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124366202399145)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Setzt den Bericht auf die Standardeinstellungen zur\00FCck, wobei von Ihnen vorgenommene Anpassungen entfernt werden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185699471399190)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Legt die Anzahl der pro Seite anzuzeigenden Datens\00E4tze fest')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124293860399145)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Speichert den angepassten Bericht f\00FCr die sp\00E4tere Verwendung. Sie k\00F6nnen einen Namen und eine optionale Beschreibung eingeben und den Bericht \00F6ffentlich zug\00E4nglich machen (bzw. den Zugriff allen Benutzern erm\00F6glichen, die auf den prim\00E4ren Standard')
||unistr('bericht zugreifen k\00F6nnen). Es k\00F6nnen vier Arten interaktiver Berichte gespeichert werden:</p>'),
'<ul>',
unistr('<li><strong>Prim\00E4rstandard</strong> (nur Entwickler). Prim\00E4rstandardberichte werden urspr\00FCnglich angezeigt. Solche Berichte k\00F6nnen weder umbenannt noch gel\00F6scht werden.</li>'),
unistr('<li><strong>Alternativer Bericht</strong> (Nur Entwickler). Erlaubt Entwicklern die Erstellung von Berichten mit mehreren Layouts. Nur Entwickler k\00F6nnen alternative Berichte sichern, umbenennen oder l\00F6schen.</li>'),
unistr('<li><strong>\00D6ffentliche Berichte</strong> (Endbenutzer). Diese Berichte k\00F6nnen von dem erstellenden Endbenutzer gespeichert, umbenannt und gel\00F6scht werden. Andere Benutzer k\00F6nnen das Layout als weiteren Bericht anzeigen und speichern.</li>'),
unistr('<li><strong>Private Berichte</strong> (Endbenutzer). Diese Berichte kann nur der erstellende Endbenutzer anzeigen, speichern, umbenennen oder l\00F6schen.</li>'),
'</ul>',
'<p>Wenn Sie angepasste Berichte speichern, dann wird der Berichtsselektor in der Suchleiste links des Spaltenselektors angezeigt (falls dieses Feature aktiviert ist).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123294921399145)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'de'
,p_message_text=>unistr('Im oberen Bereich der einzelnen Berichtsseiten befindet sich eine Suchregion. Diese Region (bzw. die Suchleiste) enth\00E4lt die folgenden Features:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186236452399191)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('<li>Das <strong>Aktionsmen\00FC</strong> erm\00F6glicht die Anpassung von Berichten. Weitere Informationen finden Sie in den folgenden Abschnitten.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185768500399190)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'de'
,p_message_text=>unistr('Mit dem Symbol <li><strong>Spalten ausw\00E4hlen</strong> k\00F6nnen Sie angeben, welche Spalten durchsucht werden sollen, bzw. ob alle Spalten durchsucht werden sollen.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186011577399190)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'de'
,p_message_text=>unistr('In <li><strong>Berichte</strong> werden verschiedene Standardwerte und gespeicherte private oder \00F6ffentliche Berichte angezeigt.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185989888399190)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('In <li><strong>Zeilen</strong> wird die Anzahl der pro Seite anzuzeigenden Datens\00E4tze angezeigt.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185801170399190)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>Im <strong>Textbereich</strong> k\00F6nnen Sie Suchkriterien eingeben, bei denen die Gro\00DF-/Kleinschreibung nicht beachtet werden muss (Platzhalterzeichen sind impliziert).</li>'),
unistr('<li><strong>Schaltfl\00E4che "Los"</strong> f\00FChrt die Suche durch. Wenn Sie die Eingabetaste dr\00FCcken, w\00E4hrend sich der Cursor im Suchtextbereich befindet, wird die Suche ebenfalls ausgef\00FChrt.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186110185399190)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'de'
,p_message_text=>'<li><strong>Ansicht-Symbole</strong> wechselt zwischen Symbol-, Berichts-, Detail-, Diagramm-, Gruppieren nach- und Pivot-Ansicht des Berichts, sofern definiert.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202108688399202)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'de'
,p_message_text=>unistr('<li><strong>Verwalten</strong> erm\00F6glicht es, die Eigenschaften, Spalten, Zeilen und die Anzeigenhistorie eines Berichts oder Daten-Grids zu verwalten.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123457817399145)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Wird zur \00C4nderung der angezeigten Spalten verwendet. Die Spalten auf der rechten Seite werden angezeigt. Die Spalten auf der linken Seite werden ausgeblendet. Sie k\00F6nnen die angezeigten Spalten mit den Pfeilen ganz au\00DFen rechts neu anordnen. Vor bere')
||'chneten Spalten steht <strong>**</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123687606399145)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Wird verwendet, um die zu sortierenden Spalten zu wechseln und anzugeben, ob in aufsteigender oder absteigender Reihenfolge sortiert werden soll. Sie k\00F6nnen auch angeben, wie <code>Nullwerte</code> behandelt werden sollen. Die Standardeinstellung ')
||unistr('zeigt die <code>Nullwerte</code> immer am Ende an; Sie k\00F6nnen sie alternativ immer am Anfang anzeigen. Die Ergebnissortierung wird rechts neben den Spalten\00FCberschriften im Bericht angezeigt.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183380491399188)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie eine Subscription hinzuf\00FCgen, geben Sie E-Mail-Adresse (oder mehrere, durch Komma getrennte E-Mail-Adressen), E-Mail-Betreff, H\00E4ufigkeit sowie die Angaben zum Start- und Enddatum ein. Die resultierenden E-Mails enthalten eine HTML-Version de')
||unistr('s interaktiven Berichts. Sie enthalten die aktuellen Daten mit den Berichtseinstellungen, die bei Hinzuf\00FCgen der Subscription vorhanden waren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201913273399202)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Daten-Grids sind im Grunde Berichte, die bearbeitet und hochgradig angepasst werden k\00F6nnen. Benutzer k\00F6nnen das Layout von Berichtsdaten \00E4ndern, indem sie Spalten ausw\00E4hlen, Filter anwenden, Bereiche hervorheben und sortieren. Sie k\00F6nnen dar\00FCber hina')
||unistr('us Gruppenwechsel, Aggregationen, verschiedene Diagramme und Gruppierungen definieren und ihre eigenen Berechnungen hinzuf\00FCgen. Benutzer k\00F6nnen mehrere Variationen eines Berichts erstellen und diese als benannte Berichte speichern, die privat angezei')
||unistr('gt werden k\00F6nnen.'),
'<p/>',
unistr('Ein Daten-Grid kann \00FCber die Suchleiste, im Men\00FC "Aktionen", im Men\00FC "Verwaltung" oder im Men\00FC "Spalten\00FCberschrift" angepasst werden.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213702094399210)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'de'
,p_message_text=>unistr('Das Men\00FC "Aktionen" wird in der Suchleiste rechts der Schaltfl\00E4che "Los" angezeigt. Mit diesem Men\00FC k\00F6nnen Sie Daten-Grid-Berichte anpassen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202414610399202)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilenseite hinzuf\00FCgen/bearbeiten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202573775399202)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Klicken Sie auf "Zeile hinzuf\00FCgen", um dem Daten-Grid eine Zeile hinzuzuf\00FCgen. Klicken Sie in der zu bearbeitenden Zeile auf das Symbol f\00FCr die Zeilenbearbeitung (erste Spalte), um die Zeilendetails zu bearbeiten. Die Seite "Zeile hinzuf\00FCgen/bearb')
||'eiten" wird mit den Zeilen des Daten-Grids angezeigt. </p>',
'',
unistr('<p>Die Optionen f\00FCr das Bearbeiten von Zeilen sind:</p>'),
'',
'<p><ul>',
unistr('<li><strong>L\00F6schen</strong>: Die Zeile wird gel\00F6scht.</li>'),
unistr('<li><strong>\00C4nderungen anwenden</strong>: Die an der Zeile vorgenommenen \00C4nderungen werden gespeichert.</li>'),
unistr('<li><strong>Aktionen</strong>: Dient zum Hinzuf\00FCgen von Zeilen, Dateien, Anmerkungen, Links oder Tags und zum Pr\00FCfen der Historie.</li>'),
unistr('<li><strong>N\00E4chsten und Vorherigen</strong>: Dient zum Navigieren zur n\00E4chsten/vorherigen Zeile.</li>'),
'<li><strong>Verwalten</strong>: Dient zum Einrichten von Spalteneigenschaften, Spaltengruppen, Vaildierungen und Wertelisten.</li>',
'</ul></p>',
'',
unistr('<p>Der Bereich "Annotationen" im unteren Abschnitt der Seite zeigt alle mit der aktuellen Zeile verkn\00FCpften Dateien, Anmerkungen, Links oder Tags.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213820964399210)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'de'
,p_message_text=>'Wird verwendet, um einen Gruppenwechsel auf einer oder mehreren Spalten zu erstellen. Dadurch werden die Spalten aus dem Daten-Grid herausgezogen und als Master-Datensatz angezeigt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202300339399202)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>unistr('Erm\00F6glicht das Herunterladen der aktuellen Ergebnismenge. Zu den Downloadformaten geh\00F6ren CSV, HTML und E-Mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213977815399210)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Wenn Sie einen Daten-Grid-Bericht anpassen, werden die Berichtseinstellungen unter der Suchleiste und \00FCber dem Bericht angezeigt. Dieser Bereich kann mit dem Symbol auf der linken Seite aus- und eingeblendet werden.'),
'<p/>',
unistr('Sie k\00F6nnen f\00FCr Berichtseinstellungen folgende Aktionen durchf\00FChren:'),
'</p><ul>',
'<li>Bearbeiten Sie eine Einstellung. indem Sie auf den Namen klicken.</li>',
unistr('<li>Deaktivieren/aktivieren Sie eine Einstellung, indem Sie das Kontrollk\00E4stchen "Aktivieren/Deaktivieren" ausw\00E4hlen oder die Wahl aufheben. Diese Option wird verwendet, um die Einstellung vor\00FCbergehend ein- und auszuschalten.</li>'),
unistr('<li>Entfernen Sie eine Einstellung, indem Sie auf das Symbol f\00FCr Entfernen klicken.</li>'),
'</ul>',
unistr('Wenn Sie ein Diagramm oder eine Ansicht "Gruppieren nach" erstellt haben, k\00F6nnen Sie mit den Links'),
' "Berichtsansicht", "Diagrammansicht" und "Nach Ansicht gruppieren" auf der rechten Seite zwischen',
' den Diagrammen und dem Basisbericht umschalten. Im Diagramm oder der Ansicht "Gruppieren nach" ',
unistr('k\00F6nnen Sie auch den Link "Bearbeiten" verwenden, um die Einstellungen zu bearbeiten.</p><p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202290562399202)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Speichert das angepasste Layout des Daten-Grid-Berichts f\00FCr die sp\00E4tere Verwendung. Sie k\00F6nnen einen Namen und eine optionale Beschreibung eingeben. Es k\00F6nnen drei Layoutarten f\00FCr Daten-Grid-Berichte gespeichert werden:</p>'),
'<ul>',
unistr('<li><strong>Prim\00E4rstandard</strong> (nur Administrator). Prim\00E4rstandardlayouts werden urspr\00FCnglich angezeigt. Solche Berichte k\00F6nnen weder umbenannt noch gel\00F6scht werden.</li>'),
unistr('<li><strong>Alternativer Bericht</strong> (Nur Administrator). Erlaubt Administratoren die Erstellung von Berichten mit mehreren Layouts. Nur Administratoren k\00F6nnen alternative Berichte sichern, umbenennen oder l\00F6schen.</li>'),
unistr('<li><strong>Private Berichte</strong> (Alle Benutzer). Diese Berichtslayouts k\00F6nnen vom erstellenden Benutzer angezeigt, gespeichert, umbenannt oder gel\00F6scht werden.</li>'),
'</ul>',
'<p>Wenn Sie angepasste Berichte speichern, dann wird die Berichtsauswahl in der Suchleiste links der Spaltenauswahl angezeigt (falls dieses Feature aktiviert ist).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128396516399148)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte ausblenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118954475399142)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'de'
,p_message_text=>'Markieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129885813399149)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'de'
,p_message_text=>'Markierungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134941841399153)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'de'
,p_message_text=>'Markierungsbedingung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183951295399189)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'de'
,p_message_text=>unistr('Stil f\00FCr Hervorheben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093914418399124)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Markierungstyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203415394399203)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'de'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233098492399224)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'de'
,p_message_text=>'1 inaktive Einstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233164024399224)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'%0 inaktive Einstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124982295399146)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe zu interaktivem Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135981495399154)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129321881399149)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Berechnungsausdruck. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088721286399120)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'de'
,p_message_text=>'Das Enddatum muss nach dem Anfangdatum liegen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143678631399159)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Filterausdruck. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211421567399208)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Filterabfrage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233243702399224)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'de'
,p_message_text=>unistr('1 ung\00FCltige Einstellung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233355704399224)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ung\00FCltige Einstellungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184193467399189)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'de'
,p_message_text=>'(in Minuten)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201127891399201)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'de'
,p_message_text=>'%0 ist in den letzten %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201390591399201)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ist in den n\00E4chsten %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201255330399201)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'de'
,p_message_text=>'%0 ist nicht in den letzten %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201460432399201)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'de'
,p_message_text=>unistr('%0 ist nicht in den n\00E4chsten %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134036503399152)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'de'
,p_message_text=>'Zehnertastatur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100170679399128)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'de'
,p_message_text=>'Label %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127960682399148)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Achsenbeschriftung f\00FCr Label')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120442207399143)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'de'
,p_message_text=>'Letzter Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120609647399143)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'de'
,p_message_text=>'Letzte Stunde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120115143399142)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'de'
,p_message_text=>'Letzter Monat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120277673399143)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'de'
,p_message_text=>'Letzte Woche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120326832399143)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120508835399143)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119918414399142)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'de'
,p_message_text=>'Letzte %0 Jahre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120026893399142)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'de'
,p_message_text=>'Letztes Jahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100057877399128)
,p_name=>'APEXIR_LINE'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096843305399126)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'de'
,p_message_text=>unistr('Linien/Fl\00E4chen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211372822399208)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'de'
,p_message_text=>'Zuordnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128838282399149)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfrage wird wahrscheinlich die maximal zul\00E4ssigen Ressourcen \00FCberschreiten. \00C4ndern Sie die Berichteinstellungen, und wiederholen Sie den Vorgang.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111026567399136)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'de'
,p_message_text=>unistr('Die maximale Anzahl der Zeilen f\00FCr diesen Bericht ist %0. Wenden Sie einen Filter an, um die Anzahl der Datens\00E4tze in der Abfrage zu reduzieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211994855399209)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'de'
,p_message_text=>'Maximum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212155573399209)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'de'
,p_message_text=>'Medianwert %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115023786399139)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212029132399209)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'de'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211055457399208)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'de'
,p_message_text=>'Monat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184502320399189)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'de'
,p_message_text=>'Monatlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127127230399147)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'de'
,p_message_text=>'Verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127067996399147)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238248027399228)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Die statische Regions-ID muss angegeben werden, da die Seite mehrere interaktive Berichte enth\00E4lt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095524460399125)
,p_name=>'APEXIR_NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122971614399144)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'de'
,p_message_text=>'Neue Aggregation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233944434399225)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'de'
,p_message_text=>'Neue Kategorie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111123010016399145)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'de'
,p_message_text=>'Neue Berechnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117890590399141)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120921901399143)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chster Tag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120721668399143)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste Stunde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121274113399143)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chster Monat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121100089399143)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste Woche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121045717399143)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Tage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111120877946399143)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Stunden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121413096399143)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chste %0 Jahre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121345876399143)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chstes Jahr')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095822822399125)
,p_name=>'APEXIR_NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136122864399154)
,p_name=>'APEXIR_NONE'
,p_message_language=>'de'
,p_message_text=>'- Kein Wert -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183772881399189)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'de'
,p_message_text=>unistr('Keine g\00FCltige E-Mail-Adresse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132652169399151)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'de'
,p_message_text=>'Nullwerte immer am Anfang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132515406399151)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'de'
,p_message_text=>'Nullwerte immer am Ende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133083787399152)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'de'
,p_message_text=>'Keine Sortierung %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129429689399149)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'de'
,p_message_text=>'Flashback-Zeit muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129075680399149)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz muss numerisch sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133547903399152)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'de'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094443622399124)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'de'
,p_message_text=>'orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203324927399203)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'de'
,p_message_text=>'Ausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096356652399125)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'de'
,p_message_text=>'Weitere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079107761399113)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'de'
,p_message_text=>'Seitenausrichtung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079801143399114)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'de'
,p_message_text=>'Querformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079947133399114)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'de'
,p_message_text=>'Hochformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079045949399113)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Seitengr\00F6\00DFe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079637109399113)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'de'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079507925399113)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'de'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079718001399113)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079333499399113)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'de'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079287604399113)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'de'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111079435075399113)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'de'
,p_message_text=>'Tabloid'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212478918399209)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz der Gesamtanzahl %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211698569399209)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz der Gesamtsumme %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210648222399208)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz der Gesamtanzahl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210556419399208)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'de'
,p_message_text=>'Prozentsatz der Gesamtsumme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099982863399128)
,p_name=>'APEXIR_PIE'
,p_message_language=>'de'
,p_message_text=>'Tortendiagramm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159826428399172)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'de'
,p_message_text=>'Pivotieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161397358399173)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Aggregat muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161562368399173)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen keine Spalte aggregieren, die als Zeilenspalte ausgew\00E4hlt ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160782397399172)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Pivot-Spalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160506319399172)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'de'
,p_message_text=>'Pivot-Spalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161168699399172)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Pivot-Spalte muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061248329399100)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'de'
,p_message_text=>unistr('Die maximale Zeilenanzahl f\00FCr eine "Pivot"-Abfrage begrenzt die Anzahl der Zeilen in der Basisabfrage, aber nicht die Anzahl der angezeigten Zeilen. Die Basisabfrage \00FCberschreitet die maximale Zeilenanzahl von %0. Wenden Sie einen Filter an, um die A')
||unistr('nzahl der Datens\00E4tze in der Basisabfrage zu reduzieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161054903399172)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'de'
,p_message_text=>'Pivot-Sortierung'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130443452399150)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'de'
,p_message_text=>unistr('Die Pivot-Spalte enth\00E4lt zu viele eindeutige Werte. Pivot-SQL kann nicht generiert werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183840069399189)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'de'
,p_message_text=>'Vorschau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117935387399141)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111209520274399207)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184885383399190)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'de'
,p_message_text=>'Hauptbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078974087399113)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'de'
,p_message_text=>'Barrierefreiheitstags einbeziehen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065869165399103)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'de'
,p_message_text=>'Rich Text entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142650874399159)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'de'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100579544399128)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'de'
,p_message_text=>unistr('\00D6ffentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096157631399125)
,p_name=>'APEXIR_RED'
,p_message_language=>'de'
,p_message_text=>'rot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238112171399228)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Statische Regions-ID %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127277263399148)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'de'
,p_message_text=>'Entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127346519399148)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233490614399224)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126874823399147)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'de'
,p_message_text=>'Kontrollgruppenwechsel entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126501650399147)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'de'
,p_message_text=>'Filter entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126690122399147)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'de'
,p_message_text=>'Flashback entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233508488399224)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'de'
,p_message_text=>'"Gruppieren nach" entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126949678399147)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'de'
,p_message_text=>'Markierung entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233601302399225)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'de'
,p_message_text=>'Pivot entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214617343399211)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht entfernen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195236589399197)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'de'
,p_message_text=>'Standardbericht umbenennen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136465836399154)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht umbenennen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118297380399141)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212508453399209)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'de'
,p_message_text=>'Berichte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092702607399123)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Gespeicherter interaktiver Bericht mit Alias %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142906999399159)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Bericht ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092847394399123)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'ID des gespeicherten interaktiven Berichts %0 ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111134742213399153)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'de'
,p_message_text=>'Berichtseinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115576284399139)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'de'
,p_message_text=>'Berichtsansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119423295399142)
,p_name=>'APEXIR_RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCcksetzen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100763877399129)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Stellen Sie die Standardeinstellungen f\00FCr den Bericht wieder her.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095999325399125)
,p_name=>'APEXIR_ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208654462399206)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen ROWID nicht als Prim\00E4rschl\00FCsselspalte f\00FCr eine REST-Datenquelle verwenden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125909162399147)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185504541399190)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'de'
,p_message_text=>'Zeilen pro Seite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160886975399172)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Zeilenspalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160651518399172)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'de'
,p_message_text=>'Zeilenspalte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161200215399173)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Zeilenspalte muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161435518399173)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'de'
,p_message_text=>'Zeilenspalte darf nicht identisch mit der Pivot-Spalte sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140046491399157)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'de'
,p_message_text=>'Zeilenfilter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115637837399139)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'de'
,p_message_text=>'Zeile %0 von %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119627143399142)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilentext enth\00E4lt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095282288399125)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'de'
,p_message_text=>'Speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130098999399150)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'de'
,p_message_text=>'Gespeicherter Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129913000399150)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'de'
,p_message_text=>'Gespeicherter Bericht = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132171277399151)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'de'
,p_message_text=>unistr('Die aktuellen Berichteinstellungen werden als Standard f\00FCr alle Benutzer verwendet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111195130010399197)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'de'
,p_message_text=>'Standardbericht speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111119359573399142)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht speichern'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233825273399225)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Bericht speichern *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186599449399191)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111124855452399146)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'de'
,p_message_text=>'Suchleiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111233764950399225)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Suchen: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192057048399195)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'de'
,p_message_text=>'Suchbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176083974399183)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Ausgew\00E4hlte Spalten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096995478399126)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('- Spalte ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118663823399141)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100431939399128)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('- Funktion ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125665548399146)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('- Gruppe nach Spalte ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160370291399172)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('- Pivot-Spalte ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211526737399209)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160496497399172)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('- Zeilenspalte ausw\00E4hlen -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069118042399106)
,p_name=>'APEXIR_SEND'
,p_message_language=>'de'
,p_message_text=>'Senden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075426102399110)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'de'
,p_message_text=>'Als E-Mail senden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095656307399125)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'de'
,p_message_text=>'Sequenz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118868161399142)
,p_name=>'APEXIR_SORT'
,p_message_language=>'de'
,p_message_text=>'Sortieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128156480399148)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'de'
,p_message_text=>'Aufsteigend sortieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128241201399148)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'de'
,p_message_text=>'Absteigend sortieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214092879399210)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'de'
,p_message_text=>'Sortierreihenfolge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122648213399144)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'de'
,p_message_text=>'Leerzeichen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133770221399152)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'de'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184288063399189)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210965851399208)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'de'
,p_message_text=>'Bis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065391800399103)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberspringen, wenn keine Daten gefunden werden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111210842096399208)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'de'
,p_message_text=>'Ab'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211706190399209)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'de'
,p_message_text=>'Summe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201728905399202)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'de'
,p_message_text=>'Region = %0, Bericht = %1, Ansicht = %2, Angezeigte Zeilen Start = %3, Angezeigte Zeilen Ende = %4, Zeilen insgesamt = %5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122302901399144)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'de'
,p_message_text=>'Region = %0, Bericht = %1, Ansicht = %2, Angezeigte Zeilen Start = %3, Angezeigte Zeilen Ende = %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094509117399124)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'de'
,p_message_text=>'Textfarbe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111635292399136)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'de'
,p_message_text=>'Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111570806399136)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'de'
,p_message_text=>'Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111460578399136)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'de'
,p_message_text=>'Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111816360399136)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'de'
,p_message_text=>'Monate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111786053399136)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'de'
,p_message_text=>'Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111111978148399137)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'de'
,p_message_text=>'Jahre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111214487438399211)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'de'
,p_message_text=>'Umschalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127427653399148)
,p_name=>'APEXIR_TOP'
,p_message_language=>'de'
,p_message_text=>'Oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207670701399206)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Nicht gruppierte Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128974604399149)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'de'
,p_message_text=>'Markierungsname muss eindeutig sein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099275581399127)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht unterst\00FCtzter Datentyp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127552042399148)
,p_name=>'APEXIR_UP'
,p_message_language=>'de'
,p_message_text=>'Nach oben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129180558399149)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine g\00FCltige Farbe ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129222284399149)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'de'
,p_message_text=>unistr('Geben Sie eine g\00FCltige Formatmaske ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111096457882399125)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'de'
,p_message_text=>'Wert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111128083413399148)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'de'
,p_message_text=>unistr('Achsenbeschriftung f\00FCr Wert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135870732399154)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Wert erforderlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099816793399128)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'de'
,p_message_text=>'Vertikale Spalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111203593486399203)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'de'
,p_message_text=>'Vertikal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135130436399153)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'de'
,p_message_text=>'Diagramm anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190318682399193)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'de'
,p_message_text=>'Details anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111235949134399226)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr den Bericht ist keine %0-Ansicht definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190479640399194)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'de'
,p_message_text=>'"Gruppieren nach" anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190222114399193)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'de'
,p_message_text=>'Symbole anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160189513399172)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'de'
,p_message_text=>'Pivot anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111135260905399153)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184468221399189)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'de'
,p_message_text=>unistr('W\00F6chentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118183693399141)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'de'
,p_message_text=>'Arbeitsbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213187565399210)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'de'
,p_message_text=>'%0 Tage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213054452399210)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'de'
,p_message_text=>'%0 Stunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111212999920399210)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'de'
,p_message_text=>'%0 Minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213398402399210)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'de'
,p_message_text=>'%0 Monate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213282822399210)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'de'
,p_message_text=>'%0 Wochen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111213476415399210)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'de'
,p_message_text=>'%0 Jahre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111211176637399208)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'de'
,p_message_text=>'Jahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111094297821399124)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'de'
,p_message_text=>'gelb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111095755908399125)
,p_name=>'APEXIR_YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111127874580399148)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'de'
,p_message_text=>unistr('%0 enth\00E4lt < oder >. Dies sind ung\00FCltige Zeichen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111150626961399165)
,p_name=>'APEX_REGION'
,p_message_language=>'de'
,p_message_text=>'Region'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111078874855399113)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'de'
,p_message_text=>'API-Vorbedingung verletzt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098313112399127)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'de'
,p_message_text=>unistr('Wert f\00FCr Anwendungseinstellung %0 kann nicht abgerufen werden, da die zugeh\00F6rige Erstelloption deaktiviert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098220225399127)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'de'
,p_message_text=>unistr('Wert f\00FCr Anwendungseinstellung %0 kann nicht festgelegt werden, da die zugeh\00F6rige Erstelloption deaktiviert ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205966765399205)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'de'
,p_message_text=>unistr('Wert der Anwendungseinstellung %0 ist ung\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111205831004399204)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'de'
,p_message_text=>'Angeforderte Anwendungseinstellung %0 ist nicht definiert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206021672399205)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'de'
,p_message_text=>'Anwendungseinstellung %0 darf nicht auf einen Nullwert gesetzt werden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086932154399119)
,p_name=>'BACK'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073977703399109)
,p_name=>'BUILDER'
,p_message_language=>'de'
,p_message_text=>'Builder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138065648399155)
,p_name=>'BUTTON LABEL'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chenlabel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073006178399109)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'de'
,p_message_text=>unistr('Schaltfl\00E4chen-CSS-Klassen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102262209399130)
,p_name=>'BUTTON_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Generierte Schaltfl\00E4chen-ID ist die statische ID der Schaltfl\00E4che sofern definiert. Sonst handelt es sich um eine intern generierte ID im Format ''B'' || [Interne Schaltfl\00E4chen-ID]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065787513399103)
,p_name=>'CANDLESTICK'
,p_message_language=>'de'
,p_message_text=>'Kerzendiagramm'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147273926399162)
,p_name=>'CENTER'
,p_message_language=>'de'
,p_message_text=>'Mitte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097265708399126)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'de'
,p_message_text=>'%0-Anforderung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088624582399120)
,p_name=>'CHECK$'
,p_message_language=>'de'
,p_message_text=>'Zeilenselektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111207756529399206)
,p_name=>'CHECKED'
,p_message_language=>'de'
,p_message_text=>'aktiviert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183217131399188)
,p_name=>'COLUMN'
,p_message_language=>'de'
,p_message_text=>'Spalte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143732351399160)
,p_name=>'COMMENTS'
,p_message_language=>'de'
,p_message_text=>'Kommentare'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125282155399146)
,p_name=>'CONTINUE'
,p_message_language=>'de'
,p_message_text=>'Fortfahren'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087203288399119)
,p_name=>'COPYRIGHT'
,p_message_language=>'de'
,p_message_text=>'Copyright &copy; %0, Oracle und/oder verbundene Unternehmen. All rights reserved. Alle Rechte vorbehalten.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130909091399150)
,p_name=>'COUNT'
,p_message_language=>'de'
,p_message_text=>'Anzahl'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137684053399155)
,p_name=>'CREATE'
,p_message_language=>'de'
,p_message_text=>'Erstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189964298399193)
,p_name=>'CREATED'
,p_message_language=>'de'
,p_message_text=>'Erstellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190079081399193)
,p_name=>'CREATED_BY'
,p_message_language=>'de'
,p_message_text=>'Erstellt von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114861401399139)
,p_name=>'CREATED_ON'
,p_message_language=>'de'
,p_message_text=>'Erstellt am'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125449950399146)
,p_name=>'CUSTOM'
,p_message_language=>'de'
,p_message_text=>'Benutzerdefiniert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136684264399154)
,p_name=>'CUSTOMIZE'
,p_message_language=>'de'
,p_message_text=>'Anpassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138223484399155)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenvoreinstellungen f\00FCr Benutzer %0 wurden zur\00FCckgesetzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138362667399156)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Voreinstellungen f\00FCr Benutzer %0 ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138163779399155)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenvoreinstellungen f\00FCr Benutzer %0 wurden zur\00FCckgesetzt.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101915733399129)
,p_name=>'DAILY'
,p_message_language=>'de'
,p_message_text=>unistr('T\00E4glich')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111073578182399109)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Die hochgeladene Datei ist ung\00FCltig oder hat die falsche Erweiterung.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097408602399126)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger XML- oder JSON-Selektor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066726682399104)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Datenprofil und hochgeladene Datei enthalten keine Zieltabellenspalte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152465727399166)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'de'
,p_message_text=>'Keine Daten in hochgeladener Datei gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152594440399166)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'de'
,p_message_text=>'Keine Daten in Arbeitsblatt "%0" gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111072311251399108)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'de'
,p_message_text=>'Die angegebene Datei ist keine XLSX-Datei.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111062798807399101)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'de'
,p_message_text=>'Datenladevorgang abgeschlossen: %0 Zeilen verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063990425399102)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'de'
,p_message_text=>'Datenladevorgang abgeschlossen: %0 Zeilen mit 1 Fehler verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064254101399102)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'de'
,p_message_text=>'Datenladevorgang abgeschlossen: %0 Zeilen mit %1 Fehlern verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064057486399102)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'de'
,p_message_text=>'Datenladevorgang abgeschlossen: 1 Zeile verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067027288399104)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'de'
,p_message_text=>'Datenladevorgang abgeschlossen: 1 Zeile mit Fehler verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064186539399102)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'de'
,p_message_text=>'Datenladevorgang abgeschlossen: 1 Zeile ohne Fehler verarbeitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157799250399170)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'de'
,p_message_text=>'Zielspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157887049399170)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'de'
,p_message_text=>'Quellspalte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158649160399171)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'de'
,p_message_text=>'Datums-/Zahlenformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222061529399216)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'de'
,p_message_text=>'Lookup-Wert konnte nicht abgerufen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111190506635399194)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'de'
,p_message_text=>'Daten-/Tabellenzuordnung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158772755399171)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154266333399167)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'de'
,p_message_text=>'Die Transformationsregel war nicht erfolgreich'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130533860399150)
,p_name=>'DATE'
,p_message_language=>'de'
,p_message_text=>'Datum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104622079399131)
,p_name=>'DAY'
,p_message_language=>'de'
,p_message_text=>'Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104780064399131)
,p_name=>'DAYS'
,p_message_language=>'de'
,p_message_text=>'Tage'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143432382399159)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'de'
,p_message_text=>unistr('Debugging ist f\00FCr diese Anwendung nicht aktiviert.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111192224504399195)
,p_name=>'DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standardwert'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105496094399132)
,p_name=>'DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('l\00F6schen')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111065666276399103)
,p_name=>'DIAL_PCT'
,p_message_language=>'de'
,p_message_text=>'Dial (Prozent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080117341399114)
,p_name=>'DOWNLOAD'
,p_message_language=>'de'
,p_message_text=>'Herunterladen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191371921399194)
,p_name=>'DUP_USER'
,p_message_language=>'de'
,p_message_text=>'Doppelter Benutzername in Liste.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087701472399119)
,p_name=>'EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097189604399126)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Adresse "%0" wurde nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082249515399115)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'de'
,p_message_text=>'Diese E-Mail wurde von %0 gesendet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191589666399194)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Die E-Mail-Adresse ist zu lang. Sie darf h\00F6chstens 240 Zeichen enthalten.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125119283399146)
,p_name=>'ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154367268399167)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'de'
,p_message_text=>'Der Seitenelement-Quellwert zur Aktualisierung der Seitenbestandteil-Region kann nicht festgelegt werden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116602427399140)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'de'
,p_message_text=>'Erstellt von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082559111399115)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'de'
,p_message_text=>'Kennwort abgelaufen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111076662720399111)
,p_name=>'FILE_EMPTY'
,p_message_language=>'de'
,p_message_text=>'Die Datei ist leer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156881333399169)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'de'
,p_message_text=>unistr('Die hochgeladene Datei war gr\00F6\00DFer als %0 MB. Laden Sie eine kleinere Datei hoch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084609955399117)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'de'
,p_message_text=>'Benutzerauthentifizierung war nicht erfolgreich. Mindestens eine Datei wurde nicht hochgeladen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084761863399117)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Instanz l\00E4sst das Hochladen von Dateien durch nicht authentifiziere Benutzer nicht zu.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137775056399155)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'de'
,p_message_text=>'1 Fehler aufgetreten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136981069399155)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'de'
,p_message_text=>'%0 Fehler sind aufgetreten'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087189523399119)
,p_name=>'FORM_OF'
,p_message_language=>'de'
,p_message_text=>'%0 von %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121837537399144)
,p_name=>'GO'
,p_message_language=>'de'
,p_message_text=>'Los'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221654031399216)
,p_name=>'HELP'
,p_message_language=>'de'
,p_message_text=>'Hilfe'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074055341399109)
,p_name=>'HOME'
,p_message_language=>'de'
,p_message_text=>'Home'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104466777399131)
,p_name=>'HOUR'
,p_message_language=>'de'
,p_message_text=>'Stunde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104572276399131)
,p_name=>'HOURS'
,p_message_language=>'de'
,p_message_text=>'Stunden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088533952399120)
,p_name=>'ICON'
,p_message_language=>'de'
,p_message_text=>'Symbol %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138566975399156)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Anmeldedaten')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111238051004399228)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Wert f\00FCr Parameter: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133254243399152)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'de'
,p_message_text=>'Als Standardberichteinstellungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133361353399152)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'de'
,p_message_text=>'Als benannter Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115727615399139)
,p_name=>'IR_ERROR'
,p_message_language=>'de'
,p_message_text=>'%0 Fehler. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115473512399139)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Formularnavigation berechnen nicht m\00F6glich. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093003249399123)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Interaktiver Bericht nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092430628399123)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Interaktive Berichtsregion ist nicht in Anwendung %0, Seite %1 und Region %2 vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111133125228399152)
,p_name=>'IR_STAR'
,p_message_language=>'de'
,p_message_text=>unistr('Wird nur f\00FCr Entwickler angezeigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121505951399143)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die Berichtsabfrage ist ein eindeutiger Schl\00FCssel zur Identifizierung der einzelnen Zeilen erforderlich. Der bereitgestellte Schl\00FCssel kann f\00FCr diese Abfrage nicht verwendet werden. Definieren Sie eine Spalte f\00FCr den eindeutigen Schl\00FCssel. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121686779399144)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr die Berichtsabfrage ist ein eindeutiger Schl\00FCssel zur Identifizierung der einzelnen Zeilen erforderlich. Der bereitgestellte Schl\00FCssel kann f\00FCr diese Abfrage nicht verwendet werden. Bearbeiten Sie die Berichtsattribute, um eine Spalte f\00FCr den ein')
||unistr('deutigen Schl\00FCssel zu definieren. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158954863399171)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158817677399171)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'de'
,p_message_text=>'Datei per Drag-and-Drop hier ablegen oder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087481348399119)
,p_name=>'ITEMS'
,p_message_language=>'de'
,p_message_text=>'Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116827538399140)
,p_name=>'ITEM_VALUE'
,p_message_language=>'de'
,p_message_text=>'Elementwert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131214478399150)
,p_name=>'LABEL'
,p_message_language=>'de'
,p_message_text=>'Label'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143318579399159)
,p_name=>'LANGUAGE'
,p_message_language=>'de'
,p_message_text=>'Sprache'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105160370399132)
,p_name=>'LAST'
,p_message_language=>'de'
,p_message_text=>'letzte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084531754399117)
,p_name=>'LENGTH'
,p_message_language=>'de'
,p_message_text=>unistr('L\00E4nge')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137826828399155)
,p_name=>'LOGIN'
,p_message_language=>'de'
,p_message_text=>'Anmeldung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176468131399183)
,p_name=>'MANAGE'
,p_message_language=>'de'
,p_message_text=>'Verwalten'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241037531399230)
,p_name=>'MAXIMIZE'
,p_message_language=>'de'
,p_message_text=>'Maximieren'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104212088399131)
,p_name=>'MINUTE'
,p_message_language=>'de'
,p_message_text=>'Minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104310904399131)
,p_name=>'MINUTES'
,p_message_language=>'de'
,p_message_text=>'Minuten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191749808399194)
,p_name=>'MISSING_AT'
,p_message_language=>'de'
,p_message_text=>'Fehlendes "@" in E-Mail-Adresse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191957905399195)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'de'
,p_message_text=>unistr('Warnung: Es wurde kein Dialogseiten-Template f\00FCr Dialogseite %0 in Anwendung %1 definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191687948399194)
,p_name=>'MISSING_DOT'
,p_message_language=>'de'
,p_message_text=>'Fehlender "." in E-Mail-Adressendomain.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140869940399157)
,p_name=>'MODULE'
,p_message_language=>'de'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097920233399126)
,p_name=>'MONTH'
,p_message_language=>'de'
,p_message_text=>'Monat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101717842399129)
,p_name=>'MONTHLY'
,p_message_language=>'de'
,p_message_text=>'Monatlich'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098025000399127)
,p_name=>'MONTHS'
,p_message_language=>'de'
,p_message_text=>'Monate'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130831336399150)
,p_name=>'MOVE'
,p_message_language=>'de'
,p_message_text=>'Verschieben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198376845399199)
,p_name=>'MOVE_FROM'
,p_message_language=>'de'
,p_message_text=>'Verschieben von'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198402143399199)
,p_name=>'MOVE_TO'
,p_message_language=>'de'
,p_message_text=>'Verschieben nach'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111118065282399141)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim L\00F6schvorgang f\00FCr mehrere Zeilen: Zeile= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117008888399140)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Darf kein \00F6ffentlicher Benutzer sein')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074256843399110)
,p_name=>'NAME'
,p_message_language=>'de'
,p_message_text=>'Name'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131036047399150)
,p_name=>'NEW'
,p_message_language=>'de'
,p_message_text=>'Neu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097753630399126)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen sich bei %0 anmelden \00FCber:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097841000399126)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Benachrichtigung \00FCber neuen %0-Account')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221805657399216)
,p_name=>'NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140771966399157)
,p_name=>'NO'
,p_message_language=>'de'
,p_message_text=>'Nein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111236012179399226)
,p_name=>'NOBODY'
,p_message_language=>'de'
,p_message_text=>'niemand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105565492399132)
,p_name=>'NOT'
,p_message_language=>'de'
,p_message_text=>'Nicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146349091399161)
,p_name=>'NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Ungleich Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117165660399140)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'de'
,p_message_text=>'Nicht %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136799553399154)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'de'
,p_message_text=>'Keine Daten gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145874550399161)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Kein aktualisierbarer Bericht gefunden. Mehrzeilige Aktualisierungs- und L\00F6schvorg\00E4nge k\00F6nnen nur auf tabellarischen Formularen vom Typ "Aktualisierbarer Bericht" ausgef\00FChrt werden.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146769167399162)
,p_name=>'OK'
,p_message_language=>'de'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142492027399159)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'de'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111239898750399229)
,p_name=>'ORA_06550'
,p_message_language=>'de'
,p_message_text=>'ORA-06550: Zeile %0, Spalte %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189393223399193)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'de'
,p_message_text=>unistr('Sie verwenden einen veralteten Webbrowser. Eine Liste der unterst\00FCtzten Browser finden Sie im Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090730361399121)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Zeilenmenge angefordert, die Quelldaten des Berichts wurden ge\00E4ndert.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110837288399136)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Es muss eine g\00FCltige Seitennummer angegeben werden. Beispiel: p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114456826399138)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'de'
,p_message_text=>'Weiter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114576234399138)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'de'
,p_message_text=>unistr('N\00E4chstes Set')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114655888399139)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111114715703399139)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'de'
,p_message_text=>'Vorheriges Set'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221769837399216)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'de'
,p_message_text=>unistr('Paginierung ausw\00E4hlen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152354974399166)
,p_name=>'PASSWORD'
,p_message_language=>'de'
,p_message_text=>'Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097013982399126)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Ihr Kennwort f\00FCr %0 wurde ge\00E4ndert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086865869399119)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('Das Kennwort entspricht nicht den Komplexit\00E4tsregeln f\00FCr Kennw\00F6rter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085956574399118)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'de'
,p_message_text=>'Das neue Kennwort muss sich vom alten Kennwort um mindestens %0 Zeichen unterscheiden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086509708399118)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Kennwort darf nicht den Benutzernamen enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086759878399118)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Das Kennwort enth\00E4lt ein nicht zul\00E4ssiges einfaches Wort.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086633289399118)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Kennwort darf nicht den Workspace-Namen enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085816968399118)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Kennwort muss mindestens %0 Zeichen enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086074652399118)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Kennwort muss mindestens einen Buchstaben (%0) enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086451903399118)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Kennwort muss mindestens ein Zeichen in Kleinbuchstaben enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086189818399118)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Kennwort muss mindestens einen numerischen Wert (0123456789) enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086229378399118)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'de'
,p_message_text=>'Das Kennwort muss mindestens ein Interpunktionszeichen (%0) enthalten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111086305759399118)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Das Kennwort muss mindestens ein Zeichen in Gro\00DFbuchstaben enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097598037399126)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Benachrichtigung \00FCber Zur\00FCcksetzen des Kennworts')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084815491399117)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'de'
,p_message_text=>'Dieses Kennwort kann nicht verwendet werden, da es in den letzten %0 Tagen verwendet wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165106313399175)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'de'
,p_message_text=>'Elemente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111165212404399175)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'de'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142298849399158)
,p_name=>'PERCENT'
,p_message_language=>'de'
,p_message_text=>'Prozent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112535981399137)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'de'
,p_message_text=>'Wenden Sie sich an den Administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111221939012399216)
,p_name=>'PREVIOUS'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157369127399170)
,p_name=>'PRINT'
,p_message_language=>'de'
,p_message_text=>'Drucken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141017879399158)
,p_name=>'PRIVILEGES'
,p_message_language=>'de'
,p_message_text=>'Berechtigungen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110992001399136)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'de'
,p_message_text=>'Regionsreferenzen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131129817399150)
,p_name=>'REPORT'
,p_message_language=>'de'
,p_message_text=>'Bericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140936498399157)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'de'
,p_message_text=>'Berichtszeitraum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222125192399216)
,p_name=>'REPORT_LABEL'
,p_message_language=>'de'
,p_message_text=>'Bericht: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141678284399158)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'de'
,p_message_text=>'Bericht Summe'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090868791399121)
,p_name=>'RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Seitennummerierung zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116737914399140)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'de'
,p_message_text=>unistr('Seitennummerierung zur\00FCcksetzen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145777761399161)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'de'
,p_message_text=>unistr('Kennwort zur\00FCcksetzen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122523235399144)
,p_name=>'RESTORE'
,p_message_language=>'de'
,p_message_text=>'Wiederherstellen'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111154480698399167)
,p_name=>'RESULTS'
,p_message_language=>'de'
,p_message_text=>'Ergebnisse'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146877220399162)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Zur\00FCck zur Anwendung.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111147153302399162)
,p_name=>'RIGHT'
,p_message_language=>'de'
,p_message_text=>'Rechts'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176791257399184)
,p_name=>'ROW'
,p_message_language=>'de'
,p_message_text=>'Zeile %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130707270399150)
,p_name=>'ROW_COUNT'
,p_message_language=>'de'
,p_message_text=>'Zeilenanzahl'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111146258072399161)
,p_name=>'SAVE'
,p_message_language=>'de'
,p_message_text=>'Speichern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142888064399159)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Alternativer Standardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143250914399159)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'de'
,p_message_text=>'Beschreibung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142748095399159)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'de'
,p_message_text=>unistr('Prim\00E4rer Standardwert')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143567879399159)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Es sind mehr als %0 Zeilen verf\00FCgbar. Erh\00F6hen Sie den Zeilenselektor, um weitere Zeilen anzuzeigen.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208994811399207)
,p_name=>'SEARCH'
,p_message_language=>'de'
,p_message_text=>'Suche'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104110118399131)
,p_name=>'SECONDS'
,p_message_language=>'de'
,p_message_text=>'Sekunden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142316731399158)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'de'
,p_message_text=>'Siehe Anhang'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200080762399200)
,p_name=>'SELECT_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile ausw\00E4hlen')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142035598399158)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'de'
,p_message_text=>'Modus Bildschirmsprachausgabe deaktivieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142177433399158)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'de'
,p_message_text=>'Modus Bildschirmsprachausgabe aktivieren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138425208399156)
,p_name=>'SHOW'
,p_message_language=>'de'
,p_message_text=>'Anzeigen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201809443399202)
,p_name=>'SHOW_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle anzeigen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111227933773399220)
,p_name=>'SIGN_IN'
,p_message_language=>'de'
,p_message_text=>'Anmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111177585099399184)
,p_name=>'SIGN_OUT'
,p_message_language=>'de'
,p_message_text=>'Abmelden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131715471399151)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Tagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138910633399156)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'%0 Tage ab jetzt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131658560399151)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Stunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138844196399156)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'%0 Stunden ab jetzt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131561270399151)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138771332399156)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'%0 Minuten ab jetzt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131985429399151)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Monaten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139134798399156)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'%0 Monate ab jetzt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139311838399156)
,p_name=>'SINCE_NOW'
,p_message_language=>'de'
,p_message_text=>'Jetzt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131432868399151)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Sekunden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111138620803399156)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'%0 Sekunden ab jetzt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111131883778399151)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Wochen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139049641399156)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'%0 Wochen ab jetzt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111132055718399151)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'de'
,p_message_text=>'vor %0 Jahren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139292345399156)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'de'
,p_message_text=>'%0 Jahre ab jetzt'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125581451399146)
,p_name=>'STANDARD'
,p_message_language=>'de'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141923227399158)
,p_name=>'START_DATE'
,p_message_language=>'de'
,p_message_text=>'Startdatum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082414611399115)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'de'
,p_message_text=>'Sie erhalten diese E-Mail vom Abonnement zu interaktiven Berichten, das von %0 erstellt wurde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237125425399227)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'de'
,p_message_text=>'Abonnements'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185274386399190)
,p_name=>'TAB'
,p_message_language=>'de'
,p_message_text=>'Registerkarte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104004689399131)
,p_name=>'TITLE'
,p_message_language=>'de'
,p_message_text=>'Titel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087067568399119)
,p_name=>'TODAY'
,p_message_language=>'de'
,p_message_text=>'Heute'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141594448399158)
,p_name=>'TOTAL'
,p_message_language=>'de'
,p_message_text=>'Gesamt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088081404399119)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Es k\00F6nnen maximal %0 Spalten ausgew\00E4hlt werden.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066555641399104)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle ausblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066851794399104)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'de'
,p_message_text=>'Alles unten ausblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066409061399104)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle einblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066680852399104)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'de'
,p_message_text=>'Alles unten einblenden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066904602399104)
,p_name=>'TREE.REPARENT'
,p_message_language=>'de'
,p_message_text=>'Neu zuordnen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159192830399171)
,p_name=>'TREES'
,p_message_language=>'de'
,p_message_text=>'Baumstrukturen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111202693259399202)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Erforderlich'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111126286840399147)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'de'
,p_message_text=>'Nicht autorisiert'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111173036682399181)
,p_name=>'UNAVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht verf\00FCgbar')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139749893399157)
,p_name=>'UNKNOWN'
,p_message_language=>'de'
,p_message_text=>'Unbekannt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083381405399116)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'de'
,p_message_text=>'Ein unbekannter Authentifizierungsfehler ist aufgetreten.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085394539399117)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie keine weiteren E-Mails erhalten m\00F6chten, klicken Sie auf <a href="%0">Abonnement k\00FCndigen</a>, um Ihr Abonnement zu verwalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111082365289399115)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn Sie keine weiteren E-Mails erhalten m\00F6chten, gehen Sie zur folgenden URL, um Ihr Abonnement zu verwalten:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111117293090399140)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Nicht unterst\00FCtzter Datentyp')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105372001399132)
,p_name=>'UPDATE'
,p_message_language=>'de'
,p_message_text=>'aktualisieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103974084399131)
,p_name=>'UPDATED'
,p_message_language=>'de'
,p_message_text=>'Aktualisiert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110639284399136)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'de'
,p_message_text=>unistr('Der angeforderte URL ist nicht zul\00E4ssig. Wenden Sie sich an den Administrator.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111130645086399150)
,p_name=>'USER'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111152202009399166)
,p_name=>'USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191884686399195)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'de'
,p_message_text=>unistr('Benutzername ist zu lang. Er darf h\00F6chstens %0 Zeichen enthalten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137496350399155)
,p_name=>'USERS'
,p_message_language=>'de'
,p_message_text=>'Benutzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111191472330399194)
,p_name=>'USER_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Benutzername ist bereits vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111206178220399205)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Profilbild f\00FCr Benutzer %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093781989399124)
,p_name=>'VALID'
,p_message_language=>'de'
,p_message_text=>unistr('G\00FCltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087343534399119)
,p_name=>'VALIDATIONS'
,p_message_language=>'de'
,p_message_text=>'Validierungen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143091390399159)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'de'
,p_message_text=>'Wert muss angegeben werden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186470097399191)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'de'
,p_message_text=>unistr('Wert muss f\00FCr %0 angegeben werden')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112975036399137)
,p_name=>'VERTICAL'
,p_message_language=>'de'
,p_message_text=>'vertikal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105265683399132)
,p_name=>'VIEW'
,p_message_language=>'de'
,p_message_text=>'Ansicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137500505399155)
,p_name=>'VIEWS'
,p_message_language=>'de'
,p_message_text=>'Ansichten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143852422399160)
,p_name=>'VIEW_ALL'
,p_message_language=>'de'
,p_message_text=>'Alle anzeigen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111125048999399146)
,p_name=>'WARNING'
,p_message_language=>'de'
,p_message_text=>'Warnung'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104857280399131)
,p_name=>'WEEK'
,p_message_language=>'de'
,p_message_text=>'Woche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101853771399129)
,p_name=>'WEEKLY'
,p_message_language=>'de'
,p_message_text=>unistr('W\00F6chentlich')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111104901422399131)
,p_name=>'WEEKS'
,p_message_language=>'de'
,p_message_text=>'Wochen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111143115328399159)
,p_name=>'WELCOME_USER'
,p_message_language=>'de'
,p_message_text=>'Willkommen: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141397404399158)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Wert gefunden. \00DCberpr\00FCfen Sie die eingegebenen Daten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141494343399158)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Wert gefunden. \00DCberpr\00FCfen Sie die eingegebenen Daten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084416283399117)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Datumswert gefunden. \00DCberpr\00FCfen Sie das Datumsformat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111141261026399158)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Zahlenwert gefunden. \00DCberpr\00FCfen Sie das Zahlenformat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093307948399123)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Zeitstempelwert gefunden. \00DCberpr\00FCfen Sie das Zeitstempelformat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111115819979399139)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Binden von "%0 "nicht m\00F6glich. Verwenden Sie doppelte Anf\00FChrungszeichen f\00FCr Mehr-Byte-Elemente, oder pr\00FCfen Sie, ob die L\00E4nge des Elements maximal 30 Byte betr\00E4gt. Verwenden Sie die v()-Syntax, um Elemente zu referenzieren, die l\00E4nger sind als 30 Byt')
||'e. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106356654399133)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'de'
,p_message_text=>unistr('Zugriff von %0-Sicherheitspr\00FCfung verweigert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108813366399134)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Anwendungen nicht verf\00FCgbar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107278127399133)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1014 Anwendung nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107373675399133)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'de'
,p_message_text=>'Anwendung=%0  Workspace=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107734558399134)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'de'
,p_message_text=>unistr('Auf diese Anwendung d\00FCrfen nur bestimmte Benutzer zugreifen. F\00FChren Sie den Vorgang sp\00E4ter aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107664106399133)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'de'
,p_message_text=>unistr('Auf diese Anwendung d\00FCrfen nur Anwendungsentwickler zugreifen. F\00FChren Sie den Vorgang sp\00E4ter aus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106897969399133)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-7744 Verarbeiten URL von Verzweigung zu Seite f\00FCr die R\00FCckgabe der Funktion nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106750819399133)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-7744 Verarbeiten von Verzweigung zu Seite f\00FCr die R\00FCckgabe der Funktion nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107095445399133)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1430 Der Aufruf f\00FCr die Anzeige vom Seitenprozess wird nicht unterst\00FCtzt: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108139760399134)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1018 Fehler beim L\00F6schen von Schrittcacheinhalt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106548566399133)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1005 Unbekannter Berechnungstyp.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107456733399133)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'de'
,p_message_text=>'ERR-1201 Keine Session-ID bei benutzerdefinierter Authentifizierung festgelegt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107528183399133)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'de'
,p_message_text=>'Seite=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111107132940399133)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-7620 Bestimmen des Workspace f\00FCr die Anwendung (%0) nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089566782399120)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'de'
,p_message_text=>'Bearbeiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106293978399132)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'de'
,p_message_text=>'ERR-1802 Element-ID "%0" nicht gefunden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105982544399132)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1002 Element-ID f\00FCr Element "%0" in Anwendung "%1" nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106073398399132)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'de'
,p_message_text=>'Unerwarteter Fehler: Elementname auf Anwendungs- oder Seitenebene nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106455985399133)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'de'
,p_message_text=>'Sie befinden sich bereits auf der ersten Datenseite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111121942255399144)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'de'
,p_message_text=>'Element-ID (%0) ist kein Element, das auf der aktuellen Seite definiert ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084019419399117)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann nicht festgelegt werden, indem Argumente an die Anwendung \00FCbergeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084364339399117)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'de'
,p_message_text=>unistr('(Keine Pr\00FCfsumme angegeben)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083854819399116)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann festgelegt werden, wenn es von einer "user-level bookmark"-Pr\00FCfsumme begleitet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083743148399116)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann festgelegt werden, wenn es von einer "application-level bookmark"-Pr\00FCfsumme begleitet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083900576399116)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'de'
,p_message_text=>unistr('Das Element kann festgelegt werden, wenn es von einer "session"-Pr\00FCfsumme begleitet wird.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083659453399116)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'de'
,p_message_text=>unistr('Element ist nicht gesch\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108227726399134)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'de'
,p_message_text=>unistr('Kein Hilfetext f\00FCr die Seite verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111097384962399126)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'de'
,p_message_text=>'Der Workspace %0 hat keine Berechtigungen zum Parsen als Schema %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106651517399133)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1010 Rekursionsgrenzwert f\00FCr die Abnahme der Verarbeitung bei Verzweigung zu Seite \00FCberschritten. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084200718399117)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Seite kann nicht mit einer URL oder \00FCber einen GET- oder POST-Vorgang bei der show-Prozedur aufgerufen werden. Sie muss mit einer Verzweigung vom Typ "Verzweigung zu Seite" aufgerufen werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111160971363399172)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Speichern von nicht numerischem Wert im Element %0. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099092674399127)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Das Parsingschema "%0" der Anwendung ist nicht in der Datenbank vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111099127958399127)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'de'
,p_message_text=>unistr('Accounts im INTERNAL-Workspace k\00F6nnen nur verwendet werden, um auf &PRODUCT_NAME.-<a href="%0">Administrationsservices</a> zuzugreifen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105890080399132)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-1029 Speichern von Sessioninformationen nicht m\00F6glich. session=%0 item=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108996262399134)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'de'
,p_message_text=>'Trace konnte nicht gestoppt werden: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111106106422399132)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'de'
,p_message_text=>'Unerwarteter Fehler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116143742399140)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler in update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109001207399134)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Um die Hilfe anzeigen zu k\00F6nnen, m\00FCssen die Anwendung und die Seite angegeben werden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111129553963399149)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Automatisierung nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110188417399135)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'de'
,p_message_text=>unistr('%0 Sessions wurden gel\00F6scht.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069456411399106)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Code %0 kann nicht ausgef\00FChrt werden. Er wird von der Datenbank nicht unterst\00FCtzt oder wurde nicht durch den Instanzparameter MLE_LANGUAGES aktiviert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111069223074399106)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('Multi Lingual Engine ist in dieser Datenbankversion nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090023490399121)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Das Anwendungs-Collection-Array darf nicht Null sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089806992399121)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'de'
,p_message_text=>unistr('Die angegebene Mitgliedsattributnummer %0 ist ung\00FCltig.  Die Attributnummer muss zwischen 1 und %1 liegen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090378578399121)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-Collection ist vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090123239399121)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'de'
,p_message_text=>'Name der Collection darf nicht Null sein'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090251660399121)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'de'
,p_message_text=>'Der Collection-Name darf maximal 255 Zeichen enthalten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089689979399121)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Anwendungs-Collection %0 ist nicht vorhanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090417682399121)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'de'
,p_message_text=>unistr('Cursor ist noch nicht ge\00F6ffnet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089724647399121)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Die Mitgliedersequenz %0 ist in Anwendungs-Collection %1 nicht vorhanden',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111089989938399121)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Die Mitgliedersequenz %0 ist in Anwendungs-Collection %1 nicht vorhanden',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161793567399173)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Die kryptografische Funktion "%0" wird in diesem System nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215220666399211)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'de'
,p_message_text=>'Barrierefreiheit getestet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109690609399135)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'de'
,p_message_text=>unistr('Schlie\00DFen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109768581399135)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'de'
,p_message_text=>unistr('Optionen f\00FCr die Seitenanpassung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109875681399135)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'de'
,p_message_text=>'Standardwert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109999731399135)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'de'
,p_message_text=>'Angezeigt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110002107399135)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'de'
,p_message_text=>'Ausgeblendet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109423082399135)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'de'
,p_message_text=>unistr('Aktivieren Sie die Kontrollk\00E4stchen f\00FCr die Regionen, die in diese Seite aufgenommen werden sollen. Diese Regionen werden dann nur angezeigt, wenn Sie sich im richtigen Anwendungskontext befinden und \00FCber die geeigneten Berechtigungen verf\00FCgen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109586826399135)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'de'
,p_message_text=>'Diese Seite kann nicht angepasst werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215597653399211)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'de'
,p_message_text=>unistr('Sie k\00F6nnen die Darstellung dieser Anwendung personalisieren, indem Sie den Theme-Stil \00E4ndern. W\00E4hlen Sie einen Theme-Stil aus der Liste unten aus, und klicken Sie auf "\00C4nderungen anwenden".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111216322569399212)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'de'
,p_message_text=>'Bereichsanzeige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215452186399211)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'de'
,p_message_text=>'Standardstil der Anwendung verwenden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111215360226399211)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'de'
,p_message_text=>'Darstellung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158389921399170)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Der im Aggregat %0 referenzierte Spaltenindex ist nicht vorhanden. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111061608293399100)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('CLOB-Ausgabe wird f\00FCr %0-Format nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158028526399170)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'de'
,p_message_text=>'Der Spaltenumbruch muss am Anfang des Spalten-Arrays erfolgen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158129895399170)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Der in %0 referenzierte Spaltengruppenindex ist nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111075674856399111)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'de'
,p_message_text=>'Export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111080844780399114)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'de'
,p_message_text=>'Das Exportformat muss XML sein, und ORDS muss als Druckserver verwendet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158429147399170)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Der in der Markierung %0 referenzierte Spaltenindex ist nicht vorhanden. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074174989399110)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiges Exportformat: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111158264121399170)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>unistr('Der in %0 referenzierte \00FCbergeordnete Gruppenindex ist nicht vorhanden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111183420908399189)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Die Spalte "%1" der Tabelle "%0" ist eine Identit\00E4tsspalte vom Typ "GENERATED ALWAYS". Stellen Sie sicher, dass im Dialogfeld "Konfigurieren" der Spalte "%1" keine Quellspalte zugeordnet ist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100826167399129)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'de'
,p_message_text=>'Angegebenes Commit-Intervall ist zu klein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111100907752399129)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'de'
,p_message_text=>'Zum Laden von Daten wurden keine Spalten bereitgestellt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102166135399129)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Spalten f\00FCr Zeilenselektor "%0" gefunden. Verwenden Sie die automatische Erkennung, oder pr\00FCfen Sie die JSON-Struktur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110435865399135)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Arbeitsbl\00E4tter in XLSX-Datei gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110396027399135)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'de'
,p_message_text=>'Das angegebene Arbeitsblatt ist in der XLSX-Datei nicht vorhanden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111090580735399121)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'de'
,p_message_text=>unistr('Die aktuelle Version der Daten in der Datenbank wurde ge\00E4ndert, seit der Benutzer einen Update-Prozess eingeleitet hat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092909409399123)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Aktualisieren von Berichtsspalten: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197639442399199)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'de'
,p_message_text=>unistr('Konvertierung von %0 in SDO__GEOMETRY nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137177891399155)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'de'
,p_message_text=>'Spalte %0 mit dem Datentyp %1 kann nicht in VARCHAR2 konvertiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144111331399160)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte "%0", die f\00FCr Attribut "%1" angegeben ist, wurde in Datenquelle nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085461055399118)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'de'
,p_message_text=>unistr('Filtertyp %0 wird bei Spalten mit mehreren Werten nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111201096696399201)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger "zwischen"-Filter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067552984399105)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Wertelistentyp angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067465892399105)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Abfragetyp. Abfragetyp muss Tabelle, SQL-Abfrage oder PL/SQL-Funktion sein, die eine SQL-Abfrage zur\00FCckgibt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137235674399155)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'de'
,p_message_text=>'SQL-Abfrage konnte nicht geparst werden.  %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144287443399160)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Angegebene Spaltenposition "%0" f\00FCr Attribut "%1" wurde in SQL-Anweisung nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111066054924399104)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'de'
,p_message_text=>'Zu viele Elemente in Filter mit mehreren Werten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144026632399160)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Spalte f\00FCr Attribut "%0" angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067385866399105)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL-Funktionsbody hat keinen Wert zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111157251997399170)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'de'
,p_message_text=>unistr('Die REST-Datenquelle enth\00E4lt keinen Vorgang zur Verarbeitung der angeforderten DML-Aktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111063237946399102)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Die Konvertierung von GeoJSON in SDO_GEOMETRY (Spalte %0) ist in dieser Datenbank nicht verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064318357399102)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'de'
,p_message_text=>unistr('Die SDO_GEOMETRY-Konvertierung (Spalte %0) wird f\00FCr XML-Datenquellen nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111071681210399108)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'de'
,p_message_text=>unistr('Das Zeichen %0 wird nicht als Trennzeichen mehrerer Werte unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111198902905399200)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'de'
,p_message_text=>'Diese Funktion kann nicht als Abfragekontext verwendet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111064405135399102)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Spaltendatentyp stimmt nicht \00FCberein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067275699399104)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Interne ORDS OUT-Bind-Grenzwerte \00FCberschritten. Reduzieren Sie die Anzahl an DML-Zeilen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111145052482399161)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Die JSON-Antwort vom Remoteserver konnte nicht geparst werden: ',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111067144385399104)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'de'
,p_message_text=>'Unbekannter oder falscher Kontexttyp.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111161630283399173)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Dieser Dateityp wird vom Parser nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116254550399140)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'de'
,p_message_text=>'Unberechtigter Zugriff (wwv_flow_api.set_credentials nicht festgelegt).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093270295399123)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'de'
,p_message_text=>'Der Workspace konnte nicht erstellt werden, weil dieser bereits vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111093152572399123)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'de'
,p_message_text=>'Die Benutzergruppe konnte nicht erstellt werden, weil sie bereits vorhanden ist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103411369399130)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'de'
,p_message_text=>unistr('Mehrfach vorhandener Benutzername f\00FCr %0 gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103531624399130)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Laden von Benutzern. Vorgang bei Benutzer %0 nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113413032399138)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'de'
,p_message_text=>unistr('Es w\00E4ren %0 Benutzer geladen worden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113277428399138)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'de'
,p_message_text=>'Kennwort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113369914399138)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'de'
,p_message_text=>'Berechtigungen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113067672399137)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'de'
,p_message_text=>'Benutzername'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189572868399193)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Rendering von Seitenelement "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109161623399135)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Seitenelement kann nicht angezeigt werden, weil die HTML-Form noch nicht ge\00F6ffnet war.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111074494197399110)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei der Berechnung des Standardwertes f\00FCr das Seitenelement #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108492126399134)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei abschlie\00DFender Berechnung f\00FCr Seitenelement #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108368657399134)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler bei der Berechnung des Quellwertes f\00FCr das Seitenelement #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088116261399119)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'de'
,p_message_text=>'Unberechtigter Zugriff.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108644164399134)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'de'
,p_message_text=>unistr('JavaScript wird nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108768972399134)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'de'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111109389502399135)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'de'
,p_message_text=>'Die Abfrage konnte nicht initialisiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116512812399140)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Aktualisierung von %0 wird nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111110735163399136)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltige Element-ID: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111137042141399155)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr dieses Element ist keine Hilfe verf\00FCgbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101575334399129)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'de'
,p_message_text=>unistr('Diagrammabfrage konnte nicht generiert werden. Pr\00FCfen Sie die Quellen- und Spaltenzuordnungseinstellungen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196381279399198)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'de'
,p_message_text=>unistr('Der Anhang mit der Gr\00F6\00DFe von %0 MB \00FCberschreitet die maximale Anhangsgr\00F6\00DFe von %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102442974399130)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Wert f\00FCr Parameter p_mail_id: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111219883365399214)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die maximale Anzahl von E-Mail-Nachrichten pro Workspace \00FCberschritten. Wenden Sie sich an den Administrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083424019399116)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'de'
,p_message_text=>'Diese Prozedur muss innerhalb einer Anwendungssession aufgerufen werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102346680399130)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Parameter %0 wurde ein Nullwert angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156325109399169)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Template "%0" in Anwendung %1 nicht gefunden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111232811655399224)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Der SMTP_HOST_ADDRESS-Instanzparameter muss festgelegt werden, um E-Mails zu senden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102055528399129)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('Es muss ein Nachrichtenempf\00E4nger angegeben werden, damit E-Mails gesendet werden k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111222261068399216)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'de'
,p_message_text=>'SMTP-Verbindung mit dem konfigurierten E-Mail-Server konnte nicht hergestellt werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111196457950399198)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'de'
,p_message_text=>unistr('Ung\00FCltiger Ajax-Aufruf')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087865976399119)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Plug-in %0 wurde keine Ajax-Funktion definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186839979399191)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Plug-in %0 wurde keine Ausf\00FChrungsfunktion definiert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087989317399119)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr Plug-in %0 wurde keine Renderfunktion definiert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197367937399198)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Das REST-Datenquellen-Plug-in "%0" enth\00E4lt keine Funktion "Funktionen".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197228763399198)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Das REST-Datenquellen-Plug-in "%0" enth\00E4lt keine DML-Funktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197407380399198)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Das REST-Datenquellen-Plug-in "%0" enth\00E4lt keine Ausf\00FChren-Funktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111197503108399199)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'de'
,p_message_text=>unistr('Das REST-Datenquellen-Plug-in "%0" enth\00E4lt keine Abrufen-Funktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085651505399118)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler im PLSQL-Code, der w\00E4hrend der Plug-in-Verarbeitung ausgel\00F6st wurde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092275840399122)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'de'
,p_message_text=>'Wert muss angegeben werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122813395399144)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'de'
,p_message_text=>'Datentyp %0 kann nicht in VARCHAR2 konvertiert werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208494764399206)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte "%0", die f\00FCr Attribut "%1" angegeben ist, wurde in SQL-Anweisung nicht gefunden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184712055399189)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr %0 muss eine Abfrage der Werteliste (LOV) oder eine benannte Werteliste angegeben werden. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111186302191399191)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'de'
,p_message_text=>unistr('In der SQL-Abfrage der Werteliste f\00FCr %0 ist eine falsche Anzahl von Spalten ausgew\00E4hlt. G\00FCltige Anweisungen siehe Beispiele.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208230903399206)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'de'
,p_message_text=>unistr('Keine Spalte f\00FCr Attribut "%0" angegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237937722399228)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Eingegebener Wert %0 f\00FCr Attribut "%1" ist nicht numerisch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111189883112399193)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>'%0 hat einen falschen Datentyp in der SQL-Anweisung. Spaltennummer %1 ist %2, es wird aber %3 erwartet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111208336064399206)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte "%0", die f\00FCr Attribut "%1" angegeben ist, hat den Datentyp %2, sollte jedoch den Datentyp %3 haben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111084927880399117)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'de'
,p_message_text=>'Berichtslayout kann nicht gefunden werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144963595399160)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'de'
,p_message_text=>unistr('Das Feature "Summe berechnen" kann nicht f\00FCr Berichte verwendet werden, die auf einer REST-Datenquelle basieren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111108501933399134)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('ERR-2904 Festlegen von Shortcut-Wert nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111112805657399137)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler: Unbekannter Shortcut-Typ.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111102818328399130)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Abrufen von authentication_scheme in Anwendung %0 nicht m\00F6glich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111176339344399183)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Mandanten-ID ist f\00FCr die aktuelle Session bereits vorhanden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111113119216399137)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'de'
,p_message_text=>'E-Mail-Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237348226399227)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'de'
,p_message_text=>'Authentifizierung nicht erfolgreich.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111139630031399157)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'de'
,p_message_text=>unistr('Mindestens ein in apex_util.g_request_cookies eingerichtetes Cookie enth\00E4lt einen ung\00FCltigen Wert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111122142428399144)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'de'
,p_message_text=>unistr('Die Antwort von der UDDI Registry war ung\00FCltig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111085716731399118)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'de'
,p_message_text=>unistr('Der angegebene URL hat kein g\00FCltiges WSDL-Dokument zur\00FCckgegeben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111088275537399120)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'de'
,p_message_text=>unistr('Das WSDL-Dokument enth\00E4lt mehrere SOAP-Bindings. &PRODUCT_NAME. unterst\00FCtzt nur WSDLs mit einem SOAP-Binding. Klicken Sie auf <b>Webservicereferenz manuell erstellen</b>, um mit dem Erstellvorgang f\00FCr eine Referenz f\00FCr diesen Service fortzufahren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111156648252399169)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'de'
,p_message_text=>'Die Antwort vom Service war nicht XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237218727399227)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'de'
,p_message_text=>unistr('OAuth-Zugriffstoken nicht verf\00FCgbar oder abgelaufen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111200443459399201)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'de'
,p_message_text=>unistr('Sie haben die maximale Anzahl an Webserviceanforderungen pro Workspace \00FCberschritten. Wenden Sie sich an den Administrator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111237485490399227)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'de'
,p_message_text=>unistr('Server hat mit nicht unterst\00FCtztem OAuth-Tokentyp geantwortet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087636041399119)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'de'
,p_message_text=>unistr('Das WSDL-Dokument enth\00E4lt kein Binding f\00FCr SOAP. Dies ist erforderlich, um die Referenz hinzuf\00FCgen zu k\00F6nnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111083528899399116)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'de'
,p_message_text=>unistr('Dieses WSDL ben\00F6tigt Zugangsdaten f\00FCr die Authentifizierung. Geben Sie unten den Benutzernamen und das Kennwort ein.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111092397957399123)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'de'
,p_message_text=>unistr('Das WSDL-Dokument wurde von der Rendering Engine nicht verstanden. Klicken Sie auf <b>Webservicereferenz manuell erstellen</b>, um mit dem Erstellvorgang f\00FCr eine Referenz f\00FCr diesen Service fortzufahren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111159277015399171)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'de'
,p_message_text=>'Update kann nicht verarbeitet werden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111185072580399190)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'de'
,p_message_text=>unistr('Die R\00FCckgabe- und Anzeigespalte der Werteliste sind gleich.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111184989020399190)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Die Werteliste hat keine Eingabespalte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116496666399140)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'de'
,p_message_text=>'Fehler beim Abrufen von Spaltenwert: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140469718399157)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'de'
,p_message_text=>unistr('Aktuelle Daten auf tabellarischem Formular sind zu alt; die Quelldaten wurden ge\00E4ndert.<br/> Klicken Sie <strong><a href="%0">hier</a></strong>, um Ihre \00C4nderungen zu verwerfen und die Daten aus der Datenbank neu zu laden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098517101399127)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Bestimmen der Zeichenfolge f\00FCr die Seitennummerierung')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098411722399127)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'de'
,p_message_text=>unistr('Bestimmen der Abfrage\00FCberschriften nicht m\00F6glich: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098600580399127)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Ausf\00FChren von Berichts-Footer-Ersetzungen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098779884399127)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'de'
,p_message_text=>'Parsen von SQL-Abfrage nicht erfolgreich: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103797285399131)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'de'
,p_message_text=>'Minimale Zeile angefordert: %0, Zeilen gefunden, die jedoch nicht angezeigt werden: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101252160399129)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfragespalte #%0 (%1) ist ung\00FCltig. HTML-Spalten ben\00F6tigen Aliasnamen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111116340644399140)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'de'
,p_message_text=>unistr('Fehler beim Abrufen von Abfrage\00FCberschriften: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098871197399127)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Berichtsfehler:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111136537391399154)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'de'
,p_message_text=>'Nach dieser Spalte sortieren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101354572399129)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'de'
,p_message_text=>unistr('<p>Die Abfrage kann nicht geparst werden. \00DCberpr\00FCfen Sie die Abfragesyntax. (%0) </p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140535959399157)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'de'
,p_message_text=>unistr('Diese Form enth\00E4lt ungespeicherte \00C4nderungen. Klicken Sie auf "OK", um fortzufahren, ohne Ihre \00C4nderungen zu speichern. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111144814467399160)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'de'
,p_message_text=>unistr('Seitennummerierungsschema des Berichts (%0) wird bei der ausgew\00E4hlten Datenquelle nicht unterst\00FCtzt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111101159077399129)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'de'
,p_message_text=>unistr('Die Abfragespalte #%0 (%1) ist ung\00FCltig. Verwenden Sie den Spaltenaliasnamen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103888580399131)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'de'
,p_message_text=>'Zeile(n) %0 - %1 von mehr als %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111142588261399159)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'de'
,p_message_text=>'%0 - %1 von mehr als %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111103645139399131)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'de'
,p_message_text=>'Zeile(n) %0 - %1 von %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111087506435399119)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'de'
,p_message_text=>'%0 - %1 von %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098902219399127)
,p_name=>'Y'
,p_message_language=>'de'
,p_message_text=>'J'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111105046763399132)
,p_name=>'YEAR'
,p_message_language=>'de'
,p_message_text=>'Jahr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111098154406399127)
,p_name=>'YEARS'
,p_message_language=>'de'
,p_message_text=>'Jahre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111140616105399157)
,p_name=>'YES'
,p_message_language=>'de'
,p_message_text=>'Ja'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4473)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4473)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4473
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4473)
,p_name=>'Nachrichten'
,p_alias=>'MESSAGES'
,p_step_title=>'Nachrichten'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
